// Generated by Futhark 0.21.5
// git: e1c63b2 (Tue Feb 1 22:06:34 2022 +0100)

// We need to define _GNU_SOURCE before
// _any_ headers files are imported to get
// the usage statistics of a thread (i.e. have RUSAGE_THREAD) on GNU/Linux
// https://manpages.courier-mta.org/htmlman2/getrusage.2.html
#ifndef _GNU_SOURCE // Avoid possible double-definition warning.
#define _GNU_SOURCE
#endif

#ifdef __clang__
#pragma clang diagnostic ignored "-Wunused-function"
#pragma clang diagnostic ignored "-Wunused-variable"
#pragma clang diagnostic ignored "-Wparentheses"
#pragma clang diagnostic ignored "-Wunused-label"
#elif __GNUC__
#pragma GCC diagnostic ignored "-Wunused-function"
#pragma GCC diagnostic ignored "-Wunused-variable"
#pragma GCC diagnostic ignored "-Wparentheses"
#pragma GCC diagnostic ignored "-Wunused-label"
#pragma GCC diagnostic ignored "-Wunused-but-set-variable"
#endif

// Headers\n")
#include <stdint.h>
#include <stddef.h>
#include <stdbool.h>
#include <stdio.h>
#include <float.h>

#ifdef __cplusplus
extern "C" {
#endif

// Initialisation
struct futhark_context_config;
struct futhark_context_config *futhark_context_config_new(void);
void futhark_context_config_free(struct futhark_context_config *cfg);
void futhark_context_config_set_debugging(struct futhark_context_config *cfg,
                                          int flag);
void futhark_context_config_set_profiling(struct futhark_context_config *cfg,
                                          int flag);
void futhark_context_config_set_logging(struct futhark_context_config *cfg,
                                        int flag);
void futhark_context_config_set_num_threads(struct futhark_context_config *cfg,
                                            int n);
struct futhark_context;
struct futhark_context *futhark_context_new(struct futhark_context_config *cfg);
void futhark_context_free(struct futhark_context *ctx);
int futhark_context_sync(struct futhark_context *ctx);
int futhark_context_config_set_tuning_param(struct futhark_context_config *cfg,
                                            const char *param_name,
                                            size_t param_value);
int futhark_get_tuning_param_count(void);
const char *futhark_get_tuning_param_name(int);
const char *futhark_get_tuning_param_class(int);

// Arrays
struct futhark_f32_1d;
struct futhark_f32_1d *futhark_new_f32_1d(struct futhark_context *ctx, const
                                          float *data, int64_t dim0);
struct futhark_f32_1d *futhark_new_raw_f32_1d(struct futhark_context *ctx, const
                                              unsigned char *data,
                                              int64_t offset, int64_t dim0);
int futhark_free_f32_1d(struct futhark_context *ctx,
                        struct futhark_f32_1d *arr);
int futhark_values_f32_1d(struct futhark_context *ctx,
                          struct futhark_f32_1d *arr, float *data);
unsigned char *futhark_values_raw_f32_1d(struct futhark_context *ctx,
                                         struct futhark_f32_1d *arr);
const int64_t *futhark_shape_f32_1d(struct futhark_context *ctx,
                                    struct futhark_f32_1d *arr);
struct futhark_f32_2d;
struct futhark_f32_2d *futhark_new_f32_2d(struct futhark_context *ctx, const
                                          float *data, int64_t dim0,
                                          int64_t dim1);
struct futhark_f32_2d *futhark_new_raw_f32_2d(struct futhark_context *ctx, const
                                              unsigned char *data,
                                              int64_t offset, int64_t dim0,
                                              int64_t dim1);
int futhark_free_f32_2d(struct futhark_context *ctx,
                        struct futhark_f32_2d *arr);
int futhark_values_f32_2d(struct futhark_context *ctx,
                          struct futhark_f32_2d *arr, float *data);
unsigned char *futhark_values_raw_f32_2d(struct futhark_context *ctx,
                                         struct futhark_f32_2d *arr);
const int64_t *futhark_shape_f32_2d(struct futhark_context *ctx,
                                    struct futhark_f32_2d *arr);

// Opaque values


// Entry points
int futhark_entry_main(struct futhark_context *ctx,
                       struct futhark_f32_2d **out0,
                       struct futhark_f32_2d **out1,
                       struct futhark_f32_2d **out2, const
                       struct futhark_f32_2d *in0, const int64_t in1, const
                       int64_t in2, const int64_t in3, const int64_t in4, const
                       int64_t in5, const int64_t in6, const int64_t in7, const
                       int64_t in8, const int64_t in9, const int64_t in10, const
                       int64_t in11, const int64_t in12, const int64_t in13,
                       const int64_t in14, const int64_t in15, const
                       int64_t in16);
int futhark_entry_seasonal_amplitude(struct futhark_context *ctx,
                                     struct futhark_f32_1d **out0, const
                                     struct futhark_f32_2d *in0);
int futhark_entry_trend_magnitude(struct futhark_context *ctx,
                                  struct futhark_f32_1d **out0, const
                                  struct futhark_f32_2d *in0);

// Miscellaneous
char *futhark_context_report(struct futhark_context *ctx);
char *futhark_context_get_error(struct futhark_context *ctx);
void futhark_context_set_logging_file(struct futhark_context *ctx, FILE *f);
void futhark_context_pause_profiling(struct futhark_context *ctx);
void futhark_context_unpause_profiling(struct futhark_context *ctx);
int futhark_context_clear_caches(struct futhark_context *ctx);
#define FUTHARK_BACKEND_multicore
#define FUTHARK_SUCCESS 0
#define FUTHARK_PROGRAM_ERROR 2
#define FUTHARK_OUT_OF_MEMORY 3

#ifdef __cplusplus
}
#endif

#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>
#include <math.h>
#include <stdint.h>
// If NDEBUG is set, the assert() macro will do nothing. Since Futhark
// (unfortunately) makes use of assert() for error detection (and even some
// side effects), we want to avoid that.
#undef NDEBUG
#include <assert.h>
#include <stdarg.h>
// Start of util.h.
//
// Various helper functions that are useful in all generated C code.

#include <errno.h>
#include <string.h>

static const char *fut_progname = "(embedded Futhark)";

static void futhark_panic(int eval, const char *fmt, ...) __attribute__((noreturn));
static char* msgprintf(const char *s, ...);
static void* slurp_file(const char *filename, size_t *size);
static int dump_file(const char *file, const void *buf, size_t n);
struct str_builder;
static void str_builder_init(struct str_builder *b);
static void str_builder(struct str_builder *b, const char *s, ...);

static void futhark_panic(int eval, const char *fmt, ...) {
  va_list ap;
  va_start(ap, fmt);
  fprintf(stderr, "%s: ", fut_progname);
  vfprintf(stderr, fmt, ap);
  va_end(ap);
  exit(eval);
}

// For generating arbitrary-sized error messages.  It is the callers
// responsibility to free the buffer at some point.
static char* msgprintf(const char *s, ...) {
  va_list vl;
  va_start(vl, s);
  size_t needed = 1 + (size_t)vsnprintf(NULL, 0, s, vl);
  char *buffer = (char*) malloc(needed);
  va_start(vl, s); // Must re-init.
  vsnprintf(buffer, needed, s, vl);
  return buffer;
}

static inline void check_err(int errval, int sets_errno, const char *fun, int line,
                            const char *msg, ...) {
  if (errval) {
    char errnum[10];

    va_list vl;
    va_start(vl, msg);

    fprintf(stderr, "ERROR: ");
    vfprintf(stderr, msg, vl);
    fprintf(stderr, " in %s() at line %d with error code %s\n",
            fun, line,
            sets_errno ? strerror(errno) : errnum);
    exit(errval);
  }
}

#define CHECK_ERR(err, ...) check_err(err, 0, __func__, __LINE__, __VA_ARGS__)
#define CHECK_ERRNO(err, ...) check_err(err, 1, __func__, __LINE__, __VA_ARGS__)

// Read the rest of an open file into a NUL-terminated string; returns
// NULL on error.
static void* fslurp_file(FILE *f, size_t *size) {
  long start = ftell(f);
  fseek(f, 0, SEEK_END);
  long src_size = ftell(f)-start;
  fseek(f, start, SEEK_SET);
  unsigned char *s = (unsigned char*) malloc((size_t)src_size + 1);
  if (fread(s, 1, (size_t)src_size, f) != (size_t)src_size) {
    free(s);
    s = NULL;
  } else {
    s[src_size] = '\0';
  }

  if (size) {
    *size = (size_t)src_size;
  }

  return s;
}

// Read a file into a NUL-terminated string; returns NULL on error.
static void* slurp_file(const char *filename, size_t *size) {
  FILE *f = fopen(filename, "rb"); // To avoid Windows messing with linebreaks.
  if (f == NULL) return NULL;
  unsigned char *s = fslurp_file(f, size);
  fclose(f);
  return s;
}

// Dump 'n' bytes from 'buf' into the file at the designated location.
// Returns 0 on success.
static int dump_file(const char *file, const void *buf, size_t n) {
  FILE *f = fopen(file, "w");

  if (f == NULL) {
    return 1;
  }

  if (fwrite(buf, sizeof(char), n, f) != n) {
    return 1;
  }

  if (fclose(f) != 0) {
    return 1;
  }

  return 0;
}

struct str_builder {
  char *str;
  size_t capacity; // Size of buffer.
  size_t used; // Bytes used, *not* including final zero.
};

static void str_builder_init(struct str_builder *b) {
  b->capacity = 10;
  b->used = 0;
  b->str = malloc(b->capacity);
  b->str[0] = 0;
}

static void str_builder(struct str_builder *b, const char *s, ...) {
  va_list vl;
  va_start(vl, s);
  size_t needed = (size_t)vsnprintf(NULL, 0, s, vl);

  while (b->capacity < b->used + needed + 1) {
    b->capacity *= 2;
    b->str = realloc(b->str, b->capacity);
  }

  va_start(vl, s); // Must re-init.
  vsnprintf(b->str+b->used, b->capacity-b->used, s, vl);
  b->used += needed;
}

// End of util.h.
// Start of half.h.

// Conversion functions are from http://half.sourceforge.net/, but
// translated to C.
//
// Copyright (c) 2012-2021 Christian Rau
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to deal
// in the Software without restriction, including without limitation the rights
// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
// THE SOFTWARE.

#ifndef __OPENCL_VERSION__
#define __constant
#endif

__constant static const uint16_t base_table[512] = {
  0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
  0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
  0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
  0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
  0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
  0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
  0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0001, 0x0002, 0x0004, 0x0008, 0x0010, 0x0020, 0x0040, 0x0080, 0x0100,
  0x0200, 0x0400, 0x0800, 0x0C00, 0x1000, 0x1400, 0x1800, 0x1C00, 0x2000, 0x2400, 0x2800, 0x2C00, 0x3000, 0x3400, 0x3800, 0x3C00,
  0x4000, 0x4400, 0x4800, 0x4C00, 0x5000, 0x5400, 0x5800, 0x5C00, 0x6000, 0x6400, 0x6800, 0x6C00, 0x7000, 0x7400, 0x7800, 0x7C00,
  0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00,
  0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00,
  0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00,
  0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00,
  0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00,
  0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00,
  0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00, 0x7C00,
  0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000,
  0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000,
  0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000,
  0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000,
  0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000,
  0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000,
  0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8000, 0x8001, 0x8002, 0x8004, 0x8008, 0x8010, 0x8020, 0x8040, 0x8080, 0x8100,
  0x8200, 0x8400, 0x8800, 0x8C00, 0x9000, 0x9400, 0x9800, 0x9C00, 0xA000, 0xA400, 0xA800, 0xAC00, 0xB000, 0xB400, 0xB800, 0xBC00,
  0xC000, 0xC400, 0xC800, 0xCC00, 0xD000, 0xD400, 0xD800, 0xDC00, 0xE000, 0xE400, 0xE800, 0xEC00, 0xF000, 0xF400, 0xF800, 0xFC00,
  0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00,
  0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00,
  0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00,
  0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00,
  0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00,
  0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00,
  0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00, 0xFC00 };

__constant static const unsigned char shift_table[512] = {
  24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
  24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
  24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
  24, 24, 24, 24, 24, 24, 24, 23, 22, 21, 20, 19, 18, 17, 16, 15, 14, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13,
  13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
  24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
  24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
  24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 13,
  24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
  24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
  24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
  24, 24, 24, 24, 24, 24, 24, 23, 22, 21, 20, 19, 18, 17, 16, 15, 14, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13,
  13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 13, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
  24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
  24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
  24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 13 };

__constant static const uint32_t mantissa_table[2048] = {
  0x00000000, 0x33800000, 0x34000000, 0x34400000, 0x34800000, 0x34A00000, 0x34C00000, 0x34E00000, 0x35000000, 0x35100000, 0x35200000, 0x35300000, 0x35400000, 0x35500000, 0x35600000, 0x35700000,
  0x35800000, 0x35880000, 0x35900000, 0x35980000, 0x35A00000, 0x35A80000, 0x35B00000, 0x35B80000, 0x35C00000, 0x35C80000, 0x35D00000, 0x35D80000, 0x35E00000, 0x35E80000, 0x35F00000, 0x35F80000,
  0x36000000, 0x36040000, 0x36080000, 0x360C0000, 0x36100000, 0x36140000, 0x36180000, 0x361C0000, 0x36200000, 0x36240000, 0x36280000, 0x362C0000, 0x36300000, 0x36340000, 0x36380000, 0x363C0000,
  0x36400000, 0x36440000, 0x36480000, 0x364C0000, 0x36500000, 0x36540000, 0x36580000, 0x365C0000, 0x36600000, 0x36640000, 0x36680000, 0x366C0000, 0x36700000, 0x36740000, 0x36780000, 0x367C0000,
  0x36800000, 0x36820000, 0x36840000, 0x36860000, 0x36880000, 0x368A0000, 0x368C0000, 0x368E0000, 0x36900000, 0x36920000, 0x36940000, 0x36960000, 0x36980000, 0x369A0000, 0x369C0000, 0x369E0000,
  0x36A00000, 0x36A20000, 0x36A40000, 0x36A60000, 0x36A80000, 0x36AA0000, 0x36AC0000, 0x36AE0000, 0x36B00000, 0x36B20000, 0x36B40000, 0x36B60000, 0x36B80000, 0x36BA0000, 0x36BC0000, 0x36BE0000,
  0x36C00000, 0x36C20000, 0x36C40000, 0x36C60000, 0x36C80000, 0x36CA0000, 0x36CC0000, 0x36CE0000, 0x36D00000, 0x36D20000, 0x36D40000, 0x36D60000, 0x36D80000, 0x36DA0000, 0x36DC0000, 0x36DE0000,
  0x36E00000, 0x36E20000, 0x36E40000, 0x36E60000, 0x36E80000, 0x36EA0000, 0x36EC0000, 0x36EE0000, 0x36F00000, 0x36F20000, 0x36F40000, 0x36F60000, 0x36F80000, 0x36FA0000, 0x36FC0000, 0x36FE0000,
  0x37000000, 0x37010000, 0x37020000, 0x37030000, 0x37040000, 0x37050000, 0x37060000, 0x37070000, 0x37080000, 0x37090000, 0x370A0000, 0x370B0000, 0x370C0000, 0x370D0000, 0x370E0000, 0x370F0000,
  0x37100000, 0x37110000, 0x37120000, 0x37130000, 0x37140000, 0x37150000, 0x37160000, 0x37170000, 0x37180000, 0x37190000, 0x371A0000, 0x371B0000, 0x371C0000, 0x371D0000, 0x371E0000, 0x371F0000,
  0x37200000, 0x37210000, 0x37220000, 0x37230000, 0x37240000, 0x37250000, 0x37260000, 0x37270000, 0x37280000, 0x37290000, 0x372A0000, 0x372B0000, 0x372C0000, 0x372D0000, 0x372E0000, 0x372F0000,
  0x37300000, 0x37310000, 0x37320000, 0x37330000, 0x37340000, 0x37350000, 0x37360000, 0x37370000, 0x37380000, 0x37390000, 0x373A0000, 0x373B0000, 0x373C0000, 0x373D0000, 0x373E0000, 0x373F0000,
  0x37400000, 0x37410000, 0x37420000, 0x37430000, 0x37440000, 0x37450000, 0x37460000, 0x37470000, 0x37480000, 0x37490000, 0x374A0000, 0x374B0000, 0x374C0000, 0x374D0000, 0x374E0000, 0x374F0000,
  0x37500000, 0x37510000, 0x37520000, 0x37530000, 0x37540000, 0x37550000, 0x37560000, 0x37570000, 0x37580000, 0x37590000, 0x375A0000, 0x375B0000, 0x375C0000, 0x375D0000, 0x375E0000, 0x375F0000,
  0x37600000, 0x37610000, 0x37620000, 0x37630000, 0x37640000, 0x37650000, 0x37660000, 0x37670000, 0x37680000, 0x37690000, 0x376A0000, 0x376B0000, 0x376C0000, 0x376D0000, 0x376E0000, 0x376F0000,
  0x37700000, 0x37710000, 0x37720000, 0x37730000, 0x37740000, 0x37750000, 0x37760000, 0x37770000, 0x37780000, 0x37790000, 0x377A0000, 0x377B0000, 0x377C0000, 0x377D0000, 0x377E0000, 0x377F0000,
  0x37800000, 0x37808000, 0x37810000, 0x37818000, 0x37820000, 0x37828000, 0x37830000, 0x37838000, 0x37840000, 0x37848000, 0x37850000, 0x37858000, 0x37860000, 0x37868000, 0x37870000, 0x37878000,
  0x37880000, 0x37888000, 0x37890000, 0x37898000, 0x378A0000, 0x378A8000, 0x378B0000, 0x378B8000, 0x378C0000, 0x378C8000, 0x378D0000, 0x378D8000, 0x378E0000, 0x378E8000, 0x378F0000, 0x378F8000,
  0x37900000, 0x37908000, 0x37910000, 0x37918000, 0x37920000, 0x37928000, 0x37930000, 0x37938000, 0x37940000, 0x37948000, 0x37950000, 0x37958000, 0x37960000, 0x37968000, 0x37970000, 0x37978000,
  0x37980000, 0x37988000, 0x37990000, 0x37998000, 0x379A0000, 0x379A8000, 0x379B0000, 0x379B8000, 0x379C0000, 0x379C8000, 0x379D0000, 0x379D8000, 0x379E0000, 0x379E8000, 0x379F0000, 0x379F8000,
  0x37A00000, 0x37A08000, 0x37A10000, 0x37A18000, 0x37A20000, 0x37A28000, 0x37A30000, 0x37A38000, 0x37A40000, 0x37A48000, 0x37A50000, 0x37A58000, 0x37A60000, 0x37A68000, 0x37A70000, 0x37A78000,
  0x37A80000, 0x37A88000, 0x37A90000, 0x37A98000, 0x37AA0000, 0x37AA8000, 0x37AB0000, 0x37AB8000, 0x37AC0000, 0x37AC8000, 0x37AD0000, 0x37AD8000, 0x37AE0000, 0x37AE8000, 0x37AF0000, 0x37AF8000,
  0x37B00000, 0x37B08000, 0x37B10000, 0x37B18000, 0x37B20000, 0x37B28000, 0x37B30000, 0x37B38000, 0x37B40000, 0x37B48000, 0x37B50000, 0x37B58000, 0x37B60000, 0x37B68000, 0x37B70000, 0x37B78000,
  0x37B80000, 0x37B88000, 0x37B90000, 0x37B98000, 0x37BA0000, 0x37BA8000, 0x37BB0000, 0x37BB8000, 0x37BC0000, 0x37BC8000, 0x37BD0000, 0x37BD8000, 0x37BE0000, 0x37BE8000, 0x37BF0000, 0x37BF8000,
  0x37C00000, 0x37C08000, 0x37C10000, 0x37C18000, 0x37C20000, 0x37C28000, 0x37C30000, 0x37C38000, 0x37C40000, 0x37C48000, 0x37C50000, 0x37C58000, 0x37C60000, 0x37C68000, 0x37C70000, 0x37C78000,
  0x37C80000, 0x37C88000, 0x37C90000, 0x37C98000, 0x37CA0000, 0x37CA8000, 0x37CB0000, 0x37CB8000, 0x37CC0000, 0x37CC8000, 0x37CD0000, 0x37CD8000, 0x37CE0000, 0x37CE8000, 0x37CF0000, 0x37CF8000,
  0x37D00000, 0x37D08000, 0x37D10000, 0x37D18000, 0x37D20000, 0x37D28000, 0x37D30000, 0x37D38000, 0x37D40000, 0x37D48000, 0x37D50000, 0x37D58000, 0x37D60000, 0x37D68000, 0x37D70000, 0x37D78000,
  0x37D80000, 0x37D88000, 0x37D90000, 0x37D98000, 0x37DA0000, 0x37DA8000, 0x37DB0000, 0x37DB8000, 0x37DC0000, 0x37DC8000, 0x37DD0000, 0x37DD8000, 0x37DE0000, 0x37DE8000, 0x37DF0000, 0x37DF8000,
  0x37E00000, 0x37E08000, 0x37E10000, 0x37E18000, 0x37E20000, 0x37E28000, 0x37E30000, 0x37E38000, 0x37E40000, 0x37E48000, 0x37E50000, 0x37E58000, 0x37E60000, 0x37E68000, 0x37E70000, 0x37E78000,
  0x37E80000, 0x37E88000, 0x37E90000, 0x37E98000, 0x37EA0000, 0x37EA8000, 0x37EB0000, 0x37EB8000, 0x37EC0000, 0x37EC8000, 0x37ED0000, 0x37ED8000, 0x37EE0000, 0x37EE8000, 0x37EF0000, 0x37EF8000,
  0x37F00000, 0x37F08000, 0x37F10000, 0x37F18000, 0x37F20000, 0x37F28000, 0x37F30000, 0x37F38000, 0x37F40000, 0x37F48000, 0x37F50000, 0x37F58000, 0x37F60000, 0x37F68000, 0x37F70000, 0x37F78000,
  0x37F80000, 0x37F88000, 0x37F90000, 0x37F98000, 0x37FA0000, 0x37FA8000, 0x37FB0000, 0x37FB8000, 0x37FC0000, 0x37FC8000, 0x37FD0000, 0x37FD8000, 0x37FE0000, 0x37FE8000, 0x37FF0000, 0x37FF8000,
  0x38000000, 0x38004000, 0x38008000, 0x3800C000, 0x38010000, 0x38014000, 0x38018000, 0x3801C000, 0x38020000, 0x38024000, 0x38028000, 0x3802C000, 0x38030000, 0x38034000, 0x38038000, 0x3803C000,
  0x38040000, 0x38044000, 0x38048000, 0x3804C000, 0x38050000, 0x38054000, 0x38058000, 0x3805C000, 0x38060000, 0x38064000, 0x38068000, 0x3806C000, 0x38070000, 0x38074000, 0x38078000, 0x3807C000,
  0x38080000, 0x38084000, 0x38088000, 0x3808C000, 0x38090000, 0x38094000, 0x38098000, 0x3809C000, 0x380A0000, 0x380A4000, 0x380A8000, 0x380AC000, 0x380B0000, 0x380B4000, 0x380B8000, 0x380BC000,
  0x380C0000, 0x380C4000, 0x380C8000, 0x380CC000, 0x380D0000, 0x380D4000, 0x380D8000, 0x380DC000, 0x380E0000, 0x380E4000, 0x380E8000, 0x380EC000, 0x380F0000, 0x380F4000, 0x380F8000, 0x380FC000,
  0x38100000, 0x38104000, 0x38108000, 0x3810C000, 0x38110000, 0x38114000, 0x38118000, 0x3811C000, 0x38120000, 0x38124000, 0x38128000, 0x3812C000, 0x38130000, 0x38134000, 0x38138000, 0x3813C000,
  0x38140000, 0x38144000, 0x38148000, 0x3814C000, 0x38150000, 0x38154000, 0x38158000, 0x3815C000, 0x38160000, 0x38164000, 0x38168000, 0x3816C000, 0x38170000, 0x38174000, 0x38178000, 0x3817C000,
  0x38180000, 0x38184000, 0x38188000, 0x3818C000, 0x38190000, 0x38194000, 0x38198000, 0x3819C000, 0x381A0000, 0x381A4000, 0x381A8000, 0x381AC000, 0x381B0000, 0x381B4000, 0x381B8000, 0x381BC000,
  0x381C0000, 0x381C4000, 0x381C8000, 0x381CC000, 0x381D0000, 0x381D4000, 0x381D8000, 0x381DC000, 0x381E0000, 0x381E4000, 0x381E8000, 0x381EC000, 0x381F0000, 0x381F4000, 0x381F8000, 0x381FC000,
  0x38200000, 0x38204000, 0x38208000, 0x3820C000, 0x38210000, 0x38214000, 0x38218000, 0x3821C000, 0x38220000, 0x38224000, 0x38228000, 0x3822C000, 0x38230000, 0x38234000, 0x38238000, 0x3823C000,
  0x38240000, 0x38244000, 0x38248000, 0x3824C000, 0x38250000, 0x38254000, 0x38258000, 0x3825C000, 0x38260000, 0x38264000, 0x38268000, 0x3826C000, 0x38270000, 0x38274000, 0x38278000, 0x3827C000,
  0x38280000, 0x38284000, 0x38288000, 0x3828C000, 0x38290000, 0x38294000, 0x38298000, 0x3829C000, 0x382A0000, 0x382A4000, 0x382A8000, 0x382AC000, 0x382B0000, 0x382B4000, 0x382B8000, 0x382BC000,
  0x382C0000, 0x382C4000, 0x382C8000, 0x382CC000, 0x382D0000, 0x382D4000, 0x382D8000, 0x382DC000, 0x382E0000, 0x382E4000, 0x382E8000, 0x382EC000, 0x382F0000, 0x382F4000, 0x382F8000, 0x382FC000,
  0x38300000, 0x38304000, 0x38308000, 0x3830C000, 0x38310000, 0x38314000, 0x38318000, 0x3831C000, 0x38320000, 0x38324000, 0x38328000, 0x3832C000, 0x38330000, 0x38334000, 0x38338000, 0x3833C000,
  0x38340000, 0x38344000, 0x38348000, 0x3834C000, 0x38350000, 0x38354000, 0x38358000, 0x3835C000, 0x38360000, 0x38364000, 0x38368000, 0x3836C000, 0x38370000, 0x38374000, 0x38378000, 0x3837C000,
  0x38380000, 0x38384000, 0x38388000, 0x3838C000, 0x38390000, 0x38394000, 0x38398000, 0x3839C000, 0x383A0000, 0x383A4000, 0x383A8000, 0x383AC000, 0x383B0000, 0x383B4000, 0x383B8000, 0x383BC000,
  0x383C0000, 0x383C4000, 0x383C8000, 0x383CC000, 0x383D0000, 0x383D4000, 0x383D8000, 0x383DC000, 0x383E0000, 0x383E4000, 0x383E8000, 0x383EC000, 0x383F0000, 0x383F4000, 0x383F8000, 0x383FC000,
  0x38400000, 0x38404000, 0x38408000, 0x3840C000, 0x38410000, 0x38414000, 0x38418000, 0x3841C000, 0x38420000, 0x38424000, 0x38428000, 0x3842C000, 0x38430000, 0x38434000, 0x38438000, 0x3843C000,
  0x38440000, 0x38444000, 0x38448000, 0x3844C000, 0x38450000, 0x38454000, 0x38458000, 0x3845C000, 0x38460000, 0x38464000, 0x38468000, 0x3846C000, 0x38470000, 0x38474000, 0x38478000, 0x3847C000,
  0x38480000, 0x38484000, 0x38488000, 0x3848C000, 0x38490000, 0x38494000, 0x38498000, 0x3849C000, 0x384A0000, 0x384A4000, 0x384A8000, 0x384AC000, 0x384B0000, 0x384B4000, 0x384B8000, 0x384BC000,
  0x384C0000, 0x384C4000, 0x384C8000, 0x384CC000, 0x384D0000, 0x384D4000, 0x384D8000, 0x384DC000, 0x384E0000, 0x384E4000, 0x384E8000, 0x384EC000, 0x384F0000, 0x384F4000, 0x384F8000, 0x384FC000,
  0x38500000, 0x38504000, 0x38508000, 0x3850C000, 0x38510000, 0x38514000, 0x38518000, 0x3851C000, 0x38520000, 0x38524000, 0x38528000, 0x3852C000, 0x38530000, 0x38534000, 0x38538000, 0x3853C000,
  0x38540000, 0x38544000, 0x38548000, 0x3854C000, 0x38550000, 0x38554000, 0x38558000, 0x3855C000, 0x38560000, 0x38564000, 0x38568000, 0x3856C000, 0x38570000, 0x38574000, 0x38578000, 0x3857C000,
  0x38580000, 0x38584000, 0x38588000, 0x3858C000, 0x38590000, 0x38594000, 0x38598000, 0x3859C000, 0x385A0000, 0x385A4000, 0x385A8000, 0x385AC000, 0x385B0000, 0x385B4000, 0x385B8000, 0x385BC000,
  0x385C0000, 0x385C4000, 0x385C8000, 0x385CC000, 0x385D0000, 0x385D4000, 0x385D8000, 0x385DC000, 0x385E0000, 0x385E4000, 0x385E8000, 0x385EC000, 0x385F0000, 0x385F4000, 0x385F8000, 0x385FC000,
  0x38600000, 0x38604000, 0x38608000, 0x3860C000, 0x38610000, 0x38614000, 0x38618000, 0x3861C000, 0x38620000, 0x38624000, 0x38628000, 0x3862C000, 0x38630000, 0x38634000, 0x38638000, 0x3863C000,
  0x38640000, 0x38644000, 0x38648000, 0x3864C000, 0x38650000, 0x38654000, 0x38658000, 0x3865C000, 0x38660000, 0x38664000, 0x38668000, 0x3866C000, 0x38670000, 0x38674000, 0x38678000, 0x3867C000,
  0x38680000, 0x38684000, 0x38688000, 0x3868C000, 0x38690000, 0x38694000, 0x38698000, 0x3869C000, 0x386A0000, 0x386A4000, 0x386A8000, 0x386AC000, 0x386B0000, 0x386B4000, 0x386B8000, 0x386BC000,
  0x386C0000, 0x386C4000, 0x386C8000, 0x386CC000, 0x386D0000, 0x386D4000, 0x386D8000, 0x386DC000, 0x386E0000, 0x386E4000, 0x386E8000, 0x386EC000, 0x386F0000, 0x386F4000, 0x386F8000, 0x386FC000,
  0x38700000, 0x38704000, 0x38708000, 0x3870C000, 0x38710000, 0x38714000, 0x38718000, 0x3871C000, 0x38720000, 0x38724000, 0x38728000, 0x3872C000, 0x38730000, 0x38734000, 0x38738000, 0x3873C000,
  0x38740000, 0x38744000, 0x38748000, 0x3874C000, 0x38750000, 0x38754000, 0x38758000, 0x3875C000, 0x38760000, 0x38764000, 0x38768000, 0x3876C000, 0x38770000, 0x38774000, 0x38778000, 0x3877C000,
  0x38780000, 0x38784000, 0x38788000, 0x3878C000, 0x38790000, 0x38794000, 0x38798000, 0x3879C000, 0x387A0000, 0x387A4000, 0x387A8000, 0x387AC000, 0x387B0000, 0x387B4000, 0x387B8000, 0x387BC000,
  0x387C0000, 0x387C4000, 0x387C8000, 0x387CC000, 0x387D0000, 0x387D4000, 0x387D8000, 0x387DC000, 0x387E0000, 0x387E4000, 0x387E8000, 0x387EC000, 0x387F0000, 0x387F4000, 0x387F8000, 0x387FC000,
  0x38000000, 0x38002000, 0x38004000, 0x38006000, 0x38008000, 0x3800A000, 0x3800C000, 0x3800E000, 0x38010000, 0x38012000, 0x38014000, 0x38016000, 0x38018000, 0x3801A000, 0x3801C000, 0x3801E000,
  0x38020000, 0x38022000, 0x38024000, 0x38026000, 0x38028000, 0x3802A000, 0x3802C000, 0x3802E000, 0x38030000, 0x38032000, 0x38034000, 0x38036000, 0x38038000, 0x3803A000, 0x3803C000, 0x3803E000,
  0x38040000, 0x38042000, 0x38044000, 0x38046000, 0x38048000, 0x3804A000, 0x3804C000, 0x3804E000, 0x38050000, 0x38052000, 0x38054000, 0x38056000, 0x38058000, 0x3805A000, 0x3805C000, 0x3805E000,
  0x38060000, 0x38062000, 0x38064000, 0x38066000, 0x38068000, 0x3806A000, 0x3806C000, 0x3806E000, 0x38070000, 0x38072000, 0x38074000, 0x38076000, 0x38078000, 0x3807A000, 0x3807C000, 0x3807E000,
  0x38080000, 0x38082000, 0x38084000, 0x38086000, 0x38088000, 0x3808A000, 0x3808C000, 0x3808E000, 0x38090000, 0x38092000, 0x38094000, 0x38096000, 0x38098000, 0x3809A000, 0x3809C000, 0x3809E000,
  0x380A0000, 0x380A2000, 0x380A4000, 0x380A6000, 0x380A8000, 0x380AA000, 0x380AC000, 0x380AE000, 0x380B0000, 0x380B2000, 0x380B4000, 0x380B6000, 0x380B8000, 0x380BA000, 0x380BC000, 0x380BE000,
  0x380C0000, 0x380C2000, 0x380C4000, 0x380C6000, 0x380C8000, 0x380CA000, 0x380CC000, 0x380CE000, 0x380D0000, 0x380D2000, 0x380D4000, 0x380D6000, 0x380D8000, 0x380DA000, 0x380DC000, 0x380DE000,
  0x380E0000, 0x380E2000, 0x380E4000, 0x380E6000, 0x380E8000, 0x380EA000, 0x380EC000, 0x380EE000, 0x380F0000, 0x380F2000, 0x380F4000, 0x380F6000, 0x380F8000, 0x380FA000, 0x380FC000, 0x380FE000,
  0x38100000, 0x38102000, 0x38104000, 0x38106000, 0x38108000, 0x3810A000, 0x3810C000, 0x3810E000, 0x38110000, 0x38112000, 0x38114000, 0x38116000, 0x38118000, 0x3811A000, 0x3811C000, 0x3811E000,
  0x38120000, 0x38122000, 0x38124000, 0x38126000, 0x38128000, 0x3812A000, 0x3812C000, 0x3812E000, 0x38130000, 0x38132000, 0x38134000, 0x38136000, 0x38138000, 0x3813A000, 0x3813C000, 0x3813E000,
  0x38140000, 0x38142000, 0x38144000, 0x38146000, 0x38148000, 0x3814A000, 0x3814C000, 0x3814E000, 0x38150000, 0x38152000, 0x38154000, 0x38156000, 0x38158000, 0x3815A000, 0x3815C000, 0x3815E000,
  0x38160000, 0x38162000, 0x38164000, 0x38166000, 0x38168000, 0x3816A000, 0x3816C000, 0x3816E000, 0x38170000, 0x38172000, 0x38174000, 0x38176000, 0x38178000, 0x3817A000, 0x3817C000, 0x3817E000,
  0x38180000, 0x38182000, 0x38184000, 0x38186000, 0x38188000, 0x3818A000, 0x3818C000, 0x3818E000, 0x38190000, 0x38192000, 0x38194000, 0x38196000, 0x38198000, 0x3819A000, 0x3819C000, 0x3819E000,
  0x381A0000, 0x381A2000, 0x381A4000, 0x381A6000, 0x381A8000, 0x381AA000, 0x381AC000, 0x381AE000, 0x381B0000, 0x381B2000, 0x381B4000, 0x381B6000, 0x381B8000, 0x381BA000, 0x381BC000, 0x381BE000,
  0x381C0000, 0x381C2000, 0x381C4000, 0x381C6000, 0x381C8000, 0x381CA000, 0x381CC000, 0x381CE000, 0x381D0000, 0x381D2000, 0x381D4000, 0x381D6000, 0x381D8000, 0x381DA000, 0x381DC000, 0x381DE000,
  0x381E0000, 0x381E2000, 0x381E4000, 0x381E6000, 0x381E8000, 0x381EA000, 0x381EC000, 0x381EE000, 0x381F0000, 0x381F2000, 0x381F4000, 0x381F6000, 0x381F8000, 0x381FA000, 0x381FC000, 0x381FE000,
  0x38200000, 0x38202000, 0x38204000, 0x38206000, 0x38208000, 0x3820A000, 0x3820C000, 0x3820E000, 0x38210000, 0x38212000, 0x38214000, 0x38216000, 0x38218000, 0x3821A000, 0x3821C000, 0x3821E000,
  0x38220000, 0x38222000, 0x38224000, 0x38226000, 0x38228000, 0x3822A000, 0x3822C000, 0x3822E000, 0x38230000, 0x38232000, 0x38234000, 0x38236000, 0x38238000, 0x3823A000, 0x3823C000, 0x3823E000,
  0x38240000, 0x38242000, 0x38244000, 0x38246000, 0x38248000, 0x3824A000, 0x3824C000, 0x3824E000, 0x38250000, 0x38252000, 0x38254000, 0x38256000, 0x38258000, 0x3825A000, 0x3825C000, 0x3825E000,
  0x38260000, 0x38262000, 0x38264000, 0x38266000, 0x38268000, 0x3826A000, 0x3826C000, 0x3826E000, 0x38270000, 0x38272000, 0x38274000, 0x38276000, 0x38278000, 0x3827A000, 0x3827C000, 0x3827E000,
  0x38280000, 0x38282000, 0x38284000, 0x38286000, 0x38288000, 0x3828A000, 0x3828C000, 0x3828E000, 0x38290000, 0x38292000, 0x38294000, 0x38296000, 0x38298000, 0x3829A000, 0x3829C000, 0x3829E000,
  0x382A0000, 0x382A2000, 0x382A4000, 0x382A6000, 0x382A8000, 0x382AA000, 0x382AC000, 0x382AE000, 0x382B0000, 0x382B2000, 0x382B4000, 0x382B6000, 0x382B8000, 0x382BA000, 0x382BC000, 0x382BE000,
  0x382C0000, 0x382C2000, 0x382C4000, 0x382C6000, 0x382C8000, 0x382CA000, 0x382CC000, 0x382CE000, 0x382D0000, 0x382D2000, 0x382D4000, 0x382D6000, 0x382D8000, 0x382DA000, 0x382DC000, 0x382DE000,
  0x382E0000, 0x382E2000, 0x382E4000, 0x382E6000, 0x382E8000, 0x382EA000, 0x382EC000, 0x382EE000, 0x382F0000, 0x382F2000, 0x382F4000, 0x382F6000, 0x382F8000, 0x382FA000, 0x382FC000, 0x382FE000,
  0x38300000, 0x38302000, 0x38304000, 0x38306000, 0x38308000, 0x3830A000, 0x3830C000, 0x3830E000, 0x38310000, 0x38312000, 0x38314000, 0x38316000, 0x38318000, 0x3831A000, 0x3831C000, 0x3831E000,
  0x38320000, 0x38322000, 0x38324000, 0x38326000, 0x38328000, 0x3832A000, 0x3832C000, 0x3832E000, 0x38330000, 0x38332000, 0x38334000, 0x38336000, 0x38338000, 0x3833A000, 0x3833C000, 0x3833E000,
  0x38340000, 0x38342000, 0x38344000, 0x38346000, 0x38348000, 0x3834A000, 0x3834C000, 0x3834E000, 0x38350000, 0x38352000, 0x38354000, 0x38356000, 0x38358000, 0x3835A000, 0x3835C000, 0x3835E000,
  0x38360000, 0x38362000, 0x38364000, 0x38366000, 0x38368000, 0x3836A000, 0x3836C000, 0x3836E000, 0x38370000, 0x38372000, 0x38374000, 0x38376000, 0x38378000, 0x3837A000, 0x3837C000, 0x3837E000,
  0x38380000, 0x38382000, 0x38384000, 0x38386000, 0x38388000, 0x3838A000, 0x3838C000, 0x3838E000, 0x38390000, 0x38392000, 0x38394000, 0x38396000, 0x38398000, 0x3839A000, 0x3839C000, 0x3839E000,
  0x383A0000, 0x383A2000, 0x383A4000, 0x383A6000, 0x383A8000, 0x383AA000, 0x383AC000, 0x383AE000, 0x383B0000, 0x383B2000, 0x383B4000, 0x383B6000, 0x383B8000, 0x383BA000, 0x383BC000, 0x383BE000,
  0x383C0000, 0x383C2000, 0x383C4000, 0x383C6000, 0x383C8000, 0x383CA000, 0x383CC000, 0x383CE000, 0x383D0000, 0x383D2000, 0x383D4000, 0x383D6000, 0x383D8000, 0x383DA000, 0x383DC000, 0x383DE000,
  0x383E0000, 0x383E2000, 0x383E4000, 0x383E6000, 0x383E8000, 0x383EA000, 0x383EC000, 0x383EE000, 0x383F0000, 0x383F2000, 0x383F4000, 0x383F6000, 0x383F8000, 0x383FA000, 0x383FC000, 0x383FE000,
  0x38400000, 0x38402000, 0x38404000, 0x38406000, 0x38408000, 0x3840A000, 0x3840C000, 0x3840E000, 0x38410000, 0x38412000, 0x38414000, 0x38416000, 0x38418000, 0x3841A000, 0x3841C000, 0x3841E000,
  0x38420000, 0x38422000, 0x38424000, 0x38426000, 0x38428000, 0x3842A000, 0x3842C000, 0x3842E000, 0x38430000, 0x38432000, 0x38434000, 0x38436000, 0x38438000, 0x3843A000, 0x3843C000, 0x3843E000,
  0x38440000, 0x38442000, 0x38444000, 0x38446000, 0x38448000, 0x3844A000, 0x3844C000, 0x3844E000, 0x38450000, 0x38452000, 0x38454000, 0x38456000, 0x38458000, 0x3845A000, 0x3845C000, 0x3845E000,
  0x38460000, 0x38462000, 0x38464000, 0x38466000, 0x38468000, 0x3846A000, 0x3846C000, 0x3846E000, 0x38470000, 0x38472000, 0x38474000, 0x38476000, 0x38478000, 0x3847A000, 0x3847C000, 0x3847E000,
  0x38480000, 0x38482000, 0x38484000, 0x38486000, 0x38488000, 0x3848A000, 0x3848C000, 0x3848E000, 0x38490000, 0x38492000, 0x38494000, 0x38496000, 0x38498000, 0x3849A000, 0x3849C000, 0x3849E000,
  0x384A0000, 0x384A2000, 0x384A4000, 0x384A6000, 0x384A8000, 0x384AA000, 0x384AC000, 0x384AE000, 0x384B0000, 0x384B2000, 0x384B4000, 0x384B6000, 0x384B8000, 0x384BA000, 0x384BC000, 0x384BE000,
  0x384C0000, 0x384C2000, 0x384C4000, 0x384C6000, 0x384C8000, 0x384CA000, 0x384CC000, 0x384CE000, 0x384D0000, 0x384D2000, 0x384D4000, 0x384D6000, 0x384D8000, 0x384DA000, 0x384DC000, 0x384DE000,
  0x384E0000, 0x384E2000, 0x384E4000, 0x384E6000, 0x384E8000, 0x384EA000, 0x384EC000, 0x384EE000, 0x384F0000, 0x384F2000, 0x384F4000, 0x384F6000, 0x384F8000, 0x384FA000, 0x384FC000, 0x384FE000,
  0x38500000, 0x38502000, 0x38504000, 0x38506000, 0x38508000, 0x3850A000, 0x3850C000, 0x3850E000, 0x38510000, 0x38512000, 0x38514000, 0x38516000, 0x38518000, 0x3851A000, 0x3851C000, 0x3851E000,
  0x38520000, 0x38522000, 0x38524000, 0x38526000, 0x38528000, 0x3852A000, 0x3852C000, 0x3852E000, 0x38530000, 0x38532000, 0x38534000, 0x38536000, 0x38538000, 0x3853A000, 0x3853C000, 0x3853E000,
  0x38540000, 0x38542000, 0x38544000, 0x38546000, 0x38548000, 0x3854A000, 0x3854C000, 0x3854E000, 0x38550000, 0x38552000, 0x38554000, 0x38556000, 0x38558000, 0x3855A000, 0x3855C000, 0x3855E000,
  0x38560000, 0x38562000, 0x38564000, 0x38566000, 0x38568000, 0x3856A000, 0x3856C000, 0x3856E000, 0x38570000, 0x38572000, 0x38574000, 0x38576000, 0x38578000, 0x3857A000, 0x3857C000, 0x3857E000,
  0x38580000, 0x38582000, 0x38584000, 0x38586000, 0x38588000, 0x3858A000, 0x3858C000, 0x3858E000, 0x38590000, 0x38592000, 0x38594000, 0x38596000, 0x38598000, 0x3859A000, 0x3859C000, 0x3859E000,
  0x385A0000, 0x385A2000, 0x385A4000, 0x385A6000, 0x385A8000, 0x385AA000, 0x385AC000, 0x385AE000, 0x385B0000, 0x385B2000, 0x385B4000, 0x385B6000, 0x385B8000, 0x385BA000, 0x385BC000, 0x385BE000,
  0x385C0000, 0x385C2000, 0x385C4000, 0x385C6000, 0x385C8000, 0x385CA000, 0x385CC000, 0x385CE000, 0x385D0000, 0x385D2000, 0x385D4000, 0x385D6000, 0x385D8000, 0x385DA000, 0x385DC000, 0x385DE000,
  0x385E0000, 0x385E2000, 0x385E4000, 0x385E6000, 0x385E8000, 0x385EA000, 0x385EC000, 0x385EE000, 0x385F0000, 0x385F2000, 0x385F4000, 0x385F6000, 0x385F8000, 0x385FA000, 0x385FC000, 0x385FE000,
  0x38600000, 0x38602000, 0x38604000, 0x38606000, 0x38608000, 0x3860A000, 0x3860C000, 0x3860E000, 0x38610000, 0x38612000, 0x38614000, 0x38616000, 0x38618000, 0x3861A000, 0x3861C000, 0x3861E000,
  0x38620000, 0x38622000, 0x38624000, 0x38626000, 0x38628000, 0x3862A000, 0x3862C000, 0x3862E000, 0x38630000, 0x38632000, 0x38634000, 0x38636000, 0x38638000, 0x3863A000, 0x3863C000, 0x3863E000,
  0x38640000, 0x38642000, 0x38644000, 0x38646000, 0x38648000, 0x3864A000, 0x3864C000, 0x3864E000, 0x38650000, 0x38652000, 0x38654000, 0x38656000, 0x38658000, 0x3865A000, 0x3865C000, 0x3865E000,
  0x38660000, 0x38662000, 0x38664000, 0x38666000, 0x38668000, 0x3866A000, 0x3866C000, 0x3866E000, 0x38670000, 0x38672000, 0x38674000, 0x38676000, 0x38678000, 0x3867A000, 0x3867C000, 0x3867E000,
  0x38680000, 0x38682000, 0x38684000, 0x38686000, 0x38688000, 0x3868A000, 0x3868C000, 0x3868E000, 0x38690000, 0x38692000, 0x38694000, 0x38696000, 0x38698000, 0x3869A000, 0x3869C000, 0x3869E000,
  0x386A0000, 0x386A2000, 0x386A4000, 0x386A6000, 0x386A8000, 0x386AA000, 0x386AC000, 0x386AE000, 0x386B0000, 0x386B2000, 0x386B4000, 0x386B6000, 0x386B8000, 0x386BA000, 0x386BC000, 0x386BE000,
  0x386C0000, 0x386C2000, 0x386C4000, 0x386C6000, 0x386C8000, 0x386CA000, 0x386CC000, 0x386CE000, 0x386D0000, 0x386D2000, 0x386D4000, 0x386D6000, 0x386D8000, 0x386DA000, 0x386DC000, 0x386DE000,
  0x386E0000, 0x386E2000, 0x386E4000, 0x386E6000, 0x386E8000, 0x386EA000, 0x386EC000, 0x386EE000, 0x386F0000, 0x386F2000, 0x386F4000, 0x386F6000, 0x386F8000, 0x386FA000, 0x386FC000, 0x386FE000,
  0x38700000, 0x38702000, 0x38704000, 0x38706000, 0x38708000, 0x3870A000, 0x3870C000, 0x3870E000, 0x38710000, 0x38712000, 0x38714000, 0x38716000, 0x38718000, 0x3871A000, 0x3871C000, 0x3871E000,
  0x38720000, 0x38722000, 0x38724000, 0x38726000, 0x38728000, 0x3872A000, 0x3872C000, 0x3872E000, 0x38730000, 0x38732000, 0x38734000, 0x38736000, 0x38738000, 0x3873A000, 0x3873C000, 0x3873E000,
  0x38740000, 0x38742000, 0x38744000, 0x38746000, 0x38748000, 0x3874A000, 0x3874C000, 0x3874E000, 0x38750000, 0x38752000, 0x38754000, 0x38756000, 0x38758000, 0x3875A000, 0x3875C000, 0x3875E000,
  0x38760000, 0x38762000, 0x38764000, 0x38766000, 0x38768000, 0x3876A000, 0x3876C000, 0x3876E000, 0x38770000, 0x38772000, 0x38774000, 0x38776000, 0x38778000, 0x3877A000, 0x3877C000, 0x3877E000,
  0x38780000, 0x38782000, 0x38784000, 0x38786000, 0x38788000, 0x3878A000, 0x3878C000, 0x3878E000, 0x38790000, 0x38792000, 0x38794000, 0x38796000, 0x38798000, 0x3879A000, 0x3879C000, 0x3879E000,
  0x387A0000, 0x387A2000, 0x387A4000, 0x387A6000, 0x387A8000, 0x387AA000, 0x387AC000, 0x387AE000, 0x387B0000, 0x387B2000, 0x387B4000, 0x387B6000, 0x387B8000, 0x387BA000, 0x387BC000, 0x387BE000,
  0x387C0000, 0x387C2000, 0x387C4000, 0x387C6000, 0x387C8000, 0x387CA000, 0x387CC000, 0x387CE000, 0x387D0000, 0x387D2000, 0x387D4000, 0x387D6000, 0x387D8000, 0x387DA000, 0x387DC000, 0x387DE000,
  0x387E0000, 0x387E2000, 0x387E4000, 0x387E6000, 0x387E8000, 0x387EA000, 0x387EC000, 0x387EE000, 0x387F0000, 0x387F2000, 0x387F4000, 0x387F6000, 0x387F8000, 0x387FA000, 0x387FC000, 0x387FE000 };
__constant static const uint32_t exponent_table[64] = {
  0x00000000, 0x00800000, 0x01000000, 0x01800000, 0x02000000, 0x02800000, 0x03000000, 0x03800000, 0x04000000, 0x04800000, 0x05000000, 0x05800000, 0x06000000, 0x06800000, 0x07000000, 0x07800000,
  0x08000000, 0x08800000, 0x09000000, 0x09800000, 0x0A000000, 0x0A800000, 0x0B000000, 0x0B800000, 0x0C000000, 0x0C800000, 0x0D000000, 0x0D800000, 0x0E000000, 0x0E800000, 0x0F000000, 0x47800000,
  0x80000000, 0x80800000, 0x81000000, 0x81800000, 0x82000000, 0x82800000, 0x83000000, 0x83800000, 0x84000000, 0x84800000, 0x85000000, 0x85800000, 0x86000000, 0x86800000, 0x87000000, 0x87800000,
  0x88000000, 0x88800000, 0x89000000, 0x89800000, 0x8A000000, 0x8A800000, 0x8B000000, 0x8B800000, 0x8C000000, 0x8C800000, 0x8D000000, 0x8D800000, 0x8E000000, 0x8E800000, 0x8F000000, 0xC7800000 };
__constant static const unsigned short offset_table[64] = {
  0, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024,
  0, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024, 1024 };

static uint16_t float2halfbits(float value) {
  union { float x; uint32_t y; } u;
  u.x = value;
  uint32_t bits = u.y;

  uint16_t hbits = base_table[bits>>23] + (uint16_t)((bits&0x7FFFFF)>>shift_table[bits>>23]);;

  return hbits;
}

static float halfbits2float(uint16_t value) {
  uint32_t bits = mantissa_table[offset_table[value>>10]+(value&0x3FF)] + exponent_table[value>>10];

  union { uint32_t x; float y; } u;
  u.x = bits;
  return u.y;
}

// End of half.h.
// Start of timing.h.

// The function get_wall_time() returns the wall time in microseconds
// (with an unspecified offset).

#ifdef _WIN32

#include <windows.h>

static int64_t get_wall_time(void) {
  LARGE_INTEGER time,freq;
  assert(QueryPerformanceFrequency(&freq));
  assert(QueryPerformanceCounter(&time));
  return ((double)time.QuadPart / freq.QuadPart) * 1000000;
}

#else
// Assuming POSIX

#include <time.h>
#include <sys/time.h>

static int64_t get_wall_time(void) {
  struct timeval time;
  assert(gettimeofday(&time,NULL) == 0);
  return time.tv_sec * 1000000 + time.tv_usec;
}

static int64_t get_wall_time_ns(void) {
  struct timespec time;
  assert(clock_gettime(CLOCK_REALTIME, &time) == 0);
  return time.tv_sec * 1000000000 + time.tv_nsec;
}

#endif

// End of timing.h.

#ifdef _MSC_VER
#define inline __inline
#endif
#include <string.h>
#include <string.h>
#include <errno.h>
#include <assert.h>
#include <ctype.h>



// Start of lock.h.

// A very simple cross-platform implementation of locks.  Uses
// pthreads on Unix and some Windows thing there.  Futhark's
// host-level code is not multithreaded, but user code may be, so we
// need some mechanism for ensuring atomic access to API functions.
// This is that mechanism.  It is not exposed to user code at all, so
// we do not have to worry about name collisions.

#ifdef _WIN32

typedef HANDLE lock_t;

static void create_lock(lock_t *lock) {
  *lock = CreateMutex(NULL,  // Default security attributes.
                      FALSE, // Initially unlocked.
                      NULL); // Unnamed.
}

static void lock_lock(lock_t *lock) {
  assert(WaitForSingleObject(*lock, INFINITE) == WAIT_OBJECT_0);
}

static void lock_unlock(lock_t *lock) {
  assert(ReleaseMutex(*lock));
}

static void free_lock(lock_t *lock) {
  CloseHandle(*lock);
}

#else
// Assuming POSIX

#include <pthread.h>

typedef pthread_mutex_t lock_t;

static void create_lock(lock_t *lock) {
  int r = pthread_mutex_init(lock, NULL);
  assert(r == 0);
}

static void lock_lock(lock_t *lock) {
  int r = pthread_mutex_lock(lock);
  assert(r == 0);
}

static void lock_unlock(lock_t *lock) {
  int r = pthread_mutex_unlock(lock);
  assert(r == 0);
}

static void free_lock(lock_t *lock) {
  // Nothing to do for pthreads.
  (void)lock;
}

#endif

// End of lock.h.

#define FUTHARK_F64_ENABLED

// Start of scalar.h.

// Implementation of the primitive scalar operations.  Very
// repetitive.  This code is inserted directly into both CUDA and
// OpenCL programs, as well as the CPU code, so it has some #ifdefs to
// work everywhere.  Some operations are defined as macros because
// this allows us to use them as constant expressions in things like
// array sizes and static initialisers.

// Some of the #ifdefs are because OpenCL uses type-generic functions
// for some operations (e.g. sqrt), while C and CUDA sensibly use
// distinct functions for different precisions (e.g. sqrtf() and
// sqrt()).  This is quite annoying.  Due to C's unfortunate casting
// rules, it is also really easy to accidentally implement
// floating-point functions in the wrong precision, so be careful.

// Double-precision definitions are only included if the preprocessor
// macro FUTHARK_F64_ENABLED is set.

static inline uint8_t add8(uint8_t x, uint8_t y) {
  return x + y;
}

static inline uint16_t add16(uint16_t x, uint16_t y) {
  return x + y;
}

static inline uint32_t add32(uint32_t x, uint32_t y) {
  return x + y;
}

static inline uint64_t add64(uint64_t x, uint64_t y) {
  return x + y;
}

static inline uint8_t sub8(uint8_t x, uint8_t y) {
  return x - y;
}

static inline uint16_t sub16(uint16_t x, uint16_t y) {
  return x - y;
}

static inline uint32_t sub32(uint32_t x, uint32_t y) {
  return x - y;
}

static inline uint64_t sub64(uint64_t x, uint64_t y) {
  return x - y;
}

static inline uint8_t mul8(uint8_t x, uint8_t y) {
  return x * y;
}

static inline uint16_t mul16(uint16_t x, uint16_t y) {
  return x * y;
}

static inline uint32_t mul32(uint32_t x, uint32_t y) {
  return x * y;
}

static inline uint64_t mul64(uint64_t x, uint64_t y) {
  return x * y;
}

static inline uint8_t udiv8(uint8_t x, uint8_t y) {
  return x / y;
}

static inline uint16_t udiv16(uint16_t x, uint16_t y) {
  return x / y;
}

static inline uint32_t udiv32(uint32_t x, uint32_t y) {
  return x / y;
}

static inline uint64_t udiv64(uint64_t x, uint64_t y) {
  return x / y;
}

static inline uint8_t udiv_up8(uint8_t x, uint8_t y) {
  return (x + y - 1) / y;
}

static inline uint16_t udiv_up16(uint16_t x, uint16_t y) {
  return (x + y - 1) / y;
}

static inline uint32_t udiv_up32(uint32_t x, uint32_t y) {
  return (x + y - 1) / y;
}

static inline uint64_t udiv_up64(uint64_t x, uint64_t y) {
  return (x + y - 1) / y;
}

static inline uint8_t umod8(uint8_t x, uint8_t y) {
  return x % y;
}

static inline uint16_t umod16(uint16_t x, uint16_t y) {
  return x % y;
}

static inline uint32_t umod32(uint32_t x, uint32_t y) {
  return x % y;
}

static inline uint64_t umod64(uint64_t x, uint64_t y) {
  return x % y;
}

static inline uint8_t udiv_safe8(uint8_t x, uint8_t y) {
  return y == 0 ? 0 : x / y;
}

static inline uint16_t udiv_safe16(uint16_t x, uint16_t y) {
  return y == 0 ? 0 : x / y;
}

static inline uint32_t udiv_safe32(uint32_t x, uint32_t y) {
  return y == 0 ? 0 : x / y;
}

static inline uint64_t udiv_safe64(uint64_t x, uint64_t y) {
  return y == 0 ? 0 : x / y;
}

static inline uint8_t udiv_up_safe8(uint8_t x, uint8_t y) {
  return y == 0 ? 0 : (x + y - 1) / y;
}

static inline uint16_t udiv_up_safe16(uint16_t x, uint16_t y) {
  return y == 0 ? 0 : (x + y - 1) / y;
}

static inline uint32_t udiv_up_safe32(uint32_t x, uint32_t y) {
  return y == 0 ? 0 : (x + y - 1) / y;
}

static inline uint64_t udiv_up_safe64(uint64_t x, uint64_t y) {
  return y == 0 ? 0 : (x + y - 1) / y;
}

static inline uint8_t umod_safe8(uint8_t x, uint8_t y) {
  return y == 0 ? 0 : x % y;
}

static inline uint16_t umod_safe16(uint16_t x, uint16_t y) {
  return y == 0 ? 0 : x % y;
}

static inline uint32_t umod_safe32(uint32_t x, uint32_t y) {
  return y == 0 ? 0 : x % y;
}

static inline uint64_t umod_safe64(uint64_t x, uint64_t y) {
  return y == 0 ? 0 : x % y;
}

static inline int8_t sdiv8(int8_t x, int8_t y) {
  int8_t q = x / y;
  int8_t r = x % y;

  return q - ((r != 0 && r < 0 != y < 0) ? 1 : 0);
}

static inline int16_t sdiv16(int16_t x, int16_t y) {
  int16_t q = x / y;
  int16_t r = x % y;

  return q - ((r != 0 && r < 0 != y < 0) ? 1 : 0);
}

static inline int32_t sdiv32(int32_t x, int32_t y) {
  int32_t q = x / y;
  int32_t r = x % y;

  return q - ((r != 0 && r < 0 != y < 0) ? 1 : 0);
}

static inline int64_t sdiv64(int64_t x, int64_t y) {
  int64_t q = x / y;
  int64_t r = x % y;

  return q - ((r != 0 && r < 0 != y < 0) ? 1 : 0);
}

static inline int8_t sdiv_up8(int8_t x, int8_t y) {
  return sdiv8(x + y - 1, y);
}

static inline int16_t sdiv_up16(int16_t x, int16_t y) {
  return sdiv16(x + y - 1, y);
}

static inline int32_t sdiv_up32(int32_t x, int32_t y) {
  return sdiv32(x + y - 1, y);
}

static inline int64_t sdiv_up64(int64_t x, int64_t y) {
  return sdiv64(x + y - 1, y);
}

static inline int8_t smod8(int8_t x, int8_t y) {
  int8_t r = x % y;

  return r + (r == 0 || (x > 0 && y > 0) || (x < 0 && y < 0) ? 0 : y);
}

static inline int16_t smod16(int16_t x, int16_t y) {
  int16_t r = x % y;

  return r + (r == 0 || (x > 0 && y > 0) || (x < 0 && y < 0) ? 0 : y);
}

static inline int32_t smod32(int32_t x, int32_t y) {
  int32_t r = x % y;

  return r + (r == 0 || (x > 0 && y > 0) || (x < 0 && y < 0) ? 0 : y);
}

static inline int64_t smod64(int64_t x, int64_t y) {
  int64_t r = x % y;

  return r + (r == 0 || (x > 0 && y > 0) || (x < 0 && y < 0) ? 0 : y);
}

static inline int8_t sdiv_safe8(int8_t x, int8_t y) {
  return y == 0 ? 0 : sdiv8(x, y);
}

static inline int16_t sdiv_safe16(int16_t x, int16_t y) {
  return y == 0 ? 0 : sdiv16(x, y);
}

static inline int32_t sdiv_safe32(int32_t x, int32_t y) {
  return y == 0 ? 0 : sdiv32(x, y);
}

static inline int64_t sdiv_safe64(int64_t x, int64_t y) {
  return y == 0 ? 0 : sdiv64(x, y);
}

static inline int8_t sdiv_up_safe8(int8_t x, int8_t y) {
  return sdiv_safe8(x + y - 1, y);
}

static inline int16_t sdiv_up_safe16(int16_t x, int16_t y) {
  return sdiv_safe16(x + y - 1, y);
}

static inline int32_t sdiv_up_safe32(int32_t x, int32_t y) {
  return sdiv_safe32(x + y - 1, y);
}

static inline int64_t sdiv_up_safe64(int64_t x, int64_t y) {
  return sdiv_safe64(x + y - 1, y);
}

static inline int8_t smod_safe8(int8_t x, int8_t y) {
  return y == 0 ? 0 : smod8(x, y);
}

static inline int16_t smod_safe16(int16_t x, int16_t y) {
  return y == 0 ? 0 : smod16(x, y);
}

static inline int32_t smod_safe32(int32_t x, int32_t y) {
  return y == 0 ? 0 : smod32(x, y);
}

static inline int64_t smod_safe64(int64_t x, int64_t y) {
  return y == 0 ? 0 : smod64(x, y);
}

static inline int8_t squot8(int8_t x, int8_t y) {
  return x / y;
}

static inline int16_t squot16(int16_t x, int16_t y) {
  return x / y;
}

static inline int32_t squot32(int32_t x, int32_t y) {
  return x / y;
}

static inline int64_t squot64(int64_t x, int64_t y) {
  return x / y;
}

static inline int8_t srem8(int8_t x, int8_t y) {
  return x % y;
}

static inline int16_t srem16(int16_t x, int16_t y) {
  return x % y;
}

static inline int32_t srem32(int32_t x, int32_t y) {
  return x % y;
}

static inline int64_t srem64(int64_t x, int64_t y) {
  return x % y;
}

static inline int8_t squot_safe8(int8_t x, int8_t y) {
  return y == 0 ? 0 : x / y;
}

static inline int16_t squot_safe16(int16_t x, int16_t y) {
  return y == 0 ? 0 : x / y;
}

static inline int32_t squot_safe32(int32_t x, int32_t y) {
  return y == 0 ? 0 : x / y;
}

static inline int64_t squot_safe64(int64_t x, int64_t y) {
  return y == 0 ? 0 : x / y;
}

static inline int8_t srem_safe8(int8_t x, int8_t y) {
  return y == 0 ? 0 : x % y;
}

static inline int16_t srem_safe16(int16_t x, int16_t y) {
  return y == 0 ? 0 : x % y;
}

static inline int32_t srem_safe32(int32_t x, int32_t y) {
  return y == 0 ? 0 : x % y;
}

static inline int64_t srem_safe64(int64_t x, int64_t y) {
  return y == 0 ? 0 : x % y;
}

static inline int8_t smin8(int8_t x, int8_t y) {
  return x < y ? x : y;
}

static inline int16_t smin16(int16_t x, int16_t y) {
  return x < y ? x : y;
}

static inline int32_t smin32(int32_t x, int32_t y) {
  return x < y ? x : y;
}

static inline int64_t smin64(int64_t x, int64_t y) {
  return x < y ? x : y;
}

static inline uint8_t umin8(uint8_t x, uint8_t y) {
  return x < y ? x : y;
}

static inline uint16_t umin16(uint16_t x, uint16_t y) {
  return x < y ? x : y;
}

static inline uint32_t umin32(uint32_t x, uint32_t y) {
  return x < y ? x : y;
}

static inline uint64_t umin64(uint64_t x, uint64_t y) {
  return x < y ? x : y;
}

static inline int8_t smax8(int8_t x, int8_t y) {
  return x < y ? y : x;
}

static inline int16_t smax16(int16_t x, int16_t y) {
  return x < y ? y : x;
}

static inline int32_t smax32(int32_t x, int32_t y) {
  return x < y ? y : x;
}

static inline int64_t smax64(int64_t x, int64_t y) {
  return x < y ? y : x;
}

static inline uint8_t umax8(uint8_t x, uint8_t y) {
  return x < y ? y : x;
}

static inline uint16_t umax16(uint16_t x, uint16_t y) {
  return x < y ? y : x;
}

static inline uint32_t umax32(uint32_t x, uint32_t y) {
  return x < y ? y : x;
}

static inline uint64_t umax64(uint64_t x, uint64_t y) {
  return x < y ? y : x;
}

static inline uint8_t shl8(uint8_t x, uint8_t y) {
  return (uint8_t)(x << y);
}

static inline uint16_t shl16(uint16_t x, uint16_t y) {
  return (uint16_t)(x << y);
}

static inline uint32_t shl32(uint32_t x, uint32_t y) {
  return x << y;
}

static inline uint64_t shl64(uint64_t x, uint64_t y) {
  return x << y;
}

static inline uint8_t lshr8(uint8_t x, uint8_t y) {
  return x >> y;
}

static inline uint16_t lshr16(uint16_t x, uint16_t y) {
  return x >> y;
}

static inline uint32_t lshr32(uint32_t x, uint32_t y) {
  return x >> y;
}

static inline uint64_t lshr64(uint64_t x, uint64_t y) {
  return x >> y;
}

static inline int8_t ashr8(int8_t x, int8_t y) {
  return x >> y;
}

static inline int16_t ashr16(int16_t x, int16_t y) {
  return x >> y;
}

static inline int32_t ashr32(int32_t x, int32_t y) {
  return x >> y;
}

static inline int64_t ashr64(int64_t x, int64_t y) {
  return x >> y;
}

static inline uint8_t and8(uint8_t x, uint8_t y) {
  return x & y;
}

static inline uint16_t and16(uint16_t x, uint16_t y) {
  return x & y;
}

static inline uint32_t and32(uint32_t x, uint32_t y) {
  return x & y;
}

static inline uint64_t and64(uint64_t x, uint64_t y) {
  return x & y;
}

static inline uint8_t or8(uint8_t x, uint8_t y) {
  return x | y;
}

static inline uint16_t or16(uint16_t x, uint16_t y) {
  return x | y;
}

static inline uint32_t or32(uint32_t x, uint32_t y) {
  return x | y;
}

static inline uint64_t or64(uint64_t x, uint64_t y) {
  return x | y;
}

static inline uint8_t xor8(uint8_t x, uint8_t y) {
  return x ^ y;
}

static inline uint16_t xor16(uint16_t x, uint16_t y) {
  return x ^ y;
}

static inline uint32_t xor32(uint32_t x, uint32_t y) {
  return x ^ y;
}

static inline uint64_t xor64(uint64_t x, uint64_t y) {
  return x ^ y;
}

static inline bool ult8(uint8_t x, uint8_t y) {
  return x < y;
}

static inline bool ult16(uint16_t x, uint16_t y) {
  return x < y;
}

static inline bool ult32(uint32_t x, uint32_t y) {
  return x < y;
}

static inline bool ult64(uint64_t x, uint64_t y) {
  return x < y;
}

static inline bool ule8(uint8_t x, uint8_t y) {
  return x <= y;
}

static inline bool ule16(uint16_t x, uint16_t y) {
  return x <= y;
}

static inline bool ule32(uint32_t x, uint32_t y) {
  return x <= y;
}

static inline bool ule64(uint64_t x, uint64_t y) {
  return x <= y;
}

static inline bool slt8(int8_t x, int8_t y) {
  return x < y;
}

static inline bool slt16(int16_t x, int16_t y) {
  return x < y;
}

static inline bool slt32(int32_t x, int32_t y) {
  return x < y;
}

static inline bool slt64(int64_t x, int64_t y) {
  return x < y;
}

static inline bool sle8(int8_t x, int8_t y) {
  return x <= y;
}

static inline bool sle16(int16_t x, int16_t y) {
  return x <= y;
}

static inline bool sle32(int32_t x, int32_t y) {
  return x <= y;
}

static inline bool sle64(int64_t x, int64_t y) {
  return x <= y;
}

static inline uint8_t pow8(uint8_t x, uint8_t y) {
  uint8_t res = 1, rem = y;

  while (rem != 0) {
    if (rem & 1)
      res *= x;
    rem >>= 1;
    x *= x;
  }
  return res;
}

static inline uint16_t pow16(uint16_t x, uint16_t y) {
  uint16_t res = 1, rem = y;

  while (rem != 0) {
    if (rem & 1)
      res *= x;
    rem >>= 1;
    x *= x;
  }
  return res;
}

static inline uint32_t pow32(uint32_t x, uint32_t y) {
  uint32_t res = 1, rem = y;

  while (rem != 0) {
    if (rem & 1)
      res *= x;
    rem >>= 1;
    x *= x;
  }
  return res;
}

static inline uint64_t pow64(uint64_t x, uint64_t y) {
  uint64_t res = 1, rem = y;

  while (rem != 0) {
    if (rem & 1)
      res *= x;
    rem >>= 1;
    x *= x;
  }
  return res;
}

static inline bool itob_i8_bool(int8_t x) {
  return x;
}

static inline bool itob_i16_bool(int16_t x) {
  return x;
}

static inline bool itob_i32_bool(int32_t x) {
  return x;
}

static inline bool itob_i64_bool(int64_t x) {
  return x;
}

static inline int8_t btoi_bool_i8(bool x) {
  return x;
}

static inline int16_t btoi_bool_i16(bool x) {
  return x;
}

static inline int32_t btoi_bool_i32(bool x) {
  return x;
}

static inline int64_t btoi_bool_i64(bool x) {
  return x;
}

#define sext_i8_i8(x) ((int8_t) (int8_t) (x))
#define sext_i8_i16(x) ((int16_t) (int8_t) (x))
#define sext_i8_i32(x) ((int32_t) (int8_t) (x))
#define sext_i8_i64(x) ((int64_t) (int8_t) (x))
#define sext_i16_i8(x) ((int8_t) (int16_t) (x))
#define sext_i16_i16(x) ((int16_t) (int16_t) (x))
#define sext_i16_i32(x) ((int32_t) (int16_t) (x))
#define sext_i16_i64(x) ((int64_t) (int16_t) (x))
#define sext_i32_i8(x) ((int8_t) (int32_t) (x))
#define sext_i32_i16(x) ((int16_t) (int32_t) (x))
#define sext_i32_i32(x) ((int32_t) (int32_t) (x))
#define sext_i32_i64(x) ((int64_t) (int32_t) (x))
#define sext_i64_i8(x) ((int8_t) (int64_t) (x))
#define sext_i64_i16(x) ((int16_t) (int64_t) (x))
#define sext_i64_i32(x) ((int32_t) (int64_t) (x))
#define sext_i64_i64(x) ((int64_t) (int64_t) (x))
#define zext_i8_i8(x) ((int8_t) (uint8_t) (x))
#define zext_i8_i16(x) ((int16_t) (uint8_t) (x))
#define zext_i8_i32(x) ((int32_t) (uint8_t) (x))
#define zext_i8_i64(x) ((int64_t) (uint8_t) (x))
#define zext_i16_i8(x) ((int8_t) (uint16_t) (x))
#define zext_i16_i16(x) ((int16_t) (uint16_t) (x))
#define zext_i16_i32(x) ((int32_t) (uint16_t) (x))
#define zext_i16_i64(x) ((int64_t) (uint16_t) (x))
#define zext_i32_i8(x) ((int8_t) (uint32_t) (x))
#define zext_i32_i16(x) ((int16_t) (uint32_t) (x))
#define zext_i32_i32(x) ((int32_t) (uint32_t) (x))
#define zext_i32_i64(x) ((int64_t) (uint32_t) (x))
#define zext_i64_i8(x) ((int8_t) (uint64_t) (x))
#define zext_i64_i16(x) ((int16_t) (uint64_t) (x))
#define zext_i64_i32(x) ((int32_t) (uint64_t) (x))
#define zext_i64_i64(x) ((int64_t) (uint64_t) (x))

static int8_t abs8(int8_t x) {
  return (int8_t)abs(x);
}

static int16_t abs16(int16_t x) {
  return (int16_t)abs(x);
}

static int32_t abs32(int32_t x) {
  return abs(x);
}

static int64_t abs64(int64_t x) {
#if defined(__OPENCL_VERSION__)
  return abs(x);
#else
  return llabs(x);
#endif
}

#if defined(__OPENCL_VERSION__)
static int32_t futrts_popc8(int8_t x) {
  return popcount(x);
}

static int32_t futrts_popc16(int16_t x) {
  return popcount(x);
}

static int32_t futrts_popc32(int32_t x) {
  return popcount(x);
}

static int32_t futrts_popc64(int64_t x) {
  return popcount(x);
}
#elif defined(__CUDA_ARCH__)

static int32_t futrts_popc8(int8_t x) {
  return __popc(zext_i8_i32(x));
}

static int32_t futrts_popc16(int16_t x) {
  return __popc(zext_i16_i32(x));
}

static int32_t futrts_popc32(int32_t x) {
  return __popc(x);
}

static int32_t futrts_popc64(int64_t x) {
  return __popcll(x);
}

#else // Not OpenCL or CUDA, but plain C.

static int32_t futrts_popc8(uint8_t x) {
  int c = 0;
  for (; x; ++c) { x &= x - 1; }
  return c;
}

static int32_t futrts_popc16(uint16_t x) {
  int c = 0;
  for (; x; ++c) { x &= x - 1; }
  return c;
}

static int32_t futrts_popc32(uint32_t x) {
  int c = 0;
  for (; x; ++c) { x &= x - 1; }
  return c;
}

static int32_t futrts_popc64(uint64_t x) {
  int c = 0;
  for (; x; ++c) { x &= x - 1; }
  return c;
}
#endif

#if defined(__OPENCL_VERSION__)
static uint8_t futrts_mul_hi8(uint8_t a, uint8_t b) {
  return mul_hi(a, b);
}

static uint16_t futrts_mul_hi16(uint16_t a, uint16_t b) {
  return mul_hi(a, b);
}

static uint32_t futrts_mul_hi32(uint32_t a, uint32_t b) {
  return mul_hi(a, b);
}

static uint64_t futrts_mul_hi64(uint64_t a, uint64_t b) {
  return mul_hi(a, b);
}

#elif defined(__CUDA_ARCH__)

static uint8_t futrts_mul_hi8(uint8_t a, uint8_t b) {
  uint16_t aa = a;
  uint16_t bb = b;

  return aa * bb >> 8;
}

static uint16_t futrts_mul_hi16(uint16_t a, uint16_t b) {
  uint32_t aa = a;
  uint32_t bb = b;

  return aa * bb >> 16;
}

static uint32_t futrts_mul_hi32(uint32_t a, uint32_t b) {
  return mulhi(a, b);
}

static uint64_t futrts_mul_hi64(uint64_t a, uint64_t b) {
  return mul64hi(a, b);
}

#else // Not OpenCL or CUDA, but plain C.

static uint8_t futrts_mul_hi8(uint8_t a, uint8_t b) {
  uint16_t aa = a;
  uint16_t bb = b;

  return aa * bb >> 8;
}

static uint16_t futrts_mul_hi16(uint16_t a, uint16_t b) {
  uint32_t aa = a;
  uint32_t bb = b;

  return aa * bb >> 16;
}

static uint32_t futrts_mul_hi32(uint32_t a, uint32_t b) {
  uint64_t aa = a;
  uint64_t bb = b;

  return aa * bb >> 32;
}

static uint64_t futrts_mul_hi64(uint64_t a, uint64_t b) {
  __uint128_t aa = a;
  __uint128_t bb = b;

  return aa * bb >> 64;
}
#endif

#if defined(__OPENCL_VERSION__)
static uint8_t futrts_mad_hi8(uint8_t a, uint8_t b, uint8_t c) {
  return mad_hi(a, b, c);
}

static uint16_t futrts_mad_hi16(uint16_t a, uint16_t b, uint16_t c) {
  return mad_hi(a, b, c);
}

static uint32_t futrts_mad_hi32(uint32_t a, uint32_t b, uint32_t c) {
  return mad_hi(a, b, c);
}

static uint64_t futrts_mad_hi64(uint64_t a, uint64_t b, uint64_t c) {
  return mad_hi(a, b, c);
}

#else // Not OpenCL

static uint8_t futrts_mad_hi8(uint8_t a, uint8_t b, uint8_t c) {
  return futrts_mul_hi8(a, b) + c;
}

static uint16_t futrts_mad_hi16(uint16_t a, uint16_t b, uint16_t c) {
  return futrts_mul_hi16(a, b) + c;
}

static uint32_t futrts_mad_hi32(uint32_t a, uint32_t b, uint32_t c) {
  return futrts_mul_hi32(a, b) + c;
}

static uint64_t futrts_mad_hi64(uint64_t a, uint64_t b, uint64_t c) {
  return futrts_mul_hi64(a, b) + c;
}
#endif

#if defined(__OPENCL_VERSION__)
static int32_t futrts_clzz8(int8_t x) {
  return clz(x);
}

static int32_t futrts_clzz16(int16_t x) {
  return clz(x);
}

static int32_t futrts_clzz32(int32_t x) {
  return clz(x);
}

static int32_t futrts_clzz64(int64_t x) {
  return clz(x);
}

#elif defined(__CUDA_ARCH__)

static int32_t futrts_clzz8(int8_t x) {
  return __clz(zext_i8_i32(x)) - 24;
}

static int32_t futrts_clzz16(int16_t x) {
  return __clz(zext_i16_i32(x)) - 16;
}

static int32_t futrts_clzz32(int32_t x) {
  return __clz(x);
}

static int32_t futrts_clzz64(int64_t x) {
  return __clzll(x);
}

#else // Not OpenCL or CUDA, but plain C.

static int32_t futrts_clzz8(int8_t x) {
  return x == 0 ? 8 : __builtin_clz((uint32_t)zext_i8_i32(x)) - 24;
}

static int32_t futrts_clzz16(int16_t x) {
  return x == 0 ? 16 : __builtin_clz((uint32_t)zext_i16_i32(x)) - 16;
}

static int32_t futrts_clzz32(int32_t x) {
  return x == 0 ? 32 : __builtin_clz((uint32_t)x);
}

static int32_t futrts_clzz64(int64_t x) {
  return x == 0 ? 64 : __builtin_clzll((uint64_t)x);
}
#endif

#if defined(__OPENCL_VERSION__)
static int32_t futrts_ctzz8(int8_t x) {
  int i = 0;
  for (; i < 8 && (x & 1) == 0; i++, x >>= 1)
    ;
  return i;
}

static int32_t futrts_ctzz16(int16_t x) {
  int i = 0;
  for (; i < 16 && (x & 1) == 0; i++, x >>= 1)
    ;
  return i;
}

static int32_t futrts_ctzz32(int32_t x) {
  int i = 0;
  for (; i < 32 && (x & 1) == 0; i++, x >>= 1)
    ;
  return i;
}

static int32_t futrts_ctzz64(int64_t x) {
  int i = 0;
  for (; i < 64 && (x & 1) == 0; i++, x >>= 1)
    ;
  return i;
}

#elif defined(__CUDA_ARCH__)

static int32_t futrts_ctzz8(int8_t x) {
  int y = __ffs(x);
  return y == 0 ? 8 : y - 1;
}

static int32_t futrts_ctzz16(int16_t x) {
  int y = __ffs(x);
  return y == 0 ? 16 : y - 1;
}

static int32_t futrts_ctzz32(int32_t x) {
  int y = __ffs(x);
  return y == 0 ? 32 : y - 1;
}

static int32_t futrts_ctzz64(int64_t x) {
  int y = __ffsll(x);
  return y == 0 ? 64 : y - 1;
}

#else // Not OpenCL or CUDA, but plain C.

static int32_t futrts_ctzz8(int8_t x) {
  return x == 0 ? 8 : __builtin_ctz((uint32_t)x);
}

static int32_t futrts_ctzz16(int16_t x) {
  return x == 0 ? 16 : __builtin_ctz((uint32_t)x);
}

static int32_t futrts_ctzz32(int32_t x) {
  return x == 0 ? 32 : __builtin_ctz((uint32_t)x);
}

static int32_t futrts_ctzz64(int64_t x) {
  return x == 0 ? 64 : __builtin_ctzll((uint64_t)x);
}
#endif

static inline float fdiv32(float x, float y) {
  return x / y;
}

static inline float fadd32(float x, float y) {
  return x + y;
}

static inline float fsub32(float x, float y) {
  return x - y;
}

static inline float fmul32(float x, float y) {
  return x * y;
}

static inline bool cmplt32(float x, float y) {
  return x < y;
}

static inline bool cmple32(float x, float y) {
  return x <= y;
}

static inline float sitofp_i8_f32(int8_t x) {
  return (float) x;
}

static inline float sitofp_i16_f32(int16_t x) {
  return (float) x;
}

static inline float sitofp_i32_f32(int32_t x) {
  return (float) x;
}

static inline float sitofp_i64_f32(int64_t x) {
  return (float) x;
}

static inline float uitofp_i8_f32(uint8_t x) {
  return (float) x;
}

static inline float uitofp_i16_f32(uint16_t x) {
  return (float) x;
}

static inline float uitofp_i32_f32(uint32_t x) {
  return (float) x;
}

static inline float uitofp_i64_f32(uint64_t x) {
  return (float) x;
}

static inline int8_t fptosi_f32_i8(float x) {
  return (int8_t) x;
}

static inline int16_t fptosi_f32_i16(float x) {
  return (int16_t) x;
}

static inline int32_t fptosi_f32_i32(float x) {
  return (int32_t) x;
}

static inline int64_t fptosi_f32_i64(float x) {
  return (int64_t) x;
}

static inline uint8_t fptoui_f32_i8(float x) {
  return (uint8_t) x;
}

static inline uint16_t fptoui_f32_i16(float x) {
  return (uint16_t) x;
}

static inline uint32_t fptoui_f32_i32(float x) {
  return (uint32_t) x;
}

static inline uint64_t fptoui_f32_i64(float x) {
  return (uint64_t) x;
}

#ifdef __OPENCL_VERSION__
static inline float fabs32(float x) {
  return fabs(x);
}

static inline float fmax32(float x, float y) {
  return fmax(x, y);
}

static inline float fmin32(float x, float y) {
  return fmin(x, y);
}

static inline float fpow32(float x, float y) {
  return pow(x, y);
}

#else // Not OpenCL, but CUDA or plain C.

static inline float fabs32(float x) {
  return fabsf(x);
}

static inline float fmax32(float x, float y) {
  return fmaxf(x, y);
}

static inline float fmin32(float x, float y) {
  return fminf(x, y);
}

static inline float fpow32(float x, float y) {
  return powf(x, y);
}
#endif

static inline bool futrts_isnan32(float x) {
  return isnan(x);
}

static inline bool futrts_isinf32(float x) {
  return isinf(x);
}

#ifdef __OPENCL_VERSION__
static inline float futrts_log32(float x) {
  return log(x);
}

static inline float futrts_log2_32(float x) {
  return log2(x);
}

static inline float futrts_log10_32(float x) {
  return log10(x);
}

static inline float futrts_sqrt32(float x) {
  return sqrt(x);
}

static inline float futrts_exp32(float x) {
  return exp(x);
}

static inline float futrts_cos32(float x) {
  return cos(x);
}

static inline float futrts_sin32(float x) {
  return sin(x);
}

static inline float futrts_tan32(float x) {
  return tan(x);
}

static inline float futrts_acos32(float x) {
  return acos(x);
}

static inline float futrts_asin32(float x) {
  return asin(x);
}

static inline float futrts_atan32(float x) {
  return atan(x);
}

static inline float futrts_cosh32(float x) {
  return cosh(x);
}

static inline float futrts_sinh32(float x) {
  return sinh(x);
}

static inline float futrts_tanh32(float x) {
  return tanh(x);
}

static inline float futrts_acosh32(float x) {
  return acosh(x);
}

static inline float futrts_asinh32(float x) {
  return asinh(x);
}

static inline float futrts_atanh32(float x) {
  return atanh(x);
}

static inline float futrts_atan2_32(float x, float y) {
  return atan2(x, y);
}

static inline float futrts_hypot32(float x, float y) {
  return hypot(x, y);
}

static inline float futrts_gamma32(float x) {
  return tgamma(x);
}

static inline float futrts_lgamma32(float x) {
  return lgamma(x);
}

static inline float fmod32(float x, float y) {
  return fmod(x, y);
}

static inline float futrts_round32(float x) {
  return rint(x);
}

static inline float futrts_floor32(float x) {
  return floor(x);
}

static inline float futrts_ceil32(float x) {
  return ceil(x);
}

static inline float futrts_lerp32(float v0, float v1, float t) {
  return mix(v0, v1, t);
}

static inline float futrts_mad32(float a, float b, float c) {
  return mad(a, b, c);
}

static inline float futrts_fma32(float a, float b, float c) {
  return fma(a, b, c);
}

#else // Not OpenCL, but CUDA or plain C.

static inline float futrts_log32(float x) {
  return logf(x);
}

static inline float futrts_log2_32(float x) {
  return log2f(x);
}

static inline float futrts_log10_32(float x) {
  return log10f(x);
}

static inline float futrts_sqrt32(float x) {
  return sqrtf(x);
}

static inline float futrts_exp32(float x) {
  return expf(x);
}

static inline float futrts_cos32(float x) {
  return cosf(x);
}

static inline float futrts_sin32(float x) {
  return sinf(x);
}

static inline float futrts_tan32(float x) {
  return tanf(x);
}

static inline float futrts_acos32(float x) {
  return acosf(x);
}

static inline float futrts_asin32(float x) {
  return asinf(x);
}

static inline float futrts_atan32(float x) {
  return atanf(x);
}

static inline float futrts_cosh32(float x) {
  return coshf(x);
}

static inline float futrts_sinh32(float x) {
  return sinhf(x);
}

static inline float futrts_tanh32(float x) {
  return tanhf(x);
}

static inline float futrts_acosh32(float x) {
  return acoshf(x);
}

static inline float futrts_asinh32(float x) {
  return asinhf(x);
}

static inline float futrts_atanh32(float x) {
  return atanhf(x);
}

static inline float futrts_atan2_32(float x, float y) {
  return atan2f(x, y);
}

static inline float futrts_hypot32(float x, float y) {
  return hypotf(x, y);
}

static inline float futrts_gamma32(float x) {
  return tgammaf(x);
}

static inline float futrts_lgamma32(float x) {
  return lgammaf(x);
}

static inline float fmod32(float x, float y) {
  return fmodf(x, y);
}

static inline float futrts_round32(float x) {
  return rintf(x);
}

static inline float futrts_floor32(float x) {
  return floorf(x);
}

static inline float futrts_ceil32(float x) {
  return ceilf(x);
}

static inline float futrts_lerp32(float v0, float v1, float t) {
  return v0 + (v1 - v0) * t;
}

static inline float futrts_mad32(float a, float b, float c) {
  return a * b + c;
}

static inline float futrts_fma32(float a, float b, float c) {
  return fmaf(a, b, c);
}
#endif

static inline int32_t futrts_to_bits32(float x) {
  union {
    float f;
    int32_t t;
  } p;

  p.f = x;
  return p.t;
}

static inline float futrts_from_bits32(int32_t x) {
  union {
    int32_t f;
    float t;
  } p;

  p.f = x;
  return p.t;
}

static inline float fsignum32(float x) {
  return futrts_isnan32(x) ? x : (x > 0) - (x < 0);
}

#ifdef FUTHARK_F64_ENABLED

static inline double fdiv64(double x, double y) {
  return x / y;
}

static inline double fadd64(double x, double y) {
  return x + y;
}

static inline double fsub64(double x, double y) {
  return x - y;
}

static inline double fmul64(double x, double y) {
  return x * y;
}

static inline bool cmplt64(double x, double y) {
  return x < y;
}

static inline bool cmple64(double x, double y) {
  return x <= y;
}

static inline double sitofp_i8_f64(int8_t x) {
  return (double) x;
}

static inline double sitofp_i16_f64(int16_t x) {
  return (double) x;
}

static inline double sitofp_i32_f64(int32_t x) {
  return (double) x;
}

static inline double sitofp_i64_f64(int64_t x) {
  return (double) x;
}

static inline double uitofp_i8_f64(uint8_t x) {
  return (double) x;
}

static inline double uitofp_i16_f64(uint16_t x) {
  return (double) x;
}

static inline double uitofp_i32_f64(uint32_t x) {
  return (double) x;
}

static inline double uitofp_i64_f64(uint64_t x) {
  return (double) x;
}

static inline int8_t fptosi_f64_i8(double x) {
  return (int8_t) x;
}

static inline int16_t fptosi_f64_i16(double x) {
  return (int16_t) x;
}

static inline int32_t fptosi_f64_i32(double x) {
  return (int32_t) x;
}

static inline int64_t fptosi_f64_i64(double x) {
  return (int64_t) x;
}

static inline uint8_t fptoui_f64_i8(double x) {
  return (uint8_t) x;
}

static inline uint16_t fptoui_f64_i16(double x) {
  return (uint16_t) x;
}

static inline uint32_t fptoui_f64_i32(double x) {
  return (uint32_t) x;
}

static inline uint64_t fptoui_f64_i64(double x) {
  return (uint64_t) x;
}

static inline double fabs64(double x) {
  return fabs(x);
}

static inline double fmax64(double x, double y) {
  return fmax(x, y);
}

static inline double fmin64(double x, double y) {
  return fmin(x, y);
}

static inline double fpow64(double x, double y) {
  return pow(x, y);
}

static inline double futrts_log64(double x) {
  return log(x);
}

static inline double futrts_log2_64(double x) {
  return log2(x);
}

static inline double futrts_log10_64(double x) {
  return log10(x);
}

static inline double futrts_sqrt64(double x) {
  return sqrt(x);
}

static inline double futrts_exp64(double x) {
  return exp(x);
}

static inline double futrts_cos64(double x) {
  return cos(x);
}

static inline double futrts_sin64(double x) {
  return sin(x);
}

static inline double futrts_tan64(double x) {
  return tan(x);
}

static inline double futrts_acos64(double x) {
  return acos(x);
}

static inline double futrts_asin64(double x) {
  return asin(x);
}

static inline double futrts_atan64(double x) {
  return atan(x);
}

static inline double futrts_cosh64(double x) {
  return cosh(x);
}

static inline double futrts_sinh64(double x) {
  return sinh(x);
}

static inline double futrts_tanh64(double x) {
  return tanh(x);
}

static inline double futrts_acosh64(double x) {
  return acosh(x);
}

static inline double futrts_asinh64(double x) {
  return asinh(x);
}

static inline double futrts_atanh64(double x) {
  return atanh(x);
}

static inline double futrts_atan2_64(double x, double y) {
  return atan2(x, y);
}

static inline double futrts_hypot64(double x, double y) {
  return hypot(x, y);
}

static inline double futrts_gamma64(double x) {
  return tgamma(x);
}

static inline double futrts_lgamma64(double x) {
  return lgamma(x);
}

static inline double futrts_fma64(double a, double b, double c) {
  return fma(a, b, c);
}

static inline double futrts_round64(double x) {
  return rint(x);
}

static inline double futrts_ceil64(double x) {
  return ceil(x);
}

static inline double futrts_floor64(double x) {
  return floor(x);
}

static inline bool futrts_isnan64(double x) {
  return isnan(x);
}

static inline bool futrts_isinf64(double x) {
  return isinf(x);
}

static inline int64_t futrts_to_bits64(double x) {
  union {
    double f;
    int64_t t;
  } p;

  p.f = x;
  return p.t;
}

static inline double futrts_from_bits64(int64_t x) {
  union {
    int64_t f;
    double t;
  } p;

  p.f = x;
  return p.t;
}

static inline double fmod64(double x, double y) {
  return fmod(x, y);
}

static inline double fsignum64(double x) {
  return futrts_isnan64(x) ? x : (x > 0) - (x < 0);
}

static inline double futrts_lerp64(double v0, double v1, double t) {
#ifdef __OPENCL_VERSION__
  return mix(v0, v1, t);
#else
  return v0 + (v1 - v0) * t;
#endif
}

static inline double futrts_mad64(double a, double b, double c) {
#ifdef __OPENCL_VERSION__
  return mad(a, b, c);
#else
  return a * b + c;
#endif
}

static inline float fpconv_f32_f32(float x) {
  return (float) x;
}

static inline double fpconv_f32_f64(float x) {
  return (double) x;
}

static inline float fpconv_f64_f32(double x) {
  return (float) x;
}

static inline double fpconv_f64_f64(double x) {
  return (double) x;
}

#endif

// End of scalar.h.
// Start of scalar_f16.h.

// Half-precision is emulated if needed (e.g. in straight C) with the
// native type used if possible.  The emulation works by typedef'ing
// 'float' to 'f16', and then implementing all operations on single
// precision.  To cut down on duplication, we use the same code for
// those Futhark functions that require just operators or casts.  The
// in-memory representation for arrays will still be 16 bits even
// under emulation, so the compiler will have to be careful when
// generating reads or writes.

#if !defined(cl_khr_fp16) && !(defined(__CUDA_ARCH__) && __CUDA_ARCH__ >= 600)
#define EMULATE_F16
#endif

#if !defined(EMULATE_F16) && defined(__OPENCL_VERSION__)
#pragma OPENCL EXTENSION cl_khr_fp16 : enable
#endif

#ifdef EMULATE_F16

// Note that the half-precision storage format is still 16 bits - the
// compiler will have to be real careful!
typedef float f16;

#else

#ifdef __CUDA_ARCH__
#include <cuda_fp16.h>
#endif

typedef half f16;

#endif

// Some of these functions convert to single precision because half
// precision versions are not available.

static inline f16 fadd16(f16 x, f16 y) {
  return x + y;
}

static inline f16 fsub16(f16 x, f16 y) {
  return x - y;
}

static inline f16 fmul16(f16 x, f16 y) {
  return x * y;
}

static inline bool cmplt16(f16 x, f16 y) {
  return x < y;
}

static inline bool cmple16(f16 x, f16 y) {
  return x <= y;
}

static inline f16 sitofp_i8_f16(int8_t x) {
  return (f16) x;
}

static inline f16 sitofp_i16_f16(int16_t x) {
  return (f16) x;
}

static inline f16 sitofp_i32_f16(int32_t x) {
  return (f16) x;
}

static inline f16 sitofp_i64_f16(int64_t x) {
  return (f16) x;
}

static inline f16 uitofp_i8_f16(uint8_t x) {
  return (f16) x;
}

static inline f16 uitofp_i16_f16(uint16_t x) {
  return (f16) x;
}

static inline f16 uitofp_i32_f16(uint32_t x) {
  return (f16) x;
}

static inline f16 uitofp_i64_f16(uint64_t x) {
  return (f16) x;
}

static inline int8_t fptosi_f16_i8(f16 x) {
  return (int8_t) (float) x;
}

static inline int16_t fptosi_f16_i16(f16 x) {
  return (int16_t) x;
}

static inline int32_t fptosi_f16_i32(f16 x) {
  return (int32_t) x;
}

static inline int64_t fptosi_f16_i64(f16 x) {
  return (int64_t) x;
}

static inline uint8_t fptoui_f16_i8(f16 x) {
  return (uint8_t) (float) x;
}

static inline uint16_t fptoui_f16_i16(f16 x) {
  return (uint16_t) x;
}

static inline uint32_t fptoui_f16_i32(f16 x) {
  return (uint32_t) x;
}

static inline uint64_t fptoui_f16_i64(f16 x) {
  return (uint64_t) x;
}

#ifndef EMULATE_F16

#ifdef __OPENCL_VERSION__
static inline f16 fabs16(f16 x) {
  return fabs(x);
}

static inline f16 fmax16(f16 x, f16 y) {
  return fmax(x, y);
}

static inline f16 fmin16(f16 x, f16 y) {
  return fmin(x, y);
}

static inline f16 fpow16(f16 x, f16 y) {
  return pow(x, y);
}

#else // Assuming CUDA.

static inline f16 fabs16(f16 x) {
  return fabsf(x);
}

static inline f16 fmax16(f16 x, f16 y) {
  return fmaxf(x, y);
}

static inline f16 fmin16(f16 x, f16 y) {
  return fminf(x, y);
}

static inline f16 fpow16(f16 x, f16 y) {
  return powf(x, y);
}
#endif

static inline bool futrts_isnan16(f16 x) {
  return isnan((float)x);
}

static inline bool futrts_isinf16(f16 x) {
  return isinf((float)x);
}

#ifdef __OPENCL_VERSION__
static inline f16 futrts_log16(f16 x) {
  return log(x);
}

static inline f16 futrts_log2_16(f16 x) {
  return log2(x);
}

static inline f16 futrts_log10_16(f16 x) {
  return log10(x);
}

static inline f16 futrts_sqrt16(f16 x) {
  return sqrt(x);
}

static inline f16 futrts_exp16(f16 x) {
  return exp(x);
}

static inline f16 futrts_cos16(f16 x) {
  return cos(x);
}

static inline f16 futrts_sin16(f16 x) {
  return sin(x);
}

static inline f16 futrts_tan16(f16 x) {
  return tan(x);
}

static inline f16 futrts_acos16(f16 x) {
  return acos(x);
}

static inline f16 futrts_asin16(f16 x) {
  return asin(x);
}

static inline f16 futrts_atan16(f16 x) {
  return atan(x);
}

static inline f16 futrts_cosh16(f16 x) {
  return cosh(x);
}

static inline f16 futrts_sinh16(f16 x) {
  return sinh(x);
}

static inline f16 futrts_tanh16(f16 x) {
  return tanh(x);
}

static inline f16 futrts_acosh16(f16 x) {
  return acosh(x);
}

static inline f16 futrts_asinh16(f16 x) {
  return asinh(x);
}

static inline f16 futrts_atanh16(f16 x) {
  return atanh(x);
}

static inline f16 futrts_atan2_16(f16 x, f16 y) {
  return atan2(x, y);
}

static inline f16 futrts_hypot16(f16 x, f16 y) {
  return hypot(x, y);
}

static inline f16 futrts_gamma16(f16 x) {
  return tgamma(x);
}

static inline f16 futrts_lgamma16(f16 x) {
  return lgamma(x);
}

static inline f16 fmod16(f16 x, f16 y) {
  return fmod(x, y);
}

static inline f16 futrts_round16(f16 x) {
  return rint(x);
}

static inline f16 futrts_floor16(f16 x) {
  return floor(x);
}

static inline f16 futrts_ceil16(f16 x) {
  return ceil(x);
}

static inline f16 futrts_lerp16(f16 v0, f16 v1, f16 t) {
  return mix(v0, v1, t);
}

static inline f16 futrts_mad16(f16 a, f16 b, f16 c) {
  return mad(a, b, c);
}

static inline f16 futrts_fma16(f16 a, f16 b, f16 c) {
  return fma(a, b, c);
}

#else // Assume CUDA.

static inline f16 futrts_log16(f16 x) {
  return hlog(x);
}

static inline f16 futrts_log2_16(f16 x) {
  return hlog2(x);
}

static inline f16 futrts_log10_16(f16 x) {
  return hlog10(x);
}

static inline f16 futrts_sqrt16(f16 x) {
  return hsqrt(x);
}

static inline f16 futrts_exp16(f16 x) {
  return hexp(x);
}

static inline f16 futrts_cos16(f16 x) {
  return hcos(x);
}

static inline f16 futrts_sin16(f16 x) {
  return hsin(x);
}

static inline f16 futrts_tan16(f16 x) {
  return tanf(x);
}

static inline f16 futrts_acos16(f16 x) {
  return acosf(x);
}

static inline f16 futrts_asin16(f16 x) {
  return asinf(x);
}

static inline f16 futrts_atan16(f16 x) {
  return atanf(x);
}

static inline f16 futrts_cosh16(f16 x) {
  return coshf(x);
}

static inline f16 futrts_sinh16(f16 x) {
  return sinhf(x);
}

static inline f16 futrts_tanh16(f16 x) {
  return tanhf(x);
}

static inline f16 futrts_acosh16(f16 x) {
  return acoshf(x);
}

static inline f16 futrts_asinh16(f16 x) {
  return asinhf(x);
}

static inline f16 futrts_atanh16(f16 x) {
  return atanhf(x);
}

static inline f16 futrts_atan2_16(f16 x, f16 y) {
  return atan2f(x, y);
}

static inline f16 futrts_hypot16(f16 x, f16 y) {
  return hypotf(x, y);
}

static inline f16 futrts_gamma16(f16 x) {
  return tgammaf(x);
}

static inline f16 futrts_lgamma16(f16 x) {
  return lgammaf(x);
}

static inline f16 fmod16(f16 x, f16 y) {
  return fmodf(x, y);
}

static inline f16 futrts_round16(f16 x) {
  return rintf(x);
}

static inline f16 futrts_floor16(f16 x) {
  return hfloor(x);
}

static inline f16 futrts_ceil16(f16 x) {
  return hceil(x);
}

static inline f16 futrts_lerp16(f16 v0, f16 v1, f16 t) {
  return v0 + (v1 - v0) * t;
}

static inline f16 futrts_mad16(f16 a, f16 b, f16 c) {
  return a * b + c;
}

static inline f16 futrts_fma16(f16 a, f16 b, f16 c) {
  return fmaf(a, b, c);
}

#endif

// The CUDA __half type cannot be put in unions for some reason, so we
// use bespoke conversion functions instead.
#ifdef __CUDA_ARCH__
static inline int16_t futrts_to_bits16(f16 x) {
  return __half_as_ushort(x);
}
static inline f16 futrts_from_bits16(int16_t x) {
  return __ushort_as_half(x);
}
#else
static inline int16_t futrts_to_bits16(f16 x) {
  union {
    f16 f;
    int16_t t;
  } p;

  p.f = x;
  return p.t;
}

static inline f16 futrts_from_bits16(int16_t x) {
  union {
    int16_t f;
    f16 t;
  } p;

  p.f = x;
  return p.t;
}
#endif

#else // No native f16 - emulate.

static inline f16 fabs16(f16 x) {
  return fabs32(x);
}

static inline f16 fmax16(f16 x, f16 y) {
  return fmax32(x, y);
}

static inline f16 fmin16(f16 x, f16 y) {
  return fmin32(x, y);
}

static inline f16 fpow16(f16 x, f16 y) {
  return fpow32(x, y);
}

static inline bool futrts_isnan16(f16 x) {
  return futrts_isnan32(x);
}

static inline bool futrts_isinf16(f16 x) {
  return futrts_isinf32(x);
}

static inline f16 futrts_log16(f16 x) {
  return futrts_log32(x);
}

static inline f16 futrts_log2_16(f16 x) {
  return futrts_log2_32(x);
}

static inline f16 futrts_log10_16(f16 x) {
  return futrts_log10_32(x);
}

static inline f16 futrts_sqrt16(f16 x) {
  return futrts_sqrt32(x);
}

static inline f16 futrts_exp16(f16 x) {
  return futrts_exp32(x);
}

static inline f16 futrts_cos16(f16 x) {
  return futrts_cos32(x);
}

static inline f16 futrts_sin16(f16 x) {
  return futrts_sin32(x);
}

static inline f16 futrts_tan16(f16 x) {
  return futrts_tan32(x);
}

static inline f16 futrts_acos16(f16 x) {
  return futrts_acos32(x);
}

static inline f16 futrts_asin16(f16 x) {
  return futrts_asin32(x);
}

static inline f16 futrts_atan16(f16 x) {
  return futrts_atan32(x);
}

static inline f16 futrts_cosh16(f16 x) {
  return futrts_cosh32(x);
}

static inline f16 futrts_sinh16(f16 x) {
  return futrts_sinh32(x);
}

static inline f16 futrts_tanh16(f16 x) {
  return futrts_tanh32(x);
}

static inline f16 futrts_acosh16(f16 x) {
  return futrts_acosh32(x);
}

static inline f16 futrts_asinh16(f16 x) {
  return futrts_asinh32(x);
}

static inline f16 futrts_atanh16(f16 x) {
  return futrts_atanh32(x);
}

static inline f16 futrts_atan2_16(f16 x, f16 y) {
  return futrts_atan2_32(x, y);
}

static inline f16 futrts_hypot16(f16 x, f16 y) {
  return futrts_hypot32(x, y);
}

static inline f16 futrts_gamma16(f16 x) {
  return futrts_gamma32(x);
}

static inline f16 futrts_lgamma16(f16 x) {
  return futrts_lgamma32(x);
}

static inline f16 fmod16(f16 x, f16 y) {
  return fmod32(x, y);
}

static inline f16 futrts_round16(f16 x) {
  return futrts_round32(x);
}

static inline f16 futrts_floor16(f16 x) {
  return futrts_floor32(x);
}

static inline f16 futrts_ceil16(f16 x) {
  return futrts_ceil32(x);
}

static inline f16 futrts_lerp16(f16 v0, f16 v1, f16 t) {
  return futrts_lerp32(v0, v1, t);
}

static inline f16 futrts_mad16(f16 a, f16 b, f16 c) {
  return futrts_mad32(a, b, c);
}

static inline f16 futrts_fma16(f16 a, f16 b, f16 c) {
  return futrts_fma32(a, b, c);
}

// Even when we are using an OpenCL that does not support cl_khr_fp16,
// it must still support vload_half for actually creating a
// half-precision number, which can then be efficiently converted to a
// float.  Similarly for vstore_half.
#ifdef __OPENCL_VERSION__

static inline int16_t futrts_to_bits16(f16 x) {
  int16_t y;
  // Violating strict aliasing here.
  vstore_half((float)x, 0, (half*)&y);
  return y;
}

static inline f16 futrts_from_bits16(int16_t x) {
  return (f16)vload_half(0, (half*)&x);
}

#else

static inline int16_t futrts_to_bits16(f16 x) {
  return (int16_t)float2halfbits(x);
}

static inline f16 futrts_from_bits16(int16_t x) {
  return halfbits2float((uint16_t)x);
}

static inline f16 fsignum16(f16 x) {
  return futrts_isnan16(x) ? x : (x > 0) - (x < 0);
}

#endif

#endif

static inline float fpconv_f16_f16(f16 x) {
  return x;
}

static inline float fpconv_f16_f32(f16 x) {
  return x;
}

static inline f16 fpconv_f32_f16(float x) {
  return x;
}

#ifdef FUTHARK_F64_ENABLED

static inline double fpconv_f16_f64(f16 x) {
  return (double) x;
}

static inline f16 fpconv_f64_f16(double x) {
  return (f16) x;
}

#endif


// End of scalar_f16.h.

static int init_constants(struct futhark_context *);
static int free_constants(struct futhark_context *);
struct memblock {
    int *references;
    unsigned char *mem;
    int64_t size;
    const char *desc;
};
// start of scheduler.h

// First, the API that the generated code will access.  In principle,
// we could then compile the scheduler separately and link an object
// file with the generated code.  In practice, we will embed all of
// this in the generated code.

// Scheduler handle.
struct scheduler;

// Initialise a scheduler (and start worker threads).
static int scheduler_init(struct scheduler *scheduler,
                          int num_workers,
                          double kappa);

// Shut down a scheduler (and destroy worker threads).
static int scheduler_destroy(struct scheduler *scheduler);

// Figure out the smallest amount of work that amortises task
// creation.
static int determine_kappa(double *kappa);

// How a segop should be scheduled.
enum scheduling {
  DYNAMIC,
  STATIC
};

// How a given task should be executed.  Filled out by the scheduler
// and passed to the segop function
struct scheduler_info {
  int64_t iter_pr_subtask;
  int64_t remainder;
  int nsubtasks;
  enum scheduling sched;
  int wake_up_threads;

  int64_t *task_time;
  int64_t *task_iter;
};

// A segop function.  This is what you hand the scheduler for
// execution.
typedef int (*segop_fn)(void* args,
                        int64_t iterations,
                        int tid,
                        struct scheduler_info info);

// A task for the scheduler to execute.
struct scheduler_segop {
  void *args;
  segop_fn top_level_fn;
  segop_fn nested_fn;
  int64_t iterations;
  enum scheduling sched;

  // Pointers to timer and iter associated with the task
  int64_t *task_time;
  int64_t *task_iter;

  // For debugging
  const char* name;
};

static inline int scheduler_prepare_task(struct scheduler *scheduler,
                                         struct scheduler_segop *task);

typedef int (*parloop_fn)(void* args,
                          int64_t start,
                          int64_t end,
                          int subtask_id,
                          int tid);

// A parallel parloop task.
struct scheduler_parloop {
  void* args;
  parloop_fn fn;
  int64_t iterations;
  struct scheduler_info info;

  // For debugging
  const char* name;
};

static inline int scheduler_execute_task(struct scheduler *scheduler,
                                         struct scheduler_parloop *task);

// Then the API implementation.

#include <signal.h>

#if defined(_WIN32)
#include <windows.h>
#elif defined(__APPLE__)
#include <sys/sysctl.h>
// For getting cpu usage of threads
#include <mach/mach.h>
#include <sys/resource.h>
#elif defined(__linux__)
#include <sys/sysinfo.h>
#include <sys/resource.h>
#include <signal.h>
#elif defined(__EMSCRIPTEN__)
#include <emscripten/threading.h>
#include <sys/sysinfo.h>
#include <sys/resource.h>
#include <signal.h>
#endif

/* Multicore Utility functions */

/* A wrapper for getting rusage on Linux and MacOS */
/* TODO maybe figure out this for windows */
static inline int getrusage_thread(struct rusage *rusage)
{
  int err = -1;
#if  defined(__APPLE__)
    thread_basic_info_data_t info = { 0 };
    mach_msg_type_number_t info_count = THREAD_BASIC_INFO_COUNT;
    kern_return_t kern_err;

    kern_err = thread_info(mach_thread_self(),
                           THREAD_BASIC_INFO,
                           (thread_info_t)&info,
                           &info_count);
    if (kern_err == KERN_SUCCESS) {
        memset(rusage, 0, sizeof(struct rusage));
        rusage->ru_utime.tv_sec = info.user_time.seconds;
        rusage->ru_utime.tv_usec = info.user_time.microseconds;
        rusage->ru_stime.tv_sec = info.system_time.seconds;
        rusage->ru_stime.tv_usec = info.system_time.microseconds;
        err = 0;
    } else {
        errno = EINVAL;
    }
#elif defined(__linux__) || __EMSCRIPTEN__
    err = getrusage(RUSAGE_THREAD, rusage);
#endif
    return err;
}

/* returns the number of logical cores */
static int num_processors()
{
#if  defined(_WIN32)
/* https://docs.microsoft.com/en-us/windows/win32/api/sysinfoapi/ns-sysinfoapi-system_info */
    SYSTEM_INFO sysinfo;
    GetSystemInfo(&sysinfo);
    int ncores = sysinfo.dwNumberOfProcessors;
    fprintf(stderr, "Found %d cores on your Windows machine\n Is that correct?\n", ncores);
    return ncores;
#elif defined(__APPLE__)
    int ncores;
    size_t ncores_size = sizeof(ncores);
    CHECK_ERRNO(sysctlbyname("hw.logicalcpu", &ncores, &ncores_size, NULL, 0),
                "sysctlbyname (hw.logicalcpu)");
    return ncores;
#elif defined(__linux__)
  return get_nprocs();
#elif __EMSCRIPTEN__
  return emscripten_num_logical_cores();
#else
  fprintf(stderr, "operating system not recognised\n");
  return -1;
#endif
}

static unsigned int g_seed;

// Used to seed the generator.
static inline void fast_srand(unsigned int seed) {
    g_seed = seed;
}

// Compute a pseudorandom integer.
// Output value in range [0, 32767]
static inline unsigned int fast_rand(void) {
    g_seed = (214013*g_seed+2531011);
    return (g_seed>>16)&0x7FFF;
}

struct subtask_queue {
  int capacity;             // Size of the buffer.
  int first;                // Index of the start of the ring buffer.
  int num_used;             // Number of used elements in the buffer.
  struct subtask **buffer;

  pthread_mutex_t mutex;    // Mutex used for synchronisation.
  pthread_cond_t cond;      // Condition variable used for synchronisation.
  int dead;

#if defined(MCPROFILE)
  /* Profiling fields */
  uint64_t time_enqueue;
  uint64_t time_dequeue;
  uint64_t n_dequeues;
  uint64_t n_enqueues;
#endif
};

/* A subtask that can be executed by a worker */
struct subtask {
  /* The parloop function */
  parloop_fn fn;
  /* Execution parameters */
  void* args;
  int64_t start, end;
  int id;

  /* Dynamic scheduling parameters */
  int chunkable;
  int64_t chunk_size;

  /* Shared variables across subtasks */
  volatile int *counter; // Counter for ongoing subtasks
  // Shared task timers and iterators
  int64_t *task_time;
  int64_t *task_iter;

  /* For debugging */
  const char *name;
};


struct worker {
  pthread_t thread;
  struct scheduler *scheduler;  /* Reference to the scheduler struct the worker belongs to*/
  struct subtask_queue q;
  int dead;
  int tid;                      /* Just a thread id */

  /* "thread local" time fields used for online algorithm */
  uint64_t timer;
  uint64_t total;
  int nested; /* How nested the current computation is */

  // Profiling fields
  int output_usage;            /* Whether to dump thread usage */
  uint64_t time_spent_working; /* Time spent in parloop functions */
};

static inline void output_worker_usage(struct worker *worker)
{
  struct rusage usage;
  CHECK_ERRNO(getrusage_thread(&usage), "getrusage_thread");
  struct timeval user_cpu_time = usage.ru_utime;
  struct timeval sys_cpu_time = usage.ru_stime;
  fprintf(stderr, "tid: %2d - work time %10llu us - user time: %10llu us - sys: %10llu us\n",
          worker->tid,
          (long long unsigned)worker->time_spent_working / 1000,
          (long long unsigned)(user_cpu_time.tv_sec * 1000000 + user_cpu_time.tv_usec),
          (long long unsigned)(sys_cpu_time.tv_sec * 1000000 + sys_cpu_time.tv_usec));
}

/* Doubles the size of the queue */
static inline int subtask_queue_grow_queue(struct subtask_queue *subtask_queue) {

  int new_capacity = 2 * subtask_queue->capacity;
#ifdef MCDEBUG
  fprintf(stderr, "Growing queue to %d\n", subtask_queue->capacity * 2);
#endif

  struct subtask **new_buffer = calloc(new_capacity, sizeof(struct subtask*));
  for (int i = 0; i < subtask_queue->num_used; i++) {
    new_buffer[i] = subtask_queue->buffer[(subtask_queue->first + i) % subtask_queue->capacity];
  }

  free(subtask_queue->buffer);
  subtask_queue->buffer = new_buffer;
  subtask_queue->capacity = new_capacity;
  subtask_queue->first = 0;

  return 0;
}

// Initialise a job queue with the given capacity.  The queue starts out
// empty.  Returns non-zero on error.
static inline int subtask_queue_init(struct subtask_queue *subtask_queue, int capacity)
{
  assert(subtask_queue != NULL);
  memset(subtask_queue, 0, sizeof(struct subtask_queue));

  subtask_queue->capacity = capacity;
  subtask_queue->buffer = calloc(capacity, sizeof(struct subtask*));
  if (subtask_queue->buffer == NULL) {
    return -1;
  }

  CHECK_ERRNO(pthread_mutex_init(&subtask_queue->mutex, NULL), "pthread_mutex_init");
  CHECK_ERRNO(pthread_cond_init(&subtask_queue->cond, NULL), "pthread_cond_init");

  return 0;
}

// Destroy the job queue.  Blocks until the queue is empty before it
// is destroyed.
static inline int subtask_queue_destroy(struct subtask_queue *subtask_queue)
{
  assert(subtask_queue != NULL);

  CHECK_ERR(pthread_mutex_lock(&subtask_queue->mutex), "pthread_mutex_lock");

  while (subtask_queue->num_used != 0) {
    CHECK_ERR(pthread_cond_wait(&subtask_queue->cond, &subtask_queue->mutex), "pthread_cond_wait");
  }

  // Queue is now empty.  Let's kill it!
  subtask_queue->dead = 1;
  free(subtask_queue->buffer);
  CHECK_ERR(pthread_cond_broadcast(&subtask_queue->cond), "pthread_cond_broadcast");
  CHECK_ERR(pthread_mutex_unlock(&subtask_queue->mutex), "pthread_mutex_unlock");

  return 0;
}

static inline void dump_queue(struct worker *worker)
{
  struct subtask_queue *subtask_queue = &worker->q;
  CHECK_ERR(pthread_mutex_lock(&subtask_queue->mutex), "pthread_mutex_lock");
  for (int i = 0; i < subtask_queue->num_used; i++) {
    struct subtask * subtask = subtask_queue->buffer[(subtask_queue->first + i) % subtask_queue->capacity];
    printf("queue tid %d with %d task %s\n", worker->tid, i, subtask->name);
  }
  CHECK_ERR(pthread_cond_broadcast(&subtask_queue->cond), "pthread_cond_broadcast");
  CHECK_ERR(pthread_mutex_unlock(&subtask_queue->mutex), "pthread_mutex_unlock");
}

// Push an element onto the end of the job queue.  Blocks if the
// subtask_queue is full (its size is equal to its capacity).  Returns
// non-zero on error.  It is an error to push a job onto a queue that
// has been destroyed.
static inline int subtask_queue_enqueue(struct worker *worker, struct subtask *subtask )
{
  assert(worker != NULL);
  struct subtask_queue *subtask_queue = &worker->q;

#ifdef MCPROFILE
  uint64_t start = get_wall_time();
#endif

  CHECK_ERR(pthread_mutex_lock(&subtask_queue->mutex), "pthread_mutex_lock");
  // Wait until there is room in the subtask_queue.
  while (subtask_queue->num_used == subtask_queue->capacity && !subtask_queue->dead) {
    if (subtask_queue->num_used == subtask_queue->capacity) {
      CHECK_ERR(subtask_queue_grow_queue(subtask_queue), "subtask_queue_grow_queue");
      continue;
    }
    CHECK_ERR(pthread_cond_wait(&subtask_queue->cond, &subtask_queue->mutex), "pthread_cond_wait");
  }

  if (subtask_queue->dead) {
    CHECK_ERR(pthread_mutex_unlock(&subtask_queue->mutex), "pthread_mutex_unlock");
    return -1;
  }

  // If we made it past the loop, there is room in the subtask_queue.
  subtask_queue->buffer[(subtask_queue->first + subtask_queue->num_used) % subtask_queue->capacity] = subtask;
  subtask_queue->num_used++;

#ifdef MCPROFILE
  uint64_t end = get_wall_time();
  subtask_queue->time_enqueue += (end - start);
  subtask_queue->n_enqueues++;
#endif
  // Broadcast a reader (if any) that there is now an element.
  CHECK_ERR(pthread_cond_broadcast(&subtask_queue->cond), "pthread_cond_broadcast");
  CHECK_ERR(pthread_mutex_unlock(&subtask_queue->mutex), "pthread_mutex_unlock");

  return 0;
}


/* Like subtask_queue_dequeue, but with two differences:
   1) the subtask is stolen from the __front__ of the queue
   2) returns immediately if there is no subtasks queued,
      as we dont' want to block on another workers queue and
*/
static inline int subtask_queue_steal(struct worker *worker,
                                      struct subtask **subtask)
{
  struct subtask_queue *subtask_queue = &worker->q;
  assert(subtask_queue != NULL);

#ifdef MCPROFILE
  uint64_t start = get_wall_time();
#endif
  CHECK_ERR(pthread_mutex_lock(&subtask_queue->mutex), "pthread_mutex_lock");

  if (subtask_queue->num_used == 0) {
    CHECK_ERR(pthread_cond_broadcast(&subtask_queue->cond), "pthread_cond_broadcast");
    CHECK_ERR(pthread_mutex_unlock(&subtask_queue->mutex), "pthread_mutex_unlock");
    return 1;
  }

  if (subtask_queue->dead) {
    CHECK_ERR(pthread_mutex_unlock(&subtask_queue->mutex), "pthread_mutex_unlock");
    return -1;
  }

  // Tasks gets stolen from the "front"
  struct subtask *cur_back = subtask_queue->buffer[subtask_queue->first];
  struct subtask *new_subtask = NULL;
  int remaining_iter = cur_back->end - cur_back->start;
  // If subtask is chunkable, we steal half of the iterations
  if (cur_back->chunkable && remaining_iter > 1) {
      int64_t half = remaining_iter / 2;
      new_subtask = malloc(sizeof(struct subtask));
      *new_subtask = *cur_back;
      new_subtask->start = cur_back->end - half;
      cur_back->end = new_subtask->start;
      __atomic_fetch_add(cur_back->counter, 1, __ATOMIC_RELAXED);
  } else {
    new_subtask = cur_back;
    subtask_queue->num_used--;
    subtask_queue->first = (subtask_queue->first + 1) % subtask_queue->capacity;
  }
  *subtask = new_subtask;

  if (*subtask == NULL) {
    CHECK_ERR(pthread_mutex_unlock(&subtask_queue->mutex), "pthred_mutex_unlock");
    return 1;
  }

#ifdef MCPROFILE
  uint64_t end = get_wall_time();
  subtask_queue->time_dequeue += (end - start);
  subtask_queue->n_dequeues++;
#endif

  // Broadcast a writer (if any) that there is now room for more.
  CHECK_ERR(pthread_cond_broadcast(&subtask_queue->cond), "pthread_cond_broadcast");
  CHECK_ERR(pthread_mutex_unlock(&subtask_queue->mutex), "pthread_mutex_unlock");

  return 0;
}


// Pop an element from the back of the job queue.
// Optional argument can be provided to block or not
static inline int subtask_queue_dequeue(struct worker *worker,
                                        struct subtask **subtask, int blocking)
{
  assert(worker != NULL);
  struct subtask_queue *subtask_queue = &worker->q;

#ifdef MCPROFILE
  uint64_t start = get_wall_time();
#endif

  CHECK_ERR(pthread_mutex_lock(&subtask_queue->mutex), "pthread_mutex_lock");
  if (subtask_queue->num_used == 0 && !blocking) {
    CHECK_ERR(pthread_mutex_unlock(&subtask_queue->mutex), "pthread_mutex_unlock");
    return 1;
  }
  // Try to steal some work while the subtask_queue is empty
  while (subtask_queue->num_used == 0 && !subtask_queue->dead) {
    pthread_cond_wait(&subtask_queue->cond, &subtask_queue->mutex);
  }

  if (subtask_queue->dead) {
    CHECK_ERR(pthread_mutex_unlock(&subtask_queue->mutex), "pthread_mutex_unlock");
    return -1;
  }

  // dequeue pops from the back
  *subtask = subtask_queue->buffer[(subtask_queue->first + subtask_queue->num_used - 1) % subtask_queue->capacity];
  subtask_queue->num_used--;

  if (*subtask == NULL) {
    assert(!"got NULL ptr");
    CHECK_ERR(pthread_mutex_unlock(&subtask_queue->mutex), "pthred_mutex_unlock");
    return -1;
  }

#ifdef MCPROFILE
  uint64_t end = get_wall_time();
  subtask_queue->time_dequeue += (end - start);
  subtask_queue->n_dequeues++;
#endif

  // Broadcast a writer (if any) that there is now room for more.
  CHECK_ERR(pthread_cond_broadcast(&subtask_queue->cond), "pthread_cond_broadcast");
  CHECK_ERR(pthread_mutex_unlock(&subtask_queue->mutex), "pthread_mutex_unlock");

  return 0;
}

static inline int subtask_queue_is_empty(struct subtask_queue *subtask_queue)
{
  return subtask_queue->num_used == 0;
}

/* Scheduler definitions */

struct scheduler {
  struct worker *workers;
  int num_threads;

  // If there is work to steal => active_work > 0
  volatile int active_work;

  // Only one error can be returned at the time now.  Maybe we can
  // provide a stack like structure for pushing errors onto if we wish
  // to backpropagte multiple errors
  volatile int error;

  // kappa time unit in nanoseconds
  double kappa;
};


// Thread local variable worker struct
// Note that, accesses to tls variables are expensive
// Minimize direct references to this variable
__thread struct worker* worker_local = NULL;

static int64_t total_now(int64_t total, int64_t time) {
  return total + (get_wall_time_ns() - time);
}

static int random_other_worker(struct scheduler *scheduler, int my_id) {
  int my_num_workers = scheduler->num_threads;
  assert(my_num_workers != 1);
  int i = fast_rand() % (my_num_workers - 1);
  if (i >= my_id) {
    i++;
  }
#ifdef MCDEBUG
  assert(i >= 0);
  assert(i < my_num_workers);
  assert(i != my_id);
#endif

  return i;
}


static inline int64_t compute_chunk_size(double kappa, struct subtask* subtask)
{
  double C = (double)*subtask->task_time / (double)*subtask->task_iter;
  if (C == 0.0F) C += DBL_EPSILON;
  return smax64((int64_t)(kappa / C), 1);
}

/* Takes a chunk from subtask and enqueues the remaining iterations onto the worker's queue */
/* A no-op if the subtask is not chunkable */
static inline struct subtask* chunk_subtask(struct worker* worker, struct subtask *subtask)
{
  if (subtask->chunkable) {
    // Do we have information from previous runs avaliable
    if (*subtask->task_iter > 0) {
      subtask->chunk_size = compute_chunk_size(worker->scheduler->kappa, subtask);
      assert(subtask->chunk_size > 0);
    }
    int64_t remaining_iter = subtask->end - subtask->start;
    assert(remaining_iter > 0);
    if (remaining_iter > subtask->chunk_size) {
      struct subtask *new_subtask = malloc(sizeof(struct subtask));
      *new_subtask = *subtask;
      // increment the subtask join counter to account for new subtask
      __atomic_fetch_add(subtask->counter, 1, __ATOMIC_RELAXED);
      // Update range parameters
      subtask->end = subtask->start + subtask->chunk_size;
      new_subtask->start = subtask->end;
      subtask_queue_enqueue(worker, new_subtask);
    }
  }
  return subtask;
}

static inline int run_subtask(struct worker* worker, struct subtask* subtask)
{
  assert(subtask != NULL);
  assert(worker != NULL);

  subtask = chunk_subtask(worker, subtask);
  worker->total = 0;
  worker->timer = get_wall_time_ns();
#if defined(MCPROFILE)
  int64_t start = worker->timer;
#endif
  worker->nested++;
  int err = subtask->fn(subtask->args, subtask->start, subtask->end,
                        subtask->id,
                        worker->tid);
  worker->nested--;
  // Some error occured during some other subtask
  // so we just clean-up and return
  if (worker->scheduler->error != 0) {
    // Even a failed task counts as finished.
    __atomic_fetch_sub(subtask->counter, 1, __ATOMIC_RELAXED);
    free(subtask);
    return 0;
  }
  if (err != 0) {
    __atomic_store_n(&worker->scheduler->error, err, __ATOMIC_RELAXED);
  }
  // Total sequential time spent
  int64_t time_elapsed = total_now(worker->total, worker->timer);
#if defined(MCPROFILE)
  worker->time_spent_working += get_wall_time_ns() - start;
#endif
  int64_t iter = subtask->end - subtask->start;
  // report measurements
  // These updates should really be done using a single atomic CAS operation
  __atomic_fetch_add(subtask->task_time, time_elapsed, __ATOMIC_RELAXED);
  __atomic_fetch_add(subtask->task_iter, iter, __ATOMIC_RELAXED);
  // We need a fence here, since if the counter is decremented before either
  // of the two above are updated bad things can happen, e.g. if they are stack-allocated
  __atomic_thread_fence(__ATOMIC_SEQ_CST);
  __atomic_fetch_sub(subtask->counter, 1, __ATOMIC_RELAXED);
  free(subtask);
  return 0;
}


static inline int is_small(struct scheduler_segop *task, struct scheduler *scheduler, int *nsubtasks)
{
  int64_t time = *task->task_time;
  int64_t iter = *task->task_iter;

  if (task->sched == DYNAMIC || iter == 0) {
    *nsubtasks = scheduler->num_threads;
    return 0;
  }

  // Estimate the constant C
  double C = (double)time / (double)iter;
  double cur_task_iter = (double) task->iterations;

  // Returns true if the task is small i.e.
  // if the number of iterations times C is smaller
  // than the overhead of subtask creation
  if (C == 0.0F || C * cur_task_iter < scheduler->kappa) {
    *nsubtasks = 1;
    return 1;
  }

  // Else compute how many subtasks this tasks should create
  int64_t min_iter_pr_subtask = smax64(scheduler->kappa / C, 1);
  *nsubtasks = smin64(smax64(task->iterations / min_iter_pr_subtask, 1), scheduler->num_threads);

  return 0;
}

// TODO make this prettier
static inline struct subtask* create_subtask(parloop_fn fn,
                                             void* args,
                                             const char* name,
                                             volatile int* counter,
                                             int64_t *timer,
                                             int64_t *iter,
                                             int64_t start, int64_t end,
                                             int chunkable,
                                             int64_t chunk_size,
                                             int id)
{
  struct subtask* subtask = malloc(sizeof(struct subtask));
  if (subtask == NULL) {
    assert(!"malloc failed in create_subtask");
    return NULL;
  }
  subtask->fn         = fn;
  subtask->args       = args;

  subtask->counter    = counter;
  subtask->task_time  = timer;
  subtask->task_iter  = iter;

  subtask->start      = start;
  subtask->end        = end;
  subtask->id         = id;
  subtask->chunkable  = chunkable;
  subtask->chunk_size = chunk_size;

  subtask->name       = name;
  return subtask;
}

static int dummy_counter = 0;
static int64_t dummy_timer = 0;
static int64_t dummy_iter = 0;

static int dummy_fn(void *args, int64_t start, int64_t end, int subtask_id, int tid) {
  (void)args;
  (void)start;
  (void)end;
  (void)subtask_id;
  (void)tid;
  return 0;
}

// Wake up threads, who are blocking by pushing a dummy task
// onto their queue
static inline void wake_up_threads(struct scheduler *scheduler, int start_tid, int end_tid) {

#if defined(MCDEBUG)
  assert(start_tid >= 1);
  assert(end_tid <= scheduler->num_threads);
#endif
  for (int i = start_tid; i < end_tid; i++) {
    struct subtask *subtask = create_subtask(dummy_fn, NULL, "dummy_fn",
                                            &dummy_counter,
                                            &dummy_timer, &dummy_iter,
                                            0, 0,
                                            0, 0,
                                            0);
    CHECK_ERR(subtask_queue_enqueue(&scheduler->workers[i], subtask), "subtask_queue_enqueue");
  }
}

static inline int is_finished(struct worker *worker) {
  return worker->dead && subtask_queue_is_empty(&worker->q);
}

// Try to steal from a random queue
static inline int steal_from_random_worker(struct worker* worker)
{
  int my_id = worker->tid;
  struct scheduler* scheduler = worker->scheduler;
  int k = random_other_worker(scheduler, my_id);
  struct worker *worker_k = &scheduler->workers[k];
  struct subtask* subtask =  NULL;
  int retval = subtask_queue_steal(worker_k, &subtask);
  if (retval == 0) {
    subtask_queue_enqueue(worker, subtask);
    return 1;
  }
  return 0;
}


static inline void *scheduler_worker(void* args)
{
  struct worker *worker = (struct worker*) args;
  struct scheduler *scheduler = worker->scheduler;
  worker_local = worker;
  struct subtask *subtask = NULL;

  while(!is_finished(worker)) {
    if (!subtask_queue_is_empty(&worker->q)) {
      int retval = subtask_queue_dequeue(worker, &subtask, 0);
      if (retval == 0) {
        assert(subtask != NULL);
        CHECK_ERR(run_subtask(worker, subtask), "run_subtask");
      } // else someone stole our work

    } else if (scheduler->active_work) { /* steal */
      while (!is_finished(worker) && scheduler->active_work) {
        if (steal_from_random_worker(worker)) {
          break;
        }
      }
    } else { /* go back to sleep and wait for work */
      int retval = subtask_queue_dequeue(worker, &subtask, 1);
      if (retval == 0) {
        assert(subtask != NULL);
        CHECK_ERR(run_subtask(worker, subtask), "run_subtask");
      }
    }
  }

  assert(subtask_queue_is_empty(&worker->q));
#if defined(MCPROFILE)
  if (worker->output_usage)
    output_worker_usage(worker);
#endif
  return NULL;
}


static inline int scheduler_execute_parloop(struct scheduler *scheduler,
                                            struct scheduler_parloop *task,
                                            int64_t *timer)
{

  struct worker *worker = worker_local;

  struct scheduler_info info = task->info;
  int64_t iter_pr_subtask = info.iter_pr_subtask;
  int64_t remainder = info.remainder;
  int nsubtasks = info.nsubtasks;
  volatile int join_counter = nsubtasks;

  // Shared timer used to sum up all
  // sequential work from each subtask
  int64_t task_timer = 0;
  int64_t task_iter = 0;

  enum scheduling sched = info.sched;
  /* If each subtasks should be processed in chunks */
  int chunkable = sched == STATIC ? 0 : 1;
  int64_t chunk_size = 1; // The initial chunk size when no info is avaliable


  if (info.wake_up_threads || sched == DYNAMIC)
    __atomic_add_fetch(&scheduler->active_work, nsubtasks, __ATOMIC_RELAXED);

  int64_t start = 0;
  int64_t end = iter_pr_subtask + (int64_t)(remainder != 0);
  for (int subtask_id = 0; subtask_id < nsubtasks; subtask_id++) {
    struct subtask *subtask = create_subtask(task->fn, task->args, task->name,
                                              &join_counter,
                                              &task_timer, &task_iter,
                                              start, end,
                                              chunkable, chunk_size,
                                              subtask_id);
    assert(subtask != NULL);
    // In most cases we will never have more subtasks than workers,
    // but there can be exceptions (e.g. the kappa tuning function).
    struct worker *subtask_worker =
      worker->nested
      ? &scheduler->workers[worker->tid]
      : &scheduler->workers[subtask_id % scheduler->num_threads];
    CHECK_ERR(subtask_queue_enqueue(subtask_worker, subtask),
              "subtask_queue_enqueue");
    // Update range params
    start = end;
    end += iter_pr_subtask + ((subtask_id + 1) < remainder);
  }

  if (info.wake_up_threads) {
    wake_up_threads(scheduler, nsubtasks, scheduler->num_threads);
  }

  // Join (wait for subtasks to finish)
  while(join_counter != 0) {
    if (!subtask_queue_is_empty(&worker->q)) {
      struct subtask *subtask = NULL;
      int err = subtask_queue_dequeue(worker, &subtask, 0);
      if (err == 0 ) {
        CHECK_ERR(run_subtask(worker, subtask), "run_subtask");
      }
    } else {
      if (steal_from_random_worker(worker)) {
        struct subtask *subtask = NULL;
        int err = subtask_queue_dequeue(worker, &subtask, 0);
        if (err == 0) {
          CHECK_ERR(run_subtask(worker, subtask), "run_subtask");
        }
      }
    }
  }


  if (info.wake_up_threads || sched == DYNAMIC) {
    __atomic_sub_fetch(&scheduler->active_work, nsubtasks, __ATOMIC_RELAXED);
  }

  // Write back timing results of all sequential work
  (*timer) += task_timer;
  return scheduler->error;
}


static inline int scheduler_execute_task(struct scheduler *scheduler,
                                         struct scheduler_parloop *task)
{

  struct worker *worker = worker_local;

  int err = 0;

  // How much sequential work was performed by the task
  int64_t task_timer = 0;

  /* Execute task sequential or parallel based on decision made earlier */
  if (task->info.nsubtasks == 1) {
    int64_t start = get_wall_time_ns();
    err = task->fn(task->args, 0, task->iterations, 0, worker->tid);
    int64_t end = get_wall_time_ns();
    task_timer = end - start;
    worker->time_spent_working += task_timer;
    // Report time measurements
    // TODO the update of both of these should really be a single atomic!!
    __atomic_fetch_add(task->info.task_time, task_timer, __ATOMIC_RELAXED);
    __atomic_fetch_add(task->info.task_iter, task->iterations, __ATOMIC_RELAXED);
  } else {
    // Add "before" time if we already are inside a task
    int64_t time_before = 0;
    if (worker->nested > 0) {
      time_before = total_now(worker->total, worker->timer);
    }

    err = scheduler_execute_parloop(scheduler, task, &task_timer);

    // Report time measurements
    // TODO the update of both of these should really be a single atomic!!
    __atomic_fetch_add(task->info.task_time, task_timer, __ATOMIC_RELAXED);
    __atomic_fetch_add(task->info.task_iter, task->iterations, __ATOMIC_RELAXED);

    // Update timers to account for new timings
    worker->total = time_before + task_timer;
    worker->timer = get_wall_time_ns();
  }


  return err;
}

/* Decide on how schedule the incoming task i.e. how many subtasks and
   to run sequential or (potentially nested) parallel code body */
static inline int scheduler_prepare_task(struct scheduler* scheduler,
                                         struct scheduler_segop *task)
{
  assert(task != NULL);

  struct worker *worker = worker_local;
  struct scheduler_info info;
  info.task_time = task->task_time;
  info.task_iter = task->task_iter;

  int nsubtasks;
  // Decide if task should be scheduled sequentially
  if (is_small(task, scheduler, &nsubtasks)) {
    info.iter_pr_subtask = task->iterations;
    info.remainder = 0;
    info.nsubtasks = nsubtasks;
    return task->top_level_fn(task->args, task->iterations, worker->tid, info);
  } else {
    info.iter_pr_subtask = task->iterations / nsubtasks;
    info.remainder = task->iterations % nsubtasks;
    info.sched = task->sched;
    switch (task->sched) {
    case STATIC:
      info.nsubtasks = info.iter_pr_subtask == 0 ? info.remainder : ((task->iterations - info.remainder) / info.iter_pr_subtask);
      break;
    case DYNAMIC:
      // As any thread can take any subtasks, we are being safe with using
      // an upper bound on the number of tasks such that the task allocate enough memory
      info.nsubtasks = info.iter_pr_subtask == 0 ? info.remainder : nsubtasks;
      break;
    default:
      assert(!"Got unknown scheduling");
    }
  }

  info.wake_up_threads = 0;
  // We only use the nested parallel segop function if we can't exchaust all cores
  // using the outer most level
  if (task->nested_fn != NULL && info.nsubtasks < scheduler->num_threads && info.nsubtasks == task->iterations) {
    if (worker->nested == 0)
      info.wake_up_threads = 1;
    return task->nested_fn(task->args, task->iterations, worker->tid, info);
  }

  return task->top_level_fn(task->args, task->iterations, worker->tid, info);
}

// Now some code for finding the proper value of kappa on a given
// machine (the smallest amount of work that amortises the cost of
// task creation).

struct tuning_struct {
  int32_t *free_tuning_res;
  int32_t *array;
};

// Reduction function over an integer array
static int tuning_loop(void *args, int64_t start, int64_t end,
                                     int flat_tid, int tid) {
  (void)flat_tid;
  (void)tid;

  int err = 0;
  struct tuning_struct *tuning_struct = (struct tuning_struct *) args;
  int32_t *array = tuning_struct->array;
  int32_t *tuning_res = tuning_struct->free_tuning_res;

  int32_t sum = 0;
  for (int i = start; i < end; i++) {
    int32_t y = array[i];
    sum = add32(sum, y);
  }
  *tuning_res = sum;
  return err;
}

// The main entry point for the tuning process.  Sets the provided
// variable ``kappa``.
static int determine_kappa(double *kappa) {
  int err = 0;

  int64_t iterations = 100000000;
  int64_t tuning_time = 0;
  int64_t tuning_iter = 0;

  int32_t *array = malloc(sizeof(int32_t) * iterations);
  for (int64_t i = 0; i < iterations; i++) {
    array[i] = fast_rand();
  }

  int64_t start_tuning = get_wall_time_ns();
  /* **************************** */
  /* Run sequential reduce first' */
  /* **************************** */
  int64_t tuning_sequentiual_start = get_wall_time_ns();
  struct tuning_struct tuning_struct;
  int32_t tuning_res;
  tuning_struct.free_tuning_res = &tuning_res;
  tuning_struct.array = array;

  err = tuning_loop(&tuning_struct, 0, iterations, 0, 0);
  int64_t tuning_sequentiual_end = get_wall_time_ns();
  int64_t sequential_elapsed = tuning_sequentiual_end - tuning_sequentiual_start;

  double C = (double)sequential_elapsed / (double)iterations;
  fprintf(stderr, " Time for sequential run is %lld - Found C %f\n", (long long)sequential_elapsed, C);

  /* ********************** */
  /* Now run tuning process */
  /* ********************** */
  // Setup a scheduler with a single worker
  struct scheduler scheduler;
  scheduler.num_threads = 1;
  scheduler.workers = malloc(sizeof(struct worker));
  worker_local = &scheduler.workers[0];
  worker_local->tid = 0;
  CHECK_ERR(subtask_queue_init(&scheduler.workers[0].q, 1024),
            "failed to init queue for worker %d\n", 0);

  // Start tuning for kappa
  double kappa_tune = 1000; // Initial kappa is 1 us
  double ratio;
  int64_t time_elapsed;
  while(1) {
    int64_t min_iter_pr_subtask = (int64_t) (kappa_tune / C) == 0 ? 1 : (kappa_tune / C);
    int nsubtasks = iterations / min_iter_pr_subtask;
    struct scheduler_info info;
    info.iter_pr_subtask = min_iter_pr_subtask;

    info.nsubtasks = iterations / min_iter_pr_subtask;
    info.remainder = iterations % min_iter_pr_subtask;
    info.task_time = &tuning_time;
    info.task_iter = &tuning_iter;
    info.sched = STATIC;

    struct scheduler_parloop parloop;
    parloop.name = "tuning_loop";
    parloop.fn = tuning_loop;
    parloop.args = &tuning_struct;
    parloop.iterations = iterations;
    parloop.info = info;

    int64_t tuning_chunked_start = get_wall_time_ns();
    int determine_kappa_err =
      scheduler_execute_task(&scheduler,
                             &parloop);
    assert(determine_kappa_err == 0);
    int64_t tuning_chunked_end = get_wall_time_ns();
    time_elapsed =  tuning_chunked_end - tuning_chunked_start;

    ratio = (double)time_elapsed / (double)sequential_elapsed;
    if (ratio < 1.055) {
      break;
    }
    kappa_tune += 100; // Increase by 100 ns at the time
    fprintf(stderr, "nsubtask %d - kappa %f - ratio %f\n", nsubtasks, kappa_tune, ratio);
  }

  int64_t end_tuning = get_wall_time_ns();
  fprintf(stderr, "tuning took %lld ns and found kappa %f - time %lld - ratio %f\n",
          (long long)end_tuning - start_tuning,
          kappa_tune,
          (long long)time_elapsed,
          ratio);
  *kappa = kappa_tune;

  // Clean-up
  CHECK_ERR(subtask_queue_destroy(&scheduler.workers[0].q), "failed to destroy queue");
  free(array);
  free(scheduler.workers);
  return err;
}

static int scheduler_init(struct scheduler *scheduler,
                          int num_workers,
                          double kappa) {
  assert(num_workers > 0);

  scheduler->kappa = kappa;
  scheduler->num_threads = num_workers;
  scheduler->active_work = 0;
  scheduler->error = 0;

  scheduler->workers = calloc(num_workers, sizeof(struct worker));

  const int queue_capacity = 1024;

  worker_local = &scheduler->workers[0];
  worker_local->tid = 0;
  worker_local->scheduler = scheduler;
  CHECK_ERR(subtask_queue_init(&worker_local->q, queue_capacity),
            "failed to init queue for worker %d\n", 0);

  for (int i = 1; i < num_workers; i++) {
    struct worker *cur_worker = &scheduler->workers[i];
    memset(cur_worker, 0, sizeof(struct worker));
    cur_worker->tid = i;
    cur_worker->output_usage = 0;
    cur_worker->scheduler = scheduler;
    CHECK_ERR(subtask_queue_init(&cur_worker->q, queue_capacity),
              "failed to init queue for worker %d\n", i);

    CHECK_ERR(pthread_create(&cur_worker->thread,
                             NULL,
                             &scheduler_worker,
                             cur_worker),
              "Failed to create worker %d\n", i);
  }

  return 0;
}

static int scheduler_destroy(struct scheduler *scheduler) {
  // We assume that this function is called by the thread controlling
  // the first worker, which is why we treat scheduler->workers[0]
  // specially here.

  // First mark them all as dead.
  for (int i = 1; i < scheduler->num_threads; i++) {
    struct worker *cur_worker = &scheduler->workers[i];
    cur_worker->dead = 1;
  }

  // Then destroy their task queues (this will wake up the threads and
  // make them do their shutdown).
  for (int i = 1; i < scheduler->num_threads; i++) {
    struct worker *cur_worker = &scheduler->workers[i];
    subtask_queue_destroy(&cur_worker->q);
  }

  // Then actually wait for them to stop.
  for (int i = 1; i < scheduler->num_threads; i++) {
    struct worker *cur_worker = &scheduler->workers[i];
    CHECK_ERR(pthread_join(scheduler->workers[i].thread, NULL), "pthread_join");
  }

  // And then destroy our own queue.
  subtask_queue_destroy(&scheduler->workers[0].q);

  free(scheduler->workers);

  return 0;
}

// End of scheduler.h

struct futhark_context_config {
    int in_use;
    int debugging;
    int profiling;
    int num_threads;
};
struct futhark_context_config *futhark_context_config_new(void)
{
    struct futhark_context_config *cfg =
                                  (struct futhark_context_config *) malloc(sizeof(struct futhark_context_config));
    
    if (cfg == NULL)
        return NULL;
    cfg->in_use = 0;
    cfg->debugging = 0;
    cfg->profiling = 0;
    cfg->num_threads = 0;
    return cfg;
}
void futhark_context_config_free(struct futhark_context_config *cfg)
{
    assert(!cfg->in_use);
    free(cfg);
}
void futhark_context_config_set_debugging(struct futhark_context_config *cfg,
                                          int detail)
{
    cfg->debugging = detail;
}
void futhark_context_config_set_profiling(struct futhark_context_config *cfg,
                                          int flag)
{
    cfg->profiling = flag;
}
void futhark_context_config_set_logging(struct futhark_context_config *cfg,
                                        int detail)
{
    // Does nothing for this backend.
    (void) cfg;
    (void) detail;
}
void futhark_context_config_set_num_threads(struct futhark_context_config *cfg,
                                            int n)
{
    cfg->num_threads = n;
}
struct futhark_context {
    struct futhark_context_config *cfg;
    struct scheduler scheduler;
    int detail_memory;
    int debugging;
    int profiling;
    int profiling_paused;
    int logging;
    lock_t lock;
    char *error;
    FILE *log;
    int total_runs;
    long total_runtime;
    int64_t peak_mem_usage_default;
    int64_t cur_mem_usage_default;
    struct {
        int dummy;
    } constants;
    int64_t *futhark_mc_segred_stage_1_parloop_337688_total_runtime;
    int *futhark_mc_segred_stage_1_parloop_337688_runs;
    int64_t *futhark_mc_segred_stage_1_parloop_337688_iter;
    int64_t futhark_mc_segred_stage_1_parloop_337688_total_total_runtime;
    int futhark_mc_segred_stage_1_parloop_337688_total_runs;
    int64_t futhark_mc_segred_stage_1_parloop_337688_total_iter;
    int64_t *futhark_mc_segred_task_337685_total_runtime;
    int *futhark_mc_segred_task_337685_runs;
    int64_t *futhark_mc_segred_task_337685_iter;
    int64_t futhark_mc_segred_task_337685_total_time;
    int64_t futhark_mc_segred_task_337685_total_iter;
    int64_t *futhark_mc_segred_stage_1_parloop_337697_total_runtime;
    int *futhark_mc_segred_stage_1_parloop_337697_runs;
    int64_t *futhark_mc_segred_stage_1_parloop_337697_iter;
    int64_t futhark_mc_segred_stage_1_parloop_337697_total_total_runtime;
    int futhark_mc_segred_stage_1_parloop_337697_total_runs;
    int64_t futhark_mc_segred_stage_1_parloop_337697_total_iter;
    int64_t *futhark_mc_segred_task_337694_total_runtime;
    int *futhark_mc_segred_task_337694_runs;
    int64_t *futhark_mc_segred_task_337694_iter;
    int64_t futhark_mc_segred_task_337694_total_time;
    int64_t futhark_mc_segred_task_337694_total_iter;
    int64_t *futhark_mc_segred_stage_1_parloop_337692_total_runtime;
    int *futhark_mc_segred_stage_1_parloop_337692_runs;
    int64_t *futhark_mc_segred_stage_1_parloop_337692_iter;
    int64_t futhark_mc_segred_stage_1_parloop_337692_total_total_runtime;
    int futhark_mc_segred_stage_1_parloop_337692_total_runs;
    int64_t futhark_mc_segred_stage_1_parloop_337692_total_iter;
    int64_t *futhark_mc_segred_nested_task_337689_total_runtime;
    int *futhark_mc_segred_nested_task_337689_runs;
    int64_t *futhark_mc_segred_nested_task_337689_iter;
    int64_t *futhark_mc_scan_stage_1_parloop_337683_total_runtime;
    int *futhark_mc_scan_stage_1_parloop_337683_runs;
    int64_t *futhark_mc_scan_stage_1_parloop_337683_iter;
    int64_t futhark_mc_scan_stage_1_parloop_337683_total_total_runtime;
    int futhark_mc_scan_stage_1_parloop_337683_total_runs;
    int64_t futhark_mc_scan_stage_1_parloop_337683_total_iter;
    int64_t *futhark_mc_segred_stage_1_parloop_337702_total_runtime;
    int *futhark_mc_segred_stage_1_parloop_337702_runs;
    int64_t *futhark_mc_segred_stage_1_parloop_337702_iter;
    int64_t futhark_mc_segred_stage_1_parloop_337702_total_total_runtime;
    int futhark_mc_segred_stage_1_parloop_337702_total_runs;
    int64_t futhark_mc_segred_stage_1_parloop_337702_total_iter;
    int64_t *futhark_mc_segred_task_337699_total_runtime;
    int *futhark_mc_segred_task_337699_runs;
    int64_t *futhark_mc_segred_task_337699_iter;
    int64_t futhark_mc_segred_task_337699_total_time;
    int64_t futhark_mc_segred_task_337699_total_iter;
    int64_t *futhark_mc_segred_stage_1_parloop_337711_total_runtime;
    int *futhark_mc_segred_stage_1_parloop_337711_runs;
    int64_t *futhark_mc_segred_stage_1_parloop_337711_iter;
    int64_t futhark_mc_segred_stage_1_parloop_337711_total_total_runtime;
    int futhark_mc_segred_stage_1_parloop_337711_total_runs;
    int64_t futhark_mc_segred_stage_1_parloop_337711_total_iter;
    int64_t *futhark_mc_segred_task_337708_total_runtime;
    int *futhark_mc_segred_task_337708_runs;
    int64_t *futhark_mc_segred_task_337708_iter;
    int64_t futhark_mc_segred_task_337708_total_time;
    int64_t futhark_mc_segred_task_337708_total_iter;
    int64_t *futhark_mc_segred_stage_1_parloop_337706_total_runtime;
    int *futhark_mc_segred_stage_1_parloop_337706_runs;
    int64_t *futhark_mc_segred_stage_1_parloop_337706_iter;
    int64_t futhark_mc_segred_stage_1_parloop_337706_total_total_runtime;
    int futhark_mc_segred_stage_1_parloop_337706_total_runs;
    int64_t futhark_mc_segred_stage_1_parloop_337706_total_iter;
    int64_t *futhark_mc_segred_nested_task_337703_total_runtime;
    int *futhark_mc_segred_nested_task_337703_runs;
    int64_t *futhark_mc_segred_nested_task_337703_iter;
    int64_t *futhark_mc_segred_stage_1_parloop_337718_total_runtime;
    int *futhark_mc_segred_stage_1_parloop_337718_runs;
    int64_t *futhark_mc_segred_stage_1_parloop_337718_iter;
    int64_t futhark_mc_segred_stage_1_parloop_337718_total_total_runtime;
    int futhark_mc_segred_stage_1_parloop_337718_total_runs;
    int64_t futhark_mc_segred_stage_1_parloop_337718_total_iter;
    int64_t *futhark_mc_segred_task_337715_total_runtime;
    int *futhark_mc_segred_task_337715_runs;
    int64_t *futhark_mc_segred_task_337715_iter;
    int64_t futhark_mc_segred_task_337715_total_time;
    int64_t futhark_mc_segred_task_337715_total_iter;
    int64_t *futhark_mc_segred_stage_1_parloop_337727_total_runtime;
    int *futhark_mc_segred_stage_1_parloop_337727_runs;
    int64_t *futhark_mc_segred_stage_1_parloop_337727_iter;
    int64_t futhark_mc_segred_stage_1_parloop_337727_total_total_runtime;
    int futhark_mc_segred_stage_1_parloop_337727_total_runs;
    int64_t futhark_mc_segred_stage_1_parloop_337727_total_iter;
    int64_t *futhark_mc_segred_task_337724_total_runtime;
    int *futhark_mc_segred_task_337724_runs;
    int64_t *futhark_mc_segred_task_337724_iter;
    int64_t futhark_mc_segred_task_337724_total_time;
    int64_t futhark_mc_segred_task_337724_total_iter;
    int64_t *futhark_mc_segred_stage_1_parloop_337722_total_runtime;
    int *futhark_mc_segred_stage_1_parloop_337722_runs;
    int64_t *futhark_mc_segred_stage_1_parloop_337722_iter;
    int64_t futhark_mc_segred_stage_1_parloop_337722_total_total_runtime;
    int futhark_mc_segred_stage_1_parloop_337722_total_runs;
    int64_t futhark_mc_segred_stage_1_parloop_337722_total_iter;
    int64_t *futhark_mc_segred_nested_task_337719_total_runtime;
    int *futhark_mc_segred_nested_task_337719_runs;
    int64_t *futhark_mc_segred_nested_task_337719_iter;
    int64_t *futhark_mc_scan_stage_3_parloop_337713_total_runtime;
    int *futhark_mc_scan_stage_3_parloop_337713_runs;
    int64_t *futhark_mc_scan_stage_3_parloop_337713_iter;
    int64_t futhark_mc_scan_stage_3_parloop_337713_total_total_runtime;
    int futhark_mc_scan_stage_3_parloop_337713_total_runs;
    int64_t futhark_mc_scan_stage_3_parloop_337713_total_iter;
    int64_t *futhark_mc_segscan_task_337680_total_runtime;
    int *futhark_mc_segscan_task_337680_runs;
    int64_t *futhark_mc_segscan_task_337680_iter;
    int64_t futhark_mc_segscan_task_337680_total_time;
    int64_t futhark_mc_segscan_task_337680_total_iter;
    int64_t *futhark_mc_segmap_parloop_337731_total_runtime;
    int *futhark_mc_segmap_parloop_337731_runs;
    int64_t *futhark_mc_segmap_parloop_337731_iter;
    int64_t futhark_mc_segmap_parloop_337731_total_total_runtime;
    int futhark_mc_segmap_parloop_337731_total_runs;
    int64_t futhark_mc_segmap_parloop_337731_total_iter;
    int64_t *futhark_mc_segmap_task_337729_total_runtime;
    int *futhark_mc_segmap_task_337729_runs;
    int64_t *futhark_mc_segmap_task_337729_iter;
    int64_t futhark_mc_segmap_task_337729_total_time;
    int64_t futhark_mc_segmap_task_337729_total_iter;
    int64_t *futhark_mc_segmap_parloop_337735_total_runtime;
    int *futhark_mc_segmap_parloop_337735_runs;
    int64_t *futhark_mc_segmap_parloop_337735_iter;
    int64_t futhark_mc_segmap_parloop_337735_total_total_runtime;
    int futhark_mc_segmap_parloop_337735_total_runs;
    int64_t futhark_mc_segmap_parloop_337735_total_iter;
    int64_t *futhark_mc_segmap_task_337733_total_runtime;
    int *futhark_mc_segmap_task_337733_runs;
    int64_t *futhark_mc_segmap_task_337733_iter;
    int64_t futhark_mc_segmap_task_337733_total_time;
    int64_t futhark_mc_segmap_task_337733_total_iter;
    int64_t *futhark_mc_scan_stage_1_parloop_337747_total_runtime;
    int *futhark_mc_scan_stage_1_parloop_337747_runs;
    int64_t *futhark_mc_scan_stage_1_parloop_337747_iter;
    int64_t futhark_mc_scan_stage_1_parloop_337747_total_total_runtime;
    int futhark_mc_scan_stage_1_parloop_337747_total_runs;
    int64_t futhark_mc_scan_stage_1_parloop_337747_total_iter;
    int64_t *futhark_mc_scan_stage_3_parloop_337749_total_runtime;
    int *futhark_mc_scan_stage_3_parloop_337749_runs;
    int64_t *futhark_mc_scan_stage_3_parloop_337749_iter;
    int64_t futhark_mc_scan_stage_3_parloop_337749_total_total_runtime;
    int futhark_mc_scan_stage_3_parloop_337749_total_runs;
    int64_t futhark_mc_scan_stage_3_parloop_337749_total_iter;
    int64_t *futhark_mc_segscan_task_337744_total_runtime;
    int *futhark_mc_segscan_task_337744_runs;
    int64_t *futhark_mc_segscan_task_337744_iter;
    int64_t futhark_mc_segscan_task_337744_total_time;
    int64_t futhark_mc_segscan_task_337744_total_iter;
    int64_t *futhark_mc_segmap_parloop_337753_total_runtime;
    int *futhark_mc_segmap_parloop_337753_runs;
    int64_t *futhark_mc_segmap_parloop_337753_iter;
    int64_t futhark_mc_segmap_parloop_337753_total_total_runtime;
    int futhark_mc_segmap_parloop_337753_total_runs;
    int64_t futhark_mc_segmap_parloop_337753_total_iter;
    int64_t *futhark_mc_segmap_task_337751_total_runtime;
    int *futhark_mc_segmap_task_337751_runs;
    int64_t *futhark_mc_segmap_task_337751_iter;
    int64_t futhark_mc_segmap_task_337751_total_time;
    int64_t futhark_mc_segmap_task_337751_total_iter;
    int64_t *futhark_mc_segmap_parloop_337740_total_runtime;
    int *futhark_mc_segmap_parloop_337740_runs;
    int64_t *futhark_mc_segmap_parloop_337740_iter;
    int64_t futhark_mc_segmap_parloop_337740_total_total_runtime;
    int futhark_mc_segmap_parloop_337740_total_runs;
    int64_t futhark_mc_segmap_parloop_337740_total_iter;
    int64_t *futhark_mc_segmap_nested_task_337738_total_runtime;
    int *futhark_mc_segmap_nested_task_337738_runs;
    int64_t *futhark_mc_segmap_nested_task_337738_iter;
    int64_t *futhark_mc_segmap_parloop_337757_total_runtime;
    int *futhark_mc_segmap_parloop_337757_runs;
    int64_t *futhark_mc_segmap_parloop_337757_iter;
    int64_t futhark_mc_segmap_parloop_337757_total_total_runtime;
    int futhark_mc_segmap_parloop_337757_total_runs;
    int64_t futhark_mc_segmap_parloop_337757_total_iter;
    int64_t *futhark_mc_segmap_task_337755_total_runtime;
    int *futhark_mc_segmap_task_337755_runs;
    int64_t *futhark_mc_segmap_task_337755_iter;
    int64_t futhark_mc_segmap_task_337755_total_time;
    int64_t futhark_mc_segmap_task_337755_total_iter;
    int64_t *futhark_mc_segmap_parloop_337766_total_runtime;
    int *futhark_mc_segmap_parloop_337766_runs;
    int64_t *futhark_mc_segmap_parloop_337766_iter;
    int64_t futhark_mc_segmap_parloop_337766_total_total_runtime;
    int futhark_mc_segmap_parloop_337766_total_runs;
    int64_t futhark_mc_segmap_parloop_337766_total_iter;
    int64_t *futhark_mc_segmap_task_337764_total_runtime;
    int *futhark_mc_segmap_task_337764_runs;
    int64_t *futhark_mc_segmap_task_337764_iter;
    int64_t futhark_mc_segmap_task_337764_total_time;
    int64_t futhark_mc_segmap_task_337764_total_iter;
    int64_t *futhark_mc_segmap_parloop_337775_total_runtime;
    int *futhark_mc_segmap_parloop_337775_runs;
    int64_t *futhark_mc_segmap_parloop_337775_iter;
    int64_t futhark_mc_segmap_parloop_337775_total_total_runtime;
    int futhark_mc_segmap_parloop_337775_total_runs;
    int64_t futhark_mc_segmap_parloop_337775_total_iter;
    int64_t *futhark_mc_segmap_task_337773_total_runtime;
    int *futhark_mc_segmap_task_337773_runs;
    int64_t *futhark_mc_segmap_task_337773_iter;
    int64_t futhark_mc_segmap_task_337773_total_time;
    int64_t futhark_mc_segmap_task_337773_total_iter;
    int64_t *futhark_mc_segmap_parloop_337770_total_runtime;
    int *futhark_mc_segmap_parloop_337770_runs;
    int64_t *futhark_mc_segmap_parloop_337770_iter;
    int64_t futhark_mc_segmap_parloop_337770_total_total_runtime;
    int futhark_mc_segmap_parloop_337770_total_runs;
    int64_t futhark_mc_segmap_parloop_337770_total_iter;
    int64_t *futhark_mc_segmap_nested_task_337768_total_runtime;
    int *futhark_mc_segmap_nested_task_337768_runs;
    int64_t *futhark_mc_segmap_nested_task_337768_iter;
    int64_t *futhark_mc_segmap_parloop_337761_total_runtime;
    int *futhark_mc_segmap_parloop_337761_runs;
    int64_t *futhark_mc_segmap_parloop_337761_iter;
    int64_t futhark_mc_segmap_parloop_337761_total_total_runtime;
    int futhark_mc_segmap_parloop_337761_total_runs;
    int64_t futhark_mc_segmap_parloop_337761_total_iter;
    int64_t *futhark_mc_segmap_nested_task_337759_total_runtime;
    int *futhark_mc_segmap_nested_task_337759_runs;
    int64_t *futhark_mc_segmap_nested_task_337759_iter;
    int64_t *futhark_mc_segmap_parloop_337779_total_runtime;
    int *futhark_mc_segmap_parloop_337779_runs;
    int64_t *futhark_mc_segmap_parloop_337779_iter;
    int64_t futhark_mc_segmap_parloop_337779_total_total_runtime;
    int futhark_mc_segmap_parloop_337779_total_runs;
    int64_t futhark_mc_segmap_parloop_337779_total_iter;
    int64_t *futhark_mc_segmap_task_337777_total_runtime;
    int *futhark_mc_segmap_task_337777_runs;
    int64_t *futhark_mc_segmap_task_337777_iter;
    int64_t futhark_mc_segmap_task_337777_total_time;
    int64_t futhark_mc_segmap_task_337777_total_iter;
    int64_t *futhark_mc_segmap_parloop_337792_total_runtime;
    int *futhark_mc_segmap_parloop_337792_runs;
    int64_t *futhark_mc_segmap_parloop_337792_iter;
    int64_t futhark_mc_segmap_parloop_337792_total_total_runtime;
    int futhark_mc_segmap_parloop_337792_total_runs;
    int64_t futhark_mc_segmap_parloop_337792_total_iter;
    int64_t *futhark_mc_segmap_task_337790_total_runtime;
    int *futhark_mc_segmap_task_337790_runs;
    int64_t *futhark_mc_segmap_task_337790_iter;
    int64_t futhark_mc_segmap_task_337790_total_time;
    int64_t futhark_mc_segmap_task_337790_total_iter;
    int64_t *futhark_mc_scan_stage_1_parloop_337804_total_runtime;
    int *futhark_mc_scan_stage_1_parloop_337804_runs;
    int64_t *futhark_mc_scan_stage_1_parloop_337804_iter;
    int64_t futhark_mc_scan_stage_1_parloop_337804_total_total_runtime;
    int futhark_mc_scan_stage_1_parloop_337804_total_runs;
    int64_t futhark_mc_scan_stage_1_parloop_337804_total_iter;
    int64_t *futhark_mc_scan_stage_3_parloop_337806_total_runtime;
    int *futhark_mc_scan_stage_3_parloop_337806_runs;
    int64_t *futhark_mc_scan_stage_3_parloop_337806_iter;
    int64_t futhark_mc_scan_stage_3_parloop_337806_total_total_runtime;
    int futhark_mc_scan_stage_3_parloop_337806_total_runs;
    int64_t futhark_mc_scan_stage_3_parloop_337806_total_iter;
    int64_t *futhark_mc_segscan_task_337801_total_runtime;
    int *futhark_mc_segscan_task_337801_runs;
    int64_t *futhark_mc_segscan_task_337801_iter;
    int64_t futhark_mc_segscan_task_337801_total_time;
    int64_t futhark_mc_segscan_task_337801_total_iter;
    int64_t *futhark_mc_segmap_parloop_337810_total_runtime;
    int *futhark_mc_segmap_parloop_337810_runs;
    int64_t *futhark_mc_segmap_parloop_337810_iter;
    int64_t futhark_mc_segmap_parloop_337810_total_total_runtime;
    int futhark_mc_segmap_parloop_337810_total_runs;
    int64_t futhark_mc_segmap_parloop_337810_total_iter;
    int64_t *futhark_mc_segmap_task_337808_total_runtime;
    int *futhark_mc_segmap_task_337808_runs;
    int64_t *futhark_mc_segmap_task_337808_iter;
    int64_t futhark_mc_segmap_task_337808_total_time;
    int64_t futhark_mc_segmap_task_337808_total_iter;
    int64_t *futhark_mc_segmap_parloop_337797_total_runtime;
    int *futhark_mc_segmap_parloop_337797_runs;
    int64_t *futhark_mc_segmap_parloop_337797_iter;
    int64_t futhark_mc_segmap_parloop_337797_total_total_runtime;
    int futhark_mc_segmap_parloop_337797_total_runs;
    int64_t futhark_mc_segmap_parloop_337797_total_iter;
    int64_t *futhark_mc_segmap_nested_task_337795_total_runtime;
    int *futhark_mc_segmap_nested_task_337795_runs;
    int64_t *futhark_mc_segmap_nested_task_337795_iter;
    int64_t *futhark_mc_segmap_parloop_337786_total_runtime;
    int *futhark_mc_segmap_parloop_337786_runs;
    int64_t *futhark_mc_segmap_parloop_337786_iter;
    int64_t futhark_mc_segmap_parloop_337786_total_total_runtime;
    int futhark_mc_segmap_parloop_337786_total_runs;
    int64_t futhark_mc_segmap_parloop_337786_total_iter;
    int64_t *futhark_mc_segmap_nested_task_337784_total_runtime;
    int *futhark_mc_segmap_nested_task_337784_runs;
    int64_t *futhark_mc_segmap_nested_task_337784_iter;
    int64_t *futhark_mc_segmap_parloop_337814_total_runtime;
    int *futhark_mc_segmap_parloop_337814_runs;
    int64_t *futhark_mc_segmap_parloop_337814_iter;
    int64_t futhark_mc_segmap_parloop_337814_total_total_runtime;
    int futhark_mc_segmap_parloop_337814_total_runs;
    int64_t futhark_mc_segmap_parloop_337814_total_iter;
    int64_t *futhark_mc_segmap_task_337812_total_runtime;
    int *futhark_mc_segmap_task_337812_runs;
    int64_t *futhark_mc_segmap_task_337812_iter;
    int64_t futhark_mc_segmap_task_337812_total_time;
    int64_t futhark_mc_segmap_task_337812_total_iter;
    int64_t *futhark_mc_segmap_parloop_337826_total_runtime;
    int *futhark_mc_segmap_parloop_337826_runs;
    int64_t *futhark_mc_segmap_parloop_337826_iter;
    int64_t futhark_mc_segmap_parloop_337826_total_total_runtime;
    int futhark_mc_segmap_parloop_337826_total_runs;
    int64_t futhark_mc_segmap_parloop_337826_total_iter;
    int64_t *futhark_mc_segmap_task_337824_total_runtime;
    int *futhark_mc_segmap_task_337824_runs;
    int64_t *futhark_mc_segmap_task_337824_iter;
    int64_t futhark_mc_segmap_task_337824_total_time;
    int64_t futhark_mc_segmap_task_337824_total_iter;
    int64_t *futhark_mc_segmap_parloop_337839_total_runtime;
    int *futhark_mc_segmap_parloop_337839_runs;
    int64_t *futhark_mc_segmap_parloop_337839_iter;
    int64_t futhark_mc_segmap_parloop_337839_total_total_runtime;
    int futhark_mc_segmap_parloop_337839_total_runs;
    int64_t futhark_mc_segmap_parloop_337839_total_iter;
    int64_t *futhark_mc_segmap_task_337837_total_runtime;
    int *futhark_mc_segmap_task_337837_runs;
    int64_t *futhark_mc_segmap_task_337837_iter;
    int64_t futhark_mc_segmap_task_337837_total_time;
    int64_t futhark_mc_segmap_task_337837_total_iter;
    int64_t *futhark_mc_segmap_parloop_337843_total_runtime;
    int *futhark_mc_segmap_parloop_337843_runs;
    int64_t *futhark_mc_segmap_parloop_337843_iter;
    int64_t futhark_mc_segmap_parloop_337843_total_total_runtime;
    int futhark_mc_segmap_parloop_337843_total_runs;
    int64_t futhark_mc_segmap_parloop_337843_total_iter;
    int64_t *futhark_mc_segmap_task_337841_total_runtime;
    int *futhark_mc_segmap_task_337841_runs;
    int64_t *futhark_mc_segmap_task_337841_iter;
    int64_t futhark_mc_segmap_task_337841_total_time;
    int64_t futhark_mc_segmap_task_337841_total_iter;
    int64_t *futhark_mc_segmap_parloop_337832_total_runtime;
    int *futhark_mc_segmap_parloop_337832_runs;
    int64_t *futhark_mc_segmap_parloop_337832_iter;
    int64_t futhark_mc_segmap_parloop_337832_total_total_runtime;
    int futhark_mc_segmap_parloop_337832_total_runs;
    int64_t futhark_mc_segmap_parloop_337832_total_iter;
    int64_t *futhark_mc_segmap_nested_task_337830_total_runtime;
    int *futhark_mc_segmap_nested_task_337830_runs;
    int64_t *futhark_mc_segmap_nested_task_337830_iter;
    int64_t *futhark_mc_segmap_parloop_337820_total_runtime;
    int *futhark_mc_segmap_parloop_337820_runs;
    int64_t *futhark_mc_segmap_parloop_337820_iter;
    int64_t futhark_mc_segmap_parloop_337820_total_total_runtime;
    int futhark_mc_segmap_parloop_337820_total_runs;
    int64_t futhark_mc_segmap_parloop_337820_total_iter;
    int64_t *futhark_mc_segmap_nested_task_337818_total_runtime;
    int *futhark_mc_segmap_nested_task_337818_runs;
    int64_t *futhark_mc_segmap_nested_task_337818_iter;
    int64_t *futhark_mc_segmap_parloop_337847_total_runtime;
    int *futhark_mc_segmap_parloop_337847_runs;
    int64_t *futhark_mc_segmap_parloop_337847_iter;
    int64_t futhark_mc_segmap_parloop_337847_total_total_runtime;
    int futhark_mc_segmap_parloop_337847_total_runs;
    int64_t futhark_mc_segmap_parloop_337847_total_iter;
    int64_t *futhark_mc_segmap_task_337845_total_runtime;
    int *futhark_mc_segmap_task_337845_runs;
    int64_t *futhark_mc_segmap_task_337845_iter;
    int64_t futhark_mc_segmap_task_337845_total_time;
    int64_t futhark_mc_segmap_task_337845_total_iter;
    int64_t *futhark_mc_segmap_parloop_337860_total_runtime;
    int *futhark_mc_segmap_parloop_337860_runs;
    int64_t *futhark_mc_segmap_parloop_337860_iter;
    int64_t futhark_mc_segmap_parloop_337860_total_total_runtime;
    int futhark_mc_segmap_parloop_337860_total_runs;
    int64_t futhark_mc_segmap_parloop_337860_total_iter;
    int64_t *futhark_mc_segmap_task_337858_total_runtime;
    int *futhark_mc_segmap_task_337858_runs;
    int64_t *futhark_mc_segmap_task_337858_iter;
    int64_t futhark_mc_segmap_task_337858_total_time;
    int64_t futhark_mc_segmap_task_337858_total_iter;
    int64_t *futhark_mc_segmap_parloop_337864_total_runtime;
    int *futhark_mc_segmap_parloop_337864_runs;
    int64_t *futhark_mc_segmap_parloop_337864_iter;
    int64_t futhark_mc_segmap_parloop_337864_total_total_runtime;
    int futhark_mc_segmap_parloop_337864_total_runs;
    int64_t futhark_mc_segmap_parloop_337864_total_iter;
    int64_t *futhark_mc_segmap_task_337862_total_runtime;
    int *futhark_mc_segmap_task_337862_runs;
    int64_t *futhark_mc_segmap_task_337862_iter;
    int64_t futhark_mc_segmap_task_337862_total_time;
    int64_t futhark_mc_segmap_task_337862_total_iter;
    int64_t *futhark_mc_segmap_parloop_337853_total_runtime;
    int *futhark_mc_segmap_parloop_337853_runs;
    int64_t *futhark_mc_segmap_parloop_337853_iter;
    int64_t futhark_mc_segmap_parloop_337853_total_total_runtime;
    int futhark_mc_segmap_parloop_337853_total_runs;
    int64_t futhark_mc_segmap_parloop_337853_total_iter;
    int64_t *futhark_mc_segmap_nested_task_337851_total_runtime;
    int *futhark_mc_segmap_nested_task_337851_runs;
    int64_t *futhark_mc_segmap_nested_task_337851_iter;
    int64_t *futhark_mc_segmap_parloop_337868_total_runtime;
    int *futhark_mc_segmap_parloop_337868_runs;
    int64_t *futhark_mc_segmap_parloop_337868_iter;
    int64_t futhark_mc_segmap_parloop_337868_total_total_runtime;
    int futhark_mc_segmap_parloop_337868_total_runs;
    int64_t futhark_mc_segmap_parloop_337868_total_iter;
    int64_t *futhark_mc_segmap_task_337866_total_runtime;
    int *futhark_mc_segmap_task_337866_runs;
    int64_t *futhark_mc_segmap_task_337866_iter;
    int64_t futhark_mc_segmap_task_337866_total_time;
    int64_t futhark_mc_segmap_task_337866_total_iter;
    int64_t *futhark_mc_segmap_parloop_337881_total_runtime;
    int *futhark_mc_segmap_parloop_337881_runs;
    int64_t *futhark_mc_segmap_parloop_337881_iter;
    int64_t futhark_mc_segmap_parloop_337881_total_total_runtime;
    int futhark_mc_segmap_parloop_337881_total_runs;
    int64_t futhark_mc_segmap_parloop_337881_total_iter;
    int64_t *futhark_mc_segmap_task_337879_total_runtime;
    int *futhark_mc_segmap_task_337879_runs;
    int64_t *futhark_mc_segmap_task_337879_iter;
    int64_t futhark_mc_segmap_task_337879_total_time;
    int64_t futhark_mc_segmap_task_337879_total_iter;
    int64_t *futhark_mc_segmap_parloop_337885_total_runtime;
    int *futhark_mc_segmap_parloop_337885_runs;
    int64_t *futhark_mc_segmap_parloop_337885_iter;
    int64_t futhark_mc_segmap_parloop_337885_total_total_runtime;
    int futhark_mc_segmap_parloop_337885_total_runs;
    int64_t futhark_mc_segmap_parloop_337885_total_iter;
    int64_t *futhark_mc_segmap_task_337883_total_runtime;
    int *futhark_mc_segmap_task_337883_runs;
    int64_t *futhark_mc_segmap_task_337883_iter;
    int64_t futhark_mc_segmap_task_337883_total_time;
    int64_t futhark_mc_segmap_task_337883_total_iter;
    int64_t *futhark_mc_segmap_parloop_337874_total_runtime;
    int *futhark_mc_segmap_parloop_337874_runs;
    int64_t *futhark_mc_segmap_parloop_337874_iter;
    int64_t futhark_mc_segmap_parloop_337874_total_total_runtime;
    int futhark_mc_segmap_parloop_337874_total_runs;
    int64_t futhark_mc_segmap_parloop_337874_total_iter;
    int64_t *futhark_mc_segmap_nested_task_337872_total_runtime;
    int *futhark_mc_segmap_nested_task_337872_runs;
    int64_t *futhark_mc_segmap_nested_task_337872_iter;
    int64_t *futhark_mc_segmap_parloop_337889_total_runtime;
    int *futhark_mc_segmap_parloop_337889_runs;
    int64_t *futhark_mc_segmap_parloop_337889_iter;
    int64_t futhark_mc_segmap_parloop_337889_total_total_runtime;
    int futhark_mc_segmap_parloop_337889_total_runs;
    int64_t futhark_mc_segmap_parloop_337889_total_iter;
    int64_t *futhark_mc_segmap_task_337887_total_runtime;
    int *futhark_mc_segmap_task_337887_runs;
    int64_t *futhark_mc_segmap_task_337887_iter;
    int64_t futhark_mc_segmap_task_337887_total_time;
    int64_t futhark_mc_segmap_task_337887_total_iter;
    int64_t *futhark_mc_segmap_parloop_337898_total_runtime;
    int *futhark_mc_segmap_parloop_337898_runs;
    int64_t *futhark_mc_segmap_parloop_337898_iter;
    int64_t futhark_mc_segmap_parloop_337898_total_total_runtime;
    int futhark_mc_segmap_parloop_337898_total_runs;
    int64_t futhark_mc_segmap_parloop_337898_total_iter;
    int64_t *futhark_mc_segmap_task_337896_total_runtime;
    int *futhark_mc_segmap_task_337896_runs;
    int64_t *futhark_mc_segmap_task_337896_iter;
    int64_t futhark_mc_segmap_task_337896_total_time;
    int64_t futhark_mc_segmap_task_337896_total_iter;
    int64_t *futhark_mc_segmap_parloop_337893_total_runtime;
    int *futhark_mc_segmap_parloop_337893_runs;
    int64_t *futhark_mc_segmap_parloop_337893_iter;
    int64_t futhark_mc_segmap_parloop_337893_total_total_runtime;
    int futhark_mc_segmap_parloop_337893_total_runs;
    int64_t futhark_mc_segmap_parloop_337893_total_iter;
    int64_t *futhark_mc_segmap_nested_task_337891_total_runtime;
    int *futhark_mc_segmap_nested_task_337891_runs;
    int64_t *futhark_mc_segmap_nested_task_337891_iter;
    int64_t *futhark_mc_segmap_parloop_337902_total_runtime;
    int *futhark_mc_segmap_parloop_337902_runs;
    int64_t *futhark_mc_segmap_parloop_337902_iter;
    int64_t futhark_mc_segmap_parloop_337902_total_total_runtime;
    int futhark_mc_segmap_parloop_337902_total_runs;
    int64_t futhark_mc_segmap_parloop_337902_total_iter;
    int64_t *futhark_mc_segmap_task_337900_total_runtime;
    int *futhark_mc_segmap_task_337900_runs;
    int64_t *futhark_mc_segmap_task_337900_iter;
    int64_t futhark_mc_segmap_task_337900_total_time;
    int64_t futhark_mc_segmap_task_337900_total_iter;
    int64_t *futhark_mc_segmap_parloop_337913_total_runtime;
    int *futhark_mc_segmap_parloop_337913_runs;
    int64_t *futhark_mc_segmap_parloop_337913_iter;
    int64_t futhark_mc_segmap_parloop_337913_total_total_runtime;
    int futhark_mc_segmap_parloop_337913_total_runs;
    int64_t futhark_mc_segmap_parloop_337913_total_iter;
    int64_t *futhark_mc_segmap_task_337911_total_runtime;
    int *futhark_mc_segmap_task_337911_runs;
    int64_t *futhark_mc_segmap_task_337911_iter;
    int64_t futhark_mc_segmap_task_337911_total_time;
    int64_t futhark_mc_segmap_task_337911_total_iter;
    int64_t *futhark_mc_segmap_parloop_337924_total_runtime;
    int *futhark_mc_segmap_parloop_337924_runs;
    int64_t *futhark_mc_segmap_parloop_337924_iter;
    int64_t futhark_mc_segmap_parloop_337924_total_total_runtime;
    int futhark_mc_segmap_parloop_337924_total_runs;
    int64_t futhark_mc_segmap_parloop_337924_total_iter;
    int64_t *futhark_mc_segmap_task_337922_total_runtime;
    int *futhark_mc_segmap_task_337922_runs;
    int64_t *futhark_mc_segmap_task_337922_iter;
    int64_t futhark_mc_segmap_task_337922_total_time;
    int64_t futhark_mc_segmap_task_337922_total_iter;
    int64_t *futhark_mc_segmap_parloop_337918_total_runtime;
    int *futhark_mc_segmap_parloop_337918_runs;
    int64_t *futhark_mc_segmap_parloop_337918_iter;
    int64_t futhark_mc_segmap_parloop_337918_total_total_runtime;
    int futhark_mc_segmap_parloop_337918_total_runs;
    int64_t futhark_mc_segmap_parloop_337918_total_iter;
    int64_t *futhark_mc_segmap_nested_task_337916_total_runtime;
    int *futhark_mc_segmap_nested_task_337916_runs;
    int64_t *futhark_mc_segmap_nested_task_337916_iter;
    int64_t *futhark_mc_segmap_parloop_337907_total_runtime;
    int *futhark_mc_segmap_parloop_337907_runs;
    int64_t *futhark_mc_segmap_parloop_337907_iter;
    int64_t futhark_mc_segmap_parloop_337907_total_total_runtime;
    int futhark_mc_segmap_parloop_337907_total_runs;
    int64_t futhark_mc_segmap_parloop_337907_total_iter;
    int64_t *futhark_mc_segmap_nested_task_337905_total_runtime;
    int *futhark_mc_segmap_nested_task_337905_runs;
    int64_t *futhark_mc_segmap_nested_task_337905_iter;
    int64_t *futhark_mc_segmap_parloop_337928_total_runtime;
    int *futhark_mc_segmap_parloop_337928_runs;
    int64_t *futhark_mc_segmap_parloop_337928_iter;
    int64_t futhark_mc_segmap_parloop_337928_total_total_runtime;
    int futhark_mc_segmap_parloop_337928_total_runs;
    int64_t futhark_mc_segmap_parloop_337928_total_iter;
    int64_t *futhark_mc_segmap_task_337926_total_runtime;
    int *futhark_mc_segmap_task_337926_runs;
    int64_t *futhark_mc_segmap_task_337926_iter;
    int64_t futhark_mc_segmap_task_337926_total_time;
    int64_t futhark_mc_segmap_task_337926_total_iter;
    int64_t *futhark_mc_segmap_parloop_337937_total_runtime;
    int *futhark_mc_segmap_parloop_337937_runs;
    int64_t *futhark_mc_segmap_parloop_337937_iter;
    int64_t futhark_mc_segmap_parloop_337937_total_total_runtime;
    int futhark_mc_segmap_parloop_337937_total_runs;
    int64_t futhark_mc_segmap_parloop_337937_total_iter;
    int64_t *futhark_mc_segmap_task_337935_total_runtime;
    int *futhark_mc_segmap_task_337935_runs;
    int64_t *futhark_mc_segmap_task_337935_iter;
    int64_t futhark_mc_segmap_task_337935_total_time;
    int64_t futhark_mc_segmap_task_337935_total_iter;
    int64_t *futhark_mc_segmap_parloop_337946_total_runtime;
    int *futhark_mc_segmap_parloop_337946_runs;
    int64_t *futhark_mc_segmap_parloop_337946_iter;
    int64_t futhark_mc_segmap_parloop_337946_total_total_runtime;
    int futhark_mc_segmap_parloop_337946_total_runs;
    int64_t futhark_mc_segmap_parloop_337946_total_iter;
    int64_t *futhark_mc_segmap_task_337944_total_runtime;
    int *futhark_mc_segmap_task_337944_runs;
    int64_t *futhark_mc_segmap_task_337944_iter;
    int64_t futhark_mc_segmap_task_337944_total_time;
    int64_t futhark_mc_segmap_task_337944_total_iter;
    int64_t *futhark_mc_segred_stage_1_parloop_337954_total_runtime;
    int *futhark_mc_segred_stage_1_parloop_337954_runs;
    int64_t *futhark_mc_segred_stage_1_parloop_337954_iter;
    int64_t futhark_mc_segred_stage_1_parloop_337954_total_total_runtime;
    int futhark_mc_segred_stage_1_parloop_337954_total_runs;
    int64_t futhark_mc_segred_stage_1_parloop_337954_total_iter;
    int64_t *futhark_mc_segred_task_337951_total_runtime;
    int *futhark_mc_segred_task_337951_runs;
    int64_t *futhark_mc_segred_task_337951_iter;
    int64_t futhark_mc_segred_task_337951_total_time;
    int64_t futhark_mc_segred_task_337951_total_iter;
    int64_t *futhark_mc_segred_stage_1_parloop_337959_total_runtime;
    int *futhark_mc_segred_stage_1_parloop_337959_runs;
    int64_t *futhark_mc_segred_stage_1_parloop_337959_iter;
    int64_t futhark_mc_segred_stage_1_parloop_337959_total_total_runtime;
    int futhark_mc_segred_stage_1_parloop_337959_total_runs;
    int64_t futhark_mc_segred_stage_1_parloop_337959_total_iter;
    int64_t *futhark_mc_segred_task_337956_total_runtime;
    int *futhark_mc_segred_task_337956_runs;
    int64_t *futhark_mc_segred_task_337956_iter;
    int64_t futhark_mc_segred_task_337956_total_time;
    int64_t futhark_mc_segred_task_337956_total_iter;
    int64_t *futhark_mc_segmap_parloop_337949_total_runtime;
    int *futhark_mc_segmap_parloop_337949_runs;
    int64_t *futhark_mc_segmap_parloop_337949_iter;
    int64_t futhark_mc_segmap_parloop_337949_total_total_runtime;
    int futhark_mc_segmap_parloop_337949_total_runs;
    int64_t futhark_mc_segmap_parloop_337949_total_iter;
    int64_t *futhark_mc_segmap_nested_task_337947_total_runtime;
    int *futhark_mc_segmap_nested_task_337947_runs;
    int64_t *futhark_mc_segmap_nested_task_337947_iter;
    int64_t *futhark_mc_segmap_parloop_337941_total_runtime;
    int *futhark_mc_segmap_parloop_337941_runs;
    int64_t *futhark_mc_segmap_parloop_337941_iter;
    int64_t futhark_mc_segmap_parloop_337941_total_total_runtime;
    int futhark_mc_segmap_parloop_337941_total_runs;
    int64_t futhark_mc_segmap_parloop_337941_total_iter;
    int64_t *futhark_mc_segmap_nested_task_337939_total_runtime;
    int *futhark_mc_segmap_nested_task_337939_runs;
    int64_t *futhark_mc_segmap_nested_task_337939_iter;
    int64_t *futhark_mc_segmap_parloop_337932_total_runtime;
    int *futhark_mc_segmap_parloop_337932_runs;
    int64_t *futhark_mc_segmap_parloop_337932_iter;
    int64_t futhark_mc_segmap_parloop_337932_total_total_runtime;
    int futhark_mc_segmap_parloop_337932_total_runs;
    int64_t futhark_mc_segmap_parloop_337932_total_iter;
    int64_t *futhark_mc_segmap_nested_task_337930_total_runtime;
    int *futhark_mc_segmap_nested_task_337930_runs;
    int64_t *futhark_mc_segmap_nested_task_337930_iter;
    int64_t *futhark_mc_segmap_parloop_337963_total_runtime;
    int *futhark_mc_segmap_parloop_337963_runs;
    int64_t *futhark_mc_segmap_parloop_337963_iter;
    int64_t futhark_mc_segmap_parloop_337963_total_total_runtime;
    int futhark_mc_segmap_parloop_337963_total_runs;
    int64_t futhark_mc_segmap_parloop_337963_total_iter;
    int64_t *futhark_mc_segmap_task_337961_total_runtime;
    int *futhark_mc_segmap_task_337961_runs;
    int64_t *futhark_mc_segmap_task_337961_iter;
    int64_t futhark_mc_segmap_task_337961_total_time;
    int64_t futhark_mc_segmap_task_337961_total_iter;
    int64_t *futhark_mc_segmap_parloop_337974_total_runtime;
    int *futhark_mc_segmap_parloop_337974_runs;
    int64_t *futhark_mc_segmap_parloop_337974_iter;
    int64_t futhark_mc_segmap_parloop_337974_total_total_runtime;
    int futhark_mc_segmap_parloop_337974_total_runs;
    int64_t futhark_mc_segmap_parloop_337974_total_iter;
    int64_t *futhark_mc_segmap_task_337972_total_runtime;
    int *futhark_mc_segmap_task_337972_runs;
    int64_t *futhark_mc_segmap_task_337972_iter;
    int64_t futhark_mc_segmap_task_337972_total_time;
    int64_t futhark_mc_segmap_task_337972_total_iter;
    int64_t *futhark_mc_segmap_parloop_337985_total_runtime;
    int *futhark_mc_segmap_parloop_337985_runs;
    int64_t *futhark_mc_segmap_parloop_337985_iter;
    int64_t futhark_mc_segmap_parloop_337985_total_total_runtime;
    int futhark_mc_segmap_parloop_337985_total_runs;
    int64_t futhark_mc_segmap_parloop_337985_total_iter;
    int64_t *futhark_mc_segmap_task_337983_total_runtime;
    int *futhark_mc_segmap_task_337983_runs;
    int64_t *futhark_mc_segmap_task_337983_iter;
    int64_t futhark_mc_segmap_task_337983_total_time;
    int64_t futhark_mc_segmap_task_337983_total_iter;
    int64_t *futhark_mc_segred_stage_1_parloop_337995_total_runtime;
    int *futhark_mc_segred_stage_1_parloop_337995_runs;
    int64_t *futhark_mc_segred_stage_1_parloop_337995_iter;
    int64_t futhark_mc_segred_stage_1_parloop_337995_total_total_runtime;
    int futhark_mc_segred_stage_1_parloop_337995_total_runs;
    int64_t futhark_mc_segred_stage_1_parloop_337995_total_iter;
    int64_t *futhark_mc_segred_task_337990_total_runtime;
    int *futhark_mc_segred_task_337990_runs;
    int64_t *futhark_mc_segred_task_337990_iter;
    int64_t futhark_mc_segred_task_337990_total_time;
    int64_t futhark_mc_segred_task_337990_total_iter;
    int64_t *futhark_mc_segred_stage_1_parloop_338001_total_runtime;
    int *futhark_mc_segred_stage_1_parloop_338001_runs;
    int64_t *futhark_mc_segred_stage_1_parloop_338001_iter;
    int64_t futhark_mc_segred_stage_1_parloop_338001_total_total_runtime;
    int futhark_mc_segred_stage_1_parloop_338001_total_runs;
    int64_t futhark_mc_segred_stage_1_parloop_338001_total_iter;
    int64_t *futhark_mc_segred_task_337997_total_runtime;
    int *futhark_mc_segred_task_337997_runs;
    int64_t *futhark_mc_segred_task_337997_iter;
    int64_t futhark_mc_segred_task_337997_total_time;
    int64_t futhark_mc_segred_task_337997_total_iter;
    int64_t *futhark_mc_segmap_parloop_337988_total_runtime;
    int *futhark_mc_segmap_parloop_337988_runs;
    int64_t *futhark_mc_segmap_parloop_337988_iter;
    int64_t futhark_mc_segmap_parloop_337988_total_total_runtime;
    int futhark_mc_segmap_parloop_337988_total_runs;
    int64_t futhark_mc_segmap_parloop_337988_total_iter;
    int64_t *futhark_mc_segmap_nested_task_337986_total_runtime;
    int *futhark_mc_segmap_nested_task_337986_runs;
    int64_t *futhark_mc_segmap_nested_task_337986_iter;
    int64_t *futhark_mc_segmap_parloop_337979_total_runtime;
    int *futhark_mc_segmap_parloop_337979_runs;
    int64_t *futhark_mc_segmap_parloop_337979_iter;
    int64_t futhark_mc_segmap_parloop_337979_total_total_runtime;
    int futhark_mc_segmap_parloop_337979_total_runs;
    int64_t futhark_mc_segmap_parloop_337979_total_iter;
    int64_t *futhark_mc_segmap_nested_task_337977_total_runtime;
    int *futhark_mc_segmap_nested_task_337977_runs;
    int64_t *futhark_mc_segmap_nested_task_337977_iter;
    int64_t *futhark_mc_segmap_parloop_337968_total_runtime;
    int *futhark_mc_segmap_parloop_337968_runs;
    int64_t *futhark_mc_segmap_parloop_337968_iter;
    int64_t futhark_mc_segmap_parloop_337968_total_total_runtime;
    int futhark_mc_segmap_parloop_337968_total_runs;
    int64_t futhark_mc_segmap_parloop_337968_total_iter;
    int64_t *futhark_mc_segmap_nested_task_337966_total_runtime;
    int *futhark_mc_segmap_nested_task_337966_runs;
    int64_t *futhark_mc_segmap_nested_task_337966_iter;
    int64_t *futhark_mc_segmap_parloop_338005_total_runtime;
    int *futhark_mc_segmap_parloop_338005_runs;
    int64_t *futhark_mc_segmap_parloop_338005_iter;
    int64_t futhark_mc_segmap_parloop_338005_total_total_runtime;
    int futhark_mc_segmap_parloop_338005_total_runs;
    int64_t futhark_mc_segmap_parloop_338005_total_iter;
    int64_t *futhark_mc_segmap_task_338003_total_runtime;
    int *futhark_mc_segmap_task_338003_runs;
    int64_t *futhark_mc_segmap_task_338003_iter;
    int64_t futhark_mc_segmap_task_338003_total_time;
    int64_t futhark_mc_segmap_task_338003_total_iter;
    int64_t *futhark_mc_segmap_parloop_338016_total_runtime;
    int *futhark_mc_segmap_parloop_338016_runs;
    int64_t *futhark_mc_segmap_parloop_338016_iter;
    int64_t futhark_mc_segmap_parloop_338016_total_total_runtime;
    int futhark_mc_segmap_parloop_338016_total_runs;
    int64_t futhark_mc_segmap_parloop_338016_total_iter;
    int64_t *futhark_mc_segmap_task_338014_total_runtime;
    int *futhark_mc_segmap_task_338014_runs;
    int64_t *futhark_mc_segmap_task_338014_iter;
    int64_t futhark_mc_segmap_task_338014_total_time;
    int64_t futhark_mc_segmap_task_338014_total_iter;
    int64_t *futhark_mc_segmap_parloop_338027_total_runtime;
    int *futhark_mc_segmap_parloop_338027_runs;
    int64_t *futhark_mc_segmap_parloop_338027_iter;
    int64_t futhark_mc_segmap_parloop_338027_total_total_runtime;
    int futhark_mc_segmap_parloop_338027_total_runs;
    int64_t futhark_mc_segmap_parloop_338027_total_iter;
    int64_t *futhark_mc_segmap_task_338025_total_runtime;
    int *futhark_mc_segmap_task_338025_runs;
    int64_t *futhark_mc_segmap_task_338025_iter;
    int64_t futhark_mc_segmap_task_338025_total_time;
    int64_t futhark_mc_segmap_task_338025_total_iter;
    int64_t *futhark_mc_segred_stage_1_parloop_338039_total_runtime;
    int *futhark_mc_segred_stage_1_parloop_338039_runs;
    int64_t *futhark_mc_segred_stage_1_parloop_338039_iter;
    int64_t futhark_mc_segred_stage_1_parloop_338039_total_total_runtime;
    int futhark_mc_segred_stage_1_parloop_338039_total_runs;
    int64_t futhark_mc_segred_stage_1_parloop_338039_total_iter;
    int64_t *futhark_mc_segred_task_338032_total_runtime;
    int *futhark_mc_segred_task_338032_runs;
    int64_t *futhark_mc_segred_task_338032_iter;
    int64_t futhark_mc_segred_task_338032_total_time;
    int64_t futhark_mc_segred_task_338032_total_iter;
    int64_t *futhark_mc_segred_stage_1_parloop_338045_total_runtime;
    int *futhark_mc_segred_stage_1_parloop_338045_runs;
    int64_t *futhark_mc_segred_stage_1_parloop_338045_iter;
    int64_t futhark_mc_segred_stage_1_parloop_338045_total_total_runtime;
    int futhark_mc_segred_stage_1_parloop_338045_total_runs;
    int64_t futhark_mc_segred_stage_1_parloop_338045_total_iter;
    int64_t *futhark_mc_segred_task_338041_total_runtime;
    int *futhark_mc_segred_task_338041_runs;
    int64_t *futhark_mc_segred_task_338041_iter;
    int64_t futhark_mc_segred_task_338041_total_time;
    int64_t futhark_mc_segred_task_338041_total_iter;
    int64_t *futhark_mc_segmap_parloop_338030_total_runtime;
    int *futhark_mc_segmap_parloop_338030_runs;
    int64_t *futhark_mc_segmap_parloop_338030_iter;
    int64_t futhark_mc_segmap_parloop_338030_total_total_runtime;
    int futhark_mc_segmap_parloop_338030_total_runs;
    int64_t futhark_mc_segmap_parloop_338030_total_iter;
    int64_t *futhark_mc_segmap_nested_task_338028_total_runtime;
    int *futhark_mc_segmap_nested_task_338028_runs;
    int64_t *futhark_mc_segmap_nested_task_338028_iter;
    int64_t *futhark_mc_segmap_parloop_338021_total_runtime;
    int *futhark_mc_segmap_parloop_338021_runs;
    int64_t *futhark_mc_segmap_parloop_338021_iter;
    int64_t futhark_mc_segmap_parloop_338021_total_total_runtime;
    int futhark_mc_segmap_parloop_338021_total_runs;
    int64_t futhark_mc_segmap_parloop_338021_total_iter;
    int64_t *futhark_mc_segmap_nested_task_338019_total_runtime;
    int *futhark_mc_segmap_nested_task_338019_runs;
    int64_t *futhark_mc_segmap_nested_task_338019_iter;
    int64_t *futhark_mc_segmap_parloop_338010_total_runtime;
    int *futhark_mc_segmap_parloop_338010_runs;
    int64_t *futhark_mc_segmap_parloop_338010_iter;
    int64_t futhark_mc_segmap_parloop_338010_total_total_runtime;
    int futhark_mc_segmap_parloop_338010_total_runs;
    int64_t futhark_mc_segmap_parloop_338010_total_iter;
    int64_t *futhark_mc_segmap_nested_task_338008_total_runtime;
    int *futhark_mc_segmap_nested_task_338008_runs;
    int64_t *futhark_mc_segmap_nested_task_338008_iter;
    int64_t *futhark_mc_segmap_parloop_338049_total_runtime;
    int *futhark_mc_segmap_parloop_338049_runs;
    int64_t *futhark_mc_segmap_parloop_338049_iter;
    int64_t futhark_mc_segmap_parloop_338049_total_total_runtime;
    int futhark_mc_segmap_parloop_338049_total_runs;
    int64_t futhark_mc_segmap_parloop_338049_total_iter;
    int64_t *futhark_mc_segmap_task_338047_total_runtime;
    int *futhark_mc_segmap_task_338047_runs;
    int64_t *futhark_mc_segmap_task_338047_iter;
    int64_t futhark_mc_segmap_task_338047_total_time;
    int64_t futhark_mc_segmap_task_338047_total_iter;
    int64_t *futhark_mc_segmap_parloop_338059_total_runtime;
    int *futhark_mc_segmap_parloop_338059_runs;
    int64_t *futhark_mc_segmap_parloop_338059_iter;
    int64_t futhark_mc_segmap_parloop_338059_total_total_runtime;
    int futhark_mc_segmap_parloop_338059_total_runs;
    int64_t futhark_mc_segmap_parloop_338059_total_iter;
    int64_t *futhark_mc_segmap_task_338057_total_runtime;
    int *futhark_mc_segmap_task_338057_runs;
    int64_t *futhark_mc_segmap_task_338057_iter;
    int64_t futhark_mc_segmap_task_338057_total_time;
    int64_t futhark_mc_segmap_task_338057_total_iter;
    int64_t *futhark_mc_segmap_parloop_338069_total_runtime;
    int *futhark_mc_segmap_parloop_338069_runs;
    int64_t *futhark_mc_segmap_parloop_338069_iter;
    int64_t futhark_mc_segmap_parloop_338069_total_total_runtime;
    int futhark_mc_segmap_parloop_338069_total_runs;
    int64_t futhark_mc_segmap_parloop_338069_total_iter;
    int64_t *futhark_mc_segmap_task_338067_total_runtime;
    int *futhark_mc_segmap_task_338067_runs;
    int64_t *futhark_mc_segmap_task_338067_iter;
    int64_t futhark_mc_segmap_task_338067_total_time;
    int64_t futhark_mc_segmap_task_338067_total_iter;
    int64_t *futhark_mc_segred_stage_1_parloop_338079_total_runtime;
    int *futhark_mc_segred_stage_1_parloop_338079_runs;
    int64_t *futhark_mc_segred_stage_1_parloop_338079_iter;
    int64_t futhark_mc_segred_stage_1_parloop_338079_total_total_runtime;
    int futhark_mc_segred_stage_1_parloop_338079_total_runs;
    int64_t futhark_mc_segred_stage_1_parloop_338079_total_iter;
    int64_t *futhark_mc_segred_task_338076_total_runtime;
    int *futhark_mc_segred_task_338076_runs;
    int64_t *futhark_mc_segred_task_338076_iter;
    int64_t futhark_mc_segred_task_338076_total_time;
    int64_t futhark_mc_segred_task_338076_total_iter;
    int64_t *futhark_mc_segred_stage_1_parloop_338084_total_runtime;
    int *futhark_mc_segred_stage_1_parloop_338084_runs;
    int64_t *futhark_mc_segred_stage_1_parloop_338084_iter;
    int64_t futhark_mc_segred_stage_1_parloop_338084_total_total_runtime;
    int futhark_mc_segred_stage_1_parloop_338084_total_runs;
    int64_t futhark_mc_segred_stage_1_parloop_338084_total_iter;
    int64_t *futhark_mc_segred_task_338081_total_runtime;
    int *futhark_mc_segred_task_338081_runs;
    int64_t *futhark_mc_segred_task_338081_iter;
    int64_t futhark_mc_segred_task_338081_total_time;
    int64_t futhark_mc_segred_task_338081_total_iter;
    int64_t *futhark_mc_segmap_parloop_338073_total_runtime;
    int *futhark_mc_segmap_parloop_338073_runs;
    int64_t *futhark_mc_segmap_parloop_338073_iter;
    int64_t futhark_mc_segmap_parloop_338073_total_total_runtime;
    int futhark_mc_segmap_parloop_338073_total_runs;
    int64_t futhark_mc_segmap_parloop_338073_total_iter;
    int64_t *futhark_mc_segmap_nested_task_338071_total_runtime;
    int *futhark_mc_segmap_nested_task_338071_runs;
    int64_t *futhark_mc_segmap_nested_task_338071_iter;
    int64_t *futhark_mc_segmap_parloop_338064_total_runtime;
    int *futhark_mc_segmap_parloop_338064_runs;
    int64_t *futhark_mc_segmap_parloop_338064_iter;
    int64_t futhark_mc_segmap_parloop_338064_total_total_runtime;
    int futhark_mc_segmap_parloop_338064_total_runs;
    int64_t futhark_mc_segmap_parloop_338064_total_iter;
    int64_t *futhark_mc_segmap_nested_task_338062_total_runtime;
    int *futhark_mc_segmap_nested_task_338062_runs;
    int64_t *futhark_mc_segmap_nested_task_338062_iter;
    int64_t *futhark_mc_segmap_parloop_338054_total_runtime;
    int *futhark_mc_segmap_parloop_338054_runs;
    int64_t *futhark_mc_segmap_parloop_338054_iter;
    int64_t futhark_mc_segmap_parloop_338054_total_total_runtime;
    int futhark_mc_segmap_parloop_338054_total_runs;
    int64_t futhark_mc_segmap_parloop_338054_total_iter;
    int64_t *futhark_mc_segmap_nested_task_338052_total_runtime;
    int *futhark_mc_segmap_nested_task_338052_runs;
    int64_t *futhark_mc_segmap_nested_task_338052_iter;
    int64_t *futhark_mc_segmap_parloop_338088_total_runtime;
    int *futhark_mc_segmap_parloop_338088_runs;
    int64_t *futhark_mc_segmap_parloop_338088_iter;
    int64_t futhark_mc_segmap_parloop_338088_total_total_runtime;
    int futhark_mc_segmap_parloop_338088_total_runs;
    int64_t futhark_mc_segmap_parloop_338088_total_iter;
    int64_t *futhark_mc_segmap_task_338086_total_runtime;
    int *futhark_mc_segmap_task_338086_runs;
    int64_t *futhark_mc_segmap_task_338086_iter;
    int64_t futhark_mc_segmap_task_338086_total_time;
    int64_t futhark_mc_segmap_task_338086_total_iter;
    int64_t *futhark_mc_segmap_parloop_338101_total_runtime;
    int *futhark_mc_segmap_parloop_338101_runs;
    int64_t *futhark_mc_segmap_parloop_338101_iter;
    int64_t futhark_mc_segmap_parloop_338101_total_total_runtime;
    int futhark_mc_segmap_parloop_338101_total_runs;
    int64_t futhark_mc_segmap_parloop_338101_total_iter;
    int64_t *futhark_mc_segmap_task_338099_total_runtime;
    int *futhark_mc_segmap_task_338099_runs;
    int64_t *futhark_mc_segmap_task_338099_iter;
    int64_t futhark_mc_segmap_task_338099_total_time;
    int64_t futhark_mc_segmap_task_338099_total_iter;
    int64_t *futhark_mc_segmap_parloop_338114_total_runtime;
    int *futhark_mc_segmap_parloop_338114_runs;
    int64_t *futhark_mc_segmap_parloop_338114_iter;
    int64_t futhark_mc_segmap_parloop_338114_total_total_runtime;
    int futhark_mc_segmap_parloop_338114_total_runs;
    int64_t futhark_mc_segmap_parloop_338114_total_iter;
    int64_t *futhark_mc_segmap_task_338112_total_runtime;
    int *futhark_mc_segmap_task_338112_runs;
    int64_t *futhark_mc_segmap_task_338112_iter;
    int64_t futhark_mc_segmap_task_338112_total_time;
    int64_t futhark_mc_segmap_task_338112_total_iter;
    int64_t *futhark_mc_segred_stage_1_parloop_338128_total_runtime;
    int *futhark_mc_segred_stage_1_parloop_338128_runs;
    int64_t *futhark_mc_segred_stage_1_parloop_338128_iter;
    int64_t futhark_mc_segred_stage_1_parloop_338128_total_total_runtime;
    int futhark_mc_segred_stage_1_parloop_338128_total_runs;
    int64_t futhark_mc_segred_stage_1_parloop_338128_total_iter;
    int64_t *futhark_mc_segred_task_338123_total_runtime;
    int *futhark_mc_segred_task_338123_runs;
    int64_t *futhark_mc_segred_task_338123_iter;
    int64_t futhark_mc_segred_task_338123_total_time;
    int64_t futhark_mc_segred_task_338123_total_iter;
    int64_t *futhark_mc_segred_stage_1_parloop_338134_total_runtime;
    int *futhark_mc_segred_stage_1_parloop_338134_runs;
    int64_t *futhark_mc_segred_stage_1_parloop_338134_iter;
    int64_t futhark_mc_segred_stage_1_parloop_338134_total_total_runtime;
    int futhark_mc_segred_stage_1_parloop_338134_total_runs;
    int64_t futhark_mc_segred_stage_1_parloop_338134_total_iter;
    int64_t *futhark_mc_segred_task_338130_total_runtime;
    int *futhark_mc_segred_task_338130_runs;
    int64_t *futhark_mc_segred_task_338130_iter;
    int64_t futhark_mc_segred_task_338130_total_time;
    int64_t futhark_mc_segred_task_338130_total_iter;
    int64_t *futhark_mc_segmap_parloop_338119_total_runtime;
    int *futhark_mc_segmap_parloop_338119_runs;
    int64_t *futhark_mc_segmap_parloop_338119_iter;
    int64_t futhark_mc_segmap_parloop_338119_total_total_runtime;
    int futhark_mc_segmap_parloop_338119_total_runs;
    int64_t futhark_mc_segmap_parloop_338119_total_iter;
    int64_t *futhark_mc_segmap_nested_task_338117_total_runtime;
    int *futhark_mc_segmap_nested_task_338117_runs;
    int64_t *futhark_mc_segmap_nested_task_338117_iter;
    int64_t *futhark_mc_segmap_parloop_338108_total_runtime;
    int *futhark_mc_segmap_parloop_338108_runs;
    int64_t *futhark_mc_segmap_parloop_338108_iter;
    int64_t futhark_mc_segmap_parloop_338108_total_total_runtime;
    int futhark_mc_segmap_parloop_338108_total_runs;
    int64_t futhark_mc_segmap_parloop_338108_total_iter;
    int64_t *futhark_mc_segmap_nested_task_338106_total_runtime;
    int *futhark_mc_segmap_nested_task_338106_runs;
    int64_t *futhark_mc_segmap_nested_task_338106_iter;
    int64_t *futhark_mc_segmap_parloop_338095_total_runtime;
    int *futhark_mc_segmap_parloop_338095_runs;
    int64_t *futhark_mc_segmap_parloop_338095_iter;
    int64_t futhark_mc_segmap_parloop_338095_total_total_runtime;
    int futhark_mc_segmap_parloop_338095_total_runs;
    int64_t futhark_mc_segmap_parloop_338095_total_iter;
    int64_t *futhark_mc_segmap_nested_task_338093_total_runtime;
    int *futhark_mc_segmap_nested_task_338093_runs;
    int64_t *futhark_mc_segmap_nested_task_338093_iter;
    int64_t *futhark_mc_segmap_parloop_338138_total_runtime;
    int *futhark_mc_segmap_parloop_338138_runs;
    int64_t *futhark_mc_segmap_parloop_338138_iter;
    int64_t futhark_mc_segmap_parloop_338138_total_total_runtime;
    int futhark_mc_segmap_parloop_338138_total_runs;
    int64_t futhark_mc_segmap_parloop_338138_total_iter;
    int64_t *futhark_mc_segmap_task_338136_total_runtime;
    int *futhark_mc_segmap_task_338136_runs;
    int64_t *futhark_mc_segmap_task_338136_iter;
    int64_t futhark_mc_segmap_task_338136_total_time;
    int64_t futhark_mc_segmap_task_338136_total_iter;
    int64_t *futhark_mc_segmap_parloop_338153_total_runtime;
    int *futhark_mc_segmap_parloop_338153_runs;
    int64_t *futhark_mc_segmap_parloop_338153_iter;
    int64_t futhark_mc_segmap_parloop_338153_total_total_runtime;
    int futhark_mc_segmap_parloop_338153_total_runs;
    int64_t futhark_mc_segmap_parloop_338153_total_iter;
    int64_t *futhark_mc_segmap_task_338151_total_runtime;
    int *futhark_mc_segmap_task_338151_runs;
    int64_t *futhark_mc_segmap_task_338151_iter;
    int64_t futhark_mc_segmap_task_338151_total_time;
    int64_t futhark_mc_segmap_task_338151_total_iter;
    int64_t *futhark_mc_segmap_parloop_338168_total_runtime;
    int *futhark_mc_segmap_parloop_338168_runs;
    int64_t *futhark_mc_segmap_parloop_338168_iter;
    int64_t futhark_mc_segmap_parloop_338168_total_total_runtime;
    int futhark_mc_segmap_parloop_338168_total_runs;
    int64_t futhark_mc_segmap_parloop_338168_total_iter;
    int64_t *futhark_mc_segmap_task_338166_total_runtime;
    int *futhark_mc_segmap_task_338166_runs;
    int64_t *futhark_mc_segmap_task_338166_iter;
    int64_t futhark_mc_segmap_task_338166_total_time;
    int64_t futhark_mc_segmap_task_338166_total_iter;
    int64_t *futhark_mc_segmap_parloop_338183_total_runtime;
    int *futhark_mc_segmap_parloop_338183_runs;
    int64_t *futhark_mc_segmap_parloop_338183_iter;
    int64_t futhark_mc_segmap_parloop_338183_total_total_runtime;
    int futhark_mc_segmap_parloop_338183_total_runs;
    int64_t futhark_mc_segmap_parloop_338183_total_iter;
    int64_t *futhark_mc_segmap_task_338181_total_runtime;
    int *futhark_mc_segmap_task_338181_runs;
    int64_t *futhark_mc_segmap_task_338181_iter;
    int64_t futhark_mc_segmap_task_338181_total_time;
    int64_t futhark_mc_segmap_task_338181_total_iter;
    int64_t *futhark_mc_segred_stage_1_parloop_338192_total_runtime;
    int *futhark_mc_segred_stage_1_parloop_338192_runs;
    int64_t *futhark_mc_segred_stage_1_parloop_338192_iter;
    int64_t futhark_mc_segred_stage_1_parloop_338192_total_total_runtime;
    int futhark_mc_segred_stage_1_parloop_338192_total_runs;
    int64_t futhark_mc_segred_stage_1_parloop_338192_total_iter;
    int64_t *futhark_mc_segred_task_338185_total_runtime;
    int *futhark_mc_segred_task_338185_runs;
    int64_t *futhark_mc_segred_task_338185_iter;
    int64_t futhark_mc_segred_task_338185_total_time;
    int64_t futhark_mc_segred_task_338185_total_iter;
    int64_t *futhark_mc_segred_stage_1_parloop_338198_total_runtime;
    int *futhark_mc_segred_stage_1_parloop_338198_runs;
    int64_t *futhark_mc_segred_stage_1_parloop_338198_iter;
    int64_t futhark_mc_segred_stage_1_parloop_338198_total_total_runtime;
    int futhark_mc_segred_stage_1_parloop_338198_total_runs;
    int64_t futhark_mc_segred_stage_1_parloop_338198_total_iter;
    int64_t *futhark_mc_segred_task_338194_total_runtime;
    int *futhark_mc_segred_task_338194_runs;
    int64_t *futhark_mc_segred_task_338194_iter;
    int64_t futhark_mc_segred_task_338194_total_time;
    int64_t futhark_mc_segred_task_338194_total_iter;
    int64_t *futhark_mc_segmap_parloop_338175_total_runtime;
    int *futhark_mc_segmap_parloop_338175_runs;
    int64_t *futhark_mc_segmap_parloop_338175_iter;
    int64_t futhark_mc_segmap_parloop_338175_total_total_runtime;
    int futhark_mc_segmap_parloop_338175_total_runs;
    int64_t futhark_mc_segmap_parloop_338175_total_iter;
    int64_t *futhark_mc_segmap_nested_task_338173_total_runtime;
    int *futhark_mc_segmap_nested_task_338173_runs;
    int64_t *futhark_mc_segmap_nested_task_338173_iter;
    int64_t *futhark_mc_segmap_parloop_338162_total_runtime;
    int *futhark_mc_segmap_parloop_338162_runs;
    int64_t *futhark_mc_segmap_parloop_338162_iter;
    int64_t futhark_mc_segmap_parloop_338162_total_total_runtime;
    int futhark_mc_segmap_parloop_338162_total_runs;
    int64_t futhark_mc_segmap_parloop_338162_total_iter;
    int64_t *futhark_mc_segmap_nested_task_338160_total_runtime;
    int *futhark_mc_segmap_nested_task_338160_runs;
    int64_t *futhark_mc_segmap_nested_task_338160_iter;
    int64_t *futhark_mc_segmap_parloop_338147_total_runtime;
    int *futhark_mc_segmap_parloop_338147_runs;
    int64_t *futhark_mc_segmap_parloop_338147_iter;
    int64_t futhark_mc_segmap_parloop_338147_total_total_runtime;
    int futhark_mc_segmap_parloop_338147_total_runs;
    int64_t futhark_mc_segmap_parloop_338147_total_iter;
    int64_t *futhark_mc_segmap_nested_task_338145_total_runtime;
    int *futhark_mc_segmap_nested_task_338145_runs;
    int64_t *futhark_mc_segmap_nested_task_338145_iter;
    int64_t *futhark_mc_segmap_parloop_338202_total_runtime;
    int *futhark_mc_segmap_parloop_338202_runs;
    int64_t *futhark_mc_segmap_parloop_338202_iter;
    int64_t futhark_mc_segmap_parloop_338202_total_total_runtime;
    int futhark_mc_segmap_parloop_338202_total_runs;
    int64_t futhark_mc_segmap_parloop_338202_total_iter;
    int64_t *futhark_mc_segmap_task_338200_total_runtime;
    int *futhark_mc_segmap_task_338200_runs;
    int64_t *futhark_mc_segmap_task_338200_iter;
    int64_t futhark_mc_segmap_task_338200_total_time;
    int64_t futhark_mc_segmap_task_338200_total_iter;
    int64_t *futhark_mc_segmap_parloop_338211_total_runtime;
    int *futhark_mc_segmap_parloop_338211_runs;
    int64_t *futhark_mc_segmap_parloop_338211_iter;
    int64_t futhark_mc_segmap_parloop_338211_total_total_runtime;
    int futhark_mc_segmap_parloop_338211_total_runs;
    int64_t futhark_mc_segmap_parloop_338211_total_iter;
    int64_t *futhark_mc_segmap_task_338209_total_runtime;
    int *futhark_mc_segmap_task_338209_runs;
    int64_t *futhark_mc_segmap_task_338209_iter;
    int64_t futhark_mc_segmap_task_338209_total_time;
    int64_t futhark_mc_segmap_task_338209_total_iter;
    int64_t *futhark_mc_segmap_parloop_338220_total_runtime;
    int *futhark_mc_segmap_parloop_338220_runs;
    int64_t *futhark_mc_segmap_parloop_338220_iter;
    int64_t futhark_mc_segmap_parloop_338220_total_total_runtime;
    int futhark_mc_segmap_parloop_338220_total_runs;
    int64_t futhark_mc_segmap_parloop_338220_total_iter;
    int64_t *futhark_mc_segmap_task_338218_total_runtime;
    int *futhark_mc_segmap_task_338218_runs;
    int64_t *futhark_mc_segmap_task_338218_iter;
    int64_t futhark_mc_segmap_task_338218_total_time;
    int64_t futhark_mc_segmap_task_338218_total_iter;
    int64_t *futhark_mc_segred_stage_1_parloop_338228_total_runtime;
    int *futhark_mc_segred_stage_1_parloop_338228_runs;
    int64_t *futhark_mc_segred_stage_1_parloop_338228_iter;
    int64_t futhark_mc_segred_stage_1_parloop_338228_total_total_runtime;
    int futhark_mc_segred_stage_1_parloop_338228_total_runs;
    int64_t futhark_mc_segred_stage_1_parloop_338228_total_iter;
    int64_t *futhark_mc_segred_task_338225_total_runtime;
    int *futhark_mc_segred_task_338225_runs;
    int64_t *futhark_mc_segred_task_338225_iter;
    int64_t futhark_mc_segred_task_338225_total_time;
    int64_t futhark_mc_segred_task_338225_total_iter;
    int64_t *futhark_mc_segred_stage_1_parloop_338233_total_runtime;
    int *futhark_mc_segred_stage_1_parloop_338233_runs;
    int64_t *futhark_mc_segred_stage_1_parloop_338233_iter;
    int64_t futhark_mc_segred_stage_1_parloop_338233_total_total_runtime;
    int futhark_mc_segred_stage_1_parloop_338233_total_runs;
    int64_t futhark_mc_segred_stage_1_parloop_338233_total_iter;
    int64_t *futhark_mc_segred_task_338230_total_runtime;
    int *futhark_mc_segred_task_338230_runs;
    int64_t *futhark_mc_segred_task_338230_iter;
    int64_t futhark_mc_segred_task_338230_total_time;
    int64_t futhark_mc_segred_task_338230_total_iter;
    int64_t *futhark_mc_segmap_parloop_338223_total_runtime;
    int *futhark_mc_segmap_parloop_338223_runs;
    int64_t *futhark_mc_segmap_parloop_338223_iter;
    int64_t futhark_mc_segmap_parloop_338223_total_total_runtime;
    int futhark_mc_segmap_parloop_338223_total_runs;
    int64_t futhark_mc_segmap_parloop_338223_total_iter;
    int64_t *futhark_mc_segmap_nested_task_338221_total_runtime;
    int *futhark_mc_segmap_nested_task_338221_runs;
    int64_t *futhark_mc_segmap_nested_task_338221_iter;
    int64_t *futhark_mc_segmap_parloop_338215_total_runtime;
    int *futhark_mc_segmap_parloop_338215_runs;
    int64_t *futhark_mc_segmap_parloop_338215_iter;
    int64_t futhark_mc_segmap_parloop_338215_total_total_runtime;
    int futhark_mc_segmap_parloop_338215_total_runs;
    int64_t futhark_mc_segmap_parloop_338215_total_iter;
    int64_t *futhark_mc_segmap_nested_task_338213_total_runtime;
    int *futhark_mc_segmap_nested_task_338213_runs;
    int64_t *futhark_mc_segmap_nested_task_338213_iter;
    int64_t *futhark_mc_segmap_parloop_338206_total_runtime;
    int *futhark_mc_segmap_parloop_338206_runs;
    int64_t *futhark_mc_segmap_parloop_338206_iter;
    int64_t futhark_mc_segmap_parloop_338206_total_total_runtime;
    int futhark_mc_segmap_parloop_338206_total_runs;
    int64_t futhark_mc_segmap_parloop_338206_total_iter;
    int64_t *futhark_mc_segmap_nested_task_338204_total_runtime;
    int *futhark_mc_segmap_nested_task_338204_runs;
    int64_t *futhark_mc_segmap_nested_task_338204_iter;
    int64_t *futhark_mc_segmap_parloop_338237_total_runtime;
    int *futhark_mc_segmap_parloop_338237_runs;
    int64_t *futhark_mc_segmap_parloop_338237_iter;
    int64_t futhark_mc_segmap_parloop_338237_total_total_runtime;
    int futhark_mc_segmap_parloop_338237_total_runs;
    int64_t futhark_mc_segmap_parloop_338237_total_iter;
    int64_t *futhark_mc_segmap_task_338235_total_runtime;
    int *futhark_mc_segmap_task_338235_runs;
    int64_t *futhark_mc_segmap_task_338235_iter;
    int64_t futhark_mc_segmap_task_338235_total_time;
    int64_t futhark_mc_segmap_task_338235_total_iter;
    int64_t *futhark_mc_segmap_parloop_338248_total_runtime;
    int *futhark_mc_segmap_parloop_338248_runs;
    int64_t *futhark_mc_segmap_parloop_338248_iter;
    int64_t futhark_mc_segmap_parloop_338248_total_total_runtime;
    int futhark_mc_segmap_parloop_338248_total_runs;
    int64_t futhark_mc_segmap_parloop_338248_total_iter;
    int64_t *futhark_mc_segmap_task_338246_total_runtime;
    int *futhark_mc_segmap_task_338246_runs;
    int64_t *futhark_mc_segmap_task_338246_iter;
    int64_t futhark_mc_segmap_task_338246_total_time;
    int64_t futhark_mc_segmap_task_338246_total_iter;
    int64_t *futhark_mc_segmap_parloop_338259_total_runtime;
    int *futhark_mc_segmap_parloop_338259_runs;
    int64_t *futhark_mc_segmap_parloop_338259_iter;
    int64_t futhark_mc_segmap_parloop_338259_total_total_runtime;
    int futhark_mc_segmap_parloop_338259_total_runs;
    int64_t futhark_mc_segmap_parloop_338259_total_iter;
    int64_t *futhark_mc_segmap_task_338257_total_runtime;
    int *futhark_mc_segmap_task_338257_runs;
    int64_t *futhark_mc_segmap_task_338257_iter;
    int64_t futhark_mc_segmap_task_338257_total_time;
    int64_t futhark_mc_segmap_task_338257_total_iter;
    int64_t *futhark_mc_segred_stage_1_parloop_338269_total_runtime;
    int *futhark_mc_segred_stage_1_parloop_338269_runs;
    int64_t *futhark_mc_segred_stage_1_parloop_338269_iter;
    int64_t futhark_mc_segred_stage_1_parloop_338269_total_total_runtime;
    int futhark_mc_segred_stage_1_parloop_338269_total_runs;
    int64_t futhark_mc_segred_stage_1_parloop_338269_total_iter;
    int64_t *futhark_mc_segred_task_338264_total_runtime;
    int *futhark_mc_segred_task_338264_runs;
    int64_t *futhark_mc_segred_task_338264_iter;
    int64_t futhark_mc_segred_task_338264_total_time;
    int64_t futhark_mc_segred_task_338264_total_iter;
    int64_t *futhark_mc_segred_stage_1_parloop_338275_total_runtime;
    int *futhark_mc_segred_stage_1_parloop_338275_runs;
    int64_t *futhark_mc_segred_stage_1_parloop_338275_iter;
    int64_t futhark_mc_segred_stage_1_parloop_338275_total_total_runtime;
    int futhark_mc_segred_stage_1_parloop_338275_total_runs;
    int64_t futhark_mc_segred_stage_1_parloop_338275_total_iter;
    int64_t *futhark_mc_segred_task_338271_total_runtime;
    int *futhark_mc_segred_task_338271_runs;
    int64_t *futhark_mc_segred_task_338271_iter;
    int64_t futhark_mc_segred_task_338271_total_time;
    int64_t futhark_mc_segred_task_338271_total_iter;
    int64_t *futhark_mc_segmap_parloop_338262_total_runtime;
    int *futhark_mc_segmap_parloop_338262_runs;
    int64_t *futhark_mc_segmap_parloop_338262_iter;
    int64_t futhark_mc_segmap_parloop_338262_total_total_runtime;
    int futhark_mc_segmap_parloop_338262_total_runs;
    int64_t futhark_mc_segmap_parloop_338262_total_iter;
    int64_t *futhark_mc_segmap_nested_task_338260_total_runtime;
    int *futhark_mc_segmap_nested_task_338260_runs;
    int64_t *futhark_mc_segmap_nested_task_338260_iter;
    int64_t *futhark_mc_segmap_parloop_338253_total_runtime;
    int *futhark_mc_segmap_parloop_338253_runs;
    int64_t *futhark_mc_segmap_parloop_338253_iter;
    int64_t futhark_mc_segmap_parloop_338253_total_total_runtime;
    int futhark_mc_segmap_parloop_338253_total_runs;
    int64_t futhark_mc_segmap_parloop_338253_total_iter;
    int64_t *futhark_mc_segmap_nested_task_338251_total_runtime;
    int *futhark_mc_segmap_nested_task_338251_runs;
    int64_t *futhark_mc_segmap_nested_task_338251_iter;
    int64_t *futhark_mc_segmap_parloop_338242_total_runtime;
    int *futhark_mc_segmap_parloop_338242_runs;
    int64_t *futhark_mc_segmap_parloop_338242_iter;
    int64_t futhark_mc_segmap_parloop_338242_total_total_runtime;
    int futhark_mc_segmap_parloop_338242_total_runs;
    int64_t futhark_mc_segmap_parloop_338242_total_iter;
    int64_t *futhark_mc_segmap_nested_task_338240_total_runtime;
    int *futhark_mc_segmap_nested_task_338240_runs;
    int64_t *futhark_mc_segmap_nested_task_338240_iter;
    int64_t *futhark_mc_segmap_parloop_338279_total_runtime;
    int *futhark_mc_segmap_parloop_338279_runs;
    int64_t *futhark_mc_segmap_parloop_338279_iter;
    int64_t futhark_mc_segmap_parloop_338279_total_total_runtime;
    int futhark_mc_segmap_parloop_338279_total_runs;
    int64_t futhark_mc_segmap_parloop_338279_total_iter;
    int64_t *futhark_mc_segmap_task_338277_total_runtime;
    int *futhark_mc_segmap_task_338277_runs;
    int64_t *futhark_mc_segmap_task_338277_iter;
    int64_t futhark_mc_segmap_task_338277_total_time;
    int64_t futhark_mc_segmap_task_338277_total_iter;
    int64_t *futhark_mc_segmap_parloop_338290_total_runtime;
    int *futhark_mc_segmap_parloop_338290_runs;
    int64_t *futhark_mc_segmap_parloop_338290_iter;
    int64_t futhark_mc_segmap_parloop_338290_total_total_runtime;
    int futhark_mc_segmap_parloop_338290_total_runs;
    int64_t futhark_mc_segmap_parloop_338290_total_iter;
    int64_t *futhark_mc_segmap_task_338288_total_runtime;
    int *futhark_mc_segmap_task_338288_runs;
    int64_t *futhark_mc_segmap_task_338288_iter;
    int64_t futhark_mc_segmap_task_338288_total_time;
    int64_t futhark_mc_segmap_task_338288_total_iter;
    int64_t *futhark_mc_segmap_parloop_338301_total_runtime;
    int *futhark_mc_segmap_parloop_338301_runs;
    int64_t *futhark_mc_segmap_parloop_338301_iter;
    int64_t futhark_mc_segmap_parloop_338301_total_total_runtime;
    int futhark_mc_segmap_parloop_338301_total_runs;
    int64_t futhark_mc_segmap_parloop_338301_total_iter;
    int64_t *futhark_mc_segmap_task_338299_total_runtime;
    int *futhark_mc_segmap_task_338299_runs;
    int64_t *futhark_mc_segmap_task_338299_iter;
    int64_t futhark_mc_segmap_task_338299_total_time;
    int64_t futhark_mc_segmap_task_338299_total_iter;
    int64_t *futhark_mc_segred_stage_1_parloop_338313_total_runtime;
    int *futhark_mc_segred_stage_1_parloop_338313_runs;
    int64_t *futhark_mc_segred_stage_1_parloop_338313_iter;
    int64_t futhark_mc_segred_stage_1_parloop_338313_total_total_runtime;
    int futhark_mc_segred_stage_1_parloop_338313_total_runs;
    int64_t futhark_mc_segred_stage_1_parloop_338313_total_iter;
    int64_t *futhark_mc_segred_task_338306_total_runtime;
    int *futhark_mc_segred_task_338306_runs;
    int64_t *futhark_mc_segred_task_338306_iter;
    int64_t futhark_mc_segred_task_338306_total_time;
    int64_t futhark_mc_segred_task_338306_total_iter;
    int64_t *futhark_mc_segred_stage_1_parloop_338319_total_runtime;
    int *futhark_mc_segred_stage_1_parloop_338319_runs;
    int64_t *futhark_mc_segred_stage_1_parloop_338319_iter;
    int64_t futhark_mc_segred_stage_1_parloop_338319_total_total_runtime;
    int futhark_mc_segred_stage_1_parloop_338319_total_runs;
    int64_t futhark_mc_segred_stage_1_parloop_338319_total_iter;
    int64_t *futhark_mc_segred_task_338315_total_runtime;
    int *futhark_mc_segred_task_338315_runs;
    int64_t *futhark_mc_segred_task_338315_iter;
    int64_t futhark_mc_segred_task_338315_total_time;
    int64_t futhark_mc_segred_task_338315_total_iter;
    int64_t *futhark_mc_segmap_parloop_338304_total_runtime;
    int *futhark_mc_segmap_parloop_338304_runs;
    int64_t *futhark_mc_segmap_parloop_338304_iter;
    int64_t futhark_mc_segmap_parloop_338304_total_total_runtime;
    int futhark_mc_segmap_parloop_338304_total_runs;
    int64_t futhark_mc_segmap_parloop_338304_total_iter;
    int64_t *futhark_mc_segmap_nested_task_338302_total_runtime;
    int *futhark_mc_segmap_nested_task_338302_runs;
    int64_t *futhark_mc_segmap_nested_task_338302_iter;
    int64_t *futhark_mc_segmap_parloop_338295_total_runtime;
    int *futhark_mc_segmap_parloop_338295_runs;
    int64_t *futhark_mc_segmap_parloop_338295_iter;
    int64_t futhark_mc_segmap_parloop_338295_total_total_runtime;
    int futhark_mc_segmap_parloop_338295_total_runs;
    int64_t futhark_mc_segmap_parloop_338295_total_iter;
    int64_t *futhark_mc_segmap_nested_task_338293_total_runtime;
    int *futhark_mc_segmap_nested_task_338293_runs;
    int64_t *futhark_mc_segmap_nested_task_338293_iter;
    int64_t *futhark_mc_segmap_parloop_338284_total_runtime;
    int *futhark_mc_segmap_parloop_338284_runs;
    int64_t *futhark_mc_segmap_parloop_338284_iter;
    int64_t futhark_mc_segmap_parloop_338284_total_total_runtime;
    int futhark_mc_segmap_parloop_338284_total_runs;
    int64_t futhark_mc_segmap_parloop_338284_total_iter;
    int64_t *futhark_mc_segmap_nested_task_338282_total_runtime;
    int *futhark_mc_segmap_nested_task_338282_runs;
    int64_t *futhark_mc_segmap_nested_task_338282_iter;
    int64_t *futhark_mc_segmap_parloop_338323_total_runtime;
    int *futhark_mc_segmap_parloop_338323_runs;
    int64_t *futhark_mc_segmap_parloop_338323_iter;
    int64_t futhark_mc_segmap_parloop_338323_total_total_runtime;
    int futhark_mc_segmap_parloop_338323_total_runs;
    int64_t futhark_mc_segmap_parloop_338323_total_iter;
    int64_t *futhark_mc_segmap_task_338321_total_runtime;
    int *futhark_mc_segmap_task_338321_runs;
    int64_t *futhark_mc_segmap_task_338321_iter;
    int64_t futhark_mc_segmap_task_338321_total_time;
    int64_t futhark_mc_segmap_task_338321_total_iter;
    int64_t *futhark_mc_segmap_parloop_338332_total_runtime;
    int *futhark_mc_segmap_parloop_338332_runs;
    int64_t *futhark_mc_segmap_parloop_338332_iter;
    int64_t futhark_mc_segmap_parloop_338332_total_total_runtime;
    int futhark_mc_segmap_parloop_338332_total_runs;
    int64_t futhark_mc_segmap_parloop_338332_total_iter;
    int64_t *futhark_mc_segmap_task_338330_total_runtime;
    int *futhark_mc_segmap_task_338330_runs;
    int64_t *futhark_mc_segmap_task_338330_iter;
    int64_t futhark_mc_segmap_task_338330_total_time;
    int64_t futhark_mc_segmap_task_338330_total_iter;
    int64_t *futhark_mc_segmap_parloop_338341_total_runtime;
    int *futhark_mc_segmap_parloop_338341_runs;
    int64_t *futhark_mc_segmap_parloop_338341_iter;
    int64_t futhark_mc_segmap_parloop_338341_total_total_runtime;
    int futhark_mc_segmap_parloop_338341_total_runs;
    int64_t futhark_mc_segmap_parloop_338341_total_iter;
    int64_t *futhark_mc_segmap_task_338339_total_runtime;
    int *futhark_mc_segmap_task_338339_runs;
    int64_t *futhark_mc_segmap_task_338339_iter;
    int64_t futhark_mc_segmap_task_338339_total_time;
    int64_t futhark_mc_segmap_task_338339_total_iter;
    int64_t *futhark_mc_segmap_parloop_338336_total_runtime;
    int *futhark_mc_segmap_parloop_338336_runs;
    int64_t *futhark_mc_segmap_parloop_338336_iter;
    int64_t futhark_mc_segmap_parloop_338336_total_total_runtime;
    int futhark_mc_segmap_parloop_338336_total_runs;
    int64_t futhark_mc_segmap_parloop_338336_total_iter;
    int64_t *futhark_mc_segmap_nested_task_338334_total_runtime;
    int *futhark_mc_segmap_nested_task_338334_runs;
    int64_t *futhark_mc_segmap_nested_task_338334_iter;
    int64_t *futhark_mc_segmap_parloop_338327_total_runtime;
    int *futhark_mc_segmap_parloop_338327_runs;
    int64_t *futhark_mc_segmap_parloop_338327_iter;
    int64_t futhark_mc_segmap_parloop_338327_total_total_runtime;
    int futhark_mc_segmap_parloop_338327_total_runs;
    int64_t futhark_mc_segmap_parloop_338327_total_iter;
    int64_t *futhark_mc_segmap_nested_task_338325_total_runtime;
    int *futhark_mc_segmap_nested_task_338325_runs;
    int64_t *futhark_mc_segmap_nested_task_338325_iter;
    int64_t *futhark_mc_segmap_parloop_338345_total_runtime;
    int *futhark_mc_segmap_parloop_338345_runs;
    int64_t *futhark_mc_segmap_parloop_338345_iter;
    int64_t futhark_mc_segmap_parloop_338345_total_total_runtime;
    int futhark_mc_segmap_parloop_338345_total_runs;
    int64_t futhark_mc_segmap_parloop_338345_total_iter;
    int64_t *futhark_mc_segmap_task_338343_total_runtime;
    int *futhark_mc_segmap_task_338343_runs;
    int64_t *futhark_mc_segmap_task_338343_iter;
    int64_t futhark_mc_segmap_task_338343_total_time;
    int64_t futhark_mc_segmap_task_338343_total_iter;
    int64_t *futhark_mc_segmap_parloop_338354_total_runtime;
    int *futhark_mc_segmap_parloop_338354_runs;
    int64_t *futhark_mc_segmap_parloop_338354_iter;
    int64_t futhark_mc_segmap_parloop_338354_total_total_runtime;
    int futhark_mc_segmap_parloop_338354_total_runs;
    int64_t futhark_mc_segmap_parloop_338354_total_iter;
    int64_t *futhark_mc_segmap_task_338352_total_runtime;
    int *futhark_mc_segmap_task_338352_runs;
    int64_t *futhark_mc_segmap_task_338352_iter;
    int64_t futhark_mc_segmap_task_338352_total_time;
    int64_t futhark_mc_segmap_task_338352_total_iter;
    int64_t *futhark_mc_segmap_parloop_338349_total_runtime;
    int *futhark_mc_segmap_parloop_338349_runs;
    int64_t *futhark_mc_segmap_parloop_338349_iter;
    int64_t futhark_mc_segmap_parloop_338349_total_total_runtime;
    int futhark_mc_segmap_parloop_338349_total_runs;
    int64_t futhark_mc_segmap_parloop_338349_total_iter;
    int64_t *futhark_mc_segmap_nested_task_338347_total_runtime;
    int *futhark_mc_segmap_nested_task_338347_runs;
    int64_t *futhark_mc_segmap_nested_task_338347_iter;
    int64_t *futhark_mc_segmap_parloop_338358_total_runtime;
    int *futhark_mc_segmap_parloop_338358_runs;
    int64_t *futhark_mc_segmap_parloop_338358_iter;
    int64_t futhark_mc_segmap_parloop_338358_total_total_runtime;
    int futhark_mc_segmap_parloop_338358_total_runs;
    int64_t futhark_mc_segmap_parloop_338358_total_iter;
    int64_t *futhark_mc_segmap_task_338356_total_runtime;
    int *futhark_mc_segmap_task_338356_runs;
    int64_t *futhark_mc_segmap_task_338356_iter;
    int64_t futhark_mc_segmap_task_338356_total_time;
    int64_t futhark_mc_segmap_task_338356_total_iter;
    int64_t *futhark_mc_segred_stage_1_parloop_338366_total_runtime;
    int *futhark_mc_segred_stage_1_parloop_338366_runs;
    int64_t *futhark_mc_segred_stage_1_parloop_338366_iter;
    int64_t futhark_mc_segred_stage_1_parloop_338366_total_total_runtime;
    int futhark_mc_segred_stage_1_parloop_338366_total_runs;
    int64_t futhark_mc_segred_stage_1_parloop_338366_total_iter;
    int64_t *futhark_mc_segred_task_338363_total_runtime;
    int *futhark_mc_segred_task_338363_runs;
    int64_t *futhark_mc_segred_task_338363_iter;
    int64_t futhark_mc_segred_task_338363_total_time;
    int64_t futhark_mc_segred_task_338363_total_iter;
    int64_t *futhark_mc_segmap_parloop_338361_total_runtime;
    int *futhark_mc_segmap_parloop_338361_runs;
    int64_t *futhark_mc_segmap_parloop_338361_iter;
    int64_t futhark_mc_segmap_parloop_338361_total_total_runtime;
    int futhark_mc_segmap_parloop_338361_total_runs;
    int64_t futhark_mc_segmap_parloop_338361_total_iter;
    int64_t *futhark_mc_segmap_nested_task_338359_total_runtime;
    int *futhark_mc_segmap_nested_task_338359_runs;
    int64_t *futhark_mc_segmap_nested_task_338359_iter;
    int64_t *futhark_mc_segmap_parloop_338370_total_runtime;
    int *futhark_mc_segmap_parloop_338370_runs;
    int64_t *futhark_mc_segmap_parloop_338370_iter;
    int64_t futhark_mc_segmap_parloop_338370_total_total_runtime;
    int futhark_mc_segmap_parloop_338370_total_runs;
    int64_t futhark_mc_segmap_parloop_338370_total_iter;
    int64_t *futhark_mc_segmap_task_338368_total_runtime;
    int *futhark_mc_segmap_task_338368_runs;
    int64_t *futhark_mc_segmap_task_338368_iter;
    int64_t futhark_mc_segmap_task_338368_total_time;
    int64_t futhark_mc_segmap_task_338368_total_iter;
    int64_t *futhark_mc_scan_stage_1_parloop_338380_total_runtime;
    int *futhark_mc_scan_stage_1_parloop_338380_runs;
    int64_t *futhark_mc_scan_stage_1_parloop_338380_iter;
    int64_t futhark_mc_scan_stage_1_parloop_338380_total_total_runtime;
    int futhark_mc_scan_stage_1_parloop_338380_total_runs;
    int64_t futhark_mc_scan_stage_1_parloop_338380_total_iter;
    int64_t *futhark_mc_scan_stage_3_parloop_338382_total_runtime;
    int *futhark_mc_scan_stage_3_parloop_338382_runs;
    int64_t *futhark_mc_scan_stage_3_parloop_338382_iter;
    int64_t futhark_mc_scan_stage_3_parloop_338382_total_total_runtime;
    int futhark_mc_scan_stage_3_parloop_338382_total_runs;
    int64_t futhark_mc_scan_stage_3_parloop_338382_total_iter;
    int64_t *futhark_mc_segscan_task_338377_total_runtime;
    int *futhark_mc_segscan_task_338377_runs;
    int64_t *futhark_mc_segscan_task_338377_iter;
    int64_t futhark_mc_segscan_task_338377_total_time;
    int64_t futhark_mc_segscan_task_338377_total_iter;
    int64_t *futhark_mc_segmap_parloop_338374_total_runtime;
    int *futhark_mc_segmap_parloop_338374_runs;
    int64_t *futhark_mc_segmap_parloop_338374_iter;
    int64_t futhark_mc_segmap_parloop_338374_total_total_runtime;
    int futhark_mc_segmap_parloop_338374_total_runs;
    int64_t futhark_mc_segmap_parloop_338374_total_iter;
    int64_t *futhark_mc_segmap_nested_task_338372_total_runtime;
    int *futhark_mc_segmap_nested_task_338372_runs;
    int64_t *futhark_mc_segmap_nested_task_338372_iter;
    int64_t *futhark_mc_segmap_parloop_338386_total_runtime;
    int *futhark_mc_segmap_parloop_338386_runs;
    int64_t *futhark_mc_segmap_parloop_338386_iter;
    int64_t futhark_mc_segmap_parloop_338386_total_total_runtime;
    int futhark_mc_segmap_parloop_338386_total_runs;
    int64_t futhark_mc_segmap_parloop_338386_total_iter;
    int64_t *futhark_mc_segmap_task_338384_total_runtime;
    int *futhark_mc_segmap_task_338384_runs;
    int64_t *futhark_mc_segmap_task_338384_iter;
    int64_t futhark_mc_segmap_task_338384_total_time;
    int64_t futhark_mc_segmap_task_338384_total_iter;
    int64_t *futhark_mc_segred_stage_1_parloop_338394_total_runtime;
    int *futhark_mc_segred_stage_1_parloop_338394_runs;
    int64_t *futhark_mc_segred_stage_1_parloop_338394_iter;
    int64_t futhark_mc_segred_stage_1_parloop_338394_total_total_runtime;
    int futhark_mc_segred_stage_1_parloop_338394_total_runs;
    int64_t futhark_mc_segred_stage_1_parloop_338394_total_iter;
    int64_t *futhark_mc_segred_task_338391_total_runtime;
    int *futhark_mc_segred_task_338391_runs;
    int64_t *futhark_mc_segred_task_338391_iter;
    int64_t futhark_mc_segred_task_338391_total_time;
    int64_t futhark_mc_segred_task_338391_total_iter;
    int64_t *futhark_mc_segmap_parloop_338389_total_runtime;
    int *futhark_mc_segmap_parloop_338389_runs;
    int64_t *futhark_mc_segmap_parloop_338389_iter;
    int64_t futhark_mc_segmap_parloop_338389_total_total_runtime;
    int futhark_mc_segmap_parloop_338389_total_runs;
    int64_t futhark_mc_segmap_parloop_338389_total_iter;
    int64_t *futhark_mc_segmap_nested_task_338387_total_runtime;
    int *futhark_mc_segmap_nested_task_338387_runs;
    int64_t *futhark_mc_segmap_nested_task_338387_iter;
    int64_t *futhark_mc_segmap_parloop_338398_total_runtime;
    int *futhark_mc_segmap_parloop_338398_runs;
    int64_t *futhark_mc_segmap_parloop_338398_iter;
    int64_t futhark_mc_segmap_parloop_338398_total_total_runtime;
    int futhark_mc_segmap_parloop_338398_total_runs;
    int64_t futhark_mc_segmap_parloop_338398_total_iter;
    int64_t *futhark_mc_segmap_task_338396_total_runtime;
    int *futhark_mc_segmap_task_338396_runs;
    int64_t *futhark_mc_segmap_task_338396_iter;
    int64_t futhark_mc_segmap_task_338396_total_time;
    int64_t futhark_mc_segmap_task_338396_total_iter;
    int64_t *futhark_mc_scan_stage_1_parloop_338408_total_runtime;
    int *futhark_mc_scan_stage_1_parloop_338408_runs;
    int64_t *futhark_mc_scan_stage_1_parloop_338408_iter;
    int64_t futhark_mc_scan_stage_1_parloop_338408_total_total_runtime;
    int futhark_mc_scan_stage_1_parloop_338408_total_runs;
    int64_t futhark_mc_scan_stage_1_parloop_338408_total_iter;
    int64_t *futhark_mc_scan_stage_3_parloop_338410_total_runtime;
    int *futhark_mc_scan_stage_3_parloop_338410_runs;
    int64_t *futhark_mc_scan_stage_3_parloop_338410_iter;
    int64_t futhark_mc_scan_stage_3_parloop_338410_total_total_runtime;
    int futhark_mc_scan_stage_3_parloop_338410_total_runs;
    int64_t futhark_mc_scan_stage_3_parloop_338410_total_iter;
    int64_t *futhark_mc_segscan_task_338405_total_runtime;
    int *futhark_mc_segscan_task_338405_runs;
    int64_t *futhark_mc_segscan_task_338405_iter;
    int64_t futhark_mc_segscan_task_338405_total_time;
    int64_t futhark_mc_segscan_task_338405_total_iter;
    int64_t *futhark_mc_segmap_parloop_338402_total_runtime;
    int *futhark_mc_segmap_parloop_338402_runs;
    int64_t *futhark_mc_segmap_parloop_338402_iter;
    int64_t futhark_mc_segmap_parloop_338402_total_total_runtime;
    int futhark_mc_segmap_parloop_338402_total_runs;
    int64_t futhark_mc_segmap_parloop_338402_total_iter;
    int64_t *futhark_mc_segmap_nested_task_338400_total_runtime;
    int *futhark_mc_segmap_nested_task_338400_runs;
    int64_t *futhark_mc_segmap_nested_task_338400_iter;
    int64_t *futhark_mc_segmap_parloop_338414_total_runtime;
    int *futhark_mc_segmap_parloop_338414_runs;
    int64_t *futhark_mc_segmap_parloop_338414_iter;
    int64_t futhark_mc_segmap_parloop_338414_total_total_runtime;
    int futhark_mc_segmap_parloop_338414_total_runs;
    int64_t futhark_mc_segmap_parloop_338414_total_iter;
    int64_t *futhark_mc_segmap_task_338412_total_runtime;
    int *futhark_mc_segmap_task_338412_runs;
    int64_t *futhark_mc_segmap_task_338412_iter;
    int64_t futhark_mc_segmap_task_338412_total_time;
    int64_t futhark_mc_segmap_task_338412_total_iter;
    int64_t *futhark_mc_segred_stage_1_parloop_338422_total_runtime;
    int *futhark_mc_segred_stage_1_parloop_338422_runs;
    int64_t *futhark_mc_segred_stage_1_parloop_338422_iter;
    int64_t futhark_mc_segred_stage_1_parloop_338422_total_total_runtime;
    int futhark_mc_segred_stage_1_parloop_338422_total_runs;
    int64_t futhark_mc_segred_stage_1_parloop_338422_total_iter;
    int64_t *futhark_mc_segred_task_338419_total_runtime;
    int *futhark_mc_segred_task_338419_runs;
    int64_t *futhark_mc_segred_task_338419_iter;
    int64_t futhark_mc_segred_task_338419_total_time;
    int64_t futhark_mc_segred_task_338419_total_iter;
    int64_t *futhark_mc_segmap_parloop_338417_total_runtime;
    int *futhark_mc_segmap_parloop_338417_runs;
    int64_t *futhark_mc_segmap_parloop_338417_iter;
    int64_t futhark_mc_segmap_parloop_338417_total_total_runtime;
    int futhark_mc_segmap_parloop_338417_total_runs;
    int64_t futhark_mc_segmap_parloop_338417_total_iter;
    int64_t *futhark_mc_segmap_nested_task_338415_total_runtime;
    int *futhark_mc_segmap_nested_task_338415_runs;
    int64_t *futhark_mc_segmap_nested_task_338415_iter;
    int64_t *futhark_mc_segmap_parloop_338426_total_runtime;
    int *futhark_mc_segmap_parloop_338426_runs;
    int64_t *futhark_mc_segmap_parloop_338426_iter;
    int64_t futhark_mc_segmap_parloop_338426_total_total_runtime;
    int futhark_mc_segmap_parloop_338426_total_runs;
    int64_t futhark_mc_segmap_parloop_338426_total_iter;
    int64_t *futhark_mc_segmap_task_338424_total_runtime;
    int *futhark_mc_segmap_task_338424_runs;
    int64_t *futhark_mc_segmap_task_338424_iter;
    int64_t futhark_mc_segmap_task_338424_total_time;
    int64_t futhark_mc_segmap_task_338424_total_iter;
    int64_t *futhark_mc_scan_stage_1_parloop_338436_total_runtime;
    int *futhark_mc_scan_stage_1_parloop_338436_runs;
    int64_t *futhark_mc_scan_stage_1_parloop_338436_iter;
    int64_t futhark_mc_scan_stage_1_parloop_338436_total_total_runtime;
    int futhark_mc_scan_stage_1_parloop_338436_total_runs;
    int64_t futhark_mc_scan_stage_1_parloop_338436_total_iter;
    int64_t *futhark_mc_scan_stage_3_parloop_338438_total_runtime;
    int *futhark_mc_scan_stage_3_parloop_338438_runs;
    int64_t *futhark_mc_scan_stage_3_parloop_338438_iter;
    int64_t futhark_mc_scan_stage_3_parloop_338438_total_total_runtime;
    int futhark_mc_scan_stage_3_parloop_338438_total_runs;
    int64_t futhark_mc_scan_stage_3_parloop_338438_total_iter;
    int64_t *futhark_mc_segscan_task_338433_total_runtime;
    int *futhark_mc_segscan_task_338433_runs;
    int64_t *futhark_mc_segscan_task_338433_iter;
    int64_t futhark_mc_segscan_task_338433_total_time;
    int64_t futhark_mc_segscan_task_338433_total_iter;
    int64_t *futhark_mc_segmap_parloop_338430_total_runtime;
    int *futhark_mc_segmap_parloop_338430_runs;
    int64_t *futhark_mc_segmap_parloop_338430_iter;
    int64_t futhark_mc_segmap_parloop_338430_total_total_runtime;
    int futhark_mc_segmap_parloop_338430_total_runs;
    int64_t futhark_mc_segmap_parloop_338430_total_iter;
    int64_t *futhark_mc_segmap_nested_task_338428_total_runtime;
    int *futhark_mc_segmap_nested_task_338428_runs;
    int64_t *futhark_mc_segmap_nested_task_338428_iter;
    int64_t *futhark_mc_segmap_parloop_338442_total_runtime;
    int *futhark_mc_segmap_parloop_338442_runs;
    int64_t *futhark_mc_segmap_parloop_338442_iter;
    int64_t futhark_mc_segmap_parloop_338442_total_total_runtime;
    int futhark_mc_segmap_parloop_338442_total_runs;
    int64_t futhark_mc_segmap_parloop_338442_total_iter;
    int64_t *futhark_mc_segmap_task_338440_total_runtime;
    int *futhark_mc_segmap_task_338440_runs;
    int64_t *futhark_mc_segmap_task_338440_iter;
    int64_t futhark_mc_segmap_task_338440_total_time;
    int64_t futhark_mc_segmap_task_338440_total_iter;
    int64_t *futhark_mc_segmap_parloop_338451_total_runtime;
    int *futhark_mc_segmap_parloop_338451_runs;
    int64_t *futhark_mc_segmap_parloop_338451_iter;
    int64_t futhark_mc_segmap_parloop_338451_total_total_runtime;
    int futhark_mc_segmap_parloop_338451_total_runs;
    int64_t futhark_mc_segmap_parloop_338451_total_iter;
    int64_t *futhark_mc_segmap_task_338449_total_runtime;
    int *futhark_mc_segmap_task_338449_runs;
    int64_t *futhark_mc_segmap_task_338449_iter;
    int64_t futhark_mc_segmap_task_338449_total_time;
    int64_t futhark_mc_segmap_task_338449_total_iter;
    int64_t *futhark_mc_segred_stage_1_parloop_338459_total_runtime;
    int *futhark_mc_segred_stage_1_parloop_338459_runs;
    int64_t *futhark_mc_segred_stage_1_parloop_338459_iter;
    int64_t futhark_mc_segred_stage_1_parloop_338459_total_total_runtime;
    int futhark_mc_segred_stage_1_parloop_338459_total_runs;
    int64_t futhark_mc_segred_stage_1_parloop_338459_total_iter;
    int64_t *futhark_mc_segred_task_338456_total_runtime;
    int *futhark_mc_segred_task_338456_runs;
    int64_t *futhark_mc_segred_task_338456_iter;
    int64_t futhark_mc_segred_task_338456_total_time;
    int64_t futhark_mc_segred_task_338456_total_iter;
    int64_t *futhark_mc_segred_stage_1_parloop_338464_total_runtime;
    int *futhark_mc_segred_stage_1_parloop_338464_runs;
    int64_t *futhark_mc_segred_stage_1_parloop_338464_iter;
    int64_t futhark_mc_segred_stage_1_parloop_338464_total_total_runtime;
    int futhark_mc_segred_stage_1_parloop_338464_total_runs;
    int64_t futhark_mc_segred_stage_1_parloop_338464_total_iter;
    int64_t *futhark_mc_segred_task_338461_total_runtime;
    int *futhark_mc_segred_task_338461_runs;
    int64_t *futhark_mc_segred_task_338461_iter;
    int64_t futhark_mc_segred_task_338461_total_time;
    int64_t futhark_mc_segred_task_338461_total_iter;
    int64_t *futhark_mc_segmap_parloop_338454_total_runtime;
    int *futhark_mc_segmap_parloop_338454_runs;
    int64_t *futhark_mc_segmap_parloop_338454_iter;
    int64_t futhark_mc_segmap_parloop_338454_total_total_runtime;
    int futhark_mc_segmap_parloop_338454_total_runs;
    int64_t futhark_mc_segmap_parloop_338454_total_iter;
    int64_t *futhark_mc_segmap_nested_task_338452_total_runtime;
    int *futhark_mc_segmap_nested_task_338452_runs;
    int64_t *futhark_mc_segmap_nested_task_338452_iter;
    int64_t *futhark_mc_segmap_parloop_338446_total_runtime;
    int *futhark_mc_segmap_parloop_338446_runs;
    int64_t *futhark_mc_segmap_parloop_338446_iter;
    int64_t futhark_mc_segmap_parloop_338446_total_total_runtime;
    int futhark_mc_segmap_parloop_338446_total_runs;
    int64_t futhark_mc_segmap_parloop_338446_total_iter;
    int64_t *futhark_mc_segmap_nested_task_338444_total_runtime;
    int *futhark_mc_segmap_nested_task_338444_runs;
    int64_t *futhark_mc_segmap_nested_task_338444_iter;
    int64_t *futhark_mc_segmap_parloop_338468_total_runtime;
    int *futhark_mc_segmap_parloop_338468_runs;
    int64_t *futhark_mc_segmap_parloop_338468_iter;
    int64_t futhark_mc_segmap_parloop_338468_total_total_runtime;
    int futhark_mc_segmap_parloop_338468_total_runs;
    int64_t futhark_mc_segmap_parloop_338468_total_iter;
    int64_t *futhark_mc_segmap_task_338466_total_runtime;
    int *futhark_mc_segmap_task_338466_runs;
    int64_t *futhark_mc_segmap_task_338466_iter;
    int64_t futhark_mc_segmap_task_338466_total_time;
    int64_t futhark_mc_segmap_task_338466_total_iter;
    int64_t *futhark_mc_segmap_parloop_338479_total_runtime;
    int *futhark_mc_segmap_parloop_338479_runs;
    int64_t *futhark_mc_segmap_parloop_338479_iter;
    int64_t futhark_mc_segmap_parloop_338479_total_total_runtime;
    int futhark_mc_segmap_parloop_338479_total_runs;
    int64_t futhark_mc_segmap_parloop_338479_total_iter;
    int64_t *futhark_mc_segmap_task_338477_total_runtime;
    int *futhark_mc_segmap_task_338477_runs;
    int64_t *futhark_mc_segmap_task_338477_iter;
    int64_t futhark_mc_segmap_task_338477_total_time;
    int64_t futhark_mc_segmap_task_338477_total_iter;
    int64_t *futhark_mc_segred_stage_1_parloop_338489_total_runtime;
    int *futhark_mc_segred_stage_1_parloop_338489_runs;
    int64_t *futhark_mc_segred_stage_1_parloop_338489_iter;
    int64_t futhark_mc_segred_stage_1_parloop_338489_total_total_runtime;
    int futhark_mc_segred_stage_1_parloop_338489_total_runs;
    int64_t futhark_mc_segred_stage_1_parloop_338489_total_iter;
    int64_t *futhark_mc_segred_task_338484_total_runtime;
    int *futhark_mc_segred_task_338484_runs;
    int64_t *futhark_mc_segred_task_338484_iter;
    int64_t futhark_mc_segred_task_338484_total_time;
    int64_t futhark_mc_segred_task_338484_total_iter;
    int64_t *futhark_mc_segred_stage_1_parloop_338495_total_runtime;
    int *futhark_mc_segred_stage_1_parloop_338495_runs;
    int64_t *futhark_mc_segred_stage_1_parloop_338495_iter;
    int64_t futhark_mc_segred_stage_1_parloop_338495_total_total_runtime;
    int futhark_mc_segred_stage_1_parloop_338495_total_runs;
    int64_t futhark_mc_segred_stage_1_parloop_338495_total_iter;
    int64_t *futhark_mc_segred_task_338491_total_runtime;
    int *futhark_mc_segred_task_338491_runs;
    int64_t *futhark_mc_segred_task_338491_iter;
    int64_t futhark_mc_segred_task_338491_total_time;
    int64_t futhark_mc_segred_task_338491_total_iter;
    int64_t *futhark_mc_segmap_parloop_338482_total_runtime;
    int *futhark_mc_segmap_parloop_338482_runs;
    int64_t *futhark_mc_segmap_parloop_338482_iter;
    int64_t futhark_mc_segmap_parloop_338482_total_total_runtime;
    int futhark_mc_segmap_parloop_338482_total_runs;
    int64_t futhark_mc_segmap_parloop_338482_total_iter;
    int64_t *futhark_mc_segmap_nested_task_338480_total_runtime;
    int *futhark_mc_segmap_nested_task_338480_runs;
    int64_t *futhark_mc_segmap_nested_task_338480_iter;
    int64_t *futhark_mc_segmap_parloop_338473_total_runtime;
    int *futhark_mc_segmap_parloop_338473_runs;
    int64_t *futhark_mc_segmap_parloop_338473_iter;
    int64_t futhark_mc_segmap_parloop_338473_total_total_runtime;
    int futhark_mc_segmap_parloop_338473_total_runs;
    int64_t futhark_mc_segmap_parloop_338473_total_iter;
    int64_t *futhark_mc_segmap_nested_task_338471_total_runtime;
    int *futhark_mc_segmap_nested_task_338471_runs;
    int64_t *futhark_mc_segmap_nested_task_338471_iter;
    int64_t *futhark_mc_segmap_parloop_338499_total_runtime;
    int *futhark_mc_segmap_parloop_338499_runs;
    int64_t *futhark_mc_segmap_parloop_338499_iter;
    int64_t futhark_mc_segmap_parloop_338499_total_total_runtime;
    int futhark_mc_segmap_parloop_338499_total_runs;
    int64_t futhark_mc_segmap_parloop_338499_total_iter;
    int64_t *futhark_mc_segmap_task_338497_total_runtime;
    int *futhark_mc_segmap_task_338497_runs;
    int64_t *futhark_mc_segmap_task_338497_iter;
    int64_t futhark_mc_segmap_task_338497_total_time;
    int64_t futhark_mc_segmap_task_338497_total_iter;
    int64_t *futhark_mc_segmap_parloop_338510_total_runtime;
    int *futhark_mc_segmap_parloop_338510_runs;
    int64_t *futhark_mc_segmap_parloop_338510_iter;
    int64_t futhark_mc_segmap_parloop_338510_total_total_runtime;
    int futhark_mc_segmap_parloop_338510_total_runs;
    int64_t futhark_mc_segmap_parloop_338510_total_iter;
    int64_t *futhark_mc_segmap_task_338508_total_runtime;
    int *futhark_mc_segmap_task_338508_runs;
    int64_t *futhark_mc_segmap_task_338508_iter;
    int64_t futhark_mc_segmap_task_338508_total_time;
    int64_t futhark_mc_segmap_task_338508_total_iter;
    int64_t *futhark_mc_segred_stage_1_parloop_338522_total_runtime;
    int *futhark_mc_segred_stage_1_parloop_338522_runs;
    int64_t *futhark_mc_segred_stage_1_parloop_338522_iter;
    int64_t futhark_mc_segred_stage_1_parloop_338522_total_total_runtime;
    int futhark_mc_segred_stage_1_parloop_338522_total_runs;
    int64_t futhark_mc_segred_stage_1_parloop_338522_total_iter;
    int64_t *futhark_mc_segred_task_338515_total_runtime;
    int *futhark_mc_segred_task_338515_runs;
    int64_t *futhark_mc_segred_task_338515_iter;
    int64_t futhark_mc_segred_task_338515_total_time;
    int64_t futhark_mc_segred_task_338515_total_iter;
    int64_t *futhark_mc_segred_stage_1_parloop_338528_total_runtime;
    int *futhark_mc_segred_stage_1_parloop_338528_runs;
    int64_t *futhark_mc_segred_stage_1_parloop_338528_iter;
    int64_t futhark_mc_segred_stage_1_parloop_338528_total_total_runtime;
    int futhark_mc_segred_stage_1_parloop_338528_total_runs;
    int64_t futhark_mc_segred_stage_1_parloop_338528_total_iter;
    int64_t *futhark_mc_segred_task_338524_total_runtime;
    int *futhark_mc_segred_task_338524_runs;
    int64_t *futhark_mc_segred_task_338524_iter;
    int64_t futhark_mc_segred_task_338524_total_time;
    int64_t futhark_mc_segred_task_338524_total_iter;
    int64_t *futhark_mc_segmap_parloop_338513_total_runtime;
    int *futhark_mc_segmap_parloop_338513_runs;
    int64_t *futhark_mc_segmap_parloop_338513_iter;
    int64_t futhark_mc_segmap_parloop_338513_total_total_runtime;
    int futhark_mc_segmap_parloop_338513_total_runs;
    int64_t futhark_mc_segmap_parloop_338513_total_iter;
    int64_t *futhark_mc_segmap_nested_task_338511_total_runtime;
    int *futhark_mc_segmap_nested_task_338511_runs;
    int64_t *futhark_mc_segmap_nested_task_338511_iter;
    int64_t *futhark_mc_segmap_parloop_338504_total_runtime;
    int *futhark_mc_segmap_parloop_338504_runs;
    int64_t *futhark_mc_segmap_parloop_338504_iter;
    int64_t futhark_mc_segmap_parloop_338504_total_total_runtime;
    int futhark_mc_segmap_parloop_338504_total_runs;
    int64_t futhark_mc_segmap_parloop_338504_total_iter;
    int64_t *futhark_mc_segmap_nested_task_338502_total_runtime;
    int *futhark_mc_segmap_nested_task_338502_runs;
    int64_t *futhark_mc_segmap_nested_task_338502_iter;
    int64_t *futhark_mc_segmap_parloop_338532_total_runtime;
    int *futhark_mc_segmap_parloop_338532_runs;
    int64_t *futhark_mc_segmap_parloop_338532_iter;
    int64_t futhark_mc_segmap_parloop_338532_total_total_runtime;
    int futhark_mc_segmap_parloop_338532_total_runs;
    int64_t futhark_mc_segmap_parloop_338532_total_iter;
    int64_t *futhark_mc_segmap_task_338530_total_runtime;
    int *futhark_mc_segmap_task_338530_runs;
    int64_t *futhark_mc_segmap_task_338530_iter;
    int64_t futhark_mc_segmap_task_338530_total_time;
    int64_t futhark_mc_segmap_task_338530_total_iter;
    int64_t *futhark_mc_segmap_parloop_338542_total_runtime;
    int *futhark_mc_segmap_parloop_338542_runs;
    int64_t *futhark_mc_segmap_parloop_338542_iter;
    int64_t futhark_mc_segmap_parloop_338542_total_total_runtime;
    int futhark_mc_segmap_parloop_338542_total_runs;
    int64_t futhark_mc_segmap_parloop_338542_total_iter;
    int64_t *futhark_mc_segmap_task_338540_total_runtime;
    int *futhark_mc_segmap_task_338540_runs;
    int64_t *futhark_mc_segmap_task_338540_iter;
    int64_t futhark_mc_segmap_task_338540_total_time;
    int64_t futhark_mc_segmap_task_338540_total_iter;
    int64_t *futhark_mc_segred_stage_1_parloop_338552_total_runtime;
    int *futhark_mc_segred_stage_1_parloop_338552_runs;
    int64_t *futhark_mc_segred_stage_1_parloop_338552_iter;
    int64_t futhark_mc_segred_stage_1_parloop_338552_total_total_runtime;
    int futhark_mc_segred_stage_1_parloop_338552_total_runs;
    int64_t futhark_mc_segred_stage_1_parloop_338552_total_iter;
    int64_t *futhark_mc_segred_task_338549_total_runtime;
    int *futhark_mc_segred_task_338549_runs;
    int64_t *futhark_mc_segred_task_338549_iter;
    int64_t futhark_mc_segred_task_338549_total_time;
    int64_t futhark_mc_segred_task_338549_total_iter;
    int64_t *futhark_mc_segred_stage_1_parloop_338557_total_runtime;
    int *futhark_mc_segred_stage_1_parloop_338557_runs;
    int64_t *futhark_mc_segred_stage_1_parloop_338557_iter;
    int64_t futhark_mc_segred_stage_1_parloop_338557_total_total_runtime;
    int futhark_mc_segred_stage_1_parloop_338557_total_runs;
    int64_t futhark_mc_segred_stage_1_parloop_338557_total_iter;
    int64_t *futhark_mc_segred_task_338554_total_runtime;
    int *futhark_mc_segred_task_338554_runs;
    int64_t *futhark_mc_segred_task_338554_iter;
    int64_t futhark_mc_segred_task_338554_total_time;
    int64_t futhark_mc_segred_task_338554_total_iter;
    int64_t *futhark_mc_segmap_parloop_338546_total_runtime;
    int *futhark_mc_segmap_parloop_338546_runs;
    int64_t *futhark_mc_segmap_parloop_338546_iter;
    int64_t futhark_mc_segmap_parloop_338546_total_total_runtime;
    int futhark_mc_segmap_parloop_338546_total_runs;
    int64_t futhark_mc_segmap_parloop_338546_total_iter;
    int64_t *futhark_mc_segmap_nested_task_338544_total_runtime;
    int *futhark_mc_segmap_nested_task_338544_runs;
    int64_t *futhark_mc_segmap_nested_task_338544_iter;
    int64_t *futhark_mc_segmap_parloop_338537_total_runtime;
    int *futhark_mc_segmap_parloop_338537_runs;
    int64_t *futhark_mc_segmap_parloop_338537_iter;
    int64_t futhark_mc_segmap_parloop_338537_total_total_runtime;
    int futhark_mc_segmap_parloop_338537_total_runs;
    int64_t futhark_mc_segmap_parloop_338537_total_iter;
    int64_t *futhark_mc_segmap_nested_task_338535_total_runtime;
    int *futhark_mc_segmap_nested_task_338535_runs;
    int64_t *futhark_mc_segmap_nested_task_338535_iter;
    int64_t *futhark_mc_segmap_parloop_338561_total_runtime;
    int *futhark_mc_segmap_parloop_338561_runs;
    int64_t *futhark_mc_segmap_parloop_338561_iter;
    int64_t futhark_mc_segmap_parloop_338561_total_total_runtime;
    int futhark_mc_segmap_parloop_338561_total_runs;
    int64_t futhark_mc_segmap_parloop_338561_total_iter;
    int64_t *futhark_mc_segmap_task_338559_total_runtime;
    int *futhark_mc_segmap_task_338559_runs;
    int64_t *futhark_mc_segmap_task_338559_iter;
    int64_t futhark_mc_segmap_task_338559_total_time;
    int64_t futhark_mc_segmap_task_338559_total_iter;
    int64_t *futhark_mc_segmap_parloop_338574_total_runtime;
    int *futhark_mc_segmap_parloop_338574_runs;
    int64_t *futhark_mc_segmap_parloop_338574_iter;
    int64_t futhark_mc_segmap_parloop_338574_total_total_runtime;
    int futhark_mc_segmap_parloop_338574_total_runs;
    int64_t futhark_mc_segmap_parloop_338574_total_iter;
    int64_t *futhark_mc_segmap_task_338572_total_runtime;
    int *futhark_mc_segmap_task_338572_runs;
    int64_t *futhark_mc_segmap_task_338572_iter;
    int64_t futhark_mc_segmap_task_338572_total_time;
    int64_t futhark_mc_segmap_task_338572_total_iter;
    int64_t *futhark_mc_segred_stage_1_parloop_338588_total_runtime;
    int *futhark_mc_segred_stage_1_parloop_338588_runs;
    int64_t *futhark_mc_segred_stage_1_parloop_338588_iter;
    int64_t futhark_mc_segred_stage_1_parloop_338588_total_total_runtime;
    int futhark_mc_segred_stage_1_parloop_338588_total_runs;
    int64_t futhark_mc_segred_stage_1_parloop_338588_total_iter;
    int64_t *futhark_mc_segred_task_338583_total_runtime;
    int *futhark_mc_segred_task_338583_runs;
    int64_t *futhark_mc_segred_task_338583_iter;
    int64_t futhark_mc_segred_task_338583_total_time;
    int64_t futhark_mc_segred_task_338583_total_iter;
    int64_t *futhark_mc_segred_stage_1_parloop_338594_total_runtime;
    int *futhark_mc_segred_stage_1_parloop_338594_runs;
    int64_t *futhark_mc_segred_stage_1_parloop_338594_iter;
    int64_t futhark_mc_segred_stage_1_parloop_338594_total_total_runtime;
    int futhark_mc_segred_stage_1_parloop_338594_total_runs;
    int64_t futhark_mc_segred_stage_1_parloop_338594_total_iter;
    int64_t *futhark_mc_segred_task_338590_total_runtime;
    int *futhark_mc_segred_task_338590_runs;
    int64_t *futhark_mc_segred_task_338590_iter;
    int64_t futhark_mc_segred_task_338590_total_time;
    int64_t futhark_mc_segred_task_338590_total_iter;
    int64_t *futhark_mc_segmap_parloop_338579_total_runtime;
    int *futhark_mc_segmap_parloop_338579_runs;
    int64_t *futhark_mc_segmap_parloop_338579_iter;
    int64_t futhark_mc_segmap_parloop_338579_total_total_runtime;
    int futhark_mc_segmap_parloop_338579_total_runs;
    int64_t futhark_mc_segmap_parloop_338579_total_iter;
    int64_t *futhark_mc_segmap_nested_task_338577_total_runtime;
    int *futhark_mc_segmap_nested_task_338577_runs;
    int64_t *futhark_mc_segmap_nested_task_338577_iter;
    int64_t *futhark_mc_segmap_parloop_338568_total_runtime;
    int *futhark_mc_segmap_parloop_338568_runs;
    int64_t *futhark_mc_segmap_parloop_338568_iter;
    int64_t futhark_mc_segmap_parloop_338568_total_total_runtime;
    int futhark_mc_segmap_parloop_338568_total_runs;
    int64_t futhark_mc_segmap_parloop_338568_total_iter;
    int64_t *futhark_mc_segmap_nested_task_338566_total_runtime;
    int *futhark_mc_segmap_nested_task_338566_runs;
    int64_t *futhark_mc_segmap_nested_task_338566_iter;
    int64_t *futhark_mc_segmap_parloop_338598_total_runtime;
    int *futhark_mc_segmap_parloop_338598_runs;
    int64_t *futhark_mc_segmap_parloop_338598_iter;
    int64_t futhark_mc_segmap_parloop_338598_total_total_runtime;
    int futhark_mc_segmap_parloop_338598_total_runs;
    int64_t futhark_mc_segmap_parloop_338598_total_iter;
    int64_t *futhark_mc_segmap_task_338596_total_runtime;
    int *futhark_mc_segmap_task_338596_runs;
    int64_t *futhark_mc_segmap_task_338596_iter;
    int64_t futhark_mc_segmap_task_338596_total_time;
    int64_t futhark_mc_segmap_task_338596_total_iter;
    int64_t *futhark_mc_segmap_parloop_338613_total_runtime;
    int *futhark_mc_segmap_parloop_338613_runs;
    int64_t *futhark_mc_segmap_parloop_338613_iter;
    int64_t futhark_mc_segmap_parloop_338613_total_total_runtime;
    int futhark_mc_segmap_parloop_338613_total_runs;
    int64_t futhark_mc_segmap_parloop_338613_total_iter;
    int64_t *futhark_mc_segmap_task_338611_total_runtime;
    int *futhark_mc_segmap_task_338611_runs;
    int64_t *futhark_mc_segmap_task_338611_iter;
    int64_t futhark_mc_segmap_task_338611_total_time;
    int64_t futhark_mc_segmap_task_338611_total_iter;
    int64_t *futhark_mc_segmap_parloop_338628_total_runtime;
    int *futhark_mc_segmap_parloop_338628_runs;
    int64_t *futhark_mc_segmap_parloop_338628_iter;
    int64_t futhark_mc_segmap_parloop_338628_total_total_runtime;
    int futhark_mc_segmap_parloop_338628_total_runs;
    int64_t futhark_mc_segmap_parloop_338628_total_iter;
    int64_t *futhark_mc_segmap_task_338626_total_runtime;
    int *futhark_mc_segmap_task_338626_runs;
    int64_t *futhark_mc_segmap_task_338626_iter;
    int64_t futhark_mc_segmap_task_338626_total_time;
    int64_t futhark_mc_segmap_task_338626_total_iter;
    int64_t *futhark_mc_segred_stage_1_parloop_338637_total_runtime;
    int *futhark_mc_segred_stage_1_parloop_338637_runs;
    int64_t *futhark_mc_segred_stage_1_parloop_338637_iter;
    int64_t futhark_mc_segred_stage_1_parloop_338637_total_total_runtime;
    int futhark_mc_segred_stage_1_parloop_338637_total_runs;
    int64_t futhark_mc_segred_stage_1_parloop_338637_total_iter;
    int64_t *futhark_mc_segred_task_338630_total_runtime;
    int *futhark_mc_segred_task_338630_runs;
    int64_t *futhark_mc_segred_task_338630_iter;
    int64_t futhark_mc_segred_task_338630_total_time;
    int64_t futhark_mc_segred_task_338630_total_iter;
    int64_t *futhark_mc_segred_stage_1_parloop_338643_total_runtime;
    int *futhark_mc_segred_stage_1_parloop_338643_runs;
    int64_t *futhark_mc_segred_stage_1_parloop_338643_iter;
    int64_t futhark_mc_segred_stage_1_parloop_338643_total_total_runtime;
    int futhark_mc_segred_stage_1_parloop_338643_total_runs;
    int64_t futhark_mc_segred_stage_1_parloop_338643_total_iter;
    int64_t *futhark_mc_segred_task_338639_total_runtime;
    int *futhark_mc_segred_task_338639_runs;
    int64_t *futhark_mc_segred_task_338639_iter;
    int64_t futhark_mc_segred_task_338639_total_time;
    int64_t futhark_mc_segred_task_338639_total_iter;
    int64_t *futhark_mc_segmap_parloop_338620_total_runtime;
    int *futhark_mc_segmap_parloop_338620_runs;
    int64_t *futhark_mc_segmap_parloop_338620_iter;
    int64_t futhark_mc_segmap_parloop_338620_total_total_runtime;
    int futhark_mc_segmap_parloop_338620_total_runs;
    int64_t futhark_mc_segmap_parloop_338620_total_iter;
    int64_t *futhark_mc_segmap_nested_task_338618_total_runtime;
    int *futhark_mc_segmap_nested_task_338618_runs;
    int64_t *futhark_mc_segmap_nested_task_338618_iter;
    int64_t *futhark_mc_segmap_parloop_338607_total_runtime;
    int *futhark_mc_segmap_parloop_338607_runs;
    int64_t *futhark_mc_segmap_parloop_338607_iter;
    int64_t futhark_mc_segmap_parloop_338607_total_total_runtime;
    int futhark_mc_segmap_parloop_338607_total_runs;
    int64_t futhark_mc_segmap_parloop_338607_total_iter;
    int64_t *futhark_mc_segmap_nested_task_338605_total_runtime;
    int *futhark_mc_segmap_nested_task_338605_runs;
    int64_t *futhark_mc_segmap_nested_task_338605_iter;
    int64_t *futhark_mc_segmap_parloop_338647_total_runtime;
    int *futhark_mc_segmap_parloop_338647_runs;
    int64_t *futhark_mc_segmap_parloop_338647_iter;
    int64_t futhark_mc_segmap_parloop_338647_total_total_runtime;
    int futhark_mc_segmap_parloop_338647_total_runs;
    int64_t futhark_mc_segmap_parloop_338647_total_iter;
    int64_t *futhark_mc_segmap_task_338645_total_runtime;
    int *futhark_mc_segmap_task_338645_runs;
    int64_t *futhark_mc_segmap_task_338645_iter;
    int64_t futhark_mc_segmap_task_338645_total_time;
    int64_t futhark_mc_segmap_task_338645_total_iter;
    int64_t *futhark_mc_segmap_parloop_338656_total_runtime;
    int *futhark_mc_segmap_parloop_338656_runs;
    int64_t *futhark_mc_segmap_parloop_338656_iter;
    int64_t futhark_mc_segmap_parloop_338656_total_total_runtime;
    int futhark_mc_segmap_parloop_338656_total_runs;
    int64_t futhark_mc_segmap_parloop_338656_total_iter;
    int64_t *futhark_mc_segmap_task_338654_total_runtime;
    int *futhark_mc_segmap_task_338654_runs;
    int64_t *futhark_mc_segmap_task_338654_iter;
    int64_t futhark_mc_segmap_task_338654_total_time;
    int64_t futhark_mc_segmap_task_338654_total_iter;
    int64_t *futhark_mc_segred_stage_1_parloop_338664_total_runtime;
    int *futhark_mc_segred_stage_1_parloop_338664_runs;
    int64_t *futhark_mc_segred_stage_1_parloop_338664_iter;
    int64_t futhark_mc_segred_stage_1_parloop_338664_total_total_runtime;
    int futhark_mc_segred_stage_1_parloop_338664_total_runs;
    int64_t futhark_mc_segred_stage_1_parloop_338664_total_iter;
    int64_t *futhark_mc_segred_task_338661_total_runtime;
    int *futhark_mc_segred_task_338661_runs;
    int64_t *futhark_mc_segred_task_338661_iter;
    int64_t futhark_mc_segred_task_338661_total_time;
    int64_t futhark_mc_segred_task_338661_total_iter;
    int64_t *futhark_mc_segred_stage_1_parloop_338669_total_runtime;
    int *futhark_mc_segred_stage_1_parloop_338669_runs;
    int64_t *futhark_mc_segred_stage_1_parloop_338669_iter;
    int64_t futhark_mc_segred_stage_1_parloop_338669_total_total_runtime;
    int futhark_mc_segred_stage_1_parloop_338669_total_runs;
    int64_t futhark_mc_segred_stage_1_parloop_338669_total_iter;
    int64_t *futhark_mc_segred_task_338666_total_runtime;
    int *futhark_mc_segred_task_338666_runs;
    int64_t *futhark_mc_segred_task_338666_iter;
    int64_t futhark_mc_segred_task_338666_total_time;
    int64_t futhark_mc_segred_task_338666_total_iter;
    int64_t *futhark_mc_segmap_parloop_338659_total_runtime;
    int *futhark_mc_segmap_parloop_338659_runs;
    int64_t *futhark_mc_segmap_parloop_338659_iter;
    int64_t futhark_mc_segmap_parloop_338659_total_total_runtime;
    int futhark_mc_segmap_parloop_338659_total_runs;
    int64_t futhark_mc_segmap_parloop_338659_total_iter;
    int64_t *futhark_mc_segmap_nested_task_338657_total_runtime;
    int *futhark_mc_segmap_nested_task_338657_runs;
    int64_t *futhark_mc_segmap_nested_task_338657_iter;
    int64_t *futhark_mc_segmap_parloop_338651_total_runtime;
    int *futhark_mc_segmap_parloop_338651_runs;
    int64_t *futhark_mc_segmap_parloop_338651_iter;
    int64_t futhark_mc_segmap_parloop_338651_total_total_runtime;
    int futhark_mc_segmap_parloop_338651_total_runs;
    int64_t futhark_mc_segmap_parloop_338651_total_iter;
    int64_t *futhark_mc_segmap_nested_task_338649_total_runtime;
    int *futhark_mc_segmap_nested_task_338649_runs;
    int64_t *futhark_mc_segmap_nested_task_338649_iter;
    int64_t *futhark_mc_segmap_parloop_338673_total_runtime;
    int *futhark_mc_segmap_parloop_338673_runs;
    int64_t *futhark_mc_segmap_parloop_338673_iter;
    int64_t futhark_mc_segmap_parloop_338673_total_total_runtime;
    int futhark_mc_segmap_parloop_338673_total_runs;
    int64_t futhark_mc_segmap_parloop_338673_total_iter;
    int64_t *futhark_mc_segmap_task_338671_total_runtime;
    int *futhark_mc_segmap_task_338671_runs;
    int64_t *futhark_mc_segmap_task_338671_iter;
    int64_t futhark_mc_segmap_task_338671_total_time;
    int64_t futhark_mc_segmap_task_338671_total_iter;
    int64_t *futhark_mc_segmap_parloop_338684_total_runtime;
    int *futhark_mc_segmap_parloop_338684_runs;
    int64_t *futhark_mc_segmap_parloop_338684_iter;
    int64_t futhark_mc_segmap_parloop_338684_total_total_runtime;
    int futhark_mc_segmap_parloop_338684_total_runs;
    int64_t futhark_mc_segmap_parloop_338684_total_iter;
    int64_t *futhark_mc_segmap_task_338682_total_runtime;
    int *futhark_mc_segmap_task_338682_runs;
    int64_t *futhark_mc_segmap_task_338682_iter;
    int64_t futhark_mc_segmap_task_338682_total_time;
    int64_t futhark_mc_segmap_task_338682_total_iter;
    int64_t *futhark_mc_segred_stage_1_parloop_338694_total_runtime;
    int *futhark_mc_segred_stage_1_parloop_338694_runs;
    int64_t *futhark_mc_segred_stage_1_parloop_338694_iter;
    int64_t futhark_mc_segred_stage_1_parloop_338694_total_total_runtime;
    int futhark_mc_segred_stage_1_parloop_338694_total_runs;
    int64_t futhark_mc_segred_stage_1_parloop_338694_total_iter;
    int64_t *futhark_mc_segred_task_338689_total_runtime;
    int *futhark_mc_segred_task_338689_runs;
    int64_t *futhark_mc_segred_task_338689_iter;
    int64_t futhark_mc_segred_task_338689_total_time;
    int64_t futhark_mc_segred_task_338689_total_iter;
    int64_t *futhark_mc_segred_stage_1_parloop_338700_total_runtime;
    int *futhark_mc_segred_stage_1_parloop_338700_runs;
    int64_t *futhark_mc_segred_stage_1_parloop_338700_iter;
    int64_t futhark_mc_segred_stage_1_parloop_338700_total_total_runtime;
    int futhark_mc_segred_stage_1_parloop_338700_total_runs;
    int64_t futhark_mc_segred_stage_1_parloop_338700_total_iter;
    int64_t *futhark_mc_segred_task_338696_total_runtime;
    int *futhark_mc_segred_task_338696_runs;
    int64_t *futhark_mc_segred_task_338696_iter;
    int64_t futhark_mc_segred_task_338696_total_time;
    int64_t futhark_mc_segred_task_338696_total_iter;
    int64_t *futhark_mc_segmap_parloop_338687_total_runtime;
    int *futhark_mc_segmap_parloop_338687_runs;
    int64_t *futhark_mc_segmap_parloop_338687_iter;
    int64_t futhark_mc_segmap_parloop_338687_total_total_runtime;
    int futhark_mc_segmap_parloop_338687_total_runs;
    int64_t futhark_mc_segmap_parloop_338687_total_iter;
    int64_t *futhark_mc_segmap_nested_task_338685_total_runtime;
    int *futhark_mc_segmap_nested_task_338685_runs;
    int64_t *futhark_mc_segmap_nested_task_338685_iter;
    int64_t *futhark_mc_segmap_parloop_338678_total_runtime;
    int *futhark_mc_segmap_parloop_338678_runs;
    int64_t *futhark_mc_segmap_parloop_338678_iter;
    int64_t futhark_mc_segmap_parloop_338678_total_total_runtime;
    int futhark_mc_segmap_parloop_338678_total_runs;
    int64_t futhark_mc_segmap_parloop_338678_total_iter;
    int64_t *futhark_mc_segmap_nested_task_338676_total_runtime;
    int *futhark_mc_segmap_nested_task_338676_runs;
    int64_t *futhark_mc_segmap_nested_task_338676_iter;
    int64_t *futhark_mc_segmap_parloop_338704_total_runtime;
    int *futhark_mc_segmap_parloop_338704_runs;
    int64_t *futhark_mc_segmap_parloop_338704_iter;
    int64_t futhark_mc_segmap_parloop_338704_total_total_runtime;
    int futhark_mc_segmap_parloop_338704_total_runs;
    int64_t futhark_mc_segmap_parloop_338704_total_iter;
    int64_t *futhark_mc_segmap_task_338702_total_runtime;
    int *futhark_mc_segmap_task_338702_runs;
    int64_t *futhark_mc_segmap_task_338702_iter;
    int64_t futhark_mc_segmap_task_338702_total_time;
    int64_t futhark_mc_segmap_task_338702_total_iter;
    int64_t *futhark_mc_segmap_parloop_338715_total_runtime;
    int *futhark_mc_segmap_parloop_338715_runs;
    int64_t *futhark_mc_segmap_parloop_338715_iter;
    int64_t futhark_mc_segmap_parloop_338715_total_total_runtime;
    int futhark_mc_segmap_parloop_338715_total_runs;
    int64_t futhark_mc_segmap_parloop_338715_total_iter;
    int64_t *futhark_mc_segmap_task_338713_total_runtime;
    int *futhark_mc_segmap_task_338713_runs;
    int64_t *futhark_mc_segmap_task_338713_iter;
    int64_t futhark_mc_segmap_task_338713_total_time;
    int64_t futhark_mc_segmap_task_338713_total_iter;
    int64_t *futhark_mc_segred_stage_1_parloop_338727_total_runtime;
    int *futhark_mc_segred_stage_1_parloop_338727_runs;
    int64_t *futhark_mc_segred_stage_1_parloop_338727_iter;
    int64_t futhark_mc_segred_stage_1_parloop_338727_total_total_runtime;
    int futhark_mc_segred_stage_1_parloop_338727_total_runs;
    int64_t futhark_mc_segred_stage_1_parloop_338727_total_iter;
    int64_t *futhark_mc_segred_task_338720_total_runtime;
    int *futhark_mc_segred_task_338720_runs;
    int64_t *futhark_mc_segred_task_338720_iter;
    int64_t futhark_mc_segred_task_338720_total_time;
    int64_t futhark_mc_segred_task_338720_total_iter;
    int64_t *futhark_mc_segred_stage_1_parloop_338733_total_runtime;
    int *futhark_mc_segred_stage_1_parloop_338733_runs;
    int64_t *futhark_mc_segred_stage_1_parloop_338733_iter;
    int64_t futhark_mc_segred_stage_1_parloop_338733_total_total_runtime;
    int futhark_mc_segred_stage_1_parloop_338733_total_runs;
    int64_t futhark_mc_segred_stage_1_parloop_338733_total_iter;
    int64_t *futhark_mc_segred_task_338729_total_runtime;
    int *futhark_mc_segred_task_338729_runs;
    int64_t *futhark_mc_segred_task_338729_iter;
    int64_t futhark_mc_segred_task_338729_total_time;
    int64_t futhark_mc_segred_task_338729_total_iter;
    int64_t *futhark_mc_segmap_parloop_338718_total_runtime;
    int *futhark_mc_segmap_parloop_338718_runs;
    int64_t *futhark_mc_segmap_parloop_338718_iter;
    int64_t futhark_mc_segmap_parloop_338718_total_total_runtime;
    int futhark_mc_segmap_parloop_338718_total_runs;
    int64_t futhark_mc_segmap_parloop_338718_total_iter;
    int64_t *futhark_mc_segmap_nested_task_338716_total_runtime;
    int *futhark_mc_segmap_nested_task_338716_runs;
    int64_t *futhark_mc_segmap_nested_task_338716_iter;
    int64_t *futhark_mc_segmap_parloop_338709_total_runtime;
    int *futhark_mc_segmap_parloop_338709_runs;
    int64_t *futhark_mc_segmap_parloop_338709_iter;
    int64_t futhark_mc_segmap_parloop_338709_total_total_runtime;
    int futhark_mc_segmap_parloop_338709_total_runs;
    int64_t futhark_mc_segmap_parloop_338709_total_iter;
    int64_t *futhark_mc_segmap_nested_task_338707_total_runtime;
    int *futhark_mc_segmap_nested_task_338707_runs;
    int64_t *futhark_mc_segmap_nested_task_338707_iter;
    int64_t *futhark_mc_segmap_parloop_338737_total_runtime;
    int *futhark_mc_segmap_parloop_338737_runs;
    int64_t *futhark_mc_segmap_parloop_338737_iter;
    int64_t futhark_mc_segmap_parloop_338737_total_total_runtime;
    int futhark_mc_segmap_parloop_338737_total_runs;
    int64_t futhark_mc_segmap_parloop_338737_total_iter;
    int64_t *futhark_mc_segmap_task_338735_total_runtime;
    int *futhark_mc_segmap_task_338735_runs;
    int64_t *futhark_mc_segmap_task_338735_iter;
    int64_t futhark_mc_segmap_task_338735_total_time;
    int64_t futhark_mc_segmap_task_338735_total_iter;
    int64_t *futhark_mc_segmap_parloop_338746_total_runtime;
    int *futhark_mc_segmap_parloop_338746_runs;
    int64_t *futhark_mc_segmap_parloop_338746_iter;
    int64_t futhark_mc_segmap_parloop_338746_total_total_runtime;
    int futhark_mc_segmap_parloop_338746_total_runs;
    int64_t futhark_mc_segmap_parloop_338746_total_iter;
    int64_t *futhark_mc_segmap_task_338744_total_runtime;
    int *futhark_mc_segmap_task_338744_runs;
    int64_t *futhark_mc_segmap_task_338744_iter;
    int64_t futhark_mc_segmap_task_338744_total_time;
    int64_t futhark_mc_segmap_task_338744_total_iter;
    int64_t *futhark_mc_segmap_parloop_338741_total_runtime;
    int *futhark_mc_segmap_parloop_338741_runs;
    int64_t *futhark_mc_segmap_parloop_338741_iter;
    int64_t futhark_mc_segmap_parloop_338741_total_total_runtime;
    int futhark_mc_segmap_parloop_338741_total_runs;
    int64_t futhark_mc_segmap_parloop_338741_total_iter;
    int64_t *futhark_mc_segmap_nested_task_338739_total_runtime;
    int *futhark_mc_segmap_nested_task_338739_runs;
    int64_t *futhark_mc_segmap_nested_task_338739_iter;
    int64_t *futhark_mc_segmap_parloop_338750_total_runtime;
    int *futhark_mc_segmap_parloop_338750_runs;
    int64_t *futhark_mc_segmap_parloop_338750_iter;
    int64_t futhark_mc_segmap_parloop_338750_total_total_runtime;
    int futhark_mc_segmap_parloop_338750_total_runs;
    int64_t futhark_mc_segmap_parloop_338750_total_iter;
    int64_t *futhark_mc_segmap_task_338748_total_runtime;
    int *futhark_mc_segmap_task_338748_runs;
    int64_t *futhark_mc_segmap_task_338748_iter;
    int64_t futhark_mc_segmap_task_338748_total_time;
    int64_t futhark_mc_segmap_task_338748_total_iter;
    int64_t *futhark_mc_segmap_parloop_338759_total_runtime;
    int *futhark_mc_segmap_parloop_338759_runs;
    int64_t *futhark_mc_segmap_parloop_338759_iter;
    int64_t futhark_mc_segmap_parloop_338759_total_total_runtime;
    int futhark_mc_segmap_parloop_338759_total_runs;
    int64_t futhark_mc_segmap_parloop_338759_total_iter;
    int64_t *futhark_mc_segmap_task_338757_total_runtime;
    int *futhark_mc_segmap_task_338757_runs;
    int64_t *futhark_mc_segmap_task_338757_iter;
    int64_t futhark_mc_segmap_task_338757_total_time;
    int64_t futhark_mc_segmap_task_338757_total_iter;
    int64_t *futhark_mc_segmap_parloop_338754_total_runtime;
    int *futhark_mc_segmap_parloop_338754_runs;
    int64_t *futhark_mc_segmap_parloop_338754_iter;
    int64_t futhark_mc_segmap_parloop_338754_total_total_runtime;
    int futhark_mc_segmap_parloop_338754_total_runs;
    int64_t futhark_mc_segmap_parloop_338754_total_iter;
    int64_t *futhark_mc_segmap_nested_task_338752_total_runtime;
    int *futhark_mc_segmap_nested_task_338752_runs;
    int64_t *futhark_mc_segmap_nested_task_338752_iter;
    int64_t *futhark_mc_segmap_parloop_338763_total_runtime;
    int *futhark_mc_segmap_parloop_338763_runs;
    int64_t *futhark_mc_segmap_parloop_338763_iter;
    int64_t futhark_mc_segmap_parloop_338763_total_total_runtime;
    int futhark_mc_segmap_parloop_338763_total_runs;
    int64_t futhark_mc_segmap_parloop_338763_total_iter;
    int64_t *futhark_mc_segmap_task_338761_total_runtime;
    int *futhark_mc_segmap_task_338761_runs;
    int64_t *futhark_mc_segmap_task_338761_iter;
    int64_t futhark_mc_segmap_task_338761_total_time;
    int64_t futhark_mc_segmap_task_338761_total_iter;
    int64_t *futhark_mc_segmap_parloop_338778_total_runtime;
    int *futhark_mc_segmap_parloop_338778_runs;
    int64_t *futhark_mc_segmap_parloop_338778_iter;
    int64_t futhark_mc_segmap_parloop_338778_total_total_runtime;
    int futhark_mc_segmap_parloop_338778_total_runs;
    int64_t futhark_mc_segmap_parloop_338778_total_iter;
    int64_t *futhark_mc_segmap_task_338776_total_runtime;
    int *futhark_mc_segmap_task_338776_runs;
    int64_t *futhark_mc_segmap_task_338776_iter;
    int64_t futhark_mc_segmap_task_338776_total_time;
    int64_t futhark_mc_segmap_task_338776_total_iter;
    int64_t *futhark_mc_segmap_parloop_338782_total_runtime;
    int *futhark_mc_segmap_parloop_338782_runs;
    int64_t *futhark_mc_segmap_parloop_338782_iter;
    int64_t futhark_mc_segmap_parloop_338782_total_total_runtime;
    int futhark_mc_segmap_parloop_338782_total_runs;
    int64_t futhark_mc_segmap_parloop_338782_total_iter;
    int64_t *futhark_mc_segmap_task_338780_total_runtime;
    int *futhark_mc_segmap_task_338780_runs;
    int64_t *futhark_mc_segmap_task_338780_iter;
    int64_t futhark_mc_segmap_task_338780_total_time;
    int64_t futhark_mc_segmap_task_338780_total_iter;
    int64_t *futhark_mc_segmap_parloop_338786_total_runtime;
    int *futhark_mc_segmap_parloop_338786_runs;
    int64_t *futhark_mc_segmap_parloop_338786_iter;
    int64_t futhark_mc_segmap_parloop_338786_total_total_runtime;
    int futhark_mc_segmap_parloop_338786_total_runs;
    int64_t futhark_mc_segmap_parloop_338786_total_iter;
    int64_t *futhark_mc_segmap_task_338784_total_runtime;
    int *futhark_mc_segmap_task_338784_runs;
    int64_t *futhark_mc_segmap_task_338784_iter;
    int64_t futhark_mc_segmap_task_338784_total_time;
    int64_t futhark_mc_segmap_task_338784_total_iter;
    int64_t *futhark_mc_segred_stage_1_parloop_338794_total_runtime;
    int *futhark_mc_segred_stage_1_parloop_338794_runs;
    int64_t *futhark_mc_segred_stage_1_parloop_338794_iter;
    int64_t futhark_mc_segred_stage_1_parloop_338794_total_total_runtime;
    int futhark_mc_segred_stage_1_parloop_338794_total_runs;
    int64_t futhark_mc_segred_stage_1_parloop_338794_total_iter;
    int64_t *futhark_mc_segred_task_338791_total_runtime;
    int *futhark_mc_segred_task_338791_runs;
    int64_t *futhark_mc_segred_task_338791_iter;
    int64_t futhark_mc_segred_task_338791_total_time;
    int64_t futhark_mc_segred_task_338791_total_iter;
    int64_t *futhark_mc_segred_stage_1_parloop_338799_total_runtime;
    int *futhark_mc_segred_stage_1_parloop_338799_runs;
    int64_t *futhark_mc_segred_stage_1_parloop_338799_iter;
    int64_t futhark_mc_segred_stage_1_parloop_338799_total_total_runtime;
    int futhark_mc_segred_stage_1_parloop_338799_total_runs;
    int64_t futhark_mc_segred_stage_1_parloop_338799_total_iter;
    int64_t *futhark_mc_segred_task_338796_total_runtime;
    int *futhark_mc_segred_task_338796_runs;
    int64_t *futhark_mc_segred_task_338796_iter;
    int64_t futhark_mc_segred_task_338796_total_time;
    int64_t futhark_mc_segred_task_338796_total_iter;
    int64_t *futhark_mc_segmap_parloop_338789_total_runtime;
    int *futhark_mc_segmap_parloop_338789_runs;
    int64_t *futhark_mc_segmap_parloop_338789_iter;
    int64_t futhark_mc_segmap_parloop_338789_total_total_runtime;
    int futhark_mc_segmap_parloop_338789_total_runs;
    int64_t futhark_mc_segmap_parloop_338789_total_iter;
    int64_t *futhark_mc_segmap_nested_task_338787_total_runtime;
    int *futhark_mc_segmap_nested_task_338787_runs;
    int64_t *futhark_mc_segmap_nested_task_338787_iter;
    int64_t *futhark_mc_segmap_parloop_338770_total_runtime;
    int *futhark_mc_segmap_parloop_338770_runs;
    int64_t *futhark_mc_segmap_parloop_338770_iter;
    int64_t futhark_mc_segmap_parloop_338770_total_total_runtime;
    int futhark_mc_segmap_parloop_338770_total_runs;
    int64_t futhark_mc_segmap_parloop_338770_total_iter;
    int64_t *futhark_mc_segmap_nested_task_338768_total_runtime;
    int *futhark_mc_segmap_nested_task_338768_runs;
    int64_t *futhark_mc_segmap_nested_task_338768_iter;
    int64_t *futhark_mc_segmap_parloop_338803_total_runtime;
    int *futhark_mc_segmap_parloop_338803_runs;
    int64_t *futhark_mc_segmap_parloop_338803_iter;
    int64_t futhark_mc_segmap_parloop_338803_total_total_runtime;
    int futhark_mc_segmap_parloop_338803_total_runs;
    int64_t futhark_mc_segmap_parloop_338803_total_iter;
    int64_t *futhark_mc_segmap_task_338801_total_runtime;
    int *futhark_mc_segmap_task_338801_runs;
    int64_t *futhark_mc_segmap_task_338801_iter;
    int64_t futhark_mc_segmap_task_338801_total_time;
    int64_t futhark_mc_segmap_task_338801_total_iter;
    int64_t *futhark_mc_segmap_parloop_338820_total_runtime;
    int *futhark_mc_segmap_parloop_338820_runs;
    int64_t *futhark_mc_segmap_parloop_338820_iter;
    int64_t futhark_mc_segmap_parloop_338820_total_total_runtime;
    int futhark_mc_segmap_parloop_338820_total_runs;
    int64_t futhark_mc_segmap_parloop_338820_total_iter;
    int64_t *futhark_mc_segmap_task_338818_total_runtime;
    int *futhark_mc_segmap_task_338818_runs;
    int64_t *futhark_mc_segmap_task_338818_iter;
    int64_t futhark_mc_segmap_task_338818_total_time;
    int64_t futhark_mc_segmap_task_338818_total_iter;
    int64_t *futhark_mc_segmap_parloop_338824_total_runtime;
    int *futhark_mc_segmap_parloop_338824_runs;
    int64_t *futhark_mc_segmap_parloop_338824_iter;
    int64_t futhark_mc_segmap_parloop_338824_total_total_runtime;
    int futhark_mc_segmap_parloop_338824_total_runs;
    int64_t futhark_mc_segmap_parloop_338824_total_iter;
    int64_t *futhark_mc_segmap_task_338822_total_runtime;
    int *futhark_mc_segmap_task_338822_runs;
    int64_t *futhark_mc_segmap_task_338822_iter;
    int64_t futhark_mc_segmap_task_338822_total_time;
    int64_t futhark_mc_segmap_task_338822_total_iter;
    int64_t *futhark_mc_segmap_parloop_338828_total_runtime;
    int *futhark_mc_segmap_parloop_338828_runs;
    int64_t *futhark_mc_segmap_parloop_338828_iter;
    int64_t futhark_mc_segmap_parloop_338828_total_total_runtime;
    int futhark_mc_segmap_parloop_338828_total_runs;
    int64_t futhark_mc_segmap_parloop_338828_total_iter;
    int64_t *futhark_mc_segmap_task_338826_total_runtime;
    int *futhark_mc_segmap_task_338826_runs;
    int64_t *futhark_mc_segmap_task_338826_iter;
    int64_t futhark_mc_segmap_task_338826_total_time;
    int64_t futhark_mc_segmap_task_338826_total_iter;
    int64_t *futhark_mc_segred_stage_1_parloop_338838_total_runtime;
    int *futhark_mc_segred_stage_1_parloop_338838_runs;
    int64_t *futhark_mc_segred_stage_1_parloop_338838_iter;
    int64_t futhark_mc_segred_stage_1_parloop_338838_total_total_runtime;
    int futhark_mc_segred_stage_1_parloop_338838_total_runs;
    int64_t futhark_mc_segred_stage_1_parloop_338838_total_iter;
    int64_t *futhark_mc_segred_task_338833_total_runtime;
    int *futhark_mc_segred_task_338833_runs;
    int64_t *futhark_mc_segred_task_338833_iter;
    int64_t futhark_mc_segred_task_338833_total_time;
    int64_t futhark_mc_segred_task_338833_total_iter;
    int64_t *futhark_mc_segred_stage_1_parloop_338844_total_runtime;
    int *futhark_mc_segred_stage_1_parloop_338844_runs;
    int64_t *futhark_mc_segred_stage_1_parloop_338844_iter;
    int64_t futhark_mc_segred_stage_1_parloop_338844_total_total_runtime;
    int futhark_mc_segred_stage_1_parloop_338844_total_runs;
    int64_t futhark_mc_segred_stage_1_parloop_338844_total_iter;
    int64_t *futhark_mc_segred_task_338840_total_runtime;
    int *futhark_mc_segred_task_338840_runs;
    int64_t *futhark_mc_segred_task_338840_iter;
    int64_t futhark_mc_segred_task_338840_total_time;
    int64_t futhark_mc_segred_task_338840_total_iter;
    int64_t *futhark_mc_segmap_parloop_338831_total_runtime;
    int *futhark_mc_segmap_parloop_338831_runs;
    int64_t *futhark_mc_segmap_parloop_338831_iter;
    int64_t futhark_mc_segmap_parloop_338831_total_total_runtime;
    int futhark_mc_segmap_parloop_338831_total_runs;
    int64_t futhark_mc_segmap_parloop_338831_total_iter;
    int64_t *futhark_mc_segmap_nested_task_338829_total_runtime;
    int *futhark_mc_segmap_nested_task_338829_runs;
    int64_t *futhark_mc_segmap_nested_task_338829_iter;
    int64_t *futhark_mc_segmap_parloop_338811_total_runtime;
    int *futhark_mc_segmap_parloop_338811_runs;
    int64_t *futhark_mc_segmap_parloop_338811_iter;
    int64_t futhark_mc_segmap_parloop_338811_total_total_runtime;
    int futhark_mc_segmap_parloop_338811_total_runs;
    int64_t futhark_mc_segmap_parloop_338811_total_iter;
    int64_t *futhark_mc_segmap_nested_task_338809_total_runtime;
    int *futhark_mc_segmap_nested_task_338809_runs;
    int64_t *futhark_mc_segmap_nested_task_338809_iter;
    int64_t *futhark_mc_segmap_parloop_338848_total_runtime;
    int *futhark_mc_segmap_parloop_338848_runs;
    int64_t *futhark_mc_segmap_parloop_338848_iter;
    int64_t futhark_mc_segmap_parloop_338848_total_total_runtime;
    int futhark_mc_segmap_parloop_338848_total_runs;
    int64_t futhark_mc_segmap_parloop_338848_total_iter;
    int64_t *futhark_mc_segmap_task_338846_total_runtime;
    int *futhark_mc_segmap_task_338846_runs;
    int64_t *futhark_mc_segmap_task_338846_iter;
    int64_t futhark_mc_segmap_task_338846_total_time;
    int64_t futhark_mc_segmap_task_338846_total_iter;
    int64_t *futhark_mc_segmap_parloop_338865_total_runtime;
    int *futhark_mc_segmap_parloop_338865_runs;
    int64_t *futhark_mc_segmap_parloop_338865_iter;
    int64_t futhark_mc_segmap_parloop_338865_total_total_runtime;
    int futhark_mc_segmap_parloop_338865_total_runs;
    int64_t futhark_mc_segmap_parloop_338865_total_iter;
    int64_t *futhark_mc_segmap_task_338863_total_runtime;
    int *futhark_mc_segmap_task_338863_runs;
    int64_t *futhark_mc_segmap_task_338863_iter;
    int64_t futhark_mc_segmap_task_338863_total_time;
    int64_t futhark_mc_segmap_task_338863_total_iter;
    int64_t *futhark_mc_segmap_parloop_338869_total_runtime;
    int *futhark_mc_segmap_parloop_338869_runs;
    int64_t *futhark_mc_segmap_parloop_338869_iter;
    int64_t futhark_mc_segmap_parloop_338869_total_total_runtime;
    int futhark_mc_segmap_parloop_338869_total_runs;
    int64_t futhark_mc_segmap_parloop_338869_total_iter;
    int64_t *futhark_mc_segmap_task_338867_total_runtime;
    int *futhark_mc_segmap_task_338867_runs;
    int64_t *futhark_mc_segmap_task_338867_iter;
    int64_t futhark_mc_segmap_task_338867_total_time;
    int64_t futhark_mc_segmap_task_338867_total_iter;
    int64_t *futhark_mc_segmap_parloop_338873_total_runtime;
    int *futhark_mc_segmap_parloop_338873_runs;
    int64_t *futhark_mc_segmap_parloop_338873_iter;
    int64_t futhark_mc_segmap_parloop_338873_total_total_runtime;
    int futhark_mc_segmap_parloop_338873_total_runs;
    int64_t futhark_mc_segmap_parloop_338873_total_iter;
    int64_t *futhark_mc_segmap_task_338871_total_runtime;
    int *futhark_mc_segmap_task_338871_runs;
    int64_t *futhark_mc_segmap_task_338871_iter;
    int64_t futhark_mc_segmap_task_338871_total_time;
    int64_t futhark_mc_segmap_task_338871_total_iter;
    int64_t *futhark_mc_segred_stage_1_parloop_338885_total_runtime;
    int *futhark_mc_segred_stage_1_parloop_338885_runs;
    int64_t *futhark_mc_segred_stage_1_parloop_338885_iter;
    int64_t futhark_mc_segred_stage_1_parloop_338885_total_total_runtime;
    int futhark_mc_segred_stage_1_parloop_338885_total_runs;
    int64_t futhark_mc_segred_stage_1_parloop_338885_total_iter;
    int64_t *futhark_mc_segred_task_338878_total_runtime;
    int *futhark_mc_segred_task_338878_runs;
    int64_t *futhark_mc_segred_task_338878_iter;
    int64_t futhark_mc_segred_task_338878_total_time;
    int64_t futhark_mc_segred_task_338878_total_iter;
    int64_t *futhark_mc_segred_stage_1_parloop_338891_total_runtime;
    int *futhark_mc_segred_stage_1_parloop_338891_runs;
    int64_t *futhark_mc_segred_stage_1_parloop_338891_iter;
    int64_t futhark_mc_segred_stage_1_parloop_338891_total_total_runtime;
    int futhark_mc_segred_stage_1_parloop_338891_total_runs;
    int64_t futhark_mc_segred_stage_1_parloop_338891_total_iter;
    int64_t *futhark_mc_segred_task_338887_total_runtime;
    int *futhark_mc_segred_task_338887_runs;
    int64_t *futhark_mc_segred_task_338887_iter;
    int64_t futhark_mc_segred_task_338887_total_time;
    int64_t futhark_mc_segred_task_338887_total_iter;
    int64_t *futhark_mc_segmap_parloop_338876_total_runtime;
    int *futhark_mc_segmap_parloop_338876_runs;
    int64_t *futhark_mc_segmap_parloop_338876_iter;
    int64_t futhark_mc_segmap_parloop_338876_total_total_runtime;
    int futhark_mc_segmap_parloop_338876_total_runs;
    int64_t futhark_mc_segmap_parloop_338876_total_iter;
    int64_t *futhark_mc_segmap_nested_task_338874_total_runtime;
    int *futhark_mc_segmap_nested_task_338874_runs;
    int64_t *futhark_mc_segmap_nested_task_338874_iter;
    int64_t *futhark_mc_segmap_parloop_338856_total_runtime;
    int *futhark_mc_segmap_parloop_338856_runs;
    int64_t *futhark_mc_segmap_parloop_338856_iter;
    int64_t futhark_mc_segmap_parloop_338856_total_total_runtime;
    int futhark_mc_segmap_parloop_338856_total_runs;
    int64_t futhark_mc_segmap_parloop_338856_total_iter;
    int64_t *futhark_mc_segmap_nested_task_338854_total_runtime;
    int *futhark_mc_segmap_nested_task_338854_runs;
    int64_t *futhark_mc_segmap_nested_task_338854_iter;
    int64_t *futhark_mc_segmap_parloop_338895_total_runtime;
    int *futhark_mc_segmap_parloop_338895_runs;
    int64_t *futhark_mc_segmap_parloop_338895_iter;
    int64_t futhark_mc_segmap_parloop_338895_total_total_runtime;
    int futhark_mc_segmap_parloop_338895_total_runs;
    int64_t futhark_mc_segmap_parloop_338895_total_iter;
    int64_t *futhark_mc_segmap_task_338893_total_runtime;
    int *futhark_mc_segmap_task_338893_runs;
    int64_t *futhark_mc_segmap_task_338893_iter;
    int64_t futhark_mc_segmap_task_338893_total_time;
    int64_t futhark_mc_segmap_task_338893_total_iter;
    int64_t *futhark_mc_segmap_parloop_338911_total_runtime;
    int *futhark_mc_segmap_parloop_338911_runs;
    int64_t *futhark_mc_segmap_parloop_338911_iter;
    int64_t futhark_mc_segmap_parloop_338911_total_total_runtime;
    int futhark_mc_segmap_parloop_338911_total_runs;
    int64_t futhark_mc_segmap_parloop_338911_total_iter;
    int64_t *futhark_mc_segmap_task_338909_total_runtime;
    int *futhark_mc_segmap_task_338909_runs;
    int64_t *futhark_mc_segmap_task_338909_iter;
    int64_t futhark_mc_segmap_task_338909_total_time;
    int64_t futhark_mc_segmap_task_338909_total_iter;
    int64_t *futhark_mc_segmap_parloop_338915_total_runtime;
    int *futhark_mc_segmap_parloop_338915_runs;
    int64_t *futhark_mc_segmap_parloop_338915_iter;
    int64_t futhark_mc_segmap_parloop_338915_total_total_runtime;
    int futhark_mc_segmap_parloop_338915_total_runs;
    int64_t futhark_mc_segmap_parloop_338915_total_iter;
    int64_t *futhark_mc_segmap_task_338913_total_runtime;
    int *futhark_mc_segmap_task_338913_runs;
    int64_t *futhark_mc_segmap_task_338913_iter;
    int64_t futhark_mc_segmap_task_338913_total_time;
    int64_t futhark_mc_segmap_task_338913_total_iter;
    int64_t *futhark_mc_segmap_parloop_338919_total_runtime;
    int *futhark_mc_segmap_parloop_338919_runs;
    int64_t *futhark_mc_segmap_parloop_338919_iter;
    int64_t futhark_mc_segmap_parloop_338919_total_total_runtime;
    int futhark_mc_segmap_parloop_338919_total_runs;
    int64_t futhark_mc_segmap_parloop_338919_total_iter;
    int64_t *futhark_mc_segmap_task_338917_total_runtime;
    int *futhark_mc_segmap_task_338917_runs;
    int64_t *futhark_mc_segmap_task_338917_iter;
    int64_t futhark_mc_segmap_task_338917_total_time;
    int64_t futhark_mc_segmap_task_338917_total_iter;
    int64_t *futhark_mc_segred_stage_1_parloop_338929_total_runtime;
    int *futhark_mc_segred_stage_1_parloop_338929_runs;
    int64_t *futhark_mc_segred_stage_1_parloop_338929_iter;
    int64_t futhark_mc_segred_stage_1_parloop_338929_total_total_runtime;
    int futhark_mc_segred_stage_1_parloop_338929_total_runs;
    int64_t futhark_mc_segred_stage_1_parloop_338929_total_iter;
    int64_t *futhark_mc_segred_task_338926_total_runtime;
    int *futhark_mc_segred_task_338926_runs;
    int64_t *futhark_mc_segred_task_338926_iter;
    int64_t futhark_mc_segred_task_338926_total_time;
    int64_t futhark_mc_segred_task_338926_total_iter;
    int64_t *futhark_mc_segred_stage_1_parloop_338934_total_runtime;
    int *futhark_mc_segred_stage_1_parloop_338934_runs;
    int64_t *futhark_mc_segred_stage_1_parloop_338934_iter;
    int64_t futhark_mc_segred_stage_1_parloop_338934_total_total_runtime;
    int futhark_mc_segred_stage_1_parloop_338934_total_runs;
    int64_t futhark_mc_segred_stage_1_parloop_338934_total_iter;
    int64_t *futhark_mc_segred_task_338931_total_runtime;
    int *futhark_mc_segred_task_338931_runs;
    int64_t *futhark_mc_segred_task_338931_iter;
    int64_t futhark_mc_segred_task_338931_total_time;
    int64_t futhark_mc_segred_task_338931_total_iter;
    int64_t *futhark_mc_segmap_parloop_338923_total_runtime;
    int *futhark_mc_segmap_parloop_338923_runs;
    int64_t *futhark_mc_segmap_parloop_338923_iter;
    int64_t futhark_mc_segmap_parloop_338923_total_total_runtime;
    int futhark_mc_segmap_parloop_338923_total_runs;
    int64_t futhark_mc_segmap_parloop_338923_total_iter;
    int64_t *futhark_mc_segmap_nested_task_338921_total_runtime;
    int *futhark_mc_segmap_nested_task_338921_runs;
    int64_t *futhark_mc_segmap_nested_task_338921_iter;
    int64_t *futhark_mc_segmap_parloop_338903_total_runtime;
    int *futhark_mc_segmap_parloop_338903_runs;
    int64_t *futhark_mc_segmap_parloop_338903_iter;
    int64_t futhark_mc_segmap_parloop_338903_total_total_runtime;
    int futhark_mc_segmap_parloop_338903_total_runs;
    int64_t futhark_mc_segmap_parloop_338903_total_iter;
    int64_t *futhark_mc_segmap_nested_task_338901_total_runtime;
    int *futhark_mc_segmap_nested_task_338901_runs;
    int64_t *futhark_mc_segmap_nested_task_338901_iter;
    int64_t *futhark_mc_segmap_parloop_338938_total_runtime;
    int *futhark_mc_segmap_parloop_338938_runs;
    int64_t *futhark_mc_segmap_parloop_338938_iter;
    int64_t futhark_mc_segmap_parloop_338938_total_total_runtime;
    int futhark_mc_segmap_parloop_338938_total_runs;
    int64_t futhark_mc_segmap_parloop_338938_total_iter;
    int64_t *futhark_mc_segmap_task_338936_total_runtime;
    int *futhark_mc_segmap_task_338936_runs;
    int64_t *futhark_mc_segmap_task_338936_iter;
    int64_t futhark_mc_segmap_task_338936_total_time;
    int64_t futhark_mc_segmap_task_338936_total_iter;
    int64_t *futhark_mc_segmap_parloop_338957_total_runtime;
    int *futhark_mc_segmap_parloop_338957_runs;
    int64_t *futhark_mc_segmap_parloop_338957_iter;
    int64_t futhark_mc_segmap_parloop_338957_total_total_runtime;
    int futhark_mc_segmap_parloop_338957_total_runs;
    int64_t futhark_mc_segmap_parloop_338957_total_iter;
    int64_t *futhark_mc_segmap_task_338955_total_runtime;
    int *futhark_mc_segmap_task_338955_runs;
    int64_t *futhark_mc_segmap_task_338955_iter;
    int64_t futhark_mc_segmap_task_338955_total_time;
    int64_t futhark_mc_segmap_task_338955_total_iter;
    int64_t *futhark_mc_segmap_parloop_338961_total_runtime;
    int *futhark_mc_segmap_parloop_338961_runs;
    int64_t *futhark_mc_segmap_parloop_338961_iter;
    int64_t futhark_mc_segmap_parloop_338961_total_total_runtime;
    int futhark_mc_segmap_parloop_338961_total_runs;
    int64_t futhark_mc_segmap_parloop_338961_total_iter;
    int64_t *futhark_mc_segmap_task_338959_total_runtime;
    int *futhark_mc_segmap_task_338959_runs;
    int64_t *futhark_mc_segmap_task_338959_iter;
    int64_t futhark_mc_segmap_task_338959_total_time;
    int64_t futhark_mc_segmap_task_338959_total_iter;
    int64_t *futhark_mc_segmap_parloop_338965_total_runtime;
    int *futhark_mc_segmap_parloop_338965_runs;
    int64_t *futhark_mc_segmap_parloop_338965_iter;
    int64_t futhark_mc_segmap_parloop_338965_total_total_runtime;
    int futhark_mc_segmap_parloop_338965_total_runs;
    int64_t futhark_mc_segmap_parloop_338965_total_iter;
    int64_t *futhark_mc_segmap_task_338963_total_runtime;
    int *futhark_mc_segmap_task_338963_runs;
    int64_t *futhark_mc_segmap_task_338963_iter;
    int64_t futhark_mc_segmap_task_338963_total_time;
    int64_t futhark_mc_segmap_task_338963_total_iter;
    int64_t *futhark_mc_segred_stage_1_parloop_338979_total_runtime;
    int *futhark_mc_segred_stage_1_parloop_338979_runs;
    int64_t *futhark_mc_segred_stage_1_parloop_338979_iter;
    int64_t futhark_mc_segred_stage_1_parloop_338979_total_total_runtime;
    int futhark_mc_segred_stage_1_parloop_338979_total_runs;
    int64_t futhark_mc_segred_stage_1_parloop_338979_total_iter;
    int64_t *futhark_mc_segred_task_338974_total_runtime;
    int *futhark_mc_segred_task_338974_runs;
    int64_t *futhark_mc_segred_task_338974_iter;
    int64_t futhark_mc_segred_task_338974_total_time;
    int64_t futhark_mc_segred_task_338974_total_iter;
    int64_t *futhark_mc_segred_stage_1_parloop_338985_total_runtime;
    int *futhark_mc_segred_stage_1_parloop_338985_runs;
    int64_t *futhark_mc_segred_stage_1_parloop_338985_iter;
    int64_t futhark_mc_segred_stage_1_parloop_338985_total_total_runtime;
    int futhark_mc_segred_stage_1_parloop_338985_total_runs;
    int64_t futhark_mc_segred_stage_1_parloop_338985_total_iter;
    int64_t *futhark_mc_segred_task_338981_total_runtime;
    int *futhark_mc_segred_task_338981_runs;
    int64_t *futhark_mc_segred_task_338981_iter;
    int64_t futhark_mc_segred_task_338981_total_time;
    int64_t futhark_mc_segred_task_338981_total_iter;
    int64_t *futhark_mc_segmap_parloop_338970_total_runtime;
    int *futhark_mc_segmap_parloop_338970_runs;
    int64_t *futhark_mc_segmap_parloop_338970_iter;
    int64_t futhark_mc_segmap_parloop_338970_total_total_runtime;
    int futhark_mc_segmap_parloop_338970_total_runs;
    int64_t futhark_mc_segmap_parloop_338970_total_iter;
    int64_t *futhark_mc_segmap_nested_task_338968_total_runtime;
    int *futhark_mc_segmap_nested_task_338968_runs;
    int64_t *futhark_mc_segmap_nested_task_338968_iter;
    int64_t *futhark_mc_segmap_parloop_338948_total_runtime;
    int *futhark_mc_segmap_parloop_338948_runs;
    int64_t *futhark_mc_segmap_parloop_338948_iter;
    int64_t futhark_mc_segmap_parloop_338948_total_total_runtime;
    int futhark_mc_segmap_parloop_338948_total_runs;
    int64_t futhark_mc_segmap_parloop_338948_total_iter;
    int64_t *futhark_mc_segmap_nested_task_338946_total_runtime;
    int *futhark_mc_segmap_nested_task_338946_runs;
    int64_t *futhark_mc_segmap_nested_task_338946_iter;
    int64_t *futhark_mc_segmap_parloop_338989_total_runtime;
    int *futhark_mc_segmap_parloop_338989_runs;
    int64_t *futhark_mc_segmap_parloop_338989_iter;
    int64_t futhark_mc_segmap_parloop_338989_total_total_runtime;
    int futhark_mc_segmap_parloop_338989_total_runs;
    int64_t futhark_mc_segmap_parloop_338989_total_iter;
    int64_t *futhark_mc_segmap_task_338987_total_runtime;
    int *futhark_mc_segmap_task_338987_runs;
    int64_t *futhark_mc_segmap_task_338987_iter;
    int64_t futhark_mc_segmap_task_338987_total_time;
    int64_t futhark_mc_segmap_task_338987_total_iter;
    int64_t *futhark_mc_segmap_parloop_339010_total_runtime;
    int *futhark_mc_segmap_parloop_339010_runs;
    int64_t *futhark_mc_segmap_parloop_339010_iter;
    int64_t futhark_mc_segmap_parloop_339010_total_total_runtime;
    int futhark_mc_segmap_parloop_339010_total_runs;
    int64_t futhark_mc_segmap_parloop_339010_total_iter;
    int64_t *futhark_mc_segmap_task_339008_total_runtime;
    int *futhark_mc_segmap_task_339008_runs;
    int64_t *futhark_mc_segmap_task_339008_iter;
    int64_t futhark_mc_segmap_task_339008_total_time;
    int64_t futhark_mc_segmap_task_339008_total_iter;
    int64_t *futhark_mc_segmap_parloop_339014_total_runtime;
    int *futhark_mc_segmap_parloop_339014_runs;
    int64_t *futhark_mc_segmap_parloop_339014_iter;
    int64_t futhark_mc_segmap_parloop_339014_total_total_runtime;
    int futhark_mc_segmap_parloop_339014_total_runs;
    int64_t futhark_mc_segmap_parloop_339014_total_iter;
    int64_t *futhark_mc_segmap_task_339012_total_runtime;
    int *futhark_mc_segmap_task_339012_runs;
    int64_t *futhark_mc_segmap_task_339012_iter;
    int64_t futhark_mc_segmap_task_339012_total_time;
    int64_t futhark_mc_segmap_task_339012_total_iter;
    int64_t *futhark_mc_segmap_parloop_339018_total_runtime;
    int *futhark_mc_segmap_parloop_339018_runs;
    int64_t *futhark_mc_segmap_parloop_339018_iter;
    int64_t futhark_mc_segmap_parloop_339018_total_total_runtime;
    int futhark_mc_segmap_parloop_339018_total_runs;
    int64_t futhark_mc_segmap_parloop_339018_total_iter;
    int64_t *futhark_mc_segmap_task_339016_total_runtime;
    int *futhark_mc_segmap_task_339016_runs;
    int64_t *futhark_mc_segmap_task_339016_iter;
    int64_t futhark_mc_segmap_task_339016_total_time;
    int64_t futhark_mc_segmap_task_339016_total_iter;
    int64_t *futhark_mc_segmap_parloop_339033_total_runtime;
    int *futhark_mc_segmap_parloop_339033_runs;
    int64_t *futhark_mc_segmap_parloop_339033_iter;
    int64_t futhark_mc_segmap_parloop_339033_total_total_runtime;
    int futhark_mc_segmap_parloop_339033_total_runs;
    int64_t futhark_mc_segmap_parloop_339033_total_iter;
    int64_t *futhark_mc_segmap_task_339031_total_runtime;
    int *futhark_mc_segmap_task_339031_runs;
    int64_t *futhark_mc_segmap_task_339031_iter;
    int64_t futhark_mc_segmap_task_339031_total_time;
    int64_t futhark_mc_segmap_task_339031_total_iter;
    int64_t *futhark_mc_segred_stage_1_parloop_339042_total_runtime;
    int *futhark_mc_segred_stage_1_parloop_339042_runs;
    int64_t *futhark_mc_segred_stage_1_parloop_339042_iter;
    int64_t futhark_mc_segred_stage_1_parloop_339042_total_total_runtime;
    int futhark_mc_segred_stage_1_parloop_339042_total_runs;
    int64_t futhark_mc_segred_stage_1_parloop_339042_total_iter;
    int64_t *futhark_mc_segred_task_339035_total_runtime;
    int *futhark_mc_segred_task_339035_runs;
    int64_t *futhark_mc_segred_task_339035_iter;
    int64_t futhark_mc_segred_task_339035_total_time;
    int64_t futhark_mc_segred_task_339035_total_iter;
    int64_t *futhark_mc_segred_stage_1_parloop_339048_total_runtime;
    int *futhark_mc_segred_stage_1_parloop_339048_runs;
    int64_t *futhark_mc_segred_stage_1_parloop_339048_iter;
    int64_t futhark_mc_segred_stage_1_parloop_339048_total_total_runtime;
    int futhark_mc_segred_stage_1_parloop_339048_total_runs;
    int64_t futhark_mc_segred_stage_1_parloop_339048_total_iter;
    int64_t *futhark_mc_segred_task_339044_total_runtime;
    int *futhark_mc_segred_task_339044_runs;
    int64_t *futhark_mc_segred_task_339044_iter;
    int64_t futhark_mc_segred_task_339044_total_time;
    int64_t futhark_mc_segred_task_339044_total_iter;
    int64_t *futhark_mc_segmap_parloop_339025_total_runtime;
    int *futhark_mc_segmap_parloop_339025_runs;
    int64_t *futhark_mc_segmap_parloop_339025_iter;
    int64_t futhark_mc_segmap_parloop_339025_total_total_runtime;
    int futhark_mc_segmap_parloop_339025_total_runs;
    int64_t futhark_mc_segmap_parloop_339025_total_iter;
    int64_t *futhark_mc_segmap_nested_task_339023_total_runtime;
    int *futhark_mc_segmap_nested_task_339023_runs;
    int64_t *futhark_mc_segmap_nested_task_339023_iter;
    int64_t *futhark_mc_segmap_parloop_339001_total_runtime;
    int *futhark_mc_segmap_parloop_339001_runs;
    int64_t *futhark_mc_segmap_parloop_339001_iter;
    int64_t futhark_mc_segmap_parloop_339001_total_total_runtime;
    int futhark_mc_segmap_parloop_339001_total_runs;
    int64_t futhark_mc_segmap_parloop_339001_total_iter;
    int64_t *futhark_mc_segmap_nested_task_338999_total_runtime;
    int *futhark_mc_segmap_nested_task_338999_runs;
    int64_t *futhark_mc_segmap_nested_task_338999_iter;
    int64_t *futhark_mc_segmap_parloop_339052_total_runtime;
    int *futhark_mc_segmap_parloop_339052_runs;
    int64_t *futhark_mc_segmap_parloop_339052_iter;
    int64_t futhark_mc_segmap_parloop_339052_total_total_runtime;
    int futhark_mc_segmap_parloop_339052_total_runs;
    int64_t futhark_mc_segmap_parloop_339052_total_iter;
    int64_t *futhark_mc_segmap_task_339050_total_runtime;
    int *futhark_mc_segmap_task_339050_runs;
    int64_t *futhark_mc_segmap_task_339050_iter;
    int64_t futhark_mc_segmap_task_339050_total_time;
    int64_t futhark_mc_segmap_task_339050_total_iter;
    int64_t *futhark_mc_segmap_parloop_339067_total_runtime;
    int *futhark_mc_segmap_parloop_339067_runs;
    int64_t *futhark_mc_segmap_parloop_339067_iter;
    int64_t futhark_mc_segmap_parloop_339067_total_total_runtime;
    int futhark_mc_segmap_parloop_339067_total_runs;
    int64_t futhark_mc_segmap_parloop_339067_total_iter;
    int64_t *futhark_mc_segmap_task_339065_total_runtime;
    int *futhark_mc_segmap_task_339065_runs;
    int64_t *futhark_mc_segmap_task_339065_iter;
    int64_t futhark_mc_segmap_task_339065_total_time;
    int64_t futhark_mc_segmap_task_339065_total_iter;
    int64_t *futhark_mc_segmap_parloop_339071_total_runtime;
    int *futhark_mc_segmap_parloop_339071_runs;
    int64_t *futhark_mc_segmap_parloop_339071_iter;
    int64_t futhark_mc_segmap_parloop_339071_total_total_runtime;
    int futhark_mc_segmap_parloop_339071_total_runs;
    int64_t futhark_mc_segmap_parloop_339071_total_iter;
    int64_t *futhark_mc_segmap_task_339069_total_runtime;
    int *futhark_mc_segmap_task_339069_runs;
    int64_t *futhark_mc_segmap_task_339069_iter;
    int64_t futhark_mc_segmap_task_339069_total_time;
    int64_t futhark_mc_segmap_task_339069_total_iter;
    int64_t *futhark_mc_segmap_parloop_339075_total_runtime;
    int *futhark_mc_segmap_parloop_339075_runs;
    int64_t *futhark_mc_segmap_parloop_339075_iter;
    int64_t futhark_mc_segmap_parloop_339075_total_total_runtime;
    int futhark_mc_segmap_parloop_339075_total_runs;
    int64_t futhark_mc_segmap_parloop_339075_total_iter;
    int64_t *futhark_mc_segmap_task_339073_total_runtime;
    int *futhark_mc_segmap_task_339073_runs;
    int64_t *futhark_mc_segmap_task_339073_iter;
    int64_t futhark_mc_segmap_task_339073_total_time;
    int64_t futhark_mc_segmap_task_339073_total_iter;
    int64_t *futhark_mc_segred_stage_1_parloop_339083_total_runtime;
    int *futhark_mc_segred_stage_1_parloop_339083_runs;
    int64_t *futhark_mc_segred_stage_1_parloop_339083_iter;
    int64_t futhark_mc_segred_stage_1_parloop_339083_total_total_runtime;
    int futhark_mc_segred_stage_1_parloop_339083_total_runs;
    int64_t futhark_mc_segred_stage_1_parloop_339083_total_iter;
    int64_t *futhark_mc_segred_task_339080_total_runtime;
    int *futhark_mc_segred_task_339080_runs;
    int64_t *futhark_mc_segred_task_339080_iter;
    int64_t futhark_mc_segred_task_339080_total_time;
    int64_t futhark_mc_segred_task_339080_total_iter;
    int64_t *futhark_mc_segred_stage_1_parloop_339088_total_runtime;
    int *futhark_mc_segred_stage_1_parloop_339088_runs;
    int64_t *futhark_mc_segred_stage_1_parloop_339088_iter;
    int64_t futhark_mc_segred_stage_1_parloop_339088_total_total_runtime;
    int futhark_mc_segred_stage_1_parloop_339088_total_runs;
    int64_t futhark_mc_segred_stage_1_parloop_339088_total_iter;
    int64_t *futhark_mc_segred_task_339085_total_runtime;
    int *futhark_mc_segred_task_339085_runs;
    int64_t *futhark_mc_segred_task_339085_iter;
    int64_t futhark_mc_segred_task_339085_total_time;
    int64_t futhark_mc_segred_task_339085_total_iter;
    int64_t *futhark_mc_segmap_parloop_339078_total_runtime;
    int *futhark_mc_segmap_parloop_339078_runs;
    int64_t *futhark_mc_segmap_parloop_339078_iter;
    int64_t futhark_mc_segmap_parloop_339078_total_total_runtime;
    int futhark_mc_segmap_parloop_339078_total_runs;
    int64_t futhark_mc_segmap_parloop_339078_total_iter;
    int64_t *futhark_mc_segmap_nested_task_339076_total_runtime;
    int *futhark_mc_segmap_nested_task_339076_runs;
    int64_t *futhark_mc_segmap_nested_task_339076_iter;
    int64_t *futhark_mc_segmap_parloop_339059_total_runtime;
    int *futhark_mc_segmap_parloop_339059_runs;
    int64_t *futhark_mc_segmap_parloop_339059_iter;
    int64_t futhark_mc_segmap_parloop_339059_total_total_runtime;
    int futhark_mc_segmap_parloop_339059_total_runs;
    int64_t futhark_mc_segmap_parloop_339059_total_iter;
    int64_t *futhark_mc_segmap_nested_task_339057_total_runtime;
    int *futhark_mc_segmap_nested_task_339057_runs;
    int64_t *futhark_mc_segmap_nested_task_339057_iter;
    int64_t *futhark_mc_segmap_parloop_339092_total_runtime;
    int *futhark_mc_segmap_parloop_339092_runs;
    int64_t *futhark_mc_segmap_parloop_339092_iter;
    int64_t futhark_mc_segmap_parloop_339092_total_total_runtime;
    int futhark_mc_segmap_parloop_339092_total_runs;
    int64_t futhark_mc_segmap_parloop_339092_total_iter;
    int64_t *futhark_mc_segmap_task_339090_total_runtime;
    int *futhark_mc_segmap_task_339090_runs;
    int64_t *futhark_mc_segmap_task_339090_iter;
    int64_t futhark_mc_segmap_task_339090_total_time;
    int64_t futhark_mc_segmap_task_339090_total_iter;
    int64_t *futhark_mc_segmap_parloop_339109_total_runtime;
    int *futhark_mc_segmap_parloop_339109_runs;
    int64_t *futhark_mc_segmap_parloop_339109_iter;
    int64_t futhark_mc_segmap_parloop_339109_total_total_runtime;
    int futhark_mc_segmap_parloop_339109_total_runs;
    int64_t futhark_mc_segmap_parloop_339109_total_iter;
    int64_t *futhark_mc_segmap_task_339107_total_runtime;
    int *futhark_mc_segmap_task_339107_runs;
    int64_t *futhark_mc_segmap_task_339107_iter;
    int64_t futhark_mc_segmap_task_339107_total_time;
    int64_t futhark_mc_segmap_task_339107_total_iter;
    int64_t *futhark_mc_segmap_parloop_339113_total_runtime;
    int *futhark_mc_segmap_parloop_339113_runs;
    int64_t *futhark_mc_segmap_parloop_339113_iter;
    int64_t futhark_mc_segmap_parloop_339113_total_total_runtime;
    int futhark_mc_segmap_parloop_339113_total_runs;
    int64_t futhark_mc_segmap_parloop_339113_total_iter;
    int64_t *futhark_mc_segmap_task_339111_total_runtime;
    int *futhark_mc_segmap_task_339111_runs;
    int64_t *futhark_mc_segmap_task_339111_iter;
    int64_t futhark_mc_segmap_task_339111_total_time;
    int64_t futhark_mc_segmap_task_339111_total_iter;
    int64_t *futhark_mc_segmap_parloop_339117_total_runtime;
    int *futhark_mc_segmap_parloop_339117_runs;
    int64_t *futhark_mc_segmap_parloop_339117_iter;
    int64_t futhark_mc_segmap_parloop_339117_total_total_runtime;
    int futhark_mc_segmap_parloop_339117_total_runs;
    int64_t futhark_mc_segmap_parloop_339117_total_iter;
    int64_t *futhark_mc_segmap_task_339115_total_runtime;
    int *futhark_mc_segmap_task_339115_runs;
    int64_t *futhark_mc_segmap_task_339115_iter;
    int64_t futhark_mc_segmap_task_339115_total_time;
    int64_t futhark_mc_segmap_task_339115_total_iter;
    int64_t *futhark_mc_segred_stage_1_parloop_339127_total_runtime;
    int *futhark_mc_segred_stage_1_parloop_339127_runs;
    int64_t *futhark_mc_segred_stage_1_parloop_339127_iter;
    int64_t futhark_mc_segred_stage_1_parloop_339127_total_total_runtime;
    int futhark_mc_segred_stage_1_parloop_339127_total_runs;
    int64_t futhark_mc_segred_stage_1_parloop_339127_total_iter;
    int64_t *futhark_mc_segred_task_339122_total_runtime;
    int *futhark_mc_segred_task_339122_runs;
    int64_t *futhark_mc_segred_task_339122_iter;
    int64_t futhark_mc_segred_task_339122_total_time;
    int64_t futhark_mc_segred_task_339122_total_iter;
    int64_t *futhark_mc_segred_stage_1_parloop_339133_total_runtime;
    int *futhark_mc_segred_stage_1_parloop_339133_runs;
    int64_t *futhark_mc_segred_stage_1_parloop_339133_iter;
    int64_t futhark_mc_segred_stage_1_parloop_339133_total_total_runtime;
    int futhark_mc_segred_stage_1_parloop_339133_total_runs;
    int64_t futhark_mc_segred_stage_1_parloop_339133_total_iter;
    int64_t *futhark_mc_segred_task_339129_total_runtime;
    int *futhark_mc_segred_task_339129_runs;
    int64_t *futhark_mc_segred_task_339129_iter;
    int64_t futhark_mc_segred_task_339129_total_time;
    int64_t futhark_mc_segred_task_339129_total_iter;
    int64_t *futhark_mc_segmap_parloop_339120_total_runtime;
    int *futhark_mc_segmap_parloop_339120_runs;
    int64_t *futhark_mc_segmap_parloop_339120_iter;
    int64_t futhark_mc_segmap_parloop_339120_total_total_runtime;
    int futhark_mc_segmap_parloop_339120_total_runs;
    int64_t futhark_mc_segmap_parloop_339120_total_iter;
    int64_t *futhark_mc_segmap_nested_task_339118_total_runtime;
    int *futhark_mc_segmap_nested_task_339118_runs;
    int64_t *futhark_mc_segmap_nested_task_339118_iter;
    int64_t *futhark_mc_segmap_parloop_339100_total_runtime;
    int *futhark_mc_segmap_parloop_339100_runs;
    int64_t *futhark_mc_segmap_parloop_339100_iter;
    int64_t futhark_mc_segmap_parloop_339100_total_total_runtime;
    int futhark_mc_segmap_parloop_339100_total_runs;
    int64_t futhark_mc_segmap_parloop_339100_total_iter;
    int64_t *futhark_mc_segmap_nested_task_339098_total_runtime;
    int *futhark_mc_segmap_nested_task_339098_runs;
    int64_t *futhark_mc_segmap_nested_task_339098_iter;
    int64_t *futhark_mc_segmap_parloop_339137_total_runtime;
    int *futhark_mc_segmap_parloop_339137_runs;
    int64_t *futhark_mc_segmap_parloop_339137_iter;
    int64_t futhark_mc_segmap_parloop_339137_total_total_runtime;
    int futhark_mc_segmap_parloop_339137_total_runs;
    int64_t futhark_mc_segmap_parloop_339137_total_iter;
    int64_t *futhark_mc_segmap_task_339135_total_runtime;
    int *futhark_mc_segmap_task_339135_runs;
    int64_t *futhark_mc_segmap_task_339135_iter;
    int64_t futhark_mc_segmap_task_339135_total_time;
    int64_t futhark_mc_segmap_task_339135_total_iter;
    int64_t *futhark_mc_segmap_parloop_339154_total_runtime;
    int *futhark_mc_segmap_parloop_339154_runs;
    int64_t *futhark_mc_segmap_parloop_339154_iter;
    int64_t futhark_mc_segmap_parloop_339154_total_total_runtime;
    int futhark_mc_segmap_parloop_339154_total_runs;
    int64_t futhark_mc_segmap_parloop_339154_total_iter;
    int64_t *futhark_mc_segmap_task_339152_total_runtime;
    int *futhark_mc_segmap_task_339152_runs;
    int64_t *futhark_mc_segmap_task_339152_iter;
    int64_t futhark_mc_segmap_task_339152_total_time;
    int64_t futhark_mc_segmap_task_339152_total_iter;
    int64_t *futhark_mc_segmap_parloop_339158_total_runtime;
    int *futhark_mc_segmap_parloop_339158_runs;
    int64_t *futhark_mc_segmap_parloop_339158_iter;
    int64_t futhark_mc_segmap_parloop_339158_total_total_runtime;
    int futhark_mc_segmap_parloop_339158_total_runs;
    int64_t futhark_mc_segmap_parloop_339158_total_iter;
    int64_t *futhark_mc_segmap_task_339156_total_runtime;
    int *futhark_mc_segmap_task_339156_runs;
    int64_t *futhark_mc_segmap_task_339156_iter;
    int64_t futhark_mc_segmap_task_339156_total_time;
    int64_t futhark_mc_segmap_task_339156_total_iter;
    int64_t *futhark_mc_segmap_parloop_339162_total_runtime;
    int *futhark_mc_segmap_parloop_339162_runs;
    int64_t *futhark_mc_segmap_parloop_339162_iter;
    int64_t futhark_mc_segmap_parloop_339162_total_total_runtime;
    int futhark_mc_segmap_parloop_339162_total_runs;
    int64_t futhark_mc_segmap_parloop_339162_total_iter;
    int64_t *futhark_mc_segmap_task_339160_total_runtime;
    int *futhark_mc_segmap_task_339160_runs;
    int64_t *futhark_mc_segmap_task_339160_iter;
    int64_t futhark_mc_segmap_task_339160_total_time;
    int64_t futhark_mc_segmap_task_339160_total_iter;
    int64_t *futhark_mc_segred_stage_1_parloop_339174_total_runtime;
    int *futhark_mc_segred_stage_1_parloop_339174_runs;
    int64_t *futhark_mc_segred_stage_1_parloop_339174_iter;
    int64_t futhark_mc_segred_stage_1_parloop_339174_total_total_runtime;
    int futhark_mc_segred_stage_1_parloop_339174_total_runs;
    int64_t futhark_mc_segred_stage_1_parloop_339174_total_iter;
    int64_t *futhark_mc_segred_task_339167_total_runtime;
    int *futhark_mc_segred_task_339167_runs;
    int64_t *futhark_mc_segred_task_339167_iter;
    int64_t futhark_mc_segred_task_339167_total_time;
    int64_t futhark_mc_segred_task_339167_total_iter;
    int64_t *futhark_mc_segred_stage_1_parloop_339180_total_runtime;
    int *futhark_mc_segred_stage_1_parloop_339180_runs;
    int64_t *futhark_mc_segred_stage_1_parloop_339180_iter;
    int64_t futhark_mc_segred_stage_1_parloop_339180_total_total_runtime;
    int futhark_mc_segred_stage_1_parloop_339180_total_runs;
    int64_t futhark_mc_segred_stage_1_parloop_339180_total_iter;
    int64_t *futhark_mc_segred_task_339176_total_runtime;
    int *futhark_mc_segred_task_339176_runs;
    int64_t *futhark_mc_segred_task_339176_iter;
    int64_t futhark_mc_segred_task_339176_total_time;
    int64_t futhark_mc_segred_task_339176_total_iter;
    int64_t *futhark_mc_segmap_parloop_339165_total_runtime;
    int *futhark_mc_segmap_parloop_339165_runs;
    int64_t *futhark_mc_segmap_parloop_339165_iter;
    int64_t futhark_mc_segmap_parloop_339165_total_total_runtime;
    int futhark_mc_segmap_parloop_339165_total_runs;
    int64_t futhark_mc_segmap_parloop_339165_total_iter;
    int64_t *futhark_mc_segmap_nested_task_339163_total_runtime;
    int *futhark_mc_segmap_nested_task_339163_runs;
    int64_t *futhark_mc_segmap_nested_task_339163_iter;
    int64_t *futhark_mc_segmap_parloop_339145_total_runtime;
    int *futhark_mc_segmap_parloop_339145_runs;
    int64_t *futhark_mc_segmap_parloop_339145_iter;
    int64_t futhark_mc_segmap_parloop_339145_total_total_runtime;
    int futhark_mc_segmap_parloop_339145_total_runs;
    int64_t futhark_mc_segmap_parloop_339145_total_iter;
    int64_t *futhark_mc_segmap_nested_task_339143_total_runtime;
    int *futhark_mc_segmap_nested_task_339143_runs;
    int64_t *futhark_mc_segmap_nested_task_339143_iter;
    int64_t *futhark_mc_segmap_parloop_339184_total_runtime;
    int *futhark_mc_segmap_parloop_339184_runs;
    int64_t *futhark_mc_segmap_parloop_339184_iter;
    int64_t futhark_mc_segmap_parloop_339184_total_total_runtime;
    int futhark_mc_segmap_parloop_339184_total_runs;
    int64_t futhark_mc_segmap_parloop_339184_total_iter;
    int64_t *futhark_mc_segmap_task_339182_total_runtime;
    int *futhark_mc_segmap_task_339182_runs;
    int64_t *futhark_mc_segmap_task_339182_iter;
    int64_t futhark_mc_segmap_task_339182_total_time;
    int64_t futhark_mc_segmap_task_339182_total_iter;
    int64_t *futhark_mc_segmap_parloop_339193_total_runtime;
    int *futhark_mc_segmap_parloop_339193_runs;
    int64_t *futhark_mc_segmap_parloop_339193_iter;
    int64_t futhark_mc_segmap_parloop_339193_total_total_runtime;
    int futhark_mc_segmap_parloop_339193_total_runs;
    int64_t futhark_mc_segmap_parloop_339193_total_iter;
    int64_t *futhark_mc_segmap_task_339191_total_runtime;
    int *futhark_mc_segmap_task_339191_runs;
    int64_t *futhark_mc_segmap_task_339191_iter;
    int64_t futhark_mc_segmap_task_339191_total_time;
    int64_t futhark_mc_segmap_task_339191_total_iter;
    int64_t *futhark_mc_segmap_parloop_339188_total_runtime;
    int *futhark_mc_segmap_parloop_339188_runs;
    int64_t *futhark_mc_segmap_parloop_339188_iter;
    int64_t futhark_mc_segmap_parloop_339188_total_total_runtime;
    int futhark_mc_segmap_parloop_339188_total_runs;
    int64_t futhark_mc_segmap_parloop_339188_total_iter;
    int64_t *futhark_mc_segmap_nested_task_339186_total_runtime;
    int *futhark_mc_segmap_nested_task_339186_runs;
    int64_t *futhark_mc_segmap_nested_task_339186_iter;
    int64_t *futhark_mc_segmap_parloop_339197_total_runtime;
    int *futhark_mc_segmap_parloop_339197_runs;
    int64_t *futhark_mc_segmap_parloop_339197_iter;
    int64_t futhark_mc_segmap_parloop_339197_total_total_runtime;
    int futhark_mc_segmap_parloop_339197_total_runs;
    int64_t futhark_mc_segmap_parloop_339197_total_iter;
    int64_t *futhark_mc_segmap_task_339195_total_runtime;
    int *futhark_mc_segmap_task_339195_runs;
    int64_t *futhark_mc_segmap_task_339195_iter;
    int64_t futhark_mc_segmap_task_339195_total_time;
    int64_t futhark_mc_segmap_task_339195_total_iter;
    int64_t *futhark_mc_segmap_parloop_339208_total_runtime;
    int *futhark_mc_segmap_parloop_339208_runs;
    int64_t *futhark_mc_segmap_parloop_339208_iter;
    int64_t futhark_mc_segmap_parloop_339208_total_total_runtime;
    int futhark_mc_segmap_parloop_339208_total_runs;
    int64_t futhark_mc_segmap_parloop_339208_total_iter;
    int64_t *futhark_mc_segmap_task_339206_total_runtime;
    int *futhark_mc_segmap_task_339206_runs;
    int64_t *futhark_mc_segmap_task_339206_iter;
    int64_t futhark_mc_segmap_task_339206_total_time;
    int64_t futhark_mc_segmap_task_339206_total_iter;
    int64_t *futhark_mc_segmap_parloop_339212_total_runtime;
    int *futhark_mc_segmap_parloop_339212_runs;
    int64_t *futhark_mc_segmap_parloop_339212_iter;
    int64_t futhark_mc_segmap_parloop_339212_total_total_runtime;
    int futhark_mc_segmap_parloop_339212_total_runs;
    int64_t futhark_mc_segmap_parloop_339212_total_iter;
    int64_t *futhark_mc_segmap_task_339210_total_runtime;
    int *futhark_mc_segmap_task_339210_runs;
    int64_t *futhark_mc_segmap_task_339210_iter;
    int64_t futhark_mc_segmap_task_339210_total_time;
    int64_t futhark_mc_segmap_task_339210_total_iter;
    int64_t *futhark_mc_segmap_parloop_339202_total_runtime;
    int *futhark_mc_segmap_parloop_339202_runs;
    int64_t *futhark_mc_segmap_parloop_339202_iter;
    int64_t futhark_mc_segmap_parloop_339202_total_total_runtime;
    int futhark_mc_segmap_parloop_339202_total_runs;
    int64_t futhark_mc_segmap_parloop_339202_total_iter;
    int64_t *futhark_mc_segmap_nested_task_339200_total_runtime;
    int *futhark_mc_segmap_nested_task_339200_runs;
    int64_t *futhark_mc_segmap_nested_task_339200_iter;
    int64_t *futhark_mc_segmap_parloop_339216_total_runtime;
    int *futhark_mc_segmap_parloop_339216_runs;
    int64_t *futhark_mc_segmap_parloop_339216_iter;
    int64_t futhark_mc_segmap_parloop_339216_total_total_runtime;
    int futhark_mc_segmap_parloop_339216_total_runs;
    int64_t futhark_mc_segmap_parloop_339216_total_iter;
    int64_t *futhark_mc_segmap_task_339214_total_runtime;
    int *futhark_mc_segmap_task_339214_runs;
    int64_t *futhark_mc_segmap_task_339214_iter;
    int64_t futhark_mc_segmap_task_339214_total_time;
    int64_t futhark_mc_segmap_task_339214_total_iter;
    int64_t *futhark_mc_segred_stage_1_parloop_339225_total_runtime;
    int *futhark_mc_segred_stage_1_parloop_339225_runs;
    int64_t *futhark_mc_segred_stage_1_parloop_339225_iter;
    int64_t futhark_mc_segred_stage_1_parloop_339225_total_total_runtime;
    int futhark_mc_segred_stage_1_parloop_339225_total_runs;
    int64_t futhark_mc_segred_stage_1_parloop_339225_total_iter;
    int64_t *futhark_mc_segred_task_339221_total_runtime;
    int *futhark_mc_segred_task_339221_runs;
    int64_t *futhark_mc_segred_task_339221_iter;
    int64_t futhark_mc_segred_task_339221_total_time;
    int64_t futhark_mc_segred_task_339221_total_iter;
    int64_t *futhark_mc_segmap_parloop_339219_total_runtime;
    int *futhark_mc_segmap_parloop_339219_runs;
    int64_t *futhark_mc_segmap_parloop_339219_iter;
    int64_t futhark_mc_segmap_parloop_339219_total_total_runtime;
    int futhark_mc_segmap_parloop_339219_total_runs;
    int64_t futhark_mc_segmap_parloop_339219_total_iter;
    int64_t *futhark_mc_segmap_nested_task_339217_total_runtime;
    int *futhark_mc_segmap_nested_task_339217_runs;
    int64_t *futhark_mc_segmap_nested_task_339217_iter;
    int64_t *futhark_mc_segmap_parloop_339229_total_runtime;
    int *futhark_mc_segmap_parloop_339229_runs;
    int64_t *futhark_mc_segmap_parloop_339229_iter;
    int64_t futhark_mc_segmap_parloop_339229_total_total_runtime;
    int futhark_mc_segmap_parloop_339229_total_runs;
    int64_t futhark_mc_segmap_parloop_339229_total_iter;
    int64_t *futhark_mc_segmap_task_339227_total_runtime;
    int *futhark_mc_segmap_task_339227_runs;
    int64_t *futhark_mc_segmap_task_339227_iter;
    int64_t futhark_mc_segmap_task_339227_total_time;
    int64_t futhark_mc_segmap_task_339227_total_iter;
    int64_t *futhark_mc_segmap_parloop_339234_total_runtime;
    int *futhark_mc_segmap_parloop_339234_runs;
    int64_t *futhark_mc_segmap_parloop_339234_iter;
    int64_t futhark_mc_segmap_parloop_339234_total_total_runtime;
    int futhark_mc_segmap_parloop_339234_total_runs;
    int64_t futhark_mc_segmap_parloop_339234_total_iter;
    int64_t *futhark_mc_segmap_task_339232_total_runtime;
    int *futhark_mc_segmap_task_339232_runs;
    int64_t *futhark_mc_segmap_task_339232_iter;
    int64_t futhark_mc_segmap_task_339232_total_time;
    int64_t futhark_mc_segmap_task_339232_total_iter;
    int64_t *futhark_mc_scan_stage_1_parloop_339239_total_runtime;
    int *futhark_mc_scan_stage_1_parloop_339239_runs;
    int64_t *futhark_mc_scan_stage_1_parloop_339239_iter;
    int64_t futhark_mc_scan_stage_1_parloop_339239_total_total_runtime;
    int futhark_mc_scan_stage_1_parloop_339239_total_runs;
    int64_t futhark_mc_scan_stage_1_parloop_339239_total_iter;
    int64_t *futhark_mc_scan_stage_3_parloop_339241_total_runtime;
    int *futhark_mc_scan_stage_3_parloop_339241_runs;
    int64_t *futhark_mc_scan_stage_3_parloop_339241_iter;
    int64_t futhark_mc_scan_stage_3_parloop_339241_total_total_runtime;
    int futhark_mc_scan_stage_3_parloop_339241_total_runs;
    int64_t futhark_mc_scan_stage_3_parloop_339241_total_iter;
    int64_t *futhark_mc_segscan_task_339236_total_runtime;
    int *futhark_mc_segscan_task_339236_runs;
    int64_t *futhark_mc_segscan_task_339236_iter;
    int64_t futhark_mc_segscan_task_339236_total_time;
    int64_t futhark_mc_segscan_task_339236_total_iter;
    int64_t *futhark_mc_segmap_parloop_339245_total_runtime;
    int *futhark_mc_segmap_parloop_339245_runs;
    int64_t *futhark_mc_segmap_parloop_339245_iter;
    int64_t futhark_mc_segmap_parloop_339245_total_total_runtime;
    int futhark_mc_segmap_parloop_339245_total_runs;
    int64_t futhark_mc_segmap_parloop_339245_total_iter;
    int64_t *futhark_mc_segmap_task_339243_total_runtime;
    int *futhark_mc_segmap_task_339243_runs;
    int64_t *futhark_mc_segmap_task_339243_iter;
    int64_t futhark_mc_segmap_task_339243_total_time;
    int64_t futhark_mc_segmap_task_339243_total_iter;
    int64_t *futhark_mc_seghist_stage_1_parloop_339250_total_runtime;
    int *futhark_mc_seghist_stage_1_parloop_339250_runs;
    int64_t *futhark_mc_seghist_stage_1_parloop_339250_iter;
    int64_t futhark_mc_seghist_stage_1_parloop_339250_total_total_runtime;
    int futhark_mc_seghist_stage_1_parloop_339250_total_runs;
    int64_t futhark_mc_seghist_stage_1_parloop_339250_total_iter;
    int64_t *futhark_mc_segmented_segred_parloop_339255_total_runtime;
    int *futhark_mc_segmented_segred_parloop_339255_runs;
    int64_t *futhark_mc_segmented_segred_parloop_339255_iter;
    int64_t futhark_mc_segmented_segred_parloop_339255_total_total_runtime;
    int futhark_mc_segmented_segred_parloop_339255_total_runs;
    int64_t futhark_mc_segmented_segred_parloop_339255_total_iter;
    int64_t *futhark_mc_seghist_red_task_339253_total_runtime;
    int *futhark_mc_seghist_red_task_339253_runs;
    int64_t *futhark_mc_seghist_red_task_339253_iter;
    int64_t futhark_mc_seghist_red_task_339253_total_time;
    int64_t futhark_mc_seghist_red_task_339253_total_iter;
    int64_t *futhark_mc_atomic_seg_hist_parloop_339257_total_runtime;
    int *futhark_mc_atomic_seg_hist_parloop_339257_runs;
    int64_t *futhark_mc_atomic_seg_hist_parloop_339257_iter;
    int64_t futhark_mc_atomic_seg_hist_parloop_339257_total_total_runtime;
    int futhark_mc_atomic_seg_hist_parloop_339257_total_runs;
    int64_t futhark_mc_atomic_seg_hist_parloop_339257_total_iter;
    int64_t *futhark_mc_seghist_task_339247_total_runtime;
    int *futhark_mc_seghist_task_339247_runs;
    int64_t *futhark_mc_seghist_task_339247_iter;
    int64_t futhark_mc_seghist_task_339247_total_time;
    int64_t futhark_mc_seghist_task_339247_total_iter;
    int64_t *futhark_mc_segmap_parloop_339261_total_runtime;
    int *futhark_mc_segmap_parloop_339261_runs;
    int64_t *futhark_mc_segmap_parloop_339261_iter;
    int64_t futhark_mc_segmap_parloop_339261_total_total_runtime;
    int futhark_mc_segmap_parloop_339261_total_runs;
    int64_t futhark_mc_segmap_parloop_339261_total_iter;
    int64_t *futhark_mc_segmap_task_339259_total_runtime;
    int *futhark_mc_segmap_task_339259_runs;
    int64_t *futhark_mc_segmap_task_339259_iter;
    int64_t futhark_mc_segmap_task_339259_total_time;
    int64_t futhark_mc_segmap_task_339259_total_iter;
    int64_t *futhark_mc_segmap_parloop_339265_total_runtime;
    int *futhark_mc_segmap_parloop_339265_runs;
    int64_t *futhark_mc_segmap_parloop_339265_iter;
    int64_t futhark_mc_segmap_parloop_339265_total_total_runtime;
    int futhark_mc_segmap_parloop_339265_total_runs;
    int64_t futhark_mc_segmap_parloop_339265_total_iter;
    int64_t *futhark_mc_segmap_task_339263_total_runtime;
    int *futhark_mc_segmap_task_339263_runs;
    int64_t *futhark_mc_segmap_task_339263_iter;
    int64_t futhark_mc_segmap_task_339263_total_time;
    int64_t futhark_mc_segmap_task_339263_total_iter;
    int64_t *futhark_mc_segmap_parloop_339269_total_runtime;
    int *futhark_mc_segmap_parloop_339269_runs;
    int64_t *futhark_mc_segmap_parloop_339269_iter;
    int64_t futhark_mc_segmap_parloop_339269_total_total_runtime;
    int futhark_mc_segmap_parloop_339269_total_runs;
    int64_t futhark_mc_segmap_parloop_339269_total_iter;
    int64_t *futhark_mc_segmap_task_339267_total_runtime;
    int *futhark_mc_segmap_task_339267_runs;
    int64_t *futhark_mc_segmap_task_339267_iter;
    int64_t futhark_mc_segmap_task_339267_total_time;
    int64_t futhark_mc_segmap_task_339267_total_iter;
    int64_t *futhark_mc_scan_stage_1_parloop_339274_total_runtime;
    int *futhark_mc_scan_stage_1_parloop_339274_runs;
    int64_t *futhark_mc_scan_stage_1_parloop_339274_iter;
    int64_t futhark_mc_scan_stage_1_parloop_339274_total_total_runtime;
    int futhark_mc_scan_stage_1_parloop_339274_total_runs;
    int64_t futhark_mc_scan_stage_1_parloop_339274_total_iter;
    int64_t *futhark_mc_scan_stage_3_parloop_339276_total_runtime;
    int *futhark_mc_scan_stage_3_parloop_339276_runs;
    int64_t *futhark_mc_scan_stage_3_parloop_339276_iter;
    int64_t futhark_mc_scan_stage_3_parloop_339276_total_total_runtime;
    int futhark_mc_scan_stage_3_parloop_339276_total_runs;
    int64_t futhark_mc_scan_stage_3_parloop_339276_total_iter;
    int64_t *futhark_mc_segscan_task_339271_total_runtime;
    int *futhark_mc_segscan_task_339271_runs;
    int64_t *futhark_mc_segscan_task_339271_iter;
    int64_t futhark_mc_segscan_task_339271_total_time;
    int64_t futhark_mc_segscan_task_339271_total_iter;
    int64_t *futhark_mc_segmap_parloop_339280_total_runtime;
    int *futhark_mc_segmap_parloop_339280_runs;
    int64_t *futhark_mc_segmap_parloop_339280_iter;
    int64_t futhark_mc_segmap_parloop_339280_total_total_runtime;
    int futhark_mc_segmap_parloop_339280_total_runs;
    int64_t futhark_mc_segmap_parloop_339280_total_iter;
    int64_t *futhark_mc_segmap_task_339278_total_runtime;
    int *futhark_mc_segmap_task_339278_runs;
    int64_t *futhark_mc_segmap_task_339278_iter;
    int64_t futhark_mc_segmap_task_339278_total_time;
    int64_t futhark_mc_segmap_task_339278_total_iter;
    int64_t *futhark_mc_segmap_parloop_339284_total_runtime;
    int *futhark_mc_segmap_parloop_339284_runs;
    int64_t *futhark_mc_segmap_parloop_339284_iter;
    int64_t futhark_mc_segmap_parloop_339284_total_total_runtime;
    int futhark_mc_segmap_parloop_339284_total_runs;
    int64_t futhark_mc_segmap_parloop_339284_total_iter;
    int64_t *futhark_mc_segmap_task_339282_total_runtime;
    int *futhark_mc_segmap_task_339282_runs;
    int64_t *futhark_mc_segmap_task_339282_iter;
    int64_t futhark_mc_segmap_task_339282_total_time;
    int64_t futhark_mc_segmap_task_339282_total_iter;
    int64_t *futhark_mc_segred_stage_1_parloop_339294_total_runtime;
    int *futhark_mc_segred_stage_1_parloop_339294_runs;
    int64_t *futhark_mc_segred_stage_1_parloop_339294_iter;
    int64_t futhark_mc_segred_stage_1_parloop_339294_total_total_runtime;
    int futhark_mc_segred_stage_1_parloop_339294_total_runs;
    int64_t futhark_mc_segred_stage_1_parloop_339294_total_iter;
    int64_t *futhark_mc_segred_task_339289_total_runtime;
    int *futhark_mc_segred_task_339289_runs;
    int64_t *futhark_mc_segred_task_339289_iter;
    int64_t futhark_mc_segred_task_339289_total_time;
    int64_t futhark_mc_segred_task_339289_total_iter;
    int64_t *futhark_mc_segmap_parloop_339287_total_runtime;
    int *futhark_mc_segmap_parloop_339287_runs;
    int64_t *futhark_mc_segmap_parloop_339287_iter;
    int64_t futhark_mc_segmap_parloop_339287_total_total_runtime;
    int futhark_mc_segmap_parloop_339287_total_runs;
    int64_t futhark_mc_segmap_parloop_339287_total_iter;
    int64_t *futhark_mc_segmap_nested_task_339285_total_runtime;
    int *futhark_mc_segmap_nested_task_339285_runs;
    int64_t *futhark_mc_segmap_nested_task_339285_iter;
    int64_t *futhark_mc_segmap_parloop_339298_total_runtime;
    int *futhark_mc_segmap_parloop_339298_runs;
    int64_t *futhark_mc_segmap_parloop_339298_iter;
    int64_t futhark_mc_segmap_parloop_339298_total_total_runtime;
    int futhark_mc_segmap_parloop_339298_total_runs;
    int64_t futhark_mc_segmap_parloop_339298_total_iter;
    int64_t *futhark_mc_segmap_task_339296_total_runtime;
    int *futhark_mc_segmap_task_339296_runs;
    int64_t *futhark_mc_segmap_task_339296_iter;
    int64_t futhark_mc_segmap_task_339296_total_time;
    int64_t futhark_mc_segmap_task_339296_total_iter;
    int64_t *futhark_mc_segmap_parloop_339307_total_runtime;
    int *futhark_mc_segmap_parloop_339307_runs;
    int64_t *futhark_mc_segmap_parloop_339307_iter;
    int64_t futhark_mc_segmap_parloop_339307_total_total_runtime;
    int futhark_mc_segmap_parloop_339307_total_runs;
    int64_t futhark_mc_segmap_parloop_339307_total_iter;
    int64_t *futhark_mc_segmap_task_339305_total_runtime;
    int *futhark_mc_segmap_task_339305_runs;
    int64_t *futhark_mc_segmap_task_339305_iter;
    int64_t futhark_mc_segmap_task_339305_total_time;
    int64_t futhark_mc_segmap_task_339305_total_iter;
    int64_t *futhark_mc_segmap_parloop_339302_total_runtime;
    int *futhark_mc_segmap_parloop_339302_runs;
    int64_t *futhark_mc_segmap_parloop_339302_iter;
    int64_t futhark_mc_segmap_parloop_339302_total_total_runtime;
    int futhark_mc_segmap_parloop_339302_total_runs;
    int64_t futhark_mc_segmap_parloop_339302_total_iter;
    int64_t *futhark_mc_segmap_nested_task_339300_total_runtime;
    int *futhark_mc_segmap_nested_task_339300_runs;
    int64_t *futhark_mc_segmap_nested_task_339300_iter;
    int64_t *futhark_mc_segmap_parloop_339318_total_runtime;
    int *futhark_mc_segmap_parloop_339318_runs;
    int64_t *futhark_mc_segmap_parloop_339318_iter;
    int64_t futhark_mc_segmap_parloop_339318_total_total_runtime;
    int futhark_mc_segmap_parloop_339318_total_runs;
    int64_t futhark_mc_segmap_parloop_339318_total_iter;
    int64_t *futhark_mc_segmap_task_339316_total_runtime;
    int *futhark_mc_segmap_task_339316_runs;
    int64_t *futhark_mc_segmap_task_339316_iter;
    int64_t futhark_mc_segmap_task_339316_total_time;
    int64_t futhark_mc_segmap_task_339316_total_iter;
    int64_t *futhark_mc_segmap_parloop_339311_total_runtime;
    int *futhark_mc_segmap_parloop_339311_runs;
    int64_t *futhark_mc_segmap_parloop_339311_iter;
    int64_t futhark_mc_segmap_parloop_339311_total_total_runtime;
    int futhark_mc_segmap_parloop_339311_total_runs;
    int64_t futhark_mc_segmap_parloop_339311_total_iter;
    int64_t *futhark_mc_segmap_task_339309_total_runtime;
    int *futhark_mc_segmap_task_339309_runs;
    int64_t *futhark_mc_segmap_task_339309_iter;
    int64_t futhark_mc_segmap_task_339309_total_time;
    int64_t futhark_mc_segmap_task_339309_total_iter;
    int64_t *futhark_mc_segmap_parloop_339323_total_runtime;
    int *futhark_mc_segmap_parloop_339323_runs;
    int64_t *futhark_mc_segmap_parloop_339323_iter;
    int64_t futhark_mc_segmap_parloop_339323_total_total_runtime;
    int futhark_mc_segmap_parloop_339323_total_runs;
    int64_t futhark_mc_segmap_parloop_339323_total_iter;
    int64_t *futhark_mc_segmap_task_339321_total_runtime;
    int *futhark_mc_segmap_task_339321_runs;
    int64_t *futhark_mc_segmap_task_339321_iter;
    int64_t futhark_mc_segmap_task_339321_total_time;
    int64_t futhark_mc_segmap_task_339321_total_iter;
    int64_t *futhark_mc_segred_stage_1_parloop_339332_total_runtime;
    int *futhark_mc_segred_stage_1_parloop_339332_runs;
    int64_t *futhark_mc_segred_stage_1_parloop_339332_iter;
    int64_t futhark_mc_segred_stage_1_parloop_339332_total_total_runtime;
    int futhark_mc_segred_stage_1_parloop_339332_total_runs;
    int64_t futhark_mc_segred_stage_1_parloop_339332_total_iter;
    int64_t *futhark_mc_segred_task_339328_total_runtime;
    int *futhark_mc_segred_task_339328_runs;
    int64_t *futhark_mc_segred_task_339328_iter;
    int64_t futhark_mc_segred_task_339328_total_time;
    int64_t futhark_mc_segred_task_339328_total_iter;
    int64_t *futhark_mc_segmap_parloop_339326_total_runtime;
    int *futhark_mc_segmap_parloop_339326_runs;
    int64_t *futhark_mc_segmap_parloop_339326_iter;
    int64_t futhark_mc_segmap_parloop_339326_total_total_runtime;
    int futhark_mc_segmap_parloop_339326_total_runs;
    int64_t futhark_mc_segmap_parloop_339326_total_iter;
    int64_t *futhark_mc_segmap_nested_task_339324_total_runtime;
    int *futhark_mc_segmap_nested_task_339324_runs;
    int64_t *futhark_mc_segmap_nested_task_339324_iter;
    int64_t *futhark_mc_segred_stage_1_parloop_339340_total_runtime;
    int *futhark_mc_segred_stage_1_parloop_339340_runs;
    int64_t *futhark_mc_segred_stage_1_parloop_339340_iter;
    int64_t futhark_mc_segred_stage_1_parloop_339340_total_total_runtime;
    int futhark_mc_segred_stage_1_parloop_339340_total_runs;
    int64_t futhark_mc_segred_stage_1_parloop_339340_total_iter;
    int64_t *futhark_mc_segred_task_339336_total_runtime;
    int *futhark_mc_segred_task_339336_runs;
    int64_t *futhark_mc_segred_task_339336_iter;
    int64_t futhark_mc_segred_task_339336_total_time;
    int64_t futhark_mc_segred_task_339336_total_iter;
    int64_t *futhark_mc_segmap_parloop_339344_total_runtime;
    int *futhark_mc_segmap_parloop_339344_runs;
    int64_t *futhark_mc_segmap_parloop_339344_iter;
    int64_t futhark_mc_segmap_parloop_339344_total_total_runtime;
    int futhark_mc_segmap_parloop_339344_total_runs;
    int64_t futhark_mc_segmap_parloop_339344_total_iter;
    int64_t *futhark_mc_segmap_task_339342_total_runtime;
    int *futhark_mc_segmap_task_339342_runs;
    int64_t *futhark_mc_segmap_task_339342_iter;
    int64_t futhark_mc_segmap_task_339342_total_time;
    int64_t futhark_mc_segmap_task_339342_total_iter;
    int64_t *futhark_mc_segred_stage_1_parloop_339352_total_runtime;
    int *futhark_mc_segred_stage_1_parloop_339352_runs;
    int64_t *futhark_mc_segred_stage_1_parloop_339352_iter;
    int64_t futhark_mc_segred_stage_1_parloop_339352_total_total_runtime;
    int futhark_mc_segred_stage_1_parloop_339352_total_runs;
    int64_t futhark_mc_segred_stage_1_parloop_339352_total_iter;
    int64_t *futhark_mc_segred_task_339349_total_runtime;
    int *futhark_mc_segred_task_339349_runs;
    int64_t *futhark_mc_segred_task_339349_iter;
    int64_t futhark_mc_segred_task_339349_total_time;
    int64_t futhark_mc_segred_task_339349_total_iter;
    int64_t *futhark_mc_segmap_parloop_339347_total_runtime;
    int *futhark_mc_segmap_parloop_339347_runs;
    int64_t *futhark_mc_segmap_parloop_339347_iter;
    int64_t futhark_mc_segmap_parloop_339347_total_total_runtime;
    int futhark_mc_segmap_parloop_339347_total_runs;
    int64_t futhark_mc_segmap_parloop_339347_total_iter;
    int64_t *futhark_mc_segmap_nested_task_339345_total_runtime;
    int *futhark_mc_segmap_nested_task_339345_runs;
    int64_t *futhark_mc_segmap_nested_task_339345_iter;
    int64_t tuning_timing;
    int64_t tuning_iter;
};
struct futhark_context *futhark_context_new(struct futhark_context_config *cfg)
{
    assert(!cfg->in_use);
    
    struct futhark_context *ctx =
                           (struct futhark_context *) malloc(sizeof(struct futhark_context));
    
    if (ctx == NULL)
        return NULL;
    ctx->cfg = cfg;
    ctx->cfg->in_use = 1;
    // Initialize rand()
    fast_srand(time(0));
    ctx->detail_memory = cfg->debugging;
    ctx->debugging = cfg->debugging;
    ctx->profiling = cfg->profiling;
    ctx->profiling_paused = 0;
    ctx->logging = 0;
    ctx->error = NULL;
    ctx->log = stderr;
    create_lock(&ctx->lock);
    
    int tune_kappa = 0;
    double kappa = 5.1f * 1000;
    
    if (tune_kappa) {
        if (determine_kappa(&kappa) != 0)
            return NULL;
    }
    if (scheduler_init(&ctx->scheduler, cfg->num_threads >
                       0 ? cfg->num_threads : num_processors(), kappa) != 0)
        return NULL;
    ctx->peak_mem_usage_default = 0;
    ctx->cur_mem_usage_default = 0;
    ctx->futhark_mc_segred_stage_1_parloop_337688_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_337688_runs = calloc(sizeof(int),
                                                                ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_337688_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_337688_total_total_runtime = 0;
    ctx->futhark_mc_segred_stage_1_parloop_337688_total_runs = 0;
    ctx->futhark_mc_segred_stage_1_parloop_337688_total_iter = 0;
    ctx->futhark_mc_segred_task_337685_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_337685_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_337685_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_337685_total_time = 0;
    ctx->futhark_mc_segred_task_337685_total_iter = 0;
    ctx->futhark_mc_segred_stage_1_parloop_337697_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_337697_runs = calloc(sizeof(int),
                                                                ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_337697_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_337697_total_total_runtime = 0;
    ctx->futhark_mc_segred_stage_1_parloop_337697_total_runs = 0;
    ctx->futhark_mc_segred_stage_1_parloop_337697_total_iter = 0;
    ctx->futhark_mc_segred_task_337694_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_337694_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_337694_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_337694_total_time = 0;
    ctx->futhark_mc_segred_task_337694_total_iter = 0;
    ctx->futhark_mc_segred_stage_1_parloop_337692_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_337692_runs = calloc(sizeof(int),
                                                                ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_337692_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_337692_total_total_runtime = 0;
    ctx->futhark_mc_segred_stage_1_parloop_337692_total_runs = 0;
    ctx->futhark_mc_segred_stage_1_parloop_337692_total_iter = 0;
    ctx->futhark_mc_segred_nested_task_337689_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_nested_task_337689_runs = calloc(sizeof(int),
                                                            ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_nested_task_337689_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_scan_stage_1_parloop_337683_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_scan_stage_1_parloop_337683_runs = calloc(sizeof(int),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_scan_stage_1_parloop_337683_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_scan_stage_1_parloop_337683_total_total_runtime = 0;
    ctx->futhark_mc_scan_stage_1_parloop_337683_total_runs = 0;
    ctx->futhark_mc_scan_stage_1_parloop_337683_total_iter = 0;
    ctx->futhark_mc_segred_stage_1_parloop_337702_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_337702_runs = calloc(sizeof(int),
                                                                ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_337702_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_337702_total_total_runtime = 0;
    ctx->futhark_mc_segred_stage_1_parloop_337702_total_runs = 0;
    ctx->futhark_mc_segred_stage_1_parloop_337702_total_iter = 0;
    ctx->futhark_mc_segred_task_337699_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_337699_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_337699_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_337699_total_time = 0;
    ctx->futhark_mc_segred_task_337699_total_iter = 0;
    ctx->futhark_mc_segred_stage_1_parloop_337711_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_337711_runs = calloc(sizeof(int),
                                                                ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_337711_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_337711_total_total_runtime = 0;
    ctx->futhark_mc_segred_stage_1_parloop_337711_total_runs = 0;
    ctx->futhark_mc_segred_stage_1_parloop_337711_total_iter = 0;
    ctx->futhark_mc_segred_task_337708_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_337708_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_337708_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_337708_total_time = 0;
    ctx->futhark_mc_segred_task_337708_total_iter = 0;
    ctx->futhark_mc_segred_stage_1_parloop_337706_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_337706_runs = calloc(sizeof(int),
                                                                ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_337706_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_337706_total_total_runtime = 0;
    ctx->futhark_mc_segred_stage_1_parloop_337706_total_runs = 0;
    ctx->futhark_mc_segred_stage_1_parloop_337706_total_iter = 0;
    ctx->futhark_mc_segred_nested_task_337703_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_nested_task_337703_runs = calloc(sizeof(int),
                                                            ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_nested_task_337703_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_337718_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_337718_runs = calloc(sizeof(int),
                                                                ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_337718_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_337718_total_total_runtime = 0;
    ctx->futhark_mc_segred_stage_1_parloop_337718_total_runs = 0;
    ctx->futhark_mc_segred_stage_1_parloop_337718_total_iter = 0;
    ctx->futhark_mc_segred_task_337715_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_337715_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_337715_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_337715_total_time = 0;
    ctx->futhark_mc_segred_task_337715_total_iter = 0;
    ctx->futhark_mc_segred_stage_1_parloop_337727_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_337727_runs = calloc(sizeof(int),
                                                                ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_337727_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_337727_total_total_runtime = 0;
    ctx->futhark_mc_segred_stage_1_parloop_337727_total_runs = 0;
    ctx->futhark_mc_segred_stage_1_parloop_337727_total_iter = 0;
    ctx->futhark_mc_segred_task_337724_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_337724_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_337724_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_337724_total_time = 0;
    ctx->futhark_mc_segred_task_337724_total_iter = 0;
    ctx->futhark_mc_segred_stage_1_parloop_337722_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_337722_runs = calloc(sizeof(int),
                                                                ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_337722_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_337722_total_total_runtime = 0;
    ctx->futhark_mc_segred_stage_1_parloop_337722_total_runs = 0;
    ctx->futhark_mc_segred_stage_1_parloop_337722_total_iter = 0;
    ctx->futhark_mc_segred_nested_task_337719_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_nested_task_337719_runs = calloc(sizeof(int),
                                                            ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_nested_task_337719_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_scan_stage_3_parloop_337713_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_scan_stage_3_parloop_337713_runs = calloc(sizeof(int),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_scan_stage_3_parloop_337713_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_scan_stage_3_parloop_337713_total_total_runtime = 0;
    ctx->futhark_mc_scan_stage_3_parloop_337713_total_runs = 0;
    ctx->futhark_mc_scan_stage_3_parloop_337713_total_iter = 0;
    ctx->futhark_mc_segscan_task_337680_total_runtime = calloc(sizeof(int64_t),
                                                               ctx->scheduler.num_threads);
    ctx->futhark_mc_segscan_task_337680_runs = calloc(sizeof(int),
                                                      ctx->scheduler.num_threads);
    ctx->futhark_mc_segscan_task_337680_iter = calloc(sizeof(sizeof(int64_t)),
                                                      ctx->scheduler.num_threads);
    ctx->futhark_mc_segscan_task_337680_total_time = 0;
    ctx->futhark_mc_segscan_task_337680_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_337731_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337731_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337731_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337731_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_337731_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_337731_total_iter = 0;
    ctx->futhark_mc_segmap_task_337729_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_337729_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_337729_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_337729_total_time = 0;
    ctx->futhark_mc_segmap_task_337729_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_337735_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337735_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337735_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337735_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_337735_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_337735_total_iter = 0;
    ctx->futhark_mc_segmap_task_337733_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_337733_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_337733_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_337733_total_time = 0;
    ctx->futhark_mc_segmap_task_337733_total_iter = 0;
    ctx->futhark_mc_scan_stage_1_parloop_337747_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_scan_stage_1_parloop_337747_runs = calloc(sizeof(int),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_scan_stage_1_parloop_337747_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_scan_stage_1_parloop_337747_total_total_runtime = 0;
    ctx->futhark_mc_scan_stage_1_parloop_337747_total_runs = 0;
    ctx->futhark_mc_scan_stage_1_parloop_337747_total_iter = 0;
    ctx->futhark_mc_scan_stage_3_parloop_337749_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_scan_stage_3_parloop_337749_runs = calloc(sizeof(int),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_scan_stage_3_parloop_337749_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_scan_stage_3_parloop_337749_total_total_runtime = 0;
    ctx->futhark_mc_scan_stage_3_parloop_337749_total_runs = 0;
    ctx->futhark_mc_scan_stage_3_parloop_337749_total_iter = 0;
    ctx->futhark_mc_segscan_task_337744_total_runtime = calloc(sizeof(int64_t),
                                                               ctx->scheduler.num_threads);
    ctx->futhark_mc_segscan_task_337744_runs = calloc(sizeof(int),
                                                      ctx->scheduler.num_threads);
    ctx->futhark_mc_segscan_task_337744_iter = calloc(sizeof(sizeof(int64_t)),
                                                      ctx->scheduler.num_threads);
    ctx->futhark_mc_segscan_task_337744_total_time = 0;
    ctx->futhark_mc_segscan_task_337744_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_337753_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337753_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337753_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337753_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_337753_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_337753_total_iter = 0;
    ctx->futhark_mc_segmap_task_337751_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_337751_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_337751_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_337751_total_time = 0;
    ctx->futhark_mc_segmap_task_337751_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_337740_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337740_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337740_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337740_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_337740_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_337740_total_iter = 0;
    ctx->futhark_mc_segmap_nested_task_337738_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_337738_runs = calloc(sizeof(int),
                                                            ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_337738_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337757_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337757_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337757_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337757_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_337757_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_337757_total_iter = 0;
    ctx->futhark_mc_segmap_task_337755_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_337755_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_337755_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_337755_total_time = 0;
    ctx->futhark_mc_segmap_task_337755_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_337766_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337766_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337766_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337766_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_337766_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_337766_total_iter = 0;
    ctx->futhark_mc_segmap_task_337764_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_337764_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_337764_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_337764_total_time = 0;
    ctx->futhark_mc_segmap_task_337764_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_337775_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337775_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337775_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337775_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_337775_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_337775_total_iter = 0;
    ctx->futhark_mc_segmap_task_337773_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_337773_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_337773_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_337773_total_time = 0;
    ctx->futhark_mc_segmap_task_337773_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_337770_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337770_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337770_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337770_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_337770_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_337770_total_iter = 0;
    ctx->futhark_mc_segmap_nested_task_337768_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_337768_runs = calloc(sizeof(int),
                                                            ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_337768_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337761_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337761_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337761_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337761_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_337761_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_337761_total_iter = 0;
    ctx->futhark_mc_segmap_nested_task_337759_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_337759_runs = calloc(sizeof(int),
                                                            ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_337759_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337779_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337779_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337779_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337779_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_337779_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_337779_total_iter = 0;
    ctx->futhark_mc_segmap_task_337777_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_337777_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_337777_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_337777_total_time = 0;
    ctx->futhark_mc_segmap_task_337777_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_337792_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337792_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337792_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337792_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_337792_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_337792_total_iter = 0;
    ctx->futhark_mc_segmap_task_337790_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_337790_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_337790_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_337790_total_time = 0;
    ctx->futhark_mc_segmap_task_337790_total_iter = 0;
    ctx->futhark_mc_scan_stage_1_parloop_337804_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_scan_stage_1_parloop_337804_runs = calloc(sizeof(int),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_scan_stage_1_parloop_337804_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_scan_stage_1_parloop_337804_total_total_runtime = 0;
    ctx->futhark_mc_scan_stage_1_parloop_337804_total_runs = 0;
    ctx->futhark_mc_scan_stage_1_parloop_337804_total_iter = 0;
    ctx->futhark_mc_scan_stage_3_parloop_337806_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_scan_stage_3_parloop_337806_runs = calloc(sizeof(int),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_scan_stage_3_parloop_337806_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_scan_stage_3_parloop_337806_total_total_runtime = 0;
    ctx->futhark_mc_scan_stage_3_parloop_337806_total_runs = 0;
    ctx->futhark_mc_scan_stage_3_parloop_337806_total_iter = 0;
    ctx->futhark_mc_segscan_task_337801_total_runtime = calloc(sizeof(int64_t),
                                                               ctx->scheduler.num_threads);
    ctx->futhark_mc_segscan_task_337801_runs = calloc(sizeof(int),
                                                      ctx->scheduler.num_threads);
    ctx->futhark_mc_segscan_task_337801_iter = calloc(sizeof(sizeof(int64_t)),
                                                      ctx->scheduler.num_threads);
    ctx->futhark_mc_segscan_task_337801_total_time = 0;
    ctx->futhark_mc_segscan_task_337801_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_337810_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337810_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337810_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337810_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_337810_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_337810_total_iter = 0;
    ctx->futhark_mc_segmap_task_337808_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_337808_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_337808_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_337808_total_time = 0;
    ctx->futhark_mc_segmap_task_337808_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_337797_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337797_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337797_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337797_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_337797_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_337797_total_iter = 0;
    ctx->futhark_mc_segmap_nested_task_337795_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_337795_runs = calloc(sizeof(int),
                                                            ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_337795_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337786_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337786_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337786_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337786_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_337786_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_337786_total_iter = 0;
    ctx->futhark_mc_segmap_nested_task_337784_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_337784_runs = calloc(sizeof(int),
                                                            ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_337784_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337814_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337814_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337814_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337814_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_337814_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_337814_total_iter = 0;
    ctx->futhark_mc_segmap_task_337812_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_337812_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_337812_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_337812_total_time = 0;
    ctx->futhark_mc_segmap_task_337812_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_337826_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337826_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337826_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337826_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_337826_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_337826_total_iter = 0;
    ctx->futhark_mc_segmap_task_337824_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_337824_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_337824_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_337824_total_time = 0;
    ctx->futhark_mc_segmap_task_337824_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_337839_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337839_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337839_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337839_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_337839_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_337839_total_iter = 0;
    ctx->futhark_mc_segmap_task_337837_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_337837_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_337837_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_337837_total_time = 0;
    ctx->futhark_mc_segmap_task_337837_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_337843_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337843_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337843_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337843_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_337843_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_337843_total_iter = 0;
    ctx->futhark_mc_segmap_task_337841_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_337841_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_337841_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_337841_total_time = 0;
    ctx->futhark_mc_segmap_task_337841_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_337832_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337832_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337832_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337832_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_337832_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_337832_total_iter = 0;
    ctx->futhark_mc_segmap_nested_task_337830_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_337830_runs = calloc(sizeof(int),
                                                            ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_337830_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337820_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337820_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337820_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337820_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_337820_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_337820_total_iter = 0;
    ctx->futhark_mc_segmap_nested_task_337818_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_337818_runs = calloc(sizeof(int),
                                                            ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_337818_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337847_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337847_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337847_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337847_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_337847_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_337847_total_iter = 0;
    ctx->futhark_mc_segmap_task_337845_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_337845_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_337845_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_337845_total_time = 0;
    ctx->futhark_mc_segmap_task_337845_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_337860_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337860_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337860_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337860_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_337860_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_337860_total_iter = 0;
    ctx->futhark_mc_segmap_task_337858_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_337858_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_337858_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_337858_total_time = 0;
    ctx->futhark_mc_segmap_task_337858_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_337864_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337864_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337864_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337864_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_337864_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_337864_total_iter = 0;
    ctx->futhark_mc_segmap_task_337862_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_337862_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_337862_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_337862_total_time = 0;
    ctx->futhark_mc_segmap_task_337862_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_337853_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337853_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337853_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337853_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_337853_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_337853_total_iter = 0;
    ctx->futhark_mc_segmap_nested_task_337851_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_337851_runs = calloc(sizeof(int),
                                                            ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_337851_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337868_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337868_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337868_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337868_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_337868_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_337868_total_iter = 0;
    ctx->futhark_mc_segmap_task_337866_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_337866_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_337866_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_337866_total_time = 0;
    ctx->futhark_mc_segmap_task_337866_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_337881_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337881_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337881_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337881_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_337881_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_337881_total_iter = 0;
    ctx->futhark_mc_segmap_task_337879_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_337879_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_337879_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_337879_total_time = 0;
    ctx->futhark_mc_segmap_task_337879_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_337885_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337885_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337885_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337885_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_337885_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_337885_total_iter = 0;
    ctx->futhark_mc_segmap_task_337883_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_337883_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_337883_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_337883_total_time = 0;
    ctx->futhark_mc_segmap_task_337883_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_337874_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337874_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337874_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337874_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_337874_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_337874_total_iter = 0;
    ctx->futhark_mc_segmap_nested_task_337872_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_337872_runs = calloc(sizeof(int),
                                                            ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_337872_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337889_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337889_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337889_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337889_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_337889_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_337889_total_iter = 0;
    ctx->futhark_mc_segmap_task_337887_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_337887_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_337887_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_337887_total_time = 0;
    ctx->futhark_mc_segmap_task_337887_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_337898_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337898_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337898_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337898_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_337898_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_337898_total_iter = 0;
    ctx->futhark_mc_segmap_task_337896_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_337896_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_337896_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_337896_total_time = 0;
    ctx->futhark_mc_segmap_task_337896_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_337893_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337893_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337893_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337893_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_337893_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_337893_total_iter = 0;
    ctx->futhark_mc_segmap_nested_task_337891_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_337891_runs = calloc(sizeof(int),
                                                            ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_337891_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337902_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337902_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337902_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337902_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_337902_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_337902_total_iter = 0;
    ctx->futhark_mc_segmap_task_337900_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_337900_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_337900_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_337900_total_time = 0;
    ctx->futhark_mc_segmap_task_337900_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_337913_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337913_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337913_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337913_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_337913_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_337913_total_iter = 0;
    ctx->futhark_mc_segmap_task_337911_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_337911_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_337911_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_337911_total_time = 0;
    ctx->futhark_mc_segmap_task_337911_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_337924_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337924_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337924_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337924_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_337924_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_337924_total_iter = 0;
    ctx->futhark_mc_segmap_task_337922_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_337922_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_337922_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_337922_total_time = 0;
    ctx->futhark_mc_segmap_task_337922_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_337918_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337918_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337918_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337918_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_337918_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_337918_total_iter = 0;
    ctx->futhark_mc_segmap_nested_task_337916_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_337916_runs = calloc(sizeof(int),
                                                            ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_337916_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337907_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337907_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337907_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337907_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_337907_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_337907_total_iter = 0;
    ctx->futhark_mc_segmap_nested_task_337905_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_337905_runs = calloc(sizeof(int),
                                                            ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_337905_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337928_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337928_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337928_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337928_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_337928_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_337928_total_iter = 0;
    ctx->futhark_mc_segmap_task_337926_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_337926_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_337926_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_337926_total_time = 0;
    ctx->futhark_mc_segmap_task_337926_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_337937_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337937_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337937_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337937_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_337937_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_337937_total_iter = 0;
    ctx->futhark_mc_segmap_task_337935_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_337935_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_337935_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_337935_total_time = 0;
    ctx->futhark_mc_segmap_task_337935_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_337946_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337946_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337946_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337946_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_337946_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_337946_total_iter = 0;
    ctx->futhark_mc_segmap_task_337944_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_337944_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_337944_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_337944_total_time = 0;
    ctx->futhark_mc_segmap_task_337944_total_iter = 0;
    ctx->futhark_mc_segred_stage_1_parloop_337954_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_337954_runs = calloc(sizeof(int),
                                                                ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_337954_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_337954_total_total_runtime = 0;
    ctx->futhark_mc_segred_stage_1_parloop_337954_total_runs = 0;
    ctx->futhark_mc_segred_stage_1_parloop_337954_total_iter = 0;
    ctx->futhark_mc_segred_task_337951_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_337951_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_337951_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_337951_total_time = 0;
    ctx->futhark_mc_segred_task_337951_total_iter = 0;
    ctx->futhark_mc_segred_stage_1_parloop_337959_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_337959_runs = calloc(sizeof(int),
                                                                ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_337959_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_337959_total_total_runtime = 0;
    ctx->futhark_mc_segred_stage_1_parloop_337959_total_runs = 0;
    ctx->futhark_mc_segred_stage_1_parloop_337959_total_iter = 0;
    ctx->futhark_mc_segred_task_337956_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_337956_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_337956_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_337956_total_time = 0;
    ctx->futhark_mc_segred_task_337956_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_337949_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337949_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337949_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337949_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_337949_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_337949_total_iter = 0;
    ctx->futhark_mc_segmap_nested_task_337947_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_337947_runs = calloc(sizeof(int),
                                                            ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_337947_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337941_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337941_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337941_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337941_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_337941_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_337941_total_iter = 0;
    ctx->futhark_mc_segmap_nested_task_337939_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_337939_runs = calloc(sizeof(int),
                                                            ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_337939_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337932_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337932_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337932_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337932_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_337932_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_337932_total_iter = 0;
    ctx->futhark_mc_segmap_nested_task_337930_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_337930_runs = calloc(sizeof(int),
                                                            ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_337930_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337963_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337963_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337963_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337963_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_337963_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_337963_total_iter = 0;
    ctx->futhark_mc_segmap_task_337961_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_337961_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_337961_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_337961_total_time = 0;
    ctx->futhark_mc_segmap_task_337961_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_337974_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337974_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337974_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337974_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_337974_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_337974_total_iter = 0;
    ctx->futhark_mc_segmap_task_337972_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_337972_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_337972_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_337972_total_time = 0;
    ctx->futhark_mc_segmap_task_337972_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_337985_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337985_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337985_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337985_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_337985_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_337985_total_iter = 0;
    ctx->futhark_mc_segmap_task_337983_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_337983_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_337983_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_337983_total_time = 0;
    ctx->futhark_mc_segmap_task_337983_total_iter = 0;
    ctx->futhark_mc_segred_stage_1_parloop_337995_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_337995_runs = calloc(sizeof(int),
                                                                ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_337995_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_337995_total_total_runtime = 0;
    ctx->futhark_mc_segred_stage_1_parloop_337995_total_runs = 0;
    ctx->futhark_mc_segred_stage_1_parloop_337995_total_iter = 0;
    ctx->futhark_mc_segred_task_337990_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_337990_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_337990_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_337990_total_time = 0;
    ctx->futhark_mc_segred_task_337990_total_iter = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338001_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338001_runs = calloc(sizeof(int),
                                                                ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338001_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338001_total_total_runtime = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338001_total_runs = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338001_total_iter = 0;
    ctx->futhark_mc_segred_task_337997_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_337997_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_337997_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_337997_total_time = 0;
    ctx->futhark_mc_segred_task_337997_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_337988_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337988_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337988_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337988_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_337988_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_337988_total_iter = 0;
    ctx->futhark_mc_segmap_nested_task_337986_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_337986_runs = calloc(sizeof(int),
                                                            ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_337986_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337979_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337979_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337979_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337979_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_337979_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_337979_total_iter = 0;
    ctx->futhark_mc_segmap_nested_task_337977_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_337977_runs = calloc(sizeof(int),
                                                            ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_337977_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337968_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337968_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337968_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_337968_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_337968_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_337968_total_iter = 0;
    ctx->futhark_mc_segmap_nested_task_337966_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_337966_runs = calloc(sizeof(int),
                                                            ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_337966_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338005_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338005_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338005_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338005_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338005_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338005_total_iter = 0;
    ctx->futhark_mc_segmap_task_338003_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338003_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338003_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338003_total_time = 0;
    ctx->futhark_mc_segmap_task_338003_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_338016_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338016_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338016_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338016_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338016_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338016_total_iter = 0;
    ctx->futhark_mc_segmap_task_338014_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338014_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338014_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338014_total_time = 0;
    ctx->futhark_mc_segmap_task_338014_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_338027_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338027_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338027_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338027_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338027_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338027_total_iter = 0;
    ctx->futhark_mc_segmap_task_338025_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338025_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338025_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338025_total_time = 0;
    ctx->futhark_mc_segmap_task_338025_total_iter = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338039_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338039_runs = calloc(sizeof(int),
                                                                ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338039_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338039_total_total_runtime = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338039_total_runs = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338039_total_iter = 0;
    ctx->futhark_mc_segred_task_338032_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338032_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338032_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338032_total_time = 0;
    ctx->futhark_mc_segred_task_338032_total_iter = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338045_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338045_runs = calloc(sizeof(int),
                                                                ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338045_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338045_total_total_runtime = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338045_total_runs = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338045_total_iter = 0;
    ctx->futhark_mc_segred_task_338041_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338041_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338041_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338041_total_time = 0;
    ctx->futhark_mc_segred_task_338041_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_338030_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338030_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338030_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338030_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338030_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338030_total_iter = 0;
    ctx->futhark_mc_segmap_nested_task_338028_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338028_runs = calloc(sizeof(int),
                                                            ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338028_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338021_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338021_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338021_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338021_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338021_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338021_total_iter = 0;
    ctx->futhark_mc_segmap_nested_task_338019_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338019_runs = calloc(sizeof(int),
                                                            ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338019_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338010_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338010_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338010_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338010_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338010_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338010_total_iter = 0;
    ctx->futhark_mc_segmap_nested_task_338008_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338008_runs = calloc(sizeof(int),
                                                            ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338008_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338049_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338049_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338049_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338049_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338049_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338049_total_iter = 0;
    ctx->futhark_mc_segmap_task_338047_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338047_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338047_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338047_total_time = 0;
    ctx->futhark_mc_segmap_task_338047_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_338059_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338059_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338059_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338059_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338059_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338059_total_iter = 0;
    ctx->futhark_mc_segmap_task_338057_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338057_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338057_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338057_total_time = 0;
    ctx->futhark_mc_segmap_task_338057_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_338069_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338069_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338069_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338069_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338069_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338069_total_iter = 0;
    ctx->futhark_mc_segmap_task_338067_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338067_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338067_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338067_total_time = 0;
    ctx->futhark_mc_segmap_task_338067_total_iter = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338079_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338079_runs = calloc(sizeof(int),
                                                                ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338079_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338079_total_total_runtime = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338079_total_runs = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338079_total_iter = 0;
    ctx->futhark_mc_segred_task_338076_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338076_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338076_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338076_total_time = 0;
    ctx->futhark_mc_segred_task_338076_total_iter = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338084_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338084_runs = calloc(sizeof(int),
                                                                ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338084_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338084_total_total_runtime = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338084_total_runs = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338084_total_iter = 0;
    ctx->futhark_mc_segred_task_338081_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338081_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338081_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338081_total_time = 0;
    ctx->futhark_mc_segred_task_338081_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_338073_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338073_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338073_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338073_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338073_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338073_total_iter = 0;
    ctx->futhark_mc_segmap_nested_task_338071_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338071_runs = calloc(sizeof(int),
                                                            ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338071_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338064_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338064_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338064_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338064_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338064_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338064_total_iter = 0;
    ctx->futhark_mc_segmap_nested_task_338062_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338062_runs = calloc(sizeof(int),
                                                            ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338062_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338054_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338054_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338054_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338054_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338054_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338054_total_iter = 0;
    ctx->futhark_mc_segmap_nested_task_338052_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338052_runs = calloc(sizeof(int),
                                                            ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338052_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338088_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338088_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338088_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338088_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338088_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338088_total_iter = 0;
    ctx->futhark_mc_segmap_task_338086_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338086_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338086_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338086_total_time = 0;
    ctx->futhark_mc_segmap_task_338086_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_338101_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338101_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338101_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338101_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338101_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338101_total_iter = 0;
    ctx->futhark_mc_segmap_task_338099_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338099_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338099_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338099_total_time = 0;
    ctx->futhark_mc_segmap_task_338099_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_338114_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338114_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338114_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338114_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338114_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338114_total_iter = 0;
    ctx->futhark_mc_segmap_task_338112_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338112_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338112_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338112_total_time = 0;
    ctx->futhark_mc_segmap_task_338112_total_iter = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338128_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338128_runs = calloc(sizeof(int),
                                                                ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338128_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338128_total_total_runtime = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338128_total_runs = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338128_total_iter = 0;
    ctx->futhark_mc_segred_task_338123_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338123_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338123_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338123_total_time = 0;
    ctx->futhark_mc_segred_task_338123_total_iter = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338134_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338134_runs = calloc(sizeof(int),
                                                                ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338134_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338134_total_total_runtime = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338134_total_runs = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338134_total_iter = 0;
    ctx->futhark_mc_segred_task_338130_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338130_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338130_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338130_total_time = 0;
    ctx->futhark_mc_segred_task_338130_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_338119_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338119_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338119_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338119_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338119_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338119_total_iter = 0;
    ctx->futhark_mc_segmap_nested_task_338117_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338117_runs = calloc(sizeof(int),
                                                            ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338117_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338108_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338108_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338108_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338108_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338108_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338108_total_iter = 0;
    ctx->futhark_mc_segmap_nested_task_338106_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338106_runs = calloc(sizeof(int),
                                                            ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338106_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338095_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338095_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338095_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338095_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338095_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338095_total_iter = 0;
    ctx->futhark_mc_segmap_nested_task_338093_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338093_runs = calloc(sizeof(int),
                                                            ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338093_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338138_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338138_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338138_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338138_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338138_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338138_total_iter = 0;
    ctx->futhark_mc_segmap_task_338136_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338136_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338136_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338136_total_time = 0;
    ctx->futhark_mc_segmap_task_338136_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_338153_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338153_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338153_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338153_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338153_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338153_total_iter = 0;
    ctx->futhark_mc_segmap_task_338151_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338151_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338151_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338151_total_time = 0;
    ctx->futhark_mc_segmap_task_338151_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_338168_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338168_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338168_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338168_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338168_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338168_total_iter = 0;
    ctx->futhark_mc_segmap_task_338166_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338166_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338166_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338166_total_time = 0;
    ctx->futhark_mc_segmap_task_338166_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_338183_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338183_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338183_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338183_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338183_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338183_total_iter = 0;
    ctx->futhark_mc_segmap_task_338181_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338181_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338181_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338181_total_time = 0;
    ctx->futhark_mc_segmap_task_338181_total_iter = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338192_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338192_runs = calloc(sizeof(int),
                                                                ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338192_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338192_total_total_runtime = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338192_total_runs = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338192_total_iter = 0;
    ctx->futhark_mc_segred_task_338185_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338185_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338185_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338185_total_time = 0;
    ctx->futhark_mc_segred_task_338185_total_iter = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338198_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338198_runs = calloc(sizeof(int),
                                                                ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338198_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338198_total_total_runtime = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338198_total_runs = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338198_total_iter = 0;
    ctx->futhark_mc_segred_task_338194_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338194_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338194_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338194_total_time = 0;
    ctx->futhark_mc_segred_task_338194_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_338175_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338175_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338175_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338175_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338175_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338175_total_iter = 0;
    ctx->futhark_mc_segmap_nested_task_338173_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338173_runs = calloc(sizeof(int),
                                                            ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338173_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338162_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338162_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338162_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338162_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338162_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338162_total_iter = 0;
    ctx->futhark_mc_segmap_nested_task_338160_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338160_runs = calloc(sizeof(int),
                                                            ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338160_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338147_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338147_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338147_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338147_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338147_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338147_total_iter = 0;
    ctx->futhark_mc_segmap_nested_task_338145_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338145_runs = calloc(sizeof(int),
                                                            ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338145_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338202_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338202_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338202_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338202_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338202_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338202_total_iter = 0;
    ctx->futhark_mc_segmap_task_338200_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338200_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338200_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338200_total_time = 0;
    ctx->futhark_mc_segmap_task_338200_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_338211_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338211_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338211_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338211_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338211_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338211_total_iter = 0;
    ctx->futhark_mc_segmap_task_338209_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338209_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338209_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338209_total_time = 0;
    ctx->futhark_mc_segmap_task_338209_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_338220_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338220_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338220_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338220_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338220_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338220_total_iter = 0;
    ctx->futhark_mc_segmap_task_338218_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338218_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338218_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338218_total_time = 0;
    ctx->futhark_mc_segmap_task_338218_total_iter = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338228_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338228_runs = calloc(sizeof(int),
                                                                ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338228_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338228_total_total_runtime = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338228_total_runs = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338228_total_iter = 0;
    ctx->futhark_mc_segred_task_338225_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338225_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338225_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338225_total_time = 0;
    ctx->futhark_mc_segred_task_338225_total_iter = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338233_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338233_runs = calloc(sizeof(int),
                                                                ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338233_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338233_total_total_runtime = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338233_total_runs = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338233_total_iter = 0;
    ctx->futhark_mc_segred_task_338230_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338230_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338230_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338230_total_time = 0;
    ctx->futhark_mc_segred_task_338230_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_338223_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338223_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338223_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338223_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338223_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338223_total_iter = 0;
    ctx->futhark_mc_segmap_nested_task_338221_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338221_runs = calloc(sizeof(int),
                                                            ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338221_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338215_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338215_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338215_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338215_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338215_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338215_total_iter = 0;
    ctx->futhark_mc_segmap_nested_task_338213_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338213_runs = calloc(sizeof(int),
                                                            ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338213_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338206_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338206_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338206_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338206_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338206_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338206_total_iter = 0;
    ctx->futhark_mc_segmap_nested_task_338204_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338204_runs = calloc(sizeof(int),
                                                            ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338204_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338237_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338237_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338237_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338237_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338237_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338237_total_iter = 0;
    ctx->futhark_mc_segmap_task_338235_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338235_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338235_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338235_total_time = 0;
    ctx->futhark_mc_segmap_task_338235_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_338248_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338248_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338248_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338248_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338248_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338248_total_iter = 0;
    ctx->futhark_mc_segmap_task_338246_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338246_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338246_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338246_total_time = 0;
    ctx->futhark_mc_segmap_task_338246_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_338259_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338259_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338259_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338259_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338259_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338259_total_iter = 0;
    ctx->futhark_mc_segmap_task_338257_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338257_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338257_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338257_total_time = 0;
    ctx->futhark_mc_segmap_task_338257_total_iter = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338269_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338269_runs = calloc(sizeof(int),
                                                                ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338269_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338269_total_total_runtime = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338269_total_runs = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338269_total_iter = 0;
    ctx->futhark_mc_segred_task_338264_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338264_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338264_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338264_total_time = 0;
    ctx->futhark_mc_segred_task_338264_total_iter = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338275_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338275_runs = calloc(sizeof(int),
                                                                ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338275_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338275_total_total_runtime = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338275_total_runs = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338275_total_iter = 0;
    ctx->futhark_mc_segred_task_338271_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338271_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338271_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338271_total_time = 0;
    ctx->futhark_mc_segred_task_338271_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_338262_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338262_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338262_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338262_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338262_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338262_total_iter = 0;
    ctx->futhark_mc_segmap_nested_task_338260_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338260_runs = calloc(sizeof(int),
                                                            ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338260_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338253_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338253_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338253_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338253_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338253_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338253_total_iter = 0;
    ctx->futhark_mc_segmap_nested_task_338251_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338251_runs = calloc(sizeof(int),
                                                            ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338251_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338242_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338242_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338242_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338242_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338242_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338242_total_iter = 0;
    ctx->futhark_mc_segmap_nested_task_338240_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338240_runs = calloc(sizeof(int),
                                                            ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338240_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338279_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338279_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338279_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338279_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338279_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338279_total_iter = 0;
    ctx->futhark_mc_segmap_task_338277_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338277_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338277_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338277_total_time = 0;
    ctx->futhark_mc_segmap_task_338277_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_338290_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338290_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338290_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338290_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338290_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338290_total_iter = 0;
    ctx->futhark_mc_segmap_task_338288_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338288_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338288_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338288_total_time = 0;
    ctx->futhark_mc_segmap_task_338288_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_338301_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338301_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338301_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338301_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338301_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338301_total_iter = 0;
    ctx->futhark_mc_segmap_task_338299_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338299_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338299_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338299_total_time = 0;
    ctx->futhark_mc_segmap_task_338299_total_iter = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338313_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338313_runs = calloc(sizeof(int),
                                                                ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338313_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338313_total_total_runtime = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338313_total_runs = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338313_total_iter = 0;
    ctx->futhark_mc_segred_task_338306_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338306_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338306_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338306_total_time = 0;
    ctx->futhark_mc_segred_task_338306_total_iter = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338319_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338319_runs = calloc(sizeof(int),
                                                                ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338319_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338319_total_total_runtime = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338319_total_runs = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338319_total_iter = 0;
    ctx->futhark_mc_segred_task_338315_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338315_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338315_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338315_total_time = 0;
    ctx->futhark_mc_segred_task_338315_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_338304_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338304_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338304_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338304_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338304_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338304_total_iter = 0;
    ctx->futhark_mc_segmap_nested_task_338302_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338302_runs = calloc(sizeof(int),
                                                            ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338302_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338295_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338295_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338295_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338295_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338295_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338295_total_iter = 0;
    ctx->futhark_mc_segmap_nested_task_338293_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338293_runs = calloc(sizeof(int),
                                                            ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338293_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338284_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338284_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338284_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338284_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338284_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338284_total_iter = 0;
    ctx->futhark_mc_segmap_nested_task_338282_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338282_runs = calloc(sizeof(int),
                                                            ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338282_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338323_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338323_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338323_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338323_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338323_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338323_total_iter = 0;
    ctx->futhark_mc_segmap_task_338321_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338321_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338321_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338321_total_time = 0;
    ctx->futhark_mc_segmap_task_338321_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_338332_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338332_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338332_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338332_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338332_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338332_total_iter = 0;
    ctx->futhark_mc_segmap_task_338330_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338330_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338330_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338330_total_time = 0;
    ctx->futhark_mc_segmap_task_338330_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_338341_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338341_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338341_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338341_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338341_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338341_total_iter = 0;
    ctx->futhark_mc_segmap_task_338339_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338339_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338339_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338339_total_time = 0;
    ctx->futhark_mc_segmap_task_338339_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_338336_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338336_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338336_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338336_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338336_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338336_total_iter = 0;
    ctx->futhark_mc_segmap_nested_task_338334_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338334_runs = calloc(sizeof(int),
                                                            ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338334_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338327_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338327_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338327_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338327_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338327_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338327_total_iter = 0;
    ctx->futhark_mc_segmap_nested_task_338325_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338325_runs = calloc(sizeof(int),
                                                            ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338325_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338345_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338345_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338345_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338345_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338345_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338345_total_iter = 0;
    ctx->futhark_mc_segmap_task_338343_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338343_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338343_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338343_total_time = 0;
    ctx->futhark_mc_segmap_task_338343_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_338354_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338354_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338354_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338354_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338354_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338354_total_iter = 0;
    ctx->futhark_mc_segmap_task_338352_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338352_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338352_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338352_total_time = 0;
    ctx->futhark_mc_segmap_task_338352_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_338349_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338349_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338349_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338349_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338349_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338349_total_iter = 0;
    ctx->futhark_mc_segmap_nested_task_338347_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338347_runs = calloc(sizeof(int),
                                                            ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338347_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338358_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338358_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338358_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338358_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338358_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338358_total_iter = 0;
    ctx->futhark_mc_segmap_task_338356_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338356_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338356_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338356_total_time = 0;
    ctx->futhark_mc_segmap_task_338356_total_iter = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338366_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338366_runs = calloc(sizeof(int),
                                                                ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338366_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338366_total_total_runtime = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338366_total_runs = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338366_total_iter = 0;
    ctx->futhark_mc_segred_task_338363_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338363_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338363_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338363_total_time = 0;
    ctx->futhark_mc_segred_task_338363_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_338361_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338361_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338361_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338361_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338361_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338361_total_iter = 0;
    ctx->futhark_mc_segmap_nested_task_338359_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338359_runs = calloc(sizeof(int),
                                                            ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338359_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338370_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338370_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338370_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338370_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338370_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338370_total_iter = 0;
    ctx->futhark_mc_segmap_task_338368_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338368_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338368_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338368_total_time = 0;
    ctx->futhark_mc_segmap_task_338368_total_iter = 0;
    ctx->futhark_mc_scan_stage_1_parloop_338380_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_scan_stage_1_parloop_338380_runs = calloc(sizeof(int),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_scan_stage_1_parloop_338380_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_scan_stage_1_parloop_338380_total_total_runtime = 0;
    ctx->futhark_mc_scan_stage_1_parloop_338380_total_runs = 0;
    ctx->futhark_mc_scan_stage_1_parloop_338380_total_iter = 0;
    ctx->futhark_mc_scan_stage_3_parloop_338382_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_scan_stage_3_parloop_338382_runs = calloc(sizeof(int),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_scan_stage_3_parloop_338382_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_scan_stage_3_parloop_338382_total_total_runtime = 0;
    ctx->futhark_mc_scan_stage_3_parloop_338382_total_runs = 0;
    ctx->futhark_mc_scan_stage_3_parloop_338382_total_iter = 0;
    ctx->futhark_mc_segscan_task_338377_total_runtime = calloc(sizeof(int64_t),
                                                               ctx->scheduler.num_threads);
    ctx->futhark_mc_segscan_task_338377_runs = calloc(sizeof(int),
                                                      ctx->scheduler.num_threads);
    ctx->futhark_mc_segscan_task_338377_iter = calloc(sizeof(sizeof(int64_t)),
                                                      ctx->scheduler.num_threads);
    ctx->futhark_mc_segscan_task_338377_total_time = 0;
    ctx->futhark_mc_segscan_task_338377_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_338374_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338374_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338374_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338374_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338374_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338374_total_iter = 0;
    ctx->futhark_mc_segmap_nested_task_338372_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338372_runs = calloc(sizeof(int),
                                                            ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338372_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338386_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338386_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338386_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338386_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338386_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338386_total_iter = 0;
    ctx->futhark_mc_segmap_task_338384_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338384_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338384_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338384_total_time = 0;
    ctx->futhark_mc_segmap_task_338384_total_iter = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338394_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338394_runs = calloc(sizeof(int),
                                                                ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338394_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338394_total_total_runtime = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338394_total_runs = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338394_total_iter = 0;
    ctx->futhark_mc_segred_task_338391_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338391_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338391_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338391_total_time = 0;
    ctx->futhark_mc_segred_task_338391_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_338389_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338389_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338389_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338389_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338389_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338389_total_iter = 0;
    ctx->futhark_mc_segmap_nested_task_338387_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338387_runs = calloc(sizeof(int),
                                                            ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338387_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338398_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338398_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338398_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338398_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338398_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338398_total_iter = 0;
    ctx->futhark_mc_segmap_task_338396_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338396_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338396_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338396_total_time = 0;
    ctx->futhark_mc_segmap_task_338396_total_iter = 0;
    ctx->futhark_mc_scan_stage_1_parloop_338408_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_scan_stage_1_parloop_338408_runs = calloc(sizeof(int),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_scan_stage_1_parloop_338408_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_scan_stage_1_parloop_338408_total_total_runtime = 0;
    ctx->futhark_mc_scan_stage_1_parloop_338408_total_runs = 0;
    ctx->futhark_mc_scan_stage_1_parloop_338408_total_iter = 0;
    ctx->futhark_mc_scan_stage_3_parloop_338410_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_scan_stage_3_parloop_338410_runs = calloc(sizeof(int),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_scan_stage_3_parloop_338410_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_scan_stage_3_parloop_338410_total_total_runtime = 0;
    ctx->futhark_mc_scan_stage_3_parloop_338410_total_runs = 0;
    ctx->futhark_mc_scan_stage_3_parloop_338410_total_iter = 0;
    ctx->futhark_mc_segscan_task_338405_total_runtime = calloc(sizeof(int64_t),
                                                               ctx->scheduler.num_threads);
    ctx->futhark_mc_segscan_task_338405_runs = calloc(sizeof(int),
                                                      ctx->scheduler.num_threads);
    ctx->futhark_mc_segscan_task_338405_iter = calloc(sizeof(sizeof(int64_t)),
                                                      ctx->scheduler.num_threads);
    ctx->futhark_mc_segscan_task_338405_total_time = 0;
    ctx->futhark_mc_segscan_task_338405_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_338402_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338402_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338402_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338402_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338402_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338402_total_iter = 0;
    ctx->futhark_mc_segmap_nested_task_338400_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338400_runs = calloc(sizeof(int),
                                                            ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338400_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338414_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338414_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338414_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338414_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338414_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338414_total_iter = 0;
    ctx->futhark_mc_segmap_task_338412_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338412_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338412_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338412_total_time = 0;
    ctx->futhark_mc_segmap_task_338412_total_iter = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338422_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338422_runs = calloc(sizeof(int),
                                                                ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338422_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338422_total_total_runtime = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338422_total_runs = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338422_total_iter = 0;
    ctx->futhark_mc_segred_task_338419_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338419_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338419_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338419_total_time = 0;
    ctx->futhark_mc_segred_task_338419_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_338417_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338417_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338417_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338417_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338417_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338417_total_iter = 0;
    ctx->futhark_mc_segmap_nested_task_338415_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338415_runs = calloc(sizeof(int),
                                                            ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338415_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338426_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338426_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338426_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338426_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338426_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338426_total_iter = 0;
    ctx->futhark_mc_segmap_task_338424_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338424_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338424_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338424_total_time = 0;
    ctx->futhark_mc_segmap_task_338424_total_iter = 0;
    ctx->futhark_mc_scan_stage_1_parloop_338436_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_scan_stage_1_parloop_338436_runs = calloc(sizeof(int),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_scan_stage_1_parloop_338436_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_scan_stage_1_parloop_338436_total_total_runtime = 0;
    ctx->futhark_mc_scan_stage_1_parloop_338436_total_runs = 0;
    ctx->futhark_mc_scan_stage_1_parloop_338436_total_iter = 0;
    ctx->futhark_mc_scan_stage_3_parloop_338438_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_scan_stage_3_parloop_338438_runs = calloc(sizeof(int),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_scan_stage_3_parloop_338438_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_scan_stage_3_parloop_338438_total_total_runtime = 0;
    ctx->futhark_mc_scan_stage_3_parloop_338438_total_runs = 0;
    ctx->futhark_mc_scan_stage_3_parloop_338438_total_iter = 0;
    ctx->futhark_mc_segscan_task_338433_total_runtime = calloc(sizeof(int64_t),
                                                               ctx->scheduler.num_threads);
    ctx->futhark_mc_segscan_task_338433_runs = calloc(sizeof(int),
                                                      ctx->scheduler.num_threads);
    ctx->futhark_mc_segscan_task_338433_iter = calloc(sizeof(sizeof(int64_t)),
                                                      ctx->scheduler.num_threads);
    ctx->futhark_mc_segscan_task_338433_total_time = 0;
    ctx->futhark_mc_segscan_task_338433_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_338430_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338430_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338430_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338430_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338430_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338430_total_iter = 0;
    ctx->futhark_mc_segmap_nested_task_338428_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338428_runs = calloc(sizeof(int),
                                                            ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338428_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338442_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338442_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338442_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338442_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338442_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338442_total_iter = 0;
    ctx->futhark_mc_segmap_task_338440_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338440_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338440_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338440_total_time = 0;
    ctx->futhark_mc_segmap_task_338440_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_338451_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338451_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338451_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338451_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338451_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338451_total_iter = 0;
    ctx->futhark_mc_segmap_task_338449_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338449_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338449_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338449_total_time = 0;
    ctx->futhark_mc_segmap_task_338449_total_iter = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338459_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338459_runs = calloc(sizeof(int),
                                                                ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338459_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338459_total_total_runtime = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338459_total_runs = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338459_total_iter = 0;
    ctx->futhark_mc_segred_task_338456_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338456_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338456_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338456_total_time = 0;
    ctx->futhark_mc_segred_task_338456_total_iter = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338464_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338464_runs = calloc(sizeof(int),
                                                                ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338464_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338464_total_total_runtime = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338464_total_runs = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338464_total_iter = 0;
    ctx->futhark_mc_segred_task_338461_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338461_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338461_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338461_total_time = 0;
    ctx->futhark_mc_segred_task_338461_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_338454_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338454_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338454_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338454_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338454_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338454_total_iter = 0;
    ctx->futhark_mc_segmap_nested_task_338452_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338452_runs = calloc(sizeof(int),
                                                            ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338452_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338446_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338446_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338446_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338446_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338446_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338446_total_iter = 0;
    ctx->futhark_mc_segmap_nested_task_338444_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338444_runs = calloc(sizeof(int),
                                                            ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338444_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338468_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338468_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338468_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338468_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338468_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338468_total_iter = 0;
    ctx->futhark_mc_segmap_task_338466_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338466_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338466_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338466_total_time = 0;
    ctx->futhark_mc_segmap_task_338466_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_338479_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338479_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338479_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338479_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338479_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338479_total_iter = 0;
    ctx->futhark_mc_segmap_task_338477_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338477_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338477_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338477_total_time = 0;
    ctx->futhark_mc_segmap_task_338477_total_iter = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338489_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338489_runs = calloc(sizeof(int),
                                                                ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338489_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338489_total_total_runtime = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338489_total_runs = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338489_total_iter = 0;
    ctx->futhark_mc_segred_task_338484_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338484_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338484_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338484_total_time = 0;
    ctx->futhark_mc_segred_task_338484_total_iter = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338495_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338495_runs = calloc(sizeof(int),
                                                                ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338495_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338495_total_total_runtime = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338495_total_runs = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338495_total_iter = 0;
    ctx->futhark_mc_segred_task_338491_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338491_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338491_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338491_total_time = 0;
    ctx->futhark_mc_segred_task_338491_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_338482_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338482_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338482_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338482_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338482_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338482_total_iter = 0;
    ctx->futhark_mc_segmap_nested_task_338480_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338480_runs = calloc(sizeof(int),
                                                            ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338480_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338473_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338473_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338473_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338473_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338473_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338473_total_iter = 0;
    ctx->futhark_mc_segmap_nested_task_338471_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338471_runs = calloc(sizeof(int),
                                                            ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338471_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338499_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338499_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338499_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338499_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338499_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338499_total_iter = 0;
    ctx->futhark_mc_segmap_task_338497_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338497_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338497_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338497_total_time = 0;
    ctx->futhark_mc_segmap_task_338497_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_338510_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338510_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338510_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338510_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338510_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338510_total_iter = 0;
    ctx->futhark_mc_segmap_task_338508_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338508_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338508_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338508_total_time = 0;
    ctx->futhark_mc_segmap_task_338508_total_iter = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338522_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338522_runs = calloc(sizeof(int),
                                                                ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338522_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338522_total_total_runtime = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338522_total_runs = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338522_total_iter = 0;
    ctx->futhark_mc_segred_task_338515_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338515_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338515_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338515_total_time = 0;
    ctx->futhark_mc_segred_task_338515_total_iter = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338528_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338528_runs = calloc(sizeof(int),
                                                                ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338528_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338528_total_total_runtime = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338528_total_runs = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338528_total_iter = 0;
    ctx->futhark_mc_segred_task_338524_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338524_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338524_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338524_total_time = 0;
    ctx->futhark_mc_segred_task_338524_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_338513_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338513_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338513_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338513_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338513_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338513_total_iter = 0;
    ctx->futhark_mc_segmap_nested_task_338511_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338511_runs = calloc(sizeof(int),
                                                            ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338511_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338504_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338504_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338504_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338504_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338504_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338504_total_iter = 0;
    ctx->futhark_mc_segmap_nested_task_338502_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338502_runs = calloc(sizeof(int),
                                                            ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338502_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338532_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338532_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338532_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338532_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338532_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338532_total_iter = 0;
    ctx->futhark_mc_segmap_task_338530_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338530_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338530_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338530_total_time = 0;
    ctx->futhark_mc_segmap_task_338530_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_338542_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338542_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338542_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338542_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338542_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338542_total_iter = 0;
    ctx->futhark_mc_segmap_task_338540_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338540_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338540_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338540_total_time = 0;
    ctx->futhark_mc_segmap_task_338540_total_iter = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338552_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338552_runs = calloc(sizeof(int),
                                                                ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338552_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338552_total_total_runtime = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338552_total_runs = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338552_total_iter = 0;
    ctx->futhark_mc_segred_task_338549_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338549_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338549_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338549_total_time = 0;
    ctx->futhark_mc_segred_task_338549_total_iter = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338557_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338557_runs = calloc(sizeof(int),
                                                                ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338557_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338557_total_total_runtime = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338557_total_runs = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338557_total_iter = 0;
    ctx->futhark_mc_segred_task_338554_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338554_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338554_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338554_total_time = 0;
    ctx->futhark_mc_segred_task_338554_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_338546_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338546_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338546_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338546_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338546_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338546_total_iter = 0;
    ctx->futhark_mc_segmap_nested_task_338544_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338544_runs = calloc(sizeof(int),
                                                            ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338544_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338537_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338537_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338537_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338537_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338537_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338537_total_iter = 0;
    ctx->futhark_mc_segmap_nested_task_338535_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338535_runs = calloc(sizeof(int),
                                                            ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338535_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338561_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338561_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338561_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338561_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338561_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338561_total_iter = 0;
    ctx->futhark_mc_segmap_task_338559_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338559_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338559_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338559_total_time = 0;
    ctx->futhark_mc_segmap_task_338559_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_338574_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338574_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338574_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338574_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338574_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338574_total_iter = 0;
    ctx->futhark_mc_segmap_task_338572_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338572_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338572_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338572_total_time = 0;
    ctx->futhark_mc_segmap_task_338572_total_iter = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338588_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338588_runs = calloc(sizeof(int),
                                                                ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338588_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338588_total_total_runtime = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338588_total_runs = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338588_total_iter = 0;
    ctx->futhark_mc_segred_task_338583_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338583_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338583_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338583_total_time = 0;
    ctx->futhark_mc_segred_task_338583_total_iter = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338594_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338594_runs = calloc(sizeof(int),
                                                                ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338594_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338594_total_total_runtime = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338594_total_runs = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338594_total_iter = 0;
    ctx->futhark_mc_segred_task_338590_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338590_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338590_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338590_total_time = 0;
    ctx->futhark_mc_segred_task_338590_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_338579_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338579_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338579_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338579_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338579_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338579_total_iter = 0;
    ctx->futhark_mc_segmap_nested_task_338577_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338577_runs = calloc(sizeof(int),
                                                            ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338577_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338568_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338568_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338568_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338568_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338568_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338568_total_iter = 0;
    ctx->futhark_mc_segmap_nested_task_338566_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338566_runs = calloc(sizeof(int),
                                                            ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338566_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338598_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338598_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338598_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338598_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338598_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338598_total_iter = 0;
    ctx->futhark_mc_segmap_task_338596_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338596_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338596_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338596_total_time = 0;
    ctx->futhark_mc_segmap_task_338596_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_338613_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338613_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338613_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338613_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338613_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338613_total_iter = 0;
    ctx->futhark_mc_segmap_task_338611_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338611_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338611_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338611_total_time = 0;
    ctx->futhark_mc_segmap_task_338611_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_338628_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338628_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338628_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338628_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338628_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338628_total_iter = 0;
    ctx->futhark_mc_segmap_task_338626_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338626_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338626_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338626_total_time = 0;
    ctx->futhark_mc_segmap_task_338626_total_iter = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338637_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338637_runs = calloc(sizeof(int),
                                                                ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338637_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338637_total_total_runtime = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338637_total_runs = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338637_total_iter = 0;
    ctx->futhark_mc_segred_task_338630_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338630_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338630_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338630_total_time = 0;
    ctx->futhark_mc_segred_task_338630_total_iter = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338643_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338643_runs = calloc(sizeof(int),
                                                                ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338643_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338643_total_total_runtime = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338643_total_runs = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338643_total_iter = 0;
    ctx->futhark_mc_segred_task_338639_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338639_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338639_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338639_total_time = 0;
    ctx->futhark_mc_segred_task_338639_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_338620_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338620_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338620_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338620_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338620_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338620_total_iter = 0;
    ctx->futhark_mc_segmap_nested_task_338618_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338618_runs = calloc(sizeof(int),
                                                            ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338618_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338607_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338607_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338607_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338607_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338607_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338607_total_iter = 0;
    ctx->futhark_mc_segmap_nested_task_338605_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338605_runs = calloc(sizeof(int),
                                                            ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338605_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338647_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338647_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338647_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338647_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338647_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338647_total_iter = 0;
    ctx->futhark_mc_segmap_task_338645_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338645_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338645_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338645_total_time = 0;
    ctx->futhark_mc_segmap_task_338645_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_338656_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338656_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338656_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338656_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338656_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338656_total_iter = 0;
    ctx->futhark_mc_segmap_task_338654_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338654_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338654_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338654_total_time = 0;
    ctx->futhark_mc_segmap_task_338654_total_iter = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338664_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338664_runs = calloc(sizeof(int),
                                                                ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338664_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338664_total_total_runtime = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338664_total_runs = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338664_total_iter = 0;
    ctx->futhark_mc_segred_task_338661_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338661_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338661_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338661_total_time = 0;
    ctx->futhark_mc_segred_task_338661_total_iter = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338669_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338669_runs = calloc(sizeof(int),
                                                                ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338669_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338669_total_total_runtime = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338669_total_runs = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338669_total_iter = 0;
    ctx->futhark_mc_segred_task_338666_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338666_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338666_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338666_total_time = 0;
    ctx->futhark_mc_segred_task_338666_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_338659_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338659_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338659_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338659_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338659_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338659_total_iter = 0;
    ctx->futhark_mc_segmap_nested_task_338657_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338657_runs = calloc(sizeof(int),
                                                            ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338657_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338651_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338651_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338651_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338651_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338651_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338651_total_iter = 0;
    ctx->futhark_mc_segmap_nested_task_338649_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338649_runs = calloc(sizeof(int),
                                                            ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338649_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338673_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338673_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338673_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338673_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338673_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338673_total_iter = 0;
    ctx->futhark_mc_segmap_task_338671_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338671_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338671_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338671_total_time = 0;
    ctx->futhark_mc_segmap_task_338671_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_338684_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338684_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338684_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338684_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338684_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338684_total_iter = 0;
    ctx->futhark_mc_segmap_task_338682_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338682_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338682_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338682_total_time = 0;
    ctx->futhark_mc_segmap_task_338682_total_iter = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338694_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338694_runs = calloc(sizeof(int),
                                                                ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338694_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338694_total_total_runtime = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338694_total_runs = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338694_total_iter = 0;
    ctx->futhark_mc_segred_task_338689_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338689_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338689_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338689_total_time = 0;
    ctx->futhark_mc_segred_task_338689_total_iter = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338700_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338700_runs = calloc(sizeof(int),
                                                                ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338700_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338700_total_total_runtime = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338700_total_runs = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338700_total_iter = 0;
    ctx->futhark_mc_segred_task_338696_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338696_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338696_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338696_total_time = 0;
    ctx->futhark_mc_segred_task_338696_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_338687_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338687_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338687_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338687_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338687_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338687_total_iter = 0;
    ctx->futhark_mc_segmap_nested_task_338685_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338685_runs = calloc(sizeof(int),
                                                            ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338685_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338678_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338678_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338678_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338678_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338678_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338678_total_iter = 0;
    ctx->futhark_mc_segmap_nested_task_338676_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338676_runs = calloc(sizeof(int),
                                                            ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338676_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338704_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338704_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338704_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338704_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338704_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338704_total_iter = 0;
    ctx->futhark_mc_segmap_task_338702_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338702_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338702_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338702_total_time = 0;
    ctx->futhark_mc_segmap_task_338702_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_338715_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338715_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338715_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338715_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338715_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338715_total_iter = 0;
    ctx->futhark_mc_segmap_task_338713_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338713_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338713_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338713_total_time = 0;
    ctx->futhark_mc_segmap_task_338713_total_iter = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338727_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338727_runs = calloc(sizeof(int),
                                                                ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338727_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338727_total_total_runtime = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338727_total_runs = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338727_total_iter = 0;
    ctx->futhark_mc_segred_task_338720_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338720_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338720_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338720_total_time = 0;
    ctx->futhark_mc_segred_task_338720_total_iter = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338733_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338733_runs = calloc(sizeof(int),
                                                                ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338733_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338733_total_total_runtime = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338733_total_runs = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338733_total_iter = 0;
    ctx->futhark_mc_segred_task_338729_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338729_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338729_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338729_total_time = 0;
    ctx->futhark_mc_segred_task_338729_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_338718_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338718_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338718_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338718_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338718_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338718_total_iter = 0;
    ctx->futhark_mc_segmap_nested_task_338716_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338716_runs = calloc(sizeof(int),
                                                            ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338716_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338709_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338709_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338709_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338709_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338709_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338709_total_iter = 0;
    ctx->futhark_mc_segmap_nested_task_338707_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338707_runs = calloc(sizeof(int),
                                                            ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338707_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338737_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338737_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338737_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338737_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338737_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338737_total_iter = 0;
    ctx->futhark_mc_segmap_task_338735_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338735_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338735_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338735_total_time = 0;
    ctx->futhark_mc_segmap_task_338735_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_338746_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338746_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338746_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338746_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338746_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338746_total_iter = 0;
    ctx->futhark_mc_segmap_task_338744_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338744_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338744_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338744_total_time = 0;
    ctx->futhark_mc_segmap_task_338744_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_338741_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338741_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338741_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338741_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338741_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338741_total_iter = 0;
    ctx->futhark_mc_segmap_nested_task_338739_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338739_runs = calloc(sizeof(int),
                                                            ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338739_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338750_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338750_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338750_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338750_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338750_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338750_total_iter = 0;
    ctx->futhark_mc_segmap_task_338748_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338748_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338748_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338748_total_time = 0;
    ctx->futhark_mc_segmap_task_338748_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_338759_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338759_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338759_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338759_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338759_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338759_total_iter = 0;
    ctx->futhark_mc_segmap_task_338757_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338757_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338757_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338757_total_time = 0;
    ctx->futhark_mc_segmap_task_338757_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_338754_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338754_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338754_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338754_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338754_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338754_total_iter = 0;
    ctx->futhark_mc_segmap_nested_task_338752_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338752_runs = calloc(sizeof(int),
                                                            ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338752_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338763_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338763_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338763_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338763_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338763_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338763_total_iter = 0;
    ctx->futhark_mc_segmap_task_338761_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338761_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338761_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338761_total_time = 0;
    ctx->futhark_mc_segmap_task_338761_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_338778_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338778_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338778_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338778_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338778_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338778_total_iter = 0;
    ctx->futhark_mc_segmap_task_338776_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338776_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338776_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338776_total_time = 0;
    ctx->futhark_mc_segmap_task_338776_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_338782_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338782_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338782_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338782_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338782_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338782_total_iter = 0;
    ctx->futhark_mc_segmap_task_338780_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338780_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338780_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338780_total_time = 0;
    ctx->futhark_mc_segmap_task_338780_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_338786_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338786_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338786_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338786_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338786_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338786_total_iter = 0;
    ctx->futhark_mc_segmap_task_338784_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338784_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338784_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338784_total_time = 0;
    ctx->futhark_mc_segmap_task_338784_total_iter = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338794_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338794_runs = calloc(sizeof(int),
                                                                ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338794_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338794_total_total_runtime = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338794_total_runs = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338794_total_iter = 0;
    ctx->futhark_mc_segred_task_338791_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338791_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338791_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338791_total_time = 0;
    ctx->futhark_mc_segred_task_338791_total_iter = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338799_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338799_runs = calloc(sizeof(int),
                                                                ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338799_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338799_total_total_runtime = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338799_total_runs = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338799_total_iter = 0;
    ctx->futhark_mc_segred_task_338796_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338796_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338796_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338796_total_time = 0;
    ctx->futhark_mc_segred_task_338796_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_338789_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338789_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338789_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338789_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338789_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338789_total_iter = 0;
    ctx->futhark_mc_segmap_nested_task_338787_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338787_runs = calloc(sizeof(int),
                                                            ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338787_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338770_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338770_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338770_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338770_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338770_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338770_total_iter = 0;
    ctx->futhark_mc_segmap_nested_task_338768_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338768_runs = calloc(sizeof(int),
                                                            ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338768_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338803_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338803_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338803_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338803_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338803_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338803_total_iter = 0;
    ctx->futhark_mc_segmap_task_338801_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338801_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338801_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338801_total_time = 0;
    ctx->futhark_mc_segmap_task_338801_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_338820_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338820_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338820_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338820_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338820_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338820_total_iter = 0;
    ctx->futhark_mc_segmap_task_338818_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338818_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338818_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338818_total_time = 0;
    ctx->futhark_mc_segmap_task_338818_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_338824_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338824_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338824_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338824_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338824_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338824_total_iter = 0;
    ctx->futhark_mc_segmap_task_338822_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338822_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338822_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338822_total_time = 0;
    ctx->futhark_mc_segmap_task_338822_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_338828_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338828_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338828_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338828_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338828_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338828_total_iter = 0;
    ctx->futhark_mc_segmap_task_338826_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338826_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338826_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338826_total_time = 0;
    ctx->futhark_mc_segmap_task_338826_total_iter = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338838_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338838_runs = calloc(sizeof(int),
                                                                ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338838_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338838_total_total_runtime = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338838_total_runs = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338838_total_iter = 0;
    ctx->futhark_mc_segred_task_338833_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338833_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338833_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338833_total_time = 0;
    ctx->futhark_mc_segred_task_338833_total_iter = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338844_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338844_runs = calloc(sizeof(int),
                                                                ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338844_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338844_total_total_runtime = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338844_total_runs = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338844_total_iter = 0;
    ctx->futhark_mc_segred_task_338840_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338840_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338840_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338840_total_time = 0;
    ctx->futhark_mc_segred_task_338840_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_338831_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338831_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338831_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338831_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338831_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338831_total_iter = 0;
    ctx->futhark_mc_segmap_nested_task_338829_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338829_runs = calloc(sizeof(int),
                                                            ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338829_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338811_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338811_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338811_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338811_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338811_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338811_total_iter = 0;
    ctx->futhark_mc_segmap_nested_task_338809_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338809_runs = calloc(sizeof(int),
                                                            ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338809_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338848_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338848_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338848_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338848_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338848_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338848_total_iter = 0;
    ctx->futhark_mc_segmap_task_338846_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338846_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338846_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338846_total_time = 0;
    ctx->futhark_mc_segmap_task_338846_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_338865_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338865_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338865_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338865_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338865_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338865_total_iter = 0;
    ctx->futhark_mc_segmap_task_338863_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338863_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338863_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338863_total_time = 0;
    ctx->futhark_mc_segmap_task_338863_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_338869_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338869_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338869_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338869_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338869_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338869_total_iter = 0;
    ctx->futhark_mc_segmap_task_338867_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338867_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338867_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338867_total_time = 0;
    ctx->futhark_mc_segmap_task_338867_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_338873_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338873_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338873_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338873_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338873_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338873_total_iter = 0;
    ctx->futhark_mc_segmap_task_338871_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338871_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338871_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338871_total_time = 0;
    ctx->futhark_mc_segmap_task_338871_total_iter = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338885_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338885_runs = calloc(sizeof(int),
                                                                ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338885_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338885_total_total_runtime = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338885_total_runs = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338885_total_iter = 0;
    ctx->futhark_mc_segred_task_338878_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338878_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338878_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338878_total_time = 0;
    ctx->futhark_mc_segred_task_338878_total_iter = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338891_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338891_runs = calloc(sizeof(int),
                                                                ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338891_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338891_total_total_runtime = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338891_total_runs = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338891_total_iter = 0;
    ctx->futhark_mc_segred_task_338887_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338887_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338887_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338887_total_time = 0;
    ctx->futhark_mc_segred_task_338887_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_338876_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338876_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338876_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338876_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338876_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338876_total_iter = 0;
    ctx->futhark_mc_segmap_nested_task_338874_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338874_runs = calloc(sizeof(int),
                                                            ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338874_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338856_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338856_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338856_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338856_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338856_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338856_total_iter = 0;
    ctx->futhark_mc_segmap_nested_task_338854_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338854_runs = calloc(sizeof(int),
                                                            ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338854_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338895_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338895_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338895_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338895_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338895_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338895_total_iter = 0;
    ctx->futhark_mc_segmap_task_338893_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338893_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338893_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338893_total_time = 0;
    ctx->futhark_mc_segmap_task_338893_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_338911_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338911_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338911_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338911_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338911_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338911_total_iter = 0;
    ctx->futhark_mc_segmap_task_338909_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338909_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338909_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338909_total_time = 0;
    ctx->futhark_mc_segmap_task_338909_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_338915_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338915_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338915_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338915_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338915_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338915_total_iter = 0;
    ctx->futhark_mc_segmap_task_338913_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338913_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338913_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338913_total_time = 0;
    ctx->futhark_mc_segmap_task_338913_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_338919_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338919_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338919_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338919_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338919_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338919_total_iter = 0;
    ctx->futhark_mc_segmap_task_338917_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338917_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338917_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338917_total_time = 0;
    ctx->futhark_mc_segmap_task_338917_total_iter = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338929_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338929_runs = calloc(sizeof(int),
                                                                ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338929_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338929_total_total_runtime = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338929_total_runs = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338929_total_iter = 0;
    ctx->futhark_mc_segred_task_338926_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338926_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338926_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338926_total_time = 0;
    ctx->futhark_mc_segred_task_338926_total_iter = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338934_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338934_runs = calloc(sizeof(int),
                                                                ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338934_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338934_total_total_runtime = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338934_total_runs = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338934_total_iter = 0;
    ctx->futhark_mc_segred_task_338931_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338931_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338931_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338931_total_time = 0;
    ctx->futhark_mc_segred_task_338931_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_338923_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338923_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338923_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338923_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338923_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338923_total_iter = 0;
    ctx->futhark_mc_segmap_nested_task_338921_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338921_runs = calloc(sizeof(int),
                                                            ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338921_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338903_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338903_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338903_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338903_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338903_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338903_total_iter = 0;
    ctx->futhark_mc_segmap_nested_task_338901_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338901_runs = calloc(sizeof(int),
                                                            ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338901_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338938_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338938_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338938_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338938_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338938_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338938_total_iter = 0;
    ctx->futhark_mc_segmap_task_338936_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338936_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338936_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338936_total_time = 0;
    ctx->futhark_mc_segmap_task_338936_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_338957_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338957_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338957_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338957_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338957_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338957_total_iter = 0;
    ctx->futhark_mc_segmap_task_338955_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338955_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338955_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338955_total_time = 0;
    ctx->futhark_mc_segmap_task_338955_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_338961_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338961_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338961_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338961_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338961_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338961_total_iter = 0;
    ctx->futhark_mc_segmap_task_338959_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338959_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338959_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338959_total_time = 0;
    ctx->futhark_mc_segmap_task_338959_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_338965_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338965_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338965_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338965_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338965_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338965_total_iter = 0;
    ctx->futhark_mc_segmap_task_338963_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338963_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338963_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338963_total_time = 0;
    ctx->futhark_mc_segmap_task_338963_total_iter = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338979_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338979_runs = calloc(sizeof(int),
                                                                ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338979_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338979_total_total_runtime = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338979_total_runs = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338979_total_iter = 0;
    ctx->futhark_mc_segred_task_338974_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338974_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338974_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338974_total_time = 0;
    ctx->futhark_mc_segred_task_338974_total_iter = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338985_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338985_runs = calloc(sizeof(int),
                                                                ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338985_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_338985_total_total_runtime = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338985_total_runs = 0;
    ctx->futhark_mc_segred_stage_1_parloop_338985_total_iter = 0;
    ctx->futhark_mc_segred_task_338981_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338981_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338981_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_338981_total_time = 0;
    ctx->futhark_mc_segred_task_338981_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_338970_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338970_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338970_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338970_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338970_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338970_total_iter = 0;
    ctx->futhark_mc_segmap_nested_task_338968_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338968_runs = calloc(sizeof(int),
                                                            ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338968_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338948_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338948_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338948_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338948_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338948_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338948_total_iter = 0;
    ctx->futhark_mc_segmap_nested_task_338946_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338946_runs = calloc(sizeof(int),
                                                            ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338946_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338989_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338989_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338989_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_338989_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_338989_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_338989_total_iter = 0;
    ctx->futhark_mc_segmap_task_338987_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338987_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338987_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_338987_total_time = 0;
    ctx->futhark_mc_segmap_task_338987_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_339010_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339010_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339010_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339010_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_339010_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_339010_total_iter = 0;
    ctx->futhark_mc_segmap_task_339008_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339008_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339008_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339008_total_time = 0;
    ctx->futhark_mc_segmap_task_339008_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_339014_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339014_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339014_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339014_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_339014_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_339014_total_iter = 0;
    ctx->futhark_mc_segmap_task_339012_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339012_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339012_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339012_total_time = 0;
    ctx->futhark_mc_segmap_task_339012_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_339018_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339018_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339018_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339018_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_339018_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_339018_total_iter = 0;
    ctx->futhark_mc_segmap_task_339016_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339016_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339016_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339016_total_time = 0;
    ctx->futhark_mc_segmap_task_339016_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_339033_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339033_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339033_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339033_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_339033_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_339033_total_iter = 0;
    ctx->futhark_mc_segmap_task_339031_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339031_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339031_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339031_total_time = 0;
    ctx->futhark_mc_segmap_task_339031_total_iter = 0;
    ctx->futhark_mc_segred_stage_1_parloop_339042_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_339042_runs = calloc(sizeof(int),
                                                                ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_339042_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_339042_total_total_runtime = 0;
    ctx->futhark_mc_segred_stage_1_parloop_339042_total_runs = 0;
    ctx->futhark_mc_segred_stage_1_parloop_339042_total_iter = 0;
    ctx->futhark_mc_segred_task_339035_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_339035_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_339035_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_339035_total_time = 0;
    ctx->futhark_mc_segred_task_339035_total_iter = 0;
    ctx->futhark_mc_segred_stage_1_parloop_339048_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_339048_runs = calloc(sizeof(int),
                                                                ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_339048_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_339048_total_total_runtime = 0;
    ctx->futhark_mc_segred_stage_1_parloop_339048_total_runs = 0;
    ctx->futhark_mc_segred_stage_1_parloop_339048_total_iter = 0;
    ctx->futhark_mc_segred_task_339044_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_339044_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_339044_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_339044_total_time = 0;
    ctx->futhark_mc_segred_task_339044_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_339025_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339025_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339025_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339025_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_339025_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_339025_total_iter = 0;
    ctx->futhark_mc_segmap_nested_task_339023_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_339023_runs = calloc(sizeof(int),
                                                            ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_339023_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339001_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339001_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339001_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339001_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_339001_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_339001_total_iter = 0;
    ctx->futhark_mc_segmap_nested_task_338999_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338999_runs = calloc(sizeof(int),
                                                            ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_338999_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339052_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339052_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339052_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339052_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_339052_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_339052_total_iter = 0;
    ctx->futhark_mc_segmap_task_339050_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339050_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339050_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339050_total_time = 0;
    ctx->futhark_mc_segmap_task_339050_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_339067_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339067_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339067_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339067_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_339067_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_339067_total_iter = 0;
    ctx->futhark_mc_segmap_task_339065_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339065_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339065_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339065_total_time = 0;
    ctx->futhark_mc_segmap_task_339065_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_339071_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339071_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339071_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339071_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_339071_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_339071_total_iter = 0;
    ctx->futhark_mc_segmap_task_339069_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339069_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339069_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339069_total_time = 0;
    ctx->futhark_mc_segmap_task_339069_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_339075_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339075_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339075_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339075_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_339075_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_339075_total_iter = 0;
    ctx->futhark_mc_segmap_task_339073_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339073_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339073_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339073_total_time = 0;
    ctx->futhark_mc_segmap_task_339073_total_iter = 0;
    ctx->futhark_mc_segred_stage_1_parloop_339083_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_339083_runs = calloc(sizeof(int),
                                                                ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_339083_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_339083_total_total_runtime = 0;
    ctx->futhark_mc_segred_stage_1_parloop_339083_total_runs = 0;
    ctx->futhark_mc_segred_stage_1_parloop_339083_total_iter = 0;
    ctx->futhark_mc_segred_task_339080_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_339080_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_339080_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_339080_total_time = 0;
    ctx->futhark_mc_segred_task_339080_total_iter = 0;
    ctx->futhark_mc_segred_stage_1_parloop_339088_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_339088_runs = calloc(sizeof(int),
                                                                ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_339088_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_339088_total_total_runtime = 0;
    ctx->futhark_mc_segred_stage_1_parloop_339088_total_runs = 0;
    ctx->futhark_mc_segred_stage_1_parloop_339088_total_iter = 0;
    ctx->futhark_mc_segred_task_339085_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_339085_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_339085_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_339085_total_time = 0;
    ctx->futhark_mc_segred_task_339085_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_339078_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339078_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339078_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339078_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_339078_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_339078_total_iter = 0;
    ctx->futhark_mc_segmap_nested_task_339076_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_339076_runs = calloc(sizeof(int),
                                                            ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_339076_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339059_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339059_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339059_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339059_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_339059_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_339059_total_iter = 0;
    ctx->futhark_mc_segmap_nested_task_339057_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_339057_runs = calloc(sizeof(int),
                                                            ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_339057_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339092_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339092_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339092_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339092_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_339092_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_339092_total_iter = 0;
    ctx->futhark_mc_segmap_task_339090_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339090_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339090_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339090_total_time = 0;
    ctx->futhark_mc_segmap_task_339090_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_339109_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339109_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339109_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339109_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_339109_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_339109_total_iter = 0;
    ctx->futhark_mc_segmap_task_339107_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339107_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339107_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339107_total_time = 0;
    ctx->futhark_mc_segmap_task_339107_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_339113_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339113_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339113_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339113_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_339113_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_339113_total_iter = 0;
    ctx->futhark_mc_segmap_task_339111_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339111_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339111_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339111_total_time = 0;
    ctx->futhark_mc_segmap_task_339111_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_339117_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339117_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339117_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339117_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_339117_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_339117_total_iter = 0;
    ctx->futhark_mc_segmap_task_339115_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339115_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339115_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339115_total_time = 0;
    ctx->futhark_mc_segmap_task_339115_total_iter = 0;
    ctx->futhark_mc_segred_stage_1_parloop_339127_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_339127_runs = calloc(sizeof(int),
                                                                ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_339127_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_339127_total_total_runtime = 0;
    ctx->futhark_mc_segred_stage_1_parloop_339127_total_runs = 0;
    ctx->futhark_mc_segred_stage_1_parloop_339127_total_iter = 0;
    ctx->futhark_mc_segred_task_339122_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_339122_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_339122_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_339122_total_time = 0;
    ctx->futhark_mc_segred_task_339122_total_iter = 0;
    ctx->futhark_mc_segred_stage_1_parloop_339133_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_339133_runs = calloc(sizeof(int),
                                                                ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_339133_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_339133_total_total_runtime = 0;
    ctx->futhark_mc_segred_stage_1_parloop_339133_total_runs = 0;
    ctx->futhark_mc_segred_stage_1_parloop_339133_total_iter = 0;
    ctx->futhark_mc_segred_task_339129_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_339129_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_339129_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_339129_total_time = 0;
    ctx->futhark_mc_segred_task_339129_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_339120_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339120_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339120_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339120_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_339120_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_339120_total_iter = 0;
    ctx->futhark_mc_segmap_nested_task_339118_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_339118_runs = calloc(sizeof(int),
                                                            ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_339118_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339100_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339100_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339100_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339100_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_339100_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_339100_total_iter = 0;
    ctx->futhark_mc_segmap_nested_task_339098_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_339098_runs = calloc(sizeof(int),
                                                            ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_339098_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339137_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339137_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339137_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339137_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_339137_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_339137_total_iter = 0;
    ctx->futhark_mc_segmap_task_339135_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339135_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339135_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339135_total_time = 0;
    ctx->futhark_mc_segmap_task_339135_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_339154_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339154_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339154_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339154_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_339154_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_339154_total_iter = 0;
    ctx->futhark_mc_segmap_task_339152_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339152_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339152_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339152_total_time = 0;
    ctx->futhark_mc_segmap_task_339152_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_339158_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339158_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339158_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339158_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_339158_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_339158_total_iter = 0;
    ctx->futhark_mc_segmap_task_339156_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339156_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339156_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339156_total_time = 0;
    ctx->futhark_mc_segmap_task_339156_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_339162_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339162_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339162_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339162_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_339162_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_339162_total_iter = 0;
    ctx->futhark_mc_segmap_task_339160_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339160_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339160_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339160_total_time = 0;
    ctx->futhark_mc_segmap_task_339160_total_iter = 0;
    ctx->futhark_mc_segred_stage_1_parloop_339174_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_339174_runs = calloc(sizeof(int),
                                                                ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_339174_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_339174_total_total_runtime = 0;
    ctx->futhark_mc_segred_stage_1_parloop_339174_total_runs = 0;
    ctx->futhark_mc_segred_stage_1_parloop_339174_total_iter = 0;
    ctx->futhark_mc_segred_task_339167_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_339167_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_339167_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_339167_total_time = 0;
    ctx->futhark_mc_segred_task_339167_total_iter = 0;
    ctx->futhark_mc_segred_stage_1_parloop_339180_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_339180_runs = calloc(sizeof(int),
                                                                ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_339180_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_339180_total_total_runtime = 0;
    ctx->futhark_mc_segred_stage_1_parloop_339180_total_runs = 0;
    ctx->futhark_mc_segred_stage_1_parloop_339180_total_iter = 0;
    ctx->futhark_mc_segred_task_339176_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_339176_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_339176_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_339176_total_time = 0;
    ctx->futhark_mc_segred_task_339176_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_339165_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339165_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339165_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339165_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_339165_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_339165_total_iter = 0;
    ctx->futhark_mc_segmap_nested_task_339163_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_339163_runs = calloc(sizeof(int),
                                                            ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_339163_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339145_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339145_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339145_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339145_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_339145_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_339145_total_iter = 0;
    ctx->futhark_mc_segmap_nested_task_339143_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_339143_runs = calloc(sizeof(int),
                                                            ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_339143_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339184_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339184_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339184_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339184_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_339184_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_339184_total_iter = 0;
    ctx->futhark_mc_segmap_task_339182_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339182_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339182_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339182_total_time = 0;
    ctx->futhark_mc_segmap_task_339182_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_339193_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339193_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339193_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339193_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_339193_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_339193_total_iter = 0;
    ctx->futhark_mc_segmap_task_339191_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339191_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339191_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339191_total_time = 0;
    ctx->futhark_mc_segmap_task_339191_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_339188_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339188_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339188_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339188_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_339188_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_339188_total_iter = 0;
    ctx->futhark_mc_segmap_nested_task_339186_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_339186_runs = calloc(sizeof(int),
                                                            ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_339186_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339197_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339197_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339197_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339197_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_339197_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_339197_total_iter = 0;
    ctx->futhark_mc_segmap_task_339195_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339195_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339195_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339195_total_time = 0;
    ctx->futhark_mc_segmap_task_339195_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_339208_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339208_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339208_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339208_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_339208_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_339208_total_iter = 0;
    ctx->futhark_mc_segmap_task_339206_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339206_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339206_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339206_total_time = 0;
    ctx->futhark_mc_segmap_task_339206_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_339212_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339212_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339212_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339212_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_339212_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_339212_total_iter = 0;
    ctx->futhark_mc_segmap_task_339210_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339210_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339210_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339210_total_time = 0;
    ctx->futhark_mc_segmap_task_339210_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_339202_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339202_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339202_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339202_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_339202_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_339202_total_iter = 0;
    ctx->futhark_mc_segmap_nested_task_339200_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_339200_runs = calloc(sizeof(int),
                                                            ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_339200_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339216_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339216_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339216_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339216_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_339216_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_339216_total_iter = 0;
    ctx->futhark_mc_segmap_task_339214_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339214_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339214_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339214_total_time = 0;
    ctx->futhark_mc_segmap_task_339214_total_iter = 0;
    ctx->futhark_mc_segred_stage_1_parloop_339225_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_339225_runs = calloc(sizeof(int),
                                                                ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_339225_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_339225_total_total_runtime = 0;
    ctx->futhark_mc_segred_stage_1_parloop_339225_total_runs = 0;
    ctx->futhark_mc_segred_stage_1_parloop_339225_total_iter = 0;
    ctx->futhark_mc_segred_task_339221_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_339221_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_339221_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_339221_total_time = 0;
    ctx->futhark_mc_segred_task_339221_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_339219_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339219_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339219_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339219_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_339219_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_339219_total_iter = 0;
    ctx->futhark_mc_segmap_nested_task_339217_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_339217_runs = calloc(sizeof(int),
                                                            ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_339217_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339229_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339229_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339229_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339229_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_339229_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_339229_total_iter = 0;
    ctx->futhark_mc_segmap_task_339227_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339227_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339227_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339227_total_time = 0;
    ctx->futhark_mc_segmap_task_339227_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_339234_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339234_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339234_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339234_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_339234_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_339234_total_iter = 0;
    ctx->futhark_mc_segmap_task_339232_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339232_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339232_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339232_total_time = 0;
    ctx->futhark_mc_segmap_task_339232_total_iter = 0;
    ctx->futhark_mc_scan_stage_1_parloop_339239_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_scan_stage_1_parloop_339239_runs = calloc(sizeof(int),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_scan_stage_1_parloop_339239_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_scan_stage_1_parloop_339239_total_total_runtime = 0;
    ctx->futhark_mc_scan_stage_1_parloop_339239_total_runs = 0;
    ctx->futhark_mc_scan_stage_1_parloop_339239_total_iter = 0;
    ctx->futhark_mc_scan_stage_3_parloop_339241_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_scan_stage_3_parloop_339241_runs = calloc(sizeof(int),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_scan_stage_3_parloop_339241_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_scan_stage_3_parloop_339241_total_total_runtime = 0;
    ctx->futhark_mc_scan_stage_3_parloop_339241_total_runs = 0;
    ctx->futhark_mc_scan_stage_3_parloop_339241_total_iter = 0;
    ctx->futhark_mc_segscan_task_339236_total_runtime = calloc(sizeof(int64_t),
                                                               ctx->scheduler.num_threads);
    ctx->futhark_mc_segscan_task_339236_runs = calloc(sizeof(int),
                                                      ctx->scheduler.num_threads);
    ctx->futhark_mc_segscan_task_339236_iter = calloc(sizeof(sizeof(int64_t)),
                                                      ctx->scheduler.num_threads);
    ctx->futhark_mc_segscan_task_339236_total_time = 0;
    ctx->futhark_mc_segscan_task_339236_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_339245_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339245_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339245_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339245_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_339245_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_339245_total_iter = 0;
    ctx->futhark_mc_segmap_task_339243_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339243_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339243_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339243_total_time = 0;
    ctx->futhark_mc_segmap_task_339243_total_iter = 0;
    ctx->futhark_mc_seghist_stage_1_parloop_339250_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_seghist_stage_1_parloop_339250_runs = calloc(sizeof(int),
                                                                 ctx->scheduler.num_threads);
    ctx->futhark_mc_seghist_stage_1_parloop_339250_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_seghist_stage_1_parloop_339250_total_total_runtime = 0;
    ctx->futhark_mc_seghist_stage_1_parloop_339250_total_runs = 0;
    ctx->futhark_mc_seghist_stage_1_parloop_339250_total_iter = 0;
    ctx->futhark_mc_segmented_segred_parloop_339255_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmented_segred_parloop_339255_runs = calloc(sizeof(int),
                                                                  ctx->scheduler.num_threads);
    ctx->futhark_mc_segmented_segred_parloop_339255_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmented_segred_parloop_339255_total_total_runtime = 0;
    ctx->futhark_mc_segmented_segred_parloop_339255_total_runs = 0;
    ctx->futhark_mc_segmented_segred_parloop_339255_total_iter = 0;
    ctx->futhark_mc_seghist_red_task_339253_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_seghist_red_task_339253_runs = calloc(sizeof(int),
                                                          ctx->scheduler.num_threads);
    ctx->futhark_mc_seghist_red_task_339253_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_seghist_red_task_339253_total_time = 0;
    ctx->futhark_mc_seghist_red_task_339253_total_iter = 0;
    ctx->futhark_mc_atomic_seg_hist_parloop_339257_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_atomic_seg_hist_parloop_339257_runs = calloc(sizeof(int),
                                                                 ctx->scheduler.num_threads);
    ctx->futhark_mc_atomic_seg_hist_parloop_339257_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_atomic_seg_hist_parloop_339257_total_total_runtime = 0;
    ctx->futhark_mc_atomic_seg_hist_parloop_339257_total_runs = 0;
    ctx->futhark_mc_atomic_seg_hist_parloop_339257_total_iter = 0;
    ctx->futhark_mc_seghist_task_339247_total_runtime = calloc(sizeof(int64_t),
                                                               ctx->scheduler.num_threads);
    ctx->futhark_mc_seghist_task_339247_runs = calloc(sizeof(int),
                                                      ctx->scheduler.num_threads);
    ctx->futhark_mc_seghist_task_339247_iter = calloc(sizeof(sizeof(int64_t)),
                                                      ctx->scheduler.num_threads);
    ctx->futhark_mc_seghist_task_339247_total_time = 0;
    ctx->futhark_mc_seghist_task_339247_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_339261_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339261_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339261_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339261_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_339261_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_339261_total_iter = 0;
    ctx->futhark_mc_segmap_task_339259_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339259_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339259_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339259_total_time = 0;
    ctx->futhark_mc_segmap_task_339259_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_339265_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339265_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339265_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339265_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_339265_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_339265_total_iter = 0;
    ctx->futhark_mc_segmap_task_339263_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339263_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339263_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339263_total_time = 0;
    ctx->futhark_mc_segmap_task_339263_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_339269_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339269_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339269_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339269_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_339269_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_339269_total_iter = 0;
    ctx->futhark_mc_segmap_task_339267_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339267_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339267_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339267_total_time = 0;
    ctx->futhark_mc_segmap_task_339267_total_iter = 0;
    ctx->futhark_mc_scan_stage_1_parloop_339274_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_scan_stage_1_parloop_339274_runs = calloc(sizeof(int),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_scan_stage_1_parloop_339274_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_scan_stage_1_parloop_339274_total_total_runtime = 0;
    ctx->futhark_mc_scan_stage_1_parloop_339274_total_runs = 0;
    ctx->futhark_mc_scan_stage_1_parloop_339274_total_iter = 0;
    ctx->futhark_mc_scan_stage_3_parloop_339276_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_scan_stage_3_parloop_339276_runs = calloc(sizeof(int),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_scan_stage_3_parloop_339276_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_scan_stage_3_parloop_339276_total_total_runtime = 0;
    ctx->futhark_mc_scan_stage_3_parloop_339276_total_runs = 0;
    ctx->futhark_mc_scan_stage_3_parloop_339276_total_iter = 0;
    ctx->futhark_mc_segscan_task_339271_total_runtime = calloc(sizeof(int64_t),
                                                               ctx->scheduler.num_threads);
    ctx->futhark_mc_segscan_task_339271_runs = calloc(sizeof(int),
                                                      ctx->scheduler.num_threads);
    ctx->futhark_mc_segscan_task_339271_iter = calloc(sizeof(sizeof(int64_t)),
                                                      ctx->scheduler.num_threads);
    ctx->futhark_mc_segscan_task_339271_total_time = 0;
    ctx->futhark_mc_segscan_task_339271_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_339280_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339280_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339280_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339280_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_339280_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_339280_total_iter = 0;
    ctx->futhark_mc_segmap_task_339278_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339278_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339278_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339278_total_time = 0;
    ctx->futhark_mc_segmap_task_339278_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_339284_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339284_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339284_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339284_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_339284_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_339284_total_iter = 0;
    ctx->futhark_mc_segmap_task_339282_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339282_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339282_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339282_total_time = 0;
    ctx->futhark_mc_segmap_task_339282_total_iter = 0;
    ctx->futhark_mc_segred_stage_1_parloop_339294_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_339294_runs = calloc(sizeof(int),
                                                                ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_339294_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_339294_total_total_runtime = 0;
    ctx->futhark_mc_segred_stage_1_parloop_339294_total_runs = 0;
    ctx->futhark_mc_segred_stage_1_parloop_339294_total_iter = 0;
    ctx->futhark_mc_segred_task_339289_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_339289_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_339289_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_339289_total_time = 0;
    ctx->futhark_mc_segred_task_339289_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_339287_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339287_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339287_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339287_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_339287_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_339287_total_iter = 0;
    ctx->futhark_mc_segmap_nested_task_339285_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_339285_runs = calloc(sizeof(int),
                                                            ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_339285_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339298_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339298_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339298_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339298_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_339298_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_339298_total_iter = 0;
    ctx->futhark_mc_segmap_task_339296_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339296_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339296_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339296_total_time = 0;
    ctx->futhark_mc_segmap_task_339296_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_339307_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339307_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339307_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339307_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_339307_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_339307_total_iter = 0;
    ctx->futhark_mc_segmap_task_339305_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339305_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339305_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339305_total_time = 0;
    ctx->futhark_mc_segmap_task_339305_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_339302_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339302_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339302_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339302_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_339302_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_339302_total_iter = 0;
    ctx->futhark_mc_segmap_nested_task_339300_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_339300_runs = calloc(sizeof(int),
                                                            ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_339300_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339318_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339318_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339318_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339318_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_339318_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_339318_total_iter = 0;
    ctx->futhark_mc_segmap_task_339316_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339316_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339316_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339316_total_time = 0;
    ctx->futhark_mc_segmap_task_339316_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_339311_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339311_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339311_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339311_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_339311_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_339311_total_iter = 0;
    ctx->futhark_mc_segmap_task_339309_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339309_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339309_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339309_total_time = 0;
    ctx->futhark_mc_segmap_task_339309_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_339323_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339323_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339323_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339323_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_339323_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_339323_total_iter = 0;
    ctx->futhark_mc_segmap_task_339321_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339321_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339321_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339321_total_time = 0;
    ctx->futhark_mc_segmap_task_339321_total_iter = 0;
    ctx->futhark_mc_segred_stage_1_parloop_339332_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_339332_runs = calloc(sizeof(int),
                                                                ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_339332_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_339332_total_total_runtime = 0;
    ctx->futhark_mc_segred_stage_1_parloop_339332_total_runs = 0;
    ctx->futhark_mc_segred_stage_1_parloop_339332_total_iter = 0;
    ctx->futhark_mc_segred_task_339328_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_339328_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_339328_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_339328_total_time = 0;
    ctx->futhark_mc_segred_task_339328_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_339326_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339326_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339326_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339326_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_339326_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_339326_total_iter = 0;
    ctx->futhark_mc_segmap_nested_task_339324_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_339324_runs = calloc(sizeof(int),
                                                            ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_339324_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_339340_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_339340_runs = calloc(sizeof(int),
                                                                ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_339340_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_339340_total_total_runtime = 0;
    ctx->futhark_mc_segred_stage_1_parloop_339340_total_runs = 0;
    ctx->futhark_mc_segred_stage_1_parloop_339340_total_iter = 0;
    ctx->futhark_mc_segred_task_339336_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_339336_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_339336_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_339336_total_time = 0;
    ctx->futhark_mc_segred_task_339336_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_339344_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339344_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339344_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339344_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_339344_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_339344_total_iter = 0;
    ctx->futhark_mc_segmap_task_339342_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339342_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339342_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_task_339342_total_time = 0;
    ctx->futhark_mc_segmap_task_339342_total_iter = 0;
    ctx->futhark_mc_segred_stage_1_parloop_339352_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_339352_runs = calloc(sizeof(int),
                                                                ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_339352_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_stage_1_parloop_339352_total_total_runtime = 0;
    ctx->futhark_mc_segred_stage_1_parloop_339352_total_runs = 0;
    ctx->futhark_mc_segred_stage_1_parloop_339352_total_iter = 0;
    ctx->futhark_mc_segred_task_339349_total_runtime = calloc(sizeof(int64_t),
                                                              ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_339349_runs = calloc(sizeof(int),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_339349_iter = calloc(sizeof(sizeof(int64_t)),
                                                     ctx->scheduler.num_threads);
    ctx->futhark_mc_segred_task_339349_total_time = 0;
    ctx->futhark_mc_segred_task_339349_total_iter = 0;
    ctx->futhark_mc_segmap_parloop_339347_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339347_runs = calloc(sizeof(int),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339347_iter = calloc(sizeof(sizeof(int64_t)),
                                                        ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_parloop_339347_total_total_runtime = 0;
    ctx->futhark_mc_segmap_parloop_339347_total_runs = 0;
    ctx->futhark_mc_segmap_parloop_339347_total_iter = 0;
    ctx->futhark_mc_segmap_nested_task_339345_total_runtime =
        calloc(sizeof(int64_t), ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_339345_runs = calloc(sizeof(int),
                                                            ctx->scheduler.num_threads);
    ctx->futhark_mc_segmap_nested_task_339345_iter =
        calloc(sizeof(sizeof(int64_t)), ctx->scheduler.num_threads);
    init_constants(ctx);
    return ctx;
}
void futhark_context_free(struct futhark_context *ctx)
{
    free(ctx->futhark_mc_segred_stage_1_parloop_337688_total_runtime);
    free(ctx->futhark_mc_segred_stage_1_parloop_337688_runs);
    free(ctx->futhark_mc_segred_stage_1_parloop_337688_iter);
    free(ctx->futhark_mc_segred_task_337685_total_runtime);
    free(ctx->futhark_mc_segred_task_337685_runs);
    free(ctx->futhark_mc_segred_task_337685_iter);
    free(ctx->futhark_mc_segred_stage_1_parloop_337697_total_runtime);
    free(ctx->futhark_mc_segred_stage_1_parloop_337697_runs);
    free(ctx->futhark_mc_segred_stage_1_parloop_337697_iter);
    free(ctx->futhark_mc_segred_task_337694_total_runtime);
    free(ctx->futhark_mc_segred_task_337694_runs);
    free(ctx->futhark_mc_segred_task_337694_iter);
    free(ctx->futhark_mc_segred_stage_1_parloop_337692_total_runtime);
    free(ctx->futhark_mc_segred_stage_1_parloop_337692_runs);
    free(ctx->futhark_mc_segred_stage_1_parloop_337692_iter);
    free(ctx->futhark_mc_segred_nested_task_337689_total_runtime);
    free(ctx->futhark_mc_segred_nested_task_337689_runs);
    free(ctx->futhark_mc_segred_nested_task_337689_iter);
    free(ctx->futhark_mc_scan_stage_1_parloop_337683_total_runtime);
    free(ctx->futhark_mc_scan_stage_1_parloop_337683_runs);
    free(ctx->futhark_mc_scan_stage_1_parloop_337683_iter);
    free(ctx->futhark_mc_segred_stage_1_parloop_337702_total_runtime);
    free(ctx->futhark_mc_segred_stage_1_parloop_337702_runs);
    free(ctx->futhark_mc_segred_stage_1_parloop_337702_iter);
    free(ctx->futhark_mc_segred_task_337699_total_runtime);
    free(ctx->futhark_mc_segred_task_337699_runs);
    free(ctx->futhark_mc_segred_task_337699_iter);
    free(ctx->futhark_mc_segred_stage_1_parloop_337711_total_runtime);
    free(ctx->futhark_mc_segred_stage_1_parloop_337711_runs);
    free(ctx->futhark_mc_segred_stage_1_parloop_337711_iter);
    free(ctx->futhark_mc_segred_task_337708_total_runtime);
    free(ctx->futhark_mc_segred_task_337708_runs);
    free(ctx->futhark_mc_segred_task_337708_iter);
    free(ctx->futhark_mc_segred_stage_1_parloop_337706_total_runtime);
    free(ctx->futhark_mc_segred_stage_1_parloop_337706_runs);
    free(ctx->futhark_mc_segred_stage_1_parloop_337706_iter);
    free(ctx->futhark_mc_segred_nested_task_337703_total_runtime);
    free(ctx->futhark_mc_segred_nested_task_337703_runs);
    free(ctx->futhark_mc_segred_nested_task_337703_iter);
    free(ctx->futhark_mc_segred_stage_1_parloop_337718_total_runtime);
    free(ctx->futhark_mc_segred_stage_1_parloop_337718_runs);
    free(ctx->futhark_mc_segred_stage_1_parloop_337718_iter);
    free(ctx->futhark_mc_segred_task_337715_total_runtime);
    free(ctx->futhark_mc_segred_task_337715_runs);
    free(ctx->futhark_mc_segred_task_337715_iter);
    free(ctx->futhark_mc_segred_stage_1_parloop_337727_total_runtime);
    free(ctx->futhark_mc_segred_stage_1_parloop_337727_runs);
    free(ctx->futhark_mc_segred_stage_1_parloop_337727_iter);
    free(ctx->futhark_mc_segred_task_337724_total_runtime);
    free(ctx->futhark_mc_segred_task_337724_runs);
    free(ctx->futhark_mc_segred_task_337724_iter);
    free(ctx->futhark_mc_segred_stage_1_parloop_337722_total_runtime);
    free(ctx->futhark_mc_segred_stage_1_parloop_337722_runs);
    free(ctx->futhark_mc_segred_stage_1_parloop_337722_iter);
    free(ctx->futhark_mc_segred_nested_task_337719_total_runtime);
    free(ctx->futhark_mc_segred_nested_task_337719_runs);
    free(ctx->futhark_mc_segred_nested_task_337719_iter);
    free(ctx->futhark_mc_scan_stage_3_parloop_337713_total_runtime);
    free(ctx->futhark_mc_scan_stage_3_parloop_337713_runs);
    free(ctx->futhark_mc_scan_stage_3_parloop_337713_iter);
    free(ctx->futhark_mc_segscan_task_337680_total_runtime);
    free(ctx->futhark_mc_segscan_task_337680_runs);
    free(ctx->futhark_mc_segscan_task_337680_iter);
    free(ctx->futhark_mc_segmap_parloop_337731_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_337731_runs);
    free(ctx->futhark_mc_segmap_parloop_337731_iter);
    free(ctx->futhark_mc_segmap_task_337729_total_runtime);
    free(ctx->futhark_mc_segmap_task_337729_runs);
    free(ctx->futhark_mc_segmap_task_337729_iter);
    free(ctx->futhark_mc_segmap_parloop_337735_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_337735_runs);
    free(ctx->futhark_mc_segmap_parloop_337735_iter);
    free(ctx->futhark_mc_segmap_task_337733_total_runtime);
    free(ctx->futhark_mc_segmap_task_337733_runs);
    free(ctx->futhark_mc_segmap_task_337733_iter);
    free(ctx->futhark_mc_scan_stage_1_parloop_337747_total_runtime);
    free(ctx->futhark_mc_scan_stage_1_parloop_337747_runs);
    free(ctx->futhark_mc_scan_stage_1_parloop_337747_iter);
    free(ctx->futhark_mc_scan_stage_3_parloop_337749_total_runtime);
    free(ctx->futhark_mc_scan_stage_3_parloop_337749_runs);
    free(ctx->futhark_mc_scan_stage_3_parloop_337749_iter);
    free(ctx->futhark_mc_segscan_task_337744_total_runtime);
    free(ctx->futhark_mc_segscan_task_337744_runs);
    free(ctx->futhark_mc_segscan_task_337744_iter);
    free(ctx->futhark_mc_segmap_parloop_337753_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_337753_runs);
    free(ctx->futhark_mc_segmap_parloop_337753_iter);
    free(ctx->futhark_mc_segmap_task_337751_total_runtime);
    free(ctx->futhark_mc_segmap_task_337751_runs);
    free(ctx->futhark_mc_segmap_task_337751_iter);
    free(ctx->futhark_mc_segmap_parloop_337740_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_337740_runs);
    free(ctx->futhark_mc_segmap_parloop_337740_iter);
    free(ctx->futhark_mc_segmap_nested_task_337738_total_runtime);
    free(ctx->futhark_mc_segmap_nested_task_337738_runs);
    free(ctx->futhark_mc_segmap_nested_task_337738_iter);
    free(ctx->futhark_mc_segmap_parloop_337757_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_337757_runs);
    free(ctx->futhark_mc_segmap_parloop_337757_iter);
    free(ctx->futhark_mc_segmap_task_337755_total_runtime);
    free(ctx->futhark_mc_segmap_task_337755_runs);
    free(ctx->futhark_mc_segmap_task_337755_iter);
    free(ctx->futhark_mc_segmap_parloop_337766_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_337766_runs);
    free(ctx->futhark_mc_segmap_parloop_337766_iter);
    free(ctx->futhark_mc_segmap_task_337764_total_runtime);
    free(ctx->futhark_mc_segmap_task_337764_runs);
    free(ctx->futhark_mc_segmap_task_337764_iter);
    free(ctx->futhark_mc_segmap_parloop_337775_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_337775_runs);
    free(ctx->futhark_mc_segmap_parloop_337775_iter);
    free(ctx->futhark_mc_segmap_task_337773_total_runtime);
    free(ctx->futhark_mc_segmap_task_337773_runs);
    free(ctx->futhark_mc_segmap_task_337773_iter);
    free(ctx->futhark_mc_segmap_parloop_337770_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_337770_runs);
    free(ctx->futhark_mc_segmap_parloop_337770_iter);
    free(ctx->futhark_mc_segmap_nested_task_337768_total_runtime);
    free(ctx->futhark_mc_segmap_nested_task_337768_runs);
    free(ctx->futhark_mc_segmap_nested_task_337768_iter);
    free(ctx->futhark_mc_segmap_parloop_337761_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_337761_runs);
    free(ctx->futhark_mc_segmap_parloop_337761_iter);
    free(ctx->futhark_mc_segmap_nested_task_337759_total_runtime);
    free(ctx->futhark_mc_segmap_nested_task_337759_runs);
    free(ctx->futhark_mc_segmap_nested_task_337759_iter);
    free(ctx->futhark_mc_segmap_parloop_337779_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_337779_runs);
    free(ctx->futhark_mc_segmap_parloop_337779_iter);
    free(ctx->futhark_mc_segmap_task_337777_total_runtime);
    free(ctx->futhark_mc_segmap_task_337777_runs);
    free(ctx->futhark_mc_segmap_task_337777_iter);
    free(ctx->futhark_mc_segmap_parloop_337792_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_337792_runs);
    free(ctx->futhark_mc_segmap_parloop_337792_iter);
    free(ctx->futhark_mc_segmap_task_337790_total_runtime);
    free(ctx->futhark_mc_segmap_task_337790_runs);
    free(ctx->futhark_mc_segmap_task_337790_iter);
    free(ctx->futhark_mc_scan_stage_1_parloop_337804_total_runtime);
    free(ctx->futhark_mc_scan_stage_1_parloop_337804_runs);
    free(ctx->futhark_mc_scan_stage_1_parloop_337804_iter);
    free(ctx->futhark_mc_scan_stage_3_parloop_337806_total_runtime);
    free(ctx->futhark_mc_scan_stage_3_parloop_337806_runs);
    free(ctx->futhark_mc_scan_stage_3_parloop_337806_iter);
    free(ctx->futhark_mc_segscan_task_337801_total_runtime);
    free(ctx->futhark_mc_segscan_task_337801_runs);
    free(ctx->futhark_mc_segscan_task_337801_iter);
    free(ctx->futhark_mc_segmap_parloop_337810_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_337810_runs);
    free(ctx->futhark_mc_segmap_parloop_337810_iter);
    free(ctx->futhark_mc_segmap_task_337808_total_runtime);
    free(ctx->futhark_mc_segmap_task_337808_runs);
    free(ctx->futhark_mc_segmap_task_337808_iter);
    free(ctx->futhark_mc_segmap_parloop_337797_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_337797_runs);
    free(ctx->futhark_mc_segmap_parloop_337797_iter);
    free(ctx->futhark_mc_segmap_nested_task_337795_total_runtime);
    free(ctx->futhark_mc_segmap_nested_task_337795_runs);
    free(ctx->futhark_mc_segmap_nested_task_337795_iter);
    free(ctx->futhark_mc_segmap_parloop_337786_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_337786_runs);
    free(ctx->futhark_mc_segmap_parloop_337786_iter);
    free(ctx->futhark_mc_segmap_nested_task_337784_total_runtime);
    free(ctx->futhark_mc_segmap_nested_task_337784_runs);
    free(ctx->futhark_mc_segmap_nested_task_337784_iter);
    free(ctx->futhark_mc_segmap_parloop_337814_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_337814_runs);
    free(ctx->futhark_mc_segmap_parloop_337814_iter);
    free(ctx->futhark_mc_segmap_task_337812_total_runtime);
    free(ctx->futhark_mc_segmap_task_337812_runs);
    free(ctx->futhark_mc_segmap_task_337812_iter);
    free(ctx->futhark_mc_segmap_parloop_337826_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_337826_runs);
    free(ctx->futhark_mc_segmap_parloop_337826_iter);
    free(ctx->futhark_mc_segmap_task_337824_total_runtime);
    free(ctx->futhark_mc_segmap_task_337824_runs);
    free(ctx->futhark_mc_segmap_task_337824_iter);
    free(ctx->futhark_mc_segmap_parloop_337839_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_337839_runs);
    free(ctx->futhark_mc_segmap_parloop_337839_iter);
    free(ctx->futhark_mc_segmap_task_337837_total_runtime);
    free(ctx->futhark_mc_segmap_task_337837_runs);
    free(ctx->futhark_mc_segmap_task_337837_iter);
    free(ctx->futhark_mc_segmap_parloop_337843_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_337843_runs);
    free(ctx->futhark_mc_segmap_parloop_337843_iter);
    free(ctx->futhark_mc_segmap_task_337841_total_runtime);
    free(ctx->futhark_mc_segmap_task_337841_runs);
    free(ctx->futhark_mc_segmap_task_337841_iter);
    free(ctx->futhark_mc_segmap_parloop_337832_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_337832_runs);
    free(ctx->futhark_mc_segmap_parloop_337832_iter);
    free(ctx->futhark_mc_segmap_nested_task_337830_total_runtime);
    free(ctx->futhark_mc_segmap_nested_task_337830_runs);
    free(ctx->futhark_mc_segmap_nested_task_337830_iter);
    free(ctx->futhark_mc_segmap_parloop_337820_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_337820_runs);
    free(ctx->futhark_mc_segmap_parloop_337820_iter);
    free(ctx->futhark_mc_segmap_nested_task_337818_total_runtime);
    free(ctx->futhark_mc_segmap_nested_task_337818_runs);
    free(ctx->futhark_mc_segmap_nested_task_337818_iter);
    free(ctx->futhark_mc_segmap_parloop_337847_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_337847_runs);
    free(ctx->futhark_mc_segmap_parloop_337847_iter);
    free(ctx->futhark_mc_segmap_task_337845_total_runtime);
    free(ctx->futhark_mc_segmap_task_337845_runs);
    free(ctx->futhark_mc_segmap_task_337845_iter);
    free(ctx->futhark_mc_segmap_parloop_337860_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_337860_runs);
    free(ctx->futhark_mc_segmap_parloop_337860_iter);
    free(ctx->futhark_mc_segmap_task_337858_total_runtime);
    free(ctx->futhark_mc_segmap_task_337858_runs);
    free(ctx->futhark_mc_segmap_task_337858_iter);
    free(ctx->futhark_mc_segmap_parloop_337864_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_337864_runs);
    free(ctx->futhark_mc_segmap_parloop_337864_iter);
    free(ctx->futhark_mc_segmap_task_337862_total_runtime);
    free(ctx->futhark_mc_segmap_task_337862_runs);
    free(ctx->futhark_mc_segmap_task_337862_iter);
    free(ctx->futhark_mc_segmap_parloop_337853_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_337853_runs);
    free(ctx->futhark_mc_segmap_parloop_337853_iter);
    free(ctx->futhark_mc_segmap_nested_task_337851_total_runtime);
    free(ctx->futhark_mc_segmap_nested_task_337851_runs);
    free(ctx->futhark_mc_segmap_nested_task_337851_iter);
    free(ctx->futhark_mc_segmap_parloop_337868_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_337868_runs);
    free(ctx->futhark_mc_segmap_parloop_337868_iter);
    free(ctx->futhark_mc_segmap_task_337866_total_runtime);
    free(ctx->futhark_mc_segmap_task_337866_runs);
    free(ctx->futhark_mc_segmap_task_337866_iter);
    free(ctx->futhark_mc_segmap_parloop_337881_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_337881_runs);
    free(ctx->futhark_mc_segmap_parloop_337881_iter);
    free(ctx->futhark_mc_segmap_task_337879_total_runtime);
    free(ctx->futhark_mc_segmap_task_337879_runs);
    free(ctx->futhark_mc_segmap_task_337879_iter);
    free(ctx->futhark_mc_segmap_parloop_337885_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_337885_runs);
    free(ctx->futhark_mc_segmap_parloop_337885_iter);
    free(ctx->futhark_mc_segmap_task_337883_total_runtime);
    free(ctx->futhark_mc_segmap_task_337883_runs);
    free(ctx->futhark_mc_segmap_task_337883_iter);
    free(ctx->futhark_mc_segmap_parloop_337874_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_337874_runs);
    free(ctx->futhark_mc_segmap_parloop_337874_iter);
    free(ctx->futhark_mc_segmap_nested_task_337872_total_runtime);
    free(ctx->futhark_mc_segmap_nested_task_337872_runs);
    free(ctx->futhark_mc_segmap_nested_task_337872_iter);
    free(ctx->futhark_mc_segmap_parloop_337889_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_337889_runs);
    free(ctx->futhark_mc_segmap_parloop_337889_iter);
    free(ctx->futhark_mc_segmap_task_337887_total_runtime);
    free(ctx->futhark_mc_segmap_task_337887_runs);
    free(ctx->futhark_mc_segmap_task_337887_iter);
    free(ctx->futhark_mc_segmap_parloop_337898_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_337898_runs);
    free(ctx->futhark_mc_segmap_parloop_337898_iter);
    free(ctx->futhark_mc_segmap_task_337896_total_runtime);
    free(ctx->futhark_mc_segmap_task_337896_runs);
    free(ctx->futhark_mc_segmap_task_337896_iter);
    free(ctx->futhark_mc_segmap_parloop_337893_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_337893_runs);
    free(ctx->futhark_mc_segmap_parloop_337893_iter);
    free(ctx->futhark_mc_segmap_nested_task_337891_total_runtime);
    free(ctx->futhark_mc_segmap_nested_task_337891_runs);
    free(ctx->futhark_mc_segmap_nested_task_337891_iter);
    free(ctx->futhark_mc_segmap_parloop_337902_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_337902_runs);
    free(ctx->futhark_mc_segmap_parloop_337902_iter);
    free(ctx->futhark_mc_segmap_task_337900_total_runtime);
    free(ctx->futhark_mc_segmap_task_337900_runs);
    free(ctx->futhark_mc_segmap_task_337900_iter);
    free(ctx->futhark_mc_segmap_parloop_337913_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_337913_runs);
    free(ctx->futhark_mc_segmap_parloop_337913_iter);
    free(ctx->futhark_mc_segmap_task_337911_total_runtime);
    free(ctx->futhark_mc_segmap_task_337911_runs);
    free(ctx->futhark_mc_segmap_task_337911_iter);
    free(ctx->futhark_mc_segmap_parloop_337924_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_337924_runs);
    free(ctx->futhark_mc_segmap_parloop_337924_iter);
    free(ctx->futhark_mc_segmap_task_337922_total_runtime);
    free(ctx->futhark_mc_segmap_task_337922_runs);
    free(ctx->futhark_mc_segmap_task_337922_iter);
    free(ctx->futhark_mc_segmap_parloop_337918_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_337918_runs);
    free(ctx->futhark_mc_segmap_parloop_337918_iter);
    free(ctx->futhark_mc_segmap_nested_task_337916_total_runtime);
    free(ctx->futhark_mc_segmap_nested_task_337916_runs);
    free(ctx->futhark_mc_segmap_nested_task_337916_iter);
    free(ctx->futhark_mc_segmap_parloop_337907_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_337907_runs);
    free(ctx->futhark_mc_segmap_parloop_337907_iter);
    free(ctx->futhark_mc_segmap_nested_task_337905_total_runtime);
    free(ctx->futhark_mc_segmap_nested_task_337905_runs);
    free(ctx->futhark_mc_segmap_nested_task_337905_iter);
    free(ctx->futhark_mc_segmap_parloop_337928_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_337928_runs);
    free(ctx->futhark_mc_segmap_parloop_337928_iter);
    free(ctx->futhark_mc_segmap_task_337926_total_runtime);
    free(ctx->futhark_mc_segmap_task_337926_runs);
    free(ctx->futhark_mc_segmap_task_337926_iter);
    free(ctx->futhark_mc_segmap_parloop_337937_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_337937_runs);
    free(ctx->futhark_mc_segmap_parloop_337937_iter);
    free(ctx->futhark_mc_segmap_task_337935_total_runtime);
    free(ctx->futhark_mc_segmap_task_337935_runs);
    free(ctx->futhark_mc_segmap_task_337935_iter);
    free(ctx->futhark_mc_segmap_parloop_337946_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_337946_runs);
    free(ctx->futhark_mc_segmap_parloop_337946_iter);
    free(ctx->futhark_mc_segmap_task_337944_total_runtime);
    free(ctx->futhark_mc_segmap_task_337944_runs);
    free(ctx->futhark_mc_segmap_task_337944_iter);
    free(ctx->futhark_mc_segred_stage_1_parloop_337954_total_runtime);
    free(ctx->futhark_mc_segred_stage_1_parloop_337954_runs);
    free(ctx->futhark_mc_segred_stage_1_parloop_337954_iter);
    free(ctx->futhark_mc_segred_task_337951_total_runtime);
    free(ctx->futhark_mc_segred_task_337951_runs);
    free(ctx->futhark_mc_segred_task_337951_iter);
    free(ctx->futhark_mc_segred_stage_1_parloop_337959_total_runtime);
    free(ctx->futhark_mc_segred_stage_1_parloop_337959_runs);
    free(ctx->futhark_mc_segred_stage_1_parloop_337959_iter);
    free(ctx->futhark_mc_segred_task_337956_total_runtime);
    free(ctx->futhark_mc_segred_task_337956_runs);
    free(ctx->futhark_mc_segred_task_337956_iter);
    free(ctx->futhark_mc_segmap_parloop_337949_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_337949_runs);
    free(ctx->futhark_mc_segmap_parloop_337949_iter);
    free(ctx->futhark_mc_segmap_nested_task_337947_total_runtime);
    free(ctx->futhark_mc_segmap_nested_task_337947_runs);
    free(ctx->futhark_mc_segmap_nested_task_337947_iter);
    free(ctx->futhark_mc_segmap_parloop_337941_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_337941_runs);
    free(ctx->futhark_mc_segmap_parloop_337941_iter);
    free(ctx->futhark_mc_segmap_nested_task_337939_total_runtime);
    free(ctx->futhark_mc_segmap_nested_task_337939_runs);
    free(ctx->futhark_mc_segmap_nested_task_337939_iter);
    free(ctx->futhark_mc_segmap_parloop_337932_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_337932_runs);
    free(ctx->futhark_mc_segmap_parloop_337932_iter);
    free(ctx->futhark_mc_segmap_nested_task_337930_total_runtime);
    free(ctx->futhark_mc_segmap_nested_task_337930_runs);
    free(ctx->futhark_mc_segmap_nested_task_337930_iter);
    free(ctx->futhark_mc_segmap_parloop_337963_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_337963_runs);
    free(ctx->futhark_mc_segmap_parloop_337963_iter);
    free(ctx->futhark_mc_segmap_task_337961_total_runtime);
    free(ctx->futhark_mc_segmap_task_337961_runs);
    free(ctx->futhark_mc_segmap_task_337961_iter);
    free(ctx->futhark_mc_segmap_parloop_337974_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_337974_runs);
    free(ctx->futhark_mc_segmap_parloop_337974_iter);
    free(ctx->futhark_mc_segmap_task_337972_total_runtime);
    free(ctx->futhark_mc_segmap_task_337972_runs);
    free(ctx->futhark_mc_segmap_task_337972_iter);
    free(ctx->futhark_mc_segmap_parloop_337985_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_337985_runs);
    free(ctx->futhark_mc_segmap_parloop_337985_iter);
    free(ctx->futhark_mc_segmap_task_337983_total_runtime);
    free(ctx->futhark_mc_segmap_task_337983_runs);
    free(ctx->futhark_mc_segmap_task_337983_iter);
    free(ctx->futhark_mc_segred_stage_1_parloop_337995_total_runtime);
    free(ctx->futhark_mc_segred_stage_1_parloop_337995_runs);
    free(ctx->futhark_mc_segred_stage_1_parloop_337995_iter);
    free(ctx->futhark_mc_segred_task_337990_total_runtime);
    free(ctx->futhark_mc_segred_task_337990_runs);
    free(ctx->futhark_mc_segred_task_337990_iter);
    free(ctx->futhark_mc_segred_stage_1_parloop_338001_total_runtime);
    free(ctx->futhark_mc_segred_stage_1_parloop_338001_runs);
    free(ctx->futhark_mc_segred_stage_1_parloop_338001_iter);
    free(ctx->futhark_mc_segred_task_337997_total_runtime);
    free(ctx->futhark_mc_segred_task_337997_runs);
    free(ctx->futhark_mc_segred_task_337997_iter);
    free(ctx->futhark_mc_segmap_parloop_337988_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_337988_runs);
    free(ctx->futhark_mc_segmap_parloop_337988_iter);
    free(ctx->futhark_mc_segmap_nested_task_337986_total_runtime);
    free(ctx->futhark_mc_segmap_nested_task_337986_runs);
    free(ctx->futhark_mc_segmap_nested_task_337986_iter);
    free(ctx->futhark_mc_segmap_parloop_337979_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_337979_runs);
    free(ctx->futhark_mc_segmap_parloop_337979_iter);
    free(ctx->futhark_mc_segmap_nested_task_337977_total_runtime);
    free(ctx->futhark_mc_segmap_nested_task_337977_runs);
    free(ctx->futhark_mc_segmap_nested_task_337977_iter);
    free(ctx->futhark_mc_segmap_parloop_337968_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_337968_runs);
    free(ctx->futhark_mc_segmap_parloop_337968_iter);
    free(ctx->futhark_mc_segmap_nested_task_337966_total_runtime);
    free(ctx->futhark_mc_segmap_nested_task_337966_runs);
    free(ctx->futhark_mc_segmap_nested_task_337966_iter);
    free(ctx->futhark_mc_segmap_parloop_338005_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338005_runs);
    free(ctx->futhark_mc_segmap_parloop_338005_iter);
    free(ctx->futhark_mc_segmap_task_338003_total_runtime);
    free(ctx->futhark_mc_segmap_task_338003_runs);
    free(ctx->futhark_mc_segmap_task_338003_iter);
    free(ctx->futhark_mc_segmap_parloop_338016_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338016_runs);
    free(ctx->futhark_mc_segmap_parloop_338016_iter);
    free(ctx->futhark_mc_segmap_task_338014_total_runtime);
    free(ctx->futhark_mc_segmap_task_338014_runs);
    free(ctx->futhark_mc_segmap_task_338014_iter);
    free(ctx->futhark_mc_segmap_parloop_338027_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338027_runs);
    free(ctx->futhark_mc_segmap_parloop_338027_iter);
    free(ctx->futhark_mc_segmap_task_338025_total_runtime);
    free(ctx->futhark_mc_segmap_task_338025_runs);
    free(ctx->futhark_mc_segmap_task_338025_iter);
    free(ctx->futhark_mc_segred_stage_1_parloop_338039_total_runtime);
    free(ctx->futhark_mc_segred_stage_1_parloop_338039_runs);
    free(ctx->futhark_mc_segred_stage_1_parloop_338039_iter);
    free(ctx->futhark_mc_segred_task_338032_total_runtime);
    free(ctx->futhark_mc_segred_task_338032_runs);
    free(ctx->futhark_mc_segred_task_338032_iter);
    free(ctx->futhark_mc_segred_stage_1_parloop_338045_total_runtime);
    free(ctx->futhark_mc_segred_stage_1_parloop_338045_runs);
    free(ctx->futhark_mc_segred_stage_1_parloop_338045_iter);
    free(ctx->futhark_mc_segred_task_338041_total_runtime);
    free(ctx->futhark_mc_segred_task_338041_runs);
    free(ctx->futhark_mc_segred_task_338041_iter);
    free(ctx->futhark_mc_segmap_parloop_338030_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338030_runs);
    free(ctx->futhark_mc_segmap_parloop_338030_iter);
    free(ctx->futhark_mc_segmap_nested_task_338028_total_runtime);
    free(ctx->futhark_mc_segmap_nested_task_338028_runs);
    free(ctx->futhark_mc_segmap_nested_task_338028_iter);
    free(ctx->futhark_mc_segmap_parloop_338021_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338021_runs);
    free(ctx->futhark_mc_segmap_parloop_338021_iter);
    free(ctx->futhark_mc_segmap_nested_task_338019_total_runtime);
    free(ctx->futhark_mc_segmap_nested_task_338019_runs);
    free(ctx->futhark_mc_segmap_nested_task_338019_iter);
    free(ctx->futhark_mc_segmap_parloop_338010_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338010_runs);
    free(ctx->futhark_mc_segmap_parloop_338010_iter);
    free(ctx->futhark_mc_segmap_nested_task_338008_total_runtime);
    free(ctx->futhark_mc_segmap_nested_task_338008_runs);
    free(ctx->futhark_mc_segmap_nested_task_338008_iter);
    free(ctx->futhark_mc_segmap_parloop_338049_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338049_runs);
    free(ctx->futhark_mc_segmap_parloop_338049_iter);
    free(ctx->futhark_mc_segmap_task_338047_total_runtime);
    free(ctx->futhark_mc_segmap_task_338047_runs);
    free(ctx->futhark_mc_segmap_task_338047_iter);
    free(ctx->futhark_mc_segmap_parloop_338059_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338059_runs);
    free(ctx->futhark_mc_segmap_parloop_338059_iter);
    free(ctx->futhark_mc_segmap_task_338057_total_runtime);
    free(ctx->futhark_mc_segmap_task_338057_runs);
    free(ctx->futhark_mc_segmap_task_338057_iter);
    free(ctx->futhark_mc_segmap_parloop_338069_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338069_runs);
    free(ctx->futhark_mc_segmap_parloop_338069_iter);
    free(ctx->futhark_mc_segmap_task_338067_total_runtime);
    free(ctx->futhark_mc_segmap_task_338067_runs);
    free(ctx->futhark_mc_segmap_task_338067_iter);
    free(ctx->futhark_mc_segred_stage_1_parloop_338079_total_runtime);
    free(ctx->futhark_mc_segred_stage_1_parloop_338079_runs);
    free(ctx->futhark_mc_segred_stage_1_parloop_338079_iter);
    free(ctx->futhark_mc_segred_task_338076_total_runtime);
    free(ctx->futhark_mc_segred_task_338076_runs);
    free(ctx->futhark_mc_segred_task_338076_iter);
    free(ctx->futhark_mc_segred_stage_1_parloop_338084_total_runtime);
    free(ctx->futhark_mc_segred_stage_1_parloop_338084_runs);
    free(ctx->futhark_mc_segred_stage_1_parloop_338084_iter);
    free(ctx->futhark_mc_segred_task_338081_total_runtime);
    free(ctx->futhark_mc_segred_task_338081_runs);
    free(ctx->futhark_mc_segred_task_338081_iter);
    free(ctx->futhark_mc_segmap_parloop_338073_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338073_runs);
    free(ctx->futhark_mc_segmap_parloop_338073_iter);
    free(ctx->futhark_mc_segmap_nested_task_338071_total_runtime);
    free(ctx->futhark_mc_segmap_nested_task_338071_runs);
    free(ctx->futhark_mc_segmap_nested_task_338071_iter);
    free(ctx->futhark_mc_segmap_parloop_338064_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338064_runs);
    free(ctx->futhark_mc_segmap_parloop_338064_iter);
    free(ctx->futhark_mc_segmap_nested_task_338062_total_runtime);
    free(ctx->futhark_mc_segmap_nested_task_338062_runs);
    free(ctx->futhark_mc_segmap_nested_task_338062_iter);
    free(ctx->futhark_mc_segmap_parloop_338054_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338054_runs);
    free(ctx->futhark_mc_segmap_parloop_338054_iter);
    free(ctx->futhark_mc_segmap_nested_task_338052_total_runtime);
    free(ctx->futhark_mc_segmap_nested_task_338052_runs);
    free(ctx->futhark_mc_segmap_nested_task_338052_iter);
    free(ctx->futhark_mc_segmap_parloop_338088_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338088_runs);
    free(ctx->futhark_mc_segmap_parloop_338088_iter);
    free(ctx->futhark_mc_segmap_task_338086_total_runtime);
    free(ctx->futhark_mc_segmap_task_338086_runs);
    free(ctx->futhark_mc_segmap_task_338086_iter);
    free(ctx->futhark_mc_segmap_parloop_338101_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338101_runs);
    free(ctx->futhark_mc_segmap_parloop_338101_iter);
    free(ctx->futhark_mc_segmap_task_338099_total_runtime);
    free(ctx->futhark_mc_segmap_task_338099_runs);
    free(ctx->futhark_mc_segmap_task_338099_iter);
    free(ctx->futhark_mc_segmap_parloop_338114_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338114_runs);
    free(ctx->futhark_mc_segmap_parloop_338114_iter);
    free(ctx->futhark_mc_segmap_task_338112_total_runtime);
    free(ctx->futhark_mc_segmap_task_338112_runs);
    free(ctx->futhark_mc_segmap_task_338112_iter);
    free(ctx->futhark_mc_segred_stage_1_parloop_338128_total_runtime);
    free(ctx->futhark_mc_segred_stage_1_parloop_338128_runs);
    free(ctx->futhark_mc_segred_stage_1_parloop_338128_iter);
    free(ctx->futhark_mc_segred_task_338123_total_runtime);
    free(ctx->futhark_mc_segred_task_338123_runs);
    free(ctx->futhark_mc_segred_task_338123_iter);
    free(ctx->futhark_mc_segred_stage_1_parloop_338134_total_runtime);
    free(ctx->futhark_mc_segred_stage_1_parloop_338134_runs);
    free(ctx->futhark_mc_segred_stage_1_parloop_338134_iter);
    free(ctx->futhark_mc_segred_task_338130_total_runtime);
    free(ctx->futhark_mc_segred_task_338130_runs);
    free(ctx->futhark_mc_segred_task_338130_iter);
    free(ctx->futhark_mc_segmap_parloop_338119_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338119_runs);
    free(ctx->futhark_mc_segmap_parloop_338119_iter);
    free(ctx->futhark_mc_segmap_nested_task_338117_total_runtime);
    free(ctx->futhark_mc_segmap_nested_task_338117_runs);
    free(ctx->futhark_mc_segmap_nested_task_338117_iter);
    free(ctx->futhark_mc_segmap_parloop_338108_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338108_runs);
    free(ctx->futhark_mc_segmap_parloop_338108_iter);
    free(ctx->futhark_mc_segmap_nested_task_338106_total_runtime);
    free(ctx->futhark_mc_segmap_nested_task_338106_runs);
    free(ctx->futhark_mc_segmap_nested_task_338106_iter);
    free(ctx->futhark_mc_segmap_parloop_338095_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338095_runs);
    free(ctx->futhark_mc_segmap_parloop_338095_iter);
    free(ctx->futhark_mc_segmap_nested_task_338093_total_runtime);
    free(ctx->futhark_mc_segmap_nested_task_338093_runs);
    free(ctx->futhark_mc_segmap_nested_task_338093_iter);
    free(ctx->futhark_mc_segmap_parloop_338138_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338138_runs);
    free(ctx->futhark_mc_segmap_parloop_338138_iter);
    free(ctx->futhark_mc_segmap_task_338136_total_runtime);
    free(ctx->futhark_mc_segmap_task_338136_runs);
    free(ctx->futhark_mc_segmap_task_338136_iter);
    free(ctx->futhark_mc_segmap_parloop_338153_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338153_runs);
    free(ctx->futhark_mc_segmap_parloop_338153_iter);
    free(ctx->futhark_mc_segmap_task_338151_total_runtime);
    free(ctx->futhark_mc_segmap_task_338151_runs);
    free(ctx->futhark_mc_segmap_task_338151_iter);
    free(ctx->futhark_mc_segmap_parloop_338168_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338168_runs);
    free(ctx->futhark_mc_segmap_parloop_338168_iter);
    free(ctx->futhark_mc_segmap_task_338166_total_runtime);
    free(ctx->futhark_mc_segmap_task_338166_runs);
    free(ctx->futhark_mc_segmap_task_338166_iter);
    free(ctx->futhark_mc_segmap_parloop_338183_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338183_runs);
    free(ctx->futhark_mc_segmap_parloop_338183_iter);
    free(ctx->futhark_mc_segmap_task_338181_total_runtime);
    free(ctx->futhark_mc_segmap_task_338181_runs);
    free(ctx->futhark_mc_segmap_task_338181_iter);
    free(ctx->futhark_mc_segred_stage_1_parloop_338192_total_runtime);
    free(ctx->futhark_mc_segred_stage_1_parloop_338192_runs);
    free(ctx->futhark_mc_segred_stage_1_parloop_338192_iter);
    free(ctx->futhark_mc_segred_task_338185_total_runtime);
    free(ctx->futhark_mc_segred_task_338185_runs);
    free(ctx->futhark_mc_segred_task_338185_iter);
    free(ctx->futhark_mc_segred_stage_1_parloop_338198_total_runtime);
    free(ctx->futhark_mc_segred_stage_1_parloop_338198_runs);
    free(ctx->futhark_mc_segred_stage_1_parloop_338198_iter);
    free(ctx->futhark_mc_segred_task_338194_total_runtime);
    free(ctx->futhark_mc_segred_task_338194_runs);
    free(ctx->futhark_mc_segred_task_338194_iter);
    free(ctx->futhark_mc_segmap_parloop_338175_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338175_runs);
    free(ctx->futhark_mc_segmap_parloop_338175_iter);
    free(ctx->futhark_mc_segmap_nested_task_338173_total_runtime);
    free(ctx->futhark_mc_segmap_nested_task_338173_runs);
    free(ctx->futhark_mc_segmap_nested_task_338173_iter);
    free(ctx->futhark_mc_segmap_parloop_338162_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338162_runs);
    free(ctx->futhark_mc_segmap_parloop_338162_iter);
    free(ctx->futhark_mc_segmap_nested_task_338160_total_runtime);
    free(ctx->futhark_mc_segmap_nested_task_338160_runs);
    free(ctx->futhark_mc_segmap_nested_task_338160_iter);
    free(ctx->futhark_mc_segmap_parloop_338147_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338147_runs);
    free(ctx->futhark_mc_segmap_parloop_338147_iter);
    free(ctx->futhark_mc_segmap_nested_task_338145_total_runtime);
    free(ctx->futhark_mc_segmap_nested_task_338145_runs);
    free(ctx->futhark_mc_segmap_nested_task_338145_iter);
    free(ctx->futhark_mc_segmap_parloop_338202_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338202_runs);
    free(ctx->futhark_mc_segmap_parloop_338202_iter);
    free(ctx->futhark_mc_segmap_task_338200_total_runtime);
    free(ctx->futhark_mc_segmap_task_338200_runs);
    free(ctx->futhark_mc_segmap_task_338200_iter);
    free(ctx->futhark_mc_segmap_parloop_338211_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338211_runs);
    free(ctx->futhark_mc_segmap_parloop_338211_iter);
    free(ctx->futhark_mc_segmap_task_338209_total_runtime);
    free(ctx->futhark_mc_segmap_task_338209_runs);
    free(ctx->futhark_mc_segmap_task_338209_iter);
    free(ctx->futhark_mc_segmap_parloop_338220_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338220_runs);
    free(ctx->futhark_mc_segmap_parloop_338220_iter);
    free(ctx->futhark_mc_segmap_task_338218_total_runtime);
    free(ctx->futhark_mc_segmap_task_338218_runs);
    free(ctx->futhark_mc_segmap_task_338218_iter);
    free(ctx->futhark_mc_segred_stage_1_parloop_338228_total_runtime);
    free(ctx->futhark_mc_segred_stage_1_parloop_338228_runs);
    free(ctx->futhark_mc_segred_stage_1_parloop_338228_iter);
    free(ctx->futhark_mc_segred_task_338225_total_runtime);
    free(ctx->futhark_mc_segred_task_338225_runs);
    free(ctx->futhark_mc_segred_task_338225_iter);
    free(ctx->futhark_mc_segred_stage_1_parloop_338233_total_runtime);
    free(ctx->futhark_mc_segred_stage_1_parloop_338233_runs);
    free(ctx->futhark_mc_segred_stage_1_parloop_338233_iter);
    free(ctx->futhark_mc_segred_task_338230_total_runtime);
    free(ctx->futhark_mc_segred_task_338230_runs);
    free(ctx->futhark_mc_segred_task_338230_iter);
    free(ctx->futhark_mc_segmap_parloop_338223_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338223_runs);
    free(ctx->futhark_mc_segmap_parloop_338223_iter);
    free(ctx->futhark_mc_segmap_nested_task_338221_total_runtime);
    free(ctx->futhark_mc_segmap_nested_task_338221_runs);
    free(ctx->futhark_mc_segmap_nested_task_338221_iter);
    free(ctx->futhark_mc_segmap_parloop_338215_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338215_runs);
    free(ctx->futhark_mc_segmap_parloop_338215_iter);
    free(ctx->futhark_mc_segmap_nested_task_338213_total_runtime);
    free(ctx->futhark_mc_segmap_nested_task_338213_runs);
    free(ctx->futhark_mc_segmap_nested_task_338213_iter);
    free(ctx->futhark_mc_segmap_parloop_338206_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338206_runs);
    free(ctx->futhark_mc_segmap_parloop_338206_iter);
    free(ctx->futhark_mc_segmap_nested_task_338204_total_runtime);
    free(ctx->futhark_mc_segmap_nested_task_338204_runs);
    free(ctx->futhark_mc_segmap_nested_task_338204_iter);
    free(ctx->futhark_mc_segmap_parloop_338237_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338237_runs);
    free(ctx->futhark_mc_segmap_parloop_338237_iter);
    free(ctx->futhark_mc_segmap_task_338235_total_runtime);
    free(ctx->futhark_mc_segmap_task_338235_runs);
    free(ctx->futhark_mc_segmap_task_338235_iter);
    free(ctx->futhark_mc_segmap_parloop_338248_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338248_runs);
    free(ctx->futhark_mc_segmap_parloop_338248_iter);
    free(ctx->futhark_mc_segmap_task_338246_total_runtime);
    free(ctx->futhark_mc_segmap_task_338246_runs);
    free(ctx->futhark_mc_segmap_task_338246_iter);
    free(ctx->futhark_mc_segmap_parloop_338259_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338259_runs);
    free(ctx->futhark_mc_segmap_parloop_338259_iter);
    free(ctx->futhark_mc_segmap_task_338257_total_runtime);
    free(ctx->futhark_mc_segmap_task_338257_runs);
    free(ctx->futhark_mc_segmap_task_338257_iter);
    free(ctx->futhark_mc_segred_stage_1_parloop_338269_total_runtime);
    free(ctx->futhark_mc_segred_stage_1_parloop_338269_runs);
    free(ctx->futhark_mc_segred_stage_1_parloop_338269_iter);
    free(ctx->futhark_mc_segred_task_338264_total_runtime);
    free(ctx->futhark_mc_segred_task_338264_runs);
    free(ctx->futhark_mc_segred_task_338264_iter);
    free(ctx->futhark_mc_segred_stage_1_parloop_338275_total_runtime);
    free(ctx->futhark_mc_segred_stage_1_parloop_338275_runs);
    free(ctx->futhark_mc_segred_stage_1_parloop_338275_iter);
    free(ctx->futhark_mc_segred_task_338271_total_runtime);
    free(ctx->futhark_mc_segred_task_338271_runs);
    free(ctx->futhark_mc_segred_task_338271_iter);
    free(ctx->futhark_mc_segmap_parloop_338262_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338262_runs);
    free(ctx->futhark_mc_segmap_parloop_338262_iter);
    free(ctx->futhark_mc_segmap_nested_task_338260_total_runtime);
    free(ctx->futhark_mc_segmap_nested_task_338260_runs);
    free(ctx->futhark_mc_segmap_nested_task_338260_iter);
    free(ctx->futhark_mc_segmap_parloop_338253_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338253_runs);
    free(ctx->futhark_mc_segmap_parloop_338253_iter);
    free(ctx->futhark_mc_segmap_nested_task_338251_total_runtime);
    free(ctx->futhark_mc_segmap_nested_task_338251_runs);
    free(ctx->futhark_mc_segmap_nested_task_338251_iter);
    free(ctx->futhark_mc_segmap_parloop_338242_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338242_runs);
    free(ctx->futhark_mc_segmap_parloop_338242_iter);
    free(ctx->futhark_mc_segmap_nested_task_338240_total_runtime);
    free(ctx->futhark_mc_segmap_nested_task_338240_runs);
    free(ctx->futhark_mc_segmap_nested_task_338240_iter);
    free(ctx->futhark_mc_segmap_parloop_338279_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338279_runs);
    free(ctx->futhark_mc_segmap_parloop_338279_iter);
    free(ctx->futhark_mc_segmap_task_338277_total_runtime);
    free(ctx->futhark_mc_segmap_task_338277_runs);
    free(ctx->futhark_mc_segmap_task_338277_iter);
    free(ctx->futhark_mc_segmap_parloop_338290_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338290_runs);
    free(ctx->futhark_mc_segmap_parloop_338290_iter);
    free(ctx->futhark_mc_segmap_task_338288_total_runtime);
    free(ctx->futhark_mc_segmap_task_338288_runs);
    free(ctx->futhark_mc_segmap_task_338288_iter);
    free(ctx->futhark_mc_segmap_parloop_338301_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338301_runs);
    free(ctx->futhark_mc_segmap_parloop_338301_iter);
    free(ctx->futhark_mc_segmap_task_338299_total_runtime);
    free(ctx->futhark_mc_segmap_task_338299_runs);
    free(ctx->futhark_mc_segmap_task_338299_iter);
    free(ctx->futhark_mc_segred_stage_1_parloop_338313_total_runtime);
    free(ctx->futhark_mc_segred_stage_1_parloop_338313_runs);
    free(ctx->futhark_mc_segred_stage_1_parloop_338313_iter);
    free(ctx->futhark_mc_segred_task_338306_total_runtime);
    free(ctx->futhark_mc_segred_task_338306_runs);
    free(ctx->futhark_mc_segred_task_338306_iter);
    free(ctx->futhark_mc_segred_stage_1_parloop_338319_total_runtime);
    free(ctx->futhark_mc_segred_stage_1_parloop_338319_runs);
    free(ctx->futhark_mc_segred_stage_1_parloop_338319_iter);
    free(ctx->futhark_mc_segred_task_338315_total_runtime);
    free(ctx->futhark_mc_segred_task_338315_runs);
    free(ctx->futhark_mc_segred_task_338315_iter);
    free(ctx->futhark_mc_segmap_parloop_338304_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338304_runs);
    free(ctx->futhark_mc_segmap_parloop_338304_iter);
    free(ctx->futhark_mc_segmap_nested_task_338302_total_runtime);
    free(ctx->futhark_mc_segmap_nested_task_338302_runs);
    free(ctx->futhark_mc_segmap_nested_task_338302_iter);
    free(ctx->futhark_mc_segmap_parloop_338295_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338295_runs);
    free(ctx->futhark_mc_segmap_parloop_338295_iter);
    free(ctx->futhark_mc_segmap_nested_task_338293_total_runtime);
    free(ctx->futhark_mc_segmap_nested_task_338293_runs);
    free(ctx->futhark_mc_segmap_nested_task_338293_iter);
    free(ctx->futhark_mc_segmap_parloop_338284_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338284_runs);
    free(ctx->futhark_mc_segmap_parloop_338284_iter);
    free(ctx->futhark_mc_segmap_nested_task_338282_total_runtime);
    free(ctx->futhark_mc_segmap_nested_task_338282_runs);
    free(ctx->futhark_mc_segmap_nested_task_338282_iter);
    free(ctx->futhark_mc_segmap_parloop_338323_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338323_runs);
    free(ctx->futhark_mc_segmap_parloop_338323_iter);
    free(ctx->futhark_mc_segmap_task_338321_total_runtime);
    free(ctx->futhark_mc_segmap_task_338321_runs);
    free(ctx->futhark_mc_segmap_task_338321_iter);
    free(ctx->futhark_mc_segmap_parloop_338332_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338332_runs);
    free(ctx->futhark_mc_segmap_parloop_338332_iter);
    free(ctx->futhark_mc_segmap_task_338330_total_runtime);
    free(ctx->futhark_mc_segmap_task_338330_runs);
    free(ctx->futhark_mc_segmap_task_338330_iter);
    free(ctx->futhark_mc_segmap_parloop_338341_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338341_runs);
    free(ctx->futhark_mc_segmap_parloop_338341_iter);
    free(ctx->futhark_mc_segmap_task_338339_total_runtime);
    free(ctx->futhark_mc_segmap_task_338339_runs);
    free(ctx->futhark_mc_segmap_task_338339_iter);
    free(ctx->futhark_mc_segmap_parloop_338336_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338336_runs);
    free(ctx->futhark_mc_segmap_parloop_338336_iter);
    free(ctx->futhark_mc_segmap_nested_task_338334_total_runtime);
    free(ctx->futhark_mc_segmap_nested_task_338334_runs);
    free(ctx->futhark_mc_segmap_nested_task_338334_iter);
    free(ctx->futhark_mc_segmap_parloop_338327_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338327_runs);
    free(ctx->futhark_mc_segmap_parloop_338327_iter);
    free(ctx->futhark_mc_segmap_nested_task_338325_total_runtime);
    free(ctx->futhark_mc_segmap_nested_task_338325_runs);
    free(ctx->futhark_mc_segmap_nested_task_338325_iter);
    free(ctx->futhark_mc_segmap_parloop_338345_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338345_runs);
    free(ctx->futhark_mc_segmap_parloop_338345_iter);
    free(ctx->futhark_mc_segmap_task_338343_total_runtime);
    free(ctx->futhark_mc_segmap_task_338343_runs);
    free(ctx->futhark_mc_segmap_task_338343_iter);
    free(ctx->futhark_mc_segmap_parloop_338354_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338354_runs);
    free(ctx->futhark_mc_segmap_parloop_338354_iter);
    free(ctx->futhark_mc_segmap_task_338352_total_runtime);
    free(ctx->futhark_mc_segmap_task_338352_runs);
    free(ctx->futhark_mc_segmap_task_338352_iter);
    free(ctx->futhark_mc_segmap_parloop_338349_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338349_runs);
    free(ctx->futhark_mc_segmap_parloop_338349_iter);
    free(ctx->futhark_mc_segmap_nested_task_338347_total_runtime);
    free(ctx->futhark_mc_segmap_nested_task_338347_runs);
    free(ctx->futhark_mc_segmap_nested_task_338347_iter);
    free(ctx->futhark_mc_segmap_parloop_338358_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338358_runs);
    free(ctx->futhark_mc_segmap_parloop_338358_iter);
    free(ctx->futhark_mc_segmap_task_338356_total_runtime);
    free(ctx->futhark_mc_segmap_task_338356_runs);
    free(ctx->futhark_mc_segmap_task_338356_iter);
    free(ctx->futhark_mc_segred_stage_1_parloop_338366_total_runtime);
    free(ctx->futhark_mc_segred_stage_1_parloop_338366_runs);
    free(ctx->futhark_mc_segred_stage_1_parloop_338366_iter);
    free(ctx->futhark_mc_segred_task_338363_total_runtime);
    free(ctx->futhark_mc_segred_task_338363_runs);
    free(ctx->futhark_mc_segred_task_338363_iter);
    free(ctx->futhark_mc_segmap_parloop_338361_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338361_runs);
    free(ctx->futhark_mc_segmap_parloop_338361_iter);
    free(ctx->futhark_mc_segmap_nested_task_338359_total_runtime);
    free(ctx->futhark_mc_segmap_nested_task_338359_runs);
    free(ctx->futhark_mc_segmap_nested_task_338359_iter);
    free(ctx->futhark_mc_segmap_parloop_338370_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338370_runs);
    free(ctx->futhark_mc_segmap_parloop_338370_iter);
    free(ctx->futhark_mc_segmap_task_338368_total_runtime);
    free(ctx->futhark_mc_segmap_task_338368_runs);
    free(ctx->futhark_mc_segmap_task_338368_iter);
    free(ctx->futhark_mc_scan_stage_1_parloop_338380_total_runtime);
    free(ctx->futhark_mc_scan_stage_1_parloop_338380_runs);
    free(ctx->futhark_mc_scan_stage_1_parloop_338380_iter);
    free(ctx->futhark_mc_scan_stage_3_parloop_338382_total_runtime);
    free(ctx->futhark_mc_scan_stage_3_parloop_338382_runs);
    free(ctx->futhark_mc_scan_stage_3_parloop_338382_iter);
    free(ctx->futhark_mc_segscan_task_338377_total_runtime);
    free(ctx->futhark_mc_segscan_task_338377_runs);
    free(ctx->futhark_mc_segscan_task_338377_iter);
    free(ctx->futhark_mc_segmap_parloop_338374_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338374_runs);
    free(ctx->futhark_mc_segmap_parloop_338374_iter);
    free(ctx->futhark_mc_segmap_nested_task_338372_total_runtime);
    free(ctx->futhark_mc_segmap_nested_task_338372_runs);
    free(ctx->futhark_mc_segmap_nested_task_338372_iter);
    free(ctx->futhark_mc_segmap_parloop_338386_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338386_runs);
    free(ctx->futhark_mc_segmap_parloop_338386_iter);
    free(ctx->futhark_mc_segmap_task_338384_total_runtime);
    free(ctx->futhark_mc_segmap_task_338384_runs);
    free(ctx->futhark_mc_segmap_task_338384_iter);
    free(ctx->futhark_mc_segred_stage_1_parloop_338394_total_runtime);
    free(ctx->futhark_mc_segred_stage_1_parloop_338394_runs);
    free(ctx->futhark_mc_segred_stage_1_parloop_338394_iter);
    free(ctx->futhark_mc_segred_task_338391_total_runtime);
    free(ctx->futhark_mc_segred_task_338391_runs);
    free(ctx->futhark_mc_segred_task_338391_iter);
    free(ctx->futhark_mc_segmap_parloop_338389_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338389_runs);
    free(ctx->futhark_mc_segmap_parloop_338389_iter);
    free(ctx->futhark_mc_segmap_nested_task_338387_total_runtime);
    free(ctx->futhark_mc_segmap_nested_task_338387_runs);
    free(ctx->futhark_mc_segmap_nested_task_338387_iter);
    free(ctx->futhark_mc_segmap_parloop_338398_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338398_runs);
    free(ctx->futhark_mc_segmap_parloop_338398_iter);
    free(ctx->futhark_mc_segmap_task_338396_total_runtime);
    free(ctx->futhark_mc_segmap_task_338396_runs);
    free(ctx->futhark_mc_segmap_task_338396_iter);
    free(ctx->futhark_mc_scan_stage_1_parloop_338408_total_runtime);
    free(ctx->futhark_mc_scan_stage_1_parloop_338408_runs);
    free(ctx->futhark_mc_scan_stage_1_parloop_338408_iter);
    free(ctx->futhark_mc_scan_stage_3_parloop_338410_total_runtime);
    free(ctx->futhark_mc_scan_stage_3_parloop_338410_runs);
    free(ctx->futhark_mc_scan_stage_3_parloop_338410_iter);
    free(ctx->futhark_mc_segscan_task_338405_total_runtime);
    free(ctx->futhark_mc_segscan_task_338405_runs);
    free(ctx->futhark_mc_segscan_task_338405_iter);
    free(ctx->futhark_mc_segmap_parloop_338402_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338402_runs);
    free(ctx->futhark_mc_segmap_parloop_338402_iter);
    free(ctx->futhark_mc_segmap_nested_task_338400_total_runtime);
    free(ctx->futhark_mc_segmap_nested_task_338400_runs);
    free(ctx->futhark_mc_segmap_nested_task_338400_iter);
    free(ctx->futhark_mc_segmap_parloop_338414_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338414_runs);
    free(ctx->futhark_mc_segmap_parloop_338414_iter);
    free(ctx->futhark_mc_segmap_task_338412_total_runtime);
    free(ctx->futhark_mc_segmap_task_338412_runs);
    free(ctx->futhark_mc_segmap_task_338412_iter);
    free(ctx->futhark_mc_segred_stage_1_parloop_338422_total_runtime);
    free(ctx->futhark_mc_segred_stage_1_parloop_338422_runs);
    free(ctx->futhark_mc_segred_stage_1_parloop_338422_iter);
    free(ctx->futhark_mc_segred_task_338419_total_runtime);
    free(ctx->futhark_mc_segred_task_338419_runs);
    free(ctx->futhark_mc_segred_task_338419_iter);
    free(ctx->futhark_mc_segmap_parloop_338417_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338417_runs);
    free(ctx->futhark_mc_segmap_parloop_338417_iter);
    free(ctx->futhark_mc_segmap_nested_task_338415_total_runtime);
    free(ctx->futhark_mc_segmap_nested_task_338415_runs);
    free(ctx->futhark_mc_segmap_nested_task_338415_iter);
    free(ctx->futhark_mc_segmap_parloop_338426_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338426_runs);
    free(ctx->futhark_mc_segmap_parloop_338426_iter);
    free(ctx->futhark_mc_segmap_task_338424_total_runtime);
    free(ctx->futhark_mc_segmap_task_338424_runs);
    free(ctx->futhark_mc_segmap_task_338424_iter);
    free(ctx->futhark_mc_scan_stage_1_parloop_338436_total_runtime);
    free(ctx->futhark_mc_scan_stage_1_parloop_338436_runs);
    free(ctx->futhark_mc_scan_stage_1_parloop_338436_iter);
    free(ctx->futhark_mc_scan_stage_3_parloop_338438_total_runtime);
    free(ctx->futhark_mc_scan_stage_3_parloop_338438_runs);
    free(ctx->futhark_mc_scan_stage_3_parloop_338438_iter);
    free(ctx->futhark_mc_segscan_task_338433_total_runtime);
    free(ctx->futhark_mc_segscan_task_338433_runs);
    free(ctx->futhark_mc_segscan_task_338433_iter);
    free(ctx->futhark_mc_segmap_parloop_338430_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338430_runs);
    free(ctx->futhark_mc_segmap_parloop_338430_iter);
    free(ctx->futhark_mc_segmap_nested_task_338428_total_runtime);
    free(ctx->futhark_mc_segmap_nested_task_338428_runs);
    free(ctx->futhark_mc_segmap_nested_task_338428_iter);
    free(ctx->futhark_mc_segmap_parloop_338442_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338442_runs);
    free(ctx->futhark_mc_segmap_parloop_338442_iter);
    free(ctx->futhark_mc_segmap_task_338440_total_runtime);
    free(ctx->futhark_mc_segmap_task_338440_runs);
    free(ctx->futhark_mc_segmap_task_338440_iter);
    free(ctx->futhark_mc_segmap_parloop_338451_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338451_runs);
    free(ctx->futhark_mc_segmap_parloop_338451_iter);
    free(ctx->futhark_mc_segmap_task_338449_total_runtime);
    free(ctx->futhark_mc_segmap_task_338449_runs);
    free(ctx->futhark_mc_segmap_task_338449_iter);
    free(ctx->futhark_mc_segred_stage_1_parloop_338459_total_runtime);
    free(ctx->futhark_mc_segred_stage_1_parloop_338459_runs);
    free(ctx->futhark_mc_segred_stage_1_parloop_338459_iter);
    free(ctx->futhark_mc_segred_task_338456_total_runtime);
    free(ctx->futhark_mc_segred_task_338456_runs);
    free(ctx->futhark_mc_segred_task_338456_iter);
    free(ctx->futhark_mc_segred_stage_1_parloop_338464_total_runtime);
    free(ctx->futhark_mc_segred_stage_1_parloop_338464_runs);
    free(ctx->futhark_mc_segred_stage_1_parloop_338464_iter);
    free(ctx->futhark_mc_segred_task_338461_total_runtime);
    free(ctx->futhark_mc_segred_task_338461_runs);
    free(ctx->futhark_mc_segred_task_338461_iter);
    free(ctx->futhark_mc_segmap_parloop_338454_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338454_runs);
    free(ctx->futhark_mc_segmap_parloop_338454_iter);
    free(ctx->futhark_mc_segmap_nested_task_338452_total_runtime);
    free(ctx->futhark_mc_segmap_nested_task_338452_runs);
    free(ctx->futhark_mc_segmap_nested_task_338452_iter);
    free(ctx->futhark_mc_segmap_parloop_338446_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338446_runs);
    free(ctx->futhark_mc_segmap_parloop_338446_iter);
    free(ctx->futhark_mc_segmap_nested_task_338444_total_runtime);
    free(ctx->futhark_mc_segmap_nested_task_338444_runs);
    free(ctx->futhark_mc_segmap_nested_task_338444_iter);
    free(ctx->futhark_mc_segmap_parloop_338468_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338468_runs);
    free(ctx->futhark_mc_segmap_parloop_338468_iter);
    free(ctx->futhark_mc_segmap_task_338466_total_runtime);
    free(ctx->futhark_mc_segmap_task_338466_runs);
    free(ctx->futhark_mc_segmap_task_338466_iter);
    free(ctx->futhark_mc_segmap_parloop_338479_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338479_runs);
    free(ctx->futhark_mc_segmap_parloop_338479_iter);
    free(ctx->futhark_mc_segmap_task_338477_total_runtime);
    free(ctx->futhark_mc_segmap_task_338477_runs);
    free(ctx->futhark_mc_segmap_task_338477_iter);
    free(ctx->futhark_mc_segred_stage_1_parloop_338489_total_runtime);
    free(ctx->futhark_mc_segred_stage_1_parloop_338489_runs);
    free(ctx->futhark_mc_segred_stage_1_parloop_338489_iter);
    free(ctx->futhark_mc_segred_task_338484_total_runtime);
    free(ctx->futhark_mc_segred_task_338484_runs);
    free(ctx->futhark_mc_segred_task_338484_iter);
    free(ctx->futhark_mc_segred_stage_1_parloop_338495_total_runtime);
    free(ctx->futhark_mc_segred_stage_1_parloop_338495_runs);
    free(ctx->futhark_mc_segred_stage_1_parloop_338495_iter);
    free(ctx->futhark_mc_segred_task_338491_total_runtime);
    free(ctx->futhark_mc_segred_task_338491_runs);
    free(ctx->futhark_mc_segred_task_338491_iter);
    free(ctx->futhark_mc_segmap_parloop_338482_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338482_runs);
    free(ctx->futhark_mc_segmap_parloop_338482_iter);
    free(ctx->futhark_mc_segmap_nested_task_338480_total_runtime);
    free(ctx->futhark_mc_segmap_nested_task_338480_runs);
    free(ctx->futhark_mc_segmap_nested_task_338480_iter);
    free(ctx->futhark_mc_segmap_parloop_338473_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338473_runs);
    free(ctx->futhark_mc_segmap_parloop_338473_iter);
    free(ctx->futhark_mc_segmap_nested_task_338471_total_runtime);
    free(ctx->futhark_mc_segmap_nested_task_338471_runs);
    free(ctx->futhark_mc_segmap_nested_task_338471_iter);
    free(ctx->futhark_mc_segmap_parloop_338499_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338499_runs);
    free(ctx->futhark_mc_segmap_parloop_338499_iter);
    free(ctx->futhark_mc_segmap_task_338497_total_runtime);
    free(ctx->futhark_mc_segmap_task_338497_runs);
    free(ctx->futhark_mc_segmap_task_338497_iter);
    free(ctx->futhark_mc_segmap_parloop_338510_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338510_runs);
    free(ctx->futhark_mc_segmap_parloop_338510_iter);
    free(ctx->futhark_mc_segmap_task_338508_total_runtime);
    free(ctx->futhark_mc_segmap_task_338508_runs);
    free(ctx->futhark_mc_segmap_task_338508_iter);
    free(ctx->futhark_mc_segred_stage_1_parloop_338522_total_runtime);
    free(ctx->futhark_mc_segred_stage_1_parloop_338522_runs);
    free(ctx->futhark_mc_segred_stage_1_parloop_338522_iter);
    free(ctx->futhark_mc_segred_task_338515_total_runtime);
    free(ctx->futhark_mc_segred_task_338515_runs);
    free(ctx->futhark_mc_segred_task_338515_iter);
    free(ctx->futhark_mc_segred_stage_1_parloop_338528_total_runtime);
    free(ctx->futhark_mc_segred_stage_1_parloop_338528_runs);
    free(ctx->futhark_mc_segred_stage_1_parloop_338528_iter);
    free(ctx->futhark_mc_segred_task_338524_total_runtime);
    free(ctx->futhark_mc_segred_task_338524_runs);
    free(ctx->futhark_mc_segred_task_338524_iter);
    free(ctx->futhark_mc_segmap_parloop_338513_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338513_runs);
    free(ctx->futhark_mc_segmap_parloop_338513_iter);
    free(ctx->futhark_mc_segmap_nested_task_338511_total_runtime);
    free(ctx->futhark_mc_segmap_nested_task_338511_runs);
    free(ctx->futhark_mc_segmap_nested_task_338511_iter);
    free(ctx->futhark_mc_segmap_parloop_338504_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338504_runs);
    free(ctx->futhark_mc_segmap_parloop_338504_iter);
    free(ctx->futhark_mc_segmap_nested_task_338502_total_runtime);
    free(ctx->futhark_mc_segmap_nested_task_338502_runs);
    free(ctx->futhark_mc_segmap_nested_task_338502_iter);
    free(ctx->futhark_mc_segmap_parloop_338532_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338532_runs);
    free(ctx->futhark_mc_segmap_parloop_338532_iter);
    free(ctx->futhark_mc_segmap_task_338530_total_runtime);
    free(ctx->futhark_mc_segmap_task_338530_runs);
    free(ctx->futhark_mc_segmap_task_338530_iter);
    free(ctx->futhark_mc_segmap_parloop_338542_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338542_runs);
    free(ctx->futhark_mc_segmap_parloop_338542_iter);
    free(ctx->futhark_mc_segmap_task_338540_total_runtime);
    free(ctx->futhark_mc_segmap_task_338540_runs);
    free(ctx->futhark_mc_segmap_task_338540_iter);
    free(ctx->futhark_mc_segred_stage_1_parloop_338552_total_runtime);
    free(ctx->futhark_mc_segred_stage_1_parloop_338552_runs);
    free(ctx->futhark_mc_segred_stage_1_parloop_338552_iter);
    free(ctx->futhark_mc_segred_task_338549_total_runtime);
    free(ctx->futhark_mc_segred_task_338549_runs);
    free(ctx->futhark_mc_segred_task_338549_iter);
    free(ctx->futhark_mc_segred_stage_1_parloop_338557_total_runtime);
    free(ctx->futhark_mc_segred_stage_1_parloop_338557_runs);
    free(ctx->futhark_mc_segred_stage_1_parloop_338557_iter);
    free(ctx->futhark_mc_segred_task_338554_total_runtime);
    free(ctx->futhark_mc_segred_task_338554_runs);
    free(ctx->futhark_mc_segred_task_338554_iter);
    free(ctx->futhark_mc_segmap_parloop_338546_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338546_runs);
    free(ctx->futhark_mc_segmap_parloop_338546_iter);
    free(ctx->futhark_mc_segmap_nested_task_338544_total_runtime);
    free(ctx->futhark_mc_segmap_nested_task_338544_runs);
    free(ctx->futhark_mc_segmap_nested_task_338544_iter);
    free(ctx->futhark_mc_segmap_parloop_338537_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338537_runs);
    free(ctx->futhark_mc_segmap_parloop_338537_iter);
    free(ctx->futhark_mc_segmap_nested_task_338535_total_runtime);
    free(ctx->futhark_mc_segmap_nested_task_338535_runs);
    free(ctx->futhark_mc_segmap_nested_task_338535_iter);
    free(ctx->futhark_mc_segmap_parloop_338561_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338561_runs);
    free(ctx->futhark_mc_segmap_parloop_338561_iter);
    free(ctx->futhark_mc_segmap_task_338559_total_runtime);
    free(ctx->futhark_mc_segmap_task_338559_runs);
    free(ctx->futhark_mc_segmap_task_338559_iter);
    free(ctx->futhark_mc_segmap_parloop_338574_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338574_runs);
    free(ctx->futhark_mc_segmap_parloop_338574_iter);
    free(ctx->futhark_mc_segmap_task_338572_total_runtime);
    free(ctx->futhark_mc_segmap_task_338572_runs);
    free(ctx->futhark_mc_segmap_task_338572_iter);
    free(ctx->futhark_mc_segred_stage_1_parloop_338588_total_runtime);
    free(ctx->futhark_mc_segred_stage_1_parloop_338588_runs);
    free(ctx->futhark_mc_segred_stage_1_parloop_338588_iter);
    free(ctx->futhark_mc_segred_task_338583_total_runtime);
    free(ctx->futhark_mc_segred_task_338583_runs);
    free(ctx->futhark_mc_segred_task_338583_iter);
    free(ctx->futhark_mc_segred_stage_1_parloop_338594_total_runtime);
    free(ctx->futhark_mc_segred_stage_1_parloop_338594_runs);
    free(ctx->futhark_mc_segred_stage_1_parloop_338594_iter);
    free(ctx->futhark_mc_segred_task_338590_total_runtime);
    free(ctx->futhark_mc_segred_task_338590_runs);
    free(ctx->futhark_mc_segred_task_338590_iter);
    free(ctx->futhark_mc_segmap_parloop_338579_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338579_runs);
    free(ctx->futhark_mc_segmap_parloop_338579_iter);
    free(ctx->futhark_mc_segmap_nested_task_338577_total_runtime);
    free(ctx->futhark_mc_segmap_nested_task_338577_runs);
    free(ctx->futhark_mc_segmap_nested_task_338577_iter);
    free(ctx->futhark_mc_segmap_parloop_338568_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338568_runs);
    free(ctx->futhark_mc_segmap_parloop_338568_iter);
    free(ctx->futhark_mc_segmap_nested_task_338566_total_runtime);
    free(ctx->futhark_mc_segmap_nested_task_338566_runs);
    free(ctx->futhark_mc_segmap_nested_task_338566_iter);
    free(ctx->futhark_mc_segmap_parloop_338598_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338598_runs);
    free(ctx->futhark_mc_segmap_parloop_338598_iter);
    free(ctx->futhark_mc_segmap_task_338596_total_runtime);
    free(ctx->futhark_mc_segmap_task_338596_runs);
    free(ctx->futhark_mc_segmap_task_338596_iter);
    free(ctx->futhark_mc_segmap_parloop_338613_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338613_runs);
    free(ctx->futhark_mc_segmap_parloop_338613_iter);
    free(ctx->futhark_mc_segmap_task_338611_total_runtime);
    free(ctx->futhark_mc_segmap_task_338611_runs);
    free(ctx->futhark_mc_segmap_task_338611_iter);
    free(ctx->futhark_mc_segmap_parloop_338628_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338628_runs);
    free(ctx->futhark_mc_segmap_parloop_338628_iter);
    free(ctx->futhark_mc_segmap_task_338626_total_runtime);
    free(ctx->futhark_mc_segmap_task_338626_runs);
    free(ctx->futhark_mc_segmap_task_338626_iter);
    free(ctx->futhark_mc_segred_stage_1_parloop_338637_total_runtime);
    free(ctx->futhark_mc_segred_stage_1_parloop_338637_runs);
    free(ctx->futhark_mc_segred_stage_1_parloop_338637_iter);
    free(ctx->futhark_mc_segred_task_338630_total_runtime);
    free(ctx->futhark_mc_segred_task_338630_runs);
    free(ctx->futhark_mc_segred_task_338630_iter);
    free(ctx->futhark_mc_segred_stage_1_parloop_338643_total_runtime);
    free(ctx->futhark_mc_segred_stage_1_parloop_338643_runs);
    free(ctx->futhark_mc_segred_stage_1_parloop_338643_iter);
    free(ctx->futhark_mc_segred_task_338639_total_runtime);
    free(ctx->futhark_mc_segred_task_338639_runs);
    free(ctx->futhark_mc_segred_task_338639_iter);
    free(ctx->futhark_mc_segmap_parloop_338620_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338620_runs);
    free(ctx->futhark_mc_segmap_parloop_338620_iter);
    free(ctx->futhark_mc_segmap_nested_task_338618_total_runtime);
    free(ctx->futhark_mc_segmap_nested_task_338618_runs);
    free(ctx->futhark_mc_segmap_nested_task_338618_iter);
    free(ctx->futhark_mc_segmap_parloop_338607_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338607_runs);
    free(ctx->futhark_mc_segmap_parloop_338607_iter);
    free(ctx->futhark_mc_segmap_nested_task_338605_total_runtime);
    free(ctx->futhark_mc_segmap_nested_task_338605_runs);
    free(ctx->futhark_mc_segmap_nested_task_338605_iter);
    free(ctx->futhark_mc_segmap_parloop_338647_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338647_runs);
    free(ctx->futhark_mc_segmap_parloop_338647_iter);
    free(ctx->futhark_mc_segmap_task_338645_total_runtime);
    free(ctx->futhark_mc_segmap_task_338645_runs);
    free(ctx->futhark_mc_segmap_task_338645_iter);
    free(ctx->futhark_mc_segmap_parloop_338656_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338656_runs);
    free(ctx->futhark_mc_segmap_parloop_338656_iter);
    free(ctx->futhark_mc_segmap_task_338654_total_runtime);
    free(ctx->futhark_mc_segmap_task_338654_runs);
    free(ctx->futhark_mc_segmap_task_338654_iter);
    free(ctx->futhark_mc_segred_stage_1_parloop_338664_total_runtime);
    free(ctx->futhark_mc_segred_stage_1_parloop_338664_runs);
    free(ctx->futhark_mc_segred_stage_1_parloop_338664_iter);
    free(ctx->futhark_mc_segred_task_338661_total_runtime);
    free(ctx->futhark_mc_segred_task_338661_runs);
    free(ctx->futhark_mc_segred_task_338661_iter);
    free(ctx->futhark_mc_segred_stage_1_parloop_338669_total_runtime);
    free(ctx->futhark_mc_segred_stage_1_parloop_338669_runs);
    free(ctx->futhark_mc_segred_stage_1_parloop_338669_iter);
    free(ctx->futhark_mc_segred_task_338666_total_runtime);
    free(ctx->futhark_mc_segred_task_338666_runs);
    free(ctx->futhark_mc_segred_task_338666_iter);
    free(ctx->futhark_mc_segmap_parloop_338659_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338659_runs);
    free(ctx->futhark_mc_segmap_parloop_338659_iter);
    free(ctx->futhark_mc_segmap_nested_task_338657_total_runtime);
    free(ctx->futhark_mc_segmap_nested_task_338657_runs);
    free(ctx->futhark_mc_segmap_nested_task_338657_iter);
    free(ctx->futhark_mc_segmap_parloop_338651_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338651_runs);
    free(ctx->futhark_mc_segmap_parloop_338651_iter);
    free(ctx->futhark_mc_segmap_nested_task_338649_total_runtime);
    free(ctx->futhark_mc_segmap_nested_task_338649_runs);
    free(ctx->futhark_mc_segmap_nested_task_338649_iter);
    free(ctx->futhark_mc_segmap_parloop_338673_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338673_runs);
    free(ctx->futhark_mc_segmap_parloop_338673_iter);
    free(ctx->futhark_mc_segmap_task_338671_total_runtime);
    free(ctx->futhark_mc_segmap_task_338671_runs);
    free(ctx->futhark_mc_segmap_task_338671_iter);
    free(ctx->futhark_mc_segmap_parloop_338684_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338684_runs);
    free(ctx->futhark_mc_segmap_parloop_338684_iter);
    free(ctx->futhark_mc_segmap_task_338682_total_runtime);
    free(ctx->futhark_mc_segmap_task_338682_runs);
    free(ctx->futhark_mc_segmap_task_338682_iter);
    free(ctx->futhark_mc_segred_stage_1_parloop_338694_total_runtime);
    free(ctx->futhark_mc_segred_stage_1_parloop_338694_runs);
    free(ctx->futhark_mc_segred_stage_1_parloop_338694_iter);
    free(ctx->futhark_mc_segred_task_338689_total_runtime);
    free(ctx->futhark_mc_segred_task_338689_runs);
    free(ctx->futhark_mc_segred_task_338689_iter);
    free(ctx->futhark_mc_segred_stage_1_parloop_338700_total_runtime);
    free(ctx->futhark_mc_segred_stage_1_parloop_338700_runs);
    free(ctx->futhark_mc_segred_stage_1_parloop_338700_iter);
    free(ctx->futhark_mc_segred_task_338696_total_runtime);
    free(ctx->futhark_mc_segred_task_338696_runs);
    free(ctx->futhark_mc_segred_task_338696_iter);
    free(ctx->futhark_mc_segmap_parloop_338687_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338687_runs);
    free(ctx->futhark_mc_segmap_parloop_338687_iter);
    free(ctx->futhark_mc_segmap_nested_task_338685_total_runtime);
    free(ctx->futhark_mc_segmap_nested_task_338685_runs);
    free(ctx->futhark_mc_segmap_nested_task_338685_iter);
    free(ctx->futhark_mc_segmap_parloop_338678_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338678_runs);
    free(ctx->futhark_mc_segmap_parloop_338678_iter);
    free(ctx->futhark_mc_segmap_nested_task_338676_total_runtime);
    free(ctx->futhark_mc_segmap_nested_task_338676_runs);
    free(ctx->futhark_mc_segmap_nested_task_338676_iter);
    free(ctx->futhark_mc_segmap_parloop_338704_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338704_runs);
    free(ctx->futhark_mc_segmap_parloop_338704_iter);
    free(ctx->futhark_mc_segmap_task_338702_total_runtime);
    free(ctx->futhark_mc_segmap_task_338702_runs);
    free(ctx->futhark_mc_segmap_task_338702_iter);
    free(ctx->futhark_mc_segmap_parloop_338715_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338715_runs);
    free(ctx->futhark_mc_segmap_parloop_338715_iter);
    free(ctx->futhark_mc_segmap_task_338713_total_runtime);
    free(ctx->futhark_mc_segmap_task_338713_runs);
    free(ctx->futhark_mc_segmap_task_338713_iter);
    free(ctx->futhark_mc_segred_stage_1_parloop_338727_total_runtime);
    free(ctx->futhark_mc_segred_stage_1_parloop_338727_runs);
    free(ctx->futhark_mc_segred_stage_1_parloop_338727_iter);
    free(ctx->futhark_mc_segred_task_338720_total_runtime);
    free(ctx->futhark_mc_segred_task_338720_runs);
    free(ctx->futhark_mc_segred_task_338720_iter);
    free(ctx->futhark_mc_segred_stage_1_parloop_338733_total_runtime);
    free(ctx->futhark_mc_segred_stage_1_parloop_338733_runs);
    free(ctx->futhark_mc_segred_stage_1_parloop_338733_iter);
    free(ctx->futhark_mc_segred_task_338729_total_runtime);
    free(ctx->futhark_mc_segred_task_338729_runs);
    free(ctx->futhark_mc_segred_task_338729_iter);
    free(ctx->futhark_mc_segmap_parloop_338718_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338718_runs);
    free(ctx->futhark_mc_segmap_parloop_338718_iter);
    free(ctx->futhark_mc_segmap_nested_task_338716_total_runtime);
    free(ctx->futhark_mc_segmap_nested_task_338716_runs);
    free(ctx->futhark_mc_segmap_nested_task_338716_iter);
    free(ctx->futhark_mc_segmap_parloop_338709_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338709_runs);
    free(ctx->futhark_mc_segmap_parloop_338709_iter);
    free(ctx->futhark_mc_segmap_nested_task_338707_total_runtime);
    free(ctx->futhark_mc_segmap_nested_task_338707_runs);
    free(ctx->futhark_mc_segmap_nested_task_338707_iter);
    free(ctx->futhark_mc_segmap_parloop_338737_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338737_runs);
    free(ctx->futhark_mc_segmap_parloop_338737_iter);
    free(ctx->futhark_mc_segmap_task_338735_total_runtime);
    free(ctx->futhark_mc_segmap_task_338735_runs);
    free(ctx->futhark_mc_segmap_task_338735_iter);
    free(ctx->futhark_mc_segmap_parloop_338746_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338746_runs);
    free(ctx->futhark_mc_segmap_parloop_338746_iter);
    free(ctx->futhark_mc_segmap_task_338744_total_runtime);
    free(ctx->futhark_mc_segmap_task_338744_runs);
    free(ctx->futhark_mc_segmap_task_338744_iter);
    free(ctx->futhark_mc_segmap_parloop_338741_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338741_runs);
    free(ctx->futhark_mc_segmap_parloop_338741_iter);
    free(ctx->futhark_mc_segmap_nested_task_338739_total_runtime);
    free(ctx->futhark_mc_segmap_nested_task_338739_runs);
    free(ctx->futhark_mc_segmap_nested_task_338739_iter);
    free(ctx->futhark_mc_segmap_parloop_338750_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338750_runs);
    free(ctx->futhark_mc_segmap_parloop_338750_iter);
    free(ctx->futhark_mc_segmap_task_338748_total_runtime);
    free(ctx->futhark_mc_segmap_task_338748_runs);
    free(ctx->futhark_mc_segmap_task_338748_iter);
    free(ctx->futhark_mc_segmap_parloop_338759_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338759_runs);
    free(ctx->futhark_mc_segmap_parloop_338759_iter);
    free(ctx->futhark_mc_segmap_task_338757_total_runtime);
    free(ctx->futhark_mc_segmap_task_338757_runs);
    free(ctx->futhark_mc_segmap_task_338757_iter);
    free(ctx->futhark_mc_segmap_parloop_338754_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338754_runs);
    free(ctx->futhark_mc_segmap_parloop_338754_iter);
    free(ctx->futhark_mc_segmap_nested_task_338752_total_runtime);
    free(ctx->futhark_mc_segmap_nested_task_338752_runs);
    free(ctx->futhark_mc_segmap_nested_task_338752_iter);
    free(ctx->futhark_mc_segmap_parloop_338763_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338763_runs);
    free(ctx->futhark_mc_segmap_parloop_338763_iter);
    free(ctx->futhark_mc_segmap_task_338761_total_runtime);
    free(ctx->futhark_mc_segmap_task_338761_runs);
    free(ctx->futhark_mc_segmap_task_338761_iter);
    free(ctx->futhark_mc_segmap_parloop_338778_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338778_runs);
    free(ctx->futhark_mc_segmap_parloop_338778_iter);
    free(ctx->futhark_mc_segmap_task_338776_total_runtime);
    free(ctx->futhark_mc_segmap_task_338776_runs);
    free(ctx->futhark_mc_segmap_task_338776_iter);
    free(ctx->futhark_mc_segmap_parloop_338782_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338782_runs);
    free(ctx->futhark_mc_segmap_parloop_338782_iter);
    free(ctx->futhark_mc_segmap_task_338780_total_runtime);
    free(ctx->futhark_mc_segmap_task_338780_runs);
    free(ctx->futhark_mc_segmap_task_338780_iter);
    free(ctx->futhark_mc_segmap_parloop_338786_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338786_runs);
    free(ctx->futhark_mc_segmap_parloop_338786_iter);
    free(ctx->futhark_mc_segmap_task_338784_total_runtime);
    free(ctx->futhark_mc_segmap_task_338784_runs);
    free(ctx->futhark_mc_segmap_task_338784_iter);
    free(ctx->futhark_mc_segred_stage_1_parloop_338794_total_runtime);
    free(ctx->futhark_mc_segred_stage_1_parloop_338794_runs);
    free(ctx->futhark_mc_segred_stage_1_parloop_338794_iter);
    free(ctx->futhark_mc_segred_task_338791_total_runtime);
    free(ctx->futhark_mc_segred_task_338791_runs);
    free(ctx->futhark_mc_segred_task_338791_iter);
    free(ctx->futhark_mc_segred_stage_1_parloop_338799_total_runtime);
    free(ctx->futhark_mc_segred_stage_1_parloop_338799_runs);
    free(ctx->futhark_mc_segred_stage_1_parloop_338799_iter);
    free(ctx->futhark_mc_segred_task_338796_total_runtime);
    free(ctx->futhark_mc_segred_task_338796_runs);
    free(ctx->futhark_mc_segred_task_338796_iter);
    free(ctx->futhark_mc_segmap_parloop_338789_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338789_runs);
    free(ctx->futhark_mc_segmap_parloop_338789_iter);
    free(ctx->futhark_mc_segmap_nested_task_338787_total_runtime);
    free(ctx->futhark_mc_segmap_nested_task_338787_runs);
    free(ctx->futhark_mc_segmap_nested_task_338787_iter);
    free(ctx->futhark_mc_segmap_parloop_338770_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338770_runs);
    free(ctx->futhark_mc_segmap_parloop_338770_iter);
    free(ctx->futhark_mc_segmap_nested_task_338768_total_runtime);
    free(ctx->futhark_mc_segmap_nested_task_338768_runs);
    free(ctx->futhark_mc_segmap_nested_task_338768_iter);
    free(ctx->futhark_mc_segmap_parloop_338803_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338803_runs);
    free(ctx->futhark_mc_segmap_parloop_338803_iter);
    free(ctx->futhark_mc_segmap_task_338801_total_runtime);
    free(ctx->futhark_mc_segmap_task_338801_runs);
    free(ctx->futhark_mc_segmap_task_338801_iter);
    free(ctx->futhark_mc_segmap_parloop_338820_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338820_runs);
    free(ctx->futhark_mc_segmap_parloop_338820_iter);
    free(ctx->futhark_mc_segmap_task_338818_total_runtime);
    free(ctx->futhark_mc_segmap_task_338818_runs);
    free(ctx->futhark_mc_segmap_task_338818_iter);
    free(ctx->futhark_mc_segmap_parloop_338824_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338824_runs);
    free(ctx->futhark_mc_segmap_parloop_338824_iter);
    free(ctx->futhark_mc_segmap_task_338822_total_runtime);
    free(ctx->futhark_mc_segmap_task_338822_runs);
    free(ctx->futhark_mc_segmap_task_338822_iter);
    free(ctx->futhark_mc_segmap_parloop_338828_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338828_runs);
    free(ctx->futhark_mc_segmap_parloop_338828_iter);
    free(ctx->futhark_mc_segmap_task_338826_total_runtime);
    free(ctx->futhark_mc_segmap_task_338826_runs);
    free(ctx->futhark_mc_segmap_task_338826_iter);
    free(ctx->futhark_mc_segred_stage_1_parloop_338838_total_runtime);
    free(ctx->futhark_mc_segred_stage_1_parloop_338838_runs);
    free(ctx->futhark_mc_segred_stage_1_parloop_338838_iter);
    free(ctx->futhark_mc_segred_task_338833_total_runtime);
    free(ctx->futhark_mc_segred_task_338833_runs);
    free(ctx->futhark_mc_segred_task_338833_iter);
    free(ctx->futhark_mc_segred_stage_1_parloop_338844_total_runtime);
    free(ctx->futhark_mc_segred_stage_1_parloop_338844_runs);
    free(ctx->futhark_mc_segred_stage_1_parloop_338844_iter);
    free(ctx->futhark_mc_segred_task_338840_total_runtime);
    free(ctx->futhark_mc_segred_task_338840_runs);
    free(ctx->futhark_mc_segred_task_338840_iter);
    free(ctx->futhark_mc_segmap_parloop_338831_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338831_runs);
    free(ctx->futhark_mc_segmap_parloop_338831_iter);
    free(ctx->futhark_mc_segmap_nested_task_338829_total_runtime);
    free(ctx->futhark_mc_segmap_nested_task_338829_runs);
    free(ctx->futhark_mc_segmap_nested_task_338829_iter);
    free(ctx->futhark_mc_segmap_parloop_338811_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338811_runs);
    free(ctx->futhark_mc_segmap_parloop_338811_iter);
    free(ctx->futhark_mc_segmap_nested_task_338809_total_runtime);
    free(ctx->futhark_mc_segmap_nested_task_338809_runs);
    free(ctx->futhark_mc_segmap_nested_task_338809_iter);
    free(ctx->futhark_mc_segmap_parloop_338848_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338848_runs);
    free(ctx->futhark_mc_segmap_parloop_338848_iter);
    free(ctx->futhark_mc_segmap_task_338846_total_runtime);
    free(ctx->futhark_mc_segmap_task_338846_runs);
    free(ctx->futhark_mc_segmap_task_338846_iter);
    free(ctx->futhark_mc_segmap_parloop_338865_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338865_runs);
    free(ctx->futhark_mc_segmap_parloop_338865_iter);
    free(ctx->futhark_mc_segmap_task_338863_total_runtime);
    free(ctx->futhark_mc_segmap_task_338863_runs);
    free(ctx->futhark_mc_segmap_task_338863_iter);
    free(ctx->futhark_mc_segmap_parloop_338869_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338869_runs);
    free(ctx->futhark_mc_segmap_parloop_338869_iter);
    free(ctx->futhark_mc_segmap_task_338867_total_runtime);
    free(ctx->futhark_mc_segmap_task_338867_runs);
    free(ctx->futhark_mc_segmap_task_338867_iter);
    free(ctx->futhark_mc_segmap_parloop_338873_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338873_runs);
    free(ctx->futhark_mc_segmap_parloop_338873_iter);
    free(ctx->futhark_mc_segmap_task_338871_total_runtime);
    free(ctx->futhark_mc_segmap_task_338871_runs);
    free(ctx->futhark_mc_segmap_task_338871_iter);
    free(ctx->futhark_mc_segred_stage_1_parloop_338885_total_runtime);
    free(ctx->futhark_mc_segred_stage_1_parloop_338885_runs);
    free(ctx->futhark_mc_segred_stage_1_parloop_338885_iter);
    free(ctx->futhark_mc_segred_task_338878_total_runtime);
    free(ctx->futhark_mc_segred_task_338878_runs);
    free(ctx->futhark_mc_segred_task_338878_iter);
    free(ctx->futhark_mc_segred_stage_1_parloop_338891_total_runtime);
    free(ctx->futhark_mc_segred_stage_1_parloop_338891_runs);
    free(ctx->futhark_mc_segred_stage_1_parloop_338891_iter);
    free(ctx->futhark_mc_segred_task_338887_total_runtime);
    free(ctx->futhark_mc_segred_task_338887_runs);
    free(ctx->futhark_mc_segred_task_338887_iter);
    free(ctx->futhark_mc_segmap_parloop_338876_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338876_runs);
    free(ctx->futhark_mc_segmap_parloop_338876_iter);
    free(ctx->futhark_mc_segmap_nested_task_338874_total_runtime);
    free(ctx->futhark_mc_segmap_nested_task_338874_runs);
    free(ctx->futhark_mc_segmap_nested_task_338874_iter);
    free(ctx->futhark_mc_segmap_parloop_338856_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338856_runs);
    free(ctx->futhark_mc_segmap_parloop_338856_iter);
    free(ctx->futhark_mc_segmap_nested_task_338854_total_runtime);
    free(ctx->futhark_mc_segmap_nested_task_338854_runs);
    free(ctx->futhark_mc_segmap_nested_task_338854_iter);
    free(ctx->futhark_mc_segmap_parloop_338895_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338895_runs);
    free(ctx->futhark_mc_segmap_parloop_338895_iter);
    free(ctx->futhark_mc_segmap_task_338893_total_runtime);
    free(ctx->futhark_mc_segmap_task_338893_runs);
    free(ctx->futhark_mc_segmap_task_338893_iter);
    free(ctx->futhark_mc_segmap_parloop_338911_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338911_runs);
    free(ctx->futhark_mc_segmap_parloop_338911_iter);
    free(ctx->futhark_mc_segmap_task_338909_total_runtime);
    free(ctx->futhark_mc_segmap_task_338909_runs);
    free(ctx->futhark_mc_segmap_task_338909_iter);
    free(ctx->futhark_mc_segmap_parloop_338915_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338915_runs);
    free(ctx->futhark_mc_segmap_parloop_338915_iter);
    free(ctx->futhark_mc_segmap_task_338913_total_runtime);
    free(ctx->futhark_mc_segmap_task_338913_runs);
    free(ctx->futhark_mc_segmap_task_338913_iter);
    free(ctx->futhark_mc_segmap_parloop_338919_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338919_runs);
    free(ctx->futhark_mc_segmap_parloop_338919_iter);
    free(ctx->futhark_mc_segmap_task_338917_total_runtime);
    free(ctx->futhark_mc_segmap_task_338917_runs);
    free(ctx->futhark_mc_segmap_task_338917_iter);
    free(ctx->futhark_mc_segred_stage_1_parloop_338929_total_runtime);
    free(ctx->futhark_mc_segred_stage_1_parloop_338929_runs);
    free(ctx->futhark_mc_segred_stage_1_parloop_338929_iter);
    free(ctx->futhark_mc_segred_task_338926_total_runtime);
    free(ctx->futhark_mc_segred_task_338926_runs);
    free(ctx->futhark_mc_segred_task_338926_iter);
    free(ctx->futhark_mc_segred_stage_1_parloop_338934_total_runtime);
    free(ctx->futhark_mc_segred_stage_1_parloop_338934_runs);
    free(ctx->futhark_mc_segred_stage_1_parloop_338934_iter);
    free(ctx->futhark_mc_segred_task_338931_total_runtime);
    free(ctx->futhark_mc_segred_task_338931_runs);
    free(ctx->futhark_mc_segred_task_338931_iter);
    free(ctx->futhark_mc_segmap_parloop_338923_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338923_runs);
    free(ctx->futhark_mc_segmap_parloop_338923_iter);
    free(ctx->futhark_mc_segmap_nested_task_338921_total_runtime);
    free(ctx->futhark_mc_segmap_nested_task_338921_runs);
    free(ctx->futhark_mc_segmap_nested_task_338921_iter);
    free(ctx->futhark_mc_segmap_parloop_338903_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338903_runs);
    free(ctx->futhark_mc_segmap_parloop_338903_iter);
    free(ctx->futhark_mc_segmap_nested_task_338901_total_runtime);
    free(ctx->futhark_mc_segmap_nested_task_338901_runs);
    free(ctx->futhark_mc_segmap_nested_task_338901_iter);
    free(ctx->futhark_mc_segmap_parloop_338938_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338938_runs);
    free(ctx->futhark_mc_segmap_parloop_338938_iter);
    free(ctx->futhark_mc_segmap_task_338936_total_runtime);
    free(ctx->futhark_mc_segmap_task_338936_runs);
    free(ctx->futhark_mc_segmap_task_338936_iter);
    free(ctx->futhark_mc_segmap_parloop_338957_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338957_runs);
    free(ctx->futhark_mc_segmap_parloop_338957_iter);
    free(ctx->futhark_mc_segmap_task_338955_total_runtime);
    free(ctx->futhark_mc_segmap_task_338955_runs);
    free(ctx->futhark_mc_segmap_task_338955_iter);
    free(ctx->futhark_mc_segmap_parloop_338961_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338961_runs);
    free(ctx->futhark_mc_segmap_parloop_338961_iter);
    free(ctx->futhark_mc_segmap_task_338959_total_runtime);
    free(ctx->futhark_mc_segmap_task_338959_runs);
    free(ctx->futhark_mc_segmap_task_338959_iter);
    free(ctx->futhark_mc_segmap_parloop_338965_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338965_runs);
    free(ctx->futhark_mc_segmap_parloop_338965_iter);
    free(ctx->futhark_mc_segmap_task_338963_total_runtime);
    free(ctx->futhark_mc_segmap_task_338963_runs);
    free(ctx->futhark_mc_segmap_task_338963_iter);
    free(ctx->futhark_mc_segred_stage_1_parloop_338979_total_runtime);
    free(ctx->futhark_mc_segred_stage_1_parloop_338979_runs);
    free(ctx->futhark_mc_segred_stage_1_parloop_338979_iter);
    free(ctx->futhark_mc_segred_task_338974_total_runtime);
    free(ctx->futhark_mc_segred_task_338974_runs);
    free(ctx->futhark_mc_segred_task_338974_iter);
    free(ctx->futhark_mc_segred_stage_1_parloop_338985_total_runtime);
    free(ctx->futhark_mc_segred_stage_1_parloop_338985_runs);
    free(ctx->futhark_mc_segred_stage_1_parloop_338985_iter);
    free(ctx->futhark_mc_segred_task_338981_total_runtime);
    free(ctx->futhark_mc_segred_task_338981_runs);
    free(ctx->futhark_mc_segred_task_338981_iter);
    free(ctx->futhark_mc_segmap_parloop_338970_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338970_runs);
    free(ctx->futhark_mc_segmap_parloop_338970_iter);
    free(ctx->futhark_mc_segmap_nested_task_338968_total_runtime);
    free(ctx->futhark_mc_segmap_nested_task_338968_runs);
    free(ctx->futhark_mc_segmap_nested_task_338968_iter);
    free(ctx->futhark_mc_segmap_parloop_338948_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338948_runs);
    free(ctx->futhark_mc_segmap_parloop_338948_iter);
    free(ctx->futhark_mc_segmap_nested_task_338946_total_runtime);
    free(ctx->futhark_mc_segmap_nested_task_338946_runs);
    free(ctx->futhark_mc_segmap_nested_task_338946_iter);
    free(ctx->futhark_mc_segmap_parloop_338989_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_338989_runs);
    free(ctx->futhark_mc_segmap_parloop_338989_iter);
    free(ctx->futhark_mc_segmap_task_338987_total_runtime);
    free(ctx->futhark_mc_segmap_task_338987_runs);
    free(ctx->futhark_mc_segmap_task_338987_iter);
    free(ctx->futhark_mc_segmap_parloop_339010_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_339010_runs);
    free(ctx->futhark_mc_segmap_parloop_339010_iter);
    free(ctx->futhark_mc_segmap_task_339008_total_runtime);
    free(ctx->futhark_mc_segmap_task_339008_runs);
    free(ctx->futhark_mc_segmap_task_339008_iter);
    free(ctx->futhark_mc_segmap_parloop_339014_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_339014_runs);
    free(ctx->futhark_mc_segmap_parloop_339014_iter);
    free(ctx->futhark_mc_segmap_task_339012_total_runtime);
    free(ctx->futhark_mc_segmap_task_339012_runs);
    free(ctx->futhark_mc_segmap_task_339012_iter);
    free(ctx->futhark_mc_segmap_parloop_339018_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_339018_runs);
    free(ctx->futhark_mc_segmap_parloop_339018_iter);
    free(ctx->futhark_mc_segmap_task_339016_total_runtime);
    free(ctx->futhark_mc_segmap_task_339016_runs);
    free(ctx->futhark_mc_segmap_task_339016_iter);
    free(ctx->futhark_mc_segmap_parloop_339033_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_339033_runs);
    free(ctx->futhark_mc_segmap_parloop_339033_iter);
    free(ctx->futhark_mc_segmap_task_339031_total_runtime);
    free(ctx->futhark_mc_segmap_task_339031_runs);
    free(ctx->futhark_mc_segmap_task_339031_iter);
    free(ctx->futhark_mc_segred_stage_1_parloop_339042_total_runtime);
    free(ctx->futhark_mc_segred_stage_1_parloop_339042_runs);
    free(ctx->futhark_mc_segred_stage_1_parloop_339042_iter);
    free(ctx->futhark_mc_segred_task_339035_total_runtime);
    free(ctx->futhark_mc_segred_task_339035_runs);
    free(ctx->futhark_mc_segred_task_339035_iter);
    free(ctx->futhark_mc_segred_stage_1_parloop_339048_total_runtime);
    free(ctx->futhark_mc_segred_stage_1_parloop_339048_runs);
    free(ctx->futhark_mc_segred_stage_1_parloop_339048_iter);
    free(ctx->futhark_mc_segred_task_339044_total_runtime);
    free(ctx->futhark_mc_segred_task_339044_runs);
    free(ctx->futhark_mc_segred_task_339044_iter);
    free(ctx->futhark_mc_segmap_parloop_339025_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_339025_runs);
    free(ctx->futhark_mc_segmap_parloop_339025_iter);
    free(ctx->futhark_mc_segmap_nested_task_339023_total_runtime);
    free(ctx->futhark_mc_segmap_nested_task_339023_runs);
    free(ctx->futhark_mc_segmap_nested_task_339023_iter);
    free(ctx->futhark_mc_segmap_parloop_339001_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_339001_runs);
    free(ctx->futhark_mc_segmap_parloop_339001_iter);
    free(ctx->futhark_mc_segmap_nested_task_338999_total_runtime);
    free(ctx->futhark_mc_segmap_nested_task_338999_runs);
    free(ctx->futhark_mc_segmap_nested_task_338999_iter);
    free(ctx->futhark_mc_segmap_parloop_339052_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_339052_runs);
    free(ctx->futhark_mc_segmap_parloop_339052_iter);
    free(ctx->futhark_mc_segmap_task_339050_total_runtime);
    free(ctx->futhark_mc_segmap_task_339050_runs);
    free(ctx->futhark_mc_segmap_task_339050_iter);
    free(ctx->futhark_mc_segmap_parloop_339067_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_339067_runs);
    free(ctx->futhark_mc_segmap_parloop_339067_iter);
    free(ctx->futhark_mc_segmap_task_339065_total_runtime);
    free(ctx->futhark_mc_segmap_task_339065_runs);
    free(ctx->futhark_mc_segmap_task_339065_iter);
    free(ctx->futhark_mc_segmap_parloop_339071_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_339071_runs);
    free(ctx->futhark_mc_segmap_parloop_339071_iter);
    free(ctx->futhark_mc_segmap_task_339069_total_runtime);
    free(ctx->futhark_mc_segmap_task_339069_runs);
    free(ctx->futhark_mc_segmap_task_339069_iter);
    free(ctx->futhark_mc_segmap_parloop_339075_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_339075_runs);
    free(ctx->futhark_mc_segmap_parloop_339075_iter);
    free(ctx->futhark_mc_segmap_task_339073_total_runtime);
    free(ctx->futhark_mc_segmap_task_339073_runs);
    free(ctx->futhark_mc_segmap_task_339073_iter);
    free(ctx->futhark_mc_segred_stage_1_parloop_339083_total_runtime);
    free(ctx->futhark_mc_segred_stage_1_parloop_339083_runs);
    free(ctx->futhark_mc_segred_stage_1_parloop_339083_iter);
    free(ctx->futhark_mc_segred_task_339080_total_runtime);
    free(ctx->futhark_mc_segred_task_339080_runs);
    free(ctx->futhark_mc_segred_task_339080_iter);
    free(ctx->futhark_mc_segred_stage_1_parloop_339088_total_runtime);
    free(ctx->futhark_mc_segred_stage_1_parloop_339088_runs);
    free(ctx->futhark_mc_segred_stage_1_parloop_339088_iter);
    free(ctx->futhark_mc_segred_task_339085_total_runtime);
    free(ctx->futhark_mc_segred_task_339085_runs);
    free(ctx->futhark_mc_segred_task_339085_iter);
    free(ctx->futhark_mc_segmap_parloop_339078_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_339078_runs);
    free(ctx->futhark_mc_segmap_parloop_339078_iter);
    free(ctx->futhark_mc_segmap_nested_task_339076_total_runtime);
    free(ctx->futhark_mc_segmap_nested_task_339076_runs);
    free(ctx->futhark_mc_segmap_nested_task_339076_iter);
    free(ctx->futhark_mc_segmap_parloop_339059_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_339059_runs);
    free(ctx->futhark_mc_segmap_parloop_339059_iter);
    free(ctx->futhark_mc_segmap_nested_task_339057_total_runtime);
    free(ctx->futhark_mc_segmap_nested_task_339057_runs);
    free(ctx->futhark_mc_segmap_nested_task_339057_iter);
    free(ctx->futhark_mc_segmap_parloop_339092_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_339092_runs);
    free(ctx->futhark_mc_segmap_parloop_339092_iter);
    free(ctx->futhark_mc_segmap_task_339090_total_runtime);
    free(ctx->futhark_mc_segmap_task_339090_runs);
    free(ctx->futhark_mc_segmap_task_339090_iter);
    free(ctx->futhark_mc_segmap_parloop_339109_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_339109_runs);
    free(ctx->futhark_mc_segmap_parloop_339109_iter);
    free(ctx->futhark_mc_segmap_task_339107_total_runtime);
    free(ctx->futhark_mc_segmap_task_339107_runs);
    free(ctx->futhark_mc_segmap_task_339107_iter);
    free(ctx->futhark_mc_segmap_parloop_339113_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_339113_runs);
    free(ctx->futhark_mc_segmap_parloop_339113_iter);
    free(ctx->futhark_mc_segmap_task_339111_total_runtime);
    free(ctx->futhark_mc_segmap_task_339111_runs);
    free(ctx->futhark_mc_segmap_task_339111_iter);
    free(ctx->futhark_mc_segmap_parloop_339117_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_339117_runs);
    free(ctx->futhark_mc_segmap_parloop_339117_iter);
    free(ctx->futhark_mc_segmap_task_339115_total_runtime);
    free(ctx->futhark_mc_segmap_task_339115_runs);
    free(ctx->futhark_mc_segmap_task_339115_iter);
    free(ctx->futhark_mc_segred_stage_1_parloop_339127_total_runtime);
    free(ctx->futhark_mc_segred_stage_1_parloop_339127_runs);
    free(ctx->futhark_mc_segred_stage_1_parloop_339127_iter);
    free(ctx->futhark_mc_segred_task_339122_total_runtime);
    free(ctx->futhark_mc_segred_task_339122_runs);
    free(ctx->futhark_mc_segred_task_339122_iter);
    free(ctx->futhark_mc_segred_stage_1_parloop_339133_total_runtime);
    free(ctx->futhark_mc_segred_stage_1_parloop_339133_runs);
    free(ctx->futhark_mc_segred_stage_1_parloop_339133_iter);
    free(ctx->futhark_mc_segred_task_339129_total_runtime);
    free(ctx->futhark_mc_segred_task_339129_runs);
    free(ctx->futhark_mc_segred_task_339129_iter);
    free(ctx->futhark_mc_segmap_parloop_339120_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_339120_runs);
    free(ctx->futhark_mc_segmap_parloop_339120_iter);
    free(ctx->futhark_mc_segmap_nested_task_339118_total_runtime);
    free(ctx->futhark_mc_segmap_nested_task_339118_runs);
    free(ctx->futhark_mc_segmap_nested_task_339118_iter);
    free(ctx->futhark_mc_segmap_parloop_339100_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_339100_runs);
    free(ctx->futhark_mc_segmap_parloop_339100_iter);
    free(ctx->futhark_mc_segmap_nested_task_339098_total_runtime);
    free(ctx->futhark_mc_segmap_nested_task_339098_runs);
    free(ctx->futhark_mc_segmap_nested_task_339098_iter);
    free(ctx->futhark_mc_segmap_parloop_339137_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_339137_runs);
    free(ctx->futhark_mc_segmap_parloop_339137_iter);
    free(ctx->futhark_mc_segmap_task_339135_total_runtime);
    free(ctx->futhark_mc_segmap_task_339135_runs);
    free(ctx->futhark_mc_segmap_task_339135_iter);
    free(ctx->futhark_mc_segmap_parloop_339154_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_339154_runs);
    free(ctx->futhark_mc_segmap_parloop_339154_iter);
    free(ctx->futhark_mc_segmap_task_339152_total_runtime);
    free(ctx->futhark_mc_segmap_task_339152_runs);
    free(ctx->futhark_mc_segmap_task_339152_iter);
    free(ctx->futhark_mc_segmap_parloop_339158_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_339158_runs);
    free(ctx->futhark_mc_segmap_parloop_339158_iter);
    free(ctx->futhark_mc_segmap_task_339156_total_runtime);
    free(ctx->futhark_mc_segmap_task_339156_runs);
    free(ctx->futhark_mc_segmap_task_339156_iter);
    free(ctx->futhark_mc_segmap_parloop_339162_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_339162_runs);
    free(ctx->futhark_mc_segmap_parloop_339162_iter);
    free(ctx->futhark_mc_segmap_task_339160_total_runtime);
    free(ctx->futhark_mc_segmap_task_339160_runs);
    free(ctx->futhark_mc_segmap_task_339160_iter);
    free(ctx->futhark_mc_segred_stage_1_parloop_339174_total_runtime);
    free(ctx->futhark_mc_segred_stage_1_parloop_339174_runs);
    free(ctx->futhark_mc_segred_stage_1_parloop_339174_iter);
    free(ctx->futhark_mc_segred_task_339167_total_runtime);
    free(ctx->futhark_mc_segred_task_339167_runs);
    free(ctx->futhark_mc_segred_task_339167_iter);
    free(ctx->futhark_mc_segred_stage_1_parloop_339180_total_runtime);
    free(ctx->futhark_mc_segred_stage_1_parloop_339180_runs);
    free(ctx->futhark_mc_segred_stage_1_parloop_339180_iter);
    free(ctx->futhark_mc_segred_task_339176_total_runtime);
    free(ctx->futhark_mc_segred_task_339176_runs);
    free(ctx->futhark_mc_segred_task_339176_iter);
    free(ctx->futhark_mc_segmap_parloop_339165_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_339165_runs);
    free(ctx->futhark_mc_segmap_parloop_339165_iter);
    free(ctx->futhark_mc_segmap_nested_task_339163_total_runtime);
    free(ctx->futhark_mc_segmap_nested_task_339163_runs);
    free(ctx->futhark_mc_segmap_nested_task_339163_iter);
    free(ctx->futhark_mc_segmap_parloop_339145_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_339145_runs);
    free(ctx->futhark_mc_segmap_parloop_339145_iter);
    free(ctx->futhark_mc_segmap_nested_task_339143_total_runtime);
    free(ctx->futhark_mc_segmap_nested_task_339143_runs);
    free(ctx->futhark_mc_segmap_nested_task_339143_iter);
    free(ctx->futhark_mc_segmap_parloop_339184_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_339184_runs);
    free(ctx->futhark_mc_segmap_parloop_339184_iter);
    free(ctx->futhark_mc_segmap_task_339182_total_runtime);
    free(ctx->futhark_mc_segmap_task_339182_runs);
    free(ctx->futhark_mc_segmap_task_339182_iter);
    free(ctx->futhark_mc_segmap_parloop_339193_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_339193_runs);
    free(ctx->futhark_mc_segmap_parloop_339193_iter);
    free(ctx->futhark_mc_segmap_task_339191_total_runtime);
    free(ctx->futhark_mc_segmap_task_339191_runs);
    free(ctx->futhark_mc_segmap_task_339191_iter);
    free(ctx->futhark_mc_segmap_parloop_339188_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_339188_runs);
    free(ctx->futhark_mc_segmap_parloop_339188_iter);
    free(ctx->futhark_mc_segmap_nested_task_339186_total_runtime);
    free(ctx->futhark_mc_segmap_nested_task_339186_runs);
    free(ctx->futhark_mc_segmap_nested_task_339186_iter);
    free(ctx->futhark_mc_segmap_parloop_339197_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_339197_runs);
    free(ctx->futhark_mc_segmap_parloop_339197_iter);
    free(ctx->futhark_mc_segmap_task_339195_total_runtime);
    free(ctx->futhark_mc_segmap_task_339195_runs);
    free(ctx->futhark_mc_segmap_task_339195_iter);
    free(ctx->futhark_mc_segmap_parloop_339208_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_339208_runs);
    free(ctx->futhark_mc_segmap_parloop_339208_iter);
    free(ctx->futhark_mc_segmap_task_339206_total_runtime);
    free(ctx->futhark_mc_segmap_task_339206_runs);
    free(ctx->futhark_mc_segmap_task_339206_iter);
    free(ctx->futhark_mc_segmap_parloop_339212_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_339212_runs);
    free(ctx->futhark_mc_segmap_parloop_339212_iter);
    free(ctx->futhark_mc_segmap_task_339210_total_runtime);
    free(ctx->futhark_mc_segmap_task_339210_runs);
    free(ctx->futhark_mc_segmap_task_339210_iter);
    free(ctx->futhark_mc_segmap_parloop_339202_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_339202_runs);
    free(ctx->futhark_mc_segmap_parloop_339202_iter);
    free(ctx->futhark_mc_segmap_nested_task_339200_total_runtime);
    free(ctx->futhark_mc_segmap_nested_task_339200_runs);
    free(ctx->futhark_mc_segmap_nested_task_339200_iter);
    free(ctx->futhark_mc_segmap_parloop_339216_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_339216_runs);
    free(ctx->futhark_mc_segmap_parloop_339216_iter);
    free(ctx->futhark_mc_segmap_task_339214_total_runtime);
    free(ctx->futhark_mc_segmap_task_339214_runs);
    free(ctx->futhark_mc_segmap_task_339214_iter);
    free(ctx->futhark_mc_segred_stage_1_parloop_339225_total_runtime);
    free(ctx->futhark_mc_segred_stage_1_parloop_339225_runs);
    free(ctx->futhark_mc_segred_stage_1_parloop_339225_iter);
    free(ctx->futhark_mc_segred_task_339221_total_runtime);
    free(ctx->futhark_mc_segred_task_339221_runs);
    free(ctx->futhark_mc_segred_task_339221_iter);
    free(ctx->futhark_mc_segmap_parloop_339219_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_339219_runs);
    free(ctx->futhark_mc_segmap_parloop_339219_iter);
    free(ctx->futhark_mc_segmap_nested_task_339217_total_runtime);
    free(ctx->futhark_mc_segmap_nested_task_339217_runs);
    free(ctx->futhark_mc_segmap_nested_task_339217_iter);
    free(ctx->futhark_mc_segmap_parloop_339229_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_339229_runs);
    free(ctx->futhark_mc_segmap_parloop_339229_iter);
    free(ctx->futhark_mc_segmap_task_339227_total_runtime);
    free(ctx->futhark_mc_segmap_task_339227_runs);
    free(ctx->futhark_mc_segmap_task_339227_iter);
    free(ctx->futhark_mc_segmap_parloop_339234_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_339234_runs);
    free(ctx->futhark_mc_segmap_parloop_339234_iter);
    free(ctx->futhark_mc_segmap_task_339232_total_runtime);
    free(ctx->futhark_mc_segmap_task_339232_runs);
    free(ctx->futhark_mc_segmap_task_339232_iter);
    free(ctx->futhark_mc_scan_stage_1_parloop_339239_total_runtime);
    free(ctx->futhark_mc_scan_stage_1_parloop_339239_runs);
    free(ctx->futhark_mc_scan_stage_1_parloop_339239_iter);
    free(ctx->futhark_mc_scan_stage_3_parloop_339241_total_runtime);
    free(ctx->futhark_mc_scan_stage_3_parloop_339241_runs);
    free(ctx->futhark_mc_scan_stage_3_parloop_339241_iter);
    free(ctx->futhark_mc_segscan_task_339236_total_runtime);
    free(ctx->futhark_mc_segscan_task_339236_runs);
    free(ctx->futhark_mc_segscan_task_339236_iter);
    free(ctx->futhark_mc_segmap_parloop_339245_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_339245_runs);
    free(ctx->futhark_mc_segmap_parloop_339245_iter);
    free(ctx->futhark_mc_segmap_task_339243_total_runtime);
    free(ctx->futhark_mc_segmap_task_339243_runs);
    free(ctx->futhark_mc_segmap_task_339243_iter);
    free(ctx->futhark_mc_seghist_stage_1_parloop_339250_total_runtime);
    free(ctx->futhark_mc_seghist_stage_1_parloop_339250_runs);
    free(ctx->futhark_mc_seghist_stage_1_parloop_339250_iter);
    free(ctx->futhark_mc_segmented_segred_parloop_339255_total_runtime);
    free(ctx->futhark_mc_segmented_segred_parloop_339255_runs);
    free(ctx->futhark_mc_segmented_segred_parloop_339255_iter);
    free(ctx->futhark_mc_seghist_red_task_339253_total_runtime);
    free(ctx->futhark_mc_seghist_red_task_339253_runs);
    free(ctx->futhark_mc_seghist_red_task_339253_iter);
    free(ctx->futhark_mc_atomic_seg_hist_parloop_339257_total_runtime);
    free(ctx->futhark_mc_atomic_seg_hist_parloop_339257_runs);
    free(ctx->futhark_mc_atomic_seg_hist_parloop_339257_iter);
    free(ctx->futhark_mc_seghist_task_339247_total_runtime);
    free(ctx->futhark_mc_seghist_task_339247_runs);
    free(ctx->futhark_mc_seghist_task_339247_iter);
    free(ctx->futhark_mc_segmap_parloop_339261_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_339261_runs);
    free(ctx->futhark_mc_segmap_parloop_339261_iter);
    free(ctx->futhark_mc_segmap_task_339259_total_runtime);
    free(ctx->futhark_mc_segmap_task_339259_runs);
    free(ctx->futhark_mc_segmap_task_339259_iter);
    free(ctx->futhark_mc_segmap_parloop_339265_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_339265_runs);
    free(ctx->futhark_mc_segmap_parloop_339265_iter);
    free(ctx->futhark_mc_segmap_task_339263_total_runtime);
    free(ctx->futhark_mc_segmap_task_339263_runs);
    free(ctx->futhark_mc_segmap_task_339263_iter);
    free(ctx->futhark_mc_segmap_parloop_339269_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_339269_runs);
    free(ctx->futhark_mc_segmap_parloop_339269_iter);
    free(ctx->futhark_mc_segmap_task_339267_total_runtime);
    free(ctx->futhark_mc_segmap_task_339267_runs);
    free(ctx->futhark_mc_segmap_task_339267_iter);
    free(ctx->futhark_mc_scan_stage_1_parloop_339274_total_runtime);
    free(ctx->futhark_mc_scan_stage_1_parloop_339274_runs);
    free(ctx->futhark_mc_scan_stage_1_parloop_339274_iter);
    free(ctx->futhark_mc_scan_stage_3_parloop_339276_total_runtime);
    free(ctx->futhark_mc_scan_stage_3_parloop_339276_runs);
    free(ctx->futhark_mc_scan_stage_3_parloop_339276_iter);
    free(ctx->futhark_mc_segscan_task_339271_total_runtime);
    free(ctx->futhark_mc_segscan_task_339271_runs);
    free(ctx->futhark_mc_segscan_task_339271_iter);
    free(ctx->futhark_mc_segmap_parloop_339280_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_339280_runs);
    free(ctx->futhark_mc_segmap_parloop_339280_iter);
    free(ctx->futhark_mc_segmap_task_339278_total_runtime);
    free(ctx->futhark_mc_segmap_task_339278_runs);
    free(ctx->futhark_mc_segmap_task_339278_iter);
    free(ctx->futhark_mc_segmap_parloop_339284_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_339284_runs);
    free(ctx->futhark_mc_segmap_parloop_339284_iter);
    free(ctx->futhark_mc_segmap_task_339282_total_runtime);
    free(ctx->futhark_mc_segmap_task_339282_runs);
    free(ctx->futhark_mc_segmap_task_339282_iter);
    free(ctx->futhark_mc_segred_stage_1_parloop_339294_total_runtime);
    free(ctx->futhark_mc_segred_stage_1_parloop_339294_runs);
    free(ctx->futhark_mc_segred_stage_1_parloop_339294_iter);
    free(ctx->futhark_mc_segred_task_339289_total_runtime);
    free(ctx->futhark_mc_segred_task_339289_runs);
    free(ctx->futhark_mc_segred_task_339289_iter);
    free(ctx->futhark_mc_segmap_parloop_339287_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_339287_runs);
    free(ctx->futhark_mc_segmap_parloop_339287_iter);
    free(ctx->futhark_mc_segmap_nested_task_339285_total_runtime);
    free(ctx->futhark_mc_segmap_nested_task_339285_runs);
    free(ctx->futhark_mc_segmap_nested_task_339285_iter);
    free(ctx->futhark_mc_segmap_parloop_339298_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_339298_runs);
    free(ctx->futhark_mc_segmap_parloop_339298_iter);
    free(ctx->futhark_mc_segmap_task_339296_total_runtime);
    free(ctx->futhark_mc_segmap_task_339296_runs);
    free(ctx->futhark_mc_segmap_task_339296_iter);
    free(ctx->futhark_mc_segmap_parloop_339307_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_339307_runs);
    free(ctx->futhark_mc_segmap_parloop_339307_iter);
    free(ctx->futhark_mc_segmap_task_339305_total_runtime);
    free(ctx->futhark_mc_segmap_task_339305_runs);
    free(ctx->futhark_mc_segmap_task_339305_iter);
    free(ctx->futhark_mc_segmap_parloop_339302_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_339302_runs);
    free(ctx->futhark_mc_segmap_parloop_339302_iter);
    free(ctx->futhark_mc_segmap_nested_task_339300_total_runtime);
    free(ctx->futhark_mc_segmap_nested_task_339300_runs);
    free(ctx->futhark_mc_segmap_nested_task_339300_iter);
    free(ctx->futhark_mc_segmap_parloop_339318_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_339318_runs);
    free(ctx->futhark_mc_segmap_parloop_339318_iter);
    free(ctx->futhark_mc_segmap_task_339316_total_runtime);
    free(ctx->futhark_mc_segmap_task_339316_runs);
    free(ctx->futhark_mc_segmap_task_339316_iter);
    free(ctx->futhark_mc_segmap_parloop_339311_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_339311_runs);
    free(ctx->futhark_mc_segmap_parloop_339311_iter);
    free(ctx->futhark_mc_segmap_task_339309_total_runtime);
    free(ctx->futhark_mc_segmap_task_339309_runs);
    free(ctx->futhark_mc_segmap_task_339309_iter);
    free(ctx->futhark_mc_segmap_parloop_339323_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_339323_runs);
    free(ctx->futhark_mc_segmap_parloop_339323_iter);
    free(ctx->futhark_mc_segmap_task_339321_total_runtime);
    free(ctx->futhark_mc_segmap_task_339321_runs);
    free(ctx->futhark_mc_segmap_task_339321_iter);
    free(ctx->futhark_mc_segred_stage_1_parloop_339332_total_runtime);
    free(ctx->futhark_mc_segred_stage_1_parloop_339332_runs);
    free(ctx->futhark_mc_segred_stage_1_parloop_339332_iter);
    free(ctx->futhark_mc_segred_task_339328_total_runtime);
    free(ctx->futhark_mc_segred_task_339328_runs);
    free(ctx->futhark_mc_segred_task_339328_iter);
    free(ctx->futhark_mc_segmap_parloop_339326_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_339326_runs);
    free(ctx->futhark_mc_segmap_parloop_339326_iter);
    free(ctx->futhark_mc_segmap_nested_task_339324_total_runtime);
    free(ctx->futhark_mc_segmap_nested_task_339324_runs);
    free(ctx->futhark_mc_segmap_nested_task_339324_iter);
    free(ctx->futhark_mc_segred_stage_1_parloop_339340_total_runtime);
    free(ctx->futhark_mc_segred_stage_1_parloop_339340_runs);
    free(ctx->futhark_mc_segred_stage_1_parloop_339340_iter);
    free(ctx->futhark_mc_segred_task_339336_total_runtime);
    free(ctx->futhark_mc_segred_task_339336_runs);
    free(ctx->futhark_mc_segred_task_339336_iter);
    free(ctx->futhark_mc_segmap_parloop_339344_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_339344_runs);
    free(ctx->futhark_mc_segmap_parloop_339344_iter);
    free(ctx->futhark_mc_segmap_task_339342_total_runtime);
    free(ctx->futhark_mc_segmap_task_339342_runs);
    free(ctx->futhark_mc_segmap_task_339342_iter);
    free(ctx->futhark_mc_segred_stage_1_parloop_339352_total_runtime);
    free(ctx->futhark_mc_segred_stage_1_parloop_339352_runs);
    free(ctx->futhark_mc_segred_stage_1_parloop_339352_iter);
    free(ctx->futhark_mc_segred_task_339349_total_runtime);
    free(ctx->futhark_mc_segred_task_339349_runs);
    free(ctx->futhark_mc_segred_task_339349_iter);
    free(ctx->futhark_mc_segmap_parloop_339347_total_runtime);
    free(ctx->futhark_mc_segmap_parloop_339347_runs);
    free(ctx->futhark_mc_segmap_parloop_339347_iter);
    free(ctx->futhark_mc_segmap_nested_task_339345_total_runtime);
    free(ctx->futhark_mc_segmap_nested_task_339345_runs);
    free(ctx->futhark_mc_segmap_nested_task_339345_iter);
    free_constants(ctx);
    (void) scheduler_destroy(&ctx->scheduler);
    free_lock(&ctx->lock);
    ctx->cfg->in_use = 0;
    free(ctx);
}
int futhark_context_sync(struct futhark_context *ctx)
{
    (void) ctx;
    return 0;
}
static const char *tuning_param_names[0];
static const char *tuning_param_vars[0];
static const char *tuning_param_classes[0];
int futhark_context_config_set_tuning_param(struct futhark_context_config *cfg,
                                            const char *param_name,
                                            size_t param_value)
{
    (void) cfg;
    (void) param_name;
    (void) param_value;
    return 1;
}
static int memblock_unref(struct futhark_context *ctx, struct memblock *block,
                          const char *desc)
{
    if (block->references != NULL) {
        *block->references -= 1;
        if (ctx->detail_memory)
            fprintf(ctx->log,
                    "Unreferencing block %s (allocated as %s) in %s: %d references remaining.\n",
                    desc, block->desc, "default space", *block->references);
        if (*block->references == 0) {
            ctx->cur_mem_usage_default -= block->size;
            free(block->mem);
            free(block->references);
            if (ctx->detail_memory)
                fprintf(ctx->log,
                        "%lld bytes freed (now allocated: %lld bytes)\n",
                        (long long) block->size,
                        (long long) ctx->cur_mem_usage_default);
        }
        block->references = NULL;
    }
    return 0;
}
static int memblock_alloc(struct futhark_context *ctx, struct memblock *block,
                          int64_t size, const char *desc)
{
    if (size < 0)
        futhark_panic(1,
                      "Negative allocation of %lld bytes attempted for %s in %s.\n",
                      (long long) size, desc, "default space",
                      ctx->cur_mem_usage_default);
    
    int ret = memblock_unref(ctx, block, desc);
    
    if (ret != FUTHARK_SUCCESS)
        return ret;
    if (ctx->detail_memory)
        fprintf(ctx->log,
                "Allocating %lld bytes for %s in %s (then allocated: %lld bytes)",
                (long long) size, desc, "default space",
                (long long) ctx->cur_mem_usage_default + size);
    if (ctx->cur_mem_usage_default > ctx->peak_mem_usage_default) {
        ctx->peak_mem_usage_default = ctx->cur_mem_usage_default;
        if (ctx->detail_memory)
            fprintf(ctx->log, " (new peak).\n");
    } else if (ctx->detail_memory)
        fprintf(ctx->log, ".\n");
    block->mem = (unsigned char *) malloc((size_t) size);
    if (ctx->error == NULL) {
        block->references = (int *) malloc(sizeof(int));
        *block->references = 1;
        block->size = size;
        block->desc = desc;
        ctx->cur_mem_usage_default += size;
        return FUTHARK_SUCCESS;
    } else {
        char *old_error = ctx->error;
        
        ctx->error =
            msgprintf("Failed to allocate memory in %s.\nAttempted allocation: %12lld bytes\nCurrently allocated:  %12lld bytes\n%s",
                      "default space", (long long) size,
                      (long long) ctx->cur_mem_usage_default, old_error);
        free(old_error);
        return FUTHARK_OUT_OF_MEMORY;
    }
}
static int memblock_set(struct futhark_context *ctx, struct memblock *lhs,
                        struct memblock *rhs, const char *lhs_desc)
{
    int ret = memblock_unref(ctx, lhs, lhs_desc);
    
    if (rhs->references != NULL)
        (*rhs->references)++;
    *lhs = *rhs;
    return ret;
}
int futhark_get_tuning_param_count(void)
{
    return sizeof(tuning_param_names) / sizeof(tuning_param_names[0]);
}
const char *futhark_get_tuning_param_name(int i)
{
    return tuning_param_names[i];
}
const char *futhark_get_tuning_param_class(int i)
{
    return tuning_param_classes[i];
}
char *futhark_context_report(struct futhark_context *ctx)
{
    if (futhark_context_sync(ctx) != 0)
        return NULL;
    
    struct str_builder builder;
    
    str_builder_init(&builder);
    if (ctx->detail_memory || ctx->profiling || ctx->logging) {
        { }
    }
    if (ctx->profiling) {
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_stage_1_parloop_337688 ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_stage_1_parloop_337688_runs[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_337688_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_337688_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_337688_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_337688_total_runtime[i],
                    (double) ctx->futhark_mc_segred_stage_1_parloop_337688_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_337688_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_337688_iter[i]),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_337688_iter[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_337688_iter[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_337688_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_337688_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segred_stage_1_parloop_337688_total ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segred_stage_1_parloop_337688_total_runs,
                (long) ctx->futhark_mc_segred_stage_1_parloop_337688_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_337688_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_337688_total_runs : 1),
                (long) ctx->futhark_mc_segred_stage_1_parloop_337688_total_total_runtime,
                (double) ctx->futhark_mc_segred_stage_1_parloop_337688_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_337688_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_337688_total_iter),
                (long) ctx->futhark_mc_segred_stage_1_parloop_337688_total_iter,
                (long) ctx->futhark_mc_segred_stage_1_parloop_337688_total_iter /
                (ctx->futhark_mc_segred_stage_1_parloop_337688_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_337688_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segred_stage_1_parloop_337688_total_total_runtime;
        ctx->total_runs +=
            ctx->futhark_mc_segred_stage_1_parloop_337688_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_stage_1_parloop_337697 ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_stage_1_parloop_337697_runs[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_337697_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_337697_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_337697_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_337697_total_runtime[i],
                    (double) ctx->futhark_mc_segred_stage_1_parloop_337697_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_337697_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_337697_iter[i]),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_337697_iter[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_337697_iter[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_337697_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_337697_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segred_stage_1_parloop_337697_total ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segred_stage_1_parloop_337697_total_runs,
                (long) ctx->futhark_mc_segred_stage_1_parloop_337697_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_337697_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_337697_total_runs : 1),
                (long) ctx->futhark_mc_segred_stage_1_parloop_337697_total_total_runtime,
                (double) ctx->futhark_mc_segred_stage_1_parloop_337697_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_337697_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_337697_total_iter),
                (long) ctx->futhark_mc_segred_stage_1_parloop_337697_total_iter,
                (long) ctx->futhark_mc_segred_stage_1_parloop_337697_total_iter /
                (ctx->futhark_mc_segred_stage_1_parloop_337697_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_337697_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segred_stage_1_parloop_337697_total_total_runtime;
        ctx->total_runs +=
            ctx->futhark_mc_segred_stage_1_parloop_337697_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_task_337694            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_task_337694_runs[i],
                    (long) ctx->futhark_mc_segred_task_337694_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_337694_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_337694_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_task_337694_total_runtime[i],
                    (double) ctx->futhark_mc_segred_task_337694_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_337694_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_task_337694_iter[i]),
                    (long) ctx->futhark_mc_segred_task_337694_iter[i],
                    (long) ctx->futhark_mc_segred_task_337694_iter[i] /
                    (ctx->futhark_mc_segred_task_337694_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_337694_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_stage_1_parloop_337692 ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_stage_1_parloop_337692_runs[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_337692_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_337692_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_337692_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_337692_total_runtime[i],
                    (double) ctx->futhark_mc_segred_stage_1_parloop_337692_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_337692_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_337692_iter[i]),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_337692_iter[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_337692_iter[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_337692_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_337692_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segred_stage_1_parloop_337692_total ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segred_stage_1_parloop_337692_total_runs,
                (long) ctx->futhark_mc_segred_stage_1_parloop_337692_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_337692_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_337692_total_runs : 1),
                (long) ctx->futhark_mc_segred_stage_1_parloop_337692_total_total_runtime,
                (double) ctx->futhark_mc_segred_stage_1_parloop_337692_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_337692_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_337692_total_iter),
                (long) ctx->futhark_mc_segred_stage_1_parloop_337692_total_iter,
                (long) ctx->futhark_mc_segred_stage_1_parloop_337692_total_iter /
                (ctx->futhark_mc_segred_stage_1_parloop_337692_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_337692_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segred_stage_1_parloop_337692_total_total_runtime;
        ctx->total_runs +=
            ctx->futhark_mc_segred_stage_1_parloop_337692_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_task_337685            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_task_337685_runs[i],
                    (long) ctx->futhark_mc_segred_task_337685_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_337685_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_337685_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_task_337685_total_runtime[i],
                    (double) ctx->futhark_mc_segred_task_337685_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_337685_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_task_337685_iter[i]),
                    (long) ctx->futhark_mc_segred_task_337685_iter[i],
                    (long) ctx->futhark_mc_segred_task_337685_iter[i] /
                    (ctx->futhark_mc_segred_task_337685_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_337685_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_nested_task_337689     ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_nested_task_337689_runs[i],
                    (long) ctx->futhark_mc_segred_nested_task_337689_total_runtime[i] /
                    (ctx->futhark_mc_segred_nested_task_337689_runs[i] !=
                     0 ? ctx->futhark_mc_segred_nested_task_337689_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_nested_task_337689_total_runtime[i],
                    (double) ctx->futhark_mc_segred_nested_task_337689_total_runtime[i] /
                    (ctx->futhark_mc_segred_nested_task_337689_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_nested_task_337689_iter[i]),
                    (long) ctx->futhark_mc_segred_nested_task_337689_iter[i],
                    (long) ctx->futhark_mc_segred_nested_task_337689_iter[i] /
                    (ctx->futhark_mc_segred_nested_task_337689_runs[i] !=
                     0 ? ctx->futhark_mc_segred_nested_task_337689_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_scan_stage_1_parloop_337683   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_scan_stage_1_parloop_337683_runs[i],
                    (long) ctx->futhark_mc_scan_stage_1_parloop_337683_total_runtime[i] /
                    (ctx->futhark_mc_scan_stage_1_parloop_337683_runs[i] !=
                     0 ? ctx->futhark_mc_scan_stage_1_parloop_337683_runs[i] : 1),
                    (long) ctx->futhark_mc_scan_stage_1_parloop_337683_total_runtime[i],
                    (double) ctx->futhark_mc_scan_stage_1_parloop_337683_total_runtime[i] /
                    (ctx->futhark_mc_scan_stage_1_parloop_337683_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_scan_stage_1_parloop_337683_iter[i]),
                    (long) ctx->futhark_mc_scan_stage_1_parloop_337683_iter[i],
                    (long) ctx->futhark_mc_scan_stage_1_parloop_337683_iter[i] /
                    (ctx->futhark_mc_scan_stage_1_parloop_337683_runs[i] !=
                     0 ? ctx->futhark_mc_scan_stage_1_parloop_337683_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_scan_stage_1_parloop_337683_total ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_scan_stage_1_parloop_337683_total_runs,
                (long) ctx->futhark_mc_scan_stage_1_parloop_337683_total_total_runtime /
                (ctx->futhark_mc_scan_stage_1_parloop_337683_total_runs !=
                 0 ? ctx->futhark_mc_scan_stage_1_parloop_337683_total_runs : 1),
                (long) ctx->futhark_mc_scan_stage_1_parloop_337683_total_total_runtime,
                (double) ctx->futhark_mc_scan_stage_1_parloop_337683_total_total_runtime /
                (ctx->futhark_mc_scan_stage_1_parloop_337683_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_scan_stage_1_parloop_337683_total_iter),
                (long) ctx->futhark_mc_scan_stage_1_parloop_337683_total_iter,
                (long) ctx->futhark_mc_scan_stage_1_parloop_337683_total_iter /
                (ctx->futhark_mc_scan_stage_1_parloop_337683_total_runs !=
                 0 ? ctx->futhark_mc_scan_stage_1_parloop_337683_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_scan_stage_1_parloop_337683_total_total_runtime;
        ctx->total_runs +=
            ctx->futhark_mc_scan_stage_1_parloop_337683_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_stage_1_parloop_337702 ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_stage_1_parloop_337702_runs[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_337702_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_337702_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_337702_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_337702_total_runtime[i],
                    (double) ctx->futhark_mc_segred_stage_1_parloop_337702_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_337702_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_337702_iter[i]),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_337702_iter[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_337702_iter[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_337702_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_337702_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segred_stage_1_parloop_337702_total ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segred_stage_1_parloop_337702_total_runs,
                (long) ctx->futhark_mc_segred_stage_1_parloop_337702_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_337702_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_337702_total_runs : 1),
                (long) ctx->futhark_mc_segred_stage_1_parloop_337702_total_total_runtime,
                (double) ctx->futhark_mc_segred_stage_1_parloop_337702_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_337702_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_337702_total_iter),
                (long) ctx->futhark_mc_segred_stage_1_parloop_337702_total_iter,
                (long) ctx->futhark_mc_segred_stage_1_parloop_337702_total_iter /
                (ctx->futhark_mc_segred_stage_1_parloop_337702_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_337702_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segred_stage_1_parloop_337702_total_total_runtime;
        ctx->total_runs +=
            ctx->futhark_mc_segred_stage_1_parloop_337702_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_stage_1_parloop_337711 ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_stage_1_parloop_337711_runs[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_337711_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_337711_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_337711_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_337711_total_runtime[i],
                    (double) ctx->futhark_mc_segred_stage_1_parloop_337711_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_337711_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_337711_iter[i]),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_337711_iter[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_337711_iter[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_337711_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_337711_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segred_stage_1_parloop_337711_total ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segred_stage_1_parloop_337711_total_runs,
                (long) ctx->futhark_mc_segred_stage_1_parloop_337711_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_337711_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_337711_total_runs : 1),
                (long) ctx->futhark_mc_segred_stage_1_parloop_337711_total_total_runtime,
                (double) ctx->futhark_mc_segred_stage_1_parloop_337711_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_337711_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_337711_total_iter),
                (long) ctx->futhark_mc_segred_stage_1_parloop_337711_total_iter,
                (long) ctx->futhark_mc_segred_stage_1_parloop_337711_total_iter /
                (ctx->futhark_mc_segred_stage_1_parloop_337711_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_337711_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segred_stage_1_parloop_337711_total_total_runtime;
        ctx->total_runs +=
            ctx->futhark_mc_segred_stage_1_parloop_337711_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_task_337708            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_task_337708_runs[i],
                    (long) ctx->futhark_mc_segred_task_337708_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_337708_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_337708_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_task_337708_total_runtime[i],
                    (double) ctx->futhark_mc_segred_task_337708_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_337708_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_task_337708_iter[i]),
                    (long) ctx->futhark_mc_segred_task_337708_iter[i],
                    (long) ctx->futhark_mc_segred_task_337708_iter[i] /
                    (ctx->futhark_mc_segred_task_337708_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_337708_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_stage_1_parloop_337706 ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_stage_1_parloop_337706_runs[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_337706_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_337706_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_337706_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_337706_total_runtime[i],
                    (double) ctx->futhark_mc_segred_stage_1_parloop_337706_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_337706_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_337706_iter[i]),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_337706_iter[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_337706_iter[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_337706_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_337706_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segred_stage_1_parloop_337706_total ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segred_stage_1_parloop_337706_total_runs,
                (long) ctx->futhark_mc_segred_stage_1_parloop_337706_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_337706_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_337706_total_runs : 1),
                (long) ctx->futhark_mc_segred_stage_1_parloop_337706_total_total_runtime,
                (double) ctx->futhark_mc_segred_stage_1_parloop_337706_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_337706_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_337706_total_iter),
                (long) ctx->futhark_mc_segred_stage_1_parloop_337706_total_iter,
                (long) ctx->futhark_mc_segred_stage_1_parloop_337706_total_iter /
                (ctx->futhark_mc_segred_stage_1_parloop_337706_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_337706_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segred_stage_1_parloop_337706_total_total_runtime;
        ctx->total_runs +=
            ctx->futhark_mc_segred_stage_1_parloop_337706_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_task_337699            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_task_337699_runs[i],
                    (long) ctx->futhark_mc_segred_task_337699_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_337699_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_337699_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_task_337699_total_runtime[i],
                    (double) ctx->futhark_mc_segred_task_337699_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_337699_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_task_337699_iter[i]),
                    (long) ctx->futhark_mc_segred_task_337699_iter[i],
                    (long) ctx->futhark_mc_segred_task_337699_iter[i] /
                    (ctx->futhark_mc_segred_task_337699_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_337699_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_nested_task_337703     ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_nested_task_337703_runs[i],
                    (long) ctx->futhark_mc_segred_nested_task_337703_total_runtime[i] /
                    (ctx->futhark_mc_segred_nested_task_337703_runs[i] !=
                     0 ? ctx->futhark_mc_segred_nested_task_337703_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_nested_task_337703_total_runtime[i],
                    (double) ctx->futhark_mc_segred_nested_task_337703_total_runtime[i] /
                    (ctx->futhark_mc_segred_nested_task_337703_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_nested_task_337703_iter[i]),
                    (long) ctx->futhark_mc_segred_nested_task_337703_iter[i],
                    (long) ctx->futhark_mc_segred_nested_task_337703_iter[i] /
                    (ctx->futhark_mc_segred_nested_task_337703_runs[i] !=
                     0 ? ctx->futhark_mc_segred_nested_task_337703_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_stage_1_parloop_337718 ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_stage_1_parloop_337718_runs[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_337718_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_337718_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_337718_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_337718_total_runtime[i],
                    (double) ctx->futhark_mc_segred_stage_1_parloop_337718_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_337718_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_337718_iter[i]),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_337718_iter[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_337718_iter[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_337718_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_337718_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segred_stage_1_parloop_337718_total ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segred_stage_1_parloop_337718_total_runs,
                (long) ctx->futhark_mc_segred_stage_1_parloop_337718_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_337718_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_337718_total_runs : 1),
                (long) ctx->futhark_mc_segred_stage_1_parloop_337718_total_total_runtime,
                (double) ctx->futhark_mc_segred_stage_1_parloop_337718_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_337718_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_337718_total_iter),
                (long) ctx->futhark_mc_segred_stage_1_parloop_337718_total_iter,
                (long) ctx->futhark_mc_segred_stage_1_parloop_337718_total_iter /
                (ctx->futhark_mc_segred_stage_1_parloop_337718_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_337718_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segred_stage_1_parloop_337718_total_total_runtime;
        ctx->total_runs +=
            ctx->futhark_mc_segred_stage_1_parloop_337718_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_stage_1_parloop_337727 ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_stage_1_parloop_337727_runs[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_337727_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_337727_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_337727_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_337727_total_runtime[i],
                    (double) ctx->futhark_mc_segred_stage_1_parloop_337727_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_337727_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_337727_iter[i]),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_337727_iter[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_337727_iter[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_337727_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_337727_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segred_stage_1_parloop_337727_total ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segred_stage_1_parloop_337727_total_runs,
                (long) ctx->futhark_mc_segred_stage_1_parloop_337727_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_337727_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_337727_total_runs : 1),
                (long) ctx->futhark_mc_segred_stage_1_parloop_337727_total_total_runtime,
                (double) ctx->futhark_mc_segred_stage_1_parloop_337727_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_337727_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_337727_total_iter),
                (long) ctx->futhark_mc_segred_stage_1_parloop_337727_total_iter,
                (long) ctx->futhark_mc_segred_stage_1_parloop_337727_total_iter /
                (ctx->futhark_mc_segred_stage_1_parloop_337727_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_337727_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segred_stage_1_parloop_337727_total_total_runtime;
        ctx->total_runs +=
            ctx->futhark_mc_segred_stage_1_parloop_337727_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_task_337724            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_task_337724_runs[i],
                    (long) ctx->futhark_mc_segred_task_337724_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_337724_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_337724_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_task_337724_total_runtime[i],
                    (double) ctx->futhark_mc_segred_task_337724_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_337724_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_task_337724_iter[i]),
                    (long) ctx->futhark_mc_segred_task_337724_iter[i],
                    (long) ctx->futhark_mc_segred_task_337724_iter[i] /
                    (ctx->futhark_mc_segred_task_337724_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_337724_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_stage_1_parloop_337722 ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_stage_1_parloop_337722_runs[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_337722_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_337722_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_337722_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_337722_total_runtime[i],
                    (double) ctx->futhark_mc_segred_stage_1_parloop_337722_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_337722_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_337722_iter[i]),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_337722_iter[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_337722_iter[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_337722_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_337722_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segred_stage_1_parloop_337722_total ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segred_stage_1_parloop_337722_total_runs,
                (long) ctx->futhark_mc_segred_stage_1_parloop_337722_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_337722_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_337722_total_runs : 1),
                (long) ctx->futhark_mc_segred_stage_1_parloop_337722_total_total_runtime,
                (double) ctx->futhark_mc_segred_stage_1_parloop_337722_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_337722_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_337722_total_iter),
                (long) ctx->futhark_mc_segred_stage_1_parloop_337722_total_iter,
                (long) ctx->futhark_mc_segred_stage_1_parloop_337722_total_iter /
                (ctx->futhark_mc_segred_stage_1_parloop_337722_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_337722_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segred_stage_1_parloop_337722_total_total_runtime;
        ctx->total_runs +=
            ctx->futhark_mc_segred_stage_1_parloop_337722_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_task_337715            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_task_337715_runs[i],
                    (long) ctx->futhark_mc_segred_task_337715_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_337715_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_337715_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_task_337715_total_runtime[i],
                    (double) ctx->futhark_mc_segred_task_337715_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_337715_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_task_337715_iter[i]),
                    (long) ctx->futhark_mc_segred_task_337715_iter[i],
                    (long) ctx->futhark_mc_segred_task_337715_iter[i] /
                    (ctx->futhark_mc_segred_task_337715_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_337715_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_nested_task_337719     ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_nested_task_337719_runs[i],
                    (long) ctx->futhark_mc_segred_nested_task_337719_total_runtime[i] /
                    (ctx->futhark_mc_segred_nested_task_337719_runs[i] !=
                     0 ? ctx->futhark_mc_segred_nested_task_337719_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_nested_task_337719_total_runtime[i],
                    (double) ctx->futhark_mc_segred_nested_task_337719_total_runtime[i] /
                    (ctx->futhark_mc_segred_nested_task_337719_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_nested_task_337719_iter[i]),
                    (long) ctx->futhark_mc_segred_nested_task_337719_iter[i],
                    (long) ctx->futhark_mc_segred_nested_task_337719_iter[i] /
                    (ctx->futhark_mc_segred_nested_task_337719_runs[i] !=
                     0 ? ctx->futhark_mc_segred_nested_task_337719_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_scan_stage_3_parloop_337713   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_scan_stage_3_parloop_337713_runs[i],
                    (long) ctx->futhark_mc_scan_stage_3_parloop_337713_total_runtime[i] /
                    (ctx->futhark_mc_scan_stage_3_parloop_337713_runs[i] !=
                     0 ? ctx->futhark_mc_scan_stage_3_parloop_337713_runs[i] : 1),
                    (long) ctx->futhark_mc_scan_stage_3_parloop_337713_total_runtime[i],
                    (double) ctx->futhark_mc_scan_stage_3_parloop_337713_total_runtime[i] /
                    (ctx->futhark_mc_scan_stage_3_parloop_337713_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_scan_stage_3_parloop_337713_iter[i]),
                    (long) ctx->futhark_mc_scan_stage_3_parloop_337713_iter[i],
                    (long) ctx->futhark_mc_scan_stage_3_parloop_337713_iter[i] /
                    (ctx->futhark_mc_scan_stage_3_parloop_337713_runs[i] !=
                     0 ? ctx->futhark_mc_scan_stage_3_parloop_337713_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_scan_stage_3_parloop_337713_total ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_scan_stage_3_parloop_337713_total_runs,
                (long) ctx->futhark_mc_scan_stage_3_parloop_337713_total_total_runtime /
                (ctx->futhark_mc_scan_stage_3_parloop_337713_total_runs !=
                 0 ? ctx->futhark_mc_scan_stage_3_parloop_337713_total_runs : 1),
                (long) ctx->futhark_mc_scan_stage_3_parloop_337713_total_total_runtime,
                (double) ctx->futhark_mc_scan_stage_3_parloop_337713_total_total_runtime /
                (ctx->futhark_mc_scan_stage_3_parloop_337713_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_scan_stage_3_parloop_337713_total_iter),
                (long) ctx->futhark_mc_scan_stage_3_parloop_337713_total_iter,
                (long) ctx->futhark_mc_scan_stage_3_parloop_337713_total_iter /
                (ctx->futhark_mc_scan_stage_3_parloop_337713_total_runs !=
                 0 ? ctx->futhark_mc_scan_stage_3_parloop_337713_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_scan_stage_3_parloop_337713_total_total_runtime;
        ctx->total_runs +=
            ctx->futhark_mc_scan_stage_3_parloop_337713_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segscan_task_337680           ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segscan_task_337680_runs[i],
                    (long) ctx->futhark_mc_segscan_task_337680_total_runtime[i] /
                    (ctx->futhark_mc_segscan_task_337680_runs[i] !=
                     0 ? ctx->futhark_mc_segscan_task_337680_runs[i] : 1),
                    (long) ctx->futhark_mc_segscan_task_337680_total_runtime[i],
                    (double) ctx->futhark_mc_segscan_task_337680_total_runtime[i] /
                    (ctx->futhark_mc_segscan_task_337680_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segscan_task_337680_iter[i]),
                    (long) ctx->futhark_mc_segscan_task_337680_iter[i],
                    (long) ctx->futhark_mc_segscan_task_337680_iter[i] /
                    (ctx->futhark_mc_segscan_task_337680_runs[i] !=
                     0 ? ctx->futhark_mc_segscan_task_337680_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_337731         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_337731_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_337731_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_337731_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_337731_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_337731_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_337731_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_337731_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_337731_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_337731_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_337731_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_337731_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_337731_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_337731_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_337731_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_337731_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_337731_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_337731_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_337731_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_337731_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_337731_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_337731_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_337731_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_337731_total_iter /
                (ctx->futhark_mc_segmap_parloop_337731_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_337731_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_337731_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_337731_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_337729            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_337729_runs[i],
                    (long) ctx->futhark_mc_segmap_task_337729_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_337729_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_337729_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_337729_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_337729_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_337729_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_337729_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_337729_iter[i],
                    (long) ctx->futhark_mc_segmap_task_337729_iter[i] /
                    (ctx->futhark_mc_segmap_task_337729_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_337729_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_337735         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_337735_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_337735_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_337735_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_337735_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_337735_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_337735_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_337735_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_337735_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_337735_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_337735_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_337735_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_337735_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_337735_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_337735_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_337735_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_337735_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_337735_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_337735_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_337735_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_337735_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_337735_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_337735_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_337735_total_iter /
                (ctx->futhark_mc_segmap_parloop_337735_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_337735_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_337735_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_337735_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_scan_stage_1_parloop_337747   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_scan_stage_1_parloop_337747_runs[i],
                    (long) ctx->futhark_mc_scan_stage_1_parloop_337747_total_runtime[i] /
                    (ctx->futhark_mc_scan_stage_1_parloop_337747_runs[i] !=
                     0 ? ctx->futhark_mc_scan_stage_1_parloop_337747_runs[i] : 1),
                    (long) ctx->futhark_mc_scan_stage_1_parloop_337747_total_runtime[i],
                    (double) ctx->futhark_mc_scan_stage_1_parloop_337747_total_runtime[i] /
                    (ctx->futhark_mc_scan_stage_1_parloop_337747_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_scan_stage_1_parloop_337747_iter[i]),
                    (long) ctx->futhark_mc_scan_stage_1_parloop_337747_iter[i],
                    (long) ctx->futhark_mc_scan_stage_1_parloop_337747_iter[i] /
                    (ctx->futhark_mc_scan_stage_1_parloop_337747_runs[i] !=
                     0 ? ctx->futhark_mc_scan_stage_1_parloop_337747_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_scan_stage_1_parloop_337747_total ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_scan_stage_1_parloop_337747_total_runs,
                (long) ctx->futhark_mc_scan_stage_1_parloop_337747_total_total_runtime /
                (ctx->futhark_mc_scan_stage_1_parloop_337747_total_runs !=
                 0 ? ctx->futhark_mc_scan_stage_1_parloop_337747_total_runs : 1),
                (long) ctx->futhark_mc_scan_stage_1_parloop_337747_total_total_runtime,
                (double) ctx->futhark_mc_scan_stage_1_parloop_337747_total_total_runtime /
                (ctx->futhark_mc_scan_stage_1_parloop_337747_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_scan_stage_1_parloop_337747_total_iter),
                (long) ctx->futhark_mc_scan_stage_1_parloop_337747_total_iter,
                (long) ctx->futhark_mc_scan_stage_1_parloop_337747_total_iter /
                (ctx->futhark_mc_scan_stage_1_parloop_337747_total_runs !=
                 0 ? ctx->futhark_mc_scan_stage_1_parloop_337747_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_scan_stage_1_parloop_337747_total_total_runtime;
        ctx->total_runs +=
            ctx->futhark_mc_scan_stage_1_parloop_337747_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_scan_stage_3_parloop_337749   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_scan_stage_3_parloop_337749_runs[i],
                    (long) ctx->futhark_mc_scan_stage_3_parloop_337749_total_runtime[i] /
                    (ctx->futhark_mc_scan_stage_3_parloop_337749_runs[i] !=
                     0 ? ctx->futhark_mc_scan_stage_3_parloop_337749_runs[i] : 1),
                    (long) ctx->futhark_mc_scan_stage_3_parloop_337749_total_runtime[i],
                    (double) ctx->futhark_mc_scan_stage_3_parloop_337749_total_runtime[i] /
                    (ctx->futhark_mc_scan_stage_3_parloop_337749_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_scan_stage_3_parloop_337749_iter[i]),
                    (long) ctx->futhark_mc_scan_stage_3_parloop_337749_iter[i],
                    (long) ctx->futhark_mc_scan_stage_3_parloop_337749_iter[i] /
                    (ctx->futhark_mc_scan_stage_3_parloop_337749_runs[i] !=
                     0 ? ctx->futhark_mc_scan_stage_3_parloop_337749_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_scan_stage_3_parloop_337749_total ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_scan_stage_3_parloop_337749_total_runs,
                (long) ctx->futhark_mc_scan_stage_3_parloop_337749_total_total_runtime /
                (ctx->futhark_mc_scan_stage_3_parloop_337749_total_runs !=
                 0 ? ctx->futhark_mc_scan_stage_3_parloop_337749_total_runs : 1),
                (long) ctx->futhark_mc_scan_stage_3_parloop_337749_total_total_runtime,
                (double) ctx->futhark_mc_scan_stage_3_parloop_337749_total_total_runtime /
                (ctx->futhark_mc_scan_stage_3_parloop_337749_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_scan_stage_3_parloop_337749_total_iter),
                (long) ctx->futhark_mc_scan_stage_3_parloop_337749_total_iter,
                (long) ctx->futhark_mc_scan_stage_3_parloop_337749_total_iter /
                (ctx->futhark_mc_scan_stage_3_parloop_337749_total_runs !=
                 0 ? ctx->futhark_mc_scan_stage_3_parloop_337749_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_scan_stage_3_parloop_337749_total_total_runtime;
        ctx->total_runs +=
            ctx->futhark_mc_scan_stage_3_parloop_337749_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segscan_task_337744           ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segscan_task_337744_runs[i],
                    (long) ctx->futhark_mc_segscan_task_337744_total_runtime[i] /
                    (ctx->futhark_mc_segscan_task_337744_runs[i] !=
                     0 ? ctx->futhark_mc_segscan_task_337744_runs[i] : 1),
                    (long) ctx->futhark_mc_segscan_task_337744_total_runtime[i],
                    (double) ctx->futhark_mc_segscan_task_337744_total_runtime[i] /
                    (ctx->futhark_mc_segscan_task_337744_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segscan_task_337744_iter[i]),
                    (long) ctx->futhark_mc_segscan_task_337744_iter[i],
                    (long) ctx->futhark_mc_segscan_task_337744_iter[i] /
                    (ctx->futhark_mc_segscan_task_337744_runs[i] !=
                     0 ? ctx->futhark_mc_segscan_task_337744_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_337753         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_337753_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_337753_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_337753_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_337753_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_337753_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_337753_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_337753_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_337753_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_337753_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_337753_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_337753_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_337753_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_337753_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_337753_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_337753_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_337753_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_337753_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_337753_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_337753_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_337753_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_337753_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_337753_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_337753_total_iter /
                (ctx->futhark_mc_segmap_parloop_337753_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_337753_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_337753_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_337753_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_337751            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_337751_runs[i],
                    (long) ctx->futhark_mc_segmap_task_337751_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_337751_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_337751_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_337751_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_337751_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_337751_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_337751_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_337751_iter[i],
                    (long) ctx->futhark_mc_segmap_task_337751_iter[i] /
                    (ctx->futhark_mc_segmap_task_337751_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_337751_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_337740         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_337740_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_337740_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_337740_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_337740_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_337740_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_337740_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_337740_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_337740_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_337740_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_337740_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_337740_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_337740_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_337740_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_337740_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_337740_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_337740_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_337740_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_337740_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_337740_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_337740_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_337740_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_337740_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_337740_total_iter /
                (ctx->futhark_mc_segmap_parloop_337740_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_337740_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_337740_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_337740_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_337733            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_337733_runs[i],
                    (long) ctx->futhark_mc_segmap_task_337733_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_337733_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_337733_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_337733_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_337733_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_337733_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_337733_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_337733_iter[i],
                    (long) ctx->futhark_mc_segmap_task_337733_iter[i] /
                    (ctx->futhark_mc_segmap_task_337733_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_337733_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_nested_task_337738     ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_nested_task_337738_runs[i],
                    (long) ctx->futhark_mc_segmap_nested_task_337738_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_337738_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_337738_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_nested_task_337738_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_nested_task_337738_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_337738_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_nested_task_337738_iter[i]),
                    (long) ctx->futhark_mc_segmap_nested_task_337738_iter[i],
                    (long) ctx->futhark_mc_segmap_nested_task_337738_iter[i] /
                    (ctx->futhark_mc_segmap_nested_task_337738_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_337738_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_337757         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_337757_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_337757_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_337757_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_337757_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_337757_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_337757_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_337757_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_337757_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_337757_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_337757_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_337757_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_337757_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_337757_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_337757_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_337757_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_337757_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_337757_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_337757_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_337757_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_337757_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_337757_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_337757_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_337757_total_iter /
                (ctx->futhark_mc_segmap_parloop_337757_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_337757_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_337757_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_337757_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_337766         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_337766_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_337766_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_337766_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_337766_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_337766_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_337766_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_337766_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_337766_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_337766_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_337766_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_337766_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_337766_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_337766_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_337766_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_337766_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_337766_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_337766_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_337766_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_337766_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_337766_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_337766_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_337766_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_337766_total_iter /
                (ctx->futhark_mc_segmap_parloop_337766_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_337766_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_337766_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_337766_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_337775         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_337775_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_337775_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_337775_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_337775_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_337775_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_337775_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_337775_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_337775_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_337775_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_337775_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_337775_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_337775_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_337775_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_337775_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_337775_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_337775_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_337775_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_337775_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_337775_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_337775_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_337775_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_337775_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_337775_total_iter /
                (ctx->futhark_mc_segmap_parloop_337775_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_337775_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_337775_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_337775_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_337773            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_337773_runs[i],
                    (long) ctx->futhark_mc_segmap_task_337773_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_337773_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_337773_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_337773_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_337773_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_337773_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_337773_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_337773_iter[i],
                    (long) ctx->futhark_mc_segmap_task_337773_iter[i] /
                    (ctx->futhark_mc_segmap_task_337773_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_337773_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_337770         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_337770_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_337770_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_337770_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_337770_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_337770_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_337770_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_337770_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_337770_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_337770_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_337770_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_337770_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_337770_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_337770_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_337770_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_337770_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_337770_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_337770_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_337770_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_337770_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_337770_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_337770_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_337770_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_337770_total_iter /
                (ctx->futhark_mc_segmap_parloop_337770_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_337770_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_337770_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_337770_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_337764            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_337764_runs[i],
                    (long) ctx->futhark_mc_segmap_task_337764_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_337764_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_337764_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_337764_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_337764_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_337764_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_337764_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_337764_iter[i],
                    (long) ctx->futhark_mc_segmap_task_337764_iter[i] /
                    (ctx->futhark_mc_segmap_task_337764_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_337764_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_nested_task_337768     ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_nested_task_337768_runs[i],
                    (long) ctx->futhark_mc_segmap_nested_task_337768_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_337768_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_337768_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_nested_task_337768_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_nested_task_337768_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_337768_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_nested_task_337768_iter[i]),
                    (long) ctx->futhark_mc_segmap_nested_task_337768_iter[i],
                    (long) ctx->futhark_mc_segmap_nested_task_337768_iter[i] /
                    (ctx->futhark_mc_segmap_nested_task_337768_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_337768_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_337761         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_337761_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_337761_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_337761_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_337761_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_337761_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_337761_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_337761_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_337761_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_337761_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_337761_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_337761_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_337761_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_337761_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_337761_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_337761_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_337761_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_337761_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_337761_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_337761_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_337761_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_337761_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_337761_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_337761_total_iter /
                (ctx->futhark_mc_segmap_parloop_337761_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_337761_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_337761_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_337761_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_337755            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_337755_runs[i],
                    (long) ctx->futhark_mc_segmap_task_337755_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_337755_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_337755_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_337755_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_337755_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_337755_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_337755_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_337755_iter[i],
                    (long) ctx->futhark_mc_segmap_task_337755_iter[i] /
                    (ctx->futhark_mc_segmap_task_337755_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_337755_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_nested_task_337759     ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_nested_task_337759_runs[i],
                    (long) ctx->futhark_mc_segmap_nested_task_337759_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_337759_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_337759_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_nested_task_337759_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_nested_task_337759_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_337759_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_nested_task_337759_iter[i]),
                    (long) ctx->futhark_mc_segmap_nested_task_337759_iter[i],
                    (long) ctx->futhark_mc_segmap_nested_task_337759_iter[i] /
                    (ctx->futhark_mc_segmap_nested_task_337759_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_337759_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_337779         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_337779_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_337779_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_337779_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_337779_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_337779_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_337779_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_337779_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_337779_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_337779_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_337779_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_337779_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_337779_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_337779_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_337779_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_337779_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_337779_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_337779_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_337779_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_337779_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_337779_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_337779_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_337779_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_337779_total_iter /
                (ctx->futhark_mc_segmap_parloop_337779_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_337779_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_337779_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_337779_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_337792         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_337792_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_337792_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_337792_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_337792_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_337792_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_337792_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_337792_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_337792_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_337792_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_337792_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_337792_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_337792_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_337792_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_337792_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_337792_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_337792_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_337792_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_337792_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_337792_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_337792_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_337792_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_337792_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_337792_total_iter /
                (ctx->futhark_mc_segmap_parloop_337792_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_337792_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_337792_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_337792_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_scan_stage_1_parloop_337804   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_scan_stage_1_parloop_337804_runs[i],
                    (long) ctx->futhark_mc_scan_stage_1_parloop_337804_total_runtime[i] /
                    (ctx->futhark_mc_scan_stage_1_parloop_337804_runs[i] !=
                     0 ? ctx->futhark_mc_scan_stage_1_parloop_337804_runs[i] : 1),
                    (long) ctx->futhark_mc_scan_stage_1_parloop_337804_total_runtime[i],
                    (double) ctx->futhark_mc_scan_stage_1_parloop_337804_total_runtime[i] /
                    (ctx->futhark_mc_scan_stage_1_parloop_337804_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_scan_stage_1_parloop_337804_iter[i]),
                    (long) ctx->futhark_mc_scan_stage_1_parloop_337804_iter[i],
                    (long) ctx->futhark_mc_scan_stage_1_parloop_337804_iter[i] /
                    (ctx->futhark_mc_scan_stage_1_parloop_337804_runs[i] !=
                     0 ? ctx->futhark_mc_scan_stage_1_parloop_337804_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_scan_stage_1_parloop_337804_total ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_scan_stage_1_parloop_337804_total_runs,
                (long) ctx->futhark_mc_scan_stage_1_parloop_337804_total_total_runtime /
                (ctx->futhark_mc_scan_stage_1_parloop_337804_total_runs !=
                 0 ? ctx->futhark_mc_scan_stage_1_parloop_337804_total_runs : 1),
                (long) ctx->futhark_mc_scan_stage_1_parloop_337804_total_total_runtime,
                (double) ctx->futhark_mc_scan_stage_1_parloop_337804_total_total_runtime /
                (ctx->futhark_mc_scan_stage_1_parloop_337804_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_scan_stage_1_parloop_337804_total_iter),
                (long) ctx->futhark_mc_scan_stage_1_parloop_337804_total_iter,
                (long) ctx->futhark_mc_scan_stage_1_parloop_337804_total_iter /
                (ctx->futhark_mc_scan_stage_1_parloop_337804_total_runs !=
                 0 ? ctx->futhark_mc_scan_stage_1_parloop_337804_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_scan_stage_1_parloop_337804_total_total_runtime;
        ctx->total_runs +=
            ctx->futhark_mc_scan_stage_1_parloop_337804_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_scan_stage_3_parloop_337806   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_scan_stage_3_parloop_337806_runs[i],
                    (long) ctx->futhark_mc_scan_stage_3_parloop_337806_total_runtime[i] /
                    (ctx->futhark_mc_scan_stage_3_parloop_337806_runs[i] !=
                     0 ? ctx->futhark_mc_scan_stage_3_parloop_337806_runs[i] : 1),
                    (long) ctx->futhark_mc_scan_stage_3_parloop_337806_total_runtime[i],
                    (double) ctx->futhark_mc_scan_stage_3_parloop_337806_total_runtime[i] /
                    (ctx->futhark_mc_scan_stage_3_parloop_337806_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_scan_stage_3_parloop_337806_iter[i]),
                    (long) ctx->futhark_mc_scan_stage_3_parloop_337806_iter[i],
                    (long) ctx->futhark_mc_scan_stage_3_parloop_337806_iter[i] /
                    (ctx->futhark_mc_scan_stage_3_parloop_337806_runs[i] !=
                     0 ? ctx->futhark_mc_scan_stage_3_parloop_337806_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_scan_stage_3_parloop_337806_total ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_scan_stage_3_parloop_337806_total_runs,
                (long) ctx->futhark_mc_scan_stage_3_parloop_337806_total_total_runtime /
                (ctx->futhark_mc_scan_stage_3_parloop_337806_total_runs !=
                 0 ? ctx->futhark_mc_scan_stage_3_parloop_337806_total_runs : 1),
                (long) ctx->futhark_mc_scan_stage_3_parloop_337806_total_total_runtime,
                (double) ctx->futhark_mc_scan_stage_3_parloop_337806_total_total_runtime /
                (ctx->futhark_mc_scan_stage_3_parloop_337806_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_scan_stage_3_parloop_337806_total_iter),
                (long) ctx->futhark_mc_scan_stage_3_parloop_337806_total_iter,
                (long) ctx->futhark_mc_scan_stage_3_parloop_337806_total_iter /
                (ctx->futhark_mc_scan_stage_3_parloop_337806_total_runs !=
                 0 ? ctx->futhark_mc_scan_stage_3_parloop_337806_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_scan_stage_3_parloop_337806_total_total_runtime;
        ctx->total_runs +=
            ctx->futhark_mc_scan_stage_3_parloop_337806_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segscan_task_337801           ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segscan_task_337801_runs[i],
                    (long) ctx->futhark_mc_segscan_task_337801_total_runtime[i] /
                    (ctx->futhark_mc_segscan_task_337801_runs[i] !=
                     0 ? ctx->futhark_mc_segscan_task_337801_runs[i] : 1),
                    (long) ctx->futhark_mc_segscan_task_337801_total_runtime[i],
                    (double) ctx->futhark_mc_segscan_task_337801_total_runtime[i] /
                    (ctx->futhark_mc_segscan_task_337801_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segscan_task_337801_iter[i]),
                    (long) ctx->futhark_mc_segscan_task_337801_iter[i],
                    (long) ctx->futhark_mc_segscan_task_337801_iter[i] /
                    (ctx->futhark_mc_segscan_task_337801_runs[i] !=
                     0 ? ctx->futhark_mc_segscan_task_337801_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_337810         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_337810_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_337810_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_337810_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_337810_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_337810_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_337810_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_337810_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_337810_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_337810_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_337810_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_337810_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_337810_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_337810_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_337810_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_337810_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_337810_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_337810_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_337810_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_337810_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_337810_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_337810_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_337810_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_337810_total_iter /
                (ctx->futhark_mc_segmap_parloop_337810_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_337810_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_337810_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_337810_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_337808            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_337808_runs[i],
                    (long) ctx->futhark_mc_segmap_task_337808_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_337808_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_337808_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_337808_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_337808_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_337808_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_337808_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_337808_iter[i],
                    (long) ctx->futhark_mc_segmap_task_337808_iter[i] /
                    (ctx->futhark_mc_segmap_task_337808_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_337808_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_337797         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_337797_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_337797_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_337797_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_337797_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_337797_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_337797_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_337797_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_337797_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_337797_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_337797_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_337797_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_337797_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_337797_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_337797_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_337797_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_337797_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_337797_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_337797_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_337797_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_337797_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_337797_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_337797_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_337797_total_iter /
                (ctx->futhark_mc_segmap_parloop_337797_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_337797_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_337797_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_337797_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_337790            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_337790_runs[i],
                    (long) ctx->futhark_mc_segmap_task_337790_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_337790_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_337790_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_337790_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_337790_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_337790_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_337790_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_337790_iter[i],
                    (long) ctx->futhark_mc_segmap_task_337790_iter[i] /
                    (ctx->futhark_mc_segmap_task_337790_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_337790_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_nested_task_337795     ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_nested_task_337795_runs[i],
                    (long) ctx->futhark_mc_segmap_nested_task_337795_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_337795_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_337795_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_nested_task_337795_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_nested_task_337795_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_337795_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_nested_task_337795_iter[i]),
                    (long) ctx->futhark_mc_segmap_nested_task_337795_iter[i],
                    (long) ctx->futhark_mc_segmap_nested_task_337795_iter[i] /
                    (ctx->futhark_mc_segmap_nested_task_337795_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_337795_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_337786         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_337786_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_337786_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_337786_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_337786_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_337786_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_337786_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_337786_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_337786_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_337786_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_337786_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_337786_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_337786_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_337786_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_337786_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_337786_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_337786_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_337786_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_337786_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_337786_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_337786_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_337786_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_337786_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_337786_total_iter /
                (ctx->futhark_mc_segmap_parloop_337786_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_337786_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_337786_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_337786_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_337777            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_337777_runs[i],
                    (long) ctx->futhark_mc_segmap_task_337777_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_337777_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_337777_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_337777_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_337777_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_337777_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_337777_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_337777_iter[i],
                    (long) ctx->futhark_mc_segmap_task_337777_iter[i] /
                    (ctx->futhark_mc_segmap_task_337777_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_337777_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_nested_task_337784     ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_nested_task_337784_runs[i],
                    (long) ctx->futhark_mc_segmap_nested_task_337784_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_337784_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_337784_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_nested_task_337784_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_nested_task_337784_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_337784_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_nested_task_337784_iter[i]),
                    (long) ctx->futhark_mc_segmap_nested_task_337784_iter[i],
                    (long) ctx->futhark_mc_segmap_nested_task_337784_iter[i] /
                    (ctx->futhark_mc_segmap_nested_task_337784_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_337784_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_337814         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_337814_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_337814_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_337814_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_337814_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_337814_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_337814_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_337814_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_337814_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_337814_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_337814_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_337814_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_337814_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_337814_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_337814_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_337814_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_337814_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_337814_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_337814_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_337814_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_337814_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_337814_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_337814_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_337814_total_iter /
                (ctx->futhark_mc_segmap_parloop_337814_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_337814_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_337814_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_337814_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_337826         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_337826_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_337826_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_337826_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_337826_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_337826_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_337826_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_337826_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_337826_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_337826_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_337826_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_337826_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_337826_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_337826_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_337826_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_337826_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_337826_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_337826_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_337826_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_337826_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_337826_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_337826_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_337826_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_337826_total_iter /
                (ctx->futhark_mc_segmap_parloop_337826_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_337826_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_337826_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_337826_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_337839         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_337839_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_337839_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_337839_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_337839_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_337839_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_337839_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_337839_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_337839_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_337839_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_337839_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_337839_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_337839_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_337839_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_337839_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_337839_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_337839_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_337839_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_337839_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_337839_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_337839_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_337839_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_337839_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_337839_total_iter /
                (ctx->futhark_mc_segmap_parloop_337839_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_337839_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_337839_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_337839_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_337837            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_337837_runs[i],
                    (long) ctx->futhark_mc_segmap_task_337837_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_337837_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_337837_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_337837_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_337837_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_337837_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_337837_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_337837_iter[i],
                    (long) ctx->futhark_mc_segmap_task_337837_iter[i] /
                    (ctx->futhark_mc_segmap_task_337837_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_337837_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_337843         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_337843_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_337843_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_337843_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_337843_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_337843_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_337843_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_337843_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_337843_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_337843_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_337843_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_337843_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_337843_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_337843_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_337843_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_337843_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_337843_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_337843_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_337843_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_337843_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_337843_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_337843_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_337843_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_337843_total_iter /
                (ctx->futhark_mc_segmap_parloop_337843_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_337843_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_337843_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_337843_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_337841            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_337841_runs[i],
                    (long) ctx->futhark_mc_segmap_task_337841_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_337841_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_337841_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_337841_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_337841_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_337841_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_337841_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_337841_iter[i],
                    (long) ctx->futhark_mc_segmap_task_337841_iter[i] /
                    (ctx->futhark_mc_segmap_task_337841_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_337841_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_337832         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_337832_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_337832_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_337832_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_337832_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_337832_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_337832_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_337832_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_337832_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_337832_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_337832_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_337832_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_337832_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_337832_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_337832_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_337832_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_337832_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_337832_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_337832_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_337832_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_337832_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_337832_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_337832_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_337832_total_iter /
                (ctx->futhark_mc_segmap_parloop_337832_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_337832_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_337832_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_337832_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_337824            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_337824_runs[i],
                    (long) ctx->futhark_mc_segmap_task_337824_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_337824_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_337824_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_337824_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_337824_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_337824_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_337824_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_337824_iter[i],
                    (long) ctx->futhark_mc_segmap_task_337824_iter[i] /
                    (ctx->futhark_mc_segmap_task_337824_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_337824_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_nested_task_337830     ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_nested_task_337830_runs[i],
                    (long) ctx->futhark_mc_segmap_nested_task_337830_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_337830_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_337830_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_nested_task_337830_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_nested_task_337830_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_337830_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_nested_task_337830_iter[i]),
                    (long) ctx->futhark_mc_segmap_nested_task_337830_iter[i],
                    (long) ctx->futhark_mc_segmap_nested_task_337830_iter[i] /
                    (ctx->futhark_mc_segmap_nested_task_337830_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_337830_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_337820         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_337820_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_337820_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_337820_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_337820_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_337820_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_337820_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_337820_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_337820_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_337820_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_337820_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_337820_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_337820_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_337820_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_337820_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_337820_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_337820_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_337820_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_337820_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_337820_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_337820_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_337820_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_337820_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_337820_total_iter /
                (ctx->futhark_mc_segmap_parloop_337820_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_337820_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_337820_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_337820_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_337812            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_337812_runs[i],
                    (long) ctx->futhark_mc_segmap_task_337812_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_337812_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_337812_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_337812_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_337812_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_337812_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_337812_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_337812_iter[i],
                    (long) ctx->futhark_mc_segmap_task_337812_iter[i] /
                    (ctx->futhark_mc_segmap_task_337812_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_337812_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_nested_task_337818     ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_nested_task_337818_runs[i],
                    (long) ctx->futhark_mc_segmap_nested_task_337818_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_337818_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_337818_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_nested_task_337818_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_nested_task_337818_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_337818_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_nested_task_337818_iter[i]),
                    (long) ctx->futhark_mc_segmap_nested_task_337818_iter[i],
                    (long) ctx->futhark_mc_segmap_nested_task_337818_iter[i] /
                    (ctx->futhark_mc_segmap_nested_task_337818_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_337818_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_337847         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_337847_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_337847_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_337847_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_337847_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_337847_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_337847_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_337847_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_337847_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_337847_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_337847_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_337847_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_337847_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_337847_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_337847_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_337847_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_337847_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_337847_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_337847_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_337847_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_337847_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_337847_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_337847_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_337847_total_iter /
                (ctx->futhark_mc_segmap_parloop_337847_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_337847_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_337847_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_337847_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_337860         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_337860_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_337860_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_337860_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_337860_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_337860_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_337860_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_337860_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_337860_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_337860_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_337860_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_337860_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_337860_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_337860_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_337860_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_337860_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_337860_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_337860_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_337860_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_337860_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_337860_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_337860_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_337860_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_337860_total_iter /
                (ctx->futhark_mc_segmap_parloop_337860_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_337860_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_337860_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_337860_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_337858            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_337858_runs[i],
                    (long) ctx->futhark_mc_segmap_task_337858_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_337858_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_337858_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_337858_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_337858_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_337858_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_337858_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_337858_iter[i],
                    (long) ctx->futhark_mc_segmap_task_337858_iter[i] /
                    (ctx->futhark_mc_segmap_task_337858_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_337858_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_337864         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_337864_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_337864_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_337864_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_337864_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_337864_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_337864_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_337864_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_337864_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_337864_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_337864_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_337864_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_337864_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_337864_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_337864_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_337864_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_337864_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_337864_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_337864_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_337864_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_337864_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_337864_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_337864_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_337864_total_iter /
                (ctx->futhark_mc_segmap_parloop_337864_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_337864_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_337864_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_337864_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_337862            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_337862_runs[i],
                    (long) ctx->futhark_mc_segmap_task_337862_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_337862_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_337862_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_337862_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_337862_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_337862_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_337862_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_337862_iter[i],
                    (long) ctx->futhark_mc_segmap_task_337862_iter[i] /
                    (ctx->futhark_mc_segmap_task_337862_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_337862_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_337853         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_337853_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_337853_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_337853_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_337853_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_337853_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_337853_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_337853_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_337853_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_337853_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_337853_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_337853_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_337853_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_337853_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_337853_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_337853_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_337853_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_337853_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_337853_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_337853_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_337853_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_337853_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_337853_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_337853_total_iter /
                (ctx->futhark_mc_segmap_parloop_337853_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_337853_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_337853_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_337853_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_337845            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_337845_runs[i],
                    (long) ctx->futhark_mc_segmap_task_337845_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_337845_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_337845_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_337845_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_337845_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_337845_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_337845_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_337845_iter[i],
                    (long) ctx->futhark_mc_segmap_task_337845_iter[i] /
                    (ctx->futhark_mc_segmap_task_337845_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_337845_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_nested_task_337851     ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_nested_task_337851_runs[i],
                    (long) ctx->futhark_mc_segmap_nested_task_337851_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_337851_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_337851_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_nested_task_337851_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_nested_task_337851_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_337851_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_nested_task_337851_iter[i]),
                    (long) ctx->futhark_mc_segmap_nested_task_337851_iter[i],
                    (long) ctx->futhark_mc_segmap_nested_task_337851_iter[i] /
                    (ctx->futhark_mc_segmap_nested_task_337851_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_337851_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_337868         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_337868_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_337868_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_337868_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_337868_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_337868_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_337868_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_337868_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_337868_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_337868_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_337868_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_337868_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_337868_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_337868_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_337868_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_337868_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_337868_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_337868_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_337868_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_337868_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_337868_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_337868_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_337868_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_337868_total_iter /
                (ctx->futhark_mc_segmap_parloop_337868_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_337868_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_337868_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_337868_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_337881         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_337881_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_337881_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_337881_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_337881_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_337881_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_337881_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_337881_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_337881_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_337881_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_337881_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_337881_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_337881_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_337881_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_337881_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_337881_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_337881_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_337881_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_337881_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_337881_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_337881_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_337881_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_337881_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_337881_total_iter /
                (ctx->futhark_mc_segmap_parloop_337881_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_337881_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_337881_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_337881_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_337879            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_337879_runs[i],
                    (long) ctx->futhark_mc_segmap_task_337879_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_337879_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_337879_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_337879_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_337879_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_337879_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_337879_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_337879_iter[i],
                    (long) ctx->futhark_mc_segmap_task_337879_iter[i] /
                    (ctx->futhark_mc_segmap_task_337879_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_337879_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_337885         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_337885_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_337885_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_337885_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_337885_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_337885_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_337885_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_337885_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_337885_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_337885_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_337885_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_337885_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_337885_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_337885_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_337885_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_337885_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_337885_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_337885_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_337885_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_337885_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_337885_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_337885_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_337885_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_337885_total_iter /
                (ctx->futhark_mc_segmap_parloop_337885_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_337885_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_337885_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_337885_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_337883            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_337883_runs[i],
                    (long) ctx->futhark_mc_segmap_task_337883_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_337883_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_337883_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_337883_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_337883_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_337883_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_337883_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_337883_iter[i],
                    (long) ctx->futhark_mc_segmap_task_337883_iter[i] /
                    (ctx->futhark_mc_segmap_task_337883_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_337883_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_337874         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_337874_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_337874_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_337874_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_337874_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_337874_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_337874_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_337874_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_337874_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_337874_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_337874_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_337874_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_337874_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_337874_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_337874_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_337874_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_337874_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_337874_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_337874_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_337874_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_337874_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_337874_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_337874_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_337874_total_iter /
                (ctx->futhark_mc_segmap_parloop_337874_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_337874_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_337874_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_337874_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_337866            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_337866_runs[i],
                    (long) ctx->futhark_mc_segmap_task_337866_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_337866_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_337866_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_337866_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_337866_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_337866_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_337866_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_337866_iter[i],
                    (long) ctx->futhark_mc_segmap_task_337866_iter[i] /
                    (ctx->futhark_mc_segmap_task_337866_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_337866_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_nested_task_337872     ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_nested_task_337872_runs[i],
                    (long) ctx->futhark_mc_segmap_nested_task_337872_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_337872_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_337872_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_nested_task_337872_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_nested_task_337872_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_337872_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_nested_task_337872_iter[i]),
                    (long) ctx->futhark_mc_segmap_nested_task_337872_iter[i],
                    (long) ctx->futhark_mc_segmap_nested_task_337872_iter[i] /
                    (ctx->futhark_mc_segmap_nested_task_337872_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_337872_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_337889         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_337889_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_337889_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_337889_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_337889_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_337889_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_337889_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_337889_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_337889_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_337889_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_337889_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_337889_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_337889_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_337889_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_337889_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_337889_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_337889_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_337889_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_337889_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_337889_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_337889_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_337889_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_337889_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_337889_total_iter /
                (ctx->futhark_mc_segmap_parloop_337889_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_337889_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_337889_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_337889_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_337898         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_337898_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_337898_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_337898_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_337898_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_337898_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_337898_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_337898_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_337898_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_337898_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_337898_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_337898_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_337898_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_337898_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_337898_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_337898_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_337898_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_337898_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_337898_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_337898_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_337898_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_337898_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_337898_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_337898_total_iter /
                (ctx->futhark_mc_segmap_parloop_337898_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_337898_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_337898_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_337898_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_337896            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_337896_runs[i],
                    (long) ctx->futhark_mc_segmap_task_337896_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_337896_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_337896_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_337896_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_337896_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_337896_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_337896_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_337896_iter[i],
                    (long) ctx->futhark_mc_segmap_task_337896_iter[i] /
                    (ctx->futhark_mc_segmap_task_337896_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_337896_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_337893         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_337893_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_337893_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_337893_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_337893_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_337893_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_337893_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_337893_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_337893_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_337893_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_337893_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_337893_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_337893_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_337893_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_337893_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_337893_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_337893_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_337893_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_337893_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_337893_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_337893_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_337893_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_337893_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_337893_total_iter /
                (ctx->futhark_mc_segmap_parloop_337893_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_337893_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_337893_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_337893_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_337887            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_337887_runs[i],
                    (long) ctx->futhark_mc_segmap_task_337887_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_337887_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_337887_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_337887_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_337887_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_337887_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_337887_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_337887_iter[i],
                    (long) ctx->futhark_mc_segmap_task_337887_iter[i] /
                    (ctx->futhark_mc_segmap_task_337887_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_337887_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_nested_task_337891     ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_nested_task_337891_runs[i],
                    (long) ctx->futhark_mc_segmap_nested_task_337891_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_337891_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_337891_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_nested_task_337891_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_nested_task_337891_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_337891_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_nested_task_337891_iter[i]),
                    (long) ctx->futhark_mc_segmap_nested_task_337891_iter[i],
                    (long) ctx->futhark_mc_segmap_nested_task_337891_iter[i] /
                    (ctx->futhark_mc_segmap_nested_task_337891_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_337891_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_337902         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_337902_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_337902_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_337902_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_337902_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_337902_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_337902_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_337902_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_337902_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_337902_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_337902_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_337902_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_337902_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_337902_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_337902_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_337902_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_337902_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_337902_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_337902_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_337902_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_337902_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_337902_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_337902_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_337902_total_iter /
                (ctx->futhark_mc_segmap_parloop_337902_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_337902_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_337902_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_337902_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_337913         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_337913_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_337913_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_337913_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_337913_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_337913_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_337913_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_337913_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_337913_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_337913_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_337913_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_337913_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_337913_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_337913_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_337913_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_337913_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_337913_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_337913_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_337913_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_337913_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_337913_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_337913_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_337913_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_337913_total_iter /
                (ctx->futhark_mc_segmap_parloop_337913_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_337913_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_337913_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_337913_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_337924         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_337924_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_337924_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_337924_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_337924_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_337924_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_337924_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_337924_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_337924_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_337924_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_337924_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_337924_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_337924_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_337924_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_337924_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_337924_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_337924_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_337924_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_337924_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_337924_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_337924_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_337924_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_337924_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_337924_total_iter /
                (ctx->futhark_mc_segmap_parloop_337924_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_337924_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_337924_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_337924_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_337922            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_337922_runs[i],
                    (long) ctx->futhark_mc_segmap_task_337922_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_337922_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_337922_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_337922_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_337922_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_337922_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_337922_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_337922_iter[i],
                    (long) ctx->futhark_mc_segmap_task_337922_iter[i] /
                    (ctx->futhark_mc_segmap_task_337922_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_337922_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_337918         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_337918_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_337918_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_337918_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_337918_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_337918_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_337918_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_337918_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_337918_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_337918_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_337918_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_337918_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_337918_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_337918_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_337918_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_337918_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_337918_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_337918_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_337918_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_337918_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_337918_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_337918_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_337918_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_337918_total_iter /
                (ctx->futhark_mc_segmap_parloop_337918_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_337918_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_337918_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_337918_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_337911            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_337911_runs[i],
                    (long) ctx->futhark_mc_segmap_task_337911_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_337911_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_337911_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_337911_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_337911_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_337911_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_337911_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_337911_iter[i],
                    (long) ctx->futhark_mc_segmap_task_337911_iter[i] /
                    (ctx->futhark_mc_segmap_task_337911_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_337911_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_nested_task_337916     ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_nested_task_337916_runs[i],
                    (long) ctx->futhark_mc_segmap_nested_task_337916_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_337916_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_337916_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_nested_task_337916_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_nested_task_337916_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_337916_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_nested_task_337916_iter[i]),
                    (long) ctx->futhark_mc_segmap_nested_task_337916_iter[i],
                    (long) ctx->futhark_mc_segmap_nested_task_337916_iter[i] /
                    (ctx->futhark_mc_segmap_nested_task_337916_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_337916_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_337907         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_337907_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_337907_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_337907_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_337907_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_337907_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_337907_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_337907_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_337907_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_337907_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_337907_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_337907_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_337907_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_337907_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_337907_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_337907_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_337907_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_337907_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_337907_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_337907_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_337907_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_337907_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_337907_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_337907_total_iter /
                (ctx->futhark_mc_segmap_parloop_337907_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_337907_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_337907_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_337907_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_337900            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_337900_runs[i],
                    (long) ctx->futhark_mc_segmap_task_337900_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_337900_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_337900_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_337900_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_337900_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_337900_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_337900_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_337900_iter[i],
                    (long) ctx->futhark_mc_segmap_task_337900_iter[i] /
                    (ctx->futhark_mc_segmap_task_337900_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_337900_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_nested_task_337905     ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_nested_task_337905_runs[i],
                    (long) ctx->futhark_mc_segmap_nested_task_337905_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_337905_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_337905_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_nested_task_337905_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_nested_task_337905_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_337905_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_nested_task_337905_iter[i]),
                    (long) ctx->futhark_mc_segmap_nested_task_337905_iter[i],
                    (long) ctx->futhark_mc_segmap_nested_task_337905_iter[i] /
                    (ctx->futhark_mc_segmap_nested_task_337905_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_337905_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_337928         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_337928_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_337928_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_337928_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_337928_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_337928_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_337928_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_337928_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_337928_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_337928_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_337928_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_337928_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_337928_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_337928_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_337928_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_337928_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_337928_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_337928_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_337928_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_337928_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_337928_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_337928_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_337928_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_337928_total_iter /
                (ctx->futhark_mc_segmap_parloop_337928_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_337928_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_337928_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_337928_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_337937         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_337937_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_337937_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_337937_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_337937_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_337937_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_337937_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_337937_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_337937_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_337937_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_337937_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_337937_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_337937_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_337937_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_337937_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_337937_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_337937_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_337937_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_337937_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_337937_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_337937_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_337937_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_337937_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_337937_total_iter /
                (ctx->futhark_mc_segmap_parloop_337937_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_337937_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_337937_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_337937_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_337946         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_337946_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_337946_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_337946_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_337946_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_337946_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_337946_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_337946_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_337946_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_337946_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_337946_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_337946_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_337946_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_337946_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_337946_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_337946_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_337946_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_337946_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_337946_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_337946_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_337946_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_337946_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_337946_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_337946_total_iter /
                (ctx->futhark_mc_segmap_parloop_337946_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_337946_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_337946_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_337946_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_stage_1_parloop_337954 ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_stage_1_parloop_337954_runs[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_337954_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_337954_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_337954_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_337954_total_runtime[i],
                    (double) ctx->futhark_mc_segred_stage_1_parloop_337954_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_337954_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_337954_iter[i]),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_337954_iter[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_337954_iter[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_337954_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_337954_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segred_stage_1_parloop_337954_total ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segred_stage_1_parloop_337954_total_runs,
                (long) ctx->futhark_mc_segred_stage_1_parloop_337954_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_337954_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_337954_total_runs : 1),
                (long) ctx->futhark_mc_segred_stage_1_parloop_337954_total_total_runtime,
                (double) ctx->futhark_mc_segred_stage_1_parloop_337954_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_337954_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_337954_total_iter),
                (long) ctx->futhark_mc_segred_stage_1_parloop_337954_total_iter,
                (long) ctx->futhark_mc_segred_stage_1_parloop_337954_total_iter /
                (ctx->futhark_mc_segred_stage_1_parloop_337954_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_337954_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segred_stage_1_parloop_337954_total_total_runtime;
        ctx->total_runs +=
            ctx->futhark_mc_segred_stage_1_parloop_337954_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_task_337951            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_task_337951_runs[i],
                    (long) ctx->futhark_mc_segred_task_337951_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_337951_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_337951_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_task_337951_total_runtime[i],
                    (double) ctx->futhark_mc_segred_task_337951_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_337951_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_task_337951_iter[i]),
                    (long) ctx->futhark_mc_segred_task_337951_iter[i],
                    (long) ctx->futhark_mc_segred_task_337951_iter[i] /
                    (ctx->futhark_mc_segred_task_337951_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_337951_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_stage_1_parloop_337959 ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_stage_1_parloop_337959_runs[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_337959_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_337959_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_337959_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_337959_total_runtime[i],
                    (double) ctx->futhark_mc_segred_stage_1_parloop_337959_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_337959_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_337959_iter[i]),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_337959_iter[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_337959_iter[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_337959_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_337959_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segred_stage_1_parloop_337959_total ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segred_stage_1_parloop_337959_total_runs,
                (long) ctx->futhark_mc_segred_stage_1_parloop_337959_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_337959_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_337959_total_runs : 1),
                (long) ctx->futhark_mc_segred_stage_1_parloop_337959_total_total_runtime,
                (double) ctx->futhark_mc_segred_stage_1_parloop_337959_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_337959_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_337959_total_iter),
                (long) ctx->futhark_mc_segred_stage_1_parloop_337959_total_iter,
                (long) ctx->futhark_mc_segred_stage_1_parloop_337959_total_iter /
                (ctx->futhark_mc_segred_stage_1_parloop_337959_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_337959_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segred_stage_1_parloop_337959_total_total_runtime;
        ctx->total_runs +=
            ctx->futhark_mc_segred_stage_1_parloop_337959_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_task_337956            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_task_337956_runs[i],
                    (long) ctx->futhark_mc_segred_task_337956_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_337956_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_337956_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_task_337956_total_runtime[i],
                    (double) ctx->futhark_mc_segred_task_337956_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_337956_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_task_337956_iter[i]),
                    (long) ctx->futhark_mc_segred_task_337956_iter[i],
                    (long) ctx->futhark_mc_segred_task_337956_iter[i] /
                    (ctx->futhark_mc_segred_task_337956_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_337956_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_337949         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_337949_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_337949_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_337949_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_337949_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_337949_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_337949_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_337949_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_337949_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_337949_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_337949_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_337949_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_337949_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_337949_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_337949_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_337949_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_337949_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_337949_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_337949_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_337949_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_337949_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_337949_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_337949_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_337949_total_iter /
                (ctx->futhark_mc_segmap_parloop_337949_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_337949_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_337949_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_337949_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_337944            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_337944_runs[i],
                    (long) ctx->futhark_mc_segmap_task_337944_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_337944_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_337944_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_337944_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_337944_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_337944_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_337944_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_337944_iter[i],
                    (long) ctx->futhark_mc_segmap_task_337944_iter[i] /
                    (ctx->futhark_mc_segmap_task_337944_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_337944_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_nested_task_337947     ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_nested_task_337947_runs[i],
                    (long) ctx->futhark_mc_segmap_nested_task_337947_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_337947_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_337947_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_nested_task_337947_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_nested_task_337947_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_337947_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_nested_task_337947_iter[i]),
                    (long) ctx->futhark_mc_segmap_nested_task_337947_iter[i],
                    (long) ctx->futhark_mc_segmap_nested_task_337947_iter[i] /
                    (ctx->futhark_mc_segmap_nested_task_337947_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_337947_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_337941         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_337941_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_337941_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_337941_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_337941_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_337941_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_337941_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_337941_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_337941_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_337941_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_337941_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_337941_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_337941_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_337941_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_337941_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_337941_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_337941_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_337941_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_337941_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_337941_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_337941_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_337941_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_337941_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_337941_total_iter /
                (ctx->futhark_mc_segmap_parloop_337941_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_337941_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_337941_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_337941_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_337935            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_337935_runs[i],
                    (long) ctx->futhark_mc_segmap_task_337935_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_337935_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_337935_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_337935_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_337935_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_337935_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_337935_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_337935_iter[i],
                    (long) ctx->futhark_mc_segmap_task_337935_iter[i] /
                    (ctx->futhark_mc_segmap_task_337935_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_337935_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_nested_task_337939     ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_nested_task_337939_runs[i],
                    (long) ctx->futhark_mc_segmap_nested_task_337939_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_337939_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_337939_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_nested_task_337939_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_nested_task_337939_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_337939_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_nested_task_337939_iter[i]),
                    (long) ctx->futhark_mc_segmap_nested_task_337939_iter[i],
                    (long) ctx->futhark_mc_segmap_nested_task_337939_iter[i] /
                    (ctx->futhark_mc_segmap_nested_task_337939_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_337939_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_337932         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_337932_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_337932_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_337932_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_337932_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_337932_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_337932_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_337932_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_337932_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_337932_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_337932_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_337932_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_337932_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_337932_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_337932_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_337932_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_337932_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_337932_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_337932_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_337932_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_337932_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_337932_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_337932_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_337932_total_iter /
                (ctx->futhark_mc_segmap_parloop_337932_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_337932_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_337932_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_337932_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_337926            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_337926_runs[i],
                    (long) ctx->futhark_mc_segmap_task_337926_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_337926_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_337926_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_337926_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_337926_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_337926_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_337926_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_337926_iter[i],
                    (long) ctx->futhark_mc_segmap_task_337926_iter[i] /
                    (ctx->futhark_mc_segmap_task_337926_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_337926_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_nested_task_337930     ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_nested_task_337930_runs[i],
                    (long) ctx->futhark_mc_segmap_nested_task_337930_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_337930_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_337930_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_nested_task_337930_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_nested_task_337930_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_337930_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_nested_task_337930_iter[i]),
                    (long) ctx->futhark_mc_segmap_nested_task_337930_iter[i],
                    (long) ctx->futhark_mc_segmap_nested_task_337930_iter[i] /
                    (ctx->futhark_mc_segmap_nested_task_337930_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_337930_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_337963         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_337963_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_337963_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_337963_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_337963_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_337963_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_337963_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_337963_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_337963_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_337963_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_337963_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_337963_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_337963_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_337963_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_337963_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_337963_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_337963_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_337963_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_337963_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_337963_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_337963_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_337963_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_337963_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_337963_total_iter /
                (ctx->futhark_mc_segmap_parloop_337963_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_337963_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_337963_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_337963_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_337974         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_337974_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_337974_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_337974_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_337974_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_337974_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_337974_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_337974_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_337974_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_337974_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_337974_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_337974_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_337974_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_337974_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_337974_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_337974_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_337974_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_337974_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_337974_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_337974_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_337974_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_337974_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_337974_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_337974_total_iter /
                (ctx->futhark_mc_segmap_parloop_337974_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_337974_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_337974_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_337974_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_337985         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_337985_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_337985_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_337985_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_337985_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_337985_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_337985_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_337985_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_337985_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_337985_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_337985_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_337985_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_337985_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_337985_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_337985_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_337985_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_337985_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_337985_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_337985_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_337985_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_337985_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_337985_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_337985_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_337985_total_iter /
                (ctx->futhark_mc_segmap_parloop_337985_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_337985_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_337985_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_337985_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_stage_1_parloop_337995 ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_stage_1_parloop_337995_runs[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_337995_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_337995_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_337995_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_337995_total_runtime[i],
                    (double) ctx->futhark_mc_segred_stage_1_parloop_337995_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_337995_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_337995_iter[i]),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_337995_iter[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_337995_iter[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_337995_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_337995_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segred_stage_1_parloop_337995_total ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segred_stage_1_parloop_337995_total_runs,
                (long) ctx->futhark_mc_segred_stage_1_parloop_337995_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_337995_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_337995_total_runs : 1),
                (long) ctx->futhark_mc_segred_stage_1_parloop_337995_total_total_runtime,
                (double) ctx->futhark_mc_segred_stage_1_parloop_337995_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_337995_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_337995_total_iter),
                (long) ctx->futhark_mc_segred_stage_1_parloop_337995_total_iter,
                (long) ctx->futhark_mc_segred_stage_1_parloop_337995_total_iter /
                (ctx->futhark_mc_segred_stage_1_parloop_337995_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_337995_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segred_stage_1_parloop_337995_total_total_runtime;
        ctx->total_runs +=
            ctx->futhark_mc_segred_stage_1_parloop_337995_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_task_337990            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_task_337990_runs[i],
                    (long) ctx->futhark_mc_segred_task_337990_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_337990_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_337990_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_task_337990_total_runtime[i],
                    (double) ctx->futhark_mc_segred_task_337990_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_337990_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_task_337990_iter[i]),
                    (long) ctx->futhark_mc_segred_task_337990_iter[i],
                    (long) ctx->futhark_mc_segred_task_337990_iter[i] /
                    (ctx->futhark_mc_segred_task_337990_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_337990_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_stage_1_parloop_338001 ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_stage_1_parloop_338001_runs[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338001_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338001_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_338001_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338001_total_runtime[i],
                    (double) ctx->futhark_mc_segred_stage_1_parloop_338001_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338001_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_338001_iter[i]),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338001_iter[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338001_iter[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338001_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_338001_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segred_stage_1_parloop_338001_total ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segred_stage_1_parloop_338001_total_runs,
                (long) ctx->futhark_mc_segred_stage_1_parloop_338001_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_338001_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_338001_total_runs : 1),
                (long) ctx->futhark_mc_segred_stage_1_parloop_338001_total_total_runtime,
                (double) ctx->futhark_mc_segred_stage_1_parloop_338001_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_338001_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_338001_total_iter),
                (long) ctx->futhark_mc_segred_stage_1_parloop_338001_total_iter,
                (long) ctx->futhark_mc_segred_stage_1_parloop_338001_total_iter /
                (ctx->futhark_mc_segred_stage_1_parloop_338001_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_338001_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segred_stage_1_parloop_338001_total_total_runtime;
        ctx->total_runs +=
            ctx->futhark_mc_segred_stage_1_parloop_338001_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_task_337997            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_task_337997_runs[i],
                    (long) ctx->futhark_mc_segred_task_337997_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_337997_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_337997_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_task_337997_total_runtime[i],
                    (double) ctx->futhark_mc_segred_task_337997_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_337997_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_task_337997_iter[i]),
                    (long) ctx->futhark_mc_segred_task_337997_iter[i],
                    (long) ctx->futhark_mc_segred_task_337997_iter[i] /
                    (ctx->futhark_mc_segred_task_337997_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_337997_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_337988         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_337988_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_337988_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_337988_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_337988_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_337988_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_337988_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_337988_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_337988_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_337988_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_337988_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_337988_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_337988_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_337988_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_337988_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_337988_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_337988_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_337988_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_337988_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_337988_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_337988_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_337988_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_337988_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_337988_total_iter /
                (ctx->futhark_mc_segmap_parloop_337988_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_337988_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_337988_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_337988_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_337983            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_337983_runs[i],
                    (long) ctx->futhark_mc_segmap_task_337983_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_337983_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_337983_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_337983_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_337983_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_337983_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_337983_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_337983_iter[i],
                    (long) ctx->futhark_mc_segmap_task_337983_iter[i] /
                    (ctx->futhark_mc_segmap_task_337983_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_337983_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_nested_task_337986     ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_nested_task_337986_runs[i],
                    (long) ctx->futhark_mc_segmap_nested_task_337986_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_337986_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_337986_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_nested_task_337986_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_nested_task_337986_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_337986_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_nested_task_337986_iter[i]),
                    (long) ctx->futhark_mc_segmap_nested_task_337986_iter[i],
                    (long) ctx->futhark_mc_segmap_nested_task_337986_iter[i] /
                    (ctx->futhark_mc_segmap_nested_task_337986_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_337986_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_337979         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_337979_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_337979_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_337979_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_337979_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_337979_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_337979_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_337979_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_337979_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_337979_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_337979_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_337979_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_337979_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_337979_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_337979_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_337979_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_337979_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_337979_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_337979_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_337979_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_337979_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_337979_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_337979_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_337979_total_iter /
                (ctx->futhark_mc_segmap_parloop_337979_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_337979_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_337979_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_337979_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_337972            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_337972_runs[i],
                    (long) ctx->futhark_mc_segmap_task_337972_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_337972_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_337972_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_337972_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_337972_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_337972_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_337972_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_337972_iter[i],
                    (long) ctx->futhark_mc_segmap_task_337972_iter[i] /
                    (ctx->futhark_mc_segmap_task_337972_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_337972_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_nested_task_337977     ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_nested_task_337977_runs[i],
                    (long) ctx->futhark_mc_segmap_nested_task_337977_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_337977_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_337977_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_nested_task_337977_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_nested_task_337977_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_337977_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_nested_task_337977_iter[i]),
                    (long) ctx->futhark_mc_segmap_nested_task_337977_iter[i],
                    (long) ctx->futhark_mc_segmap_nested_task_337977_iter[i] /
                    (ctx->futhark_mc_segmap_nested_task_337977_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_337977_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_337968         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_337968_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_337968_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_337968_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_337968_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_337968_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_337968_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_337968_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_337968_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_337968_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_337968_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_337968_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_337968_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_337968_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_337968_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_337968_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_337968_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_337968_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_337968_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_337968_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_337968_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_337968_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_337968_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_337968_total_iter /
                (ctx->futhark_mc_segmap_parloop_337968_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_337968_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_337968_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_337968_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_337961            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_337961_runs[i],
                    (long) ctx->futhark_mc_segmap_task_337961_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_337961_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_337961_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_337961_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_337961_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_337961_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_337961_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_337961_iter[i],
                    (long) ctx->futhark_mc_segmap_task_337961_iter[i] /
                    (ctx->futhark_mc_segmap_task_337961_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_337961_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_nested_task_337966     ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_nested_task_337966_runs[i],
                    (long) ctx->futhark_mc_segmap_nested_task_337966_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_337966_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_337966_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_nested_task_337966_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_nested_task_337966_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_337966_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_nested_task_337966_iter[i]),
                    (long) ctx->futhark_mc_segmap_nested_task_337966_iter[i],
                    (long) ctx->futhark_mc_segmap_nested_task_337966_iter[i] /
                    (ctx->futhark_mc_segmap_nested_task_337966_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_337966_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338005         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338005_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338005_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338005_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338005_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338005_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338005_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338005_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338005_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338005_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338005_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338005_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338005_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338005_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338005_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338005_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338005_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338005_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338005_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338005_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338005_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338005_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338005_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338005_total_iter /
                (ctx->futhark_mc_segmap_parloop_338005_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338005_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338005_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338005_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338016         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338016_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338016_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338016_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338016_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338016_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338016_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338016_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338016_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338016_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338016_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338016_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338016_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338016_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338016_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338016_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338016_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338016_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338016_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338016_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338016_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338016_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338016_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338016_total_iter /
                (ctx->futhark_mc_segmap_parloop_338016_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338016_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338016_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338016_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338027         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338027_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338027_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338027_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338027_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338027_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338027_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338027_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338027_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338027_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338027_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338027_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338027_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338027_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338027_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338027_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338027_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338027_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338027_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338027_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338027_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338027_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338027_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338027_total_iter /
                (ctx->futhark_mc_segmap_parloop_338027_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338027_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338027_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338027_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_stage_1_parloop_338039 ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_stage_1_parloop_338039_runs[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338039_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338039_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_338039_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338039_total_runtime[i],
                    (double) ctx->futhark_mc_segred_stage_1_parloop_338039_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338039_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_338039_iter[i]),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338039_iter[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338039_iter[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338039_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_338039_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segred_stage_1_parloop_338039_total ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segred_stage_1_parloop_338039_total_runs,
                (long) ctx->futhark_mc_segred_stage_1_parloop_338039_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_338039_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_338039_total_runs : 1),
                (long) ctx->futhark_mc_segred_stage_1_parloop_338039_total_total_runtime,
                (double) ctx->futhark_mc_segred_stage_1_parloop_338039_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_338039_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_338039_total_iter),
                (long) ctx->futhark_mc_segred_stage_1_parloop_338039_total_iter,
                (long) ctx->futhark_mc_segred_stage_1_parloop_338039_total_iter /
                (ctx->futhark_mc_segred_stage_1_parloop_338039_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_338039_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segred_stage_1_parloop_338039_total_total_runtime;
        ctx->total_runs +=
            ctx->futhark_mc_segred_stage_1_parloop_338039_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_task_338032            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_task_338032_runs[i],
                    (long) ctx->futhark_mc_segred_task_338032_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_338032_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_338032_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_task_338032_total_runtime[i],
                    (double) ctx->futhark_mc_segred_task_338032_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_338032_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_task_338032_iter[i]),
                    (long) ctx->futhark_mc_segred_task_338032_iter[i],
                    (long) ctx->futhark_mc_segred_task_338032_iter[i] /
                    (ctx->futhark_mc_segred_task_338032_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_338032_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_stage_1_parloop_338045 ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_stage_1_parloop_338045_runs[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338045_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338045_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_338045_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338045_total_runtime[i],
                    (double) ctx->futhark_mc_segred_stage_1_parloop_338045_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338045_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_338045_iter[i]),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338045_iter[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338045_iter[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338045_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_338045_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segred_stage_1_parloop_338045_total ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segred_stage_1_parloop_338045_total_runs,
                (long) ctx->futhark_mc_segred_stage_1_parloop_338045_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_338045_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_338045_total_runs : 1),
                (long) ctx->futhark_mc_segred_stage_1_parloop_338045_total_total_runtime,
                (double) ctx->futhark_mc_segred_stage_1_parloop_338045_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_338045_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_338045_total_iter),
                (long) ctx->futhark_mc_segred_stage_1_parloop_338045_total_iter,
                (long) ctx->futhark_mc_segred_stage_1_parloop_338045_total_iter /
                (ctx->futhark_mc_segred_stage_1_parloop_338045_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_338045_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segred_stage_1_parloop_338045_total_total_runtime;
        ctx->total_runs +=
            ctx->futhark_mc_segred_stage_1_parloop_338045_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_task_338041            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_task_338041_runs[i],
                    (long) ctx->futhark_mc_segred_task_338041_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_338041_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_338041_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_task_338041_total_runtime[i],
                    (double) ctx->futhark_mc_segred_task_338041_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_338041_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_task_338041_iter[i]),
                    (long) ctx->futhark_mc_segred_task_338041_iter[i],
                    (long) ctx->futhark_mc_segred_task_338041_iter[i] /
                    (ctx->futhark_mc_segred_task_338041_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_338041_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338030         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338030_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338030_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338030_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338030_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338030_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338030_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338030_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338030_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338030_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338030_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338030_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338030_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338030_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338030_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338030_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338030_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338030_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338030_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338030_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338030_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338030_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338030_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338030_total_iter /
                (ctx->futhark_mc_segmap_parloop_338030_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338030_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338030_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338030_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_338025            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_338025_runs[i],
                    (long) ctx->futhark_mc_segmap_task_338025_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338025_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338025_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_338025_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_338025_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338025_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_338025_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_338025_iter[i],
                    (long) ctx->futhark_mc_segmap_task_338025_iter[i] /
                    (ctx->futhark_mc_segmap_task_338025_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338025_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_nested_task_338028     ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_nested_task_338028_runs[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338028_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338028_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338028_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_nested_task_338028_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_nested_task_338028_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338028_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_nested_task_338028_iter[i]),
                    (long) ctx->futhark_mc_segmap_nested_task_338028_iter[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338028_iter[i] /
                    (ctx->futhark_mc_segmap_nested_task_338028_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338028_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338021         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338021_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338021_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338021_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338021_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338021_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338021_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338021_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338021_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338021_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338021_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338021_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338021_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338021_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338021_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338021_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338021_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338021_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338021_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338021_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338021_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338021_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338021_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338021_total_iter /
                (ctx->futhark_mc_segmap_parloop_338021_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338021_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338021_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338021_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_338014            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_338014_runs[i],
                    (long) ctx->futhark_mc_segmap_task_338014_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338014_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338014_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_338014_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_338014_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338014_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_338014_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_338014_iter[i],
                    (long) ctx->futhark_mc_segmap_task_338014_iter[i] /
                    (ctx->futhark_mc_segmap_task_338014_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338014_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_nested_task_338019     ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_nested_task_338019_runs[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338019_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338019_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338019_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_nested_task_338019_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_nested_task_338019_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338019_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_nested_task_338019_iter[i]),
                    (long) ctx->futhark_mc_segmap_nested_task_338019_iter[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338019_iter[i] /
                    (ctx->futhark_mc_segmap_nested_task_338019_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338019_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338010         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338010_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338010_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338010_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338010_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338010_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338010_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338010_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338010_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338010_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338010_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338010_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338010_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338010_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338010_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338010_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338010_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338010_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338010_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338010_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338010_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338010_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338010_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338010_total_iter /
                (ctx->futhark_mc_segmap_parloop_338010_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338010_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338010_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338010_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_338003            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_338003_runs[i],
                    (long) ctx->futhark_mc_segmap_task_338003_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338003_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338003_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_338003_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_338003_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338003_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_338003_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_338003_iter[i],
                    (long) ctx->futhark_mc_segmap_task_338003_iter[i] /
                    (ctx->futhark_mc_segmap_task_338003_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338003_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_nested_task_338008     ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_nested_task_338008_runs[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338008_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338008_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338008_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_nested_task_338008_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_nested_task_338008_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338008_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_nested_task_338008_iter[i]),
                    (long) ctx->futhark_mc_segmap_nested_task_338008_iter[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338008_iter[i] /
                    (ctx->futhark_mc_segmap_nested_task_338008_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338008_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338049         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338049_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338049_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338049_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338049_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338049_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338049_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338049_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338049_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338049_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338049_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338049_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338049_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338049_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338049_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338049_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338049_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338049_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338049_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338049_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338049_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338049_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338049_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338049_total_iter /
                (ctx->futhark_mc_segmap_parloop_338049_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338049_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338049_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338049_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338059         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338059_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338059_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338059_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338059_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338059_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338059_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338059_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338059_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338059_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338059_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338059_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338059_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338059_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338059_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338059_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338059_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338059_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338059_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338059_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338059_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338059_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338059_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338059_total_iter /
                (ctx->futhark_mc_segmap_parloop_338059_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338059_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338059_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338059_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338069         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338069_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338069_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338069_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338069_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338069_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338069_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338069_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338069_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338069_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338069_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338069_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338069_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338069_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338069_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338069_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338069_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338069_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338069_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338069_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338069_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338069_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338069_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338069_total_iter /
                (ctx->futhark_mc_segmap_parloop_338069_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338069_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338069_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338069_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_stage_1_parloop_338079 ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_stage_1_parloop_338079_runs[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338079_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338079_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_338079_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338079_total_runtime[i],
                    (double) ctx->futhark_mc_segred_stage_1_parloop_338079_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338079_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_338079_iter[i]),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338079_iter[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338079_iter[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338079_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_338079_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segred_stage_1_parloop_338079_total ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segred_stage_1_parloop_338079_total_runs,
                (long) ctx->futhark_mc_segred_stage_1_parloop_338079_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_338079_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_338079_total_runs : 1),
                (long) ctx->futhark_mc_segred_stage_1_parloop_338079_total_total_runtime,
                (double) ctx->futhark_mc_segred_stage_1_parloop_338079_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_338079_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_338079_total_iter),
                (long) ctx->futhark_mc_segred_stage_1_parloop_338079_total_iter,
                (long) ctx->futhark_mc_segred_stage_1_parloop_338079_total_iter /
                (ctx->futhark_mc_segred_stage_1_parloop_338079_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_338079_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segred_stage_1_parloop_338079_total_total_runtime;
        ctx->total_runs +=
            ctx->futhark_mc_segred_stage_1_parloop_338079_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_task_338076            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_task_338076_runs[i],
                    (long) ctx->futhark_mc_segred_task_338076_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_338076_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_338076_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_task_338076_total_runtime[i],
                    (double) ctx->futhark_mc_segred_task_338076_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_338076_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_task_338076_iter[i]),
                    (long) ctx->futhark_mc_segred_task_338076_iter[i],
                    (long) ctx->futhark_mc_segred_task_338076_iter[i] /
                    (ctx->futhark_mc_segred_task_338076_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_338076_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_stage_1_parloop_338084 ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_stage_1_parloop_338084_runs[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338084_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338084_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_338084_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338084_total_runtime[i],
                    (double) ctx->futhark_mc_segred_stage_1_parloop_338084_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338084_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_338084_iter[i]),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338084_iter[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338084_iter[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338084_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_338084_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segred_stage_1_parloop_338084_total ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segred_stage_1_parloop_338084_total_runs,
                (long) ctx->futhark_mc_segred_stage_1_parloop_338084_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_338084_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_338084_total_runs : 1),
                (long) ctx->futhark_mc_segred_stage_1_parloop_338084_total_total_runtime,
                (double) ctx->futhark_mc_segred_stage_1_parloop_338084_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_338084_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_338084_total_iter),
                (long) ctx->futhark_mc_segred_stage_1_parloop_338084_total_iter,
                (long) ctx->futhark_mc_segred_stage_1_parloop_338084_total_iter /
                (ctx->futhark_mc_segred_stage_1_parloop_338084_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_338084_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segred_stage_1_parloop_338084_total_total_runtime;
        ctx->total_runs +=
            ctx->futhark_mc_segred_stage_1_parloop_338084_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_task_338081            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_task_338081_runs[i],
                    (long) ctx->futhark_mc_segred_task_338081_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_338081_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_338081_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_task_338081_total_runtime[i],
                    (double) ctx->futhark_mc_segred_task_338081_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_338081_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_task_338081_iter[i]),
                    (long) ctx->futhark_mc_segred_task_338081_iter[i],
                    (long) ctx->futhark_mc_segred_task_338081_iter[i] /
                    (ctx->futhark_mc_segred_task_338081_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_338081_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338073         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338073_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338073_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338073_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338073_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338073_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338073_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338073_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338073_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338073_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338073_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338073_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338073_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338073_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338073_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338073_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338073_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338073_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338073_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338073_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338073_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338073_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338073_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338073_total_iter /
                (ctx->futhark_mc_segmap_parloop_338073_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338073_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338073_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338073_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_338067            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_338067_runs[i],
                    (long) ctx->futhark_mc_segmap_task_338067_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338067_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338067_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_338067_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_338067_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338067_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_338067_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_338067_iter[i],
                    (long) ctx->futhark_mc_segmap_task_338067_iter[i] /
                    (ctx->futhark_mc_segmap_task_338067_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338067_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_nested_task_338071     ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_nested_task_338071_runs[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338071_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338071_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338071_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_nested_task_338071_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_nested_task_338071_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338071_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_nested_task_338071_iter[i]),
                    (long) ctx->futhark_mc_segmap_nested_task_338071_iter[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338071_iter[i] /
                    (ctx->futhark_mc_segmap_nested_task_338071_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338071_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338064         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338064_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338064_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338064_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338064_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338064_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338064_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338064_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338064_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338064_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338064_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338064_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338064_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338064_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338064_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338064_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338064_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338064_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338064_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338064_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338064_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338064_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338064_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338064_total_iter /
                (ctx->futhark_mc_segmap_parloop_338064_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338064_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338064_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338064_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_338057            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_338057_runs[i],
                    (long) ctx->futhark_mc_segmap_task_338057_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338057_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338057_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_338057_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_338057_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338057_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_338057_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_338057_iter[i],
                    (long) ctx->futhark_mc_segmap_task_338057_iter[i] /
                    (ctx->futhark_mc_segmap_task_338057_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338057_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_nested_task_338062     ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_nested_task_338062_runs[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338062_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338062_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338062_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_nested_task_338062_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_nested_task_338062_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338062_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_nested_task_338062_iter[i]),
                    (long) ctx->futhark_mc_segmap_nested_task_338062_iter[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338062_iter[i] /
                    (ctx->futhark_mc_segmap_nested_task_338062_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338062_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338054         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338054_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338054_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338054_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338054_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338054_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338054_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338054_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338054_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338054_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338054_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338054_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338054_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338054_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338054_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338054_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338054_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338054_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338054_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338054_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338054_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338054_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338054_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338054_total_iter /
                (ctx->futhark_mc_segmap_parloop_338054_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338054_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338054_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338054_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_338047            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_338047_runs[i],
                    (long) ctx->futhark_mc_segmap_task_338047_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338047_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338047_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_338047_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_338047_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338047_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_338047_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_338047_iter[i],
                    (long) ctx->futhark_mc_segmap_task_338047_iter[i] /
                    (ctx->futhark_mc_segmap_task_338047_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338047_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_nested_task_338052     ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_nested_task_338052_runs[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338052_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338052_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338052_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_nested_task_338052_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_nested_task_338052_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338052_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_nested_task_338052_iter[i]),
                    (long) ctx->futhark_mc_segmap_nested_task_338052_iter[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338052_iter[i] /
                    (ctx->futhark_mc_segmap_nested_task_338052_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338052_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338088         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338088_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338088_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338088_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338088_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338088_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338088_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338088_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338088_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338088_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338088_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338088_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338088_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338088_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338088_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338088_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338088_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338088_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338088_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338088_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338088_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338088_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338088_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338088_total_iter /
                (ctx->futhark_mc_segmap_parloop_338088_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338088_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338088_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338088_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338101         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338101_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338101_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338101_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338101_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338101_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338101_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338101_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338101_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338101_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338101_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338101_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338101_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338101_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338101_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338101_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338101_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338101_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338101_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338101_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338101_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338101_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338101_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338101_total_iter /
                (ctx->futhark_mc_segmap_parloop_338101_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338101_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338101_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338101_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338114         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338114_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338114_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338114_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338114_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338114_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338114_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338114_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338114_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338114_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338114_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338114_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338114_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338114_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338114_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338114_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338114_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338114_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338114_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338114_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338114_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338114_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338114_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338114_total_iter /
                (ctx->futhark_mc_segmap_parloop_338114_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338114_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338114_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338114_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_stage_1_parloop_338128 ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_stage_1_parloop_338128_runs[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338128_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338128_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_338128_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338128_total_runtime[i],
                    (double) ctx->futhark_mc_segred_stage_1_parloop_338128_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338128_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_338128_iter[i]),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338128_iter[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338128_iter[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338128_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_338128_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segred_stage_1_parloop_338128_total ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segred_stage_1_parloop_338128_total_runs,
                (long) ctx->futhark_mc_segred_stage_1_parloop_338128_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_338128_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_338128_total_runs : 1),
                (long) ctx->futhark_mc_segred_stage_1_parloop_338128_total_total_runtime,
                (double) ctx->futhark_mc_segred_stage_1_parloop_338128_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_338128_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_338128_total_iter),
                (long) ctx->futhark_mc_segred_stage_1_parloop_338128_total_iter,
                (long) ctx->futhark_mc_segred_stage_1_parloop_338128_total_iter /
                (ctx->futhark_mc_segred_stage_1_parloop_338128_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_338128_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segred_stage_1_parloop_338128_total_total_runtime;
        ctx->total_runs +=
            ctx->futhark_mc_segred_stage_1_parloop_338128_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_task_338123            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_task_338123_runs[i],
                    (long) ctx->futhark_mc_segred_task_338123_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_338123_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_338123_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_task_338123_total_runtime[i],
                    (double) ctx->futhark_mc_segred_task_338123_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_338123_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_task_338123_iter[i]),
                    (long) ctx->futhark_mc_segred_task_338123_iter[i],
                    (long) ctx->futhark_mc_segred_task_338123_iter[i] /
                    (ctx->futhark_mc_segred_task_338123_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_338123_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_stage_1_parloop_338134 ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_stage_1_parloop_338134_runs[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338134_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338134_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_338134_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338134_total_runtime[i],
                    (double) ctx->futhark_mc_segred_stage_1_parloop_338134_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338134_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_338134_iter[i]),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338134_iter[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338134_iter[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338134_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_338134_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segred_stage_1_parloop_338134_total ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segred_stage_1_parloop_338134_total_runs,
                (long) ctx->futhark_mc_segred_stage_1_parloop_338134_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_338134_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_338134_total_runs : 1),
                (long) ctx->futhark_mc_segred_stage_1_parloop_338134_total_total_runtime,
                (double) ctx->futhark_mc_segred_stage_1_parloop_338134_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_338134_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_338134_total_iter),
                (long) ctx->futhark_mc_segred_stage_1_parloop_338134_total_iter,
                (long) ctx->futhark_mc_segred_stage_1_parloop_338134_total_iter /
                (ctx->futhark_mc_segred_stage_1_parloop_338134_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_338134_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segred_stage_1_parloop_338134_total_total_runtime;
        ctx->total_runs +=
            ctx->futhark_mc_segred_stage_1_parloop_338134_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_task_338130            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_task_338130_runs[i],
                    (long) ctx->futhark_mc_segred_task_338130_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_338130_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_338130_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_task_338130_total_runtime[i],
                    (double) ctx->futhark_mc_segred_task_338130_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_338130_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_task_338130_iter[i]),
                    (long) ctx->futhark_mc_segred_task_338130_iter[i],
                    (long) ctx->futhark_mc_segred_task_338130_iter[i] /
                    (ctx->futhark_mc_segred_task_338130_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_338130_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338119         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338119_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338119_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338119_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338119_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338119_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338119_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338119_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338119_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338119_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338119_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338119_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338119_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338119_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338119_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338119_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338119_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338119_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338119_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338119_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338119_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338119_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338119_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338119_total_iter /
                (ctx->futhark_mc_segmap_parloop_338119_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338119_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338119_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338119_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_338112            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_338112_runs[i],
                    (long) ctx->futhark_mc_segmap_task_338112_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338112_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338112_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_338112_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_338112_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338112_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_338112_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_338112_iter[i],
                    (long) ctx->futhark_mc_segmap_task_338112_iter[i] /
                    (ctx->futhark_mc_segmap_task_338112_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338112_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_nested_task_338117     ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_nested_task_338117_runs[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338117_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338117_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338117_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_nested_task_338117_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_nested_task_338117_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338117_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_nested_task_338117_iter[i]),
                    (long) ctx->futhark_mc_segmap_nested_task_338117_iter[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338117_iter[i] /
                    (ctx->futhark_mc_segmap_nested_task_338117_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338117_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338108         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338108_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338108_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338108_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338108_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338108_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338108_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338108_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338108_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338108_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338108_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338108_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338108_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338108_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338108_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338108_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338108_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338108_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338108_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338108_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338108_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338108_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338108_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338108_total_iter /
                (ctx->futhark_mc_segmap_parloop_338108_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338108_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338108_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338108_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_338099            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_338099_runs[i],
                    (long) ctx->futhark_mc_segmap_task_338099_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338099_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338099_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_338099_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_338099_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338099_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_338099_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_338099_iter[i],
                    (long) ctx->futhark_mc_segmap_task_338099_iter[i] /
                    (ctx->futhark_mc_segmap_task_338099_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338099_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_nested_task_338106     ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_nested_task_338106_runs[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338106_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338106_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338106_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_nested_task_338106_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_nested_task_338106_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338106_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_nested_task_338106_iter[i]),
                    (long) ctx->futhark_mc_segmap_nested_task_338106_iter[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338106_iter[i] /
                    (ctx->futhark_mc_segmap_nested_task_338106_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338106_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338095         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338095_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338095_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338095_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338095_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338095_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338095_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338095_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338095_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338095_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338095_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338095_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338095_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338095_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338095_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338095_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338095_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338095_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338095_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338095_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338095_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338095_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338095_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338095_total_iter /
                (ctx->futhark_mc_segmap_parloop_338095_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338095_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338095_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338095_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_338086            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_338086_runs[i],
                    (long) ctx->futhark_mc_segmap_task_338086_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338086_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338086_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_338086_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_338086_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338086_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_338086_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_338086_iter[i],
                    (long) ctx->futhark_mc_segmap_task_338086_iter[i] /
                    (ctx->futhark_mc_segmap_task_338086_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338086_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_nested_task_338093     ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_nested_task_338093_runs[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338093_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338093_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338093_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_nested_task_338093_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_nested_task_338093_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338093_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_nested_task_338093_iter[i]),
                    (long) ctx->futhark_mc_segmap_nested_task_338093_iter[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338093_iter[i] /
                    (ctx->futhark_mc_segmap_nested_task_338093_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338093_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338138         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338138_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338138_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338138_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338138_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338138_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338138_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338138_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338138_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338138_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338138_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338138_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338138_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338138_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338138_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338138_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338138_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338138_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338138_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338138_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338138_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338138_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338138_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338138_total_iter /
                (ctx->futhark_mc_segmap_parloop_338138_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338138_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338138_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338138_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338153         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338153_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338153_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338153_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338153_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338153_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338153_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338153_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338153_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338153_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338153_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338153_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338153_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338153_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338153_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338153_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338153_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338153_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338153_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338153_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338153_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338153_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338153_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338153_total_iter /
                (ctx->futhark_mc_segmap_parloop_338153_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338153_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338153_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338153_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338168         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338168_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338168_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338168_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338168_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338168_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338168_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338168_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338168_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338168_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338168_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338168_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338168_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338168_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338168_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338168_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338168_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338168_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338168_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338168_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338168_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338168_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338168_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338168_total_iter /
                (ctx->futhark_mc_segmap_parloop_338168_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338168_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338168_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338168_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338183         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338183_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338183_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338183_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338183_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338183_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338183_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338183_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338183_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338183_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338183_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338183_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338183_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338183_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338183_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338183_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338183_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338183_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338183_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338183_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338183_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338183_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338183_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338183_total_iter /
                (ctx->futhark_mc_segmap_parloop_338183_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338183_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338183_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338183_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_338181            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_338181_runs[i],
                    (long) ctx->futhark_mc_segmap_task_338181_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338181_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338181_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_338181_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_338181_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338181_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_338181_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_338181_iter[i],
                    (long) ctx->futhark_mc_segmap_task_338181_iter[i] /
                    (ctx->futhark_mc_segmap_task_338181_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338181_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_stage_1_parloop_338192 ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_stage_1_parloop_338192_runs[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338192_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338192_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_338192_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338192_total_runtime[i],
                    (double) ctx->futhark_mc_segred_stage_1_parloop_338192_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338192_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_338192_iter[i]),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338192_iter[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338192_iter[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338192_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_338192_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segred_stage_1_parloop_338192_total ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segred_stage_1_parloop_338192_total_runs,
                (long) ctx->futhark_mc_segred_stage_1_parloop_338192_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_338192_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_338192_total_runs : 1),
                (long) ctx->futhark_mc_segred_stage_1_parloop_338192_total_total_runtime,
                (double) ctx->futhark_mc_segred_stage_1_parloop_338192_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_338192_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_338192_total_iter),
                (long) ctx->futhark_mc_segred_stage_1_parloop_338192_total_iter,
                (long) ctx->futhark_mc_segred_stage_1_parloop_338192_total_iter /
                (ctx->futhark_mc_segred_stage_1_parloop_338192_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_338192_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segred_stage_1_parloop_338192_total_total_runtime;
        ctx->total_runs +=
            ctx->futhark_mc_segred_stage_1_parloop_338192_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_task_338185            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_task_338185_runs[i],
                    (long) ctx->futhark_mc_segred_task_338185_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_338185_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_338185_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_task_338185_total_runtime[i],
                    (double) ctx->futhark_mc_segred_task_338185_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_338185_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_task_338185_iter[i]),
                    (long) ctx->futhark_mc_segred_task_338185_iter[i],
                    (long) ctx->futhark_mc_segred_task_338185_iter[i] /
                    (ctx->futhark_mc_segred_task_338185_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_338185_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_stage_1_parloop_338198 ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_stage_1_parloop_338198_runs[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338198_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338198_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_338198_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338198_total_runtime[i],
                    (double) ctx->futhark_mc_segred_stage_1_parloop_338198_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338198_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_338198_iter[i]),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338198_iter[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338198_iter[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338198_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_338198_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segred_stage_1_parloop_338198_total ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segred_stage_1_parloop_338198_total_runs,
                (long) ctx->futhark_mc_segred_stage_1_parloop_338198_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_338198_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_338198_total_runs : 1),
                (long) ctx->futhark_mc_segred_stage_1_parloop_338198_total_total_runtime,
                (double) ctx->futhark_mc_segred_stage_1_parloop_338198_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_338198_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_338198_total_iter),
                (long) ctx->futhark_mc_segred_stage_1_parloop_338198_total_iter,
                (long) ctx->futhark_mc_segred_stage_1_parloop_338198_total_iter /
                (ctx->futhark_mc_segred_stage_1_parloop_338198_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_338198_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segred_stage_1_parloop_338198_total_total_runtime;
        ctx->total_runs +=
            ctx->futhark_mc_segred_stage_1_parloop_338198_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_task_338194            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_task_338194_runs[i],
                    (long) ctx->futhark_mc_segred_task_338194_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_338194_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_338194_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_task_338194_total_runtime[i],
                    (double) ctx->futhark_mc_segred_task_338194_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_338194_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_task_338194_iter[i]),
                    (long) ctx->futhark_mc_segred_task_338194_iter[i],
                    (long) ctx->futhark_mc_segred_task_338194_iter[i] /
                    (ctx->futhark_mc_segred_task_338194_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_338194_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338175         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338175_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338175_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338175_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338175_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338175_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338175_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338175_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338175_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338175_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338175_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338175_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338175_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338175_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338175_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338175_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338175_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338175_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338175_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338175_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338175_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338175_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338175_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338175_total_iter /
                (ctx->futhark_mc_segmap_parloop_338175_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338175_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338175_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338175_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_338166            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_338166_runs[i],
                    (long) ctx->futhark_mc_segmap_task_338166_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338166_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338166_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_338166_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_338166_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338166_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_338166_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_338166_iter[i],
                    (long) ctx->futhark_mc_segmap_task_338166_iter[i] /
                    (ctx->futhark_mc_segmap_task_338166_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338166_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_nested_task_338173     ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_nested_task_338173_runs[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338173_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338173_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338173_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_nested_task_338173_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_nested_task_338173_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338173_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_nested_task_338173_iter[i]),
                    (long) ctx->futhark_mc_segmap_nested_task_338173_iter[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338173_iter[i] /
                    (ctx->futhark_mc_segmap_nested_task_338173_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338173_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338162         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338162_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338162_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338162_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338162_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338162_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338162_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338162_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338162_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338162_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338162_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338162_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338162_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338162_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338162_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338162_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338162_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338162_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338162_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338162_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338162_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338162_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338162_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338162_total_iter /
                (ctx->futhark_mc_segmap_parloop_338162_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338162_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338162_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338162_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_338151            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_338151_runs[i],
                    (long) ctx->futhark_mc_segmap_task_338151_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338151_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338151_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_338151_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_338151_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338151_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_338151_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_338151_iter[i],
                    (long) ctx->futhark_mc_segmap_task_338151_iter[i] /
                    (ctx->futhark_mc_segmap_task_338151_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338151_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_nested_task_338160     ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_nested_task_338160_runs[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338160_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338160_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338160_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_nested_task_338160_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_nested_task_338160_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338160_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_nested_task_338160_iter[i]),
                    (long) ctx->futhark_mc_segmap_nested_task_338160_iter[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338160_iter[i] /
                    (ctx->futhark_mc_segmap_nested_task_338160_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338160_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338147         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338147_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338147_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338147_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338147_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338147_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338147_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338147_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338147_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338147_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338147_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338147_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338147_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338147_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338147_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338147_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338147_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338147_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338147_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338147_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338147_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338147_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338147_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338147_total_iter /
                (ctx->futhark_mc_segmap_parloop_338147_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338147_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338147_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338147_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_338136            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_338136_runs[i],
                    (long) ctx->futhark_mc_segmap_task_338136_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338136_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338136_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_338136_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_338136_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338136_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_338136_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_338136_iter[i],
                    (long) ctx->futhark_mc_segmap_task_338136_iter[i] /
                    (ctx->futhark_mc_segmap_task_338136_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338136_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_nested_task_338145     ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_nested_task_338145_runs[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338145_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338145_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338145_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_nested_task_338145_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_nested_task_338145_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338145_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_nested_task_338145_iter[i]),
                    (long) ctx->futhark_mc_segmap_nested_task_338145_iter[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338145_iter[i] /
                    (ctx->futhark_mc_segmap_nested_task_338145_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338145_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338202         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338202_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338202_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338202_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338202_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338202_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338202_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338202_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338202_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338202_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338202_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338202_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338202_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338202_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338202_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338202_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338202_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338202_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338202_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338202_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338202_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338202_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338202_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338202_total_iter /
                (ctx->futhark_mc_segmap_parloop_338202_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338202_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338202_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338202_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338211         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338211_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338211_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338211_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338211_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338211_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338211_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338211_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338211_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338211_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338211_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338211_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338211_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338211_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338211_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338211_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338211_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338211_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338211_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338211_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338211_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338211_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338211_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338211_total_iter /
                (ctx->futhark_mc_segmap_parloop_338211_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338211_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338211_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338211_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338220         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338220_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338220_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338220_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338220_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338220_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338220_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338220_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338220_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338220_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338220_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338220_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338220_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338220_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338220_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338220_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338220_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338220_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338220_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338220_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338220_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338220_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338220_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338220_total_iter /
                (ctx->futhark_mc_segmap_parloop_338220_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338220_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338220_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338220_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_stage_1_parloop_338228 ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_stage_1_parloop_338228_runs[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338228_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338228_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_338228_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338228_total_runtime[i],
                    (double) ctx->futhark_mc_segred_stage_1_parloop_338228_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338228_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_338228_iter[i]),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338228_iter[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338228_iter[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338228_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_338228_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segred_stage_1_parloop_338228_total ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segred_stage_1_parloop_338228_total_runs,
                (long) ctx->futhark_mc_segred_stage_1_parloop_338228_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_338228_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_338228_total_runs : 1),
                (long) ctx->futhark_mc_segred_stage_1_parloop_338228_total_total_runtime,
                (double) ctx->futhark_mc_segred_stage_1_parloop_338228_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_338228_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_338228_total_iter),
                (long) ctx->futhark_mc_segred_stage_1_parloop_338228_total_iter,
                (long) ctx->futhark_mc_segred_stage_1_parloop_338228_total_iter /
                (ctx->futhark_mc_segred_stage_1_parloop_338228_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_338228_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segred_stage_1_parloop_338228_total_total_runtime;
        ctx->total_runs +=
            ctx->futhark_mc_segred_stage_1_parloop_338228_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_task_338225            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_task_338225_runs[i],
                    (long) ctx->futhark_mc_segred_task_338225_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_338225_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_338225_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_task_338225_total_runtime[i],
                    (double) ctx->futhark_mc_segred_task_338225_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_338225_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_task_338225_iter[i]),
                    (long) ctx->futhark_mc_segred_task_338225_iter[i],
                    (long) ctx->futhark_mc_segred_task_338225_iter[i] /
                    (ctx->futhark_mc_segred_task_338225_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_338225_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_stage_1_parloop_338233 ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_stage_1_parloop_338233_runs[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338233_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338233_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_338233_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338233_total_runtime[i],
                    (double) ctx->futhark_mc_segred_stage_1_parloop_338233_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338233_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_338233_iter[i]),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338233_iter[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338233_iter[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338233_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_338233_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segred_stage_1_parloop_338233_total ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segred_stage_1_parloop_338233_total_runs,
                (long) ctx->futhark_mc_segred_stage_1_parloop_338233_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_338233_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_338233_total_runs : 1),
                (long) ctx->futhark_mc_segred_stage_1_parloop_338233_total_total_runtime,
                (double) ctx->futhark_mc_segred_stage_1_parloop_338233_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_338233_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_338233_total_iter),
                (long) ctx->futhark_mc_segred_stage_1_parloop_338233_total_iter,
                (long) ctx->futhark_mc_segred_stage_1_parloop_338233_total_iter /
                (ctx->futhark_mc_segred_stage_1_parloop_338233_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_338233_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segred_stage_1_parloop_338233_total_total_runtime;
        ctx->total_runs +=
            ctx->futhark_mc_segred_stage_1_parloop_338233_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_task_338230            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_task_338230_runs[i],
                    (long) ctx->futhark_mc_segred_task_338230_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_338230_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_338230_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_task_338230_total_runtime[i],
                    (double) ctx->futhark_mc_segred_task_338230_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_338230_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_task_338230_iter[i]),
                    (long) ctx->futhark_mc_segred_task_338230_iter[i],
                    (long) ctx->futhark_mc_segred_task_338230_iter[i] /
                    (ctx->futhark_mc_segred_task_338230_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_338230_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338223         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338223_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338223_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338223_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338223_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338223_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338223_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338223_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338223_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338223_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338223_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338223_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338223_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338223_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338223_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338223_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338223_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338223_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338223_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338223_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338223_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338223_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338223_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338223_total_iter /
                (ctx->futhark_mc_segmap_parloop_338223_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338223_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338223_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338223_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_338218            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_338218_runs[i],
                    (long) ctx->futhark_mc_segmap_task_338218_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338218_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338218_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_338218_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_338218_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338218_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_338218_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_338218_iter[i],
                    (long) ctx->futhark_mc_segmap_task_338218_iter[i] /
                    (ctx->futhark_mc_segmap_task_338218_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338218_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_nested_task_338221     ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_nested_task_338221_runs[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338221_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338221_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338221_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_nested_task_338221_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_nested_task_338221_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338221_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_nested_task_338221_iter[i]),
                    (long) ctx->futhark_mc_segmap_nested_task_338221_iter[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338221_iter[i] /
                    (ctx->futhark_mc_segmap_nested_task_338221_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338221_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338215         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338215_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338215_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338215_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338215_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338215_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338215_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338215_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338215_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338215_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338215_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338215_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338215_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338215_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338215_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338215_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338215_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338215_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338215_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338215_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338215_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338215_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338215_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338215_total_iter /
                (ctx->futhark_mc_segmap_parloop_338215_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338215_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338215_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338215_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_338209            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_338209_runs[i],
                    (long) ctx->futhark_mc_segmap_task_338209_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338209_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338209_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_338209_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_338209_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338209_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_338209_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_338209_iter[i],
                    (long) ctx->futhark_mc_segmap_task_338209_iter[i] /
                    (ctx->futhark_mc_segmap_task_338209_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338209_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_nested_task_338213     ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_nested_task_338213_runs[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338213_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338213_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338213_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_nested_task_338213_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_nested_task_338213_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338213_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_nested_task_338213_iter[i]),
                    (long) ctx->futhark_mc_segmap_nested_task_338213_iter[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338213_iter[i] /
                    (ctx->futhark_mc_segmap_nested_task_338213_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338213_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338206         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338206_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338206_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338206_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338206_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338206_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338206_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338206_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338206_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338206_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338206_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338206_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338206_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338206_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338206_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338206_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338206_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338206_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338206_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338206_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338206_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338206_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338206_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338206_total_iter /
                (ctx->futhark_mc_segmap_parloop_338206_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338206_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338206_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338206_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_338200            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_338200_runs[i],
                    (long) ctx->futhark_mc_segmap_task_338200_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338200_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338200_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_338200_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_338200_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338200_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_338200_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_338200_iter[i],
                    (long) ctx->futhark_mc_segmap_task_338200_iter[i] /
                    (ctx->futhark_mc_segmap_task_338200_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338200_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_nested_task_338204     ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_nested_task_338204_runs[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338204_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338204_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338204_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_nested_task_338204_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_nested_task_338204_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338204_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_nested_task_338204_iter[i]),
                    (long) ctx->futhark_mc_segmap_nested_task_338204_iter[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338204_iter[i] /
                    (ctx->futhark_mc_segmap_nested_task_338204_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338204_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338237         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338237_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338237_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338237_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338237_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338237_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338237_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338237_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338237_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338237_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338237_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338237_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338237_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338237_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338237_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338237_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338237_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338237_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338237_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338237_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338237_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338237_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338237_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338237_total_iter /
                (ctx->futhark_mc_segmap_parloop_338237_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338237_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338237_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338237_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338248         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338248_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338248_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338248_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338248_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338248_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338248_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338248_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338248_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338248_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338248_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338248_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338248_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338248_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338248_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338248_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338248_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338248_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338248_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338248_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338248_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338248_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338248_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338248_total_iter /
                (ctx->futhark_mc_segmap_parloop_338248_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338248_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338248_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338248_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338259         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338259_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338259_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338259_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338259_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338259_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338259_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338259_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338259_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338259_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338259_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338259_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338259_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338259_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338259_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338259_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338259_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338259_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338259_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338259_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338259_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338259_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338259_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338259_total_iter /
                (ctx->futhark_mc_segmap_parloop_338259_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338259_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338259_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338259_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_stage_1_parloop_338269 ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_stage_1_parloop_338269_runs[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338269_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338269_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_338269_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338269_total_runtime[i],
                    (double) ctx->futhark_mc_segred_stage_1_parloop_338269_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338269_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_338269_iter[i]),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338269_iter[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338269_iter[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338269_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_338269_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segred_stage_1_parloop_338269_total ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segred_stage_1_parloop_338269_total_runs,
                (long) ctx->futhark_mc_segred_stage_1_parloop_338269_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_338269_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_338269_total_runs : 1),
                (long) ctx->futhark_mc_segred_stage_1_parloop_338269_total_total_runtime,
                (double) ctx->futhark_mc_segred_stage_1_parloop_338269_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_338269_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_338269_total_iter),
                (long) ctx->futhark_mc_segred_stage_1_parloop_338269_total_iter,
                (long) ctx->futhark_mc_segred_stage_1_parloop_338269_total_iter /
                (ctx->futhark_mc_segred_stage_1_parloop_338269_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_338269_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segred_stage_1_parloop_338269_total_total_runtime;
        ctx->total_runs +=
            ctx->futhark_mc_segred_stage_1_parloop_338269_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_task_338264            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_task_338264_runs[i],
                    (long) ctx->futhark_mc_segred_task_338264_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_338264_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_338264_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_task_338264_total_runtime[i],
                    (double) ctx->futhark_mc_segred_task_338264_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_338264_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_task_338264_iter[i]),
                    (long) ctx->futhark_mc_segred_task_338264_iter[i],
                    (long) ctx->futhark_mc_segred_task_338264_iter[i] /
                    (ctx->futhark_mc_segred_task_338264_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_338264_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_stage_1_parloop_338275 ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_stage_1_parloop_338275_runs[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338275_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338275_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_338275_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338275_total_runtime[i],
                    (double) ctx->futhark_mc_segred_stage_1_parloop_338275_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338275_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_338275_iter[i]),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338275_iter[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338275_iter[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338275_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_338275_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segred_stage_1_parloop_338275_total ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segred_stage_1_parloop_338275_total_runs,
                (long) ctx->futhark_mc_segred_stage_1_parloop_338275_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_338275_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_338275_total_runs : 1),
                (long) ctx->futhark_mc_segred_stage_1_parloop_338275_total_total_runtime,
                (double) ctx->futhark_mc_segred_stage_1_parloop_338275_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_338275_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_338275_total_iter),
                (long) ctx->futhark_mc_segred_stage_1_parloop_338275_total_iter,
                (long) ctx->futhark_mc_segred_stage_1_parloop_338275_total_iter /
                (ctx->futhark_mc_segred_stage_1_parloop_338275_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_338275_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segred_stage_1_parloop_338275_total_total_runtime;
        ctx->total_runs +=
            ctx->futhark_mc_segred_stage_1_parloop_338275_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_task_338271            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_task_338271_runs[i],
                    (long) ctx->futhark_mc_segred_task_338271_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_338271_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_338271_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_task_338271_total_runtime[i],
                    (double) ctx->futhark_mc_segred_task_338271_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_338271_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_task_338271_iter[i]),
                    (long) ctx->futhark_mc_segred_task_338271_iter[i],
                    (long) ctx->futhark_mc_segred_task_338271_iter[i] /
                    (ctx->futhark_mc_segred_task_338271_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_338271_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338262         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338262_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338262_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338262_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338262_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338262_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338262_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338262_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338262_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338262_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338262_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338262_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338262_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338262_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338262_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338262_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338262_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338262_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338262_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338262_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338262_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338262_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338262_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338262_total_iter /
                (ctx->futhark_mc_segmap_parloop_338262_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338262_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338262_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338262_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_338257            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_338257_runs[i],
                    (long) ctx->futhark_mc_segmap_task_338257_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338257_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338257_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_338257_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_338257_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338257_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_338257_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_338257_iter[i],
                    (long) ctx->futhark_mc_segmap_task_338257_iter[i] /
                    (ctx->futhark_mc_segmap_task_338257_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338257_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_nested_task_338260     ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_nested_task_338260_runs[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338260_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338260_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338260_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_nested_task_338260_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_nested_task_338260_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338260_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_nested_task_338260_iter[i]),
                    (long) ctx->futhark_mc_segmap_nested_task_338260_iter[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338260_iter[i] /
                    (ctx->futhark_mc_segmap_nested_task_338260_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338260_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338253         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338253_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338253_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338253_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338253_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338253_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338253_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338253_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338253_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338253_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338253_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338253_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338253_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338253_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338253_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338253_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338253_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338253_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338253_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338253_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338253_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338253_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338253_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338253_total_iter /
                (ctx->futhark_mc_segmap_parloop_338253_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338253_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338253_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338253_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_338246            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_338246_runs[i],
                    (long) ctx->futhark_mc_segmap_task_338246_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338246_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338246_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_338246_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_338246_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338246_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_338246_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_338246_iter[i],
                    (long) ctx->futhark_mc_segmap_task_338246_iter[i] /
                    (ctx->futhark_mc_segmap_task_338246_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338246_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_nested_task_338251     ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_nested_task_338251_runs[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338251_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338251_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338251_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_nested_task_338251_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_nested_task_338251_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338251_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_nested_task_338251_iter[i]),
                    (long) ctx->futhark_mc_segmap_nested_task_338251_iter[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338251_iter[i] /
                    (ctx->futhark_mc_segmap_nested_task_338251_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338251_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338242         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338242_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338242_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338242_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338242_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338242_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338242_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338242_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338242_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338242_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338242_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338242_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338242_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338242_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338242_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338242_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338242_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338242_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338242_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338242_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338242_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338242_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338242_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338242_total_iter /
                (ctx->futhark_mc_segmap_parloop_338242_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338242_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338242_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338242_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_338235            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_338235_runs[i],
                    (long) ctx->futhark_mc_segmap_task_338235_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338235_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338235_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_338235_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_338235_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338235_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_338235_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_338235_iter[i],
                    (long) ctx->futhark_mc_segmap_task_338235_iter[i] /
                    (ctx->futhark_mc_segmap_task_338235_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338235_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_nested_task_338240     ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_nested_task_338240_runs[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338240_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338240_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338240_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_nested_task_338240_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_nested_task_338240_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338240_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_nested_task_338240_iter[i]),
                    (long) ctx->futhark_mc_segmap_nested_task_338240_iter[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338240_iter[i] /
                    (ctx->futhark_mc_segmap_nested_task_338240_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338240_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338279         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338279_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338279_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338279_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338279_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338279_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338279_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338279_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338279_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338279_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338279_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338279_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338279_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338279_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338279_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338279_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338279_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338279_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338279_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338279_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338279_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338279_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338279_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338279_total_iter /
                (ctx->futhark_mc_segmap_parloop_338279_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338279_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338279_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338279_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338290         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338290_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338290_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338290_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338290_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338290_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338290_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338290_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338290_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338290_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338290_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338290_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338290_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338290_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338290_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338290_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338290_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338290_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338290_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338290_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338290_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338290_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338290_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338290_total_iter /
                (ctx->futhark_mc_segmap_parloop_338290_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338290_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338290_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338290_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338301         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338301_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338301_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338301_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338301_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338301_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338301_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338301_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338301_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338301_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338301_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338301_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338301_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338301_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338301_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338301_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338301_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338301_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338301_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338301_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338301_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338301_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338301_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338301_total_iter /
                (ctx->futhark_mc_segmap_parloop_338301_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338301_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338301_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338301_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_stage_1_parloop_338313 ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_stage_1_parloop_338313_runs[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338313_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338313_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_338313_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338313_total_runtime[i],
                    (double) ctx->futhark_mc_segred_stage_1_parloop_338313_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338313_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_338313_iter[i]),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338313_iter[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338313_iter[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338313_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_338313_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segred_stage_1_parloop_338313_total ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segred_stage_1_parloop_338313_total_runs,
                (long) ctx->futhark_mc_segred_stage_1_parloop_338313_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_338313_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_338313_total_runs : 1),
                (long) ctx->futhark_mc_segred_stage_1_parloop_338313_total_total_runtime,
                (double) ctx->futhark_mc_segred_stage_1_parloop_338313_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_338313_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_338313_total_iter),
                (long) ctx->futhark_mc_segred_stage_1_parloop_338313_total_iter,
                (long) ctx->futhark_mc_segred_stage_1_parloop_338313_total_iter /
                (ctx->futhark_mc_segred_stage_1_parloop_338313_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_338313_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segred_stage_1_parloop_338313_total_total_runtime;
        ctx->total_runs +=
            ctx->futhark_mc_segred_stage_1_parloop_338313_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_task_338306            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_task_338306_runs[i],
                    (long) ctx->futhark_mc_segred_task_338306_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_338306_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_338306_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_task_338306_total_runtime[i],
                    (double) ctx->futhark_mc_segred_task_338306_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_338306_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_task_338306_iter[i]),
                    (long) ctx->futhark_mc_segred_task_338306_iter[i],
                    (long) ctx->futhark_mc_segred_task_338306_iter[i] /
                    (ctx->futhark_mc_segred_task_338306_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_338306_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_stage_1_parloop_338319 ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_stage_1_parloop_338319_runs[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338319_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338319_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_338319_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338319_total_runtime[i],
                    (double) ctx->futhark_mc_segred_stage_1_parloop_338319_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338319_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_338319_iter[i]),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338319_iter[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338319_iter[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338319_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_338319_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segred_stage_1_parloop_338319_total ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segred_stage_1_parloop_338319_total_runs,
                (long) ctx->futhark_mc_segred_stage_1_parloop_338319_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_338319_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_338319_total_runs : 1),
                (long) ctx->futhark_mc_segred_stage_1_parloop_338319_total_total_runtime,
                (double) ctx->futhark_mc_segred_stage_1_parloop_338319_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_338319_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_338319_total_iter),
                (long) ctx->futhark_mc_segred_stage_1_parloop_338319_total_iter,
                (long) ctx->futhark_mc_segred_stage_1_parloop_338319_total_iter /
                (ctx->futhark_mc_segred_stage_1_parloop_338319_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_338319_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segred_stage_1_parloop_338319_total_total_runtime;
        ctx->total_runs +=
            ctx->futhark_mc_segred_stage_1_parloop_338319_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_task_338315            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_task_338315_runs[i],
                    (long) ctx->futhark_mc_segred_task_338315_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_338315_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_338315_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_task_338315_total_runtime[i],
                    (double) ctx->futhark_mc_segred_task_338315_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_338315_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_task_338315_iter[i]),
                    (long) ctx->futhark_mc_segred_task_338315_iter[i],
                    (long) ctx->futhark_mc_segred_task_338315_iter[i] /
                    (ctx->futhark_mc_segred_task_338315_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_338315_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338304         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338304_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338304_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338304_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338304_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338304_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338304_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338304_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338304_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338304_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338304_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338304_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338304_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338304_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338304_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338304_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338304_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338304_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338304_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338304_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338304_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338304_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338304_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338304_total_iter /
                (ctx->futhark_mc_segmap_parloop_338304_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338304_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338304_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338304_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_338299            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_338299_runs[i],
                    (long) ctx->futhark_mc_segmap_task_338299_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338299_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338299_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_338299_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_338299_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338299_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_338299_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_338299_iter[i],
                    (long) ctx->futhark_mc_segmap_task_338299_iter[i] /
                    (ctx->futhark_mc_segmap_task_338299_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338299_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_nested_task_338302     ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_nested_task_338302_runs[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338302_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338302_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338302_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_nested_task_338302_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_nested_task_338302_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338302_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_nested_task_338302_iter[i]),
                    (long) ctx->futhark_mc_segmap_nested_task_338302_iter[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338302_iter[i] /
                    (ctx->futhark_mc_segmap_nested_task_338302_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338302_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338295         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338295_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338295_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338295_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338295_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338295_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338295_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338295_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338295_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338295_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338295_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338295_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338295_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338295_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338295_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338295_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338295_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338295_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338295_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338295_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338295_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338295_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338295_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338295_total_iter /
                (ctx->futhark_mc_segmap_parloop_338295_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338295_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338295_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338295_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_338288            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_338288_runs[i],
                    (long) ctx->futhark_mc_segmap_task_338288_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338288_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338288_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_338288_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_338288_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338288_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_338288_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_338288_iter[i],
                    (long) ctx->futhark_mc_segmap_task_338288_iter[i] /
                    (ctx->futhark_mc_segmap_task_338288_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338288_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_nested_task_338293     ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_nested_task_338293_runs[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338293_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338293_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338293_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_nested_task_338293_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_nested_task_338293_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338293_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_nested_task_338293_iter[i]),
                    (long) ctx->futhark_mc_segmap_nested_task_338293_iter[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338293_iter[i] /
                    (ctx->futhark_mc_segmap_nested_task_338293_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338293_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338284         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338284_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338284_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338284_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338284_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338284_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338284_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338284_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338284_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338284_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338284_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338284_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338284_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338284_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338284_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338284_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338284_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338284_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338284_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338284_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338284_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338284_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338284_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338284_total_iter /
                (ctx->futhark_mc_segmap_parloop_338284_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338284_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338284_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338284_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_338277            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_338277_runs[i],
                    (long) ctx->futhark_mc_segmap_task_338277_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338277_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338277_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_338277_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_338277_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338277_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_338277_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_338277_iter[i],
                    (long) ctx->futhark_mc_segmap_task_338277_iter[i] /
                    (ctx->futhark_mc_segmap_task_338277_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338277_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_nested_task_338282     ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_nested_task_338282_runs[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338282_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338282_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338282_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_nested_task_338282_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_nested_task_338282_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338282_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_nested_task_338282_iter[i]),
                    (long) ctx->futhark_mc_segmap_nested_task_338282_iter[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338282_iter[i] /
                    (ctx->futhark_mc_segmap_nested_task_338282_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338282_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338323         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338323_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338323_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338323_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338323_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338323_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338323_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338323_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338323_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338323_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338323_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338323_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338323_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338323_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338323_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338323_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338323_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338323_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338323_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338323_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338323_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338323_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338323_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338323_total_iter /
                (ctx->futhark_mc_segmap_parloop_338323_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338323_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338323_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338323_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338332         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338332_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338332_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338332_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338332_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338332_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338332_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338332_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338332_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338332_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338332_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338332_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338332_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338332_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338332_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338332_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338332_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338332_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338332_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338332_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338332_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338332_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338332_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338332_total_iter /
                (ctx->futhark_mc_segmap_parloop_338332_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338332_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338332_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338332_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338341         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338341_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338341_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338341_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338341_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338341_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338341_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338341_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338341_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338341_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338341_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338341_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338341_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338341_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338341_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338341_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338341_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338341_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338341_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338341_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338341_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338341_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338341_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338341_total_iter /
                (ctx->futhark_mc_segmap_parloop_338341_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338341_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338341_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338341_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_338339            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_338339_runs[i],
                    (long) ctx->futhark_mc_segmap_task_338339_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338339_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338339_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_338339_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_338339_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338339_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_338339_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_338339_iter[i],
                    (long) ctx->futhark_mc_segmap_task_338339_iter[i] /
                    (ctx->futhark_mc_segmap_task_338339_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338339_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338336         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338336_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338336_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338336_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338336_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338336_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338336_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338336_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338336_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338336_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338336_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338336_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338336_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338336_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338336_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338336_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338336_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338336_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338336_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338336_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338336_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338336_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338336_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338336_total_iter /
                (ctx->futhark_mc_segmap_parloop_338336_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338336_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338336_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338336_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_338330            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_338330_runs[i],
                    (long) ctx->futhark_mc_segmap_task_338330_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338330_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338330_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_338330_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_338330_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338330_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_338330_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_338330_iter[i],
                    (long) ctx->futhark_mc_segmap_task_338330_iter[i] /
                    (ctx->futhark_mc_segmap_task_338330_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338330_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_nested_task_338334     ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_nested_task_338334_runs[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338334_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338334_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338334_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_nested_task_338334_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_nested_task_338334_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338334_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_nested_task_338334_iter[i]),
                    (long) ctx->futhark_mc_segmap_nested_task_338334_iter[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338334_iter[i] /
                    (ctx->futhark_mc_segmap_nested_task_338334_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338334_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338327         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338327_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338327_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338327_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338327_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338327_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338327_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338327_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338327_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338327_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338327_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338327_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338327_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338327_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338327_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338327_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338327_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338327_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338327_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338327_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338327_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338327_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338327_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338327_total_iter /
                (ctx->futhark_mc_segmap_parloop_338327_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338327_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338327_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338327_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_338321            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_338321_runs[i],
                    (long) ctx->futhark_mc_segmap_task_338321_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338321_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338321_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_338321_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_338321_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338321_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_338321_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_338321_iter[i],
                    (long) ctx->futhark_mc_segmap_task_338321_iter[i] /
                    (ctx->futhark_mc_segmap_task_338321_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338321_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_nested_task_338325     ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_nested_task_338325_runs[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338325_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338325_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338325_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_nested_task_338325_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_nested_task_338325_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338325_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_nested_task_338325_iter[i]),
                    (long) ctx->futhark_mc_segmap_nested_task_338325_iter[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338325_iter[i] /
                    (ctx->futhark_mc_segmap_nested_task_338325_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338325_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338345         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338345_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338345_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338345_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338345_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338345_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338345_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338345_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338345_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338345_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338345_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338345_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338345_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338345_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338345_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338345_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338345_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338345_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338345_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338345_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338345_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338345_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338345_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338345_total_iter /
                (ctx->futhark_mc_segmap_parloop_338345_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338345_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338345_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338345_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338354         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338354_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338354_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338354_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338354_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338354_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338354_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338354_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338354_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338354_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338354_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338354_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338354_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338354_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338354_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338354_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338354_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338354_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338354_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338354_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338354_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338354_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338354_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338354_total_iter /
                (ctx->futhark_mc_segmap_parloop_338354_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338354_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338354_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338354_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_338352            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_338352_runs[i],
                    (long) ctx->futhark_mc_segmap_task_338352_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338352_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338352_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_338352_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_338352_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338352_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_338352_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_338352_iter[i],
                    (long) ctx->futhark_mc_segmap_task_338352_iter[i] /
                    (ctx->futhark_mc_segmap_task_338352_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338352_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338349         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338349_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338349_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338349_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338349_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338349_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338349_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338349_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338349_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338349_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338349_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338349_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338349_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338349_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338349_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338349_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338349_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338349_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338349_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338349_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338349_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338349_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338349_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338349_total_iter /
                (ctx->futhark_mc_segmap_parloop_338349_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338349_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338349_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338349_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_338343            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_338343_runs[i],
                    (long) ctx->futhark_mc_segmap_task_338343_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338343_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338343_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_338343_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_338343_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338343_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_338343_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_338343_iter[i],
                    (long) ctx->futhark_mc_segmap_task_338343_iter[i] /
                    (ctx->futhark_mc_segmap_task_338343_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338343_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_nested_task_338347     ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_nested_task_338347_runs[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338347_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338347_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338347_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_nested_task_338347_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_nested_task_338347_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338347_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_nested_task_338347_iter[i]),
                    (long) ctx->futhark_mc_segmap_nested_task_338347_iter[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338347_iter[i] /
                    (ctx->futhark_mc_segmap_nested_task_338347_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338347_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338358         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338358_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338358_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338358_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338358_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338358_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338358_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338358_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338358_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338358_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338358_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338358_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338358_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338358_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338358_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338358_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338358_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338358_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338358_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338358_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338358_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338358_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338358_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338358_total_iter /
                (ctx->futhark_mc_segmap_parloop_338358_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338358_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338358_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338358_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_stage_1_parloop_338366 ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_stage_1_parloop_338366_runs[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338366_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338366_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_338366_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338366_total_runtime[i],
                    (double) ctx->futhark_mc_segred_stage_1_parloop_338366_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338366_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_338366_iter[i]),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338366_iter[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338366_iter[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338366_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_338366_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segred_stage_1_parloop_338366_total ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segred_stage_1_parloop_338366_total_runs,
                (long) ctx->futhark_mc_segred_stage_1_parloop_338366_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_338366_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_338366_total_runs : 1),
                (long) ctx->futhark_mc_segred_stage_1_parloop_338366_total_total_runtime,
                (double) ctx->futhark_mc_segred_stage_1_parloop_338366_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_338366_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_338366_total_iter),
                (long) ctx->futhark_mc_segred_stage_1_parloop_338366_total_iter,
                (long) ctx->futhark_mc_segred_stage_1_parloop_338366_total_iter /
                (ctx->futhark_mc_segred_stage_1_parloop_338366_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_338366_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segred_stage_1_parloop_338366_total_total_runtime;
        ctx->total_runs +=
            ctx->futhark_mc_segred_stage_1_parloop_338366_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_task_338363            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_task_338363_runs[i],
                    (long) ctx->futhark_mc_segred_task_338363_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_338363_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_338363_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_task_338363_total_runtime[i],
                    (double) ctx->futhark_mc_segred_task_338363_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_338363_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_task_338363_iter[i]),
                    (long) ctx->futhark_mc_segred_task_338363_iter[i],
                    (long) ctx->futhark_mc_segred_task_338363_iter[i] /
                    (ctx->futhark_mc_segred_task_338363_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_338363_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338361         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338361_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338361_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338361_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338361_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338361_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338361_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338361_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338361_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338361_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338361_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338361_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338361_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338361_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338361_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338361_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338361_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338361_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338361_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338361_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338361_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338361_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338361_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338361_total_iter /
                (ctx->futhark_mc_segmap_parloop_338361_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338361_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338361_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338361_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_338356            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_338356_runs[i],
                    (long) ctx->futhark_mc_segmap_task_338356_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338356_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338356_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_338356_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_338356_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338356_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_338356_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_338356_iter[i],
                    (long) ctx->futhark_mc_segmap_task_338356_iter[i] /
                    (ctx->futhark_mc_segmap_task_338356_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338356_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_nested_task_338359     ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_nested_task_338359_runs[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338359_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338359_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338359_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_nested_task_338359_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_nested_task_338359_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338359_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_nested_task_338359_iter[i]),
                    (long) ctx->futhark_mc_segmap_nested_task_338359_iter[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338359_iter[i] /
                    (ctx->futhark_mc_segmap_nested_task_338359_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338359_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338370         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338370_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338370_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338370_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338370_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338370_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338370_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338370_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338370_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338370_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338370_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338370_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338370_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338370_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338370_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338370_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338370_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338370_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338370_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338370_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338370_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338370_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338370_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338370_total_iter /
                (ctx->futhark_mc_segmap_parloop_338370_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338370_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338370_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338370_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_scan_stage_1_parloop_338380   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_scan_stage_1_parloop_338380_runs[i],
                    (long) ctx->futhark_mc_scan_stage_1_parloop_338380_total_runtime[i] /
                    (ctx->futhark_mc_scan_stage_1_parloop_338380_runs[i] !=
                     0 ? ctx->futhark_mc_scan_stage_1_parloop_338380_runs[i] : 1),
                    (long) ctx->futhark_mc_scan_stage_1_parloop_338380_total_runtime[i],
                    (double) ctx->futhark_mc_scan_stage_1_parloop_338380_total_runtime[i] /
                    (ctx->futhark_mc_scan_stage_1_parloop_338380_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_scan_stage_1_parloop_338380_iter[i]),
                    (long) ctx->futhark_mc_scan_stage_1_parloop_338380_iter[i],
                    (long) ctx->futhark_mc_scan_stage_1_parloop_338380_iter[i] /
                    (ctx->futhark_mc_scan_stage_1_parloop_338380_runs[i] !=
                     0 ? ctx->futhark_mc_scan_stage_1_parloop_338380_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_scan_stage_1_parloop_338380_total ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_scan_stage_1_parloop_338380_total_runs,
                (long) ctx->futhark_mc_scan_stage_1_parloop_338380_total_total_runtime /
                (ctx->futhark_mc_scan_stage_1_parloop_338380_total_runs !=
                 0 ? ctx->futhark_mc_scan_stage_1_parloop_338380_total_runs : 1),
                (long) ctx->futhark_mc_scan_stage_1_parloop_338380_total_total_runtime,
                (double) ctx->futhark_mc_scan_stage_1_parloop_338380_total_total_runtime /
                (ctx->futhark_mc_scan_stage_1_parloop_338380_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_scan_stage_1_parloop_338380_total_iter),
                (long) ctx->futhark_mc_scan_stage_1_parloop_338380_total_iter,
                (long) ctx->futhark_mc_scan_stage_1_parloop_338380_total_iter /
                (ctx->futhark_mc_scan_stage_1_parloop_338380_total_runs !=
                 0 ? ctx->futhark_mc_scan_stage_1_parloop_338380_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_scan_stage_1_parloop_338380_total_total_runtime;
        ctx->total_runs +=
            ctx->futhark_mc_scan_stage_1_parloop_338380_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_scan_stage_3_parloop_338382   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_scan_stage_3_parloop_338382_runs[i],
                    (long) ctx->futhark_mc_scan_stage_3_parloop_338382_total_runtime[i] /
                    (ctx->futhark_mc_scan_stage_3_parloop_338382_runs[i] !=
                     0 ? ctx->futhark_mc_scan_stage_3_parloop_338382_runs[i] : 1),
                    (long) ctx->futhark_mc_scan_stage_3_parloop_338382_total_runtime[i],
                    (double) ctx->futhark_mc_scan_stage_3_parloop_338382_total_runtime[i] /
                    (ctx->futhark_mc_scan_stage_3_parloop_338382_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_scan_stage_3_parloop_338382_iter[i]),
                    (long) ctx->futhark_mc_scan_stage_3_parloop_338382_iter[i],
                    (long) ctx->futhark_mc_scan_stage_3_parloop_338382_iter[i] /
                    (ctx->futhark_mc_scan_stage_3_parloop_338382_runs[i] !=
                     0 ? ctx->futhark_mc_scan_stage_3_parloop_338382_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_scan_stage_3_parloop_338382_total ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_scan_stage_3_parloop_338382_total_runs,
                (long) ctx->futhark_mc_scan_stage_3_parloop_338382_total_total_runtime /
                (ctx->futhark_mc_scan_stage_3_parloop_338382_total_runs !=
                 0 ? ctx->futhark_mc_scan_stage_3_parloop_338382_total_runs : 1),
                (long) ctx->futhark_mc_scan_stage_3_parloop_338382_total_total_runtime,
                (double) ctx->futhark_mc_scan_stage_3_parloop_338382_total_total_runtime /
                (ctx->futhark_mc_scan_stage_3_parloop_338382_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_scan_stage_3_parloop_338382_total_iter),
                (long) ctx->futhark_mc_scan_stage_3_parloop_338382_total_iter,
                (long) ctx->futhark_mc_scan_stage_3_parloop_338382_total_iter /
                (ctx->futhark_mc_scan_stage_3_parloop_338382_total_runs !=
                 0 ? ctx->futhark_mc_scan_stage_3_parloop_338382_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_scan_stage_3_parloop_338382_total_total_runtime;
        ctx->total_runs +=
            ctx->futhark_mc_scan_stage_3_parloop_338382_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segscan_task_338377           ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segscan_task_338377_runs[i],
                    (long) ctx->futhark_mc_segscan_task_338377_total_runtime[i] /
                    (ctx->futhark_mc_segscan_task_338377_runs[i] !=
                     0 ? ctx->futhark_mc_segscan_task_338377_runs[i] : 1),
                    (long) ctx->futhark_mc_segscan_task_338377_total_runtime[i],
                    (double) ctx->futhark_mc_segscan_task_338377_total_runtime[i] /
                    (ctx->futhark_mc_segscan_task_338377_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segscan_task_338377_iter[i]),
                    (long) ctx->futhark_mc_segscan_task_338377_iter[i],
                    (long) ctx->futhark_mc_segscan_task_338377_iter[i] /
                    (ctx->futhark_mc_segscan_task_338377_runs[i] !=
                     0 ? ctx->futhark_mc_segscan_task_338377_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338374         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338374_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338374_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338374_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338374_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338374_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338374_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338374_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338374_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338374_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338374_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338374_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338374_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338374_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338374_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338374_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338374_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338374_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338374_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338374_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338374_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338374_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338374_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338374_total_iter /
                (ctx->futhark_mc_segmap_parloop_338374_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338374_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338374_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338374_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_338368            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_338368_runs[i],
                    (long) ctx->futhark_mc_segmap_task_338368_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338368_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338368_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_338368_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_338368_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338368_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_338368_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_338368_iter[i],
                    (long) ctx->futhark_mc_segmap_task_338368_iter[i] /
                    (ctx->futhark_mc_segmap_task_338368_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338368_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_nested_task_338372     ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_nested_task_338372_runs[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338372_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338372_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338372_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_nested_task_338372_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_nested_task_338372_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338372_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_nested_task_338372_iter[i]),
                    (long) ctx->futhark_mc_segmap_nested_task_338372_iter[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338372_iter[i] /
                    (ctx->futhark_mc_segmap_nested_task_338372_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338372_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338386         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338386_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338386_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338386_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338386_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338386_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338386_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338386_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338386_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338386_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338386_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338386_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338386_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338386_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338386_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338386_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338386_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338386_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338386_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338386_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338386_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338386_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338386_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338386_total_iter /
                (ctx->futhark_mc_segmap_parloop_338386_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338386_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338386_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338386_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_stage_1_parloop_338394 ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_stage_1_parloop_338394_runs[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338394_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338394_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_338394_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338394_total_runtime[i],
                    (double) ctx->futhark_mc_segred_stage_1_parloop_338394_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338394_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_338394_iter[i]),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338394_iter[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338394_iter[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338394_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_338394_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segred_stage_1_parloop_338394_total ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segred_stage_1_parloop_338394_total_runs,
                (long) ctx->futhark_mc_segred_stage_1_parloop_338394_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_338394_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_338394_total_runs : 1),
                (long) ctx->futhark_mc_segred_stage_1_parloop_338394_total_total_runtime,
                (double) ctx->futhark_mc_segred_stage_1_parloop_338394_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_338394_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_338394_total_iter),
                (long) ctx->futhark_mc_segred_stage_1_parloop_338394_total_iter,
                (long) ctx->futhark_mc_segred_stage_1_parloop_338394_total_iter /
                (ctx->futhark_mc_segred_stage_1_parloop_338394_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_338394_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segred_stage_1_parloop_338394_total_total_runtime;
        ctx->total_runs +=
            ctx->futhark_mc_segred_stage_1_parloop_338394_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_task_338391            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_task_338391_runs[i],
                    (long) ctx->futhark_mc_segred_task_338391_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_338391_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_338391_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_task_338391_total_runtime[i],
                    (double) ctx->futhark_mc_segred_task_338391_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_338391_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_task_338391_iter[i]),
                    (long) ctx->futhark_mc_segred_task_338391_iter[i],
                    (long) ctx->futhark_mc_segred_task_338391_iter[i] /
                    (ctx->futhark_mc_segred_task_338391_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_338391_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338389         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338389_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338389_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338389_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338389_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338389_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338389_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338389_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338389_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338389_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338389_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338389_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338389_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338389_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338389_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338389_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338389_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338389_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338389_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338389_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338389_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338389_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338389_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338389_total_iter /
                (ctx->futhark_mc_segmap_parloop_338389_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338389_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338389_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338389_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_338384            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_338384_runs[i],
                    (long) ctx->futhark_mc_segmap_task_338384_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338384_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338384_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_338384_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_338384_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338384_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_338384_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_338384_iter[i],
                    (long) ctx->futhark_mc_segmap_task_338384_iter[i] /
                    (ctx->futhark_mc_segmap_task_338384_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338384_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_nested_task_338387     ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_nested_task_338387_runs[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338387_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338387_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338387_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_nested_task_338387_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_nested_task_338387_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338387_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_nested_task_338387_iter[i]),
                    (long) ctx->futhark_mc_segmap_nested_task_338387_iter[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338387_iter[i] /
                    (ctx->futhark_mc_segmap_nested_task_338387_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338387_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338398         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338398_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338398_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338398_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338398_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338398_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338398_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338398_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338398_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338398_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338398_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338398_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338398_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338398_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338398_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338398_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338398_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338398_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338398_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338398_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338398_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338398_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338398_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338398_total_iter /
                (ctx->futhark_mc_segmap_parloop_338398_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338398_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338398_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338398_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_scan_stage_1_parloop_338408   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_scan_stage_1_parloop_338408_runs[i],
                    (long) ctx->futhark_mc_scan_stage_1_parloop_338408_total_runtime[i] /
                    (ctx->futhark_mc_scan_stage_1_parloop_338408_runs[i] !=
                     0 ? ctx->futhark_mc_scan_stage_1_parloop_338408_runs[i] : 1),
                    (long) ctx->futhark_mc_scan_stage_1_parloop_338408_total_runtime[i],
                    (double) ctx->futhark_mc_scan_stage_1_parloop_338408_total_runtime[i] /
                    (ctx->futhark_mc_scan_stage_1_parloop_338408_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_scan_stage_1_parloop_338408_iter[i]),
                    (long) ctx->futhark_mc_scan_stage_1_parloop_338408_iter[i],
                    (long) ctx->futhark_mc_scan_stage_1_parloop_338408_iter[i] /
                    (ctx->futhark_mc_scan_stage_1_parloop_338408_runs[i] !=
                     0 ? ctx->futhark_mc_scan_stage_1_parloop_338408_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_scan_stage_1_parloop_338408_total ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_scan_stage_1_parloop_338408_total_runs,
                (long) ctx->futhark_mc_scan_stage_1_parloop_338408_total_total_runtime /
                (ctx->futhark_mc_scan_stage_1_parloop_338408_total_runs !=
                 0 ? ctx->futhark_mc_scan_stage_1_parloop_338408_total_runs : 1),
                (long) ctx->futhark_mc_scan_stage_1_parloop_338408_total_total_runtime,
                (double) ctx->futhark_mc_scan_stage_1_parloop_338408_total_total_runtime /
                (ctx->futhark_mc_scan_stage_1_parloop_338408_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_scan_stage_1_parloop_338408_total_iter),
                (long) ctx->futhark_mc_scan_stage_1_parloop_338408_total_iter,
                (long) ctx->futhark_mc_scan_stage_1_parloop_338408_total_iter /
                (ctx->futhark_mc_scan_stage_1_parloop_338408_total_runs !=
                 0 ? ctx->futhark_mc_scan_stage_1_parloop_338408_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_scan_stage_1_parloop_338408_total_total_runtime;
        ctx->total_runs +=
            ctx->futhark_mc_scan_stage_1_parloop_338408_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_scan_stage_3_parloop_338410   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_scan_stage_3_parloop_338410_runs[i],
                    (long) ctx->futhark_mc_scan_stage_3_parloop_338410_total_runtime[i] /
                    (ctx->futhark_mc_scan_stage_3_parloop_338410_runs[i] !=
                     0 ? ctx->futhark_mc_scan_stage_3_parloop_338410_runs[i] : 1),
                    (long) ctx->futhark_mc_scan_stage_3_parloop_338410_total_runtime[i],
                    (double) ctx->futhark_mc_scan_stage_3_parloop_338410_total_runtime[i] /
                    (ctx->futhark_mc_scan_stage_3_parloop_338410_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_scan_stage_3_parloop_338410_iter[i]),
                    (long) ctx->futhark_mc_scan_stage_3_parloop_338410_iter[i],
                    (long) ctx->futhark_mc_scan_stage_3_parloop_338410_iter[i] /
                    (ctx->futhark_mc_scan_stage_3_parloop_338410_runs[i] !=
                     0 ? ctx->futhark_mc_scan_stage_3_parloop_338410_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_scan_stage_3_parloop_338410_total ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_scan_stage_3_parloop_338410_total_runs,
                (long) ctx->futhark_mc_scan_stage_3_parloop_338410_total_total_runtime /
                (ctx->futhark_mc_scan_stage_3_parloop_338410_total_runs !=
                 0 ? ctx->futhark_mc_scan_stage_3_parloop_338410_total_runs : 1),
                (long) ctx->futhark_mc_scan_stage_3_parloop_338410_total_total_runtime,
                (double) ctx->futhark_mc_scan_stage_3_parloop_338410_total_total_runtime /
                (ctx->futhark_mc_scan_stage_3_parloop_338410_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_scan_stage_3_parloop_338410_total_iter),
                (long) ctx->futhark_mc_scan_stage_3_parloop_338410_total_iter,
                (long) ctx->futhark_mc_scan_stage_3_parloop_338410_total_iter /
                (ctx->futhark_mc_scan_stage_3_parloop_338410_total_runs !=
                 0 ? ctx->futhark_mc_scan_stage_3_parloop_338410_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_scan_stage_3_parloop_338410_total_total_runtime;
        ctx->total_runs +=
            ctx->futhark_mc_scan_stage_3_parloop_338410_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segscan_task_338405           ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segscan_task_338405_runs[i],
                    (long) ctx->futhark_mc_segscan_task_338405_total_runtime[i] /
                    (ctx->futhark_mc_segscan_task_338405_runs[i] !=
                     0 ? ctx->futhark_mc_segscan_task_338405_runs[i] : 1),
                    (long) ctx->futhark_mc_segscan_task_338405_total_runtime[i],
                    (double) ctx->futhark_mc_segscan_task_338405_total_runtime[i] /
                    (ctx->futhark_mc_segscan_task_338405_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segscan_task_338405_iter[i]),
                    (long) ctx->futhark_mc_segscan_task_338405_iter[i],
                    (long) ctx->futhark_mc_segscan_task_338405_iter[i] /
                    (ctx->futhark_mc_segscan_task_338405_runs[i] !=
                     0 ? ctx->futhark_mc_segscan_task_338405_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338402         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338402_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338402_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338402_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338402_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338402_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338402_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338402_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338402_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338402_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338402_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338402_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338402_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338402_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338402_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338402_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338402_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338402_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338402_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338402_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338402_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338402_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338402_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338402_total_iter /
                (ctx->futhark_mc_segmap_parloop_338402_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338402_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338402_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338402_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_338396            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_338396_runs[i],
                    (long) ctx->futhark_mc_segmap_task_338396_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338396_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338396_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_338396_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_338396_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338396_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_338396_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_338396_iter[i],
                    (long) ctx->futhark_mc_segmap_task_338396_iter[i] /
                    (ctx->futhark_mc_segmap_task_338396_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338396_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_nested_task_338400     ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_nested_task_338400_runs[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338400_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338400_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338400_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_nested_task_338400_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_nested_task_338400_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338400_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_nested_task_338400_iter[i]),
                    (long) ctx->futhark_mc_segmap_nested_task_338400_iter[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338400_iter[i] /
                    (ctx->futhark_mc_segmap_nested_task_338400_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338400_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338414         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338414_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338414_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338414_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338414_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338414_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338414_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338414_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338414_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338414_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338414_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338414_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338414_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338414_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338414_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338414_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338414_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338414_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338414_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338414_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338414_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338414_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338414_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338414_total_iter /
                (ctx->futhark_mc_segmap_parloop_338414_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338414_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338414_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338414_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_stage_1_parloop_338422 ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_stage_1_parloop_338422_runs[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338422_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338422_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_338422_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338422_total_runtime[i],
                    (double) ctx->futhark_mc_segred_stage_1_parloop_338422_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338422_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_338422_iter[i]),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338422_iter[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338422_iter[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338422_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_338422_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segred_stage_1_parloop_338422_total ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segred_stage_1_parloop_338422_total_runs,
                (long) ctx->futhark_mc_segred_stage_1_parloop_338422_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_338422_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_338422_total_runs : 1),
                (long) ctx->futhark_mc_segred_stage_1_parloop_338422_total_total_runtime,
                (double) ctx->futhark_mc_segred_stage_1_parloop_338422_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_338422_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_338422_total_iter),
                (long) ctx->futhark_mc_segred_stage_1_parloop_338422_total_iter,
                (long) ctx->futhark_mc_segred_stage_1_parloop_338422_total_iter /
                (ctx->futhark_mc_segred_stage_1_parloop_338422_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_338422_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segred_stage_1_parloop_338422_total_total_runtime;
        ctx->total_runs +=
            ctx->futhark_mc_segred_stage_1_parloop_338422_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_task_338419            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_task_338419_runs[i],
                    (long) ctx->futhark_mc_segred_task_338419_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_338419_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_338419_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_task_338419_total_runtime[i],
                    (double) ctx->futhark_mc_segred_task_338419_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_338419_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_task_338419_iter[i]),
                    (long) ctx->futhark_mc_segred_task_338419_iter[i],
                    (long) ctx->futhark_mc_segred_task_338419_iter[i] /
                    (ctx->futhark_mc_segred_task_338419_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_338419_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338417         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338417_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338417_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338417_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338417_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338417_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338417_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338417_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338417_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338417_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338417_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338417_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338417_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338417_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338417_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338417_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338417_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338417_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338417_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338417_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338417_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338417_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338417_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338417_total_iter /
                (ctx->futhark_mc_segmap_parloop_338417_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338417_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338417_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338417_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_338412            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_338412_runs[i],
                    (long) ctx->futhark_mc_segmap_task_338412_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338412_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338412_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_338412_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_338412_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338412_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_338412_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_338412_iter[i],
                    (long) ctx->futhark_mc_segmap_task_338412_iter[i] /
                    (ctx->futhark_mc_segmap_task_338412_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338412_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_nested_task_338415     ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_nested_task_338415_runs[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338415_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338415_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338415_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_nested_task_338415_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_nested_task_338415_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338415_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_nested_task_338415_iter[i]),
                    (long) ctx->futhark_mc_segmap_nested_task_338415_iter[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338415_iter[i] /
                    (ctx->futhark_mc_segmap_nested_task_338415_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338415_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338426         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338426_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338426_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338426_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338426_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338426_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338426_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338426_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338426_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338426_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338426_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338426_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338426_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338426_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338426_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338426_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338426_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338426_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338426_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338426_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338426_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338426_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338426_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338426_total_iter /
                (ctx->futhark_mc_segmap_parloop_338426_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338426_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338426_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338426_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_scan_stage_1_parloop_338436   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_scan_stage_1_parloop_338436_runs[i],
                    (long) ctx->futhark_mc_scan_stage_1_parloop_338436_total_runtime[i] /
                    (ctx->futhark_mc_scan_stage_1_parloop_338436_runs[i] !=
                     0 ? ctx->futhark_mc_scan_stage_1_parloop_338436_runs[i] : 1),
                    (long) ctx->futhark_mc_scan_stage_1_parloop_338436_total_runtime[i],
                    (double) ctx->futhark_mc_scan_stage_1_parloop_338436_total_runtime[i] /
                    (ctx->futhark_mc_scan_stage_1_parloop_338436_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_scan_stage_1_parloop_338436_iter[i]),
                    (long) ctx->futhark_mc_scan_stage_1_parloop_338436_iter[i],
                    (long) ctx->futhark_mc_scan_stage_1_parloop_338436_iter[i] /
                    (ctx->futhark_mc_scan_stage_1_parloop_338436_runs[i] !=
                     0 ? ctx->futhark_mc_scan_stage_1_parloop_338436_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_scan_stage_1_parloop_338436_total ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_scan_stage_1_parloop_338436_total_runs,
                (long) ctx->futhark_mc_scan_stage_1_parloop_338436_total_total_runtime /
                (ctx->futhark_mc_scan_stage_1_parloop_338436_total_runs !=
                 0 ? ctx->futhark_mc_scan_stage_1_parloop_338436_total_runs : 1),
                (long) ctx->futhark_mc_scan_stage_1_parloop_338436_total_total_runtime,
                (double) ctx->futhark_mc_scan_stage_1_parloop_338436_total_total_runtime /
                (ctx->futhark_mc_scan_stage_1_parloop_338436_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_scan_stage_1_parloop_338436_total_iter),
                (long) ctx->futhark_mc_scan_stage_1_parloop_338436_total_iter,
                (long) ctx->futhark_mc_scan_stage_1_parloop_338436_total_iter /
                (ctx->futhark_mc_scan_stage_1_parloop_338436_total_runs !=
                 0 ? ctx->futhark_mc_scan_stage_1_parloop_338436_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_scan_stage_1_parloop_338436_total_total_runtime;
        ctx->total_runs +=
            ctx->futhark_mc_scan_stage_1_parloop_338436_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_scan_stage_3_parloop_338438   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_scan_stage_3_parloop_338438_runs[i],
                    (long) ctx->futhark_mc_scan_stage_3_parloop_338438_total_runtime[i] /
                    (ctx->futhark_mc_scan_stage_3_parloop_338438_runs[i] !=
                     0 ? ctx->futhark_mc_scan_stage_3_parloop_338438_runs[i] : 1),
                    (long) ctx->futhark_mc_scan_stage_3_parloop_338438_total_runtime[i],
                    (double) ctx->futhark_mc_scan_stage_3_parloop_338438_total_runtime[i] /
                    (ctx->futhark_mc_scan_stage_3_parloop_338438_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_scan_stage_3_parloop_338438_iter[i]),
                    (long) ctx->futhark_mc_scan_stage_3_parloop_338438_iter[i],
                    (long) ctx->futhark_mc_scan_stage_3_parloop_338438_iter[i] /
                    (ctx->futhark_mc_scan_stage_3_parloop_338438_runs[i] !=
                     0 ? ctx->futhark_mc_scan_stage_3_parloop_338438_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_scan_stage_3_parloop_338438_total ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_scan_stage_3_parloop_338438_total_runs,
                (long) ctx->futhark_mc_scan_stage_3_parloop_338438_total_total_runtime /
                (ctx->futhark_mc_scan_stage_3_parloop_338438_total_runs !=
                 0 ? ctx->futhark_mc_scan_stage_3_parloop_338438_total_runs : 1),
                (long) ctx->futhark_mc_scan_stage_3_parloop_338438_total_total_runtime,
                (double) ctx->futhark_mc_scan_stage_3_parloop_338438_total_total_runtime /
                (ctx->futhark_mc_scan_stage_3_parloop_338438_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_scan_stage_3_parloop_338438_total_iter),
                (long) ctx->futhark_mc_scan_stage_3_parloop_338438_total_iter,
                (long) ctx->futhark_mc_scan_stage_3_parloop_338438_total_iter /
                (ctx->futhark_mc_scan_stage_3_parloop_338438_total_runs !=
                 0 ? ctx->futhark_mc_scan_stage_3_parloop_338438_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_scan_stage_3_parloop_338438_total_total_runtime;
        ctx->total_runs +=
            ctx->futhark_mc_scan_stage_3_parloop_338438_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segscan_task_338433           ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segscan_task_338433_runs[i],
                    (long) ctx->futhark_mc_segscan_task_338433_total_runtime[i] /
                    (ctx->futhark_mc_segscan_task_338433_runs[i] !=
                     0 ? ctx->futhark_mc_segscan_task_338433_runs[i] : 1),
                    (long) ctx->futhark_mc_segscan_task_338433_total_runtime[i],
                    (double) ctx->futhark_mc_segscan_task_338433_total_runtime[i] /
                    (ctx->futhark_mc_segscan_task_338433_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segscan_task_338433_iter[i]),
                    (long) ctx->futhark_mc_segscan_task_338433_iter[i],
                    (long) ctx->futhark_mc_segscan_task_338433_iter[i] /
                    (ctx->futhark_mc_segscan_task_338433_runs[i] !=
                     0 ? ctx->futhark_mc_segscan_task_338433_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338430         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338430_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338430_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338430_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338430_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338430_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338430_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338430_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338430_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338430_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338430_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338430_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338430_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338430_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338430_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338430_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338430_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338430_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338430_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338430_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338430_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338430_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338430_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338430_total_iter /
                (ctx->futhark_mc_segmap_parloop_338430_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338430_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338430_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338430_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_338424            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_338424_runs[i],
                    (long) ctx->futhark_mc_segmap_task_338424_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338424_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338424_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_338424_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_338424_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338424_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_338424_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_338424_iter[i],
                    (long) ctx->futhark_mc_segmap_task_338424_iter[i] /
                    (ctx->futhark_mc_segmap_task_338424_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338424_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_nested_task_338428     ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_nested_task_338428_runs[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338428_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338428_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338428_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_nested_task_338428_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_nested_task_338428_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338428_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_nested_task_338428_iter[i]),
                    (long) ctx->futhark_mc_segmap_nested_task_338428_iter[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338428_iter[i] /
                    (ctx->futhark_mc_segmap_nested_task_338428_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338428_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338442         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338442_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338442_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338442_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338442_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338442_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338442_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338442_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338442_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338442_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338442_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338442_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338442_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338442_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338442_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338442_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338442_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338442_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338442_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338442_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338442_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338442_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338442_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338442_total_iter /
                (ctx->futhark_mc_segmap_parloop_338442_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338442_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338442_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338442_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338451         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338451_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338451_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338451_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338451_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338451_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338451_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338451_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338451_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338451_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338451_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338451_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338451_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338451_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338451_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338451_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338451_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338451_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338451_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338451_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338451_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338451_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338451_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338451_total_iter /
                (ctx->futhark_mc_segmap_parloop_338451_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338451_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338451_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338451_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_stage_1_parloop_338459 ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_stage_1_parloop_338459_runs[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338459_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338459_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_338459_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338459_total_runtime[i],
                    (double) ctx->futhark_mc_segred_stage_1_parloop_338459_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338459_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_338459_iter[i]),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338459_iter[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338459_iter[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338459_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_338459_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segred_stage_1_parloop_338459_total ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segred_stage_1_parloop_338459_total_runs,
                (long) ctx->futhark_mc_segred_stage_1_parloop_338459_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_338459_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_338459_total_runs : 1),
                (long) ctx->futhark_mc_segred_stage_1_parloop_338459_total_total_runtime,
                (double) ctx->futhark_mc_segred_stage_1_parloop_338459_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_338459_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_338459_total_iter),
                (long) ctx->futhark_mc_segred_stage_1_parloop_338459_total_iter,
                (long) ctx->futhark_mc_segred_stage_1_parloop_338459_total_iter /
                (ctx->futhark_mc_segred_stage_1_parloop_338459_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_338459_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segred_stage_1_parloop_338459_total_total_runtime;
        ctx->total_runs +=
            ctx->futhark_mc_segred_stage_1_parloop_338459_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_task_338456            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_task_338456_runs[i],
                    (long) ctx->futhark_mc_segred_task_338456_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_338456_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_338456_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_task_338456_total_runtime[i],
                    (double) ctx->futhark_mc_segred_task_338456_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_338456_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_task_338456_iter[i]),
                    (long) ctx->futhark_mc_segred_task_338456_iter[i],
                    (long) ctx->futhark_mc_segred_task_338456_iter[i] /
                    (ctx->futhark_mc_segred_task_338456_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_338456_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_stage_1_parloop_338464 ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_stage_1_parloop_338464_runs[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338464_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338464_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_338464_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338464_total_runtime[i],
                    (double) ctx->futhark_mc_segred_stage_1_parloop_338464_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338464_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_338464_iter[i]),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338464_iter[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338464_iter[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338464_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_338464_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segred_stage_1_parloop_338464_total ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segred_stage_1_parloop_338464_total_runs,
                (long) ctx->futhark_mc_segred_stage_1_parloop_338464_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_338464_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_338464_total_runs : 1),
                (long) ctx->futhark_mc_segred_stage_1_parloop_338464_total_total_runtime,
                (double) ctx->futhark_mc_segred_stage_1_parloop_338464_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_338464_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_338464_total_iter),
                (long) ctx->futhark_mc_segred_stage_1_parloop_338464_total_iter,
                (long) ctx->futhark_mc_segred_stage_1_parloop_338464_total_iter /
                (ctx->futhark_mc_segred_stage_1_parloop_338464_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_338464_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segred_stage_1_parloop_338464_total_total_runtime;
        ctx->total_runs +=
            ctx->futhark_mc_segred_stage_1_parloop_338464_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_task_338461            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_task_338461_runs[i],
                    (long) ctx->futhark_mc_segred_task_338461_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_338461_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_338461_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_task_338461_total_runtime[i],
                    (double) ctx->futhark_mc_segred_task_338461_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_338461_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_task_338461_iter[i]),
                    (long) ctx->futhark_mc_segred_task_338461_iter[i],
                    (long) ctx->futhark_mc_segred_task_338461_iter[i] /
                    (ctx->futhark_mc_segred_task_338461_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_338461_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338454         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338454_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338454_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338454_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338454_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338454_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338454_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338454_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338454_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338454_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338454_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338454_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338454_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338454_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338454_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338454_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338454_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338454_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338454_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338454_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338454_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338454_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338454_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338454_total_iter /
                (ctx->futhark_mc_segmap_parloop_338454_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338454_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338454_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338454_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_338449            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_338449_runs[i],
                    (long) ctx->futhark_mc_segmap_task_338449_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338449_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338449_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_338449_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_338449_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338449_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_338449_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_338449_iter[i],
                    (long) ctx->futhark_mc_segmap_task_338449_iter[i] /
                    (ctx->futhark_mc_segmap_task_338449_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338449_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_nested_task_338452     ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_nested_task_338452_runs[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338452_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338452_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338452_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_nested_task_338452_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_nested_task_338452_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338452_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_nested_task_338452_iter[i]),
                    (long) ctx->futhark_mc_segmap_nested_task_338452_iter[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338452_iter[i] /
                    (ctx->futhark_mc_segmap_nested_task_338452_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338452_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338446         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338446_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338446_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338446_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338446_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338446_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338446_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338446_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338446_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338446_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338446_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338446_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338446_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338446_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338446_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338446_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338446_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338446_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338446_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338446_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338446_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338446_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338446_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338446_total_iter /
                (ctx->futhark_mc_segmap_parloop_338446_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338446_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338446_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338446_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_338440            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_338440_runs[i],
                    (long) ctx->futhark_mc_segmap_task_338440_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338440_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338440_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_338440_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_338440_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338440_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_338440_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_338440_iter[i],
                    (long) ctx->futhark_mc_segmap_task_338440_iter[i] /
                    (ctx->futhark_mc_segmap_task_338440_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338440_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_nested_task_338444     ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_nested_task_338444_runs[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338444_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338444_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338444_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_nested_task_338444_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_nested_task_338444_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338444_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_nested_task_338444_iter[i]),
                    (long) ctx->futhark_mc_segmap_nested_task_338444_iter[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338444_iter[i] /
                    (ctx->futhark_mc_segmap_nested_task_338444_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338444_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338468         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338468_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338468_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338468_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338468_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338468_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338468_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338468_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338468_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338468_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338468_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338468_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338468_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338468_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338468_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338468_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338468_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338468_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338468_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338468_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338468_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338468_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338468_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338468_total_iter /
                (ctx->futhark_mc_segmap_parloop_338468_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338468_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338468_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338468_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338479         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338479_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338479_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338479_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338479_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338479_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338479_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338479_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338479_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338479_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338479_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338479_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338479_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338479_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338479_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338479_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338479_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338479_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338479_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338479_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338479_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338479_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338479_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338479_total_iter /
                (ctx->futhark_mc_segmap_parloop_338479_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338479_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338479_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338479_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_stage_1_parloop_338489 ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_stage_1_parloop_338489_runs[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338489_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338489_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_338489_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338489_total_runtime[i],
                    (double) ctx->futhark_mc_segred_stage_1_parloop_338489_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338489_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_338489_iter[i]),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338489_iter[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338489_iter[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338489_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_338489_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segred_stage_1_parloop_338489_total ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segred_stage_1_parloop_338489_total_runs,
                (long) ctx->futhark_mc_segred_stage_1_parloop_338489_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_338489_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_338489_total_runs : 1),
                (long) ctx->futhark_mc_segred_stage_1_parloop_338489_total_total_runtime,
                (double) ctx->futhark_mc_segred_stage_1_parloop_338489_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_338489_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_338489_total_iter),
                (long) ctx->futhark_mc_segred_stage_1_parloop_338489_total_iter,
                (long) ctx->futhark_mc_segred_stage_1_parloop_338489_total_iter /
                (ctx->futhark_mc_segred_stage_1_parloop_338489_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_338489_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segred_stage_1_parloop_338489_total_total_runtime;
        ctx->total_runs +=
            ctx->futhark_mc_segred_stage_1_parloop_338489_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_task_338484            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_task_338484_runs[i],
                    (long) ctx->futhark_mc_segred_task_338484_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_338484_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_338484_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_task_338484_total_runtime[i],
                    (double) ctx->futhark_mc_segred_task_338484_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_338484_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_task_338484_iter[i]),
                    (long) ctx->futhark_mc_segred_task_338484_iter[i],
                    (long) ctx->futhark_mc_segred_task_338484_iter[i] /
                    (ctx->futhark_mc_segred_task_338484_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_338484_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_stage_1_parloop_338495 ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_stage_1_parloop_338495_runs[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338495_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338495_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_338495_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338495_total_runtime[i],
                    (double) ctx->futhark_mc_segred_stage_1_parloop_338495_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338495_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_338495_iter[i]),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338495_iter[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338495_iter[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338495_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_338495_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segred_stage_1_parloop_338495_total ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segred_stage_1_parloop_338495_total_runs,
                (long) ctx->futhark_mc_segred_stage_1_parloop_338495_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_338495_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_338495_total_runs : 1),
                (long) ctx->futhark_mc_segred_stage_1_parloop_338495_total_total_runtime,
                (double) ctx->futhark_mc_segred_stage_1_parloop_338495_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_338495_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_338495_total_iter),
                (long) ctx->futhark_mc_segred_stage_1_parloop_338495_total_iter,
                (long) ctx->futhark_mc_segred_stage_1_parloop_338495_total_iter /
                (ctx->futhark_mc_segred_stage_1_parloop_338495_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_338495_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segred_stage_1_parloop_338495_total_total_runtime;
        ctx->total_runs +=
            ctx->futhark_mc_segred_stage_1_parloop_338495_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_task_338491            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_task_338491_runs[i],
                    (long) ctx->futhark_mc_segred_task_338491_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_338491_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_338491_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_task_338491_total_runtime[i],
                    (double) ctx->futhark_mc_segred_task_338491_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_338491_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_task_338491_iter[i]),
                    (long) ctx->futhark_mc_segred_task_338491_iter[i],
                    (long) ctx->futhark_mc_segred_task_338491_iter[i] /
                    (ctx->futhark_mc_segred_task_338491_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_338491_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338482         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338482_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338482_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338482_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338482_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338482_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338482_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338482_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338482_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338482_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338482_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338482_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338482_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338482_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338482_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338482_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338482_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338482_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338482_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338482_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338482_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338482_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338482_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338482_total_iter /
                (ctx->futhark_mc_segmap_parloop_338482_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338482_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338482_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338482_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_338477            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_338477_runs[i],
                    (long) ctx->futhark_mc_segmap_task_338477_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338477_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338477_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_338477_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_338477_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338477_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_338477_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_338477_iter[i],
                    (long) ctx->futhark_mc_segmap_task_338477_iter[i] /
                    (ctx->futhark_mc_segmap_task_338477_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338477_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_nested_task_338480     ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_nested_task_338480_runs[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338480_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338480_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338480_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_nested_task_338480_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_nested_task_338480_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338480_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_nested_task_338480_iter[i]),
                    (long) ctx->futhark_mc_segmap_nested_task_338480_iter[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338480_iter[i] /
                    (ctx->futhark_mc_segmap_nested_task_338480_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338480_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338473         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338473_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338473_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338473_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338473_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338473_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338473_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338473_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338473_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338473_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338473_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338473_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338473_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338473_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338473_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338473_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338473_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338473_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338473_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338473_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338473_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338473_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338473_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338473_total_iter /
                (ctx->futhark_mc_segmap_parloop_338473_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338473_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338473_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338473_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_338466            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_338466_runs[i],
                    (long) ctx->futhark_mc_segmap_task_338466_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338466_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338466_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_338466_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_338466_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338466_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_338466_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_338466_iter[i],
                    (long) ctx->futhark_mc_segmap_task_338466_iter[i] /
                    (ctx->futhark_mc_segmap_task_338466_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338466_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_nested_task_338471     ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_nested_task_338471_runs[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338471_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338471_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338471_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_nested_task_338471_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_nested_task_338471_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338471_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_nested_task_338471_iter[i]),
                    (long) ctx->futhark_mc_segmap_nested_task_338471_iter[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338471_iter[i] /
                    (ctx->futhark_mc_segmap_nested_task_338471_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338471_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338499         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338499_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338499_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338499_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338499_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338499_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338499_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338499_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338499_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338499_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338499_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338499_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338499_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338499_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338499_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338499_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338499_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338499_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338499_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338499_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338499_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338499_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338499_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338499_total_iter /
                (ctx->futhark_mc_segmap_parloop_338499_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338499_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338499_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338499_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338510         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338510_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338510_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338510_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338510_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338510_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338510_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338510_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338510_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338510_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338510_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338510_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338510_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338510_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338510_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338510_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338510_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338510_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338510_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338510_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338510_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338510_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338510_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338510_total_iter /
                (ctx->futhark_mc_segmap_parloop_338510_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338510_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338510_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338510_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_stage_1_parloop_338522 ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_stage_1_parloop_338522_runs[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338522_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338522_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_338522_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338522_total_runtime[i],
                    (double) ctx->futhark_mc_segred_stage_1_parloop_338522_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338522_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_338522_iter[i]),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338522_iter[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338522_iter[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338522_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_338522_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segred_stage_1_parloop_338522_total ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segred_stage_1_parloop_338522_total_runs,
                (long) ctx->futhark_mc_segred_stage_1_parloop_338522_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_338522_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_338522_total_runs : 1),
                (long) ctx->futhark_mc_segred_stage_1_parloop_338522_total_total_runtime,
                (double) ctx->futhark_mc_segred_stage_1_parloop_338522_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_338522_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_338522_total_iter),
                (long) ctx->futhark_mc_segred_stage_1_parloop_338522_total_iter,
                (long) ctx->futhark_mc_segred_stage_1_parloop_338522_total_iter /
                (ctx->futhark_mc_segred_stage_1_parloop_338522_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_338522_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segred_stage_1_parloop_338522_total_total_runtime;
        ctx->total_runs +=
            ctx->futhark_mc_segred_stage_1_parloop_338522_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_task_338515            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_task_338515_runs[i],
                    (long) ctx->futhark_mc_segred_task_338515_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_338515_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_338515_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_task_338515_total_runtime[i],
                    (double) ctx->futhark_mc_segred_task_338515_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_338515_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_task_338515_iter[i]),
                    (long) ctx->futhark_mc_segred_task_338515_iter[i],
                    (long) ctx->futhark_mc_segred_task_338515_iter[i] /
                    (ctx->futhark_mc_segred_task_338515_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_338515_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_stage_1_parloop_338528 ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_stage_1_parloop_338528_runs[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338528_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338528_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_338528_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338528_total_runtime[i],
                    (double) ctx->futhark_mc_segred_stage_1_parloop_338528_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338528_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_338528_iter[i]),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338528_iter[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338528_iter[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338528_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_338528_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segred_stage_1_parloop_338528_total ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segred_stage_1_parloop_338528_total_runs,
                (long) ctx->futhark_mc_segred_stage_1_parloop_338528_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_338528_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_338528_total_runs : 1),
                (long) ctx->futhark_mc_segred_stage_1_parloop_338528_total_total_runtime,
                (double) ctx->futhark_mc_segred_stage_1_parloop_338528_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_338528_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_338528_total_iter),
                (long) ctx->futhark_mc_segred_stage_1_parloop_338528_total_iter,
                (long) ctx->futhark_mc_segred_stage_1_parloop_338528_total_iter /
                (ctx->futhark_mc_segred_stage_1_parloop_338528_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_338528_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segred_stage_1_parloop_338528_total_total_runtime;
        ctx->total_runs +=
            ctx->futhark_mc_segred_stage_1_parloop_338528_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_task_338524            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_task_338524_runs[i],
                    (long) ctx->futhark_mc_segred_task_338524_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_338524_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_338524_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_task_338524_total_runtime[i],
                    (double) ctx->futhark_mc_segred_task_338524_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_338524_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_task_338524_iter[i]),
                    (long) ctx->futhark_mc_segred_task_338524_iter[i],
                    (long) ctx->futhark_mc_segred_task_338524_iter[i] /
                    (ctx->futhark_mc_segred_task_338524_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_338524_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338513         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338513_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338513_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338513_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338513_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338513_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338513_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338513_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338513_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338513_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338513_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338513_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338513_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338513_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338513_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338513_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338513_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338513_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338513_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338513_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338513_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338513_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338513_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338513_total_iter /
                (ctx->futhark_mc_segmap_parloop_338513_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338513_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338513_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338513_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_338508            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_338508_runs[i],
                    (long) ctx->futhark_mc_segmap_task_338508_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338508_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338508_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_338508_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_338508_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338508_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_338508_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_338508_iter[i],
                    (long) ctx->futhark_mc_segmap_task_338508_iter[i] /
                    (ctx->futhark_mc_segmap_task_338508_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338508_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_nested_task_338511     ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_nested_task_338511_runs[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338511_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338511_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338511_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_nested_task_338511_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_nested_task_338511_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338511_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_nested_task_338511_iter[i]),
                    (long) ctx->futhark_mc_segmap_nested_task_338511_iter[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338511_iter[i] /
                    (ctx->futhark_mc_segmap_nested_task_338511_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338511_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338504         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338504_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338504_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338504_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338504_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338504_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338504_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338504_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338504_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338504_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338504_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338504_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338504_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338504_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338504_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338504_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338504_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338504_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338504_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338504_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338504_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338504_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338504_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338504_total_iter /
                (ctx->futhark_mc_segmap_parloop_338504_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338504_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338504_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338504_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_338497            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_338497_runs[i],
                    (long) ctx->futhark_mc_segmap_task_338497_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338497_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338497_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_338497_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_338497_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338497_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_338497_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_338497_iter[i],
                    (long) ctx->futhark_mc_segmap_task_338497_iter[i] /
                    (ctx->futhark_mc_segmap_task_338497_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338497_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_nested_task_338502     ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_nested_task_338502_runs[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338502_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338502_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338502_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_nested_task_338502_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_nested_task_338502_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338502_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_nested_task_338502_iter[i]),
                    (long) ctx->futhark_mc_segmap_nested_task_338502_iter[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338502_iter[i] /
                    (ctx->futhark_mc_segmap_nested_task_338502_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338502_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338532         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338532_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338532_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338532_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338532_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338532_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338532_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338532_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338532_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338532_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338532_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338532_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338532_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338532_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338532_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338532_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338532_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338532_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338532_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338532_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338532_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338532_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338532_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338532_total_iter /
                (ctx->futhark_mc_segmap_parloop_338532_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338532_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338532_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338532_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338542         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338542_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338542_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338542_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338542_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338542_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338542_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338542_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338542_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338542_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338542_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338542_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338542_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338542_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338542_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338542_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338542_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338542_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338542_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338542_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338542_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338542_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338542_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338542_total_iter /
                (ctx->futhark_mc_segmap_parloop_338542_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338542_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338542_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338542_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_stage_1_parloop_338552 ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_stage_1_parloop_338552_runs[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338552_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338552_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_338552_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338552_total_runtime[i],
                    (double) ctx->futhark_mc_segred_stage_1_parloop_338552_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338552_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_338552_iter[i]),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338552_iter[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338552_iter[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338552_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_338552_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segred_stage_1_parloop_338552_total ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segred_stage_1_parloop_338552_total_runs,
                (long) ctx->futhark_mc_segred_stage_1_parloop_338552_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_338552_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_338552_total_runs : 1),
                (long) ctx->futhark_mc_segred_stage_1_parloop_338552_total_total_runtime,
                (double) ctx->futhark_mc_segred_stage_1_parloop_338552_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_338552_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_338552_total_iter),
                (long) ctx->futhark_mc_segred_stage_1_parloop_338552_total_iter,
                (long) ctx->futhark_mc_segred_stage_1_parloop_338552_total_iter /
                (ctx->futhark_mc_segred_stage_1_parloop_338552_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_338552_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segred_stage_1_parloop_338552_total_total_runtime;
        ctx->total_runs +=
            ctx->futhark_mc_segred_stage_1_parloop_338552_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_task_338549            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_task_338549_runs[i],
                    (long) ctx->futhark_mc_segred_task_338549_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_338549_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_338549_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_task_338549_total_runtime[i],
                    (double) ctx->futhark_mc_segred_task_338549_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_338549_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_task_338549_iter[i]),
                    (long) ctx->futhark_mc_segred_task_338549_iter[i],
                    (long) ctx->futhark_mc_segred_task_338549_iter[i] /
                    (ctx->futhark_mc_segred_task_338549_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_338549_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_stage_1_parloop_338557 ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_stage_1_parloop_338557_runs[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338557_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338557_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_338557_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338557_total_runtime[i],
                    (double) ctx->futhark_mc_segred_stage_1_parloop_338557_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338557_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_338557_iter[i]),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338557_iter[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338557_iter[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338557_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_338557_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segred_stage_1_parloop_338557_total ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segred_stage_1_parloop_338557_total_runs,
                (long) ctx->futhark_mc_segred_stage_1_parloop_338557_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_338557_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_338557_total_runs : 1),
                (long) ctx->futhark_mc_segred_stage_1_parloop_338557_total_total_runtime,
                (double) ctx->futhark_mc_segred_stage_1_parloop_338557_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_338557_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_338557_total_iter),
                (long) ctx->futhark_mc_segred_stage_1_parloop_338557_total_iter,
                (long) ctx->futhark_mc_segred_stage_1_parloop_338557_total_iter /
                (ctx->futhark_mc_segred_stage_1_parloop_338557_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_338557_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segred_stage_1_parloop_338557_total_total_runtime;
        ctx->total_runs +=
            ctx->futhark_mc_segred_stage_1_parloop_338557_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_task_338554            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_task_338554_runs[i],
                    (long) ctx->futhark_mc_segred_task_338554_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_338554_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_338554_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_task_338554_total_runtime[i],
                    (double) ctx->futhark_mc_segred_task_338554_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_338554_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_task_338554_iter[i]),
                    (long) ctx->futhark_mc_segred_task_338554_iter[i],
                    (long) ctx->futhark_mc_segred_task_338554_iter[i] /
                    (ctx->futhark_mc_segred_task_338554_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_338554_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338546         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338546_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338546_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338546_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338546_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338546_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338546_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338546_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338546_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338546_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338546_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338546_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338546_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338546_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338546_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338546_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338546_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338546_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338546_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338546_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338546_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338546_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338546_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338546_total_iter /
                (ctx->futhark_mc_segmap_parloop_338546_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338546_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338546_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338546_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_338540            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_338540_runs[i],
                    (long) ctx->futhark_mc_segmap_task_338540_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338540_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338540_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_338540_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_338540_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338540_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_338540_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_338540_iter[i],
                    (long) ctx->futhark_mc_segmap_task_338540_iter[i] /
                    (ctx->futhark_mc_segmap_task_338540_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338540_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_nested_task_338544     ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_nested_task_338544_runs[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338544_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338544_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338544_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_nested_task_338544_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_nested_task_338544_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338544_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_nested_task_338544_iter[i]),
                    (long) ctx->futhark_mc_segmap_nested_task_338544_iter[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338544_iter[i] /
                    (ctx->futhark_mc_segmap_nested_task_338544_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338544_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338537         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338537_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338537_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338537_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338537_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338537_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338537_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338537_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338537_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338537_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338537_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338537_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338537_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338537_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338537_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338537_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338537_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338537_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338537_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338537_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338537_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338537_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338537_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338537_total_iter /
                (ctx->futhark_mc_segmap_parloop_338537_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338537_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338537_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338537_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_338530            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_338530_runs[i],
                    (long) ctx->futhark_mc_segmap_task_338530_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338530_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338530_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_338530_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_338530_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338530_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_338530_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_338530_iter[i],
                    (long) ctx->futhark_mc_segmap_task_338530_iter[i] /
                    (ctx->futhark_mc_segmap_task_338530_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338530_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_nested_task_338535     ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_nested_task_338535_runs[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338535_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338535_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338535_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_nested_task_338535_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_nested_task_338535_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338535_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_nested_task_338535_iter[i]),
                    (long) ctx->futhark_mc_segmap_nested_task_338535_iter[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338535_iter[i] /
                    (ctx->futhark_mc_segmap_nested_task_338535_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338535_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338561         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338561_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338561_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338561_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338561_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338561_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338561_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338561_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338561_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338561_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338561_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338561_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338561_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338561_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338561_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338561_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338561_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338561_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338561_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338561_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338561_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338561_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338561_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338561_total_iter /
                (ctx->futhark_mc_segmap_parloop_338561_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338561_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338561_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338561_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338574         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338574_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338574_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338574_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338574_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338574_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338574_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338574_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338574_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338574_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338574_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338574_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338574_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338574_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338574_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338574_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338574_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338574_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338574_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338574_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338574_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338574_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338574_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338574_total_iter /
                (ctx->futhark_mc_segmap_parloop_338574_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338574_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338574_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338574_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_stage_1_parloop_338588 ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_stage_1_parloop_338588_runs[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338588_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338588_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_338588_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338588_total_runtime[i],
                    (double) ctx->futhark_mc_segred_stage_1_parloop_338588_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338588_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_338588_iter[i]),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338588_iter[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338588_iter[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338588_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_338588_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segred_stage_1_parloop_338588_total ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segred_stage_1_parloop_338588_total_runs,
                (long) ctx->futhark_mc_segred_stage_1_parloop_338588_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_338588_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_338588_total_runs : 1),
                (long) ctx->futhark_mc_segred_stage_1_parloop_338588_total_total_runtime,
                (double) ctx->futhark_mc_segred_stage_1_parloop_338588_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_338588_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_338588_total_iter),
                (long) ctx->futhark_mc_segred_stage_1_parloop_338588_total_iter,
                (long) ctx->futhark_mc_segred_stage_1_parloop_338588_total_iter /
                (ctx->futhark_mc_segred_stage_1_parloop_338588_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_338588_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segred_stage_1_parloop_338588_total_total_runtime;
        ctx->total_runs +=
            ctx->futhark_mc_segred_stage_1_parloop_338588_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_task_338583            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_task_338583_runs[i],
                    (long) ctx->futhark_mc_segred_task_338583_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_338583_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_338583_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_task_338583_total_runtime[i],
                    (double) ctx->futhark_mc_segred_task_338583_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_338583_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_task_338583_iter[i]),
                    (long) ctx->futhark_mc_segred_task_338583_iter[i],
                    (long) ctx->futhark_mc_segred_task_338583_iter[i] /
                    (ctx->futhark_mc_segred_task_338583_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_338583_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_stage_1_parloop_338594 ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_stage_1_parloop_338594_runs[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338594_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338594_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_338594_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338594_total_runtime[i],
                    (double) ctx->futhark_mc_segred_stage_1_parloop_338594_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338594_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_338594_iter[i]),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338594_iter[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338594_iter[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338594_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_338594_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segred_stage_1_parloop_338594_total ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segred_stage_1_parloop_338594_total_runs,
                (long) ctx->futhark_mc_segred_stage_1_parloop_338594_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_338594_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_338594_total_runs : 1),
                (long) ctx->futhark_mc_segred_stage_1_parloop_338594_total_total_runtime,
                (double) ctx->futhark_mc_segred_stage_1_parloop_338594_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_338594_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_338594_total_iter),
                (long) ctx->futhark_mc_segred_stage_1_parloop_338594_total_iter,
                (long) ctx->futhark_mc_segred_stage_1_parloop_338594_total_iter /
                (ctx->futhark_mc_segred_stage_1_parloop_338594_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_338594_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segred_stage_1_parloop_338594_total_total_runtime;
        ctx->total_runs +=
            ctx->futhark_mc_segred_stage_1_parloop_338594_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_task_338590            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_task_338590_runs[i],
                    (long) ctx->futhark_mc_segred_task_338590_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_338590_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_338590_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_task_338590_total_runtime[i],
                    (double) ctx->futhark_mc_segred_task_338590_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_338590_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_task_338590_iter[i]),
                    (long) ctx->futhark_mc_segred_task_338590_iter[i],
                    (long) ctx->futhark_mc_segred_task_338590_iter[i] /
                    (ctx->futhark_mc_segred_task_338590_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_338590_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338579         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338579_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338579_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338579_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338579_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338579_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338579_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338579_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338579_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338579_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338579_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338579_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338579_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338579_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338579_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338579_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338579_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338579_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338579_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338579_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338579_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338579_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338579_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338579_total_iter /
                (ctx->futhark_mc_segmap_parloop_338579_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338579_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338579_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338579_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_338572            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_338572_runs[i],
                    (long) ctx->futhark_mc_segmap_task_338572_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338572_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338572_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_338572_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_338572_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338572_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_338572_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_338572_iter[i],
                    (long) ctx->futhark_mc_segmap_task_338572_iter[i] /
                    (ctx->futhark_mc_segmap_task_338572_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338572_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_nested_task_338577     ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_nested_task_338577_runs[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338577_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338577_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338577_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_nested_task_338577_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_nested_task_338577_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338577_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_nested_task_338577_iter[i]),
                    (long) ctx->futhark_mc_segmap_nested_task_338577_iter[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338577_iter[i] /
                    (ctx->futhark_mc_segmap_nested_task_338577_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338577_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338568         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338568_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338568_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338568_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338568_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338568_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338568_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338568_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338568_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338568_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338568_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338568_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338568_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338568_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338568_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338568_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338568_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338568_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338568_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338568_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338568_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338568_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338568_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338568_total_iter /
                (ctx->futhark_mc_segmap_parloop_338568_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338568_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338568_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338568_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_338559            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_338559_runs[i],
                    (long) ctx->futhark_mc_segmap_task_338559_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338559_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338559_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_338559_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_338559_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338559_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_338559_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_338559_iter[i],
                    (long) ctx->futhark_mc_segmap_task_338559_iter[i] /
                    (ctx->futhark_mc_segmap_task_338559_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338559_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_nested_task_338566     ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_nested_task_338566_runs[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338566_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338566_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338566_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_nested_task_338566_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_nested_task_338566_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338566_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_nested_task_338566_iter[i]),
                    (long) ctx->futhark_mc_segmap_nested_task_338566_iter[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338566_iter[i] /
                    (ctx->futhark_mc_segmap_nested_task_338566_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338566_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338598         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338598_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338598_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338598_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338598_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338598_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338598_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338598_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338598_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338598_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338598_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338598_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338598_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338598_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338598_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338598_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338598_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338598_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338598_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338598_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338598_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338598_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338598_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338598_total_iter /
                (ctx->futhark_mc_segmap_parloop_338598_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338598_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338598_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338598_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338613         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338613_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338613_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338613_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338613_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338613_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338613_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338613_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338613_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338613_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338613_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338613_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338613_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338613_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338613_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338613_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338613_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338613_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338613_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338613_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338613_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338613_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338613_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338613_total_iter /
                (ctx->futhark_mc_segmap_parloop_338613_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338613_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338613_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338613_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338628         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338628_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338628_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338628_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338628_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338628_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338628_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338628_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338628_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338628_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338628_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338628_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338628_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338628_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338628_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338628_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338628_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338628_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338628_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338628_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338628_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338628_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338628_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338628_total_iter /
                (ctx->futhark_mc_segmap_parloop_338628_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338628_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338628_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338628_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_338626            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_338626_runs[i],
                    (long) ctx->futhark_mc_segmap_task_338626_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338626_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338626_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_338626_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_338626_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338626_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_338626_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_338626_iter[i],
                    (long) ctx->futhark_mc_segmap_task_338626_iter[i] /
                    (ctx->futhark_mc_segmap_task_338626_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338626_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_stage_1_parloop_338637 ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_stage_1_parloop_338637_runs[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338637_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338637_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_338637_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338637_total_runtime[i],
                    (double) ctx->futhark_mc_segred_stage_1_parloop_338637_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338637_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_338637_iter[i]),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338637_iter[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338637_iter[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338637_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_338637_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segred_stage_1_parloop_338637_total ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segred_stage_1_parloop_338637_total_runs,
                (long) ctx->futhark_mc_segred_stage_1_parloop_338637_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_338637_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_338637_total_runs : 1),
                (long) ctx->futhark_mc_segred_stage_1_parloop_338637_total_total_runtime,
                (double) ctx->futhark_mc_segred_stage_1_parloop_338637_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_338637_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_338637_total_iter),
                (long) ctx->futhark_mc_segred_stage_1_parloop_338637_total_iter,
                (long) ctx->futhark_mc_segred_stage_1_parloop_338637_total_iter /
                (ctx->futhark_mc_segred_stage_1_parloop_338637_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_338637_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segred_stage_1_parloop_338637_total_total_runtime;
        ctx->total_runs +=
            ctx->futhark_mc_segred_stage_1_parloop_338637_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_task_338630            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_task_338630_runs[i],
                    (long) ctx->futhark_mc_segred_task_338630_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_338630_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_338630_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_task_338630_total_runtime[i],
                    (double) ctx->futhark_mc_segred_task_338630_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_338630_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_task_338630_iter[i]),
                    (long) ctx->futhark_mc_segred_task_338630_iter[i],
                    (long) ctx->futhark_mc_segred_task_338630_iter[i] /
                    (ctx->futhark_mc_segred_task_338630_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_338630_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_stage_1_parloop_338643 ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_stage_1_parloop_338643_runs[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338643_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338643_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_338643_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338643_total_runtime[i],
                    (double) ctx->futhark_mc_segred_stage_1_parloop_338643_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338643_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_338643_iter[i]),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338643_iter[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338643_iter[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338643_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_338643_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segred_stage_1_parloop_338643_total ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segred_stage_1_parloop_338643_total_runs,
                (long) ctx->futhark_mc_segred_stage_1_parloop_338643_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_338643_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_338643_total_runs : 1),
                (long) ctx->futhark_mc_segred_stage_1_parloop_338643_total_total_runtime,
                (double) ctx->futhark_mc_segred_stage_1_parloop_338643_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_338643_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_338643_total_iter),
                (long) ctx->futhark_mc_segred_stage_1_parloop_338643_total_iter,
                (long) ctx->futhark_mc_segred_stage_1_parloop_338643_total_iter /
                (ctx->futhark_mc_segred_stage_1_parloop_338643_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_338643_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segred_stage_1_parloop_338643_total_total_runtime;
        ctx->total_runs +=
            ctx->futhark_mc_segred_stage_1_parloop_338643_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_task_338639            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_task_338639_runs[i],
                    (long) ctx->futhark_mc_segred_task_338639_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_338639_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_338639_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_task_338639_total_runtime[i],
                    (double) ctx->futhark_mc_segred_task_338639_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_338639_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_task_338639_iter[i]),
                    (long) ctx->futhark_mc_segred_task_338639_iter[i],
                    (long) ctx->futhark_mc_segred_task_338639_iter[i] /
                    (ctx->futhark_mc_segred_task_338639_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_338639_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338620         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338620_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338620_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338620_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338620_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338620_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338620_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338620_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338620_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338620_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338620_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338620_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338620_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338620_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338620_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338620_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338620_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338620_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338620_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338620_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338620_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338620_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338620_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338620_total_iter /
                (ctx->futhark_mc_segmap_parloop_338620_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338620_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338620_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338620_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_338611            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_338611_runs[i],
                    (long) ctx->futhark_mc_segmap_task_338611_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338611_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338611_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_338611_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_338611_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338611_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_338611_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_338611_iter[i],
                    (long) ctx->futhark_mc_segmap_task_338611_iter[i] /
                    (ctx->futhark_mc_segmap_task_338611_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338611_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_nested_task_338618     ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_nested_task_338618_runs[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338618_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338618_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338618_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_nested_task_338618_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_nested_task_338618_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338618_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_nested_task_338618_iter[i]),
                    (long) ctx->futhark_mc_segmap_nested_task_338618_iter[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338618_iter[i] /
                    (ctx->futhark_mc_segmap_nested_task_338618_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338618_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338607         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338607_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338607_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338607_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338607_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338607_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338607_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338607_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338607_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338607_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338607_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338607_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338607_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338607_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338607_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338607_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338607_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338607_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338607_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338607_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338607_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338607_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338607_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338607_total_iter /
                (ctx->futhark_mc_segmap_parloop_338607_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338607_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338607_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338607_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_338596            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_338596_runs[i],
                    (long) ctx->futhark_mc_segmap_task_338596_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338596_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338596_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_338596_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_338596_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338596_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_338596_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_338596_iter[i],
                    (long) ctx->futhark_mc_segmap_task_338596_iter[i] /
                    (ctx->futhark_mc_segmap_task_338596_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338596_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_nested_task_338605     ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_nested_task_338605_runs[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338605_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338605_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338605_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_nested_task_338605_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_nested_task_338605_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338605_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_nested_task_338605_iter[i]),
                    (long) ctx->futhark_mc_segmap_nested_task_338605_iter[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338605_iter[i] /
                    (ctx->futhark_mc_segmap_nested_task_338605_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338605_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338647         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338647_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338647_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338647_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338647_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338647_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338647_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338647_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338647_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338647_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338647_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338647_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338647_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338647_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338647_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338647_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338647_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338647_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338647_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338647_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338647_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338647_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338647_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338647_total_iter /
                (ctx->futhark_mc_segmap_parloop_338647_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338647_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338647_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338647_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338656         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338656_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338656_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338656_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338656_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338656_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338656_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338656_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338656_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338656_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338656_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338656_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338656_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338656_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338656_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338656_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338656_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338656_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338656_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338656_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338656_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338656_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338656_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338656_total_iter /
                (ctx->futhark_mc_segmap_parloop_338656_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338656_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338656_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338656_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_stage_1_parloop_338664 ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_stage_1_parloop_338664_runs[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338664_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338664_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_338664_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338664_total_runtime[i],
                    (double) ctx->futhark_mc_segred_stage_1_parloop_338664_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338664_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_338664_iter[i]),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338664_iter[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338664_iter[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338664_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_338664_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segred_stage_1_parloop_338664_total ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segred_stage_1_parloop_338664_total_runs,
                (long) ctx->futhark_mc_segred_stage_1_parloop_338664_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_338664_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_338664_total_runs : 1),
                (long) ctx->futhark_mc_segred_stage_1_parloop_338664_total_total_runtime,
                (double) ctx->futhark_mc_segred_stage_1_parloop_338664_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_338664_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_338664_total_iter),
                (long) ctx->futhark_mc_segred_stage_1_parloop_338664_total_iter,
                (long) ctx->futhark_mc_segred_stage_1_parloop_338664_total_iter /
                (ctx->futhark_mc_segred_stage_1_parloop_338664_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_338664_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segred_stage_1_parloop_338664_total_total_runtime;
        ctx->total_runs +=
            ctx->futhark_mc_segred_stage_1_parloop_338664_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_task_338661            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_task_338661_runs[i],
                    (long) ctx->futhark_mc_segred_task_338661_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_338661_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_338661_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_task_338661_total_runtime[i],
                    (double) ctx->futhark_mc_segred_task_338661_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_338661_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_task_338661_iter[i]),
                    (long) ctx->futhark_mc_segred_task_338661_iter[i],
                    (long) ctx->futhark_mc_segred_task_338661_iter[i] /
                    (ctx->futhark_mc_segred_task_338661_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_338661_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_stage_1_parloop_338669 ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_stage_1_parloop_338669_runs[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338669_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338669_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_338669_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338669_total_runtime[i],
                    (double) ctx->futhark_mc_segred_stage_1_parloop_338669_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338669_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_338669_iter[i]),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338669_iter[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338669_iter[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338669_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_338669_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segred_stage_1_parloop_338669_total ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segred_stage_1_parloop_338669_total_runs,
                (long) ctx->futhark_mc_segred_stage_1_parloop_338669_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_338669_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_338669_total_runs : 1),
                (long) ctx->futhark_mc_segred_stage_1_parloop_338669_total_total_runtime,
                (double) ctx->futhark_mc_segred_stage_1_parloop_338669_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_338669_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_338669_total_iter),
                (long) ctx->futhark_mc_segred_stage_1_parloop_338669_total_iter,
                (long) ctx->futhark_mc_segred_stage_1_parloop_338669_total_iter /
                (ctx->futhark_mc_segred_stage_1_parloop_338669_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_338669_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segred_stage_1_parloop_338669_total_total_runtime;
        ctx->total_runs +=
            ctx->futhark_mc_segred_stage_1_parloop_338669_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_task_338666            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_task_338666_runs[i],
                    (long) ctx->futhark_mc_segred_task_338666_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_338666_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_338666_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_task_338666_total_runtime[i],
                    (double) ctx->futhark_mc_segred_task_338666_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_338666_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_task_338666_iter[i]),
                    (long) ctx->futhark_mc_segred_task_338666_iter[i],
                    (long) ctx->futhark_mc_segred_task_338666_iter[i] /
                    (ctx->futhark_mc_segred_task_338666_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_338666_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338659         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338659_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338659_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338659_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338659_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338659_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338659_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338659_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338659_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338659_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338659_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338659_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338659_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338659_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338659_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338659_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338659_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338659_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338659_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338659_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338659_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338659_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338659_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338659_total_iter /
                (ctx->futhark_mc_segmap_parloop_338659_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338659_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338659_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338659_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_338654            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_338654_runs[i],
                    (long) ctx->futhark_mc_segmap_task_338654_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338654_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338654_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_338654_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_338654_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338654_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_338654_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_338654_iter[i],
                    (long) ctx->futhark_mc_segmap_task_338654_iter[i] /
                    (ctx->futhark_mc_segmap_task_338654_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338654_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_nested_task_338657     ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_nested_task_338657_runs[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338657_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338657_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338657_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_nested_task_338657_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_nested_task_338657_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338657_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_nested_task_338657_iter[i]),
                    (long) ctx->futhark_mc_segmap_nested_task_338657_iter[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338657_iter[i] /
                    (ctx->futhark_mc_segmap_nested_task_338657_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338657_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338651         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338651_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338651_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338651_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338651_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338651_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338651_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338651_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338651_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338651_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338651_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338651_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338651_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338651_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338651_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338651_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338651_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338651_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338651_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338651_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338651_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338651_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338651_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338651_total_iter /
                (ctx->futhark_mc_segmap_parloop_338651_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338651_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338651_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338651_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_338645            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_338645_runs[i],
                    (long) ctx->futhark_mc_segmap_task_338645_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338645_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338645_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_338645_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_338645_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338645_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_338645_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_338645_iter[i],
                    (long) ctx->futhark_mc_segmap_task_338645_iter[i] /
                    (ctx->futhark_mc_segmap_task_338645_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338645_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_nested_task_338649     ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_nested_task_338649_runs[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338649_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338649_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338649_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_nested_task_338649_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_nested_task_338649_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338649_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_nested_task_338649_iter[i]),
                    (long) ctx->futhark_mc_segmap_nested_task_338649_iter[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338649_iter[i] /
                    (ctx->futhark_mc_segmap_nested_task_338649_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338649_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338673         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338673_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338673_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338673_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338673_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338673_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338673_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338673_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338673_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338673_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338673_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338673_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338673_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338673_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338673_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338673_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338673_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338673_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338673_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338673_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338673_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338673_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338673_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338673_total_iter /
                (ctx->futhark_mc_segmap_parloop_338673_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338673_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338673_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338673_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338684         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338684_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338684_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338684_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338684_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338684_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338684_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338684_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338684_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338684_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338684_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338684_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338684_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338684_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338684_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338684_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338684_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338684_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338684_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338684_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338684_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338684_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338684_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338684_total_iter /
                (ctx->futhark_mc_segmap_parloop_338684_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338684_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338684_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338684_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_stage_1_parloop_338694 ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_stage_1_parloop_338694_runs[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338694_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338694_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_338694_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338694_total_runtime[i],
                    (double) ctx->futhark_mc_segred_stage_1_parloop_338694_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338694_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_338694_iter[i]),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338694_iter[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338694_iter[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338694_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_338694_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segred_stage_1_parloop_338694_total ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segred_stage_1_parloop_338694_total_runs,
                (long) ctx->futhark_mc_segred_stage_1_parloop_338694_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_338694_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_338694_total_runs : 1),
                (long) ctx->futhark_mc_segred_stage_1_parloop_338694_total_total_runtime,
                (double) ctx->futhark_mc_segred_stage_1_parloop_338694_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_338694_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_338694_total_iter),
                (long) ctx->futhark_mc_segred_stage_1_parloop_338694_total_iter,
                (long) ctx->futhark_mc_segred_stage_1_parloop_338694_total_iter /
                (ctx->futhark_mc_segred_stage_1_parloop_338694_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_338694_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segred_stage_1_parloop_338694_total_total_runtime;
        ctx->total_runs +=
            ctx->futhark_mc_segred_stage_1_parloop_338694_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_task_338689            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_task_338689_runs[i],
                    (long) ctx->futhark_mc_segred_task_338689_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_338689_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_338689_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_task_338689_total_runtime[i],
                    (double) ctx->futhark_mc_segred_task_338689_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_338689_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_task_338689_iter[i]),
                    (long) ctx->futhark_mc_segred_task_338689_iter[i],
                    (long) ctx->futhark_mc_segred_task_338689_iter[i] /
                    (ctx->futhark_mc_segred_task_338689_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_338689_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_stage_1_parloop_338700 ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_stage_1_parloop_338700_runs[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338700_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338700_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_338700_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338700_total_runtime[i],
                    (double) ctx->futhark_mc_segred_stage_1_parloop_338700_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338700_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_338700_iter[i]),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338700_iter[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338700_iter[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338700_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_338700_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segred_stage_1_parloop_338700_total ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segred_stage_1_parloop_338700_total_runs,
                (long) ctx->futhark_mc_segred_stage_1_parloop_338700_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_338700_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_338700_total_runs : 1),
                (long) ctx->futhark_mc_segred_stage_1_parloop_338700_total_total_runtime,
                (double) ctx->futhark_mc_segred_stage_1_parloop_338700_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_338700_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_338700_total_iter),
                (long) ctx->futhark_mc_segred_stage_1_parloop_338700_total_iter,
                (long) ctx->futhark_mc_segred_stage_1_parloop_338700_total_iter /
                (ctx->futhark_mc_segred_stage_1_parloop_338700_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_338700_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segred_stage_1_parloop_338700_total_total_runtime;
        ctx->total_runs +=
            ctx->futhark_mc_segred_stage_1_parloop_338700_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_task_338696            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_task_338696_runs[i],
                    (long) ctx->futhark_mc_segred_task_338696_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_338696_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_338696_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_task_338696_total_runtime[i],
                    (double) ctx->futhark_mc_segred_task_338696_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_338696_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_task_338696_iter[i]),
                    (long) ctx->futhark_mc_segred_task_338696_iter[i],
                    (long) ctx->futhark_mc_segred_task_338696_iter[i] /
                    (ctx->futhark_mc_segred_task_338696_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_338696_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338687         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338687_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338687_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338687_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338687_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338687_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338687_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338687_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338687_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338687_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338687_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338687_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338687_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338687_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338687_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338687_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338687_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338687_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338687_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338687_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338687_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338687_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338687_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338687_total_iter /
                (ctx->futhark_mc_segmap_parloop_338687_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338687_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338687_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338687_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_338682            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_338682_runs[i],
                    (long) ctx->futhark_mc_segmap_task_338682_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338682_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338682_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_338682_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_338682_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338682_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_338682_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_338682_iter[i],
                    (long) ctx->futhark_mc_segmap_task_338682_iter[i] /
                    (ctx->futhark_mc_segmap_task_338682_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338682_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_nested_task_338685     ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_nested_task_338685_runs[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338685_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338685_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338685_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_nested_task_338685_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_nested_task_338685_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338685_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_nested_task_338685_iter[i]),
                    (long) ctx->futhark_mc_segmap_nested_task_338685_iter[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338685_iter[i] /
                    (ctx->futhark_mc_segmap_nested_task_338685_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338685_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338678         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338678_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338678_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338678_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338678_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338678_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338678_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338678_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338678_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338678_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338678_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338678_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338678_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338678_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338678_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338678_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338678_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338678_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338678_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338678_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338678_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338678_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338678_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338678_total_iter /
                (ctx->futhark_mc_segmap_parloop_338678_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338678_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338678_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338678_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_338671            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_338671_runs[i],
                    (long) ctx->futhark_mc_segmap_task_338671_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338671_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338671_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_338671_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_338671_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338671_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_338671_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_338671_iter[i],
                    (long) ctx->futhark_mc_segmap_task_338671_iter[i] /
                    (ctx->futhark_mc_segmap_task_338671_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338671_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_nested_task_338676     ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_nested_task_338676_runs[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338676_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338676_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338676_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_nested_task_338676_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_nested_task_338676_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338676_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_nested_task_338676_iter[i]),
                    (long) ctx->futhark_mc_segmap_nested_task_338676_iter[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338676_iter[i] /
                    (ctx->futhark_mc_segmap_nested_task_338676_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338676_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338704         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338704_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338704_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338704_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338704_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338704_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338704_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338704_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338704_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338704_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338704_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338704_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338704_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338704_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338704_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338704_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338704_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338704_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338704_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338704_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338704_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338704_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338704_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338704_total_iter /
                (ctx->futhark_mc_segmap_parloop_338704_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338704_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338704_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338704_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338715         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338715_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338715_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338715_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338715_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338715_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338715_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338715_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338715_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338715_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338715_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338715_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338715_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338715_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338715_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338715_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338715_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338715_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338715_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338715_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338715_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338715_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338715_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338715_total_iter /
                (ctx->futhark_mc_segmap_parloop_338715_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338715_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338715_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338715_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_stage_1_parloop_338727 ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_stage_1_parloop_338727_runs[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338727_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338727_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_338727_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338727_total_runtime[i],
                    (double) ctx->futhark_mc_segred_stage_1_parloop_338727_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338727_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_338727_iter[i]),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338727_iter[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338727_iter[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338727_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_338727_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segred_stage_1_parloop_338727_total ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segred_stage_1_parloop_338727_total_runs,
                (long) ctx->futhark_mc_segred_stage_1_parloop_338727_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_338727_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_338727_total_runs : 1),
                (long) ctx->futhark_mc_segred_stage_1_parloop_338727_total_total_runtime,
                (double) ctx->futhark_mc_segred_stage_1_parloop_338727_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_338727_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_338727_total_iter),
                (long) ctx->futhark_mc_segred_stage_1_parloop_338727_total_iter,
                (long) ctx->futhark_mc_segred_stage_1_parloop_338727_total_iter /
                (ctx->futhark_mc_segred_stage_1_parloop_338727_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_338727_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segred_stage_1_parloop_338727_total_total_runtime;
        ctx->total_runs +=
            ctx->futhark_mc_segred_stage_1_parloop_338727_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_task_338720            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_task_338720_runs[i],
                    (long) ctx->futhark_mc_segred_task_338720_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_338720_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_338720_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_task_338720_total_runtime[i],
                    (double) ctx->futhark_mc_segred_task_338720_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_338720_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_task_338720_iter[i]),
                    (long) ctx->futhark_mc_segred_task_338720_iter[i],
                    (long) ctx->futhark_mc_segred_task_338720_iter[i] /
                    (ctx->futhark_mc_segred_task_338720_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_338720_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_stage_1_parloop_338733 ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_stage_1_parloop_338733_runs[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338733_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338733_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_338733_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338733_total_runtime[i],
                    (double) ctx->futhark_mc_segred_stage_1_parloop_338733_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338733_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_338733_iter[i]),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338733_iter[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338733_iter[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338733_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_338733_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segred_stage_1_parloop_338733_total ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segred_stage_1_parloop_338733_total_runs,
                (long) ctx->futhark_mc_segred_stage_1_parloop_338733_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_338733_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_338733_total_runs : 1),
                (long) ctx->futhark_mc_segred_stage_1_parloop_338733_total_total_runtime,
                (double) ctx->futhark_mc_segred_stage_1_parloop_338733_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_338733_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_338733_total_iter),
                (long) ctx->futhark_mc_segred_stage_1_parloop_338733_total_iter,
                (long) ctx->futhark_mc_segred_stage_1_parloop_338733_total_iter /
                (ctx->futhark_mc_segred_stage_1_parloop_338733_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_338733_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segred_stage_1_parloop_338733_total_total_runtime;
        ctx->total_runs +=
            ctx->futhark_mc_segred_stage_1_parloop_338733_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_task_338729            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_task_338729_runs[i],
                    (long) ctx->futhark_mc_segred_task_338729_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_338729_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_338729_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_task_338729_total_runtime[i],
                    (double) ctx->futhark_mc_segred_task_338729_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_338729_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_task_338729_iter[i]),
                    (long) ctx->futhark_mc_segred_task_338729_iter[i],
                    (long) ctx->futhark_mc_segred_task_338729_iter[i] /
                    (ctx->futhark_mc_segred_task_338729_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_338729_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338718         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338718_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338718_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338718_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338718_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338718_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338718_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338718_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338718_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338718_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338718_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338718_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338718_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338718_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338718_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338718_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338718_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338718_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338718_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338718_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338718_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338718_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338718_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338718_total_iter /
                (ctx->futhark_mc_segmap_parloop_338718_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338718_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338718_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338718_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_338713            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_338713_runs[i],
                    (long) ctx->futhark_mc_segmap_task_338713_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338713_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338713_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_338713_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_338713_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338713_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_338713_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_338713_iter[i],
                    (long) ctx->futhark_mc_segmap_task_338713_iter[i] /
                    (ctx->futhark_mc_segmap_task_338713_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338713_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_nested_task_338716     ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_nested_task_338716_runs[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338716_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338716_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338716_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_nested_task_338716_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_nested_task_338716_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338716_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_nested_task_338716_iter[i]),
                    (long) ctx->futhark_mc_segmap_nested_task_338716_iter[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338716_iter[i] /
                    (ctx->futhark_mc_segmap_nested_task_338716_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338716_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338709         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338709_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338709_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338709_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338709_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338709_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338709_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338709_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338709_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338709_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338709_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338709_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338709_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338709_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338709_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338709_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338709_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338709_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338709_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338709_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338709_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338709_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338709_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338709_total_iter /
                (ctx->futhark_mc_segmap_parloop_338709_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338709_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338709_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338709_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_338702            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_338702_runs[i],
                    (long) ctx->futhark_mc_segmap_task_338702_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338702_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338702_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_338702_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_338702_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338702_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_338702_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_338702_iter[i],
                    (long) ctx->futhark_mc_segmap_task_338702_iter[i] /
                    (ctx->futhark_mc_segmap_task_338702_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338702_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_nested_task_338707     ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_nested_task_338707_runs[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338707_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338707_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338707_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_nested_task_338707_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_nested_task_338707_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338707_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_nested_task_338707_iter[i]),
                    (long) ctx->futhark_mc_segmap_nested_task_338707_iter[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338707_iter[i] /
                    (ctx->futhark_mc_segmap_nested_task_338707_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338707_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338737         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338737_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338737_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338737_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338737_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338737_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338737_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338737_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338737_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338737_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338737_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338737_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338737_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338737_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338737_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338737_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338737_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338737_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338737_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338737_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338737_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338737_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338737_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338737_total_iter /
                (ctx->futhark_mc_segmap_parloop_338737_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338737_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338737_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338737_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338746         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338746_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338746_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338746_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338746_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338746_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338746_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338746_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338746_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338746_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338746_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338746_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338746_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338746_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338746_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338746_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338746_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338746_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338746_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338746_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338746_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338746_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338746_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338746_total_iter /
                (ctx->futhark_mc_segmap_parloop_338746_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338746_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338746_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338746_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_338744            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_338744_runs[i],
                    (long) ctx->futhark_mc_segmap_task_338744_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338744_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338744_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_338744_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_338744_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338744_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_338744_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_338744_iter[i],
                    (long) ctx->futhark_mc_segmap_task_338744_iter[i] /
                    (ctx->futhark_mc_segmap_task_338744_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338744_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338741         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338741_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338741_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338741_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338741_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338741_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338741_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338741_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338741_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338741_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338741_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338741_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338741_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338741_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338741_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338741_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338741_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338741_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338741_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338741_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338741_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338741_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338741_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338741_total_iter /
                (ctx->futhark_mc_segmap_parloop_338741_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338741_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338741_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338741_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_338735            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_338735_runs[i],
                    (long) ctx->futhark_mc_segmap_task_338735_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338735_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338735_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_338735_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_338735_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338735_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_338735_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_338735_iter[i],
                    (long) ctx->futhark_mc_segmap_task_338735_iter[i] /
                    (ctx->futhark_mc_segmap_task_338735_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338735_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_nested_task_338739     ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_nested_task_338739_runs[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338739_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338739_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338739_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_nested_task_338739_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_nested_task_338739_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338739_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_nested_task_338739_iter[i]),
                    (long) ctx->futhark_mc_segmap_nested_task_338739_iter[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338739_iter[i] /
                    (ctx->futhark_mc_segmap_nested_task_338739_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338739_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338750         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338750_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338750_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338750_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338750_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338750_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338750_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338750_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338750_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338750_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338750_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338750_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338750_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338750_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338750_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338750_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338750_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338750_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338750_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338750_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338750_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338750_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338750_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338750_total_iter /
                (ctx->futhark_mc_segmap_parloop_338750_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338750_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338750_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338750_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338759         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338759_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338759_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338759_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338759_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338759_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338759_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338759_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338759_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338759_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338759_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338759_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338759_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338759_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338759_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338759_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338759_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338759_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338759_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338759_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338759_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338759_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338759_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338759_total_iter /
                (ctx->futhark_mc_segmap_parloop_338759_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338759_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338759_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338759_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_338757            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_338757_runs[i],
                    (long) ctx->futhark_mc_segmap_task_338757_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338757_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338757_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_338757_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_338757_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338757_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_338757_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_338757_iter[i],
                    (long) ctx->futhark_mc_segmap_task_338757_iter[i] /
                    (ctx->futhark_mc_segmap_task_338757_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338757_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338754         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338754_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338754_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338754_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338754_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338754_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338754_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338754_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338754_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338754_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338754_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338754_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338754_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338754_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338754_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338754_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338754_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338754_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338754_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338754_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338754_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338754_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338754_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338754_total_iter /
                (ctx->futhark_mc_segmap_parloop_338754_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338754_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338754_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338754_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_338748            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_338748_runs[i],
                    (long) ctx->futhark_mc_segmap_task_338748_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338748_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338748_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_338748_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_338748_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338748_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_338748_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_338748_iter[i],
                    (long) ctx->futhark_mc_segmap_task_338748_iter[i] /
                    (ctx->futhark_mc_segmap_task_338748_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338748_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_nested_task_338752     ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_nested_task_338752_runs[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338752_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338752_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338752_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_nested_task_338752_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_nested_task_338752_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338752_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_nested_task_338752_iter[i]),
                    (long) ctx->futhark_mc_segmap_nested_task_338752_iter[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338752_iter[i] /
                    (ctx->futhark_mc_segmap_nested_task_338752_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338752_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338763         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338763_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338763_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338763_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338763_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338763_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338763_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338763_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338763_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338763_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338763_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338763_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338763_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338763_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338763_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338763_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338763_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338763_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338763_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338763_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338763_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338763_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338763_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338763_total_iter /
                (ctx->futhark_mc_segmap_parloop_338763_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338763_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338763_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338763_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338778         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338778_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338778_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338778_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338778_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338778_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338778_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338778_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338778_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338778_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338778_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338778_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338778_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338778_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338778_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338778_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338778_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338778_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338778_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338778_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338778_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338778_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338778_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338778_total_iter /
                (ctx->futhark_mc_segmap_parloop_338778_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338778_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338778_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338778_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_338776            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_338776_runs[i],
                    (long) ctx->futhark_mc_segmap_task_338776_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338776_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338776_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_338776_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_338776_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338776_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_338776_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_338776_iter[i],
                    (long) ctx->futhark_mc_segmap_task_338776_iter[i] /
                    (ctx->futhark_mc_segmap_task_338776_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338776_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338782         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338782_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338782_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338782_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338782_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338782_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338782_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338782_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338782_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338782_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338782_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338782_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338782_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338782_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338782_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338782_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338782_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338782_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338782_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338782_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338782_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338782_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338782_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338782_total_iter /
                (ctx->futhark_mc_segmap_parloop_338782_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338782_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338782_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338782_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_338780            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_338780_runs[i],
                    (long) ctx->futhark_mc_segmap_task_338780_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338780_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338780_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_338780_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_338780_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338780_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_338780_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_338780_iter[i],
                    (long) ctx->futhark_mc_segmap_task_338780_iter[i] /
                    (ctx->futhark_mc_segmap_task_338780_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338780_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338786         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338786_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338786_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338786_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338786_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338786_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338786_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338786_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338786_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338786_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338786_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338786_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338786_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338786_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338786_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338786_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338786_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338786_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338786_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338786_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338786_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338786_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338786_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338786_total_iter /
                (ctx->futhark_mc_segmap_parloop_338786_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338786_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338786_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338786_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_stage_1_parloop_338794 ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_stage_1_parloop_338794_runs[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338794_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338794_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_338794_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338794_total_runtime[i],
                    (double) ctx->futhark_mc_segred_stage_1_parloop_338794_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338794_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_338794_iter[i]),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338794_iter[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338794_iter[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338794_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_338794_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segred_stage_1_parloop_338794_total ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segred_stage_1_parloop_338794_total_runs,
                (long) ctx->futhark_mc_segred_stage_1_parloop_338794_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_338794_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_338794_total_runs : 1),
                (long) ctx->futhark_mc_segred_stage_1_parloop_338794_total_total_runtime,
                (double) ctx->futhark_mc_segred_stage_1_parloop_338794_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_338794_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_338794_total_iter),
                (long) ctx->futhark_mc_segred_stage_1_parloop_338794_total_iter,
                (long) ctx->futhark_mc_segred_stage_1_parloop_338794_total_iter /
                (ctx->futhark_mc_segred_stage_1_parloop_338794_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_338794_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segred_stage_1_parloop_338794_total_total_runtime;
        ctx->total_runs +=
            ctx->futhark_mc_segred_stage_1_parloop_338794_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_task_338791            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_task_338791_runs[i],
                    (long) ctx->futhark_mc_segred_task_338791_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_338791_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_338791_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_task_338791_total_runtime[i],
                    (double) ctx->futhark_mc_segred_task_338791_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_338791_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_task_338791_iter[i]),
                    (long) ctx->futhark_mc_segred_task_338791_iter[i],
                    (long) ctx->futhark_mc_segred_task_338791_iter[i] /
                    (ctx->futhark_mc_segred_task_338791_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_338791_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_stage_1_parloop_338799 ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_stage_1_parloop_338799_runs[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338799_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338799_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_338799_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338799_total_runtime[i],
                    (double) ctx->futhark_mc_segred_stage_1_parloop_338799_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338799_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_338799_iter[i]),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338799_iter[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338799_iter[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338799_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_338799_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segred_stage_1_parloop_338799_total ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segred_stage_1_parloop_338799_total_runs,
                (long) ctx->futhark_mc_segred_stage_1_parloop_338799_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_338799_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_338799_total_runs : 1),
                (long) ctx->futhark_mc_segred_stage_1_parloop_338799_total_total_runtime,
                (double) ctx->futhark_mc_segred_stage_1_parloop_338799_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_338799_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_338799_total_iter),
                (long) ctx->futhark_mc_segred_stage_1_parloop_338799_total_iter,
                (long) ctx->futhark_mc_segred_stage_1_parloop_338799_total_iter /
                (ctx->futhark_mc_segred_stage_1_parloop_338799_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_338799_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segred_stage_1_parloop_338799_total_total_runtime;
        ctx->total_runs +=
            ctx->futhark_mc_segred_stage_1_parloop_338799_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_task_338796            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_task_338796_runs[i],
                    (long) ctx->futhark_mc_segred_task_338796_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_338796_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_338796_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_task_338796_total_runtime[i],
                    (double) ctx->futhark_mc_segred_task_338796_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_338796_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_task_338796_iter[i]),
                    (long) ctx->futhark_mc_segred_task_338796_iter[i],
                    (long) ctx->futhark_mc_segred_task_338796_iter[i] /
                    (ctx->futhark_mc_segred_task_338796_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_338796_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338789         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338789_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338789_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338789_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338789_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338789_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338789_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338789_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338789_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338789_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338789_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338789_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338789_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338789_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338789_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338789_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338789_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338789_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338789_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338789_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338789_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338789_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338789_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338789_total_iter /
                (ctx->futhark_mc_segmap_parloop_338789_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338789_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338789_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338789_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_338784            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_338784_runs[i],
                    (long) ctx->futhark_mc_segmap_task_338784_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338784_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338784_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_338784_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_338784_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338784_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_338784_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_338784_iter[i],
                    (long) ctx->futhark_mc_segmap_task_338784_iter[i] /
                    (ctx->futhark_mc_segmap_task_338784_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338784_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_nested_task_338787     ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_nested_task_338787_runs[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338787_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338787_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338787_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_nested_task_338787_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_nested_task_338787_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338787_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_nested_task_338787_iter[i]),
                    (long) ctx->futhark_mc_segmap_nested_task_338787_iter[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338787_iter[i] /
                    (ctx->futhark_mc_segmap_nested_task_338787_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338787_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338770         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338770_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338770_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338770_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338770_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338770_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338770_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338770_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338770_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338770_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338770_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338770_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338770_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338770_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338770_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338770_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338770_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338770_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338770_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338770_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338770_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338770_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338770_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338770_total_iter /
                (ctx->futhark_mc_segmap_parloop_338770_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338770_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338770_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338770_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_338761            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_338761_runs[i],
                    (long) ctx->futhark_mc_segmap_task_338761_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338761_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338761_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_338761_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_338761_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338761_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_338761_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_338761_iter[i],
                    (long) ctx->futhark_mc_segmap_task_338761_iter[i] /
                    (ctx->futhark_mc_segmap_task_338761_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338761_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_nested_task_338768     ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_nested_task_338768_runs[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338768_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338768_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338768_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_nested_task_338768_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_nested_task_338768_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338768_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_nested_task_338768_iter[i]),
                    (long) ctx->futhark_mc_segmap_nested_task_338768_iter[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338768_iter[i] /
                    (ctx->futhark_mc_segmap_nested_task_338768_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338768_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338803         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338803_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338803_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338803_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338803_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338803_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338803_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338803_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338803_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338803_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338803_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338803_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338803_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338803_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338803_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338803_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338803_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338803_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338803_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338803_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338803_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338803_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338803_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338803_total_iter /
                (ctx->futhark_mc_segmap_parloop_338803_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338803_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338803_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338803_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338820         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338820_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338820_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338820_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338820_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338820_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338820_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338820_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338820_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338820_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338820_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338820_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338820_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338820_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338820_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338820_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338820_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338820_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338820_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338820_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338820_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338820_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338820_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338820_total_iter /
                (ctx->futhark_mc_segmap_parloop_338820_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338820_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338820_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338820_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_338818            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_338818_runs[i],
                    (long) ctx->futhark_mc_segmap_task_338818_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338818_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338818_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_338818_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_338818_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338818_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_338818_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_338818_iter[i],
                    (long) ctx->futhark_mc_segmap_task_338818_iter[i] /
                    (ctx->futhark_mc_segmap_task_338818_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338818_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338824         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338824_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338824_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338824_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338824_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338824_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338824_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338824_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338824_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338824_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338824_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338824_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338824_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338824_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338824_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338824_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338824_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338824_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338824_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338824_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338824_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338824_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338824_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338824_total_iter /
                (ctx->futhark_mc_segmap_parloop_338824_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338824_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338824_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338824_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_338822            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_338822_runs[i],
                    (long) ctx->futhark_mc_segmap_task_338822_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338822_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338822_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_338822_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_338822_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338822_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_338822_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_338822_iter[i],
                    (long) ctx->futhark_mc_segmap_task_338822_iter[i] /
                    (ctx->futhark_mc_segmap_task_338822_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338822_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338828         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338828_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338828_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338828_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338828_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338828_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338828_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338828_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338828_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338828_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338828_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338828_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338828_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338828_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338828_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338828_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338828_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338828_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338828_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338828_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338828_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338828_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338828_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338828_total_iter /
                (ctx->futhark_mc_segmap_parloop_338828_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338828_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338828_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338828_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_stage_1_parloop_338838 ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_stage_1_parloop_338838_runs[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338838_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338838_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_338838_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338838_total_runtime[i],
                    (double) ctx->futhark_mc_segred_stage_1_parloop_338838_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338838_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_338838_iter[i]),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338838_iter[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338838_iter[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338838_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_338838_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segred_stage_1_parloop_338838_total ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segred_stage_1_parloop_338838_total_runs,
                (long) ctx->futhark_mc_segred_stage_1_parloop_338838_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_338838_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_338838_total_runs : 1),
                (long) ctx->futhark_mc_segred_stage_1_parloop_338838_total_total_runtime,
                (double) ctx->futhark_mc_segred_stage_1_parloop_338838_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_338838_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_338838_total_iter),
                (long) ctx->futhark_mc_segred_stage_1_parloop_338838_total_iter,
                (long) ctx->futhark_mc_segred_stage_1_parloop_338838_total_iter /
                (ctx->futhark_mc_segred_stage_1_parloop_338838_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_338838_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segred_stage_1_parloop_338838_total_total_runtime;
        ctx->total_runs +=
            ctx->futhark_mc_segred_stage_1_parloop_338838_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_task_338833            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_task_338833_runs[i],
                    (long) ctx->futhark_mc_segred_task_338833_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_338833_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_338833_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_task_338833_total_runtime[i],
                    (double) ctx->futhark_mc_segred_task_338833_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_338833_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_task_338833_iter[i]),
                    (long) ctx->futhark_mc_segred_task_338833_iter[i],
                    (long) ctx->futhark_mc_segred_task_338833_iter[i] /
                    (ctx->futhark_mc_segred_task_338833_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_338833_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_stage_1_parloop_338844 ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_stage_1_parloop_338844_runs[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338844_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338844_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_338844_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338844_total_runtime[i],
                    (double) ctx->futhark_mc_segred_stage_1_parloop_338844_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338844_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_338844_iter[i]),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338844_iter[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338844_iter[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338844_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_338844_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segred_stage_1_parloop_338844_total ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segred_stage_1_parloop_338844_total_runs,
                (long) ctx->futhark_mc_segred_stage_1_parloop_338844_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_338844_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_338844_total_runs : 1),
                (long) ctx->futhark_mc_segred_stage_1_parloop_338844_total_total_runtime,
                (double) ctx->futhark_mc_segred_stage_1_parloop_338844_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_338844_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_338844_total_iter),
                (long) ctx->futhark_mc_segred_stage_1_parloop_338844_total_iter,
                (long) ctx->futhark_mc_segred_stage_1_parloop_338844_total_iter /
                (ctx->futhark_mc_segred_stage_1_parloop_338844_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_338844_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segred_stage_1_parloop_338844_total_total_runtime;
        ctx->total_runs +=
            ctx->futhark_mc_segred_stage_1_parloop_338844_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_task_338840            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_task_338840_runs[i],
                    (long) ctx->futhark_mc_segred_task_338840_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_338840_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_338840_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_task_338840_total_runtime[i],
                    (double) ctx->futhark_mc_segred_task_338840_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_338840_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_task_338840_iter[i]),
                    (long) ctx->futhark_mc_segred_task_338840_iter[i],
                    (long) ctx->futhark_mc_segred_task_338840_iter[i] /
                    (ctx->futhark_mc_segred_task_338840_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_338840_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338831         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338831_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338831_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338831_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338831_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338831_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338831_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338831_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338831_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338831_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338831_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338831_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338831_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338831_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338831_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338831_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338831_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338831_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338831_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338831_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338831_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338831_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338831_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338831_total_iter /
                (ctx->futhark_mc_segmap_parloop_338831_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338831_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338831_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338831_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_338826            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_338826_runs[i],
                    (long) ctx->futhark_mc_segmap_task_338826_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338826_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338826_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_338826_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_338826_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338826_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_338826_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_338826_iter[i],
                    (long) ctx->futhark_mc_segmap_task_338826_iter[i] /
                    (ctx->futhark_mc_segmap_task_338826_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338826_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_nested_task_338829     ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_nested_task_338829_runs[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338829_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338829_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338829_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_nested_task_338829_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_nested_task_338829_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338829_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_nested_task_338829_iter[i]),
                    (long) ctx->futhark_mc_segmap_nested_task_338829_iter[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338829_iter[i] /
                    (ctx->futhark_mc_segmap_nested_task_338829_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338829_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338811         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338811_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338811_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338811_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338811_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338811_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338811_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338811_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338811_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338811_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338811_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338811_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338811_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338811_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338811_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338811_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338811_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338811_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338811_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338811_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338811_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338811_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338811_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338811_total_iter /
                (ctx->futhark_mc_segmap_parloop_338811_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338811_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338811_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338811_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_338801            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_338801_runs[i],
                    (long) ctx->futhark_mc_segmap_task_338801_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338801_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338801_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_338801_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_338801_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338801_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_338801_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_338801_iter[i],
                    (long) ctx->futhark_mc_segmap_task_338801_iter[i] /
                    (ctx->futhark_mc_segmap_task_338801_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338801_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_nested_task_338809     ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_nested_task_338809_runs[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338809_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338809_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338809_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_nested_task_338809_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_nested_task_338809_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338809_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_nested_task_338809_iter[i]),
                    (long) ctx->futhark_mc_segmap_nested_task_338809_iter[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338809_iter[i] /
                    (ctx->futhark_mc_segmap_nested_task_338809_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338809_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338848         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338848_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338848_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338848_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338848_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338848_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338848_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338848_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338848_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338848_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338848_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338848_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338848_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338848_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338848_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338848_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338848_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338848_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338848_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338848_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338848_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338848_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338848_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338848_total_iter /
                (ctx->futhark_mc_segmap_parloop_338848_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338848_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338848_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338848_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338865         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338865_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338865_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338865_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338865_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338865_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338865_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338865_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338865_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338865_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338865_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338865_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338865_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338865_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338865_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338865_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338865_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338865_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338865_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338865_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338865_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338865_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338865_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338865_total_iter /
                (ctx->futhark_mc_segmap_parloop_338865_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338865_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338865_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338865_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_338863            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_338863_runs[i],
                    (long) ctx->futhark_mc_segmap_task_338863_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338863_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338863_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_338863_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_338863_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338863_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_338863_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_338863_iter[i],
                    (long) ctx->futhark_mc_segmap_task_338863_iter[i] /
                    (ctx->futhark_mc_segmap_task_338863_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338863_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338869         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338869_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338869_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338869_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338869_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338869_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338869_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338869_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338869_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338869_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338869_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338869_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338869_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338869_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338869_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338869_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338869_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338869_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338869_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338869_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338869_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338869_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338869_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338869_total_iter /
                (ctx->futhark_mc_segmap_parloop_338869_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338869_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338869_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338869_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_338867            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_338867_runs[i],
                    (long) ctx->futhark_mc_segmap_task_338867_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338867_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338867_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_338867_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_338867_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338867_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_338867_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_338867_iter[i],
                    (long) ctx->futhark_mc_segmap_task_338867_iter[i] /
                    (ctx->futhark_mc_segmap_task_338867_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338867_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338873         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338873_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338873_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338873_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338873_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338873_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338873_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338873_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338873_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338873_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338873_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338873_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338873_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338873_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338873_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338873_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338873_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338873_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338873_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338873_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338873_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338873_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338873_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338873_total_iter /
                (ctx->futhark_mc_segmap_parloop_338873_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338873_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338873_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338873_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_stage_1_parloop_338885 ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_stage_1_parloop_338885_runs[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338885_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338885_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_338885_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338885_total_runtime[i],
                    (double) ctx->futhark_mc_segred_stage_1_parloop_338885_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338885_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_338885_iter[i]),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338885_iter[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338885_iter[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338885_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_338885_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segred_stage_1_parloop_338885_total ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segred_stage_1_parloop_338885_total_runs,
                (long) ctx->futhark_mc_segred_stage_1_parloop_338885_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_338885_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_338885_total_runs : 1),
                (long) ctx->futhark_mc_segred_stage_1_parloop_338885_total_total_runtime,
                (double) ctx->futhark_mc_segred_stage_1_parloop_338885_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_338885_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_338885_total_iter),
                (long) ctx->futhark_mc_segred_stage_1_parloop_338885_total_iter,
                (long) ctx->futhark_mc_segred_stage_1_parloop_338885_total_iter /
                (ctx->futhark_mc_segred_stage_1_parloop_338885_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_338885_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segred_stage_1_parloop_338885_total_total_runtime;
        ctx->total_runs +=
            ctx->futhark_mc_segred_stage_1_parloop_338885_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_task_338878            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_task_338878_runs[i],
                    (long) ctx->futhark_mc_segred_task_338878_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_338878_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_338878_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_task_338878_total_runtime[i],
                    (double) ctx->futhark_mc_segred_task_338878_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_338878_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_task_338878_iter[i]),
                    (long) ctx->futhark_mc_segred_task_338878_iter[i],
                    (long) ctx->futhark_mc_segred_task_338878_iter[i] /
                    (ctx->futhark_mc_segred_task_338878_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_338878_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_stage_1_parloop_338891 ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_stage_1_parloop_338891_runs[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338891_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338891_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_338891_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338891_total_runtime[i],
                    (double) ctx->futhark_mc_segred_stage_1_parloop_338891_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338891_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_338891_iter[i]),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338891_iter[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338891_iter[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338891_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_338891_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segred_stage_1_parloop_338891_total ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segred_stage_1_parloop_338891_total_runs,
                (long) ctx->futhark_mc_segred_stage_1_parloop_338891_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_338891_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_338891_total_runs : 1),
                (long) ctx->futhark_mc_segred_stage_1_parloop_338891_total_total_runtime,
                (double) ctx->futhark_mc_segred_stage_1_parloop_338891_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_338891_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_338891_total_iter),
                (long) ctx->futhark_mc_segred_stage_1_parloop_338891_total_iter,
                (long) ctx->futhark_mc_segred_stage_1_parloop_338891_total_iter /
                (ctx->futhark_mc_segred_stage_1_parloop_338891_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_338891_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segred_stage_1_parloop_338891_total_total_runtime;
        ctx->total_runs +=
            ctx->futhark_mc_segred_stage_1_parloop_338891_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_task_338887            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_task_338887_runs[i],
                    (long) ctx->futhark_mc_segred_task_338887_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_338887_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_338887_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_task_338887_total_runtime[i],
                    (double) ctx->futhark_mc_segred_task_338887_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_338887_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_task_338887_iter[i]),
                    (long) ctx->futhark_mc_segred_task_338887_iter[i],
                    (long) ctx->futhark_mc_segred_task_338887_iter[i] /
                    (ctx->futhark_mc_segred_task_338887_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_338887_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338876         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338876_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338876_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338876_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338876_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338876_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338876_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338876_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338876_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338876_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338876_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338876_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338876_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338876_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338876_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338876_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338876_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338876_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338876_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338876_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338876_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338876_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338876_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338876_total_iter /
                (ctx->futhark_mc_segmap_parloop_338876_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338876_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338876_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338876_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_338871            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_338871_runs[i],
                    (long) ctx->futhark_mc_segmap_task_338871_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338871_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338871_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_338871_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_338871_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338871_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_338871_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_338871_iter[i],
                    (long) ctx->futhark_mc_segmap_task_338871_iter[i] /
                    (ctx->futhark_mc_segmap_task_338871_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338871_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_nested_task_338874     ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_nested_task_338874_runs[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338874_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338874_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338874_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_nested_task_338874_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_nested_task_338874_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338874_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_nested_task_338874_iter[i]),
                    (long) ctx->futhark_mc_segmap_nested_task_338874_iter[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338874_iter[i] /
                    (ctx->futhark_mc_segmap_nested_task_338874_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338874_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338856         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338856_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338856_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338856_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338856_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338856_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338856_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338856_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338856_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338856_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338856_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338856_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338856_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338856_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338856_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338856_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338856_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338856_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338856_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338856_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338856_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338856_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338856_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338856_total_iter /
                (ctx->futhark_mc_segmap_parloop_338856_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338856_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338856_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338856_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_338846            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_338846_runs[i],
                    (long) ctx->futhark_mc_segmap_task_338846_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338846_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338846_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_338846_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_338846_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338846_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_338846_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_338846_iter[i],
                    (long) ctx->futhark_mc_segmap_task_338846_iter[i] /
                    (ctx->futhark_mc_segmap_task_338846_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338846_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_nested_task_338854     ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_nested_task_338854_runs[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338854_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338854_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338854_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_nested_task_338854_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_nested_task_338854_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338854_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_nested_task_338854_iter[i]),
                    (long) ctx->futhark_mc_segmap_nested_task_338854_iter[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338854_iter[i] /
                    (ctx->futhark_mc_segmap_nested_task_338854_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338854_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338895         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338895_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338895_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338895_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338895_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338895_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338895_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338895_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338895_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338895_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338895_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338895_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338895_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338895_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338895_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338895_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338895_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338895_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338895_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338895_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338895_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338895_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338895_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338895_total_iter /
                (ctx->futhark_mc_segmap_parloop_338895_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338895_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338895_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338895_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338911         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338911_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338911_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338911_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338911_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338911_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338911_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338911_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338911_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338911_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338911_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338911_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338911_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338911_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338911_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338911_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338911_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338911_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338911_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338911_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338911_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338911_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338911_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338911_total_iter /
                (ctx->futhark_mc_segmap_parloop_338911_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338911_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338911_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338911_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_338909            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_338909_runs[i],
                    (long) ctx->futhark_mc_segmap_task_338909_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338909_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338909_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_338909_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_338909_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338909_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_338909_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_338909_iter[i],
                    (long) ctx->futhark_mc_segmap_task_338909_iter[i] /
                    (ctx->futhark_mc_segmap_task_338909_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338909_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338915         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338915_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338915_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338915_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338915_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338915_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338915_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338915_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338915_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338915_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338915_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338915_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338915_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338915_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338915_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338915_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338915_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338915_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338915_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338915_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338915_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338915_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338915_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338915_total_iter /
                (ctx->futhark_mc_segmap_parloop_338915_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338915_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338915_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338915_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_338913            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_338913_runs[i],
                    (long) ctx->futhark_mc_segmap_task_338913_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338913_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338913_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_338913_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_338913_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338913_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_338913_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_338913_iter[i],
                    (long) ctx->futhark_mc_segmap_task_338913_iter[i] /
                    (ctx->futhark_mc_segmap_task_338913_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338913_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338919         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338919_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338919_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338919_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338919_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338919_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338919_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338919_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338919_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338919_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338919_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338919_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338919_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338919_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338919_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338919_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338919_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338919_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338919_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338919_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338919_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338919_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338919_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338919_total_iter /
                (ctx->futhark_mc_segmap_parloop_338919_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338919_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338919_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338919_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_stage_1_parloop_338929 ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_stage_1_parloop_338929_runs[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338929_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338929_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_338929_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338929_total_runtime[i],
                    (double) ctx->futhark_mc_segred_stage_1_parloop_338929_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338929_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_338929_iter[i]),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338929_iter[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338929_iter[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338929_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_338929_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segred_stage_1_parloop_338929_total ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segred_stage_1_parloop_338929_total_runs,
                (long) ctx->futhark_mc_segred_stage_1_parloop_338929_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_338929_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_338929_total_runs : 1),
                (long) ctx->futhark_mc_segred_stage_1_parloop_338929_total_total_runtime,
                (double) ctx->futhark_mc_segred_stage_1_parloop_338929_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_338929_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_338929_total_iter),
                (long) ctx->futhark_mc_segred_stage_1_parloop_338929_total_iter,
                (long) ctx->futhark_mc_segred_stage_1_parloop_338929_total_iter /
                (ctx->futhark_mc_segred_stage_1_parloop_338929_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_338929_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segred_stage_1_parloop_338929_total_total_runtime;
        ctx->total_runs +=
            ctx->futhark_mc_segred_stage_1_parloop_338929_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_task_338926            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_task_338926_runs[i],
                    (long) ctx->futhark_mc_segred_task_338926_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_338926_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_338926_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_task_338926_total_runtime[i],
                    (double) ctx->futhark_mc_segred_task_338926_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_338926_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_task_338926_iter[i]),
                    (long) ctx->futhark_mc_segred_task_338926_iter[i],
                    (long) ctx->futhark_mc_segred_task_338926_iter[i] /
                    (ctx->futhark_mc_segred_task_338926_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_338926_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_stage_1_parloop_338934 ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_stage_1_parloop_338934_runs[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338934_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338934_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_338934_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338934_total_runtime[i],
                    (double) ctx->futhark_mc_segred_stage_1_parloop_338934_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338934_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_338934_iter[i]),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338934_iter[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338934_iter[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338934_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_338934_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segred_stage_1_parloop_338934_total ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segred_stage_1_parloop_338934_total_runs,
                (long) ctx->futhark_mc_segred_stage_1_parloop_338934_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_338934_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_338934_total_runs : 1),
                (long) ctx->futhark_mc_segred_stage_1_parloop_338934_total_total_runtime,
                (double) ctx->futhark_mc_segred_stage_1_parloop_338934_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_338934_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_338934_total_iter),
                (long) ctx->futhark_mc_segred_stage_1_parloop_338934_total_iter,
                (long) ctx->futhark_mc_segred_stage_1_parloop_338934_total_iter /
                (ctx->futhark_mc_segred_stage_1_parloop_338934_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_338934_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segred_stage_1_parloop_338934_total_total_runtime;
        ctx->total_runs +=
            ctx->futhark_mc_segred_stage_1_parloop_338934_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_task_338931            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_task_338931_runs[i],
                    (long) ctx->futhark_mc_segred_task_338931_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_338931_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_338931_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_task_338931_total_runtime[i],
                    (double) ctx->futhark_mc_segred_task_338931_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_338931_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_task_338931_iter[i]),
                    (long) ctx->futhark_mc_segred_task_338931_iter[i],
                    (long) ctx->futhark_mc_segred_task_338931_iter[i] /
                    (ctx->futhark_mc_segred_task_338931_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_338931_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338923         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338923_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338923_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338923_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338923_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338923_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338923_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338923_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338923_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338923_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338923_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338923_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338923_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338923_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338923_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338923_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338923_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338923_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338923_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338923_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338923_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338923_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338923_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338923_total_iter /
                (ctx->futhark_mc_segmap_parloop_338923_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338923_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338923_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338923_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_338917            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_338917_runs[i],
                    (long) ctx->futhark_mc_segmap_task_338917_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338917_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338917_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_338917_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_338917_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338917_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_338917_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_338917_iter[i],
                    (long) ctx->futhark_mc_segmap_task_338917_iter[i] /
                    (ctx->futhark_mc_segmap_task_338917_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338917_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_nested_task_338921     ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_nested_task_338921_runs[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338921_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338921_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338921_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_nested_task_338921_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_nested_task_338921_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338921_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_nested_task_338921_iter[i]),
                    (long) ctx->futhark_mc_segmap_nested_task_338921_iter[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338921_iter[i] /
                    (ctx->futhark_mc_segmap_nested_task_338921_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338921_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338903         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338903_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338903_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338903_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338903_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338903_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338903_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338903_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338903_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338903_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338903_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338903_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338903_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338903_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338903_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338903_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338903_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338903_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338903_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338903_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338903_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338903_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338903_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338903_total_iter /
                (ctx->futhark_mc_segmap_parloop_338903_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338903_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338903_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338903_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_338893            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_338893_runs[i],
                    (long) ctx->futhark_mc_segmap_task_338893_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338893_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338893_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_338893_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_338893_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338893_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_338893_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_338893_iter[i],
                    (long) ctx->futhark_mc_segmap_task_338893_iter[i] /
                    (ctx->futhark_mc_segmap_task_338893_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338893_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_nested_task_338901     ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_nested_task_338901_runs[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338901_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338901_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338901_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_nested_task_338901_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_nested_task_338901_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338901_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_nested_task_338901_iter[i]),
                    (long) ctx->futhark_mc_segmap_nested_task_338901_iter[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338901_iter[i] /
                    (ctx->futhark_mc_segmap_nested_task_338901_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338901_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338938         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338938_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338938_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338938_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338938_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338938_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338938_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338938_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338938_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338938_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338938_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338938_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338938_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338938_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338938_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338938_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338938_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338938_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338938_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338938_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338938_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338938_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338938_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338938_total_iter /
                (ctx->futhark_mc_segmap_parloop_338938_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338938_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338938_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338938_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338957         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338957_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338957_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338957_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338957_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338957_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338957_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338957_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338957_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338957_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338957_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338957_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338957_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338957_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338957_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338957_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338957_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338957_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338957_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338957_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338957_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338957_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338957_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338957_total_iter /
                (ctx->futhark_mc_segmap_parloop_338957_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338957_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338957_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338957_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_338955            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_338955_runs[i],
                    (long) ctx->futhark_mc_segmap_task_338955_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338955_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338955_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_338955_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_338955_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338955_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_338955_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_338955_iter[i],
                    (long) ctx->futhark_mc_segmap_task_338955_iter[i] /
                    (ctx->futhark_mc_segmap_task_338955_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338955_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338961         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338961_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338961_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338961_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338961_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338961_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338961_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338961_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338961_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338961_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338961_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338961_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338961_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338961_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338961_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338961_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338961_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338961_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338961_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338961_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338961_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338961_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338961_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338961_total_iter /
                (ctx->futhark_mc_segmap_parloop_338961_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338961_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338961_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338961_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_338959            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_338959_runs[i],
                    (long) ctx->futhark_mc_segmap_task_338959_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338959_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338959_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_338959_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_338959_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338959_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_338959_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_338959_iter[i],
                    (long) ctx->futhark_mc_segmap_task_338959_iter[i] /
                    (ctx->futhark_mc_segmap_task_338959_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338959_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338965         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338965_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338965_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338965_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338965_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338965_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338965_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338965_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338965_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338965_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338965_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338965_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338965_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338965_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338965_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338965_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338965_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338965_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338965_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338965_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338965_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338965_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338965_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338965_total_iter /
                (ctx->futhark_mc_segmap_parloop_338965_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338965_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338965_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338965_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_stage_1_parloop_338979 ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_stage_1_parloop_338979_runs[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338979_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338979_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_338979_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338979_total_runtime[i],
                    (double) ctx->futhark_mc_segred_stage_1_parloop_338979_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338979_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_338979_iter[i]),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338979_iter[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338979_iter[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338979_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_338979_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segred_stage_1_parloop_338979_total ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segred_stage_1_parloop_338979_total_runs,
                (long) ctx->futhark_mc_segred_stage_1_parloop_338979_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_338979_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_338979_total_runs : 1),
                (long) ctx->futhark_mc_segred_stage_1_parloop_338979_total_total_runtime,
                (double) ctx->futhark_mc_segred_stage_1_parloop_338979_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_338979_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_338979_total_iter),
                (long) ctx->futhark_mc_segred_stage_1_parloop_338979_total_iter,
                (long) ctx->futhark_mc_segred_stage_1_parloop_338979_total_iter /
                (ctx->futhark_mc_segred_stage_1_parloop_338979_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_338979_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segred_stage_1_parloop_338979_total_total_runtime;
        ctx->total_runs +=
            ctx->futhark_mc_segred_stage_1_parloop_338979_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_task_338974            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_task_338974_runs[i],
                    (long) ctx->futhark_mc_segred_task_338974_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_338974_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_338974_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_task_338974_total_runtime[i],
                    (double) ctx->futhark_mc_segred_task_338974_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_338974_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_task_338974_iter[i]),
                    (long) ctx->futhark_mc_segred_task_338974_iter[i],
                    (long) ctx->futhark_mc_segred_task_338974_iter[i] /
                    (ctx->futhark_mc_segred_task_338974_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_338974_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_stage_1_parloop_338985 ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_stage_1_parloop_338985_runs[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338985_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338985_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_338985_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338985_total_runtime[i],
                    (double) ctx->futhark_mc_segred_stage_1_parloop_338985_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338985_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_338985_iter[i]),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338985_iter[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_338985_iter[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_338985_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_338985_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segred_stage_1_parloop_338985_total ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segred_stage_1_parloop_338985_total_runs,
                (long) ctx->futhark_mc_segred_stage_1_parloop_338985_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_338985_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_338985_total_runs : 1),
                (long) ctx->futhark_mc_segred_stage_1_parloop_338985_total_total_runtime,
                (double) ctx->futhark_mc_segred_stage_1_parloop_338985_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_338985_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_338985_total_iter),
                (long) ctx->futhark_mc_segred_stage_1_parloop_338985_total_iter,
                (long) ctx->futhark_mc_segred_stage_1_parloop_338985_total_iter /
                (ctx->futhark_mc_segred_stage_1_parloop_338985_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_338985_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segred_stage_1_parloop_338985_total_total_runtime;
        ctx->total_runs +=
            ctx->futhark_mc_segred_stage_1_parloop_338985_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_task_338981            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_task_338981_runs[i],
                    (long) ctx->futhark_mc_segred_task_338981_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_338981_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_338981_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_task_338981_total_runtime[i],
                    (double) ctx->futhark_mc_segred_task_338981_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_338981_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_task_338981_iter[i]),
                    (long) ctx->futhark_mc_segred_task_338981_iter[i],
                    (long) ctx->futhark_mc_segred_task_338981_iter[i] /
                    (ctx->futhark_mc_segred_task_338981_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_338981_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338970         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338970_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338970_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338970_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338970_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338970_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338970_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338970_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338970_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338970_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338970_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338970_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338970_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338970_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338970_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338970_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338970_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338970_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338970_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338970_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338970_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338970_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338970_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338970_total_iter /
                (ctx->futhark_mc_segmap_parloop_338970_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338970_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338970_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338970_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_338963            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_338963_runs[i],
                    (long) ctx->futhark_mc_segmap_task_338963_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338963_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338963_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_338963_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_338963_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338963_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_338963_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_338963_iter[i],
                    (long) ctx->futhark_mc_segmap_task_338963_iter[i] /
                    (ctx->futhark_mc_segmap_task_338963_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338963_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_nested_task_338968     ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_nested_task_338968_runs[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338968_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338968_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338968_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_nested_task_338968_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_nested_task_338968_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338968_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_nested_task_338968_iter[i]),
                    (long) ctx->futhark_mc_segmap_nested_task_338968_iter[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338968_iter[i] /
                    (ctx->futhark_mc_segmap_nested_task_338968_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338968_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338948         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338948_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338948_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338948_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338948_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338948_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338948_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338948_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338948_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338948_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338948_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338948_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338948_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338948_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338948_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338948_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338948_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338948_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338948_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338948_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338948_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338948_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338948_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338948_total_iter /
                (ctx->futhark_mc_segmap_parloop_338948_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338948_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338948_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338948_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_338936            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_338936_runs[i],
                    (long) ctx->futhark_mc_segmap_task_338936_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338936_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338936_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_338936_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_338936_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338936_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_338936_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_338936_iter[i],
                    (long) ctx->futhark_mc_segmap_task_338936_iter[i] /
                    (ctx->futhark_mc_segmap_task_338936_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338936_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_nested_task_338946     ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_nested_task_338946_runs[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338946_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338946_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338946_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_nested_task_338946_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_nested_task_338946_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338946_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_nested_task_338946_iter[i]),
                    (long) ctx->futhark_mc_segmap_nested_task_338946_iter[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338946_iter[i] /
                    (ctx->futhark_mc_segmap_nested_task_338946_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338946_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_338989         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_338989_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_338989_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338989_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338989_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_338989_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_338989_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_338989_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338989_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_338989_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_338989_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_338989_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_338989_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_338989_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_338989_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_338989_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338989_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338989_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_338989_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_338989_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_338989_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_338989_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_338989_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_338989_total_iter /
                (ctx->futhark_mc_segmap_parloop_338989_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_338989_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_338989_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_338989_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_339010         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_339010_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_339010_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339010_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339010_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_339010_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_339010_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339010_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339010_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_339010_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_339010_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_339010_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339010_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_339010_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_339010_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_339010_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339010_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339010_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_339010_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_339010_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339010_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339010_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_339010_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_339010_total_iter /
                (ctx->futhark_mc_segmap_parloop_339010_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339010_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_339010_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_339010_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_339008            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_339008_runs[i],
                    (long) ctx->futhark_mc_segmap_task_339008_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_339008_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_339008_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_339008_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_339008_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_339008_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_339008_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_339008_iter[i],
                    (long) ctx->futhark_mc_segmap_task_339008_iter[i] /
                    (ctx->futhark_mc_segmap_task_339008_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_339008_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_339014         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_339014_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_339014_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339014_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339014_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_339014_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_339014_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339014_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339014_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_339014_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_339014_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_339014_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339014_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_339014_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_339014_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_339014_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339014_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339014_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_339014_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_339014_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339014_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339014_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_339014_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_339014_total_iter /
                (ctx->futhark_mc_segmap_parloop_339014_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339014_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_339014_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_339014_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_339012            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_339012_runs[i],
                    (long) ctx->futhark_mc_segmap_task_339012_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_339012_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_339012_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_339012_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_339012_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_339012_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_339012_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_339012_iter[i],
                    (long) ctx->futhark_mc_segmap_task_339012_iter[i] /
                    (ctx->futhark_mc_segmap_task_339012_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_339012_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_339018         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_339018_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_339018_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339018_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339018_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_339018_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_339018_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339018_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339018_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_339018_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_339018_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_339018_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339018_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_339018_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_339018_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_339018_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339018_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339018_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_339018_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_339018_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339018_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339018_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_339018_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_339018_total_iter /
                (ctx->futhark_mc_segmap_parloop_339018_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339018_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_339018_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_339018_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_339033         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_339033_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_339033_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339033_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339033_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_339033_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_339033_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339033_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339033_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_339033_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_339033_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_339033_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339033_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_339033_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_339033_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_339033_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339033_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339033_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_339033_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_339033_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339033_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339033_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_339033_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_339033_total_iter /
                (ctx->futhark_mc_segmap_parloop_339033_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339033_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_339033_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_339033_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_339031            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_339031_runs[i],
                    (long) ctx->futhark_mc_segmap_task_339031_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_339031_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_339031_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_339031_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_339031_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_339031_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_339031_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_339031_iter[i],
                    (long) ctx->futhark_mc_segmap_task_339031_iter[i] /
                    (ctx->futhark_mc_segmap_task_339031_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_339031_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_stage_1_parloop_339042 ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_stage_1_parloop_339042_runs[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_339042_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_339042_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_339042_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_339042_total_runtime[i],
                    (double) ctx->futhark_mc_segred_stage_1_parloop_339042_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_339042_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_339042_iter[i]),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_339042_iter[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_339042_iter[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_339042_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_339042_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segred_stage_1_parloop_339042_total ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segred_stage_1_parloop_339042_total_runs,
                (long) ctx->futhark_mc_segred_stage_1_parloop_339042_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_339042_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_339042_total_runs : 1),
                (long) ctx->futhark_mc_segred_stage_1_parloop_339042_total_total_runtime,
                (double) ctx->futhark_mc_segred_stage_1_parloop_339042_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_339042_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_339042_total_iter),
                (long) ctx->futhark_mc_segred_stage_1_parloop_339042_total_iter,
                (long) ctx->futhark_mc_segred_stage_1_parloop_339042_total_iter /
                (ctx->futhark_mc_segred_stage_1_parloop_339042_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_339042_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segred_stage_1_parloop_339042_total_total_runtime;
        ctx->total_runs +=
            ctx->futhark_mc_segred_stage_1_parloop_339042_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_task_339035            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_task_339035_runs[i],
                    (long) ctx->futhark_mc_segred_task_339035_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_339035_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_339035_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_task_339035_total_runtime[i],
                    (double) ctx->futhark_mc_segred_task_339035_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_339035_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_task_339035_iter[i]),
                    (long) ctx->futhark_mc_segred_task_339035_iter[i],
                    (long) ctx->futhark_mc_segred_task_339035_iter[i] /
                    (ctx->futhark_mc_segred_task_339035_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_339035_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_stage_1_parloop_339048 ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_stage_1_parloop_339048_runs[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_339048_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_339048_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_339048_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_339048_total_runtime[i],
                    (double) ctx->futhark_mc_segred_stage_1_parloop_339048_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_339048_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_339048_iter[i]),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_339048_iter[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_339048_iter[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_339048_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_339048_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segred_stage_1_parloop_339048_total ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segred_stage_1_parloop_339048_total_runs,
                (long) ctx->futhark_mc_segred_stage_1_parloop_339048_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_339048_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_339048_total_runs : 1),
                (long) ctx->futhark_mc_segred_stage_1_parloop_339048_total_total_runtime,
                (double) ctx->futhark_mc_segred_stage_1_parloop_339048_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_339048_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_339048_total_iter),
                (long) ctx->futhark_mc_segred_stage_1_parloop_339048_total_iter,
                (long) ctx->futhark_mc_segred_stage_1_parloop_339048_total_iter /
                (ctx->futhark_mc_segred_stage_1_parloop_339048_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_339048_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segred_stage_1_parloop_339048_total_total_runtime;
        ctx->total_runs +=
            ctx->futhark_mc_segred_stage_1_parloop_339048_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_task_339044            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_task_339044_runs[i],
                    (long) ctx->futhark_mc_segred_task_339044_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_339044_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_339044_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_task_339044_total_runtime[i],
                    (double) ctx->futhark_mc_segred_task_339044_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_339044_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_task_339044_iter[i]),
                    (long) ctx->futhark_mc_segred_task_339044_iter[i],
                    (long) ctx->futhark_mc_segred_task_339044_iter[i] /
                    (ctx->futhark_mc_segred_task_339044_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_339044_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_339025         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_339025_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_339025_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339025_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339025_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_339025_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_339025_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339025_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339025_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_339025_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_339025_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_339025_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339025_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_339025_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_339025_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_339025_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339025_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339025_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_339025_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_339025_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339025_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339025_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_339025_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_339025_total_iter /
                (ctx->futhark_mc_segmap_parloop_339025_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339025_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_339025_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_339025_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_339016            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_339016_runs[i],
                    (long) ctx->futhark_mc_segmap_task_339016_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_339016_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_339016_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_339016_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_339016_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_339016_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_339016_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_339016_iter[i],
                    (long) ctx->futhark_mc_segmap_task_339016_iter[i] /
                    (ctx->futhark_mc_segmap_task_339016_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_339016_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_nested_task_339023     ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_nested_task_339023_runs[i],
                    (long) ctx->futhark_mc_segmap_nested_task_339023_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_339023_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_339023_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_nested_task_339023_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_nested_task_339023_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_339023_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_nested_task_339023_iter[i]),
                    (long) ctx->futhark_mc_segmap_nested_task_339023_iter[i],
                    (long) ctx->futhark_mc_segmap_nested_task_339023_iter[i] /
                    (ctx->futhark_mc_segmap_nested_task_339023_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_339023_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_339001         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_339001_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_339001_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339001_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339001_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_339001_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_339001_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339001_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339001_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_339001_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_339001_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_339001_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339001_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_339001_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_339001_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_339001_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339001_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339001_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_339001_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_339001_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339001_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339001_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_339001_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_339001_total_iter /
                (ctx->futhark_mc_segmap_parloop_339001_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339001_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_339001_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_339001_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_338987            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_338987_runs[i],
                    (long) ctx->futhark_mc_segmap_task_338987_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338987_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338987_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_338987_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_338987_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_338987_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_338987_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_338987_iter[i],
                    (long) ctx->futhark_mc_segmap_task_338987_iter[i] /
                    (ctx->futhark_mc_segmap_task_338987_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_338987_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_nested_task_338999     ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_nested_task_338999_runs[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338999_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338999_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338999_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_nested_task_338999_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_nested_task_338999_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_338999_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_nested_task_338999_iter[i]),
                    (long) ctx->futhark_mc_segmap_nested_task_338999_iter[i],
                    (long) ctx->futhark_mc_segmap_nested_task_338999_iter[i] /
                    (ctx->futhark_mc_segmap_nested_task_338999_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_338999_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_339052         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_339052_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_339052_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339052_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339052_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_339052_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_339052_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339052_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339052_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_339052_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_339052_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_339052_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339052_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_339052_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_339052_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_339052_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339052_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339052_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_339052_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_339052_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339052_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339052_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_339052_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_339052_total_iter /
                (ctx->futhark_mc_segmap_parloop_339052_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339052_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_339052_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_339052_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_339067         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_339067_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_339067_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339067_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339067_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_339067_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_339067_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339067_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339067_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_339067_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_339067_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_339067_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339067_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_339067_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_339067_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_339067_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339067_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339067_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_339067_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_339067_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339067_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339067_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_339067_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_339067_total_iter /
                (ctx->futhark_mc_segmap_parloop_339067_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339067_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_339067_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_339067_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_339065            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_339065_runs[i],
                    (long) ctx->futhark_mc_segmap_task_339065_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_339065_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_339065_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_339065_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_339065_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_339065_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_339065_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_339065_iter[i],
                    (long) ctx->futhark_mc_segmap_task_339065_iter[i] /
                    (ctx->futhark_mc_segmap_task_339065_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_339065_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_339071         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_339071_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_339071_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339071_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339071_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_339071_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_339071_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339071_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339071_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_339071_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_339071_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_339071_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339071_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_339071_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_339071_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_339071_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339071_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339071_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_339071_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_339071_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339071_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339071_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_339071_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_339071_total_iter /
                (ctx->futhark_mc_segmap_parloop_339071_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339071_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_339071_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_339071_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_339069            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_339069_runs[i],
                    (long) ctx->futhark_mc_segmap_task_339069_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_339069_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_339069_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_339069_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_339069_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_339069_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_339069_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_339069_iter[i],
                    (long) ctx->futhark_mc_segmap_task_339069_iter[i] /
                    (ctx->futhark_mc_segmap_task_339069_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_339069_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_339075         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_339075_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_339075_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339075_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339075_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_339075_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_339075_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339075_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339075_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_339075_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_339075_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_339075_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339075_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_339075_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_339075_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_339075_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339075_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339075_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_339075_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_339075_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339075_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339075_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_339075_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_339075_total_iter /
                (ctx->futhark_mc_segmap_parloop_339075_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339075_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_339075_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_339075_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_stage_1_parloop_339083 ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_stage_1_parloop_339083_runs[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_339083_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_339083_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_339083_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_339083_total_runtime[i],
                    (double) ctx->futhark_mc_segred_stage_1_parloop_339083_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_339083_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_339083_iter[i]),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_339083_iter[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_339083_iter[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_339083_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_339083_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segred_stage_1_parloop_339083_total ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segred_stage_1_parloop_339083_total_runs,
                (long) ctx->futhark_mc_segred_stage_1_parloop_339083_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_339083_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_339083_total_runs : 1),
                (long) ctx->futhark_mc_segred_stage_1_parloop_339083_total_total_runtime,
                (double) ctx->futhark_mc_segred_stage_1_parloop_339083_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_339083_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_339083_total_iter),
                (long) ctx->futhark_mc_segred_stage_1_parloop_339083_total_iter,
                (long) ctx->futhark_mc_segred_stage_1_parloop_339083_total_iter /
                (ctx->futhark_mc_segred_stage_1_parloop_339083_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_339083_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segred_stage_1_parloop_339083_total_total_runtime;
        ctx->total_runs +=
            ctx->futhark_mc_segred_stage_1_parloop_339083_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_task_339080            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_task_339080_runs[i],
                    (long) ctx->futhark_mc_segred_task_339080_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_339080_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_339080_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_task_339080_total_runtime[i],
                    (double) ctx->futhark_mc_segred_task_339080_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_339080_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_task_339080_iter[i]),
                    (long) ctx->futhark_mc_segred_task_339080_iter[i],
                    (long) ctx->futhark_mc_segred_task_339080_iter[i] /
                    (ctx->futhark_mc_segred_task_339080_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_339080_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_stage_1_parloop_339088 ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_stage_1_parloop_339088_runs[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_339088_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_339088_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_339088_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_339088_total_runtime[i],
                    (double) ctx->futhark_mc_segred_stage_1_parloop_339088_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_339088_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_339088_iter[i]),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_339088_iter[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_339088_iter[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_339088_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_339088_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segred_stage_1_parloop_339088_total ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segred_stage_1_parloop_339088_total_runs,
                (long) ctx->futhark_mc_segred_stage_1_parloop_339088_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_339088_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_339088_total_runs : 1),
                (long) ctx->futhark_mc_segred_stage_1_parloop_339088_total_total_runtime,
                (double) ctx->futhark_mc_segred_stage_1_parloop_339088_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_339088_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_339088_total_iter),
                (long) ctx->futhark_mc_segred_stage_1_parloop_339088_total_iter,
                (long) ctx->futhark_mc_segred_stage_1_parloop_339088_total_iter /
                (ctx->futhark_mc_segred_stage_1_parloop_339088_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_339088_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segred_stage_1_parloop_339088_total_total_runtime;
        ctx->total_runs +=
            ctx->futhark_mc_segred_stage_1_parloop_339088_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_task_339085            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_task_339085_runs[i],
                    (long) ctx->futhark_mc_segred_task_339085_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_339085_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_339085_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_task_339085_total_runtime[i],
                    (double) ctx->futhark_mc_segred_task_339085_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_339085_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_task_339085_iter[i]),
                    (long) ctx->futhark_mc_segred_task_339085_iter[i],
                    (long) ctx->futhark_mc_segred_task_339085_iter[i] /
                    (ctx->futhark_mc_segred_task_339085_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_339085_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_339078         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_339078_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_339078_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339078_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339078_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_339078_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_339078_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339078_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339078_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_339078_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_339078_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_339078_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339078_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_339078_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_339078_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_339078_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339078_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339078_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_339078_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_339078_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339078_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339078_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_339078_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_339078_total_iter /
                (ctx->futhark_mc_segmap_parloop_339078_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339078_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_339078_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_339078_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_339073            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_339073_runs[i],
                    (long) ctx->futhark_mc_segmap_task_339073_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_339073_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_339073_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_339073_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_339073_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_339073_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_339073_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_339073_iter[i],
                    (long) ctx->futhark_mc_segmap_task_339073_iter[i] /
                    (ctx->futhark_mc_segmap_task_339073_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_339073_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_nested_task_339076     ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_nested_task_339076_runs[i],
                    (long) ctx->futhark_mc_segmap_nested_task_339076_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_339076_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_339076_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_nested_task_339076_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_nested_task_339076_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_339076_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_nested_task_339076_iter[i]),
                    (long) ctx->futhark_mc_segmap_nested_task_339076_iter[i],
                    (long) ctx->futhark_mc_segmap_nested_task_339076_iter[i] /
                    (ctx->futhark_mc_segmap_nested_task_339076_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_339076_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_339059         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_339059_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_339059_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339059_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339059_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_339059_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_339059_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339059_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339059_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_339059_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_339059_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_339059_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339059_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_339059_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_339059_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_339059_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339059_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339059_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_339059_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_339059_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339059_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339059_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_339059_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_339059_total_iter /
                (ctx->futhark_mc_segmap_parloop_339059_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339059_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_339059_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_339059_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_339050            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_339050_runs[i],
                    (long) ctx->futhark_mc_segmap_task_339050_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_339050_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_339050_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_339050_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_339050_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_339050_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_339050_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_339050_iter[i],
                    (long) ctx->futhark_mc_segmap_task_339050_iter[i] /
                    (ctx->futhark_mc_segmap_task_339050_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_339050_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_nested_task_339057     ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_nested_task_339057_runs[i],
                    (long) ctx->futhark_mc_segmap_nested_task_339057_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_339057_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_339057_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_nested_task_339057_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_nested_task_339057_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_339057_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_nested_task_339057_iter[i]),
                    (long) ctx->futhark_mc_segmap_nested_task_339057_iter[i],
                    (long) ctx->futhark_mc_segmap_nested_task_339057_iter[i] /
                    (ctx->futhark_mc_segmap_nested_task_339057_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_339057_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_339092         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_339092_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_339092_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339092_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339092_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_339092_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_339092_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339092_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339092_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_339092_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_339092_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_339092_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339092_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_339092_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_339092_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_339092_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339092_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339092_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_339092_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_339092_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339092_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339092_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_339092_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_339092_total_iter /
                (ctx->futhark_mc_segmap_parloop_339092_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339092_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_339092_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_339092_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_339109         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_339109_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_339109_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339109_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339109_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_339109_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_339109_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339109_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339109_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_339109_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_339109_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_339109_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339109_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_339109_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_339109_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_339109_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339109_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339109_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_339109_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_339109_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339109_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339109_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_339109_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_339109_total_iter /
                (ctx->futhark_mc_segmap_parloop_339109_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339109_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_339109_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_339109_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_339107            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_339107_runs[i],
                    (long) ctx->futhark_mc_segmap_task_339107_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_339107_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_339107_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_339107_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_339107_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_339107_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_339107_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_339107_iter[i],
                    (long) ctx->futhark_mc_segmap_task_339107_iter[i] /
                    (ctx->futhark_mc_segmap_task_339107_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_339107_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_339113         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_339113_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_339113_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339113_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339113_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_339113_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_339113_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339113_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339113_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_339113_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_339113_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_339113_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339113_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_339113_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_339113_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_339113_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339113_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339113_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_339113_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_339113_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339113_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339113_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_339113_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_339113_total_iter /
                (ctx->futhark_mc_segmap_parloop_339113_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339113_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_339113_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_339113_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_339111            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_339111_runs[i],
                    (long) ctx->futhark_mc_segmap_task_339111_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_339111_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_339111_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_339111_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_339111_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_339111_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_339111_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_339111_iter[i],
                    (long) ctx->futhark_mc_segmap_task_339111_iter[i] /
                    (ctx->futhark_mc_segmap_task_339111_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_339111_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_339117         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_339117_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_339117_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339117_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339117_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_339117_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_339117_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339117_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339117_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_339117_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_339117_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_339117_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339117_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_339117_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_339117_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_339117_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339117_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339117_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_339117_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_339117_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339117_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339117_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_339117_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_339117_total_iter /
                (ctx->futhark_mc_segmap_parloop_339117_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339117_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_339117_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_339117_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_stage_1_parloop_339127 ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_stage_1_parloop_339127_runs[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_339127_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_339127_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_339127_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_339127_total_runtime[i],
                    (double) ctx->futhark_mc_segred_stage_1_parloop_339127_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_339127_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_339127_iter[i]),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_339127_iter[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_339127_iter[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_339127_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_339127_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segred_stage_1_parloop_339127_total ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segred_stage_1_parloop_339127_total_runs,
                (long) ctx->futhark_mc_segred_stage_1_parloop_339127_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_339127_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_339127_total_runs : 1),
                (long) ctx->futhark_mc_segred_stage_1_parloop_339127_total_total_runtime,
                (double) ctx->futhark_mc_segred_stage_1_parloop_339127_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_339127_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_339127_total_iter),
                (long) ctx->futhark_mc_segred_stage_1_parloop_339127_total_iter,
                (long) ctx->futhark_mc_segred_stage_1_parloop_339127_total_iter /
                (ctx->futhark_mc_segred_stage_1_parloop_339127_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_339127_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segred_stage_1_parloop_339127_total_total_runtime;
        ctx->total_runs +=
            ctx->futhark_mc_segred_stage_1_parloop_339127_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_task_339122            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_task_339122_runs[i],
                    (long) ctx->futhark_mc_segred_task_339122_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_339122_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_339122_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_task_339122_total_runtime[i],
                    (double) ctx->futhark_mc_segred_task_339122_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_339122_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_task_339122_iter[i]),
                    (long) ctx->futhark_mc_segred_task_339122_iter[i],
                    (long) ctx->futhark_mc_segred_task_339122_iter[i] /
                    (ctx->futhark_mc_segred_task_339122_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_339122_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_stage_1_parloop_339133 ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_stage_1_parloop_339133_runs[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_339133_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_339133_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_339133_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_339133_total_runtime[i],
                    (double) ctx->futhark_mc_segred_stage_1_parloop_339133_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_339133_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_339133_iter[i]),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_339133_iter[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_339133_iter[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_339133_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_339133_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segred_stage_1_parloop_339133_total ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segred_stage_1_parloop_339133_total_runs,
                (long) ctx->futhark_mc_segred_stage_1_parloop_339133_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_339133_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_339133_total_runs : 1),
                (long) ctx->futhark_mc_segred_stage_1_parloop_339133_total_total_runtime,
                (double) ctx->futhark_mc_segred_stage_1_parloop_339133_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_339133_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_339133_total_iter),
                (long) ctx->futhark_mc_segred_stage_1_parloop_339133_total_iter,
                (long) ctx->futhark_mc_segred_stage_1_parloop_339133_total_iter /
                (ctx->futhark_mc_segred_stage_1_parloop_339133_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_339133_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segred_stage_1_parloop_339133_total_total_runtime;
        ctx->total_runs +=
            ctx->futhark_mc_segred_stage_1_parloop_339133_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_task_339129            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_task_339129_runs[i],
                    (long) ctx->futhark_mc_segred_task_339129_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_339129_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_339129_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_task_339129_total_runtime[i],
                    (double) ctx->futhark_mc_segred_task_339129_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_339129_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_task_339129_iter[i]),
                    (long) ctx->futhark_mc_segred_task_339129_iter[i],
                    (long) ctx->futhark_mc_segred_task_339129_iter[i] /
                    (ctx->futhark_mc_segred_task_339129_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_339129_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_339120         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_339120_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_339120_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339120_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339120_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_339120_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_339120_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339120_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339120_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_339120_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_339120_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_339120_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339120_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_339120_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_339120_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_339120_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339120_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339120_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_339120_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_339120_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339120_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339120_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_339120_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_339120_total_iter /
                (ctx->futhark_mc_segmap_parloop_339120_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339120_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_339120_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_339120_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_339115            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_339115_runs[i],
                    (long) ctx->futhark_mc_segmap_task_339115_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_339115_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_339115_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_339115_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_339115_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_339115_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_339115_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_339115_iter[i],
                    (long) ctx->futhark_mc_segmap_task_339115_iter[i] /
                    (ctx->futhark_mc_segmap_task_339115_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_339115_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_nested_task_339118     ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_nested_task_339118_runs[i],
                    (long) ctx->futhark_mc_segmap_nested_task_339118_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_339118_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_339118_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_nested_task_339118_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_nested_task_339118_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_339118_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_nested_task_339118_iter[i]),
                    (long) ctx->futhark_mc_segmap_nested_task_339118_iter[i],
                    (long) ctx->futhark_mc_segmap_nested_task_339118_iter[i] /
                    (ctx->futhark_mc_segmap_nested_task_339118_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_339118_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_339100         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_339100_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_339100_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339100_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339100_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_339100_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_339100_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339100_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339100_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_339100_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_339100_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_339100_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339100_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_339100_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_339100_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_339100_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339100_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339100_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_339100_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_339100_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339100_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339100_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_339100_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_339100_total_iter /
                (ctx->futhark_mc_segmap_parloop_339100_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339100_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_339100_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_339100_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_339090            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_339090_runs[i],
                    (long) ctx->futhark_mc_segmap_task_339090_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_339090_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_339090_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_339090_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_339090_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_339090_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_339090_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_339090_iter[i],
                    (long) ctx->futhark_mc_segmap_task_339090_iter[i] /
                    (ctx->futhark_mc_segmap_task_339090_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_339090_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_nested_task_339098     ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_nested_task_339098_runs[i],
                    (long) ctx->futhark_mc_segmap_nested_task_339098_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_339098_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_339098_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_nested_task_339098_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_nested_task_339098_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_339098_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_nested_task_339098_iter[i]),
                    (long) ctx->futhark_mc_segmap_nested_task_339098_iter[i],
                    (long) ctx->futhark_mc_segmap_nested_task_339098_iter[i] /
                    (ctx->futhark_mc_segmap_nested_task_339098_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_339098_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_339137         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_339137_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_339137_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339137_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339137_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_339137_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_339137_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339137_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339137_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_339137_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_339137_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_339137_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339137_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_339137_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_339137_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_339137_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339137_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339137_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_339137_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_339137_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339137_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339137_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_339137_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_339137_total_iter /
                (ctx->futhark_mc_segmap_parloop_339137_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339137_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_339137_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_339137_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_339154         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_339154_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_339154_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339154_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339154_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_339154_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_339154_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339154_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339154_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_339154_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_339154_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_339154_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339154_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_339154_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_339154_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_339154_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339154_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339154_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_339154_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_339154_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339154_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339154_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_339154_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_339154_total_iter /
                (ctx->futhark_mc_segmap_parloop_339154_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339154_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_339154_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_339154_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_339152            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_339152_runs[i],
                    (long) ctx->futhark_mc_segmap_task_339152_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_339152_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_339152_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_339152_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_339152_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_339152_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_339152_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_339152_iter[i],
                    (long) ctx->futhark_mc_segmap_task_339152_iter[i] /
                    (ctx->futhark_mc_segmap_task_339152_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_339152_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_339158         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_339158_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_339158_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339158_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339158_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_339158_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_339158_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339158_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339158_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_339158_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_339158_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_339158_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339158_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_339158_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_339158_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_339158_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339158_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339158_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_339158_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_339158_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339158_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339158_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_339158_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_339158_total_iter /
                (ctx->futhark_mc_segmap_parloop_339158_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339158_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_339158_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_339158_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_339156            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_339156_runs[i],
                    (long) ctx->futhark_mc_segmap_task_339156_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_339156_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_339156_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_339156_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_339156_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_339156_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_339156_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_339156_iter[i],
                    (long) ctx->futhark_mc_segmap_task_339156_iter[i] /
                    (ctx->futhark_mc_segmap_task_339156_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_339156_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_339162         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_339162_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_339162_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339162_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339162_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_339162_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_339162_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339162_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339162_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_339162_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_339162_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_339162_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339162_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_339162_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_339162_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_339162_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339162_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339162_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_339162_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_339162_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339162_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339162_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_339162_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_339162_total_iter /
                (ctx->futhark_mc_segmap_parloop_339162_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339162_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_339162_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_339162_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_stage_1_parloop_339174 ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_stage_1_parloop_339174_runs[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_339174_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_339174_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_339174_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_339174_total_runtime[i],
                    (double) ctx->futhark_mc_segred_stage_1_parloop_339174_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_339174_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_339174_iter[i]),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_339174_iter[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_339174_iter[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_339174_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_339174_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segred_stage_1_parloop_339174_total ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segred_stage_1_parloop_339174_total_runs,
                (long) ctx->futhark_mc_segred_stage_1_parloop_339174_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_339174_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_339174_total_runs : 1),
                (long) ctx->futhark_mc_segred_stage_1_parloop_339174_total_total_runtime,
                (double) ctx->futhark_mc_segred_stage_1_parloop_339174_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_339174_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_339174_total_iter),
                (long) ctx->futhark_mc_segred_stage_1_parloop_339174_total_iter,
                (long) ctx->futhark_mc_segred_stage_1_parloop_339174_total_iter /
                (ctx->futhark_mc_segred_stage_1_parloop_339174_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_339174_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segred_stage_1_parloop_339174_total_total_runtime;
        ctx->total_runs +=
            ctx->futhark_mc_segred_stage_1_parloop_339174_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_task_339167            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_task_339167_runs[i],
                    (long) ctx->futhark_mc_segred_task_339167_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_339167_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_339167_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_task_339167_total_runtime[i],
                    (double) ctx->futhark_mc_segred_task_339167_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_339167_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_task_339167_iter[i]),
                    (long) ctx->futhark_mc_segred_task_339167_iter[i],
                    (long) ctx->futhark_mc_segred_task_339167_iter[i] /
                    (ctx->futhark_mc_segred_task_339167_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_339167_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_stage_1_parloop_339180 ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_stage_1_parloop_339180_runs[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_339180_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_339180_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_339180_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_339180_total_runtime[i],
                    (double) ctx->futhark_mc_segred_stage_1_parloop_339180_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_339180_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_339180_iter[i]),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_339180_iter[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_339180_iter[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_339180_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_339180_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segred_stage_1_parloop_339180_total ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segred_stage_1_parloop_339180_total_runs,
                (long) ctx->futhark_mc_segred_stage_1_parloop_339180_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_339180_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_339180_total_runs : 1),
                (long) ctx->futhark_mc_segred_stage_1_parloop_339180_total_total_runtime,
                (double) ctx->futhark_mc_segred_stage_1_parloop_339180_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_339180_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_339180_total_iter),
                (long) ctx->futhark_mc_segred_stage_1_parloop_339180_total_iter,
                (long) ctx->futhark_mc_segred_stage_1_parloop_339180_total_iter /
                (ctx->futhark_mc_segred_stage_1_parloop_339180_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_339180_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segred_stage_1_parloop_339180_total_total_runtime;
        ctx->total_runs +=
            ctx->futhark_mc_segred_stage_1_parloop_339180_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_task_339176            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_task_339176_runs[i],
                    (long) ctx->futhark_mc_segred_task_339176_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_339176_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_339176_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_task_339176_total_runtime[i],
                    (double) ctx->futhark_mc_segred_task_339176_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_339176_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_task_339176_iter[i]),
                    (long) ctx->futhark_mc_segred_task_339176_iter[i],
                    (long) ctx->futhark_mc_segred_task_339176_iter[i] /
                    (ctx->futhark_mc_segred_task_339176_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_339176_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_339165         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_339165_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_339165_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339165_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339165_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_339165_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_339165_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339165_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339165_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_339165_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_339165_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_339165_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339165_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_339165_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_339165_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_339165_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339165_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339165_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_339165_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_339165_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339165_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339165_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_339165_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_339165_total_iter /
                (ctx->futhark_mc_segmap_parloop_339165_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339165_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_339165_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_339165_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_339160            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_339160_runs[i],
                    (long) ctx->futhark_mc_segmap_task_339160_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_339160_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_339160_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_339160_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_339160_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_339160_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_339160_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_339160_iter[i],
                    (long) ctx->futhark_mc_segmap_task_339160_iter[i] /
                    (ctx->futhark_mc_segmap_task_339160_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_339160_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_nested_task_339163     ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_nested_task_339163_runs[i],
                    (long) ctx->futhark_mc_segmap_nested_task_339163_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_339163_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_339163_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_nested_task_339163_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_nested_task_339163_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_339163_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_nested_task_339163_iter[i]),
                    (long) ctx->futhark_mc_segmap_nested_task_339163_iter[i],
                    (long) ctx->futhark_mc_segmap_nested_task_339163_iter[i] /
                    (ctx->futhark_mc_segmap_nested_task_339163_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_339163_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_339145         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_339145_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_339145_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339145_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339145_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_339145_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_339145_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339145_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339145_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_339145_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_339145_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_339145_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339145_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_339145_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_339145_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_339145_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339145_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339145_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_339145_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_339145_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339145_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339145_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_339145_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_339145_total_iter /
                (ctx->futhark_mc_segmap_parloop_339145_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339145_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_339145_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_339145_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_339135            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_339135_runs[i],
                    (long) ctx->futhark_mc_segmap_task_339135_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_339135_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_339135_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_339135_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_339135_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_339135_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_339135_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_339135_iter[i],
                    (long) ctx->futhark_mc_segmap_task_339135_iter[i] /
                    (ctx->futhark_mc_segmap_task_339135_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_339135_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_nested_task_339143     ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_nested_task_339143_runs[i],
                    (long) ctx->futhark_mc_segmap_nested_task_339143_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_339143_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_339143_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_nested_task_339143_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_nested_task_339143_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_339143_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_nested_task_339143_iter[i]),
                    (long) ctx->futhark_mc_segmap_nested_task_339143_iter[i],
                    (long) ctx->futhark_mc_segmap_nested_task_339143_iter[i] /
                    (ctx->futhark_mc_segmap_nested_task_339143_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_339143_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_339184         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_339184_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_339184_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339184_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339184_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_339184_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_339184_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339184_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339184_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_339184_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_339184_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_339184_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339184_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_339184_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_339184_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_339184_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339184_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339184_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_339184_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_339184_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339184_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339184_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_339184_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_339184_total_iter /
                (ctx->futhark_mc_segmap_parloop_339184_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339184_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_339184_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_339184_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_339193         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_339193_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_339193_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339193_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339193_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_339193_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_339193_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339193_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339193_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_339193_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_339193_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_339193_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339193_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_339193_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_339193_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_339193_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339193_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339193_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_339193_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_339193_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339193_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339193_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_339193_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_339193_total_iter /
                (ctx->futhark_mc_segmap_parloop_339193_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339193_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_339193_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_339193_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_339191            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_339191_runs[i],
                    (long) ctx->futhark_mc_segmap_task_339191_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_339191_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_339191_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_339191_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_339191_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_339191_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_339191_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_339191_iter[i],
                    (long) ctx->futhark_mc_segmap_task_339191_iter[i] /
                    (ctx->futhark_mc_segmap_task_339191_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_339191_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_339188         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_339188_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_339188_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339188_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339188_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_339188_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_339188_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339188_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339188_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_339188_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_339188_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_339188_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339188_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_339188_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_339188_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_339188_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339188_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339188_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_339188_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_339188_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339188_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339188_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_339188_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_339188_total_iter /
                (ctx->futhark_mc_segmap_parloop_339188_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339188_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_339188_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_339188_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_339182            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_339182_runs[i],
                    (long) ctx->futhark_mc_segmap_task_339182_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_339182_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_339182_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_339182_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_339182_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_339182_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_339182_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_339182_iter[i],
                    (long) ctx->futhark_mc_segmap_task_339182_iter[i] /
                    (ctx->futhark_mc_segmap_task_339182_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_339182_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_nested_task_339186     ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_nested_task_339186_runs[i],
                    (long) ctx->futhark_mc_segmap_nested_task_339186_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_339186_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_339186_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_nested_task_339186_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_nested_task_339186_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_339186_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_nested_task_339186_iter[i]),
                    (long) ctx->futhark_mc_segmap_nested_task_339186_iter[i],
                    (long) ctx->futhark_mc_segmap_nested_task_339186_iter[i] /
                    (ctx->futhark_mc_segmap_nested_task_339186_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_339186_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_339197         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_339197_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_339197_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339197_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339197_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_339197_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_339197_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339197_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339197_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_339197_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_339197_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_339197_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339197_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_339197_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_339197_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_339197_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339197_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339197_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_339197_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_339197_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339197_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339197_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_339197_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_339197_total_iter /
                (ctx->futhark_mc_segmap_parloop_339197_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339197_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_339197_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_339197_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_339208         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_339208_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_339208_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339208_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339208_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_339208_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_339208_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339208_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339208_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_339208_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_339208_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_339208_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339208_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_339208_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_339208_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_339208_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339208_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339208_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_339208_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_339208_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339208_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339208_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_339208_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_339208_total_iter /
                (ctx->futhark_mc_segmap_parloop_339208_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339208_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_339208_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_339208_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_339206            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_339206_runs[i],
                    (long) ctx->futhark_mc_segmap_task_339206_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_339206_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_339206_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_339206_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_339206_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_339206_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_339206_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_339206_iter[i],
                    (long) ctx->futhark_mc_segmap_task_339206_iter[i] /
                    (ctx->futhark_mc_segmap_task_339206_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_339206_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_339212         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_339212_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_339212_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339212_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339212_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_339212_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_339212_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339212_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339212_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_339212_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_339212_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_339212_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339212_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_339212_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_339212_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_339212_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339212_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339212_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_339212_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_339212_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339212_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339212_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_339212_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_339212_total_iter /
                (ctx->futhark_mc_segmap_parloop_339212_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339212_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_339212_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_339212_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_339210            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_339210_runs[i],
                    (long) ctx->futhark_mc_segmap_task_339210_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_339210_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_339210_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_339210_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_339210_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_339210_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_339210_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_339210_iter[i],
                    (long) ctx->futhark_mc_segmap_task_339210_iter[i] /
                    (ctx->futhark_mc_segmap_task_339210_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_339210_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_339202         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_339202_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_339202_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339202_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339202_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_339202_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_339202_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339202_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339202_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_339202_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_339202_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_339202_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339202_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_339202_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_339202_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_339202_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339202_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339202_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_339202_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_339202_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339202_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339202_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_339202_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_339202_total_iter /
                (ctx->futhark_mc_segmap_parloop_339202_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339202_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_339202_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_339202_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_339195            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_339195_runs[i],
                    (long) ctx->futhark_mc_segmap_task_339195_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_339195_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_339195_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_339195_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_339195_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_339195_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_339195_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_339195_iter[i],
                    (long) ctx->futhark_mc_segmap_task_339195_iter[i] /
                    (ctx->futhark_mc_segmap_task_339195_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_339195_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_nested_task_339200     ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_nested_task_339200_runs[i],
                    (long) ctx->futhark_mc_segmap_nested_task_339200_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_339200_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_339200_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_nested_task_339200_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_nested_task_339200_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_339200_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_nested_task_339200_iter[i]),
                    (long) ctx->futhark_mc_segmap_nested_task_339200_iter[i],
                    (long) ctx->futhark_mc_segmap_nested_task_339200_iter[i] /
                    (ctx->futhark_mc_segmap_nested_task_339200_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_339200_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_339216         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_339216_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_339216_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339216_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339216_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_339216_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_339216_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339216_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339216_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_339216_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_339216_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_339216_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339216_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_339216_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_339216_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_339216_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339216_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339216_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_339216_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_339216_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339216_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339216_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_339216_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_339216_total_iter /
                (ctx->futhark_mc_segmap_parloop_339216_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339216_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_339216_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_339216_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_stage_1_parloop_339225 ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_stage_1_parloop_339225_runs[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_339225_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_339225_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_339225_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_339225_total_runtime[i],
                    (double) ctx->futhark_mc_segred_stage_1_parloop_339225_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_339225_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_339225_iter[i]),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_339225_iter[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_339225_iter[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_339225_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_339225_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segred_stage_1_parloop_339225_total ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segred_stage_1_parloop_339225_total_runs,
                (long) ctx->futhark_mc_segred_stage_1_parloop_339225_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_339225_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_339225_total_runs : 1),
                (long) ctx->futhark_mc_segred_stage_1_parloop_339225_total_total_runtime,
                (double) ctx->futhark_mc_segred_stage_1_parloop_339225_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_339225_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_339225_total_iter),
                (long) ctx->futhark_mc_segred_stage_1_parloop_339225_total_iter,
                (long) ctx->futhark_mc_segred_stage_1_parloop_339225_total_iter /
                (ctx->futhark_mc_segred_stage_1_parloop_339225_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_339225_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segred_stage_1_parloop_339225_total_total_runtime;
        ctx->total_runs +=
            ctx->futhark_mc_segred_stage_1_parloop_339225_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_task_339221            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_task_339221_runs[i],
                    (long) ctx->futhark_mc_segred_task_339221_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_339221_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_339221_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_task_339221_total_runtime[i],
                    (double) ctx->futhark_mc_segred_task_339221_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_339221_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_task_339221_iter[i]),
                    (long) ctx->futhark_mc_segred_task_339221_iter[i],
                    (long) ctx->futhark_mc_segred_task_339221_iter[i] /
                    (ctx->futhark_mc_segred_task_339221_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_339221_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_339219         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_339219_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_339219_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339219_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339219_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_339219_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_339219_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339219_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339219_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_339219_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_339219_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_339219_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339219_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_339219_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_339219_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_339219_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339219_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339219_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_339219_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_339219_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339219_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339219_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_339219_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_339219_total_iter /
                (ctx->futhark_mc_segmap_parloop_339219_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339219_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_339219_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_339219_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_339214            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_339214_runs[i],
                    (long) ctx->futhark_mc_segmap_task_339214_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_339214_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_339214_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_339214_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_339214_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_339214_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_339214_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_339214_iter[i],
                    (long) ctx->futhark_mc_segmap_task_339214_iter[i] /
                    (ctx->futhark_mc_segmap_task_339214_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_339214_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_nested_task_339217     ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_nested_task_339217_runs[i],
                    (long) ctx->futhark_mc_segmap_nested_task_339217_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_339217_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_339217_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_nested_task_339217_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_nested_task_339217_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_339217_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_nested_task_339217_iter[i]),
                    (long) ctx->futhark_mc_segmap_nested_task_339217_iter[i],
                    (long) ctx->futhark_mc_segmap_nested_task_339217_iter[i] /
                    (ctx->futhark_mc_segmap_nested_task_339217_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_339217_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_339229         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_339229_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_339229_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339229_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339229_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_339229_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_339229_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339229_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339229_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_339229_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_339229_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_339229_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339229_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_339229_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_339229_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_339229_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339229_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339229_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_339229_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_339229_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339229_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339229_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_339229_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_339229_total_iter /
                (ctx->futhark_mc_segmap_parloop_339229_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339229_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_339229_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_339229_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_339227            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_339227_runs[i],
                    (long) ctx->futhark_mc_segmap_task_339227_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_339227_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_339227_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_339227_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_339227_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_339227_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_339227_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_339227_iter[i],
                    (long) ctx->futhark_mc_segmap_task_339227_iter[i] /
                    (ctx->futhark_mc_segmap_task_339227_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_339227_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_339234         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_339234_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_339234_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339234_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339234_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_339234_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_339234_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339234_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339234_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_339234_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_339234_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_339234_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339234_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_339234_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_339234_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_339234_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339234_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339234_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_339234_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_339234_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339234_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339234_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_339234_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_339234_total_iter /
                (ctx->futhark_mc_segmap_parloop_339234_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339234_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_339234_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_339234_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_339232            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_339232_runs[i],
                    (long) ctx->futhark_mc_segmap_task_339232_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_339232_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_339232_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_339232_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_339232_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_339232_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_339232_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_339232_iter[i],
                    (long) ctx->futhark_mc_segmap_task_339232_iter[i] /
                    (ctx->futhark_mc_segmap_task_339232_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_339232_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_scan_stage_1_parloop_339239   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_scan_stage_1_parloop_339239_runs[i],
                    (long) ctx->futhark_mc_scan_stage_1_parloop_339239_total_runtime[i] /
                    (ctx->futhark_mc_scan_stage_1_parloop_339239_runs[i] !=
                     0 ? ctx->futhark_mc_scan_stage_1_parloop_339239_runs[i] : 1),
                    (long) ctx->futhark_mc_scan_stage_1_parloop_339239_total_runtime[i],
                    (double) ctx->futhark_mc_scan_stage_1_parloop_339239_total_runtime[i] /
                    (ctx->futhark_mc_scan_stage_1_parloop_339239_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_scan_stage_1_parloop_339239_iter[i]),
                    (long) ctx->futhark_mc_scan_stage_1_parloop_339239_iter[i],
                    (long) ctx->futhark_mc_scan_stage_1_parloop_339239_iter[i] /
                    (ctx->futhark_mc_scan_stage_1_parloop_339239_runs[i] !=
                     0 ? ctx->futhark_mc_scan_stage_1_parloop_339239_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_scan_stage_1_parloop_339239_total ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_scan_stage_1_parloop_339239_total_runs,
                (long) ctx->futhark_mc_scan_stage_1_parloop_339239_total_total_runtime /
                (ctx->futhark_mc_scan_stage_1_parloop_339239_total_runs !=
                 0 ? ctx->futhark_mc_scan_stage_1_parloop_339239_total_runs : 1),
                (long) ctx->futhark_mc_scan_stage_1_parloop_339239_total_total_runtime,
                (double) ctx->futhark_mc_scan_stage_1_parloop_339239_total_total_runtime /
                (ctx->futhark_mc_scan_stage_1_parloop_339239_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_scan_stage_1_parloop_339239_total_iter),
                (long) ctx->futhark_mc_scan_stage_1_parloop_339239_total_iter,
                (long) ctx->futhark_mc_scan_stage_1_parloop_339239_total_iter /
                (ctx->futhark_mc_scan_stage_1_parloop_339239_total_runs !=
                 0 ? ctx->futhark_mc_scan_stage_1_parloop_339239_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_scan_stage_1_parloop_339239_total_total_runtime;
        ctx->total_runs +=
            ctx->futhark_mc_scan_stage_1_parloop_339239_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_scan_stage_3_parloop_339241   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_scan_stage_3_parloop_339241_runs[i],
                    (long) ctx->futhark_mc_scan_stage_3_parloop_339241_total_runtime[i] /
                    (ctx->futhark_mc_scan_stage_3_parloop_339241_runs[i] !=
                     0 ? ctx->futhark_mc_scan_stage_3_parloop_339241_runs[i] : 1),
                    (long) ctx->futhark_mc_scan_stage_3_parloop_339241_total_runtime[i],
                    (double) ctx->futhark_mc_scan_stage_3_parloop_339241_total_runtime[i] /
                    (ctx->futhark_mc_scan_stage_3_parloop_339241_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_scan_stage_3_parloop_339241_iter[i]),
                    (long) ctx->futhark_mc_scan_stage_3_parloop_339241_iter[i],
                    (long) ctx->futhark_mc_scan_stage_3_parloop_339241_iter[i] /
                    (ctx->futhark_mc_scan_stage_3_parloop_339241_runs[i] !=
                     0 ? ctx->futhark_mc_scan_stage_3_parloop_339241_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_scan_stage_3_parloop_339241_total ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_scan_stage_3_parloop_339241_total_runs,
                (long) ctx->futhark_mc_scan_stage_3_parloop_339241_total_total_runtime /
                (ctx->futhark_mc_scan_stage_3_parloop_339241_total_runs !=
                 0 ? ctx->futhark_mc_scan_stage_3_parloop_339241_total_runs : 1),
                (long) ctx->futhark_mc_scan_stage_3_parloop_339241_total_total_runtime,
                (double) ctx->futhark_mc_scan_stage_3_parloop_339241_total_total_runtime /
                (ctx->futhark_mc_scan_stage_3_parloop_339241_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_scan_stage_3_parloop_339241_total_iter),
                (long) ctx->futhark_mc_scan_stage_3_parloop_339241_total_iter,
                (long) ctx->futhark_mc_scan_stage_3_parloop_339241_total_iter /
                (ctx->futhark_mc_scan_stage_3_parloop_339241_total_runs !=
                 0 ? ctx->futhark_mc_scan_stage_3_parloop_339241_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_scan_stage_3_parloop_339241_total_total_runtime;
        ctx->total_runs +=
            ctx->futhark_mc_scan_stage_3_parloop_339241_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segscan_task_339236           ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segscan_task_339236_runs[i],
                    (long) ctx->futhark_mc_segscan_task_339236_total_runtime[i] /
                    (ctx->futhark_mc_segscan_task_339236_runs[i] !=
                     0 ? ctx->futhark_mc_segscan_task_339236_runs[i] : 1),
                    (long) ctx->futhark_mc_segscan_task_339236_total_runtime[i],
                    (double) ctx->futhark_mc_segscan_task_339236_total_runtime[i] /
                    (ctx->futhark_mc_segscan_task_339236_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segscan_task_339236_iter[i]),
                    (long) ctx->futhark_mc_segscan_task_339236_iter[i],
                    (long) ctx->futhark_mc_segscan_task_339236_iter[i] /
                    (ctx->futhark_mc_segscan_task_339236_runs[i] !=
                     0 ? ctx->futhark_mc_segscan_task_339236_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_339245         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_339245_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_339245_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339245_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339245_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_339245_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_339245_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339245_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339245_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_339245_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_339245_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_339245_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339245_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_339245_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_339245_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_339245_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339245_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339245_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_339245_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_339245_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339245_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339245_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_339245_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_339245_total_iter /
                (ctx->futhark_mc_segmap_parloop_339245_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339245_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_339245_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_339245_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_339243            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_339243_runs[i],
                    (long) ctx->futhark_mc_segmap_task_339243_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_339243_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_339243_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_339243_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_339243_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_339243_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_339243_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_339243_iter[i],
                    (long) ctx->futhark_mc_segmap_task_339243_iter[i] /
                    (ctx->futhark_mc_segmap_task_339243_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_339243_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_seghist_stage_1_parloop_339250 ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_seghist_stage_1_parloop_339250_runs[i],
                    (long) ctx->futhark_mc_seghist_stage_1_parloop_339250_total_runtime[i] /
                    (ctx->futhark_mc_seghist_stage_1_parloop_339250_runs[i] !=
                     0 ? ctx->futhark_mc_seghist_stage_1_parloop_339250_runs[i] : 1),
                    (long) ctx->futhark_mc_seghist_stage_1_parloop_339250_total_runtime[i],
                    (double) ctx->futhark_mc_seghist_stage_1_parloop_339250_total_runtime[i] /
                    (ctx->futhark_mc_seghist_stage_1_parloop_339250_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_seghist_stage_1_parloop_339250_iter[i]),
                    (long) ctx->futhark_mc_seghist_stage_1_parloop_339250_iter[i],
                    (long) ctx->futhark_mc_seghist_stage_1_parloop_339250_iter[i] /
                    (ctx->futhark_mc_seghist_stage_1_parloop_339250_runs[i] !=
                     0 ? ctx->futhark_mc_seghist_stage_1_parloop_339250_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_seghist_stage_1_parloop_339250_total ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_seghist_stage_1_parloop_339250_total_runs,
                (long) ctx->futhark_mc_seghist_stage_1_parloop_339250_total_total_runtime /
                (ctx->futhark_mc_seghist_stage_1_parloop_339250_total_runs !=
                 0 ? ctx->futhark_mc_seghist_stage_1_parloop_339250_total_runs : 1),
                (long) ctx->futhark_mc_seghist_stage_1_parloop_339250_total_total_runtime,
                (double) ctx->futhark_mc_seghist_stage_1_parloop_339250_total_total_runtime /
                (ctx->futhark_mc_seghist_stage_1_parloop_339250_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_seghist_stage_1_parloop_339250_total_iter),
                (long) ctx->futhark_mc_seghist_stage_1_parloop_339250_total_iter,
                (long) ctx->futhark_mc_seghist_stage_1_parloop_339250_total_iter /
                (ctx->futhark_mc_seghist_stage_1_parloop_339250_total_runs !=
                 0 ? ctx->futhark_mc_seghist_stage_1_parloop_339250_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_seghist_stage_1_parloop_339250_total_total_runtime;
        ctx->total_runs +=
            ctx->futhark_mc_seghist_stage_1_parloop_339250_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmented_segred_parloop_339255 ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmented_segred_parloop_339255_runs[i],
                    (long) ctx->futhark_mc_segmented_segred_parloop_339255_total_runtime[i] /
                    (ctx->futhark_mc_segmented_segred_parloop_339255_runs[i] !=
                     0 ? ctx->futhark_mc_segmented_segred_parloop_339255_runs[i] : 1),
                    (long) ctx->futhark_mc_segmented_segred_parloop_339255_total_runtime[i],
                    (double) ctx->futhark_mc_segmented_segred_parloop_339255_total_runtime[i] /
                    (ctx->futhark_mc_segmented_segred_parloop_339255_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmented_segred_parloop_339255_iter[i]),
                    (long) ctx->futhark_mc_segmented_segred_parloop_339255_iter[i],
                    (long) ctx->futhark_mc_segmented_segred_parloop_339255_iter[i] /
                    (ctx->futhark_mc_segmented_segred_parloop_339255_runs[i] !=
                     0 ? ctx->futhark_mc_segmented_segred_parloop_339255_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmented_segred_parloop_339255_total ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmented_segred_parloop_339255_total_runs,
                (long) ctx->futhark_mc_segmented_segred_parloop_339255_total_total_runtime /
                (ctx->futhark_mc_segmented_segred_parloop_339255_total_runs !=
                 0 ? ctx->futhark_mc_segmented_segred_parloop_339255_total_runs : 1),
                (long) ctx->futhark_mc_segmented_segred_parloop_339255_total_total_runtime,
                (double) ctx->futhark_mc_segmented_segred_parloop_339255_total_total_runtime /
                (ctx->futhark_mc_segmented_segred_parloop_339255_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmented_segred_parloop_339255_total_iter),
                (long) ctx->futhark_mc_segmented_segred_parloop_339255_total_iter,
                (long) ctx->futhark_mc_segmented_segred_parloop_339255_total_iter /
                (ctx->futhark_mc_segmented_segred_parloop_339255_total_runs !=
                 0 ? ctx->futhark_mc_segmented_segred_parloop_339255_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmented_segred_parloop_339255_total_total_runtime;
        ctx->total_runs +=
            ctx->futhark_mc_segmented_segred_parloop_339255_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_seghist_red_task_339253       ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_seghist_red_task_339253_runs[i],
                    (long) ctx->futhark_mc_seghist_red_task_339253_total_runtime[i] /
                    (ctx->futhark_mc_seghist_red_task_339253_runs[i] !=
                     0 ? ctx->futhark_mc_seghist_red_task_339253_runs[i] : 1),
                    (long) ctx->futhark_mc_seghist_red_task_339253_total_runtime[i],
                    (double) ctx->futhark_mc_seghist_red_task_339253_total_runtime[i] /
                    (ctx->futhark_mc_seghist_red_task_339253_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_seghist_red_task_339253_iter[i]),
                    (long) ctx->futhark_mc_seghist_red_task_339253_iter[i],
                    (long) ctx->futhark_mc_seghist_red_task_339253_iter[i] /
                    (ctx->futhark_mc_seghist_red_task_339253_runs[i] !=
                     0 ? ctx->futhark_mc_seghist_red_task_339253_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_atomic_seg_hist_parloop_339257 ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_atomic_seg_hist_parloop_339257_runs[i],
                    (long) ctx->futhark_mc_atomic_seg_hist_parloop_339257_total_runtime[i] /
                    (ctx->futhark_mc_atomic_seg_hist_parloop_339257_runs[i] !=
                     0 ? ctx->futhark_mc_atomic_seg_hist_parloop_339257_runs[i] : 1),
                    (long) ctx->futhark_mc_atomic_seg_hist_parloop_339257_total_runtime[i],
                    (double) ctx->futhark_mc_atomic_seg_hist_parloop_339257_total_runtime[i] /
                    (ctx->futhark_mc_atomic_seg_hist_parloop_339257_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_atomic_seg_hist_parloop_339257_iter[i]),
                    (long) ctx->futhark_mc_atomic_seg_hist_parloop_339257_iter[i],
                    (long) ctx->futhark_mc_atomic_seg_hist_parloop_339257_iter[i] /
                    (ctx->futhark_mc_atomic_seg_hist_parloop_339257_runs[i] !=
                     0 ? ctx->futhark_mc_atomic_seg_hist_parloop_339257_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_atomic_seg_hist_parloop_339257_total ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_atomic_seg_hist_parloop_339257_total_runs,
                (long) ctx->futhark_mc_atomic_seg_hist_parloop_339257_total_total_runtime /
                (ctx->futhark_mc_atomic_seg_hist_parloop_339257_total_runs !=
                 0 ? ctx->futhark_mc_atomic_seg_hist_parloop_339257_total_runs : 1),
                (long) ctx->futhark_mc_atomic_seg_hist_parloop_339257_total_total_runtime,
                (double) ctx->futhark_mc_atomic_seg_hist_parloop_339257_total_total_runtime /
                (ctx->futhark_mc_atomic_seg_hist_parloop_339257_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_atomic_seg_hist_parloop_339257_total_iter),
                (long) ctx->futhark_mc_atomic_seg_hist_parloop_339257_total_iter,
                (long) ctx->futhark_mc_atomic_seg_hist_parloop_339257_total_iter /
                (ctx->futhark_mc_atomic_seg_hist_parloop_339257_total_runs !=
                 0 ? ctx->futhark_mc_atomic_seg_hist_parloop_339257_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_atomic_seg_hist_parloop_339257_total_total_runtime;
        ctx->total_runs +=
            ctx->futhark_mc_atomic_seg_hist_parloop_339257_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_seghist_task_339247           ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_seghist_task_339247_runs[i],
                    (long) ctx->futhark_mc_seghist_task_339247_total_runtime[i] /
                    (ctx->futhark_mc_seghist_task_339247_runs[i] !=
                     0 ? ctx->futhark_mc_seghist_task_339247_runs[i] : 1),
                    (long) ctx->futhark_mc_seghist_task_339247_total_runtime[i],
                    (double) ctx->futhark_mc_seghist_task_339247_total_runtime[i] /
                    (ctx->futhark_mc_seghist_task_339247_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_seghist_task_339247_iter[i]),
                    (long) ctx->futhark_mc_seghist_task_339247_iter[i],
                    (long) ctx->futhark_mc_seghist_task_339247_iter[i] /
                    (ctx->futhark_mc_seghist_task_339247_runs[i] !=
                     0 ? ctx->futhark_mc_seghist_task_339247_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_339261         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_339261_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_339261_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339261_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339261_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_339261_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_339261_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339261_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339261_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_339261_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_339261_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_339261_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339261_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_339261_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_339261_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_339261_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339261_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339261_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_339261_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_339261_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339261_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339261_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_339261_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_339261_total_iter /
                (ctx->futhark_mc_segmap_parloop_339261_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339261_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_339261_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_339261_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_339259            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_339259_runs[i],
                    (long) ctx->futhark_mc_segmap_task_339259_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_339259_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_339259_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_339259_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_339259_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_339259_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_339259_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_339259_iter[i],
                    (long) ctx->futhark_mc_segmap_task_339259_iter[i] /
                    (ctx->futhark_mc_segmap_task_339259_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_339259_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_339265         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_339265_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_339265_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339265_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339265_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_339265_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_339265_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339265_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339265_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_339265_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_339265_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_339265_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339265_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_339265_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_339265_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_339265_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339265_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339265_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_339265_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_339265_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339265_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339265_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_339265_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_339265_total_iter /
                (ctx->futhark_mc_segmap_parloop_339265_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339265_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_339265_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_339265_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_339263            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_339263_runs[i],
                    (long) ctx->futhark_mc_segmap_task_339263_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_339263_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_339263_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_339263_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_339263_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_339263_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_339263_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_339263_iter[i],
                    (long) ctx->futhark_mc_segmap_task_339263_iter[i] /
                    (ctx->futhark_mc_segmap_task_339263_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_339263_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_339269         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_339269_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_339269_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339269_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339269_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_339269_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_339269_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339269_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339269_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_339269_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_339269_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_339269_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339269_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_339269_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_339269_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_339269_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339269_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339269_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_339269_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_339269_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339269_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339269_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_339269_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_339269_total_iter /
                (ctx->futhark_mc_segmap_parloop_339269_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339269_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_339269_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_339269_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_339267            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_339267_runs[i],
                    (long) ctx->futhark_mc_segmap_task_339267_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_339267_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_339267_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_339267_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_339267_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_339267_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_339267_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_339267_iter[i],
                    (long) ctx->futhark_mc_segmap_task_339267_iter[i] /
                    (ctx->futhark_mc_segmap_task_339267_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_339267_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_scan_stage_1_parloop_339274   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_scan_stage_1_parloop_339274_runs[i],
                    (long) ctx->futhark_mc_scan_stage_1_parloop_339274_total_runtime[i] /
                    (ctx->futhark_mc_scan_stage_1_parloop_339274_runs[i] !=
                     0 ? ctx->futhark_mc_scan_stage_1_parloop_339274_runs[i] : 1),
                    (long) ctx->futhark_mc_scan_stage_1_parloop_339274_total_runtime[i],
                    (double) ctx->futhark_mc_scan_stage_1_parloop_339274_total_runtime[i] /
                    (ctx->futhark_mc_scan_stage_1_parloop_339274_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_scan_stage_1_parloop_339274_iter[i]),
                    (long) ctx->futhark_mc_scan_stage_1_parloop_339274_iter[i],
                    (long) ctx->futhark_mc_scan_stage_1_parloop_339274_iter[i] /
                    (ctx->futhark_mc_scan_stage_1_parloop_339274_runs[i] !=
                     0 ? ctx->futhark_mc_scan_stage_1_parloop_339274_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_scan_stage_1_parloop_339274_total ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_scan_stage_1_parloop_339274_total_runs,
                (long) ctx->futhark_mc_scan_stage_1_parloop_339274_total_total_runtime /
                (ctx->futhark_mc_scan_stage_1_parloop_339274_total_runs !=
                 0 ? ctx->futhark_mc_scan_stage_1_parloop_339274_total_runs : 1),
                (long) ctx->futhark_mc_scan_stage_1_parloop_339274_total_total_runtime,
                (double) ctx->futhark_mc_scan_stage_1_parloop_339274_total_total_runtime /
                (ctx->futhark_mc_scan_stage_1_parloop_339274_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_scan_stage_1_parloop_339274_total_iter),
                (long) ctx->futhark_mc_scan_stage_1_parloop_339274_total_iter,
                (long) ctx->futhark_mc_scan_stage_1_parloop_339274_total_iter /
                (ctx->futhark_mc_scan_stage_1_parloop_339274_total_runs !=
                 0 ? ctx->futhark_mc_scan_stage_1_parloop_339274_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_scan_stage_1_parloop_339274_total_total_runtime;
        ctx->total_runs +=
            ctx->futhark_mc_scan_stage_1_parloop_339274_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_scan_stage_3_parloop_339276   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_scan_stage_3_parloop_339276_runs[i],
                    (long) ctx->futhark_mc_scan_stage_3_parloop_339276_total_runtime[i] /
                    (ctx->futhark_mc_scan_stage_3_parloop_339276_runs[i] !=
                     0 ? ctx->futhark_mc_scan_stage_3_parloop_339276_runs[i] : 1),
                    (long) ctx->futhark_mc_scan_stage_3_parloop_339276_total_runtime[i],
                    (double) ctx->futhark_mc_scan_stage_3_parloop_339276_total_runtime[i] /
                    (ctx->futhark_mc_scan_stage_3_parloop_339276_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_scan_stage_3_parloop_339276_iter[i]),
                    (long) ctx->futhark_mc_scan_stage_3_parloop_339276_iter[i],
                    (long) ctx->futhark_mc_scan_stage_3_parloop_339276_iter[i] /
                    (ctx->futhark_mc_scan_stage_3_parloop_339276_runs[i] !=
                     0 ? ctx->futhark_mc_scan_stage_3_parloop_339276_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_scan_stage_3_parloop_339276_total ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_scan_stage_3_parloop_339276_total_runs,
                (long) ctx->futhark_mc_scan_stage_3_parloop_339276_total_total_runtime /
                (ctx->futhark_mc_scan_stage_3_parloop_339276_total_runs !=
                 0 ? ctx->futhark_mc_scan_stage_3_parloop_339276_total_runs : 1),
                (long) ctx->futhark_mc_scan_stage_3_parloop_339276_total_total_runtime,
                (double) ctx->futhark_mc_scan_stage_3_parloop_339276_total_total_runtime /
                (ctx->futhark_mc_scan_stage_3_parloop_339276_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_scan_stage_3_parloop_339276_total_iter),
                (long) ctx->futhark_mc_scan_stage_3_parloop_339276_total_iter,
                (long) ctx->futhark_mc_scan_stage_3_parloop_339276_total_iter /
                (ctx->futhark_mc_scan_stage_3_parloop_339276_total_runs !=
                 0 ? ctx->futhark_mc_scan_stage_3_parloop_339276_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_scan_stage_3_parloop_339276_total_total_runtime;
        ctx->total_runs +=
            ctx->futhark_mc_scan_stage_3_parloop_339276_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segscan_task_339271           ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segscan_task_339271_runs[i],
                    (long) ctx->futhark_mc_segscan_task_339271_total_runtime[i] /
                    (ctx->futhark_mc_segscan_task_339271_runs[i] !=
                     0 ? ctx->futhark_mc_segscan_task_339271_runs[i] : 1),
                    (long) ctx->futhark_mc_segscan_task_339271_total_runtime[i],
                    (double) ctx->futhark_mc_segscan_task_339271_total_runtime[i] /
                    (ctx->futhark_mc_segscan_task_339271_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segscan_task_339271_iter[i]),
                    (long) ctx->futhark_mc_segscan_task_339271_iter[i],
                    (long) ctx->futhark_mc_segscan_task_339271_iter[i] /
                    (ctx->futhark_mc_segscan_task_339271_runs[i] !=
                     0 ? ctx->futhark_mc_segscan_task_339271_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_339280         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_339280_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_339280_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339280_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339280_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_339280_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_339280_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339280_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339280_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_339280_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_339280_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_339280_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339280_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_339280_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_339280_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_339280_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339280_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339280_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_339280_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_339280_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339280_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339280_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_339280_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_339280_total_iter /
                (ctx->futhark_mc_segmap_parloop_339280_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339280_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_339280_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_339280_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_339278            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_339278_runs[i],
                    (long) ctx->futhark_mc_segmap_task_339278_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_339278_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_339278_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_339278_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_339278_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_339278_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_339278_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_339278_iter[i],
                    (long) ctx->futhark_mc_segmap_task_339278_iter[i] /
                    (ctx->futhark_mc_segmap_task_339278_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_339278_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_339284         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_339284_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_339284_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339284_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339284_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_339284_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_339284_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339284_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339284_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_339284_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_339284_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_339284_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339284_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_339284_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_339284_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_339284_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339284_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339284_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_339284_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_339284_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339284_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339284_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_339284_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_339284_total_iter /
                (ctx->futhark_mc_segmap_parloop_339284_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339284_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_339284_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_339284_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_stage_1_parloop_339294 ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_stage_1_parloop_339294_runs[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_339294_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_339294_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_339294_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_339294_total_runtime[i],
                    (double) ctx->futhark_mc_segred_stage_1_parloop_339294_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_339294_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_339294_iter[i]),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_339294_iter[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_339294_iter[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_339294_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_339294_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segred_stage_1_parloop_339294_total ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segred_stage_1_parloop_339294_total_runs,
                (long) ctx->futhark_mc_segred_stage_1_parloop_339294_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_339294_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_339294_total_runs : 1),
                (long) ctx->futhark_mc_segred_stage_1_parloop_339294_total_total_runtime,
                (double) ctx->futhark_mc_segred_stage_1_parloop_339294_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_339294_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_339294_total_iter),
                (long) ctx->futhark_mc_segred_stage_1_parloop_339294_total_iter,
                (long) ctx->futhark_mc_segred_stage_1_parloop_339294_total_iter /
                (ctx->futhark_mc_segred_stage_1_parloop_339294_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_339294_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segred_stage_1_parloop_339294_total_total_runtime;
        ctx->total_runs +=
            ctx->futhark_mc_segred_stage_1_parloop_339294_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_task_339289            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_task_339289_runs[i],
                    (long) ctx->futhark_mc_segred_task_339289_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_339289_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_339289_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_task_339289_total_runtime[i],
                    (double) ctx->futhark_mc_segred_task_339289_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_339289_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_task_339289_iter[i]),
                    (long) ctx->futhark_mc_segred_task_339289_iter[i],
                    (long) ctx->futhark_mc_segred_task_339289_iter[i] /
                    (ctx->futhark_mc_segred_task_339289_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_339289_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_339287         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_339287_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_339287_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339287_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339287_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_339287_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_339287_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339287_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339287_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_339287_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_339287_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_339287_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339287_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_339287_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_339287_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_339287_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339287_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339287_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_339287_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_339287_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339287_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339287_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_339287_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_339287_total_iter /
                (ctx->futhark_mc_segmap_parloop_339287_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339287_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_339287_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_339287_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_339282            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_339282_runs[i],
                    (long) ctx->futhark_mc_segmap_task_339282_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_339282_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_339282_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_339282_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_339282_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_339282_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_339282_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_339282_iter[i],
                    (long) ctx->futhark_mc_segmap_task_339282_iter[i] /
                    (ctx->futhark_mc_segmap_task_339282_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_339282_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_nested_task_339285     ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_nested_task_339285_runs[i],
                    (long) ctx->futhark_mc_segmap_nested_task_339285_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_339285_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_339285_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_nested_task_339285_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_nested_task_339285_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_339285_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_nested_task_339285_iter[i]),
                    (long) ctx->futhark_mc_segmap_nested_task_339285_iter[i],
                    (long) ctx->futhark_mc_segmap_nested_task_339285_iter[i] /
                    (ctx->futhark_mc_segmap_nested_task_339285_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_339285_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_339298         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_339298_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_339298_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339298_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339298_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_339298_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_339298_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339298_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339298_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_339298_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_339298_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_339298_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339298_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_339298_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_339298_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_339298_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339298_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339298_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_339298_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_339298_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339298_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339298_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_339298_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_339298_total_iter /
                (ctx->futhark_mc_segmap_parloop_339298_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339298_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_339298_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_339298_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_339307         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_339307_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_339307_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339307_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339307_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_339307_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_339307_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339307_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339307_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_339307_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_339307_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_339307_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339307_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_339307_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_339307_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_339307_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339307_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339307_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_339307_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_339307_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339307_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339307_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_339307_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_339307_total_iter /
                (ctx->futhark_mc_segmap_parloop_339307_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339307_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_339307_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_339307_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_339305            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_339305_runs[i],
                    (long) ctx->futhark_mc_segmap_task_339305_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_339305_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_339305_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_339305_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_339305_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_339305_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_339305_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_339305_iter[i],
                    (long) ctx->futhark_mc_segmap_task_339305_iter[i] /
                    (ctx->futhark_mc_segmap_task_339305_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_339305_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_339302         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_339302_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_339302_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339302_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339302_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_339302_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_339302_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339302_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339302_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_339302_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_339302_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_339302_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339302_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_339302_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_339302_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_339302_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339302_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339302_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_339302_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_339302_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339302_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339302_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_339302_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_339302_total_iter /
                (ctx->futhark_mc_segmap_parloop_339302_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339302_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_339302_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_339302_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_339296            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_339296_runs[i],
                    (long) ctx->futhark_mc_segmap_task_339296_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_339296_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_339296_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_339296_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_339296_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_339296_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_339296_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_339296_iter[i],
                    (long) ctx->futhark_mc_segmap_task_339296_iter[i] /
                    (ctx->futhark_mc_segmap_task_339296_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_339296_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_nested_task_339300     ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_nested_task_339300_runs[i],
                    (long) ctx->futhark_mc_segmap_nested_task_339300_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_339300_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_339300_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_nested_task_339300_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_nested_task_339300_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_339300_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_nested_task_339300_iter[i]),
                    (long) ctx->futhark_mc_segmap_nested_task_339300_iter[i],
                    (long) ctx->futhark_mc_segmap_nested_task_339300_iter[i] /
                    (ctx->futhark_mc_segmap_nested_task_339300_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_339300_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_339318         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_339318_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_339318_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339318_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339318_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_339318_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_339318_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339318_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339318_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_339318_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_339318_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_339318_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339318_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_339318_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_339318_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_339318_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339318_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339318_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_339318_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_339318_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339318_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339318_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_339318_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_339318_total_iter /
                (ctx->futhark_mc_segmap_parloop_339318_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339318_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_339318_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_339318_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_339316            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_339316_runs[i],
                    (long) ctx->futhark_mc_segmap_task_339316_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_339316_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_339316_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_339316_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_339316_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_339316_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_339316_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_339316_iter[i],
                    (long) ctx->futhark_mc_segmap_task_339316_iter[i] /
                    (ctx->futhark_mc_segmap_task_339316_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_339316_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_339311         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_339311_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_339311_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339311_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339311_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_339311_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_339311_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339311_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339311_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_339311_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_339311_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_339311_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339311_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_339311_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_339311_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_339311_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339311_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339311_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_339311_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_339311_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339311_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339311_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_339311_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_339311_total_iter /
                (ctx->futhark_mc_segmap_parloop_339311_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339311_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_339311_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_339311_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_339309            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_339309_runs[i],
                    (long) ctx->futhark_mc_segmap_task_339309_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_339309_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_339309_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_339309_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_339309_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_339309_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_339309_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_339309_iter[i],
                    (long) ctx->futhark_mc_segmap_task_339309_iter[i] /
                    (ctx->futhark_mc_segmap_task_339309_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_339309_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_339323         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_339323_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_339323_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339323_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339323_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_339323_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_339323_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339323_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339323_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_339323_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_339323_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_339323_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339323_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_339323_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_339323_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_339323_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339323_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339323_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_339323_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_339323_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339323_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339323_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_339323_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_339323_total_iter /
                (ctx->futhark_mc_segmap_parloop_339323_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339323_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_339323_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_339323_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_stage_1_parloop_339332 ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_stage_1_parloop_339332_runs[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_339332_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_339332_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_339332_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_339332_total_runtime[i],
                    (double) ctx->futhark_mc_segred_stage_1_parloop_339332_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_339332_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_339332_iter[i]),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_339332_iter[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_339332_iter[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_339332_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_339332_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segred_stage_1_parloop_339332_total ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segred_stage_1_parloop_339332_total_runs,
                (long) ctx->futhark_mc_segred_stage_1_parloop_339332_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_339332_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_339332_total_runs : 1),
                (long) ctx->futhark_mc_segred_stage_1_parloop_339332_total_total_runtime,
                (double) ctx->futhark_mc_segred_stage_1_parloop_339332_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_339332_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_339332_total_iter),
                (long) ctx->futhark_mc_segred_stage_1_parloop_339332_total_iter,
                (long) ctx->futhark_mc_segred_stage_1_parloop_339332_total_iter /
                (ctx->futhark_mc_segred_stage_1_parloop_339332_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_339332_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segred_stage_1_parloop_339332_total_total_runtime;
        ctx->total_runs +=
            ctx->futhark_mc_segred_stage_1_parloop_339332_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_task_339328            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_task_339328_runs[i],
                    (long) ctx->futhark_mc_segred_task_339328_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_339328_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_339328_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_task_339328_total_runtime[i],
                    (double) ctx->futhark_mc_segred_task_339328_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_339328_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_task_339328_iter[i]),
                    (long) ctx->futhark_mc_segred_task_339328_iter[i],
                    (long) ctx->futhark_mc_segred_task_339328_iter[i] /
                    (ctx->futhark_mc_segred_task_339328_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_339328_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_339326         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_339326_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_339326_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339326_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339326_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_339326_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_339326_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339326_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339326_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_339326_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_339326_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_339326_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339326_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_339326_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_339326_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_339326_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339326_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339326_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_339326_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_339326_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339326_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339326_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_339326_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_339326_total_iter /
                (ctx->futhark_mc_segmap_parloop_339326_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339326_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_339326_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_339326_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_339321            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_339321_runs[i],
                    (long) ctx->futhark_mc_segmap_task_339321_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_339321_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_339321_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_339321_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_339321_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_339321_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_339321_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_339321_iter[i],
                    (long) ctx->futhark_mc_segmap_task_339321_iter[i] /
                    (ctx->futhark_mc_segmap_task_339321_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_339321_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_nested_task_339324     ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_nested_task_339324_runs[i],
                    (long) ctx->futhark_mc_segmap_nested_task_339324_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_339324_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_339324_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_nested_task_339324_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_nested_task_339324_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_339324_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_nested_task_339324_iter[i]),
                    (long) ctx->futhark_mc_segmap_nested_task_339324_iter[i],
                    (long) ctx->futhark_mc_segmap_nested_task_339324_iter[i] /
                    (ctx->futhark_mc_segmap_nested_task_339324_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_339324_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_stage_1_parloop_339340 ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_stage_1_parloop_339340_runs[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_339340_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_339340_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_339340_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_339340_total_runtime[i],
                    (double) ctx->futhark_mc_segred_stage_1_parloop_339340_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_339340_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_339340_iter[i]),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_339340_iter[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_339340_iter[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_339340_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_339340_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segred_stage_1_parloop_339340_total ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segred_stage_1_parloop_339340_total_runs,
                (long) ctx->futhark_mc_segred_stage_1_parloop_339340_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_339340_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_339340_total_runs : 1),
                (long) ctx->futhark_mc_segred_stage_1_parloop_339340_total_total_runtime,
                (double) ctx->futhark_mc_segred_stage_1_parloop_339340_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_339340_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_339340_total_iter),
                (long) ctx->futhark_mc_segred_stage_1_parloop_339340_total_iter,
                (long) ctx->futhark_mc_segred_stage_1_parloop_339340_total_iter /
                (ctx->futhark_mc_segred_stage_1_parloop_339340_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_339340_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segred_stage_1_parloop_339340_total_total_runtime;
        ctx->total_runs +=
            ctx->futhark_mc_segred_stage_1_parloop_339340_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_task_339336            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_task_339336_runs[i],
                    (long) ctx->futhark_mc_segred_task_339336_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_339336_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_339336_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_task_339336_total_runtime[i],
                    (double) ctx->futhark_mc_segred_task_339336_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_339336_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_task_339336_iter[i]),
                    (long) ctx->futhark_mc_segred_task_339336_iter[i],
                    (long) ctx->futhark_mc_segred_task_339336_iter[i] /
                    (ctx->futhark_mc_segred_task_339336_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_339336_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_339344         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_339344_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_339344_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339344_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339344_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_339344_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_339344_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339344_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339344_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_339344_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_339344_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_339344_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339344_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_339344_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_339344_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_339344_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339344_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339344_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_339344_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_339344_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339344_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339344_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_339344_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_339344_total_iter /
                (ctx->futhark_mc_segmap_parloop_339344_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339344_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_339344_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_339344_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_stage_1_parloop_339352 ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_stage_1_parloop_339352_runs[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_339352_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_339352_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_339352_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_339352_total_runtime[i],
                    (double) ctx->futhark_mc_segred_stage_1_parloop_339352_total_runtime[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_339352_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_339352_iter[i]),
                    (long) ctx->futhark_mc_segred_stage_1_parloop_339352_iter[i],
                    (long) ctx->futhark_mc_segred_stage_1_parloop_339352_iter[i] /
                    (ctx->futhark_mc_segred_stage_1_parloop_339352_runs[i] !=
                     0 ? ctx->futhark_mc_segred_stage_1_parloop_339352_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segred_stage_1_parloop_339352_total ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segred_stage_1_parloop_339352_total_runs,
                (long) ctx->futhark_mc_segred_stage_1_parloop_339352_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_339352_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_339352_total_runs : 1),
                (long) ctx->futhark_mc_segred_stage_1_parloop_339352_total_total_runtime,
                (double) ctx->futhark_mc_segred_stage_1_parloop_339352_total_total_runtime /
                (ctx->futhark_mc_segred_stage_1_parloop_339352_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segred_stage_1_parloop_339352_total_iter),
                (long) ctx->futhark_mc_segred_stage_1_parloop_339352_total_iter,
                (long) ctx->futhark_mc_segred_stage_1_parloop_339352_total_iter /
                (ctx->futhark_mc_segred_stage_1_parloop_339352_total_runs !=
                 0 ? ctx->futhark_mc_segred_stage_1_parloop_339352_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segred_stage_1_parloop_339352_total_total_runtime;
        ctx->total_runs +=
            ctx->futhark_mc_segred_stage_1_parloop_339352_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segred_task_339349            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segred_task_339349_runs[i],
                    (long) ctx->futhark_mc_segred_task_339349_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_339349_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_339349_runs[i] : 1),
                    (long) ctx->futhark_mc_segred_task_339349_total_runtime[i],
                    (double) ctx->futhark_mc_segred_task_339349_total_runtime[i] /
                    (ctx->futhark_mc_segred_task_339349_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segred_task_339349_iter[i]),
                    (long) ctx->futhark_mc_segred_task_339349_iter[i],
                    (long) ctx->futhark_mc_segred_task_339349_iter[i] /
                    (ctx->futhark_mc_segred_task_339349_runs[i] !=
                     0 ? ctx->futhark_mc_segred_task_339349_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_parloop_339347         ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_parloop_339347_runs[i],
                    (long) ctx->futhark_mc_segmap_parloop_339347_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339347_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339347_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_parloop_339347_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_parloop_339347_total_runtime[i] /
                    (ctx->futhark_mc_segmap_parloop_339347_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339347_iter[i]),
                    (long) ctx->futhark_mc_segmap_parloop_339347_iter[i],
                    (long) ctx->futhark_mc_segmap_parloop_339347_iter[i] /
                    (ctx->futhark_mc_segmap_parloop_339347_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_parloop_339347_runs[i] : 1));
        fprintf(ctx->log,
                "         futhark_mc_segmap_parloop_339347_total   ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                ctx->futhark_mc_segmap_parloop_339347_total_runs,
                (long) ctx->futhark_mc_segmap_parloop_339347_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339347_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339347_total_runs : 1),
                (long) ctx->futhark_mc_segmap_parloop_339347_total_total_runtime,
                (double) ctx->futhark_mc_segmap_parloop_339347_total_total_runtime /
                (ctx->futhark_mc_segmap_parloop_339347_total_iter ==
                 0 ? 1 : (double) ctx->futhark_mc_segmap_parloop_339347_total_iter),
                (long) ctx->futhark_mc_segmap_parloop_339347_total_iter,
                (long) ctx->futhark_mc_segmap_parloop_339347_total_iter /
                (ctx->futhark_mc_segmap_parloop_339347_total_runs !=
                 0 ? ctx->futhark_mc_segmap_parloop_339347_total_runs : 1));
        ctx->total_runtime +=
            ctx->futhark_mc_segmap_parloop_339347_total_total_runtime;
        ctx->total_runs += ctx->futhark_mc_segmap_parloop_339347_total_runs;
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_task_339342            ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_task_339342_runs[i],
                    (long) ctx->futhark_mc_segmap_task_339342_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_339342_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_339342_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_task_339342_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_task_339342_total_runtime[i] /
                    (ctx->futhark_mc_segmap_task_339342_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_task_339342_iter[i]),
                    (long) ctx->futhark_mc_segmap_task_339342_iter[i],
                    (long) ctx->futhark_mc_segmap_task_339342_iter[i] /
                    (ctx->futhark_mc_segmap_task_339342_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_task_339342_runs[i] : 1));
        for (int i = 0; i < ctx->scheduler.num_threads; i++)
            fprintf(ctx->log,
                    "tid %2d - futhark_mc_segmap_nested_task_339345     ran %10d times; avg: %10ldus; total: %10ldus; time pr. iter %9.6f; iters %9ld; avg %ld\n",
                    i, ctx->futhark_mc_segmap_nested_task_339345_runs[i],
                    (long) ctx->futhark_mc_segmap_nested_task_339345_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_339345_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_339345_runs[i] : 1),
                    (long) ctx->futhark_mc_segmap_nested_task_339345_total_runtime[i],
                    (double) ctx->futhark_mc_segmap_nested_task_339345_total_runtime[i] /
                    (ctx->futhark_mc_segmap_nested_task_339345_iter[i] ==
                     0 ? 1 : (double) ctx->futhark_mc_segmap_nested_task_339345_iter[i]),
                    (long) ctx->futhark_mc_segmap_nested_task_339345_iter[i],
                    (long) ctx->futhark_mc_segmap_nested_task_339345_iter[i] /
                    (ctx->futhark_mc_segmap_nested_task_339345_runs[i] !=
                     0 ? ctx->futhark_mc_segmap_nested_task_339345_runs[i] : 1));
    }
    return builder.str;
}
char *futhark_context_get_error(struct futhark_context *ctx)
{
    char *error = ctx->error;
    
    ctx->error = NULL;
    return error;
}
void futhark_context_set_logging_file(struct futhark_context *ctx, FILE *f)
{
    ctx->log = f;
}
void futhark_context_pause_profiling(struct futhark_context *ctx)
{
    ctx->profiling_paused = 1;
}
void futhark_context_unpause_profiling(struct futhark_context *ctx)
{
    ctx->profiling_paused = 0;
}
int futhark_context_clear_caches(struct futhark_context *ctx)
{
    lock_lock(&ctx->lock);
    worker_local = &ctx->scheduler.workers[0];
    ctx->peak_mem_usage_default = 0;
    lock_unlock(&ctx->lock);
    return ctx->error != NULL;
}

static int futrts_entry_main(struct futhark_context *ctx,
                             struct memblock *mem_out_p_337633,
                             struct memblock *mem_out_p_337634,
                             struct memblock *mem_out_p_337635,
                             struct memblock Y_mem_312581, int64_t m_292674,
                             int64_t n_292675, int64_t n_p_292677,
                             int64_t q_s_292678, int64_t q_t_292679,
                             int64_t q_l_292680, int64_t d_s_292681,
                             int64_t d_t_292682, int64_t d_l_292683,
                             int64_t jump_s_292684, int64_t jump_t_292685,
                             int64_t jump_l_292686, int64_t n_inner_292687,
                             int64_t n_outer_292688,
                             int64_t jump_threshold_1_292689,
                             int64_t jump_threshold_2_292690,
                             int64_t q_threshold_1_292691,
                             int64_t q_threshold_2_292692);
static int futrts_entry_seasonal_amplitude(struct futhark_context *ctx,
                                           struct memblock *mem_out_p_339319,
                                           struct memblock seasonal_l_mem_312581,
                                           int64_t m_292609, int64_t n_292610);
static int futrts_entry_trend_magnitude(struct futhark_context *ctx,
                                        struct memblock *mem_out_p_339333,
                                        struct memblock trend_l_mem_312581,
                                        int64_t m_292626, int64_t n_292627);

static int init_constants(struct futhark_context *ctx)
{
    (void) ctx;
    
    int err = 0;
    
    
  cleanup:
    return err;
}
static int free_constants(struct futhark_context *ctx)
{
    (void) ctx;
    return 0;
}
struct futhark_mc_task_337679 {
    struct futhark_context *ctx;
    int64_t free_m_292674;
    int64_t free_n_292675;
    int64_t free_n_p_292677;
    int64_t free_defunc_0_f_res_292697;
    unsigned char *free_Y_mem_312581;
    unsigned char *free_mem_312584;
    unsigned char *free_mem_312587;
    unsigned char *free_mem_312589;
};
struct futhark_mc_scan_stage_1_parloop_struct_337682 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_n_p_292677;
    int64_t free_defunc_0_f_res_292697;
    unsigned char *free_Y_mem_312581;
    unsigned char *free_mem_312584;
    unsigned char *free_mem_312587;
    unsigned char *free_mem_312589;
};
struct futhark_mc_task_337684 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_n_p_292677;
    int64_t free_defunc_0_f_res_292697;
    int64_t free_gtid_297431;
    unsigned char *free_Y_mem_312581;
    bool *retval_defunc_2_reduce_res_292736;
};
struct futhark_mc_segred_stage_1_parloop_struct_337687 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_n_p_292677;
    int64_t free_defunc_0_f_res_292697;
    int64_t free_gtid_297431;
    unsigned char *free_Y_mem_312581;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_317167;
};
static int futhark_mc_segred_stage_1_parloop_337688(void *args, int64_t start,
                                                    int64_t end,
                                                    int flat_tid_297432,
                                                    int tid)
{
    int err = 0;
    struct futhark_mc_segred_stage_1_parloop_struct_337687
    *futhark_mc_segred_stage_1_parloop_struct_337687 =
    (struct futhark_mc_segred_stage_1_parloop_struct_337687 *) args;
    struct futhark_context *ctx =
                           futhark_mc_segred_stage_1_parloop_struct_337687->ctx;
    uint64_t futhark_mc_segred_stage_1_parloop_337688_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_337688_start = get_wall_time();
    
    int64_t n_292675 =
            futhark_mc_segred_stage_1_parloop_struct_337687->free_n_292675;
    int64_t n_p_292677 =
            futhark_mc_segred_stage_1_parloop_struct_337687->free_n_p_292677;
    int64_t defunc_0_f_res_292697 =
            futhark_mc_segred_stage_1_parloop_struct_337687->free_defunc_0_f_res_292697;
    int64_t gtid_297431 =
            futhark_mc_segred_stage_1_parloop_struct_337687->free_gtid_297431;
    struct memblock Y_mem_312581 = {.desc ="Y_mem_312581", .mem =
                                    futhark_mc_segred_stage_1_parloop_struct_337687->free_Y_mem_312581,
                                    .size =0, .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_317167 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_317167",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_337687->free_reduce_stage_1_tid_res_arr_mem_317167,
                                                             .size =0,
                                                             .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_317169 = start;
    bool x_292737;
    bool x_292738;
    bool local_acc_317170 = 0;
    
    for (; iter_317169 < end; iter_317169++) {
        int64_t gtid_297433 = iter_317169;
        bool defunc_2_reduce_res_292741;
        bool redout_310929 = 1;
        
        for (int64_t i_310930 = 0; i_310930 < defunc_0_f_res_292697;
             i_310930++) {
            int64_t x_292746 = mul64(n_p_292677, i_310930);
            int64_t idx_292747 = add64(x_292746, gtid_297433);
            bool cond_292748 = sle64(n_292675, idx_292747);
            bool defunc_0_f_res_292749;
            
            if (cond_292748) {
                defunc_0_f_res_292749 = 1;
            } else {
                bool x_292750 = sle64((int64_t) 0, idx_292747);
                bool y_292751 = slt64(idx_292747, n_292675);
                bool bounds_check_292752 = x_292750 && y_292751;
                bool index_certs_292753;
                
                if (!bounds_check_292752) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [", (long long) idx_292747,
                                  "] out of bounds for array of shape [",
                                  (long long) n_292675, "].",
                                  "-> #0  stl.fut:410:68-73\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  stl.fut:408:36-411:52\n   #5  /prelude/soacs.fut:59:3-10\n   #6  /prelude/array.fut:195:3-17\n   #7  utils.fut:6:3-16\n   #8  stl.fut:407:29-412:37\n   #9  stl.fut:406:22-413:28\n   #10 stl.fut:463:3-479:36\n   #11 stl.fut:445:1-479:36\n");
                    err = FUTHARK_PROGRAM_ERROR;
                    goto cleanup;
                }
                
                float isnan_arg_292754;
                
                isnan_arg_292754 = ((float *) Y_mem_312581.mem)[gtid_297431 *
                                                                n_292675 +
                                                                idx_292747];
                
                bool isnan_res_292755;
                
                isnan_res_292755 = futrts_isnan32(isnan_arg_292754);
                defunc_0_f_res_292749 = isnan_res_292755;
            }
            
            bool x_292744 = defunc_0_f_res_292749 && redout_310929;
            bool redout_tmp_317171 = x_292744;
            
            redout_310929 = redout_tmp_317171;
        }
        defunc_2_reduce_res_292741 = redout_310929;
        // save map-out results
        { }
        // Load accum params
        {
            x_292737 = local_acc_317170;
        }
        // Load next params
        {
            x_292738 = defunc_2_reduce_res_292741;
        }
        // Red body
        {
            bool defunc_1_op_res_292739 = x_292737 || x_292738;
            
            local_acc_317170 = defunc_1_op_res_292739;
        }
    }
    ((bool *) reduce_stage_1_tid_res_arr_mem_317167.mem)[flat_tid_297432] =
        local_acc_317170;
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_337688_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_337688_end -
                 futhark_mc_segred_stage_1_parloop_337688_start;
        
        ctx->futhark_mc_segred_stage_1_parloop_337688_runs[tid]++;
        ctx->futhark_mc_segred_stage_1_parloop_337688_total_runtime[tid] +=
            elapsed;
        ctx->futhark_mc_segred_stage_1_parloop_337688_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segred_task_337685(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_297432 = tid;
    int num_tasks_317166 = info.nsubtasks;
    struct futhark_mc_task_337684 *futhark_mc_task_337684 =
                                  (struct futhark_mc_task_337684 *) args;
    struct futhark_context *ctx = futhark_mc_task_337684->ctx;
    uint64_t futhark_mc_segred_task_337685_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_task_337685_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_337684->free_n_292675;
    int64_t n_p_292677 = futhark_mc_task_337684->free_n_p_292677;
    int64_t defunc_0_f_res_292697 =
            futhark_mc_task_337684->free_defunc_0_f_res_292697;
    int64_t gtid_297431 = futhark_mc_task_337684->free_gtid_297431;
    struct memblock Y_mem_312581 = {.desc ="Y_mem_312581", .mem =
                                    futhark_mc_task_337684->free_Y_mem_312581,
                                    .size =0, .references =NULL};
    bool defunc_2_reduce_res_292736 =
         *futhark_mc_task_337684->retval_defunc_2_reduce_res_292736;
    size_t reduce_stage_1_tid_res_arr_mem_317167_cached_sizze_337686 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_317167 = NULL;
    
    if (reduce_stage_1_tid_res_arr_mem_317167_cached_sizze_337686 <
        (size_t) num_tasks_317166) {
        reduce_stage_1_tid_res_arr_mem_317167 =
            realloc(reduce_stage_1_tid_res_arr_mem_317167, num_tasks_317166);
        reduce_stage_1_tid_res_arr_mem_317167_cached_sizze_337686 =
            num_tasks_317166;
    }
    
    int64_t iter_317169;
    struct futhark_mc_segred_stage_1_parloop_struct_337687
    futhark_mc_segred_stage_1_parloop_struct_337687;
    
    futhark_mc_segred_stage_1_parloop_struct_337687.ctx = ctx;
    futhark_mc_segred_stage_1_parloop_struct_337687.free_n_292675 = n_292675;
    futhark_mc_segred_stage_1_parloop_struct_337687.free_n_p_292677 =
        n_p_292677;
    futhark_mc_segred_stage_1_parloop_struct_337687.free_defunc_0_f_res_292697 =
        defunc_0_f_res_292697;
    futhark_mc_segred_stage_1_parloop_struct_337687.free_gtid_297431 =
        gtid_297431;
    futhark_mc_segred_stage_1_parloop_struct_337687.free_Y_mem_312581 =
        Y_mem_312581.mem;
    futhark_mc_segred_stage_1_parloop_struct_337687.free_reduce_stage_1_tid_res_arr_mem_317167 =
        reduce_stage_1_tid_res_arr_mem_317167;
    
    struct scheduler_parloop futhark_mc_segred_stage_1_parloop_337688_task;
    
    futhark_mc_segred_stage_1_parloop_337688_task.name =
        "futhark_mc_segred_stage_1_parloop_337688";
    futhark_mc_segred_stage_1_parloop_337688_task.fn =
        futhark_mc_segred_stage_1_parloop_337688;
    futhark_mc_segred_stage_1_parloop_337688_task.args =
        &futhark_mc_segred_stage_1_parloop_struct_337687;
    futhark_mc_segred_stage_1_parloop_337688_task.iterations = iterations;
    futhark_mc_segred_stage_1_parloop_337688_task.info = info;
    
    uint64_t futhark_mc_segred_stage_1_parloop_337688_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_337688_total_start = get_wall_time();
    
    int futhark_mc_segred_stage_1_parloop_337688_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segred_stage_1_parloop_337688_task);
    
    if (futhark_mc_segred_stage_1_parloop_337688_err != 0) {
        err = futhark_mc_segred_stage_1_parloop_337688_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_337688_total_end =
                 get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_337688_total_end -
                 futhark_mc_segred_stage_1_parloop_337688_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_337688_total_runs,
                           1, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_337688_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_337688_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    // neutral-initialise the output
    {
        defunc_2_reduce_res_292736 = 0;
    }
    
    bool x_317172;
    bool x_317173;
    
    for (int32_t i_317175 = 0; i_317175 < num_tasks_317166; i_317175++) {
        flat_tid_297432 = i_317175;
        // Apply main thread reduction
        {
            // load acc params
            {
                x_317172 = defunc_2_reduce_res_292736;
            }
            // load next params
            {
                x_317173 =
                    ((bool *) reduce_stage_1_tid_res_arr_mem_317167)[flat_tid_297432];
            }
            // red body
            {
                bool defunc_1_op_res_317174 = x_317172 || x_317173;
                
                defunc_2_reduce_res_292736 = defunc_1_op_res_317174;
            }
        }
    }
    
  cleanup:
    {
        free(reduce_stage_1_tid_res_arr_mem_317167);
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_task_337685_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_task_337685_end -
                 futhark_mc_segred_task_337685_start;
        
        ctx->futhark_mc_segred_task_337685_runs[tid]++;
        ctx->futhark_mc_segred_task_337685_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segred_task_337685_iter[tid] += iterations;
    }
    if (err == 0) {
        *futhark_mc_task_337684->retval_defunc_2_reduce_res_292736 =
            defunc_2_reduce_res_292736;
    }
    return err;
}
struct futhark_mc_segred_stage_1_parloop_struct_337691 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_n_p_292677;
    int64_t free_defunc_0_f_res_292697;
    int64_t free_gtid_297431;
    unsigned char *free_Y_mem_312581;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_317176;
};
struct futhark_mc_task_337693 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_n_p_292677;
    int64_t free_gtid_297431;
    int64_t free_gtid_297439;
    unsigned char *free_Y_mem_312581;
    bool *retval_defunc_2_reduce_res_297444;
};
struct futhark_mc_segred_stage_1_parloop_struct_337696 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_n_p_292677;
    int64_t free_gtid_297431;
    int64_t free_gtid_297439;
    unsigned char *free_Y_mem_312581;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_317181;
};
static int futhark_mc_segred_stage_1_parloop_337697(void *args, int64_t start,
                                                    int64_t end,
                                                    int flat_tid_297445,
                                                    int tid)
{
    int err = 0;
    struct futhark_mc_segred_stage_1_parloop_struct_337696
    *futhark_mc_segred_stage_1_parloop_struct_337696 =
    (struct futhark_mc_segred_stage_1_parloop_struct_337696 *) args;
    struct futhark_context *ctx =
                           futhark_mc_segred_stage_1_parloop_struct_337696->ctx;
    uint64_t futhark_mc_segred_stage_1_parloop_337697_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_337697_start = get_wall_time();
    
    int64_t n_292675 =
            futhark_mc_segred_stage_1_parloop_struct_337696->free_n_292675;
    int64_t n_p_292677 =
            futhark_mc_segred_stage_1_parloop_struct_337696->free_n_p_292677;
    int64_t gtid_297431 =
            futhark_mc_segred_stage_1_parloop_struct_337696->free_gtid_297431;
    int64_t gtid_297439 =
            futhark_mc_segred_stage_1_parloop_struct_337696->free_gtid_297439;
    struct memblock Y_mem_312581 = {.desc ="Y_mem_312581", .mem =
                                    futhark_mc_segred_stage_1_parloop_struct_337696->free_Y_mem_312581,
                                    .size =0, .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_317181 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_317181",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_337696->free_reduce_stage_1_tid_res_arr_mem_317181,
                                                             .size =0,
                                                             .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_317183 = start;
    bool x_297447;
    bool x_297448;
    bool local_acc_317184 = 1;
    
    for (; iter_317183 < end; iter_317183++) {
        int64_t gtid_297446 = iter_317183;
        int64_t x_297451 = mul64(n_p_292677, gtid_297446);
        int64_t idx_297452 = add64(gtid_297439, x_297451);
        bool cond_297453 = sle64(n_292675, idx_297452);
        bool defunc_0_f_res_297454;
        
        if (cond_297453) {
            defunc_0_f_res_297454 = 1;
        } else {
            bool x_297455 = sle64((int64_t) 0, idx_297452);
            bool y_297456 = slt64(idx_297452, n_292675);
            bool bounds_check_297457 = x_297455 && y_297456;
            bool index_certs_297458;
            
            if (!bounds_check_297457) {
                ctx->error =
                    msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                              "Index [", (long long) idx_297452,
                              "] out of bounds for array of shape [",
                              (long long) n_292675, "].",
                              "-> #0  stl.fut:410:68-73\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  stl.fut:408:36-411:52\n   #5  /prelude/soacs.fut:59:3-10\n   #6  /prelude/array.fut:195:3-17\n   #7  utils.fut:6:3-16\n   #8  stl.fut:407:29-412:37\n   #9  stl.fut:406:22-413:28\n   #10 stl.fut:463:3-479:36\n   #11 stl.fut:445:1-479:36\n");
                err = FUTHARK_PROGRAM_ERROR;
                goto cleanup;
            }
            
            float isnan_arg_297459;
            
            isnan_arg_297459 = ((float *) Y_mem_312581.mem)[gtid_297431 *
                                                            n_292675 +
                                                            idx_297452];
            
            bool isnan_res_297460;
            
            isnan_res_297460 = futrts_isnan32(isnan_arg_297459);
            defunc_0_f_res_297454 = isnan_res_297460;
        }
        // save map-out results
        { }
        // Load accum params
        {
            x_297447 = local_acc_317184;
        }
        // Load next params
        {
            x_297448 = defunc_0_f_res_297454;
        }
        // Red body
        {
            bool x_297449 = x_297447 && x_297448;
            
            local_acc_317184 = x_297449;
        }
    }
    ((bool *) reduce_stage_1_tid_res_arr_mem_317181.mem)[flat_tid_297445] =
        local_acc_317184;
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_337697_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_337697_end -
                 futhark_mc_segred_stage_1_parloop_337697_start;
        
        ctx->futhark_mc_segred_stage_1_parloop_337697_runs[tid]++;
        ctx->futhark_mc_segred_stage_1_parloop_337697_total_runtime[tid] +=
            elapsed;
        ctx->futhark_mc_segred_stage_1_parloop_337697_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segred_task_337694(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_297445 = tid;
    int num_tasks_317180 = info.nsubtasks;
    struct futhark_mc_task_337693 *futhark_mc_task_337693 =
                                  (struct futhark_mc_task_337693 *) args;
    struct futhark_context *ctx = futhark_mc_task_337693->ctx;
    uint64_t futhark_mc_segred_task_337694_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_task_337694_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_337693->free_n_292675;
    int64_t n_p_292677 = futhark_mc_task_337693->free_n_p_292677;
    int64_t gtid_297431 = futhark_mc_task_337693->free_gtid_297431;
    int64_t gtid_297439 = futhark_mc_task_337693->free_gtid_297439;
    struct memblock Y_mem_312581 = {.desc ="Y_mem_312581", .mem =
                                    futhark_mc_task_337693->free_Y_mem_312581,
                                    .size =0, .references =NULL};
    bool defunc_2_reduce_res_297444 =
         *futhark_mc_task_337693->retval_defunc_2_reduce_res_297444;
    size_t reduce_stage_1_tid_res_arr_mem_317181_cached_sizze_337695 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_317181 = NULL;
    
    if (reduce_stage_1_tid_res_arr_mem_317181_cached_sizze_337695 <
        (size_t) num_tasks_317180) {
        reduce_stage_1_tid_res_arr_mem_317181 =
            realloc(reduce_stage_1_tid_res_arr_mem_317181, num_tasks_317180);
        reduce_stage_1_tid_res_arr_mem_317181_cached_sizze_337695 =
            num_tasks_317180;
    }
    
    int64_t iter_317183;
    struct futhark_mc_segred_stage_1_parloop_struct_337696
    futhark_mc_segred_stage_1_parloop_struct_337696;
    
    futhark_mc_segred_stage_1_parloop_struct_337696.ctx = ctx;
    futhark_mc_segred_stage_1_parloop_struct_337696.free_n_292675 = n_292675;
    futhark_mc_segred_stage_1_parloop_struct_337696.free_n_p_292677 =
        n_p_292677;
    futhark_mc_segred_stage_1_parloop_struct_337696.free_gtid_297431 =
        gtid_297431;
    futhark_mc_segred_stage_1_parloop_struct_337696.free_gtid_297439 =
        gtid_297439;
    futhark_mc_segred_stage_1_parloop_struct_337696.free_Y_mem_312581 =
        Y_mem_312581.mem;
    futhark_mc_segred_stage_1_parloop_struct_337696.free_reduce_stage_1_tid_res_arr_mem_317181 =
        reduce_stage_1_tid_res_arr_mem_317181;
    
    struct scheduler_parloop futhark_mc_segred_stage_1_parloop_337697_task;
    
    futhark_mc_segred_stage_1_parloop_337697_task.name =
        "futhark_mc_segred_stage_1_parloop_337697";
    futhark_mc_segred_stage_1_parloop_337697_task.fn =
        futhark_mc_segred_stage_1_parloop_337697;
    futhark_mc_segred_stage_1_parloop_337697_task.args =
        &futhark_mc_segred_stage_1_parloop_struct_337696;
    futhark_mc_segred_stage_1_parloop_337697_task.iterations = iterations;
    futhark_mc_segred_stage_1_parloop_337697_task.info = info;
    
    uint64_t futhark_mc_segred_stage_1_parloop_337697_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_337697_total_start = get_wall_time();
    
    int futhark_mc_segred_stage_1_parloop_337697_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segred_stage_1_parloop_337697_task);
    
    if (futhark_mc_segred_stage_1_parloop_337697_err != 0) {
        err = futhark_mc_segred_stage_1_parloop_337697_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_337697_total_end =
                 get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_337697_total_end -
                 futhark_mc_segred_stage_1_parloop_337697_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_337697_total_runs,
                           1, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_337697_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_337697_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    // neutral-initialise the output
    {
        defunc_2_reduce_res_297444 = 1;
    }
    
    bool x_317185;
    bool x_317186;
    
    for (int32_t i_317188 = 0; i_317188 < num_tasks_317180; i_317188++) {
        flat_tid_297445 = i_317188;
        // Apply main thread reduction
        {
            // load acc params
            {
                x_317185 = defunc_2_reduce_res_297444;
            }
            // load next params
            {
                x_317186 =
                    ((bool *) reduce_stage_1_tid_res_arr_mem_317181)[flat_tid_297445];
            }
            // red body
            {
                bool x_317187 = x_317185 && x_317186;
                
                defunc_2_reduce_res_297444 = x_317187;
            }
        }
    }
    
  cleanup:
    {
        free(reduce_stage_1_tid_res_arr_mem_317181);
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_task_337694_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_task_337694_end -
                 futhark_mc_segred_task_337694_start;
        
        ctx->futhark_mc_segred_task_337694_runs[tid]++;
        ctx->futhark_mc_segred_task_337694_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segred_task_337694_iter[tid] += iterations;
    }
    if (err == 0) {
        *futhark_mc_task_337693->retval_defunc_2_reduce_res_297444 =
            defunc_2_reduce_res_297444;
    }
    return err;
}
static int futhark_mc_segred_stage_1_parloop_337692(void *args, int64_t start,
                                                    int64_t end,
                                                    int flat_tid_297438,
                                                    int tid)
{
    int err = 0;
    struct futhark_mc_segred_stage_1_parloop_struct_337691
    *futhark_mc_segred_stage_1_parloop_struct_337691 =
    (struct futhark_mc_segred_stage_1_parloop_struct_337691 *) args;
    struct futhark_context *ctx =
                           futhark_mc_segred_stage_1_parloop_struct_337691->ctx;
    uint64_t futhark_mc_segred_stage_1_parloop_337692_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_337692_start = get_wall_time();
    
    int64_t n_292675 =
            futhark_mc_segred_stage_1_parloop_struct_337691->free_n_292675;
    int64_t n_p_292677 =
            futhark_mc_segred_stage_1_parloop_struct_337691->free_n_p_292677;
    int64_t defunc_0_f_res_292697 =
            futhark_mc_segred_stage_1_parloop_struct_337691->free_defunc_0_f_res_292697;
    int64_t gtid_297431 =
            futhark_mc_segred_stage_1_parloop_struct_337691->free_gtid_297431;
    struct memblock Y_mem_312581 = {.desc ="Y_mem_312581", .mem =
                                    futhark_mc_segred_stage_1_parloop_struct_337691->free_Y_mem_312581,
                                    .size =0, .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_317176 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_317176",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_337691->free_reduce_stage_1_tid_res_arr_mem_317176,
                                                             .size =0,
                                                             .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_317178 = start;
    bool x_297440;
    bool x_297441;
    bool local_acc_317179 = 0;
    
    for (; iter_317178 < end; iter_317178++) {
        int64_t gtid_297439 = iter_317178;
        bool defunc_2_reduce_res_297444;
        int64_t flat_tid_297445 = (int64_t) 0;
        int32_t num_tasks_317180;
        
        defunc_2_reduce_res_297444 = 0;
        
        struct futhark_mc_task_337693 futhark_mc_task_337693;
        
        futhark_mc_task_337693.ctx = ctx;
        futhark_mc_task_337693.free_n_292675 = n_292675;
        futhark_mc_task_337693.free_n_p_292677 = n_p_292677;
        futhark_mc_task_337693.free_gtid_297431 = gtid_297431;
        futhark_mc_task_337693.free_gtid_297439 = gtid_297439;
        futhark_mc_task_337693.free_Y_mem_312581 = Y_mem_312581.mem;
        futhark_mc_task_337693.retval_defunc_2_reduce_res_297444 =
            &defunc_2_reduce_res_297444;
        
        struct scheduler_segop futhark_mc_task_337693_task;
        
        futhark_mc_task_337693_task.args = &futhark_mc_task_337693;
        futhark_mc_task_337693_task.top_level_fn =
            futhark_mc_segred_task_337694;
        futhark_mc_task_337693_task.name = "futhark_mc_segred_task_337694";
        futhark_mc_task_337693_task.iterations = defunc_0_f_res_292697;
        futhark_mc_task_337693_task.task_time =
            &ctx->futhark_mc_segred_task_337694_total_time;
        futhark_mc_task_337693_task.task_iter =
            &ctx->futhark_mc_segred_task_337694_total_iter;
        futhark_mc_task_337693_task.sched = STATIC;
        futhark_mc_task_337693_task.nested_fn = NULL;
        
        int futhark_mc_segred_task_337694_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_337693_task);
        
        if (futhark_mc_segred_task_337694_err != 0) {
            ;
            err = futhark_mc_segred_task_337694_err;
            goto cleanup;
        }
        // save map-out results
        { }
        // Load accum params
        {
            x_297440 = local_acc_317179;
        }
        // Load next params
        {
            x_297441 = defunc_2_reduce_res_297444;
        }
        // Red body
        {
            bool defunc_1_op_res_297442 = x_297440 || x_297441;
            
            local_acc_317179 = defunc_1_op_res_297442;
        }
    }
    ((bool *) reduce_stage_1_tid_res_arr_mem_317176.mem)[flat_tid_297438] =
        local_acc_317179;
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_337692_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_337692_end -
                 futhark_mc_segred_stage_1_parloop_337692_start;
        
        ctx->futhark_mc_segred_stage_1_parloop_337692_runs[tid]++;
        ctx->futhark_mc_segred_stage_1_parloop_337692_total_runtime[tid] +=
            elapsed;
        ctx->futhark_mc_segred_stage_1_parloop_337692_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segred_nested_task_337689(void *args, int64_t iterations,
                                         int tid, struct scheduler_info info)
{
    int err = 0;
    int flat_tid_297438 = tid;
    int num_tasks_317166 = info.nsubtasks;
    struct futhark_mc_task_337684 *futhark_mc_task_337684 =
                                  (struct futhark_mc_task_337684 *) args;
    struct futhark_context *ctx = futhark_mc_task_337684->ctx;
    uint64_t futhark_mc_segred_nested_task_337689_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_nested_task_337689_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_337684->free_n_292675;
    int64_t n_p_292677 = futhark_mc_task_337684->free_n_p_292677;
    int64_t defunc_0_f_res_292697 =
            futhark_mc_task_337684->free_defunc_0_f_res_292697;
    int64_t gtid_297431 = futhark_mc_task_337684->free_gtid_297431;
    struct memblock Y_mem_312581 = {.desc ="Y_mem_312581", .mem =
                                    futhark_mc_task_337684->free_Y_mem_312581,
                                    .size =0, .references =NULL};
    bool defunc_2_reduce_res_292736 =
         *futhark_mc_task_337684->retval_defunc_2_reduce_res_292736;
    size_t reduce_stage_1_tid_res_arr_mem_317176_cached_sizze_337690 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_317176 = NULL;
    
    if (reduce_stage_1_tid_res_arr_mem_317176_cached_sizze_337690 <
        (size_t) num_tasks_317166) {
        reduce_stage_1_tid_res_arr_mem_317176 =
            realloc(reduce_stage_1_tid_res_arr_mem_317176, num_tasks_317166);
        reduce_stage_1_tid_res_arr_mem_317176_cached_sizze_337690 =
            num_tasks_317166;
    }
    
    int64_t iter_317178;
    struct futhark_mc_segred_stage_1_parloop_struct_337691
    futhark_mc_segred_stage_1_parloop_struct_337691;
    
    futhark_mc_segred_stage_1_parloop_struct_337691.ctx = ctx;
    futhark_mc_segred_stage_1_parloop_struct_337691.free_n_292675 = n_292675;
    futhark_mc_segred_stage_1_parloop_struct_337691.free_n_p_292677 =
        n_p_292677;
    futhark_mc_segred_stage_1_parloop_struct_337691.free_defunc_0_f_res_292697 =
        defunc_0_f_res_292697;
    futhark_mc_segred_stage_1_parloop_struct_337691.free_gtid_297431 =
        gtid_297431;
    futhark_mc_segred_stage_1_parloop_struct_337691.free_Y_mem_312581 =
        Y_mem_312581.mem;
    futhark_mc_segred_stage_1_parloop_struct_337691.free_reduce_stage_1_tid_res_arr_mem_317176 =
        reduce_stage_1_tid_res_arr_mem_317176;
    
    struct scheduler_parloop futhark_mc_segred_stage_1_parloop_337692_task;
    
    futhark_mc_segred_stage_1_parloop_337692_task.name =
        "futhark_mc_segred_stage_1_parloop_337692";
    futhark_mc_segred_stage_1_parloop_337692_task.fn =
        futhark_mc_segred_stage_1_parloop_337692;
    futhark_mc_segred_stage_1_parloop_337692_task.args =
        &futhark_mc_segred_stage_1_parloop_struct_337691;
    futhark_mc_segred_stage_1_parloop_337692_task.iterations = iterations;
    futhark_mc_segred_stage_1_parloop_337692_task.info = info;
    
    uint64_t futhark_mc_segred_stage_1_parloop_337692_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_337692_total_start = get_wall_time();
    
    int futhark_mc_segred_stage_1_parloop_337692_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segred_stage_1_parloop_337692_task);
    
    if (futhark_mc_segred_stage_1_parloop_337692_err != 0) {
        err = futhark_mc_segred_stage_1_parloop_337692_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_337692_total_end =
                 get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_337692_total_end -
                 futhark_mc_segred_stage_1_parloop_337692_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_337692_total_runs,
                           1, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_337692_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_337692_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    // neutral-initialise the output
    {
        defunc_2_reduce_res_292736 = 0;
    }
    
    bool x_317189;
    bool x_317190;
    
    for (int32_t i_317192 = 0; i_317192 < num_tasks_317166; i_317192++) {
        flat_tid_297438 = i_317192;
        // Apply main thread reduction
        {
            // load acc params
            {
                x_317189 = defunc_2_reduce_res_292736;
            }
            // load next params
            {
                x_317190 =
                    ((bool *) reduce_stage_1_tid_res_arr_mem_317176)[flat_tid_297438];
            }
            // red body
            {
                bool defunc_1_op_res_317191 = x_317189 || x_317190;
                
                defunc_2_reduce_res_292736 = defunc_1_op_res_317191;
            }
        }
    }
    
  cleanup:
    {
        free(reduce_stage_1_tid_res_arr_mem_317176);
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_nested_task_337689_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_nested_task_337689_end -
                 futhark_mc_segred_nested_task_337689_start;
        
        ctx->futhark_mc_segred_nested_task_337689_runs[tid]++;
        ctx->futhark_mc_segred_nested_task_337689_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segred_nested_task_337689_iter[tid] += iterations;
    }
    if (err == 0) {
        *futhark_mc_task_337684->retval_defunc_2_reduce_res_292736 =
            defunc_2_reduce_res_292736;
    }
    return err;
}
static int futhark_mc_scan_stage_1_parloop_337683(void *args, int64_t start,
                                                  int64_t end,
                                                  int flat_tid_297430, int tid)
{
    int err = 0;
    struct futhark_mc_scan_stage_1_parloop_struct_337682
    *futhark_mc_scan_stage_1_parloop_struct_337682 =
    (struct futhark_mc_scan_stage_1_parloop_struct_337682 *) args;
    struct futhark_context *ctx =
                           futhark_mc_scan_stage_1_parloop_struct_337682->ctx;
    uint64_t futhark_mc_scan_stage_1_parloop_337683_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_scan_stage_1_parloop_337683_start = get_wall_time();
    
    int64_t n_292675 =
            futhark_mc_scan_stage_1_parloop_struct_337682->free_n_292675;
    int64_t n_p_292677 =
            futhark_mc_scan_stage_1_parloop_struct_337682->free_n_p_292677;
    int64_t defunc_0_f_res_292697 =
            futhark_mc_scan_stage_1_parloop_struct_337682->free_defunc_0_f_res_292697;
    struct memblock Y_mem_312581 = {.desc ="Y_mem_312581", .mem =
                                    futhark_mc_scan_stage_1_parloop_struct_337682->free_Y_mem_312581,
                                    .size =0, .references =NULL};
    struct memblock mem_312584 = {.desc ="mem_312584", .mem =
                                  futhark_mc_scan_stage_1_parloop_struct_337682->free_mem_312584,
                                  .size =0, .references =NULL};
    struct memblock mem_312587 = {.desc ="mem_312587", .mem =
                                  futhark_mc_scan_stage_1_parloop_struct_337682->free_mem_312587,
                                  .size =0, .references =NULL};
    struct memblock mem_312589 = {.desc ="mem_312589", .mem =
                                  futhark_mc_scan_stage_1_parloop_struct_337682->free_mem_312589,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_317165 = start;
    int64_t x_292732;
    int64_t y_292733;
    
    x_292732 = (int64_t) 0;
    for (; iter_317165 < end; iter_317165++) {
        int64_t gtid_297431 = iter_317165;
        
        // stage 1 scan body
        {
            bool defunc_2_reduce_res_292736;
            int64_t flat_tid_297432 = (int64_t) 0;
            int32_t num_tasks_317166;
            
            defunc_2_reduce_res_292736 = 0;
            
            int64_t flat_tid_297438 = (int64_t) 0;
            struct futhark_mc_task_337684 futhark_mc_task_337684;
            
            futhark_mc_task_337684.ctx = ctx;
            futhark_mc_task_337684.free_n_292675 = n_292675;
            futhark_mc_task_337684.free_n_p_292677 = n_p_292677;
            futhark_mc_task_337684.free_defunc_0_f_res_292697 =
                defunc_0_f_res_292697;
            futhark_mc_task_337684.free_gtid_297431 = gtid_297431;
            futhark_mc_task_337684.free_Y_mem_312581 = Y_mem_312581.mem;
            futhark_mc_task_337684.retval_defunc_2_reduce_res_292736 =
                &defunc_2_reduce_res_292736;
            
            struct scheduler_segop futhark_mc_task_337684_task;
            
            futhark_mc_task_337684_task.args = &futhark_mc_task_337684;
            futhark_mc_task_337684_task.top_level_fn =
                futhark_mc_segred_task_337685;
            futhark_mc_task_337684_task.name = "futhark_mc_segred_task_337685";
            futhark_mc_task_337684_task.iterations = n_p_292677;
            futhark_mc_task_337684_task.task_time =
                &ctx->futhark_mc_segred_task_337685_total_time;
            futhark_mc_task_337684_task.task_iter =
                &ctx->futhark_mc_segred_task_337685_total_iter;
            futhark_mc_task_337684_task.sched = STATIC;
            futhark_mc_task_337684_task.nested_fn =
                futhark_mc_segred_nested_task_337689;
            
            int futhark_mc_segred_task_337685_err =
                scheduler_prepare_task(&ctx->scheduler,
                                       &futhark_mc_task_337684_task);
            
            if (futhark_mc_segred_task_337685_err != 0) {
                ;
                err = futhark_mc_segred_task_337685_err;
                goto cleanup;
            }
            
            int64_t defunc_2_lifted_lambda_res_292756 =
                    btoi_bool_i64(defunc_2_reduce_res_292736);
            bool is_i_292757 = defunc_2_lifted_lambda_res_292756 == (int64_t) 0;
            bool cond_neg_292758 = !is_i_292757;
            int64_t part_res_292759 = btoi_bool_i64(cond_neg_292758);
            int64_t part_res_292760 = btoi_bool_i64(is_i_292757);
            
            // write mapped values results to memory
            {
                ((int64_t *) mem_312587.mem)[gtid_297431] = part_res_292759;
                ((bool *) mem_312589.mem)[gtid_297431] =
                    defunc_2_reduce_res_292736;
            }
            x_292732 = x_292732;
            // Read next values
            {
                y_292733 = part_res_292760;
            }
            
            int64_t zz_292734 = x_292732 + y_292733;
            
            ((int64_t *) mem_312584.mem)[gtid_297431] = zz_292734;
            x_292732 = zz_292734;
        }
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_scan_stage_1_parloop_337683_end = get_wall_time();
        uint64_t elapsed = futhark_mc_scan_stage_1_parloop_337683_end -
                 futhark_mc_scan_stage_1_parloop_337683_start;
        
        ctx->futhark_mc_scan_stage_1_parloop_337683_runs[tid]++;
        ctx->futhark_mc_scan_stage_1_parloop_337683_total_runtime[tid] +=
            elapsed;
        ctx->futhark_mc_scan_stage_1_parloop_337683_iter[tid] += iterations;
    }
    return err;
}
struct futhark_mc_task_337698 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_n_p_292677;
    int64_t free_defunc_0_f_res_292697;
    int64_t free_gtid_297431;
    unsigned char *free_Y_mem_312581;
    bool *retval_defunc_2_reduce_res_292736;
};
struct futhark_mc_segred_stage_1_parloop_struct_337701 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_n_p_292677;
    int64_t free_defunc_0_f_res_292697;
    int64_t free_gtid_297431;
    unsigned char *free_Y_mem_312581;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_317202;
};
static int futhark_mc_segred_stage_1_parloop_337702(void *args, int64_t start,
                                                    int64_t end,
                                                    int flat_tid_297432,
                                                    int tid)
{
    int err = 0;
    struct futhark_mc_segred_stage_1_parloop_struct_337701
    *futhark_mc_segred_stage_1_parloop_struct_337701 =
    (struct futhark_mc_segred_stage_1_parloop_struct_337701 *) args;
    struct futhark_context *ctx =
                           futhark_mc_segred_stage_1_parloop_struct_337701->ctx;
    uint64_t futhark_mc_segred_stage_1_parloop_337702_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_337702_start = get_wall_time();
    
    int64_t n_292675 =
            futhark_mc_segred_stage_1_parloop_struct_337701->free_n_292675;
    int64_t n_p_292677 =
            futhark_mc_segred_stage_1_parloop_struct_337701->free_n_p_292677;
    int64_t defunc_0_f_res_292697 =
            futhark_mc_segred_stage_1_parloop_struct_337701->free_defunc_0_f_res_292697;
    int64_t gtid_297431 =
            futhark_mc_segred_stage_1_parloop_struct_337701->free_gtid_297431;
    struct memblock Y_mem_312581 = {.desc ="Y_mem_312581", .mem =
                                    futhark_mc_segred_stage_1_parloop_struct_337701->free_Y_mem_312581,
                                    .size =0, .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_317202 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_317202",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_337701->free_reduce_stage_1_tid_res_arr_mem_317202,
                                                             .size =0,
                                                             .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_317204 = start;
    bool x_292737;
    bool x_292738;
    bool local_acc_317205 = 0;
    
    for (; iter_317204 < end; iter_317204++) {
        int64_t gtid_297433 = iter_317204;
        bool defunc_2_reduce_res_292741;
        bool redout_310929 = 1;
        
        for (int64_t i_310930 = 0; i_310930 < defunc_0_f_res_292697;
             i_310930++) {
            int64_t x_292746 = mul64(n_p_292677, i_310930);
            int64_t idx_292747 = add64(x_292746, gtid_297433);
            bool cond_292748 = sle64(n_292675, idx_292747);
            bool defunc_0_f_res_292749;
            
            if (cond_292748) {
                defunc_0_f_res_292749 = 1;
            } else {
                bool x_292750 = sle64((int64_t) 0, idx_292747);
                bool y_292751 = slt64(idx_292747, n_292675);
                bool bounds_check_292752 = x_292750 && y_292751;
                bool index_certs_292753;
                
                if (!bounds_check_292752) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [", (long long) idx_292747,
                                  "] out of bounds for array of shape [",
                                  (long long) n_292675, "].",
                                  "-> #0  stl.fut:410:68-73\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  stl.fut:408:36-411:52\n   #5  /prelude/soacs.fut:59:3-10\n   #6  /prelude/array.fut:195:3-17\n   #7  utils.fut:6:3-16\n   #8  stl.fut:407:29-412:37\n   #9  stl.fut:406:22-413:28\n   #10 stl.fut:463:3-479:36\n   #11 stl.fut:445:1-479:36\n");
                    err = FUTHARK_PROGRAM_ERROR;
                    goto cleanup;
                }
                
                float isnan_arg_292754;
                
                isnan_arg_292754 = ((float *) Y_mem_312581.mem)[gtid_297431 *
                                                                n_292675 +
                                                                idx_292747];
                
                bool isnan_res_292755;
                
                isnan_res_292755 = futrts_isnan32(isnan_arg_292754);
                defunc_0_f_res_292749 = isnan_res_292755;
            }
            
            bool x_292744 = defunc_0_f_res_292749 && redout_310929;
            bool redout_tmp_317206 = x_292744;
            
            redout_310929 = redout_tmp_317206;
        }
        defunc_2_reduce_res_292741 = redout_310929;
        // save map-out results
        { }
        // Load accum params
        {
            x_292737 = local_acc_317205;
        }
        // Load next params
        {
            x_292738 = defunc_2_reduce_res_292741;
        }
        // Red body
        {
            bool defunc_1_op_res_292739 = x_292737 || x_292738;
            
            local_acc_317205 = defunc_1_op_res_292739;
        }
    }
    ((bool *) reduce_stage_1_tid_res_arr_mem_317202.mem)[flat_tid_297432] =
        local_acc_317205;
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_337702_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_337702_end -
                 futhark_mc_segred_stage_1_parloop_337702_start;
        
        ctx->futhark_mc_segred_stage_1_parloop_337702_runs[tid]++;
        ctx->futhark_mc_segred_stage_1_parloop_337702_total_runtime[tid] +=
            elapsed;
        ctx->futhark_mc_segred_stage_1_parloop_337702_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segred_task_337699(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_297432 = tid;
    int num_tasks_317201 = info.nsubtasks;
    struct futhark_mc_task_337698 *futhark_mc_task_337698 =
                                  (struct futhark_mc_task_337698 *) args;
    struct futhark_context *ctx = futhark_mc_task_337698->ctx;
    uint64_t futhark_mc_segred_task_337699_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_task_337699_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_337698->free_n_292675;
    int64_t n_p_292677 = futhark_mc_task_337698->free_n_p_292677;
    int64_t defunc_0_f_res_292697 =
            futhark_mc_task_337698->free_defunc_0_f_res_292697;
    int64_t gtid_297431 = futhark_mc_task_337698->free_gtid_297431;
    struct memblock Y_mem_312581 = {.desc ="Y_mem_312581", .mem =
                                    futhark_mc_task_337698->free_Y_mem_312581,
                                    .size =0, .references =NULL};
    bool defunc_2_reduce_res_292736 =
         *futhark_mc_task_337698->retval_defunc_2_reduce_res_292736;
    size_t reduce_stage_1_tid_res_arr_mem_317202_cached_sizze_337700 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_317202 = NULL;
    
    if (reduce_stage_1_tid_res_arr_mem_317202_cached_sizze_337700 <
        (size_t) num_tasks_317201) {
        reduce_stage_1_tid_res_arr_mem_317202 =
            realloc(reduce_stage_1_tid_res_arr_mem_317202, num_tasks_317201);
        reduce_stage_1_tid_res_arr_mem_317202_cached_sizze_337700 =
            num_tasks_317201;
    }
    
    int64_t iter_317204;
    struct futhark_mc_segred_stage_1_parloop_struct_337701
    futhark_mc_segred_stage_1_parloop_struct_337701;
    
    futhark_mc_segred_stage_1_parloop_struct_337701.ctx = ctx;
    futhark_mc_segred_stage_1_parloop_struct_337701.free_n_292675 = n_292675;
    futhark_mc_segred_stage_1_parloop_struct_337701.free_n_p_292677 =
        n_p_292677;
    futhark_mc_segred_stage_1_parloop_struct_337701.free_defunc_0_f_res_292697 =
        defunc_0_f_res_292697;
    futhark_mc_segred_stage_1_parloop_struct_337701.free_gtid_297431 =
        gtid_297431;
    futhark_mc_segred_stage_1_parloop_struct_337701.free_Y_mem_312581 =
        Y_mem_312581.mem;
    futhark_mc_segred_stage_1_parloop_struct_337701.free_reduce_stage_1_tid_res_arr_mem_317202 =
        reduce_stage_1_tid_res_arr_mem_317202;
    
    struct scheduler_parloop futhark_mc_segred_stage_1_parloop_337702_task;
    
    futhark_mc_segred_stage_1_parloop_337702_task.name =
        "futhark_mc_segred_stage_1_parloop_337702";
    futhark_mc_segred_stage_1_parloop_337702_task.fn =
        futhark_mc_segred_stage_1_parloop_337702;
    futhark_mc_segred_stage_1_parloop_337702_task.args =
        &futhark_mc_segred_stage_1_parloop_struct_337701;
    futhark_mc_segred_stage_1_parloop_337702_task.iterations = iterations;
    futhark_mc_segred_stage_1_parloop_337702_task.info = info;
    
    uint64_t futhark_mc_segred_stage_1_parloop_337702_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_337702_total_start = get_wall_time();
    
    int futhark_mc_segred_stage_1_parloop_337702_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segred_stage_1_parloop_337702_task);
    
    if (futhark_mc_segred_stage_1_parloop_337702_err != 0) {
        err = futhark_mc_segred_stage_1_parloop_337702_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_337702_total_end =
                 get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_337702_total_end -
                 futhark_mc_segred_stage_1_parloop_337702_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_337702_total_runs,
                           1, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_337702_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_337702_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    // neutral-initialise the output
    {
        defunc_2_reduce_res_292736 = 0;
    }
    
    bool x_317207;
    bool x_317208;
    
    for (int32_t i_317210 = 0; i_317210 < num_tasks_317201; i_317210++) {
        flat_tid_297432 = i_317210;
        // Apply main thread reduction
        {
            // load acc params
            {
                x_317207 = defunc_2_reduce_res_292736;
            }
            // load next params
            {
                x_317208 =
                    ((bool *) reduce_stage_1_tid_res_arr_mem_317202)[flat_tid_297432];
            }
            // red body
            {
                bool defunc_1_op_res_317209 = x_317207 || x_317208;
                
                defunc_2_reduce_res_292736 = defunc_1_op_res_317209;
            }
        }
    }
    
  cleanup:
    {
        free(reduce_stage_1_tid_res_arr_mem_317202);
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_task_337699_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_task_337699_end -
                 futhark_mc_segred_task_337699_start;
        
        ctx->futhark_mc_segred_task_337699_runs[tid]++;
        ctx->futhark_mc_segred_task_337699_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segred_task_337699_iter[tid] += iterations;
    }
    if (err == 0) {
        *futhark_mc_task_337698->retval_defunc_2_reduce_res_292736 =
            defunc_2_reduce_res_292736;
    }
    return err;
}
struct futhark_mc_segred_stage_1_parloop_struct_337705 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_n_p_292677;
    int64_t free_defunc_0_f_res_292697;
    int64_t free_gtid_297431;
    unsigned char *free_Y_mem_312581;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_317211;
};
struct futhark_mc_task_337707 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_n_p_292677;
    int64_t free_gtid_297431;
    int64_t free_gtid_297439;
    unsigned char *free_Y_mem_312581;
    bool *retval_defunc_2_reduce_res_297444;
};
struct futhark_mc_segred_stage_1_parloop_struct_337710 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_n_p_292677;
    int64_t free_gtid_297431;
    int64_t free_gtid_297439;
    unsigned char *free_Y_mem_312581;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_317216;
};
static int futhark_mc_segred_stage_1_parloop_337711(void *args, int64_t start,
                                                    int64_t end,
                                                    int flat_tid_297445,
                                                    int tid)
{
    int err = 0;
    struct futhark_mc_segred_stage_1_parloop_struct_337710
    *futhark_mc_segred_stage_1_parloop_struct_337710 =
    (struct futhark_mc_segred_stage_1_parloop_struct_337710 *) args;
    struct futhark_context *ctx =
                           futhark_mc_segred_stage_1_parloop_struct_337710->ctx;
    uint64_t futhark_mc_segred_stage_1_parloop_337711_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_337711_start = get_wall_time();
    
    int64_t n_292675 =
            futhark_mc_segred_stage_1_parloop_struct_337710->free_n_292675;
    int64_t n_p_292677 =
            futhark_mc_segred_stage_1_parloop_struct_337710->free_n_p_292677;
    int64_t gtid_297431 =
            futhark_mc_segred_stage_1_parloop_struct_337710->free_gtid_297431;
    int64_t gtid_297439 =
            futhark_mc_segred_stage_1_parloop_struct_337710->free_gtid_297439;
    struct memblock Y_mem_312581 = {.desc ="Y_mem_312581", .mem =
                                    futhark_mc_segred_stage_1_parloop_struct_337710->free_Y_mem_312581,
                                    .size =0, .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_317216 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_317216",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_337710->free_reduce_stage_1_tid_res_arr_mem_317216,
                                                             .size =0,
                                                             .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_317218 = start;
    bool x_297447;
    bool x_297448;
    bool local_acc_317219 = 1;
    
    for (; iter_317218 < end; iter_317218++) {
        int64_t gtid_297446 = iter_317218;
        int64_t x_297451 = mul64(n_p_292677, gtid_297446);
        int64_t idx_297452 = add64(gtid_297439, x_297451);
        bool cond_297453 = sle64(n_292675, idx_297452);
        bool defunc_0_f_res_297454;
        
        if (cond_297453) {
            defunc_0_f_res_297454 = 1;
        } else {
            bool x_297455 = sle64((int64_t) 0, idx_297452);
            bool y_297456 = slt64(idx_297452, n_292675);
            bool bounds_check_297457 = x_297455 && y_297456;
            bool index_certs_297458;
            
            if (!bounds_check_297457) {
                ctx->error =
                    msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                              "Index [", (long long) idx_297452,
                              "] out of bounds for array of shape [",
                              (long long) n_292675, "].",
                              "-> #0  stl.fut:410:68-73\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  stl.fut:408:36-411:52\n   #5  /prelude/soacs.fut:59:3-10\n   #6  /prelude/array.fut:195:3-17\n   #7  utils.fut:6:3-16\n   #8  stl.fut:407:29-412:37\n   #9  stl.fut:406:22-413:28\n   #10 stl.fut:463:3-479:36\n   #11 stl.fut:445:1-479:36\n");
                err = FUTHARK_PROGRAM_ERROR;
                goto cleanup;
            }
            
            float isnan_arg_297459;
            
            isnan_arg_297459 = ((float *) Y_mem_312581.mem)[gtid_297431 *
                                                            n_292675 +
                                                            idx_297452];
            
            bool isnan_res_297460;
            
            isnan_res_297460 = futrts_isnan32(isnan_arg_297459);
            defunc_0_f_res_297454 = isnan_res_297460;
        }
        // save map-out results
        { }
        // Load accum params
        {
            x_297447 = local_acc_317219;
        }
        // Load next params
        {
            x_297448 = defunc_0_f_res_297454;
        }
        // Red body
        {
            bool x_297449 = x_297447 && x_297448;
            
            local_acc_317219 = x_297449;
        }
    }
    ((bool *) reduce_stage_1_tid_res_arr_mem_317216.mem)[flat_tid_297445] =
        local_acc_317219;
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_337711_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_337711_end -
                 futhark_mc_segred_stage_1_parloop_337711_start;
        
        ctx->futhark_mc_segred_stage_1_parloop_337711_runs[tid]++;
        ctx->futhark_mc_segred_stage_1_parloop_337711_total_runtime[tid] +=
            elapsed;
        ctx->futhark_mc_segred_stage_1_parloop_337711_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segred_task_337708(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_297445 = tid;
    int num_tasks_317215 = info.nsubtasks;
    struct futhark_mc_task_337707 *futhark_mc_task_337707 =
                                  (struct futhark_mc_task_337707 *) args;
    struct futhark_context *ctx = futhark_mc_task_337707->ctx;
    uint64_t futhark_mc_segred_task_337708_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_task_337708_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_337707->free_n_292675;
    int64_t n_p_292677 = futhark_mc_task_337707->free_n_p_292677;
    int64_t gtid_297431 = futhark_mc_task_337707->free_gtid_297431;
    int64_t gtid_297439 = futhark_mc_task_337707->free_gtid_297439;
    struct memblock Y_mem_312581 = {.desc ="Y_mem_312581", .mem =
                                    futhark_mc_task_337707->free_Y_mem_312581,
                                    .size =0, .references =NULL};
    bool defunc_2_reduce_res_297444 =
         *futhark_mc_task_337707->retval_defunc_2_reduce_res_297444;
    size_t reduce_stage_1_tid_res_arr_mem_317216_cached_sizze_337709 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_317216 = NULL;
    
    if (reduce_stage_1_tid_res_arr_mem_317216_cached_sizze_337709 <
        (size_t) num_tasks_317215) {
        reduce_stage_1_tid_res_arr_mem_317216 =
            realloc(reduce_stage_1_tid_res_arr_mem_317216, num_tasks_317215);
        reduce_stage_1_tid_res_arr_mem_317216_cached_sizze_337709 =
            num_tasks_317215;
    }
    
    int64_t iter_317218;
    struct futhark_mc_segred_stage_1_parloop_struct_337710
    futhark_mc_segred_stage_1_parloop_struct_337710;
    
    futhark_mc_segred_stage_1_parloop_struct_337710.ctx = ctx;
    futhark_mc_segred_stage_1_parloop_struct_337710.free_n_292675 = n_292675;
    futhark_mc_segred_stage_1_parloop_struct_337710.free_n_p_292677 =
        n_p_292677;
    futhark_mc_segred_stage_1_parloop_struct_337710.free_gtid_297431 =
        gtid_297431;
    futhark_mc_segred_stage_1_parloop_struct_337710.free_gtid_297439 =
        gtid_297439;
    futhark_mc_segred_stage_1_parloop_struct_337710.free_Y_mem_312581 =
        Y_mem_312581.mem;
    futhark_mc_segred_stage_1_parloop_struct_337710.free_reduce_stage_1_tid_res_arr_mem_317216 =
        reduce_stage_1_tid_res_arr_mem_317216;
    
    struct scheduler_parloop futhark_mc_segred_stage_1_parloop_337711_task;
    
    futhark_mc_segred_stage_1_parloop_337711_task.name =
        "futhark_mc_segred_stage_1_parloop_337711";
    futhark_mc_segred_stage_1_parloop_337711_task.fn =
        futhark_mc_segred_stage_1_parloop_337711;
    futhark_mc_segred_stage_1_parloop_337711_task.args =
        &futhark_mc_segred_stage_1_parloop_struct_337710;
    futhark_mc_segred_stage_1_parloop_337711_task.iterations = iterations;
    futhark_mc_segred_stage_1_parloop_337711_task.info = info;
    
    uint64_t futhark_mc_segred_stage_1_parloop_337711_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_337711_total_start = get_wall_time();
    
    int futhark_mc_segred_stage_1_parloop_337711_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segred_stage_1_parloop_337711_task);
    
    if (futhark_mc_segred_stage_1_parloop_337711_err != 0) {
        err = futhark_mc_segred_stage_1_parloop_337711_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_337711_total_end =
                 get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_337711_total_end -
                 futhark_mc_segred_stage_1_parloop_337711_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_337711_total_runs,
                           1, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_337711_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_337711_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    // neutral-initialise the output
    {
        defunc_2_reduce_res_297444 = 1;
    }
    
    bool x_317220;
    bool x_317221;
    
    for (int32_t i_317223 = 0; i_317223 < num_tasks_317215; i_317223++) {
        flat_tid_297445 = i_317223;
        // Apply main thread reduction
        {
            // load acc params
            {
                x_317220 = defunc_2_reduce_res_297444;
            }
            // load next params
            {
                x_317221 =
                    ((bool *) reduce_stage_1_tid_res_arr_mem_317216)[flat_tid_297445];
            }
            // red body
            {
                bool x_317222 = x_317220 && x_317221;
                
                defunc_2_reduce_res_297444 = x_317222;
            }
        }
    }
    
  cleanup:
    {
        free(reduce_stage_1_tid_res_arr_mem_317216);
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_task_337708_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_task_337708_end -
                 futhark_mc_segred_task_337708_start;
        
        ctx->futhark_mc_segred_task_337708_runs[tid]++;
        ctx->futhark_mc_segred_task_337708_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segred_task_337708_iter[tid] += iterations;
    }
    if (err == 0) {
        *futhark_mc_task_337707->retval_defunc_2_reduce_res_297444 =
            defunc_2_reduce_res_297444;
    }
    return err;
}
static int futhark_mc_segred_stage_1_parloop_337706(void *args, int64_t start,
                                                    int64_t end,
                                                    int flat_tid_297438,
                                                    int tid)
{
    int err = 0;
    struct futhark_mc_segred_stage_1_parloop_struct_337705
    *futhark_mc_segred_stage_1_parloop_struct_337705 =
    (struct futhark_mc_segred_stage_1_parloop_struct_337705 *) args;
    struct futhark_context *ctx =
                           futhark_mc_segred_stage_1_parloop_struct_337705->ctx;
    uint64_t futhark_mc_segred_stage_1_parloop_337706_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_337706_start = get_wall_time();
    
    int64_t n_292675 =
            futhark_mc_segred_stage_1_parloop_struct_337705->free_n_292675;
    int64_t n_p_292677 =
            futhark_mc_segred_stage_1_parloop_struct_337705->free_n_p_292677;
    int64_t defunc_0_f_res_292697 =
            futhark_mc_segred_stage_1_parloop_struct_337705->free_defunc_0_f_res_292697;
    int64_t gtid_297431 =
            futhark_mc_segred_stage_1_parloop_struct_337705->free_gtid_297431;
    struct memblock Y_mem_312581 = {.desc ="Y_mem_312581", .mem =
                                    futhark_mc_segred_stage_1_parloop_struct_337705->free_Y_mem_312581,
                                    .size =0, .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_317211 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_317211",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_337705->free_reduce_stage_1_tid_res_arr_mem_317211,
                                                             .size =0,
                                                             .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_317213 = start;
    bool x_297440;
    bool x_297441;
    bool local_acc_317214 = 0;
    
    for (; iter_317213 < end; iter_317213++) {
        int64_t gtid_297439 = iter_317213;
        bool defunc_2_reduce_res_297444;
        int64_t flat_tid_297445 = (int64_t) 0;
        int32_t num_tasks_317215;
        
        defunc_2_reduce_res_297444 = 0;
        
        struct futhark_mc_task_337707 futhark_mc_task_337707;
        
        futhark_mc_task_337707.ctx = ctx;
        futhark_mc_task_337707.free_n_292675 = n_292675;
        futhark_mc_task_337707.free_n_p_292677 = n_p_292677;
        futhark_mc_task_337707.free_gtid_297431 = gtid_297431;
        futhark_mc_task_337707.free_gtid_297439 = gtid_297439;
        futhark_mc_task_337707.free_Y_mem_312581 = Y_mem_312581.mem;
        futhark_mc_task_337707.retval_defunc_2_reduce_res_297444 =
            &defunc_2_reduce_res_297444;
        
        struct scheduler_segop futhark_mc_task_337707_task;
        
        futhark_mc_task_337707_task.args = &futhark_mc_task_337707;
        futhark_mc_task_337707_task.top_level_fn =
            futhark_mc_segred_task_337708;
        futhark_mc_task_337707_task.name = "futhark_mc_segred_task_337708";
        futhark_mc_task_337707_task.iterations = defunc_0_f_res_292697;
        futhark_mc_task_337707_task.task_time =
            &ctx->futhark_mc_segred_task_337708_total_time;
        futhark_mc_task_337707_task.task_iter =
            &ctx->futhark_mc_segred_task_337708_total_iter;
        futhark_mc_task_337707_task.sched = STATIC;
        futhark_mc_task_337707_task.nested_fn = NULL;
        
        int futhark_mc_segred_task_337708_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_337707_task);
        
        if (futhark_mc_segred_task_337708_err != 0) {
            ;
            err = futhark_mc_segred_task_337708_err;
            goto cleanup;
        }
        // save map-out results
        { }
        // Load accum params
        {
            x_297440 = local_acc_317214;
        }
        // Load next params
        {
            x_297441 = defunc_2_reduce_res_297444;
        }
        // Red body
        {
            bool defunc_1_op_res_297442 = x_297440 || x_297441;
            
            local_acc_317214 = defunc_1_op_res_297442;
        }
    }
    ((bool *) reduce_stage_1_tid_res_arr_mem_317211.mem)[flat_tid_297438] =
        local_acc_317214;
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_337706_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_337706_end -
                 futhark_mc_segred_stage_1_parloop_337706_start;
        
        ctx->futhark_mc_segred_stage_1_parloop_337706_runs[tid]++;
        ctx->futhark_mc_segred_stage_1_parloop_337706_total_runtime[tid] +=
            elapsed;
        ctx->futhark_mc_segred_stage_1_parloop_337706_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segred_nested_task_337703(void *args, int64_t iterations,
                                         int tid, struct scheduler_info info)
{
    int err = 0;
    int flat_tid_297438 = tid;
    int num_tasks_317201 = info.nsubtasks;
    struct futhark_mc_task_337698 *futhark_mc_task_337698 =
                                  (struct futhark_mc_task_337698 *) args;
    struct futhark_context *ctx = futhark_mc_task_337698->ctx;
    uint64_t futhark_mc_segred_nested_task_337703_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_nested_task_337703_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_337698->free_n_292675;
    int64_t n_p_292677 = futhark_mc_task_337698->free_n_p_292677;
    int64_t defunc_0_f_res_292697 =
            futhark_mc_task_337698->free_defunc_0_f_res_292697;
    int64_t gtid_297431 = futhark_mc_task_337698->free_gtid_297431;
    struct memblock Y_mem_312581 = {.desc ="Y_mem_312581", .mem =
                                    futhark_mc_task_337698->free_Y_mem_312581,
                                    .size =0, .references =NULL};
    bool defunc_2_reduce_res_292736 =
         *futhark_mc_task_337698->retval_defunc_2_reduce_res_292736;
    size_t reduce_stage_1_tid_res_arr_mem_317211_cached_sizze_337704 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_317211 = NULL;
    
    if (reduce_stage_1_tid_res_arr_mem_317211_cached_sizze_337704 <
        (size_t) num_tasks_317201) {
        reduce_stage_1_tid_res_arr_mem_317211 =
            realloc(reduce_stage_1_tid_res_arr_mem_317211, num_tasks_317201);
        reduce_stage_1_tid_res_arr_mem_317211_cached_sizze_337704 =
            num_tasks_317201;
    }
    
    int64_t iter_317213;
    struct futhark_mc_segred_stage_1_parloop_struct_337705
    futhark_mc_segred_stage_1_parloop_struct_337705;
    
    futhark_mc_segred_stage_1_parloop_struct_337705.ctx = ctx;
    futhark_mc_segred_stage_1_parloop_struct_337705.free_n_292675 = n_292675;
    futhark_mc_segred_stage_1_parloop_struct_337705.free_n_p_292677 =
        n_p_292677;
    futhark_mc_segred_stage_1_parloop_struct_337705.free_defunc_0_f_res_292697 =
        defunc_0_f_res_292697;
    futhark_mc_segred_stage_1_parloop_struct_337705.free_gtid_297431 =
        gtid_297431;
    futhark_mc_segred_stage_1_parloop_struct_337705.free_Y_mem_312581 =
        Y_mem_312581.mem;
    futhark_mc_segred_stage_1_parloop_struct_337705.free_reduce_stage_1_tid_res_arr_mem_317211 =
        reduce_stage_1_tid_res_arr_mem_317211;
    
    struct scheduler_parloop futhark_mc_segred_stage_1_parloop_337706_task;
    
    futhark_mc_segred_stage_1_parloop_337706_task.name =
        "futhark_mc_segred_stage_1_parloop_337706";
    futhark_mc_segred_stage_1_parloop_337706_task.fn =
        futhark_mc_segred_stage_1_parloop_337706;
    futhark_mc_segred_stage_1_parloop_337706_task.args =
        &futhark_mc_segred_stage_1_parloop_struct_337705;
    futhark_mc_segred_stage_1_parloop_337706_task.iterations = iterations;
    futhark_mc_segred_stage_1_parloop_337706_task.info = info;
    
    uint64_t futhark_mc_segred_stage_1_parloop_337706_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_337706_total_start = get_wall_time();
    
    int futhark_mc_segred_stage_1_parloop_337706_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segred_stage_1_parloop_337706_task);
    
    if (futhark_mc_segred_stage_1_parloop_337706_err != 0) {
        err = futhark_mc_segred_stage_1_parloop_337706_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_337706_total_end =
                 get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_337706_total_end -
                 futhark_mc_segred_stage_1_parloop_337706_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_337706_total_runs,
                           1, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_337706_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_337706_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    // neutral-initialise the output
    {
        defunc_2_reduce_res_292736 = 0;
    }
    
    bool x_317224;
    bool x_317225;
    
    for (int32_t i_317227 = 0; i_317227 < num_tasks_317201; i_317227++) {
        flat_tid_297438 = i_317227;
        // Apply main thread reduction
        {
            // load acc params
            {
                x_317224 = defunc_2_reduce_res_292736;
            }
            // load next params
            {
                x_317225 =
                    ((bool *) reduce_stage_1_tid_res_arr_mem_317211)[flat_tid_297438];
            }
            // red body
            {
                bool defunc_1_op_res_317226 = x_317224 || x_317225;
                
                defunc_2_reduce_res_292736 = defunc_1_op_res_317226;
            }
        }
    }
    
  cleanup:
    {
        free(reduce_stage_1_tid_res_arr_mem_317211);
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_nested_task_337703_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_nested_task_337703_end -
                 futhark_mc_segred_nested_task_337703_start;
        
        ctx->futhark_mc_segred_nested_task_337703_runs[tid]++;
        ctx->futhark_mc_segred_nested_task_337703_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segred_nested_task_337703_iter[tid] += iterations;
    }
    if (err == 0) {
        *futhark_mc_task_337698->retval_defunc_2_reduce_res_292736 =
            defunc_2_reduce_res_292736;
    }
    return err;
}
struct futhark_mc_scan_stage_3_parloop_struct_337712 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_n_p_292677;
    int64_t free_defunc_0_f_res_292697;
    unsigned char *free_Y_mem_312581;
    unsigned char *free_mem_312584;
};
struct futhark_mc_task_337714 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_n_p_292677;
    int64_t free_defunc_0_f_res_292697;
    int64_t free_gtid_297431;
    unsigned char *free_Y_mem_312581;
    bool *retval_defunc_2_reduce_res_292736;
};
struct futhark_mc_segred_stage_1_parloop_struct_337717 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_n_p_292677;
    int64_t free_defunc_0_f_res_292697;
    int64_t free_gtid_297431;
    unsigned char *free_Y_mem_312581;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_317233;
};
static int futhark_mc_segred_stage_1_parloop_337718(void *args, int64_t start,
                                                    int64_t end,
                                                    int flat_tid_297432,
                                                    int tid)
{
    int err = 0;
    struct futhark_mc_segred_stage_1_parloop_struct_337717
    *futhark_mc_segred_stage_1_parloop_struct_337717 =
    (struct futhark_mc_segred_stage_1_parloop_struct_337717 *) args;
    struct futhark_context *ctx =
                           futhark_mc_segred_stage_1_parloop_struct_337717->ctx;
    uint64_t futhark_mc_segred_stage_1_parloop_337718_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_337718_start = get_wall_time();
    
    int64_t n_292675 =
            futhark_mc_segred_stage_1_parloop_struct_337717->free_n_292675;
    int64_t n_p_292677 =
            futhark_mc_segred_stage_1_parloop_struct_337717->free_n_p_292677;
    int64_t defunc_0_f_res_292697 =
            futhark_mc_segred_stage_1_parloop_struct_337717->free_defunc_0_f_res_292697;
    int64_t gtid_297431 =
            futhark_mc_segred_stage_1_parloop_struct_337717->free_gtid_297431;
    struct memblock Y_mem_312581 = {.desc ="Y_mem_312581", .mem =
                                    futhark_mc_segred_stage_1_parloop_struct_337717->free_Y_mem_312581,
                                    .size =0, .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_317233 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_317233",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_337717->free_reduce_stage_1_tid_res_arr_mem_317233,
                                                             .size =0,
                                                             .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_317235 = start;
    bool x_292737;
    bool x_292738;
    bool local_acc_317236 = 0;
    
    for (; iter_317235 < end; iter_317235++) {
        int64_t gtid_297433 = iter_317235;
        bool defunc_2_reduce_res_292741;
        bool redout_310929 = 1;
        
        for (int64_t i_310930 = 0; i_310930 < defunc_0_f_res_292697;
             i_310930++) {
            int64_t x_292746 = mul64(n_p_292677, i_310930);
            int64_t idx_292747 = add64(x_292746, gtid_297433);
            bool cond_292748 = sle64(n_292675, idx_292747);
            bool defunc_0_f_res_292749;
            
            if (cond_292748) {
                defunc_0_f_res_292749 = 1;
            } else {
                bool x_292750 = sle64((int64_t) 0, idx_292747);
                bool y_292751 = slt64(idx_292747, n_292675);
                bool bounds_check_292752 = x_292750 && y_292751;
                bool index_certs_292753;
                
                if (!bounds_check_292752) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [", (long long) idx_292747,
                                  "] out of bounds for array of shape [",
                                  (long long) n_292675, "].",
                                  "-> #0  stl.fut:410:68-73\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  stl.fut:408:36-411:52\n   #5  /prelude/soacs.fut:59:3-10\n   #6  /prelude/array.fut:195:3-17\n   #7  utils.fut:6:3-16\n   #8  stl.fut:407:29-412:37\n   #9  stl.fut:406:22-413:28\n   #10 stl.fut:463:3-479:36\n   #11 stl.fut:445:1-479:36\n");
                    err = FUTHARK_PROGRAM_ERROR;
                    goto cleanup;
                }
                
                float isnan_arg_292754;
                
                isnan_arg_292754 = ((float *) Y_mem_312581.mem)[gtid_297431 *
                                                                n_292675 +
                                                                idx_292747];
                
                bool isnan_res_292755;
                
                isnan_res_292755 = futrts_isnan32(isnan_arg_292754);
                defunc_0_f_res_292749 = isnan_res_292755;
            }
            
            bool x_292744 = defunc_0_f_res_292749 && redout_310929;
            bool redout_tmp_317237 = x_292744;
            
            redout_310929 = redout_tmp_317237;
        }
        defunc_2_reduce_res_292741 = redout_310929;
        // save map-out results
        { }
        // Load accum params
        {
            x_292737 = local_acc_317236;
        }
        // Load next params
        {
            x_292738 = defunc_2_reduce_res_292741;
        }
        // Red body
        {
            bool defunc_1_op_res_292739 = x_292737 || x_292738;
            
            local_acc_317236 = defunc_1_op_res_292739;
        }
    }
    ((bool *) reduce_stage_1_tid_res_arr_mem_317233.mem)[flat_tid_297432] =
        local_acc_317236;
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_337718_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_337718_end -
                 futhark_mc_segred_stage_1_parloop_337718_start;
        
        ctx->futhark_mc_segred_stage_1_parloop_337718_runs[tid]++;
        ctx->futhark_mc_segred_stage_1_parloop_337718_total_runtime[tid] +=
            elapsed;
        ctx->futhark_mc_segred_stage_1_parloop_337718_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segred_task_337715(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_297432 = tid;
    int num_tasks_317232 = info.nsubtasks;
    struct futhark_mc_task_337714 *futhark_mc_task_337714 =
                                  (struct futhark_mc_task_337714 *) args;
    struct futhark_context *ctx = futhark_mc_task_337714->ctx;
    uint64_t futhark_mc_segred_task_337715_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_task_337715_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_337714->free_n_292675;
    int64_t n_p_292677 = futhark_mc_task_337714->free_n_p_292677;
    int64_t defunc_0_f_res_292697 =
            futhark_mc_task_337714->free_defunc_0_f_res_292697;
    int64_t gtid_297431 = futhark_mc_task_337714->free_gtid_297431;
    struct memblock Y_mem_312581 = {.desc ="Y_mem_312581", .mem =
                                    futhark_mc_task_337714->free_Y_mem_312581,
                                    .size =0, .references =NULL};
    bool defunc_2_reduce_res_292736 =
         *futhark_mc_task_337714->retval_defunc_2_reduce_res_292736;
    size_t reduce_stage_1_tid_res_arr_mem_317233_cached_sizze_337716 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_317233 = NULL;
    
    if (reduce_stage_1_tid_res_arr_mem_317233_cached_sizze_337716 <
        (size_t) num_tasks_317232) {
        reduce_stage_1_tid_res_arr_mem_317233 =
            realloc(reduce_stage_1_tid_res_arr_mem_317233, num_tasks_317232);
        reduce_stage_1_tid_res_arr_mem_317233_cached_sizze_337716 =
            num_tasks_317232;
    }
    
    int64_t iter_317235;
    struct futhark_mc_segred_stage_1_parloop_struct_337717
    futhark_mc_segred_stage_1_parloop_struct_337717;
    
    futhark_mc_segred_stage_1_parloop_struct_337717.ctx = ctx;
    futhark_mc_segred_stage_1_parloop_struct_337717.free_n_292675 = n_292675;
    futhark_mc_segred_stage_1_parloop_struct_337717.free_n_p_292677 =
        n_p_292677;
    futhark_mc_segred_stage_1_parloop_struct_337717.free_defunc_0_f_res_292697 =
        defunc_0_f_res_292697;
    futhark_mc_segred_stage_1_parloop_struct_337717.free_gtid_297431 =
        gtid_297431;
    futhark_mc_segred_stage_1_parloop_struct_337717.free_Y_mem_312581 =
        Y_mem_312581.mem;
    futhark_mc_segred_stage_1_parloop_struct_337717.free_reduce_stage_1_tid_res_arr_mem_317233 =
        reduce_stage_1_tid_res_arr_mem_317233;
    
    struct scheduler_parloop futhark_mc_segred_stage_1_parloop_337718_task;
    
    futhark_mc_segred_stage_1_parloop_337718_task.name =
        "futhark_mc_segred_stage_1_parloop_337718";
    futhark_mc_segred_stage_1_parloop_337718_task.fn =
        futhark_mc_segred_stage_1_parloop_337718;
    futhark_mc_segred_stage_1_parloop_337718_task.args =
        &futhark_mc_segred_stage_1_parloop_struct_337717;
    futhark_mc_segred_stage_1_parloop_337718_task.iterations = iterations;
    futhark_mc_segred_stage_1_parloop_337718_task.info = info;
    
    uint64_t futhark_mc_segred_stage_1_parloop_337718_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_337718_total_start = get_wall_time();
    
    int futhark_mc_segred_stage_1_parloop_337718_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segred_stage_1_parloop_337718_task);
    
    if (futhark_mc_segred_stage_1_parloop_337718_err != 0) {
        err = futhark_mc_segred_stage_1_parloop_337718_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_337718_total_end =
                 get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_337718_total_end -
                 futhark_mc_segred_stage_1_parloop_337718_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_337718_total_runs,
                           1, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_337718_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_337718_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    // neutral-initialise the output
    {
        defunc_2_reduce_res_292736 = 0;
    }
    
    bool x_317238;
    bool x_317239;
    
    for (int32_t i_317241 = 0; i_317241 < num_tasks_317232; i_317241++) {
        flat_tid_297432 = i_317241;
        // Apply main thread reduction
        {
            // load acc params
            {
                x_317238 = defunc_2_reduce_res_292736;
            }
            // load next params
            {
                x_317239 =
                    ((bool *) reduce_stage_1_tid_res_arr_mem_317233)[flat_tid_297432];
            }
            // red body
            {
                bool defunc_1_op_res_317240 = x_317238 || x_317239;
                
                defunc_2_reduce_res_292736 = defunc_1_op_res_317240;
            }
        }
    }
    
  cleanup:
    {
        free(reduce_stage_1_tid_res_arr_mem_317233);
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_task_337715_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_task_337715_end -
                 futhark_mc_segred_task_337715_start;
        
        ctx->futhark_mc_segred_task_337715_runs[tid]++;
        ctx->futhark_mc_segred_task_337715_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segred_task_337715_iter[tid] += iterations;
    }
    if (err == 0) {
        *futhark_mc_task_337714->retval_defunc_2_reduce_res_292736 =
            defunc_2_reduce_res_292736;
    }
    return err;
}
struct futhark_mc_segred_stage_1_parloop_struct_337721 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_n_p_292677;
    int64_t free_defunc_0_f_res_292697;
    int64_t free_gtid_297431;
    unsigned char *free_Y_mem_312581;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_317242;
};
struct futhark_mc_task_337723 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_n_p_292677;
    int64_t free_gtid_297431;
    int64_t free_gtid_297439;
    unsigned char *free_Y_mem_312581;
    bool *retval_defunc_2_reduce_res_297444;
};
struct futhark_mc_segred_stage_1_parloop_struct_337726 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_n_p_292677;
    int64_t free_gtid_297431;
    int64_t free_gtid_297439;
    unsigned char *free_Y_mem_312581;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_317247;
};
static int futhark_mc_segred_stage_1_parloop_337727(void *args, int64_t start,
                                                    int64_t end,
                                                    int flat_tid_297445,
                                                    int tid)
{
    int err = 0;
    struct futhark_mc_segred_stage_1_parloop_struct_337726
    *futhark_mc_segred_stage_1_parloop_struct_337726 =
    (struct futhark_mc_segred_stage_1_parloop_struct_337726 *) args;
    struct futhark_context *ctx =
                           futhark_mc_segred_stage_1_parloop_struct_337726->ctx;
    uint64_t futhark_mc_segred_stage_1_parloop_337727_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_337727_start = get_wall_time();
    
    int64_t n_292675 =
            futhark_mc_segred_stage_1_parloop_struct_337726->free_n_292675;
    int64_t n_p_292677 =
            futhark_mc_segred_stage_1_parloop_struct_337726->free_n_p_292677;
    int64_t gtid_297431 =
            futhark_mc_segred_stage_1_parloop_struct_337726->free_gtid_297431;
    int64_t gtid_297439 =
            futhark_mc_segred_stage_1_parloop_struct_337726->free_gtid_297439;
    struct memblock Y_mem_312581 = {.desc ="Y_mem_312581", .mem =
                                    futhark_mc_segred_stage_1_parloop_struct_337726->free_Y_mem_312581,
                                    .size =0, .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_317247 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_317247",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_337726->free_reduce_stage_1_tid_res_arr_mem_317247,
                                                             .size =0,
                                                             .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_317249 = start;
    bool x_297447;
    bool x_297448;
    bool local_acc_317250 = 1;
    
    for (; iter_317249 < end; iter_317249++) {
        int64_t gtid_297446 = iter_317249;
        int64_t x_297451 = mul64(n_p_292677, gtid_297446);
        int64_t idx_297452 = add64(gtid_297439, x_297451);
        bool cond_297453 = sle64(n_292675, idx_297452);
        bool defunc_0_f_res_297454;
        
        if (cond_297453) {
            defunc_0_f_res_297454 = 1;
        } else {
            bool x_297455 = sle64((int64_t) 0, idx_297452);
            bool y_297456 = slt64(idx_297452, n_292675);
            bool bounds_check_297457 = x_297455 && y_297456;
            bool index_certs_297458;
            
            if (!bounds_check_297457) {
                ctx->error =
                    msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                              "Index [", (long long) idx_297452,
                              "] out of bounds for array of shape [",
                              (long long) n_292675, "].",
                              "-> #0  stl.fut:410:68-73\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  stl.fut:408:36-411:52\n   #5  /prelude/soacs.fut:59:3-10\n   #6  /prelude/array.fut:195:3-17\n   #7  utils.fut:6:3-16\n   #8  stl.fut:407:29-412:37\n   #9  stl.fut:406:22-413:28\n   #10 stl.fut:463:3-479:36\n   #11 stl.fut:445:1-479:36\n");
                err = FUTHARK_PROGRAM_ERROR;
                goto cleanup;
            }
            
            float isnan_arg_297459;
            
            isnan_arg_297459 = ((float *) Y_mem_312581.mem)[gtid_297431 *
                                                            n_292675 +
                                                            idx_297452];
            
            bool isnan_res_297460;
            
            isnan_res_297460 = futrts_isnan32(isnan_arg_297459);
            defunc_0_f_res_297454 = isnan_res_297460;
        }
        // save map-out results
        { }
        // Load accum params
        {
            x_297447 = local_acc_317250;
        }
        // Load next params
        {
            x_297448 = defunc_0_f_res_297454;
        }
        // Red body
        {
            bool x_297449 = x_297447 && x_297448;
            
            local_acc_317250 = x_297449;
        }
    }
    ((bool *) reduce_stage_1_tid_res_arr_mem_317247.mem)[flat_tid_297445] =
        local_acc_317250;
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_337727_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_337727_end -
                 futhark_mc_segred_stage_1_parloop_337727_start;
        
        ctx->futhark_mc_segred_stage_1_parloop_337727_runs[tid]++;
        ctx->futhark_mc_segred_stage_1_parloop_337727_total_runtime[tid] +=
            elapsed;
        ctx->futhark_mc_segred_stage_1_parloop_337727_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segred_task_337724(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_297445 = tid;
    int num_tasks_317246 = info.nsubtasks;
    struct futhark_mc_task_337723 *futhark_mc_task_337723 =
                                  (struct futhark_mc_task_337723 *) args;
    struct futhark_context *ctx = futhark_mc_task_337723->ctx;
    uint64_t futhark_mc_segred_task_337724_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_task_337724_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_337723->free_n_292675;
    int64_t n_p_292677 = futhark_mc_task_337723->free_n_p_292677;
    int64_t gtid_297431 = futhark_mc_task_337723->free_gtid_297431;
    int64_t gtid_297439 = futhark_mc_task_337723->free_gtid_297439;
    struct memblock Y_mem_312581 = {.desc ="Y_mem_312581", .mem =
                                    futhark_mc_task_337723->free_Y_mem_312581,
                                    .size =0, .references =NULL};
    bool defunc_2_reduce_res_297444 =
         *futhark_mc_task_337723->retval_defunc_2_reduce_res_297444;
    size_t reduce_stage_1_tid_res_arr_mem_317247_cached_sizze_337725 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_317247 = NULL;
    
    if (reduce_stage_1_tid_res_arr_mem_317247_cached_sizze_337725 <
        (size_t) num_tasks_317246) {
        reduce_stage_1_tid_res_arr_mem_317247 =
            realloc(reduce_stage_1_tid_res_arr_mem_317247, num_tasks_317246);
        reduce_stage_1_tid_res_arr_mem_317247_cached_sizze_337725 =
            num_tasks_317246;
    }
    
    int64_t iter_317249;
    struct futhark_mc_segred_stage_1_parloop_struct_337726
    futhark_mc_segred_stage_1_parloop_struct_337726;
    
    futhark_mc_segred_stage_1_parloop_struct_337726.ctx = ctx;
    futhark_mc_segred_stage_1_parloop_struct_337726.free_n_292675 = n_292675;
    futhark_mc_segred_stage_1_parloop_struct_337726.free_n_p_292677 =
        n_p_292677;
    futhark_mc_segred_stage_1_parloop_struct_337726.free_gtid_297431 =
        gtid_297431;
    futhark_mc_segred_stage_1_parloop_struct_337726.free_gtid_297439 =
        gtid_297439;
    futhark_mc_segred_stage_1_parloop_struct_337726.free_Y_mem_312581 =
        Y_mem_312581.mem;
    futhark_mc_segred_stage_1_parloop_struct_337726.free_reduce_stage_1_tid_res_arr_mem_317247 =
        reduce_stage_1_tid_res_arr_mem_317247;
    
    struct scheduler_parloop futhark_mc_segred_stage_1_parloop_337727_task;
    
    futhark_mc_segred_stage_1_parloop_337727_task.name =
        "futhark_mc_segred_stage_1_parloop_337727";
    futhark_mc_segred_stage_1_parloop_337727_task.fn =
        futhark_mc_segred_stage_1_parloop_337727;
    futhark_mc_segred_stage_1_parloop_337727_task.args =
        &futhark_mc_segred_stage_1_parloop_struct_337726;
    futhark_mc_segred_stage_1_parloop_337727_task.iterations = iterations;
    futhark_mc_segred_stage_1_parloop_337727_task.info = info;
    
    uint64_t futhark_mc_segred_stage_1_parloop_337727_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_337727_total_start = get_wall_time();
    
    int futhark_mc_segred_stage_1_parloop_337727_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segred_stage_1_parloop_337727_task);
    
    if (futhark_mc_segred_stage_1_parloop_337727_err != 0) {
        err = futhark_mc_segred_stage_1_parloop_337727_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_337727_total_end =
                 get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_337727_total_end -
                 futhark_mc_segred_stage_1_parloop_337727_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_337727_total_runs,
                           1, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_337727_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_337727_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    // neutral-initialise the output
    {
        defunc_2_reduce_res_297444 = 1;
    }
    
    bool x_317251;
    bool x_317252;
    
    for (int32_t i_317254 = 0; i_317254 < num_tasks_317246; i_317254++) {
        flat_tid_297445 = i_317254;
        // Apply main thread reduction
        {
            // load acc params
            {
                x_317251 = defunc_2_reduce_res_297444;
            }
            // load next params
            {
                x_317252 =
                    ((bool *) reduce_stage_1_tid_res_arr_mem_317247)[flat_tid_297445];
            }
            // red body
            {
                bool x_317253 = x_317251 && x_317252;
                
                defunc_2_reduce_res_297444 = x_317253;
            }
        }
    }
    
  cleanup:
    {
        free(reduce_stage_1_tid_res_arr_mem_317247);
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_task_337724_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_task_337724_end -
                 futhark_mc_segred_task_337724_start;
        
        ctx->futhark_mc_segred_task_337724_runs[tid]++;
        ctx->futhark_mc_segred_task_337724_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segred_task_337724_iter[tid] += iterations;
    }
    if (err == 0) {
        *futhark_mc_task_337723->retval_defunc_2_reduce_res_297444 =
            defunc_2_reduce_res_297444;
    }
    return err;
}
static int futhark_mc_segred_stage_1_parloop_337722(void *args, int64_t start,
                                                    int64_t end,
                                                    int flat_tid_297438,
                                                    int tid)
{
    int err = 0;
    struct futhark_mc_segred_stage_1_parloop_struct_337721
    *futhark_mc_segred_stage_1_parloop_struct_337721 =
    (struct futhark_mc_segred_stage_1_parloop_struct_337721 *) args;
    struct futhark_context *ctx =
                           futhark_mc_segred_stage_1_parloop_struct_337721->ctx;
    uint64_t futhark_mc_segred_stage_1_parloop_337722_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_337722_start = get_wall_time();
    
    int64_t n_292675 =
            futhark_mc_segred_stage_1_parloop_struct_337721->free_n_292675;
    int64_t n_p_292677 =
            futhark_mc_segred_stage_1_parloop_struct_337721->free_n_p_292677;
    int64_t defunc_0_f_res_292697 =
            futhark_mc_segred_stage_1_parloop_struct_337721->free_defunc_0_f_res_292697;
    int64_t gtid_297431 =
            futhark_mc_segred_stage_1_parloop_struct_337721->free_gtid_297431;
    struct memblock Y_mem_312581 = {.desc ="Y_mem_312581", .mem =
                                    futhark_mc_segred_stage_1_parloop_struct_337721->free_Y_mem_312581,
                                    .size =0, .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_317242 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_317242",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_337721->free_reduce_stage_1_tid_res_arr_mem_317242,
                                                             .size =0,
                                                             .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_317244 = start;
    bool x_297440;
    bool x_297441;
    bool local_acc_317245 = 0;
    
    for (; iter_317244 < end; iter_317244++) {
        int64_t gtid_297439 = iter_317244;
        bool defunc_2_reduce_res_297444;
        int64_t flat_tid_297445 = (int64_t) 0;
        int32_t num_tasks_317246;
        
        defunc_2_reduce_res_297444 = 0;
        
        struct futhark_mc_task_337723 futhark_mc_task_337723;
        
        futhark_mc_task_337723.ctx = ctx;
        futhark_mc_task_337723.free_n_292675 = n_292675;
        futhark_mc_task_337723.free_n_p_292677 = n_p_292677;
        futhark_mc_task_337723.free_gtid_297431 = gtid_297431;
        futhark_mc_task_337723.free_gtid_297439 = gtid_297439;
        futhark_mc_task_337723.free_Y_mem_312581 = Y_mem_312581.mem;
        futhark_mc_task_337723.retval_defunc_2_reduce_res_297444 =
            &defunc_2_reduce_res_297444;
        
        struct scheduler_segop futhark_mc_task_337723_task;
        
        futhark_mc_task_337723_task.args = &futhark_mc_task_337723;
        futhark_mc_task_337723_task.top_level_fn =
            futhark_mc_segred_task_337724;
        futhark_mc_task_337723_task.name = "futhark_mc_segred_task_337724";
        futhark_mc_task_337723_task.iterations = defunc_0_f_res_292697;
        futhark_mc_task_337723_task.task_time =
            &ctx->futhark_mc_segred_task_337724_total_time;
        futhark_mc_task_337723_task.task_iter =
            &ctx->futhark_mc_segred_task_337724_total_iter;
        futhark_mc_task_337723_task.sched = STATIC;
        futhark_mc_task_337723_task.nested_fn = NULL;
        
        int futhark_mc_segred_task_337724_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_337723_task);
        
        if (futhark_mc_segred_task_337724_err != 0) {
            ;
            err = futhark_mc_segred_task_337724_err;
            goto cleanup;
        }
        // save map-out results
        { }
        // Load accum params
        {
            x_297440 = local_acc_317245;
        }
        // Load next params
        {
            x_297441 = defunc_2_reduce_res_297444;
        }
        // Red body
        {
            bool defunc_1_op_res_297442 = x_297440 || x_297441;
            
            local_acc_317245 = defunc_1_op_res_297442;
        }
    }
    ((bool *) reduce_stage_1_tid_res_arr_mem_317242.mem)[flat_tid_297438] =
        local_acc_317245;
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_337722_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_337722_end -
                 futhark_mc_segred_stage_1_parloop_337722_start;
        
        ctx->futhark_mc_segred_stage_1_parloop_337722_runs[tid]++;
        ctx->futhark_mc_segred_stage_1_parloop_337722_total_runtime[tid] +=
            elapsed;
        ctx->futhark_mc_segred_stage_1_parloop_337722_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segred_nested_task_337719(void *args, int64_t iterations,
                                         int tid, struct scheduler_info info)
{
    int err = 0;
    int flat_tid_297438 = tid;
    int num_tasks_317232 = info.nsubtasks;
    struct futhark_mc_task_337714 *futhark_mc_task_337714 =
                                  (struct futhark_mc_task_337714 *) args;
    struct futhark_context *ctx = futhark_mc_task_337714->ctx;
    uint64_t futhark_mc_segred_nested_task_337719_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_nested_task_337719_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_337714->free_n_292675;
    int64_t n_p_292677 = futhark_mc_task_337714->free_n_p_292677;
    int64_t defunc_0_f_res_292697 =
            futhark_mc_task_337714->free_defunc_0_f_res_292697;
    int64_t gtid_297431 = futhark_mc_task_337714->free_gtid_297431;
    struct memblock Y_mem_312581 = {.desc ="Y_mem_312581", .mem =
                                    futhark_mc_task_337714->free_Y_mem_312581,
                                    .size =0, .references =NULL};
    bool defunc_2_reduce_res_292736 =
         *futhark_mc_task_337714->retval_defunc_2_reduce_res_292736;
    size_t reduce_stage_1_tid_res_arr_mem_317242_cached_sizze_337720 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_317242 = NULL;
    
    if (reduce_stage_1_tid_res_arr_mem_317242_cached_sizze_337720 <
        (size_t) num_tasks_317232) {
        reduce_stage_1_tid_res_arr_mem_317242 =
            realloc(reduce_stage_1_tid_res_arr_mem_317242, num_tasks_317232);
        reduce_stage_1_tid_res_arr_mem_317242_cached_sizze_337720 =
            num_tasks_317232;
    }
    
    int64_t iter_317244;
    struct futhark_mc_segred_stage_1_parloop_struct_337721
    futhark_mc_segred_stage_1_parloop_struct_337721;
    
    futhark_mc_segred_stage_1_parloop_struct_337721.ctx = ctx;
    futhark_mc_segred_stage_1_parloop_struct_337721.free_n_292675 = n_292675;
    futhark_mc_segred_stage_1_parloop_struct_337721.free_n_p_292677 =
        n_p_292677;
    futhark_mc_segred_stage_1_parloop_struct_337721.free_defunc_0_f_res_292697 =
        defunc_0_f_res_292697;
    futhark_mc_segred_stage_1_parloop_struct_337721.free_gtid_297431 =
        gtid_297431;
    futhark_mc_segred_stage_1_parloop_struct_337721.free_Y_mem_312581 =
        Y_mem_312581.mem;
    futhark_mc_segred_stage_1_parloop_struct_337721.free_reduce_stage_1_tid_res_arr_mem_317242 =
        reduce_stage_1_tid_res_arr_mem_317242;
    
    struct scheduler_parloop futhark_mc_segred_stage_1_parloop_337722_task;
    
    futhark_mc_segred_stage_1_parloop_337722_task.name =
        "futhark_mc_segred_stage_1_parloop_337722";
    futhark_mc_segred_stage_1_parloop_337722_task.fn =
        futhark_mc_segred_stage_1_parloop_337722;
    futhark_mc_segred_stage_1_parloop_337722_task.args =
        &futhark_mc_segred_stage_1_parloop_struct_337721;
    futhark_mc_segred_stage_1_parloop_337722_task.iterations = iterations;
    futhark_mc_segred_stage_1_parloop_337722_task.info = info;
    
    uint64_t futhark_mc_segred_stage_1_parloop_337722_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_337722_total_start = get_wall_time();
    
    int futhark_mc_segred_stage_1_parloop_337722_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segred_stage_1_parloop_337722_task);
    
    if (futhark_mc_segred_stage_1_parloop_337722_err != 0) {
        err = futhark_mc_segred_stage_1_parloop_337722_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_337722_total_end =
                 get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_337722_total_end -
                 futhark_mc_segred_stage_1_parloop_337722_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_337722_total_runs,
                           1, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_337722_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_337722_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    // neutral-initialise the output
    {
        defunc_2_reduce_res_292736 = 0;
    }
    
    bool x_317255;
    bool x_317256;
    
    for (int32_t i_317258 = 0; i_317258 < num_tasks_317232; i_317258++) {
        flat_tid_297438 = i_317258;
        // Apply main thread reduction
        {
            // load acc params
            {
                x_317255 = defunc_2_reduce_res_292736;
            }
            // load next params
            {
                x_317256 =
                    ((bool *) reduce_stage_1_tid_res_arr_mem_317242)[flat_tid_297438];
            }
            // red body
            {
                bool defunc_1_op_res_317257 = x_317255 || x_317256;
                
                defunc_2_reduce_res_292736 = defunc_1_op_res_317257;
            }
        }
    }
    
  cleanup:
    {
        free(reduce_stage_1_tid_res_arr_mem_317242);
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_nested_task_337719_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_nested_task_337719_end -
                 futhark_mc_segred_nested_task_337719_start;
        
        ctx->futhark_mc_segred_nested_task_337719_runs[tid]++;
        ctx->futhark_mc_segred_nested_task_337719_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segred_nested_task_337719_iter[tid] += iterations;
    }
    if (err == 0) {
        *futhark_mc_task_337714->retval_defunc_2_reduce_res_292736 =
            defunc_2_reduce_res_292736;
    }
    return err;
}
static int futhark_mc_scan_stage_3_parloop_337713(void *args, int64_t start,
                                                  int64_t end,
                                                  int flat_tid_297430, int tid)
{
    int err = 0;
    struct futhark_mc_scan_stage_3_parloop_struct_337712
    *futhark_mc_scan_stage_3_parloop_struct_337712 =
    (struct futhark_mc_scan_stage_3_parloop_struct_337712 *) args;
    struct futhark_context *ctx =
                           futhark_mc_scan_stage_3_parloop_struct_337712->ctx;
    uint64_t futhark_mc_scan_stage_3_parloop_337713_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_scan_stage_3_parloop_337713_start = get_wall_time();
    
    int64_t n_292675 =
            futhark_mc_scan_stage_3_parloop_struct_337712->free_n_292675;
    int64_t n_p_292677 =
            futhark_mc_scan_stage_3_parloop_struct_337712->free_n_p_292677;
    int64_t defunc_0_f_res_292697 =
            futhark_mc_scan_stage_3_parloop_struct_337712->free_defunc_0_f_res_292697;
    struct memblock Y_mem_312581 = {.desc ="Y_mem_312581", .mem =
                                    futhark_mc_scan_stage_3_parloop_struct_337712->free_Y_mem_312581,
                                    .size =0, .references =NULL};
    struct memblock mem_312584 = {.desc ="mem_312584", .mem =
                                  futhark_mc_scan_stage_3_parloop_struct_337712->free_mem_312584,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_317231 = start;
    int64_t x_317228;
    int64_t y_317229;
    
    if (iter_317231 == (int64_t) 0) {
        x_317228 = (int64_t) 0;
    } else {
        x_317228 = ((int64_t *) mem_312584.mem)[iter_317231 - (int64_t) 1];
    }
    for (; iter_317231 < end; iter_317231++) {
        int64_t gtid_297431 = iter_317231;
        
        // stage 3 scan body
        {
            bool defunc_2_reduce_res_292736;
            int64_t flat_tid_297432 = (int64_t) 0;
            int32_t num_tasks_317232;
            
            defunc_2_reduce_res_292736 = 0;
            
            int64_t flat_tid_297438 = (int64_t) 0;
            struct futhark_mc_task_337714 futhark_mc_task_337714;
            
            futhark_mc_task_337714.ctx = ctx;
            futhark_mc_task_337714.free_n_292675 = n_292675;
            futhark_mc_task_337714.free_n_p_292677 = n_p_292677;
            futhark_mc_task_337714.free_defunc_0_f_res_292697 =
                defunc_0_f_res_292697;
            futhark_mc_task_337714.free_gtid_297431 = gtid_297431;
            futhark_mc_task_337714.free_Y_mem_312581 = Y_mem_312581.mem;
            futhark_mc_task_337714.retval_defunc_2_reduce_res_292736 =
                &defunc_2_reduce_res_292736;
            
            struct scheduler_segop futhark_mc_task_337714_task;
            
            futhark_mc_task_337714_task.args = &futhark_mc_task_337714;
            futhark_mc_task_337714_task.top_level_fn =
                futhark_mc_segred_task_337715;
            futhark_mc_task_337714_task.name = "futhark_mc_segred_task_337715";
            futhark_mc_task_337714_task.iterations = n_p_292677;
            futhark_mc_task_337714_task.task_time =
                &ctx->futhark_mc_segred_task_337715_total_time;
            futhark_mc_task_337714_task.task_iter =
                &ctx->futhark_mc_segred_task_337715_total_iter;
            futhark_mc_task_337714_task.sched = STATIC;
            futhark_mc_task_337714_task.nested_fn =
                futhark_mc_segred_nested_task_337719;
            
            int futhark_mc_segred_task_337715_err =
                scheduler_prepare_task(&ctx->scheduler,
                                       &futhark_mc_task_337714_task);
            
            if (futhark_mc_segred_task_337715_err != 0) {
                ;
                err = futhark_mc_segred_task_337715_err;
                goto cleanup;
            }
            
            int64_t defunc_2_lifted_lambda_res_292756 =
                    btoi_bool_i64(defunc_2_reduce_res_292736);
            bool is_i_292757 = defunc_2_lifted_lambda_res_292756 == (int64_t) 0;
            bool cond_neg_292758 = !is_i_292757;
            int64_t part_res_292759 = btoi_bool_i64(cond_neg_292758);
            int64_t part_res_292760 = btoi_bool_i64(is_i_292757);
            
            x_317228 = x_317228;
            y_317229 = part_res_292760;
            
            int64_t zz_317230 = x_317228 + y_317229;
            
            ((int64_t *) mem_312584.mem)[gtid_297431] = zz_317230;
            x_317228 = zz_317230;
        }
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_scan_stage_3_parloop_337713_end = get_wall_time();
        uint64_t elapsed = futhark_mc_scan_stage_3_parloop_337713_end -
                 futhark_mc_scan_stage_3_parloop_337713_start;
        
        ctx->futhark_mc_scan_stage_3_parloop_337713_runs[tid]++;
        ctx->futhark_mc_scan_stage_3_parloop_337713_total_runtime[tid] +=
            elapsed;
        ctx->futhark_mc_scan_stage_3_parloop_337713_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segscan_task_337680(void *args, int64_t iterations, int tid,
                                   struct scheduler_info info)
{
    int err = 0;
    int flat_tid_297430 = tid;
    int num_tasks_317164 = info.nsubtasks;
    struct futhark_mc_task_337679 *futhark_mc_task_337679 =
                                  (struct futhark_mc_task_337679 *) args;
    struct futhark_context *ctx = futhark_mc_task_337679->ctx;
    uint64_t futhark_mc_segscan_task_337680_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segscan_task_337680_start = get_wall_time();
    
    int64_t m_292674 = futhark_mc_task_337679->free_m_292674;
    int64_t n_292675 = futhark_mc_task_337679->free_n_292675;
    int64_t n_p_292677 = futhark_mc_task_337679->free_n_p_292677;
    int64_t defunc_0_f_res_292697 =
            futhark_mc_task_337679->free_defunc_0_f_res_292697;
    struct memblock Y_mem_312581 = {.desc ="Y_mem_312581", .mem =
                                    futhark_mc_task_337679->free_Y_mem_312581,
                                    .size =0, .references =NULL};
    struct memblock mem_312584 = {.desc ="mem_312584", .mem =
                                  futhark_mc_task_337679->free_mem_312584,
                                  .size =0, .references =NULL};
    struct memblock mem_312587 = {.desc ="mem_312587", .mem =
                                  futhark_mc_task_337679->free_mem_312587,
                                  .size =0, .references =NULL};
    struct memblock mem_312589 = {.desc ="mem_312589", .mem =
                                  futhark_mc_task_337679->free_mem_312589,
                                  .size =0, .references =NULL};
    size_t scan_stage_2_accum_mem_317198_cached_sizze_337681 = 0;
    unsigned char *scan_stage_2_accum_mem_317198 = NULL;
    int64_t iter_317165;
    struct futhark_mc_scan_stage_1_parloop_struct_337682
    futhark_mc_scan_stage_1_parloop_struct_337682;
    
    futhark_mc_scan_stage_1_parloop_struct_337682.ctx = ctx;
    futhark_mc_scan_stage_1_parloop_struct_337682.free_n_292675 = n_292675;
    futhark_mc_scan_stage_1_parloop_struct_337682.free_n_p_292677 = n_p_292677;
    futhark_mc_scan_stage_1_parloop_struct_337682.free_defunc_0_f_res_292697 =
        defunc_0_f_res_292697;
    futhark_mc_scan_stage_1_parloop_struct_337682.free_Y_mem_312581 =
        Y_mem_312581.mem;
    futhark_mc_scan_stage_1_parloop_struct_337682.free_mem_312584 =
        mem_312584.mem;
    futhark_mc_scan_stage_1_parloop_struct_337682.free_mem_312587 =
        mem_312587.mem;
    futhark_mc_scan_stage_1_parloop_struct_337682.free_mem_312589 =
        mem_312589.mem;
    
    struct scheduler_parloop futhark_mc_scan_stage_1_parloop_337683_task;
    
    futhark_mc_scan_stage_1_parloop_337683_task.name =
        "futhark_mc_scan_stage_1_parloop_337683";
    futhark_mc_scan_stage_1_parloop_337683_task.fn =
        futhark_mc_scan_stage_1_parloop_337683;
    futhark_mc_scan_stage_1_parloop_337683_task.args =
        &futhark_mc_scan_stage_1_parloop_struct_337682;
    futhark_mc_scan_stage_1_parloop_337683_task.iterations = iterations;
    futhark_mc_scan_stage_1_parloop_337683_task.info = info;
    
    uint64_t futhark_mc_scan_stage_1_parloop_337683_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_scan_stage_1_parloop_337683_total_start = get_wall_time();
    
    int futhark_mc_scan_stage_1_parloop_337683_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_scan_stage_1_parloop_337683_task);
    
    if (futhark_mc_scan_stage_1_parloop_337683_err != 0) {
        err = futhark_mc_scan_stage_1_parloop_337683_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_scan_stage_1_parloop_337683_total_end =
                 get_wall_time();
        uint64_t elapsed = futhark_mc_scan_stage_1_parloop_337683_total_end -
                 futhark_mc_scan_stage_1_parloop_337683_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_scan_stage_1_parloop_337683_total_runs,
                           1, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_scan_stage_1_parloop_337683_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_scan_stage_1_parloop_337683_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    if (slt32(1, num_tasks_317164)) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "nonsegmentedScan stage 2");
        
        int64_t x_317193;
        int64_t y_317194;
        int64_t offset_317196 = (int64_t) 0;
        int64_t offset_index_317197 = (int64_t) 0;
        
        if (scan_stage_2_accum_mem_317198_cached_sizze_337681 <
            (size_t) (int64_t) 8) {
            scan_stage_2_accum_mem_317198 =
                realloc(scan_stage_2_accum_mem_317198, (int64_t) 8);
            scan_stage_2_accum_mem_317198_cached_sizze_337681 = (int64_t) 8;
        }
        ((int64_t *) scan_stage_2_accum_mem_317198)[(int64_t) 0] = (int64_t) 0;
        for (int32_t i_317200 = 0; i_317200 < num_tasks_317164 - 1;
             i_317200++) {
            offset_317196 = squot64(m_292674, sext_i32_i64(num_tasks_317164));
            if (slt64(sext_i32_i64(i_317200), srem64(m_292674,
                                                     sext_i32_i64(num_tasks_317164)))) {
                offset_317196 += (int64_t) 1;
            }
            offset_index_317197 += offset_317196;
            
            int64_t gtid_297431 = offset_index_317197;
            bool defunc_2_reduce_res_292736;
            int64_t flat_tid_297432 = (int64_t) 0;
            int32_t num_tasks_317201;
            
            defunc_2_reduce_res_292736 = 0;
            
            int64_t flat_tid_297438 = (int64_t) 0;
            struct futhark_mc_task_337698 futhark_mc_task_337698;
            
            futhark_mc_task_337698.ctx = ctx;
            futhark_mc_task_337698.free_n_292675 = n_292675;
            futhark_mc_task_337698.free_n_p_292677 = n_p_292677;
            futhark_mc_task_337698.free_defunc_0_f_res_292697 =
                defunc_0_f_res_292697;
            futhark_mc_task_337698.free_gtid_297431 = gtid_297431;
            futhark_mc_task_337698.free_Y_mem_312581 = Y_mem_312581.mem;
            futhark_mc_task_337698.retval_defunc_2_reduce_res_292736 =
                &defunc_2_reduce_res_292736;
            
            struct scheduler_segop futhark_mc_task_337698_task;
            
            futhark_mc_task_337698_task.args = &futhark_mc_task_337698;
            futhark_mc_task_337698_task.top_level_fn =
                futhark_mc_segred_task_337699;
            futhark_mc_task_337698_task.name = "futhark_mc_segred_task_337699";
            futhark_mc_task_337698_task.iterations = n_p_292677;
            futhark_mc_task_337698_task.task_time =
                &ctx->futhark_mc_segred_task_337699_total_time;
            futhark_mc_task_337698_task.task_iter =
                &ctx->futhark_mc_segred_task_337699_total_iter;
            futhark_mc_task_337698_task.sched = STATIC;
            futhark_mc_task_337698_task.nested_fn =
                futhark_mc_segred_nested_task_337703;
            
            int futhark_mc_segred_task_337699_err =
                scheduler_prepare_task(&ctx->scheduler,
                                       &futhark_mc_task_337698_task);
            
            if (futhark_mc_segred_task_337699_err != 0) {
                ;
                err = futhark_mc_segred_task_337699_err;
                goto cleanup;
            }
            
            int64_t defunc_2_lifted_lambda_res_292756 =
                    btoi_bool_i64(defunc_2_reduce_res_292736);
            bool is_i_292757 = defunc_2_lifted_lambda_res_292756 == (int64_t) 0;
            bool cond_neg_292758 = !is_i_292757;
            int64_t part_res_292759 = btoi_bool_i64(cond_neg_292758);
            int64_t part_res_292760 = btoi_bool_i64(is_i_292757);
            
            // Read carry in
            {
                x_317193 =
                    ((int64_t *) scan_stage_2_accum_mem_317198)[(int64_t) 0];
            }
            // Read next values
            {
                y_317194 = ((int64_t *) mem_312584.mem)[offset_index_317197 -
                                                        (int64_t) 1];
            }
            
            int64_t zz_317195 = x_317193 + y_317194;
            
            ((int64_t *) mem_312584.mem)[offset_index_317197 - (int64_t) 1] =
                zz_317195;
            ((int64_t *) scan_stage_2_accum_mem_317198)[(int64_t) 0] =
                zz_317195;
        }
        
        int64_t iter_317231 = (int64_t) 0;
        struct futhark_mc_scan_stage_3_parloop_struct_337712
        futhark_mc_scan_stage_3_parloop_struct_337712;
        
        futhark_mc_scan_stage_3_parloop_struct_337712.ctx = ctx;
        futhark_mc_scan_stage_3_parloop_struct_337712.free_n_292675 = n_292675;
        futhark_mc_scan_stage_3_parloop_struct_337712.free_n_p_292677 =
            n_p_292677;
        futhark_mc_scan_stage_3_parloop_struct_337712.free_defunc_0_f_res_292697 =
            defunc_0_f_res_292697;
        futhark_mc_scan_stage_3_parloop_struct_337712.free_Y_mem_312581 =
            Y_mem_312581.mem;
        futhark_mc_scan_stage_3_parloop_struct_337712.free_mem_312584 =
            mem_312584.mem;
        
        struct scheduler_parloop futhark_mc_scan_stage_3_parloop_337713_task;
        
        futhark_mc_scan_stage_3_parloop_337713_task.name =
            "futhark_mc_scan_stage_3_parloop_337713";
        futhark_mc_scan_stage_3_parloop_337713_task.fn =
            futhark_mc_scan_stage_3_parloop_337713;
        futhark_mc_scan_stage_3_parloop_337713_task.args =
            &futhark_mc_scan_stage_3_parloop_struct_337712;
        futhark_mc_scan_stage_3_parloop_337713_task.iterations = iterations;
        futhark_mc_scan_stage_3_parloop_337713_task.info = info;
        
        uint64_t futhark_mc_scan_stage_3_parloop_337713_total_start = 0;
        
        if (ctx->profiling && !ctx->profiling_paused)
            futhark_mc_scan_stage_3_parloop_337713_total_start =
                get_wall_time();
        
        int futhark_mc_scan_stage_3_parloop_337713_err =
            scheduler_execute_task(&ctx->scheduler,
                                   &futhark_mc_scan_stage_3_parloop_337713_task);
        
        if (futhark_mc_scan_stage_3_parloop_337713_err != 0) {
            err = futhark_mc_scan_stage_3_parloop_337713_err;
            goto cleanup;
        }
        if (ctx->profiling && !ctx->profiling_paused) {
            uint64_t futhark_mc_scan_stage_3_parloop_337713_total_end =
                     get_wall_time();
            uint64_t elapsed =
                     futhark_mc_scan_stage_3_parloop_337713_total_end -
                     futhark_mc_scan_stage_3_parloop_337713_total_start;
            
            __atomic_fetch_add(&ctx->futhark_mc_scan_stage_3_parloop_337713_total_runs,
                               1, __ATOMIC_RELAXED);
            __atomic_fetch_add(&ctx->futhark_mc_scan_stage_3_parloop_337713_total_total_runtime,
                               elapsed, __ATOMIC_RELAXED);
            __atomic_fetch_add(&ctx->futhark_mc_scan_stage_3_parloop_337713_total_iter,
                               iterations, __ATOMIC_RELAXED);
        }
    }
    
  cleanup:
    {
        free(scan_stage_2_accum_mem_317198);
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segscan_task_337680_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segscan_task_337680_end -
                 futhark_mc_segscan_task_337680_start;
        
        ctx->futhark_mc_segscan_task_337680_runs[tid]++;
        ctx->futhark_mc_segscan_task_337680_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segscan_task_337680_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_task_337728 {
    struct futhark_context *ctx;
    int64_t free_m_292674;
    int64_t free_n_292675;
    unsigned char *free_Y_mem_312581;
    unsigned char *free_mem_312584;
    unsigned char *free_mem_312587;
    unsigned char *free_mem_312593;
    unsigned char *free_mem_312596;
};
struct futhark_mc_segmap_parloop_struct_337730 {
    struct futhark_context *ctx;
    int64_t free_m_292674;
    int64_t free_n_292675;
    unsigned char *free_Y_mem_312581;
    unsigned char *free_mem_312584;
    unsigned char *free_mem_312587;
    unsigned char *free_mem_312593;
    unsigned char *free_mem_312596;
};
static int futhark_mc_segmap_parloop_337731(void *args, int64_t start,
                                            int64_t end, int flat_tid_297461,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_337730
    *futhark_mc_segmap_parloop_struct_337730 =
    (struct futhark_mc_segmap_parloop_struct_337730 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_337730->ctx;
    uint64_t futhark_mc_segmap_parloop_337731_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_337731_start = get_wall_time();
    
    int64_t m_292674 = futhark_mc_segmap_parloop_struct_337730->free_m_292674;
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_337730->free_n_292675;
    struct memblock Y_mem_312581 = {.desc ="Y_mem_312581", .mem =
                                    futhark_mc_segmap_parloop_struct_337730->free_Y_mem_312581,
                                    .size =0, .references =NULL};
    struct memblock mem_312584 = {.desc ="mem_312584", .mem =
                                  futhark_mc_segmap_parloop_struct_337730->free_mem_312584,
                                  .size =0, .references =NULL};
    struct memblock mem_312587 = {.desc ="mem_312587", .mem =
                                  futhark_mc_segmap_parloop_struct_337730->free_mem_312587,
                                  .size =0, .references =NULL};
    struct memblock mem_312593 = {.desc ="mem_312593", .mem =
                                  futhark_mc_segmap_parloop_struct_337730->free_mem_312593,
                                  .size =0, .references =NULL};
    struct memblock mem_312596 = {.desc ="mem_312596", .mem =
                                  futhark_mc_segmap_parloop_struct_337730->free_mem_312596,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_317260 = start;
    
    for (; iter_317260 < end; iter_317260++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_317261 = m_292674;
        int64_t gtid_297462 = iter_317260;
        int64_t remnant_317262 = iter_317260 - gtid_297462;
        int64_t c_292772;
        
        c_292772 = ((int64_t *) mem_312587.mem)[gtid_297462];
        
        int64_t offset_292773;
        
        offset_292773 = ((int64_t *) mem_312584.mem)[gtid_297462];
        
        bool is_this_one_292777 = c_292772 == (int64_t) 0;
        int64_t this_offset_292778 = (int64_t) -1 + offset_292773;
        int64_t total_res_292779;
        
        if (is_this_one_292777) {
            total_res_292779 = this_offset_292778;
        } else {
            total_res_292779 = (int64_t) -1;
        }
        if (sle64((int64_t) 0, total_res_292779) && slt64(total_res_292779,
                                                          m_292674)) {
            if (n_292675 * (int64_t) 4 > 0)
                memmove(mem_312593.mem + total_res_292779 * n_292675 *
                        (int64_t) 4, Y_mem_312581.mem + gtid_297462 * n_292675 *
                        (int64_t) 4, n_292675 * (int64_t) 4);
        }
        if (sle64((int64_t) 0, total_res_292779) && slt64(total_res_292779,
                                                          m_292674)) {
            ((int64_t *) mem_312596.mem)[total_res_292779] = gtid_297462;
        }
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_337731_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_337731_end -
                 futhark_mc_segmap_parloop_337731_start;
        
        ctx->futhark_mc_segmap_parloop_337731_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_337731_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_337731_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_337729(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_297461 = tid;
    int num_tasks_317259 = info.nsubtasks;
    struct futhark_mc_task_337728 *futhark_mc_task_337728 =
                                  (struct futhark_mc_task_337728 *) args;
    struct futhark_context *ctx = futhark_mc_task_337728->ctx;
    uint64_t futhark_mc_segmap_task_337729_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_337729_start = get_wall_time();
    
    int64_t m_292674 = futhark_mc_task_337728->free_m_292674;
    int64_t n_292675 = futhark_mc_task_337728->free_n_292675;
    struct memblock Y_mem_312581 = {.desc ="Y_mem_312581", .mem =
                                    futhark_mc_task_337728->free_Y_mem_312581,
                                    .size =0, .references =NULL};
    struct memblock mem_312584 = {.desc ="mem_312584", .mem =
                                  futhark_mc_task_337728->free_mem_312584,
                                  .size =0, .references =NULL};
    struct memblock mem_312587 = {.desc ="mem_312587", .mem =
                                  futhark_mc_task_337728->free_mem_312587,
                                  .size =0, .references =NULL};
    struct memblock mem_312593 = {.desc ="mem_312593", .mem =
                                  futhark_mc_task_337728->free_mem_312593,
                                  .size =0, .references =NULL};
    struct memblock mem_312596 = {.desc ="mem_312596", .mem =
                                  futhark_mc_task_337728->free_mem_312596,
                                  .size =0, .references =NULL};
    int64_t iter_317260;
    struct futhark_mc_segmap_parloop_struct_337730
    futhark_mc_segmap_parloop_struct_337730;
    
    futhark_mc_segmap_parloop_struct_337730.ctx = ctx;
    futhark_mc_segmap_parloop_struct_337730.free_m_292674 = m_292674;
    futhark_mc_segmap_parloop_struct_337730.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_337730.free_Y_mem_312581 =
        Y_mem_312581.mem;
    futhark_mc_segmap_parloop_struct_337730.free_mem_312584 = mem_312584.mem;
    futhark_mc_segmap_parloop_struct_337730.free_mem_312587 = mem_312587.mem;
    futhark_mc_segmap_parloop_struct_337730.free_mem_312593 = mem_312593.mem;
    futhark_mc_segmap_parloop_struct_337730.free_mem_312596 = mem_312596.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_337731_task;
    
    futhark_mc_segmap_parloop_337731_task.name =
        "futhark_mc_segmap_parloop_337731";
    futhark_mc_segmap_parloop_337731_task.fn = futhark_mc_segmap_parloop_337731;
    futhark_mc_segmap_parloop_337731_task.args =
        &futhark_mc_segmap_parloop_struct_337730;
    futhark_mc_segmap_parloop_337731_task.iterations = iterations;
    futhark_mc_segmap_parloop_337731_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_337731_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_337731_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_337731_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_337731_task);
    
    if (futhark_mc_segmap_parloop_337731_err != 0) {
        err = futhark_mc_segmap_parloop_337731_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_337731_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_337731_total_end -
                 futhark_mc_segmap_parloop_337731_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337731_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337731_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337731_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_337729_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_337729_end -
                 futhark_mc_segmap_task_337729_start;
        
        ctx->futhark_mc_segmap_task_337729_runs[tid]++;
        ctx->futhark_mc_segmap_task_337729_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_337729_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_task_337732 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_partition_sizze_292766;
    int64_t free_i_292846;
    unsigned char *free_mem_312593;
    int64_t free_bytes_312598;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_312639;
};
struct futhark_mc_segmap_parloop_struct_337734 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_partition_sizze_292766;
    int64_t free_i_292846;
    unsigned char *free_mem_312593;
    int64_t free_bytes_312598;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_312639;
};
static int futhark_mc_segmap_parloop_337735(void *args, int64_t start,
                                            int64_t end, int flat_tid_297463,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_337734
    *futhark_mc_segmap_parloop_struct_337734 =
    (struct futhark_mc_segmap_parloop_struct_337734 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_337734->ctx;
    uint64_t futhark_mc_segmap_parloop_337735_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_337735_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_337734->free_n_292675;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_337734->free_partition_sizze_292766;
    int64_t i_292846 = futhark_mc_segmap_parloop_struct_337734->free_i_292846;
    struct memblock mem_312593 = {.desc ="mem_312593", .mem =
                                  futhark_mc_segmap_parloop_struct_337734->free_mem_312593,
                                  .size =0, .references =NULL};
    int64_t bytes_312598 =
            futhark_mc_segmap_parloop_struct_337734->free_bytes_312598;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_segmap_parloop_struct_337734->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_312639 = {.desc ="mem_312639", .mem =
                                  futhark_mc_segmap_parloop_struct_337734->free_mem_312639,
                                  .size =0, .references =NULL};
    size_t mem_312605_cached_sizze_337736 = 0;
    unsigned char *mem_312605 = NULL;
    size_t mem_312620_cached_sizze_337737 = 0;
    unsigned char *mem_312620 = NULL;
    int64_t iterations = end - start;
    int64_t iter_317264 = start;
    
    if (mem_312605_cached_sizze_337736 < (size_t) bytes_312598) {
        mem_312605 = realloc(mem_312605, bytes_312598);
        mem_312605_cached_sizze_337736 = bytes_312598;
    }
    if (mem_312620_cached_sizze_337737 < (size_t) bytes_312598) {
        mem_312620 = realloc(mem_312620, bytes_312598);
        mem_312620_cached_sizze_337737 = bytes_312598;
    }
    for (; iter_317264 < end; iter_317264++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_317283 = partition_sizze_292766;
        int64_t gtid_297464 = iter_317264;
        int64_t remnant_317284 = iter_317264 - gtid_297464;
        int64_t discard_310936;
        int64_t scanacc_317266 = (int64_t) 0;
        
        for (int64_t i_317265 = 0; i_317265 < n_292675; i_317265++) {
            float x_317268;
            
            x_317268 = ((float *) mem_312593.mem)[gtid_297464 * n_292675 +
                                                  i_317265];
            
            bool isnan_res_317269;
            
            isnan_res_317269 = futrts_isnan32(x_317268);
            
            bool defunc_0_p_res_317270 = !isnan_res_317269;
            int64_t defunc_0_f_res_317271 =
                    btoi_bool_i64(defunc_0_p_res_317270);
            int64_t defunc_1_op_res_317272 = add64(defunc_0_f_res_317271,
                                                   scanacc_317266);
            
            ((int64_t *) mem_312605)[i_317265] = defunc_1_op_res_317272;
            
            int64_t scanacc_tmp_317285 = defunc_1_op_res_317272;
            
            scanacc_317266 = scanacc_tmp_317285;
        }
        discard_310936 = scanacc_317266;
        
        int64_t last_res_292862;
        
        last_res_292862 = ((int64_t *) mem_312605)[i_292846];
        for (int64_t i_317287 = 0; i_317287 < n_292675; i_317287++) {
            ((int64_t *) mem_312620)[i_317287] = (int64_t) -1;
        }
        for (int64_t write_iter_317274 = 0; write_iter_317274 < n_292675;
             write_iter_317274++) {
            float write_iv_317276;
            
            write_iv_317276 = ((float *) mem_312593.mem)[gtid_297464 *
                                                         n_292675 +
                                                         write_iter_317274];
            
            bool isnan_res_317277;
            
            isnan_res_317277 = futrts_isnan32(write_iv_317276);
            
            bool defunc_0_p_res_317278 = !isnan_res_317277;
            int64_t defunc_1_f_res_317279;
            
            if (defunc_0_p_res_317278) {
                int64_t write_iv_317280;
                
                write_iv_317280 = ((int64_t *) mem_312605)[write_iter_317274];
                
                int64_t defunc_1_f_res_t_res_317281 = sub64(write_iv_317280,
                                                            (int64_t) 1);
                
                defunc_1_f_res_317279 = defunc_1_f_res_t_res_317281;
            } else {
                defunc_1_f_res_317279 = (int64_t) -1;
            }
            if (sle64((int64_t) 0, defunc_1_f_res_317279) &&
                slt64(defunc_1_f_res_317279, n_292675)) {
                ((int64_t *) mem_312620)[defunc_1_f_res_317279] =
                    write_iter_317274;
            }
        }
        if (n_292675 * (int64_t) 8 > 0)
            memmove(mem_312636.mem + gtid_297464 * n_292675 * (int64_t) 8,
                    mem_312620 + (int64_t) 0, n_292675 * (int64_t) 8);
        ((int64_t *) mem_312639.mem)[gtid_297464] = last_res_292862;
    }
    
  cleanup:
    { }
    free(mem_312605);
    free(mem_312620);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_337735_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_337735_end -
                 futhark_mc_segmap_parloop_337735_start;
        
        ctx->futhark_mc_segmap_parloop_337735_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_337735_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_337735_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_337733(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_297463 = tid;
    int num_tasks_317263 = info.nsubtasks;
    struct futhark_mc_task_337732 *futhark_mc_task_337732 =
                                  (struct futhark_mc_task_337732 *) args;
    struct futhark_context *ctx = futhark_mc_task_337732->ctx;
    uint64_t futhark_mc_segmap_task_337733_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_337733_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_337732->free_n_292675;
    int64_t partition_sizze_292766 =
            futhark_mc_task_337732->free_partition_sizze_292766;
    int64_t i_292846 = futhark_mc_task_337732->free_i_292846;
    struct memblock mem_312593 = {.desc ="mem_312593", .mem =
                                  futhark_mc_task_337732->free_mem_312593,
                                  .size =0, .references =NULL};
    int64_t bytes_312598 = futhark_mc_task_337732->free_bytes_312598;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_task_337732->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_312639 = {.desc ="mem_312639", .mem =
                                  futhark_mc_task_337732->free_mem_312639,
                                  .size =0, .references =NULL};
    int64_t iter_317264;
    struct futhark_mc_segmap_parloop_struct_337734
    futhark_mc_segmap_parloop_struct_337734;
    
    futhark_mc_segmap_parloop_struct_337734.ctx = ctx;
    futhark_mc_segmap_parloop_struct_337734.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_337734.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_337734.free_i_292846 = i_292846;
    futhark_mc_segmap_parloop_struct_337734.free_mem_312593 = mem_312593.mem;
    futhark_mc_segmap_parloop_struct_337734.free_bytes_312598 = bytes_312598;
    futhark_mc_segmap_parloop_struct_337734.free_mem_312636 = mem_312636.mem;
    futhark_mc_segmap_parloop_struct_337734.free_mem_312639 = mem_312639.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_337735_task;
    
    futhark_mc_segmap_parloop_337735_task.name =
        "futhark_mc_segmap_parloop_337735";
    futhark_mc_segmap_parloop_337735_task.fn = futhark_mc_segmap_parloop_337735;
    futhark_mc_segmap_parloop_337735_task.args =
        &futhark_mc_segmap_parloop_struct_337734;
    futhark_mc_segmap_parloop_337735_task.iterations = iterations;
    futhark_mc_segmap_parloop_337735_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_337735_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_337735_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_337735_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_337735_task);
    
    if (futhark_mc_segmap_parloop_337735_err != 0) {
        err = futhark_mc_segmap_parloop_337735_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_337735_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_337735_total_end -
                 futhark_mc_segmap_parloop_337735_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337735_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337735_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337735_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_337733_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_337733_end -
                 futhark_mc_segmap_task_337733_start;
        
        ctx->futhark_mc_segmap_task_337733_runs[tid]++;
        ctx->futhark_mc_segmap_task_337733_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_337733_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_segmap_parloop_struct_337739 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_partition_sizze_292766;
    int64_t free_i_292846;
    unsigned char *free_mem_312593;
    int64_t free_bytes_312598;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_312639;
};
struct futhark_mc_task_337743 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_297472;
    unsigned char *free_mem_312593;
    unsigned char *free_mem_312599;
};
struct futhark_mc_scan_stage_1_parloop_struct_337746 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_297472;
    unsigned char *free_mem_312593;
    unsigned char *free_mem_312599;
};
static int futhark_mc_scan_stage_1_parloop_337747(void *args, int64_t start,
                                                  int64_t end,
                                                  int flat_tid_317290, int tid)
{
    int err = 0;
    struct futhark_mc_scan_stage_1_parloop_struct_337746
    *futhark_mc_scan_stage_1_parloop_struct_337746 =
    (struct futhark_mc_scan_stage_1_parloop_struct_337746 *) args;
    struct futhark_context *ctx =
                           futhark_mc_scan_stage_1_parloop_struct_337746->ctx;
    uint64_t futhark_mc_scan_stage_1_parloop_337747_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_scan_stage_1_parloop_337747_start = get_wall_time();
    
    int64_t n_292675 =
            futhark_mc_scan_stage_1_parloop_struct_337746->free_n_292675;
    int64_t gtid_297472 =
            futhark_mc_scan_stage_1_parloop_struct_337746->free_gtid_297472;
    struct memblock mem_312593 = {.desc ="mem_312593", .mem =
                                  futhark_mc_scan_stage_1_parloop_struct_337746->free_mem_312593,
                                  .size =0, .references =NULL};
    struct memblock mem_312599 = {.desc ="mem_312599", .mem =
                                  futhark_mc_scan_stage_1_parloop_struct_337746->free_mem_312599,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_317310 = start;
    int64_t x_317292;
    int64_t x_317293;
    
    x_317292 = (int64_t) 0;
    for (; iter_317310 < end; iter_317310++) {
        int64_t gtid_317291 = iter_317310;
        
        // stage 1 scan body
        {
            float x_317295;
            
            x_317295 = ((float *) mem_312593.mem)[gtid_297472 * n_292675 +
                                                  gtid_317291];
            
            bool isnan_res_317296;
            
            isnan_res_317296 = futrts_isnan32(x_317295);
            
            bool defunc_0_p_res_317297 = !isnan_res_317296;
            int64_t defunc_0_f_res_317298 =
                    btoi_bool_i64(defunc_0_p_res_317297);
            
            // write mapped values results to memory
            { }
            x_317292 = x_317292;
            // Read next values
            {
                x_317293 = defunc_0_f_res_317298;
            }
            
            int64_t defunc_1_op_res_317294 = add64(x_317292, x_317293);
            
            ((int64_t *) mem_312599.mem)[gtid_317291] = defunc_1_op_res_317294;
            x_317292 = defunc_1_op_res_317294;
        }
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_scan_stage_1_parloop_337747_end = get_wall_time();
        uint64_t elapsed = futhark_mc_scan_stage_1_parloop_337747_end -
                 futhark_mc_scan_stage_1_parloop_337747_start;
        
        ctx->futhark_mc_scan_stage_1_parloop_337747_runs[tid]++;
        ctx->futhark_mc_scan_stage_1_parloop_337747_total_runtime[tid] +=
            elapsed;
        ctx->futhark_mc_scan_stage_1_parloop_337747_iter[tid] += iterations;
    }
    return err;
}
struct futhark_mc_scan_stage_3_parloop_struct_337748 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_297472;
    unsigned char *free_mem_312593;
    unsigned char *free_mem_312599;
};
static int futhark_mc_scan_stage_3_parloop_337749(void *args, int64_t start,
                                                  int64_t end,
                                                  int flat_tid_317290, int tid)
{
    int err = 0;
    struct futhark_mc_scan_stage_3_parloop_struct_337748
    *futhark_mc_scan_stage_3_parloop_struct_337748 =
    (struct futhark_mc_scan_stage_3_parloop_struct_337748 *) args;
    struct futhark_context *ctx =
                           futhark_mc_scan_stage_3_parloop_struct_337748->ctx;
    uint64_t futhark_mc_scan_stage_3_parloop_337749_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_scan_stage_3_parloop_337749_start = get_wall_time();
    
    int64_t n_292675 =
            futhark_mc_scan_stage_3_parloop_struct_337748->free_n_292675;
    int64_t gtid_297472 =
            futhark_mc_scan_stage_3_parloop_struct_337748->free_gtid_297472;
    struct memblock mem_312593 = {.desc ="mem_312593", .mem =
                                  futhark_mc_scan_stage_3_parloop_struct_337748->free_mem_312593,
                                  .size =0, .references =NULL};
    struct memblock mem_312599 = {.desc ="mem_312599", .mem =
                                  futhark_mc_scan_stage_3_parloop_struct_337748->free_mem_312599,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_317322 = start;
    int64_t x_317319;
    int64_t x_317320;
    
    if (iter_317322 == (int64_t) 0) {
        x_317319 = (int64_t) 0;
    } else {
        x_317319 = ((int64_t *) mem_312599.mem)[iter_317322 - (int64_t) 1];
    }
    for (; iter_317322 < end; iter_317322++) {
        int64_t gtid_317291 = iter_317322;
        
        // stage 3 scan body
        {
            float x_317295;
            
            x_317295 = ((float *) mem_312593.mem)[gtid_297472 * n_292675 +
                                                  gtid_317291];
            
            bool isnan_res_317296;
            
            isnan_res_317296 = futrts_isnan32(x_317295);
            
            bool defunc_0_p_res_317297 = !isnan_res_317296;
            int64_t defunc_0_f_res_317298 =
                    btoi_bool_i64(defunc_0_p_res_317297);
            
            x_317319 = x_317319;
            x_317320 = defunc_0_f_res_317298;
            
            int64_t defunc_1_op_res_317321 = add64(x_317319, x_317320);
            
            ((int64_t *) mem_312599.mem)[gtid_317291] = defunc_1_op_res_317321;
            x_317319 = defunc_1_op_res_317321;
        }
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_scan_stage_3_parloop_337749_end = get_wall_time();
        uint64_t elapsed = futhark_mc_scan_stage_3_parloop_337749_end -
                 futhark_mc_scan_stage_3_parloop_337749_start;
        
        ctx->futhark_mc_scan_stage_3_parloop_337749_runs[tid]++;
        ctx->futhark_mc_scan_stage_3_parloop_337749_total_runtime[tid] +=
            elapsed;
        ctx->futhark_mc_scan_stage_3_parloop_337749_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segscan_task_337744(void *args, int64_t iterations, int tid,
                                   struct scheduler_info info)
{
    int err = 0;
    int flat_tid_317290 = tid;
    int num_tasks_317309 = info.nsubtasks;
    struct futhark_mc_task_337743 *futhark_mc_task_337743 =
                                  (struct futhark_mc_task_337743 *) args;
    struct futhark_context *ctx = futhark_mc_task_337743->ctx;
    uint64_t futhark_mc_segscan_task_337744_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segscan_task_337744_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_337743->free_n_292675;
    int64_t gtid_297472 = futhark_mc_task_337743->free_gtid_297472;
    struct memblock mem_312593 = {.desc ="mem_312593", .mem =
                                  futhark_mc_task_337743->free_mem_312593,
                                  .size =0, .references =NULL};
    struct memblock mem_312599 = {.desc ="mem_312599", .mem =
                                  futhark_mc_task_337743->free_mem_312599,
                                  .size =0, .references =NULL};
    size_t scan_stage_2_accum_mem_317316_cached_sizze_337745 = 0;
    unsigned char *scan_stage_2_accum_mem_317316 = NULL;
    int64_t iter_317310;
    struct futhark_mc_scan_stage_1_parloop_struct_337746
    futhark_mc_scan_stage_1_parloop_struct_337746;
    
    futhark_mc_scan_stage_1_parloop_struct_337746.ctx = ctx;
    futhark_mc_scan_stage_1_parloop_struct_337746.free_n_292675 = n_292675;
    futhark_mc_scan_stage_1_parloop_struct_337746.free_gtid_297472 =
        gtid_297472;
    futhark_mc_scan_stage_1_parloop_struct_337746.free_mem_312593 =
        mem_312593.mem;
    futhark_mc_scan_stage_1_parloop_struct_337746.free_mem_312599 =
        mem_312599.mem;
    
    struct scheduler_parloop futhark_mc_scan_stage_1_parloop_337747_task;
    
    futhark_mc_scan_stage_1_parloop_337747_task.name =
        "futhark_mc_scan_stage_1_parloop_337747";
    futhark_mc_scan_stage_1_parloop_337747_task.fn =
        futhark_mc_scan_stage_1_parloop_337747;
    futhark_mc_scan_stage_1_parloop_337747_task.args =
        &futhark_mc_scan_stage_1_parloop_struct_337746;
    futhark_mc_scan_stage_1_parloop_337747_task.iterations = iterations;
    futhark_mc_scan_stage_1_parloop_337747_task.info = info;
    
    uint64_t futhark_mc_scan_stage_1_parloop_337747_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_scan_stage_1_parloop_337747_total_start = get_wall_time();
    
    int futhark_mc_scan_stage_1_parloop_337747_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_scan_stage_1_parloop_337747_task);
    
    if (futhark_mc_scan_stage_1_parloop_337747_err != 0) {
        err = futhark_mc_scan_stage_1_parloop_337747_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_scan_stage_1_parloop_337747_total_end =
                 get_wall_time();
        uint64_t elapsed = futhark_mc_scan_stage_1_parloop_337747_total_end -
                 futhark_mc_scan_stage_1_parloop_337747_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_scan_stage_1_parloop_337747_total_runs,
                           1, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_scan_stage_1_parloop_337747_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_scan_stage_1_parloop_337747_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    if (slt32(1, num_tasks_317309)) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "nonsegmentedScan stage 2");
        
        int64_t x_317311;
        int64_t x_317312;
        int64_t offset_317314 = (int64_t) 0;
        int64_t offset_index_317315 = (int64_t) 0;
        
        if (scan_stage_2_accum_mem_317316_cached_sizze_337745 <
            (size_t) (int64_t) 8) {
            scan_stage_2_accum_mem_317316 =
                realloc(scan_stage_2_accum_mem_317316, (int64_t) 8);
            scan_stage_2_accum_mem_317316_cached_sizze_337745 = (int64_t) 8;
        }
        ((int64_t *) scan_stage_2_accum_mem_317316)[(int64_t) 0] = (int64_t) 0;
        for (int32_t i_317318 = 0; i_317318 < num_tasks_317309 - 1;
             i_317318++) {
            offset_317314 = squot64(n_292675, sext_i32_i64(num_tasks_317309));
            if (slt64(sext_i32_i64(i_317318), srem64(n_292675,
                                                     sext_i32_i64(num_tasks_317309)))) {
                offset_317314 += (int64_t) 1;
            }
            offset_index_317315 += offset_317314;
            
            int64_t gtid_317291 = offset_index_317315;
            float x_317295;
            
            x_317295 = ((float *) mem_312593.mem)[gtid_297472 * n_292675 +
                                                  gtid_317291];
            
            bool isnan_res_317296;
            
            isnan_res_317296 = futrts_isnan32(x_317295);
            
            bool defunc_0_p_res_317297 = !isnan_res_317296;
            int64_t defunc_0_f_res_317298 =
                    btoi_bool_i64(defunc_0_p_res_317297);
            
            // Read carry in
            {
                x_317311 =
                    ((int64_t *) scan_stage_2_accum_mem_317316)[(int64_t) 0];
            }
            // Read next values
            {
                x_317312 = ((int64_t *) mem_312599.mem)[offset_index_317315 -
                                                        (int64_t) 1];
            }
            
            int64_t defunc_1_op_res_317313 = add64(x_317311, x_317312);
            
            ((int64_t *) mem_312599.mem)[offset_index_317315 - (int64_t) 1] =
                defunc_1_op_res_317313;
            ((int64_t *) scan_stage_2_accum_mem_317316)[(int64_t) 0] =
                defunc_1_op_res_317313;
        }
        
        int64_t iter_317322 = (int64_t) 0;
        struct futhark_mc_scan_stage_3_parloop_struct_337748
        futhark_mc_scan_stage_3_parloop_struct_337748;
        
        futhark_mc_scan_stage_3_parloop_struct_337748.ctx = ctx;
        futhark_mc_scan_stage_3_parloop_struct_337748.free_n_292675 = n_292675;
        futhark_mc_scan_stage_3_parloop_struct_337748.free_gtid_297472 =
            gtid_297472;
        futhark_mc_scan_stage_3_parloop_struct_337748.free_mem_312593 =
            mem_312593.mem;
        futhark_mc_scan_stage_3_parloop_struct_337748.free_mem_312599 =
            mem_312599.mem;
        
        struct scheduler_parloop futhark_mc_scan_stage_3_parloop_337749_task;
        
        futhark_mc_scan_stage_3_parloop_337749_task.name =
            "futhark_mc_scan_stage_3_parloop_337749";
        futhark_mc_scan_stage_3_parloop_337749_task.fn =
            futhark_mc_scan_stage_3_parloop_337749;
        futhark_mc_scan_stage_3_parloop_337749_task.args =
            &futhark_mc_scan_stage_3_parloop_struct_337748;
        futhark_mc_scan_stage_3_parloop_337749_task.iterations = iterations;
        futhark_mc_scan_stage_3_parloop_337749_task.info = info;
        
        uint64_t futhark_mc_scan_stage_3_parloop_337749_total_start = 0;
        
        if (ctx->profiling && !ctx->profiling_paused)
            futhark_mc_scan_stage_3_parloop_337749_total_start =
                get_wall_time();
        
        int futhark_mc_scan_stage_3_parloop_337749_err =
            scheduler_execute_task(&ctx->scheduler,
                                   &futhark_mc_scan_stage_3_parloop_337749_task);
        
        if (futhark_mc_scan_stage_3_parloop_337749_err != 0) {
            err = futhark_mc_scan_stage_3_parloop_337749_err;
            goto cleanup;
        }
        if (ctx->profiling && !ctx->profiling_paused) {
            uint64_t futhark_mc_scan_stage_3_parloop_337749_total_end =
                     get_wall_time();
            uint64_t elapsed =
                     futhark_mc_scan_stage_3_parloop_337749_total_end -
                     futhark_mc_scan_stage_3_parloop_337749_total_start;
            
            __atomic_fetch_add(&ctx->futhark_mc_scan_stage_3_parloop_337749_total_runs,
                               1, __ATOMIC_RELAXED);
            __atomic_fetch_add(&ctx->futhark_mc_scan_stage_3_parloop_337749_total_total_runtime,
                               elapsed, __ATOMIC_RELAXED);
            __atomic_fetch_add(&ctx->futhark_mc_scan_stage_3_parloop_337749_total_iter,
                               iterations, __ATOMIC_RELAXED);
        }
    }
    
  cleanup:
    {
        free(scan_stage_2_accum_mem_317316);
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segscan_task_337744_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segscan_task_337744_end -
                 futhark_mc_segscan_task_337744_start;
        
        ctx->futhark_mc_segscan_task_337744_runs[tid]++;
        ctx->futhark_mc_segscan_task_337744_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segscan_task_337744_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_task_337750 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_297472;
    unsigned char *free_mem_312593;
    unsigned char *free_mem_312599;
    unsigned char *free_mem_312602;
};
struct futhark_mc_segmap_parloop_struct_337752 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_297472;
    unsigned char *free_mem_312593;
    unsigned char *free_mem_312599;
    unsigned char *free_mem_312602;
};
static int futhark_mc_segmap_parloop_337753(void *args, int64_t start,
                                            int64_t end, int flat_tid_317299,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_337752
    *futhark_mc_segmap_parloop_struct_337752 =
    (struct futhark_mc_segmap_parloop_struct_337752 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_337752->ctx;
    uint64_t futhark_mc_segmap_parloop_337753_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_337753_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_337752->free_n_292675;
    int64_t gtid_297472 =
            futhark_mc_segmap_parloop_struct_337752->free_gtid_297472;
    struct memblock mem_312593 = {.desc ="mem_312593", .mem =
                                  futhark_mc_segmap_parloop_struct_337752->free_mem_312593,
                                  .size =0, .references =NULL};
    struct memblock mem_312599 = {.desc ="mem_312599", .mem =
                                  futhark_mc_segmap_parloop_struct_337752->free_mem_312599,
                                  .size =0, .references =NULL};
    struct memblock mem_312602 = {.desc ="mem_312602", .mem =
                                  futhark_mc_segmap_parloop_struct_337752->free_mem_312602,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_317325 = start;
    
    for (; iter_317325 < end; iter_317325++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_317328 = n_292675;
        int64_t gtid_317300 = iter_317325;
        int64_t remnant_317329 = iter_317325 - gtid_317300;
        float x_317301;
        
        x_317301 = ((float *) mem_312593.mem)[gtid_297472 * n_292675 +
                                              gtid_317300];
        
        bool isnan_res_317302;
        
        isnan_res_317302 = futrts_isnan32(x_317301);
        
        bool defunc_0_p_res_317303 = !isnan_res_317302;
        int64_t defunc_1_f_res_317304;
        
        if (defunc_0_p_res_317303) {
            int64_t x_317326;
            
            x_317326 = ((int64_t *) mem_312599.mem)[gtid_317300];
            
            int64_t defunc_1_f_res_t_res_317327 = sub64(x_317326, (int64_t) 1);
            
            defunc_1_f_res_317304 = defunc_1_f_res_t_res_317327;
        } else {
            defunc_1_f_res_317304 = (int64_t) -1;
        }
        if (sle64((int64_t) 0, defunc_1_f_res_317304) &&
            slt64(defunc_1_f_res_317304, n_292675)) {
            ((int64_t *) mem_312602.mem)[defunc_1_f_res_317304] = gtid_317300;
        }
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_337753_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_337753_end -
                 futhark_mc_segmap_parloop_337753_start;
        
        ctx->futhark_mc_segmap_parloop_337753_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_337753_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_337753_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_337751(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_317299 = tid;
    int num_tasks_317324 = info.nsubtasks;
    struct futhark_mc_task_337750 *futhark_mc_task_337750 =
                                  (struct futhark_mc_task_337750 *) args;
    struct futhark_context *ctx = futhark_mc_task_337750->ctx;
    uint64_t futhark_mc_segmap_task_337751_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_337751_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_337750->free_n_292675;
    int64_t gtid_297472 = futhark_mc_task_337750->free_gtid_297472;
    struct memblock mem_312593 = {.desc ="mem_312593", .mem =
                                  futhark_mc_task_337750->free_mem_312593,
                                  .size =0, .references =NULL};
    struct memblock mem_312599 = {.desc ="mem_312599", .mem =
                                  futhark_mc_task_337750->free_mem_312599,
                                  .size =0, .references =NULL};
    struct memblock mem_312602 = {.desc ="mem_312602", .mem =
                                  futhark_mc_task_337750->free_mem_312602,
                                  .size =0, .references =NULL};
    int64_t iter_317325;
    struct futhark_mc_segmap_parloop_struct_337752
    futhark_mc_segmap_parloop_struct_337752;
    
    futhark_mc_segmap_parloop_struct_337752.ctx = ctx;
    futhark_mc_segmap_parloop_struct_337752.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_337752.free_gtid_297472 = gtid_297472;
    futhark_mc_segmap_parloop_struct_337752.free_mem_312593 = mem_312593.mem;
    futhark_mc_segmap_parloop_struct_337752.free_mem_312599 = mem_312599.mem;
    futhark_mc_segmap_parloop_struct_337752.free_mem_312602 = mem_312602.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_337753_task;
    
    futhark_mc_segmap_parloop_337753_task.name =
        "futhark_mc_segmap_parloop_337753";
    futhark_mc_segmap_parloop_337753_task.fn = futhark_mc_segmap_parloop_337753;
    futhark_mc_segmap_parloop_337753_task.args =
        &futhark_mc_segmap_parloop_struct_337752;
    futhark_mc_segmap_parloop_337753_task.iterations = iterations;
    futhark_mc_segmap_parloop_337753_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_337753_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_337753_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_337753_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_337753_task);
    
    if (futhark_mc_segmap_parloop_337753_err != 0) {
        err = futhark_mc_segmap_parloop_337753_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_337753_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_337753_total_end -
                 futhark_mc_segmap_parloop_337753_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337753_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337753_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337753_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_337751_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_337751_end -
                 futhark_mc_segmap_task_337751_start;
        
        ctx->futhark_mc_segmap_task_337751_runs[tid]++;
        ctx->futhark_mc_segmap_task_337751_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_337751_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
static int futhark_mc_segmap_parloop_337740(void *args, int64_t start,
                                            int64_t end, int flat_tid_297471,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_337739
    *futhark_mc_segmap_parloop_struct_337739 =
    (struct futhark_mc_segmap_parloop_struct_337739 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_337739->ctx;
    uint64_t futhark_mc_segmap_parloop_337740_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_337740_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_337739->free_n_292675;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_337739->free_partition_sizze_292766;
    int64_t i_292846 = futhark_mc_segmap_parloop_struct_337739->free_i_292846;
    struct memblock mem_312593 = {.desc ="mem_312593", .mem =
                                  futhark_mc_segmap_parloop_struct_337739->free_mem_312593,
                                  .size =0, .references =NULL};
    int64_t bytes_312598 =
            futhark_mc_segmap_parloop_struct_337739->free_bytes_312598;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_segmap_parloop_struct_337739->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_312639 = {.desc ="mem_312639", .mem =
                                  futhark_mc_segmap_parloop_struct_337739->free_mem_312639,
                                  .size =0, .references =NULL};
    size_t mem_312599_cached_sizze_337741 = 0;
    unsigned char *mem_312599 = NULL;
    size_t mem_312602_cached_sizze_337742 = 0;
    unsigned char *mem_312602 = NULL;
    int64_t iterations = end - start;
    int64_t iter_317289 = start;
    
    if (mem_312599_cached_sizze_337741 < (size_t) bytes_312598) {
        mem_312599 = realloc(mem_312599, bytes_312598);
        mem_312599_cached_sizze_337741 = bytes_312598;
    }
    if (mem_312602_cached_sizze_337742 < (size_t) bytes_312598) {
        mem_312602 = realloc(mem_312602, bytes_312598);
        mem_312602_cached_sizze_337742 = bytes_312598;
    }
    for (; iter_317289 < end; iter_317289++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_317307 = partition_sizze_292766;
        int64_t gtid_297472 = iter_317289;
        int64_t remnant_317308 = iter_317289 - gtid_297472;
        int64_t flat_tid_317290 = (int64_t) 0;
        int32_t num_tasks_317309;
        
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "nonsegmented segScan");
        
        struct futhark_mc_task_337743 futhark_mc_task_337743;
        
        futhark_mc_task_337743.ctx = ctx;
        futhark_mc_task_337743.free_n_292675 = n_292675;
        futhark_mc_task_337743.free_gtid_297472 = gtid_297472;
        futhark_mc_task_337743.free_mem_312593 = mem_312593.mem;
        futhark_mc_task_337743.free_mem_312599 = mem_312599;
        
        struct scheduler_segop futhark_mc_task_337743_task;
        
        futhark_mc_task_337743_task.args = &futhark_mc_task_337743;
        futhark_mc_task_337743_task.top_level_fn =
            futhark_mc_segscan_task_337744;
        futhark_mc_task_337743_task.name = "futhark_mc_segscan_task_337744";
        futhark_mc_task_337743_task.iterations = n_292675;
        futhark_mc_task_337743_task.task_time =
            &ctx->futhark_mc_segscan_task_337744_total_time;
        futhark_mc_task_337743_task.task_iter =
            &ctx->futhark_mc_segscan_task_337744_total_iter;
        futhark_mc_task_337743_task.sched = STATIC;
        futhark_mc_task_337743_task.nested_fn = NULL;
        
        int futhark_mc_segscan_task_337744_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_337743_task);
        
        if (futhark_mc_segscan_task_337744_err != 0) {
            ;
            err = futhark_mc_segscan_task_337744_err;
            goto cleanup;
        }
        
        int64_t last_res_297484;
        
        last_res_297484 = ((int64_t *) mem_312599)[i_292846];
        for (int64_t i_317323 = 0; i_317323 < n_292675; i_317323++) {
            ((int64_t *) mem_312602)[i_317323] = (int64_t) -1;
        }
        
        int64_t flat_tid_317299 = (int64_t) 0;
        int32_t num_tasks_317324;
        struct futhark_mc_task_337750 futhark_mc_task_337750;
        
        futhark_mc_task_337750.ctx = ctx;
        futhark_mc_task_337750.free_n_292675 = n_292675;
        futhark_mc_task_337750.free_gtid_297472 = gtid_297472;
        futhark_mc_task_337750.free_mem_312593 = mem_312593.mem;
        futhark_mc_task_337750.free_mem_312599 = mem_312599;
        futhark_mc_task_337750.free_mem_312602 = mem_312602;
        
        struct scheduler_segop futhark_mc_task_337750_task;
        
        futhark_mc_task_337750_task.args = &futhark_mc_task_337750;
        futhark_mc_task_337750_task.top_level_fn =
            futhark_mc_segmap_task_337751;
        futhark_mc_task_337750_task.name = "futhark_mc_segmap_task_337751";
        futhark_mc_task_337750_task.iterations = n_292675;
        futhark_mc_task_337750_task.task_time =
            &ctx->futhark_mc_segmap_task_337751_total_time;
        futhark_mc_task_337750_task.task_iter =
            &ctx->futhark_mc_segmap_task_337751_total_iter;
        futhark_mc_task_337750_task.sched = STATIC;
        futhark_mc_task_337750_task.nested_fn = NULL;
        
        int futhark_mc_segmap_task_337751_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_337750_task);
        
        if (futhark_mc_segmap_task_337751_err != 0) {
            ;
            err = futhark_mc_segmap_task_337751_err;
            goto cleanup;
        }
        if (n_292675 * (int64_t) 8 > 0)
            memmove(mem_312636.mem + gtid_297472 * n_292675 * (int64_t) 8,
                    mem_312602 + (int64_t) 0, n_292675 * (int64_t) 8);
        ((int64_t *) mem_312639.mem)[gtid_297472] = last_res_297484;
    }
    
  cleanup:
    { }
    free(mem_312599);
    free(mem_312602);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_337740_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_337740_end -
                 futhark_mc_segmap_parloop_337740_start;
        
        ctx->futhark_mc_segmap_parloop_337740_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_337740_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_337740_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_nested_task_337738(void *args, int64_t iterations,
                                         int tid, struct scheduler_info info)
{
    int err = 0;
    int flat_tid_297471 = tid;
    int num_tasks_317263 = info.nsubtasks;
    struct futhark_mc_task_337732 *futhark_mc_task_337732 =
                                  (struct futhark_mc_task_337732 *) args;
    struct futhark_context *ctx = futhark_mc_task_337732->ctx;
    uint64_t futhark_mc_segmap_nested_task_337738_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_nested_task_337738_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_337732->free_n_292675;
    int64_t partition_sizze_292766 =
            futhark_mc_task_337732->free_partition_sizze_292766;
    int64_t i_292846 = futhark_mc_task_337732->free_i_292846;
    struct memblock mem_312593 = {.desc ="mem_312593", .mem =
                                  futhark_mc_task_337732->free_mem_312593,
                                  .size =0, .references =NULL};
    int64_t bytes_312598 = futhark_mc_task_337732->free_bytes_312598;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_task_337732->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_312639 = {.desc ="mem_312639", .mem =
                                  futhark_mc_task_337732->free_mem_312639,
                                  .size =0, .references =NULL};
    int64_t iter_317289;
    struct futhark_mc_segmap_parloop_struct_337739
    futhark_mc_segmap_parloop_struct_337739;
    
    futhark_mc_segmap_parloop_struct_337739.ctx = ctx;
    futhark_mc_segmap_parloop_struct_337739.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_337739.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_337739.free_i_292846 = i_292846;
    futhark_mc_segmap_parloop_struct_337739.free_mem_312593 = mem_312593.mem;
    futhark_mc_segmap_parloop_struct_337739.free_bytes_312598 = bytes_312598;
    futhark_mc_segmap_parloop_struct_337739.free_mem_312636 = mem_312636.mem;
    futhark_mc_segmap_parloop_struct_337739.free_mem_312639 = mem_312639.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_337740_task;
    
    futhark_mc_segmap_parloop_337740_task.name =
        "futhark_mc_segmap_parloop_337740";
    futhark_mc_segmap_parloop_337740_task.fn = futhark_mc_segmap_parloop_337740;
    futhark_mc_segmap_parloop_337740_task.args =
        &futhark_mc_segmap_parloop_struct_337739;
    futhark_mc_segmap_parloop_337740_task.iterations = iterations;
    futhark_mc_segmap_parloop_337740_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_337740_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_337740_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_337740_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_337740_task);
    
    if (futhark_mc_segmap_parloop_337740_err != 0) {
        err = futhark_mc_segmap_parloop_337740_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_337740_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_337740_total_end -
                 futhark_mc_segmap_parloop_337740_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337740_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337740_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337740_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_nested_task_337738_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_nested_task_337738_end -
                 futhark_mc_segmap_nested_task_337738_start;
        
        ctx->futhark_mc_segmap_nested_task_337738_runs[tid]++;
        ctx->futhark_mc_segmap_nested_task_337738_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_nested_task_337738_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_task_337754 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_n_p_292677;
    int64_t free_partition_sizze_292766;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_i_292846;
    unsigned char *free_mem_312593;
    int64_t free_bytes_312641;
    int64_t free_bytes_312660;
    unsigned char *free_mem_312713;
};
struct futhark_mc_segmap_parloop_struct_337756 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_n_p_292677;
    int64_t free_partition_sizze_292766;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_i_292846;
    unsigned char *free_mem_312593;
    int64_t free_bytes_312660;
    unsigned char *free_mem_312713;
};
static int futhark_mc_segmap_parloop_337757(void *args, int64_t start,
                                            int64_t end, int flat_tid_297496,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_337756
    *futhark_mc_segmap_parloop_struct_337756 =
    (struct futhark_mc_segmap_parloop_struct_337756 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_337756->ctx;
    uint64_t futhark_mc_segmap_parloop_337757_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_337757_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_337756->free_n_292675;
    int64_t n_p_292677 =
            futhark_mc_segmap_parloop_struct_337756->free_n_p_292677;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_337756->free_partition_sizze_292766;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segmap_parloop_struct_337756->free_defunc_0_f_res_292820;
    int64_t i_292846 = futhark_mc_segmap_parloop_struct_337756->free_i_292846;
    struct memblock mem_312593 = {.desc ="mem_312593", .mem =
                                  futhark_mc_segmap_parloop_struct_337756->free_mem_312593,
                                  .size =0, .references =NULL};
    int64_t bytes_312660 =
            futhark_mc_segmap_parloop_struct_337756->free_bytes_312660;
    struct memblock mem_312713 = {.desc ="mem_312713", .mem =
                                  futhark_mc_segmap_parloop_struct_337756->free_mem_312713,
                                  .size =0, .references =NULL};
    size_t mem_312665_cached_sizze_337758 = 0;
    unsigned char *mem_312665 = NULL;
    int64_t iterations = end - start;
    int64_t iter_317331 = start;
    
    if (mem_312665_cached_sizze_337758 < (size_t) bytes_312660) {
        mem_312665 = realloc(mem_312665, bytes_312660);
        mem_312665_cached_sizze_337758 = bytes_312660;
    }
    for (; iter_317331 < end; iter_317331++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_317348 = partition_sizze_292766;
        int64_t gtid_297497 = iter_317331;
        int64_t remnant_317349 = iter_317331 - gtid_297497;
        
        for (int64_t i_317332 = 0; i_317332 < n_p_292677; i_317332++) {
            for (int64_t i_317335 = 0; i_317335 < defunc_0_f_res_292820;
                 i_317335++) {
                int64_t y_317337 = mul64(n_p_292677, i_317335);
                int64_t new_i_317338 = add64(y_317337, i_317332);
                bool cond_317339 = slt64(i_292846, new_i_317338);
                double defunc_0_f_res_317340;
                
                if (cond_317339) {
                    defunc_0_f_res_317340 = NAN;
                } else {
                    bool x_317341 = sle64((int64_t) 0, new_i_317338);
                    bool y_317342 = slt64(new_i_317338, n_292675);
                    bool bounds_check_317343 = x_317341 && y_317342;
                    bool index_certs_317344;
                    
                    if (!bounds_check_317343) {
                        ctx->error =
                            msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                      "Index [", (long long) new_i_317338,
                                      "] out of bounds for array of shape [",
                                      (long long) n_292675, "].",
                                      "-> #0  stl.fut:122:39-46\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  stl.fut:117:20-123:36\n   #5  /prelude/soacs.fut:59:3-10\n   #6  /prelude/array.fut:195:3-17\n   #7  utils.fut:6:3-16\n   #8  stl.fut:115:12-124:20\n   #9  stl.fut:114:5-125:11\n   #10 stl.fut:419:61-435:77\n   #11 stl.fut:463:3-479:36\n   #12 stl.fut:445:1-479:36\n");
                        err = FUTHARK_PROGRAM_ERROR;
                        goto cleanup;
                    }
                    
                    float f32_arg_317345;
                    
                    f32_arg_317345 = ((float *) mem_312593.mem)[gtid_297497 *
                                                                n_292675 +
                                                                new_i_317338];
                    
                    double f32_res_317346 = fpconv_f32_f64(f32_arg_317345);
                    
                    defunc_0_f_res_317340 = f32_res_317346;
                }
                ((double *) mem_312665)[i_317332 * defunc_0_f_res_292820 +
                                        i_317335] = defunc_0_f_res_317340;
            }
        }
        if (n_p_292677 * defunc_0_f_res_292820 * (int64_t) 8 > 0)
            memmove(mem_312713.mem + gtid_297497 * (defunc_0_f_res_292820 *
                                                    n_p_292677) * (int64_t) 8,
                    mem_312665 + (int64_t) 0, n_p_292677 *
                    defunc_0_f_res_292820 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_312665);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_337757_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_337757_end -
                 futhark_mc_segmap_parloop_337757_start;
        
        ctx->futhark_mc_segmap_parloop_337757_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_337757_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_337757_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_337755(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_297496 = tid;
    int num_tasks_317330 = info.nsubtasks;
    struct futhark_mc_task_337754 *futhark_mc_task_337754 =
                                  (struct futhark_mc_task_337754 *) args;
    struct futhark_context *ctx = futhark_mc_task_337754->ctx;
    uint64_t futhark_mc_segmap_task_337755_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_337755_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_337754->free_n_292675;
    int64_t n_p_292677 = futhark_mc_task_337754->free_n_p_292677;
    int64_t partition_sizze_292766 =
            futhark_mc_task_337754->free_partition_sizze_292766;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_337754->free_defunc_0_f_res_292820;
    int64_t i_292846 = futhark_mc_task_337754->free_i_292846;
    struct memblock mem_312593 = {.desc ="mem_312593", .mem =
                                  futhark_mc_task_337754->free_mem_312593,
                                  .size =0, .references =NULL};
    int64_t bytes_312641 = futhark_mc_task_337754->free_bytes_312641;
    int64_t bytes_312660 = futhark_mc_task_337754->free_bytes_312660;
    struct memblock mem_312713 = {.desc ="mem_312713", .mem =
                                  futhark_mc_task_337754->free_mem_312713,
                                  .size =0, .references =NULL};
    int64_t iter_317331;
    struct futhark_mc_segmap_parloop_struct_337756
    futhark_mc_segmap_parloop_struct_337756;
    
    futhark_mc_segmap_parloop_struct_337756.ctx = ctx;
    futhark_mc_segmap_parloop_struct_337756.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_337756.free_n_p_292677 = n_p_292677;
    futhark_mc_segmap_parloop_struct_337756.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_337756.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segmap_parloop_struct_337756.free_i_292846 = i_292846;
    futhark_mc_segmap_parloop_struct_337756.free_mem_312593 = mem_312593.mem;
    futhark_mc_segmap_parloop_struct_337756.free_bytes_312660 = bytes_312660;
    futhark_mc_segmap_parloop_struct_337756.free_mem_312713 = mem_312713.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_337757_task;
    
    futhark_mc_segmap_parloop_337757_task.name =
        "futhark_mc_segmap_parloop_337757";
    futhark_mc_segmap_parloop_337757_task.fn = futhark_mc_segmap_parloop_337757;
    futhark_mc_segmap_parloop_337757_task.args =
        &futhark_mc_segmap_parloop_struct_337756;
    futhark_mc_segmap_parloop_337757_task.iterations = iterations;
    futhark_mc_segmap_parloop_337757_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_337757_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_337757_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_337757_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_337757_task);
    
    if (futhark_mc_segmap_parloop_337757_err != 0) {
        err = futhark_mc_segmap_parloop_337757_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_337757_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_337757_total_end -
                 futhark_mc_segmap_parloop_337757_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337757_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337757_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337757_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_337755_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_337755_end -
                 futhark_mc_segmap_task_337755_start;
        
        ctx->futhark_mc_segmap_task_337755_runs[tid]++;
        ctx->futhark_mc_segmap_task_337755_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_337755_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_segmap_parloop_struct_337760 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_n_p_292677;
    int64_t free_partition_sizze_292766;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_i_292846;
    unsigned char *free_mem_312593;
    int64_t free_bytes_312641;
    int64_t free_bytes_312660;
    unsigned char *free_mem_312713;
};
struct futhark_mc_task_337763 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_n_p_292677;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_i_292846;
    int64_t free_gtid_297524;
    unsigned char *free_mem_312593;
    int64_t free_bytes_312641;
    unsigned char *free_mem_312661;
};
struct futhark_mc_segmap_parloop_struct_337765 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_n_p_292677;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_i_292846;
    int64_t free_gtid_297524;
    unsigned char *free_mem_312593;
    int64_t free_bytes_312641;
    unsigned char *free_mem_312661;
};
static int futhark_mc_segmap_parloop_337766(void *args, int64_t start,
                                            int64_t end, int flat_tid_317369,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_337765
    *futhark_mc_segmap_parloop_struct_337765 =
    (struct futhark_mc_segmap_parloop_struct_337765 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_337765->ctx;
    uint64_t futhark_mc_segmap_parloop_337766_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_337766_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_337765->free_n_292675;
    int64_t n_p_292677 =
            futhark_mc_segmap_parloop_struct_337765->free_n_p_292677;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segmap_parloop_struct_337765->free_defunc_0_f_res_292820;
    int64_t i_292846 = futhark_mc_segmap_parloop_struct_337765->free_i_292846;
    int64_t gtid_297524 =
            futhark_mc_segmap_parloop_struct_337765->free_gtid_297524;
    struct memblock mem_312593 = {.desc ="mem_312593", .mem =
                                  futhark_mc_segmap_parloop_struct_337765->free_mem_312593,
                                  .size =0, .references =NULL};
    int64_t bytes_312641 =
            futhark_mc_segmap_parloop_struct_337765->free_bytes_312641;
    struct memblock mem_312661 = {.desc ="mem_312661", .mem =
                                  futhark_mc_segmap_parloop_struct_337765->free_mem_312661,
                                  .size =0, .references =NULL};
    size_t mem_317371_cached_sizze_337767 = 0;
    unsigned char *mem_317371 = NULL;
    int64_t iterations = end - start;
    int64_t iter_317390 = start;
    
    if (mem_317371_cached_sizze_337767 < (size_t) bytes_312641) {
        mem_317371 = realloc(mem_317371, bytes_312641);
        mem_317371_cached_sizze_337767 = bytes_312641;
    }
    for (; iter_317390 < end; iter_317390++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_317404 = n_p_292677;
        int64_t gtid_317370 = iter_317390;
        int64_t remnant_317405 = iter_317390 - gtid_317370;
        
        for (int64_t i_317391 = 0; i_317391 < defunc_0_f_res_292820;
             i_317391++) {
            int64_t y_317393 = mul64(n_p_292677, i_317391);
            int64_t new_i_317394 = add64(gtid_317370, y_317393);
            bool cond_317395 = slt64(i_292846, new_i_317394);
            double defunc_0_f_res_317396;
            
            if (cond_317395) {
                defunc_0_f_res_317396 = NAN;
            } else {
                bool x_317397 = sle64((int64_t) 0, new_i_317394);
                bool y_317398 = slt64(new_i_317394, n_292675);
                bool bounds_check_317399 = x_317397 && y_317398;
                bool index_certs_317400;
                
                if (!bounds_check_317399) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [", (long long) new_i_317394,
                                  "] out of bounds for array of shape [",
                                  (long long) n_292675, "].",
                                  "-> #0  stl.fut:122:39-46\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  stl.fut:117:20-123:36\n   #5  /prelude/soacs.fut:59:3-10\n   #6  /prelude/array.fut:195:3-17\n   #7  utils.fut:6:3-16\n   #8  stl.fut:115:12-124:20\n   #9  stl.fut:114:5-125:11\n   #10 stl.fut:419:61-435:77\n   #11 stl.fut:463:3-479:36\n   #12 stl.fut:445:1-479:36\n");
                    err = FUTHARK_PROGRAM_ERROR;
                    goto cleanup;
                }
                
                float f32_arg_317401;
                
                f32_arg_317401 = ((float *) mem_312593.mem)[gtid_297524 *
                                                            n_292675 +
                                                            new_i_317394];
                
                double f32_res_317402 = fpconv_f32_f64(f32_arg_317401);
                
                defunc_0_f_res_317396 = f32_res_317402;
            }
            ((double *) mem_317371)[i_317391] = defunc_0_f_res_317396;
        }
        if (defunc_0_f_res_292820 * (int64_t) 8 > 0)
            memmove(mem_312661.mem + gtid_317370 * defunc_0_f_res_292820 *
                    (int64_t) 8, mem_317371 + (int64_t) 0,
                    defunc_0_f_res_292820 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_317371);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_337766_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_337766_end -
                 futhark_mc_segmap_parloop_337766_start;
        
        ctx->futhark_mc_segmap_parloop_337766_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_337766_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_337766_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_337764(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_317369 = tid;
    int num_tasks_317389 = info.nsubtasks;
    struct futhark_mc_task_337763 *futhark_mc_task_337763 =
                                  (struct futhark_mc_task_337763 *) args;
    struct futhark_context *ctx = futhark_mc_task_337763->ctx;
    uint64_t futhark_mc_segmap_task_337764_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_337764_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_337763->free_n_292675;
    int64_t n_p_292677 = futhark_mc_task_337763->free_n_p_292677;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_337763->free_defunc_0_f_res_292820;
    int64_t i_292846 = futhark_mc_task_337763->free_i_292846;
    int64_t gtid_297524 = futhark_mc_task_337763->free_gtid_297524;
    struct memblock mem_312593 = {.desc ="mem_312593", .mem =
                                  futhark_mc_task_337763->free_mem_312593,
                                  .size =0, .references =NULL};
    int64_t bytes_312641 = futhark_mc_task_337763->free_bytes_312641;
    struct memblock mem_312661 = {.desc ="mem_312661", .mem =
                                  futhark_mc_task_337763->free_mem_312661,
                                  .size =0, .references =NULL};
    int64_t iter_317390;
    struct futhark_mc_segmap_parloop_struct_337765
    futhark_mc_segmap_parloop_struct_337765;
    
    futhark_mc_segmap_parloop_struct_337765.ctx = ctx;
    futhark_mc_segmap_parloop_struct_337765.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_337765.free_n_p_292677 = n_p_292677;
    futhark_mc_segmap_parloop_struct_337765.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segmap_parloop_struct_337765.free_i_292846 = i_292846;
    futhark_mc_segmap_parloop_struct_337765.free_gtid_297524 = gtid_297524;
    futhark_mc_segmap_parloop_struct_337765.free_mem_312593 = mem_312593.mem;
    futhark_mc_segmap_parloop_struct_337765.free_bytes_312641 = bytes_312641;
    futhark_mc_segmap_parloop_struct_337765.free_mem_312661 = mem_312661.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_337766_task;
    
    futhark_mc_segmap_parloop_337766_task.name =
        "futhark_mc_segmap_parloop_337766";
    futhark_mc_segmap_parloop_337766_task.fn = futhark_mc_segmap_parloop_337766;
    futhark_mc_segmap_parloop_337766_task.args =
        &futhark_mc_segmap_parloop_struct_337765;
    futhark_mc_segmap_parloop_337766_task.iterations = iterations;
    futhark_mc_segmap_parloop_337766_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_337766_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_337766_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_337766_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_337766_task);
    
    if (futhark_mc_segmap_parloop_337766_err != 0) {
        err = futhark_mc_segmap_parloop_337766_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_337766_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_337766_total_end -
                 futhark_mc_segmap_parloop_337766_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337766_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337766_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337766_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_337764_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_337764_end -
                 futhark_mc_segmap_task_337764_start;
        
        ctx->futhark_mc_segmap_task_337764_runs[tid]++;
        ctx->futhark_mc_segmap_task_337764_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_337764_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_segmap_parloop_struct_337769 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_n_p_292677;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_i_292846;
    int64_t free_gtid_297524;
    unsigned char *free_mem_312593;
    int64_t free_bytes_312641;
    unsigned char *free_mem_312661;
};
struct futhark_mc_task_337772 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_n_p_292677;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_i_292846;
    int64_t free_gtid_297524;
    unsigned char *free_mem_312593;
    int64_t free_gtid_317354;
    unsigned char *free_mem_317355;
};
struct futhark_mc_segmap_parloop_struct_337774 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_n_p_292677;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_i_292846;
    int64_t free_gtid_297524;
    unsigned char *free_mem_312593;
    int64_t free_gtid_317354;
    unsigned char *free_mem_317355;
};
static int futhark_mc_segmap_parloop_337775(void *args, int64_t start,
                                            int64_t end, int flat_tid_317408,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_337774
    *futhark_mc_segmap_parloop_struct_337774 =
    (struct futhark_mc_segmap_parloop_struct_337774 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_337774->ctx;
    uint64_t futhark_mc_segmap_parloop_337775_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_337775_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_337774->free_n_292675;
    int64_t n_p_292677 =
            futhark_mc_segmap_parloop_struct_337774->free_n_p_292677;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segmap_parloop_struct_337774->free_defunc_0_f_res_292820;
    int64_t i_292846 = futhark_mc_segmap_parloop_struct_337774->free_i_292846;
    int64_t gtid_297524 =
            futhark_mc_segmap_parloop_struct_337774->free_gtid_297524;
    struct memblock mem_312593 = {.desc ="mem_312593", .mem =
                                  futhark_mc_segmap_parloop_struct_337774->free_mem_312593,
                                  .size =0, .references =NULL};
    int64_t gtid_317354 =
            futhark_mc_segmap_parloop_struct_337774->free_gtid_317354;
    struct memblock mem_317355 = {.desc ="mem_317355", .mem =
                                  futhark_mc_segmap_parloop_struct_337774->free_mem_317355,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_317423 = start;
    
    for (; iter_317423 < end; iter_317423++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_317430 = defunc_0_f_res_292820;
        int64_t gtid_317409 = iter_317423;
        int64_t remnant_317431 = iter_317423 - gtid_317409;
        int64_t y_317410 = mul64(n_p_292677, gtid_317409);
        int64_t new_i_317411 = add64(gtid_317354, y_317410);
        bool cond_317412 = slt64(i_292846, new_i_317411);
        double defunc_0_f_res_317413;
        
        if (cond_317412) {
            defunc_0_f_res_317413 = NAN;
        } else {
            bool x_317424 = sle64((int64_t) 0, new_i_317411);
            bool y_317425 = slt64(new_i_317411, n_292675);
            bool bounds_check_317426 = x_317424 && y_317425;
            bool index_certs_317427;
            
            if (!bounds_check_317426) {
                ctx->error =
                    msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                              "Index [", (long long) new_i_317411,
                              "] out of bounds for array of shape [",
                              (long long) n_292675, "].",
                              "-> #0  stl.fut:122:39-46\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  stl.fut:117:20-123:36\n   #5  /prelude/soacs.fut:59:3-10\n   #6  /prelude/array.fut:195:3-17\n   #7  utils.fut:6:3-16\n   #8  stl.fut:115:12-124:20\n   #9  stl.fut:114:5-125:11\n   #10 stl.fut:419:61-435:77\n   #11 stl.fut:463:3-479:36\n   #12 stl.fut:445:1-479:36\n");
                err = FUTHARK_PROGRAM_ERROR;
                goto cleanup;
            }
            
            float f32_arg_317428;
            
            f32_arg_317428 = ((float *) mem_312593.mem)[gtid_297524 * n_292675 +
                                                        new_i_317411];
            
            double f32_res_317429 = fpconv_f32_f64(f32_arg_317428);
            
            defunc_0_f_res_317413 = f32_res_317429;
        }
        ((double *) mem_317355.mem)[gtid_317409] = defunc_0_f_res_317413;
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_337775_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_337775_end -
                 futhark_mc_segmap_parloop_337775_start;
        
        ctx->futhark_mc_segmap_parloop_337775_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_337775_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_337775_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_337773(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_317408 = tid;
    int num_tasks_317422 = info.nsubtasks;
    struct futhark_mc_task_337772 *futhark_mc_task_337772 =
                                  (struct futhark_mc_task_337772 *) args;
    struct futhark_context *ctx = futhark_mc_task_337772->ctx;
    uint64_t futhark_mc_segmap_task_337773_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_337773_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_337772->free_n_292675;
    int64_t n_p_292677 = futhark_mc_task_337772->free_n_p_292677;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_337772->free_defunc_0_f_res_292820;
    int64_t i_292846 = futhark_mc_task_337772->free_i_292846;
    int64_t gtid_297524 = futhark_mc_task_337772->free_gtid_297524;
    struct memblock mem_312593 = {.desc ="mem_312593", .mem =
                                  futhark_mc_task_337772->free_mem_312593,
                                  .size =0, .references =NULL};
    int64_t gtid_317354 = futhark_mc_task_337772->free_gtid_317354;
    struct memblock mem_317355 = {.desc ="mem_317355", .mem =
                                  futhark_mc_task_337772->free_mem_317355,
                                  .size =0, .references =NULL};
    int64_t iter_317423;
    struct futhark_mc_segmap_parloop_struct_337774
    futhark_mc_segmap_parloop_struct_337774;
    
    futhark_mc_segmap_parloop_struct_337774.ctx = ctx;
    futhark_mc_segmap_parloop_struct_337774.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_337774.free_n_p_292677 = n_p_292677;
    futhark_mc_segmap_parloop_struct_337774.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segmap_parloop_struct_337774.free_i_292846 = i_292846;
    futhark_mc_segmap_parloop_struct_337774.free_gtid_297524 = gtid_297524;
    futhark_mc_segmap_parloop_struct_337774.free_mem_312593 = mem_312593.mem;
    futhark_mc_segmap_parloop_struct_337774.free_gtid_317354 = gtid_317354;
    futhark_mc_segmap_parloop_struct_337774.free_mem_317355 = mem_317355.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_337775_task;
    
    futhark_mc_segmap_parloop_337775_task.name =
        "futhark_mc_segmap_parloop_337775";
    futhark_mc_segmap_parloop_337775_task.fn = futhark_mc_segmap_parloop_337775;
    futhark_mc_segmap_parloop_337775_task.args =
        &futhark_mc_segmap_parloop_struct_337774;
    futhark_mc_segmap_parloop_337775_task.iterations = iterations;
    futhark_mc_segmap_parloop_337775_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_337775_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_337775_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_337775_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_337775_task);
    
    if (futhark_mc_segmap_parloop_337775_err != 0) {
        err = futhark_mc_segmap_parloop_337775_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_337775_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_337775_total_end -
                 futhark_mc_segmap_parloop_337775_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337775_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337775_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337775_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_337773_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_337773_end -
                 futhark_mc_segmap_task_337773_start;
        
        ctx->futhark_mc_segmap_task_337773_runs[tid]++;
        ctx->futhark_mc_segmap_task_337773_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_337773_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
static int futhark_mc_segmap_parloop_337770(void *args, int64_t start,
                                            int64_t end, int flat_tid_317353,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_337769
    *futhark_mc_segmap_parloop_struct_337769 =
    (struct futhark_mc_segmap_parloop_struct_337769 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_337769->ctx;
    uint64_t futhark_mc_segmap_parloop_337770_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_337770_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_337769->free_n_292675;
    int64_t n_p_292677 =
            futhark_mc_segmap_parloop_struct_337769->free_n_p_292677;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segmap_parloop_struct_337769->free_defunc_0_f_res_292820;
    int64_t i_292846 = futhark_mc_segmap_parloop_struct_337769->free_i_292846;
    int64_t gtid_297524 =
            futhark_mc_segmap_parloop_struct_337769->free_gtid_297524;
    struct memblock mem_312593 = {.desc ="mem_312593", .mem =
                                  futhark_mc_segmap_parloop_struct_337769->free_mem_312593,
                                  .size =0, .references =NULL};
    int64_t bytes_312641 =
            futhark_mc_segmap_parloop_struct_337769->free_bytes_312641;
    struct memblock mem_312661 = {.desc ="mem_312661", .mem =
                                  futhark_mc_segmap_parloop_struct_337769->free_mem_312661,
                                  .size =0, .references =NULL};
    size_t mem_317355_cached_sizze_337771 = 0;
    unsigned char *mem_317355 = NULL;
    int64_t iterations = end - start;
    int64_t iter_317407 = start;
    
    if (mem_317355_cached_sizze_337771 < (size_t) bytes_312641) {
        mem_317355 = realloc(mem_317355, bytes_312641);
        mem_317355_cached_sizze_337771 = bytes_312641;
    }
    for (; iter_317407 < end; iter_317407++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_317420 = n_p_292677;
        int64_t gtid_317354 = iter_317407;
        int64_t remnant_317421 = iter_317407 - gtid_317354;
        int64_t flat_tid_317408 = (int64_t) 0;
        int32_t num_tasks_317422;
        struct futhark_mc_task_337772 futhark_mc_task_337772;
        
        futhark_mc_task_337772.ctx = ctx;
        futhark_mc_task_337772.free_n_292675 = n_292675;
        futhark_mc_task_337772.free_n_p_292677 = n_p_292677;
        futhark_mc_task_337772.free_defunc_0_f_res_292820 =
            defunc_0_f_res_292820;
        futhark_mc_task_337772.free_i_292846 = i_292846;
        futhark_mc_task_337772.free_gtid_297524 = gtid_297524;
        futhark_mc_task_337772.free_mem_312593 = mem_312593.mem;
        futhark_mc_task_337772.free_gtid_317354 = gtid_317354;
        futhark_mc_task_337772.free_mem_317355 = mem_317355;
        
        struct scheduler_segop futhark_mc_task_337772_task;
        
        futhark_mc_task_337772_task.args = &futhark_mc_task_337772;
        futhark_mc_task_337772_task.top_level_fn =
            futhark_mc_segmap_task_337773;
        futhark_mc_task_337772_task.name = "futhark_mc_segmap_task_337773";
        futhark_mc_task_337772_task.iterations = defunc_0_f_res_292820;
        futhark_mc_task_337772_task.task_time =
            &ctx->futhark_mc_segmap_task_337773_total_time;
        futhark_mc_task_337772_task.task_iter =
            &ctx->futhark_mc_segmap_task_337773_total_iter;
        futhark_mc_task_337772_task.sched = STATIC;
        futhark_mc_task_337772_task.nested_fn = NULL;
        
        int futhark_mc_segmap_task_337773_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_337772_task);
        
        if (futhark_mc_segmap_task_337773_err != 0) {
            ;
            err = futhark_mc_segmap_task_337773_err;
            goto cleanup;
        }
        if (defunc_0_f_res_292820 * (int64_t) 8 > 0)
            memmove(mem_312661.mem + gtid_317354 * defunc_0_f_res_292820 *
                    (int64_t) 8, mem_317355 + (int64_t) 0,
                    defunc_0_f_res_292820 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_317355);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_337770_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_337770_end -
                 futhark_mc_segmap_parloop_337770_start;
        
        ctx->futhark_mc_segmap_parloop_337770_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_337770_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_337770_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_nested_task_337768(void *args, int64_t iterations,
                                         int tid, struct scheduler_info info)
{
    int err = 0;
    int flat_tid_317353 = tid;
    int num_tasks_317389 = info.nsubtasks;
    struct futhark_mc_task_337763 *futhark_mc_task_337763 =
                                  (struct futhark_mc_task_337763 *) args;
    struct futhark_context *ctx = futhark_mc_task_337763->ctx;
    uint64_t futhark_mc_segmap_nested_task_337768_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_nested_task_337768_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_337763->free_n_292675;
    int64_t n_p_292677 = futhark_mc_task_337763->free_n_p_292677;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_337763->free_defunc_0_f_res_292820;
    int64_t i_292846 = futhark_mc_task_337763->free_i_292846;
    int64_t gtid_297524 = futhark_mc_task_337763->free_gtid_297524;
    struct memblock mem_312593 = {.desc ="mem_312593", .mem =
                                  futhark_mc_task_337763->free_mem_312593,
                                  .size =0, .references =NULL};
    int64_t bytes_312641 = futhark_mc_task_337763->free_bytes_312641;
    struct memblock mem_312661 = {.desc ="mem_312661", .mem =
                                  futhark_mc_task_337763->free_mem_312661,
                                  .size =0, .references =NULL};
    int64_t iter_317407;
    struct futhark_mc_segmap_parloop_struct_337769
    futhark_mc_segmap_parloop_struct_337769;
    
    futhark_mc_segmap_parloop_struct_337769.ctx = ctx;
    futhark_mc_segmap_parloop_struct_337769.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_337769.free_n_p_292677 = n_p_292677;
    futhark_mc_segmap_parloop_struct_337769.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segmap_parloop_struct_337769.free_i_292846 = i_292846;
    futhark_mc_segmap_parloop_struct_337769.free_gtid_297524 = gtid_297524;
    futhark_mc_segmap_parloop_struct_337769.free_mem_312593 = mem_312593.mem;
    futhark_mc_segmap_parloop_struct_337769.free_bytes_312641 = bytes_312641;
    futhark_mc_segmap_parloop_struct_337769.free_mem_312661 = mem_312661.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_337770_task;
    
    futhark_mc_segmap_parloop_337770_task.name =
        "futhark_mc_segmap_parloop_337770";
    futhark_mc_segmap_parloop_337770_task.fn = futhark_mc_segmap_parloop_337770;
    futhark_mc_segmap_parloop_337770_task.args =
        &futhark_mc_segmap_parloop_struct_337769;
    futhark_mc_segmap_parloop_337770_task.iterations = iterations;
    futhark_mc_segmap_parloop_337770_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_337770_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_337770_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_337770_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_337770_task);
    
    if (futhark_mc_segmap_parloop_337770_err != 0) {
        err = futhark_mc_segmap_parloop_337770_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_337770_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_337770_total_end -
                 futhark_mc_segmap_parloop_337770_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337770_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337770_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337770_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_nested_task_337768_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_nested_task_337768_end -
                 futhark_mc_segmap_nested_task_337768_start;
        
        ctx->futhark_mc_segmap_nested_task_337768_runs[tid]++;
        ctx->futhark_mc_segmap_nested_task_337768_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_nested_task_337768_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
static int futhark_mc_segmap_parloop_337761(void *args, int64_t start,
                                            int64_t end, int flat_tid_297523,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_337760
    *futhark_mc_segmap_parloop_struct_337760 =
    (struct futhark_mc_segmap_parloop_struct_337760 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_337760->ctx;
    uint64_t futhark_mc_segmap_parloop_337761_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_337761_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_337760->free_n_292675;
    int64_t n_p_292677 =
            futhark_mc_segmap_parloop_struct_337760->free_n_p_292677;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_337760->free_partition_sizze_292766;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segmap_parloop_struct_337760->free_defunc_0_f_res_292820;
    int64_t i_292846 = futhark_mc_segmap_parloop_struct_337760->free_i_292846;
    struct memblock mem_312593 = {.desc ="mem_312593", .mem =
                                  futhark_mc_segmap_parloop_struct_337760->free_mem_312593,
                                  .size =0, .references =NULL};
    int64_t bytes_312641 =
            futhark_mc_segmap_parloop_struct_337760->free_bytes_312641;
    int64_t bytes_312660 =
            futhark_mc_segmap_parloop_struct_337760->free_bytes_312660;
    struct memblock mem_312713 = {.desc ="mem_312713", .mem =
                                  futhark_mc_segmap_parloop_struct_337760->free_mem_312713,
                                  .size =0, .references =NULL};
    size_t mem_312661_cached_sizze_337762 = 0;
    unsigned char *mem_312661 = NULL;
    int64_t iterations = end - start;
    int64_t iter_317352 = start;
    
    if (mem_312661_cached_sizze_337762 < (size_t) bytes_312660) {
        mem_312661 = realloc(mem_312661, bytes_312660);
        mem_312661_cached_sizze_337762 = bytes_312660;
    }
    for (; iter_317352 < end; iter_317352++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_317387 = partition_sizze_292766;
        int64_t gtid_297524 = iter_317352;
        int64_t remnant_317388 = iter_317352 - gtid_297524;
        int64_t flat_tid_317369 = (int64_t) 0;
        int32_t num_tasks_317389;
        int64_t flat_tid_317353 = (int64_t) 0;
        struct futhark_mc_task_337763 futhark_mc_task_337763;
        
        futhark_mc_task_337763.ctx = ctx;
        futhark_mc_task_337763.free_n_292675 = n_292675;
        futhark_mc_task_337763.free_n_p_292677 = n_p_292677;
        futhark_mc_task_337763.free_defunc_0_f_res_292820 =
            defunc_0_f_res_292820;
        futhark_mc_task_337763.free_i_292846 = i_292846;
        futhark_mc_task_337763.free_gtid_297524 = gtid_297524;
        futhark_mc_task_337763.free_mem_312593 = mem_312593.mem;
        futhark_mc_task_337763.free_bytes_312641 = bytes_312641;
        futhark_mc_task_337763.free_mem_312661 = mem_312661;
        
        struct scheduler_segop futhark_mc_task_337763_task;
        
        futhark_mc_task_337763_task.args = &futhark_mc_task_337763;
        futhark_mc_task_337763_task.top_level_fn =
            futhark_mc_segmap_task_337764;
        futhark_mc_task_337763_task.name = "futhark_mc_segmap_task_337764";
        futhark_mc_task_337763_task.iterations = n_p_292677;
        futhark_mc_task_337763_task.task_time =
            &ctx->futhark_mc_segmap_task_337764_total_time;
        futhark_mc_task_337763_task.task_iter =
            &ctx->futhark_mc_segmap_task_337764_total_iter;
        futhark_mc_task_337763_task.sched = STATIC;
        futhark_mc_task_337763_task.nested_fn =
            futhark_mc_segmap_nested_task_337768;
        
        int futhark_mc_segmap_task_337764_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_337763_task);
        
        if (futhark_mc_segmap_task_337764_err != 0) {
            ;
            err = futhark_mc_segmap_task_337764_err;
            goto cleanup;
        }
        if (n_p_292677 * defunc_0_f_res_292820 * (int64_t) 8 > 0)
            memmove(mem_312713.mem + gtid_297524 * (defunc_0_f_res_292820 *
                                                    n_p_292677) * (int64_t) 8,
                    mem_312661 + (int64_t) 0, n_p_292677 *
                    defunc_0_f_res_292820 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_312661);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_337761_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_337761_end -
                 futhark_mc_segmap_parloop_337761_start;
        
        ctx->futhark_mc_segmap_parloop_337761_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_337761_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_337761_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_nested_task_337759(void *args, int64_t iterations,
                                         int tid, struct scheduler_info info)
{
    int err = 0;
    int flat_tid_297523 = tid;
    int num_tasks_317330 = info.nsubtasks;
    struct futhark_mc_task_337754 *futhark_mc_task_337754 =
                                  (struct futhark_mc_task_337754 *) args;
    struct futhark_context *ctx = futhark_mc_task_337754->ctx;
    uint64_t futhark_mc_segmap_nested_task_337759_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_nested_task_337759_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_337754->free_n_292675;
    int64_t n_p_292677 = futhark_mc_task_337754->free_n_p_292677;
    int64_t partition_sizze_292766 =
            futhark_mc_task_337754->free_partition_sizze_292766;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_337754->free_defunc_0_f_res_292820;
    int64_t i_292846 = futhark_mc_task_337754->free_i_292846;
    struct memblock mem_312593 = {.desc ="mem_312593", .mem =
                                  futhark_mc_task_337754->free_mem_312593,
                                  .size =0, .references =NULL};
    int64_t bytes_312641 = futhark_mc_task_337754->free_bytes_312641;
    int64_t bytes_312660 = futhark_mc_task_337754->free_bytes_312660;
    struct memblock mem_312713 = {.desc ="mem_312713", .mem =
                                  futhark_mc_task_337754->free_mem_312713,
                                  .size =0, .references =NULL};
    int64_t iter_317352;
    struct futhark_mc_segmap_parloop_struct_337760
    futhark_mc_segmap_parloop_struct_337760;
    
    futhark_mc_segmap_parloop_struct_337760.ctx = ctx;
    futhark_mc_segmap_parloop_struct_337760.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_337760.free_n_p_292677 = n_p_292677;
    futhark_mc_segmap_parloop_struct_337760.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_337760.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segmap_parloop_struct_337760.free_i_292846 = i_292846;
    futhark_mc_segmap_parloop_struct_337760.free_mem_312593 = mem_312593.mem;
    futhark_mc_segmap_parloop_struct_337760.free_bytes_312641 = bytes_312641;
    futhark_mc_segmap_parloop_struct_337760.free_bytes_312660 = bytes_312660;
    futhark_mc_segmap_parloop_struct_337760.free_mem_312713 = mem_312713.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_337761_task;
    
    futhark_mc_segmap_parloop_337761_task.name =
        "futhark_mc_segmap_parloop_337761";
    futhark_mc_segmap_parloop_337761_task.fn = futhark_mc_segmap_parloop_337761;
    futhark_mc_segmap_parloop_337761_task.args =
        &futhark_mc_segmap_parloop_struct_337760;
    futhark_mc_segmap_parloop_337761_task.iterations = iterations;
    futhark_mc_segmap_parloop_337761_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_337761_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_337761_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_337761_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_337761_task);
    
    if (futhark_mc_segmap_parloop_337761_err != 0) {
        err = futhark_mc_segmap_parloop_337761_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_337761_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_337761_total_end -
                 futhark_mc_segmap_parloop_337761_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337761_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337761_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337761_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_nested_task_337759_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_nested_task_337759_end -
                 futhark_mc_segmap_nested_task_337759_start;
        
        ctx->futhark_mc_segmap_nested_task_337759_runs[tid]++;
        ctx->futhark_mc_segmap_nested_task_337759_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_nested_task_337759_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_task_337776 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_partition_sizze_292766;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_i_292895;
    int64_t free_bytes_312641;
    int64_t free_bytes_312660;
    unsigned char *free_mem_312713;
    int64_t free_bytes_312755;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_312842;
};
struct futhark_mc_segmap_parloop_struct_337778 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_partition_sizze_292766;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_i_292895;
    int64_t free_bytes_312641;
    int64_t free_bytes_312660;
    unsigned char *free_mem_312713;
    int64_t free_bytes_312755;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_312842;
};
static int futhark_mc_segmap_parloop_337779(void *args, int64_t start,
                                            int64_t end, int flat_tid_297559,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_337778
    *futhark_mc_segmap_parloop_struct_337778 =
    (struct futhark_mc_segmap_parloop_struct_337778 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_337778->ctx;
    uint64_t futhark_mc_segmap_parloop_337779_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_337779_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segmap_parloop_struct_337778->free_n_p_292677;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_337778->free_partition_sizze_292766;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segmap_parloop_struct_337778->free_defunc_0_f_res_292820;
    int64_t i_292895 = futhark_mc_segmap_parloop_struct_337778->free_i_292895;
    int64_t bytes_312641 =
            futhark_mc_segmap_parloop_struct_337778->free_bytes_312641;
    int64_t bytes_312660 =
            futhark_mc_segmap_parloop_struct_337778->free_bytes_312660;
    struct memblock mem_312713 = {.desc ="mem_312713", .mem =
                                  futhark_mc_segmap_parloop_struct_337778->free_mem_312713,
                                  .size =0, .references =NULL};
    int64_t bytes_312755 =
            futhark_mc_segmap_parloop_struct_337778->free_bytes_312755;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_segmap_parloop_struct_337778->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_312842 = {.desc ="mem_312842", .mem =
                                  futhark_mc_segmap_parloop_struct_337778->free_mem_312842,
                                  .size =0, .references =NULL};
    size_t mem_312760_cached_sizze_337780 = 0;
    unsigned char *mem_312760 = NULL;
    size_t mem_312763_cached_sizze_337781 = 0;
    unsigned char *mem_312763 = NULL;
    size_t mem_312783_cached_sizze_337782 = 0;
    unsigned char *mem_312783 = NULL;
    size_t mem_312798_cached_sizze_337783 = 0;
    unsigned char *mem_312798 = NULL;
    int64_t iterations = end - start;
    int64_t iter_317433 = start;
    
    if (mem_312760_cached_sizze_337780 < (size_t) bytes_312660) {
        mem_312760 = realloc(mem_312760, bytes_312660);
        mem_312760_cached_sizze_337780 = bytes_312660;
    }
    if (mem_312763_cached_sizze_337781 < (size_t) bytes_312755) {
        mem_312763 = realloc(mem_312763, bytes_312755);
        mem_312763_cached_sizze_337781 = bytes_312755;
    }
    if (mem_312783_cached_sizze_337782 < (size_t) bytes_312641) {
        mem_312783 = realloc(mem_312783, bytes_312641);
        mem_312783_cached_sizze_337782 = bytes_312641;
    }
    if (mem_312798_cached_sizze_337783 < (size_t) bytes_312641) {
        mem_312798 = realloc(mem_312798, bytes_312641);
        mem_312798_cached_sizze_337783 = bytes_312641;
    }
    for (; iter_317433 < end; iter_317433++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_317462 = partition_sizze_292766;
        int64_t gtid_297560 = iter_317433;
        int64_t remnant_317463 = iter_317433 - gtid_297560;
        
        for (int64_t i_317464 = 0; i_317464 < defunc_0_f_res_292820;
             i_317464++) {
            ((int64_t *) mem_312798)[i_317464] = (int64_t) -1;
        }
        for (int64_t i_317434 = 0; i_317434 < n_p_292677; i_317434++) {
            int64_t discard_317438;
            int64_t scanacc_317441 = (int64_t) 0;
            
            for (int64_t i_317440 = 0; i_317440 < defunc_0_f_res_292820;
                 i_317440++) {
                double x_317443;
                
                x_317443 = ((double *) mem_312713.mem)[gtid_297560 *
                                                       (defunc_0_f_res_292820 *
                                                        n_p_292677) + i_317434 *
                                                       defunc_0_f_res_292820 +
                                                       i_317440];
                
                bool isnan_res_317444;
                
                isnan_res_317444 = futrts_isnan64(x_317443);
                
                bool defunc_0_p_res_317445 = !isnan_res_317444;
                int64_t defunc_0_f_res_317446 =
                        btoi_bool_i64(defunc_0_p_res_317445);
                int64_t defunc_1_op_res_317447 = add64(defunc_0_f_res_317446,
                                                       scanacc_317441);
                
                ((int64_t *) mem_312783)[i_317440] = defunc_1_op_res_317447;
                
                int64_t scanacc_tmp_317467 = defunc_1_op_res_317447;
                
                scanacc_317441 = scanacc_tmp_317467;
            }
            discard_317438 = scanacc_317441;
            if (defunc_0_f_res_292820 * (int64_t) 8 > 0)
                memmove(mem_312760 + i_317434 * defunc_0_f_res_292820 *
                        (int64_t) 8, mem_312798 + (int64_t) 0,
                        defunc_0_f_res_292820 * (int64_t) 8);
            for (int64_t write_iter_317451 = 0; write_iter_317451 <
                 defunc_0_f_res_292820; write_iter_317451++) {
                double write_iv_317453;
                
                write_iv_317453 = ((double *) mem_312713.mem)[gtid_297560 *
                                                              (defunc_0_f_res_292820 *
                                                               n_p_292677) +
                                                              i_317434 *
                                                              defunc_0_f_res_292820 +
                                                              write_iter_317451];
                
                bool isnan_res_317454;
                
                isnan_res_317454 = futrts_isnan64(write_iv_317453);
                
                bool defunc_0_p_res_317455 = !isnan_res_317454;
                int64_t defunc_1_f_res_317456;
                
                if (defunc_0_p_res_317455) {
                    int64_t write_iv_317457;
                    
                    write_iv_317457 =
                        ((int64_t *) mem_312783)[write_iter_317451];
                    
                    int64_t defunc_1_f_res_t_res_317458 = sub64(write_iv_317457,
                                                                (int64_t) 1);
                    
                    defunc_1_f_res_317456 = defunc_1_f_res_t_res_317458;
                } else {
                    defunc_1_f_res_317456 = (int64_t) -1;
                }
                if ((sle64((int64_t) 0, i_317434) && slt64(i_317434,
                                                           n_p_292677)) &&
                    (sle64((int64_t) 0, defunc_1_f_res_317456) &&
                     slt64(defunc_1_f_res_317456, defunc_0_f_res_292820))) {
                    ((int64_t *) mem_312760)[i_317434 * defunc_0_f_res_292820 +
                                             defunc_1_f_res_317456] =
                        write_iter_317451;
                }
            }
            if ((int64_t) 8 > 0)
                memmove(mem_312763 + i_317434 * (int64_t) 8, mem_312783 +
                        i_292895 * (int64_t) 8, (int64_t) 8);
        }
        if (n_p_292677 * defunc_0_f_res_292820 * (int64_t) 8 > 0)
            memmove(mem_312838.mem + gtid_297560 * (defunc_0_f_res_292820 *
                                                    n_p_292677) * (int64_t) 8,
                    mem_312760 + (int64_t) 0, n_p_292677 *
                    defunc_0_f_res_292820 * (int64_t) 8);
        if (n_p_292677 * (int64_t) 8 > 0)
            memmove(mem_312842.mem + gtid_297560 * n_p_292677 * (int64_t) 8,
                    mem_312763 + (int64_t) 0, n_p_292677 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_312760);
    free(mem_312763);
    free(mem_312783);
    free(mem_312798);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_337779_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_337779_end -
                 futhark_mc_segmap_parloop_337779_start;
        
        ctx->futhark_mc_segmap_parloop_337779_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_337779_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_337779_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_337777(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_297559 = tid;
    int num_tasks_317432 = info.nsubtasks;
    struct futhark_mc_task_337776 *futhark_mc_task_337776 =
                                  (struct futhark_mc_task_337776 *) args;
    struct futhark_context *ctx = futhark_mc_task_337776->ctx;
    uint64_t futhark_mc_segmap_task_337777_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_337777_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_337776->free_n_p_292677;
    int64_t partition_sizze_292766 =
            futhark_mc_task_337776->free_partition_sizze_292766;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_337776->free_defunc_0_f_res_292820;
    int64_t i_292895 = futhark_mc_task_337776->free_i_292895;
    int64_t bytes_312641 = futhark_mc_task_337776->free_bytes_312641;
    int64_t bytes_312660 = futhark_mc_task_337776->free_bytes_312660;
    struct memblock mem_312713 = {.desc ="mem_312713", .mem =
                                  futhark_mc_task_337776->free_mem_312713,
                                  .size =0, .references =NULL};
    int64_t bytes_312755 = futhark_mc_task_337776->free_bytes_312755;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_task_337776->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_312842 = {.desc ="mem_312842", .mem =
                                  futhark_mc_task_337776->free_mem_312842,
                                  .size =0, .references =NULL};
    int64_t iter_317433;
    struct futhark_mc_segmap_parloop_struct_337778
    futhark_mc_segmap_parloop_struct_337778;
    
    futhark_mc_segmap_parloop_struct_337778.ctx = ctx;
    futhark_mc_segmap_parloop_struct_337778.free_n_p_292677 = n_p_292677;
    futhark_mc_segmap_parloop_struct_337778.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_337778.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segmap_parloop_struct_337778.free_i_292895 = i_292895;
    futhark_mc_segmap_parloop_struct_337778.free_bytes_312641 = bytes_312641;
    futhark_mc_segmap_parloop_struct_337778.free_bytes_312660 = bytes_312660;
    futhark_mc_segmap_parloop_struct_337778.free_mem_312713 = mem_312713.mem;
    futhark_mc_segmap_parloop_struct_337778.free_bytes_312755 = bytes_312755;
    futhark_mc_segmap_parloop_struct_337778.free_mem_312838 = mem_312838.mem;
    futhark_mc_segmap_parloop_struct_337778.free_mem_312842 = mem_312842.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_337779_task;
    
    futhark_mc_segmap_parloop_337779_task.name =
        "futhark_mc_segmap_parloop_337779";
    futhark_mc_segmap_parloop_337779_task.fn = futhark_mc_segmap_parloop_337779;
    futhark_mc_segmap_parloop_337779_task.args =
        &futhark_mc_segmap_parloop_struct_337778;
    futhark_mc_segmap_parloop_337779_task.iterations = iterations;
    futhark_mc_segmap_parloop_337779_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_337779_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_337779_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_337779_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_337779_task);
    
    if (futhark_mc_segmap_parloop_337779_err != 0) {
        err = futhark_mc_segmap_parloop_337779_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_337779_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_337779_total_end -
                 futhark_mc_segmap_parloop_337779_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337779_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337779_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337779_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_337777_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_337777_end -
                 futhark_mc_segmap_task_337777_start;
        
        ctx->futhark_mc_segmap_task_337777_runs[tid]++;
        ctx->futhark_mc_segmap_task_337777_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_337777_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_segmap_parloop_struct_337785 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_partition_sizze_292766;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_i_292895;
    int64_t free_bytes_312641;
    int64_t free_bytes_312660;
    unsigned char *free_mem_312713;
    int64_t free_bytes_312755;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_312842;
};
struct futhark_mc_task_337789 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_i_292895;
    int64_t free_gtid_297597;
    int64_t free_bytes_312641;
    unsigned char *free_mem_312713;
    unsigned char *free_mem_312753;
    unsigned char *free_mem_312756;
};
struct futhark_mc_segmap_parloop_struct_337791 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_i_292895;
    int64_t free_gtid_297597;
    int64_t free_bytes_312641;
    unsigned char *free_mem_312713;
    unsigned char *free_mem_312753;
    unsigned char *free_mem_312756;
};
static int futhark_mc_segmap_parloop_337792(void *args, int64_t start,
                                            int64_t end, int flat_tid_317496,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_337791
    *futhark_mc_segmap_parloop_struct_337791 =
    (struct futhark_mc_segmap_parloop_struct_337791 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_337791->ctx;
    uint64_t futhark_mc_segmap_parloop_337792_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_337792_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segmap_parloop_struct_337791->free_n_p_292677;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segmap_parloop_struct_337791->free_defunc_0_f_res_292820;
    int64_t i_292895 = futhark_mc_segmap_parloop_struct_337791->free_i_292895;
    int64_t gtid_297597 =
            futhark_mc_segmap_parloop_struct_337791->free_gtid_297597;
    int64_t bytes_312641 =
            futhark_mc_segmap_parloop_struct_337791->free_bytes_312641;
    struct memblock mem_312713 = {.desc ="mem_312713", .mem =
                                  futhark_mc_segmap_parloop_struct_337791->free_mem_312713,
                                  .size =0, .references =NULL};
    struct memblock mem_312753 = {.desc ="mem_312753", .mem =
                                  futhark_mc_segmap_parloop_struct_337791->free_mem_312753,
                                  .size =0, .references =NULL};
    struct memblock mem_312756 = {.desc ="mem_312756", .mem =
                                  futhark_mc_segmap_parloop_struct_337791->free_mem_312756,
                                  .size =0, .references =NULL};
    size_t mem_317498_cached_sizze_337793 = 0;
    unsigned char *mem_317498 = NULL;
    size_t mem_317512_cached_sizze_337794 = 0;
    unsigned char *mem_317512 = NULL;
    int64_t iterations = end - start;
    int64_t iter_317527 = start;
    
    if (mem_317498_cached_sizze_337793 < (size_t) bytes_312641) {
        mem_317498 = realloc(mem_317498, bytes_312641);
        mem_317498_cached_sizze_337793 = bytes_312641;
    }
    if (mem_317512_cached_sizze_337794 < (size_t) bytes_312641) {
        mem_317512 = realloc(mem_317512, bytes_312641);
        mem_317512_cached_sizze_337794 = bytes_312641;
    }
    for (; iter_317527 < end; iter_317527++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_317546 = n_p_292677;
        int64_t gtid_317497 = iter_317527;
        int64_t remnant_317547 = iter_317527 - gtid_317497;
        int64_t discard_317500;
        int64_t scanacc_317529 = (int64_t) 0;
        
        for (int64_t i_317528 = 0; i_317528 < defunc_0_f_res_292820;
             i_317528++) {
            double x_317531;
            
            x_317531 = ((double *) mem_312713.mem)[gtid_297597 *
                                                   (defunc_0_f_res_292820 *
                                                    n_p_292677) + gtid_317497 *
                                                   defunc_0_f_res_292820 +
                                                   i_317528];
            
            bool isnan_res_317532;
            
            isnan_res_317532 = futrts_isnan64(x_317531);
            
            bool defunc_0_p_res_317533 = !isnan_res_317532;
            int64_t defunc_0_f_res_317534 =
                    btoi_bool_i64(defunc_0_p_res_317533);
            int64_t defunc_1_op_res_317535 = add64(defunc_0_f_res_317534,
                                                   scanacc_317529);
            
            ((int64_t *) mem_317498)[i_317528] = defunc_1_op_res_317535;
            
            int64_t scanacc_tmp_317548 = defunc_1_op_res_317535;
            
            scanacc_317529 = scanacc_tmp_317548;
        }
        discard_317500 = scanacc_317529;
        
        int64_t last_res_317511;
        
        last_res_317511 = ((int64_t *) mem_317498)[i_292895];
        for (int64_t i_317550 = 0; i_317550 < defunc_0_f_res_292820;
             i_317550++) {
            ((int64_t *) mem_317512)[i_317550] = (int64_t) -1;
        }
        for (int64_t write_iter_317537 = 0; write_iter_317537 <
             defunc_0_f_res_292820; write_iter_317537++) {
            double write_iv_317539;
            
            write_iv_317539 = ((double *) mem_312713.mem)[gtid_297597 *
                                                          (defunc_0_f_res_292820 *
                                                           n_p_292677) +
                                                          gtid_317497 *
                                                          defunc_0_f_res_292820 +
                                                          write_iter_317537];
            
            bool isnan_res_317540;
            
            isnan_res_317540 = futrts_isnan64(write_iv_317539);
            
            bool defunc_0_p_res_317541 = !isnan_res_317540;
            int64_t defunc_1_f_res_317542;
            
            if (defunc_0_p_res_317541) {
                int64_t write_iv_317543;
                
                write_iv_317543 = ((int64_t *) mem_317498)[write_iter_317537];
                
                int64_t defunc_1_f_res_t_res_317544 = sub64(write_iv_317543,
                                                            (int64_t) 1);
                
                defunc_1_f_res_317542 = defunc_1_f_res_t_res_317544;
            } else {
                defunc_1_f_res_317542 = (int64_t) -1;
            }
            if (sle64((int64_t) 0, defunc_1_f_res_317542) &&
                slt64(defunc_1_f_res_317542, defunc_0_f_res_292820)) {
                ((int64_t *) mem_317512)[defunc_1_f_res_317542] =
                    write_iter_317537;
            }
        }
        if (defunc_0_f_res_292820 * (int64_t) 8 > 0)
            memmove(mem_312753.mem + gtid_317497 * defunc_0_f_res_292820 *
                    (int64_t) 8, mem_317512 + (int64_t) 0,
                    defunc_0_f_res_292820 * (int64_t) 8);
        ((int64_t *) mem_312756.mem)[gtid_317497] = last_res_317511;
    }
    
  cleanup:
    { }
    free(mem_317498);
    free(mem_317512);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_337792_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_337792_end -
                 futhark_mc_segmap_parloop_337792_start;
        
        ctx->futhark_mc_segmap_parloop_337792_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_337792_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_337792_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_337790(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_317496 = tid;
    int num_tasks_317526 = info.nsubtasks;
    struct futhark_mc_task_337789 *futhark_mc_task_337789 =
                                  (struct futhark_mc_task_337789 *) args;
    struct futhark_context *ctx = futhark_mc_task_337789->ctx;
    uint64_t futhark_mc_segmap_task_337790_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_337790_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_337789->free_n_p_292677;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_337789->free_defunc_0_f_res_292820;
    int64_t i_292895 = futhark_mc_task_337789->free_i_292895;
    int64_t gtid_297597 = futhark_mc_task_337789->free_gtid_297597;
    int64_t bytes_312641 = futhark_mc_task_337789->free_bytes_312641;
    struct memblock mem_312713 = {.desc ="mem_312713", .mem =
                                  futhark_mc_task_337789->free_mem_312713,
                                  .size =0, .references =NULL};
    struct memblock mem_312753 = {.desc ="mem_312753", .mem =
                                  futhark_mc_task_337789->free_mem_312753,
                                  .size =0, .references =NULL};
    struct memblock mem_312756 = {.desc ="mem_312756", .mem =
                                  futhark_mc_task_337789->free_mem_312756,
                                  .size =0, .references =NULL};
    int64_t iter_317527;
    struct futhark_mc_segmap_parloop_struct_337791
    futhark_mc_segmap_parloop_struct_337791;
    
    futhark_mc_segmap_parloop_struct_337791.ctx = ctx;
    futhark_mc_segmap_parloop_struct_337791.free_n_p_292677 = n_p_292677;
    futhark_mc_segmap_parloop_struct_337791.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segmap_parloop_struct_337791.free_i_292895 = i_292895;
    futhark_mc_segmap_parloop_struct_337791.free_gtid_297597 = gtid_297597;
    futhark_mc_segmap_parloop_struct_337791.free_bytes_312641 = bytes_312641;
    futhark_mc_segmap_parloop_struct_337791.free_mem_312713 = mem_312713.mem;
    futhark_mc_segmap_parloop_struct_337791.free_mem_312753 = mem_312753.mem;
    futhark_mc_segmap_parloop_struct_337791.free_mem_312756 = mem_312756.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_337792_task;
    
    futhark_mc_segmap_parloop_337792_task.name =
        "futhark_mc_segmap_parloop_337792";
    futhark_mc_segmap_parloop_337792_task.fn = futhark_mc_segmap_parloop_337792;
    futhark_mc_segmap_parloop_337792_task.args =
        &futhark_mc_segmap_parloop_struct_337791;
    futhark_mc_segmap_parloop_337792_task.iterations = iterations;
    futhark_mc_segmap_parloop_337792_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_337792_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_337792_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_337792_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_337792_task);
    
    if (futhark_mc_segmap_parloop_337792_err != 0) {
        err = futhark_mc_segmap_parloop_337792_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_337792_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_337792_total_end -
                 futhark_mc_segmap_parloop_337792_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337792_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337792_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337792_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_337790_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_337790_end -
                 futhark_mc_segmap_task_337790_start;
        
        ctx->futhark_mc_segmap_task_337790_runs[tid]++;
        ctx->futhark_mc_segmap_task_337790_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_337790_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_segmap_parloop_struct_337796 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_i_292895;
    int64_t free_gtid_297597;
    int64_t free_bytes_312641;
    unsigned char *free_mem_312713;
    unsigned char *free_mem_312753;
    unsigned char *free_mem_312756;
};
struct futhark_mc_task_337800 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_gtid_297597;
    unsigned char *free_mem_312713;
    int64_t free_gtid_317472;
    unsigned char *free_mem_317473;
};
struct futhark_mc_scan_stage_1_parloop_struct_337803 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_gtid_297597;
    unsigned char *free_mem_312713;
    int64_t free_gtid_317472;
    unsigned char *free_mem_317473;
};
static int futhark_mc_scan_stage_1_parloop_337804(void *args, int64_t start,
                                                  int64_t end,
                                                  int flat_tid_317553, int tid)
{
    int err = 0;
    struct futhark_mc_scan_stage_1_parloop_struct_337803
    *futhark_mc_scan_stage_1_parloop_struct_337803 =
    (struct futhark_mc_scan_stage_1_parloop_struct_337803 *) args;
    struct futhark_context *ctx =
                           futhark_mc_scan_stage_1_parloop_struct_337803->ctx;
    uint64_t futhark_mc_scan_stage_1_parloop_337804_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_scan_stage_1_parloop_337804_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_scan_stage_1_parloop_struct_337803->free_n_p_292677;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_scan_stage_1_parloop_struct_337803->free_defunc_0_f_res_292820;
    int64_t gtid_297597 =
            futhark_mc_scan_stage_1_parloop_struct_337803->free_gtid_297597;
    struct memblock mem_312713 = {.desc ="mem_312713", .mem =
                                  futhark_mc_scan_stage_1_parloop_struct_337803->free_mem_312713,
                                  .size =0, .references =NULL};
    int64_t gtid_317472 =
            futhark_mc_scan_stage_1_parloop_struct_337803->free_gtid_317472;
    struct memblock mem_317473 = {.desc ="mem_317473", .mem =
                                  futhark_mc_scan_stage_1_parloop_struct_337803->free_mem_317473,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_317573 = start;
    int64_t x_317555;
    int64_t x_317556;
    
    x_317555 = (int64_t) 0;
    for (; iter_317573 < end; iter_317573++) {
        int64_t gtid_317554 = iter_317573;
        
        // stage 1 scan body
        {
            double x_317558;
            
            x_317558 = ((double *) mem_312713.mem)[gtid_297597 *
                                                   (defunc_0_f_res_292820 *
                                                    n_p_292677) + gtid_317472 *
                                                   defunc_0_f_res_292820 +
                                                   gtid_317554];
            
            bool isnan_res_317559;
            
            isnan_res_317559 = futrts_isnan64(x_317558);
            
            bool defunc_0_p_res_317560 = !isnan_res_317559;
            int64_t defunc_0_f_res_317561 =
                    btoi_bool_i64(defunc_0_p_res_317560);
            
            // write mapped values results to memory
            { }
            x_317555 = x_317555;
            // Read next values
            {
                x_317556 = defunc_0_f_res_317561;
            }
            
            int64_t defunc_1_op_res_317557 = add64(x_317555, x_317556);
            
            ((int64_t *) mem_317473.mem)[gtid_317554] = defunc_1_op_res_317557;
            x_317555 = defunc_1_op_res_317557;
        }
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_scan_stage_1_parloop_337804_end = get_wall_time();
        uint64_t elapsed = futhark_mc_scan_stage_1_parloop_337804_end -
                 futhark_mc_scan_stage_1_parloop_337804_start;
        
        ctx->futhark_mc_scan_stage_1_parloop_337804_runs[tid]++;
        ctx->futhark_mc_scan_stage_1_parloop_337804_total_runtime[tid] +=
            elapsed;
        ctx->futhark_mc_scan_stage_1_parloop_337804_iter[tid] += iterations;
    }
    return err;
}
struct futhark_mc_scan_stage_3_parloop_struct_337805 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_gtid_297597;
    unsigned char *free_mem_312713;
    int64_t free_gtid_317472;
    unsigned char *free_mem_317473;
};
static int futhark_mc_scan_stage_3_parloop_337806(void *args, int64_t start,
                                                  int64_t end,
                                                  int flat_tid_317553, int tid)
{
    int err = 0;
    struct futhark_mc_scan_stage_3_parloop_struct_337805
    *futhark_mc_scan_stage_3_parloop_struct_337805 =
    (struct futhark_mc_scan_stage_3_parloop_struct_337805 *) args;
    struct futhark_context *ctx =
                           futhark_mc_scan_stage_3_parloop_struct_337805->ctx;
    uint64_t futhark_mc_scan_stage_3_parloop_337806_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_scan_stage_3_parloop_337806_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_scan_stage_3_parloop_struct_337805->free_n_p_292677;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_scan_stage_3_parloop_struct_337805->free_defunc_0_f_res_292820;
    int64_t gtid_297597 =
            futhark_mc_scan_stage_3_parloop_struct_337805->free_gtid_297597;
    struct memblock mem_312713 = {.desc ="mem_312713", .mem =
                                  futhark_mc_scan_stage_3_parloop_struct_337805->free_mem_312713,
                                  .size =0, .references =NULL};
    int64_t gtid_317472 =
            futhark_mc_scan_stage_3_parloop_struct_337805->free_gtid_317472;
    struct memblock mem_317473 = {.desc ="mem_317473", .mem =
                                  futhark_mc_scan_stage_3_parloop_struct_337805->free_mem_317473,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_317585 = start;
    int64_t x_317582;
    int64_t x_317583;
    
    if (iter_317585 == (int64_t) 0) {
        x_317582 = (int64_t) 0;
    } else {
        x_317582 = ((int64_t *) mem_317473.mem)[iter_317585 - (int64_t) 1];
    }
    for (; iter_317585 < end; iter_317585++) {
        int64_t gtid_317554 = iter_317585;
        
        // stage 3 scan body
        {
            double x_317558;
            
            x_317558 = ((double *) mem_312713.mem)[gtid_297597 *
                                                   (defunc_0_f_res_292820 *
                                                    n_p_292677) + gtid_317472 *
                                                   defunc_0_f_res_292820 +
                                                   gtid_317554];
            
            bool isnan_res_317559;
            
            isnan_res_317559 = futrts_isnan64(x_317558);
            
            bool defunc_0_p_res_317560 = !isnan_res_317559;
            int64_t defunc_0_f_res_317561 =
                    btoi_bool_i64(defunc_0_p_res_317560);
            
            x_317582 = x_317582;
            x_317583 = defunc_0_f_res_317561;
            
            int64_t defunc_1_op_res_317584 = add64(x_317582, x_317583);
            
            ((int64_t *) mem_317473.mem)[gtid_317554] = defunc_1_op_res_317584;
            x_317582 = defunc_1_op_res_317584;
        }
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_scan_stage_3_parloop_337806_end = get_wall_time();
        uint64_t elapsed = futhark_mc_scan_stage_3_parloop_337806_end -
                 futhark_mc_scan_stage_3_parloop_337806_start;
        
        ctx->futhark_mc_scan_stage_3_parloop_337806_runs[tid]++;
        ctx->futhark_mc_scan_stage_3_parloop_337806_total_runtime[tid] +=
            elapsed;
        ctx->futhark_mc_scan_stage_3_parloop_337806_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segscan_task_337801(void *args, int64_t iterations, int tid,
                                   struct scheduler_info info)
{
    int err = 0;
    int flat_tid_317553 = tid;
    int num_tasks_317572 = info.nsubtasks;
    struct futhark_mc_task_337800 *futhark_mc_task_337800 =
                                  (struct futhark_mc_task_337800 *) args;
    struct futhark_context *ctx = futhark_mc_task_337800->ctx;
    uint64_t futhark_mc_segscan_task_337801_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segscan_task_337801_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_337800->free_n_p_292677;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_337800->free_defunc_0_f_res_292820;
    int64_t gtid_297597 = futhark_mc_task_337800->free_gtid_297597;
    struct memblock mem_312713 = {.desc ="mem_312713", .mem =
                                  futhark_mc_task_337800->free_mem_312713,
                                  .size =0, .references =NULL};
    int64_t gtid_317472 = futhark_mc_task_337800->free_gtid_317472;
    struct memblock mem_317473 = {.desc ="mem_317473", .mem =
                                  futhark_mc_task_337800->free_mem_317473,
                                  .size =0, .references =NULL};
    size_t scan_stage_2_accum_mem_317579_cached_sizze_337802 = 0;
    unsigned char *scan_stage_2_accum_mem_317579 = NULL;
    int64_t iter_317573;
    struct futhark_mc_scan_stage_1_parloop_struct_337803
    futhark_mc_scan_stage_1_parloop_struct_337803;
    
    futhark_mc_scan_stage_1_parloop_struct_337803.ctx = ctx;
    futhark_mc_scan_stage_1_parloop_struct_337803.free_n_p_292677 = n_p_292677;
    futhark_mc_scan_stage_1_parloop_struct_337803.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_scan_stage_1_parloop_struct_337803.free_gtid_297597 =
        gtid_297597;
    futhark_mc_scan_stage_1_parloop_struct_337803.free_mem_312713 =
        mem_312713.mem;
    futhark_mc_scan_stage_1_parloop_struct_337803.free_gtid_317472 =
        gtid_317472;
    futhark_mc_scan_stage_1_parloop_struct_337803.free_mem_317473 =
        mem_317473.mem;
    
    struct scheduler_parloop futhark_mc_scan_stage_1_parloop_337804_task;
    
    futhark_mc_scan_stage_1_parloop_337804_task.name =
        "futhark_mc_scan_stage_1_parloop_337804";
    futhark_mc_scan_stage_1_parloop_337804_task.fn =
        futhark_mc_scan_stage_1_parloop_337804;
    futhark_mc_scan_stage_1_parloop_337804_task.args =
        &futhark_mc_scan_stage_1_parloop_struct_337803;
    futhark_mc_scan_stage_1_parloop_337804_task.iterations = iterations;
    futhark_mc_scan_stage_1_parloop_337804_task.info = info;
    
    uint64_t futhark_mc_scan_stage_1_parloop_337804_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_scan_stage_1_parloop_337804_total_start = get_wall_time();
    
    int futhark_mc_scan_stage_1_parloop_337804_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_scan_stage_1_parloop_337804_task);
    
    if (futhark_mc_scan_stage_1_parloop_337804_err != 0) {
        err = futhark_mc_scan_stage_1_parloop_337804_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_scan_stage_1_parloop_337804_total_end =
                 get_wall_time();
        uint64_t elapsed = futhark_mc_scan_stage_1_parloop_337804_total_end -
                 futhark_mc_scan_stage_1_parloop_337804_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_scan_stage_1_parloop_337804_total_runs,
                           1, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_scan_stage_1_parloop_337804_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_scan_stage_1_parloop_337804_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    if (slt32(1, num_tasks_317572)) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "nonsegmentedScan stage 2");
        
        int64_t x_317574;
        int64_t x_317575;
        int64_t offset_317577 = (int64_t) 0;
        int64_t offset_index_317578 = (int64_t) 0;
        
        if (scan_stage_2_accum_mem_317579_cached_sizze_337802 <
            (size_t) (int64_t) 8) {
            scan_stage_2_accum_mem_317579 =
                realloc(scan_stage_2_accum_mem_317579, (int64_t) 8);
            scan_stage_2_accum_mem_317579_cached_sizze_337802 = (int64_t) 8;
        }
        ((int64_t *) scan_stage_2_accum_mem_317579)[(int64_t) 0] = (int64_t) 0;
        for (int32_t i_317581 = 0; i_317581 < num_tasks_317572 - 1;
             i_317581++) {
            offset_317577 = squot64(defunc_0_f_res_292820,
                                    sext_i32_i64(num_tasks_317572));
            if (slt64(sext_i32_i64(i_317581), srem64(defunc_0_f_res_292820,
                                                     sext_i32_i64(num_tasks_317572)))) {
                offset_317577 += (int64_t) 1;
            }
            offset_index_317578 += offset_317577;
            
            int64_t gtid_317554 = offset_index_317578;
            double x_317558;
            
            x_317558 = ((double *) mem_312713.mem)[gtid_297597 *
                                                   (defunc_0_f_res_292820 *
                                                    n_p_292677) + gtid_317472 *
                                                   defunc_0_f_res_292820 +
                                                   gtid_317554];
            
            bool isnan_res_317559;
            
            isnan_res_317559 = futrts_isnan64(x_317558);
            
            bool defunc_0_p_res_317560 = !isnan_res_317559;
            int64_t defunc_0_f_res_317561 =
                    btoi_bool_i64(defunc_0_p_res_317560);
            
            // Read carry in
            {
                x_317574 =
                    ((int64_t *) scan_stage_2_accum_mem_317579)[(int64_t) 0];
            }
            // Read next values
            {
                x_317575 = ((int64_t *) mem_317473.mem)[offset_index_317578 -
                                                        (int64_t) 1];
            }
            
            int64_t defunc_1_op_res_317576 = add64(x_317574, x_317575);
            
            ((int64_t *) mem_317473.mem)[offset_index_317578 - (int64_t) 1] =
                defunc_1_op_res_317576;
            ((int64_t *) scan_stage_2_accum_mem_317579)[(int64_t) 0] =
                defunc_1_op_res_317576;
        }
        
        int64_t iter_317585 = (int64_t) 0;
        struct futhark_mc_scan_stage_3_parloop_struct_337805
        futhark_mc_scan_stage_3_parloop_struct_337805;
        
        futhark_mc_scan_stage_3_parloop_struct_337805.ctx = ctx;
        futhark_mc_scan_stage_3_parloop_struct_337805.free_n_p_292677 =
            n_p_292677;
        futhark_mc_scan_stage_3_parloop_struct_337805.free_defunc_0_f_res_292820 =
            defunc_0_f_res_292820;
        futhark_mc_scan_stage_3_parloop_struct_337805.free_gtid_297597 =
            gtid_297597;
        futhark_mc_scan_stage_3_parloop_struct_337805.free_mem_312713 =
            mem_312713.mem;
        futhark_mc_scan_stage_3_parloop_struct_337805.free_gtid_317472 =
            gtid_317472;
        futhark_mc_scan_stage_3_parloop_struct_337805.free_mem_317473 =
            mem_317473.mem;
        
        struct scheduler_parloop futhark_mc_scan_stage_3_parloop_337806_task;
        
        futhark_mc_scan_stage_3_parloop_337806_task.name =
            "futhark_mc_scan_stage_3_parloop_337806";
        futhark_mc_scan_stage_3_parloop_337806_task.fn =
            futhark_mc_scan_stage_3_parloop_337806;
        futhark_mc_scan_stage_3_parloop_337806_task.args =
            &futhark_mc_scan_stage_3_parloop_struct_337805;
        futhark_mc_scan_stage_3_parloop_337806_task.iterations = iterations;
        futhark_mc_scan_stage_3_parloop_337806_task.info = info;
        
        uint64_t futhark_mc_scan_stage_3_parloop_337806_total_start = 0;
        
        if (ctx->profiling && !ctx->profiling_paused)
            futhark_mc_scan_stage_3_parloop_337806_total_start =
                get_wall_time();
        
        int futhark_mc_scan_stage_3_parloop_337806_err =
            scheduler_execute_task(&ctx->scheduler,
                                   &futhark_mc_scan_stage_3_parloop_337806_task);
        
        if (futhark_mc_scan_stage_3_parloop_337806_err != 0) {
            err = futhark_mc_scan_stage_3_parloop_337806_err;
            goto cleanup;
        }
        if (ctx->profiling && !ctx->profiling_paused) {
            uint64_t futhark_mc_scan_stage_3_parloop_337806_total_end =
                     get_wall_time();
            uint64_t elapsed =
                     futhark_mc_scan_stage_3_parloop_337806_total_end -
                     futhark_mc_scan_stage_3_parloop_337806_total_start;
            
            __atomic_fetch_add(&ctx->futhark_mc_scan_stage_3_parloop_337806_total_runs,
                               1, __ATOMIC_RELAXED);
            __atomic_fetch_add(&ctx->futhark_mc_scan_stage_3_parloop_337806_total_total_runtime,
                               elapsed, __ATOMIC_RELAXED);
            __atomic_fetch_add(&ctx->futhark_mc_scan_stage_3_parloop_337806_total_iter,
                               iterations, __ATOMIC_RELAXED);
        }
    }
    
  cleanup:
    {
        free(scan_stage_2_accum_mem_317579);
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segscan_task_337801_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segscan_task_337801_end -
                 futhark_mc_segscan_task_337801_start;
        
        ctx->futhark_mc_segscan_task_337801_runs[tid]++;
        ctx->futhark_mc_segscan_task_337801_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segscan_task_337801_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_task_337807 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_gtid_297597;
    unsigned char *free_mem_312713;
    int64_t free_gtid_317472;
    unsigned char *free_mem_317473;
    unsigned char *free_mem_317485;
};
struct futhark_mc_segmap_parloop_struct_337809 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_gtid_297597;
    unsigned char *free_mem_312713;
    int64_t free_gtid_317472;
    unsigned char *free_mem_317473;
    unsigned char *free_mem_317485;
};
static int futhark_mc_segmap_parloop_337810(void *args, int64_t start,
                                            int64_t end, int flat_tid_317562,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_337809
    *futhark_mc_segmap_parloop_struct_337809 =
    (struct futhark_mc_segmap_parloop_struct_337809 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_337809->ctx;
    uint64_t futhark_mc_segmap_parloop_337810_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_337810_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segmap_parloop_struct_337809->free_n_p_292677;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segmap_parloop_struct_337809->free_defunc_0_f_res_292820;
    int64_t gtid_297597 =
            futhark_mc_segmap_parloop_struct_337809->free_gtid_297597;
    struct memblock mem_312713 = {.desc ="mem_312713", .mem =
                                  futhark_mc_segmap_parloop_struct_337809->free_mem_312713,
                                  .size =0, .references =NULL};
    int64_t gtid_317472 =
            futhark_mc_segmap_parloop_struct_337809->free_gtid_317472;
    struct memblock mem_317473 = {.desc ="mem_317473", .mem =
                                  futhark_mc_segmap_parloop_struct_337809->free_mem_317473,
                                  .size =0, .references =NULL};
    struct memblock mem_317485 = {.desc ="mem_317485", .mem =
                                  futhark_mc_segmap_parloop_struct_337809->free_mem_317485,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_317588 = start;
    
    for (; iter_317588 < end; iter_317588++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_317591 = defunc_0_f_res_292820;
        int64_t gtid_317563 = iter_317588;
        int64_t remnant_317592 = iter_317588 - gtid_317563;
        double x_317564;
        
        x_317564 = ((double *) mem_312713.mem)[gtid_297597 *
                                               (defunc_0_f_res_292820 *
                                                n_p_292677) + gtid_317472 *
                                               defunc_0_f_res_292820 +
                                               gtid_317563];
        
        bool isnan_res_317565;
        
        isnan_res_317565 = futrts_isnan64(x_317564);
        
        bool defunc_0_p_res_317566 = !isnan_res_317565;
        int64_t defunc_1_f_res_317567;
        
        if (defunc_0_p_res_317566) {
            int64_t x_317589;
            
            x_317589 = ((int64_t *) mem_317473.mem)[gtid_317563];
            
            int64_t defunc_1_f_res_t_res_317590 = sub64(x_317589, (int64_t) 1);
            
            defunc_1_f_res_317567 = defunc_1_f_res_t_res_317590;
        } else {
            defunc_1_f_res_317567 = (int64_t) -1;
        }
        if (sle64((int64_t) 0, defunc_1_f_res_317567) &&
            slt64(defunc_1_f_res_317567, defunc_0_f_res_292820)) {
            ((int64_t *) mem_317485.mem)[defunc_1_f_res_317567] = gtid_317563;
        }
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_337810_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_337810_end -
                 futhark_mc_segmap_parloop_337810_start;
        
        ctx->futhark_mc_segmap_parloop_337810_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_337810_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_337810_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_337808(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_317562 = tid;
    int num_tasks_317587 = info.nsubtasks;
    struct futhark_mc_task_337807 *futhark_mc_task_337807 =
                                  (struct futhark_mc_task_337807 *) args;
    struct futhark_context *ctx = futhark_mc_task_337807->ctx;
    uint64_t futhark_mc_segmap_task_337808_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_337808_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_337807->free_n_p_292677;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_337807->free_defunc_0_f_res_292820;
    int64_t gtid_297597 = futhark_mc_task_337807->free_gtid_297597;
    struct memblock mem_312713 = {.desc ="mem_312713", .mem =
                                  futhark_mc_task_337807->free_mem_312713,
                                  .size =0, .references =NULL};
    int64_t gtid_317472 = futhark_mc_task_337807->free_gtid_317472;
    struct memblock mem_317473 = {.desc ="mem_317473", .mem =
                                  futhark_mc_task_337807->free_mem_317473,
                                  .size =0, .references =NULL};
    struct memblock mem_317485 = {.desc ="mem_317485", .mem =
                                  futhark_mc_task_337807->free_mem_317485,
                                  .size =0, .references =NULL};
    int64_t iter_317588;
    struct futhark_mc_segmap_parloop_struct_337809
    futhark_mc_segmap_parloop_struct_337809;
    
    futhark_mc_segmap_parloop_struct_337809.ctx = ctx;
    futhark_mc_segmap_parloop_struct_337809.free_n_p_292677 = n_p_292677;
    futhark_mc_segmap_parloop_struct_337809.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segmap_parloop_struct_337809.free_gtid_297597 = gtid_297597;
    futhark_mc_segmap_parloop_struct_337809.free_mem_312713 = mem_312713.mem;
    futhark_mc_segmap_parloop_struct_337809.free_gtid_317472 = gtid_317472;
    futhark_mc_segmap_parloop_struct_337809.free_mem_317473 = mem_317473.mem;
    futhark_mc_segmap_parloop_struct_337809.free_mem_317485 = mem_317485.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_337810_task;
    
    futhark_mc_segmap_parloop_337810_task.name =
        "futhark_mc_segmap_parloop_337810";
    futhark_mc_segmap_parloop_337810_task.fn = futhark_mc_segmap_parloop_337810;
    futhark_mc_segmap_parloop_337810_task.args =
        &futhark_mc_segmap_parloop_struct_337809;
    futhark_mc_segmap_parloop_337810_task.iterations = iterations;
    futhark_mc_segmap_parloop_337810_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_337810_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_337810_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_337810_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_337810_task);
    
    if (futhark_mc_segmap_parloop_337810_err != 0) {
        err = futhark_mc_segmap_parloop_337810_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_337810_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_337810_total_end -
                 futhark_mc_segmap_parloop_337810_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337810_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337810_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337810_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_337808_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_337808_end -
                 futhark_mc_segmap_task_337808_start;
        
        ctx->futhark_mc_segmap_task_337808_runs[tid]++;
        ctx->futhark_mc_segmap_task_337808_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_337808_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
static int futhark_mc_segmap_parloop_337797(void *args, int64_t start,
                                            int64_t end, int flat_tid_317471,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_337796
    *futhark_mc_segmap_parloop_struct_337796 =
    (struct futhark_mc_segmap_parloop_struct_337796 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_337796->ctx;
    uint64_t futhark_mc_segmap_parloop_337797_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_337797_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segmap_parloop_struct_337796->free_n_p_292677;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segmap_parloop_struct_337796->free_defunc_0_f_res_292820;
    int64_t i_292895 = futhark_mc_segmap_parloop_struct_337796->free_i_292895;
    int64_t gtid_297597 =
            futhark_mc_segmap_parloop_struct_337796->free_gtid_297597;
    int64_t bytes_312641 =
            futhark_mc_segmap_parloop_struct_337796->free_bytes_312641;
    struct memblock mem_312713 = {.desc ="mem_312713", .mem =
                                  futhark_mc_segmap_parloop_struct_337796->free_mem_312713,
                                  .size =0, .references =NULL};
    struct memblock mem_312753 = {.desc ="mem_312753", .mem =
                                  futhark_mc_segmap_parloop_struct_337796->free_mem_312753,
                                  .size =0, .references =NULL};
    struct memblock mem_312756 = {.desc ="mem_312756", .mem =
                                  futhark_mc_segmap_parloop_struct_337796->free_mem_312756,
                                  .size =0, .references =NULL};
    size_t mem_317473_cached_sizze_337798 = 0;
    unsigned char *mem_317473 = NULL;
    size_t mem_317485_cached_sizze_337799 = 0;
    unsigned char *mem_317485 = NULL;
    int64_t iterations = end - start;
    int64_t iter_317552 = start;
    
    if (mem_317473_cached_sizze_337798 < (size_t) bytes_312641) {
        mem_317473 = realloc(mem_317473, bytes_312641);
        mem_317473_cached_sizze_337798 = bytes_312641;
    }
    if (mem_317485_cached_sizze_337799 < (size_t) bytes_312641) {
        mem_317485 = realloc(mem_317485, bytes_312641);
        mem_317485_cached_sizze_337799 = bytes_312641;
    }
    for (; iter_317552 < end; iter_317552++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_317570 = n_p_292677;
        int64_t gtid_317472 = iter_317552;
        int64_t remnant_317571 = iter_317552 - gtid_317472;
        int64_t flat_tid_317553 = (int64_t) 0;
        int32_t num_tasks_317572;
        
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "nonsegmented segScan");
        
        struct futhark_mc_task_337800 futhark_mc_task_337800;
        
        futhark_mc_task_337800.ctx = ctx;
        futhark_mc_task_337800.free_n_p_292677 = n_p_292677;
        futhark_mc_task_337800.free_defunc_0_f_res_292820 =
            defunc_0_f_res_292820;
        futhark_mc_task_337800.free_gtid_297597 = gtid_297597;
        futhark_mc_task_337800.free_mem_312713 = mem_312713.mem;
        futhark_mc_task_337800.free_gtid_317472 = gtid_317472;
        futhark_mc_task_337800.free_mem_317473 = mem_317473;
        
        struct scheduler_segop futhark_mc_task_337800_task;
        
        futhark_mc_task_337800_task.args = &futhark_mc_task_337800;
        futhark_mc_task_337800_task.top_level_fn =
            futhark_mc_segscan_task_337801;
        futhark_mc_task_337800_task.name = "futhark_mc_segscan_task_337801";
        futhark_mc_task_337800_task.iterations = defunc_0_f_res_292820;
        futhark_mc_task_337800_task.task_time =
            &ctx->futhark_mc_segscan_task_337801_total_time;
        futhark_mc_task_337800_task.task_iter =
            &ctx->futhark_mc_segscan_task_337801_total_iter;
        futhark_mc_task_337800_task.sched = STATIC;
        futhark_mc_task_337800_task.nested_fn = NULL;
        
        int futhark_mc_segscan_task_337801_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_337800_task);
        
        if (futhark_mc_segscan_task_337801_err != 0) {
            ;
            err = futhark_mc_segscan_task_337801_err;
            goto cleanup;
        }
        
        int64_t last_res_317484;
        
        last_res_317484 = ((int64_t *) mem_317473)[i_292895];
        for (int64_t i_317586 = 0; i_317586 < defunc_0_f_res_292820;
             i_317586++) {
            ((int64_t *) mem_317485)[i_317586] = (int64_t) -1;
        }
        
        int64_t flat_tid_317562 = (int64_t) 0;
        int32_t num_tasks_317587;
        struct futhark_mc_task_337807 futhark_mc_task_337807;
        
        futhark_mc_task_337807.ctx = ctx;
        futhark_mc_task_337807.free_n_p_292677 = n_p_292677;
        futhark_mc_task_337807.free_defunc_0_f_res_292820 =
            defunc_0_f_res_292820;
        futhark_mc_task_337807.free_gtid_297597 = gtid_297597;
        futhark_mc_task_337807.free_mem_312713 = mem_312713.mem;
        futhark_mc_task_337807.free_gtid_317472 = gtid_317472;
        futhark_mc_task_337807.free_mem_317473 = mem_317473;
        futhark_mc_task_337807.free_mem_317485 = mem_317485;
        
        struct scheduler_segop futhark_mc_task_337807_task;
        
        futhark_mc_task_337807_task.args = &futhark_mc_task_337807;
        futhark_mc_task_337807_task.top_level_fn =
            futhark_mc_segmap_task_337808;
        futhark_mc_task_337807_task.name = "futhark_mc_segmap_task_337808";
        futhark_mc_task_337807_task.iterations = defunc_0_f_res_292820;
        futhark_mc_task_337807_task.task_time =
            &ctx->futhark_mc_segmap_task_337808_total_time;
        futhark_mc_task_337807_task.task_iter =
            &ctx->futhark_mc_segmap_task_337808_total_iter;
        futhark_mc_task_337807_task.sched = STATIC;
        futhark_mc_task_337807_task.nested_fn = NULL;
        
        int futhark_mc_segmap_task_337808_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_337807_task);
        
        if (futhark_mc_segmap_task_337808_err != 0) {
            ;
            err = futhark_mc_segmap_task_337808_err;
            goto cleanup;
        }
        if (defunc_0_f_res_292820 * (int64_t) 8 > 0)
            memmove(mem_312753.mem + gtid_317472 * defunc_0_f_res_292820 *
                    (int64_t) 8, mem_317485 + (int64_t) 0,
                    defunc_0_f_res_292820 * (int64_t) 8);
        ((int64_t *) mem_312756.mem)[gtid_317472] = last_res_317484;
    }
    
  cleanup:
    { }
    free(mem_317473);
    free(mem_317485);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_337797_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_337797_end -
                 futhark_mc_segmap_parloop_337797_start;
        
        ctx->futhark_mc_segmap_parloop_337797_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_337797_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_337797_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_nested_task_337795(void *args, int64_t iterations,
                                         int tid, struct scheduler_info info)
{
    int err = 0;
    int flat_tid_317471 = tid;
    int num_tasks_317526 = info.nsubtasks;
    struct futhark_mc_task_337789 *futhark_mc_task_337789 =
                                  (struct futhark_mc_task_337789 *) args;
    struct futhark_context *ctx = futhark_mc_task_337789->ctx;
    uint64_t futhark_mc_segmap_nested_task_337795_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_nested_task_337795_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_337789->free_n_p_292677;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_337789->free_defunc_0_f_res_292820;
    int64_t i_292895 = futhark_mc_task_337789->free_i_292895;
    int64_t gtid_297597 = futhark_mc_task_337789->free_gtid_297597;
    int64_t bytes_312641 = futhark_mc_task_337789->free_bytes_312641;
    struct memblock mem_312713 = {.desc ="mem_312713", .mem =
                                  futhark_mc_task_337789->free_mem_312713,
                                  .size =0, .references =NULL};
    struct memblock mem_312753 = {.desc ="mem_312753", .mem =
                                  futhark_mc_task_337789->free_mem_312753,
                                  .size =0, .references =NULL};
    struct memblock mem_312756 = {.desc ="mem_312756", .mem =
                                  futhark_mc_task_337789->free_mem_312756,
                                  .size =0, .references =NULL};
    int64_t iter_317552;
    struct futhark_mc_segmap_parloop_struct_337796
    futhark_mc_segmap_parloop_struct_337796;
    
    futhark_mc_segmap_parloop_struct_337796.ctx = ctx;
    futhark_mc_segmap_parloop_struct_337796.free_n_p_292677 = n_p_292677;
    futhark_mc_segmap_parloop_struct_337796.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segmap_parloop_struct_337796.free_i_292895 = i_292895;
    futhark_mc_segmap_parloop_struct_337796.free_gtid_297597 = gtid_297597;
    futhark_mc_segmap_parloop_struct_337796.free_bytes_312641 = bytes_312641;
    futhark_mc_segmap_parloop_struct_337796.free_mem_312713 = mem_312713.mem;
    futhark_mc_segmap_parloop_struct_337796.free_mem_312753 = mem_312753.mem;
    futhark_mc_segmap_parloop_struct_337796.free_mem_312756 = mem_312756.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_337797_task;
    
    futhark_mc_segmap_parloop_337797_task.name =
        "futhark_mc_segmap_parloop_337797";
    futhark_mc_segmap_parloop_337797_task.fn = futhark_mc_segmap_parloop_337797;
    futhark_mc_segmap_parloop_337797_task.args =
        &futhark_mc_segmap_parloop_struct_337796;
    futhark_mc_segmap_parloop_337797_task.iterations = iterations;
    futhark_mc_segmap_parloop_337797_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_337797_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_337797_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_337797_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_337797_task);
    
    if (futhark_mc_segmap_parloop_337797_err != 0) {
        err = futhark_mc_segmap_parloop_337797_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_337797_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_337797_total_end -
                 futhark_mc_segmap_parloop_337797_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337797_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337797_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337797_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_nested_task_337795_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_nested_task_337795_end -
                 futhark_mc_segmap_nested_task_337795_start;
        
        ctx->futhark_mc_segmap_nested_task_337795_runs[tid]++;
        ctx->futhark_mc_segmap_nested_task_337795_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_nested_task_337795_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
static int futhark_mc_segmap_parloop_337786(void *args, int64_t start,
                                            int64_t end, int flat_tid_297596,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_337785
    *futhark_mc_segmap_parloop_struct_337785 =
    (struct futhark_mc_segmap_parloop_struct_337785 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_337785->ctx;
    uint64_t futhark_mc_segmap_parloop_337786_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_337786_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segmap_parloop_struct_337785->free_n_p_292677;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_337785->free_partition_sizze_292766;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segmap_parloop_struct_337785->free_defunc_0_f_res_292820;
    int64_t i_292895 = futhark_mc_segmap_parloop_struct_337785->free_i_292895;
    int64_t bytes_312641 =
            futhark_mc_segmap_parloop_struct_337785->free_bytes_312641;
    int64_t bytes_312660 =
            futhark_mc_segmap_parloop_struct_337785->free_bytes_312660;
    struct memblock mem_312713 = {.desc ="mem_312713", .mem =
                                  futhark_mc_segmap_parloop_struct_337785->free_mem_312713,
                                  .size =0, .references =NULL};
    int64_t bytes_312755 =
            futhark_mc_segmap_parloop_struct_337785->free_bytes_312755;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_segmap_parloop_struct_337785->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_312842 = {.desc ="mem_312842", .mem =
                                  futhark_mc_segmap_parloop_struct_337785->free_mem_312842,
                                  .size =0, .references =NULL};
    size_t mem_312753_cached_sizze_337787 = 0;
    unsigned char *mem_312753 = NULL;
    size_t mem_312756_cached_sizze_337788 = 0;
    unsigned char *mem_312756 = NULL;
    int64_t iterations = end - start;
    int64_t iter_317470 = start;
    
    if (mem_312753_cached_sizze_337787 < (size_t) bytes_312660) {
        mem_312753 = realloc(mem_312753, bytes_312660);
        mem_312753_cached_sizze_337787 = bytes_312660;
    }
    if (mem_312756_cached_sizze_337788 < (size_t) bytes_312755) {
        mem_312756 = realloc(mem_312756, bytes_312755);
        mem_312756_cached_sizze_337788 = bytes_312755;
    }
    for (; iter_317470 < end; iter_317470++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_317524 = partition_sizze_292766;
        int64_t gtid_297597 = iter_317470;
        int64_t remnant_317525 = iter_317470 - gtid_297597;
        int64_t flat_tid_317496 = (int64_t) 0;
        int32_t num_tasks_317526;
        int64_t flat_tid_317471 = (int64_t) 0;
        struct futhark_mc_task_337789 futhark_mc_task_337789;
        
        futhark_mc_task_337789.ctx = ctx;
        futhark_mc_task_337789.free_n_p_292677 = n_p_292677;
        futhark_mc_task_337789.free_defunc_0_f_res_292820 =
            defunc_0_f_res_292820;
        futhark_mc_task_337789.free_i_292895 = i_292895;
        futhark_mc_task_337789.free_gtid_297597 = gtid_297597;
        futhark_mc_task_337789.free_bytes_312641 = bytes_312641;
        futhark_mc_task_337789.free_mem_312713 = mem_312713.mem;
        futhark_mc_task_337789.free_mem_312753 = mem_312753;
        futhark_mc_task_337789.free_mem_312756 = mem_312756;
        
        struct scheduler_segop futhark_mc_task_337789_task;
        
        futhark_mc_task_337789_task.args = &futhark_mc_task_337789;
        futhark_mc_task_337789_task.top_level_fn =
            futhark_mc_segmap_task_337790;
        futhark_mc_task_337789_task.name = "futhark_mc_segmap_task_337790";
        futhark_mc_task_337789_task.iterations = n_p_292677;
        futhark_mc_task_337789_task.task_time =
            &ctx->futhark_mc_segmap_task_337790_total_time;
        futhark_mc_task_337789_task.task_iter =
            &ctx->futhark_mc_segmap_task_337790_total_iter;
        futhark_mc_task_337789_task.sched = STATIC;
        futhark_mc_task_337789_task.nested_fn =
            futhark_mc_segmap_nested_task_337795;
        
        int futhark_mc_segmap_task_337790_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_337789_task);
        
        if (futhark_mc_segmap_task_337790_err != 0) {
            ;
            err = futhark_mc_segmap_task_337790_err;
            goto cleanup;
        }
        if (n_p_292677 * defunc_0_f_res_292820 * (int64_t) 8 > 0)
            memmove(mem_312838.mem + gtid_297597 * (defunc_0_f_res_292820 *
                                                    n_p_292677) * (int64_t) 8,
                    mem_312753 + (int64_t) 0, n_p_292677 *
                    defunc_0_f_res_292820 * (int64_t) 8);
        if (n_p_292677 * (int64_t) 8 > 0)
            memmove(mem_312842.mem + gtid_297597 * n_p_292677 * (int64_t) 8,
                    mem_312756 + (int64_t) 0, n_p_292677 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_312753);
    free(mem_312756);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_337786_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_337786_end -
                 futhark_mc_segmap_parloop_337786_start;
        
        ctx->futhark_mc_segmap_parloop_337786_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_337786_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_337786_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_nested_task_337784(void *args, int64_t iterations,
                                         int tid, struct scheduler_info info)
{
    int err = 0;
    int flat_tid_297596 = tid;
    int num_tasks_317432 = info.nsubtasks;
    struct futhark_mc_task_337776 *futhark_mc_task_337776 =
                                  (struct futhark_mc_task_337776 *) args;
    struct futhark_context *ctx = futhark_mc_task_337776->ctx;
    uint64_t futhark_mc_segmap_nested_task_337784_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_nested_task_337784_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_337776->free_n_p_292677;
    int64_t partition_sizze_292766 =
            futhark_mc_task_337776->free_partition_sizze_292766;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_337776->free_defunc_0_f_res_292820;
    int64_t i_292895 = futhark_mc_task_337776->free_i_292895;
    int64_t bytes_312641 = futhark_mc_task_337776->free_bytes_312641;
    int64_t bytes_312660 = futhark_mc_task_337776->free_bytes_312660;
    struct memblock mem_312713 = {.desc ="mem_312713", .mem =
                                  futhark_mc_task_337776->free_mem_312713,
                                  .size =0, .references =NULL};
    int64_t bytes_312755 = futhark_mc_task_337776->free_bytes_312755;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_task_337776->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_312842 = {.desc ="mem_312842", .mem =
                                  futhark_mc_task_337776->free_mem_312842,
                                  .size =0, .references =NULL};
    int64_t iter_317470;
    struct futhark_mc_segmap_parloop_struct_337785
    futhark_mc_segmap_parloop_struct_337785;
    
    futhark_mc_segmap_parloop_struct_337785.ctx = ctx;
    futhark_mc_segmap_parloop_struct_337785.free_n_p_292677 = n_p_292677;
    futhark_mc_segmap_parloop_struct_337785.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_337785.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segmap_parloop_struct_337785.free_i_292895 = i_292895;
    futhark_mc_segmap_parloop_struct_337785.free_bytes_312641 = bytes_312641;
    futhark_mc_segmap_parloop_struct_337785.free_bytes_312660 = bytes_312660;
    futhark_mc_segmap_parloop_struct_337785.free_mem_312713 = mem_312713.mem;
    futhark_mc_segmap_parloop_struct_337785.free_bytes_312755 = bytes_312755;
    futhark_mc_segmap_parloop_struct_337785.free_mem_312838 = mem_312838.mem;
    futhark_mc_segmap_parloop_struct_337785.free_mem_312842 = mem_312842.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_337786_task;
    
    futhark_mc_segmap_parloop_337786_task.name =
        "futhark_mc_segmap_parloop_337786";
    futhark_mc_segmap_parloop_337786_task.fn = futhark_mc_segmap_parloop_337786;
    futhark_mc_segmap_parloop_337786_task.args =
        &futhark_mc_segmap_parloop_struct_337785;
    futhark_mc_segmap_parloop_337786_task.iterations = iterations;
    futhark_mc_segmap_parloop_337786_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_337786_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_337786_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_337786_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_337786_task);
    
    if (futhark_mc_segmap_parloop_337786_err != 0) {
        err = futhark_mc_segmap_parloop_337786_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_337786_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_337786_total_end -
                 futhark_mc_segmap_parloop_337786_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337786_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337786_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337786_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_nested_task_337784_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_nested_task_337784_end -
                 futhark_mc_segmap_nested_task_337784_start;
        
        ctx->futhark_mc_segmap_nested_task_337784_runs[tid]++;
        ctx->futhark_mc_segmap_nested_task_337784_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_nested_task_337784_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_task_337811 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_q_s_292678;
    int64_t free_jump_s_292684;
    int64_t free_partition_sizze_292766;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    int64_t free_i_292895;
    bool free_x_292896;
    int64_t free_min_res_292926;
    bool free_loop_cond_292931;
    double free_i64_res_292932;
    int64_t free_bytes_312641;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_312842;
    int64_t free_bytes_312847;
    int64_t free_bytes_312899;
    unsigned char *free_mem_313018;
    unsigned char *free_mem_313023;
};
struct futhark_mc_segmap_parloop_struct_337813 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_q_s_292678;
    int64_t free_jump_s_292684;
    int64_t free_partition_sizze_292766;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    int64_t free_i_292895;
    bool free_x_292896;
    int64_t free_min_res_292926;
    bool free_loop_cond_292931;
    double free_i64_res_292932;
    int64_t free_bytes_312641;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_312842;
    int64_t free_bytes_312899;
    unsigned char *free_mem_313018;
    unsigned char *free_mem_313023;
};
static int futhark_mc_segmap_parloop_337814(void *args, int64_t start,
                                            int64_t end, int flat_tid_297647,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_337813
    *futhark_mc_segmap_parloop_struct_337813 =
    (struct futhark_mc_segmap_parloop_struct_337813 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_337813->ctx;
    uint64_t futhark_mc_segmap_parloop_337814_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_337814_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segmap_parloop_struct_337813->free_n_p_292677;
    int64_t q_s_292678 =
            futhark_mc_segmap_parloop_struct_337813->free_q_s_292678;
    int64_t jump_s_292684 =
            futhark_mc_segmap_parloop_struct_337813->free_jump_s_292684;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_337813->free_partition_sizze_292766;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segmap_parloop_struct_337813->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_segmap_parloop_struct_337813->free_pad_css_len_292821;
    int64_t s_n_m_292825 =
            futhark_mc_segmap_parloop_struct_337813->free_s_n_m_292825;
    int64_t i_292895 = futhark_mc_segmap_parloop_struct_337813->free_i_292895;
    bool x_292896 = futhark_mc_segmap_parloop_struct_337813->free_x_292896;
    int64_t min_res_292926 =
            futhark_mc_segmap_parloop_struct_337813->free_min_res_292926;
    bool loop_cond_292931 =
         futhark_mc_segmap_parloop_struct_337813->free_loop_cond_292931;
    double i64_res_292932 =
           futhark_mc_segmap_parloop_struct_337813->free_i64_res_292932;
    int64_t bytes_312641 =
            futhark_mc_segmap_parloop_struct_337813->free_bytes_312641;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_segmap_parloop_struct_337813->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_312842 = {.desc ="mem_312842", .mem =
                                  futhark_mc_segmap_parloop_struct_337813->free_mem_312842,
                                  .size =0, .references =NULL};
    int64_t bytes_312899 =
            futhark_mc_segmap_parloop_struct_337813->free_bytes_312899;
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_segmap_parloop_struct_337813->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_segmap_parloop_struct_337813->free_mem_313023,
                                  .size =0, .references =NULL};
    size_t mem_312908_cached_sizze_337815 = 0;
    unsigned char *mem_312908 = NULL;
    size_t mem_312912_cached_sizze_337816 = 0;
    unsigned char *mem_312912 = NULL;
    size_t mem_312935_cached_sizze_337817 = 0;
    unsigned char *mem_312935 = NULL;
    int64_t iterations = end - start;
    int64_t iter_317594 = start;
    
    if (mem_312908_cached_sizze_337815 < (size_t) bytes_312899) {
        mem_312908 = realloc(mem_312908, bytes_312899);
        mem_312908_cached_sizze_337815 = bytes_312899;
    }
    if (mem_312912_cached_sizze_337816 < (size_t) bytes_312899) {
        mem_312912 = realloc(mem_312912, bytes_312899);
        mem_312912_cached_sizze_337816 = bytes_312899;
    }
    if (mem_312935_cached_sizze_337817 < (size_t) bytes_312641) {
        mem_312935 = realloc(mem_312935, bytes_312641);
        mem_312935_cached_sizze_337817 = bytes_312641;
    }
    for (; iter_317594 < end; iter_317594++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_317722 = partition_sizze_292766;
        int64_t gtid_297648 = iter_317594;
        int64_t remnant_317723 = iter_317594 - gtid_297648;
        
        for (int64_t i_317595 = 0; i_317595 < n_p_292677; i_317595++) {
            int64_t x_317598;
            
            x_317598 = ((int64_t *) mem_312842.mem)[gtid_297648 * n_p_292677 +
                                                    i_317595];
            for (int64_t i_317601 = 0; i_317601 < defunc_0_f_res_292820;
                 i_317601++) {
                int64_t x_317603;
                
                x_317603 = ((int64_t *) mem_312838.mem)[gtid_297648 *
                                                        (defunc_0_f_res_292820 *
                                                         n_p_292677) +
                                                        i_317595 *
                                                        defunc_0_f_res_292820 +
                                                        i_317601];
                
                int64_t defunc_0_f_res_317604 = add64((int64_t) 1, x_317603);
                
                ((int64_t *) mem_312935)[i_317601] = defunc_0_f_res_317604;
            }
            
            int64_t min_arg_317606 = sub64(x_317598, (int64_t) 1);
            int64_t min_arg_317607 = sub64(x_317598, min_res_292926);
            int64_t min_res_317608 = smin64(q_s_292678, x_317598);
            double i64_res_317609 = sitofp_i64_f64(x_317598);
            double x_317610 = i64_res_292932 - i64_res_317609;
            double max_arg_317611 = x_317610 / 2.0;
            double max_res_317612 = fmax64(0.0, max_arg_317611);
            
            for (int64_t i_317615 = 0; i_317615 < s_n_m_292825; i_317615++) {
                bool cond_317618 = i_317615 == (int64_t) 0;
                int64_t defunc_0_m_fun_res_317619;
                
                if (cond_317618) {
                    defunc_0_m_fun_res_317619 = (int64_t) 0;
                } else {
                    int64_t y_317620 = sub64(s_n_m_292825, (int64_t) 1);
                    bool cond_317621 = i_317615 == y_317620;
                    int64_t defunc_0_m_fun_res_f_res_317622;
                    
                    if (cond_317621) {
                        int64_t defunc_0_m_fun_res_f_res_t_res_317623 =
                                sub64(pad_css_len_292821, (int64_t) 1);
                        
                        defunc_0_m_fun_res_f_res_317622 =
                            defunc_0_m_fun_res_f_res_t_res_317623;
                    } else {
                        int64_t x_317624 = sub64(i_317615, (int64_t) 1);
                        int64_t x_317625 = mul64(jump_s_292684, x_317624);
                        int64_t min_arg_317626 = add64((int64_t) 1, x_317625);
                        int64_t min_res_317627 = smin64(defunc_0_f_res_292820,
                                                        min_arg_317626);
                        
                        defunc_0_m_fun_res_f_res_317622 = min_res_317627;
                    }
                    defunc_0_m_fun_res_317619 = defunc_0_m_fun_res_f_res_317622;
                }
                
                bool init_idx_317628;
                int64_t init_idx_317629;
                int64_t init_idx_317630;
                bool loop_while_317631;
                int64_t low_317632;
                int64_t high_317633;
                
                loop_while_317631 = x_292896;
                low_317632 = (int64_t) 0;
                high_317633 = i_292895;
                while (loop_while_317631) {
                    int64_t x_317634 = add64(low_317632, high_317633);
                    int64_t mid_317635 = sdiv64(x_317634, (int64_t) 2);
                    bool x_317636 = sle64((int64_t) 0, mid_317635);
                    bool y_317637 = slt64(mid_317635, defunc_0_f_res_292820);
                    bool bounds_check_317638 = x_317636 && y_317637;
                    bool index_certs_317639;
                    
                    if (!bounds_check_317638) {
                        ctx->error =
                            msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                      "Index [", (long long) mid_317635,
                                      "] out of bounds for array of shape [",
                                      (long long) defunc_0_f_res_292820, "].",
                                      "-> #0  loess.fut:645:26-36\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:638:3-665:10\n   #5  loess.fut:712:15-50\n   #6  stl.fut:140:20-80\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:139:12-141:40\n   #10 /prelude/soacs.fut:67:19-23\n   #11 /prelude/soacs.fut:67:3-37\n   #12 stl.fut:138:5-142:36\n   #13 stl.fut:419:61-435:77\n   #14 stl.fut:463:3-479:36\n   #15 stl.fut:445:1-479:36\n");
                        err = FUTHARK_PROGRAM_ERROR;
                        goto cleanup;
                    }
                    
                    int64_t mid_id_317640;
                    
                    mid_id_317640 = ((int64_t *) mem_312935)[mid_317635];
                    
                    bool cond_317641 = slt64(mid_id_317640, (int64_t) 0);
                    int64_t mid_idx_317642;
                    
                    if (cond_317641) {
                        mid_idx_317642 = (int64_t) 9223372036854775807;
                    } else {
                        mid_idx_317642 = mid_id_317640;
                    }
                    
                    bool cond_317643 = sle64(defunc_0_m_fun_res_317619,
                                             mid_idx_317642);
                    int64_t loopres_317644;
                    int64_t loopres_317645;
                    
                    if (cond_317643) {
                        int64_t loopres_t_res_317646 = sub64(mid_317635,
                                                             (int64_t) 1);
                        
                        loopres_317644 = low_317632;
                        loopres_317645 = loopres_t_res_317646;
                    } else {
                        int64_t loopres_f_res_317647 = add64((int64_t) 1,
                                                             mid_317635);
                        
                        loopres_317644 = loopres_f_res_317647;
                        loopres_317645 = high_317633;
                    }
                    
                    bool loop_cond_317648 = sle64(loopres_317644,
                                                  loopres_317645);
                    bool loop_while_tmp_317729 = loop_cond_317648;
                    int64_t low_tmp_317730 = loopres_317644;
                    int64_t high_tmp_317731 = loopres_317645;
                    
                    loop_while_317631 = loop_while_tmp_317729;
                    low_317632 = low_tmp_317730;
                    high_317633 = high_tmp_317731;
                }
                init_idx_317628 = loop_while_317631;
                init_idx_317629 = low_317632;
                init_idx_317630 = high_317633;
                
                bool idx_317649;
                int64_t idx_317650;
                int64_t idx_317651;
                int64_t idx_317652;
                bool loop_while_317653;
                int64_t l_idx_317654;
                int64_t r_idx_317655;
                int64_t span_317656;
                
                loop_while_317653 = loop_cond_292931;
                l_idx_317654 = init_idx_317629;
                r_idx_317655 = init_idx_317629;
                span_317656 = (int64_t) 1;
                while (loop_while_317653) {
                    int64_t max_arg_317657 = sub64(l_idx_317654, (int64_t) 1);
                    int64_t max_res_317658 = smax64((int64_t) 0,
                                                    max_arg_317657);
                    int64_t min_arg_317659 = add64((int64_t) 1, r_idx_317655);
                    int64_t min_res_317660 = smin64(min_arg_317606,
                                                    min_arg_317659);
                    bool x_317661 = sle64((int64_t) 0, max_res_317658);
                    bool y_317662 = slt64(max_res_317658,
                                          defunc_0_f_res_292820);
                    bool bounds_check_317663 = x_317661 && y_317662;
                    bool index_certs_317664;
                    
                    if (!bounds_check_317663) {
                        ctx->error =
                            msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                      "Index [", (long long) max_res_317658,
                                      "] out of bounds for array of shape [",
                                      (long long) defunc_0_f_res_292820, "].",
                                      "-> #0  loess.fut:655:35-48\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:638:3-665:10\n   #5  loess.fut:712:15-50\n   #6  stl.fut:140:20-80\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:139:12-141:40\n   #10 /prelude/soacs.fut:67:19-23\n   #11 /prelude/soacs.fut:67:3-37\n   #12 stl.fut:138:5-142:36\n   #13 stl.fut:419:61-435:77\n   #14 stl.fut:463:3-479:36\n   #15 stl.fut:445:1-479:36\n");
                        err = FUTHARK_PROGRAM_ERROR;
                        goto cleanup;
                    }
                    
                    int64_t x_317665;
                    
                    x_317665 = ((int64_t *) mem_312935)[max_res_317658];
                    
                    int64_t abs_arg_317666 = sub64(x_317665,
                                                   defunc_0_m_fun_res_317619);
                    int64_t abs_res_317667 = abs64(abs_arg_317666);
                    bool x_317668 = sle64((int64_t) 0, min_res_317660);
                    bool y_317669 = slt64(min_res_317660,
                                          defunc_0_f_res_292820);
                    bool bounds_check_317670 = x_317668 && y_317669;
                    bool index_certs_317671;
                    
                    if (!bounds_check_317670) {
                        ctx->error =
                            msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                      "Index [", (long long) min_res_317660,
                                      "] out of bounds for array of shape [",
                                      (long long) defunc_0_f_res_292820, "].",
                                      "-> #0  loess.fut:656:35-48\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:638:3-665:10\n   #5  loess.fut:712:15-50\n   #6  stl.fut:140:20-80\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:139:12-141:40\n   #10 /prelude/soacs.fut:67:19-23\n   #11 /prelude/soacs.fut:67:3-37\n   #12 stl.fut:138:5-142:36\n   #13 stl.fut:419:61-435:77\n   #14 stl.fut:463:3-479:36\n   #15 stl.fut:445:1-479:36\n");
                        err = FUTHARK_PROGRAM_ERROR;
                        goto cleanup;
                    }
                    
                    int64_t x_317672;
                    
                    x_317672 = ((int64_t *) mem_312935)[min_res_317660];
                    
                    int64_t abs_arg_317673 = sub64(x_317672,
                                                   defunc_0_m_fun_res_317619);
                    int64_t abs_res_317674 = abs64(abs_arg_317673);
                    bool cond_317675 = max_res_317658 == l_idx_317654;
                    int64_t loopres_317676;
                    int64_t loopres_317677;
                    int64_t loopres_317678;
                    
                    if (cond_317675) {
                        loopres_317676 = l_idx_317654;
                        loopres_317677 = r_idx_317655;
                        loopres_317678 = min_res_292926;
                    } else {
                        bool cond_317679 = slt64(abs_res_317667,
                                                 abs_res_317674);
                        bool cond_f_res_317680 = min_res_317660 == r_idx_317655;
                        bool x_317681 = !cond_317679;
                        bool y_317682 = cond_f_res_317680 && x_317681;
                        bool cond_317683 = cond_317679 || y_317682;
                        int64_t loopres_f_res_317684;
                        
                        if (cond_317683) {
                            loopres_f_res_317684 = max_res_317658;
                        } else {
                            loopres_f_res_317684 = l_idx_317654;
                        }
                        
                        int64_t loopres_f_res_317685;
                        
                        if (cond_317683) {
                            loopres_f_res_317685 = r_idx_317655;
                        } else {
                            loopres_f_res_317685 = min_res_317660;
                        }
                        
                        int64_t loopres_f_res_317686;
                        
                        if (cond_317683) {
                            int64_t loopres_f_res_t_res_317687 =
                                    add64((int64_t) 1, span_317656);
                            
                            loopres_f_res_317686 = loopres_f_res_t_res_317687;
                        } else {
                            int64_t loopres_f_res_f_res_317688 =
                                    add64((int64_t) 1, span_317656);
                            
                            loopres_f_res_317686 = loopres_f_res_f_res_317688;
                        }
                        loopres_317676 = loopres_f_res_317684;
                        loopres_317677 = loopres_f_res_317685;
                        loopres_317678 = loopres_f_res_317686;
                    }
                    
                    bool loop_cond_317689 = slt64(loopres_317678,
                                                  min_res_292926);
                    bool loop_while_tmp_317732 = loop_cond_317689;
                    int64_t l_idx_tmp_317733 = loopres_317676;
                    int64_t r_idx_tmp_317734 = loopres_317677;
                    int64_t span_tmp_317735 = loopres_317678;
                    
                    loop_while_317653 = loop_while_tmp_317732;
                    l_idx_317654 = l_idx_tmp_317733;
                    r_idx_317655 = r_idx_tmp_317734;
                    span_317656 = span_tmp_317735;
                }
                idx_317649 = loop_while_317653;
                idx_317650 = l_idx_317654;
                idx_317651 = r_idx_317655;
                idx_317652 = span_317656;
                
                int64_t min_res_317690 = smin64(min_arg_317607, idx_317650);
                int64_t max_res_317691 = smax64((int64_t) 0, min_res_317690);
                int64_t defunc_0_m_fun_res_317692;
                
                if (cond_317618) {
                    defunc_0_m_fun_res_317692 = (int64_t) 0;
                } else {
                    int64_t y_317693 = sub64(s_n_m_292825, (int64_t) 1);
                    bool cond_317694 = i_317615 == y_317693;
                    int64_t defunc_0_m_fun_res_f_res_317695;
                    
                    if (cond_317694) {
                        int64_t defunc_0_m_fun_res_f_res_t_res_317696 =
                                sub64(pad_css_len_292821, (int64_t) 1);
                        
                        defunc_0_m_fun_res_f_res_317695 =
                            defunc_0_m_fun_res_f_res_t_res_317696;
                    } else {
                        int64_t x_317697 = sub64(i_317615, (int64_t) 1);
                        int64_t x_317698 = mul64(jump_s_292684, x_317697);
                        int64_t min_arg_317699 = add64((int64_t) 1, x_317698);
                        int64_t min_res_317700 = smin64(defunc_0_f_res_292820,
                                                        min_arg_317699);
                        
                        defunc_0_m_fun_res_f_res_317695 = min_res_317700;
                    }
                    defunc_0_m_fun_res_317692 = defunc_0_m_fun_res_f_res_317695;
                }
                
                int64_t x_317701 = add64(min_res_317608, max_res_317691);
                int64_t r_317702 = sub64(x_317701, (int64_t) 1);
                bool x_317703 = sle64((int64_t) 0, r_317702);
                bool y_317704 = slt64(r_317702, defunc_0_f_res_292820);
                bool bounds_check_317705 = x_317703 && y_317704;
                bool index_certs_317706;
                
                if (!bounds_check_317705) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [", (long long) r_317702,
                                  "] out of bounds for array of shape [",
                                  (long long) defunc_0_f_res_292820, "].",
                                  "-> #0  loess.fut:680:40-47\n   #1  /prelude/soacs.fut:67:19-23\n   #2  /prelude/soacs.fut:67:3-37\n   #3  loess.fut:675:3-683:25\n   #4  loess.fut:713:16-54\n   #5  stl.fut:140:20-80\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  stl.fut:139:12-141:40\n   #9  /prelude/soacs.fut:67:19-23\n   #10 /prelude/soacs.fut:67:3-37\n   #11 stl.fut:138:5-142:36\n   #12 stl.fut:419:61-435:77\n   #13 stl.fut:463:3-479:36\n   #14 stl.fut:445:1-479:36\n");
                    err = FUTHARK_PROGRAM_ERROR;
                    goto cleanup;
                }
                
                int64_t x_317707;
                
                x_317707 = ((int64_t *) mem_312935)[r_317702];
                
                int64_t abs_arg_317708 = sub64(x_317707,
                                               defunc_0_m_fun_res_317692);
                int64_t abs_res_317709 = abs64(abs_arg_317708);
                bool x_317710 = sle64((int64_t) 0, max_res_317691);
                bool y_317711 = slt64(max_res_317691, defunc_0_f_res_292820);
                bool bounds_check_317712 = x_317710 && y_317711;
                bool index_certs_317713;
                
                if (!bounds_check_317712) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [", (long long) max_res_317691,
                                  "] out of bounds for array of shape [",
                                  (long long) defunc_0_f_res_292820, "].",
                                  "-> #0  loess.fut:679:40-47\n   #1  /prelude/soacs.fut:67:19-23\n   #2  /prelude/soacs.fut:67:3-37\n   #3  loess.fut:675:3-683:25\n   #4  loess.fut:713:16-54\n   #5  stl.fut:140:20-80\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  stl.fut:139:12-141:40\n   #9  /prelude/soacs.fut:67:19-23\n   #10 /prelude/soacs.fut:67:3-37\n   #11 stl.fut:138:5-142:36\n   #12 stl.fut:419:61-435:77\n   #13 stl.fut:463:3-479:36\n   #14 stl.fut:445:1-479:36\n");
                    err = FUTHARK_PROGRAM_ERROR;
                    goto cleanup;
                }
                
                int64_t x_317714;
                
                x_317714 = ((int64_t *) mem_312935)[max_res_317691];
                
                int64_t abs_arg_317715 = sub64(x_317714,
                                               defunc_0_m_fun_res_317692);
                int64_t abs_res_317716 = abs64(abs_arg_317715);
                int64_t max_res_317717 = smax64(abs_res_317709, abs_res_317716);
                double defunc_0_f_res_317718 = sitofp_i64_f64(max_res_317717);
                double defunc_1_f_res_317719 = max_res_317612 +
                       defunc_0_f_res_317718;
                
                ((double *) mem_312912)[i_317595 * s_n_m_292825 + i_317615] =
                    defunc_1_f_res_317719;
                ((int64_t *) mem_312908)[i_317595 * s_n_m_292825 + i_317615] =
                    max_res_317691;
            }
        }
        if (n_p_292677 * s_n_m_292825 * (int64_t) 8 > 0)
            memmove(mem_313018.mem + gtid_297648 * (s_n_m_292825 * n_p_292677) *
                    (int64_t) 8, mem_312908 + (int64_t) 0, n_p_292677 *
                    s_n_m_292825 * (int64_t) 8);
        if (n_p_292677 * s_n_m_292825 * (int64_t) 8 > 0)
            memmove(mem_313023.mem + gtid_297648 * (s_n_m_292825 * n_p_292677) *
                    (int64_t) 8, mem_312912 + (int64_t) 0, n_p_292677 *
                    s_n_m_292825 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_312908);
    free(mem_312912);
    free(mem_312935);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_337814_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_337814_end -
                 futhark_mc_segmap_parloop_337814_start;
        
        ctx->futhark_mc_segmap_parloop_337814_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_337814_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_337814_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_337812(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_297647 = tid;
    int num_tasks_317593 = info.nsubtasks;
    struct futhark_mc_task_337811 *futhark_mc_task_337811 =
                                  (struct futhark_mc_task_337811 *) args;
    struct futhark_context *ctx = futhark_mc_task_337811->ctx;
    uint64_t futhark_mc_segmap_task_337812_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_337812_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_337811->free_n_p_292677;
    int64_t q_s_292678 = futhark_mc_task_337811->free_q_s_292678;
    int64_t jump_s_292684 = futhark_mc_task_337811->free_jump_s_292684;
    int64_t partition_sizze_292766 =
            futhark_mc_task_337811->free_partition_sizze_292766;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_337811->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_task_337811->free_pad_css_len_292821;
    int64_t s_n_m_292825 = futhark_mc_task_337811->free_s_n_m_292825;
    int64_t i_292895 = futhark_mc_task_337811->free_i_292895;
    bool x_292896 = futhark_mc_task_337811->free_x_292896;
    int64_t min_res_292926 = futhark_mc_task_337811->free_min_res_292926;
    bool loop_cond_292931 = futhark_mc_task_337811->free_loop_cond_292931;
    double i64_res_292932 = futhark_mc_task_337811->free_i64_res_292932;
    int64_t bytes_312641 = futhark_mc_task_337811->free_bytes_312641;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_task_337811->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_312842 = {.desc ="mem_312842", .mem =
                                  futhark_mc_task_337811->free_mem_312842,
                                  .size =0, .references =NULL};
    int64_t bytes_312847 = futhark_mc_task_337811->free_bytes_312847;
    int64_t bytes_312899 = futhark_mc_task_337811->free_bytes_312899;
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_task_337811->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_task_337811->free_mem_313023,
                                  .size =0, .references =NULL};
    int64_t iter_317594;
    struct futhark_mc_segmap_parloop_struct_337813
    futhark_mc_segmap_parloop_struct_337813;
    
    futhark_mc_segmap_parloop_struct_337813.ctx = ctx;
    futhark_mc_segmap_parloop_struct_337813.free_n_p_292677 = n_p_292677;
    futhark_mc_segmap_parloop_struct_337813.free_q_s_292678 = q_s_292678;
    futhark_mc_segmap_parloop_struct_337813.free_jump_s_292684 = jump_s_292684;
    futhark_mc_segmap_parloop_struct_337813.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_337813.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segmap_parloop_struct_337813.free_pad_css_len_292821 =
        pad_css_len_292821;
    futhark_mc_segmap_parloop_struct_337813.free_s_n_m_292825 = s_n_m_292825;
    futhark_mc_segmap_parloop_struct_337813.free_i_292895 = i_292895;
    futhark_mc_segmap_parloop_struct_337813.free_x_292896 = x_292896;
    futhark_mc_segmap_parloop_struct_337813.free_min_res_292926 =
        min_res_292926;
    futhark_mc_segmap_parloop_struct_337813.free_loop_cond_292931 =
        loop_cond_292931;
    futhark_mc_segmap_parloop_struct_337813.free_i64_res_292932 =
        i64_res_292932;
    futhark_mc_segmap_parloop_struct_337813.free_bytes_312641 = bytes_312641;
    futhark_mc_segmap_parloop_struct_337813.free_mem_312838 = mem_312838.mem;
    futhark_mc_segmap_parloop_struct_337813.free_mem_312842 = mem_312842.mem;
    futhark_mc_segmap_parloop_struct_337813.free_bytes_312899 = bytes_312899;
    futhark_mc_segmap_parloop_struct_337813.free_mem_313018 = mem_313018.mem;
    futhark_mc_segmap_parloop_struct_337813.free_mem_313023 = mem_313023.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_337814_task;
    
    futhark_mc_segmap_parloop_337814_task.name =
        "futhark_mc_segmap_parloop_337814";
    futhark_mc_segmap_parloop_337814_task.fn = futhark_mc_segmap_parloop_337814;
    futhark_mc_segmap_parloop_337814_task.args =
        &futhark_mc_segmap_parloop_struct_337813;
    futhark_mc_segmap_parloop_337814_task.iterations = iterations;
    futhark_mc_segmap_parloop_337814_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_337814_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_337814_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_337814_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_337814_task);
    
    if (futhark_mc_segmap_parloop_337814_err != 0) {
        err = futhark_mc_segmap_parloop_337814_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_337814_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_337814_total_end -
                 futhark_mc_segmap_parloop_337814_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337814_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337814_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337814_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_337812_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_337812_end -
                 futhark_mc_segmap_task_337812_start;
        
        ctx->futhark_mc_segmap_task_337812_runs[tid]++;
        ctx->futhark_mc_segmap_task_337812_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_337812_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_segmap_parloop_struct_337819 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_q_s_292678;
    int64_t free_jump_s_292684;
    int64_t free_partition_sizze_292766;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    int64_t free_i_292895;
    bool free_x_292896;
    int64_t free_min_res_292926;
    bool free_loop_cond_292931;
    double free_i64_res_292932;
    int64_t free_bytes_312641;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_312842;
    int64_t free_bytes_312847;
    int64_t free_bytes_312899;
    unsigned char *free_mem_313018;
    unsigned char *free_mem_313023;
};
struct futhark_mc_task_337823 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_q_s_292678;
    int64_t free_jump_s_292684;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    int64_t free_i_292895;
    bool free_x_292896;
    int64_t free_min_res_292926;
    bool free_loop_cond_292931;
    double free_i64_res_292932;
    int64_t free_gtid_297783;
    int64_t free_bytes_312641;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_312842;
    int64_t free_bytes_312847;
    unsigned char *free_mem_312900;
    unsigned char *free_mem_312904;
};
struct futhark_mc_segmap_parloop_struct_337825 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_q_s_292678;
    int64_t free_jump_s_292684;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    int64_t free_i_292895;
    bool free_x_292896;
    int64_t free_min_res_292926;
    bool free_loop_cond_292931;
    double free_i64_res_292932;
    int64_t free_gtid_297783;
    int64_t free_bytes_312641;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_312842;
    int64_t free_bytes_312847;
    unsigned char *free_mem_312900;
    unsigned char *free_mem_312904;
};
static int futhark_mc_segmap_parloop_337826(void *args, int64_t start,
                                            int64_t end, int flat_tid_317861,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_337825
    *futhark_mc_segmap_parloop_struct_337825 =
    (struct futhark_mc_segmap_parloop_struct_337825 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_337825->ctx;
    uint64_t futhark_mc_segmap_parloop_337826_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_337826_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segmap_parloop_struct_337825->free_n_p_292677;
    int64_t q_s_292678 =
            futhark_mc_segmap_parloop_struct_337825->free_q_s_292678;
    int64_t jump_s_292684 =
            futhark_mc_segmap_parloop_struct_337825->free_jump_s_292684;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segmap_parloop_struct_337825->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_segmap_parloop_struct_337825->free_pad_css_len_292821;
    int64_t s_n_m_292825 =
            futhark_mc_segmap_parloop_struct_337825->free_s_n_m_292825;
    int64_t i_292895 = futhark_mc_segmap_parloop_struct_337825->free_i_292895;
    bool x_292896 = futhark_mc_segmap_parloop_struct_337825->free_x_292896;
    int64_t min_res_292926 =
            futhark_mc_segmap_parloop_struct_337825->free_min_res_292926;
    bool loop_cond_292931 =
         futhark_mc_segmap_parloop_struct_337825->free_loop_cond_292931;
    double i64_res_292932 =
           futhark_mc_segmap_parloop_struct_337825->free_i64_res_292932;
    int64_t gtid_297783 =
            futhark_mc_segmap_parloop_struct_337825->free_gtid_297783;
    int64_t bytes_312641 =
            futhark_mc_segmap_parloop_struct_337825->free_bytes_312641;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_segmap_parloop_struct_337825->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_312842 = {.desc ="mem_312842", .mem =
                                  futhark_mc_segmap_parloop_struct_337825->free_mem_312842,
                                  .size =0, .references =NULL};
    int64_t bytes_312847 =
            futhark_mc_segmap_parloop_struct_337825->free_bytes_312847;
    struct memblock mem_312900 = {.desc ="mem_312900", .mem =
                                  futhark_mc_segmap_parloop_struct_337825->free_mem_312900,
                                  .size =0, .references =NULL};
    struct memblock mem_312904 = {.desc ="mem_312904", .mem =
                                  futhark_mc_segmap_parloop_struct_337825->free_mem_312904,
                                  .size =0, .references =NULL};
    size_t mem_317864_cached_sizze_337827 = 0;
    unsigned char *mem_317864 = NULL;
    size_t mem_317879_cached_sizze_337828 = 0;
    unsigned char *mem_317879 = NULL;
    size_t mem_317881_cached_sizze_337829 = 0;
    unsigned char *mem_317881 = NULL;
    int64_t iterations = end - start;
    int64_t iter_317995 = start;
    
    if (mem_317864_cached_sizze_337827 < (size_t) bytes_312641) {
        mem_317864 = realloc(mem_317864, bytes_312641);
        mem_317864_cached_sizze_337827 = bytes_312641;
    }
    if (mem_317879_cached_sizze_337828 < (size_t) bytes_312847) {
        mem_317879 = realloc(mem_317879, bytes_312847);
        mem_317879_cached_sizze_337828 = bytes_312847;
    }
    if (mem_317881_cached_sizze_337829 < (size_t) bytes_312847) {
        mem_317881 = realloc(mem_317881, bytes_312847);
        mem_317881_cached_sizze_337829 = bytes_312847;
    }
    for (; iter_317995 < end; iter_317995++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_318108 = n_p_292677;
        int64_t gtid_317862 = iter_317995;
        int64_t remnant_318109 = iter_317995 - gtid_317862;
        int64_t x_317863;
        
        x_317863 = ((int64_t *) mem_312842.mem)[gtid_297783 * n_p_292677 +
                                                gtid_317862];
        for (int64_t i_317996 = 0; i_317996 < defunc_0_f_res_292820;
             i_317996++) {
            int64_t x_317998;
            
            x_317998 = ((int64_t *) mem_312838.mem)[gtid_297783 *
                                                    (defunc_0_f_res_292820 *
                                                     n_p_292677) + gtid_317862 *
                                                    defunc_0_f_res_292820 +
                                                    i_317996];
            
            int64_t defunc_0_f_res_317999 = add64((int64_t) 1, x_317998);
            
            ((int64_t *) mem_317864)[i_317996] = defunc_0_f_res_317999;
        }
        
        int64_t min_arg_317872 = sub64(x_317863, (int64_t) 1);
        int64_t min_arg_317873 = sub64(x_317863, min_res_292926);
        int64_t min_res_317874 = smin64(q_s_292678, x_317863);
        double i64_res_317875 = sitofp_i64_f64(x_317863);
        double x_317876 = i64_res_292932 - i64_res_317875;
        double max_arg_317877 = x_317876 / 2.0;
        double max_res_317878 = fmax64(0.0, max_arg_317877);
        
        for (int64_t i_318001 = 0; i_318001 < s_n_m_292825; i_318001++) {
            bool cond_318004 = i_318001 == (int64_t) 0;
            int64_t defunc_0_m_fun_res_318005;
            
            if (cond_318004) {
                defunc_0_m_fun_res_318005 = (int64_t) 0;
            } else {
                int64_t y_318006 = sub64(s_n_m_292825, (int64_t) 1);
                bool cond_318007 = i_318001 == y_318006;
                int64_t defunc_0_m_fun_res_f_res_318008;
                
                if (cond_318007) {
                    int64_t defunc_0_m_fun_res_f_res_t_res_318009 =
                            sub64(pad_css_len_292821, (int64_t) 1);
                    
                    defunc_0_m_fun_res_f_res_318008 =
                        defunc_0_m_fun_res_f_res_t_res_318009;
                } else {
                    int64_t x_318010 = sub64(i_318001, (int64_t) 1);
                    int64_t x_318011 = mul64(jump_s_292684, x_318010);
                    int64_t min_arg_318012 = add64((int64_t) 1, x_318011);
                    int64_t min_res_318013 = smin64(defunc_0_f_res_292820,
                                                    min_arg_318012);
                    
                    defunc_0_m_fun_res_f_res_318008 = min_res_318013;
                }
                defunc_0_m_fun_res_318005 = defunc_0_m_fun_res_f_res_318008;
            }
            
            bool init_idx_318014;
            int64_t init_idx_318015;
            int64_t init_idx_318016;
            bool loop_while_318017;
            int64_t low_318018;
            int64_t high_318019;
            
            loop_while_318017 = x_292896;
            low_318018 = (int64_t) 0;
            high_318019 = i_292895;
            while (loop_while_318017) {
                int64_t x_318020 = add64(low_318018, high_318019);
                int64_t mid_318021 = sdiv64(x_318020, (int64_t) 2);
                bool x_318022 = sle64((int64_t) 0, mid_318021);
                bool y_318023 = slt64(mid_318021, defunc_0_f_res_292820);
                bool bounds_check_318024 = x_318022 && y_318023;
                bool index_certs_318025;
                
                if (!bounds_check_318024) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [", (long long) mid_318021,
                                  "] out of bounds for array of shape [",
                                  (long long) defunc_0_f_res_292820, "].",
                                  "-> #0  loess.fut:645:26-36\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:638:3-665:10\n   #5  loess.fut:712:15-50\n   #6  stl.fut:140:20-80\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:139:12-141:40\n   #10 /prelude/soacs.fut:67:19-23\n   #11 /prelude/soacs.fut:67:3-37\n   #12 stl.fut:138:5-142:36\n   #13 stl.fut:419:61-435:77\n   #14 stl.fut:463:3-479:36\n   #15 stl.fut:445:1-479:36\n");
                    err = FUTHARK_PROGRAM_ERROR;
                    goto cleanup;
                }
                
                int64_t mid_id_318026;
                
                mid_id_318026 = ((int64_t *) mem_317864)[mid_318021];
                
                bool cond_318027 = slt64(mid_id_318026, (int64_t) 0);
                int64_t mid_idx_318028;
                
                if (cond_318027) {
                    mid_idx_318028 = (int64_t) 9223372036854775807;
                } else {
                    mid_idx_318028 = mid_id_318026;
                }
                
                bool cond_318029 = sle64(defunc_0_m_fun_res_318005,
                                         mid_idx_318028);
                int64_t loopres_318030;
                int64_t loopres_318031;
                
                if (cond_318029) {
                    int64_t loopres_t_res_318032 = sub64(mid_318021,
                                                         (int64_t) 1);
                    
                    loopres_318030 = low_318018;
                    loopres_318031 = loopres_t_res_318032;
                } else {
                    int64_t loopres_f_res_318033 = add64((int64_t) 1,
                                                         mid_318021);
                    
                    loopres_318030 = loopres_f_res_318033;
                    loopres_318031 = high_318019;
                }
                
                bool loop_cond_318034 = sle64(loopres_318030, loopres_318031);
                bool loop_while_tmp_318113 = loop_cond_318034;
                int64_t low_tmp_318114 = loopres_318030;
                int64_t high_tmp_318115 = loopres_318031;
                
                loop_while_318017 = loop_while_tmp_318113;
                low_318018 = low_tmp_318114;
                high_318019 = high_tmp_318115;
            }
            init_idx_318014 = loop_while_318017;
            init_idx_318015 = low_318018;
            init_idx_318016 = high_318019;
            
            bool idx_318035;
            int64_t idx_318036;
            int64_t idx_318037;
            int64_t idx_318038;
            bool loop_while_318039;
            int64_t l_idx_318040;
            int64_t r_idx_318041;
            int64_t span_318042;
            
            loop_while_318039 = loop_cond_292931;
            l_idx_318040 = init_idx_318015;
            r_idx_318041 = init_idx_318015;
            span_318042 = (int64_t) 1;
            while (loop_while_318039) {
                int64_t max_arg_318043 = sub64(l_idx_318040, (int64_t) 1);
                int64_t max_res_318044 = smax64((int64_t) 0, max_arg_318043);
                int64_t min_arg_318045 = add64((int64_t) 1, r_idx_318041);
                int64_t min_res_318046 = smin64(min_arg_317872, min_arg_318045);
                bool x_318047 = sle64((int64_t) 0, max_res_318044);
                bool y_318048 = slt64(max_res_318044, defunc_0_f_res_292820);
                bool bounds_check_318049 = x_318047 && y_318048;
                bool index_certs_318050;
                
                if (!bounds_check_318049) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [", (long long) max_res_318044,
                                  "] out of bounds for array of shape [",
                                  (long long) defunc_0_f_res_292820, "].",
                                  "-> #0  loess.fut:655:35-48\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:638:3-665:10\n   #5  loess.fut:712:15-50\n   #6  stl.fut:140:20-80\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:139:12-141:40\n   #10 /prelude/soacs.fut:67:19-23\n   #11 /prelude/soacs.fut:67:3-37\n   #12 stl.fut:138:5-142:36\n   #13 stl.fut:419:61-435:77\n   #14 stl.fut:463:3-479:36\n   #15 stl.fut:445:1-479:36\n");
                    err = FUTHARK_PROGRAM_ERROR;
                    goto cleanup;
                }
                
                int64_t x_318051;
                
                x_318051 = ((int64_t *) mem_317864)[max_res_318044];
                
                int64_t abs_arg_318052 = sub64(x_318051,
                                               defunc_0_m_fun_res_318005);
                int64_t abs_res_318053 = abs64(abs_arg_318052);
                bool x_318054 = sle64((int64_t) 0, min_res_318046);
                bool y_318055 = slt64(min_res_318046, defunc_0_f_res_292820);
                bool bounds_check_318056 = x_318054 && y_318055;
                bool index_certs_318057;
                
                if (!bounds_check_318056) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [", (long long) min_res_318046,
                                  "] out of bounds for array of shape [",
                                  (long long) defunc_0_f_res_292820, "].",
                                  "-> #0  loess.fut:656:35-48\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:638:3-665:10\n   #5  loess.fut:712:15-50\n   #6  stl.fut:140:20-80\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:139:12-141:40\n   #10 /prelude/soacs.fut:67:19-23\n   #11 /prelude/soacs.fut:67:3-37\n   #12 stl.fut:138:5-142:36\n   #13 stl.fut:419:61-435:77\n   #14 stl.fut:463:3-479:36\n   #15 stl.fut:445:1-479:36\n");
                    err = FUTHARK_PROGRAM_ERROR;
                    goto cleanup;
                }
                
                int64_t x_318058;
                
                x_318058 = ((int64_t *) mem_317864)[min_res_318046];
                
                int64_t abs_arg_318059 = sub64(x_318058,
                                               defunc_0_m_fun_res_318005);
                int64_t abs_res_318060 = abs64(abs_arg_318059);
                bool cond_318061 = max_res_318044 == l_idx_318040;
                int64_t loopres_318062;
                int64_t loopres_318063;
                int64_t loopres_318064;
                
                if (cond_318061) {
                    loopres_318062 = l_idx_318040;
                    loopres_318063 = r_idx_318041;
                    loopres_318064 = min_res_292926;
                } else {
                    bool cond_318065 = slt64(abs_res_318053, abs_res_318060);
                    bool cond_f_res_318066 = min_res_318046 == r_idx_318041;
                    bool x_318067 = !cond_318065;
                    bool y_318068 = cond_f_res_318066 && x_318067;
                    bool cond_318069 = cond_318065 || y_318068;
                    int64_t loopres_f_res_318070;
                    
                    if (cond_318069) {
                        loopres_f_res_318070 = max_res_318044;
                    } else {
                        loopres_f_res_318070 = l_idx_318040;
                    }
                    
                    int64_t loopres_f_res_318071;
                    
                    if (cond_318069) {
                        loopres_f_res_318071 = r_idx_318041;
                    } else {
                        loopres_f_res_318071 = min_res_318046;
                    }
                    
                    int64_t loopres_f_res_318072;
                    
                    if (cond_318069) {
                        int64_t loopres_f_res_t_res_318073 = add64((int64_t) 1,
                                                                   span_318042);
                        
                        loopres_f_res_318072 = loopres_f_res_t_res_318073;
                    } else {
                        int64_t loopres_f_res_f_res_318074 = add64((int64_t) 1,
                                                                   span_318042);
                        
                        loopres_f_res_318072 = loopres_f_res_f_res_318074;
                    }
                    loopres_318062 = loopres_f_res_318070;
                    loopres_318063 = loopres_f_res_318071;
                    loopres_318064 = loopres_f_res_318072;
                }
                
                bool loop_cond_318075 = slt64(loopres_318064, min_res_292926);
                bool loop_while_tmp_318116 = loop_cond_318075;
                int64_t l_idx_tmp_318117 = loopres_318062;
                int64_t r_idx_tmp_318118 = loopres_318063;
                int64_t span_tmp_318119 = loopres_318064;
                
                loop_while_318039 = loop_while_tmp_318116;
                l_idx_318040 = l_idx_tmp_318117;
                r_idx_318041 = r_idx_tmp_318118;
                span_318042 = span_tmp_318119;
            }
            idx_318035 = loop_while_318039;
            idx_318036 = l_idx_318040;
            idx_318037 = r_idx_318041;
            idx_318038 = span_318042;
            
            int64_t min_res_318076 = smin64(min_arg_317873, idx_318036);
            int64_t max_res_318077 = smax64((int64_t) 0, min_res_318076);
            int64_t defunc_0_m_fun_res_318078;
            
            if (cond_318004) {
                defunc_0_m_fun_res_318078 = (int64_t) 0;
            } else {
                int64_t y_318079 = sub64(s_n_m_292825, (int64_t) 1);
                bool cond_318080 = i_318001 == y_318079;
                int64_t defunc_0_m_fun_res_f_res_318081;
                
                if (cond_318080) {
                    int64_t defunc_0_m_fun_res_f_res_t_res_318082 =
                            sub64(pad_css_len_292821, (int64_t) 1);
                    
                    defunc_0_m_fun_res_f_res_318081 =
                        defunc_0_m_fun_res_f_res_t_res_318082;
                } else {
                    int64_t x_318083 = sub64(i_318001, (int64_t) 1);
                    int64_t x_318084 = mul64(jump_s_292684, x_318083);
                    int64_t min_arg_318085 = add64((int64_t) 1, x_318084);
                    int64_t min_res_318086 = smin64(defunc_0_f_res_292820,
                                                    min_arg_318085);
                    
                    defunc_0_m_fun_res_f_res_318081 = min_res_318086;
                }
                defunc_0_m_fun_res_318078 = defunc_0_m_fun_res_f_res_318081;
            }
            
            int64_t x_318087 = add64(min_res_317874, max_res_318077);
            int64_t r_318088 = sub64(x_318087, (int64_t) 1);
            bool x_318089 = sle64((int64_t) 0, r_318088);
            bool y_318090 = slt64(r_318088, defunc_0_f_res_292820);
            bool bounds_check_318091 = x_318089 && y_318090;
            bool index_certs_318092;
            
            if (!bounds_check_318091) {
                ctx->error =
                    msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                              "Index [", (long long) r_318088,
                              "] out of bounds for array of shape [",
                              (long long) defunc_0_f_res_292820, "].",
                              "-> #0  loess.fut:680:40-47\n   #1  /prelude/soacs.fut:67:19-23\n   #2  /prelude/soacs.fut:67:3-37\n   #3  loess.fut:675:3-683:25\n   #4  loess.fut:713:16-54\n   #5  stl.fut:140:20-80\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  stl.fut:139:12-141:40\n   #9  /prelude/soacs.fut:67:19-23\n   #10 /prelude/soacs.fut:67:3-37\n   #11 stl.fut:138:5-142:36\n   #12 stl.fut:419:61-435:77\n   #13 stl.fut:463:3-479:36\n   #14 stl.fut:445:1-479:36\n");
                err = FUTHARK_PROGRAM_ERROR;
                goto cleanup;
            }
            
            int64_t x_318093;
            
            x_318093 = ((int64_t *) mem_317864)[r_318088];
            
            int64_t abs_arg_318094 = sub64(x_318093, defunc_0_m_fun_res_318078);
            int64_t abs_res_318095 = abs64(abs_arg_318094);
            bool x_318096 = sle64((int64_t) 0, max_res_318077);
            bool y_318097 = slt64(max_res_318077, defunc_0_f_res_292820);
            bool bounds_check_318098 = x_318096 && y_318097;
            bool index_certs_318099;
            
            if (!bounds_check_318098) {
                ctx->error =
                    msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                              "Index [", (long long) max_res_318077,
                              "] out of bounds for array of shape [",
                              (long long) defunc_0_f_res_292820, "].",
                              "-> #0  loess.fut:679:40-47\n   #1  /prelude/soacs.fut:67:19-23\n   #2  /prelude/soacs.fut:67:3-37\n   #3  loess.fut:675:3-683:25\n   #4  loess.fut:713:16-54\n   #5  stl.fut:140:20-80\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  stl.fut:139:12-141:40\n   #9  /prelude/soacs.fut:67:19-23\n   #10 /prelude/soacs.fut:67:3-37\n   #11 stl.fut:138:5-142:36\n   #12 stl.fut:419:61-435:77\n   #13 stl.fut:463:3-479:36\n   #14 stl.fut:445:1-479:36\n");
                err = FUTHARK_PROGRAM_ERROR;
                goto cleanup;
            }
            
            int64_t x_318100;
            
            x_318100 = ((int64_t *) mem_317864)[max_res_318077];
            
            int64_t abs_arg_318101 = sub64(x_318100, defunc_0_m_fun_res_318078);
            int64_t abs_res_318102 = abs64(abs_arg_318101);
            int64_t max_res_318103 = smax64(abs_res_318095, abs_res_318102);
            double defunc_0_f_res_318104 = sitofp_i64_f64(max_res_318103);
            double defunc_1_f_res_318105 = max_res_317878 +
                   defunc_0_f_res_318104;
            
            ((double *) mem_317879)[i_318001] = defunc_1_f_res_318105;
            ((int64_t *) mem_317881)[i_318001] = max_res_318077;
        }
        if (s_n_m_292825 * (int64_t) 8 > 0)
            memmove(mem_312900.mem + gtid_317862 * s_n_m_292825 * (int64_t) 8,
                    mem_317881 + (int64_t) 0, s_n_m_292825 * (int64_t) 8);
        if (s_n_m_292825 * (int64_t) 8 > 0)
            memmove(mem_312904.mem + gtid_317862 * s_n_m_292825 * (int64_t) 8,
                    mem_317879 + (int64_t) 0, s_n_m_292825 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_317864);
    free(mem_317879);
    free(mem_317881);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_337826_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_337826_end -
                 futhark_mc_segmap_parloop_337826_start;
        
        ctx->futhark_mc_segmap_parloop_337826_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_337826_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_337826_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_337824(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_317861 = tid;
    int num_tasks_317994 = info.nsubtasks;
    struct futhark_mc_task_337823 *futhark_mc_task_337823 =
                                  (struct futhark_mc_task_337823 *) args;
    struct futhark_context *ctx = futhark_mc_task_337823->ctx;
    uint64_t futhark_mc_segmap_task_337824_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_337824_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_337823->free_n_p_292677;
    int64_t q_s_292678 = futhark_mc_task_337823->free_q_s_292678;
    int64_t jump_s_292684 = futhark_mc_task_337823->free_jump_s_292684;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_337823->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_task_337823->free_pad_css_len_292821;
    int64_t s_n_m_292825 = futhark_mc_task_337823->free_s_n_m_292825;
    int64_t i_292895 = futhark_mc_task_337823->free_i_292895;
    bool x_292896 = futhark_mc_task_337823->free_x_292896;
    int64_t min_res_292926 = futhark_mc_task_337823->free_min_res_292926;
    bool loop_cond_292931 = futhark_mc_task_337823->free_loop_cond_292931;
    double i64_res_292932 = futhark_mc_task_337823->free_i64_res_292932;
    int64_t gtid_297783 = futhark_mc_task_337823->free_gtid_297783;
    int64_t bytes_312641 = futhark_mc_task_337823->free_bytes_312641;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_task_337823->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_312842 = {.desc ="mem_312842", .mem =
                                  futhark_mc_task_337823->free_mem_312842,
                                  .size =0, .references =NULL};
    int64_t bytes_312847 = futhark_mc_task_337823->free_bytes_312847;
    struct memblock mem_312900 = {.desc ="mem_312900", .mem =
                                  futhark_mc_task_337823->free_mem_312900,
                                  .size =0, .references =NULL};
    struct memblock mem_312904 = {.desc ="mem_312904", .mem =
                                  futhark_mc_task_337823->free_mem_312904,
                                  .size =0, .references =NULL};
    int64_t iter_317995;
    struct futhark_mc_segmap_parloop_struct_337825
    futhark_mc_segmap_parloop_struct_337825;
    
    futhark_mc_segmap_parloop_struct_337825.ctx = ctx;
    futhark_mc_segmap_parloop_struct_337825.free_n_p_292677 = n_p_292677;
    futhark_mc_segmap_parloop_struct_337825.free_q_s_292678 = q_s_292678;
    futhark_mc_segmap_parloop_struct_337825.free_jump_s_292684 = jump_s_292684;
    futhark_mc_segmap_parloop_struct_337825.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segmap_parloop_struct_337825.free_pad_css_len_292821 =
        pad_css_len_292821;
    futhark_mc_segmap_parloop_struct_337825.free_s_n_m_292825 = s_n_m_292825;
    futhark_mc_segmap_parloop_struct_337825.free_i_292895 = i_292895;
    futhark_mc_segmap_parloop_struct_337825.free_x_292896 = x_292896;
    futhark_mc_segmap_parloop_struct_337825.free_min_res_292926 =
        min_res_292926;
    futhark_mc_segmap_parloop_struct_337825.free_loop_cond_292931 =
        loop_cond_292931;
    futhark_mc_segmap_parloop_struct_337825.free_i64_res_292932 =
        i64_res_292932;
    futhark_mc_segmap_parloop_struct_337825.free_gtid_297783 = gtid_297783;
    futhark_mc_segmap_parloop_struct_337825.free_bytes_312641 = bytes_312641;
    futhark_mc_segmap_parloop_struct_337825.free_mem_312838 = mem_312838.mem;
    futhark_mc_segmap_parloop_struct_337825.free_mem_312842 = mem_312842.mem;
    futhark_mc_segmap_parloop_struct_337825.free_bytes_312847 = bytes_312847;
    futhark_mc_segmap_parloop_struct_337825.free_mem_312900 = mem_312900.mem;
    futhark_mc_segmap_parloop_struct_337825.free_mem_312904 = mem_312904.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_337826_task;
    
    futhark_mc_segmap_parloop_337826_task.name =
        "futhark_mc_segmap_parloop_337826";
    futhark_mc_segmap_parloop_337826_task.fn = futhark_mc_segmap_parloop_337826;
    futhark_mc_segmap_parloop_337826_task.args =
        &futhark_mc_segmap_parloop_struct_337825;
    futhark_mc_segmap_parloop_337826_task.iterations = iterations;
    futhark_mc_segmap_parloop_337826_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_337826_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_337826_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_337826_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_337826_task);
    
    if (futhark_mc_segmap_parloop_337826_err != 0) {
        err = futhark_mc_segmap_parloop_337826_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_337826_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_337826_total_end -
                 futhark_mc_segmap_parloop_337826_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337826_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337826_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337826_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_337824_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_337824_end -
                 futhark_mc_segmap_task_337824_start;
        
        ctx->futhark_mc_segmap_task_337824_runs[tid]++;
        ctx->futhark_mc_segmap_task_337824_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_337824_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_segmap_parloop_struct_337831 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_q_s_292678;
    int64_t free_jump_s_292684;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    int64_t free_i_292895;
    bool free_x_292896;
    int64_t free_min_res_292926;
    bool free_loop_cond_292931;
    double free_i64_res_292932;
    int64_t free_gtid_297783;
    int64_t free_bytes_312641;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_312842;
    int64_t free_bytes_312847;
    unsigned char *free_mem_312900;
    unsigned char *free_mem_312904;
};
struct futhark_mc_task_337836 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_gtid_297783;
    unsigned char *free_mem_312838;
    int64_t free_gtid_317738;
    unsigned char *free_mem_317740;
};
struct futhark_mc_segmap_parloop_struct_337838 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_gtid_297783;
    unsigned char *free_mem_312838;
    int64_t free_gtid_317738;
    unsigned char *free_mem_317740;
};
static int futhark_mc_segmap_parloop_337839(void *args, int64_t start,
                                            int64_t end, int flat_tid_318121,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_337838
    *futhark_mc_segmap_parloop_struct_337838 =
    (struct futhark_mc_segmap_parloop_struct_337838 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_337838->ctx;
    uint64_t futhark_mc_segmap_parloop_337839_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_337839_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segmap_parloop_struct_337838->free_n_p_292677;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segmap_parloop_struct_337838->free_defunc_0_f_res_292820;
    int64_t gtid_297783 =
            futhark_mc_segmap_parloop_struct_337838->free_gtid_297783;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_segmap_parloop_struct_337838->free_mem_312838,
                                  .size =0, .references =NULL};
    int64_t gtid_317738 =
            futhark_mc_segmap_parloop_struct_337838->free_gtid_317738;
    struct memblock mem_317740 = {.desc ="mem_317740", .mem =
                                  futhark_mc_segmap_parloop_struct_337838->free_mem_317740,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_318232 = start;
    
    for (; iter_318232 < end; iter_318232++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_318233 = defunc_0_f_res_292820;
        int64_t gtid_318122 = iter_318232;
        int64_t remnant_318234 = iter_318232 - gtid_318122;
        int64_t x_318123;
        
        x_318123 = ((int64_t *) mem_312838.mem)[gtid_297783 *
                                                (defunc_0_f_res_292820 *
                                                 n_p_292677) + gtid_317738 *
                                                defunc_0_f_res_292820 +
                                                gtid_318122];
        
        int64_t defunc_0_f_res_318124 = add64((int64_t) 1, x_318123);
        
        ((int64_t *) mem_317740.mem)[gtid_318122] = defunc_0_f_res_318124;
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_337839_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_337839_end -
                 futhark_mc_segmap_parloop_337839_start;
        
        ctx->futhark_mc_segmap_parloop_337839_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_337839_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_337839_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_337837(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_318121 = tid;
    int num_tasks_318231 = info.nsubtasks;
    struct futhark_mc_task_337836 *futhark_mc_task_337836 =
                                  (struct futhark_mc_task_337836 *) args;
    struct futhark_context *ctx = futhark_mc_task_337836->ctx;
    uint64_t futhark_mc_segmap_task_337837_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_337837_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_337836->free_n_p_292677;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_337836->free_defunc_0_f_res_292820;
    int64_t gtid_297783 = futhark_mc_task_337836->free_gtid_297783;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_task_337836->free_mem_312838,
                                  .size =0, .references =NULL};
    int64_t gtid_317738 = futhark_mc_task_337836->free_gtid_317738;
    struct memblock mem_317740 = {.desc ="mem_317740", .mem =
                                  futhark_mc_task_337836->free_mem_317740,
                                  .size =0, .references =NULL};
    int64_t iter_318232;
    struct futhark_mc_segmap_parloop_struct_337838
    futhark_mc_segmap_parloop_struct_337838;
    
    futhark_mc_segmap_parloop_struct_337838.ctx = ctx;
    futhark_mc_segmap_parloop_struct_337838.free_n_p_292677 = n_p_292677;
    futhark_mc_segmap_parloop_struct_337838.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segmap_parloop_struct_337838.free_gtid_297783 = gtid_297783;
    futhark_mc_segmap_parloop_struct_337838.free_mem_312838 = mem_312838.mem;
    futhark_mc_segmap_parloop_struct_337838.free_gtid_317738 = gtid_317738;
    futhark_mc_segmap_parloop_struct_337838.free_mem_317740 = mem_317740.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_337839_task;
    
    futhark_mc_segmap_parloop_337839_task.name =
        "futhark_mc_segmap_parloop_337839";
    futhark_mc_segmap_parloop_337839_task.fn = futhark_mc_segmap_parloop_337839;
    futhark_mc_segmap_parloop_337839_task.args =
        &futhark_mc_segmap_parloop_struct_337838;
    futhark_mc_segmap_parloop_337839_task.iterations = iterations;
    futhark_mc_segmap_parloop_337839_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_337839_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_337839_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_337839_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_337839_task);
    
    if (futhark_mc_segmap_parloop_337839_err != 0) {
        err = futhark_mc_segmap_parloop_337839_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_337839_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_337839_total_end -
                 futhark_mc_segmap_parloop_337839_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337839_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337839_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337839_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_337837_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_337837_end -
                 futhark_mc_segmap_task_337837_start;
        
        ctx->futhark_mc_segmap_task_337837_runs[tid]++;
        ctx->futhark_mc_segmap_task_337837_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_337837_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_task_337840 {
    struct futhark_context *ctx;
    int64_t free_jump_s_292684;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    int64_t free_i_292895;
    bool free_x_292896;
    int64_t free_min_res_292926;
    bool free_loop_cond_292931;
    unsigned char *free_mem_317740;
    int64_t free_min_arg_317746;
    int64_t free_min_arg_317747;
    int64_t free_min_res_317748;
    double free_max_res_317752;
    unsigned char *free_mem_317753;
    unsigned char *free_mem_317754;
};
struct futhark_mc_segmap_parloop_struct_337842 {
    struct futhark_context *ctx;
    int64_t free_jump_s_292684;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    int64_t free_i_292895;
    bool free_x_292896;
    int64_t free_min_res_292926;
    bool free_loop_cond_292931;
    unsigned char *free_mem_317740;
    int64_t free_min_arg_317746;
    int64_t free_min_arg_317747;
    int64_t free_min_res_317748;
    double free_max_res_317752;
    unsigned char *free_mem_317753;
    unsigned char *free_mem_317754;
};
static int futhark_mc_segmap_parloop_337843(void *args, int64_t start,
                                            int64_t end, int flat_tid_318125,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_337842
    *futhark_mc_segmap_parloop_struct_337842 =
    (struct futhark_mc_segmap_parloop_struct_337842 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_337842->ctx;
    uint64_t futhark_mc_segmap_parloop_337843_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_337843_start = get_wall_time();
    
    int64_t jump_s_292684 =
            futhark_mc_segmap_parloop_struct_337842->free_jump_s_292684;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segmap_parloop_struct_337842->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_segmap_parloop_struct_337842->free_pad_css_len_292821;
    int64_t s_n_m_292825 =
            futhark_mc_segmap_parloop_struct_337842->free_s_n_m_292825;
    int64_t i_292895 = futhark_mc_segmap_parloop_struct_337842->free_i_292895;
    bool x_292896 = futhark_mc_segmap_parloop_struct_337842->free_x_292896;
    int64_t min_res_292926 =
            futhark_mc_segmap_parloop_struct_337842->free_min_res_292926;
    bool loop_cond_292931 =
         futhark_mc_segmap_parloop_struct_337842->free_loop_cond_292931;
    struct memblock mem_317740 = {.desc ="mem_317740", .mem =
                                  futhark_mc_segmap_parloop_struct_337842->free_mem_317740,
                                  .size =0, .references =NULL};
    int64_t min_arg_317746 =
            futhark_mc_segmap_parloop_struct_337842->free_min_arg_317746;
    int64_t min_arg_317747 =
            futhark_mc_segmap_parloop_struct_337842->free_min_arg_317747;
    int64_t min_res_317748 =
            futhark_mc_segmap_parloop_struct_337842->free_min_res_317748;
    double max_res_317752 =
           futhark_mc_segmap_parloop_struct_337842->free_max_res_317752;
    struct memblock mem_317753 = {.desc ="mem_317753", .mem =
                                  futhark_mc_segmap_parloop_struct_337842->free_mem_317753,
                                  .size =0, .references =NULL};
    struct memblock mem_317754 = {.desc ="mem_317754", .mem =
                                  futhark_mc_segmap_parloop_struct_337842->free_mem_317754,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_318236 = start;
    
    for (; iter_318236 < end; iter_318236++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_318308 = s_n_m_292825;
        int64_t gtid_318126 = iter_318236;
        int64_t remnant_318309 = iter_318236 - gtid_318126;
        bool cond_318127 = gtid_318126 == (int64_t) 0;
        int64_t defunc_0_m_fun_res_318128;
        
        if (cond_318127) {
            defunc_0_m_fun_res_318128 = (int64_t) 0;
        } else {
            int64_t y_318237 = sub64(s_n_m_292825, (int64_t) 1);
            bool cond_318238 = gtid_318126 == y_318237;
            int64_t defunc_0_m_fun_res_f_res_318239;
            
            if (cond_318238) {
                int64_t defunc_0_m_fun_res_f_res_t_res_318240 =
                        sub64(pad_css_len_292821, (int64_t) 1);
                
                defunc_0_m_fun_res_f_res_318239 =
                    defunc_0_m_fun_res_f_res_t_res_318240;
            } else {
                int64_t x_318241 = sub64(gtid_318126, (int64_t) 1);
                int64_t x_318242 = mul64(jump_s_292684, x_318241);
                int64_t min_arg_318243 = add64((int64_t) 1, x_318242);
                int64_t min_res_318244 = smin64(defunc_0_f_res_292820,
                                                min_arg_318243);
                
                defunc_0_m_fun_res_f_res_318239 = min_res_318244;
            }
            defunc_0_m_fun_res_318128 = defunc_0_m_fun_res_f_res_318239;
        }
        
        bool init_idx_318137;
        int64_t init_idx_318138;
        int64_t init_idx_318139;
        bool loop_while_318245;
        int64_t low_318246;
        int64_t high_318247;
        
        loop_while_318245 = x_292896;
        low_318246 = (int64_t) 0;
        high_318247 = i_292895;
        while (loop_while_318245) {
            int64_t x_318248 = add64(low_318246, high_318247);
            int64_t mid_318249 = sdiv64(x_318248, (int64_t) 2);
            bool x_318250 = sle64((int64_t) 0, mid_318249);
            bool y_318251 = slt64(mid_318249, defunc_0_f_res_292820);
            bool bounds_check_318252 = x_318250 && y_318251;
            bool index_certs_318253;
            
            if (!bounds_check_318252) {
                ctx->error =
                    msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                              "Index [", (long long) mid_318249,
                              "] out of bounds for array of shape [",
                              (long long) defunc_0_f_res_292820, "].",
                              "-> #0  loess.fut:645:26-36\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:638:3-665:10\n   #5  loess.fut:712:15-50\n   #6  stl.fut:140:20-80\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:139:12-141:40\n   #10 /prelude/soacs.fut:67:19-23\n   #11 /prelude/soacs.fut:67:3-37\n   #12 stl.fut:138:5-142:36\n   #13 stl.fut:419:61-435:77\n   #14 stl.fut:463:3-479:36\n   #15 stl.fut:445:1-479:36\n");
                err = FUTHARK_PROGRAM_ERROR;
                goto cleanup;
            }
            
            int64_t mid_id_318254;
            
            mid_id_318254 = ((int64_t *) mem_317740.mem)[mid_318249];
            
            bool cond_318255 = slt64(mid_id_318254, (int64_t) 0);
            int64_t mid_idx_318256;
            
            if (cond_318255) {
                mid_idx_318256 = (int64_t) 9223372036854775807;
            } else {
                mid_idx_318256 = mid_id_318254;
            }
            
            bool cond_318257 = sle64(defunc_0_m_fun_res_318128, mid_idx_318256);
            int64_t loopres_318258;
            int64_t loopres_318259;
            
            if (cond_318257) {
                int64_t loopres_t_res_318260 = sub64(mid_318249, (int64_t) 1);
                
                loopres_318258 = low_318246;
                loopres_318259 = loopres_t_res_318260;
            } else {
                int64_t loopres_f_res_318261 = add64((int64_t) 1, mid_318249);
                
                loopres_318258 = loopres_f_res_318261;
                loopres_318259 = high_318247;
            }
            
            bool loop_cond_318262 = sle64(loopres_318258, loopres_318259);
            bool loop_while_tmp_318310 = loop_cond_318262;
            int64_t low_tmp_318311 = loopres_318258;
            int64_t high_tmp_318312 = loopres_318259;
            
            loop_while_318245 = loop_while_tmp_318310;
            low_318246 = low_tmp_318311;
            high_318247 = high_tmp_318312;
        }
        init_idx_318137 = loop_while_318245;
        init_idx_318138 = low_318246;
        init_idx_318139 = high_318247;
        
        bool idx_318158;
        int64_t idx_318159;
        int64_t idx_318160;
        int64_t idx_318161;
        bool loop_while_318263;
        int64_t l_idx_318264;
        int64_t r_idx_318265;
        int64_t span_318266;
        
        loop_while_318263 = loop_cond_292931;
        l_idx_318264 = init_idx_318138;
        r_idx_318265 = init_idx_318138;
        span_318266 = (int64_t) 1;
        while (loop_while_318263) {
            int64_t max_arg_318267 = sub64(l_idx_318264, (int64_t) 1);
            int64_t max_res_318268 = smax64((int64_t) 0, max_arg_318267);
            int64_t min_arg_318269 = add64((int64_t) 1, r_idx_318265);
            int64_t min_res_318270 = smin64(min_arg_317746, min_arg_318269);
            bool x_318271 = sle64((int64_t) 0, max_res_318268);
            bool y_318272 = slt64(max_res_318268, defunc_0_f_res_292820);
            bool bounds_check_318273 = x_318271 && y_318272;
            bool index_certs_318274;
            
            if (!bounds_check_318273) {
                ctx->error =
                    msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                              "Index [", (long long) max_res_318268,
                              "] out of bounds for array of shape [",
                              (long long) defunc_0_f_res_292820, "].",
                              "-> #0  loess.fut:655:35-48\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:638:3-665:10\n   #5  loess.fut:712:15-50\n   #6  stl.fut:140:20-80\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:139:12-141:40\n   #10 /prelude/soacs.fut:67:19-23\n   #11 /prelude/soacs.fut:67:3-37\n   #12 stl.fut:138:5-142:36\n   #13 stl.fut:419:61-435:77\n   #14 stl.fut:463:3-479:36\n   #15 stl.fut:445:1-479:36\n");
                err = FUTHARK_PROGRAM_ERROR;
                goto cleanup;
            }
            
            int64_t x_318275;
            
            x_318275 = ((int64_t *) mem_317740.mem)[max_res_318268];
            
            int64_t abs_arg_318276 = sub64(x_318275, defunc_0_m_fun_res_318128);
            int64_t abs_res_318277 = abs64(abs_arg_318276);
            bool x_318278 = sle64((int64_t) 0, min_res_318270);
            bool y_318279 = slt64(min_res_318270, defunc_0_f_res_292820);
            bool bounds_check_318280 = x_318278 && y_318279;
            bool index_certs_318281;
            
            if (!bounds_check_318280) {
                ctx->error =
                    msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                              "Index [", (long long) min_res_318270,
                              "] out of bounds for array of shape [",
                              (long long) defunc_0_f_res_292820, "].",
                              "-> #0  loess.fut:656:35-48\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:638:3-665:10\n   #5  loess.fut:712:15-50\n   #6  stl.fut:140:20-80\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:139:12-141:40\n   #10 /prelude/soacs.fut:67:19-23\n   #11 /prelude/soacs.fut:67:3-37\n   #12 stl.fut:138:5-142:36\n   #13 stl.fut:419:61-435:77\n   #14 stl.fut:463:3-479:36\n   #15 stl.fut:445:1-479:36\n");
                err = FUTHARK_PROGRAM_ERROR;
                goto cleanup;
            }
            
            int64_t x_318282;
            
            x_318282 = ((int64_t *) mem_317740.mem)[min_res_318270];
            
            int64_t abs_arg_318283 = sub64(x_318282, defunc_0_m_fun_res_318128);
            int64_t abs_res_318284 = abs64(abs_arg_318283);
            bool cond_318285 = max_res_318268 == l_idx_318264;
            int64_t loopres_318286;
            int64_t loopres_318287;
            int64_t loopres_318288;
            
            if (cond_318285) {
                loopres_318286 = l_idx_318264;
                loopres_318287 = r_idx_318265;
                loopres_318288 = min_res_292926;
            } else {
                bool cond_318289 = slt64(abs_res_318277, abs_res_318284);
                bool cond_f_res_318290 = min_res_318270 == r_idx_318265;
                bool x_318291 = !cond_318289;
                bool y_318292 = cond_f_res_318290 && x_318291;
                bool cond_318293 = cond_318289 || y_318292;
                int64_t loopres_f_res_318294;
                
                if (cond_318293) {
                    loopres_f_res_318294 = max_res_318268;
                } else {
                    loopres_f_res_318294 = l_idx_318264;
                }
                
                int64_t loopres_f_res_318295;
                
                if (cond_318293) {
                    loopres_f_res_318295 = r_idx_318265;
                } else {
                    loopres_f_res_318295 = min_res_318270;
                }
                
                int64_t loopres_f_res_318296;
                
                if (cond_318293) {
                    int64_t loopres_f_res_t_res_318297 = add64((int64_t) 1,
                                                               span_318266);
                    
                    loopres_f_res_318296 = loopres_f_res_t_res_318297;
                } else {
                    int64_t loopres_f_res_f_res_318298 = add64((int64_t) 1,
                                                               span_318266);
                    
                    loopres_f_res_318296 = loopres_f_res_f_res_318298;
                }
                loopres_318286 = loopres_f_res_318294;
                loopres_318287 = loopres_f_res_318295;
                loopres_318288 = loopres_f_res_318296;
            }
            
            bool loop_cond_318299 = slt64(loopres_318288, min_res_292926);
            bool loop_while_tmp_318313 = loop_cond_318299;
            int64_t l_idx_tmp_318314 = loopres_318286;
            int64_t r_idx_tmp_318315 = loopres_318287;
            int64_t span_tmp_318316 = loopres_318288;
            
            loop_while_318263 = loop_while_tmp_318313;
            l_idx_318264 = l_idx_tmp_318314;
            r_idx_318265 = r_idx_tmp_318315;
            span_318266 = span_tmp_318316;
        }
        idx_318158 = loop_while_318263;
        idx_318159 = l_idx_318264;
        idx_318160 = r_idx_318265;
        idx_318161 = span_318266;
        
        int64_t min_res_318199 = smin64(min_arg_317747, idx_318159);
        int64_t max_res_318200 = smax64((int64_t) 0, min_res_318199);
        int64_t defunc_0_m_fun_res_318201;
        
        if (cond_318127) {
            defunc_0_m_fun_res_318201 = (int64_t) 0;
        } else {
            int64_t y_318300 = sub64(s_n_m_292825, (int64_t) 1);
            bool cond_318301 = gtid_318126 == y_318300;
            int64_t defunc_0_m_fun_res_f_res_318302;
            
            if (cond_318301) {
                int64_t defunc_0_m_fun_res_f_res_t_res_318303 =
                        sub64(pad_css_len_292821, (int64_t) 1);
                
                defunc_0_m_fun_res_f_res_318302 =
                    defunc_0_m_fun_res_f_res_t_res_318303;
            } else {
                int64_t x_318304 = sub64(gtid_318126, (int64_t) 1);
                int64_t x_318305 = mul64(jump_s_292684, x_318304);
                int64_t min_arg_318306 = add64((int64_t) 1, x_318305);
                int64_t min_res_318307 = smin64(defunc_0_f_res_292820,
                                                min_arg_318306);
                
                defunc_0_m_fun_res_f_res_318302 = min_res_318307;
            }
            defunc_0_m_fun_res_318201 = defunc_0_m_fun_res_f_res_318302;
        }
        
        int64_t x_318210 = add64(min_res_317748, max_res_318200);
        int64_t r_318211 = sub64(x_318210, (int64_t) 1);
        bool x_318212 = sle64((int64_t) 0, r_318211);
        bool y_318213 = slt64(r_318211, defunc_0_f_res_292820);
        bool bounds_check_318214 = x_318212 && y_318213;
        bool index_certs_318215;
        
        if (!bounds_check_318214) {
            ctx->error = msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                   "Index [", (long long) r_318211,
                                   "] out of bounds for array of shape [",
                                   (long long) defunc_0_f_res_292820, "].",
                                   "-> #0  loess.fut:680:40-47\n   #1  /prelude/soacs.fut:67:19-23\n   #2  /prelude/soacs.fut:67:3-37\n   #3  loess.fut:675:3-683:25\n   #4  loess.fut:713:16-54\n   #5  stl.fut:140:20-80\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  stl.fut:139:12-141:40\n   #9  /prelude/soacs.fut:67:19-23\n   #10 /prelude/soacs.fut:67:3-37\n   #11 stl.fut:138:5-142:36\n   #12 stl.fut:419:61-435:77\n   #13 stl.fut:463:3-479:36\n   #14 stl.fut:445:1-479:36\n");
            err = FUTHARK_PROGRAM_ERROR;
            goto cleanup;
        }
        
        int64_t x_318216;
        
        x_318216 = ((int64_t *) mem_317740.mem)[r_318211];
        
        int64_t abs_arg_318217 = sub64(x_318216, defunc_0_m_fun_res_318201);
        int64_t abs_res_318218 = abs64(abs_arg_318217);
        bool x_318219 = sle64((int64_t) 0, max_res_318200);
        bool y_318220 = slt64(max_res_318200, defunc_0_f_res_292820);
        bool bounds_check_318221 = x_318219 && y_318220;
        bool index_certs_318222;
        
        if (!bounds_check_318221) {
            ctx->error = msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                   "Index [", (long long) max_res_318200,
                                   "] out of bounds for array of shape [",
                                   (long long) defunc_0_f_res_292820, "].",
                                   "-> #0  loess.fut:679:40-47\n   #1  /prelude/soacs.fut:67:19-23\n   #2  /prelude/soacs.fut:67:3-37\n   #3  loess.fut:675:3-683:25\n   #4  loess.fut:713:16-54\n   #5  stl.fut:140:20-80\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  stl.fut:139:12-141:40\n   #9  /prelude/soacs.fut:67:19-23\n   #10 /prelude/soacs.fut:67:3-37\n   #11 stl.fut:138:5-142:36\n   #12 stl.fut:419:61-435:77\n   #13 stl.fut:463:3-479:36\n   #14 stl.fut:445:1-479:36\n");
            err = FUTHARK_PROGRAM_ERROR;
            goto cleanup;
        }
        
        int64_t x_318223;
        
        x_318223 = ((int64_t *) mem_317740.mem)[max_res_318200];
        
        int64_t abs_arg_318224 = sub64(x_318223, defunc_0_m_fun_res_318201);
        int64_t abs_res_318225 = abs64(abs_arg_318224);
        int64_t max_res_318226 = smax64(abs_res_318218, abs_res_318225);
        double defunc_0_f_res_318227 = sitofp_i64_f64(max_res_318226);
        double defunc_1_f_res_318228 = max_res_317752 + defunc_0_f_res_318227;
        
        ((double *) mem_317753.mem)[gtid_318126] = defunc_1_f_res_318228;
        ((int64_t *) mem_317754.mem)[gtid_318126] = max_res_318200;
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_337843_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_337843_end -
                 futhark_mc_segmap_parloop_337843_start;
        
        ctx->futhark_mc_segmap_parloop_337843_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_337843_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_337843_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_337841(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_318125 = tid;
    int num_tasks_318235 = info.nsubtasks;
    struct futhark_mc_task_337840 *futhark_mc_task_337840 =
                                  (struct futhark_mc_task_337840 *) args;
    struct futhark_context *ctx = futhark_mc_task_337840->ctx;
    uint64_t futhark_mc_segmap_task_337841_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_337841_start = get_wall_time();
    
    int64_t jump_s_292684 = futhark_mc_task_337840->free_jump_s_292684;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_337840->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_task_337840->free_pad_css_len_292821;
    int64_t s_n_m_292825 = futhark_mc_task_337840->free_s_n_m_292825;
    int64_t i_292895 = futhark_mc_task_337840->free_i_292895;
    bool x_292896 = futhark_mc_task_337840->free_x_292896;
    int64_t min_res_292926 = futhark_mc_task_337840->free_min_res_292926;
    bool loop_cond_292931 = futhark_mc_task_337840->free_loop_cond_292931;
    struct memblock mem_317740 = {.desc ="mem_317740", .mem =
                                  futhark_mc_task_337840->free_mem_317740,
                                  .size =0, .references =NULL};
    int64_t min_arg_317746 = futhark_mc_task_337840->free_min_arg_317746;
    int64_t min_arg_317747 = futhark_mc_task_337840->free_min_arg_317747;
    int64_t min_res_317748 = futhark_mc_task_337840->free_min_res_317748;
    double max_res_317752 = futhark_mc_task_337840->free_max_res_317752;
    struct memblock mem_317753 = {.desc ="mem_317753", .mem =
                                  futhark_mc_task_337840->free_mem_317753,
                                  .size =0, .references =NULL};
    struct memblock mem_317754 = {.desc ="mem_317754", .mem =
                                  futhark_mc_task_337840->free_mem_317754,
                                  .size =0, .references =NULL};
    int64_t iter_318236;
    struct futhark_mc_segmap_parloop_struct_337842
    futhark_mc_segmap_parloop_struct_337842;
    
    futhark_mc_segmap_parloop_struct_337842.ctx = ctx;
    futhark_mc_segmap_parloop_struct_337842.free_jump_s_292684 = jump_s_292684;
    futhark_mc_segmap_parloop_struct_337842.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segmap_parloop_struct_337842.free_pad_css_len_292821 =
        pad_css_len_292821;
    futhark_mc_segmap_parloop_struct_337842.free_s_n_m_292825 = s_n_m_292825;
    futhark_mc_segmap_parloop_struct_337842.free_i_292895 = i_292895;
    futhark_mc_segmap_parloop_struct_337842.free_x_292896 = x_292896;
    futhark_mc_segmap_parloop_struct_337842.free_min_res_292926 =
        min_res_292926;
    futhark_mc_segmap_parloop_struct_337842.free_loop_cond_292931 =
        loop_cond_292931;
    futhark_mc_segmap_parloop_struct_337842.free_mem_317740 = mem_317740.mem;
    futhark_mc_segmap_parloop_struct_337842.free_min_arg_317746 =
        min_arg_317746;
    futhark_mc_segmap_parloop_struct_337842.free_min_arg_317747 =
        min_arg_317747;
    futhark_mc_segmap_parloop_struct_337842.free_min_res_317748 =
        min_res_317748;
    futhark_mc_segmap_parloop_struct_337842.free_max_res_317752 =
        max_res_317752;
    futhark_mc_segmap_parloop_struct_337842.free_mem_317753 = mem_317753.mem;
    futhark_mc_segmap_parloop_struct_337842.free_mem_317754 = mem_317754.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_337843_task;
    
    futhark_mc_segmap_parloop_337843_task.name =
        "futhark_mc_segmap_parloop_337843";
    futhark_mc_segmap_parloop_337843_task.fn = futhark_mc_segmap_parloop_337843;
    futhark_mc_segmap_parloop_337843_task.args =
        &futhark_mc_segmap_parloop_struct_337842;
    futhark_mc_segmap_parloop_337843_task.iterations = iterations;
    futhark_mc_segmap_parloop_337843_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_337843_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_337843_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_337843_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_337843_task);
    
    if (futhark_mc_segmap_parloop_337843_err != 0) {
        err = futhark_mc_segmap_parloop_337843_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_337843_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_337843_total_end -
                 futhark_mc_segmap_parloop_337843_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337843_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337843_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337843_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_337841_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_337841_end -
                 futhark_mc_segmap_task_337841_start;
        
        ctx->futhark_mc_segmap_task_337841_runs[tid]++;
        ctx->futhark_mc_segmap_task_337841_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_337841_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
static int futhark_mc_segmap_parloop_337832(void *args, int64_t start,
                                            int64_t end, int flat_tid_317737,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_337831
    *futhark_mc_segmap_parloop_struct_337831 =
    (struct futhark_mc_segmap_parloop_struct_337831 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_337831->ctx;
    uint64_t futhark_mc_segmap_parloop_337832_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_337832_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segmap_parloop_struct_337831->free_n_p_292677;
    int64_t q_s_292678 =
            futhark_mc_segmap_parloop_struct_337831->free_q_s_292678;
    int64_t jump_s_292684 =
            futhark_mc_segmap_parloop_struct_337831->free_jump_s_292684;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segmap_parloop_struct_337831->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_segmap_parloop_struct_337831->free_pad_css_len_292821;
    int64_t s_n_m_292825 =
            futhark_mc_segmap_parloop_struct_337831->free_s_n_m_292825;
    int64_t i_292895 = futhark_mc_segmap_parloop_struct_337831->free_i_292895;
    bool x_292896 = futhark_mc_segmap_parloop_struct_337831->free_x_292896;
    int64_t min_res_292926 =
            futhark_mc_segmap_parloop_struct_337831->free_min_res_292926;
    bool loop_cond_292931 =
         futhark_mc_segmap_parloop_struct_337831->free_loop_cond_292931;
    double i64_res_292932 =
           futhark_mc_segmap_parloop_struct_337831->free_i64_res_292932;
    int64_t gtid_297783 =
            futhark_mc_segmap_parloop_struct_337831->free_gtid_297783;
    int64_t bytes_312641 =
            futhark_mc_segmap_parloop_struct_337831->free_bytes_312641;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_segmap_parloop_struct_337831->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_312842 = {.desc ="mem_312842", .mem =
                                  futhark_mc_segmap_parloop_struct_337831->free_mem_312842,
                                  .size =0, .references =NULL};
    int64_t bytes_312847 =
            futhark_mc_segmap_parloop_struct_337831->free_bytes_312847;
    struct memblock mem_312900 = {.desc ="mem_312900", .mem =
                                  futhark_mc_segmap_parloop_struct_337831->free_mem_312900,
                                  .size =0, .references =NULL};
    struct memblock mem_312904 = {.desc ="mem_312904", .mem =
                                  futhark_mc_segmap_parloop_struct_337831->free_mem_312904,
                                  .size =0, .references =NULL};
    size_t mem_317740_cached_sizze_337833 = 0;
    unsigned char *mem_317740 = NULL;
    size_t mem_317753_cached_sizze_337834 = 0;
    unsigned char *mem_317753 = NULL;
    size_t mem_317754_cached_sizze_337835 = 0;
    unsigned char *mem_317754 = NULL;
    int64_t iterations = end - start;
    int64_t iter_318120 = start;
    
    if (mem_317740_cached_sizze_337833 < (size_t) bytes_312641) {
        mem_317740 = realloc(mem_317740, bytes_312641);
        mem_317740_cached_sizze_337833 = bytes_312641;
    }
    if (mem_317753_cached_sizze_337834 < (size_t) bytes_312847) {
        mem_317753 = realloc(mem_317753, bytes_312847);
        mem_317753_cached_sizze_337834 = bytes_312847;
    }
    if (mem_317754_cached_sizze_337835 < (size_t) bytes_312847) {
        mem_317754 = realloc(mem_317754, bytes_312847);
        mem_317754_cached_sizze_337835 = bytes_312847;
    }
    for (; iter_318120 < end; iter_318120++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_318229 = n_p_292677;
        int64_t gtid_317738 = iter_318120;
        int64_t remnant_318230 = iter_318120 - gtid_317738;
        int64_t x_317739;
        
        x_317739 = ((int64_t *) mem_312842.mem)[gtid_297783 * n_p_292677 +
                                                gtid_317738];
        
        int64_t flat_tid_318121 = (int64_t) 0;
        int32_t num_tasks_318231;
        struct futhark_mc_task_337836 futhark_mc_task_337836;
        
        futhark_mc_task_337836.ctx = ctx;
        futhark_mc_task_337836.free_n_p_292677 = n_p_292677;
        futhark_mc_task_337836.free_defunc_0_f_res_292820 =
            defunc_0_f_res_292820;
        futhark_mc_task_337836.free_gtid_297783 = gtid_297783;
        futhark_mc_task_337836.free_mem_312838 = mem_312838.mem;
        futhark_mc_task_337836.free_gtid_317738 = gtid_317738;
        futhark_mc_task_337836.free_mem_317740 = mem_317740;
        
        struct scheduler_segop futhark_mc_task_337836_task;
        
        futhark_mc_task_337836_task.args = &futhark_mc_task_337836;
        futhark_mc_task_337836_task.top_level_fn =
            futhark_mc_segmap_task_337837;
        futhark_mc_task_337836_task.name = "futhark_mc_segmap_task_337837";
        futhark_mc_task_337836_task.iterations = defunc_0_f_res_292820;
        futhark_mc_task_337836_task.task_time =
            &ctx->futhark_mc_segmap_task_337837_total_time;
        futhark_mc_task_337836_task.task_iter =
            &ctx->futhark_mc_segmap_task_337837_total_iter;
        futhark_mc_task_337836_task.sched = STATIC;
        futhark_mc_task_337836_task.nested_fn = NULL;
        
        int futhark_mc_segmap_task_337837_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_337836_task);
        
        if (futhark_mc_segmap_task_337837_err != 0) {
            ;
            err = futhark_mc_segmap_task_337837_err;
            goto cleanup;
        }
        
        int64_t min_arg_317746 = sub64(x_317739, (int64_t) 1);
        int64_t min_arg_317747 = sub64(x_317739, min_res_292926);
        int64_t min_res_317748 = smin64(q_s_292678, x_317739);
        double i64_res_317749 = sitofp_i64_f64(x_317739);
        double x_317750 = i64_res_292932 - i64_res_317749;
        double max_arg_317751 = x_317750 / 2.0;
        double max_res_317752 = fmax64(0.0, max_arg_317751);
        int64_t flat_tid_318125 = (int64_t) 0;
        int32_t num_tasks_318235;
        struct futhark_mc_task_337840 futhark_mc_task_337840;
        
        futhark_mc_task_337840.ctx = ctx;
        futhark_mc_task_337840.free_jump_s_292684 = jump_s_292684;
        futhark_mc_task_337840.free_defunc_0_f_res_292820 =
            defunc_0_f_res_292820;
        futhark_mc_task_337840.free_pad_css_len_292821 = pad_css_len_292821;
        futhark_mc_task_337840.free_s_n_m_292825 = s_n_m_292825;
        futhark_mc_task_337840.free_i_292895 = i_292895;
        futhark_mc_task_337840.free_x_292896 = x_292896;
        futhark_mc_task_337840.free_min_res_292926 = min_res_292926;
        futhark_mc_task_337840.free_loop_cond_292931 = loop_cond_292931;
        futhark_mc_task_337840.free_mem_317740 = mem_317740;
        futhark_mc_task_337840.free_min_arg_317746 = min_arg_317746;
        futhark_mc_task_337840.free_min_arg_317747 = min_arg_317747;
        futhark_mc_task_337840.free_min_res_317748 = min_res_317748;
        futhark_mc_task_337840.free_max_res_317752 = max_res_317752;
        futhark_mc_task_337840.free_mem_317753 = mem_317753;
        futhark_mc_task_337840.free_mem_317754 = mem_317754;
        
        struct scheduler_segop futhark_mc_task_337840_task;
        
        futhark_mc_task_337840_task.args = &futhark_mc_task_337840;
        futhark_mc_task_337840_task.top_level_fn =
            futhark_mc_segmap_task_337841;
        futhark_mc_task_337840_task.name = "futhark_mc_segmap_task_337841";
        futhark_mc_task_337840_task.iterations = s_n_m_292825;
        futhark_mc_task_337840_task.task_time =
            &ctx->futhark_mc_segmap_task_337841_total_time;
        futhark_mc_task_337840_task.task_iter =
            &ctx->futhark_mc_segmap_task_337841_total_iter;
        futhark_mc_task_337840_task.sched = DYNAMIC;
        futhark_mc_task_337840_task.nested_fn = NULL;
        
        int futhark_mc_segmap_task_337841_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_337840_task);
        
        if (futhark_mc_segmap_task_337841_err != 0) {
            ;
            err = futhark_mc_segmap_task_337841_err;
            goto cleanup;
        }
        if (s_n_m_292825 * (int64_t) 8 > 0)
            memmove(mem_312900.mem + gtid_317738 * s_n_m_292825 * (int64_t) 8,
                    mem_317754 + (int64_t) 0, s_n_m_292825 * (int64_t) 8);
        if (s_n_m_292825 * (int64_t) 8 > 0)
            memmove(mem_312904.mem + gtid_317738 * s_n_m_292825 * (int64_t) 8,
                    mem_317753 + (int64_t) 0, s_n_m_292825 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_317740);
    free(mem_317753);
    free(mem_317754);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_337832_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_337832_end -
                 futhark_mc_segmap_parloop_337832_start;
        
        ctx->futhark_mc_segmap_parloop_337832_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_337832_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_337832_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_nested_task_337830(void *args, int64_t iterations,
                                         int tid, struct scheduler_info info)
{
    int err = 0;
    int flat_tid_317737 = tid;
    int num_tasks_317994 = info.nsubtasks;
    struct futhark_mc_task_337823 *futhark_mc_task_337823 =
                                  (struct futhark_mc_task_337823 *) args;
    struct futhark_context *ctx = futhark_mc_task_337823->ctx;
    uint64_t futhark_mc_segmap_nested_task_337830_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_nested_task_337830_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_337823->free_n_p_292677;
    int64_t q_s_292678 = futhark_mc_task_337823->free_q_s_292678;
    int64_t jump_s_292684 = futhark_mc_task_337823->free_jump_s_292684;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_337823->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_task_337823->free_pad_css_len_292821;
    int64_t s_n_m_292825 = futhark_mc_task_337823->free_s_n_m_292825;
    int64_t i_292895 = futhark_mc_task_337823->free_i_292895;
    bool x_292896 = futhark_mc_task_337823->free_x_292896;
    int64_t min_res_292926 = futhark_mc_task_337823->free_min_res_292926;
    bool loop_cond_292931 = futhark_mc_task_337823->free_loop_cond_292931;
    double i64_res_292932 = futhark_mc_task_337823->free_i64_res_292932;
    int64_t gtid_297783 = futhark_mc_task_337823->free_gtid_297783;
    int64_t bytes_312641 = futhark_mc_task_337823->free_bytes_312641;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_task_337823->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_312842 = {.desc ="mem_312842", .mem =
                                  futhark_mc_task_337823->free_mem_312842,
                                  .size =0, .references =NULL};
    int64_t bytes_312847 = futhark_mc_task_337823->free_bytes_312847;
    struct memblock mem_312900 = {.desc ="mem_312900", .mem =
                                  futhark_mc_task_337823->free_mem_312900,
                                  .size =0, .references =NULL};
    struct memblock mem_312904 = {.desc ="mem_312904", .mem =
                                  futhark_mc_task_337823->free_mem_312904,
                                  .size =0, .references =NULL};
    int64_t iter_318120;
    struct futhark_mc_segmap_parloop_struct_337831
    futhark_mc_segmap_parloop_struct_337831;
    
    futhark_mc_segmap_parloop_struct_337831.ctx = ctx;
    futhark_mc_segmap_parloop_struct_337831.free_n_p_292677 = n_p_292677;
    futhark_mc_segmap_parloop_struct_337831.free_q_s_292678 = q_s_292678;
    futhark_mc_segmap_parloop_struct_337831.free_jump_s_292684 = jump_s_292684;
    futhark_mc_segmap_parloop_struct_337831.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segmap_parloop_struct_337831.free_pad_css_len_292821 =
        pad_css_len_292821;
    futhark_mc_segmap_parloop_struct_337831.free_s_n_m_292825 = s_n_m_292825;
    futhark_mc_segmap_parloop_struct_337831.free_i_292895 = i_292895;
    futhark_mc_segmap_parloop_struct_337831.free_x_292896 = x_292896;
    futhark_mc_segmap_parloop_struct_337831.free_min_res_292926 =
        min_res_292926;
    futhark_mc_segmap_parloop_struct_337831.free_loop_cond_292931 =
        loop_cond_292931;
    futhark_mc_segmap_parloop_struct_337831.free_i64_res_292932 =
        i64_res_292932;
    futhark_mc_segmap_parloop_struct_337831.free_gtid_297783 = gtid_297783;
    futhark_mc_segmap_parloop_struct_337831.free_bytes_312641 = bytes_312641;
    futhark_mc_segmap_parloop_struct_337831.free_mem_312838 = mem_312838.mem;
    futhark_mc_segmap_parloop_struct_337831.free_mem_312842 = mem_312842.mem;
    futhark_mc_segmap_parloop_struct_337831.free_bytes_312847 = bytes_312847;
    futhark_mc_segmap_parloop_struct_337831.free_mem_312900 = mem_312900.mem;
    futhark_mc_segmap_parloop_struct_337831.free_mem_312904 = mem_312904.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_337832_task;
    
    futhark_mc_segmap_parloop_337832_task.name =
        "futhark_mc_segmap_parloop_337832";
    futhark_mc_segmap_parloop_337832_task.fn = futhark_mc_segmap_parloop_337832;
    futhark_mc_segmap_parloop_337832_task.args =
        &futhark_mc_segmap_parloop_struct_337831;
    futhark_mc_segmap_parloop_337832_task.iterations = iterations;
    futhark_mc_segmap_parloop_337832_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_337832_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_337832_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_337832_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_337832_task);
    
    if (futhark_mc_segmap_parloop_337832_err != 0) {
        err = futhark_mc_segmap_parloop_337832_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_337832_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_337832_total_end -
                 futhark_mc_segmap_parloop_337832_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337832_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337832_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337832_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_nested_task_337830_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_nested_task_337830_end -
                 futhark_mc_segmap_nested_task_337830_start;
        
        ctx->futhark_mc_segmap_nested_task_337830_runs[tid]++;
        ctx->futhark_mc_segmap_nested_task_337830_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_nested_task_337830_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
static int futhark_mc_segmap_parloop_337820(void *args, int64_t start,
                                            int64_t end, int flat_tid_297782,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_337819
    *futhark_mc_segmap_parloop_struct_337819 =
    (struct futhark_mc_segmap_parloop_struct_337819 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_337819->ctx;
    uint64_t futhark_mc_segmap_parloop_337820_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_337820_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segmap_parloop_struct_337819->free_n_p_292677;
    int64_t q_s_292678 =
            futhark_mc_segmap_parloop_struct_337819->free_q_s_292678;
    int64_t jump_s_292684 =
            futhark_mc_segmap_parloop_struct_337819->free_jump_s_292684;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_337819->free_partition_sizze_292766;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segmap_parloop_struct_337819->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_segmap_parloop_struct_337819->free_pad_css_len_292821;
    int64_t s_n_m_292825 =
            futhark_mc_segmap_parloop_struct_337819->free_s_n_m_292825;
    int64_t i_292895 = futhark_mc_segmap_parloop_struct_337819->free_i_292895;
    bool x_292896 = futhark_mc_segmap_parloop_struct_337819->free_x_292896;
    int64_t min_res_292926 =
            futhark_mc_segmap_parloop_struct_337819->free_min_res_292926;
    bool loop_cond_292931 =
         futhark_mc_segmap_parloop_struct_337819->free_loop_cond_292931;
    double i64_res_292932 =
           futhark_mc_segmap_parloop_struct_337819->free_i64_res_292932;
    int64_t bytes_312641 =
            futhark_mc_segmap_parloop_struct_337819->free_bytes_312641;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_segmap_parloop_struct_337819->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_312842 = {.desc ="mem_312842", .mem =
                                  futhark_mc_segmap_parloop_struct_337819->free_mem_312842,
                                  .size =0, .references =NULL};
    int64_t bytes_312847 =
            futhark_mc_segmap_parloop_struct_337819->free_bytes_312847;
    int64_t bytes_312899 =
            futhark_mc_segmap_parloop_struct_337819->free_bytes_312899;
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_segmap_parloop_struct_337819->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_segmap_parloop_struct_337819->free_mem_313023,
                                  .size =0, .references =NULL};
    size_t mem_312900_cached_sizze_337821 = 0;
    unsigned char *mem_312900 = NULL;
    size_t mem_312904_cached_sizze_337822 = 0;
    unsigned char *mem_312904 = NULL;
    int64_t iterations = end - start;
    int64_t iter_317736 = start;
    
    if (mem_312900_cached_sizze_337821 < (size_t) bytes_312899) {
        mem_312900 = realloc(mem_312900, bytes_312899);
        mem_312900_cached_sizze_337821 = bytes_312899;
    }
    if (mem_312904_cached_sizze_337822 < (size_t) bytes_312899) {
        mem_312904 = realloc(mem_312904, bytes_312899);
        mem_312904_cached_sizze_337822 = bytes_312899;
    }
    for (; iter_317736 < end; iter_317736++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_317992 = partition_sizze_292766;
        int64_t gtid_297783 = iter_317736;
        int64_t remnant_317993 = iter_317736 - gtid_297783;
        int64_t flat_tid_317861 = (int64_t) 0;
        int32_t num_tasks_317994;
        int64_t flat_tid_317737 = (int64_t) 0;
        struct futhark_mc_task_337823 futhark_mc_task_337823;
        
        futhark_mc_task_337823.ctx = ctx;
        futhark_mc_task_337823.free_n_p_292677 = n_p_292677;
        futhark_mc_task_337823.free_q_s_292678 = q_s_292678;
        futhark_mc_task_337823.free_jump_s_292684 = jump_s_292684;
        futhark_mc_task_337823.free_defunc_0_f_res_292820 =
            defunc_0_f_res_292820;
        futhark_mc_task_337823.free_pad_css_len_292821 = pad_css_len_292821;
        futhark_mc_task_337823.free_s_n_m_292825 = s_n_m_292825;
        futhark_mc_task_337823.free_i_292895 = i_292895;
        futhark_mc_task_337823.free_x_292896 = x_292896;
        futhark_mc_task_337823.free_min_res_292926 = min_res_292926;
        futhark_mc_task_337823.free_loop_cond_292931 = loop_cond_292931;
        futhark_mc_task_337823.free_i64_res_292932 = i64_res_292932;
        futhark_mc_task_337823.free_gtid_297783 = gtid_297783;
        futhark_mc_task_337823.free_bytes_312641 = bytes_312641;
        futhark_mc_task_337823.free_mem_312838 = mem_312838.mem;
        futhark_mc_task_337823.free_mem_312842 = mem_312842.mem;
        futhark_mc_task_337823.free_bytes_312847 = bytes_312847;
        futhark_mc_task_337823.free_mem_312900 = mem_312900;
        futhark_mc_task_337823.free_mem_312904 = mem_312904;
        
        struct scheduler_segop futhark_mc_task_337823_task;
        
        futhark_mc_task_337823_task.args = &futhark_mc_task_337823;
        futhark_mc_task_337823_task.top_level_fn =
            futhark_mc_segmap_task_337824;
        futhark_mc_task_337823_task.name = "futhark_mc_segmap_task_337824";
        futhark_mc_task_337823_task.iterations = n_p_292677;
        futhark_mc_task_337823_task.task_time =
            &ctx->futhark_mc_segmap_task_337824_total_time;
        futhark_mc_task_337823_task.task_iter =
            &ctx->futhark_mc_segmap_task_337824_total_iter;
        futhark_mc_task_337823_task.sched = DYNAMIC;
        futhark_mc_task_337823_task.nested_fn =
            futhark_mc_segmap_nested_task_337830;
        
        int futhark_mc_segmap_task_337824_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_337823_task);
        
        if (futhark_mc_segmap_task_337824_err != 0) {
            ;
            err = futhark_mc_segmap_task_337824_err;
            goto cleanup;
        }
        if (n_p_292677 * s_n_m_292825 * (int64_t) 8 > 0)
            memmove(mem_313018.mem + gtid_297783 * (s_n_m_292825 * n_p_292677) *
                    (int64_t) 8, mem_312900 + (int64_t) 0, n_p_292677 *
                    s_n_m_292825 * (int64_t) 8);
        if (n_p_292677 * s_n_m_292825 * (int64_t) 8 > 0)
            memmove(mem_313023.mem + gtid_297783 * (s_n_m_292825 * n_p_292677) *
                    (int64_t) 8, mem_312904 + (int64_t) 0, n_p_292677 *
                    s_n_m_292825 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_312900);
    free(mem_312904);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_337820_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_337820_end -
                 futhark_mc_segmap_parloop_337820_start;
        
        ctx->futhark_mc_segmap_parloop_337820_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_337820_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_337820_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_nested_task_337818(void *args, int64_t iterations,
                                         int tid, struct scheduler_info info)
{
    int err = 0;
    int flat_tid_297782 = tid;
    int num_tasks_317593 = info.nsubtasks;
    struct futhark_mc_task_337811 *futhark_mc_task_337811 =
                                  (struct futhark_mc_task_337811 *) args;
    struct futhark_context *ctx = futhark_mc_task_337811->ctx;
    uint64_t futhark_mc_segmap_nested_task_337818_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_nested_task_337818_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_337811->free_n_p_292677;
    int64_t q_s_292678 = futhark_mc_task_337811->free_q_s_292678;
    int64_t jump_s_292684 = futhark_mc_task_337811->free_jump_s_292684;
    int64_t partition_sizze_292766 =
            futhark_mc_task_337811->free_partition_sizze_292766;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_337811->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_task_337811->free_pad_css_len_292821;
    int64_t s_n_m_292825 = futhark_mc_task_337811->free_s_n_m_292825;
    int64_t i_292895 = futhark_mc_task_337811->free_i_292895;
    bool x_292896 = futhark_mc_task_337811->free_x_292896;
    int64_t min_res_292926 = futhark_mc_task_337811->free_min_res_292926;
    bool loop_cond_292931 = futhark_mc_task_337811->free_loop_cond_292931;
    double i64_res_292932 = futhark_mc_task_337811->free_i64_res_292932;
    int64_t bytes_312641 = futhark_mc_task_337811->free_bytes_312641;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_task_337811->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_312842 = {.desc ="mem_312842", .mem =
                                  futhark_mc_task_337811->free_mem_312842,
                                  .size =0, .references =NULL};
    int64_t bytes_312847 = futhark_mc_task_337811->free_bytes_312847;
    int64_t bytes_312899 = futhark_mc_task_337811->free_bytes_312899;
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_task_337811->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_task_337811->free_mem_313023,
                                  .size =0, .references =NULL};
    int64_t iter_317736;
    struct futhark_mc_segmap_parloop_struct_337819
    futhark_mc_segmap_parloop_struct_337819;
    
    futhark_mc_segmap_parloop_struct_337819.ctx = ctx;
    futhark_mc_segmap_parloop_struct_337819.free_n_p_292677 = n_p_292677;
    futhark_mc_segmap_parloop_struct_337819.free_q_s_292678 = q_s_292678;
    futhark_mc_segmap_parloop_struct_337819.free_jump_s_292684 = jump_s_292684;
    futhark_mc_segmap_parloop_struct_337819.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_337819.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segmap_parloop_struct_337819.free_pad_css_len_292821 =
        pad_css_len_292821;
    futhark_mc_segmap_parloop_struct_337819.free_s_n_m_292825 = s_n_m_292825;
    futhark_mc_segmap_parloop_struct_337819.free_i_292895 = i_292895;
    futhark_mc_segmap_parloop_struct_337819.free_x_292896 = x_292896;
    futhark_mc_segmap_parloop_struct_337819.free_min_res_292926 =
        min_res_292926;
    futhark_mc_segmap_parloop_struct_337819.free_loop_cond_292931 =
        loop_cond_292931;
    futhark_mc_segmap_parloop_struct_337819.free_i64_res_292932 =
        i64_res_292932;
    futhark_mc_segmap_parloop_struct_337819.free_bytes_312641 = bytes_312641;
    futhark_mc_segmap_parloop_struct_337819.free_mem_312838 = mem_312838.mem;
    futhark_mc_segmap_parloop_struct_337819.free_mem_312842 = mem_312842.mem;
    futhark_mc_segmap_parloop_struct_337819.free_bytes_312847 = bytes_312847;
    futhark_mc_segmap_parloop_struct_337819.free_bytes_312899 = bytes_312899;
    futhark_mc_segmap_parloop_struct_337819.free_mem_313018 = mem_313018.mem;
    futhark_mc_segmap_parloop_struct_337819.free_mem_313023 = mem_313023.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_337820_task;
    
    futhark_mc_segmap_parloop_337820_task.name =
        "futhark_mc_segmap_parloop_337820";
    futhark_mc_segmap_parloop_337820_task.fn = futhark_mc_segmap_parloop_337820;
    futhark_mc_segmap_parloop_337820_task.args =
        &futhark_mc_segmap_parloop_struct_337819;
    futhark_mc_segmap_parloop_337820_task.iterations = iterations;
    futhark_mc_segmap_parloop_337820_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_337820_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_337820_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_337820_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_337820_task);
    
    if (futhark_mc_segmap_parloop_337820_err != 0) {
        err = futhark_mc_segmap_parloop_337820_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_337820_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_337820_total_end -
                 futhark_mc_segmap_parloop_337820_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337820_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337820_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337820_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_nested_task_337818_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_nested_task_337818_end -
                 futhark_mc_segmap_nested_task_337818_start;
        
        ctx->futhark_mc_segmap_nested_task_337818_runs[tid]++;
        ctx->futhark_mc_segmap_nested_task_337818_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_nested_task_337818_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_task_337844 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_l_292680;
    int64_t free_jump_l_292686;
    int64_t free_partition_sizze_292766;
    int64_t free_l_n_m_292832;
    int64_t free_i_292846;
    bool free_x_292847;
    int64_t free_min_res_293058;
    bool free_loop_cond_293063;
    double free_i64_res_293064;
    int64_t free_bytes_312598;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_312639;
    int64_t free_bytes_313028;
    unsigned char *free_mem_313081;
    unsigned char *free_mem_313085;
};
struct futhark_mc_segmap_parloop_struct_337846 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_l_292680;
    int64_t free_jump_l_292686;
    int64_t free_partition_sizze_292766;
    int64_t free_l_n_m_292832;
    int64_t free_i_292846;
    bool free_x_292847;
    int64_t free_min_res_293058;
    bool free_loop_cond_293063;
    double free_i64_res_293064;
    int64_t free_bytes_312598;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_312639;
    int64_t free_bytes_313028;
    unsigned char *free_mem_313081;
    unsigned char *free_mem_313085;
};
static int futhark_mc_segmap_parloop_337847(void *args, int64_t start,
                                            int64_t end, int flat_tid_298030,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_337846
    *futhark_mc_segmap_parloop_struct_337846 =
    (struct futhark_mc_segmap_parloop_struct_337846 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_337846->ctx;
    uint64_t futhark_mc_segmap_parloop_337847_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_337847_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_337846->free_n_292675;
    int64_t q_l_292680 =
            futhark_mc_segmap_parloop_struct_337846->free_q_l_292680;
    int64_t jump_l_292686 =
            futhark_mc_segmap_parloop_struct_337846->free_jump_l_292686;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_337846->free_partition_sizze_292766;
    int64_t l_n_m_292832 =
            futhark_mc_segmap_parloop_struct_337846->free_l_n_m_292832;
    int64_t i_292846 = futhark_mc_segmap_parloop_struct_337846->free_i_292846;
    bool x_292847 = futhark_mc_segmap_parloop_struct_337846->free_x_292847;
    int64_t min_res_293058 =
            futhark_mc_segmap_parloop_struct_337846->free_min_res_293058;
    bool loop_cond_293063 =
         futhark_mc_segmap_parloop_struct_337846->free_loop_cond_293063;
    double i64_res_293064 =
           futhark_mc_segmap_parloop_struct_337846->free_i64_res_293064;
    int64_t bytes_312598 =
            futhark_mc_segmap_parloop_struct_337846->free_bytes_312598;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_segmap_parloop_struct_337846->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_312639 = {.desc ="mem_312639", .mem =
                                  futhark_mc_segmap_parloop_struct_337846->free_mem_312639,
                                  .size =0, .references =NULL};
    int64_t bytes_313028 =
            futhark_mc_segmap_parloop_struct_337846->free_bytes_313028;
    struct memblock mem_313081 = {.desc ="mem_313081", .mem =
                                  futhark_mc_segmap_parloop_struct_337846->free_mem_313081,
                                  .size =0, .references =NULL};
    struct memblock mem_313085 = {.desc ="mem_313085", .mem =
                                  futhark_mc_segmap_parloop_struct_337846->free_mem_313085,
                                  .size =0, .references =NULL};
    size_t mem_313035_cached_sizze_337848 = 0;
    unsigned char *mem_313035 = NULL;
    size_t mem_313050_cached_sizze_337849 = 0;
    unsigned char *mem_313050 = NULL;
    size_t mem_313053_cached_sizze_337850 = 0;
    unsigned char *mem_313053 = NULL;
    int64_t iterations = end - start;
    int64_t iter_318318 = start;
    
    if (mem_313035_cached_sizze_337848 < (size_t) bytes_312598) {
        mem_313035 = realloc(mem_313035, bytes_312598);
        mem_313035_cached_sizze_337848 = bytes_312598;
    }
    if (mem_313050_cached_sizze_337849 < (size_t) bytes_313028) {
        mem_313050 = realloc(mem_313050, bytes_313028);
        mem_313050_cached_sizze_337849 = bytes_313028;
    }
    if (mem_313053_cached_sizze_337850 < (size_t) bytes_313028) {
        mem_313053 = realloc(mem_313053, bytes_313028);
        mem_313053_cached_sizze_337850 = bytes_313028;
    }
    for (; iter_318318 < end; iter_318318++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_318415 = partition_sizze_292766;
        int64_t gtid_298031 = iter_318318;
        int64_t remnant_318416 = iter_318318 - gtid_298031;
        int64_t x_293068;
        
        x_293068 = ((int64_t *) mem_312639.mem)[gtid_298031];
        for (int64_t i_318319 = 0; i_318319 < n_292675; i_318319++) {
            int64_t x_318321;
            
            x_318321 = ((int64_t *) mem_312636.mem)[gtid_298031 * n_292675 +
                                                    i_318319];
            
            int64_t defunc_0_f_res_318322 = add64((int64_t) 1, x_318321);
            
            ((int64_t *) mem_313035)[i_318319] = defunc_0_f_res_318322;
        }
        
        int64_t min_arg_293072 = sub64(x_293068, (int64_t) 1);
        int64_t min_arg_293073 = sub64(x_293068, min_res_293058);
        int64_t min_res_293074 = smin64(q_l_292680, x_293068);
        double i64_res_293075 = sitofp_i64_f64(x_293068);
        double x_293076 = i64_res_293064 - i64_res_293075;
        double max_arg_293077 = x_293076 / 2.0;
        double max_res_293078 = fmax64(0.0, max_arg_293077);
        
        for (int64_t i_318324 = 0; i_318324 < l_n_m_292832; i_318324++) {
            int64_t min_arg_318327 = mul64(jump_l_292686, i_318324);
            int64_t min_res_318328 = smin64(i_292846, min_arg_318327);
            int64_t defunc_0_g_res_318329 = add64((int64_t) 1, min_res_318328);
            bool init_idx_318330;
            int64_t init_idx_318331;
            int64_t init_idx_318332;
            bool loop_while_318333;
            int64_t low_318334;
            int64_t high_318335;
            
            loop_while_318333 = x_292847;
            low_318334 = (int64_t) 0;
            high_318335 = i_292846;
            while (loop_while_318333) {
                int64_t x_318336 = add64(low_318334, high_318335);
                int64_t mid_318337 = sdiv64(x_318336, (int64_t) 2);
                bool x_318338 = sle64((int64_t) 0, mid_318337);
                bool y_318339 = slt64(mid_318337, n_292675);
                bool bounds_check_318340 = x_318338 && y_318339;
                bool index_certs_318341;
                
                if (!bounds_check_318340) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [", (long long) mid_318337,
                                  "] out of bounds for array of shape [",
                                  (long long) n_292675, "].",
                                  "-> #0  loess.fut:645:26-36\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:638:3-665:10\n   #5  loess.fut:698:15-61\n   #6  stl.fut:148:13-60\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:146:5-149:26\n   #10 stl.fut:419:61-435:77\n   #11 stl.fut:463:3-479:36\n   #12 stl.fut:445:1-479:36\n");
                    err = FUTHARK_PROGRAM_ERROR;
                    goto cleanup;
                }
                
                int64_t mid_id_318342;
                
                mid_id_318342 = ((int64_t *) mem_313035)[mid_318337];
                
                bool cond_318343 = slt64(mid_id_318342, (int64_t) 0);
                int64_t mid_idx_318344;
                
                if (cond_318343) {
                    mid_idx_318344 = (int64_t) 9223372036854775807;
                } else {
                    mid_idx_318344 = mid_id_318342;
                }
                
                bool cond_318345 = sle64(defunc_0_g_res_318329, mid_idx_318344);
                int64_t loopres_318346;
                int64_t loopres_318347;
                
                if (cond_318345) {
                    int64_t loopres_t_res_318348 = sub64(mid_318337,
                                                         (int64_t) 1);
                    
                    loopres_318346 = low_318334;
                    loopres_318347 = loopres_t_res_318348;
                } else {
                    int64_t loopres_f_res_318349 = add64((int64_t) 1,
                                                         mid_318337);
                    
                    loopres_318346 = loopres_f_res_318349;
                    loopres_318347 = high_318335;
                }
                
                bool loop_cond_318350 = sle64(loopres_318346, loopres_318347);
                bool loop_while_tmp_318420 = loop_cond_318350;
                int64_t low_tmp_318421 = loopres_318346;
                int64_t high_tmp_318422 = loopres_318347;
                
                loop_while_318333 = loop_while_tmp_318420;
                low_318334 = low_tmp_318421;
                high_318335 = high_tmp_318422;
            }
            init_idx_318330 = loop_while_318333;
            init_idx_318331 = low_318334;
            init_idx_318332 = high_318335;
            
            bool idx_318351;
            int64_t idx_318352;
            int64_t idx_318353;
            int64_t idx_318354;
            bool loop_while_318355;
            int64_t l_idx_318356;
            int64_t r_idx_318357;
            int64_t span_318358;
            
            loop_while_318355 = loop_cond_293063;
            l_idx_318356 = init_idx_318331;
            r_idx_318357 = init_idx_318331;
            span_318358 = (int64_t) 1;
            while (loop_while_318355) {
                int64_t max_arg_318359 = sub64(l_idx_318356, (int64_t) 1);
                int64_t max_res_318360 = smax64((int64_t) 0, max_arg_318359);
                int64_t min_arg_318361 = add64((int64_t) 1, r_idx_318357);
                int64_t min_res_318362 = smin64(min_arg_293072, min_arg_318361);
                bool x_318363 = sle64((int64_t) 0, max_res_318360);
                bool y_318364 = slt64(max_res_318360, n_292675);
                bool bounds_check_318365 = x_318363 && y_318364;
                bool index_certs_318366;
                
                if (!bounds_check_318365) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [", (long long) max_res_318360,
                                  "] out of bounds for array of shape [",
                                  (long long) n_292675, "].",
                                  "-> #0  loess.fut:655:35-48\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:638:3-665:10\n   #5  loess.fut:698:15-61\n   #6  stl.fut:148:13-60\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:146:5-149:26\n   #10 stl.fut:419:61-435:77\n   #11 stl.fut:463:3-479:36\n   #12 stl.fut:445:1-479:36\n");
                    err = FUTHARK_PROGRAM_ERROR;
                    goto cleanup;
                }
                
                int64_t x_318367;
                
                x_318367 = ((int64_t *) mem_313035)[max_res_318360];
                
                int64_t abs_arg_318368 = sub64(x_318367, defunc_0_g_res_318329);
                int64_t abs_res_318369 = abs64(abs_arg_318368);
                bool x_318370 = sle64((int64_t) 0, min_res_318362);
                bool y_318371 = slt64(min_res_318362, n_292675);
                bool bounds_check_318372 = x_318370 && y_318371;
                bool index_certs_318373;
                
                if (!bounds_check_318372) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [", (long long) min_res_318362,
                                  "] out of bounds for array of shape [",
                                  (long long) n_292675, "].",
                                  "-> #0  loess.fut:656:35-48\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:638:3-665:10\n   #5  loess.fut:698:15-61\n   #6  stl.fut:148:13-60\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:146:5-149:26\n   #10 stl.fut:419:61-435:77\n   #11 stl.fut:463:3-479:36\n   #12 stl.fut:445:1-479:36\n");
                    err = FUTHARK_PROGRAM_ERROR;
                    goto cleanup;
                }
                
                int64_t x_318374;
                
                x_318374 = ((int64_t *) mem_313035)[min_res_318362];
                
                int64_t abs_arg_318375 = sub64(x_318374, defunc_0_g_res_318329);
                int64_t abs_res_318376 = abs64(abs_arg_318375);
                bool cond_318377 = max_res_318360 == l_idx_318356;
                int64_t loopres_318378;
                int64_t loopres_318379;
                int64_t loopres_318380;
                
                if (cond_318377) {
                    loopres_318378 = l_idx_318356;
                    loopres_318379 = r_idx_318357;
                    loopres_318380 = min_res_293058;
                } else {
                    bool cond_318381 = slt64(abs_res_318369, abs_res_318376);
                    bool cond_f_res_318382 = min_res_318362 == r_idx_318357;
                    bool x_318383 = !cond_318381;
                    bool y_318384 = cond_f_res_318382 && x_318383;
                    bool cond_318385 = cond_318381 || y_318384;
                    int64_t loopres_f_res_318386;
                    
                    if (cond_318385) {
                        loopres_f_res_318386 = max_res_318360;
                    } else {
                        loopres_f_res_318386 = l_idx_318356;
                    }
                    
                    int64_t loopres_f_res_318387;
                    
                    if (cond_318385) {
                        loopres_f_res_318387 = r_idx_318357;
                    } else {
                        loopres_f_res_318387 = min_res_318362;
                    }
                    
                    int64_t loopres_f_res_318388;
                    
                    if (cond_318385) {
                        int64_t loopres_f_res_t_res_318389 = add64((int64_t) 1,
                                                                   span_318358);
                        
                        loopres_f_res_318388 = loopres_f_res_t_res_318389;
                    } else {
                        int64_t loopres_f_res_f_res_318390 = add64((int64_t) 1,
                                                                   span_318358);
                        
                        loopres_f_res_318388 = loopres_f_res_f_res_318390;
                    }
                    loopres_318378 = loopres_f_res_318386;
                    loopres_318379 = loopres_f_res_318387;
                    loopres_318380 = loopres_f_res_318388;
                }
                
                bool loop_cond_318391 = slt64(loopres_318380, min_res_293058);
                bool loop_while_tmp_318423 = loop_cond_318391;
                int64_t l_idx_tmp_318424 = loopres_318378;
                int64_t r_idx_tmp_318425 = loopres_318379;
                int64_t span_tmp_318426 = loopres_318380;
                
                loop_while_318355 = loop_while_tmp_318423;
                l_idx_318356 = l_idx_tmp_318424;
                r_idx_318357 = r_idx_tmp_318425;
                span_318358 = span_tmp_318426;
            }
            idx_318351 = loop_while_318355;
            idx_318352 = l_idx_318356;
            idx_318353 = r_idx_318357;
            idx_318354 = span_318358;
            
            int64_t min_res_318392 = smin64(min_arg_293073, idx_318352);
            int64_t max_res_318393 = smax64((int64_t) 0, min_res_318392);
            int64_t x_318394 = add64(min_res_293074, max_res_318393);
            int64_t r_318395 = sub64(x_318394, (int64_t) 1);
            bool x_318396 = sle64((int64_t) 0, r_318395);
            bool y_318397 = slt64(r_318395, n_292675);
            bool bounds_check_318398 = x_318396 && y_318397;
            bool index_certs_318399;
            
            if (!bounds_check_318398) {
                ctx->error =
                    msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                              "Index [", (long long) r_318395,
                              "] out of bounds for array of shape [",
                              (long long) n_292675, "].",
                              "-> #0  loess.fut:680:40-47\n   #1  /prelude/soacs.fut:67:19-23\n   #2  /prelude/soacs.fut:67:3-37\n   #3  loess.fut:675:3-683:25\n   #4  loess.fut:699:16-51\n   #5  stl.fut:148:13-60\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  stl.fut:146:5-149:26\n   #9  stl.fut:419:61-435:77\n   #10 stl.fut:463:3-479:36\n   #11 stl.fut:445:1-479:36\n");
                err = FUTHARK_PROGRAM_ERROR;
                goto cleanup;
            }
            
            int64_t x_318400;
            
            x_318400 = ((int64_t *) mem_312636.mem)[gtid_298031 * n_292675 +
                                                    r_318395];
            
            int64_t abs_arg_318401 = sub64(x_318400, min_res_318328);
            int64_t abs_res_318402 = abs64(abs_arg_318401);
            bool x_318403 = sle64((int64_t) 0, max_res_318393);
            bool y_318404 = slt64(max_res_318393, n_292675);
            bool bounds_check_318405 = x_318403 && y_318404;
            bool index_certs_318406;
            
            if (!bounds_check_318405) {
                ctx->error =
                    msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                              "Index [", (long long) max_res_318393,
                              "] out of bounds for array of shape [",
                              (long long) n_292675, "].",
                              "-> #0  loess.fut:679:40-47\n   #1  /prelude/soacs.fut:67:19-23\n   #2  /prelude/soacs.fut:67:3-37\n   #3  loess.fut:675:3-683:25\n   #4  loess.fut:699:16-51\n   #5  stl.fut:148:13-60\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  stl.fut:146:5-149:26\n   #9  stl.fut:419:61-435:77\n   #10 stl.fut:463:3-479:36\n   #11 stl.fut:445:1-479:36\n");
                err = FUTHARK_PROGRAM_ERROR;
                goto cleanup;
            }
            
            int64_t x_318407;
            
            x_318407 = ((int64_t *) mem_312636.mem)[gtid_298031 * n_292675 +
                                                    max_res_318393];
            
            int64_t abs_arg_318408 = sub64(x_318407, min_res_318328);
            int64_t abs_res_318409 = abs64(abs_arg_318408);
            int64_t max_res_318410 = smax64(abs_res_318402, abs_res_318409);
            double defunc_0_f_res_318411 = sitofp_i64_f64(max_res_318410);
            double defunc_1_f_res_318412 = max_res_293078 +
                   defunc_0_f_res_318411;
            
            ((double *) mem_313050)[i_318324] = defunc_1_f_res_318412;
            ((int64_t *) mem_313053)[i_318324] = max_res_318393;
        }
        if (l_n_m_292832 * (int64_t) 8 > 0)
            memmove(mem_313081.mem + gtid_298031 * l_n_m_292832 * (int64_t) 8,
                    mem_313053 + (int64_t) 0, l_n_m_292832 * (int64_t) 8);
        if (l_n_m_292832 * (int64_t) 8 > 0)
            memmove(mem_313085.mem + gtid_298031 * l_n_m_292832 * (int64_t) 8,
                    mem_313050 + (int64_t) 0, l_n_m_292832 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_313035);
    free(mem_313050);
    free(mem_313053);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_337847_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_337847_end -
                 futhark_mc_segmap_parloop_337847_start;
        
        ctx->futhark_mc_segmap_parloop_337847_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_337847_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_337847_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_337845(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_298030 = tid;
    int num_tasks_318317 = info.nsubtasks;
    struct futhark_mc_task_337844 *futhark_mc_task_337844 =
                                  (struct futhark_mc_task_337844 *) args;
    struct futhark_context *ctx = futhark_mc_task_337844->ctx;
    uint64_t futhark_mc_segmap_task_337845_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_337845_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_337844->free_n_292675;
    int64_t q_l_292680 = futhark_mc_task_337844->free_q_l_292680;
    int64_t jump_l_292686 = futhark_mc_task_337844->free_jump_l_292686;
    int64_t partition_sizze_292766 =
            futhark_mc_task_337844->free_partition_sizze_292766;
    int64_t l_n_m_292832 = futhark_mc_task_337844->free_l_n_m_292832;
    int64_t i_292846 = futhark_mc_task_337844->free_i_292846;
    bool x_292847 = futhark_mc_task_337844->free_x_292847;
    int64_t min_res_293058 = futhark_mc_task_337844->free_min_res_293058;
    bool loop_cond_293063 = futhark_mc_task_337844->free_loop_cond_293063;
    double i64_res_293064 = futhark_mc_task_337844->free_i64_res_293064;
    int64_t bytes_312598 = futhark_mc_task_337844->free_bytes_312598;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_task_337844->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_312639 = {.desc ="mem_312639", .mem =
                                  futhark_mc_task_337844->free_mem_312639,
                                  .size =0, .references =NULL};
    int64_t bytes_313028 = futhark_mc_task_337844->free_bytes_313028;
    struct memblock mem_313081 = {.desc ="mem_313081", .mem =
                                  futhark_mc_task_337844->free_mem_313081,
                                  .size =0, .references =NULL};
    struct memblock mem_313085 = {.desc ="mem_313085", .mem =
                                  futhark_mc_task_337844->free_mem_313085,
                                  .size =0, .references =NULL};
    int64_t iter_318318;
    struct futhark_mc_segmap_parloop_struct_337846
    futhark_mc_segmap_parloop_struct_337846;
    
    futhark_mc_segmap_parloop_struct_337846.ctx = ctx;
    futhark_mc_segmap_parloop_struct_337846.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_337846.free_q_l_292680 = q_l_292680;
    futhark_mc_segmap_parloop_struct_337846.free_jump_l_292686 = jump_l_292686;
    futhark_mc_segmap_parloop_struct_337846.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_337846.free_l_n_m_292832 = l_n_m_292832;
    futhark_mc_segmap_parloop_struct_337846.free_i_292846 = i_292846;
    futhark_mc_segmap_parloop_struct_337846.free_x_292847 = x_292847;
    futhark_mc_segmap_parloop_struct_337846.free_min_res_293058 =
        min_res_293058;
    futhark_mc_segmap_parloop_struct_337846.free_loop_cond_293063 =
        loop_cond_293063;
    futhark_mc_segmap_parloop_struct_337846.free_i64_res_293064 =
        i64_res_293064;
    futhark_mc_segmap_parloop_struct_337846.free_bytes_312598 = bytes_312598;
    futhark_mc_segmap_parloop_struct_337846.free_mem_312636 = mem_312636.mem;
    futhark_mc_segmap_parloop_struct_337846.free_mem_312639 = mem_312639.mem;
    futhark_mc_segmap_parloop_struct_337846.free_bytes_313028 = bytes_313028;
    futhark_mc_segmap_parloop_struct_337846.free_mem_313081 = mem_313081.mem;
    futhark_mc_segmap_parloop_struct_337846.free_mem_313085 = mem_313085.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_337847_task;
    
    futhark_mc_segmap_parloop_337847_task.name =
        "futhark_mc_segmap_parloop_337847";
    futhark_mc_segmap_parloop_337847_task.fn = futhark_mc_segmap_parloop_337847;
    futhark_mc_segmap_parloop_337847_task.args =
        &futhark_mc_segmap_parloop_struct_337846;
    futhark_mc_segmap_parloop_337847_task.iterations = iterations;
    futhark_mc_segmap_parloop_337847_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_337847_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_337847_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_337847_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_337847_task);
    
    if (futhark_mc_segmap_parloop_337847_err != 0) {
        err = futhark_mc_segmap_parloop_337847_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_337847_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_337847_total_end -
                 futhark_mc_segmap_parloop_337847_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337847_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337847_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337847_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_337845_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_337845_end -
                 futhark_mc_segmap_task_337845_start;
        
        ctx->futhark_mc_segmap_task_337845_runs[tid]++;
        ctx->futhark_mc_segmap_task_337845_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_337845_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_segmap_parloop_struct_337852 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_l_292680;
    int64_t free_jump_l_292686;
    int64_t free_partition_sizze_292766;
    int64_t free_l_n_m_292832;
    int64_t free_i_292846;
    bool free_x_292847;
    int64_t free_min_res_293058;
    bool free_loop_cond_293063;
    double free_i64_res_293064;
    int64_t free_bytes_312598;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_312639;
    int64_t free_bytes_313028;
    unsigned char *free_mem_313081;
    unsigned char *free_mem_313085;
};
struct futhark_mc_task_337857 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_298039;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_313026;
};
struct futhark_mc_segmap_parloop_struct_337859 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_298039;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_313026;
};
static int futhark_mc_segmap_parloop_337860(void *args, int64_t start,
                                            int64_t end, int flat_tid_318428,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_337859
    *futhark_mc_segmap_parloop_struct_337859 =
    (struct futhark_mc_segmap_parloop_struct_337859 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_337859->ctx;
    uint64_t futhark_mc_segmap_parloop_337860_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_337860_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_337859->free_n_292675;
    int64_t gtid_298039 =
            futhark_mc_segmap_parloop_struct_337859->free_gtid_298039;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_segmap_parloop_struct_337859->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_313026 = {.desc ="mem_313026", .mem =
                                  futhark_mc_segmap_parloop_struct_337859->free_mem_313026,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_318523 = start;
    
    for (; iter_318523 < end; iter_318523++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_318524 = n_292675;
        int64_t gtid_318429 = iter_318523;
        int64_t remnant_318525 = iter_318523 - gtid_318429;
        int64_t x_318430;
        
        x_318430 = ((int64_t *) mem_312636.mem)[gtid_298039 * n_292675 +
                                                gtid_318429];
        
        int64_t defunc_0_f_res_318431 = add64((int64_t) 1, x_318430);
        
        ((int64_t *) mem_313026.mem)[gtid_318429] = defunc_0_f_res_318431;
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_337860_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_337860_end -
                 futhark_mc_segmap_parloop_337860_start;
        
        ctx->futhark_mc_segmap_parloop_337860_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_337860_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_337860_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_337858(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_318428 = tid;
    int num_tasks_318522 = info.nsubtasks;
    struct futhark_mc_task_337857 *futhark_mc_task_337857 =
                                  (struct futhark_mc_task_337857 *) args;
    struct futhark_context *ctx = futhark_mc_task_337857->ctx;
    uint64_t futhark_mc_segmap_task_337858_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_337858_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_337857->free_n_292675;
    int64_t gtid_298039 = futhark_mc_task_337857->free_gtid_298039;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_task_337857->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_313026 = {.desc ="mem_313026", .mem =
                                  futhark_mc_task_337857->free_mem_313026,
                                  .size =0, .references =NULL};
    int64_t iter_318523;
    struct futhark_mc_segmap_parloop_struct_337859
    futhark_mc_segmap_parloop_struct_337859;
    
    futhark_mc_segmap_parloop_struct_337859.ctx = ctx;
    futhark_mc_segmap_parloop_struct_337859.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_337859.free_gtid_298039 = gtid_298039;
    futhark_mc_segmap_parloop_struct_337859.free_mem_312636 = mem_312636.mem;
    futhark_mc_segmap_parloop_struct_337859.free_mem_313026 = mem_313026.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_337860_task;
    
    futhark_mc_segmap_parloop_337860_task.name =
        "futhark_mc_segmap_parloop_337860";
    futhark_mc_segmap_parloop_337860_task.fn = futhark_mc_segmap_parloop_337860;
    futhark_mc_segmap_parloop_337860_task.args =
        &futhark_mc_segmap_parloop_struct_337859;
    futhark_mc_segmap_parloop_337860_task.iterations = iterations;
    futhark_mc_segmap_parloop_337860_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_337860_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_337860_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_337860_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_337860_task);
    
    if (futhark_mc_segmap_parloop_337860_err != 0) {
        err = futhark_mc_segmap_parloop_337860_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_337860_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_337860_total_end -
                 futhark_mc_segmap_parloop_337860_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337860_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337860_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337860_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_337858_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_337858_end -
                 futhark_mc_segmap_task_337858_start;
        
        ctx->futhark_mc_segmap_task_337858_runs[tid]++;
        ctx->futhark_mc_segmap_task_337858_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_337858_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_task_337861 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_jump_l_292686;
    int64_t free_l_n_m_292832;
    int64_t free_i_292846;
    bool free_x_292847;
    int64_t free_min_res_293058;
    bool free_loop_cond_293063;
    int64_t free_gtid_298039;
    int64_t free_min_arg_298047;
    int64_t free_min_arg_298048;
    int64_t free_min_res_298049;
    double free_max_res_298053;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_313026;
    unsigned char *free_mem_313029;
    unsigned char *free_mem_313032;
};
struct futhark_mc_segmap_parloop_struct_337863 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_jump_l_292686;
    int64_t free_l_n_m_292832;
    int64_t free_i_292846;
    bool free_x_292847;
    int64_t free_min_res_293058;
    bool free_loop_cond_293063;
    int64_t free_gtid_298039;
    int64_t free_min_arg_298047;
    int64_t free_min_arg_298048;
    int64_t free_min_res_298049;
    double free_max_res_298053;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_313026;
    unsigned char *free_mem_313029;
    unsigned char *free_mem_313032;
};
static int futhark_mc_segmap_parloop_337864(void *args, int64_t start,
                                            int64_t end, int flat_tid_318432,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_337863
    *futhark_mc_segmap_parloop_struct_337863 =
    (struct futhark_mc_segmap_parloop_struct_337863 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_337863->ctx;
    uint64_t futhark_mc_segmap_parloop_337864_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_337864_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_337863->free_n_292675;
    int64_t jump_l_292686 =
            futhark_mc_segmap_parloop_struct_337863->free_jump_l_292686;
    int64_t l_n_m_292832 =
            futhark_mc_segmap_parloop_struct_337863->free_l_n_m_292832;
    int64_t i_292846 = futhark_mc_segmap_parloop_struct_337863->free_i_292846;
    bool x_292847 = futhark_mc_segmap_parloop_struct_337863->free_x_292847;
    int64_t min_res_293058 =
            futhark_mc_segmap_parloop_struct_337863->free_min_res_293058;
    bool loop_cond_293063 =
         futhark_mc_segmap_parloop_struct_337863->free_loop_cond_293063;
    int64_t gtid_298039 =
            futhark_mc_segmap_parloop_struct_337863->free_gtid_298039;
    int64_t min_arg_298047 =
            futhark_mc_segmap_parloop_struct_337863->free_min_arg_298047;
    int64_t min_arg_298048 =
            futhark_mc_segmap_parloop_struct_337863->free_min_arg_298048;
    int64_t min_res_298049 =
            futhark_mc_segmap_parloop_struct_337863->free_min_res_298049;
    double max_res_298053 =
           futhark_mc_segmap_parloop_struct_337863->free_max_res_298053;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_segmap_parloop_struct_337863->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_313026 = {.desc ="mem_313026", .mem =
                                  futhark_mc_segmap_parloop_struct_337863->free_mem_313026,
                                  .size =0, .references =NULL};
    struct memblock mem_313029 = {.desc ="mem_313029", .mem =
                                  futhark_mc_segmap_parloop_struct_337863->free_mem_313029,
                                  .size =0, .references =NULL};
    struct memblock mem_313032 = {.desc ="mem_313032", .mem =
                                  futhark_mc_segmap_parloop_struct_337863->free_mem_313032,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_318527 = start;
    
    for (; iter_318527 < end; iter_318527++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_318583 = l_n_m_292832;
        int64_t gtid_318433 = iter_318527;
        int64_t remnant_318584 = iter_318527 - gtid_318433;
        int64_t min_arg_318434 = mul64(jump_l_292686, gtid_318433);
        int64_t min_res_318435 = smin64(i_292846, min_arg_318434);
        int64_t defunc_0_g_res_318436 = add64((int64_t) 1, min_res_318435);
        bool init_idx_318437;
        int64_t init_idx_318438;
        int64_t init_idx_318439;
        bool loop_while_318528;
        int64_t low_318529;
        int64_t high_318530;
        
        loop_while_318528 = x_292847;
        low_318529 = (int64_t) 0;
        high_318530 = i_292846;
        while (loop_while_318528) {
            int64_t x_318531 = add64(low_318529, high_318530);
            int64_t mid_318532 = sdiv64(x_318531, (int64_t) 2);
            bool x_318533 = sle64((int64_t) 0, mid_318532);
            bool y_318534 = slt64(mid_318532, n_292675);
            bool bounds_check_318535 = x_318533 && y_318534;
            bool index_certs_318536;
            
            if (!bounds_check_318535) {
                ctx->error =
                    msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                              "Index [", (long long) mid_318532,
                              "] out of bounds for array of shape [",
                              (long long) n_292675, "].",
                              "-> #0  loess.fut:645:26-36\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:638:3-665:10\n   #5  loess.fut:698:15-61\n   #6  stl.fut:148:13-60\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:146:5-149:26\n   #10 stl.fut:419:61-435:77\n   #11 stl.fut:463:3-479:36\n   #12 stl.fut:445:1-479:36\n");
                err = FUTHARK_PROGRAM_ERROR;
                goto cleanup;
            }
            
            int64_t mid_id_318537;
            
            mid_id_318537 = ((int64_t *) mem_313026.mem)[mid_318532];
            
            bool cond_318538 = slt64(mid_id_318537, (int64_t) 0);
            int64_t mid_idx_318539;
            
            if (cond_318538) {
                mid_idx_318539 = (int64_t) 9223372036854775807;
            } else {
                mid_idx_318539 = mid_id_318537;
            }
            
            bool cond_318540 = sle64(defunc_0_g_res_318436, mid_idx_318539);
            int64_t loopres_318541;
            int64_t loopres_318542;
            
            if (cond_318540) {
                int64_t loopres_t_res_318543 = sub64(mid_318532, (int64_t) 1);
                
                loopres_318541 = low_318529;
                loopres_318542 = loopres_t_res_318543;
            } else {
                int64_t loopres_f_res_318544 = add64((int64_t) 1, mid_318532);
                
                loopres_318541 = loopres_f_res_318544;
                loopres_318542 = high_318530;
            }
            
            bool loop_cond_318545 = sle64(loopres_318541, loopres_318542);
            bool loop_while_tmp_318585 = loop_cond_318545;
            int64_t low_tmp_318586 = loopres_318541;
            int64_t high_tmp_318587 = loopres_318542;
            
            loop_while_318528 = loop_while_tmp_318585;
            low_318529 = low_tmp_318586;
            high_318530 = high_tmp_318587;
        }
        init_idx_318437 = loop_while_318528;
        init_idx_318438 = low_318529;
        init_idx_318439 = high_318530;
        
        bool idx_318458;
        int64_t idx_318459;
        int64_t idx_318460;
        int64_t idx_318461;
        bool loop_while_318546;
        int64_t l_idx_318547;
        int64_t r_idx_318548;
        int64_t span_318549;
        
        loop_while_318546 = loop_cond_293063;
        l_idx_318547 = init_idx_318438;
        r_idx_318548 = init_idx_318438;
        span_318549 = (int64_t) 1;
        while (loop_while_318546) {
            int64_t max_arg_318550 = sub64(l_idx_318547, (int64_t) 1);
            int64_t max_res_318551 = smax64((int64_t) 0, max_arg_318550);
            int64_t min_arg_318552 = add64((int64_t) 1, r_idx_318548);
            int64_t min_res_318553 = smin64(min_arg_298047, min_arg_318552);
            bool x_318554 = sle64((int64_t) 0, max_res_318551);
            bool y_318555 = slt64(max_res_318551, n_292675);
            bool bounds_check_318556 = x_318554 && y_318555;
            bool index_certs_318557;
            
            if (!bounds_check_318556) {
                ctx->error =
                    msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                              "Index [", (long long) max_res_318551,
                              "] out of bounds for array of shape [",
                              (long long) n_292675, "].",
                              "-> #0  loess.fut:655:35-48\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:638:3-665:10\n   #5  loess.fut:698:15-61\n   #6  stl.fut:148:13-60\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:146:5-149:26\n   #10 stl.fut:419:61-435:77\n   #11 stl.fut:463:3-479:36\n   #12 stl.fut:445:1-479:36\n");
                err = FUTHARK_PROGRAM_ERROR;
                goto cleanup;
            }
            
            int64_t x_318558;
            
            x_318558 = ((int64_t *) mem_313026.mem)[max_res_318551];
            
            int64_t abs_arg_318559 = sub64(x_318558, defunc_0_g_res_318436);
            int64_t abs_res_318560 = abs64(abs_arg_318559);
            bool x_318561 = sle64((int64_t) 0, min_res_318553);
            bool y_318562 = slt64(min_res_318553, n_292675);
            bool bounds_check_318563 = x_318561 && y_318562;
            bool index_certs_318564;
            
            if (!bounds_check_318563) {
                ctx->error =
                    msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                              "Index [", (long long) min_res_318553,
                              "] out of bounds for array of shape [",
                              (long long) n_292675, "].",
                              "-> #0  loess.fut:656:35-48\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:638:3-665:10\n   #5  loess.fut:698:15-61\n   #6  stl.fut:148:13-60\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:146:5-149:26\n   #10 stl.fut:419:61-435:77\n   #11 stl.fut:463:3-479:36\n   #12 stl.fut:445:1-479:36\n");
                err = FUTHARK_PROGRAM_ERROR;
                goto cleanup;
            }
            
            int64_t x_318565;
            
            x_318565 = ((int64_t *) mem_313026.mem)[min_res_318553];
            
            int64_t abs_arg_318566 = sub64(x_318565, defunc_0_g_res_318436);
            int64_t abs_res_318567 = abs64(abs_arg_318566);
            bool cond_318568 = max_res_318551 == l_idx_318547;
            int64_t loopres_318569;
            int64_t loopres_318570;
            int64_t loopres_318571;
            
            if (cond_318568) {
                loopres_318569 = l_idx_318547;
                loopres_318570 = r_idx_318548;
                loopres_318571 = min_res_293058;
            } else {
                bool cond_318572 = slt64(abs_res_318560, abs_res_318567);
                bool cond_f_res_318573 = min_res_318553 == r_idx_318548;
                bool x_318574 = !cond_318572;
                bool y_318575 = cond_f_res_318573 && x_318574;
                bool cond_318576 = cond_318572 || y_318575;
                int64_t loopres_f_res_318577;
                
                if (cond_318576) {
                    loopres_f_res_318577 = max_res_318551;
                } else {
                    loopres_f_res_318577 = l_idx_318547;
                }
                
                int64_t loopres_f_res_318578;
                
                if (cond_318576) {
                    loopres_f_res_318578 = r_idx_318548;
                } else {
                    loopres_f_res_318578 = min_res_318553;
                }
                
                int64_t loopres_f_res_318579;
                
                if (cond_318576) {
                    int64_t loopres_f_res_t_res_318580 = add64((int64_t) 1,
                                                               span_318549);
                    
                    loopres_f_res_318579 = loopres_f_res_t_res_318580;
                } else {
                    int64_t loopres_f_res_f_res_318581 = add64((int64_t) 1,
                                                               span_318549);
                    
                    loopres_f_res_318579 = loopres_f_res_f_res_318581;
                }
                loopres_318569 = loopres_f_res_318577;
                loopres_318570 = loopres_f_res_318578;
                loopres_318571 = loopres_f_res_318579;
            }
            
            bool loop_cond_318582 = slt64(loopres_318571, min_res_293058);
            bool loop_while_tmp_318588 = loop_cond_318582;
            int64_t l_idx_tmp_318589 = loopres_318569;
            int64_t r_idx_tmp_318590 = loopres_318570;
            int64_t span_tmp_318591 = loopres_318571;
            
            loop_while_318546 = loop_while_tmp_318588;
            l_idx_318547 = l_idx_tmp_318589;
            r_idx_318548 = r_idx_tmp_318590;
            span_318549 = span_tmp_318591;
        }
        idx_318458 = loop_while_318546;
        idx_318459 = l_idx_318547;
        idx_318460 = r_idx_318548;
        idx_318461 = span_318549;
        
        int64_t min_res_318499 = smin64(min_arg_298048, idx_318459);
        int64_t max_res_318500 = smax64((int64_t) 0, min_res_318499);
        int64_t x_318501 = add64(min_res_298049, max_res_318500);
        int64_t r_318502 = sub64(x_318501, (int64_t) 1);
        bool x_318503 = sle64((int64_t) 0, r_318502);
        bool y_318504 = slt64(r_318502, n_292675);
        bool bounds_check_318505 = x_318503 && y_318504;
        bool index_certs_318506;
        
        if (!bounds_check_318505) {
            ctx->error = msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                   "Index [", (long long) r_318502,
                                   "] out of bounds for array of shape [",
                                   (long long) n_292675, "].",
                                   "-> #0  loess.fut:680:40-47\n   #1  /prelude/soacs.fut:67:19-23\n   #2  /prelude/soacs.fut:67:3-37\n   #3  loess.fut:675:3-683:25\n   #4  loess.fut:699:16-51\n   #5  stl.fut:148:13-60\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  stl.fut:146:5-149:26\n   #9  stl.fut:419:61-435:77\n   #10 stl.fut:463:3-479:36\n   #11 stl.fut:445:1-479:36\n");
            err = FUTHARK_PROGRAM_ERROR;
            goto cleanup;
        }
        
        int64_t x_318507;
        
        x_318507 = ((int64_t *) mem_312636.mem)[gtid_298039 * n_292675 +
                                                r_318502];
        
        int64_t abs_arg_318508 = sub64(x_318507, min_res_318435);
        int64_t abs_res_318509 = abs64(abs_arg_318508);
        bool x_318510 = sle64((int64_t) 0, max_res_318500);
        bool y_318511 = slt64(max_res_318500, n_292675);
        bool bounds_check_318512 = x_318510 && y_318511;
        bool index_certs_318513;
        
        if (!bounds_check_318512) {
            ctx->error = msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                   "Index [", (long long) max_res_318500,
                                   "] out of bounds for array of shape [",
                                   (long long) n_292675, "].",
                                   "-> #0  loess.fut:679:40-47\n   #1  /prelude/soacs.fut:67:19-23\n   #2  /prelude/soacs.fut:67:3-37\n   #3  loess.fut:675:3-683:25\n   #4  loess.fut:699:16-51\n   #5  stl.fut:148:13-60\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  stl.fut:146:5-149:26\n   #9  stl.fut:419:61-435:77\n   #10 stl.fut:463:3-479:36\n   #11 stl.fut:445:1-479:36\n");
            err = FUTHARK_PROGRAM_ERROR;
            goto cleanup;
        }
        
        int64_t x_318514;
        
        x_318514 = ((int64_t *) mem_312636.mem)[gtid_298039 * n_292675 +
                                                max_res_318500];
        
        int64_t abs_arg_318515 = sub64(x_318514, min_res_318435);
        int64_t abs_res_318516 = abs64(abs_arg_318515);
        int64_t max_res_318517 = smax64(abs_res_318509, abs_res_318516);
        double defunc_0_f_res_318518 = sitofp_i64_f64(max_res_318517);
        double defunc_1_f_res_318519 = max_res_298053 + defunc_0_f_res_318518;
        
        ((double *) mem_313029.mem)[gtid_318433] = defunc_1_f_res_318519;
        ((int64_t *) mem_313032.mem)[gtid_318433] = max_res_318500;
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_337864_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_337864_end -
                 futhark_mc_segmap_parloop_337864_start;
        
        ctx->futhark_mc_segmap_parloop_337864_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_337864_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_337864_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_337862(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_318432 = tid;
    int num_tasks_318526 = info.nsubtasks;
    struct futhark_mc_task_337861 *futhark_mc_task_337861 =
                                  (struct futhark_mc_task_337861 *) args;
    struct futhark_context *ctx = futhark_mc_task_337861->ctx;
    uint64_t futhark_mc_segmap_task_337862_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_337862_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_337861->free_n_292675;
    int64_t jump_l_292686 = futhark_mc_task_337861->free_jump_l_292686;
    int64_t l_n_m_292832 = futhark_mc_task_337861->free_l_n_m_292832;
    int64_t i_292846 = futhark_mc_task_337861->free_i_292846;
    bool x_292847 = futhark_mc_task_337861->free_x_292847;
    int64_t min_res_293058 = futhark_mc_task_337861->free_min_res_293058;
    bool loop_cond_293063 = futhark_mc_task_337861->free_loop_cond_293063;
    int64_t gtid_298039 = futhark_mc_task_337861->free_gtid_298039;
    int64_t min_arg_298047 = futhark_mc_task_337861->free_min_arg_298047;
    int64_t min_arg_298048 = futhark_mc_task_337861->free_min_arg_298048;
    int64_t min_res_298049 = futhark_mc_task_337861->free_min_res_298049;
    double max_res_298053 = futhark_mc_task_337861->free_max_res_298053;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_task_337861->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_313026 = {.desc ="mem_313026", .mem =
                                  futhark_mc_task_337861->free_mem_313026,
                                  .size =0, .references =NULL};
    struct memblock mem_313029 = {.desc ="mem_313029", .mem =
                                  futhark_mc_task_337861->free_mem_313029,
                                  .size =0, .references =NULL};
    struct memblock mem_313032 = {.desc ="mem_313032", .mem =
                                  futhark_mc_task_337861->free_mem_313032,
                                  .size =0, .references =NULL};
    int64_t iter_318527;
    struct futhark_mc_segmap_parloop_struct_337863
    futhark_mc_segmap_parloop_struct_337863;
    
    futhark_mc_segmap_parloop_struct_337863.ctx = ctx;
    futhark_mc_segmap_parloop_struct_337863.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_337863.free_jump_l_292686 = jump_l_292686;
    futhark_mc_segmap_parloop_struct_337863.free_l_n_m_292832 = l_n_m_292832;
    futhark_mc_segmap_parloop_struct_337863.free_i_292846 = i_292846;
    futhark_mc_segmap_parloop_struct_337863.free_x_292847 = x_292847;
    futhark_mc_segmap_parloop_struct_337863.free_min_res_293058 =
        min_res_293058;
    futhark_mc_segmap_parloop_struct_337863.free_loop_cond_293063 =
        loop_cond_293063;
    futhark_mc_segmap_parloop_struct_337863.free_gtid_298039 = gtid_298039;
    futhark_mc_segmap_parloop_struct_337863.free_min_arg_298047 =
        min_arg_298047;
    futhark_mc_segmap_parloop_struct_337863.free_min_arg_298048 =
        min_arg_298048;
    futhark_mc_segmap_parloop_struct_337863.free_min_res_298049 =
        min_res_298049;
    futhark_mc_segmap_parloop_struct_337863.free_max_res_298053 =
        max_res_298053;
    futhark_mc_segmap_parloop_struct_337863.free_mem_312636 = mem_312636.mem;
    futhark_mc_segmap_parloop_struct_337863.free_mem_313026 = mem_313026.mem;
    futhark_mc_segmap_parloop_struct_337863.free_mem_313029 = mem_313029.mem;
    futhark_mc_segmap_parloop_struct_337863.free_mem_313032 = mem_313032.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_337864_task;
    
    futhark_mc_segmap_parloop_337864_task.name =
        "futhark_mc_segmap_parloop_337864";
    futhark_mc_segmap_parloop_337864_task.fn = futhark_mc_segmap_parloop_337864;
    futhark_mc_segmap_parloop_337864_task.args =
        &futhark_mc_segmap_parloop_struct_337863;
    futhark_mc_segmap_parloop_337864_task.iterations = iterations;
    futhark_mc_segmap_parloop_337864_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_337864_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_337864_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_337864_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_337864_task);
    
    if (futhark_mc_segmap_parloop_337864_err != 0) {
        err = futhark_mc_segmap_parloop_337864_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_337864_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_337864_total_end -
                 futhark_mc_segmap_parloop_337864_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337864_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337864_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337864_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_337862_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_337862_end -
                 futhark_mc_segmap_task_337862_start;
        
        ctx->futhark_mc_segmap_task_337862_runs[tid]++;
        ctx->futhark_mc_segmap_task_337862_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_337862_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
static int futhark_mc_segmap_parloop_337853(void *args, int64_t start,
                                            int64_t end, int flat_tid_298038,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_337852
    *futhark_mc_segmap_parloop_struct_337852 =
    (struct futhark_mc_segmap_parloop_struct_337852 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_337852->ctx;
    uint64_t futhark_mc_segmap_parloop_337853_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_337853_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_337852->free_n_292675;
    int64_t q_l_292680 =
            futhark_mc_segmap_parloop_struct_337852->free_q_l_292680;
    int64_t jump_l_292686 =
            futhark_mc_segmap_parloop_struct_337852->free_jump_l_292686;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_337852->free_partition_sizze_292766;
    int64_t l_n_m_292832 =
            futhark_mc_segmap_parloop_struct_337852->free_l_n_m_292832;
    int64_t i_292846 = futhark_mc_segmap_parloop_struct_337852->free_i_292846;
    bool x_292847 = futhark_mc_segmap_parloop_struct_337852->free_x_292847;
    int64_t min_res_293058 =
            futhark_mc_segmap_parloop_struct_337852->free_min_res_293058;
    bool loop_cond_293063 =
         futhark_mc_segmap_parloop_struct_337852->free_loop_cond_293063;
    double i64_res_293064 =
           futhark_mc_segmap_parloop_struct_337852->free_i64_res_293064;
    int64_t bytes_312598 =
            futhark_mc_segmap_parloop_struct_337852->free_bytes_312598;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_segmap_parloop_struct_337852->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_312639 = {.desc ="mem_312639", .mem =
                                  futhark_mc_segmap_parloop_struct_337852->free_mem_312639,
                                  .size =0, .references =NULL};
    int64_t bytes_313028 =
            futhark_mc_segmap_parloop_struct_337852->free_bytes_313028;
    struct memblock mem_313081 = {.desc ="mem_313081", .mem =
                                  futhark_mc_segmap_parloop_struct_337852->free_mem_313081,
                                  .size =0, .references =NULL};
    struct memblock mem_313085 = {.desc ="mem_313085", .mem =
                                  futhark_mc_segmap_parloop_struct_337852->free_mem_313085,
                                  .size =0, .references =NULL};
    size_t mem_313026_cached_sizze_337854 = 0;
    unsigned char *mem_313026 = NULL;
    size_t mem_313029_cached_sizze_337855 = 0;
    unsigned char *mem_313029 = NULL;
    size_t mem_313032_cached_sizze_337856 = 0;
    unsigned char *mem_313032 = NULL;
    int64_t iterations = end - start;
    int64_t iter_318427 = start;
    
    if (mem_313026_cached_sizze_337854 < (size_t) bytes_312598) {
        mem_313026 = realloc(mem_313026, bytes_312598);
        mem_313026_cached_sizze_337854 = bytes_312598;
    }
    if (mem_313029_cached_sizze_337855 < (size_t) bytes_313028) {
        mem_313029 = realloc(mem_313029, bytes_313028);
        mem_313029_cached_sizze_337855 = bytes_313028;
    }
    if (mem_313032_cached_sizze_337856 < (size_t) bytes_313028) {
        mem_313032 = realloc(mem_313032, bytes_313028);
        mem_313032_cached_sizze_337856 = bytes_313028;
    }
    for (; iter_318427 < end; iter_318427++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_318520 = partition_sizze_292766;
        int64_t gtid_298039 = iter_318427;
        int64_t remnant_318521 = iter_318427 - gtid_298039;
        int64_t x_298041;
        
        x_298041 = ((int64_t *) mem_312639.mem)[gtid_298039];
        
        int64_t flat_tid_318428 = (int64_t) 0;
        int32_t num_tasks_318522;
        struct futhark_mc_task_337857 futhark_mc_task_337857;
        
        futhark_mc_task_337857.ctx = ctx;
        futhark_mc_task_337857.free_n_292675 = n_292675;
        futhark_mc_task_337857.free_gtid_298039 = gtid_298039;
        futhark_mc_task_337857.free_mem_312636 = mem_312636.mem;
        futhark_mc_task_337857.free_mem_313026 = mem_313026;
        
        struct scheduler_segop futhark_mc_task_337857_task;
        
        futhark_mc_task_337857_task.args = &futhark_mc_task_337857;
        futhark_mc_task_337857_task.top_level_fn =
            futhark_mc_segmap_task_337858;
        futhark_mc_task_337857_task.name = "futhark_mc_segmap_task_337858";
        futhark_mc_task_337857_task.iterations = n_292675;
        futhark_mc_task_337857_task.task_time =
            &ctx->futhark_mc_segmap_task_337858_total_time;
        futhark_mc_task_337857_task.task_iter =
            &ctx->futhark_mc_segmap_task_337858_total_iter;
        futhark_mc_task_337857_task.sched = STATIC;
        futhark_mc_task_337857_task.nested_fn = NULL;
        
        int futhark_mc_segmap_task_337858_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_337857_task);
        
        if (futhark_mc_segmap_task_337858_err != 0) {
            ;
            err = futhark_mc_segmap_task_337858_err;
            goto cleanup;
        }
        
        int64_t min_arg_298047 = sub64(x_298041, (int64_t) 1);
        int64_t min_arg_298048 = sub64(x_298041, min_res_293058);
        int64_t min_res_298049 = smin64(q_l_292680, x_298041);
        double i64_res_298050 = sitofp_i64_f64(x_298041);
        double x_298051 = i64_res_293064 - i64_res_298050;
        double max_arg_298052 = x_298051 / 2.0;
        double max_res_298053 = fmax64(0.0, max_arg_298052);
        int64_t flat_tid_318432 = (int64_t) 0;
        int32_t num_tasks_318526;
        struct futhark_mc_task_337861 futhark_mc_task_337861;
        
        futhark_mc_task_337861.ctx = ctx;
        futhark_mc_task_337861.free_n_292675 = n_292675;
        futhark_mc_task_337861.free_jump_l_292686 = jump_l_292686;
        futhark_mc_task_337861.free_l_n_m_292832 = l_n_m_292832;
        futhark_mc_task_337861.free_i_292846 = i_292846;
        futhark_mc_task_337861.free_x_292847 = x_292847;
        futhark_mc_task_337861.free_min_res_293058 = min_res_293058;
        futhark_mc_task_337861.free_loop_cond_293063 = loop_cond_293063;
        futhark_mc_task_337861.free_gtid_298039 = gtid_298039;
        futhark_mc_task_337861.free_min_arg_298047 = min_arg_298047;
        futhark_mc_task_337861.free_min_arg_298048 = min_arg_298048;
        futhark_mc_task_337861.free_min_res_298049 = min_res_298049;
        futhark_mc_task_337861.free_max_res_298053 = max_res_298053;
        futhark_mc_task_337861.free_mem_312636 = mem_312636.mem;
        futhark_mc_task_337861.free_mem_313026 = mem_313026;
        futhark_mc_task_337861.free_mem_313029 = mem_313029;
        futhark_mc_task_337861.free_mem_313032 = mem_313032;
        
        struct scheduler_segop futhark_mc_task_337861_task;
        
        futhark_mc_task_337861_task.args = &futhark_mc_task_337861;
        futhark_mc_task_337861_task.top_level_fn =
            futhark_mc_segmap_task_337862;
        futhark_mc_task_337861_task.name = "futhark_mc_segmap_task_337862";
        futhark_mc_task_337861_task.iterations = l_n_m_292832;
        futhark_mc_task_337861_task.task_time =
            &ctx->futhark_mc_segmap_task_337862_total_time;
        futhark_mc_task_337861_task.task_iter =
            &ctx->futhark_mc_segmap_task_337862_total_iter;
        futhark_mc_task_337861_task.sched = DYNAMIC;
        futhark_mc_task_337861_task.nested_fn = NULL;
        
        int futhark_mc_segmap_task_337862_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_337861_task);
        
        if (futhark_mc_segmap_task_337862_err != 0) {
            ;
            err = futhark_mc_segmap_task_337862_err;
            goto cleanup;
        }
        if (l_n_m_292832 * (int64_t) 8 > 0)
            memmove(mem_313081.mem + gtid_298039 * l_n_m_292832 * (int64_t) 8,
                    mem_313032 + (int64_t) 0, l_n_m_292832 * (int64_t) 8);
        if (l_n_m_292832 * (int64_t) 8 > 0)
            memmove(mem_313085.mem + gtid_298039 * l_n_m_292832 * (int64_t) 8,
                    mem_313029 + (int64_t) 0, l_n_m_292832 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_313026);
    free(mem_313029);
    free(mem_313032);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_337853_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_337853_end -
                 futhark_mc_segmap_parloop_337853_start;
        
        ctx->futhark_mc_segmap_parloop_337853_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_337853_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_337853_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_nested_task_337851(void *args, int64_t iterations,
                                         int tid, struct scheduler_info info)
{
    int err = 0;
    int flat_tid_298038 = tid;
    int num_tasks_318317 = info.nsubtasks;
    struct futhark_mc_task_337844 *futhark_mc_task_337844 =
                                  (struct futhark_mc_task_337844 *) args;
    struct futhark_context *ctx = futhark_mc_task_337844->ctx;
    uint64_t futhark_mc_segmap_nested_task_337851_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_nested_task_337851_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_337844->free_n_292675;
    int64_t q_l_292680 = futhark_mc_task_337844->free_q_l_292680;
    int64_t jump_l_292686 = futhark_mc_task_337844->free_jump_l_292686;
    int64_t partition_sizze_292766 =
            futhark_mc_task_337844->free_partition_sizze_292766;
    int64_t l_n_m_292832 = futhark_mc_task_337844->free_l_n_m_292832;
    int64_t i_292846 = futhark_mc_task_337844->free_i_292846;
    bool x_292847 = futhark_mc_task_337844->free_x_292847;
    int64_t min_res_293058 = futhark_mc_task_337844->free_min_res_293058;
    bool loop_cond_293063 = futhark_mc_task_337844->free_loop_cond_293063;
    double i64_res_293064 = futhark_mc_task_337844->free_i64_res_293064;
    int64_t bytes_312598 = futhark_mc_task_337844->free_bytes_312598;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_task_337844->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_312639 = {.desc ="mem_312639", .mem =
                                  futhark_mc_task_337844->free_mem_312639,
                                  .size =0, .references =NULL};
    int64_t bytes_313028 = futhark_mc_task_337844->free_bytes_313028;
    struct memblock mem_313081 = {.desc ="mem_313081", .mem =
                                  futhark_mc_task_337844->free_mem_313081,
                                  .size =0, .references =NULL};
    struct memblock mem_313085 = {.desc ="mem_313085", .mem =
                                  futhark_mc_task_337844->free_mem_313085,
                                  .size =0, .references =NULL};
    int64_t iter_318427;
    struct futhark_mc_segmap_parloop_struct_337852
    futhark_mc_segmap_parloop_struct_337852;
    
    futhark_mc_segmap_parloop_struct_337852.ctx = ctx;
    futhark_mc_segmap_parloop_struct_337852.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_337852.free_q_l_292680 = q_l_292680;
    futhark_mc_segmap_parloop_struct_337852.free_jump_l_292686 = jump_l_292686;
    futhark_mc_segmap_parloop_struct_337852.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_337852.free_l_n_m_292832 = l_n_m_292832;
    futhark_mc_segmap_parloop_struct_337852.free_i_292846 = i_292846;
    futhark_mc_segmap_parloop_struct_337852.free_x_292847 = x_292847;
    futhark_mc_segmap_parloop_struct_337852.free_min_res_293058 =
        min_res_293058;
    futhark_mc_segmap_parloop_struct_337852.free_loop_cond_293063 =
        loop_cond_293063;
    futhark_mc_segmap_parloop_struct_337852.free_i64_res_293064 =
        i64_res_293064;
    futhark_mc_segmap_parloop_struct_337852.free_bytes_312598 = bytes_312598;
    futhark_mc_segmap_parloop_struct_337852.free_mem_312636 = mem_312636.mem;
    futhark_mc_segmap_parloop_struct_337852.free_mem_312639 = mem_312639.mem;
    futhark_mc_segmap_parloop_struct_337852.free_bytes_313028 = bytes_313028;
    futhark_mc_segmap_parloop_struct_337852.free_mem_313081 = mem_313081.mem;
    futhark_mc_segmap_parloop_struct_337852.free_mem_313085 = mem_313085.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_337853_task;
    
    futhark_mc_segmap_parloop_337853_task.name =
        "futhark_mc_segmap_parloop_337853";
    futhark_mc_segmap_parloop_337853_task.fn = futhark_mc_segmap_parloop_337853;
    futhark_mc_segmap_parloop_337853_task.args =
        &futhark_mc_segmap_parloop_struct_337852;
    futhark_mc_segmap_parloop_337853_task.iterations = iterations;
    futhark_mc_segmap_parloop_337853_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_337853_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_337853_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_337853_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_337853_task);
    
    if (futhark_mc_segmap_parloop_337853_err != 0) {
        err = futhark_mc_segmap_parloop_337853_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_337853_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_337853_total_end -
                 futhark_mc_segmap_parloop_337853_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337853_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337853_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337853_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_nested_task_337851_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_nested_task_337851_end -
                 futhark_mc_segmap_nested_task_337851_start;
        
        ctx->futhark_mc_segmap_nested_task_337851_runs[tid]++;
        ctx->futhark_mc_segmap_nested_task_337851_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_nested_task_337851_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_task_337865 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_t_292679;
    int64_t free_jump_t_292685;
    int64_t free_partition_sizze_292766;
    int64_t free_t_n_m_292839;
    int64_t free_i_292846;
    bool free_x_292847;
    int64_t free_min_res_293170;
    bool free_loop_cond_293175;
    double free_i64_res_293176;
    int64_t free_bytes_312598;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_312639;
    int64_t free_bytes_313090;
    unsigned char *free_mem_313143;
    unsigned char *free_mem_313147;
};
struct futhark_mc_segmap_parloop_struct_337867 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_t_292679;
    int64_t free_jump_t_292685;
    int64_t free_partition_sizze_292766;
    int64_t free_t_n_m_292839;
    int64_t free_i_292846;
    bool free_x_292847;
    int64_t free_min_res_293170;
    bool free_loop_cond_293175;
    double free_i64_res_293176;
    int64_t free_bytes_312598;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_312639;
    int64_t free_bytes_313090;
    unsigned char *free_mem_313143;
    unsigned char *free_mem_313147;
};
static int futhark_mc_segmap_parloop_337868(void *args, int64_t start,
                                            int64_t end, int flat_tid_298145,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_337867
    *futhark_mc_segmap_parloop_struct_337867 =
    (struct futhark_mc_segmap_parloop_struct_337867 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_337867->ctx;
    uint64_t futhark_mc_segmap_parloop_337868_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_337868_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_337867->free_n_292675;
    int64_t q_t_292679 =
            futhark_mc_segmap_parloop_struct_337867->free_q_t_292679;
    int64_t jump_t_292685 =
            futhark_mc_segmap_parloop_struct_337867->free_jump_t_292685;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_337867->free_partition_sizze_292766;
    int64_t t_n_m_292839 =
            futhark_mc_segmap_parloop_struct_337867->free_t_n_m_292839;
    int64_t i_292846 = futhark_mc_segmap_parloop_struct_337867->free_i_292846;
    bool x_292847 = futhark_mc_segmap_parloop_struct_337867->free_x_292847;
    int64_t min_res_293170 =
            futhark_mc_segmap_parloop_struct_337867->free_min_res_293170;
    bool loop_cond_293175 =
         futhark_mc_segmap_parloop_struct_337867->free_loop_cond_293175;
    double i64_res_293176 =
           futhark_mc_segmap_parloop_struct_337867->free_i64_res_293176;
    int64_t bytes_312598 =
            futhark_mc_segmap_parloop_struct_337867->free_bytes_312598;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_segmap_parloop_struct_337867->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_312639 = {.desc ="mem_312639", .mem =
                                  futhark_mc_segmap_parloop_struct_337867->free_mem_312639,
                                  .size =0, .references =NULL};
    int64_t bytes_313090 =
            futhark_mc_segmap_parloop_struct_337867->free_bytes_313090;
    struct memblock mem_313143 = {.desc ="mem_313143", .mem =
                                  futhark_mc_segmap_parloop_struct_337867->free_mem_313143,
                                  .size =0, .references =NULL};
    struct memblock mem_313147 = {.desc ="mem_313147", .mem =
                                  futhark_mc_segmap_parloop_struct_337867->free_mem_313147,
                                  .size =0, .references =NULL};
    size_t mem_313097_cached_sizze_337869 = 0;
    unsigned char *mem_313097 = NULL;
    size_t mem_313112_cached_sizze_337870 = 0;
    unsigned char *mem_313112 = NULL;
    size_t mem_313115_cached_sizze_337871 = 0;
    unsigned char *mem_313115 = NULL;
    int64_t iterations = end - start;
    int64_t iter_318593 = start;
    
    if (mem_313097_cached_sizze_337869 < (size_t) bytes_312598) {
        mem_313097 = realloc(mem_313097, bytes_312598);
        mem_313097_cached_sizze_337869 = bytes_312598;
    }
    if (mem_313112_cached_sizze_337870 < (size_t) bytes_313090) {
        mem_313112 = realloc(mem_313112, bytes_313090);
        mem_313112_cached_sizze_337870 = bytes_313090;
    }
    if (mem_313115_cached_sizze_337871 < (size_t) bytes_313090) {
        mem_313115 = realloc(mem_313115, bytes_313090);
        mem_313115_cached_sizze_337871 = bytes_313090;
    }
    for (; iter_318593 < end; iter_318593++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_318690 = partition_sizze_292766;
        int64_t gtid_298146 = iter_318593;
        int64_t remnant_318691 = iter_318593 - gtid_298146;
        int64_t x_293180;
        
        x_293180 = ((int64_t *) mem_312639.mem)[gtid_298146];
        for (int64_t i_318594 = 0; i_318594 < n_292675; i_318594++) {
            int64_t x_318596;
            
            x_318596 = ((int64_t *) mem_312636.mem)[gtid_298146 * n_292675 +
                                                    i_318594];
            
            int64_t defunc_0_f_res_318597 = add64((int64_t) 1, x_318596);
            
            ((int64_t *) mem_313097)[i_318594] = defunc_0_f_res_318597;
        }
        
        int64_t min_arg_293184 = sub64(x_293180, (int64_t) 1);
        int64_t min_arg_293185 = sub64(x_293180, min_res_293170);
        int64_t min_res_293186 = smin64(q_t_292679, x_293180);
        double i64_res_293187 = sitofp_i64_f64(x_293180);
        double x_293188 = i64_res_293176 - i64_res_293187;
        double max_arg_293189 = x_293188 / 2.0;
        double max_res_293190 = fmax64(0.0, max_arg_293189);
        
        for (int64_t i_318599 = 0; i_318599 < t_n_m_292839; i_318599++) {
            int64_t min_arg_318602 = mul64(jump_t_292685, i_318599);
            int64_t min_res_318603 = smin64(i_292846, min_arg_318602);
            int64_t defunc_0_g_res_318604 = add64((int64_t) 1, min_res_318603);
            bool init_idx_318605;
            int64_t init_idx_318606;
            int64_t init_idx_318607;
            bool loop_while_318608;
            int64_t low_318609;
            int64_t high_318610;
            
            loop_while_318608 = x_292847;
            low_318609 = (int64_t) 0;
            high_318610 = i_292846;
            while (loop_while_318608) {
                int64_t x_318611 = add64(low_318609, high_318610);
                int64_t mid_318612 = sdiv64(x_318611, (int64_t) 2);
                bool x_318613 = sle64((int64_t) 0, mid_318612);
                bool y_318614 = slt64(mid_318612, n_292675);
                bool bounds_check_318615 = x_318613 && y_318614;
                bool index_certs_318616;
                
                if (!bounds_check_318615) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [", (long long) mid_318612,
                                  "] out of bounds for array of shape [",
                                  (long long) n_292675, "].",
                                  "-> #0  loess.fut:645:26-36\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:638:3-665:10\n   #5  loess.fut:698:15-61\n   #6  stl.fut:155:13-60\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:153:5-156:26\n   #10 stl.fut:419:61-435:77\n   #11 stl.fut:463:3-479:36\n   #12 stl.fut:445:1-479:36\n");
                    err = FUTHARK_PROGRAM_ERROR;
                    goto cleanup;
                }
                
                int64_t mid_id_318617;
                
                mid_id_318617 = ((int64_t *) mem_313097)[mid_318612];
                
                bool cond_318618 = slt64(mid_id_318617, (int64_t) 0);
                int64_t mid_idx_318619;
                
                if (cond_318618) {
                    mid_idx_318619 = (int64_t) 9223372036854775807;
                } else {
                    mid_idx_318619 = mid_id_318617;
                }
                
                bool cond_318620 = sle64(defunc_0_g_res_318604, mid_idx_318619);
                int64_t loopres_318621;
                int64_t loopres_318622;
                
                if (cond_318620) {
                    int64_t loopres_t_res_318623 = sub64(mid_318612,
                                                         (int64_t) 1);
                    
                    loopres_318621 = low_318609;
                    loopres_318622 = loopres_t_res_318623;
                } else {
                    int64_t loopres_f_res_318624 = add64((int64_t) 1,
                                                         mid_318612);
                    
                    loopres_318621 = loopres_f_res_318624;
                    loopres_318622 = high_318610;
                }
                
                bool loop_cond_318625 = sle64(loopres_318621, loopres_318622);
                bool loop_while_tmp_318695 = loop_cond_318625;
                int64_t low_tmp_318696 = loopres_318621;
                int64_t high_tmp_318697 = loopres_318622;
                
                loop_while_318608 = loop_while_tmp_318695;
                low_318609 = low_tmp_318696;
                high_318610 = high_tmp_318697;
            }
            init_idx_318605 = loop_while_318608;
            init_idx_318606 = low_318609;
            init_idx_318607 = high_318610;
            
            bool idx_318626;
            int64_t idx_318627;
            int64_t idx_318628;
            int64_t idx_318629;
            bool loop_while_318630;
            int64_t l_idx_318631;
            int64_t r_idx_318632;
            int64_t span_318633;
            
            loop_while_318630 = loop_cond_293175;
            l_idx_318631 = init_idx_318606;
            r_idx_318632 = init_idx_318606;
            span_318633 = (int64_t) 1;
            while (loop_while_318630) {
                int64_t max_arg_318634 = sub64(l_idx_318631, (int64_t) 1);
                int64_t max_res_318635 = smax64((int64_t) 0, max_arg_318634);
                int64_t min_arg_318636 = add64((int64_t) 1, r_idx_318632);
                int64_t min_res_318637 = smin64(min_arg_293184, min_arg_318636);
                bool x_318638 = sle64((int64_t) 0, max_res_318635);
                bool y_318639 = slt64(max_res_318635, n_292675);
                bool bounds_check_318640 = x_318638 && y_318639;
                bool index_certs_318641;
                
                if (!bounds_check_318640) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [", (long long) max_res_318635,
                                  "] out of bounds for array of shape [",
                                  (long long) n_292675, "].",
                                  "-> #0  loess.fut:655:35-48\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:638:3-665:10\n   #5  loess.fut:698:15-61\n   #6  stl.fut:155:13-60\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:153:5-156:26\n   #10 stl.fut:419:61-435:77\n   #11 stl.fut:463:3-479:36\n   #12 stl.fut:445:1-479:36\n");
                    err = FUTHARK_PROGRAM_ERROR;
                    goto cleanup;
                }
                
                int64_t x_318642;
                
                x_318642 = ((int64_t *) mem_313097)[max_res_318635];
                
                int64_t abs_arg_318643 = sub64(x_318642, defunc_0_g_res_318604);
                int64_t abs_res_318644 = abs64(abs_arg_318643);
                bool x_318645 = sle64((int64_t) 0, min_res_318637);
                bool y_318646 = slt64(min_res_318637, n_292675);
                bool bounds_check_318647 = x_318645 && y_318646;
                bool index_certs_318648;
                
                if (!bounds_check_318647) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [", (long long) min_res_318637,
                                  "] out of bounds for array of shape [",
                                  (long long) n_292675, "].",
                                  "-> #0  loess.fut:656:35-48\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:638:3-665:10\n   #5  loess.fut:698:15-61\n   #6  stl.fut:155:13-60\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:153:5-156:26\n   #10 stl.fut:419:61-435:77\n   #11 stl.fut:463:3-479:36\n   #12 stl.fut:445:1-479:36\n");
                    err = FUTHARK_PROGRAM_ERROR;
                    goto cleanup;
                }
                
                int64_t x_318649;
                
                x_318649 = ((int64_t *) mem_313097)[min_res_318637];
                
                int64_t abs_arg_318650 = sub64(x_318649, defunc_0_g_res_318604);
                int64_t abs_res_318651 = abs64(abs_arg_318650);
                bool cond_318652 = max_res_318635 == l_idx_318631;
                int64_t loopres_318653;
                int64_t loopres_318654;
                int64_t loopres_318655;
                
                if (cond_318652) {
                    loopres_318653 = l_idx_318631;
                    loopres_318654 = r_idx_318632;
                    loopres_318655 = min_res_293170;
                } else {
                    bool cond_318656 = slt64(abs_res_318644, abs_res_318651);
                    bool cond_f_res_318657 = min_res_318637 == r_idx_318632;
                    bool x_318658 = !cond_318656;
                    bool y_318659 = cond_f_res_318657 && x_318658;
                    bool cond_318660 = cond_318656 || y_318659;
                    int64_t loopres_f_res_318661;
                    
                    if (cond_318660) {
                        loopres_f_res_318661 = max_res_318635;
                    } else {
                        loopres_f_res_318661 = l_idx_318631;
                    }
                    
                    int64_t loopres_f_res_318662;
                    
                    if (cond_318660) {
                        loopres_f_res_318662 = r_idx_318632;
                    } else {
                        loopres_f_res_318662 = min_res_318637;
                    }
                    
                    int64_t loopres_f_res_318663;
                    
                    if (cond_318660) {
                        int64_t loopres_f_res_t_res_318664 = add64((int64_t) 1,
                                                                   span_318633);
                        
                        loopres_f_res_318663 = loopres_f_res_t_res_318664;
                    } else {
                        int64_t loopres_f_res_f_res_318665 = add64((int64_t) 1,
                                                                   span_318633);
                        
                        loopres_f_res_318663 = loopres_f_res_f_res_318665;
                    }
                    loopres_318653 = loopres_f_res_318661;
                    loopres_318654 = loopres_f_res_318662;
                    loopres_318655 = loopres_f_res_318663;
                }
                
                bool loop_cond_318666 = slt64(loopres_318655, min_res_293170);
                bool loop_while_tmp_318698 = loop_cond_318666;
                int64_t l_idx_tmp_318699 = loopres_318653;
                int64_t r_idx_tmp_318700 = loopres_318654;
                int64_t span_tmp_318701 = loopres_318655;
                
                loop_while_318630 = loop_while_tmp_318698;
                l_idx_318631 = l_idx_tmp_318699;
                r_idx_318632 = r_idx_tmp_318700;
                span_318633 = span_tmp_318701;
            }
            idx_318626 = loop_while_318630;
            idx_318627 = l_idx_318631;
            idx_318628 = r_idx_318632;
            idx_318629 = span_318633;
            
            int64_t min_res_318667 = smin64(min_arg_293185, idx_318627);
            int64_t max_res_318668 = smax64((int64_t) 0, min_res_318667);
            int64_t x_318669 = add64(min_res_293186, max_res_318668);
            int64_t r_318670 = sub64(x_318669, (int64_t) 1);
            bool x_318671 = sle64((int64_t) 0, r_318670);
            bool y_318672 = slt64(r_318670, n_292675);
            bool bounds_check_318673 = x_318671 && y_318672;
            bool index_certs_318674;
            
            if (!bounds_check_318673) {
                ctx->error =
                    msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                              "Index [", (long long) r_318670,
                              "] out of bounds for array of shape [",
                              (long long) n_292675, "].",
                              "-> #0  loess.fut:680:40-47\n   #1  /prelude/soacs.fut:67:19-23\n   #2  /prelude/soacs.fut:67:3-37\n   #3  loess.fut:675:3-683:25\n   #4  loess.fut:699:16-51\n   #5  stl.fut:155:13-60\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  stl.fut:153:5-156:26\n   #9  stl.fut:419:61-435:77\n   #10 stl.fut:463:3-479:36\n   #11 stl.fut:445:1-479:36\n");
                err = FUTHARK_PROGRAM_ERROR;
                goto cleanup;
            }
            
            int64_t x_318675;
            
            x_318675 = ((int64_t *) mem_312636.mem)[gtid_298146 * n_292675 +
                                                    r_318670];
            
            int64_t abs_arg_318676 = sub64(x_318675, min_res_318603);
            int64_t abs_res_318677 = abs64(abs_arg_318676);
            bool x_318678 = sle64((int64_t) 0, max_res_318668);
            bool y_318679 = slt64(max_res_318668, n_292675);
            bool bounds_check_318680 = x_318678 && y_318679;
            bool index_certs_318681;
            
            if (!bounds_check_318680) {
                ctx->error =
                    msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                              "Index [", (long long) max_res_318668,
                              "] out of bounds for array of shape [",
                              (long long) n_292675, "].",
                              "-> #0  loess.fut:679:40-47\n   #1  /prelude/soacs.fut:67:19-23\n   #2  /prelude/soacs.fut:67:3-37\n   #3  loess.fut:675:3-683:25\n   #4  loess.fut:699:16-51\n   #5  stl.fut:155:13-60\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  stl.fut:153:5-156:26\n   #9  stl.fut:419:61-435:77\n   #10 stl.fut:463:3-479:36\n   #11 stl.fut:445:1-479:36\n");
                err = FUTHARK_PROGRAM_ERROR;
                goto cleanup;
            }
            
            int64_t x_318682;
            
            x_318682 = ((int64_t *) mem_312636.mem)[gtid_298146 * n_292675 +
                                                    max_res_318668];
            
            int64_t abs_arg_318683 = sub64(x_318682, min_res_318603);
            int64_t abs_res_318684 = abs64(abs_arg_318683);
            int64_t max_res_318685 = smax64(abs_res_318677, abs_res_318684);
            double defunc_0_f_res_318686 = sitofp_i64_f64(max_res_318685);
            double defunc_1_f_res_318687 = max_res_293190 +
                   defunc_0_f_res_318686;
            
            ((double *) mem_313112)[i_318599] = defunc_1_f_res_318687;
            ((int64_t *) mem_313115)[i_318599] = max_res_318668;
        }
        if (t_n_m_292839 * (int64_t) 8 > 0)
            memmove(mem_313143.mem + gtid_298146 * t_n_m_292839 * (int64_t) 8,
                    mem_313115 + (int64_t) 0, t_n_m_292839 * (int64_t) 8);
        if (t_n_m_292839 * (int64_t) 8 > 0)
            memmove(mem_313147.mem + gtid_298146 * t_n_m_292839 * (int64_t) 8,
                    mem_313112 + (int64_t) 0, t_n_m_292839 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_313097);
    free(mem_313112);
    free(mem_313115);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_337868_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_337868_end -
                 futhark_mc_segmap_parloop_337868_start;
        
        ctx->futhark_mc_segmap_parloop_337868_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_337868_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_337868_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_337866(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_298145 = tid;
    int num_tasks_318592 = info.nsubtasks;
    struct futhark_mc_task_337865 *futhark_mc_task_337865 =
                                  (struct futhark_mc_task_337865 *) args;
    struct futhark_context *ctx = futhark_mc_task_337865->ctx;
    uint64_t futhark_mc_segmap_task_337866_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_337866_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_337865->free_n_292675;
    int64_t q_t_292679 = futhark_mc_task_337865->free_q_t_292679;
    int64_t jump_t_292685 = futhark_mc_task_337865->free_jump_t_292685;
    int64_t partition_sizze_292766 =
            futhark_mc_task_337865->free_partition_sizze_292766;
    int64_t t_n_m_292839 = futhark_mc_task_337865->free_t_n_m_292839;
    int64_t i_292846 = futhark_mc_task_337865->free_i_292846;
    bool x_292847 = futhark_mc_task_337865->free_x_292847;
    int64_t min_res_293170 = futhark_mc_task_337865->free_min_res_293170;
    bool loop_cond_293175 = futhark_mc_task_337865->free_loop_cond_293175;
    double i64_res_293176 = futhark_mc_task_337865->free_i64_res_293176;
    int64_t bytes_312598 = futhark_mc_task_337865->free_bytes_312598;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_task_337865->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_312639 = {.desc ="mem_312639", .mem =
                                  futhark_mc_task_337865->free_mem_312639,
                                  .size =0, .references =NULL};
    int64_t bytes_313090 = futhark_mc_task_337865->free_bytes_313090;
    struct memblock mem_313143 = {.desc ="mem_313143", .mem =
                                  futhark_mc_task_337865->free_mem_313143,
                                  .size =0, .references =NULL};
    struct memblock mem_313147 = {.desc ="mem_313147", .mem =
                                  futhark_mc_task_337865->free_mem_313147,
                                  .size =0, .references =NULL};
    int64_t iter_318593;
    struct futhark_mc_segmap_parloop_struct_337867
    futhark_mc_segmap_parloop_struct_337867;
    
    futhark_mc_segmap_parloop_struct_337867.ctx = ctx;
    futhark_mc_segmap_parloop_struct_337867.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_337867.free_q_t_292679 = q_t_292679;
    futhark_mc_segmap_parloop_struct_337867.free_jump_t_292685 = jump_t_292685;
    futhark_mc_segmap_parloop_struct_337867.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_337867.free_t_n_m_292839 = t_n_m_292839;
    futhark_mc_segmap_parloop_struct_337867.free_i_292846 = i_292846;
    futhark_mc_segmap_parloop_struct_337867.free_x_292847 = x_292847;
    futhark_mc_segmap_parloop_struct_337867.free_min_res_293170 =
        min_res_293170;
    futhark_mc_segmap_parloop_struct_337867.free_loop_cond_293175 =
        loop_cond_293175;
    futhark_mc_segmap_parloop_struct_337867.free_i64_res_293176 =
        i64_res_293176;
    futhark_mc_segmap_parloop_struct_337867.free_bytes_312598 = bytes_312598;
    futhark_mc_segmap_parloop_struct_337867.free_mem_312636 = mem_312636.mem;
    futhark_mc_segmap_parloop_struct_337867.free_mem_312639 = mem_312639.mem;
    futhark_mc_segmap_parloop_struct_337867.free_bytes_313090 = bytes_313090;
    futhark_mc_segmap_parloop_struct_337867.free_mem_313143 = mem_313143.mem;
    futhark_mc_segmap_parloop_struct_337867.free_mem_313147 = mem_313147.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_337868_task;
    
    futhark_mc_segmap_parloop_337868_task.name =
        "futhark_mc_segmap_parloop_337868";
    futhark_mc_segmap_parloop_337868_task.fn = futhark_mc_segmap_parloop_337868;
    futhark_mc_segmap_parloop_337868_task.args =
        &futhark_mc_segmap_parloop_struct_337867;
    futhark_mc_segmap_parloop_337868_task.iterations = iterations;
    futhark_mc_segmap_parloop_337868_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_337868_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_337868_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_337868_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_337868_task);
    
    if (futhark_mc_segmap_parloop_337868_err != 0) {
        err = futhark_mc_segmap_parloop_337868_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_337868_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_337868_total_end -
                 futhark_mc_segmap_parloop_337868_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337868_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337868_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337868_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_337866_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_337866_end -
                 futhark_mc_segmap_task_337866_start;
        
        ctx->futhark_mc_segmap_task_337866_runs[tid]++;
        ctx->futhark_mc_segmap_task_337866_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_337866_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_segmap_parloop_struct_337873 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_t_292679;
    int64_t free_jump_t_292685;
    int64_t free_partition_sizze_292766;
    int64_t free_t_n_m_292839;
    int64_t free_i_292846;
    bool free_x_292847;
    int64_t free_min_res_293170;
    bool free_loop_cond_293175;
    double free_i64_res_293176;
    int64_t free_bytes_312598;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_312639;
    int64_t free_bytes_313090;
    unsigned char *free_mem_313143;
    unsigned char *free_mem_313147;
};
struct futhark_mc_task_337878 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_298154;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_313088;
};
struct futhark_mc_segmap_parloop_struct_337880 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_298154;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_313088;
};
static int futhark_mc_segmap_parloop_337881(void *args, int64_t start,
                                            int64_t end, int flat_tid_318703,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_337880
    *futhark_mc_segmap_parloop_struct_337880 =
    (struct futhark_mc_segmap_parloop_struct_337880 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_337880->ctx;
    uint64_t futhark_mc_segmap_parloop_337881_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_337881_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_337880->free_n_292675;
    int64_t gtid_298154 =
            futhark_mc_segmap_parloop_struct_337880->free_gtid_298154;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_segmap_parloop_struct_337880->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_313088 = {.desc ="mem_313088", .mem =
                                  futhark_mc_segmap_parloop_struct_337880->free_mem_313088,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_318798 = start;
    
    for (; iter_318798 < end; iter_318798++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_318799 = n_292675;
        int64_t gtid_318704 = iter_318798;
        int64_t remnant_318800 = iter_318798 - gtid_318704;
        int64_t x_318705;
        
        x_318705 = ((int64_t *) mem_312636.mem)[gtid_298154 * n_292675 +
                                                gtid_318704];
        
        int64_t defunc_0_f_res_318706 = add64((int64_t) 1, x_318705);
        
        ((int64_t *) mem_313088.mem)[gtid_318704] = defunc_0_f_res_318706;
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_337881_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_337881_end -
                 futhark_mc_segmap_parloop_337881_start;
        
        ctx->futhark_mc_segmap_parloop_337881_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_337881_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_337881_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_337879(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_318703 = tid;
    int num_tasks_318797 = info.nsubtasks;
    struct futhark_mc_task_337878 *futhark_mc_task_337878 =
                                  (struct futhark_mc_task_337878 *) args;
    struct futhark_context *ctx = futhark_mc_task_337878->ctx;
    uint64_t futhark_mc_segmap_task_337879_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_337879_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_337878->free_n_292675;
    int64_t gtid_298154 = futhark_mc_task_337878->free_gtid_298154;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_task_337878->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_313088 = {.desc ="mem_313088", .mem =
                                  futhark_mc_task_337878->free_mem_313088,
                                  .size =0, .references =NULL};
    int64_t iter_318798;
    struct futhark_mc_segmap_parloop_struct_337880
    futhark_mc_segmap_parloop_struct_337880;
    
    futhark_mc_segmap_parloop_struct_337880.ctx = ctx;
    futhark_mc_segmap_parloop_struct_337880.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_337880.free_gtid_298154 = gtid_298154;
    futhark_mc_segmap_parloop_struct_337880.free_mem_312636 = mem_312636.mem;
    futhark_mc_segmap_parloop_struct_337880.free_mem_313088 = mem_313088.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_337881_task;
    
    futhark_mc_segmap_parloop_337881_task.name =
        "futhark_mc_segmap_parloop_337881";
    futhark_mc_segmap_parloop_337881_task.fn = futhark_mc_segmap_parloop_337881;
    futhark_mc_segmap_parloop_337881_task.args =
        &futhark_mc_segmap_parloop_struct_337880;
    futhark_mc_segmap_parloop_337881_task.iterations = iterations;
    futhark_mc_segmap_parloop_337881_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_337881_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_337881_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_337881_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_337881_task);
    
    if (futhark_mc_segmap_parloop_337881_err != 0) {
        err = futhark_mc_segmap_parloop_337881_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_337881_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_337881_total_end -
                 futhark_mc_segmap_parloop_337881_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337881_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337881_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337881_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_337879_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_337879_end -
                 futhark_mc_segmap_task_337879_start;
        
        ctx->futhark_mc_segmap_task_337879_runs[tid]++;
        ctx->futhark_mc_segmap_task_337879_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_337879_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_task_337882 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_jump_t_292685;
    int64_t free_t_n_m_292839;
    int64_t free_i_292846;
    bool free_x_292847;
    int64_t free_min_res_293170;
    bool free_loop_cond_293175;
    int64_t free_gtid_298154;
    int64_t free_min_arg_298162;
    int64_t free_min_arg_298163;
    int64_t free_min_res_298164;
    double free_max_res_298168;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_313088;
    unsigned char *free_mem_313091;
    unsigned char *free_mem_313094;
};
struct futhark_mc_segmap_parloop_struct_337884 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_jump_t_292685;
    int64_t free_t_n_m_292839;
    int64_t free_i_292846;
    bool free_x_292847;
    int64_t free_min_res_293170;
    bool free_loop_cond_293175;
    int64_t free_gtid_298154;
    int64_t free_min_arg_298162;
    int64_t free_min_arg_298163;
    int64_t free_min_res_298164;
    double free_max_res_298168;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_313088;
    unsigned char *free_mem_313091;
    unsigned char *free_mem_313094;
};
static int futhark_mc_segmap_parloop_337885(void *args, int64_t start,
                                            int64_t end, int flat_tid_318707,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_337884
    *futhark_mc_segmap_parloop_struct_337884 =
    (struct futhark_mc_segmap_parloop_struct_337884 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_337884->ctx;
    uint64_t futhark_mc_segmap_parloop_337885_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_337885_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_337884->free_n_292675;
    int64_t jump_t_292685 =
            futhark_mc_segmap_parloop_struct_337884->free_jump_t_292685;
    int64_t t_n_m_292839 =
            futhark_mc_segmap_parloop_struct_337884->free_t_n_m_292839;
    int64_t i_292846 = futhark_mc_segmap_parloop_struct_337884->free_i_292846;
    bool x_292847 = futhark_mc_segmap_parloop_struct_337884->free_x_292847;
    int64_t min_res_293170 =
            futhark_mc_segmap_parloop_struct_337884->free_min_res_293170;
    bool loop_cond_293175 =
         futhark_mc_segmap_parloop_struct_337884->free_loop_cond_293175;
    int64_t gtid_298154 =
            futhark_mc_segmap_parloop_struct_337884->free_gtid_298154;
    int64_t min_arg_298162 =
            futhark_mc_segmap_parloop_struct_337884->free_min_arg_298162;
    int64_t min_arg_298163 =
            futhark_mc_segmap_parloop_struct_337884->free_min_arg_298163;
    int64_t min_res_298164 =
            futhark_mc_segmap_parloop_struct_337884->free_min_res_298164;
    double max_res_298168 =
           futhark_mc_segmap_parloop_struct_337884->free_max_res_298168;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_segmap_parloop_struct_337884->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_313088 = {.desc ="mem_313088", .mem =
                                  futhark_mc_segmap_parloop_struct_337884->free_mem_313088,
                                  .size =0, .references =NULL};
    struct memblock mem_313091 = {.desc ="mem_313091", .mem =
                                  futhark_mc_segmap_parloop_struct_337884->free_mem_313091,
                                  .size =0, .references =NULL};
    struct memblock mem_313094 = {.desc ="mem_313094", .mem =
                                  futhark_mc_segmap_parloop_struct_337884->free_mem_313094,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_318802 = start;
    
    for (; iter_318802 < end; iter_318802++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_318858 = t_n_m_292839;
        int64_t gtid_318708 = iter_318802;
        int64_t remnant_318859 = iter_318802 - gtid_318708;
        int64_t min_arg_318709 = mul64(jump_t_292685, gtid_318708);
        int64_t min_res_318710 = smin64(i_292846, min_arg_318709);
        int64_t defunc_0_g_res_318711 = add64((int64_t) 1, min_res_318710);
        bool init_idx_318712;
        int64_t init_idx_318713;
        int64_t init_idx_318714;
        bool loop_while_318803;
        int64_t low_318804;
        int64_t high_318805;
        
        loop_while_318803 = x_292847;
        low_318804 = (int64_t) 0;
        high_318805 = i_292846;
        while (loop_while_318803) {
            int64_t x_318806 = add64(low_318804, high_318805);
            int64_t mid_318807 = sdiv64(x_318806, (int64_t) 2);
            bool x_318808 = sle64((int64_t) 0, mid_318807);
            bool y_318809 = slt64(mid_318807, n_292675);
            bool bounds_check_318810 = x_318808 && y_318809;
            bool index_certs_318811;
            
            if (!bounds_check_318810) {
                ctx->error =
                    msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                              "Index [", (long long) mid_318807,
                              "] out of bounds for array of shape [",
                              (long long) n_292675, "].",
                              "-> #0  loess.fut:645:26-36\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:638:3-665:10\n   #5  loess.fut:698:15-61\n   #6  stl.fut:155:13-60\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:153:5-156:26\n   #10 stl.fut:419:61-435:77\n   #11 stl.fut:463:3-479:36\n   #12 stl.fut:445:1-479:36\n");
                err = FUTHARK_PROGRAM_ERROR;
                goto cleanup;
            }
            
            int64_t mid_id_318812;
            
            mid_id_318812 = ((int64_t *) mem_313088.mem)[mid_318807];
            
            bool cond_318813 = slt64(mid_id_318812, (int64_t) 0);
            int64_t mid_idx_318814;
            
            if (cond_318813) {
                mid_idx_318814 = (int64_t) 9223372036854775807;
            } else {
                mid_idx_318814 = mid_id_318812;
            }
            
            bool cond_318815 = sle64(defunc_0_g_res_318711, mid_idx_318814);
            int64_t loopres_318816;
            int64_t loopres_318817;
            
            if (cond_318815) {
                int64_t loopres_t_res_318818 = sub64(mid_318807, (int64_t) 1);
                
                loopres_318816 = low_318804;
                loopres_318817 = loopres_t_res_318818;
            } else {
                int64_t loopres_f_res_318819 = add64((int64_t) 1, mid_318807);
                
                loopres_318816 = loopres_f_res_318819;
                loopres_318817 = high_318805;
            }
            
            bool loop_cond_318820 = sle64(loopres_318816, loopres_318817);
            bool loop_while_tmp_318860 = loop_cond_318820;
            int64_t low_tmp_318861 = loopres_318816;
            int64_t high_tmp_318862 = loopres_318817;
            
            loop_while_318803 = loop_while_tmp_318860;
            low_318804 = low_tmp_318861;
            high_318805 = high_tmp_318862;
        }
        init_idx_318712 = loop_while_318803;
        init_idx_318713 = low_318804;
        init_idx_318714 = high_318805;
        
        bool idx_318733;
        int64_t idx_318734;
        int64_t idx_318735;
        int64_t idx_318736;
        bool loop_while_318821;
        int64_t l_idx_318822;
        int64_t r_idx_318823;
        int64_t span_318824;
        
        loop_while_318821 = loop_cond_293175;
        l_idx_318822 = init_idx_318713;
        r_idx_318823 = init_idx_318713;
        span_318824 = (int64_t) 1;
        while (loop_while_318821) {
            int64_t max_arg_318825 = sub64(l_idx_318822, (int64_t) 1);
            int64_t max_res_318826 = smax64((int64_t) 0, max_arg_318825);
            int64_t min_arg_318827 = add64((int64_t) 1, r_idx_318823);
            int64_t min_res_318828 = smin64(min_arg_298162, min_arg_318827);
            bool x_318829 = sle64((int64_t) 0, max_res_318826);
            bool y_318830 = slt64(max_res_318826, n_292675);
            bool bounds_check_318831 = x_318829 && y_318830;
            bool index_certs_318832;
            
            if (!bounds_check_318831) {
                ctx->error =
                    msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                              "Index [", (long long) max_res_318826,
                              "] out of bounds for array of shape [",
                              (long long) n_292675, "].",
                              "-> #0  loess.fut:655:35-48\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:638:3-665:10\n   #5  loess.fut:698:15-61\n   #6  stl.fut:155:13-60\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:153:5-156:26\n   #10 stl.fut:419:61-435:77\n   #11 stl.fut:463:3-479:36\n   #12 stl.fut:445:1-479:36\n");
                err = FUTHARK_PROGRAM_ERROR;
                goto cleanup;
            }
            
            int64_t x_318833;
            
            x_318833 = ((int64_t *) mem_313088.mem)[max_res_318826];
            
            int64_t abs_arg_318834 = sub64(x_318833, defunc_0_g_res_318711);
            int64_t abs_res_318835 = abs64(abs_arg_318834);
            bool x_318836 = sle64((int64_t) 0, min_res_318828);
            bool y_318837 = slt64(min_res_318828, n_292675);
            bool bounds_check_318838 = x_318836 && y_318837;
            bool index_certs_318839;
            
            if (!bounds_check_318838) {
                ctx->error =
                    msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                              "Index [", (long long) min_res_318828,
                              "] out of bounds for array of shape [",
                              (long long) n_292675, "].",
                              "-> #0  loess.fut:656:35-48\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:638:3-665:10\n   #5  loess.fut:698:15-61\n   #6  stl.fut:155:13-60\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:153:5-156:26\n   #10 stl.fut:419:61-435:77\n   #11 stl.fut:463:3-479:36\n   #12 stl.fut:445:1-479:36\n");
                err = FUTHARK_PROGRAM_ERROR;
                goto cleanup;
            }
            
            int64_t x_318840;
            
            x_318840 = ((int64_t *) mem_313088.mem)[min_res_318828];
            
            int64_t abs_arg_318841 = sub64(x_318840, defunc_0_g_res_318711);
            int64_t abs_res_318842 = abs64(abs_arg_318841);
            bool cond_318843 = max_res_318826 == l_idx_318822;
            int64_t loopres_318844;
            int64_t loopres_318845;
            int64_t loopres_318846;
            
            if (cond_318843) {
                loopres_318844 = l_idx_318822;
                loopres_318845 = r_idx_318823;
                loopres_318846 = min_res_293170;
            } else {
                bool cond_318847 = slt64(abs_res_318835, abs_res_318842);
                bool cond_f_res_318848 = min_res_318828 == r_idx_318823;
                bool x_318849 = !cond_318847;
                bool y_318850 = cond_f_res_318848 && x_318849;
                bool cond_318851 = cond_318847 || y_318850;
                int64_t loopres_f_res_318852;
                
                if (cond_318851) {
                    loopres_f_res_318852 = max_res_318826;
                } else {
                    loopres_f_res_318852 = l_idx_318822;
                }
                
                int64_t loopres_f_res_318853;
                
                if (cond_318851) {
                    loopres_f_res_318853 = r_idx_318823;
                } else {
                    loopres_f_res_318853 = min_res_318828;
                }
                
                int64_t loopres_f_res_318854;
                
                if (cond_318851) {
                    int64_t loopres_f_res_t_res_318855 = add64((int64_t) 1,
                                                               span_318824);
                    
                    loopres_f_res_318854 = loopres_f_res_t_res_318855;
                } else {
                    int64_t loopres_f_res_f_res_318856 = add64((int64_t) 1,
                                                               span_318824);
                    
                    loopres_f_res_318854 = loopres_f_res_f_res_318856;
                }
                loopres_318844 = loopres_f_res_318852;
                loopres_318845 = loopres_f_res_318853;
                loopres_318846 = loopres_f_res_318854;
            }
            
            bool loop_cond_318857 = slt64(loopres_318846, min_res_293170);
            bool loop_while_tmp_318863 = loop_cond_318857;
            int64_t l_idx_tmp_318864 = loopres_318844;
            int64_t r_idx_tmp_318865 = loopres_318845;
            int64_t span_tmp_318866 = loopres_318846;
            
            loop_while_318821 = loop_while_tmp_318863;
            l_idx_318822 = l_idx_tmp_318864;
            r_idx_318823 = r_idx_tmp_318865;
            span_318824 = span_tmp_318866;
        }
        idx_318733 = loop_while_318821;
        idx_318734 = l_idx_318822;
        idx_318735 = r_idx_318823;
        idx_318736 = span_318824;
        
        int64_t min_res_318774 = smin64(min_arg_298163, idx_318734);
        int64_t max_res_318775 = smax64((int64_t) 0, min_res_318774);
        int64_t x_318776 = add64(min_res_298164, max_res_318775);
        int64_t r_318777 = sub64(x_318776, (int64_t) 1);
        bool x_318778 = sle64((int64_t) 0, r_318777);
        bool y_318779 = slt64(r_318777, n_292675);
        bool bounds_check_318780 = x_318778 && y_318779;
        bool index_certs_318781;
        
        if (!bounds_check_318780) {
            ctx->error = msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                   "Index [", (long long) r_318777,
                                   "] out of bounds for array of shape [",
                                   (long long) n_292675, "].",
                                   "-> #0  loess.fut:680:40-47\n   #1  /prelude/soacs.fut:67:19-23\n   #2  /prelude/soacs.fut:67:3-37\n   #3  loess.fut:675:3-683:25\n   #4  loess.fut:699:16-51\n   #5  stl.fut:155:13-60\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  stl.fut:153:5-156:26\n   #9  stl.fut:419:61-435:77\n   #10 stl.fut:463:3-479:36\n   #11 stl.fut:445:1-479:36\n");
            err = FUTHARK_PROGRAM_ERROR;
            goto cleanup;
        }
        
        int64_t x_318782;
        
        x_318782 = ((int64_t *) mem_312636.mem)[gtid_298154 * n_292675 +
                                                r_318777];
        
        int64_t abs_arg_318783 = sub64(x_318782, min_res_318710);
        int64_t abs_res_318784 = abs64(abs_arg_318783);
        bool x_318785 = sle64((int64_t) 0, max_res_318775);
        bool y_318786 = slt64(max_res_318775, n_292675);
        bool bounds_check_318787 = x_318785 && y_318786;
        bool index_certs_318788;
        
        if (!bounds_check_318787) {
            ctx->error = msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                   "Index [", (long long) max_res_318775,
                                   "] out of bounds for array of shape [",
                                   (long long) n_292675, "].",
                                   "-> #0  loess.fut:679:40-47\n   #1  /prelude/soacs.fut:67:19-23\n   #2  /prelude/soacs.fut:67:3-37\n   #3  loess.fut:675:3-683:25\n   #4  loess.fut:699:16-51\n   #5  stl.fut:155:13-60\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  stl.fut:153:5-156:26\n   #9  stl.fut:419:61-435:77\n   #10 stl.fut:463:3-479:36\n   #11 stl.fut:445:1-479:36\n");
            err = FUTHARK_PROGRAM_ERROR;
            goto cleanup;
        }
        
        int64_t x_318789;
        
        x_318789 = ((int64_t *) mem_312636.mem)[gtid_298154 * n_292675 +
                                                max_res_318775];
        
        int64_t abs_arg_318790 = sub64(x_318789, min_res_318710);
        int64_t abs_res_318791 = abs64(abs_arg_318790);
        int64_t max_res_318792 = smax64(abs_res_318784, abs_res_318791);
        double defunc_0_f_res_318793 = sitofp_i64_f64(max_res_318792);
        double defunc_1_f_res_318794 = max_res_298168 + defunc_0_f_res_318793;
        
        ((double *) mem_313091.mem)[gtid_318708] = defunc_1_f_res_318794;
        ((int64_t *) mem_313094.mem)[gtid_318708] = max_res_318775;
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_337885_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_337885_end -
                 futhark_mc_segmap_parloop_337885_start;
        
        ctx->futhark_mc_segmap_parloop_337885_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_337885_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_337885_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_337883(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_318707 = tid;
    int num_tasks_318801 = info.nsubtasks;
    struct futhark_mc_task_337882 *futhark_mc_task_337882 =
                                  (struct futhark_mc_task_337882 *) args;
    struct futhark_context *ctx = futhark_mc_task_337882->ctx;
    uint64_t futhark_mc_segmap_task_337883_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_337883_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_337882->free_n_292675;
    int64_t jump_t_292685 = futhark_mc_task_337882->free_jump_t_292685;
    int64_t t_n_m_292839 = futhark_mc_task_337882->free_t_n_m_292839;
    int64_t i_292846 = futhark_mc_task_337882->free_i_292846;
    bool x_292847 = futhark_mc_task_337882->free_x_292847;
    int64_t min_res_293170 = futhark_mc_task_337882->free_min_res_293170;
    bool loop_cond_293175 = futhark_mc_task_337882->free_loop_cond_293175;
    int64_t gtid_298154 = futhark_mc_task_337882->free_gtid_298154;
    int64_t min_arg_298162 = futhark_mc_task_337882->free_min_arg_298162;
    int64_t min_arg_298163 = futhark_mc_task_337882->free_min_arg_298163;
    int64_t min_res_298164 = futhark_mc_task_337882->free_min_res_298164;
    double max_res_298168 = futhark_mc_task_337882->free_max_res_298168;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_task_337882->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_313088 = {.desc ="mem_313088", .mem =
                                  futhark_mc_task_337882->free_mem_313088,
                                  .size =0, .references =NULL};
    struct memblock mem_313091 = {.desc ="mem_313091", .mem =
                                  futhark_mc_task_337882->free_mem_313091,
                                  .size =0, .references =NULL};
    struct memblock mem_313094 = {.desc ="mem_313094", .mem =
                                  futhark_mc_task_337882->free_mem_313094,
                                  .size =0, .references =NULL};
    int64_t iter_318802;
    struct futhark_mc_segmap_parloop_struct_337884
    futhark_mc_segmap_parloop_struct_337884;
    
    futhark_mc_segmap_parloop_struct_337884.ctx = ctx;
    futhark_mc_segmap_parloop_struct_337884.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_337884.free_jump_t_292685 = jump_t_292685;
    futhark_mc_segmap_parloop_struct_337884.free_t_n_m_292839 = t_n_m_292839;
    futhark_mc_segmap_parloop_struct_337884.free_i_292846 = i_292846;
    futhark_mc_segmap_parloop_struct_337884.free_x_292847 = x_292847;
    futhark_mc_segmap_parloop_struct_337884.free_min_res_293170 =
        min_res_293170;
    futhark_mc_segmap_parloop_struct_337884.free_loop_cond_293175 =
        loop_cond_293175;
    futhark_mc_segmap_parloop_struct_337884.free_gtid_298154 = gtid_298154;
    futhark_mc_segmap_parloop_struct_337884.free_min_arg_298162 =
        min_arg_298162;
    futhark_mc_segmap_parloop_struct_337884.free_min_arg_298163 =
        min_arg_298163;
    futhark_mc_segmap_parloop_struct_337884.free_min_res_298164 =
        min_res_298164;
    futhark_mc_segmap_parloop_struct_337884.free_max_res_298168 =
        max_res_298168;
    futhark_mc_segmap_parloop_struct_337884.free_mem_312636 = mem_312636.mem;
    futhark_mc_segmap_parloop_struct_337884.free_mem_313088 = mem_313088.mem;
    futhark_mc_segmap_parloop_struct_337884.free_mem_313091 = mem_313091.mem;
    futhark_mc_segmap_parloop_struct_337884.free_mem_313094 = mem_313094.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_337885_task;
    
    futhark_mc_segmap_parloop_337885_task.name =
        "futhark_mc_segmap_parloop_337885";
    futhark_mc_segmap_parloop_337885_task.fn = futhark_mc_segmap_parloop_337885;
    futhark_mc_segmap_parloop_337885_task.args =
        &futhark_mc_segmap_parloop_struct_337884;
    futhark_mc_segmap_parloop_337885_task.iterations = iterations;
    futhark_mc_segmap_parloop_337885_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_337885_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_337885_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_337885_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_337885_task);
    
    if (futhark_mc_segmap_parloop_337885_err != 0) {
        err = futhark_mc_segmap_parloop_337885_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_337885_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_337885_total_end -
                 futhark_mc_segmap_parloop_337885_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337885_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337885_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337885_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_337883_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_337883_end -
                 futhark_mc_segmap_task_337883_start;
        
        ctx->futhark_mc_segmap_task_337883_runs[tid]++;
        ctx->futhark_mc_segmap_task_337883_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_337883_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
static int futhark_mc_segmap_parloop_337874(void *args, int64_t start,
                                            int64_t end, int flat_tid_298153,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_337873
    *futhark_mc_segmap_parloop_struct_337873 =
    (struct futhark_mc_segmap_parloop_struct_337873 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_337873->ctx;
    uint64_t futhark_mc_segmap_parloop_337874_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_337874_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_337873->free_n_292675;
    int64_t q_t_292679 =
            futhark_mc_segmap_parloop_struct_337873->free_q_t_292679;
    int64_t jump_t_292685 =
            futhark_mc_segmap_parloop_struct_337873->free_jump_t_292685;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_337873->free_partition_sizze_292766;
    int64_t t_n_m_292839 =
            futhark_mc_segmap_parloop_struct_337873->free_t_n_m_292839;
    int64_t i_292846 = futhark_mc_segmap_parloop_struct_337873->free_i_292846;
    bool x_292847 = futhark_mc_segmap_parloop_struct_337873->free_x_292847;
    int64_t min_res_293170 =
            futhark_mc_segmap_parloop_struct_337873->free_min_res_293170;
    bool loop_cond_293175 =
         futhark_mc_segmap_parloop_struct_337873->free_loop_cond_293175;
    double i64_res_293176 =
           futhark_mc_segmap_parloop_struct_337873->free_i64_res_293176;
    int64_t bytes_312598 =
            futhark_mc_segmap_parloop_struct_337873->free_bytes_312598;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_segmap_parloop_struct_337873->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_312639 = {.desc ="mem_312639", .mem =
                                  futhark_mc_segmap_parloop_struct_337873->free_mem_312639,
                                  .size =0, .references =NULL};
    int64_t bytes_313090 =
            futhark_mc_segmap_parloop_struct_337873->free_bytes_313090;
    struct memblock mem_313143 = {.desc ="mem_313143", .mem =
                                  futhark_mc_segmap_parloop_struct_337873->free_mem_313143,
                                  .size =0, .references =NULL};
    struct memblock mem_313147 = {.desc ="mem_313147", .mem =
                                  futhark_mc_segmap_parloop_struct_337873->free_mem_313147,
                                  .size =0, .references =NULL};
    size_t mem_313088_cached_sizze_337875 = 0;
    unsigned char *mem_313088 = NULL;
    size_t mem_313091_cached_sizze_337876 = 0;
    unsigned char *mem_313091 = NULL;
    size_t mem_313094_cached_sizze_337877 = 0;
    unsigned char *mem_313094 = NULL;
    int64_t iterations = end - start;
    int64_t iter_318702 = start;
    
    if (mem_313088_cached_sizze_337875 < (size_t) bytes_312598) {
        mem_313088 = realloc(mem_313088, bytes_312598);
        mem_313088_cached_sizze_337875 = bytes_312598;
    }
    if (mem_313091_cached_sizze_337876 < (size_t) bytes_313090) {
        mem_313091 = realloc(mem_313091, bytes_313090);
        mem_313091_cached_sizze_337876 = bytes_313090;
    }
    if (mem_313094_cached_sizze_337877 < (size_t) bytes_313090) {
        mem_313094 = realloc(mem_313094, bytes_313090);
        mem_313094_cached_sizze_337877 = bytes_313090;
    }
    for (; iter_318702 < end; iter_318702++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_318795 = partition_sizze_292766;
        int64_t gtid_298154 = iter_318702;
        int64_t remnant_318796 = iter_318702 - gtid_298154;
        int64_t x_298156;
        
        x_298156 = ((int64_t *) mem_312639.mem)[gtid_298154];
        
        int64_t flat_tid_318703 = (int64_t) 0;
        int32_t num_tasks_318797;
        struct futhark_mc_task_337878 futhark_mc_task_337878;
        
        futhark_mc_task_337878.ctx = ctx;
        futhark_mc_task_337878.free_n_292675 = n_292675;
        futhark_mc_task_337878.free_gtid_298154 = gtid_298154;
        futhark_mc_task_337878.free_mem_312636 = mem_312636.mem;
        futhark_mc_task_337878.free_mem_313088 = mem_313088;
        
        struct scheduler_segop futhark_mc_task_337878_task;
        
        futhark_mc_task_337878_task.args = &futhark_mc_task_337878;
        futhark_mc_task_337878_task.top_level_fn =
            futhark_mc_segmap_task_337879;
        futhark_mc_task_337878_task.name = "futhark_mc_segmap_task_337879";
        futhark_mc_task_337878_task.iterations = n_292675;
        futhark_mc_task_337878_task.task_time =
            &ctx->futhark_mc_segmap_task_337879_total_time;
        futhark_mc_task_337878_task.task_iter =
            &ctx->futhark_mc_segmap_task_337879_total_iter;
        futhark_mc_task_337878_task.sched = STATIC;
        futhark_mc_task_337878_task.nested_fn = NULL;
        
        int futhark_mc_segmap_task_337879_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_337878_task);
        
        if (futhark_mc_segmap_task_337879_err != 0) {
            ;
            err = futhark_mc_segmap_task_337879_err;
            goto cleanup;
        }
        
        int64_t min_arg_298162 = sub64(x_298156, (int64_t) 1);
        int64_t min_arg_298163 = sub64(x_298156, min_res_293170);
        int64_t min_res_298164 = smin64(q_t_292679, x_298156);
        double i64_res_298165 = sitofp_i64_f64(x_298156);
        double x_298166 = i64_res_293176 - i64_res_298165;
        double max_arg_298167 = x_298166 / 2.0;
        double max_res_298168 = fmax64(0.0, max_arg_298167);
        int64_t flat_tid_318707 = (int64_t) 0;
        int32_t num_tasks_318801;
        struct futhark_mc_task_337882 futhark_mc_task_337882;
        
        futhark_mc_task_337882.ctx = ctx;
        futhark_mc_task_337882.free_n_292675 = n_292675;
        futhark_mc_task_337882.free_jump_t_292685 = jump_t_292685;
        futhark_mc_task_337882.free_t_n_m_292839 = t_n_m_292839;
        futhark_mc_task_337882.free_i_292846 = i_292846;
        futhark_mc_task_337882.free_x_292847 = x_292847;
        futhark_mc_task_337882.free_min_res_293170 = min_res_293170;
        futhark_mc_task_337882.free_loop_cond_293175 = loop_cond_293175;
        futhark_mc_task_337882.free_gtid_298154 = gtid_298154;
        futhark_mc_task_337882.free_min_arg_298162 = min_arg_298162;
        futhark_mc_task_337882.free_min_arg_298163 = min_arg_298163;
        futhark_mc_task_337882.free_min_res_298164 = min_res_298164;
        futhark_mc_task_337882.free_max_res_298168 = max_res_298168;
        futhark_mc_task_337882.free_mem_312636 = mem_312636.mem;
        futhark_mc_task_337882.free_mem_313088 = mem_313088;
        futhark_mc_task_337882.free_mem_313091 = mem_313091;
        futhark_mc_task_337882.free_mem_313094 = mem_313094;
        
        struct scheduler_segop futhark_mc_task_337882_task;
        
        futhark_mc_task_337882_task.args = &futhark_mc_task_337882;
        futhark_mc_task_337882_task.top_level_fn =
            futhark_mc_segmap_task_337883;
        futhark_mc_task_337882_task.name = "futhark_mc_segmap_task_337883";
        futhark_mc_task_337882_task.iterations = t_n_m_292839;
        futhark_mc_task_337882_task.task_time =
            &ctx->futhark_mc_segmap_task_337883_total_time;
        futhark_mc_task_337882_task.task_iter =
            &ctx->futhark_mc_segmap_task_337883_total_iter;
        futhark_mc_task_337882_task.sched = DYNAMIC;
        futhark_mc_task_337882_task.nested_fn = NULL;
        
        int futhark_mc_segmap_task_337883_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_337882_task);
        
        if (futhark_mc_segmap_task_337883_err != 0) {
            ;
            err = futhark_mc_segmap_task_337883_err;
            goto cleanup;
        }
        if (t_n_m_292839 * (int64_t) 8 > 0)
            memmove(mem_313143.mem + gtid_298154 * t_n_m_292839 * (int64_t) 8,
                    mem_313094 + (int64_t) 0, t_n_m_292839 * (int64_t) 8);
        if (t_n_m_292839 * (int64_t) 8 > 0)
            memmove(mem_313147.mem + gtid_298154 * t_n_m_292839 * (int64_t) 8,
                    mem_313091 + (int64_t) 0, t_n_m_292839 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_313088);
    free(mem_313091);
    free(mem_313094);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_337874_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_337874_end -
                 futhark_mc_segmap_parloop_337874_start;
        
        ctx->futhark_mc_segmap_parloop_337874_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_337874_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_337874_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_nested_task_337872(void *args, int64_t iterations,
                                         int tid, struct scheduler_info info)
{
    int err = 0;
    int flat_tid_298153 = tid;
    int num_tasks_318592 = info.nsubtasks;
    struct futhark_mc_task_337865 *futhark_mc_task_337865 =
                                  (struct futhark_mc_task_337865 *) args;
    struct futhark_context *ctx = futhark_mc_task_337865->ctx;
    uint64_t futhark_mc_segmap_nested_task_337872_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_nested_task_337872_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_337865->free_n_292675;
    int64_t q_t_292679 = futhark_mc_task_337865->free_q_t_292679;
    int64_t jump_t_292685 = futhark_mc_task_337865->free_jump_t_292685;
    int64_t partition_sizze_292766 =
            futhark_mc_task_337865->free_partition_sizze_292766;
    int64_t t_n_m_292839 = futhark_mc_task_337865->free_t_n_m_292839;
    int64_t i_292846 = futhark_mc_task_337865->free_i_292846;
    bool x_292847 = futhark_mc_task_337865->free_x_292847;
    int64_t min_res_293170 = futhark_mc_task_337865->free_min_res_293170;
    bool loop_cond_293175 = futhark_mc_task_337865->free_loop_cond_293175;
    double i64_res_293176 = futhark_mc_task_337865->free_i64_res_293176;
    int64_t bytes_312598 = futhark_mc_task_337865->free_bytes_312598;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_task_337865->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_312639 = {.desc ="mem_312639", .mem =
                                  futhark_mc_task_337865->free_mem_312639,
                                  .size =0, .references =NULL};
    int64_t bytes_313090 = futhark_mc_task_337865->free_bytes_313090;
    struct memblock mem_313143 = {.desc ="mem_313143", .mem =
                                  futhark_mc_task_337865->free_mem_313143,
                                  .size =0, .references =NULL};
    struct memblock mem_313147 = {.desc ="mem_313147", .mem =
                                  futhark_mc_task_337865->free_mem_313147,
                                  .size =0, .references =NULL};
    int64_t iter_318702;
    struct futhark_mc_segmap_parloop_struct_337873
    futhark_mc_segmap_parloop_struct_337873;
    
    futhark_mc_segmap_parloop_struct_337873.ctx = ctx;
    futhark_mc_segmap_parloop_struct_337873.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_337873.free_q_t_292679 = q_t_292679;
    futhark_mc_segmap_parloop_struct_337873.free_jump_t_292685 = jump_t_292685;
    futhark_mc_segmap_parloop_struct_337873.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_337873.free_t_n_m_292839 = t_n_m_292839;
    futhark_mc_segmap_parloop_struct_337873.free_i_292846 = i_292846;
    futhark_mc_segmap_parloop_struct_337873.free_x_292847 = x_292847;
    futhark_mc_segmap_parloop_struct_337873.free_min_res_293170 =
        min_res_293170;
    futhark_mc_segmap_parloop_struct_337873.free_loop_cond_293175 =
        loop_cond_293175;
    futhark_mc_segmap_parloop_struct_337873.free_i64_res_293176 =
        i64_res_293176;
    futhark_mc_segmap_parloop_struct_337873.free_bytes_312598 = bytes_312598;
    futhark_mc_segmap_parloop_struct_337873.free_mem_312636 = mem_312636.mem;
    futhark_mc_segmap_parloop_struct_337873.free_mem_312639 = mem_312639.mem;
    futhark_mc_segmap_parloop_struct_337873.free_bytes_313090 = bytes_313090;
    futhark_mc_segmap_parloop_struct_337873.free_mem_313143 = mem_313143.mem;
    futhark_mc_segmap_parloop_struct_337873.free_mem_313147 = mem_313147.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_337874_task;
    
    futhark_mc_segmap_parloop_337874_task.name =
        "futhark_mc_segmap_parloop_337874";
    futhark_mc_segmap_parloop_337874_task.fn = futhark_mc_segmap_parloop_337874;
    futhark_mc_segmap_parloop_337874_task.args =
        &futhark_mc_segmap_parloop_struct_337873;
    futhark_mc_segmap_parloop_337874_task.iterations = iterations;
    futhark_mc_segmap_parloop_337874_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_337874_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_337874_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_337874_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_337874_task);
    
    if (futhark_mc_segmap_parloop_337874_err != 0) {
        err = futhark_mc_segmap_parloop_337874_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_337874_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_337874_total_end -
                 futhark_mc_segmap_parloop_337874_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337874_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337874_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337874_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_nested_task_337872_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_nested_task_337872_end -
                 futhark_mc_segmap_nested_task_337872_start;
        
        ctx->futhark_mc_segmap_nested_task_337872_runs[tid]++;
        ctx->futhark_mc_segmap_nested_task_337872_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_nested_task_337872_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_task_337886 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_partition_sizze_292766;
    unsigned char *free_mem_312593;
    int64_t free_bytes_312598;
    int64_t free_ctx_param_ext_313197;
    unsigned char *free_mem_param_313201;
    unsigned char *free_mem_313223;
};
struct futhark_mc_segmap_parloop_struct_337888 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_partition_sizze_292766;
    unsigned char *free_mem_312593;
    int64_t free_bytes_312598;
    int64_t free_ctx_param_ext_313197;
    unsigned char *free_mem_param_313201;
    unsigned char *free_mem_313223;
};
static int futhark_mc_segmap_parloop_337889(void *args, int64_t start,
                                            int64_t end, int flat_tid_298260,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_337888
    *futhark_mc_segmap_parloop_struct_337888 =
    (struct futhark_mc_segmap_parloop_struct_337888 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_337888->ctx;
    uint64_t futhark_mc_segmap_parloop_337889_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_337889_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_337888->free_n_292675;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_337888->free_partition_sizze_292766;
    struct memblock mem_312593 = {.desc ="mem_312593", .mem =
                                  futhark_mc_segmap_parloop_struct_337888->free_mem_312593,
                                  .size =0, .references =NULL};
    int64_t bytes_312598 =
            futhark_mc_segmap_parloop_struct_337888->free_bytes_312598;
    int64_t ctx_param_ext_313197 =
            futhark_mc_segmap_parloop_struct_337888->free_ctx_param_ext_313197;
    struct memblock mem_param_313201 = {.desc ="mem_param_313201", .mem =
                                        futhark_mc_segmap_parloop_struct_337888->free_mem_param_313201,
                                        .size =0, .references =NULL};
    struct memblock mem_313223 = {.desc ="mem_313223", .mem =
                                  futhark_mc_segmap_parloop_struct_337888->free_mem_313223,
                                  .size =0, .references =NULL};
    size_t mem_313207_cached_sizze_337890 = 0;
    unsigned char *mem_313207 = NULL;
    int64_t iterations = end - start;
    int64_t iter_318893 = start;
    
    if (mem_313207_cached_sizze_337890 < (size_t) bytes_312598) {
        mem_313207 = realloc(mem_313207, bytes_312598);
        mem_313207_cached_sizze_337890 = bytes_312598;
    }
    for (; iter_318893 < end; iter_318893++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_318901 = partition_sizze_292766;
        int64_t gtid_298261 = iter_318893;
        int64_t remnant_318902 = iter_318893 - gtid_298261;
        
        for (int64_t i_318894 = 0; i_318894 < n_292675; i_318894++) {
            float x_318896;
            
            x_318896 = ((float *) mem_312593.mem)[gtid_298261 * n_292675 +
                                                  i_318894];
            
            double x_318897;
            
            x_318897 = ((double *) mem_param_313201.mem)[gtid_298261 *
                                                         ctx_param_ext_313197 +
                                                         i_318894];
            
            double f32_res_318898 = fpconv_f32_f64(x_318896);
            double defunc_1_f_res_318899 = f32_res_318898 - x_318897;
            
            ((double *) mem_313207)[i_318894] = defunc_1_f_res_318899;
        }
        if (n_292675 * (int64_t) 8 > 0)
            memmove(mem_313223.mem + gtid_298261 * n_292675 * (int64_t) 8,
                    mem_313207 + (int64_t) 0, n_292675 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_313207);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_337889_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_337889_end -
                 futhark_mc_segmap_parloop_337889_start;
        
        ctx->futhark_mc_segmap_parloop_337889_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_337889_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_337889_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_337887(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_298260 = tid;
    int num_tasks_318892 = info.nsubtasks;
    struct futhark_mc_task_337886 *futhark_mc_task_337886 =
                                  (struct futhark_mc_task_337886 *) args;
    struct futhark_context *ctx = futhark_mc_task_337886->ctx;
    uint64_t futhark_mc_segmap_task_337887_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_337887_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_337886->free_n_292675;
    int64_t partition_sizze_292766 =
            futhark_mc_task_337886->free_partition_sizze_292766;
    struct memblock mem_312593 = {.desc ="mem_312593", .mem =
                                  futhark_mc_task_337886->free_mem_312593,
                                  .size =0, .references =NULL};
    int64_t bytes_312598 = futhark_mc_task_337886->free_bytes_312598;
    int64_t ctx_param_ext_313197 =
            futhark_mc_task_337886->free_ctx_param_ext_313197;
    struct memblock mem_param_313201 = {.desc ="mem_param_313201", .mem =
                                        futhark_mc_task_337886->free_mem_param_313201,
                                        .size =0, .references =NULL};
    struct memblock mem_313223 = {.desc ="mem_313223", .mem =
                                  futhark_mc_task_337886->free_mem_313223,
                                  .size =0, .references =NULL};
    int64_t iter_318893;
    struct futhark_mc_segmap_parloop_struct_337888
    futhark_mc_segmap_parloop_struct_337888;
    
    futhark_mc_segmap_parloop_struct_337888.ctx = ctx;
    futhark_mc_segmap_parloop_struct_337888.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_337888.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_337888.free_mem_312593 = mem_312593.mem;
    futhark_mc_segmap_parloop_struct_337888.free_bytes_312598 = bytes_312598;
    futhark_mc_segmap_parloop_struct_337888.free_ctx_param_ext_313197 =
        ctx_param_ext_313197;
    futhark_mc_segmap_parloop_struct_337888.free_mem_param_313201 =
        mem_param_313201.mem;
    futhark_mc_segmap_parloop_struct_337888.free_mem_313223 = mem_313223.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_337889_task;
    
    futhark_mc_segmap_parloop_337889_task.name =
        "futhark_mc_segmap_parloop_337889";
    futhark_mc_segmap_parloop_337889_task.fn = futhark_mc_segmap_parloop_337889;
    futhark_mc_segmap_parloop_337889_task.args =
        &futhark_mc_segmap_parloop_struct_337888;
    futhark_mc_segmap_parloop_337889_task.iterations = iterations;
    futhark_mc_segmap_parloop_337889_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_337889_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_337889_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_337889_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_337889_task);
    
    if (futhark_mc_segmap_parloop_337889_err != 0) {
        err = futhark_mc_segmap_parloop_337889_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_337889_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_337889_total_end -
                 futhark_mc_segmap_parloop_337889_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337889_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337889_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337889_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_337887_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_337887_end -
                 futhark_mc_segmap_task_337887_start;
        
        ctx->futhark_mc_segmap_task_337887_runs[tid]++;
        ctx->futhark_mc_segmap_task_337887_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_337887_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_segmap_parloop_struct_337892 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_partition_sizze_292766;
    unsigned char *free_mem_312593;
    int64_t free_bytes_312598;
    int64_t free_ctx_param_ext_313197;
    unsigned char *free_mem_param_313201;
    unsigned char *free_mem_313223;
};
struct futhark_mc_task_337895 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_298267;
    unsigned char *free_mem_312593;
    int64_t free_ctx_param_ext_313197;
    unsigned char *free_mem_param_313201;
    unsigned char *free_mem_313204;
};
struct futhark_mc_segmap_parloop_struct_337897 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_298267;
    unsigned char *free_mem_312593;
    int64_t free_ctx_param_ext_313197;
    unsigned char *free_mem_param_313201;
    unsigned char *free_mem_313204;
};
static int futhark_mc_segmap_parloop_337898(void *args, int64_t start,
                                            int64_t end, int flat_tid_318905,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_337897
    *futhark_mc_segmap_parloop_struct_337897 =
    (struct futhark_mc_segmap_parloop_struct_337897 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_337897->ctx;
    uint64_t futhark_mc_segmap_parloop_337898_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_337898_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_337897->free_n_292675;
    int64_t gtid_298267 =
            futhark_mc_segmap_parloop_struct_337897->free_gtid_298267;
    struct memblock mem_312593 = {.desc ="mem_312593", .mem =
                                  futhark_mc_segmap_parloop_struct_337897->free_mem_312593,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313197 =
            futhark_mc_segmap_parloop_struct_337897->free_ctx_param_ext_313197;
    struct memblock mem_param_313201 = {.desc ="mem_param_313201", .mem =
                                        futhark_mc_segmap_parloop_struct_337897->free_mem_param_313201,
                                        .size =0, .references =NULL};
    struct memblock mem_313204 = {.desc ="mem_313204", .mem =
                                  futhark_mc_segmap_parloop_struct_337897->free_mem_313204,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_318914 = start;
    
    for (; iter_318914 < end; iter_318914++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_318915 = n_292675;
        int64_t gtid_318906 = iter_318914;
        int64_t remnant_318916 = iter_318914 - gtid_318906;
        float x_318907;
        
        x_318907 = ((float *) mem_312593.mem)[gtid_298267 * n_292675 +
                                              gtid_318906];
        
        double x_318908;
        
        x_318908 = ((double *) mem_param_313201.mem)[gtid_298267 *
                                                     ctx_param_ext_313197 +
                                                     gtid_318906];
        
        double f32_res_318909 = fpconv_f32_f64(x_318907);
        double defunc_1_f_res_318910 = f32_res_318909 - x_318908;
        
        ((double *) mem_313204.mem)[gtid_318906] = defunc_1_f_res_318910;
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_337898_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_337898_end -
                 futhark_mc_segmap_parloop_337898_start;
        
        ctx->futhark_mc_segmap_parloop_337898_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_337898_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_337898_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_337896(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_318905 = tid;
    int num_tasks_318913 = info.nsubtasks;
    struct futhark_mc_task_337895 *futhark_mc_task_337895 =
                                  (struct futhark_mc_task_337895 *) args;
    struct futhark_context *ctx = futhark_mc_task_337895->ctx;
    uint64_t futhark_mc_segmap_task_337896_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_337896_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_337895->free_n_292675;
    int64_t gtid_298267 = futhark_mc_task_337895->free_gtid_298267;
    struct memblock mem_312593 = {.desc ="mem_312593", .mem =
                                  futhark_mc_task_337895->free_mem_312593,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313197 =
            futhark_mc_task_337895->free_ctx_param_ext_313197;
    struct memblock mem_param_313201 = {.desc ="mem_param_313201", .mem =
                                        futhark_mc_task_337895->free_mem_param_313201,
                                        .size =0, .references =NULL};
    struct memblock mem_313204 = {.desc ="mem_313204", .mem =
                                  futhark_mc_task_337895->free_mem_313204,
                                  .size =0, .references =NULL};
    int64_t iter_318914;
    struct futhark_mc_segmap_parloop_struct_337897
    futhark_mc_segmap_parloop_struct_337897;
    
    futhark_mc_segmap_parloop_struct_337897.ctx = ctx;
    futhark_mc_segmap_parloop_struct_337897.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_337897.free_gtid_298267 = gtid_298267;
    futhark_mc_segmap_parloop_struct_337897.free_mem_312593 = mem_312593.mem;
    futhark_mc_segmap_parloop_struct_337897.free_ctx_param_ext_313197 =
        ctx_param_ext_313197;
    futhark_mc_segmap_parloop_struct_337897.free_mem_param_313201 =
        mem_param_313201.mem;
    futhark_mc_segmap_parloop_struct_337897.free_mem_313204 = mem_313204.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_337898_task;
    
    futhark_mc_segmap_parloop_337898_task.name =
        "futhark_mc_segmap_parloop_337898";
    futhark_mc_segmap_parloop_337898_task.fn = futhark_mc_segmap_parloop_337898;
    futhark_mc_segmap_parloop_337898_task.args =
        &futhark_mc_segmap_parloop_struct_337897;
    futhark_mc_segmap_parloop_337898_task.iterations = iterations;
    futhark_mc_segmap_parloop_337898_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_337898_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_337898_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_337898_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_337898_task);
    
    if (futhark_mc_segmap_parloop_337898_err != 0) {
        err = futhark_mc_segmap_parloop_337898_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_337898_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_337898_total_end -
                 futhark_mc_segmap_parloop_337898_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337898_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337898_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337898_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_337896_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_337896_end -
                 futhark_mc_segmap_task_337896_start;
        
        ctx->futhark_mc_segmap_task_337896_runs[tid]++;
        ctx->futhark_mc_segmap_task_337896_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_337896_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
static int futhark_mc_segmap_parloop_337893(void *args, int64_t start,
                                            int64_t end, int flat_tid_298266,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_337892
    *futhark_mc_segmap_parloop_struct_337892 =
    (struct futhark_mc_segmap_parloop_struct_337892 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_337892->ctx;
    uint64_t futhark_mc_segmap_parloop_337893_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_337893_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_337892->free_n_292675;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_337892->free_partition_sizze_292766;
    struct memblock mem_312593 = {.desc ="mem_312593", .mem =
                                  futhark_mc_segmap_parloop_struct_337892->free_mem_312593,
                                  .size =0, .references =NULL};
    int64_t bytes_312598 =
            futhark_mc_segmap_parloop_struct_337892->free_bytes_312598;
    int64_t ctx_param_ext_313197 =
            futhark_mc_segmap_parloop_struct_337892->free_ctx_param_ext_313197;
    struct memblock mem_param_313201 = {.desc ="mem_param_313201", .mem =
                                        futhark_mc_segmap_parloop_struct_337892->free_mem_param_313201,
                                        .size =0, .references =NULL};
    struct memblock mem_313223 = {.desc ="mem_313223", .mem =
                                  futhark_mc_segmap_parloop_struct_337892->free_mem_313223,
                                  .size =0, .references =NULL};
    size_t mem_313204_cached_sizze_337894 = 0;
    unsigned char *mem_313204 = NULL;
    int64_t iterations = end - start;
    int64_t iter_318904 = start;
    
    if (mem_313204_cached_sizze_337894 < (size_t) bytes_312598) {
        mem_313204 = realloc(mem_313204, bytes_312598);
        mem_313204_cached_sizze_337894 = bytes_312598;
    }
    for (; iter_318904 < end; iter_318904++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_318911 = partition_sizze_292766;
        int64_t gtid_298267 = iter_318904;
        int64_t remnant_318912 = iter_318904 - gtid_298267;
        int64_t flat_tid_318905 = (int64_t) 0;
        int32_t num_tasks_318913;
        struct futhark_mc_task_337895 futhark_mc_task_337895;
        
        futhark_mc_task_337895.ctx = ctx;
        futhark_mc_task_337895.free_n_292675 = n_292675;
        futhark_mc_task_337895.free_gtid_298267 = gtid_298267;
        futhark_mc_task_337895.free_mem_312593 = mem_312593.mem;
        futhark_mc_task_337895.free_ctx_param_ext_313197 = ctx_param_ext_313197;
        futhark_mc_task_337895.free_mem_param_313201 = mem_param_313201.mem;
        futhark_mc_task_337895.free_mem_313204 = mem_313204;
        
        struct scheduler_segop futhark_mc_task_337895_task;
        
        futhark_mc_task_337895_task.args = &futhark_mc_task_337895;
        futhark_mc_task_337895_task.top_level_fn =
            futhark_mc_segmap_task_337896;
        futhark_mc_task_337895_task.name = "futhark_mc_segmap_task_337896";
        futhark_mc_task_337895_task.iterations = n_292675;
        futhark_mc_task_337895_task.task_time =
            &ctx->futhark_mc_segmap_task_337896_total_time;
        futhark_mc_task_337895_task.task_iter =
            &ctx->futhark_mc_segmap_task_337896_total_iter;
        futhark_mc_task_337895_task.sched = STATIC;
        futhark_mc_task_337895_task.nested_fn = NULL;
        
        int futhark_mc_segmap_task_337896_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_337895_task);
        
        if (futhark_mc_segmap_task_337896_err != 0) {
            ;
            err = futhark_mc_segmap_task_337896_err;
            goto cleanup;
        }
        if (n_292675 * (int64_t) 8 > 0)
            memmove(mem_313223.mem + gtid_298267 * n_292675 * (int64_t) 8,
                    mem_313204 + (int64_t) 0, n_292675 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_313204);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_337893_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_337893_end -
                 futhark_mc_segmap_parloop_337893_start;
        
        ctx->futhark_mc_segmap_parloop_337893_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_337893_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_337893_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_nested_task_337891(void *args, int64_t iterations,
                                         int tid, struct scheduler_info info)
{
    int err = 0;
    int flat_tid_298266 = tid;
    int num_tasks_318892 = info.nsubtasks;
    struct futhark_mc_task_337886 *futhark_mc_task_337886 =
                                  (struct futhark_mc_task_337886 *) args;
    struct futhark_context *ctx = futhark_mc_task_337886->ctx;
    uint64_t futhark_mc_segmap_nested_task_337891_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_nested_task_337891_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_337886->free_n_292675;
    int64_t partition_sizze_292766 =
            futhark_mc_task_337886->free_partition_sizze_292766;
    struct memblock mem_312593 = {.desc ="mem_312593", .mem =
                                  futhark_mc_task_337886->free_mem_312593,
                                  .size =0, .references =NULL};
    int64_t bytes_312598 = futhark_mc_task_337886->free_bytes_312598;
    int64_t ctx_param_ext_313197 =
            futhark_mc_task_337886->free_ctx_param_ext_313197;
    struct memblock mem_param_313201 = {.desc ="mem_param_313201", .mem =
                                        futhark_mc_task_337886->free_mem_param_313201,
                                        .size =0, .references =NULL};
    struct memblock mem_313223 = {.desc ="mem_313223", .mem =
                                  futhark_mc_task_337886->free_mem_313223,
                                  .size =0, .references =NULL};
    int64_t iter_318904;
    struct futhark_mc_segmap_parloop_struct_337892
    futhark_mc_segmap_parloop_struct_337892;
    
    futhark_mc_segmap_parloop_struct_337892.ctx = ctx;
    futhark_mc_segmap_parloop_struct_337892.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_337892.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_337892.free_mem_312593 = mem_312593.mem;
    futhark_mc_segmap_parloop_struct_337892.free_bytes_312598 = bytes_312598;
    futhark_mc_segmap_parloop_struct_337892.free_ctx_param_ext_313197 =
        ctx_param_ext_313197;
    futhark_mc_segmap_parloop_struct_337892.free_mem_param_313201 =
        mem_param_313201.mem;
    futhark_mc_segmap_parloop_struct_337892.free_mem_313223 = mem_313223.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_337893_task;
    
    futhark_mc_segmap_parloop_337893_task.name =
        "futhark_mc_segmap_parloop_337893";
    futhark_mc_segmap_parloop_337893_task.fn = futhark_mc_segmap_parloop_337893;
    futhark_mc_segmap_parloop_337893_task.args =
        &futhark_mc_segmap_parloop_struct_337892;
    futhark_mc_segmap_parloop_337893_task.iterations = iterations;
    futhark_mc_segmap_parloop_337893_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_337893_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_337893_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_337893_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_337893_task);
    
    if (futhark_mc_segmap_parloop_337893_err != 0) {
        err = futhark_mc_segmap_parloop_337893_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_337893_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_337893_total_end -
                 futhark_mc_segmap_parloop_337893_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337893_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337893_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337893_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_nested_task_337891_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_nested_task_337891_end -
                 futhark_mc_segmap_nested_task_337891_start;
        
        ctx->futhark_mc_segmap_nested_task_337891_runs[tid]++;
        ctx->futhark_mc_segmap_nested_task_337891_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_nested_task_337891_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_task_337899 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_n_p_292677;
    int64_t free_partition_sizze_292766;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_i_292846;
    int64_t free_bytes_312641;
    int64_t free_bytes_312660;
    unsigned char *free_mem_312838;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_313223;
    unsigned char *free_mem_313366;
    unsigned char *free_mem_313371;
};
struct futhark_mc_segmap_parloop_struct_337901 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_n_p_292677;
    int64_t free_partition_sizze_292766;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_i_292846;
    int64_t free_bytes_312660;
    unsigned char *free_mem_312838;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_313223;
    unsigned char *free_mem_313366;
    unsigned char *free_mem_313371;
};
static int futhark_mc_segmap_parloop_337902(void *args, int64_t start,
                                            int64_t end, int flat_tid_298277,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_337901
    *futhark_mc_segmap_parloop_struct_337901 =
    (struct futhark_mc_segmap_parloop_struct_337901 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_337901->ctx;
    uint64_t futhark_mc_segmap_parloop_337902_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_337902_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_337901->free_n_292675;
    int64_t n_p_292677 =
            futhark_mc_segmap_parloop_struct_337901->free_n_p_292677;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_337901->free_partition_sizze_292766;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segmap_parloop_struct_337901->free_defunc_0_f_res_292820;
    int64_t i_292846 = futhark_mc_segmap_parloop_struct_337901->free_i_292846;
    int64_t bytes_312660 =
            futhark_mc_segmap_parloop_struct_337901->free_bytes_312660;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_segmap_parloop_struct_337901->free_mem_312838,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_segmap_parloop_struct_337901->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_segmap_parloop_struct_337901->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_segmap_parloop_struct_337901->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_segmap_parloop_struct_337901->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_313223 = {.desc ="mem_313223", .mem =
                                  futhark_mc_segmap_parloop_struct_337901->free_mem_313223,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_segmap_parloop_struct_337901->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_segmap_parloop_struct_337901->free_mem_313371,
                                  .size =0, .references =NULL};
    size_t mem_313271_cached_sizze_337903 = 0;
    unsigned char *mem_313271 = NULL;
    size_t mem_313275_cached_sizze_337904 = 0;
    unsigned char *mem_313275 = NULL;
    int64_t iterations = end - start;
    int64_t iter_318918 = start;
    
    if (mem_313271_cached_sizze_337903 < (size_t) bytes_312660) {
        mem_313271 = realloc(mem_313271, bytes_312660);
        mem_313271_cached_sizze_337903 = bytes_312660;
    }
    if (mem_313275_cached_sizze_337904 < (size_t) bytes_312660) {
        mem_313275 = realloc(mem_313275, bytes_312660);
        mem_313275_cached_sizze_337904 = bytes_312660;
    }
    for (; iter_318918 < end; iter_318918++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_318945 = partition_sizze_292766;
        int64_t gtid_298278 = iter_318918;
        int64_t remnant_318946 = iter_318918 - gtid_298278;
        
        for (int64_t i_318919 = 0; i_318919 < n_p_292677; i_318919++) {
            for (int64_t i_318924 = 0; i_318924 < defunc_0_f_res_292820;
                 i_318924++) {
                int64_t x_318927;
                
                x_318927 = ((int64_t *) mem_312838.mem)[gtid_298278 *
                                                        (defunc_0_f_res_292820 *
                                                         n_p_292677) +
                                                        i_318919 *
                                                        defunc_0_f_res_292820 +
                                                        i_318924];
                
                int64_t x_318928 = mul64(n_p_292677, x_318927);
                int64_t idx_318929 = add64(x_318928, i_318919);
                bool cond_318930 = slt64(i_292846, idx_318929);
                bool cond_f_res_318931 = slt64(x_318927, (int64_t) 0);
                bool x_318932 = !cond_318930;
                bool y_318933 = cond_f_res_318931 && x_318932;
                bool cond_318934 = cond_318930 || y_318933;
                double defunc_0_f_res_318935;
                double defunc_0_f_res_318936;
                
                if (cond_318934) {
                    defunc_0_f_res_318935 = 0.0;
                    defunc_0_f_res_318936 = 0.0;
                } else {
                    bool x_318937 = sle64((int64_t) 0, idx_318929);
                    bool y_318938 = slt64(idx_318929, n_292675);
                    bool bounds_check_318939 = x_318937 && y_318938;
                    bool index_certs_318940;
                    
                    if (!bounds_check_318939) {
                        ctx->error =
                            msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                      "Index [", (long long) idx_318929,
                                      "] out of bounds for array of shape [",
                                      (long long) n_292675, "].",
                                      "-> #0  stl.fut:193:42-57\n   #1  stl.fut:188:28-194:44\n   #2  /prelude/soacs.fut:67:19-23\n   #3  /prelude/soacs.fut:67:3-37\n   #4  stl.fut:186:21-195:50\n   #5  /prelude/soacs.fut:75:22-28\n   #6  /prelude/soacs.fut:75:3-45\n   #7  stl.fut:184:13-196:57\n   #8  stl.fut:419:61-435:77\n   #9  stl.fut:463:3-479:36\n   #10 stl.fut:445:1-479:36\n");
                        err = FUTHARK_PROGRAM_ERROR;
                        goto cleanup;
                    }
                    
                    double defunc_0_f_res_f_res_318941;
                    
                    defunc_0_f_res_f_res_318941 =
                        ((double *) mem_313223.mem)[gtid_298278 * n_292675 +
                                                    idx_318929];
                    
                    double defunc_0_f_res_f_res_318942;
                    
                    defunc_0_f_res_f_res_318942 =
                        ((double *) mem_param_313179.mem)[ctx_param_ext_313174 +
                                                          (gtid_298278 *
                                                           ctx_param_ext_313175 +
                                                           idx_318929 *
                                                           ctx_param_ext_313177)];
                    defunc_0_f_res_318935 = defunc_0_f_res_f_res_318941;
                    defunc_0_f_res_318936 = defunc_0_f_res_f_res_318942;
                }
                ((double *) mem_313271)[i_318919 * defunc_0_f_res_292820 +
                                        i_318924] = defunc_0_f_res_318935;
                ((double *) mem_313275)[i_318919 * defunc_0_f_res_292820 +
                                        i_318924] = defunc_0_f_res_318936;
            }
        }
        if (n_p_292677 * defunc_0_f_res_292820 * (int64_t) 8 > 0)
            memmove(mem_313366.mem + gtid_298278 * (defunc_0_f_res_292820 *
                                                    n_p_292677) * (int64_t) 8,
                    mem_313271 + (int64_t) 0, n_p_292677 *
                    defunc_0_f_res_292820 * (int64_t) 8);
        if (n_p_292677 * defunc_0_f_res_292820 * (int64_t) 8 > 0)
            memmove(mem_313371.mem + gtid_298278 * (defunc_0_f_res_292820 *
                                                    n_p_292677) * (int64_t) 8,
                    mem_313275 + (int64_t) 0, n_p_292677 *
                    defunc_0_f_res_292820 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_313271);
    free(mem_313275);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_337902_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_337902_end -
                 futhark_mc_segmap_parloop_337902_start;
        
        ctx->futhark_mc_segmap_parloop_337902_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_337902_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_337902_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_337900(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_298277 = tid;
    int num_tasks_318917 = info.nsubtasks;
    struct futhark_mc_task_337899 *futhark_mc_task_337899 =
                                  (struct futhark_mc_task_337899 *) args;
    struct futhark_context *ctx = futhark_mc_task_337899->ctx;
    uint64_t futhark_mc_segmap_task_337900_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_337900_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_337899->free_n_292675;
    int64_t n_p_292677 = futhark_mc_task_337899->free_n_p_292677;
    int64_t partition_sizze_292766 =
            futhark_mc_task_337899->free_partition_sizze_292766;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_337899->free_defunc_0_f_res_292820;
    int64_t i_292846 = futhark_mc_task_337899->free_i_292846;
    int64_t bytes_312641 = futhark_mc_task_337899->free_bytes_312641;
    int64_t bytes_312660 = futhark_mc_task_337899->free_bytes_312660;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_task_337899->free_mem_312838,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_task_337899->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_task_337899->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_task_337899->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_task_337899->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_313223 = {.desc ="mem_313223", .mem =
                                  futhark_mc_task_337899->free_mem_313223,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_task_337899->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_task_337899->free_mem_313371,
                                  .size =0, .references =NULL};
    int64_t iter_318918;
    struct futhark_mc_segmap_parloop_struct_337901
    futhark_mc_segmap_parloop_struct_337901;
    
    futhark_mc_segmap_parloop_struct_337901.ctx = ctx;
    futhark_mc_segmap_parloop_struct_337901.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_337901.free_n_p_292677 = n_p_292677;
    futhark_mc_segmap_parloop_struct_337901.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_337901.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segmap_parloop_struct_337901.free_i_292846 = i_292846;
    futhark_mc_segmap_parloop_struct_337901.free_bytes_312660 = bytes_312660;
    futhark_mc_segmap_parloop_struct_337901.free_mem_312838 = mem_312838.mem;
    futhark_mc_segmap_parloop_struct_337901.free_ctx_param_ext_313174 =
        ctx_param_ext_313174;
    futhark_mc_segmap_parloop_struct_337901.free_ctx_param_ext_313175 =
        ctx_param_ext_313175;
    futhark_mc_segmap_parloop_struct_337901.free_ctx_param_ext_313177 =
        ctx_param_ext_313177;
    futhark_mc_segmap_parloop_struct_337901.free_mem_param_313179 =
        mem_param_313179.mem;
    futhark_mc_segmap_parloop_struct_337901.free_mem_313223 = mem_313223.mem;
    futhark_mc_segmap_parloop_struct_337901.free_mem_313366 = mem_313366.mem;
    futhark_mc_segmap_parloop_struct_337901.free_mem_313371 = mem_313371.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_337902_task;
    
    futhark_mc_segmap_parloop_337902_task.name =
        "futhark_mc_segmap_parloop_337902";
    futhark_mc_segmap_parloop_337902_task.fn = futhark_mc_segmap_parloop_337902;
    futhark_mc_segmap_parloop_337902_task.args =
        &futhark_mc_segmap_parloop_struct_337901;
    futhark_mc_segmap_parloop_337902_task.iterations = iterations;
    futhark_mc_segmap_parloop_337902_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_337902_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_337902_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_337902_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_337902_task);
    
    if (futhark_mc_segmap_parloop_337902_err != 0) {
        err = futhark_mc_segmap_parloop_337902_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_337902_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_337902_total_end -
                 futhark_mc_segmap_parloop_337902_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337902_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337902_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337902_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_337900_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_337900_end -
                 futhark_mc_segmap_task_337900_start;
        
        ctx->futhark_mc_segmap_task_337900_runs[tid]++;
        ctx->futhark_mc_segmap_task_337900_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_337900_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_segmap_parloop_struct_337906 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_n_p_292677;
    int64_t free_partition_sizze_292766;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_i_292846;
    int64_t free_bytes_312641;
    int64_t free_bytes_312660;
    unsigned char *free_mem_312838;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_313223;
    unsigned char *free_mem_313366;
    unsigned char *free_mem_313371;
};
struct futhark_mc_task_337910 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_n_p_292677;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_i_292846;
    int64_t free_gtid_298312;
    int64_t free_bytes_312641;
    unsigned char *free_mem_312838;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_313223;
    unsigned char *free_mem_313263;
    unsigned char *free_mem_313267;
};
struct futhark_mc_segmap_parloop_struct_337912 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_n_p_292677;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_i_292846;
    int64_t free_gtid_298312;
    int64_t free_bytes_312641;
    unsigned char *free_mem_312838;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_313223;
    unsigned char *free_mem_313263;
    unsigned char *free_mem_313267;
};
static int futhark_mc_segmap_parloop_337913(void *args, int64_t start,
                                            int64_t end, int flat_tid_318976,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_337912
    *futhark_mc_segmap_parloop_struct_337912 =
    (struct futhark_mc_segmap_parloop_struct_337912 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_337912->ctx;
    uint64_t futhark_mc_segmap_parloop_337913_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_337913_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_337912->free_n_292675;
    int64_t n_p_292677 =
            futhark_mc_segmap_parloop_struct_337912->free_n_p_292677;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segmap_parloop_struct_337912->free_defunc_0_f_res_292820;
    int64_t i_292846 = futhark_mc_segmap_parloop_struct_337912->free_i_292846;
    int64_t gtid_298312 =
            futhark_mc_segmap_parloop_struct_337912->free_gtid_298312;
    int64_t bytes_312641 =
            futhark_mc_segmap_parloop_struct_337912->free_bytes_312641;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_segmap_parloop_struct_337912->free_mem_312838,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_segmap_parloop_struct_337912->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_segmap_parloop_struct_337912->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_segmap_parloop_struct_337912->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_segmap_parloop_struct_337912->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_313223 = {.desc ="mem_313223", .mem =
                                  futhark_mc_segmap_parloop_struct_337912->free_mem_313223,
                                  .size =0, .references =NULL};
    struct memblock mem_313263 = {.desc ="mem_313263", .mem =
                                  futhark_mc_segmap_parloop_struct_337912->free_mem_313263,
                                  .size =0, .references =NULL};
    struct memblock mem_313267 = {.desc ="mem_313267", .mem =
                                  futhark_mc_segmap_parloop_struct_337912->free_mem_313267,
                                  .size =0, .references =NULL};
    size_t mem_318978_cached_sizze_337914 = 0;
    unsigned char *mem_318978 = NULL;
    size_t mem_318980_cached_sizze_337915 = 0;
    unsigned char *mem_318980 = NULL;
    int64_t iterations = end - start;
    int64_t iter_319008 = start;
    
    if (mem_318978_cached_sizze_337914 < (size_t) bytes_312641) {
        mem_318978 = realloc(mem_318978, bytes_312641);
        mem_318978_cached_sizze_337914 = bytes_312641;
    }
    if (mem_318980_cached_sizze_337915 < (size_t) bytes_312641) {
        mem_318980 = realloc(mem_318980, bytes_312641);
        mem_318980_cached_sizze_337915 = bytes_312641;
    }
    for (; iter_319008 < end; iter_319008++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_319030 = n_p_292677;
        int64_t gtid_318977 = iter_319008;
        int64_t remnant_319031 = iter_319008 - gtid_318977;
        
        for (int64_t i_319009 = 0; i_319009 < defunc_0_f_res_292820;
             i_319009++) {
            int64_t x_319012;
            
            x_319012 = ((int64_t *) mem_312838.mem)[gtid_298312 *
                                                    (defunc_0_f_res_292820 *
                                                     n_p_292677) + gtid_318977 *
                                                    defunc_0_f_res_292820 +
                                                    i_319009];
            
            int64_t x_319013 = mul64(n_p_292677, x_319012);
            int64_t idx_319014 = add64(gtid_318977, x_319013);
            bool cond_319015 = slt64(i_292846, idx_319014);
            bool cond_f_res_319016 = slt64(x_319012, (int64_t) 0);
            bool x_319017 = !cond_319015;
            bool y_319018 = cond_f_res_319016 && x_319017;
            bool cond_319019 = cond_319015 || y_319018;
            double defunc_0_f_res_319020;
            double defunc_0_f_res_319021;
            
            if (cond_319019) {
                defunc_0_f_res_319020 = 0.0;
                defunc_0_f_res_319021 = 0.0;
            } else {
                bool x_319022 = sle64((int64_t) 0, idx_319014);
                bool y_319023 = slt64(idx_319014, n_292675);
                bool bounds_check_319024 = x_319022 && y_319023;
                bool index_certs_319025;
                
                if (!bounds_check_319024) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [", (long long) idx_319014,
                                  "] out of bounds for array of shape [",
                                  (long long) n_292675, "].",
                                  "-> #0  stl.fut:193:42-57\n   #1  stl.fut:188:28-194:44\n   #2  /prelude/soacs.fut:67:19-23\n   #3  /prelude/soacs.fut:67:3-37\n   #4  stl.fut:186:21-195:50\n   #5  /prelude/soacs.fut:75:22-28\n   #6  /prelude/soacs.fut:75:3-45\n   #7  stl.fut:184:13-196:57\n   #8  stl.fut:419:61-435:77\n   #9  stl.fut:463:3-479:36\n   #10 stl.fut:445:1-479:36\n");
                    err = FUTHARK_PROGRAM_ERROR;
                    goto cleanup;
                }
                
                double defunc_0_f_res_f_res_319026;
                
                defunc_0_f_res_f_res_319026 =
                    ((double *) mem_313223.mem)[gtid_298312 * n_292675 +
                                                idx_319014];
                
                double defunc_0_f_res_f_res_319027;
                
                defunc_0_f_res_f_res_319027 =
                    ((double *) mem_param_313179.mem)[ctx_param_ext_313174 +
                                                      (gtid_298312 *
                                                       ctx_param_ext_313175 +
                                                       idx_319014 *
                                                       ctx_param_ext_313177)];
                defunc_0_f_res_319020 = defunc_0_f_res_f_res_319026;
                defunc_0_f_res_319021 = defunc_0_f_res_f_res_319027;
            }
            ((double *) mem_318978)[i_319009] = defunc_0_f_res_319020;
            ((double *) mem_318980)[i_319009] = defunc_0_f_res_319021;
        }
        if (defunc_0_f_res_292820 * (int64_t) 8 > 0)
            memmove(mem_313263.mem + gtid_318977 * defunc_0_f_res_292820 *
                    (int64_t) 8, mem_318978 + (int64_t) 0,
                    defunc_0_f_res_292820 * (int64_t) 8);
        if (defunc_0_f_res_292820 * (int64_t) 8 > 0)
            memmove(mem_313267.mem + gtid_318977 * defunc_0_f_res_292820 *
                    (int64_t) 8, mem_318980 + (int64_t) 0,
                    defunc_0_f_res_292820 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_318978);
    free(mem_318980);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_337913_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_337913_end -
                 futhark_mc_segmap_parloop_337913_start;
        
        ctx->futhark_mc_segmap_parloop_337913_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_337913_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_337913_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_337911(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_318976 = tid;
    int num_tasks_319007 = info.nsubtasks;
    struct futhark_mc_task_337910 *futhark_mc_task_337910 =
                                  (struct futhark_mc_task_337910 *) args;
    struct futhark_context *ctx = futhark_mc_task_337910->ctx;
    uint64_t futhark_mc_segmap_task_337911_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_337911_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_337910->free_n_292675;
    int64_t n_p_292677 = futhark_mc_task_337910->free_n_p_292677;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_337910->free_defunc_0_f_res_292820;
    int64_t i_292846 = futhark_mc_task_337910->free_i_292846;
    int64_t gtid_298312 = futhark_mc_task_337910->free_gtid_298312;
    int64_t bytes_312641 = futhark_mc_task_337910->free_bytes_312641;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_task_337910->free_mem_312838,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_task_337910->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_task_337910->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_task_337910->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_task_337910->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_313223 = {.desc ="mem_313223", .mem =
                                  futhark_mc_task_337910->free_mem_313223,
                                  .size =0, .references =NULL};
    struct memblock mem_313263 = {.desc ="mem_313263", .mem =
                                  futhark_mc_task_337910->free_mem_313263,
                                  .size =0, .references =NULL};
    struct memblock mem_313267 = {.desc ="mem_313267", .mem =
                                  futhark_mc_task_337910->free_mem_313267,
                                  .size =0, .references =NULL};
    int64_t iter_319008;
    struct futhark_mc_segmap_parloop_struct_337912
    futhark_mc_segmap_parloop_struct_337912;
    
    futhark_mc_segmap_parloop_struct_337912.ctx = ctx;
    futhark_mc_segmap_parloop_struct_337912.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_337912.free_n_p_292677 = n_p_292677;
    futhark_mc_segmap_parloop_struct_337912.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segmap_parloop_struct_337912.free_i_292846 = i_292846;
    futhark_mc_segmap_parloop_struct_337912.free_gtid_298312 = gtid_298312;
    futhark_mc_segmap_parloop_struct_337912.free_bytes_312641 = bytes_312641;
    futhark_mc_segmap_parloop_struct_337912.free_mem_312838 = mem_312838.mem;
    futhark_mc_segmap_parloop_struct_337912.free_ctx_param_ext_313174 =
        ctx_param_ext_313174;
    futhark_mc_segmap_parloop_struct_337912.free_ctx_param_ext_313175 =
        ctx_param_ext_313175;
    futhark_mc_segmap_parloop_struct_337912.free_ctx_param_ext_313177 =
        ctx_param_ext_313177;
    futhark_mc_segmap_parloop_struct_337912.free_mem_param_313179 =
        mem_param_313179.mem;
    futhark_mc_segmap_parloop_struct_337912.free_mem_313223 = mem_313223.mem;
    futhark_mc_segmap_parloop_struct_337912.free_mem_313263 = mem_313263.mem;
    futhark_mc_segmap_parloop_struct_337912.free_mem_313267 = mem_313267.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_337913_task;
    
    futhark_mc_segmap_parloop_337913_task.name =
        "futhark_mc_segmap_parloop_337913";
    futhark_mc_segmap_parloop_337913_task.fn = futhark_mc_segmap_parloop_337913;
    futhark_mc_segmap_parloop_337913_task.args =
        &futhark_mc_segmap_parloop_struct_337912;
    futhark_mc_segmap_parloop_337913_task.iterations = iterations;
    futhark_mc_segmap_parloop_337913_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_337913_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_337913_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_337913_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_337913_task);
    
    if (futhark_mc_segmap_parloop_337913_err != 0) {
        err = futhark_mc_segmap_parloop_337913_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_337913_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_337913_total_end -
                 futhark_mc_segmap_parloop_337913_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337913_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337913_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337913_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_337911_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_337911_end -
                 futhark_mc_segmap_task_337911_start;
        
        ctx->futhark_mc_segmap_task_337911_runs[tid]++;
        ctx->futhark_mc_segmap_task_337911_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_337911_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_segmap_parloop_struct_337917 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_n_p_292677;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_i_292846;
    int64_t free_gtid_298312;
    int64_t free_bytes_312641;
    unsigned char *free_mem_312838;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_313223;
    unsigned char *free_mem_313263;
    unsigned char *free_mem_313267;
};
struct futhark_mc_task_337921 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_n_p_292677;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_i_292846;
    int64_t free_gtid_298312;
    unsigned char *free_mem_312838;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_313223;
    int64_t free_gtid_318953;
    unsigned char *free_mem_318954;
    unsigned char *free_mem_318955;
};
struct futhark_mc_segmap_parloop_struct_337923 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_n_p_292677;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_i_292846;
    int64_t free_gtid_298312;
    unsigned char *free_mem_312838;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_313223;
    int64_t free_gtid_318953;
    unsigned char *free_mem_318954;
    unsigned char *free_mem_318955;
};
static int futhark_mc_segmap_parloop_337924(void *args, int64_t start,
                                            int64_t end, int flat_tid_319035,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_337923
    *futhark_mc_segmap_parloop_struct_337923 =
    (struct futhark_mc_segmap_parloop_struct_337923 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_337923->ctx;
    uint64_t futhark_mc_segmap_parloop_337924_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_337924_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_337923->free_n_292675;
    int64_t n_p_292677 =
            futhark_mc_segmap_parloop_struct_337923->free_n_p_292677;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segmap_parloop_struct_337923->free_defunc_0_f_res_292820;
    int64_t i_292846 = futhark_mc_segmap_parloop_struct_337923->free_i_292846;
    int64_t gtid_298312 =
            futhark_mc_segmap_parloop_struct_337923->free_gtid_298312;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_segmap_parloop_struct_337923->free_mem_312838,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_segmap_parloop_struct_337923->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_segmap_parloop_struct_337923->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_segmap_parloop_struct_337923->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_segmap_parloop_struct_337923->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_313223 = {.desc ="mem_313223", .mem =
                                  futhark_mc_segmap_parloop_struct_337923->free_mem_313223,
                                  .size =0, .references =NULL};
    int64_t gtid_318953 =
            futhark_mc_segmap_parloop_struct_337923->free_gtid_318953;
    struct memblock mem_318954 = {.desc ="mem_318954", .mem =
                                  futhark_mc_segmap_parloop_struct_337923->free_mem_318954,
                                  .size =0, .references =NULL};
    struct memblock mem_318955 = {.desc ="mem_318955", .mem =
                                  futhark_mc_segmap_parloop_struct_337923->free_mem_318955,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_319056 = start;
    
    for (; iter_319056 < end; iter_319056++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_319063 = defunc_0_f_res_292820;
        int64_t gtid_319036 = iter_319056;
        int64_t remnant_319064 = iter_319056 - gtid_319036;
        int64_t x_319037;
        
        x_319037 = ((int64_t *) mem_312838.mem)[gtid_298312 *
                                                (defunc_0_f_res_292820 *
                                                 n_p_292677) + gtid_318953 *
                                                defunc_0_f_res_292820 +
                                                gtid_319036];
        
        int64_t x_319038 = mul64(n_p_292677, x_319037);
        int64_t idx_319039 = add64(gtid_318953, x_319038);
        bool cond_319040 = slt64(i_292846, idx_319039);
        bool cond_f_res_319041 = slt64(x_319037, (int64_t) 0);
        bool x_319042 = !cond_319040;
        bool y_319043 = cond_f_res_319041 && x_319042;
        bool cond_319044 = cond_319040 || y_319043;
        double defunc_0_f_res_319045;
        double defunc_0_f_res_319046;
        
        if (cond_319044) {
            defunc_0_f_res_319045 = 0.0;
            defunc_0_f_res_319046 = 0.0;
        } else {
            bool x_319057 = sle64((int64_t) 0, idx_319039);
            bool y_319058 = slt64(idx_319039, n_292675);
            bool bounds_check_319059 = x_319057 && y_319058;
            bool index_certs_319060;
            
            if (!bounds_check_319059) {
                ctx->error =
                    msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                              "Index [", (long long) idx_319039,
                              "] out of bounds for array of shape [",
                              (long long) n_292675, "].",
                              "-> #0  stl.fut:193:42-57\n   #1  stl.fut:188:28-194:44\n   #2  /prelude/soacs.fut:67:19-23\n   #3  /prelude/soacs.fut:67:3-37\n   #4  stl.fut:186:21-195:50\n   #5  /prelude/soacs.fut:75:22-28\n   #6  /prelude/soacs.fut:75:3-45\n   #7  stl.fut:184:13-196:57\n   #8  stl.fut:419:61-435:77\n   #9  stl.fut:463:3-479:36\n   #10 stl.fut:445:1-479:36\n");
                err = FUTHARK_PROGRAM_ERROR;
                goto cleanup;
            }
            
            double defunc_0_f_res_f_res_319061;
            
            defunc_0_f_res_f_res_319061 =
                ((double *) mem_313223.mem)[gtid_298312 * n_292675 +
                                            idx_319039];
            
            double defunc_0_f_res_f_res_319062;
            
            defunc_0_f_res_f_res_319062 =
                ((double *) mem_param_313179.mem)[ctx_param_ext_313174 +
                                                  (gtid_298312 *
                                                   ctx_param_ext_313175 +
                                                   idx_319039 *
                                                   ctx_param_ext_313177)];
            defunc_0_f_res_319045 = defunc_0_f_res_f_res_319061;
            defunc_0_f_res_319046 = defunc_0_f_res_f_res_319062;
        }
        ((double *) mem_318954.mem)[gtid_319036] = defunc_0_f_res_319045;
        ((double *) mem_318955.mem)[gtid_319036] = defunc_0_f_res_319046;
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_337924_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_337924_end -
                 futhark_mc_segmap_parloop_337924_start;
        
        ctx->futhark_mc_segmap_parloop_337924_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_337924_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_337924_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_337922(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_319035 = tid;
    int num_tasks_319055 = info.nsubtasks;
    struct futhark_mc_task_337921 *futhark_mc_task_337921 =
                                  (struct futhark_mc_task_337921 *) args;
    struct futhark_context *ctx = futhark_mc_task_337921->ctx;
    uint64_t futhark_mc_segmap_task_337922_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_337922_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_337921->free_n_292675;
    int64_t n_p_292677 = futhark_mc_task_337921->free_n_p_292677;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_337921->free_defunc_0_f_res_292820;
    int64_t i_292846 = futhark_mc_task_337921->free_i_292846;
    int64_t gtid_298312 = futhark_mc_task_337921->free_gtid_298312;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_task_337921->free_mem_312838,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_task_337921->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_task_337921->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_task_337921->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_task_337921->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_313223 = {.desc ="mem_313223", .mem =
                                  futhark_mc_task_337921->free_mem_313223,
                                  .size =0, .references =NULL};
    int64_t gtid_318953 = futhark_mc_task_337921->free_gtid_318953;
    struct memblock mem_318954 = {.desc ="mem_318954", .mem =
                                  futhark_mc_task_337921->free_mem_318954,
                                  .size =0, .references =NULL};
    struct memblock mem_318955 = {.desc ="mem_318955", .mem =
                                  futhark_mc_task_337921->free_mem_318955,
                                  .size =0, .references =NULL};
    int64_t iter_319056;
    struct futhark_mc_segmap_parloop_struct_337923
    futhark_mc_segmap_parloop_struct_337923;
    
    futhark_mc_segmap_parloop_struct_337923.ctx = ctx;
    futhark_mc_segmap_parloop_struct_337923.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_337923.free_n_p_292677 = n_p_292677;
    futhark_mc_segmap_parloop_struct_337923.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segmap_parloop_struct_337923.free_i_292846 = i_292846;
    futhark_mc_segmap_parloop_struct_337923.free_gtid_298312 = gtid_298312;
    futhark_mc_segmap_parloop_struct_337923.free_mem_312838 = mem_312838.mem;
    futhark_mc_segmap_parloop_struct_337923.free_ctx_param_ext_313174 =
        ctx_param_ext_313174;
    futhark_mc_segmap_parloop_struct_337923.free_ctx_param_ext_313175 =
        ctx_param_ext_313175;
    futhark_mc_segmap_parloop_struct_337923.free_ctx_param_ext_313177 =
        ctx_param_ext_313177;
    futhark_mc_segmap_parloop_struct_337923.free_mem_param_313179 =
        mem_param_313179.mem;
    futhark_mc_segmap_parloop_struct_337923.free_mem_313223 = mem_313223.mem;
    futhark_mc_segmap_parloop_struct_337923.free_gtid_318953 = gtid_318953;
    futhark_mc_segmap_parloop_struct_337923.free_mem_318954 = mem_318954.mem;
    futhark_mc_segmap_parloop_struct_337923.free_mem_318955 = mem_318955.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_337924_task;
    
    futhark_mc_segmap_parloop_337924_task.name =
        "futhark_mc_segmap_parloop_337924";
    futhark_mc_segmap_parloop_337924_task.fn = futhark_mc_segmap_parloop_337924;
    futhark_mc_segmap_parloop_337924_task.args =
        &futhark_mc_segmap_parloop_struct_337923;
    futhark_mc_segmap_parloop_337924_task.iterations = iterations;
    futhark_mc_segmap_parloop_337924_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_337924_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_337924_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_337924_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_337924_task);
    
    if (futhark_mc_segmap_parloop_337924_err != 0) {
        err = futhark_mc_segmap_parloop_337924_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_337924_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_337924_total_end -
                 futhark_mc_segmap_parloop_337924_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337924_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337924_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337924_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_337922_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_337922_end -
                 futhark_mc_segmap_task_337922_start;
        
        ctx->futhark_mc_segmap_task_337922_runs[tid]++;
        ctx->futhark_mc_segmap_task_337922_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_337922_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
static int futhark_mc_segmap_parloop_337918(void *args, int64_t start,
                                            int64_t end, int flat_tid_318952,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_337917
    *futhark_mc_segmap_parloop_struct_337917 =
    (struct futhark_mc_segmap_parloop_struct_337917 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_337917->ctx;
    uint64_t futhark_mc_segmap_parloop_337918_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_337918_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_337917->free_n_292675;
    int64_t n_p_292677 =
            futhark_mc_segmap_parloop_struct_337917->free_n_p_292677;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segmap_parloop_struct_337917->free_defunc_0_f_res_292820;
    int64_t i_292846 = futhark_mc_segmap_parloop_struct_337917->free_i_292846;
    int64_t gtid_298312 =
            futhark_mc_segmap_parloop_struct_337917->free_gtid_298312;
    int64_t bytes_312641 =
            futhark_mc_segmap_parloop_struct_337917->free_bytes_312641;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_segmap_parloop_struct_337917->free_mem_312838,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_segmap_parloop_struct_337917->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_segmap_parloop_struct_337917->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_segmap_parloop_struct_337917->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_segmap_parloop_struct_337917->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_313223 = {.desc ="mem_313223", .mem =
                                  futhark_mc_segmap_parloop_struct_337917->free_mem_313223,
                                  .size =0, .references =NULL};
    struct memblock mem_313263 = {.desc ="mem_313263", .mem =
                                  futhark_mc_segmap_parloop_struct_337917->free_mem_313263,
                                  .size =0, .references =NULL};
    struct memblock mem_313267 = {.desc ="mem_313267", .mem =
                                  futhark_mc_segmap_parloop_struct_337917->free_mem_313267,
                                  .size =0, .references =NULL};
    size_t mem_318954_cached_sizze_337919 = 0;
    unsigned char *mem_318954 = NULL;
    size_t mem_318955_cached_sizze_337920 = 0;
    unsigned char *mem_318955 = NULL;
    int64_t iterations = end - start;
    int64_t iter_319034 = start;
    
    if (mem_318954_cached_sizze_337919 < (size_t) bytes_312641) {
        mem_318954 = realloc(mem_318954, bytes_312641);
        mem_318954_cached_sizze_337919 = bytes_312641;
    }
    if (mem_318955_cached_sizze_337920 < (size_t) bytes_312641) {
        mem_318955 = realloc(mem_318955, bytes_312641);
        mem_318955_cached_sizze_337920 = bytes_312641;
    }
    for (; iter_319034 < end; iter_319034++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_319053 = n_p_292677;
        int64_t gtid_318953 = iter_319034;
        int64_t remnant_319054 = iter_319034 - gtid_318953;
        int64_t flat_tid_319035 = (int64_t) 0;
        int32_t num_tasks_319055;
        struct futhark_mc_task_337921 futhark_mc_task_337921;
        
        futhark_mc_task_337921.ctx = ctx;
        futhark_mc_task_337921.free_n_292675 = n_292675;
        futhark_mc_task_337921.free_n_p_292677 = n_p_292677;
        futhark_mc_task_337921.free_defunc_0_f_res_292820 =
            defunc_0_f_res_292820;
        futhark_mc_task_337921.free_i_292846 = i_292846;
        futhark_mc_task_337921.free_gtid_298312 = gtid_298312;
        futhark_mc_task_337921.free_mem_312838 = mem_312838.mem;
        futhark_mc_task_337921.free_ctx_param_ext_313174 = ctx_param_ext_313174;
        futhark_mc_task_337921.free_ctx_param_ext_313175 = ctx_param_ext_313175;
        futhark_mc_task_337921.free_ctx_param_ext_313177 = ctx_param_ext_313177;
        futhark_mc_task_337921.free_mem_param_313179 = mem_param_313179.mem;
        futhark_mc_task_337921.free_mem_313223 = mem_313223.mem;
        futhark_mc_task_337921.free_gtid_318953 = gtid_318953;
        futhark_mc_task_337921.free_mem_318954 = mem_318954;
        futhark_mc_task_337921.free_mem_318955 = mem_318955;
        
        struct scheduler_segop futhark_mc_task_337921_task;
        
        futhark_mc_task_337921_task.args = &futhark_mc_task_337921;
        futhark_mc_task_337921_task.top_level_fn =
            futhark_mc_segmap_task_337922;
        futhark_mc_task_337921_task.name = "futhark_mc_segmap_task_337922";
        futhark_mc_task_337921_task.iterations = defunc_0_f_res_292820;
        futhark_mc_task_337921_task.task_time =
            &ctx->futhark_mc_segmap_task_337922_total_time;
        futhark_mc_task_337921_task.task_iter =
            &ctx->futhark_mc_segmap_task_337922_total_iter;
        futhark_mc_task_337921_task.sched = STATIC;
        futhark_mc_task_337921_task.nested_fn = NULL;
        
        int futhark_mc_segmap_task_337922_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_337921_task);
        
        if (futhark_mc_segmap_task_337922_err != 0) {
            ;
            err = futhark_mc_segmap_task_337922_err;
            goto cleanup;
        }
        if (defunc_0_f_res_292820 * (int64_t) 8 > 0)
            memmove(mem_313263.mem + gtid_318953 * defunc_0_f_res_292820 *
                    (int64_t) 8, mem_318954 + (int64_t) 0,
                    defunc_0_f_res_292820 * (int64_t) 8);
        if (defunc_0_f_res_292820 * (int64_t) 8 > 0)
            memmove(mem_313267.mem + gtid_318953 * defunc_0_f_res_292820 *
                    (int64_t) 8, mem_318955 + (int64_t) 0,
                    defunc_0_f_res_292820 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_318954);
    free(mem_318955);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_337918_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_337918_end -
                 futhark_mc_segmap_parloop_337918_start;
        
        ctx->futhark_mc_segmap_parloop_337918_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_337918_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_337918_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_nested_task_337916(void *args, int64_t iterations,
                                         int tid, struct scheduler_info info)
{
    int err = 0;
    int flat_tid_318952 = tid;
    int num_tasks_319007 = info.nsubtasks;
    struct futhark_mc_task_337910 *futhark_mc_task_337910 =
                                  (struct futhark_mc_task_337910 *) args;
    struct futhark_context *ctx = futhark_mc_task_337910->ctx;
    uint64_t futhark_mc_segmap_nested_task_337916_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_nested_task_337916_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_337910->free_n_292675;
    int64_t n_p_292677 = futhark_mc_task_337910->free_n_p_292677;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_337910->free_defunc_0_f_res_292820;
    int64_t i_292846 = futhark_mc_task_337910->free_i_292846;
    int64_t gtid_298312 = futhark_mc_task_337910->free_gtid_298312;
    int64_t bytes_312641 = futhark_mc_task_337910->free_bytes_312641;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_task_337910->free_mem_312838,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_task_337910->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_task_337910->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_task_337910->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_task_337910->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_313223 = {.desc ="mem_313223", .mem =
                                  futhark_mc_task_337910->free_mem_313223,
                                  .size =0, .references =NULL};
    struct memblock mem_313263 = {.desc ="mem_313263", .mem =
                                  futhark_mc_task_337910->free_mem_313263,
                                  .size =0, .references =NULL};
    struct memblock mem_313267 = {.desc ="mem_313267", .mem =
                                  futhark_mc_task_337910->free_mem_313267,
                                  .size =0, .references =NULL};
    int64_t iter_319034;
    struct futhark_mc_segmap_parloop_struct_337917
    futhark_mc_segmap_parloop_struct_337917;
    
    futhark_mc_segmap_parloop_struct_337917.ctx = ctx;
    futhark_mc_segmap_parloop_struct_337917.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_337917.free_n_p_292677 = n_p_292677;
    futhark_mc_segmap_parloop_struct_337917.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segmap_parloop_struct_337917.free_i_292846 = i_292846;
    futhark_mc_segmap_parloop_struct_337917.free_gtid_298312 = gtid_298312;
    futhark_mc_segmap_parloop_struct_337917.free_bytes_312641 = bytes_312641;
    futhark_mc_segmap_parloop_struct_337917.free_mem_312838 = mem_312838.mem;
    futhark_mc_segmap_parloop_struct_337917.free_ctx_param_ext_313174 =
        ctx_param_ext_313174;
    futhark_mc_segmap_parloop_struct_337917.free_ctx_param_ext_313175 =
        ctx_param_ext_313175;
    futhark_mc_segmap_parloop_struct_337917.free_ctx_param_ext_313177 =
        ctx_param_ext_313177;
    futhark_mc_segmap_parloop_struct_337917.free_mem_param_313179 =
        mem_param_313179.mem;
    futhark_mc_segmap_parloop_struct_337917.free_mem_313223 = mem_313223.mem;
    futhark_mc_segmap_parloop_struct_337917.free_mem_313263 = mem_313263.mem;
    futhark_mc_segmap_parloop_struct_337917.free_mem_313267 = mem_313267.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_337918_task;
    
    futhark_mc_segmap_parloop_337918_task.name =
        "futhark_mc_segmap_parloop_337918";
    futhark_mc_segmap_parloop_337918_task.fn = futhark_mc_segmap_parloop_337918;
    futhark_mc_segmap_parloop_337918_task.args =
        &futhark_mc_segmap_parloop_struct_337917;
    futhark_mc_segmap_parloop_337918_task.iterations = iterations;
    futhark_mc_segmap_parloop_337918_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_337918_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_337918_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_337918_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_337918_task);
    
    if (futhark_mc_segmap_parloop_337918_err != 0) {
        err = futhark_mc_segmap_parloop_337918_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_337918_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_337918_total_end -
                 futhark_mc_segmap_parloop_337918_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337918_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337918_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337918_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_nested_task_337916_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_nested_task_337916_end -
                 futhark_mc_segmap_nested_task_337916_start;
        
        ctx->futhark_mc_segmap_nested_task_337916_runs[tid]++;
        ctx->futhark_mc_segmap_nested_task_337916_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_nested_task_337916_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
static int futhark_mc_segmap_parloop_337907(void *args, int64_t start,
                                            int64_t end, int flat_tid_298311,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_337906
    *futhark_mc_segmap_parloop_struct_337906 =
    (struct futhark_mc_segmap_parloop_struct_337906 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_337906->ctx;
    uint64_t futhark_mc_segmap_parloop_337907_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_337907_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_337906->free_n_292675;
    int64_t n_p_292677 =
            futhark_mc_segmap_parloop_struct_337906->free_n_p_292677;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_337906->free_partition_sizze_292766;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segmap_parloop_struct_337906->free_defunc_0_f_res_292820;
    int64_t i_292846 = futhark_mc_segmap_parloop_struct_337906->free_i_292846;
    int64_t bytes_312641 =
            futhark_mc_segmap_parloop_struct_337906->free_bytes_312641;
    int64_t bytes_312660 =
            futhark_mc_segmap_parloop_struct_337906->free_bytes_312660;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_segmap_parloop_struct_337906->free_mem_312838,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_segmap_parloop_struct_337906->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_segmap_parloop_struct_337906->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_segmap_parloop_struct_337906->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_segmap_parloop_struct_337906->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_313223 = {.desc ="mem_313223", .mem =
                                  futhark_mc_segmap_parloop_struct_337906->free_mem_313223,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_segmap_parloop_struct_337906->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_segmap_parloop_struct_337906->free_mem_313371,
                                  .size =0, .references =NULL};
    size_t mem_313263_cached_sizze_337908 = 0;
    unsigned char *mem_313263 = NULL;
    size_t mem_313267_cached_sizze_337909 = 0;
    unsigned char *mem_313267 = NULL;
    int64_t iterations = end - start;
    int64_t iter_318951 = start;
    
    if (mem_313263_cached_sizze_337908 < (size_t) bytes_312660) {
        mem_313263 = realloc(mem_313263, bytes_312660);
        mem_313263_cached_sizze_337908 = bytes_312660;
    }
    if (mem_313267_cached_sizze_337909 < (size_t) bytes_312660) {
        mem_313267 = realloc(mem_313267, bytes_312660);
        mem_313267_cached_sizze_337909 = bytes_312660;
    }
    for (; iter_318951 < end; iter_318951++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_319005 = partition_sizze_292766;
        int64_t gtid_298312 = iter_318951;
        int64_t remnant_319006 = iter_318951 - gtid_298312;
        int64_t flat_tid_318976 = (int64_t) 0;
        int32_t num_tasks_319007;
        int64_t flat_tid_318952 = (int64_t) 0;
        struct futhark_mc_task_337910 futhark_mc_task_337910;
        
        futhark_mc_task_337910.ctx = ctx;
        futhark_mc_task_337910.free_n_292675 = n_292675;
        futhark_mc_task_337910.free_n_p_292677 = n_p_292677;
        futhark_mc_task_337910.free_defunc_0_f_res_292820 =
            defunc_0_f_res_292820;
        futhark_mc_task_337910.free_i_292846 = i_292846;
        futhark_mc_task_337910.free_gtid_298312 = gtid_298312;
        futhark_mc_task_337910.free_bytes_312641 = bytes_312641;
        futhark_mc_task_337910.free_mem_312838 = mem_312838.mem;
        futhark_mc_task_337910.free_ctx_param_ext_313174 = ctx_param_ext_313174;
        futhark_mc_task_337910.free_ctx_param_ext_313175 = ctx_param_ext_313175;
        futhark_mc_task_337910.free_ctx_param_ext_313177 = ctx_param_ext_313177;
        futhark_mc_task_337910.free_mem_param_313179 = mem_param_313179.mem;
        futhark_mc_task_337910.free_mem_313223 = mem_313223.mem;
        futhark_mc_task_337910.free_mem_313263 = mem_313263;
        futhark_mc_task_337910.free_mem_313267 = mem_313267;
        
        struct scheduler_segop futhark_mc_task_337910_task;
        
        futhark_mc_task_337910_task.args = &futhark_mc_task_337910;
        futhark_mc_task_337910_task.top_level_fn =
            futhark_mc_segmap_task_337911;
        futhark_mc_task_337910_task.name = "futhark_mc_segmap_task_337911";
        futhark_mc_task_337910_task.iterations = n_p_292677;
        futhark_mc_task_337910_task.task_time =
            &ctx->futhark_mc_segmap_task_337911_total_time;
        futhark_mc_task_337910_task.task_iter =
            &ctx->futhark_mc_segmap_task_337911_total_iter;
        futhark_mc_task_337910_task.sched = STATIC;
        futhark_mc_task_337910_task.nested_fn =
            futhark_mc_segmap_nested_task_337916;
        
        int futhark_mc_segmap_task_337911_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_337910_task);
        
        if (futhark_mc_segmap_task_337911_err != 0) {
            ;
            err = futhark_mc_segmap_task_337911_err;
            goto cleanup;
        }
        if (n_p_292677 * defunc_0_f_res_292820 * (int64_t) 8 > 0)
            memmove(mem_313366.mem + gtid_298312 * (defunc_0_f_res_292820 *
                                                    n_p_292677) * (int64_t) 8,
                    mem_313263 + (int64_t) 0, n_p_292677 *
                    defunc_0_f_res_292820 * (int64_t) 8);
        if (n_p_292677 * defunc_0_f_res_292820 * (int64_t) 8 > 0)
            memmove(mem_313371.mem + gtid_298312 * (defunc_0_f_res_292820 *
                                                    n_p_292677) * (int64_t) 8,
                    mem_313267 + (int64_t) 0, n_p_292677 *
                    defunc_0_f_res_292820 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_313263);
    free(mem_313267);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_337907_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_337907_end -
                 futhark_mc_segmap_parloop_337907_start;
        
        ctx->futhark_mc_segmap_parloop_337907_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_337907_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_337907_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_nested_task_337905(void *args, int64_t iterations,
                                         int tid, struct scheduler_info info)
{
    int err = 0;
    int flat_tid_298311 = tid;
    int num_tasks_318917 = info.nsubtasks;
    struct futhark_mc_task_337899 *futhark_mc_task_337899 =
                                  (struct futhark_mc_task_337899 *) args;
    struct futhark_context *ctx = futhark_mc_task_337899->ctx;
    uint64_t futhark_mc_segmap_nested_task_337905_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_nested_task_337905_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_337899->free_n_292675;
    int64_t n_p_292677 = futhark_mc_task_337899->free_n_p_292677;
    int64_t partition_sizze_292766 =
            futhark_mc_task_337899->free_partition_sizze_292766;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_337899->free_defunc_0_f_res_292820;
    int64_t i_292846 = futhark_mc_task_337899->free_i_292846;
    int64_t bytes_312641 = futhark_mc_task_337899->free_bytes_312641;
    int64_t bytes_312660 = futhark_mc_task_337899->free_bytes_312660;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_task_337899->free_mem_312838,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_task_337899->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_task_337899->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_task_337899->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_task_337899->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_313223 = {.desc ="mem_313223", .mem =
                                  futhark_mc_task_337899->free_mem_313223,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_task_337899->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_task_337899->free_mem_313371,
                                  .size =0, .references =NULL};
    int64_t iter_318951;
    struct futhark_mc_segmap_parloop_struct_337906
    futhark_mc_segmap_parloop_struct_337906;
    
    futhark_mc_segmap_parloop_struct_337906.ctx = ctx;
    futhark_mc_segmap_parloop_struct_337906.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_337906.free_n_p_292677 = n_p_292677;
    futhark_mc_segmap_parloop_struct_337906.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_337906.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segmap_parloop_struct_337906.free_i_292846 = i_292846;
    futhark_mc_segmap_parloop_struct_337906.free_bytes_312641 = bytes_312641;
    futhark_mc_segmap_parloop_struct_337906.free_bytes_312660 = bytes_312660;
    futhark_mc_segmap_parloop_struct_337906.free_mem_312838 = mem_312838.mem;
    futhark_mc_segmap_parloop_struct_337906.free_ctx_param_ext_313174 =
        ctx_param_ext_313174;
    futhark_mc_segmap_parloop_struct_337906.free_ctx_param_ext_313175 =
        ctx_param_ext_313175;
    futhark_mc_segmap_parloop_struct_337906.free_ctx_param_ext_313177 =
        ctx_param_ext_313177;
    futhark_mc_segmap_parloop_struct_337906.free_mem_param_313179 =
        mem_param_313179.mem;
    futhark_mc_segmap_parloop_struct_337906.free_mem_313223 = mem_313223.mem;
    futhark_mc_segmap_parloop_struct_337906.free_mem_313366 = mem_313366.mem;
    futhark_mc_segmap_parloop_struct_337906.free_mem_313371 = mem_313371.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_337907_task;
    
    futhark_mc_segmap_parloop_337907_task.name =
        "futhark_mc_segmap_parloop_337907";
    futhark_mc_segmap_parloop_337907_task.fn = futhark_mc_segmap_parloop_337907;
    futhark_mc_segmap_parloop_337907_task.args =
        &futhark_mc_segmap_parloop_struct_337906;
    futhark_mc_segmap_parloop_337907_task.iterations = iterations;
    futhark_mc_segmap_parloop_337907_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_337907_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_337907_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_337907_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_337907_task);
    
    if (futhark_mc_segmap_parloop_337907_err != 0) {
        err = futhark_mc_segmap_parloop_337907_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_337907_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_337907_total_end -
                 futhark_mc_segmap_parloop_337907_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337907_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337907_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337907_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_nested_task_337905_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_nested_task_337905_end -
                 futhark_mc_segmap_nested_task_337905_start;
        
        ctx->futhark_mc_segmap_nested_task_337905_runs[tid]++;
        ctx->futhark_mc_segmap_nested_task_337905_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_nested_task_337905_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_task_337925 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_q_s_292678;
    int64_t free_jump_s_292684;
    int64_t free_partition_sizze_292766;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_312842;
    int64_t free_bytes_312847;
    int64_t free_bytes_312899;
    unsigned char *free_mem_313018;
    unsigned char *free_mem_313023;
    unsigned char *free_mem_313366;
    unsigned char *free_mem_313371;
    unsigned char *free_mem_313450;
};
struct futhark_mc_segmap_parloop_struct_337927 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_q_s_292678;
    int64_t free_jump_s_292684;
    int64_t free_partition_sizze_292766;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_312842;
    int64_t free_bytes_312899;
    unsigned char *free_mem_313018;
    unsigned char *free_mem_313023;
    unsigned char *free_mem_313366;
    unsigned char *free_mem_313371;
    unsigned char *free_mem_313450;
};
static int futhark_mc_segmap_parloop_337928(void *args, int64_t start,
                                            int64_t end, int flat_tid_298364,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_337927
    *futhark_mc_segmap_parloop_struct_337927 =
    (struct futhark_mc_segmap_parloop_struct_337927 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_337927->ctx;
    uint64_t futhark_mc_segmap_parloop_337928_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_337928_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segmap_parloop_struct_337927->free_n_p_292677;
    int64_t q_s_292678 =
            futhark_mc_segmap_parloop_struct_337927->free_q_s_292678;
    int64_t jump_s_292684 =
            futhark_mc_segmap_parloop_struct_337927->free_jump_s_292684;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_337927->free_partition_sizze_292766;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segmap_parloop_struct_337927->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_segmap_parloop_struct_337927->free_pad_css_len_292821;
    int64_t s_n_m_292825 =
            futhark_mc_segmap_parloop_struct_337927->free_s_n_m_292825;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_segmap_parloop_struct_337927->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_312842 = {.desc ="mem_312842", .mem =
                                  futhark_mc_segmap_parloop_struct_337927->free_mem_312842,
                                  .size =0, .references =NULL};
    int64_t bytes_312899 =
            futhark_mc_segmap_parloop_struct_337927->free_bytes_312899;
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_segmap_parloop_struct_337927->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_segmap_parloop_struct_337927->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_segmap_parloop_struct_337927->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_segmap_parloop_struct_337927->free_mem_313371,
                                  .size =0, .references =NULL};
    struct memblock mem_313450 = {.desc ="mem_313450", .mem =
                                  futhark_mc_segmap_parloop_struct_337927->free_mem_313450,
                                  .size =0, .references =NULL};
    size_t mem_313402_cached_sizze_337929 = 0;
    unsigned char *mem_313402 = NULL;
    int64_t iterations = end - start;
    int64_t iter_319069 = start;
    
    if (mem_313402_cached_sizze_337929 < (size_t) bytes_312899) {
        mem_313402 = realloc(mem_313402, bytes_312899);
        mem_313402_cached_sizze_337929 = bytes_312899;
    }
    for (; iter_319069 < end; iter_319069++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_319149 = partition_sizze_292766;
        int64_t gtid_298365 = iter_319069;
        int64_t remnant_319150 = iter_319069 - gtid_298365;
        
        for (int64_t i_319070 = 0; i_319070 < n_p_292677; i_319070++) {
            int64_t x_319072;
            
            x_319072 = ((int64_t *) mem_312842.mem)[gtid_298365 * n_p_292677 +
                                                    i_319070];
            for (int64_t i_319074 = 0; i_319074 < s_n_m_292825; i_319074++) {
                int64_t x_319076;
                
                x_319076 = ((int64_t *) mem_313018.mem)[gtid_298365 *
                                                        (s_n_m_292825 *
                                                         n_p_292677) +
                                                        i_319070 *
                                                        s_n_m_292825 +
                                                        i_319074];
                
                double x_319077;
                
                x_319077 = ((double *) mem_313023.mem)[gtid_298365 *
                                                       (s_n_m_292825 *
                                                        n_p_292677) + i_319070 *
                                                       s_n_m_292825 + i_319074];
                
                bool cond_319078 = i_319074 == (int64_t) 0;
                int64_t defunc_0_m_fun_res_319079;
                
                if (cond_319078) {
                    defunc_0_m_fun_res_319079 = (int64_t) 0;
                } else {
                    int64_t y_319080 = sub64(s_n_m_292825, (int64_t) 1);
                    bool cond_319081 = i_319074 == y_319080;
                    int64_t defunc_0_m_fun_res_f_res_319082;
                    
                    if (cond_319081) {
                        int64_t defunc_0_m_fun_res_f_res_t_res_319083 =
                                sub64(pad_css_len_292821, (int64_t) 1);
                        
                        defunc_0_m_fun_res_f_res_319082 =
                            defunc_0_m_fun_res_f_res_t_res_319083;
                    } else {
                        int64_t x_319084 = sub64(i_319074, (int64_t) 1);
                        int64_t x_319085 = mul64(jump_s_292684, x_319084);
                        int64_t min_arg_319086 = add64((int64_t) 1, x_319085);
                        int64_t min_res_319087 = smin64(defunc_0_f_res_292820,
                                                        min_arg_319086);
                        
                        defunc_0_m_fun_res_f_res_319082 = min_res_319087;
                    }
                    defunc_0_m_fun_res_319079 = defunc_0_m_fun_res_f_res_319082;
                }
                
                double defunc_2_reduce_res_319088;
                double redout_319090 = 0.0;
                
                for (int64_t i_319089 = 0; i_319089 < q_s_292678; i_319089++) {
                    bool cond_319091 = sle64(x_319072, i_319089);
                    int64_t defunc_0_f_res_319092;
                    
                    if (cond_319091) {
                        defunc_0_f_res_319092 = (int64_t) 0;
                    } else {
                        int64_t i_319093 = add64(x_319076, i_319089);
                        int64_t defunc_0_add_arg_319094;
                        
                        defunc_0_add_arg_319094 =
                            ((int64_t *) mem_312838.mem)[gtid_298365 *
                                                         (defunc_0_f_res_292820 *
                                                          n_p_292677) +
                                                         i_319070 *
                                                         defunc_0_f_res_292820 +
                                                         i_319093];
                        
                        int64_t defunc_1_add_res_319095 = add64((int64_t) 1,
                                                                defunc_0_add_arg_319094);
                        
                        defunc_0_f_res_319092 = defunc_1_add_res_319095;
                    }
                    
                    double defunc_0_f_res_319096;
                    
                    if (cond_319091) {
                        defunc_0_f_res_319096 = 0.0;
                    } else {
                        int64_t i_319097 = add64(x_319076, i_319089);
                        double defunc_0_add_arg_319098;
                        
                        defunc_0_add_arg_319098 =
                            ((double *) mem_313371.mem)[gtid_298365 *
                                                        (defunc_0_f_res_292820 *
                                                         n_p_292677) +
                                                        i_319070 *
                                                        defunc_0_f_res_292820 +
                                                        i_319097];
                        defunc_0_f_res_319096 = defunc_0_add_arg_319098;
                    }
                    
                    int64_t binop_p_319099 = sub64(defunc_0_f_res_319092,
                                                   defunc_0_m_fun_res_319079);
                    double defunc_0_f_res_319100 =
                           sitofp_i64_f64(binop_p_319099);
                    double abs_res_319101 = fabs(defunc_0_f_res_319100);
                    double tmp1_319102 = abs_res_319101 / x_319077;
                    double x_319103 = tmp1_319102 * tmp1_319102;
                    double y_319104 = tmp1_319102 * x_319103;
                    double tmp2_319105 = 1.0 - y_319104;
                    double x_319106 = tmp2_319105 * tmp2_319105;
                    double tmp3_319107 = tmp2_319105 * x_319106;
                    double w_j_319108 = defunc_0_f_res_319096 * tmp3_319107;
                    double defunc_1_op_res_319109 = w_j_319108 + redout_319090;
                    double redout_tmp_319153 = defunc_1_op_res_319109;
                    
                    redout_319090 = redout_tmp_319153;
                }
                defunc_2_reduce_res_319088 = redout_319090;
                
                double a_319110 = 2.220446049250313e-16 +
                       defunc_2_reduce_res_319088;
                double a0_319111 = 1.0 / a_319110;
                int64_t defunc_0_m_fun_res_319112;
                
                if (cond_319078) {
                    defunc_0_m_fun_res_319112 = (int64_t) 0;
                } else {
                    int64_t y_319113 = sub64(s_n_m_292825, (int64_t) 1);
                    bool cond_319114 = i_319074 == y_319113;
                    int64_t defunc_0_m_fun_res_f_res_319115;
                    
                    if (cond_319114) {
                        int64_t defunc_0_m_fun_res_f_res_t_res_319116 =
                                sub64(pad_css_len_292821, (int64_t) 1);
                        
                        defunc_0_m_fun_res_f_res_319115 =
                            defunc_0_m_fun_res_f_res_t_res_319116;
                    } else {
                        int64_t x_319117 = sub64(i_319074, (int64_t) 1);
                        int64_t x_319118 = mul64(jump_s_292684, x_319117);
                        int64_t min_arg_319119 = add64((int64_t) 1, x_319118);
                        int64_t min_res_319120 = smin64(defunc_0_f_res_292820,
                                                        min_arg_319119);
                        
                        defunc_0_m_fun_res_f_res_319115 = min_res_319120;
                    }
                    defunc_0_m_fun_res_319112 = defunc_0_m_fun_res_f_res_319115;
                }
                
                double defunc_2_reduce_res_319121;
                double redout_319123 = 0.0;
                
                for (int64_t i_319122 = 0; i_319122 < q_s_292678; i_319122++) {
                    bool cond_319124 = sle64(x_319072, i_319122);
                    int64_t defunc_0_f_res_319125;
                    
                    if (cond_319124) {
                        defunc_0_f_res_319125 = (int64_t) 0;
                    } else {
                        int64_t i_319126 = add64(x_319076, i_319122);
                        int64_t defunc_0_add_arg_319127;
                        
                        defunc_0_add_arg_319127 =
                            ((int64_t *) mem_312838.mem)[gtid_298365 *
                                                         (defunc_0_f_res_292820 *
                                                          n_p_292677) +
                                                         i_319070 *
                                                         defunc_0_f_res_292820 +
                                                         i_319126];
                        
                        int64_t defunc_1_add_res_319128 = add64((int64_t) 1,
                                                                defunc_0_add_arg_319127);
                        
                        defunc_0_f_res_319125 = defunc_1_add_res_319128;
                    }
                    
                    double defunc_0_f_res_319129;
                    
                    if (cond_319124) {
                        defunc_0_f_res_319129 = 0.0;
                    } else {
                        int64_t i_319130 = add64(x_319076, i_319122);
                        double defunc_0_add_arg_319131;
                        
                        defunc_0_add_arg_319131 =
                            ((double *) mem_313371.mem)[gtid_298365 *
                                                        (defunc_0_f_res_292820 *
                                                         n_p_292677) +
                                                        i_319070 *
                                                        defunc_0_f_res_292820 +
                                                        i_319130];
                        defunc_0_f_res_319129 = defunc_0_add_arg_319131;
                    }
                    
                    int64_t binop_p_319132 = sub64(defunc_0_f_res_319125,
                                                   defunc_0_m_fun_res_319112);
                    double defunc_0_f_res_319133 =
                           sitofp_i64_f64(binop_p_319132);
                    double abs_res_319134 = fabs(defunc_0_f_res_319133);
                    double tmp1_319135 = abs_res_319134 / x_319077;
                    double x_319136 = tmp1_319135 * tmp1_319135;
                    double y_319137 = tmp1_319135 * x_319136;
                    double tmp2_319138 = 1.0 - y_319137;
                    double x_319139 = tmp2_319138 * tmp2_319138;
                    double tmp3_319140 = tmp2_319138 * x_319139;
                    double tmp4_319141 = defunc_0_f_res_319129 * tmp3_319140;
                    double defunc_0_f_res_319142;
                    
                    if (cond_319124) {
                        defunc_0_f_res_319142 = 0.0;
                    } else {
                        int64_t i_319143 = add64(x_319076, i_319122);
                        double defunc_0_add_arg_319144;
                        
                        defunc_0_add_arg_319144 =
                            ((double *) mem_313366.mem)[gtid_298365 *
                                                        (defunc_0_f_res_292820 *
                                                         n_p_292677) +
                                                        i_319070 *
                                                        defunc_0_f_res_292820 +
                                                        i_319143];
                        defunc_0_f_res_319142 = defunc_0_add_arg_319144;
                    }
                    
                    double x_319145 = a0_319111 * tmp4_319141;
                    double defunc_9_fit_fun_res_319146 = defunc_0_f_res_319142 *
                           x_319145;
                    double defunc_1_op_res_319147 =
                           defunc_9_fit_fun_res_319146 + redout_319123;
                    double redout_tmp_319154 = defunc_1_op_res_319147;
                    
                    redout_319123 = redout_tmp_319154;
                }
                defunc_2_reduce_res_319121 = redout_319123;
                ((double *) mem_313402)[i_319070 * s_n_m_292825 + i_319074] =
                    defunc_2_reduce_res_319121;
            }
        }
        if (n_p_292677 * s_n_m_292825 * (int64_t) 8 > 0)
            memmove(mem_313450.mem + gtid_298365 * (s_n_m_292825 * n_p_292677) *
                    (int64_t) 8, mem_313402 + (int64_t) 0, n_p_292677 *
                    s_n_m_292825 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_313402);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_337928_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_337928_end -
                 futhark_mc_segmap_parloop_337928_start;
        
        ctx->futhark_mc_segmap_parloop_337928_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_337928_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_337928_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_337926(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_298364 = tid;
    int num_tasks_319068 = info.nsubtasks;
    struct futhark_mc_task_337925 *futhark_mc_task_337925 =
                                  (struct futhark_mc_task_337925 *) args;
    struct futhark_context *ctx = futhark_mc_task_337925->ctx;
    uint64_t futhark_mc_segmap_task_337926_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_337926_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_337925->free_n_p_292677;
    int64_t q_s_292678 = futhark_mc_task_337925->free_q_s_292678;
    int64_t jump_s_292684 = futhark_mc_task_337925->free_jump_s_292684;
    int64_t partition_sizze_292766 =
            futhark_mc_task_337925->free_partition_sizze_292766;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_337925->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_task_337925->free_pad_css_len_292821;
    int64_t s_n_m_292825 = futhark_mc_task_337925->free_s_n_m_292825;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_task_337925->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_312842 = {.desc ="mem_312842", .mem =
                                  futhark_mc_task_337925->free_mem_312842,
                                  .size =0, .references =NULL};
    int64_t bytes_312847 = futhark_mc_task_337925->free_bytes_312847;
    int64_t bytes_312899 = futhark_mc_task_337925->free_bytes_312899;
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_task_337925->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_task_337925->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_task_337925->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_task_337925->free_mem_313371,
                                  .size =0, .references =NULL};
    struct memblock mem_313450 = {.desc ="mem_313450", .mem =
                                  futhark_mc_task_337925->free_mem_313450,
                                  .size =0, .references =NULL};
    int64_t iter_319069;
    struct futhark_mc_segmap_parloop_struct_337927
    futhark_mc_segmap_parloop_struct_337927;
    
    futhark_mc_segmap_parloop_struct_337927.ctx = ctx;
    futhark_mc_segmap_parloop_struct_337927.free_n_p_292677 = n_p_292677;
    futhark_mc_segmap_parloop_struct_337927.free_q_s_292678 = q_s_292678;
    futhark_mc_segmap_parloop_struct_337927.free_jump_s_292684 = jump_s_292684;
    futhark_mc_segmap_parloop_struct_337927.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_337927.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segmap_parloop_struct_337927.free_pad_css_len_292821 =
        pad_css_len_292821;
    futhark_mc_segmap_parloop_struct_337927.free_s_n_m_292825 = s_n_m_292825;
    futhark_mc_segmap_parloop_struct_337927.free_mem_312838 = mem_312838.mem;
    futhark_mc_segmap_parloop_struct_337927.free_mem_312842 = mem_312842.mem;
    futhark_mc_segmap_parloop_struct_337927.free_bytes_312899 = bytes_312899;
    futhark_mc_segmap_parloop_struct_337927.free_mem_313018 = mem_313018.mem;
    futhark_mc_segmap_parloop_struct_337927.free_mem_313023 = mem_313023.mem;
    futhark_mc_segmap_parloop_struct_337927.free_mem_313366 = mem_313366.mem;
    futhark_mc_segmap_parloop_struct_337927.free_mem_313371 = mem_313371.mem;
    futhark_mc_segmap_parloop_struct_337927.free_mem_313450 = mem_313450.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_337928_task;
    
    futhark_mc_segmap_parloop_337928_task.name =
        "futhark_mc_segmap_parloop_337928";
    futhark_mc_segmap_parloop_337928_task.fn = futhark_mc_segmap_parloop_337928;
    futhark_mc_segmap_parloop_337928_task.args =
        &futhark_mc_segmap_parloop_struct_337927;
    futhark_mc_segmap_parloop_337928_task.iterations = iterations;
    futhark_mc_segmap_parloop_337928_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_337928_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_337928_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_337928_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_337928_task);
    
    if (futhark_mc_segmap_parloop_337928_err != 0) {
        err = futhark_mc_segmap_parloop_337928_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_337928_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_337928_total_end -
                 futhark_mc_segmap_parloop_337928_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337928_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337928_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337928_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_337926_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_337926_end -
                 futhark_mc_segmap_task_337926_start;
        
        ctx->futhark_mc_segmap_task_337926_runs[tid]++;
        ctx->futhark_mc_segmap_task_337926_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_337926_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_segmap_parloop_struct_337931 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_q_s_292678;
    int64_t free_jump_s_292684;
    int64_t free_partition_sizze_292766;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_312842;
    int64_t free_bytes_312847;
    int64_t free_bytes_312899;
    unsigned char *free_mem_313018;
    unsigned char *free_mem_313023;
    unsigned char *free_mem_313366;
    unsigned char *free_mem_313371;
    unsigned char *free_mem_313450;
};
struct futhark_mc_task_337934 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_q_s_292678;
    int64_t free_jump_s_292684;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    int64_t free_gtid_298629;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_312842;
    int64_t free_bytes_312847;
    unsigned char *free_mem_313018;
    unsigned char *free_mem_313023;
    unsigned char *free_mem_313366;
    unsigned char *free_mem_313371;
    unsigned char *free_mem_313398;
};
struct futhark_mc_segmap_parloop_struct_337936 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_q_s_292678;
    int64_t free_jump_s_292684;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    int64_t free_gtid_298629;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_312842;
    int64_t free_bytes_312847;
    unsigned char *free_mem_313018;
    unsigned char *free_mem_313023;
    unsigned char *free_mem_313366;
    unsigned char *free_mem_313371;
    unsigned char *free_mem_313398;
};
static int futhark_mc_segmap_parloop_337937(void *args, int64_t start,
                                            int64_t end, int flat_tid_319313,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_337936
    *futhark_mc_segmap_parloop_struct_337936 =
    (struct futhark_mc_segmap_parloop_struct_337936 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_337936->ctx;
    uint64_t futhark_mc_segmap_parloop_337937_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_337937_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segmap_parloop_struct_337936->free_n_p_292677;
    int64_t q_s_292678 =
            futhark_mc_segmap_parloop_struct_337936->free_q_s_292678;
    int64_t jump_s_292684 =
            futhark_mc_segmap_parloop_struct_337936->free_jump_s_292684;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segmap_parloop_struct_337936->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_segmap_parloop_struct_337936->free_pad_css_len_292821;
    int64_t s_n_m_292825 =
            futhark_mc_segmap_parloop_struct_337936->free_s_n_m_292825;
    int64_t gtid_298629 =
            futhark_mc_segmap_parloop_struct_337936->free_gtid_298629;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_segmap_parloop_struct_337936->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_312842 = {.desc ="mem_312842", .mem =
                                  futhark_mc_segmap_parloop_struct_337936->free_mem_312842,
                                  .size =0, .references =NULL};
    int64_t bytes_312847 =
            futhark_mc_segmap_parloop_struct_337936->free_bytes_312847;
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_segmap_parloop_struct_337936->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_segmap_parloop_struct_337936->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_segmap_parloop_struct_337936->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_segmap_parloop_struct_337936->free_mem_313371,
                                  .size =0, .references =NULL};
    struct memblock mem_313398 = {.desc ="mem_313398", .mem =
                                  futhark_mc_segmap_parloop_struct_337936->free_mem_313398,
                                  .size =0, .references =NULL};
    size_t mem_319316_cached_sizze_337938 = 0;
    unsigned char *mem_319316 = NULL;
    int64_t iterations = end - start;
    int64_t iter_319397 = start;
    
    if (mem_319316_cached_sizze_337938 < (size_t) bytes_312847) {
        mem_319316 = realloc(mem_319316, bytes_312847);
        mem_319316_cached_sizze_337938 = bytes_312847;
    }
    for (; iter_319397 < end; iter_319397++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_319473 = n_p_292677;
        int64_t gtid_319314 = iter_319397;
        int64_t remnant_319474 = iter_319397 - gtid_319314;
        int64_t x_319315;
        
        x_319315 = ((int64_t *) mem_312842.mem)[gtid_298629 * n_p_292677 +
                                                gtid_319314];
        for (int64_t i_319398 = 0; i_319398 < s_n_m_292825; i_319398++) {
            int64_t x_319400;
            
            x_319400 = ((int64_t *) mem_313018.mem)[gtid_298629 *
                                                    (s_n_m_292825 *
                                                     n_p_292677) + gtid_319314 *
                                                    s_n_m_292825 + i_319398];
            
            double x_319401;
            
            x_319401 = ((double *) mem_313023.mem)[gtid_298629 * (s_n_m_292825 *
                                                                  n_p_292677) +
                                                   gtid_319314 * s_n_m_292825 +
                                                   i_319398];
            
            bool cond_319402 = i_319398 == (int64_t) 0;
            int64_t defunc_0_m_fun_res_319403;
            
            if (cond_319402) {
                defunc_0_m_fun_res_319403 = (int64_t) 0;
            } else {
                int64_t y_319404 = sub64(s_n_m_292825, (int64_t) 1);
                bool cond_319405 = i_319398 == y_319404;
                int64_t defunc_0_m_fun_res_f_res_319406;
                
                if (cond_319405) {
                    int64_t defunc_0_m_fun_res_f_res_t_res_319407 =
                            sub64(pad_css_len_292821, (int64_t) 1);
                    
                    defunc_0_m_fun_res_f_res_319406 =
                        defunc_0_m_fun_res_f_res_t_res_319407;
                } else {
                    int64_t x_319408 = sub64(i_319398, (int64_t) 1);
                    int64_t x_319409 = mul64(jump_s_292684, x_319408);
                    int64_t min_arg_319410 = add64((int64_t) 1, x_319409);
                    int64_t min_res_319411 = smin64(defunc_0_f_res_292820,
                                                    min_arg_319410);
                    
                    defunc_0_m_fun_res_f_res_319406 = min_res_319411;
                }
                defunc_0_m_fun_res_319403 = defunc_0_m_fun_res_f_res_319406;
            }
            
            double defunc_2_reduce_res_319412;
            double redout_319414 = 0.0;
            
            for (int64_t i_319413 = 0; i_319413 < q_s_292678; i_319413++) {
                bool cond_319415 = sle64(x_319315, i_319413);
                int64_t defunc_0_f_res_319416;
                
                if (cond_319415) {
                    defunc_0_f_res_319416 = (int64_t) 0;
                } else {
                    int64_t i_319417 = add64(x_319400, i_319413);
                    int64_t defunc_0_add_arg_319418;
                    
                    defunc_0_add_arg_319418 =
                        ((int64_t *) mem_312838.mem)[gtid_298629 *
                                                     (defunc_0_f_res_292820 *
                                                      n_p_292677) +
                                                     gtid_319314 *
                                                     defunc_0_f_res_292820 +
                                                     i_319417];
                    
                    int64_t defunc_1_add_res_319419 = add64((int64_t) 1,
                                                            defunc_0_add_arg_319418);
                    
                    defunc_0_f_res_319416 = defunc_1_add_res_319419;
                }
                
                double defunc_0_f_res_319420;
                
                if (cond_319415) {
                    defunc_0_f_res_319420 = 0.0;
                } else {
                    int64_t i_319421 = add64(x_319400, i_319413);
                    double defunc_0_add_arg_319422;
                    
                    defunc_0_add_arg_319422 =
                        ((double *) mem_313371.mem)[gtid_298629 *
                                                    (defunc_0_f_res_292820 *
                                                     n_p_292677) + gtid_319314 *
                                                    defunc_0_f_res_292820 +
                                                    i_319421];
                    defunc_0_f_res_319420 = defunc_0_add_arg_319422;
                }
                
                int64_t binop_p_319423 = sub64(defunc_0_f_res_319416,
                                               defunc_0_m_fun_res_319403);
                double defunc_0_f_res_319424 = sitofp_i64_f64(binop_p_319423);
                double abs_res_319425 = fabs(defunc_0_f_res_319424);
                double tmp1_319426 = abs_res_319425 / x_319401;
                double x_319427 = tmp1_319426 * tmp1_319426;
                double y_319428 = tmp1_319426 * x_319427;
                double tmp2_319429 = 1.0 - y_319428;
                double x_319430 = tmp2_319429 * tmp2_319429;
                double tmp3_319431 = tmp2_319429 * x_319430;
                double w_j_319432 = defunc_0_f_res_319420 * tmp3_319431;
                double defunc_1_op_res_319433 = w_j_319432 + redout_319414;
                double redout_tmp_319476 = defunc_1_op_res_319433;
                
                redout_319414 = redout_tmp_319476;
            }
            defunc_2_reduce_res_319412 = redout_319414;
            
            double a_319434 = 2.220446049250313e-16 +
                   defunc_2_reduce_res_319412;
            double a0_319435 = 1.0 / a_319434;
            int64_t defunc_0_m_fun_res_319436;
            
            if (cond_319402) {
                defunc_0_m_fun_res_319436 = (int64_t) 0;
            } else {
                int64_t y_319437 = sub64(s_n_m_292825, (int64_t) 1);
                bool cond_319438 = i_319398 == y_319437;
                int64_t defunc_0_m_fun_res_f_res_319439;
                
                if (cond_319438) {
                    int64_t defunc_0_m_fun_res_f_res_t_res_319440 =
                            sub64(pad_css_len_292821, (int64_t) 1);
                    
                    defunc_0_m_fun_res_f_res_319439 =
                        defunc_0_m_fun_res_f_res_t_res_319440;
                } else {
                    int64_t x_319441 = sub64(i_319398, (int64_t) 1);
                    int64_t x_319442 = mul64(jump_s_292684, x_319441);
                    int64_t min_arg_319443 = add64((int64_t) 1, x_319442);
                    int64_t min_res_319444 = smin64(defunc_0_f_res_292820,
                                                    min_arg_319443);
                    
                    defunc_0_m_fun_res_f_res_319439 = min_res_319444;
                }
                defunc_0_m_fun_res_319436 = defunc_0_m_fun_res_f_res_319439;
            }
            
            double defunc_2_reduce_res_319445;
            double redout_319447 = 0.0;
            
            for (int64_t i_319446 = 0; i_319446 < q_s_292678; i_319446++) {
                bool cond_319448 = sle64(x_319315, i_319446);
                int64_t defunc_0_f_res_319449;
                
                if (cond_319448) {
                    defunc_0_f_res_319449 = (int64_t) 0;
                } else {
                    int64_t i_319450 = add64(x_319400, i_319446);
                    int64_t defunc_0_add_arg_319451;
                    
                    defunc_0_add_arg_319451 =
                        ((int64_t *) mem_312838.mem)[gtid_298629 *
                                                     (defunc_0_f_res_292820 *
                                                      n_p_292677) +
                                                     gtid_319314 *
                                                     defunc_0_f_res_292820 +
                                                     i_319450];
                    
                    int64_t defunc_1_add_res_319452 = add64((int64_t) 1,
                                                            defunc_0_add_arg_319451);
                    
                    defunc_0_f_res_319449 = defunc_1_add_res_319452;
                }
                
                double defunc_0_f_res_319453;
                
                if (cond_319448) {
                    defunc_0_f_res_319453 = 0.0;
                } else {
                    int64_t i_319454 = add64(x_319400, i_319446);
                    double defunc_0_add_arg_319455;
                    
                    defunc_0_add_arg_319455 =
                        ((double *) mem_313371.mem)[gtid_298629 *
                                                    (defunc_0_f_res_292820 *
                                                     n_p_292677) + gtid_319314 *
                                                    defunc_0_f_res_292820 +
                                                    i_319454];
                    defunc_0_f_res_319453 = defunc_0_add_arg_319455;
                }
                
                int64_t binop_p_319456 = sub64(defunc_0_f_res_319449,
                                               defunc_0_m_fun_res_319436);
                double defunc_0_f_res_319457 = sitofp_i64_f64(binop_p_319456);
                double abs_res_319458 = fabs(defunc_0_f_res_319457);
                double tmp1_319459 = abs_res_319458 / x_319401;
                double x_319460 = tmp1_319459 * tmp1_319459;
                double y_319461 = tmp1_319459 * x_319460;
                double tmp2_319462 = 1.0 - y_319461;
                double x_319463 = tmp2_319462 * tmp2_319462;
                double tmp3_319464 = tmp2_319462 * x_319463;
                double tmp4_319465 = defunc_0_f_res_319453 * tmp3_319464;
                double defunc_0_f_res_319466;
                
                if (cond_319448) {
                    defunc_0_f_res_319466 = 0.0;
                } else {
                    int64_t i_319467 = add64(x_319400, i_319446);
                    double defunc_0_add_arg_319468;
                    
                    defunc_0_add_arg_319468 =
                        ((double *) mem_313366.mem)[gtid_298629 *
                                                    (defunc_0_f_res_292820 *
                                                     n_p_292677) + gtid_319314 *
                                                    defunc_0_f_res_292820 +
                                                    i_319467];
                    defunc_0_f_res_319466 = defunc_0_add_arg_319468;
                }
                
                double x_319469 = a0_319435 * tmp4_319465;
                double defunc_9_fit_fun_res_319470 = defunc_0_f_res_319466 *
                       x_319469;
                double defunc_1_op_res_319471 = defunc_9_fit_fun_res_319470 +
                       redout_319447;
                double redout_tmp_319477 = defunc_1_op_res_319471;
                
                redout_319447 = redout_tmp_319477;
            }
            defunc_2_reduce_res_319445 = redout_319447;
            ((double *) mem_319316)[i_319398] = defunc_2_reduce_res_319445;
        }
        if (s_n_m_292825 * (int64_t) 8 > 0)
            memmove(mem_313398.mem + gtid_319314 * s_n_m_292825 * (int64_t) 8,
                    mem_319316 + (int64_t) 0, s_n_m_292825 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_319316);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_337937_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_337937_end -
                 futhark_mc_segmap_parloop_337937_start;
        
        ctx->futhark_mc_segmap_parloop_337937_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_337937_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_337937_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_337935(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_319313 = tid;
    int num_tasks_319396 = info.nsubtasks;
    struct futhark_mc_task_337934 *futhark_mc_task_337934 =
                                  (struct futhark_mc_task_337934 *) args;
    struct futhark_context *ctx = futhark_mc_task_337934->ctx;
    uint64_t futhark_mc_segmap_task_337935_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_337935_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_337934->free_n_p_292677;
    int64_t q_s_292678 = futhark_mc_task_337934->free_q_s_292678;
    int64_t jump_s_292684 = futhark_mc_task_337934->free_jump_s_292684;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_337934->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_task_337934->free_pad_css_len_292821;
    int64_t s_n_m_292825 = futhark_mc_task_337934->free_s_n_m_292825;
    int64_t gtid_298629 = futhark_mc_task_337934->free_gtid_298629;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_task_337934->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_312842 = {.desc ="mem_312842", .mem =
                                  futhark_mc_task_337934->free_mem_312842,
                                  .size =0, .references =NULL};
    int64_t bytes_312847 = futhark_mc_task_337934->free_bytes_312847;
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_task_337934->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_task_337934->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_task_337934->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_task_337934->free_mem_313371,
                                  .size =0, .references =NULL};
    struct memblock mem_313398 = {.desc ="mem_313398", .mem =
                                  futhark_mc_task_337934->free_mem_313398,
                                  .size =0, .references =NULL};
    int64_t iter_319397;
    struct futhark_mc_segmap_parloop_struct_337936
    futhark_mc_segmap_parloop_struct_337936;
    
    futhark_mc_segmap_parloop_struct_337936.ctx = ctx;
    futhark_mc_segmap_parloop_struct_337936.free_n_p_292677 = n_p_292677;
    futhark_mc_segmap_parloop_struct_337936.free_q_s_292678 = q_s_292678;
    futhark_mc_segmap_parloop_struct_337936.free_jump_s_292684 = jump_s_292684;
    futhark_mc_segmap_parloop_struct_337936.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segmap_parloop_struct_337936.free_pad_css_len_292821 =
        pad_css_len_292821;
    futhark_mc_segmap_parloop_struct_337936.free_s_n_m_292825 = s_n_m_292825;
    futhark_mc_segmap_parloop_struct_337936.free_gtid_298629 = gtid_298629;
    futhark_mc_segmap_parloop_struct_337936.free_mem_312838 = mem_312838.mem;
    futhark_mc_segmap_parloop_struct_337936.free_mem_312842 = mem_312842.mem;
    futhark_mc_segmap_parloop_struct_337936.free_bytes_312847 = bytes_312847;
    futhark_mc_segmap_parloop_struct_337936.free_mem_313018 = mem_313018.mem;
    futhark_mc_segmap_parloop_struct_337936.free_mem_313023 = mem_313023.mem;
    futhark_mc_segmap_parloop_struct_337936.free_mem_313366 = mem_313366.mem;
    futhark_mc_segmap_parloop_struct_337936.free_mem_313371 = mem_313371.mem;
    futhark_mc_segmap_parloop_struct_337936.free_mem_313398 = mem_313398.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_337937_task;
    
    futhark_mc_segmap_parloop_337937_task.name =
        "futhark_mc_segmap_parloop_337937";
    futhark_mc_segmap_parloop_337937_task.fn = futhark_mc_segmap_parloop_337937;
    futhark_mc_segmap_parloop_337937_task.args =
        &futhark_mc_segmap_parloop_struct_337936;
    futhark_mc_segmap_parloop_337937_task.iterations = iterations;
    futhark_mc_segmap_parloop_337937_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_337937_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_337937_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_337937_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_337937_task);
    
    if (futhark_mc_segmap_parloop_337937_err != 0) {
        err = futhark_mc_segmap_parloop_337937_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_337937_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_337937_total_end -
                 futhark_mc_segmap_parloop_337937_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337937_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337937_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337937_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_337935_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_337935_end -
                 futhark_mc_segmap_task_337935_start;
        
        ctx->futhark_mc_segmap_task_337935_runs[tid]++;
        ctx->futhark_mc_segmap_task_337935_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_337935_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_segmap_parloop_struct_337940 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_q_s_292678;
    int64_t free_jump_s_292684;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    int64_t free_gtid_298629;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_312842;
    int64_t free_bytes_312847;
    unsigned char *free_mem_313018;
    unsigned char *free_mem_313023;
    unsigned char *free_mem_313366;
    unsigned char *free_mem_313371;
    unsigned char *free_mem_313398;
};
struct futhark_mc_task_337943 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_q_s_292678;
    int64_t free_jump_s_292684;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    int64_t free_gtid_298629;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_313018;
    unsigned char *free_mem_313023;
    unsigned char *free_mem_313366;
    unsigned char *free_mem_313371;
    int64_t free_gtid_319157;
    int64_t free_x_319158;
    unsigned char *free_mem_319159;
};
struct futhark_mc_segmap_parloop_struct_337945 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_q_s_292678;
    int64_t free_jump_s_292684;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    int64_t free_gtid_298629;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_313018;
    unsigned char *free_mem_313023;
    unsigned char *free_mem_313366;
    unsigned char *free_mem_313371;
    int64_t free_gtid_319157;
    int64_t free_x_319158;
    unsigned char *free_mem_319159;
};
static int futhark_mc_segmap_parloop_337946(void *args, int64_t start,
                                            int64_t end, int flat_tid_319557,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_337945
    *futhark_mc_segmap_parloop_struct_337945 =
    (struct futhark_mc_segmap_parloop_struct_337945 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_337945->ctx;
    uint64_t futhark_mc_segmap_parloop_337946_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_337946_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segmap_parloop_struct_337945->free_n_p_292677;
    int64_t q_s_292678 =
            futhark_mc_segmap_parloop_struct_337945->free_q_s_292678;
    int64_t jump_s_292684 =
            futhark_mc_segmap_parloop_struct_337945->free_jump_s_292684;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segmap_parloop_struct_337945->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_segmap_parloop_struct_337945->free_pad_css_len_292821;
    int64_t s_n_m_292825 =
            futhark_mc_segmap_parloop_struct_337945->free_s_n_m_292825;
    int64_t gtid_298629 =
            futhark_mc_segmap_parloop_struct_337945->free_gtid_298629;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_segmap_parloop_struct_337945->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_segmap_parloop_struct_337945->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_segmap_parloop_struct_337945->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_segmap_parloop_struct_337945->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_segmap_parloop_struct_337945->free_mem_313371,
                                  .size =0, .references =NULL};
    int64_t gtid_319157 =
            futhark_mc_segmap_parloop_struct_337945->free_gtid_319157;
    int64_t x_319158 = futhark_mc_segmap_parloop_struct_337945->free_x_319158;
    struct memblock mem_319159 = {.desc ="mem_319159", .mem =
                                  futhark_mc_segmap_parloop_struct_337945->free_mem_319159,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_319634 = start;
    
    for (; iter_319634 < end; iter_319634++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_319698 = s_n_m_292825;
        int64_t gtid_319558 = iter_319634;
        int64_t remnant_319699 = iter_319634 - gtid_319558;
        int64_t x_319559;
        
        x_319559 = ((int64_t *) mem_313018.mem)[gtid_298629 * (s_n_m_292825 *
                                                               n_p_292677) +
                                                gtid_319157 * s_n_m_292825 +
                                                gtid_319558];
        
        double x_319560;
        
        x_319560 = ((double *) mem_313023.mem)[gtid_298629 * (s_n_m_292825 *
                                                              n_p_292677) +
                                               gtid_319157 * s_n_m_292825 +
                                               gtid_319558];
        
        bool cond_319561 = gtid_319558 == (int64_t) 0;
        int64_t defunc_0_m_fun_res_319562;
        
        if (cond_319561) {
            defunc_0_m_fun_res_319562 = (int64_t) 0;
        } else {
            int64_t y_319635 = sub64(s_n_m_292825, (int64_t) 1);
            bool cond_319636 = gtid_319558 == y_319635;
            int64_t defunc_0_m_fun_res_f_res_319637;
            
            if (cond_319636) {
                int64_t defunc_0_m_fun_res_f_res_t_res_319638 =
                        sub64(pad_css_len_292821, (int64_t) 1);
                
                defunc_0_m_fun_res_f_res_319637 =
                    defunc_0_m_fun_res_f_res_t_res_319638;
            } else {
                int64_t x_319639 = sub64(gtid_319558, (int64_t) 1);
                int64_t x_319640 = mul64(jump_s_292684, x_319639);
                int64_t min_arg_319641 = add64((int64_t) 1, x_319640);
                int64_t min_res_319642 = smin64(defunc_0_f_res_292820,
                                                min_arg_319641);
                
                defunc_0_m_fun_res_f_res_319637 = min_res_319642;
            }
            defunc_0_m_fun_res_319562 = defunc_0_m_fun_res_f_res_319637;
        }
        
        double defunc_2_reduce_res_319571;
        double redout_319644 = 0.0;
        
        for (int64_t i_319643 = 0; i_319643 < q_s_292678; i_319643++) {
            bool cond_319645 = sle64(x_319158, i_319643);
            int64_t defunc_0_f_res_319646;
            
            if (cond_319645) {
                defunc_0_f_res_319646 = (int64_t) 0;
            } else {
                int64_t i_319647 = add64(x_319559, i_319643);
                int64_t defunc_0_add_arg_319648;
                
                defunc_0_add_arg_319648 =
                    ((int64_t *) mem_312838.mem)[gtid_298629 *
                                                 (defunc_0_f_res_292820 *
                                                  n_p_292677) + gtid_319157 *
                                                 defunc_0_f_res_292820 +
                                                 i_319647];
                
                int64_t defunc_1_add_res_319649 = add64((int64_t) 1,
                                                        defunc_0_add_arg_319648);
                
                defunc_0_f_res_319646 = defunc_1_add_res_319649;
            }
            
            double defunc_0_f_res_319650;
            
            if (cond_319645) {
                defunc_0_f_res_319650 = 0.0;
            } else {
                int64_t i_319651 = add64(x_319559, i_319643);
                double defunc_0_add_arg_319652;
                
                defunc_0_add_arg_319652 =
                    ((double *) mem_313371.mem)[gtid_298629 *
                                                (defunc_0_f_res_292820 *
                                                 n_p_292677) + gtid_319157 *
                                                defunc_0_f_res_292820 +
                                                i_319651];
                defunc_0_f_res_319650 = defunc_0_add_arg_319652;
            }
            
            int64_t binop_p_319653 = sub64(defunc_0_f_res_319646,
                                           defunc_0_m_fun_res_319562);
            double defunc_0_f_res_319654 = sitofp_i64_f64(binop_p_319653);
            double abs_res_319655 = fabs(defunc_0_f_res_319654);
            double tmp1_319656 = abs_res_319655 / x_319560;
            double x_319657 = tmp1_319656 * tmp1_319656;
            double y_319658 = tmp1_319656 * x_319657;
            double tmp2_319659 = 1.0 - y_319658;
            double x_319660 = tmp2_319659 * tmp2_319659;
            double tmp3_319661 = tmp2_319659 * x_319660;
            double w_j_319662 = defunc_0_f_res_319650 * tmp3_319661;
            double defunc_1_op_res_319663 = w_j_319662 + redout_319644;
            double redout_tmp_319700 = defunc_1_op_res_319663;
            
            redout_319644 = redout_tmp_319700;
        }
        defunc_2_reduce_res_319571 = redout_319644;
        
        double a_319593 = 2.220446049250313e-16 + defunc_2_reduce_res_319571;
        double a0_319594 = 1.0 / a_319593;
        int64_t defunc_0_m_fun_res_319595;
        
        if (cond_319561) {
            defunc_0_m_fun_res_319595 = (int64_t) 0;
        } else {
            int64_t y_319664 = sub64(s_n_m_292825, (int64_t) 1);
            bool cond_319665 = gtid_319558 == y_319664;
            int64_t defunc_0_m_fun_res_f_res_319666;
            
            if (cond_319665) {
                int64_t defunc_0_m_fun_res_f_res_t_res_319667 =
                        sub64(pad_css_len_292821, (int64_t) 1);
                
                defunc_0_m_fun_res_f_res_319666 =
                    defunc_0_m_fun_res_f_res_t_res_319667;
            } else {
                int64_t x_319668 = sub64(gtid_319558, (int64_t) 1);
                int64_t x_319669 = mul64(jump_s_292684, x_319668);
                int64_t min_arg_319670 = add64((int64_t) 1, x_319669);
                int64_t min_res_319671 = smin64(defunc_0_f_res_292820,
                                                min_arg_319670);
                
                defunc_0_m_fun_res_f_res_319666 = min_res_319671;
            }
            defunc_0_m_fun_res_319595 = defunc_0_m_fun_res_f_res_319666;
        }
        
        double defunc_2_reduce_res_319604;
        double redout_319673 = 0.0;
        
        for (int64_t i_319672 = 0; i_319672 < q_s_292678; i_319672++) {
            bool cond_319674 = sle64(x_319158, i_319672);
            int64_t defunc_0_f_res_319675;
            
            if (cond_319674) {
                defunc_0_f_res_319675 = (int64_t) 0;
            } else {
                int64_t i_319676 = add64(x_319559, i_319672);
                int64_t defunc_0_add_arg_319677;
                
                defunc_0_add_arg_319677 =
                    ((int64_t *) mem_312838.mem)[gtid_298629 *
                                                 (defunc_0_f_res_292820 *
                                                  n_p_292677) + gtid_319157 *
                                                 defunc_0_f_res_292820 +
                                                 i_319676];
                
                int64_t defunc_1_add_res_319678 = add64((int64_t) 1,
                                                        defunc_0_add_arg_319677);
                
                defunc_0_f_res_319675 = defunc_1_add_res_319678;
            }
            
            double defunc_0_f_res_319679;
            
            if (cond_319674) {
                defunc_0_f_res_319679 = 0.0;
            } else {
                int64_t i_319680 = add64(x_319559, i_319672);
                double defunc_0_add_arg_319681;
                
                defunc_0_add_arg_319681 =
                    ((double *) mem_313371.mem)[gtid_298629 *
                                                (defunc_0_f_res_292820 *
                                                 n_p_292677) + gtid_319157 *
                                                defunc_0_f_res_292820 +
                                                i_319680];
                defunc_0_f_res_319679 = defunc_0_add_arg_319681;
            }
            
            int64_t binop_p_319682 = sub64(defunc_0_f_res_319675,
                                           defunc_0_m_fun_res_319595);
            double defunc_0_f_res_319683 = sitofp_i64_f64(binop_p_319682);
            double abs_res_319684 = fabs(defunc_0_f_res_319683);
            double tmp1_319685 = abs_res_319684 / x_319560;
            double x_319686 = tmp1_319685 * tmp1_319685;
            double y_319687 = tmp1_319685 * x_319686;
            double tmp2_319688 = 1.0 - y_319687;
            double x_319689 = tmp2_319688 * tmp2_319688;
            double tmp3_319690 = tmp2_319688 * x_319689;
            double tmp4_319691 = defunc_0_f_res_319679 * tmp3_319690;
            double defunc_0_f_res_319692;
            
            if (cond_319674) {
                defunc_0_f_res_319692 = 0.0;
            } else {
                int64_t i_319693 = add64(x_319559, i_319672);
                double defunc_0_add_arg_319694;
                
                defunc_0_add_arg_319694 =
                    ((double *) mem_313366.mem)[gtid_298629 *
                                                (defunc_0_f_res_292820 *
                                                 n_p_292677) + gtid_319157 *
                                                defunc_0_f_res_292820 +
                                                i_319693];
                defunc_0_f_res_319692 = defunc_0_add_arg_319694;
            }
            
            double x_319695 = a0_319594 * tmp4_319691;
            double defunc_9_fit_fun_res_319696 = defunc_0_f_res_319692 *
                   x_319695;
            double defunc_1_op_res_319697 = defunc_9_fit_fun_res_319696 +
                   redout_319673;
            double redout_tmp_319701 = defunc_1_op_res_319697;
            
            redout_319673 = redout_tmp_319701;
        }
        defunc_2_reduce_res_319604 = redout_319673;
        ((double *) mem_319159.mem)[gtid_319558] = defunc_2_reduce_res_319604;
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_337946_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_337946_end -
                 futhark_mc_segmap_parloop_337946_start;
        
        ctx->futhark_mc_segmap_parloop_337946_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_337946_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_337946_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_337944(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_319557 = tid;
    int num_tasks_319633 = info.nsubtasks;
    struct futhark_mc_task_337943 *futhark_mc_task_337943 =
                                  (struct futhark_mc_task_337943 *) args;
    struct futhark_context *ctx = futhark_mc_task_337943->ctx;
    uint64_t futhark_mc_segmap_task_337944_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_337944_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_337943->free_n_p_292677;
    int64_t q_s_292678 = futhark_mc_task_337943->free_q_s_292678;
    int64_t jump_s_292684 = futhark_mc_task_337943->free_jump_s_292684;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_337943->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_task_337943->free_pad_css_len_292821;
    int64_t s_n_m_292825 = futhark_mc_task_337943->free_s_n_m_292825;
    int64_t gtid_298629 = futhark_mc_task_337943->free_gtid_298629;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_task_337943->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_task_337943->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_task_337943->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_task_337943->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_task_337943->free_mem_313371,
                                  .size =0, .references =NULL};
    int64_t gtid_319157 = futhark_mc_task_337943->free_gtid_319157;
    int64_t x_319158 = futhark_mc_task_337943->free_x_319158;
    struct memblock mem_319159 = {.desc ="mem_319159", .mem =
                                  futhark_mc_task_337943->free_mem_319159,
                                  .size =0, .references =NULL};
    int64_t iter_319634;
    struct futhark_mc_segmap_parloop_struct_337945
    futhark_mc_segmap_parloop_struct_337945;
    
    futhark_mc_segmap_parloop_struct_337945.ctx = ctx;
    futhark_mc_segmap_parloop_struct_337945.free_n_p_292677 = n_p_292677;
    futhark_mc_segmap_parloop_struct_337945.free_q_s_292678 = q_s_292678;
    futhark_mc_segmap_parloop_struct_337945.free_jump_s_292684 = jump_s_292684;
    futhark_mc_segmap_parloop_struct_337945.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segmap_parloop_struct_337945.free_pad_css_len_292821 =
        pad_css_len_292821;
    futhark_mc_segmap_parloop_struct_337945.free_s_n_m_292825 = s_n_m_292825;
    futhark_mc_segmap_parloop_struct_337945.free_gtid_298629 = gtid_298629;
    futhark_mc_segmap_parloop_struct_337945.free_mem_312838 = mem_312838.mem;
    futhark_mc_segmap_parloop_struct_337945.free_mem_313018 = mem_313018.mem;
    futhark_mc_segmap_parloop_struct_337945.free_mem_313023 = mem_313023.mem;
    futhark_mc_segmap_parloop_struct_337945.free_mem_313366 = mem_313366.mem;
    futhark_mc_segmap_parloop_struct_337945.free_mem_313371 = mem_313371.mem;
    futhark_mc_segmap_parloop_struct_337945.free_gtid_319157 = gtid_319157;
    futhark_mc_segmap_parloop_struct_337945.free_x_319158 = x_319158;
    futhark_mc_segmap_parloop_struct_337945.free_mem_319159 = mem_319159.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_337946_task;
    
    futhark_mc_segmap_parloop_337946_task.name =
        "futhark_mc_segmap_parloop_337946";
    futhark_mc_segmap_parloop_337946_task.fn = futhark_mc_segmap_parloop_337946;
    futhark_mc_segmap_parloop_337946_task.args =
        &futhark_mc_segmap_parloop_struct_337945;
    futhark_mc_segmap_parloop_337946_task.iterations = iterations;
    futhark_mc_segmap_parloop_337946_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_337946_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_337946_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_337946_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_337946_task);
    
    if (futhark_mc_segmap_parloop_337946_err != 0) {
        err = futhark_mc_segmap_parloop_337946_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_337946_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_337946_total_end -
                 futhark_mc_segmap_parloop_337946_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337946_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337946_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337946_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_337944_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_337944_end -
                 futhark_mc_segmap_task_337944_start;
        
        ctx->futhark_mc_segmap_task_337944_runs[tid]++;
        ctx->futhark_mc_segmap_task_337944_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_337944_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_segmap_parloop_struct_337948 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_q_s_292678;
    int64_t free_jump_s_292684;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    int64_t free_gtid_298629;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_313018;
    unsigned char *free_mem_313023;
    unsigned char *free_mem_313366;
    unsigned char *free_mem_313371;
    int64_t free_gtid_319157;
    int64_t free_x_319158;
    unsigned char *free_mem_319159;
};
struct futhark_mc_task_337950 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_gtid_298629;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_313371;
    int64_t free_gtid_319157;
    int64_t free_x_319158;
    int64_t free_x_319481;
    double free_x_319482;
    int64_t free_defunc_0_m_fun_res_319484;
    double *retval_defunc_2_reduce_res_319493;
};
struct futhark_mc_segred_stage_1_parloop_struct_337953 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_gtid_298629;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_313371;
    int64_t free_gtid_319157;
    int64_t free_x_319158;
    int64_t free_x_319481;
    double free_x_319482;
    int64_t free_defunc_0_m_fun_res_319484;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_319773;
};
static int futhark_mc_segred_stage_1_parloop_337954(void *args, int64_t start,
                                                    int64_t end,
                                                    int flat_tid_319711,
                                                    int tid)
{
    int err = 0;
    struct futhark_mc_segred_stage_1_parloop_struct_337953
    *futhark_mc_segred_stage_1_parloop_struct_337953 =
    (struct futhark_mc_segred_stage_1_parloop_struct_337953 *) args;
    struct futhark_context *ctx =
                           futhark_mc_segred_stage_1_parloop_struct_337953->ctx;
    uint64_t futhark_mc_segred_stage_1_parloop_337954_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_337954_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segred_stage_1_parloop_struct_337953->free_n_p_292677;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segred_stage_1_parloop_struct_337953->free_defunc_0_f_res_292820;
    int64_t gtid_298629 =
            futhark_mc_segred_stage_1_parloop_struct_337953->free_gtid_298629;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_337953->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_337953->free_mem_313371,
                                  .size =0, .references =NULL};
    int64_t gtid_319157 =
            futhark_mc_segred_stage_1_parloop_struct_337953->free_gtid_319157;
    int64_t x_319158 =
            futhark_mc_segred_stage_1_parloop_struct_337953->free_x_319158;
    int64_t x_319481 =
            futhark_mc_segred_stage_1_parloop_struct_337953->free_x_319481;
    double x_319482 =
           futhark_mc_segred_stage_1_parloop_struct_337953->free_x_319482;
    int64_t defunc_0_m_fun_res_319484 =
            futhark_mc_segred_stage_1_parloop_struct_337953->free_defunc_0_m_fun_res_319484;
    struct memblock reduce_stage_1_tid_res_arr_mem_319773 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_319773",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_337953->free_reduce_stage_1_tid_res_arr_mem_319773,
                                                             .size =0,
                                                             .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_319775 = start;
    double x_319713;
    double x_319714;
    double local_acc_319776 = 0.0;
    
    for (; iter_319775 < end; iter_319775++) {
        int64_t gtid_319712 = iter_319775;
        bool cond_319716 = sle64(x_319158, gtid_319712);
        int64_t defunc_0_f_res_319717;
        
        if (cond_319716) {
            defunc_0_f_res_319717 = (int64_t) 0;
        } else {
            int64_t i_319718 = add64(x_319481, gtid_319712);
            int64_t defunc_0_add_arg_319719;
            
            defunc_0_add_arg_319719 = ((int64_t *) mem_312838.mem)[gtid_298629 *
                                                                   (defunc_0_f_res_292820 *
                                                                    n_p_292677) +
                                                                   gtid_319157 *
                                                                   defunc_0_f_res_292820 +
                                                                   i_319718];
            
            int64_t defunc_1_add_res_319720 = add64((int64_t) 1,
                                                    defunc_0_add_arg_319719);
            
            defunc_0_f_res_319717 = defunc_1_add_res_319720;
        }
        
        double defunc_0_f_res_319721;
        
        if (cond_319716) {
            defunc_0_f_res_319721 = 0.0;
        } else {
            int64_t i_319722 = add64(x_319481, gtid_319712);
            double defunc_0_add_arg_319723;
            
            defunc_0_add_arg_319723 = ((double *) mem_313371.mem)[gtid_298629 *
                                                                  (defunc_0_f_res_292820 *
                                                                   n_p_292677) +
                                                                  gtid_319157 *
                                                                  defunc_0_f_res_292820 +
                                                                  i_319722];
            defunc_0_f_res_319721 = defunc_0_add_arg_319723;
        }
        
        int64_t binop_p_319724 = sub64(defunc_0_f_res_319717,
                                       defunc_0_m_fun_res_319484);
        double defunc_0_f_res_319725 = sitofp_i64_f64(binop_p_319724);
        double abs_res_319726 = fabs(defunc_0_f_res_319725);
        double tmp1_319727 = abs_res_319726 / x_319482;
        double x_319728 = tmp1_319727 * tmp1_319727;
        double y_319729 = tmp1_319727 * x_319728;
        double tmp2_319730 = 1.0 - y_319729;
        double x_319731 = tmp2_319730 * tmp2_319730;
        double tmp3_319732 = tmp2_319730 * x_319731;
        double w_j_319733 = defunc_0_f_res_319721 * tmp3_319732;
        
        // save map-out results
        { }
        // Load accum params
        {
            x_319713 = local_acc_319776;
        }
        // Load next params
        {
            x_319714 = w_j_319733;
        }
        // Red body
        {
            double defunc_1_op_res_319715 = x_319713 + x_319714;
            
            local_acc_319776 = defunc_1_op_res_319715;
        }
    }
    ((double *) reduce_stage_1_tid_res_arr_mem_319773.mem)[flat_tid_319711] =
        local_acc_319776;
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_337954_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_337954_end -
                 futhark_mc_segred_stage_1_parloop_337954_start;
        
        ctx->futhark_mc_segred_stage_1_parloop_337954_runs[tid]++;
        ctx->futhark_mc_segred_stage_1_parloop_337954_total_runtime[tid] +=
            elapsed;
        ctx->futhark_mc_segred_stage_1_parloop_337954_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segred_task_337951(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_319711 = tid;
    int num_tasks_319772 = info.nsubtasks;
    struct futhark_mc_task_337950 *futhark_mc_task_337950 =
                                  (struct futhark_mc_task_337950 *) args;
    struct futhark_context *ctx = futhark_mc_task_337950->ctx;
    uint64_t futhark_mc_segred_task_337951_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_task_337951_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_337950->free_n_p_292677;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_337950->free_defunc_0_f_res_292820;
    int64_t gtid_298629 = futhark_mc_task_337950->free_gtid_298629;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_task_337950->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_task_337950->free_mem_313371,
                                  .size =0, .references =NULL};
    int64_t gtid_319157 = futhark_mc_task_337950->free_gtid_319157;
    int64_t x_319158 = futhark_mc_task_337950->free_x_319158;
    int64_t x_319481 = futhark_mc_task_337950->free_x_319481;
    double x_319482 = futhark_mc_task_337950->free_x_319482;
    int64_t defunc_0_m_fun_res_319484 =
            futhark_mc_task_337950->free_defunc_0_m_fun_res_319484;
    double defunc_2_reduce_res_319493 =
           *futhark_mc_task_337950->retval_defunc_2_reduce_res_319493;
    size_t reduce_stage_1_tid_res_arr_mem_319773_cached_sizze_337952 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_319773 = NULL;
    
    if (reduce_stage_1_tid_res_arr_mem_319773_cached_sizze_337952 <
        (size_t) ((int64_t) 8 * num_tasks_319772)) {
        reduce_stage_1_tid_res_arr_mem_319773 =
            realloc(reduce_stage_1_tid_res_arr_mem_319773, (int64_t) 8 *
                    num_tasks_319772);
        reduce_stage_1_tid_res_arr_mem_319773_cached_sizze_337952 =
            (int64_t) 8 * num_tasks_319772;
    }
    
    int64_t iter_319775;
    struct futhark_mc_segred_stage_1_parloop_struct_337953
    futhark_mc_segred_stage_1_parloop_struct_337953;
    
    futhark_mc_segred_stage_1_parloop_struct_337953.ctx = ctx;
    futhark_mc_segred_stage_1_parloop_struct_337953.free_n_p_292677 =
        n_p_292677;
    futhark_mc_segred_stage_1_parloop_struct_337953.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segred_stage_1_parloop_struct_337953.free_gtid_298629 =
        gtid_298629;
    futhark_mc_segred_stage_1_parloop_struct_337953.free_mem_312838 =
        mem_312838.mem;
    futhark_mc_segred_stage_1_parloop_struct_337953.free_mem_313371 =
        mem_313371.mem;
    futhark_mc_segred_stage_1_parloop_struct_337953.free_gtid_319157 =
        gtid_319157;
    futhark_mc_segred_stage_1_parloop_struct_337953.free_x_319158 = x_319158;
    futhark_mc_segred_stage_1_parloop_struct_337953.free_x_319481 = x_319481;
    futhark_mc_segred_stage_1_parloop_struct_337953.free_x_319482 = x_319482;
    futhark_mc_segred_stage_1_parloop_struct_337953.free_defunc_0_m_fun_res_319484 =
        defunc_0_m_fun_res_319484;
    futhark_mc_segred_stage_1_parloop_struct_337953.free_reduce_stage_1_tid_res_arr_mem_319773 =
        reduce_stage_1_tid_res_arr_mem_319773;
    
    struct scheduler_parloop futhark_mc_segred_stage_1_parloop_337954_task;
    
    futhark_mc_segred_stage_1_parloop_337954_task.name =
        "futhark_mc_segred_stage_1_parloop_337954";
    futhark_mc_segred_stage_1_parloop_337954_task.fn =
        futhark_mc_segred_stage_1_parloop_337954;
    futhark_mc_segred_stage_1_parloop_337954_task.args =
        &futhark_mc_segred_stage_1_parloop_struct_337953;
    futhark_mc_segred_stage_1_parloop_337954_task.iterations = iterations;
    futhark_mc_segred_stage_1_parloop_337954_task.info = info;
    
    uint64_t futhark_mc_segred_stage_1_parloop_337954_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_337954_total_start = get_wall_time();
    
    int futhark_mc_segred_stage_1_parloop_337954_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segred_stage_1_parloop_337954_task);
    
    if (futhark_mc_segred_stage_1_parloop_337954_err != 0) {
        err = futhark_mc_segred_stage_1_parloop_337954_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_337954_total_end =
                 get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_337954_total_end -
                 futhark_mc_segred_stage_1_parloop_337954_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_337954_total_runs,
                           1, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_337954_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_337954_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    // neutral-initialise the output
    {
        defunc_2_reduce_res_319493 = 0.0;
    }
    
    double x_319777;
    double x_319778;
    
    for (int32_t i_319780 = 0; i_319780 < num_tasks_319772; i_319780++) {
        flat_tid_319711 = i_319780;
        // Apply main thread reduction
        {
            // load acc params
            {
                x_319777 = defunc_2_reduce_res_319493;
            }
            // load next params
            {
                x_319778 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_319773)[flat_tid_319711];
            }
            // red body
            {
                double defunc_1_op_res_319779 = x_319777 + x_319778;
                
                defunc_2_reduce_res_319493 = defunc_1_op_res_319779;
            }
        }
    }
    
  cleanup:
    {
        free(reduce_stage_1_tid_res_arr_mem_319773);
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_task_337951_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_task_337951_end -
                 futhark_mc_segred_task_337951_start;
        
        ctx->futhark_mc_segred_task_337951_runs[tid]++;
        ctx->futhark_mc_segred_task_337951_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segred_task_337951_iter[tid] += iterations;
    }
    if (err == 0) {
        *futhark_mc_task_337950->retval_defunc_2_reduce_res_319493 =
            defunc_2_reduce_res_319493;
    }
    return err;
}
struct futhark_mc_task_337955 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_gtid_298629;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_313366;
    unsigned char *free_mem_313371;
    int64_t free_gtid_319157;
    int64_t free_x_319158;
    int64_t free_x_319481;
    double free_x_319482;
    double free_a0_319518;
    int64_t free_defunc_0_m_fun_res_319519;
    double *retval_defunc_2_reduce_res_319528;
};
struct futhark_mc_segred_stage_1_parloop_struct_337958 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_gtid_298629;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_313366;
    unsigned char *free_mem_313371;
    int64_t free_gtid_319157;
    int64_t free_x_319158;
    int64_t free_x_319481;
    double free_x_319482;
    double free_a0_319518;
    int64_t free_defunc_0_m_fun_res_319519;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_319782;
};
static int futhark_mc_segred_stage_1_parloop_337959(void *args, int64_t start,
                                                    int64_t end,
                                                    int flat_tid_319742,
                                                    int tid)
{
    int err = 0;
    struct futhark_mc_segred_stage_1_parloop_struct_337958
    *futhark_mc_segred_stage_1_parloop_struct_337958 =
    (struct futhark_mc_segred_stage_1_parloop_struct_337958 *) args;
    struct futhark_context *ctx =
                           futhark_mc_segred_stage_1_parloop_struct_337958->ctx;
    uint64_t futhark_mc_segred_stage_1_parloop_337959_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_337959_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segred_stage_1_parloop_struct_337958->free_n_p_292677;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segred_stage_1_parloop_struct_337958->free_defunc_0_f_res_292820;
    int64_t gtid_298629 =
            futhark_mc_segred_stage_1_parloop_struct_337958->free_gtid_298629;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_337958->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_337958->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_337958->free_mem_313371,
                                  .size =0, .references =NULL};
    int64_t gtid_319157 =
            futhark_mc_segred_stage_1_parloop_struct_337958->free_gtid_319157;
    int64_t x_319158 =
            futhark_mc_segred_stage_1_parloop_struct_337958->free_x_319158;
    int64_t x_319481 =
            futhark_mc_segred_stage_1_parloop_struct_337958->free_x_319481;
    double x_319482 =
           futhark_mc_segred_stage_1_parloop_struct_337958->free_x_319482;
    double a0_319518 =
           futhark_mc_segred_stage_1_parloop_struct_337958->free_a0_319518;
    int64_t defunc_0_m_fun_res_319519 =
            futhark_mc_segred_stage_1_parloop_struct_337958->free_defunc_0_m_fun_res_319519;
    struct memblock reduce_stage_1_tid_res_arr_mem_319782 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_319782",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_337958->free_reduce_stage_1_tid_res_arr_mem_319782,
                                                             .size =0,
                                                             .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_319784 = start;
    double x_319744;
    double x_319745;
    double local_acc_319785 = 0.0;
    
    for (; iter_319784 < end; iter_319784++) {
        int64_t gtid_319743 = iter_319784;
        bool cond_319747 = sle64(x_319158, gtid_319743);
        int64_t defunc_0_f_res_319748;
        
        if (cond_319747) {
            defunc_0_f_res_319748 = (int64_t) 0;
        } else {
            int64_t i_319749 = add64(x_319481, gtid_319743);
            int64_t defunc_0_add_arg_319750;
            
            defunc_0_add_arg_319750 = ((int64_t *) mem_312838.mem)[gtid_298629 *
                                                                   (defunc_0_f_res_292820 *
                                                                    n_p_292677) +
                                                                   gtid_319157 *
                                                                   defunc_0_f_res_292820 +
                                                                   i_319749];
            
            int64_t defunc_1_add_res_319751 = add64((int64_t) 1,
                                                    defunc_0_add_arg_319750);
            
            defunc_0_f_res_319748 = defunc_1_add_res_319751;
        }
        
        double defunc_0_f_res_319752;
        
        if (cond_319747) {
            defunc_0_f_res_319752 = 0.0;
        } else {
            int64_t i_319753 = add64(x_319481, gtid_319743);
            double defunc_0_add_arg_319754;
            
            defunc_0_add_arg_319754 = ((double *) mem_313371.mem)[gtid_298629 *
                                                                  (defunc_0_f_res_292820 *
                                                                   n_p_292677) +
                                                                  gtid_319157 *
                                                                  defunc_0_f_res_292820 +
                                                                  i_319753];
            defunc_0_f_res_319752 = defunc_0_add_arg_319754;
        }
        
        int64_t binop_p_319755 = sub64(defunc_0_f_res_319748,
                                       defunc_0_m_fun_res_319519);
        double defunc_0_f_res_319756 = sitofp_i64_f64(binop_p_319755);
        double abs_res_319757 = fabs(defunc_0_f_res_319756);
        double tmp1_319758 = abs_res_319757 / x_319482;
        double x_319759 = tmp1_319758 * tmp1_319758;
        double y_319760 = tmp1_319758 * x_319759;
        double tmp2_319761 = 1.0 - y_319760;
        double x_319762 = tmp2_319761 * tmp2_319761;
        double tmp3_319763 = tmp2_319761 * x_319762;
        double tmp4_319764 = defunc_0_f_res_319752 * tmp3_319763;
        double defunc_0_f_res_319765;
        
        if (cond_319747) {
            defunc_0_f_res_319765 = 0.0;
        } else {
            int64_t i_319766 = add64(x_319481, gtid_319743);
            double defunc_0_add_arg_319767;
            
            defunc_0_add_arg_319767 = ((double *) mem_313366.mem)[gtid_298629 *
                                                                  (defunc_0_f_res_292820 *
                                                                   n_p_292677) +
                                                                  gtid_319157 *
                                                                  defunc_0_f_res_292820 +
                                                                  i_319766];
            defunc_0_f_res_319765 = defunc_0_add_arg_319767;
        }
        
        double x_319768 = a0_319518 * tmp4_319764;
        double defunc_9_fit_fun_res_319769 = defunc_0_f_res_319765 * x_319768;
        
        // save map-out results
        { }
        // Load accum params
        {
            x_319744 = local_acc_319785;
        }
        // Load next params
        {
            x_319745 = defunc_9_fit_fun_res_319769;
        }
        // Red body
        {
            double defunc_1_op_res_319746 = x_319744 + x_319745;
            
            local_acc_319785 = defunc_1_op_res_319746;
        }
    }
    ((double *) reduce_stage_1_tid_res_arr_mem_319782.mem)[flat_tid_319742] =
        local_acc_319785;
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_337959_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_337959_end -
                 futhark_mc_segred_stage_1_parloop_337959_start;
        
        ctx->futhark_mc_segred_stage_1_parloop_337959_runs[tid]++;
        ctx->futhark_mc_segred_stage_1_parloop_337959_total_runtime[tid] +=
            elapsed;
        ctx->futhark_mc_segred_stage_1_parloop_337959_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segred_task_337956(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_319742 = tid;
    int num_tasks_319781 = info.nsubtasks;
    struct futhark_mc_task_337955 *futhark_mc_task_337955 =
                                  (struct futhark_mc_task_337955 *) args;
    struct futhark_context *ctx = futhark_mc_task_337955->ctx;
    uint64_t futhark_mc_segred_task_337956_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_task_337956_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_337955->free_n_p_292677;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_337955->free_defunc_0_f_res_292820;
    int64_t gtid_298629 = futhark_mc_task_337955->free_gtid_298629;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_task_337955->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_task_337955->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_task_337955->free_mem_313371,
                                  .size =0, .references =NULL};
    int64_t gtid_319157 = futhark_mc_task_337955->free_gtid_319157;
    int64_t x_319158 = futhark_mc_task_337955->free_x_319158;
    int64_t x_319481 = futhark_mc_task_337955->free_x_319481;
    double x_319482 = futhark_mc_task_337955->free_x_319482;
    double a0_319518 = futhark_mc_task_337955->free_a0_319518;
    int64_t defunc_0_m_fun_res_319519 =
            futhark_mc_task_337955->free_defunc_0_m_fun_res_319519;
    double defunc_2_reduce_res_319528 =
           *futhark_mc_task_337955->retval_defunc_2_reduce_res_319528;
    size_t reduce_stage_1_tid_res_arr_mem_319782_cached_sizze_337957 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_319782 = NULL;
    
    if (reduce_stage_1_tid_res_arr_mem_319782_cached_sizze_337957 <
        (size_t) ((int64_t) 8 * num_tasks_319781)) {
        reduce_stage_1_tid_res_arr_mem_319782 =
            realloc(reduce_stage_1_tid_res_arr_mem_319782, (int64_t) 8 *
                    num_tasks_319781);
        reduce_stage_1_tid_res_arr_mem_319782_cached_sizze_337957 =
            (int64_t) 8 * num_tasks_319781;
    }
    
    int64_t iter_319784;
    struct futhark_mc_segred_stage_1_parloop_struct_337958
    futhark_mc_segred_stage_1_parloop_struct_337958;
    
    futhark_mc_segred_stage_1_parloop_struct_337958.ctx = ctx;
    futhark_mc_segred_stage_1_parloop_struct_337958.free_n_p_292677 =
        n_p_292677;
    futhark_mc_segred_stage_1_parloop_struct_337958.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segred_stage_1_parloop_struct_337958.free_gtid_298629 =
        gtid_298629;
    futhark_mc_segred_stage_1_parloop_struct_337958.free_mem_312838 =
        mem_312838.mem;
    futhark_mc_segred_stage_1_parloop_struct_337958.free_mem_313366 =
        mem_313366.mem;
    futhark_mc_segred_stage_1_parloop_struct_337958.free_mem_313371 =
        mem_313371.mem;
    futhark_mc_segred_stage_1_parloop_struct_337958.free_gtid_319157 =
        gtid_319157;
    futhark_mc_segred_stage_1_parloop_struct_337958.free_x_319158 = x_319158;
    futhark_mc_segred_stage_1_parloop_struct_337958.free_x_319481 = x_319481;
    futhark_mc_segred_stage_1_parloop_struct_337958.free_x_319482 = x_319482;
    futhark_mc_segred_stage_1_parloop_struct_337958.free_a0_319518 = a0_319518;
    futhark_mc_segred_stage_1_parloop_struct_337958.free_defunc_0_m_fun_res_319519 =
        defunc_0_m_fun_res_319519;
    futhark_mc_segred_stage_1_parloop_struct_337958.free_reduce_stage_1_tid_res_arr_mem_319782 =
        reduce_stage_1_tid_res_arr_mem_319782;
    
    struct scheduler_parloop futhark_mc_segred_stage_1_parloop_337959_task;
    
    futhark_mc_segred_stage_1_parloop_337959_task.name =
        "futhark_mc_segred_stage_1_parloop_337959";
    futhark_mc_segred_stage_1_parloop_337959_task.fn =
        futhark_mc_segred_stage_1_parloop_337959;
    futhark_mc_segred_stage_1_parloop_337959_task.args =
        &futhark_mc_segred_stage_1_parloop_struct_337958;
    futhark_mc_segred_stage_1_parloop_337959_task.iterations = iterations;
    futhark_mc_segred_stage_1_parloop_337959_task.info = info;
    
    uint64_t futhark_mc_segred_stage_1_parloop_337959_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_337959_total_start = get_wall_time();
    
    int futhark_mc_segred_stage_1_parloop_337959_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segred_stage_1_parloop_337959_task);
    
    if (futhark_mc_segred_stage_1_parloop_337959_err != 0) {
        err = futhark_mc_segred_stage_1_parloop_337959_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_337959_total_end =
                 get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_337959_total_end -
                 futhark_mc_segred_stage_1_parloop_337959_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_337959_total_runs,
                           1, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_337959_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_337959_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    // neutral-initialise the output
    {
        defunc_2_reduce_res_319528 = 0.0;
    }
    
    double x_319786;
    double x_319787;
    
    for (int32_t i_319789 = 0; i_319789 < num_tasks_319781; i_319789++) {
        flat_tid_319742 = i_319789;
        // Apply main thread reduction
        {
            // load acc params
            {
                x_319786 = defunc_2_reduce_res_319528;
            }
            // load next params
            {
                x_319787 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_319782)[flat_tid_319742];
            }
            // red body
            {
                double defunc_1_op_res_319788 = x_319786 + x_319787;
                
                defunc_2_reduce_res_319528 = defunc_1_op_res_319788;
            }
        }
    }
    
  cleanup:
    {
        free(reduce_stage_1_tid_res_arr_mem_319782);
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_task_337956_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_task_337956_end -
                 futhark_mc_segred_task_337956_start;
        
        ctx->futhark_mc_segred_task_337956_runs[tid]++;
        ctx->futhark_mc_segred_task_337956_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segred_task_337956_iter[tid] += iterations;
    }
    if (err == 0) {
        *futhark_mc_task_337955->retval_defunc_2_reduce_res_319528 =
            defunc_2_reduce_res_319528;
    }
    return err;
}
static int futhark_mc_segmap_parloop_337949(void *args, int64_t start,
                                            int64_t end, int flat_tid_319479,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_337948
    *futhark_mc_segmap_parloop_struct_337948 =
    (struct futhark_mc_segmap_parloop_struct_337948 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_337948->ctx;
    uint64_t futhark_mc_segmap_parloop_337949_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_337949_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segmap_parloop_struct_337948->free_n_p_292677;
    int64_t q_s_292678 =
            futhark_mc_segmap_parloop_struct_337948->free_q_s_292678;
    int64_t jump_s_292684 =
            futhark_mc_segmap_parloop_struct_337948->free_jump_s_292684;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segmap_parloop_struct_337948->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_segmap_parloop_struct_337948->free_pad_css_len_292821;
    int64_t s_n_m_292825 =
            futhark_mc_segmap_parloop_struct_337948->free_s_n_m_292825;
    int64_t gtid_298629 =
            futhark_mc_segmap_parloop_struct_337948->free_gtid_298629;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_segmap_parloop_struct_337948->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_segmap_parloop_struct_337948->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_segmap_parloop_struct_337948->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_segmap_parloop_struct_337948->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_segmap_parloop_struct_337948->free_mem_313371,
                                  .size =0, .references =NULL};
    int64_t gtid_319157 =
            futhark_mc_segmap_parloop_struct_337948->free_gtid_319157;
    int64_t x_319158 = futhark_mc_segmap_parloop_struct_337948->free_x_319158;
    struct memblock mem_319159 = {.desc ="mem_319159", .mem =
                                  futhark_mc_segmap_parloop_struct_337948->free_mem_319159,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_319702 = start;
    
    for (; iter_319702 < end; iter_319702++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_319770 = s_n_m_292825;
        int64_t gtid_319480 = iter_319702;
        int64_t remnant_319771 = iter_319702 - gtid_319480;
        int64_t x_319481;
        
        x_319481 = ((int64_t *) mem_313018.mem)[gtid_298629 * (s_n_m_292825 *
                                                               n_p_292677) +
                                                gtid_319157 * s_n_m_292825 +
                                                gtid_319480];
        
        double x_319482;
        
        x_319482 = ((double *) mem_313023.mem)[gtid_298629 * (s_n_m_292825 *
                                                              n_p_292677) +
                                               gtid_319157 * s_n_m_292825 +
                                               gtid_319480];
        
        bool cond_319483 = gtid_319480 == (int64_t) 0;
        int64_t defunc_0_m_fun_res_319484;
        
        if (cond_319483) {
            defunc_0_m_fun_res_319484 = (int64_t) 0;
        } else {
            int64_t y_319703 = sub64(s_n_m_292825, (int64_t) 1);
            bool cond_319704 = gtid_319480 == y_319703;
            int64_t defunc_0_m_fun_res_f_res_319705;
            
            if (cond_319704) {
                int64_t defunc_0_m_fun_res_f_res_t_res_319706 =
                        sub64(pad_css_len_292821, (int64_t) 1);
                
                defunc_0_m_fun_res_f_res_319705 =
                    defunc_0_m_fun_res_f_res_t_res_319706;
            } else {
                int64_t x_319707 = sub64(gtid_319480, (int64_t) 1);
                int64_t x_319708 = mul64(jump_s_292684, x_319707);
                int64_t min_arg_319709 = add64((int64_t) 1, x_319708);
                int64_t min_res_319710 = smin64(defunc_0_f_res_292820,
                                                min_arg_319709);
                
                defunc_0_m_fun_res_f_res_319705 = min_res_319710;
            }
            defunc_0_m_fun_res_319484 = defunc_0_m_fun_res_f_res_319705;
        }
        
        double defunc_2_reduce_res_319493;
        int64_t flat_tid_319711 = (int64_t) 0;
        int32_t num_tasks_319772;
        
        defunc_2_reduce_res_319493 = 0.0;
        
        struct futhark_mc_task_337950 futhark_mc_task_337950;
        
        futhark_mc_task_337950.ctx = ctx;
        futhark_mc_task_337950.free_n_p_292677 = n_p_292677;
        futhark_mc_task_337950.free_defunc_0_f_res_292820 =
            defunc_0_f_res_292820;
        futhark_mc_task_337950.free_gtid_298629 = gtid_298629;
        futhark_mc_task_337950.free_mem_312838 = mem_312838.mem;
        futhark_mc_task_337950.free_mem_313371 = mem_313371.mem;
        futhark_mc_task_337950.free_gtid_319157 = gtid_319157;
        futhark_mc_task_337950.free_x_319158 = x_319158;
        futhark_mc_task_337950.free_x_319481 = x_319481;
        futhark_mc_task_337950.free_x_319482 = x_319482;
        futhark_mc_task_337950.free_defunc_0_m_fun_res_319484 =
            defunc_0_m_fun_res_319484;
        futhark_mc_task_337950.retval_defunc_2_reduce_res_319493 =
            &defunc_2_reduce_res_319493;
        
        struct scheduler_segop futhark_mc_task_337950_task;
        
        futhark_mc_task_337950_task.args = &futhark_mc_task_337950;
        futhark_mc_task_337950_task.top_level_fn =
            futhark_mc_segred_task_337951;
        futhark_mc_task_337950_task.name = "futhark_mc_segred_task_337951";
        futhark_mc_task_337950_task.iterations = q_s_292678;
        futhark_mc_task_337950_task.task_time =
            &ctx->futhark_mc_segred_task_337951_total_time;
        futhark_mc_task_337950_task.task_iter =
            &ctx->futhark_mc_segred_task_337951_total_iter;
        futhark_mc_task_337950_task.sched = STATIC;
        futhark_mc_task_337950_task.nested_fn = NULL;
        
        int futhark_mc_segred_task_337951_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_337950_task);
        
        if (futhark_mc_segred_task_337951_err != 0) {
            ;
            err = futhark_mc_segred_task_337951_err;
            goto cleanup;
        }
        
        double a_319517 = 2.220446049250313e-16 + defunc_2_reduce_res_319493;
        double a0_319518 = 1.0 / a_319517;
        int64_t defunc_0_m_fun_res_319519;
        
        if (cond_319483) {
            defunc_0_m_fun_res_319519 = (int64_t) 0;
        } else {
            int64_t y_319734 = sub64(s_n_m_292825, (int64_t) 1);
            bool cond_319735 = gtid_319480 == y_319734;
            int64_t defunc_0_m_fun_res_f_res_319736;
            
            if (cond_319735) {
                int64_t defunc_0_m_fun_res_f_res_t_res_319737 =
                        sub64(pad_css_len_292821, (int64_t) 1);
                
                defunc_0_m_fun_res_f_res_319736 =
                    defunc_0_m_fun_res_f_res_t_res_319737;
            } else {
                int64_t x_319738 = sub64(gtid_319480, (int64_t) 1);
                int64_t x_319739 = mul64(jump_s_292684, x_319738);
                int64_t min_arg_319740 = add64((int64_t) 1, x_319739);
                int64_t min_res_319741 = smin64(defunc_0_f_res_292820,
                                                min_arg_319740);
                
                defunc_0_m_fun_res_f_res_319736 = min_res_319741;
            }
            defunc_0_m_fun_res_319519 = defunc_0_m_fun_res_f_res_319736;
        }
        
        double defunc_2_reduce_res_319528;
        int64_t flat_tid_319742 = (int64_t) 0;
        int32_t num_tasks_319781;
        
        defunc_2_reduce_res_319528 = 0.0;
        
        struct futhark_mc_task_337955 futhark_mc_task_337955;
        
        futhark_mc_task_337955.ctx = ctx;
        futhark_mc_task_337955.free_n_p_292677 = n_p_292677;
        futhark_mc_task_337955.free_defunc_0_f_res_292820 =
            defunc_0_f_res_292820;
        futhark_mc_task_337955.free_gtid_298629 = gtid_298629;
        futhark_mc_task_337955.free_mem_312838 = mem_312838.mem;
        futhark_mc_task_337955.free_mem_313366 = mem_313366.mem;
        futhark_mc_task_337955.free_mem_313371 = mem_313371.mem;
        futhark_mc_task_337955.free_gtid_319157 = gtid_319157;
        futhark_mc_task_337955.free_x_319158 = x_319158;
        futhark_mc_task_337955.free_x_319481 = x_319481;
        futhark_mc_task_337955.free_x_319482 = x_319482;
        futhark_mc_task_337955.free_a0_319518 = a0_319518;
        futhark_mc_task_337955.free_defunc_0_m_fun_res_319519 =
            defunc_0_m_fun_res_319519;
        futhark_mc_task_337955.retval_defunc_2_reduce_res_319528 =
            &defunc_2_reduce_res_319528;
        
        struct scheduler_segop futhark_mc_task_337955_task;
        
        futhark_mc_task_337955_task.args = &futhark_mc_task_337955;
        futhark_mc_task_337955_task.top_level_fn =
            futhark_mc_segred_task_337956;
        futhark_mc_task_337955_task.name = "futhark_mc_segred_task_337956";
        futhark_mc_task_337955_task.iterations = q_s_292678;
        futhark_mc_task_337955_task.task_time =
            &ctx->futhark_mc_segred_task_337956_total_time;
        futhark_mc_task_337955_task.task_iter =
            &ctx->futhark_mc_segred_task_337956_total_iter;
        futhark_mc_task_337955_task.sched = STATIC;
        futhark_mc_task_337955_task.nested_fn = NULL;
        
        int futhark_mc_segred_task_337956_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_337955_task);
        
        if (futhark_mc_segred_task_337956_err != 0) {
            ;
            err = futhark_mc_segred_task_337956_err;
            goto cleanup;
        }
        ((double *) mem_319159.mem)[gtid_319480] = defunc_2_reduce_res_319528;
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_337949_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_337949_end -
                 futhark_mc_segmap_parloop_337949_start;
        
        ctx->futhark_mc_segmap_parloop_337949_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_337949_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_337949_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_nested_task_337947(void *args, int64_t iterations,
                                         int tid, struct scheduler_info info)
{
    int err = 0;
    int flat_tid_319479 = tid;
    int num_tasks_319633 = info.nsubtasks;
    struct futhark_mc_task_337943 *futhark_mc_task_337943 =
                                  (struct futhark_mc_task_337943 *) args;
    struct futhark_context *ctx = futhark_mc_task_337943->ctx;
    uint64_t futhark_mc_segmap_nested_task_337947_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_nested_task_337947_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_337943->free_n_p_292677;
    int64_t q_s_292678 = futhark_mc_task_337943->free_q_s_292678;
    int64_t jump_s_292684 = futhark_mc_task_337943->free_jump_s_292684;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_337943->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_task_337943->free_pad_css_len_292821;
    int64_t s_n_m_292825 = futhark_mc_task_337943->free_s_n_m_292825;
    int64_t gtid_298629 = futhark_mc_task_337943->free_gtid_298629;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_task_337943->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_task_337943->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_task_337943->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_task_337943->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_task_337943->free_mem_313371,
                                  .size =0, .references =NULL};
    int64_t gtid_319157 = futhark_mc_task_337943->free_gtid_319157;
    int64_t x_319158 = futhark_mc_task_337943->free_x_319158;
    struct memblock mem_319159 = {.desc ="mem_319159", .mem =
                                  futhark_mc_task_337943->free_mem_319159,
                                  .size =0, .references =NULL};
    int64_t iter_319702;
    struct futhark_mc_segmap_parloop_struct_337948
    futhark_mc_segmap_parloop_struct_337948;
    
    futhark_mc_segmap_parloop_struct_337948.ctx = ctx;
    futhark_mc_segmap_parloop_struct_337948.free_n_p_292677 = n_p_292677;
    futhark_mc_segmap_parloop_struct_337948.free_q_s_292678 = q_s_292678;
    futhark_mc_segmap_parloop_struct_337948.free_jump_s_292684 = jump_s_292684;
    futhark_mc_segmap_parloop_struct_337948.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segmap_parloop_struct_337948.free_pad_css_len_292821 =
        pad_css_len_292821;
    futhark_mc_segmap_parloop_struct_337948.free_s_n_m_292825 = s_n_m_292825;
    futhark_mc_segmap_parloop_struct_337948.free_gtid_298629 = gtid_298629;
    futhark_mc_segmap_parloop_struct_337948.free_mem_312838 = mem_312838.mem;
    futhark_mc_segmap_parloop_struct_337948.free_mem_313018 = mem_313018.mem;
    futhark_mc_segmap_parloop_struct_337948.free_mem_313023 = mem_313023.mem;
    futhark_mc_segmap_parloop_struct_337948.free_mem_313366 = mem_313366.mem;
    futhark_mc_segmap_parloop_struct_337948.free_mem_313371 = mem_313371.mem;
    futhark_mc_segmap_parloop_struct_337948.free_gtid_319157 = gtid_319157;
    futhark_mc_segmap_parloop_struct_337948.free_x_319158 = x_319158;
    futhark_mc_segmap_parloop_struct_337948.free_mem_319159 = mem_319159.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_337949_task;
    
    futhark_mc_segmap_parloop_337949_task.name =
        "futhark_mc_segmap_parloop_337949";
    futhark_mc_segmap_parloop_337949_task.fn = futhark_mc_segmap_parloop_337949;
    futhark_mc_segmap_parloop_337949_task.args =
        &futhark_mc_segmap_parloop_struct_337948;
    futhark_mc_segmap_parloop_337949_task.iterations = iterations;
    futhark_mc_segmap_parloop_337949_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_337949_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_337949_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_337949_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_337949_task);
    
    if (futhark_mc_segmap_parloop_337949_err != 0) {
        err = futhark_mc_segmap_parloop_337949_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_337949_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_337949_total_end -
                 futhark_mc_segmap_parloop_337949_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337949_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337949_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337949_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_nested_task_337947_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_nested_task_337947_end -
                 futhark_mc_segmap_nested_task_337947_start;
        
        ctx->futhark_mc_segmap_nested_task_337947_runs[tid]++;
        ctx->futhark_mc_segmap_nested_task_337947_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_nested_task_337947_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
static int futhark_mc_segmap_parloop_337941(void *args, int64_t start,
                                            int64_t end, int flat_tid_319156,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_337940
    *futhark_mc_segmap_parloop_struct_337940 =
    (struct futhark_mc_segmap_parloop_struct_337940 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_337940->ctx;
    uint64_t futhark_mc_segmap_parloop_337941_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_337941_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segmap_parloop_struct_337940->free_n_p_292677;
    int64_t q_s_292678 =
            futhark_mc_segmap_parloop_struct_337940->free_q_s_292678;
    int64_t jump_s_292684 =
            futhark_mc_segmap_parloop_struct_337940->free_jump_s_292684;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segmap_parloop_struct_337940->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_segmap_parloop_struct_337940->free_pad_css_len_292821;
    int64_t s_n_m_292825 =
            futhark_mc_segmap_parloop_struct_337940->free_s_n_m_292825;
    int64_t gtid_298629 =
            futhark_mc_segmap_parloop_struct_337940->free_gtid_298629;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_segmap_parloop_struct_337940->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_312842 = {.desc ="mem_312842", .mem =
                                  futhark_mc_segmap_parloop_struct_337940->free_mem_312842,
                                  .size =0, .references =NULL};
    int64_t bytes_312847 =
            futhark_mc_segmap_parloop_struct_337940->free_bytes_312847;
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_segmap_parloop_struct_337940->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_segmap_parloop_struct_337940->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_segmap_parloop_struct_337940->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_segmap_parloop_struct_337940->free_mem_313371,
                                  .size =0, .references =NULL};
    struct memblock mem_313398 = {.desc ="mem_313398", .mem =
                                  futhark_mc_segmap_parloop_struct_337940->free_mem_313398,
                                  .size =0, .references =NULL};
    size_t mem_319159_cached_sizze_337942 = 0;
    unsigned char *mem_319159 = NULL;
    int64_t iterations = end - start;
    int64_t iter_319478 = start;
    
    if (mem_319159_cached_sizze_337942 < (size_t) bytes_312847) {
        mem_319159 = realloc(mem_319159, bytes_312847);
        mem_319159_cached_sizze_337942 = bytes_312847;
    }
    for (; iter_319478 < end; iter_319478++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_319631 = n_p_292677;
        int64_t gtid_319157 = iter_319478;
        int64_t remnant_319632 = iter_319478 - gtid_319157;
        int64_t x_319158;
        
        x_319158 = ((int64_t *) mem_312842.mem)[gtid_298629 * n_p_292677 +
                                                gtid_319157];
        
        int64_t flat_tid_319557 = (int64_t) 0;
        int32_t num_tasks_319633;
        int64_t flat_tid_319479 = (int64_t) 0;
        struct futhark_mc_task_337943 futhark_mc_task_337943;
        
        futhark_mc_task_337943.ctx = ctx;
        futhark_mc_task_337943.free_n_p_292677 = n_p_292677;
        futhark_mc_task_337943.free_q_s_292678 = q_s_292678;
        futhark_mc_task_337943.free_jump_s_292684 = jump_s_292684;
        futhark_mc_task_337943.free_defunc_0_f_res_292820 =
            defunc_0_f_res_292820;
        futhark_mc_task_337943.free_pad_css_len_292821 = pad_css_len_292821;
        futhark_mc_task_337943.free_s_n_m_292825 = s_n_m_292825;
        futhark_mc_task_337943.free_gtid_298629 = gtid_298629;
        futhark_mc_task_337943.free_mem_312838 = mem_312838.mem;
        futhark_mc_task_337943.free_mem_313018 = mem_313018.mem;
        futhark_mc_task_337943.free_mem_313023 = mem_313023.mem;
        futhark_mc_task_337943.free_mem_313366 = mem_313366.mem;
        futhark_mc_task_337943.free_mem_313371 = mem_313371.mem;
        futhark_mc_task_337943.free_gtid_319157 = gtid_319157;
        futhark_mc_task_337943.free_x_319158 = x_319158;
        futhark_mc_task_337943.free_mem_319159 = mem_319159;
        
        struct scheduler_segop futhark_mc_task_337943_task;
        
        futhark_mc_task_337943_task.args = &futhark_mc_task_337943;
        futhark_mc_task_337943_task.top_level_fn =
            futhark_mc_segmap_task_337944;
        futhark_mc_task_337943_task.name = "futhark_mc_segmap_task_337944";
        futhark_mc_task_337943_task.iterations = s_n_m_292825;
        futhark_mc_task_337943_task.task_time =
            &ctx->futhark_mc_segmap_task_337944_total_time;
        futhark_mc_task_337943_task.task_iter =
            &ctx->futhark_mc_segmap_task_337944_total_iter;
        futhark_mc_task_337943_task.sched = STATIC;
        futhark_mc_task_337943_task.nested_fn =
            futhark_mc_segmap_nested_task_337947;
        
        int futhark_mc_segmap_task_337944_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_337943_task);
        
        if (futhark_mc_segmap_task_337944_err != 0) {
            ;
            err = futhark_mc_segmap_task_337944_err;
            goto cleanup;
        }
        if (s_n_m_292825 * (int64_t) 8 > 0)
            memmove(mem_313398.mem + gtid_319157 * s_n_m_292825 * (int64_t) 8,
                    mem_319159 + (int64_t) 0, s_n_m_292825 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_319159);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_337941_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_337941_end -
                 futhark_mc_segmap_parloop_337941_start;
        
        ctx->futhark_mc_segmap_parloop_337941_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_337941_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_337941_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_nested_task_337939(void *args, int64_t iterations,
                                         int tid, struct scheduler_info info)
{
    int err = 0;
    int flat_tid_319156 = tid;
    int num_tasks_319396 = info.nsubtasks;
    struct futhark_mc_task_337934 *futhark_mc_task_337934 =
                                  (struct futhark_mc_task_337934 *) args;
    struct futhark_context *ctx = futhark_mc_task_337934->ctx;
    uint64_t futhark_mc_segmap_nested_task_337939_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_nested_task_337939_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_337934->free_n_p_292677;
    int64_t q_s_292678 = futhark_mc_task_337934->free_q_s_292678;
    int64_t jump_s_292684 = futhark_mc_task_337934->free_jump_s_292684;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_337934->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_task_337934->free_pad_css_len_292821;
    int64_t s_n_m_292825 = futhark_mc_task_337934->free_s_n_m_292825;
    int64_t gtid_298629 = futhark_mc_task_337934->free_gtid_298629;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_task_337934->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_312842 = {.desc ="mem_312842", .mem =
                                  futhark_mc_task_337934->free_mem_312842,
                                  .size =0, .references =NULL};
    int64_t bytes_312847 = futhark_mc_task_337934->free_bytes_312847;
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_task_337934->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_task_337934->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_task_337934->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_task_337934->free_mem_313371,
                                  .size =0, .references =NULL};
    struct memblock mem_313398 = {.desc ="mem_313398", .mem =
                                  futhark_mc_task_337934->free_mem_313398,
                                  .size =0, .references =NULL};
    int64_t iter_319478;
    struct futhark_mc_segmap_parloop_struct_337940
    futhark_mc_segmap_parloop_struct_337940;
    
    futhark_mc_segmap_parloop_struct_337940.ctx = ctx;
    futhark_mc_segmap_parloop_struct_337940.free_n_p_292677 = n_p_292677;
    futhark_mc_segmap_parloop_struct_337940.free_q_s_292678 = q_s_292678;
    futhark_mc_segmap_parloop_struct_337940.free_jump_s_292684 = jump_s_292684;
    futhark_mc_segmap_parloop_struct_337940.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segmap_parloop_struct_337940.free_pad_css_len_292821 =
        pad_css_len_292821;
    futhark_mc_segmap_parloop_struct_337940.free_s_n_m_292825 = s_n_m_292825;
    futhark_mc_segmap_parloop_struct_337940.free_gtid_298629 = gtid_298629;
    futhark_mc_segmap_parloop_struct_337940.free_mem_312838 = mem_312838.mem;
    futhark_mc_segmap_parloop_struct_337940.free_mem_312842 = mem_312842.mem;
    futhark_mc_segmap_parloop_struct_337940.free_bytes_312847 = bytes_312847;
    futhark_mc_segmap_parloop_struct_337940.free_mem_313018 = mem_313018.mem;
    futhark_mc_segmap_parloop_struct_337940.free_mem_313023 = mem_313023.mem;
    futhark_mc_segmap_parloop_struct_337940.free_mem_313366 = mem_313366.mem;
    futhark_mc_segmap_parloop_struct_337940.free_mem_313371 = mem_313371.mem;
    futhark_mc_segmap_parloop_struct_337940.free_mem_313398 = mem_313398.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_337941_task;
    
    futhark_mc_segmap_parloop_337941_task.name =
        "futhark_mc_segmap_parloop_337941";
    futhark_mc_segmap_parloop_337941_task.fn = futhark_mc_segmap_parloop_337941;
    futhark_mc_segmap_parloop_337941_task.args =
        &futhark_mc_segmap_parloop_struct_337940;
    futhark_mc_segmap_parloop_337941_task.iterations = iterations;
    futhark_mc_segmap_parloop_337941_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_337941_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_337941_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_337941_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_337941_task);
    
    if (futhark_mc_segmap_parloop_337941_err != 0) {
        err = futhark_mc_segmap_parloop_337941_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_337941_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_337941_total_end -
                 futhark_mc_segmap_parloop_337941_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337941_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337941_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337941_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_nested_task_337939_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_nested_task_337939_end -
                 futhark_mc_segmap_nested_task_337939_start;
        
        ctx->futhark_mc_segmap_nested_task_337939_runs[tid]++;
        ctx->futhark_mc_segmap_nested_task_337939_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_nested_task_337939_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
static int futhark_mc_segmap_parloop_337932(void *args, int64_t start,
                                            int64_t end, int flat_tid_298628,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_337931
    *futhark_mc_segmap_parloop_struct_337931 =
    (struct futhark_mc_segmap_parloop_struct_337931 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_337931->ctx;
    uint64_t futhark_mc_segmap_parloop_337932_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_337932_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segmap_parloop_struct_337931->free_n_p_292677;
    int64_t q_s_292678 =
            futhark_mc_segmap_parloop_struct_337931->free_q_s_292678;
    int64_t jump_s_292684 =
            futhark_mc_segmap_parloop_struct_337931->free_jump_s_292684;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_337931->free_partition_sizze_292766;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segmap_parloop_struct_337931->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_segmap_parloop_struct_337931->free_pad_css_len_292821;
    int64_t s_n_m_292825 =
            futhark_mc_segmap_parloop_struct_337931->free_s_n_m_292825;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_segmap_parloop_struct_337931->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_312842 = {.desc ="mem_312842", .mem =
                                  futhark_mc_segmap_parloop_struct_337931->free_mem_312842,
                                  .size =0, .references =NULL};
    int64_t bytes_312847 =
            futhark_mc_segmap_parloop_struct_337931->free_bytes_312847;
    int64_t bytes_312899 =
            futhark_mc_segmap_parloop_struct_337931->free_bytes_312899;
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_segmap_parloop_struct_337931->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_segmap_parloop_struct_337931->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_segmap_parloop_struct_337931->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_segmap_parloop_struct_337931->free_mem_313371,
                                  .size =0, .references =NULL};
    struct memblock mem_313450 = {.desc ="mem_313450", .mem =
                                  futhark_mc_segmap_parloop_struct_337931->free_mem_313450,
                                  .size =0, .references =NULL};
    size_t mem_313398_cached_sizze_337933 = 0;
    unsigned char *mem_313398 = NULL;
    int64_t iterations = end - start;
    int64_t iter_319155 = start;
    
    if (mem_313398_cached_sizze_337933 < (size_t) bytes_312899) {
        mem_313398 = realloc(mem_313398, bytes_312899);
        mem_313398_cached_sizze_337933 = bytes_312899;
    }
    for (; iter_319155 < end; iter_319155++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_319394 = partition_sizze_292766;
        int64_t gtid_298629 = iter_319155;
        int64_t remnant_319395 = iter_319155 - gtid_298629;
        int64_t flat_tid_319313 = (int64_t) 0;
        int32_t num_tasks_319396;
        int64_t flat_tid_319156 = (int64_t) 0;
        struct futhark_mc_task_337934 futhark_mc_task_337934;
        
        futhark_mc_task_337934.ctx = ctx;
        futhark_mc_task_337934.free_n_p_292677 = n_p_292677;
        futhark_mc_task_337934.free_q_s_292678 = q_s_292678;
        futhark_mc_task_337934.free_jump_s_292684 = jump_s_292684;
        futhark_mc_task_337934.free_defunc_0_f_res_292820 =
            defunc_0_f_res_292820;
        futhark_mc_task_337934.free_pad_css_len_292821 = pad_css_len_292821;
        futhark_mc_task_337934.free_s_n_m_292825 = s_n_m_292825;
        futhark_mc_task_337934.free_gtid_298629 = gtid_298629;
        futhark_mc_task_337934.free_mem_312838 = mem_312838.mem;
        futhark_mc_task_337934.free_mem_312842 = mem_312842.mem;
        futhark_mc_task_337934.free_bytes_312847 = bytes_312847;
        futhark_mc_task_337934.free_mem_313018 = mem_313018.mem;
        futhark_mc_task_337934.free_mem_313023 = mem_313023.mem;
        futhark_mc_task_337934.free_mem_313366 = mem_313366.mem;
        futhark_mc_task_337934.free_mem_313371 = mem_313371.mem;
        futhark_mc_task_337934.free_mem_313398 = mem_313398;
        
        struct scheduler_segop futhark_mc_task_337934_task;
        
        futhark_mc_task_337934_task.args = &futhark_mc_task_337934;
        futhark_mc_task_337934_task.top_level_fn =
            futhark_mc_segmap_task_337935;
        futhark_mc_task_337934_task.name = "futhark_mc_segmap_task_337935";
        futhark_mc_task_337934_task.iterations = n_p_292677;
        futhark_mc_task_337934_task.task_time =
            &ctx->futhark_mc_segmap_task_337935_total_time;
        futhark_mc_task_337934_task.task_iter =
            &ctx->futhark_mc_segmap_task_337935_total_iter;
        futhark_mc_task_337934_task.sched = STATIC;
        futhark_mc_task_337934_task.nested_fn =
            futhark_mc_segmap_nested_task_337939;
        
        int futhark_mc_segmap_task_337935_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_337934_task);
        
        if (futhark_mc_segmap_task_337935_err != 0) {
            ;
            err = futhark_mc_segmap_task_337935_err;
            goto cleanup;
        }
        if (n_p_292677 * s_n_m_292825 * (int64_t) 8 > 0)
            memmove(mem_313450.mem + gtid_298629 * (s_n_m_292825 * n_p_292677) *
                    (int64_t) 8, mem_313398 + (int64_t) 0, n_p_292677 *
                    s_n_m_292825 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_313398);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_337932_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_337932_end -
                 futhark_mc_segmap_parloop_337932_start;
        
        ctx->futhark_mc_segmap_parloop_337932_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_337932_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_337932_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_nested_task_337930(void *args, int64_t iterations,
                                         int tid, struct scheduler_info info)
{
    int err = 0;
    int flat_tid_298628 = tid;
    int num_tasks_319068 = info.nsubtasks;
    struct futhark_mc_task_337925 *futhark_mc_task_337925 =
                                  (struct futhark_mc_task_337925 *) args;
    struct futhark_context *ctx = futhark_mc_task_337925->ctx;
    uint64_t futhark_mc_segmap_nested_task_337930_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_nested_task_337930_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_337925->free_n_p_292677;
    int64_t q_s_292678 = futhark_mc_task_337925->free_q_s_292678;
    int64_t jump_s_292684 = futhark_mc_task_337925->free_jump_s_292684;
    int64_t partition_sizze_292766 =
            futhark_mc_task_337925->free_partition_sizze_292766;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_337925->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_task_337925->free_pad_css_len_292821;
    int64_t s_n_m_292825 = futhark_mc_task_337925->free_s_n_m_292825;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_task_337925->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_312842 = {.desc ="mem_312842", .mem =
                                  futhark_mc_task_337925->free_mem_312842,
                                  .size =0, .references =NULL};
    int64_t bytes_312847 = futhark_mc_task_337925->free_bytes_312847;
    int64_t bytes_312899 = futhark_mc_task_337925->free_bytes_312899;
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_task_337925->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_task_337925->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_task_337925->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_task_337925->free_mem_313371,
                                  .size =0, .references =NULL};
    struct memblock mem_313450 = {.desc ="mem_313450", .mem =
                                  futhark_mc_task_337925->free_mem_313450,
                                  .size =0, .references =NULL};
    int64_t iter_319155;
    struct futhark_mc_segmap_parloop_struct_337931
    futhark_mc_segmap_parloop_struct_337931;
    
    futhark_mc_segmap_parloop_struct_337931.ctx = ctx;
    futhark_mc_segmap_parloop_struct_337931.free_n_p_292677 = n_p_292677;
    futhark_mc_segmap_parloop_struct_337931.free_q_s_292678 = q_s_292678;
    futhark_mc_segmap_parloop_struct_337931.free_jump_s_292684 = jump_s_292684;
    futhark_mc_segmap_parloop_struct_337931.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_337931.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segmap_parloop_struct_337931.free_pad_css_len_292821 =
        pad_css_len_292821;
    futhark_mc_segmap_parloop_struct_337931.free_s_n_m_292825 = s_n_m_292825;
    futhark_mc_segmap_parloop_struct_337931.free_mem_312838 = mem_312838.mem;
    futhark_mc_segmap_parloop_struct_337931.free_mem_312842 = mem_312842.mem;
    futhark_mc_segmap_parloop_struct_337931.free_bytes_312847 = bytes_312847;
    futhark_mc_segmap_parloop_struct_337931.free_bytes_312899 = bytes_312899;
    futhark_mc_segmap_parloop_struct_337931.free_mem_313018 = mem_313018.mem;
    futhark_mc_segmap_parloop_struct_337931.free_mem_313023 = mem_313023.mem;
    futhark_mc_segmap_parloop_struct_337931.free_mem_313366 = mem_313366.mem;
    futhark_mc_segmap_parloop_struct_337931.free_mem_313371 = mem_313371.mem;
    futhark_mc_segmap_parloop_struct_337931.free_mem_313450 = mem_313450.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_337932_task;
    
    futhark_mc_segmap_parloop_337932_task.name =
        "futhark_mc_segmap_parloop_337932";
    futhark_mc_segmap_parloop_337932_task.fn = futhark_mc_segmap_parloop_337932;
    futhark_mc_segmap_parloop_337932_task.args =
        &futhark_mc_segmap_parloop_struct_337931;
    futhark_mc_segmap_parloop_337932_task.iterations = iterations;
    futhark_mc_segmap_parloop_337932_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_337932_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_337932_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_337932_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_337932_task);
    
    if (futhark_mc_segmap_parloop_337932_err != 0) {
        err = futhark_mc_segmap_parloop_337932_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_337932_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_337932_total_end -
                 futhark_mc_segmap_parloop_337932_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337932_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337932_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337932_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_nested_task_337930_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_nested_task_337930_end -
                 futhark_mc_segmap_nested_task_337930_start;
        
        ctx->futhark_mc_segmap_nested_task_337930_runs[tid]++;
        ctx->futhark_mc_segmap_nested_task_337930_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_nested_task_337930_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_task_337960 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_q_s_292678;
    int64_t free_jump_s_292684;
    int64_t free_partition_sizze_292766;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_312842;
    int64_t free_bytes_312847;
    int64_t free_bytes_312899;
    unsigned char *free_mem_313018;
    unsigned char *free_mem_313023;
    unsigned char *free_mem_313366;
    unsigned char *free_mem_313371;
    unsigned char *free_mem_313593;
    unsigned char *free_mem_313598;
};
struct futhark_mc_segmap_parloop_struct_337962 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_q_s_292678;
    int64_t free_jump_s_292684;
    int64_t free_partition_sizze_292766;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_312842;
    int64_t free_bytes_312899;
    unsigned char *free_mem_313018;
    unsigned char *free_mem_313023;
    unsigned char *free_mem_313366;
    unsigned char *free_mem_313371;
    unsigned char *free_mem_313593;
    unsigned char *free_mem_313598;
};
static int futhark_mc_segmap_parloop_337963(void *args, int64_t start,
                                            int64_t end, int flat_tid_298888,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_337962
    *futhark_mc_segmap_parloop_struct_337962 =
    (struct futhark_mc_segmap_parloop_struct_337962 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_337962->ctx;
    uint64_t futhark_mc_segmap_parloop_337963_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_337963_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segmap_parloop_struct_337962->free_n_p_292677;
    int64_t q_s_292678 =
            futhark_mc_segmap_parloop_struct_337962->free_q_s_292678;
    int64_t jump_s_292684 =
            futhark_mc_segmap_parloop_struct_337962->free_jump_s_292684;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_337962->free_partition_sizze_292766;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segmap_parloop_struct_337962->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_segmap_parloop_struct_337962->free_pad_css_len_292821;
    int64_t s_n_m_292825 =
            futhark_mc_segmap_parloop_struct_337962->free_s_n_m_292825;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_segmap_parloop_struct_337962->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_312842 = {.desc ="mem_312842", .mem =
                                  futhark_mc_segmap_parloop_struct_337962->free_mem_312842,
                                  .size =0, .references =NULL};
    int64_t bytes_312899 =
            futhark_mc_segmap_parloop_struct_337962->free_bytes_312899;
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_segmap_parloop_struct_337962->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_segmap_parloop_struct_337962->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_segmap_parloop_struct_337962->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_segmap_parloop_struct_337962->free_mem_313371,
                                  .size =0, .references =NULL};
    struct memblock mem_313593 = {.desc ="mem_313593", .mem =
                                  futhark_mc_segmap_parloop_struct_337962->free_mem_313593,
                                  .size =0, .references =NULL};
    struct memblock mem_313598 = {.desc ="mem_313598", .mem =
                                  futhark_mc_segmap_parloop_struct_337962->free_mem_313598,
                                  .size =0, .references =NULL};
    size_t mem_313498_cached_sizze_337964 = 0;
    unsigned char *mem_313498 = NULL;
    size_t mem_313502_cached_sizze_337965 = 0;
    unsigned char *mem_313502 = NULL;
    int64_t iterations = end - start;
    int64_t iter_319791 = start;
    
    if (mem_313498_cached_sizze_337964 < (size_t) bytes_312899) {
        mem_313498 = realloc(mem_313498, bytes_312899);
        mem_313498_cached_sizze_337964 = bytes_312899;
    }
    if (mem_313502_cached_sizze_337965 < (size_t) bytes_312899) {
        mem_313502 = realloc(mem_313502, bytes_312899);
        mem_313502_cached_sizze_337965 = bytes_312899;
    }
    for (; iter_319791 < end; iter_319791++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_319902 = partition_sizze_292766;
        int64_t gtid_298889 = iter_319791;
        int64_t remnant_319903 = iter_319791 - gtid_298889;
        
        for (int64_t i_319792 = 0; i_319792 < n_p_292677; i_319792++) {
            int64_t x_319795;
            
            x_319795 = ((int64_t *) mem_312842.mem)[gtid_298889 * n_p_292677 +
                                                    i_319792];
            for (int64_t i_319798 = 0; i_319798 < s_n_m_292825; i_319798++) {
                int64_t x_319801;
                
                x_319801 = ((int64_t *) mem_313018.mem)[gtid_298889 *
                                                        (s_n_m_292825 *
                                                         n_p_292677) +
                                                        i_319792 *
                                                        s_n_m_292825 +
                                                        i_319798];
                
                double x_319802;
                
                x_319802 = ((double *) mem_313023.mem)[gtid_298889 *
                                                       (s_n_m_292825 *
                                                        n_p_292677) + i_319792 *
                                                       s_n_m_292825 + i_319798];
                
                bool cond_319803 = i_319798 == (int64_t) 0;
                int64_t defunc_0_m_fun_res_319804;
                
                if (cond_319803) {
                    defunc_0_m_fun_res_319804 = (int64_t) 0;
                } else {
                    int64_t y_319805 = sub64(s_n_m_292825, (int64_t) 1);
                    bool cond_319806 = i_319798 == y_319805;
                    int64_t defunc_0_m_fun_res_f_res_319807;
                    
                    if (cond_319806) {
                        int64_t defunc_0_m_fun_res_f_res_t_res_319808 =
                                sub64(pad_css_len_292821, (int64_t) 1);
                        
                        defunc_0_m_fun_res_f_res_319807 =
                            defunc_0_m_fun_res_f_res_t_res_319808;
                    } else {
                        int64_t x_319809 = sub64(i_319798, (int64_t) 1);
                        int64_t x_319810 = mul64(jump_s_292684, x_319809);
                        int64_t min_arg_319811 = add64((int64_t) 1, x_319810);
                        int64_t min_res_319812 = smin64(defunc_0_f_res_292820,
                                                        min_arg_319811);
                        
                        defunc_0_m_fun_res_f_res_319807 = min_res_319812;
                    }
                    defunc_0_m_fun_res_319804 = defunc_0_m_fun_res_f_res_319807;
                }
                
                double defunc_2_reduce_res_319813;
                double defunc_2_reduce_res_319814;
                double defunc_2_reduce_res_319815;
                double redout_319817;
                double redout_319818;
                double redout_319819;
                
                redout_319817 = 0.0;
                redout_319818 = 0.0;
                redout_319819 = 0.0;
                for (int64_t i_319816 = 0; i_319816 < q_s_292678; i_319816++) {
                    bool cond_319820 = sle64(x_319795, i_319816);
                    int64_t defunc_0_f_res_319821;
                    
                    if (cond_319820) {
                        defunc_0_f_res_319821 = (int64_t) 0;
                    } else {
                        int64_t i_319822 = add64(x_319801, i_319816);
                        int64_t defunc_0_add_arg_319823;
                        
                        defunc_0_add_arg_319823 =
                            ((int64_t *) mem_312838.mem)[gtid_298889 *
                                                         (defunc_0_f_res_292820 *
                                                          n_p_292677) +
                                                         i_319792 *
                                                         defunc_0_f_res_292820 +
                                                         i_319822];
                        
                        int64_t defunc_1_add_res_319824 = add64((int64_t) 1,
                                                                defunc_0_add_arg_319823);
                        
                        defunc_0_f_res_319821 = defunc_1_add_res_319824;
                    }
                    
                    double defunc_0_f_res_319825;
                    
                    if (cond_319820) {
                        defunc_0_f_res_319825 = 0.0;
                    } else {
                        int64_t i_319826 = add64(x_319801, i_319816);
                        double defunc_0_add_arg_319827;
                        
                        defunc_0_add_arg_319827 =
                            ((double *) mem_313371.mem)[gtid_298889 *
                                                        (defunc_0_f_res_292820 *
                                                         n_p_292677) +
                                                        i_319792 *
                                                        defunc_0_f_res_292820 +
                                                        i_319826];
                        defunc_0_f_res_319825 = defunc_0_add_arg_319827;
                    }
                    
                    int64_t binop_p_319828 = sub64(defunc_0_f_res_319821,
                                                   defunc_0_m_fun_res_319804);
                    double defunc_0_f_res_319829 =
                           sitofp_i64_f64(binop_p_319828);
                    double abs_res_319830 = fabs(defunc_0_f_res_319829);
                    double tmp1_319831 = abs_res_319830 / x_319802;
                    double x_319832 = tmp1_319831 * tmp1_319831;
                    double y_319833 = tmp1_319831 * x_319832;
                    double tmp2_319834 = 1.0 - y_319833;
                    double x_319835 = tmp2_319834 * tmp2_319834;
                    double tmp3_319836 = tmp2_319834 * x_319835;
                    double w_j_319837 = defunc_0_f_res_319825 * tmp3_319836;
                    double xw_j_319838 = defunc_0_f_res_319829 * w_j_319837;
                    double x2w_j_319839 = defunc_0_f_res_319829 * xw_j_319838;
                    double defunc_1_op_res_319840 = w_j_319837 + redout_319817;
                    double defunc_1_op_res_319841 = xw_j_319838 + redout_319818;
                    double defunc_1_op_res_319842 = x2w_j_319839 +
                           redout_319819;
                    double redout_tmp_319908 = defunc_1_op_res_319840;
                    double redout_tmp_319909 = defunc_1_op_res_319841;
                    double redout_tmp_319910 = defunc_1_op_res_319842;
                    
                    redout_319817 = redout_tmp_319908;
                    redout_319818 = redout_tmp_319909;
                    redout_319819 = redout_tmp_319910;
                }
                defunc_2_reduce_res_319813 = redout_319817;
                defunc_2_reduce_res_319814 = redout_319818;
                defunc_2_reduce_res_319815 = redout_319819;
                
                double a_319843 = 2.220446049250313e-16 +
                       defunc_2_reduce_res_319813;
                double b_319844 = 2.220446049250313e-16 +
                       defunc_2_reduce_res_319814;
                double c_319845 = 2.220446049250313e-16 +
                       defunc_2_reduce_res_319815;
                double x_319846 = a_319843 * c_319845;
                double y_319847 = b_319844 * b_319844;
                double y_319848 = x_319846 - y_319847;
                double det1_319849 = 1.0 / y_319848;
                double a11_319850 = c_319845 * det1_319849;
                double x_319851 = 0.0 - b_319844;
                double b11_319852 = det1_319849 * x_319851;
                double c11_319853 = a_319843 * det1_319849;
                int64_t defunc_0_m_fun_res_319854;
                
                if (cond_319803) {
                    defunc_0_m_fun_res_319854 = (int64_t) 0;
                } else {
                    int64_t y_319855 = sub64(s_n_m_292825, (int64_t) 1);
                    bool cond_319856 = i_319798 == y_319855;
                    int64_t defunc_0_m_fun_res_f_res_319857;
                    
                    if (cond_319856) {
                        int64_t defunc_0_m_fun_res_f_res_t_res_319858 =
                                sub64(pad_css_len_292821, (int64_t) 1);
                        
                        defunc_0_m_fun_res_f_res_319857 =
                            defunc_0_m_fun_res_f_res_t_res_319858;
                    } else {
                        int64_t x_319859 = sub64(i_319798, (int64_t) 1);
                        int64_t x_319860 = mul64(jump_s_292684, x_319859);
                        int64_t min_arg_319861 = add64((int64_t) 1, x_319860);
                        int64_t min_res_319862 = smin64(defunc_0_f_res_292820,
                                                        min_arg_319861);
                        
                        defunc_0_m_fun_res_f_res_319857 = min_res_319862;
                    }
                    defunc_0_m_fun_res_319854 = defunc_0_m_fun_res_f_res_319857;
                }
                
                double defunc_2_reduce_res_319863;
                double defunc_2_reduce_res_319864;
                double redout_319866;
                double redout_319867;
                
                redout_319866 = 0.0;
                redout_319867 = 0.0;
                for (int64_t i_319865 = 0; i_319865 < q_s_292678; i_319865++) {
                    bool cond_319868 = sle64(x_319795, i_319865);
                    int64_t defunc_0_f_res_319869;
                    
                    if (cond_319868) {
                        defunc_0_f_res_319869 = (int64_t) 0;
                    } else {
                        int64_t i_319870 = add64(x_319801, i_319865);
                        int64_t defunc_0_add_arg_319871;
                        
                        defunc_0_add_arg_319871 =
                            ((int64_t *) mem_312838.mem)[gtid_298889 *
                                                         (defunc_0_f_res_292820 *
                                                          n_p_292677) +
                                                         i_319792 *
                                                         defunc_0_f_res_292820 +
                                                         i_319870];
                        
                        int64_t defunc_1_add_res_319872 = add64((int64_t) 1,
                                                                defunc_0_add_arg_319871);
                        
                        defunc_0_f_res_319869 = defunc_1_add_res_319872;
                    }
                    
                    double defunc_0_f_res_319873;
                    
                    if (cond_319868) {
                        defunc_0_f_res_319873 = 0.0;
                    } else {
                        int64_t i_319874 = add64(x_319801, i_319865);
                        double defunc_0_add_arg_319875;
                        
                        defunc_0_add_arg_319875 =
                            ((double *) mem_313371.mem)[gtid_298889 *
                                                        (defunc_0_f_res_292820 *
                                                         n_p_292677) +
                                                        i_319792 *
                                                        defunc_0_f_res_292820 +
                                                        i_319874];
                        defunc_0_f_res_319873 = defunc_0_add_arg_319875;
                    }
                    
                    int64_t binop_p_319876 = sub64(defunc_0_f_res_319869,
                                                   defunc_0_m_fun_res_319854);
                    double defunc_0_f_res_319877 =
                           sitofp_i64_f64(binop_p_319876);
                    double abs_res_319878 = fabs(defunc_0_f_res_319877);
                    double tmp1_319879 = abs_res_319878 / x_319802;
                    double x_319880 = tmp1_319879 * tmp1_319879;
                    double y_319881 = tmp1_319879 * x_319880;
                    double tmp2_319882 = 1.0 - y_319881;
                    double x_319883 = tmp2_319882 * tmp2_319882;
                    double tmp3_319884 = tmp2_319882 * x_319883;
                    double tmp4_319885 = defunc_0_f_res_319873 * tmp3_319884;
                    double defunc_1_f_res_319886 = defunc_0_f_res_319877 *
                           tmp4_319885;
                    double defunc_0_f_res_319887;
                    
                    if (cond_319868) {
                        defunc_0_f_res_319887 = 0.0;
                    } else {
                        int64_t i_319888 = add64(x_319801, i_319865);
                        double defunc_0_add_arg_319889;
                        
                        defunc_0_add_arg_319889 =
                            ((double *) mem_313366.mem)[gtid_298889 *
                                                        (defunc_0_f_res_292820 *
                                                         n_p_292677) +
                                                        i_319792 *
                                                        defunc_0_f_res_292820 +
                                                        i_319888];
                        defunc_0_f_res_319887 = defunc_0_add_arg_319889;
                    }
                    
                    double x_319890 = a11_319850 * tmp4_319885;
                    double y_319891 = b11_319852 * defunc_1_f_res_319886;
                    double x_319892 = x_319890 + y_319891;
                    double defunc_9_fit_fun_res_319893 = defunc_0_f_res_319887 *
                           x_319892;
                    double x_319894 = b11_319852 * tmp4_319885;
                    double y_319895 = c11_319853 * defunc_1_f_res_319886;
                    double x_319896 = x_319894 + y_319895;
                    double defunc_9_slope_fun_res_319897 =
                           defunc_0_f_res_319887 * x_319896;
                    double defunc_1_op_res_319898 =
                           defunc_9_fit_fun_res_319893 + redout_319866;
                    double defunc_1_op_res_319899 =
                           defunc_9_slope_fun_res_319897 + redout_319867;
                    double redout_tmp_319911 = defunc_1_op_res_319898;
                    double redout_tmp_319912 = defunc_1_op_res_319899;
                    
                    redout_319866 = redout_tmp_319911;
                    redout_319867 = redout_tmp_319912;
                }
                defunc_2_reduce_res_319863 = redout_319866;
                defunc_2_reduce_res_319864 = redout_319867;
                ((double *) mem_313498)[i_319792 * s_n_m_292825 + i_319798] =
                    defunc_2_reduce_res_319863;
                ((double *) mem_313502)[i_319792 * s_n_m_292825 + i_319798] =
                    defunc_2_reduce_res_319864;
            }
        }
        if (n_p_292677 * s_n_m_292825 * (int64_t) 8 > 0)
            memmove(mem_313593.mem + gtid_298889 * (s_n_m_292825 * n_p_292677) *
                    (int64_t) 8, mem_313498 + (int64_t) 0, n_p_292677 *
                    s_n_m_292825 * (int64_t) 8);
        if (n_p_292677 * s_n_m_292825 * (int64_t) 8 > 0)
            memmove(mem_313598.mem + gtid_298889 * (s_n_m_292825 * n_p_292677) *
                    (int64_t) 8, mem_313502 + (int64_t) 0, n_p_292677 *
                    s_n_m_292825 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_313498);
    free(mem_313502);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_337963_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_337963_end -
                 futhark_mc_segmap_parloop_337963_start;
        
        ctx->futhark_mc_segmap_parloop_337963_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_337963_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_337963_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_337961(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_298888 = tid;
    int num_tasks_319790 = info.nsubtasks;
    struct futhark_mc_task_337960 *futhark_mc_task_337960 =
                                  (struct futhark_mc_task_337960 *) args;
    struct futhark_context *ctx = futhark_mc_task_337960->ctx;
    uint64_t futhark_mc_segmap_task_337961_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_337961_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_337960->free_n_p_292677;
    int64_t q_s_292678 = futhark_mc_task_337960->free_q_s_292678;
    int64_t jump_s_292684 = futhark_mc_task_337960->free_jump_s_292684;
    int64_t partition_sizze_292766 =
            futhark_mc_task_337960->free_partition_sizze_292766;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_337960->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_task_337960->free_pad_css_len_292821;
    int64_t s_n_m_292825 = futhark_mc_task_337960->free_s_n_m_292825;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_task_337960->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_312842 = {.desc ="mem_312842", .mem =
                                  futhark_mc_task_337960->free_mem_312842,
                                  .size =0, .references =NULL};
    int64_t bytes_312847 = futhark_mc_task_337960->free_bytes_312847;
    int64_t bytes_312899 = futhark_mc_task_337960->free_bytes_312899;
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_task_337960->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_task_337960->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_task_337960->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_task_337960->free_mem_313371,
                                  .size =0, .references =NULL};
    struct memblock mem_313593 = {.desc ="mem_313593", .mem =
                                  futhark_mc_task_337960->free_mem_313593,
                                  .size =0, .references =NULL};
    struct memblock mem_313598 = {.desc ="mem_313598", .mem =
                                  futhark_mc_task_337960->free_mem_313598,
                                  .size =0, .references =NULL};
    int64_t iter_319791;
    struct futhark_mc_segmap_parloop_struct_337962
    futhark_mc_segmap_parloop_struct_337962;
    
    futhark_mc_segmap_parloop_struct_337962.ctx = ctx;
    futhark_mc_segmap_parloop_struct_337962.free_n_p_292677 = n_p_292677;
    futhark_mc_segmap_parloop_struct_337962.free_q_s_292678 = q_s_292678;
    futhark_mc_segmap_parloop_struct_337962.free_jump_s_292684 = jump_s_292684;
    futhark_mc_segmap_parloop_struct_337962.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_337962.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segmap_parloop_struct_337962.free_pad_css_len_292821 =
        pad_css_len_292821;
    futhark_mc_segmap_parloop_struct_337962.free_s_n_m_292825 = s_n_m_292825;
    futhark_mc_segmap_parloop_struct_337962.free_mem_312838 = mem_312838.mem;
    futhark_mc_segmap_parloop_struct_337962.free_mem_312842 = mem_312842.mem;
    futhark_mc_segmap_parloop_struct_337962.free_bytes_312899 = bytes_312899;
    futhark_mc_segmap_parloop_struct_337962.free_mem_313018 = mem_313018.mem;
    futhark_mc_segmap_parloop_struct_337962.free_mem_313023 = mem_313023.mem;
    futhark_mc_segmap_parloop_struct_337962.free_mem_313366 = mem_313366.mem;
    futhark_mc_segmap_parloop_struct_337962.free_mem_313371 = mem_313371.mem;
    futhark_mc_segmap_parloop_struct_337962.free_mem_313593 = mem_313593.mem;
    futhark_mc_segmap_parloop_struct_337962.free_mem_313598 = mem_313598.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_337963_task;
    
    futhark_mc_segmap_parloop_337963_task.name =
        "futhark_mc_segmap_parloop_337963";
    futhark_mc_segmap_parloop_337963_task.fn = futhark_mc_segmap_parloop_337963;
    futhark_mc_segmap_parloop_337963_task.args =
        &futhark_mc_segmap_parloop_struct_337962;
    futhark_mc_segmap_parloop_337963_task.iterations = iterations;
    futhark_mc_segmap_parloop_337963_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_337963_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_337963_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_337963_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_337963_task);
    
    if (futhark_mc_segmap_parloop_337963_err != 0) {
        err = futhark_mc_segmap_parloop_337963_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_337963_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_337963_total_end -
                 futhark_mc_segmap_parloop_337963_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337963_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337963_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337963_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_337961_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_337961_end -
                 futhark_mc_segmap_task_337961_start;
        
        ctx->futhark_mc_segmap_task_337961_runs[tid]++;
        ctx->futhark_mc_segmap_task_337961_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_337961_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_segmap_parloop_struct_337967 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_q_s_292678;
    int64_t free_jump_s_292684;
    int64_t free_partition_sizze_292766;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_312842;
    int64_t free_bytes_312847;
    int64_t free_bytes_312899;
    unsigned char *free_mem_313018;
    unsigned char *free_mem_313023;
    unsigned char *free_mem_313366;
    unsigned char *free_mem_313371;
    unsigned char *free_mem_313593;
    unsigned char *free_mem_313598;
};
struct futhark_mc_task_337971 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_q_s_292678;
    int64_t free_jump_s_292684;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    int64_t free_gtid_299244;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_312842;
    int64_t free_bytes_312847;
    unsigned char *free_mem_313018;
    unsigned char *free_mem_313023;
    unsigned char *free_mem_313366;
    unsigned char *free_mem_313371;
    unsigned char *free_mem_313490;
    unsigned char *free_mem_313494;
};
struct futhark_mc_segmap_parloop_struct_337973 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_q_s_292678;
    int64_t free_jump_s_292684;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    int64_t free_gtid_299244;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_312842;
    int64_t free_bytes_312847;
    unsigned char *free_mem_313018;
    unsigned char *free_mem_313023;
    unsigned char *free_mem_313366;
    unsigned char *free_mem_313371;
    unsigned char *free_mem_313490;
    unsigned char *free_mem_313494;
};
static int futhark_mc_segmap_parloop_337974(void *args, int64_t start,
                                            int64_t end, int flat_tid_320130,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_337973
    *futhark_mc_segmap_parloop_struct_337973 =
    (struct futhark_mc_segmap_parloop_struct_337973 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_337973->ctx;
    uint64_t futhark_mc_segmap_parloop_337974_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_337974_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segmap_parloop_struct_337973->free_n_p_292677;
    int64_t q_s_292678 =
            futhark_mc_segmap_parloop_struct_337973->free_q_s_292678;
    int64_t jump_s_292684 =
            futhark_mc_segmap_parloop_struct_337973->free_jump_s_292684;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segmap_parloop_struct_337973->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_segmap_parloop_struct_337973->free_pad_css_len_292821;
    int64_t s_n_m_292825 =
            futhark_mc_segmap_parloop_struct_337973->free_s_n_m_292825;
    int64_t gtid_299244 =
            futhark_mc_segmap_parloop_struct_337973->free_gtid_299244;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_segmap_parloop_struct_337973->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_312842 = {.desc ="mem_312842", .mem =
                                  futhark_mc_segmap_parloop_struct_337973->free_mem_312842,
                                  .size =0, .references =NULL};
    int64_t bytes_312847 =
            futhark_mc_segmap_parloop_struct_337973->free_bytes_312847;
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_segmap_parloop_struct_337973->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_segmap_parloop_struct_337973->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_segmap_parloop_struct_337973->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_segmap_parloop_struct_337973->free_mem_313371,
                                  .size =0, .references =NULL};
    struct memblock mem_313490 = {.desc ="mem_313490", .mem =
                                  futhark_mc_segmap_parloop_struct_337973->free_mem_313490,
                                  .size =0, .references =NULL};
    struct memblock mem_313494 = {.desc ="mem_313494", .mem =
                                  futhark_mc_segmap_parloop_struct_337973->free_mem_313494,
                                  .size =0, .references =NULL};
    size_t mem_320133_cached_sizze_337975 = 0;
    unsigned char *mem_320133 = NULL;
    size_t mem_320135_cached_sizze_337976 = 0;
    unsigned char *mem_320135 = NULL;
    int64_t iterations = end - start;
    int64_t iter_320246 = start;
    
    if (mem_320133_cached_sizze_337975 < (size_t) bytes_312847) {
        mem_320133 = realloc(mem_320133, bytes_312847);
        mem_320133_cached_sizze_337975 = bytes_312847;
    }
    if (mem_320135_cached_sizze_337976 < (size_t) bytes_312847) {
        mem_320135 = realloc(mem_320135, bytes_312847);
        mem_320135_cached_sizze_337976 = bytes_312847;
    }
    for (; iter_320246 < end; iter_320246++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_320351 = n_p_292677;
        int64_t gtid_320131 = iter_320246;
        int64_t remnant_320352 = iter_320246 - gtid_320131;
        int64_t x_320132;
        
        x_320132 = ((int64_t *) mem_312842.mem)[gtid_299244 * n_p_292677 +
                                                gtid_320131];
        for (int64_t i_320247 = 0; i_320247 < s_n_m_292825; i_320247++) {
            int64_t x_320250;
            
            x_320250 = ((int64_t *) mem_313018.mem)[gtid_299244 *
                                                    (s_n_m_292825 *
                                                     n_p_292677) + gtid_320131 *
                                                    s_n_m_292825 + i_320247];
            
            double x_320251;
            
            x_320251 = ((double *) mem_313023.mem)[gtid_299244 * (s_n_m_292825 *
                                                                  n_p_292677) +
                                                   gtid_320131 * s_n_m_292825 +
                                                   i_320247];
            
            bool cond_320252 = i_320247 == (int64_t) 0;
            int64_t defunc_0_m_fun_res_320253;
            
            if (cond_320252) {
                defunc_0_m_fun_res_320253 = (int64_t) 0;
            } else {
                int64_t y_320254 = sub64(s_n_m_292825, (int64_t) 1);
                bool cond_320255 = i_320247 == y_320254;
                int64_t defunc_0_m_fun_res_f_res_320256;
                
                if (cond_320255) {
                    int64_t defunc_0_m_fun_res_f_res_t_res_320257 =
                            sub64(pad_css_len_292821, (int64_t) 1);
                    
                    defunc_0_m_fun_res_f_res_320256 =
                        defunc_0_m_fun_res_f_res_t_res_320257;
                } else {
                    int64_t x_320258 = sub64(i_320247, (int64_t) 1);
                    int64_t x_320259 = mul64(jump_s_292684, x_320258);
                    int64_t min_arg_320260 = add64((int64_t) 1, x_320259);
                    int64_t min_res_320261 = smin64(defunc_0_f_res_292820,
                                                    min_arg_320260);
                    
                    defunc_0_m_fun_res_f_res_320256 = min_res_320261;
                }
                defunc_0_m_fun_res_320253 = defunc_0_m_fun_res_f_res_320256;
            }
            
            double defunc_2_reduce_res_320262;
            double defunc_2_reduce_res_320263;
            double defunc_2_reduce_res_320264;
            double redout_320266;
            double redout_320267;
            double redout_320268;
            
            redout_320266 = 0.0;
            redout_320267 = 0.0;
            redout_320268 = 0.0;
            for (int64_t i_320265 = 0; i_320265 < q_s_292678; i_320265++) {
                bool cond_320269 = sle64(x_320132, i_320265);
                int64_t defunc_0_f_res_320270;
                
                if (cond_320269) {
                    defunc_0_f_res_320270 = (int64_t) 0;
                } else {
                    int64_t i_320271 = add64(x_320250, i_320265);
                    int64_t defunc_0_add_arg_320272;
                    
                    defunc_0_add_arg_320272 =
                        ((int64_t *) mem_312838.mem)[gtid_299244 *
                                                     (defunc_0_f_res_292820 *
                                                      n_p_292677) +
                                                     gtid_320131 *
                                                     defunc_0_f_res_292820 +
                                                     i_320271];
                    
                    int64_t defunc_1_add_res_320273 = add64((int64_t) 1,
                                                            defunc_0_add_arg_320272);
                    
                    defunc_0_f_res_320270 = defunc_1_add_res_320273;
                }
                
                double defunc_0_f_res_320274;
                
                if (cond_320269) {
                    defunc_0_f_res_320274 = 0.0;
                } else {
                    int64_t i_320275 = add64(x_320250, i_320265);
                    double defunc_0_add_arg_320276;
                    
                    defunc_0_add_arg_320276 =
                        ((double *) mem_313371.mem)[gtid_299244 *
                                                    (defunc_0_f_res_292820 *
                                                     n_p_292677) + gtid_320131 *
                                                    defunc_0_f_res_292820 +
                                                    i_320275];
                    defunc_0_f_res_320274 = defunc_0_add_arg_320276;
                }
                
                int64_t binop_p_320277 = sub64(defunc_0_f_res_320270,
                                               defunc_0_m_fun_res_320253);
                double defunc_0_f_res_320278 = sitofp_i64_f64(binop_p_320277);
                double abs_res_320279 = fabs(defunc_0_f_res_320278);
                double tmp1_320280 = abs_res_320279 / x_320251;
                double x_320281 = tmp1_320280 * tmp1_320280;
                double y_320282 = tmp1_320280 * x_320281;
                double tmp2_320283 = 1.0 - y_320282;
                double x_320284 = tmp2_320283 * tmp2_320283;
                double tmp3_320285 = tmp2_320283 * x_320284;
                double w_j_320286 = defunc_0_f_res_320274 * tmp3_320285;
                double xw_j_320287 = defunc_0_f_res_320278 * w_j_320286;
                double x2w_j_320288 = defunc_0_f_res_320278 * xw_j_320287;
                double defunc_1_op_res_320289 = w_j_320286 + redout_320266;
                double defunc_1_op_res_320290 = xw_j_320287 + redout_320267;
                double defunc_1_op_res_320291 = x2w_j_320288 + redout_320268;
                double redout_tmp_320355 = defunc_1_op_res_320289;
                double redout_tmp_320356 = defunc_1_op_res_320290;
                double redout_tmp_320357 = defunc_1_op_res_320291;
                
                redout_320266 = redout_tmp_320355;
                redout_320267 = redout_tmp_320356;
                redout_320268 = redout_tmp_320357;
            }
            defunc_2_reduce_res_320262 = redout_320266;
            defunc_2_reduce_res_320263 = redout_320267;
            defunc_2_reduce_res_320264 = redout_320268;
            
            double a_320292 = 2.220446049250313e-16 +
                   defunc_2_reduce_res_320262;
            double b_320293 = 2.220446049250313e-16 +
                   defunc_2_reduce_res_320263;
            double c_320294 = 2.220446049250313e-16 +
                   defunc_2_reduce_res_320264;
            double x_320295 = a_320292 * c_320294;
            double y_320296 = b_320293 * b_320293;
            double y_320297 = x_320295 - y_320296;
            double det1_320298 = 1.0 / y_320297;
            double a11_320299 = c_320294 * det1_320298;
            double x_320300 = 0.0 - b_320293;
            double b11_320301 = det1_320298 * x_320300;
            double c11_320302 = a_320292 * det1_320298;
            int64_t defunc_0_m_fun_res_320303;
            
            if (cond_320252) {
                defunc_0_m_fun_res_320303 = (int64_t) 0;
            } else {
                int64_t y_320304 = sub64(s_n_m_292825, (int64_t) 1);
                bool cond_320305 = i_320247 == y_320304;
                int64_t defunc_0_m_fun_res_f_res_320306;
                
                if (cond_320305) {
                    int64_t defunc_0_m_fun_res_f_res_t_res_320307 =
                            sub64(pad_css_len_292821, (int64_t) 1);
                    
                    defunc_0_m_fun_res_f_res_320306 =
                        defunc_0_m_fun_res_f_res_t_res_320307;
                } else {
                    int64_t x_320308 = sub64(i_320247, (int64_t) 1);
                    int64_t x_320309 = mul64(jump_s_292684, x_320308);
                    int64_t min_arg_320310 = add64((int64_t) 1, x_320309);
                    int64_t min_res_320311 = smin64(defunc_0_f_res_292820,
                                                    min_arg_320310);
                    
                    defunc_0_m_fun_res_f_res_320306 = min_res_320311;
                }
                defunc_0_m_fun_res_320303 = defunc_0_m_fun_res_f_res_320306;
            }
            
            double defunc_2_reduce_res_320312;
            double defunc_2_reduce_res_320313;
            double redout_320315;
            double redout_320316;
            
            redout_320315 = 0.0;
            redout_320316 = 0.0;
            for (int64_t i_320314 = 0; i_320314 < q_s_292678; i_320314++) {
                bool cond_320317 = sle64(x_320132, i_320314);
                int64_t defunc_0_f_res_320318;
                
                if (cond_320317) {
                    defunc_0_f_res_320318 = (int64_t) 0;
                } else {
                    int64_t i_320319 = add64(x_320250, i_320314);
                    int64_t defunc_0_add_arg_320320;
                    
                    defunc_0_add_arg_320320 =
                        ((int64_t *) mem_312838.mem)[gtid_299244 *
                                                     (defunc_0_f_res_292820 *
                                                      n_p_292677) +
                                                     gtid_320131 *
                                                     defunc_0_f_res_292820 +
                                                     i_320319];
                    
                    int64_t defunc_1_add_res_320321 = add64((int64_t) 1,
                                                            defunc_0_add_arg_320320);
                    
                    defunc_0_f_res_320318 = defunc_1_add_res_320321;
                }
                
                double defunc_0_f_res_320322;
                
                if (cond_320317) {
                    defunc_0_f_res_320322 = 0.0;
                } else {
                    int64_t i_320323 = add64(x_320250, i_320314);
                    double defunc_0_add_arg_320324;
                    
                    defunc_0_add_arg_320324 =
                        ((double *) mem_313371.mem)[gtid_299244 *
                                                    (defunc_0_f_res_292820 *
                                                     n_p_292677) + gtid_320131 *
                                                    defunc_0_f_res_292820 +
                                                    i_320323];
                    defunc_0_f_res_320322 = defunc_0_add_arg_320324;
                }
                
                int64_t binop_p_320325 = sub64(defunc_0_f_res_320318,
                                               defunc_0_m_fun_res_320303);
                double defunc_0_f_res_320326 = sitofp_i64_f64(binop_p_320325);
                double abs_res_320327 = fabs(defunc_0_f_res_320326);
                double tmp1_320328 = abs_res_320327 / x_320251;
                double x_320329 = tmp1_320328 * tmp1_320328;
                double y_320330 = tmp1_320328 * x_320329;
                double tmp2_320331 = 1.0 - y_320330;
                double x_320332 = tmp2_320331 * tmp2_320331;
                double tmp3_320333 = tmp2_320331 * x_320332;
                double tmp4_320334 = defunc_0_f_res_320322 * tmp3_320333;
                double defunc_1_f_res_320335 = defunc_0_f_res_320326 *
                       tmp4_320334;
                double defunc_0_f_res_320336;
                
                if (cond_320317) {
                    defunc_0_f_res_320336 = 0.0;
                } else {
                    int64_t i_320337 = add64(x_320250, i_320314);
                    double defunc_0_add_arg_320338;
                    
                    defunc_0_add_arg_320338 =
                        ((double *) mem_313366.mem)[gtid_299244 *
                                                    (defunc_0_f_res_292820 *
                                                     n_p_292677) + gtid_320131 *
                                                    defunc_0_f_res_292820 +
                                                    i_320337];
                    defunc_0_f_res_320336 = defunc_0_add_arg_320338;
                }
                
                double x_320339 = a11_320299 * tmp4_320334;
                double y_320340 = b11_320301 * defunc_1_f_res_320335;
                double x_320341 = x_320339 + y_320340;
                double defunc_9_fit_fun_res_320342 = defunc_0_f_res_320336 *
                       x_320341;
                double x_320343 = b11_320301 * tmp4_320334;
                double y_320344 = c11_320302 * defunc_1_f_res_320335;
                double x_320345 = x_320343 + y_320344;
                double defunc_9_slope_fun_res_320346 = defunc_0_f_res_320336 *
                       x_320345;
                double defunc_1_op_res_320347 = defunc_9_fit_fun_res_320342 +
                       redout_320315;
                double defunc_1_op_res_320348 = defunc_9_slope_fun_res_320346 +
                       redout_320316;
                double redout_tmp_320358 = defunc_1_op_res_320347;
                double redout_tmp_320359 = defunc_1_op_res_320348;
                
                redout_320315 = redout_tmp_320358;
                redout_320316 = redout_tmp_320359;
            }
            defunc_2_reduce_res_320312 = redout_320315;
            defunc_2_reduce_res_320313 = redout_320316;
            ((double *) mem_320133)[i_320247] = defunc_2_reduce_res_320312;
            ((double *) mem_320135)[i_320247] = defunc_2_reduce_res_320313;
        }
        if (s_n_m_292825 * (int64_t) 8 > 0)
            memmove(mem_313490.mem + gtid_320131 * s_n_m_292825 * (int64_t) 8,
                    mem_320133 + (int64_t) 0, s_n_m_292825 * (int64_t) 8);
        if (s_n_m_292825 * (int64_t) 8 > 0)
            memmove(mem_313494.mem + gtid_320131 * s_n_m_292825 * (int64_t) 8,
                    mem_320135 + (int64_t) 0, s_n_m_292825 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_320133);
    free(mem_320135);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_337974_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_337974_end -
                 futhark_mc_segmap_parloop_337974_start;
        
        ctx->futhark_mc_segmap_parloop_337974_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_337974_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_337974_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_337972(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_320130 = tid;
    int num_tasks_320245 = info.nsubtasks;
    struct futhark_mc_task_337971 *futhark_mc_task_337971 =
                                  (struct futhark_mc_task_337971 *) args;
    struct futhark_context *ctx = futhark_mc_task_337971->ctx;
    uint64_t futhark_mc_segmap_task_337972_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_337972_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_337971->free_n_p_292677;
    int64_t q_s_292678 = futhark_mc_task_337971->free_q_s_292678;
    int64_t jump_s_292684 = futhark_mc_task_337971->free_jump_s_292684;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_337971->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_task_337971->free_pad_css_len_292821;
    int64_t s_n_m_292825 = futhark_mc_task_337971->free_s_n_m_292825;
    int64_t gtid_299244 = futhark_mc_task_337971->free_gtid_299244;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_task_337971->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_312842 = {.desc ="mem_312842", .mem =
                                  futhark_mc_task_337971->free_mem_312842,
                                  .size =0, .references =NULL};
    int64_t bytes_312847 = futhark_mc_task_337971->free_bytes_312847;
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_task_337971->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_task_337971->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_task_337971->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_task_337971->free_mem_313371,
                                  .size =0, .references =NULL};
    struct memblock mem_313490 = {.desc ="mem_313490", .mem =
                                  futhark_mc_task_337971->free_mem_313490,
                                  .size =0, .references =NULL};
    struct memblock mem_313494 = {.desc ="mem_313494", .mem =
                                  futhark_mc_task_337971->free_mem_313494,
                                  .size =0, .references =NULL};
    int64_t iter_320246;
    struct futhark_mc_segmap_parloop_struct_337973
    futhark_mc_segmap_parloop_struct_337973;
    
    futhark_mc_segmap_parloop_struct_337973.ctx = ctx;
    futhark_mc_segmap_parloop_struct_337973.free_n_p_292677 = n_p_292677;
    futhark_mc_segmap_parloop_struct_337973.free_q_s_292678 = q_s_292678;
    futhark_mc_segmap_parloop_struct_337973.free_jump_s_292684 = jump_s_292684;
    futhark_mc_segmap_parloop_struct_337973.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segmap_parloop_struct_337973.free_pad_css_len_292821 =
        pad_css_len_292821;
    futhark_mc_segmap_parloop_struct_337973.free_s_n_m_292825 = s_n_m_292825;
    futhark_mc_segmap_parloop_struct_337973.free_gtid_299244 = gtid_299244;
    futhark_mc_segmap_parloop_struct_337973.free_mem_312838 = mem_312838.mem;
    futhark_mc_segmap_parloop_struct_337973.free_mem_312842 = mem_312842.mem;
    futhark_mc_segmap_parloop_struct_337973.free_bytes_312847 = bytes_312847;
    futhark_mc_segmap_parloop_struct_337973.free_mem_313018 = mem_313018.mem;
    futhark_mc_segmap_parloop_struct_337973.free_mem_313023 = mem_313023.mem;
    futhark_mc_segmap_parloop_struct_337973.free_mem_313366 = mem_313366.mem;
    futhark_mc_segmap_parloop_struct_337973.free_mem_313371 = mem_313371.mem;
    futhark_mc_segmap_parloop_struct_337973.free_mem_313490 = mem_313490.mem;
    futhark_mc_segmap_parloop_struct_337973.free_mem_313494 = mem_313494.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_337974_task;
    
    futhark_mc_segmap_parloop_337974_task.name =
        "futhark_mc_segmap_parloop_337974";
    futhark_mc_segmap_parloop_337974_task.fn = futhark_mc_segmap_parloop_337974;
    futhark_mc_segmap_parloop_337974_task.args =
        &futhark_mc_segmap_parloop_struct_337973;
    futhark_mc_segmap_parloop_337974_task.iterations = iterations;
    futhark_mc_segmap_parloop_337974_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_337974_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_337974_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_337974_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_337974_task);
    
    if (futhark_mc_segmap_parloop_337974_err != 0) {
        err = futhark_mc_segmap_parloop_337974_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_337974_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_337974_total_end -
                 futhark_mc_segmap_parloop_337974_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337974_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337974_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337974_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_337972_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_337972_end -
                 futhark_mc_segmap_task_337972_start;
        
        ctx->futhark_mc_segmap_task_337972_runs[tid]++;
        ctx->futhark_mc_segmap_task_337972_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_337972_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_segmap_parloop_struct_337978 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_q_s_292678;
    int64_t free_jump_s_292684;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    int64_t free_gtid_299244;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_312842;
    int64_t free_bytes_312847;
    unsigned char *free_mem_313018;
    unsigned char *free_mem_313023;
    unsigned char *free_mem_313366;
    unsigned char *free_mem_313371;
    unsigned char *free_mem_313490;
    unsigned char *free_mem_313494;
};
struct futhark_mc_task_337982 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_q_s_292678;
    int64_t free_jump_s_292684;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    int64_t free_gtid_299244;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_313018;
    unsigned char *free_mem_313023;
    unsigned char *free_mem_313366;
    unsigned char *free_mem_313371;
    int64_t free_gtid_319915;
    int64_t free_x_319916;
    unsigned char *free_mem_319917;
    unsigned char *free_mem_319918;
};
struct futhark_mc_segmap_parloop_struct_337984 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_q_s_292678;
    int64_t free_jump_s_292684;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    int64_t free_gtid_299244;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_313018;
    unsigned char *free_mem_313023;
    unsigned char *free_mem_313366;
    unsigned char *free_mem_313371;
    int64_t free_gtid_319915;
    int64_t free_x_319916;
    unsigned char *free_mem_319917;
    unsigned char *free_mem_319918;
};
static int futhark_mc_segmap_parloop_337985(void *args, int64_t start,
                                            int64_t end, int flat_tid_320469,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_337984
    *futhark_mc_segmap_parloop_struct_337984 =
    (struct futhark_mc_segmap_parloop_struct_337984 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_337984->ctx;
    uint64_t futhark_mc_segmap_parloop_337985_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_337985_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segmap_parloop_struct_337984->free_n_p_292677;
    int64_t q_s_292678 =
            futhark_mc_segmap_parloop_struct_337984->free_q_s_292678;
    int64_t jump_s_292684 =
            futhark_mc_segmap_parloop_struct_337984->free_jump_s_292684;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segmap_parloop_struct_337984->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_segmap_parloop_struct_337984->free_pad_css_len_292821;
    int64_t s_n_m_292825 =
            futhark_mc_segmap_parloop_struct_337984->free_s_n_m_292825;
    int64_t gtid_299244 =
            futhark_mc_segmap_parloop_struct_337984->free_gtid_299244;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_segmap_parloop_struct_337984->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_segmap_parloop_struct_337984->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_segmap_parloop_struct_337984->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_segmap_parloop_struct_337984->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_segmap_parloop_struct_337984->free_mem_313371,
                                  .size =0, .references =NULL};
    int64_t gtid_319915 =
            futhark_mc_segmap_parloop_struct_337984->free_gtid_319915;
    int64_t x_319916 = futhark_mc_segmap_parloop_struct_337984->free_x_319916;
    struct memblock mem_319917 = {.desc ="mem_319917", .mem =
                                  futhark_mc_segmap_parloop_struct_337984->free_mem_319917,
                                  .size =0, .references =NULL};
    struct memblock mem_319918 = {.desc ="mem_319918", .mem =
                                  futhark_mc_segmap_parloop_struct_337984->free_mem_319918,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_320573 = start;
    
    for (; iter_320573 < end; iter_320573++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_320652 = s_n_m_292825;
        int64_t gtid_320470 = iter_320573;
        int64_t remnant_320653 = iter_320573 - gtid_320470;
        int64_t x_320471;
        
        x_320471 = ((int64_t *) mem_313018.mem)[gtid_299244 * (s_n_m_292825 *
                                                               n_p_292677) +
                                                gtid_319915 * s_n_m_292825 +
                                                gtid_320470];
        
        double x_320472;
        
        x_320472 = ((double *) mem_313023.mem)[gtid_299244 * (s_n_m_292825 *
                                                              n_p_292677) +
                                               gtid_319915 * s_n_m_292825 +
                                               gtid_320470];
        
        bool cond_320473 = gtid_320470 == (int64_t) 0;
        int64_t defunc_0_m_fun_res_320474;
        
        if (cond_320473) {
            defunc_0_m_fun_res_320474 = (int64_t) 0;
        } else {
            int64_t y_320574 = sub64(s_n_m_292825, (int64_t) 1);
            bool cond_320575 = gtid_320470 == y_320574;
            int64_t defunc_0_m_fun_res_f_res_320576;
            
            if (cond_320575) {
                int64_t defunc_0_m_fun_res_f_res_t_res_320577 =
                        sub64(pad_css_len_292821, (int64_t) 1);
                
                defunc_0_m_fun_res_f_res_320576 =
                    defunc_0_m_fun_res_f_res_t_res_320577;
            } else {
                int64_t x_320578 = sub64(gtid_320470, (int64_t) 1);
                int64_t x_320579 = mul64(jump_s_292684, x_320578);
                int64_t min_arg_320580 = add64((int64_t) 1, x_320579);
                int64_t min_res_320581 = smin64(defunc_0_f_res_292820,
                                                min_arg_320580);
                
                defunc_0_m_fun_res_f_res_320576 = min_res_320581;
            }
            defunc_0_m_fun_res_320474 = defunc_0_m_fun_res_f_res_320576;
        }
        
        double defunc_2_reduce_res_320483;
        double defunc_2_reduce_res_320484;
        double defunc_2_reduce_res_320485;
        double redout_320583;
        double redout_320584;
        double redout_320585;
        
        redout_320583 = 0.0;
        redout_320584 = 0.0;
        redout_320585 = 0.0;
        for (int64_t i_320582 = 0; i_320582 < q_s_292678; i_320582++) {
            bool cond_320586 = sle64(x_319916, i_320582);
            int64_t defunc_0_f_res_320587;
            
            if (cond_320586) {
                defunc_0_f_res_320587 = (int64_t) 0;
            } else {
                int64_t i_320588 = add64(x_320471, i_320582);
                int64_t defunc_0_add_arg_320589;
                
                defunc_0_add_arg_320589 =
                    ((int64_t *) mem_312838.mem)[gtid_299244 *
                                                 (defunc_0_f_res_292820 *
                                                  n_p_292677) + gtid_319915 *
                                                 defunc_0_f_res_292820 +
                                                 i_320588];
                
                int64_t defunc_1_add_res_320590 = add64((int64_t) 1,
                                                        defunc_0_add_arg_320589);
                
                defunc_0_f_res_320587 = defunc_1_add_res_320590;
            }
            
            double defunc_0_f_res_320591;
            
            if (cond_320586) {
                defunc_0_f_res_320591 = 0.0;
            } else {
                int64_t i_320592 = add64(x_320471, i_320582);
                double defunc_0_add_arg_320593;
                
                defunc_0_add_arg_320593 =
                    ((double *) mem_313371.mem)[gtid_299244 *
                                                (defunc_0_f_res_292820 *
                                                 n_p_292677) + gtid_319915 *
                                                defunc_0_f_res_292820 +
                                                i_320592];
                defunc_0_f_res_320591 = defunc_0_add_arg_320593;
            }
            
            int64_t binop_p_320594 = sub64(defunc_0_f_res_320587,
                                           defunc_0_m_fun_res_320474);
            double defunc_0_f_res_320595 = sitofp_i64_f64(binop_p_320594);
            double abs_res_320596 = fabs(defunc_0_f_res_320595);
            double tmp1_320597 = abs_res_320596 / x_320472;
            double x_320598 = tmp1_320597 * tmp1_320597;
            double y_320599 = tmp1_320597 * x_320598;
            double tmp2_320600 = 1.0 - y_320599;
            double x_320601 = tmp2_320600 * tmp2_320600;
            double tmp3_320602 = tmp2_320600 * x_320601;
            double w_j_320603 = defunc_0_f_res_320591 * tmp3_320602;
            double xw_j_320604 = defunc_0_f_res_320595 * w_j_320603;
            double x2w_j_320605 = defunc_0_f_res_320595 * xw_j_320604;
            double defunc_1_op_res_320606 = w_j_320603 + redout_320583;
            double defunc_1_op_res_320607 = xw_j_320604 + redout_320584;
            double defunc_1_op_res_320608 = x2w_j_320605 + redout_320585;
            double redout_tmp_320654 = defunc_1_op_res_320606;
            double redout_tmp_320655 = defunc_1_op_res_320607;
            double redout_tmp_320656 = defunc_1_op_res_320608;
            
            redout_320583 = redout_tmp_320654;
            redout_320584 = redout_tmp_320655;
            redout_320585 = redout_tmp_320656;
        }
        defunc_2_reduce_res_320483 = redout_320583;
        defunc_2_reduce_res_320484 = redout_320584;
        defunc_2_reduce_res_320485 = redout_320585;
        
        double a_320513 = 2.220446049250313e-16 + defunc_2_reduce_res_320483;
        double b_320514 = 2.220446049250313e-16 + defunc_2_reduce_res_320484;
        double c_320515 = 2.220446049250313e-16 + defunc_2_reduce_res_320485;
        double x_320516 = a_320513 * c_320515;
        double y_320517 = b_320514 * b_320514;
        double y_320518 = x_320516 - y_320517;
        double det1_320519 = 1.0 / y_320518;
        double a11_320520 = c_320515 * det1_320519;
        double x_320521 = 0.0 - b_320514;
        double b11_320522 = det1_320519 * x_320521;
        double c11_320523 = a_320513 * det1_320519;
        int64_t defunc_0_m_fun_res_320524;
        
        if (cond_320473) {
            defunc_0_m_fun_res_320524 = (int64_t) 0;
        } else {
            int64_t y_320609 = sub64(s_n_m_292825, (int64_t) 1);
            bool cond_320610 = gtid_320470 == y_320609;
            int64_t defunc_0_m_fun_res_f_res_320611;
            
            if (cond_320610) {
                int64_t defunc_0_m_fun_res_f_res_t_res_320612 =
                        sub64(pad_css_len_292821, (int64_t) 1);
                
                defunc_0_m_fun_res_f_res_320611 =
                    defunc_0_m_fun_res_f_res_t_res_320612;
            } else {
                int64_t x_320613 = sub64(gtid_320470, (int64_t) 1);
                int64_t x_320614 = mul64(jump_s_292684, x_320613);
                int64_t min_arg_320615 = add64((int64_t) 1, x_320614);
                int64_t min_res_320616 = smin64(defunc_0_f_res_292820,
                                                min_arg_320615);
                
                defunc_0_m_fun_res_f_res_320611 = min_res_320616;
            }
            defunc_0_m_fun_res_320524 = defunc_0_m_fun_res_f_res_320611;
        }
        
        double defunc_2_reduce_res_320533;
        double defunc_2_reduce_res_320534;
        double redout_320618;
        double redout_320619;
        
        redout_320618 = 0.0;
        redout_320619 = 0.0;
        for (int64_t i_320617 = 0; i_320617 < q_s_292678; i_320617++) {
            bool cond_320620 = sle64(x_319916, i_320617);
            int64_t defunc_0_f_res_320621;
            
            if (cond_320620) {
                defunc_0_f_res_320621 = (int64_t) 0;
            } else {
                int64_t i_320622 = add64(x_320471, i_320617);
                int64_t defunc_0_add_arg_320623;
                
                defunc_0_add_arg_320623 =
                    ((int64_t *) mem_312838.mem)[gtid_299244 *
                                                 (defunc_0_f_res_292820 *
                                                  n_p_292677) + gtid_319915 *
                                                 defunc_0_f_res_292820 +
                                                 i_320622];
                
                int64_t defunc_1_add_res_320624 = add64((int64_t) 1,
                                                        defunc_0_add_arg_320623);
                
                defunc_0_f_res_320621 = defunc_1_add_res_320624;
            }
            
            double defunc_0_f_res_320625;
            
            if (cond_320620) {
                defunc_0_f_res_320625 = 0.0;
            } else {
                int64_t i_320626 = add64(x_320471, i_320617);
                double defunc_0_add_arg_320627;
                
                defunc_0_add_arg_320627 =
                    ((double *) mem_313371.mem)[gtid_299244 *
                                                (defunc_0_f_res_292820 *
                                                 n_p_292677) + gtid_319915 *
                                                defunc_0_f_res_292820 +
                                                i_320626];
                defunc_0_f_res_320625 = defunc_0_add_arg_320627;
            }
            
            int64_t binop_p_320628 = sub64(defunc_0_f_res_320621,
                                           defunc_0_m_fun_res_320524);
            double defunc_0_f_res_320629 = sitofp_i64_f64(binop_p_320628);
            double abs_res_320630 = fabs(defunc_0_f_res_320629);
            double tmp1_320631 = abs_res_320630 / x_320472;
            double x_320632 = tmp1_320631 * tmp1_320631;
            double y_320633 = tmp1_320631 * x_320632;
            double tmp2_320634 = 1.0 - y_320633;
            double x_320635 = tmp2_320634 * tmp2_320634;
            double tmp3_320636 = tmp2_320634 * x_320635;
            double tmp4_320637 = defunc_0_f_res_320625 * tmp3_320636;
            double defunc_1_f_res_320638 = defunc_0_f_res_320629 * tmp4_320637;
            double defunc_0_f_res_320639;
            
            if (cond_320620) {
                defunc_0_f_res_320639 = 0.0;
            } else {
                int64_t i_320640 = add64(x_320471, i_320617);
                double defunc_0_add_arg_320641;
                
                defunc_0_add_arg_320641 =
                    ((double *) mem_313366.mem)[gtid_299244 *
                                                (defunc_0_f_res_292820 *
                                                 n_p_292677) + gtid_319915 *
                                                defunc_0_f_res_292820 +
                                                i_320640];
                defunc_0_f_res_320639 = defunc_0_add_arg_320641;
            }
            
            double x_320642 = a11_320520 * tmp4_320637;
            double y_320643 = b11_320522 * defunc_1_f_res_320638;
            double x_320644 = x_320642 + y_320643;
            double defunc_9_fit_fun_res_320645 = defunc_0_f_res_320639 *
                   x_320644;
            double x_320646 = b11_320522 * tmp4_320637;
            double y_320647 = c11_320523 * defunc_1_f_res_320638;
            double x_320648 = x_320646 + y_320647;
            double defunc_9_slope_fun_res_320649 = defunc_0_f_res_320639 *
                   x_320648;
            double defunc_1_op_res_320650 = defunc_9_fit_fun_res_320645 +
                   redout_320618;
            double defunc_1_op_res_320651 = defunc_9_slope_fun_res_320649 +
                   redout_320619;
            double redout_tmp_320657 = defunc_1_op_res_320650;
            double redout_tmp_320658 = defunc_1_op_res_320651;
            
            redout_320618 = redout_tmp_320657;
            redout_320619 = redout_tmp_320658;
        }
        defunc_2_reduce_res_320533 = redout_320618;
        defunc_2_reduce_res_320534 = redout_320619;
        ((double *) mem_319917.mem)[gtid_320470] = defunc_2_reduce_res_320533;
        ((double *) mem_319918.mem)[gtid_320470] = defunc_2_reduce_res_320534;
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_337985_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_337985_end -
                 futhark_mc_segmap_parloop_337985_start;
        
        ctx->futhark_mc_segmap_parloop_337985_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_337985_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_337985_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_337983(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_320469 = tid;
    int num_tasks_320572 = info.nsubtasks;
    struct futhark_mc_task_337982 *futhark_mc_task_337982 =
                                  (struct futhark_mc_task_337982 *) args;
    struct futhark_context *ctx = futhark_mc_task_337982->ctx;
    uint64_t futhark_mc_segmap_task_337983_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_337983_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_337982->free_n_p_292677;
    int64_t q_s_292678 = futhark_mc_task_337982->free_q_s_292678;
    int64_t jump_s_292684 = futhark_mc_task_337982->free_jump_s_292684;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_337982->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_task_337982->free_pad_css_len_292821;
    int64_t s_n_m_292825 = futhark_mc_task_337982->free_s_n_m_292825;
    int64_t gtid_299244 = futhark_mc_task_337982->free_gtid_299244;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_task_337982->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_task_337982->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_task_337982->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_task_337982->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_task_337982->free_mem_313371,
                                  .size =0, .references =NULL};
    int64_t gtid_319915 = futhark_mc_task_337982->free_gtid_319915;
    int64_t x_319916 = futhark_mc_task_337982->free_x_319916;
    struct memblock mem_319917 = {.desc ="mem_319917", .mem =
                                  futhark_mc_task_337982->free_mem_319917,
                                  .size =0, .references =NULL};
    struct memblock mem_319918 = {.desc ="mem_319918", .mem =
                                  futhark_mc_task_337982->free_mem_319918,
                                  .size =0, .references =NULL};
    int64_t iter_320573;
    struct futhark_mc_segmap_parloop_struct_337984
    futhark_mc_segmap_parloop_struct_337984;
    
    futhark_mc_segmap_parloop_struct_337984.ctx = ctx;
    futhark_mc_segmap_parloop_struct_337984.free_n_p_292677 = n_p_292677;
    futhark_mc_segmap_parloop_struct_337984.free_q_s_292678 = q_s_292678;
    futhark_mc_segmap_parloop_struct_337984.free_jump_s_292684 = jump_s_292684;
    futhark_mc_segmap_parloop_struct_337984.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segmap_parloop_struct_337984.free_pad_css_len_292821 =
        pad_css_len_292821;
    futhark_mc_segmap_parloop_struct_337984.free_s_n_m_292825 = s_n_m_292825;
    futhark_mc_segmap_parloop_struct_337984.free_gtid_299244 = gtid_299244;
    futhark_mc_segmap_parloop_struct_337984.free_mem_312838 = mem_312838.mem;
    futhark_mc_segmap_parloop_struct_337984.free_mem_313018 = mem_313018.mem;
    futhark_mc_segmap_parloop_struct_337984.free_mem_313023 = mem_313023.mem;
    futhark_mc_segmap_parloop_struct_337984.free_mem_313366 = mem_313366.mem;
    futhark_mc_segmap_parloop_struct_337984.free_mem_313371 = mem_313371.mem;
    futhark_mc_segmap_parloop_struct_337984.free_gtid_319915 = gtid_319915;
    futhark_mc_segmap_parloop_struct_337984.free_x_319916 = x_319916;
    futhark_mc_segmap_parloop_struct_337984.free_mem_319917 = mem_319917.mem;
    futhark_mc_segmap_parloop_struct_337984.free_mem_319918 = mem_319918.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_337985_task;
    
    futhark_mc_segmap_parloop_337985_task.name =
        "futhark_mc_segmap_parloop_337985";
    futhark_mc_segmap_parloop_337985_task.fn = futhark_mc_segmap_parloop_337985;
    futhark_mc_segmap_parloop_337985_task.args =
        &futhark_mc_segmap_parloop_struct_337984;
    futhark_mc_segmap_parloop_337985_task.iterations = iterations;
    futhark_mc_segmap_parloop_337985_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_337985_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_337985_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_337985_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_337985_task);
    
    if (futhark_mc_segmap_parloop_337985_err != 0) {
        err = futhark_mc_segmap_parloop_337985_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_337985_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_337985_total_end -
                 futhark_mc_segmap_parloop_337985_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337985_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337985_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337985_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_337983_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_337983_end -
                 futhark_mc_segmap_task_337983_start;
        
        ctx->futhark_mc_segmap_task_337983_runs[tid]++;
        ctx->futhark_mc_segmap_task_337983_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_337983_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_segmap_parloop_struct_337987 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_q_s_292678;
    int64_t free_jump_s_292684;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    int64_t free_gtid_299244;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_313018;
    unsigned char *free_mem_313023;
    unsigned char *free_mem_313366;
    unsigned char *free_mem_313371;
    int64_t free_gtid_319915;
    int64_t free_x_319916;
    unsigned char *free_mem_319917;
    unsigned char *free_mem_319918;
};
struct futhark_mc_task_337989 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_gtid_299244;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_313371;
    int64_t free_gtid_319915;
    int64_t free_x_319916;
    int64_t free_x_320363;
    double free_x_320364;
    int64_t free_defunc_0_m_fun_res_320366;
    double *retval_defunc_2_reduce_res_320375;
    double *retval_defunc_2_reduce_res_320376;
    double *retval_defunc_2_reduce_res_320377;
};
struct futhark_mc_segred_stage_1_parloop_struct_337994 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_gtid_299244;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_313371;
    int64_t free_gtid_319915;
    int64_t free_x_319916;
    int64_t free_x_320363;
    double free_x_320364;
    int64_t free_defunc_0_m_fun_res_320366;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_320748;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_320750;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_320752;
};
static int futhark_mc_segred_stage_1_parloop_337995(void *args, int64_t start,
                                                    int64_t end,
                                                    int flat_tid_320668,
                                                    int tid)
{
    int err = 0;
    struct futhark_mc_segred_stage_1_parloop_struct_337994
    *futhark_mc_segred_stage_1_parloop_struct_337994 =
    (struct futhark_mc_segred_stage_1_parloop_struct_337994 *) args;
    struct futhark_context *ctx =
                           futhark_mc_segred_stage_1_parloop_struct_337994->ctx;
    uint64_t futhark_mc_segred_stage_1_parloop_337995_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_337995_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segred_stage_1_parloop_struct_337994->free_n_p_292677;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segred_stage_1_parloop_struct_337994->free_defunc_0_f_res_292820;
    int64_t gtid_299244 =
            futhark_mc_segred_stage_1_parloop_struct_337994->free_gtid_299244;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_337994->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_337994->free_mem_313371,
                                  .size =0, .references =NULL};
    int64_t gtid_319915 =
            futhark_mc_segred_stage_1_parloop_struct_337994->free_gtid_319915;
    int64_t x_319916 =
            futhark_mc_segred_stage_1_parloop_struct_337994->free_x_319916;
    int64_t x_320363 =
            futhark_mc_segred_stage_1_parloop_struct_337994->free_x_320363;
    double x_320364 =
           futhark_mc_segred_stage_1_parloop_struct_337994->free_x_320364;
    int64_t defunc_0_m_fun_res_320366 =
            futhark_mc_segred_stage_1_parloop_struct_337994->free_defunc_0_m_fun_res_320366;
    struct memblock reduce_stage_1_tid_res_arr_mem_320748 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_320748",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_337994->free_reduce_stage_1_tid_res_arr_mem_320748,
                                                             .size =0,
                                                             .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_320750 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_320750",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_337994->free_reduce_stage_1_tid_res_arr_mem_320750,
                                                             .size =0,
                                                             .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_320752 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_320752",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_337994->free_reduce_stage_1_tid_res_arr_mem_320752,
                                                             .size =0,
                                                             .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_320754 = start;
    double x_320670;
    double x_320671;
    double x_320673;
    double x_320674;
    double x_320676;
    double x_320677;
    double local_acc_320755 = 0.0;
    double local_acc_320756 = 0.0;
    double local_acc_320757 = 0.0;
    
    for (; iter_320754 < end; iter_320754++) {
        int64_t gtid_320669 = iter_320754;
        bool cond_320679 = sle64(x_319916, gtid_320669);
        int64_t defunc_0_f_res_320680;
        
        if (cond_320679) {
            defunc_0_f_res_320680 = (int64_t) 0;
        } else {
            int64_t i_320681 = add64(x_320363, gtid_320669);
            int64_t defunc_0_add_arg_320682;
            
            defunc_0_add_arg_320682 = ((int64_t *) mem_312838.mem)[gtid_299244 *
                                                                   (defunc_0_f_res_292820 *
                                                                    n_p_292677) +
                                                                   gtid_319915 *
                                                                   defunc_0_f_res_292820 +
                                                                   i_320681];
            
            int64_t defunc_1_add_res_320683 = add64((int64_t) 1,
                                                    defunc_0_add_arg_320682);
            
            defunc_0_f_res_320680 = defunc_1_add_res_320683;
        }
        
        double defunc_0_f_res_320684;
        
        if (cond_320679) {
            defunc_0_f_res_320684 = 0.0;
        } else {
            int64_t i_320685 = add64(x_320363, gtid_320669);
            double defunc_0_add_arg_320686;
            
            defunc_0_add_arg_320686 = ((double *) mem_313371.mem)[gtid_299244 *
                                                                  (defunc_0_f_res_292820 *
                                                                   n_p_292677) +
                                                                  gtid_319915 *
                                                                  defunc_0_f_res_292820 +
                                                                  i_320685];
            defunc_0_f_res_320684 = defunc_0_add_arg_320686;
        }
        
        int64_t binop_p_320687 = sub64(defunc_0_f_res_320680,
                                       defunc_0_m_fun_res_320366);
        double defunc_0_f_res_320688 = sitofp_i64_f64(binop_p_320687);
        double abs_res_320689 = fabs(defunc_0_f_res_320688);
        double tmp1_320690 = abs_res_320689 / x_320364;
        double x_320691 = tmp1_320690 * tmp1_320690;
        double y_320692 = tmp1_320690 * x_320691;
        double tmp2_320693 = 1.0 - y_320692;
        double x_320694 = tmp2_320693 * tmp2_320693;
        double tmp3_320695 = tmp2_320693 * x_320694;
        double w_j_320696 = defunc_0_f_res_320684 * tmp3_320695;
        double xw_j_320697 = defunc_0_f_res_320688 * w_j_320696;
        double x2w_j_320698 = defunc_0_f_res_320688 * xw_j_320697;
        
        // save map-out results
        { }
        // Load accum params
        {
            x_320670 = local_acc_320755;
        }
        // Load next params
        {
            x_320671 = w_j_320696;
        }
        // Red body
        {
            double defunc_1_op_res_320672 = x_320670 + x_320671;
            
            local_acc_320755 = defunc_1_op_res_320672;
        }
        // Load accum params
        {
            x_320673 = local_acc_320756;
        }
        // Load next params
        {
            x_320674 = xw_j_320697;
        }
        // Red body
        {
            double defunc_1_op_res_320675 = x_320673 + x_320674;
            
            local_acc_320756 = defunc_1_op_res_320675;
        }
        // Load accum params
        {
            x_320676 = local_acc_320757;
        }
        // Load next params
        {
            x_320677 = x2w_j_320698;
        }
        // Red body
        {
            double defunc_1_op_res_320678 = x_320676 + x_320677;
            
            local_acc_320757 = defunc_1_op_res_320678;
        }
    }
    ((double *) reduce_stage_1_tid_res_arr_mem_320748.mem)[flat_tid_320668] =
        local_acc_320755;
    ((double *) reduce_stage_1_tid_res_arr_mem_320750.mem)[flat_tid_320668] =
        local_acc_320756;
    ((double *) reduce_stage_1_tid_res_arr_mem_320752.mem)[flat_tid_320668] =
        local_acc_320757;
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_337995_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_337995_end -
                 futhark_mc_segred_stage_1_parloop_337995_start;
        
        ctx->futhark_mc_segred_stage_1_parloop_337995_runs[tid]++;
        ctx->futhark_mc_segred_stage_1_parloop_337995_total_runtime[tid] +=
            elapsed;
        ctx->futhark_mc_segred_stage_1_parloop_337995_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segred_task_337990(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_320668 = tid;
    int num_tasks_320747 = info.nsubtasks;
    struct futhark_mc_task_337989 *futhark_mc_task_337989 =
                                  (struct futhark_mc_task_337989 *) args;
    struct futhark_context *ctx = futhark_mc_task_337989->ctx;
    uint64_t futhark_mc_segred_task_337990_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_task_337990_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_337989->free_n_p_292677;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_337989->free_defunc_0_f_res_292820;
    int64_t gtid_299244 = futhark_mc_task_337989->free_gtid_299244;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_task_337989->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_task_337989->free_mem_313371,
                                  .size =0, .references =NULL};
    int64_t gtid_319915 = futhark_mc_task_337989->free_gtid_319915;
    int64_t x_319916 = futhark_mc_task_337989->free_x_319916;
    int64_t x_320363 = futhark_mc_task_337989->free_x_320363;
    double x_320364 = futhark_mc_task_337989->free_x_320364;
    int64_t defunc_0_m_fun_res_320366 =
            futhark_mc_task_337989->free_defunc_0_m_fun_res_320366;
    double defunc_2_reduce_res_320375 =
           *futhark_mc_task_337989->retval_defunc_2_reduce_res_320375;
    double defunc_2_reduce_res_320376 =
           *futhark_mc_task_337989->retval_defunc_2_reduce_res_320376;
    double defunc_2_reduce_res_320377 =
           *futhark_mc_task_337989->retval_defunc_2_reduce_res_320377;
    size_t reduce_stage_1_tid_res_arr_mem_320748_cached_sizze_337991 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_320748 = NULL;
    size_t reduce_stage_1_tid_res_arr_mem_320750_cached_sizze_337992 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_320750 = NULL;
    size_t reduce_stage_1_tid_res_arr_mem_320752_cached_sizze_337993 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_320752 = NULL;
    
    if (reduce_stage_1_tid_res_arr_mem_320748_cached_sizze_337991 <
        (size_t) ((int64_t) 8 * num_tasks_320747)) {
        reduce_stage_1_tid_res_arr_mem_320748 =
            realloc(reduce_stage_1_tid_res_arr_mem_320748, (int64_t) 8 *
                    num_tasks_320747);
        reduce_stage_1_tid_res_arr_mem_320748_cached_sizze_337991 =
            (int64_t) 8 * num_tasks_320747;
    }
    if (reduce_stage_1_tid_res_arr_mem_320750_cached_sizze_337992 <
        (size_t) ((int64_t) 8 * num_tasks_320747)) {
        reduce_stage_1_tid_res_arr_mem_320750 =
            realloc(reduce_stage_1_tid_res_arr_mem_320750, (int64_t) 8 *
                    num_tasks_320747);
        reduce_stage_1_tid_res_arr_mem_320750_cached_sizze_337992 =
            (int64_t) 8 * num_tasks_320747;
    }
    if (reduce_stage_1_tid_res_arr_mem_320752_cached_sizze_337993 <
        (size_t) ((int64_t) 8 * num_tasks_320747)) {
        reduce_stage_1_tid_res_arr_mem_320752 =
            realloc(reduce_stage_1_tid_res_arr_mem_320752, (int64_t) 8 *
                    num_tasks_320747);
        reduce_stage_1_tid_res_arr_mem_320752_cached_sizze_337993 =
            (int64_t) 8 * num_tasks_320747;
    }
    
    int64_t iter_320754;
    struct futhark_mc_segred_stage_1_parloop_struct_337994
    futhark_mc_segred_stage_1_parloop_struct_337994;
    
    futhark_mc_segred_stage_1_parloop_struct_337994.ctx = ctx;
    futhark_mc_segred_stage_1_parloop_struct_337994.free_n_p_292677 =
        n_p_292677;
    futhark_mc_segred_stage_1_parloop_struct_337994.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segred_stage_1_parloop_struct_337994.free_gtid_299244 =
        gtid_299244;
    futhark_mc_segred_stage_1_parloop_struct_337994.free_mem_312838 =
        mem_312838.mem;
    futhark_mc_segred_stage_1_parloop_struct_337994.free_mem_313371 =
        mem_313371.mem;
    futhark_mc_segred_stage_1_parloop_struct_337994.free_gtid_319915 =
        gtid_319915;
    futhark_mc_segred_stage_1_parloop_struct_337994.free_x_319916 = x_319916;
    futhark_mc_segred_stage_1_parloop_struct_337994.free_x_320363 = x_320363;
    futhark_mc_segred_stage_1_parloop_struct_337994.free_x_320364 = x_320364;
    futhark_mc_segred_stage_1_parloop_struct_337994.free_defunc_0_m_fun_res_320366 =
        defunc_0_m_fun_res_320366;
    futhark_mc_segred_stage_1_parloop_struct_337994.free_reduce_stage_1_tid_res_arr_mem_320748 =
        reduce_stage_1_tid_res_arr_mem_320748;
    futhark_mc_segred_stage_1_parloop_struct_337994.free_reduce_stage_1_tid_res_arr_mem_320750 =
        reduce_stage_1_tid_res_arr_mem_320750;
    futhark_mc_segred_stage_1_parloop_struct_337994.free_reduce_stage_1_tid_res_arr_mem_320752 =
        reduce_stage_1_tid_res_arr_mem_320752;
    
    struct scheduler_parloop futhark_mc_segred_stage_1_parloop_337995_task;
    
    futhark_mc_segred_stage_1_parloop_337995_task.name =
        "futhark_mc_segred_stage_1_parloop_337995";
    futhark_mc_segred_stage_1_parloop_337995_task.fn =
        futhark_mc_segred_stage_1_parloop_337995;
    futhark_mc_segred_stage_1_parloop_337995_task.args =
        &futhark_mc_segred_stage_1_parloop_struct_337994;
    futhark_mc_segred_stage_1_parloop_337995_task.iterations = iterations;
    futhark_mc_segred_stage_1_parloop_337995_task.info = info;
    
    uint64_t futhark_mc_segred_stage_1_parloop_337995_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_337995_total_start = get_wall_time();
    
    int futhark_mc_segred_stage_1_parloop_337995_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segred_stage_1_parloop_337995_task);
    
    if (futhark_mc_segred_stage_1_parloop_337995_err != 0) {
        err = futhark_mc_segred_stage_1_parloop_337995_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_337995_total_end =
                 get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_337995_total_end -
                 futhark_mc_segred_stage_1_parloop_337995_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_337995_total_runs,
                           1, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_337995_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_337995_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    // neutral-initialise the output
    {
        defunc_2_reduce_res_320375 = 0.0;
        defunc_2_reduce_res_320376 = 0.0;
        defunc_2_reduce_res_320377 = 0.0;
    }
    
    double x_320758;
    double x_320759;
    double x_320761;
    double x_320762;
    double x_320764;
    double x_320765;
    
    for (int32_t i_320767 = 0; i_320767 < num_tasks_320747; i_320767++) {
        flat_tid_320668 = i_320767;
        // Apply main thread reduction
        {
            // load acc params
            {
                x_320758 = defunc_2_reduce_res_320375;
            }
            // load next params
            {
                x_320759 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_320748)[flat_tid_320668];
            }
            // red body
            {
                double defunc_1_op_res_320760 = x_320758 + x_320759;
                
                defunc_2_reduce_res_320375 = defunc_1_op_res_320760;
            }
            // load acc params
            {
                x_320761 = defunc_2_reduce_res_320376;
            }
            // load next params
            {
                x_320762 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_320750)[flat_tid_320668];
            }
            // red body
            {
                double defunc_1_op_res_320763 = x_320761 + x_320762;
                
                defunc_2_reduce_res_320376 = defunc_1_op_res_320763;
            }
            // load acc params
            {
                x_320764 = defunc_2_reduce_res_320377;
            }
            // load next params
            {
                x_320765 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_320752)[flat_tid_320668];
            }
            // red body
            {
                double defunc_1_op_res_320766 = x_320764 + x_320765;
                
                defunc_2_reduce_res_320377 = defunc_1_op_res_320766;
            }
        }
    }
    
  cleanup:
    {
        free(reduce_stage_1_tid_res_arr_mem_320748);
        free(reduce_stage_1_tid_res_arr_mem_320750);
        free(reduce_stage_1_tid_res_arr_mem_320752);
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_task_337990_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_task_337990_end -
                 futhark_mc_segred_task_337990_start;
        
        ctx->futhark_mc_segred_task_337990_runs[tid]++;
        ctx->futhark_mc_segred_task_337990_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segred_task_337990_iter[tid] += iterations;
    }
    if (err == 0) {
        *futhark_mc_task_337989->retval_defunc_2_reduce_res_320375 =
            defunc_2_reduce_res_320375;
        *futhark_mc_task_337989->retval_defunc_2_reduce_res_320376 =
            defunc_2_reduce_res_320376;
        *futhark_mc_task_337989->retval_defunc_2_reduce_res_320377 =
            defunc_2_reduce_res_320377;
    }
    return err;
}
struct futhark_mc_task_337996 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_gtid_299244;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_313366;
    unsigned char *free_mem_313371;
    int64_t free_gtid_319915;
    int64_t free_x_319916;
    int64_t free_x_320363;
    double free_x_320364;
    double free_a11_320416;
    double free_b11_320418;
    double free_c11_320419;
    int64_t free_defunc_0_m_fun_res_320420;
    double *retval_defunc_2_reduce_res_320429;
    double *retval_defunc_2_reduce_res_320430;
};
struct futhark_mc_segred_stage_1_parloop_struct_338000 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_gtid_299244;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_313366;
    unsigned char *free_mem_313371;
    int64_t free_gtid_319915;
    int64_t free_x_319916;
    int64_t free_x_320363;
    double free_x_320364;
    double free_a11_320416;
    double free_b11_320418;
    double free_c11_320419;
    int64_t free_defunc_0_m_fun_res_320420;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_320769;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_320771;
};
static int futhark_mc_segred_stage_1_parloop_338001(void *args, int64_t start,
                                                    int64_t end,
                                                    int flat_tid_320707,
                                                    int tid)
{
    int err = 0;
    struct futhark_mc_segred_stage_1_parloop_struct_338000
    *futhark_mc_segred_stage_1_parloop_struct_338000 =
    (struct futhark_mc_segred_stage_1_parloop_struct_338000 *) args;
    struct futhark_context *ctx =
                           futhark_mc_segred_stage_1_parloop_struct_338000->ctx;
    uint64_t futhark_mc_segred_stage_1_parloop_338001_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_338001_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segred_stage_1_parloop_struct_338000->free_n_p_292677;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segred_stage_1_parloop_struct_338000->free_defunc_0_f_res_292820;
    int64_t gtid_299244 =
            futhark_mc_segred_stage_1_parloop_struct_338000->free_gtid_299244;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_338000->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_338000->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_338000->free_mem_313371,
                                  .size =0, .references =NULL};
    int64_t gtid_319915 =
            futhark_mc_segred_stage_1_parloop_struct_338000->free_gtid_319915;
    int64_t x_319916 =
            futhark_mc_segred_stage_1_parloop_struct_338000->free_x_319916;
    int64_t x_320363 =
            futhark_mc_segred_stage_1_parloop_struct_338000->free_x_320363;
    double x_320364 =
           futhark_mc_segred_stage_1_parloop_struct_338000->free_x_320364;
    double a11_320416 =
           futhark_mc_segred_stage_1_parloop_struct_338000->free_a11_320416;
    double b11_320418 =
           futhark_mc_segred_stage_1_parloop_struct_338000->free_b11_320418;
    double c11_320419 =
           futhark_mc_segred_stage_1_parloop_struct_338000->free_c11_320419;
    int64_t defunc_0_m_fun_res_320420 =
            futhark_mc_segred_stage_1_parloop_struct_338000->free_defunc_0_m_fun_res_320420;
    struct memblock reduce_stage_1_tid_res_arr_mem_320769 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_320769",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338000->free_reduce_stage_1_tid_res_arr_mem_320769,
                                                             .size =0,
                                                             .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_320771 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_320771",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338000->free_reduce_stage_1_tid_res_arr_mem_320771,
                                                             .size =0,
                                                             .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_320773 = start;
    double x_320709;
    double x_320710;
    double x_320712;
    double x_320713;
    double local_acc_320774 = 0.0;
    double local_acc_320775 = 0.0;
    
    for (; iter_320773 < end; iter_320773++) {
        int64_t gtid_320708 = iter_320773;
        bool cond_320715 = sle64(x_319916, gtid_320708);
        int64_t defunc_0_f_res_320716;
        
        if (cond_320715) {
            defunc_0_f_res_320716 = (int64_t) 0;
        } else {
            int64_t i_320717 = add64(x_320363, gtid_320708);
            int64_t defunc_0_add_arg_320718;
            
            defunc_0_add_arg_320718 = ((int64_t *) mem_312838.mem)[gtid_299244 *
                                                                   (defunc_0_f_res_292820 *
                                                                    n_p_292677) +
                                                                   gtid_319915 *
                                                                   defunc_0_f_res_292820 +
                                                                   i_320717];
            
            int64_t defunc_1_add_res_320719 = add64((int64_t) 1,
                                                    defunc_0_add_arg_320718);
            
            defunc_0_f_res_320716 = defunc_1_add_res_320719;
        }
        
        double defunc_0_f_res_320720;
        
        if (cond_320715) {
            defunc_0_f_res_320720 = 0.0;
        } else {
            int64_t i_320721 = add64(x_320363, gtid_320708);
            double defunc_0_add_arg_320722;
            
            defunc_0_add_arg_320722 = ((double *) mem_313371.mem)[gtid_299244 *
                                                                  (defunc_0_f_res_292820 *
                                                                   n_p_292677) +
                                                                  gtid_319915 *
                                                                  defunc_0_f_res_292820 +
                                                                  i_320721];
            defunc_0_f_res_320720 = defunc_0_add_arg_320722;
        }
        
        int64_t binop_p_320723 = sub64(defunc_0_f_res_320716,
                                       defunc_0_m_fun_res_320420);
        double defunc_0_f_res_320724 = sitofp_i64_f64(binop_p_320723);
        double abs_res_320725 = fabs(defunc_0_f_res_320724);
        double tmp1_320726 = abs_res_320725 / x_320364;
        double x_320727 = tmp1_320726 * tmp1_320726;
        double y_320728 = tmp1_320726 * x_320727;
        double tmp2_320729 = 1.0 - y_320728;
        double x_320730 = tmp2_320729 * tmp2_320729;
        double tmp3_320731 = tmp2_320729 * x_320730;
        double tmp4_320732 = defunc_0_f_res_320720 * tmp3_320731;
        double defunc_1_f_res_320733 = defunc_0_f_res_320724 * tmp4_320732;
        double defunc_0_f_res_320734;
        
        if (cond_320715) {
            defunc_0_f_res_320734 = 0.0;
        } else {
            int64_t i_320735 = add64(x_320363, gtid_320708);
            double defunc_0_add_arg_320736;
            
            defunc_0_add_arg_320736 = ((double *) mem_313366.mem)[gtid_299244 *
                                                                  (defunc_0_f_res_292820 *
                                                                   n_p_292677) +
                                                                  gtid_319915 *
                                                                  defunc_0_f_res_292820 +
                                                                  i_320735];
            defunc_0_f_res_320734 = defunc_0_add_arg_320736;
        }
        
        double x_320737 = a11_320416 * tmp4_320732;
        double y_320738 = b11_320418 * defunc_1_f_res_320733;
        double x_320739 = x_320737 + y_320738;
        double defunc_9_fit_fun_res_320740 = defunc_0_f_res_320734 * x_320739;
        double x_320741 = b11_320418 * tmp4_320732;
        double y_320742 = c11_320419 * defunc_1_f_res_320733;
        double x_320743 = x_320741 + y_320742;
        double defunc_9_slope_fun_res_320744 = defunc_0_f_res_320734 * x_320743;
        
        // save map-out results
        { }
        // Load accum params
        {
            x_320709 = local_acc_320774;
        }
        // Load next params
        {
            x_320710 = defunc_9_fit_fun_res_320740;
        }
        // Red body
        {
            double defunc_1_op_res_320711 = x_320709 + x_320710;
            
            local_acc_320774 = defunc_1_op_res_320711;
        }
        // Load accum params
        {
            x_320712 = local_acc_320775;
        }
        // Load next params
        {
            x_320713 = defunc_9_slope_fun_res_320744;
        }
        // Red body
        {
            double defunc_1_op_res_320714 = x_320712 + x_320713;
            
            local_acc_320775 = defunc_1_op_res_320714;
        }
    }
    ((double *) reduce_stage_1_tid_res_arr_mem_320769.mem)[flat_tid_320707] =
        local_acc_320774;
    ((double *) reduce_stage_1_tid_res_arr_mem_320771.mem)[flat_tid_320707] =
        local_acc_320775;
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_338001_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_338001_end -
                 futhark_mc_segred_stage_1_parloop_338001_start;
        
        ctx->futhark_mc_segred_stage_1_parloop_338001_runs[tid]++;
        ctx->futhark_mc_segred_stage_1_parloop_338001_total_runtime[tid] +=
            elapsed;
        ctx->futhark_mc_segred_stage_1_parloop_338001_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segred_task_337997(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_320707 = tid;
    int num_tasks_320768 = info.nsubtasks;
    struct futhark_mc_task_337996 *futhark_mc_task_337996 =
                                  (struct futhark_mc_task_337996 *) args;
    struct futhark_context *ctx = futhark_mc_task_337996->ctx;
    uint64_t futhark_mc_segred_task_337997_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_task_337997_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_337996->free_n_p_292677;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_337996->free_defunc_0_f_res_292820;
    int64_t gtid_299244 = futhark_mc_task_337996->free_gtid_299244;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_task_337996->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_task_337996->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_task_337996->free_mem_313371,
                                  .size =0, .references =NULL};
    int64_t gtid_319915 = futhark_mc_task_337996->free_gtid_319915;
    int64_t x_319916 = futhark_mc_task_337996->free_x_319916;
    int64_t x_320363 = futhark_mc_task_337996->free_x_320363;
    double x_320364 = futhark_mc_task_337996->free_x_320364;
    double a11_320416 = futhark_mc_task_337996->free_a11_320416;
    double b11_320418 = futhark_mc_task_337996->free_b11_320418;
    double c11_320419 = futhark_mc_task_337996->free_c11_320419;
    int64_t defunc_0_m_fun_res_320420 =
            futhark_mc_task_337996->free_defunc_0_m_fun_res_320420;
    double defunc_2_reduce_res_320429 =
           *futhark_mc_task_337996->retval_defunc_2_reduce_res_320429;
    double defunc_2_reduce_res_320430 =
           *futhark_mc_task_337996->retval_defunc_2_reduce_res_320430;
    size_t reduce_stage_1_tid_res_arr_mem_320769_cached_sizze_337998 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_320769 = NULL;
    size_t reduce_stage_1_tid_res_arr_mem_320771_cached_sizze_337999 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_320771 = NULL;
    
    if (reduce_stage_1_tid_res_arr_mem_320769_cached_sizze_337998 <
        (size_t) ((int64_t) 8 * num_tasks_320768)) {
        reduce_stage_1_tid_res_arr_mem_320769 =
            realloc(reduce_stage_1_tid_res_arr_mem_320769, (int64_t) 8 *
                    num_tasks_320768);
        reduce_stage_1_tid_res_arr_mem_320769_cached_sizze_337998 =
            (int64_t) 8 * num_tasks_320768;
    }
    if (reduce_stage_1_tid_res_arr_mem_320771_cached_sizze_337999 <
        (size_t) ((int64_t) 8 * num_tasks_320768)) {
        reduce_stage_1_tid_res_arr_mem_320771 =
            realloc(reduce_stage_1_tid_res_arr_mem_320771, (int64_t) 8 *
                    num_tasks_320768);
        reduce_stage_1_tid_res_arr_mem_320771_cached_sizze_337999 =
            (int64_t) 8 * num_tasks_320768;
    }
    
    int64_t iter_320773;
    struct futhark_mc_segred_stage_1_parloop_struct_338000
    futhark_mc_segred_stage_1_parloop_struct_338000;
    
    futhark_mc_segred_stage_1_parloop_struct_338000.ctx = ctx;
    futhark_mc_segred_stage_1_parloop_struct_338000.free_n_p_292677 =
        n_p_292677;
    futhark_mc_segred_stage_1_parloop_struct_338000.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segred_stage_1_parloop_struct_338000.free_gtid_299244 =
        gtid_299244;
    futhark_mc_segred_stage_1_parloop_struct_338000.free_mem_312838 =
        mem_312838.mem;
    futhark_mc_segred_stage_1_parloop_struct_338000.free_mem_313366 =
        mem_313366.mem;
    futhark_mc_segred_stage_1_parloop_struct_338000.free_mem_313371 =
        mem_313371.mem;
    futhark_mc_segred_stage_1_parloop_struct_338000.free_gtid_319915 =
        gtid_319915;
    futhark_mc_segred_stage_1_parloop_struct_338000.free_x_319916 = x_319916;
    futhark_mc_segred_stage_1_parloop_struct_338000.free_x_320363 = x_320363;
    futhark_mc_segred_stage_1_parloop_struct_338000.free_x_320364 = x_320364;
    futhark_mc_segred_stage_1_parloop_struct_338000.free_a11_320416 =
        a11_320416;
    futhark_mc_segred_stage_1_parloop_struct_338000.free_b11_320418 =
        b11_320418;
    futhark_mc_segred_stage_1_parloop_struct_338000.free_c11_320419 =
        c11_320419;
    futhark_mc_segred_stage_1_parloop_struct_338000.free_defunc_0_m_fun_res_320420 =
        defunc_0_m_fun_res_320420;
    futhark_mc_segred_stage_1_parloop_struct_338000.free_reduce_stage_1_tid_res_arr_mem_320769 =
        reduce_stage_1_tid_res_arr_mem_320769;
    futhark_mc_segred_stage_1_parloop_struct_338000.free_reduce_stage_1_tid_res_arr_mem_320771 =
        reduce_stage_1_tid_res_arr_mem_320771;
    
    struct scheduler_parloop futhark_mc_segred_stage_1_parloop_338001_task;
    
    futhark_mc_segred_stage_1_parloop_338001_task.name =
        "futhark_mc_segred_stage_1_parloop_338001";
    futhark_mc_segred_stage_1_parloop_338001_task.fn =
        futhark_mc_segred_stage_1_parloop_338001;
    futhark_mc_segred_stage_1_parloop_338001_task.args =
        &futhark_mc_segred_stage_1_parloop_struct_338000;
    futhark_mc_segred_stage_1_parloop_338001_task.iterations = iterations;
    futhark_mc_segred_stage_1_parloop_338001_task.info = info;
    
    uint64_t futhark_mc_segred_stage_1_parloop_338001_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_338001_total_start = get_wall_time();
    
    int futhark_mc_segred_stage_1_parloop_338001_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segred_stage_1_parloop_338001_task);
    
    if (futhark_mc_segred_stage_1_parloop_338001_err != 0) {
        err = futhark_mc_segred_stage_1_parloop_338001_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_338001_total_end =
                 get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_338001_total_end -
                 futhark_mc_segred_stage_1_parloop_338001_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338001_total_runs,
                           1, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338001_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338001_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    // neutral-initialise the output
    {
        defunc_2_reduce_res_320429 = 0.0;
        defunc_2_reduce_res_320430 = 0.0;
    }
    
    double x_320776;
    double x_320777;
    double x_320779;
    double x_320780;
    
    for (int32_t i_320782 = 0; i_320782 < num_tasks_320768; i_320782++) {
        flat_tid_320707 = i_320782;
        // Apply main thread reduction
        {
            // load acc params
            {
                x_320776 = defunc_2_reduce_res_320429;
            }
            // load next params
            {
                x_320777 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_320769)[flat_tid_320707];
            }
            // red body
            {
                double defunc_1_op_res_320778 = x_320776 + x_320777;
                
                defunc_2_reduce_res_320429 = defunc_1_op_res_320778;
            }
            // load acc params
            {
                x_320779 = defunc_2_reduce_res_320430;
            }
            // load next params
            {
                x_320780 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_320771)[flat_tid_320707];
            }
            // red body
            {
                double defunc_1_op_res_320781 = x_320779 + x_320780;
                
                defunc_2_reduce_res_320430 = defunc_1_op_res_320781;
            }
        }
    }
    
  cleanup:
    {
        free(reduce_stage_1_tid_res_arr_mem_320769);
        free(reduce_stage_1_tid_res_arr_mem_320771);
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_task_337997_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_task_337997_end -
                 futhark_mc_segred_task_337997_start;
        
        ctx->futhark_mc_segred_task_337997_runs[tid]++;
        ctx->futhark_mc_segred_task_337997_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segred_task_337997_iter[tid] += iterations;
    }
    if (err == 0) {
        *futhark_mc_task_337996->retval_defunc_2_reduce_res_320429 =
            defunc_2_reduce_res_320429;
        *futhark_mc_task_337996->retval_defunc_2_reduce_res_320430 =
            defunc_2_reduce_res_320430;
    }
    return err;
}
static int futhark_mc_segmap_parloop_337988(void *args, int64_t start,
                                            int64_t end, int flat_tid_320361,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_337987
    *futhark_mc_segmap_parloop_struct_337987 =
    (struct futhark_mc_segmap_parloop_struct_337987 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_337987->ctx;
    uint64_t futhark_mc_segmap_parloop_337988_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_337988_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segmap_parloop_struct_337987->free_n_p_292677;
    int64_t q_s_292678 =
            futhark_mc_segmap_parloop_struct_337987->free_q_s_292678;
    int64_t jump_s_292684 =
            futhark_mc_segmap_parloop_struct_337987->free_jump_s_292684;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segmap_parloop_struct_337987->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_segmap_parloop_struct_337987->free_pad_css_len_292821;
    int64_t s_n_m_292825 =
            futhark_mc_segmap_parloop_struct_337987->free_s_n_m_292825;
    int64_t gtid_299244 =
            futhark_mc_segmap_parloop_struct_337987->free_gtid_299244;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_segmap_parloop_struct_337987->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_segmap_parloop_struct_337987->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_segmap_parloop_struct_337987->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_segmap_parloop_struct_337987->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_segmap_parloop_struct_337987->free_mem_313371,
                                  .size =0, .references =NULL};
    int64_t gtid_319915 =
            futhark_mc_segmap_parloop_struct_337987->free_gtid_319915;
    int64_t x_319916 = futhark_mc_segmap_parloop_struct_337987->free_x_319916;
    struct memblock mem_319917 = {.desc ="mem_319917", .mem =
                                  futhark_mc_segmap_parloop_struct_337987->free_mem_319917,
                                  .size =0, .references =NULL};
    struct memblock mem_319918 = {.desc ="mem_319918", .mem =
                                  futhark_mc_segmap_parloop_struct_337987->free_mem_319918,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_320659 = start;
    
    for (; iter_320659 < end; iter_320659++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_320745 = s_n_m_292825;
        int64_t gtid_320362 = iter_320659;
        int64_t remnant_320746 = iter_320659 - gtid_320362;
        int64_t x_320363;
        
        x_320363 = ((int64_t *) mem_313018.mem)[gtid_299244 * (s_n_m_292825 *
                                                               n_p_292677) +
                                                gtid_319915 * s_n_m_292825 +
                                                gtid_320362];
        
        double x_320364;
        
        x_320364 = ((double *) mem_313023.mem)[gtid_299244 * (s_n_m_292825 *
                                                              n_p_292677) +
                                               gtid_319915 * s_n_m_292825 +
                                               gtid_320362];
        
        bool cond_320365 = gtid_320362 == (int64_t) 0;
        int64_t defunc_0_m_fun_res_320366;
        
        if (cond_320365) {
            defunc_0_m_fun_res_320366 = (int64_t) 0;
        } else {
            int64_t y_320660 = sub64(s_n_m_292825, (int64_t) 1);
            bool cond_320661 = gtid_320362 == y_320660;
            int64_t defunc_0_m_fun_res_f_res_320662;
            
            if (cond_320661) {
                int64_t defunc_0_m_fun_res_f_res_t_res_320663 =
                        sub64(pad_css_len_292821, (int64_t) 1);
                
                defunc_0_m_fun_res_f_res_320662 =
                    defunc_0_m_fun_res_f_res_t_res_320663;
            } else {
                int64_t x_320664 = sub64(gtid_320362, (int64_t) 1);
                int64_t x_320665 = mul64(jump_s_292684, x_320664);
                int64_t min_arg_320666 = add64((int64_t) 1, x_320665);
                int64_t min_res_320667 = smin64(defunc_0_f_res_292820,
                                                min_arg_320666);
                
                defunc_0_m_fun_res_f_res_320662 = min_res_320667;
            }
            defunc_0_m_fun_res_320366 = defunc_0_m_fun_res_f_res_320662;
        }
        
        double defunc_2_reduce_res_320375;
        double defunc_2_reduce_res_320376;
        double defunc_2_reduce_res_320377;
        int64_t flat_tid_320668 = (int64_t) 0;
        int32_t num_tasks_320747;
        
        defunc_2_reduce_res_320375 = 0.0;
        defunc_2_reduce_res_320376 = 0.0;
        defunc_2_reduce_res_320377 = 0.0;
        
        struct futhark_mc_task_337989 futhark_mc_task_337989;
        
        futhark_mc_task_337989.ctx = ctx;
        futhark_mc_task_337989.free_n_p_292677 = n_p_292677;
        futhark_mc_task_337989.free_defunc_0_f_res_292820 =
            defunc_0_f_res_292820;
        futhark_mc_task_337989.free_gtid_299244 = gtid_299244;
        futhark_mc_task_337989.free_mem_312838 = mem_312838.mem;
        futhark_mc_task_337989.free_mem_313371 = mem_313371.mem;
        futhark_mc_task_337989.free_gtid_319915 = gtid_319915;
        futhark_mc_task_337989.free_x_319916 = x_319916;
        futhark_mc_task_337989.free_x_320363 = x_320363;
        futhark_mc_task_337989.free_x_320364 = x_320364;
        futhark_mc_task_337989.free_defunc_0_m_fun_res_320366 =
            defunc_0_m_fun_res_320366;
        futhark_mc_task_337989.retval_defunc_2_reduce_res_320375 =
            &defunc_2_reduce_res_320375;
        futhark_mc_task_337989.retval_defunc_2_reduce_res_320376 =
            &defunc_2_reduce_res_320376;
        futhark_mc_task_337989.retval_defunc_2_reduce_res_320377 =
            &defunc_2_reduce_res_320377;
        
        struct scheduler_segop futhark_mc_task_337989_task;
        
        futhark_mc_task_337989_task.args = &futhark_mc_task_337989;
        futhark_mc_task_337989_task.top_level_fn =
            futhark_mc_segred_task_337990;
        futhark_mc_task_337989_task.name = "futhark_mc_segred_task_337990";
        futhark_mc_task_337989_task.iterations = q_s_292678;
        futhark_mc_task_337989_task.task_time =
            &ctx->futhark_mc_segred_task_337990_total_time;
        futhark_mc_task_337989_task.task_iter =
            &ctx->futhark_mc_segred_task_337990_total_iter;
        futhark_mc_task_337989_task.sched = STATIC;
        futhark_mc_task_337989_task.nested_fn = NULL;
        
        int futhark_mc_segred_task_337990_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_337989_task);
        
        if (futhark_mc_segred_task_337990_err != 0) {
            ;
            err = futhark_mc_segred_task_337990_err;
            goto cleanup;
        }
        
        double a_320409 = 2.220446049250313e-16 + defunc_2_reduce_res_320375;
        double b_320410 = 2.220446049250313e-16 + defunc_2_reduce_res_320376;
        double c_320411 = 2.220446049250313e-16 + defunc_2_reduce_res_320377;
        double x_320412 = a_320409 * c_320411;
        double y_320413 = b_320410 * b_320410;
        double y_320414 = x_320412 - y_320413;
        double det1_320415 = 1.0 / y_320414;
        double a11_320416 = c_320411 * det1_320415;
        double x_320417 = 0.0 - b_320410;
        double b11_320418 = det1_320415 * x_320417;
        double c11_320419 = a_320409 * det1_320415;
        int64_t defunc_0_m_fun_res_320420;
        
        if (cond_320365) {
            defunc_0_m_fun_res_320420 = (int64_t) 0;
        } else {
            int64_t y_320699 = sub64(s_n_m_292825, (int64_t) 1);
            bool cond_320700 = gtid_320362 == y_320699;
            int64_t defunc_0_m_fun_res_f_res_320701;
            
            if (cond_320700) {
                int64_t defunc_0_m_fun_res_f_res_t_res_320702 =
                        sub64(pad_css_len_292821, (int64_t) 1);
                
                defunc_0_m_fun_res_f_res_320701 =
                    defunc_0_m_fun_res_f_res_t_res_320702;
            } else {
                int64_t x_320703 = sub64(gtid_320362, (int64_t) 1);
                int64_t x_320704 = mul64(jump_s_292684, x_320703);
                int64_t min_arg_320705 = add64((int64_t) 1, x_320704);
                int64_t min_res_320706 = smin64(defunc_0_f_res_292820,
                                                min_arg_320705);
                
                defunc_0_m_fun_res_f_res_320701 = min_res_320706;
            }
            defunc_0_m_fun_res_320420 = defunc_0_m_fun_res_f_res_320701;
        }
        
        double defunc_2_reduce_res_320429;
        double defunc_2_reduce_res_320430;
        int64_t flat_tid_320707 = (int64_t) 0;
        int32_t num_tasks_320768;
        
        defunc_2_reduce_res_320429 = 0.0;
        defunc_2_reduce_res_320430 = 0.0;
        
        struct futhark_mc_task_337996 futhark_mc_task_337996;
        
        futhark_mc_task_337996.ctx = ctx;
        futhark_mc_task_337996.free_n_p_292677 = n_p_292677;
        futhark_mc_task_337996.free_defunc_0_f_res_292820 =
            defunc_0_f_res_292820;
        futhark_mc_task_337996.free_gtid_299244 = gtid_299244;
        futhark_mc_task_337996.free_mem_312838 = mem_312838.mem;
        futhark_mc_task_337996.free_mem_313366 = mem_313366.mem;
        futhark_mc_task_337996.free_mem_313371 = mem_313371.mem;
        futhark_mc_task_337996.free_gtid_319915 = gtid_319915;
        futhark_mc_task_337996.free_x_319916 = x_319916;
        futhark_mc_task_337996.free_x_320363 = x_320363;
        futhark_mc_task_337996.free_x_320364 = x_320364;
        futhark_mc_task_337996.free_a11_320416 = a11_320416;
        futhark_mc_task_337996.free_b11_320418 = b11_320418;
        futhark_mc_task_337996.free_c11_320419 = c11_320419;
        futhark_mc_task_337996.free_defunc_0_m_fun_res_320420 =
            defunc_0_m_fun_res_320420;
        futhark_mc_task_337996.retval_defunc_2_reduce_res_320429 =
            &defunc_2_reduce_res_320429;
        futhark_mc_task_337996.retval_defunc_2_reduce_res_320430 =
            &defunc_2_reduce_res_320430;
        
        struct scheduler_segop futhark_mc_task_337996_task;
        
        futhark_mc_task_337996_task.args = &futhark_mc_task_337996;
        futhark_mc_task_337996_task.top_level_fn =
            futhark_mc_segred_task_337997;
        futhark_mc_task_337996_task.name = "futhark_mc_segred_task_337997";
        futhark_mc_task_337996_task.iterations = q_s_292678;
        futhark_mc_task_337996_task.task_time =
            &ctx->futhark_mc_segred_task_337997_total_time;
        futhark_mc_task_337996_task.task_iter =
            &ctx->futhark_mc_segred_task_337997_total_iter;
        futhark_mc_task_337996_task.sched = STATIC;
        futhark_mc_task_337996_task.nested_fn = NULL;
        
        int futhark_mc_segred_task_337997_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_337996_task);
        
        if (futhark_mc_segred_task_337997_err != 0) {
            ;
            err = futhark_mc_segred_task_337997_err;
            goto cleanup;
        }
        ((double *) mem_319917.mem)[gtid_320362] = defunc_2_reduce_res_320429;
        ((double *) mem_319918.mem)[gtid_320362] = defunc_2_reduce_res_320430;
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_337988_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_337988_end -
                 futhark_mc_segmap_parloop_337988_start;
        
        ctx->futhark_mc_segmap_parloop_337988_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_337988_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_337988_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_nested_task_337986(void *args, int64_t iterations,
                                         int tid, struct scheduler_info info)
{
    int err = 0;
    int flat_tid_320361 = tid;
    int num_tasks_320572 = info.nsubtasks;
    struct futhark_mc_task_337982 *futhark_mc_task_337982 =
                                  (struct futhark_mc_task_337982 *) args;
    struct futhark_context *ctx = futhark_mc_task_337982->ctx;
    uint64_t futhark_mc_segmap_nested_task_337986_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_nested_task_337986_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_337982->free_n_p_292677;
    int64_t q_s_292678 = futhark_mc_task_337982->free_q_s_292678;
    int64_t jump_s_292684 = futhark_mc_task_337982->free_jump_s_292684;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_337982->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_task_337982->free_pad_css_len_292821;
    int64_t s_n_m_292825 = futhark_mc_task_337982->free_s_n_m_292825;
    int64_t gtid_299244 = futhark_mc_task_337982->free_gtid_299244;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_task_337982->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_task_337982->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_task_337982->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_task_337982->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_task_337982->free_mem_313371,
                                  .size =0, .references =NULL};
    int64_t gtid_319915 = futhark_mc_task_337982->free_gtid_319915;
    int64_t x_319916 = futhark_mc_task_337982->free_x_319916;
    struct memblock mem_319917 = {.desc ="mem_319917", .mem =
                                  futhark_mc_task_337982->free_mem_319917,
                                  .size =0, .references =NULL};
    struct memblock mem_319918 = {.desc ="mem_319918", .mem =
                                  futhark_mc_task_337982->free_mem_319918,
                                  .size =0, .references =NULL};
    int64_t iter_320659;
    struct futhark_mc_segmap_parloop_struct_337987
    futhark_mc_segmap_parloop_struct_337987;
    
    futhark_mc_segmap_parloop_struct_337987.ctx = ctx;
    futhark_mc_segmap_parloop_struct_337987.free_n_p_292677 = n_p_292677;
    futhark_mc_segmap_parloop_struct_337987.free_q_s_292678 = q_s_292678;
    futhark_mc_segmap_parloop_struct_337987.free_jump_s_292684 = jump_s_292684;
    futhark_mc_segmap_parloop_struct_337987.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segmap_parloop_struct_337987.free_pad_css_len_292821 =
        pad_css_len_292821;
    futhark_mc_segmap_parloop_struct_337987.free_s_n_m_292825 = s_n_m_292825;
    futhark_mc_segmap_parloop_struct_337987.free_gtid_299244 = gtid_299244;
    futhark_mc_segmap_parloop_struct_337987.free_mem_312838 = mem_312838.mem;
    futhark_mc_segmap_parloop_struct_337987.free_mem_313018 = mem_313018.mem;
    futhark_mc_segmap_parloop_struct_337987.free_mem_313023 = mem_313023.mem;
    futhark_mc_segmap_parloop_struct_337987.free_mem_313366 = mem_313366.mem;
    futhark_mc_segmap_parloop_struct_337987.free_mem_313371 = mem_313371.mem;
    futhark_mc_segmap_parloop_struct_337987.free_gtid_319915 = gtid_319915;
    futhark_mc_segmap_parloop_struct_337987.free_x_319916 = x_319916;
    futhark_mc_segmap_parloop_struct_337987.free_mem_319917 = mem_319917.mem;
    futhark_mc_segmap_parloop_struct_337987.free_mem_319918 = mem_319918.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_337988_task;
    
    futhark_mc_segmap_parloop_337988_task.name =
        "futhark_mc_segmap_parloop_337988";
    futhark_mc_segmap_parloop_337988_task.fn = futhark_mc_segmap_parloop_337988;
    futhark_mc_segmap_parloop_337988_task.args =
        &futhark_mc_segmap_parloop_struct_337987;
    futhark_mc_segmap_parloop_337988_task.iterations = iterations;
    futhark_mc_segmap_parloop_337988_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_337988_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_337988_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_337988_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_337988_task);
    
    if (futhark_mc_segmap_parloop_337988_err != 0) {
        err = futhark_mc_segmap_parloop_337988_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_337988_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_337988_total_end -
                 futhark_mc_segmap_parloop_337988_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337988_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337988_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337988_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_nested_task_337986_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_nested_task_337986_end -
                 futhark_mc_segmap_nested_task_337986_start;
        
        ctx->futhark_mc_segmap_nested_task_337986_runs[tid]++;
        ctx->futhark_mc_segmap_nested_task_337986_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_nested_task_337986_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
static int futhark_mc_segmap_parloop_337979(void *args, int64_t start,
                                            int64_t end, int flat_tid_319914,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_337978
    *futhark_mc_segmap_parloop_struct_337978 =
    (struct futhark_mc_segmap_parloop_struct_337978 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_337978->ctx;
    uint64_t futhark_mc_segmap_parloop_337979_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_337979_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segmap_parloop_struct_337978->free_n_p_292677;
    int64_t q_s_292678 =
            futhark_mc_segmap_parloop_struct_337978->free_q_s_292678;
    int64_t jump_s_292684 =
            futhark_mc_segmap_parloop_struct_337978->free_jump_s_292684;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segmap_parloop_struct_337978->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_segmap_parloop_struct_337978->free_pad_css_len_292821;
    int64_t s_n_m_292825 =
            futhark_mc_segmap_parloop_struct_337978->free_s_n_m_292825;
    int64_t gtid_299244 =
            futhark_mc_segmap_parloop_struct_337978->free_gtid_299244;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_segmap_parloop_struct_337978->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_312842 = {.desc ="mem_312842", .mem =
                                  futhark_mc_segmap_parloop_struct_337978->free_mem_312842,
                                  .size =0, .references =NULL};
    int64_t bytes_312847 =
            futhark_mc_segmap_parloop_struct_337978->free_bytes_312847;
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_segmap_parloop_struct_337978->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_segmap_parloop_struct_337978->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_segmap_parloop_struct_337978->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_segmap_parloop_struct_337978->free_mem_313371,
                                  .size =0, .references =NULL};
    struct memblock mem_313490 = {.desc ="mem_313490", .mem =
                                  futhark_mc_segmap_parloop_struct_337978->free_mem_313490,
                                  .size =0, .references =NULL};
    struct memblock mem_313494 = {.desc ="mem_313494", .mem =
                                  futhark_mc_segmap_parloop_struct_337978->free_mem_313494,
                                  .size =0, .references =NULL};
    size_t mem_319917_cached_sizze_337980 = 0;
    unsigned char *mem_319917 = NULL;
    size_t mem_319918_cached_sizze_337981 = 0;
    unsigned char *mem_319918 = NULL;
    int64_t iterations = end - start;
    int64_t iter_320360 = start;
    
    if (mem_319917_cached_sizze_337980 < (size_t) bytes_312847) {
        mem_319917 = realloc(mem_319917, bytes_312847);
        mem_319917_cached_sizze_337980 = bytes_312847;
    }
    if (mem_319918_cached_sizze_337981 < (size_t) bytes_312847) {
        mem_319918 = realloc(mem_319918, bytes_312847);
        mem_319918_cached_sizze_337981 = bytes_312847;
    }
    for (; iter_320360 < end; iter_320360++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_320570 = n_p_292677;
        int64_t gtid_319915 = iter_320360;
        int64_t remnant_320571 = iter_320360 - gtid_319915;
        int64_t x_319916;
        
        x_319916 = ((int64_t *) mem_312842.mem)[gtid_299244 * n_p_292677 +
                                                gtid_319915];
        
        int64_t flat_tid_320469 = (int64_t) 0;
        int32_t num_tasks_320572;
        int64_t flat_tid_320361 = (int64_t) 0;
        struct futhark_mc_task_337982 futhark_mc_task_337982;
        
        futhark_mc_task_337982.ctx = ctx;
        futhark_mc_task_337982.free_n_p_292677 = n_p_292677;
        futhark_mc_task_337982.free_q_s_292678 = q_s_292678;
        futhark_mc_task_337982.free_jump_s_292684 = jump_s_292684;
        futhark_mc_task_337982.free_defunc_0_f_res_292820 =
            defunc_0_f_res_292820;
        futhark_mc_task_337982.free_pad_css_len_292821 = pad_css_len_292821;
        futhark_mc_task_337982.free_s_n_m_292825 = s_n_m_292825;
        futhark_mc_task_337982.free_gtid_299244 = gtid_299244;
        futhark_mc_task_337982.free_mem_312838 = mem_312838.mem;
        futhark_mc_task_337982.free_mem_313018 = mem_313018.mem;
        futhark_mc_task_337982.free_mem_313023 = mem_313023.mem;
        futhark_mc_task_337982.free_mem_313366 = mem_313366.mem;
        futhark_mc_task_337982.free_mem_313371 = mem_313371.mem;
        futhark_mc_task_337982.free_gtid_319915 = gtid_319915;
        futhark_mc_task_337982.free_x_319916 = x_319916;
        futhark_mc_task_337982.free_mem_319917 = mem_319917;
        futhark_mc_task_337982.free_mem_319918 = mem_319918;
        
        struct scheduler_segop futhark_mc_task_337982_task;
        
        futhark_mc_task_337982_task.args = &futhark_mc_task_337982;
        futhark_mc_task_337982_task.top_level_fn =
            futhark_mc_segmap_task_337983;
        futhark_mc_task_337982_task.name = "futhark_mc_segmap_task_337983";
        futhark_mc_task_337982_task.iterations = s_n_m_292825;
        futhark_mc_task_337982_task.task_time =
            &ctx->futhark_mc_segmap_task_337983_total_time;
        futhark_mc_task_337982_task.task_iter =
            &ctx->futhark_mc_segmap_task_337983_total_iter;
        futhark_mc_task_337982_task.sched = STATIC;
        futhark_mc_task_337982_task.nested_fn =
            futhark_mc_segmap_nested_task_337986;
        
        int futhark_mc_segmap_task_337983_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_337982_task);
        
        if (futhark_mc_segmap_task_337983_err != 0) {
            ;
            err = futhark_mc_segmap_task_337983_err;
            goto cleanup;
        }
        if (s_n_m_292825 * (int64_t) 8 > 0)
            memmove(mem_313490.mem + gtid_319915 * s_n_m_292825 * (int64_t) 8,
                    mem_319917 + (int64_t) 0, s_n_m_292825 * (int64_t) 8);
        if (s_n_m_292825 * (int64_t) 8 > 0)
            memmove(mem_313494.mem + gtid_319915 * s_n_m_292825 * (int64_t) 8,
                    mem_319918 + (int64_t) 0, s_n_m_292825 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_319917);
    free(mem_319918);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_337979_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_337979_end -
                 futhark_mc_segmap_parloop_337979_start;
        
        ctx->futhark_mc_segmap_parloop_337979_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_337979_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_337979_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_nested_task_337977(void *args, int64_t iterations,
                                         int tid, struct scheduler_info info)
{
    int err = 0;
    int flat_tid_319914 = tid;
    int num_tasks_320245 = info.nsubtasks;
    struct futhark_mc_task_337971 *futhark_mc_task_337971 =
                                  (struct futhark_mc_task_337971 *) args;
    struct futhark_context *ctx = futhark_mc_task_337971->ctx;
    uint64_t futhark_mc_segmap_nested_task_337977_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_nested_task_337977_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_337971->free_n_p_292677;
    int64_t q_s_292678 = futhark_mc_task_337971->free_q_s_292678;
    int64_t jump_s_292684 = futhark_mc_task_337971->free_jump_s_292684;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_337971->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_task_337971->free_pad_css_len_292821;
    int64_t s_n_m_292825 = futhark_mc_task_337971->free_s_n_m_292825;
    int64_t gtid_299244 = futhark_mc_task_337971->free_gtid_299244;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_task_337971->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_312842 = {.desc ="mem_312842", .mem =
                                  futhark_mc_task_337971->free_mem_312842,
                                  .size =0, .references =NULL};
    int64_t bytes_312847 = futhark_mc_task_337971->free_bytes_312847;
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_task_337971->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_task_337971->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_task_337971->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_task_337971->free_mem_313371,
                                  .size =0, .references =NULL};
    struct memblock mem_313490 = {.desc ="mem_313490", .mem =
                                  futhark_mc_task_337971->free_mem_313490,
                                  .size =0, .references =NULL};
    struct memblock mem_313494 = {.desc ="mem_313494", .mem =
                                  futhark_mc_task_337971->free_mem_313494,
                                  .size =0, .references =NULL};
    int64_t iter_320360;
    struct futhark_mc_segmap_parloop_struct_337978
    futhark_mc_segmap_parloop_struct_337978;
    
    futhark_mc_segmap_parloop_struct_337978.ctx = ctx;
    futhark_mc_segmap_parloop_struct_337978.free_n_p_292677 = n_p_292677;
    futhark_mc_segmap_parloop_struct_337978.free_q_s_292678 = q_s_292678;
    futhark_mc_segmap_parloop_struct_337978.free_jump_s_292684 = jump_s_292684;
    futhark_mc_segmap_parloop_struct_337978.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segmap_parloop_struct_337978.free_pad_css_len_292821 =
        pad_css_len_292821;
    futhark_mc_segmap_parloop_struct_337978.free_s_n_m_292825 = s_n_m_292825;
    futhark_mc_segmap_parloop_struct_337978.free_gtid_299244 = gtid_299244;
    futhark_mc_segmap_parloop_struct_337978.free_mem_312838 = mem_312838.mem;
    futhark_mc_segmap_parloop_struct_337978.free_mem_312842 = mem_312842.mem;
    futhark_mc_segmap_parloop_struct_337978.free_bytes_312847 = bytes_312847;
    futhark_mc_segmap_parloop_struct_337978.free_mem_313018 = mem_313018.mem;
    futhark_mc_segmap_parloop_struct_337978.free_mem_313023 = mem_313023.mem;
    futhark_mc_segmap_parloop_struct_337978.free_mem_313366 = mem_313366.mem;
    futhark_mc_segmap_parloop_struct_337978.free_mem_313371 = mem_313371.mem;
    futhark_mc_segmap_parloop_struct_337978.free_mem_313490 = mem_313490.mem;
    futhark_mc_segmap_parloop_struct_337978.free_mem_313494 = mem_313494.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_337979_task;
    
    futhark_mc_segmap_parloop_337979_task.name =
        "futhark_mc_segmap_parloop_337979";
    futhark_mc_segmap_parloop_337979_task.fn = futhark_mc_segmap_parloop_337979;
    futhark_mc_segmap_parloop_337979_task.args =
        &futhark_mc_segmap_parloop_struct_337978;
    futhark_mc_segmap_parloop_337979_task.iterations = iterations;
    futhark_mc_segmap_parloop_337979_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_337979_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_337979_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_337979_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_337979_task);
    
    if (futhark_mc_segmap_parloop_337979_err != 0) {
        err = futhark_mc_segmap_parloop_337979_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_337979_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_337979_total_end -
                 futhark_mc_segmap_parloop_337979_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337979_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337979_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337979_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_nested_task_337977_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_nested_task_337977_end -
                 futhark_mc_segmap_nested_task_337977_start;
        
        ctx->futhark_mc_segmap_nested_task_337977_runs[tid]++;
        ctx->futhark_mc_segmap_nested_task_337977_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_nested_task_337977_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
static int futhark_mc_segmap_parloop_337968(void *args, int64_t start,
                                            int64_t end, int flat_tid_299243,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_337967
    *futhark_mc_segmap_parloop_struct_337967 =
    (struct futhark_mc_segmap_parloop_struct_337967 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_337967->ctx;
    uint64_t futhark_mc_segmap_parloop_337968_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_337968_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segmap_parloop_struct_337967->free_n_p_292677;
    int64_t q_s_292678 =
            futhark_mc_segmap_parloop_struct_337967->free_q_s_292678;
    int64_t jump_s_292684 =
            futhark_mc_segmap_parloop_struct_337967->free_jump_s_292684;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_337967->free_partition_sizze_292766;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segmap_parloop_struct_337967->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_segmap_parloop_struct_337967->free_pad_css_len_292821;
    int64_t s_n_m_292825 =
            futhark_mc_segmap_parloop_struct_337967->free_s_n_m_292825;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_segmap_parloop_struct_337967->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_312842 = {.desc ="mem_312842", .mem =
                                  futhark_mc_segmap_parloop_struct_337967->free_mem_312842,
                                  .size =0, .references =NULL};
    int64_t bytes_312847 =
            futhark_mc_segmap_parloop_struct_337967->free_bytes_312847;
    int64_t bytes_312899 =
            futhark_mc_segmap_parloop_struct_337967->free_bytes_312899;
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_segmap_parloop_struct_337967->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_segmap_parloop_struct_337967->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_segmap_parloop_struct_337967->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_segmap_parloop_struct_337967->free_mem_313371,
                                  .size =0, .references =NULL};
    struct memblock mem_313593 = {.desc ="mem_313593", .mem =
                                  futhark_mc_segmap_parloop_struct_337967->free_mem_313593,
                                  .size =0, .references =NULL};
    struct memblock mem_313598 = {.desc ="mem_313598", .mem =
                                  futhark_mc_segmap_parloop_struct_337967->free_mem_313598,
                                  .size =0, .references =NULL};
    size_t mem_313490_cached_sizze_337969 = 0;
    unsigned char *mem_313490 = NULL;
    size_t mem_313494_cached_sizze_337970 = 0;
    unsigned char *mem_313494 = NULL;
    int64_t iterations = end - start;
    int64_t iter_319913 = start;
    
    if (mem_313490_cached_sizze_337969 < (size_t) bytes_312899) {
        mem_313490 = realloc(mem_313490, bytes_312899);
        mem_313490_cached_sizze_337969 = bytes_312899;
    }
    if (mem_313494_cached_sizze_337970 < (size_t) bytes_312899) {
        mem_313494 = realloc(mem_313494, bytes_312899);
        mem_313494_cached_sizze_337970 = bytes_312899;
    }
    for (; iter_319913 < end; iter_319913++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_320243 = partition_sizze_292766;
        int64_t gtid_299244 = iter_319913;
        int64_t remnant_320244 = iter_319913 - gtid_299244;
        int64_t flat_tid_320130 = (int64_t) 0;
        int32_t num_tasks_320245;
        int64_t flat_tid_319914 = (int64_t) 0;
        struct futhark_mc_task_337971 futhark_mc_task_337971;
        
        futhark_mc_task_337971.ctx = ctx;
        futhark_mc_task_337971.free_n_p_292677 = n_p_292677;
        futhark_mc_task_337971.free_q_s_292678 = q_s_292678;
        futhark_mc_task_337971.free_jump_s_292684 = jump_s_292684;
        futhark_mc_task_337971.free_defunc_0_f_res_292820 =
            defunc_0_f_res_292820;
        futhark_mc_task_337971.free_pad_css_len_292821 = pad_css_len_292821;
        futhark_mc_task_337971.free_s_n_m_292825 = s_n_m_292825;
        futhark_mc_task_337971.free_gtid_299244 = gtid_299244;
        futhark_mc_task_337971.free_mem_312838 = mem_312838.mem;
        futhark_mc_task_337971.free_mem_312842 = mem_312842.mem;
        futhark_mc_task_337971.free_bytes_312847 = bytes_312847;
        futhark_mc_task_337971.free_mem_313018 = mem_313018.mem;
        futhark_mc_task_337971.free_mem_313023 = mem_313023.mem;
        futhark_mc_task_337971.free_mem_313366 = mem_313366.mem;
        futhark_mc_task_337971.free_mem_313371 = mem_313371.mem;
        futhark_mc_task_337971.free_mem_313490 = mem_313490;
        futhark_mc_task_337971.free_mem_313494 = mem_313494;
        
        struct scheduler_segop futhark_mc_task_337971_task;
        
        futhark_mc_task_337971_task.args = &futhark_mc_task_337971;
        futhark_mc_task_337971_task.top_level_fn =
            futhark_mc_segmap_task_337972;
        futhark_mc_task_337971_task.name = "futhark_mc_segmap_task_337972";
        futhark_mc_task_337971_task.iterations = n_p_292677;
        futhark_mc_task_337971_task.task_time =
            &ctx->futhark_mc_segmap_task_337972_total_time;
        futhark_mc_task_337971_task.task_iter =
            &ctx->futhark_mc_segmap_task_337972_total_iter;
        futhark_mc_task_337971_task.sched = STATIC;
        futhark_mc_task_337971_task.nested_fn =
            futhark_mc_segmap_nested_task_337977;
        
        int futhark_mc_segmap_task_337972_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_337971_task);
        
        if (futhark_mc_segmap_task_337972_err != 0) {
            ;
            err = futhark_mc_segmap_task_337972_err;
            goto cleanup;
        }
        if (n_p_292677 * s_n_m_292825 * (int64_t) 8 > 0)
            memmove(mem_313593.mem + gtid_299244 * (s_n_m_292825 * n_p_292677) *
                    (int64_t) 8, mem_313490 + (int64_t) 0, n_p_292677 *
                    s_n_m_292825 * (int64_t) 8);
        if (n_p_292677 * s_n_m_292825 * (int64_t) 8 > 0)
            memmove(mem_313598.mem + gtid_299244 * (s_n_m_292825 * n_p_292677) *
                    (int64_t) 8, mem_313494 + (int64_t) 0, n_p_292677 *
                    s_n_m_292825 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_313490);
    free(mem_313494);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_337968_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_337968_end -
                 futhark_mc_segmap_parloop_337968_start;
        
        ctx->futhark_mc_segmap_parloop_337968_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_337968_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_337968_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_nested_task_337966(void *args, int64_t iterations,
                                         int tid, struct scheduler_info info)
{
    int err = 0;
    int flat_tid_299243 = tid;
    int num_tasks_319790 = info.nsubtasks;
    struct futhark_mc_task_337960 *futhark_mc_task_337960 =
                                  (struct futhark_mc_task_337960 *) args;
    struct futhark_context *ctx = futhark_mc_task_337960->ctx;
    uint64_t futhark_mc_segmap_nested_task_337966_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_nested_task_337966_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_337960->free_n_p_292677;
    int64_t q_s_292678 = futhark_mc_task_337960->free_q_s_292678;
    int64_t jump_s_292684 = futhark_mc_task_337960->free_jump_s_292684;
    int64_t partition_sizze_292766 =
            futhark_mc_task_337960->free_partition_sizze_292766;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_337960->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_task_337960->free_pad_css_len_292821;
    int64_t s_n_m_292825 = futhark_mc_task_337960->free_s_n_m_292825;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_task_337960->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_312842 = {.desc ="mem_312842", .mem =
                                  futhark_mc_task_337960->free_mem_312842,
                                  .size =0, .references =NULL};
    int64_t bytes_312847 = futhark_mc_task_337960->free_bytes_312847;
    int64_t bytes_312899 = futhark_mc_task_337960->free_bytes_312899;
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_task_337960->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_task_337960->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_task_337960->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_task_337960->free_mem_313371,
                                  .size =0, .references =NULL};
    struct memblock mem_313593 = {.desc ="mem_313593", .mem =
                                  futhark_mc_task_337960->free_mem_313593,
                                  .size =0, .references =NULL};
    struct memblock mem_313598 = {.desc ="mem_313598", .mem =
                                  futhark_mc_task_337960->free_mem_313598,
                                  .size =0, .references =NULL};
    int64_t iter_319913;
    struct futhark_mc_segmap_parloop_struct_337967
    futhark_mc_segmap_parloop_struct_337967;
    
    futhark_mc_segmap_parloop_struct_337967.ctx = ctx;
    futhark_mc_segmap_parloop_struct_337967.free_n_p_292677 = n_p_292677;
    futhark_mc_segmap_parloop_struct_337967.free_q_s_292678 = q_s_292678;
    futhark_mc_segmap_parloop_struct_337967.free_jump_s_292684 = jump_s_292684;
    futhark_mc_segmap_parloop_struct_337967.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_337967.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segmap_parloop_struct_337967.free_pad_css_len_292821 =
        pad_css_len_292821;
    futhark_mc_segmap_parloop_struct_337967.free_s_n_m_292825 = s_n_m_292825;
    futhark_mc_segmap_parloop_struct_337967.free_mem_312838 = mem_312838.mem;
    futhark_mc_segmap_parloop_struct_337967.free_mem_312842 = mem_312842.mem;
    futhark_mc_segmap_parloop_struct_337967.free_bytes_312847 = bytes_312847;
    futhark_mc_segmap_parloop_struct_337967.free_bytes_312899 = bytes_312899;
    futhark_mc_segmap_parloop_struct_337967.free_mem_313018 = mem_313018.mem;
    futhark_mc_segmap_parloop_struct_337967.free_mem_313023 = mem_313023.mem;
    futhark_mc_segmap_parloop_struct_337967.free_mem_313366 = mem_313366.mem;
    futhark_mc_segmap_parloop_struct_337967.free_mem_313371 = mem_313371.mem;
    futhark_mc_segmap_parloop_struct_337967.free_mem_313593 = mem_313593.mem;
    futhark_mc_segmap_parloop_struct_337967.free_mem_313598 = mem_313598.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_337968_task;
    
    futhark_mc_segmap_parloop_337968_task.name =
        "futhark_mc_segmap_parloop_337968";
    futhark_mc_segmap_parloop_337968_task.fn = futhark_mc_segmap_parloop_337968;
    futhark_mc_segmap_parloop_337968_task.args =
        &futhark_mc_segmap_parloop_struct_337967;
    futhark_mc_segmap_parloop_337968_task.iterations = iterations;
    futhark_mc_segmap_parloop_337968_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_337968_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_337968_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_337968_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_337968_task);
    
    if (futhark_mc_segmap_parloop_337968_err != 0) {
        err = futhark_mc_segmap_parloop_337968_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_337968_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_337968_total_end -
                 futhark_mc_segmap_parloop_337968_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337968_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337968_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_337968_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_nested_task_337966_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_nested_task_337966_end -
                 futhark_mc_segmap_nested_task_337966_start;
        
        ctx->futhark_mc_segmap_nested_task_337966_runs[tid]++;
        ctx->futhark_mc_segmap_nested_task_337966_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_nested_task_337966_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_task_338002 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_q_s_292678;
    int64_t free_jump_s_292684;
    int64_t free_partition_sizze_292766;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_312842;
    int64_t free_bytes_312847;
    int64_t free_bytes_312899;
    unsigned char *free_mem_313018;
    unsigned char *free_mem_313023;
    unsigned char *free_mem_313366;
    unsigned char *free_mem_313371;
    unsigned char *free_mem_313741;
    unsigned char *free_mem_313746;
};
struct futhark_mc_segmap_parloop_struct_338004 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_q_s_292678;
    int64_t free_jump_s_292684;
    int64_t free_partition_sizze_292766;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_312842;
    int64_t free_bytes_312899;
    unsigned char *free_mem_313018;
    unsigned char *free_mem_313023;
    unsigned char *free_mem_313366;
    unsigned char *free_mem_313371;
    unsigned char *free_mem_313741;
    unsigned char *free_mem_313746;
};
static int futhark_mc_segmap_parloop_338005(void *args, int64_t start,
                                            int64_t end, int flat_tid_299596,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338004
    *futhark_mc_segmap_parloop_struct_338004 =
    (struct futhark_mc_segmap_parloop_struct_338004 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338004->ctx;
    uint64_t futhark_mc_segmap_parloop_338005_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338005_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segmap_parloop_struct_338004->free_n_p_292677;
    int64_t q_s_292678 =
            futhark_mc_segmap_parloop_struct_338004->free_q_s_292678;
    int64_t jump_s_292684 =
            futhark_mc_segmap_parloop_struct_338004->free_jump_s_292684;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_338004->free_partition_sizze_292766;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segmap_parloop_struct_338004->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_segmap_parloop_struct_338004->free_pad_css_len_292821;
    int64_t s_n_m_292825 =
            futhark_mc_segmap_parloop_struct_338004->free_s_n_m_292825;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_segmap_parloop_struct_338004->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_312842 = {.desc ="mem_312842", .mem =
                                  futhark_mc_segmap_parloop_struct_338004->free_mem_312842,
                                  .size =0, .references =NULL};
    int64_t bytes_312899 =
            futhark_mc_segmap_parloop_struct_338004->free_bytes_312899;
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_segmap_parloop_struct_338004->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_segmap_parloop_struct_338004->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_segmap_parloop_struct_338004->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_segmap_parloop_struct_338004->free_mem_313371,
                                  .size =0, .references =NULL};
    struct memblock mem_313741 = {.desc ="mem_313741", .mem =
                                  futhark_mc_segmap_parloop_struct_338004->free_mem_313741,
                                  .size =0, .references =NULL};
    struct memblock mem_313746 = {.desc ="mem_313746", .mem =
                                  futhark_mc_segmap_parloop_struct_338004->free_mem_313746,
                                  .size =0, .references =NULL};
    size_t mem_313646_cached_sizze_338006 = 0;
    unsigned char *mem_313646 = NULL;
    size_t mem_313650_cached_sizze_338007 = 0;
    unsigned char *mem_313650 = NULL;
    int64_t iterations = end - start;
    int64_t iter_320784 = start;
    
    if (mem_313646_cached_sizze_338006 < (size_t) bytes_312899) {
        mem_313646 = realloc(mem_313646, bytes_312899);
        mem_313646_cached_sizze_338006 = bytes_312899;
    }
    if (mem_313650_cached_sizze_338007 < (size_t) bytes_312899) {
        mem_313650 = realloc(mem_313650, bytes_312899);
        mem_313650_cached_sizze_338007 = bytes_312899;
    }
    for (; iter_320784 < end; iter_320784++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_320927 = partition_sizze_292766;
        int64_t gtid_299597 = iter_320784;
        int64_t remnant_320928 = iter_320784 - gtid_299597;
        
        for (int64_t i_320785 = 0; i_320785 < n_p_292677; i_320785++) {
            int64_t x_320788;
            
            x_320788 = ((int64_t *) mem_312842.mem)[gtid_299597 * n_p_292677 +
                                                    i_320785];
            for (int64_t i_320791 = 0; i_320791 < s_n_m_292825; i_320791++) {
                int64_t x_320794;
                
                x_320794 = ((int64_t *) mem_313018.mem)[gtid_299597 *
                                                        (s_n_m_292825 *
                                                         n_p_292677) +
                                                        i_320785 *
                                                        s_n_m_292825 +
                                                        i_320791];
                
                double x_320795;
                
                x_320795 = ((double *) mem_313023.mem)[gtid_299597 *
                                                       (s_n_m_292825 *
                                                        n_p_292677) + i_320785 *
                                                       s_n_m_292825 + i_320791];
                
                bool cond_320796 = i_320791 == (int64_t) 0;
                int64_t defunc_0_m_fun_res_320797;
                
                if (cond_320796) {
                    defunc_0_m_fun_res_320797 = (int64_t) 0;
                } else {
                    int64_t y_320798 = sub64(s_n_m_292825, (int64_t) 1);
                    bool cond_320799 = i_320791 == y_320798;
                    int64_t defunc_0_m_fun_res_f_res_320800;
                    
                    if (cond_320799) {
                        int64_t defunc_0_m_fun_res_f_res_t_res_320801 =
                                sub64(pad_css_len_292821, (int64_t) 1);
                        
                        defunc_0_m_fun_res_f_res_320800 =
                            defunc_0_m_fun_res_f_res_t_res_320801;
                    } else {
                        int64_t x_320802 = sub64(i_320791, (int64_t) 1);
                        int64_t x_320803 = mul64(jump_s_292684, x_320802);
                        int64_t min_arg_320804 = add64((int64_t) 1, x_320803);
                        int64_t min_res_320805 = smin64(defunc_0_f_res_292820,
                                                        min_arg_320804);
                        
                        defunc_0_m_fun_res_f_res_320800 = min_res_320805;
                    }
                    defunc_0_m_fun_res_320797 = defunc_0_m_fun_res_f_res_320800;
                }
                
                double defunc_2_reduce_res_320806;
                double defunc_2_reduce_res_320807;
                double defunc_2_reduce_res_320808;
                double defunc_2_reduce_res_320809;
                double defunc_2_reduce_res_320810;
                double redout_320812;
                double redout_320813;
                double redout_320814;
                double redout_320815;
                double redout_320816;
                
                redout_320812 = 0.0;
                redout_320813 = 0.0;
                redout_320814 = 0.0;
                redout_320815 = 0.0;
                redout_320816 = 0.0;
                for (int64_t i_320811 = 0; i_320811 < q_s_292678; i_320811++) {
                    bool cond_320817 = sle64(x_320788, i_320811);
                    int64_t defunc_0_f_res_320818;
                    
                    if (cond_320817) {
                        defunc_0_f_res_320818 = (int64_t) 0;
                    } else {
                        int64_t i_320819 = add64(x_320794, i_320811);
                        int64_t defunc_0_add_arg_320820;
                        
                        defunc_0_add_arg_320820 =
                            ((int64_t *) mem_312838.mem)[gtid_299597 *
                                                         (defunc_0_f_res_292820 *
                                                          n_p_292677) +
                                                         i_320785 *
                                                         defunc_0_f_res_292820 +
                                                         i_320819];
                        
                        int64_t defunc_1_add_res_320821 = add64((int64_t) 1,
                                                                defunc_0_add_arg_320820);
                        
                        defunc_0_f_res_320818 = defunc_1_add_res_320821;
                    }
                    
                    double defunc_0_f_res_320822;
                    
                    if (cond_320817) {
                        defunc_0_f_res_320822 = 0.0;
                    } else {
                        int64_t i_320823 = add64(x_320794, i_320811);
                        double defunc_0_add_arg_320824;
                        
                        defunc_0_add_arg_320824 =
                            ((double *) mem_313371.mem)[gtid_299597 *
                                                        (defunc_0_f_res_292820 *
                                                         n_p_292677) +
                                                        i_320785 *
                                                        defunc_0_f_res_292820 +
                                                        i_320823];
                        defunc_0_f_res_320822 = defunc_0_add_arg_320824;
                    }
                    
                    int64_t binop_p_320825 = sub64(defunc_0_f_res_320818,
                                                   defunc_0_m_fun_res_320797);
                    double defunc_0_f_res_320826 =
                           sitofp_i64_f64(binop_p_320825);
                    double abs_res_320827 = fabs(defunc_0_f_res_320826);
                    double tmp1_320828 = abs_res_320827 / x_320795;
                    double x_320829 = tmp1_320828 * tmp1_320828;
                    double y_320830 = tmp1_320828 * x_320829;
                    double tmp2_320831 = 1.0 - y_320830;
                    double x_320832 = tmp2_320831 * tmp2_320831;
                    double tmp3_320833 = tmp2_320831 * x_320832;
                    double w_j_320834 = defunc_0_f_res_320822 * tmp3_320833;
                    double xw_j_320835 = defunc_0_f_res_320826 * w_j_320834;
                    double x2w_j_320836 = defunc_0_f_res_320826 * xw_j_320835;
                    double x3w_j_320837 = defunc_0_f_res_320826 * x2w_j_320836;
                    double x4w_j_320838 = defunc_0_f_res_320826 * x3w_j_320837;
                    double defunc_1_op_res_320839 = w_j_320834 + redout_320812;
                    double defunc_1_op_res_320840 = xw_j_320835 + redout_320813;
                    double defunc_1_op_res_320841 = x2w_j_320836 +
                           redout_320814;
                    double defunc_1_op_res_320842 = x3w_j_320837 +
                           redout_320815;
                    double defunc_1_op_res_320843 = x4w_j_320838 +
                           redout_320816;
                    double redout_tmp_320933 = defunc_1_op_res_320839;
                    double redout_tmp_320934 = defunc_1_op_res_320840;
                    double redout_tmp_320935 = defunc_1_op_res_320841;
                    double redout_tmp_320936 = defunc_1_op_res_320842;
                    double redout_tmp_320937 = defunc_1_op_res_320843;
                    
                    redout_320812 = redout_tmp_320933;
                    redout_320813 = redout_tmp_320934;
                    redout_320814 = redout_tmp_320935;
                    redout_320815 = redout_tmp_320936;
                    redout_320816 = redout_tmp_320937;
                }
                defunc_2_reduce_res_320806 = redout_320812;
                defunc_2_reduce_res_320807 = redout_320813;
                defunc_2_reduce_res_320808 = redout_320814;
                defunc_2_reduce_res_320809 = redout_320815;
                defunc_2_reduce_res_320810 = redout_320816;
                
                double a_320844 = 2.220446049250313e-16 +
                       defunc_2_reduce_res_320806;
                double b_320845 = 2.220446049250313e-16 +
                       defunc_2_reduce_res_320807;
                double c_320846 = 2.220446049250313e-16 +
                       defunc_2_reduce_res_320808;
                double d_320847 = 2.220446049250313e-16 +
                       defunc_2_reduce_res_320809;
                double e_320848 = 2.220446049250313e-16 +
                       defunc_2_reduce_res_320810;
                double x_320849 = c_320846 * e_320848;
                double y_320850 = d_320847 * d_320847;
                double a12_320851 = x_320849 - y_320850;
                double x_320852 = c_320846 * d_320847;
                double y_320853 = b_320845 * e_320848;
                double b12_320854 = x_320852 - y_320853;
                double x_320855 = b_320845 * d_320847;
                double y_320856 = c_320846 * c_320846;
                double c12_320857 = x_320855 - y_320856;
                double x_320858 = a_320844 * e_320848;
                double b2_320859 = x_320858 - y_320856;
                double x_320860 = b_320845 * c_320846;
                double y_320861 = a_320844 * d_320847;
                double c2_320862 = x_320860 - y_320861;
                double x_320863 = a_320844 * a12_320851;
                double y_320864 = b_320845 * b12_320854;
                double x_320865 = x_320863 + y_320864;
                double y_320866 = c_320846 * c12_320857;
                double y_320867 = x_320865 + y_320866;
                double det_320868 = 1.0 / y_320867;
                double a12_320869 = a12_320851 * det_320868;
                double b12_320870 = b12_320854 * det_320868;
                double c12_320871 = c12_320857 * det_320868;
                double b2_320872 = b2_320859 * det_320868;
                double c2_320873 = c2_320862 * det_320868;
                int64_t defunc_0_m_fun_res_320874;
                
                if (cond_320796) {
                    defunc_0_m_fun_res_320874 = (int64_t) 0;
                } else {
                    int64_t y_320875 = sub64(s_n_m_292825, (int64_t) 1);
                    bool cond_320876 = i_320791 == y_320875;
                    int64_t defunc_0_m_fun_res_f_res_320877;
                    
                    if (cond_320876) {
                        int64_t defunc_0_m_fun_res_f_res_t_res_320878 =
                                sub64(pad_css_len_292821, (int64_t) 1);
                        
                        defunc_0_m_fun_res_f_res_320877 =
                            defunc_0_m_fun_res_f_res_t_res_320878;
                    } else {
                        int64_t x_320879 = sub64(i_320791, (int64_t) 1);
                        int64_t x_320880 = mul64(jump_s_292684, x_320879);
                        int64_t min_arg_320881 = add64((int64_t) 1, x_320880);
                        int64_t min_res_320882 = smin64(defunc_0_f_res_292820,
                                                        min_arg_320881);
                        
                        defunc_0_m_fun_res_f_res_320877 = min_res_320882;
                    }
                    defunc_0_m_fun_res_320874 = defunc_0_m_fun_res_f_res_320877;
                }
                
                double defunc_2_reduce_res_320883;
                double defunc_2_reduce_res_320884;
                double redout_320886;
                double redout_320887;
                
                redout_320886 = 0.0;
                redout_320887 = 0.0;
                for (int64_t i_320885 = 0; i_320885 < q_s_292678; i_320885++) {
                    bool cond_320888 = sle64(x_320788, i_320885);
                    int64_t defunc_0_f_res_320889;
                    
                    if (cond_320888) {
                        defunc_0_f_res_320889 = (int64_t) 0;
                    } else {
                        int64_t i_320890 = add64(x_320794, i_320885);
                        int64_t defunc_0_add_arg_320891;
                        
                        defunc_0_add_arg_320891 =
                            ((int64_t *) mem_312838.mem)[gtid_299597 *
                                                         (defunc_0_f_res_292820 *
                                                          n_p_292677) +
                                                         i_320785 *
                                                         defunc_0_f_res_292820 +
                                                         i_320890];
                        
                        int64_t defunc_1_add_res_320892 = add64((int64_t) 1,
                                                                defunc_0_add_arg_320891);
                        
                        defunc_0_f_res_320889 = defunc_1_add_res_320892;
                    }
                    
                    double defunc_0_f_res_320893;
                    
                    if (cond_320888) {
                        defunc_0_f_res_320893 = 0.0;
                    } else {
                        int64_t i_320894 = add64(x_320794, i_320885);
                        double defunc_0_add_arg_320895;
                        
                        defunc_0_add_arg_320895 =
                            ((double *) mem_313371.mem)[gtid_299597 *
                                                        (defunc_0_f_res_292820 *
                                                         n_p_292677) +
                                                        i_320785 *
                                                        defunc_0_f_res_292820 +
                                                        i_320894];
                        defunc_0_f_res_320893 = defunc_0_add_arg_320895;
                    }
                    
                    int64_t binop_p_320896 = sub64(defunc_0_f_res_320889,
                                                   defunc_0_m_fun_res_320874);
                    double defunc_0_f_res_320897 =
                           sitofp_i64_f64(binop_p_320896);
                    double abs_res_320898 = fabs(defunc_0_f_res_320897);
                    double tmp1_320899 = abs_res_320898 / x_320795;
                    double x_320900 = tmp1_320899 * tmp1_320899;
                    double y_320901 = tmp1_320899 * x_320900;
                    double tmp2_320902 = 1.0 - y_320901;
                    double x_320903 = tmp2_320902 * tmp2_320902;
                    double tmp3_320904 = tmp2_320902 * x_320903;
                    double tmp4_320905 = defunc_0_f_res_320893 * tmp3_320904;
                    double defunc_1_f_res_320906 = defunc_0_f_res_320897 *
                           tmp4_320905;
                    double defunc_1_f_res_320907 = defunc_0_f_res_320897 *
                           defunc_1_f_res_320906;
                    double defunc_0_f_res_320908;
                    
                    if (cond_320888) {
                        defunc_0_f_res_320908 = 0.0;
                    } else {
                        int64_t i_320909 = add64(x_320794, i_320885);
                        double defunc_0_add_arg_320910;
                        
                        defunc_0_add_arg_320910 =
                            ((double *) mem_313366.mem)[gtid_299597 *
                                                        (defunc_0_f_res_292820 *
                                                         n_p_292677) +
                                                        i_320785 *
                                                        defunc_0_f_res_292820 +
                                                        i_320909];
                        defunc_0_f_res_320908 = defunc_0_add_arg_320910;
                    }
                    
                    double x_320911 = a12_320869 * tmp4_320905;
                    double y_320912 = b12_320870 * defunc_1_f_res_320906;
                    double x_320913 = x_320911 + y_320912;
                    double y_320914 = c12_320871 * defunc_1_f_res_320907;
                    double x_320915 = x_320913 + y_320914;
                    double defunc_9_fit_fun_res_320916 = defunc_0_f_res_320908 *
                           x_320915;
                    double x_320917 = b12_320870 * tmp4_320905;
                    double y_320918 = b2_320872 * defunc_1_f_res_320906;
                    double x_320919 = x_320917 + y_320918;
                    double y_320920 = c2_320873 * defunc_1_f_res_320907;
                    double x_320921 = x_320919 + y_320920;
                    double defunc_9_slope_fun_res_320922 =
                           defunc_0_f_res_320908 * x_320921;
                    double defunc_1_op_res_320923 =
                           defunc_9_fit_fun_res_320916 + redout_320886;
                    double defunc_1_op_res_320924 =
                           defunc_9_slope_fun_res_320922 + redout_320887;
                    double redout_tmp_320938 = defunc_1_op_res_320923;
                    double redout_tmp_320939 = defunc_1_op_res_320924;
                    
                    redout_320886 = redout_tmp_320938;
                    redout_320887 = redout_tmp_320939;
                }
                defunc_2_reduce_res_320883 = redout_320886;
                defunc_2_reduce_res_320884 = redout_320887;
                ((double *) mem_313646)[i_320785 * s_n_m_292825 + i_320791] =
                    defunc_2_reduce_res_320883;
                ((double *) mem_313650)[i_320785 * s_n_m_292825 + i_320791] =
                    defunc_2_reduce_res_320884;
            }
        }
        if (n_p_292677 * s_n_m_292825 * (int64_t) 8 > 0)
            memmove(mem_313741.mem + gtid_299597 * (s_n_m_292825 * n_p_292677) *
                    (int64_t) 8, mem_313646 + (int64_t) 0, n_p_292677 *
                    s_n_m_292825 * (int64_t) 8);
        if (n_p_292677 * s_n_m_292825 * (int64_t) 8 > 0)
            memmove(mem_313746.mem + gtid_299597 * (s_n_m_292825 * n_p_292677) *
                    (int64_t) 8, mem_313650 + (int64_t) 0, n_p_292677 *
                    s_n_m_292825 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_313646);
    free(mem_313650);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338005_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338005_end -
                 futhark_mc_segmap_parloop_338005_start;
        
        ctx->futhark_mc_segmap_parloop_338005_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338005_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338005_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_338003(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_299596 = tid;
    int num_tasks_320783 = info.nsubtasks;
    struct futhark_mc_task_338002 *futhark_mc_task_338002 =
                                  (struct futhark_mc_task_338002 *) args;
    struct futhark_context *ctx = futhark_mc_task_338002->ctx;
    uint64_t futhark_mc_segmap_task_338003_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_338003_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_338002->free_n_p_292677;
    int64_t q_s_292678 = futhark_mc_task_338002->free_q_s_292678;
    int64_t jump_s_292684 = futhark_mc_task_338002->free_jump_s_292684;
    int64_t partition_sizze_292766 =
            futhark_mc_task_338002->free_partition_sizze_292766;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_338002->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_task_338002->free_pad_css_len_292821;
    int64_t s_n_m_292825 = futhark_mc_task_338002->free_s_n_m_292825;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_task_338002->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_312842 = {.desc ="mem_312842", .mem =
                                  futhark_mc_task_338002->free_mem_312842,
                                  .size =0, .references =NULL};
    int64_t bytes_312847 = futhark_mc_task_338002->free_bytes_312847;
    int64_t bytes_312899 = futhark_mc_task_338002->free_bytes_312899;
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_task_338002->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_task_338002->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_task_338002->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_task_338002->free_mem_313371,
                                  .size =0, .references =NULL};
    struct memblock mem_313741 = {.desc ="mem_313741", .mem =
                                  futhark_mc_task_338002->free_mem_313741,
                                  .size =0, .references =NULL};
    struct memblock mem_313746 = {.desc ="mem_313746", .mem =
                                  futhark_mc_task_338002->free_mem_313746,
                                  .size =0, .references =NULL};
    int64_t iter_320784;
    struct futhark_mc_segmap_parloop_struct_338004
    futhark_mc_segmap_parloop_struct_338004;
    
    futhark_mc_segmap_parloop_struct_338004.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338004.free_n_p_292677 = n_p_292677;
    futhark_mc_segmap_parloop_struct_338004.free_q_s_292678 = q_s_292678;
    futhark_mc_segmap_parloop_struct_338004.free_jump_s_292684 = jump_s_292684;
    futhark_mc_segmap_parloop_struct_338004.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_338004.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segmap_parloop_struct_338004.free_pad_css_len_292821 =
        pad_css_len_292821;
    futhark_mc_segmap_parloop_struct_338004.free_s_n_m_292825 = s_n_m_292825;
    futhark_mc_segmap_parloop_struct_338004.free_mem_312838 = mem_312838.mem;
    futhark_mc_segmap_parloop_struct_338004.free_mem_312842 = mem_312842.mem;
    futhark_mc_segmap_parloop_struct_338004.free_bytes_312899 = bytes_312899;
    futhark_mc_segmap_parloop_struct_338004.free_mem_313018 = mem_313018.mem;
    futhark_mc_segmap_parloop_struct_338004.free_mem_313023 = mem_313023.mem;
    futhark_mc_segmap_parloop_struct_338004.free_mem_313366 = mem_313366.mem;
    futhark_mc_segmap_parloop_struct_338004.free_mem_313371 = mem_313371.mem;
    futhark_mc_segmap_parloop_struct_338004.free_mem_313741 = mem_313741.mem;
    futhark_mc_segmap_parloop_struct_338004.free_mem_313746 = mem_313746.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338005_task;
    
    futhark_mc_segmap_parloop_338005_task.name =
        "futhark_mc_segmap_parloop_338005";
    futhark_mc_segmap_parloop_338005_task.fn = futhark_mc_segmap_parloop_338005;
    futhark_mc_segmap_parloop_338005_task.args =
        &futhark_mc_segmap_parloop_struct_338004;
    futhark_mc_segmap_parloop_338005_task.iterations = iterations;
    futhark_mc_segmap_parloop_338005_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338005_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338005_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338005_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338005_task);
    
    if (futhark_mc_segmap_parloop_338005_err != 0) {
        err = futhark_mc_segmap_parloop_338005_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338005_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338005_total_end -
                 futhark_mc_segmap_parloop_338005_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338005_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338005_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338005_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_338003_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_338003_end -
                 futhark_mc_segmap_task_338003_start;
        
        ctx->futhark_mc_segmap_task_338003_runs[tid]++;
        ctx->futhark_mc_segmap_task_338003_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_338003_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_segmap_parloop_struct_338009 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_q_s_292678;
    int64_t free_jump_s_292684;
    int64_t free_partition_sizze_292766;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_312842;
    int64_t free_bytes_312847;
    int64_t free_bytes_312899;
    unsigned char *free_mem_313018;
    unsigned char *free_mem_313023;
    unsigned char *free_mem_313366;
    unsigned char *free_mem_313371;
    unsigned char *free_mem_313741;
    unsigned char *free_mem_313746;
};
struct futhark_mc_task_338013 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_q_s_292678;
    int64_t free_jump_s_292684;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    int64_t free_gtid_300054;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_312842;
    int64_t free_bytes_312847;
    unsigned char *free_mem_313018;
    unsigned char *free_mem_313023;
    unsigned char *free_mem_313366;
    unsigned char *free_mem_313371;
    unsigned char *free_mem_313638;
    unsigned char *free_mem_313642;
};
struct futhark_mc_segmap_parloop_struct_338015 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_q_s_292678;
    int64_t free_jump_s_292684;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    int64_t free_gtid_300054;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_312842;
    int64_t free_bytes_312847;
    unsigned char *free_mem_313018;
    unsigned char *free_mem_313023;
    unsigned char *free_mem_313366;
    unsigned char *free_mem_313371;
    unsigned char *free_mem_313638;
    unsigned char *free_mem_313642;
};
static int futhark_mc_segmap_parloop_338016(void *args, int64_t start,
                                            int64_t end, int flat_tid_321223,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338015
    *futhark_mc_segmap_parloop_struct_338015 =
    (struct futhark_mc_segmap_parloop_struct_338015 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338015->ctx;
    uint64_t futhark_mc_segmap_parloop_338016_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338016_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segmap_parloop_struct_338015->free_n_p_292677;
    int64_t q_s_292678 =
            futhark_mc_segmap_parloop_struct_338015->free_q_s_292678;
    int64_t jump_s_292684 =
            futhark_mc_segmap_parloop_struct_338015->free_jump_s_292684;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segmap_parloop_struct_338015->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_segmap_parloop_struct_338015->free_pad_css_len_292821;
    int64_t s_n_m_292825 =
            futhark_mc_segmap_parloop_struct_338015->free_s_n_m_292825;
    int64_t gtid_300054 =
            futhark_mc_segmap_parloop_struct_338015->free_gtid_300054;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_segmap_parloop_struct_338015->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_312842 = {.desc ="mem_312842", .mem =
                                  futhark_mc_segmap_parloop_struct_338015->free_mem_312842,
                                  .size =0, .references =NULL};
    int64_t bytes_312847 =
            futhark_mc_segmap_parloop_struct_338015->free_bytes_312847;
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_segmap_parloop_struct_338015->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_segmap_parloop_struct_338015->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_segmap_parloop_struct_338015->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_segmap_parloop_struct_338015->free_mem_313371,
                                  .size =0, .references =NULL};
    struct memblock mem_313638 = {.desc ="mem_313638", .mem =
                                  futhark_mc_segmap_parloop_struct_338015->free_mem_313638,
                                  .size =0, .references =NULL};
    struct memblock mem_313642 = {.desc ="mem_313642", .mem =
                                  futhark_mc_segmap_parloop_struct_338015->free_mem_313642,
                                  .size =0, .references =NULL};
    size_t mem_321226_cached_sizze_338017 = 0;
    unsigned char *mem_321226 = NULL;
    size_t mem_321228_cached_sizze_338018 = 0;
    unsigned char *mem_321228 = NULL;
    int64_t iterations = end - start;
    int64_t iter_321371 = start;
    
    if (mem_321226_cached_sizze_338017 < (size_t) bytes_312847) {
        mem_321226 = realloc(mem_321226, bytes_312847);
        mem_321226_cached_sizze_338017 = bytes_312847;
    }
    if (mem_321228_cached_sizze_338018 < (size_t) bytes_312847) {
        mem_321228 = realloc(mem_321228, bytes_312847);
        mem_321228_cached_sizze_338018 = bytes_312847;
    }
    for (; iter_321371 < end; iter_321371++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_321508 = n_p_292677;
        int64_t gtid_321224 = iter_321371;
        int64_t remnant_321509 = iter_321371 - gtid_321224;
        int64_t x_321225;
        
        x_321225 = ((int64_t *) mem_312842.mem)[gtid_300054 * n_p_292677 +
                                                gtid_321224];
        for (int64_t i_321372 = 0; i_321372 < s_n_m_292825; i_321372++) {
            int64_t x_321375;
            
            x_321375 = ((int64_t *) mem_313018.mem)[gtid_300054 *
                                                    (s_n_m_292825 *
                                                     n_p_292677) + gtid_321224 *
                                                    s_n_m_292825 + i_321372];
            
            double x_321376;
            
            x_321376 = ((double *) mem_313023.mem)[gtid_300054 * (s_n_m_292825 *
                                                                  n_p_292677) +
                                                   gtid_321224 * s_n_m_292825 +
                                                   i_321372];
            
            bool cond_321377 = i_321372 == (int64_t) 0;
            int64_t defunc_0_m_fun_res_321378;
            
            if (cond_321377) {
                defunc_0_m_fun_res_321378 = (int64_t) 0;
            } else {
                int64_t y_321379 = sub64(s_n_m_292825, (int64_t) 1);
                bool cond_321380 = i_321372 == y_321379;
                int64_t defunc_0_m_fun_res_f_res_321381;
                
                if (cond_321380) {
                    int64_t defunc_0_m_fun_res_f_res_t_res_321382 =
                            sub64(pad_css_len_292821, (int64_t) 1);
                    
                    defunc_0_m_fun_res_f_res_321381 =
                        defunc_0_m_fun_res_f_res_t_res_321382;
                } else {
                    int64_t x_321383 = sub64(i_321372, (int64_t) 1);
                    int64_t x_321384 = mul64(jump_s_292684, x_321383);
                    int64_t min_arg_321385 = add64((int64_t) 1, x_321384);
                    int64_t min_res_321386 = smin64(defunc_0_f_res_292820,
                                                    min_arg_321385);
                    
                    defunc_0_m_fun_res_f_res_321381 = min_res_321386;
                }
                defunc_0_m_fun_res_321378 = defunc_0_m_fun_res_f_res_321381;
            }
            
            double defunc_2_reduce_res_321387;
            double defunc_2_reduce_res_321388;
            double defunc_2_reduce_res_321389;
            double defunc_2_reduce_res_321390;
            double defunc_2_reduce_res_321391;
            double redout_321393;
            double redout_321394;
            double redout_321395;
            double redout_321396;
            double redout_321397;
            
            redout_321393 = 0.0;
            redout_321394 = 0.0;
            redout_321395 = 0.0;
            redout_321396 = 0.0;
            redout_321397 = 0.0;
            for (int64_t i_321392 = 0; i_321392 < q_s_292678; i_321392++) {
                bool cond_321398 = sle64(x_321225, i_321392);
                int64_t defunc_0_f_res_321399;
                
                if (cond_321398) {
                    defunc_0_f_res_321399 = (int64_t) 0;
                } else {
                    int64_t i_321400 = add64(x_321375, i_321392);
                    int64_t defunc_0_add_arg_321401;
                    
                    defunc_0_add_arg_321401 =
                        ((int64_t *) mem_312838.mem)[gtid_300054 *
                                                     (defunc_0_f_res_292820 *
                                                      n_p_292677) +
                                                     gtid_321224 *
                                                     defunc_0_f_res_292820 +
                                                     i_321400];
                    
                    int64_t defunc_1_add_res_321402 = add64((int64_t) 1,
                                                            defunc_0_add_arg_321401);
                    
                    defunc_0_f_res_321399 = defunc_1_add_res_321402;
                }
                
                double defunc_0_f_res_321403;
                
                if (cond_321398) {
                    defunc_0_f_res_321403 = 0.0;
                } else {
                    int64_t i_321404 = add64(x_321375, i_321392);
                    double defunc_0_add_arg_321405;
                    
                    defunc_0_add_arg_321405 =
                        ((double *) mem_313371.mem)[gtid_300054 *
                                                    (defunc_0_f_res_292820 *
                                                     n_p_292677) + gtid_321224 *
                                                    defunc_0_f_res_292820 +
                                                    i_321404];
                    defunc_0_f_res_321403 = defunc_0_add_arg_321405;
                }
                
                int64_t binop_p_321406 = sub64(defunc_0_f_res_321399,
                                               defunc_0_m_fun_res_321378);
                double defunc_0_f_res_321407 = sitofp_i64_f64(binop_p_321406);
                double abs_res_321408 = fabs(defunc_0_f_res_321407);
                double tmp1_321409 = abs_res_321408 / x_321376;
                double x_321410 = tmp1_321409 * tmp1_321409;
                double y_321411 = tmp1_321409 * x_321410;
                double tmp2_321412 = 1.0 - y_321411;
                double x_321413 = tmp2_321412 * tmp2_321412;
                double tmp3_321414 = tmp2_321412 * x_321413;
                double w_j_321415 = defunc_0_f_res_321403 * tmp3_321414;
                double xw_j_321416 = defunc_0_f_res_321407 * w_j_321415;
                double x2w_j_321417 = defunc_0_f_res_321407 * xw_j_321416;
                double x3w_j_321418 = defunc_0_f_res_321407 * x2w_j_321417;
                double x4w_j_321419 = defunc_0_f_res_321407 * x3w_j_321418;
                double defunc_1_op_res_321420 = w_j_321415 + redout_321393;
                double defunc_1_op_res_321421 = xw_j_321416 + redout_321394;
                double defunc_1_op_res_321422 = x2w_j_321417 + redout_321395;
                double defunc_1_op_res_321423 = x3w_j_321418 + redout_321396;
                double defunc_1_op_res_321424 = x4w_j_321419 + redout_321397;
                double redout_tmp_321512 = defunc_1_op_res_321420;
                double redout_tmp_321513 = defunc_1_op_res_321421;
                double redout_tmp_321514 = defunc_1_op_res_321422;
                double redout_tmp_321515 = defunc_1_op_res_321423;
                double redout_tmp_321516 = defunc_1_op_res_321424;
                
                redout_321393 = redout_tmp_321512;
                redout_321394 = redout_tmp_321513;
                redout_321395 = redout_tmp_321514;
                redout_321396 = redout_tmp_321515;
                redout_321397 = redout_tmp_321516;
            }
            defunc_2_reduce_res_321387 = redout_321393;
            defunc_2_reduce_res_321388 = redout_321394;
            defunc_2_reduce_res_321389 = redout_321395;
            defunc_2_reduce_res_321390 = redout_321396;
            defunc_2_reduce_res_321391 = redout_321397;
            
            double a_321425 = 2.220446049250313e-16 +
                   defunc_2_reduce_res_321387;
            double b_321426 = 2.220446049250313e-16 +
                   defunc_2_reduce_res_321388;
            double c_321427 = 2.220446049250313e-16 +
                   defunc_2_reduce_res_321389;
            double d_321428 = 2.220446049250313e-16 +
                   defunc_2_reduce_res_321390;
            double e_321429 = 2.220446049250313e-16 +
                   defunc_2_reduce_res_321391;
            double x_321430 = c_321427 * e_321429;
            double y_321431 = d_321428 * d_321428;
            double a12_321432 = x_321430 - y_321431;
            double x_321433 = c_321427 * d_321428;
            double y_321434 = b_321426 * e_321429;
            double b12_321435 = x_321433 - y_321434;
            double x_321436 = b_321426 * d_321428;
            double y_321437 = c_321427 * c_321427;
            double c12_321438 = x_321436 - y_321437;
            double x_321439 = a_321425 * e_321429;
            double b2_321440 = x_321439 - y_321437;
            double x_321441 = b_321426 * c_321427;
            double y_321442 = a_321425 * d_321428;
            double c2_321443 = x_321441 - y_321442;
            double x_321444 = a_321425 * a12_321432;
            double y_321445 = b_321426 * b12_321435;
            double x_321446 = x_321444 + y_321445;
            double y_321447 = c_321427 * c12_321438;
            double y_321448 = x_321446 + y_321447;
            double det_321449 = 1.0 / y_321448;
            double a12_321450 = a12_321432 * det_321449;
            double b12_321451 = b12_321435 * det_321449;
            double c12_321452 = c12_321438 * det_321449;
            double b2_321453 = b2_321440 * det_321449;
            double c2_321454 = c2_321443 * det_321449;
            int64_t defunc_0_m_fun_res_321455;
            
            if (cond_321377) {
                defunc_0_m_fun_res_321455 = (int64_t) 0;
            } else {
                int64_t y_321456 = sub64(s_n_m_292825, (int64_t) 1);
                bool cond_321457 = i_321372 == y_321456;
                int64_t defunc_0_m_fun_res_f_res_321458;
                
                if (cond_321457) {
                    int64_t defunc_0_m_fun_res_f_res_t_res_321459 =
                            sub64(pad_css_len_292821, (int64_t) 1);
                    
                    defunc_0_m_fun_res_f_res_321458 =
                        defunc_0_m_fun_res_f_res_t_res_321459;
                } else {
                    int64_t x_321460 = sub64(i_321372, (int64_t) 1);
                    int64_t x_321461 = mul64(jump_s_292684, x_321460);
                    int64_t min_arg_321462 = add64((int64_t) 1, x_321461);
                    int64_t min_res_321463 = smin64(defunc_0_f_res_292820,
                                                    min_arg_321462);
                    
                    defunc_0_m_fun_res_f_res_321458 = min_res_321463;
                }
                defunc_0_m_fun_res_321455 = defunc_0_m_fun_res_f_res_321458;
            }
            
            double defunc_2_reduce_res_321464;
            double defunc_2_reduce_res_321465;
            double redout_321467;
            double redout_321468;
            
            redout_321467 = 0.0;
            redout_321468 = 0.0;
            for (int64_t i_321466 = 0; i_321466 < q_s_292678; i_321466++) {
                bool cond_321469 = sle64(x_321225, i_321466);
                int64_t defunc_0_f_res_321470;
                
                if (cond_321469) {
                    defunc_0_f_res_321470 = (int64_t) 0;
                } else {
                    int64_t i_321471 = add64(x_321375, i_321466);
                    int64_t defunc_0_add_arg_321472;
                    
                    defunc_0_add_arg_321472 =
                        ((int64_t *) mem_312838.mem)[gtid_300054 *
                                                     (defunc_0_f_res_292820 *
                                                      n_p_292677) +
                                                     gtid_321224 *
                                                     defunc_0_f_res_292820 +
                                                     i_321471];
                    
                    int64_t defunc_1_add_res_321473 = add64((int64_t) 1,
                                                            defunc_0_add_arg_321472);
                    
                    defunc_0_f_res_321470 = defunc_1_add_res_321473;
                }
                
                double defunc_0_f_res_321474;
                
                if (cond_321469) {
                    defunc_0_f_res_321474 = 0.0;
                } else {
                    int64_t i_321475 = add64(x_321375, i_321466);
                    double defunc_0_add_arg_321476;
                    
                    defunc_0_add_arg_321476 =
                        ((double *) mem_313371.mem)[gtid_300054 *
                                                    (defunc_0_f_res_292820 *
                                                     n_p_292677) + gtid_321224 *
                                                    defunc_0_f_res_292820 +
                                                    i_321475];
                    defunc_0_f_res_321474 = defunc_0_add_arg_321476;
                }
                
                int64_t binop_p_321477 = sub64(defunc_0_f_res_321470,
                                               defunc_0_m_fun_res_321455);
                double defunc_0_f_res_321478 = sitofp_i64_f64(binop_p_321477);
                double abs_res_321479 = fabs(defunc_0_f_res_321478);
                double tmp1_321480 = abs_res_321479 / x_321376;
                double x_321481 = tmp1_321480 * tmp1_321480;
                double y_321482 = tmp1_321480 * x_321481;
                double tmp2_321483 = 1.0 - y_321482;
                double x_321484 = tmp2_321483 * tmp2_321483;
                double tmp3_321485 = tmp2_321483 * x_321484;
                double tmp4_321486 = defunc_0_f_res_321474 * tmp3_321485;
                double defunc_1_f_res_321487 = defunc_0_f_res_321478 *
                       tmp4_321486;
                double defunc_1_f_res_321488 = defunc_0_f_res_321478 *
                       defunc_1_f_res_321487;
                double defunc_0_f_res_321489;
                
                if (cond_321469) {
                    defunc_0_f_res_321489 = 0.0;
                } else {
                    int64_t i_321490 = add64(x_321375, i_321466);
                    double defunc_0_add_arg_321491;
                    
                    defunc_0_add_arg_321491 =
                        ((double *) mem_313366.mem)[gtid_300054 *
                                                    (defunc_0_f_res_292820 *
                                                     n_p_292677) + gtid_321224 *
                                                    defunc_0_f_res_292820 +
                                                    i_321490];
                    defunc_0_f_res_321489 = defunc_0_add_arg_321491;
                }
                
                double x_321492 = a12_321450 * tmp4_321486;
                double y_321493 = b12_321451 * defunc_1_f_res_321487;
                double x_321494 = x_321492 + y_321493;
                double y_321495 = c12_321452 * defunc_1_f_res_321488;
                double x_321496 = x_321494 + y_321495;
                double defunc_9_fit_fun_res_321497 = defunc_0_f_res_321489 *
                       x_321496;
                double x_321498 = b12_321451 * tmp4_321486;
                double y_321499 = b2_321453 * defunc_1_f_res_321487;
                double x_321500 = x_321498 + y_321499;
                double y_321501 = c2_321454 * defunc_1_f_res_321488;
                double x_321502 = x_321500 + y_321501;
                double defunc_9_slope_fun_res_321503 = defunc_0_f_res_321489 *
                       x_321502;
                double defunc_1_op_res_321504 = defunc_9_fit_fun_res_321497 +
                       redout_321467;
                double defunc_1_op_res_321505 = defunc_9_slope_fun_res_321503 +
                       redout_321468;
                double redout_tmp_321517 = defunc_1_op_res_321504;
                double redout_tmp_321518 = defunc_1_op_res_321505;
                
                redout_321467 = redout_tmp_321517;
                redout_321468 = redout_tmp_321518;
            }
            defunc_2_reduce_res_321464 = redout_321467;
            defunc_2_reduce_res_321465 = redout_321468;
            ((double *) mem_321226)[i_321372] = defunc_2_reduce_res_321464;
            ((double *) mem_321228)[i_321372] = defunc_2_reduce_res_321465;
        }
        if (s_n_m_292825 * (int64_t) 8 > 0)
            memmove(mem_313638.mem + gtid_321224 * s_n_m_292825 * (int64_t) 8,
                    mem_321226 + (int64_t) 0, s_n_m_292825 * (int64_t) 8);
        if (s_n_m_292825 * (int64_t) 8 > 0)
            memmove(mem_313642.mem + gtid_321224 * s_n_m_292825 * (int64_t) 8,
                    mem_321228 + (int64_t) 0, s_n_m_292825 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_321226);
    free(mem_321228);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338016_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338016_end -
                 futhark_mc_segmap_parloop_338016_start;
        
        ctx->futhark_mc_segmap_parloop_338016_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338016_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338016_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_338014(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_321223 = tid;
    int num_tasks_321370 = info.nsubtasks;
    struct futhark_mc_task_338013 *futhark_mc_task_338013 =
                                  (struct futhark_mc_task_338013 *) args;
    struct futhark_context *ctx = futhark_mc_task_338013->ctx;
    uint64_t futhark_mc_segmap_task_338014_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_338014_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_338013->free_n_p_292677;
    int64_t q_s_292678 = futhark_mc_task_338013->free_q_s_292678;
    int64_t jump_s_292684 = futhark_mc_task_338013->free_jump_s_292684;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_338013->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_task_338013->free_pad_css_len_292821;
    int64_t s_n_m_292825 = futhark_mc_task_338013->free_s_n_m_292825;
    int64_t gtid_300054 = futhark_mc_task_338013->free_gtid_300054;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_task_338013->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_312842 = {.desc ="mem_312842", .mem =
                                  futhark_mc_task_338013->free_mem_312842,
                                  .size =0, .references =NULL};
    int64_t bytes_312847 = futhark_mc_task_338013->free_bytes_312847;
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_task_338013->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_task_338013->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_task_338013->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_task_338013->free_mem_313371,
                                  .size =0, .references =NULL};
    struct memblock mem_313638 = {.desc ="mem_313638", .mem =
                                  futhark_mc_task_338013->free_mem_313638,
                                  .size =0, .references =NULL};
    struct memblock mem_313642 = {.desc ="mem_313642", .mem =
                                  futhark_mc_task_338013->free_mem_313642,
                                  .size =0, .references =NULL};
    int64_t iter_321371;
    struct futhark_mc_segmap_parloop_struct_338015
    futhark_mc_segmap_parloop_struct_338015;
    
    futhark_mc_segmap_parloop_struct_338015.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338015.free_n_p_292677 = n_p_292677;
    futhark_mc_segmap_parloop_struct_338015.free_q_s_292678 = q_s_292678;
    futhark_mc_segmap_parloop_struct_338015.free_jump_s_292684 = jump_s_292684;
    futhark_mc_segmap_parloop_struct_338015.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segmap_parloop_struct_338015.free_pad_css_len_292821 =
        pad_css_len_292821;
    futhark_mc_segmap_parloop_struct_338015.free_s_n_m_292825 = s_n_m_292825;
    futhark_mc_segmap_parloop_struct_338015.free_gtid_300054 = gtid_300054;
    futhark_mc_segmap_parloop_struct_338015.free_mem_312838 = mem_312838.mem;
    futhark_mc_segmap_parloop_struct_338015.free_mem_312842 = mem_312842.mem;
    futhark_mc_segmap_parloop_struct_338015.free_bytes_312847 = bytes_312847;
    futhark_mc_segmap_parloop_struct_338015.free_mem_313018 = mem_313018.mem;
    futhark_mc_segmap_parloop_struct_338015.free_mem_313023 = mem_313023.mem;
    futhark_mc_segmap_parloop_struct_338015.free_mem_313366 = mem_313366.mem;
    futhark_mc_segmap_parloop_struct_338015.free_mem_313371 = mem_313371.mem;
    futhark_mc_segmap_parloop_struct_338015.free_mem_313638 = mem_313638.mem;
    futhark_mc_segmap_parloop_struct_338015.free_mem_313642 = mem_313642.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338016_task;
    
    futhark_mc_segmap_parloop_338016_task.name =
        "futhark_mc_segmap_parloop_338016";
    futhark_mc_segmap_parloop_338016_task.fn = futhark_mc_segmap_parloop_338016;
    futhark_mc_segmap_parloop_338016_task.args =
        &futhark_mc_segmap_parloop_struct_338015;
    futhark_mc_segmap_parloop_338016_task.iterations = iterations;
    futhark_mc_segmap_parloop_338016_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338016_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338016_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338016_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338016_task);
    
    if (futhark_mc_segmap_parloop_338016_err != 0) {
        err = futhark_mc_segmap_parloop_338016_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338016_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338016_total_end -
                 futhark_mc_segmap_parloop_338016_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338016_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338016_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338016_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_338014_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_338014_end -
                 futhark_mc_segmap_task_338014_start;
        
        ctx->futhark_mc_segmap_task_338014_runs[tid]++;
        ctx->futhark_mc_segmap_task_338014_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_338014_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_segmap_parloop_struct_338020 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_q_s_292678;
    int64_t free_jump_s_292684;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    int64_t free_gtid_300054;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_312842;
    int64_t free_bytes_312847;
    unsigned char *free_mem_313018;
    unsigned char *free_mem_313023;
    unsigned char *free_mem_313366;
    unsigned char *free_mem_313371;
    unsigned char *free_mem_313638;
    unsigned char *free_mem_313642;
};
struct futhark_mc_task_338024 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_q_s_292678;
    int64_t free_jump_s_292684;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    int64_t free_gtid_300054;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_313018;
    unsigned char *free_mem_313023;
    unsigned char *free_mem_313366;
    unsigned char *free_mem_313371;
    int64_t free_gtid_320942;
    int64_t free_x_320943;
    unsigned char *free_mem_320944;
    unsigned char *free_mem_320945;
};
struct futhark_mc_segmap_parloop_struct_338026 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_q_s_292678;
    int64_t free_jump_s_292684;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    int64_t free_gtid_300054;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_313018;
    unsigned char *free_mem_313023;
    unsigned char *free_mem_313366;
    unsigned char *free_mem_313371;
    int64_t free_gtid_320942;
    int64_t free_x_320943;
    unsigned char *free_mem_320944;
    unsigned char *free_mem_320945;
};
static int futhark_mc_segmap_parloop_338027(void *args, int64_t start,
                                            int64_t end, int flat_tid_321662,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338026
    *futhark_mc_segmap_parloop_struct_338026 =
    (struct futhark_mc_segmap_parloop_struct_338026 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338026->ctx;
    uint64_t futhark_mc_segmap_parloop_338027_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338027_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segmap_parloop_struct_338026->free_n_p_292677;
    int64_t q_s_292678 =
            futhark_mc_segmap_parloop_struct_338026->free_q_s_292678;
    int64_t jump_s_292684 =
            futhark_mc_segmap_parloop_struct_338026->free_jump_s_292684;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segmap_parloop_struct_338026->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_segmap_parloop_struct_338026->free_pad_css_len_292821;
    int64_t s_n_m_292825 =
            futhark_mc_segmap_parloop_struct_338026->free_s_n_m_292825;
    int64_t gtid_300054 =
            futhark_mc_segmap_parloop_struct_338026->free_gtid_300054;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_segmap_parloop_struct_338026->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_segmap_parloop_struct_338026->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_segmap_parloop_struct_338026->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_segmap_parloop_struct_338026->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_segmap_parloop_struct_338026->free_mem_313371,
                                  .size =0, .references =NULL};
    int64_t gtid_320942 =
            futhark_mc_segmap_parloop_struct_338026->free_gtid_320942;
    int64_t x_320943 = futhark_mc_segmap_parloop_struct_338026->free_x_320943;
    struct memblock mem_320944 = {.desc ="mem_320944", .mem =
                                  futhark_mc_segmap_parloop_struct_338026->free_mem_320944,
                                  .size =0, .references =NULL};
    struct memblock mem_320945 = {.desc ="mem_320945", .mem =
                                  futhark_mc_segmap_parloop_struct_338026->free_mem_320945,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_321798 = start;
    
    for (; iter_321798 < end; iter_321798++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_321888 = s_n_m_292825;
        int64_t gtid_321663 = iter_321798;
        int64_t remnant_321889 = iter_321798 - gtid_321663;
        int64_t x_321664;
        
        x_321664 = ((int64_t *) mem_313018.mem)[gtid_300054 * (s_n_m_292825 *
                                                               n_p_292677) +
                                                gtid_320942 * s_n_m_292825 +
                                                gtid_321663];
        
        double x_321665;
        
        x_321665 = ((double *) mem_313023.mem)[gtid_300054 * (s_n_m_292825 *
                                                              n_p_292677) +
                                               gtid_320942 * s_n_m_292825 +
                                               gtid_321663];
        
        bool cond_321666 = gtid_321663 == (int64_t) 0;
        int64_t defunc_0_m_fun_res_321667;
        
        if (cond_321666) {
            defunc_0_m_fun_res_321667 = (int64_t) 0;
        } else {
            int64_t y_321799 = sub64(s_n_m_292825, (int64_t) 1);
            bool cond_321800 = gtid_321663 == y_321799;
            int64_t defunc_0_m_fun_res_f_res_321801;
            
            if (cond_321800) {
                int64_t defunc_0_m_fun_res_f_res_t_res_321802 =
                        sub64(pad_css_len_292821, (int64_t) 1);
                
                defunc_0_m_fun_res_f_res_321801 =
                    defunc_0_m_fun_res_f_res_t_res_321802;
            } else {
                int64_t x_321803 = sub64(gtid_321663, (int64_t) 1);
                int64_t x_321804 = mul64(jump_s_292684, x_321803);
                int64_t min_arg_321805 = add64((int64_t) 1, x_321804);
                int64_t min_res_321806 = smin64(defunc_0_f_res_292820,
                                                min_arg_321805);
                
                defunc_0_m_fun_res_f_res_321801 = min_res_321806;
            }
            defunc_0_m_fun_res_321667 = defunc_0_m_fun_res_f_res_321801;
        }
        
        double defunc_2_reduce_res_321676;
        double defunc_2_reduce_res_321677;
        double defunc_2_reduce_res_321678;
        double defunc_2_reduce_res_321679;
        double defunc_2_reduce_res_321680;
        double redout_321808;
        double redout_321809;
        double redout_321810;
        double redout_321811;
        double redout_321812;
        
        redout_321808 = 0.0;
        redout_321809 = 0.0;
        redout_321810 = 0.0;
        redout_321811 = 0.0;
        redout_321812 = 0.0;
        for (int64_t i_321807 = 0; i_321807 < q_s_292678; i_321807++) {
            bool cond_321813 = sle64(x_320943, i_321807);
            int64_t defunc_0_f_res_321814;
            
            if (cond_321813) {
                defunc_0_f_res_321814 = (int64_t) 0;
            } else {
                int64_t i_321815 = add64(x_321664, i_321807);
                int64_t defunc_0_add_arg_321816;
                
                defunc_0_add_arg_321816 =
                    ((int64_t *) mem_312838.mem)[gtid_300054 *
                                                 (defunc_0_f_res_292820 *
                                                  n_p_292677) + gtid_320942 *
                                                 defunc_0_f_res_292820 +
                                                 i_321815];
                
                int64_t defunc_1_add_res_321817 = add64((int64_t) 1,
                                                        defunc_0_add_arg_321816);
                
                defunc_0_f_res_321814 = defunc_1_add_res_321817;
            }
            
            double defunc_0_f_res_321818;
            
            if (cond_321813) {
                defunc_0_f_res_321818 = 0.0;
            } else {
                int64_t i_321819 = add64(x_321664, i_321807);
                double defunc_0_add_arg_321820;
                
                defunc_0_add_arg_321820 =
                    ((double *) mem_313371.mem)[gtid_300054 *
                                                (defunc_0_f_res_292820 *
                                                 n_p_292677) + gtid_320942 *
                                                defunc_0_f_res_292820 +
                                                i_321819];
                defunc_0_f_res_321818 = defunc_0_add_arg_321820;
            }
            
            int64_t binop_p_321821 = sub64(defunc_0_f_res_321814,
                                           defunc_0_m_fun_res_321667);
            double defunc_0_f_res_321822 = sitofp_i64_f64(binop_p_321821);
            double abs_res_321823 = fabs(defunc_0_f_res_321822);
            double tmp1_321824 = abs_res_321823 / x_321665;
            double x_321825 = tmp1_321824 * tmp1_321824;
            double y_321826 = tmp1_321824 * x_321825;
            double tmp2_321827 = 1.0 - y_321826;
            double x_321828 = tmp2_321827 * tmp2_321827;
            double tmp3_321829 = tmp2_321827 * x_321828;
            double w_j_321830 = defunc_0_f_res_321818 * tmp3_321829;
            double xw_j_321831 = defunc_0_f_res_321822 * w_j_321830;
            double x2w_j_321832 = defunc_0_f_res_321822 * xw_j_321831;
            double x3w_j_321833 = defunc_0_f_res_321822 * x2w_j_321832;
            double x4w_j_321834 = defunc_0_f_res_321822 * x3w_j_321833;
            double defunc_1_op_res_321835 = w_j_321830 + redout_321808;
            double defunc_1_op_res_321836 = xw_j_321831 + redout_321809;
            double defunc_1_op_res_321837 = x2w_j_321832 + redout_321810;
            double defunc_1_op_res_321838 = x3w_j_321833 + redout_321811;
            double defunc_1_op_res_321839 = x4w_j_321834 + redout_321812;
            double redout_tmp_321890 = defunc_1_op_res_321835;
            double redout_tmp_321891 = defunc_1_op_res_321836;
            double redout_tmp_321892 = defunc_1_op_res_321837;
            double redout_tmp_321893 = defunc_1_op_res_321838;
            double redout_tmp_321894 = defunc_1_op_res_321839;
            
            redout_321808 = redout_tmp_321890;
            redout_321809 = redout_tmp_321891;
            redout_321810 = redout_tmp_321892;
            redout_321811 = redout_tmp_321893;
            redout_321812 = redout_tmp_321894;
        }
        defunc_2_reduce_res_321676 = redout_321808;
        defunc_2_reduce_res_321677 = redout_321809;
        defunc_2_reduce_res_321678 = redout_321810;
        defunc_2_reduce_res_321679 = redout_321811;
        defunc_2_reduce_res_321680 = redout_321812;
        
        double a_321714 = 2.220446049250313e-16 + defunc_2_reduce_res_321676;
        double b_321715 = 2.220446049250313e-16 + defunc_2_reduce_res_321677;
        double c_321716 = 2.220446049250313e-16 + defunc_2_reduce_res_321678;
        double d_321717 = 2.220446049250313e-16 + defunc_2_reduce_res_321679;
        double e_321718 = 2.220446049250313e-16 + defunc_2_reduce_res_321680;
        double x_321719 = c_321716 * e_321718;
        double y_321720 = d_321717 * d_321717;
        double a12_321721 = x_321719 - y_321720;
        double x_321722 = c_321716 * d_321717;
        double y_321723 = b_321715 * e_321718;
        double b12_321724 = x_321722 - y_321723;
        double x_321725 = b_321715 * d_321717;
        double y_321726 = c_321716 * c_321716;
        double c12_321727 = x_321725 - y_321726;
        double x_321728 = a_321714 * e_321718;
        double b2_321729 = x_321728 - y_321726;
        double x_321730 = b_321715 * c_321716;
        double y_321731 = a_321714 * d_321717;
        double c2_321732 = x_321730 - y_321731;
        double x_321733 = a_321714 * a12_321721;
        double y_321734 = b_321715 * b12_321724;
        double x_321735 = x_321733 + y_321734;
        double y_321736 = c_321716 * c12_321727;
        double y_321737 = x_321735 + y_321736;
        double det_321738 = 1.0 / y_321737;
        double a12_321739 = a12_321721 * det_321738;
        double b12_321740 = b12_321724 * det_321738;
        double c12_321741 = c12_321727 * det_321738;
        double b2_321742 = b2_321729 * det_321738;
        double c2_321743 = c2_321732 * det_321738;
        int64_t defunc_0_m_fun_res_321744;
        
        if (cond_321666) {
            defunc_0_m_fun_res_321744 = (int64_t) 0;
        } else {
            int64_t y_321840 = sub64(s_n_m_292825, (int64_t) 1);
            bool cond_321841 = gtid_321663 == y_321840;
            int64_t defunc_0_m_fun_res_f_res_321842;
            
            if (cond_321841) {
                int64_t defunc_0_m_fun_res_f_res_t_res_321843 =
                        sub64(pad_css_len_292821, (int64_t) 1);
                
                defunc_0_m_fun_res_f_res_321842 =
                    defunc_0_m_fun_res_f_res_t_res_321843;
            } else {
                int64_t x_321844 = sub64(gtid_321663, (int64_t) 1);
                int64_t x_321845 = mul64(jump_s_292684, x_321844);
                int64_t min_arg_321846 = add64((int64_t) 1, x_321845);
                int64_t min_res_321847 = smin64(defunc_0_f_res_292820,
                                                min_arg_321846);
                
                defunc_0_m_fun_res_f_res_321842 = min_res_321847;
            }
            defunc_0_m_fun_res_321744 = defunc_0_m_fun_res_f_res_321842;
        }
        
        double defunc_2_reduce_res_321753;
        double defunc_2_reduce_res_321754;
        double redout_321849;
        double redout_321850;
        
        redout_321849 = 0.0;
        redout_321850 = 0.0;
        for (int64_t i_321848 = 0; i_321848 < q_s_292678; i_321848++) {
            bool cond_321851 = sle64(x_320943, i_321848);
            int64_t defunc_0_f_res_321852;
            
            if (cond_321851) {
                defunc_0_f_res_321852 = (int64_t) 0;
            } else {
                int64_t i_321853 = add64(x_321664, i_321848);
                int64_t defunc_0_add_arg_321854;
                
                defunc_0_add_arg_321854 =
                    ((int64_t *) mem_312838.mem)[gtid_300054 *
                                                 (defunc_0_f_res_292820 *
                                                  n_p_292677) + gtid_320942 *
                                                 defunc_0_f_res_292820 +
                                                 i_321853];
                
                int64_t defunc_1_add_res_321855 = add64((int64_t) 1,
                                                        defunc_0_add_arg_321854);
                
                defunc_0_f_res_321852 = defunc_1_add_res_321855;
            }
            
            double defunc_0_f_res_321856;
            
            if (cond_321851) {
                defunc_0_f_res_321856 = 0.0;
            } else {
                int64_t i_321857 = add64(x_321664, i_321848);
                double defunc_0_add_arg_321858;
                
                defunc_0_add_arg_321858 =
                    ((double *) mem_313371.mem)[gtid_300054 *
                                                (defunc_0_f_res_292820 *
                                                 n_p_292677) + gtid_320942 *
                                                defunc_0_f_res_292820 +
                                                i_321857];
                defunc_0_f_res_321856 = defunc_0_add_arg_321858;
            }
            
            int64_t binop_p_321859 = sub64(defunc_0_f_res_321852,
                                           defunc_0_m_fun_res_321744);
            double defunc_0_f_res_321860 = sitofp_i64_f64(binop_p_321859);
            double abs_res_321861 = fabs(defunc_0_f_res_321860);
            double tmp1_321862 = abs_res_321861 / x_321665;
            double x_321863 = tmp1_321862 * tmp1_321862;
            double y_321864 = tmp1_321862 * x_321863;
            double tmp2_321865 = 1.0 - y_321864;
            double x_321866 = tmp2_321865 * tmp2_321865;
            double tmp3_321867 = tmp2_321865 * x_321866;
            double tmp4_321868 = defunc_0_f_res_321856 * tmp3_321867;
            double defunc_1_f_res_321869 = defunc_0_f_res_321860 * tmp4_321868;
            double defunc_1_f_res_321870 = defunc_0_f_res_321860 *
                   defunc_1_f_res_321869;
            double defunc_0_f_res_321871;
            
            if (cond_321851) {
                defunc_0_f_res_321871 = 0.0;
            } else {
                int64_t i_321872 = add64(x_321664, i_321848);
                double defunc_0_add_arg_321873;
                
                defunc_0_add_arg_321873 =
                    ((double *) mem_313366.mem)[gtid_300054 *
                                                (defunc_0_f_res_292820 *
                                                 n_p_292677) + gtid_320942 *
                                                defunc_0_f_res_292820 +
                                                i_321872];
                defunc_0_f_res_321871 = defunc_0_add_arg_321873;
            }
            
            double x_321874 = a12_321739 * tmp4_321868;
            double y_321875 = b12_321740 * defunc_1_f_res_321869;
            double x_321876 = x_321874 + y_321875;
            double y_321877 = c12_321741 * defunc_1_f_res_321870;
            double x_321878 = x_321876 + y_321877;
            double defunc_9_fit_fun_res_321879 = defunc_0_f_res_321871 *
                   x_321878;
            double x_321880 = b12_321740 * tmp4_321868;
            double y_321881 = b2_321742 * defunc_1_f_res_321869;
            double x_321882 = x_321880 + y_321881;
            double y_321883 = c2_321743 * defunc_1_f_res_321870;
            double x_321884 = x_321882 + y_321883;
            double defunc_9_slope_fun_res_321885 = defunc_0_f_res_321871 *
                   x_321884;
            double defunc_1_op_res_321886 = defunc_9_fit_fun_res_321879 +
                   redout_321849;
            double defunc_1_op_res_321887 = defunc_9_slope_fun_res_321885 +
                   redout_321850;
            double redout_tmp_321895 = defunc_1_op_res_321886;
            double redout_tmp_321896 = defunc_1_op_res_321887;
            
            redout_321849 = redout_tmp_321895;
            redout_321850 = redout_tmp_321896;
        }
        defunc_2_reduce_res_321753 = redout_321849;
        defunc_2_reduce_res_321754 = redout_321850;
        ((double *) mem_320944.mem)[gtid_321663] = defunc_2_reduce_res_321753;
        ((double *) mem_320945.mem)[gtid_321663] = defunc_2_reduce_res_321754;
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338027_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338027_end -
                 futhark_mc_segmap_parloop_338027_start;
        
        ctx->futhark_mc_segmap_parloop_338027_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338027_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338027_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_338025(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_321662 = tid;
    int num_tasks_321797 = info.nsubtasks;
    struct futhark_mc_task_338024 *futhark_mc_task_338024 =
                                  (struct futhark_mc_task_338024 *) args;
    struct futhark_context *ctx = futhark_mc_task_338024->ctx;
    uint64_t futhark_mc_segmap_task_338025_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_338025_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_338024->free_n_p_292677;
    int64_t q_s_292678 = futhark_mc_task_338024->free_q_s_292678;
    int64_t jump_s_292684 = futhark_mc_task_338024->free_jump_s_292684;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_338024->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_task_338024->free_pad_css_len_292821;
    int64_t s_n_m_292825 = futhark_mc_task_338024->free_s_n_m_292825;
    int64_t gtid_300054 = futhark_mc_task_338024->free_gtid_300054;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_task_338024->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_task_338024->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_task_338024->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_task_338024->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_task_338024->free_mem_313371,
                                  .size =0, .references =NULL};
    int64_t gtid_320942 = futhark_mc_task_338024->free_gtid_320942;
    int64_t x_320943 = futhark_mc_task_338024->free_x_320943;
    struct memblock mem_320944 = {.desc ="mem_320944", .mem =
                                  futhark_mc_task_338024->free_mem_320944,
                                  .size =0, .references =NULL};
    struct memblock mem_320945 = {.desc ="mem_320945", .mem =
                                  futhark_mc_task_338024->free_mem_320945,
                                  .size =0, .references =NULL};
    int64_t iter_321798;
    struct futhark_mc_segmap_parloop_struct_338026
    futhark_mc_segmap_parloop_struct_338026;
    
    futhark_mc_segmap_parloop_struct_338026.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338026.free_n_p_292677 = n_p_292677;
    futhark_mc_segmap_parloop_struct_338026.free_q_s_292678 = q_s_292678;
    futhark_mc_segmap_parloop_struct_338026.free_jump_s_292684 = jump_s_292684;
    futhark_mc_segmap_parloop_struct_338026.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segmap_parloop_struct_338026.free_pad_css_len_292821 =
        pad_css_len_292821;
    futhark_mc_segmap_parloop_struct_338026.free_s_n_m_292825 = s_n_m_292825;
    futhark_mc_segmap_parloop_struct_338026.free_gtid_300054 = gtid_300054;
    futhark_mc_segmap_parloop_struct_338026.free_mem_312838 = mem_312838.mem;
    futhark_mc_segmap_parloop_struct_338026.free_mem_313018 = mem_313018.mem;
    futhark_mc_segmap_parloop_struct_338026.free_mem_313023 = mem_313023.mem;
    futhark_mc_segmap_parloop_struct_338026.free_mem_313366 = mem_313366.mem;
    futhark_mc_segmap_parloop_struct_338026.free_mem_313371 = mem_313371.mem;
    futhark_mc_segmap_parloop_struct_338026.free_gtid_320942 = gtid_320942;
    futhark_mc_segmap_parloop_struct_338026.free_x_320943 = x_320943;
    futhark_mc_segmap_parloop_struct_338026.free_mem_320944 = mem_320944.mem;
    futhark_mc_segmap_parloop_struct_338026.free_mem_320945 = mem_320945.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338027_task;
    
    futhark_mc_segmap_parloop_338027_task.name =
        "futhark_mc_segmap_parloop_338027";
    futhark_mc_segmap_parloop_338027_task.fn = futhark_mc_segmap_parloop_338027;
    futhark_mc_segmap_parloop_338027_task.args =
        &futhark_mc_segmap_parloop_struct_338026;
    futhark_mc_segmap_parloop_338027_task.iterations = iterations;
    futhark_mc_segmap_parloop_338027_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338027_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338027_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338027_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338027_task);
    
    if (futhark_mc_segmap_parloop_338027_err != 0) {
        err = futhark_mc_segmap_parloop_338027_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338027_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338027_total_end -
                 futhark_mc_segmap_parloop_338027_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338027_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338027_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338027_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_338025_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_338025_end -
                 futhark_mc_segmap_task_338025_start;
        
        ctx->futhark_mc_segmap_task_338025_runs[tid]++;
        ctx->futhark_mc_segmap_task_338025_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_338025_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_segmap_parloop_struct_338029 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_q_s_292678;
    int64_t free_jump_s_292684;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    int64_t free_gtid_300054;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_313018;
    unsigned char *free_mem_313023;
    unsigned char *free_mem_313366;
    unsigned char *free_mem_313371;
    int64_t free_gtid_320942;
    int64_t free_x_320943;
    unsigned char *free_mem_320944;
    unsigned char *free_mem_320945;
};
struct futhark_mc_task_338031 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_gtid_300054;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_313371;
    int64_t free_gtid_320942;
    int64_t free_x_320943;
    int64_t free_x_321522;
    double free_x_321523;
    int64_t free_defunc_0_m_fun_res_321525;
    double *retval_defunc_2_reduce_res_321534;
    double *retval_defunc_2_reduce_res_321535;
    double *retval_defunc_2_reduce_res_321536;
    double *retval_defunc_2_reduce_res_321537;
    double *retval_defunc_2_reduce_res_321538;
};
struct futhark_mc_segred_stage_1_parloop_struct_338038 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_gtid_300054;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_313371;
    int64_t free_gtid_320942;
    int64_t free_x_320943;
    int64_t free_x_321522;
    double free_x_321523;
    int64_t free_defunc_0_m_fun_res_321525;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_321999;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_322001;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_322003;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_322005;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_322007;
};
static int futhark_mc_segred_stage_1_parloop_338039(void *args, int64_t start,
                                                    int64_t end,
                                                    int flat_tid_321906,
                                                    int tid)
{
    int err = 0;
    struct futhark_mc_segred_stage_1_parloop_struct_338038
    *futhark_mc_segred_stage_1_parloop_struct_338038 =
    (struct futhark_mc_segred_stage_1_parloop_struct_338038 *) args;
    struct futhark_context *ctx =
                           futhark_mc_segred_stage_1_parloop_struct_338038->ctx;
    uint64_t futhark_mc_segred_stage_1_parloop_338039_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_338039_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segred_stage_1_parloop_struct_338038->free_n_p_292677;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segred_stage_1_parloop_struct_338038->free_defunc_0_f_res_292820;
    int64_t gtid_300054 =
            futhark_mc_segred_stage_1_parloop_struct_338038->free_gtid_300054;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_338038->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_338038->free_mem_313371,
                                  .size =0, .references =NULL};
    int64_t gtid_320942 =
            futhark_mc_segred_stage_1_parloop_struct_338038->free_gtid_320942;
    int64_t x_320943 =
            futhark_mc_segred_stage_1_parloop_struct_338038->free_x_320943;
    int64_t x_321522 =
            futhark_mc_segred_stage_1_parloop_struct_338038->free_x_321522;
    double x_321523 =
           futhark_mc_segred_stage_1_parloop_struct_338038->free_x_321523;
    int64_t defunc_0_m_fun_res_321525 =
            futhark_mc_segred_stage_1_parloop_struct_338038->free_defunc_0_m_fun_res_321525;
    struct memblock reduce_stage_1_tid_res_arr_mem_321999 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_321999",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338038->free_reduce_stage_1_tid_res_arr_mem_321999,
                                                             .size =0,
                                                             .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_322001 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_322001",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338038->free_reduce_stage_1_tid_res_arr_mem_322001,
                                                             .size =0,
                                                             .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_322003 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_322003",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338038->free_reduce_stage_1_tid_res_arr_mem_322003,
                                                             .size =0,
                                                             .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_322005 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_322005",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338038->free_reduce_stage_1_tid_res_arr_mem_322005,
                                                             .size =0,
                                                             .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_322007 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_322007",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338038->free_reduce_stage_1_tid_res_arr_mem_322007,
                                                             .size =0,
                                                             .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_322009 = start;
    double x_321908;
    double x_321909;
    double x_321911;
    double x_321912;
    double x_321914;
    double x_321915;
    double x_321917;
    double x_321918;
    double x_321920;
    double x_321921;
    double local_acc_322010 = 0.0;
    double local_acc_322011 = 0.0;
    double local_acc_322012 = 0.0;
    double local_acc_322013 = 0.0;
    double local_acc_322014 = 0.0;
    
    for (; iter_322009 < end; iter_322009++) {
        int64_t gtid_321907 = iter_322009;
        bool cond_321923 = sle64(x_320943, gtid_321907);
        int64_t defunc_0_f_res_321924;
        
        if (cond_321923) {
            defunc_0_f_res_321924 = (int64_t) 0;
        } else {
            int64_t i_321925 = add64(x_321522, gtid_321907);
            int64_t defunc_0_add_arg_321926;
            
            defunc_0_add_arg_321926 = ((int64_t *) mem_312838.mem)[gtid_300054 *
                                                                   (defunc_0_f_res_292820 *
                                                                    n_p_292677) +
                                                                   gtid_320942 *
                                                                   defunc_0_f_res_292820 +
                                                                   i_321925];
            
            int64_t defunc_1_add_res_321927 = add64((int64_t) 1,
                                                    defunc_0_add_arg_321926);
            
            defunc_0_f_res_321924 = defunc_1_add_res_321927;
        }
        
        double defunc_0_f_res_321928;
        
        if (cond_321923) {
            defunc_0_f_res_321928 = 0.0;
        } else {
            int64_t i_321929 = add64(x_321522, gtid_321907);
            double defunc_0_add_arg_321930;
            
            defunc_0_add_arg_321930 = ((double *) mem_313371.mem)[gtid_300054 *
                                                                  (defunc_0_f_res_292820 *
                                                                   n_p_292677) +
                                                                  gtid_320942 *
                                                                  defunc_0_f_res_292820 +
                                                                  i_321929];
            defunc_0_f_res_321928 = defunc_0_add_arg_321930;
        }
        
        int64_t binop_p_321931 = sub64(defunc_0_f_res_321924,
                                       defunc_0_m_fun_res_321525);
        double defunc_0_f_res_321932 = sitofp_i64_f64(binop_p_321931);
        double abs_res_321933 = fabs(defunc_0_f_res_321932);
        double tmp1_321934 = abs_res_321933 / x_321523;
        double x_321935 = tmp1_321934 * tmp1_321934;
        double y_321936 = tmp1_321934 * x_321935;
        double tmp2_321937 = 1.0 - y_321936;
        double x_321938 = tmp2_321937 * tmp2_321937;
        double tmp3_321939 = tmp2_321937 * x_321938;
        double w_j_321940 = defunc_0_f_res_321928 * tmp3_321939;
        double xw_j_321941 = defunc_0_f_res_321932 * w_j_321940;
        double x2w_j_321942 = defunc_0_f_res_321932 * xw_j_321941;
        double x3w_j_321943 = defunc_0_f_res_321932 * x2w_j_321942;
        double x4w_j_321944 = defunc_0_f_res_321932 * x3w_j_321943;
        
        // save map-out results
        { }
        // Load accum params
        {
            x_321908 = local_acc_322010;
        }
        // Load next params
        {
            x_321909 = w_j_321940;
        }
        // Red body
        {
            double defunc_1_op_res_321910 = x_321908 + x_321909;
            
            local_acc_322010 = defunc_1_op_res_321910;
        }
        // Load accum params
        {
            x_321911 = local_acc_322011;
        }
        // Load next params
        {
            x_321912 = xw_j_321941;
        }
        // Red body
        {
            double defunc_1_op_res_321913 = x_321911 + x_321912;
            
            local_acc_322011 = defunc_1_op_res_321913;
        }
        // Load accum params
        {
            x_321914 = local_acc_322012;
        }
        // Load next params
        {
            x_321915 = x2w_j_321942;
        }
        // Red body
        {
            double defunc_1_op_res_321916 = x_321914 + x_321915;
            
            local_acc_322012 = defunc_1_op_res_321916;
        }
        // Load accum params
        {
            x_321917 = local_acc_322013;
        }
        // Load next params
        {
            x_321918 = x3w_j_321943;
        }
        // Red body
        {
            double defunc_1_op_res_321919 = x_321917 + x_321918;
            
            local_acc_322013 = defunc_1_op_res_321919;
        }
        // Load accum params
        {
            x_321920 = local_acc_322014;
        }
        // Load next params
        {
            x_321921 = x4w_j_321944;
        }
        // Red body
        {
            double defunc_1_op_res_321922 = x_321920 + x_321921;
            
            local_acc_322014 = defunc_1_op_res_321922;
        }
    }
    ((double *) reduce_stage_1_tid_res_arr_mem_321999.mem)[flat_tid_321906] =
        local_acc_322010;
    ((double *) reduce_stage_1_tid_res_arr_mem_322001.mem)[flat_tid_321906] =
        local_acc_322011;
    ((double *) reduce_stage_1_tid_res_arr_mem_322003.mem)[flat_tid_321906] =
        local_acc_322012;
    ((double *) reduce_stage_1_tid_res_arr_mem_322005.mem)[flat_tid_321906] =
        local_acc_322013;
    ((double *) reduce_stage_1_tid_res_arr_mem_322007.mem)[flat_tid_321906] =
        local_acc_322014;
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_338039_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_338039_end -
                 futhark_mc_segred_stage_1_parloop_338039_start;
        
        ctx->futhark_mc_segred_stage_1_parloop_338039_runs[tid]++;
        ctx->futhark_mc_segred_stage_1_parloop_338039_total_runtime[tid] +=
            elapsed;
        ctx->futhark_mc_segred_stage_1_parloop_338039_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segred_task_338032(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_321906 = tid;
    int num_tasks_321998 = info.nsubtasks;
    struct futhark_mc_task_338031 *futhark_mc_task_338031 =
                                  (struct futhark_mc_task_338031 *) args;
    struct futhark_context *ctx = futhark_mc_task_338031->ctx;
    uint64_t futhark_mc_segred_task_338032_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_task_338032_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_338031->free_n_p_292677;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_338031->free_defunc_0_f_res_292820;
    int64_t gtid_300054 = futhark_mc_task_338031->free_gtid_300054;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_task_338031->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_task_338031->free_mem_313371,
                                  .size =0, .references =NULL};
    int64_t gtid_320942 = futhark_mc_task_338031->free_gtid_320942;
    int64_t x_320943 = futhark_mc_task_338031->free_x_320943;
    int64_t x_321522 = futhark_mc_task_338031->free_x_321522;
    double x_321523 = futhark_mc_task_338031->free_x_321523;
    int64_t defunc_0_m_fun_res_321525 =
            futhark_mc_task_338031->free_defunc_0_m_fun_res_321525;
    double defunc_2_reduce_res_321534 =
           *futhark_mc_task_338031->retval_defunc_2_reduce_res_321534;
    double defunc_2_reduce_res_321535 =
           *futhark_mc_task_338031->retval_defunc_2_reduce_res_321535;
    double defunc_2_reduce_res_321536 =
           *futhark_mc_task_338031->retval_defunc_2_reduce_res_321536;
    double defunc_2_reduce_res_321537 =
           *futhark_mc_task_338031->retval_defunc_2_reduce_res_321537;
    double defunc_2_reduce_res_321538 =
           *futhark_mc_task_338031->retval_defunc_2_reduce_res_321538;
    size_t reduce_stage_1_tid_res_arr_mem_321999_cached_sizze_338033 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_321999 = NULL;
    size_t reduce_stage_1_tid_res_arr_mem_322001_cached_sizze_338034 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_322001 = NULL;
    size_t reduce_stage_1_tid_res_arr_mem_322003_cached_sizze_338035 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_322003 = NULL;
    size_t reduce_stage_1_tid_res_arr_mem_322005_cached_sizze_338036 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_322005 = NULL;
    size_t reduce_stage_1_tid_res_arr_mem_322007_cached_sizze_338037 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_322007 = NULL;
    
    if (reduce_stage_1_tid_res_arr_mem_321999_cached_sizze_338033 <
        (size_t) ((int64_t) 8 * num_tasks_321998)) {
        reduce_stage_1_tid_res_arr_mem_321999 =
            realloc(reduce_stage_1_tid_res_arr_mem_321999, (int64_t) 8 *
                    num_tasks_321998);
        reduce_stage_1_tid_res_arr_mem_321999_cached_sizze_338033 =
            (int64_t) 8 * num_tasks_321998;
    }
    if (reduce_stage_1_tid_res_arr_mem_322001_cached_sizze_338034 <
        (size_t) ((int64_t) 8 * num_tasks_321998)) {
        reduce_stage_1_tid_res_arr_mem_322001 =
            realloc(reduce_stage_1_tid_res_arr_mem_322001, (int64_t) 8 *
                    num_tasks_321998);
        reduce_stage_1_tid_res_arr_mem_322001_cached_sizze_338034 =
            (int64_t) 8 * num_tasks_321998;
    }
    if (reduce_stage_1_tid_res_arr_mem_322003_cached_sizze_338035 <
        (size_t) ((int64_t) 8 * num_tasks_321998)) {
        reduce_stage_1_tid_res_arr_mem_322003 =
            realloc(reduce_stage_1_tid_res_arr_mem_322003, (int64_t) 8 *
                    num_tasks_321998);
        reduce_stage_1_tid_res_arr_mem_322003_cached_sizze_338035 =
            (int64_t) 8 * num_tasks_321998;
    }
    if (reduce_stage_1_tid_res_arr_mem_322005_cached_sizze_338036 <
        (size_t) ((int64_t) 8 * num_tasks_321998)) {
        reduce_stage_1_tid_res_arr_mem_322005 =
            realloc(reduce_stage_1_tid_res_arr_mem_322005, (int64_t) 8 *
                    num_tasks_321998);
        reduce_stage_1_tid_res_arr_mem_322005_cached_sizze_338036 =
            (int64_t) 8 * num_tasks_321998;
    }
    if (reduce_stage_1_tid_res_arr_mem_322007_cached_sizze_338037 <
        (size_t) ((int64_t) 8 * num_tasks_321998)) {
        reduce_stage_1_tid_res_arr_mem_322007 =
            realloc(reduce_stage_1_tid_res_arr_mem_322007, (int64_t) 8 *
                    num_tasks_321998);
        reduce_stage_1_tid_res_arr_mem_322007_cached_sizze_338037 =
            (int64_t) 8 * num_tasks_321998;
    }
    
    int64_t iter_322009;
    struct futhark_mc_segred_stage_1_parloop_struct_338038
    futhark_mc_segred_stage_1_parloop_struct_338038;
    
    futhark_mc_segred_stage_1_parloop_struct_338038.ctx = ctx;
    futhark_mc_segred_stage_1_parloop_struct_338038.free_n_p_292677 =
        n_p_292677;
    futhark_mc_segred_stage_1_parloop_struct_338038.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segred_stage_1_parloop_struct_338038.free_gtid_300054 =
        gtid_300054;
    futhark_mc_segred_stage_1_parloop_struct_338038.free_mem_312838 =
        mem_312838.mem;
    futhark_mc_segred_stage_1_parloop_struct_338038.free_mem_313371 =
        mem_313371.mem;
    futhark_mc_segred_stage_1_parloop_struct_338038.free_gtid_320942 =
        gtid_320942;
    futhark_mc_segred_stage_1_parloop_struct_338038.free_x_320943 = x_320943;
    futhark_mc_segred_stage_1_parloop_struct_338038.free_x_321522 = x_321522;
    futhark_mc_segred_stage_1_parloop_struct_338038.free_x_321523 = x_321523;
    futhark_mc_segred_stage_1_parloop_struct_338038.free_defunc_0_m_fun_res_321525 =
        defunc_0_m_fun_res_321525;
    futhark_mc_segred_stage_1_parloop_struct_338038.free_reduce_stage_1_tid_res_arr_mem_321999 =
        reduce_stage_1_tid_res_arr_mem_321999;
    futhark_mc_segred_stage_1_parloop_struct_338038.free_reduce_stage_1_tid_res_arr_mem_322001 =
        reduce_stage_1_tid_res_arr_mem_322001;
    futhark_mc_segred_stage_1_parloop_struct_338038.free_reduce_stage_1_tid_res_arr_mem_322003 =
        reduce_stage_1_tid_res_arr_mem_322003;
    futhark_mc_segred_stage_1_parloop_struct_338038.free_reduce_stage_1_tid_res_arr_mem_322005 =
        reduce_stage_1_tid_res_arr_mem_322005;
    futhark_mc_segred_stage_1_parloop_struct_338038.free_reduce_stage_1_tid_res_arr_mem_322007 =
        reduce_stage_1_tid_res_arr_mem_322007;
    
    struct scheduler_parloop futhark_mc_segred_stage_1_parloop_338039_task;
    
    futhark_mc_segred_stage_1_parloop_338039_task.name =
        "futhark_mc_segred_stage_1_parloop_338039";
    futhark_mc_segred_stage_1_parloop_338039_task.fn =
        futhark_mc_segred_stage_1_parloop_338039;
    futhark_mc_segred_stage_1_parloop_338039_task.args =
        &futhark_mc_segred_stage_1_parloop_struct_338038;
    futhark_mc_segred_stage_1_parloop_338039_task.iterations = iterations;
    futhark_mc_segred_stage_1_parloop_338039_task.info = info;
    
    uint64_t futhark_mc_segred_stage_1_parloop_338039_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_338039_total_start = get_wall_time();
    
    int futhark_mc_segred_stage_1_parloop_338039_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segred_stage_1_parloop_338039_task);
    
    if (futhark_mc_segred_stage_1_parloop_338039_err != 0) {
        err = futhark_mc_segred_stage_1_parloop_338039_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_338039_total_end =
                 get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_338039_total_end -
                 futhark_mc_segred_stage_1_parloop_338039_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338039_total_runs,
                           1, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338039_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338039_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    // neutral-initialise the output
    {
        defunc_2_reduce_res_321534 = 0.0;
        defunc_2_reduce_res_321535 = 0.0;
        defunc_2_reduce_res_321536 = 0.0;
        defunc_2_reduce_res_321537 = 0.0;
        defunc_2_reduce_res_321538 = 0.0;
    }
    
    double x_322015;
    double x_322016;
    double x_322018;
    double x_322019;
    double x_322021;
    double x_322022;
    double x_322024;
    double x_322025;
    double x_322027;
    double x_322028;
    
    for (int32_t i_322030 = 0; i_322030 < num_tasks_321998; i_322030++) {
        flat_tid_321906 = i_322030;
        // Apply main thread reduction
        {
            // load acc params
            {
                x_322015 = defunc_2_reduce_res_321534;
            }
            // load next params
            {
                x_322016 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_321999)[flat_tid_321906];
            }
            // red body
            {
                double defunc_1_op_res_322017 = x_322015 + x_322016;
                
                defunc_2_reduce_res_321534 = defunc_1_op_res_322017;
            }
            // load acc params
            {
                x_322018 = defunc_2_reduce_res_321535;
            }
            // load next params
            {
                x_322019 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_322001)[flat_tid_321906];
            }
            // red body
            {
                double defunc_1_op_res_322020 = x_322018 + x_322019;
                
                defunc_2_reduce_res_321535 = defunc_1_op_res_322020;
            }
            // load acc params
            {
                x_322021 = defunc_2_reduce_res_321536;
            }
            // load next params
            {
                x_322022 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_322003)[flat_tid_321906];
            }
            // red body
            {
                double defunc_1_op_res_322023 = x_322021 + x_322022;
                
                defunc_2_reduce_res_321536 = defunc_1_op_res_322023;
            }
            // load acc params
            {
                x_322024 = defunc_2_reduce_res_321537;
            }
            // load next params
            {
                x_322025 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_322005)[flat_tid_321906];
            }
            // red body
            {
                double defunc_1_op_res_322026 = x_322024 + x_322025;
                
                defunc_2_reduce_res_321537 = defunc_1_op_res_322026;
            }
            // load acc params
            {
                x_322027 = defunc_2_reduce_res_321538;
            }
            // load next params
            {
                x_322028 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_322007)[flat_tid_321906];
            }
            // red body
            {
                double defunc_1_op_res_322029 = x_322027 + x_322028;
                
                defunc_2_reduce_res_321538 = defunc_1_op_res_322029;
            }
        }
    }
    
  cleanup:
    {
        free(reduce_stage_1_tid_res_arr_mem_321999);
        free(reduce_stage_1_tid_res_arr_mem_322001);
        free(reduce_stage_1_tid_res_arr_mem_322003);
        free(reduce_stage_1_tid_res_arr_mem_322005);
        free(reduce_stage_1_tid_res_arr_mem_322007);
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_task_338032_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_task_338032_end -
                 futhark_mc_segred_task_338032_start;
        
        ctx->futhark_mc_segred_task_338032_runs[tid]++;
        ctx->futhark_mc_segred_task_338032_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segred_task_338032_iter[tid] += iterations;
    }
    if (err == 0) {
        *futhark_mc_task_338031->retval_defunc_2_reduce_res_321534 =
            defunc_2_reduce_res_321534;
        *futhark_mc_task_338031->retval_defunc_2_reduce_res_321535 =
            defunc_2_reduce_res_321535;
        *futhark_mc_task_338031->retval_defunc_2_reduce_res_321536 =
            defunc_2_reduce_res_321536;
        *futhark_mc_task_338031->retval_defunc_2_reduce_res_321537 =
            defunc_2_reduce_res_321537;
        *futhark_mc_task_338031->retval_defunc_2_reduce_res_321538 =
            defunc_2_reduce_res_321538;
    }
    return err;
}
struct futhark_mc_task_338040 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_gtid_300054;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_313366;
    unsigned char *free_mem_313371;
    int64_t free_gtid_320942;
    int64_t free_x_320943;
    int64_t free_x_321522;
    double free_x_321523;
    double free_a12_321603;
    double free_b12_321604;
    double free_c12_321605;
    double free_b2_321606;
    double free_c2_321607;
    int64_t free_defunc_0_m_fun_res_321608;
    double *retval_defunc_2_reduce_res_321617;
    double *retval_defunc_2_reduce_res_321618;
};
struct futhark_mc_segred_stage_1_parloop_struct_338044 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_gtid_300054;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_313366;
    unsigned char *free_mem_313371;
    int64_t free_gtid_320942;
    int64_t free_x_320943;
    int64_t free_x_321522;
    double free_x_321523;
    double free_a12_321603;
    double free_b12_321604;
    double free_c12_321605;
    double free_b2_321606;
    double free_c2_321607;
    int64_t free_defunc_0_m_fun_res_321608;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_322032;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_322034;
};
static int futhark_mc_segred_stage_1_parloop_338045(void *args, int64_t start,
                                                    int64_t end,
                                                    int flat_tid_321953,
                                                    int tid)
{
    int err = 0;
    struct futhark_mc_segred_stage_1_parloop_struct_338044
    *futhark_mc_segred_stage_1_parloop_struct_338044 =
    (struct futhark_mc_segred_stage_1_parloop_struct_338044 *) args;
    struct futhark_context *ctx =
                           futhark_mc_segred_stage_1_parloop_struct_338044->ctx;
    uint64_t futhark_mc_segred_stage_1_parloop_338045_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_338045_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segred_stage_1_parloop_struct_338044->free_n_p_292677;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segred_stage_1_parloop_struct_338044->free_defunc_0_f_res_292820;
    int64_t gtid_300054 =
            futhark_mc_segred_stage_1_parloop_struct_338044->free_gtid_300054;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_338044->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_338044->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_338044->free_mem_313371,
                                  .size =0, .references =NULL};
    int64_t gtid_320942 =
            futhark_mc_segred_stage_1_parloop_struct_338044->free_gtid_320942;
    int64_t x_320943 =
            futhark_mc_segred_stage_1_parloop_struct_338044->free_x_320943;
    int64_t x_321522 =
            futhark_mc_segred_stage_1_parloop_struct_338044->free_x_321522;
    double x_321523 =
           futhark_mc_segred_stage_1_parloop_struct_338044->free_x_321523;
    double a12_321603 =
           futhark_mc_segred_stage_1_parloop_struct_338044->free_a12_321603;
    double b12_321604 =
           futhark_mc_segred_stage_1_parloop_struct_338044->free_b12_321604;
    double c12_321605 =
           futhark_mc_segred_stage_1_parloop_struct_338044->free_c12_321605;
    double b2_321606 =
           futhark_mc_segred_stage_1_parloop_struct_338044->free_b2_321606;
    double c2_321607 =
           futhark_mc_segred_stage_1_parloop_struct_338044->free_c2_321607;
    int64_t defunc_0_m_fun_res_321608 =
            futhark_mc_segred_stage_1_parloop_struct_338044->free_defunc_0_m_fun_res_321608;
    struct memblock reduce_stage_1_tid_res_arr_mem_322032 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_322032",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338044->free_reduce_stage_1_tid_res_arr_mem_322032,
                                                             .size =0,
                                                             .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_322034 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_322034",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338044->free_reduce_stage_1_tid_res_arr_mem_322034,
                                                             .size =0,
                                                             .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_322036 = start;
    double x_321955;
    double x_321956;
    double x_321958;
    double x_321959;
    double local_acc_322037 = 0.0;
    double local_acc_322038 = 0.0;
    
    for (; iter_322036 < end; iter_322036++) {
        int64_t gtid_321954 = iter_322036;
        bool cond_321961 = sle64(x_320943, gtid_321954);
        int64_t defunc_0_f_res_321962;
        
        if (cond_321961) {
            defunc_0_f_res_321962 = (int64_t) 0;
        } else {
            int64_t i_321963 = add64(x_321522, gtid_321954);
            int64_t defunc_0_add_arg_321964;
            
            defunc_0_add_arg_321964 = ((int64_t *) mem_312838.mem)[gtid_300054 *
                                                                   (defunc_0_f_res_292820 *
                                                                    n_p_292677) +
                                                                   gtid_320942 *
                                                                   defunc_0_f_res_292820 +
                                                                   i_321963];
            
            int64_t defunc_1_add_res_321965 = add64((int64_t) 1,
                                                    defunc_0_add_arg_321964);
            
            defunc_0_f_res_321962 = defunc_1_add_res_321965;
        }
        
        double defunc_0_f_res_321966;
        
        if (cond_321961) {
            defunc_0_f_res_321966 = 0.0;
        } else {
            int64_t i_321967 = add64(x_321522, gtid_321954);
            double defunc_0_add_arg_321968;
            
            defunc_0_add_arg_321968 = ((double *) mem_313371.mem)[gtid_300054 *
                                                                  (defunc_0_f_res_292820 *
                                                                   n_p_292677) +
                                                                  gtid_320942 *
                                                                  defunc_0_f_res_292820 +
                                                                  i_321967];
            defunc_0_f_res_321966 = defunc_0_add_arg_321968;
        }
        
        int64_t binop_p_321969 = sub64(defunc_0_f_res_321962,
                                       defunc_0_m_fun_res_321608);
        double defunc_0_f_res_321970 = sitofp_i64_f64(binop_p_321969);
        double abs_res_321971 = fabs(defunc_0_f_res_321970);
        double tmp1_321972 = abs_res_321971 / x_321523;
        double x_321973 = tmp1_321972 * tmp1_321972;
        double y_321974 = tmp1_321972 * x_321973;
        double tmp2_321975 = 1.0 - y_321974;
        double x_321976 = tmp2_321975 * tmp2_321975;
        double tmp3_321977 = tmp2_321975 * x_321976;
        double tmp4_321978 = defunc_0_f_res_321966 * tmp3_321977;
        double defunc_1_f_res_321979 = defunc_0_f_res_321970 * tmp4_321978;
        double defunc_1_f_res_321980 = defunc_0_f_res_321970 *
               defunc_1_f_res_321979;
        double defunc_0_f_res_321981;
        
        if (cond_321961) {
            defunc_0_f_res_321981 = 0.0;
        } else {
            int64_t i_321982 = add64(x_321522, gtid_321954);
            double defunc_0_add_arg_321983;
            
            defunc_0_add_arg_321983 = ((double *) mem_313366.mem)[gtid_300054 *
                                                                  (defunc_0_f_res_292820 *
                                                                   n_p_292677) +
                                                                  gtid_320942 *
                                                                  defunc_0_f_res_292820 +
                                                                  i_321982];
            defunc_0_f_res_321981 = defunc_0_add_arg_321983;
        }
        
        double x_321984 = a12_321603 * tmp4_321978;
        double y_321985 = b12_321604 * defunc_1_f_res_321979;
        double x_321986 = x_321984 + y_321985;
        double y_321987 = c12_321605 * defunc_1_f_res_321980;
        double x_321988 = x_321986 + y_321987;
        double defunc_9_fit_fun_res_321989 = defunc_0_f_res_321981 * x_321988;
        double x_321990 = b12_321604 * tmp4_321978;
        double y_321991 = b2_321606 * defunc_1_f_res_321979;
        double x_321992 = x_321990 + y_321991;
        double y_321993 = c2_321607 * defunc_1_f_res_321980;
        double x_321994 = x_321992 + y_321993;
        double defunc_9_slope_fun_res_321995 = defunc_0_f_res_321981 * x_321994;
        
        // save map-out results
        { }
        // Load accum params
        {
            x_321955 = local_acc_322037;
        }
        // Load next params
        {
            x_321956 = defunc_9_fit_fun_res_321989;
        }
        // Red body
        {
            double defunc_1_op_res_321957 = x_321955 + x_321956;
            
            local_acc_322037 = defunc_1_op_res_321957;
        }
        // Load accum params
        {
            x_321958 = local_acc_322038;
        }
        // Load next params
        {
            x_321959 = defunc_9_slope_fun_res_321995;
        }
        // Red body
        {
            double defunc_1_op_res_321960 = x_321958 + x_321959;
            
            local_acc_322038 = defunc_1_op_res_321960;
        }
    }
    ((double *) reduce_stage_1_tid_res_arr_mem_322032.mem)[flat_tid_321953] =
        local_acc_322037;
    ((double *) reduce_stage_1_tid_res_arr_mem_322034.mem)[flat_tid_321953] =
        local_acc_322038;
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_338045_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_338045_end -
                 futhark_mc_segred_stage_1_parloop_338045_start;
        
        ctx->futhark_mc_segred_stage_1_parloop_338045_runs[tid]++;
        ctx->futhark_mc_segred_stage_1_parloop_338045_total_runtime[tid] +=
            elapsed;
        ctx->futhark_mc_segred_stage_1_parloop_338045_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segred_task_338041(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_321953 = tid;
    int num_tasks_322031 = info.nsubtasks;
    struct futhark_mc_task_338040 *futhark_mc_task_338040 =
                                  (struct futhark_mc_task_338040 *) args;
    struct futhark_context *ctx = futhark_mc_task_338040->ctx;
    uint64_t futhark_mc_segred_task_338041_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_task_338041_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_338040->free_n_p_292677;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_338040->free_defunc_0_f_res_292820;
    int64_t gtid_300054 = futhark_mc_task_338040->free_gtid_300054;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_task_338040->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_task_338040->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_task_338040->free_mem_313371,
                                  .size =0, .references =NULL};
    int64_t gtid_320942 = futhark_mc_task_338040->free_gtid_320942;
    int64_t x_320943 = futhark_mc_task_338040->free_x_320943;
    int64_t x_321522 = futhark_mc_task_338040->free_x_321522;
    double x_321523 = futhark_mc_task_338040->free_x_321523;
    double a12_321603 = futhark_mc_task_338040->free_a12_321603;
    double b12_321604 = futhark_mc_task_338040->free_b12_321604;
    double c12_321605 = futhark_mc_task_338040->free_c12_321605;
    double b2_321606 = futhark_mc_task_338040->free_b2_321606;
    double c2_321607 = futhark_mc_task_338040->free_c2_321607;
    int64_t defunc_0_m_fun_res_321608 =
            futhark_mc_task_338040->free_defunc_0_m_fun_res_321608;
    double defunc_2_reduce_res_321617 =
           *futhark_mc_task_338040->retval_defunc_2_reduce_res_321617;
    double defunc_2_reduce_res_321618 =
           *futhark_mc_task_338040->retval_defunc_2_reduce_res_321618;
    size_t reduce_stage_1_tid_res_arr_mem_322032_cached_sizze_338042 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_322032 = NULL;
    size_t reduce_stage_1_tid_res_arr_mem_322034_cached_sizze_338043 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_322034 = NULL;
    
    if (reduce_stage_1_tid_res_arr_mem_322032_cached_sizze_338042 <
        (size_t) ((int64_t) 8 * num_tasks_322031)) {
        reduce_stage_1_tid_res_arr_mem_322032 =
            realloc(reduce_stage_1_tid_res_arr_mem_322032, (int64_t) 8 *
                    num_tasks_322031);
        reduce_stage_1_tid_res_arr_mem_322032_cached_sizze_338042 =
            (int64_t) 8 * num_tasks_322031;
    }
    if (reduce_stage_1_tid_res_arr_mem_322034_cached_sizze_338043 <
        (size_t) ((int64_t) 8 * num_tasks_322031)) {
        reduce_stage_1_tid_res_arr_mem_322034 =
            realloc(reduce_stage_1_tid_res_arr_mem_322034, (int64_t) 8 *
                    num_tasks_322031);
        reduce_stage_1_tid_res_arr_mem_322034_cached_sizze_338043 =
            (int64_t) 8 * num_tasks_322031;
    }
    
    int64_t iter_322036;
    struct futhark_mc_segred_stage_1_parloop_struct_338044
    futhark_mc_segred_stage_1_parloop_struct_338044;
    
    futhark_mc_segred_stage_1_parloop_struct_338044.ctx = ctx;
    futhark_mc_segred_stage_1_parloop_struct_338044.free_n_p_292677 =
        n_p_292677;
    futhark_mc_segred_stage_1_parloop_struct_338044.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segred_stage_1_parloop_struct_338044.free_gtid_300054 =
        gtid_300054;
    futhark_mc_segred_stage_1_parloop_struct_338044.free_mem_312838 =
        mem_312838.mem;
    futhark_mc_segred_stage_1_parloop_struct_338044.free_mem_313366 =
        mem_313366.mem;
    futhark_mc_segred_stage_1_parloop_struct_338044.free_mem_313371 =
        mem_313371.mem;
    futhark_mc_segred_stage_1_parloop_struct_338044.free_gtid_320942 =
        gtid_320942;
    futhark_mc_segred_stage_1_parloop_struct_338044.free_x_320943 = x_320943;
    futhark_mc_segred_stage_1_parloop_struct_338044.free_x_321522 = x_321522;
    futhark_mc_segred_stage_1_parloop_struct_338044.free_x_321523 = x_321523;
    futhark_mc_segred_stage_1_parloop_struct_338044.free_a12_321603 =
        a12_321603;
    futhark_mc_segred_stage_1_parloop_struct_338044.free_b12_321604 =
        b12_321604;
    futhark_mc_segred_stage_1_parloop_struct_338044.free_c12_321605 =
        c12_321605;
    futhark_mc_segred_stage_1_parloop_struct_338044.free_b2_321606 = b2_321606;
    futhark_mc_segred_stage_1_parloop_struct_338044.free_c2_321607 = c2_321607;
    futhark_mc_segred_stage_1_parloop_struct_338044.free_defunc_0_m_fun_res_321608 =
        defunc_0_m_fun_res_321608;
    futhark_mc_segred_stage_1_parloop_struct_338044.free_reduce_stage_1_tid_res_arr_mem_322032 =
        reduce_stage_1_tid_res_arr_mem_322032;
    futhark_mc_segred_stage_1_parloop_struct_338044.free_reduce_stage_1_tid_res_arr_mem_322034 =
        reduce_stage_1_tid_res_arr_mem_322034;
    
    struct scheduler_parloop futhark_mc_segred_stage_1_parloop_338045_task;
    
    futhark_mc_segred_stage_1_parloop_338045_task.name =
        "futhark_mc_segred_stage_1_parloop_338045";
    futhark_mc_segred_stage_1_parloop_338045_task.fn =
        futhark_mc_segred_stage_1_parloop_338045;
    futhark_mc_segred_stage_1_parloop_338045_task.args =
        &futhark_mc_segred_stage_1_parloop_struct_338044;
    futhark_mc_segred_stage_1_parloop_338045_task.iterations = iterations;
    futhark_mc_segred_stage_1_parloop_338045_task.info = info;
    
    uint64_t futhark_mc_segred_stage_1_parloop_338045_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_338045_total_start = get_wall_time();
    
    int futhark_mc_segred_stage_1_parloop_338045_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segred_stage_1_parloop_338045_task);
    
    if (futhark_mc_segred_stage_1_parloop_338045_err != 0) {
        err = futhark_mc_segred_stage_1_parloop_338045_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_338045_total_end =
                 get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_338045_total_end -
                 futhark_mc_segred_stage_1_parloop_338045_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338045_total_runs,
                           1, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338045_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338045_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    // neutral-initialise the output
    {
        defunc_2_reduce_res_321617 = 0.0;
        defunc_2_reduce_res_321618 = 0.0;
    }
    
    double x_322039;
    double x_322040;
    double x_322042;
    double x_322043;
    
    for (int32_t i_322045 = 0; i_322045 < num_tasks_322031; i_322045++) {
        flat_tid_321953 = i_322045;
        // Apply main thread reduction
        {
            // load acc params
            {
                x_322039 = defunc_2_reduce_res_321617;
            }
            // load next params
            {
                x_322040 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_322032)[flat_tid_321953];
            }
            // red body
            {
                double defunc_1_op_res_322041 = x_322039 + x_322040;
                
                defunc_2_reduce_res_321617 = defunc_1_op_res_322041;
            }
            // load acc params
            {
                x_322042 = defunc_2_reduce_res_321618;
            }
            // load next params
            {
                x_322043 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_322034)[flat_tid_321953];
            }
            // red body
            {
                double defunc_1_op_res_322044 = x_322042 + x_322043;
                
                defunc_2_reduce_res_321618 = defunc_1_op_res_322044;
            }
        }
    }
    
  cleanup:
    {
        free(reduce_stage_1_tid_res_arr_mem_322032);
        free(reduce_stage_1_tid_res_arr_mem_322034);
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_task_338041_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_task_338041_end -
                 futhark_mc_segred_task_338041_start;
        
        ctx->futhark_mc_segred_task_338041_runs[tid]++;
        ctx->futhark_mc_segred_task_338041_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segred_task_338041_iter[tid] += iterations;
    }
    if (err == 0) {
        *futhark_mc_task_338040->retval_defunc_2_reduce_res_321617 =
            defunc_2_reduce_res_321617;
        *futhark_mc_task_338040->retval_defunc_2_reduce_res_321618 =
            defunc_2_reduce_res_321618;
    }
    return err;
}
static int futhark_mc_segmap_parloop_338030(void *args, int64_t start,
                                            int64_t end, int flat_tid_321520,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338029
    *futhark_mc_segmap_parloop_struct_338029 =
    (struct futhark_mc_segmap_parloop_struct_338029 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338029->ctx;
    uint64_t futhark_mc_segmap_parloop_338030_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338030_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segmap_parloop_struct_338029->free_n_p_292677;
    int64_t q_s_292678 =
            futhark_mc_segmap_parloop_struct_338029->free_q_s_292678;
    int64_t jump_s_292684 =
            futhark_mc_segmap_parloop_struct_338029->free_jump_s_292684;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segmap_parloop_struct_338029->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_segmap_parloop_struct_338029->free_pad_css_len_292821;
    int64_t s_n_m_292825 =
            futhark_mc_segmap_parloop_struct_338029->free_s_n_m_292825;
    int64_t gtid_300054 =
            futhark_mc_segmap_parloop_struct_338029->free_gtid_300054;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_segmap_parloop_struct_338029->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_segmap_parloop_struct_338029->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_segmap_parloop_struct_338029->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_segmap_parloop_struct_338029->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_segmap_parloop_struct_338029->free_mem_313371,
                                  .size =0, .references =NULL};
    int64_t gtid_320942 =
            futhark_mc_segmap_parloop_struct_338029->free_gtid_320942;
    int64_t x_320943 = futhark_mc_segmap_parloop_struct_338029->free_x_320943;
    struct memblock mem_320944 = {.desc ="mem_320944", .mem =
                                  futhark_mc_segmap_parloop_struct_338029->free_mem_320944,
                                  .size =0, .references =NULL};
    struct memblock mem_320945 = {.desc ="mem_320945", .mem =
                                  futhark_mc_segmap_parloop_struct_338029->free_mem_320945,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_321897 = start;
    
    for (; iter_321897 < end; iter_321897++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_321996 = s_n_m_292825;
        int64_t gtid_321521 = iter_321897;
        int64_t remnant_321997 = iter_321897 - gtid_321521;
        int64_t x_321522;
        
        x_321522 = ((int64_t *) mem_313018.mem)[gtid_300054 * (s_n_m_292825 *
                                                               n_p_292677) +
                                                gtid_320942 * s_n_m_292825 +
                                                gtid_321521];
        
        double x_321523;
        
        x_321523 = ((double *) mem_313023.mem)[gtid_300054 * (s_n_m_292825 *
                                                              n_p_292677) +
                                               gtid_320942 * s_n_m_292825 +
                                               gtid_321521];
        
        bool cond_321524 = gtid_321521 == (int64_t) 0;
        int64_t defunc_0_m_fun_res_321525;
        
        if (cond_321524) {
            defunc_0_m_fun_res_321525 = (int64_t) 0;
        } else {
            int64_t y_321898 = sub64(s_n_m_292825, (int64_t) 1);
            bool cond_321899 = gtid_321521 == y_321898;
            int64_t defunc_0_m_fun_res_f_res_321900;
            
            if (cond_321899) {
                int64_t defunc_0_m_fun_res_f_res_t_res_321901 =
                        sub64(pad_css_len_292821, (int64_t) 1);
                
                defunc_0_m_fun_res_f_res_321900 =
                    defunc_0_m_fun_res_f_res_t_res_321901;
            } else {
                int64_t x_321902 = sub64(gtid_321521, (int64_t) 1);
                int64_t x_321903 = mul64(jump_s_292684, x_321902);
                int64_t min_arg_321904 = add64((int64_t) 1, x_321903);
                int64_t min_res_321905 = smin64(defunc_0_f_res_292820,
                                                min_arg_321904);
                
                defunc_0_m_fun_res_f_res_321900 = min_res_321905;
            }
            defunc_0_m_fun_res_321525 = defunc_0_m_fun_res_f_res_321900;
        }
        
        double defunc_2_reduce_res_321534;
        double defunc_2_reduce_res_321535;
        double defunc_2_reduce_res_321536;
        double defunc_2_reduce_res_321537;
        double defunc_2_reduce_res_321538;
        int64_t flat_tid_321906 = (int64_t) 0;
        int32_t num_tasks_321998;
        
        defunc_2_reduce_res_321534 = 0.0;
        defunc_2_reduce_res_321535 = 0.0;
        defunc_2_reduce_res_321536 = 0.0;
        defunc_2_reduce_res_321537 = 0.0;
        defunc_2_reduce_res_321538 = 0.0;
        
        struct futhark_mc_task_338031 futhark_mc_task_338031;
        
        futhark_mc_task_338031.ctx = ctx;
        futhark_mc_task_338031.free_n_p_292677 = n_p_292677;
        futhark_mc_task_338031.free_defunc_0_f_res_292820 =
            defunc_0_f_res_292820;
        futhark_mc_task_338031.free_gtid_300054 = gtid_300054;
        futhark_mc_task_338031.free_mem_312838 = mem_312838.mem;
        futhark_mc_task_338031.free_mem_313371 = mem_313371.mem;
        futhark_mc_task_338031.free_gtid_320942 = gtid_320942;
        futhark_mc_task_338031.free_x_320943 = x_320943;
        futhark_mc_task_338031.free_x_321522 = x_321522;
        futhark_mc_task_338031.free_x_321523 = x_321523;
        futhark_mc_task_338031.free_defunc_0_m_fun_res_321525 =
            defunc_0_m_fun_res_321525;
        futhark_mc_task_338031.retval_defunc_2_reduce_res_321534 =
            &defunc_2_reduce_res_321534;
        futhark_mc_task_338031.retval_defunc_2_reduce_res_321535 =
            &defunc_2_reduce_res_321535;
        futhark_mc_task_338031.retval_defunc_2_reduce_res_321536 =
            &defunc_2_reduce_res_321536;
        futhark_mc_task_338031.retval_defunc_2_reduce_res_321537 =
            &defunc_2_reduce_res_321537;
        futhark_mc_task_338031.retval_defunc_2_reduce_res_321538 =
            &defunc_2_reduce_res_321538;
        
        struct scheduler_segop futhark_mc_task_338031_task;
        
        futhark_mc_task_338031_task.args = &futhark_mc_task_338031;
        futhark_mc_task_338031_task.top_level_fn =
            futhark_mc_segred_task_338032;
        futhark_mc_task_338031_task.name = "futhark_mc_segred_task_338032";
        futhark_mc_task_338031_task.iterations = q_s_292678;
        futhark_mc_task_338031_task.task_time =
            &ctx->futhark_mc_segred_task_338032_total_time;
        futhark_mc_task_338031_task.task_iter =
            &ctx->futhark_mc_segred_task_338032_total_iter;
        futhark_mc_task_338031_task.sched = STATIC;
        futhark_mc_task_338031_task.nested_fn = NULL;
        
        int futhark_mc_segred_task_338032_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_338031_task);
        
        if (futhark_mc_segred_task_338032_err != 0) {
            ;
            err = futhark_mc_segred_task_338032_err;
            goto cleanup;
        }
        
        double a_321578 = 2.220446049250313e-16 + defunc_2_reduce_res_321534;
        double b_321579 = 2.220446049250313e-16 + defunc_2_reduce_res_321535;
        double c_321580 = 2.220446049250313e-16 + defunc_2_reduce_res_321536;
        double d_321581 = 2.220446049250313e-16 + defunc_2_reduce_res_321537;
        double e_321582 = 2.220446049250313e-16 + defunc_2_reduce_res_321538;
        double x_321583 = c_321580 * e_321582;
        double y_321584 = d_321581 * d_321581;
        double a12_321585 = x_321583 - y_321584;
        double x_321586 = c_321580 * d_321581;
        double y_321587 = b_321579 * e_321582;
        double b12_321588 = x_321586 - y_321587;
        double x_321589 = b_321579 * d_321581;
        double y_321590 = c_321580 * c_321580;
        double c12_321591 = x_321589 - y_321590;
        double x_321592 = a_321578 * e_321582;
        double b2_321593 = x_321592 - y_321590;
        double x_321594 = b_321579 * c_321580;
        double y_321595 = a_321578 * d_321581;
        double c2_321596 = x_321594 - y_321595;
        double x_321597 = a_321578 * a12_321585;
        double y_321598 = b_321579 * b12_321588;
        double x_321599 = x_321597 + y_321598;
        double y_321600 = c_321580 * c12_321591;
        double y_321601 = x_321599 + y_321600;
        double det_321602 = 1.0 / y_321601;
        double a12_321603 = a12_321585 * det_321602;
        double b12_321604 = b12_321588 * det_321602;
        double c12_321605 = c12_321591 * det_321602;
        double b2_321606 = b2_321593 * det_321602;
        double c2_321607 = c2_321596 * det_321602;
        int64_t defunc_0_m_fun_res_321608;
        
        if (cond_321524) {
            defunc_0_m_fun_res_321608 = (int64_t) 0;
        } else {
            int64_t y_321945 = sub64(s_n_m_292825, (int64_t) 1);
            bool cond_321946 = gtid_321521 == y_321945;
            int64_t defunc_0_m_fun_res_f_res_321947;
            
            if (cond_321946) {
                int64_t defunc_0_m_fun_res_f_res_t_res_321948 =
                        sub64(pad_css_len_292821, (int64_t) 1);
                
                defunc_0_m_fun_res_f_res_321947 =
                    defunc_0_m_fun_res_f_res_t_res_321948;
            } else {
                int64_t x_321949 = sub64(gtid_321521, (int64_t) 1);
                int64_t x_321950 = mul64(jump_s_292684, x_321949);
                int64_t min_arg_321951 = add64((int64_t) 1, x_321950);
                int64_t min_res_321952 = smin64(defunc_0_f_res_292820,
                                                min_arg_321951);
                
                defunc_0_m_fun_res_f_res_321947 = min_res_321952;
            }
            defunc_0_m_fun_res_321608 = defunc_0_m_fun_res_f_res_321947;
        }
        
        double defunc_2_reduce_res_321617;
        double defunc_2_reduce_res_321618;
        int64_t flat_tid_321953 = (int64_t) 0;
        int32_t num_tasks_322031;
        
        defunc_2_reduce_res_321617 = 0.0;
        defunc_2_reduce_res_321618 = 0.0;
        
        struct futhark_mc_task_338040 futhark_mc_task_338040;
        
        futhark_mc_task_338040.ctx = ctx;
        futhark_mc_task_338040.free_n_p_292677 = n_p_292677;
        futhark_mc_task_338040.free_defunc_0_f_res_292820 =
            defunc_0_f_res_292820;
        futhark_mc_task_338040.free_gtid_300054 = gtid_300054;
        futhark_mc_task_338040.free_mem_312838 = mem_312838.mem;
        futhark_mc_task_338040.free_mem_313366 = mem_313366.mem;
        futhark_mc_task_338040.free_mem_313371 = mem_313371.mem;
        futhark_mc_task_338040.free_gtid_320942 = gtid_320942;
        futhark_mc_task_338040.free_x_320943 = x_320943;
        futhark_mc_task_338040.free_x_321522 = x_321522;
        futhark_mc_task_338040.free_x_321523 = x_321523;
        futhark_mc_task_338040.free_a12_321603 = a12_321603;
        futhark_mc_task_338040.free_b12_321604 = b12_321604;
        futhark_mc_task_338040.free_c12_321605 = c12_321605;
        futhark_mc_task_338040.free_b2_321606 = b2_321606;
        futhark_mc_task_338040.free_c2_321607 = c2_321607;
        futhark_mc_task_338040.free_defunc_0_m_fun_res_321608 =
            defunc_0_m_fun_res_321608;
        futhark_mc_task_338040.retval_defunc_2_reduce_res_321617 =
            &defunc_2_reduce_res_321617;
        futhark_mc_task_338040.retval_defunc_2_reduce_res_321618 =
            &defunc_2_reduce_res_321618;
        
        struct scheduler_segop futhark_mc_task_338040_task;
        
        futhark_mc_task_338040_task.args = &futhark_mc_task_338040;
        futhark_mc_task_338040_task.top_level_fn =
            futhark_mc_segred_task_338041;
        futhark_mc_task_338040_task.name = "futhark_mc_segred_task_338041";
        futhark_mc_task_338040_task.iterations = q_s_292678;
        futhark_mc_task_338040_task.task_time =
            &ctx->futhark_mc_segred_task_338041_total_time;
        futhark_mc_task_338040_task.task_iter =
            &ctx->futhark_mc_segred_task_338041_total_iter;
        futhark_mc_task_338040_task.sched = STATIC;
        futhark_mc_task_338040_task.nested_fn = NULL;
        
        int futhark_mc_segred_task_338041_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_338040_task);
        
        if (futhark_mc_segred_task_338041_err != 0) {
            ;
            err = futhark_mc_segred_task_338041_err;
            goto cleanup;
        }
        ((double *) mem_320944.mem)[gtid_321521] = defunc_2_reduce_res_321617;
        ((double *) mem_320945.mem)[gtid_321521] = defunc_2_reduce_res_321618;
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338030_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338030_end -
                 futhark_mc_segmap_parloop_338030_start;
        
        ctx->futhark_mc_segmap_parloop_338030_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338030_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338030_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_nested_task_338028(void *args, int64_t iterations,
                                         int tid, struct scheduler_info info)
{
    int err = 0;
    int flat_tid_321520 = tid;
    int num_tasks_321797 = info.nsubtasks;
    struct futhark_mc_task_338024 *futhark_mc_task_338024 =
                                  (struct futhark_mc_task_338024 *) args;
    struct futhark_context *ctx = futhark_mc_task_338024->ctx;
    uint64_t futhark_mc_segmap_nested_task_338028_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_nested_task_338028_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_338024->free_n_p_292677;
    int64_t q_s_292678 = futhark_mc_task_338024->free_q_s_292678;
    int64_t jump_s_292684 = futhark_mc_task_338024->free_jump_s_292684;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_338024->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_task_338024->free_pad_css_len_292821;
    int64_t s_n_m_292825 = futhark_mc_task_338024->free_s_n_m_292825;
    int64_t gtid_300054 = futhark_mc_task_338024->free_gtid_300054;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_task_338024->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_task_338024->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_task_338024->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_task_338024->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_task_338024->free_mem_313371,
                                  .size =0, .references =NULL};
    int64_t gtid_320942 = futhark_mc_task_338024->free_gtid_320942;
    int64_t x_320943 = futhark_mc_task_338024->free_x_320943;
    struct memblock mem_320944 = {.desc ="mem_320944", .mem =
                                  futhark_mc_task_338024->free_mem_320944,
                                  .size =0, .references =NULL};
    struct memblock mem_320945 = {.desc ="mem_320945", .mem =
                                  futhark_mc_task_338024->free_mem_320945,
                                  .size =0, .references =NULL};
    int64_t iter_321897;
    struct futhark_mc_segmap_parloop_struct_338029
    futhark_mc_segmap_parloop_struct_338029;
    
    futhark_mc_segmap_parloop_struct_338029.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338029.free_n_p_292677 = n_p_292677;
    futhark_mc_segmap_parloop_struct_338029.free_q_s_292678 = q_s_292678;
    futhark_mc_segmap_parloop_struct_338029.free_jump_s_292684 = jump_s_292684;
    futhark_mc_segmap_parloop_struct_338029.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segmap_parloop_struct_338029.free_pad_css_len_292821 =
        pad_css_len_292821;
    futhark_mc_segmap_parloop_struct_338029.free_s_n_m_292825 = s_n_m_292825;
    futhark_mc_segmap_parloop_struct_338029.free_gtid_300054 = gtid_300054;
    futhark_mc_segmap_parloop_struct_338029.free_mem_312838 = mem_312838.mem;
    futhark_mc_segmap_parloop_struct_338029.free_mem_313018 = mem_313018.mem;
    futhark_mc_segmap_parloop_struct_338029.free_mem_313023 = mem_313023.mem;
    futhark_mc_segmap_parloop_struct_338029.free_mem_313366 = mem_313366.mem;
    futhark_mc_segmap_parloop_struct_338029.free_mem_313371 = mem_313371.mem;
    futhark_mc_segmap_parloop_struct_338029.free_gtid_320942 = gtid_320942;
    futhark_mc_segmap_parloop_struct_338029.free_x_320943 = x_320943;
    futhark_mc_segmap_parloop_struct_338029.free_mem_320944 = mem_320944.mem;
    futhark_mc_segmap_parloop_struct_338029.free_mem_320945 = mem_320945.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338030_task;
    
    futhark_mc_segmap_parloop_338030_task.name =
        "futhark_mc_segmap_parloop_338030";
    futhark_mc_segmap_parloop_338030_task.fn = futhark_mc_segmap_parloop_338030;
    futhark_mc_segmap_parloop_338030_task.args =
        &futhark_mc_segmap_parloop_struct_338029;
    futhark_mc_segmap_parloop_338030_task.iterations = iterations;
    futhark_mc_segmap_parloop_338030_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338030_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338030_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338030_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338030_task);
    
    if (futhark_mc_segmap_parloop_338030_err != 0) {
        err = futhark_mc_segmap_parloop_338030_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338030_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338030_total_end -
                 futhark_mc_segmap_parloop_338030_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338030_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338030_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338030_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_nested_task_338028_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_nested_task_338028_end -
                 futhark_mc_segmap_nested_task_338028_start;
        
        ctx->futhark_mc_segmap_nested_task_338028_runs[tid]++;
        ctx->futhark_mc_segmap_nested_task_338028_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_nested_task_338028_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
static int futhark_mc_segmap_parloop_338021(void *args, int64_t start,
                                            int64_t end, int flat_tid_320941,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338020
    *futhark_mc_segmap_parloop_struct_338020 =
    (struct futhark_mc_segmap_parloop_struct_338020 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338020->ctx;
    uint64_t futhark_mc_segmap_parloop_338021_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338021_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segmap_parloop_struct_338020->free_n_p_292677;
    int64_t q_s_292678 =
            futhark_mc_segmap_parloop_struct_338020->free_q_s_292678;
    int64_t jump_s_292684 =
            futhark_mc_segmap_parloop_struct_338020->free_jump_s_292684;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segmap_parloop_struct_338020->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_segmap_parloop_struct_338020->free_pad_css_len_292821;
    int64_t s_n_m_292825 =
            futhark_mc_segmap_parloop_struct_338020->free_s_n_m_292825;
    int64_t gtid_300054 =
            futhark_mc_segmap_parloop_struct_338020->free_gtid_300054;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_segmap_parloop_struct_338020->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_312842 = {.desc ="mem_312842", .mem =
                                  futhark_mc_segmap_parloop_struct_338020->free_mem_312842,
                                  .size =0, .references =NULL};
    int64_t bytes_312847 =
            futhark_mc_segmap_parloop_struct_338020->free_bytes_312847;
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_segmap_parloop_struct_338020->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_segmap_parloop_struct_338020->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_segmap_parloop_struct_338020->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_segmap_parloop_struct_338020->free_mem_313371,
                                  .size =0, .references =NULL};
    struct memblock mem_313638 = {.desc ="mem_313638", .mem =
                                  futhark_mc_segmap_parloop_struct_338020->free_mem_313638,
                                  .size =0, .references =NULL};
    struct memblock mem_313642 = {.desc ="mem_313642", .mem =
                                  futhark_mc_segmap_parloop_struct_338020->free_mem_313642,
                                  .size =0, .references =NULL};
    size_t mem_320944_cached_sizze_338022 = 0;
    unsigned char *mem_320944 = NULL;
    size_t mem_320945_cached_sizze_338023 = 0;
    unsigned char *mem_320945 = NULL;
    int64_t iterations = end - start;
    int64_t iter_321519 = start;
    
    if (mem_320944_cached_sizze_338022 < (size_t) bytes_312847) {
        mem_320944 = realloc(mem_320944, bytes_312847);
        mem_320944_cached_sizze_338022 = bytes_312847;
    }
    if (mem_320945_cached_sizze_338023 < (size_t) bytes_312847) {
        mem_320945 = realloc(mem_320945, bytes_312847);
        mem_320945_cached_sizze_338023 = bytes_312847;
    }
    for (; iter_321519 < end; iter_321519++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_321795 = n_p_292677;
        int64_t gtid_320942 = iter_321519;
        int64_t remnant_321796 = iter_321519 - gtid_320942;
        int64_t x_320943;
        
        x_320943 = ((int64_t *) mem_312842.mem)[gtid_300054 * n_p_292677 +
                                                gtid_320942];
        
        int64_t flat_tid_321662 = (int64_t) 0;
        int32_t num_tasks_321797;
        int64_t flat_tid_321520 = (int64_t) 0;
        struct futhark_mc_task_338024 futhark_mc_task_338024;
        
        futhark_mc_task_338024.ctx = ctx;
        futhark_mc_task_338024.free_n_p_292677 = n_p_292677;
        futhark_mc_task_338024.free_q_s_292678 = q_s_292678;
        futhark_mc_task_338024.free_jump_s_292684 = jump_s_292684;
        futhark_mc_task_338024.free_defunc_0_f_res_292820 =
            defunc_0_f_res_292820;
        futhark_mc_task_338024.free_pad_css_len_292821 = pad_css_len_292821;
        futhark_mc_task_338024.free_s_n_m_292825 = s_n_m_292825;
        futhark_mc_task_338024.free_gtid_300054 = gtid_300054;
        futhark_mc_task_338024.free_mem_312838 = mem_312838.mem;
        futhark_mc_task_338024.free_mem_313018 = mem_313018.mem;
        futhark_mc_task_338024.free_mem_313023 = mem_313023.mem;
        futhark_mc_task_338024.free_mem_313366 = mem_313366.mem;
        futhark_mc_task_338024.free_mem_313371 = mem_313371.mem;
        futhark_mc_task_338024.free_gtid_320942 = gtid_320942;
        futhark_mc_task_338024.free_x_320943 = x_320943;
        futhark_mc_task_338024.free_mem_320944 = mem_320944;
        futhark_mc_task_338024.free_mem_320945 = mem_320945;
        
        struct scheduler_segop futhark_mc_task_338024_task;
        
        futhark_mc_task_338024_task.args = &futhark_mc_task_338024;
        futhark_mc_task_338024_task.top_level_fn =
            futhark_mc_segmap_task_338025;
        futhark_mc_task_338024_task.name = "futhark_mc_segmap_task_338025";
        futhark_mc_task_338024_task.iterations = s_n_m_292825;
        futhark_mc_task_338024_task.task_time =
            &ctx->futhark_mc_segmap_task_338025_total_time;
        futhark_mc_task_338024_task.task_iter =
            &ctx->futhark_mc_segmap_task_338025_total_iter;
        futhark_mc_task_338024_task.sched = STATIC;
        futhark_mc_task_338024_task.nested_fn =
            futhark_mc_segmap_nested_task_338028;
        
        int futhark_mc_segmap_task_338025_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_338024_task);
        
        if (futhark_mc_segmap_task_338025_err != 0) {
            ;
            err = futhark_mc_segmap_task_338025_err;
            goto cleanup;
        }
        if (s_n_m_292825 * (int64_t) 8 > 0)
            memmove(mem_313638.mem + gtid_320942 * s_n_m_292825 * (int64_t) 8,
                    mem_320944 + (int64_t) 0, s_n_m_292825 * (int64_t) 8);
        if (s_n_m_292825 * (int64_t) 8 > 0)
            memmove(mem_313642.mem + gtid_320942 * s_n_m_292825 * (int64_t) 8,
                    mem_320945 + (int64_t) 0, s_n_m_292825 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_320944);
    free(mem_320945);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338021_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338021_end -
                 futhark_mc_segmap_parloop_338021_start;
        
        ctx->futhark_mc_segmap_parloop_338021_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338021_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338021_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_nested_task_338019(void *args, int64_t iterations,
                                         int tid, struct scheduler_info info)
{
    int err = 0;
    int flat_tid_320941 = tid;
    int num_tasks_321370 = info.nsubtasks;
    struct futhark_mc_task_338013 *futhark_mc_task_338013 =
                                  (struct futhark_mc_task_338013 *) args;
    struct futhark_context *ctx = futhark_mc_task_338013->ctx;
    uint64_t futhark_mc_segmap_nested_task_338019_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_nested_task_338019_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_338013->free_n_p_292677;
    int64_t q_s_292678 = futhark_mc_task_338013->free_q_s_292678;
    int64_t jump_s_292684 = futhark_mc_task_338013->free_jump_s_292684;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_338013->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_task_338013->free_pad_css_len_292821;
    int64_t s_n_m_292825 = futhark_mc_task_338013->free_s_n_m_292825;
    int64_t gtid_300054 = futhark_mc_task_338013->free_gtid_300054;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_task_338013->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_312842 = {.desc ="mem_312842", .mem =
                                  futhark_mc_task_338013->free_mem_312842,
                                  .size =0, .references =NULL};
    int64_t bytes_312847 = futhark_mc_task_338013->free_bytes_312847;
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_task_338013->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_task_338013->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_task_338013->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_task_338013->free_mem_313371,
                                  .size =0, .references =NULL};
    struct memblock mem_313638 = {.desc ="mem_313638", .mem =
                                  futhark_mc_task_338013->free_mem_313638,
                                  .size =0, .references =NULL};
    struct memblock mem_313642 = {.desc ="mem_313642", .mem =
                                  futhark_mc_task_338013->free_mem_313642,
                                  .size =0, .references =NULL};
    int64_t iter_321519;
    struct futhark_mc_segmap_parloop_struct_338020
    futhark_mc_segmap_parloop_struct_338020;
    
    futhark_mc_segmap_parloop_struct_338020.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338020.free_n_p_292677 = n_p_292677;
    futhark_mc_segmap_parloop_struct_338020.free_q_s_292678 = q_s_292678;
    futhark_mc_segmap_parloop_struct_338020.free_jump_s_292684 = jump_s_292684;
    futhark_mc_segmap_parloop_struct_338020.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segmap_parloop_struct_338020.free_pad_css_len_292821 =
        pad_css_len_292821;
    futhark_mc_segmap_parloop_struct_338020.free_s_n_m_292825 = s_n_m_292825;
    futhark_mc_segmap_parloop_struct_338020.free_gtid_300054 = gtid_300054;
    futhark_mc_segmap_parloop_struct_338020.free_mem_312838 = mem_312838.mem;
    futhark_mc_segmap_parloop_struct_338020.free_mem_312842 = mem_312842.mem;
    futhark_mc_segmap_parloop_struct_338020.free_bytes_312847 = bytes_312847;
    futhark_mc_segmap_parloop_struct_338020.free_mem_313018 = mem_313018.mem;
    futhark_mc_segmap_parloop_struct_338020.free_mem_313023 = mem_313023.mem;
    futhark_mc_segmap_parloop_struct_338020.free_mem_313366 = mem_313366.mem;
    futhark_mc_segmap_parloop_struct_338020.free_mem_313371 = mem_313371.mem;
    futhark_mc_segmap_parloop_struct_338020.free_mem_313638 = mem_313638.mem;
    futhark_mc_segmap_parloop_struct_338020.free_mem_313642 = mem_313642.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338021_task;
    
    futhark_mc_segmap_parloop_338021_task.name =
        "futhark_mc_segmap_parloop_338021";
    futhark_mc_segmap_parloop_338021_task.fn = futhark_mc_segmap_parloop_338021;
    futhark_mc_segmap_parloop_338021_task.args =
        &futhark_mc_segmap_parloop_struct_338020;
    futhark_mc_segmap_parloop_338021_task.iterations = iterations;
    futhark_mc_segmap_parloop_338021_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338021_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338021_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338021_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338021_task);
    
    if (futhark_mc_segmap_parloop_338021_err != 0) {
        err = futhark_mc_segmap_parloop_338021_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338021_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338021_total_end -
                 futhark_mc_segmap_parloop_338021_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338021_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338021_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338021_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_nested_task_338019_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_nested_task_338019_end -
                 futhark_mc_segmap_nested_task_338019_start;
        
        ctx->futhark_mc_segmap_nested_task_338019_runs[tid]++;
        ctx->futhark_mc_segmap_nested_task_338019_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_nested_task_338019_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
static int futhark_mc_segmap_parloop_338010(void *args, int64_t start,
                                            int64_t end, int flat_tid_300053,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338009
    *futhark_mc_segmap_parloop_struct_338009 =
    (struct futhark_mc_segmap_parloop_struct_338009 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338009->ctx;
    uint64_t futhark_mc_segmap_parloop_338010_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338010_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segmap_parloop_struct_338009->free_n_p_292677;
    int64_t q_s_292678 =
            futhark_mc_segmap_parloop_struct_338009->free_q_s_292678;
    int64_t jump_s_292684 =
            futhark_mc_segmap_parloop_struct_338009->free_jump_s_292684;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_338009->free_partition_sizze_292766;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segmap_parloop_struct_338009->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_segmap_parloop_struct_338009->free_pad_css_len_292821;
    int64_t s_n_m_292825 =
            futhark_mc_segmap_parloop_struct_338009->free_s_n_m_292825;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_segmap_parloop_struct_338009->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_312842 = {.desc ="mem_312842", .mem =
                                  futhark_mc_segmap_parloop_struct_338009->free_mem_312842,
                                  .size =0, .references =NULL};
    int64_t bytes_312847 =
            futhark_mc_segmap_parloop_struct_338009->free_bytes_312847;
    int64_t bytes_312899 =
            futhark_mc_segmap_parloop_struct_338009->free_bytes_312899;
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_segmap_parloop_struct_338009->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_segmap_parloop_struct_338009->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_segmap_parloop_struct_338009->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_segmap_parloop_struct_338009->free_mem_313371,
                                  .size =0, .references =NULL};
    struct memblock mem_313741 = {.desc ="mem_313741", .mem =
                                  futhark_mc_segmap_parloop_struct_338009->free_mem_313741,
                                  .size =0, .references =NULL};
    struct memblock mem_313746 = {.desc ="mem_313746", .mem =
                                  futhark_mc_segmap_parloop_struct_338009->free_mem_313746,
                                  .size =0, .references =NULL};
    size_t mem_313638_cached_sizze_338011 = 0;
    unsigned char *mem_313638 = NULL;
    size_t mem_313642_cached_sizze_338012 = 0;
    unsigned char *mem_313642 = NULL;
    int64_t iterations = end - start;
    int64_t iter_320940 = start;
    
    if (mem_313638_cached_sizze_338011 < (size_t) bytes_312899) {
        mem_313638 = realloc(mem_313638, bytes_312899);
        mem_313638_cached_sizze_338011 = bytes_312899;
    }
    if (mem_313642_cached_sizze_338012 < (size_t) bytes_312899) {
        mem_313642 = realloc(mem_313642, bytes_312899);
        mem_313642_cached_sizze_338012 = bytes_312899;
    }
    for (; iter_320940 < end; iter_320940++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_321368 = partition_sizze_292766;
        int64_t gtid_300054 = iter_320940;
        int64_t remnant_321369 = iter_320940 - gtid_300054;
        int64_t flat_tid_321223 = (int64_t) 0;
        int32_t num_tasks_321370;
        int64_t flat_tid_320941 = (int64_t) 0;
        struct futhark_mc_task_338013 futhark_mc_task_338013;
        
        futhark_mc_task_338013.ctx = ctx;
        futhark_mc_task_338013.free_n_p_292677 = n_p_292677;
        futhark_mc_task_338013.free_q_s_292678 = q_s_292678;
        futhark_mc_task_338013.free_jump_s_292684 = jump_s_292684;
        futhark_mc_task_338013.free_defunc_0_f_res_292820 =
            defunc_0_f_res_292820;
        futhark_mc_task_338013.free_pad_css_len_292821 = pad_css_len_292821;
        futhark_mc_task_338013.free_s_n_m_292825 = s_n_m_292825;
        futhark_mc_task_338013.free_gtid_300054 = gtid_300054;
        futhark_mc_task_338013.free_mem_312838 = mem_312838.mem;
        futhark_mc_task_338013.free_mem_312842 = mem_312842.mem;
        futhark_mc_task_338013.free_bytes_312847 = bytes_312847;
        futhark_mc_task_338013.free_mem_313018 = mem_313018.mem;
        futhark_mc_task_338013.free_mem_313023 = mem_313023.mem;
        futhark_mc_task_338013.free_mem_313366 = mem_313366.mem;
        futhark_mc_task_338013.free_mem_313371 = mem_313371.mem;
        futhark_mc_task_338013.free_mem_313638 = mem_313638;
        futhark_mc_task_338013.free_mem_313642 = mem_313642;
        
        struct scheduler_segop futhark_mc_task_338013_task;
        
        futhark_mc_task_338013_task.args = &futhark_mc_task_338013;
        futhark_mc_task_338013_task.top_level_fn =
            futhark_mc_segmap_task_338014;
        futhark_mc_task_338013_task.name = "futhark_mc_segmap_task_338014";
        futhark_mc_task_338013_task.iterations = n_p_292677;
        futhark_mc_task_338013_task.task_time =
            &ctx->futhark_mc_segmap_task_338014_total_time;
        futhark_mc_task_338013_task.task_iter =
            &ctx->futhark_mc_segmap_task_338014_total_iter;
        futhark_mc_task_338013_task.sched = STATIC;
        futhark_mc_task_338013_task.nested_fn =
            futhark_mc_segmap_nested_task_338019;
        
        int futhark_mc_segmap_task_338014_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_338013_task);
        
        if (futhark_mc_segmap_task_338014_err != 0) {
            ;
            err = futhark_mc_segmap_task_338014_err;
            goto cleanup;
        }
        if (n_p_292677 * s_n_m_292825 * (int64_t) 8 > 0)
            memmove(mem_313741.mem + gtid_300054 * (s_n_m_292825 * n_p_292677) *
                    (int64_t) 8, mem_313638 + (int64_t) 0, n_p_292677 *
                    s_n_m_292825 * (int64_t) 8);
        if (n_p_292677 * s_n_m_292825 * (int64_t) 8 > 0)
            memmove(mem_313746.mem + gtid_300054 * (s_n_m_292825 * n_p_292677) *
                    (int64_t) 8, mem_313642 + (int64_t) 0, n_p_292677 *
                    s_n_m_292825 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_313638);
    free(mem_313642);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338010_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338010_end -
                 futhark_mc_segmap_parloop_338010_start;
        
        ctx->futhark_mc_segmap_parloop_338010_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338010_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338010_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_nested_task_338008(void *args, int64_t iterations,
                                         int tid, struct scheduler_info info)
{
    int err = 0;
    int flat_tid_300053 = tid;
    int num_tasks_320783 = info.nsubtasks;
    struct futhark_mc_task_338002 *futhark_mc_task_338002 =
                                  (struct futhark_mc_task_338002 *) args;
    struct futhark_context *ctx = futhark_mc_task_338002->ctx;
    uint64_t futhark_mc_segmap_nested_task_338008_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_nested_task_338008_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_338002->free_n_p_292677;
    int64_t q_s_292678 = futhark_mc_task_338002->free_q_s_292678;
    int64_t jump_s_292684 = futhark_mc_task_338002->free_jump_s_292684;
    int64_t partition_sizze_292766 =
            futhark_mc_task_338002->free_partition_sizze_292766;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_338002->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_task_338002->free_pad_css_len_292821;
    int64_t s_n_m_292825 = futhark_mc_task_338002->free_s_n_m_292825;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_task_338002->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_312842 = {.desc ="mem_312842", .mem =
                                  futhark_mc_task_338002->free_mem_312842,
                                  .size =0, .references =NULL};
    int64_t bytes_312847 = futhark_mc_task_338002->free_bytes_312847;
    int64_t bytes_312899 = futhark_mc_task_338002->free_bytes_312899;
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_task_338002->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_task_338002->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_task_338002->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_task_338002->free_mem_313371,
                                  .size =0, .references =NULL};
    struct memblock mem_313741 = {.desc ="mem_313741", .mem =
                                  futhark_mc_task_338002->free_mem_313741,
                                  .size =0, .references =NULL};
    struct memblock mem_313746 = {.desc ="mem_313746", .mem =
                                  futhark_mc_task_338002->free_mem_313746,
                                  .size =0, .references =NULL};
    int64_t iter_320940;
    struct futhark_mc_segmap_parloop_struct_338009
    futhark_mc_segmap_parloop_struct_338009;
    
    futhark_mc_segmap_parloop_struct_338009.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338009.free_n_p_292677 = n_p_292677;
    futhark_mc_segmap_parloop_struct_338009.free_q_s_292678 = q_s_292678;
    futhark_mc_segmap_parloop_struct_338009.free_jump_s_292684 = jump_s_292684;
    futhark_mc_segmap_parloop_struct_338009.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_338009.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segmap_parloop_struct_338009.free_pad_css_len_292821 =
        pad_css_len_292821;
    futhark_mc_segmap_parloop_struct_338009.free_s_n_m_292825 = s_n_m_292825;
    futhark_mc_segmap_parloop_struct_338009.free_mem_312838 = mem_312838.mem;
    futhark_mc_segmap_parloop_struct_338009.free_mem_312842 = mem_312842.mem;
    futhark_mc_segmap_parloop_struct_338009.free_bytes_312847 = bytes_312847;
    futhark_mc_segmap_parloop_struct_338009.free_bytes_312899 = bytes_312899;
    futhark_mc_segmap_parloop_struct_338009.free_mem_313018 = mem_313018.mem;
    futhark_mc_segmap_parloop_struct_338009.free_mem_313023 = mem_313023.mem;
    futhark_mc_segmap_parloop_struct_338009.free_mem_313366 = mem_313366.mem;
    futhark_mc_segmap_parloop_struct_338009.free_mem_313371 = mem_313371.mem;
    futhark_mc_segmap_parloop_struct_338009.free_mem_313741 = mem_313741.mem;
    futhark_mc_segmap_parloop_struct_338009.free_mem_313746 = mem_313746.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338010_task;
    
    futhark_mc_segmap_parloop_338010_task.name =
        "futhark_mc_segmap_parloop_338010";
    futhark_mc_segmap_parloop_338010_task.fn = futhark_mc_segmap_parloop_338010;
    futhark_mc_segmap_parloop_338010_task.args =
        &futhark_mc_segmap_parloop_struct_338009;
    futhark_mc_segmap_parloop_338010_task.iterations = iterations;
    futhark_mc_segmap_parloop_338010_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338010_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338010_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338010_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338010_task);
    
    if (futhark_mc_segmap_parloop_338010_err != 0) {
        err = futhark_mc_segmap_parloop_338010_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338010_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338010_total_end -
                 futhark_mc_segmap_parloop_338010_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338010_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338010_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338010_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_nested_task_338008_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_nested_task_338008_end -
                 futhark_mc_segmap_nested_task_338008_start;
        
        ctx->futhark_mc_segmap_nested_task_338008_runs[tid]++;
        ctx->futhark_mc_segmap_nested_task_338008_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_nested_task_338008_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_task_338046 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_q_s_292678;
    int64_t free_jump_s_292684;
    int64_t free_partition_sizze_292766;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_312842;
    int64_t free_bytes_312847;
    int64_t free_bytes_312899;
    unsigned char *free_mem_313018;
    unsigned char *free_mem_313023;
    unsigned char *free_mem_313366;
    unsigned char *free_mem_313371;
    int64_t free_bytes_313757;
    unsigned char *free_mem_313877;
};
struct futhark_mc_segmap_parloop_struct_338048 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_q_s_292678;
    int64_t free_jump_s_292684;
    int64_t free_partition_sizze_292766;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_312842;
    int64_t free_bytes_312899;
    unsigned char *free_mem_313018;
    unsigned char *free_mem_313023;
    unsigned char *free_mem_313366;
    unsigned char *free_mem_313371;
    int64_t free_bytes_313757;
    unsigned char *free_mem_313877;
};
static int futhark_mc_segmap_parloop_338049(void *args, int64_t start,
                                            int64_t end, int flat_tid_300508,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338048
    *futhark_mc_segmap_parloop_struct_338048 =
    (struct futhark_mc_segmap_parloop_struct_338048 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338048->ctx;
    uint64_t futhark_mc_segmap_parloop_338049_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338049_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segmap_parloop_struct_338048->free_n_p_292677;
    int64_t q_s_292678 =
            futhark_mc_segmap_parloop_struct_338048->free_q_s_292678;
    int64_t jump_s_292684 =
            futhark_mc_segmap_parloop_struct_338048->free_jump_s_292684;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_338048->free_partition_sizze_292766;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segmap_parloop_struct_338048->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_segmap_parloop_struct_338048->free_pad_css_len_292821;
    int64_t s_n_m_292825 =
            futhark_mc_segmap_parloop_struct_338048->free_s_n_m_292825;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_segmap_parloop_struct_338048->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_312842 = {.desc ="mem_312842", .mem =
                                  futhark_mc_segmap_parloop_struct_338048->free_mem_312842,
                                  .size =0, .references =NULL};
    int64_t bytes_312899 =
            futhark_mc_segmap_parloop_struct_338048->free_bytes_312899;
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_segmap_parloop_struct_338048->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_segmap_parloop_struct_338048->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_segmap_parloop_struct_338048->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_segmap_parloop_struct_338048->free_mem_313371,
                                  .size =0, .references =NULL};
    int64_t bytes_313757 =
            futhark_mc_segmap_parloop_struct_338048->free_bytes_313757;
    struct memblock mem_313877 = {.desc ="mem_313877", .mem =
                                  futhark_mc_segmap_parloop_struct_338048->free_mem_313877,
                                  .size =0, .references =NULL};
    size_t mem_313814_cached_sizze_338050 = 0;
    unsigned char *mem_313814 = NULL;
    size_t mem_313838_cached_sizze_338051 = 0;
    unsigned char *mem_313838 = NULL;
    int64_t iterations = end - start;
    int64_t iter_322050 = start;
    
    if (mem_313814_cached_sizze_338050 < (size_t) bytes_312899) {
        mem_313814 = realloc(mem_313814, bytes_312899);
        mem_313814_cached_sizze_338050 = bytes_312899;
    }
    if (mem_313838_cached_sizze_338051 < (size_t) bytes_313757) {
        mem_313838 = realloc(mem_313838, bytes_313757);
        mem_313838_cached_sizze_338051 = bytes_313757;
    }
    for (; iter_322050 < end; iter_322050++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_322109 = partition_sizze_292766;
        int64_t gtid_300509 = iter_322050;
        int64_t remnant_322110 = iter_322050 - gtid_300509;
        
        for (int64_t i_322051 = 0; i_322051 < n_p_292677; i_322051++) {
            int64_t x_322053;
            
            x_322053 = ((int64_t *) mem_312842.mem)[gtid_300509 * n_p_292677 +
                                                    i_322051];
            for (int64_t i_322055 = 0; i_322055 < s_n_m_292825; i_322055++) {
                int64_t x_322057;
                
                x_322057 = ((int64_t *) mem_313018.mem)[gtid_300509 *
                                                        (s_n_m_292825 *
                                                         n_p_292677) +
                                                        i_322051 *
                                                        s_n_m_292825 +
                                                        i_322055];
                
                double x_322058;
                
                x_322058 = ((double *) mem_313023.mem)[gtid_300509 *
                                                       (s_n_m_292825 *
                                                        n_p_292677) + i_322051 *
                                                       s_n_m_292825 + i_322055];
                
                bool cond_322059 = i_322055 == (int64_t) 0;
                int64_t defunc_0_m_fun_res_322060;
                
                if (cond_322059) {
                    defunc_0_m_fun_res_322060 = (int64_t) 0;
                } else {
                    int64_t y_322061 = sub64(s_n_m_292825, (int64_t) 1);
                    bool cond_322062 = i_322055 == y_322061;
                    int64_t defunc_0_m_fun_res_f_res_322063;
                    
                    if (cond_322062) {
                        int64_t defunc_0_m_fun_res_f_res_t_res_322064 =
                                sub64(pad_css_len_292821, (int64_t) 1);
                        
                        defunc_0_m_fun_res_f_res_322063 =
                            defunc_0_m_fun_res_f_res_t_res_322064;
                    } else {
                        int64_t x_322065 = sub64(i_322055, (int64_t) 1);
                        int64_t x_322066 = mul64(jump_s_292684, x_322065);
                        int64_t min_arg_322067 = add64((int64_t) 1, x_322066);
                        int64_t min_res_322068 = smin64(defunc_0_f_res_292820,
                                                        min_arg_322067);
                        
                        defunc_0_m_fun_res_f_res_322063 = min_res_322068;
                    }
                    defunc_0_m_fun_res_322060 = defunc_0_m_fun_res_f_res_322063;
                }
                
                double defunc_2_reduce_res_322070;
                double redout_322073 = 0.0;
                
                for (int64_t i_322072 = 0; i_322072 < q_s_292678; i_322072++) {
                    bool cond_322075 = sle64(x_322053, i_322072);
                    int64_t defunc_0_f_res_322076;
                    
                    if (cond_322075) {
                        defunc_0_f_res_322076 = (int64_t) 0;
                    } else {
                        int64_t i_322077 = add64(x_322057, i_322072);
                        int64_t defunc_0_add_arg_322078;
                        
                        defunc_0_add_arg_322078 =
                            ((int64_t *) mem_312838.mem)[gtid_300509 *
                                                         (defunc_0_f_res_292820 *
                                                          n_p_292677) +
                                                         i_322051 *
                                                         defunc_0_f_res_292820 +
                                                         i_322077];
                        
                        int64_t defunc_1_add_res_322079 = add64((int64_t) 1,
                                                                defunc_0_add_arg_322078);
                        
                        defunc_0_f_res_322076 = defunc_1_add_res_322079;
                    }
                    
                    double defunc_0_f_res_322080;
                    
                    if (cond_322075) {
                        defunc_0_f_res_322080 = 0.0;
                    } else {
                        int64_t i_322081 = add64(x_322057, i_322072);
                        double defunc_0_add_arg_322082;
                        
                        defunc_0_add_arg_322082 =
                            ((double *) mem_313371.mem)[gtid_300509 *
                                                        (defunc_0_f_res_292820 *
                                                         n_p_292677) +
                                                        i_322051 *
                                                        defunc_0_f_res_292820 +
                                                        i_322081];
                        defunc_0_f_res_322080 = defunc_0_add_arg_322082;
                    }
                    
                    int64_t binop_p_322083 = sub64(defunc_0_f_res_322076,
                                                   defunc_0_m_fun_res_322060);
                    double defunc_0_f_res_322084 =
                           sitofp_i64_f64(binop_p_322083);
                    double abs_res_322085 = fabs(defunc_0_f_res_322084);
                    double tmp1_322086 = abs_res_322085 / x_322058;
                    double x_322087 = tmp1_322086 * tmp1_322086;
                    double y_322088 = tmp1_322086 * x_322087;
                    double tmp2_322089 = 1.0 - y_322088;
                    double x_322090 = tmp2_322089 * tmp2_322089;
                    double tmp3_322091 = tmp2_322089 * x_322090;
                    double tmp4_322092 = defunc_0_f_res_322080 * tmp3_322091;
                    double defunc_1_op_res_322093 = tmp4_322092 + redout_322073;
                    
                    ((double *) mem_313838)[i_322072] = tmp4_322092;
                    
                    double redout_tmp_322113 = defunc_1_op_res_322093;
                    
                    redout_322073 = redout_tmp_322113;
                }
                defunc_2_reduce_res_322070 = redout_322073;
                
                double a_322095 = 2.220446049250313e-16 +
                       defunc_2_reduce_res_322070;
                double a0_322096 = 1.0 / a_322095;
                double defunc_2_reduce_res_322097;
                double redout_322099 = 0.0;
                
                for (int64_t i_322098 = 0; i_322098 < q_s_292678; i_322098++) {
                    double x_322100;
                    
                    x_322100 = ((double *) mem_313838)[i_322098];
                    
                    bool cond_322101 = sle64(x_322053, i_322098);
                    double defunc_0_f_res_322102;
                    
                    if (cond_322101) {
                        defunc_0_f_res_322102 = 0.0;
                    } else {
                        int64_t i_322103 = add64(x_322057, i_322098);
                        double defunc_0_add_arg_322104;
                        
                        defunc_0_add_arg_322104 =
                            ((double *) mem_313366.mem)[gtid_300509 *
                                                        (defunc_0_f_res_292820 *
                                                         n_p_292677) +
                                                        i_322051 *
                                                        defunc_0_f_res_292820 +
                                                        i_322103];
                        defunc_0_f_res_322102 = defunc_0_add_arg_322104;
                    }
                    
                    double x_322105 = a0_322096 * x_322100;
                    double defunc_9_fit_fun_res_322106 = defunc_0_f_res_322102 *
                           x_322105;
                    double defunc_1_op_res_322107 =
                           defunc_9_fit_fun_res_322106 + redout_322099;
                    double redout_tmp_322115 = defunc_1_op_res_322107;
                    
                    redout_322099 = redout_tmp_322115;
                }
                defunc_2_reduce_res_322097 = redout_322099;
                ((double *) mem_313814)[i_322051 * s_n_m_292825 + i_322055] =
                    defunc_2_reduce_res_322097;
            }
        }
        if (n_p_292677 * s_n_m_292825 * (int64_t) 8 > 0)
            memmove(mem_313877.mem + gtid_300509 * (s_n_m_292825 * n_p_292677) *
                    (int64_t) 8, mem_313814 + (int64_t) 0, n_p_292677 *
                    s_n_m_292825 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_313814);
    free(mem_313838);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338049_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338049_end -
                 futhark_mc_segmap_parloop_338049_start;
        
        ctx->futhark_mc_segmap_parloop_338049_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338049_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338049_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_338047(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_300508 = tid;
    int num_tasks_322049 = info.nsubtasks;
    struct futhark_mc_task_338046 *futhark_mc_task_338046 =
                                  (struct futhark_mc_task_338046 *) args;
    struct futhark_context *ctx = futhark_mc_task_338046->ctx;
    uint64_t futhark_mc_segmap_task_338047_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_338047_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_338046->free_n_p_292677;
    int64_t q_s_292678 = futhark_mc_task_338046->free_q_s_292678;
    int64_t jump_s_292684 = futhark_mc_task_338046->free_jump_s_292684;
    int64_t partition_sizze_292766 =
            futhark_mc_task_338046->free_partition_sizze_292766;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_338046->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_task_338046->free_pad_css_len_292821;
    int64_t s_n_m_292825 = futhark_mc_task_338046->free_s_n_m_292825;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_task_338046->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_312842 = {.desc ="mem_312842", .mem =
                                  futhark_mc_task_338046->free_mem_312842,
                                  .size =0, .references =NULL};
    int64_t bytes_312847 = futhark_mc_task_338046->free_bytes_312847;
    int64_t bytes_312899 = futhark_mc_task_338046->free_bytes_312899;
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_task_338046->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_task_338046->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_task_338046->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_task_338046->free_mem_313371,
                                  .size =0, .references =NULL};
    int64_t bytes_313757 = futhark_mc_task_338046->free_bytes_313757;
    struct memblock mem_313877 = {.desc ="mem_313877", .mem =
                                  futhark_mc_task_338046->free_mem_313877,
                                  .size =0, .references =NULL};
    int64_t iter_322050;
    struct futhark_mc_segmap_parloop_struct_338048
    futhark_mc_segmap_parloop_struct_338048;
    
    futhark_mc_segmap_parloop_struct_338048.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338048.free_n_p_292677 = n_p_292677;
    futhark_mc_segmap_parloop_struct_338048.free_q_s_292678 = q_s_292678;
    futhark_mc_segmap_parloop_struct_338048.free_jump_s_292684 = jump_s_292684;
    futhark_mc_segmap_parloop_struct_338048.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_338048.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segmap_parloop_struct_338048.free_pad_css_len_292821 =
        pad_css_len_292821;
    futhark_mc_segmap_parloop_struct_338048.free_s_n_m_292825 = s_n_m_292825;
    futhark_mc_segmap_parloop_struct_338048.free_mem_312838 = mem_312838.mem;
    futhark_mc_segmap_parloop_struct_338048.free_mem_312842 = mem_312842.mem;
    futhark_mc_segmap_parloop_struct_338048.free_bytes_312899 = bytes_312899;
    futhark_mc_segmap_parloop_struct_338048.free_mem_313018 = mem_313018.mem;
    futhark_mc_segmap_parloop_struct_338048.free_mem_313023 = mem_313023.mem;
    futhark_mc_segmap_parloop_struct_338048.free_mem_313366 = mem_313366.mem;
    futhark_mc_segmap_parloop_struct_338048.free_mem_313371 = mem_313371.mem;
    futhark_mc_segmap_parloop_struct_338048.free_bytes_313757 = bytes_313757;
    futhark_mc_segmap_parloop_struct_338048.free_mem_313877 = mem_313877.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338049_task;
    
    futhark_mc_segmap_parloop_338049_task.name =
        "futhark_mc_segmap_parloop_338049";
    futhark_mc_segmap_parloop_338049_task.fn = futhark_mc_segmap_parloop_338049;
    futhark_mc_segmap_parloop_338049_task.args =
        &futhark_mc_segmap_parloop_struct_338048;
    futhark_mc_segmap_parloop_338049_task.iterations = iterations;
    futhark_mc_segmap_parloop_338049_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338049_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338049_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338049_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338049_task);
    
    if (futhark_mc_segmap_parloop_338049_err != 0) {
        err = futhark_mc_segmap_parloop_338049_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338049_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338049_total_end -
                 futhark_mc_segmap_parloop_338049_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338049_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338049_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338049_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_338047_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_338047_end -
                 futhark_mc_segmap_task_338047_start;
        
        ctx->futhark_mc_segmap_task_338047_runs[tid]++;
        ctx->futhark_mc_segmap_task_338047_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_338047_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_segmap_parloop_struct_338053 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_q_s_292678;
    int64_t free_jump_s_292684;
    int64_t free_partition_sizze_292766;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_312842;
    int64_t free_bytes_312847;
    int64_t free_bytes_312899;
    unsigned char *free_mem_313018;
    unsigned char *free_mem_313023;
    unsigned char *free_mem_313366;
    unsigned char *free_mem_313371;
    int64_t free_bytes_313757;
    unsigned char *free_mem_313877;
};
struct futhark_mc_task_338056 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_q_s_292678;
    int64_t free_jump_s_292684;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    int64_t free_gtid_300701;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_312842;
    int64_t free_bytes_312847;
    unsigned char *free_mem_313018;
    unsigned char *free_mem_313023;
    unsigned char *free_mem_313366;
    unsigned char *free_mem_313371;
    int64_t free_bytes_313757;
    unsigned char *free_mem_313810;
};
struct futhark_mc_segmap_parloop_struct_338058 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_q_s_292678;
    int64_t free_jump_s_292684;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    int64_t free_gtid_300701;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_312842;
    int64_t free_bytes_312847;
    unsigned char *free_mem_313018;
    unsigned char *free_mem_313023;
    unsigned char *free_mem_313366;
    unsigned char *free_mem_313371;
    int64_t free_bytes_313757;
    unsigned char *free_mem_313810;
};
static int futhark_mc_segmap_parloop_338059(void *args, int64_t start,
                                            int64_t end, int flat_tid_322231,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338058
    *futhark_mc_segmap_parloop_struct_338058 =
    (struct futhark_mc_segmap_parloop_struct_338058 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338058->ctx;
    uint64_t futhark_mc_segmap_parloop_338059_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338059_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segmap_parloop_struct_338058->free_n_p_292677;
    int64_t q_s_292678 =
            futhark_mc_segmap_parloop_struct_338058->free_q_s_292678;
    int64_t jump_s_292684 =
            futhark_mc_segmap_parloop_struct_338058->free_jump_s_292684;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segmap_parloop_struct_338058->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_segmap_parloop_struct_338058->free_pad_css_len_292821;
    int64_t s_n_m_292825 =
            futhark_mc_segmap_parloop_struct_338058->free_s_n_m_292825;
    int64_t gtid_300701 =
            futhark_mc_segmap_parloop_struct_338058->free_gtid_300701;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_segmap_parloop_struct_338058->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_312842 = {.desc ="mem_312842", .mem =
                                  futhark_mc_segmap_parloop_struct_338058->free_mem_312842,
                                  .size =0, .references =NULL};
    int64_t bytes_312847 =
            futhark_mc_segmap_parloop_struct_338058->free_bytes_312847;
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_segmap_parloop_struct_338058->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_segmap_parloop_struct_338058->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_segmap_parloop_struct_338058->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_segmap_parloop_struct_338058->free_mem_313371,
                                  .size =0, .references =NULL};
    int64_t bytes_313757 =
            futhark_mc_segmap_parloop_struct_338058->free_bytes_313757;
    struct memblock mem_313810 = {.desc ="mem_313810", .mem =
                                  futhark_mc_segmap_parloop_struct_338058->free_mem_313810,
                                  .size =0, .references =NULL};
    size_t mem_322234_cached_sizze_338060 = 0;
    unsigned char *mem_322234 = NULL;
    size_t mem_322236_cached_sizze_338061 = 0;
    unsigned char *mem_322236 = NULL;
    int64_t iterations = end - start;
    int64_t iter_322295 = start;
    
    if (mem_322234_cached_sizze_338060 < (size_t) bytes_312847) {
        mem_322234 = realloc(mem_322234, bytes_312847);
        mem_322234_cached_sizze_338060 = bytes_312847;
    }
    if (mem_322236_cached_sizze_338061 < (size_t) bytes_313757) {
        mem_322236 = realloc(mem_322236, bytes_313757);
        mem_322236_cached_sizze_338061 = bytes_313757;
    }
    for (; iter_322295 < end; iter_322295++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_322350 = n_p_292677;
        int64_t gtid_322232 = iter_322295;
        int64_t remnant_322351 = iter_322295 - gtid_322232;
        int64_t x_322233;
        
        x_322233 = ((int64_t *) mem_312842.mem)[gtid_300701 * n_p_292677 +
                                                gtid_322232];
        for (int64_t i_322296 = 0; i_322296 < s_n_m_292825; i_322296++) {
            int64_t x_322298;
            
            x_322298 = ((int64_t *) mem_313018.mem)[gtid_300701 *
                                                    (s_n_m_292825 *
                                                     n_p_292677) + gtid_322232 *
                                                    s_n_m_292825 + i_322296];
            
            double x_322299;
            
            x_322299 = ((double *) mem_313023.mem)[gtid_300701 * (s_n_m_292825 *
                                                                  n_p_292677) +
                                                   gtid_322232 * s_n_m_292825 +
                                                   i_322296];
            
            bool cond_322300 = i_322296 == (int64_t) 0;
            int64_t defunc_0_m_fun_res_322301;
            
            if (cond_322300) {
                defunc_0_m_fun_res_322301 = (int64_t) 0;
            } else {
                int64_t y_322302 = sub64(s_n_m_292825, (int64_t) 1);
                bool cond_322303 = i_322296 == y_322302;
                int64_t defunc_0_m_fun_res_f_res_322304;
                
                if (cond_322303) {
                    int64_t defunc_0_m_fun_res_f_res_t_res_322305 =
                            sub64(pad_css_len_292821, (int64_t) 1);
                    
                    defunc_0_m_fun_res_f_res_322304 =
                        defunc_0_m_fun_res_f_res_t_res_322305;
                } else {
                    int64_t x_322306 = sub64(i_322296, (int64_t) 1);
                    int64_t x_322307 = mul64(jump_s_292684, x_322306);
                    int64_t min_arg_322308 = add64((int64_t) 1, x_322307);
                    int64_t min_res_322309 = smin64(defunc_0_f_res_292820,
                                                    min_arg_322308);
                    
                    defunc_0_m_fun_res_f_res_322304 = min_res_322309;
                }
                defunc_0_m_fun_res_322301 = defunc_0_m_fun_res_f_res_322304;
            }
            
            double defunc_2_reduce_res_322311;
            double redout_322314 = 0.0;
            
            for (int64_t i_322313 = 0; i_322313 < q_s_292678; i_322313++) {
                bool cond_322316 = sle64(x_322233, i_322313);
                int64_t defunc_0_f_res_322317;
                
                if (cond_322316) {
                    defunc_0_f_res_322317 = (int64_t) 0;
                } else {
                    int64_t i_322318 = add64(x_322298, i_322313);
                    int64_t defunc_0_add_arg_322319;
                    
                    defunc_0_add_arg_322319 =
                        ((int64_t *) mem_312838.mem)[gtid_300701 *
                                                     (defunc_0_f_res_292820 *
                                                      n_p_292677) +
                                                     gtid_322232 *
                                                     defunc_0_f_res_292820 +
                                                     i_322318];
                    
                    int64_t defunc_1_add_res_322320 = add64((int64_t) 1,
                                                            defunc_0_add_arg_322319);
                    
                    defunc_0_f_res_322317 = defunc_1_add_res_322320;
                }
                
                double defunc_0_f_res_322321;
                
                if (cond_322316) {
                    defunc_0_f_res_322321 = 0.0;
                } else {
                    int64_t i_322322 = add64(x_322298, i_322313);
                    double defunc_0_add_arg_322323;
                    
                    defunc_0_add_arg_322323 =
                        ((double *) mem_313371.mem)[gtid_300701 *
                                                    (defunc_0_f_res_292820 *
                                                     n_p_292677) + gtid_322232 *
                                                    defunc_0_f_res_292820 +
                                                    i_322322];
                    defunc_0_f_res_322321 = defunc_0_add_arg_322323;
                }
                
                int64_t binop_p_322324 = sub64(defunc_0_f_res_322317,
                                               defunc_0_m_fun_res_322301);
                double defunc_0_f_res_322325 = sitofp_i64_f64(binop_p_322324);
                double abs_res_322326 = fabs(defunc_0_f_res_322325);
                double tmp1_322327 = abs_res_322326 / x_322299;
                double x_322328 = tmp1_322327 * tmp1_322327;
                double y_322329 = tmp1_322327 * x_322328;
                double tmp2_322330 = 1.0 - y_322329;
                double x_322331 = tmp2_322330 * tmp2_322330;
                double tmp3_322332 = tmp2_322330 * x_322331;
                double tmp4_322333 = defunc_0_f_res_322321 * tmp3_322332;
                double defunc_1_op_res_322334 = tmp4_322333 + redout_322314;
                
                ((double *) mem_322236)[i_322313] = tmp4_322333;
                
                double redout_tmp_322353 = defunc_1_op_res_322334;
                
                redout_322314 = redout_tmp_322353;
            }
            defunc_2_reduce_res_322311 = redout_322314;
            
            double a_322336 = 2.220446049250313e-16 +
                   defunc_2_reduce_res_322311;
            double a0_322337 = 1.0 / a_322336;
            double defunc_2_reduce_res_322338;
            double redout_322340 = 0.0;
            
            for (int64_t i_322339 = 0; i_322339 < q_s_292678; i_322339++) {
                double x_322341;
                
                x_322341 = ((double *) mem_322236)[i_322339];
                
                bool cond_322342 = sle64(x_322233, i_322339);
                double defunc_0_f_res_322343;
                
                if (cond_322342) {
                    defunc_0_f_res_322343 = 0.0;
                } else {
                    int64_t i_322344 = add64(x_322298, i_322339);
                    double defunc_0_add_arg_322345;
                    
                    defunc_0_add_arg_322345 =
                        ((double *) mem_313366.mem)[gtid_300701 *
                                                    (defunc_0_f_res_292820 *
                                                     n_p_292677) + gtid_322232 *
                                                    defunc_0_f_res_292820 +
                                                    i_322344];
                    defunc_0_f_res_322343 = defunc_0_add_arg_322345;
                }
                
                double x_322346 = a0_322337 * x_322341;
                double defunc_9_fit_fun_res_322347 = defunc_0_f_res_322343 *
                       x_322346;
                double defunc_1_op_res_322348 = defunc_9_fit_fun_res_322347 +
                       redout_322340;
                double redout_tmp_322355 = defunc_1_op_res_322348;
                
                redout_322340 = redout_tmp_322355;
            }
            defunc_2_reduce_res_322338 = redout_322340;
            ((double *) mem_322234)[i_322296] = defunc_2_reduce_res_322338;
        }
        if (s_n_m_292825 * (int64_t) 8 > 0)
            memmove(mem_313810.mem + gtid_322232 * s_n_m_292825 * (int64_t) 8,
                    mem_322234 + (int64_t) 0, s_n_m_292825 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_322234);
    free(mem_322236);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338059_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338059_end -
                 futhark_mc_segmap_parloop_338059_start;
        
        ctx->futhark_mc_segmap_parloop_338059_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338059_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338059_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_338057(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_322231 = tid;
    int num_tasks_322294 = info.nsubtasks;
    struct futhark_mc_task_338056 *futhark_mc_task_338056 =
                                  (struct futhark_mc_task_338056 *) args;
    struct futhark_context *ctx = futhark_mc_task_338056->ctx;
    uint64_t futhark_mc_segmap_task_338057_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_338057_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_338056->free_n_p_292677;
    int64_t q_s_292678 = futhark_mc_task_338056->free_q_s_292678;
    int64_t jump_s_292684 = futhark_mc_task_338056->free_jump_s_292684;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_338056->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_task_338056->free_pad_css_len_292821;
    int64_t s_n_m_292825 = futhark_mc_task_338056->free_s_n_m_292825;
    int64_t gtid_300701 = futhark_mc_task_338056->free_gtid_300701;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_task_338056->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_312842 = {.desc ="mem_312842", .mem =
                                  futhark_mc_task_338056->free_mem_312842,
                                  .size =0, .references =NULL};
    int64_t bytes_312847 = futhark_mc_task_338056->free_bytes_312847;
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_task_338056->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_task_338056->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_task_338056->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_task_338056->free_mem_313371,
                                  .size =0, .references =NULL};
    int64_t bytes_313757 = futhark_mc_task_338056->free_bytes_313757;
    struct memblock mem_313810 = {.desc ="mem_313810", .mem =
                                  futhark_mc_task_338056->free_mem_313810,
                                  .size =0, .references =NULL};
    int64_t iter_322295;
    struct futhark_mc_segmap_parloop_struct_338058
    futhark_mc_segmap_parloop_struct_338058;
    
    futhark_mc_segmap_parloop_struct_338058.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338058.free_n_p_292677 = n_p_292677;
    futhark_mc_segmap_parloop_struct_338058.free_q_s_292678 = q_s_292678;
    futhark_mc_segmap_parloop_struct_338058.free_jump_s_292684 = jump_s_292684;
    futhark_mc_segmap_parloop_struct_338058.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segmap_parloop_struct_338058.free_pad_css_len_292821 =
        pad_css_len_292821;
    futhark_mc_segmap_parloop_struct_338058.free_s_n_m_292825 = s_n_m_292825;
    futhark_mc_segmap_parloop_struct_338058.free_gtid_300701 = gtid_300701;
    futhark_mc_segmap_parloop_struct_338058.free_mem_312838 = mem_312838.mem;
    futhark_mc_segmap_parloop_struct_338058.free_mem_312842 = mem_312842.mem;
    futhark_mc_segmap_parloop_struct_338058.free_bytes_312847 = bytes_312847;
    futhark_mc_segmap_parloop_struct_338058.free_mem_313018 = mem_313018.mem;
    futhark_mc_segmap_parloop_struct_338058.free_mem_313023 = mem_313023.mem;
    futhark_mc_segmap_parloop_struct_338058.free_mem_313366 = mem_313366.mem;
    futhark_mc_segmap_parloop_struct_338058.free_mem_313371 = mem_313371.mem;
    futhark_mc_segmap_parloop_struct_338058.free_bytes_313757 = bytes_313757;
    futhark_mc_segmap_parloop_struct_338058.free_mem_313810 = mem_313810.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338059_task;
    
    futhark_mc_segmap_parloop_338059_task.name =
        "futhark_mc_segmap_parloop_338059";
    futhark_mc_segmap_parloop_338059_task.fn = futhark_mc_segmap_parloop_338059;
    futhark_mc_segmap_parloop_338059_task.args =
        &futhark_mc_segmap_parloop_struct_338058;
    futhark_mc_segmap_parloop_338059_task.iterations = iterations;
    futhark_mc_segmap_parloop_338059_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338059_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338059_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338059_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338059_task);
    
    if (futhark_mc_segmap_parloop_338059_err != 0) {
        err = futhark_mc_segmap_parloop_338059_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338059_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338059_total_end -
                 futhark_mc_segmap_parloop_338059_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338059_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338059_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338059_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_338057_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_338057_end -
                 futhark_mc_segmap_task_338057_start;
        
        ctx->futhark_mc_segmap_task_338057_runs[tid]++;
        ctx->futhark_mc_segmap_task_338057_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_338057_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_segmap_parloop_struct_338063 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_q_s_292678;
    int64_t free_jump_s_292684;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    int64_t free_gtid_300701;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_312842;
    int64_t free_bytes_312847;
    unsigned char *free_mem_313018;
    unsigned char *free_mem_313023;
    unsigned char *free_mem_313366;
    unsigned char *free_mem_313371;
    int64_t free_bytes_313757;
    unsigned char *free_mem_313810;
};
struct futhark_mc_task_338066 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_q_s_292678;
    int64_t free_jump_s_292684;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    int64_t free_gtid_300701;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_313018;
    unsigned char *free_mem_313023;
    unsigned char *free_mem_313366;
    unsigned char *free_mem_313371;
    int64_t free_bytes_313757;
    int64_t free_gtid_322118;
    int64_t free_x_322119;
    unsigned char *free_mem_322120;
};
struct futhark_mc_segmap_parloop_struct_338068 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_q_s_292678;
    int64_t free_jump_s_292684;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    int64_t free_gtid_300701;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_313018;
    unsigned char *free_mem_313023;
    unsigned char *free_mem_313366;
    unsigned char *free_mem_313371;
    int64_t free_bytes_313757;
    int64_t free_gtid_322118;
    int64_t free_x_322119;
    unsigned char *free_mem_322120;
};
static int futhark_mc_segmap_parloop_338069(void *args, int64_t start,
                                            int64_t end, int flat_tid_322412,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338068
    *futhark_mc_segmap_parloop_struct_338068 =
    (struct futhark_mc_segmap_parloop_struct_338068 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338068->ctx;
    uint64_t futhark_mc_segmap_parloop_338069_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338069_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segmap_parloop_struct_338068->free_n_p_292677;
    int64_t q_s_292678 =
            futhark_mc_segmap_parloop_struct_338068->free_q_s_292678;
    int64_t jump_s_292684 =
            futhark_mc_segmap_parloop_struct_338068->free_jump_s_292684;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segmap_parloop_struct_338068->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_segmap_parloop_struct_338068->free_pad_css_len_292821;
    int64_t s_n_m_292825 =
            futhark_mc_segmap_parloop_struct_338068->free_s_n_m_292825;
    int64_t gtid_300701 =
            futhark_mc_segmap_parloop_struct_338068->free_gtid_300701;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_segmap_parloop_struct_338068->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_segmap_parloop_struct_338068->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_segmap_parloop_struct_338068->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_segmap_parloop_struct_338068->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_segmap_parloop_struct_338068->free_mem_313371,
                                  .size =0, .references =NULL};
    int64_t bytes_313757 =
            futhark_mc_segmap_parloop_struct_338068->free_bytes_313757;
    int64_t gtid_322118 =
            futhark_mc_segmap_parloop_struct_338068->free_gtid_322118;
    int64_t x_322119 = futhark_mc_segmap_parloop_struct_338068->free_x_322119;
    struct memblock mem_322120 = {.desc ="mem_322120", .mem =
                                  futhark_mc_segmap_parloop_struct_338068->free_mem_322120,
                                  .size =0, .references =NULL};
    size_t mem_322426_cached_sizze_338070 = 0;
    unsigned char *mem_322426 = NULL;
    int64_t iterations = end - start;
    int64_t iter_322469 = start;
    
    if (mem_322426_cached_sizze_338070 < (size_t) bytes_313757) {
        mem_322426 = realloc(mem_322426, bytes_313757);
        mem_322426_cached_sizze_338070 = bytes_313757;
    }
    for (; iter_322469 < end; iter_322469++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_322511 = s_n_m_292825;
        int64_t gtid_322413 = iter_322469;
        int64_t remnant_322512 = iter_322469 - gtid_322413;
        int64_t x_322414;
        
        x_322414 = ((int64_t *) mem_313018.mem)[gtid_300701 * (s_n_m_292825 *
                                                               n_p_292677) +
                                                gtid_322118 * s_n_m_292825 +
                                                gtid_322413];
        
        double x_322415;
        
        x_322415 = ((double *) mem_313023.mem)[gtid_300701 * (s_n_m_292825 *
                                                              n_p_292677) +
                                               gtid_322118 * s_n_m_292825 +
                                               gtid_322413];
        
        bool cond_322416 = gtid_322413 == (int64_t) 0;
        int64_t defunc_0_m_fun_res_322417;
        
        if (cond_322416) {
            defunc_0_m_fun_res_322417 = (int64_t) 0;
        } else {
            int64_t y_322470 = sub64(s_n_m_292825, (int64_t) 1);
            bool cond_322471 = gtid_322413 == y_322470;
            int64_t defunc_0_m_fun_res_f_res_322472;
            
            if (cond_322471) {
                int64_t defunc_0_m_fun_res_f_res_t_res_322473 =
                        sub64(pad_css_len_292821, (int64_t) 1);
                
                defunc_0_m_fun_res_f_res_322472 =
                    defunc_0_m_fun_res_f_res_t_res_322473;
            } else {
                int64_t x_322474 = sub64(gtid_322413, (int64_t) 1);
                int64_t x_322475 = mul64(jump_s_292684, x_322474);
                int64_t min_arg_322476 = add64((int64_t) 1, x_322475);
                int64_t min_res_322477 = smin64(defunc_0_f_res_292820,
                                                min_arg_322476);
                
                defunc_0_m_fun_res_f_res_322472 = min_res_322477;
            }
            defunc_0_m_fun_res_322417 = defunc_0_m_fun_res_f_res_322472;
        }
        
        double defunc_2_reduce_res_322428;
        double redout_322479 = 0.0;
        
        for (int64_t i_322478 = 0; i_322478 < q_s_292678; i_322478++) {
            bool cond_322481 = sle64(x_322119, i_322478);
            int64_t defunc_0_f_res_322482;
            
            if (cond_322481) {
                defunc_0_f_res_322482 = (int64_t) 0;
            } else {
                int64_t i_322483 = add64(x_322414, i_322478);
                int64_t defunc_0_add_arg_322484;
                
                defunc_0_add_arg_322484 =
                    ((int64_t *) mem_312838.mem)[gtid_300701 *
                                                 (defunc_0_f_res_292820 *
                                                  n_p_292677) + gtid_322118 *
                                                 defunc_0_f_res_292820 +
                                                 i_322483];
                
                int64_t defunc_1_add_res_322485 = add64((int64_t) 1,
                                                        defunc_0_add_arg_322484);
                
                defunc_0_f_res_322482 = defunc_1_add_res_322485;
            }
            
            double defunc_0_f_res_322486;
            
            if (cond_322481) {
                defunc_0_f_res_322486 = 0.0;
            } else {
                int64_t i_322487 = add64(x_322414, i_322478);
                double defunc_0_add_arg_322488;
                
                defunc_0_add_arg_322488 =
                    ((double *) mem_313371.mem)[gtid_300701 *
                                                (defunc_0_f_res_292820 *
                                                 n_p_292677) + gtid_322118 *
                                                defunc_0_f_res_292820 +
                                                i_322487];
                defunc_0_f_res_322486 = defunc_0_add_arg_322488;
            }
            
            int64_t binop_p_322489 = sub64(defunc_0_f_res_322482,
                                           defunc_0_m_fun_res_322417);
            double defunc_0_f_res_322490 = sitofp_i64_f64(binop_p_322489);
            double abs_res_322491 = fabs(defunc_0_f_res_322490);
            double tmp1_322492 = abs_res_322491 / x_322415;
            double x_322493 = tmp1_322492 * tmp1_322492;
            double y_322494 = tmp1_322492 * x_322493;
            double tmp2_322495 = 1.0 - y_322494;
            double x_322496 = tmp2_322495 * tmp2_322495;
            double tmp3_322497 = tmp2_322495 * x_322496;
            double tmp4_322498 = defunc_0_f_res_322486 * tmp3_322497;
            double defunc_1_op_res_322499 = tmp4_322498 + redout_322479;
            
            ((double *) mem_322426)[i_322478] = tmp4_322498;
            
            double redout_tmp_322513 = defunc_1_op_res_322499;
            
            redout_322479 = redout_tmp_322513;
        }
        defunc_2_reduce_res_322428 = redout_322479;
        
        double a_322453 = 2.220446049250313e-16 + defunc_2_reduce_res_322428;
        double a0_322454 = 1.0 / a_322453;
        double defunc_2_reduce_res_322455;
        double redout_322502 = 0.0;
        
        for (int64_t i_322501 = 0; i_322501 < q_s_292678; i_322501++) {
            double x_322503;
            
            x_322503 = ((double *) mem_322426)[i_322501];
            
            bool cond_322504 = sle64(x_322119, i_322501);
            double defunc_0_f_res_322505;
            
            if (cond_322504) {
                defunc_0_f_res_322505 = 0.0;
            } else {
                int64_t i_322506 = add64(x_322414, i_322501);
                double defunc_0_add_arg_322507;
                
                defunc_0_add_arg_322507 =
                    ((double *) mem_313366.mem)[gtid_300701 *
                                                (defunc_0_f_res_292820 *
                                                 n_p_292677) + gtid_322118 *
                                                defunc_0_f_res_292820 +
                                                i_322506];
                defunc_0_f_res_322505 = defunc_0_add_arg_322507;
            }
            
            double x_322508 = a0_322454 * x_322503;
            double defunc_9_fit_fun_res_322509 = defunc_0_f_res_322505 *
                   x_322508;
            double defunc_1_op_res_322510 = defunc_9_fit_fun_res_322509 +
                   redout_322502;
            double redout_tmp_322515 = defunc_1_op_res_322510;
            
            redout_322502 = redout_tmp_322515;
        }
        defunc_2_reduce_res_322455 = redout_322502;
        ((double *) mem_322120.mem)[gtid_322413] = defunc_2_reduce_res_322455;
    }
    
  cleanup:
    { }
    free(mem_322426);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338069_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338069_end -
                 futhark_mc_segmap_parloop_338069_start;
        
        ctx->futhark_mc_segmap_parloop_338069_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338069_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338069_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_338067(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_322412 = tid;
    int num_tasks_322468 = info.nsubtasks;
    struct futhark_mc_task_338066 *futhark_mc_task_338066 =
                                  (struct futhark_mc_task_338066 *) args;
    struct futhark_context *ctx = futhark_mc_task_338066->ctx;
    uint64_t futhark_mc_segmap_task_338067_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_338067_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_338066->free_n_p_292677;
    int64_t q_s_292678 = futhark_mc_task_338066->free_q_s_292678;
    int64_t jump_s_292684 = futhark_mc_task_338066->free_jump_s_292684;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_338066->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_task_338066->free_pad_css_len_292821;
    int64_t s_n_m_292825 = futhark_mc_task_338066->free_s_n_m_292825;
    int64_t gtid_300701 = futhark_mc_task_338066->free_gtid_300701;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_task_338066->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_task_338066->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_task_338066->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_task_338066->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_task_338066->free_mem_313371,
                                  .size =0, .references =NULL};
    int64_t bytes_313757 = futhark_mc_task_338066->free_bytes_313757;
    int64_t gtid_322118 = futhark_mc_task_338066->free_gtid_322118;
    int64_t x_322119 = futhark_mc_task_338066->free_x_322119;
    struct memblock mem_322120 = {.desc ="mem_322120", .mem =
                                  futhark_mc_task_338066->free_mem_322120,
                                  .size =0, .references =NULL};
    int64_t iter_322469;
    struct futhark_mc_segmap_parloop_struct_338068
    futhark_mc_segmap_parloop_struct_338068;
    
    futhark_mc_segmap_parloop_struct_338068.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338068.free_n_p_292677 = n_p_292677;
    futhark_mc_segmap_parloop_struct_338068.free_q_s_292678 = q_s_292678;
    futhark_mc_segmap_parloop_struct_338068.free_jump_s_292684 = jump_s_292684;
    futhark_mc_segmap_parloop_struct_338068.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segmap_parloop_struct_338068.free_pad_css_len_292821 =
        pad_css_len_292821;
    futhark_mc_segmap_parloop_struct_338068.free_s_n_m_292825 = s_n_m_292825;
    futhark_mc_segmap_parloop_struct_338068.free_gtid_300701 = gtid_300701;
    futhark_mc_segmap_parloop_struct_338068.free_mem_312838 = mem_312838.mem;
    futhark_mc_segmap_parloop_struct_338068.free_mem_313018 = mem_313018.mem;
    futhark_mc_segmap_parloop_struct_338068.free_mem_313023 = mem_313023.mem;
    futhark_mc_segmap_parloop_struct_338068.free_mem_313366 = mem_313366.mem;
    futhark_mc_segmap_parloop_struct_338068.free_mem_313371 = mem_313371.mem;
    futhark_mc_segmap_parloop_struct_338068.free_bytes_313757 = bytes_313757;
    futhark_mc_segmap_parloop_struct_338068.free_gtid_322118 = gtid_322118;
    futhark_mc_segmap_parloop_struct_338068.free_x_322119 = x_322119;
    futhark_mc_segmap_parloop_struct_338068.free_mem_322120 = mem_322120.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338069_task;
    
    futhark_mc_segmap_parloop_338069_task.name =
        "futhark_mc_segmap_parloop_338069";
    futhark_mc_segmap_parloop_338069_task.fn = futhark_mc_segmap_parloop_338069;
    futhark_mc_segmap_parloop_338069_task.args =
        &futhark_mc_segmap_parloop_struct_338068;
    futhark_mc_segmap_parloop_338069_task.iterations = iterations;
    futhark_mc_segmap_parloop_338069_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338069_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338069_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338069_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338069_task);
    
    if (futhark_mc_segmap_parloop_338069_err != 0) {
        err = futhark_mc_segmap_parloop_338069_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338069_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338069_total_end -
                 futhark_mc_segmap_parloop_338069_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338069_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338069_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338069_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_338067_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_338067_end -
                 futhark_mc_segmap_task_338067_start;
        
        ctx->futhark_mc_segmap_task_338067_runs[tid]++;
        ctx->futhark_mc_segmap_task_338067_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_338067_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_segmap_parloop_struct_338072 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_q_s_292678;
    int64_t free_jump_s_292684;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    int64_t free_gtid_300701;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_313018;
    unsigned char *free_mem_313023;
    unsigned char *free_mem_313366;
    unsigned char *free_mem_313371;
    int64_t free_bytes_313757;
    int64_t free_gtid_322118;
    int64_t free_x_322119;
    unsigned char *free_mem_322120;
};
struct futhark_mc_task_338075 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_gtid_300701;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_313371;
    int64_t free_gtid_322118;
    int64_t free_x_322119;
    int64_t free_x_322359;
    double free_x_322360;
    int64_t free_defunc_0_m_fun_res_322362;
    double *retval_defunc_2_reduce_res_322372;
    unsigned char *retval_mem_322371;
};
struct futhark_mc_segred_stage_1_parloop_struct_338078 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_gtid_300701;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_313371;
    int64_t free_gtid_322118;
    int64_t free_x_322119;
    int64_t free_x_322359;
    double free_x_322360;
    int64_t free_defunc_0_m_fun_res_322362;
    unsigned char *free_mem_322371;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_322563;
};
static int futhark_mc_segred_stage_1_parloop_338079(void *args, int64_t start,
                                                    int64_t end,
                                                    int flat_tid_322525,
                                                    int tid)
{
    int err = 0;
    struct futhark_mc_segred_stage_1_parloop_struct_338078
    *futhark_mc_segred_stage_1_parloop_struct_338078 =
    (struct futhark_mc_segred_stage_1_parloop_struct_338078 *) args;
    struct futhark_context *ctx =
                           futhark_mc_segred_stage_1_parloop_struct_338078->ctx;
    uint64_t futhark_mc_segred_stage_1_parloop_338079_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_338079_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segred_stage_1_parloop_struct_338078->free_n_p_292677;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segred_stage_1_parloop_struct_338078->free_defunc_0_f_res_292820;
    int64_t gtid_300701 =
            futhark_mc_segred_stage_1_parloop_struct_338078->free_gtid_300701;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_338078->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_338078->free_mem_313371,
                                  .size =0, .references =NULL};
    int64_t gtid_322118 =
            futhark_mc_segred_stage_1_parloop_struct_338078->free_gtid_322118;
    int64_t x_322119 =
            futhark_mc_segred_stage_1_parloop_struct_338078->free_x_322119;
    int64_t x_322359 =
            futhark_mc_segred_stage_1_parloop_struct_338078->free_x_322359;
    double x_322360 =
           futhark_mc_segred_stage_1_parloop_struct_338078->free_x_322360;
    int64_t defunc_0_m_fun_res_322362 =
            futhark_mc_segred_stage_1_parloop_struct_338078->free_defunc_0_m_fun_res_322362;
    struct memblock mem_322371 = {.desc ="mem_322371", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_338078->free_mem_322371,
                                  .size =0, .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_322563 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_322563",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338078->free_reduce_stage_1_tid_res_arr_mem_322563,
                                                             .size =0,
                                                             .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_322565 = start;
    double x_322527;
    double x_322528;
    double local_acc_322566 = 0.0;
    
    for (; iter_322565 < end; iter_322565++) {
        int64_t gtid_322526 = iter_322565;
        bool cond_322530 = sle64(x_322119, gtid_322526);
        int64_t defunc_0_f_res_322531;
        
        if (cond_322530) {
            defunc_0_f_res_322531 = (int64_t) 0;
        } else {
            int64_t i_322532 = add64(x_322359, gtid_322526);
            int64_t defunc_0_add_arg_322533;
            
            defunc_0_add_arg_322533 = ((int64_t *) mem_312838.mem)[gtid_300701 *
                                                                   (defunc_0_f_res_292820 *
                                                                    n_p_292677) +
                                                                   gtid_322118 *
                                                                   defunc_0_f_res_292820 +
                                                                   i_322532];
            
            int64_t defunc_1_add_res_322534 = add64((int64_t) 1,
                                                    defunc_0_add_arg_322533);
            
            defunc_0_f_res_322531 = defunc_1_add_res_322534;
        }
        
        double defunc_0_f_res_322535;
        
        if (cond_322530) {
            defunc_0_f_res_322535 = 0.0;
        } else {
            int64_t i_322536 = add64(x_322359, gtid_322526);
            double defunc_0_add_arg_322537;
            
            defunc_0_add_arg_322537 = ((double *) mem_313371.mem)[gtid_300701 *
                                                                  (defunc_0_f_res_292820 *
                                                                   n_p_292677) +
                                                                  gtid_322118 *
                                                                  defunc_0_f_res_292820 +
                                                                  i_322536];
            defunc_0_f_res_322535 = defunc_0_add_arg_322537;
        }
        
        int64_t binop_p_322538 = sub64(defunc_0_f_res_322531,
                                       defunc_0_m_fun_res_322362);
        double defunc_0_f_res_322539 = sitofp_i64_f64(binop_p_322538);
        double abs_res_322540 = fabs(defunc_0_f_res_322539);
        double tmp1_322541 = abs_res_322540 / x_322360;
        double x_322542 = tmp1_322541 * tmp1_322541;
        double y_322543 = tmp1_322541 * x_322542;
        double tmp2_322544 = 1.0 - y_322543;
        double x_322545 = tmp2_322544 * tmp2_322544;
        double tmp3_322546 = tmp2_322544 * x_322545;
        double tmp4_322547 = defunc_0_f_res_322535 * tmp3_322546;
        
        // save map-out results
        {
            ((double *) mem_322371.mem)[gtid_322526] = tmp4_322547;
        }
        // Load accum params
        {
            x_322527 = local_acc_322566;
        }
        // Load next params
        {
            x_322528 = tmp4_322547;
        }
        // Red body
        {
            double defunc_1_op_res_322529 = x_322527 + x_322528;
            
            local_acc_322566 = defunc_1_op_res_322529;
        }
    }
    ((double *) reduce_stage_1_tid_res_arr_mem_322563.mem)[flat_tid_322525] =
        local_acc_322566;
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_338079_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_338079_end -
                 futhark_mc_segred_stage_1_parloop_338079_start;
        
        ctx->futhark_mc_segred_stage_1_parloop_338079_runs[tid]++;
        ctx->futhark_mc_segred_stage_1_parloop_338079_total_runtime[tid] +=
            elapsed;
        ctx->futhark_mc_segred_stage_1_parloop_338079_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segred_task_338076(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_322525 = tid;
    int num_tasks_322562 = info.nsubtasks;
    struct futhark_mc_task_338075 *futhark_mc_task_338075 =
                                  (struct futhark_mc_task_338075 *) args;
    struct futhark_context *ctx = futhark_mc_task_338075->ctx;
    uint64_t futhark_mc_segred_task_338076_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_task_338076_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_338075->free_n_p_292677;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_338075->free_defunc_0_f_res_292820;
    int64_t gtid_300701 = futhark_mc_task_338075->free_gtid_300701;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_task_338075->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_task_338075->free_mem_313371,
                                  .size =0, .references =NULL};
    int64_t gtid_322118 = futhark_mc_task_338075->free_gtid_322118;
    int64_t x_322119 = futhark_mc_task_338075->free_x_322119;
    int64_t x_322359 = futhark_mc_task_338075->free_x_322359;
    double x_322360 = futhark_mc_task_338075->free_x_322360;
    int64_t defunc_0_m_fun_res_322362 =
            futhark_mc_task_338075->free_defunc_0_m_fun_res_322362;
    double defunc_2_reduce_res_322372 =
           *futhark_mc_task_338075->retval_defunc_2_reduce_res_322372;
    struct memblock mem_322371 = {.desc ="mem_322371", .mem =
                                  futhark_mc_task_338075->retval_mem_322371,
                                  .size =0, .references =NULL};
    size_t reduce_stage_1_tid_res_arr_mem_322563_cached_sizze_338077 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_322563 = NULL;
    
    if (reduce_stage_1_tid_res_arr_mem_322563_cached_sizze_338077 <
        (size_t) ((int64_t) 8 * num_tasks_322562)) {
        reduce_stage_1_tid_res_arr_mem_322563 =
            realloc(reduce_stage_1_tid_res_arr_mem_322563, (int64_t) 8 *
                    num_tasks_322562);
        reduce_stage_1_tid_res_arr_mem_322563_cached_sizze_338077 =
            (int64_t) 8 * num_tasks_322562;
    }
    
    int64_t iter_322565;
    struct futhark_mc_segred_stage_1_parloop_struct_338078
    futhark_mc_segred_stage_1_parloop_struct_338078;
    
    futhark_mc_segred_stage_1_parloop_struct_338078.ctx = ctx;
    futhark_mc_segred_stage_1_parloop_struct_338078.free_n_p_292677 =
        n_p_292677;
    futhark_mc_segred_stage_1_parloop_struct_338078.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segred_stage_1_parloop_struct_338078.free_gtid_300701 =
        gtid_300701;
    futhark_mc_segred_stage_1_parloop_struct_338078.free_mem_312838 =
        mem_312838.mem;
    futhark_mc_segred_stage_1_parloop_struct_338078.free_mem_313371 =
        mem_313371.mem;
    futhark_mc_segred_stage_1_parloop_struct_338078.free_gtid_322118 =
        gtid_322118;
    futhark_mc_segred_stage_1_parloop_struct_338078.free_x_322119 = x_322119;
    futhark_mc_segred_stage_1_parloop_struct_338078.free_x_322359 = x_322359;
    futhark_mc_segred_stage_1_parloop_struct_338078.free_x_322360 = x_322360;
    futhark_mc_segred_stage_1_parloop_struct_338078.free_defunc_0_m_fun_res_322362 =
        defunc_0_m_fun_res_322362;
    futhark_mc_segred_stage_1_parloop_struct_338078.free_mem_322371 =
        mem_322371.mem;
    futhark_mc_segred_stage_1_parloop_struct_338078.free_reduce_stage_1_tid_res_arr_mem_322563 =
        reduce_stage_1_tid_res_arr_mem_322563;
    
    struct scheduler_parloop futhark_mc_segred_stage_1_parloop_338079_task;
    
    futhark_mc_segred_stage_1_parloop_338079_task.name =
        "futhark_mc_segred_stage_1_parloop_338079";
    futhark_mc_segred_stage_1_parloop_338079_task.fn =
        futhark_mc_segred_stage_1_parloop_338079;
    futhark_mc_segred_stage_1_parloop_338079_task.args =
        &futhark_mc_segred_stage_1_parloop_struct_338078;
    futhark_mc_segred_stage_1_parloop_338079_task.iterations = iterations;
    futhark_mc_segred_stage_1_parloop_338079_task.info = info;
    
    uint64_t futhark_mc_segred_stage_1_parloop_338079_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_338079_total_start = get_wall_time();
    
    int futhark_mc_segred_stage_1_parloop_338079_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segred_stage_1_parloop_338079_task);
    
    if (futhark_mc_segred_stage_1_parloop_338079_err != 0) {
        err = futhark_mc_segred_stage_1_parloop_338079_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_338079_total_end =
                 get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_338079_total_end -
                 futhark_mc_segred_stage_1_parloop_338079_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338079_total_runs,
                           1, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338079_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338079_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    // neutral-initialise the output
    {
        defunc_2_reduce_res_322372 = 0.0;
    }
    
    double x_322567;
    double x_322568;
    
    for (int32_t i_322570 = 0; i_322570 < num_tasks_322562; i_322570++) {
        flat_tid_322525 = i_322570;
        // Apply main thread reduction
        {
            // load acc params
            {
                x_322567 = defunc_2_reduce_res_322372;
            }
            // load next params
            {
                x_322568 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_322563)[flat_tid_322525];
            }
            // red body
            {
                double defunc_1_op_res_322569 = x_322567 + x_322568;
                
                defunc_2_reduce_res_322372 = defunc_1_op_res_322569;
            }
        }
    }
    
  cleanup:
    {
        free(reduce_stage_1_tid_res_arr_mem_322563);
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_task_338076_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_task_338076_end -
                 futhark_mc_segred_task_338076_start;
        
        ctx->futhark_mc_segred_task_338076_runs[tid]++;
        ctx->futhark_mc_segred_task_338076_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segred_task_338076_iter[tid] += iterations;
    }
    if (err == 0) {
        *futhark_mc_task_338075->retval_defunc_2_reduce_res_322372 =
            defunc_2_reduce_res_322372;
        futhark_mc_task_338075->retval_mem_322371 = mem_322371.mem;
    }
    return err;
}
struct futhark_mc_task_338080 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_gtid_300701;
    unsigned char *free_mem_313366;
    int64_t free_gtid_322118;
    int64_t free_x_322119;
    int64_t free_x_322359;
    unsigned char *free_mem_322371;
    double free_a0_322398;
    double *retval_defunc_2_reduce_res_322399;
};
struct futhark_mc_segred_stage_1_parloop_struct_338083 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_gtid_300701;
    unsigned char *free_mem_313366;
    int64_t free_gtid_322118;
    int64_t free_x_322119;
    int64_t free_x_322359;
    unsigned char *free_mem_322371;
    double free_a0_322398;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_322572;
};
static int futhark_mc_segred_stage_1_parloop_338084(void *args, int64_t start,
                                                    int64_t end,
                                                    int flat_tid_322548,
                                                    int tid)
{
    int err = 0;
    struct futhark_mc_segred_stage_1_parloop_struct_338083
    *futhark_mc_segred_stage_1_parloop_struct_338083 =
    (struct futhark_mc_segred_stage_1_parloop_struct_338083 *) args;
    struct futhark_context *ctx =
                           futhark_mc_segred_stage_1_parloop_struct_338083->ctx;
    uint64_t futhark_mc_segred_stage_1_parloop_338084_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_338084_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segred_stage_1_parloop_struct_338083->free_n_p_292677;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segred_stage_1_parloop_struct_338083->free_defunc_0_f_res_292820;
    int64_t gtid_300701 =
            futhark_mc_segred_stage_1_parloop_struct_338083->free_gtid_300701;
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_338083->free_mem_313366,
                                  .size =0, .references =NULL};
    int64_t gtid_322118 =
            futhark_mc_segred_stage_1_parloop_struct_338083->free_gtid_322118;
    int64_t x_322119 =
            futhark_mc_segred_stage_1_parloop_struct_338083->free_x_322119;
    int64_t x_322359 =
            futhark_mc_segred_stage_1_parloop_struct_338083->free_x_322359;
    struct memblock mem_322371 = {.desc ="mem_322371", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_338083->free_mem_322371,
                                  .size =0, .references =NULL};
    double a0_322398 =
           futhark_mc_segred_stage_1_parloop_struct_338083->free_a0_322398;
    struct memblock reduce_stage_1_tid_res_arr_mem_322572 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_322572",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338083->free_reduce_stage_1_tid_res_arr_mem_322572,
                                                             .size =0,
                                                             .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_322574 = start;
    double x_322550;
    double x_322551;
    double local_acc_322575 = 0.0;
    
    for (; iter_322574 < end; iter_322574++) {
        int64_t gtid_322549 = iter_322574;
        double x_322553;
        
        x_322553 = ((double *) mem_322371.mem)[gtid_322549];
        
        bool cond_322554 = sle64(x_322119, gtid_322549);
        double defunc_0_f_res_322555;
        
        if (cond_322554) {
            defunc_0_f_res_322555 = 0.0;
        } else {
            int64_t i_322556 = add64(x_322359, gtid_322549);
            double defunc_0_add_arg_322557;
            
            defunc_0_add_arg_322557 = ((double *) mem_313366.mem)[gtid_300701 *
                                                                  (defunc_0_f_res_292820 *
                                                                   n_p_292677) +
                                                                  gtid_322118 *
                                                                  defunc_0_f_res_292820 +
                                                                  i_322556];
            defunc_0_f_res_322555 = defunc_0_add_arg_322557;
        }
        
        double x_322558 = a0_322398 * x_322553;
        double defunc_9_fit_fun_res_322559 = defunc_0_f_res_322555 * x_322558;
        
        // save map-out results
        { }
        // Load accum params
        {
            x_322550 = local_acc_322575;
        }
        // Load next params
        {
            x_322551 = defunc_9_fit_fun_res_322559;
        }
        // Red body
        {
            double defunc_1_op_res_322552 = x_322550 + x_322551;
            
            local_acc_322575 = defunc_1_op_res_322552;
        }
    }
    ((double *) reduce_stage_1_tid_res_arr_mem_322572.mem)[flat_tid_322548] =
        local_acc_322575;
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_338084_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_338084_end -
                 futhark_mc_segred_stage_1_parloop_338084_start;
        
        ctx->futhark_mc_segred_stage_1_parloop_338084_runs[tid]++;
        ctx->futhark_mc_segred_stage_1_parloop_338084_total_runtime[tid] +=
            elapsed;
        ctx->futhark_mc_segred_stage_1_parloop_338084_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segred_task_338081(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_322548 = tid;
    int num_tasks_322571 = info.nsubtasks;
    struct futhark_mc_task_338080 *futhark_mc_task_338080 =
                                  (struct futhark_mc_task_338080 *) args;
    struct futhark_context *ctx = futhark_mc_task_338080->ctx;
    uint64_t futhark_mc_segred_task_338081_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_task_338081_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_338080->free_n_p_292677;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_338080->free_defunc_0_f_res_292820;
    int64_t gtid_300701 = futhark_mc_task_338080->free_gtid_300701;
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_task_338080->free_mem_313366,
                                  .size =0, .references =NULL};
    int64_t gtid_322118 = futhark_mc_task_338080->free_gtid_322118;
    int64_t x_322119 = futhark_mc_task_338080->free_x_322119;
    int64_t x_322359 = futhark_mc_task_338080->free_x_322359;
    struct memblock mem_322371 = {.desc ="mem_322371", .mem =
                                  futhark_mc_task_338080->free_mem_322371,
                                  .size =0, .references =NULL};
    double a0_322398 = futhark_mc_task_338080->free_a0_322398;
    double defunc_2_reduce_res_322399 =
           *futhark_mc_task_338080->retval_defunc_2_reduce_res_322399;
    size_t reduce_stage_1_tid_res_arr_mem_322572_cached_sizze_338082 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_322572 = NULL;
    
    if (reduce_stage_1_tid_res_arr_mem_322572_cached_sizze_338082 <
        (size_t) ((int64_t) 8 * num_tasks_322571)) {
        reduce_stage_1_tid_res_arr_mem_322572 =
            realloc(reduce_stage_1_tid_res_arr_mem_322572, (int64_t) 8 *
                    num_tasks_322571);
        reduce_stage_1_tid_res_arr_mem_322572_cached_sizze_338082 =
            (int64_t) 8 * num_tasks_322571;
    }
    
    int64_t iter_322574;
    struct futhark_mc_segred_stage_1_parloop_struct_338083
    futhark_mc_segred_stage_1_parloop_struct_338083;
    
    futhark_mc_segred_stage_1_parloop_struct_338083.ctx = ctx;
    futhark_mc_segred_stage_1_parloop_struct_338083.free_n_p_292677 =
        n_p_292677;
    futhark_mc_segred_stage_1_parloop_struct_338083.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segred_stage_1_parloop_struct_338083.free_gtid_300701 =
        gtid_300701;
    futhark_mc_segred_stage_1_parloop_struct_338083.free_mem_313366 =
        mem_313366.mem;
    futhark_mc_segred_stage_1_parloop_struct_338083.free_gtid_322118 =
        gtid_322118;
    futhark_mc_segred_stage_1_parloop_struct_338083.free_x_322119 = x_322119;
    futhark_mc_segred_stage_1_parloop_struct_338083.free_x_322359 = x_322359;
    futhark_mc_segred_stage_1_parloop_struct_338083.free_mem_322371 =
        mem_322371.mem;
    futhark_mc_segred_stage_1_parloop_struct_338083.free_a0_322398 = a0_322398;
    futhark_mc_segred_stage_1_parloop_struct_338083.free_reduce_stage_1_tid_res_arr_mem_322572 =
        reduce_stage_1_tid_res_arr_mem_322572;
    
    struct scheduler_parloop futhark_mc_segred_stage_1_parloop_338084_task;
    
    futhark_mc_segred_stage_1_parloop_338084_task.name =
        "futhark_mc_segred_stage_1_parloop_338084";
    futhark_mc_segred_stage_1_parloop_338084_task.fn =
        futhark_mc_segred_stage_1_parloop_338084;
    futhark_mc_segred_stage_1_parloop_338084_task.args =
        &futhark_mc_segred_stage_1_parloop_struct_338083;
    futhark_mc_segred_stage_1_parloop_338084_task.iterations = iterations;
    futhark_mc_segred_stage_1_parloop_338084_task.info = info;
    
    uint64_t futhark_mc_segred_stage_1_parloop_338084_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_338084_total_start = get_wall_time();
    
    int futhark_mc_segred_stage_1_parloop_338084_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segred_stage_1_parloop_338084_task);
    
    if (futhark_mc_segred_stage_1_parloop_338084_err != 0) {
        err = futhark_mc_segred_stage_1_parloop_338084_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_338084_total_end =
                 get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_338084_total_end -
                 futhark_mc_segred_stage_1_parloop_338084_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338084_total_runs,
                           1, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338084_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338084_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    // neutral-initialise the output
    {
        defunc_2_reduce_res_322399 = 0.0;
    }
    
    double x_322576;
    double x_322577;
    
    for (int32_t i_322579 = 0; i_322579 < num_tasks_322571; i_322579++) {
        flat_tid_322548 = i_322579;
        // Apply main thread reduction
        {
            // load acc params
            {
                x_322576 = defunc_2_reduce_res_322399;
            }
            // load next params
            {
                x_322577 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_322572)[flat_tid_322548];
            }
            // red body
            {
                double defunc_1_op_res_322578 = x_322576 + x_322577;
                
                defunc_2_reduce_res_322399 = defunc_1_op_res_322578;
            }
        }
    }
    
  cleanup:
    {
        free(reduce_stage_1_tid_res_arr_mem_322572);
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_task_338081_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_task_338081_end -
                 futhark_mc_segred_task_338081_start;
        
        ctx->futhark_mc_segred_task_338081_runs[tid]++;
        ctx->futhark_mc_segred_task_338081_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segred_task_338081_iter[tid] += iterations;
    }
    if (err == 0) {
        *futhark_mc_task_338080->retval_defunc_2_reduce_res_322399 =
            defunc_2_reduce_res_322399;
    }
    return err;
}
static int futhark_mc_segmap_parloop_338073(void *args, int64_t start,
                                            int64_t end, int flat_tid_322357,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338072
    *futhark_mc_segmap_parloop_struct_338072 =
    (struct futhark_mc_segmap_parloop_struct_338072 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338072->ctx;
    uint64_t futhark_mc_segmap_parloop_338073_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338073_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segmap_parloop_struct_338072->free_n_p_292677;
    int64_t q_s_292678 =
            futhark_mc_segmap_parloop_struct_338072->free_q_s_292678;
    int64_t jump_s_292684 =
            futhark_mc_segmap_parloop_struct_338072->free_jump_s_292684;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segmap_parloop_struct_338072->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_segmap_parloop_struct_338072->free_pad_css_len_292821;
    int64_t s_n_m_292825 =
            futhark_mc_segmap_parloop_struct_338072->free_s_n_m_292825;
    int64_t gtid_300701 =
            futhark_mc_segmap_parloop_struct_338072->free_gtid_300701;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_segmap_parloop_struct_338072->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_segmap_parloop_struct_338072->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_segmap_parloop_struct_338072->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_segmap_parloop_struct_338072->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_segmap_parloop_struct_338072->free_mem_313371,
                                  .size =0, .references =NULL};
    int64_t bytes_313757 =
            futhark_mc_segmap_parloop_struct_338072->free_bytes_313757;
    int64_t gtid_322118 =
            futhark_mc_segmap_parloop_struct_338072->free_gtid_322118;
    int64_t x_322119 = futhark_mc_segmap_parloop_struct_338072->free_x_322119;
    struct memblock mem_322120 = {.desc ="mem_322120", .mem =
                                  futhark_mc_segmap_parloop_struct_338072->free_mem_322120,
                                  .size =0, .references =NULL};
    size_t mem_322371_cached_sizze_338074 = 0;
    unsigned char *mem_322371 = NULL;
    int64_t iterations = end - start;
    int64_t iter_322516 = start;
    
    if (mem_322371_cached_sizze_338074 < (size_t) bytes_313757) {
        mem_322371 = realloc(mem_322371, bytes_313757);
        mem_322371_cached_sizze_338074 = bytes_313757;
    }
    for (; iter_322516 < end; iter_322516++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_322560 = s_n_m_292825;
        int64_t gtid_322358 = iter_322516;
        int64_t remnant_322561 = iter_322516 - gtid_322358;
        int64_t x_322359;
        
        x_322359 = ((int64_t *) mem_313018.mem)[gtid_300701 * (s_n_m_292825 *
                                                               n_p_292677) +
                                                gtid_322118 * s_n_m_292825 +
                                                gtid_322358];
        
        double x_322360;
        
        x_322360 = ((double *) mem_313023.mem)[gtid_300701 * (s_n_m_292825 *
                                                              n_p_292677) +
                                               gtid_322118 * s_n_m_292825 +
                                               gtid_322358];
        
        bool cond_322361 = gtid_322358 == (int64_t) 0;
        int64_t defunc_0_m_fun_res_322362;
        
        if (cond_322361) {
            defunc_0_m_fun_res_322362 = (int64_t) 0;
        } else {
            int64_t y_322517 = sub64(s_n_m_292825, (int64_t) 1);
            bool cond_322518 = gtid_322358 == y_322517;
            int64_t defunc_0_m_fun_res_f_res_322519;
            
            if (cond_322518) {
                int64_t defunc_0_m_fun_res_f_res_t_res_322520 =
                        sub64(pad_css_len_292821, (int64_t) 1);
                
                defunc_0_m_fun_res_f_res_322519 =
                    defunc_0_m_fun_res_f_res_t_res_322520;
            } else {
                int64_t x_322521 = sub64(gtid_322358, (int64_t) 1);
                int64_t x_322522 = mul64(jump_s_292684, x_322521);
                int64_t min_arg_322523 = add64((int64_t) 1, x_322522);
                int64_t min_res_322524 = smin64(defunc_0_f_res_292820,
                                                min_arg_322523);
                
                defunc_0_m_fun_res_f_res_322519 = min_res_322524;
            }
            defunc_0_m_fun_res_322362 = defunc_0_m_fun_res_f_res_322519;
        }
        
        double defunc_2_reduce_res_322372;
        int64_t flat_tid_322525 = (int64_t) 0;
        int32_t num_tasks_322562;
        
        defunc_2_reduce_res_322372 = 0.0;
        
        struct futhark_mc_task_338075 futhark_mc_task_338075;
        
        futhark_mc_task_338075.ctx = ctx;
        futhark_mc_task_338075.free_n_p_292677 = n_p_292677;
        futhark_mc_task_338075.free_defunc_0_f_res_292820 =
            defunc_0_f_res_292820;
        futhark_mc_task_338075.free_gtid_300701 = gtid_300701;
        futhark_mc_task_338075.free_mem_312838 = mem_312838.mem;
        futhark_mc_task_338075.free_mem_313371 = mem_313371.mem;
        futhark_mc_task_338075.free_gtid_322118 = gtid_322118;
        futhark_mc_task_338075.free_x_322119 = x_322119;
        futhark_mc_task_338075.free_x_322359 = x_322359;
        futhark_mc_task_338075.free_x_322360 = x_322360;
        futhark_mc_task_338075.free_defunc_0_m_fun_res_322362 =
            defunc_0_m_fun_res_322362;
        futhark_mc_task_338075.retval_defunc_2_reduce_res_322372 =
            &defunc_2_reduce_res_322372;
        futhark_mc_task_338075.retval_mem_322371 = mem_322371;
        
        struct scheduler_segop futhark_mc_task_338075_task;
        
        futhark_mc_task_338075_task.args = &futhark_mc_task_338075;
        futhark_mc_task_338075_task.top_level_fn =
            futhark_mc_segred_task_338076;
        futhark_mc_task_338075_task.name = "futhark_mc_segred_task_338076";
        futhark_mc_task_338075_task.iterations = q_s_292678;
        futhark_mc_task_338075_task.task_time =
            &ctx->futhark_mc_segred_task_338076_total_time;
        futhark_mc_task_338075_task.task_iter =
            &ctx->futhark_mc_segred_task_338076_total_iter;
        futhark_mc_task_338075_task.sched = STATIC;
        futhark_mc_task_338075_task.nested_fn = NULL;
        
        int futhark_mc_segred_task_338076_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_338075_task);
        
        if (futhark_mc_segred_task_338076_err != 0) {
            ;
            err = futhark_mc_segred_task_338076_err;
            goto cleanup;
        }
        
        double a_322397 = 2.220446049250313e-16 + defunc_2_reduce_res_322372;
        double a0_322398 = 1.0 / a_322397;
        double defunc_2_reduce_res_322399;
        int64_t flat_tid_322548 = (int64_t) 0;
        int32_t num_tasks_322571;
        
        defunc_2_reduce_res_322399 = 0.0;
        
        struct futhark_mc_task_338080 futhark_mc_task_338080;
        
        futhark_mc_task_338080.ctx = ctx;
        futhark_mc_task_338080.free_n_p_292677 = n_p_292677;
        futhark_mc_task_338080.free_defunc_0_f_res_292820 =
            defunc_0_f_res_292820;
        futhark_mc_task_338080.free_gtid_300701 = gtid_300701;
        futhark_mc_task_338080.free_mem_313366 = mem_313366.mem;
        futhark_mc_task_338080.free_gtid_322118 = gtid_322118;
        futhark_mc_task_338080.free_x_322119 = x_322119;
        futhark_mc_task_338080.free_x_322359 = x_322359;
        futhark_mc_task_338080.free_mem_322371 = mem_322371;
        futhark_mc_task_338080.free_a0_322398 = a0_322398;
        futhark_mc_task_338080.retval_defunc_2_reduce_res_322399 =
            &defunc_2_reduce_res_322399;
        
        struct scheduler_segop futhark_mc_task_338080_task;
        
        futhark_mc_task_338080_task.args = &futhark_mc_task_338080;
        futhark_mc_task_338080_task.top_level_fn =
            futhark_mc_segred_task_338081;
        futhark_mc_task_338080_task.name = "futhark_mc_segred_task_338081";
        futhark_mc_task_338080_task.iterations = q_s_292678;
        futhark_mc_task_338080_task.task_time =
            &ctx->futhark_mc_segred_task_338081_total_time;
        futhark_mc_task_338080_task.task_iter =
            &ctx->futhark_mc_segred_task_338081_total_iter;
        futhark_mc_task_338080_task.sched = STATIC;
        futhark_mc_task_338080_task.nested_fn = NULL;
        
        int futhark_mc_segred_task_338081_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_338080_task);
        
        if (futhark_mc_segred_task_338081_err != 0) {
            ;
            err = futhark_mc_segred_task_338081_err;
            goto cleanup;
        }
        ((double *) mem_322120.mem)[gtid_322358] = defunc_2_reduce_res_322399;
    }
    
  cleanup:
    { }
    free(mem_322371);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338073_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338073_end -
                 futhark_mc_segmap_parloop_338073_start;
        
        ctx->futhark_mc_segmap_parloop_338073_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338073_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338073_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_nested_task_338071(void *args, int64_t iterations,
                                         int tid, struct scheduler_info info)
{
    int err = 0;
    int flat_tid_322357 = tid;
    int num_tasks_322468 = info.nsubtasks;
    struct futhark_mc_task_338066 *futhark_mc_task_338066 =
                                  (struct futhark_mc_task_338066 *) args;
    struct futhark_context *ctx = futhark_mc_task_338066->ctx;
    uint64_t futhark_mc_segmap_nested_task_338071_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_nested_task_338071_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_338066->free_n_p_292677;
    int64_t q_s_292678 = futhark_mc_task_338066->free_q_s_292678;
    int64_t jump_s_292684 = futhark_mc_task_338066->free_jump_s_292684;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_338066->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_task_338066->free_pad_css_len_292821;
    int64_t s_n_m_292825 = futhark_mc_task_338066->free_s_n_m_292825;
    int64_t gtid_300701 = futhark_mc_task_338066->free_gtid_300701;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_task_338066->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_task_338066->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_task_338066->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_task_338066->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_task_338066->free_mem_313371,
                                  .size =0, .references =NULL};
    int64_t bytes_313757 = futhark_mc_task_338066->free_bytes_313757;
    int64_t gtid_322118 = futhark_mc_task_338066->free_gtid_322118;
    int64_t x_322119 = futhark_mc_task_338066->free_x_322119;
    struct memblock mem_322120 = {.desc ="mem_322120", .mem =
                                  futhark_mc_task_338066->free_mem_322120,
                                  .size =0, .references =NULL};
    int64_t iter_322516;
    struct futhark_mc_segmap_parloop_struct_338072
    futhark_mc_segmap_parloop_struct_338072;
    
    futhark_mc_segmap_parloop_struct_338072.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338072.free_n_p_292677 = n_p_292677;
    futhark_mc_segmap_parloop_struct_338072.free_q_s_292678 = q_s_292678;
    futhark_mc_segmap_parloop_struct_338072.free_jump_s_292684 = jump_s_292684;
    futhark_mc_segmap_parloop_struct_338072.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segmap_parloop_struct_338072.free_pad_css_len_292821 =
        pad_css_len_292821;
    futhark_mc_segmap_parloop_struct_338072.free_s_n_m_292825 = s_n_m_292825;
    futhark_mc_segmap_parloop_struct_338072.free_gtid_300701 = gtid_300701;
    futhark_mc_segmap_parloop_struct_338072.free_mem_312838 = mem_312838.mem;
    futhark_mc_segmap_parloop_struct_338072.free_mem_313018 = mem_313018.mem;
    futhark_mc_segmap_parloop_struct_338072.free_mem_313023 = mem_313023.mem;
    futhark_mc_segmap_parloop_struct_338072.free_mem_313366 = mem_313366.mem;
    futhark_mc_segmap_parloop_struct_338072.free_mem_313371 = mem_313371.mem;
    futhark_mc_segmap_parloop_struct_338072.free_bytes_313757 = bytes_313757;
    futhark_mc_segmap_parloop_struct_338072.free_gtid_322118 = gtid_322118;
    futhark_mc_segmap_parloop_struct_338072.free_x_322119 = x_322119;
    futhark_mc_segmap_parloop_struct_338072.free_mem_322120 = mem_322120.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338073_task;
    
    futhark_mc_segmap_parloop_338073_task.name =
        "futhark_mc_segmap_parloop_338073";
    futhark_mc_segmap_parloop_338073_task.fn = futhark_mc_segmap_parloop_338073;
    futhark_mc_segmap_parloop_338073_task.args =
        &futhark_mc_segmap_parloop_struct_338072;
    futhark_mc_segmap_parloop_338073_task.iterations = iterations;
    futhark_mc_segmap_parloop_338073_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338073_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338073_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338073_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338073_task);
    
    if (futhark_mc_segmap_parloop_338073_err != 0) {
        err = futhark_mc_segmap_parloop_338073_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338073_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338073_total_end -
                 futhark_mc_segmap_parloop_338073_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338073_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338073_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338073_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_nested_task_338071_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_nested_task_338071_end -
                 futhark_mc_segmap_nested_task_338071_start;
        
        ctx->futhark_mc_segmap_nested_task_338071_runs[tid]++;
        ctx->futhark_mc_segmap_nested_task_338071_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_nested_task_338071_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
static int futhark_mc_segmap_parloop_338064(void *args, int64_t start,
                                            int64_t end, int flat_tid_322117,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338063
    *futhark_mc_segmap_parloop_struct_338063 =
    (struct futhark_mc_segmap_parloop_struct_338063 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338063->ctx;
    uint64_t futhark_mc_segmap_parloop_338064_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338064_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segmap_parloop_struct_338063->free_n_p_292677;
    int64_t q_s_292678 =
            futhark_mc_segmap_parloop_struct_338063->free_q_s_292678;
    int64_t jump_s_292684 =
            futhark_mc_segmap_parloop_struct_338063->free_jump_s_292684;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segmap_parloop_struct_338063->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_segmap_parloop_struct_338063->free_pad_css_len_292821;
    int64_t s_n_m_292825 =
            futhark_mc_segmap_parloop_struct_338063->free_s_n_m_292825;
    int64_t gtid_300701 =
            futhark_mc_segmap_parloop_struct_338063->free_gtid_300701;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_segmap_parloop_struct_338063->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_312842 = {.desc ="mem_312842", .mem =
                                  futhark_mc_segmap_parloop_struct_338063->free_mem_312842,
                                  .size =0, .references =NULL};
    int64_t bytes_312847 =
            futhark_mc_segmap_parloop_struct_338063->free_bytes_312847;
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_segmap_parloop_struct_338063->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_segmap_parloop_struct_338063->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_segmap_parloop_struct_338063->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_segmap_parloop_struct_338063->free_mem_313371,
                                  .size =0, .references =NULL};
    int64_t bytes_313757 =
            futhark_mc_segmap_parloop_struct_338063->free_bytes_313757;
    struct memblock mem_313810 = {.desc ="mem_313810", .mem =
                                  futhark_mc_segmap_parloop_struct_338063->free_mem_313810,
                                  .size =0, .references =NULL};
    size_t mem_322120_cached_sizze_338065 = 0;
    unsigned char *mem_322120 = NULL;
    int64_t iterations = end - start;
    int64_t iter_322356 = start;
    
    if (mem_322120_cached_sizze_338065 < (size_t) bytes_312847) {
        mem_322120 = realloc(mem_322120, bytes_312847);
        mem_322120_cached_sizze_338065 = bytes_312847;
    }
    for (; iter_322356 < end; iter_322356++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_322466 = n_p_292677;
        int64_t gtid_322118 = iter_322356;
        int64_t remnant_322467 = iter_322356 - gtid_322118;
        int64_t x_322119;
        
        x_322119 = ((int64_t *) mem_312842.mem)[gtid_300701 * n_p_292677 +
                                                gtid_322118];
        
        int64_t flat_tid_322412 = (int64_t) 0;
        int32_t num_tasks_322468;
        int64_t flat_tid_322357 = (int64_t) 0;
        struct futhark_mc_task_338066 futhark_mc_task_338066;
        
        futhark_mc_task_338066.ctx = ctx;
        futhark_mc_task_338066.free_n_p_292677 = n_p_292677;
        futhark_mc_task_338066.free_q_s_292678 = q_s_292678;
        futhark_mc_task_338066.free_jump_s_292684 = jump_s_292684;
        futhark_mc_task_338066.free_defunc_0_f_res_292820 =
            defunc_0_f_res_292820;
        futhark_mc_task_338066.free_pad_css_len_292821 = pad_css_len_292821;
        futhark_mc_task_338066.free_s_n_m_292825 = s_n_m_292825;
        futhark_mc_task_338066.free_gtid_300701 = gtid_300701;
        futhark_mc_task_338066.free_mem_312838 = mem_312838.mem;
        futhark_mc_task_338066.free_mem_313018 = mem_313018.mem;
        futhark_mc_task_338066.free_mem_313023 = mem_313023.mem;
        futhark_mc_task_338066.free_mem_313366 = mem_313366.mem;
        futhark_mc_task_338066.free_mem_313371 = mem_313371.mem;
        futhark_mc_task_338066.free_bytes_313757 = bytes_313757;
        futhark_mc_task_338066.free_gtid_322118 = gtid_322118;
        futhark_mc_task_338066.free_x_322119 = x_322119;
        futhark_mc_task_338066.free_mem_322120 = mem_322120;
        
        struct scheduler_segop futhark_mc_task_338066_task;
        
        futhark_mc_task_338066_task.args = &futhark_mc_task_338066;
        futhark_mc_task_338066_task.top_level_fn =
            futhark_mc_segmap_task_338067;
        futhark_mc_task_338066_task.name = "futhark_mc_segmap_task_338067";
        futhark_mc_task_338066_task.iterations = s_n_m_292825;
        futhark_mc_task_338066_task.task_time =
            &ctx->futhark_mc_segmap_task_338067_total_time;
        futhark_mc_task_338066_task.task_iter =
            &ctx->futhark_mc_segmap_task_338067_total_iter;
        futhark_mc_task_338066_task.sched = STATIC;
        futhark_mc_task_338066_task.nested_fn =
            futhark_mc_segmap_nested_task_338071;
        
        int futhark_mc_segmap_task_338067_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_338066_task);
        
        if (futhark_mc_segmap_task_338067_err != 0) {
            ;
            err = futhark_mc_segmap_task_338067_err;
            goto cleanup;
        }
        if (s_n_m_292825 * (int64_t) 8 > 0)
            memmove(mem_313810.mem + gtid_322118 * s_n_m_292825 * (int64_t) 8,
                    mem_322120 + (int64_t) 0, s_n_m_292825 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_322120);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338064_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338064_end -
                 futhark_mc_segmap_parloop_338064_start;
        
        ctx->futhark_mc_segmap_parloop_338064_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338064_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338064_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_nested_task_338062(void *args, int64_t iterations,
                                         int tid, struct scheduler_info info)
{
    int err = 0;
    int flat_tid_322117 = tid;
    int num_tasks_322294 = info.nsubtasks;
    struct futhark_mc_task_338056 *futhark_mc_task_338056 =
                                  (struct futhark_mc_task_338056 *) args;
    struct futhark_context *ctx = futhark_mc_task_338056->ctx;
    uint64_t futhark_mc_segmap_nested_task_338062_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_nested_task_338062_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_338056->free_n_p_292677;
    int64_t q_s_292678 = futhark_mc_task_338056->free_q_s_292678;
    int64_t jump_s_292684 = futhark_mc_task_338056->free_jump_s_292684;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_338056->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_task_338056->free_pad_css_len_292821;
    int64_t s_n_m_292825 = futhark_mc_task_338056->free_s_n_m_292825;
    int64_t gtid_300701 = futhark_mc_task_338056->free_gtid_300701;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_task_338056->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_312842 = {.desc ="mem_312842", .mem =
                                  futhark_mc_task_338056->free_mem_312842,
                                  .size =0, .references =NULL};
    int64_t bytes_312847 = futhark_mc_task_338056->free_bytes_312847;
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_task_338056->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_task_338056->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_task_338056->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_task_338056->free_mem_313371,
                                  .size =0, .references =NULL};
    int64_t bytes_313757 = futhark_mc_task_338056->free_bytes_313757;
    struct memblock mem_313810 = {.desc ="mem_313810", .mem =
                                  futhark_mc_task_338056->free_mem_313810,
                                  .size =0, .references =NULL};
    int64_t iter_322356;
    struct futhark_mc_segmap_parloop_struct_338063
    futhark_mc_segmap_parloop_struct_338063;
    
    futhark_mc_segmap_parloop_struct_338063.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338063.free_n_p_292677 = n_p_292677;
    futhark_mc_segmap_parloop_struct_338063.free_q_s_292678 = q_s_292678;
    futhark_mc_segmap_parloop_struct_338063.free_jump_s_292684 = jump_s_292684;
    futhark_mc_segmap_parloop_struct_338063.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segmap_parloop_struct_338063.free_pad_css_len_292821 =
        pad_css_len_292821;
    futhark_mc_segmap_parloop_struct_338063.free_s_n_m_292825 = s_n_m_292825;
    futhark_mc_segmap_parloop_struct_338063.free_gtid_300701 = gtid_300701;
    futhark_mc_segmap_parloop_struct_338063.free_mem_312838 = mem_312838.mem;
    futhark_mc_segmap_parloop_struct_338063.free_mem_312842 = mem_312842.mem;
    futhark_mc_segmap_parloop_struct_338063.free_bytes_312847 = bytes_312847;
    futhark_mc_segmap_parloop_struct_338063.free_mem_313018 = mem_313018.mem;
    futhark_mc_segmap_parloop_struct_338063.free_mem_313023 = mem_313023.mem;
    futhark_mc_segmap_parloop_struct_338063.free_mem_313366 = mem_313366.mem;
    futhark_mc_segmap_parloop_struct_338063.free_mem_313371 = mem_313371.mem;
    futhark_mc_segmap_parloop_struct_338063.free_bytes_313757 = bytes_313757;
    futhark_mc_segmap_parloop_struct_338063.free_mem_313810 = mem_313810.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338064_task;
    
    futhark_mc_segmap_parloop_338064_task.name =
        "futhark_mc_segmap_parloop_338064";
    futhark_mc_segmap_parloop_338064_task.fn = futhark_mc_segmap_parloop_338064;
    futhark_mc_segmap_parloop_338064_task.args =
        &futhark_mc_segmap_parloop_struct_338063;
    futhark_mc_segmap_parloop_338064_task.iterations = iterations;
    futhark_mc_segmap_parloop_338064_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338064_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338064_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338064_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338064_task);
    
    if (futhark_mc_segmap_parloop_338064_err != 0) {
        err = futhark_mc_segmap_parloop_338064_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338064_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338064_total_end -
                 futhark_mc_segmap_parloop_338064_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338064_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338064_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338064_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_nested_task_338062_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_nested_task_338062_end -
                 futhark_mc_segmap_nested_task_338062_start;
        
        ctx->futhark_mc_segmap_nested_task_338062_runs[tid]++;
        ctx->futhark_mc_segmap_nested_task_338062_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_nested_task_338062_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
static int futhark_mc_segmap_parloop_338054(void *args, int64_t start,
                                            int64_t end, int flat_tid_300700,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338053
    *futhark_mc_segmap_parloop_struct_338053 =
    (struct futhark_mc_segmap_parloop_struct_338053 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338053->ctx;
    uint64_t futhark_mc_segmap_parloop_338054_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338054_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segmap_parloop_struct_338053->free_n_p_292677;
    int64_t q_s_292678 =
            futhark_mc_segmap_parloop_struct_338053->free_q_s_292678;
    int64_t jump_s_292684 =
            futhark_mc_segmap_parloop_struct_338053->free_jump_s_292684;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_338053->free_partition_sizze_292766;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segmap_parloop_struct_338053->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_segmap_parloop_struct_338053->free_pad_css_len_292821;
    int64_t s_n_m_292825 =
            futhark_mc_segmap_parloop_struct_338053->free_s_n_m_292825;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_segmap_parloop_struct_338053->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_312842 = {.desc ="mem_312842", .mem =
                                  futhark_mc_segmap_parloop_struct_338053->free_mem_312842,
                                  .size =0, .references =NULL};
    int64_t bytes_312847 =
            futhark_mc_segmap_parloop_struct_338053->free_bytes_312847;
    int64_t bytes_312899 =
            futhark_mc_segmap_parloop_struct_338053->free_bytes_312899;
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_segmap_parloop_struct_338053->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_segmap_parloop_struct_338053->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_segmap_parloop_struct_338053->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_segmap_parloop_struct_338053->free_mem_313371,
                                  .size =0, .references =NULL};
    int64_t bytes_313757 =
            futhark_mc_segmap_parloop_struct_338053->free_bytes_313757;
    struct memblock mem_313877 = {.desc ="mem_313877", .mem =
                                  futhark_mc_segmap_parloop_struct_338053->free_mem_313877,
                                  .size =0, .references =NULL};
    size_t mem_313810_cached_sizze_338055 = 0;
    unsigned char *mem_313810 = NULL;
    int64_t iterations = end - start;
    int64_t iter_322116 = start;
    
    if (mem_313810_cached_sizze_338055 < (size_t) bytes_312899) {
        mem_313810 = realloc(mem_313810, bytes_312899);
        mem_313810_cached_sizze_338055 = bytes_312899;
    }
    for (; iter_322116 < end; iter_322116++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_322292 = partition_sizze_292766;
        int64_t gtid_300701 = iter_322116;
        int64_t remnant_322293 = iter_322116 - gtid_300701;
        int64_t flat_tid_322231 = (int64_t) 0;
        int32_t num_tasks_322294;
        int64_t flat_tid_322117 = (int64_t) 0;
        struct futhark_mc_task_338056 futhark_mc_task_338056;
        
        futhark_mc_task_338056.ctx = ctx;
        futhark_mc_task_338056.free_n_p_292677 = n_p_292677;
        futhark_mc_task_338056.free_q_s_292678 = q_s_292678;
        futhark_mc_task_338056.free_jump_s_292684 = jump_s_292684;
        futhark_mc_task_338056.free_defunc_0_f_res_292820 =
            defunc_0_f_res_292820;
        futhark_mc_task_338056.free_pad_css_len_292821 = pad_css_len_292821;
        futhark_mc_task_338056.free_s_n_m_292825 = s_n_m_292825;
        futhark_mc_task_338056.free_gtid_300701 = gtid_300701;
        futhark_mc_task_338056.free_mem_312838 = mem_312838.mem;
        futhark_mc_task_338056.free_mem_312842 = mem_312842.mem;
        futhark_mc_task_338056.free_bytes_312847 = bytes_312847;
        futhark_mc_task_338056.free_mem_313018 = mem_313018.mem;
        futhark_mc_task_338056.free_mem_313023 = mem_313023.mem;
        futhark_mc_task_338056.free_mem_313366 = mem_313366.mem;
        futhark_mc_task_338056.free_mem_313371 = mem_313371.mem;
        futhark_mc_task_338056.free_bytes_313757 = bytes_313757;
        futhark_mc_task_338056.free_mem_313810 = mem_313810;
        
        struct scheduler_segop futhark_mc_task_338056_task;
        
        futhark_mc_task_338056_task.args = &futhark_mc_task_338056;
        futhark_mc_task_338056_task.top_level_fn =
            futhark_mc_segmap_task_338057;
        futhark_mc_task_338056_task.name = "futhark_mc_segmap_task_338057";
        futhark_mc_task_338056_task.iterations = n_p_292677;
        futhark_mc_task_338056_task.task_time =
            &ctx->futhark_mc_segmap_task_338057_total_time;
        futhark_mc_task_338056_task.task_iter =
            &ctx->futhark_mc_segmap_task_338057_total_iter;
        futhark_mc_task_338056_task.sched = STATIC;
        futhark_mc_task_338056_task.nested_fn =
            futhark_mc_segmap_nested_task_338062;
        
        int futhark_mc_segmap_task_338057_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_338056_task);
        
        if (futhark_mc_segmap_task_338057_err != 0) {
            ;
            err = futhark_mc_segmap_task_338057_err;
            goto cleanup;
        }
        if (n_p_292677 * s_n_m_292825 * (int64_t) 8 > 0)
            memmove(mem_313877.mem + gtid_300701 * (s_n_m_292825 * n_p_292677) *
                    (int64_t) 8, mem_313810 + (int64_t) 0, n_p_292677 *
                    s_n_m_292825 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_313810);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338054_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338054_end -
                 futhark_mc_segmap_parloop_338054_start;
        
        ctx->futhark_mc_segmap_parloop_338054_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338054_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338054_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_nested_task_338052(void *args, int64_t iterations,
                                         int tid, struct scheduler_info info)
{
    int err = 0;
    int flat_tid_300700 = tid;
    int num_tasks_322049 = info.nsubtasks;
    struct futhark_mc_task_338046 *futhark_mc_task_338046 =
                                  (struct futhark_mc_task_338046 *) args;
    struct futhark_context *ctx = futhark_mc_task_338046->ctx;
    uint64_t futhark_mc_segmap_nested_task_338052_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_nested_task_338052_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_338046->free_n_p_292677;
    int64_t q_s_292678 = futhark_mc_task_338046->free_q_s_292678;
    int64_t jump_s_292684 = futhark_mc_task_338046->free_jump_s_292684;
    int64_t partition_sizze_292766 =
            futhark_mc_task_338046->free_partition_sizze_292766;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_338046->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_task_338046->free_pad_css_len_292821;
    int64_t s_n_m_292825 = futhark_mc_task_338046->free_s_n_m_292825;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_task_338046->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_312842 = {.desc ="mem_312842", .mem =
                                  futhark_mc_task_338046->free_mem_312842,
                                  .size =0, .references =NULL};
    int64_t bytes_312847 = futhark_mc_task_338046->free_bytes_312847;
    int64_t bytes_312899 = futhark_mc_task_338046->free_bytes_312899;
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_task_338046->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_task_338046->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_task_338046->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_task_338046->free_mem_313371,
                                  .size =0, .references =NULL};
    int64_t bytes_313757 = futhark_mc_task_338046->free_bytes_313757;
    struct memblock mem_313877 = {.desc ="mem_313877", .mem =
                                  futhark_mc_task_338046->free_mem_313877,
                                  .size =0, .references =NULL};
    int64_t iter_322116;
    struct futhark_mc_segmap_parloop_struct_338053
    futhark_mc_segmap_parloop_struct_338053;
    
    futhark_mc_segmap_parloop_struct_338053.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338053.free_n_p_292677 = n_p_292677;
    futhark_mc_segmap_parloop_struct_338053.free_q_s_292678 = q_s_292678;
    futhark_mc_segmap_parloop_struct_338053.free_jump_s_292684 = jump_s_292684;
    futhark_mc_segmap_parloop_struct_338053.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_338053.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segmap_parloop_struct_338053.free_pad_css_len_292821 =
        pad_css_len_292821;
    futhark_mc_segmap_parloop_struct_338053.free_s_n_m_292825 = s_n_m_292825;
    futhark_mc_segmap_parloop_struct_338053.free_mem_312838 = mem_312838.mem;
    futhark_mc_segmap_parloop_struct_338053.free_mem_312842 = mem_312842.mem;
    futhark_mc_segmap_parloop_struct_338053.free_bytes_312847 = bytes_312847;
    futhark_mc_segmap_parloop_struct_338053.free_bytes_312899 = bytes_312899;
    futhark_mc_segmap_parloop_struct_338053.free_mem_313018 = mem_313018.mem;
    futhark_mc_segmap_parloop_struct_338053.free_mem_313023 = mem_313023.mem;
    futhark_mc_segmap_parloop_struct_338053.free_mem_313366 = mem_313366.mem;
    futhark_mc_segmap_parloop_struct_338053.free_mem_313371 = mem_313371.mem;
    futhark_mc_segmap_parloop_struct_338053.free_bytes_313757 = bytes_313757;
    futhark_mc_segmap_parloop_struct_338053.free_mem_313877 = mem_313877.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338054_task;
    
    futhark_mc_segmap_parloop_338054_task.name =
        "futhark_mc_segmap_parloop_338054";
    futhark_mc_segmap_parloop_338054_task.fn = futhark_mc_segmap_parloop_338054;
    futhark_mc_segmap_parloop_338054_task.args =
        &futhark_mc_segmap_parloop_struct_338053;
    futhark_mc_segmap_parloop_338054_task.iterations = iterations;
    futhark_mc_segmap_parloop_338054_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338054_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338054_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338054_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338054_task);
    
    if (futhark_mc_segmap_parloop_338054_err != 0) {
        err = futhark_mc_segmap_parloop_338054_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338054_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338054_total_end -
                 futhark_mc_segmap_parloop_338054_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338054_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338054_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338054_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_nested_task_338052_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_nested_task_338052_end -
                 futhark_mc_segmap_nested_task_338052_start;
        
        ctx->futhark_mc_segmap_nested_task_338052_runs[tid]++;
        ctx->futhark_mc_segmap_nested_task_338052_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_nested_task_338052_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_task_338085 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_q_s_292678;
    int64_t free_jump_s_292684;
    int64_t free_partition_sizze_292766;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_312842;
    int64_t free_bytes_312847;
    int64_t free_bytes_312899;
    unsigned char *free_mem_313018;
    unsigned char *free_mem_313023;
    unsigned char *free_mem_313366;
    unsigned char *free_mem_313371;
    int64_t free_bytes_313879;
    unsigned char *free_mem_314116;
    unsigned char *free_mem_314121;
};
struct futhark_mc_segmap_parloop_struct_338087 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_q_s_292678;
    int64_t free_jump_s_292684;
    int64_t free_partition_sizze_292766;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_312842;
    int64_t free_bytes_312899;
    unsigned char *free_mem_313018;
    unsigned char *free_mem_313023;
    unsigned char *free_mem_313366;
    unsigned char *free_mem_313371;
    int64_t free_bytes_313879;
    unsigned char *free_mem_314116;
    unsigned char *free_mem_314121;
};
static int futhark_mc_segmap_parloop_338088(void *args, int64_t start,
                                            int64_t end, int flat_tid_300888,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338087
    *futhark_mc_segmap_parloop_struct_338087 =
    (struct futhark_mc_segmap_parloop_struct_338087 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338087->ctx;
    uint64_t futhark_mc_segmap_parloop_338088_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338088_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segmap_parloop_struct_338087->free_n_p_292677;
    int64_t q_s_292678 =
            futhark_mc_segmap_parloop_struct_338087->free_q_s_292678;
    int64_t jump_s_292684 =
            futhark_mc_segmap_parloop_struct_338087->free_jump_s_292684;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_338087->free_partition_sizze_292766;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segmap_parloop_struct_338087->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_segmap_parloop_struct_338087->free_pad_css_len_292821;
    int64_t s_n_m_292825 =
            futhark_mc_segmap_parloop_struct_338087->free_s_n_m_292825;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_segmap_parloop_struct_338087->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_312842 = {.desc ="mem_312842", .mem =
                                  futhark_mc_segmap_parloop_struct_338087->free_mem_312842,
                                  .size =0, .references =NULL};
    int64_t bytes_312899 =
            futhark_mc_segmap_parloop_struct_338087->free_bytes_312899;
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_segmap_parloop_struct_338087->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_segmap_parloop_struct_338087->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_segmap_parloop_struct_338087->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_segmap_parloop_struct_338087->free_mem_313371,
                                  .size =0, .references =NULL};
    int64_t bytes_313879 =
            futhark_mc_segmap_parloop_struct_338087->free_bytes_313879;
    struct memblock mem_314116 = {.desc ="mem_314116", .mem =
                                  futhark_mc_segmap_parloop_struct_338087->free_mem_314116,
                                  .size =0, .references =NULL};
    struct memblock mem_314121 = {.desc ="mem_314121", .mem =
                                  futhark_mc_segmap_parloop_struct_338087->free_mem_314121,
                                  .size =0, .references =NULL};
    size_t mem_313991_cached_sizze_338089 = 0;
    unsigned char *mem_313991 = NULL;
    size_t mem_313995_cached_sizze_338090 = 0;
    unsigned char *mem_313995 = NULL;
    size_t mem_314040_cached_sizze_338091 = 0;
    unsigned char *mem_314040 = NULL;
    size_t mem_314043_cached_sizze_338092 = 0;
    unsigned char *mem_314043 = NULL;
    int64_t iterations = end - start;
    int64_t iter_322581 = start;
    
    if (mem_313991_cached_sizze_338089 < (size_t) bytes_312899) {
        mem_313991 = realloc(mem_313991, bytes_312899);
        mem_313991_cached_sizze_338089 = bytes_312899;
    }
    if (mem_313995_cached_sizze_338090 < (size_t) bytes_312899) {
        mem_313995 = realloc(mem_313995, bytes_312899);
        mem_313995_cached_sizze_338090 = bytes_312899;
    }
    if (mem_314040_cached_sizze_338091 < (size_t) bytes_313879) {
        mem_314040 = realloc(mem_314040, bytes_313879);
        mem_314040_cached_sizze_338091 = bytes_313879;
    }
    if (mem_314043_cached_sizze_338092 < (size_t) bytes_313879) {
        mem_314043 = realloc(mem_314043, bytes_313879);
        mem_314043_cached_sizze_338092 = bytes_313879;
    }
    for (; iter_322581 < end; iter_322581++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_322675 = partition_sizze_292766;
        int64_t gtid_300889 = iter_322581;
        int64_t remnant_322676 = iter_322581 - gtid_300889;
        
        for (int64_t i_322582 = 0; i_322582 < n_p_292677; i_322582++) {
            int64_t x_322585;
            
            x_322585 = ((int64_t *) mem_312842.mem)[gtid_300889 * n_p_292677 +
                                                    i_322582];
            for (int64_t i_322588 = 0; i_322588 < s_n_m_292825; i_322588++) {
                int64_t x_322591;
                
                x_322591 = ((int64_t *) mem_313018.mem)[gtid_300889 *
                                                        (s_n_m_292825 *
                                                         n_p_292677) +
                                                        i_322582 *
                                                        s_n_m_292825 +
                                                        i_322588];
                
                double x_322592;
                
                x_322592 = ((double *) mem_313023.mem)[gtid_300889 *
                                                       (s_n_m_292825 *
                                                        n_p_292677) + i_322582 *
                                                       s_n_m_292825 + i_322588];
                
                bool cond_322593 = i_322588 == (int64_t) 0;
                int64_t defunc_0_m_fun_res_322594;
                
                if (cond_322593) {
                    defunc_0_m_fun_res_322594 = (int64_t) 0;
                } else {
                    int64_t y_322595 = sub64(s_n_m_292825, (int64_t) 1);
                    bool cond_322596 = i_322588 == y_322595;
                    int64_t defunc_0_m_fun_res_f_res_322597;
                    
                    if (cond_322596) {
                        int64_t defunc_0_m_fun_res_f_res_t_res_322598 =
                                sub64(pad_css_len_292821, (int64_t) 1);
                        
                        defunc_0_m_fun_res_f_res_322597 =
                            defunc_0_m_fun_res_f_res_t_res_322598;
                    } else {
                        int64_t x_322599 = sub64(i_322588, (int64_t) 1);
                        int64_t x_322600 = mul64(jump_s_292684, x_322599);
                        int64_t min_arg_322601 = add64((int64_t) 1, x_322600);
                        int64_t min_res_322602 = smin64(defunc_0_f_res_292820,
                                                        min_arg_322601);
                        
                        defunc_0_m_fun_res_f_res_322597 = min_res_322602;
                    }
                    defunc_0_m_fun_res_322594 = defunc_0_m_fun_res_f_res_322597;
                }
                
                double defunc_2_reduce_res_322605;
                double defunc_2_reduce_res_322606;
                double defunc_2_reduce_res_322607;
                double redout_322611;
                double redout_322612;
                double redout_322613;
                
                redout_322611 = 0.0;
                redout_322612 = 0.0;
                redout_322613 = 0.0;
                for (int64_t i_322610 = 0; i_322610 < q_s_292678; i_322610++) {
                    bool cond_322616 = sle64(x_322585, i_322610);
                    int64_t defunc_0_f_res_322617;
                    
                    if (cond_322616) {
                        defunc_0_f_res_322617 = (int64_t) 0;
                    } else {
                        int64_t i_322618 = add64(x_322591, i_322610);
                        int64_t defunc_0_add_arg_322619;
                        
                        defunc_0_add_arg_322619 =
                            ((int64_t *) mem_312838.mem)[gtid_300889 *
                                                         (defunc_0_f_res_292820 *
                                                          n_p_292677) +
                                                         i_322582 *
                                                         defunc_0_f_res_292820 +
                                                         i_322618];
                        
                        int64_t defunc_1_add_res_322620 = add64((int64_t) 1,
                                                                defunc_0_add_arg_322619);
                        
                        defunc_0_f_res_322617 = defunc_1_add_res_322620;
                    }
                    
                    double defunc_0_f_res_322621;
                    
                    if (cond_322616) {
                        defunc_0_f_res_322621 = 0.0;
                    } else {
                        int64_t i_322622 = add64(x_322591, i_322610);
                        double defunc_0_add_arg_322623;
                        
                        defunc_0_add_arg_322623 =
                            ((double *) mem_313371.mem)[gtid_300889 *
                                                        (defunc_0_f_res_292820 *
                                                         n_p_292677) +
                                                        i_322582 *
                                                        defunc_0_f_res_292820 +
                                                        i_322622];
                        defunc_0_f_res_322621 = defunc_0_add_arg_322623;
                    }
                    
                    int64_t binop_p_322624 = sub64(defunc_0_f_res_322617,
                                                   defunc_0_m_fun_res_322594);
                    double defunc_0_f_res_322625 =
                           sitofp_i64_f64(binop_p_322624);
                    double abs_res_322626 = fabs(defunc_0_f_res_322625);
                    double tmp1_322627 = abs_res_322626 / x_322592;
                    double x_322628 = tmp1_322627 * tmp1_322627;
                    double y_322629 = tmp1_322627 * x_322628;
                    double tmp2_322630 = 1.0 - y_322629;
                    double x_322631 = tmp2_322630 * tmp2_322630;
                    double tmp3_322632 = tmp2_322630 * x_322631;
                    double tmp4_322633 = defunc_0_f_res_322621 * tmp3_322632;
                    double defunc_1_f_res_322634 = defunc_0_f_res_322625 *
                           tmp4_322633;
                    double defunc_1_f_res_322635 = defunc_0_f_res_322625 *
                           defunc_1_f_res_322634;
                    double defunc_1_op_res_322636 = tmp4_322633 + redout_322611;
                    double defunc_1_op_res_322637 = defunc_1_f_res_322634 +
                           redout_322612;
                    double defunc_1_op_res_322638 = defunc_1_f_res_322635 +
                           redout_322613;
                    
                    ((double *) mem_314040)[i_322610] = defunc_1_f_res_322634;
                    ((double *) mem_314043)[i_322610] = tmp4_322633;
                    
                    double redout_tmp_322681 = defunc_1_op_res_322636;
                    double redout_tmp_322682 = defunc_1_op_res_322637;
                    double redout_tmp_322683 = defunc_1_op_res_322638;
                    
                    redout_322611 = redout_tmp_322681;
                    redout_322612 = redout_tmp_322682;
                    redout_322613 = redout_tmp_322683;
                }
                defunc_2_reduce_res_322605 = redout_322611;
                defunc_2_reduce_res_322606 = redout_322612;
                defunc_2_reduce_res_322607 = redout_322613;
                
                double a_322641 = 2.220446049250313e-16 +
                       defunc_2_reduce_res_322605;
                double b_322642 = 2.220446049250313e-16 +
                       defunc_2_reduce_res_322606;
                double c_322643 = 2.220446049250313e-16 +
                       defunc_2_reduce_res_322607;
                double x_322644 = a_322641 * c_322643;
                double y_322645 = b_322642 * b_322642;
                double y_322646 = x_322644 - y_322645;
                double det1_322647 = 1.0 / y_322646;
                double a11_322648 = c_322643 * det1_322647;
                double x_322649 = 0.0 - b_322642;
                double b11_322650 = det1_322647 * x_322649;
                double c11_322651 = a_322641 * det1_322647;
                double defunc_2_reduce_res_322652;
                double defunc_2_reduce_res_322653;
                double redout_322655;
                double redout_322656;
                
                redout_322655 = 0.0;
                redout_322656 = 0.0;
                for (int64_t i_322654 = 0; i_322654 < q_s_292678; i_322654++) {
                    double x_322657;
                    
                    x_322657 = ((double *) mem_314043)[i_322654];
                    
                    double x_322658;
                    
                    x_322658 = ((double *) mem_314040)[i_322654];
                    
                    bool cond_322659 = sle64(x_322585, i_322654);
                    double defunc_0_f_res_322660;
                    
                    if (cond_322659) {
                        defunc_0_f_res_322660 = 0.0;
                    } else {
                        int64_t i_322661 = add64(x_322591, i_322654);
                        double defunc_0_add_arg_322662;
                        
                        defunc_0_add_arg_322662 =
                            ((double *) mem_313366.mem)[gtid_300889 *
                                                        (defunc_0_f_res_292820 *
                                                         n_p_292677) +
                                                        i_322582 *
                                                        defunc_0_f_res_292820 +
                                                        i_322661];
                        defunc_0_f_res_322660 = defunc_0_add_arg_322662;
                    }
                    
                    double x_322663 = a11_322648 * x_322657;
                    double y_322664 = b11_322650 * x_322658;
                    double x_322665 = x_322663 + y_322664;
                    double defunc_9_fit_fun_res_322666 = defunc_0_f_res_322660 *
                           x_322665;
                    double x_322667 = b11_322650 * x_322657;
                    double y_322668 = c11_322651 * x_322658;
                    double x_322669 = x_322667 + y_322668;
                    double defunc_9_slope_fun_res_322670 =
                           defunc_0_f_res_322660 * x_322669;
                    double defunc_1_op_res_322671 =
                           defunc_9_fit_fun_res_322666 + redout_322655;
                    double defunc_1_op_res_322672 =
                           defunc_9_slope_fun_res_322670 + redout_322656;
                    double redout_tmp_322686 = defunc_1_op_res_322671;
                    double redout_tmp_322687 = defunc_1_op_res_322672;
                    
                    redout_322655 = redout_tmp_322686;
                    redout_322656 = redout_tmp_322687;
                }
                defunc_2_reduce_res_322652 = redout_322655;
                defunc_2_reduce_res_322653 = redout_322656;
                ((double *) mem_313991)[i_322582 * s_n_m_292825 + i_322588] =
                    defunc_2_reduce_res_322652;
                ((double *) mem_313995)[i_322582 * s_n_m_292825 + i_322588] =
                    defunc_2_reduce_res_322653;
            }
        }
        if (n_p_292677 * s_n_m_292825 * (int64_t) 8 > 0)
            memmove(mem_314116.mem + gtid_300889 * (s_n_m_292825 * n_p_292677) *
                    (int64_t) 8, mem_313991 + (int64_t) 0, n_p_292677 *
                    s_n_m_292825 * (int64_t) 8);
        if (n_p_292677 * s_n_m_292825 * (int64_t) 8 > 0)
            memmove(mem_314121.mem + gtid_300889 * (s_n_m_292825 * n_p_292677) *
                    (int64_t) 8, mem_313995 + (int64_t) 0, n_p_292677 *
                    s_n_m_292825 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_313991);
    free(mem_313995);
    free(mem_314040);
    free(mem_314043);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338088_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338088_end -
                 futhark_mc_segmap_parloop_338088_start;
        
        ctx->futhark_mc_segmap_parloop_338088_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338088_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338088_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_338086(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_300888 = tid;
    int num_tasks_322580 = info.nsubtasks;
    struct futhark_mc_task_338085 *futhark_mc_task_338085 =
                                  (struct futhark_mc_task_338085 *) args;
    struct futhark_context *ctx = futhark_mc_task_338085->ctx;
    uint64_t futhark_mc_segmap_task_338086_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_338086_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_338085->free_n_p_292677;
    int64_t q_s_292678 = futhark_mc_task_338085->free_q_s_292678;
    int64_t jump_s_292684 = futhark_mc_task_338085->free_jump_s_292684;
    int64_t partition_sizze_292766 =
            futhark_mc_task_338085->free_partition_sizze_292766;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_338085->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_task_338085->free_pad_css_len_292821;
    int64_t s_n_m_292825 = futhark_mc_task_338085->free_s_n_m_292825;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_task_338085->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_312842 = {.desc ="mem_312842", .mem =
                                  futhark_mc_task_338085->free_mem_312842,
                                  .size =0, .references =NULL};
    int64_t bytes_312847 = futhark_mc_task_338085->free_bytes_312847;
    int64_t bytes_312899 = futhark_mc_task_338085->free_bytes_312899;
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_task_338085->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_task_338085->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_task_338085->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_task_338085->free_mem_313371,
                                  .size =0, .references =NULL};
    int64_t bytes_313879 = futhark_mc_task_338085->free_bytes_313879;
    struct memblock mem_314116 = {.desc ="mem_314116", .mem =
                                  futhark_mc_task_338085->free_mem_314116,
                                  .size =0, .references =NULL};
    struct memblock mem_314121 = {.desc ="mem_314121", .mem =
                                  futhark_mc_task_338085->free_mem_314121,
                                  .size =0, .references =NULL};
    int64_t iter_322581;
    struct futhark_mc_segmap_parloop_struct_338087
    futhark_mc_segmap_parloop_struct_338087;
    
    futhark_mc_segmap_parloop_struct_338087.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338087.free_n_p_292677 = n_p_292677;
    futhark_mc_segmap_parloop_struct_338087.free_q_s_292678 = q_s_292678;
    futhark_mc_segmap_parloop_struct_338087.free_jump_s_292684 = jump_s_292684;
    futhark_mc_segmap_parloop_struct_338087.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_338087.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segmap_parloop_struct_338087.free_pad_css_len_292821 =
        pad_css_len_292821;
    futhark_mc_segmap_parloop_struct_338087.free_s_n_m_292825 = s_n_m_292825;
    futhark_mc_segmap_parloop_struct_338087.free_mem_312838 = mem_312838.mem;
    futhark_mc_segmap_parloop_struct_338087.free_mem_312842 = mem_312842.mem;
    futhark_mc_segmap_parloop_struct_338087.free_bytes_312899 = bytes_312899;
    futhark_mc_segmap_parloop_struct_338087.free_mem_313018 = mem_313018.mem;
    futhark_mc_segmap_parloop_struct_338087.free_mem_313023 = mem_313023.mem;
    futhark_mc_segmap_parloop_struct_338087.free_mem_313366 = mem_313366.mem;
    futhark_mc_segmap_parloop_struct_338087.free_mem_313371 = mem_313371.mem;
    futhark_mc_segmap_parloop_struct_338087.free_bytes_313879 = bytes_313879;
    futhark_mc_segmap_parloop_struct_338087.free_mem_314116 = mem_314116.mem;
    futhark_mc_segmap_parloop_struct_338087.free_mem_314121 = mem_314121.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338088_task;
    
    futhark_mc_segmap_parloop_338088_task.name =
        "futhark_mc_segmap_parloop_338088";
    futhark_mc_segmap_parloop_338088_task.fn = futhark_mc_segmap_parloop_338088;
    futhark_mc_segmap_parloop_338088_task.args =
        &futhark_mc_segmap_parloop_struct_338087;
    futhark_mc_segmap_parloop_338088_task.iterations = iterations;
    futhark_mc_segmap_parloop_338088_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338088_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338088_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338088_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338088_task);
    
    if (futhark_mc_segmap_parloop_338088_err != 0) {
        err = futhark_mc_segmap_parloop_338088_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338088_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338088_total_end -
                 futhark_mc_segmap_parloop_338088_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338088_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338088_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338088_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_338086_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_338086_end -
                 futhark_mc_segmap_task_338086_start;
        
        ctx->futhark_mc_segmap_task_338086_runs[tid]++;
        ctx->futhark_mc_segmap_task_338086_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_338086_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_segmap_parloop_struct_338094 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_q_s_292678;
    int64_t free_jump_s_292684;
    int64_t free_partition_sizze_292766;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_312842;
    int64_t free_bytes_312847;
    int64_t free_bytes_312899;
    unsigned char *free_mem_313018;
    unsigned char *free_mem_313023;
    unsigned char *free_mem_313366;
    unsigned char *free_mem_313371;
    int64_t free_bytes_313879;
    unsigned char *free_mem_314116;
    unsigned char *free_mem_314121;
};
struct futhark_mc_task_338098 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_q_s_292678;
    int64_t free_jump_s_292684;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    int64_t free_gtid_301175;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_312842;
    int64_t free_bytes_312847;
    unsigned char *free_mem_313018;
    unsigned char *free_mem_313023;
    unsigned char *free_mem_313366;
    unsigned char *free_mem_313371;
    int64_t free_bytes_313879;
    unsigned char *free_mem_313983;
    unsigned char *free_mem_313987;
};
struct futhark_mc_segmap_parloop_struct_338100 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_q_s_292678;
    int64_t free_jump_s_292684;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    int64_t free_gtid_301175;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_312842;
    int64_t free_bytes_312847;
    unsigned char *free_mem_313018;
    unsigned char *free_mem_313023;
    unsigned char *free_mem_313366;
    unsigned char *free_mem_313371;
    int64_t free_bytes_313879;
    unsigned char *free_mem_313983;
    unsigned char *free_mem_313987;
};
static int futhark_mc_segmap_parloop_338101(void *args, int64_t start,
                                            int64_t end, int flat_tid_322869,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338100
    *futhark_mc_segmap_parloop_struct_338100 =
    (struct futhark_mc_segmap_parloop_struct_338100 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338100->ctx;
    uint64_t futhark_mc_segmap_parloop_338101_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338101_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segmap_parloop_struct_338100->free_n_p_292677;
    int64_t q_s_292678 =
            futhark_mc_segmap_parloop_struct_338100->free_q_s_292678;
    int64_t jump_s_292684 =
            futhark_mc_segmap_parloop_struct_338100->free_jump_s_292684;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segmap_parloop_struct_338100->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_segmap_parloop_struct_338100->free_pad_css_len_292821;
    int64_t s_n_m_292825 =
            futhark_mc_segmap_parloop_struct_338100->free_s_n_m_292825;
    int64_t gtid_301175 =
            futhark_mc_segmap_parloop_struct_338100->free_gtid_301175;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_segmap_parloop_struct_338100->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_312842 = {.desc ="mem_312842", .mem =
                                  futhark_mc_segmap_parloop_struct_338100->free_mem_312842,
                                  .size =0, .references =NULL};
    int64_t bytes_312847 =
            futhark_mc_segmap_parloop_struct_338100->free_bytes_312847;
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_segmap_parloop_struct_338100->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_segmap_parloop_struct_338100->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_segmap_parloop_struct_338100->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_segmap_parloop_struct_338100->free_mem_313371,
                                  .size =0, .references =NULL};
    int64_t bytes_313879 =
            futhark_mc_segmap_parloop_struct_338100->free_bytes_313879;
    struct memblock mem_313983 = {.desc ="mem_313983", .mem =
                                  futhark_mc_segmap_parloop_struct_338100->free_mem_313983,
                                  .size =0, .references =NULL};
    struct memblock mem_313987 = {.desc ="mem_313987", .mem =
                                  futhark_mc_segmap_parloop_struct_338100->free_mem_313987,
                                  .size =0, .references =NULL};
    size_t mem_322872_cached_sizze_338102 = 0;
    unsigned char *mem_322872 = NULL;
    size_t mem_322874_cached_sizze_338103 = 0;
    unsigned char *mem_322874 = NULL;
    size_t mem_322876_cached_sizze_338104 = 0;
    unsigned char *mem_322876 = NULL;
    size_t mem_322877_cached_sizze_338105 = 0;
    unsigned char *mem_322877 = NULL;
    int64_t iterations = end - start;
    int64_t iter_322970 = start;
    
    if (mem_322872_cached_sizze_338102 < (size_t) bytes_312847) {
        mem_322872 = realloc(mem_322872, bytes_312847);
        mem_322872_cached_sizze_338102 = bytes_312847;
    }
    if (mem_322874_cached_sizze_338103 < (size_t) bytes_312847) {
        mem_322874 = realloc(mem_322874, bytes_312847);
        mem_322874_cached_sizze_338103 = bytes_312847;
    }
    if (mem_322876_cached_sizze_338104 < (size_t) bytes_313879) {
        mem_322876 = realloc(mem_322876, bytes_313879);
        mem_322876_cached_sizze_338104 = bytes_313879;
    }
    if (mem_322877_cached_sizze_338105 < (size_t) bytes_313879) {
        mem_322877 = realloc(mem_322877, bytes_313879);
        mem_322877_cached_sizze_338105 = bytes_313879;
    }
    for (; iter_322970 < end; iter_322970++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_323058 = n_p_292677;
        int64_t gtid_322870 = iter_322970;
        int64_t remnant_323059 = iter_322970 - gtid_322870;
        int64_t x_322871;
        
        x_322871 = ((int64_t *) mem_312842.mem)[gtid_301175 * n_p_292677 +
                                                gtid_322870];
        for (int64_t i_322971 = 0; i_322971 < s_n_m_292825; i_322971++) {
            int64_t x_322974;
            
            x_322974 = ((int64_t *) mem_313018.mem)[gtid_301175 *
                                                    (s_n_m_292825 *
                                                     n_p_292677) + gtid_322870 *
                                                    s_n_m_292825 + i_322971];
            
            double x_322975;
            
            x_322975 = ((double *) mem_313023.mem)[gtid_301175 * (s_n_m_292825 *
                                                                  n_p_292677) +
                                                   gtid_322870 * s_n_m_292825 +
                                                   i_322971];
            
            bool cond_322976 = i_322971 == (int64_t) 0;
            int64_t defunc_0_m_fun_res_322977;
            
            if (cond_322976) {
                defunc_0_m_fun_res_322977 = (int64_t) 0;
            } else {
                int64_t y_322978 = sub64(s_n_m_292825, (int64_t) 1);
                bool cond_322979 = i_322971 == y_322978;
                int64_t defunc_0_m_fun_res_f_res_322980;
                
                if (cond_322979) {
                    int64_t defunc_0_m_fun_res_f_res_t_res_322981 =
                            sub64(pad_css_len_292821, (int64_t) 1);
                    
                    defunc_0_m_fun_res_f_res_322980 =
                        defunc_0_m_fun_res_f_res_t_res_322981;
                } else {
                    int64_t x_322982 = sub64(i_322971, (int64_t) 1);
                    int64_t x_322983 = mul64(jump_s_292684, x_322982);
                    int64_t min_arg_322984 = add64((int64_t) 1, x_322983);
                    int64_t min_res_322985 = smin64(defunc_0_f_res_292820,
                                                    min_arg_322984);
                    
                    defunc_0_m_fun_res_f_res_322980 = min_res_322985;
                }
                defunc_0_m_fun_res_322977 = defunc_0_m_fun_res_f_res_322980;
            }
            
            double defunc_2_reduce_res_322988;
            double defunc_2_reduce_res_322989;
            double defunc_2_reduce_res_322990;
            double redout_322994;
            double redout_322995;
            double redout_322996;
            
            redout_322994 = 0.0;
            redout_322995 = 0.0;
            redout_322996 = 0.0;
            for (int64_t i_322993 = 0; i_322993 < q_s_292678; i_322993++) {
                bool cond_322999 = sle64(x_322871, i_322993);
                int64_t defunc_0_f_res_323000;
                
                if (cond_322999) {
                    defunc_0_f_res_323000 = (int64_t) 0;
                } else {
                    int64_t i_323001 = add64(x_322974, i_322993);
                    int64_t defunc_0_add_arg_323002;
                    
                    defunc_0_add_arg_323002 =
                        ((int64_t *) mem_312838.mem)[gtid_301175 *
                                                     (defunc_0_f_res_292820 *
                                                      n_p_292677) +
                                                     gtid_322870 *
                                                     defunc_0_f_res_292820 +
                                                     i_323001];
                    
                    int64_t defunc_1_add_res_323003 = add64((int64_t) 1,
                                                            defunc_0_add_arg_323002);
                    
                    defunc_0_f_res_323000 = defunc_1_add_res_323003;
                }
                
                double defunc_0_f_res_323004;
                
                if (cond_322999) {
                    defunc_0_f_res_323004 = 0.0;
                } else {
                    int64_t i_323005 = add64(x_322974, i_322993);
                    double defunc_0_add_arg_323006;
                    
                    defunc_0_add_arg_323006 =
                        ((double *) mem_313371.mem)[gtid_301175 *
                                                    (defunc_0_f_res_292820 *
                                                     n_p_292677) + gtid_322870 *
                                                    defunc_0_f_res_292820 +
                                                    i_323005];
                    defunc_0_f_res_323004 = defunc_0_add_arg_323006;
                }
                
                int64_t binop_p_323007 = sub64(defunc_0_f_res_323000,
                                               defunc_0_m_fun_res_322977);
                double defunc_0_f_res_323008 = sitofp_i64_f64(binop_p_323007);
                double abs_res_323009 = fabs(defunc_0_f_res_323008);
                double tmp1_323010 = abs_res_323009 / x_322975;
                double x_323011 = tmp1_323010 * tmp1_323010;
                double y_323012 = tmp1_323010 * x_323011;
                double tmp2_323013 = 1.0 - y_323012;
                double x_323014 = tmp2_323013 * tmp2_323013;
                double tmp3_323015 = tmp2_323013 * x_323014;
                double tmp4_323016 = defunc_0_f_res_323004 * tmp3_323015;
                double defunc_1_f_res_323017 = defunc_0_f_res_323008 *
                       tmp4_323016;
                double defunc_1_f_res_323018 = defunc_0_f_res_323008 *
                       defunc_1_f_res_323017;
                double defunc_1_op_res_323019 = tmp4_323016 + redout_322994;
                double defunc_1_op_res_323020 = defunc_1_f_res_323017 +
                       redout_322995;
                double defunc_1_op_res_323021 = defunc_1_f_res_323018 +
                       redout_322996;
                
                ((double *) mem_322876)[i_322993] = defunc_1_f_res_323017;
                ((double *) mem_322877)[i_322993] = tmp4_323016;
                
                double redout_tmp_323062 = defunc_1_op_res_323019;
                double redout_tmp_323063 = defunc_1_op_res_323020;
                double redout_tmp_323064 = defunc_1_op_res_323021;
                
                redout_322994 = redout_tmp_323062;
                redout_322995 = redout_tmp_323063;
                redout_322996 = redout_tmp_323064;
            }
            defunc_2_reduce_res_322988 = redout_322994;
            defunc_2_reduce_res_322989 = redout_322995;
            defunc_2_reduce_res_322990 = redout_322996;
            
            double a_323024 = 2.220446049250313e-16 +
                   defunc_2_reduce_res_322988;
            double b_323025 = 2.220446049250313e-16 +
                   defunc_2_reduce_res_322989;
            double c_323026 = 2.220446049250313e-16 +
                   defunc_2_reduce_res_322990;
            double x_323027 = a_323024 * c_323026;
            double y_323028 = b_323025 * b_323025;
            double y_323029 = x_323027 - y_323028;
            double det1_323030 = 1.0 / y_323029;
            double a11_323031 = c_323026 * det1_323030;
            double x_323032 = 0.0 - b_323025;
            double b11_323033 = det1_323030 * x_323032;
            double c11_323034 = a_323024 * det1_323030;
            double defunc_2_reduce_res_323035;
            double defunc_2_reduce_res_323036;
            double redout_323038;
            double redout_323039;
            
            redout_323038 = 0.0;
            redout_323039 = 0.0;
            for (int64_t i_323037 = 0; i_323037 < q_s_292678; i_323037++) {
                double x_323040;
                
                x_323040 = ((double *) mem_322877)[i_323037];
                
                double x_323041;
                
                x_323041 = ((double *) mem_322876)[i_323037];
                
                bool cond_323042 = sle64(x_322871, i_323037);
                double defunc_0_f_res_323043;
                
                if (cond_323042) {
                    defunc_0_f_res_323043 = 0.0;
                } else {
                    int64_t i_323044 = add64(x_322974, i_323037);
                    double defunc_0_add_arg_323045;
                    
                    defunc_0_add_arg_323045 =
                        ((double *) mem_313366.mem)[gtid_301175 *
                                                    (defunc_0_f_res_292820 *
                                                     n_p_292677) + gtid_322870 *
                                                    defunc_0_f_res_292820 +
                                                    i_323044];
                    defunc_0_f_res_323043 = defunc_0_add_arg_323045;
                }
                
                double x_323046 = a11_323031 * x_323040;
                double y_323047 = b11_323033 * x_323041;
                double x_323048 = x_323046 + y_323047;
                double defunc_9_fit_fun_res_323049 = defunc_0_f_res_323043 *
                       x_323048;
                double x_323050 = b11_323033 * x_323040;
                double y_323051 = c11_323034 * x_323041;
                double x_323052 = x_323050 + y_323051;
                double defunc_9_slope_fun_res_323053 = defunc_0_f_res_323043 *
                       x_323052;
                double defunc_1_op_res_323054 = defunc_9_fit_fun_res_323049 +
                       redout_323038;
                double defunc_1_op_res_323055 = defunc_9_slope_fun_res_323053 +
                       redout_323039;
                double redout_tmp_323067 = defunc_1_op_res_323054;
                double redout_tmp_323068 = defunc_1_op_res_323055;
                
                redout_323038 = redout_tmp_323067;
                redout_323039 = redout_tmp_323068;
            }
            defunc_2_reduce_res_323035 = redout_323038;
            defunc_2_reduce_res_323036 = redout_323039;
            ((double *) mem_322872)[i_322971] = defunc_2_reduce_res_323035;
            ((double *) mem_322874)[i_322971] = defunc_2_reduce_res_323036;
        }
        if (s_n_m_292825 * (int64_t) 8 > 0)
            memmove(mem_313983.mem + gtid_322870 * s_n_m_292825 * (int64_t) 8,
                    mem_322872 + (int64_t) 0, s_n_m_292825 * (int64_t) 8);
        if (s_n_m_292825 * (int64_t) 8 > 0)
            memmove(mem_313987.mem + gtid_322870 * s_n_m_292825 * (int64_t) 8,
                    mem_322874 + (int64_t) 0, s_n_m_292825 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_322872);
    free(mem_322874);
    free(mem_322876);
    free(mem_322877);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338101_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338101_end -
                 futhark_mc_segmap_parloop_338101_start;
        
        ctx->futhark_mc_segmap_parloop_338101_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338101_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338101_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_338099(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_322869 = tid;
    int num_tasks_322969 = info.nsubtasks;
    struct futhark_mc_task_338098 *futhark_mc_task_338098 =
                                  (struct futhark_mc_task_338098 *) args;
    struct futhark_context *ctx = futhark_mc_task_338098->ctx;
    uint64_t futhark_mc_segmap_task_338099_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_338099_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_338098->free_n_p_292677;
    int64_t q_s_292678 = futhark_mc_task_338098->free_q_s_292678;
    int64_t jump_s_292684 = futhark_mc_task_338098->free_jump_s_292684;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_338098->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_task_338098->free_pad_css_len_292821;
    int64_t s_n_m_292825 = futhark_mc_task_338098->free_s_n_m_292825;
    int64_t gtid_301175 = futhark_mc_task_338098->free_gtid_301175;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_task_338098->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_312842 = {.desc ="mem_312842", .mem =
                                  futhark_mc_task_338098->free_mem_312842,
                                  .size =0, .references =NULL};
    int64_t bytes_312847 = futhark_mc_task_338098->free_bytes_312847;
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_task_338098->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_task_338098->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_task_338098->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_task_338098->free_mem_313371,
                                  .size =0, .references =NULL};
    int64_t bytes_313879 = futhark_mc_task_338098->free_bytes_313879;
    struct memblock mem_313983 = {.desc ="mem_313983", .mem =
                                  futhark_mc_task_338098->free_mem_313983,
                                  .size =0, .references =NULL};
    struct memblock mem_313987 = {.desc ="mem_313987", .mem =
                                  futhark_mc_task_338098->free_mem_313987,
                                  .size =0, .references =NULL};
    int64_t iter_322970;
    struct futhark_mc_segmap_parloop_struct_338100
    futhark_mc_segmap_parloop_struct_338100;
    
    futhark_mc_segmap_parloop_struct_338100.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338100.free_n_p_292677 = n_p_292677;
    futhark_mc_segmap_parloop_struct_338100.free_q_s_292678 = q_s_292678;
    futhark_mc_segmap_parloop_struct_338100.free_jump_s_292684 = jump_s_292684;
    futhark_mc_segmap_parloop_struct_338100.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segmap_parloop_struct_338100.free_pad_css_len_292821 =
        pad_css_len_292821;
    futhark_mc_segmap_parloop_struct_338100.free_s_n_m_292825 = s_n_m_292825;
    futhark_mc_segmap_parloop_struct_338100.free_gtid_301175 = gtid_301175;
    futhark_mc_segmap_parloop_struct_338100.free_mem_312838 = mem_312838.mem;
    futhark_mc_segmap_parloop_struct_338100.free_mem_312842 = mem_312842.mem;
    futhark_mc_segmap_parloop_struct_338100.free_bytes_312847 = bytes_312847;
    futhark_mc_segmap_parloop_struct_338100.free_mem_313018 = mem_313018.mem;
    futhark_mc_segmap_parloop_struct_338100.free_mem_313023 = mem_313023.mem;
    futhark_mc_segmap_parloop_struct_338100.free_mem_313366 = mem_313366.mem;
    futhark_mc_segmap_parloop_struct_338100.free_mem_313371 = mem_313371.mem;
    futhark_mc_segmap_parloop_struct_338100.free_bytes_313879 = bytes_313879;
    futhark_mc_segmap_parloop_struct_338100.free_mem_313983 = mem_313983.mem;
    futhark_mc_segmap_parloop_struct_338100.free_mem_313987 = mem_313987.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338101_task;
    
    futhark_mc_segmap_parloop_338101_task.name =
        "futhark_mc_segmap_parloop_338101";
    futhark_mc_segmap_parloop_338101_task.fn = futhark_mc_segmap_parloop_338101;
    futhark_mc_segmap_parloop_338101_task.args =
        &futhark_mc_segmap_parloop_struct_338100;
    futhark_mc_segmap_parloop_338101_task.iterations = iterations;
    futhark_mc_segmap_parloop_338101_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338101_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338101_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338101_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338101_task);
    
    if (futhark_mc_segmap_parloop_338101_err != 0) {
        err = futhark_mc_segmap_parloop_338101_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338101_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338101_total_end -
                 futhark_mc_segmap_parloop_338101_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338101_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338101_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338101_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_338099_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_338099_end -
                 futhark_mc_segmap_task_338099_start;
        
        ctx->futhark_mc_segmap_task_338099_runs[tid]++;
        ctx->futhark_mc_segmap_task_338099_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_338099_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_segmap_parloop_struct_338107 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_q_s_292678;
    int64_t free_jump_s_292684;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    int64_t free_gtid_301175;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_312842;
    int64_t free_bytes_312847;
    unsigned char *free_mem_313018;
    unsigned char *free_mem_313023;
    unsigned char *free_mem_313366;
    unsigned char *free_mem_313371;
    int64_t free_bytes_313879;
    unsigned char *free_mem_313983;
    unsigned char *free_mem_313987;
};
struct futhark_mc_task_338111 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_q_s_292678;
    int64_t free_jump_s_292684;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    int64_t free_gtid_301175;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_313018;
    unsigned char *free_mem_313023;
    unsigned char *free_mem_313366;
    unsigned char *free_mem_313371;
    int64_t free_bytes_313879;
    int64_t free_gtid_322690;
    int64_t free_x_322691;
    unsigned char *free_mem_322692;
    unsigned char *free_mem_322693;
};
struct futhark_mc_segmap_parloop_struct_338113 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_q_s_292678;
    int64_t free_jump_s_292684;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    int64_t free_gtid_301175;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_313018;
    unsigned char *free_mem_313023;
    unsigned char *free_mem_313366;
    unsigned char *free_mem_313371;
    int64_t free_bytes_313879;
    int64_t free_gtid_322690;
    int64_t free_x_322691;
    unsigned char *free_mem_322692;
    unsigned char *free_mem_322693;
};
static int futhark_mc_segmap_parloop_338114(void *args, int64_t start,
                                            int64_t end, int flat_tid_323157,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338113
    *futhark_mc_segmap_parloop_struct_338113 =
    (struct futhark_mc_segmap_parloop_struct_338113 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338113->ctx;
    uint64_t futhark_mc_segmap_parloop_338114_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338114_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segmap_parloop_struct_338113->free_n_p_292677;
    int64_t q_s_292678 =
            futhark_mc_segmap_parloop_struct_338113->free_q_s_292678;
    int64_t jump_s_292684 =
            futhark_mc_segmap_parloop_struct_338113->free_jump_s_292684;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segmap_parloop_struct_338113->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_segmap_parloop_struct_338113->free_pad_css_len_292821;
    int64_t s_n_m_292825 =
            futhark_mc_segmap_parloop_struct_338113->free_s_n_m_292825;
    int64_t gtid_301175 =
            futhark_mc_segmap_parloop_struct_338113->free_gtid_301175;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_segmap_parloop_struct_338113->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_segmap_parloop_struct_338113->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_segmap_parloop_struct_338113->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_segmap_parloop_struct_338113->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_segmap_parloop_struct_338113->free_mem_313371,
                                  .size =0, .references =NULL};
    int64_t bytes_313879 =
            futhark_mc_segmap_parloop_struct_338113->free_bytes_313879;
    int64_t gtid_322690 =
            futhark_mc_segmap_parloop_struct_338113->free_gtid_322690;
    int64_t x_322691 = futhark_mc_segmap_parloop_struct_338113->free_x_322691;
    struct memblock mem_322692 = {.desc ="mem_322692", .mem =
                                  futhark_mc_segmap_parloop_struct_338113->free_mem_322692,
                                  .size =0, .references =NULL};
    struct memblock mem_322693 = {.desc ="mem_322693", .mem =
                                  futhark_mc_segmap_parloop_struct_338113->free_mem_322693,
                                  .size =0, .references =NULL};
    size_t mem_323171_cached_sizze_338115 = 0;
    unsigned char *mem_323171 = NULL;
    size_t mem_323173_cached_sizze_338116 = 0;
    unsigned char *mem_323173 = NULL;
    int64_t iterations = end - start;
    int64_t iter_323246 = start;
    
    if (mem_323171_cached_sizze_338115 < (size_t) bytes_313879) {
        mem_323171 = realloc(mem_323171, bytes_313879);
        mem_323171_cached_sizze_338115 = bytes_313879;
    }
    if (mem_323173_cached_sizze_338116 < (size_t) bytes_313879) {
        mem_323173 = realloc(mem_323173, bytes_313879);
        mem_323173_cached_sizze_338116 = bytes_313879;
    }
    for (; iter_323246 < end; iter_323246++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_323305 = s_n_m_292825;
        int64_t gtid_323158 = iter_323246;
        int64_t remnant_323306 = iter_323246 - gtid_323158;
        int64_t x_323159;
        
        x_323159 = ((int64_t *) mem_313018.mem)[gtid_301175 * (s_n_m_292825 *
                                                               n_p_292677) +
                                                gtid_322690 * s_n_m_292825 +
                                                gtid_323158];
        
        double x_323160;
        
        x_323160 = ((double *) mem_313023.mem)[gtid_301175 * (s_n_m_292825 *
                                                              n_p_292677) +
                                               gtid_322690 * s_n_m_292825 +
                                               gtid_323158];
        
        bool cond_323161 = gtid_323158 == (int64_t) 0;
        int64_t defunc_0_m_fun_res_323162;
        
        if (cond_323161) {
            defunc_0_m_fun_res_323162 = (int64_t) 0;
        } else {
            int64_t y_323247 = sub64(s_n_m_292825, (int64_t) 1);
            bool cond_323248 = gtid_323158 == y_323247;
            int64_t defunc_0_m_fun_res_f_res_323249;
            
            if (cond_323248) {
                int64_t defunc_0_m_fun_res_f_res_t_res_323250 =
                        sub64(pad_css_len_292821, (int64_t) 1);
                
                defunc_0_m_fun_res_f_res_323249 =
                    defunc_0_m_fun_res_f_res_t_res_323250;
            } else {
                int64_t x_323251 = sub64(gtid_323158, (int64_t) 1);
                int64_t x_323252 = mul64(jump_s_292684, x_323251);
                int64_t min_arg_323253 = add64((int64_t) 1, x_323252);
                int64_t min_res_323254 = smin64(defunc_0_f_res_292820,
                                                min_arg_323253);
                
                defunc_0_m_fun_res_f_res_323249 = min_res_323254;
            }
            defunc_0_m_fun_res_323162 = defunc_0_m_fun_res_f_res_323249;
        }
        
        double defunc_2_reduce_res_323175;
        double defunc_2_reduce_res_323176;
        double defunc_2_reduce_res_323177;
        double redout_323256;
        double redout_323257;
        double redout_323258;
        
        redout_323256 = 0.0;
        redout_323257 = 0.0;
        redout_323258 = 0.0;
        for (int64_t i_323255 = 0; i_323255 < q_s_292678; i_323255++) {
            bool cond_323261 = sle64(x_322691, i_323255);
            int64_t defunc_0_f_res_323262;
            
            if (cond_323261) {
                defunc_0_f_res_323262 = (int64_t) 0;
            } else {
                int64_t i_323263 = add64(x_323159, i_323255);
                int64_t defunc_0_add_arg_323264;
                
                defunc_0_add_arg_323264 =
                    ((int64_t *) mem_312838.mem)[gtid_301175 *
                                                 (defunc_0_f_res_292820 *
                                                  n_p_292677) + gtid_322690 *
                                                 defunc_0_f_res_292820 +
                                                 i_323263];
                
                int64_t defunc_1_add_res_323265 = add64((int64_t) 1,
                                                        defunc_0_add_arg_323264);
                
                defunc_0_f_res_323262 = defunc_1_add_res_323265;
            }
            
            double defunc_0_f_res_323266;
            
            if (cond_323261) {
                defunc_0_f_res_323266 = 0.0;
            } else {
                int64_t i_323267 = add64(x_323159, i_323255);
                double defunc_0_add_arg_323268;
                
                defunc_0_add_arg_323268 =
                    ((double *) mem_313371.mem)[gtid_301175 *
                                                (defunc_0_f_res_292820 *
                                                 n_p_292677) + gtid_322690 *
                                                defunc_0_f_res_292820 +
                                                i_323267];
                defunc_0_f_res_323266 = defunc_0_add_arg_323268;
            }
            
            int64_t binop_p_323269 = sub64(defunc_0_f_res_323262,
                                           defunc_0_m_fun_res_323162);
            double defunc_0_f_res_323270 = sitofp_i64_f64(binop_p_323269);
            double abs_res_323271 = fabs(defunc_0_f_res_323270);
            double tmp1_323272 = abs_res_323271 / x_323160;
            double x_323273 = tmp1_323272 * tmp1_323272;
            double y_323274 = tmp1_323272 * x_323273;
            double tmp2_323275 = 1.0 - y_323274;
            double x_323276 = tmp2_323275 * tmp2_323275;
            double tmp3_323277 = tmp2_323275 * x_323276;
            double tmp4_323278 = defunc_0_f_res_323266 * tmp3_323277;
            double defunc_1_f_res_323279 = defunc_0_f_res_323270 * tmp4_323278;
            double defunc_1_f_res_323280 = defunc_0_f_res_323270 *
                   defunc_1_f_res_323279;
            double defunc_1_op_res_323281 = tmp4_323278 + redout_323256;
            double defunc_1_op_res_323282 = defunc_1_f_res_323279 +
                   redout_323257;
            double defunc_1_op_res_323283 = defunc_1_f_res_323280 +
                   redout_323258;
            
            ((double *) mem_323171)[i_323255] = defunc_1_f_res_323279;
            ((double *) mem_323173)[i_323255] = tmp4_323278;
            
            double redout_tmp_323307 = defunc_1_op_res_323281;
            double redout_tmp_323308 = defunc_1_op_res_323282;
            double redout_tmp_323309 = defunc_1_op_res_323283;
            
            redout_323256 = redout_tmp_323307;
            redout_323257 = redout_tmp_323308;
            redout_323258 = redout_tmp_323309;
        }
        defunc_2_reduce_res_323175 = redout_323256;
        defunc_2_reduce_res_323176 = redout_323257;
        defunc_2_reduce_res_323177 = redout_323258;
        
        double a_323211 = 2.220446049250313e-16 + defunc_2_reduce_res_323175;
        double b_323212 = 2.220446049250313e-16 + defunc_2_reduce_res_323176;
        double c_323213 = 2.220446049250313e-16 + defunc_2_reduce_res_323177;
        double x_323214 = a_323211 * c_323213;
        double y_323215 = b_323212 * b_323212;
        double y_323216 = x_323214 - y_323215;
        double det1_323217 = 1.0 / y_323216;
        double a11_323218 = c_323213 * det1_323217;
        double x_323219 = 0.0 - b_323212;
        double b11_323220 = det1_323217 * x_323219;
        double c11_323221 = a_323211 * det1_323217;
        double defunc_2_reduce_res_323222;
        double defunc_2_reduce_res_323223;
        double redout_323287;
        double redout_323288;
        
        redout_323287 = 0.0;
        redout_323288 = 0.0;
        for (int64_t i_323286 = 0; i_323286 < q_s_292678; i_323286++) {
            double x_323289;
            
            x_323289 = ((double *) mem_323173)[i_323286];
            
            double x_323290;
            
            x_323290 = ((double *) mem_323171)[i_323286];
            
            bool cond_323291 = sle64(x_322691, i_323286);
            double defunc_0_f_res_323292;
            
            if (cond_323291) {
                defunc_0_f_res_323292 = 0.0;
            } else {
                int64_t i_323293 = add64(x_323159, i_323286);
                double defunc_0_add_arg_323294;
                
                defunc_0_add_arg_323294 =
                    ((double *) mem_313366.mem)[gtid_301175 *
                                                (defunc_0_f_res_292820 *
                                                 n_p_292677) + gtid_322690 *
                                                defunc_0_f_res_292820 +
                                                i_323293];
                defunc_0_f_res_323292 = defunc_0_add_arg_323294;
            }
            
            double x_323295 = a11_323218 * x_323289;
            double y_323296 = b11_323220 * x_323290;
            double x_323297 = x_323295 + y_323296;
            double defunc_9_fit_fun_res_323298 = defunc_0_f_res_323292 *
                   x_323297;
            double x_323299 = b11_323220 * x_323289;
            double y_323300 = c11_323221 * x_323290;
            double x_323301 = x_323299 + y_323300;
            double defunc_9_slope_fun_res_323302 = defunc_0_f_res_323292 *
                   x_323301;
            double defunc_1_op_res_323303 = defunc_9_fit_fun_res_323298 +
                   redout_323287;
            double defunc_1_op_res_323304 = defunc_9_slope_fun_res_323302 +
                   redout_323288;
            double redout_tmp_323312 = defunc_1_op_res_323303;
            double redout_tmp_323313 = defunc_1_op_res_323304;
            
            redout_323287 = redout_tmp_323312;
            redout_323288 = redout_tmp_323313;
        }
        defunc_2_reduce_res_323222 = redout_323287;
        defunc_2_reduce_res_323223 = redout_323288;
        ((double *) mem_322692.mem)[gtid_323158] = defunc_2_reduce_res_323222;
        ((double *) mem_322693.mem)[gtid_323158] = defunc_2_reduce_res_323223;
    }
    
  cleanup:
    { }
    free(mem_323171);
    free(mem_323173);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338114_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338114_end -
                 futhark_mc_segmap_parloop_338114_start;
        
        ctx->futhark_mc_segmap_parloop_338114_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338114_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338114_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_338112(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_323157 = tid;
    int num_tasks_323245 = info.nsubtasks;
    struct futhark_mc_task_338111 *futhark_mc_task_338111 =
                                  (struct futhark_mc_task_338111 *) args;
    struct futhark_context *ctx = futhark_mc_task_338111->ctx;
    uint64_t futhark_mc_segmap_task_338112_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_338112_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_338111->free_n_p_292677;
    int64_t q_s_292678 = futhark_mc_task_338111->free_q_s_292678;
    int64_t jump_s_292684 = futhark_mc_task_338111->free_jump_s_292684;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_338111->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_task_338111->free_pad_css_len_292821;
    int64_t s_n_m_292825 = futhark_mc_task_338111->free_s_n_m_292825;
    int64_t gtid_301175 = futhark_mc_task_338111->free_gtid_301175;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_task_338111->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_task_338111->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_task_338111->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_task_338111->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_task_338111->free_mem_313371,
                                  .size =0, .references =NULL};
    int64_t bytes_313879 = futhark_mc_task_338111->free_bytes_313879;
    int64_t gtid_322690 = futhark_mc_task_338111->free_gtid_322690;
    int64_t x_322691 = futhark_mc_task_338111->free_x_322691;
    struct memblock mem_322692 = {.desc ="mem_322692", .mem =
                                  futhark_mc_task_338111->free_mem_322692,
                                  .size =0, .references =NULL};
    struct memblock mem_322693 = {.desc ="mem_322693", .mem =
                                  futhark_mc_task_338111->free_mem_322693,
                                  .size =0, .references =NULL};
    int64_t iter_323246;
    struct futhark_mc_segmap_parloop_struct_338113
    futhark_mc_segmap_parloop_struct_338113;
    
    futhark_mc_segmap_parloop_struct_338113.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338113.free_n_p_292677 = n_p_292677;
    futhark_mc_segmap_parloop_struct_338113.free_q_s_292678 = q_s_292678;
    futhark_mc_segmap_parloop_struct_338113.free_jump_s_292684 = jump_s_292684;
    futhark_mc_segmap_parloop_struct_338113.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segmap_parloop_struct_338113.free_pad_css_len_292821 =
        pad_css_len_292821;
    futhark_mc_segmap_parloop_struct_338113.free_s_n_m_292825 = s_n_m_292825;
    futhark_mc_segmap_parloop_struct_338113.free_gtid_301175 = gtid_301175;
    futhark_mc_segmap_parloop_struct_338113.free_mem_312838 = mem_312838.mem;
    futhark_mc_segmap_parloop_struct_338113.free_mem_313018 = mem_313018.mem;
    futhark_mc_segmap_parloop_struct_338113.free_mem_313023 = mem_313023.mem;
    futhark_mc_segmap_parloop_struct_338113.free_mem_313366 = mem_313366.mem;
    futhark_mc_segmap_parloop_struct_338113.free_mem_313371 = mem_313371.mem;
    futhark_mc_segmap_parloop_struct_338113.free_bytes_313879 = bytes_313879;
    futhark_mc_segmap_parloop_struct_338113.free_gtid_322690 = gtid_322690;
    futhark_mc_segmap_parloop_struct_338113.free_x_322691 = x_322691;
    futhark_mc_segmap_parloop_struct_338113.free_mem_322692 = mem_322692.mem;
    futhark_mc_segmap_parloop_struct_338113.free_mem_322693 = mem_322693.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338114_task;
    
    futhark_mc_segmap_parloop_338114_task.name =
        "futhark_mc_segmap_parloop_338114";
    futhark_mc_segmap_parloop_338114_task.fn = futhark_mc_segmap_parloop_338114;
    futhark_mc_segmap_parloop_338114_task.args =
        &futhark_mc_segmap_parloop_struct_338113;
    futhark_mc_segmap_parloop_338114_task.iterations = iterations;
    futhark_mc_segmap_parloop_338114_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338114_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338114_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338114_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338114_task);
    
    if (futhark_mc_segmap_parloop_338114_err != 0) {
        err = futhark_mc_segmap_parloop_338114_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338114_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338114_total_end -
                 futhark_mc_segmap_parloop_338114_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338114_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338114_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338114_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_338112_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_338112_end -
                 futhark_mc_segmap_task_338112_start;
        
        ctx->futhark_mc_segmap_task_338112_runs[tid]++;
        ctx->futhark_mc_segmap_task_338112_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_338112_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_segmap_parloop_struct_338118 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_q_s_292678;
    int64_t free_jump_s_292684;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    int64_t free_gtid_301175;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_313018;
    unsigned char *free_mem_313023;
    unsigned char *free_mem_313366;
    unsigned char *free_mem_313371;
    int64_t free_bytes_313879;
    int64_t free_gtid_322690;
    int64_t free_x_322691;
    unsigned char *free_mem_322692;
    unsigned char *free_mem_322693;
};
struct futhark_mc_task_338122 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_gtid_301175;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_313371;
    int64_t free_gtid_322690;
    int64_t free_x_322691;
    int64_t free_x_323072;
    double free_x_323073;
    int64_t free_defunc_0_m_fun_res_323075;
    double *retval_defunc_2_reduce_res_323086;
    double *retval_defunc_2_reduce_res_323087;
    double *retval_defunc_2_reduce_res_323088;
    unsigned char *retval_mem_323084;
    unsigned char *retval_mem_323085;
};
struct futhark_mc_segred_stage_1_parloop_struct_338127 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_gtid_301175;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_313371;
    int64_t free_gtid_322690;
    int64_t free_x_322691;
    int64_t free_x_323072;
    double free_x_323073;
    int64_t free_defunc_0_m_fun_res_323075;
    unsigned char *free_mem_323084;
    unsigned char *free_mem_323085;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_323379;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_323381;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_323383;
};
static int futhark_mc_segred_stage_1_parloop_338128(void *args, int64_t start,
                                                    int64_t end,
                                                    int flat_tid_323323,
                                                    int tid)
{
    int err = 0;
    struct futhark_mc_segred_stage_1_parloop_struct_338127
    *futhark_mc_segred_stage_1_parloop_struct_338127 =
    (struct futhark_mc_segred_stage_1_parloop_struct_338127 *) args;
    struct futhark_context *ctx =
                           futhark_mc_segred_stage_1_parloop_struct_338127->ctx;
    uint64_t futhark_mc_segred_stage_1_parloop_338128_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_338128_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segred_stage_1_parloop_struct_338127->free_n_p_292677;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segred_stage_1_parloop_struct_338127->free_defunc_0_f_res_292820;
    int64_t gtid_301175 =
            futhark_mc_segred_stage_1_parloop_struct_338127->free_gtid_301175;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_338127->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_338127->free_mem_313371,
                                  .size =0, .references =NULL};
    int64_t gtid_322690 =
            futhark_mc_segred_stage_1_parloop_struct_338127->free_gtid_322690;
    int64_t x_322691 =
            futhark_mc_segred_stage_1_parloop_struct_338127->free_x_322691;
    int64_t x_323072 =
            futhark_mc_segred_stage_1_parloop_struct_338127->free_x_323072;
    double x_323073 =
           futhark_mc_segred_stage_1_parloop_struct_338127->free_x_323073;
    int64_t defunc_0_m_fun_res_323075 =
            futhark_mc_segred_stage_1_parloop_struct_338127->free_defunc_0_m_fun_res_323075;
    struct memblock mem_323084 = {.desc ="mem_323084", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_338127->free_mem_323084,
                                  .size =0, .references =NULL};
    struct memblock mem_323085 = {.desc ="mem_323085", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_338127->free_mem_323085,
                                  .size =0, .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_323379 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_323379",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338127->free_reduce_stage_1_tid_res_arr_mem_323379,
                                                             .size =0,
                                                             .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_323381 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_323381",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338127->free_reduce_stage_1_tid_res_arr_mem_323381,
                                                             .size =0,
                                                             .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_323383 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_323383",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338127->free_reduce_stage_1_tid_res_arr_mem_323383,
                                                             .size =0,
                                                             .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_323385 = start;
    double x_323325;
    double x_323326;
    double x_323328;
    double x_323329;
    double x_323331;
    double x_323332;
    double local_acc_323386 = 0.0;
    double local_acc_323387 = 0.0;
    double local_acc_323388 = 0.0;
    
    for (; iter_323385 < end; iter_323385++) {
        int64_t gtid_323324 = iter_323385;
        bool cond_323334 = sle64(x_322691, gtid_323324);
        int64_t defunc_0_f_res_323335;
        
        if (cond_323334) {
            defunc_0_f_res_323335 = (int64_t) 0;
        } else {
            int64_t i_323336 = add64(x_323072, gtid_323324);
            int64_t defunc_0_add_arg_323337;
            
            defunc_0_add_arg_323337 = ((int64_t *) mem_312838.mem)[gtid_301175 *
                                                                   (defunc_0_f_res_292820 *
                                                                    n_p_292677) +
                                                                   gtid_322690 *
                                                                   defunc_0_f_res_292820 +
                                                                   i_323336];
            
            int64_t defunc_1_add_res_323338 = add64((int64_t) 1,
                                                    defunc_0_add_arg_323337);
            
            defunc_0_f_res_323335 = defunc_1_add_res_323338;
        }
        
        double defunc_0_f_res_323339;
        
        if (cond_323334) {
            defunc_0_f_res_323339 = 0.0;
        } else {
            int64_t i_323340 = add64(x_323072, gtid_323324);
            double defunc_0_add_arg_323341;
            
            defunc_0_add_arg_323341 = ((double *) mem_313371.mem)[gtid_301175 *
                                                                  (defunc_0_f_res_292820 *
                                                                   n_p_292677) +
                                                                  gtid_322690 *
                                                                  defunc_0_f_res_292820 +
                                                                  i_323340];
            defunc_0_f_res_323339 = defunc_0_add_arg_323341;
        }
        
        int64_t binop_p_323342 = sub64(defunc_0_f_res_323335,
                                       defunc_0_m_fun_res_323075);
        double defunc_0_f_res_323343 = sitofp_i64_f64(binop_p_323342);
        double abs_res_323344 = fabs(defunc_0_f_res_323343);
        double tmp1_323345 = abs_res_323344 / x_323073;
        double x_323346 = tmp1_323345 * tmp1_323345;
        double y_323347 = tmp1_323345 * x_323346;
        double tmp2_323348 = 1.0 - y_323347;
        double x_323349 = tmp2_323348 * tmp2_323348;
        double tmp3_323350 = tmp2_323348 * x_323349;
        double tmp4_323351 = defunc_0_f_res_323339 * tmp3_323350;
        double defunc_1_f_res_323352 = defunc_0_f_res_323343 * tmp4_323351;
        double defunc_1_f_res_323353 = defunc_0_f_res_323343 *
               defunc_1_f_res_323352;
        
        // save map-out results
        {
            ((double *) mem_323084.mem)[gtid_323324] = defunc_1_f_res_323352;
            ((double *) mem_323085.mem)[gtid_323324] = tmp4_323351;
        }
        // Load accum params
        {
            x_323325 = local_acc_323386;
        }
        // Load next params
        {
            x_323326 = tmp4_323351;
        }
        // Red body
        {
            double defunc_1_op_res_323327 = x_323325 + x_323326;
            
            local_acc_323386 = defunc_1_op_res_323327;
        }
        // Load accum params
        {
            x_323328 = local_acc_323387;
        }
        // Load next params
        {
            x_323329 = defunc_1_f_res_323352;
        }
        // Red body
        {
            double defunc_1_op_res_323330 = x_323328 + x_323329;
            
            local_acc_323387 = defunc_1_op_res_323330;
        }
        // Load accum params
        {
            x_323331 = local_acc_323388;
        }
        // Load next params
        {
            x_323332 = defunc_1_f_res_323353;
        }
        // Red body
        {
            double defunc_1_op_res_323333 = x_323331 + x_323332;
            
            local_acc_323388 = defunc_1_op_res_323333;
        }
    }
    ((double *) reduce_stage_1_tid_res_arr_mem_323379.mem)[flat_tid_323323] =
        local_acc_323386;
    ((double *) reduce_stage_1_tid_res_arr_mem_323381.mem)[flat_tid_323323] =
        local_acc_323387;
    ((double *) reduce_stage_1_tid_res_arr_mem_323383.mem)[flat_tid_323323] =
        local_acc_323388;
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_338128_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_338128_end -
                 futhark_mc_segred_stage_1_parloop_338128_start;
        
        ctx->futhark_mc_segred_stage_1_parloop_338128_runs[tid]++;
        ctx->futhark_mc_segred_stage_1_parloop_338128_total_runtime[tid] +=
            elapsed;
        ctx->futhark_mc_segred_stage_1_parloop_338128_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segred_task_338123(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_323323 = tid;
    int num_tasks_323378 = info.nsubtasks;
    struct futhark_mc_task_338122 *futhark_mc_task_338122 =
                                  (struct futhark_mc_task_338122 *) args;
    struct futhark_context *ctx = futhark_mc_task_338122->ctx;
    uint64_t futhark_mc_segred_task_338123_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_task_338123_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_338122->free_n_p_292677;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_338122->free_defunc_0_f_res_292820;
    int64_t gtid_301175 = futhark_mc_task_338122->free_gtid_301175;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_task_338122->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_task_338122->free_mem_313371,
                                  .size =0, .references =NULL};
    int64_t gtid_322690 = futhark_mc_task_338122->free_gtid_322690;
    int64_t x_322691 = futhark_mc_task_338122->free_x_322691;
    int64_t x_323072 = futhark_mc_task_338122->free_x_323072;
    double x_323073 = futhark_mc_task_338122->free_x_323073;
    int64_t defunc_0_m_fun_res_323075 =
            futhark_mc_task_338122->free_defunc_0_m_fun_res_323075;
    double defunc_2_reduce_res_323086 =
           *futhark_mc_task_338122->retval_defunc_2_reduce_res_323086;
    double defunc_2_reduce_res_323087 =
           *futhark_mc_task_338122->retval_defunc_2_reduce_res_323087;
    double defunc_2_reduce_res_323088 =
           *futhark_mc_task_338122->retval_defunc_2_reduce_res_323088;
    struct memblock mem_323084 = {.desc ="mem_323084", .mem =
                                  futhark_mc_task_338122->retval_mem_323084,
                                  .size =0, .references =NULL};
    struct memblock mem_323085 = {.desc ="mem_323085", .mem =
                                  futhark_mc_task_338122->retval_mem_323085,
                                  .size =0, .references =NULL};
    size_t reduce_stage_1_tid_res_arr_mem_323379_cached_sizze_338124 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_323379 = NULL;
    size_t reduce_stage_1_tid_res_arr_mem_323381_cached_sizze_338125 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_323381 = NULL;
    size_t reduce_stage_1_tid_res_arr_mem_323383_cached_sizze_338126 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_323383 = NULL;
    
    if (reduce_stage_1_tid_res_arr_mem_323379_cached_sizze_338124 <
        (size_t) ((int64_t) 8 * num_tasks_323378)) {
        reduce_stage_1_tid_res_arr_mem_323379 =
            realloc(reduce_stage_1_tid_res_arr_mem_323379, (int64_t) 8 *
                    num_tasks_323378);
        reduce_stage_1_tid_res_arr_mem_323379_cached_sizze_338124 =
            (int64_t) 8 * num_tasks_323378;
    }
    if (reduce_stage_1_tid_res_arr_mem_323381_cached_sizze_338125 <
        (size_t) ((int64_t) 8 * num_tasks_323378)) {
        reduce_stage_1_tid_res_arr_mem_323381 =
            realloc(reduce_stage_1_tid_res_arr_mem_323381, (int64_t) 8 *
                    num_tasks_323378);
        reduce_stage_1_tid_res_arr_mem_323381_cached_sizze_338125 =
            (int64_t) 8 * num_tasks_323378;
    }
    if (reduce_stage_1_tid_res_arr_mem_323383_cached_sizze_338126 <
        (size_t) ((int64_t) 8 * num_tasks_323378)) {
        reduce_stage_1_tid_res_arr_mem_323383 =
            realloc(reduce_stage_1_tid_res_arr_mem_323383, (int64_t) 8 *
                    num_tasks_323378);
        reduce_stage_1_tid_res_arr_mem_323383_cached_sizze_338126 =
            (int64_t) 8 * num_tasks_323378;
    }
    
    int64_t iter_323385;
    struct futhark_mc_segred_stage_1_parloop_struct_338127
    futhark_mc_segred_stage_1_parloop_struct_338127;
    
    futhark_mc_segred_stage_1_parloop_struct_338127.ctx = ctx;
    futhark_mc_segred_stage_1_parloop_struct_338127.free_n_p_292677 =
        n_p_292677;
    futhark_mc_segred_stage_1_parloop_struct_338127.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segred_stage_1_parloop_struct_338127.free_gtid_301175 =
        gtid_301175;
    futhark_mc_segred_stage_1_parloop_struct_338127.free_mem_312838 =
        mem_312838.mem;
    futhark_mc_segred_stage_1_parloop_struct_338127.free_mem_313371 =
        mem_313371.mem;
    futhark_mc_segred_stage_1_parloop_struct_338127.free_gtid_322690 =
        gtid_322690;
    futhark_mc_segred_stage_1_parloop_struct_338127.free_x_322691 = x_322691;
    futhark_mc_segred_stage_1_parloop_struct_338127.free_x_323072 = x_323072;
    futhark_mc_segred_stage_1_parloop_struct_338127.free_x_323073 = x_323073;
    futhark_mc_segred_stage_1_parloop_struct_338127.free_defunc_0_m_fun_res_323075 =
        defunc_0_m_fun_res_323075;
    futhark_mc_segred_stage_1_parloop_struct_338127.free_mem_323084 =
        mem_323084.mem;
    futhark_mc_segred_stage_1_parloop_struct_338127.free_mem_323085 =
        mem_323085.mem;
    futhark_mc_segred_stage_1_parloop_struct_338127.free_reduce_stage_1_tid_res_arr_mem_323379 =
        reduce_stage_1_tid_res_arr_mem_323379;
    futhark_mc_segred_stage_1_parloop_struct_338127.free_reduce_stage_1_tid_res_arr_mem_323381 =
        reduce_stage_1_tid_res_arr_mem_323381;
    futhark_mc_segred_stage_1_parloop_struct_338127.free_reduce_stage_1_tid_res_arr_mem_323383 =
        reduce_stage_1_tid_res_arr_mem_323383;
    
    struct scheduler_parloop futhark_mc_segred_stage_1_parloop_338128_task;
    
    futhark_mc_segred_stage_1_parloop_338128_task.name =
        "futhark_mc_segred_stage_1_parloop_338128";
    futhark_mc_segred_stage_1_parloop_338128_task.fn =
        futhark_mc_segred_stage_1_parloop_338128;
    futhark_mc_segred_stage_1_parloop_338128_task.args =
        &futhark_mc_segred_stage_1_parloop_struct_338127;
    futhark_mc_segred_stage_1_parloop_338128_task.iterations = iterations;
    futhark_mc_segred_stage_1_parloop_338128_task.info = info;
    
    uint64_t futhark_mc_segred_stage_1_parloop_338128_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_338128_total_start = get_wall_time();
    
    int futhark_mc_segred_stage_1_parloop_338128_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segred_stage_1_parloop_338128_task);
    
    if (futhark_mc_segred_stage_1_parloop_338128_err != 0) {
        err = futhark_mc_segred_stage_1_parloop_338128_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_338128_total_end =
                 get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_338128_total_end -
                 futhark_mc_segred_stage_1_parloop_338128_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338128_total_runs,
                           1, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338128_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338128_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    // neutral-initialise the output
    {
        defunc_2_reduce_res_323086 = 0.0;
        defunc_2_reduce_res_323087 = 0.0;
        defunc_2_reduce_res_323088 = 0.0;
    }
    
    double x_323389;
    double x_323390;
    double x_323392;
    double x_323393;
    double x_323395;
    double x_323396;
    
    for (int32_t i_323398 = 0; i_323398 < num_tasks_323378; i_323398++) {
        flat_tid_323323 = i_323398;
        // Apply main thread reduction
        {
            // load acc params
            {
                x_323389 = defunc_2_reduce_res_323086;
            }
            // load next params
            {
                x_323390 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_323379)[flat_tid_323323];
            }
            // red body
            {
                double defunc_1_op_res_323391 = x_323389 + x_323390;
                
                defunc_2_reduce_res_323086 = defunc_1_op_res_323391;
            }
            // load acc params
            {
                x_323392 = defunc_2_reduce_res_323087;
            }
            // load next params
            {
                x_323393 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_323381)[flat_tid_323323];
            }
            // red body
            {
                double defunc_1_op_res_323394 = x_323392 + x_323393;
                
                defunc_2_reduce_res_323087 = defunc_1_op_res_323394;
            }
            // load acc params
            {
                x_323395 = defunc_2_reduce_res_323088;
            }
            // load next params
            {
                x_323396 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_323383)[flat_tid_323323];
            }
            // red body
            {
                double defunc_1_op_res_323397 = x_323395 + x_323396;
                
                defunc_2_reduce_res_323088 = defunc_1_op_res_323397;
            }
        }
    }
    
  cleanup:
    {
        free(reduce_stage_1_tid_res_arr_mem_323379);
        free(reduce_stage_1_tid_res_arr_mem_323381);
        free(reduce_stage_1_tid_res_arr_mem_323383);
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_task_338123_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_task_338123_end -
                 futhark_mc_segred_task_338123_start;
        
        ctx->futhark_mc_segred_task_338123_runs[tid]++;
        ctx->futhark_mc_segred_task_338123_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segred_task_338123_iter[tid] += iterations;
    }
    if (err == 0) {
        *futhark_mc_task_338122->retval_defunc_2_reduce_res_323086 =
            defunc_2_reduce_res_323086;
        *futhark_mc_task_338122->retval_defunc_2_reduce_res_323087 =
            defunc_2_reduce_res_323087;
        *futhark_mc_task_338122->retval_defunc_2_reduce_res_323088 =
            defunc_2_reduce_res_323088;
        futhark_mc_task_338122->retval_mem_323084 = mem_323084.mem;
        futhark_mc_task_338122->retval_mem_323085 = mem_323085.mem;
    }
    return err;
}
struct futhark_mc_task_338129 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_gtid_301175;
    unsigned char *free_mem_313366;
    int64_t free_gtid_322690;
    int64_t free_x_322691;
    int64_t free_x_323072;
    unsigned char *free_mem_323084;
    unsigned char *free_mem_323085;
    double free_a11_323129;
    double free_b11_323131;
    double free_c11_323132;
    double *retval_defunc_2_reduce_res_323133;
    double *retval_defunc_2_reduce_res_323134;
};
struct futhark_mc_segred_stage_1_parloop_struct_338133 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_gtid_301175;
    unsigned char *free_mem_313366;
    int64_t free_gtid_322690;
    int64_t free_x_322691;
    int64_t free_x_323072;
    unsigned char *free_mem_323084;
    unsigned char *free_mem_323085;
    double free_a11_323129;
    double free_b11_323131;
    double free_c11_323132;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_323400;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_323402;
};
static int futhark_mc_segred_stage_1_parloop_338134(void *args, int64_t start,
                                                    int64_t end,
                                                    int flat_tid_323354,
                                                    int tid)
{
    int err = 0;
    struct futhark_mc_segred_stage_1_parloop_struct_338133
    *futhark_mc_segred_stage_1_parloop_struct_338133 =
    (struct futhark_mc_segred_stage_1_parloop_struct_338133 *) args;
    struct futhark_context *ctx =
                           futhark_mc_segred_stage_1_parloop_struct_338133->ctx;
    uint64_t futhark_mc_segred_stage_1_parloop_338134_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_338134_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segred_stage_1_parloop_struct_338133->free_n_p_292677;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segred_stage_1_parloop_struct_338133->free_defunc_0_f_res_292820;
    int64_t gtid_301175 =
            futhark_mc_segred_stage_1_parloop_struct_338133->free_gtid_301175;
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_338133->free_mem_313366,
                                  .size =0, .references =NULL};
    int64_t gtid_322690 =
            futhark_mc_segred_stage_1_parloop_struct_338133->free_gtid_322690;
    int64_t x_322691 =
            futhark_mc_segred_stage_1_parloop_struct_338133->free_x_322691;
    int64_t x_323072 =
            futhark_mc_segred_stage_1_parloop_struct_338133->free_x_323072;
    struct memblock mem_323084 = {.desc ="mem_323084", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_338133->free_mem_323084,
                                  .size =0, .references =NULL};
    struct memblock mem_323085 = {.desc ="mem_323085", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_338133->free_mem_323085,
                                  .size =0, .references =NULL};
    double a11_323129 =
           futhark_mc_segred_stage_1_parloop_struct_338133->free_a11_323129;
    double b11_323131 =
           futhark_mc_segred_stage_1_parloop_struct_338133->free_b11_323131;
    double c11_323132 =
           futhark_mc_segred_stage_1_parloop_struct_338133->free_c11_323132;
    struct memblock reduce_stage_1_tid_res_arr_mem_323400 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_323400",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338133->free_reduce_stage_1_tid_res_arr_mem_323400,
                                                             .size =0,
                                                             .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_323402 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_323402",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338133->free_reduce_stage_1_tid_res_arr_mem_323402,
                                                             .size =0,
                                                             .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_323404 = start;
    double x_323356;
    double x_323357;
    double x_323359;
    double x_323360;
    double local_acc_323405 = 0.0;
    double local_acc_323406 = 0.0;
    
    for (; iter_323404 < end; iter_323404++) {
        int64_t gtid_323355 = iter_323404;
        double x_323362;
        
        x_323362 = ((double *) mem_323085.mem)[gtid_323355];
        
        double x_323363;
        
        x_323363 = ((double *) mem_323084.mem)[gtid_323355];
        
        bool cond_323364 = sle64(x_322691, gtid_323355);
        double defunc_0_f_res_323365;
        
        if (cond_323364) {
            defunc_0_f_res_323365 = 0.0;
        } else {
            int64_t i_323366 = add64(x_323072, gtid_323355);
            double defunc_0_add_arg_323367;
            
            defunc_0_add_arg_323367 = ((double *) mem_313366.mem)[gtid_301175 *
                                                                  (defunc_0_f_res_292820 *
                                                                   n_p_292677) +
                                                                  gtid_322690 *
                                                                  defunc_0_f_res_292820 +
                                                                  i_323366];
            defunc_0_f_res_323365 = defunc_0_add_arg_323367;
        }
        
        double x_323368 = a11_323129 * x_323362;
        double y_323369 = b11_323131 * x_323363;
        double x_323370 = x_323368 + y_323369;
        double defunc_9_fit_fun_res_323371 = defunc_0_f_res_323365 * x_323370;
        double x_323372 = b11_323131 * x_323362;
        double y_323373 = c11_323132 * x_323363;
        double x_323374 = x_323372 + y_323373;
        double defunc_9_slope_fun_res_323375 = defunc_0_f_res_323365 * x_323374;
        
        // save map-out results
        { }
        // Load accum params
        {
            x_323356 = local_acc_323405;
        }
        // Load next params
        {
            x_323357 = defunc_9_fit_fun_res_323371;
        }
        // Red body
        {
            double defunc_1_op_res_323358 = x_323356 + x_323357;
            
            local_acc_323405 = defunc_1_op_res_323358;
        }
        // Load accum params
        {
            x_323359 = local_acc_323406;
        }
        // Load next params
        {
            x_323360 = defunc_9_slope_fun_res_323375;
        }
        // Red body
        {
            double defunc_1_op_res_323361 = x_323359 + x_323360;
            
            local_acc_323406 = defunc_1_op_res_323361;
        }
    }
    ((double *) reduce_stage_1_tid_res_arr_mem_323400.mem)[flat_tid_323354] =
        local_acc_323405;
    ((double *) reduce_stage_1_tid_res_arr_mem_323402.mem)[flat_tid_323354] =
        local_acc_323406;
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_338134_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_338134_end -
                 futhark_mc_segred_stage_1_parloop_338134_start;
        
        ctx->futhark_mc_segred_stage_1_parloop_338134_runs[tid]++;
        ctx->futhark_mc_segred_stage_1_parloop_338134_total_runtime[tid] +=
            elapsed;
        ctx->futhark_mc_segred_stage_1_parloop_338134_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segred_task_338130(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_323354 = tid;
    int num_tasks_323399 = info.nsubtasks;
    struct futhark_mc_task_338129 *futhark_mc_task_338129 =
                                  (struct futhark_mc_task_338129 *) args;
    struct futhark_context *ctx = futhark_mc_task_338129->ctx;
    uint64_t futhark_mc_segred_task_338130_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_task_338130_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_338129->free_n_p_292677;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_338129->free_defunc_0_f_res_292820;
    int64_t gtid_301175 = futhark_mc_task_338129->free_gtid_301175;
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_task_338129->free_mem_313366,
                                  .size =0, .references =NULL};
    int64_t gtid_322690 = futhark_mc_task_338129->free_gtid_322690;
    int64_t x_322691 = futhark_mc_task_338129->free_x_322691;
    int64_t x_323072 = futhark_mc_task_338129->free_x_323072;
    struct memblock mem_323084 = {.desc ="mem_323084", .mem =
                                  futhark_mc_task_338129->free_mem_323084,
                                  .size =0, .references =NULL};
    struct memblock mem_323085 = {.desc ="mem_323085", .mem =
                                  futhark_mc_task_338129->free_mem_323085,
                                  .size =0, .references =NULL};
    double a11_323129 = futhark_mc_task_338129->free_a11_323129;
    double b11_323131 = futhark_mc_task_338129->free_b11_323131;
    double c11_323132 = futhark_mc_task_338129->free_c11_323132;
    double defunc_2_reduce_res_323133 =
           *futhark_mc_task_338129->retval_defunc_2_reduce_res_323133;
    double defunc_2_reduce_res_323134 =
           *futhark_mc_task_338129->retval_defunc_2_reduce_res_323134;
    size_t reduce_stage_1_tid_res_arr_mem_323400_cached_sizze_338131 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_323400 = NULL;
    size_t reduce_stage_1_tid_res_arr_mem_323402_cached_sizze_338132 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_323402 = NULL;
    
    if (reduce_stage_1_tid_res_arr_mem_323400_cached_sizze_338131 <
        (size_t) ((int64_t) 8 * num_tasks_323399)) {
        reduce_stage_1_tid_res_arr_mem_323400 =
            realloc(reduce_stage_1_tid_res_arr_mem_323400, (int64_t) 8 *
                    num_tasks_323399);
        reduce_stage_1_tid_res_arr_mem_323400_cached_sizze_338131 =
            (int64_t) 8 * num_tasks_323399;
    }
    if (reduce_stage_1_tid_res_arr_mem_323402_cached_sizze_338132 <
        (size_t) ((int64_t) 8 * num_tasks_323399)) {
        reduce_stage_1_tid_res_arr_mem_323402 =
            realloc(reduce_stage_1_tid_res_arr_mem_323402, (int64_t) 8 *
                    num_tasks_323399);
        reduce_stage_1_tid_res_arr_mem_323402_cached_sizze_338132 =
            (int64_t) 8 * num_tasks_323399;
    }
    
    int64_t iter_323404;
    struct futhark_mc_segred_stage_1_parloop_struct_338133
    futhark_mc_segred_stage_1_parloop_struct_338133;
    
    futhark_mc_segred_stage_1_parloop_struct_338133.ctx = ctx;
    futhark_mc_segred_stage_1_parloop_struct_338133.free_n_p_292677 =
        n_p_292677;
    futhark_mc_segred_stage_1_parloop_struct_338133.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segred_stage_1_parloop_struct_338133.free_gtid_301175 =
        gtid_301175;
    futhark_mc_segred_stage_1_parloop_struct_338133.free_mem_313366 =
        mem_313366.mem;
    futhark_mc_segred_stage_1_parloop_struct_338133.free_gtid_322690 =
        gtid_322690;
    futhark_mc_segred_stage_1_parloop_struct_338133.free_x_322691 = x_322691;
    futhark_mc_segred_stage_1_parloop_struct_338133.free_x_323072 = x_323072;
    futhark_mc_segred_stage_1_parloop_struct_338133.free_mem_323084 =
        mem_323084.mem;
    futhark_mc_segred_stage_1_parloop_struct_338133.free_mem_323085 =
        mem_323085.mem;
    futhark_mc_segred_stage_1_parloop_struct_338133.free_a11_323129 =
        a11_323129;
    futhark_mc_segred_stage_1_parloop_struct_338133.free_b11_323131 =
        b11_323131;
    futhark_mc_segred_stage_1_parloop_struct_338133.free_c11_323132 =
        c11_323132;
    futhark_mc_segred_stage_1_parloop_struct_338133.free_reduce_stage_1_tid_res_arr_mem_323400 =
        reduce_stage_1_tid_res_arr_mem_323400;
    futhark_mc_segred_stage_1_parloop_struct_338133.free_reduce_stage_1_tid_res_arr_mem_323402 =
        reduce_stage_1_tid_res_arr_mem_323402;
    
    struct scheduler_parloop futhark_mc_segred_stage_1_parloop_338134_task;
    
    futhark_mc_segred_stage_1_parloop_338134_task.name =
        "futhark_mc_segred_stage_1_parloop_338134";
    futhark_mc_segred_stage_1_parloop_338134_task.fn =
        futhark_mc_segred_stage_1_parloop_338134;
    futhark_mc_segred_stage_1_parloop_338134_task.args =
        &futhark_mc_segred_stage_1_parloop_struct_338133;
    futhark_mc_segred_stage_1_parloop_338134_task.iterations = iterations;
    futhark_mc_segred_stage_1_parloop_338134_task.info = info;
    
    uint64_t futhark_mc_segred_stage_1_parloop_338134_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_338134_total_start = get_wall_time();
    
    int futhark_mc_segred_stage_1_parloop_338134_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segred_stage_1_parloop_338134_task);
    
    if (futhark_mc_segred_stage_1_parloop_338134_err != 0) {
        err = futhark_mc_segred_stage_1_parloop_338134_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_338134_total_end =
                 get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_338134_total_end -
                 futhark_mc_segred_stage_1_parloop_338134_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338134_total_runs,
                           1, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338134_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338134_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    // neutral-initialise the output
    {
        defunc_2_reduce_res_323133 = 0.0;
        defunc_2_reduce_res_323134 = 0.0;
    }
    
    double x_323407;
    double x_323408;
    double x_323410;
    double x_323411;
    
    for (int32_t i_323413 = 0; i_323413 < num_tasks_323399; i_323413++) {
        flat_tid_323354 = i_323413;
        // Apply main thread reduction
        {
            // load acc params
            {
                x_323407 = defunc_2_reduce_res_323133;
            }
            // load next params
            {
                x_323408 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_323400)[flat_tid_323354];
            }
            // red body
            {
                double defunc_1_op_res_323409 = x_323407 + x_323408;
                
                defunc_2_reduce_res_323133 = defunc_1_op_res_323409;
            }
            // load acc params
            {
                x_323410 = defunc_2_reduce_res_323134;
            }
            // load next params
            {
                x_323411 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_323402)[flat_tid_323354];
            }
            // red body
            {
                double defunc_1_op_res_323412 = x_323410 + x_323411;
                
                defunc_2_reduce_res_323134 = defunc_1_op_res_323412;
            }
        }
    }
    
  cleanup:
    {
        free(reduce_stage_1_tid_res_arr_mem_323400);
        free(reduce_stage_1_tid_res_arr_mem_323402);
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_task_338130_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_task_338130_end -
                 futhark_mc_segred_task_338130_start;
        
        ctx->futhark_mc_segred_task_338130_runs[tid]++;
        ctx->futhark_mc_segred_task_338130_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segred_task_338130_iter[tid] += iterations;
    }
    if (err == 0) {
        *futhark_mc_task_338129->retval_defunc_2_reduce_res_323133 =
            defunc_2_reduce_res_323133;
        *futhark_mc_task_338129->retval_defunc_2_reduce_res_323134 =
            defunc_2_reduce_res_323134;
    }
    return err;
}
static int futhark_mc_segmap_parloop_338119(void *args, int64_t start,
                                            int64_t end, int flat_tid_323070,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338118
    *futhark_mc_segmap_parloop_struct_338118 =
    (struct futhark_mc_segmap_parloop_struct_338118 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338118->ctx;
    uint64_t futhark_mc_segmap_parloop_338119_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338119_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segmap_parloop_struct_338118->free_n_p_292677;
    int64_t q_s_292678 =
            futhark_mc_segmap_parloop_struct_338118->free_q_s_292678;
    int64_t jump_s_292684 =
            futhark_mc_segmap_parloop_struct_338118->free_jump_s_292684;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segmap_parloop_struct_338118->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_segmap_parloop_struct_338118->free_pad_css_len_292821;
    int64_t s_n_m_292825 =
            futhark_mc_segmap_parloop_struct_338118->free_s_n_m_292825;
    int64_t gtid_301175 =
            futhark_mc_segmap_parloop_struct_338118->free_gtid_301175;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_segmap_parloop_struct_338118->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_segmap_parloop_struct_338118->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_segmap_parloop_struct_338118->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_segmap_parloop_struct_338118->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_segmap_parloop_struct_338118->free_mem_313371,
                                  .size =0, .references =NULL};
    int64_t bytes_313879 =
            futhark_mc_segmap_parloop_struct_338118->free_bytes_313879;
    int64_t gtid_322690 =
            futhark_mc_segmap_parloop_struct_338118->free_gtid_322690;
    int64_t x_322691 = futhark_mc_segmap_parloop_struct_338118->free_x_322691;
    struct memblock mem_322692 = {.desc ="mem_322692", .mem =
                                  futhark_mc_segmap_parloop_struct_338118->free_mem_322692,
                                  .size =0, .references =NULL};
    struct memblock mem_322693 = {.desc ="mem_322693", .mem =
                                  futhark_mc_segmap_parloop_struct_338118->free_mem_322693,
                                  .size =0, .references =NULL};
    size_t mem_323084_cached_sizze_338120 = 0;
    unsigned char *mem_323084 = NULL;
    size_t mem_323085_cached_sizze_338121 = 0;
    unsigned char *mem_323085 = NULL;
    int64_t iterations = end - start;
    int64_t iter_323314 = start;
    
    if (mem_323084_cached_sizze_338120 < (size_t) bytes_313879) {
        mem_323084 = realloc(mem_323084, bytes_313879);
        mem_323084_cached_sizze_338120 = bytes_313879;
    }
    if (mem_323085_cached_sizze_338121 < (size_t) bytes_313879) {
        mem_323085 = realloc(mem_323085, bytes_313879);
        mem_323085_cached_sizze_338121 = bytes_313879;
    }
    for (; iter_323314 < end; iter_323314++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_323376 = s_n_m_292825;
        int64_t gtid_323071 = iter_323314;
        int64_t remnant_323377 = iter_323314 - gtid_323071;
        int64_t x_323072;
        
        x_323072 = ((int64_t *) mem_313018.mem)[gtid_301175 * (s_n_m_292825 *
                                                               n_p_292677) +
                                                gtid_322690 * s_n_m_292825 +
                                                gtid_323071];
        
        double x_323073;
        
        x_323073 = ((double *) mem_313023.mem)[gtid_301175 * (s_n_m_292825 *
                                                              n_p_292677) +
                                               gtid_322690 * s_n_m_292825 +
                                               gtid_323071];
        
        bool cond_323074 = gtid_323071 == (int64_t) 0;
        int64_t defunc_0_m_fun_res_323075;
        
        if (cond_323074) {
            defunc_0_m_fun_res_323075 = (int64_t) 0;
        } else {
            int64_t y_323315 = sub64(s_n_m_292825, (int64_t) 1);
            bool cond_323316 = gtid_323071 == y_323315;
            int64_t defunc_0_m_fun_res_f_res_323317;
            
            if (cond_323316) {
                int64_t defunc_0_m_fun_res_f_res_t_res_323318 =
                        sub64(pad_css_len_292821, (int64_t) 1);
                
                defunc_0_m_fun_res_f_res_323317 =
                    defunc_0_m_fun_res_f_res_t_res_323318;
            } else {
                int64_t x_323319 = sub64(gtid_323071, (int64_t) 1);
                int64_t x_323320 = mul64(jump_s_292684, x_323319);
                int64_t min_arg_323321 = add64((int64_t) 1, x_323320);
                int64_t min_res_323322 = smin64(defunc_0_f_res_292820,
                                                min_arg_323321);
                
                defunc_0_m_fun_res_f_res_323317 = min_res_323322;
            }
            defunc_0_m_fun_res_323075 = defunc_0_m_fun_res_f_res_323317;
        }
        
        double defunc_2_reduce_res_323086;
        double defunc_2_reduce_res_323087;
        double defunc_2_reduce_res_323088;
        int64_t flat_tid_323323 = (int64_t) 0;
        int32_t num_tasks_323378;
        
        defunc_2_reduce_res_323086 = 0.0;
        defunc_2_reduce_res_323087 = 0.0;
        defunc_2_reduce_res_323088 = 0.0;
        
        struct futhark_mc_task_338122 futhark_mc_task_338122;
        
        futhark_mc_task_338122.ctx = ctx;
        futhark_mc_task_338122.free_n_p_292677 = n_p_292677;
        futhark_mc_task_338122.free_defunc_0_f_res_292820 =
            defunc_0_f_res_292820;
        futhark_mc_task_338122.free_gtid_301175 = gtid_301175;
        futhark_mc_task_338122.free_mem_312838 = mem_312838.mem;
        futhark_mc_task_338122.free_mem_313371 = mem_313371.mem;
        futhark_mc_task_338122.free_gtid_322690 = gtid_322690;
        futhark_mc_task_338122.free_x_322691 = x_322691;
        futhark_mc_task_338122.free_x_323072 = x_323072;
        futhark_mc_task_338122.free_x_323073 = x_323073;
        futhark_mc_task_338122.free_defunc_0_m_fun_res_323075 =
            defunc_0_m_fun_res_323075;
        futhark_mc_task_338122.retval_defunc_2_reduce_res_323086 =
            &defunc_2_reduce_res_323086;
        futhark_mc_task_338122.retval_defunc_2_reduce_res_323087 =
            &defunc_2_reduce_res_323087;
        futhark_mc_task_338122.retval_defunc_2_reduce_res_323088 =
            &defunc_2_reduce_res_323088;
        futhark_mc_task_338122.retval_mem_323084 = mem_323084;
        futhark_mc_task_338122.retval_mem_323085 = mem_323085;
        
        struct scheduler_segop futhark_mc_task_338122_task;
        
        futhark_mc_task_338122_task.args = &futhark_mc_task_338122;
        futhark_mc_task_338122_task.top_level_fn =
            futhark_mc_segred_task_338123;
        futhark_mc_task_338122_task.name = "futhark_mc_segred_task_338123";
        futhark_mc_task_338122_task.iterations = q_s_292678;
        futhark_mc_task_338122_task.task_time =
            &ctx->futhark_mc_segred_task_338123_total_time;
        futhark_mc_task_338122_task.task_iter =
            &ctx->futhark_mc_segred_task_338123_total_iter;
        futhark_mc_task_338122_task.sched = STATIC;
        futhark_mc_task_338122_task.nested_fn = NULL;
        
        int futhark_mc_segred_task_338123_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_338122_task);
        
        if (futhark_mc_segred_task_338123_err != 0) {
            ;
            err = futhark_mc_segred_task_338123_err;
            goto cleanup;
        }
        
        double a_323122 = 2.220446049250313e-16 + defunc_2_reduce_res_323086;
        double b_323123 = 2.220446049250313e-16 + defunc_2_reduce_res_323087;
        double c_323124 = 2.220446049250313e-16 + defunc_2_reduce_res_323088;
        double x_323125 = a_323122 * c_323124;
        double y_323126 = b_323123 * b_323123;
        double y_323127 = x_323125 - y_323126;
        double det1_323128 = 1.0 / y_323127;
        double a11_323129 = c_323124 * det1_323128;
        double x_323130 = 0.0 - b_323123;
        double b11_323131 = det1_323128 * x_323130;
        double c11_323132 = a_323122 * det1_323128;
        double defunc_2_reduce_res_323133;
        double defunc_2_reduce_res_323134;
        int64_t flat_tid_323354 = (int64_t) 0;
        int32_t num_tasks_323399;
        
        defunc_2_reduce_res_323133 = 0.0;
        defunc_2_reduce_res_323134 = 0.0;
        
        struct futhark_mc_task_338129 futhark_mc_task_338129;
        
        futhark_mc_task_338129.ctx = ctx;
        futhark_mc_task_338129.free_n_p_292677 = n_p_292677;
        futhark_mc_task_338129.free_defunc_0_f_res_292820 =
            defunc_0_f_res_292820;
        futhark_mc_task_338129.free_gtid_301175 = gtid_301175;
        futhark_mc_task_338129.free_mem_313366 = mem_313366.mem;
        futhark_mc_task_338129.free_gtid_322690 = gtid_322690;
        futhark_mc_task_338129.free_x_322691 = x_322691;
        futhark_mc_task_338129.free_x_323072 = x_323072;
        futhark_mc_task_338129.free_mem_323084 = mem_323084;
        futhark_mc_task_338129.free_mem_323085 = mem_323085;
        futhark_mc_task_338129.free_a11_323129 = a11_323129;
        futhark_mc_task_338129.free_b11_323131 = b11_323131;
        futhark_mc_task_338129.free_c11_323132 = c11_323132;
        futhark_mc_task_338129.retval_defunc_2_reduce_res_323133 =
            &defunc_2_reduce_res_323133;
        futhark_mc_task_338129.retval_defunc_2_reduce_res_323134 =
            &defunc_2_reduce_res_323134;
        
        struct scheduler_segop futhark_mc_task_338129_task;
        
        futhark_mc_task_338129_task.args = &futhark_mc_task_338129;
        futhark_mc_task_338129_task.top_level_fn =
            futhark_mc_segred_task_338130;
        futhark_mc_task_338129_task.name = "futhark_mc_segred_task_338130";
        futhark_mc_task_338129_task.iterations = q_s_292678;
        futhark_mc_task_338129_task.task_time =
            &ctx->futhark_mc_segred_task_338130_total_time;
        futhark_mc_task_338129_task.task_iter =
            &ctx->futhark_mc_segred_task_338130_total_iter;
        futhark_mc_task_338129_task.sched = STATIC;
        futhark_mc_task_338129_task.nested_fn = NULL;
        
        int futhark_mc_segred_task_338130_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_338129_task);
        
        if (futhark_mc_segred_task_338130_err != 0) {
            ;
            err = futhark_mc_segred_task_338130_err;
            goto cleanup;
        }
        ((double *) mem_322692.mem)[gtid_323071] = defunc_2_reduce_res_323133;
        ((double *) mem_322693.mem)[gtid_323071] = defunc_2_reduce_res_323134;
    }
    
  cleanup:
    { }
    free(mem_323084);
    free(mem_323085);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338119_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338119_end -
                 futhark_mc_segmap_parloop_338119_start;
        
        ctx->futhark_mc_segmap_parloop_338119_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338119_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338119_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_nested_task_338117(void *args, int64_t iterations,
                                         int tid, struct scheduler_info info)
{
    int err = 0;
    int flat_tid_323070 = tid;
    int num_tasks_323245 = info.nsubtasks;
    struct futhark_mc_task_338111 *futhark_mc_task_338111 =
                                  (struct futhark_mc_task_338111 *) args;
    struct futhark_context *ctx = futhark_mc_task_338111->ctx;
    uint64_t futhark_mc_segmap_nested_task_338117_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_nested_task_338117_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_338111->free_n_p_292677;
    int64_t q_s_292678 = futhark_mc_task_338111->free_q_s_292678;
    int64_t jump_s_292684 = futhark_mc_task_338111->free_jump_s_292684;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_338111->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_task_338111->free_pad_css_len_292821;
    int64_t s_n_m_292825 = futhark_mc_task_338111->free_s_n_m_292825;
    int64_t gtid_301175 = futhark_mc_task_338111->free_gtid_301175;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_task_338111->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_task_338111->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_task_338111->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_task_338111->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_task_338111->free_mem_313371,
                                  .size =0, .references =NULL};
    int64_t bytes_313879 = futhark_mc_task_338111->free_bytes_313879;
    int64_t gtid_322690 = futhark_mc_task_338111->free_gtid_322690;
    int64_t x_322691 = futhark_mc_task_338111->free_x_322691;
    struct memblock mem_322692 = {.desc ="mem_322692", .mem =
                                  futhark_mc_task_338111->free_mem_322692,
                                  .size =0, .references =NULL};
    struct memblock mem_322693 = {.desc ="mem_322693", .mem =
                                  futhark_mc_task_338111->free_mem_322693,
                                  .size =0, .references =NULL};
    int64_t iter_323314;
    struct futhark_mc_segmap_parloop_struct_338118
    futhark_mc_segmap_parloop_struct_338118;
    
    futhark_mc_segmap_parloop_struct_338118.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338118.free_n_p_292677 = n_p_292677;
    futhark_mc_segmap_parloop_struct_338118.free_q_s_292678 = q_s_292678;
    futhark_mc_segmap_parloop_struct_338118.free_jump_s_292684 = jump_s_292684;
    futhark_mc_segmap_parloop_struct_338118.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segmap_parloop_struct_338118.free_pad_css_len_292821 =
        pad_css_len_292821;
    futhark_mc_segmap_parloop_struct_338118.free_s_n_m_292825 = s_n_m_292825;
    futhark_mc_segmap_parloop_struct_338118.free_gtid_301175 = gtid_301175;
    futhark_mc_segmap_parloop_struct_338118.free_mem_312838 = mem_312838.mem;
    futhark_mc_segmap_parloop_struct_338118.free_mem_313018 = mem_313018.mem;
    futhark_mc_segmap_parloop_struct_338118.free_mem_313023 = mem_313023.mem;
    futhark_mc_segmap_parloop_struct_338118.free_mem_313366 = mem_313366.mem;
    futhark_mc_segmap_parloop_struct_338118.free_mem_313371 = mem_313371.mem;
    futhark_mc_segmap_parloop_struct_338118.free_bytes_313879 = bytes_313879;
    futhark_mc_segmap_parloop_struct_338118.free_gtid_322690 = gtid_322690;
    futhark_mc_segmap_parloop_struct_338118.free_x_322691 = x_322691;
    futhark_mc_segmap_parloop_struct_338118.free_mem_322692 = mem_322692.mem;
    futhark_mc_segmap_parloop_struct_338118.free_mem_322693 = mem_322693.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338119_task;
    
    futhark_mc_segmap_parloop_338119_task.name =
        "futhark_mc_segmap_parloop_338119";
    futhark_mc_segmap_parloop_338119_task.fn = futhark_mc_segmap_parloop_338119;
    futhark_mc_segmap_parloop_338119_task.args =
        &futhark_mc_segmap_parloop_struct_338118;
    futhark_mc_segmap_parloop_338119_task.iterations = iterations;
    futhark_mc_segmap_parloop_338119_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338119_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338119_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338119_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338119_task);
    
    if (futhark_mc_segmap_parloop_338119_err != 0) {
        err = futhark_mc_segmap_parloop_338119_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338119_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338119_total_end -
                 futhark_mc_segmap_parloop_338119_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338119_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338119_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338119_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_nested_task_338117_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_nested_task_338117_end -
                 futhark_mc_segmap_nested_task_338117_start;
        
        ctx->futhark_mc_segmap_nested_task_338117_runs[tid]++;
        ctx->futhark_mc_segmap_nested_task_338117_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_nested_task_338117_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
static int futhark_mc_segmap_parloop_338108(void *args, int64_t start,
                                            int64_t end, int flat_tid_322689,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338107
    *futhark_mc_segmap_parloop_struct_338107 =
    (struct futhark_mc_segmap_parloop_struct_338107 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338107->ctx;
    uint64_t futhark_mc_segmap_parloop_338108_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338108_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segmap_parloop_struct_338107->free_n_p_292677;
    int64_t q_s_292678 =
            futhark_mc_segmap_parloop_struct_338107->free_q_s_292678;
    int64_t jump_s_292684 =
            futhark_mc_segmap_parloop_struct_338107->free_jump_s_292684;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segmap_parloop_struct_338107->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_segmap_parloop_struct_338107->free_pad_css_len_292821;
    int64_t s_n_m_292825 =
            futhark_mc_segmap_parloop_struct_338107->free_s_n_m_292825;
    int64_t gtid_301175 =
            futhark_mc_segmap_parloop_struct_338107->free_gtid_301175;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_segmap_parloop_struct_338107->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_312842 = {.desc ="mem_312842", .mem =
                                  futhark_mc_segmap_parloop_struct_338107->free_mem_312842,
                                  .size =0, .references =NULL};
    int64_t bytes_312847 =
            futhark_mc_segmap_parloop_struct_338107->free_bytes_312847;
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_segmap_parloop_struct_338107->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_segmap_parloop_struct_338107->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_segmap_parloop_struct_338107->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_segmap_parloop_struct_338107->free_mem_313371,
                                  .size =0, .references =NULL};
    int64_t bytes_313879 =
            futhark_mc_segmap_parloop_struct_338107->free_bytes_313879;
    struct memblock mem_313983 = {.desc ="mem_313983", .mem =
                                  futhark_mc_segmap_parloop_struct_338107->free_mem_313983,
                                  .size =0, .references =NULL};
    struct memblock mem_313987 = {.desc ="mem_313987", .mem =
                                  futhark_mc_segmap_parloop_struct_338107->free_mem_313987,
                                  .size =0, .references =NULL};
    size_t mem_322692_cached_sizze_338109 = 0;
    unsigned char *mem_322692 = NULL;
    size_t mem_322693_cached_sizze_338110 = 0;
    unsigned char *mem_322693 = NULL;
    int64_t iterations = end - start;
    int64_t iter_323069 = start;
    
    if (mem_322692_cached_sizze_338109 < (size_t) bytes_312847) {
        mem_322692 = realloc(mem_322692, bytes_312847);
        mem_322692_cached_sizze_338109 = bytes_312847;
    }
    if (mem_322693_cached_sizze_338110 < (size_t) bytes_312847) {
        mem_322693 = realloc(mem_322693, bytes_312847);
        mem_322693_cached_sizze_338110 = bytes_312847;
    }
    for (; iter_323069 < end; iter_323069++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_323243 = n_p_292677;
        int64_t gtid_322690 = iter_323069;
        int64_t remnant_323244 = iter_323069 - gtid_322690;
        int64_t x_322691;
        
        x_322691 = ((int64_t *) mem_312842.mem)[gtid_301175 * n_p_292677 +
                                                gtid_322690];
        
        int64_t flat_tid_323157 = (int64_t) 0;
        int32_t num_tasks_323245;
        int64_t flat_tid_323070 = (int64_t) 0;
        struct futhark_mc_task_338111 futhark_mc_task_338111;
        
        futhark_mc_task_338111.ctx = ctx;
        futhark_mc_task_338111.free_n_p_292677 = n_p_292677;
        futhark_mc_task_338111.free_q_s_292678 = q_s_292678;
        futhark_mc_task_338111.free_jump_s_292684 = jump_s_292684;
        futhark_mc_task_338111.free_defunc_0_f_res_292820 =
            defunc_0_f_res_292820;
        futhark_mc_task_338111.free_pad_css_len_292821 = pad_css_len_292821;
        futhark_mc_task_338111.free_s_n_m_292825 = s_n_m_292825;
        futhark_mc_task_338111.free_gtid_301175 = gtid_301175;
        futhark_mc_task_338111.free_mem_312838 = mem_312838.mem;
        futhark_mc_task_338111.free_mem_313018 = mem_313018.mem;
        futhark_mc_task_338111.free_mem_313023 = mem_313023.mem;
        futhark_mc_task_338111.free_mem_313366 = mem_313366.mem;
        futhark_mc_task_338111.free_mem_313371 = mem_313371.mem;
        futhark_mc_task_338111.free_bytes_313879 = bytes_313879;
        futhark_mc_task_338111.free_gtid_322690 = gtid_322690;
        futhark_mc_task_338111.free_x_322691 = x_322691;
        futhark_mc_task_338111.free_mem_322692 = mem_322692;
        futhark_mc_task_338111.free_mem_322693 = mem_322693;
        
        struct scheduler_segop futhark_mc_task_338111_task;
        
        futhark_mc_task_338111_task.args = &futhark_mc_task_338111;
        futhark_mc_task_338111_task.top_level_fn =
            futhark_mc_segmap_task_338112;
        futhark_mc_task_338111_task.name = "futhark_mc_segmap_task_338112";
        futhark_mc_task_338111_task.iterations = s_n_m_292825;
        futhark_mc_task_338111_task.task_time =
            &ctx->futhark_mc_segmap_task_338112_total_time;
        futhark_mc_task_338111_task.task_iter =
            &ctx->futhark_mc_segmap_task_338112_total_iter;
        futhark_mc_task_338111_task.sched = STATIC;
        futhark_mc_task_338111_task.nested_fn =
            futhark_mc_segmap_nested_task_338117;
        
        int futhark_mc_segmap_task_338112_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_338111_task);
        
        if (futhark_mc_segmap_task_338112_err != 0) {
            ;
            err = futhark_mc_segmap_task_338112_err;
            goto cleanup;
        }
        if (s_n_m_292825 * (int64_t) 8 > 0)
            memmove(mem_313983.mem + gtid_322690 * s_n_m_292825 * (int64_t) 8,
                    mem_322692 + (int64_t) 0, s_n_m_292825 * (int64_t) 8);
        if (s_n_m_292825 * (int64_t) 8 > 0)
            memmove(mem_313987.mem + gtid_322690 * s_n_m_292825 * (int64_t) 8,
                    mem_322693 + (int64_t) 0, s_n_m_292825 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_322692);
    free(mem_322693);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338108_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338108_end -
                 futhark_mc_segmap_parloop_338108_start;
        
        ctx->futhark_mc_segmap_parloop_338108_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338108_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338108_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_nested_task_338106(void *args, int64_t iterations,
                                         int tid, struct scheduler_info info)
{
    int err = 0;
    int flat_tid_322689 = tid;
    int num_tasks_322969 = info.nsubtasks;
    struct futhark_mc_task_338098 *futhark_mc_task_338098 =
                                  (struct futhark_mc_task_338098 *) args;
    struct futhark_context *ctx = futhark_mc_task_338098->ctx;
    uint64_t futhark_mc_segmap_nested_task_338106_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_nested_task_338106_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_338098->free_n_p_292677;
    int64_t q_s_292678 = futhark_mc_task_338098->free_q_s_292678;
    int64_t jump_s_292684 = futhark_mc_task_338098->free_jump_s_292684;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_338098->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_task_338098->free_pad_css_len_292821;
    int64_t s_n_m_292825 = futhark_mc_task_338098->free_s_n_m_292825;
    int64_t gtid_301175 = futhark_mc_task_338098->free_gtid_301175;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_task_338098->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_312842 = {.desc ="mem_312842", .mem =
                                  futhark_mc_task_338098->free_mem_312842,
                                  .size =0, .references =NULL};
    int64_t bytes_312847 = futhark_mc_task_338098->free_bytes_312847;
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_task_338098->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_task_338098->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_task_338098->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_task_338098->free_mem_313371,
                                  .size =0, .references =NULL};
    int64_t bytes_313879 = futhark_mc_task_338098->free_bytes_313879;
    struct memblock mem_313983 = {.desc ="mem_313983", .mem =
                                  futhark_mc_task_338098->free_mem_313983,
                                  .size =0, .references =NULL};
    struct memblock mem_313987 = {.desc ="mem_313987", .mem =
                                  futhark_mc_task_338098->free_mem_313987,
                                  .size =0, .references =NULL};
    int64_t iter_323069;
    struct futhark_mc_segmap_parloop_struct_338107
    futhark_mc_segmap_parloop_struct_338107;
    
    futhark_mc_segmap_parloop_struct_338107.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338107.free_n_p_292677 = n_p_292677;
    futhark_mc_segmap_parloop_struct_338107.free_q_s_292678 = q_s_292678;
    futhark_mc_segmap_parloop_struct_338107.free_jump_s_292684 = jump_s_292684;
    futhark_mc_segmap_parloop_struct_338107.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segmap_parloop_struct_338107.free_pad_css_len_292821 =
        pad_css_len_292821;
    futhark_mc_segmap_parloop_struct_338107.free_s_n_m_292825 = s_n_m_292825;
    futhark_mc_segmap_parloop_struct_338107.free_gtid_301175 = gtid_301175;
    futhark_mc_segmap_parloop_struct_338107.free_mem_312838 = mem_312838.mem;
    futhark_mc_segmap_parloop_struct_338107.free_mem_312842 = mem_312842.mem;
    futhark_mc_segmap_parloop_struct_338107.free_bytes_312847 = bytes_312847;
    futhark_mc_segmap_parloop_struct_338107.free_mem_313018 = mem_313018.mem;
    futhark_mc_segmap_parloop_struct_338107.free_mem_313023 = mem_313023.mem;
    futhark_mc_segmap_parloop_struct_338107.free_mem_313366 = mem_313366.mem;
    futhark_mc_segmap_parloop_struct_338107.free_mem_313371 = mem_313371.mem;
    futhark_mc_segmap_parloop_struct_338107.free_bytes_313879 = bytes_313879;
    futhark_mc_segmap_parloop_struct_338107.free_mem_313983 = mem_313983.mem;
    futhark_mc_segmap_parloop_struct_338107.free_mem_313987 = mem_313987.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338108_task;
    
    futhark_mc_segmap_parloop_338108_task.name =
        "futhark_mc_segmap_parloop_338108";
    futhark_mc_segmap_parloop_338108_task.fn = futhark_mc_segmap_parloop_338108;
    futhark_mc_segmap_parloop_338108_task.args =
        &futhark_mc_segmap_parloop_struct_338107;
    futhark_mc_segmap_parloop_338108_task.iterations = iterations;
    futhark_mc_segmap_parloop_338108_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338108_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338108_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338108_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338108_task);
    
    if (futhark_mc_segmap_parloop_338108_err != 0) {
        err = futhark_mc_segmap_parloop_338108_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338108_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338108_total_end -
                 futhark_mc_segmap_parloop_338108_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338108_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338108_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338108_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_nested_task_338106_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_nested_task_338106_end -
                 futhark_mc_segmap_nested_task_338106_start;
        
        ctx->futhark_mc_segmap_nested_task_338106_runs[tid]++;
        ctx->futhark_mc_segmap_nested_task_338106_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_nested_task_338106_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
static int futhark_mc_segmap_parloop_338095(void *args, int64_t start,
                                            int64_t end, int flat_tid_301174,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338094
    *futhark_mc_segmap_parloop_struct_338094 =
    (struct futhark_mc_segmap_parloop_struct_338094 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338094->ctx;
    uint64_t futhark_mc_segmap_parloop_338095_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338095_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segmap_parloop_struct_338094->free_n_p_292677;
    int64_t q_s_292678 =
            futhark_mc_segmap_parloop_struct_338094->free_q_s_292678;
    int64_t jump_s_292684 =
            futhark_mc_segmap_parloop_struct_338094->free_jump_s_292684;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_338094->free_partition_sizze_292766;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segmap_parloop_struct_338094->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_segmap_parloop_struct_338094->free_pad_css_len_292821;
    int64_t s_n_m_292825 =
            futhark_mc_segmap_parloop_struct_338094->free_s_n_m_292825;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_segmap_parloop_struct_338094->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_312842 = {.desc ="mem_312842", .mem =
                                  futhark_mc_segmap_parloop_struct_338094->free_mem_312842,
                                  .size =0, .references =NULL};
    int64_t bytes_312847 =
            futhark_mc_segmap_parloop_struct_338094->free_bytes_312847;
    int64_t bytes_312899 =
            futhark_mc_segmap_parloop_struct_338094->free_bytes_312899;
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_segmap_parloop_struct_338094->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_segmap_parloop_struct_338094->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_segmap_parloop_struct_338094->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_segmap_parloop_struct_338094->free_mem_313371,
                                  .size =0, .references =NULL};
    int64_t bytes_313879 =
            futhark_mc_segmap_parloop_struct_338094->free_bytes_313879;
    struct memblock mem_314116 = {.desc ="mem_314116", .mem =
                                  futhark_mc_segmap_parloop_struct_338094->free_mem_314116,
                                  .size =0, .references =NULL};
    struct memblock mem_314121 = {.desc ="mem_314121", .mem =
                                  futhark_mc_segmap_parloop_struct_338094->free_mem_314121,
                                  .size =0, .references =NULL};
    size_t mem_313983_cached_sizze_338096 = 0;
    unsigned char *mem_313983 = NULL;
    size_t mem_313987_cached_sizze_338097 = 0;
    unsigned char *mem_313987 = NULL;
    int64_t iterations = end - start;
    int64_t iter_322688 = start;
    
    if (mem_313983_cached_sizze_338096 < (size_t) bytes_312899) {
        mem_313983 = realloc(mem_313983, bytes_312899);
        mem_313983_cached_sizze_338096 = bytes_312899;
    }
    if (mem_313987_cached_sizze_338097 < (size_t) bytes_312899) {
        mem_313987 = realloc(mem_313987, bytes_312899);
        mem_313987_cached_sizze_338097 = bytes_312899;
    }
    for (; iter_322688 < end; iter_322688++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_322967 = partition_sizze_292766;
        int64_t gtid_301175 = iter_322688;
        int64_t remnant_322968 = iter_322688 - gtid_301175;
        int64_t flat_tid_322869 = (int64_t) 0;
        int32_t num_tasks_322969;
        int64_t flat_tid_322689 = (int64_t) 0;
        struct futhark_mc_task_338098 futhark_mc_task_338098;
        
        futhark_mc_task_338098.ctx = ctx;
        futhark_mc_task_338098.free_n_p_292677 = n_p_292677;
        futhark_mc_task_338098.free_q_s_292678 = q_s_292678;
        futhark_mc_task_338098.free_jump_s_292684 = jump_s_292684;
        futhark_mc_task_338098.free_defunc_0_f_res_292820 =
            defunc_0_f_res_292820;
        futhark_mc_task_338098.free_pad_css_len_292821 = pad_css_len_292821;
        futhark_mc_task_338098.free_s_n_m_292825 = s_n_m_292825;
        futhark_mc_task_338098.free_gtid_301175 = gtid_301175;
        futhark_mc_task_338098.free_mem_312838 = mem_312838.mem;
        futhark_mc_task_338098.free_mem_312842 = mem_312842.mem;
        futhark_mc_task_338098.free_bytes_312847 = bytes_312847;
        futhark_mc_task_338098.free_mem_313018 = mem_313018.mem;
        futhark_mc_task_338098.free_mem_313023 = mem_313023.mem;
        futhark_mc_task_338098.free_mem_313366 = mem_313366.mem;
        futhark_mc_task_338098.free_mem_313371 = mem_313371.mem;
        futhark_mc_task_338098.free_bytes_313879 = bytes_313879;
        futhark_mc_task_338098.free_mem_313983 = mem_313983;
        futhark_mc_task_338098.free_mem_313987 = mem_313987;
        
        struct scheduler_segop futhark_mc_task_338098_task;
        
        futhark_mc_task_338098_task.args = &futhark_mc_task_338098;
        futhark_mc_task_338098_task.top_level_fn =
            futhark_mc_segmap_task_338099;
        futhark_mc_task_338098_task.name = "futhark_mc_segmap_task_338099";
        futhark_mc_task_338098_task.iterations = n_p_292677;
        futhark_mc_task_338098_task.task_time =
            &ctx->futhark_mc_segmap_task_338099_total_time;
        futhark_mc_task_338098_task.task_iter =
            &ctx->futhark_mc_segmap_task_338099_total_iter;
        futhark_mc_task_338098_task.sched = STATIC;
        futhark_mc_task_338098_task.nested_fn =
            futhark_mc_segmap_nested_task_338106;
        
        int futhark_mc_segmap_task_338099_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_338098_task);
        
        if (futhark_mc_segmap_task_338099_err != 0) {
            ;
            err = futhark_mc_segmap_task_338099_err;
            goto cleanup;
        }
        if (n_p_292677 * s_n_m_292825 * (int64_t) 8 > 0)
            memmove(mem_314116.mem + gtid_301175 * (s_n_m_292825 * n_p_292677) *
                    (int64_t) 8, mem_313983 + (int64_t) 0, n_p_292677 *
                    s_n_m_292825 * (int64_t) 8);
        if (n_p_292677 * s_n_m_292825 * (int64_t) 8 > 0)
            memmove(mem_314121.mem + gtid_301175 * (s_n_m_292825 * n_p_292677) *
                    (int64_t) 8, mem_313987 + (int64_t) 0, n_p_292677 *
                    s_n_m_292825 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_313983);
    free(mem_313987);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338095_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338095_end -
                 futhark_mc_segmap_parloop_338095_start;
        
        ctx->futhark_mc_segmap_parloop_338095_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338095_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338095_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_nested_task_338093(void *args, int64_t iterations,
                                         int tid, struct scheduler_info info)
{
    int err = 0;
    int flat_tid_301174 = tid;
    int num_tasks_322580 = info.nsubtasks;
    struct futhark_mc_task_338085 *futhark_mc_task_338085 =
                                  (struct futhark_mc_task_338085 *) args;
    struct futhark_context *ctx = futhark_mc_task_338085->ctx;
    uint64_t futhark_mc_segmap_nested_task_338093_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_nested_task_338093_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_338085->free_n_p_292677;
    int64_t q_s_292678 = futhark_mc_task_338085->free_q_s_292678;
    int64_t jump_s_292684 = futhark_mc_task_338085->free_jump_s_292684;
    int64_t partition_sizze_292766 =
            futhark_mc_task_338085->free_partition_sizze_292766;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_338085->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_task_338085->free_pad_css_len_292821;
    int64_t s_n_m_292825 = futhark_mc_task_338085->free_s_n_m_292825;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_task_338085->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_312842 = {.desc ="mem_312842", .mem =
                                  futhark_mc_task_338085->free_mem_312842,
                                  .size =0, .references =NULL};
    int64_t bytes_312847 = futhark_mc_task_338085->free_bytes_312847;
    int64_t bytes_312899 = futhark_mc_task_338085->free_bytes_312899;
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_task_338085->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_task_338085->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_task_338085->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_task_338085->free_mem_313371,
                                  .size =0, .references =NULL};
    int64_t bytes_313879 = futhark_mc_task_338085->free_bytes_313879;
    struct memblock mem_314116 = {.desc ="mem_314116", .mem =
                                  futhark_mc_task_338085->free_mem_314116,
                                  .size =0, .references =NULL};
    struct memblock mem_314121 = {.desc ="mem_314121", .mem =
                                  futhark_mc_task_338085->free_mem_314121,
                                  .size =0, .references =NULL};
    int64_t iter_322688;
    struct futhark_mc_segmap_parloop_struct_338094
    futhark_mc_segmap_parloop_struct_338094;
    
    futhark_mc_segmap_parloop_struct_338094.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338094.free_n_p_292677 = n_p_292677;
    futhark_mc_segmap_parloop_struct_338094.free_q_s_292678 = q_s_292678;
    futhark_mc_segmap_parloop_struct_338094.free_jump_s_292684 = jump_s_292684;
    futhark_mc_segmap_parloop_struct_338094.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_338094.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segmap_parloop_struct_338094.free_pad_css_len_292821 =
        pad_css_len_292821;
    futhark_mc_segmap_parloop_struct_338094.free_s_n_m_292825 = s_n_m_292825;
    futhark_mc_segmap_parloop_struct_338094.free_mem_312838 = mem_312838.mem;
    futhark_mc_segmap_parloop_struct_338094.free_mem_312842 = mem_312842.mem;
    futhark_mc_segmap_parloop_struct_338094.free_bytes_312847 = bytes_312847;
    futhark_mc_segmap_parloop_struct_338094.free_bytes_312899 = bytes_312899;
    futhark_mc_segmap_parloop_struct_338094.free_mem_313018 = mem_313018.mem;
    futhark_mc_segmap_parloop_struct_338094.free_mem_313023 = mem_313023.mem;
    futhark_mc_segmap_parloop_struct_338094.free_mem_313366 = mem_313366.mem;
    futhark_mc_segmap_parloop_struct_338094.free_mem_313371 = mem_313371.mem;
    futhark_mc_segmap_parloop_struct_338094.free_bytes_313879 = bytes_313879;
    futhark_mc_segmap_parloop_struct_338094.free_mem_314116 = mem_314116.mem;
    futhark_mc_segmap_parloop_struct_338094.free_mem_314121 = mem_314121.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338095_task;
    
    futhark_mc_segmap_parloop_338095_task.name =
        "futhark_mc_segmap_parloop_338095";
    futhark_mc_segmap_parloop_338095_task.fn = futhark_mc_segmap_parloop_338095;
    futhark_mc_segmap_parloop_338095_task.args =
        &futhark_mc_segmap_parloop_struct_338094;
    futhark_mc_segmap_parloop_338095_task.iterations = iterations;
    futhark_mc_segmap_parloop_338095_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338095_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338095_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338095_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338095_task);
    
    if (futhark_mc_segmap_parloop_338095_err != 0) {
        err = futhark_mc_segmap_parloop_338095_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338095_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338095_total_end -
                 futhark_mc_segmap_parloop_338095_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338095_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338095_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338095_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_nested_task_338093_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_nested_task_338093_end -
                 futhark_mc_segmap_nested_task_338093_start;
        
        ctx->futhark_mc_segmap_nested_task_338093_runs[tid]++;
        ctx->futhark_mc_segmap_nested_task_338093_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_nested_task_338093_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_task_338135 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_q_s_292678;
    int64_t free_jump_s_292684;
    int64_t free_partition_sizze_292766;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_312842;
    int64_t free_bytes_312847;
    int64_t free_bytes_312899;
    unsigned char *free_mem_313018;
    unsigned char *free_mem_313023;
    unsigned char *free_mem_313366;
    unsigned char *free_mem_313371;
    int64_t free_bytes_314123;
    unsigned char *free_mem_314456;
    unsigned char *free_mem_314461;
};
struct futhark_mc_segmap_parloop_struct_338137 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_q_s_292678;
    int64_t free_jump_s_292684;
    int64_t free_partition_sizze_292766;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_312842;
    int64_t free_bytes_312899;
    unsigned char *free_mem_313018;
    unsigned char *free_mem_313023;
    unsigned char *free_mem_313366;
    unsigned char *free_mem_313371;
    int64_t free_bytes_314123;
    unsigned char *free_mem_314456;
    unsigned char *free_mem_314461;
};
static int futhark_mc_segmap_parloop_338138(void *args, int64_t start,
                                            int64_t end, int flat_tid_301458,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338137
    *futhark_mc_segmap_parloop_struct_338137 =
    (struct futhark_mc_segmap_parloop_struct_338137 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338137->ctx;
    uint64_t futhark_mc_segmap_parloop_338138_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338138_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segmap_parloop_struct_338137->free_n_p_292677;
    int64_t q_s_292678 =
            futhark_mc_segmap_parloop_struct_338137->free_q_s_292678;
    int64_t jump_s_292684 =
            futhark_mc_segmap_parloop_struct_338137->free_jump_s_292684;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_338137->free_partition_sizze_292766;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segmap_parloop_struct_338137->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_segmap_parloop_struct_338137->free_pad_css_len_292821;
    int64_t s_n_m_292825 =
            futhark_mc_segmap_parloop_struct_338137->free_s_n_m_292825;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_segmap_parloop_struct_338137->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_312842 = {.desc ="mem_312842", .mem =
                                  futhark_mc_segmap_parloop_struct_338137->free_mem_312842,
                                  .size =0, .references =NULL};
    int64_t bytes_312899 =
            futhark_mc_segmap_parloop_struct_338137->free_bytes_312899;
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_segmap_parloop_struct_338137->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_segmap_parloop_struct_338137->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_segmap_parloop_struct_338137->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_segmap_parloop_struct_338137->free_mem_313371,
                                  .size =0, .references =NULL};
    int64_t bytes_314123 =
            futhark_mc_segmap_parloop_struct_338137->free_bytes_314123;
    struct memblock mem_314456 = {.desc ="mem_314456", .mem =
                                  futhark_mc_segmap_parloop_struct_338137->free_mem_314456,
                                  .size =0, .references =NULL};
    struct memblock mem_314461 = {.desc ="mem_314461", .mem =
                                  futhark_mc_segmap_parloop_struct_338137->free_mem_314461,
                                  .size =0, .references =NULL};
    size_t mem_314301_cached_sizze_338139 = 0;
    unsigned char *mem_314301 = NULL;
    size_t mem_314305_cached_sizze_338140 = 0;
    unsigned char *mem_314305 = NULL;
    size_t mem_314350_cached_sizze_338141 = 0;
    unsigned char *mem_314350 = NULL;
    size_t mem_314353_cached_sizze_338142 = 0;
    unsigned char *mem_314353 = NULL;
    size_t mem_314380_cached_sizze_338143 = 0;
    unsigned char *mem_314380 = NULL;
    size_t mem_314383_cached_sizze_338144 = 0;
    unsigned char *mem_314383 = NULL;
    int64_t iterations = end - start;
    int64_t iter_323415 = start;
    
    if (mem_314301_cached_sizze_338139 < (size_t) bytes_312899) {
        mem_314301 = realloc(mem_314301, bytes_312899);
        mem_314301_cached_sizze_338139 = bytes_312899;
    }
    if (mem_314305_cached_sizze_338140 < (size_t) bytes_312899) {
        mem_314305 = realloc(mem_314305, bytes_312899);
        mem_314305_cached_sizze_338140 = bytes_312899;
    }
    if (mem_314350_cached_sizze_338141 < (size_t) bytes_314123) {
        mem_314350 = realloc(mem_314350, bytes_314123);
        mem_314350_cached_sizze_338141 = bytes_314123;
    }
    if (mem_314353_cached_sizze_338142 < (size_t) bytes_314123) {
        mem_314353 = realloc(mem_314353, bytes_314123);
        mem_314353_cached_sizze_338142 = bytes_314123;
    }
    if (mem_314380_cached_sizze_338143 < (size_t) bytes_314123) {
        mem_314380 = realloc(mem_314380, bytes_314123);
        mem_314380_cached_sizze_338143 = bytes_314123;
    }
    if (mem_314383_cached_sizze_338144 < (size_t) bytes_314123) {
        mem_314383 = realloc(mem_314383, bytes_314123);
        mem_314383_cached_sizze_338144 = bytes_314123;
    }
    for (; iter_323415 < end; iter_323415++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_323552 = partition_sizze_292766;
        int64_t gtid_301459 = iter_323415;
        int64_t remnant_323553 = iter_323415 - gtid_301459;
        
        for (int64_t i_323416 = 0; i_323416 < n_p_292677; i_323416++) {
            int64_t x_323419;
            
            x_323419 = ((int64_t *) mem_312842.mem)[gtid_301459 * n_p_292677 +
                                                    i_323416];
            for (int64_t i_323422 = 0; i_323422 < s_n_m_292825; i_323422++) {
                int64_t x_323425;
                
                x_323425 = ((int64_t *) mem_313018.mem)[gtid_301459 *
                                                        (s_n_m_292825 *
                                                         n_p_292677) +
                                                        i_323416 *
                                                        s_n_m_292825 +
                                                        i_323422];
                
                double x_323426;
                
                x_323426 = ((double *) mem_313023.mem)[gtid_301459 *
                                                       (s_n_m_292825 *
                                                        n_p_292677) + i_323416 *
                                                       s_n_m_292825 + i_323422];
                
                bool cond_323427 = i_323422 == (int64_t) 0;
                int64_t defunc_0_m_fun_res_323428;
                
                if (cond_323427) {
                    defunc_0_m_fun_res_323428 = (int64_t) 0;
                } else {
                    int64_t y_323429 = sub64(s_n_m_292825, (int64_t) 1);
                    bool cond_323430 = i_323422 == y_323429;
                    int64_t defunc_0_m_fun_res_f_res_323431;
                    
                    if (cond_323430) {
                        int64_t defunc_0_m_fun_res_f_res_t_res_323432 =
                                sub64(pad_css_len_292821, (int64_t) 1);
                        
                        defunc_0_m_fun_res_f_res_323431 =
                            defunc_0_m_fun_res_f_res_t_res_323432;
                    } else {
                        int64_t x_323433 = sub64(i_323422, (int64_t) 1);
                        int64_t x_323434 = mul64(jump_s_292684, x_323433);
                        int64_t min_arg_323435 = add64((int64_t) 1, x_323434);
                        int64_t min_res_323436 = smin64(defunc_0_f_res_292820,
                                                        min_arg_323435);
                        
                        defunc_0_m_fun_res_f_res_323431 = min_res_323436;
                    }
                    defunc_0_m_fun_res_323428 = defunc_0_m_fun_res_f_res_323431;
                }
                for (int64_t i_323441 = 0; i_323441 < q_s_292678; i_323441++) {
                    bool cond_323444 = sle64(x_323419, i_323441);
                    int64_t defunc_0_f_res_323445;
                    
                    if (cond_323444) {
                        defunc_0_f_res_323445 = (int64_t) 0;
                    } else {
                        int64_t i_323446 = add64(x_323425, i_323441);
                        int64_t defunc_0_add_arg_323447;
                        
                        defunc_0_add_arg_323447 =
                            ((int64_t *) mem_312838.mem)[gtid_301459 *
                                                         (defunc_0_f_res_292820 *
                                                          n_p_292677) +
                                                         i_323416 *
                                                         defunc_0_f_res_292820 +
                                                         i_323446];
                        
                        int64_t defunc_1_add_res_323448 = add64((int64_t) 1,
                                                                defunc_0_add_arg_323447);
                        
                        defunc_0_f_res_323445 = defunc_1_add_res_323448;
                    }
                    
                    double defunc_0_f_res_323449;
                    
                    if (cond_323444) {
                        defunc_0_f_res_323449 = 0.0;
                    } else {
                        int64_t i_323450 = add64(x_323425, i_323441);
                        double defunc_0_add_arg_323451;
                        
                        defunc_0_add_arg_323451 =
                            ((double *) mem_313371.mem)[gtid_301459 *
                                                        (defunc_0_f_res_292820 *
                                                         n_p_292677) +
                                                        i_323416 *
                                                        defunc_0_f_res_292820 +
                                                        i_323450];
                        defunc_0_f_res_323449 = defunc_0_add_arg_323451;
                    }
                    
                    int64_t binop_p_323452 = sub64(defunc_0_f_res_323445,
                                                   defunc_0_m_fun_res_323428);
                    double defunc_0_f_res_323453 =
                           sitofp_i64_f64(binop_p_323452);
                    double abs_res_323454 = fabs(defunc_0_f_res_323453);
                    double tmp1_323455 = abs_res_323454 / x_323426;
                    double x_323456 = tmp1_323455 * tmp1_323455;
                    double y_323457 = tmp1_323455 * x_323456;
                    double tmp2_323458 = 1.0 - y_323457;
                    double x_323459 = tmp2_323458 * tmp2_323458;
                    double tmp3_323460 = tmp2_323458 * x_323459;
                    double tmp4_323461 = defunc_0_f_res_323449 * tmp3_323460;
                    
                    ((double *) mem_314350)[i_323441] = defunc_0_f_res_323453;
                    ((double *) mem_314353)[i_323441] = tmp4_323461;
                }
                
                double defunc_2_reduce_res_323466;
                double defunc_2_reduce_res_323467;
                double defunc_2_reduce_res_323468;
                double defunc_2_reduce_res_323469;
                double defunc_2_reduce_res_323470;
                double redout_323474;
                double redout_323475;
                double redout_323476;
                double redout_323477;
                double redout_323478;
                
                redout_323474 = 0.0;
                redout_323475 = 0.0;
                redout_323476 = 0.0;
                redout_323477 = 0.0;
                redout_323478 = 0.0;
                for (int64_t i_323473 = 0; i_323473 < q_s_292678; i_323473++) {
                    double x_323481;
                    
                    x_323481 = ((double *) mem_314350)[i_323473];
                    
                    double x_323482;
                    
                    x_323482 = ((double *) mem_314353)[i_323473];
                    
                    double defunc_1_f_res_323483 = x_323481 * x_323482;
                    double defunc_1_f_res_323484 = x_323481 *
                           defunc_1_f_res_323483;
                    double defunc_1_f_res_323485 = x_323481 *
                           defunc_1_f_res_323484;
                    double defunc_1_f_res_323486 = x_323481 *
                           defunc_1_f_res_323485;
                    double defunc_1_op_res_323487 = x_323482 + redout_323474;
                    double defunc_1_op_res_323488 = defunc_1_f_res_323483 +
                           redout_323475;
                    double defunc_1_op_res_323489 = defunc_1_f_res_323484 +
                           redout_323476;
                    double defunc_1_op_res_323490 = defunc_1_f_res_323485 +
                           redout_323477;
                    double defunc_1_op_res_323491 = defunc_1_f_res_323486 +
                           redout_323478;
                    
                    ((double *) mem_314380)[i_323473] = defunc_1_f_res_323484;
                    ((double *) mem_314383)[i_323473] = defunc_1_f_res_323483;
                    
                    double redout_tmp_323560 = defunc_1_op_res_323487;
                    double redout_tmp_323561 = defunc_1_op_res_323488;
                    double redout_tmp_323562 = defunc_1_op_res_323489;
                    double redout_tmp_323563 = defunc_1_op_res_323490;
                    double redout_tmp_323564 = defunc_1_op_res_323491;
                    
                    redout_323474 = redout_tmp_323560;
                    redout_323475 = redout_tmp_323561;
                    redout_323476 = redout_tmp_323562;
                    redout_323477 = redout_tmp_323563;
                    redout_323478 = redout_tmp_323564;
                }
                defunc_2_reduce_res_323466 = redout_323474;
                defunc_2_reduce_res_323467 = redout_323475;
                defunc_2_reduce_res_323468 = redout_323476;
                defunc_2_reduce_res_323469 = redout_323477;
                defunc_2_reduce_res_323470 = redout_323478;
                
                double a_323494 = 2.220446049250313e-16 +
                       defunc_2_reduce_res_323466;
                double b_323495 = 2.220446049250313e-16 +
                       defunc_2_reduce_res_323467;
                double c_323496 = 2.220446049250313e-16 +
                       defunc_2_reduce_res_323468;
                double d_323497 = 2.220446049250313e-16 +
                       defunc_2_reduce_res_323469;
                double e_323498 = 2.220446049250313e-16 +
                       defunc_2_reduce_res_323470;
                double x_323499 = c_323496 * e_323498;
                double y_323500 = d_323497 * d_323497;
                double a12_323501 = x_323499 - y_323500;
                double x_323502 = c_323496 * d_323497;
                double y_323503 = b_323495 * e_323498;
                double b12_323504 = x_323502 - y_323503;
                double x_323505 = b_323495 * d_323497;
                double y_323506 = c_323496 * c_323496;
                double c12_323507 = x_323505 - y_323506;
                double x_323508 = a_323494 * e_323498;
                double b2_323509 = x_323508 - y_323506;
                double x_323510 = b_323495 * c_323496;
                double y_323511 = a_323494 * d_323497;
                double c2_323512 = x_323510 - y_323511;
                double x_323513 = a_323494 * a12_323501;
                double y_323514 = b_323495 * b12_323504;
                double x_323515 = x_323513 + y_323514;
                double y_323516 = c_323496 * c12_323507;
                double y_323517 = x_323515 + y_323516;
                double det_323518 = 1.0 / y_323517;
                double a12_323519 = a12_323501 * det_323518;
                double b12_323520 = b12_323504 * det_323518;
                double c12_323521 = c12_323507 * det_323518;
                double b2_323522 = b2_323509 * det_323518;
                double c2_323523 = c2_323512 * det_323518;
                double defunc_2_reduce_res_323524;
                double defunc_2_reduce_res_323525;
                double redout_323527;
                double redout_323528;
                
                redout_323527 = 0.0;
                redout_323528 = 0.0;
                for (int64_t i_323526 = 0; i_323526 < q_s_292678; i_323526++) {
                    double x_323529;
                    
                    x_323529 = ((double *) mem_314353)[i_323526];
                    
                    double x_323530;
                    
                    x_323530 = ((double *) mem_314383)[i_323526];
                    
                    double x_323531;
                    
                    x_323531 = ((double *) mem_314380)[i_323526];
                    
                    bool cond_323532 = sle64(x_323419, i_323526);
                    double defunc_0_f_res_323533;
                    
                    if (cond_323532) {
                        defunc_0_f_res_323533 = 0.0;
                    } else {
                        int64_t i_323534 = add64(x_323425, i_323526);
                        double defunc_0_add_arg_323535;
                        
                        defunc_0_add_arg_323535 =
                            ((double *) mem_313366.mem)[gtid_301459 *
                                                        (defunc_0_f_res_292820 *
                                                         n_p_292677) +
                                                        i_323416 *
                                                        defunc_0_f_res_292820 +
                                                        i_323534];
                        defunc_0_f_res_323533 = defunc_0_add_arg_323535;
                    }
                    
                    double x_323536 = a12_323519 * x_323529;
                    double y_323537 = b12_323520 * x_323530;
                    double x_323538 = x_323536 + y_323537;
                    double y_323539 = c12_323521 * x_323531;
                    double x_323540 = x_323538 + y_323539;
                    double defunc_9_fit_fun_res_323541 = defunc_0_f_res_323533 *
                           x_323540;
                    double x_323542 = b12_323520 * x_323529;
                    double y_323543 = b2_323522 * x_323530;
                    double x_323544 = x_323542 + y_323543;
                    double y_323545 = c2_323523 * x_323531;
                    double x_323546 = x_323544 + y_323545;
                    double defunc_9_slope_fun_res_323547 =
                           defunc_0_f_res_323533 * x_323546;
                    double defunc_1_op_res_323548 =
                           defunc_9_fit_fun_res_323541 + redout_323527;
                    double defunc_1_op_res_323549 =
                           defunc_9_slope_fun_res_323547 + redout_323528;
                    double redout_tmp_323567 = defunc_1_op_res_323548;
                    double redout_tmp_323568 = defunc_1_op_res_323549;
                    
                    redout_323527 = redout_tmp_323567;
                    redout_323528 = redout_tmp_323568;
                }
                defunc_2_reduce_res_323524 = redout_323527;
                defunc_2_reduce_res_323525 = redout_323528;
                ((double *) mem_314301)[i_323416 * s_n_m_292825 + i_323422] =
                    defunc_2_reduce_res_323524;
                ((double *) mem_314305)[i_323416 * s_n_m_292825 + i_323422] =
                    defunc_2_reduce_res_323525;
            }
        }
        if (n_p_292677 * s_n_m_292825 * (int64_t) 8 > 0)
            memmove(mem_314456.mem + gtid_301459 * (s_n_m_292825 * n_p_292677) *
                    (int64_t) 8, mem_314301 + (int64_t) 0, n_p_292677 *
                    s_n_m_292825 * (int64_t) 8);
        if (n_p_292677 * s_n_m_292825 * (int64_t) 8 > 0)
            memmove(mem_314461.mem + gtid_301459 * (s_n_m_292825 * n_p_292677) *
                    (int64_t) 8, mem_314305 + (int64_t) 0, n_p_292677 *
                    s_n_m_292825 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_314301);
    free(mem_314305);
    free(mem_314350);
    free(mem_314353);
    free(mem_314380);
    free(mem_314383);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338138_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338138_end -
                 futhark_mc_segmap_parloop_338138_start;
        
        ctx->futhark_mc_segmap_parloop_338138_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338138_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338138_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_338136(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_301458 = tid;
    int num_tasks_323414 = info.nsubtasks;
    struct futhark_mc_task_338135 *futhark_mc_task_338135 =
                                  (struct futhark_mc_task_338135 *) args;
    struct futhark_context *ctx = futhark_mc_task_338135->ctx;
    uint64_t futhark_mc_segmap_task_338136_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_338136_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_338135->free_n_p_292677;
    int64_t q_s_292678 = futhark_mc_task_338135->free_q_s_292678;
    int64_t jump_s_292684 = futhark_mc_task_338135->free_jump_s_292684;
    int64_t partition_sizze_292766 =
            futhark_mc_task_338135->free_partition_sizze_292766;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_338135->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_task_338135->free_pad_css_len_292821;
    int64_t s_n_m_292825 = futhark_mc_task_338135->free_s_n_m_292825;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_task_338135->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_312842 = {.desc ="mem_312842", .mem =
                                  futhark_mc_task_338135->free_mem_312842,
                                  .size =0, .references =NULL};
    int64_t bytes_312847 = futhark_mc_task_338135->free_bytes_312847;
    int64_t bytes_312899 = futhark_mc_task_338135->free_bytes_312899;
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_task_338135->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_task_338135->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_task_338135->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_task_338135->free_mem_313371,
                                  .size =0, .references =NULL};
    int64_t bytes_314123 = futhark_mc_task_338135->free_bytes_314123;
    struct memblock mem_314456 = {.desc ="mem_314456", .mem =
                                  futhark_mc_task_338135->free_mem_314456,
                                  .size =0, .references =NULL};
    struct memblock mem_314461 = {.desc ="mem_314461", .mem =
                                  futhark_mc_task_338135->free_mem_314461,
                                  .size =0, .references =NULL};
    int64_t iter_323415;
    struct futhark_mc_segmap_parloop_struct_338137
    futhark_mc_segmap_parloop_struct_338137;
    
    futhark_mc_segmap_parloop_struct_338137.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338137.free_n_p_292677 = n_p_292677;
    futhark_mc_segmap_parloop_struct_338137.free_q_s_292678 = q_s_292678;
    futhark_mc_segmap_parloop_struct_338137.free_jump_s_292684 = jump_s_292684;
    futhark_mc_segmap_parloop_struct_338137.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_338137.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segmap_parloop_struct_338137.free_pad_css_len_292821 =
        pad_css_len_292821;
    futhark_mc_segmap_parloop_struct_338137.free_s_n_m_292825 = s_n_m_292825;
    futhark_mc_segmap_parloop_struct_338137.free_mem_312838 = mem_312838.mem;
    futhark_mc_segmap_parloop_struct_338137.free_mem_312842 = mem_312842.mem;
    futhark_mc_segmap_parloop_struct_338137.free_bytes_312899 = bytes_312899;
    futhark_mc_segmap_parloop_struct_338137.free_mem_313018 = mem_313018.mem;
    futhark_mc_segmap_parloop_struct_338137.free_mem_313023 = mem_313023.mem;
    futhark_mc_segmap_parloop_struct_338137.free_mem_313366 = mem_313366.mem;
    futhark_mc_segmap_parloop_struct_338137.free_mem_313371 = mem_313371.mem;
    futhark_mc_segmap_parloop_struct_338137.free_bytes_314123 = bytes_314123;
    futhark_mc_segmap_parloop_struct_338137.free_mem_314456 = mem_314456.mem;
    futhark_mc_segmap_parloop_struct_338137.free_mem_314461 = mem_314461.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338138_task;
    
    futhark_mc_segmap_parloop_338138_task.name =
        "futhark_mc_segmap_parloop_338138";
    futhark_mc_segmap_parloop_338138_task.fn = futhark_mc_segmap_parloop_338138;
    futhark_mc_segmap_parloop_338138_task.args =
        &futhark_mc_segmap_parloop_struct_338137;
    futhark_mc_segmap_parloop_338138_task.iterations = iterations;
    futhark_mc_segmap_parloop_338138_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338138_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338138_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338138_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338138_task);
    
    if (futhark_mc_segmap_parloop_338138_err != 0) {
        err = futhark_mc_segmap_parloop_338138_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338138_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338138_total_end -
                 futhark_mc_segmap_parloop_338138_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338138_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338138_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338138_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_338136_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_338136_end -
                 futhark_mc_segmap_task_338136_start;
        
        ctx->futhark_mc_segmap_task_338136_runs[tid]++;
        ctx->futhark_mc_segmap_task_338136_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_338136_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_segmap_parloop_struct_338146 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_q_s_292678;
    int64_t free_jump_s_292684;
    int64_t free_partition_sizze_292766;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_312842;
    int64_t free_bytes_312847;
    int64_t free_bytes_312899;
    unsigned char *free_mem_313018;
    unsigned char *free_mem_313023;
    unsigned char *free_mem_313366;
    unsigned char *free_mem_313371;
    int64_t free_bytes_314123;
    unsigned char *free_mem_314456;
    unsigned char *free_mem_314461;
};
struct futhark_mc_task_338150 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_q_s_292678;
    int64_t free_jump_s_292684;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    int64_t free_gtid_301865;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_312842;
    int64_t free_bytes_312847;
    unsigned char *free_mem_313018;
    unsigned char *free_mem_313023;
    unsigned char *free_mem_313366;
    unsigned char *free_mem_313371;
    int64_t free_bytes_314123;
    unsigned char *free_mem_314293;
    unsigned char *free_mem_314297;
};
struct futhark_mc_segmap_parloop_struct_338152 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_q_s_292678;
    int64_t free_jump_s_292684;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    int64_t free_gtid_301865;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_312842;
    int64_t free_bytes_312847;
    unsigned char *free_mem_313018;
    unsigned char *free_mem_313023;
    unsigned char *free_mem_313366;
    unsigned char *free_mem_313371;
    int64_t free_bytes_314123;
    unsigned char *free_mem_314293;
    unsigned char *free_mem_314297;
};
static int futhark_mc_segmap_parloop_338153(void *args, int64_t start,
                                            int64_t end, int flat_tid_323837,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338152
    *futhark_mc_segmap_parloop_struct_338152 =
    (struct futhark_mc_segmap_parloop_struct_338152 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338152->ctx;
    uint64_t futhark_mc_segmap_parloop_338153_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338153_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segmap_parloop_struct_338152->free_n_p_292677;
    int64_t q_s_292678 =
            futhark_mc_segmap_parloop_struct_338152->free_q_s_292678;
    int64_t jump_s_292684 =
            futhark_mc_segmap_parloop_struct_338152->free_jump_s_292684;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segmap_parloop_struct_338152->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_segmap_parloop_struct_338152->free_pad_css_len_292821;
    int64_t s_n_m_292825 =
            futhark_mc_segmap_parloop_struct_338152->free_s_n_m_292825;
    int64_t gtid_301865 =
            futhark_mc_segmap_parloop_struct_338152->free_gtid_301865;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_segmap_parloop_struct_338152->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_312842 = {.desc ="mem_312842", .mem =
                                  futhark_mc_segmap_parloop_struct_338152->free_mem_312842,
                                  .size =0, .references =NULL};
    int64_t bytes_312847 =
            futhark_mc_segmap_parloop_struct_338152->free_bytes_312847;
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_segmap_parloop_struct_338152->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_segmap_parloop_struct_338152->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_segmap_parloop_struct_338152->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_segmap_parloop_struct_338152->free_mem_313371,
                                  .size =0, .references =NULL};
    int64_t bytes_314123 =
            futhark_mc_segmap_parloop_struct_338152->free_bytes_314123;
    struct memblock mem_314293 = {.desc ="mem_314293", .mem =
                                  futhark_mc_segmap_parloop_struct_338152->free_mem_314293,
                                  .size =0, .references =NULL};
    struct memblock mem_314297 = {.desc ="mem_314297", .mem =
                                  futhark_mc_segmap_parloop_struct_338152->free_mem_314297,
                                  .size =0, .references =NULL};
    size_t mem_323840_cached_sizze_338154 = 0;
    unsigned char *mem_323840 = NULL;
    size_t mem_323842_cached_sizze_338155 = 0;
    unsigned char *mem_323842 = NULL;
    size_t mem_323844_cached_sizze_338156 = 0;
    unsigned char *mem_323844 = NULL;
    size_t mem_323845_cached_sizze_338157 = 0;
    unsigned char *mem_323845 = NULL;
    size_t mem_323846_cached_sizze_338158 = 0;
    unsigned char *mem_323846 = NULL;
    size_t mem_323847_cached_sizze_338159 = 0;
    unsigned char *mem_323847 = NULL;
    int64_t iterations = end - start;
    int64_t iter_323983 = start;
    
    if (mem_323840_cached_sizze_338154 < (size_t) bytes_312847) {
        mem_323840 = realloc(mem_323840, bytes_312847);
        mem_323840_cached_sizze_338154 = bytes_312847;
    }
    if (mem_323842_cached_sizze_338155 < (size_t) bytes_312847) {
        mem_323842 = realloc(mem_323842, bytes_312847);
        mem_323842_cached_sizze_338155 = bytes_312847;
    }
    if (mem_323844_cached_sizze_338156 < (size_t) bytes_314123) {
        mem_323844 = realloc(mem_323844, bytes_314123);
        mem_323844_cached_sizze_338156 = bytes_314123;
    }
    if (mem_323845_cached_sizze_338157 < (size_t) bytes_314123) {
        mem_323845 = realloc(mem_323845, bytes_314123);
        mem_323845_cached_sizze_338157 = bytes_314123;
    }
    if (mem_323846_cached_sizze_338158 < (size_t) bytes_314123) {
        mem_323846 = realloc(mem_323846, bytes_314123);
        mem_323846_cached_sizze_338158 = bytes_314123;
    }
    if (mem_323847_cached_sizze_338159 < (size_t) bytes_314123) {
        mem_323847 = realloc(mem_323847, bytes_314123);
        mem_323847_cached_sizze_338159 = bytes_314123;
    }
    for (; iter_323983 < end; iter_323983++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_324114 = n_p_292677;
        int64_t gtid_323838 = iter_323983;
        int64_t remnant_324115 = iter_323983 - gtid_323838;
        int64_t x_323839;
        
        x_323839 = ((int64_t *) mem_312842.mem)[gtid_301865 * n_p_292677 +
                                                gtid_323838];
        for (int64_t i_323984 = 0; i_323984 < s_n_m_292825; i_323984++) {
            int64_t x_323987;
            
            x_323987 = ((int64_t *) mem_313018.mem)[gtid_301865 *
                                                    (s_n_m_292825 *
                                                     n_p_292677) + gtid_323838 *
                                                    s_n_m_292825 + i_323984];
            
            double x_323988;
            
            x_323988 = ((double *) mem_313023.mem)[gtid_301865 * (s_n_m_292825 *
                                                                  n_p_292677) +
                                                   gtid_323838 * s_n_m_292825 +
                                                   i_323984];
            
            bool cond_323989 = i_323984 == (int64_t) 0;
            int64_t defunc_0_m_fun_res_323990;
            
            if (cond_323989) {
                defunc_0_m_fun_res_323990 = (int64_t) 0;
            } else {
                int64_t y_323991 = sub64(s_n_m_292825, (int64_t) 1);
                bool cond_323992 = i_323984 == y_323991;
                int64_t defunc_0_m_fun_res_f_res_323993;
                
                if (cond_323992) {
                    int64_t defunc_0_m_fun_res_f_res_t_res_323994 =
                            sub64(pad_css_len_292821, (int64_t) 1);
                    
                    defunc_0_m_fun_res_f_res_323993 =
                        defunc_0_m_fun_res_f_res_t_res_323994;
                } else {
                    int64_t x_323995 = sub64(i_323984, (int64_t) 1);
                    int64_t x_323996 = mul64(jump_s_292684, x_323995);
                    int64_t min_arg_323997 = add64((int64_t) 1, x_323996);
                    int64_t min_res_323998 = smin64(defunc_0_f_res_292820,
                                                    min_arg_323997);
                    
                    defunc_0_m_fun_res_f_res_323993 = min_res_323998;
                }
                defunc_0_m_fun_res_323990 = defunc_0_m_fun_res_f_res_323993;
            }
            for (int64_t i_324003 = 0; i_324003 < q_s_292678; i_324003++) {
                bool cond_324006 = sle64(x_323839, i_324003);
                int64_t defunc_0_f_res_324007;
                
                if (cond_324006) {
                    defunc_0_f_res_324007 = (int64_t) 0;
                } else {
                    int64_t i_324008 = add64(x_323987, i_324003);
                    int64_t defunc_0_add_arg_324009;
                    
                    defunc_0_add_arg_324009 =
                        ((int64_t *) mem_312838.mem)[gtid_301865 *
                                                     (defunc_0_f_res_292820 *
                                                      n_p_292677) +
                                                     gtid_323838 *
                                                     defunc_0_f_res_292820 +
                                                     i_324008];
                    
                    int64_t defunc_1_add_res_324010 = add64((int64_t) 1,
                                                            defunc_0_add_arg_324009);
                    
                    defunc_0_f_res_324007 = defunc_1_add_res_324010;
                }
                
                double defunc_0_f_res_324011;
                
                if (cond_324006) {
                    defunc_0_f_res_324011 = 0.0;
                } else {
                    int64_t i_324012 = add64(x_323987, i_324003);
                    double defunc_0_add_arg_324013;
                    
                    defunc_0_add_arg_324013 =
                        ((double *) mem_313371.mem)[gtid_301865 *
                                                    (defunc_0_f_res_292820 *
                                                     n_p_292677) + gtid_323838 *
                                                    defunc_0_f_res_292820 +
                                                    i_324012];
                    defunc_0_f_res_324011 = defunc_0_add_arg_324013;
                }
                
                int64_t binop_p_324014 = sub64(defunc_0_f_res_324007,
                                               defunc_0_m_fun_res_323990);
                double defunc_0_f_res_324015 = sitofp_i64_f64(binop_p_324014);
                double abs_res_324016 = fabs(defunc_0_f_res_324015);
                double tmp1_324017 = abs_res_324016 / x_323988;
                double x_324018 = tmp1_324017 * tmp1_324017;
                double y_324019 = tmp1_324017 * x_324018;
                double tmp2_324020 = 1.0 - y_324019;
                double x_324021 = tmp2_324020 * tmp2_324020;
                double tmp3_324022 = tmp2_324020 * x_324021;
                double tmp4_324023 = defunc_0_f_res_324011 * tmp3_324022;
                
                ((double *) mem_323844)[i_324003] = defunc_0_f_res_324015;
                ((double *) mem_323845)[i_324003] = tmp4_324023;
            }
            
            double defunc_2_reduce_res_324028;
            double defunc_2_reduce_res_324029;
            double defunc_2_reduce_res_324030;
            double defunc_2_reduce_res_324031;
            double defunc_2_reduce_res_324032;
            double redout_324036;
            double redout_324037;
            double redout_324038;
            double redout_324039;
            double redout_324040;
            
            redout_324036 = 0.0;
            redout_324037 = 0.0;
            redout_324038 = 0.0;
            redout_324039 = 0.0;
            redout_324040 = 0.0;
            for (int64_t i_324035 = 0; i_324035 < q_s_292678; i_324035++) {
                double x_324043;
                
                x_324043 = ((double *) mem_323844)[i_324035];
                
                double x_324044;
                
                x_324044 = ((double *) mem_323845)[i_324035];
                
                double defunc_1_f_res_324045 = x_324043 * x_324044;
                double defunc_1_f_res_324046 = x_324043 * defunc_1_f_res_324045;
                double defunc_1_f_res_324047 = x_324043 * defunc_1_f_res_324046;
                double defunc_1_f_res_324048 = x_324043 * defunc_1_f_res_324047;
                double defunc_1_op_res_324049 = x_324044 + redout_324036;
                double defunc_1_op_res_324050 = defunc_1_f_res_324045 +
                       redout_324037;
                double defunc_1_op_res_324051 = defunc_1_f_res_324046 +
                       redout_324038;
                double defunc_1_op_res_324052 = defunc_1_f_res_324047 +
                       redout_324039;
                double defunc_1_op_res_324053 = defunc_1_f_res_324048 +
                       redout_324040;
                
                ((double *) mem_323846)[i_324035] = defunc_1_f_res_324046;
                ((double *) mem_323847)[i_324035] = defunc_1_f_res_324045;
                
                double redout_tmp_324120 = defunc_1_op_res_324049;
                double redout_tmp_324121 = defunc_1_op_res_324050;
                double redout_tmp_324122 = defunc_1_op_res_324051;
                double redout_tmp_324123 = defunc_1_op_res_324052;
                double redout_tmp_324124 = defunc_1_op_res_324053;
                
                redout_324036 = redout_tmp_324120;
                redout_324037 = redout_tmp_324121;
                redout_324038 = redout_tmp_324122;
                redout_324039 = redout_tmp_324123;
                redout_324040 = redout_tmp_324124;
            }
            defunc_2_reduce_res_324028 = redout_324036;
            defunc_2_reduce_res_324029 = redout_324037;
            defunc_2_reduce_res_324030 = redout_324038;
            defunc_2_reduce_res_324031 = redout_324039;
            defunc_2_reduce_res_324032 = redout_324040;
            
            double a_324056 = 2.220446049250313e-16 +
                   defunc_2_reduce_res_324028;
            double b_324057 = 2.220446049250313e-16 +
                   defunc_2_reduce_res_324029;
            double c_324058 = 2.220446049250313e-16 +
                   defunc_2_reduce_res_324030;
            double d_324059 = 2.220446049250313e-16 +
                   defunc_2_reduce_res_324031;
            double e_324060 = 2.220446049250313e-16 +
                   defunc_2_reduce_res_324032;
            double x_324061 = c_324058 * e_324060;
            double y_324062 = d_324059 * d_324059;
            double a12_324063 = x_324061 - y_324062;
            double x_324064 = c_324058 * d_324059;
            double y_324065 = b_324057 * e_324060;
            double b12_324066 = x_324064 - y_324065;
            double x_324067 = b_324057 * d_324059;
            double y_324068 = c_324058 * c_324058;
            double c12_324069 = x_324067 - y_324068;
            double x_324070 = a_324056 * e_324060;
            double b2_324071 = x_324070 - y_324068;
            double x_324072 = b_324057 * c_324058;
            double y_324073 = a_324056 * d_324059;
            double c2_324074 = x_324072 - y_324073;
            double x_324075 = a_324056 * a12_324063;
            double y_324076 = b_324057 * b12_324066;
            double x_324077 = x_324075 + y_324076;
            double y_324078 = c_324058 * c12_324069;
            double y_324079 = x_324077 + y_324078;
            double det_324080 = 1.0 / y_324079;
            double a12_324081 = a12_324063 * det_324080;
            double b12_324082 = b12_324066 * det_324080;
            double c12_324083 = c12_324069 * det_324080;
            double b2_324084 = b2_324071 * det_324080;
            double c2_324085 = c2_324074 * det_324080;
            double defunc_2_reduce_res_324086;
            double defunc_2_reduce_res_324087;
            double redout_324089;
            double redout_324090;
            
            redout_324089 = 0.0;
            redout_324090 = 0.0;
            for (int64_t i_324088 = 0; i_324088 < q_s_292678; i_324088++) {
                double x_324091;
                
                x_324091 = ((double *) mem_323845)[i_324088];
                
                double x_324092;
                
                x_324092 = ((double *) mem_323847)[i_324088];
                
                double x_324093;
                
                x_324093 = ((double *) mem_323846)[i_324088];
                
                bool cond_324094 = sle64(x_323839, i_324088);
                double defunc_0_f_res_324095;
                
                if (cond_324094) {
                    defunc_0_f_res_324095 = 0.0;
                } else {
                    int64_t i_324096 = add64(x_323987, i_324088);
                    double defunc_0_add_arg_324097;
                    
                    defunc_0_add_arg_324097 =
                        ((double *) mem_313366.mem)[gtid_301865 *
                                                    (defunc_0_f_res_292820 *
                                                     n_p_292677) + gtid_323838 *
                                                    defunc_0_f_res_292820 +
                                                    i_324096];
                    defunc_0_f_res_324095 = defunc_0_add_arg_324097;
                }
                
                double x_324098 = a12_324081 * x_324091;
                double y_324099 = b12_324082 * x_324092;
                double x_324100 = x_324098 + y_324099;
                double y_324101 = c12_324083 * x_324093;
                double x_324102 = x_324100 + y_324101;
                double defunc_9_fit_fun_res_324103 = defunc_0_f_res_324095 *
                       x_324102;
                double x_324104 = b12_324082 * x_324091;
                double y_324105 = b2_324084 * x_324092;
                double x_324106 = x_324104 + y_324105;
                double y_324107 = c2_324085 * x_324093;
                double x_324108 = x_324106 + y_324107;
                double defunc_9_slope_fun_res_324109 = defunc_0_f_res_324095 *
                       x_324108;
                double defunc_1_op_res_324110 = defunc_9_fit_fun_res_324103 +
                       redout_324089;
                double defunc_1_op_res_324111 = defunc_9_slope_fun_res_324109 +
                       redout_324090;
                double redout_tmp_324127 = defunc_1_op_res_324110;
                double redout_tmp_324128 = defunc_1_op_res_324111;
                
                redout_324089 = redout_tmp_324127;
                redout_324090 = redout_tmp_324128;
            }
            defunc_2_reduce_res_324086 = redout_324089;
            defunc_2_reduce_res_324087 = redout_324090;
            ((double *) mem_323840)[i_323984] = defunc_2_reduce_res_324086;
            ((double *) mem_323842)[i_323984] = defunc_2_reduce_res_324087;
        }
        if (s_n_m_292825 * (int64_t) 8 > 0)
            memmove(mem_314293.mem + gtid_323838 * s_n_m_292825 * (int64_t) 8,
                    mem_323840 + (int64_t) 0, s_n_m_292825 * (int64_t) 8);
        if (s_n_m_292825 * (int64_t) 8 > 0)
            memmove(mem_314297.mem + gtid_323838 * s_n_m_292825 * (int64_t) 8,
                    mem_323842 + (int64_t) 0, s_n_m_292825 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_323840);
    free(mem_323842);
    free(mem_323844);
    free(mem_323845);
    free(mem_323846);
    free(mem_323847);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338153_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338153_end -
                 futhark_mc_segmap_parloop_338153_start;
        
        ctx->futhark_mc_segmap_parloop_338153_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338153_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338153_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_338151(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_323837 = tid;
    int num_tasks_323982 = info.nsubtasks;
    struct futhark_mc_task_338150 *futhark_mc_task_338150 =
                                  (struct futhark_mc_task_338150 *) args;
    struct futhark_context *ctx = futhark_mc_task_338150->ctx;
    uint64_t futhark_mc_segmap_task_338151_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_338151_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_338150->free_n_p_292677;
    int64_t q_s_292678 = futhark_mc_task_338150->free_q_s_292678;
    int64_t jump_s_292684 = futhark_mc_task_338150->free_jump_s_292684;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_338150->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_task_338150->free_pad_css_len_292821;
    int64_t s_n_m_292825 = futhark_mc_task_338150->free_s_n_m_292825;
    int64_t gtid_301865 = futhark_mc_task_338150->free_gtid_301865;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_task_338150->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_312842 = {.desc ="mem_312842", .mem =
                                  futhark_mc_task_338150->free_mem_312842,
                                  .size =0, .references =NULL};
    int64_t bytes_312847 = futhark_mc_task_338150->free_bytes_312847;
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_task_338150->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_task_338150->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_task_338150->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_task_338150->free_mem_313371,
                                  .size =0, .references =NULL};
    int64_t bytes_314123 = futhark_mc_task_338150->free_bytes_314123;
    struct memblock mem_314293 = {.desc ="mem_314293", .mem =
                                  futhark_mc_task_338150->free_mem_314293,
                                  .size =0, .references =NULL};
    struct memblock mem_314297 = {.desc ="mem_314297", .mem =
                                  futhark_mc_task_338150->free_mem_314297,
                                  .size =0, .references =NULL};
    int64_t iter_323983;
    struct futhark_mc_segmap_parloop_struct_338152
    futhark_mc_segmap_parloop_struct_338152;
    
    futhark_mc_segmap_parloop_struct_338152.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338152.free_n_p_292677 = n_p_292677;
    futhark_mc_segmap_parloop_struct_338152.free_q_s_292678 = q_s_292678;
    futhark_mc_segmap_parloop_struct_338152.free_jump_s_292684 = jump_s_292684;
    futhark_mc_segmap_parloop_struct_338152.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segmap_parloop_struct_338152.free_pad_css_len_292821 =
        pad_css_len_292821;
    futhark_mc_segmap_parloop_struct_338152.free_s_n_m_292825 = s_n_m_292825;
    futhark_mc_segmap_parloop_struct_338152.free_gtid_301865 = gtid_301865;
    futhark_mc_segmap_parloop_struct_338152.free_mem_312838 = mem_312838.mem;
    futhark_mc_segmap_parloop_struct_338152.free_mem_312842 = mem_312842.mem;
    futhark_mc_segmap_parloop_struct_338152.free_bytes_312847 = bytes_312847;
    futhark_mc_segmap_parloop_struct_338152.free_mem_313018 = mem_313018.mem;
    futhark_mc_segmap_parloop_struct_338152.free_mem_313023 = mem_313023.mem;
    futhark_mc_segmap_parloop_struct_338152.free_mem_313366 = mem_313366.mem;
    futhark_mc_segmap_parloop_struct_338152.free_mem_313371 = mem_313371.mem;
    futhark_mc_segmap_parloop_struct_338152.free_bytes_314123 = bytes_314123;
    futhark_mc_segmap_parloop_struct_338152.free_mem_314293 = mem_314293.mem;
    futhark_mc_segmap_parloop_struct_338152.free_mem_314297 = mem_314297.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338153_task;
    
    futhark_mc_segmap_parloop_338153_task.name =
        "futhark_mc_segmap_parloop_338153";
    futhark_mc_segmap_parloop_338153_task.fn = futhark_mc_segmap_parloop_338153;
    futhark_mc_segmap_parloop_338153_task.args =
        &futhark_mc_segmap_parloop_struct_338152;
    futhark_mc_segmap_parloop_338153_task.iterations = iterations;
    futhark_mc_segmap_parloop_338153_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338153_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338153_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338153_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338153_task);
    
    if (futhark_mc_segmap_parloop_338153_err != 0) {
        err = futhark_mc_segmap_parloop_338153_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338153_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338153_total_end -
                 futhark_mc_segmap_parloop_338153_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338153_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338153_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338153_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_338151_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_338151_end -
                 futhark_mc_segmap_task_338151_start;
        
        ctx->futhark_mc_segmap_task_338151_runs[tid]++;
        ctx->futhark_mc_segmap_task_338151_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_338151_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_segmap_parloop_struct_338161 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_q_s_292678;
    int64_t free_jump_s_292684;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    int64_t free_gtid_301865;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_312842;
    int64_t free_bytes_312847;
    unsigned char *free_mem_313018;
    unsigned char *free_mem_313023;
    unsigned char *free_mem_313366;
    unsigned char *free_mem_313371;
    int64_t free_bytes_314123;
    unsigned char *free_mem_314293;
    unsigned char *free_mem_314297;
};
struct futhark_mc_task_338165 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_q_s_292678;
    int64_t free_jump_s_292684;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    int64_t free_gtid_301865;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_313018;
    unsigned char *free_mem_313023;
    unsigned char *free_mem_313366;
    unsigned char *free_mem_313371;
    int64_t free_bytes_314123;
    int64_t free_gtid_323571;
    int64_t free_x_323572;
    unsigned char *free_mem_323573;
    unsigned char *free_mem_323574;
};
struct futhark_mc_segmap_parloop_struct_338167 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_q_s_292678;
    int64_t free_jump_s_292684;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    int64_t free_gtid_301865;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_313018;
    unsigned char *free_mem_313023;
    unsigned char *free_mem_313366;
    unsigned char *free_mem_313371;
    int64_t free_bytes_314123;
    int64_t free_gtid_323571;
    int64_t free_x_323572;
    unsigned char *free_mem_323573;
    unsigned char *free_mem_323574;
};
static int futhark_mc_segmap_parloop_338168(void *args, int64_t start,
                                            int64_t end, int flat_tid_324259,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338167
    *futhark_mc_segmap_parloop_struct_338167 =
    (struct futhark_mc_segmap_parloop_struct_338167 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338167->ctx;
    uint64_t futhark_mc_segmap_parloop_338168_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338168_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segmap_parloop_struct_338167->free_n_p_292677;
    int64_t q_s_292678 =
            futhark_mc_segmap_parloop_struct_338167->free_q_s_292678;
    int64_t jump_s_292684 =
            futhark_mc_segmap_parloop_struct_338167->free_jump_s_292684;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segmap_parloop_struct_338167->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_segmap_parloop_struct_338167->free_pad_css_len_292821;
    int64_t s_n_m_292825 =
            futhark_mc_segmap_parloop_struct_338167->free_s_n_m_292825;
    int64_t gtid_301865 =
            futhark_mc_segmap_parloop_struct_338167->free_gtid_301865;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_segmap_parloop_struct_338167->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_segmap_parloop_struct_338167->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_segmap_parloop_struct_338167->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_segmap_parloop_struct_338167->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_segmap_parloop_struct_338167->free_mem_313371,
                                  .size =0, .references =NULL};
    int64_t bytes_314123 =
            futhark_mc_segmap_parloop_struct_338167->free_bytes_314123;
    int64_t gtid_323571 =
            futhark_mc_segmap_parloop_struct_338167->free_gtid_323571;
    int64_t x_323572 = futhark_mc_segmap_parloop_struct_338167->free_x_323572;
    struct memblock mem_323573 = {.desc ="mem_323573", .mem =
                                  futhark_mc_segmap_parloop_struct_338167->free_mem_323573,
                                  .size =0, .references =NULL};
    struct memblock mem_323574 = {.desc ="mem_323574", .mem =
                                  futhark_mc_segmap_parloop_struct_338167->free_mem_323574,
                                  .size =0, .references =NULL};
    size_t mem_324273_cached_sizze_338169 = 0;
    unsigned char *mem_324273 = NULL;
    size_t mem_324275_cached_sizze_338170 = 0;
    unsigned char *mem_324275 = NULL;
    size_t mem_324302_cached_sizze_338171 = 0;
    unsigned char *mem_324302 = NULL;
    size_t mem_324304_cached_sizze_338172 = 0;
    unsigned char *mem_324304 = NULL;
    int64_t iterations = end - start;
    int64_t iter_324393 = start;
    
    if (mem_324273_cached_sizze_338169 < (size_t) bytes_314123) {
        mem_324273 = realloc(mem_324273, bytes_314123);
        mem_324273_cached_sizze_338169 = bytes_314123;
    }
    if (mem_324275_cached_sizze_338170 < (size_t) bytes_314123) {
        mem_324275 = realloc(mem_324275, bytes_314123);
        mem_324275_cached_sizze_338170 = bytes_314123;
    }
    if (mem_324302_cached_sizze_338171 < (size_t) bytes_314123) {
        mem_324302 = realloc(mem_324302, bytes_314123);
        mem_324302_cached_sizze_338171 = bytes_314123;
    }
    if (mem_324304_cached_sizze_338172 < (size_t) bytes_314123) {
        mem_324304 = realloc(mem_324304, bytes_314123);
        mem_324304_cached_sizze_338172 = bytes_314123;
    }
    for (; iter_324393 < end; iter_324393++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_324470 = s_n_m_292825;
        int64_t gtid_324260 = iter_324393;
        int64_t remnant_324471 = iter_324393 - gtid_324260;
        int64_t x_324261;
        
        x_324261 = ((int64_t *) mem_313018.mem)[gtid_301865 * (s_n_m_292825 *
                                                               n_p_292677) +
                                                gtid_323571 * s_n_m_292825 +
                                                gtid_324260];
        
        double x_324262;
        
        x_324262 = ((double *) mem_313023.mem)[gtid_301865 * (s_n_m_292825 *
                                                              n_p_292677) +
                                               gtid_323571 * s_n_m_292825 +
                                               gtid_324260];
        
        bool cond_324263 = gtid_324260 == (int64_t) 0;
        int64_t defunc_0_m_fun_res_324264;
        
        if (cond_324263) {
            defunc_0_m_fun_res_324264 = (int64_t) 0;
        } else {
            int64_t y_324394 = sub64(s_n_m_292825, (int64_t) 1);
            bool cond_324395 = gtid_324260 == y_324394;
            int64_t defunc_0_m_fun_res_f_res_324396;
            
            if (cond_324395) {
                int64_t defunc_0_m_fun_res_f_res_t_res_324397 =
                        sub64(pad_css_len_292821, (int64_t) 1);
                
                defunc_0_m_fun_res_f_res_324396 =
                    defunc_0_m_fun_res_f_res_t_res_324397;
            } else {
                int64_t x_324398 = sub64(gtid_324260, (int64_t) 1);
                int64_t x_324399 = mul64(jump_s_292684, x_324398);
                int64_t min_arg_324400 = add64((int64_t) 1, x_324399);
                int64_t min_res_324401 = smin64(defunc_0_f_res_292820,
                                                min_arg_324400);
                
                defunc_0_m_fun_res_f_res_324396 = min_res_324401;
            }
            defunc_0_m_fun_res_324264 = defunc_0_m_fun_res_f_res_324396;
        }
        for (int64_t i_324402 = 0; i_324402 < q_s_292678; i_324402++) {
            bool cond_324405 = sle64(x_323572, i_324402);
            int64_t defunc_0_f_res_324406;
            
            if (cond_324405) {
                defunc_0_f_res_324406 = (int64_t) 0;
            } else {
                int64_t i_324407 = add64(x_324261, i_324402);
                int64_t defunc_0_add_arg_324408;
                
                defunc_0_add_arg_324408 =
                    ((int64_t *) mem_312838.mem)[gtid_301865 *
                                                 (defunc_0_f_res_292820 *
                                                  n_p_292677) + gtid_323571 *
                                                 defunc_0_f_res_292820 +
                                                 i_324407];
                
                int64_t defunc_1_add_res_324409 = add64((int64_t) 1,
                                                        defunc_0_add_arg_324408);
                
                defunc_0_f_res_324406 = defunc_1_add_res_324409;
            }
            
            double defunc_0_f_res_324410;
            
            if (cond_324405) {
                defunc_0_f_res_324410 = 0.0;
            } else {
                int64_t i_324411 = add64(x_324261, i_324402);
                double defunc_0_add_arg_324412;
                
                defunc_0_add_arg_324412 =
                    ((double *) mem_313371.mem)[gtid_301865 *
                                                (defunc_0_f_res_292820 *
                                                 n_p_292677) + gtid_323571 *
                                                defunc_0_f_res_292820 +
                                                i_324411];
                defunc_0_f_res_324410 = defunc_0_add_arg_324412;
            }
            
            int64_t binop_p_324413 = sub64(defunc_0_f_res_324406,
                                           defunc_0_m_fun_res_324264);
            double defunc_0_f_res_324414 = sitofp_i64_f64(binop_p_324413);
            double abs_res_324415 = fabs(defunc_0_f_res_324414);
            double tmp1_324416 = abs_res_324415 / x_324262;
            double x_324417 = tmp1_324416 * tmp1_324416;
            double y_324418 = tmp1_324416 * x_324417;
            double tmp2_324419 = 1.0 - y_324418;
            double x_324420 = tmp2_324419 * tmp2_324419;
            double tmp3_324421 = tmp2_324419 * x_324420;
            double tmp4_324422 = defunc_0_f_res_324410 * tmp3_324421;
            
            ((double *) mem_324273)[i_324402] = defunc_0_f_res_324414;
            ((double *) mem_324275)[i_324402] = tmp4_324422;
        }
        
        double defunc_2_reduce_res_324306;
        double defunc_2_reduce_res_324307;
        double defunc_2_reduce_res_324308;
        double defunc_2_reduce_res_324309;
        double defunc_2_reduce_res_324310;
        double redout_324426;
        double redout_324427;
        double redout_324428;
        double redout_324429;
        double redout_324430;
        
        redout_324426 = 0.0;
        redout_324427 = 0.0;
        redout_324428 = 0.0;
        redout_324429 = 0.0;
        redout_324430 = 0.0;
        for (int64_t i_324425 = 0; i_324425 < q_s_292678; i_324425++) {
            double x_324433;
            
            x_324433 = ((double *) mem_324273)[i_324425];
            
            double x_324434;
            
            x_324434 = ((double *) mem_324275)[i_324425];
            
            double defunc_1_f_res_324435 = x_324433 * x_324434;
            double defunc_1_f_res_324436 = x_324433 * defunc_1_f_res_324435;
            double defunc_1_f_res_324437 = x_324433 * defunc_1_f_res_324436;
            double defunc_1_f_res_324438 = x_324433 * defunc_1_f_res_324437;
            double defunc_1_op_res_324439 = x_324434 + redout_324426;
            double defunc_1_op_res_324440 = defunc_1_f_res_324435 +
                   redout_324427;
            double defunc_1_op_res_324441 = defunc_1_f_res_324436 +
                   redout_324428;
            double defunc_1_op_res_324442 = defunc_1_f_res_324437 +
                   redout_324429;
            double defunc_1_op_res_324443 = defunc_1_f_res_324438 +
                   redout_324430;
            
            ((double *) mem_324302)[i_324425] = defunc_1_f_res_324436;
            ((double *) mem_324304)[i_324425] = defunc_1_f_res_324435;
            
            double redout_tmp_324474 = defunc_1_op_res_324439;
            double redout_tmp_324475 = defunc_1_op_res_324440;
            double redout_tmp_324476 = defunc_1_op_res_324441;
            double redout_tmp_324477 = defunc_1_op_res_324442;
            double redout_tmp_324478 = defunc_1_op_res_324443;
            
            redout_324426 = redout_tmp_324474;
            redout_324427 = redout_tmp_324475;
            redout_324428 = redout_tmp_324476;
            redout_324429 = redout_tmp_324477;
            redout_324430 = redout_tmp_324478;
        }
        defunc_2_reduce_res_324306 = redout_324426;
        defunc_2_reduce_res_324307 = redout_324427;
        defunc_2_reduce_res_324308 = redout_324428;
        defunc_2_reduce_res_324309 = redout_324429;
        defunc_2_reduce_res_324310 = redout_324430;
        
        double a_324334 = 2.220446049250313e-16 + defunc_2_reduce_res_324306;
        double b_324335 = 2.220446049250313e-16 + defunc_2_reduce_res_324307;
        double c_324336 = 2.220446049250313e-16 + defunc_2_reduce_res_324308;
        double d_324337 = 2.220446049250313e-16 + defunc_2_reduce_res_324309;
        double e_324338 = 2.220446049250313e-16 + defunc_2_reduce_res_324310;
        double x_324339 = c_324336 * e_324338;
        double y_324340 = d_324337 * d_324337;
        double a12_324341 = x_324339 - y_324340;
        double x_324342 = c_324336 * d_324337;
        double y_324343 = b_324335 * e_324338;
        double b12_324344 = x_324342 - y_324343;
        double x_324345 = b_324335 * d_324337;
        double y_324346 = c_324336 * c_324336;
        double c12_324347 = x_324345 - y_324346;
        double x_324348 = a_324334 * e_324338;
        double b2_324349 = x_324348 - y_324346;
        double x_324350 = b_324335 * c_324336;
        double y_324351 = a_324334 * d_324337;
        double c2_324352 = x_324350 - y_324351;
        double x_324353 = a_324334 * a12_324341;
        double y_324354 = b_324335 * b12_324344;
        double x_324355 = x_324353 + y_324354;
        double y_324356 = c_324336 * c12_324347;
        double y_324357 = x_324355 + y_324356;
        double det_324358 = 1.0 / y_324357;
        double a12_324359 = a12_324341 * det_324358;
        double b12_324360 = b12_324344 * det_324358;
        double c12_324361 = c12_324347 * det_324358;
        double b2_324362 = b2_324349 * det_324358;
        double c2_324363 = c2_324352 * det_324358;
        double defunc_2_reduce_res_324364;
        double defunc_2_reduce_res_324365;
        double redout_324447;
        double redout_324448;
        
        redout_324447 = 0.0;
        redout_324448 = 0.0;
        for (int64_t i_324446 = 0; i_324446 < q_s_292678; i_324446++) {
            double x_324449;
            
            x_324449 = ((double *) mem_324275)[i_324446];
            
            double x_324450;
            
            x_324450 = ((double *) mem_324304)[i_324446];
            
            double x_324451;
            
            x_324451 = ((double *) mem_324302)[i_324446];
            
            bool cond_324452 = sle64(x_323572, i_324446);
            double defunc_0_f_res_324453;
            
            if (cond_324452) {
                defunc_0_f_res_324453 = 0.0;
            } else {
                int64_t i_324454 = add64(x_324261, i_324446);
                double defunc_0_add_arg_324455;
                
                defunc_0_add_arg_324455 =
                    ((double *) mem_313366.mem)[gtid_301865 *
                                                (defunc_0_f_res_292820 *
                                                 n_p_292677) + gtid_323571 *
                                                defunc_0_f_res_292820 +
                                                i_324454];
                defunc_0_f_res_324453 = defunc_0_add_arg_324455;
            }
            
            double x_324456 = a12_324359 * x_324449;
            double y_324457 = b12_324360 * x_324450;
            double x_324458 = x_324456 + y_324457;
            double y_324459 = c12_324361 * x_324451;
            double x_324460 = x_324458 + y_324459;
            double defunc_9_fit_fun_res_324461 = defunc_0_f_res_324453 *
                   x_324460;
            double x_324462 = b12_324360 * x_324449;
            double y_324463 = b2_324362 * x_324450;
            double x_324464 = x_324462 + y_324463;
            double y_324465 = c2_324363 * x_324451;
            double x_324466 = x_324464 + y_324465;
            double defunc_9_slope_fun_res_324467 = defunc_0_f_res_324453 *
                   x_324466;
            double defunc_1_op_res_324468 = defunc_9_fit_fun_res_324461 +
                   redout_324447;
            double defunc_1_op_res_324469 = defunc_9_slope_fun_res_324467 +
                   redout_324448;
            double redout_tmp_324481 = defunc_1_op_res_324468;
            double redout_tmp_324482 = defunc_1_op_res_324469;
            
            redout_324447 = redout_tmp_324481;
            redout_324448 = redout_tmp_324482;
        }
        defunc_2_reduce_res_324364 = redout_324447;
        defunc_2_reduce_res_324365 = redout_324448;
        ((double *) mem_323573.mem)[gtid_324260] = defunc_2_reduce_res_324364;
        ((double *) mem_323574.mem)[gtid_324260] = defunc_2_reduce_res_324365;
    }
    
  cleanup:
    { }
    free(mem_324273);
    free(mem_324275);
    free(mem_324302);
    free(mem_324304);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338168_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338168_end -
                 futhark_mc_segmap_parloop_338168_start;
        
        ctx->futhark_mc_segmap_parloop_338168_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338168_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338168_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_338166(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_324259 = tid;
    int num_tasks_324392 = info.nsubtasks;
    struct futhark_mc_task_338165 *futhark_mc_task_338165 =
                                  (struct futhark_mc_task_338165 *) args;
    struct futhark_context *ctx = futhark_mc_task_338165->ctx;
    uint64_t futhark_mc_segmap_task_338166_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_338166_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_338165->free_n_p_292677;
    int64_t q_s_292678 = futhark_mc_task_338165->free_q_s_292678;
    int64_t jump_s_292684 = futhark_mc_task_338165->free_jump_s_292684;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_338165->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_task_338165->free_pad_css_len_292821;
    int64_t s_n_m_292825 = futhark_mc_task_338165->free_s_n_m_292825;
    int64_t gtid_301865 = futhark_mc_task_338165->free_gtid_301865;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_task_338165->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_task_338165->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_task_338165->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_task_338165->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_task_338165->free_mem_313371,
                                  .size =0, .references =NULL};
    int64_t bytes_314123 = futhark_mc_task_338165->free_bytes_314123;
    int64_t gtid_323571 = futhark_mc_task_338165->free_gtid_323571;
    int64_t x_323572 = futhark_mc_task_338165->free_x_323572;
    struct memblock mem_323573 = {.desc ="mem_323573", .mem =
                                  futhark_mc_task_338165->free_mem_323573,
                                  .size =0, .references =NULL};
    struct memblock mem_323574 = {.desc ="mem_323574", .mem =
                                  futhark_mc_task_338165->free_mem_323574,
                                  .size =0, .references =NULL};
    int64_t iter_324393;
    struct futhark_mc_segmap_parloop_struct_338167
    futhark_mc_segmap_parloop_struct_338167;
    
    futhark_mc_segmap_parloop_struct_338167.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338167.free_n_p_292677 = n_p_292677;
    futhark_mc_segmap_parloop_struct_338167.free_q_s_292678 = q_s_292678;
    futhark_mc_segmap_parloop_struct_338167.free_jump_s_292684 = jump_s_292684;
    futhark_mc_segmap_parloop_struct_338167.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segmap_parloop_struct_338167.free_pad_css_len_292821 =
        pad_css_len_292821;
    futhark_mc_segmap_parloop_struct_338167.free_s_n_m_292825 = s_n_m_292825;
    futhark_mc_segmap_parloop_struct_338167.free_gtid_301865 = gtid_301865;
    futhark_mc_segmap_parloop_struct_338167.free_mem_312838 = mem_312838.mem;
    futhark_mc_segmap_parloop_struct_338167.free_mem_313018 = mem_313018.mem;
    futhark_mc_segmap_parloop_struct_338167.free_mem_313023 = mem_313023.mem;
    futhark_mc_segmap_parloop_struct_338167.free_mem_313366 = mem_313366.mem;
    futhark_mc_segmap_parloop_struct_338167.free_mem_313371 = mem_313371.mem;
    futhark_mc_segmap_parloop_struct_338167.free_bytes_314123 = bytes_314123;
    futhark_mc_segmap_parloop_struct_338167.free_gtid_323571 = gtid_323571;
    futhark_mc_segmap_parloop_struct_338167.free_x_323572 = x_323572;
    futhark_mc_segmap_parloop_struct_338167.free_mem_323573 = mem_323573.mem;
    futhark_mc_segmap_parloop_struct_338167.free_mem_323574 = mem_323574.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338168_task;
    
    futhark_mc_segmap_parloop_338168_task.name =
        "futhark_mc_segmap_parloop_338168";
    futhark_mc_segmap_parloop_338168_task.fn = futhark_mc_segmap_parloop_338168;
    futhark_mc_segmap_parloop_338168_task.args =
        &futhark_mc_segmap_parloop_struct_338167;
    futhark_mc_segmap_parloop_338168_task.iterations = iterations;
    futhark_mc_segmap_parloop_338168_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338168_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338168_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338168_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338168_task);
    
    if (futhark_mc_segmap_parloop_338168_err != 0) {
        err = futhark_mc_segmap_parloop_338168_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338168_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338168_total_end -
                 futhark_mc_segmap_parloop_338168_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338168_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338168_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338168_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_338166_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_338166_end -
                 futhark_mc_segmap_task_338166_start;
        
        ctx->futhark_mc_segmap_task_338166_runs[tid]++;
        ctx->futhark_mc_segmap_task_338166_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_338166_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_segmap_parloop_struct_338174 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_q_s_292678;
    int64_t free_jump_s_292684;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    int64_t free_gtid_301865;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_313018;
    unsigned char *free_mem_313023;
    unsigned char *free_mem_313366;
    unsigned char *free_mem_313371;
    int64_t free_bytes_314123;
    int64_t free_gtid_323571;
    int64_t free_x_323572;
    unsigned char *free_mem_323573;
    unsigned char *free_mem_323574;
};
struct futhark_mc_task_338180 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_q_s_292678;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_gtid_301865;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_313371;
    int64_t free_gtid_323571;
    int64_t free_x_323572;
    int64_t free_x_324132;
    double free_x_324133;
    int64_t free_defunc_0_m_fun_res_324135;
    unsigned char *free_mem_324144;
    unsigned char *free_mem_324145;
};
struct futhark_mc_segmap_parloop_struct_338182 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_q_s_292678;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_gtid_301865;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_313371;
    int64_t free_gtid_323571;
    int64_t free_x_323572;
    int64_t free_x_324132;
    double free_x_324133;
    int64_t free_defunc_0_m_fun_res_324135;
    unsigned char *free_mem_324144;
    unsigned char *free_mem_324145;
};
static int futhark_mc_segmap_parloop_338183(void *args, int64_t start,
                                            int64_t end, int flat_tid_324492,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338182
    *futhark_mc_segmap_parloop_struct_338182 =
    (struct futhark_mc_segmap_parloop_struct_338182 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338182->ctx;
    uint64_t futhark_mc_segmap_parloop_338183_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338183_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segmap_parloop_struct_338182->free_n_p_292677;
    int64_t q_s_292678 =
            futhark_mc_segmap_parloop_struct_338182->free_q_s_292678;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segmap_parloop_struct_338182->free_defunc_0_f_res_292820;
    int64_t gtid_301865 =
            futhark_mc_segmap_parloop_struct_338182->free_gtid_301865;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_segmap_parloop_struct_338182->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_segmap_parloop_struct_338182->free_mem_313371,
                                  .size =0, .references =NULL};
    int64_t gtid_323571 =
            futhark_mc_segmap_parloop_struct_338182->free_gtid_323571;
    int64_t x_323572 = futhark_mc_segmap_parloop_struct_338182->free_x_323572;
    int64_t x_324132 = futhark_mc_segmap_parloop_struct_338182->free_x_324132;
    double x_324133 = futhark_mc_segmap_parloop_struct_338182->free_x_324133;
    int64_t defunc_0_m_fun_res_324135 =
            futhark_mc_segmap_parloop_struct_338182->free_defunc_0_m_fun_res_324135;
    struct memblock mem_324144 = {.desc ="mem_324144", .mem =
                                  futhark_mc_segmap_parloop_struct_338182->free_mem_324144,
                                  .size =0, .references =NULL};
    struct memblock mem_324145 = {.desc ="mem_324145", .mem =
                                  futhark_mc_segmap_parloop_struct_338182->free_mem_324145,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_324565 = start;
    
    for (; iter_324565 < end; iter_324565++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_324571 = q_s_292678;
        int64_t gtid_324493 = iter_324565;
        int64_t remnant_324572 = iter_324565 - gtid_324493;
        bool cond_324494 = sle64(x_323572, gtid_324493);
        int64_t defunc_0_f_res_324495;
        
        if (cond_324494) {
            defunc_0_f_res_324495 = (int64_t) 0;
        } else {
            int64_t i_324566 = add64(x_324132, gtid_324493);
            int64_t defunc_0_add_arg_324567;
            
            defunc_0_add_arg_324567 = ((int64_t *) mem_312838.mem)[gtid_301865 *
                                                                   (defunc_0_f_res_292820 *
                                                                    n_p_292677) +
                                                                   gtid_323571 *
                                                                   defunc_0_f_res_292820 +
                                                                   i_324566];
            
            int64_t defunc_1_add_res_324568 = add64((int64_t) 1,
                                                    defunc_0_add_arg_324567);
            
            defunc_0_f_res_324495 = defunc_1_add_res_324568;
        }
        
        double defunc_0_f_res_324499;
        
        if (cond_324494) {
            defunc_0_f_res_324499 = 0.0;
        } else {
            int64_t i_324569 = add64(x_324132, gtid_324493);
            double defunc_0_add_arg_324570;
            
            defunc_0_add_arg_324570 = ((double *) mem_313371.mem)[gtid_301865 *
                                                                  (defunc_0_f_res_292820 *
                                                                   n_p_292677) +
                                                                  gtid_323571 *
                                                                  defunc_0_f_res_292820 +
                                                                  i_324569];
            defunc_0_f_res_324499 = defunc_0_add_arg_324570;
        }
        
        int64_t binop_p_324502 = sub64(defunc_0_f_res_324495,
                                       defunc_0_m_fun_res_324135);
        double defunc_0_f_res_324503 = sitofp_i64_f64(binop_p_324502);
        double abs_res_324504 = fabs(defunc_0_f_res_324503);
        double tmp1_324505 = abs_res_324504 / x_324133;
        double x_324506 = tmp1_324505 * tmp1_324505;
        double y_324507 = tmp1_324505 * x_324506;
        double tmp2_324508 = 1.0 - y_324507;
        double x_324509 = tmp2_324508 * tmp2_324508;
        double tmp3_324510 = tmp2_324508 * x_324509;
        double tmp4_324511 = defunc_0_f_res_324499 * tmp3_324510;
        
        ((double *) mem_324144.mem)[gtid_324493] = defunc_0_f_res_324503;
        ((double *) mem_324145.mem)[gtid_324493] = tmp4_324511;
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338183_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338183_end -
                 futhark_mc_segmap_parloop_338183_start;
        
        ctx->futhark_mc_segmap_parloop_338183_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338183_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338183_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_338181(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_324492 = tid;
    int num_tasks_324564 = info.nsubtasks;
    struct futhark_mc_task_338180 *futhark_mc_task_338180 =
                                  (struct futhark_mc_task_338180 *) args;
    struct futhark_context *ctx = futhark_mc_task_338180->ctx;
    uint64_t futhark_mc_segmap_task_338181_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_338181_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_338180->free_n_p_292677;
    int64_t q_s_292678 = futhark_mc_task_338180->free_q_s_292678;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_338180->free_defunc_0_f_res_292820;
    int64_t gtid_301865 = futhark_mc_task_338180->free_gtid_301865;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_task_338180->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_task_338180->free_mem_313371,
                                  .size =0, .references =NULL};
    int64_t gtid_323571 = futhark_mc_task_338180->free_gtid_323571;
    int64_t x_323572 = futhark_mc_task_338180->free_x_323572;
    int64_t x_324132 = futhark_mc_task_338180->free_x_324132;
    double x_324133 = futhark_mc_task_338180->free_x_324133;
    int64_t defunc_0_m_fun_res_324135 =
            futhark_mc_task_338180->free_defunc_0_m_fun_res_324135;
    struct memblock mem_324144 = {.desc ="mem_324144", .mem =
                                  futhark_mc_task_338180->free_mem_324144,
                                  .size =0, .references =NULL};
    struct memblock mem_324145 = {.desc ="mem_324145", .mem =
                                  futhark_mc_task_338180->free_mem_324145,
                                  .size =0, .references =NULL};
    int64_t iter_324565;
    struct futhark_mc_segmap_parloop_struct_338182
    futhark_mc_segmap_parloop_struct_338182;
    
    futhark_mc_segmap_parloop_struct_338182.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338182.free_n_p_292677 = n_p_292677;
    futhark_mc_segmap_parloop_struct_338182.free_q_s_292678 = q_s_292678;
    futhark_mc_segmap_parloop_struct_338182.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segmap_parloop_struct_338182.free_gtid_301865 = gtid_301865;
    futhark_mc_segmap_parloop_struct_338182.free_mem_312838 = mem_312838.mem;
    futhark_mc_segmap_parloop_struct_338182.free_mem_313371 = mem_313371.mem;
    futhark_mc_segmap_parloop_struct_338182.free_gtid_323571 = gtid_323571;
    futhark_mc_segmap_parloop_struct_338182.free_x_323572 = x_323572;
    futhark_mc_segmap_parloop_struct_338182.free_x_324132 = x_324132;
    futhark_mc_segmap_parloop_struct_338182.free_x_324133 = x_324133;
    futhark_mc_segmap_parloop_struct_338182.free_defunc_0_m_fun_res_324135 =
        defunc_0_m_fun_res_324135;
    futhark_mc_segmap_parloop_struct_338182.free_mem_324144 = mem_324144.mem;
    futhark_mc_segmap_parloop_struct_338182.free_mem_324145 = mem_324145.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338183_task;
    
    futhark_mc_segmap_parloop_338183_task.name =
        "futhark_mc_segmap_parloop_338183";
    futhark_mc_segmap_parloop_338183_task.fn = futhark_mc_segmap_parloop_338183;
    futhark_mc_segmap_parloop_338183_task.args =
        &futhark_mc_segmap_parloop_struct_338182;
    futhark_mc_segmap_parloop_338183_task.iterations = iterations;
    futhark_mc_segmap_parloop_338183_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338183_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338183_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338183_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338183_task);
    
    if (futhark_mc_segmap_parloop_338183_err != 0) {
        err = futhark_mc_segmap_parloop_338183_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338183_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338183_total_end -
                 futhark_mc_segmap_parloop_338183_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338183_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338183_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338183_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_338181_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_338181_end -
                 futhark_mc_segmap_task_338181_start;
        
        ctx->futhark_mc_segmap_task_338181_runs[tid]++;
        ctx->futhark_mc_segmap_task_338181_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_338181_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_task_338184 {
    struct futhark_context *ctx;
    unsigned char *free_mem_324144;
    unsigned char *free_mem_324145;
    double *retval_defunc_2_reduce_res_324170;
    double *retval_defunc_2_reduce_res_324171;
    double *retval_defunc_2_reduce_res_324172;
    double *retval_defunc_2_reduce_res_324173;
    double *retval_defunc_2_reduce_res_324174;
    unsigned char *retval_mem_324168;
    unsigned char *retval_mem_324169;
};
struct futhark_mc_segred_stage_1_parloop_struct_338191 {
    struct futhark_context *ctx;
    unsigned char *free_mem_324144;
    unsigned char *free_mem_324145;
    unsigned char *free_mem_324168;
    unsigned char *free_mem_324169;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_324574;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_324576;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_324578;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_324580;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_324582;
};
static int futhark_mc_segred_stage_1_parloop_338192(void *args, int64_t start,
                                                    int64_t end,
                                                    int flat_tid_324512,
                                                    int tid)
{
    int err = 0;
    struct futhark_mc_segred_stage_1_parloop_struct_338191
    *futhark_mc_segred_stage_1_parloop_struct_338191 =
    (struct futhark_mc_segred_stage_1_parloop_struct_338191 *) args;
    struct futhark_context *ctx =
                           futhark_mc_segred_stage_1_parloop_struct_338191->ctx;
    uint64_t futhark_mc_segred_stage_1_parloop_338192_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_338192_start = get_wall_time();
    
    struct memblock mem_324144 = {.desc ="mem_324144", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_338191->free_mem_324144,
                                  .size =0, .references =NULL};
    struct memblock mem_324145 = {.desc ="mem_324145", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_338191->free_mem_324145,
                                  .size =0, .references =NULL};
    struct memblock mem_324168 = {.desc ="mem_324168", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_338191->free_mem_324168,
                                  .size =0, .references =NULL};
    struct memblock mem_324169 = {.desc ="mem_324169", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_338191->free_mem_324169,
                                  .size =0, .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_324574 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_324574",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338191->free_reduce_stage_1_tid_res_arr_mem_324574,
                                                             .size =0,
                                                             .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_324576 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_324576",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338191->free_reduce_stage_1_tid_res_arr_mem_324576,
                                                             .size =0,
                                                             .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_324578 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_324578",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338191->free_reduce_stage_1_tid_res_arr_mem_324578,
                                                             .size =0,
                                                             .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_324580 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_324580",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338191->free_reduce_stage_1_tid_res_arr_mem_324580,
                                                             .size =0,
                                                             .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_324582 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_324582",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338191->free_reduce_stage_1_tid_res_arr_mem_324582,
                                                             .size =0,
                                                             .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_324584 = start;
    double x_324514;
    double x_324515;
    double x_324517;
    double x_324518;
    double x_324520;
    double x_324521;
    double x_324523;
    double x_324524;
    double x_324526;
    double x_324527;
    double local_acc_324585 = 0.0;
    double local_acc_324586 = 0.0;
    double local_acc_324587 = 0.0;
    double local_acc_324588 = 0.0;
    double local_acc_324589 = 0.0;
    
    for (; iter_324584 < end; iter_324584++) {
        int64_t gtid_324513 = iter_324584;
        double x_324529;
        
        x_324529 = ((double *) mem_324144.mem)[gtid_324513];
        
        double x_324530;
        
        x_324530 = ((double *) mem_324145.mem)[gtid_324513];
        
        double defunc_1_f_res_324531 = x_324529 * x_324530;
        double defunc_1_f_res_324532 = x_324529 * defunc_1_f_res_324531;
        double defunc_1_f_res_324533 = x_324529 * defunc_1_f_res_324532;
        double defunc_1_f_res_324534 = x_324529 * defunc_1_f_res_324533;
        
        // save map-out results
        {
            ((double *) mem_324168.mem)[gtid_324513] = defunc_1_f_res_324532;
            ((double *) mem_324169.mem)[gtid_324513] = defunc_1_f_res_324531;
        }
        // Load accum params
        {
            x_324514 = local_acc_324585;
        }
        // Load next params
        {
            x_324515 = x_324530;
        }
        // Red body
        {
            double defunc_1_op_res_324516 = x_324514 + x_324515;
            
            local_acc_324585 = defunc_1_op_res_324516;
        }
        // Load accum params
        {
            x_324517 = local_acc_324586;
        }
        // Load next params
        {
            x_324518 = defunc_1_f_res_324531;
        }
        // Red body
        {
            double defunc_1_op_res_324519 = x_324517 + x_324518;
            
            local_acc_324586 = defunc_1_op_res_324519;
        }
        // Load accum params
        {
            x_324520 = local_acc_324587;
        }
        // Load next params
        {
            x_324521 = defunc_1_f_res_324532;
        }
        // Red body
        {
            double defunc_1_op_res_324522 = x_324520 + x_324521;
            
            local_acc_324587 = defunc_1_op_res_324522;
        }
        // Load accum params
        {
            x_324523 = local_acc_324588;
        }
        // Load next params
        {
            x_324524 = defunc_1_f_res_324533;
        }
        // Red body
        {
            double defunc_1_op_res_324525 = x_324523 + x_324524;
            
            local_acc_324588 = defunc_1_op_res_324525;
        }
        // Load accum params
        {
            x_324526 = local_acc_324589;
        }
        // Load next params
        {
            x_324527 = defunc_1_f_res_324534;
        }
        // Red body
        {
            double defunc_1_op_res_324528 = x_324526 + x_324527;
            
            local_acc_324589 = defunc_1_op_res_324528;
        }
    }
    ((double *) reduce_stage_1_tid_res_arr_mem_324574.mem)[flat_tid_324512] =
        local_acc_324585;
    ((double *) reduce_stage_1_tid_res_arr_mem_324576.mem)[flat_tid_324512] =
        local_acc_324586;
    ((double *) reduce_stage_1_tid_res_arr_mem_324578.mem)[flat_tid_324512] =
        local_acc_324587;
    ((double *) reduce_stage_1_tid_res_arr_mem_324580.mem)[flat_tid_324512] =
        local_acc_324588;
    ((double *) reduce_stage_1_tid_res_arr_mem_324582.mem)[flat_tid_324512] =
        local_acc_324589;
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_338192_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_338192_end -
                 futhark_mc_segred_stage_1_parloop_338192_start;
        
        ctx->futhark_mc_segred_stage_1_parloop_338192_runs[tid]++;
        ctx->futhark_mc_segred_stage_1_parloop_338192_total_runtime[tid] +=
            elapsed;
        ctx->futhark_mc_segred_stage_1_parloop_338192_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segred_task_338185(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_324512 = tid;
    int num_tasks_324573 = info.nsubtasks;
    struct futhark_mc_task_338184 *futhark_mc_task_338184 =
                                  (struct futhark_mc_task_338184 *) args;
    struct futhark_context *ctx = futhark_mc_task_338184->ctx;
    uint64_t futhark_mc_segred_task_338185_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_task_338185_start = get_wall_time();
    
    struct memblock mem_324144 = {.desc ="mem_324144", .mem =
                                  futhark_mc_task_338184->free_mem_324144,
                                  .size =0, .references =NULL};
    struct memblock mem_324145 = {.desc ="mem_324145", .mem =
                                  futhark_mc_task_338184->free_mem_324145,
                                  .size =0, .references =NULL};
    double defunc_2_reduce_res_324170 =
           *futhark_mc_task_338184->retval_defunc_2_reduce_res_324170;
    double defunc_2_reduce_res_324171 =
           *futhark_mc_task_338184->retval_defunc_2_reduce_res_324171;
    double defunc_2_reduce_res_324172 =
           *futhark_mc_task_338184->retval_defunc_2_reduce_res_324172;
    double defunc_2_reduce_res_324173 =
           *futhark_mc_task_338184->retval_defunc_2_reduce_res_324173;
    double defunc_2_reduce_res_324174 =
           *futhark_mc_task_338184->retval_defunc_2_reduce_res_324174;
    struct memblock mem_324168 = {.desc ="mem_324168", .mem =
                                  futhark_mc_task_338184->retval_mem_324168,
                                  .size =0, .references =NULL};
    struct memblock mem_324169 = {.desc ="mem_324169", .mem =
                                  futhark_mc_task_338184->retval_mem_324169,
                                  .size =0, .references =NULL};
    size_t reduce_stage_1_tid_res_arr_mem_324574_cached_sizze_338186 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_324574 = NULL;
    size_t reduce_stage_1_tid_res_arr_mem_324576_cached_sizze_338187 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_324576 = NULL;
    size_t reduce_stage_1_tid_res_arr_mem_324578_cached_sizze_338188 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_324578 = NULL;
    size_t reduce_stage_1_tid_res_arr_mem_324580_cached_sizze_338189 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_324580 = NULL;
    size_t reduce_stage_1_tid_res_arr_mem_324582_cached_sizze_338190 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_324582 = NULL;
    
    if (reduce_stage_1_tid_res_arr_mem_324574_cached_sizze_338186 <
        (size_t) ((int64_t) 8 * num_tasks_324573)) {
        reduce_stage_1_tid_res_arr_mem_324574 =
            realloc(reduce_stage_1_tid_res_arr_mem_324574, (int64_t) 8 *
                    num_tasks_324573);
        reduce_stage_1_tid_res_arr_mem_324574_cached_sizze_338186 =
            (int64_t) 8 * num_tasks_324573;
    }
    if (reduce_stage_1_tid_res_arr_mem_324576_cached_sizze_338187 <
        (size_t) ((int64_t) 8 * num_tasks_324573)) {
        reduce_stage_1_tid_res_arr_mem_324576 =
            realloc(reduce_stage_1_tid_res_arr_mem_324576, (int64_t) 8 *
                    num_tasks_324573);
        reduce_stage_1_tid_res_arr_mem_324576_cached_sizze_338187 =
            (int64_t) 8 * num_tasks_324573;
    }
    if (reduce_stage_1_tid_res_arr_mem_324578_cached_sizze_338188 <
        (size_t) ((int64_t) 8 * num_tasks_324573)) {
        reduce_stage_1_tid_res_arr_mem_324578 =
            realloc(reduce_stage_1_tid_res_arr_mem_324578, (int64_t) 8 *
                    num_tasks_324573);
        reduce_stage_1_tid_res_arr_mem_324578_cached_sizze_338188 =
            (int64_t) 8 * num_tasks_324573;
    }
    if (reduce_stage_1_tid_res_arr_mem_324580_cached_sizze_338189 <
        (size_t) ((int64_t) 8 * num_tasks_324573)) {
        reduce_stage_1_tid_res_arr_mem_324580 =
            realloc(reduce_stage_1_tid_res_arr_mem_324580, (int64_t) 8 *
                    num_tasks_324573);
        reduce_stage_1_tid_res_arr_mem_324580_cached_sizze_338189 =
            (int64_t) 8 * num_tasks_324573;
    }
    if (reduce_stage_1_tid_res_arr_mem_324582_cached_sizze_338190 <
        (size_t) ((int64_t) 8 * num_tasks_324573)) {
        reduce_stage_1_tid_res_arr_mem_324582 =
            realloc(reduce_stage_1_tid_res_arr_mem_324582, (int64_t) 8 *
                    num_tasks_324573);
        reduce_stage_1_tid_res_arr_mem_324582_cached_sizze_338190 =
            (int64_t) 8 * num_tasks_324573;
    }
    
    int64_t iter_324584;
    struct futhark_mc_segred_stage_1_parloop_struct_338191
    futhark_mc_segred_stage_1_parloop_struct_338191;
    
    futhark_mc_segred_stage_1_parloop_struct_338191.ctx = ctx;
    futhark_mc_segred_stage_1_parloop_struct_338191.free_mem_324144 =
        mem_324144.mem;
    futhark_mc_segred_stage_1_parloop_struct_338191.free_mem_324145 =
        mem_324145.mem;
    futhark_mc_segred_stage_1_parloop_struct_338191.free_mem_324168 =
        mem_324168.mem;
    futhark_mc_segred_stage_1_parloop_struct_338191.free_mem_324169 =
        mem_324169.mem;
    futhark_mc_segred_stage_1_parloop_struct_338191.free_reduce_stage_1_tid_res_arr_mem_324574 =
        reduce_stage_1_tid_res_arr_mem_324574;
    futhark_mc_segred_stage_1_parloop_struct_338191.free_reduce_stage_1_tid_res_arr_mem_324576 =
        reduce_stage_1_tid_res_arr_mem_324576;
    futhark_mc_segred_stage_1_parloop_struct_338191.free_reduce_stage_1_tid_res_arr_mem_324578 =
        reduce_stage_1_tid_res_arr_mem_324578;
    futhark_mc_segred_stage_1_parloop_struct_338191.free_reduce_stage_1_tid_res_arr_mem_324580 =
        reduce_stage_1_tid_res_arr_mem_324580;
    futhark_mc_segred_stage_1_parloop_struct_338191.free_reduce_stage_1_tid_res_arr_mem_324582 =
        reduce_stage_1_tid_res_arr_mem_324582;
    
    struct scheduler_parloop futhark_mc_segred_stage_1_parloop_338192_task;
    
    futhark_mc_segred_stage_1_parloop_338192_task.name =
        "futhark_mc_segred_stage_1_parloop_338192";
    futhark_mc_segred_stage_1_parloop_338192_task.fn =
        futhark_mc_segred_stage_1_parloop_338192;
    futhark_mc_segred_stage_1_parloop_338192_task.args =
        &futhark_mc_segred_stage_1_parloop_struct_338191;
    futhark_mc_segred_stage_1_parloop_338192_task.iterations = iterations;
    futhark_mc_segred_stage_1_parloop_338192_task.info = info;
    
    uint64_t futhark_mc_segred_stage_1_parloop_338192_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_338192_total_start = get_wall_time();
    
    int futhark_mc_segred_stage_1_parloop_338192_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segred_stage_1_parloop_338192_task);
    
    if (futhark_mc_segred_stage_1_parloop_338192_err != 0) {
        err = futhark_mc_segred_stage_1_parloop_338192_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_338192_total_end =
                 get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_338192_total_end -
                 futhark_mc_segred_stage_1_parloop_338192_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338192_total_runs,
                           1, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338192_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338192_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    // neutral-initialise the output
    {
        defunc_2_reduce_res_324170 = 0.0;
        defunc_2_reduce_res_324171 = 0.0;
        defunc_2_reduce_res_324172 = 0.0;
        defunc_2_reduce_res_324173 = 0.0;
        defunc_2_reduce_res_324174 = 0.0;
    }
    
    double x_324590;
    double x_324591;
    double x_324593;
    double x_324594;
    double x_324596;
    double x_324597;
    double x_324599;
    double x_324600;
    double x_324602;
    double x_324603;
    
    for (int32_t i_324605 = 0; i_324605 < num_tasks_324573; i_324605++) {
        flat_tid_324512 = i_324605;
        // Apply main thread reduction
        {
            // load acc params
            {
                x_324590 = defunc_2_reduce_res_324170;
            }
            // load next params
            {
                x_324591 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_324574)[flat_tid_324512];
            }
            // red body
            {
                double defunc_1_op_res_324592 = x_324590 + x_324591;
                
                defunc_2_reduce_res_324170 = defunc_1_op_res_324592;
            }
            // load acc params
            {
                x_324593 = defunc_2_reduce_res_324171;
            }
            // load next params
            {
                x_324594 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_324576)[flat_tid_324512];
            }
            // red body
            {
                double defunc_1_op_res_324595 = x_324593 + x_324594;
                
                defunc_2_reduce_res_324171 = defunc_1_op_res_324595;
            }
            // load acc params
            {
                x_324596 = defunc_2_reduce_res_324172;
            }
            // load next params
            {
                x_324597 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_324578)[flat_tid_324512];
            }
            // red body
            {
                double defunc_1_op_res_324598 = x_324596 + x_324597;
                
                defunc_2_reduce_res_324172 = defunc_1_op_res_324598;
            }
            // load acc params
            {
                x_324599 = defunc_2_reduce_res_324173;
            }
            // load next params
            {
                x_324600 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_324580)[flat_tid_324512];
            }
            // red body
            {
                double defunc_1_op_res_324601 = x_324599 + x_324600;
                
                defunc_2_reduce_res_324173 = defunc_1_op_res_324601;
            }
            // load acc params
            {
                x_324602 = defunc_2_reduce_res_324174;
            }
            // load next params
            {
                x_324603 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_324582)[flat_tid_324512];
            }
            // red body
            {
                double defunc_1_op_res_324604 = x_324602 + x_324603;
                
                defunc_2_reduce_res_324174 = defunc_1_op_res_324604;
            }
        }
    }
    
  cleanup:
    {
        free(reduce_stage_1_tid_res_arr_mem_324574);
        free(reduce_stage_1_tid_res_arr_mem_324576);
        free(reduce_stage_1_tid_res_arr_mem_324578);
        free(reduce_stage_1_tid_res_arr_mem_324580);
        free(reduce_stage_1_tid_res_arr_mem_324582);
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_task_338185_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_task_338185_end -
                 futhark_mc_segred_task_338185_start;
        
        ctx->futhark_mc_segred_task_338185_runs[tid]++;
        ctx->futhark_mc_segred_task_338185_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segred_task_338185_iter[tid] += iterations;
    }
    if (err == 0) {
        *futhark_mc_task_338184->retval_defunc_2_reduce_res_324170 =
            defunc_2_reduce_res_324170;
        *futhark_mc_task_338184->retval_defunc_2_reduce_res_324171 =
            defunc_2_reduce_res_324171;
        *futhark_mc_task_338184->retval_defunc_2_reduce_res_324172 =
            defunc_2_reduce_res_324172;
        *futhark_mc_task_338184->retval_defunc_2_reduce_res_324173 =
            defunc_2_reduce_res_324173;
        *futhark_mc_task_338184->retval_defunc_2_reduce_res_324174 =
            defunc_2_reduce_res_324174;
        futhark_mc_task_338184->retval_mem_324168 = mem_324168.mem;
        futhark_mc_task_338184->retval_mem_324169 = mem_324169.mem;
    }
    return err;
}
struct futhark_mc_task_338193 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_gtid_301865;
    unsigned char *free_mem_313366;
    int64_t free_gtid_323571;
    int64_t free_x_323572;
    int64_t free_x_324132;
    unsigned char *free_mem_324145;
    unsigned char *free_mem_324168;
    unsigned char *free_mem_324169;
    double free_a12_324225;
    double free_b12_324226;
    double free_c12_324227;
    double free_b2_324228;
    double free_c2_324229;
    double *retval_defunc_2_reduce_res_324230;
    double *retval_defunc_2_reduce_res_324231;
};
struct futhark_mc_segred_stage_1_parloop_struct_338197 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_gtid_301865;
    unsigned char *free_mem_313366;
    int64_t free_gtid_323571;
    int64_t free_x_323572;
    int64_t free_x_324132;
    unsigned char *free_mem_324145;
    unsigned char *free_mem_324168;
    unsigned char *free_mem_324169;
    double free_a12_324225;
    double free_b12_324226;
    double free_c12_324227;
    double free_b2_324228;
    double free_c2_324229;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_324607;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_324609;
};
static int futhark_mc_segred_stage_1_parloop_338198(void *args, int64_t start,
                                                    int64_t end,
                                                    int flat_tid_324535,
                                                    int tid)
{
    int err = 0;
    struct futhark_mc_segred_stage_1_parloop_struct_338197
    *futhark_mc_segred_stage_1_parloop_struct_338197 =
    (struct futhark_mc_segred_stage_1_parloop_struct_338197 *) args;
    struct futhark_context *ctx =
                           futhark_mc_segred_stage_1_parloop_struct_338197->ctx;
    uint64_t futhark_mc_segred_stage_1_parloop_338198_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_338198_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segred_stage_1_parloop_struct_338197->free_n_p_292677;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segred_stage_1_parloop_struct_338197->free_defunc_0_f_res_292820;
    int64_t gtid_301865 =
            futhark_mc_segred_stage_1_parloop_struct_338197->free_gtid_301865;
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_338197->free_mem_313366,
                                  .size =0, .references =NULL};
    int64_t gtid_323571 =
            futhark_mc_segred_stage_1_parloop_struct_338197->free_gtid_323571;
    int64_t x_323572 =
            futhark_mc_segred_stage_1_parloop_struct_338197->free_x_323572;
    int64_t x_324132 =
            futhark_mc_segred_stage_1_parloop_struct_338197->free_x_324132;
    struct memblock mem_324145 = {.desc ="mem_324145", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_338197->free_mem_324145,
                                  .size =0, .references =NULL};
    struct memblock mem_324168 = {.desc ="mem_324168", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_338197->free_mem_324168,
                                  .size =0, .references =NULL};
    struct memblock mem_324169 = {.desc ="mem_324169", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_338197->free_mem_324169,
                                  .size =0, .references =NULL};
    double a12_324225 =
           futhark_mc_segred_stage_1_parloop_struct_338197->free_a12_324225;
    double b12_324226 =
           futhark_mc_segred_stage_1_parloop_struct_338197->free_b12_324226;
    double c12_324227 =
           futhark_mc_segred_stage_1_parloop_struct_338197->free_c12_324227;
    double b2_324228 =
           futhark_mc_segred_stage_1_parloop_struct_338197->free_b2_324228;
    double c2_324229 =
           futhark_mc_segred_stage_1_parloop_struct_338197->free_c2_324229;
    struct memblock reduce_stage_1_tid_res_arr_mem_324607 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_324607",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338197->free_reduce_stage_1_tid_res_arr_mem_324607,
                                                             .size =0,
                                                             .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_324609 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_324609",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338197->free_reduce_stage_1_tid_res_arr_mem_324609,
                                                             .size =0,
                                                             .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_324611 = start;
    double x_324537;
    double x_324538;
    double x_324540;
    double x_324541;
    double local_acc_324612 = 0.0;
    double local_acc_324613 = 0.0;
    
    for (; iter_324611 < end; iter_324611++) {
        int64_t gtid_324536 = iter_324611;
        double x_324543;
        
        x_324543 = ((double *) mem_324145.mem)[gtid_324536];
        
        double x_324544;
        
        x_324544 = ((double *) mem_324169.mem)[gtid_324536];
        
        double x_324545;
        
        x_324545 = ((double *) mem_324168.mem)[gtid_324536];
        
        bool cond_324546 = sle64(x_323572, gtid_324536);
        double defunc_0_f_res_324547;
        
        if (cond_324546) {
            defunc_0_f_res_324547 = 0.0;
        } else {
            int64_t i_324548 = add64(x_324132, gtid_324536);
            double defunc_0_add_arg_324549;
            
            defunc_0_add_arg_324549 = ((double *) mem_313366.mem)[gtid_301865 *
                                                                  (defunc_0_f_res_292820 *
                                                                   n_p_292677) +
                                                                  gtid_323571 *
                                                                  defunc_0_f_res_292820 +
                                                                  i_324548];
            defunc_0_f_res_324547 = defunc_0_add_arg_324549;
        }
        
        double x_324550 = a12_324225 * x_324543;
        double y_324551 = b12_324226 * x_324544;
        double x_324552 = x_324550 + y_324551;
        double y_324553 = c12_324227 * x_324545;
        double x_324554 = x_324552 + y_324553;
        double defunc_9_fit_fun_res_324555 = defunc_0_f_res_324547 * x_324554;
        double x_324556 = b12_324226 * x_324543;
        double y_324557 = b2_324228 * x_324544;
        double x_324558 = x_324556 + y_324557;
        double y_324559 = c2_324229 * x_324545;
        double x_324560 = x_324558 + y_324559;
        double defunc_9_slope_fun_res_324561 = defunc_0_f_res_324547 * x_324560;
        
        // save map-out results
        { }
        // Load accum params
        {
            x_324537 = local_acc_324612;
        }
        // Load next params
        {
            x_324538 = defunc_9_fit_fun_res_324555;
        }
        // Red body
        {
            double defunc_1_op_res_324539 = x_324537 + x_324538;
            
            local_acc_324612 = defunc_1_op_res_324539;
        }
        // Load accum params
        {
            x_324540 = local_acc_324613;
        }
        // Load next params
        {
            x_324541 = defunc_9_slope_fun_res_324561;
        }
        // Red body
        {
            double defunc_1_op_res_324542 = x_324540 + x_324541;
            
            local_acc_324613 = defunc_1_op_res_324542;
        }
    }
    ((double *) reduce_stage_1_tid_res_arr_mem_324607.mem)[flat_tid_324535] =
        local_acc_324612;
    ((double *) reduce_stage_1_tid_res_arr_mem_324609.mem)[flat_tid_324535] =
        local_acc_324613;
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_338198_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_338198_end -
                 futhark_mc_segred_stage_1_parloop_338198_start;
        
        ctx->futhark_mc_segred_stage_1_parloop_338198_runs[tid]++;
        ctx->futhark_mc_segred_stage_1_parloop_338198_total_runtime[tid] +=
            elapsed;
        ctx->futhark_mc_segred_stage_1_parloop_338198_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segred_task_338194(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_324535 = tid;
    int num_tasks_324606 = info.nsubtasks;
    struct futhark_mc_task_338193 *futhark_mc_task_338193 =
                                  (struct futhark_mc_task_338193 *) args;
    struct futhark_context *ctx = futhark_mc_task_338193->ctx;
    uint64_t futhark_mc_segred_task_338194_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_task_338194_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_338193->free_n_p_292677;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_338193->free_defunc_0_f_res_292820;
    int64_t gtid_301865 = futhark_mc_task_338193->free_gtid_301865;
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_task_338193->free_mem_313366,
                                  .size =0, .references =NULL};
    int64_t gtid_323571 = futhark_mc_task_338193->free_gtid_323571;
    int64_t x_323572 = futhark_mc_task_338193->free_x_323572;
    int64_t x_324132 = futhark_mc_task_338193->free_x_324132;
    struct memblock mem_324145 = {.desc ="mem_324145", .mem =
                                  futhark_mc_task_338193->free_mem_324145,
                                  .size =0, .references =NULL};
    struct memblock mem_324168 = {.desc ="mem_324168", .mem =
                                  futhark_mc_task_338193->free_mem_324168,
                                  .size =0, .references =NULL};
    struct memblock mem_324169 = {.desc ="mem_324169", .mem =
                                  futhark_mc_task_338193->free_mem_324169,
                                  .size =0, .references =NULL};
    double a12_324225 = futhark_mc_task_338193->free_a12_324225;
    double b12_324226 = futhark_mc_task_338193->free_b12_324226;
    double c12_324227 = futhark_mc_task_338193->free_c12_324227;
    double b2_324228 = futhark_mc_task_338193->free_b2_324228;
    double c2_324229 = futhark_mc_task_338193->free_c2_324229;
    double defunc_2_reduce_res_324230 =
           *futhark_mc_task_338193->retval_defunc_2_reduce_res_324230;
    double defunc_2_reduce_res_324231 =
           *futhark_mc_task_338193->retval_defunc_2_reduce_res_324231;
    size_t reduce_stage_1_tid_res_arr_mem_324607_cached_sizze_338195 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_324607 = NULL;
    size_t reduce_stage_1_tid_res_arr_mem_324609_cached_sizze_338196 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_324609 = NULL;
    
    if (reduce_stage_1_tid_res_arr_mem_324607_cached_sizze_338195 <
        (size_t) ((int64_t) 8 * num_tasks_324606)) {
        reduce_stage_1_tid_res_arr_mem_324607 =
            realloc(reduce_stage_1_tid_res_arr_mem_324607, (int64_t) 8 *
                    num_tasks_324606);
        reduce_stage_1_tid_res_arr_mem_324607_cached_sizze_338195 =
            (int64_t) 8 * num_tasks_324606;
    }
    if (reduce_stage_1_tid_res_arr_mem_324609_cached_sizze_338196 <
        (size_t) ((int64_t) 8 * num_tasks_324606)) {
        reduce_stage_1_tid_res_arr_mem_324609 =
            realloc(reduce_stage_1_tid_res_arr_mem_324609, (int64_t) 8 *
                    num_tasks_324606);
        reduce_stage_1_tid_res_arr_mem_324609_cached_sizze_338196 =
            (int64_t) 8 * num_tasks_324606;
    }
    
    int64_t iter_324611;
    struct futhark_mc_segred_stage_1_parloop_struct_338197
    futhark_mc_segred_stage_1_parloop_struct_338197;
    
    futhark_mc_segred_stage_1_parloop_struct_338197.ctx = ctx;
    futhark_mc_segred_stage_1_parloop_struct_338197.free_n_p_292677 =
        n_p_292677;
    futhark_mc_segred_stage_1_parloop_struct_338197.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segred_stage_1_parloop_struct_338197.free_gtid_301865 =
        gtid_301865;
    futhark_mc_segred_stage_1_parloop_struct_338197.free_mem_313366 =
        mem_313366.mem;
    futhark_mc_segred_stage_1_parloop_struct_338197.free_gtid_323571 =
        gtid_323571;
    futhark_mc_segred_stage_1_parloop_struct_338197.free_x_323572 = x_323572;
    futhark_mc_segred_stage_1_parloop_struct_338197.free_x_324132 = x_324132;
    futhark_mc_segred_stage_1_parloop_struct_338197.free_mem_324145 =
        mem_324145.mem;
    futhark_mc_segred_stage_1_parloop_struct_338197.free_mem_324168 =
        mem_324168.mem;
    futhark_mc_segred_stage_1_parloop_struct_338197.free_mem_324169 =
        mem_324169.mem;
    futhark_mc_segred_stage_1_parloop_struct_338197.free_a12_324225 =
        a12_324225;
    futhark_mc_segred_stage_1_parloop_struct_338197.free_b12_324226 =
        b12_324226;
    futhark_mc_segred_stage_1_parloop_struct_338197.free_c12_324227 =
        c12_324227;
    futhark_mc_segred_stage_1_parloop_struct_338197.free_b2_324228 = b2_324228;
    futhark_mc_segred_stage_1_parloop_struct_338197.free_c2_324229 = c2_324229;
    futhark_mc_segred_stage_1_parloop_struct_338197.free_reduce_stage_1_tid_res_arr_mem_324607 =
        reduce_stage_1_tid_res_arr_mem_324607;
    futhark_mc_segred_stage_1_parloop_struct_338197.free_reduce_stage_1_tid_res_arr_mem_324609 =
        reduce_stage_1_tid_res_arr_mem_324609;
    
    struct scheduler_parloop futhark_mc_segred_stage_1_parloop_338198_task;
    
    futhark_mc_segred_stage_1_parloop_338198_task.name =
        "futhark_mc_segred_stage_1_parloop_338198";
    futhark_mc_segred_stage_1_parloop_338198_task.fn =
        futhark_mc_segred_stage_1_parloop_338198;
    futhark_mc_segred_stage_1_parloop_338198_task.args =
        &futhark_mc_segred_stage_1_parloop_struct_338197;
    futhark_mc_segred_stage_1_parloop_338198_task.iterations = iterations;
    futhark_mc_segred_stage_1_parloop_338198_task.info = info;
    
    uint64_t futhark_mc_segred_stage_1_parloop_338198_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_338198_total_start = get_wall_time();
    
    int futhark_mc_segred_stage_1_parloop_338198_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segred_stage_1_parloop_338198_task);
    
    if (futhark_mc_segred_stage_1_parloop_338198_err != 0) {
        err = futhark_mc_segred_stage_1_parloop_338198_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_338198_total_end =
                 get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_338198_total_end -
                 futhark_mc_segred_stage_1_parloop_338198_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338198_total_runs,
                           1, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338198_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338198_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    // neutral-initialise the output
    {
        defunc_2_reduce_res_324230 = 0.0;
        defunc_2_reduce_res_324231 = 0.0;
    }
    
    double x_324614;
    double x_324615;
    double x_324617;
    double x_324618;
    
    for (int32_t i_324620 = 0; i_324620 < num_tasks_324606; i_324620++) {
        flat_tid_324535 = i_324620;
        // Apply main thread reduction
        {
            // load acc params
            {
                x_324614 = defunc_2_reduce_res_324230;
            }
            // load next params
            {
                x_324615 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_324607)[flat_tid_324535];
            }
            // red body
            {
                double defunc_1_op_res_324616 = x_324614 + x_324615;
                
                defunc_2_reduce_res_324230 = defunc_1_op_res_324616;
            }
            // load acc params
            {
                x_324617 = defunc_2_reduce_res_324231;
            }
            // load next params
            {
                x_324618 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_324609)[flat_tid_324535];
            }
            // red body
            {
                double defunc_1_op_res_324619 = x_324617 + x_324618;
                
                defunc_2_reduce_res_324231 = defunc_1_op_res_324619;
            }
        }
    }
    
  cleanup:
    {
        free(reduce_stage_1_tid_res_arr_mem_324607);
        free(reduce_stage_1_tid_res_arr_mem_324609);
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_task_338194_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_task_338194_end -
                 futhark_mc_segred_task_338194_start;
        
        ctx->futhark_mc_segred_task_338194_runs[tid]++;
        ctx->futhark_mc_segred_task_338194_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segred_task_338194_iter[tid] += iterations;
    }
    if (err == 0) {
        *futhark_mc_task_338193->retval_defunc_2_reduce_res_324230 =
            defunc_2_reduce_res_324230;
        *futhark_mc_task_338193->retval_defunc_2_reduce_res_324231 =
            defunc_2_reduce_res_324231;
    }
    return err;
}
static int futhark_mc_segmap_parloop_338175(void *args, int64_t start,
                                            int64_t end, int flat_tid_324130,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338174
    *futhark_mc_segmap_parloop_struct_338174 =
    (struct futhark_mc_segmap_parloop_struct_338174 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338174->ctx;
    uint64_t futhark_mc_segmap_parloop_338175_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338175_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segmap_parloop_struct_338174->free_n_p_292677;
    int64_t q_s_292678 =
            futhark_mc_segmap_parloop_struct_338174->free_q_s_292678;
    int64_t jump_s_292684 =
            futhark_mc_segmap_parloop_struct_338174->free_jump_s_292684;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segmap_parloop_struct_338174->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_segmap_parloop_struct_338174->free_pad_css_len_292821;
    int64_t s_n_m_292825 =
            futhark_mc_segmap_parloop_struct_338174->free_s_n_m_292825;
    int64_t gtid_301865 =
            futhark_mc_segmap_parloop_struct_338174->free_gtid_301865;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_segmap_parloop_struct_338174->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_segmap_parloop_struct_338174->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_segmap_parloop_struct_338174->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_segmap_parloop_struct_338174->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_segmap_parloop_struct_338174->free_mem_313371,
                                  .size =0, .references =NULL};
    int64_t bytes_314123 =
            futhark_mc_segmap_parloop_struct_338174->free_bytes_314123;
    int64_t gtid_323571 =
            futhark_mc_segmap_parloop_struct_338174->free_gtid_323571;
    int64_t x_323572 = futhark_mc_segmap_parloop_struct_338174->free_x_323572;
    struct memblock mem_323573 = {.desc ="mem_323573", .mem =
                                  futhark_mc_segmap_parloop_struct_338174->free_mem_323573,
                                  .size =0, .references =NULL};
    struct memblock mem_323574 = {.desc ="mem_323574", .mem =
                                  futhark_mc_segmap_parloop_struct_338174->free_mem_323574,
                                  .size =0, .references =NULL};
    size_t mem_324144_cached_sizze_338176 = 0;
    unsigned char *mem_324144 = NULL;
    size_t mem_324145_cached_sizze_338177 = 0;
    unsigned char *mem_324145 = NULL;
    size_t mem_324168_cached_sizze_338178 = 0;
    unsigned char *mem_324168 = NULL;
    size_t mem_324169_cached_sizze_338179 = 0;
    unsigned char *mem_324169 = NULL;
    int64_t iterations = end - start;
    int64_t iter_324483 = start;
    
    if (mem_324144_cached_sizze_338176 < (size_t) bytes_314123) {
        mem_324144 = realloc(mem_324144, bytes_314123);
        mem_324144_cached_sizze_338176 = bytes_314123;
    }
    if (mem_324145_cached_sizze_338177 < (size_t) bytes_314123) {
        mem_324145 = realloc(mem_324145, bytes_314123);
        mem_324145_cached_sizze_338177 = bytes_314123;
    }
    if (mem_324168_cached_sizze_338178 < (size_t) bytes_314123) {
        mem_324168 = realloc(mem_324168, bytes_314123);
        mem_324168_cached_sizze_338178 = bytes_314123;
    }
    if (mem_324169_cached_sizze_338179 < (size_t) bytes_314123) {
        mem_324169 = realloc(mem_324169, bytes_314123);
        mem_324169_cached_sizze_338179 = bytes_314123;
    }
    for (; iter_324483 < end; iter_324483++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_324562 = s_n_m_292825;
        int64_t gtid_324131 = iter_324483;
        int64_t remnant_324563 = iter_324483 - gtid_324131;
        int64_t x_324132;
        
        x_324132 = ((int64_t *) mem_313018.mem)[gtid_301865 * (s_n_m_292825 *
                                                               n_p_292677) +
                                                gtid_323571 * s_n_m_292825 +
                                                gtid_324131];
        
        double x_324133;
        
        x_324133 = ((double *) mem_313023.mem)[gtid_301865 * (s_n_m_292825 *
                                                              n_p_292677) +
                                               gtid_323571 * s_n_m_292825 +
                                               gtid_324131];
        
        bool cond_324134 = gtid_324131 == (int64_t) 0;
        int64_t defunc_0_m_fun_res_324135;
        
        if (cond_324134) {
            defunc_0_m_fun_res_324135 = (int64_t) 0;
        } else {
            int64_t y_324484 = sub64(s_n_m_292825, (int64_t) 1);
            bool cond_324485 = gtid_324131 == y_324484;
            int64_t defunc_0_m_fun_res_f_res_324486;
            
            if (cond_324485) {
                int64_t defunc_0_m_fun_res_f_res_t_res_324487 =
                        sub64(pad_css_len_292821, (int64_t) 1);
                
                defunc_0_m_fun_res_f_res_324486 =
                    defunc_0_m_fun_res_f_res_t_res_324487;
            } else {
                int64_t x_324488 = sub64(gtid_324131, (int64_t) 1);
                int64_t x_324489 = mul64(jump_s_292684, x_324488);
                int64_t min_arg_324490 = add64((int64_t) 1, x_324489);
                int64_t min_res_324491 = smin64(defunc_0_f_res_292820,
                                                min_arg_324490);
                
                defunc_0_m_fun_res_f_res_324486 = min_res_324491;
            }
            defunc_0_m_fun_res_324135 = defunc_0_m_fun_res_f_res_324486;
        }
        
        int64_t flat_tid_324492 = (int64_t) 0;
        int32_t num_tasks_324564;
        struct futhark_mc_task_338180 futhark_mc_task_338180;
        
        futhark_mc_task_338180.ctx = ctx;
        futhark_mc_task_338180.free_n_p_292677 = n_p_292677;
        futhark_mc_task_338180.free_q_s_292678 = q_s_292678;
        futhark_mc_task_338180.free_defunc_0_f_res_292820 =
            defunc_0_f_res_292820;
        futhark_mc_task_338180.free_gtid_301865 = gtid_301865;
        futhark_mc_task_338180.free_mem_312838 = mem_312838.mem;
        futhark_mc_task_338180.free_mem_313371 = mem_313371.mem;
        futhark_mc_task_338180.free_gtid_323571 = gtid_323571;
        futhark_mc_task_338180.free_x_323572 = x_323572;
        futhark_mc_task_338180.free_x_324132 = x_324132;
        futhark_mc_task_338180.free_x_324133 = x_324133;
        futhark_mc_task_338180.free_defunc_0_m_fun_res_324135 =
            defunc_0_m_fun_res_324135;
        futhark_mc_task_338180.free_mem_324144 = mem_324144;
        futhark_mc_task_338180.free_mem_324145 = mem_324145;
        
        struct scheduler_segop futhark_mc_task_338180_task;
        
        futhark_mc_task_338180_task.args = &futhark_mc_task_338180;
        futhark_mc_task_338180_task.top_level_fn =
            futhark_mc_segmap_task_338181;
        futhark_mc_task_338180_task.name = "futhark_mc_segmap_task_338181";
        futhark_mc_task_338180_task.iterations = q_s_292678;
        futhark_mc_task_338180_task.task_time =
            &ctx->futhark_mc_segmap_task_338181_total_time;
        futhark_mc_task_338180_task.task_iter =
            &ctx->futhark_mc_segmap_task_338181_total_iter;
        futhark_mc_task_338180_task.sched = STATIC;
        futhark_mc_task_338180_task.nested_fn = NULL;
        
        int futhark_mc_segmap_task_338181_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_338180_task);
        
        if (futhark_mc_segmap_task_338181_err != 0) {
            ;
            err = futhark_mc_segmap_task_338181_err;
            goto cleanup;
        }
        
        double defunc_2_reduce_res_324170;
        double defunc_2_reduce_res_324171;
        double defunc_2_reduce_res_324172;
        double defunc_2_reduce_res_324173;
        double defunc_2_reduce_res_324174;
        int64_t flat_tid_324512 = (int64_t) 0;
        int32_t num_tasks_324573;
        
        defunc_2_reduce_res_324170 = 0.0;
        defunc_2_reduce_res_324171 = 0.0;
        defunc_2_reduce_res_324172 = 0.0;
        defunc_2_reduce_res_324173 = 0.0;
        defunc_2_reduce_res_324174 = 0.0;
        
        struct futhark_mc_task_338184 futhark_mc_task_338184;
        
        futhark_mc_task_338184.ctx = ctx;
        futhark_mc_task_338184.free_mem_324144 = mem_324144;
        futhark_mc_task_338184.free_mem_324145 = mem_324145;
        futhark_mc_task_338184.retval_defunc_2_reduce_res_324170 =
            &defunc_2_reduce_res_324170;
        futhark_mc_task_338184.retval_defunc_2_reduce_res_324171 =
            &defunc_2_reduce_res_324171;
        futhark_mc_task_338184.retval_defunc_2_reduce_res_324172 =
            &defunc_2_reduce_res_324172;
        futhark_mc_task_338184.retval_defunc_2_reduce_res_324173 =
            &defunc_2_reduce_res_324173;
        futhark_mc_task_338184.retval_defunc_2_reduce_res_324174 =
            &defunc_2_reduce_res_324174;
        futhark_mc_task_338184.retval_mem_324168 = mem_324168;
        futhark_mc_task_338184.retval_mem_324169 = mem_324169;
        
        struct scheduler_segop futhark_mc_task_338184_task;
        
        futhark_mc_task_338184_task.args = &futhark_mc_task_338184;
        futhark_mc_task_338184_task.top_level_fn =
            futhark_mc_segred_task_338185;
        futhark_mc_task_338184_task.name = "futhark_mc_segred_task_338185";
        futhark_mc_task_338184_task.iterations = q_s_292678;
        futhark_mc_task_338184_task.task_time =
            &ctx->futhark_mc_segred_task_338185_total_time;
        futhark_mc_task_338184_task.task_iter =
            &ctx->futhark_mc_segred_task_338185_total_iter;
        futhark_mc_task_338184_task.sched = STATIC;
        futhark_mc_task_338184_task.nested_fn = NULL;
        
        int futhark_mc_segred_task_338185_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_338184_task);
        
        if (futhark_mc_segred_task_338185_err != 0) {
            ;
            err = futhark_mc_segred_task_338185_err;
            goto cleanup;
        }
        
        double a_324200 = 2.220446049250313e-16 + defunc_2_reduce_res_324170;
        double b_324201 = 2.220446049250313e-16 + defunc_2_reduce_res_324171;
        double c_324202 = 2.220446049250313e-16 + defunc_2_reduce_res_324172;
        double d_324203 = 2.220446049250313e-16 + defunc_2_reduce_res_324173;
        double e_324204 = 2.220446049250313e-16 + defunc_2_reduce_res_324174;
        double x_324205 = c_324202 * e_324204;
        double y_324206 = d_324203 * d_324203;
        double a12_324207 = x_324205 - y_324206;
        double x_324208 = c_324202 * d_324203;
        double y_324209 = b_324201 * e_324204;
        double b12_324210 = x_324208 - y_324209;
        double x_324211 = b_324201 * d_324203;
        double y_324212 = c_324202 * c_324202;
        double c12_324213 = x_324211 - y_324212;
        double x_324214 = a_324200 * e_324204;
        double b2_324215 = x_324214 - y_324212;
        double x_324216 = b_324201 * c_324202;
        double y_324217 = a_324200 * d_324203;
        double c2_324218 = x_324216 - y_324217;
        double x_324219 = a_324200 * a12_324207;
        double y_324220 = b_324201 * b12_324210;
        double x_324221 = x_324219 + y_324220;
        double y_324222 = c_324202 * c12_324213;
        double y_324223 = x_324221 + y_324222;
        double det_324224 = 1.0 / y_324223;
        double a12_324225 = a12_324207 * det_324224;
        double b12_324226 = b12_324210 * det_324224;
        double c12_324227 = c12_324213 * det_324224;
        double b2_324228 = b2_324215 * det_324224;
        double c2_324229 = c2_324218 * det_324224;
        double defunc_2_reduce_res_324230;
        double defunc_2_reduce_res_324231;
        int64_t flat_tid_324535 = (int64_t) 0;
        int32_t num_tasks_324606;
        
        defunc_2_reduce_res_324230 = 0.0;
        defunc_2_reduce_res_324231 = 0.0;
        
        struct futhark_mc_task_338193 futhark_mc_task_338193;
        
        futhark_mc_task_338193.ctx = ctx;
        futhark_mc_task_338193.free_n_p_292677 = n_p_292677;
        futhark_mc_task_338193.free_defunc_0_f_res_292820 =
            defunc_0_f_res_292820;
        futhark_mc_task_338193.free_gtid_301865 = gtid_301865;
        futhark_mc_task_338193.free_mem_313366 = mem_313366.mem;
        futhark_mc_task_338193.free_gtid_323571 = gtid_323571;
        futhark_mc_task_338193.free_x_323572 = x_323572;
        futhark_mc_task_338193.free_x_324132 = x_324132;
        futhark_mc_task_338193.free_mem_324145 = mem_324145;
        futhark_mc_task_338193.free_mem_324168 = mem_324168;
        futhark_mc_task_338193.free_mem_324169 = mem_324169;
        futhark_mc_task_338193.free_a12_324225 = a12_324225;
        futhark_mc_task_338193.free_b12_324226 = b12_324226;
        futhark_mc_task_338193.free_c12_324227 = c12_324227;
        futhark_mc_task_338193.free_b2_324228 = b2_324228;
        futhark_mc_task_338193.free_c2_324229 = c2_324229;
        futhark_mc_task_338193.retval_defunc_2_reduce_res_324230 =
            &defunc_2_reduce_res_324230;
        futhark_mc_task_338193.retval_defunc_2_reduce_res_324231 =
            &defunc_2_reduce_res_324231;
        
        struct scheduler_segop futhark_mc_task_338193_task;
        
        futhark_mc_task_338193_task.args = &futhark_mc_task_338193;
        futhark_mc_task_338193_task.top_level_fn =
            futhark_mc_segred_task_338194;
        futhark_mc_task_338193_task.name = "futhark_mc_segred_task_338194";
        futhark_mc_task_338193_task.iterations = q_s_292678;
        futhark_mc_task_338193_task.task_time =
            &ctx->futhark_mc_segred_task_338194_total_time;
        futhark_mc_task_338193_task.task_iter =
            &ctx->futhark_mc_segred_task_338194_total_iter;
        futhark_mc_task_338193_task.sched = STATIC;
        futhark_mc_task_338193_task.nested_fn = NULL;
        
        int futhark_mc_segred_task_338194_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_338193_task);
        
        if (futhark_mc_segred_task_338194_err != 0) {
            ;
            err = futhark_mc_segred_task_338194_err;
            goto cleanup;
        }
        ((double *) mem_323573.mem)[gtid_324131] = defunc_2_reduce_res_324230;
        ((double *) mem_323574.mem)[gtid_324131] = defunc_2_reduce_res_324231;
    }
    
  cleanup:
    { }
    free(mem_324144);
    free(mem_324145);
    free(mem_324168);
    free(mem_324169);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338175_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338175_end -
                 futhark_mc_segmap_parloop_338175_start;
        
        ctx->futhark_mc_segmap_parloop_338175_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338175_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338175_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_nested_task_338173(void *args, int64_t iterations,
                                         int tid, struct scheduler_info info)
{
    int err = 0;
    int flat_tid_324130 = tid;
    int num_tasks_324392 = info.nsubtasks;
    struct futhark_mc_task_338165 *futhark_mc_task_338165 =
                                  (struct futhark_mc_task_338165 *) args;
    struct futhark_context *ctx = futhark_mc_task_338165->ctx;
    uint64_t futhark_mc_segmap_nested_task_338173_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_nested_task_338173_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_338165->free_n_p_292677;
    int64_t q_s_292678 = futhark_mc_task_338165->free_q_s_292678;
    int64_t jump_s_292684 = futhark_mc_task_338165->free_jump_s_292684;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_338165->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_task_338165->free_pad_css_len_292821;
    int64_t s_n_m_292825 = futhark_mc_task_338165->free_s_n_m_292825;
    int64_t gtid_301865 = futhark_mc_task_338165->free_gtid_301865;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_task_338165->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_task_338165->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_task_338165->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_task_338165->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_task_338165->free_mem_313371,
                                  .size =0, .references =NULL};
    int64_t bytes_314123 = futhark_mc_task_338165->free_bytes_314123;
    int64_t gtid_323571 = futhark_mc_task_338165->free_gtid_323571;
    int64_t x_323572 = futhark_mc_task_338165->free_x_323572;
    struct memblock mem_323573 = {.desc ="mem_323573", .mem =
                                  futhark_mc_task_338165->free_mem_323573,
                                  .size =0, .references =NULL};
    struct memblock mem_323574 = {.desc ="mem_323574", .mem =
                                  futhark_mc_task_338165->free_mem_323574,
                                  .size =0, .references =NULL};
    int64_t iter_324483;
    struct futhark_mc_segmap_parloop_struct_338174
    futhark_mc_segmap_parloop_struct_338174;
    
    futhark_mc_segmap_parloop_struct_338174.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338174.free_n_p_292677 = n_p_292677;
    futhark_mc_segmap_parloop_struct_338174.free_q_s_292678 = q_s_292678;
    futhark_mc_segmap_parloop_struct_338174.free_jump_s_292684 = jump_s_292684;
    futhark_mc_segmap_parloop_struct_338174.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segmap_parloop_struct_338174.free_pad_css_len_292821 =
        pad_css_len_292821;
    futhark_mc_segmap_parloop_struct_338174.free_s_n_m_292825 = s_n_m_292825;
    futhark_mc_segmap_parloop_struct_338174.free_gtid_301865 = gtid_301865;
    futhark_mc_segmap_parloop_struct_338174.free_mem_312838 = mem_312838.mem;
    futhark_mc_segmap_parloop_struct_338174.free_mem_313018 = mem_313018.mem;
    futhark_mc_segmap_parloop_struct_338174.free_mem_313023 = mem_313023.mem;
    futhark_mc_segmap_parloop_struct_338174.free_mem_313366 = mem_313366.mem;
    futhark_mc_segmap_parloop_struct_338174.free_mem_313371 = mem_313371.mem;
    futhark_mc_segmap_parloop_struct_338174.free_bytes_314123 = bytes_314123;
    futhark_mc_segmap_parloop_struct_338174.free_gtid_323571 = gtid_323571;
    futhark_mc_segmap_parloop_struct_338174.free_x_323572 = x_323572;
    futhark_mc_segmap_parloop_struct_338174.free_mem_323573 = mem_323573.mem;
    futhark_mc_segmap_parloop_struct_338174.free_mem_323574 = mem_323574.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338175_task;
    
    futhark_mc_segmap_parloop_338175_task.name =
        "futhark_mc_segmap_parloop_338175";
    futhark_mc_segmap_parloop_338175_task.fn = futhark_mc_segmap_parloop_338175;
    futhark_mc_segmap_parloop_338175_task.args =
        &futhark_mc_segmap_parloop_struct_338174;
    futhark_mc_segmap_parloop_338175_task.iterations = iterations;
    futhark_mc_segmap_parloop_338175_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338175_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338175_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338175_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338175_task);
    
    if (futhark_mc_segmap_parloop_338175_err != 0) {
        err = futhark_mc_segmap_parloop_338175_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338175_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338175_total_end -
                 futhark_mc_segmap_parloop_338175_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338175_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338175_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338175_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_nested_task_338173_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_nested_task_338173_end -
                 futhark_mc_segmap_nested_task_338173_start;
        
        ctx->futhark_mc_segmap_nested_task_338173_runs[tid]++;
        ctx->futhark_mc_segmap_nested_task_338173_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_nested_task_338173_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
static int futhark_mc_segmap_parloop_338162(void *args, int64_t start,
                                            int64_t end, int flat_tid_323570,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338161
    *futhark_mc_segmap_parloop_struct_338161 =
    (struct futhark_mc_segmap_parloop_struct_338161 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338161->ctx;
    uint64_t futhark_mc_segmap_parloop_338162_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338162_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segmap_parloop_struct_338161->free_n_p_292677;
    int64_t q_s_292678 =
            futhark_mc_segmap_parloop_struct_338161->free_q_s_292678;
    int64_t jump_s_292684 =
            futhark_mc_segmap_parloop_struct_338161->free_jump_s_292684;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segmap_parloop_struct_338161->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_segmap_parloop_struct_338161->free_pad_css_len_292821;
    int64_t s_n_m_292825 =
            futhark_mc_segmap_parloop_struct_338161->free_s_n_m_292825;
    int64_t gtid_301865 =
            futhark_mc_segmap_parloop_struct_338161->free_gtid_301865;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_segmap_parloop_struct_338161->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_312842 = {.desc ="mem_312842", .mem =
                                  futhark_mc_segmap_parloop_struct_338161->free_mem_312842,
                                  .size =0, .references =NULL};
    int64_t bytes_312847 =
            futhark_mc_segmap_parloop_struct_338161->free_bytes_312847;
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_segmap_parloop_struct_338161->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_segmap_parloop_struct_338161->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_segmap_parloop_struct_338161->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_segmap_parloop_struct_338161->free_mem_313371,
                                  .size =0, .references =NULL};
    int64_t bytes_314123 =
            futhark_mc_segmap_parloop_struct_338161->free_bytes_314123;
    struct memblock mem_314293 = {.desc ="mem_314293", .mem =
                                  futhark_mc_segmap_parloop_struct_338161->free_mem_314293,
                                  .size =0, .references =NULL};
    struct memblock mem_314297 = {.desc ="mem_314297", .mem =
                                  futhark_mc_segmap_parloop_struct_338161->free_mem_314297,
                                  .size =0, .references =NULL};
    size_t mem_323573_cached_sizze_338163 = 0;
    unsigned char *mem_323573 = NULL;
    size_t mem_323574_cached_sizze_338164 = 0;
    unsigned char *mem_323574 = NULL;
    int64_t iterations = end - start;
    int64_t iter_324129 = start;
    
    if (mem_323573_cached_sizze_338163 < (size_t) bytes_312847) {
        mem_323573 = realloc(mem_323573, bytes_312847);
        mem_323573_cached_sizze_338163 = bytes_312847;
    }
    if (mem_323574_cached_sizze_338164 < (size_t) bytes_312847) {
        mem_323574 = realloc(mem_323574, bytes_312847);
        mem_323574_cached_sizze_338164 = bytes_312847;
    }
    for (; iter_324129 < end; iter_324129++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_324390 = n_p_292677;
        int64_t gtid_323571 = iter_324129;
        int64_t remnant_324391 = iter_324129 - gtid_323571;
        int64_t x_323572;
        
        x_323572 = ((int64_t *) mem_312842.mem)[gtid_301865 * n_p_292677 +
                                                gtid_323571];
        
        int64_t flat_tid_324259 = (int64_t) 0;
        int32_t num_tasks_324392;
        int64_t flat_tid_324130 = (int64_t) 0;
        struct futhark_mc_task_338165 futhark_mc_task_338165;
        
        futhark_mc_task_338165.ctx = ctx;
        futhark_mc_task_338165.free_n_p_292677 = n_p_292677;
        futhark_mc_task_338165.free_q_s_292678 = q_s_292678;
        futhark_mc_task_338165.free_jump_s_292684 = jump_s_292684;
        futhark_mc_task_338165.free_defunc_0_f_res_292820 =
            defunc_0_f_res_292820;
        futhark_mc_task_338165.free_pad_css_len_292821 = pad_css_len_292821;
        futhark_mc_task_338165.free_s_n_m_292825 = s_n_m_292825;
        futhark_mc_task_338165.free_gtid_301865 = gtid_301865;
        futhark_mc_task_338165.free_mem_312838 = mem_312838.mem;
        futhark_mc_task_338165.free_mem_313018 = mem_313018.mem;
        futhark_mc_task_338165.free_mem_313023 = mem_313023.mem;
        futhark_mc_task_338165.free_mem_313366 = mem_313366.mem;
        futhark_mc_task_338165.free_mem_313371 = mem_313371.mem;
        futhark_mc_task_338165.free_bytes_314123 = bytes_314123;
        futhark_mc_task_338165.free_gtid_323571 = gtid_323571;
        futhark_mc_task_338165.free_x_323572 = x_323572;
        futhark_mc_task_338165.free_mem_323573 = mem_323573;
        futhark_mc_task_338165.free_mem_323574 = mem_323574;
        
        struct scheduler_segop futhark_mc_task_338165_task;
        
        futhark_mc_task_338165_task.args = &futhark_mc_task_338165;
        futhark_mc_task_338165_task.top_level_fn =
            futhark_mc_segmap_task_338166;
        futhark_mc_task_338165_task.name = "futhark_mc_segmap_task_338166";
        futhark_mc_task_338165_task.iterations = s_n_m_292825;
        futhark_mc_task_338165_task.task_time =
            &ctx->futhark_mc_segmap_task_338166_total_time;
        futhark_mc_task_338165_task.task_iter =
            &ctx->futhark_mc_segmap_task_338166_total_iter;
        futhark_mc_task_338165_task.sched = STATIC;
        futhark_mc_task_338165_task.nested_fn =
            futhark_mc_segmap_nested_task_338173;
        
        int futhark_mc_segmap_task_338166_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_338165_task);
        
        if (futhark_mc_segmap_task_338166_err != 0) {
            ;
            err = futhark_mc_segmap_task_338166_err;
            goto cleanup;
        }
        if (s_n_m_292825 * (int64_t) 8 > 0)
            memmove(mem_314293.mem + gtid_323571 * s_n_m_292825 * (int64_t) 8,
                    mem_323573 + (int64_t) 0, s_n_m_292825 * (int64_t) 8);
        if (s_n_m_292825 * (int64_t) 8 > 0)
            memmove(mem_314297.mem + gtid_323571 * s_n_m_292825 * (int64_t) 8,
                    mem_323574 + (int64_t) 0, s_n_m_292825 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_323573);
    free(mem_323574);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338162_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338162_end -
                 futhark_mc_segmap_parloop_338162_start;
        
        ctx->futhark_mc_segmap_parloop_338162_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338162_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338162_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_nested_task_338160(void *args, int64_t iterations,
                                         int tid, struct scheduler_info info)
{
    int err = 0;
    int flat_tid_323570 = tid;
    int num_tasks_323982 = info.nsubtasks;
    struct futhark_mc_task_338150 *futhark_mc_task_338150 =
                                  (struct futhark_mc_task_338150 *) args;
    struct futhark_context *ctx = futhark_mc_task_338150->ctx;
    uint64_t futhark_mc_segmap_nested_task_338160_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_nested_task_338160_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_338150->free_n_p_292677;
    int64_t q_s_292678 = futhark_mc_task_338150->free_q_s_292678;
    int64_t jump_s_292684 = futhark_mc_task_338150->free_jump_s_292684;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_338150->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_task_338150->free_pad_css_len_292821;
    int64_t s_n_m_292825 = futhark_mc_task_338150->free_s_n_m_292825;
    int64_t gtid_301865 = futhark_mc_task_338150->free_gtid_301865;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_task_338150->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_312842 = {.desc ="mem_312842", .mem =
                                  futhark_mc_task_338150->free_mem_312842,
                                  .size =0, .references =NULL};
    int64_t bytes_312847 = futhark_mc_task_338150->free_bytes_312847;
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_task_338150->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_task_338150->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_task_338150->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_task_338150->free_mem_313371,
                                  .size =0, .references =NULL};
    int64_t bytes_314123 = futhark_mc_task_338150->free_bytes_314123;
    struct memblock mem_314293 = {.desc ="mem_314293", .mem =
                                  futhark_mc_task_338150->free_mem_314293,
                                  .size =0, .references =NULL};
    struct memblock mem_314297 = {.desc ="mem_314297", .mem =
                                  futhark_mc_task_338150->free_mem_314297,
                                  .size =0, .references =NULL};
    int64_t iter_324129;
    struct futhark_mc_segmap_parloop_struct_338161
    futhark_mc_segmap_parloop_struct_338161;
    
    futhark_mc_segmap_parloop_struct_338161.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338161.free_n_p_292677 = n_p_292677;
    futhark_mc_segmap_parloop_struct_338161.free_q_s_292678 = q_s_292678;
    futhark_mc_segmap_parloop_struct_338161.free_jump_s_292684 = jump_s_292684;
    futhark_mc_segmap_parloop_struct_338161.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segmap_parloop_struct_338161.free_pad_css_len_292821 =
        pad_css_len_292821;
    futhark_mc_segmap_parloop_struct_338161.free_s_n_m_292825 = s_n_m_292825;
    futhark_mc_segmap_parloop_struct_338161.free_gtid_301865 = gtid_301865;
    futhark_mc_segmap_parloop_struct_338161.free_mem_312838 = mem_312838.mem;
    futhark_mc_segmap_parloop_struct_338161.free_mem_312842 = mem_312842.mem;
    futhark_mc_segmap_parloop_struct_338161.free_bytes_312847 = bytes_312847;
    futhark_mc_segmap_parloop_struct_338161.free_mem_313018 = mem_313018.mem;
    futhark_mc_segmap_parloop_struct_338161.free_mem_313023 = mem_313023.mem;
    futhark_mc_segmap_parloop_struct_338161.free_mem_313366 = mem_313366.mem;
    futhark_mc_segmap_parloop_struct_338161.free_mem_313371 = mem_313371.mem;
    futhark_mc_segmap_parloop_struct_338161.free_bytes_314123 = bytes_314123;
    futhark_mc_segmap_parloop_struct_338161.free_mem_314293 = mem_314293.mem;
    futhark_mc_segmap_parloop_struct_338161.free_mem_314297 = mem_314297.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338162_task;
    
    futhark_mc_segmap_parloop_338162_task.name =
        "futhark_mc_segmap_parloop_338162";
    futhark_mc_segmap_parloop_338162_task.fn = futhark_mc_segmap_parloop_338162;
    futhark_mc_segmap_parloop_338162_task.args =
        &futhark_mc_segmap_parloop_struct_338161;
    futhark_mc_segmap_parloop_338162_task.iterations = iterations;
    futhark_mc_segmap_parloop_338162_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338162_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338162_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338162_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338162_task);
    
    if (futhark_mc_segmap_parloop_338162_err != 0) {
        err = futhark_mc_segmap_parloop_338162_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338162_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338162_total_end -
                 futhark_mc_segmap_parloop_338162_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338162_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338162_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338162_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_nested_task_338160_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_nested_task_338160_end -
                 futhark_mc_segmap_nested_task_338160_start;
        
        ctx->futhark_mc_segmap_nested_task_338160_runs[tid]++;
        ctx->futhark_mc_segmap_nested_task_338160_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_nested_task_338160_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
static int futhark_mc_segmap_parloop_338147(void *args, int64_t start,
                                            int64_t end, int flat_tid_301864,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338146
    *futhark_mc_segmap_parloop_struct_338146 =
    (struct futhark_mc_segmap_parloop_struct_338146 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338146->ctx;
    uint64_t futhark_mc_segmap_parloop_338147_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338147_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segmap_parloop_struct_338146->free_n_p_292677;
    int64_t q_s_292678 =
            futhark_mc_segmap_parloop_struct_338146->free_q_s_292678;
    int64_t jump_s_292684 =
            futhark_mc_segmap_parloop_struct_338146->free_jump_s_292684;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_338146->free_partition_sizze_292766;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segmap_parloop_struct_338146->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_segmap_parloop_struct_338146->free_pad_css_len_292821;
    int64_t s_n_m_292825 =
            futhark_mc_segmap_parloop_struct_338146->free_s_n_m_292825;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_segmap_parloop_struct_338146->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_312842 = {.desc ="mem_312842", .mem =
                                  futhark_mc_segmap_parloop_struct_338146->free_mem_312842,
                                  .size =0, .references =NULL};
    int64_t bytes_312847 =
            futhark_mc_segmap_parloop_struct_338146->free_bytes_312847;
    int64_t bytes_312899 =
            futhark_mc_segmap_parloop_struct_338146->free_bytes_312899;
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_segmap_parloop_struct_338146->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_segmap_parloop_struct_338146->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_segmap_parloop_struct_338146->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_segmap_parloop_struct_338146->free_mem_313371,
                                  .size =0, .references =NULL};
    int64_t bytes_314123 =
            futhark_mc_segmap_parloop_struct_338146->free_bytes_314123;
    struct memblock mem_314456 = {.desc ="mem_314456", .mem =
                                  futhark_mc_segmap_parloop_struct_338146->free_mem_314456,
                                  .size =0, .references =NULL};
    struct memblock mem_314461 = {.desc ="mem_314461", .mem =
                                  futhark_mc_segmap_parloop_struct_338146->free_mem_314461,
                                  .size =0, .references =NULL};
    size_t mem_314293_cached_sizze_338148 = 0;
    unsigned char *mem_314293 = NULL;
    size_t mem_314297_cached_sizze_338149 = 0;
    unsigned char *mem_314297 = NULL;
    int64_t iterations = end - start;
    int64_t iter_323569 = start;
    
    if (mem_314293_cached_sizze_338148 < (size_t) bytes_312899) {
        mem_314293 = realloc(mem_314293, bytes_312899);
        mem_314293_cached_sizze_338148 = bytes_312899;
    }
    if (mem_314297_cached_sizze_338149 < (size_t) bytes_312899) {
        mem_314297 = realloc(mem_314297, bytes_312899);
        mem_314297_cached_sizze_338149 = bytes_312899;
    }
    for (; iter_323569 < end; iter_323569++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_323980 = partition_sizze_292766;
        int64_t gtid_301865 = iter_323569;
        int64_t remnant_323981 = iter_323569 - gtid_301865;
        int64_t flat_tid_323837 = (int64_t) 0;
        int32_t num_tasks_323982;
        int64_t flat_tid_323570 = (int64_t) 0;
        struct futhark_mc_task_338150 futhark_mc_task_338150;
        
        futhark_mc_task_338150.ctx = ctx;
        futhark_mc_task_338150.free_n_p_292677 = n_p_292677;
        futhark_mc_task_338150.free_q_s_292678 = q_s_292678;
        futhark_mc_task_338150.free_jump_s_292684 = jump_s_292684;
        futhark_mc_task_338150.free_defunc_0_f_res_292820 =
            defunc_0_f_res_292820;
        futhark_mc_task_338150.free_pad_css_len_292821 = pad_css_len_292821;
        futhark_mc_task_338150.free_s_n_m_292825 = s_n_m_292825;
        futhark_mc_task_338150.free_gtid_301865 = gtid_301865;
        futhark_mc_task_338150.free_mem_312838 = mem_312838.mem;
        futhark_mc_task_338150.free_mem_312842 = mem_312842.mem;
        futhark_mc_task_338150.free_bytes_312847 = bytes_312847;
        futhark_mc_task_338150.free_mem_313018 = mem_313018.mem;
        futhark_mc_task_338150.free_mem_313023 = mem_313023.mem;
        futhark_mc_task_338150.free_mem_313366 = mem_313366.mem;
        futhark_mc_task_338150.free_mem_313371 = mem_313371.mem;
        futhark_mc_task_338150.free_bytes_314123 = bytes_314123;
        futhark_mc_task_338150.free_mem_314293 = mem_314293;
        futhark_mc_task_338150.free_mem_314297 = mem_314297;
        
        struct scheduler_segop futhark_mc_task_338150_task;
        
        futhark_mc_task_338150_task.args = &futhark_mc_task_338150;
        futhark_mc_task_338150_task.top_level_fn =
            futhark_mc_segmap_task_338151;
        futhark_mc_task_338150_task.name = "futhark_mc_segmap_task_338151";
        futhark_mc_task_338150_task.iterations = n_p_292677;
        futhark_mc_task_338150_task.task_time =
            &ctx->futhark_mc_segmap_task_338151_total_time;
        futhark_mc_task_338150_task.task_iter =
            &ctx->futhark_mc_segmap_task_338151_total_iter;
        futhark_mc_task_338150_task.sched = STATIC;
        futhark_mc_task_338150_task.nested_fn =
            futhark_mc_segmap_nested_task_338160;
        
        int futhark_mc_segmap_task_338151_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_338150_task);
        
        if (futhark_mc_segmap_task_338151_err != 0) {
            ;
            err = futhark_mc_segmap_task_338151_err;
            goto cleanup;
        }
        if (n_p_292677 * s_n_m_292825 * (int64_t) 8 > 0)
            memmove(mem_314456.mem + gtid_301865 * (s_n_m_292825 * n_p_292677) *
                    (int64_t) 8, mem_314293 + (int64_t) 0, n_p_292677 *
                    s_n_m_292825 * (int64_t) 8);
        if (n_p_292677 * s_n_m_292825 * (int64_t) 8 > 0)
            memmove(mem_314461.mem + gtid_301865 * (s_n_m_292825 * n_p_292677) *
                    (int64_t) 8, mem_314297 + (int64_t) 0, n_p_292677 *
                    s_n_m_292825 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_314293);
    free(mem_314297);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338147_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338147_end -
                 futhark_mc_segmap_parloop_338147_start;
        
        ctx->futhark_mc_segmap_parloop_338147_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338147_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338147_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_nested_task_338145(void *args, int64_t iterations,
                                         int tid, struct scheduler_info info)
{
    int err = 0;
    int flat_tid_301864 = tid;
    int num_tasks_323414 = info.nsubtasks;
    struct futhark_mc_task_338135 *futhark_mc_task_338135 =
                                  (struct futhark_mc_task_338135 *) args;
    struct futhark_context *ctx = futhark_mc_task_338135->ctx;
    uint64_t futhark_mc_segmap_nested_task_338145_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_nested_task_338145_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_338135->free_n_p_292677;
    int64_t q_s_292678 = futhark_mc_task_338135->free_q_s_292678;
    int64_t jump_s_292684 = futhark_mc_task_338135->free_jump_s_292684;
    int64_t partition_sizze_292766 =
            futhark_mc_task_338135->free_partition_sizze_292766;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_338135->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_task_338135->free_pad_css_len_292821;
    int64_t s_n_m_292825 = futhark_mc_task_338135->free_s_n_m_292825;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_task_338135->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_312842 = {.desc ="mem_312842", .mem =
                                  futhark_mc_task_338135->free_mem_312842,
                                  .size =0, .references =NULL};
    int64_t bytes_312847 = futhark_mc_task_338135->free_bytes_312847;
    int64_t bytes_312899 = futhark_mc_task_338135->free_bytes_312899;
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_task_338135->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_task_338135->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_task_338135->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_task_338135->free_mem_313371,
                                  .size =0, .references =NULL};
    int64_t bytes_314123 = futhark_mc_task_338135->free_bytes_314123;
    struct memblock mem_314456 = {.desc ="mem_314456", .mem =
                                  futhark_mc_task_338135->free_mem_314456,
                                  .size =0, .references =NULL};
    struct memblock mem_314461 = {.desc ="mem_314461", .mem =
                                  futhark_mc_task_338135->free_mem_314461,
                                  .size =0, .references =NULL};
    int64_t iter_323569;
    struct futhark_mc_segmap_parloop_struct_338146
    futhark_mc_segmap_parloop_struct_338146;
    
    futhark_mc_segmap_parloop_struct_338146.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338146.free_n_p_292677 = n_p_292677;
    futhark_mc_segmap_parloop_struct_338146.free_q_s_292678 = q_s_292678;
    futhark_mc_segmap_parloop_struct_338146.free_jump_s_292684 = jump_s_292684;
    futhark_mc_segmap_parloop_struct_338146.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_338146.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segmap_parloop_struct_338146.free_pad_css_len_292821 =
        pad_css_len_292821;
    futhark_mc_segmap_parloop_struct_338146.free_s_n_m_292825 = s_n_m_292825;
    futhark_mc_segmap_parloop_struct_338146.free_mem_312838 = mem_312838.mem;
    futhark_mc_segmap_parloop_struct_338146.free_mem_312842 = mem_312842.mem;
    futhark_mc_segmap_parloop_struct_338146.free_bytes_312847 = bytes_312847;
    futhark_mc_segmap_parloop_struct_338146.free_bytes_312899 = bytes_312899;
    futhark_mc_segmap_parloop_struct_338146.free_mem_313018 = mem_313018.mem;
    futhark_mc_segmap_parloop_struct_338146.free_mem_313023 = mem_313023.mem;
    futhark_mc_segmap_parloop_struct_338146.free_mem_313366 = mem_313366.mem;
    futhark_mc_segmap_parloop_struct_338146.free_mem_313371 = mem_313371.mem;
    futhark_mc_segmap_parloop_struct_338146.free_bytes_314123 = bytes_314123;
    futhark_mc_segmap_parloop_struct_338146.free_mem_314456 = mem_314456.mem;
    futhark_mc_segmap_parloop_struct_338146.free_mem_314461 = mem_314461.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338147_task;
    
    futhark_mc_segmap_parloop_338147_task.name =
        "futhark_mc_segmap_parloop_338147";
    futhark_mc_segmap_parloop_338147_task.fn = futhark_mc_segmap_parloop_338147;
    futhark_mc_segmap_parloop_338147_task.args =
        &futhark_mc_segmap_parloop_struct_338146;
    futhark_mc_segmap_parloop_338147_task.iterations = iterations;
    futhark_mc_segmap_parloop_338147_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338147_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338147_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338147_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338147_task);
    
    if (futhark_mc_segmap_parloop_338147_err != 0) {
        err = futhark_mc_segmap_parloop_338147_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338147_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338147_total_end -
                 futhark_mc_segmap_parloop_338147_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338147_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338147_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338147_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_nested_task_338145_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_nested_task_338145_end -
                 futhark_mc_segmap_nested_task_338145_start;
        
        ctx->futhark_mc_segmap_nested_task_338145_runs[tid]++;
        ctx->futhark_mc_segmap_nested_task_338145_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_nested_task_338145_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_task_338199 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_q_s_292678;
    int64_t free_jump_s_292684;
    int64_t free_partition_sizze_292766;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_312842;
    int64_t free_bytes_312847;
    int64_t free_bytes_312899;
    unsigned char *free_mem_313018;
    unsigned char *free_mem_313023;
    unsigned char *free_mem_313366;
    unsigned char *free_mem_313371;
    unsigned char *free_mem_314544;
};
struct futhark_mc_segmap_parloop_struct_338201 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_q_s_292678;
    int64_t free_jump_s_292684;
    int64_t free_partition_sizze_292766;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_312842;
    int64_t free_bytes_312899;
    unsigned char *free_mem_313018;
    unsigned char *free_mem_313023;
    unsigned char *free_mem_313366;
    unsigned char *free_mem_313371;
    unsigned char *free_mem_314544;
};
static int futhark_mc_segmap_parloop_338202(void *args, int64_t start,
                                            int64_t end, int flat_tid_302264,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338201
    *futhark_mc_segmap_parloop_struct_338201 =
    (struct futhark_mc_segmap_parloop_struct_338201 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338201->ctx;
    uint64_t futhark_mc_segmap_parloop_338202_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338202_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segmap_parloop_struct_338201->free_n_p_292677;
    int64_t q_s_292678 =
            futhark_mc_segmap_parloop_struct_338201->free_q_s_292678;
    int64_t jump_s_292684 =
            futhark_mc_segmap_parloop_struct_338201->free_jump_s_292684;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_338201->free_partition_sizze_292766;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segmap_parloop_struct_338201->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_segmap_parloop_struct_338201->free_pad_css_len_292821;
    int64_t s_n_m_292825 =
            futhark_mc_segmap_parloop_struct_338201->free_s_n_m_292825;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_segmap_parloop_struct_338201->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_312842 = {.desc ="mem_312842", .mem =
                                  futhark_mc_segmap_parloop_struct_338201->free_mem_312842,
                                  .size =0, .references =NULL};
    int64_t bytes_312899 =
            futhark_mc_segmap_parloop_struct_338201->free_bytes_312899;
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_segmap_parloop_struct_338201->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_segmap_parloop_struct_338201->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_segmap_parloop_struct_338201->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_segmap_parloop_struct_338201->free_mem_313371,
                                  .size =0, .references =NULL};
    struct memblock mem_314544 = {.desc ="mem_314544", .mem =
                                  futhark_mc_segmap_parloop_struct_338201->free_mem_314544,
                                  .size =0, .references =NULL};
    size_t mem_314496_cached_sizze_338203 = 0;
    unsigned char *mem_314496 = NULL;
    int64_t iterations = end - start;
    int64_t iter_324625 = start;
    
    if (mem_314496_cached_sizze_338203 < (size_t) bytes_312899) {
        mem_314496 = realloc(mem_314496, bytes_312899);
        mem_314496_cached_sizze_338203 = bytes_312899;
    }
    for (; iter_324625 < end; iter_324625++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_324705 = partition_sizze_292766;
        int64_t gtid_302265 = iter_324625;
        int64_t remnant_324706 = iter_324625 - gtid_302265;
        
        for (int64_t i_324626 = 0; i_324626 < n_p_292677; i_324626++) {
            int64_t x_324628;
            
            x_324628 = ((int64_t *) mem_312842.mem)[gtid_302265 * n_p_292677 +
                                                    i_324626];
            for (int64_t i_324630 = 0; i_324630 < s_n_m_292825; i_324630++) {
                int64_t x_324632;
                
                x_324632 = ((int64_t *) mem_313018.mem)[gtid_302265 *
                                                        (s_n_m_292825 *
                                                         n_p_292677) +
                                                        i_324626 *
                                                        s_n_m_292825 +
                                                        i_324630];
                
                double x_324633;
                
                x_324633 = ((double *) mem_313023.mem)[gtid_302265 *
                                                       (s_n_m_292825 *
                                                        n_p_292677) + i_324626 *
                                                       s_n_m_292825 + i_324630];
                
                bool cond_324634 = i_324630 == (int64_t) 0;
                int64_t defunc_0_m_fun_res_324635;
                
                if (cond_324634) {
                    defunc_0_m_fun_res_324635 = (int64_t) 0;
                } else {
                    int64_t y_324636 = sub64(s_n_m_292825, (int64_t) 1);
                    bool cond_324637 = i_324630 == y_324636;
                    int64_t defunc_0_m_fun_res_f_res_324638;
                    
                    if (cond_324637) {
                        int64_t defunc_0_m_fun_res_f_res_t_res_324639 =
                                sub64(pad_css_len_292821, (int64_t) 1);
                        
                        defunc_0_m_fun_res_f_res_324638 =
                            defunc_0_m_fun_res_f_res_t_res_324639;
                    } else {
                        int64_t x_324640 = sub64(i_324630, (int64_t) 1);
                        int64_t x_324641 = mul64(jump_s_292684, x_324640);
                        int64_t min_arg_324642 = add64((int64_t) 1, x_324641);
                        int64_t min_res_324643 = smin64(defunc_0_f_res_292820,
                                                        min_arg_324642);
                        
                        defunc_0_m_fun_res_f_res_324638 = min_res_324643;
                    }
                    defunc_0_m_fun_res_324635 = defunc_0_m_fun_res_f_res_324638;
                }
                
                double defunc_2_reduce_res_324644;
                double redout_324646 = 0.0;
                
                for (int64_t i_324645 = 0; i_324645 < q_s_292678; i_324645++) {
                    bool cond_324647 = sle64(x_324628, i_324645);
                    int64_t defunc_0_f_res_324648;
                    
                    if (cond_324647) {
                        defunc_0_f_res_324648 = (int64_t) 0;
                    } else {
                        int64_t i_324649 = add64(x_324632, i_324645);
                        int64_t defunc_0_add_arg_324650;
                        
                        defunc_0_add_arg_324650 =
                            ((int64_t *) mem_312838.mem)[gtid_302265 *
                                                         (defunc_0_f_res_292820 *
                                                          n_p_292677) +
                                                         i_324626 *
                                                         defunc_0_f_res_292820 +
                                                         i_324649];
                        
                        int64_t defunc_1_add_res_324651 = add64((int64_t) 1,
                                                                defunc_0_add_arg_324650);
                        
                        defunc_0_f_res_324648 = defunc_1_add_res_324651;
                    }
                    
                    double defunc_0_f_res_324652;
                    
                    if (cond_324647) {
                        defunc_0_f_res_324652 = 0.0;
                    } else {
                        int64_t i_324653 = add64(x_324632, i_324645);
                        double defunc_0_add_arg_324654;
                        
                        defunc_0_add_arg_324654 =
                            ((double *) mem_313371.mem)[gtid_302265 *
                                                        (defunc_0_f_res_292820 *
                                                         n_p_292677) +
                                                        i_324626 *
                                                        defunc_0_f_res_292820 +
                                                        i_324653];
                        defunc_0_f_res_324652 = defunc_0_add_arg_324654;
                    }
                    
                    int64_t binop_p_324655 = sub64(defunc_0_f_res_324648,
                                                   defunc_0_m_fun_res_324635);
                    double defunc_0_f_res_324656 =
                           sitofp_i64_f64(binop_p_324655);
                    double abs_res_324657 = fabs(defunc_0_f_res_324656);
                    double tmp1_324658 = abs_res_324657 / x_324633;
                    double x_324659 = tmp1_324658 * tmp1_324658;
                    double y_324660 = tmp1_324658 * x_324659;
                    double tmp2_324661 = 1.0 - y_324660;
                    double x_324662 = tmp2_324661 * tmp2_324661;
                    double tmp3_324663 = tmp2_324661 * x_324662;
                    double w_j_324664 = defunc_0_f_res_324652 * tmp3_324663;
                    double defunc_1_op_res_324665 = w_j_324664 + redout_324646;
                    double redout_tmp_324709 = defunc_1_op_res_324665;
                    
                    redout_324646 = redout_tmp_324709;
                }
                defunc_2_reduce_res_324644 = redout_324646;
                
                double a_324666 = 2.220446049250313e-16 +
                       defunc_2_reduce_res_324644;
                double a0_324667 = 1.0 / a_324666;
                int64_t defunc_0_m_fun_res_324668;
                
                if (cond_324634) {
                    defunc_0_m_fun_res_324668 = (int64_t) 0;
                } else {
                    int64_t y_324669 = sub64(s_n_m_292825, (int64_t) 1);
                    bool cond_324670 = i_324630 == y_324669;
                    int64_t defunc_0_m_fun_res_f_res_324671;
                    
                    if (cond_324670) {
                        int64_t defunc_0_m_fun_res_f_res_t_res_324672 =
                                sub64(pad_css_len_292821, (int64_t) 1);
                        
                        defunc_0_m_fun_res_f_res_324671 =
                            defunc_0_m_fun_res_f_res_t_res_324672;
                    } else {
                        int64_t x_324673 = sub64(i_324630, (int64_t) 1);
                        int64_t x_324674 = mul64(jump_s_292684, x_324673);
                        int64_t min_arg_324675 = add64((int64_t) 1, x_324674);
                        int64_t min_res_324676 = smin64(defunc_0_f_res_292820,
                                                        min_arg_324675);
                        
                        defunc_0_m_fun_res_f_res_324671 = min_res_324676;
                    }
                    defunc_0_m_fun_res_324668 = defunc_0_m_fun_res_f_res_324671;
                }
                
                double defunc_2_reduce_res_324677;
                double redout_324679 = 0.0;
                
                for (int64_t i_324678 = 0; i_324678 < q_s_292678; i_324678++) {
                    bool cond_324680 = sle64(x_324628, i_324678);
                    int64_t defunc_0_f_res_324681;
                    
                    if (cond_324680) {
                        defunc_0_f_res_324681 = (int64_t) 0;
                    } else {
                        int64_t i_324682 = add64(x_324632, i_324678);
                        int64_t defunc_0_add_arg_324683;
                        
                        defunc_0_add_arg_324683 =
                            ((int64_t *) mem_312838.mem)[gtid_302265 *
                                                         (defunc_0_f_res_292820 *
                                                          n_p_292677) +
                                                         i_324626 *
                                                         defunc_0_f_res_292820 +
                                                         i_324682];
                        
                        int64_t defunc_1_add_res_324684 = add64((int64_t) 1,
                                                                defunc_0_add_arg_324683);
                        
                        defunc_0_f_res_324681 = defunc_1_add_res_324684;
                    }
                    
                    double defunc_0_f_res_324685;
                    
                    if (cond_324680) {
                        defunc_0_f_res_324685 = 0.0;
                    } else {
                        int64_t i_324686 = add64(x_324632, i_324678);
                        double defunc_0_add_arg_324687;
                        
                        defunc_0_add_arg_324687 =
                            ((double *) mem_313371.mem)[gtid_302265 *
                                                        (defunc_0_f_res_292820 *
                                                         n_p_292677) +
                                                        i_324626 *
                                                        defunc_0_f_res_292820 +
                                                        i_324686];
                        defunc_0_f_res_324685 = defunc_0_add_arg_324687;
                    }
                    
                    int64_t binop_p_324688 = sub64(defunc_0_f_res_324681,
                                                   defunc_0_m_fun_res_324668);
                    double defunc_0_f_res_324689 =
                           sitofp_i64_f64(binop_p_324688);
                    double abs_res_324690 = fabs(defunc_0_f_res_324689);
                    double tmp1_324691 = abs_res_324690 / x_324633;
                    double x_324692 = tmp1_324691 * tmp1_324691;
                    double y_324693 = tmp1_324691 * x_324692;
                    double tmp2_324694 = 1.0 - y_324693;
                    double x_324695 = tmp2_324694 * tmp2_324694;
                    double tmp3_324696 = tmp2_324694 * x_324695;
                    double tmp4_324697 = defunc_0_f_res_324685 * tmp3_324696;
                    double defunc_0_f_res_324698;
                    
                    if (cond_324680) {
                        defunc_0_f_res_324698 = 0.0;
                    } else {
                        int64_t i_324699 = add64(x_324632, i_324678);
                        double defunc_0_add_arg_324700;
                        
                        defunc_0_add_arg_324700 =
                            ((double *) mem_313366.mem)[gtid_302265 *
                                                        (defunc_0_f_res_292820 *
                                                         n_p_292677) +
                                                        i_324626 *
                                                        defunc_0_f_res_292820 +
                                                        i_324699];
                        defunc_0_f_res_324698 = defunc_0_add_arg_324700;
                    }
                    
                    double x_324701 = a0_324667 * tmp4_324697;
                    double defunc_9_fit_fun_res_324702 = defunc_0_f_res_324698 *
                           x_324701;
                    double defunc_1_op_res_324703 =
                           defunc_9_fit_fun_res_324702 + redout_324679;
                    double redout_tmp_324710 = defunc_1_op_res_324703;
                    
                    redout_324679 = redout_tmp_324710;
                }
                defunc_2_reduce_res_324677 = redout_324679;
                ((double *) mem_314496)[i_324626 * s_n_m_292825 + i_324630] =
                    defunc_2_reduce_res_324677;
            }
        }
        if (n_p_292677 * s_n_m_292825 * (int64_t) 8 > 0)
            memmove(mem_314544.mem + gtid_302265 * (s_n_m_292825 * n_p_292677) *
                    (int64_t) 8, mem_314496 + (int64_t) 0, n_p_292677 *
                    s_n_m_292825 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_314496);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338202_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338202_end -
                 futhark_mc_segmap_parloop_338202_start;
        
        ctx->futhark_mc_segmap_parloop_338202_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338202_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338202_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_338200(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_302264 = tid;
    int num_tasks_324624 = info.nsubtasks;
    struct futhark_mc_task_338199 *futhark_mc_task_338199 =
                                  (struct futhark_mc_task_338199 *) args;
    struct futhark_context *ctx = futhark_mc_task_338199->ctx;
    uint64_t futhark_mc_segmap_task_338200_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_338200_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_338199->free_n_p_292677;
    int64_t q_s_292678 = futhark_mc_task_338199->free_q_s_292678;
    int64_t jump_s_292684 = futhark_mc_task_338199->free_jump_s_292684;
    int64_t partition_sizze_292766 =
            futhark_mc_task_338199->free_partition_sizze_292766;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_338199->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_task_338199->free_pad_css_len_292821;
    int64_t s_n_m_292825 = futhark_mc_task_338199->free_s_n_m_292825;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_task_338199->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_312842 = {.desc ="mem_312842", .mem =
                                  futhark_mc_task_338199->free_mem_312842,
                                  .size =0, .references =NULL};
    int64_t bytes_312847 = futhark_mc_task_338199->free_bytes_312847;
    int64_t bytes_312899 = futhark_mc_task_338199->free_bytes_312899;
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_task_338199->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_task_338199->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_task_338199->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_task_338199->free_mem_313371,
                                  .size =0, .references =NULL};
    struct memblock mem_314544 = {.desc ="mem_314544", .mem =
                                  futhark_mc_task_338199->free_mem_314544,
                                  .size =0, .references =NULL};
    int64_t iter_324625;
    struct futhark_mc_segmap_parloop_struct_338201
    futhark_mc_segmap_parloop_struct_338201;
    
    futhark_mc_segmap_parloop_struct_338201.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338201.free_n_p_292677 = n_p_292677;
    futhark_mc_segmap_parloop_struct_338201.free_q_s_292678 = q_s_292678;
    futhark_mc_segmap_parloop_struct_338201.free_jump_s_292684 = jump_s_292684;
    futhark_mc_segmap_parloop_struct_338201.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_338201.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segmap_parloop_struct_338201.free_pad_css_len_292821 =
        pad_css_len_292821;
    futhark_mc_segmap_parloop_struct_338201.free_s_n_m_292825 = s_n_m_292825;
    futhark_mc_segmap_parloop_struct_338201.free_mem_312838 = mem_312838.mem;
    futhark_mc_segmap_parloop_struct_338201.free_mem_312842 = mem_312842.mem;
    futhark_mc_segmap_parloop_struct_338201.free_bytes_312899 = bytes_312899;
    futhark_mc_segmap_parloop_struct_338201.free_mem_313018 = mem_313018.mem;
    futhark_mc_segmap_parloop_struct_338201.free_mem_313023 = mem_313023.mem;
    futhark_mc_segmap_parloop_struct_338201.free_mem_313366 = mem_313366.mem;
    futhark_mc_segmap_parloop_struct_338201.free_mem_313371 = mem_313371.mem;
    futhark_mc_segmap_parloop_struct_338201.free_mem_314544 = mem_314544.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338202_task;
    
    futhark_mc_segmap_parloop_338202_task.name =
        "futhark_mc_segmap_parloop_338202";
    futhark_mc_segmap_parloop_338202_task.fn = futhark_mc_segmap_parloop_338202;
    futhark_mc_segmap_parloop_338202_task.args =
        &futhark_mc_segmap_parloop_struct_338201;
    futhark_mc_segmap_parloop_338202_task.iterations = iterations;
    futhark_mc_segmap_parloop_338202_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338202_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338202_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338202_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338202_task);
    
    if (futhark_mc_segmap_parloop_338202_err != 0) {
        err = futhark_mc_segmap_parloop_338202_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338202_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338202_total_end -
                 futhark_mc_segmap_parloop_338202_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338202_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338202_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338202_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_338200_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_338200_end -
                 futhark_mc_segmap_task_338200_start;
        
        ctx->futhark_mc_segmap_task_338200_runs[tid]++;
        ctx->futhark_mc_segmap_task_338200_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_338200_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_segmap_parloop_struct_338205 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_q_s_292678;
    int64_t free_jump_s_292684;
    int64_t free_partition_sizze_292766;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_312842;
    int64_t free_bytes_312847;
    int64_t free_bytes_312899;
    unsigned char *free_mem_313018;
    unsigned char *free_mem_313023;
    unsigned char *free_mem_313366;
    unsigned char *free_mem_313371;
    unsigned char *free_mem_314544;
};
struct futhark_mc_task_338208 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_q_s_292678;
    int64_t free_jump_s_292684;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    int64_t free_gtid_302529;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_312842;
    int64_t free_bytes_312847;
    unsigned char *free_mem_313018;
    unsigned char *free_mem_313023;
    unsigned char *free_mem_313366;
    unsigned char *free_mem_313371;
    unsigned char *free_mem_314492;
};
struct futhark_mc_segmap_parloop_struct_338210 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_q_s_292678;
    int64_t free_jump_s_292684;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    int64_t free_gtid_302529;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_312842;
    int64_t free_bytes_312847;
    unsigned char *free_mem_313018;
    unsigned char *free_mem_313023;
    unsigned char *free_mem_313366;
    unsigned char *free_mem_313371;
    unsigned char *free_mem_314492;
};
static int futhark_mc_segmap_parloop_338211(void *args, int64_t start,
                                            int64_t end, int flat_tid_324869,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338210
    *futhark_mc_segmap_parloop_struct_338210 =
    (struct futhark_mc_segmap_parloop_struct_338210 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338210->ctx;
    uint64_t futhark_mc_segmap_parloop_338211_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338211_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segmap_parloop_struct_338210->free_n_p_292677;
    int64_t q_s_292678 =
            futhark_mc_segmap_parloop_struct_338210->free_q_s_292678;
    int64_t jump_s_292684 =
            futhark_mc_segmap_parloop_struct_338210->free_jump_s_292684;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segmap_parloop_struct_338210->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_segmap_parloop_struct_338210->free_pad_css_len_292821;
    int64_t s_n_m_292825 =
            futhark_mc_segmap_parloop_struct_338210->free_s_n_m_292825;
    int64_t gtid_302529 =
            futhark_mc_segmap_parloop_struct_338210->free_gtid_302529;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_segmap_parloop_struct_338210->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_312842 = {.desc ="mem_312842", .mem =
                                  futhark_mc_segmap_parloop_struct_338210->free_mem_312842,
                                  .size =0, .references =NULL};
    int64_t bytes_312847 =
            futhark_mc_segmap_parloop_struct_338210->free_bytes_312847;
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_segmap_parloop_struct_338210->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_segmap_parloop_struct_338210->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_segmap_parloop_struct_338210->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_segmap_parloop_struct_338210->free_mem_313371,
                                  .size =0, .references =NULL};
    struct memblock mem_314492 = {.desc ="mem_314492", .mem =
                                  futhark_mc_segmap_parloop_struct_338210->free_mem_314492,
                                  .size =0, .references =NULL};
    size_t mem_324872_cached_sizze_338212 = 0;
    unsigned char *mem_324872 = NULL;
    int64_t iterations = end - start;
    int64_t iter_324953 = start;
    
    if (mem_324872_cached_sizze_338212 < (size_t) bytes_312847) {
        mem_324872 = realloc(mem_324872, bytes_312847);
        mem_324872_cached_sizze_338212 = bytes_312847;
    }
    for (; iter_324953 < end; iter_324953++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_325029 = n_p_292677;
        int64_t gtid_324870 = iter_324953;
        int64_t remnant_325030 = iter_324953 - gtid_324870;
        int64_t x_324871;
        
        x_324871 = ((int64_t *) mem_312842.mem)[gtid_302529 * n_p_292677 +
                                                gtid_324870];
        for (int64_t i_324954 = 0; i_324954 < s_n_m_292825; i_324954++) {
            int64_t x_324956;
            
            x_324956 = ((int64_t *) mem_313018.mem)[gtid_302529 *
                                                    (s_n_m_292825 *
                                                     n_p_292677) + gtid_324870 *
                                                    s_n_m_292825 + i_324954];
            
            double x_324957;
            
            x_324957 = ((double *) mem_313023.mem)[gtid_302529 * (s_n_m_292825 *
                                                                  n_p_292677) +
                                                   gtid_324870 * s_n_m_292825 +
                                                   i_324954];
            
            bool cond_324958 = i_324954 == (int64_t) 0;
            int64_t defunc_0_m_fun_res_324959;
            
            if (cond_324958) {
                defunc_0_m_fun_res_324959 = (int64_t) 0;
            } else {
                int64_t y_324960 = sub64(s_n_m_292825, (int64_t) 1);
                bool cond_324961 = i_324954 == y_324960;
                int64_t defunc_0_m_fun_res_f_res_324962;
                
                if (cond_324961) {
                    int64_t defunc_0_m_fun_res_f_res_t_res_324963 =
                            sub64(pad_css_len_292821, (int64_t) 1);
                    
                    defunc_0_m_fun_res_f_res_324962 =
                        defunc_0_m_fun_res_f_res_t_res_324963;
                } else {
                    int64_t x_324964 = sub64(i_324954, (int64_t) 1);
                    int64_t x_324965 = mul64(jump_s_292684, x_324964);
                    int64_t min_arg_324966 = add64((int64_t) 1, x_324965);
                    int64_t min_res_324967 = smin64(defunc_0_f_res_292820,
                                                    min_arg_324966);
                    
                    defunc_0_m_fun_res_f_res_324962 = min_res_324967;
                }
                defunc_0_m_fun_res_324959 = defunc_0_m_fun_res_f_res_324962;
            }
            
            double defunc_2_reduce_res_324968;
            double redout_324970 = 0.0;
            
            for (int64_t i_324969 = 0; i_324969 < q_s_292678; i_324969++) {
                bool cond_324971 = sle64(x_324871, i_324969);
                int64_t defunc_0_f_res_324972;
                
                if (cond_324971) {
                    defunc_0_f_res_324972 = (int64_t) 0;
                } else {
                    int64_t i_324973 = add64(x_324956, i_324969);
                    int64_t defunc_0_add_arg_324974;
                    
                    defunc_0_add_arg_324974 =
                        ((int64_t *) mem_312838.mem)[gtid_302529 *
                                                     (defunc_0_f_res_292820 *
                                                      n_p_292677) +
                                                     gtid_324870 *
                                                     defunc_0_f_res_292820 +
                                                     i_324973];
                    
                    int64_t defunc_1_add_res_324975 = add64((int64_t) 1,
                                                            defunc_0_add_arg_324974);
                    
                    defunc_0_f_res_324972 = defunc_1_add_res_324975;
                }
                
                double defunc_0_f_res_324976;
                
                if (cond_324971) {
                    defunc_0_f_res_324976 = 0.0;
                } else {
                    int64_t i_324977 = add64(x_324956, i_324969);
                    double defunc_0_add_arg_324978;
                    
                    defunc_0_add_arg_324978 =
                        ((double *) mem_313371.mem)[gtid_302529 *
                                                    (defunc_0_f_res_292820 *
                                                     n_p_292677) + gtid_324870 *
                                                    defunc_0_f_res_292820 +
                                                    i_324977];
                    defunc_0_f_res_324976 = defunc_0_add_arg_324978;
                }
                
                int64_t binop_p_324979 = sub64(defunc_0_f_res_324972,
                                               defunc_0_m_fun_res_324959);
                double defunc_0_f_res_324980 = sitofp_i64_f64(binop_p_324979);
                double abs_res_324981 = fabs(defunc_0_f_res_324980);
                double tmp1_324982 = abs_res_324981 / x_324957;
                double x_324983 = tmp1_324982 * tmp1_324982;
                double y_324984 = tmp1_324982 * x_324983;
                double tmp2_324985 = 1.0 - y_324984;
                double x_324986 = tmp2_324985 * tmp2_324985;
                double tmp3_324987 = tmp2_324985 * x_324986;
                double w_j_324988 = defunc_0_f_res_324976 * tmp3_324987;
                double defunc_1_op_res_324989 = w_j_324988 + redout_324970;
                double redout_tmp_325032 = defunc_1_op_res_324989;
                
                redout_324970 = redout_tmp_325032;
            }
            defunc_2_reduce_res_324968 = redout_324970;
            
            double a_324990 = 2.220446049250313e-16 +
                   defunc_2_reduce_res_324968;
            double a0_324991 = 1.0 / a_324990;
            int64_t defunc_0_m_fun_res_324992;
            
            if (cond_324958) {
                defunc_0_m_fun_res_324992 = (int64_t) 0;
            } else {
                int64_t y_324993 = sub64(s_n_m_292825, (int64_t) 1);
                bool cond_324994 = i_324954 == y_324993;
                int64_t defunc_0_m_fun_res_f_res_324995;
                
                if (cond_324994) {
                    int64_t defunc_0_m_fun_res_f_res_t_res_324996 =
                            sub64(pad_css_len_292821, (int64_t) 1);
                    
                    defunc_0_m_fun_res_f_res_324995 =
                        defunc_0_m_fun_res_f_res_t_res_324996;
                } else {
                    int64_t x_324997 = sub64(i_324954, (int64_t) 1);
                    int64_t x_324998 = mul64(jump_s_292684, x_324997);
                    int64_t min_arg_324999 = add64((int64_t) 1, x_324998);
                    int64_t min_res_325000 = smin64(defunc_0_f_res_292820,
                                                    min_arg_324999);
                    
                    defunc_0_m_fun_res_f_res_324995 = min_res_325000;
                }
                defunc_0_m_fun_res_324992 = defunc_0_m_fun_res_f_res_324995;
            }
            
            double defunc_2_reduce_res_325001;
            double redout_325003 = 0.0;
            
            for (int64_t i_325002 = 0; i_325002 < q_s_292678; i_325002++) {
                bool cond_325004 = sle64(x_324871, i_325002);
                int64_t defunc_0_f_res_325005;
                
                if (cond_325004) {
                    defunc_0_f_res_325005 = (int64_t) 0;
                } else {
                    int64_t i_325006 = add64(x_324956, i_325002);
                    int64_t defunc_0_add_arg_325007;
                    
                    defunc_0_add_arg_325007 =
                        ((int64_t *) mem_312838.mem)[gtid_302529 *
                                                     (defunc_0_f_res_292820 *
                                                      n_p_292677) +
                                                     gtid_324870 *
                                                     defunc_0_f_res_292820 +
                                                     i_325006];
                    
                    int64_t defunc_1_add_res_325008 = add64((int64_t) 1,
                                                            defunc_0_add_arg_325007);
                    
                    defunc_0_f_res_325005 = defunc_1_add_res_325008;
                }
                
                double defunc_0_f_res_325009;
                
                if (cond_325004) {
                    defunc_0_f_res_325009 = 0.0;
                } else {
                    int64_t i_325010 = add64(x_324956, i_325002);
                    double defunc_0_add_arg_325011;
                    
                    defunc_0_add_arg_325011 =
                        ((double *) mem_313371.mem)[gtid_302529 *
                                                    (defunc_0_f_res_292820 *
                                                     n_p_292677) + gtid_324870 *
                                                    defunc_0_f_res_292820 +
                                                    i_325010];
                    defunc_0_f_res_325009 = defunc_0_add_arg_325011;
                }
                
                int64_t binop_p_325012 = sub64(defunc_0_f_res_325005,
                                               defunc_0_m_fun_res_324992);
                double defunc_0_f_res_325013 = sitofp_i64_f64(binop_p_325012);
                double abs_res_325014 = fabs(defunc_0_f_res_325013);
                double tmp1_325015 = abs_res_325014 / x_324957;
                double x_325016 = tmp1_325015 * tmp1_325015;
                double y_325017 = tmp1_325015 * x_325016;
                double tmp2_325018 = 1.0 - y_325017;
                double x_325019 = tmp2_325018 * tmp2_325018;
                double tmp3_325020 = tmp2_325018 * x_325019;
                double tmp4_325021 = defunc_0_f_res_325009 * tmp3_325020;
                double defunc_0_f_res_325022;
                
                if (cond_325004) {
                    defunc_0_f_res_325022 = 0.0;
                } else {
                    int64_t i_325023 = add64(x_324956, i_325002);
                    double defunc_0_add_arg_325024;
                    
                    defunc_0_add_arg_325024 =
                        ((double *) mem_313366.mem)[gtid_302529 *
                                                    (defunc_0_f_res_292820 *
                                                     n_p_292677) + gtid_324870 *
                                                    defunc_0_f_res_292820 +
                                                    i_325023];
                    defunc_0_f_res_325022 = defunc_0_add_arg_325024;
                }
                
                double x_325025 = a0_324991 * tmp4_325021;
                double defunc_9_fit_fun_res_325026 = defunc_0_f_res_325022 *
                       x_325025;
                double defunc_1_op_res_325027 = defunc_9_fit_fun_res_325026 +
                       redout_325003;
                double redout_tmp_325033 = defunc_1_op_res_325027;
                
                redout_325003 = redout_tmp_325033;
            }
            defunc_2_reduce_res_325001 = redout_325003;
            ((double *) mem_324872)[i_324954] = defunc_2_reduce_res_325001;
        }
        if (s_n_m_292825 * (int64_t) 8 > 0)
            memmove(mem_314492.mem + gtid_324870 * s_n_m_292825 * (int64_t) 8,
                    mem_324872 + (int64_t) 0, s_n_m_292825 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_324872);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338211_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338211_end -
                 futhark_mc_segmap_parloop_338211_start;
        
        ctx->futhark_mc_segmap_parloop_338211_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338211_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338211_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_338209(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_324869 = tid;
    int num_tasks_324952 = info.nsubtasks;
    struct futhark_mc_task_338208 *futhark_mc_task_338208 =
                                  (struct futhark_mc_task_338208 *) args;
    struct futhark_context *ctx = futhark_mc_task_338208->ctx;
    uint64_t futhark_mc_segmap_task_338209_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_338209_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_338208->free_n_p_292677;
    int64_t q_s_292678 = futhark_mc_task_338208->free_q_s_292678;
    int64_t jump_s_292684 = futhark_mc_task_338208->free_jump_s_292684;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_338208->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_task_338208->free_pad_css_len_292821;
    int64_t s_n_m_292825 = futhark_mc_task_338208->free_s_n_m_292825;
    int64_t gtid_302529 = futhark_mc_task_338208->free_gtid_302529;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_task_338208->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_312842 = {.desc ="mem_312842", .mem =
                                  futhark_mc_task_338208->free_mem_312842,
                                  .size =0, .references =NULL};
    int64_t bytes_312847 = futhark_mc_task_338208->free_bytes_312847;
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_task_338208->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_task_338208->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_task_338208->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_task_338208->free_mem_313371,
                                  .size =0, .references =NULL};
    struct memblock mem_314492 = {.desc ="mem_314492", .mem =
                                  futhark_mc_task_338208->free_mem_314492,
                                  .size =0, .references =NULL};
    int64_t iter_324953;
    struct futhark_mc_segmap_parloop_struct_338210
    futhark_mc_segmap_parloop_struct_338210;
    
    futhark_mc_segmap_parloop_struct_338210.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338210.free_n_p_292677 = n_p_292677;
    futhark_mc_segmap_parloop_struct_338210.free_q_s_292678 = q_s_292678;
    futhark_mc_segmap_parloop_struct_338210.free_jump_s_292684 = jump_s_292684;
    futhark_mc_segmap_parloop_struct_338210.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segmap_parloop_struct_338210.free_pad_css_len_292821 =
        pad_css_len_292821;
    futhark_mc_segmap_parloop_struct_338210.free_s_n_m_292825 = s_n_m_292825;
    futhark_mc_segmap_parloop_struct_338210.free_gtid_302529 = gtid_302529;
    futhark_mc_segmap_parloop_struct_338210.free_mem_312838 = mem_312838.mem;
    futhark_mc_segmap_parloop_struct_338210.free_mem_312842 = mem_312842.mem;
    futhark_mc_segmap_parloop_struct_338210.free_bytes_312847 = bytes_312847;
    futhark_mc_segmap_parloop_struct_338210.free_mem_313018 = mem_313018.mem;
    futhark_mc_segmap_parloop_struct_338210.free_mem_313023 = mem_313023.mem;
    futhark_mc_segmap_parloop_struct_338210.free_mem_313366 = mem_313366.mem;
    futhark_mc_segmap_parloop_struct_338210.free_mem_313371 = mem_313371.mem;
    futhark_mc_segmap_parloop_struct_338210.free_mem_314492 = mem_314492.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338211_task;
    
    futhark_mc_segmap_parloop_338211_task.name =
        "futhark_mc_segmap_parloop_338211";
    futhark_mc_segmap_parloop_338211_task.fn = futhark_mc_segmap_parloop_338211;
    futhark_mc_segmap_parloop_338211_task.args =
        &futhark_mc_segmap_parloop_struct_338210;
    futhark_mc_segmap_parloop_338211_task.iterations = iterations;
    futhark_mc_segmap_parloop_338211_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338211_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338211_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338211_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338211_task);
    
    if (futhark_mc_segmap_parloop_338211_err != 0) {
        err = futhark_mc_segmap_parloop_338211_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338211_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338211_total_end -
                 futhark_mc_segmap_parloop_338211_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338211_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338211_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338211_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_338209_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_338209_end -
                 futhark_mc_segmap_task_338209_start;
        
        ctx->futhark_mc_segmap_task_338209_runs[tid]++;
        ctx->futhark_mc_segmap_task_338209_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_338209_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_segmap_parloop_struct_338214 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_q_s_292678;
    int64_t free_jump_s_292684;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    int64_t free_gtid_302529;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_312842;
    int64_t free_bytes_312847;
    unsigned char *free_mem_313018;
    unsigned char *free_mem_313023;
    unsigned char *free_mem_313366;
    unsigned char *free_mem_313371;
    unsigned char *free_mem_314492;
};
struct futhark_mc_task_338217 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_q_s_292678;
    int64_t free_jump_s_292684;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    int64_t free_gtid_302529;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_313018;
    unsigned char *free_mem_313023;
    unsigned char *free_mem_313366;
    unsigned char *free_mem_313371;
    int64_t free_gtid_324713;
    int64_t free_x_324714;
    unsigned char *free_mem_324715;
};
struct futhark_mc_segmap_parloop_struct_338219 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_q_s_292678;
    int64_t free_jump_s_292684;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    int64_t free_gtid_302529;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_313018;
    unsigned char *free_mem_313023;
    unsigned char *free_mem_313366;
    unsigned char *free_mem_313371;
    int64_t free_gtid_324713;
    int64_t free_x_324714;
    unsigned char *free_mem_324715;
};
static int futhark_mc_segmap_parloop_338220(void *args, int64_t start,
                                            int64_t end, int flat_tid_325113,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338219
    *futhark_mc_segmap_parloop_struct_338219 =
    (struct futhark_mc_segmap_parloop_struct_338219 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338219->ctx;
    uint64_t futhark_mc_segmap_parloop_338220_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338220_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segmap_parloop_struct_338219->free_n_p_292677;
    int64_t q_s_292678 =
            futhark_mc_segmap_parloop_struct_338219->free_q_s_292678;
    int64_t jump_s_292684 =
            futhark_mc_segmap_parloop_struct_338219->free_jump_s_292684;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segmap_parloop_struct_338219->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_segmap_parloop_struct_338219->free_pad_css_len_292821;
    int64_t s_n_m_292825 =
            futhark_mc_segmap_parloop_struct_338219->free_s_n_m_292825;
    int64_t gtid_302529 =
            futhark_mc_segmap_parloop_struct_338219->free_gtid_302529;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_segmap_parloop_struct_338219->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_segmap_parloop_struct_338219->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_segmap_parloop_struct_338219->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_segmap_parloop_struct_338219->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_segmap_parloop_struct_338219->free_mem_313371,
                                  .size =0, .references =NULL};
    int64_t gtid_324713 =
            futhark_mc_segmap_parloop_struct_338219->free_gtid_324713;
    int64_t x_324714 = futhark_mc_segmap_parloop_struct_338219->free_x_324714;
    struct memblock mem_324715 = {.desc ="mem_324715", .mem =
                                  futhark_mc_segmap_parloop_struct_338219->free_mem_324715,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_325190 = start;
    
    for (; iter_325190 < end; iter_325190++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_325254 = s_n_m_292825;
        int64_t gtid_325114 = iter_325190;
        int64_t remnant_325255 = iter_325190 - gtid_325114;
        int64_t x_325115;
        
        x_325115 = ((int64_t *) mem_313018.mem)[gtid_302529 * (s_n_m_292825 *
                                                               n_p_292677) +
                                                gtid_324713 * s_n_m_292825 +
                                                gtid_325114];
        
        double x_325116;
        
        x_325116 = ((double *) mem_313023.mem)[gtid_302529 * (s_n_m_292825 *
                                                              n_p_292677) +
                                               gtid_324713 * s_n_m_292825 +
                                               gtid_325114];
        
        bool cond_325117 = gtid_325114 == (int64_t) 0;
        int64_t defunc_0_m_fun_res_325118;
        
        if (cond_325117) {
            defunc_0_m_fun_res_325118 = (int64_t) 0;
        } else {
            int64_t y_325191 = sub64(s_n_m_292825, (int64_t) 1);
            bool cond_325192 = gtid_325114 == y_325191;
            int64_t defunc_0_m_fun_res_f_res_325193;
            
            if (cond_325192) {
                int64_t defunc_0_m_fun_res_f_res_t_res_325194 =
                        sub64(pad_css_len_292821, (int64_t) 1);
                
                defunc_0_m_fun_res_f_res_325193 =
                    defunc_0_m_fun_res_f_res_t_res_325194;
            } else {
                int64_t x_325195 = sub64(gtid_325114, (int64_t) 1);
                int64_t x_325196 = mul64(jump_s_292684, x_325195);
                int64_t min_arg_325197 = add64((int64_t) 1, x_325196);
                int64_t min_res_325198 = smin64(defunc_0_f_res_292820,
                                                min_arg_325197);
                
                defunc_0_m_fun_res_f_res_325193 = min_res_325198;
            }
            defunc_0_m_fun_res_325118 = defunc_0_m_fun_res_f_res_325193;
        }
        
        double defunc_2_reduce_res_325127;
        double redout_325200 = 0.0;
        
        for (int64_t i_325199 = 0; i_325199 < q_s_292678; i_325199++) {
            bool cond_325201 = sle64(x_324714, i_325199);
            int64_t defunc_0_f_res_325202;
            
            if (cond_325201) {
                defunc_0_f_res_325202 = (int64_t) 0;
            } else {
                int64_t i_325203 = add64(x_325115, i_325199);
                int64_t defunc_0_add_arg_325204;
                
                defunc_0_add_arg_325204 =
                    ((int64_t *) mem_312838.mem)[gtid_302529 *
                                                 (defunc_0_f_res_292820 *
                                                  n_p_292677) + gtid_324713 *
                                                 defunc_0_f_res_292820 +
                                                 i_325203];
                
                int64_t defunc_1_add_res_325205 = add64((int64_t) 1,
                                                        defunc_0_add_arg_325204);
                
                defunc_0_f_res_325202 = defunc_1_add_res_325205;
            }
            
            double defunc_0_f_res_325206;
            
            if (cond_325201) {
                defunc_0_f_res_325206 = 0.0;
            } else {
                int64_t i_325207 = add64(x_325115, i_325199);
                double defunc_0_add_arg_325208;
                
                defunc_0_add_arg_325208 =
                    ((double *) mem_313371.mem)[gtid_302529 *
                                                (defunc_0_f_res_292820 *
                                                 n_p_292677) + gtid_324713 *
                                                defunc_0_f_res_292820 +
                                                i_325207];
                defunc_0_f_res_325206 = defunc_0_add_arg_325208;
            }
            
            int64_t binop_p_325209 = sub64(defunc_0_f_res_325202,
                                           defunc_0_m_fun_res_325118);
            double defunc_0_f_res_325210 = sitofp_i64_f64(binop_p_325209);
            double abs_res_325211 = fabs(defunc_0_f_res_325210);
            double tmp1_325212 = abs_res_325211 / x_325116;
            double x_325213 = tmp1_325212 * tmp1_325212;
            double y_325214 = tmp1_325212 * x_325213;
            double tmp2_325215 = 1.0 - y_325214;
            double x_325216 = tmp2_325215 * tmp2_325215;
            double tmp3_325217 = tmp2_325215 * x_325216;
            double w_j_325218 = defunc_0_f_res_325206 * tmp3_325217;
            double defunc_1_op_res_325219 = w_j_325218 + redout_325200;
            double redout_tmp_325256 = defunc_1_op_res_325219;
            
            redout_325200 = redout_tmp_325256;
        }
        defunc_2_reduce_res_325127 = redout_325200;
        
        double a_325149 = 2.220446049250313e-16 + defunc_2_reduce_res_325127;
        double a0_325150 = 1.0 / a_325149;
        int64_t defunc_0_m_fun_res_325151;
        
        if (cond_325117) {
            defunc_0_m_fun_res_325151 = (int64_t) 0;
        } else {
            int64_t y_325220 = sub64(s_n_m_292825, (int64_t) 1);
            bool cond_325221 = gtid_325114 == y_325220;
            int64_t defunc_0_m_fun_res_f_res_325222;
            
            if (cond_325221) {
                int64_t defunc_0_m_fun_res_f_res_t_res_325223 =
                        sub64(pad_css_len_292821, (int64_t) 1);
                
                defunc_0_m_fun_res_f_res_325222 =
                    defunc_0_m_fun_res_f_res_t_res_325223;
            } else {
                int64_t x_325224 = sub64(gtid_325114, (int64_t) 1);
                int64_t x_325225 = mul64(jump_s_292684, x_325224);
                int64_t min_arg_325226 = add64((int64_t) 1, x_325225);
                int64_t min_res_325227 = smin64(defunc_0_f_res_292820,
                                                min_arg_325226);
                
                defunc_0_m_fun_res_f_res_325222 = min_res_325227;
            }
            defunc_0_m_fun_res_325151 = defunc_0_m_fun_res_f_res_325222;
        }
        
        double defunc_2_reduce_res_325160;
        double redout_325229 = 0.0;
        
        for (int64_t i_325228 = 0; i_325228 < q_s_292678; i_325228++) {
            bool cond_325230 = sle64(x_324714, i_325228);
            int64_t defunc_0_f_res_325231;
            
            if (cond_325230) {
                defunc_0_f_res_325231 = (int64_t) 0;
            } else {
                int64_t i_325232 = add64(x_325115, i_325228);
                int64_t defunc_0_add_arg_325233;
                
                defunc_0_add_arg_325233 =
                    ((int64_t *) mem_312838.mem)[gtid_302529 *
                                                 (defunc_0_f_res_292820 *
                                                  n_p_292677) + gtid_324713 *
                                                 defunc_0_f_res_292820 +
                                                 i_325232];
                
                int64_t defunc_1_add_res_325234 = add64((int64_t) 1,
                                                        defunc_0_add_arg_325233);
                
                defunc_0_f_res_325231 = defunc_1_add_res_325234;
            }
            
            double defunc_0_f_res_325235;
            
            if (cond_325230) {
                defunc_0_f_res_325235 = 0.0;
            } else {
                int64_t i_325236 = add64(x_325115, i_325228);
                double defunc_0_add_arg_325237;
                
                defunc_0_add_arg_325237 =
                    ((double *) mem_313371.mem)[gtid_302529 *
                                                (defunc_0_f_res_292820 *
                                                 n_p_292677) + gtid_324713 *
                                                defunc_0_f_res_292820 +
                                                i_325236];
                defunc_0_f_res_325235 = defunc_0_add_arg_325237;
            }
            
            int64_t binop_p_325238 = sub64(defunc_0_f_res_325231,
                                           defunc_0_m_fun_res_325151);
            double defunc_0_f_res_325239 = sitofp_i64_f64(binop_p_325238);
            double abs_res_325240 = fabs(defunc_0_f_res_325239);
            double tmp1_325241 = abs_res_325240 / x_325116;
            double x_325242 = tmp1_325241 * tmp1_325241;
            double y_325243 = tmp1_325241 * x_325242;
            double tmp2_325244 = 1.0 - y_325243;
            double x_325245 = tmp2_325244 * tmp2_325244;
            double tmp3_325246 = tmp2_325244 * x_325245;
            double tmp4_325247 = defunc_0_f_res_325235 * tmp3_325246;
            double defunc_0_f_res_325248;
            
            if (cond_325230) {
                defunc_0_f_res_325248 = 0.0;
            } else {
                int64_t i_325249 = add64(x_325115, i_325228);
                double defunc_0_add_arg_325250;
                
                defunc_0_add_arg_325250 =
                    ((double *) mem_313366.mem)[gtid_302529 *
                                                (defunc_0_f_res_292820 *
                                                 n_p_292677) + gtid_324713 *
                                                defunc_0_f_res_292820 +
                                                i_325249];
                defunc_0_f_res_325248 = defunc_0_add_arg_325250;
            }
            
            double x_325251 = a0_325150 * tmp4_325247;
            double defunc_9_fit_fun_res_325252 = defunc_0_f_res_325248 *
                   x_325251;
            double defunc_1_op_res_325253 = defunc_9_fit_fun_res_325252 +
                   redout_325229;
            double redout_tmp_325257 = defunc_1_op_res_325253;
            
            redout_325229 = redout_tmp_325257;
        }
        defunc_2_reduce_res_325160 = redout_325229;
        ((double *) mem_324715.mem)[gtid_325114] = defunc_2_reduce_res_325160;
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338220_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338220_end -
                 futhark_mc_segmap_parloop_338220_start;
        
        ctx->futhark_mc_segmap_parloop_338220_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338220_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338220_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_338218(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_325113 = tid;
    int num_tasks_325189 = info.nsubtasks;
    struct futhark_mc_task_338217 *futhark_mc_task_338217 =
                                  (struct futhark_mc_task_338217 *) args;
    struct futhark_context *ctx = futhark_mc_task_338217->ctx;
    uint64_t futhark_mc_segmap_task_338218_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_338218_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_338217->free_n_p_292677;
    int64_t q_s_292678 = futhark_mc_task_338217->free_q_s_292678;
    int64_t jump_s_292684 = futhark_mc_task_338217->free_jump_s_292684;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_338217->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_task_338217->free_pad_css_len_292821;
    int64_t s_n_m_292825 = futhark_mc_task_338217->free_s_n_m_292825;
    int64_t gtid_302529 = futhark_mc_task_338217->free_gtid_302529;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_task_338217->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_task_338217->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_task_338217->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_task_338217->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_task_338217->free_mem_313371,
                                  .size =0, .references =NULL};
    int64_t gtid_324713 = futhark_mc_task_338217->free_gtid_324713;
    int64_t x_324714 = futhark_mc_task_338217->free_x_324714;
    struct memblock mem_324715 = {.desc ="mem_324715", .mem =
                                  futhark_mc_task_338217->free_mem_324715,
                                  .size =0, .references =NULL};
    int64_t iter_325190;
    struct futhark_mc_segmap_parloop_struct_338219
    futhark_mc_segmap_parloop_struct_338219;
    
    futhark_mc_segmap_parloop_struct_338219.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338219.free_n_p_292677 = n_p_292677;
    futhark_mc_segmap_parloop_struct_338219.free_q_s_292678 = q_s_292678;
    futhark_mc_segmap_parloop_struct_338219.free_jump_s_292684 = jump_s_292684;
    futhark_mc_segmap_parloop_struct_338219.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segmap_parloop_struct_338219.free_pad_css_len_292821 =
        pad_css_len_292821;
    futhark_mc_segmap_parloop_struct_338219.free_s_n_m_292825 = s_n_m_292825;
    futhark_mc_segmap_parloop_struct_338219.free_gtid_302529 = gtid_302529;
    futhark_mc_segmap_parloop_struct_338219.free_mem_312838 = mem_312838.mem;
    futhark_mc_segmap_parloop_struct_338219.free_mem_313018 = mem_313018.mem;
    futhark_mc_segmap_parloop_struct_338219.free_mem_313023 = mem_313023.mem;
    futhark_mc_segmap_parloop_struct_338219.free_mem_313366 = mem_313366.mem;
    futhark_mc_segmap_parloop_struct_338219.free_mem_313371 = mem_313371.mem;
    futhark_mc_segmap_parloop_struct_338219.free_gtid_324713 = gtid_324713;
    futhark_mc_segmap_parloop_struct_338219.free_x_324714 = x_324714;
    futhark_mc_segmap_parloop_struct_338219.free_mem_324715 = mem_324715.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338220_task;
    
    futhark_mc_segmap_parloop_338220_task.name =
        "futhark_mc_segmap_parloop_338220";
    futhark_mc_segmap_parloop_338220_task.fn = futhark_mc_segmap_parloop_338220;
    futhark_mc_segmap_parloop_338220_task.args =
        &futhark_mc_segmap_parloop_struct_338219;
    futhark_mc_segmap_parloop_338220_task.iterations = iterations;
    futhark_mc_segmap_parloop_338220_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338220_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338220_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338220_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338220_task);
    
    if (futhark_mc_segmap_parloop_338220_err != 0) {
        err = futhark_mc_segmap_parloop_338220_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338220_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338220_total_end -
                 futhark_mc_segmap_parloop_338220_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338220_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338220_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338220_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_338218_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_338218_end -
                 futhark_mc_segmap_task_338218_start;
        
        ctx->futhark_mc_segmap_task_338218_runs[tid]++;
        ctx->futhark_mc_segmap_task_338218_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_338218_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_segmap_parloop_struct_338222 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_q_s_292678;
    int64_t free_jump_s_292684;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    int64_t free_gtid_302529;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_313018;
    unsigned char *free_mem_313023;
    unsigned char *free_mem_313366;
    unsigned char *free_mem_313371;
    int64_t free_gtid_324713;
    int64_t free_x_324714;
    unsigned char *free_mem_324715;
};
struct futhark_mc_task_338224 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_gtid_302529;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_313371;
    int64_t free_gtid_324713;
    int64_t free_x_324714;
    int64_t free_x_325037;
    double free_x_325038;
    int64_t free_defunc_0_m_fun_res_325040;
    double *retval_defunc_2_reduce_res_325049;
};
struct futhark_mc_segred_stage_1_parloop_struct_338227 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_gtid_302529;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_313371;
    int64_t free_gtid_324713;
    int64_t free_x_324714;
    int64_t free_x_325037;
    double free_x_325038;
    int64_t free_defunc_0_m_fun_res_325040;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_325329;
};
static int futhark_mc_segred_stage_1_parloop_338228(void *args, int64_t start,
                                                    int64_t end,
                                                    int flat_tid_325267,
                                                    int tid)
{
    int err = 0;
    struct futhark_mc_segred_stage_1_parloop_struct_338227
    *futhark_mc_segred_stage_1_parloop_struct_338227 =
    (struct futhark_mc_segred_stage_1_parloop_struct_338227 *) args;
    struct futhark_context *ctx =
                           futhark_mc_segred_stage_1_parloop_struct_338227->ctx;
    uint64_t futhark_mc_segred_stage_1_parloop_338228_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_338228_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segred_stage_1_parloop_struct_338227->free_n_p_292677;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segred_stage_1_parloop_struct_338227->free_defunc_0_f_res_292820;
    int64_t gtid_302529 =
            futhark_mc_segred_stage_1_parloop_struct_338227->free_gtid_302529;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_338227->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_338227->free_mem_313371,
                                  .size =0, .references =NULL};
    int64_t gtid_324713 =
            futhark_mc_segred_stage_1_parloop_struct_338227->free_gtid_324713;
    int64_t x_324714 =
            futhark_mc_segred_stage_1_parloop_struct_338227->free_x_324714;
    int64_t x_325037 =
            futhark_mc_segred_stage_1_parloop_struct_338227->free_x_325037;
    double x_325038 =
           futhark_mc_segred_stage_1_parloop_struct_338227->free_x_325038;
    int64_t defunc_0_m_fun_res_325040 =
            futhark_mc_segred_stage_1_parloop_struct_338227->free_defunc_0_m_fun_res_325040;
    struct memblock reduce_stage_1_tid_res_arr_mem_325329 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_325329",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338227->free_reduce_stage_1_tid_res_arr_mem_325329,
                                                             .size =0,
                                                             .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_325331 = start;
    double x_325269;
    double x_325270;
    double local_acc_325332 = 0.0;
    
    for (; iter_325331 < end; iter_325331++) {
        int64_t gtid_325268 = iter_325331;
        bool cond_325272 = sle64(x_324714, gtid_325268);
        int64_t defunc_0_f_res_325273;
        
        if (cond_325272) {
            defunc_0_f_res_325273 = (int64_t) 0;
        } else {
            int64_t i_325274 = add64(x_325037, gtid_325268);
            int64_t defunc_0_add_arg_325275;
            
            defunc_0_add_arg_325275 = ((int64_t *) mem_312838.mem)[gtid_302529 *
                                                                   (defunc_0_f_res_292820 *
                                                                    n_p_292677) +
                                                                   gtid_324713 *
                                                                   defunc_0_f_res_292820 +
                                                                   i_325274];
            
            int64_t defunc_1_add_res_325276 = add64((int64_t) 1,
                                                    defunc_0_add_arg_325275);
            
            defunc_0_f_res_325273 = defunc_1_add_res_325276;
        }
        
        double defunc_0_f_res_325277;
        
        if (cond_325272) {
            defunc_0_f_res_325277 = 0.0;
        } else {
            int64_t i_325278 = add64(x_325037, gtid_325268);
            double defunc_0_add_arg_325279;
            
            defunc_0_add_arg_325279 = ((double *) mem_313371.mem)[gtid_302529 *
                                                                  (defunc_0_f_res_292820 *
                                                                   n_p_292677) +
                                                                  gtid_324713 *
                                                                  defunc_0_f_res_292820 +
                                                                  i_325278];
            defunc_0_f_res_325277 = defunc_0_add_arg_325279;
        }
        
        int64_t binop_p_325280 = sub64(defunc_0_f_res_325273,
                                       defunc_0_m_fun_res_325040);
        double defunc_0_f_res_325281 = sitofp_i64_f64(binop_p_325280);
        double abs_res_325282 = fabs(defunc_0_f_res_325281);
        double tmp1_325283 = abs_res_325282 / x_325038;
        double x_325284 = tmp1_325283 * tmp1_325283;
        double y_325285 = tmp1_325283 * x_325284;
        double tmp2_325286 = 1.0 - y_325285;
        double x_325287 = tmp2_325286 * tmp2_325286;
        double tmp3_325288 = tmp2_325286 * x_325287;
        double w_j_325289 = defunc_0_f_res_325277 * tmp3_325288;
        
        // save map-out results
        { }
        // Load accum params
        {
            x_325269 = local_acc_325332;
        }
        // Load next params
        {
            x_325270 = w_j_325289;
        }
        // Red body
        {
            double defunc_1_op_res_325271 = x_325269 + x_325270;
            
            local_acc_325332 = defunc_1_op_res_325271;
        }
    }
    ((double *) reduce_stage_1_tid_res_arr_mem_325329.mem)[flat_tid_325267] =
        local_acc_325332;
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_338228_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_338228_end -
                 futhark_mc_segred_stage_1_parloop_338228_start;
        
        ctx->futhark_mc_segred_stage_1_parloop_338228_runs[tid]++;
        ctx->futhark_mc_segred_stage_1_parloop_338228_total_runtime[tid] +=
            elapsed;
        ctx->futhark_mc_segred_stage_1_parloop_338228_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segred_task_338225(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_325267 = tid;
    int num_tasks_325328 = info.nsubtasks;
    struct futhark_mc_task_338224 *futhark_mc_task_338224 =
                                  (struct futhark_mc_task_338224 *) args;
    struct futhark_context *ctx = futhark_mc_task_338224->ctx;
    uint64_t futhark_mc_segred_task_338225_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_task_338225_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_338224->free_n_p_292677;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_338224->free_defunc_0_f_res_292820;
    int64_t gtid_302529 = futhark_mc_task_338224->free_gtid_302529;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_task_338224->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_task_338224->free_mem_313371,
                                  .size =0, .references =NULL};
    int64_t gtid_324713 = futhark_mc_task_338224->free_gtid_324713;
    int64_t x_324714 = futhark_mc_task_338224->free_x_324714;
    int64_t x_325037 = futhark_mc_task_338224->free_x_325037;
    double x_325038 = futhark_mc_task_338224->free_x_325038;
    int64_t defunc_0_m_fun_res_325040 =
            futhark_mc_task_338224->free_defunc_0_m_fun_res_325040;
    double defunc_2_reduce_res_325049 =
           *futhark_mc_task_338224->retval_defunc_2_reduce_res_325049;
    size_t reduce_stage_1_tid_res_arr_mem_325329_cached_sizze_338226 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_325329 = NULL;
    
    if (reduce_stage_1_tid_res_arr_mem_325329_cached_sizze_338226 <
        (size_t) ((int64_t) 8 * num_tasks_325328)) {
        reduce_stage_1_tid_res_arr_mem_325329 =
            realloc(reduce_stage_1_tid_res_arr_mem_325329, (int64_t) 8 *
                    num_tasks_325328);
        reduce_stage_1_tid_res_arr_mem_325329_cached_sizze_338226 =
            (int64_t) 8 * num_tasks_325328;
    }
    
    int64_t iter_325331;
    struct futhark_mc_segred_stage_1_parloop_struct_338227
    futhark_mc_segred_stage_1_parloop_struct_338227;
    
    futhark_mc_segred_stage_1_parloop_struct_338227.ctx = ctx;
    futhark_mc_segred_stage_1_parloop_struct_338227.free_n_p_292677 =
        n_p_292677;
    futhark_mc_segred_stage_1_parloop_struct_338227.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segred_stage_1_parloop_struct_338227.free_gtid_302529 =
        gtid_302529;
    futhark_mc_segred_stage_1_parloop_struct_338227.free_mem_312838 =
        mem_312838.mem;
    futhark_mc_segred_stage_1_parloop_struct_338227.free_mem_313371 =
        mem_313371.mem;
    futhark_mc_segred_stage_1_parloop_struct_338227.free_gtid_324713 =
        gtid_324713;
    futhark_mc_segred_stage_1_parloop_struct_338227.free_x_324714 = x_324714;
    futhark_mc_segred_stage_1_parloop_struct_338227.free_x_325037 = x_325037;
    futhark_mc_segred_stage_1_parloop_struct_338227.free_x_325038 = x_325038;
    futhark_mc_segred_stage_1_parloop_struct_338227.free_defunc_0_m_fun_res_325040 =
        defunc_0_m_fun_res_325040;
    futhark_mc_segred_stage_1_parloop_struct_338227.free_reduce_stage_1_tid_res_arr_mem_325329 =
        reduce_stage_1_tid_res_arr_mem_325329;
    
    struct scheduler_parloop futhark_mc_segred_stage_1_parloop_338228_task;
    
    futhark_mc_segred_stage_1_parloop_338228_task.name =
        "futhark_mc_segred_stage_1_parloop_338228";
    futhark_mc_segred_stage_1_parloop_338228_task.fn =
        futhark_mc_segred_stage_1_parloop_338228;
    futhark_mc_segred_stage_1_parloop_338228_task.args =
        &futhark_mc_segred_stage_1_parloop_struct_338227;
    futhark_mc_segred_stage_1_parloop_338228_task.iterations = iterations;
    futhark_mc_segred_stage_1_parloop_338228_task.info = info;
    
    uint64_t futhark_mc_segred_stage_1_parloop_338228_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_338228_total_start = get_wall_time();
    
    int futhark_mc_segred_stage_1_parloop_338228_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segred_stage_1_parloop_338228_task);
    
    if (futhark_mc_segred_stage_1_parloop_338228_err != 0) {
        err = futhark_mc_segred_stage_1_parloop_338228_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_338228_total_end =
                 get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_338228_total_end -
                 futhark_mc_segred_stage_1_parloop_338228_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338228_total_runs,
                           1, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338228_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338228_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    // neutral-initialise the output
    {
        defunc_2_reduce_res_325049 = 0.0;
    }
    
    double x_325333;
    double x_325334;
    
    for (int32_t i_325336 = 0; i_325336 < num_tasks_325328; i_325336++) {
        flat_tid_325267 = i_325336;
        // Apply main thread reduction
        {
            // load acc params
            {
                x_325333 = defunc_2_reduce_res_325049;
            }
            // load next params
            {
                x_325334 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_325329)[flat_tid_325267];
            }
            // red body
            {
                double defunc_1_op_res_325335 = x_325333 + x_325334;
                
                defunc_2_reduce_res_325049 = defunc_1_op_res_325335;
            }
        }
    }
    
  cleanup:
    {
        free(reduce_stage_1_tid_res_arr_mem_325329);
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_task_338225_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_task_338225_end -
                 futhark_mc_segred_task_338225_start;
        
        ctx->futhark_mc_segred_task_338225_runs[tid]++;
        ctx->futhark_mc_segred_task_338225_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segred_task_338225_iter[tid] += iterations;
    }
    if (err == 0) {
        *futhark_mc_task_338224->retval_defunc_2_reduce_res_325049 =
            defunc_2_reduce_res_325049;
    }
    return err;
}
struct futhark_mc_task_338229 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_gtid_302529;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_313366;
    unsigned char *free_mem_313371;
    int64_t free_gtid_324713;
    int64_t free_x_324714;
    int64_t free_x_325037;
    double free_x_325038;
    double free_a0_325074;
    int64_t free_defunc_0_m_fun_res_325075;
    double *retval_defunc_2_reduce_res_325084;
};
struct futhark_mc_segred_stage_1_parloop_struct_338232 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_gtid_302529;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_313366;
    unsigned char *free_mem_313371;
    int64_t free_gtid_324713;
    int64_t free_x_324714;
    int64_t free_x_325037;
    double free_x_325038;
    double free_a0_325074;
    int64_t free_defunc_0_m_fun_res_325075;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_325338;
};
static int futhark_mc_segred_stage_1_parloop_338233(void *args, int64_t start,
                                                    int64_t end,
                                                    int flat_tid_325298,
                                                    int tid)
{
    int err = 0;
    struct futhark_mc_segred_stage_1_parloop_struct_338232
    *futhark_mc_segred_stage_1_parloop_struct_338232 =
    (struct futhark_mc_segred_stage_1_parloop_struct_338232 *) args;
    struct futhark_context *ctx =
                           futhark_mc_segred_stage_1_parloop_struct_338232->ctx;
    uint64_t futhark_mc_segred_stage_1_parloop_338233_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_338233_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segred_stage_1_parloop_struct_338232->free_n_p_292677;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segred_stage_1_parloop_struct_338232->free_defunc_0_f_res_292820;
    int64_t gtid_302529 =
            futhark_mc_segred_stage_1_parloop_struct_338232->free_gtid_302529;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_338232->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_338232->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_338232->free_mem_313371,
                                  .size =0, .references =NULL};
    int64_t gtid_324713 =
            futhark_mc_segred_stage_1_parloop_struct_338232->free_gtid_324713;
    int64_t x_324714 =
            futhark_mc_segred_stage_1_parloop_struct_338232->free_x_324714;
    int64_t x_325037 =
            futhark_mc_segred_stage_1_parloop_struct_338232->free_x_325037;
    double x_325038 =
           futhark_mc_segred_stage_1_parloop_struct_338232->free_x_325038;
    double a0_325074 =
           futhark_mc_segred_stage_1_parloop_struct_338232->free_a0_325074;
    int64_t defunc_0_m_fun_res_325075 =
            futhark_mc_segred_stage_1_parloop_struct_338232->free_defunc_0_m_fun_res_325075;
    struct memblock reduce_stage_1_tid_res_arr_mem_325338 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_325338",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338232->free_reduce_stage_1_tid_res_arr_mem_325338,
                                                             .size =0,
                                                             .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_325340 = start;
    double x_325300;
    double x_325301;
    double local_acc_325341 = 0.0;
    
    for (; iter_325340 < end; iter_325340++) {
        int64_t gtid_325299 = iter_325340;
        bool cond_325303 = sle64(x_324714, gtid_325299);
        int64_t defunc_0_f_res_325304;
        
        if (cond_325303) {
            defunc_0_f_res_325304 = (int64_t) 0;
        } else {
            int64_t i_325305 = add64(x_325037, gtid_325299);
            int64_t defunc_0_add_arg_325306;
            
            defunc_0_add_arg_325306 = ((int64_t *) mem_312838.mem)[gtid_302529 *
                                                                   (defunc_0_f_res_292820 *
                                                                    n_p_292677) +
                                                                   gtid_324713 *
                                                                   defunc_0_f_res_292820 +
                                                                   i_325305];
            
            int64_t defunc_1_add_res_325307 = add64((int64_t) 1,
                                                    defunc_0_add_arg_325306);
            
            defunc_0_f_res_325304 = defunc_1_add_res_325307;
        }
        
        double defunc_0_f_res_325308;
        
        if (cond_325303) {
            defunc_0_f_res_325308 = 0.0;
        } else {
            int64_t i_325309 = add64(x_325037, gtid_325299);
            double defunc_0_add_arg_325310;
            
            defunc_0_add_arg_325310 = ((double *) mem_313371.mem)[gtid_302529 *
                                                                  (defunc_0_f_res_292820 *
                                                                   n_p_292677) +
                                                                  gtid_324713 *
                                                                  defunc_0_f_res_292820 +
                                                                  i_325309];
            defunc_0_f_res_325308 = defunc_0_add_arg_325310;
        }
        
        int64_t binop_p_325311 = sub64(defunc_0_f_res_325304,
                                       defunc_0_m_fun_res_325075);
        double defunc_0_f_res_325312 = sitofp_i64_f64(binop_p_325311);
        double abs_res_325313 = fabs(defunc_0_f_res_325312);
        double tmp1_325314 = abs_res_325313 / x_325038;
        double x_325315 = tmp1_325314 * tmp1_325314;
        double y_325316 = tmp1_325314 * x_325315;
        double tmp2_325317 = 1.0 - y_325316;
        double x_325318 = tmp2_325317 * tmp2_325317;
        double tmp3_325319 = tmp2_325317 * x_325318;
        double tmp4_325320 = defunc_0_f_res_325308 * tmp3_325319;
        double defunc_0_f_res_325321;
        
        if (cond_325303) {
            defunc_0_f_res_325321 = 0.0;
        } else {
            int64_t i_325322 = add64(x_325037, gtid_325299);
            double defunc_0_add_arg_325323;
            
            defunc_0_add_arg_325323 = ((double *) mem_313366.mem)[gtid_302529 *
                                                                  (defunc_0_f_res_292820 *
                                                                   n_p_292677) +
                                                                  gtid_324713 *
                                                                  defunc_0_f_res_292820 +
                                                                  i_325322];
            defunc_0_f_res_325321 = defunc_0_add_arg_325323;
        }
        
        double x_325324 = a0_325074 * tmp4_325320;
        double defunc_9_fit_fun_res_325325 = defunc_0_f_res_325321 * x_325324;
        
        // save map-out results
        { }
        // Load accum params
        {
            x_325300 = local_acc_325341;
        }
        // Load next params
        {
            x_325301 = defunc_9_fit_fun_res_325325;
        }
        // Red body
        {
            double defunc_1_op_res_325302 = x_325300 + x_325301;
            
            local_acc_325341 = defunc_1_op_res_325302;
        }
    }
    ((double *) reduce_stage_1_tid_res_arr_mem_325338.mem)[flat_tid_325298] =
        local_acc_325341;
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_338233_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_338233_end -
                 futhark_mc_segred_stage_1_parloop_338233_start;
        
        ctx->futhark_mc_segred_stage_1_parloop_338233_runs[tid]++;
        ctx->futhark_mc_segred_stage_1_parloop_338233_total_runtime[tid] +=
            elapsed;
        ctx->futhark_mc_segred_stage_1_parloop_338233_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segred_task_338230(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_325298 = tid;
    int num_tasks_325337 = info.nsubtasks;
    struct futhark_mc_task_338229 *futhark_mc_task_338229 =
                                  (struct futhark_mc_task_338229 *) args;
    struct futhark_context *ctx = futhark_mc_task_338229->ctx;
    uint64_t futhark_mc_segred_task_338230_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_task_338230_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_338229->free_n_p_292677;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_338229->free_defunc_0_f_res_292820;
    int64_t gtid_302529 = futhark_mc_task_338229->free_gtid_302529;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_task_338229->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_task_338229->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_task_338229->free_mem_313371,
                                  .size =0, .references =NULL};
    int64_t gtid_324713 = futhark_mc_task_338229->free_gtid_324713;
    int64_t x_324714 = futhark_mc_task_338229->free_x_324714;
    int64_t x_325037 = futhark_mc_task_338229->free_x_325037;
    double x_325038 = futhark_mc_task_338229->free_x_325038;
    double a0_325074 = futhark_mc_task_338229->free_a0_325074;
    int64_t defunc_0_m_fun_res_325075 =
            futhark_mc_task_338229->free_defunc_0_m_fun_res_325075;
    double defunc_2_reduce_res_325084 =
           *futhark_mc_task_338229->retval_defunc_2_reduce_res_325084;
    size_t reduce_stage_1_tid_res_arr_mem_325338_cached_sizze_338231 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_325338 = NULL;
    
    if (reduce_stage_1_tid_res_arr_mem_325338_cached_sizze_338231 <
        (size_t) ((int64_t) 8 * num_tasks_325337)) {
        reduce_stage_1_tid_res_arr_mem_325338 =
            realloc(reduce_stage_1_tid_res_arr_mem_325338, (int64_t) 8 *
                    num_tasks_325337);
        reduce_stage_1_tid_res_arr_mem_325338_cached_sizze_338231 =
            (int64_t) 8 * num_tasks_325337;
    }
    
    int64_t iter_325340;
    struct futhark_mc_segred_stage_1_parloop_struct_338232
    futhark_mc_segred_stage_1_parloop_struct_338232;
    
    futhark_mc_segred_stage_1_parloop_struct_338232.ctx = ctx;
    futhark_mc_segred_stage_1_parloop_struct_338232.free_n_p_292677 =
        n_p_292677;
    futhark_mc_segred_stage_1_parloop_struct_338232.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segred_stage_1_parloop_struct_338232.free_gtid_302529 =
        gtid_302529;
    futhark_mc_segred_stage_1_parloop_struct_338232.free_mem_312838 =
        mem_312838.mem;
    futhark_mc_segred_stage_1_parloop_struct_338232.free_mem_313366 =
        mem_313366.mem;
    futhark_mc_segred_stage_1_parloop_struct_338232.free_mem_313371 =
        mem_313371.mem;
    futhark_mc_segred_stage_1_parloop_struct_338232.free_gtid_324713 =
        gtid_324713;
    futhark_mc_segred_stage_1_parloop_struct_338232.free_x_324714 = x_324714;
    futhark_mc_segred_stage_1_parloop_struct_338232.free_x_325037 = x_325037;
    futhark_mc_segred_stage_1_parloop_struct_338232.free_x_325038 = x_325038;
    futhark_mc_segred_stage_1_parloop_struct_338232.free_a0_325074 = a0_325074;
    futhark_mc_segred_stage_1_parloop_struct_338232.free_defunc_0_m_fun_res_325075 =
        defunc_0_m_fun_res_325075;
    futhark_mc_segred_stage_1_parloop_struct_338232.free_reduce_stage_1_tid_res_arr_mem_325338 =
        reduce_stage_1_tid_res_arr_mem_325338;
    
    struct scheduler_parloop futhark_mc_segred_stage_1_parloop_338233_task;
    
    futhark_mc_segred_stage_1_parloop_338233_task.name =
        "futhark_mc_segred_stage_1_parloop_338233";
    futhark_mc_segred_stage_1_parloop_338233_task.fn =
        futhark_mc_segred_stage_1_parloop_338233;
    futhark_mc_segred_stage_1_parloop_338233_task.args =
        &futhark_mc_segred_stage_1_parloop_struct_338232;
    futhark_mc_segred_stage_1_parloop_338233_task.iterations = iterations;
    futhark_mc_segred_stage_1_parloop_338233_task.info = info;
    
    uint64_t futhark_mc_segred_stage_1_parloop_338233_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_338233_total_start = get_wall_time();
    
    int futhark_mc_segred_stage_1_parloop_338233_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segred_stage_1_parloop_338233_task);
    
    if (futhark_mc_segred_stage_1_parloop_338233_err != 0) {
        err = futhark_mc_segred_stage_1_parloop_338233_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_338233_total_end =
                 get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_338233_total_end -
                 futhark_mc_segred_stage_1_parloop_338233_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338233_total_runs,
                           1, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338233_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338233_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    // neutral-initialise the output
    {
        defunc_2_reduce_res_325084 = 0.0;
    }
    
    double x_325342;
    double x_325343;
    
    for (int32_t i_325345 = 0; i_325345 < num_tasks_325337; i_325345++) {
        flat_tid_325298 = i_325345;
        // Apply main thread reduction
        {
            // load acc params
            {
                x_325342 = defunc_2_reduce_res_325084;
            }
            // load next params
            {
                x_325343 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_325338)[flat_tid_325298];
            }
            // red body
            {
                double defunc_1_op_res_325344 = x_325342 + x_325343;
                
                defunc_2_reduce_res_325084 = defunc_1_op_res_325344;
            }
        }
    }
    
  cleanup:
    {
        free(reduce_stage_1_tid_res_arr_mem_325338);
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_task_338230_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_task_338230_end -
                 futhark_mc_segred_task_338230_start;
        
        ctx->futhark_mc_segred_task_338230_runs[tid]++;
        ctx->futhark_mc_segred_task_338230_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segred_task_338230_iter[tid] += iterations;
    }
    if (err == 0) {
        *futhark_mc_task_338229->retval_defunc_2_reduce_res_325084 =
            defunc_2_reduce_res_325084;
    }
    return err;
}
static int futhark_mc_segmap_parloop_338223(void *args, int64_t start,
                                            int64_t end, int flat_tid_325035,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338222
    *futhark_mc_segmap_parloop_struct_338222 =
    (struct futhark_mc_segmap_parloop_struct_338222 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338222->ctx;
    uint64_t futhark_mc_segmap_parloop_338223_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338223_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segmap_parloop_struct_338222->free_n_p_292677;
    int64_t q_s_292678 =
            futhark_mc_segmap_parloop_struct_338222->free_q_s_292678;
    int64_t jump_s_292684 =
            futhark_mc_segmap_parloop_struct_338222->free_jump_s_292684;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segmap_parloop_struct_338222->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_segmap_parloop_struct_338222->free_pad_css_len_292821;
    int64_t s_n_m_292825 =
            futhark_mc_segmap_parloop_struct_338222->free_s_n_m_292825;
    int64_t gtid_302529 =
            futhark_mc_segmap_parloop_struct_338222->free_gtid_302529;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_segmap_parloop_struct_338222->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_segmap_parloop_struct_338222->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_segmap_parloop_struct_338222->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_segmap_parloop_struct_338222->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_segmap_parloop_struct_338222->free_mem_313371,
                                  .size =0, .references =NULL};
    int64_t gtid_324713 =
            futhark_mc_segmap_parloop_struct_338222->free_gtid_324713;
    int64_t x_324714 = futhark_mc_segmap_parloop_struct_338222->free_x_324714;
    struct memblock mem_324715 = {.desc ="mem_324715", .mem =
                                  futhark_mc_segmap_parloop_struct_338222->free_mem_324715,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_325258 = start;
    
    for (; iter_325258 < end; iter_325258++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_325326 = s_n_m_292825;
        int64_t gtid_325036 = iter_325258;
        int64_t remnant_325327 = iter_325258 - gtid_325036;
        int64_t x_325037;
        
        x_325037 = ((int64_t *) mem_313018.mem)[gtid_302529 * (s_n_m_292825 *
                                                               n_p_292677) +
                                                gtid_324713 * s_n_m_292825 +
                                                gtid_325036];
        
        double x_325038;
        
        x_325038 = ((double *) mem_313023.mem)[gtid_302529 * (s_n_m_292825 *
                                                              n_p_292677) +
                                               gtid_324713 * s_n_m_292825 +
                                               gtid_325036];
        
        bool cond_325039 = gtid_325036 == (int64_t) 0;
        int64_t defunc_0_m_fun_res_325040;
        
        if (cond_325039) {
            defunc_0_m_fun_res_325040 = (int64_t) 0;
        } else {
            int64_t y_325259 = sub64(s_n_m_292825, (int64_t) 1);
            bool cond_325260 = gtid_325036 == y_325259;
            int64_t defunc_0_m_fun_res_f_res_325261;
            
            if (cond_325260) {
                int64_t defunc_0_m_fun_res_f_res_t_res_325262 =
                        sub64(pad_css_len_292821, (int64_t) 1);
                
                defunc_0_m_fun_res_f_res_325261 =
                    defunc_0_m_fun_res_f_res_t_res_325262;
            } else {
                int64_t x_325263 = sub64(gtid_325036, (int64_t) 1);
                int64_t x_325264 = mul64(jump_s_292684, x_325263);
                int64_t min_arg_325265 = add64((int64_t) 1, x_325264);
                int64_t min_res_325266 = smin64(defunc_0_f_res_292820,
                                                min_arg_325265);
                
                defunc_0_m_fun_res_f_res_325261 = min_res_325266;
            }
            defunc_0_m_fun_res_325040 = defunc_0_m_fun_res_f_res_325261;
        }
        
        double defunc_2_reduce_res_325049;
        int64_t flat_tid_325267 = (int64_t) 0;
        int32_t num_tasks_325328;
        
        defunc_2_reduce_res_325049 = 0.0;
        
        struct futhark_mc_task_338224 futhark_mc_task_338224;
        
        futhark_mc_task_338224.ctx = ctx;
        futhark_mc_task_338224.free_n_p_292677 = n_p_292677;
        futhark_mc_task_338224.free_defunc_0_f_res_292820 =
            defunc_0_f_res_292820;
        futhark_mc_task_338224.free_gtid_302529 = gtid_302529;
        futhark_mc_task_338224.free_mem_312838 = mem_312838.mem;
        futhark_mc_task_338224.free_mem_313371 = mem_313371.mem;
        futhark_mc_task_338224.free_gtid_324713 = gtid_324713;
        futhark_mc_task_338224.free_x_324714 = x_324714;
        futhark_mc_task_338224.free_x_325037 = x_325037;
        futhark_mc_task_338224.free_x_325038 = x_325038;
        futhark_mc_task_338224.free_defunc_0_m_fun_res_325040 =
            defunc_0_m_fun_res_325040;
        futhark_mc_task_338224.retval_defunc_2_reduce_res_325049 =
            &defunc_2_reduce_res_325049;
        
        struct scheduler_segop futhark_mc_task_338224_task;
        
        futhark_mc_task_338224_task.args = &futhark_mc_task_338224;
        futhark_mc_task_338224_task.top_level_fn =
            futhark_mc_segred_task_338225;
        futhark_mc_task_338224_task.name = "futhark_mc_segred_task_338225";
        futhark_mc_task_338224_task.iterations = q_s_292678;
        futhark_mc_task_338224_task.task_time =
            &ctx->futhark_mc_segred_task_338225_total_time;
        futhark_mc_task_338224_task.task_iter =
            &ctx->futhark_mc_segred_task_338225_total_iter;
        futhark_mc_task_338224_task.sched = STATIC;
        futhark_mc_task_338224_task.nested_fn = NULL;
        
        int futhark_mc_segred_task_338225_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_338224_task);
        
        if (futhark_mc_segred_task_338225_err != 0) {
            ;
            err = futhark_mc_segred_task_338225_err;
            goto cleanup;
        }
        
        double a_325073 = 2.220446049250313e-16 + defunc_2_reduce_res_325049;
        double a0_325074 = 1.0 / a_325073;
        int64_t defunc_0_m_fun_res_325075;
        
        if (cond_325039) {
            defunc_0_m_fun_res_325075 = (int64_t) 0;
        } else {
            int64_t y_325290 = sub64(s_n_m_292825, (int64_t) 1);
            bool cond_325291 = gtid_325036 == y_325290;
            int64_t defunc_0_m_fun_res_f_res_325292;
            
            if (cond_325291) {
                int64_t defunc_0_m_fun_res_f_res_t_res_325293 =
                        sub64(pad_css_len_292821, (int64_t) 1);
                
                defunc_0_m_fun_res_f_res_325292 =
                    defunc_0_m_fun_res_f_res_t_res_325293;
            } else {
                int64_t x_325294 = sub64(gtid_325036, (int64_t) 1);
                int64_t x_325295 = mul64(jump_s_292684, x_325294);
                int64_t min_arg_325296 = add64((int64_t) 1, x_325295);
                int64_t min_res_325297 = smin64(defunc_0_f_res_292820,
                                                min_arg_325296);
                
                defunc_0_m_fun_res_f_res_325292 = min_res_325297;
            }
            defunc_0_m_fun_res_325075 = defunc_0_m_fun_res_f_res_325292;
        }
        
        double defunc_2_reduce_res_325084;
        int64_t flat_tid_325298 = (int64_t) 0;
        int32_t num_tasks_325337;
        
        defunc_2_reduce_res_325084 = 0.0;
        
        struct futhark_mc_task_338229 futhark_mc_task_338229;
        
        futhark_mc_task_338229.ctx = ctx;
        futhark_mc_task_338229.free_n_p_292677 = n_p_292677;
        futhark_mc_task_338229.free_defunc_0_f_res_292820 =
            defunc_0_f_res_292820;
        futhark_mc_task_338229.free_gtid_302529 = gtid_302529;
        futhark_mc_task_338229.free_mem_312838 = mem_312838.mem;
        futhark_mc_task_338229.free_mem_313366 = mem_313366.mem;
        futhark_mc_task_338229.free_mem_313371 = mem_313371.mem;
        futhark_mc_task_338229.free_gtid_324713 = gtid_324713;
        futhark_mc_task_338229.free_x_324714 = x_324714;
        futhark_mc_task_338229.free_x_325037 = x_325037;
        futhark_mc_task_338229.free_x_325038 = x_325038;
        futhark_mc_task_338229.free_a0_325074 = a0_325074;
        futhark_mc_task_338229.free_defunc_0_m_fun_res_325075 =
            defunc_0_m_fun_res_325075;
        futhark_mc_task_338229.retval_defunc_2_reduce_res_325084 =
            &defunc_2_reduce_res_325084;
        
        struct scheduler_segop futhark_mc_task_338229_task;
        
        futhark_mc_task_338229_task.args = &futhark_mc_task_338229;
        futhark_mc_task_338229_task.top_level_fn =
            futhark_mc_segred_task_338230;
        futhark_mc_task_338229_task.name = "futhark_mc_segred_task_338230";
        futhark_mc_task_338229_task.iterations = q_s_292678;
        futhark_mc_task_338229_task.task_time =
            &ctx->futhark_mc_segred_task_338230_total_time;
        futhark_mc_task_338229_task.task_iter =
            &ctx->futhark_mc_segred_task_338230_total_iter;
        futhark_mc_task_338229_task.sched = STATIC;
        futhark_mc_task_338229_task.nested_fn = NULL;
        
        int futhark_mc_segred_task_338230_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_338229_task);
        
        if (futhark_mc_segred_task_338230_err != 0) {
            ;
            err = futhark_mc_segred_task_338230_err;
            goto cleanup;
        }
        ((double *) mem_324715.mem)[gtid_325036] = defunc_2_reduce_res_325084;
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338223_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338223_end -
                 futhark_mc_segmap_parloop_338223_start;
        
        ctx->futhark_mc_segmap_parloop_338223_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338223_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338223_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_nested_task_338221(void *args, int64_t iterations,
                                         int tid, struct scheduler_info info)
{
    int err = 0;
    int flat_tid_325035 = tid;
    int num_tasks_325189 = info.nsubtasks;
    struct futhark_mc_task_338217 *futhark_mc_task_338217 =
                                  (struct futhark_mc_task_338217 *) args;
    struct futhark_context *ctx = futhark_mc_task_338217->ctx;
    uint64_t futhark_mc_segmap_nested_task_338221_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_nested_task_338221_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_338217->free_n_p_292677;
    int64_t q_s_292678 = futhark_mc_task_338217->free_q_s_292678;
    int64_t jump_s_292684 = futhark_mc_task_338217->free_jump_s_292684;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_338217->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_task_338217->free_pad_css_len_292821;
    int64_t s_n_m_292825 = futhark_mc_task_338217->free_s_n_m_292825;
    int64_t gtid_302529 = futhark_mc_task_338217->free_gtid_302529;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_task_338217->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_task_338217->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_task_338217->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_task_338217->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_task_338217->free_mem_313371,
                                  .size =0, .references =NULL};
    int64_t gtid_324713 = futhark_mc_task_338217->free_gtid_324713;
    int64_t x_324714 = futhark_mc_task_338217->free_x_324714;
    struct memblock mem_324715 = {.desc ="mem_324715", .mem =
                                  futhark_mc_task_338217->free_mem_324715,
                                  .size =0, .references =NULL};
    int64_t iter_325258;
    struct futhark_mc_segmap_parloop_struct_338222
    futhark_mc_segmap_parloop_struct_338222;
    
    futhark_mc_segmap_parloop_struct_338222.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338222.free_n_p_292677 = n_p_292677;
    futhark_mc_segmap_parloop_struct_338222.free_q_s_292678 = q_s_292678;
    futhark_mc_segmap_parloop_struct_338222.free_jump_s_292684 = jump_s_292684;
    futhark_mc_segmap_parloop_struct_338222.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segmap_parloop_struct_338222.free_pad_css_len_292821 =
        pad_css_len_292821;
    futhark_mc_segmap_parloop_struct_338222.free_s_n_m_292825 = s_n_m_292825;
    futhark_mc_segmap_parloop_struct_338222.free_gtid_302529 = gtid_302529;
    futhark_mc_segmap_parloop_struct_338222.free_mem_312838 = mem_312838.mem;
    futhark_mc_segmap_parloop_struct_338222.free_mem_313018 = mem_313018.mem;
    futhark_mc_segmap_parloop_struct_338222.free_mem_313023 = mem_313023.mem;
    futhark_mc_segmap_parloop_struct_338222.free_mem_313366 = mem_313366.mem;
    futhark_mc_segmap_parloop_struct_338222.free_mem_313371 = mem_313371.mem;
    futhark_mc_segmap_parloop_struct_338222.free_gtid_324713 = gtid_324713;
    futhark_mc_segmap_parloop_struct_338222.free_x_324714 = x_324714;
    futhark_mc_segmap_parloop_struct_338222.free_mem_324715 = mem_324715.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338223_task;
    
    futhark_mc_segmap_parloop_338223_task.name =
        "futhark_mc_segmap_parloop_338223";
    futhark_mc_segmap_parloop_338223_task.fn = futhark_mc_segmap_parloop_338223;
    futhark_mc_segmap_parloop_338223_task.args =
        &futhark_mc_segmap_parloop_struct_338222;
    futhark_mc_segmap_parloop_338223_task.iterations = iterations;
    futhark_mc_segmap_parloop_338223_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338223_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338223_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338223_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338223_task);
    
    if (futhark_mc_segmap_parloop_338223_err != 0) {
        err = futhark_mc_segmap_parloop_338223_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338223_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338223_total_end -
                 futhark_mc_segmap_parloop_338223_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338223_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338223_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338223_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_nested_task_338221_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_nested_task_338221_end -
                 futhark_mc_segmap_nested_task_338221_start;
        
        ctx->futhark_mc_segmap_nested_task_338221_runs[tid]++;
        ctx->futhark_mc_segmap_nested_task_338221_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_nested_task_338221_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
static int futhark_mc_segmap_parloop_338215(void *args, int64_t start,
                                            int64_t end, int flat_tid_324712,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338214
    *futhark_mc_segmap_parloop_struct_338214 =
    (struct futhark_mc_segmap_parloop_struct_338214 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338214->ctx;
    uint64_t futhark_mc_segmap_parloop_338215_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338215_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segmap_parloop_struct_338214->free_n_p_292677;
    int64_t q_s_292678 =
            futhark_mc_segmap_parloop_struct_338214->free_q_s_292678;
    int64_t jump_s_292684 =
            futhark_mc_segmap_parloop_struct_338214->free_jump_s_292684;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segmap_parloop_struct_338214->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_segmap_parloop_struct_338214->free_pad_css_len_292821;
    int64_t s_n_m_292825 =
            futhark_mc_segmap_parloop_struct_338214->free_s_n_m_292825;
    int64_t gtid_302529 =
            futhark_mc_segmap_parloop_struct_338214->free_gtid_302529;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_segmap_parloop_struct_338214->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_312842 = {.desc ="mem_312842", .mem =
                                  futhark_mc_segmap_parloop_struct_338214->free_mem_312842,
                                  .size =0, .references =NULL};
    int64_t bytes_312847 =
            futhark_mc_segmap_parloop_struct_338214->free_bytes_312847;
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_segmap_parloop_struct_338214->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_segmap_parloop_struct_338214->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_segmap_parloop_struct_338214->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_segmap_parloop_struct_338214->free_mem_313371,
                                  .size =0, .references =NULL};
    struct memblock mem_314492 = {.desc ="mem_314492", .mem =
                                  futhark_mc_segmap_parloop_struct_338214->free_mem_314492,
                                  .size =0, .references =NULL};
    size_t mem_324715_cached_sizze_338216 = 0;
    unsigned char *mem_324715 = NULL;
    int64_t iterations = end - start;
    int64_t iter_325034 = start;
    
    if (mem_324715_cached_sizze_338216 < (size_t) bytes_312847) {
        mem_324715 = realloc(mem_324715, bytes_312847);
        mem_324715_cached_sizze_338216 = bytes_312847;
    }
    for (; iter_325034 < end; iter_325034++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_325187 = n_p_292677;
        int64_t gtid_324713 = iter_325034;
        int64_t remnant_325188 = iter_325034 - gtid_324713;
        int64_t x_324714;
        
        x_324714 = ((int64_t *) mem_312842.mem)[gtid_302529 * n_p_292677 +
                                                gtid_324713];
        
        int64_t flat_tid_325113 = (int64_t) 0;
        int32_t num_tasks_325189;
        int64_t flat_tid_325035 = (int64_t) 0;
        struct futhark_mc_task_338217 futhark_mc_task_338217;
        
        futhark_mc_task_338217.ctx = ctx;
        futhark_mc_task_338217.free_n_p_292677 = n_p_292677;
        futhark_mc_task_338217.free_q_s_292678 = q_s_292678;
        futhark_mc_task_338217.free_jump_s_292684 = jump_s_292684;
        futhark_mc_task_338217.free_defunc_0_f_res_292820 =
            defunc_0_f_res_292820;
        futhark_mc_task_338217.free_pad_css_len_292821 = pad_css_len_292821;
        futhark_mc_task_338217.free_s_n_m_292825 = s_n_m_292825;
        futhark_mc_task_338217.free_gtid_302529 = gtid_302529;
        futhark_mc_task_338217.free_mem_312838 = mem_312838.mem;
        futhark_mc_task_338217.free_mem_313018 = mem_313018.mem;
        futhark_mc_task_338217.free_mem_313023 = mem_313023.mem;
        futhark_mc_task_338217.free_mem_313366 = mem_313366.mem;
        futhark_mc_task_338217.free_mem_313371 = mem_313371.mem;
        futhark_mc_task_338217.free_gtid_324713 = gtid_324713;
        futhark_mc_task_338217.free_x_324714 = x_324714;
        futhark_mc_task_338217.free_mem_324715 = mem_324715;
        
        struct scheduler_segop futhark_mc_task_338217_task;
        
        futhark_mc_task_338217_task.args = &futhark_mc_task_338217;
        futhark_mc_task_338217_task.top_level_fn =
            futhark_mc_segmap_task_338218;
        futhark_mc_task_338217_task.name = "futhark_mc_segmap_task_338218";
        futhark_mc_task_338217_task.iterations = s_n_m_292825;
        futhark_mc_task_338217_task.task_time =
            &ctx->futhark_mc_segmap_task_338218_total_time;
        futhark_mc_task_338217_task.task_iter =
            &ctx->futhark_mc_segmap_task_338218_total_iter;
        futhark_mc_task_338217_task.sched = STATIC;
        futhark_mc_task_338217_task.nested_fn =
            futhark_mc_segmap_nested_task_338221;
        
        int futhark_mc_segmap_task_338218_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_338217_task);
        
        if (futhark_mc_segmap_task_338218_err != 0) {
            ;
            err = futhark_mc_segmap_task_338218_err;
            goto cleanup;
        }
        if (s_n_m_292825 * (int64_t) 8 > 0)
            memmove(mem_314492.mem + gtid_324713 * s_n_m_292825 * (int64_t) 8,
                    mem_324715 + (int64_t) 0, s_n_m_292825 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_324715);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338215_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338215_end -
                 futhark_mc_segmap_parloop_338215_start;
        
        ctx->futhark_mc_segmap_parloop_338215_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338215_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338215_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_nested_task_338213(void *args, int64_t iterations,
                                         int tid, struct scheduler_info info)
{
    int err = 0;
    int flat_tid_324712 = tid;
    int num_tasks_324952 = info.nsubtasks;
    struct futhark_mc_task_338208 *futhark_mc_task_338208 =
                                  (struct futhark_mc_task_338208 *) args;
    struct futhark_context *ctx = futhark_mc_task_338208->ctx;
    uint64_t futhark_mc_segmap_nested_task_338213_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_nested_task_338213_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_338208->free_n_p_292677;
    int64_t q_s_292678 = futhark_mc_task_338208->free_q_s_292678;
    int64_t jump_s_292684 = futhark_mc_task_338208->free_jump_s_292684;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_338208->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_task_338208->free_pad_css_len_292821;
    int64_t s_n_m_292825 = futhark_mc_task_338208->free_s_n_m_292825;
    int64_t gtid_302529 = futhark_mc_task_338208->free_gtid_302529;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_task_338208->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_312842 = {.desc ="mem_312842", .mem =
                                  futhark_mc_task_338208->free_mem_312842,
                                  .size =0, .references =NULL};
    int64_t bytes_312847 = futhark_mc_task_338208->free_bytes_312847;
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_task_338208->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_task_338208->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_task_338208->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_task_338208->free_mem_313371,
                                  .size =0, .references =NULL};
    struct memblock mem_314492 = {.desc ="mem_314492", .mem =
                                  futhark_mc_task_338208->free_mem_314492,
                                  .size =0, .references =NULL};
    int64_t iter_325034;
    struct futhark_mc_segmap_parloop_struct_338214
    futhark_mc_segmap_parloop_struct_338214;
    
    futhark_mc_segmap_parloop_struct_338214.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338214.free_n_p_292677 = n_p_292677;
    futhark_mc_segmap_parloop_struct_338214.free_q_s_292678 = q_s_292678;
    futhark_mc_segmap_parloop_struct_338214.free_jump_s_292684 = jump_s_292684;
    futhark_mc_segmap_parloop_struct_338214.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segmap_parloop_struct_338214.free_pad_css_len_292821 =
        pad_css_len_292821;
    futhark_mc_segmap_parloop_struct_338214.free_s_n_m_292825 = s_n_m_292825;
    futhark_mc_segmap_parloop_struct_338214.free_gtid_302529 = gtid_302529;
    futhark_mc_segmap_parloop_struct_338214.free_mem_312838 = mem_312838.mem;
    futhark_mc_segmap_parloop_struct_338214.free_mem_312842 = mem_312842.mem;
    futhark_mc_segmap_parloop_struct_338214.free_bytes_312847 = bytes_312847;
    futhark_mc_segmap_parloop_struct_338214.free_mem_313018 = mem_313018.mem;
    futhark_mc_segmap_parloop_struct_338214.free_mem_313023 = mem_313023.mem;
    futhark_mc_segmap_parloop_struct_338214.free_mem_313366 = mem_313366.mem;
    futhark_mc_segmap_parloop_struct_338214.free_mem_313371 = mem_313371.mem;
    futhark_mc_segmap_parloop_struct_338214.free_mem_314492 = mem_314492.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338215_task;
    
    futhark_mc_segmap_parloop_338215_task.name =
        "futhark_mc_segmap_parloop_338215";
    futhark_mc_segmap_parloop_338215_task.fn = futhark_mc_segmap_parloop_338215;
    futhark_mc_segmap_parloop_338215_task.args =
        &futhark_mc_segmap_parloop_struct_338214;
    futhark_mc_segmap_parloop_338215_task.iterations = iterations;
    futhark_mc_segmap_parloop_338215_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338215_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338215_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338215_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338215_task);
    
    if (futhark_mc_segmap_parloop_338215_err != 0) {
        err = futhark_mc_segmap_parloop_338215_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338215_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338215_total_end -
                 futhark_mc_segmap_parloop_338215_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338215_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338215_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338215_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_nested_task_338213_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_nested_task_338213_end -
                 futhark_mc_segmap_nested_task_338213_start;
        
        ctx->futhark_mc_segmap_nested_task_338213_runs[tid]++;
        ctx->futhark_mc_segmap_nested_task_338213_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_nested_task_338213_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
static int futhark_mc_segmap_parloop_338206(void *args, int64_t start,
                                            int64_t end, int flat_tid_302528,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338205
    *futhark_mc_segmap_parloop_struct_338205 =
    (struct futhark_mc_segmap_parloop_struct_338205 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338205->ctx;
    uint64_t futhark_mc_segmap_parloop_338206_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338206_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segmap_parloop_struct_338205->free_n_p_292677;
    int64_t q_s_292678 =
            futhark_mc_segmap_parloop_struct_338205->free_q_s_292678;
    int64_t jump_s_292684 =
            futhark_mc_segmap_parloop_struct_338205->free_jump_s_292684;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_338205->free_partition_sizze_292766;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segmap_parloop_struct_338205->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_segmap_parloop_struct_338205->free_pad_css_len_292821;
    int64_t s_n_m_292825 =
            futhark_mc_segmap_parloop_struct_338205->free_s_n_m_292825;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_segmap_parloop_struct_338205->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_312842 = {.desc ="mem_312842", .mem =
                                  futhark_mc_segmap_parloop_struct_338205->free_mem_312842,
                                  .size =0, .references =NULL};
    int64_t bytes_312847 =
            futhark_mc_segmap_parloop_struct_338205->free_bytes_312847;
    int64_t bytes_312899 =
            futhark_mc_segmap_parloop_struct_338205->free_bytes_312899;
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_segmap_parloop_struct_338205->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_segmap_parloop_struct_338205->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_segmap_parloop_struct_338205->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_segmap_parloop_struct_338205->free_mem_313371,
                                  .size =0, .references =NULL};
    struct memblock mem_314544 = {.desc ="mem_314544", .mem =
                                  futhark_mc_segmap_parloop_struct_338205->free_mem_314544,
                                  .size =0, .references =NULL};
    size_t mem_314492_cached_sizze_338207 = 0;
    unsigned char *mem_314492 = NULL;
    int64_t iterations = end - start;
    int64_t iter_324711 = start;
    
    if (mem_314492_cached_sizze_338207 < (size_t) bytes_312899) {
        mem_314492 = realloc(mem_314492, bytes_312899);
        mem_314492_cached_sizze_338207 = bytes_312899;
    }
    for (; iter_324711 < end; iter_324711++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_324950 = partition_sizze_292766;
        int64_t gtid_302529 = iter_324711;
        int64_t remnant_324951 = iter_324711 - gtid_302529;
        int64_t flat_tid_324869 = (int64_t) 0;
        int32_t num_tasks_324952;
        int64_t flat_tid_324712 = (int64_t) 0;
        struct futhark_mc_task_338208 futhark_mc_task_338208;
        
        futhark_mc_task_338208.ctx = ctx;
        futhark_mc_task_338208.free_n_p_292677 = n_p_292677;
        futhark_mc_task_338208.free_q_s_292678 = q_s_292678;
        futhark_mc_task_338208.free_jump_s_292684 = jump_s_292684;
        futhark_mc_task_338208.free_defunc_0_f_res_292820 =
            defunc_0_f_res_292820;
        futhark_mc_task_338208.free_pad_css_len_292821 = pad_css_len_292821;
        futhark_mc_task_338208.free_s_n_m_292825 = s_n_m_292825;
        futhark_mc_task_338208.free_gtid_302529 = gtid_302529;
        futhark_mc_task_338208.free_mem_312838 = mem_312838.mem;
        futhark_mc_task_338208.free_mem_312842 = mem_312842.mem;
        futhark_mc_task_338208.free_bytes_312847 = bytes_312847;
        futhark_mc_task_338208.free_mem_313018 = mem_313018.mem;
        futhark_mc_task_338208.free_mem_313023 = mem_313023.mem;
        futhark_mc_task_338208.free_mem_313366 = mem_313366.mem;
        futhark_mc_task_338208.free_mem_313371 = mem_313371.mem;
        futhark_mc_task_338208.free_mem_314492 = mem_314492;
        
        struct scheduler_segop futhark_mc_task_338208_task;
        
        futhark_mc_task_338208_task.args = &futhark_mc_task_338208;
        futhark_mc_task_338208_task.top_level_fn =
            futhark_mc_segmap_task_338209;
        futhark_mc_task_338208_task.name = "futhark_mc_segmap_task_338209";
        futhark_mc_task_338208_task.iterations = n_p_292677;
        futhark_mc_task_338208_task.task_time =
            &ctx->futhark_mc_segmap_task_338209_total_time;
        futhark_mc_task_338208_task.task_iter =
            &ctx->futhark_mc_segmap_task_338209_total_iter;
        futhark_mc_task_338208_task.sched = STATIC;
        futhark_mc_task_338208_task.nested_fn =
            futhark_mc_segmap_nested_task_338213;
        
        int futhark_mc_segmap_task_338209_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_338208_task);
        
        if (futhark_mc_segmap_task_338209_err != 0) {
            ;
            err = futhark_mc_segmap_task_338209_err;
            goto cleanup;
        }
        if (n_p_292677 * s_n_m_292825 * (int64_t) 8 > 0)
            memmove(mem_314544.mem + gtid_302529 * (s_n_m_292825 * n_p_292677) *
                    (int64_t) 8, mem_314492 + (int64_t) 0, n_p_292677 *
                    s_n_m_292825 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_314492);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338206_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338206_end -
                 futhark_mc_segmap_parloop_338206_start;
        
        ctx->futhark_mc_segmap_parloop_338206_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338206_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338206_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_nested_task_338204(void *args, int64_t iterations,
                                         int tid, struct scheduler_info info)
{
    int err = 0;
    int flat_tid_302528 = tid;
    int num_tasks_324624 = info.nsubtasks;
    struct futhark_mc_task_338199 *futhark_mc_task_338199 =
                                  (struct futhark_mc_task_338199 *) args;
    struct futhark_context *ctx = futhark_mc_task_338199->ctx;
    uint64_t futhark_mc_segmap_nested_task_338204_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_nested_task_338204_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_338199->free_n_p_292677;
    int64_t q_s_292678 = futhark_mc_task_338199->free_q_s_292678;
    int64_t jump_s_292684 = futhark_mc_task_338199->free_jump_s_292684;
    int64_t partition_sizze_292766 =
            futhark_mc_task_338199->free_partition_sizze_292766;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_338199->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_task_338199->free_pad_css_len_292821;
    int64_t s_n_m_292825 = futhark_mc_task_338199->free_s_n_m_292825;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_task_338199->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_312842 = {.desc ="mem_312842", .mem =
                                  futhark_mc_task_338199->free_mem_312842,
                                  .size =0, .references =NULL};
    int64_t bytes_312847 = futhark_mc_task_338199->free_bytes_312847;
    int64_t bytes_312899 = futhark_mc_task_338199->free_bytes_312899;
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_task_338199->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_task_338199->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_task_338199->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_task_338199->free_mem_313371,
                                  .size =0, .references =NULL};
    struct memblock mem_314544 = {.desc ="mem_314544", .mem =
                                  futhark_mc_task_338199->free_mem_314544,
                                  .size =0, .references =NULL};
    int64_t iter_324711;
    struct futhark_mc_segmap_parloop_struct_338205
    futhark_mc_segmap_parloop_struct_338205;
    
    futhark_mc_segmap_parloop_struct_338205.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338205.free_n_p_292677 = n_p_292677;
    futhark_mc_segmap_parloop_struct_338205.free_q_s_292678 = q_s_292678;
    futhark_mc_segmap_parloop_struct_338205.free_jump_s_292684 = jump_s_292684;
    futhark_mc_segmap_parloop_struct_338205.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_338205.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segmap_parloop_struct_338205.free_pad_css_len_292821 =
        pad_css_len_292821;
    futhark_mc_segmap_parloop_struct_338205.free_s_n_m_292825 = s_n_m_292825;
    futhark_mc_segmap_parloop_struct_338205.free_mem_312838 = mem_312838.mem;
    futhark_mc_segmap_parloop_struct_338205.free_mem_312842 = mem_312842.mem;
    futhark_mc_segmap_parloop_struct_338205.free_bytes_312847 = bytes_312847;
    futhark_mc_segmap_parloop_struct_338205.free_bytes_312899 = bytes_312899;
    futhark_mc_segmap_parloop_struct_338205.free_mem_313018 = mem_313018.mem;
    futhark_mc_segmap_parloop_struct_338205.free_mem_313023 = mem_313023.mem;
    futhark_mc_segmap_parloop_struct_338205.free_mem_313366 = mem_313366.mem;
    futhark_mc_segmap_parloop_struct_338205.free_mem_313371 = mem_313371.mem;
    futhark_mc_segmap_parloop_struct_338205.free_mem_314544 = mem_314544.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338206_task;
    
    futhark_mc_segmap_parloop_338206_task.name =
        "futhark_mc_segmap_parloop_338206";
    futhark_mc_segmap_parloop_338206_task.fn = futhark_mc_segmap_parloop_338206;
    futhark_mc_segmap_parloop_338206_task.args =
        &futhark_mc_segmap_parloop_struct_338205;
    futhark_mc_segmap_parloop_338206_task.iterations = iterations;
    futhark_mc_segmap_parloop_338206_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338206_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338206_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338206_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338206_task);
    
    if (futhark_mc_segmap_parloop_338206_err != 0) {
        err = futhark_mc_segmap_parloop_338206_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338206_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338206_total_end -
                 futhark_mc_segmap_parloop_338206_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338206_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338206_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338206_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_nested_task_338204_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_nested_task_338204_end -
                 futhark_mc_segmap_nested_task_338204_start;
        
        ctx->futhark_mc_segmap_nested_task_338204_runs[tid]++;
        ctx->futhark_mc_segmap_nested_task_338204_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_nested_task_338204_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_task_338234 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_q_s_292678;
    int64_t free_jump_s_292684;
    int64_t free_partition_sizze_292766;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_312842;
    int64_t free_bytes_312847;
    int64_t free_bytes_312899;
    unsigned char *free_mem_313018;
    unsigned char *free_mem_313023;
    unsigned char *free_mem_313366;
    unsigned char *free_mem_313371;
    unsigned char *free_mem_314687;
    unsigned char *free_mem_314692;
};
struct futhark_mc_segmap_parloop_struct_338236 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_q_s_292678;
    int64_t free_jump_s_292684;
    int64_t free_partition_sizze_292766;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_312842;
    int64_t free_bytes_312899;
    unsigned char *free_mem_313018;
    unsigned char *free_mem_313023;
    unsigned char *free_mem_313366;
    unsigned char *free_mem_313371;
    unsigned char *free_mem_314687;
    unsigned char *free_mem_314692;
};
static int futhark_mc_segmap_parloop_338237(void *args, int64_t start,
                                            int64_t end, int flat_tid_302788,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338236
    *futhark_mc_segmap_parloop_struct_338236 =
    (struct futhark_mc_segmap_parloop_struct_338236 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338236->ctx;
    uint64_t futhark_mc_segmap_parloop_338237_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338237_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segmap_parloop_struct_338236->free_n_p_292677;
    int64_t q_s_292678 =
            futhark_mc_segmap_parloop_struct_338236->free_q_s_292678;
    int64_t jump_s_292684 =
            futhark_mc_segmap_parloop_struct_338236->free_jump_s_292684;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_338236->free_partition_sizze_292766;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segmap_parloop_struct_338236->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_segmap_parloop_struct_338236->free_pad_css_len_292821;
    int64_t s_n_m_292825 =
            futhark_mc_segmap_parloop_struct_338236->free_s_n_m_292825;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_segmap_parloop_struct_338236->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_312842 = {.desc ="mem_312842", .mem =
                                  futhark_mc_segmap_parloop_struct_338236->free_mem_312842,
                                  .size =0, .references =NULL};
    int64_t bytes_312899 =
            futhark_mc_segmap_parloop_struct_338236->free_bytes_312899;
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_segmap_parloop_struct_338236->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_segmap_parloop_struct_338236->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_segmap_parloop_struct_338236->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_segmap_parloop_struct_338236->free_mem_313371,
                                  .size =0, .references =NULL};
    struct memblock mem_314687 = {.desc ="mem_314687", .mem =
                                  futhark_mc_segmap_parloop_struct_338236->free_mem_314687,
                                  .size =0, .references =NULL};
    struct memblock mem_314692 = {.desc ="mem_314692", .mem =
                                  futhark_mc_segmap_parloop_struct_338236->free_mem_314692,
                                  .size =0, .references =NULL};
    size_t mem_314592_cached_sizze_338238 = 0;
    unsigned char *mem_314592 = NULL;
    size_t mem_314596_cached_sizze_338239 = 0;
    unsigned char *mem_314596 = NULL;
    int64_t iterations = end - start;
    int64_t iter_325347 = start;
    
    if (mem_314592_cached_sizze_338238 < (size_t) bytes_312899) {
        mem_314592 = realloc(mem_314592, bytes_312899);
        mem_314592_cached_sizze_338238 = bytes_312899;
    }
    if (mem_314596_cached_sizze_338239 < (size_t) bytes_312899) {
        mem_314596 = realloc(mem_314596, bytes_312899);
        mem_314596_cached_sizze_338239 = bytes_312899;
    }
    for (; iter_325347 < end; iter_325347++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_325458 = partition_sizze_292766;
        int64_t gtid_302789 = iter_325347;
        int64_t remnant_325459 = iter_325347 - gtid_302789;
        
        for (int64_t i_325348 = 0; i_325348 < n_p_292677; i_325348++) {
            int64_t x_325351;
            
            x_325351 = ((int64_t *) mem_312842.mem)[gtid_302789 * n_p_292677 +
                                                    i_325348];
            for (int64_t i_325354 = 0; i_325354 < s_n_m_292825; i_325354++) {
                int64_t x_325357;
                
                x_325357 = ((int64_t *) mem_313018.mem)[gtid_302789 *
                                                        (s_n_m_292825 *
                                                         n_p_292677) +
                                                        i_325348 *
                                                        s_n_m_292825 +
                                                        i_325354];
                
                double x_325358;
                
                x_325358 = ((double *) mem_313023.mem)[gtid_302789 *
                                                       (s_n_m_292825 *
                                                        n_p_292677) + i_325348 *
                                                       s_n_m_292825 + i_325354];
                
                bool cond_325359 = i_325354 == (int64_t) 0;
                int64_t defunc_0_m_fun_res_325360;
                
                if (cond_325359) {
                    defunc_0_m_fun_res_325360 = (int64_t) 0;
                } else {
                    int64_t y_325361 = sub64(s_n_m_292825, (int64_t) 1);
                    bool cond_325362 = i_325354 == y_325361;
                    int64_t defunc_0_m_fun_res_f_res_325363;
                    
                    if (cond_325362) {
                        int64_t defunc_0_m_fun_res_f_res_t_res_325364 =
                                sub64(pad_css_len_292821, (int64_t) 1);
                        
                        defunc_0_m_fun_res_f_res_325363 =
                            defunc_0_m_fun_res_f_res_t_res_325364;
                    } else {
                        int64_t x_325365 = sub64(i_325354, (int64_t) 1);
                        int64_t x_325366 = mul64(jump_s_292684, x_325365);
                        int64_t min_arg_325367 = add64((int64_t) 1, x_325366);
                        int64_t min_res_325368 = smin64(defunc_0_f_res_292820,
                                                        min_arg_325367);
                        
                        defunc_0_m_fun_res_f_res_325363 = min_res_325368;
                    }
                    defunc_0_m_fun_res_325360 = defunc_0_m_fun_res_f_res_325363;
                }
                
                double defunc_2_reduce_res_325369;
                double defunc_2_reduce_res_325370;
                double defunc_2_reduce_res_325371;
                double redout_325373;
                double redout_325374;
                double redout_325375;
                
                redout_325373 = 0.0;
                redout_325374 = 0.0;
                redout_325375 = 0.0;
                for (int64_t i_325372 = 0; i_325372 < q_s_292678; i_325372++) {
                    bool cond_325376 = sle64(x_325351, i_325372);
                    int64_t defunc_0_f_res_325377;
                    
                    if (cond_325376) {
                        defunc_0_f_res_325377 = (int64_t) 0;
                    } else {
                        int64_t i_325378 = add64(x_325357, i_325372);
                        int64_t defunc_0_add_arg_325379;
                        
                        defunc_0_add_arg_325379 =
                            ((int64_t *) mem_312838.mem)[gtid_302789 *
                                                         (defunc_0_f_res_292820 *
                                                          n_p_292677) +
                                                         i_325348 *
                                                         defunc_0_f_res_292820 +
                                                         i_325378];
                        
                        int64_t defunc_1_add_res_325380 = add64((int64_t) 1,
                                                                defunc_0_add_arg_325379);
                        
                        defunc_0_f_res_325377 = defunc_1_add_res_325380;
                    }
                    
                    double defunc_0_f_res_325381;
                    
                    if (cond_325376) {
                        defunc_0_f_res_325381 = 0.0;
                    } else {
                        int64_t i_325382 = add64(x_325357, i_325372);
                        double defunc_0_add_arg_325383;
                        
                        defunc_0_add_arg_325383 =
                            ((double *) mem_313371.mem)[gtid_302789 *
                                                        (defunc_0_f_res_292820 *
                                                         n_p_292677) +
                                                        i_325348 *
                                                        defunc_0_f_res_292820 +
                                                        i_325382];
                        defunc_0_f_res_325381 = defunc_0_add_arg_325383;
                    }
                    
                    int64_t binop_p_325384 = sub64(defunc_0_f_res_325377,
                                                   defunc_0_m_fun_res_325360);
                    double defunc_0_f_res_325385 =
                           sitofp_i64_f64(binop_p_325384);
                    double abs_res_325386 = fabs(defunc_0_f_res_325385);
                    double tmp1_325387 = abs_res_325386 / x_325358;
                    double x_325388 = tmp1_325387 * tmp1_325387;
                    double y_325389 = tmp1_325387 * x_325388;
                    double tmp2_325390 = 1.0 - y_325389;
                    double x_325391 = tmp2_325390 * tmp2_325390;
                    double tmp3_325392 = tmp2_325390 * x_325391;
                    double w_j_325393 = defunc_0_f_res_325381 * tmp3_325392;
                    double xw_j_325394 = defunc_0_f_res_325385 * w_j_325393;
                    double x2w_j_325395 = defunc_0_f_res_325385 * xw_j_325394;
                    double defunc_1_op_res_325396 = w_j_325393 + redout_325373;
                    double defunc_1_op_res_325397 = xw_j_325394 + redout_325374;
                    double defunc_1_op_res_325398 = x2w_j_325395 +
                           redout_325375;
                    double redout_tmp_325464 = defunc_1_op_res_325396;
                    double redout_tmp_325465 = defunc_1_op_res_325397;
                    double redout_tmp_325466 = defunc_1_op_res_325398;
                    
                    redout_325373 = redout_tmp_325464;
                    redout_325374 = redout_tmp_325465;
                    redout_325375 = redout_tmp_325466;
                }
                defunc_2_reduce_res_325369 = redout_325373;
                defunc_2_reduce_res_325370 = redout_325374;
                defunc_2_reduce_res_325371 = redout_325375;
                
                double a_325399 = 2.220446049250313e-16 +
                       defunc_2_reduce_res_325369;
                double b_325400 = 2.220446049250313e-16 +
                       defunc_2_reduce_res_325370;
                double c_325401 = 2.220446049250313e-16 +
                       defunc_2_reduce_res_325371;
                double x_325402 = a_325399 * c_325401;
                double y_325403 = b_325400 * b_325400;
                double y_325404 = x_325402 - y_325403;
                double det1_325405 = 1.0 / y_325404;
                double a11_325406 = c_325401 * det1_325405;
                double x_325407 = 0.0 - b_325400;
                double b11_325408 = det1_325405 * x_325407;
                double c11_325409 = a_325399 * det1_325405;
                int64_t defunc_0_m_fun_res_325410;
                
                if (cond_325359) {
                    defunc_0_m_fun_res_325410 = (int64_t) 0;
                } else {
                    int64_t y_325411 = sub64(s_n_m_292825, (int64_t) 1);
                    bool cond_325412 = i_325354 == y_325411;
                    int64_t defunc_0_m_fun_res_f_res_325413;
                    
                    if (cond_325412) {
                        int64_t defunc_0_m_fun_res_f_res_t_res_325414 =
                                sub64(pad_css_len_292821, (int64_t) 1);
                        
                        defunc_0_m_fun_res_f_res_325413 =
                            defunc_0_m_fun_res_f_res_t_res_325414;
                    } else {
                        int64_t x_325415 = sub64(i_325354, (int64_t) 1);
                        int64_t x_325416 = mul64(jump_s_292684, x_325415);
                        int64_t min_arg_325417 = add64((int64_t) 1, x_325416);
                        int64_t min_res_325418 = smin64(defunc_0_f_res_292820,
                                                        min_arg_325417);
                        
                        defunc_0_m_fun_res_f_res_325413 = min_res_325418;
                    }
                    defunc_0_m_fun_res_325410 = defunc_0_m_fun_res_f_res_325413;
                }
                
                double defunc_2_reduce_res_325419;
                double defunc_2_reduce_res_325420;
                double redout_325422;
                double redout_325423;
                
                redout_325422 = 0.0;
                redout_325423 = 0.0;
                for (int64_t i_325421 = 0; i_325421 < q_s_292678; i_325421++) {
                    bool cond_325424 = sle64(x_325351, i_325421);
                    int64_t defunc_0_f_res_325425;
                    
                    if (cond_325424) {
                        defunc_0_f_res_325425 = (int64_t) 0;
                    } else {
                        int64_t i_325426 = add64(x_325357, i_325421);
                        int64_t defunc_0_add_arg_325427;
                        
                        defunc_0_add_arg_325427 =
                            ((int64_t *) mem_312838.mem)[gtid_302789 *
                                                         (defunc_0_f_res_292820 *
                                                          n_p_292677) +
                                                         i_325348 *
                                                         defunc_0_f_res_292820 +
                                                         i_325426];
                        
                        int64_t defunc_1_add_res_325428 = add64((int64_t) 1,
                                                                defunc_0_add_arg_325427);
                        
                        defunc_0_f_res_325425 = defunc_1_add_res_325428;
                    }
                    
                    double defunc_0_f_res_325429;
                    
                    if (cond_325424) {
                        defunc_0_f_res_325429 = 0.0;
                    } else {
                        int64_t i_325430 = add64(x_325357, i_325421);
                        double defunc_0_add_arg_325431;
                        
                        defunc_0_add_arg_325431 =
                            ((double *) mem_313371.mem)[gtid_302789 *
                                                        (defunc_0_f_res_292820 *
                                                         n_p_292677) +
                                                        i_325348 *
                                                        defunc_0_f_res_292820 +
                                                        i_325430];
                        defunc_0_f_res_325429 = defunc_0_add_arg_325431;
                    }
                    
                    int64_t binop_p_325432 = sub64(defunc_0_f_res_325425,
                                                   defunc_0_m_fun_res_325410);
                    double defunc_0_f_res_325433 =
                           sitofp_i64_f64(binop_p_325432);
                    double abs_res_325434 = fabs(defunc_0_f_res_325433);
                    double tmp1_325435 = abs_res_325434 / x_325358;
                    double x_325436 = tmp1_325435 * tmp1_325435;
                    double y_325437 = tmp1_325435 * x_325436;
                    double tmp2_325438 = 1.0 - y_325437;
                    double x_325439 = tmp2_325438 * tmp2_325438;
                    double tmp3_325440 = tmp2_325438 * x_325439;
                    double tmp4_325441 = defunc_0_f_res_325429 * tmp3_325440;
                    double defunc_1_f_res_325442 = defunc_0_f_res_325433 *
                           tmp4_325441;
                    double defunc_0_f_res_325443;
                    
                    if (cond_325424) {
                        defunc_0_f_res_325443 = 0.0;
                    } else {
                        int64_t i_325444 = add64(x_325357, i_325421);
                        double defunc_0_add_arg_325445;
                        
                        defunc_0_add_arg_325445 =
                            ((double *) mem_313366.mem)[gtid_302789 *
                                                        (defunc_0_f_res_292820 *
                                                         n_p_292677) +
                                                        i_325348 *
                                                        defunc_0_f_res_292820 +
                                                        i_325444];
                        defunc_0_f_res_325443 = defunc_0_add_arg_325445;
                    }
                    
                    double x_325446 = a11_325406 * tmp4_325441;
                    double y_325447 = b11_325408 * defunc_1_f_res_325442;
                    double x_325448 = x_325446 + y_325447;
                    double defunc_9_fit_fun_res_325449 = defunc_0_f_res_325443 *
                           x_325448;
                    double x_325450 = b11_325408 * tmp4_325441;
                    double y_325451 = c11_325409 * defunc_1_f_res_325442;
                    double x_325452 = x_325450 + y_325451;
                    double defunc_9_slope_fun_res_325453 =
                           defunc_0_f_res_325443 * x_325452;
                    double defunc_1_op_res_325454 =
                           defunc_9_fit_fun_res_325449 + redout_325422;
                    double defunc_1_op_res_325455 =
                           defunc_9_slope_fun_res_325453 + redout_325423;
                    double redout_tmp_325467 = defunc_1_op_res_325454;
                    double redout_tmp_325468 = defunc_1_op_res_325455;
                    
                    redout_325422 = redout_tmp_325467;
                    redout_325423 = redout_tmp_325468;
                }
                defunc_2_reduce_res_325419 = redout_325422;
                defunc_2_reduce_res_325420 = redout_325423;
                ((double *) mem_314592)[i_325348 * s_n_m_292825 + i_325354] =
                    defunc_2_reduce_res_325419;
                ((double *) mem_314596)[i_325348 * s_n_m_292825 + i_325354] =
                    defunc_2_reduce_res_325420;
            }
        }
        if (n_p_292677 * s_n_m_292825 * (int64_t) 8 > 0)
            memmove(mem_314687.mem + gtid_302789 * (s_n_m_292825 * n_p_292677) *
                    (int64_t) 8, mem_314592 + (int64_t) 0, n_p_292677 *
                    s_n_m_292825 * (int64_t) 8);
        if (n_p_292677 * s_n_m_292825 * (int64_t) 8 > 0)
            memmove(mem_314692.mem + gtid_302789 * (s_n_m_292825 * n_p_292677) *
                    (int64_t) 8, mem_314596 + (int64_t) 0, n_p_292677 *
                    s_n_m_292825 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_314592);
    free(mem_314596);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338237_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338237_end -
                 futhark_mc_segmap_parloop_338237_start;
        
        ctx->futhark_mc_segmap_parloop_338237_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338237_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338237_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_338235(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_302788 = tid;
    int num_tasks_325346 = info.nsubtasks;
    struct futhark_mc_task_338234 *futhark_mc_task_338234 =
                                  (struct futhark_mc_task_338234 *) args;
    struct futhark_context *ctx = futhark_mc_task_338234->ctx;
    uint64_t futhark_mc_segmap_task_338235_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_338235_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_338234->free_n_p_292677;
    int64_t q_s_292678 = futhark_mc_task_338234->free_q_s_292678;
    int64_t jump_s_292684 = futhark_mc_task_338234->free_jump_s_292684;
    int64_t partition_sizze_292766 =
            futhark_mc_task_338234->free_partition_sizze_292766;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_338234->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_task_338234->free_pad_css_len_292821;
    int64_t s_n_m_292825 = futhark_mc_task_338234->free_s_n_m_292825;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_task_338234->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_312842 = {.desc ="mem_312842", .mem =
                                  futhark_mc_task_338234->free_mem_312842,
                                  .size =0, .references =NULL};
    int64_t bytes_312847 = futhark_mc_task_338234->free_bytes_312847;
    int64_t bytes_312899 = futhark_mc_task_338234->free_bytes_312899;
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_task_338234->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_task_338234->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_task_338234->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_task_338234->free_mem_313371,
                                  .size =0, .references =NULL};
    struct memblock mem_314687 = {.desc ="mem_314687", .mem =
                                  futhark_mc_task_338234->free_mem_314687,
                                  .size =0, .references =NULL};
    struct memblock mem_314692 = {.desc ="mem_314692", .mem =
                                  futhark_mc_task_338234->free_mem_314692,
                                  .size =0, .references =NULL};
    int64_t iter_325347;
    struct futhark_mc_segmap_parloop_struct_338236
    futhark_mc_segmap_parloop_struct_338236;
    
    futhark_mc_segmap_parloop_struct_338236.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338236.free_n_p_292677 = n_p_292677;
    futhark_mc_segmap_parloop_struct_338236.free_q_s_292678 = q_s_292678;
    futhark_mc_segmap_parloop_struct_338236.free_jump_s_292684 = jump_s_292684;
    futhark_mc_segmap_parloop_struct_338236.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_338236.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segmap_parloop_struct_338236.free_pad_css_len_292821 =
        pad_css_len_292821;
    futhark_mc_segmap_parloop_struct_338236.free_s_n_m_292825 = s_n_m_292825;
    futhark_mc_segmap_parloop_struct_338236.free_mem_312838 = mem_312838.mem;
    futhark_mc_segmap_parloop_struct_338236.free_mem_312842 = mem_312842.mem;
    futhark_mc_segmap_parloop_struct_338236.free_bytes_312899 = bytes_312899;
    futhark_mc_segmap_parloop_struct_338236.free_mem_313018 = mem_313018.mem;
    futhark_mc_segmap_parloop_struct_338236.free_mem_313023 = mem_313023.mem;
    futhark_mc_segmap_parloop_struct_338236.free_mem_313366 = mem_313366.mem;
    futhark_mc_segmap_parloop_struct_338236.free_mem_313371 = mem_313371.mem;
    futhark_mc_segmap_parloop_struct_338236.free_mem_314687 = mem_314687.mem;
    futhark_mc_segmap_parloop_struct_338236.free_mem_314692 = mem_314692.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338237_task;
    
    futhark_mc_segmap_parloop_338237_task.name =
        "futhark_mc_segmap_parloop_338237";
    futhark_mc_segmap_parloop_338237_task.fn = futhark_mc_segmap_parloop_338237;
    futhark_mc_segmap_parloop_338237_task.args =
        &futhark_mc_segmap_parloop_struct_338236;
    futhark_mc_segmap_parloop_338237_task.iterations = iterations;
    futhark_mc_segmap_parloop_338237_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338237_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338237_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338237_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338237_task);
    
    if (futhark_mc_segmap_parloop_338237_err != 0) {
        err = futhark_mc_segmap_parloop_338237_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338237_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338237_total_end -
                 futhark_mc_segmap_parloop_338237_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338237_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338237_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338237_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_338235_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_338235_end -
                 futhark_mc_segmap_task_338235_start;
        
        ctx->futhark_mc_segmap_task_338235_runs[tid]++;
        ctx->futhark_mc_segmap_task_338235_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_338235_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_segmap_parloop_struct_338241 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_q_s_292678;
    int64_t free_jump_s_292684;
    int64_t free_partition_sizze_292766;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_312842;
    int64_t free_bytes_312847;
    int64_t free_bytes_312899;
    unsigned char *free_mem_313018;
    unsigned char *free_mem_313023;
    unsigned char *free_mem_313366;
    unsigned char *free_mem_313371;
    unsigned char *free_mem_314687;
    unsigned char *free_mem_314692;
};
struct futhark_mc_task_338245 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_q_s_292678;
    int64_t free_jump_s_292684;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    int64_t free_gtid_303144;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_312842;
    int64_t free_bytes_312847;
    unsigned char *free_mem_313018;
    unsigned char *free_mem_313023;
    unsigned char *free_mem_313366;
    unsigned char *free_mem_313371;
    unsigned char *free_mem_314584;
    unsigned char *free_mem_314588;
};
struct futhark_mc_segmap_parloop_struct_338247 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_q_s_292678;
    int64_t free_jump_s_292684;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    int64_t free_gtid_303144;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_312842;
    int64_t free_bytes_312847;
    unsigned char *free_mem_313018;
    unsigned char *free_mem_313023;
    unsigned char *free_mem_313366;
    unsigned char *free_mem_313371;
    unsigned char *free_mem_314584;
    unsigned char *free_mem_314588;
};
static int futhark_mc_segmap_parloop_338248(void *args, int64_t start,
                                            int64_t end, int flat_tid_325686,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338247
    *futhark_mc_segmap_parloop_struct_338247 =
    (struct futhark_mc_segmap_parloop_struct_338247 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338247->ctx;
    uint64_t futhark_mc_segmap_parloop_338248_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338248_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segmap_parloop_struct_338247->free_n_p_292677;
    int64_t q_s_292678 =
            futhark_mc_segmap_parloop_struct_338247->free_q_s_292678;
    int64_t jump_s_292684 =
            futhark_mc_segmap_parloop_struct_338247->free_jump_s_292684;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segmap_parloop_struct_338247->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_segmap_parloop_struct_338247->free_pad_css_len_292821;
    int64_t s_n_m_292825 =
            futhark_mc_segmap_parloop_struct_338247->free_s_n_m_292825;
    int64_t gtid_303144 =
            futhark_mc_segmap_parloop_struct_338247->free_gtid_303144;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_segmap_parloop_struct_338247->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_312842 = {.desc ="mem_312842", .mem =
                                  futhark_mc_segmap_parloop_struct_338247->free_mem_312842,
                                  .size =0, .references =NULL};
    int64_t bytes_312847 =
            futhark_mc_segmap_parloop_struct_338247->free_bytes_312847;
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_segmap_parloop_struct_338247->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_segmap_parloop_struct_338247->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_segmap_parloop_struct_338247->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_segmap_parloop_struct_338247->free_mem_313371,
                                  .size =0, .references =NULL};
    struct memblock mem_314584 = {.desc ="mem_314584", .mem =
                                  futhark_mc_segmap_parloop_struct_338247->free_mem_314584,
                                  .size =0, .references =NULL};
    struct memblock mem_314588 = {.desc ="mem_314588", .mem =
                                  futhark_mc_segmap_parloop_struct_338247->free_mem_314588,
                                  .size =0, .references =NULL};
    size_t mem_325689_cached_sizze_338249 = 0;
    unsigned char *mem_325689 = NULL;
    size_t mem_325691_cached_sizze_338250 = 0;
    unsigned char *mem_325691 = NULL;
    int64_t iterations = end - start;
    int64_t iter_325802 = start;
    
    if (mem_325689_cached_sizze_338249 < (size_t) bytes_312847) {
        mem_325689 = realloc(mem_325689, bytes_312847);
        mem_325689_cached_sizze_338249 = bytes_312847;
    }
    if (mem_325691_cached_sizze_338250 < (size_t) bytes_312847) {
        mem_325691 = realloc(mem_325691, bytes_312847);
        mem_325691_cached_sizze_338250 = bytes_312847;
    }
    for (; iter_325802 < end; iter_325802++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_325907 = n_p_292677;
        int64_t gtid_325687 = iter_325802;
        int64_t remnant_325908 = iter_325802 - gtid_325687;
        int64_t x_325688;
        
        x_325688 = ((int64_t *) mem_312842.mem)[gtid_303144 * n_p_292677 +
                                                gtid_325687];
        for (int64_t i_325803 = 0; i_325803 < s_n_m_292825; i_325803++) {
            int64_t x_325806;
            
            x_325806 = ((int64_t *) mem_313018.mem)[gtid_303144 *
                                                    (s_n_m_292825 *
                                                     n_p_292677) + gtid_325687 *
                                                    s_n_m_292825 + i_325803];
            
            double x_325807;
            
            x_325807 = ((double *) mem_313023.mem)[gtid_303144 * (s_n_m_292825 *
                                                                  n_p_292677) +
                                                   gtid_325687 * s_n_m_292825 +
                                                   i_325803];
            
            bool cond_325808 = i_325803 == (int64_t) 0;
            int64_t defunc_0_m_fun_res_325809;
            
            if (cond_325808) {
                defunc_0_m_fun_res_325809 = (int64_t) 0;
            } else {
                int64_t y_325810 = sub64(s_n_m_292825, (int64_t) 1);
                bool cond_325811 = i_325803 == y_325810;
                int64_t defunc_0_m_fun_res_f_res_325812;
                
                if (cond_325811) {
                    int64_t defunc_0_m_fun_res_f_res_t_res_325813 =
                            sub64(pad_css_len_292821, (int64_t) 1);
                    
                    defunc_0_m_fun_res_f_res_325812 =
                        defunc_0_m_fun_res_f_res_t_res_325813;
                } else {
                    int64_t x_325814 = sub64(i_325803, (int64_t) 1);
                    int64_t x_325815 = mul64(jump_s_292684, x_325814);
                    int64_t min_arg_325816 = add64((int64_t) 1, x_325815);
                    int64_t min_res_325817 = smin64(defunc_0_f_res_292820,
                                                    min_arg_325816);
                    
                    defunc_0_m_fun_res_f_res_325812 = min_res_325817;
                }
                defunc_0_m_fun_res_325809 = defunc_0_m_fun_res_f_res_325812;
            }
            
            double defunc_2_reduce_res_325818;
            double defunc_2_reduce_res_325819;
            double defunc_2_reduce_res_325820;
            double redout_325822;
            double redout_325823;
            double redout_325824;
            
            redout_325822 = 0.0;
            redout_325823 = 0.0;
            redout_325824 = 0.0;
            for (int64_t i_325821 = 0; i_325821 < q_s_292678; i_325821++) {
                bool cond_325825 = sle64(x_325688, i_325821);
                int64_t defunc_0_f_res_325826;
                
                if (cond_325825) {
                    defunc_0_f_res_325826 = (int64_t) 0;
                } else {
                    int64_t i_325827 = add64(x_325806, i_325821);
                    int64_t defunc_0_add_arg_325828;
                    
                    defunc_0_add_arg_325828 =
                        ((int64_t *) mem_312838.mem)[gtid_303144 *
                                                     (defunc_0_f_res_292820 *
                                                      n_p_292677) +
                                                     gtid_325687 *
                                                     defunc_0_f_res_292820 +
                                                     i_325827];
                    
                    int64_t defunc_1_add_res_325829 = add64((int64_t) 1,
                                                            defunc_0_add_arg_325828);
                    
                    defunc_0_f_res_325826 = defunc_1_add_res_325829;
                }
                
                double defunc_0_f_res_325830;
                
                if (cond_325825) {
                    defunc_0_f_res_325830 = 0.0;
                } else {
                    int64_t i_325831 = add64(x_325806, i_325821);
                    double defunc_0_add_arg_325832;
                    
                    defunc_0_add_arg_325832 =
                        ((double *) mem_313371.mem)[gtid_303144 *
                                                    (defunc_0_f_res_292820 *
                                                     n_p_292677) + gtid_325687 *
                                                    defunc_0_f_res_292820 +
                                                    i_325831];
                    defunc_0_f_res_325830 = defunc_0_add_arg_325832;
                }
                
                int64_t binop_p_325833 = sub64(defunc_0_f_res_325826,
                                               defunc_0_m_fun_res_325809);
                double defunc_0_f_res_325834 = sitofp_i64_f64(binop_p_325833);
                double abs_res_325835 = fabs(defunc_0_f_res_325834);
                double tmp1_325836 = abs_res_325835 / x_325807;
                double x_325837 = tmp1_325836 * tmp1_325836;
                double y_325838 = tmp1_325836 * x_325837;
                double tmp2_325839 = 1.0 - y_325838;
                double x_325840 = tmp2_325839 * tmp2_325839;
                double tmp3_325841 = tmp2_325839 * x_325840;
                double w_j_325842 = defunc_0_f_res_325830 * tmp3_325841;
                double xw_j_325843 = defunc_0_f_res_325834 * w_j_325842;
                double x2w_j_325844 = defunc_0_f_res_325834 * xw_j_325843;
                double defunc_1_op_res_325845 = w_j_325842 + redout_325822;
                double defunc_1_op_res_325846 = xw_j_325843 + redout_325823;
                double defunc_1_op_res_325847 = x2w_j_325844 + redout_325824;
                double redout_tmp_325911 = defunc_1_op_res_325845;
                double redout_tmp_325912 = defunc_1_op_res_325846;
                double redout_tmp_325913 = defunc_1_op_res_325847;
                
                redout_325822 = redout_tmp_325911;
                redout_325823 = redout_tmp_325912;
                redout_325824 = redout_tmp_325913;
            }
            defunc_2_reduce_res_325818 = redout_325822;
            defunc_2_reduce_res_325819 = redout_325823;
            defunc_2_reduce_res_325820 = redout_325824;
            
            double a_325848 = 2.220446049250313e-16 +
                   defunc_2_reduce_res_325818;
            double b_325849 = 2.220446049250313e-16 +
                   defunc_2_reduce_res_325819;
            double c_325850 = 2.220446049250313e-16 +
                   defunc_2_reduce_res_325820;
            double x_325851 = a_325848 * c_325850;
            double y_325852 = b_325849 * b_325849;
            double y_325853 = x_325851 - y_325852;
            double det1_325854 = 1.0 / y_325853;
            double a11_325855 = c_325850 * det1_325854;
            double x_325856 = 0.0 - b_325849;
            double b11_325857 = det1_325854 * x_325856;
            double c11_325858 = a_325848 * det1_325854;
            int64_t defunc_0_m_fun_res_325859;
            
            if (cond_325808) {
                defunc_0_m_fun_res_325859 = (int64_t) 0;
            } else {
                int64_t y_325860 = sub64(s_n_m_292825, (int64_t) 1);
                bool cond_325861 = i_325803 == y_325860;
                int64_t defunc_0_m_fun_res_f_res_325862;
                
                if (cond_325861) {
                    int64_t defunc_0_m_fun_res_f_res_t_res_325863 =
                            sub64(pad_css_len_292821, (int64_t) 1);
                    
                    defunc_0_m_fun_res_f_res_325862 =
                        defunc_0_m_fun_res_f_res_t_res_325863;
                } else {
                    int64_t x_325864 = sub64(i_325803, (int64_t) 1);
                    int64_t x_325865 = mul64(jump_s_292684, x_325864);
                    int64_t min_arg_325866 = add64((int64_t) 1, x_325865);
                    int64_t min_res_325867 = smin64(defunc_0_f_res_292820,
                                                    min_arg_325866);
                    
                    defunc_0_m_fun_res_f_res_325862 = min_res_325867;
                }
                defunc_0_m_fun_res_325859 = defunc_0_m_fun_res_f_res_325862;
            }
            
            double defunc_2_reduce_res_325868;
            double defunc_2_reduce_res_325869;
            double redout_325871;
            double redout_325872;
            
            redout_325871 = 0.0;
            redout_325872 = 0.0;
            for (int64_t i_325870 = 0; i_325870 < q_s_292678; i_325870++) {
                bool cond_325873 = sle64(x_325688, i_325870);
                int64_t defunc_0_f_res_325874;
                
                if (cond_325873) {
                    defunc_0_f_res_325874 = (int64_t) 0;
                } else {
                    int64_t i_325875 = add64(x_325806, i_325870);
                    int64_t defunc_0_add_arg_325876;
                    
                    defunc_0_add_arg_325876 =
                        ((int64_t *) mem_312838.mem)[gtid_303144 *
                                                     (defunc_0_f_res_292820 *
                                                      n_p_292677) +
                                                     gtid_325687 *
                                                     defunc_0_f_res_292820 +
                                                     i_325875];
                    
                    int64_t defunc_1_add_res_325877 = add64((int64_t) 1,
                                                            defunc_0_add_arg_325876);
                    
                    defunc_0_f_res_325874 = defunc_1_add_res_325877;
                }
                
                double defunc_0_f_res_325878;
                
                if (cond_325873) {
                    defunc_0_f_res_325878 = 0.0;
                } else {
                    int64_t i_325879 = add64(x_325806, i_325870);
                    double defunc_0_add_arg_325880;
                    
                    defunc_0_add_arg_325880 =
                        ((double *) mem_313371.mem)[gtid_303144 *
                                                    (defunc_0_f_res_292820 *
                                                     n_p_292677) + gtid_325687 *
                                                    defunc_0_f_res_292820 +
                                                    i_325879];
                    defunc_0_f_res_325878 = defunc_0_add_arg_325880;
                }
                
                int64_t binop_p_325881 = sub64(defunc_0_f_res_325874,
                                               defunc_0_m_fun_res_325859);
                double defunc_0_f_res_325882 = sitofp_i64_f64(binop_p_325881);
                double abs_res_325883 = fabs(defunc_0_f_res_325882);
                double tmp1_325884 = abs_res_325883 / x_325807;
                double x_325885 = tmp1_325884 * tmp1_325884;
                double y_325886 = tmp1_325884 * x_325885;
                double tmp2_325887 = 1.0 - y_325886;
                double x_325888 = tmp2_325887 * tmp2_325887;
                double tmp3_325889 = tmp2_325887 * x_325888;
                double tmp4_325890 = defunc_0_f_res_325878 * tmp3_325889;
                double defunc_1_f_res_325891 = defunc_0_f_res_325882 *
                       tmp4_325890;
                double defunc_0_f_res_325892;
                
                if (cond_325873) {
                    defunc_0_f_res_325892 = 0.0;
                } else {
                    int64_t i_325893 = add64(x_325806, i_325870);
                    double defunc_0_add_arg_325894;
                    
                    defunc_0_add_arg_325894 =
                        ((double *) mem_313366.mem)[gtid_303144 *
                                                    (defunc_0_f_res_292820 *
                                                     n_p_292677) + gtid_325687 *
                                                    defunc_0_f_res_292820 +
                                                    i_325893];
                    defunc_0_f_res_325892 = defunc_0_add_arg_325894;
                }
                
                double x_325895 = a11_325855 * tmp4_325890;
                double y_325896 = b11_325857 * defunc_1_f_res_325891;
                double x_325897 = x_325895 + y_325896;
                double defunc_9_fit_fun_res_325898 = defunc_0_f_res_325892 *
                       x_325897;
                double x_325899 = b11_325857 * tmp4_325890;
                double y_325900 = c11_325858 * defunc_1_f_res_325891;
                double x_325901 = x_325899 + y_325900;
                double defunc_9_slope_fun_res_325902 = defunc_0_f_res_325892 *
                       x_325901;
                double defunc_1_op_res_325903 = defunc_9_fit_fun_res_325898 +
                       redout_325871;
                double defunc_1_op_res_325904 = defunc_9_slope_fun_res_325902 +
                       redout_325872;
                double redout_tmp_325914 = defunc_1_op_res_325903;
                double redout_tmp_325915 = defunc_1_op_res_325904;
                
                redout_325871 = redout_tmp_325914;
                redout_325872 = redout_tmp_325915;
            }
            defunc_2_reduce_res_325868 = redout_325871;
            defunc_2_reduce_res_325869 = redout_325872;
            ((double *) mem_325689)[i_325803] = defunc_2_reduce_res_325868;
            ((double *) mem_325691)[i_325803] = defunc_2_reduce_res_325869;
        }
        if (s_n_m_292825 * (int64_t) 8 > 0)
            memmove(mem_314584.mem + gtid_325687 * s_n_m_292825 * (int64_t) 8,
                    mem_325689 + (int64_t) 0, s_n_m_292825 * (int64_t) 8);
        if (s_n_m_292825 * (int64_t) 8 > 0)
            memmove(mem_314588.mem + gtid_325687 * s_n_m_292825 * (int64_t) 8,
                    mem_325691 + (int64_t) 0, s_n_m_292825 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_325689);
    free(mem_325691);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338248_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338248_end -
                 futhark_mc_segmap_parloop_338248_start;
        
        ctx->futhark_mc_segmap_parloop_338248_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338248_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338248_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_338246(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_325686 = tid;
    int num_tasks_325801 = info.nsubtasks;
    struct futhark_mc_task_338245 *futhark_mc_task_338245 =
                                  (struct futhark_mc_task_338245 *) args;
    struct futhark_context *ctx = futhark_mc_task_338245->ctx;
    uint64_t futhark_mc_segmap_task_338246_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_338246_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_338245->free_n_p_292677;
    int64_t q_s_292678 = futhark_mc_task_338245->free_q_s_292678;
    int64_t jump_s_292684 = futhark_mc_task_338245->free_jump_s_292684;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_338245->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_task_338245->free_pad_css_len_292821;
    int64_t s_n_m_292825 = futhark_mc_task_338245->free_s_n_m_292825;
    int64_t gtid_303144 = futhark_mc_task_338245->free_gtid_303144;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_task_338245->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_312842 = {.desc ="mem_312842", .mem =
                                  futhark_mc_task_338245->free_mem_312842,
                                  .size =0, .references =NULL};
    int64_t bytes_312847 = futhark_mc_task_338245->free_bytes_312847;
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_task_338245->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_task_338245->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_task_338245->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_task_338245->free_mem_313371,
                                  .size =0, .references =NULL};
    struct memblock mem_314584 = {.desc ="mem_314584", .mem =
                                  futhark_mc_task_338245->free_mem_314584,
                                  .size =0, .references =NULL};
    struct memblock mem_314588 = {.desc ="mem_314588", .mem =
                                  futhark_mc_task_338245->free_mem_314588,
                                  .size =0, .references =NULL};
    int64_t iter_325802;
    struct futhark_mc_segmap_parloop_struct_338247
    futhark_mc_segmap_parloop_struct_338247;
    
    futhark_mc_segmap_parloop_struct_338247.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338247.free_n_p_292677 = n_p_292677;
    futhark_mc_segmap_parloop_struct_338247.free_q_s_292678 = q_s_292678;
    futhark_mc_segmap_parloop_struct_338247.free_jump_s_292684 = jump_s_292684;
    futhark_mc_segmap_parloop_struct_338247.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segmap_parloop_struct_338247.free_pad_css_len_292821 =
        pad_css_len_292821;
    futhark_mc_segmap_parloop_struct_338247.free_s_n_m_292825 = s_n_m_292825;
    futhark_mc_segmap_parloop_struct_338247.free_gtid_303144 = gtid_303144;
    futhark_mc_segmap_parloop_struct_338247.free_mem_312838 = mem_312838.mem;
    futhark_mc_segmap_parloop_struct_338247.free_mem_312842 = mem_312842.mem;
    futhark_mc_segmap_parloop_struct_338247.free_bytes_312847 = bytes_312847;
    futhark_mc_segmap_parloop_struct_338247.free_mem_313018 = mem_313018.mem;
    futhark_mc_segmap_parloop_struct_338247.free_mem_313023 = mem_313023.mem;
    futhark_mc_segmap_parloop_struct_338247.free_mem_313366 = mem_313366.mem;
    futhark_mc_segmap_parloop_struct_338247.free_mem_313371 = mem_313371.mem;
    futhark_mc_segmap_parloop_struct_338247.free_mem_314584 = mem_314584.mem;
    futhark_mc_segmap_parloop_struct_338247.free_mem_314588 = mem_314588.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338248_task;
    
    futhark_mc_segmap_parloop_338248_task.name =
        "futhark_mc_segmap_parloop_338248";
    futhark_mc_segmap_parloop_338248_task.fn = futhark_mc_segmap_parloop_338248;
    futhark_mc_segmap_parloop_338248_task.args =
        &futhark_mc_segmap_parloop_struct_338247;
    futhark_mc_segmap_parloop_338248_task.iterations = iterations;
    futhark_mc_segmap_parloop_338248_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338248_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338248_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338248_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338248_task);
    
    if (futhark_mc_segmap_parloop_338248_err != 0) {
        err = futhark_mc_segmap_parloop_338248_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338248_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338248_total_end -
                 futhark_mc_segmap_parloop_338248_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338248_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338248_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338248_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_338246_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_338246_end -
                 futhark_mc_segmap_task_338246_start;
        
        ctx->futhark_mc_segmap_task_338246_runs[tid]++;
        ctx->futhark_mc_segmap_task_338246_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_338246_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_segmap_parloop_struct_338252 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_q_s_292678;
    int64_t free_jump_s_292684;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    int64_t free_gtid_303144;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_312842;
    int64_t free_bytes_312847;
    unsigned char *free_mem_313018;
    unsigned char *free_mem_313023;
    unsigned char *free_mem_313366;
    unsigned char *free_mem_313371;
    unsigned char *free_mem_314584;
    unsigned char *free_mem_314588;
};
struct futhark_mc_task_338256 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_q_s_292678;
    int64_t free_jump_s_292684;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    int64_t free_gtid_303144;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_313018;
    unsigned char *free_mem_313023;
    unsigned char *free_mem_313366;
    unsigned char *free_mem_313371;
    int64_t free_gtid_325471;
    int64_t free_x_325472;
    unsigned char *free_mem_325473;
    unsigned char *free_mem_325474;
};
struct futhark_mc_segmap_parloop_struct_338258 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_q_s_292678;
    int64_t free_jump_s_292684;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    int64_t free_gtid_303144;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_313018;
    unsigned char *free_mem_313023;
    unsigned char *free_mem_313366;
    unsigned char *free_mem_313371;
    int64_t free_gtid_325471;
    int64_t free_x_325472;
    unsigned char *free_mem_325473;
    unsigned char *free_mem_325474;
};
static int futhark_mc_segmap_parloop_338259(void *args, int64_t start,
                                            int64_t end, int flat_tid_326025,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338258
    *futhark_mc_segmap_parloop_struct_338258 =
    (struct futhark_mc_segmap_parloop_struct_338258 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338258->ctx;
    uint64_t futhark_mc_segmap_parloop_338259_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338259_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segmap_parloop_struct_338258->free_n_p_292677;
    int64_t q_s_292678 =
            futhark_mc_segmap_parloop_struct_338258->free_q_s_292678;
    int64_t jump_s_292684 =
            futhark_mc_segmap_parloop_struct_338258->free_jump_s_292684;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segmap_parloop_struct_338258->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_segmap_parloop_struct_338258->free_pad_css_len_292821;
    int64_t s_n_m_292825 =
            futhark_mc_segmap_parloop_struct_338258->free_s_n_m_292825;
    int64_t gtid_303144 =
            futhark_mc_segmap_parloop_struct_338258->free_gtid_303144;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_segmap_parloop_struct_338258->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_segmap_parloop_struct_338258->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_segmap_parloop_struct_338258->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_segmap_parloop_struct_338258->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_segmap_parloop_struct_338258->free_mem_313371,
                                  .size =0, .references =NULL};
    int64_t gtid_325471 =
            futhark_mc_segmap_parloop_struct_338258->free_gtid_325471;
    int64_t x_325472 = futhark_mc_segmap_parloop_struct_338258->free_x_325472;
    struct memblock mem_325473 = {.desc ="mem_325473", .mem =
                                  futhark_mc_segmap_parloop_struct_338258->free_mem_325473,
                                  .size =0, .references =NULL};
    struct memblock mem_325474 = {.desc ="mem_325474", .mem =
                                  futhark_mc_segmap_parloop_struct_338258->free_mem_325474,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_326129 = start;
    
    for (; iter_326129 < end; iter_326129++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_326208 = s_n_m_292825;
        int64_t gtid_326026 = iter_326129;
        int64_t remnant_326209 = iter_326129 - gtid_326026;
        int64_t x_326027;
        
        x_326027 = ((int64_t *) mem_313018.mem)[gtid_303144 * (s_n_m_292825 *
                                                               n_p_292677) +
                                                gtid_325471 * s_n_m_292825 +
                                                gtid_326026];
        
        double x_326028;
        
        x_326028 = ((double *) mem_313023.mem)[gtid_303144 * (s_n_m_292825 *
                                                              n_p_292677) +
                                               gtid_325471 * s_n_m_292825 +
                                               gtid_326026];
        
        bool cond_326029 = gtid_326026 == (int64_t) 0;
        int64_t defunc_0_m_fun_res_326030;
        
        if (cond_326029) {
            defunc_0_m_fun_res_326030 = (int64_t) 0;
        } else {
            int64_t y_326130 = sub64(s_n_m_292825, (int64_t) 1);
            bool cond_326131 = gtid_326026 == y_326130;
            int64_t defunc_0_m_fun_res_f_res_326132;
            
            if (cond_326131) {
                int64_t defunc_0_m_fun_res_f_res_t_res_326133 =
                        sub64(pad_css_len_292821, (int64_t) 1);
                
                defunc_0_m_fun_res_f_res_326132 =
                    defunc_0_m_fun_res_f_res_t_res_326133;
            } else {
                int64_t x_326134 = sub64(gtid_326026, (int64_t) 1);
                int64_t x_326135 = mul64(jump_s_292684, x_326134);
                int64_t min_arg_326136 = add64((int64_t) 1, x_326135);
                int64_t min_res_326137 = smin64(defunc_0_f_res_292820,
                                                min_arg_326136);
                
                defunc_0_m_fun_res_f_res_326132 = min_res_326137;
            }
            defunc_0_m_fun_res_326030 = defunc_0_m_fun_res_f_res_326132;
        }
        
        double defunc_2_reduce_res_326039;
        double defunc_2_reduce_res_326040;
        double defunc_2_reduce_res_326041;
        double redout_326139;
        double redout_326140;
        double redout_326141;
        
        redout_326139 = 0.0;
        redout_326140 = 0.0;
        redout_326141 = 0.0;
        for (int64_t i_326138 = 0; i_326138 < q_s_292678; i_326138++) {
            bool cond_326142 = sle64(x_325472, i_326138);
            int64_t defunc_0_f_res_326143;
            
            if (cond_326142) {
                defunc_0_f_res_326143 = (int64_t) 0;
            } else {
                int64_t i_326144 = add64(x_326027, i_326138);
                int64_t defunc_0_add_arg_326145;
                
                defunc_0_add_arg_326145 =
                    ((int64_t *) mem_312838.mem)[gtid_303144 *
                                                 (defunc_0_f_res_292820 *
                                                  n_p_292677) + gtid_325471 *
                                                 defunc_0_f_res_292820 +
                                                 i_326144];
                
                int64_t defunc_1_add_res_326146 = add64((int64_t) 1,
                                                        defunc_0_add_arg_326145);
                
                defunc_0_f_res_326143 = defunc_1_add_res_326146;
            }
            
            double defunc_0_f_res_326147;
            
            if (cond_326142) {
                defunc_0_f_res_326147 = 0.0;
            } else {
                int64_t i_326148 = add64(x_326027, i_326138);
                double defunc_0_add_arg_326149;
                
                defunc_0_add_arg_326149 =
                    ((double *) mem_313371.mem)[gtid_303144 *
                                                (defunc_0_f_res_292820 *
                                                 n_p_292677) + gtid_325471 *
                                                defunc_0_f_res_292820 +
                                                i_326148];
                defunc_0_f_res_326147 = defunc_0_add_arg_326149;
            }
            
            int64_t binop_p_326150 = sub64(defunc_0_f_res_326143,
                                           defunc_0_m_fun_res_326030);
            double defunc_0_f_res_326151 = sitofp_i64_f64(binop_p_326150);
            double abs_res_326152 = fabs(defunc_0_f_res_326151);
            double tmp1_326153 = abs_res_326152 / x_326028;
            double x_326154 = tmp1_326153 * tmp1_326153;
            double y_326155 = tmp1_326153 * x_326154;
            double tmp2_326156 = 1.0 - y_326155;
            double x_326157 = tmp2_326156 * tmp2_326156;
            double tmp3_326158 = tmp2_326156 * x_326157;
            double w_j_326159 = defunc_0_f_res_326147 * tmp3_326158;
            double xw_j_326160 = defunc_0_f_res_326151 * w_j_326159;
            double x2w_j_326161 = defunc_0_f_res_326151 * xw_j_326160;
            double defunc_1_op_res_326162 = w_j_326159 + redout_326139;
            double defunc_1_op_res_326163 = xw_j_326160 + redout_326140;
            double defunc_1_op_res_326164 = x2w_j_326161 + redout_326141;
            double redout_tmp_326210 = defunc_1_op_res_326162;
            double redout_tmp_326211 = defunc_1_op_res_326163;
            double redout_tmp_326212 = defunc_1_op_res_326164;
            
            redout_326139 = redout_tmp_326210;
            redout_326140 = redout_tmp_326211;
            redout_326141 = redout_tmp_326212;
        }
        defunc_2_reduce_res_326039 = redout_326139;
        defunc_2_reduce_res_326040 = redout_326140;
        defunc_2_reduce_res_326041 = redout_326141;
        
        double a_326069 = 2.220446049250313e-16 + defunc_2_reduce_res_326039;
        double b_326070 = 2.220446049250313e-16 + defunc_2_reduce_res_326040;
        double c_326071 = 2.220446049250313e-16 + defunc_2_reduce_res_326041;
        double x_326072 = a_326069 * c_326071;
        double y_326073 = b_326070 * b_326070;
        double y_326074 = x_326072 - y_326073;
        double det1_326075 = 1.0 / y_326074;
        double a11_326076 = c_326071 * det1_326075;
        double x_326077 = 0.0 - b_326070;
        double b11_326078 = det1_326075 * x_326077;
        double c11_326079 = a_326069 * det1_326075;
        int64_t defunc_0_m_fun_res_326080;
        
        if (cond_326029) {
            defunc_0_m_fun_res_326080 = (int64_t) 0;
        } else {
            int64_t y_326165 = sub64(s_n_m_292825, (int64_t) 1);
            bool cond_326166 = gtid_326026 == y_326165;
            int64_t defunc_0_m_fun_res_f_res_326167;
            
            if (cond_326166) {
                int64_t defunc_0_m_fun_res_f_res_t_res_326168 =
                        sub64(pad_css_len_292821, (int64_t) 1);
                
                defunc_0_m_fun_res_f_res_326167 =
                    defunc_0_m_fun_res_f_res_t_res_326168;
            } else {
                int64_t x_326169 = sub64(gtid_326026, (int64_t) 1);
                int64_t x_326170 = mul64(jump_s_292684, x_326169);
                int64_t min_arg_326171 = add64((int64_t) 1, x_326170);
                int64_t min_res_326172 = smin64(defunc_0_f_res_292820,
                                                min_arg_326171);
                
                defunc_0_m_fun_res_f_res_326167 = min_res_326172;
            }
            defunc_0_m_fun_res_326080 = defunc_0_m_fun_res_f_res_326167;
        }
        
        double defunc_2_reduce_res_326089;
        double defunc_2_reduce_res_326090;
        double redout_326174;
        double redout_326175;
        
        redout_326174 = 0.0;
        redout_326175 = 0.0;
        for (int64_t i_326173 = 0; i_326173 < q_s_292678; i_326173++) {
            bool cond_326176 = sle64(x_325472, i_326173);
            int64_t defunc_0_f_res_326177;
            
            if (cond_326176) {
                defunc_0_f_res_326177 = (int64_t) 0;
            } else {
                int64_t i_326178 = add64(x_326027, i_326173);
                int64_t defunc_0_add_arg_326179;
                
                defunc_0_add_arg_326179 =
                    ((int64_t *) mem_312838.mem)[gtid_303144 *
                                                 (defunc_0_f_res_292820 *
                                                  n_p_292677) + gtid_325471 *
                                                 defunc_0_f_res_292820 +
                                                 i_326178];
                
                int64_t defunc_1_add_res_326180 = add64((int64_t) 1,
                                                        defunc_0_add_arg_326179);
                
                defunc_0_f_res_326177 = defunc_1_add_res_326180;
            }
            
            double defunc_0_f_res_326181;
            
            if (cond_326176) {
                defunc_0_f_res_326181 = 0.0;
            } else {
                int64_t i_326182 = add64(x_326027, i_326173);
                double defunc_0_add_arg_326183;
                
                defunc_0_add_arg_326183 =
                    ((double *) mem_313371.mem)[gtid_303144 *
                                                (defunc_0_f_res_292820 *
                                                 n_p_292677) + gtid_325471 *
                                                defunc_0_f_res_292820 +
                                                i_326182];
                defunc_0_f_res_326181 = defunc_0_add_arg_326183;
            }
            
            int64_t binop_p_326184 = sub64(defunc_0_f_res_326177,
                                           defunc_0_m_fun_res_326080);
            double defunc_0_f_res_326185 = sitofp_i64_f64(binop_p_326184);
            double abs_res_326186 = fabs(defunc_0_f_res_326185);
            double tmp1_326187 = abs_res_326186 / x_326028;
            double x_326188 = tmp1_326187 * tmp1_326187;
            double y_326189 = tmp1_326187 * x_326188;
            double tmp2_326190 = 1.0 - y_326189;
            double x_326191 = tmp2_326190 * tmp2_326190;
            double tmp3_326192 = tmp2_326190 * x_326191;
            double tmp4_326193 = defunc_0_f_res_326181 * tmp3_326192;
            double defunc_1_f_res_326194 = defunc_0_f_res_326185 * tmp4_326193;
            double defunc_0_f_res_326195;
            
            if (cond_326176) {
                defunc_0_f_res_326195 = 0.0;
            } else {
                int64_t i_326196 = add64(x_326027, i_326173);
                double defunc_0_add_arg_326197;
                
                defunc_0_add_arg_326197 =
                    ((double *) mem_313366.mem)[gtid_303144 *
                                                (defunc_0_f_res_292820 *
                                                 n_p_292677) + gtid_325471 *
                                                defunc_0_f_res_292820 +
                                                i_326196];
                defunc_0_f_res_326195 = defunc_0_add_arg_326197;
            }
            
            double x_326198 = a11_326076 * tmp4_326193;
            double y_326199 = b11_326078 * defunc_1_f_res_326194;
            double x_326200 = x_326198 + y_326199;
            double defunc_9_fit_fun_res_326201 = defunc_0_f_res_326195 *
                   x_326200;
            double x_326202 = b11_326078 * tmp4_326193;
            double y_326203 = c11_326079 * defunc_1_f_res_326194;
            double x_326204 = x_326202 + y_326203;
            double defunc_9_slope_fun_res_326205 = defunc_0_f_res_326195 *
                   x_326204;
            double defunc_1_op_res_326206 = defunc_9_fit_fun_res_326201 +
                   redout_326174;
            double defunc_1_op_res_326207 = defunc_9_slope_fun_res_326205 +
                   redout_326175;
            double redout_tmp_326213 = defunc_1_op_res_326206;
            double redout_tmp_326214 = defunc_1_op_res_326207;
            
            redout_326174 = redout_tmp_326213;
            redout_326175 = redout_tmp_326214;
        }
        defunc_2_reduce_res_326089 = redout_326174;
        defunc_2_reduce_res_326090 = redout_326175;
        ((double *) mem_325473.mem)[gtid_326026] = defunc_2_reduce_res_326089;
        ((double *) mem_325474.mem)[gtid_326026] = defunc_2_reduce_res_326090;
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338259_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338259_end -
                 futhark_mc_segmap_parloop_338259_start;
        
        ctx->futhark_mc_segmap_parloop_338259_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338259_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338259_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_338257(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_326025 = tid;
    int num_tasks_326128 = info.nsubtasks;
    struct futhark_mc_task_338256 *futhark_mc_task_338256 =
                                  (struct futhark_mc_task_338256 *) args;
    struct futhark_context *ctx = futhark_mc_task_338256->ctx;
    uint64_t futhark_mc_segmap_task_338257_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_338257_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_338256->free_n_p_292677;
    int64_t q_s_292678 = futhark_mc_task_338256->free_q_s_292678;
    int64_t jump_s_292684 = futhark_mc_task_338256->free_jump_s_292684;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_338256->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_task_338256->free_pad_css_len_292821;
    int64_t s_n_m_292825 = futhark_mc_task_338256->free_s_n_m_292825;
    int64_t gtid_303144 = futhark_mc_task_338256->free_gtid_303144;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_task_338256->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_task_338256->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_task_338256->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_task_338256->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_task_338256->free_mem_313371,
                                  .size =0, .references =NULL};
    int64_t gtid_325471 = futhark_mc_task_338256->free_gtid_325471;
    int64_t x_325472 = futhark_mc_task_338256->free_x_325472;
    struct memblock mem_325473 = {.desc ="mem_325473", .mem =
                                  futhark_mc_task_338256->free_mem_325473,
                                  .size =0, .references =NULL};
    struct memblock mem_325474 = {.desc ="mem_325474", .mem =
                                  futhark_mc_task_338256->free_mem_325474,
                                  .size =0, .references =NULL};
    int64_t iter_326129;
    struct futhark_mc_segmap_parloop_struct_338258
    futhark_mc_segmap_parloop_struct_338258;
    
    futhark_mc_segmap_parloop_struct_338258.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338258.free_n_p_292677 = n_p_292677;
    futhark_mc_segmap_parloop_struct_338258.free_q_s_292678 = q_s_292678;
    futhark_mc_segmap_parloop_struct_338258.free_jump_s_292684 = jump_s_292684;
    futhark_mc_segmap_parloop_struct_338258.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segmap_parloop_struct_338258.free_pad_css_len_292821 =
        pad_css_len_292821;
    futhark_mc_segmap_parloop_struct_338258.free_s_n_m_292825 = s_n_m_292825;
    futhark_mc_segmap_parloop_struct_338258.free_gtid_303144 = gtid_303144;
    futhark_mc_segmap_parloop_struct_338258.free_mem_312838 = mem_312838.mem;
    futhark_mc_segmap_parloop_struct_338258.free_mem_313018 = mem_313018.mem;
    futhark_mc_segmap_parloop_struct_338258.free_mem_313023 = mem_313023.mem;
    futhark_mc_segmap_parloop_struct_338258.free_mem_313366 = mem_313366.mem;
    futhark_mc_segmap_parloop_struct_338258.free_mem_313371 = mem_313371.mem;
    futhark_mc_segmap_parloop_struct_338258.free_gtid_325471 = gtid_325471;
    futhark_mc_segmap_parloop_struct_338258.free_x_325472 = x_325472;
    futhark_mc_segmap_parloop_struct_338258.free_mem_325473 = mem_325473.mem;
    futhark_mc_segmap_parloop_struct_338258.free_mem_325474 = mem_325474.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338259_task;
    
    futhark_mc_segmap_parloop_338259_task.name =
        "futhark_mc_segmap_parloop_338259";
    futhark_mc_segmap_parloop_338259_task.fn = futhark_mc_segmap_parloop_338259;
    futhark_mc_segmap_parloop_338259_task.args =
        &futhark_mc_segmap_parloop_struct_338258;
    futhark_mc_segmap_parloop_338259_task.iterations = iterations;
    futhark_mc_segmap_parloop_338259_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338259_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338259_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338259_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338259_task);
    
    if (futhark_mc_segmap_parloop_338259_err != 0) {
        err = futhark_mc_segmap_parloop_338259_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338259_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338259_total_end -
                 futhark_mc_segmap_parloop_338259_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338259_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338259_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338259_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_338257_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_338257_end -
                 futhark_mc_segmap_task_338257_start;
        
        ctx->futhark_mc_segmap_task_338257_runs[tid]++;
        ctx->futhark_mc_segmap_task_338257_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_338257_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_segmap_parloop_struct_338261 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_q_s_292678;
    int64_t free_jump_s_292684;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    int64_t free_gtid_303144;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_313018;
    unsigned char *free_mem_313023;
    unsigned char *free_mem_313366;
    unsigned char *free_mem_313371;
    int64_t free_gtid_325471;
    int64_t free_x_325472;
    unsigned char *free_mem_325473;
    unsigned char *free_mem_325474;
};
struct futhark_mc_task_338263 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_gtid_303144;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_313371;
    int64_t free_gtid_325471;
    int64_t free_x_325472;
    int64_t free_x_325919;
    double free_x_325920;
    int64_t free_defunc_0_m_fun_res_325922;
    double *retval_defunc_2_reduce_res_325931;
    double *retval_defunc_2_reduce_res_325932;
    double *retval_defunc_2_reduce_res_325933;
};
struct futhark_mc_segred_stage_1_parloop_struct_338268 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_gtid_303144;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_313371;
    int64_t free_gtid_325471;
    int64_t free_x_325472;
    int64_t free_x_325919;
    double free_x_325920;
    int64_t free_defunc_0_m_fun_res_325922;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_326304;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_326306;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_326308;
};
static int futhark_mc_segred_stage_1_parloop_338269(void *args, int64_t start,
                                                    int64_t end,
                                                    int flat_tid_326224,
                                                    int tid)
{
    int err = 0;
    struct futhark_mc_segred_stage_1_parloop_struct_338268
    *futhark_mc_segred_stage_1_parloop_struct_338268 =
    (struct futhark_mc_segred_stage_1_parloop_struct_338268 *) args;
    struct futhark_context *ctx =
                           futhark_mc_segred_stage_1_parloop_struct_338268->ctx;
    uint64_t futhark_mc_segred_stage_1_parloop_338269_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_338269_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segred_stage_1_parloop_struct_338268->free_n_p_292677;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segred_stage_1_parloop_struct_338268->free_defunc_0_f_res_292820;
    int64_t gtid_303144 =
            futhark_mc_segred_stage_1_parloop_struct_338268->free_gtid_303144;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_338268->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_338268->free_mem_313371,
                                  .size =0, .references =NULL};
    int64_t gtid_325471 =
            futhark_mc_segred_stage_1_parloop_struct_338268->free_gtid_325471;
    int64_t x_325472 =
            futhark_mc_segred_stage_1_parloop_struct_338268->free_x_325472;
    int64_t x_325919 =
            futhark_mc_segred_stage_1_parloop_struct_338268->free_x_325919;
    double x_325920 =
           futhark_mc_segred_stage_1_parloop_struct_338268->free_x_325920;
    int64_t defunc_0_m_fun_res_325922 =
            futhark_mc_segred_stage_1_parloop_struct_338268->free_defunc_0_m_fun_res_325922;
    struct memblock reduce_stage_1_tid_res_arr_mem_326304 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_326304",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338268->free_reduce_stage_1_tid_res_arr_mem_326304,
                                                             .size =0,
                                                             .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_326306 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_326306",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338268->free_reduce_stage_1_tid_res_arr_mem_326306,
                                                             .size =0,
                                                             .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_326308 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_326308",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338268->free_reduce_stage_1_tid_res_arr_mem_326308,
                                                             .size =0,
                                                             .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_326310 = start;
    double x_326226;
    double x_326227;
    double x_326229;
    double x_326230;
    double x_326232;
    double x_326233;
    double local_acc_326311 = 0.0;
    double local_acc_326312 = 0.0;
    double local_acc_326313 = 0.0;
    
    for (; iter_326310 < end; iter_326310++) {
        int64_t gtid_326225 = iter_326310;
        bool cond_326235 = sle64(x_325472, gtid_326225);
        int64_t defunc_0_f_res_326236;
        
        if (cond_326235) {
            defunc_0_f_res_326236 = (int64_t) 0;
        } else {
            int64_t i_326237 = add64(x_325919, gtid_326225);
            int64_t defunc_0_add_arg_326238;
            
            defunc_0_add_arg_326238 = ((int64_t *) mem_312838.mem)[gtid_303144 *
                                                                   (defunc_0_f_res_292820 *
                                                                    n_p_292677) +
                                                                   gtid_325471 *
                                                                   defunc_0_f_res_292820 +
                                                                   i_326237];
            
            int64_t defunc_1_add_res_326239 = add64((int64_t) 1,
                                                    defunc_0_add_arg_326238);
            
            defunc_0_f_res_326236 = defunc_1_add_res_326239;
        }
        
        double defunc_0_f_res_326240;
        
        if (cond_326235) {
            defunc_0_f_res_326240 = 0.0;
        } else {
            int64_t i_326241 = add64(x_325919, gtid_326225);
            double defunc_0_add_arg_326242;
            
            defunc_0_add_arg_326242 = ((double *) mem_313371.mem)[gtid_303144 *
                                                                  (defunc_0_f_res_292820 *
                                                                   n_p_292677) +
                                                                  gtid_325471 *
                                                                  defunc_0_f_res_292820 +
                                                                  i_326241];
            defunc_0_f_res_326240 = defunc_0_add_arg_326242;
        }
        
        int64_t binop_p_326243 = sub64(defunc_0_f_res_326236,
                                       defunc_0_m_fun_res_325922);
        double defunc_0_f_res_326244 = sitofp_i64_f64(binop_p_326243);
        double abs_res_326245 = fabs(defunc_0_f_res_326244);
        double tmp1_326246 = abs_res_326245 / x_325920;
        double x_326247 = tmp1_326246 * tmp1_326246;
        double y_326248 = tmp1_326246 * x_326247;
        double tmp2_326249 = 1.0 - y_326248;
        double x_326250 = tmp2_326249 * tmp2_326249;
        double tmp3_326251 = tmp2_326249 * x_326250;
        double w_j_326252 = defunc_0_f_res_326240 * tmp3_326251;
        double xw_j_326253 = defunc_0_f_res_326244 * w_j_326252;
        double x2w_j_326254 = defunc_0_f_res_326244 * xw_j_326253;
        
        // save map-out results
        { }
        // Load accum params
        {
            x_326226 = local_acc_326311;
        }
        // Load next params
        {
            x_326227 = w_j_326252;
        }
        // Red body
        {
            double defunc_1_op_res_326228 = x_326226 + x_326227;
            
            local_acc_326311 = defunc_1_op_res_326228;
        }
        // Load accum params
        {
            x_326229 = local_acc_326312;
        }
        // Load next params
        {
            x_326230 = xw_j_326253;
        }
        // Red body
        {
            double defunc_1_op_res_326231 = x_326229 + x_326230;
            
            local_acc_326312 = defunc_1_op_res_326231;
        }
        // Load accum params
        {
            x_326232 = local_acc_326313;
        }
        // Load next params
        {
            x_326233 = x2w_j_326254;
        }
        // Red body
        {
            double defunc_1_op_res_326234 = x_326232 + x_326233;
            
            local_acc_326313 = defunc_1_op_res_326234;
        }
    }
    ((double *) reduce_stage_1_tid_res_arr_mem_326304.mem)[flat_tid_326224] =
        local_acc_326311;
    ((double *) reduce_stage_1_tid_res_arr_mem_326306.mem)[flat_tid_326224] =
        local_acc_326312;
    ((double *) reduce_stage_1_tid_res_arr_mem_326308.mem)[flat_tid_326224] =
        local_acc_326313;
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_338269_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_338269_end -
                 futhark_mc_segred_stage_1_parloop_338269_start;
        
        ctx->futhark_mc_segred_stage_1_parloop_338269_runs[tid]++;
        ctx->futhark_mc_segred_stage_1_parloop_338269_total_runtime[tid] +=
            elapsed;
        ctx->futhark_mc_segred_stage_1_parloop_338269_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segred_task_338264(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_326224 = tid;
    int num_tasks_326303 = info.nsubtasks;
    struct futhark_mc_task_338263 *futhark_mc_task_338263 =
                                  (struct futhark_mc_task_338263 *) args;
    struct futhark_context *ctx = futhark_mc_task_338263->ctx;
    uint64_t futhark_mc_segred_task_338264_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_task_338264_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_338263->free_n_p_292677;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_338263->free_defunc_0_f_res_292820;
    int64_t gtid_303144 = futhark_mc_task_338263->free_gtid_303144;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_task_338263->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_task_338263->free_mem_313371,
                                  .size =0, .references =NULL};
    int64_t gtid_325471 = futhark_mc_task_338263->free_gtid_325471;
    int64_t x_325472 = futhark_mc_task_338263->free_x_325472;
    int64_t x_325919 = futhark_mc_task_338263->free_x_325919;
    double x_325920 = futhark_mc_task_338263->free_x_325920;
    int64_t defunc_0_m_fun_res_325922 =
            futhark_mc_task_338263->free_defunc_0_m_fun_res_325922;
    double defunc_2_reduce_res_325931 =
           *futhark_mc_task_338263->retval_defunc_2_reduce_res_325931;
    double defunc_2_reduce_res_325932 =
           *futhark_mc_task_338263->retval_defunc_2_reduce_res_325932;
    double defunc_2_reduce_res_325933 =
           *futhark_mc_task_338263->retval_defunc_2_reduce_res_325933;
    size_t reduce_stage_1_tid_res_arr_mem_326304_cached_sizze_338265 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_326304 = NULL;
    size_t reduce_stage_1_tid_res_arr_mem_326306_cached_sizze_338266 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_326306 = NULL;
    size_t reduce_stage_1_tid_res_arr_mem_326308_cached_sizze_338267 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_326308 = NULL;
    
    if (reduce_stage_1_tid_res_arr_mem_326304_cached_sizze_338265 <
        (size_t) ((int64_t) 8 * num_tasks_326303)) {
        reduce_stage_1_tid_res_arr_mem_326304 =
            realloc(reduce_stage_1_tid_res_arr_mem_326304, (int64_t) 8 *
                    num_tasks_326303);
        reduce_stage_1_tid_res_arr_mem_326304_cached_sizze_338265 =
            (int64_t) 8 * num_tasks_326303;
    }
    if (reduce_stage_1_tid_res_arr_mem_326306_cached_sizze_338266 <
        (size_t) ((int64_t) 8 * num_tasks_326303)) {
        reduce_stage_1_tid_res_arr_mem_326306 =
            realloc(reduce_stage_1_tid_res_arr_mem_326306, (int64_t) 8 *
                    num_tasks_326303);
        reduce_stage_1_tid_res_arr_mem_326306_cached_sizze_338266 =
            (int64_t) 8 * num_tasks_326303;
    }
    if (reduce_stage_1_tid_res_arr_mem_326308_cached_sizze_338267 <
        (size_t) ((int64_t) 8 * num_tasks_326303)) {
        reduce_stage_1_tid_res_arr_mem_326308 =
            realloc(reduce_stage_1_tid_res_arr_mem_326308, (int64_t) 8 *
                    num_tasks_326303);
        reduce_stage_1_tid_res_arr_mem_326308_cached_sizze_338267 =
            (int64_t) 8 * num_tasks_326303;
    }
    
    int64_t iter_326310;
    struct futhark_mc_segred_stage_1_parloop_struct_338268
    futhark_mc_segred_stage_1_parloop_struct_338268;
    
    futhark_mc_segred_stage_1_parloop_struct_338268.ctx = ctx;
    futhark_mc_segred_stage_1_parloop_struct_338268.free_n_p_292677 =
        n_p_292677;
    futhark_mc_segred_stage_1_parloop_struct_338268.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segred_stage_1_parloop_struct_338268.free_gtid_303144 =
        gtid_303144;
    futhark_mc_segred_stage_1_parloop_struct_338268.free_mem_312838 =
        mem_312838.mem;
    futhark_mc_segred_stage_1_parloop_struct_338268.free_mem_313371 =
        mem_313371.mem;
    futhark_mc_segred_stage_1_parloop_struct_338268.free_gtid_325471 =
        gtid_325471;
    futhark_mc_segred_stage_1_parloop_struct_338268.free_x_325472 = x_325472;
    futhark_mc_segred_stage_1_parloop_struct_338268.free_x_325919 = x_325919;
    futhark_mc_segred_stage_1_parloop_struct_338268.free_x_325920 = x_325920;
    futhark_mc_segred_stage_1_parloop_struct_338268.free_defunc_0_m_fun_res_325922 =
        defunc_0_m_fun_res_325922;
    futhark_mc_segred_stage_1_parloop_struct_338268.free_reduce_stage_1_tid_res_arr_mem_326304 =
        reduce_stage_1_tid_res_arr_mem_326304;
    futhark_mc_segred_stage_1_parloop_struct_338268.free_reduce_stage_1_tid_res_arr_mem_326306 =
        reduce_stage_1_tid_res_arr_mem_326306;
    futhark_mc_segred_stage_1_parloop_struct_338268.free_reduce_stage_1_tid_res_arr_mem_326308 =
        reduce_stage_1_tid_res_arr_mem_326308;
    
    struct scheduler_parloop futhark_mc_segred_stage_1_parloop_338269_task;
    
    futhark_mc_segred_stage_1_parloop_338269_task.name =
        "futhark_mc_segred_stage_1_parloop_338269";
    futhark_mc_segred_stage_1_parloop_338269_task.fn =
        futhark_mc_segred_stage_1_parloop_338269;
    futhark_mc_segred_stage_1_parloop_338269_task.args =
        &futhark_mc_segred_stage_1_parloop_struct_338268;
    futhark_mc_segred_stage_1_parloop_338269_task.iterations = iterations;
    futhark_mc_segred_stage_1_parloop_338269_task.info = info;
    
    uint64_t futhark_mc_segred_stage_1_parloop_338269_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_338269_total_start = get_wall_time();
    
    int futhark_mc_segred_stage_1_parloop_338269_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segred_stage_1_parloop_338269_task);
    
    if (futhark_mc_segred_stage_1_parloop_338269_err != 0) {
        err = futhark_mc_segred_stage_1_parloop_338269_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_338269_total_end =
                 get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_338269_total_end -
                 futhark_mc_segred_stage_1_parloop_338269_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338269_total_runs,
                           1, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338269_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338269_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    // neutral-initialise the output
    {
        defunc_2_reduce_res_325931 = 0.0;
        defunc_2_reduce_res_325932 = 0.0;
        defunc_2_reduce_res_325933 = 0.0;
    }
    
    double x_326314;
    double x_326315;
    double x_326317;
    double x_326318;
    double x_326320;
    double x_326321;
    
    for (int32_t i_326323 = 0; i_326323 < num_tasks_326303; i_326323++) {
        flat_tid_326224 = i_326323;
        // Apply main thread reduction
        {
            // load acc params
            {
                x_326314 = defunc_2_reduce_res_325931;
            }
            // load next params
            {
                x_326315 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_326304)[flat_tid_326224];
            }
            // red body
            {
                double defunc_1_op_res_326316 = x_326314 + x_326315;
                
                defunc_2_reduce_res_325931 = defunc_1_op_res_326316;
            }
            // load acc params
            {
                x_326317 = defunc_2_reduce_res_325932;
            }
            // load next params
            {
                x_326318 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_326306)[flat_tid_326224];
            }
            // red body
            {
                double defunc_1_op_res_326319 = x_326317 + x_326318;
                
                defunc_2_reduce_res_325932 = defunc_1_op_res_326319;
            }
            // load acc params
            {
                x_326320 = defunc_2_reduce_res_325933;
            }
            // load next params
            {
                x_326321 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_326308)[flat_tid_326224];
            }
            // red body
            {
                double defunc_1_op_res_326322 = x_326320 + x_326321;
                
                defunc_2_reduce_res_325933 = defunc_1_op_res_326322;
            }
        }
    }
    
  cleanup:
    {
        free(reduce_stage_1_tid_res_arr_mem_326304);
        free(reduce_stage_1_tid_res_arr_mem_326306);
        free(reduce_stage_1_tid_res_arr_mem_326308);
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_task_338264_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_task_338264_end -
                 futhark_mc_segred_task_338264_start;
        
        ctx->futhark_mc_segred_task_338264_runs[tid]++;
        ctx->futhark_mc_segred_task_338264_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segred_task_338264_iter[tid] += iterations;
    }
    if (err == 0) {
        *futhark_mc_task_338263->retval_defunc_2_reduce_res_325931 =
            defunc_2_reduce_res_325931;
        *futhark_mc_task_338263->retval_defunc_2_reduce_res_325932 =
            defunc_2_reduce_res_325932;
        *futhark_mc_task_338263->retval_defunc_2_reduce_res_325933 =
            defunc_2_reduce_res_325933;
    }
    return err;
}
struct futhark_mc_task_338270 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_gtid_303144;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_313366;
    unsigned char *free_mem_313371;
    int64_t free_gtid_325471;
    int64_t free_x_325472;
    int64_t free_x_325919;
    double free_x_325920;
    double free_a11_325972;
    double free_b11_325974;
    double free_c11_325975;
    int64_t free_defunc_0_m_fun_res_325976;
    double *retval_defunc_2_reduce_res_325985;
    double *retval_defunc_2_reduce_res_325986;
};
struct futhark_mc_segred_stage_1_parloop_struct_338274 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_gtid_303144;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_313366;
    unsigned char *free_mem_313371;
    int64_t free_gtid_325471;
    int64_t free_x_325472;
    int64_t free_x_325919;
    double free_x_325920;
    double free_a11_325972;
    double free_b11_325974;
    double free_c11_325975;
    int64_t free_defunc_0_m_fun_res_325976;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_326325;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_326327;
};
static int futhark_mc_segred_stage_1_parloop_338275(void *args, int64_t start,
                                                    int64_t end,
                                                    int flat_tid_326263,
                                                    int tid)
{
    int err = 0;
    struct futhark_mc_segred_stage_1_parloop_struct_338274
    *futhark_mc_segred_stage_1_parloop_struct_338274 =
    (struct futhark_mc_segred_stage_1_parloop_struct_338274 *) args;
    struct futhark_context *ctx =
                           futhark_mc_segred_stage_1_parloop_struct_338274->ctx;
    uint64_t futhark_mc_segred_stage_1_parloop_338275_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_338275_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segred_stage_1_parloop_struct_338274->free_n_p_292677;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segred_stage_1_parloop_struct_338274->free_defunc_0_f_res_292820;
    int64_t gtid_303144 =
            futhark_mc_segred_stage_1_parloop_struct_338274->free_gtid_303144;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_338274->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_338274->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_338274->free_mem_313371,
                                  .size =0, .references =NULL};
    int64_t gtid_325471 =
            futhark_mc_segred_stage_1_parloop_struct_338274->free_gtid_325471;
    int64_t x_325472 =
            futhark_mc_segred_stage_1_parloop_struct_338274->free_x_325472;
    int64_t x_325919 =
            futhark_mc_segred_stage_1_parloop_struct_338274->free_x_325919;
    double x_325920 =
           futhark_mc_segred_stage_1_parloop_struct_338274->free_x_325920;
    double a11_325972 =
           futhark_mc_segred_stage_1_parloop_struct_338274->free_a11_325972;
    double b11_325974 =
           futhark_mc_segred_stage_1_parloop_struct_338274->free_b11_325974;
    double c11_325975 =
           futhark_mc_segred_stage_1_parloop_struct_338274->free_c11_325975;
    int64_t defunc_0_m_fun_res_325976 =
            futhark_mc_segred_stage_1_parloop_struct_338274->free_defunc_0_m_fun_res_325976;
    struct memblock reduce_stage_1_tid_res_arr_mem_326325 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_326325",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338274->free_reduce_stage_1_tid_res_arr_mem_326325,
                                                             .size =0,
                                                             .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_326327 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_326327",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338274->free_reduce_stage_1_tid_res_arr_mem_326327,
                                                             .size =0,
                                                             .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_326329 = start;
    double x_326265;
    double x_326266;
    double x_326268;
    double x_326269;
    double local_acc_326330 = 0.0;
    double local_acc_326331 = 0.0;
    
    for (; iter_326329 < end; iter_326329++) {
        int64_t gtid_326264 = iter_326329;
        bool cond_326271 = sle64(x_325472, gtid_326264);
        int64_t defunc_0_f_res_326272;
        
        if (cond_326271) {
            defunc_0_f_res_326272 = (int64_t) 0;
        } else {
            int64_t i_326273 = add64(x_325919, gtid_326264);
            int64_t defunc_0_add_arg_326274;
            
            defunc_0_add_arg_326274 = ((int64_t *) mem_312838.mem)[gtid_303144 *
                                                                   (defunc_0_f_res_292820 *
                                                                    n_p_292677) +
                                                                   gtid_325471 *
                                                                   defunc_0_f_res_292820 +
                                                                   i_326273];
            
            int64_t defunc_1_add_res_326275 = add64((int64_t) 1,
                                                    defunc_0_add_arg_326274);
            
            defunc_0_f_res_326272 = defunc_1_add_res_326275;
        }
        
        double defunc_0_f_res_326276;
        
        if (cond_326271) {
            defunc_0_f_res_326276 = 0.0;
        } else {
            int64_t i_326277 = add64(x_325919, gtid_326264);
            double defunc_0_add_arg_326278;
            
            defunc_0_add_arg_326278 = ((double *) mem_313371.mem)[gtid_303144 *
                                                                  (defunc_0_f_res_292820 *
                                                                   n_p_292677) +
                                                                  gtid_325471 *
                                                                  defunc_0_f_res_292820 +
                                                                  i_326277];
            defunc_0_f_res_326276 = defunc_0_add_arg_326278;
        }
        
        int64_t binop_p_326279 = sub64(defunc_0_f_res_326272,
                                       defunc_0_m_fun_res_325976);
        double defunc_0_f_res_326280 = sitofp_i64_f64(binop_p_326279);
        double abs_res_326281 = fabs(defunc_0_f_res_326280);
        double tmp1_326282 = abs_res_326281 / x_325920;
        double x_326283 = tmp1_326282 * tmp1_326282;
        double y_326284 = tmp1_326282 * x_326283;
        double tmp2_326285 = 1.0 - y_326284;
        double x_326286 = tmp2_326285 * tmp2_326285;
        double tmp3_326287 = tmp2_326285 * x_326286;
        double tmp4_326288 = defunc_0_f_res_326276 * tmp3_326287;
        double defunc_1_f_res_326289 = defunc_0_f_res_326280 * tmp4_326288;
        double defunc_0_f_res_326290;
        
        if (cond_326271) {
            defunc_0_f_res_326290 = 0.0;
        } else {
            int64_t i_326291 = add64(x_325919, gtid_326264);
            double defunc_0_add_arg_326292;
            
            defunc_0_add_arg_326292 = ((double *) mem_313366.mem)[gtid_303144 *
                                                                  (defunc_0_f_res_292820 *
                                                                   n_p_292677) +
                                                                  gtid_325471 *
                                                                  defunc_0_f_res_292820 +
                                                                  i_326291];
            defunc_0_f_res_326290 = defunc_0_add_arg_326292;
        }
        
        double x_326293 = a11_325972 * tmp4_326288;
        double y_326294 = b11_325974 * defunc_1_f_res_326289;
        double x_326295 = x_326293 + y_326294;
        double defunc_9_fit_fun_res_326296 = defunc_0_f_res_326290 * x_326295;
        double x_326297 = b11_325974 * tmp4_326288;
        double y_326298 = c11_325975 * defunc_1_f_res_326289;
        double x_326299 = x_326297 + y_326298;
        double defunc_9_slope_fun_res_326300 = defunc_0_f_res_326290 * x_326299;
        
        // save map-out results
        { }
        // Load accum params
        {
            x_326265 = local_acc_326330;
        }
        // Load next params
        {
            x_326266 = defunc_9_fit_fun_res_326296;
        }
        // Red body
        {
            double defunc_1_op_res_326267 = x_326265 + x_326266;
            
            local_acc_326330 = defunc_1_op_res_326267;
        }
        // Load accum params
        {
            x_326268 = local_acc_326331;
        }
        // Load next params
        {
            x_326269 = defunc_9_slope_fun_res_326300;
        }
        // Red body
        {
            double defunc_1_op_res_326270 = x_326268 + x_326269;
            
            local_acc_326331 = defunc_1_op_res_326270;
        }
    }
    ((double *) reduce_stage_1_tid_res_arr_mem_326325.mem)[flat_tid_326263] =
        local_acc_326330;
    ((double *) reduce_stage_1_tid_res_arr_mem_326327.mem)[flat_tid_326263] =
        local_acc_326331;
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_338275_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_338275_end -
                 futhark_mc_segred_stage_1_parloop_338275_start;
        
        ctx->futhark_mc_segred_stage_1_parloop_338275_runs[tid]++;
        ctx->futhark_mc_segred_stage_1_parloop_338275_total_runtime[tid] +=
            elapsed;
        ctx->futhark_mc_segred_stage_1_parloop_338275_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segred_task_338271(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_326263 = tid;
    int num_tasks_326324 = info.nsubtasks;
    struct futhark_mc_task_338270 *futhark_mc_task_338270 =
                                  (struct futhark_mc_task_338270 *) args;
    struct futhark_context *ctx = futhark_mc_task_338270->ctx;
    uint64_t futhark_mc_segred_task_338271_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_task_338271_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_338270->free_n_p_292677;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_338270->free_defunc_0_f_res_292820;
    int64_t gtid_303144 = futhark_mc_task_338270->free_gtid_303144;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_task_338270->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_task_338270->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_task_338270->free_mem_313371,
                                  .size =0, .references =NULL};
    int64_t gtid_325471 = futhark_mc_task_338270->free_gtid_325471;
    int64_t x_325472 = futhark_mc_task_338270->free_x_325472;
    int64_t x_325919 = futhark_mc_task_338270->free_x_325919;
    double x_325920 = futhark_mc_task_338270->free_x_325920;
    double a11_325972 = futhark_mc_task_338270->free_a11_325972;
    double b11_325974 = futhark_mc_task_338270->free_b11_325974;
    double c11_325975 = futhark_mc_task_338270->free_c11_325975;
    int64_t defunc_0_m_fun_res_325976 =
            futhark_mc_task_338270->free_defunc_0_m_fun_res_325976;
    double defunc_2_reduce_res_325985 =
           *futhark_mc_task_338270->retval_defunc_2_reduce_res_325985;
    double defunc_2_reduce_res_325986 =
           *futhark_mc_task_338270->retval_defunc_2_reduce_res_325986;
    size_t reduce_stage_1_tid_res_arr_mem_326325_cached_sizze_338272 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_326325 = NULL;
    size_t reduce_stage_1_tid_res_arr_mem_326327_cached_sizze_338273 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_326327 = NULL;
    
    if (reduce_stage_1_tid_res_arr_mem_326325_cached_sizze_338272 <
        (size_t) ((int64_t) 8 * num_tasks_326324)) {
        reduce_stage_1_tid_res_arr_mem_326325 =
            realloc(reduce_stage_1_tid_res_arr_mem_326325, (int64_t) 8 *
                    num_tasks_326324);
        reduce_stage_1_tid_res_arr_mem_326325_cached_sizze_338272 =
            (int64_t) 8 * num_tasks_326324;
    }
    if (reduce_stage_1_tid_res_arr_mem_326327_cached_sizze_338273 <
        (size_t) ((int64_t) 8 * num_tasks_326324)) {
        reduce_stage_1_tid_res_arr_mem_326327 =
            realloc(reduce_stage_1_tid_res_arr_mem_326327, (int64_t) 8 *
                    num_tasks_326324);
        reduce_stage_1_tid_res_arr_mem_326327_cached_sizze_338273 =
            (int64_t) 8 * num_tasks_326324;
    }
    
    int64_t iter_326329;
    struct futhark_mc_segred_stage_1_parloop_struct_338274
    futhark_mc_segred_stage_1_parloop_struct_338274;
    
    futhark_mc_segred_stage_1_parloop_struct_338274.ctx = ctx;
    futhark_mc_segred_stage_1_parloop_struct_338274.free_n_p_292677 =
        n_p_292677;
    futhark_mc_segred_stage_1_parloop_struct_338274.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segred_stage_1_parloop_struct_338274.free_gtid_303144 =
        gtid_303144;
    futhark_mc_segred_stage_1_parloop_struct_338274.free_mem_312838 =
        mem_312838.mem;
    futhark_mc_segred_stage_1_parloop_struct_338274.free_mem_313366 =
        mem_313366.mem;
    futhark_mc_segred_stage_1_parloop_struct_338274.free_mem_313371 =
        mem_313371.mem;
    futhark_mc_segred_stage_1_parloop_struct_338274.free_gtid_325471 =
        gtid_325471;
    futhark_mc_segred_stage_1_parloop_struct_338274.free_x_325472 = x_325472;
    futhark_mc_segred_stage_1_parloop_struct_338274.free_x_325919 = x_325919;
    futhark_mc_segred_stage_1_parloop_struct_338274.free_x_325920 = x_325920;
    futhark_mc_segred_stage_1_parloop_struct_338274.free_a11_325972 =
        a11_325972;
    futhark_mc_segred_stage_1_parloop_struct_338274.free_b11_325974 =
        b11_325974;
    futhark_mc_segred_stage_1_parloop_struct_338274.free_c11_325975 =
        c11_325975;
    futhark_mc_segred_stage_1_parloop_struct_338274.free_defunc_0_m_fun_res_325976 =
        defunc_0_m_fun_res_325976;
    futhark_mc_segred_stage_1_parloop_struct_338274.free_reduce_stage_1_tid_res_arr_mem_326325 =
        reduce_stage_1_tid_res_arr_mem_326325;
    futhark_mc_segred_stage_1_parloop_struct_338274.free_reduce_stage_1_tid_res_arr_mem_326327 =
        reduce_stage_1_tid_res_arr_mem_326327;
    
    struct scheduler_parloop futhark_mc_segred_stage_1_parloop_338275_task;
    
    futhark_mc_segred_stage_1_parloop_338275_task.name =
        "futhark_mc_segred_stage_1_parloop_338275";
    futhark_mc_segred_stage_1_parloop_338275_task.fn =
        futhark_mc_segred_stage_1_parloop_338275;
    futhark_mc_segred_stage_1_parloop_338275_task.args =
        &futhark_mc_segred_stage_1_parloop_struct_338274;
    futhark_mc_segred_stage_1_parloop_338275_task.iterations = iterations;
    futhark_mc_segred_stage_1_parloop_338275_task.info = info;
    
    uint64_t futhark_mc_segred_stage_1_parloop_338275_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_338275_total_start = get_wall_time();
    
    int futhark_mc_segred_stage_1_parloop_338275_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segred_stage_1_parloop_338275_task);
    
    if (futhark_mc_segred_stage_1_parloop_338275_err != 0) {
        err = futhark_mc_segred_stage_1_parloop_338275_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_338275_total_end =
                 get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_338275_total_end -
                 futhark_mc_segred_stage_1_parloop_338275_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338275_total_runs,
                           1, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338275_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338275_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    // neutral-initialise the output
    {
        defunc_2_reduce_res_325985 = 0.0;
        defunc_2_reduce_res_325986 = 0.0;
    }
    
    double x_326332;
    double x_326333;
    double x_326335;
    double x_326336;
    
    for (int32_t i_326338 = 0; i_326338 < num_tasks_326324; i_326338++) {
        flat_tid_326263 = i_326338;
        // Apply main thread reduction
        {
            // load acc params
            {
                x_326332 = defunc_2_reduce_res_325985;
            }
            // load next params
            {
                x_326333 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_326325)[flat_tid_326263];
            }
            // red body
            {
                double defunc_1_op_res_326334 = x_326332 + x_326333;
                
                defunc_2_reduce_res_325985 = defunc_1_op_res_326334;
            }
            // load acc params
            {
                x_326335 = defunc_2_reduce_res_325986;
            }
            // load next params
            {
                x_326336 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_326327)[flat_tid_326263];
            }
            // red body
            {
                double defunc_1_op_res_326337 = x_326335 + x_326336;
                
                defunc_2_reduce_res_325986 = defunc_1_op_res_326337;
            }
        }
    }
    
  cleanup:
    {
        free(reduce_stage_1_tid_res_arr_mem_326325);
        free(reduce_stage_1_tid_res_arr_mem_326327);
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_task_338271_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_task_338271_end -
                 futhark_mc_segred_task_338271_start;
        
        ctx->futhark_mc_segred_task_338271_runs[tid]++;
        ctx->futhark_mc_segred_task_338271_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segred_task_338271_iter[tid] += iterations;
    }
    if (err == 0) {
        *futhark_mc_task_338270->retval_defunc_2_reduce_res_325985 =
            defunc_2_reduce_res_325985;
        *futhark_mc_task_338270->retval_defunc_2_reduce_res_325986 =
            defunc_2_reduce_res_325986;
    }
    return err;
}
static int futhark_mc_segmap_parloop_338262(void *args, int64_t start,
                                            int64_t end, int flat_tid_325917,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338261
    *futhark_mc_segmap_parloop_struct_338261 =
    (struct futhark_mc_segmap_parloop_struct_338261 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338261->ctx;
    uint64_t futhark_mc_segmap_parloop_338262_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338262_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segmap_parloop_struct_338261->free_n_p_292677;
    int64_t q_s_292678 =
            futhark_mc_segmap_parloop_struct_338261->free_q_s_292678;
    int64_t jump_s_292684 =
            futhark_mc_segmap_parloop_struct_338261->free_jump_s_292684;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segmap_parloop_struct_338261->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_segmap_parloop_struct_338261->free_pad_css_len_292821;
    int64_t s_n_m_292825 =
            futhark_mc_segmap_parloop_struct_338261->free_s_n_m_292825;
    int64_t gtid_303144 =
            futhark_mc_segmap_parloop_struct_338261->free_gtid_303144;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_segmap_parloop_struct_338261->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_segmap_parloop_struct_338261->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_segmap_parloop_struct_338261->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_segmap_parloop_struct_338261->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_segmap_parloop_struct_338261->free_mem_313371,
                                  .size =0, .references =NULL};
    int64_t gtid_325471 =
            futhark_mc_segmap_parloop_struct_338261->free_gtid_325471;
    int64_t x_325472 = futhark_mc_segmap_parloop_struct_338261->free_x_325472;
    struct memblock mem_325473 = {.desc ="mem_325473", .mem =
                                  futhark_mc_segmap_parloop_struct_338261->free_mem_325473,
                                  .size =0, .references =NULL};
    struct memblock mem_325474 = {.desc ="mem_325474", .mem =
                                  futhark_mc_segmap_parloop_struct_338261->free_mem_325474,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_326215 = start;
    
    for (; iter_326215 < end; iter_326215++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_326301 = s_n_m_292825;
        int64_t gtid_325918 = iter_326215;
        int64_t remnant_326302 = iter_326215 - gtid_325918;
        int64_t x_325919;
        
        x_325919 = ((int64_t *) mem_313018.mem)[gtid_303144 * (s_n_m_292825 *
                                                               n_p_292677) +
                                                gtid_325471 * s_n_m_292825 +
                                                gtid_325918];
        
        double x_325920;
        
        x_325920 = ((double *) mem_313023.mem)[gtid_303144 * (s_n_m_292825 *
                                                              n_p_292677) +
                                               gtid_325471 * s_n_m_292825 +
                                               gtid_325918];
        
        bool cond_325921 = gtid_325918 == (int64_t) 0;
        int64_t defunc_0_m_fun_res_325922;
        
        if (cond_325921) {
            defunc_0_m_fun_res_325922 = (int64_t) 0;
        } else {
            int64_t y_326216 = sub64(s_n_m_292825, (int64_t) 1);
            bool cond_326217 = gtid_325918 == y_326216;
            int64_t defunc_0_m_fun_res_f_res_326218;
            
            if (cond_326217) {
                int64_t defunc_0_m_fun_res_f_res_t_res_326219 =
                        sub64(pad_css_len_292821, (int64_t) 1);
                
                defunc_0_m_fun_res_f_res_326218 =
                    defunc_0_m_fun_res_f_res_t_res_326219;
            } else {
                int64_t x_326220 = sub64(gtid_325918, (int64_t) 1);
                int64_t x_326221 = mul64(jump_s_292684, x_326220);
                int64_t min_arg_326222 = add64((int64_t) 1, x_326221);
                int64_t min_res_326223 = smin64(defunc_0_f_res_292820,
                                                min_arg_326222);
                
                defunc_0_m_fun_res_f_res_326218 = min_res_326223;
            }
            defunc_0_m_fun_res_325922 = defunc_0_m_fun_res_f_res_326218;
        }
        
        double defunc_2_reduce_res_325931;
        double defunc_2_reduce_res_325932;
        double defunc_2_reduce_res_325933;
        int64_t flat_tid_326224 = (int64_t) 0;
        int32_t num_tasks_326303;
        
        defunc_2_reduce_res_325931 = 0.0;
        defunc_2_reduce_res_325932 = 0.0;
        defunc_2_reduce_res_325933 = 0.0;
        
        struct futhark_mc_task_338263 futhark_mc_task_338263;
        
        futhark_mc_task_338263.ctx = ctx;
        futhark_mc_task_338263.free_n_p_292677 = n_p_292677;
        futhark_mc_task_338263.free_defunc_0_f_res_292820 =
            defunc_0_f_res_292820;
        futhark_mc_task_338263.free_gtid_303144 = gtid_303144;
        futhark_mc_task_338263.free_mem_312838 = mem_312838.mem;
        futhark_mc_task_338263.free_mem_313371 = mem_313371.mem;
        futhark_mc_task_338263.free_gtid_325471 = gtid_325471;
        futhark_mc_task_338263.free_x_325472 = x_325472;
        futhark_mc_task_338263.free_x_325919 = x_325919;
        futhark_mc_task_338263.free_x_325920 = x_325920;
        futhark_mc_task_338263.free_defunc_0_m_fun_res_325922 =
            defunc_0_m_fun_res_325922;
        futhark_mc_task_338263.retval_defunc_2_reduce_res_325931 =
            &defunc_2_reduce_res_325931;
        futhark_mc_task_338263.retval_defunc_2_reduce_res_325932 =
            &defunc_2_reduce_res_325932;
        futhark_mc_task_338263.retval_defunc_2_reduce_res_325933 =
            &defunc_2_reduce_res_325933;
        
        struct scheduler_segop futhark_mc_task_338263_task;
        
        futhark_mc_task_338263_task.args = &futhark_mc_task_338263;
        futhark_mc_task_338263_task.top_level_fn =
            futhark_mc_segred_task_338264;
        futhark_mc_task_338263_task.name = "futhark_mc_segred_task_338264";
        futhark_mc_task_338263_task.iterations = q_s_292678;
        futhark_mc_task_338263_task.task_time =
            &ctx->futhark_mc_segred_task_338264_total_time;
        futhark_mc_task_338263_task.task_iter =
            &ctx->futhark_mc_segred_task_338264_total_iter;
        futhark_mc_task_338263_task.sched = STATIC;
        futhark_mc_task_338263_task.nested_fn = NULL;
        
        int futhark_mc_segred_task_338264_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_338263_task);
        
        if (futhark_mc_segred_task_338264_err != 0) {
            ;
            err = futhark_mc_segred_task_338264_err;
            goto cleanup;
        }
        
        double a_325965 = 2.220446049250313e-16 + defunc_2_reduce_res_325931;
        double b_325966 = 2.220446049250313e-16 + defunc_2_reduce_res_325932;
        double c_325967 = 2.220446049250313e-16 + defunc_2_reduce_res_325933;
        double x_325968 = a_325965 * c_325967;
        double y_325969 = b_325966 * b_325966;
        double y_325970 = x_325968 - y_325969;
        double det1_325971 = 1.0 / y_325970;
        double a11_325972 = c_325967 * det1_325971;
        double x_325973 = 0.0 - b_325966;
        double b11_325974 = det1_325971 * x_325973;
        double c11_325975 = a_325965 * det1_325971;
        int64_t defunc_0_m_fun_res_325976;
        
        if (cond_325921) {
            defunc_0_m_fun_res_325976 = (int64_t) 0;
        } else {
            int64_t y_326255 = sub64(s_n_m_292825, (int64_t) 1);
            bool cond_326256 = gtid_325918 == y_326255;
            int64_t defunc_0_m_fun_res_f_res_326257;
            
            if (cond_326256) {
                int64_t defunc_0_m_fun_res_f_res_t_res_326258 =
                        sub64(pad_css_len_292821, (int64_t) 1);
                
                defunc_0_m_fun_res_f_res_326257 =
                    defunc_0_m_fun_res_f_res_t_res_326258;
            } else {
                int64_t x_326259 = sub64(gtid_325918, (int64_t) 1);
                int64_t x_326260 = mul64(jump_s_292684, x_326259);
                int64_t min_arg_326261 = add64((int64_t) 1, x_326260);
                int64_t min_res_326262 = smin64(defunc_0_f_res_292820,
                                                min_arg_326261);
                
                defunc_0_m_fun_res_f_res_326257 = min_res_326262;
            }
            defunc_0_m_fun_res_325976 = defunc_0_m_fun_res_f_res_326257;
        }
        
        double defunc_2_reduce_res_325985;
        double defunc_2_reduce_res_325986;
        int64_t flat_tid_326263 = (int64_t) 0;
        int32_t num_tasks_326324;
        
        defunc_2_reduce_res_325985 = 0.0;
        defunc_2_reduce_res_325986 = 0.0;
        
        struct futhark_mc_task_338270 futhark_mc_task_338270;
        
        futhark_mc_task_338270.ctx = ctx;
        futhark_mc_task_338270.free_n_p_292677 = n_p_292677;
        futhark_mc_task_338270.free_defunc_0_f_res_292820 =
            defunc_0_f_res_292820;
        futhark_mc_task_338270.free_gtid_303144 = gtid_303144;
        futhark_mc_task_338270.free_mem_312838 = mem_312838.mem;
        futhark_mc_task_338270.free_mem_313366 = mem_313366.mem;
        futhark_mc_task_338270.free_mem_313371 = mem_313371.mem;
        futhark_mc_task_338270.free_gtid_325471 = gtid_325471;
        futhark_mc_task_338270.free_x_325472 = x_325472;
        futhark_mc_task_338270.free_x_325919 = x_325919;
        futhark_mc_task_338270.free_x_325920 = x_325920;
        futhark_mc_task_338270.free_a11_325972 = a11_325972;
        futhark_mc_task_338270.free_b11_325974 = b11_325974;
        futhark_mc_task_338270.free_c11_325975 = c11_325975;
        futhark_mc_task_338270.free_defunc_0_m_fun_res_325976 =
            defunc_0_m_fun_res_325976;
        futhark_mc_task_338270.retval_defunc_2_reduce_res_325985 =
            &defunc_2_reduce_res_325985;
        futhark_mc_task_338270.retval_defunc_2_reduce_res_325986 =
            &defunc_2_reduce_res_325986;
        
        struct scheduler_segop futhark_mc_task_338270_task;
        
        futhark_mc_task_338270_task.args = &futhark_mc_task_338270;
        futhark_mc_task_338270_task.top_level_fn =
            futhark_mc_segred_task_338271;
        futhark_mc_task_338270_task.name = "futhark_mc_segred_task_338271";
        futhark_mc_task_338270_task.iterations = q_s_292678;
        futhark_mc_task_338270_task.task_time =
            &ctx->futhark_mc_segred_task_338271_total_time;
        futhark_mc_task_338270_task.task_iter =
            &ctx->futhark_mc_segred_task_338271_total_iter;
        futhark_mc_task_338270_task.sched = STATIC;
        futhark_mc_task_338270_task.nested_fn = NULL;
        
        int futhark_mc_segred_task_338271_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_338270_task);
        
        if (futhark_mc_segred_task_338271_err != 0) {
            ;
            err = futhark_mc_segred_task_338271_err;
            goto cleanup;
        }
        ((double *) mem_325473.mem)[gtid_325918] = defunc_2_reduce_res_325985;
        ((double *) mem_325474.mem)[gtid_325918] = defunc_2_reduce_res_325986;
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338262_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338262_end -
                 futhark_mc_segmap_parloop_338262_start;
        
        ctx->futhark_mc_segmap_parloop_338262_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338262_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338262_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_nested_task_338260(void *args, int64_t iterations,
                                         int tid, struct scheduler_info info)
{
    int err = 0;
    int flat_tid_325917 = tid;
    int num_tasks_326128 = info.nsubtasks;
    struct futhark_mc_task_338256 *futhark_mc_task_338256 =
                                  (struct futhark_mc_task_338256 *) args;
    struct futhark_context *ctx = futhark_mc_task_338256->ctx;
    uint64_t futhark_mc_segmap_nested_task_338260_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_nested_task_338260_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_338256->free_n_p_292677;
    int64_t q_s_292678 = futhark_mc_task_338256->free_q_s_292678;
    int64_t jump_s_292684 = futhark_mc_task_338256->free_jump_s_292684;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_338256->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_task_338256->free_pad_css_len_292821;
    int64_t s_n_m_292825 = futhark_mc_task_338256->free_s_n_m_292825;
    int64_t gtid_303144 = futhark_mc_task_338256->free_gtid_303144;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_task_338256->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_task_338256->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_task_338256->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_task_338256->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_task_338256->free_mem_313371,
                                  .size =0, .references =NULL};
    int64_t gtid_325471 = futhark_mc_task_338256->free_gtid_325471;
    int64_t x_325472 = futhark_mc_task_338256->free_x_325472;
    struct memblock mem_325473 = {.desc ="mem_325473", .mem =
                                  futhark_mc_task_338256->free_mem_325473,
                                  .size =0, .references =NULL};
    struct memblock mem_325474 = {.desc ="mem_325474", .mem =
                                  futhark_mc_task_338256->free_mem_325474,
                                  .size =0, .references =NULL};
    int64_t iter_326215;
    struct futhark_mc_segmap_parloop_struct_338261
    futhark_mc_segmap_parloop_struct_338261;
    
    futhark_mc_segmap_parloop_struct_338261.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338261.free_n_p_292677 = n_p_292677;
    futhark_mc_segmap_parloop_struct_338261.free_q_s_292678 = q_s_292678;
    futhark_mc_segmap_parloop_struct_338261.free_jump_s_292684 = jump_s_292684;
    futhark_mc_segmap_parloop_struct_338261.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segmap_parloop_struct_338261.free_pad_css_len_292821 =
        pad_css_len_292821;
    futhark_mc_segmap_parloop_struct_338261.free_s_n_m_292825 = s_n_m_292825;
    futhark_mc_segmap_parloop_struct_338261.free_gtid_303144 = gtid_303144;
    futhark_mc_segmap_parloop_struct_338261.free_mem_312838 = mem_312838.mem;
    futhark_mc_segmap_parloop_struct_338261.free_mem_313018 = mem_313018.mem;
    futhark_mc_segmap_parloop_struct_338261.free_mem_313023 = mem_313023.mem;
    futhark_mc_segmap_parloop_struct_338261.free_mem_313366 = mem_313366.mem;
    futhark_mc_segmap_parloop_struct_338261.free_mem_313371 = mem_313371.mem;
    futhark_mc_segmap_parloop_struct_338261.free_gtid_325471 = gtid_325471;
    futhark_mc_segmap_parloop_struct_338261.free_x_325472 = x_325472;
    futhark_mc_segmap_parloop_struct_338261.free_mem_325473 = mem_325473.mem;
    futhark_mc_segmap_parloop_struct_338261.free_mem_325474 = mem_325474.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338262_task;
    
    futhark_mc_segmap_parloop_338262_task.name =
        "futhark_mc_segmap_parloop_338262";
    futhark_mc_segmap_parloop_338262_task.fn = futhark_mc_segmap_parloop_338262;
    futhark_mc_segmap_parloop_338262_task.args =
        &futhark_mc_segmap_parloop_struct_338261;
    futhark_mc_segmap_parloop_338262_task.iterations = iterations;
    futhark_mc_segmap_parloop_338262_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338262_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338262_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338262_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338262_task);
    
    if (futhark_mc_segmap_parloop_338262_err != 0) {
        err = futhark_mc_segmap_parloop_338262_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338262_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338262_total_end -
                 futhark_mc_segmap_parloop_338262_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338262_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338262_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338262_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_nested_task_338260_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_nested_task_338260_end -
                 futhark_mc_segmap_nested_task_338260_start;
        
        ctx->futhark_mc_segmap_nested_task_338260_runs[tid]++;
        ctx->futhark_mc_segmap_nested_task_338260_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_nested_task_338260_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
static int futhark_mc_segmap_parloop_338253(void *args, int64_t start,
                                            int64_t end, int flat_tid_325470,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338252
    *futhark_mc_segmap_parloop_struct_338252 =
    (struct futhark_mc_segmap_parloop_struct_338252 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338252->ctx;
    uint64_t futhark_mc_segmap_parloop_338253_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338253_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segmap_parloop_struct_338252->free_n_p_292677;
    int64_t q_s_292678 =
            futhark_mc_segmap_parloop_struct_338252->free_q_s_292678;
    int64_t jump_s_292684 =
            futhark_mc_segmap_parloop_struct_338252->free_jump_s_292684;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segmap_parloop_struct_338252->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_segmap_parloop_struct_338252->free_pad_css_len_292821;
    int64_t s_n_m_292825 =
            futhark_mc_segmap_parloop_struct_338252->free_s_n_m_292825;
    int64_t gtid_303144 =
            futhark_mc_segmap_parloop_struct_338252->free_gtid_303144;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_segmap_parloop_struct_338252->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_312842 = {.desc ="mem_312842", .mem =
                                  futhark_mc_segmap_parloop_struct_338252->free_mem_312842,
                                  .size =0, .references =NULL};
    int64_t bytes_312847 =
            futhark_mc_segmap_parloop_struct_338252->free_bytes_312847;
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_segmap_parloop_struct_338252->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_segmap_parloop_struct_338252->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_segmap_parloop_struct_338252->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_segmap_parloop_struct_338252->free_mem_313371,
                                  .size =0, .references =NULL};
    struct memblock mem_314584 = {.desc ="mem_314584", .mem =
                                  futhark_mc_segmap_parloop_struct_338252->free_mem_314584,
                                  .size =0, .references =NULL};
    struct memblock mem_314588 = {.desc ="mem_314588", .mem =
                                  futhark_mc_segmap_parloop_struct_338252->free_mem_314588,
                                  .size =0, .references =NULL};
    size_t mem_325473_cached_sizze_338254 = 0;
    unsigned char *mem_325473 = NULL;
    size_t mem_325474_cached_sizze_338255 = 0;
    unsigned char *mem_325474 = NULL;
    int64_t iterations = end - start;
    int64_t iter_325916 = start;
    
    if (mem_325473_cached_sizze_338254 < (size_t) bytes_312847) {
        mem_325473 = realloc(mem_325473, bytes_312847);
        mem_325473_cached_sizze_338254 = bytes_312847;
    }
    if (mem_325474_cached_sizze_338255 < (size_t) bytes_312847) {
        mem_325474 = realloc(mem_325474, bytes_312847);
        mem_325474_cached_sizze_338255 = bytes_312847;
    }
    for (; iter_325916 < end; iter_325916++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_326126 = n_p_292677;
        int64_t gtid_325471 = iter_325916;
        int64_t remnant_326127 = iter_325916 - gtid_325471;
        int64_t x_325472;
        
        x_325472 = ((int64_t *) mem_312842.mem)[gtid_303144 * n_p_292677 +
                                                gtid_325471];
        
        int64_t flat_tid_326025 = (int64_t) 0;
        int32_t num_tasks_326128;
        int64_t flat_tid_325917 = (int64_t) 0;
        struct futhark_mc_task_338256 futhark_mc_task_338256;
        
        futhark_mc_task_338256.ctx = ctx;
        futhark_mc_task_338256.free_n_p_292677 = n_p_292677;
        futhark_mc_task_338256.free_q_s_292678 = q_s_292678;
        futhark_mc_task_338256.free_jump_s_292684 = jump_s_292684;
        futhark_mc_task_338256.free_defunc_0_f_res_292820 =
            defunc_0_f_res_292820;
        futhark_mc_task_338256.free_pad_css_len_292821 = pad_css_len_292821;
        futhark_mc_task_338256.free_s_n_m_292825 = s_n_m_292825;
        futhark_mc_task_338256.free_gtid_303144 = gtid_303144;
        futhark_mc_task_338256.free_mem_312838 = mem_312838.mem;
        futhark_mc_task_338256.free_mem_313018 = mem_313018.mem;
        futhark_mc_task_338256.free_mem_313023 = mem_313023.mem;
        futhark_mc_task_338256.free_mem_313366 = mem_313366.mem;
        futhark_mc_task_338256.free_mem_313371 = mem_313371.mem;
        futhark_mc_task_338256.free_gtid_325471 = gtid_325471;
        futhark_mc_task_338256.free_x_325472 = x_325472;
        futhark_mc_task_338256.free_mem_325473 = mem_325473;
        futhark_mc_task_338256.free_mem_325474 = mem_325474;
        
        struct scheduler_segop futhark_mc_task_338256_task;
        
        futhark_mc_task_338256_task.args = &futhark_mc_task_338256;
        futhark_mc_task_338256_task.top_level_fn =
            futhark_mc_segmap_task_338257;
        futhark_mc_task_338256_task.name = "futhark_mc_segmap_task_338257";
        futhark_mc_task_338256_task.iterations = s_n_m_292825;
        futhark_mc_task_338256_task.task_time =
            &ctx->futhark_mc_segmap_task_338257_total_time;
        futhark_mc_task_338256_task.task_iter =
            &ctx->futhark_mc_segmap_task_338257_total_iter;
        futhark_mc_task_338256_task.sched = STATIC;
        futhark_mc_task_338256_task.nested_fn =
            futhark_mc_segmap_nested_task_338260;
        
        int futhark_mc_segmap_task_338257_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_338256_task);
        
        if (futhark_mc_segmap_task_338257_err != 0) {
            ;
            err = futhark_mc_segmap_task_338257_err;
            goto cleanup;
        }
        if (s_n_m_292825 * (int64_t) 8 > 0)
            memmove(mem_314584.mem + gtid_325471 * s_n_m_292825 * (int64_t) 8,
                    mem_325473 + (int64_t) 0, s_n_m_292825 * (int64_t) 8);
        if (s_n_m_292825 * (int64_t) 8 > 0)
            memmove(mem_314588.mem + gtid_325471 * s_n_m_292825 * (int64_t) 8,
                    mem_325474 + (int64_t) 0, s_n_m_292825 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_325473);
    free(mem_325474);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338253_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338253_end -
                 futhark_mc_segmap_parloop_338253_start;
        
        ctx->futhark_mc_segmap_parloop_338253_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338253_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338253_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_nested_task_338251(void *args, int64_t iterations,
                                         int tid, struct scheduler_info info)
{
    int err = 0;
    int flat_tid_325470 = tid;
    int num_tasks_325801 = info.nsubtasks;
    struct futhark_mc_task_338245 *futhark_mc_task_338245 =
                                  (struct futhark_mc_task_338245 *) args;
    struct futhark_context *ctx = futhark_mc_task_338245->ctx;
    uint64_t futhark_mc_segmap_nested_task_338251_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_nested_task_338251_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_338245->free_n_p_292677;
    int64_t q_s_292678 = futhark_mc_task_338245->free_q_s_292678;
    int64_t jump_s_292684 = futhark_mc_task_338245->free_jump_s_292684;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_338245->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_task_338245->free_pad_css_len_292821;
    int64_t s_n_m_292825 = futhark_mc_task_338245->free_s_n_m_292825;
    int64_t gtid_303144 = futhark_mc_task_338245->free_gtid_303144;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_task_338245->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_312842 = {.desc ="mem_312842", .mem =
                                  futhark_mc_task_338245->free_mem_312842,
                                  .size =0, .references =NULL};
    int64_t bytes_312847 = futhark_mc_task_338245->free_bytes_312847;
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_task_338245->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_task_338245->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_task_338245->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_task_338245->free_mem_313371,
                                  .size =0, .references =NULL};
    struct memblock mem_314584 = {.desc ="mem_314584", .mem =
                                  futhark_mc_task_338245->free_mem_314584,
                                  .size =0, .references =NULL};
    struct memblock mem_314588 = {.desc ="mem_314588", .mem =
                                  futhark_mc_task_338245->free_mem_314588,
                                  .size =0, .references =NULL};
    int64_t iter_325916;
    struct futhark_mc_segmap_parloop_struct_338252
    futhark_mc_segmap_parloop_struct_338252;
    
    futhark_mc_segmap_parloop_struct_338252.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338252.free_n_p_292677 = n_p_292677;
    futhark_mc_segmap_parloop_struct_338252.free_q_s_292678 = q_s_292678;
    futhark_mc_segmap_parloop_struct_338252.free_jump_s_292684 = jump_s_292684;
    futhark_mc_segmap_parloop_struct_338252.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segmap_parloop_struct_338252.free_pad_css_len_292821 =
        pad_css_len_292821;
    futhark_mc_segmap_parloop_struct_338252.free_s_n_m_292825 = s_n_m_292825;
    futhark_mc_segmap_parloop_struct_338252.free_gtid_303144 = gtid_303144;
    futhark_mc_segmap_parloop_struct_338252.free_mem_312838 = mem_312838.mem;
    futhark_mc_segmap_parloop_struct_338252.free_mem_312842 = mem_312842.mem;
    futhark_mc_segmap_parloop_struct_338252.free_bytes_312847 = bytes_312847;
    futhark_mc_segmap_parloop_struct_338252.free_mem_313018 = mem_313018.mem;
    futhark_mc_segmap_parloop_struct_338252.free_mem_313023 = mem_313023.mem;
    futhark_mc_segmap_parloop_struct_338252.free_mem_313366 = mem_313366.mem;
    futhark_mc_segmap_parloop_struct_338252.free_mem_313371 = mem_313371.mem;
    futhark_mc_segmap_parloop_struct_338252.free_mem_314584 = mem_314584.mem;
    futhark_mc_segmap_parloop_struct_338252.free_mem_314588 = mem_314588.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338253_task;
    
    futhark_mc_segmap_parloop_338253_task.name =
        "futhark_mc_segmap_parloop_338253";
    futhark_mc_segmap_parloop_338253_task.fn = futhark_mc_segmap_parloop_338253;
    futhark_mc_segmap_parloop_338253_task.args =
        &futhark_mc_segmap_parloop_struct_338252;
    futhark_mc_segmap_parloop_338253_task.iterations = iterations;
    futhark_mc_segmap_parloop_338253_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338253_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338253_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338253_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338253_task);
    
    if (futhark_mc_segmap_parloop_338253_err != 0) {
        err = futhark_mc_segmap_parloop_338253_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338253_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338253_total_end -
                 futhark_mc_segmap_parloop_338253_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338253_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338253_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338253_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_nested_task_338251_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_nested_task_338251_end -
                 futhark_mc_segmap_nested_task_338251_start;
        
        ctx->futhark_mc_segmap_nested_task_338251_runs[tid]++;
        ctx->futhark_mc_segmap_nested_task_338251_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_nested_task_338251_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
static int futhark_mc_segmap_parloop_338242(void *args, int64_t start,
                                            int64_t end, int flat_tid_303143,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338241
    *futhark_mc_segmap_parloop_struct_338241 =
    (struct futhark_mc_segmap_parloop_struct_338241 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338241->ctx;
    uint64_t futhark_mc_segmap_parloop_338242_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338242_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segmap_parloop_struct_338241->free_n_p_292677;
    int64_t q_s_292678 =
            futhark_mc_segmap_parloop_struct_338241->free_q_s_292678;
    int64_t jump_s_292684 =
            futhark_mc_segmap_parloop_struct_338241->free_jump_s_292684;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_338241->free_partition_sizze_292766;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segmap_parloop_struct_338241->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_segmap_parloop_struct_338241->free_pad_css_len_292821;
    int64_t s_n_m_292825 =
            futhark_mc_segmap_parloop_struct_338241->free_s_n_m_292825;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_segmap_parloop_struct_338241->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_312842 = {.desc ="mem_312842", .mem =
                                  futhark_mc_segmap_parloop_struct_338241->free_mem_312842,
                                  .size =0, .references =NULL};
    int64_t bytes_312847 =
            futhark_mc_segmap_parloop_struct_338241->free_bytes_312847;
    int64_t bytes_312899 =
            futhark_mc_segmap_parloop_struct_338241->free_bytes_312899;
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_segmap_parloop_struct_338241->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_segmap_parloop_struct_338241->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_segmap_parloop_struct_338241->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_segmap_parloop_struct_338241->free_mem_313371,
                                  .size =0, .references =NULL};
    struct memblock mem_314687 = {.desc ="mem_314687", .mem =
                                  futhark_mc_segmap_parloop_struct_338241->free_mem_314687,
                                  .size =0, .references =NULL};
    struct memblock mem_314692 = {.desc ="mem_314692", .mem =
                                  futhark_mc_segmap_parloop_struct_338241->free_mem_314692,
                                  .size =0, .references =NULL};
    size_t mem_314584_cached_sizze_338243 = 0;
    unsigned char *mem_314584 = NULL;
    size_t mem_314588_cached_sizze_338244 = 0;
    unsigned char *mem_314588 = NULL;
    int64_t iterations = end - start;
    int64_t iter_325469 = start;
    
    if (mem_314584_cached_sizze_338243 < (size_t) bytes_312899) {
        mem_314584 = realloc(mem_314584, bytes_312899);
        mem_314584_cached_sizze_338243 = bytes_312899;
    }
    if (mem_314588_cached_sizze_338244 < (size_t) bytes_312899) {
        mem_314588 = realloc(mem_314588, bytes_312899);
        mem_314588_cached_sizze_338244 = bytes_312899;
    }
    for (; iter_325469 < end; iter_325469++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_325799 = partition_sizze_292766;
        int64_t gtid_303144 = iter_325469;
        int64_t remnant_325800 = iter_325469 - gtid_303144;
        int64_t flat_tid_325686 = (int64_t) 0;
        int32_t num_tasks_325801;
        int64_t flat_tid_325470 = (int64_t) 0;
        struct futhark_mc_task_338245 futhark_mc_task_338245;
        
        futhark_mc_task_338245.ctx = ctx;
        futhark_mc_task_338245.free_n_p_292677 = n_p_292677;
        futhark_mc_task_338245.free_q_s_292678 = q_s_292678;
        futhark_mc_task_338245.free_jump_s_292684 = jump_s_292684;
        futhark_mc_task_338245.free_defunc_0_f_res_292820 =
            defunc_0_f_res_292820;
        futhark_mc_task_338245.free_pad_css_len_292821 = pad_css_len_292821;
        futhark_mc_task_338245.free_s_n_m_292825 = s_n_m_292825;
        futhark_mc_task_338245.free_gtid_303144 = gtid_303144;
        futhark_mc_task_338245.free_mem_312838 = mem_312838.mem;
        futhark_mc_task_338245.free_mem_312842 = mem_312842.mem;
        futhark_mc_task_338245.free_bytes_312847 = bytes_312847;
        futhark_mc_task_338245.free_mem_313018 = mem_313018.mem;
        futhark_mc_task_338245.free_mem_313023 = mem_313023.mem;
        futhark_mc_task_338245.free_mem_313366 = mem_313366.mem;
        futhark_mc_task_338245.free_mem_313371 = mem_313371.mem;
        futhark_mc_task_338245.free_mem_314584 = mem_314584;
        futhark_mc_task_338245.free_mem_314588 = mem_314588;
        
        struct scheduler_segop futhark_mc_task_338245_task;
        
        futhark_mc_task_338245_task.args = &futhark_mc_task_338245;
        futhark_mc_task_338245_task.top_level_fn =
            futhark_mc_segmap_task_338246;
        futhark_mc_task_338245_task.name = "futhark_mc_segmap_task_338246";
        futhark_mc_task_338245_task.iterations = n_p_292677;
        futhark_mc_task_338245_task.task_time =
            &ctx->futhark_mc_segmap_task_338246_total_time;
        futhark_mc_task_338245_task.task_iter =
            &ctx->futhark_mc_segmap_task_338246_total_iter;
        futhark_mc_task_338245_task.sched = STATIC;
        futhark_mc_task_338245_task.nested_fn =
            futhark_mc_segmap_nested_task_338251;
        
        int futhark_mc_segmap_task_338246_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_338245_task);
        
        if (futhark_mc_segmap_task_338246_err != 0) {
            ;
            err = futhark_mc_segmap_task_338246_err;
            goto cleanup;
        }
        if (n_p_292677 * s_n_m_292825 * (int64_t) 8 > 0)
            memmove(mem_314687.mem + gtid_303144 * (s_n_m_292825 * n_p_292677) *
                    (int64_t) 8, mem_314584 + (int64_t) 0, n_p_292677 *
                    s_n_m_292825 * (int64_t) 8);
        if (n_p_292677 * s_n_m_292825 * (int64_t) 8 > 0)
            memmove(mem_314692.mem + gtid_303144 * (s_n_m_292825 * n_p_292677) *
                    (int64_t) 8, mem_314588 + (int64_t) 0, n_p_292677 *
                    s_n_m_292825 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_314584);
    free(mem_314588);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338242_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338242_end -
                 futhark_mc_segmap_parloop_338242_start;
        
        ctx->futhark_mc_segmap_parloop_338242_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338242_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338242_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_nested_task_338240(void *args, int64_t iterations,
                                         int tid, struct scheduler_info info)
{
    int err = 0;
    int flat_tid_303143 = tid;
    int num_tasks_325346 = info.nsubtasks;
    struct futhark_mc_task_338234 *futhark_mc_task_338234 =
                                  (struct futhark_mc_task_338234 *) args;
    struct futhark_context *ctx = futhark_mc_task_338234->ctx;
    uint64_t futhark_mc_segmap_nested_task_338240_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_nested_task_338240_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_338234->free_n_p_292677;
    int64_t q_s_292678 = futhark_mc_task_338234->free_q_s_292678;
    int64_t jump_s_292684 = futhark_mc_task_338234->free_jump_s_292684;
    int64_t partition_sizze_292766 =
            futhark_mc_task_338234->free_partition_sizze_292766;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_338234->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_task_338234->free_pad_css_len_292821;
    int64_t s_n_m_292825 = futhark_mc_task_338234->free_s_n_m_292825;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_task_338234->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_312842 = {.desc ="mem_312842", .mem =
                                  futhark_mc_task_338234->free_mem_312842,
                                  .size =0, .references =NULL};
    int64_t bytes_312847 = futhark_mc_task_338234->free_bytes_312847;
    int64_t bytes_312899 = futhark_mc_task_338234->free_bytes_312899;
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_task_338234->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_task_338234->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_task_338234->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_task_338234->free_mem_313371,
                                  .size =0, .references =NULL};
    struct memblock mem_314687 = {.desc ="mem_314687", .mem =
                                  futhark_mc_task_338234->free_mem_314687,
                                  .size =0, .references =NULL};
    struct memblock mem_314692 = {.desc ="mem_314692", .mem =
                                  futhark_mc_task_338234->free_mem_314692,
                                  .size =0, .references =NULL};
    int64_t iter_325469;
    struct futhark_mc_segmap_parloop_struct_338241
    futhark_mc_segmap_parloop_struct_338241;
    
    futhark_mc_segmap_parloop_struct_338241.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338241.free_n_p_292677 = n_p_292677;
    futhark_mc_segmap_parloop_struct_338241.free_q_s_292678 = q_s_292678;
    futhark_mc_segmap_parloop_struct_338241.free_jump_s_292684 = jump_s_292684;
    futhark_mc_segmap_parloop_struct_338241.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_338241.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segmap_parloop_struct_338241.free_pad_css_len_292821 =
        pad_css_len_292821;
    futhark_mc_segmap_parloop_struct_338241.free_s_n_m_292825 = s_n_m_292825;
    futhark_mc_segmap_parloop_struct_338241.free_mem_312838 = mem_312838.mem;
    futhark_mc_segmap_parloop_struct_338241.free_mem_312842 = mem_312842.mem;
    futhark_mc_segmap_parloop_struct_338241.free_bytes_312847 = bytes_312847;
    futhark_mc_segmap_parloop_struct_338241.free_bytes_312899 = bytes_312899;
    futhark_mc_segmap_parloop_struct_338241.free_mem_313018 = mem_313018.mem;
    futhark_mc_segmap_parloop_struct_338241.free_mem_313023 = mem_313023.mem;
    futhark_mc_segmap_parloop_struct_338241.free_mem_313366 = mem_313366.mem;
    futhark_mc_segmap_parloop_struct_338241.free_mem_313371 = mem_313371.mem;
    futhark_mc_segmap_parloop_struct_338241.free_mem_314687 = mem_314687.mem;
    futhark_mc_segmap_parloop_struct_338241.free_mem_314692 = mem_314692.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338242_task;
    
    futhark_mc_segmap_parloop_338242_task.name =
        "futhark_mc_segmap_parloop_338242";
    futhark_mc_segmap_parloop_338242_task.fn = futhark_mc_segmap_parloop_338242;
    futhark_mc_segmap_parloop_338242_task.args =
        &futhark_mc_segmap_parloop_struct_338241;
    futhark_mc_segmap_parloop_338242_task.iterations = iterations;
    futhark_mc_segmap_parloop_338242_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338242_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338242_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338242_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338242_task);
    
    if (futhark_mc_segmap_parloop_338242_err != 0) {
        err = futhark_mc_segmap_parloop_338242_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338242_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338242_total_end -
                 futhark_mc_segmap_parloop_338242_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338242_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338242_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338242_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_nested_task_338240_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_nested_task_338240_end -
                 futhark_mc_segmap_nested_task_338240_start;
        
        ctx->futhark_mc_segmap_nested_task_338240_runs[tid]++;
        ctx->futhark_mc_segmap_nested_task_338240_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_nested_task_338240_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_task_338276 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_q_s_292678;
    int64_t free_jump_s_292684;
    int64_t free_partition_sizze_292766;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_312842;
    int64_t free_bytes_312847;
    int64_t free_bytes_312899;
    unsigned char *free_mem_313018;
    unsigned char *free_mem_313023;
    unsigned char *free_mem_313366;
    unsigned char *free_mem_313371;
    unsigned char *free_mem_314835;
    unsigned char *free_mem_314840;
};
struct futhark_mc_segmap_parloop_struct_338278 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_q_s_292678;
    int64_t free_jump_s_292684;
    int64_t free_partition_sizze_292766;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_312842;
    int64_t free_bytes_312899;
    unsigned char *free_mem_313018;
    unsigned char *free_mem_313023;
    unsigned char *free_mem_313366;
    unsigned char *free_mem_313371;
    unsigned char *free_mem_314835;
    unsigned char *free_mem_314840;
};
static int futhark_mc_segmap_parloop_338279(void *args, int64_t start,
                                            int64_t end, int flat_tid_303496,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338278
    *futhark_mc_segmap_parloop_struct_338278 =
    (struct futhark_mc_segmap_parloop_struct_338278 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338278->ctx;
    uint64_t futhark_mc_segmap_parloop_338279_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338279_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segmap_parloop_struct_338278->free_n_p_292677;
    int64_t q_s_292678 =
            futhark_mc_segmap_parloop_struct_338278->free_q_s_292678;
    int64_t jump_s_292684 =
            futhark_mc_segmap_parloop_struct_338278->free_jump_s_292684;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_338278->free_partition_sizze_292766;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segmap_parloop_struct_338278->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_segmap_parloop_struct_338278->free_pad_css_len_292821;
    int64_t s_n_m_292825 =
            futhark_mc_segmap_parloop_struct_338278->free_s_n_m_292825;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_segmap_parloop_struct_338278->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_312842 = {.desc ="mem_312842", .mem =
                                  futhark_mc_segmap_parloop_struct_338278->free_mem_312842,
                                  .size =0, .references =NULL};
    int64_t bytes_312899 =
            futhark_mc_segmap_parloop_struct_338278->free_bytes_312899;
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_segmap_parloop_struct_338278->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_segmap_parloop_struct_338278->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_segmap_parloop_struct_338278->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_segmap_parloop_struct_338278->free_mem_313371,
                                  .size =0, .references =NULL};
    struct memblock mem_314835 = {.desc ="mem_314835", .mem =
                                  futhark_mc_segmap_parloop_struct_338278->free_mem_314835,
                                  .size =0, .references =NULL};
    struct memblock mem_314840 = {.desc ="mem_314840", .mem =
                                  futhark_mc_segmap_parloop_struct_338278->free_mem_314840,
                                  .size =0, .references =NULL};
    size_t mem_314740_cached_sizze_338280 = 0;
    unsigned char *mem_314740 = NULL;
    size_t mem_314744_cached_sizze_338281 = 0;
    unsigned char *mem_314744 = NULL;
    int64_t iterations = end - start;
    int64_t iter_326340 = start;
    
    if (mem_314740_cached_sizze_338280 < (size_t) bytes_312899) {
        mem_314740 = realloc(mem_314740, bytes_312899);
        mem_314740_cached_sizze_338280 = bytes_312899;
    }
    if (mem_314744_cached_sizze_338281 < (size_t) bytes_312899) {
        mem_314744 = realloc(mem_314744, bytes_312899);
        mem_314744_cached_sizze_338281 = bytes_312899;
    }
    for (; iter_326340 < end; iter_326340++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_326483 = partition_sizze_292766;
        int64_t gtid_303497 = iter_326340;
        int64_t remnant_326484 = iter_326340 - gtid_303497;
        
        for (int64_t i_326341 = 0; i_326341 < n_p_292677; i_326341++) {
            int64_t x_326344;
            
            x_326344 = ((int64_t *) mem_312842.mem)[gtid_303497 * n_p_292677 +
                                                    i_326341];
            for (int64_t i_326347 = 0; i_326347 < s_n_m_292825; i_326347++) {
                int64_t x_326350;
                
                x_326350 = ((int64_t *) mem_313018.mem)[gtid_303497 *
                                                        (s_n_m_292825 *
                                                         n_p_292677) +
                                                        i_326341 *
                                                        s_n_m_292825 +
                                                        i_326347];
                
                double x_326351;
                
                x_326351 = ((double *) mem_313023.mem)[gtid_303497 *
                                                       (s_n_m_292825 *
                                                        n_p_292677) + i_326341 *
                                                       s_n_m_292825 + i_326347];
                
                bool cond_326352 = i_326347 == (int64_t) 0;
                int64_t defunc_0_m_fun_res_326353;
                
                if (cond_326352) {
                    defunc_0_m_fun_res_326353 = (int64_t) 0;
                } else {
                    int64_t y_326354 = sub64(s_n_m_292825, (int64_t) 1);
                    bool cond_326355 = i_326347 == y_326354;
                    int64_t defunc_0_m_fun_res_f_res_326356;
                    
                    if (cond_326355) {
                        int64_t defunc_0_m_fun_res_f_res_t_res_326357 =
                                sub64(pad_css_len_292821, (int64_t) 1);
                        
                        defunc_0_m_fun_res_f_res_326356 =
                            defunc_0_m_fun_res_f_res_t_res_326357;
                    } else {
                        int64_t x_326358 = sub64(i_326347, (int64_t) 1);
                        int64_t x_326359 = mul64(jump_s_292684, x_326358);
                        int64_t min_arg_326360 = add64((int64_t) 1, x_326359);
                        int64_t min_res_326361 = smin64(defunc_0_f_res_292820,
                                                        min_arg_326360);
                        
                        defunc_0_m_fun_res_f_res_326356 = min_res_326361;
                    }
                    defunc_0_m_fun_res_326353 = defunc_0_m_fun_res_f_res_326356;
                }
                
                double defunc_2_reduce_res_326362;
                double defunc_2_reduce_res_326363;
                double defunc_2_reduce_res_326364;
                double defunc_2_reduce_res_326365;
                double defunc_2_reduce_res_326366;
                double redout_326368;
                double redout_326369;
                double redout_326370;
                double redout_326371;
                double redout_326372;
                
                redout_326368 = 0.0;
                redout_326369 = 0.0;
                redout_326370 = 0.0;
                redout_326371 = 0.0;
                redout_326372 = 0.0;
                for (int64_t i_326367 = 0; i_326367 < q_s_292678; i_326367++) {
                    bool cond_326373 = sle64(x_326344, i_326367);
                    int64_t defunc_0_f_res_326374;
                    
                    if (cond_326373) {
                        defunc_0_f_res_326374 = (int64_t) 0;
                    } else {
                        int64_t i_326375 = add64(x_326350, i_326367);
                        int64_t defunc_0_add_arg_326376;
                        
                        defunc_0_add_arg_326376 =
                            ((int64_t *) mem_312838.mem)[gtid_303497 *
                                                         (defunc_0_f_res_292820 *
                                                          n_p_292677) +
                                                         i_326341 *
                                                         defunc_0_f_res_292820 +
                                                         i_326375];
                        
                        int64_t defunc_1_add_res_326377 = add64((int64_t) 1,
                                                                defunc_0_add_arg_326376);
                        
                        defunc_0_f_res_326374 = defunc_1_add_res_326377;
                    }
                    
                    double defunc_0_f_res_326378;
                    
                    if (cond_326373) {
                        defunc_0_f_res_326378 = 0.0;
                    } else {
                        int64_t i_326379 = add64(x_326350, i_326367);
                        double defunc_0_add_arg_326380;
                        
                        defunc_0_add_arg_326380 =
                            ((double *) mem_313371.mem)[gtid_303497 *
                                                        (defunc_0_f_res_292820 *
                                                         n_p_292677) +
                                                        i_326341 *
                                                        defunc_0_f_res_292820 +
                                                        i_326379];
                        defunc_0_f_res_326378 = defunc_0_add_arg_326380;
                    }
                    
                    int64_t binop_p_326381 = sub64(defunc_0_f_res_326374,
                                                   defunc_0_m_fun_res_326353);
                    double defunc_0_f_res_326382 =
                           sitofp_i64_f64(binop_p_326381);
                    double abs_res_326383 = fabs(defunc_0_f_res_326382);
                    double tmp1_326384 = abs_res_326383 / x_326351;
                    double x_326385 = tmp1_326384 * tmp1_326384;
                    double y_326386 = tmp1_326384 * x_326385;
                    double tmp2_326387 = 1.0 - y_326386;
                    double x_326388 = tmp2_326387 * tmp2_326387;
                    double tmp3_326389 = tmp2_326387 * x_326388;
                    double w_j_326390 = defunc_0_f_res_326378 * tmp3_326389;
                    double xw_j_326391 = defunc_0_f_res_326382 * w_j_326390;
                    double x2w_j_326392 = defunc_0_f_res_326382 * xw_j_326391;
                    double x3w_j_326393 = defunc_0_f_res_326382 * x2w_j_326392;
                    double x4w_j_326394 = defunc_0_f_res_326382 * x3w_j_326393;
                    double defunc_1_op_res_326395 = w_j_326390 + redout_326368;
                    double defunc_1_op_res_326396 = xw_j_326391 + redout_326369;
                    double defunc_1_op_res_326397 = x2w_j_326392 +
                           redout_326370;
                    double defunc_1_op_res_326398 = x3w_j_326393 +
                           redout_326371;
                    double defunc_1_op_res_326399 = x4w_j_326394 +
                           redout_326372;
                    double redout_tmp_326489 = defunc_1_op_res_326395;
                    double redout_tmp_326490 = defunc_1_op_res_326396;
                    double redout_tmp_326491 = defunc_1_op_res_326397;
                    double redout_tmp_326492 = defunc_1_op_res_326398;
                    double redout_tmp_326493 = defunc_1_op_res_326399;
                    
                    redout_326368 = redout_tmp_326489;
                    redout_326369 = redout_tmp_326490;
                    redout_326370 = redout_tmp_326491;
                    redout_326371 = redout_tmp_326492;
                    redout_326372 = redout_tmp_326493;
                }
                defunc_2_reduce_res_326362 = redout_326368;
                defunc_2_reduce_res_326363 = redout_326369;
                defunc_2_reduce_res_326364 = redout_326370;
                defunc_2_reduce_res_326365 = redout_326371;
                defunc_2_reduce_res_326366 = redout_326372;
                
                double a_326400 = 2.220446049250313e-16 +
                       defunc_2_reduce_res_326362;
                double b_326401 = 2.220446049250313e-16 +
                       defunc_2_reduce_res_326363;
                double c_326402 = 2.220446049250313e-16 +
                       defunc_2_reduce_res_326364;
                double d_326403 = 2.220446049250313e-16 +
                       defunc_2_reduce_res_326365;
                double e_326404 = 2.220446049250313e-16 +
                       defunc_2_reduce_res_326366;
                double x_326405 = c_326402 * e_326404;
                double y_326406 = d_326403 * d_326403;
                double a12_326407 = x_326405 - y_326406;
                double x_326408 = c_326402 * d_326403;
                double y_326409 = b_326401 * e_326404;
                double b12_326410 = x_326408 - y_326409;
                double x_326411 = b_326401 * d_326403;
                double y_326412 = c_326402 * c_326402;
                double c12_326413 = x_326411 - y_326412;
                double x_326414 = a_326400 * e_326404;
                double b2_326415 = x_326414 - y_326412;
                double x_326416 = b_326401 * c_326402;
                double y_326417 = a_326400 * d_326403;
                double c2_326418 = x_326416 - y_326417;
                double x_326419 = a_326400 * a12_326407;
                double y_326420 = b_326401 * b12_326410;
                double x_326421 = x_326419 + y_326420;
                double y_326422 = c_326402 * c12_326413;
                double y_326423 = x_326421 + y_326422;
                double det_326424 = 1.0 / y_326423;
                double a12_326425 = a12_326407 * det_326424;
                double b12_326426 = b12_326410 * det_326424;
                double c12_326427 = c12_326413 * det_326424;
                double b2_326428 = b2_326415 * det_326424;
                double c2_326429 = c2_326418 * det_326424;
                int64_t defunc_0_m_fun_res_326430;
                
                if (cond_326352) {
                    defunc_0_m_fun_res_326430 = (int64_t) 0;
                } else {
                    int64_t y_326431 = sub64(s_n_m_292825, (int64_t) 1);
                    bool cond_326432 = i_326347 == y_326431;
                    int64_t defunc_0_m_fun_res_f_res_326433;
                    
                    if (cond_326432) {
                        int64_t defunc_0_m_fun_res_f_res_t_res_326434 =
                                sub64(pad_css_len_292821, (int64_t) 1);
                        
                        defunc_0_m_fun_res_f_res_326433 =
                            defunc_0_m_fun_res_f_res_t_res_326434;
                    } else {
                        int64_t x_326435 = sub64(i_326347, (int64_t) 1);
                        int64_t x_326436 = mul64(jump_s_292684, x_326435);
                        int64_t min_arg_326437 = add64((int64_t) 1, x_326436);
                        int64_t min_res_326438 = smin64(defunc_0_f_res_292820,
                                                        min_arg_326437);
                        
                        defunc_0_m_fun_res_f_res_326433 = min_res_326438;
                    }
                    defunc_0_m_fun_res_326430 = defunc_0_m_fun_res_f_res_326433;
                }
                
                double defunc_2_reduce_res_326439;
                double defunc_2_reduce_res_326440;
                double redout_326442;
                double redout_326443;
                
                redout_326442 = 0.0;
                redout_326443 = 0.0;
                for (int64_t i_326441 = 0; i_326441 < q_s_292678; i_326441++) {
                    bool cond_326444 = sle64(x_326344, i_326441);
                    int64_t defunc_0_f_res_326445;
                    
                    if (cond_326444) {
                        defunc_0_f_res_326445 = (int64_t) 0;
                    } else {
                        int64_t i_326446 = add64(x_326350, i_326441);
                        int64_t defunc_0_add_arg_326447;
                        
                        defunc_0_add_arg_326447 =
                            ((int64_t *) mem_312838.mem)[gtid_303497 *
                                                         (defunc_0_f_res_292820 *
                                                          n_p_292677) +
                                                         i_326341 *
                                                         defunc_0_f_res_292820 +
                                                         i_326446];
                        
                        int64_t defunc_1_add_res_326448 = add64((int64_t) 1,
                                                                defunc_0_add_arg_326447);
                        
                        defunc_0_f_res_326445 = defunc_1_add_res_326448;
                    }
                    
                    double defunc_0_f_res_326449;
                    
                    if (cond_326444) {
                        defunc_0_f_res_326449 = 0.0;
                    } else {
                        int64_t i_326450 = add64(x_326350, i_326441);
                        double defunc_0_add_arg_326451;
                        
                        defunc_0_add_arg_326451 =
                            ((double *) mem_313371.mem)[gtid_303497 *
                                                        (defunc_0_f_res_292820 *
                                                         n_p_292677) +
                                                        i_326341 *
                                                        defunc_0_f_res_292820 +
                                                        i_326450];
                        defunc_0_f_res_326449 = defunc_0_add_arg_326451;
                    }
                    
                    int64_t binop_p_326452 = sub64(defunc_0_f_res_326445,
                                                   defunc_0_m_fun_res_326430);
                    double defunc_0_f_res_326453 =
                           sitofp_i64_f64(binop_p_326452);
                    double abs_res_326454 = fabs(defunc_0_f_res_326453);
                    double tmp1_326455 = abs_res_326454 / x_326351;
                    double x_326456 = tmp1_326455 * tmp1_326455;
                    double y_326457 = tmp1_326455 * x_326456;
                    double tmp2_326458 = 1.0 - y_326457;
                    double x_326459 = tmp2_326458 * tmp2_326458;
                    double tmp3_326460 = tmp2_326458 * x_326459;
                    double tmp4_326461 = defunc_0_f_res_326449 * tmp3_326460;
                    double defunc_1_f_res_326462 = defunc_0_f_res_326453 *
                           tmp4_326461;
                    double defunc_1_f_res_326463 = defunc_0_f_res_326453 *
                           defunc_1_f_res_326462;
                    double defunc_0_f_res_326464;
                    
                    if (cond_326444) {
                        defunc_0_f_res_326464 = 0.0;
                    } else {
                        int64_t i_326465 = add64(x_326350, i_326441);
                        double defunc_0_add_arg_326466;
                        
                        defunc_0_add_arg_326466 =
                            ((double *) mem_313366.mem)[gtid_303497 *
                                                        (defunc_0_f_res_292820 *
                                                         n_p_292677) +
                                                        i_326341 *
                                                        defunc_0_f_res_292820 +
                                                        i_326465];
                        defunc_0_f_res_326464 = defunc_0_add_arg_326466;
                    }
                    
                    double x_326467 = a12_326425 * tmp4_326461;
                    double y_326468 = b12_326426 * defunc_1_f_res_326462;
                    double x_326469 = x_326467 + y_326468;
                    double y_326470 = c12_326427 * defunc_1_f_res_326463;
                    double x_326471 = x_326469 + y_326470;
                    double defunc_9_fit_fun_res_326472 = defunc_0_f_res_326464 *
                           x_326471;
                    double x_326473 = b12_326426 * tmp4_326461;
                    double y_326474 = b2_326428 * defunc_1_f_res_326462;
                    double x_326475 = x_326473 + y_326474;
                    double y_326476 = c2_326429 * defunc_1_f_res_326463;
                    double x_326477 = x_326475 + y_326476;
                    double defunc_9_slope_fun_res_326478 =
                           defunc_0_f_res_326464 * x_326477;
                    double defunc_1_op_res_326479 =
                           defunc_9_fit_fun_res_326472 + redout_326442;
                    double defunc_1_op_res_326480 =
                           defunc_9_slope_fun_res_326478 + redout_326443;
                    double redout_tmp_326494 = defunc_1_op_res_326479;
                    double redout_tmp_326495 = defunc_1_op_res_326480;
                    
                    redout_326442 = redout_tmp_326494;
                    redout_326443 = redout_tmp_326495;
                }
                defunc_2_reduce_res_326439 = redout_326442;
                defunc_2_reduce_res_326440 = redout_326443;
                ((double *) mem_314740)[i_326341 * s_n_m_292825 + i_326347] =
                    defunc_2_reduce_res_326439;
                ((double *) mem_314744)[i_326341 * s_n_m_292825 + i_326347] =
                    defunc_2_reduce_res_326440;
            }
        }
        if (n_p_292677 * s_n_m_292825 * (int64_t) 8 > 0)
            memmove(mem_314835.mem + gtid_303497 * (s_n_m_292825 * n_p_292677) *
                    (int64_t) 8, mem_314740 + (int64_t) 0, n_p_292677 *
                    s_n_m_292825 * (int64_t) 8);
        if (n_p_292677 * s_n_m_292825 * (int64_t) 8 > 0)
            memmove(mem_314840.mem + gtid_303497 * (s_n_m_292825 * n_p_292677) *
                    (int64_t) 8, mem_314744 + (int64_t) 0, n_p_292677 *
                    s_n_m_292825 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_314740);
    free(mem_314744);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338279_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338279_end -
                 futhark_mc_segmap_parloop_338279_start;
        
        ctx->futhark_mc_segmap_parloop_338279_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338279_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338279_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_338277(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_303496 = tid;
    int num_tasks_326339 = info.nsubtasks;
    struct futhark_mc_task_338276 *futhark_mc_task_338276 =
                                  (struct futhark_mc_task_338276 *) args;
    struct futhark_context *ctx = futhark_mc_task_338276->ctx;
    uint64_t futhark_mc_segmap_task_338277_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_338277_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_338276->free_n_p_292677;
    int64_t q_s_292678 = futhark_mc_task_338276->free_q_s_292678;
    int64_t jump_s_292684 = futhark_mc_task_338276->free_jump_s_292684;
    int64_t partition_sizze_292766 =
            futhark_mc_task_338276->free_partition_sizze_292766;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_338276->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_task_338276->free_pad_css_len_292821;
    int64_t s_n_m_292825 = futhark_mc_task_338276->free_s_n_m_292825;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_task_338276->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_312842 = {.desc ="mem_312842", .mem =
                                  futhark_mc_task_338276->free_mem_312842,
                                  .size =0, .references =NULL};
    int64_t bytes_312847 = futhark_mc_task_338276->free_bytes_312847;
    int64_t bytes_312899 = futhark_mc_task_338276->free_bytes_312899;
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_task_338276->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_task_338276->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_task_338276->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_task_338276->free_mem_313371,
                                  .size =0, .references =NULL};
    struct memblock mem_314835 = {.desc ="mem_314835", .mem =
                                  futhark_mc_task_338276->free_mem_314835,
                                  .size =0, .references =NULL};
    struct memblock mem_314840 = {.desc ="mem_314840", .mem =
                                  futhark_mc_task_338276->free_mem_314840,
                                  .size =0, .references =NULL};
    int64_t iter_326340;
    struct futhark_mc_segmap_parloop_struct_338278
    futhark_mc_segmap_parloop_struct_338278;
    
    futhark_mc_segmap_parloop_struct_338278.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338278.free_n_p_292677 = n_p_292677;
    futhark_mc_segmap_parloop_struct_338278.free_q_s_292678 = q_s_292678;
    futhark_mc_segmap_parloop_struct_338278.free_jump_s_292684 = jump_s_292684;
    futhark_mc_segmap_parloop_struct_338278.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_338278.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segmap_parloop_struct_338278.free_pad_css_len_292821 =
        pad_css_len_292821;
    futhark_mc_segmap_parloop_struct_338278.free_s_n_m_292825 = s_n_m_292825;
    futhark_mc_segmap_parloop_struct_338278.free_mem_312838 = mem_312838.mem;
    futhark_mc_segmap_parloop_struct_338278.free_mem_312842 = mem_312842.mem;
    futhark_mc_segmap_parloop_struct_338278.free_bytes_312899 = bytes_312899;
    futhark_mc_segmap_parloop_struct_338278.free_mem_313018 = mem_313018.mem;
    futhark_mc_segmap_parloop_struct_338278.free_mem_313023 = mem_313023.mem;
    futhark_mc_segmap_parloop_struct_338278.free_mem_313366 = mem_313366.mem;
    futhark_mc_segmap_parloop_struct_338278.free_mem_313371 = mem_313371.mem;
    futhark_mc_segmap_parloop_struct_338278.free_mem_314835 = mem_314835.mem;
    futhark_mc_segmap_parloop_struct_338278.free_mem_314840 = mem_314840.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338279_task;
    
    futhark_mc_segmap_parloop_338279_task.name =
        "futhark_mc_segmap_parloop_338279";
    futhark_mc_segmap_parloop_338279_task.fn = futhark_mc_segmap_parloop_338279;
    futhark_mc_segmap_parloop_338279_task.args =
        &futhark_mc_segmap_parloop_struct_338278;
    futhark_mc_segmap_parloop_338279_task.iterations = iterations;
    futhark_mc_segmap_parloop_338279_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338279_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338279_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338279_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338279_task);
    
    if (futhark_mc_segmap_parloop_338279_err != 0) {
        err = futhark_mc_segmap_parloop_338279_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338279_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338279_total_end -
                 futhark_mc_segmap_parloop_338279_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338279_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338279_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338279_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_338277_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_338277_end -
                 futhark_mc_segmap_task_338277_start;
        
        ctx->futhark_mc_segmap_task_338277_runs[tid]++;
        ctx->futhark_mc_segmap_task_338277_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_338277_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_segmap_parloop_struct_338283 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_q_s_292678;
    int64_t free_jump_s_292684;
    int64_t free_partition_sizze_292766;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_312842;
    int64_t free_bytes_312847;
    int64_t free_bytes_312899;
    unsigned char *free_mem_313018;
    unsigned char *free_mem_313023;
    unsigned char *free_mem_313366;
    unsigned char *free_mem_313371;
    unsigned char *free_mem_314835;
    unsigned char *free_mem_314840;
};
struct futhark_mc_task_338287 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_q_s_292678;
    int64_t free_jump_s_292684;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    int64_t free_gtid_303954;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_312842;
    int64_t free_bytes_312847;
    unsigned char *free_mem_313018;
    unsigned char *free_mem_313023;
    unsigned char *free_mem_313366;
    unsigned char *free_mem_313371;
    unsigned char *free_mem_314732;
    unsigned char *free_mem_314736;
};
struct futhark_mc_segmap_parloop_struct_338289 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_q_s_292678;
    int64_t free_jump_s_292684;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    int64_t free_gtid_303954;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_312842;
    int64_t free_bytes_312847;
    unsigned char *free_mem_313018;
    unsigned char *free_mem_313023;
    unsigned char *free_mem_313366;
    unsigned char *free_mem_313371;
    unsigned char *free_mem_314732;
    unsigned char *free_mem_314736;
};
static int futhark_mc_segmap_parloop_338290(void *args, int64_t start,
                                            int64_t end, int flat_tid_326779,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338289
    *futhark_mc_segmap_parloop_struct_338289 =
    (struct futhark_mc_segmap_parloop_struct_338289 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338289->ctx;
    uint64_t futhark_mc_segmap_parloop_338290_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338290_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segmap_parloop_struct_338289->free_n_p_292677;
    int64_t q_s_292678 =
            futhark_mc_segmap_parloop_struct_338289->free_q_s_292678;
    int64_t jump_s_292684 =
            futhark_mc_segmap_parloop_struct_338289->free_jump_s_292684;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segmap_parloop_struct_338289->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_segmap_parloop_struct_338289->free_pad_css_len_292821;
    int64_t s_n_m_292825 =
            futhark_mc_segmap_parloop_struct_338289->free_s_n_m_292825;
    int64_t gtid_303954 =
            futhark_mc_segmap_parloop_struct_338289->free_gtid_303954;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_segmap_parloop_struct_338289->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_312842 = {.desc ="mem_312842", .mem =
                                  futhark_mc_segmap_parloop_struct_338289->free_mem_312842,
                                  .size =0, .references =NULL};
    int64_t bytes_312847 =
            futhark_mc_segmap_parloop_struct_338289->free_bytes_312847;
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_segmap_parloop_struct_338289->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_segmap_parloop_struct_338289->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_segmap_parloop_struct_338289->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_segmap_parloop_struct_338289->free_mem_313371,
                                  .size =0, .references =NULL};
    struct memblock mem_314732 = {.desc ="mem_314732", .mem =
                                  futhark_mc_segmap_parloop_struct_338289->free_mem_314732,
                                  .size =0, .references =NULL};
    struct memblock mem_314736 = {.desc ="mem_314736", .mem =
                                  futhark_mc_segmap_parloop_struct_338289->free_mem_314736,
                                  .size =0, .references =NULL};
    size_t mem_326782_cached_sizze_338291 = 0;
    unsigned char *mem_326782 = NULL;
    size_t mem_326784_cached_sizze_338292 = 0;
    unsigned char *mem_326784 = NULL;
    int64_t iterations = end - start;
    int64_t iter_326927 = start;
    
    if (mem_326782_cached_sizze_338291 < (size_t) bytes_312847) {
        mem_326782 = realloc(mem_326782, bytes_312847);
        mem_326782_cached_sizze_338291 = bytes_312847;
    }
    if (mem_326784_cached_sizze_338292 < (size_t) bytes_312847) {
        mem_326784 = realloc(mem_326784, bytes_312847);
        mem_326784_cached_sizze_338292 = bytes_312847;
    }
    for (; iter_326927 < end; iter_326927++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_327064 = n_p_292677;
        int64_t gtid_326780 = iter_326927;
        int64_t remnant_327065 = iter_326927 - gtid_326780;
        int64_t x_326781;
        
        x_326781 = ((int64_t *) mem_312842.mem)[gtid_303954 * n_p_292677 +
                                                gtid_326780];
        for (int64_t i_326928 = 0; i_326928 < s_n_m_292825; i_326928++) {
            int64_t x_326931;
            
            x_326931 = ((int64_t *) mem_313018.mem)[gtid_303954 *
                                                    (s_n_m_292825 *
                                                     n_p_292677) + gtid_326780 *
                                                    s_n_m_292825 + i_326928];
            
            double x_326932;
            
            x_326932 = ((double *) mem_313023.mem)[gtid_303954 * (s_n_m_292825 *
                                                                  n_p_292677) +
                                                   gtid_326780 * s_n_m_292825 +
                                                   i_326928];
            
            bool cond_326933 = i_326928 == (int64_t) 0;
            int64_t defunc_0_m_fun_res_326934;
            
            if (cond_326933) {
                defunc_0_m_fun_res_326934 = (int64_t) 0;
            } else {
                int64_t y_326935 = sub64(s_n_m_292825, (int64_t) 1);
                bool cond_326936 = i_326928 == y_326935;
                int64_t defunc_0_m_fun_res_f_res_326937;
                
                if (cond_326936) {
                    int64_t defunc_0_m_fun_res_f_res_t_res_326938 =
                            sub64(pad_css_len_292821, (int64_t) 1);
                    
                    defunc_0_m_fun_res_f_res_326937 =
                        defunc_0_m_fun_res_f_res_t_res_326938;
                } else {
                    int64_t x_326939 = sub64(i_326928, (int64_t) 1);
                    int64_t x_326940 = mul64(jump_s_292684, x_326939);
                    int64_t min_arg_326941 = add64((int64_t) 1, x_326940);
                    int64_t min_res_326942 = smin64(defunc_0_f_res_292820,
                                                    min_arg_326941);
                    
                    defunc_0_m_fun_res_f_res_326937 = min_res_326942;
                }
                defunc_0_m_fun_res_326934 = defunc_0_m_fun_res_f_res_326937;
            }
            
            double defunc_2_reduce_res_326943;
            double defunc_2_reduce_res_326944;
            double defunc_2_reduce_res_326945;
            double defunc_2_reduce_res_326946;
            double defunc_2_reduce_res_326947;
            double redout_326949;
            double redout_326950;
            double redout_326951;
            double redout_326952;
            double redout_326953;
            
            redout_326949 = 0.0;
            redout_326950 = 0.0;
            redout_326951 = 0.0;
            redout_326952 = 0.0;
            redout_326953 = 0.0;
            for (int64_t i_326948 = 0; i_326948 < q_s_292678; i_326948++) {
                bool cond_326954 = sle64(x_326781, i_326948);
                int64_t defunc_0_f_res_326955;
                
                if (cond_326954) {
                    defunc_0_f_res_326955 = (int64_t) 0;
                } else {
                    int64_t i_326956 = add64(x_326931, i_326948);
                    int64_t defunc_0_add_arg_326957;
                    
                    defunc_0_add_arg_326957 =
                        ((int64_t *) mem_312838.mem)[gtid_303954 *
                                                     (defunc_0_f_res_292820 *
                                                      n_p_292677) +
                                                     gtid_326780 *
                                                     defunc_0_f_res_292820 +
                                                     i_326956];
                    
                    int64_t defunc_1_add_res_326958 = add64((int64_t) 1,
                                                            defunc_0_add_arg_326957);
                    
                    defunc_0_f_res_326955 = defunc_1_add_res_326958;
                }
                
                double defunc_0_f_res_326959;
                
                if (cond_326954) {
                    defunc_0_f_res_326959 = 0.0;
                } else {
                    int64_t i_326960 = add64(x_326931, i_326948);
                    double defunc_0_add_arg_326961;
                    
                    defunc_0_add_arg_326961 =
                        ((double *) mem_313371.mem)[gtid_303954 *
                                                    (defunc_0_f_res_292820 *
                                                     n_p_292677) + gtid_326780 *
                                                    defunc_0_f_res_292820 +
                                                    i_326960];
                    defunc_0_f_res_326959 = defunc_0_add_arg_326961;
                }
                
                int64_t binop_p_326962 = sub64(defunc_0_f_res_326955,
                                               defunc_0_m_fun_res_326934);
                double defunc_0_f_res_326963 = sitofp_i64_f64(binop_p_326962);
                double abs_res_326964 = fabs(defunc_0_f_res_326963);
                double tmp1_326965 = abs_res_326964 / x_326932;
                double x_326966 = tmp1_326965 * tmp1_326965;
                double y_326967 = tmp1_326965 * x_326966;
                double tmp2_326968 = 1.0 - y_326967;
                double x_326969 = tmp2_326968 * tmp2_326968;
                double tmp3_326970 = tmp2_326968 * x_326969;
                double w_j_326971 = defunc_0_f_res_326959 * tmp3_326970;
                double xw_j_326972 = defunc_0_f_res_326963 * w_j_326971;
                double x2w_j_326973 = defunc_0_f_res_326963 * xw_j_326972;
                double x3w_j_326974 = defunc_0_f_res_326963 * x2w_j_326973;
                double x4w_j_326975 = defunc_0_f_res_326963 * x3w_j_326974;
                double defunc_1_op_res_326976 = w_j_326971 + redout_326949;
                double defunc_1_op_res_326977 = xw_j_326972 + redout_326950;
                double defunc_1_op_res_326978 = x2w_j_326973 + redout_326951;
                double defunc_1_op_res_326979 = x3w_j_326974 + redout_326952;
                double defunc_1_op_res_326980 = x4w_j_326975 + redout_326953;
                double redout_tmp_327068 = defunc_1_op_res_326976;
                double redout_tmp_327069 = defunc_1_op_res_326977;
                double redout_tmp_327070 = defunc_1_op_res_326978;
                double redout_tmp_327071 = defunc_1_op_res_326979;
                double redout_tmp_327072 = defunc_1_op_res_326980;
                
                redout_326949 = redout_tmp_327068;
                redout_326950 = redout_tmp_327069;
                redout_326951 = redout_tmp_327070;
                redout_326952 = redout_tmp_327071;
                redout_326953 = redout_tmp_327072;
            }
            defunc_2_reduce_res_326943 = redout_326949;
            defunc_2_reduce_res_326944 = redout_326950;
            defunc_2_reduce_res_326945 = redout_326951;
            defunc_2_reduce_res_326946 = redout_326952;
            defunc_2_reduce_res_326947 = redout_326953;
            
            double a_326981 = 2.220446049250313e-16 +
                   defunc_2_reduce_res_326943;
            double b_326982 = 2.220446049250313e-16 +
                   defunc_2_reduce_res_326944;
            double c_326983 = 2.220446049250313e-16 +
                   defunc_2_reduce_res_326945;
            double d_326984 = 2.220446049250313e-16 +
                   defunc_2_reduce_res_326946;
            double e_326985 = 2.220446049250313e-16 +
                   defunc_2_reduce_res_326947;
            double x_326986 = c_326983 * e_326985;
            double y_326987 = d_326984 * d_326984;
            double a12_326988 = x_326986 - y_326987;
            double x_326989 = c_326983 * d_326984;
            double y_326990 = b_326982 * e_326985;
            double b12_326991 = x_326989 - y_326990;
            double x_326992 = b_326982 * d_326984;
            double y_326993 = c_326983 * c_326983;
            double c12_326994 = x_326992 - y_326993;
            double x_326995 = a_326981 * e_326985;
            double b2_326996 = x_326995 - y_326993;
            double x_326997 = b_326982 * c_326983;
            double y_326998 = a_326981 * d_326984;
            double c2_326999 = x_326997 - y_326998;
            double x_327000 = a_326981 * a12_326988;
            double y_327001 = b_326982 * b12_326991;
            double x_327002 = x_327000 + y_327001;
            double y_327003 = c_326983 * c12_326994;
            double y_327004 = x_327002 + y_327003;
            double det_327005 = 1.0 / y_327004;
            double a12_327006 = a12_326988 * det_327005;
            double b12_327007 = b12_326991 * det_327005;
            double c12_327008 = c12_326994 * det_327005;
            double b2_327009 = b2_326996 * det_327005;
            double c2_327010 = c2_326999 * det_327005;
            int64_t defunc_0_m_fun_res_327011;
            
            if (cond_326933) {
                defunc_0_m_fun_res_327011 = (int64_t) 0;
            } else {
                int64_t y_327012 = sub64(s_n_m_292825, (int64_t) 1);
                bool cond_327013 = i_326928 == y_327012;
                int64_t defunc_0_m_fun_res_f_res_327014;
                
                if (cond_327013) {
                    int64_t defunc_0_m_fun_res_f_res_t_res_327015 =
                            sub64(pad_css_len_292821, (int64_t) 1);
                    
                    defunc_0_m_fun_res_f_res_327014 =
                        defunc_0_m_fun_res_f_res_t_res_327015;
                } else {
                    int64_t x_327016 = sub64(i_326928, (int64_t) 1);
                    int64_t x_327017 = mul64(jump_s_292684, x_327016);
                    int64_t min_arg_327018 = add64((int64_t) 1, x_327017);
                    int64_t min_res_327019 = smin64(defunc_0_f_res_292820,
                                                    min_arg_327018);
                    
                    defunc_0_m_fun_res_f_res_327014 = min_res_327019;
                }
                defunc_0_m_fun_res_327011 = defunc_0_m_fun_res_f_res_327014;
            }
            
            double defunc_2_reduce_res_327020;
            double defunc_2_reduce_res_327021;
            double redout_327023;
            double redout_327024;
            
            redout_327023 = 0.0;
            redout_327024 = 0.0;
            for (int64_t i_327022 = 0; i_327022 < q_s_292678; i_327022++) {
                bool cond_327025 = sle64(x_326781, i_327022);
                int64_t defunc_0_f_res_327026;
                
                if (cond_327025) {
                    defunc_0_f_res_327026 = (int64_t) 0;
                } else {
                    int64_t i_327027 = add64(x_326931, i_327022);
                    int64_t defunc_0_add_arg_327028;
                    
                    defunc_0_add_arg_327028 =
                        ((int64_t *) mem_312838.mem)[gtid_303954 *
                                                     (defunc_0_f_res_292820 *
                                                      n_p_292677) +
                                                     gtid_326780 *
                                                     defunc_0_f_res_292820 +
                                                     i_327027];
                    
                    int64_t defunc_1_add_res_327029 = add64((int64_t) 1,
                                                            defunc_0_add_arg_327028);
                    
                    defunc_0_f_res_327026 = defunc_1_add_res_327029;
                }
                
                double defunc_0_f_res_327030;
                
                if (cond_327025) {
                    defunc_0_f_res_327030 = 0.0;
                } else {
                    int64_t i_327031 = add64(x_326931, i_327022);
                    double defunc_0_add_arg_327032;
                    
                    defunc_0_add_arg_327032 =
                        ((double *) mem_313371.mem)[gtid_303954 *
                                                    (defunc_0_f_res_292820 *
                                                     n_p_292677) + gtid_326780 *
                                                    defunc_0_f_res_292820 +
                                                    i_327031];
                    defunc_0_f_res_327030 = defunc_0_add_arg_327032;
                }
                
                int64_t binop_p_327033 = sub64(defunc_0_f_res_327026,
                                               defunc_0_m_fun_res_327011);
                double defunc_0_f_res_327034 = sitofp_i64_f64(binop_p_327033);
                double abs_res_327035 = fabs(defunc_0_f_res_327034);
                double tmp1_327036 = abs_res_327035 / x_326932;
                double x_327037 = tmp1_327036 * tmp1_327036;
                double y_327038 = tmp1_327036 * x_327037;
                double tmp2_327039 = 1.0 - y_327038;
                double x_327040 = tmp2_327039 * tmp2_327039;
                double tmp3_327041 = tmp2_327039 * x_327040;
                double tmp4_327042 = defunc_0_f_res_327030 * tmp3_327041;
                double defunc_1_f_res_327043 = defunc_0_f_res_327034 *
                       tmp4_327042;
                double defunc_1_f_res_327044 = defunc_0_f_res_327034 *
                       defunc_1_f_res_327043;
                double defunc_0_f_res_327045;
                
                if (cond_327025) {
                    defunc_0_f_res_327045 = 0.0;
                } else {
                    int64_t i_327046 = add64(x_326931, i_327022);
                    double defunc_0_add_arg_327047;
                    
                    defunc_0_add_arg_327047 =
                        ((double *) mem_313366.mem)[gtid_303954 *
                                                    (defunc_0_f_res_292820 *
                                                     n_p_292677) + gtid_326780 *
                                                    defunc_0_f_res_292820 +
                                                    i_327046];
                    defunc_0_f_res_327045 = defunc_0_add_arg_327047;
                }
                
                double x_327048 = a12_327006 * tmp4_327042;
                double y_327049 = b12_327007 * defunc_1_f_res_327043;
                double x_327050 = x_327048 + y_327049;
                double y_327051 = c12_327008 * defunc_1_f_res_327044;
                double x_327052 = x_327050 + y_327051;
                double defunc_9_fit_fun_res_327053 = defunc_0_f_res_327045 *
                       x_327052;
                double x_327054 = b12_327007 * tmp4_327042;
                double y_327055 = b2_327009 * defunc_1_f_res_327043;
                double x_327056 = x_327054 + y_327055;
                double y_327057 = c2_327010 * defunc_1_f_res_327044;
                double x_327058 = x_327056 + y_327057;
                double defunc_9_slope_fun_res_327059 = defunc_0_f_res_327045 *
                       x_327058;
                double defunc_1_op_res_327060 = defunc_9_fit_fun_res_327053 +
                       redout_327023;
                double defunc_1_op_res_327061 = defunc_9_slope_fun_res_327059 +
                       redout_327024;
                double redout_tmp_327073 = defunc_1_op_res_327060;
                double redout_tmp_327074 = defunc_1_op_res_327061;
                
                redout_327023 = redout_tmp_327073;
                redout_327024 = redout_tmp_327074;
            }
            defunc_2_reduce_res_327020 = redout_327023;
            defunc_2_reduce_res_327021 = redout_327024;
            ((double *) mem_326782)[i_326928] = defunc_2_reduce_res_327020;
            ((double *) mem_326784)[i_326928] = defunc_2_reduce_res_327021;
        }
        if (s_n_m_292825 * (int64_t) 8 > 0)
            memmove(mem_314732.mem + gtid_326780 * s_n_m_292825 * (int64_t) 8,
                    mem_326782 + (int64_t) 0, s_n_m_292825 * (int64_t) 8);
        if (s_n_m_292825 * (int64_t) 8 > 0)
            memmove(mem_314736.mem + gtid_326780 * s_n_m_292825 * (int64_t) 8,
                    mem_326784 + (int64_t) 0, s_n_m_292825 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_326782);
    free(mem_326784);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338290_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338290_end -
                 futhark_mc_segmap_parloop_338290_start;
        
        ctx->futhark_mc_segmap_parloop_338290_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338290_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338290_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_338288(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_326779 = tid;
    int num_tasks_326926 = info.nsubtasks;
    struct futhark_mc_task_338287 *futhark_mc_task_338287 =
                                  (struct futhark_mc_task_338287 *) args;
    struct futhark_context *ctx = futhark_mc_task_338287->ctx;
    uint64_t futhark_mc_segmap_task_338288_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_338288_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_338287->free_n_p_292677;
    int64_t q_s_292678 = futhark_mc_task_338287->free_q_s_292678;
    int64_t jump_s_292684 = futhark_mc_task_338287->free_jump_s_292684;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_338287->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_task_338287->free_pad_css_len_292821;
    int64_t s_n_m_292825 = futhark_mc_task_338287->free_s_n_m_292825;
    int64_t gtid_303954 = futhark_mc_task_338287->free_gtid_303954;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_task_338287->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_312842 = {.desc ="mem_312842", .mem =
                                  futhark_mc_task_338287->free_mem_312842,
                                  .size =0, .references =NULL};
    int64_t bytes_312847 = futhark_mc_task_338287->free_bytes_312847;
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_task_338287->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_task_338287->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_task_338287->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_task_338287->free_mem_313371,
                                  .size =0, .references =NULL};
    struct memblock mem_314732 = {.desc ="mem_314732", .mem =
                                  futhark_mc_task_338287->free_mem_314732,
                                  .size =0, .references =NULL};
    struct memblock mem_314736 = {.desc ="mem_314736", .mem =
                                  futhark_mc_task_338287->free_mem_314736,
                                  .size =0, .references =NULL};
    int64_t iter_326927;
    struct futhark_mc_segmap_parloop_struct_338289
    futhark_mc_segmap_parloop_struct_338289;
    
    futhark_mc_segmap_parloop_struct_338289.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338289.free_n_p_292677 = n_p_292677;
    futhark_mc_segmap_parloop_struct_338289.free_q_s_292678 = q_s_292678;
    futhark_mc_segmap_parloop_struct_338289.free_jump_s_292684 = jump_s_292684;
    futhark_mc_segmap_parloop_struct_338289.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segmap_parloop_struct_338289.free_pad_css_len_292821 =
        pad_css_len_292821;
    futhark_mc_segmap_parloop_struct_338289.free_s_n_m_292825 = s_n_m_292825;
    futhark_mc_segmap_parloop_struct_338289.free_gtid_303954 = gtid_303954;
    futhark_mc_segmap_parloop_struct_338289.free_mem_312838 = mem_312838.mem;
    futhark_mc_segmap_parloop_struct_338289.free_mem_312842 = mem_312842.mem;
    futhark_mc_segmap_parloop_struct_338289.free_bytes_312847 = bytes_312847;
    futhark_mc_segmap_parloop_struct_338289.free_mem_313018 = mem_313018.mem;
    futhark_mc_segmap_parloop_struct_338289.free_mem_313023 = mem_313023.mem;
    futhark_mc_segmap_parloop_struct_338289.free_mem_313366 = mem_313366.mem;
    futhark_mc_segmap_parloop_struct_338289.free_mem_313371 = mem_313371.mem;
    futhark_mc_segmap_parloop_struct_338289.free_mem_314732 = mem_314732.mem;
    futhark_mc_segmap_parloop_struct_338289.free_mem_314736 = mem_314736.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338290_task;
    
    futhark_mc_segmap_parloop_338290_task.name =
        "futhark_mc_segmap_parloop_338290";
    futhark_mc_segmap_parloop_338290_task.fn = futhark_mc_segmap_parloop_338290;
    futhark_mc_segmap_parloop_338290_task.args =
        &futhark_mc_segmap_parloop_struct_338289;
    futhark_mc_segmap_parloop_338290_task.iterations = iterations;
    futhark_mc_segmap_parloop_338290_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338290_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338290_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338290_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338290_task);
    
    if (futhark_mc_segmap_parloop_338290_err != 0) {
        err = futhark_mc_segmap_parloop_338290_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338290_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338290_total_end -
                 futhark_mc_segmap_parloop_338290_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338290_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338290_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338290_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_338288_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_338288_end -
                 futhark_mc_segmap_task_338288_start;
        
        ctx->futhark_mc_segmap_task_338288_runs[tid]++;
        ctx->futhark_mc_segmap_task_338288_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_338288_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_segmap_parloop_struct_338294 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_q_s_292678;
    int64_t free_jump_s_292684;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    int64_t free_gtid_303954;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_312842;
    int64_t free_bytes_312847;
    unsigned char *free_mem_313018;
    unsigned char *free_mem_313023;
    unsigned char *free_mem_313366;
    unsigned char *free_mem_313371;
    unsigned char *free_mem_314732;
    unsigned char *free_mem_314736;
};
struct futhark_mc_task_338298 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_q_s_292678;
    int64_t free_jump_s_292684;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    int64_t free_gtid_303954;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_313018;
    unsigned char *free_mem_313023;
    unsigned char *free_mem_313366;
    unsigned char *free_mem_313371;
    int64_t free_gtid_326498;
    int64_t free_x_326499;
    unsigned char *free_mem_326500;
    unsigned char *free_mem_326501;
};
struct futhark_mc_segmap_parloop_struct_338300 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_q_s_292678;
    int64_t free_jump_s_292684;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    int64_t free_gtid_303954;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_313018;
    unsigned char *free_mem_313023;
    unsigned char *free_mem_313366;
    unsigned char *free_mem_313371;
    int64_t free_gtid_326498;
    int64_t free_x_326499;
    unsigned char *free_mem_326500;
    unsigned char *free_mem_326501;
};
static int futhark_mc_segmap_parloop_338301(void *args, int64_t start,
                                            int64_t end, int flat_tid_327218,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338300
    *futhark_mc_segmap_parloop_struct_338300 =
    (struct futhark_mc_segmap_parloop_struct_338300 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338300->ctx;
    uint64_t futhark_mc_segmap_parloop_338301_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338301_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segmap_parloop_struct_338300->free_n_p_292677;
    int64_t q_s_292678 =
            futhark_mc_segmap_parloop_struct_338300->free_q_s_292678;
    int64_t jump_s_292684 =
            futhark_mc_segmap_parloop_struct_338300->free_jump_s_292684;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segmap_parloop_struct_338300->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_segmap_parloop_struct_338300->free_pad_css_len_292821;
    int64_t s_n_m_292825 =
            futhark_mc_segmap_parloop_struct_338300->free_s_n_m_292825;
    int64_t gtid_303954 =
            futhark_mc_segmap_parloop_struct_338300->free_gtid_303954;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_segmap_parloop_struct_338300->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_segmap_parloop_struct_338300->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_segmap_parloop_struct_338300->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_segmap_parloop_struct_338300->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_segmap_parloop_struct_338300->free_mem_313371,
                                  .size =0, .references =NULL};
    int64_t gtid_326498 =
            futhark_mc_segmap_parloop_struct_338300->free_gtid_326498;
    int64_t x_326499 = futhark_mc_segmap_parloop_struct_338300->free_x_326499;
    struct memblock mem_326500 = {.desc ="mem_326500", .mem =
                                  futhark_mc_segmap_parloop_struct_338300->free_mem_326500,
                                  .size =0, .references =NULL};
    struct memblock mem_326501 = {.desc ="mem_326501", .mem =
                                  futhark_mc_segmap_parloop_struct_338300->free_mem_326501,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_327354 = start;
    
    for (; iter_327354 < end; iter_327354++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_327444 = s_n_m_292825;
        int64_t gtid_327219 = iter_327354;
        int64_t remnant_327445 = iter_327354 - gtid_327219;
        int64_t x_327220;
        
        x_327220 = ((int64_t *) mem_313018.mem)[gtid_303954 * (s_n_m_292825 *
                                                               n_p_292677) +
                                                gtid_326498 * s_n_m_292825 +
                                                gtid_327219];
        
        double x_327221;
        
        x_327221 = ((double *) mem_313023.mem)[gtid_303954 * (s_n_m_292825 *
                                                              n_p_292677) +
                                               gtid_326498 * s_n_m_292825 +
                                               gtid_327219];
        
        bool cond_327222 = gtid_327219 == (int64_t) 0;
        int64_t defunc_0_m_fun_res_327223;
        
        if (cond_327222) {
            defunc_0_m_fun_res_327223 = (int64_t) 0;
        } else {
            int64_t y_327355 = sub64(s_n_m_292825, (int64_t) 1);
            bool cond_327356 = gtid_327219 == y_327355;
            int64_t defunc_0_m_fun_res_f_res_327357;
            
            if (cond_327356) {
                int64_t defunc_0_m_fun_res_f_res_t_res_327358 =
                        sub64(pad_css_len_292821, (int64_t) 1);
                
                defunc_0_m_fun_res_f_res_327357 =
                    defunc_0_m_fun_res_f_res_t_res_327358;
            } else {
                int64_t x_327359 = sub64(gtid_327219, (int64_t) 1);
                int64_t x_327360 = mul64(jump_s_292684, x_327359);
                int64_t min_arg_327361 = add64((int64_t) 1, x_327360);
                int64_t min_res_327362 = smin64(defunc_0_f_res_292820,
                                                min_arg_327361);
                
                defunc_0_m_fun_res_f_res_327357 = min_res_327362;
            }
            defunc_0_m_fun_res_327223 = defunc_0_m_fun_res_f_res_327357;
        }
        
        double defunc_2_reduce_res_327232;
        double defunc_2_reduce_res_327233;
        double defunc_2_reduce_res_327234;
        double defunc_2_reduce_res_327235;
        double defunc_2_reduce_res_327236;
        double redout_327364;
        double redout_327365;
        double redout_327366;
        double redout_327367;
        double redout_327368;
        
        redout_327364 = 0.0;
        redout_327365 = 0.0;
        redout_327366 = 0.0;
        redout_327367 = 0.0;
        redout_327368 = 0.0;
        for (int64_t i_327363 = 0; i_327363 < q_s_292678; i_327363++) {
            bool cond_327369 = sle64(x_326499, i_327363);
            int64_t defunc_0_f_res_327370;
            
            if (cond_327369) {
                defunc_0_f_res_327370 = (int64_t) 0;
            } else {
                int64_t i_327371 = add64(x_327220, i_327363);
                int64_t defunc_0_add_arg_327372;
                
                defunc_0_add_arg_327372 =
                    ((int64_t *) mem_312838.mem)[gtid_303954 *
                                                 (defunc_0_f_res_292820 *
                                                  n_p_292677) + gtid_326498 *
                                                 defunc_0_f_res_292820 +
                                                 i_327371];
                
                int64_t defunc_1_add_res_327373 = add64((int64_t) 1,
                                                        defunc_0_add_arg_327372);
                
                defunc_0_f_res_327370 = defunc_1_add_res_327373;
            }
            
            double defunc_0_f_res_327374;
            
            if (cond_327369) {
                defunc_0_f_res_327374 = 0.0;
            } else {
                int64_t i_327375 = add64(x_327220, i_327363);
                double defunc_0_add_arg_327376;
                
                defunc_0_add_arg_327376 =
                    ((double *) mem_313371.mem)[gtid_303954 *
                                                (defunc_0_f_res_292820 *
                                                 n_p_292677) + gtid_326498 *
                                                defunc_0_f_res_292820 +
                                                i_327375];
                defunc_0_f_res_327374 = defunc_0_add_arg_327376;
            }
            
            int64_t binop_p_327377 = sub64(defunc_0_f_res_327370,
                                           defunc_0_m_fun_res_327223);
            double defunc_0_f_res_327378 = sitofp_i64_f64(binop_p_327377);
            double abs_res_327379 = fabs(defunc_0_f_res_327378);
            double tmp1_327380 = abs_res_327379 / x_327221;
            double x_327381 = tmp1_327380 * tmp1_327380;
            double y_327382 = tmp1_327380 * x_327381;
            double tmp2_327383 = 1.0 - y_327382;
            double x_327384 = tmp2_327383 * tmp2_327383;
            double tmp3_327385 = tmp2_327383 * x_327384;
            double w_j_327386 = defunc_0_f_res_327374 * tmp3_327385;
            double xw_j_327387 = defunc_0_f_res_327378 * w_j_327386;
            double x2w_j_327388 = defunc_0_f_res_327378 * xw_j_327387;
            double x3w_j_327389 = defunc_0_f_res_327378 * x2w_j_327388;
            double x4w_j_327390 = defunc_0_f_res_327378 * x3w_j_327389;
            double defunc_1_op_res_327391 = w_j_327386 + redout_327364;
            double defunc_1_op_res_327392 = xw_j_327387 + redout_327365;
            double defunc_1_op_res_327393 = x2w_j_327388 + redout_327366;
            double defunc_1_op_res_327394 = x3w_j_327389 + redout_327367;
            double defunc_1_op_res_327395 = x4w_j_327390 + redout_327368;
            double redout_tmp_327446 = defunc_1_op_res_327391;
            double redout_tmp_327447 = defunc_1_op_res_327392;
            double redout_tmp_327448 = defunc_1_op_res_327393;
            double redout_tmp_327449 = defunc_1_op_res_327394;
            double redout_tmp_327450 = defunc_1_op_res_327395;
            
            redout_327364 = redout_tmp_327446;
            redout_327365 = redout_tmp_327447;
            redout_327366 = redout_tmp_327448;
            redout_327367 = redout_tmp_327449;
            redout_327368 = redout_tmp_327450;
        }
        defunc_2_reduce_res_327232 = redout_327364;
        defunc_2_reduce_res_327233 = redout_327365;
        defunc_2_reduce_res_327234 = redout_327366;
        defunc_2_reduce_res_327235 = redout_327367;
        defunc_2_reduce_res_327236 = redout_327368;
        
        double a_327270 = 2.220446049250313e-16 + defunc_2_reduce_res_327232;
        double b_327271 = 2.220446049250313e-16 + defunc_2_reduce_res_327233;
        double c_327272 = 2.220446049250313e-16 + defunc_2_reduce_res_327234;
        double d_327273 = 2.220446049250313e-16 + defunc_2_reduce_res_327235;
        double e_327274 = 2.220446049250313e-16 + defunc_2_reduce_res_327236;
        double x_327275 = c_327272 * e_327274;
        double y_327276 = d_327273 * d_327273;
        double a12_327277 = x_327275 - y_327276;
        double x_327278 = c_327272 * d_327273;
        double y_327279 = b_327271 * e_327274;
        double b12_327280 = x_327278 - y_327279;
        double x_327281 = b_327271 * d_327273;
        double y_327282 = c_327272 * c_327272;
        double c12_327283 = x_327281 - y_327282;
        double x_327284 = a_327270 * e_327274;
        double b2_327285 = x_327284 - y_327282;
        double x_327286 = b_327271 * c_327272;
        double y_327287 = a_327270 * d_327273;
        double c2_327288 = x_327286 - y_327287;
        double x_327289 = a_327270 * a12_327277;
        double y_327290 = b_327271 * b12_327280;
        double x_327291 = x_327289 + y_327290;
        double y_327292 = c_327272 * c12_327283;
        double y_327293 = x_327291 + y_327292;
        double det_327294 = 1.0 / y_327293;
        double a12_327295 = a12_327277 * det_327294;
        double b12_327296 = b12_327280 * det_327294;
        double c12_327297 = c12_327283 * det_327294;
        double b2_327298 = b2_327285 * det_327294;
        double c2_327299 = c2_327288 * det_327294;
        int64_t defunc_0_m_fun_res_327300;
        
        if (cond_327222) {
            defunc_0_m_fun_res_327300 = (int64_t) 0;
        } else {
            int64_t y_327396 = sub64(s_n_m_292825, (int64_t) 1);
            bool cond_327397 = gtid_327219 == y_327396;
            int64_t defunc_0_m_fun_res_f_res_327398;
            
            if (cond_327397) {
                int64_t defunc_0_m_fun_res_f_res_t_res_327399 =
                        sub64(pad_css_len_292821, (int64_t) 1);
                
                defunc_0_m_fun_res_f_res_327398 =
                    defunc_0_m_fun_res_f_res_t_res_327399;
            } else {
                int64_t x_327400 = sub64(gtid_327219, (int64_t) 1);
                int64_t x_327401 = mul64(jump_s_292684, x_327400);
                int64_t min_arg_327402 = add64((int64_t) 1, x_327401);
                int64_t min_res_327403 = smin64(defunc_0_f_res_292820,
                                                min_arg_327402);
                
                defunc_0_m_fun_res_f_res_327398 = min_res_327403;
            }
            defunc_0_m_fun_res_327300 = defunc_0_m_fun_res_f_res_327398;
        }
        
        double defunc_2_reduce_res_327309;
        double defunc_2_reduce_res_327310;
        double redout_327405;
        double redout_327406;
        
        redout_327405 = 0.0;
        redout_327406 = 0.0;
        for (int64_t i_327404 = 0; i_327404 < q_s_292678; i_327404++) {
            bool cond_327407 = sle64(x_326499, i_327404);
            int64_t defunc_0_f_res_327408;
            
            if (cond_327407) {
                defunc_0_f_res_327408 = (int64_t) 0;
            } else {
                int64_t i_327409 = add64(x_327220, i_327404);
                int64_t defunc_0_add_arg_327410;
                
                defunc_0_add_arg_327410 =
                    ((int64_t *) mem_312838.mem)[gtid_303954 *
                                                 (defunc_0_f_res_292820 *
                                                  n_p_292677) + gtid_326498 *
                                                 defunc_0_f_res_292820 +
                                                 i_327409];
                
                int64_t defunc_1_add_res_327411 = add64((int64_t) 1,
                                                        defunc_0_add_arg_327410);
                
                defunc_0_f_res_327408 = defunc_1_add_res_327411;
            }
            
            double defunc_0_f_res_327412;
            
            if (cond_327407) {
                defunc_0_f_res_327412 = 0.0;
            } else {
                int64_t i_327413 = add64(x_327220, i_327404);
                double defunc_0_add_arg_327414;
                
                defunc_0_add_arg_327414 =
                    ((double *) mem_313371.mem)[gtid_303954 *
                                                (defunc_0_f_res_292820 *
                                                 n_p_292677) + gtid_326498 *
                                                defunc_0_f_res_292820 +
                                                i_327413];
                defunc_0_f_res_327412 = defunc_0_add_arg_327414;
            }
            
            int64_t binop_p_327415 = sub64(defunc_0_f_res_327408,
                                           defunc_0_m_fun_res_327300);
            double defunc_0_f_res_327416 = sitofp_i64_f64(binop_p_327415);
            double abs_res_327417 = fabs(defunc_0_f_res_327416);
            double tmp1_327418 = abs_res_327417 / x_327221;
            double x_327419 = tmp1_327418 * tmp1_327418;
            double y_327420 = tmp1_327418 * x_327419;
            double tmp2_327421 = 1.0 - y_327420;
            double x_327422 = tmp2_327421 * tmp2_327421;
            double tmp3_327423 = tmp2_327421 * x_327422;
            double tmp4_327424 = defunc_0_f_res_327412 * tmp3_327423;
            double defunc_1_f_res_327425 = defunc_0_f_res_327416 * tmp4_327424;
            double defunc_1_f_res_327426 = defunc_0_f_res_327416 *
                   defunc_1_f_res_327425;
            double defunc_0_f_res_327427;
            
            if (cond_327407) {
                defunc_0_f_res_327427 = 0.0;
            } else {
                int64_t i_327428 = add64(x_327220, i_327404);
                double defunc_0_add_arg_327429;
                
                defunc_0_add_arg_327429 =
                    ((double *) mem_313366.mem)[gtid_303954 *
                                                (defunc_0_f_res_292820 *
                                                 n_p_292677) + gtid_326498 *
                                                defunc_0_f_res_292820 +
                                                i_327428];
                defunc_0_f_res_327427 = defunc_0_add_arg_327429;
            }
            
            double x_327430 = a12_327295 * tmp4_327424;
            double y_327431 = b12_327296 * defunc_1_f_res_327425;
            double x_327432 = x_327430 + y_327431;
            double y_327433 = c12_327297 * defunc_1_f_res_327426;
            double x_327434 = x_327432 + y_327433;
            double defunc_9_fit_fun_res_327435 = defunc_0_f_res_327427 *
                   x_327434;
            double x_327436 = b12_327296 * tmp4_327424;
            double y_327437 = b2_327298 * defunc_1_f_res_327425;
            double x_327438 = x_327436 + y_327437;
            double y_327439 = c2_327299 * defunc_1_f_res_327426;
            double x_327440 = x_327438 + y_327439;
            double defunc_9_slope_fun_res_327441 = defunc_0_f_res_327427 *
                   x_327440;
            double defunc_1_op_res_327442 = defunc_9_fit_fun_res_327435 +
                   redout_327405;
            double defunc_1_op_res_327443 = defunc_9_slope_fun_res_327441 +
                   redout_327406;
            double redout_tmp_327451 = defunc_1_op_res_327442;
            double redout_tmp_327452 = defunc_1_op_res_327443;
            
            redout_327405 = redout_tmp_327451;
            redout_327406 = redout_tmp_327452;
        }
        defunc_2_reduce_res_327309 = redout_327405;
        defunc_2_reduce_res_327310 = redout_327406;
        ((double *) mem_326500.mem)[gtid_327219] = defunc_2_reduce_res_327309;
        ((double *) mem_326501.mem)[gtid_327219] = defunc_2_reduce_res_327310;
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338301_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338301_end -
                 futhark_mc_segmap_parloop_338301_start;
        
        ctx->futhark_mc_segmap_parloop_338301_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338301_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338301_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_338299(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_327218 = tid;
    int num_tasks_327353 = info.nsubtasks;
    struct futhark_mc_task_338298 *futhark_mc_task_338298 =
                                  (struct futhark_mc_task_338298 *) args;
    struct futhark_context *ctx = futhark_mc_task_338298->ctx;
    uint64_t futhark_mc_segmap_task_338299_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_338299_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_338298->free_n_p_292677;
    int64_t q_s_292678 = futhark_mc_task_338298->free_q_s_292678;
    int64_t jump_s_292684 = futhark_mc_task_338298->free_jump_s_292684;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_338298->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_task_338298->free_pad_css_len_292821;
    int64_t s_n_m_292825 = futhark_mc_task_338298->free_s_n_m_292825;
    int64_t gtid_303954 = futhark_mc_task_338298->free_gtid_303954;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_task_338298->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_task_338298->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_task_338298->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_task_338298->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_task_338298->free_mem_313371,
                                  .size =0, .references =NULL};
    int64_t gtid_326498 = futhark_mc_task_338298->free_gtid_326498;
    int64_t x_326499 = futhark_mc_task_338298->free_x_326499;
    struct memblock mem_326500 = {.desc ="mem_326500", .mem =
                                  futhark_mc_task_338298->free_mem_326500,
                                  .size =0, .references =NULL};
    struct memblock mem_326501 = {.desc ="mem_326501", .mem =
                                  futhark_mc_task_338298->free_mem_326501,
                                  .size =0, .references =NULL};
    int64_t iter_327354;
    struct futhark_mc_segmap_parloop_struct_338300
    futhark_mc_segmap_parloop_struct_338300;
    
    futhark_mc_segmap_parloop_struct_338300.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338300.free_n_p_292677 = n_p_292677;
    futhark_mc_segmap_parloop_struct_338300.free_q_s_292678 = q_s_292678;
    futhark_mc_segmap_parloop_struct_338300.free_jump_s_292684 = jump_s_292684;
    futhark_mc_segmap_parloop_struct_338300.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segmap_parloop_struct_338300.free_pad_css_len_292821 =
        pad_css_len_292821;
    futhark_mc_segmap_parloop_struct_338300.free_s_n_m_292825 = s_n_m_292825;
    futhark_mc_segmap_parloop_struct_338300.free_gtid_303954 = gtid_303954;
    futhark_mc_segmap_parloop_struct_338300.free_mem_312838 = mem_312838.mem;
    futhark_mc_segmap_parloop_struct_338300.free_mem_313018 = mem_313018.mem;
    futhark_mc_segmap_parloop_struct_338300.free_mem_313023 = mem_313023.mem;
    futhark_mc_segmap_parloop_struct_338300.free_mem_313366 = mem_313366.mem;
    futhark_mc_segmap_parloop_struct_338300.free_mem_313371 = mem_313371.mem;
    futhark_mc_segmap_parloop_struct_338300.free_gtid_326498 = gtid_326498;
    futhark_mc_segmap_parloop_struct_338300.free_x_326499 = x_326499;
    futhark_mc_segmap_parloop_struct_338300.free_mem_326500 = mem_326500.mem;
    futhark_mc_segmap_parloop_struct_338300.free_mem_326501 = mem_326501.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338301_task;
    
    futhark_mc_segmap_parloop_338301_task.name =
        "futhark_mc_segmap_parloop_338301";
    futhark_mc_segmap_parloop_338301_task.fn = futhark_mc_segmap_parloop_338301;
    futhark_mc_segmap_parloop_338301_task.args =
        &futhark_mc_segmap_parloop_struct_338300;
    futhark_mc_segmap_parloop_338301_task.iterations = iterations;
    futhark_mc_segmap_parloop_338301_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338301_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338301_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338301_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338301_task);
    
    if (futhark_mc_segmap_parloop_338301_err != 0) {
        err = futhark_mc_segmap_parloop_338301_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338301_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338301_total_end -
                 futhark_mc_segmap_parloop_338301_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338301_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338301_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338301_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_338299_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_338299_end -
                 futhark_mc_segmap_task_338299_start;
        
        ctx->futhark_mc_segmap_task_338299_runs[tid]++;
        ctx->futhark_mc_segmap_task_338299_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_338299_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_segmap_parloop_struct_338303 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_q_s_292678;
    int64_t free_jump_s_292684;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    int64_t free_gtid_303954;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_313018;
    unsigned char *free_mem_313023;
    unsigned char *free_mem_313366;
    unsigned char *free_mem_313371;
    int64_t free_gtid_326498;
    int64_t free_x_326499;
    unsigned char *free_mem_326500;
    unsigned char *free_mem_326501;
};
struct futhark_mc_task_338305 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_gtid_303954;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_313371;
    int64_t free_gtid_326498;
    int64_t free_x_326499;
    int64_t free_x_327078;
    double free_x_327079;
    int64_t free_defunc_0_m_fun_res_327081;
    double *retval_defunc_2_reduce_res_327090;
    double *retval_defunc_2_reduce_res_327091;
    double *retval_defunc_2_reduce_res_327092;
    double *retval_defunc_2_reduce_res_327093;
    double *retval_defunc_2_reduce_res_327094;
};
struct futhark_mc_segred_stage_1_parloop_struct_338312 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_gtid_303954;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_313371;
    int64_t free_gtid_326498;
    int64_t free_x_326499;
    int64_t free_x_327078;
    double free_x_327079;
    int64_t free_defunc_0_m_fun_res_327081;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_327555;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_327557;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_327559;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_327561;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_327563;
};
static int futhark_mc_segred_stage_1_parloop_338313(void *args, int64_t start,
                                                    int64_t end,
                                                    int flat_tid_327462,
                                                    int tid)
{
    int err = 0;
    struct futhark_mc_segred_stage_1_parloop_struct_338312
    *futhark_mc_segred_stage_1_parloop_struct_338312 =
    (struct futhark_mc_segred_stage_1_parloop_struct_338312 *) args;
    struct futhark_context *ctx =
                           futhark_mc_segred_stage_1_parloop_struct_338312->ctx;
    uint64_t futhark_mc_segred_stage_1_parloop_338313_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_338313_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segred_stage_1_parloop_struct_338312->free_n_p_292677;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segred_stage_1_parloop_struct_338312->free_defunc_0_f_res_292820;
    int64_t gtid_303954 =
            futhark_mc_segred_stage_1_parloop_struct_338312->free_gtid_303954;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_338312->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_338312->free_mem_313371,
                                  .size =0, .references =NULL};
    int64_t gtid_326498 =
            futhark_mc_segred_stage_1_parloop_struct_338312->free_gtid_326498;
    int64_t x_326499 =
            futhark_mc_segred_stage_1_parloop_struct_338312->free_x_326499;
    int64_t x_327078 =
            futhark_mc_segred_stage_1_parloop_struct_338312->free_x_327078;
    double x_327079 =
           futhark_mc_segred_stage_1_parloop_struct_338312->free_x_327079;
    int64_t defunc_0_m_fun_res_327081 =
            futhark_mc_segred_stage_1_parloop_struct_338312->free_defunc_0_m_fun_res_327081;
    struct memblock reduce_stage_1_tid_res_arr_mem_327555 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_327555",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338312->free_reduce_stage_1_tid_res_arr_mem_327555,
                                                             .size =0,
                                                             .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_327557 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_327557",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338312->free_reduce_stage_1_tid_res_arr_mem_327557,
                                                             .size =0,
                                                             .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_327559 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_327559",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338312->free_reduce_stage_1_tid_res_arr_mem_327559,
                                                             .size =0,
                                                             .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_327561 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_327561",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338312->free_reduce_stage_1_tid_res_arr_mem_327561,
                                                             .size =0,
                                                             .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_327563 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_327563",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338312->free_reduce_stage_1_tid_res_arr_mem_327563,
                                                             .size =0,
                                                             .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_327565 = start;
    double x_327464;
    double x_327465;
    double x_327467;
    double x_327468;
    double x_327470;
    double x_327471;
    double x_327473;
    double x_327474;
    double x_327476;
    double x_327477;
    double local_acc_327566 = 0.0;
    double local_acc_327567 = 0.0;
    double local_acc_327568 = 0.0;
    double local_acc_327569 = 0.0;
    double local_acc_327570 = 0.0;
    
    for (; iter_327565 < end; iter_327565++) {
        int64_t gtid_327463 = iter_327565;
        bool cond_327479 = sle64(x_326499, gtid_327463);
        int64_t defunc_0_f_res_327480;
        
        if (cond_327479) {
            defunc_0_f_res_327480 = (int64_t) 0;
        } else {
            int64_t i_327481 = add64(x_327078, gtid_327463);
            int64_t defunc_0_add_arg_327482;
            
            defunc_0_add_arg_327482 = ((int64_t *) mem_312838.mem)[gtid_303954 *
                                                                   (defunc_0_f_res_292820 *
                                                                    n_p_292677) +
                                                                   gtid_326498 *
                                                                   defunc_0_f_res_292820 +
                                                                   i_327481];
            
            int64_t defunc_1_add_res_327483 = add64((int64_t) 1,
                                                    defunc_0_add_arg_327482);
            
            defunc_0_f_res_327480 = defunc_1_add_res_327483;
        }
        
        double defunc_0_f_res_327484;
        
        if (cond_327479) {
            defunc_0_f_res_327484 = 0.0;
        } else {
            int64_t i_327485 = add64(x_327078, gtid_327463);
            double defunc_0_add_arg_327486;
            
            defunc_0_add_arg_327486 = ((double *) mem_313371.mem)[gtid_303954 *
                                                                  (defunc_0_f_res_292820 *
                                                                   n_p_292677) +
                                                                  gtid_326498 *
                                                                  defunc_0_f_res_292820 +
                                                                  i_327485];
            defunc_0_f_res_327484 = defunc_0_add_arg_327486;
        }
        
        int64_t binop_p_327487 = sub64(defunc_0_f_res_327480,
                                       defunc_0_m_fun_res_327081);
        double defunc_0_f_res_327488 = sitofp_i64_f64(binop_p_327487);
        double abs_res_327489 = fabs(defunc_0_f_res_327488);
        double tmp1_327490 = abs_res_327489 / x_327079;
        double x_327491 = tmp1_327490 * tmp1_327490;
        double y_327492 = tmp1_327490 * x_327491;
        double tmp2_327493 = 1.0 - y_327492;
        double x_327494 = tmp2_327493 * tmp2_327493;
        double tmp3_327495 = tmp2_327493 * x_327494;
        double w_j_327496 = defunc_0_f_res_327484 * tmp3_327495;
        double xw_j_327497 = defunc_0_f_res_327488 * w_j_327496;
        double x2w_j_327498 = defunc_0_f_res_327488 * xw_j_327497;
        double x3w_j_327499 = defunc_0_f_res_327488 * x2w_j_327498;
        double x4w_j_327500 = defunc_0_f_res_327488 * x3w_j_327499;
        
        // save map-out results
        { }
        // Load accum params
        {
            x_327464 = local_acc_327566;
        }
        // Load next params
        {
            x_327465 = w_j_327496;
        }
        // Red body
        {
            double defunc_1_op_res_327466 = x_327464 + x_327465;
            
            local_acc_327566 = defunc_1_op_res_327466;
        }
        // Load accum params
        {
            x_327467 = local_acc_327567;
        }
        // Load next params
        {
            x_327468 = xw_j_327497;
        }
        // Red body
        {
            double defunc_1_op_res_327469 = x_327467 + x_327468;
            
            local_acc_327567 = defunc_1_op_res_327469;
        }
        // Load accum params
        {
            x_327470 = local_acc_327568;
        }
        // Load next params
        {
            x_327471 = x2w_j_327498;
        }
        // Red body
        {
            double defunc_1_op_res_327472 = x_327470 + x_327471;
            
            local_acc_327568 = defunc_1_op_res_327472;
        }
        // Load accum params
        {
            x_327473 = local_acc_327569;
        }
        // Load next params
        {
            x_327474 = x3w_j_327499;
        }
        // Red body
        {
            double defunc_1_op_res_327475 = x_327473 + x_327474;
            
            local_acc_327569 = defunc_1_op_res_327475;
        }
        // Load accum params
        {
            x_327476 = local_acc_327570;
        }
        // Load next params
        {
            x_327477 = x4w_j_327500;
        }
        // Red body
        {
            double defunc_1_op_res_327478 = x_327476 + x_327477;
            
            local_acc_327570 = defunc_1_op_res_327478;
        }
    }
    ((double *) reduce_stage_1_tid_res_arr_mem_327555.mem)[flat_tid_327462] =
        local_acc_327566;
    ((double *) reduce_stage_1_tid_res_arr_mem_327557.mem)[flat_tid_327462] =
        local_acc_327567;
    ((double *) reduce_stage_1_tid_res_arr_mem_327559.mem)[flat_tid_327462] =
        local_acc_327568;
    ((double *) reduce_stage_1_tid_res_arr_mem_327561.mem)[flat_tid_327462] =
        local_acc_327569;
    ((double *) reduce_stage_1_tid_res_arr_mem_327563.mem)[flat_tid_327462] =
        local_acc_327570;
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_338313_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_338313_end -
                 futhark_mc_segred_stage_1_parloop_338313_start;
        
        ctx->futhark_mc_segred_stage_1_parloop_338313_runs[tid]++;
        ctx->futhark_mc_segred_stage_1_parloop_338313_total_runtime[tid] +=
            elapsed;
        ctx->futhark_mc_segred_stage_1_parloop_338313_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segred_task_338306(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_327462 = tid;
    int num_tasks_327554 = info.nsubtasks;
    struct futhark_mc_task_338305 *futhark_mc_task_338305 =
                                  (struct futhark_mc_task_338305 *) args;
    struct futhark_context *ctx = futhark_mc_task_338305->ctx;
    uint64_t futhark_mc_segred_task_338306_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_task_338306_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_338305->free_n_p_292677;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_338305->free_defunc_0_f_res_292820;
    int64_t gtid_303954 = futhark_mc_task_338305->free_gtid_303954;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_task_338305->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_task_338305->free_mem_313371,
                                  .size =0, .references =NULL};
    int64_t gtid_326498 = futhark_mc_task_338305->free_gtid_326498;
    int64_t x_326499 = futhark_mc_task_338305->free_x_326499;
    int64_t x_327078 = futhark_mc_task_338305->free_x_327078;
    double x_327079 = futhark_mc_task_338305->free_x_327079;
    int64_t defunc_0_m_fun_res_327081 =
            futhark_mc_task_338305->free_defunc_0_m_fun_res_327081;
    double defunc_2_reduce_res_327090 =
           *futhark_mc_task_338305->retval_defunc_2_reduce_res_327090;
    double defunc_2_reduce_res_327091 =
           *futhark_mc_task_338305->retval_defunc_2_reduce_res_327091;
    double defunc_2_reduce_res_327092 =
           *futhark_mc_task_338305->retval_defunc_2_reduce_res_327092;
    double defunc_2_reduce_res_327093 =
           *futhark_mc_task_338305->retval_defunc_2_reduce_res_327093;
    double defunc_2_reduce_res_327094 =
           *futhark_mc_task_338305->retval_defunc_2_reduce_res_327094;
    size_t reduce_stage_1_tid_res_arr_mem_327555_cached_sizze_338307 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_327555 = NULL;
    size_t reduce_stage_1_tid_res_arr_mem_327557_cached_sizze_338308 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_327557 = NULL;
    size_t reduce_stage_1_tid_res_arr_mem_327559_cached_sizze_338309 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_327559 = NULL;
    size_t reduce_stage_1_tid_res_arr_mem_327561_cached_sizze_338310 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_327561 = NULL;
    size_t reduce_stage_1_tid_res_arr_mem_327563_cached_sizze_338311 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_327563 = NULL;
    
    if (reduce_stage_1_tid_res_arr_mem_327555_cached_sizze_338307 <
        (size_t) ((int64_t) 8 * num_tasks_327554)) {
        reduce_stage_1_tid_res_arr_mem_327555 =
            realloc(reduce_stage_1_tid_res_arr_mem_327555, (int64_t) 8 *
                    num_tasks_327554);
        reduce_stage_1_tid_res_arr_mem_327555_cached_sizze_338307 =
            (int64_t) 8 * num_tasks_327554;
    }
    if (reduce_stage_1_tid_res_arr_mem_327557_cached_sizze_338308 <
        (size_t) ((int64_t) 8 * num_tasks_327554)) {
        reduce_stage_1_tid_res_arr_mem_327557 =
            realloc(reduce_stage_1_tid_res_arr_mem_327557, (int64_t) 8 *
                    num_tasks_327554);
        reduce_stage_1_tid_res_arr_mem_327557_cached_sizze_338308 =
            (int64_t) 8 * num_tasks_327554;
    }
    if (reduce_stage_1_tid_res_arr_mem_327559_cached_sizze_338309 <
        (size_t) ((int64_t) 8 * num_tasks_327554)) {
        reduce_stage_1_tid_res_arr_mem_327559 =
            realloc(reduce_stage_1_tid_res_arr_mem_327559, (int64_t) 8 *
                    num_tasks_327554);
        reduce_stage_1_tid_res_arr_mem_327559_cached_sizze_338309 =
            (int64_t) 8 * num_tasks_327554;
    }
    if (reduce_stage_1_tid_res_arr_mem_327561_cached_sizze_338310 <
        (size_t) ((int64_t) 8 * num_tasks_327554)) {
        reduce_stage_1_tid_res_arr_mem_327561 =
            realloc(reduce_stage_1_tid_res_arr_mem_327561, (int64_t) 8 *
                    num_tasks_327554);
        reduce_stage_1_tid_res_arr_mem_327561_cached_sizze_338310 =
            (int64_t) 8 * num_tasks_327554;
    }
    if (reduce_stage_1_tid_res_arr_mem_327563_cached_sizze_338311 <
        (size_t) ((int64_t) 8 * num_tasks_327554)) {
        reduce_stage_1_tid_res_arr_mem_327563 =
            realloc(reduce_stage_1_tid_res_arr_mem_327563, (int64_t) 8 *
                    num_tasks_327554);
        reduce_stage_1_tid_res_arr_mem_327563_cached_sizze_338311 =
            (int64_t) 8 * num_tasks_327554;
    }
    
    int64_t iter_327565;
    struct futhark_mc_segred_stage_1_parloop_struct_338312
    futhark_mc_segred_stage_1_parloop_struct_338312;
    
    futhark_mc_segred_stage_1_parloop_struct_338312.ctx = ctx;
    futhark_mc_segred_stage_1_parloop_struct_338312.free_n_p_292677 =
        n_p_292677;
    futhark_mc_segred_stage_1_parloop_struct_338312.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segred_stage_1_parloop_struct_338312.free_gtid_303954 =
        gtid_303954;
    futhark_mc_segred_stage_1_parloop_struct_338312.free_mem_312838 =
        mem_312838.mem;
    futhark_mc_segred_stage_1_parloop_struct_338312.free_mem_313371 =
        mem_313371.mem;
    futhark_mc_segred_stage_1_parloop_struct_338312.free_gtid_326498 =
        gtid_326498;
    futhark_mc_segred_stage_1_parloop_struct_338312.free_x_326499 = x_326499;
    futhark_mc_segred_stage_1_parloop_struct_338312.free_x_327078 = x_327078;
    futhark_mc_segred_stage_1_parloop_struct_338312.free_x_327079 = x_327079;
    futhark_mc_segred_stage_1_parloop_struct_338312.free_defunc_0_m_fun_res_327081 =
        defunc_0_m_fun_res_327081;
    futhark_mc_segred_stage_1_parloop_struct_338312.free_reduce_stage_1_tid_res_arr_mem_327555 =
        reduce_stage_1_tid_res_arr_mem_327555;
    futhark_mc_segred_stage_1_parloop_struct_338312.free_reduce_stage_1_tid_res_arr_mem_327557 =
        reduce_stage_1_tid_res_arr_mem_327557;
    futhark_mc_segred_stage_1_parloop_struct_338312.free_reduce_stage_1_tid_res_arr_mem_327559 =
        reduce_stage_1_tid_res_arr_mem_327559;
    futhark_mc_segred_stage_1_parloop_struct_338312.free_reduce_stage_1_tid_res_arr_mem_327561 =
        reduce_stage_1_tid_res_arr_mem_327561;
    futhark_mc_segred_stage_1_parloop_struct_338312.free_reduce_stage_1_tid_res_arr_mem_327563 =
        reduce_stage_1_tid_res_arr_mem_327563;
    
    struct scheduler_parloop futhark_mc_segred_stage_1_parloop_338313_task;
    
    futhark_mc_segred_stage_1_parloop_338313_task.name =
        "futhark_mc_segred_stage_1_parloop_338313";
    futhark_mc_segred_stage_1_parloop_338313_task.fn =
        futhark_mc_segred_stage_1_parloop_338313;
    futhark_mc_segred_stage_1_parloop_338313_task.args =
        &futhark_mc_segred_stage_1_parloop_struct_338312;
    futhark_mc_segred_stage_1_parloop_338313_task.iterations = iterations;
    futhark_mc_segred_stage_1_parloop_338313_task.info = info;
    
    uint64_t futhark_mc_segred_stage_1_parloop_338313_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_338313_total_start = get_wall_time();
    
    int futhark_mc_segred_stage_1_parloop_338313_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segred_stage_1_parloop_338313_task);
    
    if (futhark_mc_segred_stage_1_parloop_338313_err != 0) {
        err = futhark_mc_segred_stage_1_parloop_338313_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_338313_total_end =
                 get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_338313_total_end -
                 futhark_mc_segred_stage_1_parloop_338313_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338313_total_runs,
                           1, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338313_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338313_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    // neutral-initialise the output
    {
        defunc_2_reduce_res_327090 = 0.0;
        defunc_2_reduce_res_327091 = 0.0;
        defunc_2_reduce_res_327092 = 0.0;
        defunc_2_reduce_res_327093 = 0.0;
        defunc_2_reduce_res_327094 = 0.0;
    }
    
    double x_327571;
    double x_327572;
    double x_327574;
    double x_327575;
    double x_327577;
    double x_327578;
    double x_327580;
    double x_327581;
    double x_327583;
    double x_327584;
    
    for (int32_t i_327586 = 0; i_327586 < num_tasks_327554; i_327586++) {
        flat_tid_327462 = i_327586;
        // Apply main thread reduction
        {
            // load acc params
            {
                x_327571 = defunc_2_reduce_res_327090;
            }
            // load next params
            {
                x_327572 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_327555)[flat_tid_327462];
            }
            // red body
            {
                double defunc_1_op_res_327573 = x_327571 + x_327572;
                
                defunc_2_reduce_res_327090 = defunc_1_op_res_327573;
            }
            // load acc params
            {
                x_327574 = defunc_2_reduce_res_327091;
            }
            // load next params
            {
                x_327575 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_327557)[flat_tid_327462];
            }
            // red body
            {
                double defunc_1_op_res_327576 = x_327574 + x_327575;
                
                defunc_2_reduce_res_327091 = defunc_1_op_res_327576;
            }
            // load acc params
            {
                x_327577 = defunc_2_reduce_res_327092;
            }
            // load next params
            {
                x_327578 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_327559)[flat_tid_327462];
            }
            // red body
            {
                double defunc_1_op_res_327579 = x_327577 + x_327578;
                
                defunc_2_reduce_res_327092 = defunc_1_op_res_327579;
            }
            // load acc params
            {
                x_327580 = defunc_2_reduce_res_327093;
            }
            // load next params
            {
                x_327581 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_327561)[flat_tid_327462];
            }
            // red body
            {
                double defunc_1_op_res_327582 = x_327580 + x_327581;
                
                defunc_2_reduce_res_327093 = defunc_1_op_res_327582;
            }
            // load acc params
            {
                x_327583 = defunc_2_reduce_res_327094;
            }
            // load next params
            {
                x_327584 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_327563)[flat_tid_327462];
            }
            // red body
            {
                double defunc_1_op_res_327585 = x_327583 + x_327584;
                
                defunc_2_reduce_res_327094 = defunc_1_op_res_327585;
            }
        }
    }
    
  cleanup:
    {
        free(reduce_stage_1_tid_res_arr_mem_327555);
        free(reduce_stage_1_tid_res_arr_mem_327557);
        free(reduce_stage_1_tid_res_arr_mem_327559);
        free(reduce_stage_1_tid_res_arr_mem_327561);
        free(reduce_stage_1_tid_res_arr_mem_327563);
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_task_338306_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_task_338306_end -
                 futhark_mc_segred_task_338306_start;
        
        ctx->futhark_mc_segred_task_338306_runs[tid]++;
        ctx->futhark_mc_segred_task_338306_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segred_task_338306_iter[tid] += iterations;
    }
    if (err == 0) {
        *futhark_mc_task_338305->retval_defunc_2_reduce_res_327090 =
            defunc_2_reduce_res_327090;
        *futhark_mc_task_338305->retval_defunc_2_reduce_res_327091 =
            defunc_2_reduce_res_327091;
        *futhark_mc_task_338305->retval_defunc_2_reduce_res_327092 =
            defunc_2_reduce_res_327092;
        *futhark_mc_task_338305->retval_defunc_2_reduce_res_327093 =
            defunc_2_reduce_res_327093;
        *futhark_mc_task_338305->retval_defunc_2_reduce_res_327094 =
            defunc_2_reduce_res_327094;
    }
    return err;
}
struct futhark_mc_task_338314 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_gtid_303954;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_313366;
    unsigned char *free_mem_313371;
    int64_t free_gtid_326498;
    int64_t free_x_326499;
    int64_t free_x_327078;
    double free_x_327079;
    double free_a12_327159;
    double free_b12_327160;
    double free_c12_327161;
    double free_b2_327162;
    double free_c2_327163;
    int64_t free_defunc_0_m_fun_res_327164;
    double *retval_defunc_2_reduce_res_327173;
    double *retval_defunc_2_reduce_res_327174;
};
struct futhark_mc_segred_stage_1_parloop_struct_338318 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_gtid_303954;
    unsigned char *free_mem_312838;
    unsigned char *free_mem_313366;
    unsigned char *free_mem_313371;
    int64_t free_gtid_326498;
    int64_t free_x_326499;
    int64_t free_x_327078;
    double free_x_327079;
    double free_a12_327159;
    double free_b12_327160;
    double free_c12_327161;
    double free_b2_327162;
    double free_c2_327163;
    int64_t free_defunc_0_m_fun_res_327164;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_327588;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_327590;
};
static int futhark_mc_segred_stage_1_parloop_338319(void *args, int64_t start,
                                                    int64_t end,
                                                    int flat_tid_327509,
                                                    int tid)
{
    int err = 0;
    struct futhark_mc_segred_stage_1_parloop_struct_338318
    *futhark_mc_segred_stage_1_parloop_struct_338318 =
    (struct futhark_mc_segred_stage_1_parloop_struct_338318 *) args;
    struct futhark_context *ctx =
                           futhark_mc_segred_stage_1_parloop_struct_338318->ctx;
    uint64_t futhark_mc_segred_stage_1_parloop_338319_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_338319_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segred_stage_1_parloop_struct_338318->free_n_p_292677;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segred_stage_1_parloop_struct_338318->free_defunc_0_f_res_292820;
    int64_t gtid_303954 =
            futhark_mc_segred_stage_1_parloop_struct_338318->free_gtid_303954;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_338318->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_338318->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_338318->free_mem_313371,
                                  .size =0, .references =NULL};
    int64_t gtid_326498 =
            futhark_mc_segred_stage_1_parloop_struct_338318->free_gtid_326498;
    int64_t x_326499 =
            futhark_mc_segred_stage_1_parloop_struct_338318->free_x_326499;
    int64_t x_327078 =
            futhark_mc_segred_stage_1_parloop_struct_338318->free_x_327078;
    double x_327079 =
           futhark_mc_segred_stage_1_parloop_struct_338318->free_x_327079;
    double a12_327159 =
           futhark_mc_segred_stage_1_parloop_struct_338318->free_a12_327159;
    double b12_327160 =
           futhark_mc_segred_stage_1_parloop_struct_338318->free_b12_327160;
    double c12_327161 =
           futhark_mc_segred_stage_1_parloop_struct_338318->free_c12_327161;
    double b2_327162 =
           futhark_mc_segred_stage_1_parloop_struct_338318->free_b2_327162;
    double c2_327163 =
           futhark_mc_segred_stage_1_parloop_struct_338318->free_c2_327163;
    int64_t defunc_0_m_fun_res_327164 =
            futhark_mc_segred_stage_1_parloop_struct_338318->free_defunc_0_m_fun_res_327164;
    struct memblock reduce_stage_1_tid_res_arr_mem_327588 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_327588",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338318->free_reduce_stage_1_tid_res_arr_mem_327588,
                                                             .size =0,
                                                             .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_327590 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_327590",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338318->free_reduce_stage_1_tid_res_arr_mem_327590,
                                                             .size =0,
                                                             .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_327592 = start;
    double x_327511;
    double x_327512;
    double x_327514;
    double x_327515;
    double local_acc_327593 = 0.0;
    double local_acc_327594 = 0.0;
    
    for (; iter_327592 < end; iter_327592++) {
        int64_t gtid_327510 = iter_327592;
        bool cond_327517 = sle64(x_326499, gtid_327510);
        int64_t defunc_0_f_res_327518;
        
        if (cond_327517) {
            defunc_0_f_res_327518 = (int64_t) 0;
        } else {
            int64_t i_327519 = add64(x_327078, gtid_327510);
            int64_t defunc_0_add_arg_327520;
            
            defunc_0_add_arg_327520 = ((int64_t *) mem_312838.mem)[gtid_303954 *
                                                                   (defunc_0_f_res_292820 *
                                                                    n_p_292677) +
                                                                   gtid_326498 *
                                                                   defunc_0_f_res_292820 +
                                                                   i_327519];
            
            int64_t defunc_1_add_res_327521 = add64((int64_t) 1,
                                                    defunc_0_add_arg_327520);
            
            defunc_0_f_res_327518 = defunc_1_add_res_327521;
        }
        
        double defunc_0_f_res_327522;
        
        if (cond_327517) {
            defunc_0_f_res_327522 = 0.0;
        } else {
            int64_t i_327523 = add64(x_327078, gtid_327510);
            double defunc_0_add_arg_327524;
            
            defunc_0_add_arg_327524 = ((double *) mem_313371.mem)[gtid_303954 *
                                                                  (defunc_0_f_res_292820 *
                                                                   n_p_292677) +
                                                                  gtid_326498 *
                                                                  defunc_0_f_res_292820 +
                                                                  i_327523];
            defunc_0_f_res_327522 = defunc_0_add_arg_327524;
        }
        
        int64_t binop_p_327525 = sub64(defunc_0_f_res_327518,
                                       defunc_0_m_fun_res_327164);
        double defunc_0_f_res_327526 = sitofp_i64_f64(binop_p_327525);
        double abs_res_327527 = fabs(defunc_0_f_res_327526);
        double tmp1_327528 = abs_res_327527 / x_327079;
        double x_327529 = tmp1_327528 * tmp1_327528;
        double y_327530 = tmp1_327528 * x_327529;
        double tmp2_327531 = 1.0 - y_327530;
        double x_327532 = tmp2_327531 * tmp2_327531;
        double tmp3_327533 = tmp2_327531 * x_327532;
        double tmp4_327534 = defunc_0_f_res_327522 * tmp3_327533;
        double defunc_1_f_res_327535 = defunc_0_f_res_327526 * tmp4_327534;
        double defunc_1_f_res_327536 = defunc_0_f_res_327526 *
               defunc_1_f_res_327535;
        double defunc_0_f_res_327537;
        
        if (cond_327517) {
            defunc_0_f_res_327537 = 0.0;
        } else {
            int64_t i_327538 = add64(x_327078, gtid_327510);
            double defunc_0_add_arg_327539;
            
            defunc_0_add_arg_327539 = ((double *) mem_313366.mem)[gtid_303954 *
                                                                  (defunc_0_f_res_292820 *
                                                                   n_p_292677) +
                                                                  gtid_326498 *
                                                                  defunc_0_f_res_292820 +
                                                                  i_327538];
            defunc_0_f_res_327537 = defunc_0_add_arg_327539;
        }
        
        double x_327540 = a12_327159 * tmp4_327534;
        double y_327541 = b12_327160 * defunc_1_f_res_327535;
        double x_327542 = x_327540 + y_327541;
        double y_327543 = c12_327161 * defunc_1_f_res_327536;
        double x_327544 = x_327542 + y_327543;
        double defunc_9_fit_fun_res_327545 = defunc_0_f_res_327537 * x_327544;
        double x_327546 = b12_327160 * tmp4_327534;
        double y_327547 = b2_327162 * defunc_1_f_res_327535;
        double x_327548 = x_327546 + y_327547;
        double y_327549 = c2_327163 * defunc_1_f_res_327536;
        double x_327550 = x_327548 + y_327549;
        double defunc_9_slope_fun_res_327551 = defunc_0_f_res_327537 * x_327550;
        
        // save map-out results
        { }
        // Load accum params
        {
            x_327511 = local_acc_327593;
        }
        // Load next params
        {
            x_327512 = defunc_9_fit_fun_res_327545;
        }
        // Red body
        {
            double defunc_1_op_res_327513 = x_327511 + x_327512;
            
            local_acc_327593 = defunc_1_op_res_327513;
        }
        // Load accum params
        {
            x_327514 = local_acc_327594;
        }
        // Load next params
        {
            x_327515 = defunc_9_slope_fun_res_327551;
        }
        // Red body
        {
            double defunc_1_op_res_327516 = x_327514 + x_327515;
            
            local_acc_327594 = defunc_1_op_res_327516;
        }
    }
    ((double *) reduce_stage_1_tid_res_arr_mem_327588.mem)[flat_tid_327509] =
        local_acc_327593;
    ((double *) reduce_stage_1_tid_res_arr_mem_327590.mem)[flat_tid_327509] =
        local_acc_327594;
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_338319_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_338319_end -
                 futhark_mc_segred_stage_1_parloop_338319_start;
        
        ctx->futhark_mc_segred_stage_1_parloop_338319_runs[tid]++;
        ctx->futhark_mc_segred_stage_1_parloop_338319_total_runtime[tid] +=
            elapsed;
        ctx->futhark_mc_segred_stage_1_parloop_338319_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segred_task_338315(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_327509 = tid;
    int num_tasks_327587 = info.nsubtasks;
    struct futhark_mc_task_338314 *futhark_mc_task_338314 =
                                  (struct futhark_mc_task_338314 *) args;
    struct futhark_context *ctx = futhark_mc_task_338314->ctx;
    uint64_t futhark_mc_segred_task_338315_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_task_338315_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_338314->free_n_p_292677;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_338314->free_defunc_0_f_res_292820;
    int64_t gtid_303954 = futhark_mc_task_338314->free_gtid_303954;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_task_338314->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_task_338314->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_task_338314->free_mem_313371,
                                  .size =0, .references =NULL};
    int64_t gtid_326498 = futhark_mc_task_338314->free_gtid_326498;
    int64_t x_326499 = futhark_mc_task_338314->free_x_326499;
    int64_t x_327078 = futhark_mc_task_338314->free_x_327078;
    double x_327079 = futhark_mc_task_338314->free_x_327079;
    double a12_327159 = futhark_mc_task_338314->free_a12_327159;
    double b12_327160 = futhark_mc_task_338314->free_b12_327160;
    double c12_327161 = futhark_mc_task_338314->free_c12_327161;
    double b2_327162 = futhark_mc_task_338314->free_b2_327162;
    double c2_327163 = futhark_mc_task_338314->free_c2_327163;
    int64_t defunc_0_m_fun_res_327164 =
            futhark_mc_task_338314->free_defunc_0_m_fun_res_327164;
    double defunc_2_reduce_res_327173 =
           *futhark_mc_task_338314->retval_defunc_2_reduce_res_327173;
    double defunc_2_reduce_res_327174 =
           *futhark_mc_task_338314->retval_defunc_2_reduce_res_327174;
    size_t reduce_stage_1_tid_res_arr_mem_327588_cached_sizze_338316 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_327588 = NULL;
    size_t reduce_stage_1_tid_res_arr_mem_327590_cached_sizze_338317 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_327590 = NULL;
    
    if (reduce_stage_1_tid_res_arr_mem_327588_cached_sizze_338316 <
        (size_t) ((int64_t) 8 * num_tasks_327587)) {
        reduce_stage_1_tid_res_arr_mem_327588 =
            realloc(reduce_stage_1_tid_res_arr_mem_327588, (int64_t) 8 *
                    num_tasks_327587);
        reduce_stage_1_tid_res_arr_mem_327588_cached_sizze_338316 =
            (int64_t) 8 * num_tasks_327587;
    }
    if (reduce_stage_1_tid_res_arr_mem_327590_cached_sizze_338317 <
        (size_t) ((int64_t) 8 * num_tasks_327587)) {
        reduce_stage_1_tid_res_arr_mem_327590 =
            realloc(reduce_stage_1_tid_res_arr_mem_327590, (int64_t) 8 *
                    num_tasks_327587);
        reduce_stage_1_tid_res_arr_mem_327590_cached_sizze_338317 =
            (int64_t) 8 * num_tasks_327587;
    }
    
    int64_t iter_327592;
    struct futhark_mc_segred_stage_1_parloop_struct_338318
    futhark_mc_segred_stage_1_parloop_struct_338318;
    
    futhark_mc_segred_stage_1_parloop_struct_338318.ctx = ctx;
    futhark_mc_segred_stage_1_parloop_struct_338318.free_n_p_292677 =
        n_p_292677;
    futhark_mc_segred_stage_1_parloop_struct_338318.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segred_stage_1_parloop_struct_338318.free_gtid_303954 =
        gtid_303954;
    futhark_mc_segred_stage_1_parloop_struct_338318.free_mem_312838 =
        mem_312838.mem;
    futhark_mc_segred_stage_1_parloop_struct_338318.free_mem_313366 =
        mem_313366.mem;
    futhark_mc_segred_stage_1_parloop_struct_338318.free_mem_313371 =
        mem_313371.mem;
    futhark_mc_segred_stage_1_parloop_struct_338318.free_gtid_326498 =
        gtid_326498;
    futhark_mc_segred_stage_1_parloop_struct_338318.free_x_326499 = x_326499;
    futhark_mc_segred_stage_1_parloop_struct_338318.free_x_327078 = x_327078;
    futhark_mc_segred_stage_1_parloop_struct_338318.free_x_327079 = x_327079;
    futhark_mc_segred_stage_1_parloop_struct_338318.free_a12_327159 =
        a12_327159;
    futhark_mc_segred_stage_1_parloop_struct_338318.free_b12_327160 =
        b12_327160;
    futhark_mc_segred_stage_1_parloop_struct_338318.free_c12_327161 =
        c12_327161;
    futhark_mc_segred_stage_1_parloop_struct_338318.free_b2_327162 = b2_327162;
    futhark_mc_segred_stage_1_parloop_struct_338318.free_c2_327163 = c2_327163;
    futhark_mc_segred_stage_1_parloop_struct_338318.free_defunc_0_m_fun_res_327164 =
        defunc_0_m_fun_res_327164;
    futhark_mc_segred_stage_1_parloop_struct_338318.free_reduce_stage_1_tid_res_arr_mem_327588 =
        reduce_stage_1_tid_res_arr_mem_327588;
    futhark_mc_segred_stage_1_parloop_struct_338318.free_reduce_stage_1_tid_res_arr_mem_327590 =
        reduce_stage_1_tid_res_arr_mem_327590;
    
    struct scheduler_parloop futhark_mc_segred_stage_1_parloop_338319_task;
    
    futhark_mc_segred_stage_1_parloop_338319_task.name =
        "futhark_mc_segred_stage_1_parloop_338319";
    futhark_mc_segred_stage_1_parloop_338319_task.fn =
        futhark_mc_segred_stage_1_parloop_338319;
    futhark_mc_segred_stage_1_parloop_338319_task.args =
        &futhark_mc_segred_stage_1_parloop_struct_338318;
    futhark_mc_segred_stage_1_parloop_338319_task.iterations = iterations;
    futhark_mc_segred_stage_1_parloop_338319_task.info = info;
    
    uint64_t futhark_mc_segred_stage_1_parloop_338319_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_338319_total_start = get_wall_time();
    
    int futhark_mc_segred_stage_1_parloop_338319_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segred_stage_1_parloop_338319_task);
    
    if (futhark_mc_segred_stage_1_parloop_338319_err != 0) {
        err = futhark_mc_segred_stage_1_parloop_338319_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_338319_total_end =
                 get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_338319_total_end -
                 futhark_mc_segred_stage_1_parloop_338319_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338319_total_runs,
                           1, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338319_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338319_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    // neutral-initialise the output
    {
        defunc_2_reduce_res_327173 = 0.0;
        defunc_2_reduce_res_327174 = 0.0;
    }
    
    double x_327595;
    double x_327596;
    double x_327598;
    double x_327599;
    
    for (int32_t i_327601 = 0; i_327601 < num_tasks_327587; i_327601++) {
        flat_tid_327509 = i_327601;
        // Apply main thread reduction
        {
            // load acc params
            {
                x_327595 = defunc_2_reduce_res_327173;
            }
            // load next params
            {
                x_327596 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_327588)[flat_tid_327509];
            }
            // red body
            {
                double defunc_1_op_res_327597 = x_327595 + x_327596;
                
                defunc_2_reduce_res_327173 = defunc_1_op_res_327597;
            }
            // load acc params
            {
                x_327598 = defunc_2_reduce_res_327174;
            }
            // load next params
            {
                x_327599 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_327590)[flat_tid_327509];
            }
            // red body
            {
                double defunc_1_op_res_327600 = x_327598 + x_327599;
                
                defunc_2_reduce_res_327174 = defunc_1_op_res_327600;
            }
        }
    }
    
  cleanup:
    {
        free(reduce_stage_1_tid_res_arr_mem_327588);
        free(reduce_stage_1_tid_res_arr_mem_327590);
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_task_338315_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_task_338315_end -
                 futhark_mc_segred_task_338315_start;
        
        ctx->futhark_mc_segred_task_338315_runs[tid]++;
        ctx->futhark_mc_segred_task_338315_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segred_task_338315_iter[tid] += iterations;
    }
    if (err == 0) {
        *futhark_mc_task_338314->retval_defunc_2_reduce_res_327173 =
            defunc_2_reduce_res_327173;
        *futhark_mc_task_338314->retval_defunc_2_reduce_res_327174 =
            defunc_2_reduce_res_327174;
    }
    return err;
}
static int futhark_mc_segmap_parloop_338304(void *args, int64_t start,
                                            int64_t end, int flat_tid_327076,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338303
    *futhark_mc_segmap_parloop_struct_338303 =
    (struct futhark_mc_segmap_parloop_struct_338303 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338303->ctx;
    uint64_t futhark_mc_segmap_parloop_338304_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338304_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segmap_parloop_struct_338303->free_n_p_292677;
    int64_t q_s_292678 =
            futhark_mc_segmap_parloop_struct_338303->free_q_s_292678;
    int64_t jump_s_292684 =
            futhark_mc_segmap_parloop_struct_338303->free_jump_s_292684;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segmap_parloop_struct_338303->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_segmap_parloop_struct_338303->free_pad_css_len_292821;
    int64_t s_n_m_292825 =
            futhark_mc_segmap_parloop_struct_338303->free_s_n_m_292825;
    int64_t gtid_303954 =
            futhark_mc_segmap_parloop_struct_338303->free_gtid_303954;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_segmap_parloop_struct_338303->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_segmap_parloop_struct_338303->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_segmap_parloop_struct_338303->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_segmap_parloop_struct_338303->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_segmap_parloop_struct_338303->free_mem_313371,
                                  .size =0, .references =NULL};
    int64_t gtid_326498 =
            futhark_mc_segmap_parloop_struct_338303->free_gtid_326498;
    int64_t x_326499 = futhark_mc_segmap_parloop_struct_338303->free_x_326499;
    struct memblock mem_326500 = {.desc ="mem_326500", .mem =
                                  futhark_mc_segmap_parloop_struct_338303->free_mem_326500,
                                  .size =0, .references =NULL};
    struct memblock mem_326501 = {.desc ="mem_326501", .mem =
                                  futhark_mc_segmap_parloop_struct_338303->free_mem_326501,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_327453 = start;
    
    for (; iter_327453 < end; iter_327453++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_327552 = s_n_m_292825;
        int64_t gtid_327077 = iter_327453;
        int64_t remnant_327553 = iter_327453 - gtid_327077;
        int64_t x_327078;
        
        x_327078 = ((int64_t *) mem_313018.mem)[gtid_303954 * (s_n_m_292825 *
                                                               n_p_292677) +
                                                gtid_326498 * s_n_m_292825 +
                                                gtid_327077];
        
        double x_327079;
        
        x_327079 = ((double *) mem_313023.mem)[gtid_303954 * (s_n_m_292825 *
                                                              n_p_292677) +
                                               gtid_326498 * s_n_m_292825 +
                                               gtid_327077];
        
        bool cond_327080 = gtid_327077 == (int64_t) 0;
        int64_t defunc_0_m_fun_res_327081;
        
        if (cond_327080) {
            defunc_0_m_fun_res_327081 = (int64_t) 0;
        } else {
            int64_t y_327454 = sub64(s_n_m_292825, (int64_t) 1);
            bool cond_327455 = gtid_327077 == y_327454;
            int64_t defunc_0_m_fun_res_f_res_327456;
            
            if (cond_327455) {
                int64_t defunc_0_m_fun_res_f_res_t_res_327457 =
                        sub64(pad_css_len_292821, (int64_t) 1);
                
                defunc_0_m_fun_res_f_res_327456 =
                    defunc_0_m_fun_res_f_res_t_res_327457;
            } else {
                int64_t x_327458 = sub64(gtid_327077, (int64_t) 1);
                int64_t x_327459 = mul64(jump_s_292684, x_327458);
                int64_t min_arg_327460 = add64((int64_t) 1, x_327459);
                int64_t min_res_327461 = smin64(defunc_0_f_res_292820,
                                                min_arg_327460);
                
                defunc_0_m_fun_res_f_res_327456 = min_res_327461;
            }
            defunc_0_m_fun_res_327081 = defunc_0_m_fun_res_f_res_327456;
        }
        
        double defunc_2_reduce_res_327090;
        double defunc_2_reduce_res_327091;
        double defunc_2_reduce_res_327092;
        double defunc_2_reduce_res_327093;
        double defunc_2_reduce_res_327094;
        int64_t flat_tid_327462 = (int64_t) 0;
        int32_t num_tasks_327554;
        
        defunc_2_reduce_res_327090 = 0.0;
        defunc_2_reduce_res_327091 = 0.0;
        defunc_2_reduce_res_327092 = 0.0;
        defunc_2_reduce_res_327093 = 0.0;
        defunc_2_reduce_res_327094 = 0.0;
        
        struct futhark_mc_task_338305 futhark_mc_task_338305;
        
        futhark_mc_task_338305.ctx = ctx;
        futhark_mc_task_338305.free_n_p_292677 = n_p_292677;
        futhark_mc_task_338305.free_defunc_0_f_res_292820 =
            defunc_0_f_res_292820;
        futhark_mc_task_338305.free_gtid_303954 = gtid_303954;
        futhark_mc_task_338305.free_mem_312838 = mem_312838.mem;
        futhark_mc_task_338305.free_mem_313371 = mem_313371.mem;
        futhark_mc_task_338305.free_gtid_326498 = gtid_326498;
        futhark_mc_task_338305.free_x_326499 = x_326499;
        futhark_mc_task_338305.free_x_327078 = x_327078;
        futhark_mc_task_338305.free_x_327079 = x_327079;
        futhark_mc_task_338305.free_defunc_0_m_fun_res_327081 =
            defunc_0_m_fun_res_327081;
        futhark_mc_task_338305.retval_defunc_2_reduce_res_327090 =
            &defunc_2_reduce_res_327090;
        futhark_mc_task_338305.retval_defunc_2_reduce_res_327091 =
            &defunc_2_reduce_res_327091;
        futhark_mc_task_338305.retval_defunc_2_reduce_res_327092 =
            &defunc_2_reduce_res_327092;
        futhark_mc_task_338305.retval_defunc_2_reduce_res_327093 =
            &defunc_2_reduce_res_327093;
        futhark_mc_task_338305.retval_defunc_2_reduce_res_327094 =
            &defunc_2_reduce_res_327094;
        
        struct scheduler_segop futhark_mc_task_338305_task;
        
        futhark_mc_task_338305_task.args = &futhark_mc_task_338305;
        futhark_mc_task_338305_task.top_level_fn =
            futhark_mc_segred_task_338306;
        futhark_mc_task_338305_task.name = "futhark_mc_segred_task_338306";
        futhark_mc_task_338305_task.iterations = q_s_292678;
        futhark_mc_task_338305_task.task_time =
            &ctx->futhark_mc_segred_task_338306_total_time;
        futhark_mc_task_338305_task.task_iter =
            &ctx->futhark_mc_segred_task_338306_total_iter;
        futhark_mc_task_338305_task.sched = STATIC;
        futhark_mc_task_338305_task.nested_fn = NULL;
        
        int futhark_mc_segred_task_338306_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_338305_task);
        
        if (futhark_mc_segred_task_338306_err != 0) {
            ;
            err = futhark_mc_segred_task_338306_err;
            goto cleanup;
        }
        
        double a_327134 = 2.220446049250313e-16 + defunc_2_reduce_res_327090;
        double b_327135 = 2.220446049250313e-16 + defunc_2_reduce_res_327091;
        double c_327136 = 2.220446049250313e-16 + defunc_2_reduce_res_327092;
        double d_327137 = 2.220446049250313e-16 + defunc_2_reduce_res_327093;
        double e_327138 = 2.220446049250313e-16 + defunc_2_reduce_res_327094;
        double x_327139 = c_327136 * e_327138;
        double y_327140 = d_327137 * d_327137;
        double a12_327141 = x_327139 - y_327140;
        double x_327142 = c_327136 * d_327137;
        double y_327143 = b_327135 * e_327138;
        double b12_327144 = x_327142 - y_327143;
        double x_327145 = b_327135 * d_327137;
        double y_327146 = c_327136 * c_327136;
        double c12_327147 = x_327145 - y_327146;
        double x_327148 = a_327134 * e_327138;
        double b2_327149 = x_327148 - y_327146;
        double x_327150 = b_327135 * c_327136;
        double y_327151 = a_327134 * d_327137;
        double c2_327152 = x_327150 - y_327151;
        double x_327153 = a_327134 * a12_327141;
        double y_327154 = b_327135 * b12_327144;
        double x_327155 = x_327153 + y_327154;
        double y_327156 = c_327136 * c12_327147;
        double y_327157 = x_327155 + y_327156;
        double det_327158 = 1.0 / y_327157;
        double a12_327159 = a12_327141 * det_327158;
        double b12_327160 = b12_327144 * det_327158;
        double c12_327161 = c12_327147 * det_327158;
        double b2_327162 = b2_327149 * det_327158;
        double c2_327163 = c2_327152 * det_327158;
        int64_t defunc_0_m_fun_res_327164;
        
        if (cond_327080) {
            defunc_0_m_fun_res_327164 = (int64_t) 0;
        } else {
            int64_t y_327501 = sub64(s_n_m_292825, (int64_t) 1);
            bool cond_327502 = gtid_327077 == y_327501;
            int64_t defunc_0_m_fun_res_f_res_327503;
            
            if (cond_327502) {
                int64_t defunc_0_m_fun_res_f_res_t_res_327504 =
                        sub64(pad_css_len_292821, (int64_t) 1);
                
                defunc_0_m_fun_res_f_res_327503 =
                    defunc_0_m_fun_res_f_res_t_res_327504;
            } else {
                int64_t x_327505 = sub64(gtid_327077, (int64_t) 1);
                int64_t x_327506 = mul64(jump_s_292684, x_327505);
                int64_t min_arg_327507 = add64((int64_t) 1, x_327506);
                int64_t min_res_327508 = smin64(defunc_0_f_res_292820,
                                                min_arg_327507);
                
                defunc_0_m_fun_res_f_res_327503 = min_res_327508;
            }
            defunc_0_m_fun_res_327164 = defunc_0_m_fun_res_f_res_327503;
        }
        
        double defunc_2_reduce_res_327173;
        double defunc_2_reduce_res_327174;
        int64_t flat_tid_327509 = (int64_t) 0;
        int32_t num_tasks_327587;
        
        defunc_2_reduce_res_327173 = 0.0;
        defunc_2_reduce_res_327174 = 0.0;
        
        struct futhark_mc_task_338314 futhark_mc_task_338314;
        
        futhark_mc_task_338314.ctx = ctx;
        futhark_mc_task_338314.free_n_p_292677 = n_p_292677;
        futhark_mc_task_338314.free_defunc_0_f_res_292820 =
            defunc_0_f_res_292820;
        futhark_mc_task_338314.free_gtid_303954 = gtid_303954;
        futhark_mc_task_338314.free_mem_312838 = mem_312838.mem;
        futhark_mc_task_338314.free_mem_313366 = mem_313366.mem;
        futhark_mc_task_338314.free_mem_313371 = mem_313371.mem;
        futhark_mc_task_338314.free_gtid_326498 = gtid_326498;
        futhark_mc_task_338314.free_x_326499 = x_326499;
        futhark_mc_task_338314.free_x_327078 = x_327078;
        futhark_mc_task_338314.free_x_327079 = x_327079;
        futhark_mc_task_338314.free_a12_327159 = a12_327159;
        futhark_mc_task_338314.free_b12_327160 = b12_327160;
        futhark_mc_task_338314.free_c12_327161 = c12_327161;
        futhark_mc_task_338314.free_b2_327162 = b2_327162;
        futhark_mc_task_338314.free_c2_327163 = c2_327163;
        futhark_mc_task_338314.free_defunc_0_m_fun_res_327164 =
            defunc_0_m_fun_res_327164;
        futhark_mc_task_338314.retval_defunc_2_reduce_res_327173 =
            &defunc_2_reduce_res_327173;
        futhark_mc_task_338314.retval_defunc_2_reduce_res_327174 =
            &defunc_2_reduce_res_327174;
        
        struct scheduler_segop futhark_mc_task_338314_task;
        
        futhark_mc_task_338314_task.args = &futhark_mc_task_338314;
        futhark_mc_task_338314_task.top_level_fn =
            futhark_mc_segred_task_338315;
        futhark_mc_task_338314_task.name = "futhark_mc_segred_task_338315";
        futhark_mc_task_338314_task.iterations = q_s_292678;
        futhark_mc_task_338314_task.task_time =
            &ctx->futhark_mc_segred_task_338315_total_time;
        futhark_mc_task_338314_task.task_iter =
            &ctx->futhark_mc_segred_task_338315_total_iter;
        futhark_mc_task_338314_task.sched = STATIC;
        futhark_mc_task_338314_task.nested_fn = NULL;
        
        int futhark_mc_segred_task_338315_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_338314_task);
        
        if (futhark_mc_segred_task_338315_err != 0) {
            ;
            err = futhark_mc_segred_task_338315_err;
            goto cleanup;
        }
        ((double *) mem_326500.mem)[gtid_327077] = defunc_2_reduce_res_327173;
        ((double *) mem_326501.mem)[gtid_327077] = defunc_2_reduce_res_327174;
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338304_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338304_end -
                 futhark_mc_segmap_parloop_338304_start;
        
        ctx->futhark_mc_segmap_parloop_338304_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338304_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338304_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_nested_task_338302(void *args, int64_t iterations,
                                         int tid, struct scheduler_info info)
{
    int err = 0;
    int flat_tid_327076 = tid;
    int num_tasks_327353 = info.nsubtasks;
    struct futhark_mc_task_338298 *futhark_mc_task_338298 =
                                  (struct futhark_mc_task_338298 *) args;
    struct futhark_context *ctx = futhark_mc_task_338298->ctx;
    uint64_t futhark_mc_segmap_nested_task_338302_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_nested_task_338302_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_338298->free_n_p_292677;
    int64_t q_s_292678 = futhark_mc_task_338298->free_q_s_292678;
    int64_t jump_s_292684 = futhark_mc_task_338298->free_jump_s_292684;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_338298->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_task_338298->free_pad_css_len_292821;
    int64_t s_n_m_292825 = futhark_mc_task_338298->free_s_n_m_292825;
    int64_t gtid_303954 = futhark_mc_task_338298->free_gtid_303954;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_task_338298->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_task_338298->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_task_338298->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_task_338298->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_task_338298->free_mem_313371,
                                  .size =0, .references =NULL};
    int64_t gtid_326498 = futhark_mc_task_338298->free_gtid_326498;
    int64_t x_326499 = futhark_mc_task_338298->free_x_326499;
    struct memblock mem_326500 = {.desc ="mem_326500", .mem =
                                  futhark_mc_task_338298->free_mem_326500,
                                  .size =0, .references =NULL};
    struct memblock mem_326501 = {.desc ="mem_326501", .mem =
                                  futhark_mc_task_338298->free_mem_326501,
                                  .size =0, .references =NULL};
    int64_t iter_327453;
    struct futhark_mc_segmap_parloop_struct_338303
    futhark_mc_segmap_parloop_struct_338303;
    
    futhark_mc_segmap_parloop_struct_338303.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338303.free_n_p_292677 = n_p_292677;
    futhark_mc_segmap_parloop_struct_338303.free_q_s_292678 = q_s_292678;
    futhark_mc_segmap_parloop_struct_338303.free_jump_s_292684 = jump_s_292684;
    futhark_mc_segmap_parloop_struct_338303.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segmap_parloop_struct_338303.free_pad_css_len_292821 =
        pad_css_len_292821;
    futhark_mc_segmap_parloop_struct_338303.free_s_n_m_292825 = s_n_m_292825;
    futhark_mc_segmap_parloop_struct_338303.free_gtid_303954 = gtid_303954;
    futhark_mc_segmap_parloop_struct_338303.free_mem_312838 = mem_312838.mem;
    futhark_mc_segmap_parloop_struct_338303.free_mem_313018 = mem_313018.mem;
    futhark_mc_segmap_parloop_struct_338303.free_mem_313023 = mem_313023.mem;
    futhark_mc_segmap_parloop_struct_338303.free_mem_313366 = mem_313366.mem;
    futhark_mc_segmap_parloop_struct_338303.free_mem_313371 = mem_313371.mem;
    futhark_mc_segmap_parloop_struct_338303.free_gtid_326498 = gtid_326498;
    futhark_mc_segmap_parloop_struct_338303.free_x_326499 = x_326499;
    futhark_mc_segmap_parloop_struct_338303.free_mem_326500 = mem_326500.mem;
    futhark_mc_segmap_parloop_struct_338303.free_mem_326501 = mem_326501.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338304_task;
    
    futhark_mc_segmap_parloop_338304_task.name =
        "futhark_mc_segmap_parloop_338304";
    futhark_mc_segmap_parloop_338304_task.fn = futhark_mc_segmap_parloop_338304;
    futhark_mc_segmap_parloop_338304_task.args =
        &futhark_mc_segmap_parloop_struct_338303;
    futhark_mc_segmap_parloop_338304_task.iterations = iterations;
    futhark_mc_segmap_parloop_338304_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338304_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338304_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338304_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338304_task);
    
    if (futhark_mc_segmap_parloop_338304_err != 0) {
        err = futhark_mc_segmap_parloop_338304_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338304_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338304_total_end -
                 futhark_mc_segmap_parloop_338304_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338304_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338304_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338304_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_nested_task_338302_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_nested_task_338302_end -
                 futhark_mc_segmap_nested_task_338302_start;
        
        ctx->futhark_mc_segmap_nested_task_338302_runs[tid]++;
        ctx->futhark_mc_segmap_nested_task_338302_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_nested_task_338302_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
static int futhark_mc_segmap_parloop_338295(void *args, int64_t start,
                                            int64_t end, int flat_tid_326497,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338294
    *futhark_mc_segmap_parloop_struct_338294 =
    (struct futhark_mc_segmap_parloop_struct_338294 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338294->ctx;
    uint64_t futhark_mc_segmap_parloop_338295_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338295_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segmap_parloop_struct_338294->free_n_p_292677;
    int64_t q_s_292678 =
            futhark_mc_segmap_parloop_struct_338294->free_q_s_292678;
    int64_t jump_s_292684 =
            futhark_mc_segmap_parloop_struct_338294->free_jump_s_292684;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segmap_parloop_struct_338294->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_segmap_parloop_struct_338294->free_pad_css_len_292821;
    int64_t s_n_m_292825 =
            futhark_mc_segmap_parloop_struct_338294->free_s_n_m_292825;
    int64_t gtid_303954 =
            futhark_mc_segmap_parloop_struct_338294->free_gtid_303954;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_segmap_parloop_struct_338294->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_312842 = {.desc ="mem_312842", .mem =
                                  futhark_mc_segmap_parloop_struct_338294->free_mem_312842,
                                  .size =0, .references =NULL};
    int64_t bytes_312847 =
            futhark_mc_segmap_parloop_struct_338294->free_bytes_312847;
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_segmap_parloop_struct_338294->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_segmap_parloop_struct_338294->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_segmap_parloop_struct_338294->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_segmap_parloop_struct_338294->free_mem_313371,
                                  .size =0, .references =NULL};
    struct memblock mem_314732 = {.desc ="mem_314732", .mem =
                                  futhark_mc_segmap_parloop_struct_338294->free_mem_314732,
                                  .size =0, .references =NULL};
    struct memblock mem_314736 = {.desc ="mem_314736", .mem =
                                  futhark_mc_segmap_parloop_struct_338294->free_mem_314736,
                                  .size =0, .references =NULL};
    size_t mem_326500_cached_sizze_338296 = 0;
    unsigned char *mem_326500 = NULL;
    size_t mem_326501_cached_sizze_338297 = 0;
    unsigned char *mem_326501 = NULL;
    int64_t iterations = end - start;
    int64_t iter_327075 = start;
    
    if (mem_326500_cached_sizze_338296 < (size_t) bytes_312847) {
        mem_326500 = realloc(mem_326500, bytes_312847);
        mem_326500_cached_sizze_338296 = bytes_312847;
    }
    if (mem_326501_cached_sizze_338297 < (size_t) bytes_312847) {
        mem_326501 = realloc(mem_326501, bytes_312847);
        mem_326501_cached_sizze_338297 = bytes_312847;
    }
    for (; iter_327075 < end; iter_327075++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_327351 = n_p_292677;
        int64_t gtid_326498 = iter_327075;
        int64_t remnant_327352 = iter_327075 - gtid_326498;
        int64_t x_326499;
        
        x_326499 = ((int64_t *) mem_312842.mem)[gtid_303954 * n_p_292677 +
                                                gtid_326498];
        
        int64_t flat_tid_327218 = (int64_t) 0;
        int32_t num_tasks_327353;
        int64_t flat_tid_327076 = (int64_t) 0;
        struct futhark_mc_task_338298 futhark_mc_task_338298;
        
        futhark_mc_task_338298.ctx = ctx;
        futhark_mc_task_338298.free_n_p_292677 = n_p_292677;
        futhark_mc_task_338298.free_q_s_292678 = q_s_292678;
        futhark_mc_task_338298.free_jump_s_292684 = jump_s_292684;
        futhark_mc_task_338298.free_defunc_0_f_res_292820 =
            defunc_0_f_res_292820;
        futhark_mc_task_338298.free_pad_css_len_292821 = pad_css_len_292821;
        futhark_mc_task_338298.free_s_n_m_292825 = s_n_m_292825;
        futhark_mc_task_338298.free_gtid_303954 = gtid_303954;
        futhark_mc_task_338298.free_mem_312838 = mem_312838.mem;
        futhark_mc_task_338298.free_mem_313018 = mem_313018.mem;
        futhark_mc_task_338298.free_mem_313023 = mem_313023.mem;
        futhark_mc_task_338298.free_mem_313366 = mem_313366.mem;
        futhark_mc_task_338298.free_mem_313371 = mem_313371.mem;
        futhark_mc_task_338298.free_gtid_326498 = gtid_326498;
        futhark_mc_task_338298.free_x_326499 = x_326499;
        futhark_mc_task_338298.free_mem_326500 = mem_326500;
        futhark_mc_task_338298.free_mem_326501 = mem_326501;
        
        struct scheduler_segop futhark_mc_task_338298_task;
        
        futhark_mc_task_338298_task.args = &futhark_mc_task_338298;
        futhark_mc_task_338298_task.top_level_fn =
            futhark_mc_segmap_task_338299;
        futhark_mc_task_338298_task.name = "futhark_mc_segmap_task_338299";
        futhark_mc_task_338298_task.iterations = s_n_m_292825;
        futhark_mc_task_338298_task.task_time =
            &ctx->futhark_mc_segmap_task_338299_total_time;
        futhark_mc_task_338298_task.task_iter =
            &ctx->futhark_mc_segmap_task_338299_total_iter;
        futhark_mc_task_338298_task.sched = STATIC;
        futhark_mc_task_338298_task.nested_fn =
            futhark_mc_segmap_nested_task_338302;
        
        int futhark_mc_segmap_task_338299_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_338298_task);
        
        if (futhark_mc_segmap_task_338299_err != 0) {
            ;
            err = futhark_mc_segmap_task_338299_err;
            goto cleanup;
        }
        if (s_n_m_292825 * (int64_t) 8 > 0)
            memmove(mem_314732.mem + gtid_326498 * s_n_m_292825 * (int64_t) 8,
                    mem_326500 + (int64_t) 0, s_n_m_292825 * (int64_t) 8);
        if (s_n_m_292825 * (int64_t) 8 > 0)
            memmove(mem_314736.mem + gtid_326498 * s_n_m_292825 * (int64_t) 8,
                    mem_326501 + (int64_t) 0, s_n_m_292825 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_326500);
    free(mem_326501);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338295_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338295_end -
                 futhark_mc_segmap_parloop_338295_start;
        
        ctx->futhark_mc_segmap_parloop_338295_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338295_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338295_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_nested_task_338293(void *args, int64_t iterations,
                                         int tid, struct scheduler_info info)
{
    int err = 0;
    int flat_tid_326497 = tid;
    int num_tasks_326926 = info.nsubtasks;
    struct futhark_mc_task_338287 *futhark_mc_task_338287 =
                                  (struct futhark_mc_task_338287 *) args;
    struct futhark_context *ctx = futhark_mc_task_338287->ctx;
    uint64_t futhark_mc_segmap_nested_task_338293_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_nested_task_338293_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_338287->free_n_p_292677;
    int64_t q_s_292678 = futhark_mc_task_338287->free_q_s_292678;
    int64_t jump_s_292684 = futhark_mc_task_338287->free_jump_s_292684;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_338287->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_task_338287->free_pad_css_len_292821;
    int64_t s_n_m_292825 = futhark_mc_task_338287->free_s_n_m_292825;
    int64_t gtid_303954 = futhark_mc_task_338287->free_gtid_303954;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_task_338287->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_312842 = {.desc ="mem_312842", .mem =
                                  futhark_mc_task_338287->free_mem_312842,
                                  .size =0, .references =NULL};
    int64_t bytes_312847 = futhark_mc_task_338287->free_bytes_312847;
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_task_338287->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_task_338287->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_task_338287->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_task_338287->free_mem_313371,
                                  .size =0, .references =NULL};
    struct memblock mem_314732 = {.desc ="mem_314732", .mem =
                                  futhark_mc_task_338287->free_mem_314732,
                                  .size =0, .references =NULL};
    struct memblock mem_314736 = {.desc ="mem_314736", .mem =
                                  futhark_mc_task_338287->free_mem_314736,
                                  .size =0, .references =NULL};
    int64_t iter_327075;
    struct futhark_mc_segmap_parloop_struct_338294
    futhark_mc_segmap_parloop_struct_338294;
    
    futhark_mc_segmap_parloop_struct_338294.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338294.free_n_p_292677 = n_p_292677;
    futhark_mc_segmap_parloop_struct_338294.free_q_s_292678 = q_s_292678;
    futhark_mc_segmap_parloop_struct_338294.free_jump_s_292684 = jump_s_292684;
    futhark_mc_segmap_parloop_struct_338294.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segmap_parloop_struct_338294.free_pad_css_len_292821 =
        pad_css_len_292821;
    futhark_mc_segmap_parloop_struct_338294.free_s_n_m_292825 = s_n_m_292825;
    futhark_mc_segmap_parloop_struct_338294.free_gtid_303954 = gtid_303954;
    futhark_mc_segmap_parloop_struct_338294.free_mem_312838 = mem_312838.mem;
    futhark_mc_segmap_parloop_struct_338294.free_mem_312842 = mem_312842.mem;
    futhark_mc_segmap_parloop_struct_338294.free_bytes_312847 = bytes_312847;
    futhark_mc_segmap_parloop_struct_338294.free_mem_313018 = mem_313018.mem;
    futhark_mc_segmap_parloop_struct_338294.free_mem_313023 = mem_313023.mem;
    futhark_mc_segmap_parloop_struct_338294.free_mem_313366 = mem_313366.mem;
    futhark_mc_segmap_parloop_struct_338294.free_mem_313371 = mem_313371.mem;
    futhark_mc_segmap_parloop_struct_338294.free_mem_314732 = mem_314732.mem;
    futhark_mc_segmap_parloop_struct_338294.free_mem_314736 = mem_314736.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338295_task;
    
    futhark_mc_segmap_parloop_338295_task.name =
        "futhark_mc_segmap_parloop_338295";
    futhark_mc_segmap_parloop_338295_task.fn = futhark_mc_segmap_parloop_338295;
    futhark_mc_segmap_parloop_338295_task.args =
        &futhark_mc_segmap_parloop_struct_338294;
    futhark_mc_segmap_parloop_338295_task.iterations = iterations;
    futhark_mc_segmap_parloop_338295_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338295_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338295_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338295_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338295_task);
    
    if (futhark_mc_segmap_parloop_338295_err != 0) {
        err = futhark_mc_segmap_parloop_338295_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338295_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338295_total_end -
                 futhark_mc_segmap_parloop_338295_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338295_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338295_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338295_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_nested_task_338293_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_nested_task_338293_end -
                 futhark_mc_segmap_nested_task_338293_start;
        
        ctx->futhark_mc_segmap_nested_task_338293_runs[tid]++;
        ctx->futhark_mc_segmap_nested_task_338293_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_nested_task_338293_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
static int futhark_mc_segmap_parloop_338284(void *args, int64_t start,
                                            int64_t end, int flat_tid_303953,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338283
    *futhark_mc_segmap_parloop_struct_338283 =
    (struct futhark_mc_segmap_parloop_struct_338283 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338283->ctx;
    uint64_t futhark_mc_segmap_parloop_338284_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338284_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segmap_parloop_struct_338283->free_n_p_292677;
    int64_t q_s_292678 =
            futhark_mc_segmap_parloop_struct_338283->free_q_s_292678;
    int64_t jump_s_292684 =
            futhark_mc_segmap_parloop_struct_338283->free_jump_s_292684;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_338283->free_partition_sizze_292766;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segmap_parloop_struct_338283->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_segmap_parloop_struct_338283->free_pad_css_len_292821;
    int64_t s_n_m_292825 =
            futhark_mc_segmap_parloop_struct_338283->free_s_n_m_292825;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_segmap_parloop_struct_338283->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_312842 = {.desc ="mem_312842", .mem =
                                  futhark_mc_segmap_parloop_struct_338283->free_mem_312842,
                                  .size =0, .references =NULL};
    int64_t bytes_312847 =
            futhark_mc_segmap_parloop_struct_338283->free_bytes_312847;
    int64_t bytes_312899 =
            futhark_mc_segmap_parloop_struct_338283->free_bytes_312899;
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_segmap_parloop_struct_338283->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_segmap_parloop_struct_338283->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_segmap_parloop_struct_338283->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_segmap_parloop_struct_338283->free_mem_313371,
                                  .size =0, .references =NULL};
    struct memblock mem_314835 = {.desc ="mem_314835", .mem =
                                  futhark_mc_segmap_parloop_struct_338283->free_mem_314835,
                                  .size =0, .references =NULL};
    struct memblock mem_314840 = {.desc ="mem_314840", .mem =
                                  futhark_mc_segmap_parloop_struct_338283->free_mem_314840,
                                  .size =0, .references =NULL};
    size_t mem_314732_cached_sizze_338285 = 0;
    unsigned char *mem_314732 = NULL;
    size_t mem_314736_cached_sizze_338286 = 0;
    unsigned char *mem_314736 = NULL;
    int64_t iterations = end - start;
    int64_t iter_326496 = start;
    
    if (mem_314732_cached_sizze_338285 < (size_t) bytes_312899) {
        mem_314732 = realloc(mem_314732, bytes_312899);
        mem_314732_cached_sizze_338285 = bytes_312899;
    }
    if (mem_314736_cached_sizze_338286 < (size_t) bytes_312899) {
        mem_314736 = realloc(mem_314736, bytes_312899);
        mem_314736_cached_sizze_338286 = bytes_312899;
    }
    for (; iter_326496 < end; iter_326496++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_326924 = partition_sizze_292766;
        int64_t gtid_303954 = iter_326496;
        int64_t remnant_326925 = iter_326496 - gtid_303954;
        int64_t flat_tid_326779 = (int64_t) 0;
        int32_t num_tasks_326926;
        int64_t flat_tid_326497 = (int64_t) 0;
        struct futhark_mc_task_338287 futhark_mc_task_338287;
        
        futhark_mc_task_338287.ctx = ctx;
        futhark_mc_task_338287.free_n_p_292677 = n_p_292677;
        futhark_mc_task_338287.free_q_s_292678 = q_s_292678;
        futhark_mc_task_338287.free_jump_s_292684 = jump_s_292684;
        futhark_mc_task_338287.free_defunc_0_f_res_292820 =
            defunc_0_f_res_292820;
        futhark_mc_task_338287.free_pad_css_len_292821 = pad_css_len_292821;
        futhark_mc_task_338287.free_s_n_m_292825 = s_n_m_292825;
        futhark_mc_task_338287.free_gtid_303954 = gtid_303954;
        futhark_mc_task_338287.free_mem_312838 = mem_312838.mem;
        futhark_mc_task_338287.free_mem_312842 = mem_312842.mem;
        futhark_mc_task_338287.free_bytes_312847 = bytes_312847;
        futhark_mc_task_338287.free_mem_313018 = mem_313018.mem;
        futhark_mc_task_338287.free_mem_313023 = mem_313023.mem;
        futhark_mc_task_338287.free_mem_313366 = mem_313366.mem;
        futhark_mc_task_338287.free_mem_313371 = mem_313371.mem;
        futhark_mc_task_338287.free_mem_314732 = mem_314732;
        futhark_mc_task_338287.free_mem_314736 = mem_314736;
        
        struct scheduler_segop futhark_mc_task_338287_task;
        
        futhark_mc_task_338287_task.args = &futhark_mc_task_338287;
        futhark_mc_task_338287_task.top_level_fn =
            futhark_mc_segmap_task_338288;
        futhark_mc_task_338287_task.name = "futhark_mc_segmap_task_338288";
        futhark_mc_task_338287_task.iterations = n_p_292677;
        futhark_mc_task_338287_task.task_time =
            &ctx->futhark_mc_segmap_task_338288_total_time;
        futhark_mc_task_338287_task.task_iter =
            &ctx->futhark_mc_segmap_task_338288_total_iter;
        futhark_mc_task_338287_task.sched = STATIC;
        futhark_mc_task_338287_task.nested_fn =
            futhark_mc_segmap_nested_task_338293;
        
        int futhark_mc_segmap_task_338288_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_338287_task);
        
        if (futhark_mc_segmap_task_338288_err != 0) {
            ;
            err = futhark_mc_segmap_task_338288_err;
            goto cleanup;
        }
        if (n_p_292677 * s_n_m_292825 * (int64_t) 8 > 0)
            memmove(mem_314835.mem + gtid_303954 * (s_n_m_292825 * n_p_292677) *
                    (int64_t) 8, mem_314732 + (int64_t) 0, n_p_292677 *
                    s_n_m_292825 * (int64_t) 8);
        if (n_p_292677 * s_n_m_292825 * (int64_t) 8 > 0)
            memmove(mem_314840.mem + gtid_303954 * (s_n_m_292825 * n_p_292677) *
                    (int64_t) 8, mem_314736 + (int64_t) 0, n_p_292677 *
                    s_n_m_292825 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_314732);
    free(mem_314736);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338284_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338284_end -
                 futhark_mc_segmap_parloop_338284_start;
        
        ctx->futhark_mc_segmap_parloop_338284_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338284_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338284_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_nested_task_338282(void *args, int64_t iterations,
                                         int tid, struct scheduler_info info)
{
    int err = 0;
    int flat_tid_303953 = tid;
    int num_tasks_326339 = info.nsubtasks;
    struct futhark_mc_task_338276 *futhark_mc_task_338276 =
                                  (struct futhark_mc_task_338276 *) args;
    struct futhark_context *ctx = futhark_mc_task_338276->ctx;
    uint64_t futhark_mc_segmap_nested_task_338282_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_nested_task_338282_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_338276->free_n_p_292677;
    int64_t q_s_292678 = futhark_mc_task_338276->free_q_s_292678;
    int64_t jump_s_292684 = futhark_mc_task_338276->free_jump_s_292684;
    int64_t partition_sizze_292766 =
            futhark_mc_task_338276->free_partition_sizze_292766;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_338276->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_task_338276->free_pad_css_len_292821;
    int64_t s_n_m_292825 = futhark_mc_task_338276->free_s_n_m_292825;
    struct memblock mem_312838 = {.desc ="mem_312838", .mem =
                                  futhark_mc_task_338276->free_mem_312838,
                                  .size =0, .references =NULL};
    struct memblock mem_312842 = {.desc ="mem_312842", .mem =
                                  futhark_mc_task_338276->free_mem_312842,
                                  .size =0, .references =NULL};
    int64_t bytes_312847 = futhark_mc_task_338276->free_bytes_312847;
    int64_t bytes_312899 = futhark_mc_task_338276->free_bytes_312899;
    struct memblock mem_313018 = {.desc ="mem_313018", .mem =
                                  futhark_mc_task_338276->free_mem_313018,
                                  .size =0, .references =NULL};
    struct memblock mem_313023 = {.desc ="mem_313023", .mem =
                                  futhark_mc_task_338276->free_mem_313023,
                                  .size =0, .references =NULL};
    struct memblock mem_313366 = {.desc ="mem_313366", .mem =
                                  futhark_mc_task_338276->free_mem_313366,
                                  .size =0, .references =NULL};
    struct memblock mem_313371 = {.desc ="mem_313371", .mem =
                                  futhark_mc_task_338276->free_mem_313371,
                                  .size =0, .references =NULL};
    struct memblock mem_314835 = {.desc ="mem_314835", .mem =
                                  futhark_mc_task_338276->free_mem_314835,
                                  .size =0, .references =NULL};
    struct memblock mem_314840 = {.desc ="mem_314840", .mem =
                                  futhark_mc_task_338276->free_mem_314840,
                                  .size =0, .references =NULL};
    int64_t iter_326496;
    struct futhark_mc_segmap_parloop_struct_338283
    futhark_mc_segmap_parloop_struct_338283;
    
    futhark_mc_segmap_parloop_struct_338283.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338283.free_n_p_292677 = n_p_292677;
    futhark_mc_segmap_parloop_struct_338283.free_q_s_292678 = q_s_292678;
    futhark_mc_segmap_parloop_struct_338283.free_jump_s_292684 = jump_s_292684;
    futhark_mc_segmap_parloop_struct_338283.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_338283.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segmap_parloop_struct_338283.free_pad_css_len_292821 =
        pad_css_len_292821;
    futhark_mc_segmap_parloop_struct_338283.free_s_n_m_292825 = s_n_m_292825;
    futhark_mc_segmap_parloop_struct_338283.free_mem_312838 = mem_312838.mem;
    futhark_mc_segmap_parloop_struct_338283.free_mem_312842 = mem_312842.mem;
    futhark_mc_segmap_parloop_struct_338283.free_bytes_312847 = bytes_312847;
    futhark_mc_segmap_parloop_struct_338283.free_bytes_312899 = bytes_312899;
    futhark_mc_segmap_parloop_struct_338283.free_mem_313018 = mem_313018.mem;
    futhark_mc_segmap_parloop_struct_338283.free_mem_313023 = mem_313023.mem;
    futhark_mc_segmap_parloop_struct_338283.free_mem_313366 = mem_313366.mem;
    futhark_mc_segmap_parloop_struct_338283.free_mem_313371 = mem_313371.mem;
    futhark_mc_segmap_parloop_struct_338283.free_mem_314835 = mem_314835.mem;
    futhark_mc_segmap_parloop_struct_338283.free_mem_314840 = mem_314840.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338284_task;
    
    futhark_mc_segmap_parloop_338284_task.name =
        "futhark_mc_segmap_parloop_338284";
    futhark_mc_segmap_parloop_338284_task.fn = futhark_mc_segmap_parloop_338284;
    futhark_mc_segmap_parloop_338284_task.args =
        &futhark_mc_segmap_parloop_struct_338283;
    futhark_mc_segmap_parloop_338284_task.iterations = iterations;
    futhark_mc_segmap_parloop_338284_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338284_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338284_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338284_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338284_task);
    
    if (futhark_mc_segmap_parloop_338284_err != 0) {
        err = futhark_mc_segmap_parloop_338284_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338284_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338284_total_end -
                 futhark_mc_segmap_parloop_338284_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338284_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338284_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338284_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_nested_task_338282_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_nested_task_338282_end -
                 futhark_mc_segmap_nested_task_338282_start;
        
        ctx->futhark_mc_segmap_nested_task_338282_runs[tid]++;
        ctx->futhark_mc_segmap_nested_task_338282_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_nested_task_338282_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_task_338320 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_jump_s_292684;
    int64_t free_partition_sizze_292766;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    unsigned char *free_ext_mem_314847;
    unsigned char *free_ext_mem_314848;
    int64_t free_bytes_314850;
    int64_t free_bytes_314869;
    unsigned char *free_mem_314922;
};
struct futhark_mc_segmap_parloop_struct_338322 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_jump_s_292684;
    int64_t free_partition_sizze_292766;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    unsigned char *free_ext_mem_314847;
    unsigned char *free_ext_mem_314848;
    int64_t free_bytes_314869;
    unsigned char *free_mem_314922;
};
static int futhark_mc_segmap_parloop_338323(void *args, int64_t start,
                                            int64_t end, int flat_tid_304408,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338322
    *futhark_mc_segmap_parloop_struct_338322 =
    (struct futhark_mc_segmap_parloop_struct_338322 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338322->ctx;
    uint64_t futhark_mc_segmap_parloop_338323_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338323_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segmap_parloop_struct_338322->free_n_p_292677;
    int64_t jump_s_292684 =
            futhark_mc_segmap_parloop_struct_338322->free_jump_s_292684;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_338322->free_partition_sizze_292766;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segmap_parloop_struct_338322->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_segmap_parloop_struct_338322->free_pad_css_len_292821;
    int64_t s_n_m_292825 =
            futhark_mc_segmap_parloop_struct_338322->free_s_n_m_292825;
    struct memblock ext_mem_314847 = {.desc ="ext_mem_314847", .mem =
                                      futhark_mc_segmap_parloop_struct_338322->free_ext_mem_314847,
                                      .size =0, .references =NULL};
    struct memblock ext_mem_314848 = {.desc ="ext_mem_314848", .mem =
                                      futhark_mc_segmap_parloop_struct_338322->free_ext_mem_314848,
                                      .size =0, .references =NULL};
    int64_t bytes_314869 =
            futhark_mc_segmap_parloop_struct_338322->free_bytes_314869;
    struct memblock mem_314922 = {.desc ="mem_314922", .mem =
                                  futhark_mc_segmap_parloop_struct_338322->free_mem_314922,
                                  .size =0, .references =NULL};
    size_t mem_314874_cached_sizze_338324 = 0;
    unsigned char *mem_314874 = NULL;
    int64_t iterations = end - start;
    int64_t iter_327603 = start;
    
    if (mem_314874_cached_sizze_338324 < (size_t) bytes_314869) {
        mem_314874 = realloc(mem_314874, bytes_314869);
        mem_314874_cached_sizze_338324 = bytes_314869;
    }
    for (; iter_327603 < end; iter_327603++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_327689 = partition_sizze_292766;
        int64_t gtid_304409 = iter_327603;
        int64_t remnant_327690 = iter_327603 - gtid_304409;
        
        for (int64_t i_327604 = 0; i_327604 < n_p_292677; i_327604++) {
            for (int64_t i_327607 = 0; i_327607 < pad_css_len_292821;
                 i_327607++) {
                bool cond_327609 = i_327607 == (int64_t) 0;
                double defunc_0_f_res_327610;
                
                if (cond_327609) {
                    bool y_327611 = slt64((int64_t) 0, s_n_m_292825);
                    bool index_certs_327612;
                    
                    if (!y_327611) {
                        ctx->error =
                            msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                      "Index [", (long long) (int64_t) 0,
                                      "] out of bounds for array of shape [",
                                      (long long) s_n_m_292825, "].",
                                      "-> #0  /prelude/array.fut:21:29-32\n   #1  loess.fut:754:12-20\n   #2  /prelude/soacs.fut:59:3-10\n   #3  /prelude/array.fut:195:3-17\n   #4  utils.fut:6:3-16\n   #5  loess.fut:752:3-761:9\n   #6  stl.fut:222:31-96\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:221:23-223:48\n   #10 /prelude/soacs.fut:67:19-23\n   #11 /prelude/soacs.fut:67:3-37\n   #12 stl.fut:220:15-224:44\n   #13 stl.fut:419:61-435:77\n   #14 stl.fut:463:3-479:36\n   #15 stl.fut:445:1-479:36\n");
                        err = FUTHARK_PROGRAM_ERROR;
                        goto cleanup;
                    }
                    
                    double head_res_327613;
                    
                    head_res_327613 =
                        ((double *) ext_mem_314848.mem)[gtid_304409 *
                                                        (s_n_m_292825 *
                                                         n_p_292677) +
                                                        i_327604 *
                                                        s_n_m_292825];
                    defunc_0_f_res_327610 = head_res_327613;
                } else {
                    int64_t y_327614 = sub64(pad_css_len_292821, (int64_t) 1);
                    bool cond_327615 = i_327607 == y_327614;
                    double defunc_0_f_res_f_res_327616;
                    
                    if (cond_327615) {
                        int64_t i_327617 = sub64(s_n_m_292825, (int64_t) 1);
                        bool x_327618 = sle64((int64_t) 0, i_327617);
                        bool y_327619 = slt64(i_327617, s_n_m_292825);
                        bool bounds_check_327620 = x_327618 && y_327619;
                        bool index_certs_327621;
                        
                        if (!bounds_check_327620) {
                            ctx->error =
                                msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                          "Index [", (long long) i_327617,
                                          "] out of bounds for array of shape [",
                                          (long long) s_n_m_292825, "].",
                                          "-> #0  /prelude/array.fut:26:29-34\n   #1  loess.fut:756:12-20\n   #2  /prelude/soacs.fut:59:3-10\n   #3  /prelude/array.fut:195:3-17\n   #4  utils.fut:6:3-16\n   #5  loess.fut:752:3-761:9\n   #6  stl.fut:222:31-96\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:221:23-223:48\n   #10 /prelude/soacs.fut:67:19-23\n   #11 /prelude/soacs.fut:67:3-37\n   #12 stl.fut:220:15-224:44\n   #13 stl.fut:419:61-435:77\n   #14 stl.fut:463:3-479:36\n   #15 stl.fut:445:1-479:36\n");
                            err = FUTHARK_PROGRAM_ERROR;
                            goto cleanup;
                        }
                        
                        double last_res_327622;
                        
                        last_res_327622 =
                            ((double *) ext_mem_314848.mem)[gtid_304409 *
                                                            (s_n_m_292825 *
                                                             n_p_292677) +
                                                            i_327604 *
                                                            s_n_m_292825 +
                                                            i_327617];
                        defunc_0_f_res_f_res_327616 = last_res_327622;
                    } else {
                        int64_t x_327623 = sub64(i_327607, (int64_t) 1);
                        bool zzero_327624 = jump_s_292684 == (int64_t) 0;
                        bool nonzzero_327625 = !zzero_327624;
                        bool nonzzero_cert_327626;
                        
                        if (!nonzzero_327625) {
                            ctx->error =
                                msgprintf("Error: %s\n\nBacktrace:\n%s",
                                          "division by zero",
                                          "-> #0  loess.fut:758:22-35\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:752:3-761:9\n   #5  stl.fut:222:31-96\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  stl.fut:221:23-223:48\n   #9  /prelude/soacs.fut:67:19-23\n   #10 /prelude/soacs.fut:67:3-37\n   #11 stl.fut:220:15-224:44\n   #12 stl.fut:419:61-435:77\n   #13 stl.fut:463:3-479:36\n   #14 stl.fut:445:1-479:36\n");
                            err = FUTHARK_PROGRAM_ERROR;
                            goto cleanup;
                        }
                        
                        int64_t x_327627 = sdiv64(x_327623, jump_s_292684);
                        int64_t m_v_327628 = add64((int64_t) 1, x_327627);
                        int64_t j_327629;
                        
                        if (cond_327609) {
                            j_327629 = (int64_t) 0;
                        } else {
                            int64_t y_327630 = sub64(s_n_m_292825, (int64_t) 1);
                            bool cond_327631 = m_v_327628 == y_327630;
                            int64_t j_f_res_327632;
                            
                            if (cond_327631) {
                                j_f_res_327632 = x_327627;
                            } else {
                                j_f_res_327632 = m_v_327628;
                            }
                            j_327629 = j_f_res_327632;
                        }
                        
                        bool cond_327633 = j_327629 == (int64_t) 0;
                        int64_t defunc_0_m_fun_res_327634;
                        
                        if (cond_327633) {
                            defunc_0_m_fun_res_327634 = (int64_t) 0;
                        } else {
                            int64_t y_327635 = sub64(s_n_m_292825, (int64_t) 1);
                            bool cond_327636 = j_327629 == y_327635;
                            int64_t defunc_0_m_fun_res_f_res_327637;
                            
                            if (cond_327636) {
                                defunc_0_m_fun_res_f_res_327637 = y_327614;
                            } else {
                                int64_t x_327638 = sub64(j_327629, (int64_t) 1);
                                int64_t x_327639 = mul64(jump_s_292684,
                                                         x_327638);
                                int64_t min_arg_327640 = add64((int64_t) 1,
                                                               x_327639);
                                int64_t min_res_327641 =
                                        smin64(defunc_0_f_res_292820,
                                               min_arg_327640);
                                
                                defunc_0_m_fun_res_f_res_327637 =
                                    min_res_327641;
                            }
                            defunc_0_m_fun_res_327634 =
                                defunc_0_m_fun_res_f_res_327637;
                        }
                        
                        int64_t defunc_0_m_fun_arg_327642 = add64((int64_t) 1,
                                                                  j_327629);
                        bool cond_327643 = defunc_0_m_fun_arg_327642 ==
                             (int64_t) 0;
                        int64_t defunc_0_m_fun_res_327644;
                        
                        if (cond_327643) {
                            defunc_0_m_fun_res_327644 = (int64_t) 0;
                        } else {
                            int64_t y_327645 = sub64(s_n_m_292825, (int64_t) 1);
                            bool cond_327646 = defunc_0_m_fun_arg_327642 ==
                                 y_327645;
                            int64_t defunc_0_m_fun_res_f_res_327647;
                            
                            if (cond_327646) {
                                defunc_0_m_fun_res_f_res_327647 = y_327614;
                            } else {
                                int64_t x_327648 = mul64(jump_s_292684,
                                                         j_327629);
                                int64_t min_arg_327649 = add64((int64_t) 1,
                                                               x_327648);
                                int64_t min_res_327650 =
                                        smin64(defunc_0_f_res_292820,
                                               min_arg_327649);
                                
                                defunc_0_m_fun_res_f_res_327647 =
                                    min_res_327650;
                            }
                            defunc_0_m_fun_res_327644 =
                                defunc_0_m_fun_res_f_res_327647;
                        }
                        
                        int64_t i64_arg_327651 =
                                sub64(defunc_0_m_fun_res_327644,
                                      defunc_0_m_fun_res_327634);
                        double i64_res_327652 = sitofp_i64_f64(i64_arg_327651);
                        int64_t i64_arg_327653 = sub64(i_327607,
                                                       defunc_0_m_fun_res_327634);
                        double i64_res_327654 = sitofp_i64_f64(i64_arg_327653);
                        double u_327655 = i64_res_327654 / i64_res_327652;
                        double u2_327656 = u_327655 * u_327655;
                        double u3_327657 = u_327655 * u2_327656;
                        double x_327658 = 2.0 * u3_327657;
                        double y_327659 = 3.0 * u2_327656;
                        double x_327660 = x_327658 - y_327659;
                        double x_327661 = 1.0 + x_327660;
                        bool x_327662 = sle64((int64_t) 0, j_327629);
                        bool y_327663 = slt64(j_327629, s_n_m_292825);
                        bool bounds_check_327664 = x_327662 && y_327663;
                        bool index_certs_327665;
                        
                        if (!bounds_check_327664) {
                            ctx->error =
                                msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                          "Index [", (long long) j_327629,
                                          "] out of bounds for array of shape [",
                                          (long long) s_n_m_292825, "].",
                                          "-> #0  loess.fut:731:27-33\n   #1  loess.fut:760:15-52\n   #2  /prelude/soacs.fut:59:3-10\n   #3  /prelude/array.fut:195:3-17\n   #4  utils.fut:6:3-16\n   #5  loess.fut:752:3-761:9\n   #6  stl.fut:222:31-96\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:221:23-223:48\n   #10 /prelude/soacs.fut:67:19-23\n   #11 /prelude/soacs.fut:67:3-37\n   #12 stl.fut:220:15-224:44\n   #13 stl.fut:419:61-435:77\n   #14 stl.fut:463:3-479:36\n   #15 stl.fut:445:1-479:36\n");
                            err = FUTHARK_PROGRAM_ERROR;
                            goto cleanup;
                        }
                        
                        double y_327666;
                        
                        y_327666 = ((double *) ext_mem_314848.mem)[gtid_304409 *
                                                                   (s_n_m_292825 *
                                                                    n_p_292677) +
                                                                   i_327604 *
                                                                   s_n_m_292825 +
                                                                   j_327629];
                        
                        double x_327667 = x_327661 * y_327666;
                        double x_327668 = y_327659 - x_327658;
                        bool x_327669 = sle64((int64_t) 0,
                                              defunc_0_m_fun_arg_327642);
                        bool y_327670 = slt64(defunc_0_m_fun_arg_327642,
                                              s_n_m_292825);
                        bool bounds_check_327671 = x_327669 && y_327670;
                        bool index_certs_327672;
                        
                        if (!bounds_check_327671) {
                            ctx->error =
                                msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                          "Index [",
                                          (long long) defunc_0_m_fun_arg_327642,
                                          "] out of bounds for array of shape [",
                                          (long long) s_n_m_292825, "].",
                                          "-> #0  loess.fut:732:27-37\n   #1  loess.fut:760:15-52\n   #2  /prelude/soacs.fut:59:3-10\n   #3  /prelude/array.fut:195:3-17\n   #4  utils.fut:6:3-16\n   #5  loess.fut:752:3-761:9\n   #6  stl.fut:222:31-96\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:221:23-223:48\n   #10 /prelude/soacs.fut:67:19-23\n   #11 /prelude/soacs.fut:67:3-37\n   #12 stl.fut:220:15-224:44\n   #13 stl.fut:419:61-435:77\n   #14 stl.fut:463:3-479:36\n   #15 stl.fut:445:1-479:36\n");
                            err = FUTHARK_PROGRAM_ERROR;
                            goto cleanup;
                        }
                        
                        double y_327673;
                        
                        y_327673 = ((double *) ext_mem_314848.mem)[gtid_304409 *
                                                                   (s_n_m_292825 *
                                                                    n_p_292677) +
                                                                   i_327604 *
                                                                   s_n_m_292825 +
                                                                   defunc_0_m_fun_arg_327642];
                        
                        double y_327674 = x_327668 * y_327673;
                        double x_327675 = x_327667 + y_327674;
                        double y_327676 = 2.0 * u2_327656;
                        double x_327677 = u3_327657 - y_327676;
                        double x_327678 = u_327655 + x_327677;
                        double y_327679;
                        
                        y_327679 = ((double *) ext_mem_314847.mem)[gtid_304409 *
                                                                   (s_n_m_292825 *
                                                                    n_p_292677) +
                                                                   i_327604 *
                                                                   s_n_m_292825 +
                                                                   j_327629];
                        
                        double x_327680 = x_327678 * y_327679;
                        double y_327681 = i64_res_327652 * x_327680;
                        double x_327682 = x_327675 + y_327681;
                        double x_327683 = u3_327657 - u2_327656;
                        double y_327684;
                        
                        y_327684 = ((double *) ext_mem_314847.mem)[gtid_304409 *
                                                                   (s_n_m_292825 *
                                                                    n_p_292677) +
                                                                   i_327604 *
                                                                   s_n_m_292825 +
                                                                   defunc_0_m_fun_arg_327642];
                        
                        double x_327685 = x_327683 * y_327684;
                        double y_327686 = i64_res_327652 * x_327685;
                        double defunc_4_interpolate_proc_res_327687 = x_327682 +
                               y_327686;
                        
                        defunc_0_f_res_f_res_327616 =
                            defunc_4_interpolate_proc_res_327687;
                    }
                    defunc_0_f_res_327610 = defunc_0_f_res_f_res_327616;
                }
                ((double *) mem_314874)[i_327604 * pad_css_len_292821 +
                                        i_327607] = defunc_0_f_res_327610;
            }
        }
        if (n_p_292677 * pad_css_len_292821 * (int64_t) 8 > 0)
            memmove(mem_314922.mem + gtid_304409 * (pad_css_len_292821 *
                                                    n_p_292677) * (int64_t) 8,
                    mem_314874 + (int64_t) 0, n_p_292677 * pad_css_len_292821 *
                    (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_314874);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338323_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338323_end -
                 futhark_mc_segmap_parloop_338323_start;
        
        ctx->futhark_mc_segmap_parloop_338323_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338323_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338323_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_338321(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_304408 = tid;
    int num_tasks_327602 = info.nsubtasks;
    struct futhark_mc_task_338320 *futhark_mc_task_338320 =
                                  (struct futhark_mc_task_338320 *) args;
    struct futhark_context *ctx = futhark_mc_task_338320->ctx;
    uint64_t futhark_mc_segmap_task_338321_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_338321_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_338320->free_n_p_292677;
    int64_t jump_s_292684 = futhark_mc_task_338320->free_jump_s_292684;
    int64_t partition_sizze_292766 =
            futhark_mc_task_338320->free_partition_sizze_292766;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_338320->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_task_338320->free_pad_css_len_292821;
    int64_t s_n_m_292825 = futhark_mc_task_338320->free_s_n_m_292825;
    struct memblock ext_mem_314847 = {.desc ="ext_mem_314847", .mem =
                                      futhark_mc_task_338320->free_ext_mem_314847,
                                      .size =0, .references =NULL};
    struct memblock ext_mem_314848 = {.desc ="ext_mem_314848", .mem =
                                      futhark_mc_task_338320->free_ext_mem_314848,
                                      .size =0, .references =NULL};
    int64_t bytes_314850 = futhark_mc_task_338320->free_bytes_314850;
    int64_t bytes_314869 = futhark_mc_task_338320->free_bytes_314869;
    struct memblock mem_314922 = {.desc ="mem_314922", .mem =
                                  futhark_mc_task_338320->free_mem_314922,
                                  .size =0, .references =NULL};
    int64_t iter_327603;
    struct futhark_mc_segmap_parloop_struct_338322
    futhark_mc_segmap_parloop_struct_338322;
    
    futhark_mc_segmap_parloop_struct_338322.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338322.free_n_p_292677 = n_p_292677;
    futhark_mc_segmap_parloop_struct_338322.free_jump_s_292684 = jump_s_292684;
    futhark_mc_segmap_parloop_struct_338322.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_338322.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segmap_parloop_struct_338322.free_pad_css_len_292821 =
        pad_css_len_292821;
    futhark_mc_segmap_parloop_struct_338322.free_s_n_m_292825 = s_n_m_292825;
    futhark_mc_segmap_parloop_struct_338322.free_ext_mem_314847 =
        ext_mem_314847.mem;
    futhark_mc_segmap_parloop_struct_338322.free_ext_mem_314848 =
        ext_mem_314848.mem;
    futhark_mc_segmap_parloop_struct_338322.free_bytes_314869 = bytes_314869;
    futhark_mc_segmap_parloop_struct_338322.free_mem_314922 = mem_314922.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338323_task;
    
    futhark_mc_segmap_parloop_338323_task.name =
        "futhark_mc_segmap_parloop_338323";
    futhark_mc_segmap_parloop_338323_task.fn = futhark_mc_segmap_parloop_338323;
    futhark_mc_segmap_parloop_338323_task.args =
        &futhark_mc_segmap_parloop_struct_338322;
    futhark_mc_segmap_parloop_338323_task.iterations = iterations;
    futhark_mc_segmap_parloop_338323_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338323_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338323_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338323_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338323_task);
    
    if (futhark_mc_segmap_parloop_338323_err != 0) {
        err = futhark_mc_segmap_parloop_338323_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338323_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338323_total_end -
                 futhark_mc_segmap_parloop_338323_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338323_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338323_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338323_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_338321_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_338321_end -
                 futhark_mc_segmap_task_338321_start;
        
        ctx->futhark_mc_segmap_task_338321_runs[tid]++;
        ctx->futhark_mc_segmap_task_338321_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_338321_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_segmap_parloop_struct_338326 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_jump_s_292684;
    int64_t free_partition_sizze_292766;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    unsigned char *free_ext_mem_314847;
    unsigned char *free_ext_mem_314848;
    int64_t free_bytes_314850;
    int64_t free_bytes_314869;
    unsigned char *free_mem_314922;
};
struct futhark_mc_task_338329 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_jump_s_292684;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    int64_t free_gtid_304506;
    unsigned char *free_ext_mem_314847;
    unsigned char *free_ext_mem_314848;
    int64_t free_bytes_314850;
    unsigned char *free_mem_314870;
};
struct futhark_mc_segmap_parloop_struct_338331 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_jump_s_292684;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    int64_t free_gtid_304506;
    unsigned char *free_ext_mem_314847;
    unsigned char *free_ext_mem_314848;
    int64_t free_bytes_314850;
    unsigned char *free_mem_314870;
};
static int futhark_mc_segmap_parloop_338332(void *args, int64_t start,
                                            int64_t end, int flat_tid_327779,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338331
    *futhark_mc_segmap_parloop_struct_338331 =
    (struct futhark_mc_segmap_parloop_struct_338331 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338331->ctx;
    uint64_t futhark_mc_segmap_parloop_338332_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338332_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segmap_parloop_struct_338331->free_n_p_292677;
    int64_t jump_s_292684 =
            futhark_mc_segmap_parloop_struct_338331->free_jump_s_292684;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segmap_parloop_struct_338331->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_segmap_parloop_struct_338331->free_pad_css_len_292821;
    int64_t s_n_m_292825 =
            futhark_mc_segmap_parloop_struct_338331->free_s_n_m_292825;
    int64_t gtid_304506 =
            futhark_mc_segmap_parloop_struct_338331->free_gtid_304506;
    struct memblock ext_mem_314847 = {.desc ="ext_mem_314847", .mem =
                                      futhark_mc_segmap_parloop_struct_338331->free_ext_mem_314847,
                                      .size =0, .references =NULL};
    struct memblock ext_mem_314848 = {.desc ="ext_mem_314848", .mem =
                                      futhark_mc_segmap_parloop_struct_338331->free_ext_mem_314848,
                                      .size =0, .references =NULL};
    int64_t bytes_314850 =
            futhark_mc_segmap_parloop_struct_338331->free_bytes_314850;
    struct memblock mem_314870 = {.desc ="mem_314870", .mem =
                                  futhark_mc_segmap_parloop_struct_338331->free_mem_314870,
                                  .size =0, .references =NULL};
    size_t mem_327781_cached_sizze_338333 = 0;
    unsigned char *mem_327781 = NULL;
    int64_t iterations = end - start;
    int64_t iter_327869 = start;
    
    if (mem_327781_cached_sizze_338333 < (size_t) bytes_314850) {
        mem_327781 = realloc(mem_327781, bytes_314850);
        mem_327781_cached_sizze_338333 = bytes_314850;
    }
    for (; iter_327869 < end; iter_327869++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_327952 = n_p_292677;
        int64_t gtid_327780 = iter_327869;
        int64_t remnant_327953 = iter_327869 - gtid_327780;
        
        for (int64_t i_327870 = 0; i_327870 < pad_css_len_292821; i_327870++) {
            bool cond_327872 = i_327870 == (int64_t) 0;
            double defunc_0_f_res_327873;
            
            if (cond_327872) {
                bool y_327874 = slt64((int64_t) 0, s_n_m_292825);
                bool index_certs_327875;
                
                if (!y_327874) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [", (long long) (int64_t) 0,
                                  "] out of bounds for array of shape [",
                                  (long long) s_n_m_292825, "].",
                                  "-> #0  /prelude/array.fut:21:29-32\n   #1  loess.fut:754:12-20\n   #2  /prelude/soacs.fut:59:3-10\n   #3  /prelude/array.fut:195:3-17\n   #4  utils.fut:6:3-16\n   #5  loess.fut:752:3-761:9\n   #6  stl.fut:222:31-96\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:221:23-223:48\n   #10 /prelude/soacs.fut:67:19-23\n   #11 /prelude/soacs.fut:67:3-37\n   #12 stl.fut:220:15-224:44\n   #13 stl.fut:419:61-435:77\n   #14 stl.fut:463:3-479:36\n   #15 stl.fut:445:1-479:36\n");
                    err = FUTHARK_PROGRAM_ERROR;
                    goto cleanup;
                }
                
                double head_res_327876;
                
                head_res_327876 = ((double *) ext_mem_314848.mem)[gtid_304506 *
                                                                  (s_n_m_292825 *
                                                                   n_p_292677) +
                                                                  gtid_327780 *
                                                                  s_n_m_292825];
                defunc_0_f_res_327873 = head_res_327876;
            } else {
                int64_t y_327877 = sub64(pad_css_len_292821, (int64_t) 1);
                bool cond_327878 = i_327870 == y_327877;
                double defunc_0_f_res_f_res_327879;
                
                if (cond_327878) {
                    int64_t i_327880 = sub64(s_n_m_292825, (int64_t) 1);
                    bool x_327881 = sle64((int64_t) 0, i_327880);
                    bool y_327882 = slt64(i_327880, s_n_m_292825);
                    bool bounds_check_327883 = x_327881 && y_327882;
                    bool index_certs_327884;
                    
                    if (!bounds_check_327883) {
                        ctx->error =
                            msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                      "Index [", (long long) i_327880,
                                      "] out of bounds for array of shape [",
                                      (long long) s_n_m_292825, "].",
                                      "-> #0  /prelude/array.fut:26:29-34\n   #1  loess.fut:756:12-20\n   #2  /prelude/soacs.fut:59:3-10\n   #3  /prelude/array.fut:195:3-17\n   #4  utils.fut:6:3-16\n   #5  loess.fut:752:3-761:9\n   #6  stl.fut:222:31-96\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:221:23-223:48\n   #10 /prelude/soacs.fut:67:19-23\n   #11 /prelude/soacs.fut:67:3-37\n   #12 stl.fut:220:15-224:44\n   #13 stl.fut:419:61-435:77\n   #14 stl.fut:463:3-479:36\n   #15 stl.fut:445:1-479:36\n");
                        err = FUTHARK_PROGRAM_ERROR;
                        goto cleanup;
                    }
                    
                    double last_res_327885;
                    
                    last_res_327885 =
                        ((double *) ext_mem_314848.mem)[gtid_304506 *
                                                        (s_n_m_292825 *
                                                         n_p_292677) +
                                                        gtid_327780 *
                                                        s_n_m_292825 +
                                                        i_327880];
                    defunc_0_f_res_f_res_327879 = last_res_327885;
                } else {
                    int64_t x_327886 = sub64(i_327870, (int64_t) 1);
                    bool zzero_327887 = jump_s_292684 == (int64_t) 0;
                    bool nonzzero_327888 = !zzero_327887;
                    bool nonzzero_cert_327889;
                    
                    if (!nonzzero_327888) {
                        ctx->error = msgprintf("Error: %s\n\nBacktrace:\n%s",
                                               "division by zero",
                                               "-> #0  loess.fut:758:22-35\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:752:3-761:9\n   #5  stl.fut:222:31-96\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  stl.fut:221:23-223:48\n   #9  /prelude/soacs.fut:67:19-23\n   #10 /prelude/soacs.fut:67:3-37\n   #11 stl.fut:220:15-224:44\n   #12 stl.fut:419:61-435:77\n   #13 stl.fut:463:3-479:36\n   #14 stl.fut:445:1-479:36\n");
                        err = FUTHARK_PROGRAM_ERROR;
                        goto cleanup;
                    }
                    
                    int64_t x_327890 = sdiv64(x_327886, jump_s_292684);
                    int64_t m_v_327891 = add64((int64_t) 1, x_327890);
                    int64_t j_327892;
                    
                    if (cond_327872) {
                        j_327892 = (int64_t) 0;
                    } else {
                        int64_t y_327893 = sub64(s_n_m_292825, (int64_t) 1);
                        bool cond_327894 = m_v_327891 == y_327893;
                        int64_t j_f_res_327895;
                        
                        if (cond_327894) {
                            j_f_res_327895 = x_327890;
                        } else {
                            j_f_res_327895 = m_v_327891;
                        }
                        j_327892 = j_f_res_327895;
                    }
                    
                    bool cond_327896 = j_327892 == (int64_t) 0;
                    int64_t defunc_0_m_fun_res_327897;
                    
                    if (cond_327896) {
                        defunc_0_m_fun_res_327897 = (int64_t) 0;
                    } else {
                        int64_t y_327898 = sub64(s_n_m_292825, (int64_t) 1);
                        bool cond_327899 = j_327892 == y_327898;
                        int64_t defunc_0_m_fun_res_f_res_327900;
                        
                        if (cond_327899) {
                            defunc_0_m_fun_res_f_res_327900 = y_327877;
                        } else {
                            int64_t x_327901 = sub64(j_327892, (int64_t) 1);
                            int64_t x_327902 = mul64(jump_s_292684, x_327901);
                            int64_t min_arg_327903 = add64((int64_t) 1,
                                                           x_327902);
                            int64_t min_res_327904 =
                                    smin64(defunc_0_f_res_292820,
                                           min_arg_327903);
                            
                            defunc_0_m_fun_res_f_res_327900 = min_res_327904;
                        }
                        defunc_0_m_fun_res_327897 =
                            defunc_0_m_fun_res_f_res_327900;
                    }
                    
                    int64_t defunc_0_m_fun_arg_327905 = add64((int64_t) 1,
                                                              j_327892);
                    bool cond_327906 = defunc_0_m_fun_arg_327905 == (int64_t) 0;
                    int64_t defunc_0_m_fun_res_327907;
                    
                    if (cond_327906) {
                        defunc_0_m_fun_res_327907 = (int64_t) 0;
                    } else {
                        int64_t y_327908 = sub64(s_n_m_292825, (int64_t) 1);
                        bool cond_327909 = defunc_0_m_fun_arg_327905 ==
                             y_327908;
                        int64_t defunc_0_m_fun_res_f_res_327910;
                        
                        if (cond_327909) {
                            defunc_0_m_fun_res_f_res_327910 = y_327877;
                        } else {
                            int64_t x_327911 = mul64(jump_s_292684, j_327892);
                            int64_t min_arg_327912 = add64((int64_t) 1,
                                                           x_327911);
                            int64_t min_res_327913 =
                                    smin64(defunc_0_f_res_292820,
                                           min_arg_327912);
                            
                            defunc_0_m_fun_res_f_res_327910 = min_res_327913;
                        }
                        defunc_0_m_fun_res_327907 =
                            defunc_0_m_fun_res_f_res_327910;
                    }
                    
                    int64_t i64_arg_327914 = sub64(defunc_0_m_fun_res_327907,
                                                   defunc_0_m_fun_res_327897);
                    double i64_res_327915 = sitofp_i64_f64(i64_arg_327914);
                    int64_t i64_arg_327916 = sub64(i_327870,
                                                   defunc_0_m_fun_res_327897);
                    double i64_res_327917 = sitofp_i64_f64(i64_arg_327916);
                    double u_327918 = i64_res_327917 / i64_res_327915;
                    double u2_327919 = u_327918 * u_327918;
                    double u3_327920 = u_327918 * u2_327919;
                    double x_327921 = 2.0 * u3_327920;
                    double y_327922 = 3.0 * u2_327919;
                    double x_327923 = x_327921 - y_327922;
                    double x_327924 = 1.0 + x_327923;
                    bool x_327925 = sle64((int64_t) 0, j_327892);
                    bool y_327926 = slt64(j_327892, s_n_m_292825);
                    bool bounds_check_327927 = x_327925 && y_327926;
                    bool index_certs_327928;
                    
                    if (!bounds_check_327927) {
                        ctx->error =
                            msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                      "Index [", (long long) j_327892,
                                      "] out of bounds for array of shape [",
                                      (long long) s_n_m_292825, "].",
                                      "-> #0  loess.fut:731:27-33\n   #1  loess.fut:760:15-52\n   #2  /prelude/soacs.fut:59:3-10\n   #3  /prelude/array.fut:195:3-17\n   #4  utils.fut:6:3-16\n   #5  loess.fut:752:3-761:9\n   #6  stl.fut:222:31-96\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:221:23-223:48\n   #10 /prelude/soacs.fut:67:19-23\n   #11 /prelude/soacs.fut:67:3-37\n   #12 stl.fut:220:15-224:44\n   #13 stl.fut:419:61-435:77\n   #14 stl.fut:463:3-479:36\n   #15 stl.fut:445:1-479:36\n");
                        err = FUTHARK_PROGRAM_ERROR;
                        goto cleanup;
                    }
                    
                    double y_327929;
                    
                    y_327929 = ((double *) ext_mem_314848.mem)[gtid_304506 *
                                                               (s_n_m_292825 *
                                                                n_p_292677) +
                                                               gtid_327780 *
                                                               s_n_m_292825 +
                                                               j_327892];
                    
                    double x_327930 = x_327924 * y_327929;
                    double x_327931 = y_327922 - x_327921;
                    bool x_327932 = sle64((int64_t) 0,
                                          defunc_0_m_fun_arg_327905);
                    bool y_327933 = slt64(defunc_0_m_fun_arg_327905,
                                          s_n_m_292825);
                    bool bounds_check_327934 = x_327932 && y_327933;
                    bool index_certs_327935;
                    
                    if (!bounds_check_327934) {
                        ctx->error =
                            msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                      "Index [",
                                      (long long) defunc_0_m_fun_arg_327905,
                                      "] out of bounds for array of shape [",
                                      (long long) s_n_m_292825, "].",
                                      "-> #0  loess.fut:732:27-37\n   #1  loess.fut:760:15-52\n   #2  /prelude/soacs.fut:59:3-10\n   #3  /prelude/array.fut:195:3-17\n   #4  utils.fut:6:3-16\n   #5  loess.fut:752:3-761:9\n   #6  stl.fut:222:31-96\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:221:23-223:48\n   #10 /prelude/soacs.fut:67:19-23\n   #11 /prelude/soacs.fut:67:3-37\n   #12 stl.fut:220:15-224:44\n   #13 stl.fut:419:61-435:77\n   #14 stl.fut:463:3-479:36\n   #15 stl.fut:445:1-479:36\n");
                        err = FUTHARK_PROGRAM_ERROR;
                        goto cleanup;
                    }
                    
                    double y_327936;
                    
                    y_327936 = ((double *) ext_mem_314848.mem)[gtid_304506 *
                                                               (s_n_m_292825 *
                                                                n_p_292677) +
                                                               gtid_327780 *
                                                               s_n_m_292825 +
                                                               defunc_0_m_fun_arg_327905];
                    
                    double y_327937 = x_327931 * y_327936;
                    double x_327938 = x_327930 + y_327937;
                    double y_327939 = 2.0 * u2_327919;
                    double x_327940 = u3_327920 - y_327939;
                    double x_327941 = u_327918 + x_327940;
                    double y_327942;
                    
                    y_327942 = ((double *) ext_mem_314847.mem)[gtid_304506 *
                                                               (s_n_m_292825 *
                                                                n_p_292677) +
                                                               gtid_327780 *
                                                               s_n_m_292825 +
                                                               j_327892];
                    
                    double x_327943 = x_327941 * y_327942;
                    double y_327944 = i64_res_327915 * x_327943;
                    double x_327945 = x_327938 + y_327944;
                    double x_327946 = u3_327920 - u2_327919;
                    double y_327947;
                    
                    y_327947 = ((double *) ext_mem_314847.mem)[gtid_304506 *
                                                               (s_n_m_292825 *
                                                                n_p_292677) +
                                                               gtid_327780 *
                                                               s_n_m_292825 +
                                                               defunc_0_m_fun_arg_327905];
                    
                    double x_327948 = x_327946 * y_327947;
                    double y_327949 = i64_res_327915 * x_327948;
                    double defunc_4_interpolate_proc_res_327950 = x_327945 +
                           y_327949;
                    
                    defunc_0_f_res_f_res_327879 =
                        defunc_4_interpolate_proc_res_327950;
                }
                defunc_0_f_res_327873 = defunc_0_f_res_f_res_327879;
            }
            ((double *) mem_327781)[i_327870] = defunc_0_f_res_327873;
        }
        if (pad_css_len_292821 * (int64_t) 8 > 0)
            memmove(mem_314870.mem + gtid_327780 * pad_css_len_292821 *
                    (int64_t) 8, mem_327781 + (int64_t) 0, pad_css_len_292821 *
                    (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_327781);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338332_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338332_end -
                 futhark_mc_segmap_parloop_338332_start;
        
        ctx->futhark_mc_segmap_parloop_338332_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338332_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338332_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_338330(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_327779 = tid;
    int num_tasks_327868 = info.nsubtasks;
    struct futhark_mc_task_338329 *futhark_mc_task_338329 =
                                  (struct futhark_mc_task_338329 *) args;
    struct futhark_context *ctx = futhark_mc_task_338329->ctx;
    uint64_t futhark_mc_segmap_task_338330_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_338330_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_338329->free_n_p_292677;
    int64_t jump_s_292684 = futhark_mc_task_338329->free_jump_s_292684;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_338329->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_task_338329->free_pad_css_len_292821;
    int64_t s_n_m_292825 = futhark_mc_task_338329->free_s_n_m_292825;
    int64_t gtid_304506 = futhark_mc_task_338329->free_gtid_304506;
    struct memblock ext_mem_314847 = {.desc ="ext_mem_314847", .mem =
                                      futhark_mc_task_338329->free_ext_mem_314847,
                                      .size =0, .references =NULL};
    struct memblock ext_mem_314848 = {.desc ="ext_mem_314848", .mem =
                                      futhark_mc_task_338329->free_ext_mem_314848,
                                      .size =0, .references =NULL};
    int64_t bytes_314850 = futhark_mc_task_338329->free_bytes_314850;
    struct memblock mem_314870 = {.desc ="mem_314870", .mem =
                                  futhark_mc_task_338329->free_mem_314870,
                                  .size =0, .references =NULL};
    int64_t iter_327869;
    struct futhark_mc_segmap_parloop_struct_338331
    futhark_mc_segmap_parloop_struct_338331;
    
    futhark_mc_segmap_parloop_struct_338331.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338331.free_n_p_292677 = n_p_292677;
    futhark_mc_segmap_parloop_struct_338331.free_jump_s_292684 = jump_s_292684;
    futhark_mc_segmap_parloop_struct_338331.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segmap_parloop_struct_338331.free_pad_css_len_292821 =
        pad_css_len_292821;
    futhark_mc_segmap_parloop_struct_338331.free_s_n_m_292825 = s_n_m_292825;
    futhark_mc_segmap_parloop_struct_338331.free_gtid_304506 = gtid_304506;
    futhark_mc_segmap_parloop_struct_338331.free_ext_mem_314847 =
        ext_mem_314847.mem;
    futhark_mc_segmap_parloop_struct_338331.free_ext_mem_314848 =
        ext_mem_314848.mem;
    futhark_mc_segmap_parloop_struct_338331.free_bytes_314850 = bytes_314850;
    futhark_mc_segmap_parloop_struct_338331.free_mem_314870 = mem_314870.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338332_task;
    
    futhark_mc_segmap_parloop_338332_task.name =
        "futhark_mc_segmap_parloop_338332";
    futhark_mc_segmap_parloop_338332_task.fn = futhark_mc_segmap_parloop_338332;
    futhark_mc_segmap_parloop_338332_task.args =
        &futhark_mc_segmap_parloop_struct_338331;
    futhark_mc_segmap_parloop_338332_task.iterations = iterations;
    futhark_mc_segmap_parloop_338332_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338332_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338332_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338332_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338332_task);
    
    if (futhark_mc_segmap_parloop_338332_err != 0) {
        err = futhark_mc_segmap_parloop_338332_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338332_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338332_total_end -
                 futhark_mc_segmap_parloop_338332_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338332_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338332_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338332_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_338330_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_338330_end -
                 futhark_mc_segmap_task_338330_start;
        
        ctx->futhark_mc_segmap_task_338330_runs[tid]++;
        ctx->futhark_mc_segmap_task_338330_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_338330_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_segmap_parloop_struct_338335 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_jump_s_292684;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    int64_t free_gtid_304506;
    unsigned char *free_ext_mem_314847;
    unsigned char *free_ext_mem_314848;
    int64_t free_bytes_314850;
    unsigned char *free_mem_314870;
};
struct futhark_mc_task_338338 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_jump_s_292684;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    int64_t free_gtid_304506;
    unsigned char *free_ext_mem_314847;
    unsigned char *free_ext_mem_314848;
    int64_t free_gtid_327695;
    unsigned char *free_mem_327696;
};
struct futhark_mc_segmap_parloop_struct_338340 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_jump_s_292684;
    int64_t free_defunc_0_f_res_292820;
    int64_t free_pad_css_len_292821;
    int64_t free_s_n_m_292825;
    int64_t free_gtid_304506;
    unsigned char *free_ext_mem_314847;
    unsigned char *free_ext_mem_314848;
    int64_t free_gtid_327695;
    unsigned char *free_mem_327696;
};
static int futhark_mc_segmap_parloop_338341(void *args, int64_t start,
                                            int64_t end, int flat_tid_327956,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338340
    *futhark_mc_segmap_parloop_struct_338340 =
    (struct futhark_mc_segmap_parloop_struct_338340 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338340->ctx;
    uint64_t futhark_mc_segmap_parloop_338341_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338341_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segmap_parloop_struct_338340->free_n_p_292677;
    int64_t jump_s_292684 =
            futhark_mc_segmap_parloop_struct_338340->free_jump_s_292684;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segmap_parloop_struct_338340->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_segmap_parloop_struct_338340->free_pad_css_len_292821;
    int64_t s_n_m_292825 =
            futhark_mc_segmap_parloop_struct_338340->free_s_n_m_292825;
    int64_t gtid_304506 =
            futhark_mc_segmap_parloop_struct_338340->free_gtid_304506;
    struct memblock ext_mem_314847 = {.desc ="ext_mem_314847", .mem =
                                      futhark_mc_segmap_parloop_struct_338340->free_ext_mem_314847,
                                      .size =0, .references =NULL};
    struct memblock ext_mem_314848 = {.desc ="ext_mem_314848", .mem =
                                      futhark_mc_segmap_parloop_struct_338340->free_ext_mem_314848,
                                      .size =0, .references =NULL};
    int64_t gtid_327695 =
            futhark_mc_segmap_parloop_struct_338340->free_gtid_327695;
    struct memblock mem_327696 = {.desc ="mem_327696", .mem =
                                  futhark_mc_segmap_parloop_struct_338340->free_mem_327696,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_328040 = start;
    
    for (; iter_328040 < end; iter_328040++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_328118 = pad_css_len_292821;
        int64_t gtid_327957 = iter_328040;
        int64_t remnant_328119 = iter_328040 - gtid_327957;
        bool cond_327958 = gtid_327957 == (int64_t) 0;
        double defunc_0_f_res_327959;
        
        if (cond_327958) {
            bool y_328041 = slt64((int64_t) 0, s_n_m_292825);
            bool index_certs_328042;
            
            if (!y_328041) {
                ctx->error =
                    msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                              "Index [", (long long) (int64_t) 0,
                              "] out of bounds for array of shape [",
                              (long long) s_n_m_292825, "].",
                              "-> #0  /prelude/array.fut:21:29-32\n   #1  loess.fut:754:12-20\n   #2  /prelude/soacs.fut:59:3-10\n   #3  /prelude/array.fut:195:3-17\n   #4  utils.fut:6:3-16\n   #5  loess.fut:752:3-761:9\n   #6  stl.fut:222:31-96\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:221:23-223:48\n   #10 /prelude/soacs.fut:67:19-23\n   #11 /prelude/soacs.fut:67:3-37\n   #12 stl.fut:220:15-224:44\n   #13 stl.fut:419:61-435:77\n   #14 stl.fut:463:3-479:36\n   #15 stl.fut:445:1-479:36\n");
                err = FUTHARK_PROGRAM_ERROR;
                goto cleanup;
            }
            
            double head_res_328043;
            
            head_res_328043 = ((double *) ext_mem_314848.mem)[gtid_304506 *
                                                              (s_n_m_292825 *
                                                               n_p_292677) +
                                                              gtid_327695 *
                                                              s_n_m_292825];
            defunc_0_f_res_327959 = head_res_328043;
        } else {
            int64_t y_328044 = sub64(pad_css_len_292821, (int64_t) 1);
            bool cond_328045 = gtid_327957 == y_328044;
            double defunc_0_f_res_f_res_328046;
            
            if (cond_328045) {
                int64_t i_328047 = sub64(s_n_m_292825, (int64_t) 1);
                bool x_328048 = sle64((int64_t) 0, i_328047);
                bool y_328049 = slt64(i_328047, s_n_m_292825);
                bool bounds_check_328050 = x_328048 && y_328049;
                bool index_certs_328051;
                
                if (!bounds_check_328050) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [", (long long) i_328047,
                                  "] out of bounds for array of shape [",
                                  (long long) s_n_m_292825, "].",
                                  "-> #0  /prelude/array.fut:26:29-34\n   #1  loess.fut:756:12-20\n   #2  /prelude/soacs.fut:59:3-10\n   #3  /prelude/array.fut:195:3-17\n   #4  utils.fut:6:3-16\n   #5  loess.fut:752:3-761:9\n   #6  stl.fut:222:31-96\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:221:23-223:48\n   #10 /prelude/soacs.fut:67:19-23\n   #11 /prelude/soacs.fut:67:3-37\n   #12 stl.fut:220:15-224:44\n   #13 stl.fut:419:61-435:77\n   #14 stl.fut:463:3-479:36\n   #15 stl.fut:445:1-479:36\n");
                    err = FUTHARK_PROGRAM_ERROR;
                    goto cleanup;
                }
                
                double last_res_328052;
                
                last_res_328052 = ((double *) ext_mem_314848.mem)[gtid_304506 *
                                                                  (s_n_m_292825 *
                                                                   n_p_292677) +
                                                                  gtid_327695 *
                                                                  s_n_m_292825 +
                                                                  i_328047];
                defunc_0_f_res_f_res_328046 = last_res_328052;
            } else {
                int64_t x_328053 = sub64(gtid_327957, (int64_t) 1);
                bool zzero_328054 = jump_s_292684 == (int64_t) 0;
                bool nonzzero_328055 = !zzero_328054;
                bool nonzzero_cert_328056;
                
                if (!nonzzero_328055) {
                    ctx->error = msgprintf("Error: %s\n\nBacktrace:\n%s",
                                           "division by zero",
                                           "-> #0  loess.fut:758:22-35\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:752:3-761:9\n   #5  stl.fut:222:31-96\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  stl.fut:221:23-223:48\n   #9  /prelude/soacs.fut:67:19-23\n   #10 /prelude/soacs.fut:67:3-37\n   #11 stl.fut:220:15-224:44\n   #12 stl.fut:419:61-435:77\n   #13 stl.fut:463:3-479:36\n   #14 stl.fut:445:1-479:36\n");
                    err = FUTHARK_PROGRAM_ERROR;
                    goto cleanup;
                }
                
                int64_t x_328057 = sdiv64(x_328053, jump_s_292684);
                int64_t m_v_328058 = add64((int64_t) 1, x_328057);
                int64_t j_328059;
                
                if (cond_327958) {
                    j_328059 = (int64_t) 0;
                } else {
                    int64_t y_328060 = sub64(s_n_m_292825, (int64_t) 1);
                    bool cond_328061 = m_v_328058 == y_328060;
                    int64_t j_f_res_328062;
                    
                    if (cond_328061) {
                        j_f_res_328062 = x_328057;
                    } else {
                        j_f_res_328062 = m_v_328058;
                    }
                    j_328059 = j_f_res_328062;
                }
                
                bool cond_328063 = j_328059 == (int64_t) 0;
                int64_t defunc_0_m_fun_res_328064;
                
                if (cond_328063) {
                    defunc_0_m_fun_res_328064 = (int64_t) 0;
                } else {
                    int64_t y_328065 = sub64(s_n_m_292825, (int64_t) 1);
                    bool cond_328066 = j_328059 == y_328065;
                    int64_t defunc_0_m_fun_res_f_res_328067;
                    
                    if (cond_328066) {
                        defunc_0_m_fun_res_f_res_328067 = y_328044;
                    } else {
                        int64_t x_328068 = sub64(j_328059, (int64_t) 1);
                        int64_t x_328069 = mul64(jump_s_292684, x_328068);
                        int64_t min_arg_328070 = add64((int64_t) 1, x_328069);
                        int64_t min_res_328071 = smin64(defunc_0_f_res_292820,
                                                        min_arg_328070);
                        
                        defunc_0_m_fun_res_f_res_328067 = min_res_328071;
                    }
                    defunc_0_m_fun_res_328064 = defunc_0_m_fun_res_f_res_328067;
                }
                
                int64_t defunc_0_m_fun_arg_328072 = add64((int64_t) 1,
                                                          j_328059);
                bool cond_328073 = defunc_0_m_fun_arg_328072 == (int64_t) 0;
                int64_t defunc_0_m_fun_res_328074;
                
                if (cond_328073) {
                    defunc_0_m_fun_res_328074 = (int64_t) 0;
                } else {
                    int64_t y_328075 = sub64(s_n_m_292825, (int64_t) 1);
                    bool cond_328076 = defunc_0_m_fun_arg_328072 == y_328075;
                    int64_t defunc_0_m_fun_res_f_res_328077;
                    
                    if (cond_328076) {
                        defunc_0_m_fun_res_f_res_328077 = y_328044;
                    } else {
                        int64_t x_328078 = mul64(jump_s_292684, j_328059);
                        int64_t min_arg_328079 = add64((int64_t) 1, x_328078);
                        int64_t min_res_328080 = smin64(defunc_0_f_res_292820,
                                                        min_arg_328079);
                        
                        defunc_0_m_fun_res_f_res_328077 = min_res_328080;
                    }
                    defunc_0_m_fun_res_328074 = defunc_0_m_fun_res_f_res_328077;
                }
                
                int64_t i64_arg_328081 = sub64(defunc_0_m_fun_res_328074,
                                               defunc_0_m_fun_res_328064);
                double i64_res_328082 = sitofp_i64_f64(i64_arg_328081);
                int64_t i64_arg_328083 = sub64(gtid_327957,
                                               defunc_0_m_fun_res_328064);
                double i64_res_328084 = sitofp_i64_f64(i64_arg_328083);
                double u_328085 = i64_res_328084 / i64_res_328082;
                double u2_328086 = u_328085 * u_328085;
                double u3_328087 = u_328085 * u2_328086;
                double x_328088 = 2.0 * u3_328087;
                double y_328089 = 3.0 * u2_328086;
                double x_328090 = x_328088 - y_328089;
                double x_328091 = 1.0 + x_328090;
                bool x_328092 = sle64((int64_t) 0, j_328059);
                bool y_328093 = slt64(j_328059, s_n_m_292825);
                bool bounds_check_328094 = x_328092 && y_328093;
                bool index_certs_328095;
                
                if (!bounds_check_328094) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [", (long long) j_328059,
                                  "] out of bounds for array of shape [",
                                  (long long) s_n_m_292825, "].",
                                  "-> #0  loess.fut:731:27-33\n   #1  loess.fut:760:15-52\n   #2  /prelude/soacs.fut:59:3-10\n   #3  /prelude/array.fut:195:3-17\n   #4  utils.fut:6:3-16\n   #5  loess.fut:752:3-761:9\n   #6  stl.fut:222:31-96\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:221:23-223:48\n   #10 /prelude/soacs.fut:67:19-23\n   #11 /prelude/soacs.fut:67:3-37\n   #12 stl.fut:220:15-224:44\n   #13 stl.fut:419:61-435:77\n   #14 stl.fut:463:3-479:36\n   #15 stl.fut:445:1-479:36\n");
                    err = FUTHARK_PROGRAM_ERROR;
                    goto cleanup;
                }
                
                double y_328096;
                
                y_328096 = ((double *) ext_mem_314848.mem)[gtid_304506 *
                                                           (s_n_m_292825 *
                                                            n_p_292677) +
                                                           gtid_327695 *
                                                           s_n_m_292825 +
                                                           j_328059];
                
                double x_328097 = x_328091 * y_328096;
                double x_328098 = y_328089 - x_328088;
                bool x_328099 = sle64((int64_t) 0, defunc_0_m_fun_arg_328072);
                bool y_328100 = slt64(defunc_0_m_fun_arg_328072, s_n_m_292825);
                bool bounds_check_328101 = x_328099 && y_328100;
                bool index_certs_328102;
                
                if (!bounds_check_328101) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [",
                                  (long long) defunc_0_m_fun_arg_328072,
                                  "] out of bounds for array of shape [",
                                  (long long) s_n_m_292825, "].",
                                  "-> #0  loess.fut:732:27-37\n   #1  loess.fut:760:15-52\n   #2  /prelude/soacs.fut:59:3-10\n   #3  /prelude/array.fut:195:3-17\n   #4  utils.fut:6:3-16\n   #5  loess.fut:752:3-761:9\n   #6  stl.fut:222:31-96\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:221:23-223:48\n   #10 /prelude/soacs.fut:67:19-23\n   #11 /prelude/soacs.fut:67:3-37\n   #12 stl.fut:220:15-224:44\n   #13 stl.fut:419:61-435:77\n   #14 stl.fut:463:3-479:36\n   #15 stl.fut:445:1-479:36\n");
                    err = FUTHARK_PROGRAM_ERROR;
                    goto cleanup;
                }
                
                double y_328103;
                
                y_328103 = ((double *) ext_mem_314848.mem)[gtid_304506 *
                                                           (s_n_m_292825 *
                                                            n_p_292677) +
                                                           gtid_327695 *
                                                           s_n_m_292825 +
                                                           defunc_0_m_fun_arg_328072];
                
                double y_328104 = x_328098 * y_328103;
                double x_328105 = x_328097 + y_328104;
                double y_328106 = 2.0 * u2_328086;
                double x_328107 = u3_328087 - y_328106;
                double x_328108 = u_328085 + x_328107;
                double y_328109;
                
                y_328109 = ((double *) ext_mem_314847.mem)[gtid_304506 *
                                                           (s_n_m_292825 *
                                                            n_p_292677) +
                                                           gtid_327695 *
                                                           s_n_m_292825 +
                                                           j_328059];
                
                double x_328110 = x_328108 * y_328109;
                double y_328111 = i64_res_328082 * x_328110;
                double x_328112 = x_328105 + y_328111;
                double x_328113 = u3_328087 - u2_328086;
                double y_328114;
                
                y_328114 = ((double *) ext_mem_314847.mem)[gtid_304506 *
                                                           (s_n_m_292825 *
                                                            n_p_292677) +
                                                           gtid_327695 *
                                                           s_n_m_292825 +
                                                           defunc_0_m_fun_arg_328072];
                
                double x_328115 = x_328113 * y_328114;
                double y_328116 = i64_res_328082 * x_328115;
                double defunc_4_interpolate_proc_res_328117 = x_328112 +
                       y_328116;
                
                defunc_0_f_res_f_res_328046 =
                    defunc_4_interpolate_proc_res_328117;
            }
            defunc_0_f_res_327959 = defunc_0_f_res_f_res_328046;
        }
        ((double *) mem_327696.mem)[gtid_327957] = defunc_0_f_res_327959;
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338341_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338341_end -
                 futhark_mc_segmap_parloop_338341_start;
        
        ctx->futhark_mc_segmap_parloop_338341_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338341_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338341_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_338339(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_327956 = tid;
    int num_tasks_328039 = info.nsubtasks;
    struct futhark_mc_task_338338 *futhark_mc_task_338338 =
                                  (struct futhark_mc_task_338338 *) args;
    struct futhark_context *ctx = futhark_mc_task_338338->ctx;
    uint64_t futhark_mc_segmap_task_338339_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_338339_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_338338->free_n_p_292677;
    int64_t jump_s_292684 = futhark_mc_task_338338->free_jump_s_292684;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_338338->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_task_338338->free_pad_css_len_292821;
    int64_t s_n_m_292825 = futhark_mc_task_338338->free_s_n_m_292825;
    int64_t gtid_304506 = futhark_mc_task_338338->free_gtid_304506;
    struct memblock ext_mem_314847 = {.desc ="ext_mem_314847", .mem =
                                      futhark_mc_task_338338->free_ext_mem_314847,
                                      .size =0, .references =NULL};
    struct memblock ext_mem_314848 = {.desc ="ext_mem_314848", .mem =
                                      futhark_mc_task_338338->free_ext_mem_314848,
                                      .size =0, .references =NULL};
    int64_t gtid_327695 = futhark_mc_task_338338->free_gtid_327695;
    struct memblock mem_327696 = {.desc ="mem_327696", .mem =
                                  futhark_mc_task_338338->free_mem_327696,
                                  .size =0, .references =NULL};
    int64_t iter_328040;
    struct futhark_mc_segmap_parloop_struct_338340
    futhark_mc_segmap_parloop_struct_338340;
    
    futhark_mc_segmap_parloop_struct_338340.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338340.free_n_p_292677 = n_p_292677;
    futhark_mc_segmap_parloop_struct_338340.free_jump_s_292684 = jump_s_292684;
    futhark_mc_segmap_parloop_struct_338340.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segmap_parloop_struct_338340.free_pad_css_len_292821 =
        pad_css_len_292821;
    futhark_mc_segmap_parloop_struct_338340.free_s_n_m_292825 = s_n_m_292825;
    futhark_mc_segmap_parloop_struct_338340.free_gtid_304506 = gtid_304506;
    futhark_mc_segmap_parloop_struct_338340.free_ext_mem_314847 =
        ext_mem_314847.mem;
    futhark_mc_segmap_parloop_struct_338340.free_ext_mem_314848 =
        ext_mem_314848.mem;
    futhark_mc_segmap_parloop_struct_338340.free_gtid_327695 = gtid_327695;
    futhark_mc_segmap_parloop_struct_338340.free_mem_327696 = mem_327696.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338341_task;
    
    futhark_mc_segmap_parloop_338341_task.name =
        "futhark_mc_segmap_parloop_338341";
    futhark_mc_segmap_parloop_338341_task.fn = futhark_mc_segmap_parloop_338341;
    futhark_mc_segmap_parloop_338341_task.args =
        &futhark_mc_segmap_parloop_struct_338340;
    futhark_mc_segmap_parloop_338341_task.iterations = iterations;
    futhark_mc_segmap_parloop_338341_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338341_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338341_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338341_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338341_task);
    
    if (futhark_mc_segmap_parloop_338341_err != 0) {
        err = futhark_mc_segmap_parloop_338341_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338341_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338341_total_end -
                 futhark_mc_segmap_parloop_338341_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338341_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338341_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338341_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_338339_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_338339_end -
                 futhark_mc_segmap_task_338339_start;
        
        ctx->futhark_mc_segmap_task_338339_runs[tid]++;
        ctx->futhark_mc_segmap_task_338339_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_338339_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
static int futhark_mc_segmap_parloop_338336(void *args, int64_t start,
                                            int64_t end, int flat_tid_327694,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338335
    *futhark_mc_segmap_parloop_struct_338335 =
    (struct futhark_mc_segmap_parloop_struct_338335 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338335->ctx;
    uint64_t futhark_mc_segmap_parloop_338336_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338336_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segmap_parloop_struct_338335->free_n_p_292677;
    int64_t jump_s_292684 =
            futhark_mc_segmap_parloop_struct_338335->free_jump_s_292684;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segmap_parloop_struct_338335->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_segmap_parloop_struct_338335->free_pad_css_len_292821;
    int64_t s_n_m_292825 =
            futhark_mc_segmap_parloop_struct_338335->free_s_n_m_292825;
    int64_t gtid_304506 =
            futhark_mc_segmap_parloop_struct_338335->free_gtid_304506;
    struct memblock ext_mem_314847 = {.desc ="ext_mem_314847", .mem =
                                      futhark_mc_segmap_parloop_struct_338335->free_ext_mem_314847,
                                      .size =0, .references =NULL};
    struct memblock ext_mem_314848 = {.desc ="ext_mem_314848", .mem =
                                      futhark_mc_segmap_parloop_struct_338335->free_ext_mem_314848,
                                      .size =0, .references =NULL};
    int64_t bytes_314850 =
            futhark_mc_segmap_parloop_struct_338335->free_bytes_314850;
    struct memblock mem_314870 = {.desc ="mem_314870", .mem =
                                  futhark_mc_segmap_parloop_struct_338335->free_mem_314870,
                                  .size =0, .references =NULL};
    size_t mem_327696_cached_sizze_338337 = 0;
    unsigned char *mem_327696 = NULL;
    int64_t iterations = end - start;
    int64_t iter_327955 = start;
    
    if (mem_327696_cached_sizze_338337 < (size_t) bytes_314850) {
        mem_327696 = realloc(mem_327696, bytes_314850);
        mem_327696_cached_sizze_338337 = bytes_314850;
    }
    for (; iter_327955 < end; iter_327955++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_328037 = n_p_292677;
        int64_t gtid_327695 = iter_327955;
        int64_t remnant_328038 = iter_327955 - gtid_327695;
        int64_t flat_tid_327956 = (int64_t) 0;
        int32_t num_tasks_328039;
        struct futhark_mc_task_338338 futhark_mc_task_338338;
        
        futhark_mc_task_338338.ctx = ctx;
        futhark_mc_task_338338.free_n_p_292677 = n_p_292677;
        futhark_mc_task_338338.free_jump_s_292684 = jump_s_292684;
        futhark_mc_task_338338.free_defunc_0_f_res_292820 =
            defunc_0_f_res_292820;
        futhark_mc_task_338338.free_pad_css_len_292821 = pad_css_len_292821;
        futhark_mc_task_338338.free_s_n_m_292825 = s_n_m_292825;
        futhark_mc_task_338338.free_gtid_304506 = gtid_304506;
        futhark_mc_task_338338.free_ext_mem_314847 = ext_mem_314847.mem;
        futhark_mc_task_338338.free_ext_mem_314848 = ext_mem_314848.mem;
        futhark_mc_task_338338.free_gtid_327695 = gtid_327695;
        futhark_mc_task_338338.free_mem_327696 = mem_327696;
        
        struct scheduler_segop futhark_mc_task_338338_task;
        
        futhark_mc_task_338338_task.args = &futhark_mc_task_338338;
        futhark_mc_task_338338_task.top_level_fn =
            futhark_mc_segmap_task_338339;
        futhark_mc_task_338338_task.name = "futhark_mc_segmap_task_338339";
        futhark_mc_task_338338_task.iterations = pad_css_len_292821;
        futhark_mc_task_338338_task.task_time =
            &ctx->futhark_mc_segmap_task_338339_total_time;
        futhark_mc_task_338338_task.task_iter =
            &ctx->futhark_mc_segmap_task_338339_total_iter;
        futhark_mc_task_338338_task.sched = STATIC;
        futhark_mc_task_338338_task.nested_fn = NULL;
        
        int futhark_mc_segmap_task_338339_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_338338_task);
        
        if (futhark_mc_segmap_task_338339_err != 0) {
            ;
            err = futhark_mc_segmap_task_338339_err;
            goto cleanup;
        }
        if (pad_css_len_292821 * (int64_t) 8 > 0)
            memmove(mem_314870.mem + gtid_327695 * pad_css_len_292821 *
                    (int64_t) 8, mem_327696 + (int64_t) 0, pad_css_len_292821 *
                    (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_327696);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338336_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338336_end -
                 futhark_mc_segmap_parloop_338336_start;
        
        ctx->futhark_mc_segmap_parloop_338336_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338336_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338336_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_nested_task_338334(void *args, int64_t iterations,
                                         int tid, struct scheduler_info info)
{
    int err = 0;
    int flat_tid_327694 = tid;
    int num_tasks_327868 = info.nsubtasks;
    struct futhark_mc_task_338329 *futhark_mc_task_338329 =
                                  (struct futhark_mc_task_338329 *) args;
    struct futhark_context *ctx = futhark_mc_task_338329->ctx;
    uint64_t futhark_mc_segmap_nested_task_338334_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_nested_task_338334_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_338329->free_n_p_292677;
    int64_t jump_s_292684 = futhark_mc_task_338329->free_jump_s_292684;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_338329->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_task_338329->free_pad_css_len_292821;
    int64_t s_n_m_292825 = futhark_mc_task_338329->free_s_n_m_292825;
    int64_t gtid_304506 = futhark_mc_task_338329->free_gtid_304506;
    struct memblock ext_mem_314847 = {.desc ="ext_mem_314847", .mem =
                                      futhark_mc_task_338329->free_ext_mem_314847,
                                      .size =0, .references =NULL};
    struct memblock ext_mem_314848 = {.desc ="ext_mem_314848", .mem =
                                      futhark_mc_task_338329->free_ext_mem_314848,
                                      .size =0, .references =NULL};
    int64_t bytes_314850 = futhark_mc_task_338329->free_bytes_314850;
    struct memblock mem_314870 = {.desc ="mem_314870", .mem =
                                  futhark_mc_task_338329->free_mem_314870,
                                  .size =0, .references =NULL};
    int64_t iter_327955;
    struct futhark_mc_segmap_parloop_struct_338335
    futhark_mc_segmap_parloop_struct_338335;
    
    futhark_mc_segmap_parloop_struct_338335.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338335.free_n_p_292677 = n_p_292677;
    futhark_mc_segmap_parloop_struct_338335.free_jump_s_292684 = jump_s_292684;
    futhark_mc_segmap_parloop_struct_338335.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segmap_parloop_struct_338335.free_pad_css_len_292821 =
        pad_css_len_292821;
    futhark_mc_segmap_parloop_struct_338335.free_s_n_m_292825 = s_n_m_292825;
    futhark_mc_segmap_parloop_struct_338335.free_gtid_304506 = gtid_304506;
    futhark_mc_segmap_parloop_struct_338335.free_ext_mem_314847 =
        ext_mem_314847.mem;
    futhark_mc_segmap_parloop_struct_338335.free_ext_mem_314848 =
        ext_mem_314848.mem;
    futhark_mc_segmap_parloop_struct_338335.free_bytes_314850 = bytes_314850;
    futhark_mc_segmap_parloop_struct_338335.free_mem_314870 = mem_314870.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338336_task;
    
    futhark_mc_segmap_parloop_338336_task.name =
        "futhark_mc_segmap_parloop_338336";
    futhark_mc_segmap_parloop_338336_task.fn = futhark_mc_segmap_parloop_338336;
    futhark_mc_segmap_parloop_338336_task.args =
        &futhark_mc_segmap_parloop_struct_338335;
    futhark_mc_segmap_parloop_338336_task.iterations = iterations;
    futhark_mc_segmap_parloop_338336_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338336_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338336_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338336_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338336_task);
    
    if (futhark_mc_segmap_parloop_338336_err != 0) {
        err = futhark_mc_segmap_parloop_338336_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338336_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338336_total_end -
                 futhark_mc_segmap_parloop_338336_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338336_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338336_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338336_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_nested_task_338334_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_nested_task_338334_end -
                 futhark_mc_segmap_nested_task_338334_start;
        
        ctx->futhark_mc_segmap_nested_task_338334_runs[tid]++;
        ctx->futhark_mc_segmap_nested_task_338334_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_nested_task_338334_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
static int futhark_mc_segmap_parloop_338327(void *args, int64_t start,
                                            int64_t end, int flat_tid_304505,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338326
    *futhark_mc_segmap_parloop_struct_338326 =
    (struct futhark_mc_segmap_parloop_struct_338326 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338326->ctx;
    uint64_t futhark_mc_segmap_parloop_338327_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338327_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segmap_parloop_struct_338326->free_n_p_292677;
    int64_t jump_s_292684 =
            futhark_mc_segmap_parloop_struct_338326->free_jump_s_292684;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_338326->free_partition_sizze_292766;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_segmap_parloop_struct_338326->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_segmap_parloop_struct_338326->free_pad_css_len_292821;
    int64_t s_n_m_292825 =
            futhark_mc_segmap_parloop_struct_338326->free_s_n_m_292825;
    struct memblock ext_mem_314847 = {.desc ="ext_mem_314847", .mem =
                                      futhark_mc_segmap_parloop_struct_338326->free_ext_mem_314847,
                                      .size =0, .references =NULL};
    struct memblock ext_mem_314848 = {.desc ="ext_mem_314848", .mem =
                                      futhark_mc_segmap_parloop_struct_338326->free_ext_mem_314848,
                                      .size =0, .references =NULL};
    int64_t bytes_314850 =
            futhark_mc_segmap_parloop_struct_338326->free_bytes_314850;
    int64_t bytes_314869 =
            futhark_mc_segmap_parloop_struct_338326->free_bytes_314869;
    struct memblock mem_314922 = {.desc ="mem_314922", .mem =
                                  futhark_mc_segmap_parloop_struct_338326->free_mem_314922,
                                  .size =0, .references =NULL};
    size_t mem_314870_cached_sizze_338328 = 0;
    unsigned char *mem_314870 = NULL;
    int64_t iterations = end - start;
    int64_t iter_327693 = start;
    
    if (mem_314870_cached_sizze_338328 < (size_t) bytes_314869) {
        mem_314870 = realloc(mem_314870, bytes_314869);
        mem_314870_cached_sizze_338328 = bytes_314869;
    }
    for (; iter_327693 < end; iter_327693++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_327866 = partition_sizze_292766;
        int64_t gtid_304506 = iter_327693;
        int64_t remnant_327867 = iter_327693 - gtid_304506;
        int64_t flat_tid_327779 = (int64_t) 0;
        int32_t num_tasks_327868;
        int64_t flat_tid_327694 = (int64_t) 0;
        struct futhark_mc_task_338329 futhark_mc_task_338329;
        
        futhark_mc_task_338329.ctx = ctx;
        futhark_mc_task_338329.free_n_p_292677 = n_p_292677;
        futhark_mc_task_338329.free_jump_s_292684 = jump_s_292684;
        futhark_mc_task_338329.free_defunc_0_f_res_292820 =
            defunc_0_f_res_292820;
        futhark_mc_task_338329.free_pad_css_len_292821 = pad_css_len_292821;
        futhark_mc_task_338329.free_s_n_m_292825 = s_n_m_292825;
        futhark_mc_task_338329.free_gtid_304506 = gtid_304506;
        futhark_mc_task_338329.free_ext_mem_314847 = ext_mem_314847.mem;
        futhark_mc_task_338329.free_ext_mem_314848 = ext_mem_314848.mem;
        futhark_mc_task_338329.free_bytes_314850 = bytes_314850;
        futhark_mc_task_338329.free_mem_314870 = mem_314870;
        
        struct scheduler_segop futhark_mc_task_338329_task;
        
        futhark_mc_task_338329_task.args = &futhark_mc_task_338329;
        futhark_mc_task_338329_task.top_level_fn =
            futhark_mc_segmap_task_338330;
        futhark_mc_task_338329_task.name = "futhark_mc_segmap_task_338330";
        futhark_mc_task_338329_task.iterations = n_p_292677;
        futhark_mc_task_338329_task.task_time =
            &ctx->futhark_mc_segmap_task_338330_total_time;
        futhark_mc_task_338329_task.task_iter =
            &ctx->futhark_mc_segmap_task_338330_total_iter;
        futhark_mc_task_338329_task.sched = STATIC;
        futhark_mc_task_338329_task.nested_fn =
            futhark_mc_segmap_nested_task_338334;
        
        int futhark_mc_segmap_task_338330_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_338329_task);
        
        if (futhark_mc_segmap_task_338330_err != 0) {
            ;
            err = futhark_mc_segmap_task_338330_err;
            goto cleanup;
        }
        if (n_p_292677 * pad_css_len_292821 * (int64_t) 8 > 0)
            memmove(mem_314922.mem + gtid_304506 * (pad_css_len_292821 *
                                                    n_p_292677) * (int64_t) 8,
                    mem_314870 + (int64_t) 0, n_p_292677 * pad_css_len_292821 *
                    (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_314870);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338327_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338327_end -
                 futhark_mc_segmap_parloop_338327_start;
        
        ctx->futhark_mc_segmap_parloop_338327_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338327_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338327_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_nested_task_338325(void *args, int64_t iterations,
                                         int tid, struct scheduler_info info)
{
    int err = 0;
    int flat_tid_304505 = tid;
    int num_tasks_327602 = info.nsubtasks;
    struct futhark_mc_task_338320 *futhark_mc_task_338320 =
                                  (struct futhark_mc_task_338320 *) args;
    struct futhark_context *ctx = futhark_mc_task_338320->ctx;
    uint64_t futhark_mc_segmap_nested_task_338325_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_nested_task_338325_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_338320->free_n_p_292677;
    int64_t jump_s_292684 = futhark_mc_task_338320->free_jump_s_292684;
    int64_t partition_sizze_292766 =
            futhark_mc_task_338320->free_partition_sizze_292766;
    int64_t defunc_0_f_res_292820 =
            futhark_mc_task_338320->free_defunc_0_f_res_292820;
    int64_t pad_css_len_292821 =
            futhark_mc_task_338320->free_pad_css_len_292821;
    int64_t s_n_m_292825 = futhark_mc_task_338320->free_s_n_m_292825;
    struct memblock ext_mem_314847 = {.desc ="ext_mem_314847", .mem =
                                      futhark_mc_task_338320->free_ext_mem_314847,
                                      .size =0, .references =NULL};
    struct memblock ext_mem_314848 = {.desc ="ext_mem_314848", .mem =
                                      futhark_mc_task_338320->free_ext_mem_314848,
                                      .size =0, .references =NULL};
    int64_t bytes_314850 = futhark_mc_task_338320->free_bytes_314850;
    int64_t bytes_314869 = futhark_mc_task_338320->free_bytes_314869;
    struct memblock mem_314922 = {.desc ="mem_314922", .mem =
                                  futhark_mc_task_338320->free_mem_314922,
                                  .size =0, .references =NULL};
    int64_t iter_327693;
    struct futhark_mc_segmap_parloop_struct_338326
    futhark_mc_segmap_parloop_struct_338326;
    
    futhark_mc_segmap_parloop_struct_338326.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338326.free_n_p_292677 = n_p_292677;
    futhark_mc_segmap_parloop_struct_338326.free_jump_s_292684 = jump_s_292684;
    futhark_mc_segmap_parloop_struct_338326.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_338326.free_defunc_0_f_res_292820 =
        defunc_0_f_res_292820;
    futhark_mc_segmap_parloop_struct_338326.free_pad_css_len_292821 =
        pad_css_len_292821;
    futhark_mc_segmap_parloop_struct_338326.free_s_n_m_292825 = s_n_m_292825;
    futhark_mc_segmap_parloop_struct_338326.free_ext_mem_314847 =
        ext_mem_314847.mem;
    futhark_mc_segmap_parloop_struct_338326.free_ext_mem_314848 =
        ext_mem_314848.mem;
    futhark_mc_segmap_parloop_struct_338326.free_bytes_314850 = bytes_314850;
    futhark_mc_segmap_parloop_struct_338326.free_bytes_314869 = bytes_314869;
    futhark_mc_segmap_parloop_struct_338326.free_mem_314922 = mem_314922.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338327_task;
    
    futhark_mc_segmap_parloop_338327_task.name =
        "futhark_mc_segmap_parloop_338327";
    futhark_mc_segmap_parloop_338327_task.fn = futhark_mc_segmap_parloop_338327;
    futhark_mc_segmap_parloop_338327_task.args =
        &futhark_mc_segmap_parloop_struct_338326;
    futhark_mc_segmap_parloop_338327_task.iterations = iterations;
    futhark_mc_segmap_parloop_338327_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338327_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338327_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338327_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338327_task);
    
    if (futhark_mc_segmap_parloop_338327_err != 0) {
        err = futhark_mc_segmap_parloop_338327_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338327_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338327_total_end -
                 futhark_mc_segmap_parloop_338327_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338327_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338327_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338327_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_nested_task_338325_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_nested_task_338325_end -
                 futhark_mc_segmap_nested_task_338325_start;
        
        ctx->futhark_mc_segmap_nested_task_338325_runs[tid]++;
        ctx->futhark_mc_segmap_nested_task_338325_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_nested_task_338325_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_task_338342 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_partition_sizze_292766;
    int64_t free_C_len_292823;
    int64_t free_css_results_l_293288;
    unsigned char *free_ext_mem_314923;
    int64_t free_bytes_314926;
    unsigned char *free_mem_314946;
};
struct futhark_mc_segmap_parloop_struct_338344 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_partition_sizze_292766;
    int64_t free_C_len_292823;
    int64_t free_css_results_l_293288;
    unsigned char *free_ext_mem_314923;
    int64_t free_bytes_314926;
    unsigned char *free_mem_314946;
};
static int futhark_mc_segmap_parloop_338345(void *args, int64_t start,
                                            int64_t end, int flat_tid_304682,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338344
    *futhark_mc_segmap_parloop_struct_338344 =
    (struct futhark_mc_segmap_parloop_struct_338344 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338344->ctx;
    uint64_t futhark_mc_segmap_parloop_338345_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338345_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segmap_parloop_struct_338344->free_n_p_292677;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_338344->free_partition_sizze_292766;
    int64_t C_len_292823 =
            futhark_mc_segmap_parloop_struct_338344->free_C_len_292823;
    int64_t css_results_l_293288 =
            futhark_mc_segmap_parloop_struct_338344->free_css_results_l_293288;
    struct memblock ext_mem_314923 = {.desc ="ext_mem_314923", .mem =
                                      futhark_mc_segmap_parloop_struct_338344->free_ext_mem_314923,
                                      .size =0, .references =NULL};
    int64_t bytes_314926 =
            futhark_mc_segmap_parloop_struct_338344->free_bytes_314926;
    struct memblock mem_314946 = {.desc ="mem_314946", .mem =
                                  futhark_mc_segmap_parloop_struct_338344->free_mem_314946,
                                  .size =0, .references =NULL};
    size_t mem_314930_cached_sizze_338346 = 0;
    unsigned char *mem_314930 = NULL;
    int64_t iterations = end - start;
    int64_t iter_328121 = start;
    
    if (mem_314930_cached_sizze_338346 < (size_t) bytes_314926) {
        mem_314930 = realloc(mem_314930, bytes_314926);
        mem_314930_cached_sizze_338346 = bytes_314926;
    }
    for (; iter_328121 < end; iter_328121++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_328136 = partition_sizze_292766;
        int64_t gtid_304683 = iter_328121;
        int64_t remnant_328137 = iter_328121 - gtid_304683;
        
        for (int64_t i_328122 = 0; i_328122 < C_len_292823; i_328122++) {
            int64_t i_328124 = smod64(i_328122, n_p_292677);
            bool x_328125 = sle64((int64_t) 0, i_328124);
            bool y_328126 = slt64(i_328124, n_p_292677);
            bool bounds_check_328127 = x_328125 && y_328126;
            int64_t i_328128 = sdiv64(i_328122, n_p_292677);
            bool x_328129 = sle64((int64_t) 0, i_328128);
            bool y_328130 = slt64(i_328128, css_results_l_293288);
            bool bounds_check_328131 = x_328129 && y_328130;
            bool index_ok_328132 = bounds_check_328127 && bounds_check_328131;
            bool index_certs_328133;
            
            if (!index_ok_328132) {
                ctx->error =
                    msgprintf("Error: %s%lld%s%lld%s%lld%s%lld%s\n\nBacktrace:\n%s",
                              "Index [", (long long) i_328124, ", ",
                              (long long) i_328128,
                              "] out of bounds for array of shape [",
                              (long long) n_p_292677, "][",
                              (long long) css_results_l_293288, "].",
                              "-> #0  stl.fut:228:39-67\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  stl.fut:228:28-74\n   #5  stl.fut:227:21-229:39\n   #6  stl.fut:419:61-435:77\n   #7  stl.fut:463:3-479:36\n   #8  stl.fut:445:1-479:36\n");
                err = FUTHARK_PROGRAM_ERROR;
                goto cleanup;
            }
            if ((int64_t) 8 > 0)
                memmove(mem_314930 + i_328122 * (int64_t) 8,
                        ext_mem_314923.mem + (gtid_304683 *
                                              (css_results_l_293288 *
                                               n_p_292677) + i_328124 *
                                              css_results_l_293288 + i_328128) *
                        (int64_t) 8, (int64_t) 8);
        }
        if (C_len_292823 * (int64_t) 8 > 0)
            memmove(mem_314946.mem + gtid_304683 * C_len_292823 * (int64_t) 8,
                    mem_314930 + (int64_t) 0, C_len_292823 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_314930);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338345_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338345_end -
                 futhark_mc_segmap_parloop_338345_start;
        
        ctx->futhark_mc_segmap_parloop_338345_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338345_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338345_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_338343(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_304682 = tid;
    int num_tasks_328120 = info.nsubtasks;
    struct futhark_mc_task_338342 *futhark_mc_task_338342 =
                                  (struct futhark_mc_task_338342 *) args;
    struct futhark_context *ctx = futhark_mc_task_338342->ctx;
    uint64_t futhark_mc_segmap_task_338343_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_338343_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_338342->free_n_p_292677;
    int64_t partition_sizze_292766 =
            futhark_mc_task_338342->free_partition_sizze_292766;
    int64_t C_len_292823 = futhark_mc_task_338342->free_C_len_292823;
    int64_t css_results_l_293288 =
            futhark_mc_task_338342->free_css_results_l_293288;
    struct memblock ext_mem_314923 = {.desc ="ext_mem_314923", .mem =
                                      futhark_mc_task_338342->free_ext_mem_314923,
                                      .size =0, .references =NULL};
    int64_t bytes_314926 = futhark_mc_task_338342->free_bytes_314926;
    struct memblock mem_314946 = {.desc ="mem_314946", .mem =
                                  futhark_mc_task_338342->free_mem_314946,
                                  .size =0, .references =NULL};
    int64_t iter_328121;
    struct futhark_mc_segmap_parloop_struct_338344
    futhark_mc_segmap_parloop_struct_338344;
    
    futhark_mc_segmap_parloop_struct_338344.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338344.free_n_p_292677 = n_p_292677;
    futhark_mc_segmap_parloop_struct_338344.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_338344.free_C_len_292823 = C_len_292823;
    futhark_mc_segmap_parloop_struct_338344.free_css_results_l_293288 =
        css_results_l_293288;
    futhark_mc_segmap_parloop_struct_338344.free_ext_mem_314923 =
        ext_mem_314923.mem;
    futhark_mc_segmap_parloop_struct_338344.free_bytes_314926 = bytes_314926;
    futhark_mc_segmap_parloop_struct_338344.free_mem_314946 = mem_314946.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338345_task;
    
    futhark_mc_segmap_parloop_338345_task.name =
        "futhark_mc_segmap_parloop_338345";
    futhark_mc_segmap_parloop_338345_task.fn = futhark_mc_segmap_parloop_338345;
    futhark_mc_segmap_parloop_338345_task.args =
        &futhark_mc_segmap_parloop_struct_338344;
    futhark_mc_segmap_parloop_338345_task.iterations = iterations;
    futhark_mc_segmap_parloop_338345_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338345_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338345_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338345_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338345_task);
    
    if (futhark_mc_segmap_parloop_338345_err != 0) {
        err = futhark_mc_segmap_parloop_338345_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338345_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338345_total_end -
                 futhark_mc_segmap_parloop_338345_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338345_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338345_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338345_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_338343_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_338343_end -
                 futhark_mc_segmap_task_338343_start;
        
        ctx->futhark_mc_segmap_task_338343_runs[tid]++;
        ctx->futhark_mc_segmap_task_338343_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_338343_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_segmap_parloop_struct_338348 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_partition_sizze_292766;
    int64_t free_C_len_292823;
    int64_t free_css_results_l_293288;
    unsigned char *free_ext_mem_314923;
    int64_t free_bytes_314926;
    unsigned char *free_mem_314946;
};
struct futhark_mc_task_338351 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_C_len_292823;
    int64_t free_css_results_l_293288;
    int64_t free_gtid_304689;
    unsigned char *free_ext_mem_314923;
    unsigned char *free_mem_314927;
};
struct futhark_mc_segmap_parloop_struct_338353 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_C_len_292823;
    int64_t free_css_results_l_293288;
    int64_t free_gtid_304689;
    unsigned char *free_ext_mem_314923;
    unsigned char *free_mem_314927;
};
static int futhark_mc_segmap_parloop_338354(void *args, int64_t start,
                                            int64_t end, int flat_tid_328140,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338353
    *futhark_mc_segmap_parloop_struct_338353 =
    (struct futhark_mc_segmap_parloop_struct_338353 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338353->ctx;
    uint64_t futhark_mc_segmap_parloop_338354_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338354_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segmap_parloop_struct_338353->free_n_p_292677;
    int64_t C_len_292823 =
            futhark_mc_segmap_parloop_struct_338353->free_C_len_292823;
    int64_t css_results_l_293288 =
            futhark_mc_segmap_parloop_struct_338353->free_css_results_l_293288;
    int64_t gtid_304689 =
            futhark_mc_segmap_parloop_struct_338353->free_gtid_304689;
    struct memblock ext_mem_314923 = {.desc ="ext_mem_314923", .mem =
                                      futhark_mc_segmap_parloop_struct_338353->free_ext_mem_314923,
                                      .size =0, .references =NULL};
    struct memblock mem_314927 = {.desc ="mem_314927", .mem =
                                  futhark_mc_segmap_parloop_struct_338353->free_mem_314927,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_328156 = start;
    
    for (; iter_328156 < end; iter_328156++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_328157 = C_len_292823;
        int64_t gtid_328141 = iter_328156;
        int64_t remnant_328158 = iter_328156 - gtid_328141;
        int64_t i_328142 = smod64(gtid_328141, n_p_292677);
        bool x_328143 = sle64((int64_t) 0, i_328142);
        bool y_328144 = slt64(i_328142, n_p_292677);
        bool bounds_check_328145 = x_328143 && y_328144;
        int64_t i_328146 = sdiv64(gtid_328141, n_p_292677);
        bool x_328147 = sle64((int64_t) 0, i_328146);
        bool y_328148 = slt64(i_328146, css_results_l_293288);
        bool bounds_check_328149 = x_328147 && y_328148;
        bool index_ok_328150 = bounds_check_328145 && bounds_check_328149;
        bool index_certs_328151;
        
        if (!index_ok_328150) {
            ctx->error =
                msgprintf("Error: %s%lld%s%lld%s%lld%s%lld%s\n\nBacktrace:\n%s",
                          "Index [", (long long) i_328142, ", ",
                          (long long) i_328146,
                          "] out of bounds for array of shape [",
                          (long long) n_p_292677, "][",
                          (long long) css_results_l_293288, "].",
                          "-> #0  stl.fut:228:39-67\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  stl.fut:228:28-74\n   #5  stl.fut:227:21-229:39\n   #6  stl.fut:419:61-435:77\n   #7  stl.fut:463:3-479:36\n   #8  stl.fut:445:1-479:36\n");
            err = FUTHARK_PROGRAM_ERROR;
            goto cleanup;
        }
        
        double defunc_0_f_res_328152;
        
        defunc_0_f_res_328152 = ((double *) ext_mem_314923.mem)[gtid_304689 *
                                                                (css_results_l_293288 *
                                                                 n_p_292677) +
                                                                i_328142 *
                                                                css_results_l_293288 +
                                                                i_328146];
        ((double *) mem_314927.mem)[gtid_328141] = defunc_0_f_res_328152;
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338354_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338354_end -
                 futhark_mc_segmap_parloop_338354_start;
        
        ctx->futhark_mc_segmap_parloop_338354_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338354_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338354_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_338352(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_328140 = tid;
    int num_tasks_328155 = info.nsubtasks;
    struct futhark_mc_task_338351 *futhark_mc_task_338351 =
                                  (struct futhark_mc_task_338351 *) args;
    struct futhark_context *ctx = futhark_mc_task_338351->ctx;
    uint64_t futhark_mc_segmap_task_338352_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_338352_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_338351->free_n_p_292677;
    int64_t C_len_292823 = futhark_mc_task_338351->free_C_len_292823;
    int64_t css_results_l_293288 =
            futhark_mc_task_338351->free_css_results_l_293288;
    int64_t gtid_304689 = futhark_mc_task_338351->free_gtid_304689;
    struct memblock ext_mem_314923 = {.desc ="ext_mem_314923", .mem =
                                      futhark_mc_task_338351->free_ext_mem_314923,
                                      .size =0, .references =NULL};
    struct memblock mem_314927 = {.desc ="mem_314927", .mem =
                                  futhark_mc_task_338351->free_mem_314927,
                                  .size =0, .references =NULL};
    int64_t iter_328156;
    struct futhark_mc_segmap_parloop_struct_338353
    futhark_mc_segmap_parloop_struct_338353;
    
    futhark_mc_segmap_parloop_struct_338353.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338353.free_n_p_292677 = n_p_292677;
    futhark_mc_segmap_parloop_struct_338353.free_C_len_292823 = C_len_292823;
    futhark_mc_segmap_parloop_struct_338353.free_css_results_l_293288 =
        css_results_l_293288;
    futhark_mc_segmap_parloop_struct_338353.free_gtid_304689 = gtid_304689;
    futhark_mc_segmap_parloop_struct_338353.free_ext_mem_314923 =
        ext_mem_314923.mem;
    futhark_mc_segmap_parloop_struct_338353.free_mem_314927 = mem_314927.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338354_task;
    
    futhark_mc_segmap_parloop_338354_task.name =
        "futhark_mc_segmap_parloop_338354";
    futhark_mc_segmap_parloop_338354_task.fn = futhark_mc_segmap_parloop_338354;
    futhark_mc_segmap_parloop_338354_task.args =
        &futhark_mc_segmap_parloop_struct_338353;
    futhark_mc_segmap_parloop_338354_task.iterations = iterations;
    futhark_mc_segmap_parloop_338354_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338354_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338354_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338354_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338354_task);
    
    if (futhark_mc_segmap_parloop_338354_err != 0) {
        err = futhark_mc_segmap_parloop_338354_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338354_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338354_total_end -
                 futhark_mc_segmap_parloop_338354_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338354_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338354_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338354_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_338352_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_338352_end -
                 futhark_mc_segmap_task_338352_start;
        
        ctx->futhark_mc_segmap_task_338352_runs[tid]++;
        ctx->futhark_mc_segmap_task_338352_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_338352_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
static int futhark_mc_segmap_parloop_338349(void *args, int64_t start,
                                            int64_t end, int flat_tid_304688,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338348
    *futhark_mc_segmap_parloop_struct_338348 =
    (struct futhark_mc_segmap_parloop_struct_338348 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338348->ctx;
    uint64_t futhark_mc_segmap_parloop_338349_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338349_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segmap_parloop_struct_338348->free_n_p_292677;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_338348->free_partition_sizze_292766;
    int64_t C_len_292823 =
            futhark_mc_segmap_parloop_struct_338348->free_C_len_292823;
    int64_t css_results_l_293288 =
            futhark_mc_segmap_parloop_struct_338348->free_css_results_l_293288;
    struct memblock ext_mem_314923 = {.desc ="ext_mem_314923", .mem =
                                      futhark_mc_segmap_parloop_struct_338348->free_ext_mem_314923,
                                      .size =0, .references =NULL};
    int64_t bytes_314926 =
            futhark_mc_segmap_parloop_struct_338348->free_bytes_314926;
    struct memblock mem_314946 = {.desc ="mem_314946", .mem =
                                  futhark_mc_segmap_parloop_struct_338348->free_mem_314946,
                                  .size =0, .references =NULL};
    size_t mem_314927_cached_sizze_338350 = 0;
    unsigned char *mem_314927 = NULL;
    int64_t iterations = end - start;
    int64_t iter_328139 = start;
    
    if (mem_314927_cached_sizze_338350 < (size_t) bytes_314926) {
        mem_314927 = realloc(mem_314927, bytes_314926);
        mem_314927_cached_sizze_338350 = bytes_314926;
    }
    for (; iter_328139 < end; iter_328139++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_328153 = partition_sizze_292766;
        int64_t gtid_304689 = iter_328139;
        int64_t remnant_328154 = iter_328139 - gtid_304689;
        int64_t flat_tid_328140 = (int64_t) 0;
        int32_t num_tasks_328155;
        struct futhark_mc_task_338351 futhark_mc_task_338351;
        
        futhark_mc_task_338351.ctx = ctx;
        futhark_mc_task_338351.free_n_p_292677 = n_p_292677;
        futhark_mc_task_338351.free_C_len_292823 = C_len_292823;
        futhark_mc_task_338351.free_css_results_l_293288 = css_results_l_293288;
        futhark_mc_task_338351.free_gtid_304689 = gtid_304689;
        futhark_mc_task_338351.free_ext_mem_314923 = ext_mem_314923.mem;
        futhark_mc_task_338351.free_mem_314927 = mem_314927;
        
        struct scheduler_segop futhark_mc_task_338351_task;
        
        futhark_mc_task_338351_task.args = &futhark_mc_task_338351;
        futhark_mc_task_338351_task.top_level_fn =
            futhark_mc_segmap_task_338352;
        futhark_mc_task_338351_task.name = "futhark_mc_segmap_task_338352";
        futhark_mc_task_338351_task.iterations = C_len_292823;
        futhark_mc_task_338351_task.task_time =
            &ctx->futhark_mc_segmap_task_338352_total_time;
        futhark_mc_task_338351_task.task_iter =
            &ctx->futhark_mc_segmap_task_338352_total_iter;
        futhark_mc_task_338351_task.sched = STATIC;
        futhark_mc_task_338351_task.nested_fn = NULL;
        
        int futhark_mc_segmap_task_338352_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_338351_task);
        
        if (futhark_mc_segmap_task_338352_err != 0) {
            ;
            err = futhark_mc_segmap_task_338352_err;
            goto cleanup;
        }
        if (C_len_292823 * (int64_t) 8 > 0)
            memmove(mem_314946.mem + gtid_304689 * C_len_292823 * (int64_t) 8,
                    mem_314927 + (int64_t) 0, C_len_292823 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_314927);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338349_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338349_end -
                 futhark_mc_segmap_parloop_338349_start;
        
        ctx->futhark_mc_segmap_parloop_338349_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338349_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338349_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_nested_task_338347(void *args, int64_t iterations,
                                         int tid, struct scheduler_info info)
{
    int err = 0;
    int flat_tid_304688 = tid;
    int num_tasks_328120 = info.nsubtasks;
    struct futhark_mc_task_338342 *futhark_mc_task_338342 =
                                  (struct futhark_mc_task_338342 *) args;
    struct futhark_context *ctx = futhark_mc_task_338342->ctx;
    uint64_t futhark_mc_segmap_nested_task_338347_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_nested_task_338347_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_338342->free_n_p_292677;
    int64_t partition_sizze_292766 =
            futhark_mc_task_338342->free_partition_sizze_292766;
    int64_t C_len_292823 = futhark_mc_task_338342->free_C_len_292823;
    int64_t css_results_l_293288 =
            futhark_mc_task_338342->free_css_results_l_293288;
    struct memblock ext_mem_314923 = {.desc ="ext_mem_314923", .mem =
                                      futhark_mc_task_338342->free_ext_mem_314923,
                                      .size =0, .references =NULL};
    int64_t bytes_314926 = futhark_mc_task_338342->free_bytes_314926;
    struct memblock mem_314946 = {.desc ="mem_314946", .mem =
                                  futhark_mc_task_338342->free_mem_314946,
                                  .size =0, .references =NULL};
    int64_t iter_328139;
    struct futhark_mc_segmap_parloop_struct_338348
    futhark_mc_segmap_parloop_struct_338348;
    
    futhark_mc_segmap_parloop_struct_338348.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338348.free_n_p_292677 = n_p_292677;
    futhark_mc_segmap_parloop_struct_338348.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_338348.free_C_len_292823 = C_len_292823;
    futhark_mc_segmap_parloop_struct_338348.free_css_results_l_293288 =
        css_results_l_293288;
    futhark_mc_segmap_parloop_struct_338348.free_ext_mem_314923 =
        ext_mem_314923.mem;
    futhark_mc_segmap_parloop_struct_338348.free_bytes_314926 = bytes_314926;
    futhark_mc_segmap_parloop_struct_338348.free_mem_314946 = mem_314946.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338349_task;
    
    futhark_mc_segmap_parloop_338349_task.name =
        "futhark_mc_segmap_parloop_338349";
    futhark_mc_segmap_parloop_338349_task.fn = futhark_mc_segmap_parloop_338349;
    futhark_mc_segmap_parloop_338349_task.args =
        &futhark_mc_segmap_parloop_struct_338348;
    futhark_mc_segmap_parloop_338349_task.iterations = iterations;
    futhark_mc_segmap_parloop_338349_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338349_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338349_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338349_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338349_task);
    
    if (futhark_mc_segmap_parloop_338349_err != 0) {
        err = futhark_mc_segmap_parloop_338349_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338349_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338349_total_end -
                 futhark_mc_segmap_parloop_338349_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338349_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338349_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338349_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_nested_task_338347_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_nested_task_338347_end -
                 futhark_mc_segmap_nested_task_338347_start;
        
        ctx->futhark_mc_segmap_nested_task_338347_runs[tid]++;
        ctx->futhark_mc_segmap_nested_task_338347_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_nested_task_338347_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_task_338355 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_partition_sizze_292766;
    int64_t free_C_len_292823;
    unsigned char *free_mem_314946;
    unsigned char *free_mem_314949;
};
struct futhark_mc_segmap_parloop_struct_338357 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_partition_sizze_292766;
    int64_t free_C_len_292823;
    unsigned char *free_mem_314946;
    unsigned char *free_mem_314949;
};
static int futhark_mc_segmap_parloop_338358(void *args, int64_t start,
                                            int64_t end, int flat_tid_304706,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338357
    *futhark_mc_segmap_parloop_struct_338357 =
    (struct futhark_mc_segmap_parloop_struct_338357 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338357->ctx;
    uint64_t futhark_mc_segmap_parloop_338358_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338358_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segmap_parloop_struct_338357->free_n_p_292677;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_338357->free_partition_sizze_292766;
    int64_t C_len_292823 =
            futhark_mc_segmap_parloop_struct_338357->free_C_len_292823;
    struct memblock mem_314946 = {.desc ="mem_314946", .mem =
                                  futhark_mc_segmap_parloop_struct_338357->free_mem_314946,
                                  .size =0, .references =NULL};
    struct memblock mem_314949 = {.desc ="mem_314949", .mem =
                                  futhark_mc_segmap_parloop_struct_338357->free_mem_314949,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_328160 = start;
    
    for (; iter_328160 < end; iter_328160++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_328165 = partition_sizze_292766;
        int64_t gtid_304707 = iter_328160;
        int64_t remnant_328166 = iter_328160 - gtid_304707;
        double defunc_2_reduce_res_294696;
        double redout_328162 = 0.0;
        
        for (int64_t i_328161 = 0; i_328161 < n_p_292677; i_328161++) {
            double x_328163;
            
            x_328163 = ((double *) mem_314946.mem)[gtid_304707 * C_len_292823 +
                                                   i_328161];
            
            double defunc_1_op_res_328164 = x_328163 + redout_328162;
            double redout_tmp_328167 = defunc_1_op_res_328164;
            
            redout_328162 = redout_tmp_328167;
        }
        defunc_2_reduce_res_294696 = redout_328162;
        ((double *) mem_314949.mem)[gtid_304707] = defunc_2_reduce_res_294696;
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338358_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338358_end -
                 futhark_mc_segmap_parloop_338358_start;
        
        ctx->futhark_mc_segmap_parloop_338358_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338358_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338358_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_338356(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_304706 = tid;
    int num_tasks_328159 = info.nsubtasks;
    struct futhark_mc_task_338355 *futhark_mc_task_338355 =
                                  (struct futhark_mc_task_338355 *) args;
    struct futhark_context *ctx = futhark_mc_task_338355->ctx;
    uint64_t futhark_mc_segmap_task_338356_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_338356_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_338355->free_n_p_292677;
    int64_t partition_sizze_292766 =
            futhark_mc_task_338355->free_partition_sizze_292766;
    int64_t C_len_292823 = futhark_mc_task_338355->free_C_len_292823;
    struct memblock mem_314946 = {.desc ="mem_314946", .mem =
                                  futhark_mc_task_338355->free_mem_314946,
                                  .size =0, .references =NULL};
    struct memblock mem_314949 = {.desc ="mem_314949", .mem =
                                  futhark_mc_task_338355->free_mem_314949,
                                  .size =0, .references =NULL};
    int64_t iter_328160;
    struct futhark_mc_segmap_parloop_struct_338357
    futhark_mc_segmap_parloop_struct_338357;
    
    futhark_mc_segmap_parloop_struct_338357.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338357.free_n_p_292677 = n_p_292677;
    futhark_mc_segmap_parloop_struct_338357.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_338357.free_C_len_292823 = C_len_292823;
    futhark_mc_segmap_parloop_struct_338357.free_mem_314946 = mem_314946.mem;
    futhark_mc_segmap_parloop_struct_338357.free_mem_314949 = mem_314949.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338358_task;
    
    futhark_mc_segmap_parloop_338358_task.name =
        "futhark_mc_segmap_parloop_338358";
    futhark_mc_segmap_parloop_338358_task.fn = futhark_mc_segmap_parloop_338358;
    futhark_mc_segmap_parloop_338358_task.args =
        &futhark_mc_segmap_parloop_struct_338357;
    futhark_mc_segmap_parloop_338358_task.iterations = iterations;
    futhark_mc_segmap_parloop_338358_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338358_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338358_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338358_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338358_task);
    
    if (futhark_mc_segmap_parloop_338358_err != 0) {
        err = futhark_mc_segmap_parloop_338358_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338358_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338358_total_end -
                 futhark_mc_segmap_parloop_338358_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338358_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338358_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338358_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_338356_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_338356_end -
                 futhark_mc_segmap_task_338356_start;
        
        ctx->futhark_mc_segmap_task_338356_runs[tid]++;
        ctx->futhark_mc_segmap_task_338356_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_338356_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_segmap_parloop_struct_338360 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_partition_sizze_292766;
    int64_t free_C_len_292823;
    unsigned char *free_mem_314946;
    unsigned char *free_mem_314949;
};
struct futhark_mc_task_338362 {
    struct futhark_context *ctx;
    int64_t free_C_len_292823;
    int64_t free_gtid_304713;
    unsigned char *free_mem_314946;
    double *retval_defunc_2_reduce_res_304715;
};
struct futhark_mc_segred_stage_1_parloop_struct_338365 {
    struct futhark_context *ctx;
    int64_t free_C_len_292823;
    int64_t free_gtid_304713;
    unsigned char *free_mem_314946;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_328178;
};
static int futhark_mc_segred_stage_1_parloop_338366(void *args, int64_t start,
                                                    int64_t end,
                                                    int flat_tid_328169,
                                                    int tid)
{
    int err = 0;
    struct futhark_mc_segred_stage_1_parloop_struct_338365
    *futhark_mc_segred_stage_1_parloop_struct_338365 =
    (struct futhark_mc_segred_stage_1_parloop_struct_338365 *) args;
    struct futhark_context *ctx =
                           futhark_mc_segred_stage_1_parloop_struct_338365->ctx;
    uint64_t futhark_mc_segred_stage_1_parloop_338366_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_338366_start = get_wall_time();
    
    int64_t C_len_292823 =
            futhark_mc_segred_stage_1_parloop_struct_338365->free_C_len_292823;
    int64_t gtid_304713 =
            futhark_mc_segred_stage_1_parloop_struct_338365->free_gtid_304713;
    struct memblock mem_314946 = {.desc ="mem_314946", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_338365->free_mem_314946,
                                  .size =0, .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_328178 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_328178",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338365->free_reduce_stage_1_tid_res_arr_mem_328178,
                                                             .size =0,
                                                             .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_328180 = start;
    double x_328171;
    double x_328172;
    double local_acc_328181 = 0.0;
    
    for (; iter_328180 < end; iter_328180++) {
        int64_t gtid_328170 = iter_328180;
        double x_328174;
        
        x_328174 = ((double *) mem_314946.mem)[gtid_304713 * C_len_292823 +
                                               gtid_328170];
        // save map-out results
        { }
        // Load accum params
        {
            x_328171 = local_acc_328181;
        }
        // Load next params
        {
            x_328172 = x_328174;
        }
        // Red body
        {
            double defunc_1_op_res_328173 = x_328171 + x_328172;
            
            local_acc_328181 = defunc_1_op_res_328173;
        }
    }
    ((double *) reduce_stage_1_tid_res_arr_mem_328178.mem)[flat_tid_328169] =
        local_acc_328181;
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_338366_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_338366_end -
                 futhark_mc_segred_stage_1_parloop_338366_start;
        
        ctx->futhark_mc_segred_stage_1_parloop_338366_runs[tid]++;
        ctx->futhark_mc_segred_stage_1_parloop_338366_total_runtime[tid] +=
            elapsed;
        ctx->futhark_mc_segred_stage_1_parloop_338366_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segred_task_338363(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_328169 = tid;
    int num_tasks_328177 = info.nsubtasks;
    struct futhark_mc_task_338362 *futhark_mc_task_338362 =
                                  (struct futhark_mc_task_338362 *) args;
    struct futhark_context *ctx = futhark_mc_task_338362->ctx;
    uint64_t futhark_mc_segred_task_338363_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_task_338363_start = get_wall_time();
    
    int64_t C_len_292823 = futhark_mc_task_338362->free_C_len_292823;
    int64_t gtid_304713 = futhark_mc_task_338362->free_gtid_304713;
    struct memblock mem_314946 = {.desc ="mem_314946", .mem =
                                  futhark_mc_task_338362->free_mem_314946,
                                  .size =0, .references =NULL};
    double defunc_2_reduce_res_304715 =
           *futhark_mc_task_338362->retval_defunc_2_reduce_res_304715;
    size_t reduce_stage_1_tid_res_arr_mem_328178_cached_sizze_338364 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_328178 = NULL;
    
    if (reduce_stage_1_tid_res_arr_mem_328178_cached_sizze_338364 <
        (size_t) ((int64_t) 8 * num_tasks_328177)) {
        reduce_stage_1_tid_res_arr_mem_328178 =
            realloc(reduce_stage_1_tid_res_arr_mem_328178, (int64_t) 8 *
                    num_tasks_328177);
        reduce_stage_1_tid_res_arr_mem_328178_cached_sizze_338364 =
            (int64_t) 8 * num_tasks_328177;
    }
    
    int64_t iter_328180;
    struct futhark_mc_segred_stage_1_parloop_struct_338365
    futhark_mc_segred_stage_1_parloop_struct_338365;
    
    futhark_mc_segred_stage_1_parloop_struct_338365.ctx = ctx;
    futhark_mc_segred_stage_1_parloop_struct_338365.free_C_len_292823 =
        C_len_292823;
    futhark_mc_segred_stage_1_parloop_struct_338365.free_gtid_304713 =
        gtid_304713;
    futhark_mc_segred_stage_1_parloop_struct_338365.free_mem_314946 =
        mem_314946.mem;
    futhark_mc_segred_stage_1_parloop_struct_338365.free_reduce_stage_1_tid_res_arr_mem_328178 =
        reduce_stage_1_tid_res_arr_mem_328178;
    
    struct scheduler_parloop futhark_mc_segred_stage_1_parloop_338366_task;
    
    futhark_mc_segred_stage_1_parloop_338366_task.name =
        "futhark_mc_segred_stage_1_parloop_338366";
    futhark_mc_segred_stage_1_parloop_338366_task.fn =
        futhark_mc_segred_stage_1_parloop_338366;
    futhark_mc_segred_stage_1_parloop_338366_task.args =
        &futhark_mc_segred_stage_1_parloop_struct_338365;
    futhark_mc_segred_stage_1_parloop_338366_task.iterations = iterations;
    futhark_mc_segred_stage_1_parloop_338366_task.info = info;
    
    uint64_t futhark_mc_segred_stage_1_parloop_338366_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_338366_total_start = get_wall_time();
    
    int futhark_mc_segred_stage_1_parloop_338366_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segred_stage_1_parloop_338366_task);
    
    if (futhark_mc_segred_stage_1_parloop_338366_err != 0) {
        err = futhark_mc_segred_stage_1_parloop_338366_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_338366_total_end =
                 get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_338366_total_end -
                 futhark_mc_segred_stage_1_parloop_338366_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338366_total_runs,
                           1, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338366_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338366_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    // neutral-initialise the output
    {
        defunc_2_reduce_res_304715 = 0.0;
    }
    
    double x_328182;
    double x_328183;
    
    for (int32_t i_328185 = 0; i_328185 < num_tasks_328177; i_328185++) {
        flat_tid_328169 = i_328185;
        // Apply main thread reduction
        {
            // load acc params
            {
                x_328182 = defunc_2_reduce_res_304715;
            }
            // load next params
            {
                x_328183 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_328178)[flat_tid_328169];
            }
            // red body
            {
                double defunc_1_op_res_328184 = x_328182 + x_328183;
                
                defunc_2_reduce_res_304715 = defunc_1_op_res_328184;
            }
        }
    }
    
  cleanup:
    {
        free(reduce_stage_1_tid_res_arr_mem_328178);
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_task_338363_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_task_338363_end -
                 futhark_mc_segred_task_338363_start;
        
        ctx->futhark_mc_segred_task_338363_runs[tid]++;
        ctx->futhark_mc_segred_task_338363_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segred_task_338363_iter[tid] += iterations;
    }
    if (err == 0) {
        *futhark_mc_task_338362->retval_defunc_2_reduce_res_304715 =
            defunc_2_reduce_res_304715;
    }
    return err;
}
static int futhark_mc_segmap_parloop_338361(void *args, int64_t start,
                                            int64_t end, int flat_tid_304712,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338360
    *futhark_mc_segmap_parloop_struct_338360 =
    (struct futhark_mc_segmap_parloop_struct_338360 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338360->ctx;
    uint64_t futhark_mc_segmap_parloop_338361_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338361_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segmap_parloop_struct_338360->free_n_p_292677;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_338360->free_partition_sizze_292766;
    int64_t C_len_292823 =
            futhark_mc_segmap_parloop_struct_338360->free_C_len_292823;
    struct memblock mem_314946 = {.desc ="mem_314946", .mem =
                                  futhark_mc_segmap_parloop_struct_338360->free_mem_314946,
                                  .size =0, .references =NULL};
    struct memblock mem_314949 = {.desc ="mem_314949", .mem =
                                  futhark_mc_segmap_parloop_struct_338360->free_mem_314949,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_328168 = start;
    
    for (; iter_328168 < end; iter_328168++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_328175 = partition_sizze_292766;
        int64_t gtid_304713 = iter_328168;
        int64_t remnant_328176 = iter_328168 - gtid_304713;
        double defunc_2_reduce_res_304715;
        int64_t flat_tid_328169 = (int64_t) 0;
        int32_t num_tasks_328177;
        
        defunc_2_reduce_res_304715 = 0.0;
        
        struct futhark_mc_task_338362 futhark_mc_task_338362;
        
        futhark_mc_task_338362.ctx = ctx;
        futhark_mc_task_338362.free_C_len_292823 = C_len_292823;
        futhark_mc_task_338362.free_gtid_304713 = gtid_304713;
        futhark_mc_task_338362.free_mem_314946 = mem_314946.mem;
        futhark_mc_task_338362.retval_defunc_2_reduce_res_304715 =
            &defunc_2_reduce_res_304715;
        
        struct scheduler_segop futhark_mc_task_338362_task;
        
        futhark_mc_task_338362_task.args = &futhark_mc_task_338362;
        futhark_mc_task_338362_task.top_level_fn =
            futhark_mc_segred_task_338363;
        futhark_mc_task_338362_task.name = "futhark_mc_segred_task_338363";
        futhark_mc_task_338362_task.iterations = n_p_292677;
        futhark_mc_task_338362_task.task_time =
            &ctx->futhark_mc_segred_task_338363_total_time;
        futhark_mc_task_338362_task.task_iter =
            &ctx->futhark_mc_segred_task_338363_total_iter;
        futhark_mc_task_338362_task.sched = STATIC;
        futhark_mc_task_338362_task.nested_fn = NULL;
        
        int futhark_mc_segred_task_338363_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_338362_task);
        
        if (futhark_mc_segred_task_338363_err != 0) {
            ;
            err = futhark_mc_segred_task_338363_err;
            goto cleanup;
        }
        ((double *) mem_314949.mem)[gtid_304713] = defunc_2_reduce_res_304715;
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338361_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338361_end -
                 futhark_mc_segmap_parloop_338361_start;
        
        ctx->futhark_mc_segmap_parloop_338361_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338361_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338361_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_nested_task_338359(void *args, int64_t iterations,
                                         int tid, struct scheduler_info info)
{
    int err = 0;
    int flat_tid_304712 = tid;
    int num_tasks_328159 = info.nsubtasks;
    struct futhark_mc_task_338355 *futhark_mc_task_338355 =
                                  (struct futhark_mc_task_338355 *) args;
    struct futhark_context *ctx = futhark_mc_task_338355->ctx;
    uint64_t futhark_mc_segmap_nested_task_338359_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_nested_task_338359_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_338355->free_n_p_292677;
    int64_t partition_sizze_292766 =
            futhark_mc_task_338355->free_partition_sizze_292766;
    int64_t C_len_292823 = futhark_mc_task_338355->free_C_len_292823;
    struct memblock mem_314946 = {.desc ="mem_314946", .mem =
                                  futhark_mc_task_338355->free_mem_314946,
                                  .size =0, .references =NULL};
    struct memblock mem_314949 = {.desc ="mem_314949", .mem =
                                  futhark_mc_task_338355->free_mem_314949,
                                  .size =0, .references =NULL};
    int64_t iter_328168;
    struct futhark_mc_segmap_parloop_struct_338360
    futhark_mc_segmap_parloop_struct_338360;
    
    futhark_mc_segmap_parloop_struct_338360.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338360.free_n_p_292677 = n_p_292677;
    futhark_mc_segmap_parloop_struct_338360.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_338360.free_C_len_292823 = C_len_292823;
    futhark_mc_segmap_parloop_struct_338360.free_mem_314946 = mem_314946.mem;
    futhark_mc_segmap_parloop_struct_338360.free_mem_314949 = mem_314949.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338361_task;
    
    futhark_mc_segmap_parloop_338361_task.name =
        "futhark_mc_segmap_parloop_338361";
    futhark_mc_segmap_parloop_338361_task.fn = futhark_mc_segmap_parloop_338361;
    futhark_mc_segmap_parloop_338361_task.args =
        &futhark_mc_segmap_parloop_struct_338360;
    futhark_mc_segmap_parloop_338361_task.iterations = iterations;
    futhark_mc_segmap_parloop_338361_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338361_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338361_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338361_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338361_task);
    
    if (futhark_mc_segmap_parloop_338361_err != 0) {
        err = futhark_mc_segmap_parloop_338361_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338361_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338361_total_end -
                 futhark_mc_segmap_parloop_338361_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338361_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338361_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338361_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_nested_task_338359_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_nested_task_338359_end -
                 futhark_mc_segmap_nested_task_338359_start;
        
        ctx->futhark_mc_segmap_nested_task_338359_runs[tid]++;
        ctx->futhark_mc_segmap_nested_task_338359_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_nested_task_338359_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_task_338367 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    double free_i64_res_292694;
    int64_t free_partition_sizze_292766;
    int64_t free_C_len_292823;
    int64_t free_lifted_single_ma_l_arg_293311;
    unsigned char *free_mem_314946;
    unsigned char *free_mem_314949;
    int64_t free_bytes_314951;
    unsigned char *free_mem_314971;
};
struct futhark_mc_segmap_parloop_struct_338369 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    double free_i64_res_292694;
    int64_t free_partition_sizze_292766;
    int64_t free_C_len_292823;
    int64_t free_lifted_single_ma_l_arg_293311;
    unsigned char *free_mem_314946;
    unsigned char *free_mem_314949;
    int64_t free_bytes_314951;
    unsigned char *free_mem_314971;
};
static int futhark_mc_segmap_parloop_338370(void *args, int64_t start,
                                            int64_t end, int flat_tid_304722,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338369
    *futhark_mc_segmap_parloop_struct_338369 =
    (struct futhark_mc_segmap_parloop_struct_338369 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338369->ctx;
    uint64_t futhark_mc_segmap_parloop_338370_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338370_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segmap_parloop_struct_338369->free_n_p_292677;
    double i64_res_292694 =
           futhark_mc_segmap_parloop_struct_338369->free_i64_res_292694;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_338369->free_partition_sizze_292766;
    int64_t C_len_292823 =
            futhark_mc_segmap_parloop_struct_338369->free_C_len_292823;
    int64_t lifted_single_ma_l_arg_293311 =
            futhark_mc_segmap_parloop_struct_338369->free_lifted_single_ma_l_arg_293311;
    struct memblock mem_314946 = {.desc ="mem_314946", .mem =
                                  futhark_mc_segmap_parloop_struct_338369->free_mem_314946,
                                  .size =0, .references =NULL};
    struct memblock mem_314949 = {.desc ="mem_314949", .mem =
                                  futhark_mc_segmap_parloop_struct_338369->free_mem_314949,
                                  .size =0, .references =NULL};
    int64_t bytes_314951 =
            futhark_mc_segmap_parloop_struct_338369->free_bytes_314951;
    struct memblock mem_314971 = {.desc ="mem_314971", .mem =
                                  futhark_mc_segmap_parloop_struct_338369->free_mem_314971,
                                  .size =0, .references =NULL};
    size_t mem_314955_cached_sizze_338371 = 0;
    unsigned char *mem_314955 = NULL;
    int64_t iterations = end - start;
    int64_t iter_328187 = start;
    
    if (mem_314955_cached_sizze_338371 < (size_t) bytes_314951) {
        mem_314955 = realloc(mem_314955, bytes_314951);
        mem_314955_cached_sizze_338371 = bytes_314951;
    }
    for (; iter_328187 < end; iter_328187++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_328211 = partition_sizze_292766;
        int64_t gtid_304723 = iter_328187;
        int64_t remnant_328212 = iter_328187 - gtid_304723;
        double x_294704;
        
        x_294704 = ((double *) mem_314949.mem)[gtid_304723];
        
        double discard_311493;
        double scanacc_328189 = 0.0;
        
        for (int64_t i_328188 = 0; i_328188 < lifted_single_ma_l_arg_293311;
             i_328188++) {
            bool cond_328191 = i_328188 == (int64_t) 0;
            double defunc_0_f_res_328192;
            
            if (cond_328191) {
                double defunc_0_f_res_t_res_328193 = x_294704 / i64_res_292694;
                
                defunc_0_f_res_328192 = defunc_0_f_res_t_res_328193;
            } else {
                int64_t x_328194 = add64(n_p_292677, i_328188);
                int64_t i_328195 = sub64(x_328194, (int64_t) 1);
                bool x_328196 = sle64((int64_t) 0, i_328195);
                bool y_328197 = slt64(i_328195, C_len_292823);
                bool bounds_check_328198 = x_328196 && y_328197;
                bool index_certs_328199;
                
                if (!bounds_check_328198) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [", (long long) i_328195,
                                  "] out of bounds for array of shape [",
                                  (long long) C_len_292823, "].",
                                  "-> #0  stl.fut:34:23-36\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  stl.fut:29:13-35:19\n   #5  /prelude/soacs.fut:67:19-23\n   #6  /prelude/soacs.fut:67:3-37\n   #7  stl.fut:28:5-36:23\n   #8  stl.fut:40:3-36\n   #9  stl.fut:233:23-47\n   #10 stl.fut:419:61-435:77\n   #11 stl.fut:463:3-479:36\n   #12 stl.fut:445:1-479:36\n");
                    err = FUTHARK_PROGRAM_ERROR;
                    goto cleanup;
                }
                
                double x_328200;
                
                x_328200 = ((double *) mem_314946.mem)[gtid_304723 *
                                                       C_len_292823 + i_328195];
                
                int64_t i_328201 = sub64(i_328188, (int64_t) 1);
                bool x_328202 = sle64((int64_t) 0, i_328201);
                bool y_328203 = slt64(i_328201, C_len_292823);
                bool bounds_check_328204 = x_328202 && y_328203;
                bool index_certs_328205;
                
                if (!bounds_check_328204) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [", (long long) i_328201,
                                  "] out of bounds for array of shape [",
                                  (long long) C_len_292823, "].",
                                  "-> #0  stl.fut:34:40-47\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  stl.fut:29:13-35:19\n   #5  /prelude/soacs.fut:67:19-23\n   #6  /prelude/soacs.fut:67:3-37\n   #7  stl.fut:28:5-36:23\n   #8  stl.fut:40:3-36\n   #9  stl.fut:233:23-47\n   #10 stl.fut:419:61-435:77\n   #11 stl.fut:463:3-479:36\n   #12 stl.fut:445:1-479:36\n");
                    err = FUTHARK_PROGRAM_ERROR;
                    goto cleanup;
                }
                
                double y_328206;
                
                y_328206 = ((double *) mem_314946.mem)[gtid_304723 *
                                                       C_len_292823 + i_328201];
                
                double x_328207 = x_328200 - y_328206;
                double defunc_0_f_res_f_res_328208 = x_328207 / i64_res_292694;
                
                defunc_0_f_res_328192 = defunc_0_f_res_f_res_328208;
            }
            
            double defunc_1_op_res_328209 = defunc_0_f_res_328192 +
                   scanacc_328189;
            
            ((double *) mem_314955)[i_328188] = defunc_1_op_res_328209;
            
            double scanacc_tmp_328213 = defunc_1_op_res_328209;
            
            scanacc_328189 = scanacc_tmp_328213;
        }
        discard_311493 = scanacc_328189;
        if (lifted_single_ma_l_arg_293311 * (int64_t) 8 > 0)
            memmove(mem_314971.mem + gtid_304723 *
                    lifted_single_ma_l_arg_293311 * (int64_t) 8, mem_314955 +
                    (int64_t) 0, lifted_single_ma_l_arg_293311 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_314955);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338370_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338370_end -
                 futhark_mc_segmap_parloop_338370_start;
        
        ctx->futhark_mc_segmap_parloop_338370_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338370_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338370_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_338368(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_304722 = tid;
    int num_tasks_328186 = info.nsubtasks;
    struct futhark_mc_task_338367 *futhark_mc_task_338367 =
                                  (struct futhark_mc_task_338367 *) args;
    struct futhark_context *ctx = futhark_mc_task_338367->ctx;
    uint64_t futhark_mc_segmap_task_338368_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_338368_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_338367->free_n_p_292677;
    double i64_res_292694 = futhark_mc_task_338367->free_i64_res_292694;
    int64_t partition_sizze_292766 =
            futhark_mc_task_338367->free_partition_sizze_292766;
    int64_t C_len_292823 = futhark_mc_task_338367->free_C_len_292823;
    int64_t lifted_single_ma_l_arg_293311 =
            futhark_mc_task_338367->free_lifted_single_ma_l_arg_293311;
    struct memblock mem_314946 = {.desc ="mem_314946", .mem =
                                  futhark_mc_task_338367->free_mem_314946,
                                  .size =0, .references =NULL};
    struct memblock mem_314949 = {.desc ="mem_314949", .mem =
                                  futhark_mc_task_338367->free_mem_314949,
                                  .size =0, .references =NULL};
    int64_t bytes_314951 = futhark_mc_task_338367->free_bytes_314951;
    struct memblock mem_314971 = {.desc ="mem_314971", .mem =
                                  futhark_mc_task_338367->free_mem_314971,
                                  .size =0, .references =NULL};
    int64_t iter_328187;
    struct futhark_mc_segmap_parloop_struct_338369
    futhark_mc_segmap_parloop_struct_338369;
    
    futhark_mc_segmap_parloop_struct_338369.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338369.free_n_p_292677 = n_p_292677;
    futhark_mc_segmap_parloop_struct_338369.free_i64_res_292694 =
        i64_res_292694;
    futhark_mc_segmap_parloop_struct_338369.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_338369.free_C_len_292823 = C_len_292823;
    futhark_mc_segmap_parloop_struct_338369.free_lifted_single_ma_l_arg_293311 =
        lifted_single_ma_l_arg_293311;
    futhark_mc_segmap_parloop_struct_338369.free_mem_314946 = mem_314946.mem;
    futhark_mc_segmap_parloop_struct_338369.free_mem_314949 = mem_314949.mem;
    futhark_mc_segmap_parloop_struct_338369.free_bytes_314951 = bytes_314951;
    futhark_mc_segmap_parloop_struct_338369.free_mem_314971 = mem_314971.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338370_task;
    
    futhark_mc_segmap_parloop_338370_task.name =
        "futhark_mc_segmap_parloop_338370";
    futhark_mc_segmap_parloop_338370_task.fn = futhark_mc_segmap_parloop_338370;
    futhark_mc_segmap_parloop_338370_task.args =
        &futhark_mc_segmap_parloop_struct_338369;
    futhark_mc_segmap_parloop_338370_task.iterations = iterations;
    futhark_mc_segmap_parloop_338370_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338370_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338370_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338370_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338370_task);
    
    if (futhark_mc_segmap_parloop_338370_err != 0) {
        err = futhark_mc_segmap_parloop_338370_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338370_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338370_total_end -
                 futhark_mc_segmap_parloop_338370_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338370_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338370_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338370_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_338368_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_338368_end -
                 futhark_mc_segmap_task_338368_start;
        
        ctx->futhark_mc_segmap_task_338368_runs[tid]++;
        ctx->futhark_mc_segmap_task_338368_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_338368_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_segmap_parloop_struct_338373 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    double free_i64_res_292694;
    int64_t free_partition_sizze_292766;
    int64_t free_C_len_292823;
    int64_t free_lifted_single_ma_l_arg_293311;
    unsigned char *free_mem_314946;
    unsigned char *free_mem_314949;
    int64_t free_bytes_314951;
    unsigned char *free_mem_314971;
};
struct futhark_mc_task_338376 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    double free_i64_res_292694;
    int64_t free_C_len_292823;
    int64_t free_lifted_single_ma_l_arg_293311;
    int64_t free_gtid_304729;
    double free_x_304731;
    unsigned char *free_mem_314946;
    unsigned char *free_mem_314952;
};
struct futhark_mc_scan_stage_1_parloop_struct_338379 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    double free_i64_res_292694;
    int64_t free_C_len_292823;
    int64_t free_gtid_304729;
    double free_x_304731;
    unsigned char *free_mem_314946;
    unsigned char *free_mem_314952;
};
static int futhark_mc_scan_stage_1_parloop_338380(void *args, int64_t start,
                                                  int64_t end,
                                                  int flat_tid_328216, int tid)
{
    int err = 0;
    struct futhark_mc_scan_stage_1_parloop_struct_338379
    *futhark_mc_scan_stage_1_parloop_struct_338379 =
    (struct futhark_mc_scan_stage_1_parloop_struct_338379 *) args;
    struct futhark_context *ctx =
                           futhark_mc_scan_stage_1_parloop_struct_338379->ctx;
    uint64_t futhark_mc_scan_stage_1_parloop_338380_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_scan_stage_1_parloop_338380_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_scan_stage_1_parloop_struct_338379->free_n_p_292677;
    double i64_res_292694 =
           futhark_mc_scan_stage_1_parloop_struct_338379->free_i64_res_292694;
    int64_t C_len_292823 =
            futhark_mc_scan_stage_1_parloop_struct_338379->free_C_len_292823;
    int64_t gtid_304729 =
            futhark_mc_scan_stage_1_parloop_struct_338379->free_gtid_304729;
    double x_304731 =
           futhark_mc_scan_stage_1_parloop_struct_338379->free_x_304731;
    struct memblock mem_314946 = {.desc ="mem_314946", .mem =
                                  futhark_mc_scan_stage_1_parloop_struct_338379->free_mem_314946,
                                  .size =0, .references =NULL};
    struct memblock mem_314952 = {.desc ="mem_314952", .mem =
                                  futhark_mc_scan_stage_1_parloop_struct_338379->free_mem_314952,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_328242 = start;
    double x_328218;
    double x_328219;
    
    x_328218 = 0.0;
    for (; iter_328242 < end; iter_328242++) {
        int64_t gtid_328217 = iter_328242;
        
        // stage 1 scan body
        {
            bool cond_328221 = gtid_328217 == (int64_t) 0;
            double defunc_0_f_res_328222;
            
            if (cond_328221) {
                double defunc_0_f_res_t_res_328223 = x_304731 / i64_res_292694;
                
                defunc_0_f_res_328222 = defunc_0_f_res_t_res_328223;
            } else {
                int64_t x_328224 = add64(n_p_292677, gtid_328217);
                int64_t i_328225 = sub64(x_328224, (int64_t) 1);
                bool x_328226 = sle64((int64_t) 0, i_328225);
                bool y_328227 = slt64(i_328225, C_len_292823);
                bool bounds_check_328228 = x_328226 && y_328227;
                bool index_certs_328229;
                
                if (!bounds_check_328228) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [", (long long) i_328225,
                                  "] out of bounds for array of shape [",
                                  (long long) C_len_292823, "].",
                                  "-> #0  stl.fut:34:23-36\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  stl.fut:29:13-35:19\n   #5  /prelude/soacs.fut:67:19-23\n   #6  /prelude/soacs.fut:67:3-37\n   #7  stl.fut:28:5-36:23\n   #8  stl.fut:40:3-36\n   #9  stl.fut:233:23-47\n   #10 stl.fut:419:61-435:77\n   #11 stl.fut:463:3-479:36\n   #12 stl.fut:445:1-479:36\n");
                    err = FUTHARK_PROGRAM_ERROR;
                    goto cleanup;
                }
                
                double x_328230;
                
                x_328230 = ((double *) mem_314946.mem)[gtid_304729 *
                                                       C_len_292823 + i_328225];
                
                int64_t i_328231 = sub64(gtid_328217, (int64_t) 1);
                bool x_328232 = sle64((int64_t) 0, i_328231);
                bool y_328233 = slt64(i_328231, C_len_292823);
                bool bounds_check_328234 = x_328232 && y_328233;
                bool index_certs_328235;
                
                if (!bounds_check_328234) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [", (long long) i_328231,
                                  "] out of bounds for array of shape [",
                                  (long long) C_len_292823, "].",
                                  "-> #0  stl.fut:34:40-47\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  stl.fut:29:13-35:19\n   #5  /prelude/soacs.fut:67:19-23\n   #6  /prelude/soacs.fut:67:3-37\n   #7  stl.fut:28:5-36:23\n   #8  stl.fut:40:3-36\n   #9  stl.fut:233:23-47\n   #10 stl.fut:419:61-435:77\n   #11 stl.fut:463:3-479:36\n   #12 stl.fut:445:1-479:36\n");
                    err = FUTHARK_PROGRAM_ERROR;
                    goto cleanup;
                }
                
                double y_328236;
                
                y_328236 = ((double *) mem_314946.mem)[gtid_304729 *
                                                       C_len_292823 + i_328231];
                
                double x_328237 = x_328230 - y_328236;
                double defunc_0_f_res_f_res_328238 = x_328237 / i64_res_292694;
                
                defunc_0_f_res_328222 = defunc_0_f_res_f_res_328238;
            }
            // write mapped values results to memory
            { }
            x_328218 = x_328218;
            // Read next values
            {
                x_328219 = defunc_0_f_res_328222;
            }
            
            double defunc_1_op_res_328220 = x_328218 + x_328219;
            
            ((double *) mem_314952.mem)[gtid_328217] = defunc_1_op_res_328220;
            x_328218 = defunc_1_op_res_328220;
        }
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_scan_stage_1_parloop_338380_end = get_wall_time();
        uint64_t elapsed = futhark_mc_scan_stage_1_parloop_338380_end -
                 futhark_mc_scan_stage_1_parloop_338380_start;
        
        ctx->futhark_mc_scan_stage_1_parloop_338380_runs[tid]++;
        ctx->futhark_mc_scan_stage_1_parloop_338380_total_runtime[tid] +=
            elapsed;
        ctx->futhark_mc_scan_stage_1_parloop_338380_iter[tid] += iterations;
    }
    return err;
}
struct futhark_mc_scan_stage_3_parloop_struct_338381 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    double free_i64_res_292694;
    int64_t free_C_len_292823;
    int64_t free_gtid_304729;
    double free_x_304731;
    unsigned char *free_mem_314946;
    unsigned char *free_mem_314952;
};
static int futhark_mc_scan_stage_3_parloop_338382(void *args, int64_t start,
                                                  int64_t end,
                                                  int flat_tid_328216, int tid)
{
    int err = 0;
    struct futhark_mc_scan_stage_3_parloop_struct_338381
    *futhark_mc_scan_stage_3_parloop_struct_338381 =
    (struct futhark_mc_scan_stage_3_parloop_struct_338381 *) args;
    struct futhark_context *ctx =
                           futhark_mc_scan_stage_3_parloop_struct_338381->ctx;
    uint64_t futhark_mc_scan_stage_3_parloop_338382_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_scan_stage_3_parloop_338382_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_scan_stage_3_parloop_struct_338381->free_n_p_292677;
    double i64_res_292694 =
           futhark_mc_scan_stage_3_parloop_struct_338381->free_i64_res_292694;
    int64_t C_len_292823 =
            futhark_mc_scan_stage_3_parloop_struct_338381->free_C_len_292823;
    int64_t gtid_304729 =
            futhark_mc_scan_stage_3_parloop_struct_338381->free_gtid_304729;
    double x_304731 =
           futhark_mc_scan_stage_3_parloop_struct_338381->free_x_304731;
    struct memblock mem_314946 = {.desc ="mem_314946", .mem =
                                  futhark_mc_scan_stage_3_parloop_struct_338381->free_mem_314946,
                                  .size =0, .references =NULL};
    struct memblock mem_314952 = {.desc ="mem_314952", .mem =
                                  futhark_mc_scan_stage_3_parloop_struct_338381->free_mem_314952,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_328254 = start;
    double x_328251;
    double x_328252;
    
    if (iter_328254 == (int64_t) 0) {
        x_328251 = 0.0;
    } else {
        x_328251 = ((double *) mem_314952.mem)[iter_328254 - (int64_t) 1];
    }
    for (; iter_328254 < end; iter_328254++) {
        int64_t gtid_328217 = iter_328254;
        
        // stage 3 scan body
        {
            bool cond_328221 = gtid_328217 == (int64_t) 0;
            double defunc_0_f_res_328222;
            
            if (cond_328221) {
                double defunc_0_f_res_t_res_328223 = x_304731 / i64_res_292694;
                
                defunc_0_f_res_328222 = defunc_0_f_res_t_res_328223;
            } else {
                int64_t x_328224 = add64(n_p_292677, gtid_328217);
                int64_t i_328225 = sub64(x_328224, (int64_t) 1);
                bool x_328226 = sle64((int64_t) 0, i_328225);
                bool y_328227 = slt64(i_328225, C_len_292823);
                bool bounds_check_328228 = x_328226 && y_328227;
                bool index_certs_328229;
                
                if (!bounds_check_328228) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [", (long long) i_328225,
                                  "] out of bounds for array of shape [",
                                  (long long) C_len_292823, "].",
                                  "-> #0  stl.fut:34:23-36\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  stl.fut:29:13-35:19\n   #5  /prelude/soacs.fut:67:19-23\n   #6  /prelude/soacs.fut:67:3-37\n   #7  stl.fut:28:5-36:23\n   #8  stl.fut:40:3-36\n   #9  stl.fut:233:23-47\n   #10 stl.fut:419:61-435:77\n   #11 stl.fut:463:3-479:36\n   #12 stl.fut:445:1-479:36\n");
                    err = FUTHARK_PROGRAM_ERROR;
                    goto cleanup;
                }
                
                double x_328230;
                
                x_328230 = ((double *) mem_314946.mem)[gtid_304729 *
                                                       C_len_292823 + i_328225];
                
                int64_t i_328231 = sub64(gtid_328217, (int64_t) 1);
                bool x_328232 = sle64((int64_t) 0, i_328231);
                bool y_328233 = slt64(i_328231, C_len_292823);
                bool bounds_check_328234 = x_328232 && y_328233;
                bool index_certs_328235;
                
                if (!bounds_check_328234) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [", (long long) i_328231,
                                  "] out of bounds for array of shape [",
                                  (long long) C_len_292823, "].",
                                  "-> #0  stl.fut:34:40-47\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  stl.fut:29:13-35:19\n   #5  /prelude/soacs.fut:67:19-23\n   #6  /prelude/soacs.fut:67:3-37\n   #7  stl.fut:28:5-36:23\n   #8  stl.fut:40:3-36\n   #9  stl.fut:233:23-47\n   #10 stl.fut:419:61-435:77\n   #11 stl.fut:463:3-479:36\n   #12 stl.fut:445:1-479:36\n");
                    err = FUTHARK_PROGRAM_ERROR;
                    goto cleanup;
                }
                
                double y_328236;
                
                y_328236 = ((double *) mem_314946.mem)[gtid_304729 *
                                                       C_len_292823 + i_328231];
                
                double x_328237 = x_328230 - y_328236;
                double defunc_0_f_res_f_res_328238 = x_328237 / i64_res_292694;
                
                defunc_0_f_res_328222 = defunc_0_f_res_f_res_328238;
            }
            x_328251 = x_328251;
            x_328252 = defunc_0_f_res_328222;
            
            double defunc_1_op_res_328253 = x_328251 + x_328252;
            
            ((double *) mem_314952.mem)[gtid_328217] = defunc_1_op_res_328253;
            x_328251 = defunc_1_op_res_328253;
        }
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_scan_stage_3_parloop_338382_end = get_wall_time();
        uint64_t elapsed = futhark_mc_scan_stage_3_parloop_338382_end -
                 futhark_mc_scan_stage_3_parloop_338382_start;
        
        ctx->futhark_mc_scan_stage_3_parloop_338382_runs[tid]++;
        ctx->futhark_mc_scan_stage_3_parloop_338382_total_runtime[tid] +=
            elapsed;
        ctx->futhark_mc_scan_stage_3_parloop_338382_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segscan_task_338377(void *args, int64_t iterations, int tid,
                                   struct scheduler_info info)
{
    int err = 0;
    int flat_tid_328216 = tid;
    int num_tasks_328241 = info.nsubtasks;
    struct futhark_mc_task_338376 *futhark_mc_task_338376 =
                                  (struct futhark_mc_task_338376 *) args;
    struct futhark_context *ctx = futhark_mc_task_338376->ctx;
    uint64_t futhark_mc_segscan_task_338377_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segscan_task_338377_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_338376->free_n_p_292677;
    double i64_res_292694 = futhark_mc_task_338376->free_i64_res_292694;
    int64_t C_len_292823 = futhark_mc_task_338376->free_C_len_292823;
    int64_t lifted_single_ma_l_arg_293311 =
            futhark_mc_task_338376->free_lifted_single_ma_l_arg_293311;
    int64_t gtid_304729 = futhark_mc_task_338376->free_gtid_304729;
    double x_304731 = futhark_mc_task_338376->free_x_304731;
    struct memblock mem_314946 = {.desc ="mem_314946", .mem =
                                  futhark_mc_task_338376->free_mem_314946,
                                  .size =0, .references =NULL};
    struct memblock mem_314952 = {.desc ="mem_314952", .mem =
                                  futhark_mc_task_338376->free_mem_314952,
                                  .size =0, .references =NULL};
    size_t scan_stage_2_accum_mem_328248_cached_sizze_338378 = 0;
    unsigned char *scan_stage_2_accum_mem_328248 = NULL;
    int64_t iter_328242;
    struct futhark_mc_scan_stage_1_parloop_struct_338379
    futhark_mc_scan_stage_1_parloop_struct_338379;
    
    futhark_mc_scan_stage_1_parloop_struct_338379.ctx = ctx;
    futhark_mc_scan_stage_1_parloop_struct_338379.free_n_p_292677 = n_p_292677;
    futhark_mc_scan_stage_1_parloop_struct_338379.free_i64_res_292694 =
        i64_res_292694;
    futhark_mc_scan_stage_1_parloop_struct_338379.free_C_len_292823 =
        C_len_292823;
    futhark_mc_scan_stage_1_parloop_struct_338379.free_gtid_304729 =
        gtid_304729;
    futhark_mc_scan_stage_1_parloop_struct_338379.free_x_304731 = x_304731;
    futhark_mc_scan_stage_1_parloop_struct_338379.free_mem_314946 =
        mem_314946.mem;
    futhark_mc_scan_stage_1_parloop_struct_338379.free_mem_314952 =
        mem_314952.mem;
    
    struct scheduler_parloop futhark_mc_scan_stage_1_parloop_338380_task;
    
    futhark_mc_scan_stage_1_parloop_338380_task.name =
        "futhark_mc_scan_stage_1_parloop_338380";
    futhark_mc_scan_stage_1_parloop_338380_task.fn =
        futhark_mc_scan_stage_1_parloop_338380;
    futhark_mc_scan_stage_1_parloop_338380_task.args =
        &futhark_mc_scan_stage_1_parloop_struct_338379;
    futhark_mc_scan_stage_1_parloop_338380_task.iterations = iterations;
    futhark_mc_scan_stage_1_parloop_338380_task.info = info;
    
    uint64_t futhark_mc_scan_stage_1_parloop_338380_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_scan_stage_1_parloop_338380_total_start = get_wall_time();
    
    int futhark_mc_scan_stage_1_parloop_338380_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_scan_stage_1_parloop_338380_task);
    
    if (futhark_mc_scan_stage_1_parloop_338380_err != 0) {
        err = futhark_mc_scan_stage_1_parloop_338380_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_scan_stage_1_parloop_338380_total_end =
                 get_wall_time();
        uint64_t elapsed = futhark_mc_scan_stage_1_parloop_338380_total_end -
                 futhark_mc_scan_stage_1_parloop_338380_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_scan_stage_1_parloop_338380_total_runs,
                           1, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_scan_stage_1_parloop_338380_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_scan_stage_1_parloop_338380_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    if (slt32(1, num_tasks_328241)) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "nonsegmentedScan stage 2");
        
        double x_328243;
        double x_328244;
        int64_t offset_328246 = (int64_t) 0;
        int64_t offset_index_328247 = (int64_t) 0;
        
        if (scan_stage_2_accum_mem_328248_cached_sizze_338378 <
            (size_t) (int64_t) 8) {
            scan_stage_2_accum_mem_328248 =
                realloc(scan_stage_2_accum_mem_328248, (int64_t) 8);
            scan_stage_2_accum_mem_328248_cached_sizze_338378 = (int64_t) 8;
        }
        ((double *) scan_stage_2_accum_mem_328248)[(int64_t) 0] = 0.0;
        for (int32_t i_328250 = 0; i_328250 < num_tasks_328241 - 1;
             i_328250++) {
            offset_328246 = squot64(lifted_single_ma_l_arg_293311,
                                    sext_i32_i64(num_tasks_328241));
            if (slt64(sext_i32_i64(i_328250),
                      srem64(lifted_single_ma_l_arg_293311,
                             sext_i32_i64(num_tasks_328241)))) {
                offset_328246 += (int64_t) 1;
            }
            offset_index_328247 += offset_328246;
            
            int64_t gtid_328217 = offset_index_328247;
            bool cond_328221 = gtid_328217 == (int64_t) 0;
            double defunc_0_f_res_328222;
            
            if (cond_328221) {
                double defunc_0_f_res_t_res_328223 = x_304731 / i64_res_292694;
                
                defunc_0_f_res_328222 = defunc_0_f_res_t_res_328223;
            } else {
                int64_t x_328224 = add64(n_p_292677, gtid_328217);
                int64_t i_328225 = sub64(x_328224, (int64_t) 1);
                bool x_328226 = sle64((int64_t) 0, i_328225);
                bool y_328227 = slt64(i_328225, C_len_292823);
                bool bounds_check_328228 = x_328226 && y_328227;
                bool index_certs_328229;
                
                if (!bounds_check_328228) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [", (long long) i_328225,
                                  "] out of bounds for array of shape [",
                                  (long long) C_len_292823, "].",
                                  "-> #0  stl.fut:34:23-36\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  stl.fut:29:13-35:19\n   #5  /prelude/soacs.fut:67:19-23\n   #6  /prelude/soacs.fut:67:3-37\n   #7  stl.fut:28:5-36:23\n   #8  stl.fut:40:3-36\n   #9  stl.fut:233:23-47\n   #10 stl.fut:419:61-435:77\n   #11 stl.fut:463:3-479:36\n   #12 stl.fut:445:1-479:36\n");
                    err = FUTHARK_PROGRAM_ERROR;
                    goto cleanup;
                }
                
                double x_328230;
                
                x_328230 = ((double *) mem_314946.mem)[gtid_304729 *
                                                       C_len_292823 + i_328225];
                
                int64_t i_328231 = sub64(gtid_328217, (int64_t) 1);
                bool x_328232 = sle64((int64_t) 0, i_328231);
                bool y_328233 = slt64(i_328231, C_len_292823);
                bool bounds_check_328234 = x_328232 && y_328233;
                bool index_certs_328235;
                
                if (!bounds_check_328234) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [", (long long) i_328231,
                                  "] out of bounds for array of shape [",
                                  (long long) C_len_292823, "].",
                                  "-> #0  stl.fut:34:40-47\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  stl.fut:29:13-35:19\n   #5  /prelude/soacs.fut:67:19-23\n   #6  /prelude/soacs.fut:67:3-37\n   #7  stl.fut:28:5-36:23\n   #8  stl.fut:40:3-36\n   #9  stl.fut:233:23-47\n   #10 stl.fut:419:61-435:77\n   #11 stl.fut:463:3-479:36\n   #12 stl.fut:445:1-479:36\n");
                    err = FUTHARK_PROGRAM_ERROR;
                    goto cleanup;
                }
                
                double y_328236;
                
                y_328236 = ((double *) mem_314946.mem)[gtid_304729 *
                                                       C_len_292823 + i_328231];
                
                double x_328237 = x_328230 - y_328236;
                double defunc_0_f_res_f_res_328238 = x_328237 / i64_res_292694;
                
                defunc_0_f_res_328222 = defunc_0_f_res_f_res_328238;
            }
            // Read carry in
            {
                x_328243 =
                    ((double *) scan_stage_2_accum_mem_328248)[(int64_t) 0];
            }
            // Read next values
            {
                x_328244 = ((double *) mem_314952.mem)[offset_index_328247 -
                                                       (int64_t) 1];
            }
            
            double defunc_1_op_res_328245 = x_328243 + x_328244;
            
            ((double *) mem_314952.mem)[offset_index_328247 - (int64_t) 1] =
                defunc_1_op_res_328245;
            ((double *) scan_stage_2_accum_mem_328248)[(int64_t) 0] =
                defunc_1_op_res_328245;
        }
        
        int64_t iter_328254 = (int64_t) 0;
        struct futhark_mc_scan_stage_3_parloop_struct_338381
        futhark_mc_scan_stage_3_parloop_struct_338381;
        
        futhark_mc_scan_stage_3_parloop_struct_338381.ctx = ctx;
        futhark_mc_scan_stage_3_parloop_struct_338381.free_n_p_292677 =
            n_p_292677;
        futhark_mc_scan_stage_3_parloop_struct_338381.free_i64_res_292694 =
            i64_res_292694;
        futhark_mc_scan_stage_3_parloop_struct_338381.free_C_len_292823 =
            C_len_292823;
        futhark_mc_scan_stage_3_parloop_struct_338381.free_gtid_304729 =
            gtid_304729;
        futhark_mc_scan_stage_3_parloop_struct_338381.free_x_304731 = x_304731;
        futhark_mc_scan_stage_3_parloop_struct_338381.free_mem_314946 =
            mem_314946.mem;
        futhark_mc_scan_stage_3_parloop_struct_338381.free_mem_314952 =
            mem_314952.mem;
        
        struct scheduler_parloop futhark_mc_scan_stage_3_parloop_338382_task;
        
        futhark_mc_scan_stage_3_parloop_338382_task.name =
            "futhark_mc_scan_stage_3_parloop_338382";
        futhark_mc_scan_stage_3_parloop_338382_task.fn =
            futhark_mc_scan_stage_3_parloop_338382;
        futhark_mc_scan_stage_3_parloop_338382_task.args =
            &futhark_mc_scan_stage_3_parloop_struct_338381;
        futhark_mc_scan_stage_3_parloop_338382_task.iterations = iterations;
        futhark_mc_scan_stage_3_parloop_338382_task.info = info;
        
        uint64_t futhark_mc_scan_stage_3_parloop_338382_total_start = 0;
        
        if (ctx->profiling && !ctx->profiling_paused)
            futhark_mc_scan_stage_3_parloop_338382_total_start =
                get_wall_time();
        
        int futhark_mc_scan_stage_3_parloop_338382_err =
            scheduler_execute_task(&ctx->scheduler,
                                   &futhark_mc_scan_stage_3_parloop_338382_task);
        
        if (futhark_mc_scan_stage_3_parloop_338382_err != 0) {
            err = futhark_mc_scan_stage_3_parloop_338382_err;
            goto cleanup;
        }
        if (ctx->profiling && !ctx->profiling_paused) {
            uint64_t futhark_mc_scan_stage_3_parloop_338382_total_end =
                     get_wall_time();
            uint64_t elapsed =
                     futhark_mc_scan_stage_3_parloop_338382_total_end -
                     futhark_mc_scan_stage_3_parloop_338382_total_start;
            
            __atomic_fetch_add(&ctx->futhark_mc_scan_stage_3_parloop_338382_total_runs,
                               1, __ATOMIC_RELAXED);
            __atomic_fetch_add(&ctx->futhark_mc_scan_stage_3_parloop_338382_total_total_runtime,
                               elapsed, __ATOMIC_RELAXED);
            __atomic_fetch_add(&ctx->futhark_mc_scan_stage_3_parloop_338382_total_iter,
                               iterations, __ATOMIC_RELAXED);
        }
    }
    
  cleanup:
    {
        free(scan_stage_2_accum_mem_328248);
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segscan_task_338377_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segscan_task_338377_end -
                 futhark_mc_segscan_task_338377_start;
        
        ctx->futhark_mc_segscan_task_338377_runs[tid]++;
        ctx->futhark_mc_segscan_task_338377_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segscan_task_338377_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
static int futhark_mc_segmap_parloop_338374(void *args, int64_t start,
                                            int64_t end, int flat_tid_304728,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338373
    *futhark_mc_segmap_parloop_struct_338373 =
    (struct futhark_mc_segmap_parloop_struct_338373 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338373->ctx;
    uint64_t futhark_mc_segmap_parloop_338374_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338374_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segmap_parloop_struct_338373->free_n_p_292677;
    double i64_res_292694 =
           futhark_mc_segmap_parloop_struct_338373->free_i64_res_292694;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_338373->free_partition_sizze_292766;
    int64_t C_len_292823 =
            futhark_mc_segmap_parloop_struct_338373->free_C_len_292823;
    int64_t lifted_single_ma_l_arg_293311 =
            futhark_mc_segmap_parloop_struct_338373->free_lifted_single_ma_l_arg_293311;
    struct memblock mem_314946 = {.desc ="mem_314946", .mem =
                                  futhark_mc_segmap_parloop_struct_338373->free_mem_314946,
                                  .size =0, .references =NULL};
    struct memblock mem_314949 = {.desc ="mem_314949", .mem =
                                  futhark_mc_segmap_parloop_struct_338373->free_mem_314949,
                                  .size =0, .references =NULL};
    int64_t bytes_314951 =
            futhark_mc_segmap_parloop_struct_338373->free_bytes_314951;
    struct memblock mem_314971 = {.desc ="mem_314971", .mem =
                                  futhark_mc_segmap_parloop_struct_338373->free_mem_314971,
                                  .size =0, .references =NULL};
    size_t mem_314952_cached_sizze_338375 = 0;
    unsigned char *mem_314952 = NULL;
    int64_t iterations = end - start;
    int64_t iter_328215 = start;
    
    if (mem_314952_cached_sizze_338375 < (size_t) bytes_314951) {
        mem_314952 = realloc(mem_314952, bytes_314951);
        mem_314952_cached_sizze_338375 = bytes_314951;
    }
    for (; iter_328215 < end; iter_328215++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_328239 = partition_sizze_292766;
        int64_t gtid_304729 = iter_328215;
        int64_t remnant_328240 = iter_328215 - gtid_304729;
        double x_304731;
        
        x_304731 = ((double *) mem_314949.mem)[gtid_304729];
        
        int64_t flat_tid_328216 = (int64_t) 0;
        int32_t num_tasks_328241;
        
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "nonsegmented segScan");
        
        struct futhark_mc_task_338376 futhark_mc_task_338376;
        
        futhark_mc_task_338376.ctx = ctx;
        futhark_mc_task_338376.free_n_p_292677 = n_p_292677;
        futhark_mc_task_338376.free_i64_res_292694 = i64_res_292694;
        futhark_mc_task_338376.free_C_len_292823 = C_len_292823;
        futhark_mc_task_338376.free_lifted_single_ma_l_arg_293311 =
            lifted_single_ma_l_arg_293311;
        futhark_mc_task_338376.free_gtid_304729 = gtid_304729;
        futhark_mc_task_338376.free_x_304731 = x_304731;
        futhark_mc_task_338376.free_mem_314946 = mem_314946.mem;
        futhark_mc_task_338376.free_mem_314952 = mem_314952;
        
        struct scheduler_segop futhark_mc_task_338376_task;
        
        futhark_mc_task_338376_task.args = &futhark_mc_task_338376;
        futhark_mc_task_338376_task.top_level_fn =
            futhark_mc_segscan_task_338377;
        futhark_mc_task_338376_task.name = "futhark_mc_segscan_task_338377";
        futhark_mc_task_338376_task.iterations = lifted_single_ma_l_arg_293311;
        futhark_mc_task_338376_task.task_time =
            &ctx->futhark_mc_segscan_task_338377_total_time;
        futhark_mc_task_338376_task.task_iter =
            &ctx->futhark_mc_segscan_task_338377_total_iter;
        futhark_mc_task_338376_task.sched = STATIC;
        futhark_mc_task_338376_task.nested_fn = NULL;
        
        int futhark_mc_segscan_task_338377_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_338376_task);
        
        if (futhark_mc_segscan_task_338377_err != 0) {
            ;
            err = futhark_mc_segscan_task_338377_err;
            goto cleanup;
        }
        if (lifted_single_ma_l_arg_293311 * (int64_t) 8 > 0)
            memmove(mem_314971.mem + gtid_304729 *
                    lifted_single_ma_l_arg_293311 * (int64_t) 8, mem_314952 +
                    (int64_t) 0, lifted_single_ma_l_arg_293311 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_314952);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338374_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338374_end -
                 futhark_mc_segmap_parloop_338374_start;
        
        ctx->futhark_mc_segmap_parloop_338374_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338374_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338374_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_nested_task_338372(void *args, int64_t iterations,
                                         int tid, struct scheduler_info info)
{
    int err = 0;
    int flat_tid_304728 = tid;
    int num_tasks_328186 = info.nsubtasks;
    struct futhark_mc_task_338367 *futhark_mc_task_338367 =
                                  (struct futhark_mc_task_338367 *) args;
    struct futhark_context *ctx = futhark_mc_task_338367->ctx;
    uint64_t futhark_mc_segmap_nested_task_338372_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_nested_task_338372_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_338367->free_n_p_292677;
    double i64_res_292694 = futhark_mc_task_338367->free_i64_res_292694;
    int64_t partition_sizze_292766 =
            futhark_mc_task_338367->free_partition_sizze_292766;
    int64_t C_len_292823 = futhark_mc_task_338367->free_C_len_292823;
    int64_t lifted_single_ma_l_arg_293311 =
            futhark_mc_task_338367->free_lifted_single_ma_l_arg_293311;
    struct memblock mem_314946 = {.desc ="mem_314946", .mem =
                                  futhark_mc_task_338367->free_mem_314946,
                                  .size =0, .references =NULL};
    struct memblock mem_314949 = {.desc ="mem_314949", .mem =
                                  futhark_mc_task_338367->free_mem_314949,
                                  .size =0, .references =NULL};
    int64_t bytes_314951 = futhark_mc_task_338367->free_bytes_314951;
    struct memblock mem_314971 = {.desc ="mem_314971", .mem =
                                  futhark_mc_task_338367->free_mem_314971,
                                  .size =0, .references =NULL};
    int64_t iter_328215;
    struct futhark_mc_segmap_parloop_struct_338373
    futhark_mc_segmap_parloop_struct_338373;
    
    futhark_mc_segmap_parloop_struct_338373.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338373.free_n_p_292677 = n_p_292677;
    futhark_mc_segmap_parloop_struct_338373.free_i64_res_292694 =
        i64_res_292694;
    futhark_mc_segmap_parloop_struct_338373.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_338373.free_C_len_292823 = C_len_292823;
    futhark_mc_segmap_parloop_struct_338373.free_lifted_single_ma_l_arg_293311 =
        lifted_single_ma_l_arg_293311;
    futhark_mc_segmap_parloop_struct_338373.free_mem_314946 = mem_314946.mem;
    futhark_mc_segmap_parloop_struct_338373.free_mem_314949 = mem_314949.mem;
    futhark_mc_segmap_parloop_struct_338373.free_bytes_314951 = bytes_314951;
    futhark_mc_segmap_parloop_struct_338373.free_mem_314971 = mem_314971.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338374_task;
    
    futhark_mc_segmap_parloop_338374_task.name =
        "futhark_mc_segmap_parloop_338374";
    futhark_mc_segmap_parloop_338374_task.fn = futhark_mc_segmap_parloop_338374;
    futhark_mc_segmap_parloop_338374_task.args =
        &futhark_mc_segmap_parloop_struct_338373;
    futhark_mc_segmap_parloop_338374_task.iterations = iterations;
    futhark_mc_segmap_parloop_338374_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338374_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338374_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338374_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338374_task);
    
    if (futhark_mc_segmap_parloop_338374_err != 0) {
        err = futhark_mc_segmap_parloop_338374_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338374_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338374_total_end -
                 futhark_mc_segmap_parloop_338374_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338374_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338374_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338374_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_nested_task_338372_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_nested_task_338372_end -
                 futhark_mc_segmap_nested_task_338372_start;
        
        ctx->futhark_mc_segmap_nested_task_338372_runs[tid]++;
        ctx->futhark_mc_segmap_nested_task_338372_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_nested_task_338372_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_task_338383 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_partition_sizze_292766;
    int64_t free_lifted_single_ma_l_arg_293311;
    unsigned char *free_mem_314971;
    unsigned char *free_mem_314974;
};
struct futhark_mc_segmap_parloop_struct_338385 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_partition_sizze_292766;
    int64_t free_lifted_single_ma_l_arg_293311;
    unsigned char *free_mem_314971;
    unsigned char *free_mem_314974;
};
static int futhark_mc_segmap_parloop_338386(void *args, int64_t start,
                                            int64_t end, int flat_tid_304757,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338385
    *futhark_mc_segmap_parloop_struct_338385 =
    (struct futhark_mc_segmap_parloop_struct_338385 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338385->ctx;
    uint64_t futhark_mc_segmap_parloop_338386_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338386_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segmap_parloop_struct_338385->free_n_p_292677;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_338385->free_partition_sizze_292766;
    int64_t lifted_single_ma_l_arg_293311 =
            futhark_mc_segmap_parloop_struct_338385->free_lifted_single_ma_l_arg_293311;
    struct memblock mem_314971 = {.desc ="mem_314971", .mem =
                                  futhark_mc_segmap_parloop_struct_338385->free_mem_314971,
                                  .size =0, .references =NULL};
    struct memblock mem_314974 = {.desc ="mem_314974", .mem =
                                  futhark_mc_segmap_parloop_struct_338385->free_mem_314974,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_328256 = start;
    
    for (; iter_328256 < end; iter_328256++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_328261 = partition_sizze_292766;
        int64_t gtid_304758 = iter_328256;
        int64_t remnant_328262 = iter_328256 - gtid_304758;
        double defunc_2_reduce_res_294732;
        double redout_328258 = 0.0;
        
        for (int64_t i_328257 = 0; i_328257 < n_p_292677; i_328257++) {
            double x_328259;
            
            x_328259 = ((double *) mem_314971.mem)[gtid_304758 *
                                                   lifted_single_ma_l_arg_293311 +
                                                   i_328257];
            
            double defunc_1_op_res_328260 = x_328259 + redout_328258;
            double redout_tmp_328263 = defunc_1_op_res_328260;
            
            redout_328258 = redout_tmp_328263;
        }
        defunc_2_reduce_res_294732 = redout_328258;
        ((double *) mem_314974.mem)[gtid_304758] = defunc_2_reduce_res_294732;
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338386_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338386_end -
                 futhark_mc_segmap_parloop_338386_start;
        
        ctx->futhark_mc_segmap_parloop_338386_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338386_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338386_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_338384(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_304757 = tid;
    int num_tasks_328255 = info.nsubtasks;
    struct futhark_mc_task_338383 *futhark_mc_task_338383 =
                                  (struct futhark_mc_task_338383 *) args;
    struct futhark_context *ctx = futhark_mc_task_338383->ctx;
    uint64_t futhark_mc_segmap_task_338384_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_338384_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_338383->free_n_p_292677;
    int64_t partition_sizze_292766 =
            futhark_mc_task_338383->free_partition_sizze_292766;
    int64_t lifted_single_ma_l_arg_293311 =
            futhark_mc_task_338383->free_lifted_single_ma_l_arg_293311;
    struct memblock mem_314971 = {.desc ="mem_314971", .mem =
                                  futhark_mc_task_338383->free_mem_314971,
                                  .size =0, .references =NULL};
    struct memblock mem_314974 = {.desc ="mem_314974", .mem =
                                  futhark_mc_task_338383->free_mem_314974,
                                  .size =0, .references =NULL};
    int64_t iter_328256;
    struct futhark_mc_segmap_parloop_struct_338385
    futhark_mc_segmap_parloop_struct_338385;
    
    futhark_mc_segmap_parloop_struct_338385.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338385.free_n_p_292677 = n_p_292677;
    futhark_mc_segmap_parloop_struct_338385.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_338385.free_lifted_single_ma_l_arg_293311 =
        lifted_single_ma_l_arg_293311;
    futhark_mc_segmap_parloop_struct_338385.free_mem_314971 = mem_314971.mem;
    futhark_mc_segmap_parloop_struct_338385.free_mem_314974 = mem_314974.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338386_task;
    
    futhark_mc_segmap_parloop_338386_task.name =
        "futhark_mc_segmap_parloop_338386";
    futhark_mc_segmap_parloop_338386_task.fn = futhark_mc_segmap_parloop_338386;
    futhark_mc_segmap_parloop_338386_task.args =
        &futhark_mc_segmap_parloop_struct_338385;
    futhark_mc_segmap_parloop_338386_task.iterations = iterations;
    futhark_mc_segmap_parloop_338386_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338386_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338386_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338386_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338386_task);
    
    if (futhark_mc_segmap_parloop_338386_err != 0) {
        err = futhark_mc_segmap_parloop_338386_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338386_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338386_total_end -
                 futhark_mc_segmap_parloop_338386_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338386_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338386_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338386_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_338384_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_338384_end -
                 futhark_mc_segmap_task_338384_start;
        
        ctx->futhark_mc_segmap_task_338384_runs[tid]++;
        ctx->futhark_mc_segmap_task_338384_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_338384_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_segmap_parloop_struct_338388 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    int64_t free_partition_sizze_292766;
    int64_t free_lifted_single_ma_l_arg_293311;
    unsigned char *free_mem_314971;
    unsigned char *free_mem_314974;
};
struct futhark_mc_task_338390 {
    struct futhark_context *ctx;
    int64_t free_lifted_single_ma_l_arg_293311;
    int64_t free_gtid_304764;
    unsigned char *free_mem_314971;
    double *retval_defunc_2_reduce_res_304766;
};
struct futhark_mc_segred_stage_1_parloop_struct_338393 {
    struct futhark_context *ctx;
    int64_t free_lifted_single_ma_l_arg_293311;
    int64_t free_gtid_304764;
    unsigned char *free_mem_314971;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_328274;
};
static int futhark_mc_segred_stage_1_parloop_338394(void *args, int64_t start,
                                                    int64_t end,
                                                    int flat_tid_328265,
                                                    int tid)
{
    int err = 0;
    struct futhark_mc_segred_stage_1_parloop_struct_338393
    *futhark_mc_segred_stage_1_parloop_struct_338393 =
    (struct futhark_mc_segred_stage_1_parloop_struct_338393 *) args;
    struct futhark_context *ctx =
                           futhark_mc_segred_stage_1_parloop_struct_338393->ctx;
    uint64_t futhark_mc_segred_stage_1_parloop_338394_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_338394_start = get_wall_time();
    
    int64_t lifted_single_ma_l_arg_293311 =
            futhark_mc_segred_stage_1_parloop_struct_338393->free_lifted_single_ma_l_arg_293311;
    int64_t gtid_304764 =
            futhark_mc_segred_stage_1_parloop_struct_338393->free_gtid_304764;
    struct memblock mem_314971 = {.desc ="mem_314971", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_338393->free_mem_314971,
                                  .size =0, .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_328274 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_328274",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338393->free_reduce_stage_1_tid_res_arr_mem_328274,
                                                             .size =0,
                                                             .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_328276 = start;
    double x_328267;
    double x_328268;
    double local_acc_328277 = 0.0;
    
    for (; iter_328276 < end; iter_328276++) {
        int64_t gtid_328266 = iter_328276;
        double x_328270;
        
        x_328270 = ((double *) mem_314971.mem)[gtid_304764 *
                                               lifted_single_ma_l_arg_293311 +
                                               gtid_328266];
        // save map-out results
        { }
        // Load accum params
        {
            x_328267 = local_acc_328277;
        }
        // Load next params
        {
            x_328268 = x_328270;
        }
        // Red body
        {
            double defunc_1_op_res_328269 = x_328267 + x_328268;
            
            local_acc_328277 = defunc_1_op_res_328269;
        }
    }
    ((double *) reduce_stage_1_tid_res_arr_mem_328274.mem)[flat_tid_328265] =
        local_acc_328277;
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_338394_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_338394_end -
                 futhark_mc_segred_stage_1_parloop_338394_start;
        
        ctx->futhark_mc_segred_stage_1_parloop_338394_runs[tid]++;
        ctx->futhark_mc_segred_stage_1_parloop_338394_total_runtime[tid] +=
            elapsed;
        ctx->futhark_mc_segred_stage_1_parloop_338394_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segred_task_338391(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_328265 = tid;
    int num_tasks_328273 = info.nsubtasks;
    struct futhark_mc_task_338390 *futhark_mc_task_338390 =
                                  (struct futhark_mc_task_338390 *) args;
    struct futhark_context *ctx = futhark_mc_task_338390->ctx;
    uint64_t futhark_mc_segred_task_338391_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_task_338391_start = get_wall_time();
    
    int64_t lifted_single_ma_l_arg_293311 =
            futhark_mc_task_338390->free_lifted_single_ma_l_arg_293311;
    int64_t gtid_304764 = futhark_mc_task_338390->free_gtid_304764;
    struct memblock mem_314971 = {.desc ="mem_314971", .mem =
                                  futhark_mc_task_338390->free_mem_314971,
                                  .size =0, .references =NULL};
    double defunc_2_reduce_res_304766 =
           *futhark_mc_task_338390->retval_defunc_2_reduce_res_304766;
    size_t reduce_stage_1_tid_res_arr_mem_328274_cached_sizze_338392 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_328274 = NULL;
    
    if (reduce_stage_1_tid_res_arr_mem_328274_cached_sizze_338392 <
        (size_t) ((int64_t) 8 * num_tasks_328273)) {
        reduce_stage_1_tid_res_arr_mem_328274 =
            realloc(reduce_stage_1_tid_res_arr_mem_328274, (int64_t) 8 *
                    num_tasks_328273);
        reduce_stage_1_tid_res_arr_mem_328274_cached_sizze_338392 =
            (int64_t) 8 * num_tasks_328273;
    }
    
    int64_t iter_328276;
    struct futhark_mc_segred_stage_1_parloop_struct_338393
    futhark_mc_segred_stage_1_parloop_struct_338393;
    
    futhark_mc_segred_stage_1_parloop_struct_338393.ctx = ctx;
    futhark_mc_segred_stage_1_parloop_struct_338393.free_lifted_single_ma_l_arg_293311 =
        lifted_single_ma_l_arg_293311;
    futhark_mc_segred_stage_1_parloop_struct_338393.free_gtid_304764 =
        gtid_304764;
    futhark_mc_segred_stage_1_parloop_struct_338393.free_mem_314971 =
        mem_314971.mem;
    futhark_mc_segred_stage_1_parloop_struct_338393.free_reduce_stage_1_tid_res_arr_mem_328274 =
        reduce_stage_1_tid_res_arr_mem_328274;
    
    struct scheduler_parloop futhark_mc_segred_stage_1_parloop_338394_task;
    
    futhark_mc_segred_stage_1_parloop_338394_task.name =
        "futhark_mc_segred_stage_1_parloop_338394";
    futhark_mc_segred_stage_1_parloop_338394_task.fn =
        futhark_mc_segred_stage_1_parloop_338394;
    futhark_mc_segred_stage_1_parloop_338394_task.args =
        &futhark_mc_segred_stage_1_parloop_struct_338393;
    futhark_mc_segred_stage_1_parloop_338394_task.iterations = iterations;
    futhark_mc_segred_stage_1_parloop_338394_task.info = info;
    
    uint64_t futhark_mc_segred_stage_1_parloop_338394_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_338394_total_start = get_wall_time();
    
    int futhark_mc_segred_stage_1_parloop_338394_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segred_stage_1_parloop_338394_task);
    
    if (futhark_mc_segred_stage_1_parloop_338394_err != 0) {
        err = futhark_mc_segred_stage_1_parloop_338394_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_338394_total_end =
                 get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_338394_total_end -
                 futhark_mc_segred_stage_1_parloop_338394_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338394_total_runs,
                           1, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338394_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338394_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    // neutral-initialise the output
    {
        defunc_2_reduce_res_304766 = 0.0;
    }
    
    double x_328278;
    double x_328279;
    
    for (int32_t i_328281 = 0; i_328281 < num_tasks_328273; i_328281++) {
        flat_tid_328265 = i_328281;
        // Apply main thread reduction
        {
            // load acc params
            {
                x_328278 = defunc_2_reduce_res_304766;
            }
            // load next params
            {
                x_328279 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_328274)[flat_tid_328265];
            }
            // red body
            {
                double defunc_1_op_res_328280 = x_328278 + x_328279;
                
                defunc_2_reduce_res_304766 = defunc_1_op_res_328280;
            }
        }
    }
    
  cleanup:
    {
        free(reduce_stage_1_tid_res_arr_mem_328274);
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_task_338391_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_task_338391_end -
                 futhark_mc_segred_task_338391_start;
        
        ctx->futhark_mc_segred_task_338391_runs[tid]++;
        ctx->futhark_mc_segred_task_338391_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segred_task_338391_iter[tid] += iterations;
    }
    if (err == 0) {
        *futhark_mc_task_338390->retval_defunc_2_reduce_res_304766 =
            defunc_2_reduce_res_304766;
    }
    return err;
}
static int futhark_mc_segmap_parloop_338389(void *args, int64_t start,
                                            int64_t end, int flat_tid_304763,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338388
    *futhark_mc_segmap_parloop_struct_338388 =
    (struct futhark_mc_segmap_parloop_struct_338388 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338388->ctx;
    uint64_t futhark_mc_segmap_parloop_338389_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338389_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segmap_parloop_struct_338388->free_n_p_292677;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_338388->free_partition_sizze_292766;
    int64_t lifted_single_ma_l_arg_293311 =
            futhark_mc_segmap_parloop_struct_338388->free_lifted_single_ma_l_arg_293311;
    struct memblock mem_314971 = {.desc ="mem_314971", .mem =
                                  futhark_mc_segmap_parloop_struct_338388->free_mem_314971,
                                  .size =0, .references =NULL};
    struct memblock mem_314974 = {.desc ="mem_314974", .mem =
                                  futhark_mc_segmap_parloop_struct_338388->free_mem_314974,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_328264 = start;
    
    for (; iter_328264 < end; iter_328264++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_328271 = partition_sizze_292766;
        int64_t gtid_304764 = iter_328264;
        int64_t remnant_328272 = iter_328264 - gtid_304764;
        double defunc_2_reduce_res_304766;
        int64_t flat_tid_328265 = (int64_t) 0;
        int32_t num_tasks_328273;
        
        defunc_2_reduce_res_304766 = 0.0;
        
        struct futhark_mc_task_338390 futhark_mc_task_338390;
        
        futhark_mc_task_338390.ctx = ctx;
        futhark_mc_task_338390.free_lifted_single_ma_l_arg_293311 =
            lifted_single_ma_l_arg_293311;
        futhark_mc_task_338390.free_gtid_304764 = gtid_304764;
        futhark_mc_task_338390.free_mem_314971 = mem_314971.mem;
        futhark_mc_task_338390.retval_defunc_2_reduce_res_304766 =
            &defunc_2_reduce_res_304766;
        
        struct scheduler_segop futhark_mc_task_338390_task;
        
        futhark_mc_task_338390_task.args = &futhark_mc_task_338390;
        futhark_mc_task_338390_task.top_level_fn =
            futhark_mc_segred_task_338391;
        futhark_mc_task_338390_task.name = "futhark_mc_segred_task_338391";
        futhark_mc_task_338390_task.iterations = n_p_292677;
        futhark_mc_task_338390_task.task_time =
            &ctx->futhark_mc_segred_task_338391_total_time;
        futhark_mc_task_338390_task.task_iter =
            &ctx->futhark_mc_segred_task_338391_total_iter;
        futhark_mc_task_338390_task.sched = STATIC;
        futhark_mc_task_338390_task.nested_fn = NULL;
        
        int futhark_mc_segred_task_338391_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_338390_task);
        
        if (futhark_mc_segred_task_338391_err != 0) {
            ;
            err = futhark_mc_segred_task_338391_err;
            goto cleanup;
        }
        ((double *) mem_314974.mem)[gtid_304764] = defunc_2_reduce_res_304766;
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338389_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338389_end -
                 futhark_mc_segmap_parloop_338389_start;
        
        ctx->futhark_mc_segmap_parloop_338389_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338389_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338389_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_nested_task_338387(void *args, int64_t iterations,
                                         int tid, struct scheduler_info info)
{
    int err = 0;
    int flat_tid_304763 = tid;
    int num_tasks_328255 = info.nsubtasks;
    struct futhark_mc_task_338383 *futhark_mc_task_338383 =
                                  (struct futhark_mc_task_338383 *) args;
    struct futhark_context *ctx = futhark_mc_task_338383->ctx;
    uint64_t futhark_mc_segmap_nested_task_338387_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_nested_task_338387_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_338383->free_n_p_292677;
    int64_t partition_sizze_292766 =
            futhark_mc_task_338383->free_partition_sizze_292766;
    int64_t lifted_single_ma_l_arg_293311 =
            futhark_mc_task_338383->free_lifted_single_ma_l_arg_293311;
    struct memblock mem_314971 = {.desc ="mem_314971", .mem =
                                  futhark_mc_task_338383->free_mem_314971,
                                  .size =0, .references =NULL};
    struct memblock mem_314974 = {.desc ="mem_314974", .mem =
                                  futhark_mc_task_338383->free_mem_314974,
                                  .size =0, .references =NULL};
    int64_t iter_328264;
    struct futhark_mc_segmap_parloop_struct_338388
    futhark_mc_segmap_parloop_struct_338388;
    
    futhark_mc_segmap_parloop_struct_338388.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338388.free_n_p_292677 = n_p_292677;
    futhark_mc_segmap_parloop_struct_338388.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_338388.free_lifted_single_ma_l_arg_293311 =
        lifted_single_ma_l_arg_293311;
    futhark_mc_segmap_parloop_struct_338388.free_mem_314971 = mem_314971.mem;
    futhark_mc_segmap_parloop_struct_338388.free_mem_314974 = mem_314974.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338389_task;
    
    futhark_mc_segmap_parloop_338389_task.name =
        "futhark_mc_segmap_parloop_338389";
    futhark_mc_segmap_parloop_338389_task.fn = futhark_mc_segmap_parloop_338389;
    futhark_mc_segmap_parloop_338389_task.args =
        &futhark_mc_segmap_parloop_struct_338388;
    futhark_mc_segmap_parloop_338389_task.iterations = iterations;
    futhark_mc_segmap_parloop_338389_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338389_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338389_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338389_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338389_task);
    
    if (futhark_mc_segmap_parloop_338389_err != 0) {
        err = futhark_mc_segmap_parloop_338389_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338389_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338389_total_end -
                 futhark_mc_segmap_parloop_338389_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338389_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338389_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338389_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_nested_task_338387_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_nested_task_338387_end -
                 futhark_mc_segmap_nested_task_338387_start;
        
        ctx->futhark_mc_segmap_nested_task_338387_runs[tid]++;
        ctx->futhark_mc_segmap_nested_task_338387_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_nested_task_338387_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_task_338395 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    double free_i64_res_292694;
    int64_t free_partition_sizze_292766;
    int64_t free_lifted_single_ma_l_arg_293311;
    int64_t free_dyn_lifted_single_ma_l_arg_293321;
    unsigned char *free_mem_314971;
    unsigned char *free_mem_314974;
    int64_t free_bytes_314976;
    unsigned char *free_mem_314996;
};
struct futhark_mc_segmap_parloop_struct_338397 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    double free_i64_res_292694;
    int64_t free_partition_sizze_292766;
    int64_t free_lifted_single_ma_l_arg_293311;
    int64_t free_dyn_lifted_single_ma_l_arg_293321;
    unsigned char *free_mem_314971;
    unsigned char *free_mem_314974;
    int64_t free_bytes_314976;
    unsigned char *free_mem_314996;
};
static int futhark_mc_segmap_parloop_338398(void *args, int64_t start,
                                            int64_t end, int flat_tid_304773,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338397
    *futhark_mc_segmap_parloop_struct_338397 =
    (struct futhark_mc_segmap_parloop_struct_338397 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338397->ctx;
    uint64_t futhark_mc_segmap_parloop_338398_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338398_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segmap_parloop_struct_338397->free_n_p_292677;
    double i64_res_292694 =
           futhark_mc_segmap_parloop_struct_338397->free_i64_res_292694;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_338397->free_partition_sizze_292766;
    int64_t lifted_single_ma_l_arg_293311 =
            futhark_mc_segmap_parloop_struct_338397->free_lifted_single_ma_l_arg_293311;
    int64_t dyn_lifted_single_ma_l_arg_293321 =
            futhark_mc_segmap_parloop_struct_338397->free_dyn_lifted_single_ma_l_arg_293321;
    struct memblock mem_314971 = {.desc ="mem_314971", .mem =
                                  futhark_mc_segmap_parloop_struct_338397->free_mem_314971,
                                  .size =0, .references =NULL};
    struct memblock mem_314974 = {.desc ="mem_314974", .mem =
                                  futhark_mc_segmap_parloop_struct_338397->free_mem_314974,
                                  .size =0, .references =NULL};
    int64_t bytes_314976 =
            futhark_mc_segmap_parloop_struct_338397->free_bytes_314976;
    struct memblock mem_314996 = {.desc ="mem_314996", .mem =
                                  futhark_mc_segmap_parloop_struct_338397->free_mem_314996,
                                  .size =0, .references =NULL};
    size_t mem_314980_cached_sizze_338399 = 0;
    unsigned char *mem_314980 = NULL;
    int64_t iterations = end - start;
    int64_t iter_328283 = start;
    
    if (mem_314980_cached_sizze_338399 < (size_t) bytes_314976) {
        mem_314980 = realloc(mem_314980, bytes_314976);
        mem_314980_cached_sizze_338399 = bytes_314976;
    }
    for (; iter_328283 < end; iter_328283++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_328307 = partition_sizze_292766;
        int64_t gtid_304774 = iter_328283;
        int64_t remnant_328308 = iter_328283 - gtid_304774;
        double x_294740;
        
        x_294740 = ((double *) mem_314974.mem)[gtid_304774];
        
        double discard_311501;
        double scanacc_328285 = 0.0;
        
        for (int64_t i_328284 = 0; i_328284 < dyn_lifted_single_ma_l_arg_293321;
             i_328284++) {
            bool cond_328287 = i_328284 == (int64_t) 0;
            double defunc_0_f_res_328288;
            
            if (cond_328287) {
                double defunc_0_f_res_t_res_328289 = x_294740 / i64_res_292694;
                
                defunc_0_f_res_328288 = defunc_0_f_res_t_res_328289;
            } else {
                int64_t x_328290 = add64(n_p_292677, i_328284);
                int64_t i_328291 = sub64(x_328290, (int64_t) 1);
                bool x_328292 = sle64((int64_t) 0, i_328291);
                bool y_328293 = slt64(i_328291, lifted_single_ma_l_arg_293311);
                bool bounds_check_328294 = x_328292 && y_328293;
                bool index_certs_328295;
                
                if (!bounds_check_328294) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [", (long long) i_328291,
                                  "] out of bounds for array of shape [",
                                  (long long) lifted_single_ma_l_arg_293311,
                                  "].",
                                  "-> #0  stl.fut:34:23-36\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  stl.fut:29:13-35:19\n   #5  /prelude/soacs.fut:67:19-23\n   #6  /prelude/soacs.fut:67:3-37\n   #7  stl.fut:28:5-36:23\n   #8  /prelude/functional.fut:9:42-44\n   #9  stl.fut:40:3-64\n   #10 stl.fut:233:23-47\n   #11 stl.fut:419:61-435:77\n   #12 stl.fut:463:3-479:36\n   #13 stl.fut:445:1-479:36\n");
                    err = FUTHARK_PROGRAM_ERROR;
                    goto cleanup;
                }
                
                double x_328296;
                
                x_328296 = ((double *) mem_314971.mem)[gtid_304774 *
                                                       lifted_single_ma_l_arg_293311 +
                                                       i_328291];
                
                int64_t i_328297 = sub64(i_328284, (int64_t) 1);
                bool x_328298 = sle64((int64_t) 0, i_328297);
                bool y_328299 = slt64(i_328297, lifted_single_ma_l_arg_293311);
                bool bounds_check_328300 = x_328298 && y_328299;
                bool index_certs_328301;
                
                if (!bounds_check_328300) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [", (long long) i_328297,
                                  "] out of bounds for array of shape [",
                                  (long long) lifted_single_ma_l_arg_293311,
                                  "].",
                                  "-> #0  stl.fut:34:40-47\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  stl.fut:29:13-35:19\n   #5  /prelude/soacs.fut:67:19-23\n   #6  /prelude/soacs.fut:67:3-37\n   #7  stl.fut:28:5-36:23\n   #8  /prelude/functional.fut:9:42-44\n   #9  stl.fut:40:3-64\n   #10 stl.fut:233:23-47\n   #11 stl.fut:419:61-435:77\n   #12 stl.fut:463:3-479:36\n   #13 stl.fut:445:1-479:36\n");
                    err = FUTHARK_PROGRAM_ERROR;
                    goto cleanup;
                }
                
                double y_328302;
                
                y_328302 = ((double *) mem_314971.mem)[gtid_304774 *
                                                       lifted_single_ma_l_arg_293311 +
                                                       i_328297];
                
                double x_328303 = x_328296 - y_328302;
                double defunc_0_f_res_f_res_328304 = x_328303 / i64_res_292694;
                
                defunc_0_f_res_328288 = defunc_0_f_res_f_res_328304;
            }
            
            double defunc_1_op_res_328305 = defunc_0_f_res_328288 +
                   scanacc_328285;
            
            ((double *) mem_314980)[i_328284] = defunc_1_op_res_328305;
            
            double scanacc_tmp_328309 = defunc_1_op_res_328305;
            
            scanacc_328285 = scanacc_tmp_328309;
        }
        discard_311501 = scanacc_328285;
        if (dyn_lifted_single_ma_l_arg_293321 * (int64_t) 8 > 0)
            memmove(mem_314996.mem + gtid_304774 *
                    dyn_lifted_single_ma_l_arg_293321 * (int64_t) 8,
                    mem_314980 + (int64_t) 0,
                    dyn_lifted_single_ma_l_arg_293321 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_314980);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338398_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338398_end -
                 futhark_mc_segmap_parloop_338398_start;
        
        ctx->futhark_mc_segmap_parloop_338398_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338398_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338398_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_338396(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_304773 = tid;
    int num_tasks_328282 = info.nsubtasks;
    struct futhark_mc_task_338395 *futhark_mc_task_338395 =
                                  (struct futhark_mc_task_338395 *) args;
    struct futhark_context *ctx = futhark_mc_task_338395->ctx;
    uint64_t futhark_mc_segmap_task_338396_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_338396_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_338395->free_n_p_292677;
    double i64_res_292694 = futhark_mc_task_338395->free_i64_res_292694;
    int64_t partition_sizze_292766 =
            futhark_mc_task_338395->free_partition_sizze_292766;
    int64_t lifted_single_ma_l_arg_293311 =
            futhark_mc_task_338395->free_lifted_single_ma_l_arg_293311;
    int64_t dyn_lifted_single_ma_l_arg_293321 =
            futhark_mc_task_338395->free_dyn_lifted_single_ma_l_arg_293321;
    struct memblock mem_314971 = {.desc ="mem_314971", .mem =
                                  futhark_mc_task_338395->free_mem_314971,
                                  .size =0, .references =NULL};
    struct memblock mem_314974 = {.desc ="mem_314974", .mem =
                                  futhark_mc_task_338395->free_mem_314974,
                                  .size =0, .references =NULL};
    int64_t bytes_314976 = futhark_mc_task_338395->free_bytes_314976;
    struct memblock mem_314996 = {.desc ="mem_314996", .mem =
                                  futhark_mc_task_338395->free_mem_314996,
                                  .size =0, .references =NULL};
    int64_t iter_328283;
    struct futhark_mc_segmap_parloop_struct_338397
    futhark_mc_segmap_parloop_struct_338397;
    
    futhark_mc_segmap_parloop_struct_338397.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338397.free_n_p_292677 = n_p_292677;
    futhark_mc_segmap_parloop_struct_338397.free_i64_res_292694 =
        i64_res_292694;
    futhark_mc_segmap_parloop_struct_338397.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_338397.free_lifted_single_ma_l_arg_293311 =
        lifted_single_ma_l_arg_293311;
    futhark_mc_segmap_parloop_struct_338397.free_dyn_lifted_single_ma_l_arg_293321 =
        dyn_lifted_single_ma_l_arg_293321;
    futhark_mc_segmap_parloop_struct_338397.free_mem_314971 = mem_314971.mem;
    futhark_mc_segmap_parloop_struct_338397.free_mem_314974 = mem_314974.mem;
    futhark_mc_segmap_parloop_struct_338397.free_bytes_314976 = bytes_314976;
    futhark_mc_segmap_parloop_struct_338397.free_mem_314996 = mem_314996.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338398_task;
    
    futhark_mc_segmap_parloop_338398_task.name =
        "futhark_mc_segmap_parloop_338398";
    futhark_mc_segmap_parloop_338398_task.fn = futhark_mc_segmap_parloop_338398;
    futhark_mc_segmap_parloop_338398_task.args =
        &futhark_mc_segmap_parloop_struct_338397;
    futhark_mc_segmap_parloop_338398_task.iterations = iterations;
    futhark_mc_segmap_parloop_338398_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338398_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338398_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338398_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338398_task);
    
    if (futhark_mc_segmap_parloop_338398_err != 0) {
        err = futhark_mc_segmap_parloop_338398_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338398_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338398_total_end -
                 futhark_mc_segmap_parloop_338398_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338398_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338398_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338398_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_338396_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_338396_end -
                 futhark_mc_segmap_task_338396_start;
        
        ctx->futhark_mc_segmap_task_338396_runs[tid]++;
        ctx->futhark_mc_segmap_task_338396_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_338396_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_segmap_parloop_struct_338401 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    double free_i64_res_292694;
    int64_t free_partition_sizze_292766;
    int64_t free_lifted_single_ma_l_arg_293311;
    int64_t free_dyn_lifted_single_ma_l_arg_293321;
    unsigned char *free_mem_314971;
    unsigned char *free_mem_314974;
    int64_t free_bytes_314976;
    unsigned char *free_mem_314996;
};
struct futhark_mc_task_338404 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    double free_i64_res_292694;
    int64_t free_lifted_single_ma_l_arg_293311;
    int64_t free_dyn_lifted_single_ma_l_arg_293321;
    int64_t free_gtid_304780;
    double free_x_304782;
    unsigned char *free_mem_314971;
    unsigned char *free_mem_314977;
};
struct futhark_mc_scan_stage_1_parloop_struct_338407 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    double free_i64_res_292694;
    int64_t free_lifted_single_ma_l_arg_293311;
    int64_t free_gtid_304780;
    double free_x_304782;
    unsigned char *free_mem_314971;
    unsigned char *free_mem_314977;
};
static int futhark_mc_scan_stage_1_parloop_338408(void *args, int64_t start,
                                                  int64_t end,
                                                  int flat_tid_328312, int tid)
{
    int err = 0;
    struct futhark_mc_scan_stage_1_parloop_struct_338407
    *futhark_mc_scan_stage_1_parloop_struct_338407 =
    (struct futhark_mc_scan_stage_1_parloop_struct_338407 *) args;
    struct futhark_context *ctx =
                           futhark_mc_scan_stage_1_parloop_struct_338407->ctx;
    uint64_t futhark_mc_scan_stage_1_parloop_338408_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_scan_stage_1_parloop_338408_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_scan_stage_1_parloop_struct_338407->free_n_p_292677;
    double i64_res_292694 =
           futhark_mc_scan_stage_1_parloop_struct_338407->free_i64_res_292694;
    int64_t lifted_single_ma_l_arg_293311 =
            futhark_mc_scan_stage_1_parloop_struct_338407->free_lifted_single_ma_l_arg_293311;
    int64_t gtid_304780 =
            futhark_mc_scan_stage_1_parloop_struct_338407->free_gtid_304780;
    double x_304782 =
           futhark_mc_scan_stage_1_parloop_struct_338407->free_x_304782;
    struct memblock mem_314971 = {.desc ="mem_314971", .mem =
                                  futhark_mc_scan_stage_1_parloop_struct_338407->free_mem_314971,
                                  .size =0, .references =NULL};
    struct memblock mem_314977 = {.desc ="mem_314977", .mem =
                                  futhark_mc_scan_stage_1_parloop_struct_338407->free_mem_314977,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_328338 = start;
    double x_328314;
    double x_328315;
    
    x_328314 = 0.0;
    for (; iter_328338 < end; iter_328338++) {
        int64_t gtid_328313 = iter_328338;
        
        // stage 1 scan body
        {
            bool cond_328317 = gtid_328313 == (int64_t) 0;
            double defunc_0_f_res_328318;
            
            if (cond_328317) {
                double defunc_0_f_res_t_res_328319 = x_304782 / i64_res_292694;
                
                defunc_0_f_res_328318 = defunc_0_f_res_t_res_328319;
            } else {
                int64_t x_328320 = add64(n_p_292677, gtid_328313);
                int64_t i_328321 = sub64(x_328320, (int64_t) 1);
                bool x_328322 = sle64((int64_t) 0, i_328321);
                bool y_328323 = slt64(i_328321, lifted_single_ma_l_arg_293311);
                bool bounds_check_328324 = x_328322 && y_328323;
                bool index_certs_328325;
                
                if (!bounds_check_328324) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [", (long long) i_328321,
                                  "] out of bounds for array of shape [",
                                  (long long) lifted_single_ma_l_arg_293311,
                                  "].",
                                  "-> #0  stl.fut:34:23-36\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  stl.fut:29:13-35:19\n   #5  /prelude/soacs.fut:67:19-23\n   #6  /prelude/soacs.fut:67:3-37\n   #7  stl.fut:28:5-36:23\n   #8  /prelude/functional.fut:9:42-44\n   #9  stl.fut:40:3-64\n   #10 stl.fut:233:23-47\n   #11 stl.fut:419:61-435:77\n   #12 stl.fut:463:3-479:36\n   #13 stl.fut:445:1-479:36\n");
                    err = FUTHARK_PROGRAM_ERROR;
                    goto cleanup;
                }
                
                double x_328326;
                
                x_328326 = ((double *) mem_314971.mem)[gtid_304780 *
                                                       lifted_single_ma_l_arg_293311 +
                                                       i_328321];
                
                int64_t i_328327 = sub64(gtid_328313, (int64_t) 1);
                bool x_328328 = sle64((int64_t) 0, i_328327);
                bool y_328329 = slt64(i_328327, lifted_single_ma_l_arg_293311);
                bool bounds_check_328330 = x_328328 && y_328329;
                bool index_certs_328331;
                
                if (!bounds_check_328330) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [", (long long) i_328327,
                                  "] out of bounds for array of shape [",
                                  (long long) lifted_single_ma_l_arg_293311,
                                  "].",
                                  "-> #0  stl.fut:34:40-47\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  stl.fut:29:13-35:19\n   #5  /prelude/soacs.fut:67:19-23\n   #6  /prelude/soacs.fut:67:3-37\n   #7  stl.fut:28:5-36:23\n   #8  /prelude/functional.fut:9:42-44\n   #9  stl.fut:40:3-64\n   #10 stl.fut:233:23-47\n   #11 stl.fut:419:61-435:77\n   #12 stl.fut:463:3-479:36\n   #13 stl.fut:445:1-479:36\n");
                    err = FUTHARK_PROGRAM_ERROR;
                    goto cleanup;
                }
                
                double y_328332;
                
                y_328332 = ((double *) mem_314971.mem)[gtid_304780 *
                                                       lifted_single_ma_l_arg_293311 +
                                                       i_328327];
                
                double x_328333 = x_328326 - y_328332;
                double defunc_0_f_res_f_res_328334 = x_328333 / i64_res_292694;
                
                defunc_0_f_res_328318 = defunc_0_f_res_f_res_328334;
            }
            // write mapped values results to memory
            { }
            x_328314 = x_328314;
            // Read next values
            {
                x_328315 = defunc_0_f_res_328318;
            }
            
            double defunc_1_op_res_328316 = x_328314 + x_328315;
            
            ((double *) mem_314977.mem)[gtid_328313] = defunc_1_op_res_328316;
            x_328314 = defunc_1_op_res_328316;
        }
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_scan_stage_1_parloop_338408_end = get_wall_time();
        uint64_t elapsed = futhark_mc_scan_stage_1_parloop_338408_end -
                 futhark_mc_scan_stage_1_parloop_338408_start;
        
        ctx->futhark_mc_scan_stage_1_parloop_338408_runs[tid]++;
        ctx->futhark_mc_scan_stage_1_parloop_338408_total_runtime[tid] +=
            elapsed;
        ctx->futhark_mc_scan_stage_1_parloop_338408_iter[tid] += iterations;
    }
    return err;
}
struct futhark_mc_scan_stage_3_parloop_struct_338409 {
    struct futhark_context *ctx;
    int64_t free_n_p_292677;
    double free_i64_res_292694;
    int64_t free_lifted_single_ma_l_arg_293311;
    int64_t free_gtid_304780;
    double free_x_304782;
    unsigned char *free_mem_314971;
    unsigned char *free_mem_314977;
};
static int futhark_mc_scan_stage_3_parloop_338410(void *args, int64_t start,
                                                  int64_t end,
                                                  int flat_tid_328312, int tid)
{
    int err = 0;
    struct futhark_mc_scan_stage_3_parloop_struct_338409
    *futhark_mc_scan_stage_3_parloop_struct_338409 =
    (struct futhark_mc_scan_stage_3_parloop_struct_338409 *) args;
    struct futhark_context *ctx =
                           futhark_mc_scan_stage_3_parloop_struct_338409->ctx;
    uint64_t futhark_mc_scan_stage_3_parloop_338410_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_scan_stage_3_parloop_338410_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_scan_stage_3_parloop_struct_338409->free_n_p_292677;
    double i64_res_292694 =
           futhark_mc_scan_stage_3_parloop_struct_338409->free_i64_res_292694;
    int64_t lifted_single_ma_l_arg_293311 =
            futhark_mc_scan_stage_3_parloop_struct_338409->free_lifted_single_ma_l_arg_293311;
    int64_t gtid_304780 =
            futhark_mc_scan_stage_3_parloop_struct_338409->free_gtid_304780;
    double x_304782 =
           futhark_mc_scan_stage_3_parloop_struct_338409->free_x_304782;
    struct memblock mem_314971 = {.desc ="mem_314971", .mem =
                                  futhark_mc_scan_stage_3_parloop_struct_338409->free_mem_314971,
                                  .size =0, .references =NULL};
    struct memblock mem_314977 = {.desc ="mem_314977", .mem =
                                  futhark_mc_scan_stage_3_parloop_struct_338409->free_mem_314977,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_328350 = start;
    double x_328347;
    double x_328348;
    
    if (iter_328350 == (int64_t) 0) {
        x_328347 = 0.0;
    } else {
        x_328347 = ((double *) mem_314977.mem)[iter_328350 - (int64_t) 1];
    }
    for (; iter_328350 < end; iter_328350++) {
        int64_t gtid_328313 = iter_328350;
        
        // stage 3 scan body
        {
            bool cond_328317 = gtid_328313 == (int64_t) 0;
            double defunc_0_f_res_328318;
            
            if (cond_328317) {
                double defunc_0_f_res_t_res_328319 = x_304782 / i64_res_292694;
                
                defunc_0_f_res_328318 = defunc_0_f_res_t_res_328319;
            } else {
                int64_t x_328320 = add64(n_p_292677, gtid_328313);
                int64_t i_328321 = sub64(x_328320, (int64_t) 1);
                bool x_328322 = sle64((int64_t) 0, i_328321);
                bool y_328323 = slt64(i_328321, lifted_single_ma_l_arg_293311);
                bool bounds_check_328324 = x_328322 && y_328323;
                bool index_certs_328325;
                
                if (!bounds_check_328324) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [", (long long) i_328321,
                                  "] out of bounds for array of shape [",
                                  (long long) lifted_single_ma_l_arg_293311,
                                  "].",
                                  "-> #0  stl.fut:34:23-36\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  stl.fut:29:13-35:19\n   #5  /prelude/soacs.fut:67:19-23\n   #6  /prelude/soacs.fut:67:3-37\n   #7  stl.fut:28:5-36:23\n   #8  /prelude/functional.fut:9:42-44\n   #9  stl.fut:40:3-64\n   #10 stl.fut:233:23-47\n   #11 stl.fut:419:61-435:77\n   #12 stl.fut:463:3-479:36\n   #13 stl.fut:445:1-479:36\n");
                    err = FUTHARK_PROGRAM_ERROR;
                    goto cleanup;
                }
                
                double x_328326;
                
                x_328326 = ((double *) mem_314971.mem)[gtid_304780 *
                                                       lifted_single_ma_l_arg_293311 +
                                                       i_328321];
                
                int64_t i_328327 = sub64(gtid_328313, (int64_t) 1);
                bool x_328328 = sle64((int64_t) 0, i_328327);
                bool y_328329 = slt64(i_328327, lifted_single_ma_l_arg_293311);
                bool bounds_check_328330 = x_328328 && y_328329;
                bool index_certs_328331;
                
                if (!bounds_check_328330) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [", (long long) i_328327,
                                  "] out of bounds for array of shape [",
                                  (long long) lifted_single_ma_l_arg_293311,
                                  "].",
                                  "-> #0  stl.fut:34:40-47\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  stl.fut:29:13-35:19\n   #5  /prelude/soacs.fut:67:19-23\n   #6  /prelude/soacs.fut:67:3-37\n   #7  stl.fut:28:5-36:23\n   #8  /prelude/functional.fut:9:42-44\n   #9  stl.fut:40:3-64\n   #10 stl.fut:233:23-47\n   #11 stl.fut:419:61-435:77\n   #12 stl.fut:463:3-479:36\n   #13 stl.fut:445:1-479:36\n");
                    err = FUTHARK_PROGRAM_ERROR;
                    goto cleanup;
                }
                
                double y_328332;
                
                y_328332 = ((double *) mem_314971.mem)[gtid_304780 *
                                                       lifted_single_ma_l_arg_293311 +
                                                       i_328327];
                
                double x_328333 = x_328326 - y_328332;
                double defunc_0_f_res_f_res_328334 = x_328333 / i64_res_292694;
                
                defunc_0_f_res_328318 = defunc_0_f_res_f_res_328334;
            }
            x_328347 = x_328347;
            x_328348 = defunc_0_f_res_328318;
            
            double defunc_1_op_res_328349 = x_328347 + x_328348;
            
            ((double *) mem_314977.mem)[gtid_328313] = defunc_1_op_res_328349;
            x_328347 = defunc_1_op_res_328349;
        }
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_scan_stage_3_parloop_338410_end = get_wall_time();
        uint64_t elapsed = futhark_mc_scan_stage_3_parloop_338410_end -
                 futhark_mc_scan_stage_3_parloop_338410_start;
        
        ctx->futhark_mc_scan_stage_3_parloop_338410_runs[tid]++;
        ctx->futhark_mc_scan_stage_3_parloop_338410_total_runtime[tid] +=
            elapsed;
        ctx->futhark_mc_scan_stage_3_parloop_338410_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segscan_task_338405(void *args, int64_t iterations, int tid,
                                   struct scheduler_info info)
{
    int err = 0;
    int flat_tid_328312 = tid;
    int num_tasks_328337 = info.nsubtasks;
    struct futhark_mc_task_338404 *futhark_mc_task_338404 =
                                  (struct futhark_mc_task_338404 *) args;
    struct futhark_context *ctx = futhark_mc_task_338404->ctx;
    uint64_t futhark_mc_segscan_task_338405_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segscan_task_338405_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_338404->free_n_p_292677;
    double i64_res_292694 = futhark_mc_task_338404->free_i64_res_292694;
    int64_t lifted_single_ma_l_arg_293311 =
            futhark_mc_task_338404->free_lifted_single_ma_l_arg_293311;
    int64_t dyn_lifted_single_ma_l_arg_293321 =
            futhark_mc_task_338404->free_dyn_lifted_single_ma_l_arg_293321;
    int64_t gtid_304780 = futhark_mc_task_338404->free_gtid_304780;
    double x_304782 = futhark_mc_task_338404->free_x_304782;
    struct memblock mem_314971 = {.desc ="mem_314971", .mem =
                                  futhark_mc_task_338404->free_mem_314971,
                                  .size =0, .references =NULL};
    struct memblock mem_314977 = {.desc ="mem_314977", .mem =
                                  futhark_mc_task_338404->free_mem_314977,
                                  .size =0, .references =NULL};
    size_t scan_stage_2_accum_mem_328344_cached_sizze_338406 = 0;
    unsigned char *scan_stage_2_accum_mem_328344 = NULL;
    int64_t iter_328338;
    struct futhark_mc_scan_stage_1_parloop_struct_338407
    futhark_mc_scan_stage_1_parloop_struct_338407;
    
    futhark_mc_scan_stage_1_parloop_struct_338407.ctx = ctx;
    futhark_mc_scan_stage_1_parloop_struct_338407.free_n_p_292677 = n_p_292677;
    futhark_mc_scan_stage_1_parloop_struct_338407.free_i64_res_292694 =
        i64_res_292694;
    futhark_mc_scan_stage_1_parloop_struct_338407.free_lifted_single_ma_l_arg_293311 =
        lifted_single_ma_l_arg_293311;
    futhark_mc_scan_stage_1_parloop_struct_338407.free_gtid_304780 =
        gtid_304780;
    futhark_mc_scan_stage_1_parloop_struct_338407.free_x_304782 = x_304782;
    futhark_mc_scan_stage_1_parloop_struct_338407.free_mem_314971 =
        mem_314971.mem;
    futhark_mc_scan_stage_1_parloop_struct_338407.free_mem_314977 =
        mem_314977.mem;
    
    struct scheduler_parloop futhark_mc_scan_stage_1_parloop_338408_task;
    
    futhark_mc_scan_stage_1_parloop_338408_task.name =
        "futhark_mc_scan_stage_1_parloop_338408";
    futhark_mc_scan_stage_1_parloop_338408_task.fn =
        futhark_mc_scan_stage_1_parloop_338408;
    futhark_mc_scan_stage_1_parloop_338408_task.args =
        &futhark_mc_scan_stage_1_parloop_struct_338407;
    futhark_mc_scan_stage_1_parloop_338408_task.iterations = iterations;
    futhark_mc_scan_stage_1_parloop_338408_task.info = info;
    
    uint64_t futhark_mc_scan_stage_1_parloop_338408_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_scan_stage_1_parloop_338408_total_start = get_wall_time();
    
    int futhark_mc_scan_stage_1_parloop_338408_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_scan_stage_1_parloop_338408_task);
    
    if (futhark_mc_scan_stage_1_parloop_338408_err != 0) {
        err = futhark_mc_scan_stage_1_parloop_338408_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_scan_stage_1_parloop_338408_total_end =
                 get_wall_time();
        uint64_t elapsed = futhark_mc_scan_stage_1_parloop_338408_total_end -
                 futhark_mc_scan_stage_1_parloop_338408_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_scan_stage_1_parloop_338408_total_runs,
                           1, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_scan_stage_1_parloop_338408_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_scan_stage_1_parloop_338408_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    if (slt32(1, num_tasks_328337)) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "nonsegmentedScan stage 2");
        
        double x_328339;
        double x_328340;
        int64_t offset_328342 = (int64_t) 0;
        int64_t offset_index_328343 = (int64_t) 0;
        
        if (scan_stage_2_accum_mem_328344_cached_sizze_338406 <
            (size_t) (int64_t) 8) {
            scan_stage_2_accum_mem_328344 =
                realloc(scan_stage_2_accum_mem_328344, (int64_t) 8);
            scan_stage_2_accum_mem_328344_cached_sizze_338406 = (int64_t) 8;
        }
        ((double *) scan_stage_2_accum_mem_328344)[(int64_t) 0] = 0.0;
        for (int32_t i_328346 = 0; i_328346 < num_tasks_328337 - 1;
             i_328346++) {
            offset_328342 = squot64(dyn_lifted_single_ma_l_arg_293321,
                                    sext_i32_i64(num_tasks_328337));
            if (slt64(sext_i32_i64(i_328346),
                      srem64(dyn_lifted_single_ma_l_arg_293321,
                             sext_i32_i64(num_tasks_328337)))) {
                offset_328342 += (int64_t) 1;
            }
            offset_index_328343 += offset_328342;
            
            int64_t gtid_328313 = offset_index_328343;
            bool cond_328317 = gtid_328313 == (int64_t) 0;
            double defunc_0_f_res_328318;
            
            if (cond_328317) {
                double defunc_0_f_res_t_res_328319 = x_304782 / i64_res_292694;
                
                defunc_0_f_res_328318 = defunc_0_f_res_t_res_328319;
            } else {
                int64_t x_328320 = add64(n_p_292677, gtid_328313);
                int64_t i_328321 = sub64(x_328320, (int64_t) 1);
                bool x_328322 = sle64((int64_t) 0, i_328321);
                bool y_328323 = slt64(i_328321, lifted_single_ma_l_arg_293311);
                bool bounds_check_328324 = x_328322 && y_328323;
                bool index_certs_328325;
                
                if (!bounds_check_328324) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [", (long long) i_328321,
                                  "] out of bounds for array of shape [",
                                  (long long) lifted_single_ma_l_arg_293311,
                                  "].",
                                  "-> #0  stl.fut:34:23-36\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  stl.fut:29:13-35:19\n   #5  /prelude/soacs.fut:67:19-23\n   #6  /prelude/soacs.fut:67:3-37\n   #7  stl.fut:28:5-36:23\n   #8  /prelude/functional.fut:9:42-44\n   #9  stl.fut:40:3-64\n   #10 stl.fut:233:23-47\n   #11 stl.fut:419:61-435:77\n   #12 stl.fut:463:3-479:36\n   #13 stl.fut:445:1-479:36\n");
                    err = FUTHARK_PROGRAM_ERROR;
                    goto cleanup;
                }
                
                double x_328326;
                
                x_328326 = ((double *) mem_314971.mem)[gtid_304780 *
                                                       lifted_single_ma_l_arg_293311 +
                                                       i_328321];
                
                int64_t i_328327 = sub64(gtid_328313, (int64_t) 1);
                bool x_328328 = sle64((int64_t) 0, i_328327);
                bool y_328329 = slt64(i_328327, lifted_single_ma_l_arg_293311);
                bool bounds_check_328330 = x_328328 && y_328329;
                bool index_certs_328331;
                
                if (!bounds_check_328330) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [", (long long) i_328327,
                                  "] out of bounds for array of shape [",
                                  (long long) lifted_single_ma_l_arg_293311,
                                  "].",
                                  "-> #0  stl.fut:34:40-47\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  stl.fut:29:13-35:19\n   #5  /prelude/soacs.fut:67:19-23\n   #6  /prelude/soacs.fut:67:3-37\n   #7  stl.fut:28:5-36:23\n   #8  /prelude/functional.fut:9:42-44\n   #9  stl.fut:40:3-64\n   #10 stl.fut:233:23-47\n   #11 stl.fut:419:61-435:77\n   #12 stl.fut:463:3-479:36\n   #13 stl.fut:445:1-479:36\n");
                    err = FUTHARK_PROGRAM_ERROR;
                    goto cleanup;
                }
                
                double y_328332;
                
                y_328332 = ((double *) mem_314971.mem)[gtid_304780 *
                                                       lifted_single_ma_l_arg_293311 +
                                                       i_328327];
                
                double x_328333 = x_328326 - y_328332;
                double defunc_0_f_res_f_res_328334 = x_328333 / i64_res_292694;
                
                defunc_0_f_res_328318 = defunc_0_f_res_f_res_328334;
            }
            // Read carry in
            {
                x_328339 =
                    ((double *) scan_stage_2_accum_mem_328344)[(int64_t) 0];
            }
            // Read next values
            {
                x_328340 = ((double *) mem_314977.mem)[offset_index_328343 -
                                                       (int64_t) 1];
            }
            
            double defunc_1_op_res_328341 = x_328339 + x_328340;
            
            ((double *) mem_314977.mem)[offset_index_328343 - (int64_t) 1] =
                defunc_1_op_res_328341;
            ((double *) scan_stage_2_accum_mem_328344)[(int64_t) 0] =
                defunc_1_op_res_328341;
        }
        
        int64_t iter_328350 = (int64_t) 0;
        struct futhark_mc_scan_stage_3_parloop_struct_338409
        futhark_mc_scan_stage_3_parloop_struct_338409;
        
        futhark_mc_scan_stage_3_parloop_struct_338409.ctx = ctx;
        futhark_mc_scan_stage_3_parloop_struct_338409.free_n_p_292677 =
            n_p_292677;
        futhark_mc_scan_stage_3_parloop_struct_338409.free_i64_res_292694 =
            i64_res_292694;
        futhark_mc_scan_stage_3_parloop_struct_338409.free_lifted_single_ma_l_arg_293311 =
            lifted_single_ma_l_arg_293311;
        futhark_mc_scan_stage_3_parloop_struct_338409.free_gtid_304780 =
            gtid_304780;
        futhark_mc_scan_stage_3_parloop_struct_338409.free_x_304782 = x_304782;
        futhark_mc_scan_stage_3_parloop_struct_338409.free_mem_314971 =
            mem_314971.mem;
        futhark_mc_scan_stage_3_parloop_struct_338409.free_mem_314977 =
            mem_314977.mem;
        
        struct scheduler_parloop futhark_mc_scan_stage_3_parloop_338410_task;
        
        futhark_mc_scan_stage_3_parloop_338410_task.name =
            "futhark_mc_scan_stage_3_parloop_338410";
        futhark_mc_scan_stage_3_parloop_338410_task.fn =
            futhark_mc_scan_stage_3_parloop_338410;
        futhark_mc_scan_stage_3_parloop_338410_task.args =
            &futhark_mc_scan_stage_3_parloop_struct_338409;
        futhark_mc_scan_stage_3_parloop_338410_task.iterations = iterations;
        futhark_mc_scan_stage_3_parloop_338410_task.info = info;
        
        uint64_t futhark_mc_scan_stage_3_parloop_338410_total_start = 0;
        
        if (ctx->profiling && !ctx->profiling_paused)
            futhark_mc_scan_stage_3_parloop_338410_total_start =
                get_wall_time();
        
        int futhark_mc_scan_stage_3_parloop_338410_err =
            scheduler_execute_task(&ctx->scheduler,
                                   &futhark_mc_scan_stage_3_parloop_338410_task);
        
        if (futhark_mc_scan_stage_3_parloop_338410_err != 0) {
            err = futhark_mc_scan_stage_3_parloop_338410_err;
            goto cleanup;
        }
        if (ctx->profiling && !ctx->profiling_paused) {
            uint64_t futhark_mc_scan_stage_3_parloop_338410_total_end =
                     get_wall_time();
            uint64_t elapsed =
                     futhark_mc_scan_stage_3_parloop_338410_total_end -
                     futhark_mc_scan_stage_3_parloop_338410_total_start;
            
            __atomic_fetch_add(&ctx->futhark_mc_scan_stage_3_parloop_338410_total_runs,
                               1, __ATOMIC_RELAXED);
            __atomic_fetch_add(&ctx->futhark_mc_scan_stage_3_parloop_338410_total_total_runtime,
                               elapsed, __ATOMIC_RELAXED);
            __atomic_fetch_add(&ctx->futhark_mc_scan_stage_3_parloop_338410_total_iter,
                               iterations, __ATOMIC_RELAXED);
        }
    }
    
  cleanup:
    {
        free(scan_stage_2_accum_mem_328344);
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segscan_task_338405_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segscan_task_338405_end -
                 futhark_mc_segscan_task_338405_start;
        
        ctx->futhark_mc_segscan_task_338405_runs[tid]++;
        ctx->futhark_mc_segscan_task_338405_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segscan_task_338405_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
static int futhark_mc_segmap_parloop_338402(void *args, int64_t start,
                                            int64_t end, int flat_tid_304779,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338401
    *futhark_mc_segmap_parloop_struct_338401 =
    (struct futhark_mc_segmap_parloop_struct_338401 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338401->ctx;
    uint64_t futhark_mc_segmap_parloop_338402_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338402_start = get_wall_time();
    
    int64_t n_p_292677 =
            futhark_mc_segmap_parloop_struct_338401->free_n_p_292677;
    double i64_res_292694 =
           futhark_mc_segmap_parloop_struct_338401->free_i64_res_292694;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_338401->free_partition_sizze_292766;
    int64_t lifted_single_ma_l_arg_293311 =
            futhark_mc_segmap_parloop_struct_338401->free_lifted_single_ma_l_arg_293311;
    int64_t dyn_lifted_single_ma_l_arg_293321 =
            futhark_mc_segmap_parloop_struct_338401->free_dyn_lifted_single_ma_l_arg_293321;
    struct memblock mem_314971 = {.desc ="mem_314971", .mem =
                                  futhark_mc_segmap_parloop_struct_338401->free_mem_314971,
                                  .size =0, .references =NULL};
    struct memblock mem_314974 = {.desc ="mem_314974", .mem =
                                  futhark_mc_segmap_parloop_struct_338401->free_mem_314974,
                                  .size =0, .references =NULL};
    int64_t bytes_314976 =
            futhark_mc_segmap_parloop_struct_338401->free_bytes_314976;
    struct memblock mem_314996 = {.desc ="mem_314996", .mem =
                                  futhark_mc_segmap_parloop_struct_338401->free_mem_314996,
                                  .size =0, .references =NULL};
    size_t mem_314977_cached_sizze_338403 = 0;
    unsigned char *mem_314977 = NULL;
    int64_t iterations = end - start;
    int64_t iter_328311 = start;
    
    if (mem_314977_cached_sizze_338403 < (size_t) bytes_314976) {
        mem_314977 = realloc(mem_314977, bytes_314976);
        mem_314977_cached_sizze_338403 = bytes_314976;
    }
    for (; iter_328311 < end; iter_328311++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_328335 = partition_sizze_292766;
        int64_t gtid_304780 = iter_328311;
        int64_t remnant_328336 = iter_328311 - gtid_304780;
        double x_304782;
        
        x_304782 = ((double *) mem_314974.mem)[gtid_304780];
        
        int64_t flat_tid_328312 = (int64_t) 0;
        int32_t num_tasks_328337;
        
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "nonsegmented segScan");
        
        struct futhark_mc_task_338404 futhark_mc_task_338404;
        
        futhark_mc_task_338404.ctx = ctx;
        futhark_mc_task_338404.free_n_p_292677 = n_p_292677;
        futhark_mc_task_338404.free_i64_res_292694 = i64_res_292694;
        futhark_mc_task_338404.free_lifted_single_ma_l_arg_293311 =
            lifted_single_ma_l_arg_293311;
        futhark_mc_task_338404.free_dyn_lifted_single_ma_l_arg_293321 =
            dyn_lifted_single_ma_l_arg_293321;
        futhark_mc_task_338404.free_gtid_304780 = gtid_304780;
        futhark_mc_task_338404.free_x_304782 = x_304782;
        futhark_mc_task_338404.free_mem_314971 = mem_314971.mem;
        futhark_mc_task_338404.free_mem_314977 = mem_314977;
        
        struct scheduler_segop futhark_mc_task_338404_task;
        
        futhark_mc_task_338404_task.args = &futhark_mc_task_338404;
        futhark_mc_task_338404_task.top_level_fn =
            futhark_mc_segscan_task_338405;
        futhark_mc_task_338404_task.name = "futhark_mc_segscan_task_338405";
        futhark_mc_task_338404_task.iterations =
            dyn_lifted_single_ma_l_arg_293321;
        futhark_mc_task_338404_task.task_time =
            &ctx->futhark_mc_segscan_task_338405_total_time;
        futhark_mc_task_338404_task.task_iter =
            &ctx->futhark_mc_segscan_task_338405_total_iter;
        futhark_mc_task_338404_task.sched = STATIC;
        futhark_mc_task_338404_task.nested_fn = NULL;
        
        int futhark_mc_segscan_task_338405_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_338404_task);
        
        if (futhark_mc_segscan_task_338405_err != 0) {
            ;
            err = futhark_mc_segscan_task_338405_err;
            goto cleanup;
        }
        if (dyn_lifted_single_ma_l_arg_293321 * (int64_t) 8 > 0)
            memmove(mem_314996.mem + gtid_304780 *
                    dyn_lifted_single_ma_l_arg_293321 * (int64_t) 8,
                    mem_314977 + (int64_t) 0,
                    dyn_lifted_single_ma_l_arg_293321 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_314977);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338402_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338402_end -
                 futhark_mc_segmap_parloop_338402_start;
        
        ctx->futhark_mc_segmap_parloop_338402_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338402_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338402_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_nested_task_338400(void *args, int64_t iterations,
                                         int tid, struct scheduler_info info)
{
    int err = 0;
    int flat_tid_304779 = tid;
    int num_tasks_328282 = info.nsubtasks;
    struct futhark_mc_task_338395 *futhark_mc_task_338395 =
                                  (struct futhark_mc_task_338395 *) args;
    struct futhark_context *ctx = futhark_mc_task_338395->ctx;
    uint64_t futhark_mc_segmap_nested_task_338400_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_nested_task_338400_start = get_wall_time();
    
    int64_t n_p_292677 = futhark_mc_task_338395->free_n_p_292677;
    double i64_res_292694 = futhark_mc_task_338395->free_i64_res_292694;
    int64_t partition_sizze_292766 =
            futhark_mc_task_338395->free_partition_sizze_292766;
    int64_t lifted_single_ma_l_arg_293311 =
            futhark_mc_task_338395->free_lifted_single_ma_l_arg_293311;
    int64_t dyn_lifted_single_ma_l_arg_293321 =
            futhark_mc_task_338395->free_dyn_lifted_single_ma_l_arg_293321;
    struct memblock mem_314971 = {.desc ="mem_314971", .mem =
                                  futhark_mc_task_338395->free_mem_314971,
                                  .size =0, .references =NULL};
    struct memblock mem_314974 = {.desc ="mem_314974", .mem =
                                  futhark_mc_task_338395->free_mem_314974,
                                  .size =0, .references =NULL};
    int64_t bytes_314976 = futhark_mc_task_338395->free_bytes_314976;
    struct memblock mem_314996 = {.desc ="mem_314996", .mem =
                                  futhark_mc_task_338395->free_mem_314996,
                                  .size =0, .references =NULL};
    int64_t iter_328311;
    struct futhark_mc_segmap_parloop_struct_338401
    futhark_mc_segmap_parloop_struct_338401;
    
    futhark_mc_segmap_parloop_struct_338401.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338401.free_n_p_292677 = n_p_292677;
    futhark_mc_segmap_parloop_struct_338401.free_i64_res_292694 =
        i64_res_292694;
    futhark_mc_segmap_parloop_struct_338401.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_338401.free_lifted_single_ma_l_arg_293311 =
        lifted_single_ma_l_arg_293311;
    futhark_mc_segmap_parloop_struct_338401.free_dyn_lifted_single_ma_l_arg_293321 =
        dyn_lifted_single_ma_l_arg_293321;
    futhark_mc_segmap_parloop_struct_338401.free_mem_314971 = mem_314971.mem;
    futhark_mc_segmap_parloop_struct_338401.free_mem_314974 = mem_314974.mem;
    futhark_mc_segmap_parloop_struct_338401.free_bytes_314976 = bytes_314976;
    futhark_mc_segmap_parloop_struct_338401.free_mem_314996 = mem_314996.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338402_task;
    
    futhark_mc_segmap_parloop_338402_task.name =
        "futhark_mc_segmap_parloop_338402";
    futhark_mc_segmap_parloop_338402_task.fn = futhark_mc_segmap_parloop_338402;
    futhark_mc_segmap_parloop_338402_task.args =
        &futhark_mc_segmap_parloop_struct_338401;
    futhark_mc_segmap_parloop_338402_task.iterations = iterations;
    futhark_mc_segmap_parloop_338402_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338402_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338402_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338402_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338402_task);
    
    if (futhark_mc_segmap_parloop_338402_err != 0) {
        err = futhark_mc_segmap_parloop_338402_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338402_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338402_total_end -
                 futhark_mc_segmap_parloop_338402_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338402_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338402_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338402_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_nested_task_338400_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_nested_task_338400_end -
                 futhark_mc_segmap_nested_task_338400_start;
        
        ctx->futhark_mc_segmap_nested_task_338400_runs[tid]++;
        ctx->futhark_mc_segmap_nested_task_338400_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_nested_task_338400_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_task_338411 {
    struct futhark_context *ctx;
    int64_t free_partition_sizze_292766;
    int64_t free_dyn_lifted_single_ma_l_arg_293321;
    unsigned char *free_mem_314996;
    unsigned char *free_mem_314999;
};
struct futhark_mc_segmap_parloop_struct_338413 {
    struct futhark_context *ctx;
    int64_t free_partition_sizze_292766;
    int64_t free_dyn_lifted_single_ma_l_arg_293321;
    unsigned char *free_mem_314996;
    unsigned char *free_mem_314999;
};
static int futhark_mc_segmap_parloop_338414(void *args, int64_t start,
                                            int64_t end, int flat_tid_304808,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338413
    *futhark_mc_segmap_parloop_struct_338413 =
    (struct futhark_mc_segmap_parloop_struct_338413 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338413->ctx;
    uint64_t futhark_mc_segmap_parloop_338414_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338414_start = get_wall_time();
    
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_338413->free_partition_sizze_292766;
    int64_t dyn_lifted_single_ma_l_arg_293321 =
            futhark_mc_segmap_parloop_struct_338413->free_dyn_lifted_single_ma_l_arg_293321;
    struct memblock mem_314996 = {.desc ="mem_314996", .mem =
                                  futhark_mc_segmap_parloop_struct_338413->free_mem_314996,
                                  .size =0, .references =NULL};
    struct memblock mem_314999 = {.desc ="mem_314999", .mem =
                                  futhark_mc_segmap_parloop_struct_338413->free_mem_314999,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_328352 = start;
    
    for (; iter_328352 < end; iter_328352++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_328358 = partition_sizze_292766;
        int64_t gtid_304809 = iter_328352;
        int64_t remnant_328359 = iter_328352 - gtid_304809;
        double defunc_2_reduce_res_294768;
        double redout_328354 = 0.0;
        
        for (int32_t i_328353 = 0; i_328353 < 3; i_328353++) {
            int64_t i_328355 = sext_i32_i64(i_328353);
            double x_328356;
            
            x_328356 = ((double *) mem_314996.mem)[gtid_304809 *
                                                   dyn_lifted_single_ma_l_arg_293321 +
                                                   i_328355];
            
            double defunc_1_op_res_328357 = x_328356 + redout_328354;
            double redout_tmp_328360 = defunc_1_op_res_328357;
            
            redout_328354 = redout_tmp_328360;
        }
        defunc_2_reduce_res_294768 = redout_328354;
        ((double *) mem_314999.mem)[gtid_304809] = defunc_2_reduce_res_294768;
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338414_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338414_end -
                 futhark_mc_segmap_parloop_338414_start;
        
        ctx->futhark_mc_segmap_parloop_338414_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338414_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338414_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_338412(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_304808 = tid;
    int num_tasks_328351 = info.nsubtasks;
    struct futhark_mc_task_338411 *futhark_mc_task_338411 =
                                  (struct futhark_mc_task_338411 *) args;
    struct futhark_context *ctx = futhark_mc_task_338411->ctx;
    uint64_t futhark_mc_segmap_task_338412_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_338412_start = get_wall_time();
    
    int64_t partition_sizze_292766 =
            futhark_mc_task_338411->free_partition_sizze_292766;
    int64_t dyn_lifted_single_ma_l_arg_293321 =
            futhark_mc_task_338411->free_dyn_lifted_single_ma_l_arg_293321;
    struct memblock mem_314996 = {.desc ="mem_314996", .mem =
                                  futhark_mc_task_338411->free_mem_314996,
                                  .size =0, .references =NULL};
    struct memblock mem_314999 = {.desc ="mem_314999", .mem =
                                  futhark_mc_task_338411->free_mem_314999,
                                  .size =0, .references =NULL};
    int64_t iter_328352;
    struct futhark_mc_segmap_parloop_struct_338413
    futhark_mc_segmap_parloop_struct_338413;
    
    futhark_mc_segmap_parloop_struct_338413.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338413.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_338413.free_dyn_lifted_single_ma_l_arg_293321 =
        dyn_lifted_single_ma_l_arg_293321;
    futhark_mc_segmap_parloop_struct_338413.free_mem_314996 = mem_314996.mem;
    futhark_mc_segmap_parloop_struct_338413.free_mem_314999 = mem_314999.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338414_task;
    
    futhark_mc_segmap_parloop_338414_task.name =
        "futhark_mc_segmap_parloop_338414";
    futhark_mc_segmap_parloop_338414_task.fn = futhark_mc_segmap_parloop_338414;
    futhark_mc_segmap_parloop_338414_task.args =
        &futhark_mc_segmap_parloop_struct_338413;
    futhark_mc_segmap_parloop_338414_task.iterations = iterations;
    futhark_mc_segmap_parloop_338414_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338414_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338414_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338414_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338414_task);
    
    if (futhark_mc_segmap_parloop_338414_err != 0) {
        err = futhark_mc_segmap_parloop_338414_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338414_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338414_total_end -
                 futhark_mc_segmap_parloop_338414_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338414_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338414_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338414_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_338412_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_338412_end -
                 futhark_mc_segmap_task_338412_start;
        
        ctx->futhark_mc_segmap_task_338412_runs[tid]++;
        ctx->futhark_mc_segmap_task_338412_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_338412_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_segmap_parloop_struct_338416 {
    struct futhark_context *ctx;
    int64_t free_partition_sizze_292766;
    int64_t free_dyn_lifted_single_ma_l_arg_293321;
    unsigned char *free_mem_314996;
    unsigned char *free_mem_314999;
};
struct futhark_mc_task_338418 {
    struct futhark_context *ctx;
    int64_t free_dyn_lifted_single_ma_l_arg_293321;
    int64_t free_gtid_304815;
    unsigned char *free_mem_314996;
    double *retval_defunc_2_reduce_res_304817;
};
struct futhark_mc_segred_stage_1_parloop_struct_338421 {
    struct futhark_context *ctx;
    int64_t free_dyn_lifted_single_ma_l_arg_293321;
    int64_t free_gtid_304815;
    unsigned char *free_mem_314996;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_328371;
};
static int futhark_mc_segred_stage_1_parloop_338422(void *args, int64_t start,
                                                    int64_t end,
                                                    int flat_tid_328362,
                                                    int tid)
{
    int err = 0;
    struct futhark_mc_segred_stage_1_parloop_struct_338421
    *futhark_mc_segred_stage_1_parloop_struct_338421 =
    (struct futhark_mc_segred_stage_1_parloop_struct_338421 *) args;
    struct futhark_context *ctx =
                           futhark_mc_segred_stage_1_parloop_struct_338421->ctx;
    uint64_t futhark_mc_segred_stage_1_parloop_338422_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_338422_start = get_wall_time();
    
    int64_t dyn_lifted_single_ma_l_arg_293321 =
            futhark_mc_segred_stage_1_parloop_struct_338421->free_dyn_lifted_single_ma_l_arg_293321;
    int64_t gtid_304815 =
            futhark_mc_segred_stage_1_parloop_struct_338421->free_gtid_304815;
    struct memblock mem_314996 = {.desc ="mem_314996", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_338421->free_mem_314996,
                                  .size =0, .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_328371 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_328371",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338421->free_reduce_stage_1_tid_res_arr_mem_328371,
                                                             .size =0,
                                                             .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_328373 = start;
    double x_328364;
    double x_328365;
    double local_acc_328374 = 0.0;
    
    for (; iter_328373 < end; iter_328373++) {
        int64_t gtid_328363 = iter_328373;
        double x_328367;
        
        x_328367 = ((double *) mem_314996.mem)[gtid_304815 *
                                               dyn_lifted_single_ma_l_arg_293321 +
                                               gtid_328363];
        // save map-out results
        { }
        // Load accum params
        {
            x_328364 = local_acc_328374;
        }
        // Load next params
        {
            x_328365 = x_328367;
        }
        // Red body
        {
            double defunc_1_op_res_328366 = x_328364 + x_328365;
            
            local_acc_328374 = defunc_1_op_res_328366;
        }
    }
    ((double *) reduce_stage_1_tid_res_arr_mem_328371.mem)[flat_tid_328362] =
        local_acc_328374;
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_338422_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_338422_end -
                 futhark_mc_segred_stage_1_parloop_338422_start;
        
        ctx->futhark_mc_segred_stage_1_parloop_338422_runs[tid]++;
        ctx->futhark_mc_segred_stage_1_parloop_338422_total_runtime[tid] +=
            elapsed;
        ctx->futhark_mc_segred_stage_1_parloop_338422_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segred_task_338419(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_328362 = tid;
    int num_tasks_328370 = info.nsubtasks;
    struct futhark_mc_task_338418 *futhark_mc_task_338418 =
                                  (struct futhark_mc_task_338418 *) args;
    struct futhark_context *ctx = futhark_mc_task_338418->ctx;
    uint64_t futhark_mc_segred_task_338419_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_task_338419_start = get_wall_time();
    
    int64_t dyn_lifted_single_ma_l_arg_293321 =
            futhark_mc_task_338418->free_dyn_lifted_single_ma_l_arg_293321;
    int64_t gtid_304815 = futhark_mc_task_338418->free_gtid_304815;
    struct memblock mem_314996 = {.desc ="mem_314996", .mem =
                                  futhark_mc_task_338418->free_mem_314996,
                                  .size =0, .references =NULL};
    double defunc_2_reduce_res_304817 =
           *futhark_mc_task_338418->retval_defunc_2_reduce_res_304817;
    size_t reduce_stage_1_tid_res_arr_mem_328371_cached_sizze_338420 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_328371 = NULL;
    
    if (reduce_stage_1_tid_res_arr_mem_328371_cached_sizze_338420 <
        (size_t) ((int64_t) 8 * num_tasks_328370)) {
        reduce_stage_1_tid_res_arr_mem_328371 =
            realloc(reduce_stage_1_tid_res_arr_mem_328371, (int64_t) 8 *
                    num_tasks_328370);
        reduce_stage_1_tid_res_arr_mem_328371_cached_sizze_338420 =
            (int64_t) 8 * num_tasks_328370;
    }
    
    int64_t iter_328373;
    struct futhark_mc_segred_stage_1_parloop_struct_338421
    futhark_mc_segred_stage_1_parloop_struct_338421;
    
    futhark_mc_segred_stage_1_parloop_struct_338421.ctx = ctx;
    futhark_mc_segred_stage_1_parloop_struct_338421.free_dyn_lifted_single_ma_l_arg_293321 =
        dyn_lifted_single_ma_l_arg_293321;
    futhark_mc_segred_stage_1_parloop_struct_338421.free_gtid_304815 =
        gtid_304815;
    futhark_mc_segred_stage_1_parloop_struct_338421.free_mem_314996 =
        mem_314996.mem;
    futhark_mc_segred_stage_1_parloop_struct_338421.free_reduce_stage_1_tid_res_arr_mem_328371 =
        reduce_stage_1_tid_res_arr_mem_328371;
    
    struct scheduler_parloop futhark_mc_segred_stage_1_parloop_338422_task;
    
    futhark_mc_segred_stage_1_parloop_338422_task.name =
        "futhark_mc_segred_stage_1_parloop_338422";
    futhark_mc_segred_stage_1_parloop_338422_task.fn =
        futhark_mc_segred_stage_1_parloop_338422;
    futhark_mc_segred_stage_1_parloop_338422_task.args =
        &futhark_mc_segred_stage_1_parloop_struct_338421;
    futhark_mc_segred_stage_1_parloop_338422_task.iterations = iterations;
    futhark_mc_segred_stage_1_parloop_338422_task.info = info;
    
    uint64_t futhark_mc_segred_stage_1_parloop_338422_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_338422_total_start = get_wall_time();
    
    int futhark_mc_segred_stage_1_parloop_338422_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segred_stage_1_parloop_338422_task);
    
    if (futhark_mc_segred_stage_1_parloop_338422_err != 0) {
        err = futhark_mc_segred_stage_1_parloop_338422_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_338422_total_end =
                 get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_338422_total_end -
                 futhark_mc_segred_stage_1_parloop_338422_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338422_total_runs,
                           1, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338422_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338422_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    // neutral-initialise the output
    {
        defunc_2_reduce_res_304817 = 0.0;
    }
    
    double x_328375;
    double x_328376;
    
    for (int32_t i_328378 = 0; i_328378 < num_tasks_328370; i_328378++) {
        flat_tid_328362 = i_328378;
        // Apply main thread reduction
        {
            // load acc params
            {
                x_328375 = defunc_2_reduce_res_304817;
            }
            // load next params
            {
                x_328376 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_328371)[flat_tid_328362];
            }
            // red body
            {
                double defunc_1_op_res_328377 = x_328375 + x_328376;
                
                defunc_2_reduce_res_304817 = defunc_1_op_res_328377;
            }
        }
    }
    
  cleanup:
    {
        free(reduce_stage_1_tid_res_arr_mem_328371);
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_task_338419_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_task_338419_end -
                 futhark_mc_segred_task_338419_start;
        
        ctx->futhark_mc_segred_task_338419_runs[tid]++;
        ctx->futhark_mc_segred_task_338419_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segred_task_338419_iter[tid] += iterations;
    }
    if (err == 0) {
        *futhark_mc_task_338418->retval_defunc_2_reduce_res_304817 =
            defunc_2_reduce_res_304817;
    }
    return err;
}
static int futhark_mc_segmap_parloop_338417(void *args, int64_t start,
                                            int64_t end, int flat_tid_304814,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338416
    *futhark_mc_segmap_parloop_struct_338416 =
    (struct futhark_mc_segmap_parloop_struct_338416 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338416->ctx;
    uint64_t futhark_mc_segmap_parloop_338417_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338417_start = get_wall_time();
    
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_338416->free_partition_sizze_292766;
    int64_t dyn_lifted_single_ma_l_arg_293321 =
            futhark_mc_segmap_parloop_struct_338416->free_dyn_lifted_single_ma_l_arg_293321;
    struct memblock mem_314996 = {.desc ="mem_314996", .mem =
                                  futhark_mc_segmap_parloop_struct_338416->free_mem_314996,
                                  .size =0, .references =NULL};
    struct memblock mem_314999 = {.desc ="mem_314999", .mem =
                                  futhark_mc_segmap_parloop_struct_338416->free_mem_314999,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_328361 = start;
    
    for (; iter_328361 < end; iter_328361++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_328368 = partition_sizze_292766;
        int64_t gtid_304815 = iter_328361;
        int64_t remnant_328369 = iter_328361 - gtid_304815;
        double defunc_2_reduce_res_304817;
        int64_t flat_tid_328362 = (int64_t) 0;
        int32_t num_tasks_328370;
        
        defunc_2_reduce_res_304817 = 0.0;
        
        struct futhark_mc_task_338418 futhark_mc_task_338418;
        
        futhark_mc_task_338418.ctx = ctx;
        futhark_mc_task_338418.free_dyn_lifted_single_ma_l_arg_293321 =
            dyn_lifted_single_ma_l_arg_293321;
        futhark_mc_task_338418.free_gtid_304815 = gtid_304815;
        futhark_mc_task_338418.free_mem_314996 = mem_314996.mem;
        futhark_mc_task_338418.retval_defunc_2_reduce_res_304817 =
            &defunc_2_reduce_res_304817;
        
        struct scheduler_segop futhark_mc_task_338418_task;
        
        futhark_mc_task_338418_task.args = &futhark_mc_task_338418;
        futhark_mc_task_338418_task.top_level_fn =
            futhark_mc_segred_task_338419;
        futhark_mc_task_338418_task.name = "futhark_mc_segred_task_338419";
        futhark_mc_task_338418_task.iterations = (int64_t) 3;
        futhark_mc_task_338418_task.task_time =
            &ctx->futhark_mc_segred_task_338419_total_time;
        futhark_mc_task_338418_task.task_iter =
            &ctx->futhark_mc_segred_task_338419_total_iter;
        futhark_mc_task_338418_task.sched = STATIC;
        futhark_mc_task_338418_task.nested_fn = NULL;
        
        int futhark_mc_segred_task_338419_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_338418_task);
        
        if (futhark_mc_segred_task_338419_err != 0) {
            ;
            err = futhark_mc_segred_task_338419_err;
            goto cleanup;
        }
        ((double *) mem_314999.mem)[gtid_304815] = defunc_2_reduce_res_304817;
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338417_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338417_end -
                 futhark_mc_segmap_parloop_338417_start;
        
        ctx->futhark_mc_segmap_parloop_338417_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338417_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338417_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_nested_task_338415(void *args, int64_t iterations,
                                         int tid, struct scheduler_info info)
{
    int err = 0;
    int flat_tid_304814 = tid;
    int num_tasks_328351 = info.nsubtasks;
    struct futhark_mc_task_338411 *futhark_mc_task_338411 =
                                  (struct futhark_mc_task_338411 *) args;
    struct futhark_context *ctx = futhark_mc_task_338411->ctx;
    uint64_t futhark_mc_segmap_nested_task_338415_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_nested_task_338415_start = get_wall_time();
    
    int64_t partition_sizze_292766 =
            futhark_mc_task_338411->free_partition_sizze_292766;
    int64_t dyn_lifted_single_ma_l_arg_293321 =
            futhark_mc_task_338411->free_dyn_lifted_single_ma_l_arg_293321;
    struct memblock mem_314996 = {.desc ="mem_314996", .mem =
                                  futhark_mc_task_338411->free_mem_314996,
                                  .size =0, .references =NULL};
    struct memblock mem_314999 = {.desc ="mem_314999", .mem =
                                  futhark_mc_task_338411->free_mem_314999,
                                  .size =0, .references =NULL};
    int64_t iter_328361;
    struct futhark_mc_segmap_parloop_struct_338416
    futhark_mc_segmap_parloop_struct_338416;
    
    futhark_mc_segmap_parloop_struct_338416.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338416.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_338416.free_dyn_lifted_single_ma_l_arg_293321 =
        dyn_lifted_single_ma_l_arg_293321;
    futhark_mc_segmap_parloop_struct_338416.free_mem_314996 = mem_314996.mem;
    futhark_mc_segmap_parloop_struct_338416.free_mem_314999 = mem_314999.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338417_task;
    
    futhark_mc_segmap_parloop_338417_task.name =
        "futhark_mc_segmap_parloop_338417";
    futhark_mc_segmap_parloop_338417_task.fn = futhark_mc_segmap_parloop_338417;
    futhark_mc_segmap_parloop_338417_task.args =
        &futhark_mc_segmap_parloop_struct_338416;
    futhark_mc_segmap_parloop_338417_task.iterations = iterations;
    futhark_mc_segmap_parloop_338417_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338417_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338417_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338417_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338417_task);
    
    if (futhark_mc_segmap_parloop_338417_err != 0) {
        err = futhark_mc_segmap_parloop_338417_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338417_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338417_total_end -
                 futhark_mc_segmap_parloop_338417_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338417_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338417_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338417_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_nested_task_338415_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_nested_task_338415_end -
                 futhark_mc_segmap_nested_task_338415_start;
        
        ctx->futhark_mc_segmap_nested_task_338415_runs[tid]++;
        ctx->futhark_mc_segmap_nested_task_338415_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_nested_task_338415_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_task_338423 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_partition_sizze_292766;
    int64_t free_dyn_lifted_single_ma_l_arg_293321;
    int64_t free_bytes_312598;
    unsigned char *free_mem_314996;
    unsigned char *free_mem_314999;
    unsigned char *free_mem_315021;
};
struct futhark_mc_segmap_parloop_struct_338425 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_partition_sizze_292766;
    int64_t free_dyn_lifted_single_ma_l_arg_293321;
    int64_t free_bytes_312598;
    unsigned char *free_mem_314996;
    unsigned char *free_mem_314999;
    unsigned char *free_mem_315021;
};
static int futhark_mc_segmap_parloop_338426(void *args, int64_t start,
                                            int64_t end, int flat_tid_304824,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338425
    *futhark_mc_segmap_parloop_struct_338425 =
    (struct futhark_mc_segmap_parloop_struct_338425 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338425->ctx;
    uint64_t futhark_mc_segmap_parloop_338426_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338426_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_338425->free_n_292675;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_338425->free_partition_sizze_292766;
    int64_t dyn_lifted_single_ma_l_arg_293321 =
            futhark_mc_segmap_parloop_struct_338425->free_dyn_lifted_single_ma_l_arg_293321;
    int64_t bytes_312598 =
            futhark_mc_segmap_parloop_struct_338425->free_bytes_312598;
    struct memblock mem_314996 = {.desc ="mem_314996", .mem =
                                  futhark_mc_segmap_parloop_struct_338425->free_mem_314996,
                                  .size =0, .references =NULL};
    struct memblock mem_314999 = {.desc ="mem_314999", .mem =
                                  futhark_mc_segmap_parloop_struct_338425->free_mem_314999,
                                  .size =0, .references =NULL};
    struct memblock mem_315021 = {.desc ="mem_315021", .mem =
                                  futhark_mc_segmap_parloop_struct_338425->free_mem_315021,
                                  .size =0, .references =NULL};
    size_t mem_315005_cached_sizze_338427 = 0;
    unsigned char *mem_315005 = NULL;
    int64_t iterations = end - start;
    int64_t iter_328380 = start;
    
    if (mem_315005_cached_sizze_338427 < (size_t) bytes_312598) {
        mem_315005 = realloc(mem_315005, bytes_312598);
        mem_315005_cached_sizze_338427 = bytes_312598;
    }
    for (; iter_328380 < end; iter_328380++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_328404 = partition_sizze_292766;
        int64_t gtid_304825 = iter_328380;
        int64_t remnant_328405 = iter_328380 - gtid_304825;
        double x_294776;
        
        x_294776 = ((double *) mem_314999.mem)[gtid_304825];
        
        double discard_311509;
        double scanacc_328382 = 0.0;
        
        for (int64_t i_328381 = 0; i_328381 < n_292675; i_328381++) {
            bool cond_328384 = i_328381 == (int64_t) 0;
            double defunc_0_f_res_328385;
            
            if (cond_328384) {
                double defunc_0_f_res_t_res_328386 = x_294776 / 3.0;
                
                defunc_0_f_res_328385 = defunc_0_f_res_t_res_328386;
            } else {
                int64_t x_328387 = add64((int64_t) 3, i_328381);
                int64_t i_328388 = sub64(x_328387, (int64_t) 1);
                bool x_328389 = sle64((int64_t) 0, i_328388);
                bool y_328390 = slt64(i_328388,
                                      dyn_lifted_single_ma_l_arg_293321);
                bool bounds_check_328391 = x_328389 && y_328390;
                bool index_certs_328392;
                
                if (!bounds_check_328391) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [", (long long) i_328388,
                                  "] out of bounds for array of shape [",
                                  (long long) dyn_lifted_single_ma_l_arg_293321,
                                  "].",
                                  "-> #0  stl.fut:34:23-36\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  stl.fut:29:13-35:19\n   #5  /prelude/soacs.fut:67:19-23\n   #6  /prelude/soacs.fut:67:3-37\n   #7  stl.fut:28:5-36:23\n   #8  /prelude/functional.fut:9:42-44\n   #9  stl.fut:40:3-84\n   #10 stl.fut:233:23-47\n   #11 stl.fut:419:61-435:77\n   #12 stl.fut:463:3-479:36\n   #13 stl.fut:445:1-479:36\n");
                    err = FUTHARK_PROGRAM_ERROR;
                    goto cleanup;
                }
                
                double x_328393;
                
                x_328393 = ((double *) mem_314996.mem)[gtid_304825 *
                                                       dyn_lifted_single_ma_l_arg_293321 +
                                                       i_328388];
                
                int64_t i_328394 = sub64(i_328381, (int64_t) 1);
                bool x_328395 = sle64((int64_t) 0, i_328394);
                bool y_328396 = slt64(i_328394,
                                      dyn_lifted_single_ma_l_arg_293321);
                bool bounds_check_328397 = x_328395 && y_328396;
                bool index_certs_328398;
                
                if (!bounds_check_328397) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [", (long long) i_328394,
                                  "] out of bounds for array of shape [",
                                  (long long) dyn_lifted_single_ma_l_arg_293321,
                                  "].",
                                  "-> #0  stl.fut:34:40-47\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  stl.fut:29:13-35:19\n   #5  /prelude/soacs.fut:67:19-23\n   #6  /prelude/soacs.fut:67:3-37\n   #7  stl.fut:28:5-36:23\n   #8  /prelude/functional.fut:9:42-44\n   #9  stl.fut:40:3-84\n   #10 stl.fut:233:23-47\n   #11 stl.fut:419:61-435:77\n   #12 stl.fut:463:3-479:36\n   #13 stl.fut:445:1-479:36\n");
                    err = FUTHARK_PROGRAM_ERROR;
                    goto cleanup;
                }
                
                double y_328399;
                
                y_328399 = ((double *) mem_314996.mem)[gtid_304825 *
                                                       dyn_lifted_single_ma_l_arg_293321 +
                                                       i_328394];
                
                double x_328400 = x_328393 - y_328399;
                double defunc_0_f_res_f_res_328401 = x_328400 / 3.0;
                
                defunc_0_f_res_328385 = defunc_0_f_res_f_res_328401;
            }
            
            double defunc_1_op_res_328402 = defunc_0_f_res_328385 +
                   scanacc_328382;
            
            ((double *) mem_315005)[i_328381] = defunc_1_op_res_328402;
            
            double scanacc_tmp_328406 = defunc_1_op_res_328402;
            
            scanacc_328382 = scanacc_tmp_328406;
        }
        discard_311509 = scanacc_328382;
        if (n_292675 * (int64_t) 8 > 0)
            memmove(mem_315021.mem + gtid_304825 * n_292675 * (int64_t) 8,
                    mem_315005 + (int64_t) 0, n_292675 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_315005);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338426_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338426_end -
                 futhark_mc_segmap_parloop_338426_start;
        
        ctx->futhark_mc_segmap_parloop_338426_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338426_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338426_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_338424(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_304824 = tid;
    int num_tasks_328379 = info.nsubtasks;
    struct futhark_mc_task_338423 *futhark_mc_task_338423 =
                                  (struct futhark_mc_task_338423 *) args;
    struct futhark_context *ctx = futhark_mc_task_338423->ctx;
    uint64_t futhark_mc_segmap_task_338424_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_338424_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338423->free_n_292675;
    int64_t partition_sizze_292766 =
            futhark_mc_task_338423->free_partition_sizze_292766;
    int64_t dyn_lifted_single_ma_l_arg_293321 =
            futhark_mc_task_338423->free_dyn_lifted_single_ma_l_arg_293321;
    int64_t bytes_312598 = futhark_mc_task_338423->free_bytes_312598;
    struct memblock mem_314996 = {.desc ="mem_314996", .mem =
                                  futhark_mc_task_338423->free_mem_314996,
                                  .size =0, .references =NULL};
    struct memblock mem_314999 = {.desc ="mem_314999", .mem =
                                  futhark_mc_task_338423->free_mem_314999,
                                  .size =0, .references =NULL};
    struct memblock mem_315021 = {.desc ="mem_315021", .mem =
                                  futhark_mc_task_338423->free_mem_315021,
                                  .size =0, .references =NULL};
    int64_t iter_328380;
    struct futhark_mc_segmap_parloop_struct_338425
    futhark_mc_segmap_parloop_struct_338425;
    
    futhark_mc_segmap_parloop_struct_338425.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338425.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_338425.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_338425.free_dyn_lifted_single_ma_l_arg_293321 =
        dyn_lifted_single_ma_l_arg_293321;
    futhark_mc_segmap_parloop_struct_338425.free_bytes_312598 = bytes_312598;
    futhark_mc_segmap_parloop_struct_338425.free_mem_314996 = mem_314996.mem;
    futhark_mc_segmap_parloop_struct_338425.free_mem_314999 = mem_314999.mem;
    futhark_mc_segmap_parloop_struct_338425.free_mem_315021 = mem_315021.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338426_task;
    
    futhark_mc_segmap_parloop_338426_task.name =
        "futhark_mc_segmap_parloop_338426";
    futhark_mc_segmap_parloop_338426_task.fn = futhark_mc_segmap_parloop_338426;
    futhark_mc_segmap_parloop_338426_task.args =
        &futhark_mc_segmap_parloop_struct_338425;
    futhark_mc_segmap_parloop_338426_task.iterations = iterations;
    futhark_mc_segmap_parloop_338426_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338426_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338426_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338426_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338426_task);
    
    if (futhark_mc_segmap_parloop_338426_err != 0) {
        err = futhark_mc_segmap_parloop_338426_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338426_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338426_total_end -
                 futhark_mc_segmap_parloop_338426_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338426_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338426_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338426_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_338424_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_338424_end -
                 futhark_mc_segmap_task_338424_start;
        
        ctx->futhark_mc_segmap_task_338424_runs[tid]++;
        ctx->futhark_mc_segmap_task_338424_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_338424_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_segmap_parloop_struct_338429 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_partition_sizze_292766;
    int64_t free_dyn_lifted_single_ma_l_arg_293321;
    int64_t free_bytes_312598;
    unsigned char *free_mem_314996;
    unsigned char *free_mem_314999;
    unsigned char *free_mem_315021;
};
struct futhark_mc_task_338432 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_dyn_lifted_single_ma_l_arg_293321;
    int64_t free_gtid_304831;
    double free_x_304833;
    unsigned char *free_mem_314996;
    unsigned char *free_mem_315002;
};
struct futhark_mc_scan_stage_1_parloop_struct_338435 {
    struct futhark_context *ctx;
    int64_t free_dyn_lifted_single_ma_l_arg_293321;
    int64_t free_gtid_304831;
    double free_x_304833;
    unsigned char *free_mem_314996;
    unsigned char *free_mem_315002;
};
static int futhark_mc_scan_stage_1_parloop_338436(void *args, int64_t start,
                                                  int64_t end,
                                                  int flat_tid_328409, int tid)
{
    int err = 0;
    struct futhark_mc_scan_stage_1_parloop_struct_338435
    *futhark_mc_scan_stage_1_parloop_struct_338435 =
    (struct futhark_mc_scan_stage_1_parloop_struct_338435 *) args;
    struct futhark_context *ctx =
                           futhark_mc_scan_stage_1_parloop_struct_338435->ctx;
    uint64_t futhark_mc_scan_stage_1_parloop_338436_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_scan_stage_1_parloop_338436_start = get_wall_time();
    
    int64_t dyn_lifted_single_ma_l_arg_293321 =
            futhark_mc_scan_stage_1_parloop_struct_338435->free_dyn_lifted_single_ma_l_arg_293321;
    int64_t gtid_304831 =
            futhark_mc_scan_stage_1_parloop_struct_338435->free_gtid_304831;
    double x_304833 =
           futhark_mc_scan_stage_1_parloop_struct_338435->free_x_304833;
    struct memblock mem_314996 = {.desc ="mem_314996", .mem =
                                  futhark_mc_scan_stage_1_parloop_struct_338435->free_mem_314996,
                                  .size =0, .references =NULL};
    struct memblock mem_315002 = {.desc ="mem_315002", .mem =
                                  futhark_mc_scan_stage_1_parloop_struct_338435->free_mem_315002,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_328435 = start;
    double x_328411;
    double x_328412;
    
    x_328411 = 0.0;
    for (; iter_328435 < end; iter_328435++) {
        int64_t gtid_328410 = iter_328435;
        
        // stage 1 scan body
        {
            bool cond_328414 = gtid_328410 == (int64_t) 0;
            double defunc_0_f_res_328415;
            
            if (cond_328414) {
                double defunc_0_f_res_t_res_328416 = x_304833 / 3.0;
                
                defunc_0_f_res_328415 = defunc_0_f_res_t_res_328416;
            } else {
                int64_t x_328417 = add64((int64_t) 3, gtid_328410);
                int64_t i_328418 = sub64(x_328417, (int64_t) 1);
                bool x_328419 = sle64((int64_t) 0, i_328418);
                bool y_328420 = slt64(i_328418,
                                      dyn_lifted_single_ma_l_arg_293321);
                bool bounds_check_328421 = x_328419 && y_328420;
                bool index_certs_328422;
                
                if (!bounds_check_328421) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [", (long long) i_328418,
                                  "] out of bounds for array of shape [",
                                  (long long) dyn_lifted_single_ma_l_arg_293321,
                                  "].",
                                  "-> #0  stl.fut:34:23-36\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  stl.fut:29:13-35:19\n   #5  /prelude/soacs.fut:67:19-23\n   #6  /prelude/soacs.fut:67:3-37\n   #7  stl.fut:28:5-36:23\n   #8  /prelude/functional.fut:9:42-44\n   #9  stl.fut:40:3-84\n   #10 stl.fut:233:23-47\n   #11 stl.fut:419:61-435:77\n   #12 stl.fut:463:3-479:36\n   #13 stl.fut:445:1-479:36\n");
                    err = FUTHARK_PROGRAM_ERROR;
                    goto cleanup;
                }
                
                double x_328423;
                
                x_328423 = ((double *) mem_314996.mem)[gtid_304831 *
                                                       dyn_lifted_single_ma_l_arg_293321 +
                                                       i_328418];
                
                int64_t i_328424 = sub64(gtid_328410, (int64_t) 1);
                bool x_328425 = sle64((int64_t) 0, i_328424);
                bool y_328426 = slt64(i_328424,
                                      dyn_lifted_single_ma_l_arg_293321);
                bool bounds_check_328427 = x_328425 && y_328426;
                bool index_certs_328428;
                
                if (!bounds_check_328427) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [", (long long) i_328424,
                                  "] out of bounds for array of shape [",
                                  (long long) dyn_lifted_single_ma_l_arg_293321,
                                  "].",
                                  "-> #0  stl.fut:34:40-47\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  stl.fut:29:13-35:19\n   #5  /prelude/soacs.fut:67:19-23\n   #6  /prelude/soacs.fut:67:3-37\n   #7  stl.fut:28:5-36:23\n   #8  /prelude/functional.fut:9:42-44\n   #9  stl.fut:40:3-84\n   #10 stl.fut:233:23-47\n   #11 stl.fut:419:61-435:77\n   #12 stl.fut:463:3-479:36\n   #13 stl.fut:445:1-479:36\n");
                    err = FUTHARK_PROGRAM_ERROR;
                    goto cleanup;
                }
                
                double y_328429;
                
                y_328429 = ((double *) mem_314996.mem)[gtid_304831 *
                                                       dyn_lifted_single_ma_l_arg_293321 +
                                                       i_328424];
                
                double x_328430 = x_328423 - y_328429;
                double defunc_0_f_res_f_res_328431 = x_328430 / 3.0;
                
                defunc_0_f_res_328415 = defunc_0_f_res_f_res_328431;
            }
            // write mapped values results to memory
            { }
            x_328411 = x_328411;
            // Read next values
            {
                x_328412 = defunc_0_f_res_328415;
            }
            
            double defunc_1_op_res_328413 = x_328411 + x_328412;
            
            ((double *) mem_315002.mem)[gtid_328410] = defunc_1_op_res_328413;
            x_328411 = defunc_1_op_res_328413;
        }
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_scan_stage_1_parloop_338436_end = get_wall_time();
        uint64_t elapsed = futhark_mc_scan_stage_1_parloop_338436_end -
                 futhark_mc_scan_stage_1_parloop_338436_start;
        
        ctx->futhark_mc_scan_stage_1_parloop_338436_runs[tid]++;
        ctx->futhark_mc_scan_stage_1_parloop_338436_total_runtime[tid] +=
            elapsed;
        ctx->futhark_mc_scan_stage_1_parloop_338436_iter[tid] += iterations;
    }
    return err;
}
struct futhark_mc_scan_stage_3_parloop_struct_338437 {
    struct futhark_context *ctx;
    int64_t free_dyn_lifted_single_ma_l_arg_293321;
    int64_t free_gtid_304831;
    double free_x_304833;
    unsigned char *free_mem_314996;
    unsigned char *free_mem_315002;
};
static int futhark_mc_scan_stage_3_parloop_338438(void *args, int64_t start,
                                                  int64_t end,
                                                  int flat_tid_328409, int tid)
{
    int err = 0;
    struct futhark_mc_scan_stage_3_parloop_struct_338437
    *futhark_mc_scan_stage_3_parloop_struct_338437 =
    (struct futhark_mc_scan_stage_3_parloop_struct_338437 *) args;
    struct futhark_context *ctx =
                           futhark_mc_scan_stage_3_parloop_struct_338437->ctx;
    uint64_t futhark_mc_scan_stage_3_parloop_338438_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_scan_stage_3_parloop_338438_start = get_wall_time();
    
    int64_t dyn_lifted_single_ma_l_arg_293321 =
            futhark_mc_scan_stage_3_parloop_struct_338437->free_dyn_lifted_single_ma_l_arg_293321;
    int64_t gtid_304831 =
            futhark_mc_scan_stage_3_parloop_struct_338437->free_gtid_304831;
    double x_304833 =
           futhark_mc_scan_stage_3_parloop_struct_338437->free_x_304833;
    struct memblock mem_314996 = {.desc ="mem_314996", .mem =
                                  futhark_mc_scan_stage_3_parloop_struct_338437->free_mem_314996,
                                  .size =0, .references =NULL};
    struct memblock mem_315002 = {.desc ="mem_315002", .mem =
                                  futhark_mc_scan_stage_3_parloop_struct_338437->free_mem_315002,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_328447 = start;
    double x_328444;
    double x_328445;
    
    if (iter_328447 == (int64_t) 0) {
        x_328444 = 0.0;
    } else {
        x_328444 = ((double *) mem_315002.mem)[iter_328447 - (int64_t) 1];
    }
    for (; iter_328447 < end; iter_328447++) {
        int64_t gtid_328410 = iter_328447;
        
        // stage 3 scan body
        {
            bool cond_328414 = gtid_328410 == (int64_t) 0;
            double defunc_0_f_res_328415;
            
            if (cond_328414) {
                double defunc_0_f_res_t_res_328416 = x_304833 / 3.0;
                
                defunc_0_f_res_328415 = defunc_0_f_res_t_res_328416;
            } else {
                int64_t x_328417 = add64((int64_t) 3, gtid_328410);
                int64_t i_328418 = sub64(x_328417, (int64_t) 1);
                bool x_328419 = sle64((int64_t) 0, i_328418);
                bool y_328420 = slt64(i_328418,
                                      dyn_lifted_single_ma_l_arg_293321);
                bool bounds_check_328421 = x_328419 && y_328420;
                bool index_certs_328422;
                
                if (!bounds_check_328421) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [", (long long) i_328418,
                                  "] out of bounds for array of shape [",
                                  (long long) dyn_lifted_single_ma_l_arg_293321,
                                  "].",
                                  "-> #0  stl.fut:34:23-36\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  stl.fut:29:13-35:19\n   #5  /prelude/soacs.fut:67:19-23\n   #6  /prelude/soacs.fut:67:3-37\n   #7  stl.fut:28:5-36:23\n   #8  /prelude/functional.fut:9:42-44\n   #9  stl.fut:40:3-84\n   #10 stl.fut:233:23-47\n   #11 stl.fut:419:61-435:77\n   #12 stl.fut:463:3-479:36\n   #13 stl.fut:445:1-479:36\n");
                    err = FUTHARK_PROGRAM_ERROR;
                    goto cleanup;
                }
                
                double x_328423;
                
                x_328423 = ((double *) mem_314996.mem)[gtid_304831 *
                                                       dyn_lifted_single_ma_l_arg_293321 +
                                                       i_328418];
                
                int64_t i_328424 = sub64(gtid_328410, (int64_t) 1);
                bool x_328425 = sle64((int64_t) 0, i_328424);
                bool y_328426 = slt64(i_328424,
                                      dyn_lifted_single_ma_l_arg_293321);
                bool bounds_check_328427 = x_328425 && y_328426;
                bool index_certs_328428;
                
                if (!bounds_check_328427) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [", (long long) i_328424,
                                  "] out of bounds for array of shape [",
                                  (long long) dyn_lifted_single_ma_l_arg_293321,
                                  "].",
                                  "-> #0  stl.fut:34:40-47\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  stl.fut:29:13-35:19\n   #5  /prelude/soacs.fut:67:19-23\n   #6  /prelude/soacs.fut:67:3-37\n   #7  stl.fut:28:5-36:23\n   #8  /prelude/functional.fut:9:42-44\n   #9  stl.fut:40:3-84\n   #10 stl.fut:233:23-47\n   #11 stl.fut:419:61-435:77\n   #12 stl.fut:463:3-479:36\n   #13 stl.fut:445:1-479:36\n");
                    err = FUTHARK_PROGRAM_ERROR;
                    goto cleanup;
                }
                
                double y_328429;
                
                y_328429 = ((double *) mem_314996.mem)[gtid_304831 *
                                                       dyn_lifted_single_ma_l_arg_293321 +
                                                       i_328424];
                
                double x_328430 = x_328423 - y_328429;
                double defunc_0_f_res_f_res_328431 = x_328430 / 3.0;
                
                defunc_0_f_res_328415 = defunc_0_f_res_f_res_328431;
            }
            x_328444 = x_328444;
            x_328445 = defunc_0_f_res_328415;
            
            double defunc_1_op_res_328446 = x_328444 + x_328445;
            
            ((double *) mem_315002.mem)[gtid_328410] = defunc_1_op_res_328446;
            x_328444 = defunc_1_op_res_328446;
        }
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_scan_stage_3_parloop_338438_end = get_wall_time();
        uint64_t elapsed = futhark_mc_scan_stage_3_parloop_338438_end -
                 futhark_mc_scan_stage_3_parloop_338438_start;
        
        ctx->futhark_mc_scan_stage_3_parloop_338438_runs[tid]++;
        ctx->futhark_mc_scan_stage_3_parloop_338438_total_runtime[tid] +=
            elapsed;
        ctx->futhark_mc_scan_stage_3_parloop_338438_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segscan_task_338433(void *args, int64_t iterations, int tid,
                                   struct scheduler_info info)
{
    int err = 0;
    int flat_tid_328409 = tid;
    int num_tasks_328434 = info.nsubtasks;
    struct futhark_mc_task_338432 *futhark_mc_task_338432 =
                                  (struct futhark_mc_task_338432 *) args;
    struct futhark_context *ctx = futhark_mc_task_338432->ctx;
    uint64_t futhark_mc_segscan_task_338433_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segscan_task_338433_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338432->free_n_292675;
    int64_t dyn_lifted_single_ma_l_arg_293321 =
            futhark_mc_task_338432->free_dyn_lifted_single_ma_l_arg_293321;
    int64_t gtid_304831 = futhark_mc_task_338432->free_gtid_304831;
    double x_304833 = futhark_mc_task_338432->free_x_304833;
    struct memblock mem_314996 = {.desc ="mem_314996", .mem =
                                  futhark_mc_task_338432->free_mem_314996,
                                  .size =0, .references =NULL};
    struct memblock mem_315002 = {.desc ="mem_315002", .mem =
                                  futhark_mc_task_338432->free_mem_315002,
                                  .size =0, .references =NULL};
    size_t scan_stage_2_accum_mem_328441_cached_sizze_338434 = 0;
    unsigned char *scan_stage_2_accum_mem_328441 = NULL;
    int64_t iter_328435;
    struct futhark_mc_scan_stage_1_parloop_struct_338435
    futhark_mc_scan_stage_1_parloop_struct_338435;
    
    futhark_mc_scan_stage_1_parloop_struct_338435.ctx = ctx;
    futhark_mc_scan_stage_1_parloop_struct_338435.free_dyn_lifted_single_ma_l_arg_293321 =
        dyn_lifted_single_ma_l_arg_293321;
    futhark_mc_scan_stage_1_parloop_struct_338435.free_gtid_304831 =
        gtid_304831;
    futhark_mc_scan_stage_1_parloop_struct_338435.free_x_304833 = x_304833;
    futhark_mc_scan_stage_1_parloop_struct_338435.free_mem_314996 =
        mem_314996.mem;
    futhark_mc_scan_stage_1_parloop_struct_338435.free_mem_315002 =
        mem_315002.mem;
    
    struct scheduler_parloop futhark_mc_scan_stage_1_parloop_338436_task;
    
    futhark_mc_scan_stage_1_parloop_338436_task.name =
        "futhark_mc_scan_stage_1_parloop_338436";
    futhark_mc_scan_stage_1_parloop_338436_task.fn =
        futhark_mc_scan_stage_1_parloop_338436;
    futhark_mc_scan_stage_1_parloop_338436_task.args =
        &futhark_mc_scan_stage_1_parloop_struct_338435;
    futhark_mc_scan_stage_1_parloop_338436_task.iterations = iterations;
    futhark_mc_scan_stage_1_parloop_338436_task.info = info;
    
    uint64_t futhark_mc_scan_stage_1_parloop_338436_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_scan_stage_1_parloop_338436_total_start = get_wall_time();
    
    int futhark_mc_scan_stage_1_parloop_338436_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_scan_stage_1_parloop_338436_task);
    
    if (futhark_mc_scan_stage_1_parloop_338436_err != 0) {
        err = futhark_mc_scan_stage_1_parloop_338436_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_scan_stage_1_parloop_338436_total_end =
                 get_wall_time();
        uint64_t elapsed = futhark_mc_scan_stage_1_parloop_338436_total_end -
                 futhark_mc_scan_stage_1_parloop_338436_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_scan_stage_1_parloop_338436_total_runs,
                           1, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_scan_stage_1_parloop_338436_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_scan_stage_1_parloop_338436_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    if (slt32(1, num_tasks_328434)) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "nonsegmentedScan stage 2");
        
        double x_328436;
        double x_328437;
        int64_t offset_328439 = (int64_t) 0;
        int64_t offset_index_328440 = (int64_t) 0;
        
        if (scan_stage_2_accum_mem_328441_cached_sizze_338434 <
            (size_t) (int64_t) 8) {
            scan_stage_2_accum_mem_328441 =
                realloc(scan_stage_2_accum_mem_328441, (int64_t) 8);
            scan_stage_2_accum_mem_328441_cached_sizze_338434 = (int64_t) 8;
        }
        ((double *) scan_stage_2_accum_mem_328441)[(int64_t) 0] = 0.0;
        for (int32_t i_328443 = 0; i_328443 < num_tasks_328434 - 1;
             i_328443++) {
            offset_328439 = squot64(n_292675, sext_i32_i64(num_tasks_328434));
            if (slt64(sext_i32_i64(i_328443), srem64(n_292675,
                                                     sext_i32_i64(num_tasks_328434)))) {
                offset_328439 += (int64_t) 1;
            }
            offset_index_328440 += offset_328439;
            
            int64_t gtid_328410 = offset_index_328440;
            bool cond_328414 = gtid_328410 == (int64_t) 0;
            double defunc_0_f_res_328415;
            
            if (cond_328414) {
                double defunc_0_f_res_t_res_328416 = x_304833 / 3.0;
                
                defunc_0_f_res_328415 = defunc_0_f_res_t_res_328416;
            } else {
                int64_t x_328417 = add64((int64_t) 3, gtid_328410);
                int64_t i_328418 = sub64(x_328417, (int64_t) 1);
                bool x_328419 = sle64((int64_t) 0, i_328418);
                bool y_328420 = slt64(i_328418,
                                      dyn_lifted_single_ma_l_arg_293321);
                bool bounds_check_328421 = x_328419 && y_328420;
                bool index_certs_328422;
                
                if (!bounds_check_328421) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [", (long long) i_328418,
                                  "] out of bounds for array of shape [",
                                  (long long) dyn_lifted_single_ma_l_arg_293321,
                                  "].",
                                  "-> #0  stl.fut:34:23-36\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  stl.fut:29:13-35:19\n   #5  /prelude/soacs.fut:67:19-23\n   #6  /prelude/soacs.fut:67:3-37\n   #7  stl.fut:28:5-36:23\n   #8  /prelude/functional.fut:9:42-44\n   #9  stl.fut:40:3-84\n   #10 stl.fut:233:23-47\n   #11 stl.fut:419:61-435:77\n   #12 stl.fut:463:3-479:36\n   #13 stl.fut:445:1-479:36\n");
                    err = FUTHARK_PROGRAM_ERROR;
                    goto cleanup;
                }
                
                double x_328423;
                
                x_328423 = ((double *) mem_314996.mem)[gtid_304831 *
                                                       dyn_lifted_single_ma_l_arg_293321 +
                                                       i_328418];
                
                int64_t i_328424 = sub64(gtid_328410, (int64_t) 1);
                bool x_328425 = sle64((int64_t) 0, i_328424);
                bool y_328426 = slt64(i_328424,
                                      dyn_lifted_single_ma_l_arg_293321);
                bool bounds_check_328427 = x_328425 && y_328426;
                bool index_certs_328428;
                
                if (!bounds_check_328427) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [", (long long) i_328424,
                                  "] out of bounds for array of shape [",
                                  (long long) dyn_lifted_single_ma_l_arg_293321,
                                  "].",
                                  "-> #0  stl.fut:34:40-47\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  stl.fut:29:13-35:19\n   #5  /prelude/soacs.fut:67:19-23\n   #6  /prelude/soacs.fut:67:3-37\n   #7  stl.fut:28:5-36:23\n   #8  /prelude/functional.fut:9:42-44\n   #9  stl.fut:40:3-84\n   #10 stl.fut:233:23-47\n   #11 stl.fut:419:61-435:77\n   #12 stl.fut:463:3-479:36\n   #13 stl.fut:445:1-479:36\n");
                    err = FUTHARK_PROGRAM_ERROR;
                    goto cleanup;
                }
                
                double y_328429;
                
                y_328429 = ((double *) mem_314996.mem)[gtid_304831 *
                                                       dyn_lifted_single_ma_l_arg_293321 +
                                                       i_328424];
                
                double x_328430 = x_328423 - y_328429;
                double defunc_0_f_res_f_res_328431 = x_328430 / 3.0;
                
                defunc_0_f_res_328415 = defunc_0_f_res_f_res_328431;
            }
            // Read carry in
            {
                x_328436 =
                    ((double *) scan_stage_2_accum_mem_328441)[(int64_t) 0];
            }
            // Read next values
            {
                x_328437 = ((double *) mem_315002.mem)[offset_index_328440 -
                                                       (int64_t) 1];
            }
            
            double defunc_1_op_res_328438 = x_328436 + x_328437;
            
            ((double *) mem_315002.mem)[offset_index_328440 - (int64_t) 1] =
                defunc_1_op_res_328438;
            ((double *) scan_stage_2_accum_mem_328441)[(int64_t) 0] =
                defunc_1_op_res_328438;
        }
        
        int64_t iter_328447 = (int64_t) 0;
        struct futhark_mc_scan_stage_3_parloop_struct_338437
        futhark_mc_scan_stage_3_parloop_struct_338437;
        
        futhark_mc_scan_stage_3_parloop_struct_338437.ctx = ctx;
        futhark_mc_scan_stage_3_parloop_struct_338437.free_dyn_lifted_single_ma_l_arg_293321 =
            dyn_lifted_single_ma_l_arg_293321;
        futhark_mc_scan_stage_3_parloop_struct_338437.free_gtid_304831 =
            gtid_304831;
        futhark_mc_scan_stage_3_parloop_struct_338437.free_x_304833 = x_304833;
        futhark_mc_scan_stage_3_parloop_struct_338437.free_mem_314996 =
            mem_314996.mem;
        futhark_mc_scan_stage_3_parloop_struct_338437.free_mem_315002 =
            mem_315002.mem;
        
        struct scheduler_parloop futhark_mc_scan_stage_3_parloop_338438_task;
        
        futhark_mc_scan_stage_3_parloop_338438_task.name =
            "futhark_mc_scan_stage_3_parloop_338438";
        futhark_mc_scan_stage_3_parloop_338438_task.fn =
            futhark_mc_scan_stage_3_parloop_338438;
        futhark_mc_scan_stage_3_parloop_338438_task.args =
            &futhark_mc_scan_stage_3_parloop_struct_338437;
        futhark_mc_scan_stage_3_parloop_338438_task.iterations = iterations;
        futhark_mc_scan_stage_3_parloop_338438_task.info = info;
        
        uint64_t futhark_mc_scan_stage_3_parloop_338438_total_start = 0;
        
        if (ctx->profiling && !ctx->profiling_paused)
            futhark_mc_scan_stage_3_parloop_338438_total_start =
                get_wall_time();
        
        int futhark_mc_scan_stage_3_parloop_338438_err =
            scheduler_execute_task(&ctx->scheduler,
                                   &futhark_mc_scan_stage_3_parloop_338438_task);
        
        if (futhark_mc_scan_stage_3_parloop_338438_err != 0) {
            err = futhark_mc_scan_stage_3_parloop_338438_err;
            goto cleanup;
        }
        if (ctx->profiling && !ctx->profiling_paused) {
            uint64_t futhark_mc_scan_stage_3_parloop_338438_total_end =
                     get_wall_time();
            uint64_t elapsed =
                     futhark_mc_scan_stage_3_parloop_338438_total_end -
                     futhark_mc_scan_stage_3_parloop_338438_total_start;
            
            __atomic_fetch_add(&ctx->futhark_mc_scan_stage_3_parloop_338438_total_runs,
                               1, __ATOMIC_RELAXED);
            __atomic_fetch_add(&ctx->futhark_mc_scan_stage_3_parloop_338438_total_total_runtime,
                               elapsed, __ATOMIC_RELAXED);
            __atomic_fetch_add(&ctx->futhark_mc_scan_stage_3_parloop_338438_total_iter,
                               iterations, __ATOMIC_RELAXED);
        }
    }
    
  cleanup:
    {
        free(scan_stage_2_accum_mem_328441);
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segscan_task_338433_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segscan_task_338433_end -
                 futhark_mc_segscan_task_338433_start;
        
        ctx->futhark_mc_segscan_task_338433_runs[tid]++;
        ctx->futhark_mc_segscan_task_338433_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segscan_task_338433_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
static int futhark_mc_segmap_parloop_338430(void *args, int64_t start,
                                            int64_t end, int flat_tid_304830,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338429
    *futhark_mc_segmap_parloop_struct_338429 =
    (struct futhark_mc_segmap_parloop_struct_338429 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338429->ctx;
    uint64_t futhark_mc_segmap_parloop_338430_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338430_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_338429->free_n_292675;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_338429->free_partition_sizze_292766;
    int64_t dyn_lifted_single_ma_l_arg_293321 =
            futhark_mc_segmap_parloop_struct_338429->free_dyn_lifted_single_ma_l_arg_293321;
    int64_t bytes_312598 =
            futhark_mc_segmap_parloop_struct_338429->free_bytes_312598;
    struct memblock mem_314996 = {.desc ="mem_314996", .mem =
                                  futhark_mc_segmap_parloop_struct_338429->free_mem_314996,
                                  .size =0, .references =NULL};
    struct memblock mem_314999 = {.desc ="mem_314999", .mem =
                                  futhark_mc_segmap_parloop_struct_338429->free_mem_314999,
                                  .size =0, .references =NULL};
    struct memblock mem_315021 = {.desc ="mem_315021", .mem =
                                  futhark_mc_segmap_parloop_struct_338429->free_mem_315021,
                                  .size =0, .references =NULL};
    size_t mem_315002_cached_sizze_338431 = 0;
    unsigned char *mem_315002 = NULL;
    int64_t iterations = end - start;
    int64_t iter_328408 = start;
    
    if (mem_315002_cached_sizze_338431 < (size_t) bytes_312598) {
        mem_315002 = realloc(mem_315002, bytes_312598);
        mem_315002_cached_sizze_338431 = bytes_312598;
    }
    for (; iter_328408 < end; iter_328408++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_328432 = partition_sizze_292766;
        int64_t gtid_304831 = iter_328408;
        int64_t remnant_328433 = iter_328408 - gtid_304831;
        double x_304833;
        
        x_304833 = ((double *) mem_314999.mem)[gtid_304831];
        
        int64_t flat_tid_328409 = (int64_t) 0;
        int32_t num_tasks_328434;
        
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "nonsegmented segScan");
        
        struct futhark_mc_task_338432 futhark_mc_task_338432;
        
        futhark_mc_task_338432.ctx = ctx;
        futhark_mc_task_338432.free_n_292675 = n_292675;
        futhark_mc_task_338432.free_dyn_lifted_single_ma_l_arg_293321 =
            dyn_lifted_single_ma_l_arg_293321;
        futhark_mc_task_338432.free_gtid_304831 = gtid_304831;
        futhark_mc_task_338432.free_x_304833 = x_304833;
        futhark_mc_task_338432.free_mem_314996 = mem_314996.mem;
        futhark_mc_task_338432.free_mem_315002 = mem_315002;
        
        struct scheduler_segop futhark_mc_task_338432_task;
        
        futhark_mc_task_338432_task.args = &futhark_mc_task_338432;
        futhark_mc_task_338432_task.top_level_fn =
            futhark_mc_segscan_task_338433;
        futhark_mc_task_338432_task.name = "futhark_mc_segscan_task_338433";
        futhark_mc_task_338432_task.iterations = n_292675;
        futhark_mc_task_338432_task.task_time =
            &ctx->futhark_mc_segscan_task_338433_total_time;
        futhark_mc_task_338432_task.task_iter =
            &ctx->futhark_mc_segscan_task_338433_total_iter;
        futhark_mc_task_338432_task.sched = STATIC;
        futhark_mc_task_338432_task.nested_fn = NULL;
        
        int futhark_mc_segscan_task_338433_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_338432_task);
        
        if (futhark_mc_segscan_task_338433_err != 0) {
            ;
            err = futhark_mc_segscan_task_338433_err;
            goto cleanup;
        }
        if (n_292675 * (int64_t) 8 > 0)
            memmove(mem_315021.mem + gtid_304831 * n_292675 * (int64_t) 8,
                    mem_315002 + (int64_t) 0, n_292675 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_315002);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338430_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338430_end -
                 futhark_mc_segmap_parloop_338430_start;
        
        ctx->futhark_mc_segmap_parloop_338430_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338430_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338430_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_nested_task_338428(void *args, int64_t iterations,
                                         int tid, struct scheduler_info info)
{
    int err = 0;
    int flat_tid_304830 = tid;
    int num_tasks_328379 = info.nsubtasks;
    struct futhark_mc_task_338423 *futhark_mc_task_338423 =
                                  (struct futhark_mc_task_338423 *) args;
    struct futhark_context *ctx = futhark_mc_task_338423->ctx;
    uint64_t futhark_mc_segmap_nested_task_338428_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_nested_task_338428_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338423->free_n_292675;
    int64_t partition_sizze_292766 =
            futhark_mc_task_338423->free_partition_sizze_292766;
    int64_t dyn_lifted_single_ma_l_arg_293321 =
            futhark_mc_task_338423->free_dyn_lifted_single_ma_l_arg_293321;
    int64_t bytes_312598 = futhark_mc_task_338423->free_bytes_312598;
    struct memblock mem_314996 = {.desc ="mem_314996", .mem =
                                  futhark_mc_task_338423->free_mem_314996,
                                  .size =0, .references =NULL};
    struct memblock mem_314999 = {.desc ="mem_314999", .mem =
                                  futhark_mc_task_338423->free_mem_314999,
                                  .size =0, .references =NULL};
    struct memblock mem_315021 = {.desc ="mem_315021", .mem =
                                  futhark_mc_task_338423->free_mem_315021,
                                  .size =0, .references =NULL};
    int64_t iter_328408;
    struct futhark_mc_segmap_parloop_struct_338429
    futhark_mc_segmap_parloop_struct_338429;
    
    futhark_mc_segmap_parloop_struct_338429.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338429.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_338429.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_338429.free_dyn_lifted_single_ma_l_arg_293321 =
        dyn_lifted_single_ma_l_arg_293321;
    futhark_mc_segmap_parloop_struct_338429.free_bytes_312598 = bytes_312598;
    futhark_mc_segmap_parloop_struct_338429.free_mem_314996 = mem_314996.mem;
    futhark_mc_segmap_parloop_struct_338429.free_mem_314999 = mem_314999.mem;
    futhark_mc_segmap_parloop_struct_338429.free_mem_315021 = mem_315021.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338430_task;
    
    futhark_mc_segmap_parloop_338430_task.name =
        "futhark_mc_segmap_parloop_338430";
    futhark_mc_segmap_parloop_338430_task.fn = futhark_mc_segmap_parloop_338430;
    futhark_mc_segmap_parloop_338430_task.args =
        &futhark_mc_segmap_parloop_struct_338429;
    futhark_mc_segmap_parloop_338430_task.iterations = iterations;
    futhark_mc_segmap_parloop_338430_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338430_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338430_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338430_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338430_task);
    
    if (futhark_mc_segmap_parloop_338430_err != 0) {
        err = futhark_mc_segmap_parloop_338430_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338430_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338430_total_end -
                 futhark_mc_segmap_parloop_338430_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338430_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338430_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338430_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_nested_task_338428_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_nested_task_338428_end -
                 futhark_mc_segmap_nested_task_338428_start;
        
        ctx->futhark_mc_segmap_nested_task_338428_runs[tid]++;
        ctx->futhark_mc_segmap_nested_task_338428_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_nested_task_338428_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_task_338439 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_l_292680;
    int64_t free_jump_t_292685;
    int64_t free_partition_sizze_292766;
    int64_t free_l_n_m_292832;
    int64_t free_i_292846;
    int64_t free_bytes_313028;
    unsigned char *free_mem_313081;
    unsigned char *free_mem_313085;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315021;
    unsigned char *free_mem_315047;
};
struct futhark_mc_segmap_parloop_struct_338441 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_l_292680;
    int64_t free_jump_t_292685;
    int64_t free_partition_sizze_292766;
    int64_t free_l_n_m_292832;
    int64_t free_i_292846;
    int64_t free_bytes_313028;
    unsigned char *free_mem_313081;
    unsigned char *free_mem_313085;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315021;
    unsigned char *free_mem_315047;
};
static int futhark_mc_segmap_parloop_338442(void *args, int64_t start,
                                            int64_t end, int flat_tid_304859,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338441
    *futhark_mc_segmap_parloop_struct_338441 =
    (struct futhark_mc_segmap_parloop_struct_338441 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338441->ctx;
    uint64_t futhark_mc_segmap_parloop_338442_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338442_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_338441->free_n_292675;
    int64_t q_l_292680 =
            futhark_mc_segmap_parloop_struct_338441->free_q_l_292680;
    int64_t jump_t_292685 =
            futhark_mc_segmap_parloop_struct_338441->free_jump_t_292685;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_338441->free_partition_sizze_292766;
    int64_t l_n_m_292832 =
            futhark_mc_segmap_parloop_struct_338441->free_l_n_m_292832;
    int64_t i_292846 = futhark_mc_segmap_parloop_struct_338441->free_i_292846;
    int64_t bytes_313028 =
            futhark_mc_segmap_parloop_struct_338441->free_bytes_313028;
    struct memblock mem_313081 = {.desc ="mem_313081", .mem =
                                  futhark_mc_segmap_parloop_struct_338441->free_mem_313081,
                                  .size =0, .references =NULL};
    struct memblock mem_313085 = {.desc ="mem_313085", .mem =
                                  futhark_mc_segmap_parloop_struct_338441->free_mem_313085,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_segmap_parloop_struct_338441->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_segmap_parloop_struct_338441->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_segmap_parloop_struct_338441->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_segmap_parloop_struct_338441->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315021 = {.desc ="mem_315021", .mem =
                                  futhark_mc_segmap_parloop_struct_338441->free_mem_315021,
                                  .size =0, .references =NULL};
    struct memblock mem_315047 = {.desc ="mem_315047", .mem =
                                  futhark_mc_segmap_parloop_struct_338441->free_mem_315047,
                                  .size =0, .references =NULL};
    size_t mem_315031_cached_sizze_338443 = 0;
    unsigned char *mem_315031 = NULL;
    int64_t iterations = end - start;
    int64_t iter_328451 = start;
    
    if (mem_315031_cached_sizze_338443 < (size_t) bytes_313028) {
        mem_315031 = realloc(mem_315031, bytes_313028);
        mem_315031_cached_sizze_338443 = bytes_313028;
    }
    for (; iter_328451 < end; iter_328451++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_328509 = partition_sizze_292766;
        int64_t gtid_304860 = iter_328451;
        int64_t remnant_328510 = iter_328451 - gtid_304860;
        
        for (int64_t i_328452 = 0; i_328452 < l_n_m_292832; i_328452++) {
            int64_t x_328454;
            
            x_328454 = ((int64_t *) mem_313081.mem)[gtid_304860 * l_n_m_292832 +
                                                    i_328452];
            
            double x_328455;
            
            x_328455 = ((double *) mem_313085.mem)[gtid_304860 * l_n_m_292832 +
                                                   i_328452];
            
            int64_t min_arg_328456 = mul64(jump_t_292685, i_328452);
            int64_t min_res_328457 = smin64(i_292846, min_arg_328456);
            int64_t defunc_0_g_res_328458 = add64((int64_t) 1, min_res_328457);
            double defunc_2_reduce_res_328459;
            double redout_328461 = 0.0;
            
            for (int64_t i_328460 = 0; i_328460 < q_l_292680; i_328460++) {
                bool cond_328462 = sle64(n_292675, i_328460);
                int64_t defunc_0_f_res_328463;
                
                if (cond_328462) {
                    defunc_0_f_res_328463 = (int64_t) 0;
                } else {
                    int64_t i_328464 = add64(x_328454, i_328460);
                    int64_t defunc_1_add_res_328465 = add64((int64_t) 1,
                                                            i_328464);
                    
                    defunc_0_f_res_328463 = defunc_1_add_res_328465;
                }
                
                double defunc_0_f_res_328466;
                
                if (cond_328462) {
                    defunc_0_f_res_328466 = 0.0;
                } else {
                    int64_t i_328467 = add64(x_328454, i_328460);
                    double defunc_0_add_arg_328468;
                    
                    defunc_0_add_arg_328468 =
                        ((double *) mem_param_313179.mem)[ctx_param_ext_313174 +
                                                          (gtid_304860 *
                                                           ctx_param_ext_313175 +
                                                           i_328467 *
                                                           ctx_param_ext_313177)];
                    defunc_0_f_res_328466 = defunc_0_add_arg_328468;
                }
                
                int64_t binop_p_328469 = sub64(defunc_0_f_res_328463,
                                               defunc_0_g_res_328458);
                double defunc_0_f_res_328470 = sitofp_i64_f64(binop_p_328469);
                double abs_res_328471 = fabs(defunc_0_f_res_328470);
                double tmp1_328472 = abs_res_328471 / x_328455;
                double x_328473 = tmp1_328472 * tmp1_328472;
                double y_328474 = tmp1_328472 * x_328473;
                double tmp2_328475 = 1.0 - y_328474;
                double x_328476 = tmp2_328475 * tmp2_328475;
                double tmp3_328477 = tmp2_328475 * x_328476;
                double w_j_328478 = defunc_0_f_res_328466 * tmp3_328477;
                double defunc_1_op_res_328479 = w_j_328478 + redout_328461;
                double redout_tmp_328512 = defunc_1_op_res_328479;
                
                redout_328461 = redout_tmp_328512;
            }
            defunc_2_reduce_res_328459 = redout_328461;
            
            double a_328480 = 2.220446049250313e-16 +
                   defunc_2_reduce_res_328459;
            double a0_328481 = 1.0 / a_328480;
            double defunc_2_reduce_res_328482;
            double redout_328484 = 0.0;
            
            for (int64_t i_328483 = 0; i_328483 < q_l_292680; i_328483++) {
                bool cond_328485 = sle64(n_292675, i_328483);
                int64_t defunc_0_f_res_328486;
                
                if (cond_328485) {
                    defunc_0_f_res_328486 = (int64_t) 0;
                } else {
                    int64_t i_328487 = add64(x_328454, i_328483);
                    int64_t defunc_1_add_res_328488 = add64((int64_t) 1,
                                                            i_328487);
                    
                    defunc_0_f_res_328486 = defunc_1_add_res_328488;
                }
                
                double defunc_0_f_res_328489;
                
                if (cond_328485) {
                    defunc_0_f_res_328489 = 0.0;
                } else {
                    int64_t i_328490 = add64(x_328454, i_328483);
                    double defunc_0_add_arg_328491;
                    
                    defunc_0_add_arg_328491 =
                        ((double *) mem_param_313179.mem)[ctx_param_ext_313174 +
                                                          (gtid_304860 *
                                                           ctx_param_ext_313175 +
                                                           i_328490 *
                                                           ctx_param_ext_313177)];
                    defunc_0_f_res_328489 = defunc_0_add_arg_328491;
                }
                
                int64_t binop_p_328492 = sub64(defunc_0_f_res_328486,
                                               defunc_0_g_res_328458);
                double defunc_0_f_res_328493 = sitofp_i64_f64(binop_p_328492);
                double abs_res_328494 = fabs(defunc_0_f_res_328493);
                double tmp1_328495 = abs_res_328494 / x_328455;
                double x_328496 = tmp1_328495 * tmp1_328495;
                double y_328497 = tmp1_328495 * x_328496;
                double tmp2_328498 = 1.0 - y_328497;
                double x_328499 = tmp2_328498 * tmp2_328498;
                double tmp3_328500 = tmp2_328498 * x_328499;
                double tmp4_328501 = defunc_0_f_res_328489 * tmp3_328500;
                double defunc_0_f_res_328502;
                
                if (cond_328485) {
                    defunc_0_f_res_328502 = 0.0;
                } else {
                    int64_t i_328503 = add64(x_328454, i_328483);
                    double defunc_0_add_arg_328504;
                    
                    defunc_0_add_arg_328504 =
                        ((double *) mem_315021.mem)[gtid_304860 * n_292675 +
                                                    i_328503];
                    defunc_0_f_res_328502 = defunc_0_add_arg_328504;
                }
                
                double x_328505 = a0_328481 * tmp4_328501;
                double defunc_9_fit_fun_res_328506 = defunc_0_f_res_328502 *
                       x_328505;
                double defunc_1_op_res_328507 = defunc_9_fit_fun_res_328506 +
                       redout_328484;
                double redout_tmp_328513 = defunc_1_op_res_328507;
                
                redout_328484 = redout_tmp_328513;
            }
            defunc_2_reduce_res_328482 = redout_328484;
            ((double *) mem_315031)[i_328452] = defunc_2_reduce_res_328482;
        }
        if (l_n_m_292832 * (int64_t) 8 > 0)
            memmove(mem_315047.mem + gtid_304860 * l_n_m_292832 * (int64_t) 8,
                    mem_315031 + (int64_t) 0, l_n_m_292832 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_315031);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338442_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338442_end -
                 futhark_mc_segmap_parloop_338442_start;
        
        ctx->futhark_mc_segmap_parloop_338442_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338442_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338442_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_338440(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_304859 = tid;
    int num_tasks_328450 = info.nsubtasks;
    struct futhark_mc_task_338439 *futhark_mc_task_338439 =
                                  (struct futhark_mc_task_338439 *) args;
    struct futhark_context *ctx = futhark_mc_task_338439->ctx;
    uint64_t futhark_mc_segmap_task_338440_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_338440_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338439->free_n_292675;
    int64_t q_l_292680 = futhark_mc_task_338439->free_q_l_292680;
    int64_t jump_t_292685 = futhark_mc_task_338439->free_jump_t_292685;
    int64_t partition_sizze_292766 =
            futhark_mc_task_338439->free_partition_sizze_292766;
    int64_t l_n_m_292832 = futhark_mc_task_338439->free_l_n_m_292832;
    int64_t i_292846 = futhark_mc_task_338439->free_i_292846;
    int64_t bytes_313028 = futhark_mc_task_338439->free_bytes_313028;
    struct memblock mem_313081 = {.desc ="mem_313081", .mem =
                                  futhark_mc_task_338439->free_mem_313081,
                                  .size =0, .references =NULL};
    struct memblock mem_313085 = {.desc ="mem_313085", .mem =
                                  futhark_mc_task_338439->free_mem_313085,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_task_338439->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_task_338439->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_task_338439->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_task_338439->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315021 = {.desc ="mem_315021", .mem =
                                  futhark_mc_task_338439->free_mem_315021,
                                  .size =0, .references =NULL};
    struct memblock mem_315047 = {.desc ="mem_315047", .mem =
                                  futhark_mc_task_338439->free_mem_315047,
                                  .size =0, .references =NULL};
    int64_t iter_328451;
    struct futhark_mc_segmap_parloop_struct_338441
    futhark_mc_segmap_parloop_struct_338441;
    
    futhark_mc_segmap_parloop_struct_338441.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338441.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_338441.free_q_l_292680 = q_l_292680;
    futhark_mc_segmap_parloop_struct_338441.free_jump_t_292685 = jump_t_292685;
    futhark_mc_segmap_parloop_struct_338441.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_338441.free_l_n_m_292832 = l_n_m_292832;
    futhark_mc_segmap_parloop_struct_338441.free_i_292846 = i_292846;
    futhark_mc_segmap_parloop_struct_338441.free_bytes_313028 = bytes_313028;
    futhark_mc_segmap_parloop_struct_338441.free_mem_313081 = mem_313081.mem;
    futhark_mc_segmap_parloop_struct_338441.free_mem_313085 = mem_313085.mem;
    futhark_mc_segmap_parloop_struct_338441.free_ctx_param_ext_313174 =
        ctx_param_ext_313174;
    futhark_mc_segmap_parloop_struct_338441.free_ctx_param_ext_313175 =
        ctx_param_ext_313175;
    futhark_mc_segmap_parloop_struct_338441.free_ctx_param_ext_313177 =
        ctx_param_ext_313177;
    futhark_mc_segmap_parloop_struct_338441.free_mem_param_313179 =
        mem_param_313179.mem;
    futhark_mc_segmap_parloop_struct_338441.free_mem_315021 = mem_315021.mem;
    futhark_mc_segmap_parloop_struct_338441.free_mem_315047 = mem_315047.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338442_task;
    
    futhark_mc_segmap_parloop_338442_task.name =
        "futhark_mc_segmap_parloop_338442";
    futhark_mc_segmap_parloop_338442_task.fn = futhark_mc_segmap_parloop_338442;
    futhark_mc_segmap_parloop_338442_task.args =
        &futhark_mc_segmap_parloop_struct_338441;
    futhark_mc_segmap_parloop_338442_task.iterations = iterations;
    futhark_mc_segmap_parloop_338442_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338442_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338442_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338442_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338442_task);
    
    if (futhark_mc_segmap_parloop_338442_err != 0) {
        err = futhark_mc_segmap_parloop_338442_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338442_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338442_total_end -
                 futhark_mc_segmap_parloop_338442_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338442_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338442_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338442_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_338440_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_338440_end -
                 futhark_mc_segmap_task_338440_start;
        
        ctx->futhark_mc_segmap_task_338440_runs[tid]++;
        ctx->futhark_mc_segmap_task_338440_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_338440_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_segmap_parloop_struct_338445 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_l_292680;
    int64_t free_jump_t_292685;
    int64_t free_partition_sizze_292766;
    int64_t free_l_n_m_292832;
    int64_t free_i_292846;
    int64_t free_bytes_313028;
    unsigned char *free_mem_313081;
    unsigned char *free_mem_313085;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315021;
    unsigned char *free_mem_315047;
};
struct futhark_mc_task_338448 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_l_292680;
    int64_t free_jump_t_292685;
    int64_t free_l_n_m_292832;
    int64_t free_i_292846;
    int64_t free_gtid_304935;
    unsigned char *free_mem_313081;
    unsigned char *free_mem_313085;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315021;
    unsigned char *free_mem_315028;
};
struct futhark_mc_segmap_parloop_struct_338450 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_l_292680;
    int64_t free_jump_t_292685;
    int64_t free_l_n_m_292832;
    int64_t free_i_292846;
    int64_t free_gtid_304935;
    unsigned char *free_mem_313081;
    unsigned char *free_mem_313085;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315021;
    unsigned char *free_mem_315028;
};
static int futhark_mc_segmap_parloop_338451(void *args, int64_t start,
                                            int64_t end, int flat_tid_328575,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338450
    *futhark_mc_segmap_parloop_struct_338450 =
    (struct futhark_mc_segmap_parloop_struct_338450 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338450->ctx;
    uint64_t futhark_mc_segmap_parloop_338451_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338451_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_338450->free_n_292675;
    int64_t q_l_292680 =
            futhark_mc_segmap_parloop_struct_338450->free_q_l_292680;
    int64_t jump_t_292685 =
            futhark_mc_segmap_parloop_struct_338450->free_jump_t_292685;
    int64_t l_n_m_292832 =
            futhark_mc_segmap_parloop_struct_338450->free_l_n_m_292832;
    int64_t i_292846 = futhark_mc_segmap_parloop_struct_338450->free_i_292846;
    int64_t gtid_304935 =
            futhark_mc_segmap_parloop_struct_338450->free_gtid_304935;
    struct memblock mem_313081 = {.desc ="mem_313081", .mem =
                                  futhark_mc_segmap_parloop_struct_338450->free_mem_313081,
                                  .size =0, .references =NULL};
    struct memblock mem_313085 = {.desc ="mem_313085", .mem =
                                  futhark_mc_segmap_parloop_struct_338450->free_mem_313085,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_segmap_parloop_struct_338450->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_segmap_parloop_struct_338450->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_segmap_parloop_struct_338450->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_segmap_parloop_struct_338450->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315021 = {.desc ="mem_315021", .mem =
                                  futhark_mc_segmap_parloop_struct_338450->free_mem_315021,
                                  .size =0, .references =NULL};
    struct memblock mem_315028 = {.desc ="mem_315028", .mem =
                                  futhark_mc_segmap_parloop_struct_338450->free_mem_315028,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_328634 = start;
    
    for (; iter_328634 < end; iter_328634++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_328680 = l_n_m_292832;
        int64_t gtid_328576 = iter_328634;
        int64_t remnant_328681 = iter_328634 - gtid_328576;
        int64_t x_328577;
        
        x_328577 = ((int64_t *) mem_313081.mem)[gtid_304935 * l_n_m_292832 +
                                                gtid_328576];
        
        double x_328578;
        
        x_328578 = ((double *) mem_313085.mem)[gtid_304935 * l_n_m_292832 +
                                               gtid_328576];
        
        int64_t min_arg_328579 = mul64(jump_t_292685, gtid_328576);
        int64_t min_res_328580 = smin64(i_292846, min_arg_328579);
        int64_t defunc_0_g_res_328581 = add64((int64_t) 1, min_res_328580);
        double defunc_2_reduce_res_328582;
        double redout_328636 = 0.0;
        
        for (int64_t i_328635 = 0; i_328635 < q_l_292680; i_328635++) {
            bool cond_328637 = sle64(n_292675, i_328635);
            int64_t defunc_0_f_res_328638;
            
            if (cond_328637) {
                defunc_0_f_res_328638 = (int64_t) 0;
            } else {
                int64_t i_328639 = add64(x_328577, i_328635);
                int64_t defunc_1_add_res_328640 = add64((int64_t) 1, i_328639);
                
                defunc_0_f_res_328638 = defunc_1_add_res_328640;
            }
            
            double defunc_0_f_res_328641;
            
            if (cond_328637) {
                defunc_0_f_res_328641 = 0.0;
            } else {
                int64_t i_328642 = add64(x_328577, i_328635);
                double defunc_0_add_arg_328643;
                
                defunc_0_add_arg_328643 =
                    ((double *) mem_param_313179.mem)[ctx_param_ext_313174 +
                                                      (gtid_304935 *
                                                       ctx_param_ext_313175 +
                                                       i_328642 *
                                                       ctx_param_ext_313177)];
                defunc_0_f_res_328641 = defunc_0_add_arg_328643;
            }
            
            int64_t binop_p_328644 = sub64(defunc_0_f_res_328638,
                                           defunc_0_g_res_328581);
            double defunc_0_f_res_328645 = sitofp_i64_f64(binop_p_328644);
            double abs_res_328646 = fabs(defunc_0_f_res_328645);
            double tmp1_328647 = abs_res_328646 / x_328578;
            double x_328648 = tmp1_328647 * tmp1_328647;
            double y_328649 = tmp1_328647 * x_328648;
            double tmp2_328650 = 1.0 - y_328649;
            double x_328651 = tmp2_328650 * tmp2_328650;
            double tmp3_328652 = tmp2_328650 * x_328651;
            double w_j_328653 = defunc_0_f_res_328641 * tmp3_328652;
            double defunc_1_op_res_328654 = w_j_328653 + redout_328636;
            double redout_tmp_328682 = defunc_1_op_res_328654;
            
            redout_328636 = redout_tmp_328682;
        }
        defunc_2_reduce_res_328582 = redout_328636;
        
        double a_328603 = 2.220446049250313e-16 + defunc_2_reduce_res_328582;
        double a0_328604 = 1.0 / a_328603;
        double defunc_2_reduce_res_328605;
        double redout_328656 = 0.0;
        
        for (int64_t i_328655 = 0; i_328655 < q_l_292680; i_328655++) {
            bool cond_328657 = sle64(n_292675, i_328655);
            int64_t defunc_0_f_res_328658;
            
            if (cond_328657) {
                defunc_0_f_res_328658 = (int64_t) 0;
            } else {
                int64_t i_328659 = add64(x_328577, i_328655);
                int64_t defunc_1_add_res_328660 = add64((int64_t) 1, i_328659);
                
                defunc_0_f_res_328658 = defunc_1_add_res_328660;
            }
            
            double defunc_0_f_res_328661;
            
            if (cond_328657) {
                defunc_0_f_res_328661 = 0.0;
            } else {
                int64_t i_328662 = add64(x_328577, i_328655);
                double defunc_0_add_arg_328663;
                
                defunc_0_add_arg_328663 =
                    ((double *) mem_param_313179.mem)[ctx_param_ext_313174 +
                                                      (gtid_304935 *
                                                       ctx_param_ext_313175 +
                                                       i_328662 *
                                                       ctx_param_ext_313177)];
                defunc_0_f_res_328661 = defunc_0_add_arg_328663;
            }
            
            int64_t binop_p_328664 = sub64(defunc_0_f_res_328658,
                                           defunc_0_g_res_328581);
            double defunc_0_f_res_328665 = sitofp_i64_f64(binop_p_328664);
            double abs_res_328666 = fabs(defunc_0_f_res_328665);
            double tmp1_328667 = abs_res_328666 / x_328578;
            double x_328668 = tmp1_328667 * tmp1_328667;
            double y_328669 = tmp1_328667 * x_328668;
            double tmp2_328670 = 1.0 - y_328669;
            double x_328671 = tmp2_328670 * tmp2_328670;
            double tmp3_328672 = tmp2_328670 * x_328671;
            double tmp4_328673 = defunc_0_f_res_328661 * tmp3_328672;
            double defunc_0_f_res_328674;
            
            if (cond_328657) {
                defunc_0_f_res_328674 = 0.0;
            } else {
                int64_t i_328675 = add64(x_328577, i_328655);
                double defunc_0_add_arg_328676;
                
                defunc_0_add_arg_328676 =
                    ((double *) mem_315021.mem)[gtid_304935 * n_292675 +
                                                i_328675];
                defunc_0_f_res_328674 = defunc_0_add_arg_328676;
            }
            
            double x_328677 = a0_328604 * tmp4_328673;
            double defunc_9_fit_fun_res_328678 = defunc_0_f_res_328674 *
                   x_328677;
            double defunc_1_op_res_328679 = defunc_9_fit_fun_res_328678 +
                   redout_328656;
            double redout_tmp_328683 = defunc_1_op_res_328679;
            
            redout_328656 = redout_tmp_328683;
        }
        defunc_2_reduce_res_328605 = redout_328656;
        ((double *) mem_315028.mem)[gtid_328576] = defunc_2_reduce_res_328605;
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338451_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338451_end -
                 futhark_mc_segmap_parloop_338451_start;
        
        ctx->futhark_mc_segmap_parloop_338451_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338451_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338451_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_338449(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_328575 = tid;
    int num_tasks_328633 = info.nsubtasks;
    struct futhark_mc_task_338448 *futhark_mc_task_338448 =
                                  (struct futhark_mc_task_338448 *) args;
    struct futhark_context *ctx = futhark_mc_task_338448->ctx;
    uint64_t futhark_mc_segmap_task_338449_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_338449_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338448->free_n_292675;
    int64_t q_l_292680 = futhark_mc_task_338448->free_q_l_292680;
    int64_t jump_t_292685 = futhark_mc_task_338448->free_jump_t_292685;
    int64_t l_n_m_292832 = futhark_mc_task_338448->free_l_n_m_292832;
    int64_t i_292846 = futhark_mc_task_338448->free_i_292846;
    int64_t gtid_304935 = futhark_mc_task_338448->free_gtid_304935;
    struct memblock mem_313081 = {.desc ="mem_313081", .mem =
                                  futhark_mc_task_338448->free_mem_313081,
                                  .size =0, .references =NULL};
    struct memblock mem_313085 = {.desc ="mem_313085", .mem =
                                  futhark_mc_task_338448->free_mem_313085,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_task_338448->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_task_338448->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_task_338448->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_task_338448->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315021 = {.desc ="mem_315021", .mem =
                                  futhark_mc_task_338448->free_mem_315021,
                                  .size =0, .references =NULL};
    struct memblock mem_315028 = {.desc ="mem_315028", .mem =
                                  futhark_mc_task_338448->free_mem_315028,
                                  .size =0, .references =NULL};
    int64_t iter_328634;
    struct futhark_mc_segmap_parloop_struct_338450
    futhark_mc_segmap_parloop_struct_338450;
    
    futhark_mc_segmap_parloop_struct_338450.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338450.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_338450.free_q_l_292680 = q_l_292680;
    futhark_mc_segmap_parloop_struct_338450.free_jump_t_292685 = jump_t_292685;
    futhark_mc_segmap_parloop_struct_338450.free_l_n_m_292832 = l_n_m_292832;
    futhark_mc_segmap_parloop_struct_338450.free_i_292846 = i_292846;
    futhark_mc_segmap_parloop_struct_338450.free_gtid_304935 = gtid_304935;
    futhark_mc_segmap_parloop_struct_338450.free_mem_313081 = mem_313081.mem;
    futhark_mc_segmap_parloop_struct_338450.free_mem_313085 = mem_313085.mem;
    futhark_mc_segmap_parloop_struct_338450.free_ctx_param_ext_313174 =
        ctx_param_ext_313174;
    futhark_mc_segmap_parloop_struct_338450.free_ctx_param_ext_313175 =
        ctx_param_ext_313175;
    futhark_mc_segmap_parloop_struct_338450.free_ctx_param_ext_313177 =
        ctx_param_ext_313177;
    futhark_mc_segmap_parloop_struct_338450.free_mem_param_313179 =
        mem_param_313179.mem;
    futhark_mc_segmap_parloop_struct_338450.free_mem_315021 = mem_315021.mem;
    futhark_mc_segmap_parloop_struct_338450.free_mem_315028 = mem_315028.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338451_task;
    
    futhark_mc_segmap_parloop_338451_task.name =
        "futhark_mc_segmap_parloop_338451";
    futhark_mc_segmap_parloop_338451_task.fn = futhark_mc_segmap_parloop_338451;
    futhark_mc_segmap_parloop_338451_task.args =
        &futhark_mc_segmap_parloop_struct_338450;
    futhark_mc_segmap_parloop_338451_task.iterations = iterations;
    futhark_mc_segmap_parloop_338451_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338451_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338451_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338451_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338451_task);
    
    if (futhark_mc_segmap_parloop_338451_err != 0) {
        err = futhark_mc_segmap_parloop_338451_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338451_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338451_total_end -
                 futhark_mc_segmap_parloop_338451_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338451_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338451_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338451_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_338449_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_338449_end -
                 futhark_mc_segmap_task_338449_start;
        
        ctx->futhark_mc_segmap_task_338449_runs[tid]++;
        ctx->futhark_mc_segmap_task_338449_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_338449_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_segmap_parloop_struct_338453 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_l_292680;
    int64_t free_jump_t_292685;
    int64_t free_l_n_m_292832;
    int64_t free_i_292846;
    int64_t free_gtid_304935;
    unsigned char *free_mem_313081;
    unsigned char *free_mem_313085;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315021;
    unsigned char *free_mem_315028;
};
struct futhark_mc_task_338455 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_304935;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    int64_t free_x_328517;
    double free_x_328518;
    int64_t free_defunc_0_g_res_328521;
    double *retval_defunc_2_reduce_res_328522;
};
struct futhark_mc_segred_stage_1_parloop_struct_338458 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_304935;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    int64_t free_x_328517;
    double free_x_328518;
    int64_t free_defunc_0_g_res_328521;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_328737;
};
static int futhark_mc_segred_stage_1_parloop_338459(void *args, int64_t start,
                                                    int64_t end,
                                                    int flat_tid_328685,
                                                    int tid)
{
    int err = 0;
    struct futhark_mc_segred_stage_1_parloop_struct_338458
    *futhark_mc_segred_stage_1_parloop_struct_338458 =
    (struct futhark_mc_segred_stage_1_parloop_struct_338458 *) args;
    struct futhark_context *ctx =
                           futhark_mc_segred_stage_1_parloop_struct_338458->ctx;
    uint64_t futhark_mc_segred_stage_1_parloop_338459_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_338459_start = get_wall_time();
    
    int64_t n_292675 =
            futhark_mc_segred_stage_1_parloop_struct_338458->free_n_292675;
    int64_t gtid_304935 =
            futhark_mc_segred_stage_1_parloop_struct_338458->free_gtid_304935;
    int64_t ctx_param_ext_313174 =
            futhark_mc_segred_stage_1_parloop_struct_338458->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_segred_stage_1_parloop_struct_338458->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_segred_stage_1_parloop_struct_338458->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_segred_stage_1_parloop_struct_338458->free_mem_param_313179,
                                        .size =0, .references =NULL};
    int64_t x_328517 =
            futhark_mc_segred_stage_1_parloop_struct_338458->free_x_328517;
    double x_328518 =
           futhark_mc_segred_stage_1_parloop_struct_338458->free_x_328518;
    int64_t defunc_0_g_res_328521 =
            futhark_mc_segred_stage_1_parloop_struct_338458->free_defunc_0_g_res_328521;
    struct memblock reduce_stage_1_tid_res_arr_mem_328737 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_328737",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338458->free_reduce_stage_1_tid_res_arr_mem_328737,
                                                             .size =0,
                                                             .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_328739 = start;
    double x_328687;
    double x_328688;
    double local_acc_328740 = 0.0;
    
    for (; iter_328739 < end; iter_328739++) {
        int64_t gtid_328686 = iter_328739;
        bool cond_328690 = sle64(n_292675, gtid_328686);
        int64_t defunc_0_f_res_328691;
        
        if (cond_328690) {
            defunc_0_f_res_328691 = (int64_t) 0;
        } else {
            int64_t i_328692 = add64(x_328517, gtid_328686);
            int64_t defunc_1_add_res_328693 = add64((int64_t) 1, i_328692);
            
            defunc_0_f_res_328691 = defunc_1_add_res_328693;
        }
        
        double defunc_0_f_res_328694;
        
        if (cond_328690) {
            defunc_0_f_res_328694 = 0.0;
        } else {
            int64_t i_328695 = add64(x_328517, gtid_328686);
            double defunc_0_add_arg_328696;
            
            defunc_0_add_arg_328696 =
                ((double *) mem_param_313179.mem)[ctx_param_ext_313174 +
                                                  (gtid_304935 *
                                                   ctx_param_ext_313175 +
                                                   i_328695 *
                                                   ctx_param_ext_313177)];
            defunc_0_f_res_328694 = defunc_0_add_arg_328696;
        }
        
        int64_t binop_p_328697 = sub64(defunc_0_f_res_328691,
                                       defunc_0_g_res_328521);
        double defunc_0_f_res_328698 = sitofp_i64_f64(binop_p_328697);
        double abs_res_328699 = fabs(defunc_0_f_res_328698);
        double tmp1_328700 = abs_res_328699 / x_328518;
        double x_328701 = tmp1_328700 * tmp1_328700;
        double y_328702 = tmp1_328700 * x_328701;
        double tmp2_328703 = 1.0 - y_328702;
        double x_328704 = tmp2_328703 * tmp2_328703;
        double tmp3_328705 = tmp2_328703 * x_328704;
        double w_j_328706 = defunc_0_f_res_328694 * tmp3_328705;
        
        // save map-out results
        { }
        // Load accum params
        {
            x_328687 = local_acc_328740;
        }
        // Load next params
        {
            x_328688 = w_j_328706;
        }
        // Red body
        {
            double defunc_1_op_res_328689 = x_328687 + x_328688;
            
            local_acc_328740 = defunc_1_op_res_328689;
        }
    }
    ((double *) reduce_stage_1_tid_res_arr_mem_328737.mem)[flat_tid_328685] =
        local_acc_328740;
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_338459_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_338459_end -
                 futhark_mc_segred_stage_1_parloop_338459_start;
        
        ctx->futhark_mc_segred_stage_1_parloop_338459_runs[tid]++;
        ctx->futhark_mc_segred_stage_1_parloop_338459_total_runtime[tid] +=
            elapsed;
        ctx->futhark_mc_segred_stage_1_parloop_338459_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segred_task_338456(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_328685 = tid;
    int num_tasks_328736 = info.nsubtasks;
    struct futhark_mc_task_338455 *futhark_mc_task_338455 =
                                  (struct futhark_mc_task_338455 *) args;
    struct futhark_context *ctx = futhark_mc_task_338455->ctx;
    uint64_t futhark_mc_segred_task_338456_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_task_338456_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338455->free_n_292675;
    int64_t gtid_304935 = futhark_mc_task_338455->free_gtid_304935;
    int64_t ctx_param_ext_313174 =
            futhark_mc_task_338455->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_task_338455->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_task_338455->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_task_338455->free_mem_param_313179,
                                        .size =0, .references =NULL};
    int64_t x_328517 = futhark_mc_task_338455->free_x_328517;
    double x_328518 = futhark_mc_task_338455->free_x_328518;
    int64_t defunc_0_g_res_328521 =
            futhark_mc_task_338455->free_defunc_0_g_res_328521;
    double defunc_2_reduce_res_328522 =
           *futhark_mc_task_338455->retval_defunc_2_reduce_res_328522;
    size_t reduce_stage_1_tid_res_arr_mem_328737_cached_sizze_338457 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_328737 = NULL;
    
    if (reduce_stage_1_tid_res_arr_mem_328737_cached_sizze_338457 <
        (size_t) ((int64_t) 8 * num_tasks_328736)) {
        reduce_stage_1_tid_res_arr_mem_328737 =
            realloc(reduce_stage_1_tid_res_arr_mem_328737, (int64_t) 8 *
                    num_tasks_328736);
        reduce_stage_1_tid_res_arr_mem_328737_cached_sizze_338457 =
            (int64_t) 8 * num_tasks_328736;
    }
    
    int64_t iter_328739;
    struct futhark_mc_segred_stage_1_parloop_struct_338458
    futhark_mc_segred_stage_1_parloop_struct_338458;
    
    futhark_mc_segred_stage_1_parloop_struct_338458.ctx = ctx;
    futhark_mc_segred_stage_1_parloop_struct_338458.free_n_292675 = n_292675;
    futhark_mc_segred_stage_1_parloop_struct_338458.free_gtid_304935 =
        gtid_304935;
    futhark_mc_segred_stage_1_parloop_struct_338458.free_ctx_param_ext_313174 =
        ctx_param_ext_313174;
    futhark_mc_segred_stage_1_parloop_struct_338458.free_ctx_param_ext_313175 =
        ctx_param_ext_313175;
    futhark_mc_segred_stage_1_parloop_struct_338458.free_ctx_param_ext_313177 =
        ctx_param_ext_313177;
    futhark_mc_segred_stage_1_parloop_struct_338458.free_mem_param_313179 =
        mem_param_313179.mem;
    futhark_mc_segred_stage_1_parloop_struct_338458.free_x_328517 = x_328517;
    futhark_mc_segred_stage_1_parloop_struct_338458.free_x_328518 = x_328518;
    futhark_mc_segred_stage_1_parloop_struct_338458.free_defunc_0_g_res_328521 =
        defunc_0_g_res_328521;
    futhark_mc_segred_stage_1_parloop_struct_338458.free_reduce_stage_1_tid_res_arr_mem_328737 =
        reduce_stage_1_tid_res_arr_mem_328737;
    
    struct scheduler_parloop futhark_mc_segred_stage_1_parloop_338459_task;
    
    futhark_mc_segred_stage_1_parloop_338459_task.name =
        "futhark_mc_segred_stage_1_parloop_338459";
    futhark_mc_segred_stage_1_parloop_338459_task.fn =
        futhark_mc_segred_stage_1_parloop_338459;
    futhark_mc_segred_stage_1_parloop_338459_task.args =
        &futhark_mc_segred_stage_1_parloop_struct_338458;
    futhark_mc_segred_stage_1_parloop_338459_task.iterations = iterations;
    futhark_mc_segred_stage_1_parloop_338459_task.info = info;
    
    uint64_t futhark_mc_segred_stage_1_parloop_338459_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_338459_total_start = get_wall_time();
    
    int futhark_mc_segred_stage_1_parloop_338459_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segred_stage_1_parloop_338459_task);
    
    if (futhark_mc_segred_stage_1_parloop_338459_err != 0) {
        err = futhark_mc_segred_stage_1_parloop_338459_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_338459_total_end =
                 get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_338459_total_end -
                 futhark_mc_segred_stage_1_parloop_338459_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338459_total_runs,
                           1, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338459_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338459_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    // neutral-initialise the output
    {
        defunc_2_reduce_res_328522 = 0.0;
    }
    
    double x_328741;
    double x_328742;
    
    for (int32_t i_328744 = 0; i_328744 < num_tasks_328736; i_328744++) {
        flat_tid_328685 = i_328744;
        // Apply main thread reduction
        {
            // load acc params
            {
                x_328741 = defunc_2_reduce_res_328522;
            }
            // load next params
            {
                x_328742 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_328737)[flat_tid_328685];
            }
            // red body
            {
                double defunc_1_op_res_328743 = x_328741 + x_328742;
                
                defunc_2_reduce_res_328522 = defunc_1_op_res_328743;
            }
        }
    }
    
  cleanup:
    {
        free(reduce_stage_1_tid_res_arr_mem_328737);
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_task_338456_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_task_338456_end -
                 futhark_mc_segred_task_338456_start;
        
        ctx->futhark_mc_segred_task_338456_runs[tid]++;
        ctx->futhark_mc_segred_task_338456_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segred_task_338456_iter[tid] += iterations;
    }
    if (err == 0) {
        *futhark_mc_task_338455->retval_defunc_2_reduce_res_328522 =
            defunc_2_reduce_res_328522;
    }
    return err;
}
struct futhark_mc_task_338460 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_304935;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315021;
    int64_t free_x_328517;
    double free_x_328518;
    int64_t free_defunc_0_g_res_328521;
    double free_a0_328546;
    double *retval_defunc_2_reduce_res_328547;
};
struct futhark_mc_segred_stage_1_parloop_struct_338463 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_304935;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315021;
    int64_t free_x_328517;
    double free_x_328518;
    int64_t free_defunc_0_g_res_328521;
    double free_a0_328546;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_328746;
};
static int futhark_mc_segred_stage_1_parloop_338464(void *args, int64_t start,
                                                    int64_t end,
                                                    int flat_tid_328707,
                                                    int tid)
{
    int err = 0;
    struct futhark_mc_segred_stage_1_parloop_struct_338463
    *futhark_mc_segred_stage_1_parloop_struct_338463 =
    (struct futhark_mc_segred_stage_1_parloop_struct_338463 *) args;
    struct futhark_context *ctx =
                           futhark_mc_segred_stage_1_parloop_struct_338463->ctx;
    uint64_t futhark_mc_segred_stage_1_parloop_338464_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_338464_start = get_wall_time();
    
    int64_t n_292675 =
            futhark_mc_segred_stage_1_parloop_struct_338463->free_n_292675;
    int64_t gtid_304935 =
            futhark_mc_segred_stage_1_parloop_struct_338463->free_gtid_304935;
    int64_t ctx_param_ext_313174 =
            futhark_mc_segred_stage_1_parloop_struct_338463->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_segred_stage_1_parloop_struct_338463->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_segred_stage_1_parloop_struct_338463->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_segred_stage_1_parloop_struct_338463->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315021 = {.desc ="mem_315021", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_338463->free_mem_315021,
                                  .size =0, .references =NULL};
    int64_t x_328517 =
            futhark_mc_segred_stage_1_parloop_struct_338463->free_x_328517;
    double x_328518 =
           futhark_mc_segred_stage_1_parloop_struct_338463->free_x_328518;
    int64_t defunc_0_g_res_328521 =
            futhark_mc_segred_stage_1_parloop_struct_338463->free_defunc_0_g_res_328521;
    double a0_328546 =
           futhark_mc_segred_stage_1_parloop_struct_338463->free_a0_328546;
    struct memblock reduce_stage_1_tid_res_arr_mem_328746 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_328746",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338463->free_reduce_stage_1_tid_res_arr_mem_328746,
                                                             .size =0,
                                                             .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_328748 = start;
    double x_328709;
    double x_328710;
    double local_acc_328749 = 0.0;
    
    for (; iter_328748 < end; iter_328748++) {
        int64_t gtid_328708 = iter_328748;
        bool cond_328712 = sle64(n_292675, gtid_328708);
        int64_t defunc_0_f_res_328713;
        
        if (cond_328712) {
            defunc_0_f_res_328713 = (int64_t) 0;
        } else {
            int64_t i_328714 = add64(x_328517, gtid_328708);
            int64_t defunc_1_add_res_328715 = add64((int64_t) 1, i_328714);
            
            defunc_0_f_res_328713 = defunc_1_add_res_328715;
        }
        
        double defunc_0_f_res_328716;
        
        if (cond_328712) {
            defunc_0_f_res_328716 = 0.0;
        } else {
            int64_t i_328717 = add64(x_328517, gtid_328708);
            double defunc_0_add_arg_328718;
            
            defunc_0_add_arg_328718 =
                ((double *) mem_param_313179.mem)[ctx_param_ext_313174 +
                                                  (gtid_304935 *
                                                   ctx_param_ext_313175 +
                                                   i_328717 *
                                                   ctx_param_ext_313177)];
            defunc_0_f_res_328716 = defunc_0_add_arg_328718;
        }
        
        int64_t binop_p_328719 = sub64(defunc_0_f_res_328713,
                                       defunc_0_g_res_328521);
        double defunc_0_f_res_328720 = sitofp_i64_f64(binop_p_328719);
        double abs_res_328721 = fabs(defunc_0_f_res_328720);
        double tmp1_328722 = abs_res_328721 / x_328518;
        double x_328723 = tmp1_328722 * tmp1_328722;
        double y_328724 = tmp1_328722 * x_328723;
        double tmp2_328725 = 1.0 - y_328724;
        double x_328726 = tmp2_328725 * tmp2_328725;
        double tmp3_328727 = tmp2_328725 * x_328726;
        double tmp4_328728 = defunc_0_f_res_328716 * tmp3_328727;
        double defunc_0_f_res_328729;
        
        if (cond_328712) {
            defunc_0_f_res_328729 = 0.0;
        } else {
            int64_t i_328730 = add64(x_328517, gtid_328708);
            double defunc_0_add_arg_328731;
            
            defunc_0_add_arg_328731 = ((double *) mem_315021.mem)[gtid_304935 *
                                                                  n_292675 +
                                                                  i_328730];
            defunc_0_f_res_328729 = defunc_0_add_arg_328731;
        }
        
        double x_328732 = a0_328546 * tmp4_328728;
        double defunc_9_fit_fun_res_328733 = defunc_0_f_res_328729 * x_328732;
        
        // save map-out results
        { }
        // Load accum params
        {
            x_328709 = local_acc_328749;
        }
        // Load next params
        {
            x_328710 = defunc_9_fit_fun_res_328733;
        }
        // Red body
        {
            double defunc_1_op_res_328711 = x_328709 + x_328710;
            
            local_acc_328749 = defunc_1_op_res_328711;
        }
    }
    ((double *) reduce_stage_1_tid_res_arr_mem_328746.mem)[flat_tid_328707] =
        local_acc_328749;
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_338464_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_338464_end -
                 futhark_mc_segred_stage_1_parloop_338464_start;
        
        ctx->futhark_mc_segred_stage_1_parloop_338464_runs[tid]++;
        ctx->futhark_mc_segred_stage_1_parloop_338464_total_runtime[tid] +=
            elapsed;
        ctx->futhark_mc_segred_stage_1_parloop_338464_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segred_task_338461(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_328707 = tid;
    int num_tasks_328745 = info.nsubtasks;
    struct futhark_mc_task_338460 *futhark_mc_task_338460 =
                                  (struct futhark_mc_task_338460 *) args;
    struct futhark_context *ctx = futhark_mc_task_338460->ctx;
    uint64_t futhark_mc_segred_task_338461_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_task_338461_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338460->free_n_292675;
    int64_t gtid_304935 = futhark_mc_task_338460->free_gtid_304935;
    int64_t ctx_param_ext_313174 =
            futhark_mc_task_338460->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_task_338460->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_task_338460->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_task_338460->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315021 = {.desc ="mem_315021", .mem =
                                  futhark_mc_task_338460->free_mem_315021,
                                  .size =0, .references =NULL};
    int64_t x_328517 = futhark_mc_task_338460->free_x_328517;
    double x_328518 = futhark_mc_task_338460->free_x_328518;
    int64_t defunc_0_g_res_328521 =
            futhark_mc_task_338460->free_defunc_0_g_res_328521;
    double a0_328546 = futhark_mc_task_338460->free_a0_328546;
    double defunc_2_reduce_res_328547 =
           *futhark_mc_task_338460->retval_defunc_2_reduce_res_328547;
    size_t reduce_stage_1_tid_res_arr_mem_328746_cached_sizze_338462 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_328746 = NULL;
    
    if (reduce_stage_1_tid_res_arr_mem_328746_cached_sizze_338462 <
        (size_t) ((int64_t) 8 * num_tasks_328745)) {
        reduce_stage_1_tid_res_arr_mem_328746 =
            realloc(reduce_stage_1_tid_res_arr_mem_328746, (int64_t) 8 *
                    num_tasks_328745);
        reduce_stage_1_tid_res_arr_mem_328746_cached_sizze_338462 =
            (int64_t) 8 * num_tasks_328745;
    }
    
    int64_t iter_328748;
    struct futhark_mc_segred_stage_1_parloop_struct_338463
    futhark_mc_segred_stage_1_parloop_struct_338463;
    
    futhark_mc_segred_stage_1_parloop_struct_338463.ctx = ctx;
    futhark_mc_segred_stage_1_parloop_struct_338463.free_n_292675 = n_292675;
    futhark_mc_segred_stage_1_parloop_struct_338463.free_gtid_304935 =
        gtid_304935;
    futhark_mc_segred_stage_1_parloop_struct_338463.free_ctx_param_ext_313174 =
        ctx_param_ext_313174;
    futhark_mc_segred_stage_1_parloop_struct_338463.free_ctx_param_ext_313175 =
        ctx_param_ext_313175;
    futhark_mc_segred_stage_1_parloop_struct_338463.free_ctx_param_ext_313177 =
        ctx_param_ext_313177;
    futhark_mc_segred_stage_1_parloop_struct_338463.free_mem_param_313179 =
        mem_param_313179.mem;
    futhark_mc_segred_stage_1_parloop_struct_338463.free_mem_315021 =
        mem_315021.mem;
    futhark_mc_segred_stage_1_parloop_struct_338463.free_x_328517 = x_328517;
    futhark_mc_segred_stage_1_parloop_struct_338463.free_x_328518 = x_328518;
    futhark_mc_segred_stage_1_parloop_struct_338463.free_defunc_0_g_res_328521 =
        defunc_0_g_res_328521;
    futhark_mc_segred_stage_1_parloop_struct_338463.free_a0_328546 = a0_328546;
    futhark_mc_segred_stage_1_parloop_struct_338463.free_reduce_stage_1_tid_res_arr_mem_328746 =
        reduce_stage_1_tid_res_arr_mem_328746;
    
    struct scheduler_parloop futhark_mc_segred_stage_1_parloop_338464_task;
    
    futhark_mc_segred_stage_1_parloop_338464_task.name =
        "futhark_mc_segred_stage_1_parloop_338464";
    futhark_mc_segred_stage_1_parloop_338464_task.fn =
        futhark_mc_segred_stage_1_parloop_338464;
    futhark_mc_segred_stage_1_parloop_338464_task.args =
        &futhark_mc_segred_stage_1_parloop_struct_338463;
    futhark_mc_segred_stage_1_parloop_338464_task.iterations = iterations;
    futhark_mc_segred_stage_1_parloop_338464_task.info = info;
    
    uint64_t futhark_mc_segred_stage_1_parloop_338464_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_338464_total_start = get_wall_time();
    
    int futhark_mc_segred_stage_1_parloop_338464_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segred_stage_1_parloop_338464_task);
    
    if (futhark_mc_segred_stage_1_parloop_338464_err != 0) {
        err = futhark_mc_segred_stage_1_parloop_338464_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_338464_total_end =
                 get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_338464_total_end -
                 futhark_mc_segred_stage_1_parloop_338464_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338464_total_runs,
                           1, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338464_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338464_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    // neutral-initialise the output
    {
        defunc_2_reduce_res_328547 = 0.0;
    }
    
    double x_328750;
    double x_328751;
    
    for (int32_t i_328753 = 0; i_328753 < num_tasks_328745; i_328753++) {
        flat_tid_328707 = i_328753;
        // Apply main thread reduction
        {
            // load acc params
            {
                x_328750 = defunc_2_reduce_res_328547;
            }
            // load next params
            {
                x_328751 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_328746)[flat_tid_328707];
            }
            // red body
            {
                double defunc_1_op_res_328752 = x_328750 + x_328751;
                
                defunc_2_reduce_res_328547 = defunc_1_op_res_328752;
            }
        }
    }
    
  cleanup:
    {
        free(reduce_stage_1_tid_res_arr_mem_328746);
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_task_338461_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_task_338461_end -
                 futhark_mc_segred_task_338461_start;
        
        ctx->futhark_mc_segred_task_338461_runs[tid]++;
        ctx->futhark_mc_segred_task_338461_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segred_task_338461_iter[tid] += iterations;
    }
    if (err == 0) {
        *futhark_mc_task_338460->retval_defunc_2_reduce_res_328547 =
            defunc_2_reduce_res_328547;
    }
    return err;
}
static int futhark_mc_segmap_parloop_338454(void *args, int64_t start,
                                            int64_t end, int flat_tid_328515,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338453
    *futhark_mc_segmap_parloop_struct_338453 =
    (struct futhark_mc_segmap_parloop_struct_338453 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338453->ctx;
    uint64_t futhark_mc_segmap_parloop_338454_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338454_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_338453->free_n_292675;
    int64_t q_l_292680 =
            futhark_mc_segmap_parloop_struct_338453->free_q_l_292680;
    int64_t jump_t_292685 =
            futhark_mc_segmap_parloop_struct_338453->free_jump_t_292685;
    int64_t l_n_m_292832 =
            futhark_mc_segmap_parloop_struct_338453->free_l_n_m_292832;
    int64_t i_292846 = futhark_mc_segmap_parloop_struct_338453->free_i_292846;
    int64_t gtid_304935 =
            futhark_mc_segmap_parloop_struct_338453->free_gtid_304935;
    struct memblock mem_313081 = {.desc ="mem_313081", .mem =
                                  futhark_mc_segmap_parloop_struct_338453->free_mem_313081,
                                  .size =0, .references =NULL};
    struct memblock mem_313085 = {.desc ="mem_313085", .mem =
                                  futhark_mc_segmap_parloop_struct_338453->free_mem_313085,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_segmap_parloop_struct_338453->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_segmap_parloop_struct_338453->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_segmap_parloop_struct_338453->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_segmap_parloop_struct_338453->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315021 = {.desc ="mem_315021", .mem =
                                  futhark_mc_segmap_parloop_struct_338453->free_mem_315021,
                                  .size =0, .references =NULL};
    struct memblock mem_315028 = {.desc ="mem_315028", .mem =
                                  futhark_mc_segmap_parloop_struct_338453->free_mem_315028,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_328684 = start;
    
    for (; iter_328684 < end; iter_328684++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_328734 = l_n_m_292832;
        int64_t gtid_328516 = iter_328684;
        int64_t remnant_328735 = iter_328684 - gtid_328516;
        int64_t x_328517;
        
        x_328517 = ((int64_t *) mem_313081.mem)[gtid_304935 * l_n_m_292832 +
                                                gtid_328516];
        
        double x_328518;
        
        x_328518 = ((double *) mem_313085.mem)[gtid_304935 * l_n_m_292832 +
                                               gtid_328516];
        
        int64_t min_arg_328519 = mul64(jump_t_292685, gtid_328516);
        int64_t min_res_328520 = smin64(i_292846, min_arg_328519);
        int64_t defunc_0_g_res_328521 = add64((int64_t) 1, min_res_328520);
        double defunc_2_reduce_res_328522;
        int64_t flat_tid_328685 = (int64_t) 0;
        int32_t num_tasks_328736;
        
        defunc_2_reduce_res_328522 = 0.0;
        
        struct futhark_mc_task_338455 futhark_mc_task_338455;
        
        futhark_mc_task_338455.ctx = ctx;
        futhark_mc_task_338455.free_n_292675 = n_292675;
        futhark_mc_task_338455.free_gtid_304935 = gtid_304935;
        futhark_mc_task_338455.free_ctx_param_ext_313174 = ctx_param_ext_313174;
        futhark_mc_task_338455.free_ctx_param_ext_313175 = ctx_param_ext_313175;
        futhark_mc_task_338455.free_ctx_param_ext_313177 = ctx_param_ext_313177;
        futhark_mc_task_338455.free_mem_param_313179 = mem_param_313179.mem;
        futhark_mc_task_338455.free_x_328517 = x_328517;
        futhark_mc_task_338455.free_x_328518 = x_328518;
        futhark_mc_task_338455.free_defunc_0_g_res_328521 =
            defunc_0_g_res_328521;
        futhark_mc_task_338455.retval_defunc_2_reduce_res_328522 =
            &defunc_2_reduce_res_328522;
        
        struct scheduler_segop futhark_mc_task_338455_task;
        
        futhark_mc_task_338455_task.args = &futhark_mc_task_338455;
        futhark_mc_task_338455_task.top_level_fn =
            futhark_mc_segred_task_338456;
        futhark_mc_task_338455_task.name = "futhark_mc_segred_task_338456";
        futhark_mc_task_338455_task.iterations = q_l_292680;
        futhark_mc_task_338455_task.task_time =
            &ctx->futhark_mc_segred_task_338456_total_time;
        futhark_mc_task_338455_task.task_iter =
            &ctx->futhark_mc_segred_task_338456_total_iter;
        futhark_mc_task_338455_task.sched = STATIC;
        futhark_mc_task_338455_task.nested_fn = NULL;
        
        int futhark_mc_segred_task_338456_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_338455_task);
        
        if (futhark_mc_segred_task_338456_err != 0) {
            ;
            err = futhark_mc_segred_task_338456_err;
            goto cleanup;
        }
        
        double a_328545 = 2.220446049250313e-16 + defunc_2_reduce_res_328522;
        double a0_328546 = 1.0 / a_328545;
        double defunc_2_reduce_res_328547;
        int64_t flat_tid_328707 = (int64_t) 0;
        int32_t num_tasks_328745;
        
        defunc_2_reduce_res_328547 = 0.0;
        
        struct futhark_mc_task_338460 futhark_mc_task_338460;
        
        futhark_mc_task_338460.ctx = ctx;
        futhark_mc_task_338460.free_n_292675 = n_292675;
        futhark_mc_task_338460.free_gtid_304935 = gtid_304935;
        futhark_mc_task_338460.free_ctx_param_ext_313174 = ctx_param_ext_313174;
        futhark_mc_task_338460.free_ctx_param_ext_313175 = ctx_param_ext_313175;
        futhark_mc_task_338460.free_ctx_param_ext_313177 = ctx_param_ext_313177;
        futhark_mc_task_338460.free_mem_param_313179 = mem_param_313179.mem;
        futhark_mc_task_338460.free_mem_315021 = mem_315021.mem;
        futhark_mc_task_338460.free_x_328517 = x_328517;
        futhark_mc_task_338460.free_x_328518 = x_328518;
        futhark_mc_task_338460.free_defunc_0_g_res_328521 =
            defunc_0_g_res_328521;
        futhark_mc_task_338460.free_a0_328546 = a0_328546;
        futhark_mc_task_338460.retval_defunc_2_reduce_res_328547 =
            &defunc_2_reduce_res_328547;
        
        struct scheduler_segop futhark_mc_task_338460_task;
        
        futhark_mc_task_338460_task.args = &futhark_mc_task_338460;
        futhark_mc_task_338460_task.top_level_fn =
            futhark_mc_segred_task_338461;
        futhark_mc_task_338460_task.name = "futhark_mc_segred_task_338461";
        futhark_mc_task_338460_task.iterations = q_l_292680;
        futhark_mc_task_338460_task.task_time =
            &ctx->futhark_mc_segred_task_338461_total_time;
        futhark_mc_task_338460_task.task_iter =
            &ctx->futhark_mc_segred_task_338461_total_iter;
        futhark_mc_task_338460_task.sched = STATIC;
        futhark_mc_task_338460_task.nested_fn = NULL;
        
        int futhark_mc_segred_task_338461_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_338460_task);
        
        if (futhark_mc_segred_task_338461_err != 0) {
            ;
            err = futhark_mc_segred_task_338461_err;
            goto cleanup;
        }
        ((double *) mem_315028.mem)[gtid_328516] = defunc_2_reduce_res_328547;
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338454_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338454_end -
                 futhark_mc_segmap_parloop_338454_start;
        
        ctx->futhark_mc_segmap_parloop_338454_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338454_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338454_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_nested_task_338452(void *args, int64_t iterations,
                                         int tid, struct scheduler_info info)
{
    int err = 0;
    int flat_tid_328515 = tid;
    int num_tasks_328633 = info.nsubtasks;
    struct futhark_mc_task_338448 *futhark_mc_task_338448 =
                                  (struct futhark_mc_task_338448 *) args;
    struct futhark_context *ctx = futhark_mc_task_338448->ctx;
    uint64_t futhark_mc_segmap_nested_task_338452_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_nested_task_338452_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338448->free_n_292675;
    int64_t q_l_292680 = futhark_mc_task_338448->free_q_l_292680;
    int64_t jump_t_292685 = futhark_mc_task_338448->free_jump_t_292685;
    int64_t l_n_m_292832 = futhark_mc_task_338448->free_l_n_m_292832;
    int64_t i_292846 = futhark_mc_task_338448->free_i_292846;
    int64_t gtid_304935 = futhark_mc_task_338448->free_gtid_304935;
    struct memblock mem_313081 = {.desc ="mem_313081", .mem =
                                  futhark_mc_task_338448->free_mem_313081,
                                  .size =0, .references =NULL};
    struct memblock mem_313085 = {.desc ="mem_313085", .mem =
                                  futhark_mc_task_338448->free_mem_313085,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_task_338448->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_task_338448->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_task_338448->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_task_338448->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315021 = {.desc ="mem_315021", .mem =
                                  futhark_mc_task_338448->free_mem_315021,
                                  .size =0, .references =NULL};
    struct memblock mem_315028 = {.desc ="mem_315028", .mem =
                                  futhark_mc_task_338448->free_mem_315028,
                                  .size =0, .references =NULL};
    int64_t iter_328684;
    struct futhark_mc_segmap_parloop_struct_338453
    futhark_mc_segmap_parloop_struct_338453;
    
    futhark_mc_segmap_parloop_struct_338453.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338453.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_338453.free_q_l_292680 = q_l_292680;
    futhark_mc_segmap_parloop_struct_338453.free_jump_t_292685 = jump_t_292685;
    futhark_mc_segmap_parloop_struct_338453.free_l_n_m_292832 = l_n_m_292832;
    futhark_mc_segmap_parloop_struct_338453.free_i_292846 = i_292846;
    futhark_mc_segmap_parloop_struct_338453.free_gtid_304935 = gtid_304935;
    futhark_mc_segmap_parloop_struct_338453.free_mem_313081 = mem_313081.mem;
    futhark_mc_segmap_parloop_struct_338453.free_mem_313085 = mem_313085.mem;
    futhark_mc_segmap_parloop_struct_338453.free_ctx_param_ext_313174 =
        ctx_param_ext_313174;
    futhark_mc_segmap_parloop_struct_338453.free_ctx_param_ext_313175 =
        ctx_param_ext_313175;
    futhark_mc_segmap_parloop_struct_338453.free_ctx_param_ext_313177 =
        ctx_param_ext_313177;
    futhark_mc_segmap_parloop_struct_338453.free_mem_param_313179 =
        mem_param_313179.mem;
    futhark_mc_segmap_parloop_struct_338453.free_mem_315021 = mem_315021.mem;
    futhark_mc_segmap_parloop_struct_338453.free_mem_315028 = mem_315028.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338454_task;
    
    futhark_mc_segmap_parloop_338454_task.name =
        "futhark_mc_segmap_parloop_338454";
    futhark_mc_segmap_parloop_338454_task.fn = futhark_mc_segmap_parloop_338454;
    futhark_mc_segmap_parloop_338454_task.args =
        &futhark_mc_segmap_parloop_struct_338453;
    futhark_mc_segmap_parloop_338454_task.iterations = iterations;
    futhark_mc_segmap_parloop_338454_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338454_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338454_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338454_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338454_task);
    
    if (futhark_mc_segmap_parloop_338454_err != 0) {
        err = futhark_mc_segmap_parloop_338454_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338454_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338454_total_end -
                 futhark_mc_segmap_parloop_338454_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338454_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338454_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338454_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_nested_task_338452_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_nested_task_338452_end -
                 futhark_mc_segmap_nested_task_338452_start;
        
        ctx->futhark_mc_segmap_nested_task_338452_runs[tid]++;
        ctx->futhark_mc_segmap_nested_task_338452_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_nested_task_338452_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
static int futhark_mc_segmap_parloop_338446(void *args, int64_t start,
                                            int64_t end, int flat_tid_304934,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338445
    *futhark_mc_segmap_parloop_struct_338445 =
    (struct futhark_mc_segmap_parloop_struct_338445 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338445->ctx;
    uint64_t futhark_mc_segmap_parloop_338446_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338446_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_338445->free_n_292675;
    int64_t q_l_292680 =
            futhark_mc_segmap_parloop_struct_338445->free_q_l_292680;
    int64_t jump_t_292685 =
            futhark_mc_segmap_parloop_struct_338445->free_jump_t_292685;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_338445->free_partition_sizze_292766;
    int64_t l_n_m_292832 =
            futhark_mc_segmap_parloop_struct_338445->free_l_n_m_292832;
    int64_t i_292846 = futhark_mc_segmap_parloop_struct_338445->free_i_292846;
    int64_t bytes_313028 =
            futhark_mc_segmap_parloop_struct_338445->free_bytes_313028;
    struct memblock mem_313081 = {.desc ="mem_313081", .mem =
                                  futhark_mc_segmap_parloop_struct_338445->free_mem_313081,
                                  .size =0, .references =NULL};
    struct memblock mem_313085 = {.desc ="mem_313085", .mem =
                                  futhark_mc_segmap_parloop_struct_338445->free_mem_313085,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_segmap_parloop_struct_338445->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_segmap_parloop_struct_338445->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_segmap_parloop_struct_338445->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_segmap_parloop_struct_338445->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315021 = {.desc ="mem_315021", .mem =
                                  futhark_mc_segmap_parloop_struct_338445->free_mem_315021,
                                  .size =0, .references =NULL};
    struct memblock mem_315047 = {.desc ="mem_315047", .mem =
                                  futhark_mc_segmap_parloop_struct_338445->free_mem_315047,
                                  .size =0, .references =NULL};
    size_t mem_315028_cached_sizze_338447 = 0;
    unsigned char *mem_315028 = NULL;
    int64_t iterations = end - start;
    int64_t iter_328514 = start;
    
    if (mem_315028_cached_sizze_338447 < (size_t) bytes_313028) {
        mem_315028 = realloc(mem_315028, bytes_313028);
        mem_315028_cached_sizze_338447 = bytes_313028;
    }
    for (; iter_328514 < end; iter_328514++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_328631 = partition_sizze_292766;
        int64_t gtid_304935 = iter_328514;
        int64_t remnant_328632 = iter_328514 - gtid_304935;
        int64_t flat_tid_328575 = (int64_t) 0;
        int32_t num_tasks_328633;
        int64_t flat_tid_328515 = (int64_t) 0;
        struct futhark_mc_task_338448 futhark_mc_task_338448;
        
        futhark_mc_task_338448.ctx = ctx;
        futhark_mc_task_338448.free_n_292675 = n_292675;
        futhark_mc_task_338448.free_q_l_292680 = q_l_292680;
        futhark_mc_task_338448.free_jump_t_292685 = jump_t_292685;
        futhark_mc_task_338448.free_l_n_m_292832 = l_n_m_292832;
        futhark_mc_task_338448.free_i_292846 = i_292846;
        futhark_mc_task_338448.free_gtid_304935 = gtid_304935;
        futhark_mc_task_338448.free_mem_313081 = mem_313081.mem;
        futhark_mc_task_338448.free_mem_313085 = mem_313085.mem;
        futhark_mc_task_338448.free_ctx_param_ext_313174 = ctx_param_ext_313174;
        futhark_mc_task_338448.free_ctx_param_ext_313175 = ctx_param_ext_313175;
        futhark_mc_task_338448.free_ctx_param_ext_313177 = ctx_param_ext_313177;
        futhark_mc_task_338448.free_mem_param_313179 = mem_param_313179.mem;
        futhark_mc_task_338448.free_mem_315021 = mem_315021.mem;
        futhark_mc_task_338448.free_mem_315028 = mem_315028;
        
        struct scheduler_segop futhark_mc_task_338448_task;
        
        futhark_mc_task_338448_task.args = &futhark_mc_task_338448;
        futhark_mc_task_338448_task.top_level_fn =
            futhark_mc_segmap_task_338449;
        futhark_mc_task_338448_task.name = "futhark_mc_segmap_task_338449";
        futhark_mc_task_338448_task.iterations = l_n_m_292832;
        futhark_mc_task_338448_task.task_time =
            &ctx->futhark_mc_segmap_task_338449_total_time;
        futhark_mc_task_338448_task.task_iter =
            &ctx->futhark_mc_segmap_task_338449_total_iter;
        futhark_mc_task_338448_task.sched = STATIC;
        futhark_mc_task_338448_task.nested_fn =
            futhark_mc_segmap_nested_task_338452;
        
        int futhark_mc_segmap_task_338449_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_338448_task);
        
        if (futhark_mc_segmap_task_338449_err != 0) {
            ;
            err = futhark_mc_segmap_task_338449_err;
            goto cleanup;
        }
        if (l_n_m_292832 * (int64_t) 8 > 0)
            memmove(mem_315047.mem + gtid_304935 * l_n_m_292832 * (int64_t) 8,
                    mem_315028 + (int64_t) 0, l_n_m_292832 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_315028);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338446_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338446_end -
                 futhark_mc_segmap_parloop_338446_start;
        
        ctx->futhark_mc_segmap_parloop_338446_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338446_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338446_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_nested_task_338444(void *args, int64_t iterations,
                                         int tid, struct scheduler_info info)
{
    int err = 0;
    int flat_tid_304934 = tid;
    int num_tasks_328450 = info.nsubtasks;
    struct futhark_mc_task_338439 *futhark_mc_task_338439 =
                                  (struct futhark_mc_task_338439 *) args;
    struct futhark_context *ctx = futhark_mc_task_338439->ctx;
    uint64_t futhark_mc_segmap_nested_task_338444_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_nested_task_338444_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338439->free_n_292675;
    int64_t q_l_292680 = futhark_mc_task_338439->free_q_l_292680;
    int64_t jump_t_292685 = futhark_mc_task_338439->free_jump_t_292685;
    int64_t partition_sizze_292766 =
            futhark_mc_task_338439->free_partition_sizze_292766;
    int64_t l_n_m_292832 = futhark_mc_task_338439->free_l_n_m_292832;
    int64_t i_292846 = futhark_mc_task_338439->free_i_292846;
    int64_t bytes_313028 = futhark_mc_task_338439->free_bytes_313028;
    struct memblock mem_313081 = {.desc ="mem_313081", .mem =
                                  futhark_mc_task_338439->free_mem_313081,
                                  .size =0, .references =NULL};
    struct memblock mem_313085 = {.desc ="mem_313085", .mem =
                                  futhark_mc_task_338439->free_mem_313085,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_task_338439->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_task_338439->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_task_338439->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_task_338439->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315021 = {.desc ="mem_315021", .mem =
                                  futhark_mc_task_338439->free_mem_315021,
                                  .size =0, .references =NULL};
    struct memblock mem_315047 = {.desc ="mem_315047", .mem =
                                  futhark_mc_task_338439->free_mem_315047,
                                  .size =0, .references =NULL};
    int64_t iter_328514;
    struct futhark_mc_segmap_parloop_struct_338445
    futhark_mc_segmap_parloop_struct_338445;
    
    futhark_mc_segmap_parloop_struct_338445.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338445.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_338445.free_q_l_292680 = q_l_292680;
    futhark_mc_segmap_parloop_struct_338445.free_jump_t_292685 = jump_t_292685;
    futhark_mc_segmap_parloop_struct_338445.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_338445.free_l_n_m_292832 = l_n_m_292832;
    futhark_mc_segmap_parloop_struct_338445.free_i_292846 = i_292846;
    futhark_mc_segmap_parloop_struct_338445.free_bytes_313028 = bytes_313028;
    futhark_mc_segmap_parloop_struct_338445.free_mem_313081 = mem_313081.mem;
    futhark_mc_segmap_parloop_struct_338445.free_mem_313085 = mem_313085.mem;
    futhark_mc_segmap_parloop_struct_338445.free_ctx_param_ext_313174 =
        ctx_param_ext_313174;
    futhark_mc_segmap_parloop_struct_338445.free_ctx_param_ext_313175 =
        ctx_param_ext_313175;
    futhark_mc_segmap_parloop_struct_338445.free_ctx_param_ext_313177 =
        ctx_param_ext_313177;
    futhark_mc_segmap_parloop_struct_338445.free_mem_param_313179 =
        mem_param_313179.mem;
    futhark_mc_segmap_parloop_struct_338445.free_mem_315021 = mem_315021.mem;
    futhark_mc_segmap_parloop_struct_338445.free_mem_315047 = mem_315047.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338446_task;
    
    futhark_mc_segmap_parloop_338446_task.name =
        "futhark_mc_segmap_parloop_338446";
    futhark_mc_segmap_parloop_338446_task.fn = futhark_mc_segmap_parloop_338446;
    futhark_mc_segmap_parloop_338446_task.args =
        &futhark_mc_segmap_parloop_struct_338445;
    futhark_mc_segmap_parloop_338446_task.iterations = iterations;
    futhark_mc_segmap_parloop_338446_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338446_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338446_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338446_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338446_task);
    
    if (futhark_mc_segmap_parloop_338446_err != 0) {
        err = futhark_mc_segmap_parloop_338446_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338446_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338446_total_end -
                 futhark_mc_segmap_parloop_338446_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338446_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338446_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338446_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_nested_task_338444_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_nested_task_338444_end -
                 futhark_mc_segmap_nested_task_338444_start;
        
        ctx->futhark_mc_segmap_nested_task_338444_runs[tid]++;
        ctx->futhark_mc_segmap_nested_task_338444_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_nested_task_338444_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_task_338465 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_l_292680;
    int64_t free_jump_t_292685;
    int64_t free_partition_sizze_292766;
    int64_t free_l_n_m_292832;
    int64_t free_i_292846;
    int64_t free_bytes_313028;
    unsigned char *free_mem_313081;
    unsigned char *free_mem_313085;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315021;
    unsigned char *free_mem_315087;
    unsigned char *free_mem_315091;
};
struct futhark_mc_segmap_parloop_struct_338467 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_l_292680;
    int64_t free_jump_t_292685;
    int64_t free_partition_sizze_292766;
    int64_t free_l_n_m_292832;
    int64_t free_i_292846;
    int64_t free_bytes_313028;
    unsigned char *free_mem_313081;
    unsigned char *free_mem_313085;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315021;
    unsigned char *free_mem_315087;
    unsigned char *free_mem_315091;
};
static int futhark_mc_segmap_parloop_338468(void *args, int64_t start,
                                            int64_t end, int flat_tid_305063,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338467
    *futhark_mc_segmap_parloop_struct_338467 =
    (struct futhark_mc_segmap_parloop_struct_338467 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338467->ctx;
    uint64_t futhark_mc_segmap_parloop_338468_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338468_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_338467->free_n_292675;
    int64_t q_l_292680 =
            futhark_mc_segmap_parloop_struct_338467->free_q_l_292680;
    int64_t jump_t_292685 =
            futhark_mc_segmap_parloop_struct_338467->free_jump_t_292685;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_338467->free_partition_sizze_292766;
    int64_t l_n_m_292832 =
            futhark_mc_segmap_parloop_struct_338467->free_l_n_m_292832;
    int64_t i_292846 = futhark_mc_segmap_parloop_struct_338467->free_i_292846;
    int64_t bytes_313028 =
            futhark_mc_segmap_parloop_struct_338467->free_bytes_313028;
    struct memblock mem_313081 = {.desc ="mem_313081", .mem =
                                  futhark_mc_segmap_parloop_struct_338467->free_mem_313081,
                                  .size =0, .references =NULL};
    struct memblock mem_313085 = {.desc ="mem_313085", .mem =
                                  futhark_mc_segmap_parloop_struct_338467->free_mem_313085,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_segmap_parloop_struct_338467->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_segmap_parloop_struct_338467->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_segmap_parloop_struct_338467->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_segmap_parloop_struct_338467->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315021 = {.desc ="mem_315021", .mem =
                                  futhark_mc_segmap_parloop_struct_338467->free_mem_315021,
                                  .size =0, .references =NULL};
    struct memblock mem_315087 = {.desc ="mem_315087", .mem =
                                  futhark_mc_segmap_parloop_struct_338467->free_mem_315087,
                                  .size =0, .references =NULL};
    struct memblock mem_315091 = {.desc ="mem_315091", .mem =
                                  futhark_mc_segmap_parloop_struct_338467->free_mem_315091,
                                  .size =0, .references =NULL};
    size_t mem_315056_cached_sizze_338469 = 0;
    unsigned char *mem_315056 = NULL;
    size_t mem_315059_cached_sizze_338470 = 0;
    unsigned char *mem_315059 = NULL;
    int64_t iterations = end - start;
    int64_t iter_328755 = start;
    
    if (mem_315056_cached_sizze_338469 < (size_t) bytes_313028) {
        mem_315056 = realloc(mem_315056, bytes_313028);
        mem_315056_cached_sizze_338469 = bytes_313028;
    }
    if (mem_315059_cached_sizze_338470 < (size_t) bytes_313028) {
        mem_315059 = realloc(mem_315059, bytes_313028);
        mem_315059_cached_sizze_338470 = bytes_313028;
    }
    for (; iter_328755 < end; iter_328755++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_328842 = partition_sizze_292766;
        int64_t gtid_305064 = iter_328755;
        int64_t remnant_328843 = iter_328755 - gtid_305064;
        
        for (int64_t i_328756 = 0; i_328756 < l_n_m_292832; i_328756++) {
            int64_t x_328759;
            
            x_328759 = ((int64_t *) mem_313081.mem)[gtid_305064 * l_n_m_292832 +
                                                    i_328756];
            
            double x_328760;
            
            x_328760 = ((double *) mem_313085.mem)[gtid_305064 * l_n_m_292832 +
                                                   i_328756];
            
            int64_t min_arg_328761 = mul64(jump_t_292685, i_328756);
            int64_t min_res_328762 = smin64(i_292846, min_arg_328761);
            int64_t defunc_0_g_res_328763 = add64((int64_t) 1, min_res_328762);
            double defunc_2_reduce_res_328764;
            double defunc_2_reduce_res_328765;
            double defunc_2_reduce_res_328766;
            double redout_328768;
            double redout_328769;
            double redout_328770;
            
            redout_328768 = 0.0;
            redout_328769 = 0.0;
            redout_328770 = 0.0;
            for (int64_t i_328767 = 0; i_328767 < q_l_292680; i_328767++) {
                bool cond_328771 = sle64(n_292675, i_328767);
                int64_t defunc_0_f_res_328772;
                
                if (cond_328771) {
                    defunc_0_f_res_328772 = (int64_t) 0;
                } else {
                    int64_t i_328773 = add64(x_328759, i_328767);
                    int64_t defunc_1_add_res_328774 = add64((int64_t) 1,
                                                            i_328773);
                    
                    defunc_0_f_res_328772 = defunc_1_add_res_328774;
                }
                
                double defunc_0_f_res_328775;
                
                if (cond_328771) {
                    defunc_0_f_res_328775 = 0.0;
                } else {
                    int64_t i_328776 = add64(x_328759, i_328767);
                    double defunc_0_add_arg_328777;
                    
                    defunc_0_add_arg_328777 =
                        ((double *) mem_param_313179.mem)[ctx_param_ext_313174 +
                                                          (gtid_305064 *
                                                           ctx_param_ext_313175 +
                                                           i_328776 *
                                                           ctx_param_ext_313177)];
                    defunc_0_f_res_328775 = defunc_0_add_arg_328777;
                }
                
                int64_t binop_p_328778 = sub64(defunc_0_f_res_328772,
                                               defunc_0_g_res_328763);
                double defunc_0_f_res_328779 = sitofp_i64_f64(binop_p_328778);
                double abs_res_328780 = fabs(defunc_0_f_res_328779);
                double tmp1_328781 = abs_res_328780 / x_328760;
                double x_328782 = tmp1_328781 * tmp1_328781;
                double y_328783 = tmp1_328781 * x_328782;
                double tmp2_328784 = 1.0 - y_328783;
                double x_328785 = tmp2_328784 * tmp2_328784;
                double tmp3_328786 = tmp2_328784 * x_328785;
                double w_j_328787 = defunc_0_f_res_328775 * tmp3_328786;
                double xw_j_328788 = defunc_0_f_res_328779 * w_j_328787;
                double x2w_j_328789 = defunc_0_f_res_328779 * xw_j_328788;
                double defunc_1_op_res_328790 = w_j_328787 + redout_328768;
                double defunc_1_op_res_328791 = xw_j_328788 + redout_328769;
                double defunc_1_op_res_328792 = x2w_j_328789 + redout_328770;
                double redout_tmp_328846 = defunc_1_op_res_328790;
                double redout_tmp_328847 = defunc_1_op_res_328791;
                double redout_tmp_328848 = defunc_1_op_res_328792;
                
                redout_328768 = redout_tmp_328846;
                redout_328769 = redout_tmp_328847;
                redout_328770 = redout_tmp_328848;
            }
            defunc_2_reduce_res_328764 = redout_328768;
            defunc_2_reduce_res_328765 = redout_328769;
            defunc_2_reduce_res_328766 = redout_328770;
            
            double a_328793 = 2.220446049250313e-16 +
                   defunc_2_reduce_res_328764;
            double b_328794 = 2.220446049250313e-16 +
                   defunc_2_reduce_res_328765;
            double c_328795 = 2.220446049250313e-16 +
                   defunc_2_reduce_res_328766;
            double x_328796 = a_328793 * c_328795;
            double y_328797 = b_328794 * b_328794;
            double y_328798 = x_328796 - y_328797;
            double det1_328799 = 1.0 / y_328798;
            double a11_328800 = c_328795 * det1_328799;
            double x_328801 = 0.0 - b_328794;
            double b11_328802 = det1_328799 * x_328801;
            double c11_328803 = a_328793 * det1_328799;
            double defunc_2_reduce_res_328804;
            double defunc_2_reduce_res_328805;
            double redout_328807;
            double redout_328808;
            
            redout_328807 = 0.0;
            redout_328808 = 0.0;
            for (int64_t i_328806 = 0; i_328806 < q_l_292680; i_328806++) {
                bool cond_328809 = sle64(n_292675, i_328806);
                int64_t defunc_0_f_res_328810;
                
                if (cond_328809) {
                    defunc_0_f_res_328810 = (int64_t) 0;
                } else {
                    int64_t i_328811 = add64(x_328759, i_328806);
                    int64_t defunc_1_add_res_328812 = add64((int64_t) 1,
                                                            i_328811);
                    
                    defunc_0_f_res_328810 = defunc_1_add_res_328812;
                }
                
                double defunc_0_f_res_328813;
                
                if (cond_328809) {
                    defunc_0_f_res_328813 = 0.0;
                } else {
                    int64_t i_328814 = add64(x_328759, i_328806);
                    double defunc_0_add_arg_328815;
                    
                    defunc_0_add_arg_328815 =
                        ((double *) mem_param_313179.mem)[ctx_param_ext_313174 +
                                                          (gtid_305064 *
                                                           ctx_param_ext_313175 +
                                                           i_328814 *
                                                           ctx_param_ext_313177)];
                    defunc_0_f_res_328813 = defunc_0_add_arg_328815;
                }
                
                int64_t binop_p_328816 = sub64(defunc_0_f_res_328810,
                                               defunc_0_g_res_328763);
                double defunc_0_f_res_328817 = sitofp_i64_f64(binop_p_328816);
                double abs_res_328818 = fabs(defunc_0_f_res_328817);
                double tmp1_328819 = abs_res_328818 / x_328760;
                double x_328820 = tmp1_328819 * tmp1_328819;
                double y_328821 = tmp1_328819 * x_328820;
                double tmp2_328822 = 1.0 - y_328821;
                double x_328823 = tmp2_328822 * tmp2_328822;
                double tmp3_328824 = tmp2_328822 * x_328823;
                double tmp4_328825 = defunc_0_f_res_328813 * tmp3_328824;
                double defunc_1_f_res_328826 = defunc_0_f_res_328817 *
                       tmp4_328825;
                double defunc_0_f_res_328827;
                
                if (cond_328809) {
                    defunc_0_f_res_328827 = 0.0;
                } else {
                    int64_t i_328828 = add64(x_328759, i_328806);
                    double defunc_0_add_arg_328829;
                    
                    defunc_0_add_arg_328829 =
                        ((double *) mem_315021.mem)[gtid_305064 * n_292675 +
                                                    i_328828];
                    defunc_0_f_res_328827 = defunc_0_add_arg_328829;
                }
                
                double x_328830 = a11_328800 * tmp4_328825;
                double y_328831 = b11_328802 * defunc_1_f_res_328826;
                double x_328832 = x_328830 + y_328831;
                double defunc_9_fit_fun_res_328833 = defunc_0_f_res_328827 *
                       x_328832;
                double x_328834 = b11_328802 * tmp4_328825;
                double y_328835 = c11_328803 * defunc_1_f_res_328826;
                double x_328836 = x_328834 + y_328835;
                double defunc_9_slope_fun_res_328837 = defunc_0_f_res_328827 *
                       x_328836;
                double defunc_1_op_res_328838 = defunc_9_fit_fun_res_328833 +
                       redout_328807;
                double defunc_1_op_res_328839 = defunc_9_slope_fun_res_328837 +
                       redout_328808;
                double redout_tmp_328849 = defunc_1_op_res_328838;
                double redout_tmp_328850 = defunc_1_op_res_328839;
                
                redout_328807 = redout_tmp_328849;
                redout_328808 = redout_tmp_328850;
            }
            defunc_2_reduce_res_328804 = redout_328807;
            defunc_2_reduce_res_328805 = redout_328808;
            ((double *) mem_315056)[i_328756] = defunc_2_reduce_res_328804;
            ((double *) mem_315059)[i_328756] = defunc_2_reduce_res_328805;
        }
        if (l_n_m_292832 * (int64_t) 8 > 0)
            memmove(mem_315087.mem + gtid_305064 * l_n_m_292832 * (int64_t) 8,
                    mem_315056 + (int64_t) 0, l_n_m_292832 * (int64_t) 8);
        if (l_n_m_292832 * (int64_t) 8 > 0)
            memmove(mem_315091.mem + gtid_305064 * l_n_m_292832 * (int64_t) 8,
                    mem_315059 + (int64_t) 0, l_n_m_292832 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_315056);
    free(mem_315059);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338468_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338468_end -
                 futhark_mc_segmap_parloop_338468_start;
        
        ctx->futhark_mc_segmap_parloop_338468_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338468_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338468_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_338466(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_305063 = tid;
    int num_tasks_328754 = info.nsubtasks;
    struct futhark_mc_task_338465 *futhark_mc_task_338465 =
                                  (struct futhark_mc_task_338465 *) args;
    struct futhark_context *ctx = futhark_mc_task_338465->ctx;
    uint64_t futhark_mc_segmap_task_338466_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_338466_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338465->free_n_292675;
    int64_t q_l_292680 = futhark_mc_task_338465->free_q_l_292680;
    int64_t jump_t_292685 = futhark_mc_task_338465->free_jump_t_292685;
    int64_t partition_sizze_292766 =
            futhark_mc_task_338465->free_partition_sizze_292766;
    int64_t l_n_m_292832 = futhark_mc_task_338465->free_l_n_m_292832;
    int64_t i_292846 = futhark_mc_task_338465->free_i_292846;
    int64_t bytes_313028 = futhark_mc_task_338465->free_bytes_313028;
    struct memblock mem_313081 = {.desc ="mem_313081", .mem =
                                  futhark_mc_task_338465->free_mem_313081,
                                  .size =0, .references =NULL};
    struct memblock mem_313085 = {.desc ="mem_313085", .mem =
                                  futhark_mc_task_338465->free_mem_313085,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_task_338465->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_task_338465->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_task_338465->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_task_338465->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315021 = {.desc ="mem_315021", .mem =
                                  futhark_mc_task_338465->free_mem_315021,
                                  .size =0, .references =NULL};
    struct memblock mem_315087 = {.desc ="mem_315087", .mem =
                                  futhark_mc_task_338465->free_mem_315087,
                                  .size =0, .references =NULL};
    struct memblock mem_315091 = {.desc ="mem_315091", .mem =
                                  futhark_mc_task_338465->free_mem_315091,
                                  .size =0, .references =NULL};
    int64_t iter_328755;
    struct futhark_mc_segmap_parloop_struct_338467
    futhark_mc_segmap_parloop_struct_338467;
    
    futhark_mc_segmap_parloop_struct_338467.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338467.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_338467.free_q_l_292680 = q_l_292680;
    futhark_mc_segmap_parloop_struct_338467.free_jump_t_292685 = jump_t_292685;
    futhark_mc_segmap_parloop_struct_338467.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_338467.free_l_n_m_292832 = l_n_m_292832;
    futhark_mc_segmap_parloop_struct_338467.free_i_292846 = i_292846;
    futhark_mc_segmap_parloop_struct_338467.free_bytes_313028 = bytes_313028;
    futhark_mc_segmap_parloop_struct_338467.free_mem_313081 = mem_313081.mem;
    futhark_mc_segmap_parloop_struct_338467.free_mem_313085 = mem_313085.mem;
    futhark_mc_segmap_parloop_struct_338467.free_ctx_param_ext_313174 =
        ctx_param_ext_313174;
    futhark_mc_segmap_parloop_struct_338467.free_ctx_param_ext_313175 =
        ctx_param_ext_313175;
    futhark_mc_segmap_parloop_struct_338467.free_ctx_param_ext_313177 =
        ctx_param_ext_313177;
    futhark_mc_segmap_parloop_struct_338467.free_mem_param_313179 =
        mem_param_313179.mem;
    futhark_mc_segmap_parloop_struct_338467.free_mem_315021 = mem_315021.mem;
    futhark_mc_segmap_parloop_struct_338467.free_mem_315087 = mem_315087.mem;
    futhark_mc_segmap_parloop_struct_338467.free_mem_315091 = mem_315091.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338468_task;
    
    futhark_mc_segmap_parloop_338468_task.name =
        "futhark_mc_segmap_parloop_338468";
    futhark_mc_segmap_parloop_338468_task.fn = futhark_mc_segmap_parloop_338468;
    futhark_mc_segmap_parloop_338468_task.args =
        &futhark_mc_segmap_parloop_struct_338467;
    futhark_mc_segmap_parloop_338468_task.iterations = iterations;
    futhark_mc_segmap_parloop_338468_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338468_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338468_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338468_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338468_task);
    
    if (futhark_mc_segmap_parloop_338468_err != 0) {
        err = futhark_mc_segmap_parloop_338468_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338468_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338468_total_end -
                 futhark_mc_segmap_parloop_338468_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338468_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338468_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338468_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_338466_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_338466_end -
                 futhark_mc_segmap_task_338466_start;
        
        ctx->futhark_mc_segmap_task_338466_runs[tid]++;
        ctx->futhark_mc_segmap_task_338466_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_338466_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_segmap_parloop_struct_338472 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_l_292680;
    int64_t free_jump_t_292685;
    int64_t free_partition_sizze_292766;
    int64_t free_l_n_m_292832;
    int64_t free_i_292846;
    int64_t free_bytes_313028;
    unsigned char *free_mem_313081;
    unsigned char *free_mem_313085;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315021;
    unsigned char *free_mem_315087;
    unsigned char *free_mem_315091;
};
struct futhark_mc_task_338476 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_l_292680;
    int64_t free_jump_t_292685;
    int64_t free_l_n_m_292832;
    int64_t free_i_292846;
    int64_t free_gtid_305169;
    unsigned char *free_mem_313081;
    unsigned char *free_mem_313085;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315021;
    unsigned char *free_mem_315050;
    unsigned char *free_mem_315053;
};
struct futhark_mc_segmap_parloop_struct_338478 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_l_292680;
    int64_t free_jump_t_292685;
    int64_t free_l_n_m_292832;
    int64_t free_i_292846;
    int64_t free_gtid_305169;
    unsigned char *free_mem_313081;
    unsigned char *free_mem_313085;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315021;
    unsigned char *free_mem_315050;
    unsigned char *free_mem_315053;
};
static int futhark_mc_segmap_parloop_338479(void *args, int64_t start,
                                            int64_t end, int flat_tid_328942,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338478
    *futhark_mc_segmap_parloop_struct_338478 =
    (struct futhark_mc_segmap_parloop_struct_338478 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338478->ctx;
    uint64_t futhark_mc_segmap_parloop_338479_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338479_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_338478->free_n_292675;
    int64_t q_l_292680 =
            futhark_mc_segmap_parloop_struct_338478->free_q_l_292680;
    int64_t jump_t_292685 =
            futhark_mc_segmap_parloop_struct_338478->free_jump_t_292685;
    int64_t l_n_m_292832 =
            futhark_mc_segmap_parloop_struct_338478->free_l_n_m_292832;
    int64_t i_292846 = futhark_mc_segmap_parloop_struct_338478->free_i_292846;
    int64_t gtid_305169 =
            futhark_mc_segmap_parloop_struct_338478->free_gtid_305169;
    struct memblock mem_313081 = {.desc ="mem_313081", .mem =
                                  futhark_mc_segmap_parloop_struct_338478->free_mem_313081,
                                  .size =0, .references =NULL};
    struct memblock mem_313085 = {.desc ="mem_313085", .mem =
                                  futhark_mc_segmap_parloop_struct_338478->free_mem_313085,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_segmap_parloop_struct_338478->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_segmap_parloop_struct_338478->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_segmap_parloop_struct_338478->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_segmap_parloop_struct_338478->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315021 = {.desc ="mem_315021", .mem =
                                  futhark_mc_segmap_parloop_struct_338478->free_mem_315021,
                                  .size =0, .references =NULL};
    struct memblock mem_315050 = {.desc ="mem_315050", .mem =
                                  futhark_mc_segmap_parloop_struct_338478->free_mem_315050,
                                  .size =0, .references =NULL};
    struct memblock mem_315053 = {.desc ="mem_315053", .mem =
                                  futhark_mc_segmap_parloop_struct_338478->free_mem_315053,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_329028 = start;
    
    for (; iter_329028 < end; iter_329028++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_329089 = l_n_m_292832;
        int64_t gtid_328943 = iter_329028;
        int64_t remnant_329090 = iter_329028 - gtid_328943;
        int64_t x_328944;
        
        x_328944 = ((int64_t *) mem_313081.mem)[gtid_305169 * l_n_m_292832 +
                                                gtid_328943];
        
        double x_328945;
        
        x_328945 = ((double *) mem_313085.mem)[gtid_305169 * l_n_m_292832 +
                                               gtid_328943];
        
        int64_t min_arg_328946 = mul64(jump_t_292685, gtid_328943);
        int64_t min_res_328947 = smin64(i_292846, min_arg_328946);
        int64_t defunc_0_g_res_328948 = add64((int64_t) 1, min_res_328947);
        double defunc_2_reduce_res_328949;
        double defunc_2_reduce_res_328950;
        double defunc_2_reduce_res_328951;
        double redout_329030;
        double redout_329031;
        double redout_329032;
        
        redout_329030 = 0.0;
        redout_329031 = 0.0;
        redout_329032 = 0.0;
        for (int64_t i_329029 = 0; i_329029 < q_l_292680; i_329029++) {
            bool cond_329033 = sle64(n_292675, i_329029);
            int64_t defunc_0_f_res_329034;
            
            if (cond_329033) {
                defunc_0_f_res_329034 = (int64_t) 0;
            } else {
                int64_t i_329035 = add64(x_328944, i_329029);
                int64_t defunc_1_add_res_329036 = add64((int64_t) 1, i_329035);
                
                defunc_0_f_res_329034 = defunc_1_add_res_329036;
            }
            
            double defunc_0_f_res_329037;
            
            if (cond_329033) {
                defunc_0_f_res_329037 = 0.0;
            } else {
                int64_t i_329038 = add64(x_328944, i_329029);
                double defunc_0_add_arg_329039;
                
                defunc_0_add_arg_329039 =
                    ((double *) mem_param_313179.mem)[ctx_param_ext_313174 +
                                                      (gtid_305169 *
                                                       ctx_param_ext_313175 +
                                                       i_329038 *
                                                       ctx_param_ext_313177)];
                defunc_0_f_res_329037 = defunc_0_add_arg_329039;
            }
            
            int64_t binop_p_329040 = sub64(defunc_0_f_res_329034,
                                           defunc_0_g_res_328948);
            double defunc_0_f_res_329041 = sitofp_i64_f64(binop_p_329040);
            double abs_res_329042 = fabs(defunc_0_f_res_329041);
            double tmp1_329043 = abs_res_329042 / x_328945;
            double x_329044 = tmp1_329043 * tmp1_329043;
            double y_329045 = tmp1_329043 * x_329044;
            double tmp2_329046 = 1.0 - y_329045;
            double x_329047 = tmp2_329046 * tmp2_329046;
            double tmp3_329048 = tmp2_329046 * x_329047;
            double w_j_329049 = defunc_0_f_res_329037 * tmp3_329048;
            double xw_j_329050 = defunc_0_f_res_329041 * w_j_329049;
            double x2w_j_329051 = defunc_0_f_res_329041 * xw_j_329050;
            double defunc_1_op_res_329052 = w_j_329049 + redout_329030;
            double defunc_1_op_res_329053 = xw_j_329050 + redout_329031;
            double defunc_1_op_res_329054 = x2w_j_329051 + redout_329032;
            double redout_tmp_329091 = defunc_1_op_res_329052;
            double redout_tmp_329092 = defunc_1_op_res_329053;
            double redout_tmp_329093 = defunc_1_op_res_329054;
            
            redout_329030 = redout_tmp_329091;
            redout_329031 = redout_tmp_329092;
            redout_329032 = redout_tmp_329093;
        }
        defunc_2_reduce_res_328949 = redout_329030;
        defunc_2_reduce_res_328950 = redout_329031;
        defunc_2_reduce_res_328951 = redout_329032;
        
        double a_328978 = 2.220446049250313e-16 + defunc_2_reduce_res_328949;
        double b_328979 = 2.220446049250313e-16 + defunc_2_reduce_res_328950;
        double c_328980 = 2.220446049250313e-16 + defunc_2_reduce_res_328951;
        double x_328981 = a_328978 * c_328980;
        double y_328982 = b_328979 * b_328979;
        double y_328983 = x_328981 - y_328982;
        double det1_328984 = 1.0 / y_328983;
        double a11_328985 = c_328980 * det1_328984;
        double x_328986 = 0.0 - b_328979;
        double b11_328987 = det1_328984 * x_328986;
        double c11_328988 = a_328978 * det1_328984;
        double defunc_2_reduce_res_328989;
        double defunc_2_reduce_res_328990;
        double redout_329056;
        double redout_329057;
        
        redout_329056 = 0.0;
        redout_329057 = 0.0;
        for (int64_t i_329055 = 0; i_329055 < q_l_292680; i_329055++) {
            bool cond_329058 = sle64(n_292675, i_329055);
            int64_t defunc_0_f_res_329059;
            
            if (cond_329058) {
                defunc_0_f_res_329059 = (int64_t) 0;
            } else {
                int64_t i_329060 = add64(x_328944, i_329055);
                int64_t defunc_1_add_res_329061 = add64((int64_t) 1, i_329060);
                
                defunc_0_f_res_329059 = defunc_1_add_res_329061;
            }
            
            double defunc_0_f_res_329062;
            
            if (cond_329058) {
                defunc_0_f_res_329062 = 0.0;
            } else {
                int64_t i_329063 = add64(x_328944, i_329055);
                double defunc_0_add_arg_329064;
                
                defunc_0_add_arg_329064 =
                    ((double *) mem_param_313179.mem)[ctx_param_ext_313174 +
                                                      (gtid_305169 *
                                                       ctx_param_ext_313175 +
                                                       i_329063 *
                                                       ctx_param_ext_313177)];
                defunc_0_f_res_329062 = defunc_0_add_arg_329064;
            }
            
            int64_t binop_p_329065 = sub64(defunc_0_f_res_329059,
                                           defunc_0_g_res_328948);
            double defunc_0_f_res_329066 = sitofp_i64_f64(binop_p_329065);
            double abs_res_329067 = fabs(defunc_0_f_res_329066);
            double tmp1_329068 = abs_res_329067 / x_328945;
            double x_329069 = tmp1_329068 * tmp1_329068;
            double y_329070 = tmp1_329068 * x_329069;
            double tmp2_329071 = 1.0 - y_329070;
            double x_329072 = tmp2_329071 * tmp2_329071;
            double tmp3_329073 = tmp2_329071 * x_329072;
            double tmp4_329074 = defunc_0_f_res_329062 * tmp3_329073;
            double defunc_1_f_res_329075 = defunc_0_f_res_329066 * tmp4_329074;
            double defunc_0_f_res_329076;
            
            if (cond_329058) {
                defunc_0_f_res_329076 = 0.0;
            } else {
                int64_t i_329077 = add64(x_328944, i_329055);
                double defunc_0_add_arg_329078;
                
                defunc_0_add_arg_329078 =
                    ((double *) mem_315021.mem)[gtid_305169 * n_292675 +
                                                i_329077];
                defunc_0_f_res_329076 = defunc_0_add_arg_329078;
            }
            
            double x_329079 = a11_328985 * tmp4_329074;
            double y_329080 = b11_328987 * defunc_1_f_res_329075;
            double x_329081 = x_329079 + y_329080;
            double defunc_9_fit_fun_res_329082 = defunc_0_f_res_329076 *
                   x_329081;
            double x_329083 = b11_328987 * tmp4_329074;
            double y_329084 = c11_328988 * defunc_1_f_res_329075;
            double x_329085 = x_329083 + y_329084;
            double defunc_9_slope_fun_res_329086 = defunc_0_f_res_329076 *
                   x_329085;
            double defunc_1_op_res_329087 = defunc_9_fit_fun_res_329082 +
                   redout_329056;
            double defunc_1_op_res_329088 = defunc_9_slope_fun_res_329086 +
                   redout_329057;
            double redout_tmp_329094 = defunc_1_op_res_329087;
            double redout_tmp_329095 = defunc_1_op_res_329088;
            
            redout_329056 = redout_tmp_329094;
            redout_329057 = redout_tmp_329095;
        }
        defunc_2_reduce_res_328989 = redout_329056;
        defunc_2_reduce_res_328990 = redout_329057;
        ((double *) mem_315050.mem)[gtid_328943] = defunc_2_reduce_res_328989;
        ((double *) mem_315053.mem)[gtid_328943] = defunc_2_reduce_res_328990;
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338479_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338479_end -
                 futhark_mc_segmap_parloop_338479_start;
        
        ctx->futhark_mc_segmap_parloop_338479_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338479_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338479_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_338477(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_328942 = tid;
    int num_tasks_329027 = info.nsubtasks;
    struct futhark_mc_task_338476 *futhark_mc_task_338476 =
                                  (struct futhark_mc_task_338476 *) args;
    struct futhark_context *ctx = futhark_mc_task_338476->ctx;
    uint64_t futhark_mc_segmap_task_338477_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_338477_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338476->free_n_292675;
    int64_t q_l_292680 = futhark_mc_task_338476->free_q_l_292680;
    int64_t jump_t_292685 = futhark_mc_task_338476->free_jump_t_292685;
    int64_t l_n_m_292832 = futhark_mc_task_338476->free_l_n_m_292832;
    int64_t i_292846 = futhark_mc_task_338476->free_i_292846;
    int64_t gtid_305169 = futhark_mc_task_338476->free_gtid_305169;
    struct memblock mem_313081 = {.desc ="mem_313081", .mem =
                                  futhark_mc_task_338476->free_mem_313081,
                                  .size =0, .references =NULL};
    struct memblock mem_313085 = {.desc ="mem_313085", .mem =
                                  futhark_mc_task_338476->free_mem_313085,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_task_338476->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_task_338476->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_task_338476->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_task_338476->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315021 = {.desc ="mem_315021", .mem =
                                  futhark_mc_task_338476->free_mem_315021,
                                  .size =0, .references =NULL};
    struct memblock mem_315050 = {.desc ="mem_315050", .mem =
                                  futhark_mc_task_338476->free_mem_315050,
                                  .size =0, .references =NULL};
    struct memblock mem_315053 = {.desc ="mem_315053", .mem =
                                  futhark_mc_task_338476->free_mem_315053,
                                  .size =0, .references =NULL};
    int64_t iter_329028;
    struct futhark_mc_segmap_parloop_struct_338478
    futhark_mc_segmap_parloop_struct_338478;
    
    futhark_mc_segmap_parloop_struct_338478.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338478.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_338478.free_q_l_292680 = q_l_292680;
    futhark_mc_segmap_parloop_struct_338478.free_jump_t_292685 = jump_t_292685;
    futhark_mc_segmap_parloop_struct_338478.free_l_n_m_292832 = l_n_m_292832;
    futhark_mc_segmap_parloop_struct_338478.free_i_292846 = i_292846;
    futhark_mc_segmap_parloop_struct_338478.free_gtid_305169 = gtid_305169;
    futhark_mc_segmap_parloop_struct_338478.free_mem_313081 = mem_313081.mem;
    futhark_mc_segmap_parloop_struct_338478.free_mem_313085 = mem_313085.mem;
    futhark_mc_segmap_parloop_struct_338478.free_ctx_param_ext_313174 =
        ctx_param_ext_313174;
    futhark_mc_segmap_parloop_struct_338478.free_ctx_param_ext_313175 =
        ctx_param_ext_313175;
    futhark_mc_segmap_parloop_struct_338478.free_ctx_param_ext_313177 =
        ctx_param_ext_313177;
    futhark_mc_segmap_parloop_struct_338478.free_mem_param_313179 =
        mem_param_313179.mem;
    futhark_mc_segmap_parloop_struct_338478.free_mem_315021 = mem_315021.mem;
    futhark_mc_segmap_parloop_struct_338478.free_mem_315050 = mem_315050.mem;
    futhark_mc_segmap_parloop_struct_338478.free_mem_315053 = mem_315053.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338479_task;
    
    futhark_mc_segmap_parloop_338479_task.name =
        "futhark_mc_segmap_parloop_338479";
    futhark_mc_segmap_parloop_338479_task.fn = futhark_mc_segmap_parloop_338479;
    futhark_mc_segmap_parloop_338479_task.args =
        &futhark_mc_segmap_parloop_struct_338478;
    futhark_mc_segmap_parloop_338479_task.iterations = iterations;
    futhark_mc_segmap_parloop_338479_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338479_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338479_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338479_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338479_task);
    
    if (futhark_mc_segmap_parloop_338479_err != 0) {
        err = futhark_mc_segmap_parloop_338479_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338479_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338479_total_end -
                 futhark_mc_segmap_parloop_338479_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338479_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338479_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338479_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_338477_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_338477_end -
                 futhark_mc_segmap_task_338477_start;
        
        ctx->futhark_mc_segmap_task_338477_runs[tid]++;
        ctx->futhark_mc_segmap_task_338477_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_338477_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_segmap_parloop_struct_338481 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_l_292680;
    int64_t free_jump_t_292685;
    int64_t free_l_n_m_292832;
    int64_t free_i_292846;
    int64_t free_gtid_305169;
    unsigned char *free_mem_313081;
    unsigned char *free_mem_313085;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315021;
    unsigned char *free_mem_315050;
    unsigned char *free_mem_315053;
};
struct futhark_mc_task_338483 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_305169;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    int64_t free_x_328854;
    double free_x_328855;
    int64_t free_defunc_0_g_res_328858;
    double *retval_defunc_2_reduce_res_328859;
    double *retval_defunc_2_reduce_res_328860;
    double *retval_defunc_2_reduce_res_328861;
};
struct futhark_mc_segred_stage_1_parloop_struct_338488 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_305169;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    int64_t free_x_328854;
    double free_x_328855;
    int64_t free_defunc_0_g_res_328858;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_329167;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_329169;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_329171;
};
static int futhark_mc_segred_stage_1_parloop_338489(void *args, int64_t start,
                                                    int64_t end,
                                                    int flat_tid_329097,
                                                    int tid)
{
    int err = 0;
    struct futhark_mc_segred_stage_1_parloop_struct_338488
    *futhark_mc_segred_stage_1_parloop_struct_338488 =
    (struct futhark_mc_segred_stage_1_parloop_struct_338488 *) args;
    struct futhark_context *ctx =
                           futhark_mc_segred_stage_1_parloop_struct_338488->ctx;
    uint64_t futhark_mc_segred_stage_1_parloop_338489_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_338489_start = get_wall_time();
    
    int64_t n_292675 =
            futhark_mc_segred_stage_1_parloop_struct_338488->free_n_292675;
    int64_t gtid_305169 =
            futhark_mc_segred_stage_1_parloop_struct_338488->free_gtid_305169;
    int64_t ctx_param_ext_313174 =
            futhark_mc_segred_stage_1_parloop_struct_338488->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_segred_stage_1_parloop_struct_338488->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_segred_stage_1_parloop_struct_338488->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_segred_stage_1_parloop_struct_338488->free_mem_param_313179,
                                        .size =0, .references =NULL};
    int64_t x_328854 =
            futhark_mc_segred_stage_1_parloop_struct_338488->free_x_328854;
    double x_328855 =
           futhark_mc_segred_stage_1_parloop_struct_338488->free_x_328855;
    int64_t defunc_0_g_res_328858 =
            futhark_mc_segred_stage_1_parloop_struct_338488->free_defunc_0_g_res_328858;
    struct memblock reduce_stage_1_tid_res_arr_mem_329167 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_329167",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338488->free_reduce_stage_1_tid_res_arr_mem_329167,
                                                             .size =0,
                                                             .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_329169 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_329169",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338488->free_reduce_stage_1_tid_res_arr_mem_329169,
                                                             .size =0,
                                                             .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_329171 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_329171",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338488->free_reduce_stage_1_tid_res_arr_mem_329171,
                                                             .size =0,
                                                             .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_329173 = start;
    double x_329099;
    double x_329100;
    double x_329102;
    double x_329103;
    double x_329105;
    double x_329106;
    double local_acc_329174 = 0.0;
    double local_acc_329175 = 0.0;
    double local_acc_329176 = 0.0;
    
    for (; iter_329173 < end; iter_329173++) {
        int64_t gtid_329098 = iter_329173;
        bool cond_329108 = sle64(n_292675, gtid_329098);
        int64_t defunc_0_f_res_329109;
        
        if (cond_329108) {
            defunc_0_f_res_329109 = (int64_t) 0;
        } else {
            int64_t i_329110 = add64(x_328854, gtid_329098);
            int64_t defunc_1_add_res_329111 = add64((int64_t) 1, i_329110);
            
            defunc_0_f_res_329109 = defunc_1_add_res_329111;
        }
        
        double defunc_0_f_res_329112;
        
        if (cond_329108) {
            defunc_0_f_res_329112 = 0.0;
        } else {
            int64_t i_329113 = add64(x_328854, gtid_329098);
            double defunc_0_add_arg_329114;
            
            defunc_0_add_arg_329114 =
                ((double *) mem_param_313179.mem)[ctx_param_ext_313174 +
                                                  (gtid_305169 *
                                                   ctx_param_ext_313175 +
                                                   i_329113 *
                                                   ctx_param_ext_313177)];
            defunc_0_f_res_329112 = defunc_0_add_arg_329114;
        }
        
        int64_t binop_p_329115 = sub64(defunc_0_f_res_329109,
                                       defunc_0_g_res_328858);
        double defunc_0_f_res_329116 = sitofp_i64_f64(binop_p_329115);
        double abs_res_329117 = fabs(defunc_0_f_res_329116);
        double tmp1_329118 = abs_res_329117 / x_328855;
        double x_329119 = tmp1_329118 * tmp1_329118;
        double y_329120 = tmp1_329118 * x_329119;
        double tmp2_329121 = 1.0 - y_329120;
        double x_329122 = tmp2_329121 * tmp2_329121;
        double tmp3_329123 = tmp2_329121 * x_329122;
        double w_j_329124 = defunc_0_f_res_329112 * tmp3_329123;
        double xw_j_329125 = defunc_0_f_res_329116 * w_j_329124;
        double x2w_j_329126 = defunc_0_f_res_329116 * xw_j_329125;
        
        // save map-out results
        { }
        // Load accum params
        {
            x_329099 = local_acc_329174;
        }
        // Load next params
        {
            x_329100 = w_j_329124;
        }
        // Red body
        {
            double defunc_1_op_res_329101 = x_329099 + x_329100;
            
            local_acc_329174 = defunc_1_op_res_329101;
        }
        // Load accum params
        {
            x_329102 = local_acc_329175;
        }
        // Load next params
        {
            x_329103 = xw_j_329125;
        }
        // Red body
        {
            double defunc_1_op_res_329104 = x_329102 + x_329103;
            
            local_acc_329175 = defunc_1_op_res_329104;
        }
        // Load accum params
        {
            x_329105 = local_acc_329176;
        }
        // Load next params
        {
            x_329106 = x2w_j_329126;
        }
        // Red body
        {
            double defunc_1_op_res_329107 = x_329105 + x_329106;
            
            local_acc_329176 = defunc_1_op_res_329107;
        }
    }
    ((double *) reduce_stage_1_tid_res_arr_mem_329167.mem)[flat_tid_329097] =
        local_acc_329174;
    ((double *) reduce_stage_1_tid_res_arr_mem_329169.mem)[flat_tid_329097] =
        local_acc_329175;
    ((double *) reduce_stage_1_tid_res_arr_mem_329171.mem)[flat_tid_329097] =
        local_acc_329176;
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_338489_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_338489_end -
                 futhark_mc_segred_stage_1_parloop_338489_start;
        
        ctx->futhark_mc_segred_stage_1_parloop_338489_runs[tid]++;
        ctx->futhark_mc_segred_stage_1_parloop_338489_total_runtime[tid] +=
            elapsed;
        ctx->futhark_mc_segred_stage_1_parloop_338489_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segred_task_338484(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_329097 = tid;
    int num_tasks_329166 = info.nsubtasks;
    struct futhark_mc_task_338483 *futhark_mc_task_338483 =
                                  (struct futhark_mc_task_338483 *) args;
    struct futhark_context *ctx = futhark_mc_task_338483->ctx;
    uint64_t futhark_mc_segred_task_338484_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_task_338484_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338483->free_n_292675;
    int64_t gtid_305169 = futhark_mc_task_338483->free_gtid_305169;
    int64_t ctx_param_ext_313174 =
            futhark_mc_task_338483->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_task_338483->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_task_338483->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_task_338483->free_mem_param_313179,
                                        .size =0, .references =NULL};
    int64_t x_328854 = futhark_mc_task_338483->free_x_328854;
    double x_328855 = futhark_mc_task_338483->free_x_328855;
    int64_t defunc_0_g_res_328858 =
            futhark_mc_task_338483->free_defunc_0_g_res_328858;
    double defunc_2_reduce_res_328859 =
           *futhark_mc_task_338483->retval_defunc_2_reduce_res_328859;
    double defunc_2_reduce_res_328860 =
           *futhark_mc_task_338483->retval_defunc_2_reduce_res_328860;
    double defunc_2_reduce_res_328861 =
           *futhark_mc_task_338483->retval_defunc_2_reduce_res_328861;
    size_t reduce_stage_1_tid_res_arr_mem_329167_cached_sizze_338485 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_329167 = NULL;
    size_t reduce_stage_1_tid_res_arr_mem_329169_cached_sizze_338486 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_329169 = NULL;
    size_t reduce_stage_1_tid_res_arr_mem_329171_cached_sizze_338487 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_329171 = NULL;
    
    if (reduce_stage_1_tid_res_arr_mem_329167_cached_sizze_338485 <
        (size_t) ((int64_t) 8 * num_tasks_329166)) {
        reduce_stage_1_tid_res_arr_mem_329167 =
            realloc(reduce_stage_1_tid_res_arr_mem_329167, (int64_t) 8 *
                    num_tasks_329166);
        reduce_stage_1_tid_res_arr_mem_329167_cached_sizze_338485 =
            (int64_t) 8 * num_tasks_329166;
    }
    if (reduce_stage_1_tid_res_arr_mem_329169_cached_sizze_338486 <
        (size_t) ((int64_t) 8 * num_tasks_329166)) {
        reduce_stage_1_tid_res_arr_mem_329169 =
            realloc(reduce_stage_1_tid_res_arr_mem_329169, (int64_t) 8 *
                    num_tasks_329166);
        reduce_stage_1_tid_res_arr_mem_329169_cached_sizze_338486 =
            (int64_t) 8 * num_tasks_329166;
    }
    if (reduce_stage_1_tid_res_arr_mem_329171_cached_sizze_338487 <
        (size_t) ((int64_t) 8 * num_tasks_329166)) {
        reduce_stage_1_tid_res_arr_mem_329171 =
            realloc(reduce_stage_1_tid_res_arr_mem_329171, (int64_t) 8 *
                    num_tasks_329166);
        reduce_stage_1_tid_res_arr_mem_329171_cached_sizze_338487 =
            (int64_t) 8 * num_tasks_329166;
    }
    
    int64_t iter_329173;
    struct futhark_mc_segred_stage_1_parloop_struct_338488
    futhark_mc_segred_stage_1_parloop_struct_338488;
    
    futhark_mc_segred_stage_1_parloop_struct_338488.ctx = ctx;
    futhark_mc_segred_stage_1_parloop_struct_338488.free_n_292675 = n_292675;
    futhark_mc_segred_stage_1_parloop_struct_338488.free_gtid_305169 =
        gtid_305169;
    futhark_mc_segred_stage_1_parloop_struct_338488.free_ctx_param_ext_313174 =
        ctx_param_ext_313174;
    futhark_mc_segred_stage_1_parloop_struct_338488.free_ctx_param_ext_313175 =
        ctx_param_ext_313175;
    futhark_mc_segred_stage_1_parloop_struct_338488.free_ctx_param_ext_313177 =
        ctx_param_ext_313177;
    futhark_mc_segred_stage_1_parloop_struct_338488.free_mem_param_313179 =
        mem_param_313179.mem;
    futhark_mc_segred_stage_1_parloop_struct_338488.free_x_328854 = x_328854;
    futhark_mc_segred_stage_1_parloop_struct_338488.free_x_328855 = x_328855;
    futhark_mc_segred_stage_1_parloop_struct_338488.free_defunc_0_g_res_328858 =
        defunc_0_g_res_328858;
    futhark_mc_segred_stage_1_parloop_struct_338488.free_reduce_stage_1_tid_res_arr_mem_329167 =
        reduce_stage_1_tid_res_arr_mem_329167;
    futhark_mc_segred_stage_1_parloop_struct_338488.free_reduce_stage_1_tid_res_arr_mem_329169 =
        reduce_stage_1_tid_res_arr_mem_329169;
    futhark_mc_segred_stage_1_parloop_struct_338488.free_reduce_stage_1_tid_res_arr_mem_329171 =
        reduce_stage_1_tid_res_arr_mem_329171;
    
    struct scheduler_parloop futhark_mc_segred_stage_1_parloop_338489_task;
    
    futhark_mc_segred_stage_1_parloop_338489_task.name =
        "futhark_mc_segred_stage_1_parloop_338489";
    futhark_mc_segred_stage_1_parloop_338489_task.fn =
        futhark_mc_segred_stage_1_parloop_338489;
    futhark_mc_segred_stage_1_parloop_338489_task.args =
        &futhark_mc_segred_stage_1_parloop_struct_338488;
    futhark_mc_segred_stage_1_parloop_338489_task.iterations = iterations;
    futhark_mc_segred_stage_1_parloop_338489_task.info = info;
    
    uint64_t futhark_mc_segred_stage_1_parloop_338489_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_338489_total_start = get_wall_time();
    
    int futhark_mc_segred_stage_1_parloop_338489_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segred_stage_1_parloop_338489_task);
    
    if (futhark_mc_segred_stage_1_parloop_338489_err != 0) {
        err = futhark_mc_segred_stage_1_parloop_338489_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_338489_total_end =
                 get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_338489_total_end -
                 futhark_mc_segred_stage_1_parloop_338489_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338489_total_runs,
                           1, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338489_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338489_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    // neutral-initialise the output
    {
        defunc_2_reduce_res_328859 = 0.0;
        defunc_2_reduce_res_328860 = 0.0;
        defunc_2_reduce_res_328861 = 0.0;
    }
    
    double x_329177;
    double x_329178;
    double x_329180;
    double x_329181;
    double x_329183;
    double x_329184;
    
    for (int32_t i_329186 = 0; i_329186 < num_tasks_329166; i_329186++) {
        flat_tid_329097 = i_329186;
        // Apply main thread reduction
        {
            // load acc params
            {
                x_329177 = defunc_2_reduce_res_328859;
            }
            // load next params
            {
                x_329178 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_329167)[flat_tid_329097];
            }
            // red body
            {
                double defunc_1_op_res_329179 = x_329177 + x_329178;
                
                defunc_2_reduce_res_328859 = defunc_1_op_res_329179;
            }
            // load acc params
            {
                x_329180 = defunc_2_reduce_res_328860;
            }
            // load next params
            {
                x_329181 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_329169)[flat_tid_329097];
            }
            // red body
            {
                double defunc_1_op_res_329182 = x_329180 + x_329181;
                
                defunc_2_reduce_res_328860 = defunc_1_op_res_329182;
            }
            // load acc params
            {
                x_329183 = defunc_2_reduce_res_328861;
            }
            // load next params
            {
                x_329184 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_329171)[flat_tid_329097];
            }
            // red body
            {
                double defunc_1_op_res_329185 = x_329183 + x_329184;
                
                defunc_2_reduce_res_328861 = defunc_1_op_res_329185;
            }
        }
    }
    
  cleanup:
    {
        free(reduce_stage_1_tid_res_arr_mem_329167);
        free(reduce_stage_1_tid_res_arr_mem_329169);
        free(reduce_stage_1_tid_res_arr_mem_329171);
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_task_338484_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_task_338484_end -
                 futhark_mc_segred_task_338484_start;
        
        ctx->futhark_mc_segred_task_338484_runs[tid]++;
        ctx->futhark_mc_segred_task_338484_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segred_task_338484_iter[tid] += iterations;
    }
    if (err == 0) {
        *futhark_mc_task_338483->retval_defunc_2_reduce_res_328859 =
            defunc_2_reduce_res_328859;
        *futhark_mc_task_338483->retval_defunc_2_reduce_res_328860 =
            defunc_2_reduce_res_328860;
        *futhark_mc_task_338483->retval_defunc_2_reduce_res_328861 =
            defunc_2_reduce_res_328861;
    }
    return err;
}
struct futhark_mc_task_338490 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_305169;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315021;
    int64_t free_x_328854;
    double free_x_328855;
    int64_t free_defunc_0_g_res_328858;
    double free_a11_328899;
    double free_b11_328901;
    double free_c11_328902;
    double *retval_defunc_2_reduce_res_328903;
    double *retval_defunc_2_reduce_res_328904;
};
struct futhark_mc_segred_stage_1_parloop_struct_338494 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_305169;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315021;
    int64_t free_x_328854;
    double free_x_328855;
    int64_t free_defunc_0_g_res_328858;
    double free_a11_328899;
    double free_b11_328901;
    double free_c11_328902;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_329188;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_329190;
};
static int futhark_mc_segred_stage_1_parloop_338495(void *args, int64_t start,
                                                    int64_t end,
                                                    int flat_tid_329127,
                                                    int tid)
{
    int err = 0;
    struct futhark_mc_segred_stage_1_parloop_struct_338494
    *futhark_mc_segred_stage_1_parloop_struct_338494 =
    (struct futhark_mc_segred_stage_1_parloop_struct_338494 *) args;
    struct futhark_context *ctx =
                           futhark_mc_segred_stage_1_parloop_struct_338494->ctx;
    uint64_t futhark_mc_segred_stage_1_parloop_338495_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_338495_start = get_wall_time();
    
    int64_t n_292675 =
            futhark_mc_segred_stage_1_parloop_struct_338494->free_n_292675;
    int64_t gtid_305169 =
            futhark_mc_segred_stage_1_parloop_struct_338494->free_gtid_305169;
    int64_t ctx_param_ext_313174 =
            futhark_mc_segred_stage_1_parloop_struct_338494->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_segred_stage_1_parloop_struct_338494->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_segred_stage_1_parloop_struct_338494->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_segred_stage_1_parloop_struct_338494->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315021 = {.desc ="mem_315021", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_338494->free_mem_315021,
                                  .size =0, .references =NULL};
    int64_t x_328854 =
            futhark_mc_segred_stage_1_parloop_struct_338494->free_x_328854;
    double x_328855 =
           futhark_mc_segred_stage_1_parloop_struct_338494->free_x_328855;
    int64_t defunc_0_g_res_328858 =
            futhark_mc_segred_stage_1_parloop_struct_338494->free_defunc_0_g_res_328858;
    double a11_328899 =
           futhark_mc_segred_stage_1_parloop_struct_338494->free_a11_328899;
    double b11_328901 =
           futhark_mc_segred_stage_1_parloop_struct_338494->free_b11_328901;
    double c11_328902 =
           futhark_mc_segred_stage_1_parloop_struct_338494->free_c11_328902;
    struct memblock reduce_stage_1_tid_res_arr_mem_329188 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_329188",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338494->free_reduce_stage_1_tid_res_arr_mem_329188,
                                                             .size =0,
                                                             .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_329190 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_329190",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338494->free_reduce_stage_1_tid_res_arr_mem_329190,
                                                             .size =0,
                                                             .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_329192 = start;
    double x_329129;
    double x_329130;
    double x_329132;
    double x_329133;
    double local_acc_329193 = 0.0;
    double local_acc_329194 = 0.0;
    
    for (; iter_329192 < end; iter_329192++) {
        int64_t gtid_329128 = iter_329192;
        bool cond_329135 = sle64(n_292675, gtid_329128);
        int64_t defunc_0_f_res_329136;
        
        if (cond_329135) {
            defunc_0_f_res_329136 = (int64_t) 0;
        } else {
            int64_t i_329137 = add64(x_328854, gtid_329128);
            int64_t defunc_1_add_res_329138 = add64((int64_t) 1, i_329137);
            
            defunc_0_f_res_329136 = defunc_1_add_res_329138;
        }
        
        double defunc_0_f_res_329139;
        
        if (cond_329135) {
            defunc_0_f_res_329139 = 0.0;
        } else {
            int64_t i_329140 = add64(x_328854, gtid_329128);
            double defunc_0_add_arg_329141;
            
            defunc_0_add_arg_329141 =
                ((double *) mem_param_313179.mem)[ctx_param_ext_313174 +
                                                  (gtid_305169 *
                                                   ctx_param_ext_313175 +
                                                   i_329140 *
                                                   ctx_param_ext_313177)];
            defunc_0_f_res_329139 = defunc_0_add_arg_329141;
        }
        
        int64_t binop_p_329142 = sub64(defunc_0_f_res_329136,
                                       defunc_0_g_res_328858);
        double defunc_0_f_res_329143 = sitofp_i64_f64(binop_p_329142);
        double abs_res_329144 = fabs(defunc_0_f_res_329143);
        double tmp1_329145 = abs_res_329144 / x_328855;
        double x_329146 = tmp1_329145 * tmp1_329145;
        double y_329147 = tmp1_329145 * x_329146;
        double tmp2_329148 = 1.0 - y_329147;
        double x_329149 = tmp2_329148 * tmp2_329148;
        double tmp3_329150 = tmp2_329148 * x_329149;
        double tmp4_329151 = defunc_0_f_res_329139 * tmp3_329150;
        double defunc_1_f_res_329152 = defunc_0_f_res_329143 * tmp4_329151;
        double defunc_0_f_res_329153;
        
        if (cond_329135) {
            defunc_0_f_res_329153 = 0.0;
        } else {
            int64_t i_329154 = add64(x_328854, gtid_329128);
            double defunc_0_add_arg_329155;
            
            defunc_0_add_arg_329155 = ((double *) mem_315021.mem)[gtid_305169 *
                                                                  n_292675 +
                                                                  i_329154];
            defunc_0_f_res_329153 = defunc_0_add_arg_329155;
        }
        
        double x_329156 = a11_328899 * tmp4_329151;
        double y_329157 = b11_328901 * defunc_1_f_res_329152;
        double x_329158 = x_329156 + y_329157;
        double defunc_9_fit_fun_res_329159 = defunc_0_f_res_329153 * x_329158;
        double x_329160 = b11_328901 * tmp4_329151;
        double y_329161 = c11_328902 * defunc_1_f_res_329152;
        double x_329162 = x_329160 + y_329161;
        double defunc_9_slope_fun_res_329163 = defunc_0_f_res_329153 * x_329162;
        
        // save map-out results
        { }
        // Load accum params
        {
            x_329129 = local_acc_329193;
        }
        // Load next params
        {
            x_329130 = defunc_9_fit_fun_res_329159;
        }
        // Red body
        {
            double defunc_1_op_res_329131 = x_329129 + x_329130;
            
            local_acc_329193 = defunc_1_op_res_329131;
        }
        // Load accum params
        {
            x_329132 = local_acc_329194;
        }
        // Load next params
        {
            x_329133 = defunc_9_slope_fun_res_329163;
        }
        // Red body
        {
            double defunc_1_op_res_329134 = x_329132 + x_329133;
            
            local_acc_329194 = defunc_1_op_res_329134;
        }
    }
    ((double *) reduce_stage_1_tid_res_arr_mem_329188.mem)[flat_tid_329127] =
        local_acc_329193;
    ((double *) reduce_stage_1_tid_res_arr_mem_329190.mem)[flat_tid_329127] =
        local_acc_329194;
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_338495_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_338495_end -
                 futhark_mc_segred_stage_1_parloop_338495_start;
        
        ctx->futhark_mc_segred_stage_1_parloop_338495_runs[tid]++;
        ctx->futhark_mc_segred_stage_1_parloop_338495_total_runtime[tid] +=
            elapsed;
        ctx->futhark_mc_segred_stage_1_parloop_338495_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segred_task_338491(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_329127 = tid;
    int num_tasks_329187 = info.nsubtasks;
    struct futhark_mc_task_338490 *futhark_mc_task_338490 =
                                  (struct futhark_mc_task_338490 *) args;
    struct futhark_context *ctx = futhark_mc_task_338490->ctx;
    uint64_t futhark_mc_segred_task_338491_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_task_338491_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338490->free_n_292675;
    int64_t gtid_305169 = futhark_mc_task_338490->free_gtid_305169;
    int64_t ctx_param_ext_313174 =
            futhark_mc_task_338490->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_task_338490->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_task_338490->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_task_338490->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315021 = {.desc ="mem_315021", .mem =
                                  futhark_mc_task_338490->free_mem_315021,
                                  .size =0, .references =NULL};
    int64_t x_328854 = futhark_mc_task_338490->free_x_328854;
    double x_328855 = futhark_mc_task_338490->free_x_328855;
    int64_t defunc_0_g_res_328858 =
            futhark_mc_task_338490->free_defunc_0_g_res_328858;
    double a11_328899 = futhark_mc_task_338490->free_a11_328899;
    double b11_328901 = futhark_mc_task_338490->free_b11_328901;
    double c11_328902 = futhark_mc_task_338490->free_c11_328902;
    double defunc_2_reduce_res_328903 =
           *futhark_mc_task_338490->retval_defunc_2_reduce_res_328903;
    double defunc_2_reduce_res_328904 =
           *futhark_mc_task_338490->retval_defunc_2_reduce_res_328904;
    size_t reduce_stage_1_tid_res_arr_mem_329188_cached_sizze_338492 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_329188 = NULL;
    size_t reduce_stage_1_tid_res_arr_mem_329190_cached_sizze_338493 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_329190 = NULL;
    
    if (reduce_stage_1_tid_res_arr_mem_329188_cached_sizze_338492 <
        (size_t) ((int64_t) 8 * num_tasks_329187)) {
        reduce_stage_1_tid_res_arr_mem_329188 =
            realloc(reduce_stage_1_tid_res_arr_mem_329188, (int64_t) 8 *
                    num_tasks_329187);
        reduce_stage_1_tid_res_arr_mem_329188_cached_sizze_338492 =
            (int64_t) 8 * num_tasks_329187;
    }
    if (reduce_stage_1_tid_res_arr_mem_329190_cached_sizze_338493 <
        (size_t) ((int64_t) 8 * num_tasks_329187)) {
        reduce_stage_1_tid_res_arr_mem_329190 =
            realloc(reduce_stage_1_tid_res_arr_mem_329190, (int64_t) 8 *
                    num_tasks_329187);
        reduce_stage_1_tid_res_arr_mem_329190_cached_sizze_338493 =
            (int64_t) 8 * num_tasks_329187;
    }
    
    int64_t iter_329192;
    struct futhark_mc_segred_stage_1_parloop_struct_338494
    futhark_mc_segred_stage_1_parloop_struct_338494;
    
    futhark_mc_segred_stage_1_parloop_struct_338494.ctx = ctx;
    futhark_mc_segred_stage_1_parloop_struct_338494.free_n_292675 = n_292675;
    futhark_mc_segred_stage_1_parloop_struct_338494.free_gtid_305169 =
        gtid_305169;
    futhark_mc_segred_stage_1_parloop_struct_338494.free_ctx_param_ext_313174 =
        ctx_param_ext_313174;
    futhark_mc_segred_stage_1_parloop_struct_338494.free_ctx_param_ext_313175 =
        ctx_param_ext_313175;
    futhark_mc_segred_stage_1_parloop_struct_338494.free_ctx_param_ext_313177 =
        ctx_param_ext_313177;
    futhark_mc_segred_stage_1_parloop_struct_338494.free_mem_param_313179 =
        mem_param_313179.mem;
    futhark_mc_segred_stage_1_parloop_struct_338494.free_mem_315021 =
        mem_315021.mem;
    futhark_mc_segred_stage_1_parloop_struct_338494.free_x_328854 = x_328854;
    futhark_mc_segred_stage_1_parloop_struct_338494.free_x_328855 = x_328855;
    futhark_mc_segred_stage_1_parloop_struct_338494.free_defunc_0_g_res_328858 =
        defunc_0_g_res_328858;
    futhark_mc_segred_stage_1_parloop_struct_338494.free_a11_328899 =
        a11_328899;
    futhark_mc_segred_stage_1_parloop_struct_338494.free_b11_328901 =
        b11_328901;
    futhark_mc_segred_stage_1_parloop_struct_338494.free_c11_328902 =
        c11_328902;
    futhark_mc_segred_stage_1_parloop_struct_338494.free_reduce_stage_1_tid_res_arr_mem_329188 =
        reduce_stage_1_tid_res_arr_mem_329188;
    futhark_mc_segred_stage_1_parloop_struct_338494.free_reduce_stage_1_tid_res_arr_mem_329190 =
        reduce_stage_1_tid_res_arr_mem_329190;
    
    struct scheduler_parloop futhark_mc_segred_stage_1_parloop_338495_task;
    
    futhark_mc_segred_stage_1_parloop_338495_task.name =
        "futhark_mc_segred_stage_1_parloop_338495";
    futhark_mc_segred_stage_1_parloop_338495_task.fn =
        futhark_mc_segred_stage_1_parloop_338495;
    futhark_mc_segred_stage_1_parloop_338495_task.args =
        &futhark_mc_segred_stage_1_parloop_struct_338494;
    futhark_mc_segred_stage_1_parloop_338495_task.iterations = iterations;
    futhark_mc_segred_stage_1_parloop_338495_task.info = info;
    
    uint64_t futhark_mc_segred_stage_1_parloop_338495_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_338495_total_start = get_wall_time();
    
    int futhark_mc_segred_stage_1_parloop_338495_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segred_stage_1_parloop_338495_task);
    
    if (futhark_mc_segred_stage_1_parloop_338495_err != 0) {
        err = futhark_mc_segred_stage_1_parloop_338495_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_338495_total_end =
                 get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_338495_total_end -
                 futhark_mc_segred_stage_1_parloop_338495_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338495_total_runs,
                           1, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338495_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338495_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    // neutral-initialise the output
    {
        defunc_2_reduce_res_328903 = 0.0;
        defunc_2_reduce_res_328904 = 0.0;
    }
    
    double x_329195;
    double x_329196;
    double x_329198;
    double x_329199;
    
    for (int32_t i_329201 = 0; i_329201 < num_tasks_329187; i_329201++) {
        flat_tid_329127 = i_329201;
        // Apply main thread reduction
        {
            // load acc params
            {
                x_329195 = defunc_2_reduce_res_328903;
            }
            // load next params
            {
                x_329196 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_329188)[flat_tid_329127];
            }
            // red body
            {
                double defunc_1_op_res_329197 = x_329195 + x_329196;
                
                defunc_2_reduce_res_328903 = defunc_1_op_res_329197;
            }
            // load acc params
            {
                x_329198 = defunc_2_reduce_res_328904;
            }
            // load next params
            {
                x_329199 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_329190)[flat_tid_329127];
            }
            // red body
            {
                double defunc_1_op_res_329200 = x_329198 + x_329199;
                
                defunc_2_reduce_res_328904 = defunc_1_op_res_329200;
            }
        }
    }
    
  cleanup:
    {
        free(reduce_stage_1_tid_res_arr_mem_329188);
        free(reduce_stage_1_tid_res_arr_mem_329190);
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_task_338491_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_task_338491_end -
                 futhark_mc_segred_task_338491_start;
        
        ctx->futhark_mc_segred_task_338491_runs[tid]++;
        ctx->futhark_mc_segred_task_338491_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segred_task_338491_iter[tid] += iterations;
    }
    if (err == 0) {
        *futhark_mc_task_338490->retval_defunc_2_reduce_res_328903 =
            defunc_2_reduce_res_328903;
        *futhark_mc_task_338490->retval_defunc_2_reduce_res_328904 =
            defunc_2_reduce_res_328904;
    }
    return err;
}
static int futhark_mc_segmap_parloop_338482(void *args, int64_t start,
                                            int64_t end, int flat_tid_328852,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338481
    *futhark_mc_segmap_parloop_struct_338481 =
    (struct futhark_mc_segmap_parloop_struct_338481 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338481->ctx;
    uint64_t futhark_mc_segmap_parloop_338482_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338482_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_338481->free_n_292675;
    int64_t q_l_292680 =
            futhark_mc_segmap_parloop_struct_338481->free_q_l_292680;
    int64_t jump_t_292685 =
            futhark_mc_segmap_parloop_struct_338481->free_jump_t_292685;
    int64_t l_n_m_292832 =
            futhark_mc_segmap_parloop_struct_338481->free_l_n_m_292832;
    int64_t i_292846 = futhark_mc_segmap_parloop_struct_338481->free_i_292846;
    int64_t gtid_305169 =
            futhark_mc_segmap_parloop_struct_338481->free_gtid_305169;
    struct memblock mem_313081 = {.desc ="mem_313081", .mem =
                                  futhark_mc_segmap_parloop_struct_338481->free_mem_313081,
                                  .size =0, .references =NULL};
    struct memblock mem_313085 = {.desc ="mem_313085", .mem =
                                  futhark_mc_segmap_parloop_struct_338481->free_mem_313085,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_segmap_parloop_struct_338481->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_segmap_parloop_struct_338481->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_segmap_parloop_struct_338481->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_segmap_parloop_struct_338481->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315021 = {.desc ="mem_315021", .mem =
                                  futhark_mc_segmap_parloop_struct_338481->free_mem_315021,
                                  .size =0, .references =NULL};
    struct memblock mem_315050 = {.desc ="mem_315050", .mem =
                                  futhark_mc_segmap_parloop_struct_338481->free_mem_315050,
                                  .size =0, .references =NULL};
    struct memblock mem_315053 = {.desc ="mem_315053", .mem =
                                  futhark_mc_segmap_parloop_struct_338481->free_mem_315053,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_329096 = start;
    
    for (; iter_329096 < end; iter_329096++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_329164 = l_n_m_292832;
        int64_t gtid_328853 = iter_329096;
        int64_t remnant_329165 = iter_329096 - gtid_328853;
        int64_t x_328854;
        
        x_328854 = ((int64_t *) mem_313081.mem)[gtid_305169 * l_n_m_292832 +
                                                gtid_328853];
        
        double x_328855;
        
        x_328855 = ((double *) mem_313085.mem)[gtid_305169 * l_n_m_292832 +
                                               gtid_328853];
        
        int64_t min_arg_328856 = mul64(jump_t_292685, gtid_328853);
        int64_t min_res_328857 = smin64(i_292846, min_arg_328856);
        int64_t defunc_0_g_res_328858 = add64((int64_t) 1, min_res_328857);
        double defunc_2_reduce_res_328859;
        double defunc_2_reduce_res_328860;
        double defunc_2_reduce_res_328861;
        int64_t flat_tid_329097 = (int64_t) 0;
        int32_t num_tasks_329166;
        
        defunc_2_reduce_res_328859 = 0.0;
        defunc_2_reduce_res_328860 = 0.0;
        defunc_2_reduce_res_328861 = 0.0;
        
        struct futhark_mc_task_338483 futhark_mc_task_338483;
        
        futhark_mc_task_338483.ctx = ctx;
        futhark_mc_task_338483.free_n_292675 = n_292675;
        futhark_mc_task_338483.free_gtid_305169 = gtid_305169;
        futhark_mc_task_338483.free_ctx_param_ext_313174 = ctx_param_ext_313174;
        futhark_mc_task_338483.free_ctx_param_ext_313175 = ctx_param_ext_313175;
        futhark_mc_task_338483.free_ctx_param_ext_313177 = ctx_param_ext_313177;
        futhark_mc_task_338483.free_mem_param_313179 = mem_param_313179.mem;
        futhark_mc_task_338483.free_x_328854 = x_328854;
        futhark_mc_task_338483.free_x_328855 = x_328855;
        futhark_mc_task_338483.free_defunc_0_g_res_328858 =
            defunc_0_g_res_328858;
        futhark_mc_task_338483.retval_defunc_2_reduce_res_328859 =
            &defunc_2_reduce_res_328859;
        futhark_mc_task_338483.retval_defunc_2_reduce_res_328860 =
            &defunc_2_reduce_res_328860;
        futhark_mc_task_338483.retval_defunc_2_reduce_res_328861 =
            &defunc_2_reduce_res_328861;
        
        struct scheduler_segop futhark_mc_task_338483_task;
        
        futhark_mc_task_338483_task.args = &futhark_mc_task_338483;
        futhark_mc_task_338483_task.top_level_fn =
            futhark_mc_segred_task_338484;
        futhark_mc_task_338483_task.name = "futhark_mc_segred_task_338484";
        futhark_mc_task_338483_task.iterations = q_l_292680;
        futhark_mc_task_338483_task.task_time =
            &ctx->futhark_mc_segred_task_338484_total_time;
        futhark_mc_task_338483_task.task_iter =
            &ctx->futhark_mc_segred_task_338484_total_iter;
        futhark_mc_task_338483_task.sched = STATIC;
        futhark_mc_task_338483_task.nested_fn = NULL;
        
        int futhark_mc_segred_task_338484_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_338483_task);
        
        if (futhark_mc_segred_task_338484_err != 0) {
            ;
            err = futhark_mc_segred_task_338484_err;
            goto cleanup;
        }
        
        double a_328892 = 2.220446049250313e-16 + defunc_2_reduce_res_328859;
        double b_328893 = 2.220446049250313e-16 + defunc_2_reduce_res_328860;
        double c_328894 = 2.220446049250313e-16 + defunc_2_reduce_res_328861;
        double x_328895 = a_328892 * c_328894;
        double y_328896 = b_328893 * b_328893;
        double y_328897 = x_328895 - y_328896;
        double det1_328898 = 1.0 / y_328897;
        double a11_328899 = c_328894 * det1_328898;
        double x_328900 = 0.0 - b_328893;
        double b11_328901 = det1_328898 * x_328900;
        double c11_328902 = a_328892 * det1_328898;
        double defunc_2_reduce_res_328903;
        double defunc_2_reduce_res_328904;
        int64_t flat_tid_329127 = (int64_t) 0;
        int32_t num_tasks_329187;
        
        defunc_2_reduce_res_328903 = 0.0;
        defunc_2_reduce_res_328904 = 0.0;
        
        struct futhark_mc_task_338490 futhark_mc_task_338490;
        
        futhark_mc_task_338490.ctx = ctx;
        futhark_mc_task_338490.free_n_292675 = n_292675;
        futhark_mc_task_338490.free_gtid_305169 = gtid_305169;
        futhark_mc_task_338490.free_ctx_param_ext_313174 = ctx_param_ext_313174;
        futhark_mc_task_338490.free_ctx_param_ext_313175 = ctx_param_ext_313175;
        futhark_mc_task_338490.free_ctx_param_ext_313177 = ctx_param_ext_313177;
        futhark_mc_task_338490.free_mem_param_313179 = mem_param_313179.mem;
        futhark_mc_task_338490.free_mem_315021 = mem_315021.mem;
        futhark_mc_task_338490.free_x_328854 = x_328854;
        futhark_mc_task_338490.free_x_328855 = x_328855;
        futhark_mc_task_338490.free_defunc_0_g_res_328858 =
            defunc_0_g_res_328858;
        futhark_mc_task_338490.free_a11_328899 = a11_328899;
        futhark_mc_task_338490.free_b11_328901 = b11_328901;
        futhark_mc_task_338490.free_c11_328902 = c11_328902;
        futhark_mc_task_338490.retval_defunc_2_reduce_res_328903 =
            &defunc_2_reduce_res_328903;
        futhark_mc_task_338490.retval_defunc_2_reduce_res_328904 =
            &defunc_2_reduce_res_328904;
        
        struct scheduler_segop futhark_mc_task_338490_task;
        
        futhark_mc_task_338490_task.args = &futhark_mc_task_338490;
        futhark_mc_task_338490_task.top_level_fn =
            futhark_mc_segred_task_338491;
        futhark_mc_task_338490_task.name = "futhark_mc_segred_task_338491";
        futhark_mc_task_338490_task.iterations = q_l_292680;
        futhark_mc_task_338490_task.task_time =
            &ctx->futhark_mc_segred_task_338491_total_time;
        futhark_mc_task_338490_task.task_iter =
            &ctx->futhark_mc_segred_task_338491_total_iter;
        futhark_mc_task_338490_task.sched = STATIC;
        futhark_mc_task_338490_task.nested_fn = NULL;
        
        int futhark_mc_segred_task_338491_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_338490_task);
        
        if (futhark_mc_segred_task_338491_err != 0) {
            ;
            err = futhark_mc_segred_task_338491_err;
            goto cleanup;
        }
        ((double *) mem_315050.mem)[gtid_328853] = defunc_2_reduce_res_328903;
        ((double *) mem_315053.mem)[gtid_328853] = defunc_2_reduce_res_328904;
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338482_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338482_end -
                 futhark_mc_segmap_parloop_338482_start;
        
        ctx->futhark_mc_segmap_parloop_338482_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338482_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338482_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_nested_task_338480(void *args, int64_t iterations,
                                         int tid, struct scheduler_info info)
{
    int err = 0;
    int flat_tid_328852 = tid;
    int num_tasks_329027 = info.nsubtasks;
    struct futhark_mc_task_338476 *futhark_mc_task_338476 =
                                  (struct futhark_mc_task_338476 *) args;
    struct futhark_context *ctx = futhark_mc_task_338476->ctx;
    uint64_t futhark_mc_segmap_nested_task_338480_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_nested_task_338480_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338476->free_n_292675;
    int64_t q_l_292680 = futhark_mc_task_338476->free_q_l_292680;
    int64_t jump_t_292685 = futhark_mc_task_338476->free_jump_t_292685;
    int64_t l_n_m_292832 = futhark_mc_task_338476->free_l_n_m_292832;
    int64_t i_292846 = futhark_mc_task_338476->free_i_292846;
    int64_t gtid_305169 = futhark_mc_task_338476->free_gtid_305169;
    struct memblock mem_313081 = {.desc ="mem_313081", .mem =
                                  futhark_mc_task_338476->free_mem_313081,
                                  .size =0, .references =NULL};
    struct memblock mem_313085 = {.desc ="mem_313085", .mem =
                                  futhark_mc_task_338476->free_mem_313085,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_task_338476->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_task_338476->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_task_338476->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_task_338476->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315021 = {.desc ="mem_315021", .mem =
                                  futhark_mc_task_338476->free_mem_315021,
                                  .size =0, .references =NULL};
    struct memblock mem_315050 = {.desc ="mem_315050", .mem =
                                  futhark_mc_task_338476->free_mem_315050,
                                  .size =0, .references =NULL};
    struct memblock mem_315053 = {.desc ="mem_315053", .mem =
                                  futhark_mc_task_338476->free_mem_315053,
                                  .size =0, .references =NULL};
    int64_t iter_329096;
    struct futhark_mc_segmap_parloop_struct_338481
    futhark_mc_segmap_parloop_struct_338481;
    
    futhark_mc_segmap_parloop_struct_338481.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338481.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_338481.free_q_l_292680 = q_l_292680;
    futhark_mc_segmap_parloop_struct_338481.free_jump_t_292685 = jump_t_292685;
    futhark_mc_segmap_parloop_struct_338481.free_l_n_m_292832 = l_n_m_292832;
    futhark_mc_segmap_parloop_struct_338481.free_i_292846 = i_292846;
    futhark_mc_segmap_parloop_struct_338481.free_gtid_305169 = gtid_305169;
    futhark_mc_segmap_parloop_struct_338481.free_mem_313081 = mem_313081.mem;
    futhark_mc_segmap_parloop_struct_338481.free_mem_313085 = mem_313085.mem;
    futhark_mc_segmap_parloop_struct_338481.free_ctx_param_ext_313174 =
        ctx_param_ext_313174;
    futhark_mc_segmap_parloop_struct_338481.free_ctx_param_ext_313175 =
        ctx_param_ext_313175;
    futhark_mc_segmap_parloop_struct_338481.free_ctx_param_ext_313177 =
        ctx_param_ext_313177;
    futhark_mc_segmap_parloop_struct_338481.free_mem_param_313179 =
        mem_param_313179.mem;
    futhark_mc_segmap_parloop_struct_338481.free_mem_315021 = mem_315021.mem;
    futhark_mc_segmap_parloop_struct_338481.free_mem_315050 = mem_315050.mem;
    futhark_mc_segmap_parloop_struct_338481.free_mem_315053 = mem_315053.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338482_task;
    
    futhark_mc_segmap_parloop_338482_task.name =
        "futhark_mc_segmap_parloop_338482";
    futhark_mc_segmap_parloop_338482_task.fn = futhark_mc_segmap_parloop_338482;
    futhark_mc_segmap_parloop_338482_task.args =
        &futhark_mc_segmap_parloop_struct_338481;
    futhark_mc_segmap_parloop_338482_task.iterations = iterations;
    futhark_mc_segmap_parloop_338482_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338482_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338482_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338482_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338482_task);
    
    if (futhark_mc_segmap_parloop_338482_err != 0) {
        err = futhark_mc_segmap_parloop_338482_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338482_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338482_total_end -
                 futhark_mc_segmap_parloop_338482_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338482_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338482_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338482_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_nested_task_338480_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_nested_task_338480_end -
                 futhark_mc_segmap_nested_task_338480_start;
        
        ctx->futhark_mc_segmap_nested_task_338480_runs[tid]++;
        ctx->futhark_mc_segmap_nested_task_338480_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_nested_task_338480_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
static int futhark_mc_segmap_parloop_338473(void *args, int64_t start,
                                            int64_t end, int flat_tid_305168,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338472
    *futhark_mc_segmap_parloop_struct_338472 =
    (struct futhark_mc_segmap_parloop_struct_338472 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338472->ctx;
    uint64_t futhark_mc_segmap_parloop_338473_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338473_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_338472->free_n_292675;
    int64_t q_l_292680 =
            futhark_mc_segmap_parloop_struct_338472->free_q_l_292680;
    int64_t jump_t_292685 =
            futhark_mc_segmap_parloop_struct_338472->free_jump_t_292685;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_338472->free_partition_sizze_292766;
    int64_t l_n_m_292832 =
            futhark_mc_segmap_parloop_struct_338472->free_l_n_m_292832;
    int64_t i_292846 = futhark_mc_segmap_parloop_struct_338472->free_i_292846;
    int64_t bytes_313028 =
            futhark_mc_segmap_parloop_struct_338472->free_bytes_313028;
    struct memblock mem_313081 = {.desc ="mem_313081", .mem =
                                  futhark_mc_segmap_parloop_struct_338472->free_mem_313081,
                                  .size =0, .references =NULL};
    struct memblock mem_313085 = {.desc ="mem_313085", .mem =
                                  futhark_mc_segmap_parloop_struct_338472->free_mem_313085,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_segmap_parloop_struct_338472->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_segmap_parloop_struct_338472->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_segmap_parloop_struct_338472->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_segmap_parloop_struct_338472->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315021 = {.desc ="mem_315021", .mem =
                                  futhark_mc_segmap_parloop_struct_338472->free_mem_315021,
                                  .size =0, .references =NULL};
    struct memblock mem_315087 = {.desc ="mem_315087", .mem =
                                  futhark_mc_segmap_parloop_struct_338472->free_mem_315087,
                                  .size =0, .references =NULL};
    struct memblock mem_315091 = {.desc ="mem_315091", .mem =
                                  futhark_mc_segmap_parloop_struct_338472->free_mem_315091,
                                  .size =0, .references =NULL};
    size_t mem_315050_cached_sizze_338474 = 0;
    unsigned char *mem_315050 = NULL;
    size_t mem_315053_cached_sizze_338475 = 0;
    unsigned char *mem_315053 = NULL;
    int64_t iterations = end - start;
    int64_t iter_328851 = start;
    
    if (mem_315050_cached_sizze_338474 < (size_t) bytes_313028) {
        mem_315050 = realloc(mem_315050, bytes_313028);
        mem_315050_cached_sizze_338474 = bytes_313028;
    }
    if (mem_315053_cached_sizze_338475 < (size_t) bytes_313028) {
        mem_315053 = realloc(mem_315053, bytes_313028);
        mem_315053_cached_sizze_338475 = bytes_313028;
    }
    for (; iter_328851 < end; iter_328851++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_329025 = partition_sizze_292766;
        int64_t gtid_305169 = iter_328851;
        int64_t remnant_329026 = iter_328851 - gtid_305169;
        int64_t flat_tid_328942 = (int64_t) 0;
        int32_t num_tasks_329027;
        int64_t flat_tid_328852 = (int64_t) 0;
        struct futhark_mc_task_338476 futhark_mc_task_338476;
        
        futhark_mc_task_338476.ctx = ctx;
        futhark_mc_task_338476.free_n_292675 = n_292675;
        futhark_mc_task_338476.free_q_l_292680 = q_l_292680;
        futhark_mc_task_338476.free_jump_t_292685 = jump_t_292685;
        futhark_mc_task_338476.free_l_n_m_292832 = l_n_m_292832;
        futhark_mc_task_338476.free_i_292846 = i_292846;
        futhark_mc_task_338476.free_gtid_305169 = gtid_305169;
        futhark_mc_task_338476.free_mem_313081 = mem_313081.mem;
        futhark_mc_task_338476.free_mem_313085 = mem_313085.mem;
        futhark_mc_task_338476.free_ctx_param_ext_313174 = ctx_param_ext_313174;
        futhark_mc_task_338476.free_ctx_param_ext_313175 = ctx_param_ext_313175;
        futhark_mc_task_338476.free_ctx_param_ext_313177 = ctx_param_ext_313177;
        futhark_mc_task_338476.free_mem_param_313179 = mem_param_313179.mem;
        futhark_mc_task_338476.free_mem_315021 = mem_315021.mem;
        futhark_mc_task_338476.free_mem_315050 = mem_315050;
        futhark_mc_task_338476.free_mem_315053 = mem_315053;
        
        struct scheduler_segop futhark_mc_task_338476_task;
        
        futhark_mc_task_338476_task.args = &futhark_mc_task_338476;
        futhark_mc_task_338476_task.top_level_fn =
            futhark_mc_segmap_task_338477;
        futhark_mc_task_338476_task.name = "futhark_mc_segmap_task_338477";
        futhark_mc_task_338476_task.iterations = l_n_m_292832;
        futhark_mc_task_338476_task.task_time =
            &ctx->futhark_mc_segmap_task_338477_total_time;
        futhark_mc_task_338476_task.task_iter =
            &ctx->futhark_mc_segmap_task_338477_total_iter;
        futhark_mc_task_338476_task.sched = STATIC;
        futhark_mc_task_338476_task.nested_fn =
            futhark_mc_segmap_nested_task_338480;
        
        int futhark_mc_segmap_task_338477_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_338476_task);
        
        if (futhark_mc_segmap_task_338477_err != 0) {
            ;
            err = futhark_mc_segmap_task_338477_err;
            goto cleanup;
        }
        if (l_n_m_292832 * (int64_t) 8 > 0)
            memmove(mem_315087.mem + gtid_305169 * l_n_m_292832 * (int64_t) 8,
                    mem_315050 + (int64_t) 0, l_n_m_292832 * (int64_t) 8);
        if (l_n_m_292832 * (int64_t) 8 > 0)
            memmove(mem_315091.mem + gtid_305169 * l_n_m_292832 * (int64_t) 8,
                    mem_315053 + (int64_t) 0, l_n_m_292832 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_315050);
    free(mem_315053);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338473_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338473_end -
                 futhark_mc_segmap_parloop_338473_start;
        
        ctx->futhark_mc_segmap_parloop_338473_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338473_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338473_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_nested_task_338471(void *args, int64_t iterations,
                                         int tid, struct scheduler_info info)
{
    int err = 0;
    int flat_tid_305168 = tid;
    int num_tasks_328754 = info.nsubtasks;
    struct futhark_mc_task_338465 *futhark_mc_task_338465 =
                                  (struct futhark_mc_task_338465 *) args;
    struct futhark_context *ctx = futhark_mc_task_338465->ctx;
    uint64_t futhark_mc_segmap_nested_task_338471_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_nested_task_338471_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338465->free_n_292675;
    int64_t q_l_292680 = futhark_mc_task_338465->free_q_l_292680;
    int64_t jump_t_292685 = futhark_mc_task_338465->free_jump_t_292685;
    int64_t partition_sizze_292766 =
            futhark_mc_task_338465->free_partition_sizze_292766;
    int64_t l_n_m_292832 = futhark_mc_task_338465->free_l_n_m_292832;
    int64_t i_292846 = futhark_mc_task_338465->free_i_292846;
    int64_t bytes_313028 = futhark_mc_task_338465->free_bytes_313028;
    struct memblock mem_313081 = {.desc ="mem_313081", .mem =
                                  futhark_mc_task_338465->free_mem_313081,
                                  .size =0, .references =NULL};
    struct memblock mem_313085 = {.desc ="mem_313085", .mem =
                                  futhark_mc_task_338465->free_mem_313085,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_task_338465->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_task_338465->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_task_338465->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_task_338465->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315021 = {.desc ="mem_315021", .mem =
                                  futhark_mc_task_338465->free_mem_315021,
                                  .size =0, .references =NULL};
    struct memblock mem_315087 = {.desc ="mem_315087", .mem =
                                  futhark_mc_task_338465->free_mem_315087,
                                  .size =0, .references =NULL};
    struct memblock mem_315091 = {.desc ="mem_315091", .mem =
                                  futhark_mc_task_338465->free_mem_315091,
                                  .size =0, .references =NULL};
    int64_t iter_328851;
    struct futhark_mc_segmap_parloop_struct_338472
    futhark_mc_segmap_parloop_struct_338472;
    
    futhark_mc_segmap_parloop_struct_338472.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338472.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_338472.free_q_l_292680 = q_l_292680;
    futhark_mc_segmap_parloop_struct_338472.free_jump_t_292685 = jump_t_292685;
    futhark_mc_segmap_parloop_struct_338472.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_338472.free_l_n_m_292832 = l_n_m_292832;
    futhark_mc_segmap_parloop_struct_338472.free_i_292846 = i_292846;
    futhark_mc_segmap_parloop_struct_338472.free_bytes_313028 = bytes_313028;
    futhark_mc_segmap_parloop_struct_338472.free_mem_313081 = mem_313081.mem;
    futhark_mc_segmap_parloop_struct_338472.free_mem_313085 = mem_313085.mem;
    futhark_mc_segmap_parloop_struct_338472.free_ctx_param_ext_313174 =
        ctx_param_ext_313174;
    futhark_mc_segmap_parloop_struct_338472.free_ctx_param_ext_313175 =
        ctx_param_ext_313175;
    futhark_mc_segmap_parloop_struct_338472.free_ctx_param_ext_313177 =
        ctx_param_ext_313177;
    futhark_mc_segmap_parloop_struct_338472.free_mem_param_313179 =
        mem_param_313179.mem;
    futhark_mc_segmap_parloop_struct_338472.free_mem_315021 = mem_315021.mem;
    futhark_mc_segmap_parloop_struct_338472.free_mem_315087 = mem_315087.mem;
    futhark_mc_segmap_parloop_struct_338472.free_mem_315091 = mem_315091.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338473_task;
    
    futhark_mc_segmap_parloop_338473_task.name =
        "futhark_mc_segmap_parloop_338473";
    futhark_mc_segmap_parloop_338473_task.fn = futhark_mc_segmap_parloop_338473;
    futhark_mc_segmap_parloop_338473_task.args =
        &futhark_mc_segmap_parloop_struct_338472;
    futhark_mc_segmap_parloop_338473_task.iterations = iterations;
    futhark_mc_segmap_parloop_338473_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338473_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338473_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338473_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338473_task);
    
    if (futhark_mc_segmap_parloop_338473_err != 0) {
        err = futhark_mc_segmap_parloop_338473_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338473_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338473_total_end -
                 futhark_mc_segmap_parloop_338473_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338473_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338473_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338473_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_nested_task_338471_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_nested_task_338471_end -
                 futhark_mc_segmap_nested_task_338471_start;
        
        ctx->futhark_mc_segmap_nested_task_338471_runs[tid]++;
        ctx->futhark_mc_segmap_nested_task_338471_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_nested_task_338471_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_task_338496 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_l_292680;
    int64_t free_jump_t_292685;
    int64_t free_partition_sizze_292766;
    int64_t free_l_n_m_292832;
    int64_t free_i_292846;
    int64_t free_bytes_313028;
    unsigned char *free_mem_313081;
    unsigned char *free_mem_313085;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315021;
    unsigned char *free_mem_315131;
    unsigned char *free_mem_315135;
};
struct futhark_mc_segmap_parloop_struct_338498 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_l_292680;
    int64_t free_jump_t_292685;
    int64_t free_partition_sizze_292766;
    int64_t free_l_n_m_292832;
    int64_t free_i_292846;
    int64_t free_bytes_313028;
    unsigned char *free_mem_313081;
    unsigned char *free_mem_313085;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315021;
    unsigned char *free_mem_315131;
    unsigned char *free_mem_315135;
};
static int futhark_mc_segmap_parloop_338499(void *args, int64_t start,
                                            int64_t end, int flat_tid_305358,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338498
    *futhark_mc_segmap_parloop_struct_338498 =
    (struct futhark_mc_segmap_parloop_struct_338498 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338498->ctx;
    uint64_t futhark_mc_segmap_parloop_338499_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338499_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_338498->free_n_292675;
    int64_t q_l_292680 =
            futhark_mc_segmap_parloop_struct_338498->free_q_l_292680;
    int64_t jump_t_292685 =
            futhark_mc_segmap_parloop_struct_338498->free_jump_t_292685;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_338498->free_partition_sizze_292766;
    int64_t l_n_m_292832 =
            futhark_mc_segmap_parloop_struct_338498->free_l_n_m_292832;
    int64_t i_292846 = futhark_mc_segmap_parloop_struct_338498->free_i_292846;
    int64_t bytes_313028 =
            futhark_mc_segmap_parloop_struct_338498->free_bytes_313028;
    struct memblock mem_313081 = {.desc ="mem_313081", .mem =
                                  futhark_mc_segmap_parloop_struct_338498->free_mem_313081,
                                  .size =0, .references =NULL};
    struct memblock mem_313085 = {.desc ="mem_313085", .mem =
                                  futhark_mc_segmap_parloop_struct_338498->free_mem_313085,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_segmap_parloop_struct_338498->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_segmap_parloop_struct_338498->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_segmap_parloop_struct_338498->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_segmap_parloop_struct_338498->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315021 = {.desc ="mem_315021", .mem =
                                  futhark_mc_segmap_parloop_struct_338498->free_mem_315021,
                                  .size =0, .references =NULL};
    struct memblock mem_315131 = {.desc ="mem_315131", .mem =
                                  futhark_mc_segmap_parloop_struct_338498->free_mem_315131,
                                  .size =0, .references =NULL};
    struct memblock mem_315135 = {.desc ="mem_315135", .mem =
                                  futhark_mc_segmap_parloop_struct_338498->free_mem_315135,
                                  .size =0, .references =NULL};
    size_t mem_315100_cached_sizze_338500 = 0;
    unsigned char *mem_315100 = NULL;
    size_t mem_315103_cached_sizze_338501 = 0;
    unsigned char *mem_315103 = NULL;
    int64_t iterations = end - start;
    int64_t iter_329203 = start;
    
    if (mem_315100_cached_sizze_338500 < (size_t) bytes_313028) {
        mem_315100 = realloc(mem_315100, bytes_313028);
        mem_315100_cached_sizze_338500 = bytes_313028;
    }
    if (mem_315103_cached_sizze_338501 < (size_t) bytes_313028) {
        mem_315103 = realloc(mem_315103, bytes_313028);
        mem_315103_cached_sizze_338501 = bytes_313028;
    }
    for (; iter_329203 < end; iter_329203++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_329322 = partition_sizze_292766;
        int64_t gtid_305359 = iter_329203;
        int64_t remnant_329323 = iter_329203 - gtid_305359;
        
        for (int64_t i_329204 = 0; i_329204 < l_n_m_292832; i_329204++) {
            int64_t x_329207;
            
            x_329207 = ((int64_t *) mem_313081.mem)[gtid_305359 * l_n_m_292832 +
                                                    i_329204];
            
            double x_329208;
            
            x_329208 = ((double *) mem_313085.mem)[gtid_305359 * l_n_m_292832 +
                                                   i_329204];
            
            int64_t min_arg_329209 = mul64(jump_t_292685, i_329204);
            int64_t min_res_329210 = smin64(i_292846, min_arg_329209);
            int64_t defunc_0_g_res_329211 = add64((int64_t) 1, min_res_329210);
            double defunc_2_reduce_res_329212;
            double defunc_2_reduce_res_329213;
            double defunc_2_reduce_res_329214;
            double defunc_2_reduce_res_329215;
            double defunc_2_reduce_res_329216;
            double redout_329218;
            double redout_329219;
            double redout_329220;
            double redout_329221;
            double redout_329222;
            
            redout_329218 = 0.0;
            redout_329219 = 0.0;
            redout_329220 = 0.0;
            redout_329221 = 0.0;
            redout_329222 = 0.0;
            for (int64_t i_329217 = 0; i_329217 < q_l_292680; i_329217++) {
                bool cond_329223 = sle64(n_292675, i_329217);
                int64_t defunc_0_f_res_329224;
                
                if (cond_329223) {
                    defunc_0_f_res_329224 = (int64_t) 0;
                } else {
                    int64_t i_329225 = add64(x_329207, i_329217);
                    int64_t defunc_1_add_res_329226 = add64((int64_t) 1,
                                                            i_329225);
                    
                    defunc_0_f_res_329224 = defunc_1_add_res_329226;
                }
                
                double defunc_0_f_res_329227;
                
                if (cond_329223) {
                    defunc_0_f_res_329227 = 0.0;
                } else {
                    int64_t i_329228 = add64(x_329207, i_329217);
                    double defunc_0_add_arg_329229;
                    
                    defunc_0_add_arg_329229 =
                        ((double *) mem_param_313179.mem)[ctx_param_ext_313174 +
                                                          (gtid_305359 *
                                                           ctx_param_ext_313175 +
                                                           i_329228 *
                                                           ctx_param_ext_313177)];
                    defunc_0_f_res_329227 = defunc_0_add_arg_329229;
                }
                
                int64_t binop_p_329230 = sub64(defunc_0_f_res_329224,
                                               defunc_0_g_res_329211);
                double defunc_0_f_res_329231 = sitofp_i64_f64(binop_p_329230);
                double abs_res_329232 = fabs(defunc_0_f_res_329231);
                double tmp1_329233 = abs_res_329232 / x_329208;
                double x_329234 = tmp1_329233 * tmp1_329233;
                double y_329235 = tmp1_329233 * x_329234;
                double tmp2_329236 = 1.0 - y_329235;
                double x_329237 = tmp2_329236 * tmp2_329236;
                double tmp3_329238 = tmp2_329236 * x_329237;
                double w_j_329239 = defunc_0_f_res_329227 * tmp3_329238;
                double xw_j_329240 = defunc_0_f_res_329231 * w_j_329239;
                double x2w_j_329241 = defunc_0_f_res_329231 * xw_j_329240;
                double x3w_j_329242 = defunc_0_f_res_329231 * x2w_j_329241;
                double x4w_j_329243 = defunc_0_f_res_329231 * x3w_j_329242;
                double defunc_1_op_res_329244 = w_j_329239 + redout_329218;
                double defunc_1_op_res_329245 = xw_j_329240 + redout_329219;
                double defunc_1_op_res_329246 = x2w_j_329241 + redout_329220;
                double defunc_1_op_res_329247 = x3w_j_329242 + redout_329221;
                double defunc_1_op_res_329248 = x4w_j_329243 + redout_329222;
                double redout_tmp_329326 = defunc_1_op_res_329244;
                double redout_tmp_329327 = defunc_1_op_res_329245;
                double redout_tmp_329328 = defunc_1_op_res_329246;
                double redout_tmp_329329 = defunc_1_op_res_329247;
                double redout_tmp_329330 = defunc_1_op_res_329248;
                
                redout_329218 = redout_tmp_329326;
                redout_329219 = redout_tmp_329327;
                redout_329220 = redout_tmp_329328;
                redout_329221 = redout_tmp_329329;
                redout_329222 = redout_tmp_329330;
            }
            defunc_2_reduce_res_329212 = redout_329218;
            defunc_2_reduce_res_329213 = redout_329219;
            defunc_2_reduce_res_329214 = redout_329220;
            defunc_2_reduce_res_329215 = redout_329221;
            defunc_2_reduce_res_329216 = redout_329222;
            
            double a_329249 = 2.220446049250313e-16 +
                   defunc_2_reduce_res_329212;
            double b_329250 = 2.220446049250313e-16 +
                   defunc_2_reduce_res_329213;
            double c_329251 = 2.220446049250313e-16 +
                   defunc_2_reduce_res_329214;
            double d_329252 = 2.220446049250313e-16 +
                   defunc_2_reduce_res_329215;
            double e_329253 = 2.220446049250313e-16 +
                   defunc_2_reduce_res_329216;
            double x_329254 = c_329251 * e_329253;
            double y_329255 = d_329252 * d_329252;
            double a12_329256 = x_329254 - y_329255;
            double x_329257 = c_329251 * d_329252;
            double y_329258 = b_329250 * e_329253;
            double b12_329259 = x_329257 - y_329258;
            double x_329260 = b_329250 * d_329252;
            double y_329261 = c_329251 * c_329251;
            double c12_329262 = x_329260 - y_329261;
            double x_329263 = a_329249 * e_329253;
            double b2_329264 = x_329263 - y_329261;
            double x_329265 = b_329250 * c_329251;
            double y_329266 = a_329249 * d_329252;
            double c2_329267 = x_329265 - y_329266;
            double x_329268 = a_329249 * a12_329256;
            double y_329269 = b_329250 * b12_329259;
            double x_329270 = x_329268 + y_329269;
            double y_329271 = c_329251 * c12_329262;
            double y_329272 = x_329270 + y_329271;
            double det_329273 = 1.0 / y_329272;
            double a12_329274 = a12_329256 * det_329273;
            double b12_329275 = b12_329259 * det_329273;
            double c12_329276 = c12_329262 * det_329273;
            double b2_329277 = b2_329264 * det_329273;
            double c2_329278 = c2_329267 * det_329273;
            double defunc_2_reduce_res_329279;
            double defunc_2_reduce_res_329280;
            double redout_329282;
            double redout_329283;
            
            redout_329282 = 0.0;
            redout_329283 = 0.0;
            for (int64_t i_329281 = 0; i_329281 < q_l_292680; i_329281++) {
                bool cond_329284 = sle64(n_292675, i_329281);
                int64_t defunc_0_f_res_329285;
                
                if (cond_329284) {
                    defunc_0_f_res_329285 = (int64_t) 0;
                } else {
                    int64_t i_329286 = add64(x_329207, i_329281);
                    int64_t defunc_1_add_res_329287 = add64((int64_t) 1,
                                                            i_329286);
                    
                    defunc_0_f_res_329285 = defunc_1_add_res_329287;
                }
                
                double defunc_0_f_res_329288;
                
                if (cond_329284) {
                    defunc_0_f_res_329288 = 0.0;
                } else {
                    int64_t i_329289 = add64(x_329207, i_329281);
                    double defunc_0_add_arg_329290;
                    
                    defunc_0_add_arg_329290 =
                        ((double *) mem_param_313179.mem)[ctx_param_ext_313174 +
                                                          (gtid_305359 *
                                                           ctx_param_ext_313175 +
                                                           i_329289 *
                                                           ctx_param_ext_313177)];
                    defunc_0_f_res_329288 = defunc_0_add_arg_329290;
                }
                
                int64_t binop_p_329291 = sub64(defunc_0_f_res_329285,
                                               defunc_0_g_res_329211);
                double defunc_0_f_res_329292 = sitofp_i64_f64(binop_p_329291);
                double abs_res_329293 = fabs(defunc_0_f_res_329292);
                double tmp1_329294 = abs_res_329293 / x_329208;
                double x_329295 = tmp1_329294 * tmp1_329294;
                double y_329296 = tmp1_329294 * x_329295;
                double tmp2_329297 = 1.0 - y_329296;
                double x_329298 = tmp2_329297 * tmp2_329297;
                double tmp3_329299 = tmp2_329297 * x_329298;
                double tmp4_329300 = defunc_0_f_res_329288 * tmp3_329299;
                double defunc_1_f_res_329301 = defunc_0_f_res_329292 *
                       tmp4_329300;
                double defunc_1_f_res_329302 = defunc_0_f_res_329292 *
                       defunc_1_f_res_329301;
                double defunc_0_f_res_329303;
                
                if (cond_329284) {
                    defunc_0_f_res_329303 = 0.0;
                } else {
                    int64_t i_329304 = add64(x_329207, i_329281);
                    double defunc_0_add_arg_329305;
                    
                    defunc_0_add_arg_329305 =
                        ((double *) mem_315021.mem)[gtid_305359 * n_292675 +
                                                    i_329304];
                    defunc_0_f_res_329303 = defunc_0_add_arg_329305;
                }
                
                double x_329306 = a12_329274 * tmp4_329300;
                double y_329307 = b12_329275 * defunc_1_f_res_329301;
                double x_329308 = x_329306 + y_329307;
                double y_329309 = c12_329276 * defunc_1_f_res_329302;
                double x_329310 = x_329308 + y_329309;
                double defunc_9_fit_fun_res_329311 = defunc_0_f_res_329303 *
                       x_329310;
                double x_329312 = b12_329275 * tmp4_329300;
                double y_329313 = b2_329277 * defunc_1_f_res_329301;
                double x_329314 = x_329312 + y_329313;
                double y_329315 = c2_329278 * defunc_1_f_res_329302;
                double x_329316 = x_329314 + y_329315;
                double defunc_9_slope_fun_res_329317 = defunc_0_f_res_329303 *
                       x_329316;
                double defunc_1_op_res_329318 = defunc_9_fit_fun_res_329311 +
                       redout_329282;
                double defunc_1_op_res_329319 = defunc_9_slope_fun_res_329317 +
                       redout_329283;
                double redout_tmp_329331 = defunc_1_op_res_329318;
                double redout_tmp_329332 = defunc_1_op_res_329319;
                
                redout_329282 = redout_tmp_329331;
                redout_329283 = redout_tmp_329332;
            }
            defunc_2_reduce_res_329279 = redout_329282;
            defunc_2_reduce_res_329280 = redout_329283;
            ((double *) mem_315100)[i_329204] = defunc_2_reduce_res_329279;
            ((double *) mem_315103)[i_329204] = defunc_2_reduce_res_329280;
        }
        if (l_n_m_292832 * (int64_t) 8 > 0)
            memmove(mem_315131.mem + gtid_305359 * l_n_m_292832 * (int64_t) 8,
                    mem_315100 + (int64_t) 0, l_n_m_292832 * (int64_t) 8);
        if (l_n_m_292832 * (int64_t) 8 > 0)
            memmove(mem_315135.mem + gtid_305359 * l_n_m_292832 * (int64_t) 8,
                    mem_315103 + (int64_t) 0, l_n_m_292832 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_315100);
    free(mem_315103);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338499_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338499_end -
                 futhark_mc_segmap_parloop_338499_start;
        
        ctx->futhark_mc_segmap_parloop_338499_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338499_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338499_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_338497(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_305358 = tid;
    int num_tasks_329202 = info.nsubtasks;
    struct futhark_mc_task_338496 *futhark_mc_task_338496 =
                                  (struct futhark_mc_task_338496 *) args;
    struct futhark_context *ctx = futhark_mc_task_338496->ctx;
    uint64_t futhark_mc_segmap_task_338497_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_338497_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338496->free_n_292675;
    int64_t q_l_292680 = futhark_mc_task_338496->free_q_l_292680;
    int64_t jump_t_292685 = futhark_mc_task_338496->free_jump_t_292685;
    int64_t partition_sizze_292766 =
            futhark_mc_task_338496->free_partition_sizze_292766;
    int64_t l_n_m_292832 = futhark_mc_task_338496->free_l_n_m_292832;
    int64_t i_292846 = futhark_mc_task_338496->free_i_292846;
    int64_t bytes_313028 = futhark_mc_task_338496->free_bytes_313028;
    struct memblock mem_313081 = {.desc ="mem_313081", .mem =
                                  futhark_mc_task_338496->free_mem_313081,
                                  .size =0, .references =NULL};
    struct memblock mem_313085 = {.desc ="mem_313085", .mem =
                                  futhark_mc_task_338496->free_mem_313085,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_task_338496->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_task_338496->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_task_338496->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_task_338496->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315021 = {.desc ="mem_315021", .mem =
                                  futhark_mc_task_338496->free_mem_315021,
                                  .size =0, .references =NULL};
    struct memblock mem_315131 = {.desc ="mem_315131", .mem =
                                  futhark_mc_task_338496->free_mem_315131,
                                  .size =0, .references =NULL};
    struct memblock mem_315135 = {.desc ="mem_315135", .mem =
                                  futhark_mc_task_338496->free_mem_315135,
                                  .size =0, .references =NULL};
    int64_t iter_329203;
    struct futhark_mc_segmap_parloop_struct_338498
    futhark_mc_segmap_parloop_struct_338498;
    
    futhark_mc_segmap_parloop_struct_338498.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338498.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_338498.free_q_l_292680 = q_l_292680;
    futhark_mc_segmap_parloop_struct_338498.free_jump_t_292685 = jump_t_292685;
    futhark_mc_segmap_parloop_struct_338498.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_338498.free_l_n_m_292832 = l_n_m_292832;
    futhark_mc_segmap_parloop_struct_338498.free_i_292846 = i_292846;
    futhark_mc_segmap_parloop_struct_338498.free_bytes_313028 = bytes_313028;
    futhark_mc_segmap_parloop_struct_338498.free_mem_313081 = mem_313081.mem;
    futhark_mc_segmap_parloop_struct_338498.free_mem_313085 = mem_313085.mem;
    futhark_mc_segmap_parloop_struct_338498.free_ctx_param_ext_313174 =
        ctx_param_ext_313174;
    futhark_mc_segmap_parloop_struct_338498.free_ctx_param_ext_313175 =
        ctx_param_ext_313175;
    futhark_mc_segmap_parloop_struct_338498.free_ctx_param_ext_313177 =
        ctx_param_ext_313177;
    futhark_mc_segmap_parloop_struct_338498.free_mem_param_313179 =
        mem_param_313179.mem;
    futhark_mc_segmap_parloop_struct_338498.free_mem_315021 = mem_315021.mem;
    futhark_mc_segmap_parloop_struct_338498.free_mem_315131 = mem_315131.mem;
    futhark_mc_segmap_parloop_struct_338498.free_mem_315135 = mem_315135.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338499_task;
    
    futhark_mc_segmap_parloop_338499_task.name =
        "futhark_mc_segmap_parloop_338499";
    futhark_mc_segmap_parloop_338499_task.fn = futhark_mc_segmap_parloop_338499;
    futhark_mc_segmap_parloop_338499_task.args =
        &futhark_mc_segmap_parloop_struct_338498;
    futhark_mc_segmap_parloop_338499_task.iterations = iterations;
    futhark_mc_segmap_parloop_338499_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338499_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338499_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338499_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338499_task);
    
    if (futhark_mc_segmap_parloop_338499_err != 0) {
        err = futhark_mc_segmap_parloop_338499_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338499_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338499_total_end -
                 futhark_mc_segmap_parloop_338499_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338499_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338499_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338499_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_338497_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_338497_end -
                 futhark_mc_segmap_task_338497_start;
        
        ctx->futhark_mc_segmap_task_338497_runs[tid]++;
        ctx->futhark_mc_segmap_task_338497_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_338497_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_segmap_parloop_struct_338503 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_l_292680;
    int64_t free_jump_t_292685;
    int64_t free_partition_sizze_292766;
    int64_t free_l_n_m_292832;
    int64_t free_i_292846;
    int64_t free_bytes_313028;
    unsigned char *free_mem_313081;
    unsigned char *free_mem_313085;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315021;
    unsigned char *free_mem_315131;
    unsigned char *free_mem_315135;
};
struct futhark_mc_task_338507 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_l_292680;
    int64_t free_jump_t_292685;
    int64_t free_l_n_m_292832;
    int64_t free_i_292846;
    int64_t free_gtid_305498;
    unsigned char *free_mem_313081;
    unsigned char *free_mem_313085;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315021;
    unsigned char *free_mem_315094;
    unsigned char *free_mem_315097;
};
struct futhark_mc_segmap_parloop_struct_338509 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_l_292680;
    int64_t free_jump_t_292685;
    int64_t free_l_n_m_292832;
    int64_t free_i_292846;
    int64_t free_gtid_305498;
    unsigned char *free_mem_313081;
    unsigned char *free_mem_313085;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315021;
    unsigned char *free_mem_315094;
    unsigned char *free_mem_315097;
};
static int futhark_mc_segmap_parloop_338510(void *args, int64_t start,
                                            int64_t end, int flat_tid_329458,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338509
    *futhark_mc_segmap_parloop_struct_338509 =
    (struct futhark_mc_segmap_parloop_struct_338509 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338509->ctx;
    uint64_t futhark_mc_segmap_parloop_338510_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338510_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_338509->free_n_292675;
    int64_t q_l_292680 =
            futhark_mc_segmap_parloop_struct_338509->free_q_l_292680;
    int64_t jump_t_292685 =
            futhark_mc_segmap_parloop_struct_338509->free_jump_t_292685;
    int64_t l_n_m_292832 =
            futhark_mc_segmap_parloop_struct_338509->free_l_n_m_292832;
    int64_t i_292846 = futhark_mc_segmap_parloop_struct_338509->free_i_292846;
    int64_t gtid_305498 =
            futhark_mc_segmap_parloop_struct_338509->free_gtid_305498;
    struct memblock mem_313081 = {.desc ="mem_313081", .mem =
                                  futhark_mc_segmap_parloop_struct_338509->free_mem_313081,
                                  .size =0, .references =NULL};
    struct memblock mem_313085 = {.desc ="mem_313085", .mem =
                                  futhark_mc_segmap_parloop_struct_338509->free_mem_313085,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_segmap_parloop_struct_338509->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_segmap_parloop_struct_338509->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_segmap_parloop_struct_338509->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_segmap_parloop_struct_338509->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315021 = {.desc ="mem_315021", .mem =
                                  futhark_mc_segmap_parloop_struct_338509->free_mem_315021,
                                  .size =0, .references =NULL};
    struct memblock mem_315094 = {.desc ="mem_315094", .mem =
                                  futhark_mc_segmap_parloop_struct_338509->free_mem_315094,
                                  .size =0, .references =NULL};
    struct memblock mem_315097 = {.desc ="mem_315097", .mem =
                                  futhark_mc_segmap_parloop_struct_338509->free_mem_315097,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_329576 = start;
    
    for (; iter_329576 < end; iter_329576++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_329648 = l_n_m_292832;
        int64_t gtid_329459 = iter_329576;
        int64_t remnant_329649 = iter_329576 - gtid_329459;
        int64_t x_329460;
        
        x_329460 = ((int64_t *) mem_313081.mem)[gtid_305498 * l_n_m_292832 +
                                                gtid_329459];
        
        double x_329461;
        
        x_329461 = ((double *) mem_313085.mem)[gtid_305498 * l_n_m_292832 +
                                               gtid_329459];
        
        int64_t min_arg_329462 = mul64(jump_t_292685, gtid_329459);
        int64_t min_res_329463 = smin64(i_292846, min_arg_329462);
        int64_t defunc_0_g_res_329464 = add64((int64_t) 1, min_res_329463);
        double defunc_2_reduce_res_329465;
        double defunc_2_reduce_res_329466;
        double defunc_2_reduce_res_329467;
        double defunc_2_reduce_res_329468;
        double defunc_2_reduce_res_329469;
        double redout_329578;
        double redout_329579;
        double redout_329580;
        double redout_329581;
        double redout_329582;
        
        redout_329578 = 0.0;
        redout_329579 = 0.0;
        redout_329580 = 0.0;
        redout_329581 = 0.0;
        redout_329582 = 0.0;
        for (int64_t i_329577 = 0; i_329577 < q_l_292680; i_329577++) {
            bool cond_329583 = sle64(n_292675, i_329577);
            int64_t defunc_0_f_res_329584;
            
            if (cond_329583) {
                defunc_0_f_res_329584 = (int64_t) 0;
            } else {
                int64_t i_329585 = add64(x_329460, i_329577);
                int64_t defunc_1_add_res_329586 = add64((int64_t) 1, i_329585);
                
                defunc_0_f_res_329584 = defunc_1_add_res_329586;
            }
            
            double defunc_0_f_res_329587;
            
            if (cond_329583) {
                defunc_0_f_res_329587 = 0.0;
            } else {
                int64_t i_329588 = add64(x_329460, i_329577);
                double defunc_0_add_arg_329589;
                
                defunc_0_add_arg_329589 =
                    ((double *) mem_param_313179.mem)[ctx_param_ext_313174 +
                                                      (gtid_305498 *
                                                       ctx_param_ext_313175 +
                                                       i_329588 *
                                                       ctx_param_ext_313177)];
                defunc_0_f_res_329587 = defunc_0_add_arg_329589;
            }
            
            int64_t binop_p_329590 = sub64(defunc_0_f_res_329584,
                                           defunc_0_g_res_329464);
            double defunc_0_f_res_329591 = sitofp_i64_f64(binop_p_329590);
            double abs_res_329592 = fabs(defunc_0_f_res_329591);
            double tmp1_329593 = abs_res_329592 / x_329461;
            double x_329594 = tmp1_329593 * tmp1_329593;
            double y_329595 = tmp1_329593 * x_329594;
            double tmp2_329596 = 1.0 - y_329595;
            double x_329597 = tmp2_329596 * tmp2_329596;
            double tmp3_329598 = tmp2_329596 * x_329597;
            double w_j_329599 = defunc_0_f_res_329587 * tmp3_329598;
            double xw_j_329600 = defunc_0_f_res_329591 * w_j_329599;
            double x2w_j_329601 = defunc_0_f_res_329591 * xw_j_329600;
            double x3w_j_329602 = defunc_0_f_res_329591 * x2w_j_329601;
            double x4w_j_329603 = defunc_0_f_res_329591 * x3w_j_329602;
            double defunc_1_op_res_329604 = w_j_329599 + redout_329578;
            double defunc_1_op_res_329605 = xw_j_329600 + redout_329579;
            double defunc_1_op_res_329606 = x2w_j_329601 + redout_329580;
            double defunc_1_op_res_329607 = x3w_j_329602 + redout_329581;
            double defunc_1_op_res_329608 = x4w_j_329603 + redout_329582;
            double redout_tmp_329650 = defunc_1_op_res_329604;
            double redout_tmp_329651 = defunc_1_op_res_329605;
            double redout_tmp_329652 = defunc_1_op_res_329606;
            double redout_tmp_329653 = defunc_1_op_res_329607;
            double redout_tmp_329654 = defunc_1_op_res_329608;
            
            redout_329578 = redout_tmp_329650;
            redout_329579 = redout_tmp_329651;
            redout_329580 = redout_tmp_329652;
            redout_329581 = redout_tmp_329653;
            redout_329582 = redout_tmp_329654;
        }
        defunc_2_reduce_res_329465 = redout_329578;
        defunc_2_reduce_res_329466 = redout_329579;
        defunc_2_reduce_res_329467 = redout_329580;
        defunc_2_reduce_res_329468 = redout_329581;
        defunc_2_reduce_res_329469 = redout_329582;
        
        double a_329502 = 2.220446049250313e-16 + defunc_2_reduce_res_329465;
        double b_329503 = 2.220446049250313e-16 + defunc_2_reduce_res_329466;
        double c_329504 = 2.220446049250313e-16 + defunc_2_reduce_res_329467;
        double d_329505 = 2.220446049250313e-16 + defunc_2_reduce_res_329468;
        double e_329506 = 2.220446049250313e-16 + defunc_2_reduce_res_329469;
        double x_329507 = c_329504 * e_329506;
        double y_329508 = d_329505 * d_329505;
        double a12_329509 = x_329507 - y_329508;
        double x_329510 = c_329504 * d_329505;
        double y_329511 = b_329503 * e_329506;
        double b12_329512 = x_329510 - y_329511;
        double x_329513 = b_329503 * d_329505;
        double y_329514 = c_329504 * c_329504;
        double c12_329515 = x_329513 - y_329514;
        double x_329516 = a_329502 * e_329506;
        double b2_329517 = x_329516 - y_329514;
        double x_329518 = b_329503 * c_329504;
        double y_329519 = a_329502 * d_329505;
        double c2_329520 = x_329518 - y_329519;
        double x_329521 = a_329502 * a12_329509;
        double y_329522 = b_329503 * b12_329512;
        double x_329523 = x_329521 + y_329522;
        double y_329524 = c_329504 * c12_329515;
        double y_329525 = x_329523 + y_329524;
        double det_329526 = 1.0 / y_329525;
        double a12_329527 = a12_329509 * det_329526;
        double b12_329528 = b12_329512 * det_329526;
        double c12_329529 = c12_329515 * det_329526;
        double b2_329530 = b2_329517 * det_329526;
        double c2_329531 = c2_329520 * det_329526;
        double defunc_2_reduce_res_329532;
        double defunc_2_reduce_res_329533;
        double redout_329610;
        double redout_329611;
        
        redout_329610 = 0.0;
        redout_329611 = 0.0;
        for (int64_t i_329609 = 0; i_329609 < q_l_292680; i_329609++) {
            bool cond_329612 = sle64(n_292675, i_329609);
            int64_t defunc_0_f_res_329613;
            
            if (cond_329612) {
                defunc_0_f_res_329613 = (int64_t) 0;
            } else {
                int64_t i_329614 = add64(x_329460, i_329609);
                int64_t defunc_1_add_res_329615 = add64((int64_t) 1, i_329614);
                
                defunc_0_f_res_329613 = defunc_1_add_res_329615;
            }
            
            double defunc_0_f_res_329616;
            
            if (cond_329612) {
                defunc_0_f_res_329616 = 0.0;
            } else {
                int64_t i_329617 = add64(x_329460, i_329609);
                double defunc_0_add_arg_329618;
                
                defunc_0_add_arg_329618 =
                    ((double *) mem_param_313179.mem)[ctx_param_ext_313174 +
                                                      (gtid_305498 *
                                                       ctx_param_ext_313175 +
                                                       i_329617 *
                                                       ctx_param_ext_313177)];
                defunc_0_f_res_329616 = defunc_0_add_arg_329618;
            }
            
            int64_t binop_p_329619 = sub64(defunc_0_f_res_329613,
                                           defunc_0_g_res_329464);
            double defunc_0_f_res_329620 = sitofp_i64_f64(binop_p_329619);
            double abs_res_329621 = fabs(defunc_0_f_res_329620);
            double tmp1_329622 = abs_res_329621 / x_329461;
            double x_329623 = tmp1_329622 * tmp1_329622;
            double y_329624 = tmp1_329622 * x_329623;
            double tmp2_329625 = 1.0 - y_329624;
            double x_329626 = tmp2_329625 * tmp2_329625;
            double tmp3_329627 = tmp2_329625 * x_329626;
            double tmp4_329628 = defunc_0_f_res_329616 * tmp3_329627;
            double defunc_1_f_res_329629 = defunc_0_f_res_329620 * tmp4_329628;
            double defunc_1_f_res_329630 = defunc_0_f_res_329620 *
                   defunc_1_f_res_329629;
            double defunc_0_f_res_329631;
            
            if (cond_329612) {
                defunc_0_f_res_329631 = 0.0;
            } else {
                int64_t i_329632 = add64(x_329460, i_329609);
                double defunc_0_add_arg_329633;
                
                defunc_0_add_arg_329633 =
                    ((double *) mem_315021.mem)[gtid_305498 * n_292675 +
                                                i_329632];
                defunc_0_f_res_329631 = defunc_0_add_arg_329633;
            }
            
            double x_329634 = a12_329527 * tmp4_329628;
            double y_329635 = b12_329528 * defunc_1_f_res_329629;
            double x_329636 = x_329634 + y_329635;
            double y_329637 = c12_329529 * defunc_1_f_res_329630;
            double x_329638 = x_329636 + y_329637;
            double defunc_9_fit_fun_res_329639 = defunc_0_f_res_329631 *
                   x_329638;
            double x_329640 = b12_329528 * tmp4_329628;
            double y_329641 = b2_329530 * defunc_1_f_res_329629;
            double x_329642 = x_329640 + y_329641;
            double y_329643 = c2_329531 * defunc_1_f_res_329630;
            double x_329644 = x_329642 + y_329643;
            double defunc_9_slope_fun_res_329645 = defunc_0_f_res_329631 *
                   x_329644;
            double defunc_1_op_res_329646 = defunc_9_fit_fun_res_329639 +
                   redout_329610;
            double defunc_1_op_res_329647 = defunc_9_slope_fun_res_329645 +
                   redout_329611;
            double redout_tmp_329655 = defunc_1_op_res_329646;
            double redout_tmp_329656 = defunc_1_op_res_329647;
            
            redout_329610 = redout_tmp_329655;
            redout_329611 = redout_tmp_329656;
        }
        defunc_2_reduce_res_329532 = redout_329610;
        defunc_2_reduce_res_329533 = redout_329611;
        ((double *) mem_315094.mem)[gtid_329459] = defunc_2_reduce_res_329532;
        ((double *) mem_315097.mem)[gtid_329459] = defunc_2_reduce_res_329533;
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338510_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338510_end -
                 futhark_mc_segmap_parloop_338510_start;
        
        ctx->futhark_mc_segmap_parloop_338510_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338510_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338510_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_338508(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_329458 = tid;
    int num_tasks_329575 = info.nsubtasks;
    struct futhark_mc_task_338507 *futhark_mc_task_338507 =
                                  (struct futhark_mc_task_338507 *) args;
    struct futhark_context *ctx = futhark_mc_task_338507->ctx;
    uint64_t futhark_mc_segmap_task_338508_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_338508_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338507->free_n_292675;
    int64_t q_l_292680 = futhark_mc_task_338507->free_q_l_292680;
    int64_t jump_t_292685 = futhark_mc_task_338507->free_jump_t_292685;
    int64_t l_n_m_292832 = futhark_mc_task_338507->free_l_n_m_292832;
    int64_t i_292846 = futhark_mc_task_338507->free_i_292846;
    int64_t gtid_305498 = futhark_mc_task_338507->free_gtid_305498;
    struct memblock mem_313081 = {.desc ="mem_313081", .mem =
                                  futhark_mc_task_338507->free_mem_313081,
                                  .size =0, .references =NULL};
    struct memblock mem_313085 = {.desc ="mem_313085", .mem =
                                  futhark_mc_task_338507->free_mem_313085,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_task_338507->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_task_338507->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_task_338507->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_task_338507->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315021 = {.desc ="mem_315021", .mem =
                                  futhark_mc_task_338507->free_mem_315021,
                                  .size =0, .references =NULL};
    struct memblock mem_315094 = {.desc ="mem_315094", .mem =
                                  futhark_mc_task_338507->free_mem_315094,
                                  .size =0, .references =NULL};
    struct memblock mem_315097 = {.desc ="mem_315097", .mem =
                                  futhark_mc_task_338507->free_mem_315097,
                                  .size =0, .references =NULL};
    int64_t iter_329576;
    struct futhark_mc_segmap_parloop_struct_338509
    futhark_mc_segmap_parloop_struct_338509;
    
    futhark_mc_segmap_parloop_struct_338509.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338509.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_338509.free_q_l_292680 = q_l_292680;
    futhark_mc_segmap_parloop_struct_338509.free_jump_t_292685 = jump_t_292685;
    futhark_mc_segmap_parloop_struct_338509.free_l_n_m_292832 = l_n_m_292832;
    futhark_mc_segmap_parloop_struct_338509.free_i_292846 = i_292846;
    futhark_mc_segmap_parloop_struct_338509.free_gtid_305498 = gtid_305498;
    futhark_mc_segmap_parloop_struct_338509.free_mem_313081 = mem_313081.mem;
    futhark_mc_segmap_parloop_struct_338509.free_mem_313085 = mem_313085.mem;
    futhark_mc_segmap_parloop_struct_338509.free_ctx_param_ext_313174 =
        ctx_param_ext_313174;
    futhark_mc_segmap_parloop_struct_338509.free_ctx_param_ext_313175 =
        ctx_param_ext_313175;
    futhark_mc_segmap_parloop_struct_338509.free_ctx_param_ext_313177 =
        ctx_param_ext_313177;
    futhark_mc_segmap_parloop_struct_338509.free_mem_param_313179 =
        mem_param_313179.mem;
    futhark_mc_segmap_parloop_struct_338509.free_mem_315021 = mem_315021.mem;
    futhark_mc_segmap_parloop_struct_338509.free_mem_315094 = mem_315094.mem;
    futhark_mc_segmap_parloop_struct_338509.free_mem_315097 = mem_315097.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338510_task;
    
    futhark_mc_segmap_parloop_338510_task.name =
        "futhark_mc_segmap_parloop_338510";
    futhark_mc_segmap_parloop_338510_task.fn = futhark_mc_segmap_parloop_338510;
    futhark_mc_segmap_parloop_338510_task.args =
        &futhark_mc_segmap_parloop_struct_338509;
    futhark_mc_segmap_parloop_338510_task.iterations = iterations;
    futhark_mc_segmap_parloop_338510_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338510_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338510_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338510_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338510_task);
    
    if (futhark_mc_segmap_parloop_338510_err != 0) {
        err = futhark_mc_segmap_parloop_338510_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338510_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338510_total_end -
                 futhark_mc_segmap_parloop_338510_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338510_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338510_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338510_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_338508_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_338508_end -
                 futhark_mc_segmap_task_338508_start;
        
        ctx->futhark_mc_segmap_task_338508_runs[tid]++;
        ctx->futhark_mc_segmap_task_338508_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_338508_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_segmap_parloop_struct_338512 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_l_292680;
    int64_t free_jump_t_292685;
    int64_t free_l_n_m_292832;
    int64_t free_i_292846;
    int64_t free_gtid_305498;
    unsigned char *free_mem_313081;
    unsigned char *free_mem_313085;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315021;
    unsigned char *free_mem_315094;
    unsigned char *free_mem_315097;
};
struct futhark_mc_task_338514 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_305498;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    int64_t free_x_329336;
    double free_x_329337;
    int64_t free_defunc_0_g_res_329340;
    double *retval_defunc_2_reduce_res_329341;
    double *retval_defunc_2_reduce_res_329342;
    double *retval_defunc_2_reduce_res_329343;
    double *retval_defunc_2_reduce_res_329344;
    double *retval_defunc_2_reduce_res_329345;
};
struct futhark_mc_segred_stage_1_parloop_struct_338521 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_305498;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    int64_t free_x_329336;
    double free_x_329337;
    int64_t free_defunc_0_g_res_329340;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_329741;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_329743;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_329745;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_329747;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_329749;
};
static int futhark_mc_segred_stage_1_parloop_338522(void *args, int64_t start,
                                                    int64_t end,
                                                    int flat_tid_329658,
                                                    int tid)
{
    int err = 0;
    struct futhark_mc_segred_stage_1_parloop_struct_338521
    *futhark_mc_segred_stage_1_parloop_struct_338521 =
    (struct futhark_mc_segred_stage_1_parloop_struct_338521 *) args;
    struct futhark_context *ctx =
                           futhark_mc_segred_stage_1_parloop_struct_338521->ctx;
    uint64_t futhark_mc_segred_stage_1_parloop_338522_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_338522_start = get_wall_time();
    
    int64_t n_292675 =
            futhark_mc_segred_stage_1_parloop_struct_338521->free_n_292675;
    int64_t gtid_305498 =
            futhark_mc_segred_stage_1_parloop_struct_338521->free_gtid_305498;
    int64_t ctx_param_ext_313174 =
            futhark_mc_segred_stage_1_parloop_struct_338521->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_segred_stage_1_parloop_struct_338521->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_segred_stage_1_parloop_struct_338521->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_segred_stage_1_parloop_struct_338521->free_mem_param_313179,
                                        .size =0, .references =NULL};
    int64_t x_329336 =
            futhark_mc_segred_stage_1_parloop_struct_338521->free_x_329336;
    double x_329337 =
           futhark_mc_segred_stage_1_parloop_struct_338521->free_x_329337;
    int64_t defunc_0_g_res_329340 =
            futhark_mc_segred_stage_1_parloop_struct_338521->free_defunc_0_g_res_329340;
    struct memblock reduce_stage_1_tid_res_arr_mem_329741 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_329741",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338521->free_reduce_stage_1_tid_res_arr_mem_329741,
                                                             .size =0,
                                                             .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_329743 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_329743",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338521->free_reduce_stage_1_tid_res_arr_mem_329743,
                                                             .size =0,
                                                             .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_329745 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_329745",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338521->free_reduce_stage_1_tid_res_arr_mem_329745,
                                                             .size =0,
                                                             .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_329747 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_329747",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338521->free_reduce_stage_1_tid_res_arr_mem_329747,
                                                             .size =0,
                                                             .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_329749 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_329749",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338521->free_reduce_stage_1_tid_res_arr_mem_329749,
                                                             .size =0,
                                                             .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_329751 = start;
    double x_329660;
    double x_329661;
    double x_329663;
    double x_329664;
    double x_329666;
    double x_329667;
    double x_329669;
    double x_329670;
    double x_329672;
    double x_329673;
    double local_acc_329752 = 0.0;
    double local_acc_329753 = 0.0;
    double local_acc_329754 = 0.0;
    double local_acc_329755 = 0.0;
    double local_acc_329756 = 0.0;
    
    for (; iter_329751 < end; iter_329751++) {
        int64_t gtid_329659 = iter_329751;
        bool cond_329675 = sle64(n_292675, gtid_329659);
        int64_t defunc_0_f_res_329676;
        
        if (cond_329675) {
            defunc_0_f_res_329676 = (int64_t) 0;
        } else {
            int64_t i_329677 = add64(x_329336, gtid_329659);
            int64_t defunc_1_add_res_329678 = add64((int64_t) 1, i_329677);
            
            defunc_0_f_res_329676 = defunc_1_add_res_329678;
        }
        
        double defunc_0_f_res_329679;
        
        if (cond_329675) {
            defunc_0_f_res_329679 = 0.0;
        } else {
            int64_t i_329680 = add64(x_329336, gtid_329659);
            double defunc_0_add_arg_329681;
            
            defunc_0_add_arg_329681 =
                ((double *) mem_param_313179.mem)[ctx_param_ext_313174 +
                                                  (gtid_305498 *
                                                   ctx_param_ext_313175 +
                                                   i_329680 *
                                                   ctx_param_ext_313177)];
            defunc_0_f_res_329679 = defunc_0_add_arg_329681;
        }
        
        int64_t binop_p_329682 = sub64(defunc_0_f_res_329676,
                                       defunc_0_g_res_329340);
        double defunc_0_f_res_329683 = sitofp_i64_f64(binop_p_329682);
        double abs_res_329684 = fabs(defunc_0_f_res_329683);
        double tmp1_329685 = abs_res_329684 / x_329337;
        double x_329686 = tmp1_329685 * tmp1_329685;
        double y_329687 = tmp1_329685 * x_329686;
        double tmp2_329688 = 1.0 - y_329687;
        double x_329689 = tmp2_329688 * tmp2_329688;
        double tmp3_329690 = tmp2_329688 * x_329689;
        double w_j_329691 = defunc_0_f_res_329679 * tmp3_329690;
        double xw_j_329692 = defunc_0_f_res_329683 * w_j_329691;
        double x2w_j_329693 = defunc_0_f_res_329683 * xw_j_329692;
        double x3w_j_329694 = defunc_0_f_res_329683 * x2w_j_329693;
        double x4w_j_329695 = defunc_0_f_res_329683 * x3w_j_329694;
        
        // save map-out results
        { }
        // Load accum params
        {
            x_329660 = local_acc_329752;
        }
        // Load next params
        {
            x_329661 = w_j_329691;
        }
        // Red body
        {
            double defunc_1_op_res_329662 = x_329660 + x_329661;
            
            local_acc_329752 = defunc_1_op_res_329662;
        }
        // Load accum params
        {
            x_329663 = local_acc_329753;
        }
        // Load next params
        {
            x_329664 = xw_j_329692;
        }
        // Red body
        {
            double defunc_1_op_res_329665 = x_329663 + x_329664;
            
            local_acc_329753 = defunc_1_op_res_329665;
        }
        // Load accum params
        {
            x_329666 = local_acc_329754;
        }
        // Load next params
        {
            x_329667 = x2w_j_329693;
        }
        // Red body
        {
            double defunc_1_op_res_329668 = x_329666 + x_329667;
            
            local_acc_329754 = defunc_1_op_res_329668;
        }
        // Load accum params
        {
            x_329669 = local_acc_329755;
        }
        // Load next params
        {
            x_329670 = x3w_j_329694;
        }
        // Red body
        {
            double defunc_1_op_res_329671 = x_329669 + x_329670;
            
            local_acc_329755 = defunc_1_op_res_329671;
        }
        // Load accum params
        {
            x_329672 = local_acc_329756;
        }
        // Load next params
        {
            x_329673 = x4w_j_329695;
        }
        // Red body
        {
            double defunc_1_op_res_329674 = x_329672 + x_329673;
            
            local_acc_329756 = defunc_1_op_res_329674;
        }
    }
    ((double *) reduce_stage_1_tid_res_arr_mem_329741.mem)[flat_tid_329658] =
        local_acc_329752;
    ((double *) reduce_stage_1_tid_res_arr_mem_329743.mem)[flat_tid_329658] =
        local_acc_329753;
    ((double *) reduce_stage_1_tid_res_arr_mem_329745.mem)[flat_tid_329658] =
        local_acc_329754;
    ((double *) reduce_stage_1_tid_res_arr_mem_329747.mem)[flat_tid_329658] =
        local_acc_329755;
    ((double *) reduce_stage_1_tid_res_arr_mem_329749.mem)[flat_tid_329658] =
        local_acc_329756;
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_338522_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_338522_end -
                 futhark_mc_segred_stage_1_parloop_338522_start;
        
        ctx->futhark_mc_segred_stage_1_parloop_338522_runs[tid]++;
        ctx->futhark_mc_segred_stage_1_parloop_338522_total_runtime[tid] +=
            elapsed;
        ctx->futhark_mc_segred_stage_1_parloop_338522_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segred_task_338515(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_329658 = tid;
    int num_tasks_329740 = info.nsubtasks;
    struct futhark_mc_task_338514 *futhark_mc_task_338514 =
                                  (struct futhark_mc_task_338514 *) args;
    struct futhark_context *ctx = futhark_mc_task_338514->ctx;
    uint64_t futhark_mc_segred_task_338515_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_task_338515_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338514->free_n_292675;
    int64_t gtid_305498 = futhark_mc_task_338514->free_gtid_305498;
    int64_t ctx_param_ext_313174 =
            futhark_mc_task_338514->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_task_338514->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_task_338514->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_task_338514->free_mem_param_313179,
                                        .size =0, .references =NULL};
    int64_t x_329336 = futhark_mc_task_338514->free_x_329336;
    double x_329337 = futhark_mc_task_338514->free_x_329337;
    int64_t defunc_0_g_res_329340 =
            futhark_mc_task_338514->free_defunc_0_g_res_329340;
    double defunc_2_reduce_res_329341 =
           *futhark_mc_task_338514->retval_defunc_2_reduce_res_329341;
    double defunc_2_reduce_res_329342 =
           *futhark_mc_task_338514->retval_defunc_2_reduce_res_329342;
    double defunc_2_reduce_res_329343 =
           *futhark_mc_task_338514->retval_defunc_2_reduce_res_329343;
    double defunc_2_reduce_res_329344 =
           *futhark_mc_task_338514->retval_defunc_2_reduce_res_329344;
    double defunc_2_reduce_res_329345 =
           *futhark_mc_task_338514->retval_defunc_2_reduce_res_329345;
    size_t reduce_stage_1_tid_res_arr_mem_329741_cached_sizze_338516 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_329741 = NULL;
    size_t reduce_stage_1_tid_res_arr_mem_329743_cached_sizze_338517 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_329743 = NULL;
    size_t reduce_stage_1_tid_res_arr_mem_329745_cached_sizze_338518 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_329745 = NULL;
    size_t reduce_stage_1_tid_res_arr_mem_329747_cached_sizze_338519 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_329747 = NULL;
    size_t reduce_stage_1_tid_res_arr_mem_329749_cached_sizze_338520 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_329749 = NULL;
    
    if (reduce_stage_1_tid_res_arr_mem_329741_cached_sizze_338516 <
        (size_t) ((int64_t) 8 * num_tasks_329740)) {
        reduce_stage_1_tid_res_arr_mem_329741 =
            realloc(reduce_stage_1_tid_res_arr_mem_329741, (int64_t) 8 *
                    num_tasks_329740);
        reduce_stage_1_tid_res_arr_mem_329741_cached_sizze_338516 =
            (int64_t) 8 * num_tasks_329740;
    }
    if (reduce_stage_1_tid_res_arr_mem_329743_cached_sizze_338517 <
        (size_t) ((int64_t) 8 * num_tasks_329740)) {
        reduce_stage_1_tid_res_arr_mem_329743 =
            realloc(reduce_stage_1_tid_res_arr_mem_329743, (int64_t) 8 *
                    num_tasks_329740);
        reduce_stage_1_tid_res_arr_mem_329743_cached_sizze_338517 =
            (int64_t) 8 * num_tasks_329740;
    }
    if (reduce_stage_1_tid_res_arr_mem_329745_cached_sizze_338518 <
        (size_t) ((int64_t) 8 * num_tasks_329740)) {
        reduce_stage_1_tid_res_arr_mem_329745 =
            realloc(reduce_stage_1_tid_res_arr_mem_329745, (int64_t) 8 *
                    num_tasks_329740);
        reduce_stage_1_tid_res_arr_mem_329745_cached_sizze_338518 =
            (int64_t) 8 * num_tasks_329740;
    }
    if (reduce_stage_1_tid_res_arr_mem_329747_cached_sizze_338519 <
        (size_t) ((int64_t) 8 * num_tasks_329740)) {
        reduce_stage_1_tid_res_arr_mem_329747 =
            realloc(reduce_stage_1_tid_res_arr_mem_329747, (int64_t) 8 *
                    num_tasks_329740);
        reduce_stage_1_tid_res_arr_mem_329747_cached_sizze_338519 =
            (int64_t) 8 * num_tasks_329740;
    }
    if (reduce_stage_1_tid_res_arr_mem_329749_cached_sizze_338520 <
        (size_t) ((int64_t) 8 * num_tasks_329740)) {
        reduce_stage_1_tid_res_arr_mem_329749 =
            realloc(reduce_stage_1_tid_res_arr_mem_329749, (int64_t) 8 *
                    num_tasks_329740);
        reduce_stage_1_tid_res_arr_mem_329749_cached_sizze_338520 =
            (int64_t) 8 * num_tasks_329740;
    }
    
    int64_t iter_329751;
    struct futhark_mc_segred_stage_1_parloop_struct_338521
    futhark_mc_segred_stage_1_parloop_struct_338521;
    
    futhark_mc_segred_stage_1_parloop_struct_338521.ctx = ctx;
    futhark_mc_segred_stage_1_parloop_struct_338521.free_n_292675 = n_292675;
    futhark_mc_segred_stage_1_parloop_struct_338521.free_gtid_305498 =
        gtid_305498;
    futhark_mc_segred_stage_1_parloop_struct_338521.free_ctx_param_ext_313174 =
        ctx_param_ext_313174;
    futhark_mc_segred_stage_1_parloop_struct_338521.free_ctx_param_ext_313175 =
        ctx_param_ext_313175;
    futhark_mc_segred_stage_1_parloop_struct_338521.free_ctx_param_ext_313177 =
        ctx_param_ext_313177;
    futhark_mc_segred_stage_1_parloop_struct_338521.free_mem_param_313179 =
        mem_param_313179.mem;
    futhark_mc_segred_stage_1_parloop_struct_338521.free_x_329336 = x_329336;
    futhark_mc_segred_stage_1_parloop_struct_338521.free_x_329337 = x_329337;
    futhark_mc_segred_stage_1_parloop_struct_338521.free_defunc_0_g_res_329340 =
        defunc_0_g_res_329340;
    futhark_mc_segred_stage_1_parloop_struct_338521.free_reduce_stage_1_tid_res_arr_mem_329741 =
        reduce_stage_1_tid_res_arr_mem_329741;
    futhark_mc_segred_stage_1_parloop_struct_338521.free_reduce_stage_1_tid_res_arr_mem_329743 =
        reduce_stage_1_tid_res_arr_mem_329743;
    futhark_mc_segred_stage_1_parloop_struct_338521.free_reduce_stage_1_tid_res_arr_mem_329745 =
        reduce_stage_1_tid_res_arr_mem_329745;
    futhark_mc_segred_stage_1_parloop_struct_338521.free_reduce_stage_1_tid_res_arr_mem_329747 =
        reduce_stage_1_tid_res_arr_mem_329747;
    futhark_mc_segred_stage_1_parloop_struct_338521.free_reduce_stage_1_tid_res_arr_mem_329749 =
        reduce_stage_1_tid_res_arr_mem_329749;
    
    struct scheduler_parloop futhark_mc_segred_stage_1_parloop_338522_task;
    
    futhark_mc_segred_stage_1_parloop_338522_task.name =
        "futhark_mc_segred_stage_1_parloop_338522";
    futhark_mc_segred_stage_1_parloop_338522_task.fn =
        futhark_mc_segred_stage_1_parloop_338522;
    futhark_mc_segred_stage_1_parloop_338522_task.args =
        &futhark_mc_segred_stage_1_parloop_struct_338521;
    futhark_mc_segred_stage_1_parloop_338522_task.iterations = iterations;
    futhark_mc_segred_stage_1_parloop_338522_task.info = info;
    
    uint64_t futhark_mc_segred_stage_1_parloop_338522_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_338522_total_start = get_wall_time();
    
    int futhark_mc_segred_stage_1_parloop_338522_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segred_stage_1_parloop_338522_task);
    
    if (futhark_mc_segred_stage_1_parloop_338522_err != 0) {
        err = futhark_mc_segred_stage_1_parloop_338522_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_338522_total_end =
                 get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_338522_total_end -
                 futhark_mc_segred_stage_1_parloop_338522_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338522_total_runs,
                           1, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338522_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338522_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    // neutral-initialise the output
    {
        defunc_2_reduce_res_329341 = 0.0;
        defunc_2_reduce_res_329342 = 0.0;
        defunc_2_reduce_res_329343 = 0.0;
        defunc_2_reduce_res_329344 = 0.0;
        defunc_2_reduce_res_329345 = 0.0;
    }
    
    double x_329757;
    double x_329758;
    double x_329760;
    double x_329761;
    double x_329763;
    double x_329764;
    double x_329766;
    double x_329767;
    double x_329769;
    double x_329770;
    
    for (int32_t i_329772 = 0; i_329772 < num_tasks_329740; i_329772++) {
        flat_tid_329658 = i_329772;
        // Apply main thread reduction
        {
            // load acc params
            {
                x_329757 = defunc_2_reduce_res_329341;
            }
            // load next params
            {
                x_329758 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_329741)[flat_tid_329658];
            }
            // red body
            {
                double defunc_1_op_res_329759 = x_329757 + x_329758;
                
                defunc_2_reduce_res_329341 = defunc_1_op_res_329759;
            }
            // load acc params
            {
                x_329760 = defunc_2_reduce_res_329342;
            }
            // load next params
            {
                x_329761 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_329743)[flat_tid_329658];
            }
            // red body
            {
                double defunc_1_op_res_329762 = x_329760 + x_329761;
                
                defunc_2_reduce_res_329342 = defunc_1_op_res_329762;
            }
            // load acc params
            {
                x_329763 = defunc_2_reduce_res_329343;
            }
            // load next params
            {
                x_329764 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_329745)[flat_tid_329658];
            }
            // red body
            {
                double defunc_1_op_res_329765 = x_329763 + x_329764;
                
                defunc_2_reduce_res_329343 = defunc_1_op_res_329765;
            }
            // load acc params
            {
                x_329766 = defunc_2_reduce_res_329344;
            }
            // load next params
            {
                x_329767 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_329747)[flat_tid_329658];
            }
            // red body
            {
                double defunc_1_op_res_329768 = x_329766 + x_329767;
                
                defunc_2_reduce_res_329344 = defunc_1_op_res_329768;
            }
            // load acc params
            {
                x_329769 = defunc_2_reduce_res_329345;
            }
            // load next params
            {
                x_329770 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_329749)[flat_tid_329658];
            }
            // red body
            {
                double defunc_1_op_res_329771 = x_329769 + x_329770;
                
                defunc_2_reduce_res_329345 = defunc_1_op_res_329771;
            }
        }
    }
    
  cleanup:
    {
        free(reduce_stage_1_tid_res_arr_mem_329741);
        free(reduce_stage_1_tid_res_arr_mem_329743);
        free(reduce_stage_1_tid_res_arr_mem_329745);
        free(reduce_stage_1_tid_res_arr_mem_329747);
        free(reduce_stage_1_tid_res_arr_mem_329749);
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_task_338515_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_task_338515_end -
                 futhark_mc_segred_task_338515_start;
        
        ctx->futhark_mc_segred_task_338515_runs[tid]++;
        ctx->futhark_mc_segred_task_338515_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segred_task_338515_iter[tid] += iterations;
    }
    if (err == 0) {
        *futhark_mc_task_338514->retval_defunc_2_reduce_res_329341 =
            defunc_2_reduce_res_329341;
        *futhark_mc_task_338514->retval_defunc_2_reduce_res_329342 =
            defunc_2_reduce_res_329342;
        *futhark_mc_task_338514->retval_defunc_2_reduce_res_329343 =
            defunc_2_reduce_res_329343;
        *futhark_mc_task_338514->retval_defunc_2_reduce_res_329344 =
            defunc_2_reduce_res_329344;
        *futhark_mc_task_338514->retval_defunc_2_reduce_res_329345 =
            defunc_2_reduce_res_329345;
    }
    return err;
}
struct futhark_mc_task_338523 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_305498;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315021;
    int64_t free_x_329336;
    double free_x_329337;
    int64_t free_defunc_0_g_res_329340;
    double free_a12_329409;
    double free_b12_329410;
    double free_c12_329411;
    double free_b2_329412;
    double free_c2_329413;
    double *retval_defunc_2_reduce_res_329414;
    double *retval_defunc_2_reduce_res_329415;
};
struct futhark_mc_segred_stage_1_parloop_struct_338527 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_305498;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315021;
    int64_t free_x_329336;
    double free_x_329337;
    int64_t free_defunc_0_g_res_329340;
    double free_a12_329409;
    double free_b12_329410;
    double free_c12_329411;
    double free_b2_329412;
    double free_c2_329413;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_329774;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_329776;
};
static int futhark_mc_segred_stage_1_parloop_338528(void *args, int64_t start,
                                                    int64_t end,
                                                    int flat_tid_329696,
                                                    int tid)
{
    int err = 0;
    struct futhark_mc_segred_stage_1_parloop_struct_338527
    *futhark_mc_segred_stage_1_parloop_struct_338527 =
    (struct futhark_mc_segred_stage_1_parloop_struct_338527 *) args;
    struct futhark_context *ctx =
                           futhark_mc_segred_stage_1_parloop_struct_338527->ctx;
    uint64_t futhark_mc_segred_stage_1_parloop_338528_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_338528_start = get_wall_time();
    
    int64_t n_292675 =
            futhark_mc_segred_stage_1_parloop_struct_338527->free_n_292675;
    int64_t gtid_305498 =
            futhark_mc_segred_stage_1_parloop_struct_338527->free_gtid_305498;
    int64_t ctx_param_ext_313174 =
            futhark_mc_segred_stage_1_parloop_struct_338527->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_segred_stage_1_parloop_struct_338527->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_segred_stage_1_parloop_struct_338527->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_segred_stage_1_parloop_struct_338527->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315021 = {.desc ="mem_315021", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_338527->free_mem_315021,
                                  .size =0, .references =NULL};
    int64_t x_329336 =
            futhark_mc_segred_stage_1_parloop_struct_338527->free_x_329336;
    double x_329337 =
           futhark_mc_segred_stage_1_parloop_struct_338527->free_x_329337;
    int64_t defunc_0_g_res_329340 =
            futhark_mc_segred_stage_1_parloop_struct_338527->free_defunc_0_g_res_329340;
    double a12_329409 =
           futhark_mc_segred_stage_1_parloop_struct_338527->free_a12_329409;
    double b12_329410 =
           futhark_mc_segred_stage_1_parloop_struct_338527->free_b12_329410;
    double c12_329411 =
           futhark_mc_segred_stage_1_parloop_struct_338527->free_c12_329411;
    double b2_329412 =
           futhark_mc_segred_stage_1_parloop_struct_338527->free_b2_329412;
    double c2_329413 =
           futhark_mc_segred_stage_1_parloop_struct_338527->free_c2_329413;
    struct memblock reduce_stage_1_tid_res_arr_mem_329774 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_329774",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338527->free_reduce_stage_1_tid_res_arr_mem_329774,
                                                             .size =0,
                                                             .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_329776 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_329776",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338527->free_reduce_stage_1_tid_res_arr_mem_329776,
                                                             .size =0,
                                                             .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_329778 = start;
    double x_329698;
    double x_329699;
    double x_329701;
    double x_329702;
    double local_acc_329779 = 0.0;
    double local_acc_329780 = 0.0;
    
    for (; iter_329778 < end; iter_329778++) {
        int64_t gtid_329697 = iter_329778;
        bool cond_329704 = sle64(n_292675, gtid_329697);
        int64_t defunc_0_f_res_329705;
        
        if (cond_329704) {
            defunc_0_f_res_329705 = (int64_t) 0;
        } else {
            int64_t i_329706 = add64(x_329336, gtid_329697);
            int64_t defunc_1_add_res_329707 = add64((int64_t) 1, i_329706);
            
            defunc_0_f_res_329705 = defunc_1_add_res_329707;
        }
        
        double defunc_0_f_res_329708;
        
        if (cond_329704) {
            defunc_0_f_res_329708 = 0.0;
        } else {
            int64_t i_329709 = add64(x_329336, gtid_329697);
            double defunc_0_add_arg_329710;
            
            defunc_0_add_arg_329710 =
                ((double *) mem_param_313179.mem)[ctx_param_ext_313174 +
                                                  (gtid_305498 *
                                                   ctx_param_ext_313175 +
                                                   i_329709 *
                                                   ctx_param_ext_313177)];
            defunc_0_f_res_329708 = defunc_0_add_arg_329710;
        }
        
        int64_t binop_p_329711 = sub64(defunc_0_f_res_329705,
                                       defunc_0_g_res_329340);
        double defunc_0_f_res_329712 = sitofp_i64_f64(binop_p_329711);
        double abs_res_329713 = fabs(defunc_0_f_res_329712);
        double tmp1_329714 = abs_res_329713 / x_329337;
        double x_329715 = tmp1_329714 * tmp1_329714;
        double y_329716 = tmp1_329714 * x_329715;
        double tmp2_329717 = 1.0 - y_329716;
        double x_329718 = tmp2_329717 * tmp2_329717;
        double tmp3_329719 = tmp2_329717 * x_329718;
        double tmp4_329720 = defunc_0_f_res_329708 * tmp3_329719;
        double defunc_1_f_res_329721 = defunc_0_f_res_329712 * tmp4_329720;
        double defunc_1_f_res_329722 = defunc_0_f_res_329712 *
               defunc_1_f_res_329721;
        double defunc_0_f_res_329723;
        
        if (cond_329704) {
            defunc_0_f_res_329723 = 0.0;
        } else {
            int64_t i_329724 = add64(x_329336, gtid_329697);
            double defunc_0_add_arg_329725;
            
            defunc_0_add_arg_329725 = ((double *) mem_315021.mem)[gtid_305498 *
                                                                  n_292675 +
                                                                  i_329724];
            defunc_0_f_res_329723 = defunc_0_add_arg_329725;
        }
        
        double x_329726 = a12_329409 * tmp4_329720;
        double y_329727 = b12_329410 * defunc_1_f_res_329721;
        double x_329728 = x_329726 + y_329727;
        double y_329729 = c12_329411 * defunc_1_f_res_329722;
        double x_329730 = x_329728 + y_329729;
        double defunc_9_fit_fun_res_329731 = defunc_0_f_res_329723 * x_329730;
        double x_329732 = b12_329410 * tmp4_329720;
        double y_329733 = b2_329412 * defunc_1_f_res_329721;
        double x_329734 = x_329732 + y_329733;
        double y_329735 = c2_329413 * defunc_1_f_res_329722;
        double x_329736 = x_329734 + y_329735;
        double defunc_9_slope_fun_res_329737 = defunc_0_f_res_329723 * x_329736;
        
        // save map-out results
        { }
        // Load accum params
        {
            x_329698 = local_acc_329779;
        }
        // Load next params
        {
            x_329699 = defunc_9_fit_fun_res_329731;
        }
        // Red body
        {
            double defunc_1_op_res_329700 = x_329698 + x_329699;
            
            local_acc_329779 = defunc_1_op_res_329700;
        }
        // Load accum params
        {
            x_329701 = local_acc_329780;
        }
        // Load next params
        {
            x_329702 = defunc_9_slope_fun_res_329737;
        }
        // Red body
        {
            double defunc_1_op_res_329703 = x_329701 + x_329702;
            
            local_acc_329780 = defunc_1_op_res_329703;
        }
    }
    ((double *) reduce_stage_1_tid_res_arr_mem_329774.mem)[flat_tid_329696] =
        local_acc_329779;
    ((double *) reduce_stage_1_tid_res_arr_mem_329776.mem)[flat_tid_329696] =
        local_acc_329780;
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_338528_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_338528_end -
                 futhark_mc_segred_stage_1_parloop_338528_start;
        
        ctx->futhark_mc_segred_stage_1_parloop_338528_runs[tid]++;
        ctx->futhark_mc_segred_stage_1_parloop_338528_total_runtime[tid] +=
            elapsed;
        ctx->futhark_mc_segred_stage_1_parloop_338528_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segred_task_338524(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_329696 = tid;
    int num_tasks_329773 = info.nsubtasks;
    struct futhark_mc_task_338523 *futhark_mc_task_338523 =
                                  (struct futhark_mc_task_338523 *) args;
    struct futhark_context *ctx = futhark_mc_task_338523->ctx;
    uint64_t futhark_mc_segred_task_338524_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_task_338524_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338523->free_n_292675;
    int64_t gtid_305498 = futhark_mc_task_338523->free_gtid_305498;
    int64_t ctx_param_ext_313174 =
            futhark_mc_task_338523->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_task_338523->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_task_338523->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_task_338523->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315021 = {.desc ="mem_315021", .mem =
                                  futhark_mc_task_338523->free_mem_315021,
                                  .size =0, .references =NULL};
    int64_t x_329336 = futhark_mc_task_338523->free_x_329336;
    double x_329337 = futhark_mc_task_338523->free_x_329337;
    int64_t defunc_0_g_res_329340 =
            futhark_mc_task_338523->free_defunc_0_g_res_329340;
    double a12_329409 = futhark_mc_task_338523->free_a12_329409;
    double b12_329410 = futhark_mc_task_338523->free_b12_329410;
    double c12_329411 = futhark_mc_task_338523->free_c12_329411;
    double b2_329412 = futhark_mc_task_338523->free_b2_329412;
    double c2_329413 = futhark_mc_task_338523->free_c2_329413;
    double defunc_2_reduce_res_329414 =
           *futhark_mc_task_338523->retval_defunc_2_reduce_res_329414;
    double defunc_2_reduce_res_329415 =
           *futhark_mc_task_338523->retval_defunc_2_reduce_res_329415;
    size_t reduce_stage_1_tid_res_arr_mem_329774_cached_sizze_338525 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_329774 = NULL;
    size_t reduce_stage_1_tid_res_arr_mem_329776_cached_sizze_338526 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_329776 = NULL;
    
    if (reduce_stage_1_tid_res_arr_mem_329774_cached_sizze_338525 <
        (size_t) ((int64_t) 8 * num_tasks_329773)) {
        reduce_stage_1_tid_res_arr_mem_329774 =
            realloc(reduce_stage_1_tid_res_arr_mem_329774, (int64_t) 8 *
                    num_tasks_329773);
        reduce_stage_1_tid_res_arr_mem_329774_cached_sizze_338525 =
            (int64_t) 8 * num_tasks_329773;
    }
    if (reduce_stage_1_tid_res_arr_mem_329776_cached_sizze_338526 <
        (size_t) ((int64_t) 8 * num_tasks_329773)) {
        reduce_stage_1_tid_res_arr_mem_329776 =
            realloc(reduce_stage_1_tid_res_arr_mem_329776, (int64_t) 8 *
                    num_tasks_329773);
        reduce_stage_1_tid_res_arr_mem_329776_cached_sizze_338526 =
            (int64_t) 8 * num_tasks_329773;
    }
    
    int64_t iter_329778;
    struct futhark_mc_segred_stage_1_parloop_struct_338527
    futhark_mc_segred_stage_1_parloop_struct_338527;
    
    futhark_mc_segred_stage_1_parloop_struct_338527.ctx = ctx;
    futhark_mc_segred_stage_1_parloop_struct_338527.free_n_292675 = n_292675;
    futhark_mc_segred_stage_1_parloop_struct_338527.free_gtid_305498 =
        gtid_305498;
    futhark_mc_segred_stage_1_parloop_struct_338527.free_ctx_param_ext_313174 =
        ctx_param_ext_313174;
    futhark_mc_segred_stage_1_parloop_struct_338527.free_ctx_param_ext_313175 =
        ctx_param_ext_313175;
    futhark_mc_segred_stage_1_parloop_struct_338527.free_ctx_param_ext_313177 =
        ctx_param_ext_313177;
    futhark_mc_segred_stage_1_parloop_struct_338527.free_mem_param_313179 =
        mem_param_313179.mem;
    futhark_mc_segred_stage_1_parloop_struct_338527.free_mem_315021 =
        mem_315021.mem;
    futhark_mc_segred_stage_1_parloop_struct_338527.free_x_329336 = x_329336;
    futhark_mc_segred_stage_1_parloop_struct_338527.free_x_329337 = x_329337;
    futhark_mc_segred_stage_1_parloop_struct_338527.free_defunc_0_g_res_329340 =
        defunc_0_g_res_329340;
    futhark_mc_segred_stage_1_parloop_struct_338527.free_a12_329409 =
        a12_329409;
    futhark_mc_segred_stage_1_parloop_struct_338527.free_b12_329410 =
        b12_329410;
    futhark_mc_segred_stage_1_parloop_struct_338527.free_c12_329411 =
        c12_329411;
    futhark_mc_segred_stage_1_parloop_struct_338527.free_b2_329412 = b2_329412;
    futhark_mc_segred_stage_1_parloop_struct_338527.free_c2_329413 = c2_329413;
    futhark_mc_segred_stage_1_parloop_struct_338527.free_reduce_stage_1_tid_res_arr_mem_329774 =
        reduce_stage_1_tid_res_arr_mem_329774;
    futhark_mc_segred_stage_1_parloop_struct_338527.free_reduce_stage_1_tid_res_arr_mem_329776 =
        reduce_stage_1_tid_res_arr_mem_329776;
    
    struct scheduler_parloop futhark_mc_segred_stage_1_parloop_338528_task;
    
    futhark_mc_segred_stage_1_parloop_338528_task.name =
        "futhark_mc_segred_stage_1_parloop_338528";
    futhark_mc_segred_stage_1_parloop_338528_task.fn =
        futhark_mc_segred_stage_1_parloop_338528;
    futhark_mc_segred_stage_1_parloop_338528_task.args =
        &futhark_mc_segred_stage_1_parloop_struct_338527;
    futhark_mc_segred_stage_1_parloop_338528_task.iterations = iterations;
    futhark_mc_segred_stage_1_parloop_338528_task.info = info;
    
    uint64_t futhark_mc_segred_stage_1_parloop_338528_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_338528_total_start = get_wall_time();
    
    int futhark_mc_segred_stage_1_parloop_338528_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segred_stage_1_parloop_338528_task);
    
    if (futhark_mc_segred_stage_1_parloop_338528_err != 0) {
        err = futhark_mc_segred_stage_1_parloop_338528_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_338528_total_end =
                 get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_338528_total_end -
                 futhark_mc_segred_stage_1_parloop_338528_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338528_total_runs,
                           1, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338528_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338528_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    // neutral-initialise the output
    {
        defunc_2_reduce_res_329414 = 0.0;
        defunc_2_reduce_res_329415 = 0.0;
    }
    
    double x_329781;
    double x_329782;
    double x_329784;
    double x_329785;
    
    for (int32_t i_329787 = 0; i_329787 < num_tasks_329773; i_329787++) {
        flat_tid_329696 = i_329787;
        // Apply main thread reduction
        {
            // load acc params
            {
                x_329781 = defunc_2_reduce_res_329414;
            }
            // load next params
            {
                x_329782 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_329774)[flat_tid_329696];
            }
            // red body
            {
                double defunc_1_op_res_329783 = x_329781 + x_329782;
                
                defunc_2_reduce_res_329414 = defunc_1_op_res_329783;
            }
            // load acc params
            {
                x_329784 = defunc_2_reduce_res_329415;
            }
            // load next params
            {
                x_329785 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_329776)[flat_tid_329696];
            }
            // red body
            {
                double defunc_1_op_res_329786 = x_329784 + x_329785;
                
                defunc_2_reduce_res_329415 = defunc_1_op_res_329786;
            }
        }
    }
    
  cleanup:
    {
        free(reduce_stage_1_tid_res_arr_mem_329774);
        free(reduce_stage_1_tid_res_arr_mem_329776);
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_task_338524_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_task_338524_end -
                 futhark_mc_segred_task_338524_start;
        
        ctx->futhark_mc_segred_task_338524_runs[tid]++;
        ctx->futhark_mc_segred_task_338524_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segred_task_338524_iter[tid] += iterations;
    }
    if (err == 0) {
        *futhark_mc_task_338523->retval_defunc_2_reduce_res_329414 =
            defunc_2_reduce_res_329414;
        *futhark_mc_task_338523->retval_defunc_2_reduce_res_329415 =
            defunc_2_reduce_res_329415;
    }
    return err;
}
static int futhark_mc_segmap_parloop_338513(void *args, int64_t start,
                                            int64_t end, int flat_tid_329334,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338512
    *futhark_mc_segmap_parloop_struct_338512 =
    (struct futhark_mc_segmap_parloop_struct_338512 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338512->ctx;
    uint64_t futhark_mc_segmap_parloop_338513_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338513_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_338512->free_n_292675;
    int64_t q_l_292680 =
            futhark_mc_segmap_parloop_struct_338512->free_q_l_292680;
    int64_t jump_t_292685 =
            futhark_mc_segmap_parloop_struct_338512->free_jump_t_292685;
    int64_t l_n_m_292832 =
            futhark_mc_segmap_parloop_struct_338512->free_l_n_m_292832;
    int64_t i_292846 = futhark_mc_segmap_parloop_struct_338512->free_i_292846;
    int64_t gtid_305498 =
            futhark_mc_segmap_parloop_struct_338512->free_gtid_305498;
    struct memblock mem_313081 = {.desc ="mem_313081", .mem =
                                  futhark_mc_segmap_parloop_struct_338512->free_mem_313081,
                                  .size =0, .references =NULL};
    struct memblock mem_313085 = {.desc ="mem_313085", .mem =
                                  futhark_mc_segmap_parloop_struct_338512->free_mem_313085,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_segmap_parloop_struct_338512->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_segmap_parloop_struct_338512->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_segmap_parloop_struct_338512->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_segmap_parloop_struct_338512->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315021 = {.desc ="mem_315021", .mem =
                                  futhark_mc_segmap_parloop_struct_338512->free_mem_315021,
                                  .size =0, .references =NULL};
    struct memblock mem_315094 = {.desc ="mem_315094", .mem =
                                  futhark_mc_segmap_parloop_struct_338512->free_mem_315094,
                                  .size =0, .references =NULL};
    struct memblock mem_315097 = {.desc ="mem_315097", .mem =
                                  futhark_mc_segmap_parloop_struct_338512->free_mem_315097,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_329657 = start;
    
    for (; iter_329657 < end; iter_329657++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_329738 = l_n_m_292832;
        int64_t gtid_329335 = iter_329657;
        int64_t remnant_329739 = iter_329657 - gtid_329335;
        int64_t x_329336;
        
        x_329336 = ((int64_t *) mem_313081.mem)[gtid_305498 * l_n_m_292832 +
                                                gtid_329335];
        
        double x_329337;
        
        x_329337 = ((double *) mem_313085.mem)[gtid_305498 * l_n_m_292832 +
                                               gtid_329335];
        
        int64_t min_arg_329338 = mul64(jump_t_292685, gtid_329335);
        int64_t min_res_329339 = smin64(i_292846, min_arg_329338);
        int64_t defunc_0_g_res_329340 = add64((int64_t) 1, min_res_329339);
        double defunc_2_reduce_res_329341;
        double defunc_2_reduce_res_329342;
        double defunc_2_reduce_res_329343;
        double defunc_2_reduce_res_329344;
        double defunc_2_reduce_res_329345;
        int64_t flat_tid_329658 = (int64_t) 0;
        int32_t num_tasks_329740;
        
        defunc_2_reduce_res_329341 = 0.0;
        defunc_2_reduce_res_329342 = 0.0;
        defunc_2_reduce_res_329343 = 0.0;
        defunc_2_reduce_res_329344 = 0.0;
        defunc_2_reduce_res_329345 = 0.0;
        
        struct futhark_mc_task_338514 futhark_mc_task_338514;
        
        futhark_mc_task_338514.ctx = ctx;
        futhark_mc_task_338514.free_n_292675 = n_292675;
        futhark_mc_task_338514.free_gtid_305498 = gtid_305498;
        futhark_mc_task_338514.free_ctx_param_ext_313174 = ctx_param_ext_313174;
        futhark_mc_task_338514.free_ctx_param_ext_313175 = ctx_param_ext_313175;
        futhark_mc_task_338514.free_ctx_param_ext_313177 = ctx_param_ext_313177;
        futhark_mc_task_338514.free_mem_param_313179 = mem_param_313179.mem;
        futhark_mc_task_338514.free_x_329336 = x_329336;
        futhark_mc_task_338514.free_x_329337 = x_329337;
        futhark_mc_task_338514.free_defunc_0_g_res_329340 =
            defunc_0_g_res_329340;
        futhark_mc_task_338514.retval_defunc_2_reduce_res_329341 =
            &defunc_2_reduce_res_329341;
        futhark_mc_task_338514.retval_defunc_2_reduce_res_329342 =
            &defunc_2_reduce_res_329342;
        futhark_mc_task_338514.retval_defunc_2_reduce_res_329343 =
            &defunc_2_reduce_res_329343;
        futhark_mc_task_338514.retval_defunc_2_reduce_res_329344 =
            &defunc_2_reduce_res_329344;
        futhark_mc_task_338514.retval_defunc_2_reduce_res_329345 =
            &defunc_2_reduce_res_329345;
        
        struct scheduler_segop futhark_mc_task_338514_task;
        
        futhark_mc_task_338514_task.args = &futhark_mc_task_338514;
        futhark_mc_task_338514_task.top_level_fn =
            futhark_mc_segred_task_338515;
        futhark_mc_task_338514_task.name = "futhark_mc_segred_task_338515";
        futhark_mc_task_338514_task.iterations = q_l_292680;
        futhark_mc_task_338514_task.task_time =
            &ctx->futhark_mc_segred_task_338515_total_time;
        futhark_mc_task_338514_task.task_iter =
            &ctx->futhark_mc_segred_task_338515_total_iter;
        futhark_mc_task_338514_task.sched = STATIC;
        futhark_mc_task_338514_task.nested_fn = NULL;
        
        int futhark_mc_segred_task_338515_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_338514_task);
        
        if (futhark_mc_segred_task_338515_err != 0) {
            ;
            err = futhark_mc_segred_task_338515_err;
            goto cleanup;
        }
        
        double a_329384 = 2.220446049250313e-16 + defunc_2_reduce_res_329341;
        double b_329385 = 2.220446049250313e-16 + defunc_2_reduce_res_329342;
        double c_329386 = 2.220446049250313e-16 + defunc_2_reduce_res_329343;
        double d_329387 = 2.220446049250313e-16 + defunc_2_reduce_res_329344;
        double e_329388 = 2.220446049250313e-16 + defunc_2_reduce_res_329345;
        double x_329389 = c_329386 * e_329388;
        double y_329390 = d_329387 * d_329387;
        double a12_329391 = x_329389 - y_329390;
        double x_329392 = c_329386 * d_329387;
        double y_329393 = b_329385 * e_329388;
        double b12_329394 = x_329392 - y_329393;
        double x_329395 = b_329385 * d_329387;
        double y_329396 = c_329386 * c_329386;
        double c12_329397 = x_329395 - y_329396;
        double x_329398 = a_329384 * e_329388;
        double b2_329399 = x_329398 - y_329396;
        double x_329400 = b_329385 * c_329386;
        double y_329401 = a_329384 * d_329387;
        double c2_329402 = x_329400 - y_329401;
        double x_329403 = a_329384 * a12_329391;
        double y_329404 = b_329385 * b12_329394;
        double x_329405 = x_329403 + y_329404;
        double y_329406 = c_329386 * c12_329397;
        double y_329407 = x_329405 + y_329406;
        double det_329408 = 1.0 / y_329407;
        double a12_329409 = a12_329391 * det_329408;
        double b12_329410 = b12_329394 * det_329408;
        double c12_329411 = c12_329397 * det_329408;
        double b2_329412 = b2_329399 * det_329408;
        double c2_329413 = c2_329402 * det_329408;
        double defunc_2_reduce_res_329414;
        double defunc_2_reduce_res_329415;
        int64_t flat_tid_329696 = (int64_t) 0;
        int32_t num_tasks_329773;
        
        defunc_2_reduce_res_329414 = 0.0;
        defunc_2_reduce_res_329415 = 0.0;
        
        struct futhark_mc_task_338523 futhark_mc_task_338523;
        
        futhark_mc_task_338523.ctx = ctx;
        futhark_mc_task_338523.free_n_292675 = n_292675;
        futhark_mc_task_338523.free_gtid_305498 = gtid_305498;
        futhark_mc_task_338523.free_ctx_param_ext_313174 = ctx_param_ext_313174;
        futhark_mc_task_338523.free_ctx_param_ext_313175 = ctx_param_ext_313175;
        futhark_mc_task_338523.free_ctx_param_ext_313177 = ctx_param_ext_313177;
        futhark_mc_task_338523.free_mem_param_313179 = mem_param_313179.mem;
        futhark_mc_task_338523.free_mem_315021 = mem_315021.mem;
        futhark_mc_task_338523.free_x_329336 = x_329336;
        futhark_mc_task_338523.free_x_329337 = x_329337;
        futhark_mc_task_338523.free_defunc_0_g_res_329340 =
            defunc_0_g_res_329340;
        futhark_mc_task_338523.free_a12_329409 = a12_329409;
        futhark_mc_task_338523.free_b12_329410 = b12_329410;
        futhark_mc_task_338523.free_c12_329411 = c12_329411;
        futhark_mc_task_338523.free_b2_329412 = b2_329412;
        futhark_mc_task_338523.free_c2_329413 = c2_329413;
        futhark_mc_task_338523.retval_defunc_2_reduce_res_329414 =
            &defunc_2_reduce_res_329414;
        futhark_mc_task_338523.retval_defunc_2_reduce_res_329415 =
            &defunc_2_reduce_res_329415;
        
        struct scheduler_segop futhark_mc_task_338523_task;
        
        futhark_mc_task_338523_task.args = &futhark_mc_task_338523;
        futhark_mc_task_338523_task.top_level_fn =
            futhark_mc_segred_task_338524;
        futhark_mc_task_338523_task.name = "futhark_mc_segred_task_338524";
        futhark_mc_task_338523_task.iterations = q_l_292680;
        futhark_mc_task_338523_task.task_time =
            &ctx->futhark_mc_segred_task_338524_total_time;
        futhark_mc_task_338523_task.task_iter =
            &ctx->futhark_mc_segred_task_338524_total_iter;
        futhark_mc_task_338523_task.sched = STATIC;
        futhark_mc_task_338523_task.nested_fn = NULL;
        
        int futhark_mc_segred_task_338524_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_338523_task);
        
        if (futhark_mc_segred_task_338524_err != 0) {
            ;
            err = futhark_mc_segred_task_338524_err;
            goto cleanup;
        }
        ((double *) mem_315094.mem)[gtid_329335] = defunc_2_reduce_res_329414;
        ((double *) mem_315097.mem)[gtid_329335] = defunc_2_reduce_res_329415;
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338513_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338513_end -
                 futhark_mc_segmap_parloop_338513_start;
        
        ctx->futhark_mc_segmap_parloop_338513_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338513_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338513_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_nested_task_338511(void *args, int64_t iterations,
                                         int tid, struct scheduler_info info)
{
    int err = 0;
    int flat_tid_329334 = tid;
    int num_tasks_329575 = info.nsubtasks;
    struct futhark_mc_task_338507 *futhark_mc_task_338507 =
                                  (struct futhark_mc_task_338507 *) args;
    struct futhark_context *ctx = futhark_mc_task_338507->ctx;
    uint64_t futhark_mc_segmap_nested_task_338511_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_nested_task_338511_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338507->free_n_292675;
    int64_t q_l_292680 = futhark_mc_task_338507->free_q_l_292680;
    int64_t jump_t_292685 = futhark_mc_task_338507->free_jump_t_292685;
    int64_t l_n_m_292832 = futhark_mc_task_338507->free_l_n_m_292832;
    int64_t i_292846 = futhark_mc_task_338507->free_i_292846;
    int64_t gtid_305498 = futhark_mc_task_338507->free_gtid_305498;
    struct memblock mem_313081 = {.desc ="mem_313081", .mem =
                                  futhark_mc_task_338507->free_mem_313081,
                                  .size =0, .references =NULL};
    struct memblock mem_313085 = {.desc ="mem_313085", .mem =
                                  futhark_mc_task_338507->free_mem_313085,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_task_338507->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_task_338507->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_task_338507->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_task_338507->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315021 = {.desc ="mem_315021", .mem =
                                  futhark_mc_task_338507->free_mem_315021,
                                  .size =0, .references =NULL};
    struct memblock mem_315094 = {.desc ="mem_315094", .mem =
                                  futhark_mc_task_338507->free_mem_315094,
                                  .size =0, .references =NULL};
    struct memblock mem_315097 = {.desc ="mem_315097", .mem =
                                  futhark_mc_task_338507->free_mem_315097,
                                  .size =0, .references =NULL};
    int64_t iter_329657;
    struct futhark_mc_segmap_parloop_struct_338512
    futhark_mc_segmap_parloop_struct_338512;
    
    futhark_mc_segmap_parloop_struct_338512.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338512.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_338512.free_q_l_292680 = q_l_292680;
    futhark_mc_segmap_parloop_struct_338512.free_jump_t_292685 = jump_t_292685;
    futhark_mc_segmap_parloop_struct_338512.free_l_n_m_292832 = l_n_m_292832;
    futhark_mc_segmap_parloop_struct_338512.free_i_292846 = i_292846;
    futhark_mc_segmap_parloop_struct_338512.free_gtid_305498 = gtid_305498;
    futhark_mc_segmap_parloop_struct_338512.free_mem_313081 = mem_313081.mem;
    futhark_mc_segmap_parloop_struct_338512.free_mem_313085 = mem_313085.mem;
    futhark_mc_segmap_parloop_struct_338512.free_ctx_param_ext_313174 =
        ctx_param_ext_313174;
    futhark_mc_segmap_parloop_struct_338512.free_ctx_param_ext_313175 =
        ctx_param_ext_313175;
    futhark_mc_segmap_parloop_struct_338512.free_ctx_param_ext_313177 =
        ctx_param_ext_313177;
    futhark_mc_segmap_parloop_struct_338512.free_mem_param_313179 =
        mem_param_313179.mem;
    futhark_mc_segmap_parloop_struct_338512.free_mem_315021 = mem_315021.mem;
    futhark_mc_segmap_parloop_struct_338512.free_mem_315094 = mem_315094.mem;
    futhark_mc_segmap_parloop_struct_338512.free_mem_315097 = mem_315097.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338513_task;
    
    futhark_mc_segmap_parloop_338513_task.name =
        "futhark_mc_segmap_parloop_338513";
    futhark_mc_segmap_parloop_338513_task.fn = futhark_mc_segmap_parloop_338513;
    futhark_mc_segmap_parloop_338513_task.args =
        &futhark_mc_segmap_parloop_struct_338512;
    futhark_mc_segmap_parloop_338513_task.iterations = iterations;
    futhark_mc_segmap_parloop_338513_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338513_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338513_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338513_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338513_task);
    
    if (futhark_mc_segmap_parloop_338513_err != 0) {
        err = futhark_mc_segmap_parloop_338513_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338513_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338513_total_end -
                 futhark_mc_segmap_parloop_338513_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338513_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338513_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338513_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_nested_task_338511_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_nested_task_338511_end -
                 futhark_mc_segmap_nested_task_338511_start;
        
        ctx->futhark_mc_segmap_nested_task_338511_runs[tid]++;
        ctx->futhark_mc_segmap_nested_task_338511_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_nested_task_338511_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
static int futhark_mc_segmap_parloop_338504(void *args, int64_t start,
                                            int64_t end, int flat_tid_305497,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338503
    *futhark_mc_segmap_parloop_struct_338503 =
    (struct futhark_mc_segmap_parloop_struct_338503 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338503->ctx;
    uint64_t futhark_mc_segmap_parloop_338504_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338504_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_338503->free_n_292675;
    int64_t q_l_292680 =
            futhark_mc_segmap_parloop_struct_338503->free_q_l_292680;
    int64_t jump_t_292685 =
            futhark_mc_segmap_parloop_struct_338503->free_jump_t_292685;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_338503->free_partition_sizze_292766;
    int64_t l_n_m_292832 =
            futhark_mc_segmap_parloop_struct_338503->free_l_n_m_292832;
    int64_t i_292846 = futhark_mc_segmap_parloop_struct_338503->free_i_292846;
    int64_t bytes_313028 =
            futhark_mc_segmap_parloop_struct_338503->free_bytes_313028;
    struct memblock mem_313081 = {.desc ="mem_313081", .mem =
                                  futhark_mc_segmap_parloop_struct_338503->free_mem_313081,
                                  .size =0, .references =NULL};
    struct memblock mem_313085 = {.desc ="mem_313085", .mem =
                                  futhark_mc_segmap_parloop_struct_338503->free_mem_313085,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_segmap_parloop_struct_338503->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_segmap_parloop_struct_338503->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_segmap_parloop_struct_338503->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_segmap_parloop_struct_338503->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315021 = {.desc ="mem_315021", .mem =
                                  futhark_mc_segmap_parloop_struct_338503->free_mem_315021,
                                  .size =0, .references =NULL};
    struct memblock mem_315131 = {.desc ="mem_315131", .mem =
                                  futhark_mc_segmap_parloop_struct_338503->free_mem_315131,
                                  .size =0, .references =NULL};
    struct memblock mem_315135 = {.desc ="mem_315135", .mem =
                                  futhark_mc_segmap_parloop_struct_338503->free_mem_315135,
                                  .size =0, .references =NULL};
    size_t mem_315094_cached_sizze_338505 = 0;
    unsigned char *mem_315094 = NULL;
    size_t mem_315097_cached_sizze_338506 = 0;
    unsigned char *mem_315097 = NULL;
    int64_t iterations = end - start;
    int64_t iter_329333 = start;
    
    if (mem_315094_cached_sizze_338505 < (size_t) bytes_313028) {
        mem_315094 = realloc(mem_315094, bytes_313028);
        mem_315094_cached_sizze_338505 = bytes_313028;
    }
    if (mem_315097_cached_sizze_338506 < (size_t) bytes_313028) {
        mem_315097 = realloc(mem_315097, bytes_313028);
        mem_315097_cached_sizze_338506 = bytes_313028;
    }
    for (; iter_329333 < end; iter_329333++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_329573 = partition_sizze_292766;
        int64_t gtid_305498 = iter_329333;
        int64_t remnant_329574 = iter_329333 - gtid_305498;
        int64_t flat_tid_329458 = (int64_t) 0;
        int32_t num_tasks_329575;
        int64_t flat_tid_329334 = (int64_t) 0;
        struct futhark_mc_task_338507 futhark_mc_task_338507;
        
        futhark_mc_task_338507.ctx = ctx;
        futhark_mc_task_338507.free_n_292675 = n_292675;
        futhark_mc_task_338507.free_q_l_292680 = q_l_292680;
        futhark_mc_task_338507.free_jump_t_292685 = jump_t_292685;
        futhark_mc_task_338507.free_l_n_m_292832 = l_n_m_292832;
        futhark_mc_task_338507.free_i_292846 = i_292846;
        futhark_mc_task_338507.free_gtid_305498 = gtid_305498;
        futhark_mc_task_338507.free_mem_313081 = mem_313081.mem;
        futhark_mc_task_338507.free_mem_313085 = mem_313085.mem;
        futhark_mc_task_338507.free_ctx_param_ext_313174 = ctx_param_ext_313174;
        futhark_mc_task_338507.free_ctx_param_ext_313175 = ctx_param_ext_313175;
        futhark_mc_task_338507.free_ctx_param_ext_313177 = ctx_param_ext_313177;
        futhark_mc_task_338507.free_mem_param_313179 = mem_param_313179.mem;
        futhark_mc_task_338507.free_mem_315021 = mem_315021.mem;
        futhark_mc_task_338507.free_mem_315094 = mem_315094;
        futhark_mc_task_338507.free_mem_315097 = mem_315097;
        
        struct scheduler_segop futhark_mc_task_338507_task;
        
        futhark_mc_task_338507_task.args = &futhark_mc_task_338507;
        futhark_mc_task_338507_task.top_level_fn =
            futhark_mc_segmap_task_338508;
        futhark_mc_task_338507_task.name = "futhark_mc_segmap_task_338508";
        futhark_mc_task_338507_task.iterations = l_n_m_292832;
        futhark_mc_task_338507_task.task_time =
            &ctx->futhark_mc_segmap_task_338508_total_time;
        futhark_mc_task_338507_task.task_iter =
            &ctx->futhark_mc_segmap_task_338508_total_iter;
        futhark_mc_task_338507_task.sched = STATIC;
        futhark_mc_task_338507_task.nested_fn =
            futhark_mc_segmap_nested_task_338511;
        
        int futhark_mc_segmap_task_338508_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_338507_task);
        
        if (futhark_mc_segmap_task_338508_err != 0) {
            ;
            err = futhark_mc_segmap_task_338508_err;
            goto cleanup;
        }
        if (l_n_m_292832 * (int64_t) 8 > 0)
            memmove(mem_315131.mem + gtid_305498 * l_n_m_292832 * (int64_t) 8,
                    mem_315094 + (int64_t) 0, l_n_m_292832 * (int64_t) 8);
        if (l_n_m_292832 * (int64_t) 8 > 0)
            memmove(mem_315135.mem + gtid_305498 * l_n_m_292832 * (int64_t) 8,
                    mem_315097 + (int64_t) 0, l_n_m_292832 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_315094);
    free(mem_315097);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338504_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338504_end -
                 futhark_mc_segmap_parloop_338504_start;
        
        ctx->futhark_mc_segmap_parloop_338504_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338504_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338504_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_nested_task_338502(void *args, int64_t iterations,
                                         int tid, struct scheduler_info info)
{
    int err = 0;
    int flat_tid_305497 = tid;
    int num_tasks_329202 = info.nsubtasks;
    struct futhark_mc_task_338496 *futhark_mc_task_338496 =
                                  (struct futhark_mc_task_338496 *) args;
    struct futhark_context *ctx = futhark_mc_task_338496->ctx;
    uint64_t futhark_mc_segmap_nested_task_338502_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_nested_task_338502_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338496->free_n_292675;
    int64_t q_l_292680 = futhark_mc_task_338496->free_q_l_292680;
    int64_t jump_t_292685 = futhark_mc_task_338496->free_jump_t_292685;
    int64_t partition_sizze_292766 =
            futhark_mc_task_338496->free_partition_sizze_292766;
    int64_t l_n_m_292832 = futhark_mc_task_338496->free_l_n_m_292832;
    int64_t i_292846 = futhark_mc_task_338496->free_i_292846;
    int64_t bytes_313028 = futhark_mc_task_338496->free_bytes_313028;
    struct memblock mem_313081 = {.desc ="mem_313081", .mem =
                                  futhark_mc_task_338496->free_mem_313081,
                                  .size =0, .references =NULL};
    struct memblock mem_313085 = {.desc ="mem_313085", .mem =
                                  futhark_mc_task_338496->free_mem_313085,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_task_338496->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_task_338496->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_task_338496->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_task_338496->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315021 = {.desc ="mem_315021", .mem =
                                  futhark_mc_task_338496->free_mem_315021,
                                  .size =0, .references =NULL};
    struct memblock mem_315131 = {.desc ="mem_315131", .mem =
                                  futhark_mc_task_338496->free_mem_315131,
                                  .size =0, .references =NULL};
    struct memblock mem_315135 = {.desc ="mem_315135", .mem =
                                  futhark_mc_task_338496->free_mem_315135,
                                  .size =0, .references =NULL};
    int64_t iter_329333;
    struct futhark_mc_segmap_parloop_struct_338503
    futhark_mc_segmap_parloop_struct_338503;
    
    futhark_mc_segmap_parloop_struct_338503.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338503.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_338503.free_q_l_292680 = q_l_292680;
    futhark_mc_segmap_parloop_struct_338503.free_jump_t_292685 = jump_t_292685;
    futhark_mc_segmap_parloop_struct_338503.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_338503.free_l_n_m_292832 = l_n_m_292832;
    futhark_mc_segmap_parloop_struct_338503.free_i_292846 = i_292846;
    futhark_mc_segmap_parloop_struct_338503.free_bytes_313028 = bytes_313028;
    futhark_mc_segmap_parloop_struct_338503.free_mem_313081 = mem_313081.mem;
    futhark_mc_segmap_parloop_struct_338503.free_mem_313085 = mem_313085.mem;
    futhark_mc_segmap_parloop_struct_338503.free_ctx_param_ext_313174 =
        ctx_param_ext_313174;
    futhark_mc_segmap_parloop_struct_338503.free_ctx_param_ext_313175 =
        ctx_param_ext_313175;
    futhark_mc_segmap_parloop_struct_338503.free_ctx_param_ext_313177 =
        ctx_param_ext_313177;
    futhark_mc_segmap_parloop_struct_338503.free_mem_param_313179 =
        mem_param_313179.mem;
    futhark_mc_segmap_parloop_struct_338503.free_mem_315021 = mem_315021.mem;
    futhark_mc_segmap_parloop_struct_338503.free_mem_315131 = mem_315131.mem;
    futhark_mc_segmap_parloop_struct_338503.free_mem_315135 = mem_315135.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338504_task;
    
    futhark_mc_segmap_parloop_338504_task.name =
        "futhark_mc_segmap_parloop_338504";
    futhark_mc_segmap_parloop_338504_task.fn = futhark_mc_segmap_parloop_338504;
    futhark_mc_segmap_parloop_338504_task.args =
        &futhark_mc_segmap_parloop_struct_338503;
    futhark_mc_segmap_parloop_338504_task.iterations = iterations;
    futhark_mc_segmap_parloop_338504_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338504_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338504_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338504_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338504_task);
    
    if (futhark_mc_segmap_parloop_338504_err != 0) {
        err = futhark_mc_segmap_parloop_338504_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338504_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338504_total_end -
                 futhark_mc_segmap_parloop_338504_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338504_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338504_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338504_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_nested_task_338502_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_nested_task_338502_end -
                 futhark_mc_segmap_nested_task_338502_start;
        
        ctx->futhark_mc_segmap_nested_task_338502_runs[tid]++;
        ctx->futhark_mc_segmap_nested_task_338502_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_nested_task_338502_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_task_338529 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_l_292680;
    int64_t free_jump_t_292685;
    int64_t free_partition_sizze_292766;
    int64_t free_l_n_m_292832;
    int64_t free_i_292846;
    int64_t free_bytes_313028;
    unsigned char *free_mem_313081;
    unsigned char *free_mem_313085;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315021;
    int64_t free_bytes_315145;
    unsigned char *free_mem_315198;
};
struct futhark_mc_segmap_parloop_struct_338531 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_l_292680;
    int64_t free_jump_t_292685;
    int64_t free_partition_sizze_292766;
    int64_t free_l_n_m_292832;
    int64_t free_i_292846;
    int64_t free_bytes_313028;
    unsigned char *free_mem_313081;
    unsigned char *free_mem_313085;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315021;
    int64_t free_bytes_315145;
    unsigned char *free_mem_315198;
};
static int futhark_mc_segmap_parloop_338532(void *args, int64_t start,
                                            int64_t end, int flat_tid_305755,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338531
    *futhark_mc_segmap_parloop_struct_338531 =
    (struct futhark_mc_segmap_parloop_struct_338531 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338531->ctx;
    uint64_t futhark_mc_segmap_parloop_338532_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338532_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_338531->free_n_292675;
    int64_t q_l_292680 =
            futhark_mc_segmap_parloop_struct_338531->free_q_l_292680;
    int64_t jump_t_292685 =
            futhark_mc_segmap_parloop_struct_338531->free_jump_t_292685;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_338531->free_partition_sizze_292766;
    int64_t l_n_m_292832 =
            futhark_mc_segmap_parloop_struct_338531->free_l_n_m_292832;
    int64_t i_292846 = futhark_mc_segmap_parloop_struct_338531->free_i_292846;
    int64_t bytes_313028 =
            futhark_mc_segmap_parloop_struct_338531->free_bytes_313028;
    struct memblock mem_313081 = {.desc ="mem_313081", .mem =
                                  futhark_mc_segmap_parloop_struct_338531->free_mem_313081,
                                  .size =0, .references =NULL};
    struct memblock mem_313085 = {.desc ="mem_313085", .mem =
                                  futhark_mc_segmap_parloop_struct_338531->free_mem_313085,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_segmap_parloop_struct_338531->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_segmap_parloop_struct_338531->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_segmap_parloop_struct_338531->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_segmap_parloop_struct_338531->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315021 = {.desc ="mem_315021", .mem =
                                  futhark_mc_segmap_parloop_struct_338531->free_mem_315021,
                                  .size =0, .references =NULL};
    int64_t bytes_315145 =
            futhark_mc_segmap_parloop_struct_338531->free_bytes_315145;
    struct memblock mem_315198 = {.desc ="mem_315198", .mem =
                                  futhark_mc_segmap_parloop_struct_338531->free_mem_315198,
                                  .size =0, .references =NULL};
    size_t mem_315167_cached_sizze_338533 = 0;
    unsigned char *mem_315167 = NULL;
    size_t mem_315177_cached_sizze_338534 = 0;
    unsigned char *mem_315177 = NULL;
    int64_t iterations = end - start;
    int64_t iter_329791 = start;
    
    if (mem_315167_cached_sizze_338533 < (size_t) bytes_313028) {
        mem_315167 = realloc(mem_315167, bytes_313028);
        mem_315167_cached_sizze_338533 = bytes_313028;
    }
    if (mem_315177_cached_sizze_338534 < (size_t) bytes_315145) {
        mem_315177 = realloc(mem_315177, bytes_315145);
        mem_315177_cached_sizze_338534 = bytes_315145;
    }
    for (; iter_329791 < end; iter_329791++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_329838 = partition_sizze_292766;
        int64_t gtid_305756 = iter_329791;
        int64_t remnant_329839 = iter_329791 - gtid_305756;
        
        for (int64_t i_329792 = 0; i_329792 < l_n_m_292832; i_329792++) {
            int64_t x_329794;
            
            x_329794 = ((int64_t *) mem_313081.mem)[gtid_305756 * l_n_m_292832 +
                                                    i_329792];
            
            double x_329795;
            
            x_329795 = ((double *) mem_313085.mem)[gtid_305756 * l_n_m_292832 +
                                                   i_329792];
            
            int64_t min_arg_329796 = mul64(jump_t_292685, i_329792);
            int64_t min_res_329797 = smin64(i_292846, min_arg_329796);
            int64_t defunc_0_g_res_329798 = add64((int64_t) 1, min_res_329797);
            double defunc_2_reduce_res_329800;
            double redout_329803 = 0.0;
            
            for (int64_t i_329802 = 0; i_329802 < q_l_292680; i_329802++) {
                bool cond_329805 = sle64(n_292675, i_329802);
                int64_t defunc_0_f_res_329806;
                
                if (cond_329805) {
                    defunc_0_f_res_329806 = (int64_t) 0;
                } else {
                    int64_t i_329807 = add64(x_329794, i_329802);
                    int64_t defunc_1_add_res_329808 = add64((int64_t) 1,
                                                            i_329807);
                    
                    defunc_0_f_res_329806 = defunc_1_add_res_329808;
                }
                
                double defunc_0_f_res_329809;
                
                if (cond_329805) {
                    defunc_0_f_res_329809 = 0.0;
                } else {
                    int64_t i_329810 = add64(x_329794, i_329802);
                    double defunc_0_add_arg_329811;
                    
                    defunc_0_add_arg_329811 =
                        ((double *) mem_param_313179.mem)[ctx_param_ext_313174 +
                                                          (gtid_305756 *
                                                           ctx_param_ext_313175 +
                                                           i_329810 *
                                                           ctx_param_ext_313177)];
                    defunc_0_f_res_329809 = defunc_0_add_arg_329811;
                }
                
                int64_t binop_p_329812 = sub64(defunc_0_f_res_329806,
                                               defunc_0_g_res_329798);
                double defunc_0_f_res_329813 = sitofp_i64_f64(binop_p_329812);
                double abs_res_329814 = fabs(defunc_0_f_res_329813);
                double tmp1_329815 = abs_res_329814 / x_329795;
                double x_329816 = tmp1_329815 * tmp1_329815;
                double y_329817 = tmp1_329815 * x_329816;
                double tmp2_329818 = 1.0 - y_329817;
                double x_329819 = tmp2_329818 * tmp2_329818;
                double tmp3_329820 = tmp2_329818 * x_329819;
                double tmp4_329821 = defunc_0_f_res_329809 * tmp3_329820;
                double defunc_1_op_res_329822 = tmp4_329821 + redout_329803;
                
                ((double *) mem_315177)[i_329802] = tmp4_329821;
                
                double redout_tmp_329841 = defunc_1_op_res_329822;
                
                redout_329803 = redout_tmp_329841;
            }
            defunc_2_reduce_res_329800 = redout_329803;
            
            double a_329824 = 2.220446049250313e-16 +
                   defunc_2_reduce_res_329800;
            double a0_329825 = 1.0 / a_329824;
            double defunc_2_reduce_res_329826;
            double redout_329828 = 0.0;
            
            for (int64_t i_329827 = 0; i_329827 < q_l_292680; i_329827++) {
                double x_329829;
                
                x_329829 = ((double *) mem_315177)[i_329827];
                
                bool cond_329830 = sle64(n_292675, i_329827);
                double defunc_0_f_res_329831;
                
                if (cond_329830) {
                    defunc_0_f_res_329831 = 0.0;
                } else {
                    int64_t i_329832 = add64(x_329794, i_329827);
                    double defunc_0_add_arg_329833;
                    
                    defunc_0_add_arg_329833 =
                        ((double *) mem_315021.mem)[gtid_305756 * n_292675 +
                                                    i_329832];
                    defunc_0_f_res_329831 = defunc_0_add_arg_329833;
                }
                
                double x_329834 = a0_329825 * x_329829;
                double defunc_9_fit_fun_res_329835 = defunc_0_f_res_329831 *
                       x_329834;
                double defunc_1_op_res_329836 = defunc_9_fit_fun_res_329835 +
                       redout_329828;
                double redout_tmp_329843 = defunc_1_op_res_329836;
                
                redout_329828 = redout_tmp_329843;
            }
            defunc_2_reduce_res_329826 = redout_329828;
            ((double *) mem_315167)[i_329792] = defunc_2_reduce_res_329826;
        }
        if (l_n_m_292832 * (int64_t) 8 > 0)
            memmove(mem_315198.mem + gtid_305756 * l_n_m_292832 * (int64_t) 8,
                    mem_315167 + (int64_t) 0, l_n_m_292832 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_315167);
    free(mem_315177);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338532_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338532_end -
                 futhark_mc_segmap_parloop_338532_start;
        
        ctx->futhark_mc_segmap_parloop_338532_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338532_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338532_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_338530(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_305755 = tid;
    int num_tasks_329790 = info.nsubtasks;
    struct futhark_mc_task_338529 *futhark_mc_task_338529 =
                                  (struct futhark_mc_task_338529 *) args;
    struct futhark_context *ctx = futhark_mc_task_338529->ctx;
    uint64_t futhark_mc_segmap_task_338530_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_338530_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338529->free_n_292675;
    int64_t q_l_292680 = futhark_mc_task_338529->free_q_l_292680;
    int64_t jump_t_292685 = futhark_mc_task_338529->free_jump_t_292685;
    int64_t partition_sizze_292766 =
            futhark_mc_task_338529->free_partition_sizze_292766;
    int64_t l_n_m_292832 = futhark_mc_task_338529->free_l_n_m_292832;
    int64_t i_292846 = futhark_mc_task_338529->free_i_292846;
    int64_t bytes_313028 = futhark_mc_task_338529->free_bytes_313028;
    struct memblock mem_313081 = {.desc ="mem_313081", .mem =
                                  futhark_mc_task_338529->free_mem_313081,
                                  .size =0, .references =NULL};
    struct memblock mem_313085 = {.desc ="mem_313085", .mem =
                                  futhark_mc_task_338529->free_mem_313085,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_task_338529->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_task_338529->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_task_338529->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_task_338529->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315021 = {.desc ="mem_315021", .mem =
                                  futhark_mc_task_338529->free_mem_315021,
                                  .size =0, .references =NULL};
    int64_t bytes_315145 = futhark_mc_task_338529->free_bytes_315145;
    struct memblock mem_315198 = {.desc ="mem_315198", .mem =
                                  futhark_mc_task_338529->free_mem_315198,
                                  .size =0, .references =NULL};
    int64_t iter_329791;
    struct futhark_mc_segmap_parloop_struct_338531
    futhark_mc_segmap_parloop_struct_338531;
    
    futhark_mc_segmap_parloop_struct_338531.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338531.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_338531.free_q_l_292680 = q_l_292680;
    futhark_mc_segmap_parloop_struct_338531.free_jump_t_292685 = jump_t_292685;
    futhark_mc_segmap_parloop_struct_338531.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_338531.free_l_n_m_292832 = l_n_m_292832;
    futhark_mc_segmap_parloop_struct_338531.free_i_292846 = i_292846;
    futhark_mc_segmap_parloop_struct_338531.free_bytes_313028 = bytes_313028;
    futhark_mc_segmap_parloop_struct_338531.free_mem_313081 = mem_313081.mem;
    futhark_mc_segmap_parloop_struct_338531.free_mem_313085 = mem_313085.mem;
    futhark_mc_segmap_parloop_struct_338531.free_ctx_param_ext_313174 =
        ctx_param_ext_313174;
    futhark_mc_segmap_parloop_struct_338531.free_ctx_param_ext_313175 =
        ctx_param_ext_313175;
    futhark_mc_segmap_parloop_struct_338531.free_ctx_param_ext_313177 =
        ctx_param_ext_313177;
    futhark_mc_segmap_parloop_struct_338531.free_mem_param_313179 =
        mem_param_313179.mem;
    futhark_mc_segmap_parloop_struct_338531.free_mem_315021 = mem_315021.mem;
    futhark_mc_segmap_parloop_struct_338531.free_bytes_315145 = bytes_315145;
    futhark_mc_segmap_parloop_struct_338531.free_mem_315198 = mem_315198.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338532_task;
    
    futhark_mc_segmap_parloop_338532_task.name =
        "futhark_mc_segmap_parloop_338532";
    futhark_mc_segmap_parloop_338532_task.fn = futhark_mc_segmap_parloop_338532;
    futhark_mc_segmap_parloop_338532_task.args =
        &futhark_mc_segmap_parloop_struct_338531;
    futhark_mc_segmap_parloop_338532_task.iterations = iterations;
    futhark_mc_segmap_parloop_338532_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338532_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338532_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338532_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338532_task);
    
    if (futhark_mc_segmap_parloop_338532_err != 0) {
        err = futhark_mc_segmap_parloop_338532_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338532_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338532_total_end -
                 futhark_mc_segmap_parloop_338532_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338532_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338532_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338532_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_338530_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_338530_end -
                 futhark_mc_segmap_task_338530_start;
        
        ctx->futhark_mc_segmap_task_338530_runs[tid]++;
        ctx->futhark_mc_segmap_task_338530_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_338530_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_segmap_parloop_struct_338536 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_l_292680;
    int64_t free_jump_t_292685;
    int64_t free_partition_sizze_292766;
    int64_t free_l_n_m_292832;
    int64_t free_i_292846;
    int64_t free_bytes_313028;
    unsigned char *free_mem_313081;
    unsigned char *free_mem_313085;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315021;
    int64_t free_bytes_315145;
    unsigned char *free_mem_315198;
};
struct futhark_mc_task_338539 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_l_292680;
    int64_t free_jump_t_292685;
    int64_t free_l_n_m_292832;
    int64_t free_i_292846;
    int64_t free_gtid_305817;
    unsigned char *free_mem_313081;
    unsigned char *free_mem_313085;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315021;
    int64_t free_bytes_315145;
    unsigned char *free_mem_315164;
};
struct futhark_mc_segmap_parloop_struct_338541 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_l_292680;
    int64_t free_jump_t_292685;
    int64_t free_l_n_m_292832;
    int64_t free_i_292846;
    int64_t free_gtid_305817;
    unsigned char *free_mem_313081;
    unsigned char *free_mem_313085;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315021;
    int64_t free_bytes_315145;
    unsigned char *free_mem_315164;
};
static int futhark_mc_segmap_parloop_338542(void *args, int64_t start,
                                            int64_t end, int flat_tid_329892,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338541
    *futhark_mc_segmap_parloop_struct_338541 =
    (struct futhark_mc_segmap_parloop_struct_338541 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338541->ctx;
    uint64_t futhark_mc_segmap_parloop_338542_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338542_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_338541->free_n_292675;
    int64_t q_l_292680 =
            futhark_mc_segmap_parloop_struct_338541->free_q_l_292680;
    int64_t jump_t_292685 =
            futhark_mc_segmap_parloop_struct_338541->free_jump_t_292685;
    int64_t l_n_m_292832 =
            futhark_mc_segmap_parloop_struct_338541->free_l_n_m_292832;
    int64_t i_292846 = futhark_mc_segmap_parloop_struct_338541->free_i_292846;
    int64_t gtid_305817 =
            futhark_mc_segmap_parloop_struct_338541->free_gtid_305817;
    struct memblock mem_313081 = {.desc ="mem_313081", .mem =
                                  futhark_mc_segmap_parloop_struct_338541->free_mem_313081,
                                  .size =0, .references =NULL};
    struct memblock mem_313085 = {.desc ="mem_313085", .mem =
                                  futhark_mc_segmap_parloop_struct_338541->free_mem_313085,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_segmap_parloop_struct_338541->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_segmap_parloop_struct_338541->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_segmap_parloop_struct_338541->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_segmap_parloop_struct_338541->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315021 = {.desc ="mem_315021", .mem =
                                  futhark_mc_segmap_parloop_struct_338541->free_mem_315021,
                                  .size =0, .references =NULL};
    int64_t bytes_315145 =
            futhark_mc_segmap_parloop_struct_338541->free_bytes_315145;
    struct memblock mem_315164 = {.desc ="mem_315164", .mem =
                                  futhark_mc_segmap_parloop_struct_338541->free_mem_315164,
                                  .size =0, .references =NULL};
    size_t mem_329899_cached_sizze_338543 = 0;
    unsigned char *mem_329899 = NULL;
    int64_t iterations = end - start;
    int64_t iter_329941 = start;
    
    if (mem_329899_cached_sizze_338543 < (size_t) bytes_315145) {
        mem_329899 = realloc(mem_329899, bytes_315145);
        mem_329899_cached_sizze_338543 = bytes_315145;
    }
    for (; iter_329941 < end; iter_329941++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_329974 = l_n_m_292832;
        int64_t gtid_329893 = iter_329941;
        int64_t remnant_329975 = iter_329941 - gtid_329893;
        int64_t x_329894;
        
        x_329894 = ((int64_t *) mem_313081.mem)[gtid_305817 * l_n_m_292832 +
                                                gtid_329893];
        
        double x_329895;
        
        x_329895 = ((double *) mem_313085.mem)[gtid_305817 * l_n_m_292832 +
                                               gtid_329893];
        
        int64_t min_arg_329896 = mul64(jump_t_292685, gtid_329893);
        int64_t min_res_329897 = smin64(i_292846, min_arg_329896);
        int64_t defunc_0_g_res_329898 = add64((int64_t) 1, min_res_329897);
        double defunc_2_reduce_res_329901;
        double redout_329943 = 0.0;
        
        for (int64_t i_329942 = 0; i_329942 < q_l_292680; i_329942++) {
            bool cond_329945 = sle64(n_292675, i_329942);
            int64_t defunc_0_f_res_329946;
            
            if (cond_329945) {
                defunc_0_f_res_329946 = (int64_t) 0;
            } else {
                int64_t i_329947 = add64(x_329894, i_329942);
                int64_t defunc_1_add_res_329948 = add64((int64_t) 1, i_329947);
                
                defunc_0_f_res_329946 = defunc_1_add_res_329948;
            }
            
            double defunc_0_f_res_329949;
            
            if (cond_329945) {
                defunc_0_f_res_329949 = 0.0;
            } else {
                int64_t i_329950 = add64(x_329894, i_329942);
                double defunc_0_add_arg_329951;
                
                defunc_0_add_arg_329951 =
                    ((double *) mem_param_313179.mem)[ctx_param_ext_313174 +
                                                      (gtid_305817 *
                                                       ctx_param_ext_313175 +
                                                       i_329950 *
                                                       ctx_param_ext_313177)];
                defunc_0_f_res_329949 = defunc_0_add_arg_329951;
            }
            
            int64_t binop_p_329952 = sub64(defunc_0_f_res_329946,
                                           defunc_0_g_res_329898);
            double defunc_0_f_res_329953 = sitofp_i64_f64(binop_p_329952);
            double abs_res_329954 = fabs(defunc_0_f_res_329953);
            double tmp1_329955 = abs_res_329954 / x_329895;
            double x_329956 = tmp1_329955 * tmp1_329955;
            double y_329957 = tmp1_329955 * x_329956;
            double tmp2_329958 = 1.0 - y_329957;
            double x_329959 = tmp2_329958 * tmp2_329958;
            double tmp3_329960 = tmp2_329958 * x_329959;
            double tmp4_329961 = defunc_0_f_res_329949 * tmp3_329960;
            double defunc_1_op_res_329962 = tmp4_329961 + redout_329943;
            
            ((double *) mem_329899)[i_329942] = tmp4_329961;
            
            double redout_tmp_329976 = defunc_1_op_res_329962;
            
            redout_329943 = redout_tmp_329976;
        }
        defunc_2_reduce_res_329901 = redout_329943;
        
        double a_329925 = 2.220446049250313e-16 + defunc_2_reduce_res_329901;
        double a0_329926 = 1.0 / a_329925;
        double defunc_2_reduce_res_329927;
        double redout_329965 = 0.0;
        
        for (int64_t i_329964 = 0; i_329964 < q_l_292680; i_329964++) {
            double x_329966;
            
            x_329966 = ((double *) mem_329899)[i_329964];
            
            bool cond_329967 = sle64(n_292675, i_329964);
            double defunc_0_f_res_329968;
            
            if (cond_329967) {
                defunc_0_f_res_329968 = 0.0;
            } else {
                int64_t i_329969 = add64(x_329894, i_329964);
                double defunc_0_add_arg_329970;
                
                defunc_0_add_arg_329970 =
                    ((double *) mem_315021.mem)[gtid_305817 * n_292675 +
                                                i_329969];
                defunc_0_f_res_329968 = defunc_0_add_arg_329970;
            }
            
            double x_329971 = a0_329926 * x_329966;
            double defunc_9_fit_fun_res_329972 = defunc_0_f_res_329968 *
                   x_329971;
            double defunc_1_op_res_329973 = defunc_9_fit_fun_res_329972 +
                   redout_329965;
            double redout_tmp_329978 = defunc_1_op_res_329973;
            
            redout_329965 = redout_tmp_329978;
        }
        defunc_2_reduce_res_329927 = redout_329965;
        ((double *) mem_315164.mem)[gtid_329893] = defunc_2_reduce_res_329927;
    }
    
  cleanup:
    { }
    free(mem_329899);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338542_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338542_end -
                 futhark_mc_segmap_parloop_338542_start;
        
        ctx->futhark_mc_segmap_parloop_338542_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338542_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338542_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_338540(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_329892 = tid;
    int num_tasks_329940 = info.nsubtasks;
    struct futhark_mc_task_338539 *futhark_mc_task_338539 =
                                  (struct futhark_mc_task_338539 *) args;
    struct futhark_context *ctx = futhark_mc_task_338539->ctx;
    uint64_t futhark_mc_segmap_task_338540_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_338540_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338539->free_n_292675;
    int64_t q_l_292680 = futhark_mc_task_338539->free_q_l_292680;
    int64_t jump_t_292685 = futhark_mc_task_338539->free_jump_t_292685;
    int64_t l_n_m_292832 = futhark_mc_task_338539->free_l_n_m_292832;
    int64_t i_292846 = futhark_mc_task_338539->free_i_292846;
    int64_t gtid_305817 = futhark_mc_task_338539->free_gtid_305817;
    struct memblock mem_313081 = {.desc ="mem_313081", .mem =
                                  futhark_mc_task_338539->free_mem_313081,
                                  .size =0, .references =NULL};
    struct memblock mem_313085 = {.desc ="mem_313085", .mem =
                                  futhark_mc_task_338539->free_mem_313085,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_task_338539->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_task_338539->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_task_338539->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_task_338539->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315021 = {.desc ="mem_315021", .mem =
                                  futhark_mc_task_338539->free_mem_315021,
                                  .size =0, .references =NULL};
    int64_t bytes_315145 = futhark_mc_task_338539->free_bytes_315145;
    struct memblock mem_315164 = {.desc ="mem_315164", .mem =
                                  futhark_mc_task_338539->free_mem_315164,
                                  .size =0, .references =NULL};
    int64_t iter_329941;
    struct futhark_mc_segmap_parloop_struct_338541
    futhark_mc_segmap_parloop_struct_338541;
    
    futhark_mc_segmap_parloop_struct_338541.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338541.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_338541.free_q_l_292680 = q_l_292680;
    futhark_mc_segmap_parloop_struct_338541.free_jump_t_292685 = jump_t_292685;
    futhark_mc_segmap_parloop_struct_338541.free_l_n_m_292832 = l_n_m_292832;
    futhark_mc_segmap_parloop_struct_338541.free_i_292846 = i_292846;
    futhark_mc_segmap_parloop_struct_338541.free_gtid_305817 = gtid_305817;
    futhark_mc_segmap_parloop_struct_338541.free_mem_313081 = mem_313081.mem;
    futhark_mc_segmap_parloop_struct_338541.free_mem_313085 = mem_313085.mem;
    futhark_mc_segmap_parloop_struct_338541.free_ctx_param_ext_313174 =
        ctx_param_ext_313174;
    futhark_mc_segmap_parloop_struct_338541.free_ctx_param_ext_313175 =
        ctx_param_ext_313175;
    futhark_mc_segmap_parloop_struct_338541.free_ctx_param_ext_313177 =
        ctx_param_ext_313177;
    futhark_mc_segmap_parloop_struct_338541.free_mem_param_313179 =
        mem_param_313179.mem;
    futhark_mc_segmap_parloop_struct_338541.free_mem_315021 = mem_315021.mem;
    futhark_mc_segmap_parloop_struct_338541.free_bytes_315145 = bytes_315145;
    futhark_mc_segmap_parloop_struct_338541.free_mem_315164 = mem_315164.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338542_task;
    
    futhark_mc_segmap_parloop_338542_task.name =
        "futhark_mc_segmap_parloop_338542";
    futhark_mc_segmap_parloop_338542_task.fn = futhark_mc_segmap_parloop_338542;
    futhark_mc_segmap_parloop_338542_task.args =
        &futhark_mc_segmap_parloop_struct_338541;
    futhark_mc_segmap_parloop_338542_task.iterations = iterations;
    futhark_mc_segmap_parloop_338542_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338542_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338542_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338542_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338542_task);
    
    if (futhark_mc_segmap_parloop_338542_err != 0) {
        err = futhark_mc_segmap_parloop_338542_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338542_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338542_total_end -
                 futhark_mc_segmap_parloop_338542_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338542_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338542_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338542_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_338540_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_338540_end -
                 futhark_mc_segmap_task_338540_start;
        
        ctx->futhark_mc_segmap_task_338540_runs[tid]++;
        ctx->futhark_mc_segmap_task_338540_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_338540_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_segmap_parloop_struct_338545 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_l_292680;
    int64_t free_jump_t_292685;
    int64_t free_l_n_m_292832;
    int64_t free_i_292846;
    int64_t free_gtid_305817;
    unsigned char *free_mem_313081;
    unsigned char *free_mem_313085;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315021;
    int64_t free_bytes_315145;
    unsigned char *free_mem_315164;
};
struct futhark_mc_task_338548 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_305817;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    int64_t free_x_329847;
    double free_x_329848;
    int64_t free_defunc_0_g_res_329851;
    double *retval_defunc_2_reduce_res_329853;
    unsigned char *retval_mem_329852;
};
struct futhark_mc_segred_stage_1_parloop_struct_338551 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_305817;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    int64_t free_x_329847;
    double free_x_329848;
    int64_t free_defunc_0_g_res_329851;
    unsigned char *free_mem_329852;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_330017;
};
static int futhark_mc_segred_stage_1_parloop_338552(void *args, int64_t start,
                                                    int64_t end,
                                                    int flat_tid_329980,
                                                    int tid)
{
    int err = 0;
    struct futhark_mc_segred_stage_1_parloop_struct_338551
    *futhark_mc_segred_stage_1_parloop_struct_338551 =
    (struct futhark_mc_segred_stage_1_parloop_struct_338551 *) args;
    struct futhark_context *ctx =
                           futhark_mc_segred_stage_1_parloop_struct_338551->ctx;
    uint64_t futhark_mc_segred_stage_1_parloop_338552_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_338552_start = get_wall_time();
    
    int64_t n_292675 =
            futhark_mc_segred_stage_1_parloop_struct_338551->free_n_292675;
    int64_t gtid_305817 =
            futhark_mc_segred_stage_1_parloop_struct_338551->free_gtid_305817;
    int64_t ctx_param_ext_313174 =
            futhark_mc_segred_stage_1_parloop_struct_338551->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_segred_stage_1_parloop_struct_338551->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_segred_stage_1_parloop_struct_338551->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_segred_stage_1_parloop_struct_338551->free_mem_param_313179,
                                        .size =0, .references =NULL};
    int64_t x_329847 =
            futhark_mc_segred_stage_1_parloop_struct_338551->free_x_329847;
    double x_329848 =
           futhark_mc_segred_stage_1_parloop_struct_338551->free_x_329848;
    int64_t defunc_0_g_res_329851 =
            futhark_mc_segred_stage_1_parloop_struct_338551->free_defunc_0_g_res_329851;
    struct memblock mem_329852 = {.desc ="mem_329852", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_338551->free_mem_329852,
                                  .size =0, .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_330017 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_330017",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338551->free_reduce_stage_1_tid_res_arr_mem_330017,
                                                             .size =0,
                                                             .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_330019 = start;
    double x_329982;
    double x_329983;
    double local_acc_330020 = 0.0;
    
    for (; iter_330019 < end; iter_330019++) {
        int64_t gtid_329981 = iter_330019;
        bool cond_329985 = sle64(n_292675, gtid_329981);
        int64_t defunc_0_f_res_329986;
        
        if (cond_329985) {
            defunc_0_f_res_329986 = (int64_t) 0;
        } else {
            int64_t i_329987 = add64(x_329847, gtid_329981);
            int64_t defunc_1_add_res_329988 = add64((int64_t) 1, i_329987);
            
            defunc_0_f_res_329986 = defunc_1_add_res_329988;
        }
        
        double defunc_0_f_res_329989;
        
        if (cond_329985) {
            defunc_0_f_res_329989 = 0.0;
        } else {
            int64_t i_329990 = add64(x_329847, gtid_329981);
            double defunc_0_add_arg_329991;
            
            defunc_0_add_arg_329991 =
                ((double *) mem_param_313179.mem)[ctx_param_ext_313174 +
                                                  (gtid_305817 *
                                                   ctx_param_ext_313175 +
                                                   i_329990 *
                                                   ctx_param_ext_313177)];
            defunc_0_f_res_329989 = defunc_0_add_arg_329991;
        }
        
        int64_t binop_p_329992 = sub64(defunc_0_f_res_329986,
                                       defunc_0_g_res_329851);
        double defunc_0_f_res_329993 = sitofp_i64_f64(binop_p_329992);
        double abs_res_329994 = fabs(defunc_0_f_res_329993);
        double tmp1_329995 = abs_res_329994 / x_329848;
        double x_329996 = tmp1_329995 * tmp1_329995;
        double y_329997 = tmp1_329995 * x_329996;
        double tmp2_329998 = 1.0 - y_329997;
        double x_329999 = tmp2_329998 * tmp2_329998;
        double tmp3_330000 = tmp2_329998 * x_329999;
        double tmp4_330001 = defunc_0_f_res_329989 * tmp3_330000;
        
        // save map-out results
        {
            ((double *) mem_329852.mem)[gtid_329981] = tmp4_330001;
        }
        // Load accum params
        {
            x_329982 = local_acc_330020;
        }
        // Load next params
        {
            x_329983 = tmp4_330001;
        }
        // Red body
        {
            double defunc_1_op_res_329984 = x_329982 + x_329983;
            
            local_acc_330020 = defunc_1_op_res_329984;
        }
    }
    ((double *) reduce_stage_1_tid_res_arr_mem_330017.mem)[flat_tid_329980] =
        local_acc_330020;
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_338552_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_338552_end -
                 futhark_mc_segred_stage_1_parloop_338552_start;
        
        ctx->futhark_mc_segred_stage_1_parloop_338552_runs[tid]++;
        ctx->futhark_mc_segred_stage_1_parloop_338552_total_runtime[tid] +=
            elapsed;
        ctx->futhark_mc_segred_stage_1_parloop_338552_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segred_task_338549(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_329980 = tid;
    int num_tasks_330016 = info.nsubtasks;
    struct futhark_mc_task_338548 *futhark_mc_task_338548 =
                                  (struct futhark_mc_task_338548 *) args;
    struct futhark_context *ctx = futhark_mc_task_338548->ctx;
    uint64_t futhark_mc_segred_task_338549_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_task_338549_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338548->free_n_292675;
    int64_t gtid_305817 = futhark_mc_task_338548->free_gtid_305817;
    int64_t ctx_param_ext_313174 =
            futhark_mc_task_338548->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_task_338548->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_task_338548->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_task_338548->free_mem_param_313179,
                                        .size =0, .references =NULL};
    int64_t x_329847 = futhark_mc_task_338548->free_x_329847;
    double x_329848 = futhark_mc_task_338548->free_x_329848;
    int64_t defunc_0_g_res_329851 =
            futhark_mc_task_338548->free_defunc_0_g_res_329851;
    double defunc_2_reduce_res_329853 =
           *futhark_mc_task_338548->retval_defunc_2_reduce_res_329853;
    struct memblock mem_329852 = {.desc ="mem_329852", .mem =
                                  futhark_mc_task_338548->retval_mem_329852,
                                  .size =0, .references =NULL};
    size_t reduce_stage_1_tid_res_arr_mem_330017_cached_sizze_338550 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_330017 = NULL;
    
    if (reduce_stage_1_tid_res_arr_mem_330017_cached_sizze_338550 <
        (size_t) ((int64_t) 8 * num_tasks_330016)) {
        reduce_stage_1_tid_res_arr_mem_330017 =
            realloc(reduce_stage_1_tid_res_arr_mem_330017, (int64_t) 8 *
                    num_tasks_330016);
        reduce_stage_1_tid_res_arr_mem_330017_cached_sizze_338550 =
            (int64_t) 8 * num_tasks_330016;
    }
    
    int64_t iter_330019;
    struct futhark_mc_segred_stage_1_parloop_struct_338551
    futhark_mc_segred_stage_1_parloop_struct_338551;
    
    futhark_mc_segred_stage_1_parloop_struct_338551.ctx = ctx;
    futhark_mc_segred_stage_1_parloop_struct_338551.free_n_292675 = n_292675;
    futhark_mc_segred_stage_1_parloop_struct_338551.free_gtid_305817 =
        gtid_305817;
    futhark_mc_segred_stage_1_parloop_struct_338551.free_ctx_param_ext_313174 =
        ctx_param_ext_313174;
    futhark_mc_segred_stage_1_parloop_struct_338551.free_ctx_param_ext_313175 =
        ctx_param_ext_313175;
    futhark_mc_segred_stage_1_parloop_struct_338551.free_ctx_param_ext_313177 =
        ctx_param_ext_313177;
    futhark_mc_segred_stage_1_parloop_struct_338551.free_mem_param_313179 =
        mem_param_313179.mem;
    futhark_mc_segred_stage_1_parloop_struct_338551.free_x_329847 = x_329847;
    futhark_mc_segred_stage_1_parloop_struct_338551.free_x_329848 = x_329848;
    futhark_mc_segred_stage_1_parloop_struct_338551.free_defunc_0_g_res_329851 =
        defunc_0_g_res_329851;
    futhark_mc_segred_stage_1_parloop_struct_338551.free_mem_329852 =
        mem_329852.mem;
    futhark_mc_segred_stage_1_parloop_struct_338551.free_reduce_stage_1_tid_res_arr_mem_330017 =
        reduce_stage_1_tid_res_arr_mem_330017;
    
    struct scheduler_parloop futhark_mc_segred_stage_1_parloop_338552_task;
    
    futhark_mc_segred_stage_1_parloop_338552_task.name =
        "futhark_mc_segred_stage_1_parloop_338552";
    futhark_mc_segred_stage_1_parloop_338552_task.fn =
        futhark_mc_segred_stage_1_parloop_338552;
    futhark_mc_segred_stage_1_parloop_338552_task.args =
        &futhark_mc_segred_stage_1_parloop_struct_338551;
    futhark_mc_segred_stage_1_parloop_338552_task.iterations = iterations;
    futhark_mc_segred_stage_1_parloop_338552_task.info = info;
    
    uint64_t futhark_mc_segred_stage_1_parloop_338552_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_338552_total_start = get_wall_time();
    
    int futhark_mc_segred_stage_1_parloop_338552_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segred_stage_1_parloop_338552_task);
    
    if (futhark_mc_segred_stage_1_parloop_338552_err != 0) {
        err = futhark_mc_segred_stage_1_parloop_338552_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_338552_total_end =
                 get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_338552_total_end -
                 futhark_mc_segred_stage_1_parloop_338552_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338552_total_runs,
                           1, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338552_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338552_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    // neutral-initialise the output
    {
        defunc_2_reduce_res_329853 = 0.0;
    }
    
    double x_330021;
    double x_330022;
    
    for (int32_t i_330024 = 0; i_330024 < num_tasks_330016; i_330024++) {
        flat_tid_329980 = i_330024;
        // Apply main thread reduction
        {
            // load acc params
            {
                x_330021 = defunc_2_reduce_res_329853;
            }
            // load next params
            {
                x_330022 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_330017)[flat_tid_329980];
            }
            // red body
            {
                double defunc_1_op_res_330023 = x_330021 + x_330022;
                
                defunc_2_reduce_res_329853 = defunc_1_op_res_330023;
            }
        }
    }
    
  cleanup:
    {
        free(reduce_stage_1_tid_res_arr_mem_330017);
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_task_338549_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_task_338549_end -
                 futhark_mc_segred_task_338549_start;
        
        ctx->futhark_mc_segred_task_338549_runs[tid]++;
        ctx->futhark_mc_segred_task_338549_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segred_task_338549_iter[tid] += iterations;
    }
    if (err == 0) {
        *futhark_mc_task_338548->retval_defunc_2_reduce_res_329853 =
            defunc_2_reduce_res_329853;
        futhark_mc_task_338548->retval_mem_329852 = mem_329852.mem;
    }
    return err;
}
struct futhark_mc_task_338553 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_305817;
    unsigned char *free_mem_315021;
    int64_t free_x_329847;
    unsigned char *free_mem_329852;
    double free_a0_329878;
    double *retval_defunc_2_reduce_res_329879;
};
struct futhark_mc_segred_stage_1_parloop_struct_338556 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_305817;
    unsigned char *free_mem_315021;
    int64_t free_x_329847;
    unsigned char *free_mem_329852;
    double free_a0_329878;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_330026;
};
static int futhark_mc_segred_stage_1_parloop_338557(void *args, int64_t start,
                                                    int64_t end,
                                                    int flat_tid_330002,
                                                    int tid)
{
    int err = 0;
    struct futhark_mc_segred_stage_1_parloop_struct_338556
    *futhark_mc_segred_stage_1_parloop_struct_338556 =
    (struct futhark_mc_segred_stage_1_parloop_struct_338556 *) args;
    struct futhark_context *ctx =
                           futhark_mc_segred_stage_1_parloop_struct_338556->ctx;
    uint64_t futhark_mc_segred_stage_1_parloop_338557_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_338557_start = get_wall_time();
    
    int64_t n_292675 =
            futhark_mc_segred_stage_1_parloop_struct_338556->free_n_292675;
    int64_t gtid_305817 =
            futhark_mc_segred_stage_1_parloop_struct_338556->free_gtid_305817;
    struct memblock mem_315021 = {.desc ="mem_315021", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_338556->free_mem_315021,
                                  .size =0, .references =NULL};
    int64_t x_329847 =
            futhark_mc_segred_stage_1_parloop_struct_338556->free_x_329847;
    struct memblock mem_329852 = {.desc ="mem_329852", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_338556->free_mem_329852,
                                  .size =0, .references =NULL};
    double a0_329878 =
           futhark_mc_segred_stage_1_parloop_struct_338556->free_a0_329878;
    struct memblock reduce_stage_1_tid_res_arr_mem_330026 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_330026",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338556->free_reduce_stage_1_tid_res_arr_mem_330026,
                                                             .size =0,
                                                             .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_330028 = start;
    double x_330004;
    double x_330005;
    double local_acc_330029 = 0.0;
    
    for (; iter_330028 < end; iter_330028++) {
        int64_t gtid_330003 = iter_330028;
        double x_330007;
        
        x_330007 = ((double *) mem_329852.mem)[gtid_330003];
        
        bool cond_330008 = sle64(n_292675, gtid_330003);
        double defunc_0_f_res_330009;
        
        if (cond_330008) {
            defunc_0_f_res_330009 = 0.0;
        } else {
            int64_t i_330010 = add64(x_329847, gtid_330003);
            double defunc_0_add_arg_330011;
            
            defunc_0_add_arg_330011 = ((double *) mem_315021.mem)[gtid_305817 *
                                                                  n_292675 +
                                                                  i_330010];
            defunc_0_f_res_330009 = defunc_0_add_arg_330011;
        }
        
        double x_330012 = a0_329878 * x_330007;
        double defunc_9_fit_fun_res_330013 = defunc_0_f_res_330009 * x_330012;
        
        // save map-out results
        { }
        // Load accum params
        {
            x_330004 = local_acc_330029;
        }
        // Load next params
        {
            x_330005 = defunc_9_fit_fun_res_330013;
        }
        // Red body
        {
            double defunc_1_op_res_330006 = x_330004 + x_330005;
            
            local_acc_330029 = defunc_1_op_res_330006;
        }
    }
    ((double *) reduce_stage_1_tid_res_arr_mem_330026.mem)[flat_tid_330002] =
        local_acc_330029;
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_338557_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_338557_end -
                 futhark_mc_segred_stage_1_parloop_338557_start;
        
        ctx->futhark_mc_segred_stage_1_parloop_338557_runs[tid]++;
        ctx->futhark_mc_segred_stage_1_parloop_338557_total_runtime[tid] +=
            elapsed;
        ctx->futhark_mc_segred_stage_1_parloop_338557_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segred_task_338554(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_330002 = tid;
    int num_tasks_330025 = info.nsubtasks;
    struct futhark_mc_task_338553 *futhark_mc_task_338553 =
                                  (struct futhark_mc_task_338553 *) args;
    struct futhark_context *ctx = futhark_mc_task_338553->ctx;
    uint64_t futhark_mc_segred_task_338554_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_task_338554_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338553->free_n_292675;
    int64_t gtid_305817 = futhark_mc_task_338553->free_gtid_305817;
    struct memblock mem_315021 = {.desc ="mem_315021", .mem =
                                  futhark_mc_task_338553->free_mem_315021,
                                  .size =0, .references =NULL};
    int64_t x_329847 = futhark_mc_task_338553->free_x_329847;
    struct memblock mem_329852 = {.desc ="mem_329852", .mem =
                                  futhark_mc_task_338553->free_mem_329852,
                                  .size =0, .references =NULL};
    double a0_329878 = futhark_mc_task_338553->free_a0_329878;
    double defunc_2_reduce_res_329879 =
           *futhark_mc_task_338553->retval_defunc_2_reduce_res_329879;
    size_t reduce_stage_1_tid_res_arr_mem_330026_cached_sizze_338555 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_330026 = NULL;
    
    if (reduce_stage_1_tid_res_arr_mem_330026_cached_sizze_338555 <
        (size_t) ((int64_t) 8 * num_tasks_330025)) {
        reduce_stage_1_tid_res_arr_mem_330026 =
            realloc(reduce_stage_1_tid_res_arr_mem_330026, (int64_t) 8 *
                    num_tasks_330025);
        reduce_stage_1_tid_res_arr_mem_330026_cached_sizze_338555 =
            (int64_t) 8 * num_tasks_330025;
    }
    
    int64_t iter_330028;
    struct futhark_mc_segred_stage_1_parloop_struct_338556
    futhark_mc_segred_stage_1_parloop_struct_338556;
    
    futhark_mc_segred_stage_1_parloop_struct_338556.ctx = ctx;
    futhark_mc_segred_stage_1_parloop_struct_338556.free_n_292675 = n_292675;
    futhark_mc_segred_stage_1_parloop_struct_338556.free_gtid_305817 =
        gtid_305817;
    futhark_mc_segred_stage_1_parloop_struct_338556.free_mem_315021 =
        mem_315021.mem;
    futhark_mc_segred_stage_1_parloop_struct_338556.free_x_329847 = x_329847;
    futhark_mc_segred_stage_1_parloop_struct_338556.free_mem_329852 =
        mem_329852.mem;
    futhark_mc_segred_stage_1_parloop_struct_338556.free_a0_329878 = a0_329878;
    futhark_mc_segred_stage_1_parloop_struct_338556.free_reduce_stage_1_tid_res_arr_mem_330026 =
        reduce_stage_1_tid_res_arr_mem_330026;
    
    struct scheduler_parloop futhark_mc_segred_stage_1_parloop_338557_task;
    
    futhark_mc_segred_stage_1_parloop_338557_task.name =
        "futhark_mc_segred_stage_1_parloop_338557";
    futhark_mc_segred_stage_1_parloop_338557_task.fn =
        futhark_mc_segred_stage_1_parloop_338557;
    futhark_mc_segred_stage_1_parloop_338557_task.args =
        &futhark_mc_segred_stage_1_parloop_struct_338556;
    futhark_mc_segred_stage_1_parloop_338557_task.iterations = iterations;
    futhark_mc_segred_stage_1_parloop_338557_task.info = info;
    
    uint64_t futhark_mc_segred_stage_1_parloop_338557_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_338557_total_start = get_wall_time();
    
    int futhark_mc_segred_stage_1_parloop_338557_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segred_stage_1_parloop_338557_task);
    
    if (futhark_mc_segred_stage_1_parloop_338557_err != 0) {
        err = futhark_mc_segred_stage_1_parloop_338557_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_338557_total_end =
                 get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_338557_total_end -
                 futhark_mc_segred_stage_1_parloop_338557_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338557_total_runs,
                           1, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338557_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338557_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    // neutral-initialise the output
    {
        defunc_2_reduce_res_329879 = 0.0;
    }
    
    double x_330030;
    double x_330031;
    
    for (int32_t i_330033 = 0; i_330033 < num_tasks_330025; i_330033++) {
        flat_tid_330002 = i_330033;
        // Apply main thread reduction
        {
            // load acc params
            {
                x_330030 = defunc_2_reduce_res_329879;
            }
            // load next params
            {
                x_330031 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_330026)[flat_tid_330002];
            }
            // red body
            {
                double defunc_1_op_res_330032 = x_330030 + x_330031;
                
                defunc_2_reduce_res_329879 = defunc_1_op_res_330032;
            }
        }
    }
    
  cleanup:
    {
        free(reduce_stage_1_tid_res_arr_mem_330026);
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_task_338554_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_task_338554_end -
                 futhark_mc_segred_task_338554_start;
        
        ctx->futhark_mc_segred_task_338554_runs[tid]++;
        ctx->futhark_mc_segred_task_338554_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segred_task_338554_iter[tid] += iterations;
    }
    if (err == 0) {
        *futhark_mc_task_338553->retval_defunc_2_reduce_res_329879 =
            defunc_2_reduce_res_329879;
    }
    return err;
}
static int futhark_mc_segmap_parloop_338546(void *args, int64_t start,
                                            int64_t end, int flat_tid_329845,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338545
    *futhark_mc_segmap_parloop_struct_338545 =
    (struct futhark_mc_segmap_parloop_struct_338545 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338545->ctx;
    uint64_t futhark_mc_segmap_parloop_338546_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338546_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_338545->free_n_292675;
    int64_t q_l_292680 =
            futhark_mc_segmap_parloop_struct_338545->free_q_l_292680;
    int64_t jump_t_292685 =
            futhark_mc_segmap_parloop_struct_338545->free_jump_t_292685;
    int64_t l_n_m_292832 =
            futhark_mc_segmap_parloop_struct_338545->free_l_n_m_292832;
    int64_t i_292846 = futhark_mc_segmap_parloop_struct_338545->free_i_292846;
    int64_t gtid_305817 =
            futhark_mc_segmap_parloop_struct_338545->free_gtid_305817;
    struct memblock mem_313081 = {.desc ="mem_313081", .mem =
                                  futhark_mc_segmap_parloop_struct_338545->free_mem_313081,
                                  .size =0, .references =NULL};
    struct memblock mem_313085 = {.desc ="mem_313085", .mem =
                                  futhark_mc_segmap_parloop_struct_338545->free_mem_313085,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_segmap_parloop_struct_338545->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_segmap_parloop_struct_338545->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_segmap_parloop_struct_338545->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_segmap_parloop_struct_338545->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315021 = {.desc ="mem_315021", .mem =
                                  futhark_mc_segmap_parloop_struct_338545->free_mem_315021,
                                  .size =0, .references =NULL};
    int64_t bytes_315145 =
            futhark_mc_segmap_parloop_struct_338545->free_bytes_315145;
    struct memblock mem_315164 = {.desc ="mem_315164", .mem =
                                  futhark_mc_segmap_parloop_struct_338545->free_mem_315164,
                                  .size =0, .references =NULL};
    size_t mem_329852_cached_sizze_338547 = 0;
    unsigned char *mem_329852 = NULL;
    int64_t iterations = end - start;
    int64_t iter_329979 = start;
    
    if (mem_329852_cached_sizze_338547 < (size_t) bytes_315145) {
        mem_329852 = realloc(mem_329852, bytes_315145);
        mem_329852_cached_sizze_338547 = bytes_315145;
    }
    for (; iter_329979 < end; iter_329979++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_330014 = l_n_m_292832;
        int64_t gtid_329846 = iter_329979;
        int64_t remnant_330015 = iter_329979 - gtid_329846;
        int64_t x_329847;
        
        x_329847 = ((int64_t *) mem_313081.mem)[gtid_305817 * l_n_m_292832 +
                                                gtid_329846];
        
        double x_329848;
        
        x_329848 = ((double *) mem_313085.mem)[gtid_305817 * l_n_m_292832 +
                                               gtid_329846];
        
        int64_t min_arg_329849 = mul64(jump_t_292685, gtid_329846);
        int64_t min_res_329850 = smin64(i_292846, min_arg_329849);
        int64_t defunc_0_g_res_329851 = add64((int64_t) 1, min_res_329850);
        double defunc_2_reduce_res_329853;
        int64_t flat_tid_329980 = (int64_t) 0;
        int32_t num_tasks_330016;
        
        defunc_2_reduce_res_329853 = 0.0;
        
        struct futhark_mc_task_338548 futhark_mc_task_338548;
        
        futhark_mc_task_338548.ctx = ctx;
        futhark_mc_task_338548.free_n_292675 = n_292675;
        futhark_mc_task_338548.free_gtid_305817 = gtid_305817;
        futhark_mc_task_338548.free_ctx_param_ext_313174 = ctx_param_ext_313174;
        futhark_mc_task_338548.free_ctx_param_ext_313175 = ctx_param_ext_313175;
        futhark_mc_task_338548.free_ctx_param_ext_313177 = ctx_param_ext_313177;
        futhark_mc_task_338548.free_mem_param_313179 = mem_param_313179.mem;
        futhark_mc_task_338548.free_x_329847 = x_329847;
        futhark_mc_task_338548.free_x_329848 = x_329848;
        futhark_mc_task_338548.free_defunc_0_g_res_329851 =
            defunc_0_g_res_329851;
        futhark_mc_task_338548.retval_defunc_2_reduce_res_329853 =
            &defunc_2_reduce_res_329853;
        futhark_mc_task_338548.retval_mem_329852 = mem_329852;
        
        struct scheduler_segop futhark_mc_task_338548_task;
        
        futhark_mc_task_338548_task.args = &futhark_mc_task_338548;
        futhark_mc_task_338548_task.top_level_fn =
            futhark_mc_segred_task_338549;
        futhark_mc_task_338548_task.name = "futhark_mc_segred_task_338549";
        futhark_mc_task_338548_task.iterations = q_l_292680;
        futhark_mc_task_338548_task.task_time =
            &ctx->futhark_mc_segred_task_338549_total_time;
        futhark_mc_task_338548_task.task_iter =
            &ctx->futhark_mc_segred_task_338549_total_iter;
        futhark_mc_task_338548_task.sched = STATIC;
        futhark_mc_task_338548_task.nested_fn = NULL;
        
        int futhark_mc_segred_task_338549_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_338548_task);
        
        if (futhark_mc_segred_task_338549_err != 0) {
            ;
            err = futhark_mc_segred_task_338549_err;
            goto cleanup;
        }
        
        double a_329877 = 2.220446049250313e-16 + defunc_2_reduce_res_329853;
        double a0_329878 = 1.0 / a_329877;
        double defunc_2_reduce_res_329879;
        int64_t flat_tid_330002 = (int64_t) 0;
        int32_t num_tasks_330025;
        
        defunc_2_reduce_res_329879 = 0.0;
        
        struct futhark_mc_task_338553 futhark_mc_task_338553;
        
        futhark_mc_task_338553.ctx = ctx;
        futhark_mc_task_338553.free_n_292675 = n_292675;
        futhark_mc_task_338553.free_gtid_305817 = gtid_305817;
        futhark_mc_task_338553.free_mem_315021 = mem_315021.mem;
        futhark_mc_task_338553.free_x_329847 = x_329847;
        futhark_mc_task_338553.free_mem_329852 = mem_329852;
        futhark_mc_task_338553.free_a0_329878 = a0_329878;
        futhark_mc_task_338553.retval_defunc_2_reduce_res_329879 =
            &defunc_2_reduce_res_329879;
        
        struct scheduler_segop futhark_mc_task_338553_task;
        
        futhark_mc_task_338553_task.args = &futhark_mc_task_338553;
        futhark_mc_task_338553_task.top_level_fn =
            futhark_mc_segred_task_338554;
        futhark_mc_task_338553_task.name = "futhark_mc_segred_task_338554";
        futhark_mc_task_338553_task.iterations = q_l_292680;
        futhark_mc_task_338553_task.task_time =
            &ctx->futhark_mc_segred_task_338554_total_time;
        futhark_mc_task_338553_task.task_iter =
            &ctx->futhark_mc_segred_task_338554_total_iter;
        futhark_mc_task_338553_task.sched = STATIC;
        futhark_mc_task_338553_task.nested_fn = NULL;
        
        int futhark_mc_segred_task_338554_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_338553_task);
        
        if (futhark_mc_segred_task_338554_err != 0) {
            ;
            err = futhark_mc_segred_task_338554_err;
            goto cleanup;
        }
        ((double *) mem_315164.mem)[gtid_329846] = defunc_2_reduce_res_329879;
    }
    
  cleanup:
    { }
    free(mem_329852);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338546_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338546_end -
                 futhark_mc_segmap_parloop_338546_start;
        
        ctx->futhark_mc_segmap_parloop_338546_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338546_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338546_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_nested_task_338544(void *args, int64_t iterations,
                                         int tid, struct scheduler_info info)
{
    int err = 0;
    int flat_tid_329845 = tid;
    int num_tasks_329940 = info.nsubtasks;
    struct futhark_mc_task_338539 *futhark_mc_task_338539 =
                                  (struct futhark_mc_task_338539 *) args;
    struct futhark_context *ctx = futhark_mc_task_338539->ctx;
    uint64_t futhark_mc_segmap_nested_task_338544_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_nested_task_338544_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338539->free_n_292675;
    int64_t q_l_292680 = futhark_mc_task_338539->free_q_l_292680;
    int64_t jump_t_292685 = futhark_mc_task_338539->free_jump_t_292685;
    int64_t l_n_m_292832 = futhark_mc_task_338539->free_l_n_m_292832;
    int64_t i_292846 = futhark_mc_task_338539->free_i_292846;
    int64_t gtid_305817 = futhark_mc_task_338539->free_gtid_305817;
    struct memblock mem_313081 = {.desc ="mem_313081", .mem =
                                  futhark_mc_task_338539->free_mem_313081,
                                  .size =0, .references =NULL};
    struct memblock mem_313085 = {.desc ="mem_313085", .mem =
                                  futhark_mc_task_338539->free_mem_313085,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_task_338539->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_task_338539->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_task_338539->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_task_338539->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315021 = {.desc ="mem_315021", .mem =
                                  futhark_mc_task_338539->free_mem_315021,
                                  .size =0, .references =NULL};
    int64_t bytes_315145 = futhark_mc_task_338539->free_bytes_315145;
    struct memblock mem_315164 = {.desc ="mem_315164", .mem =
                                  futhark_mc_task_338539->free_mem_315164,
                                  .size =0, .references =NULL};
    int64_t iter_329979;
    struct futhark_mc_segmap_parloop_struct_338545
    futhark_mc_segmap_parloop_struct_338545;
    
    futhark_mc_segmap_parloop_struct_338545.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338545.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_338545.free_q_l_292680 = q_l_292680;
    futhark_mc_segmap_parloop_struct_338545.free_jump_t_292685 = jump_t_292685;
    futhark_mc_segmap_parloop_struct_338545.free_l_n_m_292832 = l_n_m_292832;
    futhark_mc_segmap_parloop_struct_338545.free_i_292846 = i_292846;
    futhark_mc_segmap_parloop_struct_338545.free_gtid_305817 = gtid_305817;
    futhark_mc_segmap_parloop_struct_338545.free_mem_313081 = mem_313081.mem;
    futhark_mc_segmap_parloop_struct_338545.free_mem_313085 = mem_313085.mem;
    futhark_mc_segmap_parloop_struct_338545.free_ctx_param_ext_313174 =
        ctx_param_ext_313174;
    futhark_mc_segmap_parloop_struct_338545.free_ctx_param_ext_313175 =
        ctx_param_ext_313175;
    futhark_mc_segmap_parloop_struct_338545.free_ctx_param_ext_313177 =
        ctx_param_ext_313177;
    futhark_mc_segmap_parloop_struct_338545.free_mem_param_313179 =
        mem_param_313179.mem;
    futhark_mc_segmap_parloop_struct_338545.free_mem_315021 = mem_315021.mem;
    futhark_mc_segmap_parloop_struct_338545.free_bytes_315145 = bytes_315145;
    futhark_mc_segmap_parloop_struct_338545.free_mem_315164 = mem_315164.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338546_task;
    
    futhark_mc_segmap_parloop_338546_task.name =
        "futhark_mc_segmap_parloop_338546";
    futhark_mc_segmap_parloop_338546_task.fn = futhark_mc_segmap_parloop_338546;
    futhark_mc_segmap_parloop_338546_task.args =
        &futhark_mc_segmap_parloop_struct_338545;
    futhark_mc_segmap_parloop_338546_task.iterations = iterations;
    futhark_mc_segmap_parloop_338546_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338546_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338546_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338546_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338546_task);
    
    if (futhark_mc_segmap_parloop_338546_err != 0) {
        err = futhark_mc_segmap_parloop_338546_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338546_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338546_total_end -
                 futhark_mc_segmap_parloop_338546_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338546_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338546_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338546_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_nested_task_338544_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_nested_task_338544_end -
                 futhark_mc_segmap_nested_task_338544_start;
        
        ctx->futhark_mc_segmap_nested_task_338544_runs[tid]++;
        ctx->futhark_mc_segmap_nested_task_338544_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_nested_task_338544_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
static int futhark_mc_segmap_parloop_338537(void *args, int64_t start,
                                            int64_t end, int flat_tid_305816,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338536
    *futhark_mc_segmap_parloop_struct_338536 =
    (struct futhark_mc_segmap_parloop_struct_338536 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338536->ctx;
    uint64_t futhark_mc_segmap_parloop_338537_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338537_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_338536->free_n_292675;
    int64_t q_l_292680 =
            futhark_mc_segmap_parloop_struct_338536->free_q_l_292680;
    int64_t jump_t_292685 =
            futhark_mc_segmap_parloop_struct_338536->free_jump_t_292685;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_338536->free_partition_sizze_292766;
    int64_t l_n_m_292832 =
            futhark_mc_segmap_parloop_struct_338536->free_l_n_m_292832;
    int64_t i_292846 = futhark_mc_segmap_parloop_struct_338536->free_i_292846;
    int64_t bytes_313028 =
            futhark_mc_segmap_parloop_struct_338536->free_bytes_313028;
    struct memblock mem_313081 = {.desc ="mem_313081", .mem =
                                  futhark_mc_segmap_parloop_struct_338536->free_mem_313081,
                                  .size =0, .references =NULL};
    struct memblock mem_313085 = {.desc ="mem_313085", .mem =
                                  futhark_mc_segmap_parloop_struct_338536->free_mem_313085,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_segmap_parloop_struct_338536->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_segmap_parloop_struct_338536->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_segmap_parloop_struct_338536->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_segmap_parloop_struct_338536->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315021 = {.desc ="mem_315021", .mem =
                                  futhark_mc_segmap_parloop_struct_338536->free_mem_315021,
                                  .size =0, .references =NULL};
    int64_t bytes_315145 =
            futhark_mc_segmap_parloop_struct_338536->free_bytes_315145;
    struct memblock mem_315198 = {.desc ="mem_315198", .mem =
                                  futhark_mc_segmap_parloop_struct_338536->free_mem_315198,
                                  .size =0, .references =NULL};
    size_t mem_315164_cached_sizze_338538 = 0;
    unsigned char *mem_315164 = NULL;
    int64_t iterations = end - start;
    int64_t iter_329844 = start;
    
    if (mem_315164_cached_sizze_338538 < (size_t) bytes_313028) {
        mem_315164 = realloc(mem_315164, bytes_313028);
        mem_315164_cached_sizze_338538 = bytes_313028;
    }
    for (; iter_329844 < end; iter_329844++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_329938 = partition_sizze_292766;
        int64_t gtid_305817 = iter_329844;
        int64_t remnant_329939 = iter_329844 - gtid_305817;
        int64_t flat_tid_329892 = (int64_t) 0;
        int32_t num_tasks_329940;
        int64_t flat_tid_329845 = (int64_t) 0;
        struct futhark_mc_task_338539 futhark_mc_task_338539;
        
        futhark_mc_task_338539.ctx = ctx;
        futhark_mc_task_338539.free_n_292675 = n_292675;
        futhark_mc_task_338539.free_q_l_292680 = q_l_292680;
        futhark_mc_task_338539.free_jump_t_292685 = jump_t_292685;
        futhark_mc_task_338539.free_l_n_m_292832 = l_n_m_292832;
        futhark_mc_task_338539.free_i_292846 = i_292846;
        futhark_mc_task_338539.free_gtid_305817 = gtid_305817;
        futhark_mc_task_338539.free_mem_313081 = mem_313081.mem;
        futhark_mc_task_338539.free_mem_313085 = mem_313085.mem;
        futhark_mc_task_338539.free_ctx_param_ext_313174 = ctx_param_ext_313174;
        futhark_mc_task_338539.free_ctx_param_ext_313175 = ctx_param_ext_313175;
        futhark_mc_task_338539.free_ctx_param_ext_313177 = ctx_param_ext_313177;
        futhark_mc_task_338539.free_mem_param_313179 = mem_param_313179.mem;
        futhark_mc_task_338539.free_mem_315021 = mem_315021.mem;
        futhark_mc_task_338539.free_bytes_315145 = bytes_315145;
        futhark_mc_task_338539.free_mem_315164 = mem_315164;
        
        struct scheduler_segop futhark_mc_task_338539_task;
        
        futhark_mc_task_338539_task.args = &futhark_mc_task_338539;
        futhark_mc_task_338539_task.top_level_fn =
            futhark_mc_segmap_task_338540;
        futhark_mc_task_338539_task.name = "futhark_mc_segmap_task_338540";
        futhark_mc_task_338539_task.iterations = l_n_m_292832;
        futhark_mc_task_338539_task.task_time =
            &ctx->futhark_mc_segmap_task_338540_total_time;
        futhark_mc_task_338539_task.task_iter =
            &ctx->futhark_mc_segmap_task_338540_total_iter;
        futhark_mc_task_338539_task.sched = STATIC;
        futhark_mc_task_338539_task.nested_fn =
            futhark_mc_segmap_nested_task_338544;
        
        int futhark_mc_segmap_task_338540_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_338539_task);
        
        if (futhark_mc_segmap_task_338540_err != 0) {
            ;
            err = futhark_mc_segmap_task_338540_err;
            goto cleanup;
        }
        if (l_n_m_292832 * (int64_t) 8 > 0)
            memmove(mem_315198.mem + gtid_305817 * l_n_m_292832 * (int64_t) 8,
                    mem_315164 + (int64_t) 0, l_n_m_292832 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_315164);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338537_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338537_end -
                 futhark_mc_segmap_parloop_338537_start;
        
        ctx->futhark_mc_segmap_parloop_338537_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338537_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338537_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_nested_task_338535(void *args, int64_t iterations,
                                         int tid, struct scheduler_info info)
{
    int err = 0;
    int flat_tid_305816 = tid;
    int num_tasks_329790 = info.nsubtasks;
    struct futhark_mc_task_338529 *futhark_mc_task_338529 =
                                  (struct futhark_mc_task_338529 *) args;
    struct futhark_context *ctx = futhark_mc_task_338529->ctx;
    uint64_t futhark_mc_segmap_nested_task_338535_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_nested_task_338535_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338529->free_n_292675;
    int64_t q_l_292680 = futhark_mc_task_338529->free_q_l_292680;
    int64_t jump_t_292685 = futhark_mc_task_338529->free_jump_t_292685;
    int64_t partition_sizze_292766 =
            futhark_mc_task_338529->free_partition_sizze_292766;
    int64_t l_n_m_292832 = futhark_mc_task_338529->free_l_n_m_292832;
    int64_t i_292846 = futhark_mc_task_338529->free_i_292846;
    int64_t bytes_313028 = futhark_mc_task_338529->free_bytes_313028;
    struct memblock mem_313081 = {.desc ="mem_313081", .mem =
                                  futhark_mc_task_338529->free_mem_313081,
                                  .size =0, .references =NULL};
    struct memblock mem_313085 = {.desc ="mem_313085", .mem =
                                  futhark_mc_task_338529->free_mem_313085,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_task_338529->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_task_338529->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_task_338529->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_task_338529->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315021 = {.desc ="mem_315021", .mem =
                                  futhark_mc_task_338529->free_mem_315021,
                                  .size =0, .references =NULL};
    int64_t bytes_315145 = futhark_mc_task_338529->free_bytes_315145;
    struct memblock mem_315198 = {.desc ="mem_315198", .mem =
                                  futhark_mc_task_338529->free_mem_315198,
                                  .size =0, .references =NULL};
    int64_t iter_329844;
    struct futhark_mc_segmap_parloop_struct_338536
    futhark_mc_segmap_parloop_struct_338536;
    
    futhark_mc_segmap_parloop_struct_338536.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338536.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_338536.free_q_l_292680 = q_l_292680;
    futhark_mc_segmap_parloop_struct_338536.free_jump_t_292685 = jump_t_292685;
    futhark_mc_segmap_parloop_struct_338536.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_338536.free_l_n_m_292832 = l_n_m_292832;
    futhark_mc_segmap_parloop_struct_338536.free_i_292846 = i_292846;
    futhark_mc_segmap_parloop_struct_338536.free_bytes_313028 = bytes_313028;
    futhark_mc_segmap_parloop_struct_338536.free_mem_313081 = mem_313081.mem;
    futhark_mc_segmap_parloop_struct_338536.free_mem_313085 = mem_313085.mem;
    futhark_mc_segmap_parloop_struct_338536.free_ctx_param_ext_313174 =
        ctx_param_ext_313174;
    futhark_mc_segmap_parloop_struct_338536.free_ctx_param_ext_313175 =
        ctx_param_ext_313175;
    futhark_mc_segmap_parloop_struct_338536.free_ctx_param_ext_313177 =
        ctx_param_ext_313177;
    futhark_mc_segmap_parloop_struct_338536.free_mem_param_313179 =
        mem_param_313179.mem;
    futhark_mc_segmap_parloop_struct_338536.free_mem_315021 = mem_315021.mem;
    futhark_mc_segmap_parloop_struct_338536.free_bytes_315145 = bytes_315145;
    futhark_mc_segmap_parloop_struct_338536.free_mem_315198 = mem_315198.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338537_task;
    
    futhark_mc_segmap_parloop_338537_task.name =
        "futhark_mc_segmap_parloop_338537";
    futhark_mc_segmap_parloop_338537_task.fn = futhark_mc_segmap_parloop_338537;
    futhark_mc_segmap_parloop_338537_task.args =
        &futhark_mc_segmap_parloop_struct_338536;
    futhark_mc_segmap_parloop_338537_task.iterations = iterations;
    futhark_mc_segmap_parloop_338537_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338537_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338537_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338537_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338537_task);
    
    if (futhark_mc_segmap_parloop_338537_err != 0) {
        err = futhark_mc_segmap_parloop_338537_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338537_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338537_total_end -
                 futhark_mc_segmap_parloop_338537_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338537_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338537_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338537_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_nested_task_338535_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_nested_task_338535_end -
                 futhark_mc_segmap_nested_task_338535_start;
        
        ctx->futhark_mc_segmap_nested_task_338535_runs[tid]++;
        ctx->futhark_mc_segmap_nested_task_338535_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_nested_task_338535_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_task_338558 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_l_292680;
    int64_t free_jump_t_292685;
    int64_t free_partition_sizze_292766;
    int64_t free_l_n_m_292832;
    int64_t free_i_292846;
    int64_t free_bytes_313028;
    unsigned char *free_mem_313081;
    unsigned char *free_mem_313085;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315021;
    int64_t free_bytes_315200;
    unsigned char *free_mem_315304;
    unsigned char *free_mem_315308;
};
struct futhark_mc_segmap_parloop_struct_338560 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_l_292680;
    int64_t free_jump_t_292685;
    int64_t free_partition_sizze_292766;
    int64_t free_l_n_m_292832;
    int64_t free_i_292846;
    int64_t free_bytes_313028;
    unsigned char *free_mem_313081;
    unsigned char *free_mem_313085;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315021;
    int64_t free_bytes_315200;
    unsigned char *free_mem_315304;
    unsigned char *free_mem_315308;
};
static int futhark_mc_segmap_parloop_338561(void *args, int64_t start,
                                            int64_t end, int flat_tid_305917,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338560
    *futhark_mc_segmap_parloop_struct_338560 =
    (struct futhark_mc_segmap_parloop_struct_338560 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338560->ctx;
    uint64_t futhark_mc_segmap_parloop_338561_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338561_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_338560->free_n_292675;
    int64_t q_l_292680 =
            futhark_mc_segmap_parloop_struct_338560->free_q_l_292680;
    int64_t jump_t_292685 =
            futhark_mc_segmap_parloop_struct_338560->free_jump_t_292685;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_338560->free_partition_sizze_292766;
    int64_t l_n_m_292832 =
            futhark_mc_segmap_parloop_struct_338560->free_l_n_m_292832;
    int64_t i_292846 = futhark_mc_segmap_parloop_struct_338560->free_i_292846;
    int64_t bytes_313028 =
            futhark_mc_segmap_parloop_struct_338560->free_bytes_313028;
    struct memblock mem_313081 = {.desc ="mem_313081", .mem =
                                  futhark_mc_segmap_parloop_struct_338560->free_mem_313081,
                                  .size =0, .references =NULL};
    struct memblock mem_313085 = {.desc ="mem_313085", .mem =
                                  futhark_mc_segmap_parloop_struct_338560->free_mem_313085,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_segmap_parloop_struct_338560->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_segmap_parloop_struct_338560->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_segmap_parloop_struct_338560->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_segmap_parloop_struct_338560->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315021 = {.desc ="mem_315021", .mem =
                                  futhark_mc_segmap_parloop_struct_338560->free_mem_315021,
                                  .size =0, .references =NULL};
    int64_t bytes_315200 =
            futhark_mc_segmap_parloop_struct_338560->free_bytes_315200;
    struct memblock mem_315304 = {.desc ="mem_315304", .mem =
                                  futhark_mc_segmap_parloop_struct_338560->free_mem_315304,
                                  .size =0, .references =NULL};
    struct memblock mem_315308 = {.desc ="mem_315308", .mem =
                                  futhark_mc_segmap_parloop_struct_338560->free_mem_315308,
                                  .size =0, .references =NULL};
    size_t mem_315243_cached_sizze_338562 = 0;
    unsigned char *mem_315243 = NULL;
    size_t mem_315246_cached_sizze_338563 = 0;
    unsigned char *mem_315246 = NULL;
    size_t mem_315263_cached_sizze_338564 = 0;
    unsigned char *mem_315263 = NULL;
    size_t mem_315266_cached_sizze_338565 = 0;
    unsigned char *mem_315266 = NULL;
    int64_t iterations = end - start;
    int64_t iter_330035 = start;
    
    if (mem_315243_cached_sizze_338562 < (size_t) bytes_313028) {
        mem_315243 = realloc(mem_315243, bytes_313028);
        mem_315243_cached_sizze_338562 = bytes_313028;
    }
    if (mem_315246_cached_sizze_338563 < (size_t) bytes_313028) {
        mem_315246 = realloc(mem_315246, bytes_313028);
        mem_315246_cached_sizze_338563 = bytes_313028;
    }
    if (mem_315263_cached_sizze_338564 < (size_t) bytes_315200) {
        mem_315263 = realloc(mem_315263, bytes_315200);
        mem_315263_cached_sizze_338564 = bytes_315200;
    }
    if (mem_315266_cached_sizze_338565 < (size_t) bytes_315200) {
        mem_315266 = realloc(mem_315266, bytes_315200);
        mem_315266_cached_sizze_338565 = bytes_315200;
    }
    for (; iter_330035 < end; iter_330035++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_330115 = partition_sizze_292766;
        int64_t gtid_305918 = iter_330035;
        int64_t remnant_330116 = iter_330035 - gtid_305918;
        
        for (int64_t i_330036 = 0; i_330036 < l_n_m_292832; i_330036++) {
            int64_t x_330039;
            
            x_330039 = ((int64_t *) mem_313081.mem)[gtid_305918 * l_n_m_292832 +
                                                    i_330036];
            
            double x_330040;
            
            x_330040 = ((double *) mem_313085.mem)[gtid_305918 * l_n_m_292832 +
                                                   i_330036];
            
            int64_t min_arg_330041 = mul64(jump_t_292685, i_330036);
            int64_t min_res_330042 = smin64(i_292846, min_arg_330041);
            int64_t defunc_0_g_res_330043 = add64((int64_t) 1, min_res_330042);
            double defunc_2_reduce_res_330046;
            double defunc_2_reduce_res_330047;
            double defunc_2_reduce_res_330048;
            double redout_330052;
            double redout_330053;
            double redout_330054;
            
            redout_330052 = 0.0;
            redout_330053 = 0.0;
            redout_330054 = 0.0;
            for (int64_t i_330051 = 0; i_330051 < q_l_292680; i_330051++) {
                bool cond_330057 = sle64(n_292675, i_330051);
                int64_t defunc_0_f_res_330058;
                
                if (cond_330057) {
                    defunc_0_f_res_330058 = (int64_t) 0;
                } else {
                    int64_t i_330059 = add64(x_330039, i_330051);
                    int64_t defunc_1_add_res_330060 = add64((int64_t) 1,
                                                            i_330059);
                    
                    defunc_0_f_res_330058 = defunc_1_add_res_330060;
                }
                
                double defunc_0_f_res_330061;
                
                if (cond_330057) {
                    defunc_0_f_res_330061 = 0.0;
                } else {
                    int64_t i_330062 = add64(x_330039, i_330051);
                    double defunc_0_add_arg_330063;
                    
                    defunc_0_add_arg_330063 =
                        ((double *) mem_param_313179.mem)[ctx_param_ext_313174 +
                                                          (gtid_305918 *
                                                           ctx_param_ext_313175 +
                                                           i_330062 *
                                                           ctx_param_ext_313177)];
                    defunc_0_f_res_330061 = defunc_0_add_arg_330063;
                }
                
                int64_t binop_p_330064 = sub64(defunc_0_f_res_330058,
                                               defunc_0_g_res_330043);
                double defunc_0_f_res_330065 = sitofp_i64_f64(binop_p_330064);
                double abs_res_330066 = fabs(defunc_0_f_res_330065);
                double tmp1_330067 = abs_res_330066 / x_330040;
                double x_330068 = tmp1_330067 * tmp1_330067;
                double y_330069 = tmp1_330067 * x_330068;
                double tmp2_330070 = 1.0 - y_330069;
                double x_330071 = tmp2_330070 * tmp2_330070;
                double tmp3_330072 = tmp2_330070 * x_330071;
                double tmp4_330073 = defunc_0_f_res_330061 * tmp3_330072;
                double defunc_1_f_res_330074 = defunc_0_f_res_330065 *
                       tmp4_330073;
                double defunc_1_f_res_330075 = defunc_0_f_res_330065 *
                       defunc_1_f_res_330074;
                double defunc_1_op_res_330076 = tmp4_330073 + redout_330052;
                double defunc_1_op_res_330077 = defunc_1_f_res_330074 +
                       redout_330053;
                double defunc_1_op_res_330078 = defunc_1_f_res_330075 +
                       redout_330054;
                
                ((double *) mem_315263)[i_330051] = defunc_1_f_res_330074;
                ((double *) mem_315266)[i_330051] = tmp4_330073;
                
                double redout_tmp_330119 = defunc_1_op_res_330076;
                double redout_tmp_330120 = defunc_1_op_res_330077;
                double redout_tmp_330121 = defunc_1_op_res_330078;
                
                redout_330052 = redout_tmp_330119;
                redout_330053 = redout_tmp_330120;
                redout_330054 = redout_tmp_330121;
            }
            defunc_2_reduce_res_330046 = redout_330052;
            defunc_2_reduce_res_330047 = redout_330053;
            defunc_2_reduce_res_330048 = redout_330054;
            
            double a_330081 = 2.220446049250313e-16 +
                   defunc_2_reduce_res_330046;
            double b_330082 = 2.220446049250313e-16 +
                   defunc_2_reduce_res_330047;
            double c_330083 = 2.220446049250313e-16 +
                   defunc_2_reduce_res_330048;
            double x_330084 = a_330081 * c_330083;
            double y_330085 = b_330082 * b_330082;
            double y_330086 = x_330084 - y_330085;
            double det1_330087 = 1.0 / y_330086;
            double a11_330088 = c_330083 * det1_330087;
            double x_330089 = 0.0 - b_330082;
            double b11_330090 = det1_330087 * x_330089;
            double c11_330091 = a_330081 * det1_330087;
            double defunc_2_reduce_res_330092;
            double defunc_2_reduce_res_330093;
            double redout_330095;
            double redout_330096;
            
            redout_330095 = 0.0;
            redout_330096 = 0.0;
            for (int64_t i_330094 = 0; i_330094 < q_l_292680; i_330094++) {
                double x_330097;
                
                x_330097 = ((double *) mem_315266)[i_330094];
                
                double x_330098;
                
                x_330098 = ((double *) mem_315263)[i_330094];
                
                bool cond_330099 = sle64(n_292675, i_330094);
                double defunc_0_f_res_330100;
                
                if (cond_330099) {
                    defunc_0_f_res_330100 = 0.0;
                } else {
                    int64_t i_330101 = add64(x_330039, i_330094);
                    double defunc_0_add_arg_330102;
                    
                    defunc_0_add_arg_330102 =
                        ((double *) mem_315021.mem)[gtid_305918 * n_292675 +
                                                    i_330101];
                    defunc_0_f_res_330100 = defunc_0_add_arg_330102;
                }
                
                double x_330103 = a11_330088 * x_330097;
                double y_330104 = b11_330090 * x_330098;
                double x_330105 = x_330103 + y_330104;
                double defunc_9_fit_fun_res_330106 = defunc_0_f_res_330100 *
                       x_330105;
                double x_330107 = b11_330090 * x_330097;
                double y_330108 = c11_330091 * x_330098;
                double x_330109 = x_330107 + y_330108;
                double defunc_9_slope_fun_res_330110 = defunc_0_f_res_330100 *
                       x_330109;
                double defunc_1_op_res_330111 = defunc_9_fit_fun_res_330106 +
                       redout_330095;
                double defunc_1_op_res_330112 = defunc_9_slope_fun_res_330110 +
                       redout_330096;
                double redout_tmp_330124 = defunc_1_op_res_330111;
                double redout_tmp_330125 = defunc_1_op_res_330112;
                
                redout_330095 = redout_tmp_330124;
                redout_330096 = redout_tmp_330125;
            }
            defunc_2_reduce_res_330092 = redout_330095;
            defunc_2_reduce_res_330093 = redout_330096;
            ((double *) mem_315243)[i_330036] = defunc_2_reduce_res_330092;
            ((double *) mem_315246)[i_330036] = defunc_2_reduce_res_330093;
        }
        if (l_n_m_292832 * (int64_t) 8 > 0)
            memmove(mem_315304.mem + gtid_305918 * l_n_m_292832 * (int64_t) 8,
                    mem_315243 + (int64_t) 0, l_n_m_292832 * (int64_t) 8);
        if (l_n_m_292832 * (int64_t) 8 > 0)
            memmove(mem_315308.mem + gtid_305918 * l_n_m_292832 * (int64_t) 8,
                    mem_315246 + (int64_t) 0, l_n_m_292832 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_315243);
    free(mem_315246);
    free(mem_315263);
    free(mem_315266);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338561_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338561_end -
                 futhark_mc_segmap_parloop_338561_start;
        
        ctx->futhark_mc_segmap_parloop_338561_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338561_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338561_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_338559(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_305917 = tid;
    int num_tasks_330034 = info.nsubtasks;
    struct futhark_mc_task_338558 *futhark_mc_task_338558 =
                                  (struct futhark_mc_task_338558 *) args;
    struct futhark_context *ctx = futhark_mc_task_338558->ctx;
    uint64_t futhark_mc_segmap_task_338559_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_338559_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338558->free_n_292675;
    int64_t q_l_292680 = futhark_mc_task_338558->free_q_l_292680;
    int64_t jump_t_292685 = futhark_mc_task_338558->free_jump_t_292685;
    int64_t partition_sizze_292766 =
            futhark_mc_task_338558->free_partition_sizze_292766;
    int64_t l_n_m_292832 = futhark_mc_task_338558->free_l_n_m_292832;
    int64_t i_292846 = futhark_mc_task_338558->free_i_292846;
    int64_t bytes_313028 = futhark_mc_task_338558->free_bytes_313028;
    struct memblock mem_313081 = {.desc ="mem_313081", .mem =
                                  futhark_mc_task_338558->free_mem_313081,
                                  .size =0, .references =NULL};
    struct memblock mem_313085 = {.desc ="mem_313085", .mem =
                                  futhark_mc_task_338558->free_mem_313085,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_task_338558->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_task_338558->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_task_338558->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_task_338558->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315021 = {.desc ="mem_315021", .mem =
                                  futhark_mc_task_338558->free_mem_315021,
                                  .size =0, .references =NULL};
    int64_t bytes_315200 = futhark_mc_task_338558->free_bytes_315200;
    struct memblock mem_315304 = {.desc ="mem_315304", .mem =
                                  futhark_mc_task_338558->free_mem_315304,
                                  .size =0, .references =NULL};
    struct memblock mem_315308 = {.desc ="mem_315308", .mem =
                                  futhark_mc_task_338558->free_mem_315308,
                                  .size =0, .references =NULL};
    int64_t iter_330035;
    struct futhark_mc_segmap_parloop_struct_338560
    futhark_mc_segmap_parloop_struct_338560;
    
    futhark_mc_segmap_parloop_struct_338560.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338560.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_338560.free_q_l_292680 = q_l_292680;
    futhark_mc_segmap_parloop_struct_338560.free_jump_t_292685 = jump_t_292685;
    futhark_mc_segmap_parloop_struct_338560.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_338560.free_l_n_m_292832 = l_n_m_292832;
    futhark_mc_segmap_parloop_struct_338560.free_i_292846 = i_292846;
    futhark_mc_segmap_parloop_struct_338560.free_bytes_313028 = bytes_313028;
    futhark_mc_segmap_parloop_struct_338560.free_mem_313081 = mem_313081.mem;
    futhark_mc_segmap_parloop_struct_338560.free_mem_313085 = mem_313085.mem;
    futhark_mc_segmap_parloop_struct_338560.free_ctx_param_ext_313174 =
        ctx_param_ext_313174;
    futhark_mc_segmap_parloop_struct_338560.free_ctx_param_ext_313175 =
        ctx_param_ext_313175;
    futhark_mc_segmap_parloop_struct_338560.free_ctx_param_ext_313177 =
        ctx_param_ext_313177;
    futhark_mc_segmap_parloop_struct_338560.free_mem_param_313179 =
        mem_param_313179.mem;
    futhark_mc_segmap_parloop_struct_338560.free_mem_315021 = mem_315021.mem;
    futhark_mc_segmap_parloop_struct_338560.free_bytes_315200 = bytes_315200;
    futhark_mc_segmap_parloop_struct_338560.free_mem_315304 = mem_315304.mem;
    futhark_mc_segmap_parloop_struct_338560.free_mem_315308 = mem_315308.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338561_task;
    
    futhark_mc_segmap_parloop_338561_task.name =
        "futhark_mc_segmap_parloop_338561";
    futhark_mc_segmap_parloop_338561_task.fn = futhark_mc_segmap_parloop_338561;
    futhark_mc_segmap_parloop_338561_task.args =
        &futhark_mc_segmap_parloop_struct_338560;
    futhark_mc_segmap_parloop_338561_task.iterations = iterations;
    futhark_mc_segmap_parloop_338561_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338561_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338561_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338561_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338561_task);
    
    if (futhark_mc_segmap_parloop_338561_err != 0) {
        err = futhark_mc_segmap_parloop_338561_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338561_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338561_total_end -
                 futhark_mc_segmap_parloop_338561_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338561_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338561_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338561_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_338559_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_338559_end -
                 futhark_mc_segmap_task_338559_start;
        
        ctx->futhark_mc_segmap_task_338559_runs[tid]++;
        ctx->futhark_mc_segmap_task_338559_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_338559_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_segmap_parloop_struct_338567 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_l_292680;
    int64_t free_jump_t_292685;
    int64_t free_partition_sizze_292766;
    int64_t free_l_n_m_292832;
    int64_t free_i_292846;
    int64_t free_bytes_313028;
    unsigned char *free_mem_313081;
    unsigned char *free_mem_313085;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315021;
    int64_t free_bytes_315200;
    unsigned char *free_mem_315304;
    unsigned char *free_mem_315308;
};
struct futhark_mc_task_338571 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_l_292680;
    int64_t free_jump_t_292685;
    int64_t free_l_n_m_292832;
    int64_t free_i_292846;
    int64_t free_gtid_306010;
    unsigned char *free_mem_313081;
    unsigned char *free_mem_313085;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315021;
    int64_t free_bytes_315200;
    unsigned char *free_mem_315237;
    unsigned char *free_mem_315240;
};
struct futhark_mc_segmap_parloop_struct_338573 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_l_292680;
    int64_t free_jump_t_292685;
    int64_t free_l_n_m_292832;
    int64_t free_i_292846;
    int64_t free_gtid_306010;
    unsigned char *free_mem_313081;
    unsigned char *free_mem_313085;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315021;
    int64_t free_bytes_315200;
    unsigned char *free_mem_315237;
    unsigned char *free_mem_315240;
};
static int futhark_mc_segmap_parloop_338574(void *args, int64_t start,
                                            int64_t end, int flat_tid_330206,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338573
    *futhark_mc_segmap_parloop_struct_338573 =
    (struct futhark_mc_segmap_parloop_struct_338573 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338573->ctx;
    uint64_t futhark_mc_segmap_parloop_338574_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338574_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_338573->free_n_292675;
    int64_t q_l_292680 =
            futhark_mc_segmap_parloop_struct_338573->free_q_l_292680;
    int64_t jump_t_292685 =
            futhark_mc_segmap_parloop_struct_338573->free_jump_t_292685;
    int64_t l_n_m_292832 =
            futhark_mc_segmap_parloop_struct_338573->free_l_n_m_292832;
    int64_t i_292846 = futhark_mc_segmap_parloop_struct_338573->free_i_292846;
    int64_t gtid_306010 =
            futhark_mc_segmap_parloop_struct_338573->free_gtid_306010;
    struct memblock mem_313081 = {.desc ="mem_313081", .mem =
                                  futhark_mc_segmap_parloop_struct_338573->free_mem_313081,
                                  .size =0, .references =NULL};
    struct memblock mem_313085 = {.desc ="mem_313085", .mem =
                                  futhark_mc_segmap_parloop_struct_338573->free_mem_313085,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_segmap_parloop_struct_338573->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_segmap_parloop_struct_338573->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_segmap_parloop_struct_338573->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_segmap_parloop_struct_338573->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315021 = {.desc ="mem_315021", .mem =
                                  futhark_mc_segmap_parloop_struct_338573->free_mem_315021,
                                  .size =0, .references =NULL};
    int64_t bytes_315200 =
            futhark_mc_segmap_parloop_struct_338573->free_bytes_315200;
    struct memblock mem_315237 = {.desc ="mem_315237", .mem =
                                  futhark_mc_segmap_parloop_struct_338573->free_mem_315237,
                                  .size =0, .references =NULL};
    struct memblock mem_315240 = {.desc ="mem_315240", .mem =
                                  futhark_mc_segmap_parloop_struct_338573->free_mem_315240,
                                  .size =0, .references =NULL};
    size_t mem_330213_cached_sizze_338575 = 0;
    unsigned char *mem_330213 = NULL;
    size_t mem_330215_cached_sizze_338576 = 0;
    unsigned char *mem_330215 = NULL;
    int64_t iterations = end - start;
    int64_t iter_330287 = start;
    
    if (mem_330213_cached_sizze_338575 < (size_t) bytes_315200) {
        mem_330213 = realloc(mem_330213, bytes_315200);
        mem_330213_cached_sizze_338575 = bytes_315200;
    }
    if (mem_330215_cached_sizze_338576 < (size_t) bytes_315200) {
        mem_330215 = realloc(mem_330215, bytes_315200);
        mem_330215_cached_sizze_338576 = bytes_315200;
    }
    for (; iter_330287 < end; iter_330287++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_330337 = l_n_m_292832;
        int64_t gtid_330207 = iter_330287;
        int64_t remnant_330338 = iter_330287 - gtid_330207;
        int64_t x_330208;
        
        x_330208 = ((int64_t *) mem_313081.mem)[gtid_306010 * l_n_m_292832 +
                                                gtid_330207];
        
        double x_330209;
        
        x_330209 = ((double *) mem_313085.mem)[gtid_306010 * l_n_m_292832 +
                                               gtid_330207];
        
        int64_t min_arg_330210 = mul64(jump_t_292685, gtid_330207);
        int64_t min_res_330211 = smin64(i_292846, min_arg_330210);
        int64_t defunc_0_g_res_330212 = add64((int64_t) 1, min_res_330211);
        double defunc_2_reduce_res_330217;
        double defunc_2_reduce_res_330218;
        double defunc_2_reduce_res_330219;
        double redout_330289;
        double redout_330290;
        double redout_330291;
        
        redout_330289 = 0.0;
        redout_330290 = 0.0;
        redout_330291 = 0.0;
        for (int64_t i_330288 = 0; i_330288 < q_l_292680; i_330288++) {
            bool cond_330294 = sle64(n_292675, i_330288);
            int64_t defunc_0_f_res_330295;
            
            if (cond_330294) {
                defunc_0_f_res_330295 = (int64_t) 0;
            } else {
                int64_t i_330296 = add64(x_330208, i_330288);
                int64_t defunc_1_add_res_330297 = add64((int64_t) 1, i_330296);
                
                defunc_0_f_res_330295 = defunc_1_add_res_330297;
            }
            
            double defunc_0_f_res_330298;
            
            if (cond_330294) {
                defunc_0_f_res_330298 = 0.0;
            } else {
                int64_t i_330299 = add64(x_330208, i_330288);
                double defunc_0_add_arg_330300;
                
                defunc_0_add_arg_330300 =
                    ((double *) mem_param_313179.mem)[ctx_param_ext_313174 +
                                                      (gtid_306010 *
                                                       ctx_param_ext_313175 +
                                                       i_330299 *
                                                       ctx_param_ext_313177)];
                defunc_0_f_res_330298 = defunc_0_add_arg_330300;
            }
            
            int64_t binop_p_330301 = sub64(defunc_0_f_res_330295,
                                           defunc_0_g_res_330212);
            double defunc_0_f_res_330302 = sitofp_i64_f64(binop_p_330301);
            double abs_res_330303 = fabs(defunc_0_f_res_330302);
            double tmp1_330304 = abs_res_330303 / x_330209;
            double x_330305 = tmp1_330304 * tmp1_330304;
            double y_330306 = tmp1_330304 * x_330305;
            double tmp2_330307 = 1.0 - y_330306;
            double x_330308 = tmp2_330307 * tmp2_330307;
            double tmp3_330309 = tmp2_330307 * x_330308;
            double tmp4_330310 = defunc_0_f_res_330298 * tmp3_330309;
            double defunc_1_f_res_330311 = defunc_0_f_res_330302 * tmp4_330310;
            double defunc_1_f_res_330312 = defunc_0_f_res_330302 *
                   defunc_1_f_res_330311;
            double defunc_1_op_res_330313 = tmp4_330310 + redout_330289;
            double defunc_1_op_res_330314 = defunc_1_f_res_330311 +
                   redout_330290;
            double defunc_1_op_res_330315 = defunc_1_f_res_330312 +
                   redout_330291;
            
            ((double *) mem_330213)[i_330288] = defunc_1_f_res_330311;
            ((double *) mem_330215)[i_330288] = tmp4_330310;
            
            double redout_tmp_330339 = defunc_1_op_res_330313;
            double redout_tmp_330340 = defunc_1_op_res_330314;
            double redout_tmp_330341 = defunc_1_op_res_330315;
            
            redout_330289 = redout_tmp_330339;
            redout_330290 = redout_tmp_330340;
            redout_330291 = redout_tmp_330341;
        }
        defunc_2_reduce_res_330217 = redout_330289;
        defunc_2_reduce_res_330218 = redout_330290;
        defunc_2_reduce_res_330219 = redout_330291;
        
        double a_330252 = 2.220446049250313e-16 + defunc_2_reduce_res_330217;
        double b_330253 = 2.220446049250313e-16 + defunc_2_reduce_res_330218;
        double c_330254 = 2.220446049250313e-16 + defunc_2_reduce_res_330219;
        double x_330255 = a_330252 * c_330254;
        double y_330256 = b_330253 * b_330253;
        double y_330257 = x_330255 - y_330256;
        double det1_330258 = 1.0 / y_330257;
        double a11_330259 = c_330254 * det1_330258;
        double x_330260 = 0.0 - b_330253;
        double b11_330261 = det1_330258 * x_330260;
        double c11_330262 = a_330252 * det1_330258;
        double defunc_2_reduce_res_330263;
        double defunc_2_reduce_res_330264;
        double redout_330319;
        double redout_330320;
        
        redout_330319 = 0.0;
        redout_330320 = 0.0;
        for (int64_t i_330318 = 0; i_330318 < q_l_292680; i_330318++) {
            double x_330321;
            
            x_330321 = ((double *) mem_330215)[i_330318];
            
            double x_330322;
            
            x_330322 = ((double *) mem_330213)[i_330318];
            
            bool cond_330323 = sle64(n_292675, i_330318);
            double defunc_0_f_res_330324;
            
            if (cond_330323) {
                defunc_0_f_res_330324 = 0.0;
            } else {
                int64_t i_330325 = add64(x_330208, i_330318);
                double defunc_0_add_arg_330326;
                
                defunc_0_add_arg_330326 =
                    ((double *) mem_315021.mem)[gtid_306010 * n_292675 +
                                                i_330325];
                defunc_0_f_res_330324 = defunc_0_add_arg_330326;
            }
            
            double x_330327 = a11_330259 * x_330321;
            double y_330328 = b11_330261 * x_330322;
            double x_330329 = x_330327 + y_330328;
            double defunc_9_fit_fun_res_330330 = defunc_0_f_res_330324 *
                   x_330329;
            double x_330331 = b11_330261 * x_330321;
            double y_330332 = c11_330262 * x_330322;
            double x_330333 = x_330331 + y_330332;
            double defunc_9_slope_fun_res_330334 = defunc_0_f_res_330324 *
                   x_330333;
            double defunc_1_op_res_330335 = defunc_9_fit_fun_res_330330 +
                   redout_330319;
            double defunc_1_op_res_330336 = defunc_9_slope_fun_res_330334 +
                   redout_330320;
            double redout_tmp_330344 = defunc_1_op_res_330335;
            double redout_tmp_330345 = defunc_1_op_res_330336;
            
            redout_330319 = redout_tmp_330344;
            redout_330320 = redout_tmp_330345;
        }
        defunc_2_reduce_res_330263 = redout_330319;
        defunc_2_reduce_res_330264 = redout_330320;
        ((double *) mem_315237.mem)[gtid_330207] = defunc_2_reduce_res_330263;
        ((double *) mem_315240.mem)[gtid_330207] = defunc_2_reduce_res_330264;
    }
    
  cleanup:
    { }
    free(mem_330213);
    free(mem_330215);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338574_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338574_end -
                 futhark_mc_segmap_parloop_338574_start;
        
        ctx->futhark_mc_segmap_parloop_338574_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338574_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338574_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_338572(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_330206 = tid;
    int num_tasks_330286 = info.nsubtasks;
    struct futhark_mc_task_338571 *futhark_mc_task_338571 =
                                  (struct futhark_mc_task_338571 *) args;
    struct futhark_context *ctx = futhark_mc_task_338571->ctx;
    uint64_t futhark_mc_segmap_task_338572_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_338572_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338571->free_n_292675;
    int64_t q_l_292680 = futhark_mc_task_338571->free_q_l_292680;
    int64_t jump_t_292685 = futhark_mc_task_338571->free_jump_t_292685;
    int64_t l_n_m_292832 = futhark_mc_task_338571->free_l_n_m_292832;
    int64_t i_292846 = futhark_mc_task_338571->free_i_292846;
    int64_t gtid_306010 = futhark_mc_task_338571->free_gtid_306010;
    struct memblock mem_313081 = {.desc ="mem_313081", .mem =
                                  futhark_mc_task_338571->free_mem_313081,
                                  .size =0, .references =NULL};
    struct memblock mem_313085 = {.desc ="mem_313085", .mem =
                                  futhark_mc_task_338571->free_mem_313085,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_task_338571->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_task_338571->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_task_338571->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_task_338571->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315021 = {.desc ="mem_315021", .mem =
                                  futhark_mc_task_338571->free_mem_315021,
                                  .size =0, .references =NULL};
    int64_t bytes_315200 = futhark_mc_task_338571->free_bytes_315200;
    struct memblock mem_315237 = {.desc ="mem_315237", .mem =
                                  futhark_mc_task_338571->free_mem_315237,
                                  .size =0, .references =NULL};
    struct memblock mem_315240 = {.desc ="mem_315240", .mem =
                                  futhark_mc_task_338571->free_mem_315240,
                                  .size =0, .references =NULL};
    int64_t iter_330287;
    struct futhark_mc_segmap_parloop_struct_338573
    futhark_mc_segmap_parloop_struct_338573;
    
    futhark_mc_segmap_parloop_struct_338573.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338573.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_338573.free_q_l_292680 = q_l_292680;
    futhark_mc_segmap_parloop_struct_338573.free_jump_t_292685 = jump_t_292685;
    futhark_mc_segmap_parloop_struct_338573.free_l_n_m_292832 = l_n_m_292832;
    futhark_mc_segmap_parloop_struct_338573.free_i_292846 = i_292846;
    futhark_mc_segmap_parloop_struct_338573.free_gtid_306010 = gtid_306010;
    futhark_mc_segmap_parloop_struct_338573.free_mem_313081 = mem_313081.mem;
    futhark_mc_segmap_parloop_struct_338573.free_mem_313085 = mem_313085.mem;
    futhark_mc_segmap_parloop_struct_338573.free_ctx_param_ext_313174 =
        ctx_param_ext_313174;
    futhark_mc_segmap_parloop_struct_338573.free_ctx_param_ext_313175 =
        ctx_param_ext_313175;
    futhark_mc_segmap_parloop_struct_338573.free_ctx_param_ext_313177 =
        ctx_param_ext_313177;
    futhark_mc_segmap_parloop_struct_338573.free_mem_param_313179 =
        mem_param_313179.mem;
    futhark_mc_segmap_parloop_struct_338573.free_mem_315021 = mem_315021.mem;
    futhark_mc_segmap_parloop_struct_338573.free_bytes_315200 = bytes_315200;
    futhark_mc_segmap_parloop_struct_338573.free_mem_315237 = mem_315237.mem;
    futhark_mc_segmap_parloop_struct_338573.free_mem_315240 = mem_315240.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338574_task;
    
    futhark_mc_segmap_parloop_338574_task.name =
        "futhark_mc_segmap_parloop_338574";
    futhark_mc_segmap_parloop_338574_task.fn = futhark_mc_segmap_parloop_338574;
    futhark_mc_segmap_parloop_338574_task.args =
        &futhark_mc_segmap_parloop_struct_338573;
    futhark_mc_segmap_parloop_338574_task.iterations = iterations;
    futhark_mc_segmap_parloop_338574_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338574_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338574_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338574_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338574_task);
    
    if (futhark_mc_segmap_parloop_338574_err != 0) {
        err = futhark_mc_segmap_parloop_338574_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338574_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338574_total_end -
                 futhark_mc_segmap_parloop_338574_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338574_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338574_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338574_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_338572_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_338572_end -
                 futhark_mc_segmap_task_338572_start;
        
        ctx->futhark_mc_segmap_task_338572_runs[tid]++;
        ctx->futhark_mc_segmap_task_338572_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_338572_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_segmap_parloop_struct_338578 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_l_292680;
    int64_t free_jump_t_292685;
    int64_t free_l_n_m_292832;
    int64_t free_i_292846;
    int64_t free_gtid_306010;
    unsigned char *free_mem_313081;
    unsigned char *free_mem_313085;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315021;
    int64_t free_bytes_315200;
    unsigned char *free_mem_315237;
    unsigned char *free_mem_315240;
};
struct futhark_mc_task_338582 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_306010;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    int64_t free_x_330129;
    double free_x_330130;
    int64_t free_defunc_0_g_res_330133;
    double *retval_defunc_2_reduce_res_330136;
    double *retval_defunc_2_reduce_res_330137;
    double *retval_defunc_2_reduce_res_330138;
    unsigned char *retval_mem_330134;
    unsigned char *retval_mem_330135;
};
struct futhark_mc_segred_stage_1_parloop_struct_338587 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_306010;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    int64_t free_x_330129;
    double free_x_330130;
    int64_t free_defunc_0_g_res_330133;
    unsigned char *free_mem_330134;
    unsigned char *free_mem_330135;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_330402;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_330404;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_330406;
};
static int futhark_mc_segred_stage_1_parloop_338588(void *args, int64_t start,
                                                    int64_t end,
                                                    int flat_tid_330347,
                                                    int tid)
{
    int err = 0;
    struct futhark_mc_segred_stage_1_parloop_struct_338587
    *futhark_mc_segred_stage_1_parloop_struct_338587 =
    (struct futhark_mc_segred_stage_1_parloop_struct_338587 *) args;
    struct futhark_context *ctx =
                           futhark_mc_segred_stage_1_parloop_struct_338587->ctx;
    uint64_t futhark_mc_segred_stage_1_parloop_338588_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_338588_start = get_wall_time();
    
    int64_t n_292675 =
            futhark_mc_segred_stage_1_parloop_struct_338587->free_n_292675;
    int64_t gtid_306010 =
            futhark_mc_segred_stage_1_parloop_struct_338587->free_gtid_306010;
    int64_t ctx_param_ext_313174 =
            futhark_mc_segred_stage_1_parloop_struct_338587->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_segred_stage_1_parloop_struct_338587->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_segred_stage_1_parloop_struct_338587->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_segred_stage_1_parloop_struct_338587->free_mem_param_313179,
                                        .size =0, .references =NULL};
    int64_t x_330129 =
            futhark_mc_segred_stage_1_parloop_struct_338587->free_x_330129;
    double x_330130 =
           futhark_mc_segred_stage_1_parloop_struct_338587->free_x_330130;
    int64_t defunc_0_g_res_330133 =
            futhark_mc_segred_stage_1_parloop_struct_338587->free_defunc_0_g_res_330133;
    struct memblock mem_330134 = {.desc ="mem_330134", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_338587->free_mem_330134,
                                  .size =0, .references =NULL};
    struct memblock mem_330135 = {.desc ="mem_330135", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_338587->free_mem_330135,
                                  .size =0, .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_330402 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_330402",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338587->free_reduce_stage_1_tid_res_arr_mem_330402,
                                                             .size =0,
                                                             .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_330404 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_330404",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338587->free_reduce_stage_1_tid_res_arr_mem_330404,
                                                             .size =0,
                                                             .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_330406 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_330406",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338587->free_reduce_stage_1_tid_res_arr_mem_330406,
                                                             .size =0,
                                                             .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_330408 = start;
    double x_330349;
    double x_330350;
    double x_330352;
    double x_330353;
    double x_330355;
    double x_330356;
    double local_acc_330409 = 0.0;
    double local_acc_330410 = 0.0;
    double local_acc_330411 = 0.0;
    
    for (; iter_330408 < end; iter_330408++) {
        int64_t gtid_330348 = iter_330408;
        bool cond_330358 = sle64(n_292675, gtid_330348);
        int64_t defunc_0_f_res_330359;
        
        if (cond_330358) {
            defunc_0_f_res_330359 = (int64_t) 0;
        } else {
            int64_t i_330360 = add64(x_330129, gtid_330348);
            int64_t defunc_1_add_res_330361 = add64((int64_t) 1, i_330360);
            
            defunc_0_f_res_330359 = defunc_1_add_res_330361;
        }
        
        double defunc_0_f_res_330362;
        
        if (cond_330358) {
            defunc_0_f_res_330362 = 0.0;
        } else {
            int64_t i_330363 = add64(x_330129, gtid_330348);
            double defunc_0_add_arg_330364;
            
            defunc_0_add_arg_330364 =
                ((double *) mem_param_313179.mem)[ctx_param_ext_313174 +
                                                  (gtid_306010 *
                                                   ctx_param_ext_313175 +
                                                   i_330363 *
                                                   ctx_param_ext_313177)];
            defunc_0_f_res_330362 = defunc_0_add_arg_330364;
        }
        
        int64_t binop_p_330365 = sub64(defunc_0_f_res_330359,
                                       defunc_0_g_res_330133);
        double defunc_0_f_res_330366 = sitofp_i64_f64(binop_p_330365);
        double abs_res_330367 = fabs(defunc_0_f_res_330366);
        double tmp1_330368 = abs_res_330367 / x_330130;
        double x_330369 = tmp1_330368 * tmp1_330368;
        double y_330370 = tmp1_330368 * x_330369;
        double tmp2_330371 = 1.0 - y_330370;
        double x_330372 = tmp2_330371 * tmp2_330371;
        double tmp3_330373 = tmp2_330371 * x_330372;
        double tmp4_330374 = defunc_0_f_res_330362 * tmp3_330373;
        double defunc_1_f_res_330375 = defunc_0_f_res_330366 * tmp4_330374;
        double defunc_1_f_res_330376 = defunc_0_f_res_330366 *
               defunc_1_f_res_330375;
        
        // save map-out results
        {
            ((double *) mem_330134.mem)[gtid_330348] = defunc_1_f_res_330375;
            ((double *) mem_330135.mem)[gtid_330348] = tmp4_330374;
        }
        // Load accum params
        {
            x_330349 = local_acc_330409;
        }
        // Load next params
        {
            x_330350 = tmp4_330374;
        }
        // Red body
        {
            double defunc_1_op_res_330351 = x_330349 + x_330350;
            
            local_acc_330409 = defunc_1_op_res_330351;
        }
        // Load accum params
        {
            x_330352 = local_acc_330410;
        }
        // Load next params
        {
            x_330353 = defunc_1_f_res_330375;
        }
        // Red body
        {
            double defunc_1_op_res_330354 = x_330352 + x_330353;
            
            local_acc_330410 = defunc_1_op_res_330354;
        }
        // Load accum params
        {
            x_330355 = local_acc_330411;
        }
        // Load next params
        {
            x_330356 = defunc_1_f_res_330376;
        }
        // Red body
        {
            double defunc_1_op_res_330357 = x_330355 + x_330356;
            
            local_acc_330411 = defunc_1_op_res_330357;
        }
    }
    ((double *) reduce_stage_1_tid_res_arr_mem_330402.mem)[flat_tid_330347] =
        local_acc_330409;
    ((double *) reduce_stage_1_tid_res_arr_mem_330404.mem)[flat_tid_330347] =
        local_acc_330410;
    ((double *) reduce_stage_1_tid_res_arr_mem_330406.mem)[flat_tid_330347] =
        local_acc_330411;
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_338588_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_338588_end -
                 futhark_mc_segred_stage_1_parloop_338588_start;
        
        ctx->futhark_mc_segred_stage_1_parloop_338588_runs[tid]++;
        ctx->futhark_mc_segred_stage_1_parloop_338588_total_runtime[tid] +=
            elapsed;
        ctx->futhark_mc_segred_stage_1_parloop_338588_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segred_task_338583(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_330347 = tid;
    int num_tasks_330401 = info.nsubtasks;
    struct futhark_mc_task_338582 *futhark_mc_task_338582 =
                                  (struct futhark_mc_task_338582 *) args;
    struct futhark_context *ctx = futhark_mc_task_338582->ctx;
    uint64_t futhark_mc_segred_task_338583_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_task_338583_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338582->free_n_292675;
    int64_t gtid_306010 = futhark_mc_task_338582->free_gtid_306010;
    int64_t ctx_param_ext_313174 =
            futhark_mc_task_338582->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_task_338582->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_task_338582->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_task_338582->free_mem_param_313179,
                                        .size =0, .references =NULL};
    int64_t x_330129 = futhark_mc_task_338582->free_x_330129;
    double x_330130 = futhark_mc_task_338582->free_x_330130;
    int64_t defunc_0_g_res_330133 =
            futhark_mc_task_338582->free_defunc_0_g_res_330133;
    double defunc_2_reduce_res_330136 =
           *futhark_mc_task_338582->retval_defunc_2_reduce_res_330136;
    double defunc_2_reduce_res_330137 =
           *futhark_mc_task_338582->retval_defunc_2_reduce_res_330137;
    double defunc_2_reduce_res_330138 =
           *futhark_mc_task_338582->retval_defunc_2_reduce_res_330138;
    struct memblock mem_330134 = {.desc ="mem_330134", .mem =
                                  futhark_mc_task_338582->retval_mem_330134,
                                  .size =0, .references =NULL};
    struct memblock mem_330135 = {.desc ="mem_330135", .mem =
                                  futhark_mc_task_338582->retval_mem_330135,
                                  .size =0, .references =NULL};
    size_t reduce_stage_1_tid_res_arr_mem_330402_cached_sizze_338584 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_330402 = NULL;
    size_t reduce_stage_1_tid_res_arr_mem_330404_cached_sizze_338585 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_330404 = NULL;
    size_t reduce_stage_1_tid_res_arr_mem_330406_cached_sizze_338586 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_330406 = NULL;
    
    if (reduce_stage_1_tid_res_arr_mem_330402_cached_sizze_338584 <
        (size_t) ((int64_t) 8 * num_tasks_330401)) {
        reduce_stage_1_tid_res_arr_mem_330402 =
            realloc(reduce_stage_1_tid_res_arr_mem_330402, (int64_t) 8 *
                    num_tasks_330401);
        reduce_stage_1_tid_res_arr_mem_330402_cached_sizze_338584 =
            (int64_t) 8 * num_tasks_330401;
    }
    if (reduce_stage_1_tid_res_arr_mem_330404_cached_sizze_338585 <
        (size_t) ((int64_t) 8 * num_tasks_330401)) {
        reduce_stage_1_tid_res_arr_mem_330404 =
            realloc(reduce_stage_1_tid_res_arr_mem_330404, (int64_t) 8 *
                    num_tasks_330401);
        reduce_stage_1_tid_res_arr_mem_330404_cached_sizze_338585 =
            (int64_t) 8 * num_tasks_330401;
    }
    if (reduce_stage_1_tid_res_arr_mem_330406_cached_sizze_338586 <
        (size_t) ((int64_t) 8 * num_tasks_330401)) {
        reduce_stage_1_tid_res_arr_mem_330406 =
            realloc(reduce_stage_1_tid_res_arr_mem_330406, (int64_t) 8 *
                    num_tasks_330401);
        reduce_stage_1_tid_res_arr_mem_330406_cached_sizze_338586 =
            (int64_t) 8 * num_tasks_330401;
    }
    
    int64_t iter_330408;
    struct futhark_mc_segred_stage_1_parloop_struct_338587
    futhark_mc_segred_stage_1_parloop_struct_338587;
    
    futhark_mc_segred_stage_1_parloop_struct_338587.ctx = ctx;
    futhark_mc_segred_stage_1_parloop_struct_338587.free_n_292675 = n_292675;
    futhark_mc_segred_stage_1_parloop_struct_338587.free_gtid_306010 =
        gtid_306010;
    futhark_mc_segred_stage_1_parloop_struct_338587.free_ctx_param_ext_313174 =
        ctx_param_ext_313174;
    futhark_mc_segred_stage_1_parloop_struct_338587.free_ctx_param_ext_313175 =
        ctx_param_ext_313175;
    futhark_mc_segred_stage_1_parloop_struct_338587.free_ctx_param_ext_313177 =
        ctx_param_ext_313177;
    futhark_mc_segred_stage_1_parloop_struct_338587.free_mem_param_313179 =
        mem_param_313179.mem;
    futhark_mc_segred_stage_1_parloop_struct_338587.free_x_330129 = x_330129;
    futhark_mc_segred_stage_1_parloop_struct_338587.free_x_330130 = x_330130;
    futhark_mc_segred_stage_1_parloop_struct_338587.free_defunc_0_g_res_330133 =
        defunc_0_g_res_330133;
    futhark_mc_segred_stage_1_parloop_struct_338587.free_mem_330134 =
        mem_330134.mem;
    futhark_mc_segred_stage_1_parloop_struct_338587.free_mem_330135 =
        mem_330135.mem;
    futhark_mc_segred_stage_1_parloop_struct_338587.free_reduce_stage_1_tid_res_arr_mem_330402 =
        reduce_stage_1_tid_res_arr_mem_330402;
    futhark_mc_segred_stage_1_parloop_struct_338587.free_reduce_stage_1_tid_res_arr_mem_330404 =
        reduce_stage_1_tid_res_arr_mem_330404;
    futhark_mc_segred_stage_1_parloop_struct_338587.free_reduce_stage_1_tid_res_arr_mem_330406 =
        reduce_stage_1_tid_res_arr_mem_330406;
    
    struct scheduler_parloop futhark_mc_segred_stage_1_parloop_338588_task;
    
    futhark_mc_segred_stage_1_parloop_338588_task.name =
        "futhark_mc_segred_stage_1_parloop_338588";
    futhark_mc_segred_stage_1_parloop_338588_task.fn =
        futhark_mc_segred_stage_1_parloop_338588;
    futhark_mc_segred_stage_1_parloop_338588_task.args =
        &futhark_mc_segred_stage_1_parloop_struct_338587;
    futhark_mc_segred_stage_1_parloop_338588_task.iterations = iterations;
    futhark_mc_segred_stage_1_parloop_338588_task.info = info;
    
    uint64_t futhark_mc_segred_stage_1_parloop_338588_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_338588_total_start = get_wall_time();
    
    int futhark_mc_segred_stage_1_parloop_338588_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segred_stage_1_parloop_338588_task);
    
    if (futhark_mc_segred_stage_1_parloop_338588_err != 0) {
        err = futhark_mc_segred_stage_1_parloop_338588_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_338588_total_end =
                 get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_338588_total_end -
                 futhark_mc_segred_stage_1_parloop_338588_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338588_total_runs,
                           1, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338588_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338588_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    // neutral-initialise the output
    {
        defunc_2_reduce_res_330136 = 0.0;
        defunc_2_reduce_res_330137 = 0.0;
        defunc_2_reduce_res_330138 = 0.0;
    }
    
    double x_330412;
    double x_330413;
    double x_330415;
    double x_330416;
    double x_330418;
    double x_330419;
    
    for (int32_t i_330421 = 0; i_330421 < num_tasks_330401; i_330421++) {
        flat_tid_330347 = i_330421;
        // Apply main thread reduction
        {
            // load acc params
            {
                x_330412 = defunc_2_reduce_res_330136;
            }
            // load next params
            {
                x_330413 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_330402)[flat_tid_330347];
            }
            // red body
            {
                double defunc_1_op_res_330414 = x_330412 + x_330413;
                
                defunc_2_reduce_res_330136 = defunc_1_op_res_330414;
            }
            // load acc params
            {
                x_330415 = defunc_2_reduce_res_330137;
            }
            // load next params
            {
                x_330416 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_330404)[flat_tid_330347];
            }
            // red body
            {
                double defunc_1_op_res_330417 = x_330415 + x_330416;
                
                defunc_2_reduce_res_330137 = defunc_1_op_res_330417;
            }
            // load acc params
            {
                x_330418 = defunc_2_reduce_res_330138;
            }
            // load next params
            {
                x_330419 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_330406)[flat_tid_330347];
            }
            // red body
            {
                double defunc_1_op_res_330420 = x_330418 + x_330419;
                
                defunc_2_reduce_res_330138 = defunc_1_op_res_330420;
            }
        }
    }
    
  cleanup:
    {
        free(reduce_stage_1_tid_res_arr_mem_330402);
        free(reduce_stage_1_tid_res_arr_mem_330404);
        free(reduce_stage_1_tid_res_arr_mem_330406);
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_task_338583_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_task_338583_end -
                 futhark_mc_segred_task_338583_start;
        
        ctx->futhark_mc_segred_task_338583_runs[tid]++;
        ctx->futhark_mc_segred_task_338583_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segred_task_338583_iter[tid] += iterations;
    }
    if (err == 0) {
        *futhark_mc_task_338582->retval_defunc_2_reduce_res_330136 =
            defunc_2_reduce_res_330136;
        *futhark_mc_task_338582->retval_defunc_2_reduce_res_330137 =
            defunc_2_reduce_res_330137;
        *futhark_mc_task_338582->retval_defunc_2_reduce_res_330138 =
            defunc_2_reduce_res_330138;
        futhark_mc_task_338582->retval_mem_330134 = mem_330134.mem;
        futhark_mc_task_338582->retval_mem_330135 = mem_330135.mem;
    }
    return err;
}
struct futhark_mc_task_338589 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_306010;
    unsigned char *free_mem_315021;
    int64_t free_x_330129;
    unsigned char *free_mem_330134;
    unsigned char *free_mem_330135;
    double free_a11_330178;
    double free_b11_330180;
    double free_c11_330181;
    double *retval_defunc_2_reduce_res_330182;
    double *retval_defunc_2_reduce_res_330183;
};
struct futhark_mc_segred_stage_1_parloop_struct_338593 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_306010;
    unsigned char *free_mem_315021;
    int64_t free_x_330129;
    unsigned char *free_mem_330134;
    unsigned char *free_mem_330135;
    double free_a11_330178;
    double free_b11_330180;
    double free_c11_330181;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_330423;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_330425;
};
static int futhark_mc_segred_stage_1_parloop_338594(void *args, int64_t start,
                                                    int64_t end,
                                                    int flat_tid_330377,
                                                    int tid)
{
    int err = 0;
    struct futhark_mc_segred_stage_1_parloop_struct_338593
    *futhark_mc_segred_stage_1_parloop_struct_338593 =
    (struct futhark_mc_segred_stage_1_parloop_struct_338593 *) args;
    struct futhark_context *ctx =
                           futhark_mc_segred_stage_1_parloop_struct_338593->ctx;
    uint64_t futhark_mc_segred_stage_1_parloop_338594_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_338594_start = get_wall_time();
    
    int64_t n_292675 =
            futhark_mc_segred_stage_1_parloop_struct_338593->free_n_292675;
    int64_t gtid_306010 =
            futhark_mc_segred_stage_1_parloop_struct_338593->free_gtid_306010;
    struct memblock mem_315021 = {.desc ="mem_315021", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_338593->free_mem_315021,
                                  .size =0, .references =NULL};
    int64_t x_330129 =
            futhark_mc_segred_stage_1_parloop_struct_338593->free_x_330129;
    struct memblock mem_330134 = {.desc ="mem_330134", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_338593->free_mem_330134,
                                  .size =0, .references =NULL};
    struct memblock mem_330135 = {.desc ="mem_330135", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_338593->free_mem_330135,
                                  .size =0, .references =NULL};
    double a11_330178 =
           futhark_mc_segred_stage_1_parloop_struct_338593->free_a11_330178;
    double b11_330180 =
           futhark_mc_segred_stage_1_parloop_struct_338593->free_b11_330180;
    double c11_330181 =
           futhark_mc_segred_stage_1_parloop_struct_338593->free_c11_330181;
    struct memblock reduce_stage_1_tid_res_arr_mem_330423 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_330423",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338593->free_reduce_stage_1_tid_res_arr_mem_330423,
                                                             .size =0,
                                                             .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_330425 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_330425",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338593->free_reduce_stage_1_tid_res_arr_mem_330425,
                                                             .size =0,
                                                             .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_330427 = start;
    double x_330379;
    double x_330380;
    double x_330382;
    double x_330383;
    double local_acc_330428 = 0.0;
    double local_acc_330429 = 0.0;
    
    for (; iter_330427 < end; iter_330427++) {
        int64_t gtid_330378 = iter_330427;
        double x_330385;
        
        x_330385 = ((double *) mem_330135.mem)[gtid_330378];
        
        double x_330386;
        
        x_330386 = ((double *) mem_330134.mem)[gtid_330378];
        
        bool cond_330387 = sle64(n_292675, gtid_330378);
        double defunc_0_f_res_330388;
        
        if (cond_330387) {
            defunc_0_f_res_330388 = 0.0;
        } else {
            int64_t i_330389 = add64(x_330129, gtid_330378);
            double defunc_0_add_arg_330390;
            
            defunc_0_add_arg_330390 = ((double *) mem_315021.mem)[gtid_306010 *
                                                                  n_292675 +
                                                                  i_330389];
            defunc_0_f_res_330388 = defunc_0_add_arg_330390;
        }
        
        double x_330391 = a11_330178 * x_330385;
        double y_330392 = b11_330180 * x_330386;
        double x_330393 = x_330391 + y_330392;
        double defunc_9_fit_fun_res_330394 = defunc_0_f_res_330388 * x_330393;
        double x_330395 = b11_330180 * x_330385;
        double y_330396 = c11_330181 * x_330386;
        double x_330397 = x_330395 + y_330396;
        double defunc_9_slope_fun_res_330398 = defunc_0_f_res_330388 * x_330397;
        
        // save map-out results
        { }
        // Load accum params
        {
            x_330379 = local_acc_330428;
        }
        // Load next params
        {
            x_330380 = defunc_9_fit_fun_res_330394;
        }
        // Red body
        {
            double defunc_1_op_res_330381 = x_330379 + x_330380;
            
            local_acc_330428 = defunc_1_op_res_330381;
        }
        // Load accum params
        {
            x_330382 = local_acc_330429;
        }
        // Load next params
        {
            x_330383 = defunc_9_slope_fun_res_330398;
        }
        // Red body
        {
            double defunc_1_op_res_330384 = x_330382 + x_330383;
            
            local_acc_330429 = defunc_1_op_res_330384;
        }
    }
    ((double *) reduce_stage_1_tid_res_arr_mem_330423.mem)[flat_tid_330377] =
        local_acc_330428;
    ((double *) reduce_stage_1_tid_res_arr_mem_330425.mem)[flat_tid_330377] =
        local_acc_330429;
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_338594_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_338594_end -
                 futhark_mc_segred_stage_1_parloop_338594_start;
        
        ctx->futhark_mc_segred_stage_1_parloop_338594_runs[tid]++;
        ctx->futhark_mc_segred_stage_1_parloop_338594_total_runtime[tid] +=
            elapsed;
        ctx->futhark_mc_segred_stage_1_parloop_338594_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segred_task_338590(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_330377 = tid;
    int num_tasks_330422 = info.nsubtasks;
    struct futhark_mc_task_338589 *futhark_mc_task_338589 =
                                  (struct futhark_mc_task_338589 *) args;
    struct futhark_context *ctx = futhark_mc_task_338589->ctx;
    uint64_t futhark_mc_segred_task_338590_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_task_338590_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338589->free_n_292675;
    int64_t gtid_306010 = futhark_mc_task_338589->free_gtid_306010;
    struct memblock mem_315021 = {.desc ="mem_315021", .mem =
                                  futhark_mc_task_338589->free_mem_315021,
                                  .size =0, .references =NULL};
    int64_t x_330129 = futhark_mc_task_338589->free_x_330129;
    struct memblock mem_330134 = {.desc ="mem_330134", .mem =
                                  futhark_mc_task_338589->free_mem_330134,
                                  .size =0, .references =NULL};
    struct memblock mem_330135 = {.desc ="mem_330135", .mem =
                                  futhark_mc_task_338589->free_mem_330135,
                                  .size =0, .references =NULL};
    double a11_330178 = futhark_mc_task_338589->free_a11_330178;
    double b11_330180 = futhark_mc_task_338589->free_b11_330180;
    double c11_330181 = futhark_mc_task_338589->free_c11_330181;
    double defunc_2_reduce_res_330182 =
           *futhark_mc_task_338589->retval_defunc_2_reduce_res_330182;
    double defunc_2_reduce_res_330183 =
           *futhark_mc_task_338589->retval_defunc_2_reduce_res_330183;
    size_t reduce_stage_1_tid_res_arr_mem_330423_cached_sizze_338591 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_330423 = NULL;
    size_t reduce_stage_1_tid_res_arr_mem_330425_cached_sizze_338592 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_330425 = NULL;
    
    if (reduce_stage_1_tid_res_arr_mem_330423_cached_sizze_338591 <
        (size_t) ((int64_t) 8 * num_tasks_330422)) {
        reduce_stage_1_tid_res_arr_mem_330423 =
            realloc(reduce_stage_1_tid_res_arr_mem_330423, (int64_t) 8 *
                    num_tasks_330422);
        reduce_stage_1_tid_res_arr_mem_330423_cached_sizze_338591 =
            (int64_t) 8 * num_tasks_330422;
    }
    if (reduce_stage_1_tid_res_arr_mem_330425_cached_sizze_338592 <
        (size_t) ((int64_t) 8 * num_tasks_330422)) {
        reduce_stage_1_tid_res_arr_mem_330425 =
            realloc(reduce_stage_1_tid_res_arr_mem_330425, (int64_t) 8 *
                    num_tasks_330422);
        reduce_stage_1_tid_res_arr_mem_330425_cached_sizze_338592 =
            (int64_t) 8 * num_tasks_330422;
    }
    
    int64_t iter_330427;
    struct futhark_mc_segred_stage_1_parloop_struct_338593
    futhark_mc_segred_stage_1_parloop_struct_338593;
    
    futhark_mc_segred_stage_1_parloop_struct_338593.ctx = ctx;
    futhark_mc_segred_stage_1_parloop_struct_338593.free_n_292675 = n_292675;
    futhark_mc_segred_stage_1_parloop_struct_338593.free_gtid_306010 =
        gtid_306010;
    futhark_mc_segred_stage_1_parloop_struct_338593.free_mem_315021 =
        mem_315021.mem;
    futhark_mc_segred_stage_1_parloop_struct_338593.free_x_330129 = x_330129;
    futhark_mc_segred_stage_1_parloop_struct_338593.free_mem_330134 =
        mem_330134.mem;
    futhark_mc_segred_stage_1_parloop_struct_338593.free_mem_330135 =
        mem_330135.mem;
    futhark_mc_segred_stage_1_parloop_struct_338593.free_a11_330178 =
        a11_330178;
    futhark_mc_segred_stage_1_parloop_struct_338593.free_b11_330180 =
        b11_330180;
    futhark_mc_segred_stage_1_parloop_struct_338593.free_c11_330181 =
        c11_330181;
    futhark_mc_segred_stage_1_parloop_struct_338593.free_reduce_stage_1_tid_res_arr_mem_330423 =
        reduce_stage_1_tid_res_arr_mem_330423;
    futhark_mc_segred_stage_1_parloop_struct_338593.free_reduce_stage_1_tid_res_arr_mem_330425 =
        reduce_stage_1_tid_res_arr_mem_330425;
    
    struct scheduler_parloop futhark_mc_segred_stage_1_parloop_338594_task;
    
    futhark_mc_segred_stage_1_parloop_338594_task.name =
        "futhark_mc_segred_stage_1_parloop_338594";
    futhark_mc_segred_stage_1_parloop_338594_task.fn =
        futhark_mc_segred_stage_1_parloop_338594;
    futhark_mc_segred_stage_1_parloop_338594_task.args =
        &futhark_mc_segred_stage_1_parloop_struct_338593;
    futhark_mc_segred_stage_1_parloop_338594_task.iterations = iterations;
    futhark_mc_segred_stage_1_parloop_338594_task.info = info;
    
    uint64_t futhark_mc_segred_stage_1_parloop_338594_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_338594_total_start = get_wall_time();
    
    int futhark_mc_segred_stage_1_parloop_338594_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segred_stage_1_parloop_338594_task);
    
    if (futhark_mc_segred_stage_1_parloop_338594_err != 0) {
        err = futhark_mc_segred_stage_1_parloop_338594_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_338594_total_end =
                 get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_338594_total_end -
                 futhark_mc_segred_stage_1_parloop_338594_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338594_total_runs,
                           1, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338594_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338594_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    // neutral-initialise the output
    {
        defunc_2_reduce_res_330182 = 0.0;
        defunc_2_reduce_res_330183 = 0.0;
    }
    
    double x_330430;
    double x_330431;
    double x_330433;
    double x_330434;
    
    for (int32_t i_330436 = 0; i_330436 < num_tasks_330422; i_330436++) {
        flat_tid_330377 = i_330436;
        // Apply main thread reduction
        {
            // load acc params
            {
                x_330430 = defunc_2_reduce_res_330182;
            }
            // load next params
            {
                x_330431 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_330423)[flat_tid_330377];
            }
            // red body
            {
                double defunc_1_op_res_330432 = x_330430 + x_330431;
                
                defunc_2_reduce_res_330182 = defunc_1_op_res_330432;
            }
            // load acc params
            {
                x_330433 = defunc_2_reduce_res_330183;
            }
            // load next params
            {
                x_330434 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_330425)[flat_tid_330377];
            }
            // red body
            {
                double defunc_1_op_res_330435 = x_330433 + x_330434;
                
                defunc_2_reduce_res_330183 = defunc_1_op_res_330435;
            }
        }
    }
    
  cleanup:
    {
        free(reduce_stage_1_tid_res_arr_mem_330423);
        free(reduce_stage_1_tid_res_arr_mem_330425);
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_task_338590_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_task_338590_end -
                 futhark_mc_segred_task_338590_start;
        
        ctx->futhark_mc_segred_task_338590_runs[tid]++;
        ctx->futhark_mc_segred_task_338590_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segred_task_338590_iter[tid] += iterations;
    }
    if (err == 0) {
        *futhark_mc_task_338589->retval_defunc_2_reduce_res_330182 =
            defunc_2_reduce_res_330182;
        *futhark_mc_task_338589->retval_defunc_2_reduce_res_330183 =
            defunc_2_reduce_res_330183;
    }
    return err;
}
static int futhark_mc_segmap_parloop_338579(void *args, int64_t start,
                                            int64_t end, int flat_tid_330127,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338578
    *futhark_mc_segmap_parloop_struct_338578 =
    (struct futhark_mc_segmap_parloop_struct_338578 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338578->ctx;
    uint64_t futhark_mc_segmap_parloop_338579_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338579_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_338578->free_n_292675;
    int64_t q_l_292680 =
            futhark_mc_segmap_parloop_struct_338578->free_q_l_292680;
    int64_t jump_t_292685 =
            futhark_mc_segmap_parloop_struct_338578->free_jump_t_292685;
    int64_t l_n_m_292832 =
            futhark_mc_segmap_parloop_struct_338578->free_l_n_m_292832;
    int64_t i_292846 = futhark_mc_segmap_parloop_struct_338578->free_i_292846;
    int64_t gtid_306010 =
            futhark_mc_segmap_parloop_struct_338578->free_gtid_306010;
    struct memblock mem_313081 = {.desc ="mem_313081", .mem =
                                  futhark_mc_segmap_parloop_struct_338578->free_mem_313081,
                                  .size =0, .references =NULL};
    struct memblock mem_313085 = {.desc ="mem_313085", .mem =
                                  futhark_mc_segmap_parloop_struct_338578->free_mem_313085,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_segmap_parloop_struct_338578->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_segmap_parloop_struct_338578->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_segmap_parloop_struct_338578->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_segmap_parloop_struct_338578->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315021 = {.desc ="mem_315021", .mem =
                                  futhark_mc_segmap_parloop_struct_338578->free_mem_315021,
                                  .size =0, .references =NULL};
    int64_t bytes_315200 =
            futhark_mc_segmap_parloop_struct_338578->free_bytes_315200;
    struct memblock mem_315237 = {.desc ="mem_315237", .mem =
                                  futhark_mc_segmap_parloop_struct_338578->free_mem_315237,
                                  .size =0, .references =NULL};
    struct memblock mem_315240 = {.desc ="mem_315240", .mem =
                                  futhark_mc_segmap_parloop_struct_338578->free_mem_315240,
                                  .size =0, .references =NULL};
    size_t mem_330134_cached_sizze_338580 = 0;
    unsigned char *mem_330134 = NULL;
    size_t mem_330135_cached_sizze_338581 = 0;
    unsigned char *mem_330135 = NULL;
    int64_t iterations = end - start;
    int64_t iter_330346 = start;
    
    if (mem_330134_cached_sizze_338580 < (size_t) bytes_315200) {
        mem_330134 = realloc(mem_330134, bytes_315200);
        mem_330134_cached_sizze_338580 = bytes_315200;
    }
    if (mem_330135_cached_sizze_338581 < (size_t) bytes_315200) {
        mem_330135 = realloc(mem_330135, bytes_315200);
        mem_330135_cached_sizze_338581 = bytes_315200;
    }
    for (; iter_330346 < end; iter_330346++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_330399 = l_n_m_292832;
        int64_t gtid_330128 = iter_330346;
        int64_t remnant_330400 = iter_330346 - gtid_330128;
        int64_t x_330129;
        
        x_330129 = ((int64_t *) mem_313081.mem)[gtid_306010 * l_n_m_292832 +
                                                gtid_330128];
        
        double x_330130;
        
        x_330130 = ((double *) mem_313085.mem)[gtid_306010 * l_n_m_292832 +
                                               gtid_330128];
        
        int64_t min_arg_330131 = mul64(jump_t_292685, gtid_330128);
        int64_t min_res_330132 = smin64(i_292846, min_arg_330131);
        int64_t defunc_0_g_res_330133 = add64((int64_t) 1, min_res_330132);
        double defunc_2_reduce_res_330136;
        double defunc_2_reduce_res_330137;
        double defunc_2_reduce_res_330138;
        int64_t flat_tid_330347 = (int64_t) 0;
        int32_t num_tasks_330401;
        
        defunc_2_reduce_res_330136 = 0.0;
        defunc_2_reduce_res_330137 = 0.0;
        defunc_2_reduce_res_330138 = 0.0;
        
        struct futhark_mc_task_338582 futhark_mc_task_338582;
        
        futhark_mc_task_338582.ctx = ctx;
        futhark_mc_task_338582.free_n_292675 = n_292675;
        futhark_mc_task_338582.free_gtid_306010 = gtid_306010;
        futhark_mc_task_338582.free_ctx_param_ext_313174 = ctx_param_ext_313174;
        futhark_mc_task_338582.free_ctx_param_ext_313175 = ctx_param_ext_313175;
        futhark_mc_task_338582.free_ctx_param_ext_313177 = ctx_param_ext_313177;
        futhark_mc_task_338582.free_mem_param_313179 = mem_param_313179.mem;
        futhark_mc_task_338582.free_x_330129 = x_330129;
        futhark_mc_task_338582.free_x_330130 = x_330130;
        futhark_mc_task_338582.free_defunc_0_g_res_330133 =
            defunc_0_g_res_330133;
        futhark_mc_task_338582.retval_defunc_2_reduce_res_330136 =
            &defunc_2_reduce_res_330136;
        futhark_mc_task_338582.retval_defunc_2_reduce_res_330137 =
            &defunc_2_reduce_res_330137;
        futhark_mc_task_338582.retval_defunc_2_reduce_res_330138 =
            &defunc_2_reduce_res_330138;
        futhark_mc_task_338582.retval_mem_330134 = mem_330134;
        futhark_mc_task_338582.retval_mem_330135 = mem_330135;
        
        struct scheduler_segop futhark_mc_task_338582_task;
        
        futhark_mc_task_338582_task.args = &futhark_mc_task_338582;
        futhark_mc_task_338582_task.top_level_fn =
            futhark_mc_segred_task_338583;
        futhark_mc_task_338582_task.name = "futhark_mc_segred_task_338583";
        futhark_mc_task_338582_task.iterations = q_l_292680;
        futhark_mc_task_338582_task.task_time =
            &ctx->futhark_mc_segred_task_338583_total_time;
        futhark_mc_task_338582_task.task_iter =
            &ctx->futhark_mc_segred_task_338583_total_iter;
        futhark_mc_task_338582_task.sched = STATIC;
        futhark_mc_task_338582_task.nested_fn = NULL;
        
        int futhark_mc_segred_task_338583_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_338582_task);
        
        if (futhark_mc_segred_task_338583_err != 0) {
            ;
            err = futhark_mc_segred_task_338583_err;
            goto cleanup;
        }
        
        double a_330171 = 2.220446049250313e-16 + defunc_2_reduce_res_330136;
        double b_330172 = 2.220446049250313e-16 + defunc_2_reduce_res_330137;
        double c_330173 = 2.220446049250313e-16 + defunc_2_reduce_res_330138;
        double x_330174 = a_330171 * c_330173;
        double y_330175 = b_330172 * b_330172;
        double y_330176 = x_330174 - y_330175;
        double det1_330177 = 1.0 / y_330176;
        double a11_330178 = c_330173 * det1_330177;
        double x_330179 = 0.0 - b_330172;
        double b11_330180 = det1_330177 * x_330179;
        double c11_330181 = a_330171 * det1_330177;
        double defunc_2_reduce_res_330182;
        double defunc_2_reduce_res_330183;
        int64_t flat_tid_330377 = (int64_t) 0;
        int32_t num_tasks_330422;
        
        defunc_2_reduce_res_330182 = 0.0;
        defunc_2_reduce_res_330183 = 0.0;
        
        struct futhark_mc_task_338589 futhark_mc_task_338589;
        
        futhark_mc_task_338589.ctx = ctx;
        futhark_mc_task_338589.free_n_292675 = n_292675;
        futhark_mc_task_338589.free_gtid_306010 = gtid_306010;
        futhark_mc_task_338589.free_mem_315021 = mem_315021.mem;
        futhark_mc_task_338589.free_x_330129 = x_330129;
        futhark_mc_task_338589.free_mem_330134 = mem_330134;
        futhark_mc_task_338589.free_mem_330135 = mem_330135;
        futhark_mc_task_338589.free_a11_330178 = a11_330178;
        futhark_mc_task_338589.free_b11_330180 = b11_330180;
        futhark_mc_task_338589.free_c11_330181 = c11_330181;
        futhark_mc_task_338589.retval_defunc_2_reduce_res_330182 =
            &defunc_2_reduce_res_330182;
        futhark_mc_task_338589.retval_defunc_2_reduce_res_330183 =
            &defunc_2_reduce_res_330183;
        
        struct scheduler_segop futhark_mc_task_338589_task;
        
        futhark_mc_task_338589_task.args = &futhark_mc_task_338589;
        futhark_mc_task_338589_task.top_level_fn =
            futhark_mc_segred_task_338590;
        futhark_mc_task_338589_task.name = "futhark_mc_segred_task_338590";
        futhark_mc_task_338589_task.iterations = q_l_292680;
        futhark_mc_task_338589_task.task_time =
            &ctx->futhark_mc_segred_task_338590_total_time;
        futhark_mc_task_338589_task.task_iter =
            &ctx->futhark_mc_segred_task_338590_total_iter;
        futhark_mc_task_338589_task.sched = STATIC;
        futhark_mc_task_338589_task.nested_fn = NULL;
        
        int futhark_mc_segred_task_338590_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_338589_task);
        
        if (futhark_mc_segred_task_338590_err != 0) {
            ;
            err = futhark_mc_segred_task_338590_err;
            goto cleanup;
        }
        ((double *) mem_315237.mem)[gtid_330128] = defunc_2_reduce_res_330182;
        ((double *) mem_315240.mem)[gtid_330128] = defunc_2_reduce_res_330183;
    }
    
  cleanup:
    { }
    free(mem_330134);
    free(mem_330135);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338579_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338579_end -
                 futhark_mc_segmap_parloop_338579_start;
        
        ctx->futhark_mc_segmap_parloop_338579_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338579_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338579_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_nested_task_338577(void *args, int64_t iterations,
                                         int tid, struct scheduler_info info)
{
    int err = 0;
    int flat_tid_330127 = tid;
    int num_tasks_330286 = info.nsubtasks;
    struct futhark_mc_task_338571 *futhark_mc_task_338571 =
                                  (struct futhark_mc_task_338571 *) args;
    struct futhark_context *ctx = futhark_mc_task_338571->ctx;
    uint64_t futhark_mc_segmap_nested_task_338577_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_nested_task_338577_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338571->free_n_292675;
    int64_t q_l_292680 = futhark_mc_task_338571->free_q_l_292680;
    int64_t jump_t_292685 = futhark_mc_task_338571->free_jump_t_292685;
    int64_t l_n_m_292832 = futhark_mc_task_338571->free_l_n_m_292832;
    int64_t i_292846 = futhark_mc_task_338571->free_i_292846;
    int64_t gtid_306010 = futhark_mc_task_338571->free_gtid_306010;
    struct memblock mem_313081 = {.desc ="mem_313081", .mem =
                                  futhark_mc_task_338571->free_mem_313081,
                                  .size =0, .references =NULL};
    struct memblock mem_313085 = {.desc ="mem_313085", .mem =
                                  futhark_mc_task_338571->free_mem_313085,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_task_338571->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_task_338571->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_task_338571->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_task_338571->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315021 = {.desc ="mem_315021", .mem =
                                  futhark_mc_task_338571->free_mem_315021,
                                  .size =0, .references =NULL};
    int64_t bytes_315200 = futhark_mc_task_338571->free_bytes_315200;
    struct memblock mem_315237 = {.desc ="mem_315237", .mem =
                                  futhark_mc_task_338571->free_mem_315237,
                                  .size =0, .references =NULL};
    struct memblock mem_315240 = {.desc ="mem_315240", .mem =
                                  futhark_mc_task_338571->free_mem_315240,
                                  .size =0, .references =NULL};
    int64_t iter_330346;
    struct futhark_mc_segmap_parloop_struct_338578
    futhark_mc_segmap_parloop_struct_338578;
    
    futhark_mc_segmap_parloop_struct_338578.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338578.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_338578.free_q_l_292680 = q_l_292680;
    futhark_mc_segmap_parloop_struct_338578.free_jump_t_292685 = jump_t_292685;
    futhark_mc_segmap_parloop_struct_338578.free_l_n_m_292832 = l_n_m_292832;
    futhark_mc_segmap_parloop_struct_338578.free_i_292846 = i_292846;
    futhark_mc_segmap_parloop_struct_338578.free_gtid_306010 = gtid_306010;
    futhark_mc_segmap_parloop_struct_338578.free_mem_313081 = mem_313081.mem;
    futhark_mc_segmap_parloop_struct_338578.free_mem_313085 = mem_313085.mem;
    futhark_mc_segmap_parloop_struct_338578.free_ctx_param_ext_313174 =
        ctx_param_ext_313174;
    futhark_mc_segmap_parloop_struct_338578.free_ctx_param_ext_313175 =
        ctx_param_ext_313175;
    futhark_mc_segmap_parloop_struct_338578.free_ctx_param_ext_313177 =
        ctx_param_ext_313177;
    futhark_mc_segmap_parloop_struct_338578.free_mem_param_313179 =
        mem_param_313179.mem;
    futhark_mc_segmap_parloop_struct_338578.free_mem_315021 = mem_315021.mem;
    futhark_mc_segmap_parloop_struct_338578.free_bytes_315200 = bytes_315200;
    futhark_mc_segmap_parloop_struct_338578.free_mem_315237 = mem_315237.mem;
    futhark_mc_segmap_parloop_struct_338578.free_mem_315240 = mem_315240.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338579_task;
    
    futhark_mc_segmap_parloop_338579_task.name =
        "futhark_mc_segmap_parloop_338579";
    futhark_mc_segmap_parloop_338579_task.fn = futhark_mc_segmap_parloop_338579;
    futhark_mc_segmap_parloop_338579_task.args =
        &futhark_mc_segmap_parloop_struct_338578;
    futhark_mc_segmap_parloop_338579_task.iterations = iterations;
    futhark_mc_segmap_parloop_338579_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338579_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338579_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338579_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338579_task);
    
    if (futhark_mc_segmap_parloop_338579_err != 0) {
        err = futhark_mc_segmap_parloop_338579_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338579_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338579_total_end -
                 futhark_mc_segmap_parloop_338579_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338579_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338579_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338579_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_nested_task_338577_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_nested_task_338577_end -
                 futhark_mc_segmap_nested_task_338577_start;
        
        ctx->futhark_mc_segmap_nested_task_338577_runs[tid]++;
        ctx->futhark_mc_segmap_nested_task_338577_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_nested_task_338577_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
static int futhark_mc_segmap_parloop_338568(void *args, int64_t start,
                                            int64_t end, int flat_tid_306009,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338567
    *futhark_mc_segmap_parloop_struct_338567 =
    (struct futhark_mc_segmap_parloop_struct_338567 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338567->ctx;
    uint64_t futhark_mc_segmap_parloop_338568_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338568_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_338567->free_n_292675;
    int64_t q_l_292680 =
            futhark_mc_segmap_parloop_struct_338567->free_q_l_292680;
    int64_t jump_t_292685 =
            futhark_mc_segmap_parloop_struct_338567->free_jump_t_292685;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_338567->free_partition_sizze_292766;
    int64_t l_n_m_292832 =
            futhark_mc_segmap_parloop_struct_338567->free_l_n_m_292832;
    int64_t i_292846 = futhark_mc_segmap_parloop_struct_338567->free_i_292846;
    int64_t bytes_313028 =
            futhark_mc_segmap_parloop_struct_338567->free_bytes_313028;
    struct memblock mem_313081 = {.desc ="mem_313081", .mem =
                                  futhark_mc_segmap_parloop_struct_338567->free_mem_313081,
                                  .size =0, .references =NULL};
    struct memblock mem_313085 = {.desc ="mem_313085", .mem =
                                  futhark_mc_segmap_parloop_struct_338567->free_mem_313085,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_segmap_parloop_struct_338567->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_segmap_parloop_struct_338567->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_segmap_parloop_struct_338567->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_segmap_parloop_struct_338567->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315021 = {.desc ="mem_315021", .mem =
                                  futhark_mc_segmap_parloop_struct_338567->free_mem_315021,
                                  .size =0, .references =NULL};
    int64_t bytes_315200 =
            futhark_mc_segmap_parloop_struct_338567->free_bytes_315200;
    struct memblock mem_315304 = {.desc ="mem_315304", .mem =
                                  futhark_mc_segmap_parloop_struct_338567->free_mem_315304,
                                  .size =0, .references =NULL};
    struct memblock mem_315308 = {.desc ="mem_315308", .mem =
                                  futhark_mc_segmap_parloop_struct_338567->free_mem_315308,
                                  .size =0, .references =NULL};
    size_t mem_315237_cached_sizze_338569 = 0;
    unsigned char *mem_315237 = NULL;
    size_t mem_315240_cached_sizze_338570 = 0;
    unsigned char *mem_315240 = NULL;
    int64_t iterations = end - start;
    int64_t iter_330126 = start;
    
    if (mem_315237_cached_sizze_338569 < (size_t) bytes_313028) {
        mem_315237 = realloc(mem_315237, bytes_313028);
        mem_315237_cached_sizze_338569 = bytes_313028;
    }
    if (mem_315240_cached_sizze_338570 < (size_t) bytes_313028) {
        mem_315240 = realloc(mem_315240, bytes_313028);
        mem_315240_cached_sizze_338570 = bytes_313028;
    }
    for (; iter_330126 < end; iter_330126++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_330284 = partition_sizze_292766;
        int64_t gtid_306010 = iter_330126;
        int64_t remnant_330285 = iter_330126 - gtid_306010;
        int64_t flat_tid_330206 = (int64_t) 0;
        int32_t num_tasks_330286;
        int64_t flat_tid_330127 = (int64_t) 0;
        struct futhark_mc_task_338571 futhark_mc_task_338571;
        
        futhark_mc_task_338571.ctx = ctx;
        futhark_mc_task_338571.free_n_292675 = n_292675;
        futhark_mc_task_338571.free_q_l_292680 = q_l_292680;
        futhark_mc_task_338571.free_jump_t_292685 = jump_t_292685;
        futhark_mc_task_338571.free_l_n_m_292832 = l_n_m_292832;
        futhark_mc_task_338571.free_i_292846 = i_292846;
        futhark_mc_task_338571.free_gtid_306010 = gtid_306010;
        futhark_mc_task_338571.free_mem_313081 = mem_313081.mem;
        futhark_mc_task_338571.free_mem_313085 = mem_313085.mem;
        futhark_mc_task_338571.free_ctx_param_ext_313174 = ctx_param_ext_313174;
        futhark_mc_task_338571.free_ctx_param_ext_313175 = ctx_param_ext_313175;
        futhark_mc_task_338571.free_ctx_param_ext_313177 = ctx_param_ext_313177;
        futhark_mc_task_338571.free_mem_param_313179 = mem_param_313179.mem;
        futhark_mc_task_338571.free_mem_315021 = mem_315021.mem;
        futhark_mc_task_338571.free_bytes_315200 = bytes_315200;
        futhark_mc_task_338571.free_mem_315237 = mem_315237;
        futhark_mc_task_338571.free_mem_315240 = mem_315240;
        
        struct scheduler_segop futhark_mc_task_338571_task;
        
        futhark_mc_task_338571_task.args = &futhark_mc_task_338571;
        futhark_mc_task_338571_task.top_level_fn =
            futhark_mc_segmap_task_338572;
        futhark_mc_task_338571_task.name = "futhark_mc_segmap_task_338572";
        futhark_mc_task_338571_task.iterations = l_n_m_292832;
        futhark_mc_task_338571_task.task_time =
            &ctx->futhark_mc_segmap_task_338572_total_time;
        futhark_mc_task_338571_task.task_iter =
            &ctx->futhark_mc_segmap_task_338572_total_iter;
        futhark_mc_task_338571_task.sched = STATIC;
        futhark_mc_task_338571_task.nested_fn =
            futhark_mc_segmap_nested_task_338577;
        
        int futhark_mc_segmap_task_338572_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_338571_task);
        
        if (futhark_mc_segmap_task_338572_err != 0) {
            ;
            err = futhark_mc_segmap_task_338572_err;
            goto cleanup;
        }
        if (l_n_m_292832 * (int64_t) 8 > 0)
            memmove(mem_315304.mem + gtid_306010 * l_n_m_292832 * (int64_t) 8,
                    mem_315237 + (int64_t) 0, l_n_m_292832 * (int64_t) 8);
        if (l_n_m_292832 * (int64_t) 8 > 0)
            memmove(mem_315308.mem + gtid_306010 * l_n_m_292832 * (int64_t) 8,
                    mem_315240 + (int64_t) 0, l_n_m_292832 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_315237);
    free(mem_315240);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338568_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338568_end -
                 futhark_mc_segmap_parloop_338568_start;
        
        ctx->futhark_mc_segmap_parloop_338568_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338568_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338568_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_nested_task_338566(void *args, int64_t iterations,
                                         int tid, struct scheduler_info info)
{
    int err = 0;
    int flat_tid_306009 = tid;
    int num_tasks_330034 = info.nsubtasks;
    struct futhark_mc_task_338558 *futhark_mc_task_338558 =
                                  (struct futhark_mc_task_338558 *) args;
    struct futhark_context *ctx = futhark_mc_task_338558->ctx;
    uint64_t futhark_mc_segmap_nested_task_338566_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_nested_task_338566_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338558->free_n_292675;
    int64_t q_l_292680 = futhark_mc_task_338558->free_q_l_292680;
    int64_t jump_t_292685 = futhark_mc_task_338558->free_jump_t_292685;
    int64_t partition_sizze_292766 =
            futhark_mc_task_338558->free_partition_sizze_292766;
    int64_t l_n_m_292832 = futhark_mc_task_338558->free_l_n_m_292832;
    int64_t i_292846 = futhark_mc_task_338558->free_i_292846;
    int64_t bytes_313028 = futhark_mc_task_338558->free_bytes_313028;
    struct memblock mem_313081 = {.desc ="mem_313081", .mem =
                                  futhark_mc_task_338558->free_mem_313081,
                                  .size =0, .references =NULL};
    struct memblock mem_313085 = {.desc ="mem_313085", .mem =
                                  futhark_mc_task_338558->free_mem_313085,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_task_338558->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_task_338558->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_task_338558->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_task_338558->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315021 = {.desc ="mem_315021", .mem =
                                  futhark_mc_task_338558->free_mem_315021,
                                  .size =0, .references =NULL};
    int64_t bytes_315200 = futhark_mc_task_338558->free_bytes_315200;
    struct memblock mem_315304 = {.desc ="mem_315304", .mem =
                                  futhark_mc_task_338558->free_mem_315304,
                                  .size =0, .references =NULL};
    struct memblock mem_315308 = {.desc ="mem_315308", .mem =
                                  futhark_mc_task_338558->free_mem_315308,
                                  .size =0, .references =NULL};
    int64_t iter_330126;
    struct futhark_mc_segmap_parloop_struct_338567
    futhark_mc_segmap_parloop_struct_338567;
    
    futhark_mc_segmap_parloop_struct_338567.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338567.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_338567.free_q_l_292680 = q_l_292680;
    futhark_mc_segmap_parloop_struct_338567.free_jump_t_292685 = jump_t_292685;
    futhark_mc_segmap_parloop_struct_338567.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_338567.free_l_n_m_292832 = l_n_m_292832;
    futhark_mc_segmap_parloop_struct_338567.free_i_292846 = i_292846;
    futhark_mc_segmap_parloop_struct_338567.free_bytes_313028 = bytes_313028;
    futhark_mc_segmap_parloop_struct_338567.free_mem_313081 = mem_313081.mem;
    futhark_mc_segmap_parloop_struct_338567.free_mem_313085 = mem_313085.mem;
    futhark_mc_segmap_parloop_struct_338567.free_ctx_param_ext_313174 =
        ctx_param_ext_313174;
    futhark_mc_segmap_parloop_struct_338567.free_ctx_param_ext_313175 =
        ctx_param_ext_313175;
    futhark_mc_segmap_parloop_struct_338567.free_ctx_param_ext_313177 =
        ctx_param_ext_313177;
    futhark_mc_segmap_parloop_struct_338567.free_mem_param_313179 =
        mem_param_313179.mem;
    futhark_mc_segmap_parloop_struct_338567.free_mem_315021 = mem_315021.mem;
    futhark_mc_segmap_parloop_struct_338567.free_bytes_315200 = bytes_315200;
    futhark_mc_segmap_parloop_struct_338567.free_mem_315304 = mem_315304.mem;
    futhark_mc_segmap_parloop_struct_338567.free_mem_315308 = mem_315308.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338568_task;
    
    futhark_mc_segmap_parloop_338568_task.name =
        "futhark_mc_segmap_parloop_338568";
    futhark_mc_segmap_parloop_338568_task.fn = futhark_mc_segmap_parloop_338568;
    futhark_mc_segmap_parloop_338568_task.args =
        &futhark_mc_segmap_parloop_struct_338567;
    futhark_mc_segmap_parloop_338568_task.iterations = iterations;
    futhark_mc_segmap_parloop_338568_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338568_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338568_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338568_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338568_task);
    
    if (futhark_mc_segmap_parloop_338568_err != 0) {
        err = futhark_mc_segmap_parloop_338568_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338568_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338568_total_end -
                 futhark_mc_segmap_parloop_338568_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338568_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338568_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338568_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_nested_task_338566_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_nested_task_338566_end -
                 futhark_mc_segmap_nested_task_338566_start;
        
        ctx->futhark_mc_segmap_nested_task_338566_runs[tid]++;
        ctx->futhark_mc_segmap_nested_task_338566_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_nested_task_338566_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_task_338595 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_l_292680;
    int64_t free_jump_t_292685;
    int64_t free_partition_sizze_292766;
    int64_t free_l_n_m_292832;
    int64_t free_i_292846;
    int64_t free_bytes_313028;
    unsigned char *free_mem_313081;
    unsigned char *free_mem_313085;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315021;
    int64_t free_bytes_315310;
    unsigned char *free_mem_315480;
    unsigned char *free_mem_315484;
};
struct futhark_mc_segmap_parloop_struct_338597 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_l_292680;
    int64_t free_jump_t_292685;
    int64_t free_partition_sizze_292766;
    int64_t free_l_n_m_292832;
    int64_t free_i_292846;
    int64_t free_bytes_313028;
    unsigned char *free_mem_313081;
    unsigned char *free_mem_313085;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315021;
    int64_t free_bytes_315310;
    unsigned char *free_mem_315480;
    unsigned char *free_mem_315484;
};
static int futhark_mc_segmap_parloop_338598(void *args, int64_t start,
                                            int64_t end, int flat_tid_306173,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338597
    *futhark_mc_segmap_parloop_struct_338597 =
    (struct futhark_mc_segmap_parloop_struct_338597 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338597->ctx;
    uint64_t futhark_mc_segmap_parloop_338598_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338598_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_338597->free_n_292675;
    int64_t q_l_292680 =
            futhark_mc_segmap_parloop_struct_338597->free_q_l_292680;
    int64_t jump_t_292685 =
            futhark_mc_segmap_parloop_struct_338597->free_jump_t_292685;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_338597->free_partition_sizze_292766;
    int64_t l_n_m_292832 =
            futhark_mc_segmap_parloop_struct_338597->free_l_n_m_292832;
    int64_t i_292846 = futhark_mc_segmap_parloop_struct_338597->free_i_292846;
    int64_t bytes_313028 =
            futhark_mc_segmap_parloop_struct_338597->free_bytes_313028;
    struct memblock mem_313081 = {.desc ="mem_313081", .mem =
                                  futhark_mc_segmap_parloop_struct_338597->free_mem_313081,
                                  .size =0, .references =NULL};
    struct memblock mem_313085 = {.desc ="mem_313085", .mem =
                                  futhark_mc_segmap_parloop_struct_338597->free_mem_313085,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_segmap_parloop_struct_338597->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_segmap_parloop_struct_338597->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_segmap_parloop_struct_338597->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_segmap_parloop_struct_338597->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315021 = {.desc ="mem_315021", .mem =
                                  futhark_mc_segmap_parloop_struct_338597->free_mem_315021,
                                  .size =0, .references =NULL};
    int64_t bytes_315310 =
            futhark_mc_segmap_parloop_struct_338597->free_bytes_315310;
    struct memblock mem_315480 = {.desc ="mem_315480", .mem =
                                  futhark_mc_segmap_parloop_struct_338597->free_mem_315480,
                                  .size =0, .references =NULL};
    struct memblock mem_315484 = {.desc ="mem_315484", .mem =
                                  futhark_mc_segmap_parloop_struct_338597->free_mem_315484,
                                  .size =0, .references =NULL};
    size_t mem_315389_cached_sizze_338599 = 0;
    unsigned char *mem_315389 = NULL;
    size_t mem_315392_cached_sizze_338600 = 0;
    unsigned char *mem_315392 = NULL;
    size_t mem_315409_cached_sizze_338601 = 0;
    unsigned char *mem_315409 = NULL;
    size_t mem_315412_cached_sizze_338602 = 0;
    unsigned char *mem_315412 = NULL;
    size_t mem_315439_cached_sizze_338603 = 0;
    unsigned char *mem_315439 = NULL;
    size_t mem_315442_cached_sizze_338604 = 0;
    unsigned char *mem_315442 = NULL;
    int64_t iterations = end - start;
    int64_t iter_330438 = start;
    
    if (mem_315389_cached_sizze_338599 < (size_t) bytes_313028) {
        mem_315389 = realloc(mem_315389, bytes_313028);
        mem_315389_cached_sizze_338599 = bytes_313028;
    }
    if (mem_315392_cached_sizze_338600 < (size_t) bytes_313028) {
        mem_315392 = realloc(mem_315392, bytes_313028);
        mem_315392_cached_sizze_338600 = bytes_313028;
    }
    if (mem_315409_cached_sizze_338601 < (size_t) bytes_315310) {
        mem_315409 = realloc(mem_315409, bytes_315310);
        mem_315409_cached_sizze_338601 = bytes_315310;
    }
    if (mem_315412_cached_sizze_338602 < (size_t) bytes_315310) {
        mem_315412 = realloc(mem_315412, bytes_315310);
        mem_315412_cached_sizze_338602 = bytes_315310;
    }
    if (mem_315439_cached_sizze_338603 < (size_t) bytes_315310) {
        mem_315439 = realloc(mem_315439, bytes_315310);
        mem_315439_cached_sizze_338603 = bytes_315310;
    }
    if (mem_315442_cached_sizze_338604 < (size_t) bytes_315310) {
        mem_315442 = realloc(mem_315442, bytes_315310);
        mem_315442_cached_sizze_338604 = bytes_315310;
    }
    for (; iter_330438 < end; iter_330438++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_330561 = partition_sizze_292766;
        int64_t gtid_306174 = iter_330438;
        int64_t remnant_330562 = iter_330438 - gtid_306174;
        
        for (int64_t i_330439 = 0; i_330439 < l_n_m_292832; i_330439++) {
            int64_t x_330442;
            
            x_330442 = ((int64_t *) mem_313081.mem)[gtid_306174 * l_n_m_292832 +
                                                    i_330439];
            
            double x_330443;
            
            x_330443 = ((double *) mem_313085.mem)[gtid_306174 * l_n_m_292832 +
                                                   i_330439];
            
            int64_t min_arg_330444 = mul64(jump_t_292685, i_330439);
            int64_t min_res_330445 = smin64(i_292846, min_arg_330444);
            int64_t defunc_0_g_res_330446 = add64((int64_t) 1, min_res_330445);
            
            for (int64_t i_330451 = 0; i_330451 < q_l_292680; i_330451++) {
                bool cond_330454 = sle64(n_292675, i_330451);
                int64_t defunc_0_f_res_330455;
                
                if (cond_330454) {
                    defunc_0_f_res_330455 = (int64_t) 0;
                } else {
                    int64_t i_330456 = add64(x_330442, i_330451);
                    int64_t defunc_1_add_res_330457 = add64((int64_t) 1,
                                                            i_330456);
                    
                    defunc_0_f_res_330455 = defunc_1_add_res_330457;
                }
                
                double defunc_0_f_res_330458;
                
                if (cond_330454) {
                    defunc_0_f_res_330458 = 0.0;
                } else {
                    int64_t i_330459 = add64(x_330442, i_330451);
                    double defunc_0_add_arg_330460;
                    
                    defunc_0_add_arg_330460 =
                        ((double *) mem_param_313179.mem)[ctx_param_ext_313174 +
                                                          (gtid_306174 *
                                                           ctx_param_ext_313175 +
                                                           i_330459 *
                                                           ctx_param_ext_313177)];
                    defunc_0_f_res_330458 = defunc_0_add_arg_330460;
                }
                
                int64_t binop_p_330461 = sub64(defunc_0_f_res_330455,
                                               defunc_0_g_res_330446);
                double defunc_0_f_res_330462 = sitofp_i64_f64(binop_p_330461);
                double abs_res_330463 = fabs(defunc_0_f_res_330462);
                double tmp1_330464 = abs_res_330463 / x_330443;
                double x_330465 = tmp1_330464 * tmp1_330464;
                double y_330466 = tmp1_330464 * x_330465;
                double tmp2_330467 = 1.0 - y_330466;
                double x_330468 = tmp2_330467 * tmp2_330467;
                double tmp3_330469 = tmp2_330467 * x_330468;
                double tmp4_330470 = defunc_0_f_res_330458 * tmp3_330469;
                
                ((double *) mem_315409)[i_330451] = defunc_0_f_res_330462;
                ((double *) mem_315412)[i_330451] = tmp4_330470;
            }
            
            double defunc_2_reduce_res_330475;
            double defunc_2_reduce_res_330476;
            double defunc_2_reduce_res_330477;
            double defunc_2_reduce_res_330478;
            double defunc_2_reduce_res_330479;
            double redout_330483;
            double redout_330484;
            double redout_330485;
            double redout_330486;
            double redout_330487;
            
            redout_330483 = 0.0;
            redout_330484 = 0.0;
            redout_330485 = 0.0;
            redout_330486 = 0.0;
            redout_330487 = 0.0;
            for (int64_t i_330482 = 0; i_330482 < q_l_292680; i_330482++) {
                double x_330490;
                
                x_330490 = ((double *) mem_315409)[i_330482];
                
                double x_330491;
                
                x_330491 = ((double *) mem_315412)[i_330482];
                
                double defunc_1_f_res_330492 = x_330490 * x_330491;
                double defunc_1_f_res_330493 = x_330490 * defunc_1_f_res_330492;
                double defunc_1_f_res_330494 = x_330490 * defunc_1_f_res_330493;
                double defunc_1_f_res_330495 = x_330490 * defunc_1_f_res_330494;
                double defunc_1_op_res_330496 = x_330491 + redout_330483;
                double defunc_1_op_res_330497 = defunc_1_f_res_330492 +
                       redout_330484;
                double defunc_1_op_res_330498 = defunc_1_f_res_330493 +
                       redout_330485;
                double defunc_1_op_res_330499 = defunc_1_f_res_330494 +
                       redout_330486;
                double defunc_1_op_res_330500 = defunc_1_f_res_330495 +
                       redout_330487;
                
                ((double *) mem_315439)[i_330482] = defunc_1_f_res_330493;
                ((double *) mem_315442)[i_330482] = defunc_1_f_res_330492;
                
                double redout_tmp_330567 = defunc_1_op_res_330496;
                double redout_tmp_330568 = defunc_1_op_res_330497;
                double redout_tmp_330569 = defunc_1_op_res_330498;
                double redout_tmp_330570 = defunc_1_op_res_330499;
                double redout_tmp_330571 = defunc_1_op_res_330500;
                
                redout_330483 = redout_tmp_330567;
                redout_330484 = redout_tmp_330568;
                redout_330485 = redout_tmp_330569;
                redout_330486 = redout_tmp_330570;
                redout_330487 = redout_tmp_330571;
            }
            defunc_2_reduce_res_330475 = redout_330483;
            defunc_2_reduce_res_330476 = redout_330484;
            defunc_2_reduce_res_330477 = redout_330485;
            defunc_2_reduce_res_330478 = redout_330486;
            defunc_2_reduce_res_330479 = redout_330487;
            
            double a_330503 = 2.220446049250313e-16 +
                   defunc_2_reduce_res_330475;
            double b_330504 = 2.220446049250313e-16 +
                   defunc_2_reduce_res_330476;
            double c_330505 = 2.220446049250313e-16 +
                   defunc_2_reduce_res_330477;
            double d_330506 = 2.220446049250313e-16 +
                   defunc_2_reduce_res_330478;
            double e_330507 = 2.220446049250313e-16 +
                   defunc_2_reduce_res_330479;
            double x_330508 = c_330505 * e_330507;
            double y_330509 = d_330506 * d_330506;
            double a12_330510 = x_330508 - y_330509;
            double x_330511 = c_330505 * d_330506;
            double y_330512 = b_330504 * e_330507;
            double b12_330513 = x_330511 - y_330512;
            double x_330514 = b_330504 * d_330506;
            double y_330515 = c_330505 * c_330505;
            double c12_330516 = x_330514 - y_330515;
            double x_330517 = a_330503 * e_330507;
            double b2_330518 = x_330517 - y_330515;
            double x_330519 = b_330504 * c_330505;
            double y_330520 = a_330503 * d_330506;
            double c2_330521 = x_330519 - y_330520;
            double x_330522 = a_330503 * a12_330510;
            double y_330523 = b_330504 * b12_330513;
            double x_330524 = x_330522 + y_330523;
            double y_330525 = c_330505 * c12_330516;
            double y_330526 = x_330524 + y_330525;
            double det_330527 = 1.0 / y_330526;
            double a12_330528 = a12_330510 * det_330527;
            double b12_330529 = b12_330513 * det_330527;
            double c12_330530 = c12_330516 * det_330527;
            double b2_330531 = b2_330518 * det_330527;
            double c2_330532 = c2_330521 * det_330527;
            double defunc_2_reduce_res_330533;
            double defunc_2_reduce_res_330534;
            double redout_330536;
            double redout_330537;
            
            redout_330536 = 0.0;
            redout_330537 = 0.0;
            for (int64_t i_330535 = 0; i_330535 < q_l_292680; i_330535++) {
                double x_330538;
                
                x_330538 = ((double *) mem_315412)[i_330535];
                
                double x_330539;
                
                x_330539 = ((double *) mem_315442)[i_330535];
                
                double x_330540;
                
                x_330540 = ((double *) mem_315439)[i_330535];
                
                bool cond_330541 = sle64(n_292675, i_330535);
                double defunc_0_f_res_330542;
                
                if (cond_330541) {
                    defunc_0_f_res_330542 = 0.0;
                } else {
                    int64_t i_330543 = add64(x_330442, i_330535);
                    double defunc_0_add_arg_330544;
                    
                    defunc_0_add_arg_330544 =
                        ((double *) mem_315021.mem)[gtid_306174 * n_292675 +
                                                    i_330543];
                    defunc_0_f_res_330542 = defunc_0_add_arg_330544;
                }
                
                double x_330545 = a12_330528 * x_330538;
                double y_330546 = b12_330529 * x_330539;
                double x_330547 = x_330545 + y_330546;
                double y_330548 = c12_330530 * x_330540;
                double x_330549 = x_330547 + y_330548;
                double defunc_9_fit_fun_res_330550 = defunc_0_f_res_330542 *
                       x_330549;
                double x_330551 = b12_330529 * x_330538;
                double y_330552 = b2_330531 * x_330539;
                double x_330553 = x_330551 + y_330552;
                double y_330554 = c2_330532 * x_330540;
                double x_330555 = x_330553 + y_330554;
                double defunc_9_slope_fun_res_330556 = defunc_0_f_res_330542 *
                       x_330555;
                double defunc_1_op_res_330557 = defunc_9_fit_fun_res_330550 +
                       redout_330536;
                double defunc_1_op_res_330558 = defunc_9_slope_fun_res_330556 +
                       redout_330537;
                double redout_tmp_330574 = defunc_1_op_res_330557;
                double redout_tmp_330575 = defunc_1_op_res_330558;
                
                redout_330536 = redout_tmp_330574;
                redout_330537 = redout_tmp_330575;
            }
            defunc_2_reduce_res_330533 = redout_330536;
            defunc_2_reduce_res_330534 = redout_330537;
            ((double *) mem_315389)[i_330439] = defunc_2_reduce_res_330533;
            ((double *) mem_315392)[i_330439] = defunc_2_reduce_res_330534;
        }
        if (l_n_m_292832 * (int64_t) 8 > 0)
            memmove(mem_315480.mem + gtid_306174 * l_n_m_292832 * (int64_t) 8,
                    mem_315389 + (int64_t) 0, l_n_m_292832 * (int64_t) 8);
        if (l_n_m_292832 * (int64_t) 8 > 0)
            memmove(mem_315484.mem + gtid_306174 * l_n_m_292832 * (int64_t) 8,
                    mem_315392 + (int64_t) 0, l_n_m_292832 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_315389);
    free(mem_315392);
    free(mem_315409);
    free(mem_315412);
    free(mem_315439);
    free(mem_315442);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338598_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338598_end -
                 futhark_mc_segmap_parloop_338598_start;
        
        ctx->futhark_mc_segmap_parloop_338598_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338598_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338598_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_338596(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_306173 = tid;
    int num_tasks_330437 = info.nsubtasks;
    struct futhark_mc_task_338595 *futhark_mc_task_338595 =
                                  (struct futhark_mc_task_338595 *) args;
    struct futhark_context *ctx = futhark_mc_task_338595->ctx;
    uint64_t futhark_mc_segmap_task_338596_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_338596_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338595->free_n_292675;
    int64_t q_l_292680 = futhark_mc_task_338595->free_q_l_292680;
    int64_t jump_t_292685 = futhark_mc_task_338595->free_jump_t_292685;
    int64_t partition_sizze_292766 =
            futhark_mc_task_338595->free_partition_sizze_292766;
    int64_t l_n_m_292832 = futhark_mc_task_338595->free_l_n_m_292832;
    int64_t i_292846 = futhark_mc_task_338595->free_i_292846;
    int64_t bytes_313028 = futhark_mc_task_338595->free_bytes_313028;
    struct memblock mem_313081 = {.desc ="mem_313081", .mem =
                                  futhark_mc_task_338595->free_mem_313081,
                                  .size =0, .references =NULL};
    struct memblock mem_313085 = {.desc ="mem_313085", .mem =
                                  futhark_mc_task_338595->free_mem_313085,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_task_338595->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_task_338595->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_task_338595->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_task_338595->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315021 = {.desc ="mem_315021", .mem =
                                  futhark_mc_task_338595->free_mem_315021,
                                  .size =0, .references =NULL};
    int64_t bytes_315310 = futhark_mc_task_338595->free_bytes_315310;
    struct memblock mem_315480 = {.desc ="mem_315480", .mem =
                                  futhark_mc_task_338595->free_mem_315480,
                                  .size =0, .references =NULL};
    struct memblock mem_315484 = {.desc ="mem_315484", .mem =
                                  futhark_mc_task_338595->free_mem_315484,
                                  .size =0, .references =NULL};
    int64_t iter_330438;
    struct futhark_mc_segmap_parloop_struct_338597
    futhark_mc_segmap_parloop_struct_338597;
    
    futhark_mc_segmap_parloop_struct_338597.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338597.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_338597.free_q_l_292680 = q_l_292680;
    futhark_mc_segmap_parloop_struct_338597.free_jump_t_292685 = jump_t_292685;
    futhark_mc_segmap_parloop_struct_338597.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_338597.free_l_n_m_292832 = l_n_m_292832;
    futhark_mc_segmap_parloop_struct_338597.free_i_292846 = i_292846;
    futhark_mc_segmap_parloop_struct_338597.free_bytes_313028 = bytes_313028;
    futhark_mc_segmap_parloop_struct_338597.free_mem_313081 = mem_313081.mem;
    futhark_mc_segmap_parloop_struct_338597.free_mem_313085 = mem_313085.mem;
    futhark_mc_segmap_parloop_struct_338597.free_ctx_param_ext_313174 =
        ctx_param_ext_313174;
    futhark_mc_segmap_parloop_struct_338597.free_ctx_param_ext_313175 =
        ctx_param_ext_313175;
    futhark_mc_segmap_parloop_struct_338597.free_ctx_param_ext_313177 =
        ctx_param_ext_313177;
    futhark_mc_segmap_parloop_struct_338597.free_mem_param_313179 =
        mem_param_313179.mem;
    futhark_mc_segmap_parloop_struct_338597.free_mem_315021 = mem_315021.mem;
    futhark_mc_segmap_parloop_struct_338597.free_bytes_315310 = bytes_315310;
    futhark_mc_segmap_parloop_struct_338597.free_mem_315480 = mem_315480.mem;
    futhark_mc_segmap_parloop_struct_338597.free_mem_315484 = mem_315484.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338598_task;
    
    futhark_mc_segmap_parloop_338598_task.name =
        "futhark_mc_segmap_parloop_338598";
    futhark_mc_segmap_parloop_338598_task.fn = futhark_mc_segmap_parloop_338598;
    futhark_mc_segmap_parloop_338598_task.args =
        &futhark_mc_segmap_parloop_struct_338597;
    futhark_mc_segmap_parloop_338598_task.iterations = iterations;
    futhark_mc_segmap_parloop_338598_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338598_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338598_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338598_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338598_task);
    
    if (futhark_mc_segmap_parloop_338598_err != 0) {
        err = futhark_mc_segmap_parloop_338598_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338598_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338598_total_end -
                 futhark_mc_segmap_parloop_338598_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338598_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338598_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338598_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_338596_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_338596_end -
                 futhark_mc_segmap_task_338596_start;
        
        ctx->futhark_mc_segmap_task_338596_runs[tid]++;
        ctx->futhark_mc_segmap_task_338596_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_338596_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_segmap_parloop_struct_338606 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_l_292680;
    int64_t free_jump_t_292685;
    int64_t free_partition_sizze_292766;
    int64_t free_l_n_m_292832;
    int64_t free_i_292846;
    int64_t free_bytes_313028;
    unsigned char *free_mem_313081;
    unsigned char *free_mem_313085;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315021;
    int64_t free_bytes_315310;
    unsigned char *free_mem_315480;
    unsigned char *free_mem_315484;
};
struct futhark_mc_task_338610 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_l_292680;
    int64_t free_jump_t_292685;
    int64_t free_l_n_m_292832;
    int64_t free_i_292846;
    int64_t free_gtid_306308;
    unsigned char *free_mem_313081;
    unsigned char *free_mem_313085;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315021;
    int64_t free_bytes_315310;
    unsigned char *free_mem_315383;
    unsigned char *free_mem_315386;
};
struct futhark_mc_segmap_parloop_struct_338612 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_l_292680;
    int64_t free_jump_t_292685;
    int64_t free_l_n_m_292832;
    int64_t free_i_292846;
    int64_t free_gtid_306308;
    unsigned char *free_mem_313081;
    unsigned char *free_mem_313085;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315021;
    int64_t free_bytes_315310;
    unsigned char *free_mem_315383;
    unsigned char *free_mem_315386;
};
static int futhark_mc_segmap_parloop_338613(void *args, int64_t start,
                                            int64_t end, int flat_tid_330698,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338612
    *futhark_mc_segmap_parloop_struct_338612 =
    (struct futhark_mc_segmap_parloop_struct_338612 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338612->ctx;
    uint64_t futhark_mc_segmap_parloop_338613_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338613_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_338612->free_n_292675;
    int64_t q_l_292680 =
            futhark_mc_segmap_parloop_struct_338612->free_q_l_292680;
    int64_t jump_t_292685 =
            futhark_mc_segmap_parloop_struct_338612->free_jump_t_292685;
    int64_t l_n_m_292832 =
            futhark_mc_segmap_parloop_struct_338612->free_l_n_m_292832;
    int64_t i_292846 = futhark_mc_segmap_parloop_struct_338612->free_i_292846;
    int64_t gtid_306308 =
            futhark_mc_segmap_parloop_struct_338612->free_gtid_306308;
    struct memblock mem_313081 = {.desc ="mem_313081", .mem =
                                  futhark_mc_segmap_parloop_struct_338612->free_mem_313081,
                                  .size =0, .references =NULL};
    struct memblock mem_313085 = {.desc ="mem_313085", .mem =
                                  futhark_mc_segmap_parloop_struct_338612->free_mem_313085,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_segmap_parloop_struct_338612->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_segmap_parloop_struct_338612->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_segmap_parloop_struct_338612->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_segmap_parloop_struct_338612->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315021 = {.desc ="mem_315021", .mem =
                                  futhark_mc_segmap_parloop_struct_338612->free_mem_315021,
                                  .size =0, .references =NULL};
    int64_t bytes_315310 =
            futhark_mc_segmap_parloop_struct_338612->free_bytes_315310;
    struct memblock mem_315383 = {.desc ="mem_315383", .mem =
                                  futhark_mc_segmap_parloop_struct_338612->free_mem_315383,
                                  .size =0, .references =NULL};
    struct memblock mem_315386 = {.desc ="mem_315386", .mem =
                                  futhark_mc_segmap_parloop_struct_338612->free_mem_315386,
                                  .size =0, .references =NULL};
    size_t mem_330705_cached_sizze_338614 = 0;
    unsigned char *mem_330705 = NULL;
    size_t mem_330707_cached_sizze_338615 = 0;
    unsigned char *mem_330707 = NULL;
    size_t mem_330733_cached_sizze_338616 = 0;
    unsigned char *mem_330733 = NULL;
    size_t mem_330735_cached_sizze_338617 = 0;
    unsigned char *mem_330735 = NULL;
    int64_t iterations = end - start;
    int64_t iter_330824 = start;
    
    if (mem_330705_cached_sizze_338614 < (size_t) bytes_315310) {
        mem_330705 = realloc(mem_330705, bytes_315310);
        mem_330705_cached_sizze_338614 = bytes_315310;
    }
    if (mem_330707_cached_sizze_338615 < (size_t) bytes_315310) {
        mem_330707 = realloc(mem_330707, bytes_315310);
        mem_330707_cached_sizze_338615 = bytes_315310;
    }
    if (mem_330733_cached_sizze_338616 < (size_t) bytes_315310) {
        mem_330733 = realloc(mem_330733, bytes_315310);
        mem_330733_cached_sizze_338616 = bytes_315310;
    }
    if (mem_330735_cached_sizze_338617 < (size_t) bytes_315310) {
        mem_330735 = realloc(mem_330735, bytes_315310);
        mem_330735_cached_sizze_338617 = bytes_315310;
    }
    for (; iter_330824 < end; iter_330824++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_330892 = l_n_m_292832;
        int64_t gtid_330699 = iter_330824;
        int64_t remnant_330893 = iter_330824 - gtid_330699;
        int64_t x_330700;
        
        x_330700 = ((int64_t *) mem_313081.mem)[gtid_306308 * l_n_m_292832 +
                                                gtid_330699];
        
        double x_330701;
        
        x_330701 = ((double *) mem_313085.mem)[gtid_306308 * l_n_m_292832 +
                                               gtid_330699];
        
        int64_t min_arg_330702 = mul64(jump_t_292685, gtid_330699);
        int64_t min_res_330703 = smin64(i_292846, min_arg_330702);
        int64_t defunc_0_g_res_330704 = add64((int64_t) 1, min_res_330703);
        
        for (int64_t i_330825 = 0; i_330825 < q_l_292680; i_330825++) {
            bool cond_330828 = sle64(n_292675, i_330825);
            int64_t defunc_0_f_res_330829;
            
            if (cond_330828) {
                defunc_0_f_res_330829 = (int64_t) 0;
            } else {
                int64_t i_330830 = add64(x_330700, i_330825);
                int64_t defunc_1_add_res_330831 = add64((int64_t) 1, i_330830);
                
                defunc_0_f_res_330829 = defunc_1_add_res_330831;
            }
            
            double defunc_0_f_res_330832;
            
            if (cond_330828) {
                defunc_0_f_res_330832 = 0.0;
            } else {
                int64_t i_330833 = add64(x_330700, i_330825);
                double defunc_0_add_arg_330834;
                
                defunc_0_add_arg_330834 =
                    ((double *) mem_param_313179.mem)[ctx_param_ext_313174 +
                                                      (gtid_306308 *
                                                       ctx_param_ext_313175 +
                                                       i_330833 *
                                                       ctx_param_ext_313177)];
                defunc_0_f_res_330832 = defunc_0_add_arg_330834;
            }
            
            int64_t binop_p_330835 = sub64(defunc_0_f_res_330829,
                                           defunc_0_g_res_330704);
            double defunc_0_f_res_330836 = sitofp_i64_f64(binop_p_330835);
            double abs_res_330837 = fabs(defunc_0_f_res_330836);
            double tmp1_330838 = abs_res_330837 / x_330701;
            double x_330839 = tmp1_330838 * tmp1_330838;
            double y_330840 = tmp1_330838 * x_330839;
            double tmp2_330841 = 1.0 - y_330840;
            double x_330842 = tmp2_330841 * tmp2_330841;
            double tmp3_330843 = tmp2_330841 * x_330842;
            double tmp4_330844 = defunc_0_f_res_330832 * tmp3_330843;
            
            ((double *) mem_330705)[i_330825] = defunc_0_f_res_330836;
            ((double *) mem_330707)[i_330825] = tmp4_330844;
        }
        
        double defunc_2_reduce_res_330737;
        double defunc_2_reduce_res_330738;
        double defunc_2_reduce_res_330739;
        double defunc_2_reduce_res_330740;
        double defunc_2_reduce_res_330741;
        double redout_330848;
        double redout_330849;
        double redout_330850;
        double redout_330851;
        double redout_330852;
        
        redout_330848 = 0.0;
        redout_330849 = 0.0;
        redout_330850 = 0.0;
        redout_330851 = 0.0;
        redout_330852 = 0.0;
        for (int64_t i_330847 = 0; i_330847 < q_l_292680; i_330847++) {
            double x_330855;
            
            x_330855 = ((double *) mem_330705)[i_330847];
            
            double x_330856;
            
            x_330856 = ((double *) mem_330707)[i_330847];
            
            double defunc_1_f_res_330857 = x_330855 * x_330856;
            double defunc_1_f_res_330858 = x_330855 * defunc_1_f_res_330857;
            double defunc_1_f_res_330859 = x_330855 * defunc_1_f_res_330858;
            double defunc_1_f_res_330860 = x_330855 * defunc_1_f_res_330859;
            double defunc_1_op_res_330861 = x_330856 + redout_330848;
            double defunc_1_op_res_330862 = defunc_1_f_res_330857 +
                   redout_330849;
            double defunc_1_op_res_330863 = defunc_1_f_res_330858 +
                   redout_330850;
            double defunc_1_op_res_330864 = defunc_1_f_res_330859 +
                   redout_330851;
            double defunc_1_op_res_330865 = defunc_1_f_res_330860 +
                   redout_330852;
            
            ((double *) mem_330733)[i_330847] = defunc_1_f_res_330858;
            ((double *) mem_330735)[i_330847] = defunc_1_f_res_330857;
            
            double redout_tmp_330896 = defunc_1_op_res_330861;
            double redout_tmp_330897 = defunc_1_op_res_330862;
            double redout_tmp_330898 = defunc_1_op_res_330863;
            double redout_tmp_330899 = defunc_1_op_res_330864;
            double redout_tmp_330900 = defunc_1_op_res_330865;
            
            redout_330848 = redout_tmp_330896;
            redout_330849 = redout_tmp_330897;
            redout_330850 = redout_tmp_330898;
            redout_330851 = redout_tmp_330899;
            redout_330852 = redout_tmp_330900;
        }
        defunc_2_reduce_res_330737 = redout_330848;
        defunc_2_reduce_res_330738 = redout_330849;
        defunc_2_reduce_res_330739 = redout_330850;
        defunc_2_reduce_res_330740 = redout_330851;
        defunc_2_reduce_res_330741 = redout_330852;
        
        double a_330765 = 2.220446049250313e-16 + defunc_2_reduce_res_330737;
        double b_330766 = 2.220446049250313e-16 + defunc_2_reduce_res_330738;
        double c_330767 = 2.220446049250313e-16 + defunc_2_reduce_res_330739;
        double d_330768 = 2.220446049250313e-16 + defunc_2_reduce_res_330740;
        double e_330769 = 2.220446049250313e-16 + defunc_2_reduce_res_330741;
        double x_330770 = c_330767 * e_330769;
        double y_330771 = d_330768 * d_330768;
        double a12_330772 = x_330770 - y_330771;
        double x_330773 = c_330767 * d_330768;
        double y_330774 = b_330766 * e_330769;
        double b12_330775 = x_330773 - y_330774;
        double x_330776 = b_330766 * d_330768;
        double y_330777 = c_330767 * c_330767;
        double c12_330778 = x_330776 - y_330777;
        double x_330779 = a_330765 * e_330769;
        double b2_330780 = x_330779 - y_330777;
        double x_330781 = b_330766 * c_330767;
        double y_330782 = a_330765 * d_330768;
        double c2_330783 = x_330781 - y_330782;
        double x_330784 = a_330765 * a12_330772;
        double y_330785 = b_330766 * b12_330775;
        double x_330786 = x_330784 + y_330785;
        double y_330787 = c_330767 * c12_330778;
        double y_330788 = x_330786 + y_330787;
        double det_330789 = 1.0 / y_330788;
        double a12_330790 = a12_330772 * det_330789;
        double b12_330791 = b12_330775 * det_330789;
        double c12_330792 = c12_330778 * det_330789;
        double b2_330793 = b2_330780 * det_330789;
        double c2_330794 = c2_330783 * det_330789;
        double defunc_2_reduce_res_330795;
        double defunc_2_reduce_res_330796;
        double redout_330869;
        double redout_330870;
        
        redout_330869 = 0.0;
        redout_330870 = 0.0;
        for (int64_t i_330868 = 0; i_330868 < q_l_292680; i_330868++) {
            double x_330871;
            
            x_330871 = ((double *) mem_330707)[i_330868];
            
            double x_330872;
            
            x_330872 = ((double *) mem_330735)[i_330868];
            
            double x_330873;
            
            x_330873 = ((double *) mem_330733)[i_330868];
            
            bool cond_330874 = sle64(n_292675, i_330868);
            double defunc_0_f_res_330875;
            
            if (cond_330874) {
                defunc_0_f_res_330875 = 0.0;
            } else {
                int64_t i_330876 = add64(x_330700, i_330868);
                double defunc_0_add_arg_330877;
                
                defunc_0_add_arg_330877 =
                    ((double *) mem_315021.mem)[gtid_306308 * n_292675 +
                                                i_330876];
                defunc_0_f_res_330875 = defunc_0_add_arg_330877;
            }
            
            double x_330878 = a12_330790 * x_330871;
            double y_330879 = b12_330791 * x_330872;
            double x_330880 = x_330878 + y_330879;
            double y_330881 = c12_330792 * x_330873;
            double x_330882 = x_330880 + y_330881;
            double defunc_9_fit_fun_res_330883 = defunc_0_f_res_330875 *
                   x_330882;
            double x_330884 = b12_330791 * x_330871;
            double y_330885 = b2_330793 * x_330872;
            double x_330886 = x_330884 + y_330885;
            double y_330887 = c2_330794 * x_330873;
            double x_330888 = x_330886 + y_330887;
            double defunc_9_slope_fun_res_330889 = defunc_0_f_res_330875 *
                   x_330888;
            double defunc_1_op_res_330890 = defunc_9_fit_fun_res_330883 +
                   redout_330869;
            double defunc_1_op_res_330891 = defunc_9_slope_fun_res_330889 +
                   redout_330870;
            double redout_tmp_330903 = defunc_1_op_res_330890;
            double redout_tmp_330904 = defunc_1_op_res_330891;
            
            redout_330869 = redout_tmp_330903;
            redout_330870 = redout_tmp_330904;
        }
        defunc_2_reduce_res_330795 = redout_330869;
        defunc_2_reduce_res_330796 = redout_330870;
        ((double *) mem_315383.mem)[gtid_330699] = defunc_2_reduce_res_330795;
        ((double *) mem_315386.mem)[gtid_330699] = defunc_2_reduce_res_330796;
    }
    
  cleanup:
    { }
    free(mem_330705);
    free(mem_330707);
    free(mem_330733);
    free(mem_330735);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338613_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338613_end -
                 futhark_mc_segmap_parloop_338613_start;
        
        ctx->futhark_mc_segmap_parloop_338613_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338613_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338613_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_338611(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_330698 = tid;
    int num_tasks_330823 = info.nsubtasks;
    struct futhark_mc_task_338610 *futhark_mc_task_338610 =
                                  (struct futhark_mc_task_338610 *) args;
    struct futhark_context *ctx = futhark_mc_task_338610->ctx;
    uint64_t futhark_mc_segmap_task_338611_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_338611_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338610->free_n_292675;
    int64_t q_l_292680 = futhark_mc_task_338610->free_q_l_292680;
    int64_t jump_t_292685 = futhark_mc_task_338610->free_jump_t_292685;
    int64_t l_n_m_292832 = futhark_mc_task_338610->free_l_n_m_292832;
    int64_t i_292846 = futhark_mc_task_338610->free_i_292846;
    int64_t gtid_306308 = futhark_mc_task_338610->free_gtid_306308;
    struct memblock mem_313081 = {.desc ="mem_313081", .mem =
                                  futhark_mc_task_338610->free_mem_313081,
                                  .size =0, .references =NULL};
    struct memblock mem_313085 = {.desc ="mem_313085", .mem =
                                  futhark_mc_task_338610->free_mem_313085,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_task_338610->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_task_338610->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_task_338610->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_task_338610->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315021 = {.desc ="mem_315021", .mem =
                                  futhark_mc_task_338610->free_mem_315021,
                                  .size =0, .references =NULL};
    int64_t bytes_315310 = futhark_mc_task_338610->free_bytes_315310;
    struct memblock mem_315383 = {.desc ="mem_315383", .mem =
                                  futhark_mc_task_338610->free_mem_315383,
                                  .size =0, .references =NULL};
    struct memblock mem_315386 = {.desc ="mem_315386", .mem =
                                  futhark_mc_task_338610->free_mem_315386,
                                  .size =0, .references =NULL};
    int64_t iter_330824;
    struct futhark_mc_segmap_parloop_struct_338612
    futhark_mc_segmap_parloop_struct_338612;
    
    futhark_mc_segmap_parloop_struct_338612.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338612.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_338612.free_q_l_292680 = q_l_292680;
    futhark_mc_segmap_parloop_struct_338612.free_jump_t_292685 = jump_t_292685;
    futhark_mc_segmap_parloop_struct_338612.free_l_n_m_292832 = l_n_m_292832;
    futhark_mc_segmap_parloop_struct_338612.free_i_292846 = i_292846;
    futhark_mc_segmap_parloop_struct_338612.free_gtid_306308 = gtid_306308;
    futhark_mc_segmap_parloop_struct_338612.free_mem_313081 = mem_313081.mem;
    futhark_mc_segmap_parloop_struct_338612.free_mem_313085 = mem_313085.mem;
    futhark_mc_segmap_parloop_struct_338612.free_ctx_param_ext_313174 =
        ctx_param_ext_313174;
    futhark_mc_segmap_parloop_struct_338612.free_ctx_param_ext_313175 =
        ctx_param_ext_313175;
    futhark_mc_segmap_parloop_struct_338612.free_ctx_param_ext_313177 =
        ctx_param_ext_313177;
    futhark_mc_segmap_parloop_struct_338612.free_mem_param_313179 =
        mem_param_313179.mem;
    futhark_mc_segmap_parloop_struct_338612.free_mem_315021 = mem_315021.mem;
    futhark_mc_segmap_parloop_struct_338612.free_bytes_315310 = bytes_315310;
    futhark_mc_segmap_parloop_struct_338612.free_mem_315383 = mem_315383.mem;
    futhark_mc_segmap_parloop_struct_338612.free_mem_315386 = mem_315386.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338613_task;
    
    futhark_mc_segmap_parloop_338613_task.name =
        "futhark_mc_segmap_parloop_338613";
    futhark_mc_segmap_parloop_338613_task.fn = futhark_mc_segmap_parloop_338613;
    futhark_mc_segmap_parloop_338613_task.args =
        &futhark_mc_segmap_parloop_struct_338612;
    futhark_mc_segmap_parloop_338613_task.iterations = iterations;
    futhark_mc_segmap_parloop_338613_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338613_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338613_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338613_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338613_task);
    
    if (futhark_mc_segmap_parloop_338613_err != 0) {
        err = futhark_mc_segmap_parloop_338613_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338613_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338613_total_end -
                 futhark_mc_segmap_parloop_338613_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338613_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338613_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338613_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_338611_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_338611_end -
                 futhark_mc_segmap_task_338611_start;
        
        ctx->futhark_mc_segmap_task_338611_runs[tid]++;
        ctx->futhark_mc_segmap_task_338611_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_338611_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_segmap_parloop_struct_338619 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_l_292680;
    int64_t free_jump_t_292685;
    int64_t free_l_n_m_292832;
    int64_t free_i_292846;
    int64_t free_gtid_306308;
    unsigned char *free_mem_313081;
    unsigned char *free_mem_313085;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315021;
    int64_t free_bytes_315310;
    unsigned char *free_mem_315383;
    unsigned char *free_mem_315386;
};
struct futhark_mc_task_338625 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_l_292680;
    int64_t free_gtid_306308;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    int64_t free_x_330579;
    double free_x_330580;
    int64_t free_defunc_0_g_res_330583;
    unsigned char *free_mem_330584;
    unsigned char *free_mem_330585;
};
struct futhark_mc_segmap_parloop_struct_338627 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_l_292680;
    int64_t free_gtid_306308;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    int64_t free_x_330579;
    double free_x_330580;
    int64_t free_defunc_0_g_res_330583;
    unsigned char *free_mem_330584;
    unsigned char *free_mem_330585;
};
static int futhark_mc_segmap_parloop_338628(void *args, int64_t start,
                                            int64_t end, int flat_tid_330906,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338627
    *futhark_mc_segmap_parloop_struct_338627 =
    (struct futhark_mc_segmap_parloop_struct_338627 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338627->ctx;
    uint64_t futhark_mc_segmap_parloop_338628_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338628_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_338627->free_n_292675;
    int64_t q_l_292680 =
            futhark_mc_segmap_parloop_struct_338627->free_q_l_292680;
    int64_t gtid_306308 =
            futhark_mc_segmap_parloop_struct_338627->free_gtid_306308;
    int64_t ctx_param_ext_313174 =
            futhark_mc_segmap_parloop_struct_338627->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_segmap_parloop_struct_338627->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_segmap_parloop_struct_338627->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_segmap_parloop_struct_338627->free_mem_param_313179,
                                        .size =0, .references =NULL};
    int64_t x_330579 = futhark_mc_segmap_parloop_struct_338627->free_x_330579;
    double x_330580 = futhark_mc_segmap_parloop_struct_338627->free_x_330580;
    int64_t defunc_0_g_res_330583 =
            futhark_mc_segmap_parloop_struct_338627->free_defunc_0_g_res_330583;
    struct memblock mem_330584 = {.desc ="mem_330584", .mem =
                                  futhark_mc_segmap_parloop_struct_338627->free_mem_330584,
                                  .size =0, .references =NULL};
    struct memblock mem_330585 = {.desc ="mem_330585", .mem =
                                  futhark_mc_segmap_parloop_struct_338627->free_mem_330585,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_330978 = start;
    
    for (; iter_330978 < end; iter_330978++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_330983 = q_l_292680;
        int64_t gtid_330907 = iter_330978;
        int64_t remnant_330984 = iter_330978 - gtid_330907;
        bool cond_330908 = sle64(n_292675, gtid_330907);
        int64_t defunc_0_f_res_330909;
        
        if (cond_330908) {
            defunc_0_f_res_330909 = (int64_t) 0;
        } else {
            int64_t i_330979 = add64(x_330579, gtid_330907);
            int64_t defunc_1_add_res_330980 = add64((int64_t) 1, i_330979);
            
            defunc_0_f_res_330909 = defunc_1_add_res_330980;
        }
        
        double defunc_0_f_res_330912;
        
        if (cond_330908) {
            defunc_0_f_res_330912 = 0.0;
        } else {
            int64_t i_330981 = add64(x_330579, gtid_330907);
            double defunc_0_add_arg_330982;
            
            defunc_0_add_arg_330982 =
                ((double *) mem_param_313179.mem)[ctx_param_ext_313174 +
                                                  (gtid_306308 *
                                                   ctx_param_ext_313175 +
                                                   i_330981 *
                                                   ctx_param_ext_313177)];
            defunc_0_f_res_330912 = defunc_0_add_arg_330982;
        }
        
        int64_t binop_p_330915 = sub64(defunc_0_f_res_330909,
                                       defunc_0_g_res_330583);
        double defunc_0_f_res_330916 = sitofp_i64_f64(binop_p_330915);
        double abs_res_330917 = fabs(defunc_0_f_res_330916);
        double tmp1_330918 = abs_res_330917 / x_330580;
        double x_330919 = tmp1_330918 * tmp1_330918;
        double y_330920 = tmp1_330918 * x_330919;
        double tmp2_330921 = 1.0 - y_330920;
        double x_330922 = tmp2_330921 * tmp2_330921;
        double tmp3_330923 = tmp2_330921 * x_330922;
        double tmp4_330924 = defunc_0_f_res_330912 * tmp3_330923;
        
        ((double *) mem_330584.mem)[gtid_330907] = defunc_0_f_res_330916;
        ((double *) mem_330585.mem)[gtid_330907] = tmp4_330924;
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338628_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338628_end -
                 futhark_mc_segmap_parloop_338628_start;
        
        ctx->futhark_mc_segmap_parloop_338628_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338628_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338628_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_338626(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_330906 = tid;
    int num_tasks_330977 = info.nsubtasks;
    struct futhark_mc_task_338625 *futhark_mc_task_338625 =
                                  (struct futhark_mc_task_338625 *) args;
    struct futhark_context *ctx = futhark_mc_task_338625->ctx;
    uint64_t futhark_mc_segmap_task_338626_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_338626_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338625->free_n_292675;
    int64_t q_l_292680 = futhark_mc_task_338625->free_q_l_292680;
    int64_t gtid_306308 = futhark_mc_task_338625->free_gtid_306308;
    int64_t ctx_param_ext_313174 =
            futhark_mc_task_338625->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_task_338625->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_task_338625->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_task_338625->free_mem_param_313179,
                                        .size =0, .references =NULL};
    int64_t x_330579 = futhark_mc_task_338625->free_x_330579;
    double x_330580 = futhark_mc_task_338625->free_x_330580;
    int64_t defunc_0_g_res_330583 =
            futhark_mc_task_338625->free_defunc_0_g_res_330583;
    struct memblock mem_330584 = {.desc ="mem_330584", .mem =
                                  futhark_mc_task_338625->free_mem_330584,
                                  .size =0, .references =NULL};
    struct memblock mem_330585 = {.desc ="mem_330585", .mem =
                                  futhark_mc_task_338625->free_mem_330585,
                                  .size =0, .references =NULL};
    int64_t iter_330978;
    struct futhark_mc_segmap_parloop_struct_338627
    futhark_mc_segmap_parloop_struct_338627;
    
    futhark_mc_segmap_parloop_struct_338627.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338627.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_338627.free_q_l_292680 = q_l_292680;
    futhark_mc_segmap_parloop_struct_338627.free_gtid_306308 = gtid_306308;
    futhark_mc_segmap_parloop_struct_338627.free_ctx_param_ext_313174 =
        ctx_param_ext_313174;
    futhark_mc_segmap_parloop_struct_338627.free_ctx_param_ext_313175 =
        ctx_param_ext_313175;
    futhark_mc_segmap_parloop_struct_338627.free_ctx_param_ext_313177 =
        ctx_param_ext_313177;
    futhark_mc_segmap_parloop_struct_338627.free_mem_param_313179 =
        mem_param_313179.mem;
    futhark_mc_segmap_parloop_struct_338627.free_x_330579 = x_330579;
    futhark_mc_segmap_parloop_struct_338627.free_x_330580 = x_330580;
    futhark_mc_segmap_parloop_struct_338627.free_defunc_0_g_res_330583 =
        defunc_0_g_res_330583;
    futhark_mc_segmap_parloop_struct_338627.free_mem_330584 = mem_330584.mem;
    futhark_mc_segmap_parloop_struct_338627.free_mem_330585 = mem_330585.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338628_task;
    
    futhark_mc_segmap_parloop_338628_task.name =
        "futhark_mc_segmap_parloop_338628";
    futhark_mc_segmap_parloop_338628_task.fn = futhark_mc_segmap_parloop_338628;
    futhark_mc_segmap_parloop_338628_task.args =
        &futhark_mc_segmap_parloop_struct_338627;
    futhark_mc_segmap_parloop_338628_task.iterations = iterations;
    futhark_mc_segmap_parloop_338628_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338628_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338628_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338628_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338628_task);
    
    if (futhark_mc_segmap_parloop_338628_err != 0) {
        err = futhark_mc_segmap_parloop_338628_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338628_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338628_total_end -
                 futhark_mc_segmap_parloop_338628_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338628_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338628_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338628_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_338626_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_338626_end -
                 futhark_mc_segmap_task_338626_start;
        
        ctx->futhark_mc_segmap_task_338626_runs[tid]++;
        ctx->futhark_mc_segmap_task_338626_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_338626_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_task_338629 {
    struct futhark_context *ctx;
    unsigned char *free_mem_330584;
    unsigned char *free_mem_330585;
    double *retval_defunc_2_reduce_res_330609;
    double *retval_defunc_2_reduce_res_330610;
    double *retval_defunc_2_reduce_res_330611;
    double *retval_defunc_2_reduce_res_330612;
    double *retval_defunc_2_reduce_res_330613;
    unsigned char *retval_mem_330607;
    unsigned char *retval_mem_330608;
};
struct futhark_mc_segred_stage_1_parloop_struct_338636 {
    struct futhark_context *ctx;
    unsigned char *free_mem_330584;
    unsigned char *free_mem_330585;
    unsigned char *free_mem_330607;
    unsigned char *free_mem_330608;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_330986;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_330988;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_330990;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_330992;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_330994;
};
static int futhark_mc_segred_stage_1_parloop_338637(void *args, int64_t start,
                                                    int64_t end,
                                                    int flat_tid_330925,
                                                    int tid)
{
    int err = 0;
    struct futhark_mc_segred_stage_1_parloop_struct_338636
    *futhark_mc_segred_stage_1_parloop_struct_338636 =
    (struct futhark_mc_segred_stage_1_parloop_struct_338636 *) args;
    struct futhark_context *ctx =
                           futhark_mc_segred_stage_1_parloop_struct_338636->ctx;
    uint64_t futhark_mc_segred_stage_1_parloop_338637_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_338637_start = get_wall_time();
    
    struct memblock mem_330584 = {.desc ="mem_330584", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_338636->free_mem_330584,
                                  .size =0, .references =NULL};
    struct memblock mem_330585 = {.desc ="mem_330585", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_338636->free_mem_330585,
                                  .size =0, .references =NULL};
    struct memblock mem_330607 = {.desc ="mem_330607", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_338636->free_mem_330607,
                                  .size =0, .references =NULL};
    struct memblock mem_330608 = {.desc ="mem_330608", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_338636->free_mem_330608,
                                  .size =0, .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_330986 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_330986",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338636->free_reduce_stage_1_tid_res_arr_mem_330986,
                                                             .size =0,
                                                             .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_330988 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_330988",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338636->free_reduce_stage_1_tid_res_arr_mem_330988,
                                                             .size =0,
                                                             .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_330990 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_330990",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338636->free_reduce_stage_1_tid_res_arr_mem_330990,
                                                             .size =0,
                                                             .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_330992 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_330992",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338636->free_reduce_stage_1_tid_res_arr_mem_330992,
                                                             .size =0,
                                                             .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_330994 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_330994",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338636->free_reduce_stage_1_tid_res_arr_mem_330994,
                                                             .size =0,
                                                             .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_330996 = start;
    double x_330927;
    double x_330928;
    double x_330930;
    double x_330931;
    double x_330933;
    double x_330934;
    double x_330936;
    double x_330937;
    double x_330939;
    double x_330940;
    double local_acc_330997 = 0.0;
    double local_acc_330998 = 0.0;
    double local_acc_330999 = 0.0;
    double local_acc_331000 = 0.0;
    double local_acc_331001 = 0.0;
    
    for (; iter_330996 < end; iter_330996++) {
        int64_t gtid_330926 = iter_330996;
        double x_330942;
        
        x_330942 = ((double *) mem_330584.mem)[gtid_330926];
        
        double x_330943;
        
        x_330943 = ((double *) mem_330585.mem)[gtid_330926];
        
        double defunc_1_f_res_330944 = x_330942 * x_330943;
        double defunc_1_f_res_330945 = x_330942 * defunc_1_f_res_330944;
        double defunc_1_f_res_330946 = x_330942 * defunc_1_f_res_330945;
        double defunc_1_f_res_330947 = x_330942 * defunc_1_f_res_330946;
        
        // save map-out results
        {
            ((double *) mem_330607.mem)[gtid_330926] = defunc_1_f_res_330945;
            ((double *) mem_330608.mem)[gtid_330926] = defunc_1_f_res_330944;
        }
        // Load accum params
        {
            x_330927 = local_acc_330997;
        }
        // Load next params
        {
            x_330928 = x_330943;
        }
        // Red body
        {
            double defunc_1_op_res_330929 = x_330927 + x_330928;
            
            local_acc_330997 = defunc_1_op_res_330929;
        }
        // Load accum params
        {
            x_330930 = local_acc_330998;
        }
        // Load next params
        {
            x_330931 = defunc_1_f_res_330944;
        }
        // Red body
        {
            double defunc_1_op_res_330932 = x_330930 + x_330931;
            
            local_acc_330998 = defunc_1_op_res_330932;
        }
        // Load accum params
        {
            x_330933 = local_acc_330999;
        }
        // Load next params
        {
            x_330934 = defunc_1_f_res_330945;
        }
        // Red body
        {
            double defunc_1_op_res_330935 = x_330933 + x_330934;
            
            local_acc_330999 = defunc_1_op_res_330935;
        }
        // Load accum params
        {
            x_330936 = local_acc_331000;
        }
        // Load next params
        {
            x_330937 = defunc_1_f_res_330946;
        }
        // Red body
        {
            double defunc_1_op_res_330938 = x_330936 + x_330937;
            
            local_acc_331000 = defunc_1_op_res_330938;
        }
        // Load accum params
        {
            x_330939 = local_acc_331001;
        }
        // Load next params
        {
            x_330940 = defunc_1_f_res_330947;
        }
        // Red body
        {
            double defunc_1_op_res_330941 = x_330939 + x_330940;
            
            local_acc_331001 = defunc_1_op_res_330941;
        }
    }
    ((double *) reduce_stage_1_tid_res_arr_mem_330986.mem)[flat_tid_330925] =
        local_acc_330997;
    ((double *) reduce_stage_1_tid_res_arr_mem_330988.mem)[flat_tid_330925] =
        local_acc_330998;
    ((double *) reduce_stage_1_tid_res_arr_mem_330990.mem)[flat_tid_330925] =
        local_acc_330999;
    ((double *) reduce_stage_1_tid_res_arr_mem_330992.mem)[flat_tid_330925] =
        local_acc_331000;
    ((double *) reduce_stage_1_tid_res_arr_mem_330994.mem)[flat_tid_330925] =
        local_acc_331001;
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_338637_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_338637_end -
                 futhark_mc_segred_stage_1_parloop_338637_start;
        
        ctx->futhark_mc_segred_stage_1_parloop_338637_runs[tid]++;
        ctx->futhark_mc_segred_stage_1_parloop_338637_total_runtime[tid] +=
            elapsed;
        ctx->futhark_mc_segred_stage_1_parloop_338637_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segred_task_338630(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_330925 = tid;
    int num_tasks_330985 = info.nsubtasks;
    struct futhark_mc_task_338629 *futhark_mc_task_338629 =
                                  (struct futhark_mc_task_338629 *) args;
    struct futhark_context *ctx = futhark_mc_task_338629->ctx;
    uint64_t futhark_mc_segred_task_338630_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_task_338630_start = get_wall_time();
    
    struct memblock mem_330584 = {.desc ="mem_330584", .mem =
                                  futhark_mc_task_338629->free_mem_330584,
                                  .size =0, .references =NULL};
    struct memblock mem_330585 = {.desc ="mem_330585", .mem =
                                  futhark_mc_task_338629->free_mem_330585,
                                  .size =0, .references =NULL};
    double defunc_2_reduce_res_330609 =
           *futhark_mc_task_338629->retval_defunc_2_reduce_res_330609;
    double defunc_2_reduce_res_330610 =
           *futhark_mc_task_338629->retval_defunc_2_reduce_res_330610;
    double defunc_2_reduce_res_330611 =
           *futhark_mc_task_338629->retval_defunc_2_reduce_res_330611;
    double defunc_2_reduce_res_330612 =
           *futhark_mc_task_338629->retval_defunc_2_reduce_res_330612;
    double defunc_2_reduce_res_330613 =
           *futhark_mc_task_338629->retval_defunc_2_reduce_res_330613;
    struct memblock mem_330607 = {.desc ="mem_330607", .mem =
                                  futhark_mc_task_338629->retval_mem_330607,
                                  .size =0, .references =NULL};
    struct memblock mem_330608 = {.desc ="mem_330608", .mem =
                                  futhark_mc_task_338629->retval_mem_330608,
                                  .size =0, .references =NULL};
    size_t reduce_stage_1_tid_res_arr_mem_330986_cached_sizze_338631 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_330986 = NULL;
    size_t reduce_stage_1_tid_res_arr_mem_330988_cached_sizze_338632 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_330988 = NULL;
    size_t reduce_stage_1_tid_res_arr_mem_330990_cached_sizze_338633 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_330990 = NULL;
    size_t reduce_stage_1_tid_res_arr_mem_330992_cached_sizze_338634 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_330992 = NULL;
    size_t reduce_stage_1_tid_res_arr_mem_330994_cached_sizze_338635 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_330994 = NULL;
    
    if (reduce_stage_1_tid_res_arr_mem_330986_cached_sizze_338631 <
        (size_t) ((int64_t) 8 * num_tasks_330985)) {
        reduce_stage_1_tid_res_arr_mem_330986 =
            realloc(reduce_stage_1_tid_res_arr_mem_330986, (int64_t) 8 *
                    num_tasks_330985);
        reduce_stage_1_tid_res_arr_mem_330986_cached_sizze_338631 =
            (int64_t) 8 * num_tasks_330985;
    }
    if (reduce_stage_1_tid_res_arr_mem_330988_cached_sizze_338632 <
        (size_t) ((int64_t) 8 * num_tasks_330985)) {
        reduce_stage_1_tid_res_arr_mem_330988 =
            realloc(reduce_stage_1_tid_res_arr_mem_330988, (int64_t) 8 *
                    num_tasks_330985);
        reduce_stage_1_tid_res_arr_mem_330988_cached_sizze_338632 =
            (int64_t) 8 * num_tasks_330985;
    }
    if (reduce_stage_1_tid_res_arr_mem_330990_cached_sizze_338633 <
        (size_t) ((int64_t) 8 * num_tasks_330985)) {
        reduce_stage_1_tid_res_arr_mem_330990 =
            realloc(reduce_stage_1_tid_res_arr_mem_330990, (int64_t) 8 *
                    num_tasks_330985);
        reduce_stage_1_tid_res_arr_mem_330990_cached_sizze_338633 =
            (int64_t) 8 * num_tasks_330985;
    }
    if (reduce_stage_1_tid_res_arr_mem_330992_cached_sizze_338634 <
        (size_t) ((int64_t) 8 * num_tasks_330985)) {
        reduce_stage_1_tid_res_arr_mem_330992 =
            realloc(reduce_stage_1_tid_res_arr_mem_330992, (int64_t) 8 *
                    num_tasks_330985);
        reduce_stage_1_tid_res_arr_mem_330992_cached_sizze_338634 =
            (int64_t) 8 * num_tasks_330985;
    }
    if (reduce_stage_1_tid_res_arr_mem_330994_cached_sizze_338635 <
        (size_t) ((int64_t) 8 * num_tasks_330985)) {
        reduce_stage_1_tid_res_arr_mem_330994 =
            realloc(reduce_stage_1_tid_res_arr_mem_330994, (int64_t) 8 *
                    num_tasks_330985);
        reduce_stage_1_tid_res_arr_mem_330994_cached_sizze_338635 =
            (int64_t) 8 * num_tasks_330985;
    }
    
    int64_t iter_330996;
    struct futhark_mc_segred_stage_1_parloop_struct_338636
    futhark_mc_segred_stage_1_parloop_struct_338636;
    
    futhark_mc_segred_stage_1_parloop_struct_338636.ctx = ctx;
    futhark_mc_segred_stage_1_parloop_struct_338636.free_mem_330584 =
        mem_330584.mem;
    futhark_mc_segred_stage_1_parloop_struct_338636.free_mem_330585 =
        mem_330585.mem;
    futhark_mc_segred_stage_1_parloop_struct_338636.free_mem_330607 =
        mem_330607.mem;
    futhark_mc_segred_stage_1_parloop_struct_338636.free_mem_330608 =
        mem_330608.mem;
    futhark_mc_segred_stage_1_parloop_struct_338636.free_reduce_stage_1_tid_res_arr_mem_330986 =
        reduce_stage_1_tid_res_arr_mem_330986;
    futhark_mc_segred_stage_1_parloop_struct_338636.free_reduce_stage_1_tid_res_arr_mem_330988 =
        reduce_stage_1_tid_res_arr_mem_330988;
    futhark_mc_segred_stage_1_parloop_struct_338636.free_reduce_stage_1_tid_res_arr_mem_330990 =
        reduce_stage_1_tid_res_arr_mem_330990;
    futhark_mc_segred_stage_1_parloop_struct_338636.free_reduce_stage_1_tid_res_arr_mem_330992 =
        reduce_stage_1_tid_res_arr_mem_330992;
    futhark_mc_segred_stage_1_parloop_struct_338636.free_reduce_stage_1_tid_res_arr_mem_330994 =
        reduce_stage_1_tid_res_arr_mem_330994;
    
    struct scheduler_parloop futhark_mc_segred_stage_1_parloop_338637_task;
    
    futhark_mc_segred_stage_1_parloop_338637_task.name =
        "futhark_mc_segred_stage_1_parloop_338637";
    futhark_mc_segred_stage_1_parloop_338637_task.fn =
        futhark_mc_segred_stage_1_parloop_338637;
    futhark_mc_segred_stage_1_parloop_338637_task.args =
        &futhark_mc_segred_stage_1_parloop_struct_338636;
    futhark_mc_segred_stage_1_parloop_338637_task.iterations = iterations;
    futhark_mc_segred_stage_1_parloop_338637_task.info = info;
    
    uint64_t futhark_mc_segred_stage_1_parloop_338637_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_338637_total_start = get_wall_time();
    
    int futhark_mc_segred_stage_1_parloop_338637_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segred_stage_1_parloop_338637_task);
    
    if (futhark_mc_segred_stage_1_parloop_338637_err != 0) {
        err = futhark_mc_segred_stage_1_parloop_338637_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_338637_total_end =
                 get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_338637_total_end -
                 futhark_mc_segred_stage_1_parloop_338637_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338637_total_runs,
                           1, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338637_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338637_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    // neutral-initialise the output
    {
        defunc_2_reduce_res_330609 = 0.0;
        defunc_2_reduce_res_330610 = 0.0;
        defunc_2_reduce_res_330611 = 0.0;
        defunc_2_reduce_res_330612 = 0.0;
        defunc_2_reduce_res_330613 = 0.0;
    }
    
    double x_331002;
    double x_331003;
    double x_331005;
    double x_331006;
    double x_331008;
    double x_331009;
    double x_331011;
    double x_331012;
    double x_331014;
    double x_331015;
    
    for (int32_t i_331017 = 0; i_331017 < num_tasks_330985; i_331017++) {
        flat_tid_330925 = i_331017;
        // Apply main thread reduction
        {
            // load acc params
            {
                x_331002 = defunc_2_reduce_res_330609;
            }
            // load next params
            {
                x_331003 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_330986)[flat_tid_330925];
            }
            // red body
            {
                double defunc_1_op_res_331004 = x_331002 + x_331003;
                
                defunc_2_reduce_res_330609 = defunc_1_op_res_331004;
            }
            // load acc params
            {
                x_331005 = defunc_2_reduce_res_330610;
            }
            // load next params
            {
                x_331006 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_330988)[flat_tid_330925];
            }
            // red body
            {
                double defunc_1_op_res_331007 = x_331005 + x_331006;
                
                defunc_2_reduce_res_330610 = defunc_1_op_res_331007;
            }
            // load acc params
            {
                x_331008 = defunc_2_reduce_res_330611;
            }
            // load next params
            {
                x_331009 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_330990)[flat_tid_330925];
            }
            // red body
            {
                double defunc_1_op_res_331010 = x_331008 + x_331009;
                
                defunc_2_reduce_res_330611 = defunc_1_op_res_331010;
            }
            // load acc params
            {
                x_331011 = defunc_2_reduce_res_330612;
            }
            // load next params
            {
                x_331012 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_330992)[flat_tid_330925];
            }
            // red body
            {
                double defunc_1_op_res_331013 = x_331011 + x_331012;
                
                defunc_2_reduce_res_330612 = defunc_1_op_res_331013;
            }
            // load acc params
            {
                x_331014 = defunc_2_reduce_res_330613;
            }
            // load next params
            {
                x_331015 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_330994)[flat_tid_330925];
            }
            // red body
            {
                double defunc_1_op_res_331016 = x_331014 + x_331015;
                
                defunc_2_reduce_res_330613 = defunc_1_op_res_331016;
            }
        }
    }
    
  cleanup:
    {
        free(reduce_stage_1_tid_res_arr_mem_330986);
        free(reduce_stage_1_tid_res_arr_mem_330988);
        free(reduce_stage_1_tid_res_arr_mem_330990);
        free(reduce_stage_1_tid_res_arr_mem_330992);
        free(reduce_stage_1_tid_res_arr_mem_330994);
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_task_338630_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_task_338630_end -
                 futhark_mc_segred_task_338630_start;
        
        ctx->futhark_mc_segred_task_338630_runs[tid]++;
        ctx->futhark_mc_segred_task_338630_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segred_task_338630_iter[tid] += iterations;
    }
    if (err == 0) {
        *futhark_mc_task_338629->retval_defunc_2_reduce_res_330609 =
            defunc_2_reduce_res_330609;
        *futhark_mc_task_338629->retval_defunc_2_reduce_res_330610 =
            defunc_2_reduce_res_330610;
        *futhark_mc_task_338629->retval_defunc_2_reduce_res_330611 =
            defunc_2_reduce_res_330611;
        *futhark_mc_task_338629->retval_defunc_2_reduce_res_330612 =
            defunc_2_reduce_res_330612;
        *futhark_mc_task_338629->retval_defunc_2_reduce_res_330613 =
            defunc_2_reduce_res_330613;
        futhark_mc_task_338629->retval_mem_330607 = mem_330607.mem;
        futhark_mc_task_338629->retval_mem_330608 = mem_330608.mem;
    }
    return err;
}
struct futhark_mc_task_338638 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_306308;
    unsigned char *free_mem_315021;
    int64_t free_x_330579;
    unsigned char *free_mem_330585;
    unsigned char *free_mem_330607;
    unsigned char *free_mem_330608;
    double free_a12_330664;
    double free_b12_330665;
    double free_c12_330666;
    double free_b2_330667;
    double free_c2_330668;
    double *retval_defunc_2_reduce_res_330669;
    double *retval_defunc_2_reduce_res_330670;
};
struct futhark_mc_segred_stage_1_parloop_struct_338642 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_306308;
    unsigned char *free_mem_315021;
    int64_t free_x_330579;
    unsigned char *free_mem_330585;
    unsigned char *free_mem_330607;
    unsigned char *free_mem_330608;
    double free_a12_330664;
    double free_b12_330665;
    double free_c12_330666;
    double free_b2_330667;
    double free_c2_330668;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_331019;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_331021;
};
static int futhark_mc_segred_stage_1_parloop_338643(void *args, int64_t start,
                                                    int64_t end,
                                                    int flat_tid_330948,
                                                    int tid)
{
    int err = 0;
    struct futhark_mc_segred_stage_1_parloop_struct_338642
    *futhark_mc_segred_stage_1_parloop_struct_338642 =
    (struct futhark_mc_segred_stage_1_parloop_struct_338642 *) args;
    struct futhark_context *ctx =
                           futhark_mc_segred_stage_1_parloop_struct_338642->ctx;
    uint64_t futhark_mc_segred_stage_1_parloop_338643_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_338643_start = get_wall_time();
    
    int64_t n_292675 =
            futhark_mc_segred_stage_1_parloop_struct_338642->free_n_292675;
    int64_t gtid_306308 =
            futhark_mc_segred_stage_1_parloop_struct_338642->free_gtid_306308;
    struct memblock mem_315021 = {.desc ="mem_315021", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_338642->free_mem_315021,
                                  .size =0, .references =NULL};
    int64_t x_330579 =
            futhark_mc_segred_stage_1_parloop_struct_338642->free_x_330579;
    struct memblock mem_330585 = {.desc ="mem_330585", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_338642->free_mem_330585,
                                  .size =0, .references =NULL};
    struct memblock mem_330607 = {.desc ="mem_330607", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_338642->free_mem_330607,
                                  .size =0, .references =NULL};
    struct memblock mem_330608 = {.desc ="mem_330608", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_338642->free_mem_330608,
                                  .size =0, .references =NULL};
    double a12_330664 =
           futhark_mc_segred_stage_1_parloop_struct_338642->free_a12_330664;
    double b12_330665 =
           futhark_mc_segred_stage_1_parloop_struct_338642->free_b12_330665;
    double c12_330666 =
           futhark_mc_segred_stage_1_parloop_struct_338642->free_c12_330666;
    double b2_330667 =
           futhark_mc_segred_stage_1_parloop_struct_338642->free_b2_330667;
    double c2_330668 =
           futhark_mc_segred_stage_1_parloop_struct_338642->free_c2_330668;
    struct memblock reduce_stage_1_tid_res_arr_mem_331019 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_331019",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338642->free_reduce_stage_1_tid_res_arr_mem_331019,
                                                             .size =0,
                                                             .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_331021 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_331021",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338642->free_reduce_stage_1_tid_res_arr_mem_331021,
                                                             .size =0,
                                                             .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_331023 = start;
    double x_330950;
    double x_330951;
    double x_330953;
    double x_330954;
    double local_acc_331024 = 0.0;
    double local_acc_331025 = 0.0;
    
    for (; iter_331023 < end; iter_331023++) {
        int64_t gtid_330949 = iter_331023;
        double x_330956;
        
        x_330956 = ((double *) mem_330585.mem)[gtid_330949];
        
        double x_330957;
        
        x_330957 = ((double *) mem_330608.mem)[gtid_330949];
        
        double x_330958;
        
        x_330958 = ((double *) mem_330607.mem)[gtid_330949];
        
        bool cond_330959 = sle64(n_292675, gtid_330949);
        double defunc_0_f_res_330960;
        
        if (cond_330959) {
            defunc_0_f_res_330960 = 0.0;
        } else {
            int64_t i_330961 = add64(x_330579, gtid_330949);
            double defunc_0_add_arg_330962;
            
            defunc_0_add_arg_330962 = ((double *) mem_315021.mem)[gtid_306308 *
                                                                  n_292675 +
                                                                  i_330961];
            defunc_0_f_res_330960 = defunc_0_add_arg_330962;
        }
        
        double x_330963 = a12_330664 * x_330956;
        double y_330964 = b12_330665 * x_330957;
        double x_330965 = x_330963 + y_330964;
        double y_330966 = c12_330666 * x_330958;
        double x_330967 = x_330965 + y_330966;
        double defunc_9_fit_fun_res_330968 = defunc_0_f_res_330960 * x_330967;
        double x_330969 = b12_330665 * x_330956;
        double y_330970 = b2_330667 * x_330957;
        double x_330971 = x_330969 + y_330970;
        double y_330972 = c2_330668 * x_330958;
        double x_330973 = x_330971 + y_330972;
        double defunc_9_slope_fun_res_330974 = defunc_0_f_res_330960 * x_330973;
        
        // save map-out results
        { }
        // Load accum params
        {
            x_330950 = local_acc_331024;
        }
        // Load next params
        {
            x_330951 = defunc_9_fit_fun_res_330968;
        }
        // Red body
        {
            double defunc_1_op_res_330952 = x_330950 + x_330951;
            
            local_acc_331024 = defunc_1_op_res_330952;
        }
        // Load accum params
        {
            x_330953 = local_acc_331025;
        }
        // Load next params
        {
            x_330954 = defunc_9_slope_fun_res_330974;
        }
        // Red body
        {
            double defunc_1_op_res_330955 = x_330953 + x_330954;
            
            local_acc_331025 = defunc_1_op_res_330955;
        }
    }
    ((double *) reduce_stage_1_tid_res_arr_mem_331019.mem)[flat_tid_330948] =
        local_acc_331024;
    ((double *) reduce_stage_1_tid_res_arr_mem_331021.mem)[flat_tid_330948] =
        local_acc_331025;
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_338643_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_338643_end -
                 futhark_mc_segred_stage_1_parloop_338643_start;
        
        ctx->futhark_mc_segred_stage_1_parloop_338643_runs[tid]++;
        ctx->futhark_mc_segred_stage_1_parloop_338643_total_runtime[tid] +=
            elapsed;
        ctx->futhark_mc_segred_stage_1_parloop_338643_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segred_task_338639(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_330948 = tid;
    int num_tasks_331018 = info.nsubtasks;
    struct futhark_mc_task_338638 *futhark_mc_task_338638 =
                                  (struct futhark_mc_task_338638 *) args;
    struct futhark_context *ctx = futhark_mc_task_338638->ctx;
    uint64_t futhark_mc_segred_task_338639_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_task_338639_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338638->free_n_292675;
    int64_t gtid_306308 = futhark_mc_task_338638->free_gtid_306308;
    struct memblock mem_315021 = {.desc ="mem_315021", .mem =
                                  futhark_mc_task_338638->free_mem_315021,
                                  .size =0, .references =NULL};
    int64_t x_330579 = futhark_mc_task_338638->free_x_330579;
    struct memblock mem_330585 = {.desc ="mem_330585", .mem =
                                  futhark_mc_task_338638->free_mem_330585,
                                  .size =0, .references =NULL};
    struct memblock mem_330607 = {.desc ="mem_330607", .mem =
                                  futhark_mc_task_338638->free_mem_330607,
                                  .size =0, .references =NULL};
    struct memblock mem_330608 = {.desc ="mem_330608", .mem =
                                  futhark_mc_task_338638->free_mem_330608,
                                  .size =0, .references =NULL};
    double a12_330664 = futhark_mc_task_338638->free_a12_330664;
    double b12_330665 = futhark_mc_task_338638->free_b12_330665;
    double c12_330666 = futhark_mc_task_338638->free_c12_330666;
    double b2_330667 = futhark_mc_task_338638->free_b2_330667;
    double c2_330668 = futhark_mc_task_338638->free_c2_330668;
    double defunc_2_reduce_res_330669 =
           *futhark_mc_task_338638->retval_defunc_2_reduce_res_330669;
    double defunc_2_reduce_res_330670 =
           *futhark_mc_task_338638->retval_defunc_2_reduce_res_330670;
    size_t reduce_stage_1_tid_res_arr_mem_331019_cached_sizze_338640 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_331019 = NULL;
    size_t reduce_stage_1_tid_res_arr_mem_331021_cached_sizze_338641 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_331021 = NULL;
    
    if (reduce_stage_1_tid_res_arr_mem_331019_cached_sizze_338640 <
        (size_t) ((int64_t) 8 * num_tasks_331018)) {
        reduce_stage_1_tid_res_arr_mem_331019 =
            realloc(reduce_stage_1_tid_res_arr_mem_331019, (int64_t) 8 *
                    num_tasks_331018);
        reduce_stage_1_tid_res_arr_mem_331019_cached_sizze_338640 =
            (int64_t) 8 * num_tasks_331018;
    }
    if (reduce_stage_1_tid_res_arr_mem_331021_cached_sizze_338641 <
        (size_t) ((int64_t) 8 * num_tasks_331018)) {
        reduce_stage_1_tid_res_arr_mem_331021 =
            realloc(reduce_stage_1_tid_res_arr_mem_331021, (int64_t) 8 *
                    num_tasks_331018);
        reduce_stage_1_tid_res_arr_mem_331021_cached_sizze_338641 =
            (int64_t) 8 * num_tasks_331018;
    }
    
    int64_t iter_331023;
    struct futhark_mc_segred_stage_1_parloop_struct_338642
    futhark_mc_segred_stage_1_parloop_struct_338642;
    
    futhark_mc_segred_stage_1_parloop_struct_338642.ctx = ctx;
    futhark_mc_segred_stage_1_parloop_struct_338642.free_n_292675 = n_292675;
    futhark_mc_segred_stage_1_parloop_struct_338642.free_gtid_306308 =
        gtid_306308;
    futhark_mc_segred_stage_1_parloop_struct_338642.free_mem_315021 =
        mem_315021.mem;
    futhark_mc_segred_stage_1_parloop_struct_338642.free_x_330579 = x_330579;
    futhark_mc_segred_stage_1_parloop_struct_338642.free_mem_330585 =
        mem_330585.mem;
    futhark_mc_segred_stage_1_parloop_struct_338642.free_mem_330607 =
        mem_330607.mem;
    futhark_mc_segred_stage_1_parloop_struct_338642.free_mem_330608 =
        mem_330608.mem;
    futhark_mc_segred_stage_1_parloop_struct_338642.free_a12_330664 =
        a12_330664;
    futhark_mc_segred_stage_1_parloop_struct_338642.free_b12_330665 =
        b12_330665;
    futhark_mc_segred_stage_1_parloop_struct_338642.free_c12_330666 =
        c12_330666;
    futhark_mc_segred_stage_1_parloop_struct_338642.free_b2_330667 = b2_330667;
    futhark_mc_segred_stage_1_parloop_struct_338642.free_c2_330668 = c2_330668;
    futhark_mc_segred_stage_1_parloop_struct_338642.free_reduce_stage_1_tid_res_arr_mem_331019 =
        reduce_stage_1_tid_res_arr_mem_331019;
    futhark_mc_segred_stage_1_parloop_struct_338642.free_reduce_stage_1_tid_res_arr_mem_331021 =
        reduce_stage_1_tid_res_arr_mem_331021;
    
    struct scheduler_parloop futhark_mc_segred_stage_1_parloop_338643_task;
    
    futhark_mc_segred_stage_1_parloop_338643_task.name =
        "futhark_mc_segred_stage_1_parloop_338643";
    futhark_mc_segred_stage_1_parloop_338643_task.fn =
        futhark_mc_segred_stage_1_parloop_338643;
    futhark_mc_segred_stage_1_parloop_338643_task.args =
        &futhark_mc_segred_stage_1_parloop_struct_338642;
    futhark_mc_segred_stage_1_parloop_338643_task.iterations = iterations;
    futhark_mc_segred_stage_1_parloop_338643_task.info = info;
    
    uint64_t futhark_mc_segred_stage_1_parloop_338643_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_338643_total_start = get_wall_time();
    
    int futhark_mc_segred_stage_1_parloop_338643_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segred_stage_1_parloop_338643_task);
    
    if (futhark_mc_segred_stage_1_parloop_338643_err != 0) {
        err = futhark_mc_segred_stage_1_parloop_338643_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_338643_total_end =
                 get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_338643_total_end -
                 futhark_mc_segred_stage_1_parloop_338643_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338643_total_runs,
                           1, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338643_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338643_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    // neutral-initialise the output
    {
        defunc_2_reduce_res_330669 = 0.0;
        defunc_2_reduce_res_330670 = 0.0;
    }
    
    double x_331026;
    double x_331027;
    double x_331029;
    double x_331030;
    
    for (int32_t i_331032 = 0; i_331032 < num_tasks_331018; i_331032++) {
        flat_tid_330948 = i_331032;
        // Apply main thread reduction
        {
            // load acc params
            {
                x_331026 = defunc_2_reduce_res_330669;
            }
            // load next params
            {
                x_331027 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_331019)[flat_tid_330948];
            }
            // red body
            {
                double defunc_1_op_res_331028 = x_331026 + x_331027;
                
                defunc_2_reduce_res_330669 = defunc_1_op_res_331028;
            }
            // load acc params
            {
                x_331029 = defunc_2_reduce_res_330670;
            }
            // load next params
            {
                x_331030 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_331021)[flat_tid_330948];
            }
            // red body
            {
                double defunc_1_op_res_331031 = x_331029 + x_331030;
                
                defunc_2_reduce_res_330670 = defunc_1_op_res_331031;
            }
        }
    }
    
  cleanup:
    {
        free(reduce_stage_1_tid_res_arr_mem_331019);
        free(reduce_stage_1_tid_res_arr_mem_331021);
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_task_338639_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_task_338639_end -
                 futhark_mc_segred_task_338639_start;
        
        ctx->futhark_mc_segred_task_338639_runs[tid]++;
        ctx->futhark_mc_segred_task_338639_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segred_task_338639_iter[tid] += iterations;
    }
    if (err == 0) {
        *futhark_mc_task_338638->retval_defunc_2_reduce_res_330669 =
            defunc_2_reduce_res_330669;
        *futhark_mc_task_338638->retval_defunc_2_reduce_res_330670 =
            defunc_2_reduce_res_330670;
    }
    return err;
}
static int futhark_mc_segmap_parloop_338620(void *args, int64_t start,
                                            int64_t end, int flat_tid_330577,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338619
    *futhark_mc_segmap_parloop_struct_338619 =
    (struct futhark_mc_segmap_parloop_struct_338619 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338619->ctx;
    uint64_t futhark_mc_segmap_parloop_338620_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338620_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_338619->free_n_292675;
    int64_t q_l_292680 =
            futhark_mc_segmap_parloop_struct_338619->free_q_l_292680;
    int64_t jump_t_292685 =
            futhark_mc_segmap_parloop_struct_338619->free_jump_t_292685;
    int64_t l_n_m_292832 =
            futhark_mc_segmap_parloop_struct_338619->free_l_n_m_292832;
    int64_t i_292846 = futhark_mc_segmap_parloop_struct_338619->free_i_292846;
    int64_t gtid_306308 =
            futhark_mc_segmap_parloop_struct_338619->free_gtid_306308;
    struct memblock mem_313081 = {.desc ="mem_313081", .mem =
                                  futhark_mc_segmap_parloop_struct_338619->free_mem_313081,
                                  .size =0, .references =NULL};
    struct memblock mem_313085 = {.desc ="mem_313085", .mem =
                                  futhark_mc_segmap_parloop_struct_338619->free_mem_313085,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_segmap_parloop_struct_338619->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_segmap_parloop_struct_338619->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_segmap_parloop_struct_338619->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_segmap_parloop_struct_338619->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315021 = {.desc ="mem_315021", .mem =
                                  futhark_mc_segmap_parloop_struct_338619->free_mem_315021,
                                  .size =0, .references =NULL};
    int64_t bytes_315310 =
            futhark_mc_segmap_parloop_struct_338619->free_bytes_315310;
    struct memblock mem_315383 = {.desc ="mem_315383", .mem =
                                  futhark_mc_segmap_parloop_struct_338619->free_mem_315383,
                                  .size =0, .references =NULL};
    struct memblock mem_315386 = {.desc ="mem_315386", .mem =
                                  futhark_mc_segmap_parloop_struct_338619->free_mem_315386,
                                  .size =0, .references =NULL};
    size_t mem_330584_cached_sizze_338621 = 0;
    unsigned char *mem_330584 = NULL;
    size_t mem_330585_cached_sizze_338622 = 0;
    unsigned char *mem_330585 = NULL;
    size_t mem_330607_cached_sizze_338623 = 0;
    unsigned char *mem_330607 = NULL;
    size_t mem_330608_cached_sizze_338624 = 0;
    unsigned char *mem_330608 = NULL;
    int64_t iterations = end - start;
    int64_t iter_330905 = start;
    
    if (mem_330584_cached_sizze_338621 < (size_t) bytes_315310) {
        mem_330584 = realloc(mem_330584, bytes_315310);
        mem_330584_cached_sizze_338621 = bytes_315310;
    }
    if (mem_330585_cached_sizze_338622 < (size_t) bytes_315310) {
        mem_330585 = realloc(mem_330585, bytes_315310);
        mem_330585_cached_sizze_338622 = bytes_315310;
    }
    if (mem_330607_cached_sizze_338623 < (size_t) bytes_315310) {
        mem_330607 = realloc(mem_330607, bytes_315310);
        mem_330607_cached_sizze_338623 = bytes_315310;
    }
    if (mem_330608_cached_sizze_338624 < (size_t) bytes_315310) {
        mem_330608 = realloc(mem_330608, bytes_315310);
        mem_330608_cached_sizze_338624 = bytes_315310;
    }
    for (; iter_330905 < end; iter_330905++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_330975 = l_n_m_292832;
        int64_t gtid_330578 = iter_330905;
        int64_t remnant_330976 = iter_330905 - gtid_330578;
        int64_t x_330579;
        
        x_330579 = ((int64_t *) mem_313081.mem)[gtid_306308 * l_n_m_292832 +
                                                gtid_330578];
        
        double x_330580;
        
        x_330580 = ((double *) mem_313085.mem)[gtid_306308 * l_n_m_292832 +
                                               gtid_330578];
        
        int64_t min_arg_330581 = mul64(jump_t_292685, gtid_330578);
        int64_t min_res_330582 = smin64(i_292846, min_arg_330581);
        int64_t defunc_0_g_res_330583 = add64((int64_t) 1, min_res_330582);
        int64_t flat_tid_330906 = (int64_t) 0;
        int32_t num_tasks_330977;
        struct futhark_mc_task_338625 futhark_mc_task_338625;
        
        futhark_mc_task_338625.ctx = ctx;
        futhark_mc_task_338625.free_n_292675 = n_292675;
        futhark_mc_task_338625.free_q_l_292680 = q_l_292680;
        futhark_mc_task_338625.free_gtid_306308 = gtid_306308;
        futhark_mc_task_338625.free_ctx_param_ext_313174 = ctx_param_ext_313174;
        futhark_mc_task_338625.free_ctx_param_ext_313175 = ctx_param_ext_313175;
        futhark_mc_task_338625.free_ctx_param_ext_313177 = ctx_param_ext_313177;
        futhark_mc_task_338625.free_mem_param_313179 = mem_param_313179.mem;
        futhark_mc_task_338625.free_x_330579 = x_330579;
        futhark_mc_task_338625.free_x_330580 = x_330580;
        futhark_mc_task_338625.free_defunc_0_g_res_330583 =
            defunc_0_g_res_330583;
        futhark_mc_task_338625.free_mem_330584 = mem_330584;
        futhark_mc_task_338625.free_mem_330585 = mem_330585;
        
        struct scheduler_segop futhark_mc_task_338625_task;
        
        futhark_mc_task_338625_task.args = &futhark_mc_task_338625;
        futhark_mc_task_338625_task.top_level_fn =
            futhark_mc_segmap_task_338626;
        futhark_mc_task_338625_task.name = "futhark_mc_segmap_task_338626";
        futhark_mc_task_338625_task.iterations = q_l_292680;
        futhark_mc_task_338625_task.task_time =
            &ctx->futhark_mc_segmap_task_338626_total_time;
        futhark_mc_task_338625_task.task_iter =
            &ctx->futhark_mc_segmap_task_338626_total_iter;
        futhark_mc_task_338625_task.sched = STATIC;
        futhark_mc_task_338625_task.nested_fn = NULL;
        
        int futhark_mc_segmap_task_338626_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_338625_task);
        
        if (futhark_mc_segmap_task_338626_err != 0) {
            ;
            err = futhark_mc_segmap_task_338626_err;
            goto cleanup;
        }
        
        double defunc_2_reduce_res_330609;
        double defunc_2_reduce_res_330610;
        double defunc_2_reduce_res_330611;
        double defunc_2_reduce_res_330612;
        double defunc_2_reduce_res_330613;
        int64_t flat_tid_330925 = (int64_t) 0;
        int32_t num_tasks_330985;
        
        defunc_2_reduce_res_330609 = 0.0;
        defunc_2_reduce_res_330610 = 0.0;
        defunc_2_reduce_res_330611 = 0.0;
        defunc_2_reduce_res_330612 = 0.0;
        defunc_2_reduce_res_330613 = 0.0;
        
        struct futhark_mc_task_338629 futhark_mc_task_338629;
        
        futhark_mc_task_338629.ctx = ctx;
        futhark_mc_task_338629.free_mem_330584 = mem_330584;
        futhark_mc_task_338629.free_mem_330585 = mem_330585;
        futhark_mc_task_338629.retval_defunc_2_reduce_res_330609 =
            &defunc_2_reduce_res_330609;
        futhark_mc_task_338629.retval_defunc_2_reduce_res_330610 =
            &defunc_2_reduce_res_330610;
        futhark_mc_task_338629.retval_defunc_2_reduce_res_330611 =
            &defunc_2_reduce_res_330611;
        futhark_mc_task_338629.retval_defunc_2_reduce_res_330612 =
            &defunc_2_reduce_res_330612;
        futhark_mc_task_338629.retval_defunc_2_reduce_res_330613 =
            &defunc_2_reduce_res_330613;
        futhark_mc_task_338629.retval_mem_330607 = mem_330607;
        futhark_mc_task_338629.retval_mem_330608 = mem_330608;
        
        struct scheduler_segop futhark_mc_task_338629_task;
        
        futhark_mc_task_338629_task.args = &futhark_mc_task_338629;
        futhark_mc_task_338629_task.top_level_fn =
            futhark_mc_segred_task_338630;
        futhark_mc_task_338629_task.name = "futhark_mc_segred_task_338630";
        futhark_mc_task_338629_task.iterations = q_l_292680;
        futhark_mc_task_338629_task.task_time =
            &ctx->futhark_mc_segred_task_338630_total_time;
        futhark_mc_task_338629_task.task_iter =
            &ctx->futhark_mc_segred_task_338630_total_iter;
        futhark_mc_task_338629_task.sched = STATIC;
        futhark_mc_task_338629_task.nested_fn = NULL;
        
        int futhark_mc_segred_task_338630_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_338629_task);
        
        if (futhark_mc_segred_task_338630_err != 0) {
            ;
            err = futhark_mc_segred_task_338630_err;
            goto cleanup;
        }
        
        double a_330639 = 2.220446049250313e-16 + defunc_2_reduce_res_330609;
        double b_330640 = 2.220446049250313e-16 + defunc_2_reduce_res_330610;
        double c_330641 = 2.220446049250313e-16 + defunc_2_reduce_res_330611;
        double d_330642 = 2.220446049250313e-16 + defunc_2_reduce_res_330612;
        double e_330643 = 2.220446049250313e-16 + defunc_2_reduce_res_330613;
        double x_330644 = c_330641 * e_330643;
        double y_330645 = d_330642 * d_330642;
        double a12_330646 = x_330644 - y_330645;
        double x_330647 = c_330641 * d_330642;
        double y_330648 = b_330640 * e_330643;
        double b12_330649 = x_330647 - y_330648;
        double x_330650 = b_330640 * d_330642;
        double y_330651 = c_330641 * c_330641;
        double c12_330652 = x_330650 - y_330651;
        double x_330653 = a_330639 * e_330643;
        double b2_330654 = x_330653 - y_330651;
        double x_330655 = b_330640 * c_330641;
        double y_330656 = a_330639 * d_330642;
        double c2_330657 = x_330655 - y_330656;
        double x_330658 = a_330639 * a12_330646;
        double y_330659 = b_330640 * b12_330649;
        double x_330660 = x_330658 + y_330659;
        double y_330661 = c_330641 * c12_330652;
        double y_330662 = x_330660 + y_330661;
        double det_330663 = 1.0 / y_330662;
        double a12_330664 = a12_330646 * det_330663;
        double b12_330665 = b12_330649 * det_330663;
        double c12_330666 = c12_330652 * det_330663;
        double b2_330667 = b2_330654 * det_330663;
        double c2_330668 = c2_330657 * det_330663;
        double defunc_2_reduce_res_330669;
        double defunc_2_reduce_res_330670;
        int64_t flat_tid_330948 = (int64_t) 0;
        int32_t num_tasks_331018;
        
        defunc_2_reduce_res_330669 = 0.0;
        defunc_2_reduce_res_330670 = 0.0;
        
        struct futhark_mc_task_338638 futhark_mc_task_338638;
        
        futhark_mc_task_338638.ctx = ctx;
        futhark_mc_task_338638.free_n_292675 = n_292675;
        futhark_mc_task_338638.free_gtid_306308 = gtid_306308;
        futhark_mc_task_338638.free_mem_315021 = mem_315021.mem;
        futhark_mc_task_338638.free_x_330579 = x_330579;
        futhark_mc_task_338638.free_mem_330585 = mem_330585;
        futhark_mc_task_338638.free_mem_330607 = mem_330607;
        futhark_mc_task_338638.free_mem_330608 = mem_330608;
        futhark_mc_task_338638.free_a12_330664 = a12_330664;
        futhark_mc_task_338638.free_b12_330665 = b12_330665;
        futhark_mc_task_338638.free_c12_330666 = c12_330666;
        futhark_mc_task_338638.free_b2_330667 = b2_330667;
        futhark_mc_task_338638.free_c2_330668 = c2_330668;
        futhark_mc_task_338638.retval_defunc_2_reduce_res_330669 =
            &defunc_2_reduce_res_330669;
        futhark_mc_task_338638.retval_defunc_2_reduce_res_330670 =
            &defunc_2_reduce_res_330670;
        
        struct scheduler_segop futhark_mc_task_338638_task;
        
        futhark_mc_task_338638_task.args = &futhark_mc_task_338638;
        futhark_mc_task_338638_task.top_level_fn =
            futhark_mc_segred_task_338639;
        futhark_mc_task_338638_task.name = "futhark_mc_segred_task_338639";
        futhark_mc_task_338638_task.iterations = q_l_292680;
        futhark_mc_task_338638_task.task_time =
            &ctx->futhark_mc_segred_task_338639_total_time;
        futhark_mc_task_338638_task.task_iter =
            &ctx->futhark_mc_segred_task_338639_total_iter;
        futhark_mc_task_338638_task.sched = STATIC;
        futhark_mc_task_338638_task.nested_fn = NULL;
        
        int futhark_mc_segred_task_338639_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_338638_task);
        
        if (futhark_mc_segred_task_338639_err != 0) {
            ;
            err = futhark_mc_segred_task_338639_err;
            goto cleanup;
        }
        ((double *) mem_315383.mem)[gtid_330578] = defunc_2_reduce_res_330669;
        ((double *) mem_315386.mem)[gtid_330578] = defunc_2_reduce_res_330670;
    }
    
  cleanup:
    { }
    free(mem_330584);
    free(mem_330585);
    free(mem_330607);
    free(mem_330608);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338620_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338620_end -
                 futhark_mc_segmap_parloop_338620_start;
        
        ctx->futhark_mc_segmap_parloop_338620_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338620_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338620_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_nested_task_338618(void *args, int64_t iterations,
                                         int tid, struct scheduler_info info)
{
    int err = 0;
    int flat_tid_330577 = tid;
    int num_tasks_330823 = info.nsubtasks;
    struct futhark_mc_task_338610 *futhark_mc_task_338610 =
                                  (struct futhark_mc_task_338610 *) args;
    struct futhark_context *ctx = futhark_mc_task_338610->ctx;
    uint64_t futhark_mc_segmap_nested_task_338618_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_nested_task_338618_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338610->free_n_292675;
    int64_t q_l_292680 = futhark_mc_task_338610->free_q_l_292680;
    int64_t jump_t_292685 = futhark_mc_task_338610->free_jump_t_292685;
    int64_t l_n_m_292832 = futhark_mc_task_338610->free_l_n_m_292832;
    int64_t i_292846 = futhark_mc_task_338610->free_i_292846;
    int64_t gtid_306308 = futhark_mc_task_338610->free_gtid_306308;
    struct memblock mem_313081 = {.desc ="mem_313081", .mem =
                                  futhark_mc_task_338610->free_mem_313081,
                                  .size =0, .references =NULL};
    struct memblock mem_313085 = {.desc ="mem_313085", .mem =
                                  futhark_mc_task_338610->free_mem_313085,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_task_338610->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_task_338610->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_task_338610->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_task_338610->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315021 = {.desc ="mem_315021", .mem =
                                  futhark_mc_task_338610->free_mem_315021,
                                  .size =0, .references =NULL};
    int64_t bytes_315310 = futhark_mc_task_338610->free_bytes_315310;
    struct memblock mem_315383 = {.desc ="mem_315383", .mem =
                                  futhark_mc_task_338610->free_mem_315383,
                                  .size =0, .references =NULL};
    struct memblock mem_315386 = {.desc ="mem_315386", .mem =
                                  futhark_mc_task_338610->free_mem_315386,
                                  .size =0, .references =NULL};
    int64_t iter_330905;
    struct futhark_mc_segmap_parloop_struct_338619
    futhark_mc_segmap_parloop_struct_338619;
    
    futhark_mc_segmap_parloop_struct_338619.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338619.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_338619.free_q_l_292680 = q_l_292680;
    futhark_mc_segmap_parloop_struct_338619.free_jump_t_292685 = jump_t_292685;
    futhark_mc_segmap_parloop_struct_338619.free_l_n_m_292832 = l_n_m_292832;
    futhark_mc_segmap_parloop_struct_338619.free_i_292846 = i_292846;
    futhark_mc_segmap_parloop_struct_338619.free_gtid_306308 = gtid_306308;
    futhark_mc_segmap_parloop_struct_338619.free_mem_313081 = mem_313081.mem;
    futhark_mc_segmap_parloop_struct_338619.free_mem_313085 = mem_313085.mem;
    futhark_mc_segmap_parloop_struct_338619.free_ctx_param_ext_313174 =
        ctx_param_ext_313174;
    futhark_mc_segmap_parloop_struct_338619.free_ctx_param_ext_313175 =
        ctx_param_ext_313175;
    futhark_mc_segmap_parloop_struct_338619.free_ctx_param_ext_313177 =
        ctx_param_ext_313177;
    futhark_mc_segmap_parloop_struct_338619.free_mem_param_313179 =
        mem_param_313179.mem;
    futhark_mc_segmap_parloop_struct_338619.free_mem_315021 = mem_315021.mem;
    futhark_mc_segmap_parloop_struct_338619.free_bytes_315310 = bytes_315310;
    futhark_mc_segmap_parloop_struct_338619.free_mem_315383 = mem_315383.mem;
    futhark_mc_segmap_parloop_struct_338619.free_mem_315386 = mem_315386.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338620_task;
    
    futhark_mc_segmap_parloop_338620_task.name =
        "futhark_mc_segmap_parloop_338620";
    futhark_mc_segmap_parloop_338620_task.fn = futhark_mc_segmap_parloop_338620;
    futhark_mc_segmap_parloop_338620_task.args =
        &futhark_mc_segmap_parloop_struct_338619;
    futhark_mc_segmap_parloop_338620_task.iterations = iterations;
    futhark_mc_segmap_parloop_338620_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338620_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338620_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338620_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338620_task);
    
    if (futhark_mc_segmap_parloop_338620_err != 0) {
        err = futhark_mc_segmap_parloop_338620_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338620_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338620_total_end -
                 futhark_mc_segmap_parloop_338620_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338620_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338620_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338620_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_nested_task_338618_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_nested_task_338618_end -
                 futhark_mc_segmap_nested_task_338618_start;
        
        ctx->futhark_mc_segmap_nested_task_338618_runs[tid]++;
        ctx->futhark_mc_segmap_nested_task_338618_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_nested_task_338618_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
static int futhark_mc_segmap_parloop_338607(void *args, int64_t start,
                                            int64_t end, int flat_tid_306307,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338606
    *futhark_mc_segmap_parloop_struct_338606 =
    (struct futhark_mc_segmap_parloop_struct_338606 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338606->ctx;
    uint64_t futhark_mc_segmap_parloop_338607_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338607_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_338606->free_n_292675;
    int64_t q_l_292680 =
            futhark_mc_segmap_parloop_struct_338606->free_q_l_292680;
    int64_t jump_t_292685 =
            futhark_mc_segmap_parloop_struct_338606->free_jump_t_292685;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_338606->free_partition_sizze_292766;
    int64_t l_n_m_292832 =
            futhark_mc_segmap_parloop_struct_338606->free_l_n_m_292832;
    int64_t i_292846 = futhark_mc_segmap_parloop_struct_338606->free_i_292846;
    int64_t bytes_313028 =
            futhark_mc_segmap_parloop_struct_338606->free_bytes_313028;
    struct memblock mem_313081 = {.desc ="mem_313081", .mem =
                                  futhark_mc_segmap_parloop_struct_338606->free_mem_313081,
                                  .size =0, .references =NULL};
    struct memblock mem_313085 = {.desc ="mem_313085", .mem =
                                  futhark_mc_segmap_parloop_struct_338606->free_mem_313085,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_segmap_parloop_struct_338606->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_segmap_parloop_struct_338606->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_segmap_parloop_struct_338606->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_segmap_parloop_struct_338606->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315021 = {.desc ="mem_315021", .mem =
                                  futhark_mc_segmap_parloop_struct_338606->free_mem_315021,
                                  .size =0, .references =NULL};
    int64_t bytes_315310 =
            futhark_mc_segmap_parloop_struct_338606->free_bytes_315310;
    struct memblock mem_315480 = {.desc ="mem_315480", .mem =
                                  futhark_mc_segmap_parloop_struct_338606->free_mem_315480,
                                  .size =0, .references =NULL};
    struct memblock mem_315484 = {.desc ="mem_315484", .mem =
                                  futhark_mc_segmap_parloop_struct_338606->free_mem_315484,
                                  .size =0, .references =NULL};
    size_t mem_315383_cached_sizze_338608 = 0;
    unsigned char *mem_315383 = NULL;
    size_t mem_315386_cached_sizze_338609 = 0;
    unsigned char *mem_315386 = NULL;
    int64_t iterations = end - start;
    int64_t iter_330576 = start;
    
    if (mem_315383_cached_sizze_338608 < (size_t) bytes_313028) {
        mem_315383 = realloc(mem_315383, bytes_313028);
        mem_315383_cached_sizze_338608 = bytes_313028;
    }
    if (mem_315386_cached_sizze_338609 < (size_t) bytes_313028) {
        mem_315386 = realloc(mem_315386, bytes_313028);
        mem_315386_cached_sizze_338609 = bytes_313028;
    }
    for (; iter_330576 < end; iter_330576++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_330821 = partition_sizze_292766;
        int64_t gtid_306308 = iter_330576;
        int64_t remnant_330822 = iter_330576 - gtid_306308;
        int64_t flat_tid_330698 = (int64_t) 0;
        int32_t num_tasks_330823;
        int64_t flat_tid_330577 = (int64_t) 0;
        struct futhark_mc_task_338610 futhark_mc_task_338610;
        
        futhark_mc_task_338610.ctx = ctx;
        futhark_mc_task_338610.free_n_292675 = n_292675;
        futhark_mc_task_338610.free_q_l_292680 = q_l_292680;
        futhark_mc_task_338610.free_jump_t_292685 = jump_t_292685;
        futhark_mc_task_338610.free_l_n_m_292832 = l_n_m_292832;
        futhark_mc_task_338610.free_i_292846 = i_292846;
        futhark_mc_task_338610.free_gtid_306308 = gtid_306308;
        futhark_mc_task_338610.free_mem_313081 = mem_313081.mem;
        futhark_mc_task_338610.free_mem_313085 = mem_313085.mem;
        futhark_mc_task_338610.free_ctx_param_ext_313174 = ctx_param_ext_313174;
        futhark_mc_task_338610.free_ctx_param_ext_313175 = ctx_param_ext_313175;
        futhark_mc_task_338610.free_ctx_param_ext_313177 = ctx_param_ext_313177;
        futhark_mc_task_338610.free_mem_param_313179 = mem_param_313179.mem;
        futhark_mc_task_338610.free_mem_315021 = mem_315021.mem;
        futhark_mc_task_338610.free_bytes_315310 = bytes_315310;
        futhark_mc_task_338610.free_mem_315383 = mem_315383;
        futhark_mc_task_338610.free_mem_315386 = mem_315386;
        
        struct scheduler_segop futhark_mc_task_338610_task;
        
        futhark_mc_task_338610_task.args = &futhark_mc_task_338610;
        futhark_mc_task_338610_task.top_level_fn =
            futhark_mc_segmap_task_338611;
        futhark_mc_task_338610_task.name = "futhark_mc_segmap_task_338611";
        futhark_mc_task_338610_task.iterations = l_n_m_292832;
        futhark_mc_task_338610_task.task_time =
            &ctx->futhark_mc_segmap_task_338611_total_time;
        futhark_mc_task_338610_task.task_iter =
            &ctx->futhark_mc_segmap_task_338611_total_iter;
        futhark_mc_task_338610_task.sched = STATIC;
        futhark_mc_task_338610_task.nested_fn =
            futhark_mc_segmap_nested_task_338618;
        
        int futhark_mc_segmap_task_338611_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_338610_task);
        
        if (futhark_mc_segmap_task_338611_err != 0) {
            ;
            err = futhark_mc_segmap_task_338611_err;
            goto cleanup;
        }
        if (l_n_m_292832 * (int64_t) 8 > 0)
            memmove(mem_315480.mem + gtid_306308 * l_n_m_292832 * (int64_t) 8,
                    mem_315383 + (int64_t) 0, l_n_m_292832 * (int64_t) 8);
        if (l_n_m_292832 * (int64_t) 8 > 0)
            memmove(mem_315484.mem + gtid_306308 * l_n_m_292832 * (int64_t) 8,
                    mem_315386 + (int64_t) 0, l_n_m_292832 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_315383);
    free(mem_315386);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338607_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338607_end -
                 futhark_mc_segmap_parloop_338607_start;
        
        ctx->futhark_mc_segmap_parloop_338607_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338607_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338607_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_nested_task_338605(void *args, int64_t iterations,
                                         int tid, struct scheduler_info info)
{
    int err = 0;
    int flat_tid_306307 = tid;
    int num_tasks_330437 = info.nsubtasks;
    struct futhark_mc_task_338595 *futhark_mc_task_338595 =
                                  (struct futhark_mc_task_338595 *) args;
    struct futhark_context *ctx = futhark_mc_task_338595->ctx;
    uint64_t futhark_mc_segmap_nested_task_338605_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_nested_task_338605_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338595->free_n_292675;
    int64_t q_l_292680 = futhark_mc_task_338595->free_q_l_292680;
    int64_t jump_t_292685 = futhark_mc_task_338595->free_jump_t_292685;
    int64_t partition_sizze_292766 =
            futhark_mc_task_338595->free_partition_sizze_292766;
    int64_t l_n_m_292832 = futhark_mc_task_338595->free_l_n_m_292832;
    int64_t i_292846 = futhark_mc_task_338595->free_i_292846;
    int64_t bytes_313028 = futhark_mc_task_338595->free_bytes_313028;
    struct memblock mem_313081 = {.desc ="mem_313081", .mem =
                                  futhark_mc_task_338595->free_mem_313081,
                                  .size =0, .references =NULL};
    struct memblock mem_313085 = {.desc ="mem_313085", .mem =
                                  futhark_mc_task_338595->free_mem_313085,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_task_338595->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_task_338595->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_task_338595->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_task_338595->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315021 = {.desc ="mem_315021", .mem =
                                  futhark_mc_task_338595->free_mem_315021,
                                  .size =0, .references =NULL};
    int64_t bytes_315310 = futhark_mc_task_338595->free_bytes_315310;
    struct memblock mem_315480 = {.desc ="mem_315480", .mem =
                                  futhark_mc_task_338595->free_mem_315480,
                                  .size =0, .references =NULL};
    struct memblock mem_315484 = {.desc ="mem_315484", .mem =
                                  futhark_mc_task_338595->free_mem_315484,
                                  .size =0, .references =NULL};
    int64_t iter_330576;
    struct futhark_mc_segmap_parloop_struct_338606
    futhark_mc_segmap_parloop_struct_338606;
    
    futhark_mc_segmap_parloop_struct_338606.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338606.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_338606.free_q_l_292680 = q_l_292680;
    futhark_mc_segmap_parloop_struct_338606.free_jump_t_292685 = jump_t_292685;
    futhark_mc_segmap_parloop_struct_338606.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_338606.free_l_n_m_292832 = l_n_m_292832;
    futhark_mc_segmap_parloop_struct_338606.free_i_292846 = i_292846;
    futhark_mc_segmap_parloop_struct_338606.free_bytes_313028 = bytes_313028;
    futhark_mc_segmap_parloop_struct_338606.free_mem_313081 = mem_313081.mem;
    futhark_mc_segmap_parloop_struct_338606.free_mem_313085 = mem_313085.mem;
    futhark_mc_segmap_parloop_struct_338606.free_ctx_param_ext_313174 =
        ctx_param_ext_313174;
    futhark_mc_segmap_parloop_struct_338606.free_ctx_param_ext_313175 =
        ctx_param_ext_313175;
    futhark_mc_segmap_parloop_struct_338606.free_ctx_param_ext_313177 =
        ctx_param_ext_313177;
    futhark_mc_segmap_parloop_struct_338606.free_mem_param_313179 =
        mem_param_313179.mem;
    futhark_mc_segmap_parloop_struct_338606.free_mem_315021 = mem_315021.mem;
    futhark_mc_segmap_parloop_struct_338606.free_bytes_315310 = bytes_315310;
    futhark_mc_segmap_parloop_struct_338606.free_mem_315480 = mem_315480.mem;
    futhark_mc_segmap_parloop_struct_338606.free_mem_315484 = mem_315484.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338607_task;
    
    futhark_mc_segmap_parloop_338607_task.name =
        "futhark_mc_segmap_parloop_338607";
    futhark_mc_segmap_parloop_338607_task.fn = futhark_mc_segmap_parloop_338607;
    futhark_mc_segmap_parloop_338607_task.args =
        &futhark_mc_segmap_parloop_struct_338606;
    futhark_mc_segmap_parloop_338607_task.iterations = iterations;
    futhark_mc_segmap_parloop_338607_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338607_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338607_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338607_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338607_task);
    
    if (futhark_mc_segmap_parloop_338607_err != 0) {
        err = futhark_mc_segmap_parloop_338607_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338607_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338607_total_end -
                 futhark_mc_segmap_parloop_338607_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338607_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338607_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338607_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_nested_task_338605_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_nested_task_338605_end -
                 futhark_mc_segmap_nested_task_338605_start;
        
        ctx->futhark_mc_segmap_nested_task_338605_runs[tid]++;
        ctx->futhark_mc_segmap_nested_task_338605_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_nested_task_338605_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_task_338644 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_l_292680;
    int64_t free_jump_t_292685;
    int64_t free_partition_sizze_292766;
    int64_t free_l_n_m_292832;
    int64_t free_i_292846;
    int64_t free_bytes_313028;
    unsigned char *free_mem_313081;
    unsigned char *free_mem_313085;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315021;
    unsigned char *free_mem_315514;
};
struct futhark_mc_segmap_parloop_struct_338646 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_l_292680;
    int64_t free_jump_t_292685;
    int64_t free_partition_sizze_292766;
    int64_t free_l_n_m_292832;
    int64_t free_i_292846;
    int64_t free_bytes_313028;
    unsigned char *free_mem_313081;
    unsigned char *free_mem_313085;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315021;
    unsigned char *free_mem_315514;
};
static int futhark_mc_segmap_parloop_338647(void *args, int64_t start,
                                            int64_t end, int flat_tid_306549,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338646
    *futhark_mc_segmap_parloop_struct_338646 =
    (struct futhark_mc_segmap_parloop_struct_338646 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338646->ctx;
    uint64_t futhark_mc_segmap_parloop_338647_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338647_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_338646->free_n_292675;
    int64_t q_l_292680 =
            futhark_mc_segmap_parloop_struct_338646->free_q_l_292680;
    int64_t jump_t_292685 =
            futhark_mc_segmap_parloop_struct_338646->free_jump_t_292685;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_338646->free_partition_sizze_292766;
    int64_t l_n_m_292832 =
            futhark_mc_segmap_parloop_struct_338646->free_l_n_m_292832;
    int64_t i_292846 = futhark_mc_segmap_parloop_struct_338646->free_i_292846;
    int64_t bytes_313028 =
            futhark_mc_segmap_parloop_struct_338646->free_bytes_313028;
    struct memblock mem_313081 = {.desc ="mem_313081", .mem =
                                  futhark_mc_segmap_parloop_struct_338646->free_mem_313081,
                                  .size =0, .references =NULL};
    struct memblock mem_313085 = {.desc ="mem_313085", .mem =
                                  futhark_mc_segmap_parloop_struct_338646->free_mem_313085,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_segmap_parloop_struct_338646->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_segmap_parloop_struct_338646->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_segmap_parloop_struct_338646->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_segmap_parloop_struct_338646->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315021 = {.desc ="mem_315021", .mem =
                                  futhark_mc_segmap_parloop_struct_338646->free_mem_315021,
                                  .size =0, .references =NULL};
    struct memblock mem_315514 = {.desc ="mem_315514", .mem =
                                  futhark_mc_segmap_parloop_struct_338646->free_mem_315514,
                                  .size =0, .references =NULL};
    size_t mem_315498_cached_sizze_338648 = 0;
    unsigned char *mem_315498 = NULL;
    int64_t iterations = end - start;
    int64_t iter_331036 = start;
    
    if (mem_315498_cached_sizze_338648 < (size_t) bytes_313028) {
        mem_315498 = realloc(mem_315498, bytes_313028);
        mem_315498_cached_sizze_338648 = bytes_313028;
    }
    for (; iter_331036 < end; iter_331036++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_331094 = partition_sizze_292766;
        int64_t gtid_306550 = iter_331036;
        int64_t remnant_331095 = iter_331036 - gtid_306550;
        
        for (int64_t i_331037 = 0; i_331037 < l_n_m_292832; i_331037++) {
            int64_t x_331039;
            
            x_331039 = ((int64_t *) mem_313081.mem)[gtid_306550 * l_n_m_292832 +
                                                    i_331037];
            
            double x_331040;
            
            x_331040 = ((double *) mem_313085.mem)[gtid_306550 * l_n_m_292832 +
                                                   i_331037];
            
            int64_t min_arg_331041 = mul64(jump_t_292685, i_331037);
            int64_t min_res_331042 = smin64(i_292846, min_arg_331041);
            int64_t defunc_0_g_res_331043 = add64((int64_t) 1, min_res_331042);
            double defunc_2_reduce_res_331044;
            double redout_331046 = 0.0;
            
            for (int64_t i_331045 = 0; i_331045 < q_l_292680; i_331045++) {
                bool cond_331047 = sle64(n_292675, i_331045);
                int64_t defunc_0_f_res_331048;
                
                if (cond_331047) {
                    defunc_0_f_res_331048 = (int64_t) 0;
                } else {
                    int64_t i_331049 = add64(x_331039, i_331045);
                    int64_t defunc_1_add_res_331050 = add64((int64_t) 1,
                                                            i_331049);
                    
                    defunc_0_f_res_331048 = defunc_1_add_res_331050;
                }
                
                double defunc_0_f_res_331051;
                
                if (cond_331047) {
                    defunc_0_f_res_331051 = 0.0;
                } else {
                    int64_t i_331052 = add64(x_331039, i_331045);
                    double defunc_0_add_arg_331053;
                    
                    defunc_0_add_arg_331053 =
                        ((double *) mem_param_313179.mem)[ctx_param_ext_313174 +
                                                          (gtid_306550 *
                                                           ctx_param_ext_313175 +
                                                           i_331052 *
                                                           ctx_param_ext_313177)];
                    defunc_0_f_res_331051 = defunc_0_add_arg_331053;
                }
                
                int64_t binop_p_331054 = sub64(defunc_0_f_res_331048,
                                               defunc_0_g_res_331043);
                double defunc_0_f_res_331055 = sitofp_i64_f64(binop_p_331054);
                double abs_res_331056 = fabs(defunc_0_f_res_331055);
                double tmp1_331057 = abs_res_331056 / x_331040;
                double x_331058 = tmp1_331057 * tmp1_331057;
                double y_331059 = tmp1_331057 * x_331058;
                double tmp2_331060 = 1.0 - y_331059;
                double x_331061 = tmp2_331060 * tmp2_331060;
                double tmp3_331062 = tmp2_331060 * x_331061;
                double w_j_331063 = defunc_0_f_res_331051 * tmp3_331062;
                double defunc_1_op_res_331064 = w_j_331063 + redout_331046;
                double redout_tmp_331097 = defunc_1_op_res_331064;
                
                redout_331046 = redout_tmp_331097;
            }
            defunc_2_reduce_res_331044 = redout_331046;
            
            double a_331065 = 2.220446049250313e-16 +
                   defunc_2_reduce_res_331044;
            double a0_331066 = 1.0 / a_331065;
            double defunc_2_reduce_res_331067;
            double redout_331069 = 0.0;
            
            for (int64_t i_331068 = 0; i_331068 < q_l_292680; i_331068++) {
                bool cond_331070 = sle64(n_292675, i_331068);
                int64_t defunc_0_f_res_331071;
                
                if (cond_331070) {
                    defunc_0_f_res_331071 = (int64_t) 0;
                } else {
                    int64_t i_331072 = add64(x_331039, i_331068);
                    int64_t defunc_1_add_res_331073 = add64((int64_t) 1,
                                                            i_331072);
                    
                    defunc_0_f_res_331071 = defunc_1_add_res_331073;
                }
                
                double defunc_0_f_res_331074;
                
                if (cond_331070) {
                    defunc_0_f_res_331074 = 0.0;
                } else {
                    int64_t i_331075 = add64(x_331039, i_331068);
                    double defunc_0_add_arg_331076;
                    
                    defunc_0_add_arg_331076 =
                        ((double *) mem_param_313179.mem)[ctx_param_ext_313174 +
                                                          (gtid_306550 *
                                                           ctx_param_ext_313175 +
                                                           i_331075 *
                                                           ctx_param_ext_313177)];
                    defunc_0_f_res_331074 = defunc_0_add_arg_331076;
                }
                
                int64_t binop_p_331077 = sub64(defunc_0_f_res_331071,
                                               defunc_0_g_res_331043);
                double defunc_0_f_res_331078 = sitofp_i64_f64(binop_p_331077);
                double abs_res_331079 = fabs(defunc_0_f_res_331078);
                double tmp1_331080 = abs_res_331079 / x_331040;
                double x_331081 = tmp1_331080 * tmp1_331080;
                double y_331082 = tmp1_331080 * x_331081;
                double tmp2_331083 = 1.0 - y_331082;
                double x_331084 = tmp2_331083 * tmp2_331083;
                double tmp3_331085 = tmp2_331083 * x_331084;
                double tmp4_331086 = defunc_0_f_res_331074 * tmp3_331085;
                double defunc_0_f_res_331087;
                
                if (cond_331070) {
                    defunc_0_f_res_331087 = 0.0;
                } else {
                    int64_t i_331088 = add64(x_331039, i_331068);
                    double defunc_0_add_arg_331089;
                    
                    defunc_0_add_arg_331089 =
                        ((double *) mem_315021.mem)[gtid_306550 * n_292675 +
                                                    i_331088];
                    defunc_0_f_res_331087 = defunc_0_add_arg_331089;
                }
                
                double x_331090 = a0_331066 * tmp4_331086;
                double defunc_9_fit_fun_res_331091 = defunc_0_f_res_331087 *
                       x_331090;
                double defunc_1_op_res_331092 = defunc_9_fit_fun_res_331091 +
                       redout_331069;
                double redout_tmp_331098 = defunc_1_op_res_331092;
                
                redout_331069 = redout_tmp_331098;
            }
            defunc_2_reduce_res_331067 = redout_331069;
            ((double *) mem_315498)[i_331037] = defunc_2_reduce_res_331067;
        }
        if (l_n_m_292832 * (int64_t) 8 > 0)
            memmove(mem_315514.mem + gtid_306550 * l_n_m_292832 * (int64_t) 8,
                    mem_315498 + (int64_t) 0, l_n_m_292832 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_315498);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338647_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338647_end -
                 futhark_mc_segmap_parloop_338647_start;
        
        ctx->futhark_mc_segmap_parloop_338647_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338647_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338647_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_338645(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_306549 = tid;
    int num_tasks_331035 = info.nsubtasks;
    struct futhark_mc_task_338644 *futhark_mc_task_338644 =
                                  (struct futhark_mc_task_338644 *) args;
    struct futhark_context *ctx = futhark_mc_task_338644->ctx;
    uint64_t futhark_mc_segmap_task_338645_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_338645_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338644->free_n_292675;
    int64_t q_l_292680 = futhark_mc_task_338644->free_q_l_292680;
    int64_t jump_t_292685 = futhark_mc_task_338644->free_jump_t_292685;
    int64_t partition_sizze_292766 =
            futhark_mc_task_338644->free_partition_sizze_292766;
    int64_t l_n_m_292832 = futhark_mc_task_338644->free_l_n_m_292832;
    int64_t i_292846 = futhark_mc_task_338644->free_i_292846;
    int64_t bytes_313028 = futhark_mc_task_338644->free_bytes_313028;
    struct memblock mem_313081 = {.desc ="mem_313081", .mem =
                                  futhark_mc_task_338644->free_mem_313081,
                                  .size =0, .references =NULL};
    struct memblock mem_313085 = {.desc ="mem_313085", .mem =
                                  futhark_mc_task_338644->free_mem_313085,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_task_338644->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_task_338644->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_task_338644->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_task_338644->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315021 = {.desc ="mem_315021", .mem =
                                  futhark_mc_task_338644->free_mem_315021,
                                  .size =0, .references =NULL};
    struct memblock mem_315514 = {.desc ="mem_315514", .mem =
                                  futhark_mc_task_338644->free_mem_315514,
                                  .size =0, .references =NULL};
    int64_t iter_331036;
    struct futhark_mc_segmap_parloop_struct_338646
    futhark_mc_segmap_parloop_struct_338646;
    
    futhark_mc_segmap_parloop_struct_338646.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338646.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_338646.free_q_l_292680 = q_l_292680;
    futhark_mc_segmap_parloop_struct_338646.free_jump_t_292685 = jump_t_292685;
    futhark_mc_segmap_parloop_struct_338646.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_338646.free_l_n_m_292832 = l_n_m_292832;
    futhark_mc_segmap_parloop_struct_338646.free_i_292846 = i_292846;
    futhark_mc_segmap_parloop_struct_338646.free_bytes_313028 = bytes_313028;
    futhark_mc_segmap_parloop_struct_338646.free_mem_313081 = mem_313081.mem;
    futhark_mc_segmap_parloop_struct_338646.free_mem_313085 = mem_313085.mem;
    futhark_mc_segmap_parloop_struct_338646.free_ctx_param_ext_313174 =
        ctx_param_ext_313174;
    futhark_mc_segmap_parloop_struct_338646.free_ctx_param_ext_313175 =
        ctx_param_ext_313175;
    futhark_mc_segmap_parloop_struct_338646.free_ctx_param_ext_313177 =
        ctx_param_ext_313177;
    futhark_mc_segmap_parloop_struct_338646.free_mem_param_313179 =
        mem_param_313179.mem;
    futhark_mc_segmap_parloop_struct_338646.free_mem_315021 = mem_315021.mem;
    futhark_mc_segmap_parloop_struct_338646.free_mem_315514 = mem_315514.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338647_task;
    
    futhark_mc_segmap_parloop_338647_task.name =
        "futhark_mc_segmap_parloop_338647";
    futhark_mc_segmap_parloop_338647_task.fn = futhark_mc_segmap_parloop_338647;
    futhark_mc_segmap_parloop_338647_task.args =
        &futhark_mc_segmap_parloop_struct_338646;
    futhark_mc_segmap_parloop_338647_task.iterations = iterations;
    futhark_mc_segmap_parloop_338647_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338647_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338647_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338647_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338647_task);
    
    if (futhark_mc_segmap_parloop_338647_err != 0) {
        err = futhark_mc_segmap_parloop_338647_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338647_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338647_total_end -
                 futhark_mc_segmap_parloop_338647_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338647_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338647_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338647_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_338645_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_338645_end -
                 futhark_mc_segmap_task_338645_start;
        
        ctx->futhark_mc_segmap_task_338645_runs[tid]++;
        ctx->futhark_mc_segmap_task_338645_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_338645_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_segmap_parloop_struct_338650 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_l_292680;
    int64_t free_jump_t_292685;
    int64_t free_partition_sizze_292766;
    int64_t free_l_n_m_292832;
    int64_t free_i_292846;
    int64_t free_bytes_313028;
    unsigned char *free_mem_313081;
    unsigned char *free_mem_313085;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315021;
    unsigned char *free_mem_315514;
};
struct futhark_mc_task_338653 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_l_292680;
    int64_t free_jump_t_292685;
    int64_t free_l_n_m_292832;
    int64_t free_i_292846;
    int64_t free_gtid_306625;
    unsigned char *free_mem_313081;
    unsigned char *free_mem_313085;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315021;
    unsigned char *free_mem_315495;
};
struct futhark_mc_segmap_parloop_struct_338655 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_l_292680;
    int64_t free_jump_t_292685;
    int64_t free_l_n_m_292832;
    int64_t free_i_292846;
    int64_t free_gtid_306625;
    unsigned char *free_mem_313081;
    unsigned char *free_mem_313085;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315021;
    unsigned char *free_mem_315495;
};
static int futhark_mc_segmap_parloop_338656(void *args, int64_t start,
                                            int64_t end, int flat_tid_331160,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338655
    *futhark_mc_segmap_parloop_struct_338655 =
    (struct futhark_mc_segmap_parloop_struct_338655 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338655->ctx;
    uint64_t futhark_mc_segmap_parloop_338656_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338656_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_338655->free_n_292675;
    int64_t q_l_292680 =
            futhark_mc_segmap_parloop_struct_338655->free_q_l_292680;
    int64_t jump_t_292685 =
            futhark_mc_segmap_parloop_struct_338655->free_jump_t_292685;
    int64_t l_n_m_292832 =
            futhark_mc_segmap_parloop_struct_338655->free_l_n_m_292832;
    int64_t i_292846 = futhark_mc_segmap_parloop_struct_338655->free_i_292846;
    int64_t gtid_306625 =
            futhark_mc_segmap_parloop_struct_338655->free_gtid_306625;
    struct memblock mem_313081 = {.desc ="mem_313081", .mem =
                                  futhark_mc_segmap_parloop_struct_338655->free_mem_313081,
                                  .size =0, .references =NULL};
    struct memblock mem_313085 = {.desc ="mem_313085", .mem =
                                  futhark_mc_segmap_parloop_struct_338655->free_mem_313085,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_segmap_parloop_struct_338655->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_segmap_parloop_struct_338655->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_segmap_parloop_struct_338655->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_segmap_parloop_struct_338655->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315021 = {.desc ="mem_315021", .mem =
                                  futhark_mc_segmap_parloop_struct_338655->free_mem_315021,
                                  .size =0, .references =NULL};
    struct memblock mem_315495 = {.desc ="mem_315495", .mem =
                                  futhark_mc_segmap_parloop_struct_338655->free_mem_315495,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_331219 = start;
    
    for (; iter_331219 < end; iter_331219++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_331265 = l_n_m_292832;
        int64_t gtid_331161 = iter_331219;
        int64_t remnant_331266 = iter_331219 - gtid_331161;
        int64_t x_331162;
        
        x_331162 = ((int64_t *) mem_313081.mem)[gtid_306625 * l_n_m_292832 +
                                                gtid_331161];
        
        double x_331163;
        
        x_331163 = ((double *) mem_313085.mem)[gtid_306625 * l_n_m_292832 +
                                               gtid_331161];
        
        int64_t min_arg_331164 = mul64(jump_t_292685, gtid_331161);
        int64_t min_res_331165 = smin64(i_292846, min_arg_331164);
        int64_t defunc_0_g_res_331166 = add64((int64_t) 1, min_res_331165);
        double defunc_2_reduce_res_331167;
        double redout_331221 = 0.0;
        
        for (int64_t i_331220 = 0; i_331220 < q_l_292680; i_331220++) {
            bool cond_331222 = sle64(n_292675, i_331220);
            int64_t defunc_0_f_res_331223;
            
            if (cond_331222) {
                defunc_0_f_res_331223 = (int64_t) 0;
            } else {
                int64_t i_331224 = add64(x_331162, i_331220);
                int64_t defunc_1_add_res_331225 = add64((int64_t) 1, i_331224);
                
                defunc_0_f_res_331223 = defunc_1_add_res_331225;
            }
            
            double defunc_0_f_res_331226;
            
            if (cond_331222) {
                defunc_0_f_res_331226 = 0.0;
            } else {
                int64_t i_331227 = add64(x_331162, i_331220);
                double defunc_0_add_arg_331228;
                
                defunc_0_add_arg_331228 =
                    ((double *) mem_param_313179.mem)[ctx_param_ext_313174 +
                                                      (gtid_306625 *
                                                       ctx_param_ext_313175 +
                                                       i_331227 *
                                                       ctx_param_ext_313177)];
                defunc_0_f_res_331226 = defunc_0_add_arg_331228;
            }
            
            int64_t binop_p_331229 = sub64(defunc_0_f_res_331223,
                                           defunc_0_g_res_331166);
            double defunc_0_f_res_331230 = sitofp_i64_f64(binop_p_331229);
            double abs_res_331231 = fabs(defunc_0_f_res_331230);
            double tmp1_331232 = abs_res_331231 / x_331163;
            double x_331233 = tmp1_331232 * tmp1_331232;
            double y_331234 = tmp1_331232 * x_331233;
            double tmp2_331235 = 1.0 - y_331234;
            double x_331236 = tmp2_331235 * tmp2_331235;
            double tmp3_331237 = tmp2_331235 * x_331236;
            double w_j_331238 = defunc_0_f_res_331226 * tmp3_331237;
            double defunc_1_op_res_331239 = w_j_331238 + redout_331221;
            double redout_tmp_331267 = defunc_1_op_res_331239;
            
            redout_331221 = redout_tmp_331267;
        }
        defunc_2_reduce_res_331167 = redout_331221;
        
        double a_331188 = 2.220446049250313e-16 + defunc_2_reduce_res_331167;
        double a0_331189 = 1.0 / a_331188;
        double defunc_2_reduce_res_331190;
        double redout_331241 = 0.0;
        
        for (int64_t i_331240 = 0; i_331240 < q_l_292680; i_331240++) {
            bool cond_331242 = sle64(n_292675, i_331240);
            int64_t defunc_0_f_res_331243;
            
            if (cond_331242) {
                defunc_0_f_res_331243 = (int64_t) 0;
            } else {
                int64_t i_331244 = add64(x_331162, i_331240);
                int64_t defunc_1_add_res_331245 = add64((int64_t) 1, i_331244);
                
                defunc_0_f_res_331243 = defunc_1_add_res_331245;
            }
            
            double defunc_0_f_res_331246;
            
            if (cond_331242) {
                defunc_0_f_res_331246 = 0.0;
            } else {
                int64_t i_331247 = add64(x_331162, i_331240);
                double defunc_0_add_arg_331248;
                
                defunc_0_add_arg_331248 =
                    ((double *) mem_param_313179.mem)[ctx_param_ext_313174 +
                                                      (gtid_306625 *
                                                       ctx_param_ext_313175 +
                                                       i_331247 *
                                                       ctx_param_ext_313177)];
                defunc_0_f_res_331246 = defunc_0_add_arg_331248;
            }
            
            int64_t binop_p_331249 = sub64(defunc_0_f_res_331243,
                                           defunc_0_g_res_331166);
            double defunc_0_f_res_331250 = sitofp_i64_f64(binop_p_331249);
            double abs_res_331251 = fabs(defunc_0_f_res_331250);
            double tmp1_331252 = abs_res_331251 / x_331163;
            double x_331253 = tmp1_331252 * tmp1_331252;
            double y_331254 = tmp1_331252 * x_331253;
            double tmp2_331255 = 1.0 - y_331254;
            double x_331256 = tmp2_331255 * tmp2_331255;
            double tmp3_331257 = tmp2_331255 * x_331256;
            double tmp4_331258 = defunc_0_f_res_331246 * tmp3_331257;
            double defunc_0_f_res_331259;
            
            if (cond_331242) {
                defunc_0_f_res_331259 = 0.0;
            } else {
                int64_t i_331260 = add64(x_331162, i_331240);
                double defunc_0_add_arg_331261;
                
                defunc_0_add_arg_331261 =
                    ((double *) mem_315021.mem)[gtid_306625 * n_292675 +
                                                i_331260];
                defunc_0_f_res_331259 = defunc_0_add_arg_331261;
            }
            
            double x_331262 = a0_331189 * tmp4_331258;
            double defunc_9_fit_fun_res_331263 = defunc_0_f_res_331259 *
                   x_331262;
            double defunc_1_op_res_331264 = defunc_9_fit_fun_res_331263 +
                   redout_331241;
            double redout_tmp_331268 = defunc_1_op_res_331264;
            
            redout_331241 = redout_tmp_331268;
        }
        defunc_2_reduce_res_331190 = redout_331241;
        ((double *) mem_315495.mem)[gtid_331161] = defunc_2_reduce_res_331190;
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338656_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338656_end -
                 futhark_mc_segmap_parloop_338656_start;
        
        ctx->futhark_mc_segmap_parloop_338656_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338656_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338656_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_338654(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_331160 = tid;
    int num_tasks_331218 = info.nsubtasks;
    struct futhark_mc_task_338653 *futhark_mc_task_338653 =
                                  (struct futhark_mc_task_338653 *) args;
    struct futhark_context *ctx = futhark_mc_task_338653->ctx;
    uint64_t futhark_mc_segmap_task_338654_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_338654_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338653->free_n_292675;
    int64_t q_l_292680 = futhark_mc_task_338653->free_q_l_292680;
    int64_t jump_t_292685 = futhark_mc_task_338653->free_jump_t_292685;
    int64_t l_n_m_292832 = futhark_mc_task_338653->free_l_n_m_292832;
    int64_t i_292846 = futhark_mc_task_338653->free_i_292846;
    int64_t gtid_306625 = futhark_mc_task_338653->free_gtid_306625;
    struct memblock mem_313081 = {.desc ="mem_313081", .mem =
                                  futhark_mc_task_338653->free_mem_313081,
                                  .size =0, .references =NULL};
    struct memblock mem_313085 = {.desc ="mem_313085", .mem =
                                  futhark_mc_task_338653->free_mem_313085,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_task_338653->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_task_338653->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_task_338653->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_task_338653->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315021 = {.desc ="mem_315021", .mem =
                                  futhark_mc_task_338653->free_mem_315021,
                                  .size =0, .references =NULL};
    struct memblock mem_315495 = {.desc ="mem_315495", .mem =
                                  futhark_mc_task_338653->free_mem_315495,
                                  .size =0, .references =NULL};
    int64_t iter_331219;
    struct futhark_mc_segmap_parloop_struct_338655
    futhark_mc_segmap_parloop_struct_338655;
    
    futhark_mc_segmap_parloop_struct_338655.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338655.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_338655.free_q_l_292680 = q_l_292680;
    futhark_mc_segmap_parloop_struct_338655.free_jump_t_292685 = jump_t_292685;
    futhark_mc_segmap_parloop_struct_338655.free_l_n_m_292832 = l_n_m_292832;
    futhark_mc_segmap_parloop_struct_338655.free_i_292846 = i_292846;
    futhark_mc_segmap_parloop_struct_338655.free_gtid_306625 = gtid_306625;
    futhark_mc_segmap_parloop_struct_338655.free_mem_313081 = mem_313081.mem;
    futhark_mc_segmap_parloop_struct_338655.free_mem_313085 = mem_313085.mem;
    futhark_mc_segmap_parloop_struct_338655.free_ctx_param_ext_313174 =
        ctx_param_ext_313174;
    futhark_mc_segmap_parloop_struct_338655.free_ctx_param_ext_313175 =
        ctx_param_ext_313175;
    futhark_mc_segmap_parloop_struct_338655.free_ctx_param_ext_313177 =
        ctx_param_ext_313177;
    futhark_mc_segmap_parloop_struct_338655.free_mem_param_313179 =
        mem_param_313179.mem;
    futhark_mc_segmap_parloop_struct_338655.free_mem_315021 = mem_315021.mem;
    futhark_mc_segmap_parloop_struct_338655.free_mem_315495 = mem_315495.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338656_task;
    
    futhark_mc_segmap_parloop_338656_task.name =
        "futhark_mc_segmap_parloop_338656";
    futhark_mc_segmap_parloop_338656_task.fn = futhark_mc_segmap_parloop_338656;
    futhark_mc_segmap_parloop_338656_task.args =
        &futhark_mc_segmap_parloop_struct_338655;
    futhark_mc_segmap_parloop_338656_task.iterations = iterations;
    futhark_mc_segmap_parloop_338656_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338656_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338656_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338656_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338656_task);
    
    if (futhark_mc_segmap_parloop_338656_err != 0) {
        err = futhark_mc_segmap_parloop_338656_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338656_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338656_total_end -
                 futhark_mc_segmap_parloop_338656_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338656_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338656_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338656_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_338654_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_338654_end -
                 futhark_mc_segmap_task_338654_start;
        
        ctx->futhark_mc_segmap_task_338654_runs[tid]++;
        ctx->futhark_mc_segmap_task_338654_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_338654_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_segmap_parloop_struct_338658 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_l_292680;
    int64_t free_jump_t_292685;
    int64_t free_l_n_m_292832;
    int64_t free_i_292846;
    int64_t free_gtid_306625;
    unsigned char *free_mem_313081;
    unsigned char *free_mem_313085;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315021;
    unsigned char *free_mem_315495;
};
struct futhark_mc_task_338660 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_306625;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    int64_t free_x_331102;
    double free_x_331103;
    int64_t free_defunc_0_g_res_331106;
    double *retval_defunc_2_reduce_res_331107;
};
struct futhark_mc_segred_stage_1_parloop_struct_338663 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_306625;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    int64_t free_x_331102;
    double free_x_331103;
    int64_t free_defunc_0_g_res_331106;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_331322;
};
static int futhark_mc_segred_stage_1_parloop_338664(void *args, int64_t start,
                                                    int64_t end,
                                                    int flat_tid_331270,
                                                    int tid)
{
    int err = 0;
    struct futhark_mc_segred_stage_1_parloop_struct_338663
    *futhark_mc_segred_stage_1_parloop_struct_338663 =
    (struct futhark_mc_segred_stage_1_parloop_struct_338663 *) args;
    struct futhark_context *ctx =
                           futhark_mc_segred_stage_1_parloop_struct_338663->ctx;
    uint64_t futhark_mc_segred_stage_1_parloop_338664_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_338664_start = get_wall_time();
    
    int64_t n_292675 =
            futhark_mc_segred_stage_1_parloop_struct_338663->free_n_292675;
    int64_t gtid_306625 =
            futhark_mc_segred_stage_1_parloop_struct_338663->free_gtid_306625;
    int64_t ctx_param_ext_313174 =
            futhark_mc_segred_stage_1_parloop_struct_338663->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_segred_stage_1_parloop_struct_338663->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_segred_stage_1_parloop_struct_338663->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_segred_stage_1_parloop_struct_338663->free_mem_param_313179,
                                        .size =0, .references =NULL};
    int64_t x_331102 =
            futhark_mc_segred_stage_1_parloop_struct_338663->free_x_331102;
    double x_331103 =
           futhark_mc_segred_stage_1_parloop_struct_338663->free_x_331103;
    int64_t defunc_0_g_res_331106 =
            futhark_mc_segred_stage_1_parloop_struct_338663->free_defunc_0_g_res_331106;
    struct memblock reduce_stage_1_tid_res_arr_mem_331322 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_331322",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338663->free_reduce_stage_1_tid_res_arr_mem_331322,
                                                             .size =0,
                                                             .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_331324 = start;
    double x_331272;
    double x_331273;
    double local_acc_331325 = 0.0;
    
    for (; iter_331324 < end; iter_331324++) {
        int64_t gtid_331271 = iter_331324;
        bool cond_331275 = sle64(n_292675, gtid_331271);
        int64_t defunc_0_f_res_331276;
        
        if (cond_331275) {
            defunc_0_f_res_331276 = (int64_t) 0;
        } else {
            int64_t i_331277 = add64(x_331102, gtid_331271);
            int64_t defunc_1_add_res_331278 = add64((int64_t) 1, i_331277);
            
            defunc_0_f_res_331276 = defunc_1_add_res_331278;
        }
        
        double defunc_0_f_res_331279;
        
        if (cond_331275) {
            defunc_0_f_res_331279 = 0.0;
        } else {
            int64_t i_331280 = add64(x_331102, gtid_331271);
            double defunc_0_add_arg_331281;
            
            defunc_0_add_arg_331281 =
                ((double *) mem_param_313179.mem)[ctx_param_ext_313174 +
                                                  (gtid_306625 *
                                                   ctx_param_ext_313175 +
                                                   i_331280 *
                                                   ctx_param_ext_313177)];
            defunc_0_f_res_331279 = defunc_0_add_arg_331281;
        }
        
        int64_t binop_p_331282 = sub64(defunc_0_f_res_331276,
                                       defunc_0_g_res_331106);
        double defunc_0_f_res_331283 = sitofp_i64_f64(binop_p_331282);
        double abs_res_331284 = fabs(defunc_0_f_res_331283);
        double tmp1_331285 = abs_res_331284 / x_331103;
        double x_331286 = tmp1_331285 * tmp1_331285;
        double y_331287 = tmp1_331285 * x_331286;
        double tmp2_331288 = 1.0 - y_331287;
        double x_331289 = tmp2_331288 * tmp2_331288;
        double tmp3_331290 = tmp2_331288 * x_331289;
        double w_j_331291 = defunc_0_f_res_331279 * tmp3_331290;
        
        // save map-out results
        { }
        // Load accum params
        {
            x_331272 = local_acc_331325;
        }
        // Load next params
        {
            x_331273 = w_j_331291;
        }
        // Red body
        {
            double defunc_1_op_res_331274 = x_331272 + x_331273;
            
            local_acc_331325 = defunc_1_op_res_331274;
        }
    }
    ((double *) reduce_stage_1_tid_res_arr_mem_331322.mem)[flat_tid_331270] =
        local_acc_331325;
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_338664_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_338664_end -
                 futhark_mc_segred_stage_1_parloop_338664_start;
        
        ctx->futhark_mc_segred_stage_1_parloop_338664_runs[tid]++;
        ctx->futhark_mc_segred_stage_1_parloop_338664_total_runtime[tid] +=
            elapsed;
        ctx->futhark_mc_segred_stage_1_parloop_338664_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segred_task_338661(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_331270 = tid;
    int num_tasks_331321 = info.nsubtasks;
    struct futhark_mc_task_338660 *futhark_mc_task_338660 =
                                  (struct futhark_mc_task_338660 *) args;
    struct futhark_context *ctx = futhark_mc_task_338660->ctx;
    uint64_t futhark_mc_segred_task_338661_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_task_338661_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338660->free_n_292675;
    int64_t gtid_306625 = futhark_mc_task_338660->free_gtid_306625;
    int64_t ctx_param_ext_313174 =
            futhark_mc_task_338660->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_task_338660->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_task_338660->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_task_338660->free_mem_param_313179,
                                        .size =0, .references =NULL};
    int64_t x_331102 = futhark_mc_task_338660->free_x_331102;
    double x_331103 = futhark_mc_task_338660->free_x_331103;
    int64_t defunc_0_g_res_331106 =
            futhark_mc_task_338660->free_defunc_0_g_res_331106;
    double defunc_2_reduce_res_331107 =
           *futhark_mc_task_338660->retval_defunc_2_reduce_res_331107;
    size_t reduce_stage_1_tid_res_arr_mem_331322_cached_sizze_338662 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_331322 = NULL;
    
    if (reduce_stage_1_tid_res_arr_mem_331322_cached_sizze_338662 <
        (size_t) ((int64_t) 8 * num_tasks_331321)) {
        reduce_stage_1_tid_res_arr_mem_331322 =
            realloc(reduce_stage_1_tid_res_arr_mem_331322, (int64_t) 8 *
                    num_tasks_331321);
        reduce_stage_1_tid_res_arr_mem_331322_cached_sizze_338662 =
            (int64_t) 8 * num_tasks_331321;
    }
    
    int64_t iter_331324;
    struct futhark_mc_segred_stage_1_parloop_struct_338663
    futhark_mc_segred_stage_1_parloop_struct_338663;
    
    futhark_mc_segred_stage_1_parloop_struct_338663.ctx = ctx;
    futhark_mc_segred_stage_1_parloop_struct_338663.free_n_292675 = n_292675;
    futhark_mc_segred_stage_1_parloop_struct_338663.free_gtid_306625 =
        gtid_306625;
    futhark_mc_segred_stage_1_parloop_struct_338663.free_ctx_param_ext_313174 =
        ctx_param_ext_313174;
    futhark_mc_segred_stage_1_parloop_struct_338663.free_ctx_param_ext_313175 =
        ctx_param_ext_313175;
    futhark_mc_segred_stage_1_parloop_struct_338663.free_ctx_param_ext_313177 =
        ctx_param_ext_313177;
    futhark_mc_segred_stage_1_parloop_struct_338663.free_mem_param_313179 =
        mem_param_313179.mem;
    futhark_mc_segred_stage_1_parloop_struct_338663.free_x_331102 = x_331102;
    futhark_mc_segred_stage_1_parloop_struct_338663.free_x_331103 = x_331103;
    futhark_mc_segred_stage_1_parloop_struct_338663.free_defunc_0_g_res_331106 =
        defunc_0_g_res_331106;
    futhark_mc_segred_stage_1_parloop_struct_338663.free_reduce_stage_1_tid_res_arr_mem_331322 =
        reduce_stage_1_tid_res_arr_mem_331322;
    
    struct scheduler_parloop futhark_mc_segred_stage_1_parloop_338664_task;
    
    futhark_mc_segred_stage_1_parloop_338664_task.name =
        "futhark_mc_segred_stage_1_parloop_338664";
    futhark_mc_segred_stage_1_parloop_338664_task.fn =
        futhark_mc_segred_stage_1_parloop_338664;
    futhark_mc_segred_stage_1_parloop_338664_task.args =
        &futhark_mc_segred_stage_1_parloop_struct_338663;
    futhark_mc_segred_stage_1_parloop_338664_task.iterations = iterations;
    futhark_mc_segred_stage_1_parloop_338664_task.info = info;
    
    uint64_t futhark_mc_segred_stage_1_parloop_338664_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_338664_total_start = get_wall_time();
    
    int futhark_mc_segred_stage_1_parloop_338664_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segred_stage_1_parloop_338664_task);
    
    if (futhark_mc_segred_stage_1_parloop_338664_err != 0) {
        err = futhark_mc_segred_stage_1_parloop_338664_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_338664_total_end =
                 get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_338664_total_end -
                 futhark_mc_segred_stage_1_parloop_338664_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338664_total_runs,
                           1, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338664_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338664_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    // neutral-initialise the output
    {
        defunc_2_reduce_res_331107 = 0.0;
    }
    
    double x_331326;
    double x_331327;
    
    for (int32_t i_331329 = 0; i_331329 < num_tasks_331321; i_331329++) {
        flat_tid_331270 = i_331329;
        // Apply main thread reduction
        {
            // load acc params
            {
                x_331326 = defunc_2_reduce_res_331107;
            }
            // load next params
            {
                x_331327 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_331322)[flat_tid_331270];
            }
            // red body
            {
                double defunc_1_op_res_331328 = x_331326 + x_331327;
                
                defunc_2_reduce_res_331107 = defunc_1_op_res_331328;
            }
        }
    }
    
  cleanup:
    {
        free(reduce_stage_1_tid_res_arr_mem_331322);
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_task_338661_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_task_338661_end -
                 futhark_mc_segred_task_338661_start;
        
        ctx->futhark_mc_segred_task_338661_runs[tid]++;
        ctx->futhark_mc_segred_task_338661_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segred_task_338661_iter[tid] += iterations;
    }
    if (err == 0) {
        *futhark_mc_task_338660->retval_defunc_2_reduce_res_331107 =
            defunc_2_reduce_res_331107;
    }
    return err;
}
struct futhark_mc_task_338665 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_306625;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315021;
    int64_t free_x_331102;
    double free_x_331103;
    int64_t free_defunc_0_g_res_331106;
    double free_a0_331131;
    double *retval_defunc_2_reduce_res_331132;
};
struct futhark_mc_segred_stage_1_parloop_struct_338668 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_306625;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315021;
    int64_t free_x_331102;
    double free_x_331103;
    int64_t free_defunc_0_g_res_331106;
    double free_a0_331131;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_331331;
};
static int futhark_mc_segred_stage_1_parloop_338669(void *args, int64_t start,
                                                    int64_t end,
                                                    int flat_tid_331292,
                                                    int tid)
{
    int err = 0;
    struct futhark_mc_segred_stage_1_parloop_struct_338668
    *futhark_mc_segred_stage_1_parloop_struct_338668 =
    (struct futhark_mc_segred_stage_1_parloop_struct_338668 *) args;
    struct futhark_context *ctx =
                           futhark_mc_segred_stage_1_parloop_struct_338668->ctx;
    uint64_t futhark_mc_segred_stage_1_parloop_338669_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_338669_start = get_wall_time();
    
    int64_t n_292675 =
            futhark_mc_segred_stage_1_parloop_struct_338668->free_n_292675;
    int64_t gtid_306625 =
            futhark_mc_segred_stage_1_parloop_struct_338668->free_gtid_306625;
    int64_t ctx_param_ext_313174 =
            futhark_mc_segred_stage_1_parloop_struct_338668->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_segred_stage_1_parloop_struct_338668->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_segred_stage_1_parloop_struct_338668->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_segred_stage_1_parloop_struct_338668->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315021 = {.desc ="mem_315021", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_338668->free_mem_315021,
                                  .size =0, .references =NULL};
    int64_t x_331102 =
            futhark_mc_segred_stage_1_parloop_struct_338668->free_x_331102;
    double x_331103 =
           futhark_mc_segred_stage_1_parloop_struct_338668->free_x_331103;
    int64_t defunc_0_g_res_331106 =
            futhark_mc_segred_stage_1_parloop_struct_338668->free_defunc_0_g_res_331106;
    double a0_331131 =
           futhark_mc_segred_stage_1_parloop_struct_338668->free_a0_331131;
    struct memblock reduce_stage_1_tid_res_arr_mem_331331 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_331331",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338668->free_reduce_stage_1_tid_res_arr_mem_331331,
                                                             .size =0,
                                                             .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_331333 = start;
    double x_331294;
    double x_331295;
    double local_acc_331334 = 0.0;
    
    for (; iter_331333 < end; iter_331333++) {
        int64_t gtid_331293 = iter_331333;
        bool cond_331297 = sle64(n_292675, gtid_331293);
        int64_t defunc_0_f_res_331298;
        
        if (cond_331297) {
            defunc_0_f_res_331298 = (int64_t) 0;
        } else {
            int64_t i_331299 = add64(x_331102, gtid_331293);
            int64_t defunc_1_add_res_331300 = add64((int64_t) 1, i_331299);
            
            defunc_0_f_res_331298 = defunc_1_add_res_331300;
        }
        
        double defunc_0_f_res_331301;
        
        if (cond_331297) {
            defunc_0_f_res_331301 = 0.0;
        } else {
            int64_t i_331302 = add64(x_331102, gtid_331293);
            double defunc_0_add_arg_331303;
            
            defunc_0_add_arg_331303 =
                ((double *) mem_param_313179.mem)[ctx_param_ext_313174 +
                                                  (gtid_306625 *
                                                   ctx_param_ext_313175 +
                                                   i_331302 *
                                                   ctx_param_ext_313177)];
            defunc_0_f_res_331301 = defunc_0_add_arg_331303;
        }
        
        int64_t binop_p_331304 = sub64(defunc_0_f_res_331298,
                                       defunc_0_g_res_331106);
        double defunc_0_f_res_331305 = sitofp_i64_f64(binop_p_331304);
        double abs_res_331306 = fabs(defunc_0_f_res_331305);
        double tmp1_331307 = abs_res_331306 / x_331103;
        double x_331308 = tmp1_331307 * tmp1_331307;
        double y_331309 = tmp1_331307 * x_331308;
        double tmp2_331310 = 1.0 - y_331309;
        double x_331311 = tmp2_331310 * tmp2_331310;
        double tmp3_331312 = tmp2_331310 * x_331311;
        double tmp4_331313 = defunc_0_f_res_331301 * tmp3_331312;
        double defunc_0_f_res_331314;
        
        if (cond_331297) {
            defunc_0_f_res_331314 = 0.0;
        } else {
            int64_t i_331315 = add64(x_331102, gtid_331293);
            double defunc_0_add_arg_331316;
            
            defunc_0_add_arg_331316 = ((double *) mem_315021.mem)[gtid_306625 *
                                                                  n_292675 +
                                                                  i_331315];
            defunc_0_f_res_331314 = defunc_0_add_arg_331316;
        }
        
        double x_331317 = a0_331131 * tmp4_331313;
        double defunc_9_fit_fun_res_331318 = defunc_0_f_res_331314 * x_331317;
        
        // save map-out results
        { }
        // Load accum params
        {
            x_331294 = local_acc_331334;
        }
        // Load next params
        {
            x_331295 = defunc_9_fit_fun_res_331318;
        }
        // Red body
        {
            double defunc_1_op_res_331296 = x_331294 + x_331295;
            
            local_acc_331334 = defunc_1_op_res_331296;
        }
    }
    ((double *) reduce_stage_1_tid_res_arr_mem_331331.mem)[flat_tid_331292] =
        local_acc_331334;
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_338669_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_338669_end -
                 futhark_mc_segred_stage_1_parloop_338669_start;
        
        ctx->futhark_mc_segred_stage_1_parloop_338669_runs[tid]++;
        ctx->futhark_mc_segred_stage_1_parloop_338669_total_runtime[tid] +=
            elapsed;
        ctx->futhark_mc_segred_stage_1_parloop_338669_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segred_task_338666(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_331292 = tid;
    int num_tasks_331330 = info.nsubtasks;
    struct futhark_mc_task_338665 *futhark_mc_task_338665 =
                                  (struct futhark_mc_task_338665 *) args;
    struct futhark_context *ctx = futhark_mc_task_338665->ctx;
    uint64_t futhark_mc_segred_task_338666_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_task_338666_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338665->free_n_292675;
    int64_t gtid_306625 = futhark_mc_task_338665->free_gtid_306625;
    int64_t ctx_param_ext_313174 =
            futhark_mc_task_338665->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_task_338665->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_task_338665->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_task_338665->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315021 = {.desc ="mem_315021", .mem =
                                  futhark_mc_task_338665->free_mem_315021,
                                  .size =0, .references =NULL};
    int64_t x_331102 = futhark_mc_task_338665->free_x_331102;
    double x_331103 = futhark_mc_task_338665->free_x_331103;
    int64_t defunc_0_g_res_331106 =
            futhark_mc_task_338665->free_defunc_0_g_res_331106;
    double a0_331131 = futhark_mc_task_338665->free_a0_331131;
    double defunc_2_reduce_res_331132 =
           *futhark_mc_task_338665->retval_defunc_2_reduce_res_331132;
    size_t reduce_stage_1_tid_res_arr_mem_331331_cached_sizze_338667 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_331331 = NULL;
    
    if (reduce_stage_1_tid_res_arr_mem_331331_cached_sizze_338667 <
        (size_t) ((int64_t) 8 * num_tasks_331330)) {
        reduce_stage_1_tid_res_arr_mem_331331 =
            realloc(reduce_stage_1_tid_res_arr_mem_331331, (int64_t) 8 *
                    num_tasks_331330);
        reduce_stage_1_tid_res_arr_mem_331331_cached_sizze_338667 =
            (int64_t) 8 * num_tasks_331330;
    }
    
    int64_t iter_331333;
    struct futhark_mc_segred_stage_1_parloop_struct_338668
    futhark_mc_segred_stage_1_parloop_struct_338668;
    
    futhark_mc_segred_stage_1_parloop_struct_338668.ctx = ctx;
    futhark_mc_segred_stage_1_parloop_struct_338668.free_n_292675 = n_292675;
    futhark_mc_segred_stage_1_parloop_struct_338668.free_gtid_306625 =
        gtid_306625;
    futhark_mc_segred_stage_1_parloop_struct_338668.free_ctx_param_ext_313174 =
        ctx_param_ext_313174;
    futhark_mc_segred_stage_1_parloop_struct_338668.free_ctx_param_ext_313175 =
        ctx_param_ext_313175;
    futhark_mc_segred_stage_1_parloop_struct_338668.free_ctx_param_ext_313177 =
        ctx_param_ext_313177;
    futhark_mc_segred_stage_1_parloop_struct_338668.free_mem_param_313179 =
        mem_param_313179.mem;
    futhark_mc_segred_stage_1_parloop_struct_338668.free_mem_315021 =
        mem_315021.mem;
    futhark_mc_segred_stage_1_parloop_struct_338668.free_x_331102 = x_331102;
    futhark_mc_segred_stage_1_parloop_struct_338668.free_x_331103 = x_331103;
    futhark_mc_segred_stage_1_parloop_struct_338668.free_defunc_0_g_res_331106 =
        defunc_0_g_res_331106;
    futhark_mc_segred_stage_1_parloop_struct_338668.free_a0_331131 = a0_331131;
    futhark_mc_segred_stage_1_parloop_struct_338668.free_reduce_stage_1_tid_res_arr_mem_331331 =
        reduce_stage_1_tid_res_arr_mem_331331;
    
    struct scheduler_parloop futhark_mc_segred_stage_1_parloop_338669_task;
    
    futhark_mc_segred_stage_1_parloop_338669_task.name =
        "futhark_mc_segred_stage_1_parloop_338669";
    futhark_mc_segred_stage_1_parloop_338669_task.fn =
        futhark_mc_segred_stage_1_parloop_338669;
    futhark_mc_segred_stage_1_parloop_338669_task.args =
        &futhark_mc_segred_stage_1_parloop_struct_338668;
    futhark_mc_segred_stage_1_parloop_338669_task.iterations = iterations;
    futhark_mc_segred_stage_1_parloop_338669_task.info = info;
    
    uint64_t futhark_mc_segred_stage_1_parloop_338669_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_338669_total_start = get_wall_time();
    
    int futhark_mc_segred_stage_1_parloop_338669_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segred_stage_1_parloop_338669_task);
    
    if (futhark_mc_segred_stage_1_parloop_338669_err != 0) {
        err = futhark_mc_segred_stage_1_parloop_338669_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_338669_total_end =
                 get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_338669_total_end -
                 futhark_mc_segred_stage_1_parloop_338669_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338669_total_runs,
                           1, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338669_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338669_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    // neutral-initialise the output
    {
        defunc_2_reduce_res_331132 = 0.0;
    }
    
    double x_331335;
    double x_331336;
    
    for (int32_t i_331338 = 0; i_331338 < num_tasks_331330; i_331338++) {
        flat_tid_331292 = i_331338;
        // Apply main thread reduction
        {
            // load acc params
            {
                x_331335 = defunc_2_reduce_res_331132;
            }
            // load next params
            {
                x_331336 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_331331)[flat_tid_331292];
            }
            // red body
            {
                double defunc_1_op_res_331337 = x_331335 + x_331336;
                
                defunc_2_reduce_res_331132 = defunc_1_op_res_331337;
            }
        }
    }
    
  cleanup:
    {
        free(reduce_stage_1_tid_res_arr_mem_331331);
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_task_338666_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_task_338666_end -
                 futhark_mc_segred_task_338666_start;
        
        ctx->futhark_mc_segred_task_338666_runs[tid]++;
        ctx->futhark_mc_segred_task_338666_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segred_task_338666_iter[tid] += iterations;
    }
    if (err == 0) {
        *futhark_mc_task_338665->retval_defunc_2_reduce_res_331132 =
            defunc_2_reduce_res_331132;
    }
    return err;
}
static int futhark_mc_segmap_parloop_338659(void *args, int64_t start,
                                            int64_t end, int flat_tid_331100,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338658
    *futhark_mc_segmap_parloop_struct_338658 =
    (struct futhark_mc_segmap_parloop_struct_338658 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338658->ctx;
    uint64_t futhark_mc_segmap_parloop_338659_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338659_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_338658->free_n_292675;
    int64_t q_l_292680 =
            futhark_mc_segmap_parloop_struct_338658->free_q_l_292680;
    int64_t jump_t_292685 =
            futhark_mc_segmap_parloop_struct_338658->free_jump_t_292685;
    int64_t l_n_m_292832 =
            futhark_mc_segmap_parloop_struct_338658->free_l_n_m_292832;
    int64_t i_292846 = futhark_mc_segmap_parloop_struct_338658->free_i_292846;
    int64_t gtid_306625 =
            futhark_mc_segmap_parloop_struct_338658->free_gtid_306625;
    struct memblock mem_313081 = {.desc ="mem_313081", .mem =
                                  futhark_mc_segmap_parloop_struct_338658->free_mem_313081,
                                  .size =0, .references =NULL};
    struct memblock mem_313085 = {.desc ="mem_313085", .mem =
                                  futhark_mc_segmap_parloop_struct_338658->free_mem_313085,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_segmap_parloop_struct_338658->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_segmap_parloop_struct_338658->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_segmap_parloop_struct_338658->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_segmap_parloop_struct_338658->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315021 = {.desc ="mem_315021", .mem =
                                  futhark_mc_segmap_parloop_struct_338658->free_mem_315021,
                                  .size =0, .references =NULL};
    struct memblock mem_315495 = {.desc ="mem_315495", .mem =
                                  futhark_mc_segmap_parloop_struct_338658->free_mem_315495,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_331269 = start;
    
    for (; iter_331269 < end; iter_331269++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_331319 = l_n_m_292832;
        int64_t gtid_331101 = iter_331269;
        int64_t remnant_331320 = iter_331269 - gtid_331101;
        int64_t x_331102;
        
        x_331102 = ((int64_t *) mem_313081.mem)[gtid_306625 * l_n_m_292832 +
                                                gtid_331101];
        
        double x_331103;
        
        x_331103 = ((double *) mem_313085.mem)[gtid_306625 * l_n_m_292832 +
                                               gtid_331101];
        
        int64_t min_arg_331104 = mul64(jump_t_292685, gtid_331101);
        int64_t min_res_331105 = smin64(i_292846, min_arg_331104);
        int64_t defunc_0_g_res_331106 = add64((int64_t) 1, min_res_331105);
        double defunc_2_reduce_res_331107;
        int64_t flat_tid_331270 = (int64_t) 0;
        int32_t num_tasks_331321;
        
        defunc_2_reduce_res_331107 = 0.0;
        
        struct futhark_mc_task_338660 futhark_mc_task_338660;
        
        futhark_mc_task_338660.ctx = ctx;
        futhark_mc_task_338660.free_n_292675 = n_292675;
        futhark_mc_task_338660.free_gtid_306625 = gtid_306625;
        futhark_mc_task_338660.free_ctx_param_ext_313174 = ctx_param_ext_313174;
        futhark_mc_task_338660.free_ctx_param_ext_313175 = ctx_param_ext_313175;
        futhark_mc_task_338660.free_ctx_param_ext_313177 = ctx_param_ext_313177;
        futhark_mc_task_338660.free_mem_param_313179 = mem_param_313179.mem;
        futhark_mc_task_338660.free_x_331102 = x_331102;
        futhark_mc_task_338660.free_x_331103 = x_331103;
        futhark_mc_task_338660.free_defunc_0_g_res_331106 =
            defunc_0_g_res_331106;
        futhark_mc_task_338660.retval_defunc_2_reduce_res_331107 =
            &defunc_2_reduce_res_331107;
        
        struct scheduler_segop futhark_mc_task_338660_task;
        
        futhark_mc_task_338660_task.args = &futhark_mc_task_338660;
        futhark_mc_task_338660_task.top_level_fn =
            futhark_mc_segred_task_338661;
        futhark_mc_task_338660_task.name = "futhark_mc_segred_task_338661";
        futhark_mc_task_338660_task.iterations = q_l_292680;
        futhark_mc_task_338660_task.task_time =
            &ctx->futhark_mc_segred_task_338661_total_time;
        futhark_mc_task_338660_task.task_iter =
            &ctx->futhark_mc_segred_task_338661_total_iter;
        futhark_mc_task_338660_task.sched = STATIC;
        futhark_mc_task_338660_task.nested_fn = NULL;
        
        int futhark_mc_segred_task_338661_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_338660_task);
        
        if (futhark_mc_segred_task_338661_err != 0) {
            ;
            err = futhark_mc_segred_task_338661_err;
            goto cleanup;
        }
        
        double a_331130 = 2.220446049250313e-16 + defunc_2_reduce_res_331107;
        double a0_331131 = 1.0 / a_331130;
        double defunc_2_reduce_res_331132;
        int64_t flat_tid_331292 = (int64_t) 0;
        int32_t num_tasks_331330;
        
        defunc_2_reduce_res_331132 = 0.0;
        
        struct futhark_mc_task_338665 futhark_mc_task_338665;
        
        futhark_mc_task_338665.ctx = ctx;
        futhark_mc_task_338665.free_n_292675 = n_292675;
        futhark_mc_task_338665.free_gtid_306625 = gtid_306625;
        futhark_mc_task_338665.free_ctx_param_ext_313174 = ctx_param_ext_313174;
        futhark_mc_task_338665.free_ctx_param_ext_313175 = ctx_param_ext_313175;
        futhark_mc_task_338665.free_ctx_param_ext_313177 = ctx_param_ext_313177;
        futhark_mc_task_338665.free_mem_param_313179 = mem_param_313179.mem;
        futhark_mc_task_338665.free_mem_315021 = mem_315021.mem;
        futhark_mc_task_338665.free_x_331102 = x_331102;
        futhark_mc_task_338665.free_x_331103 = x_331103;
        futhark_mc_task_338665.free_defunc_0_g_res_331106 =
            defunc_0_g_res_331106;
        futhark_mc_task_338665.free_a0_331131 = a0_331131;
        futhark_mc_task_338665.retval_defunc_2_reduce_res_331132 =
            &defunc_2_reduce_res_331132;
        
        struct scheduler_segop futhark_mc_task_338665_task;
        
        futhark_mc_task_338665_task.args = &futhark_mc_task_338665;
        futhark_mc_task_338665_task.top_level_fn =
            futhark_mc_segred_task_338666;
        futhark_mc_task_338665_task.name = "futhark_mc_segred_task_338666";
        futhark_mc_task_338665_task.iterations = q_l_292680;
        futhark_mc_task_338665_task.task_time =
            &ctx->futhark_mc_segred_task_338666_total_time;
        futhark_mc_task_338665_task.task_iter =
            &ctx->futhark_mc_segred_task_338666_total_iter;
        futhark_mc_task_338665_task.sched = STATIC;
        futhark_mc_task_338665_task.nested_fn = NULL;
        
        int futhark_mc_segred_task_338666_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_338665_task);
        
        if (futhark_mc_segred_task_338666_err != 0) {
            ;
            err = futhark_mc_segred_task_338666_err;
            goto cleanup;
        }
        ((double *) mem_315495.mem)[gtid_331101] = defunc_2_reduce_res_331132;
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338659_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338659_end -
                 futhark_mc_segmap_parloop_338659_start;
        
        ctx->futhark_mc_segmap_parloop_338659_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338659_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338659_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_nested_task_338657(void *args, int64_t iterations,
                                         int tid, struct scheduler_info info)
{
    int err = 0;
    int flat_tid_331100 = tid;
    int num_tasks_331218 = info.nsubtasks;
    struct futhark_mc_task_338653 *futhark_mc_task_338653 =
                                  (struct futhark_mc_task_338653 *) args;
    struct futhark_context *ctx = futhark_mc_task_338653->ctx;
    uint64_t futhark_mc_segmap_nested_task_338657_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_nested_task_338657_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338653->free_n_292675;
    int64_t q_l_292680 = futhark_mc_task_338653->free_q_l_292680;
    int64_t jump_t_292685 = futhark_mc_task_338653->free_jump_t_292685;
    int64_t l_n_m_292832 = futhark_mc_task_338653->free_l_n_m_292832;
    int64_t i_292846 = futhark_mc_task_338653->free_i_292846;
    int64_t gtid_306625 = futhark_mc_task_338653->free_gtid_306625;
    struct memblock mem_313081 = {.desc ="mem_313081", .mem =
                                  futhark_mc_task_338653->free_mem_313081,
                                  .size =0, .references =NULL};
    struct memblock mem_313085 = {.desc ="mem_313085", .mem =
                                  futhark_mc_task_338653->free_mem_313085,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_task_338653->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_task_338653->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_task_338653->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_task_338653->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315021 = {.desc ="mem_315021", .mem =
                                  futhark_mc_task_338653->free_mem_315021,
                                  .size =0, .references =NULL};
    struct memblock mem_315495 = {.desc ="mem_315495", .mem =
                                  futhark_mc_task_338653->free_mem_315495,
                                  .size =0, .references =NULL};
    int64_t iter_331269;
    struct futhark_mc_segmap_parloop_struct_338658
    futhark_mc_segmap_parloop_struct_338658;
    
    futhark_mc_segmap_parloop_struct_338658.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338658.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_338658.free_q_l_292680 = q_l_292680;
    futhark_mc_segmap_parloop_struct_338658.free_jump_t_292685 = jump_t_292685;
    futhark_mc_segmap_parloop_struct_338658.free_l_n_m_292832 = l_n_m_292832;
    futhark_mc_segmap_parloop_struct_338658.free_i_292846 = i_292846;
    futhark_mc_segmap_parloop_struct_338658.free_gtid_306625 = gtid_306625;
    futhark_mc_segmap_parloop_struct_338658.free_mem_313081 = mem_313081.mem;
    futhark_mc_segmap_parloop_struct_338658.free_mem_313085 = mem_313085.mem;
    futhark_mc_segmap_parloop_struct_338658.free_ctx_param_ext_313174 =
        ctx_param_ext_313174;
    futhark_mc_segmap_parloop_struct_338658.free_ctx_param_ext_313175 =
        ctx_param_ext_313175;
    futhark_mc_segmap_parloop_struct_338658.free_ctx_param_ext_313177 =
        ctx_param_ext_313177;
    futhark_mc_segmap_parloop_struct_338658.free_mem_param_313179 =
        mem_param_313179.mem;
    futhark_mc_segmap_parloop_struct_338658.free_mem_315021 = mem_315021.mem;
    futhark_mc_segmap_parloop_struct_338658.free_mem_315495 = mem_315495.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338659_task;
    
    futhark_mc_segmap_parloop_338659_task.name =
        "futhark_mc_segmap_parloop_338659";
    futhark_mc_segmap_parloop_338659_task.fn = futhark_mc_segmap_parloop_338659;
    futhark_mc_segmap_parloop_338659_task.args =
        &futhark_mc_segmap_parloop_struct_338658;
    futhark_mc_segmap_parloop_338659_task.iterations = iterations;
    futhark_mc_segmap_parloop_338659_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338659_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338659_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338659_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338659_task);
    
    if (futhark_mc_segmap_parloop_338659_err != 0) {
        err = futhark_mc_segmap_parloop_338659_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338659_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338659_total_end -
                 futhark_mc_segmap_parloop_338659_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338659_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338659_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338659_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_nested_task_338657_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_nested_task_338657_end -
                 futhark_mc_segmap_nested_task_338657_start;
        
        ctx->futhark_mc_segmap_nested_task_338657_runs[tid]++;
        ctx->futhark_mc_segmap_nested_task_338657_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_nested_task_338657_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
static int futhark_mc_segmap_parloop_338651(void *args, int64_t start,
                                            int64_t end, int flat_tid_306624,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338650
    *futhark_mc_segmap_parloop_struct_338650 =
    (struct futhark_mc_segmap_parloop_struct_338650 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338650->ctx;
    uint64_t futhark_mc_segmap_parloop_338651_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338651_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_338650->free_n_292675;
    int64_t q_l_292680 =
            futhark_mc_segmap_parloop_struct_338650->free_q_l_292680;
    int64_t jump_t_292685 =
            futhark_mc_segmap_parloop_struct_338650->free_jump_t_292685;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_338650->free_partition_sizze_292766;
    int64_t l_n_m_292832 =
            futhark_mc_segmap_parloop_struct_338650->free_l_n_m_292832;
    int64_t i_292846 = futhark_mc_segmap_parloop_struct_338650->free_i_292846;
    int64_t bytes_313028 =
            futhark_mc_segmap_parloop_struct_338650->free_bytes_313028;
    struct memblock mem_313081 = {.desc ="mem_313081", .mem =
                                  futhark_mc_segmap_parloop_struct_338650->free_mem_313081,
                                  .size =0, .references =NULL};
    struct memblock mem_313085 = {.desc ="mem_313085", .mem =
                                  futhark_mc_segmap_parloop_struct_338650->free_mem_313085,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_segmap_parloop_struct_338650->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_segmap_parloop_struct_338650->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_segmap_parloop_struct_338650->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_segmap_parloop_struct_338650->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315021 = {.desc ="mem_315021", .mem =
                                  futhark_mc_segmap_parloop_struct_338650->free_mem_315021,
                                  .size =0, .references =NULL};
    struct memblock mem_315514 = {.desc ="mem_315514", .mem =
                                  futhark_mc_segmap_parloop_struct_338650->free_mem_315514,
                                  .size =0, .references =NULL};
    size_t mem_315495_cached_sizze_338652 = 0;
    unsigned char *mem_315495 = NULL;
    int64_t iterations = end - start;
    int64_t iter_331099 = start;
    
    if (mem_315495_cached_sizze_338652 < (size_t) bytes_313028) {
        mem_315495 = realloc(mem_315495, bytes_313028);
        mem_315495_cached_sizze_338652 = bytes_313028;
    }
    for (; iter_331099 < end; iter_331099++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_331216 = partition_sizze_292766;
        int64_t gtid_306625 = iter_331099;
        int64_t remnant_331217 = iter_331099 - gtid_306625;
        int64_t flat_tid_331160 = (int64_t) 0;
        int32_t num_tasks_331218;
        int64_t flat_tid_331100 = (int64_t) 0;
        struct futhark_mc_task_338653 futhark_mc_task_338653;
        
        futhark_mc_task_338653.ctx = ctx;
        futhark_mc_task_338653.free_n_292675 = n_292675;
        futhark_mc_task_338653.free_q_l_292680 = q_l_292680;
        futhark_mc_task_338653.free_jump_t_292685 = jump_t_292685;
        futhark_mc_task_338653.free_l_n_m_292832 = l_n_m_292832;
        futhark_mc_task_338653.free_i_292846 = i_292846;
        futhark_mc_task_338653.free_gtid_306625 = gtid_306625;
        futhark_mc_task_338653.free_mem_313081 = mem_313081.mem;
        futhark_mc_task_338653.free_mem_313085 = mem_313085.mem;
        futhark_mc_task_338653.free_ctx_param_ext_313174 = ctx_param_ext_313174;
        futhark_mc_task_338653.free_ctx_param_ext_313175 = ctx_param_ext_313175;
        futhark_mc_task_338653.free_ctx_param_ext_313177 = ctx_param_ext_313177;
        futhark_mc_task_338653.free_mem_param_313179 = mem_param_313179.mem;
        futhark_mc_task_338653.free_mem_315021 = mem_315021.mem;
        futhark_mc_task_338653.free_mem_315495 = mem_315495;
        
        struct scheduler_segop futhark_mc_task_338653_task;
        
        futhark_mc_task_338653_task.args = &futhark_mc_task_338653;
        futhark_mc_task_338653_task.top_level_fn =
            futhark_mc_segmap_task_338654;
        futhark_mc_task_338653_task.name = "futhark_mc_segmap_task_338654";
        futhark_mc_task_338653_task.iterations = l_n_m_292832;
        futhark_mc_task_338653_task.task_time =
            &ctx->futhark_mc_segmap_task_338654_total_time;
        futhark_mc_task_338653_task.task_iter =
            &ctx->futhark_mc_segmap_task_338654_total_iter;
        futhark_mc_task_338653_task.sched = STATIC;
        futhark_mc_task_338653_task.nested_fn =
            futhark_mc_segmap_nested_task_338657;
        
        int futhark_mc_segmap_task_338654_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_338653_task);
        
        if (futhark_mc_segmap_task_338654_err != 0) {
            ;
            err = futhark_mc_segmap_task_338654_err;
            goto cleanup;
        }
        if (l_n_m_292832 * (int64_t) 8 > 0)
            memmove(mem_315514.mem + gtid_306625 * l_n_m_292832 * (int64_t) 8,
                    mem_315495 + (int64_t) 0, l_n_m_292832 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_315495);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338651_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338651_end -
                 futhark_mc_segmap_parloop_338651_start;
        
        ctx->futhark_mc_segmap_parloop_338651_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338651_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338651_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_nested_task_338649(void *args, int64_t iterations,
                                         int tid, struct scheduler_info info)
{
    int err = 0;
    int flat_tid_306624 = tid;
    int num_tasks_331035 = info.nsubtasks;
    struct futhark_mc_task_338644 *futhark_mc_task_338644 =
                                  (struct futhark_mc_task_338644 *) args;
    struct futhark_context *ctx = futhark_mc_task_338644->ctx;
    uint64_t futhark_mc_segmap_nested_task_338649_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_nested_task_338649_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338644->free_n_292675;
    int64_t q_l_292680 = futhark_mc_task_338644->free_q_l_292680;
    int64_t jump_t_292685 = futhark_mc_task_338644->free_jump_t_292685;
    int64_t partition_sizze_292766 =
            futhark_mc_task_338644->free_partition_sizze_292766;
    int64_t l_n_m_292832 = futhark_mc_task_338644->free_l_n_m_292832;
    int64_t i_292846 = futhark_mc_task_338644->free_i_292846;
    int64_t bytes_313028 = futhark_mc_task_338644->free_bytes_313028;
    struct memblock mem_313081 = {.desc ="mem_313081", .mem =
                                  futhark_mc_task_338644->free_mem_313081,
                                  .size =0, .references =NULL};
    struct memblock mem_313085 = {.desc ="mem_313085", .mem =
                                  futhark_mc_task_338644->free_mem_313085,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_task_338644->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_task_338644->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_task_338644->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_task_338644->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315021 = {.desc ="mem_315021", .mem =
                                  futhark_mc_task_338644->free_mem_315021,
                                  .size =0, .references =NULL};
    struct memblock mem_315514 = {.desc ="mem_315514", .mem =
                                  futhark_mc_task_338644->free_mem_315514,
                                  .size =0, .references =NULL};
    int64_t iter_331099;
    struct futhark_mc_segmap_parloop_struct_338650
    futhark_mc_segmap_parloop_struct_338650;
    
    futhark_mc_segmap_parloop_struct_338650.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338650.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_338650.free_q_l_292680 = q_l_292680;
    futhark_mc_segmap_parloop_struct_338650.free_jump_t_292685 = jump_t_292685;
    futhark_mc_segmap_parloop_struct_338650.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_338650.free_l_n_m_292832 = l_n_m_292832;
    futhark_mc_segmap_parloop_struct_338650.free_i_292846 = i_292846;
    futhark_mc_segmap_parloop_struct_338650.free_bytes_313028 = bytes_313028;
    futhark_mc_segmap_parloop_struct_338650.free_mem_313081 = mem_313081.mem;
    futhark_mc_segmap_parloop_struct_338650.free_mem_313085 = mem_313085.mem;
    futhark_mc_segmap_parloop_struct_338650.free_ctx_param_ext_313174 =
        ctx_param_ext_313174;
    futhark_mc_segmap_parloop_struct_338650.free_ctx_param_ext_313175 =
        ctx_param_ext_313175;
    futhark_mc_segmap_parloop_struct_338650.free_ctx_param_ext_313177 =
        ctx_param_ext_313177;
    futhark_mc_segmap_parloop_struct_338650.free_mem_param_313179 =
        mem_param_313179.mem;
    futhark_mc_segmap_parloop_struct_338650.free_mem_315021 = mem_315021.mem;
    futhark_mc_segmap_parloop_struct_338650.free_mem_315514 = mem_315514.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338651_task;
    
    futhark_mc_segmap_parloop_338651_task.name =
        "futhark_mc_segmap_parloop_338651";
    futhark_mc_segmap_parloop_338651_task.fn = futhark_mc_segmap_parloop_338651;
    futhark_mc_segmap_parloop_338651_task.args =
        &futhark_mc_segmap_parloop_struct_338650;
    futhark_mc_segmap_parloop_338651_task.iterations = iterations;
    futhark_mc_segmap_parloop_338651_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338651_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338651_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338651_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338651_task);
    
    if (futhark_mc_segmap_parloop_338651_err != 0) {
        err = futhark_mc_segmap_parloop_338651_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338651_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338651_total_end -
                 futhark_mc_segmap_parloop_338651_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338651_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338651_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338651_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_nested_task_338649_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_nested_task_338649_end -
                 futhark_mc_segmap_nested_task_338649_start;
        
        ctx->futhark_mc_segmap_nested_task_338649_runs[tid]++;
        ctx->futhark_mc_segmap_nested_task_338649_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_nested_task_338649_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_task_338670 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_l_292680;
    int64_t free_jump_t_292685;
    int64_t free_partition_sizze_292766;
    int64_t free_l_n_m_292832;
    int64_t free_i_292846;
    int64_t free_bytes_313028;
    unsigned char *free_mem_313081;
    unsigned char *free_mem_313085;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315021;
    unsigned char *free_mem_315554;
    unsigned char *free_mem_315558;
};
struct futhark_mc_segmap_parloop_struct_338672 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_l_292680;
    int64_t free_jump_t_292685;
    int64_t free_partition_sizze_292766;
    int64_t free_l_n_m_292832;
    int64_t free_i_292846;
    int64_t free_bytes_313028;
    unsigned char *free_mem_313081;
    unsigned char *free_mem_313085;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315021;
    unsigned char *free_mem_315554;
    unsigned char *free_mem_315558;
};
static int futhark_mc_segmap_parloop_338673(void *args, int64_t start,
                                            int64_t end, int flat_tid_306753,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338672
    *futhark_mc_segmap_parloop_struct_338672 =
    (struct futhark_mc_segmap_parloop_struct_338672 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338672->ctx;
    uint64_t futhark_mc_segmap_parloop_338673_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338673_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_338672->free_n_292675;
    int64_t q_l_292680 =
            futhark_mc_segmap_parloop_struct_338672->free_q_l_292680;
    int64_t jump_t_292685 =
            futhark_mc_segmap_parloop_struct_338672->free_jump_t_292685;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_338672->free_partition_sizze_292766;
    int64_t l_n_m_292832 =
            futhark_mc_segmap_parloop_struct_338672->free_l_n_m_292832;
    int64_t i_292846 = futhark_mc_segmap_parloop_struct_338672->free_i_292846;
    int64_t bytes_313028 =
            futhark_mc_segmap_parloop_struct_338672->free_bytes_313028;
    struct memblock mem_313081 = {.desc ="mem_313081", .mem =
                                  futhark_mc_segmap_parloop_struct_338672->free_mem_313081,
                                  .size =0, .references =NULL};
    struct memblock mem_313085 = {.desc ="mem_313085", .mem =
                                  futhark_mc_segmap_parloop_struct_338672->free_mem_313085,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_segmap_parloop_struct_338672->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_segmap_parloop_struct_338672->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_segmap_parloop_struct_338672->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_segmap_parloop_struct_338672->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315021 = {.desc ="mem_315021", .mem =
                                  futhark_mc_segmap_parloop_struct_338672->free_mem_315021,
                                  .size =0, .references =NULL};
    struct memblock mem_315554 = {.desc ="mem_315554", .mem =
                                  futhark_mc_segmap_parloop_struct_338672->free_mem_315554,
                                  .size =0, .references =NULL};
    struct memblock mem_315558 = {.desc ="mem_315558", .mem =
                                  futhark_mc_segmap_parloop_struct_338672->free_mem_315558,
                                  .size =0, .references =NULL};
    size_t mem_315523_cached_sizze_338674 = 0;
    unsigned char *mem_315523 = NULL;
    size_t mem_315526_cached_sizze_338675 = 0;
    unsigned char *mem_315526 = NULL;
    int64_t iterations = end - start;
    int64_t iter_331340 = start;
    
    if (mem_315523_cached_sizze_338674 < (size_t) bytes_313028) {
        mem_315523 = realloc(mem_315523, bytes_313028);
        mem_315523_cached_sizze_338674 = bytes_313028;
    }
    if (mem_315526_cached_sizze_338675 < (size_t) bytes_313028) {
        mem_315526 = realloc(mem_315526, bytes_313028);
        mem_315526_cached_sizze_338675 = bytes_313028;
    }
    for (; iter_331340 < end; iter_331340++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_331427 = partition_sizze_292766;
        int64_t gtid_306754 = iter_331340;
        int64_t remnant_331428 = iter_331340 - gtid_306754;
        
        for (int64_t i_331341 = 0; i_331341 < l_n_m_292832; i_331341++) {
            int64_t x_331344;
            
            x_331344 = ((int64_t *) mem_313081.mem)[gtid_306754 * l_n_m_292832 +
                                                    i_331341];
            
            double x_331345;
            
            x_331345 = ((double *) mem_313085.mem)[gtid_306754 * l_n_m_292832 +
                                                   i_331341];
            
            int64_t min_arg_331346 = mul64(jump_t_292685, i_331341);
            int64_t min_res_331347 = smin64(i_292846, min_arg_331346);
            int64_t defunc_0_g_res_331348 = add64((int64_t) 1, min_res_331347);
            double defunc_2_reduce_res_331349;
            double defunc_2_reduce_res_331350;
            double defunc_2_reduce_res_331351;
            double redout_331353;
            double redout_331354;
            double redout_331355;
            
            redout_331353 = 0.0;
            redout_331354 = 0.0;
            redout_331355 = 0.0;
            for (int64_t i_331352 = 0; i_331352 < q_l_292680; i_331352++) {
                bool cond_331356 = sle64(n_292675, i_331352);
                int64_t defunc_0_f_res_331357;
                
                if (cond_331356) {
                    defunc_0_f_res_331357 = (int64_t) 0;
                } else {
                    int64_t i_331358 = add64(x_331344, i_331352);
                    int64_t defunc_1_add_res_331359 = add64((int64_t) 1,
                                                            i_331358);
                    
                    defunc_0_f_res_331357 = defunc_1_add_res_331359;
                }
                
                double defunc_0_f_res_331360;
                
                if (cond_331356) {
                    defunc_0_f_res_331360 = 0.0;
                } else {
                    int64_t i_331361 = add64(x_331344, i_331352);
                    double defunc_0_add_arg_331362;
                    
                    defunc_0_add_arg_331362 =
                        ((double *) mem_param_313179.mem)[ctx_param_ext_313174 +
                                                          (gtid_306754 *
                                                           ctx_param_ext_313175 +
                                                           i_331361 *
                                                           ctx_param_ext_313177)];
                    defunc_0_f_res_331360 = defunc_0_add_arg_331362;
                }
                
                int64_t binop_p_331363 = sub64(defunc_0_f_res_331357,
                                               defunc_0_g_res_331348);
                double defunc_0_f_res_331364 = sitofp_i64_f64(binop_p_331363);
                double abs_res_331365 = fabs(defunc_0_f_res_331364);
                double tmp1_331366 = abs_res_331365 / x_331345;
                double x_331367 = tmp1_331366 * tmp1_331366;
                double y_331368 = tmp1_331366 * x_331367;
                double tmp2_331369 = 1.0 - y_331368;
                double x_331370 = tmp2_331369 * tmp2_331369;
                double tmp3_331371 = tmp2_331369 * x_331370;
                double w_j_331372 = defunc_0_f_res_331360 * tmp3_331371;
                double xw_j_331373 = defunc_0_f_res_331364 * w_j_331372;
                double x2w_j_331374 = defunc_0_f_res_331364 * xw_j_331373;
                double defunc_1_op_res_331375 = w_j_331372 + redout_331353;
                double defunc_1_op_res_331376 = xw_j_331373 + redout_331354;
                double defunc_1_op_res_331377 = x2w_j_331374 + redout_331355;
                double redout_tmp_331431 = defunc_1_op_res_331375;
                double redout_tmp_331432 = defunc_1_op_res_331376;
                double redout_tmp_331433 = defunc_1_op_res_331377;
                
                redout_331353 = redout_tmp_331431;
                redout_331354 = redout_tmp_331432;
                redout_331355 = redout_tmp_331433;
            }
            defunc_2_reduce_res_331349 = redout_331353;
            defunc_2_reduce_res_331350 = redout_331354;
            defunc_2_reduce_res_331351 = redout_331355;
            
            double a_331378 = 2.220446049250313e-16 +
                   defunc_2_reduce_res_331349;
            double b_331379 = 2.220446049250313e-16 +
                   defunc_2_reduce_res_331350;
            double c_331380 = 2.220446049250313e-16 +
                   defunc_2_reduce_res_331351;
            double x_331381 = a_331378 * c_331380;
            double y_331382 = b_331379 * b_331379;
            double y_331383 = x_331381 - y_331382;
            double det1_331384 = 1.0 / y_331383;
            double a11_331385 = c_331380 * det1_331384;
            double x_331386 = 0.0 - b_331379;
            double b11_331387 = det1_331384 * x_331386;
            double c11_331388 = a_331378 * det1_331384;
            double defunc_2_reduce_res_331389;
            double defunc_2_reduce_res_331390;
            double redout_331392;
            double redout_331393;
            
            redout_331392 = 0.0;
            redout_331393 = 0.0;
            for (int64_t i_331391 = 0; i_331391 < q_l_292680; i_331391++) {
                bool cond_331394 = sle64(n_292675, i_331391);
                int64_t defunc_0_f_res_331395;
                
                if (cond_331394) {
                    defunc_0_f_res_331395 = (int64_t) 0;
                } else {
                    int64_t i_331396 = add64(x_331344, i_331391);
                    int64_t defunc_1_add_res_331397 = add64((int64_t) 1,
                                                            i_331396);
                    
                    defunc_0_f_res_331395 = defunc_1_add_res_331397;
                }
                
                double defunc_0_f_res_331398;
                
                if (cond_331394) {
                    defunc_0_f_res_331398 = 0.0;
                } else {
                    int64_t i_331399 = add64(x_331344, i_331391);
                    double defunc_0_add_arg_331400;
                    
                    defunc_0_add_arg_331400 =
                        ((double *) mem_param_313179.mem)[ctx_param_ext_313174 +
                                                          (gtid_306754 *
                                                           ctx_param_ext_313175 +
                                                           i_331399 *
                                                           ctx_param_ext_313177)];
                    defunc_0_f_res_331398 = defunc_0_add_arg_331400;
                }
                
                int64_t binop_p_331401 = sub64(defunc_0_f_res_331395,
                                               defunc_0_g_res_331348);
                double defunc_0_f_res_331402 = sitofp_i64_f64(binop_p_331401);
                double abs_res_331403 = fabs(defunc_0_f_res_331402);
                double tmp1_331404 = abs_res_331403 / x_331345;
                double x_331405 = tmp1_331404 * tmp1_331404;
                double y_331406 = tmp1_331404 * x_331405;
                double tmp2_331407 = 1.0 - y_331406;
                double x_331408 = tmp2_331407 * tmp2_331407;
                double tmp3_331409 = tmp2_331407 * x_331408;
                double tmp4_331410 = defunc_0_f_res_331398 * tmp3_331409;
                double defunc_1_f_res_331411 = defunc_0_f_res_331402 *
                       tmp4_331410;
                double defunc_0_f_res_331412;
                
                if (cond_331394) {
                    defunc_0_f_res_331412 = 0.0;
                } else {
                    int64_t i_331413 = add64(x_331344, i_331391);
                    double defunc_0_add_arg_331414;
                    
                    defunc_0_add_arg_331414 =
                        ((double *) mem_315021.mem)[gtid_306754 * n_292675 +
                                                    i_331413];
                    defunc_0_f_res_331412 = defunc_0_add_arg_331414;
                }
                
                double x_331415 = a11_331385 * tmp4_331410;
                double y_331416 = b11_331387 * defunc_1_f_res_331411;
                double x_331417 = x_331415 + y_331416;
                double defunc_9_fit_fun_res_331418 = defunc_0_f_res_331412 *
                       x_331417;
                double x_331419 = b11_331387 * tmp4_331410;
                double y_331420 = c11_331388 * defunc_1_f_res_331411;
                double x_331421 = x_331419 + y_331420;
                double defunc_9_slope_fun_res_331422 = defunc_0_f_res_331412 *
                       x_331421;
                double defunc_1_op_res_331423 = defunc_9_fit_fun_res_331418 +
                       redout_331392;
                double defunc_1_op_res_331424 = defunc_9_slope_fun_res_331422 +
                       redout_331393;
                double redout_tmp_331434 = defunc_1_op_res_331423;
                double redout_tmp_331435 = defunc_1_op_res_331424;
                
                redout_331392 = redout_tmp_331434;
                redout_331393 = redout_tmp_331435;
            }
            defunc_2_reduce_res_331389 = redout_331392;
            defunc_2_reduce_res_331390 = redout_331393;
            ((double *) mem_315523)[i_331341] = defunc_2_reduce_res_331389;
            ((double *) mem_315526)[i_331341] = defunc_2_reduce_res_331390;
        }
        if (l_n_m_292832 * (int64_t) 8 > 0)
            memmove(mem_315554.mem + gtid_306754 * l_n_m_292832 * (int64_t) 8,
                    mem_315523 + (int64_t) 0, l_n_m_292832 * (int64_t) 8);
        if (l_n_m_292832 * (int64_t) 8 > 0)
            memmove(mem_315558.mem + gtid_306754 * l_n_m_292832 * (int64_t) 8,
                    mem_315526 + (int64_t) 0, l_n_m_292832 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_315523);
    free(mem_315526);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338673_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338673_end -
                 futhark_mc_segmap_parloop_338673_start;
        
        ctx->futhark_mc_segmap_parloop_338673_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338673_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338673_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_338671(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_306753 = tid;
    int num_tasks_331339 = info.nsubtasks;
    struct futhark_mc_task_338670 *futhark_mc_task_338670 =
                                  (struct futhark_mc_task_338670 *) args;
    struct futhark_context *ctx = futhark_mc_task_338670->ctx;
    uint64_t futhark_mc_segmap_task_338671_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_338671_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338670->free_n_292675;
    int64_t q_l_292680 = futhark_mc_task_338670->free_q_l_292680;
    int64_t jump_t_292685 = futhark_mc_task_338670->free_jump_t_292685;
    int64_t partition_sizze_292766 =
            futhark_mc_task_338670->free_partition_sizze_292766;
    int64_t l_n_m_292832 = futhark_mc_task_338670->free_l_n_m_292832;
    int64_t i_292846 = futhark_mc_task_338670->free_i_292846;
    int64_t bytes_313028 = futhark_mc_task_338670->free_bytes_313028;
    struct memblock mem_313081 = {.desc ="mem_313081", .mem =
                                  futhark_mc_task_338670->free_mem_313081,
                                  .size =0, .references =NULL};
    struct memblock mem_313085 = {.desc ="mem_313085", .mem =
                                  futhark_mc_task_338670->free_mem_313085,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_task_338670->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_task_338670->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_task_338670->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_task_338670->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315021 = {.desc ="mem_315021", .mem =
                                  futhark_mc_task_338670->free_mem_315021,
                                  .size =0, .references =NULL};
    struct memblock mem_315554 = {.desc ="mem_315554", .mem =
                                  futhark_mc_task_338670->free_mem_315554,
                                  .size =0, .references =NULL};
    struct memblock mem_315558 = {.desc ="mem_315558", .mem =
                                  futhark_mc_task_338670->free_mem_315558,
                                  .size =0, .references =NULL};
    int64_t iter_331340;
    struct futhark_mc_segmap_parloop_struct_338672
    futhark_mc_segmap_parloop_struct_338672;
    
    futhark_mc_segmap_parloop_struct_338672.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338672.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_338672.free_q_l_292680 = q_l_292680;
    futhark_mc_segmap_parloop_struct_338672.free_jump_t_292685 = jump_t_292685;
    futhark_mc_segmap_parloop_struct_338672.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_338672.free_l_n_m_292832 = l_n_m_292832;
    futhark_mc_segmap_parloop_struct_338672.free_i_292846 = i_292846;
    futhark_mc_segmap_parloop_struct_338672.free_bytes_313028 = bytes_313028;
    futhark_mc_segmap_parloop_struct_338672.free_mem_313081 = mem_313081.mem;
    futhark_mc_segmap_parloop_struct_338672.free_mem_313085 = mem_313085.mem;
    futhark_mc_segmap_parloop_struct_338672.free_ctx_param_ext_313174 =
        ctx_param_ext_313174;
    futhark_mc_segmap_parloop_struct_338672.free_ctx_param_ext_313175 =
        ctx_param_ext_313175;
    futhark_mc_segmap_parloop_struct_338672.free_ctx_param_ext_313177 =
        ctx_param_ext_313177;
    futhark_mc_segmap_parloop_struct_338672.free_mem_param_313179 =
        mem_param_313179.mem;
    futhark_mc_segmap_parloop_struct_338672.free_mem_315021 = mem_315021.mem;
    futhark_mc_segmap_parloop_struct_338672.free_mem_315554 = mem_315554.mem;
    futhark_mc_segmap_parloop_struct_338672.free_mem_315558 = mem_315558.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338673_task;
    
    futhark_mc_segmap_parloop_338673_task.name =
        "futhark_mc_segmap_parloop_338673";
    futhark_mc_segmap_parloop_338673_task.fn = futhark_mc_segmap_parloop_338673;
    futhark_mc_segmap_parloop_338673_task.args =
        &futhark_mc_segmap_parloop_struct_338672;
    futhark_mc_segmap_parloop_338673_task.iterations = iterations;
    futhark_mc_segmap_parloop_338673_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338673_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338673_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338673_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338673_task);
    
    if (futhark_mc_segmap_parloop_338673_err != 0) {
        err = futhark_mc_segmap_parloop_338673_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338673_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338673_total_end -
                 futhark_mc_segmap_parloop_338673_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338673_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338673_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338673_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_338671_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_338671_end -
                 futhark_mc_segmap_task_338671_start;
        
        ctx->futhark_mc_segmap_task_338671_runs[tid]++;
        ctx->futhark_mc_segmap_task_338671_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_338671_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_segmap_parloop_struct_338677 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_l_292680;
    int64_t free_jump_t_292685;
    int64_t free_partition_sizze_292766;
    int64_t free_l_n_m_292832;
    int64_t free_i_292846;
    int64_t free_bytes_313028;
    unsigned char *free_mem_313081;
    unsigned char *free_mem_313085;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315021;
    unsigned char *free_mem_315554;
    unsigned char *free_mem_315558;
};
struct futhark_mc_task_338681 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_l_292680;
    int64_t free_jump_t_292685;
    int64_t free_l_n_m_292832;
    int64_t free_i_292846;
    int64_t free_gtid_306859;
    unsigned char *free_mem_313081;
    unsigned char *free_mem_313085;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315021;
    unsigned char *free_mem_315517;
    unsigned char *free_mem_315520;
};
struct futhark_mc_segmap_parloop_struct_338683 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_l_292680;
    int64_t free_jump_t_292685;
    int64_t free_l_n_m_292832;
    int64_t free_i_292846;
    int64_t free_gtid_306859;
    unsigned char *free_mem_313081;
    unsigned char *free_mem_313085;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315021;
    unsigned char *free_mem_315517;
    unsigned char *free_mem_315520;
};
static int futhark_mc_segmap_parloop_338684(void *args, int64_t start,
                                            int64_t end, int flat_tid_331527,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338683
    *futhark_mc_segmap_parloop_struct_338683 =
    (struct futhark_mc_segmap_parloop_struct_338683 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338683->ctx;
    uint64_t futhark_mc_segmap_parloop_338684_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338684_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_338683->free_n_292675;
    int64_t q_l_292680 =
            futhark_mc_segmap_parloop_struct_338683->free_q_l_292680;
    int64_t jump_t_292685 =
            futhark_mc_segmap_parloop_struct_338683->free_jump_t_292685;
    int64_t l_n_m_292832 =
            futhark_mc_segmap_parloop_struct_338683->free_l_n_m_292832;
    int64_t i_292846 = futhark_mc_segmap_parloop_struct_338683->free_i_292846;
    int64_t gtid_306859 =
            futhark_mc_segmap_parloop_struct_338683->free_gtid_306859;
    struct memblock mem_313081 = {.desc ="mem_313081", .mem =
                                  futhark_mc_segmap_parloop_struct_338683->free_mem_313081,
                                  .size =0, .references =NULL};
    struct memblock mem_313085 = {.desc ="mem_313085", .mem =
                                  futhark_mc_segmap_parloop_struct_338683->free_mem_313085,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_segmap_parloop_struct_338683->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_segmap_parloop_struct_338683->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_segmap_parloop_struct_338683->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_segmap_parloop_struct_338683->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315021 = {.desc ="mem_315021", .mem =
                                  futhark_mc_segmap_parloop_struct_338683->free_mem_315021,
                                  .size =0, .references =NULL};
    struct memblock mem_315517 = {.desc ="mem_315517", .mem =
                                  futhark_mc_segmap_parloop_struct_338683->free_mem_315517,
                                  .size =0, .references =NULL};
    struct memblock mem_315520 = {.desc ="mem_315520", .mem =
                                  futhark_mc_segmap_parloop_struct_338683->free_mem_315520,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_331613 = start;
    
    for (; iter_331613 < end; iter_331613++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_331674 = l_n_m_292832;
        int64_t gtid_331528 = iter_331613;
        int64_t remnant_331675 = iter_331613 - gtid_331528;
        int64_t x_331529;
        
        x_331529 = ((int64_t *) mem_313081.mem)[gtid_306859 * l_n_m_292832 +
                                                gtid_331528];
        
        double x_331530;
        
        x_331530 = ((double *) mem_313085.mem)[gtid_306859 * l_n_m_292832 +
                                               gtid_331528];
        
        int64_t min_arg_331531 = mul64(jump_t_292685, gtid_331528);
        int64_t min_res_331532 = smin64(i_292846, min_arg_331531);
        int64_t defunc_0_g_res_331533 = add64((int64_t) 1, min_res_331532);
        double defunc_2_reduce_res_331534;
        double defunc_2_reduce_res_331535;
        double defunc_2_reduce_res_331536;
        double redout_331615;
        double redout_331616;
        double redout_331617;
        
        redout_331615 = 0.0;
        redout_331616 = 0.0;
        redout_331617 = 0.0;
        for (int64_t i_331614 = 0; i_331614 < q_l_292680; i_331614++) {
            bool cond_331618 = sle64(n_292675, i_331614);
            int64_t defunc_0_f_res_331619;
            
            if (cond_331618) {
                defunc_0_f_res_331619 = (int64_t) 0;
            } else {
                int64_t i_331620 = add64(x_331529, i_331614);
                int64_t defunc_1_add_res_331621 = add64((int64_t) 1, i_331620);
                
                defunc_0_f_res_331619 = defunc_1_add_res_331621;
            }
            
            double defunc_0_f_res_331622;
            
            if (cond_331618) {
                defunc_0_f_res_331622 = 0.0;
            } else {
                int64_t i_331623 = add64(x_331529, i_331614);
                double defunc_0_add_arg_331624;
                
                defunc_0_add_arg_331624 =
                    ((double *) mem_param_313179.mem)[ctx_param_ext_313174 +
                                                      (gtid_306859 *
                                                       ctx_param_ext_313175 +
                                                       i_331623 *
                                                       ctx_param_ext_313177)];
                defunc_0_f_res_331622 = defunc_0_add_arg_331624;
            }
            
            int64_t binop_p_331625 = sub64(defunc_0_f_res_331619,
                                           defunc_0_g_res_331533);
            double defunc_0_f_res_331626 = sitofp_i64_f64(binop_p_331625);
            double abs_res_331627 = fabs(defunc_0_f_res_331626);
            double tmp1_331628 = abs_res_331627 / x_331530;
            double x_331629 = tmp1_331628 * tmp1_331628;
            double y_331630 = tmp1_331628 * x_331629;
            double tmp2_331631 = 1.0 - y_331630;
            double x_331632 = tmp2_331631 * tmp2_331631;
            double tmp3_331633 = tmp2_331631 * x_331632;
            double w_j_331634 = defunc_0_f_res_331622 * tmp3_331633;
            double xw_j_331635 = defunc_0_f_res_331626 * w_j_331634;
            double x2w_j_331636 = defunc_0_f_res_331626 * xw_j_331635;
            double defunc_1_op_res_331637 = w_j_331634 + redout_331615;
            double defunc_1_op_res_331638 = xw_j_331635 + redout_331616;
            double defunc_1_op_res_331639 = x2w_j_331636 + redout_331617;
            double redout_tmp_331676 = defunc_1_op_res_331637;
            double redout_tmp_331677 = defunc_1_op_res_331638;
            double redout_tmp_331678 = defunc_1_op_res_331639;
            
            redout_331615 = redout_tmp_331676;
            redout_331616 = redout_tmp_331677;
            redout_331617 = redout_tmp_331678;
        }
        defunc_2_reduce_res_331534 = redout_331615;
        defunc_2_reduce_res_331535 = redout_331616;
        defunc_2_reduce_res_331536 = redout_331617;
        
        double a_331563 = 2.220446049250313e-16 + defunc_2_reduce_res_331534;
        double b_331564 = 2.220446049250313e-16 + defunc_2_reduce_res_331535;
        double c_331565 = 2.220446049250313e-16 + defunc_2_reduce_res_331536;
        double x_331566 = a_331563 * c_331565;
        double y_331567 = b_331564 * b_331564;
        double y_331568 = x_331566 - y_331567;
        double det1_331569 = 1.0 / y_331568;
        double a11_331570 = c_331565 * det1_331569;
        double x_331571 = 0.0 - b_331564;
        double b11_331572 = det1_331569 * x_331571;
        double c11_331573 = a_331563 * det1_331569;
        double defunc_2_reduce_res_331574;
        double defunc_2_reduce_res_331575;
        double redout_331641;
        double redout_331642;
        
        redout_331641 = 0.0;
        redout_331642 = 0.0;
        for (int64_t i_331640 = 0; i_331640 < q_l_292680; i_331640++) {
            bool cond_331643 = sle64(n_292675, i_331640);
            int64_t defunc_0_f_res_331644;
            
            if (cond_331643) {
                defunc_0_f_res_331644 = (int64_t) 0;
            } else {
                int64_t i_331645 = add64(x_331529, i_331640);
                int64_t defunc_1_add_res_331646 = add64((int64_t) 1, i_331645);
                
                defunc_0_f_res_331644 = defunc_1_add_res_331646;
            }
            
            double defunc_0_f_res_331647;
            
            if (cond_331643) {
                defunc_0_f_res_331647 = 0.0;
            } else {
                int64_t i_331648 = add64(x_331529, i_331640);
                double defunc_0_add_arg_331649;
                
                defunc_0_add_arg_331649 =
                    ((double *) mem_param_313179.mem)[ctx_param_ext_313174 +
                                                      (gtid_306859 *
                                                       ctx_param_ext_313175 +
                                                       i_331648 *
                                                       ctx_param_ext_313177)];
                defunc_0_f_res_331647 = defunc_0_add_arg_331649;
            }
            
            int64_t binop_p_331650 = sub64(defunc_0_f_res_331644,
                                           defunc_0_g_res_331533);
            double defunc_0_f_res_331651 = sitofp_i64_f64(binop_p_331650);
            double abs_res_331652 = fabs(defunc_0_f_res_331651);
            double tmp1_331653 = abs_res_331652 / x_331530;
            double x_331654 = tmp1_331653 * tmp1_331653;
            double y_331655 = tmp1_331653 * x_331654;
            double tmp2_331656 = 1.0 - y_331655;
            double x_331657 = tmp2_331656 * tmp2_331656;
            double tmp3_331658 = tmp2_331656 * x_331657;
            double tmp4_331659 = defunc_0_f_res_331647 * tmp3_331658;
            double defunc_1_f_res_331660 = defunc_0_f_res_331651 * tmp4_331659;
            double defunc_0_f_res_331661;
            
            if (cond_331643) {
                defunc_0_f_res_331661 = 0.0;
            } else {
                int64_t i_331662 = add64(x_331529, i_331640);
                double defunc_0_add_arg_331663;
                
                defunc_0_add_arg_331663 =
                    ((double *) mem_315021.mem)[gtid_306859 * n_292675 +
                                                i_331662];
                defunc_0_f_res_331661 = defunc_0_add_arg_331663;
            }
            
            double x_331664 = a11_331570 * tmp4_331659;
            double y_331665 = b11_331572 * defunc_1_f_res_331660;
            double x_331666 = x_331664 + y_331665;
            double defunc_9_fit_fun_res_331667 = defunc_0_f_res_331661 *
                   x_331666;
            double x_331668 = b11_331572 * tmp4_331659;
            double y_331669 = c11_331573 * defunc_1_f_res_331660;
            double x_331670 = x_331668 + y_331669;
            double defunc_9_slope_fun_res_331671 = defunc_0_f_res_331661 *
                   x_331670;
            double defunc_1_op_res_331672 = defunc_9_fit_fun_res_331667 +
                   redout_331641;
            double defunc_1_op_res_331673 = defunc_9_slope_fun_res_331671 +
                   redout_331642;
            double redout_tmp_331679 = defunc_1_op_res_331672;
            double redout_tmp_331680 = defunc_1_op_res_331673;
            
            redout_331641 = redout_tmp_331679;
            redout_331642 = redout_tmp_331680;
        }
        defunc_2_reduce_res_331574 = redout_331641;
        defunc_2_reduce_res_331575 = redout_331642;
        ((double *) mem_315517.mem)[gtid_331528] = defunc_2_reduce_res_331574;
        ((double *) mem_315520.mem)[gtid_331528] = defunc_2_reduce_res_331575;
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338684_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338684_end -
                 futhark_mc_segmap_parloop_338684_start;
        
        ctx->futhark_mc_segmap_parloop_338684_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338684_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338684_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_338682(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_331527 = tid;
    int num_tasks_331612 = info.nsubtasks;
    struct futhark_mc_task_338681 *futhark_mc_task_338681 =
                                  (struct futhark_mc_task_338681 *) args;
    struct futhark_context *ctx = futhark_mc_task_338681->ctx;
    uint64_t futhark_mc_segmap_task_338682_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_338682_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338681->free_n_292675;
    int64_t q_l_292680 = futhark_mc_task_338681->free_q_l_292680;
    int64_t jump_t_292685 = futhark_mc_task_338681->free_jump_t_292685;
    int64_t l_n_m_292832 = futhark_mc_task_338681->free_l_n_m_292832;
    int64_t i_292846 = futhark_mc_task_338681->free_i_292846;
    int64_t gtid_306859 = futhark_mc_task_338681->free_gtid_306859;
    struct memblock mem_313081 = {.desc ="mem_313081", .mem =
                                  futhark_mc_task_338681->free_mem_313081,
                                  .size =0, .references =NULL};
    struct memblock mem_313085 = {.desc ="mem_313085", .mem =
                                  futhark_mc_task_338681->free_mem_313085,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_task_338681->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_task_338681->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_task_338681->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_task_338681->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315021 = {.desc ="mem_315021", .mem =
                                  futhark_mc_task_338681->free_mem_315021,
                                  .size =0, .references =NULL};
    struct memblock mem_315517 = {.desc ="mem_315517", .mem =
                                  futhark_mc_task_338681->free_mem_315517,
                                  .size =0, .references =NULL};
    struct memblock mem_315520 = {.desc ="mem_315520", .mem =
                                  futhark_mc_task_338681->free_mem_315520,
                                  .size =0, .references =NULL};
    int64_t iter_331613;
    struct futhark_mc_segmap_parloop_struct_338683
    futhark_mc_segmap_parloop_struct_338683;
    
    futhark_mc_segmap_parloop_struct_338683.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338683.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_338683.free_q_l_292680 = q_l_292680;
    futhark_mc_segmap_parloop_struct_338683.free_jump_t_292685 = jump_t_292685;
    futhark_mc_segmap_parloop_struct_338683.free_l_n_m_292832 = l_n_m_292832;
    futhark_mc_segmap_parloop_struct_338683.free_i_292846 = i_292846;
    futhark_mc_segmap_parloop_struct_338683.free_gtid_306859 = gtid_306859;
    futhark_mc_segmap_parloop_struct_338683.free_mem_313081 = mem_313081.mem;
    futhark_mc_segmap_parloop_struct_338683.free_mem_313085 = mem_313085.mem;
    futhark_mc_segmap_parloop_struct_338683.free_ctx_param_ext_313174 =
        ctx_param_ext_313174;
    futhark_mc_segmap_parloop_struct_338683.free_ctx_param_ext_313175 =
        ctx_param_ext_313175;
    futhark_mc_segmap_parloop_struct_338683.free_ctx_param_ext_313177 =
        ctx_param_ext_313177;
    futhark_mc_segmap_parloop_struct_338683.free_mem_param_313179 =
        mem_param_313179.mem;
    futhark_mc_segmap_parloop_struct_338683.free_mem_315021 = mem_315021.mem;
    futhark_mc_segmap_parloop_struct_338683.free_mem_315517 = mem_315517.mem;
    futhark_mc_segmap_parloop_struct_338683.free_mem_315520 = mem_315520.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338684_task;
    
    futhark_mc_segmap_parloop_338684_task.name =
        "futhark_mc_segmap_parloop_338684";
    futhark_mc_segmap_parloop_338684_task.fn = futhark_mc_segmap_parloop_338684;
    futhark_mc_segmap_parloop_338684_task.args =
        &futhark_mc_segmap_parloop_struct_338683;
    futhark_mc_segmap_parloop_338684_task.iterations = iterations;
    futhark_mc_segmap_parloop_338684_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338684_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338684_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338684_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338684_task);
    
    if (futhark_mc_segmap_parloop_338684_err != 0) {
        err = futhark_mc_segmap_parloop_338684_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338684_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338684_total_end -
                 futhark_mc_segmap_parloop_338684_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338684_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338684_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338684_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_338682_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_338682_end -
                 futhark_mc_segmap_task_338682_start;
        
        ctx->futhark_mc_segmap_task_338682_runs[tid]++;
        ctx->futhark_mc_segmap_task_338682_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_338682_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_segmap_parloop_struct_338686 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_l_292680;
    int64_t free_jump_t_292685;
    int64_t free_l_n_m_292832;
    int64_t free_i_292846;
    int64_t free_gtid_306859;
    unsigned char *free_mem_313081;
    unsigned char *free_mem_313085;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315021;
    unsigned char *free_mem_315517;
    unsigned char *free_mem_315520;
};
struct futhark_mc_task_338688 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_306859;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    int64_t free_x_331439;
    double free_x_331440;
    int64_t free_defunc_0_g_res_331443;
    double *retval_defunc_2_reduce_res_331444;
    double *retval_defunc_2_reduce_res_331445;
    double *retval_defunc_2_reduce_res_331446;
};
struct futhark_mc_segred_stage_1_parloop_struct_338693 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_306859;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    int64_t free_x_331439;
    double free_x_331440;
    int64_t free_defunc_0_g_res_331443;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_331752;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_331754;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_331756;
};
static int futhark_mc_segred_stage_1_parloop_338694(void *args, int64_t start,
                                                    int64_t end,
                                                    int flat_tid_331682,
                                                    int tid)
{
    int err = 0;
    struct futhark_mc_segred_stage_1_parloop_struct_338693
    *futhark_mc_segred_stage_1_parloop_struct_338693 =
    (struct futhark_mc_segred_stage_1_parloop_struct_338693 *) args;
    struct futhark_context *ctx =
                           futhark_mc_segred_stage_1_parloop_struct_338693->ctx;
    uint64_t futhark_mc_segred_stage_1_parloop_338694_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_338694_start = get_wall_time();
    
    int64_t n_292675 =
            futhark_mc_segred_stage_1_parloop_struct_338693->free_n_292675;
    int64_t gtid_306859 =
            futhark_mc_segred_stage_1_parloop_struct_338693->free_gtid_306859;
    int64_t ctx_param_ext_313174 =
            futhark_mc_segred_stage_1_parloop_struct_338693->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_segred_stage_1_parloop_struct_338693->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_segred_stage_1_parloop_struct_338693->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_segred_stage_1_parloop_struct_338693->free_mem_param_313179,
                                        .size =0, .references =NULL};
    int64_t x_331439 =
            futhark_mc_segred_stage_1_parloop_struct_338693->free_x_331439;
    double x_331440 =
           futhark_mc_segred_stage_1_parloop_struct_338693->free_x_331440;
    int64_t defunc_0_g_res_331443 =
            futhark_mc_segred_stage_1_parloop_struct_338693->free_defunc_0_g_res_331443;
    struct memblock reduce_stage_1_tid_res_arr_mem_331752 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_331752",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338693->free_reduce_stage_1_tid_res_arr_mem_331752,
                                                             .size =0,
                                                             .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_331754 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_331754",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338693->free_reduce_stage_1_tid_res_arr_mem_331754,
                                                             .size =0,
                                                             .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_331756 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_331756",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338693->free_reduce_stage_1_tid_res_arr_mem_331756,
                                                             .size =0,
                                                             .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_331758 = start;
    double x_331684;
    double x_331685;
    double x_331687;
    double x_331688;
    double x_331690;
    double x_331691;
    double local_acc_331759 = 0.0;
    double local_acc_331760 = 0.0;
    double local_acc_331761 = 0.0;
    
    for (; iter_331758 < end; iter_331758++) {
        int64_t gtid_331683 = iter_331758;
        bool cond_331693 = sle64(n_292675, gtid_331683);
        int64_t defunc_0_f_res_331694;
        
        if (cond_331693) {
            defunc_0_f_res_331694 = (int64_t) 0;
        } else {
            int64_t i_331695 = add64(x_331439, gtid_331683);
            int64_t defunc_1_add_res_331696 = add64((int64_t) 1, i_331695);
            
            defunc_0_f_res_331694 = defunc_1_add_res_331696;
        }
        
        double defunc_0_f_res_331697;
        
        if (cond_331693) {
            defunc_0_f_res_331697 = 0.0;
        } else {
            int64_t i_331698 = add64(x_331439, gtid_331683);
            double defunc_0_add_arg_331699;
            
            defunc_0_add_arg_331699 =
                ((double *) mem_param_313179.mem)[ctx_param_ext_313174 +
                                                  (gtid_306859 *
                                                   ctx_param_ext_313175 +
                                                   i_331698 *
                                                   ctx_param_ext_313177)];
            defunc_0_f_res_331697 = defunc_0_add_arg_331699;
        }
        
        int64_t binop_p_331700 = sub64(defunc_0_f_res_331694,
                                       defunc_0_g_res_331443);
        double defunc_0_f_res_331701 = sitofp_i64_f64(binop_p_331700);
        double abs_res_331702 = fabs(defunc_0_f_res_331701);
        double tmp1_331703 = abs_res_331702 / x_331440;
        double x_331704 = tmp1_331703 * tmp1_331703;
        double y_331705 = tmp1_331703 * x_331704;
        double tmp2_331706 = 1.0 - y_331705;
        double x_331707 = tmp2_331706 * tmp2_331706;
        double tmp3_331708 = tmp2_331706 * x_331707;
        double w_j_331709 = defunc_0_f_res_331697 * tmp3_331708;
        double xw_j_331710 = defunc_0_f_res_331701 * w_j_331709;
        double x2w_j_331711 = defunc_0_f_res_331701 * xw_j_331710;
        
        // save map-out results
        { }
        // Load accum params
        {
            x_331684 = local_acc_331759;
        }
        // Load next params
        {
            x_331685 = w_j_331709;
        }
        // Red body
        {
            double defunc_1_op_res_331686 = x_331684 + x_331685;
            
            local_acc_331759 = defunc_1_op_res_331686;
        }
        // Load accum params
        {
            x_331687 = local_acc_331760;
        }
        // Load next params
        {
            x_331688 = xw_j_331710;
        }
        // Red body
        {
            double defunc_1_op_res_331689 = x_331687 + x_331688;
            
            local_acc_331760 = defunc_1_op_res_331689;
        }
        // Load accum params
        {
            x_331690 = local_acc_331761;
        }
        // Load next params
        {
            x_331691 = x2w_j_331711;
        }
        // Red body
        {
            double defunc_1_op_res_331692 = x_331690 + x_331691;
            
            local_acc_331761 = defunc_1_op_res_331692;
        }
    }
    ((double *) reduce_stage_1_tid_res_arr_mem_331752.mem)[flat_tid_331682] =
        local_acc_331759;
    ((double *) reduce_stage_1_tid_res_arr_mem_331754.mem)[flat_tid_331682] =
        local_acc_331760;
    ((double *) reduce_stage_1_tid_res_arr_mem_331756.mem)[flat_tid_331682] =
        local_acc_331761;
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_338694_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_338694_end -
                 futhark_mc_segred_stage_1_parloop_338694_start;
        
        ctx->futhark_mc_segred_stage_1_parloop_338694_runs[tid]++;
        ctx->futhark_mc_segred_stage_1_parloop_338694_total_runtime[tid] +=
            elapsed;
        ctx->futhark_mc_segred_stage_1_parloop_338694_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segred_task_338689(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_331682 = tid;
    int num_tasks_331751 = info.nsubtasks;
    struct futhark_mc_task_338688 *futhark_mc_task_338688 =
                                  (struct futhark_mc_task_338688 *) args;
    struct futhark_context *ctx = futhark_mc_task_338688->ctx;
    uint64_t futhark_mc_segred_task_338689_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_task_338689_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338688->free_n_292675;
    int64_t gtid_306859 = futhark_mc_task_338688->free_gtid_306859;
    int64_t ctx_param_ext_313174 =
            futhark_mc_task_338688->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_task_338688->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_task_338688->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_task_338688->free_mem_param_313179,
                                        .size =0, .references =NULL};
    int64_t x_331439 = futhark_mc_task_338688->free_x_331439;
    double x_331440 = futhark_mc_task_338688->free_x_331440;
    int64_t defunc_0_g_res_331443 =
            futhark_mc_task_338688->free_defunc_0_g_res_331443;
    double defunc_2_reduce_res_331444 =
           *futhark_mc_task_338688->retval_defunc_2_reduce_res_331444;
    double defunc_2_reduce_res_331445 =
           *futhark_mc_task_338688->retval_defunc_2_reduce_res_331445;
    double defunc_2_reduce_res_331446 =
           *futhark_mc_task_338688->retval_defunc_2_reduce_res_331446;
    size_t reduce_stage_1_tid_res_arr_mem_331752_cached_sizze_338690 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_331752 = NULL;
    size_t reduce_stage_1_tid_res_arr_mem_331754_cached_sizze_338691 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_331754 = NULL;
    size_t reduce_stage_1_tid_res_arr_mem_331756_cached_sizze_338692 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_331756 = NULL;
    
    if (reduce_stage_1_tid_res_arr_mem_331752_cached_sizze_338690 <
        (size_t) ((int64_t) 8 * num_tasks_331751)) {
        reduce_stage_1_tid_res_arr_mem_331752 =
            realloc(reduce_stage_1_tid_res_arr_mem_331752, (int64_t) 8 *
                    num_tasks_331751);
        reduce_stage_1_tid_res_arr_mem_331752_cached_sizze_338690 =
            (int64_t) 8 * num_tasks_331751;
    }
    if (reduce_stage_1_tid_res_arr_mem_331754_cached_sizze_338691 <
        (size_t) ((int64_t) 8 * num_tasks_331751)) {
        reduce_stage_1_tid_res_arr_mem_331754 =
            realloc(reduce_stage_1_tid_res_arr_mem_331754, (int64_t) 8 *
                    num_tasks_331751);
        reduce_stage_1_tid_res_arr_mem_331754_cached_sizze_338691 =
            (int64_t) 8 * num_tasks_331751;
    }
    if (reduce_stage_1_tid_res_arr_mem_331756_cached_sizze_338692 <
        (size_t) ((int64_t) 8 * num_tasks_331751)) {
        reduce_stage_1_tid_res_arr_mem_331756 =
            realloc(reduce_stage_1_tid_res_arr_mem_331756, (int64_t) 8 *
                    num_tasks_331751);
        reduce_stage_1_tid_res_arr_mem_331756_cached_sizze_338692 =
            (int64_t) 8 * num_tasks_331751;
    }
    
    int64_t iter_331758;
    struct futhark_mc_segred_stage_1_parloop_struct_338693
    futhark_mc_segred_stage_1_parloop_struct_338693;
    
    futhark_mc_segred_stage_1_parloop_struct_338693.ctx = ctx;
    futhark_mc_segred_stage_1_parloop_struct_338693.free_n_292675 = n_292675;
    futhark_mc_segred_stage_1_parloop_struct_338693.free_gtid_306859 =
        gtid_306859;
    futhark_mc_segred_stage_1_parloop_struct_338693.free_ctx_param_ext_313174 =
        ctx_param_ext_313174;
    futhark_mc_segred_stage_1_parloop_struct_338693.free_ctx_param_ext_313175 =
        ctx_param_ext_313175;
    futhark_mc_segred_stage_1_parloop_struct_338693.free_ctx_param_ext_313177 =
        ctx_param_ext_313177;
    futhark_mc_segred_stage_1_parloop_struct_338693.free_mem_param_313179 =
        mem_param_313179.mem;
    futhark_mc_segred_stage_1_parloop_struct_338693.free_x_331439 = x_331439;
    futhark_mc_segred_stage_1_parloop_struct_338693.free_x_331440 = x_331440;
    futhark_mc_segred_stage_1_parloop_struct_338693.free_defunc_0_g_res_331443 =
        defunc_0_g_res_331443;
    futhark_mc_segred_stage_1_parloop_struct_338693.free_reduce_stage_1_tid_res_arr_mem_331752 =
        reduce_stage_1_tid_res_arr_mem_331752;
    futhark_mc_segred_stage_1_parloop_struct_338693.free_reduce_stage_1_tid_res_arr_mem_331754 =
        reduce_stage_1_tid_res_arr_mem_331754;
    futhark_mc_segred_stage_1_parloop_struct_338693.free_reduce_stage_1_tid_res_arr_mem_331756 =
        reduce_stage_1_tid_res_arr_mem_331756;
    
    struct scheduler_parloop futhark_mc_segred_stage_1_parloop_338694_task;
    
    futhark_mc_segred_stage_1_parloop_338694_task.name =
        "futhark_mc_segred_stage_1_parloop_338694";
    futhark_mc_segred_stage_1_parloop_338694_task.fn =
        futhark_mc_segred_stage_1_parloop_338694;
    futhark_mc_segred_stage_1_parloop_338694_task.args =
        &futhark_mc_segred_stage_1_parloop_struct_338693;
    futhark_mc_segred_stage_1_parloop_338694_task.iterations = iterations;
    futhark_mc_segred_stage_1_parloop_338694_task.info = info;
    
    uint64_t futhark_mc_segred_stage_1_parloop_338694_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_338694_total_start = get_wall_time();
    
    int futhark_mc_segred_stage_1_parloop_338694_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segred_stage_1_parloop_338694_task);
    
    if (futhark_mc_segred_stage_1_parloop_338694_err != 0) {
        err = futhark_mc_segred_stage_1_parloop_338694_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_338694_total_end =
                 get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_338694_total_end -
                 futhark_mc_segred_stage_1_parloop_338694_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338694_total_runs,
                           1, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338694_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338694_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    // neutral-initialise the output
    {
        defunc_2_reduce_res_331444 = 0.0;
        defunc_2_reduce_res_331445 = 0.0;
        defunc_2_reduce_res_331446 = 0.0;
    }
    
    double x_331762;
    double x_331763;
    double x_331765;
    double x_331766;
    double x_331768;
    double x_331769;
    
    for (int32_t i_331771 = 0; i_331771 < num_tasks_331751; i_331771++) {
        flat_tid_331682 = i_331771;
        // Apply main thread reduction
        {
            // load acc params
            {
                x_331762 = defunc_2_reduce_res_331444;
            }
            // load next params
            {
                x_331763 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_331752)[flat_tid_331682];
            }
            // red body
            {
                double defunc_1_op_res_331764 = x_331762 + x_331763;
                
                defunc_2_reduce_res_331444 = defunc_1_op_res_331764;
            }
            // load acc params
            {
                x_331765 = defunc_2_reduce_res_331445;
            }
            // load next params
            {
                x_331766 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_331754)[flat_tid_331682];
            }
            // red body
            {
                double defunc_1_op_res_331767 = x_331765 + x_331766;
                
                defunc_2_reduce_res_331445 = defunc_1_op_res_331767;
            }
            // load acc params
            {
                x_331768 = defunc_2_reduce_res_331446;
            }
            // load next params
            {
                x_331769 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_331756)[flat_tid_331682];
            }
            // red body
            {
                double defunc_1_op_res_331770 = x_331768 + x_331769;
                
                defunc_2_reduce_res_331446 = defunc_1_op_res_331770;
            }
        }
    }
    
  cleanup:
    {
        free(reduce_stage_1_tid_res_arr_mem_331752);
        free(reduce_stage_1_tid_res_arr_mem_331754);
        free(reduce_stage_1_tid_res_arr_mem_331756);
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_task_338689_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_task_338689_end -
                 futhark_mc_segred_task_338689_start;
        
        ctx->futhark_mc_segred_task_338689_runs[tid]++;
        ctx->futhark_mc_segred_task_338689_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segred_task_338689_iter[tid] += iterations;
    }
    if (err == 0) {
        *futhark_mc_task_338688->retval_defunc_2_reduce_res_331444 =
            defunc_2_reduce_res_331444;
        *futhark_mc_task_338688->retval_defunc_2_reduce_res_331445 =
            defunc_2_reduce_res_331445;
        *futhark_mc_task_338688->retval_defunc_2_reduce_res_331446 =
            defunc_2_reduce_res_331446;
    }
    return err;
}
struct futhark_mc_task_338695 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_306859;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315021;
    int64_t free_x_331439;
    double free_x_331440;
    int64_t free_defunc_0_g_res_331443;
    double free_a11_331484;
    double free_b11_331486;
    double free_c11_331487;
    double *retval_defunc_2_reduce_res_331488;
    double *retval_defunc_2_reduce_res_331489;
};
struct futhark_mc_segred_stage_1_parloop_struct_338699 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_306859;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315021;
    int64_t free_x_331439;
    double free_x_331440;
    int64_t free_defunc_0_g_res_331443;
    double free_a11_331484;
    double free_b11_331486;
    double free_c11_331487;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_331773;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_331775;
};
static int futhark_mc_segred_stage_1_parloop_338700(void *args, int64_t start,
                                                    int64_t end,
                                                    int flat_tid_331712,
                                                    int tid)
{
    int err = 0;
    struct futhark_mc_segred_stage_1_parloop_struct_338699
    *futhark_mc_segred_stage_1_parloop_struct_338699 =
    (struct futhark_mc_segred_stage_1_parloop_struct_338699 *) args;
    struct futhark_context *ctx =
                           futhark_mc_segred_stage_1_parloop_struct_338699->ctx;
    uint64_t futhark_mc_segred_stage_1_parloop_338700_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_338700_start = get_wall_time();
    
    int64_t n_292675 =
            futhark_mc_segred_stage_1_parloop_struct_338699->free_n_292675;
    int64_t gtid_306859 =
            futhark_mc_segred_stage_1_parloop_struct_338699->free_gtid_306859;
    int64_t ctx_param_ext_313174 =
            futhark_mc_segred_stage_1_parloop_struct_338699->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_segred_stage_1_parloop_struct_338699->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_segred_stage_1_parloop_struct_338699->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_segred_stage_1_parloop_struct_338699->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315021 = {.desc ="mem_315021", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_338699->free_mem_315021,
                                  .size =0, .references =NULL};
    int64_t x_331439 =
            futhark_mc_segred_stage_1_parloop_struct_338699->free_x_331439;
    double x_331440 =
           futhark_mc_segred_stage_1_parloop_struct_338699->free_x_331440;
    int64_t defunc_0_g_res_331443 =
            futhark_mc_segred_stage_1_parloop_struct_338699->free_defunc_0_g_res_331443;
    double a11_331484 =
           futhark_mc_segred_stage_1_parloop_struct_338699->free_a11_331484;
    double b11_331486 =
           futhark_mc_segred_stage_1_parloop_struct_338699->free_b11_331486;
    double c11_331487 =
           futhark_mc_segred_stage_1_parloop_struct_338699->free_c11_331487;
    struct memblock reduce_stage_1_tid_res_arr_mem_331773 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_331773",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338699->free_reduce_stage_1_tid_res_arr_mem_331773,
                                                             .size =0,
                                                             .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_331775 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_331775",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338699->free_reduce_stage_1_tid_res_arr_mem_331775,
                                                             .size =0,
                                                             .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_331777 = start;
    double x_331714;
    double x_331715;
    double x_331717;
    double x_331718;
    double local_acc_331778 = 0.0;
    double local_acc_331779 = 0.0;
    
    for (; iter_331777 < end; iter_331777++) {
        int64_t gtid_331713 = iter_331777;
        bool cond_331720 = sle64(n_292675, gtid_331713);
        int64_t defunc_0_f_res_331721;
        
        if (cond_331720) {
            defunc_0_f_res_331721 = (int64_t) 0;
        } else {
            int64_t i_331722 = add64(x_331439, gtid_331713);
            int64_t defunc_1_add_res_331723 = add64((int64_t) 1, i_331722);
            
            defunc_0_f_res_331721 = defunc_1_add_res_331723;
        }
        
        double defunc_0_f_res_331724;
        
        if (cond_331720) {
            defunc_0_f_res_331724 = 0.0;
        } else {
            int64_t i_331725 = add64(x_331439, gtid_331713);
            double defunc_0_add_arg_331726;
            
            defunc_0_add_arg_331726 =
                ((double *) mem_param_313179.mem)[ctx_param_ext_313174 +
                                                  (gtid_306859 *
                                                   ctx_param_ext_313175 +
                                                   i_331725 *
                                                   ctx_param_ext_313177)];
            defunc_0_f_res_331724 = defunc_0_add_arg_331726;
        }
        
        int64_t binop_p_331727 = sub64(defunc_0_f_res_331721,
                                       defunc_0_g_res_331443);
        double defunc_0_f_res_331728 = sitofp_i64_f64(binop_p_331727);
        double abs_res_331729 = fabs(defunc_0_f_res_331728);
        double tmp1_331730 = abs_res_331729 / x_331440;
        double x_331731 = tmp1_331730 * tmp1_331730;
        double y_331732 = tmp1_331730 * x_331731;
        double tmp2_331733 = 1.0 - y_331732;
        double x_331734 = tmp2_331733 * tmp2_331733;
        double tmp3_331735 = tmp2_331733 * x_331734;
        double tmp4_331736 = defunc_0_f_res_331724 * tmp3_331735;
        double defunc_1_f_res_331737 = defunc_0_f_res_331728 * tmp4_331736;
        double defunc_0_f_res_331738;
        
        if (cond_331720) {
            defunc_0_f_res_331738 = 0.0;
        } else {
            int64_t i_331739 = add64(x_331439, gtid_331713);
            double defunc_0_add_arg_331740;
            
            defunc_0_add_arg_331740 = ((double *) mem_315021.mem)[gtid_306859 *
                                                                  n_292675 +
                                                                  i_331739];
            defunc_0_f_res_331738 = defunc_0_add_arg_331740;
        }
        
        double x_331741 = a11_331484 * tmp4_331736;
        double y_331742 = b11_331486 * defunc_1_f_res_331737;
        double x_331743 = x_331741 + y_331742;
        double defunc_9_fit_fun_res_331744 = defunc_0_f_res_331738 * x_331743;
        double x_331745 = b11_331486 * tmp4_331736;
        double y_331746 = c11_331487 * defunc_1_f_res_331737;
        double x_331747 = x_331745 + y_331746;
        double defunc_9_slope_fun_res_331748 = defunc_0_f_res_331738 * x_331747;
        
        // save map-out results
        { }
        // Load accum params
        {
            x_331714 = local_acc_331778;
        }
        // Load next params
        {
            x_331715 = defunc_9_fit_fun_res_331744;
        }
        // Red body
        {
            double defunc_1_op_res_331716 = x_331714 + x_331715;
            
            local_acc_331778 = defunc_1_op_res_331716;
        }
        // Load accum params
        {
            x_331717 = local_acc_331779;
        }
        // Load next params
        {
            x_331718 = defunc_9_slope_fun_res_331748;
        }
        // Red body
        {
            double defunc_1_op_res_331719 = x_331717 + x_331718;
            
            local_acc_331779 = defunc_1_op_res_331719;
        }
    }
    ((double *) reduce_stage_1_tid_res_arr_mem_331773.mem)[flat_tid_331712] =
        local_acc_331778;
    ((double *) reduce_stage_1_tid_res_arr_mem_331775.mem)[flat_tid_331712] =
        local_acc_331779;
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_338700_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_338700_end -
                 futhark_mc_segred_stage_1_parloop_338700_start;
        
        ctx->futhark_mc_segred_stage_1_parloop_338700_runs[tid]++;
        ctx->futhark_mc_segred_stage_1_parloop_338700_total_runtime[tid] +=
            elapsed;
        ctx->futhark_mc_segred_stage_1_parloop_338700_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segred_task_338696(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_331712 = tid;
    int num_tasks_331772 = info.nsubtasks;
    struct futhark_mc_task_338695 *futhark_mc_task_338695 =
                                  (struct futhark_mc_task_338695 *) args;
    struct futhark_context *ctx = futhark_mc_task_338695->ctx;
    uint64_t futhark_mc_segred_task_338696_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_task_338696_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338695->free_n_292675;
    int64_t gtid_306859 = futhark_mc_task_338695->free_gtid_306859;
    int64_t ctx_param_ext_313174 =
            futhark_mc_task_338695->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_task_338695->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_task_338695->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_task_338695->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315021 = {.desc ="mem_315021", .mem =
                                  futhark_mc_task_338695->free_mem_315021,
                                  .size =0, .references =NULL};
    int64_t x_331439 = futhark_mc_task_338695->free_x_331439;
    double x_331440 = futhark_mc_task_338695->free_x_331440;
    int64_t defunc_0_g_res_331443 =
            futhark_mc_task_338695->free_defunc_0_g_res_331443;
    double a11_331484 = futhark_mc_task_338695->free_a11_331484;
    double b11_331486 = futhark_mc_task_338695->free_b11_331486;
    double c11_331487 = futhark_mc_task_338695->free_c11_331487;
    double defunc_2_reduce_res_331488 =
           *futhark_mc_task_338695->retval_defunc_2_reduce_res_331488;
    double defunc_2_reduce_res_331489 =
           *futhark_mc_task_338695->retval_defunc_2_reduce_res_331489;
    size_t reduce_stage_1_tid_res_arr_mem_331773_cached_sizze_338697 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_331773 = NULL;
    size_t reduce_stage_1_tid_res_arr_mem_331775_cached_sizze_338698 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_331775 = NULL;
    
    if (reduce_stage_1_tid_res_arr_mem_331773_cached_sizze_338697 <
        (size_t) ((int64_t) 8 * num_tasks_331772)) {
        reduce_stage_1_tid_res_arr_mem_331773 =
            realloc(reduce_stage_1_tid_res_arr_mem_331773, (int64_t) 8 *
                    num_tasks_331772);
        reduce_stage_1_tid_res_arr_mem_331773_cached_sizze_338697 =
            (int64_t) 8 * num_tasks_331772;
    }
    if (reduce_stage_1_tid_res_arr_mem_331775_cached_sizze_338698 <
        (size_t) ((int64_t) 8 * num_tasks_331772)) {
        reduce_stage_1_tid_res_arr_mem_331775 =
            realloc(reduce_stage_1_tid_res_arr_mem_331775, (int64_t) 8 *
                    num_tasks_331772);
        reduce_stage_1_tid_res_arr_mem_331775_cached_sizze_338698 =
            (int64_t) 8 * num_tasks_331772;
    }
    
    int64_t iter_331777;
    struct futhark_mc_segred_stage_1_parloop_struct_338699
    futhark_mc_segred_stage_1_parloop_struct_338699;
    
    futhark_mc_segred_stage_1_parloop_struct_338699.ctx = ctx;
    futhark_mc_segred_stage_1_parloop_struct_338699.free_n_292675 = n_292675;
    futhark_mc_segred_stage_1_parloop_struct_338699.free_gtid_306859 =
        gtid_306859;
    futhark_mc_segred_stage_1_parloop_struct_338699.free_ctx_param_ext_313174 =
        ctx_param_ext_313174;
    futhark_mc_segred_stage_1_parloop_struct_338699.free_ctx_param_ext_313175 =
        ctx_param_ext_313175;
    futhark_mc_segred_stage_1_parloop_struct_338699.free_ctx_param_ext_313177 =
        ctx_param_ext_313177;
    futhark_mc_segred_stage_1_parloop_struct_338699.free_mem_param_313179 =
        mem_param_313179.mem;
    futhark_mc_segred_stage_1_parloop_struct_338699.free_mem_315021 =
        mem_315021.mem;
    futhark_mc_segred_stage_1_parloop_struct_338699.free_x_331439 = x_331439;
    futhark_mc_segred_stage_1_parloop_struct_338699.free_x_331440 = x_331440;
    futhark_mc_segred_stage_1_parloop_struct_338699.free_defunc_0_g_res_331443 =
        defunc_0_g_res_331443;
    futhark_mc_segred_stage_1_parloop_struct_338699.free_a11_331484 =
        a11_331484;
    futhark_mc_segred_stage_1_parloop_struct_338699.free_b11_331486 =
        b11_331486;
    futhark_mc_segred_stage_1_parloop_struct_338699.free_c11_331487 =
        c11_331487;
    futhark_mc_segred_stage_1_parloop_struct_338699.free_reduce_stage_1_tid_res_arr_mem_331773 =
        reduce_stage_1_tid_res_arr_mem_331773;
    futhark_mc_segred_stage_1_parloop_struct_338699.free_reduce_stage_1_tid_res_arr_mem_331775 =
        reduce_stage_1_tid_res_arr_mem_331775;
    
    struct scheduler_parloop futhark_mc_segred_stage_1_parloop_338700_task;
    
    futhark_mc_segred_stage_1_parloop_338700_task.name =
        "futhark_mc_segred_stage_1_parloop_338700";
    futhark_mc_segred_stage_1_parloop_338700_task.fn =
        futhark_mc_segred_stage_1_parloop_338700;
    futhark_mc_segred_stage_1_parloop_338700_task.args =
        &futhark_mc_segred_stage_1_parloop_struct_338699;
    futhark_mc_segred_stage_1_parloop_338700_task.iterations = iterations;
    futhark_mc_segred_stage_1_parloop_338700_task.info = info;
    
    uint64_t futhark_mc_segred_stage_1_parloop_338700_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_338700_total_start = get_wall_time();
    
    int futhark_mc_segred_stage_1_parloop_338700_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segred_stage_1_parloop_338700_task);
    
    if (futhark_mc_segred_stage_1_parloop_338700_err != 0) {
        err = futhark_mc_segred_stage_1_parloop_338700_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_338700_total_end =
                 get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_338700_total_end -
                 futhark_mc_segred_stage_1_parloop_338700_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338700_total_runs,
                           1, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338700_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338700_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    // neutral-initialise the output
    {
        defunc_2_reduce_res_331488 = 0.0;
        defunc_2_reduce_res_331489 = 0.0;
    }
    
    double x_331780;
    double x_331781;
    double x_331783;
    double x_331784;
    
    for (int32_t i_331786 = 0; i_331786 < num_tasks_331772; i_331786++) {
        flat_tid_331712 = i_331786;
        // Apply main thread reduction
        {
            // load acc params
            {
                x_331780 = defunc_2_reduce_res_331488;
            }
            // load next params
            {
                x_331781 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_331773)[flat_tid_331712];
            }
            // red body
            {
                double defunc_1_op_res_331782 = x_331780 + x_331781;
                
                defunc_2_reduce_res_331488 = defunc_1_op_res_331782;
            }
            // load acc params
            {
                x_331783 = defunc_2_reduce_res_331489;
            }
            // load next params
            {
                x_331784 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_331775)[flat_tid_331712];
            }
            // red body
            {
                double defunc_1_op_res_331785 = x_331783 + x_331784;
                
                defunc_2_reduce_res_331489 = defunc_1_op_res_331785;
            }
        }
    }
    
  cleanup:
    {
        free(reduce_stage_1_tid_res_arr_mem_331773);
        free(reduce_stage_1_tid_res_arr_mem_331775);
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_task_338696_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_task_338696_end -
                 futhark_mc_segred_task_338696_start;
        
        ctx->futhark_mc_segred_task_338696_runs[tid]++;
        ctx->futhark_mc_segred_task_338696_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segred_task_338696_iter[tid] += iterations;
    }
    if (err == 0) {
        *futhark_mc_task_338695->retval_defunc_2_reduce_res_331488 =
            defunc_2_reduce_res_331488;
        *futhark_mc_task_338695->retval_defunc_2_reduce_res_331489 =
            defunc_2_reduce_res_331489;
    }
    return err;
}
static int futhark_mc_segmap_parloop_338687(void *args, int64_t start,
                                            int64_t end, int flat_tid_331437,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338686
    *futhark_mc_segmap_parloop_struct_338686 =
    (struct futhark_mc_segmap_parloop_struct_338686 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338686->ctx;
    uint64_t futhark_mc_segmap_parloop_338687_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338687_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_338686->free_n_292675;
    int64_t q_l_292680 =
            futhark_mc_segmap_parloop_struct_338686->free_q_l_292680;
    int64_t jump_t_292685 =
            futhark_mc_segmap_parloop_struct_338686->free_jump_t_292685;
    int64_t l_n_m_292832 =
            futhark_mc_segmap_parloop_struct_338686->free_l_n_m_292832;
    int64_t i_292846 = futhark_mc_segmap_parloop_struct_338686->free_i_292846;
    int64_t gtid_306859 =
            futhark_mc_segmap_parloop_struct_338686->free_gtid_306859;
    struct memblock mem_313081 = {.desc ="mem_313081", .mem =
                                  futhark_mc_segmap_parloop_struct_338686->free_mem_313081,
                                  .size =0, .references =NULL};
    struct memblock mem_313085 = {.desc ="mem_313085", .mem =
                                  futhark_mc_segmap_parloop_struct_338686->free_mem_313085,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_segmap_parloop_struct_338686->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_segmap_parloop_struct_338686->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_segmap_parloop_struct_338686->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_segmap_parloop_struct_338686->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315021 = {.desc ="mem_315021", .mem =
                                  futhark_mc_segmap_parloop_struct_338686->free_mem_315021,
                                  .size =0, .references =NULL};
    struct memblock mem_315517 = {.desc ="mem_315517", .mem =
                                  futhark_mc_segmap_parloop_struct_338686->free_mem_315517,
                                  .size =0, .references =NULL};
    struct memblock mem_315520 = {.desc ="mem_315520", .mem =
                                  futhark_mc_segmap_parloop_struct_338686->free_mem_315520,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_331681 = start;
    
    for (; iter_331681 < end; iter_331681++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_331749 = l_n_m_292832;
        int64_t gtid_331438 = iter_331681;
        int64_t remnant_331750 = iter_331681 - gtid_331438;
        int64_t x_331439;
        
        x_331439 = ((int64_t *) mem_313081.mem)[gtid_306859 * l_n_m_292832 +
                                                gtid_331438];
        
        double x_331440;
        
        x_331440 = ((double *) mem_313085.mem)[gtid_306859 * l_n_m_292832 +
                                               gtid_331438];
        
        int64_t min_arg_331441 = mul64(jump_t_292685, gtid_331438);
        int64_t min_res_331442 = smin64(i_292846, min_arg_331441);
        int64_t defunc_0_g_res_331443 = add64((int64_t) 1, min_res_331442);
        double defunc_2_reduce_res_331444;
        double defunc_2_reduce_res_331445;
        double defunc_2_reduce_res_331446;
        int64_t flat_tid_331682 = (int64_t) 0;
        int32_t num_tasks_331751;
        
        defunc_2_reduce_res_331444 = 0.0;
        defunc_2_reduce_res_331445 = 0.0;
        defunc_2_reduce_res_331446 = 0.0;
        
        struct futhark_mc_task_338688 futhark_mc_task_338688;
        
        futhark_mc_task_338688.ctx = ctx;
        futhark_mc_task_338688.free_n_292675 = n_292675;
        futhark_mc_task_338688.free_gtid_306859 = gtid_306859;
        futhark_mc_task_338688.free_ctx_param_ext_313174 = ctx_param_ext_313174;
        futhark_mc_task_338688.free_ctx_param_ext_313175 = ctx_param_ext_313175;
        futhark_mc_task_338688.free_ctx_param_ext_313177 = ctx_param_ext_313177;
        futhark_mc_task_338688.free_mem_param_313179 = mem_param_313179.mem;
        futhark_mc_task_338688.free_x_331439 = x_331439;
        futhark_mc_task_338688.free_x_331440 = x_331440;
        futhark_mc_task_338688.free_defunc_0_g_res_331443 =
            defunc_0_g_res_331443;
        futhark_mc_task_338688.retval_defunc_2_reduce_res_331444 =
            &defunc_2_reduce_res_331444;
        futhark_mc_task_338688.retval_defunc_2_reduce_res_331445 =
            &defunc_2_reduce_res_331445;
        futhark_mc_task_338688.retval_defunc_2_reduce_res_331446 =
            &defunc_2_reduce_res_331446;
        
        struct scheduler_segop futhark_mc_task_338688_task;
        
        futhark_mc_task_338688_task.args = &futhark_mc_task_338688;
        futhark_mc_task_338688_task.top_level_fn =
            futhark_mc_segred_task_338689;
        futhark_mc_task_338688_task.name = "futhark_mc_segred_task_338689";
        futhark_mc_task_338688_task.iterations = q_l_292680;
        futhark_mc_task_338688_task.task_time =
            &ctx->futhark_mc_segred_task_338689_total_time;
        futhark_mc_task_338688_task.task_iter =
            &ctx->futhark_mc_segred_task_338689_total_iter;
        futhark_mc_task_338688_task.sched = STATIC;
        futhark_mc_task_338688_task.nested_fn = NULL;
        
        int futhark_mc_segred_task_338689_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_338688_task);
        
        if (futhark_mc_segred_task_338689_err != 0) {
            ;
            err = futhark_mc_segred_task_338689_err;
            goto cleanup;
        }
        
        double a_331477 = 2.220446049250313e-16 + defunc_2_reduce_res_331444;
        double b_331478 = 2.220446049250313e-16 + defunc_2_reduce_res_331445;
        double c_331479 = 2.220446049250313e-16 + defunc_2_reduce_res_331446;
        double x_331480 = a_331477 * c_331479;
        double y_331481 = b_331478 * b_331478;
        double y_331482 = x_331480 - y_331481;
        double det1_331483 = 1.0 / y_331482;
        double a11_331484 = c_331479 * det1_331483;
        double x_331485 = 0.0 - b_331478;
        double b11_331486 = det1_331483 * x_331485;
        double c11_331487 = a_331477 * det1_331483;
        double defunc_2_reduce_res_331488;
        double defunc_2_reduce_res_331489;
        int64_t flat_tid_331712 = (int64_t) 0;
        int32_t num_tasks_331772;
        
        defunc_2_reduce_res_331488 = 0.0;
        defunc_2_reduce_res_331489 = 0.0;
        
        struct futhark_mc_task_338695 futhark_mc_task_338695;
        
        futhark_mc_task_338695.ctx = ctx;
        futhark_mc_task_338695.free_n_292675 = n_292675;
        futhark_mc_task_338695.free_gtid_306859 = gtid_306859;
        futhark_mc_task_338695.free_ctx_param_ext_313174 = ctx_param_ext_313174;
        futhark_mc_task_338695.free_ctx_param_ext_313175 = ctx_param_ext_313175;
        futhark_mc_task_338695.free_ctx_param_ext_313177 = ctx_param_ext_313177;
        futhark_mc_task_338695.free_mem_param_313179 = mem_param_313179.mem;
        futhark_mc_task_338695.free_mem_315021 = mem_315021.mem;
        futhark_mc_task_338695.free_x_331439 = x_331439;
        futhark_mc_task_338695.free_x_331440 = x_331440;
        futhark_mc_task_338695.free_defunc_0_g_res_331443 =
            defunc_0_g_res_331443;
        futhark_mc_task_338695.free_a11_331484 = a11_331484;
        futhark_mc_task_338695.free_b11_331486 = b11_331486;
        futhark_mc_task_338695.free_c11_331487 = c11_331487;
        futhark_mc_task_338695.retval_defunc_2_reduce_res_331488 =
            &defunc_2_reduce_res_331488;
        futhark_mc_task_338695.retval_defunc_2_reduce_res_331489 =
            &defunc_2_reduce_res_331489;
        
        struct scheduler_segop futhark_mc_task_338695_task;
        
        futhark_mc_task_338695_task.args = &futhark_mc_task_338695;
        futhark_mc_task_338695_task.top_level_fn =
            futhark_mc_segred_task_338696;
        futhark_mc_task_338695_task.name = "futhark_mc_segred_task_338696";
        futhark_mc_task_338695_task.iterations = q_l_292680;
        futhark_mc_task_338695_task.task_time =
            &ctx->futhark_mc_segred_task_338696_total_time;
        futhark_mc_task_338695_task.task_iter =
            &ctx->futhark_mc_segred_task_338696_total_iter;
        futhark_mc_task_338695_task.sched = STATIC;
        futhark_mc_task_338695_task.nested_fn = NULL;
        
        int futhark_mc_segred_task_338696_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_338695_task);
        
        if (futhark_mc_segred_task_338696_err != 0) {
            ;
            err = futhark_mc_segred_task_338696_err;
            goto cleanup;
        }
        ((double *) mem_315517.mem)[gtid_331438] = defunc_2_reduce_res_331488;
        ((double *) mem_315520.mem)[gtid_331438] = defunc_2_reduce_res_331489;
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338687_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338687_end -
                 futhark_mc_segmap_parloop_338687_start;
        
        ctx->futhark_mc_segmap_parloop_338687_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338687_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338687_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_nested_task_338685(void *args, int64_t iterations,
                                         int tid, struct scheduler_info info)
{
    int err = 0;
    int flat_tid_331437 = tid;
    int num_tasks_331612 = info.nsubtasks;
    struct futhark_mc_task_338681 *futhark_mc_task_338681 =
                                  (struct futhark_mc_task_338681 *) args;
    struct futhark_context *ctx = futhark_mc_task_338681->ctx;
    uint64_t futhark_mc_segmap_nested_task_338685_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_nested_task_338685_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338681->free_n_292675;
    int64_t q_l_292680 = futhark_mc_task_338681->free_q_l_292680;
    int64_t jump_t_292685 = futhark_mc_task_338681->free_jump_t_292685;
    int64_t l_n_m_292832 = futhark_mc_task_338681->free_l_n_m_292832;
    int64_t i_292846 = futhark_mc_task_338681->free_i_292846;
    int64_t gtid_306859 = futhark_mc_task_338681->free_gtid_306859;
    struct memblock mem_313081 = {.desc ="mem_313081", .mem =
                                  futhark_mc_task_338681->free_mem_313081,
                                  .size =0, .references =NULL};
    struct memblock mem_313085 = {.desc ="mem_313085", .mem =
                                  futhark_mc_task_338681->free_mem_313085,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_task_338681->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_task_338681->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_task_338681->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_task_338681->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315021 = {.desc ="mem_315021", .mem =
                                  futhark_mc_task_338681->free_mem_315021,
                                  .size =0, .references =NULL};
    struct memblock mem_315517 = {.desc ="mem_315517", .mem =
                                  futhark_mc_task_338681->free_mem_315517,
                                  .size =0, .references =NULL};
    struct memblock mem_315520 = {.desc ="mem_315520", .mem =
                                  futhark_mc_task_338681->free_mem_315520,
                                  .size =0, .references =NULL};
    int64_t iter_331681;
    struct futhark_mc_segmap_parloop_struct_338686
    futhark_mc_segmap_parloop_struct_338686;
    
    futhark_mc_segmap_parloop_struct_338686.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338686.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_338686.free_q_l_292680 = q_l_292680;
    futhark_mc_segmap_parloop_struct_338686.free_jump_t_292685 = jump_t_292685;
    futhark_mc_segmap_parloop_struct_338686.free_l_n_m_292832 = l_n_m_292832;
    futhark_mc_segmap_parloop_struct_338686.free_i_292846 = i_292846;
    futhark_mc_segmap_parloop_struct_338686.free_gtid_306859 = gtid_306859;
    futhark_mc_segmap_parloop_struct_338686.free_mem_313081 = mem_313081.mem;
    futhark_mc_segmap_parloop_struct_338686.free_mem_313085 = mem_313085.mem;
    futhark_mc_segmap_parloop_struct_338686.free_ctx_param_ext_313174 =
        ctx_param_ext_313174;
    futhark_mc_segmap_parloop_struct_338686.free_ctx_param_ext_313175 =
        ctx_param_ext_313175;
    futhark_mc_segmap_parloop_struct_338686.free_ctx_param_ext_313177 =
        ctx_param_ext_313177;
    futhark_mc_segmap_parloop_struct_338686.free_mem_param_313179 =
        mem_param_313179.mem;
    futhark_mc_segmap_parloop_struct_338686.free_mem_315021 = mem_315021.mem;
    futhark_mc_segmap_parloop_struct_338686.free_mem_315517 = mem_315517.mem;
    futhark_mc_segmap_parloop_struct_338686.free_mem_315520 = mem_315520.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338687_task;
    
    futhark_mc_segmap_parloop_338687_task.name =
        "futhark_mc_segmap_parloop_338687";
    futhark_mc_segmap_parloop_338687_task.fn = futhark_mc_segmap_parloop_338687;
    futhark_mc_segmap_parloop_338687_task.args =
        &futhark_mc_segmap_parloop_struct_338686;
    futhark_mc_segmap_parloop_338687_task.iterations = iterations;
    futhark_mc_segmap_parloop_338687_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338687_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338687_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338687_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338687_task);
    
    if (futhark_mc_segmap_parloop_338687_err != 0) {
        err = futhark_mc_segmap_parloop_338687_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338687_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338687_total_end -
                 futhark_mc_segmap_parloop_338687_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338687_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338687_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338687_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_nested_task_338685_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_nested_task_338685_end -
                 futhark_mc_segmap_nested_task_338685_start;
        
        ctx->futhark_mc_segmap_nested_task_338685_runs[tid]++;
        ctx->futhark_mc_segmap_nested_task_338685_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_nested_task_338685_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
static int futhark_mc_segmap_parloop_338678(void *args, int64_t start,
                                            int64_t end, int flat_tid_306858,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338677
    *futhark_mc_segmap_parloop_struct_338677 =
    (struct futhark_mc_segmap_parloop_struct_338677 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338677->ctx;
    uint64_t futhark_mc_segmap_parloop_338678_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338678_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_338677->free_n_292675;
    int64_t q_l_292680 =
            futhark_mc_segmap_parloop_struct_338677->free_q_l_292680;
    int64_t jump_t_292685 =
            futhark_mc_segmap_parloop_struct_338677->free_jump_t_292685;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_338677->free_partition_sizze_292766;
    int64_t l_n_m_292832 =
            futhark_mc_segmap_parloop_struct_338677->free_l_n_m_292832;
    int64_t i_292846 = futhark_mc_segmap_parloop_struct_338677->free_i_292846;
    int64_t bytes_313028 =
            futhark_mc_segmap_parloop_struct_338677->free_bytes_313028;
    struct memblock mem_313081 = {.desc ="mem_313081", .mem =
                                  futhark_mc_segmap_parloop_struct_338677->free_mem_313081,
                                  .size =0, .references =NULL};
    struct memblock mem_313085 = {.desc ="mem_313085", .mem =
                                  futhark_mc_segmap_parloop_struct_338677->free_mem_313085,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_segmap_parloop_struct_338677->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_segmap_parloop_struct_338677->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_segmap_parloop_struct_338677->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_segmap_parloop_struct_338677->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315021 = {.desc ="mem_315021", .mem =
                                  futhark_mc_segmap_parloop_struct_338677->free_mem_315021,
                                  .size =0, .references =NULL};
    struct memblock mem_315554 = {.desc ="mem_315554", .mem =
                                  futhark_mc_segmap_parloop_struct_338677->free_mem_315554,
                                  .size =0, .references =NULL};
    struct memblock mem_315558 = {.desc ="mem_315558", .mem =
                                  futhark_mc_segmap_parloop_struct_338677->free_mem_315558,
                                  .size =0, .references =NULL};
    size_t mem_315517_cached_sizze_338679 = 0;
    unsigned char *mem_315517 = NULL;
    size_t mem_315520_cached_sizze_338680 = 0;
    unsigned char *mem_315520 = NULL;
    int64_t iterations = end - start;
    int64_t iter_331436 = start;
    
    if (mem_315517_cached_sizze_338679 < (size_t) bytes_313028) {
        mem_315517 = realloc(mem_315517, bytes_313028);
        mem_315517_cached_sizze_338679 = bytes_313028;
    }
    if (mem_315520_cached_sizze_338680 < (size_t) bytes_313028) {
        mem_315520 = realloc(mem_315520, bytes_313028);
        mem_315520_cached_sizze_338680 = bytes_313028;
    }
    for (; iter_331436 < end; iter_331436++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_331610 = partition_sizze_292766;
        int64_t gtid_306859 = iter_331436;
        int64_t remnant_331611 = iter_331436 - gtid_306859;
        int64_t flat_tid_331527 = (int64_t) 0;
        int32_t num_tasks_331612;
        int64_t flat_tid_331437 = (int64_t) 0;
        struct futhark_mc_task_338681 futhark_mc_task_338681;
        
        futhark_mc_task_338681.ctx = ctx;
        futhark_mc_task_338681.free_n_292675 = n_292675;
        futhark_mc_task_338681.free_q_l_292680 = q_l_292680;
        futhark_mc_task_338681.free_jump_t_292685 = jump_t_292685;
        futhark_mc_task_338681.free_l_n_m_292832 = l_n_m_292832;
        futhark_mc_task_338681.free_i_292846 = i_292846;
        futhark_mc_task_338681.free_gtid_306859 = gtid_306859;
        futhark_mc_task_338681.free_mem_313081 = mem_313081.mem;
        futhark_mc_task_338681.free_mem_313085 = mem_313085.mem;
        futhark_mc_task_338681.free_ctx_param_ext_313174 = ctx_param_ext_313174;
        futhark_mc_task_338681.free_ctx_param_ext_313175 = ctx_param_ext_313175;
        futhark_mc_task_338681.free_ctx_param_ext_313177 = ctx_param_ext_313177;
        futhark_mc_task_338681.free_mem_param_313179 = mem_param_313179.mem;
        futhark_mc_task_338681.free_mem_315021 = mem_315021.mem;
        futhark_mc_task_338681.free_mem_315517 = mem_315517;
        futhark_mc_task_338681.free_mem_315520 = mem_315520;
        
        struct scheduler_segop futhark_mc_task_338681_task;
        
        futhark_mc_task_338681_task.args = &futhark_mc_task_338681;
        futhark_mc_task_338681_task.top_level_fn =
            futhark_mc_segmap_task_338682;
        futhark_mc_task_338681_task.name = "futhark_mc_segmap_task_338682";
        futhark_mc_task_338681_task.iterations = l_n_m_292832;
        futhark_mc_task_338681_task.task_time =
            &ctx->futhark_mc_segmap_task_338682_total_time;
        futhark_mc_task_338681_task.task_iter =
            &ctx->futhark_mc_segmap_task_338682_total_iter;
        futhark_mc_task_338681_task.sched = STATIC;
        futhark_mc_task_338681_task.nested_fn =
            futhark_mc_segmap_nested_task_338685;
        
        int futhark_mc_segmap_task_338682_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_338681_task);
        
        if (futhark_mc_segmap_task_338682_err != 0) {
            ;
            err = futhark_mc_segmap_task_338682_err;
            goto cleanup;
        }
        if (l_n_m_292832 * (int64_t) 8 > 0)
            memmove(mem_315554.mem + gtid_306859 * l_n_m_292832 * (int64_t) 8,
                    mem_315517 + (int64_t) 0, l_n_m_292832 * (int64_t) 8);
        if (l_n_m_292832 * (int64_t) 8 > 0)
            memmove(mem_315558.mem + gtid_306859 * l_n_m_292832 * (int64_t) 8,
                    mem_315520 + (int64_t) 0, l_n_m_292832 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_315517);
    free(mem_315520);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338678_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338678_end -
                 futhark_mc_segmap_parloop_338678_start;
        
        ctx->futhark_mc_segmap_parloop_338678_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338678_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338678_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_nested_task_338676(void *args, int64_t iterations,
                                         int tid, struct scheduler_info info)
{
    int err = 0;
    int flat_tid_306858 = tid;
    int num_tasks_331339 = info.nsubtasks;
    struct futhark_mc_task_338670 *futhark_mc_task_338670 =
                                  (struct futhark_mc_task_338670 *) args;
    struct futhark_context *ctx = futhark_mc_task_338670->ctx;
    uint64_t futhark_mc_segmap_nested_task_338676_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_nested_task_338676_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338670->free_n_292675;
    int64_t q_l_292680 = futhark_mc_task_338670->free_q_l_292680;
    int64_t jump_t_292685 = futhark_mc_task_338670->free_jump_t_292685;
    int64_t partition_sizze_292766 =
            futhark_mc_task_338670->free_partition_sizze_292766;
    int64_t l_n_m_292832 = futhark_mc_task_338670->free_l_n_m_292832;
    int64_t i_292846 = futhark_mc_task_338670->free_i_292846;
    int64_t bytes_313028 = futhark_mc_task_338670->free_bytes_313028;
    struct memblock mem_313081 = {.desc ="mem_313081", .mem =
                                  futhark_mc_task_338670->free_mem_313081,
                                  .size =0, .references =NULL};
    struct memblock mem_313085 = {.desc ="mem_313085", .mem =
                                  futhark_mc_task_338670->free_mem_313085,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_task_338670->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_task_338670->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_task_338670->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_task_338670->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315021 = {.desc ="mem_315021", .mem =
                                  futhark_mc_task_338670->free_mem_315021,
                                  .size =0, .references =NULL};
    struct memblock mem_315554 = {.desc ="mem_315554", .mem =
                                  futhark_mc_task_338670->free_mem_315554,
                                  .size =0, .references =NULL};
    struct memblock mem_315558 = {.desc ="mem_315558", .mem =
                                  futhark_mc_task_338670->free_mem_315558,
                                  .size =0, .references =NULL};
    int64_t iter_331436;
    struct futhark_mc_segmap_parloop_struct_338677
    futhark_mc_segmap_parloop_struct_338677;
    
    futhark_mc_segmap_parloop_struct_338677.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338677.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_338677.free_q_l_292680 = q_l_292680;
    futhark_mc_segmap_parloop_struct_338677.free_jump_t_292685 = jump_t_292685;
    futhark_mc_segmap_parloop_struct_338677.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_338677.free_l_n_m_292832 = l_n_m_292832;
    futhark_mc_segmap_parloop_struct_338677.free_i_292846 = i_292846;
    futhark_mc_segmap_parloop_struct_338677.free_bytes_313028 = bytes_313028;
    futhark_mc_segmap_parloop_struct_338677.free_mem_313081 = mem_313081.mem;
    futhark_mc_segmap_parloop_struct_338677.free_mem_313085 = mem_313085.mem;
    futhark_mc_segmap_parloop_struct_338677.free_ctx_param_ext_313174 =
        ctx_param_ext_313174;
    futhark_mc_segmap_parloop_struct_338677.free_ctx_param_ext_313175 =
        ctx_param_ext_313175;
    futhark_mc_segmap_parloop_struct_338677.free_ctx_param_ext_313177 =
        ctx_param_ext_313177;
    futhark_mc_segmap_parloop_struct_338677.free_mem_param_313179 =
        mem_param_313179.mem;
    futhark_mc_segmap_parloop_struct_338677.free_mem_315021 = mem_315021.mem;
    futhark_mc_segmap_parloop_struct_338677.free_mem_315554 = mem_315554.mem;
    futhark_mc_segmap_parloop_struct_338677.free_mem_315558 = mem_315558.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338678_task;
    
    futhark_mc_segmap_parloop_338678_task.name =
        "futhark_mc_segmap_parloop_338678";
    futhark_mc_segmap_parloop_338678_task.fn = futhark_mc_segmap_parloop_338678;
    futhark_mc_segmap_parloop_338678_task.args =
        &futhark_mc_segmap_parloop_struct_338677;
    futhark_mc_segmap_parloop_338678_task.iterations = iterations;
    futhark_mc_segmap_parloop_338678_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338678_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338678_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338678_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338678_task);
    
    if (futhark_mc_segmap_parloop_338678_err != 0) {
        err = futhark_mc_segmap_parloop_338678_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338678_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338678_total_end -
                 futhark_mc_segmap_parloop_338678_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338678_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338678_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338678_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_nested_task_338676_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_nested_task_338676_end -
                 futhark_mc_segmap_nested_task_338676_start;
        
        ctx->futhark_mc_segmap_nested_task_338676_runs[tid]++;
        ctx->futhark_mc_segmap_nested_task_338676_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_nested_task_338676_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_task_338701 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_l_292680;
    int64_t free_jump_t_292685;
    int64_t free_partition_sizze_292766;
    int64_t free_l_n_m_292832;
    int64_t free_i_292846;
    int64_t free_bytes_313028;
    unsigned char *free_mem_313081;
    unsigned char *free_mem_313085;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315021;
    unsigned char *free_mem_315598;
    unsigned char *free_mem_315602;
};
struct futhark_mc_segmap_parloop_struct_338703 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_l_292680;
    int64_t free_jump_t_292685;
    int64_t free_partition_sizze_292766;
    int64_t free_l_n_m_292832;
    int64_t free_i_292846;
    int64_t free_bytes_313028;
    unsigned char *free_mem_313081;
    unsigned char *free_mem_313085;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315021;
    unsigned char *free_mem_315598;
    unsigned char *free_mem_315602;
};
static int futhark_mc_segmap_parloop_338704(void *args, int64_t start,
                                            int64_t end, int flat_tid_307048,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338703
    *futhark_mc_segmap_parloop_struct_338703 =
    (struct futhark_mc_segmap_parloop_struct_338703 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338703->ctx;
    uint64_t futhark_mc_segmap_parloop_338704_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338704_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_338703->free_n_292675;
    int64_t q_l_292680 =
            futhark_mc_segmap_parloop_struct_338703->free_q_l_292680;
    int64_t jump_t_292685 =
            futhark_mc_segmap_parloop_struct_338703->free_jump_t_292685;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_338703->free_partition_sizze_292766;
    int64_t l_n_m_292832 =
            futhark_mc_segmap_parloop_struct_338703->free_l_n_m_292832;
    int64_t i_292846 = futhark_mc_segmap_parloop_struct_338703->free_i_292846;
    int64_t bytes_313028 =
            futhark_mc_segmap_parloop_struct_338703->free_bytes_313028;
    struct memblock mem_313081 = {.desc ="mem_313081", .mem =
                                  futhark_mc_segmap_parloop_struct_338703->free_mem_313081,
                                  .size =0, .references =NULL};
    struct memblock mem_313085 = {.desc ="mem_313085", .mem =
                                  futhark_mc_segmap_parloop_struct_338703->free_mem_313085,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_segmap_parloop_struct_338703->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_segmap_parloop_struct_338703->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_segmap_parloop_struct_338703->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_segmap_parloop_struct_338703->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315021 = {.desc ="mem_315021", .mem =
                                  futhark_mc_segmap_parloop_struct_338703->free_mem_315021,
                                  .size =0, .references =NULL};
    struct memblock mem_315598 = {.desc ="mem_315598", .mem =
                                  futhark_mc_segmap_parloop_struct_338703->free_mem_315598,
                                  .size =0, .references =NULL};
    struct memblock mem_315602 = {.desc ="mem_315602", .mem =
                                  futhark_mc_segmap_parloop_struct_338703->free_mem_315602,
                                  .size =0, .references =NULL};
    size_t mem_315567_cached_sizze_338705 = 0;
    unsigned char *mem_315567 = NULL;
    size_t mem_315570_cached_sizze_338706 = 0;
    unsigned char *mem_315570 = NULL;
    int64_t iterations = end - start;
    int64_t iter_331788 = start;
    
    if (mem_315567_cached_sizze_338705 < (size_t) bytes_313028) {
        mem_315567 = realloc(mem_315567, bytes_313028);
        mem_315567_cached_sizze_338705 = bytes_313028;
    }
    if (mem_315570_cached_sizze_338706 < (size_t) bytes_313028) {
        mem_315570 = realloc(mem_315570, bytes_313028);
        mem_315570_cached_sizze_338706 = bytes_313028;
    }
    for (; iter_331788 < end; iter_331788++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_331907 = partition_sizze_292766;
        int64_t gtid_307049 = iter_331788;
        int64_t remnant_331908 = iter_331788 - gtid_307049;
        
        for (int64_t i_331789 = 0; i_331789 < l_n_m_292832; i_331789++) {
            int64_t x_331792;
            
            x_331792 = ((int64_t *) mem_313081.mem)[gtid_307049 * l_n_m_292832 +
                                                    i_331789];
            
            double x_331793;
            
            x_331793 = ((double *) mem_313085.mem)[gtid_307049 * l_n_m_292832 +
                                                   i_331789];
            
            int64_t min_arg_331794 = mul64(jump_t_292685, i_331789);
            int64_t min_res_331795 = smin64(i_292846, min_arg_331794);
            int64_t defunc_0_g_res_331796 = add64((int64_t) 1, min_res_331795);
            double defunc_2_reduce_res_331797;
            double defunc_2_reduce_res_331798;
            double defunc_2_reduce_res_331799;
            double defunc_2_reduce_res_331800;
            double defunc_2_reduce_res_331801;
            double redout_331803;
            double redout_331804;
            double redout_331805;
            double redout_331806;
            double redout_331807;
            
            redout_331803 = 0.0;
            redout_331804 = 0.0;
            redout_331805 = 0.0;
            redout_331806 = 0.0;
            redout_331807 = 0.0;
            for (int64_t i_331802 = 0; i_331802 < q_l_292680; i_331802++) {
                bool cond_331808 = sle64(n_292675, i_331802);
                int64_t defunc_0_f_res_331809;
                
                if (cond_331808) {
                    defunc_0_f_res_331809 = (int64_t) 0;
                } else {
                    int64_t i_331810 = add64(x_331792, i_331802);
                    int64_t defunc_1_add_res_331811 = add64((int64_t) 1,
                                                            i_331810);
                    
                    defunc_0_f_res_331809 = defunc_1_add_res_331811;
                }
                
                double defunc_0_f_res_331812;
                
                if (cond_331808) {
                    defunc_0_f_res_331812 = 0.0;
                } else {
                    int64_t i_331813 = add64(x_331792, i_331802);
                    double defunc_0_add_arg_331814;
                    
                    defunc_0_add_arg_331814 =
                        ((double *) mem_param_313179.mem)[ctx_param_ext_313174 +
                                                          (gtid_307049 *
                                                           ctx_param_ext_313175 +
                                                           i_331813 *
                                                           ctx_param_ext_313177)];
                    defunc_0_f_res_331812 = defunc_0_add_arg_331814;
                }
                
                int64_t binop_p_331815 = sub64(defunc_0_f_res_331809,
                                               defunc_0_g_res_331796);
                double defunc_0_f_res_331816 = sitofp_i64_f64(binop_p_331815);
                double abs_res_331817 = fabs(defunc_0_f_res_331816);
                double tmp1_331818 = abs_res_331817 / x_331793;
                double x_331819 = tmp1_331818 * tmp1_331818;
                double y_331820 = tmp1_331818 * x_331819;
                double tmp2_331821 = 1.0 - y_331820;
                double x_331822 = tmp2_331821 * tmp2_331821;
                double tmp3_331823 = tmp2_331821 * x_331822;
                double w_j_331824 = defunc_0_f_res_331812 * tmp3_331823;
                double xw_j_331825 = defunc_0_f_res_331816 * w_j_331824;
                double x2w_j_331826 = defunc_0_f_res_331816 * xw_j_331825;
                double x3w_j_331827 = defunc_0_f_res_331816 * x2w_j_331826;
                double x4w_j_331828 = defunc_0_f_res_331816 * x3w_j_331827;
                double defunc_1_op_res_331829 = w_j_331824 + redout_331803;
                double defunc_1_op_res_331830 = xw_j_331825 + redout_331804;
                double defunc_1_op_res_331831 = x2w_j_331826 + redout_331805;
                double defunc_1_op_res_331832 = x3w_j_331827 + redout_331806;
                double defunc_1_op_res_331833 = x4w_j_331828 + redout_331807;
                double redout_tmp_331911 = defunc_1_op_res_331829;
                double redout_tmp_331912 = defunc_1_op_res_331830;
                double redout_tmp_331913 = defunc_1_op_res_331831;
                double redout_tmp_331914 = defunc_1_op_res_331832;
                double redout_tmp_331915 = defunc_1_op_res_331833;
                
                redout_331803 = redout_tmp_331911;
                redout_331804 = redout_tmp_331912;
                redout_331805 = redout_tmp_331913;
                redout_331806 = redout_tmp_331914;
                redout_331807 = redout_tmp_331915;
            }
            defunc_2_reduce_res_331797 = redout_331803;
            defunc_2_reduce_res_331798 = redout_331804;
            defunc_2_reduce_res_331799 = redout_331805;
            defunc_2_reduce_res_331800 = redout_331806;
            defunc_2_reduce_res_331801 = redout_331807;
            
            double a_331834 = 2.220446049250313e-16 +
                   defunc_2_reduce_res_331797;
            double b_331835 = 2.220446049250313e-16 +
                   defunc_2_reduce_res_331798;
            double c_331836 = 2.220446049250313e-16 +
                   defunc_2_reduce_res_331799;
            double d_331837 = 2.220446049250313e-16 +
                   defunc_2_reduce_res_331800;
            double e_331838 = 2.220446049250313e-16 +
                   defunc_2_reduce_res_331801;
            double x_331839 = c_331836 * e_331838;
            double y_331840 = d_331837 * d_331837;
            double a12_331841 = x_331839 - y_331840;
            double x_331842 = c_331836 * d_331837;
            double y_331843 = b_331835 * e_331838;
            double b12_331844 = x_331842 - y_331843;
            double x_331845 = b_331835 * d_331837;
            double y_331846 = c_331836 * c_331836;
            double c12_331847 = x_331845 - y_331846;
            double x_331848 = a_331834 * e_331838;
            double b2_331849 = x_331848 - y_331846;
            double x_331850 = b_331835 * c_331836;
            double y_331851 = a_331834 * d_331837;
            double c2_331852 = x_331850 - y_331851;
            double x_331853 = a_331834 * a12_331841;
            double y_331854 = b_331835 * b12_331844;
            double x_331855 = x_331853 + y_331854;
            double y_331856 = c_331836 * c12_331847;
            double y_331857 = x_331855 + y_331856;
            double det_331858 = 1.0 / y_331857;
            double a12_331859 = a12_331841 * det_331858;
            double b12_331860 = b12_331844 * det_331858;
            double c12_331861 = c12_331847 * det_331858;
            double b2_331862 = b2_331849 * det_331858;
            double c2_331863 = c2_331852 * det_331858;
            double defunc_2_reduce_res_331864;
            double defunc_2_reduce_res_331865;
            double redout_331867;
            double redout_331868;
            
            redout_331867 = 0.0;
            redout_331868 = 0.0;
            for (int64_t i_331866 = 0; i_331866 < q_l_292680; i_331866++) {
                bool cond_331869 = sle64(n_292675, i_331866);
                int64_t defunc_0_f_res_331870;
                
                if (cond_331869) {
                    defunc_0_f_res_331870 = (int64_t) 0;
                } else {
                    int64_t i_331871 = add64(x_331792, i_331866);
                    int64_t defunc_1_add_res_331872 = add64((int64_t) 1,
                                                            i_331871);
                    
                    defunc_0_f_res_331870 = defunc_1_add_res_331872;
                }
                
                double defunc_0_f_res_331873;
                
                if (cond_331869) {
                    defunc_0_f_res_331873 = 0.0;
                } else {
                    int64_t i_331874 = add64(x_331792, i_331866);
                    double defunc_0_add_arg_331875;
                    
                    defunc_0_add_arg_331875 =
                        ((double *) mem_param_313179.mem)[ctx_param_ext_313174 +
                                                          (gtid_307049 *
                                                           ctx_param_ext_313175 +
                                                           i_331874 *
                                                           ctx_param_ext_313177)];
                    defunc_0_f_res_331873 = defunc_0_add_arg_331875;
                }
                
                int64_t binop_p_331876 = sub64(defunc_0_f_res_331870,
                                               defunc_0_g_res_331796);
                double defunc_0_f_res_331877 = sitofp_i64_f64(binop_p_331876);
                double abs_res_331878 = fabs(defunc_0_f_res_331877);
                double tmp1_331879 = abs_res_331878 / x_331793;
                double x_331880 = tmp1_331879 * tmp1_331879;
                double y_331881 = tmp1_331879 * x_331880;
                double tmp2_331882 = 1.0 - y_331881;
                double x_331883 = tmp2_331882 * tmp2_331882;
                double tmp3_331884 = tmp2_331882 * x_331883;
                double tmp4_331885 = defunc_0_f_res_331873 * tmp3_331884;
                double defunc_1_f_res_331886 = defunc_0_f_res_331877 *
                       tmp4_331885;
                double defunc_1_f_res_331887 = defunc_0_f_res_331877 *
                       defunc_1_f_res_331886;
                double defunc_0_f_res_331888;
                
                if (cond_331869) {
                    defunc_0_f_res_331888 = 0.0;
                } else {
                    int64_t i_331889 = add64(x_331792, i_331866);
                    double defunc_0_add_arg_331890;
                    
                    defunc_0_add_arg_331890 =
                        ((double *) mem_315021.mem)[gtid_307049 * n_292675 +
                                                    i_331889];
                    defunc_0_f_res_331888 = defunc_0_add_arg_331890;
                }
                
                double x_331891 = a12_331859 * tmp4_331885;
                double y_331892 = b12_331860 * defunc_1_f_res_331886;
                double x_331893 = x_331891 + y_331892;
                double y_331894 = c12_331861 * defunc_1_f_res_331887;
                double x_331895 = x_331893 + y_331894;
                double defunc_9_fit_fun_res_331896 = defunc_0_f_res_331888 *
                       x_331895;
                double x_331897 = b12_331860 * tmp4_331885;
                double y_331898 = b2_331862 * defunc_1_f_res_331886;
                double x_331899 = x_331897 + y_331898;
                double y_331900 = c2_331863 * defunc_1_f_res_331887;
                double x_331901 = x_331899 + y_331900;
                double defunc_9_slope_fun_res_331902 = defunc_0_f_res_331888 *
                       x_331901;
                double defunc_1_op_res_331903 = defunc_9_fit_fun_res_331896 +
                       redout_331867;
                double defunc_1_op_res_331904 = defunc_9_slope_fun_res_331902 +
                       redout_331868;
                double redout_tmp_331916 = defunc_1_op_res_331903;
                double redout_tmp_331917 = defunc_1_op_res_331904;
                
                redout_331867 = redout_tmp_331916;
                redout_331868 = redout_tmp_331917;
            }
            defunc_2_reduce_res_331864 = redout_331867;
            defunc_2_reduce_res_331865 = redout_331868;
            ((double *) mem_315567)[i_331789] = defunc_2_reduce_res_331864;
            ((double *) mem_315570)[i_331789] = defunc_2_reduce_res_331865;
        }
        if (l_n_m_292832 * (int64_t) 8 > 0)
            memmove(mem_315598.mem + gtid_307049 * l_n_m_292832 * (int64_t) 8,
                    mem_315567 + (int64_t) 0, l_n_m_292832 * (int64_t) 8);
        if (l_n_m_292832 * (int64_t) 8 > 0)
            memmove(mem_315602.mem + gtid_307049 * l_n_m_292832 * (int64_t) 8,
                    mem_315570 + (int64_t) 0, l_n_m_292832 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_315567);
    free(mem_315570);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338704_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338704_end -
                 futhark_mc_segmap_parloop_338704_start;
        
        ctx->futhark_mc_segmap_parloop_338704_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338704_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338704_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_338702(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_307048 = tid;
    int num_tasks_331787 = info.nsubtasks;
    struct futhark_mc_task_338701 *futhark_mc_task_338701 =
                                  (struct futhark_mc_task_338701 *) args;
    struct futhark_context *ctx = futhark_mc_task_338701->ctx;
    uint64_t futhark_mc_segmap_task_338702_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_338702_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338701->free_n_292675;
    int64_t q_l_292680 = futhark_mc_task_338701->free_q_l_292680;
    int64_t jump_t_292685 = futhark_mc_task_338701->free_jump_t_292685;
    int64_t partition_sizze_292766 =
            futhark_mc_task_338701->free_partition_sizze_292766;
    int64_t l_n_m_292832 = futhark_mc_task_338701->free_l_n_m_292832;
    int64_t i_292846 = futhark_mc_task_338701->free_i_292846;
    int64_t bytes_313028 = futhark_mc_task_338701->free_bytes_313028;
    struct memblock mem_313081 = {.desc ="mem_313081", .mem =
                                  futhark_mc_task_338701->free_mem_313081,
                                  .size =0, .references =NULL};
    struct memblock mem_313085 = {.desc ="mem_313085", .mem =
                                  futhark_mc_task_338701->free_mem_313085,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_task_338701->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_task_338701->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_task_338701->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_task_338701->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315021 = {.desc ="mem_315021", .mem =
                                  futhark_mc_task_338701->free_mem_315021,
                                  .size =0, .references =NULL};
    struct memblock mem_315598 = {.desc ="mem_315598", .mem =
                                  futhark_mc_task_338701->free_mem_315598,
                                  .size =0, .references =NULL};
    struct memblock mem_315602 = {.desc ="mem_315602", .mem =
                                  futhark_mc_task_338701->free_mem_315602,
                                  .size =0, .references =NULL};
    int64_t iter_331788;
    struct futhark_mc_segmap_parloop_struct_338703
    futhark_mc_segmap_parloop_struct_338703;
    
    futhark_mc_segmap_parloop_struct_338703.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338703.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_338703.free_q_l_292680 = q_l_292680;
    futhark_mc_segmap_parloop_struct_338703.free_jump_t_292685 = jump_t_292685;
    futhark_mc_segmap_parloop_struct_338703.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_338703.free_l_n_m_292832 = l_n_m_292832;
    futhark_mc_segmap_parloop_struct_338703.free_i_292846 = i_292846;
    futhark_mc_segmap_parloop_struct_338703.free_bytes_313028 = bytes_313028;
    futhark_mc_segmap_parloop_struct_338703.free_mem_313081 = mem_313081.mem;
    futhark_mc_segmap_parloop_struct_338703.free_mem_313085 = mem_313085.mem;
    futhark_mc_segmap_parloop_struct_338703.free_ctx_param_ext_313174 =
        ctx_param_ext_313174;
    futhark_mc_segmap_parloop_struct_338703.free_ctx_param_ext_313175 =
        ctx_param_ext_313175;
    futhark_mc_segmap_parloop_struct_338703.free_ctx_param_ext_313177 =
        ctx_param_ext_313177;
    futhark_mc_segmap_parloop_struct_338703.free_mem_param_313179 =
        mem_param_313179.mem;
    futhark_mc_segmap_parloop_struct_338703.free_mem_315021 = mem_315021.mem;
    futhark_mc_segmap_parloop_struct_338703.free_mem_315598 = mem_315598.mem;
    futhark_mc_segmap_parloop_struct_338703.free_mem_315602 = mem_315602.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338704_task;
    
    futhark_mc_segmap_parloop_338704_task.name =
        "futhark_mc_segmap_parloop_338704";
    futhark_mc_segmap_parloop_338704_task.fn = futhark_mc_segmap_parloop_338704;
    futhark_mc_segmap_parloop_338704_task.args =
        &futhark_mc_segmap_parloop_struct_338703;
    futhark_mc_segmap_parloop_338704_task.iterations = iterations;
    futhark_mc_segmap_parloop_338704_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338704_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338704_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338704_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338704_task);
    
    if (futhark_mc_segmap_parloop_338704_err != 0) {
        err = futhark_mc_segmap_parloop_338704_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338704_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338704_total_end -
                 futhark_mc_segmap_parloop_338704_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338704_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338704_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338704_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_338702_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_338702_end -
                 futhark_mc_segmap_task_338702_start;
        
        ctx->futhark_mc_segmap_task_338702_runs[tid]++;
        ctx->futhark_mc_segmap_task_338702_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_338702_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_segmap_parloop_struct_338708 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_l_292680;
    int64_t free_jump_t_292685;
    int64_t free_partition_sizze_292766;
    int64_t free_l_n_m_292832;
    int64_t free_i_292846;
    int64_t free_bytes_313028;
    unsigned char *free_mem_313081;
    unsigned char *free_mem_313085;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315021;
    unsigned char *free_mem_315598;
    unsigned char *free_mem_315602;
};
struct futhark_mc_task_338712 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_l_292680;
    int64_t free_jump_t_292685;
    int64_t free_l_n_m_292832;
    int64_t free_i_292846;
    int64_t free_gtid_307188;
    unsigned char *free_mem_313081;
    unsigned char *free_mem_313085;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315021;
    unsigned char *free_mem_315561;
    unsigned char *free_mem_315564;
};
struct futhark_mc_segmap_parloop_struct_338714 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_l_292680;
    int64_t free_jump_t_292685;
    int64_t free_l_n_m_292832;
    int64_t free_i_292846;
    int64_t free_gtid_307188;
    unsigned char *free_mem_313081;
    unsigned char *free_mem_313085;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315021;
    unsigned char *free_mem_315561;
    unsigned char *free_mem_315564;
};
static int futhark_mc_segmap_parloop_338715(void *args, int64_t start,
                                            int64_t end, int flat_tid_332043,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338714
    *futhark_mc_segmap_parloop_struct_338714 =
    (struct futhark_mc_segmap_parloop_struct_338714 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338714->ctx;
    uint64_t futhark_mc_segmap_parloop_338715_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338715_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_338714->free_n_292675;
    int64_t q_l_292680 =
            futhark_mc_segmap_parloop_struct_338714->free_q_l_292680;
    int64_t jump_t_292685 =
            futhark_mc_segmap_parloop_struct_338714->free_jump_t_292685;
    int64_t l_n_m_292832 =
            futhark_mc_segmap_parloop_struct_338714->free_l_n_m_292832;
    int64_t i_292846 = futhark_mc_segmap_parloop_struct_338714->free_i_292846;
    int64_t gtid_307188 =
            futhark_mc_segmap_parloop_struct_338714->free_gtid_307188;
    struct memblock mem_313081 = {.desc ="mem_313081", .mem =
                                  futhark_mc_segmap_parloop_struct_338714->free_mem_313081,
                                  .size =0, .references =NULL};
    struct memblock mem_313085 = {.desc ="mem_313085", .mem =
                                  futhark_mc_segmap_parloop_struct_338714->free_mem_313085,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_segmap_parloop_struct_338714->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_segmap_parloop_struct_338714->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_segmap_parloop_struct_338714->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_segmap_parloop_struct_338714->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315021 = {.desc ="mem_315021", .mem =
                                  futhark_mc_segmap_parloop_struct_338714->free_mem_315021,
                                  .size =0, .references =NULL};
    struct memblock mem_315561 = {.desc ="mem_315561", .mem =
                                  futhark_mc_segmap_parloop_struct_338714->free_mem_315561,
                                  .size =0, .references =NULL};
    struct memblock mem_315564 = {.desc ="mem_315564", .mem =
                                  futhark_mc_segmap_parloop_struct_338714->free_mem_315564,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_332161 = start;
    
    for (; iter_332161 < end; iter_332161++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_332233 = l_n_m_292832;
        int64_t gtid_332044 = iter_332161;
        int64_t remnant_332234 = iter_332161 - gtid_332044;
        int64_t x_332045;
        
        x_332045 = ((int64_t *) mem_313081.mem)[gtid_307188 * l_n_m_292832 +
                                                gtid_332044];
        
        double x_332046;
        
        x_332046 = ((double *) mem_313085.mem)[gtid_307188 * l_n_m_292832 +
                                               gtid_332044];
        
        int64_t min_arg_332047 = mul64(jump_t_292685, gtid_332044);
        int64_t min_res_332048 = smin64(i_292846, min_arg_332047);
        int64_t defunc_0_g_res_332049 = add64((int64_t) 1, min_res_332048);
        double defunc_2_reduce_res_332050;
        double defunc_2_reduce_res_332051;
        double defunc_2_reduce_res_332052;
        double defunc_2_reduce_res_332053;
        double defunc_2_reduce_res_332054;
        double redout_332163;
        double redout_332164;
        double redout_332165;
        double redout_332166;
        double redout_332167;
        
        redout_332163 = 0.0;
        redout_332164 = 0.0;
        redout_332165 = 0.0;
        redout_332166 = 0.0;
        redout_332167 = 0.0;
        for (int64_t i_332162 = 0; i_332162 < q_l_292680; i_332162++) {
            bool cond_332168 = sle64(n_292675, i_332162);
            int64_t defunc_0_f_res_332169;
            
            if (cond_332168) {
                defunc_0_f_res_332169 = (int64_t) 0;
            } else {
                int64_t i_332170 = add64(x_332045, i_332162);
                int64_t defunc_1_add_res_332171 = add64((int64_t) 1, i_332170);
                
                defunc_0_f_res_332169 = defunc_1_add_res_332171;
            }
            
            double defunc_0_f_res_332172;
            
            if (cond_332168) {
                defunc_0_f_res_332172 = 0.0;
            } else {
                int64_t i_332173 = add64(x_332045, i_332162);
                double defunc_0_add_arg_332174;
                
                defunc_0_add_arg_332174 =
                    ((double *) mem_param_313179.mem)[ctx_param_ext_313174 +
                                                      (gtid_307188 *
                                                       ctx_param_ext_313175 +
                                                       i_332173 *
                                                       ctx_param_ext_313177)];
                defunc_0_f_res_332172 = defunc_0_add_arg_332174;
            }
            
            int64_t binop_p_332175 = sub64(defunc_0_f_res_332169,
                                           defunc_0_g_res_332049);
            double defunc_0_f_res_332176 = sitofp_i64_f64(binop_p_332175);
            double abs_res_332177 = fabs(defunc_0_f_res_332176);
            double tmp1_332178 = abs_res_332177 / x_332046;
            double x_332179 = tmp1_332178 * tmp1_332178;
            double y_332180 = tmp1_332178 * x_332179;
            double tmp2_332181 = 1.0 - y_332180;
            double x_332182 = tmp2_332181 * tmp2_332181;
            double tmp3_332183 = tmp2_332181 * x_332182;
            double w_j_332184 = defunc_0_f_res_332172 * tmp3_332183;
            double xw_j_332185 = defunc_0_f_res_332176 * w_j_332184;
            double x2w_j_332186 = defunc_0_f_res_332176 * xw_j_332185;
            double x3w_j_332187 = defunc_0_f_res_332176 * x2w_j_332186;
            double x4w_j_332188 = defunc_0_f_res_332176 * x3w_j_332187;
            double defunc_1_op_res_332189 = w_j_332184 + redout_332163;
            double defunc_1_op_res_332190 = xw_j_332185 + redout_332164;
            double defunc_1_op_res_332191 = x2w_j_332186 + redout_332165;
            double defunc_1_op_res_332192 = x3w_j_332187 + redout_332166;
            double defunc_1_op_res_332193 = x4w_j_332188 + redout_332167;
            double redout_tmp_332235 = defunc_1_op_res_332189;
            double redout_tmp_332236 = defunc_1_op_res_332190;
            double redout_tmp_332237 = defunc_1_op_res_332191;
            double redout_tmp_332238 = defunc_1_op_res_332192;
            double redout_tmp_332239 = defunc_1_op_res_332193;
            
            redout_332163 = redout_tmp_332235;
            redout_332164 = redout_tmp_332236;
            redout_332165 = redout_tmp_332237;
            redout_332166 = redout_tmp_332238;
            redout_332167 = redout_tmp_332239;
        }
        defunc_2_reduce_res_332050 = redout_332163;
        defunc_2_reduce_res_332051 = redout_332164;
        defunc_2_reduce_res_332052 = redout_332165;
        defunc_2_reduce_res_332053 = redout_332166;
        defunc_2_reduce_res_332054 = redout_332167;
        
        double a_332087 = 2.220446049250313e-16 + defunc_2_reduce_res_332050;
        double b_332088 = 2.220446049250313e-16 + defunc_2_reduce_res_332051;
        double c_332089 = 2.220446049250313e-16 + defunc_2_reduce_res_332052;
        double d_332090 = 2.220446049250313e-16 + defunc_2_reduce_res_332053;
        double e_332091 = 2.220446049250313e-16 + defunc_2_reduce_res_332054;
        double x_332092 = c_332089 * e_332091;
        double y_332093 = d_332090 * d_332090;
        double a12_332094 = x_332092 - y_332093;
        double x_332095 = c_332089 * d_332090;
        double y_332096 = b_332088 * e_332091;
        double b12_332097 = x_332095 - y_332096;
        double x_332098 = b_332088 * d_332090;
        double y_332099 = c_332089 * c_332089;
        double c12_332100 = x_332098 - y_332099;
        double x_332101 = a_332087 * e_332091;
        double b2_332102 = x_332101 - y_332099;
        double x_332103 = b_332088 * c_332089;
        double y_332104 = a_332087 * d_332090;
        double c2_332105 = x_332103 - y_332104;
        double x_332106 = a_332087 * a12_332094;
        double y_332107 = b_332088 * b12_332097;
        double x_332108 = x_332106 + y_332107;
        double y_332109 = c_332089 * c12_332100;
        double y_332110 = x_332108 + y_332109;
        double det_332111 = 1.0 / y_332110;
        double a12_332112 = a12_332094 * det_332111;
        double b12_332113 = b12_332097 * det_332111;
        double c12_332114 = c12_332100 * det_332111;
        double b2_332115 = b2_332102 * det_332111;
        double c2_332116 = c2_332105 * det_332111;
        double defunc_2_reduce_res_332117;
        double defunc_2_reduce_res_332118;
        double redout_332195;
        double redout_332196;
        
        redout_332195 = 0.0;
        redout_332196 = 0.0;
        for (int64_t i_332194 = 0; i_332194 < q_l_292680; i_332194++) {
            bool cond_332197 = sle64(n_292675, i_332194);
            int64_t defunc_0_f_res_332198;
            
            if (cond_332197) {
                defunc_0_f_res_332198 = (int64_t) 0;
            } else {
                int64_t i_332199 = add64(x_332045, i_332194);
                int64_t defunc_1_add_res_332200 = add64((int64_t) 1, i_332199);
                
                defunc_0_f_res_332198 = defunc_1_add_res_332200;
            }
            
            double defunc_0_f_res_332201;
            
            if (cond_332197) {
                defunc_0_f_res_332201 = 0.0;
            } else {
                int64_t i_332202 = add64(x_332045, i_332194);
                double defunc_0_add_arg_332203;
                
                defunc_0_add_arg_332203 =
                    ((double *) mem_param_313179.mem)[ctx_param_ext_313174 +
                                                      (gtid_307188 *
                                                       ctx_param_ext_313175 +
                                                       i_332202 *
                                                       ctx_param_ext_313177)];
                defunc_0_f_res_332201 = defunc_0_add_arg_332203;
            }
            
            int64_t binop_p_332204 = sub64(defunc_0_f_res_332198,
                                           defunc_0_g_res_332049);
            double defunc_0_f_res_332205 = sitofp_i64_f64(binop_p_332204);
            double abs_res_332206 = fabs(defunc_0_f_res_332205);
            double tmp1_332207 = abs_res_332206 / x_332046;
            double x_332208 = tmp1_332207 * tmp1_332207;
            double y_332209 = tmp1_332207 * x_332208;
            double tmp2_332210 = 1.0 - y_332209;
            double x_332211 = tmp2_332210 * tmp2_332210;
            double tmp3_332212 = tmp2_332210 * x_332211;
            double tmp4_332213 = defunc_0_f_res_332201 * tmp3_332212;
            double defunc_1_f_res_332214 = defunc_0_f_res_332205 * tmp4_332213;
            double defunc_1_f_res_332215 = defunc_0_f_res_332205 *
                   defunc_1_f_res_332214;
            double defunc_0_f_res_332216;
            
            if (cond_332197) {
                defunc_0_f_res_332216 = 0.0;
            } else {
                int64_t i_332217 = add64(x_332045, i_332194);
                double defunc_0_add_arg_332218;
                
                defunc_0_add_arg_332218 =
                    ((double *) mem_315021.mem)[gtid_307188 * n_292675 +
                                                i_332217];
                defunc_0_f_res_332216 = defunc_0_add_arg_332218;
            }
            
            double x_332219 = a12_332112 * tmp4_332213;
            double y_332220 = b12_332113 * defunc_1_f_res_332214;
            double x_332221 = x_332219 + y_332220;
            double y_332222 = c12_332114 * defunc_1_f_res_332215;
            double x_332223 = x_332221 + y_332222;
            double defunc_9_fit_fun_res_332224 = defunc_0_f_res_332216 *
                   x_332223;
            double x_332225 = b12_332113 * tmp4_332213;
            double y_332226 = b2_332115 * defunc_1_f_res_332214;
            double x_332227 = x_332225 + y_332226;
            double y_332228 = c2_332116 * defunc_1_f_res_332215;
            double x_332229 = x_332227 + y_332228;
            double defunc_9_slope_fun_res_332230 = defunc_0_f_res_332216 *
                   x_332229;
            double defunc_1_op_res_332231 = defunc_9_fit_fun_res_332224 +
                   redout_332195;
            double defunc_1_op_res_332232 = defunc_9_slope_fun_res_332230 +
                   redout_332196;
            double redout_tmp_332240 = defunc_1_op_res_332231;
            double redout_tmp_332241 = defunc_1_op_res_332232;
            
            redout_332195 = redout_tmp_332240;
            redout_332196 = redout_tmp_332241;
        }
        defunc_2_reduce_res_332117 = redout_332195;
        defunc_2_reduce_res_332118 = redout_332196;
        ((double *) mem_315561.mem)[gtid_332044] = defunc_2_reduce_res_332117;
        ((double *) mem_315564.mem)[gtid_332044] = defunc_2_reduce_res_332118;
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338715_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338715_end -
                 futhark_mc_segmap_parloop_338715_start;
        
        ctx->futhark_mc_segmap_parloop_338715_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338715_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338715_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_338713(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_332043 = tid;
    int num_tasks_332160 = info.nsubtasks;
    struct futhark_mc_task_338712 *futhark_mc_task_338712 =
                                  (struct futhark_mc_task_338712 *) args;
    struct futhark_context *ctx = futhark_mc_task_338712->ctx;
    uint64_t futhark_mc_segmap_task_338713_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_338713_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338712->free_n_292675;
    int64_t q_l_292680 = futhark_mc_task_338712->free_q_l_292680;
    int64_t jump_t_292685 = futhark_mc_task_338712->free_jump_t_292685;
    int64_t l_n_m_292832 = futhark_mc_task_338712->free_l_n_m_292832;
    int64_t i_292846 = futhark_mc_task_338712->free_i_292846;
    int64_t gtid_307188 = futhark_mc_task_338712->free_gtid_307188;
    struct memblock mem_313081 = {.desc ="mem_313081", .mem =
                                  futhark_mc_task_338712->free_mem_313081,
                                  .size =0, .references =NULL};
    struct memblock mem_313085 = {.desc ="mem_313085", .mem =
                                  futhark_mc_task_338712->free_mem_313085,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_task_338712->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_task_338712->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_task_338712->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_task_338712->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315021 = {.desc ="mem_315021", .mem =
                                  futhark_mc_task_338712->free_mem_315021,
                                  .size =0, .references =NULL};
    struct memblock mem_315561 = {.desc ="mem_315561", .mem =
                                  futhark_mc_task_338712->free_mem_315561,
                                  .size =0, .references =NULL};
    struct memblock mem_315564 = {.desc ="mem_315564", .mem =
                                  futhark_mc_task_338712->free_mem_315564,
                                  .size =0, .references =NULL};
    int64_t iter_332161;
    struct futhark_mc_segmap_parloop_struct_338714
    futhark_mc_segmap_parloop_struct_338714;
    
    futhark_mc_segmap_parloop_struct_338714.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338714.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_338714.free_q_l_292680 = q_l_292680;
    futhark_mc_segmap_parloop_struct_338714.free_jump_t_292685 = jump_t_292685;
    futhark_mc_segmap_parloop_struct_338714.free_l_n_m_292832 = l_n_m_292832;
    futhark_mc_segmap_parloop_struct_338714.free_i_292846 = i_292846;
    futhark_mc_segmap_parloop_struct_338714.free_gtid_307188 = gtid_307188;
    futhark_mc_segmap_parloop_struct_338714.free_mem_313081 = mem_313081.mem;
    futhark_mc_segmap_parloop_struct_338714.free_mem_313085 = mem_313085.mem;
    futhark_mc_segmap_parloop_struct_338714.free_ctx_param_ext_313174 =
        ctx_param_ext_313174;
    futhark_mc_segmap_parloop_struct_338714.free_ctx_param_ext_313175 =
        ctx_param_ext_313175;
    futhark_mc_segmap_parloop_struct_338714.free_ctx_param_ext_313177 =
        ctx_param_ext_313177;
    futhark_mc_segmap_parloop_struct_338714.free_mem_param_313179 =
        mem_param_313179.mem;
    futhark_mc_segmap_parloop_struct_338714.free_mem_315021 = mem_315021.mem;
    futhark_mc_segmap_parloop_struct_338714.free_mem_315561 = mem_315561.mem;
    futhark_mc_segmap_parloop_struct_338714.free_mem_315564 = mem_315564.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338715_task;
    
    futhark_mc_segmap_parloop_338715_task.name =
        "futhark_mc_segmap_parloop_338715";
    futhark_mc_segmap_parloop_338715_task.fn = futhark_mc_segmap_parloop_338715;
    futhark_mc_segmap_parloop_338715_task.args =
        &futhark_mc_segmap_parloop_struct_338714;
    futhark_mc_segmap_parloop_338715_task.iterations = iterations;
    futhark_mc_segmap_parloop_338715_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338715_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338715_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338715_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338715_task);
    
    if (futhark_mc_segmap_parloop_338715_err != 0) {
        err = futhark_mc_segmap_parloop_338715_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338715_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338715_total_end -
                 futhark_mc_segmap_parloop_338715_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338715_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338715_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338715_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_338713_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_338713_end -
                 futhark_mc_segmap_task_338713_start;
        
        ctx->futhark_mc_segmap_task_338713_runs[tid]++;
        ctx->futhark_mc_segmap_task_338713_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_338713_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_segmap_parloop_struct_338717 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_l_292680;
    int64_t free_jump_t_292685;
    int64_t free_l_n_m_292832;
    int64_t free_i_292846;
    int64_t free_gtid_307188;
    unsigned char *free_mem_313081;
    unsigned char *free_mem_313085;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315021;
    unsigned char *free_mem_315561;
    unsigned char *free_mem_315564;
};
struct futhark_mc_task_338719 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_307188;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    int64_t free_x_331921;
    double free_x_331922;
    int64_t free_defunc_0_g_res_331925;
    double *retval_defunc_2_reduce_res_331926;
    double *retval_defunc_2_reduce_res_331927;
    double *retval_defunc_2_reduce_res_331928;
    double *retval_defunc_2_reduce_res_331929;
    double *retval_defunc_2_reduce_res_331930;
};
struct futhark_mc_segred_stage_1_parloop_struct_338726 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_307188;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    int64_t free_x_331921;
    double free_x_331922;
    int64_t free_defunc_0_g_res_331925;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_332326;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_332328;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_332330;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_332332;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_332334;
};
static int futhark_mc_segred_stage_1_parloop_338727(void *args, int64_t start,
                                                    int64_t end,
                                                    int flat_tid_332243,
                                                    int tid)
{
    int err = 0;
    struct futhark_mc_segred_stage_1_parloop_struct_338726
    *futhark_mc_segred_stage_1_parloop_struct_338726 =
    (struct futhark_mc_segred_stage_1_parloop_struct_338726 *) args;
    struct futhark_context *ctx =
                           futhark_mc_segred_stage_1_parloop_struct_338726->ctx;
    uint64_t futhark_mc_segred_stage_1_parloop_338727_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_338727_start = get_wall_time();
    
    int64_t n_292675 =
            futhark_mc_segred_stage_1_parloop_struct_338726->free_n_292675;
    int64_t gtid_307188 =
            futhark_mc_segred_stage_1_parloop_struct_338726->free_gtid_307188;
    int64_t ctx_param_ext_313174 =
            futhark_mc_segred_stage_1_parloop_struct_338726->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_segred_stage_1_parloop_struct_338726->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_segred_stage_1_parloop_struct_338726->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_segred_stage_1_parloop_struct_338726->free_mem_param_313179,
                                        .size =0, .references =NULL};
    int64_t x_331921 =
            futhark_mc_segred_stage_1_parloop_struct_338726->free_x_331921;
    double x_331922 =
           futhark_mc_segred_stage_1_parloop_struct_338726->free_x_331922;
    int64_t defunc_0_g_res_331925 =
            futhark_mc_segred_stage_1_parloop_struct_338726->free_defunc_0_g_res_331925;
    struct memblock reduce_stage_1_tid_res_arr_mem_332326 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_332326",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338726->free_reduce_stage_1_tid_res_arr_mem_332326,
                                                             .size =0,
                                                             .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_332328 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_332328",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338726->free_reduce_stage_1_tid_res_arr_mem_332328,
                                                             .size =0,
                                                             .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_332330 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_332330",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338726->free_reduce_stage_1_tid_res_arr_mem_332330,
                                                             .size =0,
                                                             .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_332332 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_332332",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338726->free_reduce_stage_1_tid_res_arr_mem_332332,
                                                             .size =0,
                                                             .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_332334 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_332334",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338726->free_reduce_stage_1_tid_res_arr_mem_332334,
                                                             .size =0,
                                                             .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_332336 = start;
    double x_332245;
    double x_332246;
    double x_332248;
    double x_332249;
    double x_332251;
    double x_332252;
    double x_332254;
    double x_332255;
    double x_332257;
    double x_332258;
    double local_acc_332337 = 0.0;
    double local_acc_332338 = 0.0;
    double local_acc_332339 = 0.0;
    double local_acc_332340 = 0.0;
    double local_acc_332341 = 0.0;
    
    for (; iter_332336 < end; iter_332336++) {
        int64_t gtid_332244 = iter_332336;
        bool cond_332260 = sle64(n_292675, gtid_332244);
        int64_t defunc_0_f_res_332261;
        
        if (cond_332260) {
            defunc_0_f_res_332261 = (int64_t) 0;
        } else {
            int64_t i_332262 = add64(x_331921, gtid_332244);
            int64_t defunc_1_add_res_332263 = add64((int64_t) 1, i_332262);
            
            defunc_0_f_res_332261 = defunc_1_add_res_332263;
        }
        
        double defunc_0_f_res_332264;
        
        if (cond_332260) {
            defunc_0_f_res_332264 = 0.0;
        } else {
            int64_t i_332265 = add64(x_331921, gtid_332244);
            double defunc_0_add_arg_332266;
            
            defunc_0_add_arg_332266 =
                ((double *) mem_param_313179.mem)[ctx_param_ext_313174 +
                                                  (gtid_307188 *
                                                   ctx_param_ext_313175 +
                                                   i_332265 *
                                                   ctx_param_ext_313177)];
            defunc_0_f_res_332264 = defunc_0_add_arg_332266;
        }
        
        int64_t binop_p_332267 = sub64(defunc_0_f_res_332261,
                                       defunc_0_g_res_331925);
        double defunc_0_f_res_332268 = sitofp_i64_f64(binop_p_332267);
        double abs_res_332269 = fabs(defunc_0_f_res_332268);
        double tmp1_332270 = abs_res_332269 / x_331922;
        double x_332271 = tmp1_332270 * tmp1_332270;
        double y_332272 = tmp1_332270 * x_332271;
        double tmp2_332273 = 1.0 - y_332272;
        double x_332274 = tmp2_332273 * tmp2_332273;
        double tmp3_332275 = tmp2_332273 * x_332274;
        double w_j_332276 = defunc_0_f_res_332264 * tmp3_332275;
        double xw_j_332277 = defunc_0_f_res_332268 * w_j_332276;
        double x2w_j_332278 = defunc_0_f_res_332268 * xw_j_332277;
        double x3w_j_332279 = defunc_0_f_res_332268 * x2w_j_332278;
        double x4w_j_332280 = defunc_0_f_res_332268 * x3w_j_332279;
        
        // save map-out results
        { }
        // Load accum params
        {
            x_332245 = local_acc_332337;
        }
        // Load next params
        {
            x_332246 = w_j_332276;
        }
        // Red body
        {
            double defunc_1_op_res_332247 = x_332245 + x_332246;
            
            local_acc_332337 = defunc_1_op_res_332247;
        }
        // Load accum params
        {
            x_332248 = local_acc_332338;
        }
        // Load next params
        {
            x_332249 = xw_j_332277;
        }
        // Red body
        {
            double defunc_1_op_res_332250 = x_332248 + x_332249;
            
            local_acc_332338 = defunc_1_op_res_332250;
        }
        // Load accum params
        {
            x_332251 = local_acc_332339;
        }
        // Load next params
        {
            x_332252 = x2w_j_332278;
        }
        // Red body
        {
            double defunc_1_op_res_332253 = x_332251 + x_332252;
            
            local_acc_332339 = defunc_1_op_res_332253;
        }
        // Load accum params
        {
            x_332254 = local_acc_332340;
        }
        // Load next params
        {
            x_332255 = x3w_j_332279;
        }
        // Red body
        {
            double defunc_1_op_res_332256 = x_332254 + x_332255;
            
            local_acc_332340 = defunc_1_op_res_332256;
        }
        // Load accum params
        {
            x_332257 = local_acc_332341;
        }
        // Load next params
        {
            x_332258 = x4w_j_332280;
        }
        // Red body
        {
            double defunc_1_op_res_332259 = x_332257 + x_332258;
            
            local_acc_332341 = defunc_1_op_res_332259;
        }
    }
    ((double *) reduce_stage_1_tid_res_arr_mem_332326.mem)[flat_tid_332243] =
        local_acc_332337;
    ((double *) reduce_stage_1_tid_res_arr_mem_332328.mem)[flat_tid_332243] =
        local_acc_332338;
    ((double *) reduce_stage_1_tid_res_arr_mem_332330.mem)[flat_tid_332243] =
        local_acc_332339;
    ((double *) reduce_stage_1_tid_res_arr_mem_332332.mem)[flat_tid_332243] =
        local_acc_332340;
    ((double *) reduce_stage_1_tid_res_arr_mem_332334.mem)[flat_tid_332243] =
        local_acc_332341;
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_338727_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_338727_end -
                 futhark_mc_segred_stage_1_parloop_338727_start;
        
        ctx->futhark_mc_segred_stage_1_parloop_338727_runs[tid]++;
        ctx->futhark_mc_segred_stage_1_parloop_338727_total_runtime[tid] +=
            elapsed;
        ctx->futhark_mc_segred_stage_1_parloop_338727_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segred_task_338720(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_332243 = tid;
    int num_tasks_332325 = info.nsubtasks;
    struct futhark_mc_task_338719 *futhark_mc_task_338719 =
                                  (struct futhark_mc_task_338719 *) args;
    struct futhark_context *ctx = futhark_mc_task_338719->ctx;
    uint64_t futhark_mc_segred_task_338720_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_task_338720_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338719->free_n_292675;
    int64_t gtid_307188 = futhark_mc_task_338719->free_gtid_307188;
    int64_t ctx_param_ext_313174 =
            futhark_mc_task_338719->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_task_338719->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_task_338719->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_task_338719->free_mem_param_313179,
                                        .size =0, .references =NULL};
    int64_t x_331921 = futhark_mc_task_338719->free_x_331921;
    double x_331922 = futhark_mc_task_338719->free_x_331922;
    int64_t defunc_0_g_res_331925 =
            futhark_mc_task_338719->free_defunc_0_g_res_331925;
    double defunc_2_reduce_res_331926 =
           *futhark_mc_task_338719->retval_defunc_2_reduce_res_331926;
    double defunc_2_reduce_res_331927 =
           *futhark_mc_task_338719->retval_defunc_2_reduce_res_331927;
    double defunc_2_reduce_res_331928 =
           *futhark_mc_task_338719->retval_defunc_2_reduce_res_331928;
    double defunc_2_reduce_res_331929 =
           *futhark_mc_task_338719->retval_defunc_2_reduce_res_331929;
    double defunc_2_reduce_res_331930 =
           *futhark_mc_task_338719->retval_defunc_2_reduce_res_331930;
    size_t reduce_stage_1_tid_res_arr_mem_332326_cached_sizze_338721 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_332326 = NULL;
    size_t reduce_stage_1_tid_res_arr_mem_332328_cached_sizze_338722 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_332328 = NULL;
    size_t reduce_stage_1_tid_res_arr_mem_332330_cached_sizze_338723 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_332330 = NULL;
    size_t reduce_stage_1_tid_res_arr_mem_332332_cached_sizze_338724 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_332332 = NULL;
    size_t reduce_stage_1_tid_res_arr_mem_332334_cached_sizze_338725 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_332334 = NULL;
    
    if (reduce_stage_1_tid_res_arr_mem_332326_cached_sizze_338721 <
        (size_t) ((int64_t) 8 * num_tasks_332325)) {
        reduce_stage_1_tid_res_arr_mem_332326 =
            realloc(reduce_stage_1_tid_res_arr_mem_332326, (int64_t) 8 *
                    num_tasks_332325);
        reduce_stage_1_tid_res_arr_mem_332326_cached_sizze_338721 =
            (int64_t) 8 * num_tasks_332325;
    }
    if (reduce_stage_1_tid_res_arr_mem_332328_cached_sizze_338722 <
        (size_t) ((int64_t) 8 * num_tasks_332325)) {
        reduce_stage_1_tid_res_arr_mem_332328 =
            realloc(reduce_stage_1_tid_res_arr_mem_332328, (int64_t) 8 *
                    num_tasks_332325);
        reduce_stage_1_tid_res_arr_mem_332328_cached_sizze_338722 =
            (int64_t) 8 * num_tasks_332325;
    }
    if (reduce_stage_1_tid_res_arr_mem_332330_cached_sizze_338723 <
        (size_t) ((int64_t) 8 * num_tasks_332325)) {
        reduce_stage_1_tid_res_arr_mem_332330 =
            realloc(reduce_stage_1_tid_res_arr_mem_332330, (int64_t) 8 *
                    num_tasks_332325);
        reduce_stage_1_tid_res_arr_mem_332330_cached_sizze_338723 =
            (int64_t) 8 * num_tasks_332325;
    }
    if (reduce_stage_1_tid_res_arr_mem_332332_cached_sizze_338724 <
        (size_t) ((int64_t) 8 * num_tasks_332325)) {
        reduce_stage_1_tid_res_arr_mem_332332 =
            realloc(reduce_stage_1_tid_res_arr_mem_332332, (int64_t) 8 *
                    num_tasks_332325);
        reduce_stage_1_tid_res_arr_mem_332332_cached_sizze_338724 =
            (int64_t) 8 * num_tasks_332325;
    }
    if (reduce_stage_1_tid_res_arr_mem_332334_cached_sizze_338725 <
        (size_t) ((int64_t) 8 * num_tasks_332325)) {
        reduce_stage_1_tid_res_arr_mem_332334 =
            realloc(reduce_stage_1_tid_res_arr_mem_332334, (int64_t) 8 *
                    num_tasks_332325);
        reduce_stage_1_tid_res_arr_mem_332334_cached_sizze_338725 =
            (int64_t) 8 * num_tasks_332325;
    }
    
    int64_t iter_332336;
    struct futhark_mc_segred_stage_1_parloop_struct_338726
    futhark_mc_segred_stage_1_parloop_struct_338726;
    
    futhark_mc_segred_stage_1_parloop_struct_338726.ctx = ctx;
    futhark_mc_segred_stage_1_parloop_struct_338726.free_n_292675 = n_292675;
    futhark_mc_segred_stage_1_parloop_struct_338726.free_gtid_307188 =
        gtid_307188;
    futhark_mc_segred_stage_1_parloop_struct_338726.free_ctx_param_ext_313174 =
        ctx_param_ext_313174;
    futhark_mc_segred_stage_1_parloop_struct_338726.free_ctx_param_ext_313175 =
        ctx_param_ext_313175;
    futhark_mc_segred_stage_1_parloop_struct_338726.free_ctx_param_ext_313177 =
        ctx_param_ext_313177;
    futhark_mc_segred_stage_1_parloop_struct_338726.free_mem_param_313179 =
        mem_param_313179.mem;
    futhark_mc_segred_stage_1_parloop_struct_338726.free_x_331921 = x_331921;
    futhark_mc_segred_stage_1_parloop_struct_338726.free_x_331922 = x_331922;
    futhark_mc_segred_stage_1_parloop_struct_338726.free_defunc_0_g_res_331925 =
        defunc_0_g_res_331925;
    futhark_mc_segred_stage_1_parloop_struct_338726.free_reduce_stage_1_tid_res_arr_mem_332326 =
        reduce_stage_1_tid_res_arr_mem_332326;
    futhark_mc_segred_stage_1_parloop_struct_338726.free_reduce_stage_1_tid_res_arr_mem_332328 =
        reduce_stage_1_tid_res_arr_mem_332328;
    futhark_mc_segred_stage_1_parloop_struct_338726.free_reduce_stage_1_tid_res_arr_mem_332330 =
        reduce_stage_1_tid_res_arr_mem_332330;
    futhark_mc_segred_stage_1_parloop_struct_338726.free_reduce_stage_1_tid_res_arr_mem_332332 =
        reduce_stage_1_tid_res_arr_mem_332332;
    futhark_mc_segred_stage_1_parloop_struct_338726.free_reduce_stage_1_tid_res_arr_mem_332334 =
        reduce_stage_1_tid_res_arr_mem_332334;
    
    struct scheduler_parloop futhark_mc_segred_stage_1_parloop_338727_task;
    
    futhark_mc_segred_stage_1_parloop_338727_task.name =
        "futhark_mc_segred_stage_1_parloop_338727";
    futhark_mc_segred_stage_1_parloop_338727_task.fn =
        futhark_mc_segred_stage_1_parloop_338727;
    futhark_mc_segred_stage_1_parloop_338727_task.args =
        &futhark_mc_segred_stage_1_parloop_struct_338726;
    futhark_mc_segred_stage_1_parloop_338727_task.iterations = iterations;
    futhark_mc_segred_stage_1_parloop_338727_task.info = info;
    
    uint64_t futhark_mc_segred_stage_1_parloop_338727_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_338727_total_start = get_wall_time();
    
    int futhark_mc_segred_stage_1_parloop_338727_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segred_stage_1_parloop_338727_task);
    
    if (futhark_mc_segred_stage_1_parloop_338727_err != 0) {
        err = futhark_mc_segred_stage_1_parloop_338727_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_338727_total_end =
                 get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_338727_total_end -
                 futhark_mc_segred_stage_1_parloop_338727_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338727_total_runs,
                           1, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338727_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338727_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    // neutral-initialise the output
    {
        defunc_2_reduce_res_331926 = 0.0;
        defunc_2_reduce_res_331927 = 0.0;
        defunc_2_reduce_res_331928 = 0.0;
        defunc_2_reduce_res_331929 = 0.0;
        defunc_2_reduce_res_331930 = 0.0;
    }
    
    double x_332342;
    double x_332343;
    double x_332345;
    double x_332346;
    double x_332348;
    double x_332349;
    double x_332351;
    double x_332352;
    double x_332354;
    double x_332355;
    
    for (int32_t i_332357 = 0; i_332357 < num_tasks_332325; i_332357++) {
        flat_tid_332243 = i_332357;
        // Apply main thread reduction
        {
            // load acc params
            {
                x_332342 = defunc_2_reduce_res_331926;
            }
            // load next params
            {
                x_332343 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_332326)[flat_tid_332243];
            }
            // red body
            {
                double defunc_1_op_res_332344 = x_332342 + x_332343;
                
                defunc_2_reduce_res_331926 = defunc_1_op_res_332344;
            }
            // load acc params
            {
                x_332345 = defunc_2_reduce_res_331927;
            }
            // load next params
            {
                x_332346 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_332328)[flat_tid_332243];
            }
            // red body
            {
                double defunc_1_op_res_332347 = x_332345 + x_332346;
                
                defunc_2_reduce_res_331927 = defunc_1_op_res_332347;
            }
            // load acc params
            {
                x_332348 = defunc_2_reduce_res_331928;
            }
            // load next params
            {
                x_332349 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_332330)[flat_tid_332243];
            }
            // red body
            {
                double defunc_1_op_res_332350 = x_332348 + x_332349;
                
                defunc_2_reduce_res_331928 = defunc_1_op_res_332350;
            }
            // load acc params
            {
                x_332351 = defunc_2_reduce_res_331929;
            }
            // load next params
            {
                x_332352 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_332332)[flat_tid_332243];
            }
            // red body
            {
                double defunc_1_op_res_332353 = x_332351 + x_332352;
                
                defunc_2_reduce_res_331929 = defunc_1_op_res_332353;
            }
            // load acc params
            {
                x_332354 = defunc_2_reduce_res_331930;
            }
            // load next params
            {
                x_332355 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_332334)[flat_tid_332243];
            }
            // red body
            {
                double defunc_1_op_res_332356 = x_332354 + x_332355;
                
                defunc_2_reduce_res_331930 = defunc_1_op_res_332356;
            }
        }
    }
    
  cleanup:
    {
        free(reduce_stage_1_tid_res_arr_mem_332326);
        free(reduce_stage_1_tid_res_arr_mem_332328);
        free(reduce_stage_1_tid_res_arr_mem_332330);
        free(reduce_stage_1_tid_res_arr_mem_332332);
        free(reduce_stage_1_tid_res_arr_mem_332334);
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_task_338720_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_task_338720_end -
                 futhark_mc_segred_task_338720_start;
        
        ctx->futhark_mc_segred_task_338720_runs[tid]++;
        ctx->futhark_mc_segred_task_338720_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segred_task_338720_iter[tid] += iterations;
    }
    if (err == 0) {
        *futhark_mc_task_338719->retval_defunc_2_reduce_res_331926 =
            defunc_2_reduce_res_331926;
        *futhark_mc_task_338719->retval_defunc_2_reduce_res_331927 =
            defunc_2_reduce_res_331927;
        *futhark_mc_task_338719->retval_defunc_2_reduce_res_331928 =
            defunc_2_reduce_res_331928;
        *futhark_mc_task_338719->retval_defunc_2_reduce_res_331929 =
            defunc_2_reduce_res_331929;
        *futhark_mc_task_338719->retval_defunc_2_reduce_res_331930 =
            defunc_2_reduce_res_331930;
    }
    return err;
}
struct futhark_mc_task_338728 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_307188;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315021;
    int64_t free_x_331921;
    double free_x_331922;
    int64_t free_defunc_0_g_res_331925;
    double free_a12_331994;
    double free_b12_331995;
    double free_c12_331996;
    double free_b2_331997;
    double free_c2_331998;
    double *retval_defunc_2_reduce_res_331999;
    double *retval_defunc_2_reduce_res_332000;
};
struct futhark_mc_segred_stage_1_parloop_struct_338732 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_307188;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315021;
    int64_t free_x_331921;
    double free_x_331922;
    int64_t free_defunc_0_g_res_331925;
    double free_a12_331994;
    double free_b12_331995;
    double free_c12_331996;
    double free_b2_331997;
    double free_c2_331998;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_332359;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_332361;
};
static int futhark_mc_segred_stage_1_parloop_338733(void *args, int64_t start,
                                                    int64_t end,
                                                    int flat_tid_332281,
                                                    int tid)
{
    int err = 0;
    struct futhark_mc_segred_stage_1_parloop_struct_338732
    *futhark_mc_segred_stage_1_parloop_struct_338732 =
    (struct futhark_mc_segred_stage_1_parloop_struct_338732 *) args;
    struct futhark_context *ctx =
                           futhark_mc_segred_stage_1_parloop_struct_338732->ctx;
    uint64_t futhark_mc_segred_stage_1_parloop_338733_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_338733_start = get_wall_time();
    
    int64_t n_292675 =
            futhark_mc_segred_stage_1_parloop_struct_338732->free_n_292675;
    int64_t gtid_307188 =
            futhark_mc_segred_stage_1_parloop_struct_338732->free_gtid_307188;
    int64_t ctx_param_ext_313174 =
            futhark_mc_segred_stage_1_parloop_struct_338732->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_segred_stage_1_parloop_struct_338732->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_segred_stage_1_parloop_struct_338732->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_segred_stage_1_parloop_struct_338732->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315021 = {.desc ="mem_315021", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_338732->free_mem_315021,
                                  .size =0, .references =NULL};
    int64_t x_331921 =
            futhark_mc_segred_stage_1_parloop_struct_338732->free_x_331921;
    double x_331922 =
           futhark_mc_segred_stage_1_parloop_struct_338732->free_x_331922;
    int64_t defunc_0_g_res_331925 =
            futhark_mc_segred_stage_1_parloop_struct_338732->free_defunc_0_g_res_331925;
    double a12_331994 =
           futhark_mc_segred_stage_1_parloop_struct_338732->free_a12_331994;
    double b12_331995 =
           futhark_mc_segred_stage_1_parloop_struct_338732->free_b12_331995;
    double c12_331996 =
           futhark_mc_segred_stage_1_parloop_struct_338732->free_c12_331996;
    double b2_331997 =
           futhark_mc_segred_stage_1_parloop_struct_338732->free_b2_331997;
    double c2_331998 =
           futhark_mc_segred_stage_1_parloop_struct_338732->free_c2_331998;
    struct memblock reduce_stage_1_tid_res_arr_mem_332359 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_332359",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338732->free_reduce_stage_1_tid_res_arr_mem_332359,
                                                             .size =0,
                                                             .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_332361 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_332361",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338732->free_reduce_stage_1_tid_res_arr_mem_332361,
                                                             .size =0,
                                                             .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_332363 = start;
    double x_332283;
    double x_332284;
    double x_332286;
    double x_332287;
    double local_acc_332364 = 0.0;
    double local_acc_332365 = 0.0;
    
    for (; iter_332363 < end; iter_332363++) {
        int64_t gtid_332282 = iter_332363;
        bool cond_332289 = sle64(n_292675, gtid_332282);
        int64_t defunc_0_f_res_332290;
        
        if (cond_332289) {
            defunc_0_f_res_332290 = (int64_t) 0;
        } else {
            int64_t i_332291 = add64(x_331921, gtid_332282);
            int64_t defunc_1_add_res_332292 = add64((int64_t) 1, i_332291);
            
            defunc_0_f_res_332290 = defunc_1_add_res_332292;
        }
        
        double defunc_0_f_res_332293;
        
        if (cond_332289) {
            defunc_0_f_res_332293 = 0.0;
        } else {
            int64_t i_332294 = add64(x_331921, gtid_332282);
            double defunc_0_add_arg_332295;
            
            defunc_0_add_arg_332295 =
                ((double *) mem_param_313179.mem)[ctx_param_ext_313174 +
                                                  (gtid_307188 *
                                                   ctx_param_ext_313175 +
                                                   i_332294 *
                                                   ctx_param_ext_313177)];
            defunc_0_f_res_332293 = defunc_0_add_arg_332295;
        }
        
        int64_t binop_p_332296 = sub64(defunc_0_f_res_332290,
                                       defunc_0_g_res_331925);
        double defunc_0_f_res_332297 = sitofp_i64_f64(binop_p_332296);
        double abs_res_332298 = fabs(defunc_0_f_res_332297);
        double tmp1_332299 = abs_res_332298 / x_331922;
        double x_332300 = tmp1_332299 * tmp1_332299;
        double y_332301 = tmp1_332299 * x_332300;
        double tmp2_332302 = 1.0 - y_332301;
        double x_332303 = tmp2_332302 * tmp2_332302;
        double tmp3_332304 = tmp2_332302 * x_332303;
        double tmp4_332305 = defunc_0_f_res_332293 * tmp3_332304;
        double defunc_1_f_res_332306 = defunc_0_f_res_332297 * tmp4_332305;
        double defunc_1_f_res_332307 = defunc_0_f_res_332297 *
               defunc_1_f_res_332306;
        double defunc_0_f_res_332308;
        
        if (cond_332289) {
            defunc_0_f_res_332308 = 0.0;
        } else {
            int64_t i_332309 = add64(x_331921, gtid_332282);
            double defunc_0_add_arg_332310;
            
            defunc_0_add_arg_332310 = ((double *) mem_315021.mem)[gtid_307188 *
                                                                  n_292675 +
                                                                  i_332309];
            defunc_0_f_res_332308 = defunc_0_add_arg_332310;
        }
        
        double x_332311 = a12_331994 * tmp4_332305;
        double y_332312 = b12_331995 * defunc_1_f_res_332306;
        double x_332313 = x_332311 + y_332312;
        double y_332314 = c12_331996 * defunc_1_f_res_332307;
        double x_332315 = x_332313 + y_332314;
        double defunc_9_fit_fun_res_332316 = defunc_0_f_res_332308 * x_332315;
        double x_332317 = b12_331995 * tmp4_332305;
        double y_332318 = b2_331997 * defunc_1_f_res_332306;
        double x_332319 = x_332317 + y_332318;
        double y_332320 = c2_331998 * defunc_1_f_res_332307;
        double x_332321 = x_332319 + y_332320;
        double defunc_9_slope_fun_res_332322 = defunc_0_f_res_332308 * x_332321;
        
        // save map-out results
        { }
        // Load accum params
        {
            x_332283 = local_acc_332364;
        }
        // Load next params
        {
            x_332284 = defunc_9_fit_fun_res_332316;
        }
        // Red body
        {
            double defunc_1_op_res_332285 = x_332283 + x_332284;
            
            local_acc_332364 = defunc_1_op_res_332285;
        }
        // Load accum params
        {
            x_332286 = local_acc_332365;
        }
        // Load next params
        {
            x_332287 = defunc_9_slope_fun_res_332322;
        }
        // Red body
        {
            double defunc_1_op_res_332288 = x_332286 + x_332287;
            
            local_acc_332365 = defunc_1_op_res_332288;
        }
    }
    ((double *) reduce_stage_1_tid_res_arr_mem_332359.mem)[flat_tid_332281] =
        local_acc_332364;
    ((double *) reduce_stage_1_tid_res_arr_mem_332361.mem)[flat_tid_332281] =
        local_acc_332365;
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_338733_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_338733_end -
                 futhark_mc_segred_stage_1_parloop_338733_start;
        
        ctx->futhark_mc_segred_stage_1_parloop_338733_runs[tid]++;
        ctx->futhark_mc_segred_stage_1_parloop_338733_total_runtime[tid] +=
            elapsed;
        ctx->futhark_mc_segred_stage_1_parloop_338733_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segred_task_338729(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_332281 = tid;
    int num_tasks_332358 = info.nsubtasks;
    struct futhark_mc_task_338728 *futhark_mc_task_338728 =
                                  (struct futhark_mc_task_338728 *) args;
    struct futhark_context *ctx = futhark_mc_task_338728->ctx;
    uint64_t futhark_mc_segred_task_338729_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_task_338729_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338728->free_n_292675;
    int64_t gtid_307188 = futhark_mc_task_338728->free_gtid_307188;
    int64_t ctx_param_ext_313174 =
            futhark_mc_task_338728->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_task_338728->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_task_338728->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_task_338728->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315021 = {.desc ="mem_315021", .mem =
                                  futhark_mc_task_338728->free_mem_315021,
                                  .size =0, .references =NULL};
    int64_t x_331921 = futhark_mc_task_338728->free_x_331921;
    double x_331922 = futhark_mc_task_338728->free_x_331922;
    int64_t defunc_0_g_res_331925 =
            futhark_mc_task_338728->free_defunc_0_g_res_331925;
    double a12_331994 = futhark_mc_task_338728->free_a12_331994;
    double b12_331995 = futhark_mc_task_338728->free_b12_331995;
    double c12_331996 = futhark_mc_task_338728->free_c12_331996;
    double b2_331997 = futhark_mc_task_338728->free_b2_331997;
    double c2_331998 = futhark_mc_task_338728->free_c2_331998;
    double defunc_2_reduce_res_331999 =
           *futhark_mc_task_338728->retval_defunc_2_reduce_res_331999;
    double defunc_2_reduce_res_332000 =
           *futhark_mc_task_338728->retval_defunc_2_reduce_res_332000;
    size_t reduce_stage_1_tid_res_arr_mem_332359_cached_sizze_338730 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_332359 = NULL;
    size_t reduce_stage_1_tid_res_arr_mem_332361_cached_sizze_338731 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_332361 = NULL;
    
    if (reduce_stage_1_tid_res_arr_mem_332359_cached_sizze_338730 <
        (size_t) ((int64_t) 8 * num_tasks_332358)) {
        reduce_stage_1_tid_res_arr_mem_332359 =
            realloc(reduce_stage_1_tid_res_arr_mem_332359, (int64_t) 8 *
                    num_tasks_332358);
        reduce_stage_1_tid_res_arr_mem_332359_cached_sizze_338730 =
            (int64_t) 8 * num_tasks_332358;
    }
    if (reduce_stage_1_tid_res_arr_mem_332361_cached_sizze_338731 <
        (size_t) ((int64_t) 8 * num_tasks_332358)) {
        reduce_stage_1_tid_res_arr_mem_332361 =
            realloc(reduce_stage_1_tid_res_arr_mem_332361, (int64_t) 8 *
                    num_tasks_332358);
        reduce_stage_1_tid_res_arr_mem_332361_cached_sizze_338731 =
            (int64_t) 8 * num_tasks_332358;
    }
    
    int64_t iter_332363;
    struct futhark_mc_segred_stage_1_parloop_struct_338732
    futhark_mc_segred_stage_1_parloop_struct_338732;
    
    futhark_mc_segred_stage_1_parloop_struct_338732.ctx = ctx;
    futhark_mc_segred_stage_1_parloop_struct_338732.free_n_292675 = n_292675;
    futhark_mc_segred_stage_1_parloop_struct_338732.free_gtid_307188 =
        gtid_307188;
    futhark_mc_segred_stage_1_parloop_struct_338732.free_ctx_param_ext_313174 =
        ctx_param_ext_313174;
    futhark_mc_segred_stage_1_parloop_struct_338732.free_ctx_param_ext_313175 =
        ctx_param_ext_313175;
    futhark_mc_segred_stage_1_parloop_struct_338732.free_ctx_param_ext_313177 =
        ctx_param_ext_313177;
    futhark_mc_segred_stage_1_parloop_struct_338732.free_mem_param_313179 =
        mem_param_313179.mem;
    futhark_mc_segred_stage_1_parloop_struct_338732.free_mem_315021 =
        mem_315021.mem;
    futhark_mc_segred_stage_1_parloop_struct_338732.free_x_331921 = x_331921;
    futhark_mc_segred_stage_1_parloop_struct_338732.free_x_331922 = x_331922;
    futhark_mc_segred_stage_1_parloop_struct_338732.free_defunc_0_g_res_331925 =
        defunc_0_g_res_331925;
    futhark_mc_segred_stage_1_parloop_struct_338732.free_a12_331994 =
        a12_331994;
    futhark_mc_segred_stage_1_parloop_struct_338732.free_b12_331995 =
        b12_331995;
    futhark_mc_segred_stage_1_parloop_struct_338732.free_c12_331996 =
        c12_331996;
    futhark_mc_segred_stage_1_parloop_struct_338732.free_b2_331997 = b2_331997;
    futhark_mc_segred_stage_1_parloop_struct_338732.free_c2_331998 = c2_331998;
    futhark_mc_segred_stage_1_parloop_struct_338732.free_reduce_stage_1_tid_res_arr_mem_332359 =
        reduce_stage_1_tid_res_arr_mem_332359;
    futhark_mc_segred_stage_1_parloop_struct_338732.free_reduce_stage_1_tid_res_arr_mem_332361 =
        reduce_stage_1_tid_res_arr_mem_332361;
    
    struct scheduler_parloop futhark_mc_segred_stage_1_parloop_338733_task;
    
    futhark_mc_segred_stage_1_parloop_338733_task.name =
        "futhark_mc_segred_stage_1_parloop_338733";
    futhark_mc_segred_stage_1_parloop_338733_task.fn =
        futhark_mc_segred_stage_1_parloop_338733;
    futhark_mc_segred_stage_1_parloop_338733_task.args =
        &futhark_mc_segred_stage_1_parloop_struct_338732;
    futhark_mc_segred_stage_1_parloop_338733_task.iterations = iterations;
    futhark_mc_segred_stage_1_parloop_338733_task.info = info;
    
    uint64_t futhark_mc_segred_stage_1_parloop_338733_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_338733_total_start = get_wall_time();
    
    int futhark_mc_segred_stage_1_parloop_338733_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segred_stage_1_parloop_338733_task);
    
    if (futhark_mc_segred_stage_1_parloop_338733_err != 0) {
        err = futhark_mc_segred_stage_1_parloop_338733_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_338733_total_end =
                 get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_338733_total_end -
                 futhark_mc_segred_stage_1_parloop_338733_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338733_total_runs,
                           1, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338733_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338733_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    // neutral-initialise the output
    {
        defunc_2_reduce_res_331999 = 0.0;
        defunc_2_reduce_res_332000 = 0.0;
    }
    
    double x_332366;
    double x_332367;
    double x_332369;
    double x_332370;
    
    for (int32_t i_332372 = 0; i_332372 < num_tasks_332358; i_332372++) {
        flat_tid_332281 = i_332372;
        // Apply main thread reduction
        {
            // load acc params
            {
                x_332366 = defunc_2_reduce_res_331999;
            }
            // load next params
            {
                x_332367 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_332359)[flat_tid_332281];
            }
            // red body
            {
                double defunc_1_op_res_332368 = x_332366 + x_332367;
                
                defunc_2_reduce_res_331999 = defunc_1_op_res_332368;
            }
            // load acc params
            {
                x_332369 = defunc_2_reduce_res_332000;
            }
            // load next params
            {
                x_332370 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_332361)[flat_tid_332281];
            }
            // red body
            {
                double defunc_1_op_res_332371 = x_332369 + x_332370;
                
                defunc_2_reduce_res_332000 = defunc_1_op_res_332371;
            }
        }
    }
    
  cleanup:
    {
        free(reduce_stage_1_tid_res_arr_mem_332359);
        free(reduce_stage_1_tid_res_arr_mem_332361);
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_task_338729_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_task_338729_end -
                 futhark_mc_segred_task_338729_start;
        
        ctx->futhark_mc_segred_task_338729_runs[tid]++;
        ctx->futhark_mc_segred_task_338729_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segred_task_338729_iter[tid] += iterations;
    }
    if (err == 0) {
        *futhark_mc_task_338728->retval_defunc_2_reduce_res_331999 =
            defunc_2_reduce_res_331999;
        *futhark_mc_task_338728->retval_defunc_2_reduce_res_332000 =
            defunc_2_reduce_res_332000;
    }
    return err;
}
static int futhark_mc_segmap_parloop_338718(void *args, int64_t start,
                                            int64_t end, int flat_tid_331919,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338717
    *futhark_mc_segmap_parloop_struct_338717 =
    (struct futhark_mc_segmap_parloop_struct_338717 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338717->ctx;
    uint64_t futhark_mc_segmap_parloop_338718_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338718_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_338717->free_n_292675;
    int64_t q_l_292680 =
            futhark_mc_segmap_parloop_struct_338717->free_q_l_292680;
    int64_t jump_t_292685 =
            futhark_mc_segmap_parloop_struct_338717->free_jump_t_292685;
    int64_t l_n_m_292832 =
            futhark_mc_segmap_parloop_struct_338717->free_l_n_m_292832;
    int64_t i_292846 = futhark_mc_segmap_parloop_struct_338717->free_i_292846;
    int64_t gtid_307188 =
            futhark_mc_segmap_parloop_struct_338717->free_gtid_307188;
    struct memblock mem_313081 = {.desc ="mem_313081", .mem =
                                  futhark_mc_segmap_parloop_struct_338717->free_mem_313081,
                                  .size =0, .references =NULL};
    struct memblock mem_313085 = {.desc ="mem_313085", .mem =
                                  futhark_mc_segmap_parloop_struct_338717->free_mem_313085,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_segmap_parloop_struct_338717->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_segmap_parloop_struct_338717->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_segmap_parloop_struct_338717->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_segmap_parloop_struct_338717->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315021 = {.desc ="mem_315021", .mem =
                                  futhark_mc_segmap_parloop_struct_338717->free_mem_315021,
                                  .size =0, .references =NULL};
    struct memblock mem_315561 = {.desc ="mem_315561", .mem =
                                  futhark_mc_segmap_parloop_struct_338717->free_mem_315561,
                                  .size =0, .references =NULL};
    struct memblock mem_315564 = {.desc ="mem_315564", .mem =
                                  futhark_mc_segmap_parloop_struct_338717->free_mem_315564,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_332242 = start;
    
    for (; iter_332242 < end; iter_332242++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_332323 = l_n_m_292832;
        int64_t gtid_331920 = iter_332242;
        int64_t remnant_332324 = iter_332242 - gtid_331920;
        int64_t x_331921;
        
        x_331921 = ((int64_t *) mem_313081.mem)[gtid_307188 * l_n_m_292832 +
                                                gtid_331920];
        
        double x_331922;
        
        x_331922 = ((double *) mem_313085.mem)[gtid_307188 * l_n_m_292832 +
                                               gtid_331920];
        
        int64_t min_arg_331923 = mul64(jump_t_292685, gtid_331920);
        int64_t min_res_331924 = smin64(i_292846, min_arg_331923);
        int64_t defunc_0_g_res_331925 = add64((int64_t) 1, min_res_331924);
        double defunc_2_reduce_res_331926;
        double defunc_2_reduce_res_331927;
        double defunc_2_reduce_res_331928;
        double defunc_2_reduce_res_331929;
        double defunc_2_reduce_res_331930;
        int64_t flat_tid_332243 = (int64_t) 0;
        int32_t num_tasks_332325;
        
        defunc_2_reduce_res_331926 = 0.0;
        defunc_2_reduce_res_331927 = 0.0;
        defunc_2_reduce_res_331928 = 0.0;
        defunc_2_reduce_res_331929 = 0.0;
        defunc_2_reduce_res_331930 = 0.0;
        
        struct futhark_mc_task_338719 futhark_mc_task_338719;
        
        futhark_mc_task_338719.ctx = ctx;
        futhark_mc_task_338719.free_n_292675 = n_292675;
        futhark_mc_task_338719.free_gtid_307188 = gtid_307188;
        futhark_mc_task_338719.free_ctx_param_ext_313174 = ctx_param_ext_313174;
        futhark_mc_task_338719.free_ctx_param_ext_313175 = ctx_param_ext_313175;
        futhark_mc_task_338719.free_ctx_param_ext_313177 = ctx_param_ext_313177;
        futhark_mc_task_338719.free_mem_param_313179 = mem_param_313179.mem;
        futhark_mc_task_338719.free_x_331921 = x_331921;
        futhark_mc_task_338719.free_x_331922 = x_331922;
        futhark_mc_task_338719.free_defunc_0_g_res_331925 =
            defunc_0_g_res_331925;
        futhark_mc_task_338719.retval_defunc_2_reduce_res_331926 =
            &defunc_2_reduce_res_331926;
        futhark_mc_task_338719.retval_defunc_2_reduce_res_331927 =
            &defunc_2_reduce_res_331927;
        futhark_mc_task_338719.retval_defunc_2_reduce_res_331928 =
            &defunc_2_reduce_res_331928;
        futhark_mc_task_338719.retval_defunc_2_reduce_res_331929 =
            &defunc_2_reduce_res_331929;
        futhark_mc_task_338719.retval_defunc_2_reduce_res_331930 =
            &defunc_2_reduce_res_331930;
        
        struct scheduler_segop futhark_mc_task_338719_task;
        
        futhark_mc_task_338719_task.args = &futhark_mc_task_338719;
        futhark_mc_task_338719_task.top_level_fn =
            futhark_mc_segred_task_338720;
        futhark_mc_task_338719_task.name = "futhark_mc_segred_task_338720";
        futhark_mc_task_338719_task.iterations = q_l_292680;
        futhark_mc_task_338719_task.task_time =
            &ctx->futhark_mc_segred_task_338720_total_time;
        futhark_mc_task_338719_task.task_iter =
            &ctx->futhark_mc_segred_task_338720_total_iter;
        futhark_mc_task_338719_task.sched = STATIC;
        futhark_mc_task_338719_task.nested_fn = NULL;
        
        int futhark_mc_segred_task_338720_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_338719_task);
        
        if (futhark_mc_segred_task_338720_err != 0) {
            ;
            err = futhark_mc_segred_task_338720_err;
            goto cleanup;
        }
        
        double a_331969 = 2.220446049250313e-16 + defunc_2_reduce_res_331926;
        double b_331970 = 2.220446049250313e-16 + defunc_2_reduce_res_331927;
        double c_331971 = 2.220446049250313e-16 + defunc_2_reduce_res_331928;
        double d_331972 = 2.220446049250313e-16 + defunc_2_reduce_res_331929;
        double e_331973 = 2.220446049250313e-16 + defunc_2_reduce_res_331930;
        double x_331974 = c_331971 * e_331973;
        double y_331975 = d_331972 * d_331972;
        double a12_331976 = x_331974 - y_331975;
        double x_331977 = c_331971 * d_331972;
        double y_331978 = b_331970 * e_331973;
        double b12_331979 = x_331977 - y_331978;
        double x_331980 = b_331970 * d_331972;
        double y_331981 = c_331971 * c_331971;
        double c12_331982 = x_331980 - y_331981;
        double x_331983 = a_331969 * e_331973;
        double b2_331984 = x_331983 - y_331981;
        double x_331985 = b_331970 * c_331971;
        double y_331986 = a_331969 * d_331972;
        double c2_331987 = x_331985 - y_331986;
        double x_331988 = a_331969 * a12_331976;
        double y_331989 = b_331970 * b12_331979;
        double x_331990 = x_331988 + y_331989;
        double y_331991 = c_331971 * c12_331982;
        double y_331992 = x_331990 + y_331991;
        double det_331993 = 1.0 / y_331992;
        double a12_331994 = a12_331976 * det_331993;
        double b12_331995 = b12_331979 * det_331993;
        double c12_331996 = c12_331982 * det_331993;
        double b2_331997 = b2_331984 * det_331993;
        double c2_331998 = c2_331987 * det_331993;
        double defunc_2_reduce_res_331999;
        double defunc_2_reduce_res_332000;
        int64_t flat_tid_332281 = (int64_t) 0;
        int32_t num_tasks_332358;
        
        defunc_2_reduce_res_331999 = 0.0;
        defunc_2_reduce_res_332000 = 0.0;
        
        struct futhark_mc_task_338728 futhark_mc_task_338728;
        
        futhark_mc_task_338728.ctx = ctx;
        futhark_mc_task_338728.free_n_292675 = n_292675;
        futhark_mc_task_338728.free_gtid_307188 = gtid_307188;
        futhark_mc_task_338728.free_ctx_param_ext_313174 = ctx_param_ext_313174;
        futhark_mc_task_338728.free_ctx_param_ext_313175 = ctx_param_ext_313175;
        futhark_mc_task_338728.free_ctx_param_ext_313177 = ctx_param_ext_313177;
        futhark_mc_task_338728.free_mem_param_313179 = mem_param_313179.mem;
        futhark_mc_task_338728.free_mem_315021 = mem_315021.mem;
        futhark_mc_task_338728.free_x_331921 = x_331921;
        futhark_mc_task_338728.free_x_331922 = x_331922;
        futhark_mc_task_338728.free_defunc_0_g_res_331925 =
            defunc_0_g_res_331925;
        futhark_mc_task_338728.free_a12_331994 = a12_331994;
        futhark_mc_task_338728.free_b12_331995 = b12_331995;
        futhark_mc_task_338728.free_c12_331996 = c12_331996;
        futhark_mc_task_338728.free_b2_331997 = b2_331997;
        futhark_mc_task_338728.free_c2_331998 = c2_331998;
        futhark_mc_task_338728.retval_defunc_2_reduce_res_331999 =
            &defunc_2_reduce_res_331999;
        futhark_mc_task_338728.retval_defunc_2_reduce_res_332000 =
            &defunc_2_reduce_res_332000;
        
        struct scheduler_segop futhark_mc_task_338728_task;
        
        futhark_mc_task_338728_task.args = &futhark_mc_task_338728;
        futhark_mc_task_338728_task.top_level_fn =
            futhark_mc_segred_task_338729;
        futhark_mc_task_338728_task.name = "futhark_mc_segred_task_338729";
        futhark_mc_task_338728_task.iterations = q_l_292680;
        futhark_mc_task_338728_task.task_time =
            &ctx->futhark_mc_segred_task_338729_total_time;
        futhark_mc_task_338728_task.task_iter =
            &ctx->futhark_mc_segred_task_338729_total_iter;
        futhark_mc_task_338728_task.sched = STATIC;
        futhark_mc_task_338728_task.nested_fn = NULL;
        
        int futhark_mc_segred_task_338729_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_338728_task);
        
        if (futhark_mc_segred_task_338729_err != 0) {
            ;
            err = futhark_mc_segred_task_338729_err;
            goto cleanup;
        }
        ((double *) mem_315561.mem)[gtid_331920] = defunc_2_reduce_res_331999;
        ((double *) mem_315564.mem)[gtid_331920] = defunc_2_reduce_res_332000;
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338718_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338718_end -
                 futhark_mc_segmap_parloop_338718_start;
        
        ctx->futhark_mc_segmap_parloop_338718_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338718_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338718_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_nested_task_338716(void *args, int64_t iterations,
                                         int tid, struct scheduler_info info)
{
    int err = 0;
    int flat_tid_331919 = tid;
    int num_tasks_332160 = info.nsubtasks;
    struct futhark_mc_task_338712 *futhark_mc_task_338712 =
                                  (struct futhark_mc_task_338712 *) args;
    struct futhark_context *ctx = futhark_mc_task_338712->ctx;
    uint64_t futhark_mc_segmap_nested_task_338716_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_nested_task_338716_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338712->free_n_292675;
    int64_t q_l_292680 = futhark_mc_task_338712->free_q_l_292680;
    int64_t jump_t_292685 = futhark_mc_task_338712->free_jump_t_292685;
    int64_t l_n_m_292832 = futhark_mc_task_338712->free_l_n_m_292832;
    int64_t i_292846 = futhark_mc_task_338712->free_i_292846;
    int64_t gtid_307188 = futhark_mc_task_338712->free_gtid_307188;
    struct memblock mem_313081 = {.desc ="mem_313081", .mem =
                                  futhark_mc_task_338712->free_mem_313081,
                                  .size =0, .references =NULL};
    struct memblock mem_313085 = {.desc ="mem_313085", .mem =
                                  futhark_mc_task_338712->free_mem_313085,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_task_338712->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_task_338712->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_task_338712->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_task_338712->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315021 = {.desc ="mem_315021", .mem =
                                  futhark_mc_task_338712->free_mem_315021,
                                  .size =0, .references =NULL};
    struct memblock mem_315561 = {.desc ="mem_315561", .mem =
                                  futhark_mc_task_338712->free_mem_315561,
                                  .size =0, .references =NULL};
    struct memblock mem_315564 = {.desc ="mem_315564", .mem =
                                  futhark_mc_task_338712->free_mem_315564,
                                  .size =0, .references =NULL};
    int64_t iter_332242;
    struct futhark_mc_segmap_parloop_struct_338717
    futhark_mc_segmap_parloop_struct_338717;
    
    futhark_mc_segmap_parloop_struct_338717.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338717.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_338717.free_q_l_292680 = q_l_292680;
    futhark_mc_segmap_parloop_struct_338717.free_jump_t_292685 = jump_t_292685;
    futhark_mc_segmap_parloop_struct_338717.free_l_n_m_292832 = l_n_m_292832;
    futhark_mc_segmap_parloop_struct_338717.free_i_292846 = i_292846;
    futhark_mc_segmap_parloop_struct_338717.free_gtid_307188 = gtid_307188;
    futhark_mc_segmap_parloop_struct_338717.free_mem_313081 = mem_313081.mem;
    futhark_mc_segmap_parloop_struct_338717.free_mem_313085 = mem_313085.mem;
    futhark_mc_segmap_parloop_struct_338717.free_ctx_param_ext_313174 =
        ctx_param_ext_313174;
    futhark_mc_segmap_parloop_struct_338717.free_ctx_param_ext_313175 =
        ctx_param_ext_313175;
    futhark_mc_segmap_parloop_struct_338717.free_ctx_param_ext_313177 =
        ctx_param_ext_313177;
    futhark_mc_segmap_parloop_struct_338717.free_mem_param_313179 =
        mem_param_313179.mem;
    futhark_mc_segmap_parloop_struct_338717.free_mem_315021 = mem_315021.mem;
    futhark_mc_segmap_parloop_struct_338717.free_mem_315561 = mem_315561.mem;
    futhark_mc_segmap_parloop_struct_338717.free_mem_315564 = mem_315564.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338718_task;
    
    futhark_mc_segmap_parloop_338718_task.name =
        "futhark_mc_segmap_parloop_338718";
    futhark_mc_segmap_parloop_338718_task.fn = futhark_mc_segmap_parloop_338718;
    futhark_mc_segmap_parloop_338718_task.args =
        &futhark_mc_segmap_parloop_struct_338717;
    futhark_mc_segmap_parloop_338718_task.iterations = iterations;
    futhark_mc_segmap_parloop_338718_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338718_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338718_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338718_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338718_task);
    
    if (futhark_mc_segmap_parloop_338718_err != 0) {
        err = futhark_mc_segmap_parloop_338718_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338718_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338718_total_end -
                 futhark_mc_segmap_parloop_338718_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338718_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338718_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338718_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_nested_task_338716_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_nested_task_338716_end -
                 futhark_mc_segmap_nested_task_338716_start;
        
        ctx->futhark_mc_segmap_nested_task_338716_runs[tid]++;
        ctx->futhark_mc_segmap_nested_task_338716_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_nested_task_338716_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
static int futhark_mc_segmap_parloop_338709(void *args, int64_t start,
                                            int64_t end, int flat_tid_307187,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338708
    *futhark_mc_segmap_parloop_struct_338708 =
    (struct futhark_mc_segmap_parloop_struct_338708 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338708->ctx;
    uint64_t futhark_mc_segmap_parloop_338709_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338709_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_338708->free_n_292675;
    int64_t q_l_292680 =
            futhark_mc_segmap_parloop_struct_338708->free_q_l_292680;
    int64_t jump_t_292685 =
            futhark_mc_segmap_parloop_struct_338708->free_jump_t_292685;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_338708->free_partition_sizze_292766;
    int64_t l_n_m_292832 =
            futhark_mc_segmap_parloop_struct_338708->free_l_n_m_292832;
    int64_t i_292846 = futhark_mc_segmap_parloop_struct_338708->free_i_292846;
    int64_t bytes_313028 =
            futhark_mc_segmap_parloop_struct_338708->free_bytes_313028;
    struct memblock mem_313081 = {.desc ="mem_313081", .mem =
                                  futhark_mc_segmap_parloop_struct_338708->free_mem_313081,
                                  .size =0, .references =NULL};
    struct memblock mem_313085 = {.desc ="mem_313085", .mem =
                                  futhark_mc_segmap_parloop_struct_338708->free_mem_313085,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_segmap_parloop_struct_338708->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_segmap_parloop_struct_338708->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_segmap_parloop_struct_338708->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_segmap_parloop_struct_338708->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315021 = {.desc ="mem_315021", .mem =
                                  futhark_mc_segmap_parloop_struct_338708->free_mem_315021,
                                  .size =0, .references =NULL};
    struct memblock mem_315598 = {.desc ="mem_315598", .mem =
                                  futhark_mc_segmap_parloop_struct_338708->free_mem_315598,
                                  .size =0, .references =NULL};
    struct memblock mem_315602 = {.desc ="mem_315602", .mem =
                                  futhark_mc_segmap_parloop_struct_338708->free_mem_315602,
                                  .size =0, .references =NULL};
    size_t mem_315561_cached_sizze_338710 = 0;
    unsigned char *mem_315561 = NULL;
    size_t mem_315564_cached_sizze_338711 = 0;
    unsigned char *mem_315564 = NULL;
    int64_t iterations = end - start;
    int64_t iter_331918 = start;
    
    if (mem_315561_cached_sizze_338710 < (size_t) bytes_313028) {
        mem_315561 = realloc(mem_315561, bytes_313028);
        mem_315561_cached_sizze_338710 = bytes_313028;
    }
    if (mem_315564_cached_sizze_338711 < (size_t) bytes_313028) {
        mem_315564 = realloc(mem_315564, bytes_313028);
        mem_315564_cached_sizze_338711 = bytes_313028;
    }
    for (; iter_331918 < end; iter_331918++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_332158 = partition_sizze_292766;
        int64_t gtid_307188 = iter_331918;
        int64_t remnant_332159 = iter_331918 - gtid_307188;
        int64_t flat_tid_332043 = (int64_t) 0;
        int32_t num_tasks_332160;
        int64_t flat_tid_331919 = (int64_t) 0;
        struct futhark_mc_task_338712 futhark_mc_task_338712;
        
        futhark_mc_task_338712.ctx = ctx;
        futhark_mc_task_338712.free_n_292675 = n_292675;
        futhark_mc_task_338712.free_q_l_292680 = q_l_292680;
        futhark_mc_task_338712.free_jump_t_292685 = jump_t_292685;
        futhark_mc_task_338712.free_l_n_m_292832 = l_n_m_292832;
        futhark_mc_task_338712.free_i_292846 = i_292846;
        futhark_mc_task_338712.free_gtid_307188 = gtid_307188;
        futhark_mc_task_338712.free_mem_313081 = mem_313081.mem;
        futhark_mc_task_338712.free_mem_313085 = mem_313085.mem;
        futhark_mc_task_338712.free_ctx_param_ext_313174 = ctx_param_ext_313174;
        futhark_mc_task_338712.free_ctx_param_ext_313175 = ctx_param_ext_313175;
        futhark_mc_task_338712.free_ctx_param_ext_313177 = ctx_param_ext_313177;
        futhark_mc_task_338712.free_mem_param_313179 = mem_param_313179.mem;
        futhark_mc_task_338712.free_mem_315021 = mem_315021.mem;
        futhark_mc_task_338712.free_mem_315561 = mem_315561;
        futhark_mc_task_338712.free_mem_315564 = mem_315564;
        
        struct scheduler_segop futhark_mc_task_338712_task;
        
        futhark_mc_task_338712_task.args = &futhark_mc_task_338712;
        futhark_mc_task_338712_task.top_level_fn =
            futhark_mc_segmap_task_338713;
        futhark_mc_task_338712_task.name = "futhark_mc_segmap_task_338713";
        futhark_mc_task_338712_task.iterations = l_n_m_292832;
        futhark_mc_task_338712_task.task_time =
            &ctx->futhark_mc_segmap_task_338713_total_time;
        futhark_mc_task_338712_task.task_iter =
            &ctx->futhark_mc_segmap_task_338713_total_iter;
        futhark_mc_task_338712_task.sched = STATIC;
        futhark_mc_task_338712_task.nested_fn =
            futhark_mc_segmap_nested_task_338716;
        
        int futhark_mc_segmap_task_338713_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_338712_task);
        
        if (futhark_mc_segmap_task_338713_err != 0) {
            ;
            err = futhark_mc_segmap_task_338713_err;
            goto cleanup;
        }
        if (l_n_m_292832 * (int64_t) 8 > 0)
            memmove(mem_315598.mem + gtid_307188 * l_n_m_292832 * (int64_t) 8,
                    mem_315561 + (int64_t) 0, l_n_m_292832 * (int64_t) 8);
        if (l_n_m_292832 * (int64_t) 8 > 0)
            memmove(mem_315602.mem + gtid_307188 * l_n_m_292832 * (int64_t) 8,
                    mem_315564 + (int64_t) 0, l_n_m_292832 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_315561);
    free(mem_315564);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338709_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338709_end -
                 futhark_mc_segmap_parloop_338709_start;
        
        ctx->futhark_mc_segmap_parloop_338709_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338709_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338709_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_nested_task_338707(void *args, int64_t iterations,
                                         int tid, struct scheduler_info info)
{
    int err = 0;
    int flat_tid_307187 = tid;
    int num_tasks_331787 = info.nsubtasks;
    struct futhark_mc_task_338701 *futhark_mc_task_338701 =
                                  (struct futhark_mc_task_338701 *) args;
    struct futhark_context *ctx = futhark_mc_task_338701->ctx;
    uint64_t futhark_mc_segmap_nested_task_338707_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_nested_task_338707_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338701->free_n_292675;
    int64_t q_l_292680 = futhark_mc_task_338701->free_q_l_292680;
    int64_t jump_t_292685 = futhark_mc_task_338701->free_jump_t_292685;
    int64_t partition_sizze_292766 =
            futhark_mc_task_338701->free_partition_sizze_292766;
    int64_t l_n_m_292832 = futhark_mc_task_338701->free_l_n_m_292832;
    int64_t i_292846 = futhark_mc_task_338701->free_i_292846;
    int64_t bytes_313028 = futhark_mc_task_338701->free_bytes_313028;
    struct memblock mem_313081 = {.desc ="mem_313081", .mem =
                                  futhark_mc_task_338701->free_mem_313081,
                                  .size =0, .references =NULL};
    struct memblock mem_313085 = {.desc ="mem_313085", .mem =
                                  futhark_mc_task_338701->free_mem_313085,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_task_338701->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_task_338701->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_task_338701->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_task_338701->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315021 = {.desc ="mem_315021", .mem =
                                  futhark_mc_task_338701->free_mem_315021,
                                  .size =0, .references =NULL};
    struct memblock mem_315598 = {.desc ="mem_315598", .mem =
                                  futhark_mc_task_338701->free_mem_315598,
                                  .size =0, .references =NULL};
    struct memblock mem_315602 = {.desc ="mem_315602", .mem =
                                  futhark_mc_task_338701->free_mem_315602,
                                  .size =0, .references =NULL};
    int64_t iter_331918;
    struct futhark_mc_segmap_parloop_struct_338708
    futhark_mc_segmap_parloop_struct_338708;
    
    futhark_mc_segmap_parloop_struct_338708.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338708.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_338708.free_q_l_292680 = q_l_292680;
    futhark_mc_segmap_parloop_struct_338708.free_jump_t_292685 = jump_t_292685;
    futhark_mc_segmap_parloop_struct_338708.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_338708.free_l_n_m_292832 = l_n_m_292832;
    futhark_mc_segmap_parloop_struct_338708.free_i_292846 = i_292846;
    futhark_mc_segmap_parloop_struct_338708.free_bytes_313028 = bytes_313028;
    futhark_mc_segmap_parloop_struct_338708.free_mem_313081 = mem_313081.mem;
    futhark_mc_segmap_parloop_struct_338708.free_mem_313085 = mem_313085.mem;
    futhark_mc_segmap_parloop_struct_338708.free_ctx_param_ext_313174 =
        ctx_param_ext_313174;
    futhark_mc_segmap_parloop_struct_338708.free_ctx_param_ext_313175 =
        ctx_param_ext_313175;
    futhark_mc_segmap_parloop_struct_338708.free_ctx_param_ext_313177 =
        ctx_param_ext_313177;
    futhark_mc_segmap_parloop_struct_338708.free_mem_param_313179 =
        mem_param_313179.mem;
    futhark_mc_segmap_parloop_struct_338708.free_mem_315021 = mem_315021.mem;
    futhark_mc_segmap_parloop_struct_338708.free_mem_315598 = mem_315598.mem;
    futhark_mc_segmap_parloop_struct_338708.free_mem_315602 = mem_315602.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338709_task;
    
    futhark_mc_segmap_parloop_338709_task.name =
        "futhark_mc_segmap_parloop_338709";
    futhark_mc_segmap_parloop_338709_task.fn = futhark_mc_segmap_parloop_338709;
    futhark_mc_segmap_parloop_338709_task.args =
        &futhark_mc_segmap_parloop_struct_338708;
    futhark_mc_segmap_parloop_338709_task.iterations = iterations;
    futhark_mc_segmap_parloop_338709_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338709_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338709_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338709_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338709_task);
    
    if (futhark_mc_segmap_parloop_338709_err != 0) {
        err = futhark_mc_segmap_parloop_338709_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338709_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338709_total_end -
                 futhark_mc_segmap_parloop_338709_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338709_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338709_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338709_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_nested_task_338707_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_nested_task_338707_end -
                 futhark_mc_segmap_nested_task_338707_start;
        
        ctx->futhark_mc_segmap_nested_task_338707_runs[tid]++;
        ctx->futhark_mc_segmap_nested_task_338707_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_nested_task_338707_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_task_338734 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_jump_l_292686;
    int64_t free_partition_sizze_292766;
    int64_t free_l_n_m_292832;
    int64_t free_i_292846;
    int64_t free_y_295743;
    int64_t free_bytes_312598;
    unsigned char *free_ext_mem_315609;
    unsigned char *free_ext_mem_315610;
    unsigned char *free_mem_315632;
};
struct futhark_mc_segmap_parloop_struct_338736 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_jump_l_292686;
    int64_t free_partition_sizze_292766;
    int64_t free_l_n_m_292832;
    int64_t free_i_292846;
    int64_t free_y_295743;
    int64_t free_bytes_312598;
    unsigned char *free_ext_mem_315609;
    unsigned char *free_ext_mem_315610;
    unsigned char *free_mem_315632;
};
static int futhark_mc_segmap_parloop_338737(void *args, int64_t start,
                                            int64_t end, int flat_tid_307445,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338736
    *futhark_mc_segmap_parloop_struct_338736 =
    (struct futhark_mc_segmap_parloop_struct_338736 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338736->ctx;
    uint64_t futhark_mc_segmap_parloop_338737_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338737_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_338736->free_n_292675;
    int64_t jump_l_292686 =
            futhark_mc_segmap_parloop_struct_338736->free_jump_l_292686;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_338736->free_partition_sizze_292766;
    int64_t l_n_m_292832 =
            futhark_mc_segmap_parloop_struct_338736->free_l_n_m_292832;
    int64_t i_292846 = futhark_mc_segmap_parloop_struct_338736->free_i_292846;
    int64_t y_295743 = futhark_mc_segmap_parloop_struct_338736->free_y_295743;
    int64_t bytes_312598 =
            futhark_mc_segmap_parloop_struct_338736->free_bytes_312598;
    struct memblock ext_mem_315609 = {.desc ="ext_mem_315609", .mem =
                                      futhark_mc_segmap_parloop_struct_338736->free_ext_mem_315609,
                                      .size =0, .references =NULL};
    struct memblock ext_mem_315610 = {.desc ="ext_mem_315610", .mem =
                                      futhark_mc_segmap_parloop_struct_338736->free_ext_mem_315610,
                                      .size =0, .references =NULL};
    struct memblock mem_315632 = {.desc ="mem_315632", .mem =
                                  futhark_mc_segmap_parloop_struct_338736->free_mem_315632,
                                  .size =0, .references =NULL};
    size_t mem_315616_cached_sizze_338738 = 0;
    unsigned char *mem_315616 = NULL;
    int64_t iterations = end - start;
    int64_t iter_332374 = start;
    
    if (mem_315616_cached_sizze_338738 < (size_t) bytes_312598) {
        mem_315616 = realloc(mem_315616, bytes_312598);
        mem_315616_cached_sizze_338738 = bytes_312598;
    }
    for (; iter_332374 < end; iter_332374++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_332424 = partition_sizze_292766;
        int64_t gtid_307446 = iter_332374;
        int64_t remnant_332425 = iter_332374 - gtid_307446;
        
        for (int64_t i_332375 = 0; i_332375 < n_292675; i_332375++) {
            int64_t m_v_332377 = sdiv64(i_332375, jump_l_292686);
            bool cond_332378 = m_v_332377 == y_295743;
            int64_t j_332379;
            
            if (cond_332378) {
                int64_t j_t_res_332380 = sub64(m_v_332377, (int64_t) 1);
                
                j_332379 = j_t_res_332380;
            } else {
                j_332379 = m_v_332377;
            }
            
            int64_t min_arg_332381 = mul64(jump_l_292686, j_332379);
            int64_t min_res_332382 = smin64(i_292846, min_arg_332381);
            int64_t defunc_0_m_fun_arg_332383 = add64((int64_t) 1, j_332379);
            int64_t min_arg_332384 = mul64(jump_l_292686,
                                           defunc_0_m_fun_arg_332383);
            int64_t min_res_332385 = smin64(i_292846, min_arg_332384);
            int64_t i64_arg_332386 = sub64(min_res_332385, min_res_332382);
            double i64_res_332387 = sitofp_i64_f64(i64_arg_332386);
            int64_t i64_arg_332388 = sub64(i_332375, min_res_332382);
            double i64_res_332389 = sitofp_i64_f64(i64_arg_332388);
            double u_332390 = i64_res_332389 / i64_res_332387;
            double u2_332391 = u_332390 * u_332390;
            double u3_332392 = u_332390 * u2_332391;
            double x_332393 = 2.0 * u3_332392;
            double y_332394 = 3.0 * u2_332391;
            double x_332395 = x_332393 - y_332394;
            double x_332396 = 1.0 + x_332395;
            bool x_332397 = sle64((int64_t) 0, j_332379);
            bool y_332398 = slt64(j_332379, l_n_m_292832);
            bool bounds_check_332399 = x_332397 && y_332398;
            bool index_certs_332400;
            
            if (!bounds_check_332399) {
                ctx->error =
                    msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                              "Index [", (long long) j_332379,
                              "] out of bounds for array of shape [",
                              (long long) l_n_m_292832, "].",
                              "-> #0  loess.fut:731:27-33\n   #1  loess.fut:744:13-50\n   #2  /prelude/soacs.fut:59:3-10\n   #3  /prelude/array.fut:195:3-17\n   #4  utils.fut:6:3-16\n   #5  loess.fut:741:3-745:9\n   #6  stl.fut:256:23-75\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:254:15-257:43\n   #10 stl.fut:419:61-435:77\n   #11 stl.fut:463:3-479:36\n   #12 stl.fut:445:1-479:36\n");
                err = FUTHARK_PROGRAM_ERROR;
                goto cleanup;
            }
            
            double y_332401;
            
            y_332401 = ((double *) ext_mem_315610.mem)[gtid_307446 *
                                                       l_n_m_292832 + j_332379];
            
            double x_332402 = x_332396 * y_332401;
            double x_332403 = y_332394 - x_332393;
            bool x_332404 = sle64((int64_t) 0, defunc_0_m_fun_arg_332383);
            bool y_332405 = slt64(defunc_0_m_fun_arg_332383, l_n_m_292832);
            bool bounds_check_332406 = x_332404 && y_332405;
            bool index_certs_332407;
            
            if (!bounds_check_332406) {
                ctx->error =
                    msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                              "Index [", (long long) defunc_0_m_fun_arg_332383,
                              "] out of bounds for array of shape [",
                              (long long) l_n_m_292832, "].",
                              "-> #0  loess.fut:732:27-37\n   #1  loess.fut:744:13-50\n   #2  /prelude/soacs.fut:59:3-10\n   #3  /prelude/array.fut:195:3-17\n   #4  utils.fut:6:3-16\n   #5  loess.fut:741:3-745:9\n   #6  stl.fut:256:23-75\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:254:15-257:43\n   #10 stl.fut:419:61-435:77\n   #11 stl.fut:463:3-479:36\n   #12 stl.fut:445:1-479:36\n");
                err = FUTHARK_PROGRAM_ERROR;
                goto cleanup;
            }
            
            double y_332408;
            
            y_332408 = ((double *) ext_mem_315610.mem)[gtid_307446 *
                                                       l_n_m_292832 +
                                                       defunc_0_m_fun_arg_332383];
            
            double y_332409 = x_332403 * y_332408;
            double x_332410 = x_332402 + y_332409;
            double y_332411 = 2.0 * u2_332391;
            double x_332412 = u3_332392 - y_332411;
            double x_332413 = u_332390 + x_332412;
            double y_332414;
            
            y_332414 = ((double *) ext_mem_315609.mem)[gtid_307446 *
                                                       l_n_m_292832 + j_332379];
            
            double x_332415 = x_332413 * y_332414;
            double y_332416 = i64_res_332387 * x_332415;
            double x_332417 = x_332410 + y_332416;
            double x_332418 = u3_332392 - u2_332391;
            double y_332419;
            
            y_332419 = ((double *) ext_mem_315609.mem)[gtid_307446 *
                                                       l_n_m_292832 +
                                                       defunc_0_m_fun_arg_332383];
            
            double x_332420 = x_332418 * y_332419;
            double y_332421 = i64_res_332387 * x_332420;
            double defunc_4_interpolate_proc_res_332422 = x_332417 + y_332421;
            
            ((double *) mem_315616)[i_332375] =
                defunc_4_interpolate_proc_res_332422;
        }
        if (n_292675 * (int64_t) 8 > 0)
            memmove(mem_315632.mem + gtid_307446 * n_292675 * (int64_t) 8,
                    mem_315616 + (int64_t) 0, n_292675 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_315616);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338737_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338737_end -
                 futhark_mc_segmap_parloop_338737_start;
        
        ctx->futhark_mc_segmap_parloop_338737_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338737_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338737_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_338735(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_307445 = tid;
    int num_tasks_332373 = info.nsubtasks;
    struct futhark_mc_task_338734 *futhark_mc_task_338734 =
                                  (struct futhark_mc_task_338734 *) args;
    struct futhark_context *ctx = futhark_mc_task_338734->ctx;
    uint64_t futhark_mc_segmap_task_338735_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_338735_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338734->free_n_292675;
    int64_t jump_l_292686 = futhark_mc_task_338734->free_jump_l_292686;
    int64_t partition_sizze_292766 =
            futhark_mc_task_338734->free_partition_sizze_292766;
    int64_t l_n_m_292832 = futhark_mc_task_338734->free_l_n_m_292832;
    int64_t i_292846 = futhark_mc_task_338734->free_i_292846;
    int64_t y_295743 = futhark_mc_task_338734->free_y_295743;
    int64_t bytes_312598 = futhark_mc_task_338734->free_bytes_312598;
    struct memblock ext_mem_315609 = {.desc ="ext_mem_315609", .mem =
                                      futhark_mc_task_338734->free_ext_mem_315609,
                                      .size =0, .references =NULL};
    struct memblock ext_mem_315610 = {.desc ="ext_mem_315610", .mem =
                                      futhark_mc_task_338734->free_ext_mem_315610,
                                      .size =0, .references =NULL};
    struct memblock mem_315632 = {.desc ="mem_315632", .mem =
                                  futhark_mc_task_338734->free_mem_315632,
                                  .size =0, .references =NULL};
    int64_t iter_332374;
    struct futhark_mc_segmap_parloop_struct_338736
    futhark_mc_segmap_parloop_struct_338736;
    
    futhark_mc_segmap_parloop_struct_338736.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338736.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_338736.free_jump_l_292686 = jump_l_292686;
    futhark_mc_segmap_parloop_struct_338736.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_338736.free_l_n_m_292832 = l_n_m_292832;
    futhark_mc_segmap_parloop_struct_338736.free_i_292846 = i_292846;
    futhark_mc_segmap_parloop_struct_338736.free_y_295743 = y_295743;
    futhark_mc_segmap_parloop_struct_338736.free_bytes_312598 = bytes_312598;
    futhark_mc_segmap_parloop_struct_338736.free_ext_mem_315609 =
        ext_mem_315609.mem;
    futhark_mc_segmap_parloop_struct_338736.free_ext_mem_315610 =
        ext_mem_315610.mem;
    futhark_mc_segmap_parloop_struct_338736.free_mem_315632 = mem_315632.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338737_task;
    
    futhark_mc_segmap_parloop_338737_task.name =
        "futhark_mc_segmap_parloop_338737";
    futhark_mc_segmap_parloop_338737_task.fn = futhark_mc_segmap_parloop_338737;
    futhark_mc_segmap_parloop_338737_task.args =
        &futhark_mc_segmap_parloop_struct_338736;
    futhark_mc_segmap_parloop_338737_task.iterations = iterations;
    futhark_mc_segmap_parloop_338737_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338737_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338737_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338737_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338737_task);
    
    if (futhark_mc_segmap_parloop_338737_err != 0) {
        err = futhark_mc_segmap_parloop_338737_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338737_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338737_total_end -
                 futhark_mc_segmap_parloop_338737_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338737_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338737_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338737_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_338735_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_338735_end -
                 futhark_mc_segmap_task_338735_start;
        
        ctx->futhark_mc_segmap_task_338735_runs[tid]++;
        ctx->futhark_mc_segmap_task_338735_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_338735_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_segmap_parloop_struct_338740 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_jump_l_292686;
    int64_t free_partition_sizze_292766;
    int64_t free_l_n_m_292832;
    int64_t free_i_292846;
    int64_t free_y_295743;
    int64_t free_bytes_312598;
    unsigned char *free_ext_mem_315609;
    unsigned char *free_ext_mem_315610;
    unsigned char *free_mem_315632;
};
struct futhark_mc_task_338743 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_jump_l_292686;
    int64_t free_l_n_m_292832;
    int64_t free_i_292846;
    int64_t free_y_295743;
    int64_t free_gtid_307452;
    unsigned char *free_ext_mem_315609;
    unsigned char *free_ext_mem_315610;
    unsigned char *free_mem_315613;
};
struct futhark_mc_segmap_parloop_struct_338745 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_jump_l_292686;
    int64_t free_l_n_m_292832;
    int64_t free_i_292846;
    int64_t free_y_295743;
    int64_t free_gtid_307452;
    unsigned char *free_ext_mem_315609;
    unsigned char *free_ext_mem_315610;
    unsigned char *free_mem_315613;
};
static int futhark_mc_segmap_parloop_338746(void *args, int64_t start,
                                            int64_t end, int flat_tid_332428,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338745
    *futhark_mc_segmap_parloop_struct_338745 =
    (struct futhark_mc_segmap_parloop_struct_338745 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338745->ctx;
    uint64_t futhark_mc_segmap_parloop_338746_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338746_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_338745->free_n_292675;
    int64_t jump_l_292686 =
            futhark_mc_segmap_parloop_struct_338745->free_jump_l_292686;
    int64_t l_n_m_292832 =
            futhark_mc_segmap_parloop_struct_338745->free_l_n_m_292832;
    int64_t i_292846 = futhark_mc_segmap_parloop_struct_338745->free_i_292846;
    int64_t y_295743 = futhark_mc_segmap_parloop_struct_338745->free_y_295743;
    int64_t gtid_307452 =
            futhark_mc_segmap_parloop_struct_338745->free_gtid_307452;
    struct memblock ext_mem_315609 = {.desc ="ext_mem_315609", .mem =
                                      futhark_mc_segmap_parloop_struct_338745->free_ext_mem_315609,
                                      .size =0, .references =NULL};
    struct memblock ext_mem_315610 = {.desc ="ext_mem_315610", .mem =
                                      futhark_mc_segmap_parloop_struct_338745->free_ext_mem_315610,
                                      .size =0, .references =NULL};
    struct memblock mem_315613 = {.desc ="mem_315613", .mem =
                                  futhark_mc_segmap_parloop_struct_338745->free_mem_315613,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_332479 = start;
    
    for (; iter_332479 < end; iter_332479++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_332481 = n_292675;
        int64_t gtid_332429 = iter_332479;
        int64_t remnant_332482 = iter_332479 - gtid_332429;
        int64_t m_v_332430 = sdiv64(gtid_332429, jump_l_292686);
        bool cond_332431 = m_v_332430 == y_295743;
        int64_t j_332432;
        
        if (cond_332431) {
            int64_t j_t_res_332480 = sub64(m_v_332430, (int64_t) 1);
            
            j_332432 = j_t_res_332480;
        } else {
            j_332432 = m_v_332430;
        }
        
        int64_t min_arg_332434 = mul64(jump_l_292686, j_332432);
        int64_t min_res_332435 = smin64(i_292846, min_arg_332434);
        int64_t defunc_0_m_fun_arg_332436 = add64((int64_t) 1, j_332432);
        int64_t min_arg_332437 = mul64(jump_l_292686,
                                       defunc_0_m_fun_arg_332436);
        int64_t min_res_332438 = smin64(i_292846, min_arg_332437);
        int64_t i64_arg_332439 = sub64(min_res_332438, min_res_332435);
        double i64_res_332440 = sitofp_i64_f64(i64_arg_332439);
        int64_t i64_arg_332441 = sub64(gtid_332429, min_res_332435);
        double i64_res_332442 = sitofp_i64_f64(i64_arg_332441);
        double u_332443 = i64_res_332442 / i64_res_332440;
        double u2_332444 = u_332443 * u_332443;
        double u3_332445 = u_332443 * u2_332444;
        double x_332446 = 2.0 * u3_332445;
        double y_332447 = 3.0 * u2_332444;
        double x_332448 = x_332446 - y_332447;
        double x_332449 = 1.0 + x_332448;
        bool x_332450 = sle64((int64_t) 0, j_332432);
        bool y_332451 = slt64(j_332432, l_n_m_292832);
        bool bounds_check_332452 = x_332450 && y_332451;
        bool index_certs_332453;
        
        if (!bounds_check_332452) {
            ctx->error = msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                   "Index [", (long long) j_332432,
                                   "] out of bounds for array of shape [",
                                   (long long) l_n_m_292832, "].",
                                   "-> #0  loess.fut:731:27-33\n   #1  loess.fut:744:13-50\n   #2  /prelude/soacs.fut:59:3-10\n   #3  /prelude/array.fut:195:3-17\n   #4  utils.fut:6:3-16\n   #5  loess.fut:741:3-745:9\n   #6  stl.fut:256:23-75\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:254:15-257:43\n   #10 stl.fut:419:61-435:77\n   #11 stl.fut:463:3-479:36\n   #12 stl.fut:445:1-479:36\n");
            err = FUTHARK_PROGRAM_ERROR;
            goto cleanup;
        }
        
        double y_332454;
        
        y_332454 = ((double *) ext_mem_315610.mem)[gtid_307452 * l_n_m_292832 +
                                                   j_332432];
        
        double x_332455 = x_332449 * y_332454;
        double x_332456 = y_332447 - x_332446;
        bool x_332457 = sle64((int64_t) 0, defunc_0_m_fun_arg_332436);
        bool y_332458 = slt64(defunc_0_m_fun_arg_332436, l_n_m_292832);
        bool bounds_check_332459 = x_332457 && y_332458;
        bool index_certs_332460;
        
        if (!bounds_check_332459) {
            ctx->error = msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                   "Index [",
                                   (long long) defunc_0_m_fun_arg_332436,
                                   "] out of bounds for array of shape [",
                                   (long long) l_n_m_292832, "].",
                                   "-> #0  loess.fut:732:27-37\n   #1  loess.fut:744:13-50\n   #2  /prelude/soacs.fut:59:3-10\n   #3  /prelude/array.fut:195:3-17\n   #4  utils.fut:6:3-16\n   #5  loess.fut:741:3-745:9\n   #6  stl.fut:256:23-75\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:254:15-257:43\n   #10 stl.fut:419:61-435:77\n   #11 stl.fut:463:3-479:36\n   #12 stl.fut:445:1-479:36\n");
            err = FUTHARK_PROGRAM_ERROR;
            goto cleanup;
        }
        
        double y_332461;
        
        y_332461 = ((double *) ext_mem_315610.mem)[gtid_307452 * l_n_m_292832 +
                                                   defunc_0_m_fun_arg_332436];
        
        double y_332462 = x_332456 * y_332461;
        double x_332463 = x_332455 + y_332462;
        double y_332464 = 2.0 * u2_332444;
        double x_332465 = u3_332445 - y_332464;
        double x_332466 = u_332443 + x_332465;
        double y_332467;
        
        y_332467 = ((double *) ext_mem_315609.mem)[gtid_307452 * l_n_m_292832 +
                                                   j_332432];
        
        double x_332468 = x_332466 * y_332467;
        double y_332469 = i64_res_332440 * x_332468;
        double x_332470 = x_332463 + y_332469;
        double x_332471 = u3_332445 - u2_332444;
        double y_332472;
        
        y_332472 = ((double *) ext_mem_315609.mem)[gtid_307452 * l_n_m_292832 +
                                                   defunc_0_m_fun_arg_332436];
        
        double x_332473 = x_332471 * y_332472;
        double y_332474 = i64_res_332440 * x_332473;
        double defunc_4_interpolate_proc_res_332475 = x_332470 + y_332474;
        
        ((double *) mem_315613.mem)[gtid_332429] =
            defunc_4_interpolate_proc_res_332475;
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338746_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338746_end -
                 futhark_mc_segmap_parloop_338746_start;
        
        ctx->futhark_mc_segmap_parloop_338746_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338746_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338746_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_338744(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_332428 = tid;
    int num_tasks_332478 = info.nsubtasks;
    struct futhark_mc_task_338743 *futhark_mc_task_338743 =
                                  (struct futhark_mc_task_338743 *) args;
    struct futhark_context *ctx = futhark_mc_task_338743->ctx;
    uint64_t futhark_mc_segmap_task_338744_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_338744_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338743->free_n_292675;
    int64_t jump_l_292686 = futhark_mc_task_338743->free_jump_l_292686;
    int64_t l_n_m_292832 = futhark_mc_task_338743->free_l_n_m_292832;
    int64_t i_292846 = futhark_mc_task_338743->free_i_292846;
    int64_t y_295743 = futhark_mc_task_338743->free_y_295743;
    int64_t gtid_307452 = futhark_mc_task_338743->free_gtid_307452;
    struct memblock ext_mem_315609 = {.desc ="ext_mem_315609", .mem =
                                      futhark_mc_task_338743->free_ext_mem_315609,
                                      .size =0, .references =NULL};
    struct memblock ext_mem_315610 = {.desc ="ext_mem_315610", .mem =
                                      futhark_mc_task_338743->free_ext_mem_315610,
                                      .size =0, .references =NULL};
    struct memblock mem_315613 = {.desc ="mem_315613", .mem =
                                  futhark_mc_task_338743->free_mem_315613,
                                  .size =0, .references =NULL};
    int64_t iter_332479;
    struct futhark_mc_segmap_parloop_struct_338745
    futhark_mc_segmap_parloop_struct_338745;
    
    futhark_mc_segmap_parloop_struct_338745.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338745.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_338745.free_jump_l_292686 = jump_l_292686;
    futhark_mc_segmap_parloop_struct_338745.free_l_n_m_292832 = l_n_m_292832;
    futhark_mc_segmap_parloop_struct_338745.free_i_292846 = i_292846;
    futhark_mc_segmap_parloop_struct_338745.free_y_295743 = y_295743;
    futhark_mc_segmap_parloop_struct_338745.free_gtid_307452 = gtid_307452;
    futhark_mc_segmap_parloop_struct_338745.free_ext_mem_315609 =
        ext_mem_315609.mem;
    futhark_mc_segmap_parloop_struct_338745.free_ext_mem_315610 =
        ext_mem_315610.mem;
    futhark_mc_segmap_parloop_struct_338745.free_mem_315613 = mem_315613.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338746_task;
    
    futhark_mc_segmap_parloop_338746_task.name =
        "futhark_mc_segmap_parloop_338746";
    futhark_mc_segmap_parloop_338746_task.fn = futhark_mc_segmap_parloop_338746;
    futhark_mc_segmap_parloop_338746_task.args =
        &futhark_mc_segmap_parloop_struct_338745;
    futhark_mc_segmap_parloop_338746_task.iterations = iterations;
    futhark_mc_segmap_parloop_338746_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338746_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338746_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338746_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338746_task);
    
    if (futhark_mc_segmap_parloop_338746_err != 0) {
        err = futhark_mc_segmap_parloop_338746_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338746_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338746_total_end -
                 futhark_mc_segmap_parloop_338746_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338746_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338746_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338746_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_338744_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_338744_end -
                 futhark_mc_segmap_task_338744_start;
        
        ctx->futhark_mc_segmap_task_338744_runs[tid]++;
        ctx->futhark_mc_segmap_task_338744_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_338744_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
static int futhark_mc_segmap_parloop_338741(void *args, int64_t start,
                                            int64_t end, int flat_tid_307451,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338740
    *futhark_mc_segmap_parloop_struct_338740 =
    (struct futhark_mc_segmap_parloop_struct_338740 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338740->ctx;
    uint64_t futhark_mc_segmap_parloop_338741_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338741_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_338740->free_n_292675;
    int64_t jump_l_292686 =
            futhark_mc_segmap_parloop_struct_338740->free_jump_l_292686;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_338740->free_partition_sizze_292766;
    int64_t l_n_m_292832 =
            futhark_mc_segmap_parloop_struct_338740->free_l_n_m_292832;
    int64_t i_292846 = futhark_mc_segmap_parloop_struct_338740->free_i_292846;
    int64_t y_295743 = futhark_mc_segmap_parloop_struct_338740->free_y_295743;
    int64_t bytes_312598 =
            futhark_mc_segmap_parloop_struct_338740->free_bytes_312598;
    struct memblock ext_mem_315609 = {.desc ="ext_mem_315609", .mem =
                                      futhark_mc_segmap_parloop_struct_338740->free_ext_mem_315609,
                                      .size =0, .references =NULL};
    struct memblock ext_mem_315610 = {.desc ="ext_mem_315610", .mem =
                                      futhark_mc_segmap_parloop_struct_338740->free_ext_mem_315610,
                                      .size =0, .references =NULL};
    struct memblock mem_315632 = {.desc ="mem_315632", .mem =
                                  futhark_mc_segmap_parloop_struct_338740->free_mem_315632,
                                  .size =0, .references =NULL};
    size_t mem_315613_cached_sizze_338742 = 0;
    unsigned char *mem_315613 = NULL;
    int64_t iterations = end - start;
    int64_t iter_332427 = start;
    
    if (mem_315613_cached_sizze_338742 < (size_t) bytes_312598) {
        mem_315613 = realloc(mem_315613, bytes_312598);
        mem_315613_cached_sizze_338742 = bytes_312598;
    }
    for (; iter_332427 < end; iter_332427++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_332476 = partition_sizze_292766;
        int64_t gtid_307452 = iter_332427;
        int64_t remnant_332477 = iter_332427 - gtid_307452;
        int64_t flat_tid_332428 = (int64_t) 0;
        int32_t num_tasks_332478;
        struct futhark_mc_task_338743 futhark_mc_task_338743;
        
        futhark_mc_task_338743.ctx = ctx;
        futhark_mc_task_338743.free_n_292675 = n_292675;
        futhark_mc_task_338743.free_jump_l_292686 = jump_l_292686;
        futhark_mc_task_338743.free_l_n_m_292832 = l_n_m_292832;
        futhark_mc_task_338743.free_i_292846 = i_292846;
        futhark_mc_task_338743.free_y_295743 = y_295743;
        futhark_mc_task_338743.free_gtid_307452 = gtid_307452;
        futhark_mc_task_338743.free_ext_mem_315609 = ext_mem_315609.mem;
        futhark_mc_task_338743.free_ext_mem_315610 = ext_mem_315610.mem;
        futhark_mc_task_338743.free_mem_315613 = mem_315613;
        
        struct scheduler_segop futhark_mc_task_338743_task;
        
        futhark_mc_task_338743_task.args = &futhark_mc_task_338743;
        futhark_mc_task_338743_task.top_level_fn =
            futhark_mc_segmap_task_338744;
        futhark_mc_task_338743_task.name = "futhark_mc_segmap_task_338744";
        futhark_mc_task_338743_task.iterations = n_292675;
        futhark_mc_task_338743_task.task_time =
            &ctx->futhark_mc_segmap_task_338744_total_time;
        futhark_mc_task_338743_task.task_iter =
            &ctx->futhark_mc_segmap_task_338744_total_iter;
        futhark_mc_task_338743_task.sched = STATIC;
        futhark_mc_task_338743_task.nested_fn = NULL;
        
        int futhark_mc_segmap_task_338744_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_338743_task);
        
        if (futhark_mc_segmap_task_338744_err != 0) {
            ;
            err = futhark_mc_segmap_task_338744_err;
            goto cleanup;
        }
        if (n_292675 * (int64_t) 8 > 0)
            memmove(mem_315632.mem + gtid_307452 * n_292675 * (int64_t) 8,
                    mem_315613 + (int64_t) 0, n_292675 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_315613);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338741_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338741_end -
                 futhark_mc_segmap_parloop_338741_start;
        
        ctx->futhark_mc_segmap_parloop_338741_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338741_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338741_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_nested_task_338739(void *args, int64_t iterations,
                                         int tid, struct scheduler_info info)
{
    int err = 0;
    int flat_tid_307451 = tid;
    int num_tasks_332373 = info.nsubtasks;
    struct futhark_mc_task_338734 *futhark_mc_task_338734 =
                                  (struct futhark_mc_task_338734 *) args;
    struct futhark_context *ctx = futhark_mc_task_338734->ctx;
    uint64_t futhark_mc_segmap_nested_task_338739_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_nested_task_338739_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338734->free_n_292675;
    int64_t jump_l_292686 = futhark_mc_task_338734->free_jump_l_292686;
    int64_t partition_sizze_292766 =
            futhark_mc_task_338734->free_partition_sizze_292766;
    int64_t l_n_m_292832 = futhark_mc_task_338734->free_l_n_m_292832;
    int64_t i_292846 = futhark_mc_task_338734->free_i_292846;
    int64_t y_295743 = futhark_mc_task_338734->free_y_295743;
    int64_t bytes_312598 = futhark_mc_task_338734->free_bytes_312598;
    struct memblock ext_mem_315609 = {.desc ="ext_mem_315609", .mem =
                                      futhark_mc_task_338734->free_ext_mem_315609,
                                      .size =0, .references =NULL};
    struct memblock ext_mem_315610 = {.desc ="ext_mem_315610", .mem =
                                      futhark_mc_task_338734->free_ext_mem_315610,
                                      .size =0, .references =NULL};
    struct memblock mem_315632 = {.desc ="mem_315632", .mem =
                                  futhark_mc_task_338734->free_mem_315632,
                                  .size =0, .references =NULL};
    int64_t iter_332427;
    struct futhark_mc_segmap_parloop_struct_338740
    futhark_mc_segmap_parloop_struct_338740;
    
    futhark_mc_segmap_parloop_struct_338740.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338740.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_338740.free_jump_l_292686 = jump_l_292686;
    futhark_mc_segmap_parloop_struct_338740.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_338740.free_l_n_m_292832 = l_n_m_292832;
    futhark_mc_segmap_parloop_struct_338740.free_i_292846 = i_292846;
    futhark_mc_segmap_parloop_struct_338740.free_y_295743 = y_295743;
    futhark_mc_segmap_parloop_struct_338740.free_bytes_312598 = bytes_312598;
    futhark_mc_segmap_parloop_struct_338740.free_ext_mem_315609 =
        ext_mem_315609.mem;
    futhark_mc_segmap_parloop_struct_338740.free_ext_mem_315610 =
        ext_mem_315610.mem;
    futhark_mc_segmap_parloop_struct_338740.free_mem_315632 = mem_315632.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338741_task;
    
    futhark_mc_segmap_parloop_338741_task.name =
        "futhark_mc_segmap_parloop_338741";
    futhark_mc_segmap_parloop_338741_task.fn = futhark_mc_segmap_parloop_338741;
    futhark_mc_segmap_parloop_338741_task.args =
        &futhark_mc_segmap_parloop_struct_338740;
    futhark_mc_segmap_parloop_338741_task.iterations = iterations;
    futhark_mc_segmap_parloop_338741_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338741_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338741_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338741_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338741_task);
    
    if (futhark_mc_segmap_parloop_338741_err != 0) {
        err = futhark_mc_segmap_parloop_338741_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338741_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338741_total_end -
                 futhark_mc_segmap_parloop_338741_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338741_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338741_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338741_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_nested_task_338739_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_nested_task_338739_end -
                 futhark_mc_segmap_nested_task_338739_start;
        
        ctx->futhark_mc_segmap_nested_task_338739_runs[tid]++;
        ctx->futhark_mc_segmap_nested_task_338739_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_nested_task_338739_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_task_338747 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_n_p_292677;
    int64_t free_partition_sizze_292766;
    int64_t free_C_len_292823;
    int64_t free_bytes_312598;
    unsigned char *free_mem_314946;
    unsigned char *free_ext_mem_315633;
    int64_t free_ext_315634;
    unsigned char *free_mem_315656;
};
struct futhark_mc_segmap_parloop_struct_338749 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_n_p_292677;
    int64_t free_partition_sizze_292766;
    int64_t free_C_len_292823;
    int64_t free_bytes_312598;
    unsigned char *free_mem_314946;
    unsigned char *free_ext_mem_315633;
    int64_t free_ext_315634;
    unsigned char *free_mem_315656;
};
static int futhark_mc_segmap_parloop_338750(void *args, int64_t start,
                                            int64_t end, int flat_tid_307505,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338749
    *futhark_mc_segmap_parloop_struct_338749 =
    (struct futhark_mc_segmap_parloop_struct_338749 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338749->ctx;
    uint64_t futhark_mc_segmap_parloop_338750_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338750_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_338749->free_n_292675;
    int64_t n_p_292677 =
            futhark_mc_segmap_parloop_struct_338749->free_n_p_292677;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_338749->free_partition_sizze_292766;
    int64_t C_len_292823 =
            futhark_mc_segmap_parloop_struct_338749->free_C_len_292823;
    int64_t bytes_312598 =
            futhark_mc_segmap_parloop_struct_338749->free_bytes_312598;
    struct memblock mem_314946 = {.desc ="mem_314946", .mem =
                                  futhark_mc_segmap_parloop_struct_338749->free_mem_314946,
                                  .size =0, .references =NULL};
    struct memblock ext_mem_315633 = {.desc ="ext_mem_315633", .mem =
                                      futhark_mc_segmap_parloop_struct_338749->free_ext_mem_315633,
                                      .size =0, .references =NULL};
    int64_t ext_315634 =
            futhark_mc_segmap_parloop_struct_338749->free_ext_315634;
    struct memblock mem_315656 = {.desc ="mem_315656", .mem =
                                  futhark_mc_segmap_parloop_struct_338749->free_mem_315656,
                                  .size =0, .references =NULL};
    size_t mem_315640_cached_sizze_338751 = 0;
    unsigned char *mem_315640 = NULL;
    int64_t iterations = end - start;
    int64_t iter_332484 = start;
    
    if (mem_315640_cached_sizze_338751 < (size_t) bytes_312598) {
        mem_315640 = realloc(mem_315640, bytes_312598);
        mem_315640_cached_sizze_338751 = bytes_312598;
    }
    for (; iter_332484 < end; iter_332484++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_332492 = partition_sizze_292766;
        int64_t gtid_307506 = iter_332484;
        int64_t remnant_332493 = iter_332484 - gtid_307506;
        
        for (int64_t i_332485 = 0; i_332485 < n_292675; i_332485++) {
            int64_t slice_332487 = n_p_292677 + i_332485;
            double x_332488;
            
            x_332488 = ((double *) mem_314946.mem)[gtid_307506 * C_len_292823 +
                                                   slice_332487];
            
            double x_332489;
            
            x_332489 = ((double *) ext_mem_315633.mem)[gtid_307506 *
                                                       ext_315634 + i_332485];
            
            double defunc_1_f_res_332490 = x_332488 - x_332489;
            
            ((double *) mem_315640)[i_332485] = defunc_1_f_res_332490;
        }
        if (n_292675 * (int64_t) 8 > 0)
            memmove(mem_315656.mem + gtid_307506 * n_292675 * (int64_t) 8,
                    mem_315640 + (int64_t) 0, n_292675 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_315640);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338750_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338750_end -
                 futhark_mc_segmap_parloop_338750_start;
        
        ctx->futhark_mc_segmap_parloop_338750_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338750_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338750_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_338748(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_307505 = tid;
    int num_tasks_332483 = info.nsubtasks;
    struct futhark_mc_task_338747 *futhark_mc_task_338747 =
                                  (struct futhark_mc_task_338747 *) args;
    struct futhark_context *ctx = futhark_mc_task_338747->ctx;
    uint64_t futhark_mc_segmap_task_338748_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_338748_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338747->free_n_292675;
    int64_t n_p_292677 = futhark_mc_task_338747->free_n_p_292677;
    int64_t partition_sizze_292766 =
            futhark_mc_task_338747->free_partition_sizze_292766;
    int64_t C_len_292823 = futhark_mc_task_338747->free_C_len_292823;
    int64_t bytes_312598 = futhark_mc_task_338747->free_bytes_312598;
    struct memblock mem_314946 = {.desc ="mem_314946", .mem =
                                  futhark_mc_task_338747->free_mem_314946,
                                  .size =0, .references =NULL};
    struct memblock ext_mem_315633 = {.desc ="ext_mem_315633", .mem =
                                      futhark_mc_task_338747->free_ext_mem_315633,
                                      .size =0, .references =NULL};
    int64_t ext_315634 = futhark_mc_task_338747->free_ext_315634;
    struct memblock mem_315656 = {.desc ="mem_315656", .mem =
                                  futhark_mc_task_338747->free_mem_315656,
                                  .size =0, .references =NULL};
    int64_t iter_332484;
    struct futhark_mc_segmap_parloop_struct_338749
    futhark_mc_segmap_parloop_struct_338749;
    
    futhark_mc_segmap_parloop_struct_338749.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338749.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_338749.free_n_p_292677 = n_p_292677;
    futhark_mc_segmap_parloop_struct_338749.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_338749.free_C_len_292823 = C_len_292823;
    futhark_mc_segmap_parloop_struct_338749.free_bytes_312598 = bytes_312598;
    futhark_mc_segmap_parloop_struct_338749.free_mem_314946 = mem_314946.mem;
    futhark_mc_segmap_parloop_struct_338749.free_ext_mem_315633 =
        ext_mem_315633.mem;
    futhark_mc_segmap_parloop_struct_338749.free_ext_315634 = ext_315634;
    futhark_mc_segmap_parloop_struct_338749.free_mem_315656 = mem_315656.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338750_task;
    
    futhark_mc_segmap_parloop_338750_task.name =
        "futhark_mc_segmap_parloop_338750";
    futhark_mc_segmap_parloop_338750_task.fn = futhark_mc_segmap_parloop_338750;
    futhark_mc_segmap_parloop_338750_task.args =
        &futhark_mc_segmap_parloop_struct_338749;
    futhark_mc_segmap_parloop_338750_task.iterations = iterations;
    futhark_mc_segmap_parloop_338750_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338750_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338750_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338750_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338750_task);
    
    if (futhark_mc_segmap_parloop_338750_err != 0) {
        err = futhark_mc_segmap_parloop_338750_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338750_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338750_total_end -
                 futhark_mc_segmap_parloop_338750_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338750_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338750_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338750_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_338748_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_338748_end -
                 futhark_mc_segmap_task_338748_start;
        
        ctx->futhark_mc_segmap_task_338748_runs[tid]++;
        ctx->futhark_mc_segmap_task_338748_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_338748_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_segmap_parloop_struct_338753 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_n_p_292677;
    int64_t free_partition_sizze_292766;
    int64_t free_C_len_292823;
    int64_t free_bytes_312598;
    unsigned char *free_mem_314946;
    unsigned char *free_ext_mem_315633;
    int64_t free_ext_315634;
    unsigned char *free_mem_315656;
};
struct futhark_mc_task_338756 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_n_p_292677;
    int64_t free_C_len_292823;
    int64_t free_gtid_307512;
    unsigned char *free_mem_314946;
    unsigned char *free_ext_mem_315633;
    int64_t free_ext_315634;
    unsigned char *free_mem_315637;
};
struct futhark_mc_segmap_parloop_struct_338758 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_n_p_292677;
    int64_t free_C_len_292823;
    int64_t free_gtid_307512;
    unsigned char *free_mem_314946;
    unsigned char *free_ext_mem_315633;
    int64_t free_ext_315634;
    unsigned char *free_mem_315637;
};
static int futhark_mc_segmap_parloop_338759(void *args, int64_t start,
                                            int64_t end, int flat_tid_332496,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338758
    *futhark_mc_segmap_parloop_struct_338758 =
    (struct futhark_mc_segmap_parloop_struct_338758 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338758->ctx;
    uint64_t futhark_mc_segmap_parloop_338759_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338759_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_338758->free_n_292675;
    int64_t n_p_292677 =
            futhark_mc_segmap_parloop_struct_338758->free_n_p_292677;
    int64_t C_len_292823 =
            futhark_mc_segmap_parloop_struct_338758->free_C_len_292823;
    int64_t gtid_307512 =
            futhark_mc_segmap_parloop_struct_338758->free_gtid_307512;
    struct memblock mem_314946 = {.desc ="mem_314946", .mem =
                                  futhark_mc_segmap_parloop_struct_338758->free_mem_314946,
                                  .size =0, .references =NULL};
    struct memblock ext_mem_315633 = {.desc ="ext_mem_315633", .mem =
                                      futhark_mc_segmap_parloop_struct_338758->free_ext_mem_315633,
                                      .size =0, .references =NULL};
    int64_t ext_315634 =
            futhark_mc_segmap_parloop_struct_338758->free_ext_315634;
    struct memblock mem_315637 = {.desc ="mem_315637", .mem =
                                  futhark_mc_segmap_parloop_struct_338758->free_mem_315637,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_332505 = start;
    
    for (; iter_332505 < end; iter_332505++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_332506 = n_292675;
        int64_t gtid_332497 = iter_332505;
        int64_t remnant_332507 = iter_332505 - gtid_332497;
        int64_t slice_332498 = n_p_292677 + gtid_332497;
        double x_332499;
        
        x_332499 = ((double *) mem_314946.mem)[gtid_307512 * C_len_292823 +
                                               slice_332498];
        
        double x_332500;
        
        x_332500 = ((double *) ext_mem_315633.mem)[gtid_307512 * ext_315634 +
                                                   gtid_332497];
        
        double defunc_1_f_res_332501 = x_332499 - x_332500;
        
        ((double *) mem_315637.mem)[gtid_332497] = defunc_1_f_res_332501;
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338759_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338759_end -
                 futhark_mc_segmap_parloop_338759_start;
        
        ctx->futhark_mc_segmap_parloop_338759_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338759_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338759_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_338757(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_332496 = tid;
    int num_tasks_332504 = info.nsubtasks;
    struct futhark_mc_task_338756 *futhark_mc_task_338756 =
                                  (struct futhark_mc_task_338756 *) args;
    struct futhark_context *ctx = futhark_mc_task_338756->ctx;
    uint64_t futhark_mc_segmap_task_338757_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_338757_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338756->free_n_292675;
    int64_t n_p_292677 = futhark_mc_task_338756->free_n_p_292677;
    int64_t C_len_292823 = futhark_mc_task_338756->free_C_len_292823;
    int64_t gtid_307512 = futhark_mc_task_338756->free_gtid_307512;
    struct memblock mem_314946 = {.desc ="mem_314946", .mem =
                                  futhark_mc_task_338756->free_mem_314946,
                                  .size =0, .references =NULL};
    struct memblock ext_mem_315633 = {.desc ="ext_mem_315633", .mem =
                                      futhark_mc_task_338756->free_ext_mem_315633,
                                      .size =0, .references =NULL};
    int64_t ext_315634 = futhark_mc_task_338756->free_ext_315634;
    struct memblock mem_315637 = {.desc ="mem_315637", .mem =
                                  futhark_mc_task_338756->free_mem_315637,
                                  .size =0, .references =NULL};
    int64_t iter_332505;
    struct futhark_mc_segmap_parloop_struct_338758
    futhark_mc_segmap_parloop_struct_338758;
    
    futhark_mc_segmap_parloop_struct_338758.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338758.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_338758.free_n_p_292677 = n_p_292677;
    futhark_mc_segmap_parloop_struct_338758.free_C_len_292823 = C_len_292823;
    futhark_mc_segmap_parloop_struct_338758.free_gtid_307512 = gtid_307512;
    futhark_mc_segmap_parloop_struct_338758.free_mem_314946 = mem_314946.mem;
    futhark_mc_segmap_parloop_struct_338758.free_ext_mem_315633 =
        ext_mem_315633.mem;
    futhark_mc_segmap_parloop_struct_338758.free_ext_315634 = ext_315634;
    futhark_mc_segmap_parloop_struct_338758.free_mem_315637 = mem_315637.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338759_task;
    
    futhark_mc_segmap_parloop_338759_task.name =
        "futhark_mc_segmap_parloop_338759";
    futhark_mc_segmap_parloop_338759_task.fn = futhark_mc_segmap_parloop_338759;
    futhark_mc_segmap_parloop_338759_task.args =
        &futhark_mc_segmap_parloop_struct_338758;
    futhark_mc_segmap_parloop_338759_task.iterations = iterations;
    futhark_mc_segmap_parloop_338759_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338759_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338759_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338759_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338759_task);
    
    if (futhark_mc_segmap_parloop_338759_err != 0) {
        err = futhark_mc_segmap_parloop_338759_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338759_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338759_total_end -
                 futhark_mc_segmap_parloop_338759_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338759_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338759_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338759_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_338757_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_338757_end -
                 futhark_mc_segmap_task_338757_start;
        
        ctx->futhark_mc_segmap_task_338757_runs[tid]++;
        ctx->futhark_mc_segmap_task_338757_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_338757_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
static int futhark_mc_segmap_parloop_338754(void *args, int64_t start,
                                            int64_t end, int flat_tid_307511,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338753
    *futhark_mc_segmap_parloop_struct_338753 =
    (struct futhark_mc_segmap_parloop_struct_338753 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338753->ctx;
    uint64_t futhark_mc_segmap_parloop_338754_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338754_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_338753->free_n_292675;
    int64_t n_p_292677 =
            futhark_mc_segmap_parloop_struct_338753->free_n_p_292677;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_338753->free_partition_sizze_292766;
    int64_t C_len_292823 =
            futhark_mc_segmap_parloop_struct_338753->free_C_len_292823;
    int64_t bytes_312598 =
            futhark_mc_segmap_parloop_struct_338753->free_bytes_312598;
    struct memblock mem_314946 = {.desc ="mem_314946", .mem =
                                  futhark_mc_segmap_parloop_struct_338753->free_mem_314946,
                                  .size =0, .references =NULL};
    struct memblock ext_mem_315633 = {.desc ="ext_mem_315633", .mem =
                                      futhark_mc_segmap_parloop_struct_338753->free_ext_mem_315633,
                                      .size =0, .references =NULL};
    int64_t ext_315634 =
            futhark_mc_segmap_parloop_struct_338753->free_ext_315634;
    struct memblock mem_315656 = {.desc ="mem_315656", .mem =
                                  futhark_mc_segmap_parloop_struct_338753->free_mem_315656,
                                  .size =0, .references =NULL};
    size_t mem_315637_cached_sizze_338755 = 0;
    unsigned char *mem_315637 = NULL;
    int64_t iterations = end - start;
    int64_t iter_332495 = start;
    
    if (mem_315637_cached_sizze_338755 < (size_t) bytes_312598) {
        mem_315637 = realloc(mem_315637, bytes_312598);
        mem_315637_cached_sizze_338755 = bytes_312598;
    }
    for (; iter_332495 < end; iter_332495++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_332502 = partition_sizze_292766;
        int64_t gtid_307512 = iter_332495;
        int64_t remnant_332503 = iter_332495 - gtid_307512;
        int64_t flat_tid_332496 = (int64_t) 0;
        int32_t num_tasks_332504;
        struct futhark_mc_task_338756 futhark_mc_task_338756;
        
        futhark_mc_task_338756.ctx = ctx;
        futhark_mc_task_338756.free_n_292675 = n_292675;
        futhark_mc_task_338756.free_n_p_292677 = n_p_292677;
        futhark_mc_task_338756.free_C_len_292823 = C_len_292823;
        futhark_mc_task_338756.free_gtid_307512 = gtid_307512;
        futhark_mc_task_338756.free_mem_314946 = mem_314946.mem;
        futhark_mc_task_338756.free_ext_mem_315633 = ext_mem_315633.mem;
        futhark_mc_task_338756.free_ext_315634 = ext_315634;
        futhark_mc_task_338756.free_mem_315637 = mem_315637;
        
        struct scheduler_segop futhark_mc_task_338756_task;
        
        futhark_mc_task_338756_task.args = &futhark_mc_task_338756;
        futhark_mc_task_338756_task.top_level_fn =
            futhark_mc_segmap_task_338757;
        futhark_mc_task_338756_task.name = "futhark_mc_segmap_task_338757";
        futhark_mc_task_338756_task.iterations = n_292675;
        futhark_mc_task_338756_task.task_time =
            &ctx->futhark_mc_segmap_task_338757_total_time;
        futhark_mc_task_338756_task.task_iter =
            &ctx->futhark_mc_segmap_task_338757_total_iter;
        futhark_mc_task_338756_task.sched = STATIC;
        futhark_mc_task_338756_task.nested_fn = NULL;
        
        int futhark_mc_segmap_task_338757_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_338756_task);
        
        if (futhark_mc_segmap_task_338757_err != 0) {
            ;
            err = futhark_mc_segmap_task_338757_err;
            goto cleanup;
        }
        if (n_292675 * (int64_t) 8 > 0)
            memmove(mem_315656.mem + gtid_307512 * n_292675 * (int64_t) 8,
                    mem_315637 + (int64_t) 0, n_292675 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_315637);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338754_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338754_end -
                 futhark_mc_segmap_parloop_338754_start;
        
        ctx->futhark_mc_segmap_parloop_338754_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338754_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338754_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_nested_task_338752(void *args, int64_t iterations,
                                         int tid, struct scheduler_info info)
{
    int err = 0;
    int flat_tid_307511 = tid;
    int num_tasks_332483 = info.nsubtasks;
    struct futhark_mc_task_338747 *futhark_mc_task_338747 =
                                  (struct futhark_mc_task_338747 *) args;
    struct futhark_context *ctx = futhark_mc_task_338747->ctx;
    uint64_t futhark_mc_segmap_nested_task_338752_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_nested_task_338752_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338747->free_n_292675;
    int64_t n_p_292677 = futhark_mc_task_338747->free_n_p_292677;
    int64_t partition_sizze_292766 =
            futhark_mc_task_338747->free_partition_sizze_292766;
    int64_t C_len_292823 = futhark_mc_task_338747->free_C_len_292823;
    int64_t bytes_312598 = futhark_mc_task_338747->free_bytes_312598;
    struct memblock mem_314946 = {.desc ="mem_314946", .mem =
                                  futhark_mc_task_338747->free_mem_314946,
                                  .size =0, .references =NULL};
    struct memblock ext_mem_315633 = {.desc ="ext_mem_315633", .mem =
                                      futhark_mc_task_338747->free_ext_mem_315633,
                                      .size =0, .references =NULL};
    int64_t ext_315634 = futhark_mc_task_338747->free_ext_315634;
    struct memblock mem_315656 = {.desc ="mem_315656", .mem =
                                  futhark_mc_task_338747->free_mem_315656,
                                  .size =0, .references =NULL};
    int64_t iter_332495;
    struct futhark_mc_segmap_parloop_struct_338753
    futhark_mc_segmap_parloop_struct_338753;
    
    futhark_mc_segmap_parloop_struct_338753.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338753.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_338753.free_n_p_292677 = n_p_292677;
    futhark_mc_segmap_parloop_struct_338753.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_338753.free_C_len_292823 = C_len_292823;
    futhark_mc_segmap_parloop_struct_338753.free_bytes_312598 = bytes_312598;
    futhark_mc_segmap_parloop_struct_338753.free_mem_314946 = mem_314946.mem;
    futhark_mc_segmap_parloop_struct_338753.free_ext_mem_315633 =
        ext_mem_315633.mem;
    futhark_mc_segmap_parloop_struct_338753.free_ext_315634 = ext_315634;
    futhark_mc_segmap_parloop_struct_338753.free_mem_315656 = mem_315656.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338754_task;
    
    futhark_mc_segmap_parloop_338754_task.name =
        "futhark_mc_segmap_parloop_338754";
    futhark_mc_segmap_parloop_338754_task.fn = futhark_mc_segmap_parloop_338754;
    futhark_mc_segmap_parloop_338754_task.args =
        &futhark_mc_segmap_parloop_struct_338753;
    futhark_mc_segmap_parloop_338754_task.iterations = iterations;
    futhark_mc_segmap_parloop_338754_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338754_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338754_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338754_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338754_task);
    
    if (futhark_mc_segmap_parloop_338754_err != 0) {
        err = futhark_mc_segmap_parloop_338754_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338754_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338754_total_end -
                 futhark_mc_segmap_parloop_338754_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338754_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338754_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338754_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_nested_task_338752_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_nested_task_338752_end -
                 futhark_mc_segmap_nested_task_338752_start;
        
        ctx->futhark_mc_segmap_nested_task_338752_runs[tid]++;
        ctx->futhark_mc_segmap_nested_task_338752_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_nested_task_338752_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_task_338760 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_t_292679;
    int64_t free_jump_t_292685;
    int64_t free_partition_sizze_292766;
    int64_t free_t_n_m_292839;
    int64_t free_i_292846;
    unsigned char *free_mem_312593;
    int64_t free_bytes_312598;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_312639;
    int64_t free_bytes_313090;
    unsigned char *free_mem_313143;
    unsigned char *free_mem_313147;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315656;
    unsigned char *free_mem_315736;
};
struct futhark_mc_segmap_parloop_struct_338762 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_t_292679;
    int64_t free_jump_t_292685;
    int64_t free_partition_sizze_292766;
    int64_t free_t_n_m_292839;
    int64_t free_i_292846;
    unsigned char *free_mem_312593;
    int64_t free_bytes_312598;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_312639;
    int64_t free_bytes_313090;
    unsigned char *free_mem_313143;
    unsigned char *free_mem_313147;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315656;
    unsigned char *free_mem_315736;
};
static int futhark_mc_segmap_parloop_338763(void *args, int64_t start,
                                            int64_t end, int flat_tid_307521,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338762
    *futhark_mc_segmap_parloop_struct_338762 =
    (struct futhark_mc_segmap_parloop_struct_338762 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338762->ctx;
    uint64_t futhark_mc_segmap_parloop_338763_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338763_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_338762->free_n_292675;
    int64_t q_t_292679 =
            futhark_mc_segmap_parloop_struct_338762->free_q_t_292679;
    int64_t jump_t_292685 =
            futhark_mc_segmap_parloop_struct_338762->free_jump_t_292685;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_338762->free_partition_sizze_292766;
    int64_t t_n_m_292839 =
            futhark_mc_segmap_parloop_struct_338762->free_t_n_m_292839;
    int64_t i_292846 = futhark_mc_segmap_parloop_struct_338762->free_i_292846;
    struct memblock mem_312593 = {.desc ="mem_312593", .mem =
                                  futhark_mc_segmap_parloop_struct_338762->free_mem_312593,
                                  .size =0, .references =NULL};
    int64_t bytes_312598 =
            futhark_mc_segmap_parloop_struct_338762->free_bytes_312598;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_segmap_parloop_struct_338762->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_312639 = {.desc ="mem_312639", .mem =
                                  futhark_mc_segmap_parloop_struct_338762->free_mem_312639,
                                  .size =0, .references =NULL};
    int64_t bytes_313090 =
            futhark_mc_segmap_parloop_struct_338762->free_bytes_313090;
    struct memblock mem_313143 = {.desc ="mem_313143", .mem =
                                  futhark_mc_segmap_parloop_struct_338762->free_mem_313143,
                                  .size =0, .references =NULL};
    struct memblock mem_313147 = {.desc ="mem_313147", .mem =
                                  futhark_mc_segmap_parloop_struct_338762->free_mem_313147,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_segmap_parloop_struct_338762->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_segmap_parloop_struct_338762->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_segmap_parloop_struct_338762->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_segmap_parloop_struct_338762->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315656 = {.desc ="mem_315656", .mem =
                                  futhark_mc_segmap_parloop_struct_338762->free_mem_315656,
                                  .size =0, .references =NULL};
    struct memblock mem_315736 = {.desc ="mem_315736", .mem =
                                  futhark_mc_segmap_parloop_struct_338762->free_mem_315736,
                                  .size =0, .references =NULL};
    size_t mem_315675_cached_sizze_338764 = 0;
    unsigned char *mem_315675 = NULL;
    size_t mem_315690_cached_sizze_338765 = 0;
    unsigned char *mem_315690 = NULL;
    size_t mem_315693_cached_sizze_338766 = 0;
    unsigned char *mem_315693 = NULL;
    size_t mem_315720_cached_sizze_338767 = 0;
    unsigned char *mem_315720 = NULL;
    int64_t iterations = end - start;
    int64_t iter_332511 = start;
    
    if (mem_315675_cached_sizze_338764 < (size_t) bytes_312598) {
        mem_315675 = realloc(mem_315675, bytes_312598);
        mem_315675_cached_sizze_338764 = bytes_312598;
    }
    if (mem_315690_cached_sizze_338765 < (size_t) bytes_312598) {
        mem_315690 = realloc(mem_315690, bytes_312598);
        mem_315690_cached_sizze_338765 = bytes_312598;
    }
    if (mem_315693_cached_sizze_338766 < (size_t) bytes_312598) {
        mem_315693 = realloc(mem_315693, bytes_312598);
        mem_315693_cached_sizze_338766 = bytes_312598;
    }
    if (mem_315720_cached_sizze_338767 < (size_t) bytes_313090) {
        mem_315720 = realloc(mem_315720, bytes_313090);
        mem_315720_cached_sizze_338767 = bytes_313090;
    }
    for (; iter_332511 < end; iter_332511++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_332595 = partition_sizze_292766;
        int64_t gtid_307522 = iter_332511;
        int64_t remnant_332596 = iter_332511 - gtid_307522;
        int64_t x_295818;
        
        x_295818 = ((int64_t *) mem_312639.mem)[gtid_307522];
        for (int64_t i_332512 = 0; i_332512 < n_292675; i_332512++) {
            float x_332514;
            
            x_332514 = ((float *) mem_312593.mem)[gtid_307522 * n_292675 +
                                                  i_332512];
            
            double x_332515;
            
            x_332515 = ((double *) mem_315656.mem)[gtid_307522 * n_292675 +
                                                   i_332512];
            
            double f32_res_332516 = fpconv_f32_f64(x_332514);
            double defunc_1_f_res_332517 = f32_res_332516 - x_332515;
            
            ((double *) mem_315675)[i_332512] = defunc_1_f_res_332517;
        }
        for (int64_t i_332519 = 0; i_332519 < n_292675; i_332519++) {
            int64_t x_332522;
            
            x_332522 = ((int64_t *) mem_312636.mem)[gtid_307522 * n_292675 +
                                                    i_332519];
            
            bool cond_332523 = sle64((int64_t) 0, x_332522);
            double defunc_0_f_res_332524;
            
            if (cond_332523) {
                bool y_332525 = slt64(x_332522, n_292675);
                bool bounds_check_332526 = cond_332523 && y_332525;
                bool index_certs_332527;
                
                if (!bounds_check_332526) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [", (long long) x_332522,
                                  "] out of bounds for array of shape [",
                                  (long long) n_292675, "].",
                                  "-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:45:43-70\n   #3  stl.fut:285:33-58\n   #4  /prelude/soacs.fut:75:22-28\n   #5  /prelude/soacs.fut:75:3-45\n   #6  stl.fut:283:13-288:41\n   #7  stl.fut:419:61-435:77\n   #8  stl.fut:463:3-479:36\n   #9  stl.fut:445:1-479:36\n");
                    err = FUTHARK_PROGRAM_ERROR;
                    goto cleanup;
                }
                
                double defunc_0_f_res_t_res_332528;
                
                defunc_0_f_res_t_res_332528 = ((double *) mem_315675)[x_332522];
                defunc_0_f_res_332524 = defunc_0_f_res_t_res_332528;
            } else {
                defunc_0_f_res_332524 = 0.0;
            }
            
            double defunc_0_f_res_332529;
            
            if (cond_332523) {
                bool y_332530 = slt64(x_332522, n_292675);
                bool bounds_check_332531 = cond_332523 && y_332530;
                bool index_certs_332532;
                
                if (!bounds_check_332531) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [", (long long) x_332522,
                                  "] out of bounds for array of shape [",
                                  (long long) n_292675, "].",
                                  "-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:45:43-70\n   #3  stl.fut:286:33-64\n   #4  /prelude/soacs.fut:75:22-28\n   #5  /prelude/soacs.fut:75:3-45\n   #6  stl.fut:283:13-288:41\n   #7  stl.fut:419:61-435:77\n   #8  stl.fut:463:3-479:36\n   #9  stl.fut:445:1-479:36\n");
                    err = FUTHARK_PROGRAM_ERROR;
                    goto cleanup;
                }
                
                double defunc_0_f_res_t_res_332533;
                
                defunc_0_f_res_t_res_332533 =
                    ((double *) mem_param_313179.mem)[ctx_param_ext_313174 +
                                                      (gtid_307522 *
                                                       ctx_param_ext_313175 +
                                                       x_332522 *
                                                       ctx_param_ext_313177)];
                defunc_0_f_res_332529 = defunc_0_f_res_t_res_332533;
            } else {
                defunc_0_f_res_332529 = 0.0;
            }
            ((double *) mem_315690)[i_332519] = defunc_0_f_res_332529;
            ((double *) mem_315693)[i_332519] = defunc_0_f_res_332524;
        }
        for (int64_t i_332536 = 0; i_332536 < t_n_m_292839; i_332536++) {
            int64_t x_332538;
            
            x_332538 = ((int64_t *) mem_313143.mem)[gtid_307522 * t_n_m_292839 +
                                                    i_332536];
            
            double x_332539;
            
            x_332539 = ((double *) mem_313147.mem)[gtid_307522 * t_n_m_292839 +
                                                   i_332536];
            
            int64_t min_arg_332540 = mul64(jump_t_292685, i_332536);
            int64_t min_res_332541 = smin64(i_292846, min_arg_332540);
            int64_t defunc_0_g_res_332542 = add64((int64_t) 1, min_res_332541);
            double defunc_2_reduce_res_332543;
            double redout_332545 = 0.0;
            
            for (int64_t i_332544 = 0; i_332544 < q_t_292679; i_332544++) {
                bool cond_332546 = sle64(x_295818, i_332544);
                int64_t defunc_0_f_res_332547;
                
                if (cond_332546) {
                    defunc_0_f_res_332547 = (int64_t) 0;
                } else {
                    int64_t i_332548 = add64(x_332538, i_332544);
                    int64_t defunc_0_add_arg_332549;
                    
                    defunc_0_add_arg_332549 =
                        ((int64_t *) mem_312636.mem)[gtid_307522 * n_292675 +
                                                     i_332548];
                    
                    int64_t defunc_1_add_res_332550 = add64((int64_t) 1,
                                                            defunc_0_add_arg_332549);
                    
                    defunc_0_f_res_332547 = defunc_1_add_res_332550;
                }
                
                double defunc_0_f_res_332551;
                
                if (cond_332546) {
                    defunc_0_f_res_332551 = 0.0;
                } else {
                    int64_t i_332552 = add64(x_332538, i_332544);
                    double defunc_0_add_arg_332553;
                    
                    defunc_0_add_arg_332553 = ((double *) mem_315690)[i_332552];
                    defunc_0_f_res_332551 = defunc_0_add_arg_332553;
                }
                
                int64_t binop_p_332554 = sub64(defunc_0_f_res_332547,
                                               defunc_0_g_res_332542);
                double defunc_0_f_res_332555 = sitofp_i64_f64(binop_p_332554);
                double abs_res_332556 = fabs(defunc_0_f_res_332555);
                double tmp1_332557 = abs_res_332556 / x_332539;
                double x_332558 = tmp1_332557 * tmp1_332557;
                double y_332559 = tmp1_332557 * x_332558;
                double tmp2_332560 = 1.0 - y_332559;
                double x_332561 = tmp2_332560 * tmp2_332560;
                double tmp3_332562 = tmp2_332560 * x_332561;
                double w_j_332563 = defunc_0_f_res_332551 * tmp3_332562;
                double defunc_1_op_res_332564 = w_j_332563 + redout_332545;
                double redout_tmp_332601 = defunc_1_op_res_332564;
                
                redout_332545 = redout_tmp_332601;
            }
            defunc_2_reduce_res_332543 = redout_332545;
            
            double a_332565 = 2.220446049250313e-16 +
                   defunc_2_reduce_res_332543;
            double a0_332566 = 1.0 / a_332565;
            double defunc_2_reduce_res_332567;
            double redout_332569 = 0.0;
            
            for (int64_t i_332568 = 0; i_332568 < q_t_292679; i_332568++) {
                bool cond_332570 = sle64(x_295818, i_332568);
                int64_t defunc_0_f_res_332571;
                
                if (cond_332570) {
                    defunc_0_f_res_332571 = (int64_t) 0;
                } else {
                    int64_t i_332572 = add64(x_332538, i_332568);
                    int64_t defunc_0_add_arg_332573;
                    
                    defunc_0_add_arg_332573 =
                        ((int64_t *) mem_312636.mem)[gtid_307522 * n_292675 +
                                                     i_332572];
                    
                    int64_t defunc_1_add_res_332574 = add64((int64_t) 1,
                                                            defunc_0_add_arg_332573);
                    
                    defunc_0_f_res_332571 = defunc_1_add_res_332574;
                }
                
                double defunc_0_f_res_332575;
                
                if (cond_332570) {
                    defunc_0_f_res_332575 = 0.0;
                } else {
                    int64_t i_332576 = add64(x_332538, i_332568);
                    double defunc_0_add_arg_332577;
                    
                    defunc_0_add_arg_332577 = ((double *) mem_315690)[i_332576];
                    defunc_0_f_res_332575 = defunc_0_add_arg_332577;
                }
                
                int64_t binop_p_332578 = sub64(defunc_0_f_res_332571,
                                               defunc_0_g_res_332542);
                double defunc_0_f_res_332579 = sitofp_i64_f64(binop_p_332578);
                double abs_res_332580 = fabs(defunc_0_f_res_332579);
                double tmp1_332581 = abs_res_332580 / x_332539;
                double x_332582 = tmp1_332581 * tmp1_332581;
                double y_332583 = tmp1_332581 * x_332582;
                double tmp2_332584 = 1.0 - y_332583;
                double x_332585 = tmp2_332584 * tmp2_332584;
                double tmp3_332586 = tmp2_332584 * x_332585;
                double tmp4_332587 = defunc_0_f_res_332575 * tmp3_332586;
                double defunc_0_f_res_332588;
                
                if (cond_332570) {
                    defunc_0_f_res_332588 = 0.0;
                } else {
                    int64_t i_332589 = add64(x_332538, i_332568);
                    double defunc_0_add_arg_332590;
                    
                    defunc_0_add_arg_332590 = ((double *) mem_315693)[i_332589];
                    defunc_0_f_res_332588 = defunc_0_add_arg_332590;
                }
                
                double x_332591 = a0_332566 * tmp4_332587;
                double defunc_9_fit_fun_res_332592 = defunc_0_f_res_332588 *
                       x_332591;
                double defunc_1_op_res_332593 = defunc_9_fit_fun_res_332592 +
                       redout_332569;
                double redout_tmp_332602 = defunc_1_op_res_332593;
                
                redout_332569 = redout_tmp_332602;
            }
            defunc_2_reduce_res_332567 = redout_332569;
            ((double *) mem_315720)[i_332536] = defunc_2_reduce_res_332567;
        }
        if (t_n_m_292839 * (int64_t) 8 > 0)
            memmove(mem_315736.mem + gtid_307522 * t_n_m_292839 * (int64_t) 8,
                    mem_315720 + (int64_t) 0, t_n_m_292839 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_315675);
    free(mem_315690);
    free(mem_315693);
    free(mem_315720);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338763_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338763_end -
                 futhark_mc_segmap_parloop_338763_start;
        
        ctx->futhark_mc_segmap_parloop_338763_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338763_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338763_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_338761(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_307521 = tid;
    int num_tasks_332510 = info.nsubtasks;
    struct futhark_mc_task_338760 *futhark_mc_task_338760 =
                                  (struct futhark_mc_task_338760 *) args;
    struct futhark_context *ctx = futhark_mc_task_338760->ctx;
    uint64_t futhark_mc_segmap_task_338761_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_338761_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338760->free_n_292675;
    int64_t q_t_292679 = futhark_mc_task_338760->free_q_t_292679;
    int64_t jump_t_292685 = futhark_mc_task_338760->free_jump_t_292685;
    int64_t partition_sizze_292766 =
            futhark_mc_task_338760->free_partition_sizze_292766;
    int64_t t_n_m_292839 = futhark_mc_task_338760->free_t_n_m_292839;
    int64_t i_292846 = futhark_mc_task_338760->free_i_292846;
    struct memblock mem_312593 = {.desc ="mem_312593", .mem =
                                  futhark_mc_task_338760->free_mem_312593,
                                  .size =0, .references =NULL};
    int64_t bytes_312598 = futhark_mc_task_338760->free_bytes_312598;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_task_338760->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_312639 = {.desc ="mem_312639", .mem =
                                  futhark_mc_task_338760->free_mem_312639,
                                  .size =0, .references =NULL};
    int64_t bytes_313090 = futhark_mc_task_338760->free_bytes_313090;
    struct memblock mem_313143 = {.desc ="mem_313143", .mem =
                                  futhark_mc_task_338760->free_mem_313143,
                                  .size =0, .references =NULL};
    struct memblock mem_313147 = {.desc ="mem_313147", .mem =
                                  futhark_mc_task_338760->free_mem_313147,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_task_338760->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_task_338760->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_task_338760->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_task_338760->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315656 = {.desc ="mem_315656", .mem =
                                  futhark_mc_task_338760->free_mem_315656,
                                  .size =0, .references =NULL};
    struct memblock mem_315736 = {.desc ="mem_315736", .mem =
                                  futhark_mc_task_338760->free_mem_315736,
                                  .size =0, .references =NULL};
    int64_t iter_332511;
    struct futhark_mc_segmap_parloop_struct_338762
    futhark_mc_segmap_parloop_struct_338762;
    
    futhark_mc_segmap_parloop_struct_338762.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338762.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_338762.free_q_t_292679 = q_t_292679;
    futhark_mc_segmap_parloop_struct_338762.free_jump_t_292685 = jump_t_292685;
    futhark_mc_segmap_parloop_struct_338762.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_338762.free_t_n_m_292839 = t_n_m_292839;
    futhark_mc_segmap_parloop_struct_338762.free_i_292846 = i_292846;
    futhark_mc_segmap_parloop_struct_338762.free_mem_312593 = mem_312593.mem;
    futhark_mc_segmap_parloop_struct_338762.free_bytes_312598 = bytes_312598;
    futhark_mc_segmap_parloop_struct_338762.free_mem_312636 = mem_312636.mem;
    futhark_mc_segmap_parloop_struct_338762.free_mem_312639 = mem_312639.mem;
    futhark_mc_segmap_parloop_struct_338762.free_bytes_313090 = bytes_313090;
    futhark_mc_segmap_parloop_struct_338762.free_mem_313143 = mem_313143.mem;
    futhark_mc_segmap_parloop_struct_338762.free_mem_313147 = mem_313147.mem;
    futhark_mc_segmap_parloop_struct_338762.free_ctx_param_ext_313174 =
        ctx_param_ext_313174;
    futhark_mc_segmap_parloop_struct_338762.free_ctx_param_ext_313175 =
        ctx_param_ext_313175;
    futhark_mc_segmap_parloop_struct_338762.free_ctx_param_ext_313177 =
        ctx_param_ext_313177;
    futhark_mc_segmap_parloop_struct_338762.free_mem_param_313179 =
        mem_param_313179.mem;
    futhark_mc_segmap_parloop_struct_338762.free_mem_315656 = mem_315656.mem;
    futhark_mc_segmap_parloop_struct_338762.free_mem_315736 = mem_315736.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338763_task;
    
    futhark_mc_segmap_parloop_338763_task.name =
        "futhark_mc_segmap_parloop_338763";
    futhark_mc_segmap_parloop_338763_task.fn = futhark_mc_segmap_parloop_338763;
    futhark_mc_segmap_parloop_338763_task.args =
        &futhark_mc_segmap_parloop_struct_338762;
    futhark_mc_segmap_parloop_338763_task.iterations = iterations;
    futhark_mc_segmap_parloop_338763_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338763_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338763_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338763_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338763_task);
    
    if (futhark_mc_segmap_parloop_338763_err != 0) {
        err = futhark_mc_segmap_parloop_338763_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338763_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338763_total_end -
                 futhark_mc_segmap_parloop_338763_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338763_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338763_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338763_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_338761_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_338761_end -
                 futhark_mc_segmap_task_338761_start;
        
        ctx->futhark_mc_segmap_task_338761_runs[tid]++;
        ctx->futhark_mc_segmap_task_338761_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_338761_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_segmap_parloop_struct_338769 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_t_292679;
    int64_t free_jump_t_292685;
    int64_t free_partition_sizze_292766;
    int64_t free_t_n_m_292839;
    int64_t free_i_292846;
    unsigned char *free_mem_312593;
    int64_t free_bytes_312598;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_312639;
    int64_t free_bytes_313090;
    unsigned char *free_mem_313143;
    unsigned char *free_mem_313147;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315656;
    unsigned char *free_mem_315736;
};
struct futhark_mc_task_338775 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_307603;
    unsigned char *free_mem_312593;
    unsigned char *free_mem_315656;
    unsigned char *free_mem_315663;
};
struct futhark_mc_segmap_parloop_struct_338777 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_307603;
    unsigned char *free_mem_312593;
    unsigned char *free_mem_315656;
    unsigned char *free_mem_315663;
};
static int futhark_mc_segmap_parloop_338778(void *args, int64_t start,
                                            int64_t end, int flat_tid_332604,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338777
    *futhark_mc_segmap_parloop_struct_338777 =
    (struct futhark_mc_segmap_parloop_struct_338777 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338777->ctx;
    uint64_t futhark_mc_segmap_parloop_338778_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338778_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_338777->free_n_292675;
    int64_t gtid_307603 =
            futhark_mc_segmap_parloop_struct_338777->free_gtid_307603;
    struct memblock mem_312593 = {.desc ="mem_312593", .mem =
                                  futhark_mc_segmap_parloop_struct_338777->free_mem_312593,
                                  .size =0, .references =NULL};
    struct memblock mem_315656 = {.desc ="mem_315656", .mem =
                                  futhark_mc_segmap_parloop_struct_338777->free_mem_315656,
                                  .size =0, .references =NULL};
    struct memblock mem_315663 = {.desc ="mem_315663", .mem =
                                  futhark_mc_segmap_parloop_struct_338777->free_mem_315663,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_332747 = start;
    
    for (; iter_332747 < end; iter_332747++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_332748 = n_292675;
        int64_t gtid_332605 = iter_332747;
        int64_t remnant_332749 = iter_332747 - gtid_332605;
        float x_332606;
        
        x_332606 = ((float *) mem_312593.mem)[gtid_307603 * n_292675 +
                                              gtid_332605];
        
        double x_332607;
        
        x_332607 = ((double *) mem_315656.mem)[gtid_307603 * n_292675 +
                                               gtid_332605];
        
        double f32_res_332608 = fpconv_f32_f64(x_332606);
        double defunc_1_f_res_332609 = f32_res_332608 - x_332607;
        
        ((double *) mem_315663.mem)[gtid_332605] = defunc_1_f_res_332609;
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338778_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338778_end -
                 futhark_mc_segmap_parloop_338778_start;
        
        ctx->futhark_mc_segmap_parloop_338778_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338778_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338778_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_338776(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_332604 = tid;
    int num_tasks_332746 = info.nsubtasks;
    struct futhark_mc_task_338775 *futhark_mc_task_338775 =
                                  (struct futhark_mc_task_338775 *) args;
    struct futhark_context *ctx = futhark_mc_task_338775->ctx;
    uint64_t futhark_mc_segmap_task_338776_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_338776_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338775->free_n_292675;
    int64_t gtid_307603 = futhark_mc_task_338775->free_gtid_307603;
    struct memblock mem_312593 = {.desc ="mem_312593", .mem =
                                  futhark_mc_task_338775->free_mem_312593,
                                  .size =0, .references =NULL};
    struct memblock mem_315656 = {.desc ="mem_315656", .mem =
                                  futhark_mc_task_338775->free_mem_315656,
                                  .size =0, .references =NULL};
    struct memblock mem_315663 = {.desc ="mem_315663", .mem =
                                  futhark_mc_task_338775->free_mem_315663,
                                  .size =0, .references =NULL};
    int64_t iter_332747;
    struct futhark_mc_segmap_parloop_struct_338777
    futhark_mc_segmap_parloop_struct_338777;
    
    futhark_mc_segmap_parloop_struct_338777.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338777.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_338777.free_gtid_307603 = gtid_307603;
    futhark_mc_segmap_parloop_struct_338777.free_mem_312593 = mem_312593.mem;
    futhark_mc_segmap_parloop_struct_338777.free_mem_315656 = mem_315656.mem;
    futhark_mc_segmap_parloop_struct_338777.free_mem_315663 = mem_315663.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338778_task;
    
    futhark_mc_segmap_parloop_338778_task.name =
        "futhark_mc_segmap_parloop_338778";
    futhark_mc_segmap_parloop_338778_task.fn = futhark_mc_segmap_parloop_338778;
    futhark_mc_segmap_parloop_338778_task.args =
        &futhark_mc_segmap_parloop_struct_338777;
    futhark_mc_segmap_parloop_338778_task.iterations = iterations;
    futhark_mc_segmap_parloop_338778_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338778_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338778_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338778_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338778_task);
    
    if (futhark_mc_segmap_parloop_338778_err != 0) {
        err = futhark_mc_segmap_parloop_338778_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338778_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338778_total_end -
                 futhark_mc_segmap_parloop_338778_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338778_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338778_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338778_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_338776_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_338776_end -
                 futhark_mc_segmap_task_338776_start;
        
        ctx->futhark_mc_segmap_task_338776_runs[tid]++;
        ctx->futhark_mc_segmap_task_338776_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_338776_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_task_338779 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_307603;
    unsigned char *free_mem_312636;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315663;
    unsigned char *free_mem_315666;
    unsigned char *free_mem_315669;
};
struct futhark_mc_segmap_parloop_struct_338781 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_307603;
    unsigned char *free_mem_312636;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315663;
    unsigned char *free_mem_315666;
    unsigned char *free_mem_315669;
};
static int futhark_mc_segmap_parloop_338782(void *args, int64_t start,
                                            int64_t end, int flat_tid_332610,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338781
    *futhark_mc_segmap_parloop_struct_338781 =
    (struct futhark_mc_segmap_parloop_struct_338781 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338781->ctx;
    uint64_t futhark_mc_segmap_parloop_338782_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338782_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_338781->free_n_292675;
    int64_t gtid_307603 =
            futhark_mc_segmap_parloop_struct_338781->free_gtid_307603;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_segmap_parloop_struct_338781->free_mem_312636,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_segmap_parloop_struct_338781->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_segmap_parloop_struct_338781->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_segmap_parloop_struct_338781->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_segmap_parloop_struct_338781->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315663 = {.desc ="mem_315663", .mem =
                                  futhark_mc_segmap_parloop_struct_338781->free_mem_315663,
                                  .size =0, .references =NULL};
    struct memblock mem_315666 = {.desc ="mem_315666", .mem =
                                  futhark_mc_segmap_parloop_struct_338781->free_mem_315666,
                                  .size =0, .references =NULL};
    struct memblock mem_315669 = {.desc ="mem_315669", .mem =
                                  futhark_mc_segmap_parloop_struct_338781->free_mem_315669,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_332751 = start;
    
    for (; iter_332751 < end; iter_332751++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_332760 = n_292675;
        int64_t gtid_332611 = iter_332751;
        int64_t remnant_332761 = iter_332751 - gtid_332611;
        int64_t x_332612;
        
        x_332612 = ((int64_t *) mem_312636.mem)[gtid_307603 * n_292675 +
                                                gtid_332611];
        
        bool cond_332613 = sle64((int64_t) 0, x_332612);
        double defunc_0_f_res_332614;
        
        if (cond_332613) {
            bool y_332752 = slt64(x_332612, n_292675);
            bool bounds_check_332753 = cond_332613 && y_332752;
            bool index_certs_332754;
            
            if (!bounds_check_332753) {
                ctx->error =
                    msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                              "Index [", (long long) x_332612,
                              "] out of bounds for array of shape [",
                              (long long) n_292675, "].",
                              "-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:45:43-70\n   #3  stl.fut:285:33-58\n   #4  /prelude/soacs.fut:75:22-28\n   #5  /prelude/soacs.fut:75:3-45\n   #6  stl.fut:283:13-288:41\n   #7  stl.fut:419:61-435:77\n   #8  stl.fut:463:3-479:36\n   #9  stl.fut:445:1-479:36\n");
                err = FUTHARK_PROGRAM_ERROR;
                goto cleanup;
            }
            
            double defunc_0_f_res_t_res_332755;
            
            defunc_0_f_res_t_res_332755 = ((double *) mem_315663.mem)[x_332612];
            defunc_0_f_res_332614 = defunc_0_f_res_t_res_332755;
        } else {
            defunc_0_f_res_332614 = 0.0;
        }
        
        double defunc_0_f_res_332619;
        
        if (cond_332613) {
            bool y_332756 = slt64(x_332612, n_292675);
            bool bounds_check_332757 = cond_332613 && y_332756;
            bool index_certs_332758;
            
            if (!bounds_check_332757) {
                ctx->error =
                    msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                              "Index [", (long long) x_332612,
                              "] out of bounds for array of shape [",
                              (long long) n_292675, "].",
                              "-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:45:43-70\n   #3  stl.fut:286:33-64\n   #4  /prelude/soacs.fut:75:22-28\n   #5  /prelude/soacs.fut:75:3-45\n   #6  stl.fut:283:13-288:41\n   #7  stl.fut:419:61-435:77\n   #8  stl.fut:463:3-479:36\n   #9  stl.fut:445:1-479:36\n");
                err = FUTHARK_PROGRAM_ERROR;
                goto cleanup;
            }
            
            double defunc_0_f_res_t_res_332759;
            
            defunc_0_f_res_t_res_332759 =
                ((double *) mem_param_313179.mem)[ctx_param_ext_313174 +
                                                  (gtid_307603 *
                                                   ctx_param_ext_313175 +
                                                   x_332612 *
                                                   ctx_param_ext_313177)];
            defunc_0_f_res_332619 = defunc_0_f_res_t_res_332759;
        } else {
            defunc_0_f_res_332619 = 0.0;
        }
        ((double *) mem_315666.mem)[gtid_332611] = defunc_0_f_res_332619;
        ((double *) mem_315669.mem)[gtid_332611] = defunc_0_f_res_332614;
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338782_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338782_end -
                 futhark_mc_segmap_parloop_338782_start;
        
        ctx->futhark_mc_segmap_parloop_338782_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338782_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338782_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_338780(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_332610 = tid;
    int num_tasks_332750 = info.nsubtasks;
    struct futhark_mc_task_338779 *futhark_mc_task_338779 =
                                  (struct futhark_mc_task_338779 *) args;
    struct futhark_context *ctx = futhark_mc_task_338779->ctx;
    uint64_t futhark_mc_segmap_task_338780_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_338780_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338779->free_n_292675;
    int64_t gtid_307603 = futhark_mc_task_338779->free_gtid_307603;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_task_338779->free_mem_312636,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_task_338779->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_task_338779->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_task_338779->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_task_338779->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315663 = {.desc ="mem_315663", .mem =
                                  futhark_mc_task_338779->free_mem_315663,
                                  .size =0, .references =NULL};
    struct memblock mem_315666 = {.desc ="mem_315666", .mem =
                                  futhark_mc_task_338779->free_mem_315666,
                                  .size =0, .references =NULL};
    struct memblock mem_315669 = {.desc ="mem_315669", .mem =
                                  futhark_mc_task_338779->free_mem_315669,
                                  .size =0, .references =NULL};
    int64_t iter_332751;
    struct futhark_mc_segmap_parloop_struct_338781
    futhark_mc_segmap_parloop_struct_338781;
    
    futhark_mc_segmap_parloop_struct_338781.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338781.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_338781.free_gtid_307603 = gtid_307603;
    futhark_mc_segmap_parloop_struct_338781.free_mem_312636 = mem_312636.mem;
    futhark_mc_segmap_parloop_struct_338781.free_ctx_param_ext_313174 =
        ctx_param_ext_313174;
    futhark_mc_segmap_parloop_struct_338781.free_ctx_param_ext_313175 =
        ctx_param_ext_313175;
    futhark_mc_segmap_parloop_struct_338781.free_ctx_param_ext_313177 =
        ctx_param_ext_313177;
    futhark_mc_segmap_parloop_struct_338781.free_mem_param_313179 =
        mem_param_313179.mem;
    futhark_mc_segmap_parloop_struct_338781.free_mem_315663 = mem_315663.mem;
    futhark_mc_segmap_parloop_struct_338781.free_mem_315666 = mem_315666.mem;
    futhark_mc_segmap_parloop_struct_338781.free_mem_315669 = mem_315669.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338782_task;
    
    futhark_mc_segmap_parloop_338782_task.name =
        "futhark_mc_segmap_parloop_338782";
    futhark_mc_segmap_parloop_338782_task.fn = futhark_mc_segmap_parloop_338782;
    futhark_mc_segmap_parloop_338782_task.args =
        &futhark_mc_segmap_parloop_struct_338781;
    futhark_mc_segmap_parloop_338782_task.iterations = iterations;
    futhark_mc_segmap_parloop_338782_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338782_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338782_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338782_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338782_task);
    
    if (futhark_mc_segmap_parloop_338782_err != 0) {
        err = futhark_mc_segmap_parloop_338782_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338782_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338782_total_end -
                 futhark_mc_segmap_parloop_338782_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338782_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338782_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338782_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_338780_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_338780_end -
                 futhark_mc_segmap_task_338780_start;
        
        ctx->futhark_mc_segmap_task_338780_runs[tid]++;
        ctx->futhark_mc_segmap_task_338780_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_338780_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_task_338783 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_t_292679;
    int64_t free_jump_t_292685;
    int64_t free_t_n_m_292839;
    int64_t free_i_292846;
    int64_t free_gtid_307603;
    int64_t free_x_307608;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_313143;
    unsigned char *free_mem_313147;
    unsigned char *free_mem_315666;
    unsigned char *free_mem_315669;
    unsigned char *free_mem_315672;
};
struct futhark_mc_segmap_parloop_struct_338785 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_t_292679;
    int64_t free_jump_t_292685;
    int64_t free_t_n_m_292839;
    int64_t free_i_292846;
    int64_t free_gtid_307603;
    int64_t free_x_307608;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_313143;
    unsigned char *free_mem_313147;
    unsigned char *free_mem_315666;
    unsigned char *free_mem_315669;
    unsigned char *free_mem_315672;
};
static int futhark_mc_segmap_parloop_338786(void *args, int64_t start,
                                            int64_t end, int flat_tid_332686,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338785
    *futhark_mc_segmap_parloop_struct_338785 =
    (struct futhark_mc_segmap_parloop_struct_338785 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338785->ctx;
    uint64_t futhark_mc_segmap_parloop_338786_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338786_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_338785->free_n_292675;
    int64_t q_t_292679 =
            futhark_mc_segmap_parloop_struct_338785->free_q_t_292679;
    int64_t jump_t_292685 =
            futhark_mc_segmap_parloop_struct_338785->free_jump_t_292685;
    int64_t t_n_m_292839 =
            futhark_mc_segmap_parloop_struct_338785->free_t_n_m_292839;
    int64_t i_292846 = futhark_mc_segmap_parloop_struct_338785->free_i_292846;
    int64_t gtid_307603 =
            futhark_mc_segmap_parloop_struct_338785->free_gtid_307603;
    int64_t x_307608 = futhark_mc_segmap_parloop_struct_338785->free_x_307608;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_segmap_parloop_struct_338785->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_313143 = {.desc ="mem_313143", .mem =
                                  futhark_mc_segmap_parloop_struct_338785->free_mem_313143,
                                  .size =0, .references =NULL};
    struct memblock mem_313147 = {.desc ="mem_313147", .mem =
                                  futhark_mc_segmap_parloop_struct_338785->free_mem_313147,
                                  .size =0, .references =NULL};
    struct memblock mem_315666 = {.desc ="mem_315666", .mem =
                                  futhark_mc_segmap_parloop_struct_338785->free_mem_315666,
                                  .size =0, .references =NULL};
    struct memblock mem_315669 = {.desc ="mem_315669", .mem =
                                  futhark_mc_segmap_parloop_struct_338785->free_mem_315669,
                                  .size =0, .references =NULL};
    struct memblock mem_315672 = {.desc ="mem_315672", .mem =
                                  futhark_mc_segmap_parloop_struct_338785->free_mem_315672,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_332763 = start;
    
    for (; iter_332763 < end; iter_332763++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_332811 = t_n_m_292839;
        int64_t gtid_332687 = iter_332763;
        int64_t remnant_332812 = iter_332763 - gtid_332687;
        int64_t x_332688;
        
        x_332688 = ((int64_t *) mem_313143.mem)[gtid_307603 * t_n_m_292839 +
                                                gtid_332687];
        
        double x_332689;
        
        x_332689 = ((double *) mem_313147.mem)[gtid_307603 * t_n_m_292839 +
                                               gtid_332687];
        
        int64_t min_arg_332690 = mul64(jump_t_292685, gtid_332687);
        int64_t min_res_332691 = smin64(i_292846, min_arg_332690);
        int64_t defunc_0_g_res_332692 = add64((int64_t) 1, min_res_332691);
        double defunc_2_reduce_res_332693;
        double redout_332765 = 0.0;
        
        for (int64_t i_332764 = 0; i_332764 < q_t_292679; i_332764++) {
            bool cond_332766 = sle64(x_307608, i_332764);
            int64_t defunc_0_f_res_332767;
            
            if (cond_332766) {
                defunc_0_f_res_332767 = (int64_t) 0;
            } else {
                int64_t i_332768 = add64(x_332688, i_332764);
                int64_t defunc_0_add_arg_332769;
                
                defunc_0_add_arg_332769 =
                    ((int64_t *) mem_312636.mem)[gtid_307603 * n_292675 +
                                                 i_332768];
                
                int64_t defunc_1_add_res_332770 = add64((int64_t) 1,
                                                        defunc_0_add_arg_332769);
                
                defunc_0_f_res_332767 = defunc_1_add_res_332770;
            }
            
            double defunc_0_f_res_332771;
            
            if (cond_332766) {
                defunc_0_f_res_332771 = 0.0;
            } else {
                int64_t i_332772 = add64(x_332688, i_332764);
                double defunc_0_add_arg_332773;
                
                defunc_0_add_arg_332773 = ((double *) mem_315666.mem)[i_332772];
                defunc_0_f_res_332771 = defunc_0_add_arg_332773;
            }
            
            int64_t binop_p_332774 = sub64(defunc_0_f_res_332767,
                                           defunc_0_g_res_332692);
            double defunc_0_f_res_332775 = sitofp_i64_f64(binop_p_332774);
            double abs_res_332776 = fabs(defunc_0_f_res_332775);
            double tmp1_332777 = abs_res_332776 / x_332689;
            double x_332778 = tmp1_332777 * tmp1_332777;
            double y_332779 = tmp1_332777 * x_332778;
            double tmp2_332780 = 1.0 - y_332779;
            double x_332781 = tmp2_332780 * tmp2_332780;
            double tmp3_332782 = tmp2_332780 * x_332781;
            double w_j_332783 = defunc_0_f_res_332771 * tmp3_332782;
            double defunc_1_op_res_332784 = w_j_332783 + redout_332765;
            double redout_tmp_332813 = defunc_1_op_res_332784;
            
            redout_332765 = redout_tmp_332813;
        }
        defunc_2_reduce_res_332693 = redout_332765;
        
        double a_332715 = 2.220446049250313e-16 + defunc_2_reduce_res_332693;
        double a0_332716 = 1.0 / a_332715;
        double defunc_2_reduce_res_332717;
        double redout_332786 = 0.0;
        
        for (int64_t i_332785 = 0; i_332785 < q_t_292679; i_332785++) {
            bool cond_332787 = sle64(x_307608, i_332785);
            int64_t defunc_0_f_res_332788;
            
            if (cond_332787) {
                defunc_0_f_res_332788 = (int64_t) 0;
            } else {
                int64_t i_332789 = add64(x_332688, i_332785);
                int64_t defunc_0_add_arg_332790;
                
                defunc_0_add_arg_332790 =
                    ((int64_t *) mem_312636.mem)[gtid_307603 * n_292675 +
                                                 i_332789];
                
                int64_t defunc_1_add_res_332791 = add64((int64_t) 1,
                                                        defunc_0_add_arg_332790);
                
                defunc_0_f_res_332788 = defunc_1_add_res_332791;
            }
            
            double defunc_0_f_res_332792;
            
            if (cond_332787) {
                defunc_0_f_res_332792 = 0.0;
            } else {
                int64_t i_332793 = add64(x_332688, i_332785);
                double defunc_0_add_arg_332794;
                
                defunc_0_add_arg_332794 = ((double *) mem_315666.mem)[i_332793];
                defunc_0_f_res_332792 = defunc_0_add_arg_332794;
            }
            
            int64_t binop_p_332795 = sub64(defunc_0_f_res_332788,
                                           defunc_0_g_res_332692);
            double defunc_0_f_res_332796 = sitofp_i64_f64(binop_p_332795);
            double abs_res_332797 = fabs(defunc_0_f_res_332796);
            double tmp1_332798 = abs_res_332797 / x_332689;
            double x_332799 = tmp1_332798 * tmp1_332798;
            double y_332800 = tmp1_332798 * x_332799;
            double tmp2_332801 = 1.0 - y_332800;
            double x_332802 = tmp2_332801 * tmp2_332801;
            double tmp3_332803 = tmp2_332801 * x_332802;
            double tmp4_332804 = defunc_0_f_res_332792 * tmp3_332803;
            double defunc_0_f_res_332805;
            
            if (cond_332787) {
                defunc_0_f_res_332805 = 0.0;
            } else {
                int64_t i_332806 = add64(x_332688, i_332785);
                double defunc_0_add_arg_332807;
                
                defunc_0_add_arg_332807 = ((double *) mem_315669.mem)[i_332806];
                defunc_0_f_res_332805 = defunc_0_add_arg_332807;
            }
            
            double x_332808 = a0_332716 * tmp4_332804;
            double defunc_9_fit_fun_res_332809 = defunc_0_f_res_332805 *
                   x_332808;
            double defunc_1_op_res_332810 = defunc_9_fit_fun_res_332809 +
                   redout_332786;
            double redout_tmp_332814 = defunc_1_op_res_332810;
            
            redout_332786 = redout_tmp_332814;
        }
        defunc_2_reduce_res_332717 = redout_332786;
        ((double *) mem_315672.mem)[gtid_332687] = defunc_2_reduce_res_332717;
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338786_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338786_end -
                 futhark_mc_segmap_parloop_338786_start;
        
        ctx->futhark_mc_segmap_parloop_338786_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338786_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338786_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_338784(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_332686 = tid;
    int num_tasks_332762 = info.nsubtasks;
    struct futhark_mc_task_338783 *futhark_mc_task_338783 =
                                  (struct futhark_mc_task_338783 *) args;
    struct futhark_context *ctx = futhark_mc_task_338783->ctx;
    uint64_t futhark_mc_segmap_task_338784_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_338784_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338783->free_n_292675;
    int64_t q_t_292679 = futhark_mc_task_338783->free_q_t_292679;
    int64_t jump_t_292685 = futhark_mc_task_338783->free_jump_t_292685;
    int64_t t_n_m_292839 = futhark_mc_task_338783->free_t_n_m_292839;
    int64_t i_292846 = futhark_mc_task_338783->free_i_292846;
    int64_t gtid_307603 = futhark_mc_task_338783->free_gtid_307603;
    int64_t x_307608 = futhark_mc_task_338783->free_x_307608;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_task_338783->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_313143 = {.desc ="mem_313143", .mem =
                                  futhark_mc_task_338783->free_mem_313143,
                                  .size =0, .references =NULL};
    struct memblock mem_313147 = {.desc ="mem_313147", .mem =
                                  futhark_mc_task_338783->free_mem_313147,
                                  .size =0, .references =NULL};
    struct memblock mem_315666 = {.desc ="mem_315666", .mem =
                                  futhark_mc_task_338783->free_mem_315666,
                                  .size =0, .references =NULL};
    struct memblock mem_315669 = {.desc ="mem_315669", .mem =
                                  futhark_mc_task_338783->free_mem_315669,
                                  .size =0, .references =NULL};
    struct memblock mem_315672 = {.desc ="mem_315672", .mem =
                                  futhark_mc_task_338783->free_mem_315672,
                                  .size =0, .references =NULL};
    int64_t iter_332763;
    struct futhark_mc_segmap_parloop_struct_338785
    futhark_mc_segmap_parloop_struct_338785;
    
    futhark_mc_segmap_parloop_struct_338785.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338785.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_338785.free_q_t_292679 = q_t_292679;
    futhark_mc_segmap_parloop_struct_338785.free_jump_t_292685 = jump_t_292685;
    futhark_mc_segmap_parloop_struct_338785.free_t_n_m_292839 = t_n_m_292839;
    futhark_mc_segmap_parloop_struct_338785.free_i_292846 = i_292846;
    futhark_mc_segmap_parloop_struct_338785.free_gtid_307603 = gtid_307603;
    futhark_mc_segmap_parloop_struct_338785.free_x_307608 = x_307608;
    futhark_mc_segmap_parloop_struct_338785.free_mem_312636 = mem_312636.mem;
    futhark_mc_segmap_parloop_struct_338785.free_mem_313143 = mem_313143.mem;
    futhark_mc_segmap_parloop_struct_338785.free_mem_313147 = mem_313147.mem;
    futhark_mc_segmap_parloop_struct_338785.free_mem_315666 = mem_315666.mem;
    futhark_mc_segmap_parloop_struct_338785.free_mem_315669 = mem_315669.mem;
    futhark_mc_segmap_parloop_struct_338785.free_mem_315672 = mem_315672.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338786_task;
    
    futhark_mc_segmap_parloop_338786_task.name =
        "futhark_mc_segmap_parloop_338786";
    futhark_mc_segmap_parloop_338786_task.fn = futhark_mc_segmap_parloop_338786;
    futhark_mc_segmap_parloop_338786_task.args =
        &futhark_mc_segmap_parloop_struct_338785;
    futhark_mc_segmap_parloop_338786_task.iterations = iterations;
    futhark_mc_segmap_parloop_338786_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338786_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338786_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338786_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338786_task);
    
    if (futhark_mc_segmap_parloop_338786_err != 0) {
        err = futhark_mc_segmap_parloop_338786_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338786_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338786_total_end -
                 futhark_mc_segmap_parloop_338786_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338786_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338786_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338786_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_338784_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_338784_end -
                 futhark_mc_segmap_task_338784_start;
        
        ctx->futhark_mc_segmap_task_338784_runs[tid]++;
        ctx->futhark_mc_segmap_task_338784_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_338784_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_segmap_parloop_struct_338788 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_t_292679;
    int64_t free_jump_t_292685;
    int64_t free_t_n_m_292839;
    int64_t free_i_292846;
    int64_t free_gtid_307603;
    int64_t free_x_307608;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_313143;
    unsigned char *free_mem_313147;
    unsigned char *free_mem_315666;
    unsigned char *free_mem_315669;
    unsigned char *free_mem_315672;
};
struct futhark_mc_task_338790 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_307603;
    int64_t free_x_307608;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_315666;
    int64_t free_x_332626;
    double free_x_332627;
    int64_t free_defunc_0_g_res_332630;
    double *retval_defunc_2_reduce_res_332631;
};
struct futhark_mc_segred_stage_1_parloop_struct_338793 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_307603;
    int64_t free_x_307608;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_315666;
    int64_t free_x_332626;
    double free_x_332627;
    int64_t free_defunc_0_g_res_332630;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_332870;
};
static int futhark_mc_segred_stage_1_parloop_338794(void *args, int64_t start,
                                                    int64_t end,
                                                    int flat_tid_332816,
                                                    int tid)
{
    int err = 0;
    struct futhark_mc_segred_stage_1_parloop_struct_338793
    *futhark_mc_segred_stage_1_parloop_struct_338793 =
    (struct futhark_mc_segred_stage_1_parloop_struct_338793 *) args;
    struct futhark_context *ctx =
                           futhark_mc_segred_stage_1_parloop_struct_338793->ctx;
    uint64_t futhark_mc_segred_stage_1_parloop_338794_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_338794_start = get_wall_time();
    
    int64_t n_292675 =
            futhark_mc_segred_stage_1_parloop_struct_338793->free_n_292675;
    int64_t gtid_307603 =
            futhark_mc_segred_stage_1_parloop_struct_338793->free_gtid_307603;
    int64_t x_307608 =
            futhark_mc_segred_stage_1_parloop_struct_338793->free_x_307608;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_338793->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_315666 = {.desc ="mem_315666", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_338793->free_mem_315666,
                                  .size =0, .references =NULL};
    int64_t x_332626 =
            futhark_mc_segred_stage_1_parloop_struct_338793->free_x_332626;
    double x_332627 =
           futhark_mc_segred_stage_1_parloop_struct_338793->free_x_332627;
    int64_t defunc_0_g_res_332630 =
            futhark_mc_segred_stage_1_parloop_struct_338793->free_defunc_0_g_res_332630;
    struct memblock reduce_stage_1_tid_res_arr_mem_332870 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_332870",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338793->free_reduce_stage_1_tid_res_arr_mem_332870,
                                                             .size =0,
                                                             .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_332872 = start;
    double x_332818;
    double x_332819;
    double local_acc_332873 = 0.0;
    
    for (; iter_332872 < end; iter_332872++) {
        int64_t gtid_332817 = iter_332872;
        bool cond_332821 = sle64(x_307608, gtid_332817);
        int64_t defunc_0_f_res_332822;
        
        if (cond_332821) {
            defunc_0_f_res_332822 = (int64_t) 0;
        } else {
            int64_t i_332823 = add64(x_332626, gtid_332817);
            int64_t defunc_0_add_arg_332824;
            
            defunc_0_add_arg_332824 = ((int64_t *) mem_312636.mem)[gtid_307603 *
                                                                   n_292675 +
                                                                   i_332823];
            
            int64_t defunc_1_add_res_332825 = add64((int64_t) 1,
                                                    defunc_0_add_arg_332824);
            
            defunc_0_f_res_332822 = defunc_1_add_res_332825;
        }
        
        double defunc_0_f_res_332826;
        
        if (cond_332821) {
            defunc_0_f_res_332826 = 0.0;
        } else {
            int64_t i_332827 = add64(x_332626, gtid_332817);
            double defunc_0_add_arg_332828;
            
            defunc_0_add_arg_332828 = ((double *) mem_315666.mem)[i_332827];
            defunc_0_f_res_332826 = defunc_0_add_arg_332828;
        }
        
        int64_t binop_p_332829 = sub64(defunc_0_f_res_332822,
                                       defunc_0_g_res_332630);
        double defunc_0_f_res_332830 = sitofp_i64_f64(binop_p_332829);
        double abs_res_332831 = fabs(defunc_0_f_res_332830);
        double tmp1_332832 = abs_res_332831 / x_332627;
        double x_332833 = tmp1_332832 * tmp1_332832;
        double y_332834 = tmp1_332832 * x_332833;
        double tmp2_332835 = 1.0 - y_332834;
        double x_332836 = tmp2_332835 * tmp2_332835;
        double tmp3_332837 = tmp2_332835 * x_332836;
        double w_j_332838 = defunc_0_f_res_332826 * tmp3_332837;
        
        // save map-out results
        { }
        // Load accum params
        {
            x_332818 = local_acc_332873;
        }
        // Load next params
        {
            x_332819 = w_j_332838;
        }
        // Red body
        {
            double defunc_1_op_res_332820 = x_332818 + x_332819;
            
            local_acc_332873 = defunc_1_op_res_332820;
        }
    }
    ((double *) reduce_stage_1_tid_res_arr_mem_332870.mem)[flat_tid_332816] =
        local_acc_332873;
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_338794_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_338794_end -
                 futhark_mc_segred_stage_1_parloop_338794_start;
        
        ctx->futhark_mc_segred_stage_1_parloop_338794_runs[tid]++;
        ctx->futhark_mc_segred_stage_1_parloop_338794_total_runtime[tid] +=
            elapsed;
        ctx->futhark_mc_segred_stage_1_parloop_338794_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segred_task_338791(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_332816 = tid;
    int num_tasks_332869 = info.nsubtasks;
    struct futhark_mc_task_338790 *futhark_mc_task_338790 =
                                  (struct futhark_mc_task_338790 *) args;
    struct futhark_context *ctx = futhark_mc_task_338790->ctx;
    uint64_t futhark_mc_segred_task_338791_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_task_338791_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338790->free_n_292675;
    int64_t gtid_307603 = futhark_mc_task_338790->free_gtid_307603;
    int64_t x_307608 = futhark_mc_task_338790->free_x_307608;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_task_338790->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_315666 = {.desc ="mem_315666", .mem =
                                  futhark_mc_task_338790->free_mem_315666,
                                  .size =0, .references =NULL};
    int64_t x_332626 = futhark_mc_task_338790->free_x_332626;
    double x_332627 = futhark_mc_task_338790->free_x_332627;
    int64_t defunc_0_g_res_332630 =
            futhark_mc_task_338790->free_defunc_0_g_res_332630;
    double defunc_2_reduce_res_332631 =
           *futhark_mc_task_338790->retval_defunc_2_reduce_res_332631;
    size_t reduce_stage_1_tid_res_arr_mem_332870_cached_sizze_338792 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_332870 = NULL;
    
    if (reduce_stage_1_tid_res_arr_mem_332870_cached_sizze_338792 <
        (size_t) ((int64_t) 8 * num_tasks_332869)) {
        reduce_stage_1_tid_res_arr_mem_332870 =
            realloc(reduce_stage_1_tid_res_arr_mem_332870, (int64_t) 8 *
                    num_tasks_332869);
        reduce_stage_1_tid_res_arr_mem_332870_cached_sizze_338792 =
            (int64_t) 8 * num_tasks_332869;
    }
    
    int64_t iter_332872;
    struct futhark_mc_segred_stage_1_parloop_struct_338793
    futhark_mc_segred_stage_1_parloop_struct_338793;
    
    futhark_mc_segred_stage_1_parloop_struct_338793.ctx = ctx;
    futhark_mc_segred_stage_1_parloop_struct_338793.free_n_292675 = n_292675;
    futhark_mc_segred_stage_1_parloop_struct_338793.free_gtid_307603 =
        gtid_307603;
    futhark_mc_segred_stage_1_parloop_struct_338793.free_x_307608 = x_307608;
    futhark_mc_segred_stage_1_parloop_struct_338793.free_mem_312636 =
        mem_312636.mem;
    futhark_mc_segred_stage_1_parloop_struct_338793.free_mem_315666 =
        mem_315666.mem;
    futhark_mc_segred_stage_1_parloop_struct_338793.free_x_332626 = x_332626;
    futhark_mc_segred_stage_1_parloop_struct_338793.free_x_332627 = x_332627;
    futhark_mc_segred_stage_1_parloop_struct_338793.free_defunc_0_g_res_332630 =
        defunc_0_g_res_332630;
    futhark_mc_segred_stage_1_parloop_struct_338793.free_reduce_stage_1_tid_res_arr_mem_332870 =
        reduce_stage_1_tid_res_arr_mem_332870;
    
    struct scheduler_parloop futhark_mc_segred_stage_1_parloop_338794_task;
    
    futhark_mc_segred_stage_1_parloop_338794_task.name =
        "futhark_mc_segred_stage_1_parloop_338794";
    futhark_mc_segred_stage_1_parloop_338794_task.fn =
        futhark_mc_segred_stage_1_parloop_338794;
    futhark_mc_segred_stage_1_parloop_338794_task.args =
        &futhark_mc_segred_stage_1_parloop_struct_338793;
    futhark_mc_segred_stage_1_parloop_338794_task.iterations = iterations;
    futhark_mc_segred_stage_1_parloop_338794_task.info = info;
    
    uint64_t futhark_mc_segred_stage_1_parloop_338794_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_338794_total_start = get_wall_time();
    
    int futhark_mc_segred_stage_1_parloop_338794_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segred_stage_1_parloop_338794_task);
    
    if (futhark_mc_segred_stage_1_parloop_338794_err != 0) {
        err = futhark_mc_segred_stage_1_parloop_338794_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_338794_total_end =
                 get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_338794_total_end -
                 futhark_mc_segred_stage_1_parloop_338794_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338794_total_runs,
                           1, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338794_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338794_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    // neutral-initialise the output
    {
        defunc_2_reduce_res_332631 = 0.0;
    }
    
    double x_332874;
    double x_332875;
    
    for (int32_t i_332877 = 0; i_332877 < num_tasks_332869; i_332877++) {
        flat_tid_332816 = i_332877;
        // Apply main thread reduction
        {
            // load acc params
            {
                x_332874 = defunc_2_reduce_res_332631;
            }
            // load next params
            {
                x_332875 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_332870)[flat_tid_332816];
            }
            // red body
            {
                double defunc_1_op_res_332876 = x_332874 + x_332875;
                
                defunc_2_reduce_res_332631 = defunc_1_op_res_332876;
            }
        }
    }
    
  cleanup:
    {
        free(reduce_stage_1_tid_res_arr_mem_332870);
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_task_338791_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_task_338791_end -
                 futhark_mc_segred_task_338791_start;
        
        ctx->futhark_mc_segred_task_338791_runs[tid]++;
        ctx->futhark_mc_segred_task_338791_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segred_task_338791_iter[tid] += iterations;
    }
    if (err == 0) {
        *futhark_mc_task_338790->retval_defunc_2_reduce_res_332631 =
            defunc_2_reduce_res_332631;
    }
    return err;
}
struct futhark_mc_task_338795 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_307603;
    int64_t free_x_307608;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_315666;
    unsigned char *free_mem_315669;
    int64_t free_x_332626;
    double free_x_332627;
    int64_t free_defunc_0_g_res_332630;
    double free_a0_332656;
    double *retval_defunc_2_reduce_res_332657;
};
struct futhark_mc_segred_stage_1_parloop_struct_338798 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_307603;
    int64_t free_x_307608;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_315666;
    unsigned char *free_mem_315669;
    int64_t free_x_332626;
    double free_x_332627;
    int64_t free_defunc_0_g_res_332630;
    double free_a0_332656;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_332879;
};
static int futhark_mc_segred_stage_1_parloop_338799(void *args, int64_t start,
                                                    int64_t end,
                                                    int flat_tid_332839,
                                                    int tid)
{
    int err = 0;
    struct futhark_mc_segred_stage_1_parloop_struct_338798
    *futhark_mc_segred_stage_1_parloop_struct_338798 =
    (struct futhark_mc_segred_stage_1_parloop_struct_338798 *) args;
    struct futhark_context *ctx =
                           futhark_mc_segred_stage_1_parloop_struct_338798->ctx;
    uint64_t futhark_mc_segred_stage_1_parloop_338799_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_338799_start = get_wall_time();
    
    int64_t n_292675 =
            futhark_mc_segred_stage_1_parloop_struct_338798->free_n_292675;
    int64_t gtid_307603 =
            futhark_mc_segred_stage_1_parloop_struct_338798->free_gtid_307603;
    int64_t x_307608 =
            futhark_mc_segred_stage_1_parloop_struct_338798->free_x_307608;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_338798->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_315666 = {.desc ="mem_315666", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_338798->free_mem_315666,
                                  .size =0, .references =NULL};
    struct memblock mem_315669 = {.desc ="mem_315669", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_338798->free_mem_315669,
                                  .size =0, .references =NULL};
    int64_t x_332626 =
            futhark_mc_segred_stage_1_parloop_struct_338798->free_x_332626;
    double x_332627 =
           futhark_mc_segred_stage_1_parloop_struct_338798->free_x_332627;
    int64_t defunc_0_g_res_332630 =
            futhark_mc_segred_stage_1_parloop_struct_338798->free_defunc_0_g_res_332630;
    double a0_332656 =
           futhark_mc_segred_stage_1_parloop_struct_338798->free_a0_332656;
    struct memblock reduce_stage_1_tid_res_arr_mem_332879 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_332879",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338798->free_reduce_stage_1_tid_res_arr_mem_332879,
                                                             .size =0,
                                                             .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_332881 = start;
    double x_332841;
    double x_332842;
    double local_acc_332882 = 0.0;
    
    for (; iter_332881 < end; iter_332881++) {
        int64_t gtid_332840 = iter_332881;
        bool cond_332844 = sle64(x_307608, gtid_332840);
        int64_t defunc_0_f_res_332845;
        
        if (cond_332844) {
            defunc_0_f_res_332845 = (int64_t) 0;
        } else {
            int64_t i_332846 = add64(x_332626, gtid_332840);
            int64_t defunc_0_add_arg_332847;
            
            defunc_0_add_arg_332847 = ((int64_t *) mem_312636.mem)[gtid_307603 *
                                                                   n_292675 +
                                                                   i_332846];
            
            int64_t defunc_1_add_res_332848 = add64((int64_t) 1,
                                                    defunc_0_add_arg_332847);
            
            defunc_0_f_res_332845 = defunc_1_add_res_332848;
        }
        
        double defunc_0_f_res_332849;
        
        if (cond_332844) {
            defunc_0_f_res_332849 = 0.0;
        } else {
            int64_t i_332850 = add64(x_332626, gtid_332840);
            double defunc_0_add_arg_332851;
            
            defunc_0_add_arg_332851 = ((double *) mem_315666.mem)[i_332850];
            defunc_0_f_res_332849 = defunc_0_add_arg_332851;
        }
        
        int64_t binop_p_332852 = sub64(defunc_0_f_res_332845,
                                       defunc_0_g_res_332630);
        double defunc_0_f_res_332853 = sitofp_i64_f64(binop_p_332852);
        double abs_res_332854 = fabs(defunc_0_f_res_332853);
        double tmp1_332855 = abs_res_332854 / x_332627;
        double x_332856 = tmp1_332855 * tmp1_332855;
        double y_332857 = tmp1_332855 * x_332856;
        double tmp2_332858 = 1.0 - y_332857;
        double x_332859 = tmp2_332858 * tmp2_332858;
        double tmp3_332860 = tmp2_332858 * x_332859;
        double tmp4_332861 = defunc_0_f_res_332849 * tmp3_332860;
        double defunc_0_f_res_332862;
        
        if (cond_332844) {
            defunc_0_f_res_332862 = 0.0;
        } else {
            int64_t i_332863 = add64(x_332626, gtid_332840);
            double defunc_0_add_arg_332864;
            
            defunc_0_add_arg_332864 = ((double *) mem_315669.mem)[i_332863];
            defunc_0_f_res_332862 = defunc_0_add_arg_332864;
        }
        
        double x_332865 = a0_332656 * tmp4_332861;
        double defunc_9_fit_fun_res_332866 = defunc_0_f_res_332862 * x_332865;
        
        // save map-out results
        { }
        // Load accum params
        {
            x_332841 = local_acc_332882;
        }
        // Load next params
        {
            x_332842 = defunc_9_fit_fun_res_332866;
        }
        // Red body
        {
            double defunc_1_op_res_332843 = x_332841 + x_332842;
            
            local_acc_332882 = defunc_1_op_res_332843;
        }
    }
    ((double *) reduce_stage_1_tid_res_arr_mem_332879.mem)[flat_tid_332839] =
        local_acc_332882;
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_338799_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_338799_end -
                 futhark_mc_segred_stage_1_parloop_338799_start;
        
        ctx->futhark_mc_segred_stage_1_parloop_338799_runs[tid]++;
        ctx->futhark_mc_segred_stage_1_parloop_338799_total_runtime[tid] +=
            elapsed;
        ctx->futhark_mc_segred_stage_1_parloop_338799_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segred_task_338796(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_332839 = tid;
    int num_tasks_332878 = info.nsubtasks;
    struct futhark_mc_task_338795 *futhark_mc_task_338795 =
                                  (struct futhark_mc_task_338795 *) args;
    struct futhark_context *ctx = futhark_mc_task_338795->ctx;
    uint64_t futhark_mc_segred_task_338796_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_task_338796_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338795->free_n_292675;
    int64_t gtid_307603 = futhark_mc_task_338795->free_gtid_307603;
    int64_t x_307608 = futhark_mc_task_338795->free_x_307608;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_task_338795->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_315666 = {.desc ="mem_315666", .mem =
                                  futhark_mc_task_338795->free_mem_315666,
                                  .size =0, .references =NULL};
    struct memblock mem_315669 = {.desc ="mem_315669", .mem =
                                  futhark_mc_task_338795->free_mem_315669,
                                  .size =0, .references =NULL};
    int64_t x_332626 = futhark_mc_task_338795->free_x_332626;
    double x_332627 = futhark_mc_task_338795->free_x_332627;
    int64_t defunc_0_g_res_332630 =
            futhark_mc_task_338795->free_defunc_0_g_res_332630;
    double a0_332656 = futhark_mc_task_338795->free_a0_332656;
    double defunc_2_reduce_res_332657 =
           *futhark_mc_task_338795->retval_defunc_2_reduce_res_332657;
    size_t reduce_stage_1_tid_res_arr_mem_332879_cached_sizze_338797 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_332879 = NULL;
    
    if (reduce_stage_1_tid_res_arr_mem_332879_cached_sizze_338797 <
        (size_t) ((int64_t) 8 * num_tasks_332878)) {
        reduce_stage_1_tid_res_arr_mem_332879 =
            realloc(reduce_stage_1_tid_res_arr_mem_332879, (int64_t) 8 *
                    num_tasks_332878);
        reduce_stage_1_tid_res_arr_mem_332879_cached_sizze_338797 =
            (int64_t) 8 * num_tasks_332878;
    }
    
    int64_t iter_332881;
    struct futhark_mc_segred_stage_1_parloop_struct_338798
    futhark_mc_segred_stage_1_parloop_struct_338798;
    
    futhark_mc_segred_stage_1_parloop_struct_338798.ctx = ctx;
    futhark_mc_segred_stage_1_parloop_struct_338798.free_n_292675 = n_292675;
    futhark_mc_segred_stage_1_parloop_struct_338798.free_gtid_307603 =
        gtid_307603;
    futhark_mc_segred_stage_1_parloop_struct_338798.free_x_307608 = x_307608;
    futhark_mc_segred_stage_1_parloop_struct_338798.free_mem_312636 =
        mem_312636.mem;
    futhark_mc_segred_stage_1_parloop_struct_338798.free_mem_315666 =
        mem_315666.mem;
    futhark_mc_segred_stage_1_parloop_struct_338798.free_mem_315669 =
        mem_315669.mem;
    futhark_mc_segred_stage_1_parloop_struct_338798.free_x_332626 = x_332626;
    futhark_mc_segred_stage_1_parloop_struct_338798.free_x_332627 = x_332627;
    futhark_mc_segred_stage_1_parloop_struct_338798.free_defunc_0_g_res_332630 =
        defunc_0_g_res_332630;
    futhark_mc_segred_stage_1_parloop_struct_338798.free_a0_332656 = a0_332656;
    futhark_mc_segred_stage_1_parloop_struct_338798.free_reduce_stage_1_tid_res_arr_mem_332879 =
        reduce_stage_1_tid_res_arr_mem_332879;
    
    struct scheduler_parloop futhark_mc_segred_stage_1_parloop_338799_task;
    
    futhark_mc_segred_stage_1_parloop_338799_task.name =
        "futhark_mc_segred_stage_1_parloop_338799";
    futhark_mc_segred_stage_1_parloop_338799_task.fn =
        futhark_mc_segred_stage_1_parloop_338799;
    futhark_mc_segred_stage_1_parloop_338799_task.args =
        &futhark_mc_segred_stage_1_parloop_struct_338798;
    futhark_mc_segred_stage_1_parloop_338799_task.iterations = iterations;
    futhark_mc_segred_stage_1_parloop_338799_task.info = info;
    
    uint64_t futhark_mc_segred_stage_1_parloop_338799_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_338799_total_start = get_wall_time();
    
    int futhark_mc_segred_stage_1_parloop_338799_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segred_stage_1_parloop_338799_task);
    
    if (futhark_mc_segred_stage_1_parloop_338799_err != 0) {
        err = futhark_mc_segred_stage_1_parloop_338799_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_338799_total_end =
                 get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_338799_total_end -
                 futhark_mc_segred_stage_1_parloop_338799_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338799_total_runs,
                           1, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338799_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338799_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    // neutral-initialise the output
    {
        defunc_2_reduce_res_332657 = 0.0;
    }
    
    double x_332883;
    double x_332884;
    
    for (int32_t i_332886 = 0; i_332886 < num_tasks_332878; i_332886++) {
        flat_tid_332839 = i_332886;
        // Apply main thread reduction
        {
            // load acc params
            {
                x_332883 = defunc_2_reduce_res_332657;
            }
            // load next params
            {
                x_332884 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_332879)[flat_tid_332839];
            }
            // red body
            {
                double defunc_1_op_res_332885 = x_332883 + x_332884;
                
                defunc_2_reduce_res_332657 = defunc_1_op_res_332885;
            }
        }
    }
    
  cleanup:
    {
        free(reduce_stage_1_tid_res_arr_mem_332879);
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_task_338796_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_task_338796_end -
                 futhark_mc_segred_task_338796_start;
        
        ctx->futhark_mc_segred_task_338796_runs[tid]++;
        ctx->futhark_mc_segred_task_338796_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segred_task_338796_iter[tid] += iterations;
    }
    if (err == 0) {
        *futhark_mc_task_338795->retval_defunc_2_reduce_res_332657 =
            defunc_2_reduce_res_332657;
    }
    return err;
}
static int futhark_mc_segmap_parloop_338789(void *args, int64_t start,
                                            int64_t end, int flat_tid_332624,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338788
    *futhark_mc_segmap_parloop_struct_338788 =
    (struct futhark_mc_segmap_parloop_struct_338788 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338788->ctx;
    uint64_t futhark_mc_segmap_parloop_338789_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338789_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_338788->free_n_292675;
    int64_t q_t_292679 =
            futhark_mc_segmap_parloop_struct_338788->free_q_t_292679;
    int64_t jump_t_292685 =
            futhark_mc_segmap_parloop_struct_338788->free_jump_t_292685;
    int64_t t_n_m_292839 =
            futhark_mc_segmap_parloop_struct_338788->free_t_n_m_292839;
    int64_t i_292846 = futhark_mc_segmap_parloop_struct_338788->free_i_292846;
    int64_t gtid_307603 =
            futhark_mc_segmap_parloop_struct_338788->free_gtid_307603;
    int64_t x_307608 = futhark_mc_segmap_parloop_struct_338788->free_x_307608;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_segmap_parloop_struct_338788->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_313143 = {.desc ="mem_313143", .mem =
                                  futhark_mc_segmap_parloop_struct_338788->free_mem_313143,
                                  .size =0, .references =NULL};
    struct memblock mem_313147 = {.desc ="mem_313147", .mem =
                                  futhark_mc_segmap_parloop_struct_338788->free_mem_313147,
                                  .size =0, .references =NULL};
    struct memblock mem_315666 = {.desc ="mem_315666", .mem =
                                  futhark_mc_segmap_parloop_struct_338788->free_mem_315666,
                                  .size =0, .references =NULL};
    struct memblock mem_315669 = {.desc ="mem_315669", .mem =
                                  futhark_mc_segmap_parloop_struct_338788->free_mem_315669,
                                  .size =0, .references =NULL};
    struct memblock mem_315672 = {.desc ="mem_315672", .mem =
                                  futhark_mc_segmap_parloop_struct_338788->free_mem_315672,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_332815 = start;
    
    for (; iter_332815 < end; iter_332815++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_332867 = t_n_m_292839;
        int64_t gtid_332625 = iter_332815;
        int64_t remnant_332868 = iter_332815 - gtid_332625;
        int64_t x_332626;
        
        x_332626 = ((int64_t *) mem_313143.mem)[gtid_307603 * t_n_m_292839 +
                                                gtid_332625];
        
        double x_332627;
        
        x_332627 = ((double *) mem_313147.mem)[gtid_307603 * t_n_m_292839 +
                                               gtid_332625];
        
        int64_t min_arg_332628 = mul64(jump_t_292685, gtid_332625);
        int64_t min_res_332629 = smin64(i_292846, min_arg_332628);
        int64_t defunc_0_g_res_332630 = add64((int64_t) 1, min_res_332629);
        double defunc_2_reduce_res_332631;
        int64_t flat_tid_332816 = (int64_t) 0;
        int32_t num_tasks_332869;
        
        defunc_2_reduce_res_332631 = 0.0;
        
        struct futhark_mc_task_338790 futhark_mc_task_338790;
        
        futhark_mc_task_338790.ctx = ctx;
        futhark_mc_task_338790.free_n_292675 = n_292675;
        futhark_mc_task_338790.free_gtid_307603 = gtid_307603;
        futhark_mc_task_338790.free_x_307608 = x_307608;
        futhark_mc_task_338790.free_mem_312636 = mem_312636.mem;
        futhark_mc_task_338790.free_mem_315666 = mem_315666.mem;
        futhark_mc_task_338790.free_x_332626 = x_332626;
        futhark_mc_task_338790.free_x_332627 = x_332627;
        futhark_mc_task_338790.free_defunc_0_g_res_332630 =
            defunc_0_g_res_332630;
        futhark_mc_task_338790.retval_defunc_2_reduce_res_332631 =
            &defunc_2_reduce_res_332631;
        
        struct scheduler_segop futhark_mc_task_338790_task;
        
        futhark_mc_task_338790_task.args = &futhark_mc_task_338790;
        futhark_mc_task_338790_task.top_level_fn =
            futhark_mc_segred_task_338791;
        futhark_mc_task_338790_task.name = "futhark_mc_segred_task_338791";
        futhark_mc_task_338790_task.iterations = q_t_292679;
        futhark_mc_task_338790_task.task_time =
            &ctx->futhark_mc_segred_task_338791_total_time;
        futhark_mc_task_338790_task.task_iter =
            &ctx->futhark_mc_segred_task_338791_total_iter;
        futhark_mc_task_338790_task.sched = STATIC;
        futhark_mc_task_338790_task.nested_fn = NULL;
        
        int futhark_mc_segred_task_338791_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_338790_task);
        
        if (futhark_mc_segred_task_338791_err != 0) {
            ;
            err = futhark_mc_segred_task_338791_err;
            goto cleanup;
        }
        
        double a_332655 = 2.220446049250313e-16 + defunc_2_reduce_res_332631;
        double a0_332656 = 1.0 / a_332655;
        double defunc_2_reduce_res_332657;
        int64_t flat_tid_332839 = (int64_t) 0;
        int32_t num_tasks_332878;
        
        defunc_2_reduce_res_332657 = 0.0;
        
        struct futhark_mc_task_338795 futhark_mc_task_338795;
        
        futhark_mc_task_338795.ctx = ctx;
        futhark_mc_task_338795.free_n_292675 = n_292675;
        futhark_mc_task_338795.free_gtid_307603 = gtid_307603;
        futhark_mc_task_338795.free_x_307608 = x_307608;
        futhark_mc_task_338795.free_mem_312636 = mem_312636.mem;
        futhark_mc_task_338795.free_mem_315666 = mem_315666.mem;
        futhark_mc_task_338795.free_mem_315669 = mem_315669.mem;
        futhark_mc_task_338795.free_x_332626 = x_332626;
        futhark_mc_task_338795.free_x_332627 = x_332627;
        futhark_mc_task_338795.free_defunc_0_g_res_332630 =
            defunc_0_g_res_332630;
        futhark_mc_task_338795.free_a0_332656 = a0_332656;
        futhark_mc_task_338795.retval_defunc_2_reduce_res_332657 =
            &defunc_2_reduce_res_332657;
        
        struct scheduler_segop futhark_mc_task_338795_task;
        
        futhark_mc_task_338795_task.args = &futhark_mc_task_338795;
        futhark_mc_task_338795_task.top_level_fn =
            futhark_mc_segred_task_338796;
        futhark_mc_task_338795_task.name = "futhark_mc_segred_task_338796";
        futhark_mc_task_338795_task.iterations = q_t_292679;
        futhark_mc_task_338795_task.task_time =
            &ctx->futhark_mc_segred_task_338796_total_time;
        futhark_mc_task_338795_task.task_iter =
            &ctx->futhark_mc_segred_task_338796_total_iter;
        futhark_mc_task_338795_task.sched = STATIC;
        futhark_mc_task_338795_task.nested_fn = NULL;
        
        int futhark_mc_segred_task_338796_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_338795_task);
        
        if (futhark_mc_segred_task_338796_err != 0) {
            ;
            err = futhark_mc_segred_task_338796_err;
            goto cleanup;
        }
        ((double *) mem_315672.mem)[gtid_332625] = defunc_2_reduce_res_332657;
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338789_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338789_end -
                 futhark_mc_segmap_parloop_338789_start;
        
        ctx->futhark_mc_segmap_parloop_338789_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338789_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338789_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_nested_task_338787(void *args, int64_t iterations,
                                         int tid, struct scheduler_info info)
{
    int err = 0;
    int flat_tid_332624 = tid;
    int num_tasks_332762 = info.nsubtasks;
    struct futhark_mc_task_338783 *futhark_mc_task_338783 =
                                  (struct futhark_mc_task_338783 *) args;
    struct futhark_context *ctx = futhark_mc_task_338783->ctx;
    uint64_t futhark_mc_segmap_nested_task_338787_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_nested_task_338787_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338783->free_n_292675;
    int64_t q_t_292679 = futhark_mc_task_338783->free_q_t_292679;
    int64_t jump_t_292685 = futhark_mc_task_338783->free_jump_t_292685;
    int64_t t_n_m_292839 = futhark_mc_task_338783->free_t_n_m_292839;
    int64_t i_292846 = futhark_mc_task_338783->free_i_292846;
    int64_t gtid_307603 = futhark_mc_task_338783->free_gtid_307603;
    int64_t x_307608 = futhark_mc_task_338783->free_x_307608;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_task_338783->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_313143 = {.desc ="mem_313143", .mem =
                                  futhark_mc_task_338783->free_mem_313143,
                                  .size =0, .references =NULL};
    struct memblock mem_313147 = {.desc ="mem_313147", .mem =
                                  futhark_mc_task_338783->free_mem_313147,
                                  .size =0, .references =NULL};
    struct memblock mem_315666 = {.desc ="mem_315666", .mem =
                                  futhark_mc_task_338783->free_mem_315666,
                                  .size =0, .references =NULL};
    struct memblock mem_315669 = {.desc ="mem_315669", .mem =
                                  futhark_mc_task_338783->free_mem_315669,
                                  .size =0, .references =NULL};
    struct memblock mem_315672 = {.desc ="mem_315672", .mem =
                                  futhark_mc_task_338783->free_mem_315672,
                                  .size =0, .references =NULL};
    int64_t iter_332815;
    struct futhark_mc_segmap_parloop_struct_338788
    futhark_mc_segmap_parloop_struct_338788;
    
    futhark_mc_segmap_parloop_struct_338788.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338788.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_338788.free_q_t_292679 = q_t_292679;
    futhark_mc_segmap_parloop_struct_338788.free_jump_t_292685 = jump_t_292685;
    futhark_mc_segmap_parloop_struct_338788.free_t_n_m_292839 = t_n_m_292839;
    futhark_mc_segmap_parloop_struct_338788.free_i_292846 = i_292846;
    futhark_mc_segmap_parloop_struct_338788.free_gtid_307603 = gtid_307603;
    futhark_mc_segmap_parloop_struct_338788.free_x_307608 = x_307608;
    futhark_mc_segmap_parloop_struct_338788.free_mem_312636 = mem_312636.mem;
    futhark_mc_segmap_parloop_struct_338788.free_mem_313143 = mem_313143.mem;
    futhark_mc_segmap_parloop_struct_338788.free_mem_313147 = mem_313147.mem;
    futhark_mc_segmap_parloop_struct_338788.free_mem_315666 = mem_315666.mem;
    futhark_mc_segmap_parloop_struct_338788.free_mem_315669 = mem_315669.mem;
    futhark_mc_segmap_parloop_struct_338788.free_mem_315672 = mem_315672.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338789_task;
    
    futhark_mc_segmap_parloop_338789_task.name =
        "futhark_mc_segmap_parloop_338789";
    futhark_mc_segmap_parloop_338789_task.fn = futhark_mc_segmap_parloop_338789;
    futhark_mc_segmap_parloop_338789_task.args =
        &futhark_mc_segmap_parloop_struct_338788;
    futhark_mc_segmap_parloop_338789_task.iterations = iterations;
    futhark_mc_segmap_parloop_338789_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338789_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338789_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338789_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338789_task);
    
    if (futhark_mc_segmap_parloop_338789_err != 0) {
        err = futhark_mc_segmap_parloop_338789_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338789_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338789_total_end -
                 futhark_mc_segmap_parloop_338789_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338789_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338789_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338789_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_nested_task_338787_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_nested_task_338787_end -
                 futhark_mc_segmap_nested_task_338787_start;
        
        ctx->futhark_mc_segmap_nested_task_338787_runs[tid]++;
        ctx->futhark_mc_segmap_nested_task_338787_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_nested_task_338787_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
static int futhark_mc_segmap_parloop_338770(void *args, int64_t start,
                                            int64_t end, int flat_tid_307602,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338769
    *futhark_mc_segmap_parloop_struct_338769 =
    (struct futhark_mc_segmap_parloop_struct_338769 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338769->ctx;
    uint64_t futhark_mc_segmap_parloop_338770_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338770_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_338769->free_n_292675;
    int64_t q_t_292679 =
            futhark_mc_segmap_parloop_struct_338769->free_q_t_292679;
    int64_t jump_t_292685 =
            futhark_mc_segmap_parloop_struct_338769->free_jump_t_292685;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_338769->free_partition_sizze_292766;
    int64_t t_n_m_292839 =
            futhark_mc_segmap_parloop_struct_338769->free_t_n_m_292839;
    int64_t i_292846 = futhark_mc_segmap_parloop_struct_338769->free_i_292846;
    struct memblock mem_312593 = {.desc ="mem_312593", .mem =
                                  futhark_mc_segmap_parloop_struct_338769->free_mem_312593,
                                  .size =0, .references =NULL};
    int64_t bytes_312598 =
            futhark_mc_segmap_parloop_struct_338769->free_bytes_312598;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_segmap_parloop_struct_338769->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_312639 = {.desc ="mem_312639", .mem =
                                  futhark_mc_segmap_parloop_struct_338769->free_mem_312639,
                                  .size =0, .references =NULL};
    int64_t bytes_313090 =
            futhark_mc_segmap_parloop_struct_338769->free_bytes_313090;
    struct memblock mem_313143 = {.desc ="mem_313143", .mem =
                                  futhark_mc_segmap_parloop_struct_338769->free_mem_313143,
                                  .size =0, .references =NULL};
    struct memblock mem_313147 = {.desc ="mem_313147", .mem =
                                  futhark_mc_segmap_parloop_struct_338769->free_mem_313147,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_segmap_parloop_struct_338769->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_segmap_parloop_struct_338769->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_segmap_parloop_struct_338769->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_segmap_parloop_struct_338769->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315656 = {.desc ="mem_315656", .mem =
                                  futhark_mc_segmap_parloop_struct_338769->free_mem_315656,
                                  .size =0, .references =NULL};
    struct memblock mem_315736 = {.desc ="mem_315736", .mem =
                                  futhark_mc_segmap_parloop_struct_338769->free_mem_315736,
                                  .size =0, .references =NULL};
    size_t mem_315663_cached_sizze_338771 = 0;
    unsigned char *mem_315663 = NULL;
    size_t mem_315666_cached_sizze_338772 = 0;
    unsigned char *mem_315666 = NULL;
    size_t mem_315669_cached_sizze_338773 = 0;
    unsigned char *mem_315669 = NULL;
    size_t mem_315672_cached_sizze_338774 = 0;
    unsigned char *mem_315672 = NULL;
    int64_t iterations = end - start;
    int64_t iter_332603 = start;
    
    if (mem_315663_cached_sizze_338771 < (size_t) bytes_312598) {
        mem_315663 = realloc(mem_315663, bytes_312598);
        mem_315663_cached_sizze_338771 = bytes_312598;
    }
    if (mem_315666_cached_sizze_338772 < (size_t) bytes_312598) {
        mem_315666 = realloc(mem_315666, bytes_312598);
        mem_315666_cached_sizze_338772 = bytes_312598;
    }
    if (mem_315669_cached_sizze_338773 < (size_t) bytes_312598) {
        mem_315669 = realloc(mem_315669, bytes_312598);
        mem_315669_cached_sizze_338773 = bytes_312598;
    }
    if (mem_315672_cached_sizze_338774 < (size_t) bytes_313090) {
        mem_315672 = realloc(mem_315672, bytes_313090);
        mem_315672_cached_sizze_338774 = bytes_313090;
    }
    for (; iter_332603 < end; iter_332603++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_332744 = partition_sizze_292766;
        int64_t gtid_307603 = iter_332603;
        int64_t remnant_332745 = iter_332603 - gtid_307603;
        int64_t x_307608;
        
        x_307608 = ((int64_t *) mem_312639.mem)[gtid_307603];
        
        int64_t flat_tid_332604 = (int64_t) 0;
        int32_t num_tasks_332746;
        struct futhark_mc_task_338775 futhark_mc_task_338775;
        
        futhark_mc_task_338775.ctx = ctx;
        futhark_mc_task_338775.free_n_292675 = n_292675;
        futhark_mc_task_338775.free_gtid_307603 = gtid_307603;
        futhark_mc_task_338775.free_mem_312593 = mem_312593.mem;
        futhark_mc_task_338775.free_mem_315656 = mem_315656.mem;
        futhark_mc_task_338775.free_mem_315663 = mem_315663;
        
        struct scheduler_segop futhark_mc_task_338775_task;
        
        futhark_mc_task_338775_task.args = &futhark_mc_task_338775;
        futhark_mc_task_338775_task.top_level_fn =
            futhark_mc_segmap_task_338776;
        futhark_mc_task_338775_task.name = "futhark_mc_segmap_task_338776";
        futhark_mc_task_338775_task.iterations = n_292675;
        futhark_mc_task_338775_task.task_time =
            &ctx->futhark_mc_segmap_task_338776_total_time;
        futhark_mc_task_338775_task.task_iter =
            &ctx->futhark_mc_segmap_task_338776_total_iter;
        futhark_mc_task_338775_task.sched = STATIC;
        futhark_mc_task_338775_task.nested_fn = NULL;
        
        int futhark_mc_segmap_task_338776_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_338775_task);
        
        if (futhark_mc_segmap_task_338776_err != 0) {
            ;
            err = futhark_mc_segmap_task_338776_err;
            goto cleanup;
        }
        
        int64_t flat_tid_332610 = (int64_t) 0;
        int32_t num_tasks_332750;
        struct futhark_mc_task_338779 futhark_mc_task_338779;
        
        futhark_mc_task_338779.ctx = ctx;
        futhark_mc_task_338779.free_n_292675 = n_292675;
        futhark_mc_task_338779.free_gtid_307603 = gtid_307603;
        futhark_mc_task_338779.free_mem_312636 = mem_312636.mem;
        futhark_mc_task_338779.free_ctx_param_ext_313174 = ctx_param_ext_313174;
        futhark_mc_task_338779.free_ctx_param_ext_313175 = ctx_param_ext_313175;
        futhark_mc_task_338779.free_ctx_param_ext_313177 = ctx_param_ext_313177;
        futhark_mc_task_338779.free_mem_param_313179 = mem_param_313179.mem;
        futhark_mc_task_338779.free_mem_315663 = mem_315663;
        futhark_mc_task_338779.free_mem_315666 = mem_315666;
        futhark_mc_task_338779.free_mem_315669 = mem_315669;
        
        struct scheduler_segop futhark_mc_task_338779_task;
        
        futhark_mc_task_338779_task.args = &futhark_mc_task_338779;
        futhark_mc_task_338779_task.top_level_fn =
            futhark_mc_segmap_task_338780;
        futhark_mc_task_338779_task.name = "futhark_mc_segmap_task_338780";
        futhark_mc_task_338779_task.iterations = n_292675;
        futhark_mc_task_338779_task.task_time =
            &ctx->futhark_mc_segmap_task_338780_total_time;
        futhark_mc_task_338779_task.task_iter =
            &ctx->futhark_mc_segmap_task_338780_total_iter;
        futhark_mc_task_338779_task.sched = STATIC;
        futhark_mc_task_338779_task.nested_fn = NULL;
        
        int futhark_mc_segmap_task_338780_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_338779_task);
        
        if (futhark_mc_segmap_task_338780_err != 0) {
            ;
            err = futhark_mc_segmap_task_338780_err;
            goto cleanup;
        }
        
        int64_t flat_tid_332686 = (int64_t) 0;
        int32_t num_tasks_332762;
        int64_t flat_tid_332624 = (int64_t) 0;
        struct futhark_mc_task_338783 futhark_mc_task_338783;
        
        futhark_mc_task_338783.ctx = ctx;
        futhark_mc_task_338783.free_n_292675 = n_292675;
        futhark_mc_task_338783.free_q_t_292679 = q_t_292679;
        futhark_mc_task_338783.free_jump_t_292685 = jump_t_292685;
        futhark_mc_task_338783.free_t_n_m_292839 = t_n_m_292839;
        futhark_mc_task_338783.free_i_292846 = i_292846;
        futhark_mc_task_338783.free_gtid_307603 = gtid_307603;
        futhark_mc_task_338783.free_x_307608 = x_307608;
        futhark_mc_task_338783.free_mem_312636 = mem_312636.mem;
        futhark_mc_task_338783.free_mem_313143 = mem_313143.mem;
        futhark_mc_task_338783.free_mem_313147 = mem_313147.mem;
        futhark_mc_task_338783.free_mem_315666 = mem_315666;
        futhark_mc_task_338783.free_mem_315669 = mem_315669;
        futhark_mc_task_338783.free_mem_315672 = mem_315672;
        
        struct scheduler_segop futhark_mc_task_338783_task;
        
        futhark_mc_task_338783_task.args = &futhark_mc_task_338783;
        futhark_mc_task_338783_task.top_level_fn =
            futhark_mc_segmap_task_338784;
        futhark_mc_task_338783_task.name = "futhark_mc_segmap_task_338784";
        futhark_mc_task_338783_task.iterations = t_n_m_292839;
        futhark_mc_task_338783_task.task_time =
            &ctx->futhark_mc_segmap_task_338784_total_time;
        futhark_mc_task_338783_task.task_iter =
            &ctx->futhark_mc_segmap_task_338784_total_iter;
        futhark_mc_task_338783_task.sched = STATIC;
        futhark_mc_task_338783_task.nested_fn =
            futhark_mc_segmap_nested_task_338787;
        
        int futhark_mc_segmap_task_338784_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_338783_task);
        
        if (futhark_mc_segmap_task_338784_err != 0) {
            ;
            err = futhark_mc_segmap_task_338784_err;
            goto cleanup;
        }
        if (t_n_m_292839 * (int64_t) 8 > 0)
            memmove(mem_315736.mem + gtid_307603 * t_n_m_292839 * (int64_t) 8,
                    mem_315672 + (int64_t) 0, t_n_m_292839 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_315663);
    free(mem_315666);
    free(mem_315669);
    free(mem_315672);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338770_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338770_end -
                 futhark_mc_segmap_parloop_338770_start;
        
        ctx->futhark_mc_segmap_parloop_338770_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338770_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338770_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_nested_task_338768(void *args, int64_t iterations,
                                         int tid, struct scheduler_info info)
{
    int err = 0;
    int flat_tid_307602 = tid;
    int num_tasks_332510 = info.nsubtasks;
    struct futhark_mc_task_338760 *futhark_mc_task_338760 =
                                  (struct futhark_mc_task_338760 *) args;
    struct futhark_context *ctx = futhark_mc_task_338760->ctx;
    uint64_t futhark_mc_segmap_nested_task_338768_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_nested_task_338768_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338760->free_n_292675;
    int64_t q_t_292679 = futhark_mc_task_338760->free_q_t_292679;
    int64_t jump_t_292685 = futhark_mc_task_338760->free_jump_t_292685;
    int64_t partition_sizze_292766 =
            futhark_mc_task_338760->free_partition_sizze_292766;
    int64_t t_n_m_292839 = futhark_mc_task_338760->free_t_n_m_292839;
    int64_t i_292846 = futhark_mc_task_338760->free_i_292846;
    struct memblock mem_312593 = {.desc ="mem_312593", .mem =
                                  futhark_mc_task_338760->free_mem_312593,
                                  .size =0, .references =NULL};
    int64_t bytes_312598 = futhark_mc_task_338760->free_bytes_312598;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_task_338760->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_312639 = {.desc ="mem_312639", .mem =
                                  futhark_mc_task_338760->free_mem_312639,
                                  .size =0, .references =NULL};
    int64_t bytes_313090 = futhark_mc_task_338760->free_bytes_313090;
    struct memblock mem_313143 = {.desc ="mem_313143", .mem =
                                  futhark_mc_task_338760->free_mem_313143,
                                  .size =0, .references =NULL};
    struct memblock mem_313147 = {.desc ="mem_313147", .mem =
                                  futhark_mc_task_338760->free_mem_313147,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_task_338760->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_task_338760->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_task_338760->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_task_338760->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315656 = {.desc ="mem_315656", .mem =
                                  futhark_mc_task_338760->free_mem_315656,
                                  .size =0, .references =NULL};
    struct memblock mem_315736 = {.desc ="mem_315736", .mem =
                                  futhark_mc_task_338760->free_mem_315736,
                                  .size =0, .references =NULL};
    int64_t iter_332603;
    struct futhark_mc_segmap_parloop_struct_338769
    futhark_mc_segmap_parloop_struct_338769;
    
    futhark_mc_segmap_parloop_struct_338769.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338769.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_338769.free_q_t_292679 = q_t_292679;
    futhark_mc_segmap_parloop_struct_338769.free_jump_t_292685 = jump_t_292685;
    futhark_mc_segmap_parloop_struct_338769.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_338769.free_t_n_m_292839 = t_n_m_292839;
    futhark_mc_segmap_parloop_struct_338769.free_i_292846 = i_292846;
    futhark_mc_segmap_parloop_struct_338769.free_mem_312593 = mem_312593.mem;
    futhark_mc_segmap_parloop_struct_338769.free_bytes_312598 = bytes_312598;
    futhark_mc_segmap_parloop_struct_338769.free_mem_312636 = mem_312636.mem;
    futhark_mc_segmap_parloop_struct_338769.free_mem_312639 = mem_312639.mem;
    futhark_mc_segmap_parloop_struct_338769.free_bytes_313090 = bytes_313090;
    futhark_mc_segmap_parloop_struct_338769.free_mem_313143 = mem_313143.mem;
    futhark_mc_segmap_parloop_struct_338769.free_mem_313147 = mem_313147.mem;
    futhark_mc_segmap_parloop_struct_338769.free_ctx_param_ext_313174 =
        ctx_param_ext_313174;
    futhark_mc_segmap_parloop_struct_338769.free_ctx_param_ext_313175 =
        ctx_param_ext_313175;
    futhark_mc_segmap_parloop_struct_338769.free_ctx_param_ext_313177 =
        ctx_param_ext_313177;
    futhark_mc_segmap_parloop_struct_338769.free_mem_param_313179 =
        mem_param_313179.mem;
    futhark_mc_segmap_parloop_struct_338769.free_mem_315656 = mem_315656.mem;
    futhark_mc_segmap_parloop_struct_338769.free_mem_315736 = mem_315736.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338770_task;
    
    futhark_mc_segmap_parloop_338770_task.name =
        "futhark_mc_segmap_parloop_338770";
    futhark_mc_segmap_parloop_338770_task.fn = futhark_mc_segmap_parloop_338770;
    futhark_mc_segmap_parloop_338770_task.args =
        &futhark_mc_segmap_parloop_struct_338769;
    futhark_mc_segmap_parloop_338770_task.iterations = iterations;
    futhark_mc_segmap_parloop_338770_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338770_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338770_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338770_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338770_task);
    
    if (futhark_mc_segmap_parloop_338770_err != 0) {
        err = futhark_mc_segmap_parloop_338770_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338770_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338770_total_end -
                 futhark_mc_segmap_parloop_338770_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338770_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338770_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338770_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_nested_task_338768_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_nested_task_338768_end -
                 futhark_mc_segmap_nested_task_338768_start;
        
        ctx->futhark_mc_segmap_nested_task_338768_runs[tid]++;
        ctx->futhark_mc_segmap_nested_task_338768_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_nested_task_338768_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_task_338800 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_t_292679;
    int64_t free_jump_t_292685;
    int64_t free_partition_sizze_292766;
    int64_t free_t_n_m_292839;
    int64_t free_i_292846;
    unsigned char *free_mem_312593;
    int64_t free_bytes_312598;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_312639;
    int64_t free_bytes_313090;
    unsigned char *free_mem_313143;
    unsigned char *free_mem_313147;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315656;
    unsigned char *free_mem_315830;
    unsigned char *free_mem_315834;
};
struct futhark_mc_segmap_parloop_struct_338802 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_t_292679;
    int64_t free_jump_t_292685;
    int64_t free_partition_sizze_292766;
    int64_t free_t_n_m_292839;
    int64_t free_i_292846;
    unsigned char *free_mem_312593;
    int64_t free_bytes_312598;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_312639;
    int64_t free_bytes_313090;
    unsigned char *free_mem_313143;
    unsigned char *free_mem_313147;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315656;
    unsigned char *free_mem_315830;
    unsigned char *free_mem_315834;
};
static int futhark_mc_segmap_parloop_338803(void *args, int64_t start,
                                            int64_t end, int flat_tid_307761,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338802
    *futhark_mc_segmap_parloop_struct_338802 =
    (struct futhark_mc_segmap_parloop_struct_338802 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338802->ctx;
    uint64_t futhark_mc_segmap_parloop_338803_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338803_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_338802->free_n_292675;
    int64_t q_t_292679 =
            futhark_mc_segmap_parloop_struct_338802->free_q_t_292679;
    int64_t jump_t_292685 =
            futhark_mc_segmap_parloop_struct_338802->free_jump_t_292685;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_338802->free_partition_sizze_292766;
    int64_t t_n_m_292839 =
            futhark_mc_segmap_parloop_struct_338802->free_t_n_m_292839;
    int64_t i_292846 = futhark_mc_segmap_parloop_struct_338802->free_i_292846;
    struct memblock mem_312593 = {.desc ="mem_312593", .mem =
                                  futhark_mc_segmap_parloop_struct_338802->free_mem_312593,
                                  .size =0, .references =NULL};
    int64_t bytes_312598 =
            futhark_mc_segmap_parloop_struct_338802->free_bytes_312598;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_segmap_parloop_struct_338802->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_312639 = {.desc ="mem_312639", .mem =
                                  futhark_mc_segmap_parloop_struct_338802->free_mem_312639,
                                  .size =0, .references =NULL};
    int64_t bytes_313090 =
            futhark_mc_segmap_parloop_struct_338802->free_bytes_313090;
    struct memblock mem_313143 = {.desc ="mem_313143", .mem =
                                  futhark_mc_segmap_parloop_struct_338802->free_mem_313143,
                                  .size =0, .references =NULL};
    struct memblock mem_313147 = {.desc ="mem_313147", .mem =
                                  futhark_mc_segmap_parloop_struct_338802->free_mem_313147,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_segmap_parloop_struct_338802->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_segmap_parloop_struct_338802->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_segmap_parloop_struct_338802->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_segmap_parloop_struct_338802->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315656 = {.desc ="mem_315656", .mem =
                                  futhark_mc_segmap_parloop_struct_338802->free_mem_315656,
                                  .size =0, .references =NULL};
    struct memblock mem_315830 = {.desc ="mem_315830", .mem =
                                  futhark_mc_segmap_parloop_struct_338802->free_mem_315830,
                                  .size =0, .references =NULL};
    struct memblock mem_315834 = {.desc ="mem_315834", .mem =
                                  futhark_mc_segmap_parloop_struct_338802->free_mem_315834,
                                  .size =0, .references =NULL};
    size_t mem_315754_cached_sizze_338804 = 0;
    unsigned char *mem_315754 = NULL;
    size_t mem_315769_cached_sizze_338805 = 0;
    unsigned char *mem_315769 = NULL;
    size_t mem_315772_cached_sizze_338806 = 0;
    unsigned char *mem_315772 = NULL;
    size_t mem_315799_cached_sizze_338807 = 0;
    unsigned char *mem_315799 = NULL;
    size_t mem_315802_cached_sizze_338808 = 0;
    unsigned char *mem_315802 = NULL;
    int64_t iterations = end - start;
    int64_t iter_332888 = start;
    
    if (mem_315754_cached_sizze_338804 < (size_t) bytes_312598) {
        mem_315754 = realloc(mem_315754, bytes_312598);
        mem_315754_cached_sizze_338804 = bytes_312598;
    }
    if (mem_315769_cached_sizze_338805 < (size_t) bytes_312598) {
        mem_315769 = realloc(mem_315769, bytes_312598);
        mem_315769_cached_sizze_338805 = bytes_312598;
    }
    if (mem_315772_cached_sizze_338806 < (size_t) bytes_312598) {
        mem_315772 = realloc(mem_315772, bytes_312598);
        mem_315772_cached_sizze_338806 = bytes_312598;
    }
    if (mem_315799_cached_sizze_338807 < (size_t) bytes_313090) {
        mem_315799 = realloc(mem_315799, bytes_313090);
        mem_315799_cached_sizze_338807 = bytes_313090;
    }
    if (mem_315802_cached_sizze_338808 < (size_t) bytes_313090) {
        mem_315802 = realloc(mem_315802, bytes_313090);
        mem_315802_cached_sizze_338808 = bytes_313090;
    }
    for (; iter_332888 < end; iter_332888++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_333001 = partition_sizze_292766;
        int64_t gtid_307762 = iter_332888;
        int64_t remnant_333002 = iter_332888 - gtid_307762;
        int64_t x_295914;
        
        x_295914 = ((int64_t *) mem_312639.mem)[gtid_307762];
        for (int64_t i_332889 = 0; i_332889 < n_292675; i_332889++) {
            float x_332891;
            
            x_332891 = ((float *) mem_312593.mem)[gtid_307762 * n_292675 +
                                                  i_332889];
            
            double x_332892;
            
            x_332892 = ((double *) mem_315656.mem)[gtid_307762 * n_292675 +
                                                   i_332889];
            
            double f32_res_332893 = fpconv_f32_f64(x_332891);
            double defunc_1_f_res_332894 = f32_res_332893 - x_332892;
            
            ((double *) mem_315754)[i_332889] = defunc_1_f_res_332894;
        }
        for (int64_t i_332896 = 0; i_332896 < n_292675; i_332896++) {
            int64_t x_332899;
            
            x_332899 = ((int64_t *) mem_312636.mem)[gtid_307762 * n_292675 +
                                                    i_332896];
            
            bool cond_332900 = sle64((int64_t) 0, x_332899);
            double defunc_0_f_res_332901;
            
            if (cond_332900) {
                bool y_332902 = slt64(x_332899, n_292675);
                bool bounds_check_332903 = cond_332900 && y_332902;
                bool index_certs_332904;
                
                if (!bounds_check_332903) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [", (long long) x_332899,
                                  "] out of bounds for array of shape [",
                                  (long long) n_292675, "].",
                                  "-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:45:43-70\n   #3  stl.fut:285:33-58\n   #4  /prelude/soacs.fut:75:22-28\n   #5  /prelude/soacs.fut:75:3-45\n   #6  stl.fut:283:13-288:41\n   #7  stl.fut:419:61-435:77\n   #8  stl.fut:463:3-479:36\n   #9  stl.fut:445:1-479:36\n");
                    err = FUTHARK_PROGRAM_ERROR;
                    goto cleanup;
                }
                
                double defunc_0_f_res_t_res_332905;
                
                defunc_0_f_res_t_res_332905 = ((double *) mem_315754)[x_332899];
                defunc_0_f_res_332901 = defunc_0_f_res_t_res_332905;
            } else {
                defunc_0_f_res_332901 = 0.0;
            }
            
            double defunc_0_f_res_332906;
            
            if (cond_332900) {
                bool y_332907 = slt64(x_332899, n_292675);
                bool bounds_check_332908 = cond_332900 && y_332907;
                bool index_certs_332909;
                
                if (!bounds_check_332908) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [", (long long) x_332899,
                                  "] out of bounds for array of shape [",
                                  (long long) n_292675, "].",
                                  "-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:45:43-70\n   #3  stl.fut:286:33-64\n   #4  /prelude/soacs.fut:75:22-28\n   #5  /prelude/soacs.fut:75:3-45\n   #6  stl.fut:283:13-288:41\n   #7  stl.fut:419:61-435:77\n   #8  stl.fut:463:3-479:36\n   #9  stl.fut:445:1-479:36\n");
                    err = FUTHARK_PROGRAM_ERROR;
                    goto cleanup;
                }
                
                double defunc_0_f_res_t_res_332910;
                
                defunc_0_f_res_t_res_332910 =
                    ((double *) mem_param_313179.mem)[ctx_param_ext_313174 +
                                                      (gtid_307762 *
                                                       ctx_param_ext_313175 +
                                                       x_332899 *
                                                       ctx_param_ext_313177)];
                defunc_0_f_res_332906 = defunc_0_f_res_t_res_332910;
            } else {
                defunc_0_f_res_332906 = 0.0;
            }
            ((double *) mem_315769)[i_332896] = defunc_0_f_res_332906;
            ((double *) mem_315772)[i_332896] = defunc_0_f_res_332901;
        }
        for (int64_t i_332913 = 0; i_332913 < t_n_m_292839; i_332913++) {
            int64_t x_332916;
            
            x_332916 = ((int64_t *) mem_313143.mem)[gtid_307762 * t_n_m_292839 +
                                                    i_332913];
            
            double x_332917;
            
            x_332917 = ((double *) mem_313147.mem)[gtid_307762 * t_n_m_292839 +
                                                   i_332913];
            
            int64_t min_arg_332918 = mul64(jump_t_292685, i_332913);
            int64_t min_res_332919 = smin64(i_292846, min_arg_332918);
            int64_t defunc_0_g_res_332920 = add64((int64_t) 1, min_res_332919);
            double defunc_2_reduce_res_332921;
            double defunc_2_reduce_res_332922;
            double defunc_2_reduce_res_332923;
            double redout_332925;
            double redout_332926;
            double redout_332927;
            
            redout_332925 = 0.0;
            redout_332926 = 0.0;
            redout_332927 = 0.0;
            for (int64_t i_332924 = 0; i_332924 < q_t_292679; i_332924++) {
                bool cond_332928 = sle64(x_295914, i_332924);
                int64_t defunc_0_f_res_332929;
                
                if (cond_332928) {
                    defunc_0_f_res_332929 = (int64_t) 0;
                } else {
                    int64_t i_332930 = add64(x_332916, i_332924);
                    int64_t defunc_0_add_arg_332931;
                    
                    defunc_0_add_arg_332931 =
                        ((int64_t *) mem_312636.mem)[gtid_307762 * n_292675 +
                                                     i_332930];
                    
                    int64_t defunc_1_add_res_332932 = add64((int64_t) 1,
                                                            defunc_0_add_arg_332931);
                    
                    defunc_0_f_res_332929 = defunc_1_add_res_332932;
                }
                
                double defunc_0_f_res_332933;
                
                if (cond_332928) {
                    defunc_0_f_res_332933 = 0.0;
                } else {
                    int64_t i_332934 = add64(x_332916, i_332924);
                    double defunc_0_add_arg_332935;
                    
                    defunc_0_add_arg_332935 = ((double *) mem_315769)[i_332934];
                    defunc_0_f_res_332933 = defunc_0_add_arg_332935;
                }
                
                int64_t binop_p_332936 = sub64(defunc_0_f_res_332929,
                                               defunc_0_g_res_332920);
                double defunc_0_f_res_332937 = sitofp_i64_f64(binop_p_332936);
                double abs_res_332938 = fabs(defunc_0_f_res_332937);
                double tmp1_332939 = abs_res_332938 / x_332917;
                double x_332940 = tmp1_332939 * tmp1_332939;
                double y_332941 = tmp1_332939 * x_332940;
                double tmp2_332942 = 1.0 - y_332941;
                double x_332943 = tmp2_332942 * tmp2_332942;
                double tmp3_332944 = tmp2_332942 * x_332943;
                double w_j_332945 = defunc_0_f_res_332933 * tmp3_332944;
                double xw_j_332946 = defunc_0_f_res_332937 * w_j_332945;
                double x2w_j_332947 = defunc_0_f_res_332937 * xw_j_332946;
                double defunc_1_op_res_332948 = w_j_332945 + redout_332925;
                double defunc_1_op_res_332949 = xw_j_332946 + redout_332926;
                double defunc_1_op_res_332950 = x2w_j_332947 + redout_332927;
                double redout_tmp_333008 = defunc_1_op_res_332948;
                double redout_tmp_333009 = defunc_1_op_res_332949;
                double redout_tmp_333010 = defunc_1_op_res_332950;
                
                redout_332925 = redout_tmp_333008;
                redout_332926 = redout_tmp_333009;
                redout_332927 = redout_tmp_333010;
            }
            defunc_2_reduce_res_332921 = redout_332925;
            defunc_2_reduce_res_332922 = redout_332926;
            defunc_2_reduce_res_332923 = redout_332927;
            
            double a_332951 = 2.220446049250313e-16 +
                   defunc_2_reduce_res_332921;
            double b_332952 = 2.220446049250313e-16 +
                   defunc_2_reduce_res_332922;
            double c_332953 = 2.220446049250313e-16 +
                   defunc_2_reduce_res_332923;
            double x_332954 = a_332951 * c_332953;
            double y_332955 = b_332952 * b_332952;
            double y_332956 = x_332954 - y_332955;
            double det1_332957 = 1.0 / y_332956;
            double a11_332958 = c_332953 * det1_332957;
            double x_332959 = 0.0 - b_332952;
            double b11_332960 = det1_332957 * x_332959;
            double c11_332961 = a_332951 * det1_332957;
            double defunc_2_reduce_res_332962;
            double defunc_2_reduce_res_332963;
            double redout_332965;
            double redout_332966;
            
            redout_332965 = 0.0;
            redout_332966 = 0.0;
            for (int64_t i_332964 = 0; i_332964 < q_t_292679; i_332964++) {
                bool cond_332967 = sle64(x_295914, i_332964);
                int64_t defunc_0_f_res_332968;
                
                if (cond_332967) {
                    defunc_0_f_res_332968 = (int64_t) 0;
                } else {
                    int64_t i_332969 = add64(x_332916, i_332964);
                    int64_t defunc_0_add_arg_332970;
                    
                    defunc_0_add_arg_332970 =
                        ((int64_t *) mem_312636.mem)[gtid_307762 * n_292675 +
                                                     i_332969];
                    
                    int64_t defunc_1_add_res_332971 = add64((int64_t) 1,
                                                            defunc_0_add_arg_332970);
                    
                    defunc_0_f_res_332968 = defunc_1_add_res_332971;
                }
                
                double defunc_0_f_res_332972;
                
                if (cond_332967) {
                    defunc_0_f_res_332972 = 0.0;
                } else {
                    int64_t i_332973 = add64(x_332916, i_332964);
                    double defunc_0_add_arg_332974;
                    
                    defunc_0_add_arg_332974 = ((double *) mem_315769)[i_332973];
                    defunc_0_f_res_332972 = defunc_0_add_arg_332974;
                }
                
                int64_t binop_p_332975 = sub64(defunc_0_f_res_332968,
                                               defunc_0_g_res_332920);
                double defunc_0_f_res_332976 = sitofp_i64_f64(binop_p_332975);
                double abs_res_332977 = fabs(defunc_0_f_res_332976);
                double tmp1_332978 = abs_res_332977 / x_332917;
                double x_332979 = tmp1_332978 * tmp1_332978;
                double y_332980 = tmp1_332978 * x_332979;
                double tmp2_332981 = 1.0 - y_332980;
                double x_332982 = tmp2_332981 * tmp2_332981;
                double tmp3_332983 = tmp2_332981 * x_332982;
                double tmp4_332984 = defunc_0_f_res_332972 * tmp3_332983;
                double defunc_1_f_res_332985 = defunc_0_f_res_332976 *
                       tmp4_332984;
                double defunc_0_f_res_332986;
                
                if (cond_332967) {
                    defunc_0_f_res_332986 = 0.0;
                } else {
                    int64_t i_332987 = add64(x_332916, i_332964);
                    double defunc_0_add_arg_332988;
                    
                    defunc_0_add_arg_332988 = ((double *) mem_315772)[i_332987];
                    defunc_0_f_res_332986 = defunc_0_add_arg_332988;
                }
                
                double x_332989 = a11_332958 * tmp4_332984;
                double y_332990 = b11_332960 * defunc_1_f_res_332985;
                double x_332991 = x_332989 + y_332990;
                double defunc_9_fit_fun_res_332992 = defunc_0_f_res_332986 *
                       x_332991;
                double x_332993 = b11_332960 * tmp4_332984;
                double y_332994 = c11_332961 * defunc_1_f_res_332985;
                double x_332995 = x_332993 + y_332994;
                double defunc_9_slope_fun_res_332996 = defunc_0_f_res_332986 *
                       x_332995;
                double defunc_1_op_res_332997 = defunc_9_fit_fun_res_332992 +
                       redout_332965;
                double defunc_1_op_res_332998 = defunc_9_slope_fun_res_332996 +
                       redout_332966;
                double redout_tmp_333011 = defunc_1_op_res_332997;
                double redout_tmp_333012 = defunc_1_op_res_332998;
                
                redout_332965 = redout_tmp_333011;
                redout_332966 = redout_tmp_333012;
            }
            defunc_2_reduce_res_332962 = redout_332965;
            defunc_2_reduce_res_332963 = redout_332966;
            ((double *) mem_315799)[i_332913] = defunc_2_reduce_res_332962;
            ((double *) mem_315802)[i_332913] = defunc_2_reduce_res_332963;
        }
        if (t_n_m_292839 * (int64_t) 8 > 0)
            memmove(mem_315830.mem + gtid_307762 * t_n_m_292839 * (int64_t) 8,
                    mem_315799 + (int64_t) 0, t_n_m_292839 * (int64_t) 8);
        if (t_n_m_292839 * (int64_t) 8 > 0)
            memmove(mem_315834.mem + gtid_307762 * t_n_m_292839 * (int64_t) 8,
                    mem_315802 + (int64_t) 0, t_n_m_292839 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_315754);
    free(mem_315769);
    free(mem_315772);
    free(mem_315799);
    free(mem_315802);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338803_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338803_end -
                 futhark_mc_segmap_parloop_338803_start;
        
        ctx->futhark_mc_segmap_parloop_338803_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338803_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338803_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_338801(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_307761 = tid;
    int num_tasks_332887 = info.nsubtasks;
    struct futhark_mc_task_338800 *futhark_mc_task_338800 =
                                  (struct futhark_mc_task_338800 *) args;
    struct futhark_context *ctx = futhark_mc_task_338800->ctx;
    uint64_t futhark_mc_segmap_task_338801_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_338801_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338800->free_n_292675;
    int64_t q_t_292679 = futhark_mc_task_338800->free_q_t_292679;
    int64_t jump_t_292685 = futhark_mc_task_338800->free_jump_t_292685;
    int64_t partition_sizze_292766 =
            futhark_mc_task_338800->free_partition_sizze_292766;
    int64_t t_n_m_292839 = futhark_mc_task_338800->free_t_n_m_292839;
    int64_t i_292846 = futhark_mc_task_338800->free_i_292846;
    struct memblock mem_312593 = {.desc ="mem_312593", .mem =
                                  futhark_mc_task_338800->free_mem_312593,
                                  .size =0, .references =NULL};
    int64_t bytes_312598 = futhark_mc_task_338800->free_bytes_312598;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_task_338800->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_312639 = {.desc ="mem_312639", .mem =
                                  futhark_mc_task_338800->free_mem_312639,
                                  .size =0, .references =NULL};
    int64_t bytes_313090 = futhark_mc_task_338800->free_bytes_313090;
    struct memblock mem_313143 = {.desc ="mem_313143", .mem =
                                  futhark_mc_task_338800->free_mem_313143,
                                  .size =0, .references =NULL};
    struct memblock mem_313147 = {.desc ="mem_313147", .mem =
                                  futhark_mc_task_338800->free_mem_313147,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_task_338800->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_task_338800->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_task_338800->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_task_338800->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315656 = {.desc ="mem_315656", .mem =
                                  futhark_mc_task_338800->free_mem_315656,
                                  .size =0, .references =NULL};
    struct memblock mem_315830 = {.desc ="mem_315830", .mem =
                                  futhark_mc_task_338800->free_mem_315830,
                                  .size =0, .references =NULL};
    struct memblock mem_315834 = {.desc ="mem_315834", .mem =
                                  futhark_mc_task_338800->free_mem_315834,
                                  .size =0, .references =NULL};
    int64_t iter_332888;
    struct futhark_mc_segmap_parloop_struct_338802
    futhark_mc_segmap_parloop_struct_338802;
    
    futhark_mc_segmap_parloop_struct_338802.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338802.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_338802.free_q_t_292679 = q_t_292679;
    futhark_mc_segmap_parloop_struct_338802.free_jump_t_292685 = jump_t_292685;
    futhark_mc_segmap_parloop_struct_338802.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_338802.free_t_n_m_292839 = t_n_m_292839;
    futhark_mc_segmap_parloop_struct_338802.free_i_292846 = i_292846;
    futhark_mc_segmap_parloop_struct_338802.free_mem_312593 = mem_312593.mem;
    futhark_mc_segmap_parloop_struct_338802.free_bytes_312598 = bytes_312598;
    futhark_mc_segmap_parloop_struct_338802.free_mem_312636 = mem_312636.mem;
    futhark_mc_segmap_parloop_struct_338802.free_mem_312639 = mem_312639.mem;
    futhark_mc_segmap_parloop_struct_338802.free_bytes_313090 = bytes_313090;
    futhark_mc_segmap_parloop_struct_338802.free_mem_313143 = mem_313143.mem;
    futhark_mc_segmap_parloop_struct_338802.free_mem_313147 = mem_313147.mem;
    futhark_mc_segmap_parloop_struct_338802.free_ctx_param_ext_313174 =
        ctx_param_ext_313174;
    futhark_mc_segmap_parloop_struct_338802.free_ctx_param_ext_313175 =
        ctx_param_ext_313175;
    futhark_mc_segmap_parloop_struct_338802.free_ctx_param_ext_313177 =
        ctx_param_ext_313177;
    futhark_mc_segmap_parloop_struct_338802.free_mem_param_313179 =
        mem_param_313179.mem;
    futhark_mc_segmap_parloop_struct_338802.free_mem_315656 = mem_315656.mem;
    futhark_mc_segmap_parloop_struct_338802.free_mem_315830 = mem_315830.mem;
    futhark_mc_segmap_parloop_struct_338802.free_mem_315834 = mem_315834.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338803_task;
    
    futhark_mc_segmap_parloop_338803_task.name =
        "futhark_mc_segmap_parloop_338803";
    futhark_mc_segmap_parloop_338803_task.fn = futhark_mc_segmap_parloop_338803;
    futhark_mc_segmap_parloop_338803_task.args =
        &futhark_mc_segmap_parloop_struct_338802;
    futhark_mc_segmap_parloop_338803_task.iterations = iterations;
    futhark_mc_segmap_parloop_338803_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338803_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338803_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338803_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338803_task);
    
    if (futhark_mc_segmap_parloop_338803_err != 0) {
        err = futhark_mc_segmap_parloop_338803_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338803_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338803_total_end -
                 futhark_mc_segmap_parloop_338803_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338803_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338803_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338803_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_338801_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_338801_end -
                 futhark_mc_segmap_task_338801_start;
        
        ctx->futhark_mc_segmap_task_338801_runs[tid]++;
        ctx->futhark_mc_segmap_task_338801_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_338801_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_segmap_parloop_struct_338810 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_t_292679;
    int64_t free_jump_t_292685;
    int64_t free_partition_sizze_292766;
    int64_t free_t_n_m_292839;
    int64_t free_i_292846;
    unsigned char *free_mem_312593;
    int64_t free_bytes_312598;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_312639;
    int64_t free_bytes_313090;
    unsigned char *free_mem_313143;
    unsigned char *free_mem_313147;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315656;
    unsigned char *free_mem_315830;
    unsigned char *free_mem_315834;
};
struct futhark_mc_task_338817 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_307873;
    unsigned char *free_mem_312593;
    unsigned char *free_mem_315656;
    unsigned char *free_mem_315739;
};
struct futhark_mc_segmap_parloop_struct_338819 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_307873;
    unsigned char *free_mem_312593;
    unsigned char *free_mem_315656;
    unsigned char *free_mem_315739;
};
static int futhark_mc_segmap_parloop_338820(void *args, int64_t start,
                                            int64_t end, int flat_tid_333014,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338819
    *futhark_mc_segmap_parloop_struct_338819 =
    (struct futhark_mc_segmap_parloop_struct_338819 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338819->ctx;
    uint64_t futhark_mc_segmap_parloop_338820_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338820_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_338819->free_n_292675;
    int64_t gtid_307873 =
            futhark_mc_segmap_parloop_struct_338819->free_gtid_307873;
    struct memblock mem_312593 = {.desc ="mem_312593", .mem =
                                  futhark_mc_segmap_parloop_struct_338819->free_mem_312593,
                                  .size =0, .references =NULL};
    struct memblock mem_315656 = {.desc ="mem_315656", .mem =
                                  futhark_mc_segmap_parloop_struct_338819->free_mem_315656,
                                  .size =0, .references =NULL};
    struct memblock mem_315739 = {.desc ="mem_315739", .mem =
                                  futhark_mc_segmap_parloop_struct_338819->free_mem_315739,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_333214 = start;
    
    for (; iter_333214 < end; iter_333214++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_333215 = n_292675;
        int64_t gtid_333015 = iter_333214;
        int64_t remnant_333216 = iter_333214 - gtid_333015;
        float x_333016;
        
        x_333016 = ((float *) mem_312593.mem)[gtid_307873 * n_292675 +
                                              gtid_333015];
        
        double x_333017;
        
        x_333017 = ((double *) mem_315656.mem)[gtid_307873 * n_292675 +
                                               gtid_333015];
        
        double f32_res_333018 = fpconv_f32_f64(x_333016);
        double defunc_1_f_res_333019 = f32_res_333018 - x_333017;
        
        ((double *) mem_315739.mem)[gtid_333015] = defunc_1_f_res_333019;
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338820_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338820_end -
                 futhark_mc_segmap_parloop_338820_start;
        
        ctx->futhark_mc_segmap_parloop_338820_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338820_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338820_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_338818(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_333014 = tid;
    int num_tasks_333213 = info.nsubtasks;
    struct futhark_mc_task_338817 *futhark_mc_task_338817 =
                                  (struct futhark_mc_task_338817 *) args;
    struct futhark_context *ctx = futhark_mc_task_338817->ctx;
    uint64_t futhark_mc_segmap_task_338818_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_338818_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338817->free_n_292675;
    int64_t gtid_307873 = futhark_mc_task_338817->free_gtid_307873;
    struct memblock mem_312593 = {.desc ="mem_312593", .mem =
                                  futhark_mc_task_338817->free_mem_312593,
                                  .size =0, .references =NULL};
    struct memblock mem_315656 = {.desc ="mem_315656", .mem =
                                  futhark_mc_task_338817->free_mem_315656,
                                  .size =0, .references =NULL};
    struct memblock mem_315739 = {.desc ="mem_315739", .mem =
                                  futhark_mc_task_338817->free_mem_315739,
                                  .size =0, .references =NULL};
    int64_t iter_333214;
    struct futhark_mc_segmap_parloop_struct_338819
    futhark_mc_segmap_parloop_struct_338819;
    
    futhark_mc_segmap_parloop_struct_338819.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338819.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_338819.free_gtid_307873 = gtid_307873;
    futhark_mc_segmap_parloop_struct_338819.free_mem_312593 = mem_312593.mem;
    futhark_mc_segmap_parloop_struct_338819.free_mem_315656 = mem_315656.mem;
    futhark_mc_segmap_parloop_struct_338819.free_mem_315739 = mem_315739.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338820_task;
    
    futhark_mc_segmap_parloop_338820_task.name =
        "futhark_mc_segmap_parloop_338820";
    futhark_mc_segmap_parloop_338820_task.fn = futhark_mc_segmap_parloop_338820;
    futhark_mc_segmap_parloop_338820_task.args =
        &futhark_mc_segmap_parloop_struct_338819;
    futhark_mc_segmap_parloop_338820_task.iterations = iterations;
    futhark_mc_segmap_parloop_338820_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338820_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338820_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338820_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338820_task);
    
    if (futhark_mc_segmap_parloop_338820_err != 0) {
        err = futhark_mc_segmap_parloop_338820_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338820_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338820_total_end -
                 futhark_mc_segmap_parloop_338820_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338820_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338820_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338820_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_338818_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_338818_end -
                 futhark_mc_segmap_task_338818_start;
        
        ctx->futhark_mc_segmap_task_338818_runs[tid]++;
        ctx->futhark_mc_segmap_task_338818_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_338818_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_task_338821 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_307873;
    unsigned char *free_mem_312636;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315739;
    unsigned char *free_mem_315742;
    unsigned char *free_mem_315745;
};
struct futhark_mc_segmap_parloop_struct_338823 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_307873;
    unsigned char *free_mem_312636;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315739;
    unsigned char *free_mem_315742;
    unsigned char *free_mem_315745;
};
static int futhark_mc_segmap_parloop_338824(void *args, int64_t start,
                                            int64_t end, int flat_tid_333020,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338823
    *futhark_mc_segmap_parloop_struct_338823 =
    (struct futhark_mc_segmap_parloop_struct_338823 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338823->ctx;
    uint64_t futhark_mc_segmap_parloop_338824_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338824_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_338823->free_n_292675;
    int64_t gtid_307873 =
            futhark_mc_segmap_parloop_struct_338823->free_gtid_307873;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_segmap_parloop_struct_338823->free_mem_312636,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_segmap_parloop_struct_338823->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_segmap_parloop_struct_338823->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_segmap_parloop_struct_338823->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_segmap_parloop_struct_338823->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315739 = {.desc ="mem_315739", .mem =
                                  futhark_mc_segmap_parloop_struct_338823->free_mem_315739,
                                  .size =0, .references =NULL};
    struct memblock mem_315742 = {.desc ="mem_315742", .mem =
                                  futhark_mc_segmap_parloop_struct_338823->free_mem_315742,
                                  .size =0, .references =NULL};
    struct memblock mem_315745 = {.desc ="mem_315745", .mem =
                                  futhark_mc_segmap_parloop_struct_338823->free_mem_315745,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_333218 = start;
    
    for (; iter_333218 < end; iter_333218++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_333227 = n_292675;
        int64_t gtid_333021 = iter_333218;
        int64_t remnant_333228 = iter_333218 - gtid_333021;
        int64_t x_333022;
        
        x_333022 = ((int64_t *) mem_312636.mem)[gtid_307873 * n_292675 +
                                                gtid_333021];
        
        bool cond_333023 = sle64((int64_t) 0, x_333022);
        double defunc_0_f_res_333024;
        
        if (cond_333023) {
            bool y_333219 = slt64(x_333022, n_292675);
            bool bounds_check_333220 = cond_333023 && y_333219;
            bool index_certs_333221;
            
            if (!bounds_check_333220) {
                ctx->error =
                    msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                              "Index [", (long long) x_333022,
                              "] out of bounds for array of shape [",
                              (long long) n_292675, "].",
                              "-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:45:43-70\n   #3  stl.fut:285:33-58\n   #4  /prelude/soacs.fut:75:22-28\n   #5  /prelude/soacs.fut:75:3-45\n   #6  stl.fut:283:13-288:41\n   #7  stl.fut:419:61-435:77\n   #8  stl.fut:463:3-479:36\n   #9  stl.fut:445:1-479:36\n");
                err = FUTHARK_PROGRAM_ERROR;
                goto cleanup;
            }
            
            double defunc_0_f_res_t_res_333222;
            
            defunc_0_f_res_t_res_333222 = ((double *) mem_315739.mem)[x_333022];
            defunc_0_f_res_333024 = defunc_0_f_res_t_res_333222;
        } else {
            defunc_0_f_res_333024 = 0.0;
        }
        
        double defunc_0_f_res_333029;
        
        if (cond_333023) {
            bool y_333223 = slt64(x_333022, n_292675);
            bool bounds_check_333224 = cond_333023 && y_333223;
            bool index_certs_333225;
            
            if (!bounds_check_333224) {
                ctx->error =
                    msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                              "Index [", (long long) x_333022,
                              "] out of bounds for array of shape [",
                              (long long) n_292675, "].",
                              "-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:45:43-70\n   #3  stl.fut:286:33-64\n   #4  /prelude/soacs.fut:75:22-28\n   #5  /prelude/soacs.fut:75:3-45\n   #6  stl.fut:283:13-288:41\n   #7  stl.fut:419:61-435:77\n   #8  stl.fut:463:3-479:36\n   #9  stl.fut:445:1-479:36\n");
                err = FUTHARK_PROGRAM_ERROR;
                goto cleanup;
            }
            
            double defunc_0_f_res_t_res_333226;
            
            defunc_0_f_res_t_res_333226 =
                ((double *) mem_param_313179.mem)[ctx_param_ext_313174 +
                                                  (gtid_307873 *
                                                   ctx_param_ext_313175 +
                                                   x_333022 *
                                                   ctx_param_ext_313177)];
            defunc_0_f_res_333029 = defunc_0_f_res_t_res_333226;
        } else {
            defunc_0_f_res_333029 = 0.0;
        }
        ((double *) mem_315742.mem)[gtid_333021] = defunc_0_f_res_333029;
        ((double *) mem_315745.mem)[gtid_333021] = defunc_0_f_res_333024;
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338824_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338824_end -
                 futhark_mc_segmap_parloop_338824_start;
        
        ctx->futhark_mc_segmap_parloop_338824_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338824_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338824_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_338822(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_333020 = tid;
    int num_tasks_333217 = info.nsubtasks;
    struct futhark_mc_task_338821 *futhark_mc_task_338821 =
                                  (struct futhark_mc_task_338821 *) args;
    struct futhark_context *ctx = futhark_mc_task_338821->ctx;
    uint64_t futhark_mc_segmap_task_338822_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_338822_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338821->free_n_292675;
    int64_t gtid_307873 = futhark_mc_task_338821->free_gtid_307873;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_task_338821->free_mem_312636,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_task_338821->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_task_338821->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_task_338821->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_task_338821->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315739 = {.desc ="mem_315739", .mem =
                                  futhark_mc_task_338821->free_mem_315739,
                                  .size =0, .references =NULL};
    struct memblock mem_315742 = {.desc ="mem_315742", .mem =
                                  futhark_mc_task_338821->free_mem_315742,
                                  .size =0, .references =NULL};
    struct memblock mem_315745 = {.desc ="mem_315745", .mem =
                                  futhark_mc_task_338821->free_mem_315745,
                                  .size =0, .references =NULL};
    int64_t iter_333218;
    struct futhark_mc_segmap_parloop_struct_338823
    futhark_mc_segmap_parloop_struct_338823;
    
    futhark_mc_segmap_parloop_struct_338823.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338823.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_338823.free_gtid_307873 = gtid_307873;
    futhark_mc_segmap_parloop_struct_338823.free_mem_312636 = mem_312636.mem;
    futhark_mc_segmap_parloop_struct_338823.free_ctx_param_ext_313174 =
        ctx_param_ext_313174;
    futhark_mc_segmap_parloop_struct_338823.free_ctx_param_ext_313175 =
        ctx_param_ext_313175;
    futhark_mc_segmap_parloop_struct_338823.free_ctx_param_ext_313177 =
        ctx_param_ext_313177;
    futhark_mc_segmap_parloop_struct_338823.free_mem_param_313179 =
        mem_param_313179.mem;
    futhark_mc_segmap_parloop_struct_338823.free_mem_315739 = mem_315739.mem;
    futhark_mc_segmap_parloop_struct_338823.free_mem_315742 = mem_315742.mem;
    futhark_mc_segmap_parloop_struct_338823.free_mem_315745 = mem_315745.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338824_task;
    
    futhark_mc_segmap_parloop_338824_task.name =
        "futhark_mc_segmap_parloop_338824";
    futhark_mc_segmap_parloop_338824_task.fn = futhark_mc_segmap_parloop_338824;
    futhark_mc_segmap_parloop_338824_task.args =
        &futhark_mc_segmap_parloop_struct_338823;
    futhark_mc_segmap_parloop_338824_task.iterations = iterations;
    futhark_mc_segmap_parloop_338824_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338824_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338824_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338824_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338824_task);
    
    if (futhark_mc_segmap_parloop_338824_err != 0) {
        err = futhark_mc_segmap_parloop_338824_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338824_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338824_total_end -
                 futhark_mc_segmap_parloop_338824_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338824_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338824_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338824_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_338822_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_338822_end -
                 futhark_mc_segmap_task_338822_start;
        
        ctx->futhark_mc_segmap_task_338822_runs[tid]++;
        ctx->futhark_mc_segmap_task_338822_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_338822_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_task_338825 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_t_292679;
    int64_t free_jump_t_292685;
    int64_t free_t_n_m_292839;
    int64_t free_i_292846;
    int64_t free_gtid_307873;
    int64_t free_x_307878;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_313143;
    unsigned char *free_mem_313147;
    unsigned char *free_mem_315742;
    unsigned char *free_mem_315745;
    unsigned char *free_mem_315748;
    unsigned char *free_mem_315751;
};
struct futhark_mc_segmap_parloop_struct_338827 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_t_292679;
    int64_t free_jump_t_292685;
    int64_t free_t_n_m_292839;
    int64_t free_i_292846;
    int64_t free_gtid_307873;
    int64_t free_x_307878;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_313143;
    unsigned char *free_mem_313147;
    unsigned char *free_mem_315742;
    unsigned char *free_mem_315745;
    unsigned char *free_mem_315748;
    unsigned char *free_mem_315751;
};
static int futhark_mc_segmap_parloop_338828(void *args, int64_t start,
                                            int64_t end, int flat_tid_333126,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338827
    *futhark_mc_segmap_parloop_struct_338827 =
    (struct futhark_mc_segmap_parloop_struct_338827 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338827->ctx;
    uint64_t futhark_mc_segmap_parloop_338828_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338828_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_338827->free_n_292675;
    int64_t q_t_292679 =
            futhark_mc_segmap_parloop_struct_338827->free_q_t_292679;
    int64_t jump_t_292685 =
            futhark_mc_segmap_parloop_struct_338827->free_jump_t_292685;
    int64_t t_n_m_292839 =
            futhark_mc_segmap_parloop_struct_338827->free_t_n_m_292839;
    int64_t i_292846 = futhark_mc_segmap_parloop_struct_338827->free_i_292846;
    int64_t gtid_307873 =
            futhark_mc_segmap_parloop_struct_338827->free_gtid_307873;
    int64_t x_307878 = futhark_mc_segmap_parloop_struct_338827->free_x_307878;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_segmap_parloop_struct_338827->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_313143 = {.desc ="mem_313143", .mem =
                                  futhark_mc_segmap_parloop_struct_338827->free_mem_313143,
                                  .size =0, .references =NULL};
    struct memblock mem_313147 = {.desc ="mem_313147", .mem =
                                  futhark_mc_segmap_parloop_struct_338827->free_mem_313147,
                                  .size =0, .references =NULL};
    struct memblock mem_315742 = {.desc ="mem_315742", .mem =
                                  futhark_mc_segmap_parloop_struct_338827->free_mem_315742,
                                  .size =0, .references =NULL};
    struct memblock mem_315745 = {.desc ="mem_315745", .mem =
                                  futhark_mc_segmap_parloop_struct_338827->free_mem_315745,
                                  .size =0, .references =NULL};
    struct memblock mem_315748 = {.desc ="mem_315748", .mem =
                                  futhark_mc_segmap_parloop_struct_338827->free_mem_315748,
                                  .size =0, .references =NULL};
    struct memblock mem_315751 = {.desc ="mem_315751", .mem =
                                  futhark_mc_segmap_parloop_struct_338827->free_mem_315751,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_333230 = start;
    
    for (; iter_333230 < end; iter_333230++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_333293 = t_n_m_292839;
        int64_t gtid_333127 = iter_333230;
        int64_t remnant_333294 = iter_333230 - gtid_333127;
        int64_t x_333128;
        
        x_333128 = ((int64_t *) mem_313143.mem)[gtid_307873 * t_n_m_292839 +
                                                gtid_333127];
        
        double x_333129;
        
        x_333129 = ((double *) mem_313147.mem)[gtid_307873 * t_n_m_292839 +
                                               gtid_333127];
        
        int64_t min_arg_333130 = mul64(jump_t_292685, gtid_333127);
        int64_t min_res_333131 = smin64(i_292846, min_arg_333130);
        int64_t defunc_0_g_res_333132 = add64((int64_t) 1, min_res_333131);
        double defunc_2_reduce_res_333133;
        double defunc_2_reduce_res_333134;
        double defunc_2_reduce_res_333135;
        double redout_333232;
        double redout_333233;
        double redout_333234;
        
        redout_333232 = 0.0;
        redout_333233 = 0.0;
        redout_333234 = 0.0;
        for (int64_t i_333231 = 0; i_333231 < q_t_292679; i_333231++) {
            bool cond_333235 = sle64(x_307878, i_333231);
            int64_t defunc_0_f_res_333236;
            
            if (cond_333235) {
                defunc_0_f_res_333236 = (int64_t) 0;
            } else {
                int64_t i_333237 = add64(x_333128, i_333231);
                int64_t defunc_0_add_arg_333238;
                
                defunc_0_add_arg_333238 =
                    ((int64_t *) mem_312636.mem)[gtid_307873 * n_292675 +
                                                 i_333237];
                
                int64_t defunc_1_add_res_333239 = add64((int64_t) 1,
                                                        defunc_0_add_arg_333238);
                
                defunc_0_f_res_333236 = defunc_1_add_res_333239;
            }
            
            double defunc_0_f_res_333240;
            
            if (cond_333235) {
                defunc_0_f_res_333240 = 0.0;
            } else {
                int64_t i_333241 = add64(x_333128, i_333231);
                double defunc_0_add_arg_333242;
                
                defunc_0_add_arg_333242 = ((double *) mem_315742.mem)[i_333241];
                defunc_0_f_res_333240 = defunc_0_add_arg_333242;
            }
            
            int64_t binop_p_333243 = sub64(defunc_0_f_res_333236,
                                           defunc_0_g_res_333132);
            double defunc_0_f_res_333244 = sitofp_i64_f64(binop_p_333243);
            double abs_res_333245 = fabs(defunc_0_f_res_333244);
            double tmp1_333246 = abs_res_333245 / x_333129;
            double x_333247 = tmp1_333246 * tmp1_333246;
            double y_333248 = tmp1_333246 * x_333247;
            double tmp2_333249 = 1.0 - y_333248;
            double x_333250 = tmp2_333249 * tmp2_333249;
            double tmp3_333251 = tmp2_333249 * x_333250;
            double w_j_333252 = defunc_0_f_res_333240 * tmp3_333251;
            double xw_j_333253 = defunc_0_f_res_333244 * w_j_333252;
            double x2w_j_333254 = defunc_0_f_res_333244 * xw_j_333253;
            double defunc_1_op_res_333255 = w_j_333252 + redout_333232;
            double defunc_1_op_res_333256 = xw_j_333253 + redout_333233;
            double defunc_1_op_res_333257 = x2w_j_333254 + redout_333234;
            double redout_tmp_333295 = defunc_1_op_res_333255;
            double redout_tmp_333296 = defunc_1_op_res_333256;
            double redout_tmp_333297 = defunc_1_op_res_333257;
            
            redout_333232 = redout_tmp_333295;
            redout_333233 = redout_tmp_333296;
            redout_333234 = redout_tmp_333297;
        }
        defunc_2_reduce_res_333133 = redout_333232;
        defunc_2_reduce_res_333134 = redout_333233;
        defunc_2_reduce_res_333135 = redout_333234;
        
        double a_333163 = 2.220446049250313e-16 + defunc_2_reduce_res_333133;
        double b_333164 = 2.220446049250313e-16 + defunc_2_reduce_res_333134;
        double c_333165 = 2.220446049250313e-16 + defunc_2_reduce_res_333135;
        double x_333166 = a_333163 * c_333165;
        double y_333167 = b_333164 * b_333164;
        double y_333168 = x_333166 - y_333167;
        double det1_333169 = 1.0 / y_333168;
        double a11_333170 = c_333165 * det1_333169;
        double x_333171 = 0.0 - b_333164;
        double b11_333172 = det1_333169 * x_333171;
        double c11_333173 = a_333163 * det1_333169;
        double defunc_2_reduce_res_333174;
        double defunc_2_reduce_res_333175;
        double redout_333259;
        double redout_333260;
        
        redout_333259 = 0.0;
        redout_333260 = 0.0;
        for (int64_t i_333258 = 0; i_333258 < q_t_292679; i_333258++) {
            bool cond_333261 = sle64(x_307878, i_333258);
            int64_t defunc_0_f_res_333262;
            
            if (cond_333261) {
                defunc_0_f_res_333262 = (int64_t) 0;
            } else {
                int64_t i_333263 = add64(x_333128, i_333258);
                int64_t defunc_0_add_arg_333264;
                
                defunc_0_add_arg_333264 =
                    ((int64_t *) mem_312636.mem)[gtid_307873 * n_292675 +
                                                 i_333263];
                
                int64_t defunc_1_add_res_333265 = add64((int64_t) 1,
                                                        defunc_0_add_arg_333264);
                
                defunc_0_f_res_333262 = defunc_1_add_res_333265;
            }
            
            double defunc_0_f_res_333266;
            
            if (cond_333261) {
                defunc_0_f_res_333266 = 0.0;
            } else {
                int64_t i_333267 = add64(x_333128, i_333258);
                double defunc_0_add_arg_333268;
                
                defunc_0_add_arg_333268 = ((double *) mem_315742.mem)[i_333267];
                defunc_0_f_res_333266 = defunc_0_add_arg_333268;
            }
            
            int64_t binop_p_333269 = sub64(defunc_0_f_res_333262,
                                           defunc_0_g_res_333132);
            double defunc_0_f_res_333270 = sitofp_i64_f64(binop_p_333269);
            double abs_res_333271 = fabs(defunc_0_f_res_333270);
            double tmp1_333272 = abs_res_333271 / x_333129;
            double x_333273 = tmp1_333272 * tmp1_333272;
            double y_333274 = tmp1_333272 * x_333273;
            double tmp2_333275 = 1.0 - y_333274;
            double x_333276 = tmp2_333275 * tmp2_333275;
            double tmp3_333277 = tmp2_333275 * x_333276;
            double tmp4_333278 = defunc_0_f_res_333266 * tmp3_333277;
            double defunc_1_f_res_333279 = defunc_0_f_res_333270 * tmp4_333278;
            double defunc_0_f_res_333280;
            
            if (cond_333261) {
                defunc_0_f_res_333280 = 0.0;
            } else {
                int64_t i_333281 = add64(x_333128, i_333258);
                double defunc_0_add_arg_333282;
                
                defunc_0_add_arg_333282 = ((double *) mem_315745.mem)[i_333281];
                defunc_0_f_res_333280 = defunc_0_add_arg_333282;
            }
            
            double x_333283 = a11_333170 * tmp4_333278;
            double y_333284 = b11_333172 * defunc_1_f_res_333279;
            double x_333285 = x_333283 + y_333284;
            double defunc_9_fit_fun_res_333286 = defunc_0_f_res_333280 *
                   x_333285;
            double x_333287 = b11_333172 * tmp4_333278;
            double y_333288 = c11_333173 * defunc_1_f_res_333279;
            double x_333289 = x_333287 + y_333288;
            double defunc_9_slope_fun_res_333290 = defunc_0_f_res_333280 *
                   x_333289;
            double defunc_1_op_res_333291 = defunc_9_fit_fun_res_333286 +
                   redout_333259;
            double defunc_1_op_res_333292 = defunc_9_slope_fun_res_333290 +
                   redout_333260;
            double redout_tmp_333298 = defunc_1_op_res_333291;
            double redout_tmp_333299 = defunc_1_op_res_333292;
            
            redout_333259 = redout_tmp_333298;
            redout_333260 = redout_tmp_333299;
        }
        defunc_2_reduce_res_333174 = redout_333259;
        defunc_2_reduce_res_333175 = redout_333260;
        ((double *) mem_315748.mem)[gtid_333127] = defunc_2_reduce_res_333174;
        ((double *) mem_315751.mem)[gtid_333127] = defunc_2_reduce_res_333175;
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338828_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338828_end -
                 futhark_mc_segmap_parloop_338828_start;
        
        ctx->futhark_mc_segmap_parloop_338828_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338828_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338828_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_338826(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_333126 = tid;
    int num_tasks_333229 = info.nsubtasks;
    struct futhark_mc_task_338825 *futhark_mc_task_338825 =
                                  (struct futhark_mc_task_338825 *) args;
    struct futhark_context *ctx = futhark_mc_task_338825->ctx;
    uint64_t futhark_mc_segmap_task_338826_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_338826_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338825->free_n_292675;
    int64_t q_t_292679 = futhark_mc_task_338825->free_q_t_292679;
    int64_t jump_t_292685 = futhark_mc_task_338825->free_jump_t_292685;
    int64_t t_n_m_292839 = futhark_mc_task_338825->free_t_n_m_292839;
    int64_t i_292846 = futhark_mc_task_338825->free_i_292846;
    int64_t gtid_307873 = futhark_mc_task_338825->free_gtid_307873;
    int64_t x_307878 = futhark_mc_task_338825->free_x_307878;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_task_338825->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_313143 = {.desc ="mem_313143", .mem =
                                  futhark_mc_task_338825->free_mem_313143,
                                  .size =0, .references =NULL};
    struct memblock mem_313147 = {.desc ="mem_313147", .mem =
                                  futhark_mc_task_338825->free_mem_313147,
                                  .size =0, .references =NULL};
    struct memblock mem_315742 = {.desc ="mem_315742", .mem =
                                  futhark_mc_task_338825->free_mem_315742,
                                  .size =0, .references =NULL};
    struct memblock mem_315745 = {.desc ="mem_315745", .mem =
                                  futhark_mc_task_338825->free_mem_315745,
                                  .size =0, .references =NULL};
    struct memblock mem_315748 = {.desc ="mem_315748", .mem =
                                  futhark_mc_task_338825->free_mem_315748,
                                  .size =0, .references =NULL};
    struct memblock mem_315751 = {.desc ="mem_315751", .mem =
                                  futhark_mc_task_338825->free_mem_315751,
                                  .size =0, .references =NULL};
    int64_t iter_333230;
    struct futhark_mc_segmap_parloop_struct_338827
    futhark_mc_segmap_parloop_struct_338827;
    
    futhark_mc_segmap_parloop_struct_338827.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338827.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_338827.free_q_t_292679 = q_t_292679;
    futhark_mc_segmap_parloop_struct_338827.free_jump_t_292685 = jump_t_292685;
    futhark_mc_segmap_parloop_struct_338827.free_t_n_m_292839 = t_n_m_292839;
    futhark_mc_segmap_parloop_struct_338827.free_i_292846 = i_292846;
    futhark_mc_segmap_parloop_struct_338827.free_gtid_307873 = gtid_307873;
    futhark_mc_segmap_parloop_struct_338827.free_x_307878 = x_307878;
    futhark_mc_segmap_parloop_struct_338827.free_mem_312636 = mem_312636.mem;
    futhark_mc_segmap_parloop_struct_338827.free_mem_313143 = mem_313143.mem;
    futhark_mc_segmap_parloop_struct_338827.free_mem_313147 = mem_313147.mem;
    futhark_mc_segmap_parloop_struct_338827.free_mem_315742 = mem_315742.mem;
    futhark_mc_segmap_parloop_struct_338827.free_mem_315745 = mem_315745.mem;
    futhark_mc_segmap_parloop_struct_338827.free_mem_315748 = mem_315748.mem;
    futhark_mc_segmap_parloop_struct_338827.free_mem_315751 = mem_315751.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338828_task;
    
    futhark_mc_segmap_parloop_338828_task.name =
        "futhark_mc_segmap_parloop_338828";
    futhark_mc_segmap_parloop_338828_task.fn = futhark_mc_segmap_parloop_338828;
    futhark_mc_segmap_parloop_338828_task.args =
        &futhark_mc_segmap_parloop_struct_338827;
    futhark_mc_segmap_parloop_338828_task.iterations = iterations;
    futhark_mc_segmap_parloop_338828_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338828_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338828_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338828_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338828_task);
    
    if (futhark_mc_segmap_parloop_338828_err != 0) {
        err = futhark_mc_segmap_parloop_338828_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338828_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338828_total_end -
                 futhark_mc_segmap_parloop_338828_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338828_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338828_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338828_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_338826_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_338826_end -
                 futhark_mc_segmap_task_338826_start;
        
        ctx->futhark_mc_segmap_task_338826_runs[tid]++;
        ctx->futhark_mc_segmap_task_338826_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_338826_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_segmap_parloop_struct_338830 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_t_292679;
    int64_t free_jump_t_292685;
    int64_t free_t_n_m_292839;
    int64_t free_i_292846;
    int64_t free_gtid_307873;
    int64_t free_x_307878;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_313143;
    unsigned char *free_mem_313147;
    unsigned char *free_mem_315742;
    unsigned char *free_mem_315745;
    unsigned char *free_mem_315748;
    unsigned char *free_mem_315751;
};
struct futhark_mc_task_338832 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_307873;
    int64_t free_x_307878;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_315742;
    int64_t free_x_333036;
    double free_x_333037;
    int64_t free_defunc_0_g_res_333040;
    double *retval_defunc_2_reduce_res_333041;
    double *retval_defunc_2_reduce_res_333042;
    double *retval_defunc_2_reduce_res_333043;
};
struct futhark_mc_segred_stage_1_parloop_struct_338837 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_307873;
    int64_t free_x_307878;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_315742;
    int64_t free_x_333036;
    double free_x_333037;
    int64_t free_defunc_0_g_res_333040;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_333373;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_333375;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_333377;
};
static int futhark_mc_segred_stage_1_parloop_338838(void *args, int64_t start,
                                                    int64_t end,
                                                    int flat_tid_333301,
                                                    int tid)
{
    int err = 0;
    struct futhark_mc_segred_stage_1_parloop_struct_338837
    *futhark_mc_segred_stage_1_parloop_struct_338837 =
    (struct futhark_mc_segred_stage_1_parloop_struct_338837 *) args;
    struct futhark_context *ctx =
                           futhark_mc_segred_stage_1_parloop_struct_338837->ctx;
    uint64_t futhark_mc_segred_stage_1_parloop_338838_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_338838_start = get_wall_time();
    
    int64_t n_292675 =
            futhark_mc_segred_stage_1_parloop_struct_338837->free_n_292675;
    int64_t gtid_307873 =
            futhark_mc_segred_stage_1_parloop_struct_338837->free_gtid_307873;
    int64_t x_307878 =
            futhark_mc_segred_stage_1_parloop_struct_338837->free_x_307878;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_338837->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_315742 = {.desc ="mem_315742", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_338837->free_mem_315742,
                                  .size =0, .references =NULL};
    int64_t x_333036 =
            futhark_mc_segred_stage_1_parloop_struct_338837->free_x_333036;
    double x_333037 =
           futhark_mc_segred_stage_1_parloop_struct_338837->free_x_333037;
    int64_t defunc_0_g_res_333040 =
            futhark_mc_segred_stage_1_parloop_struct_338837->free_defunc_0_g_res_333040;
    struct memblock reduce_stage_1_tid_res_arr_mem_333373 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_333373",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338837->free_reduce_stage_1_tid_res_arr_mem_333373,
                                                             .size =0,
                                                             .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_333375 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_333375",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338837->free_reduce_stage_1_tid_res_arr_mem_333375,
                                                             .size =0,
                                                             .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_333377 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_333377",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338837->free_reduce_stage_1_tid_res_arr_mem_333377,
                                                             .size =0,
                                                             .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_333379 = start;
    double x_333303;
    double x_333304;
    double x_333306;
    double x_333307;
    double x_333309;
    double x_333310;
    double local_acc_333380 = 0.0;
    double local_acc_333381 = 0.0;
    double local_acc_333382 = 0.0;
    
    for (; iter_333379 < end; iter_333379++) {
        int64_t gtid_333302 = iter_333379;
        bool cond_333312 = sle64(x_307878, gtid_333302);
        int64_t defunc_0_f_res_333313;
        
        if (cond_333312) {
            defunc_0_f_res_333313 = (int64_t) 0;
        } else {
            int64_t i_333314 = add64(x_333036, gtid_333302);
            int64_t defunc_0_add_arg_333315;
            
            defunc_0_add_arg_333315 = ((int64_t *) mem_312636.mem)[gtid_307873 *
                                                                   n_292675 +
                                                                   i_333314];
            
            int64_t defunc_1_add_res_333316 = add64((int64_t) 1,
                                                    defunc_0_add_arg_333315);
            
            defunc_0_f_res_333313 = defunc_1_add_res_333316;
        }
        
        double defunc_0_f_res_333317;
        
        if (cond_333312) {
            defunc_0_f_res_333317 = 0.0;
        } else {
            int64_t i_333318 = add64(x_333036, gtid_333302);
            double defunc_0_add_arg_333319;
            
            defunc_0_add_arg_333319 = ((double *) mem_315742.mem)[i_333318];
            defunc_0_f_res_333317 = defunc_0_add_arg_333319;
        }
        
        int64_t binop_p_333320 = sub64(defunc_0_f_res_333313,
                                       defunc_0_g_res_333040);
        double defunc_0_f_res_333321 = sitofp_i64_f64(binop_p_333320);
        double abs_res_333322 = fabs(defunc_0_f_res_333321);
        double tmp1_333323 = abs_res_333322 / x_333037;
        double x_333324 = tmp1_333323 * tmp1_333323;
        double y_333325 = tmp1_333323 * x_333324;
        double tmp2_333326 = 1.0 - y_333325;
        double x_333327 = tmp2_333326 * tmp2_333326;
        double tmp3_333328 = tmp2_333326 * x_333327;
        double w_j_333329 = defunc_0_f_res_333317 * tmp3_333328;
        double xw_j_333330 = defunc_0_f_res_333321 * w_j_333329;
        double x2w_j_333331 = defunc_0_f_res_333321 * xw_j_333330;
        
        // save map-out results
        { }
        // Load accum params
        {
            x_333303 = local_acc_333380;
        }
        // Load next params
        {
            x_333304 = w_j_333329;
        }
        // Red body
        {
            double defunc_1_op_res_333305 = x_333303 + x_333304;
            
            local_acc_333380 = defunc_1_op_res_333305;
        }
        // Load accum params
        {
            x_333306 = local_acc_333381;
        }
        // Load next params
        {
            x_333307 = xw_j_333330;
        }
        // Red body
        {
            double defunc_1_op_res_333308 = x_333306 + x_333307;
            
            local_acc_333381 = defunc_1_op_res_333308;
        }
        // Load accum params
        {
            x_333309 = local_acc_333382;
        }
        // Load next params
        {
            x_333310 = x2w_j_333331;
        }
        // Red body
        {
            double defunc_1_op_res_333311 = x_333309 + x_333310;
            
            local_acc_333382 = defunc_1_op_res_333311;
        }
    }
    ((double *) reduce_stage_1_tid_res_arr_mem_333373.mem)[flat_tid_333301] =
        local_acc_333380;
    ((double *) reduce_stage_1_tid_res_arr_mem_333375.mem)[flat_tid_333301] =
        local_acc_333381;
    ((double *) reduce_stage_1_tid_res_arr_mem_333377.mem)[flat_tid_333301] =
        local_acc_333382;
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_338838_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_338838_end -
                 futhark_mc_segred_stage_1_parloop_338838_start;
        
        ctx->futhark_mc_segred_stage_1_parloop_338838_runs[tid]++;
        ctx->futhark_mc_segred_stage_1_parloop_338838_total_runtime[tid] +=
            elapsed;
        ctx->futhark_mc_segred_stage_1_parloop_338838_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segred_task_338833(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_333301 = tid;
    int num_tasks_333372 = info.nsubtasks;
    struct futhark_mc_task_338832 *futhark_mc_task_338832 =
                                  (struct futhark_mc_task_338832 *) args;
    struct futhark_context *ctx = futhark_mc_task_338832->ctx;
    uint64_t futhark_mc_segred_task_338833_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_task_338833_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338832->free_n_292675;
    int64_t gtid_307873 = futhark_mc_task_338832->free_gtid_307873;
    int64_t x_307878 = futhark_mc_task_338832->free_x_307878;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_task_338832->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_315742 = {.desc ="mem_315742", .mem =
                                  futhark_mc_task_338832->free_mem_315742,
                                  .size =0, .references =NULL};
    int64_t x_333036 = futhark_mc_task_338832->free_x_333036;
    double x_333037 = futhark_mc_task_338832->free_x_333037;
    int64_t defunc_0_g_res_333040 =
            futhark_mc_task_338832->free_defunc_0_g_res_333040;
    double defunc_2_reduce_res_333041 =
           *futhark_mc_task_338832->retval_defunc_2_reduce_res_333041;
    double defunc_2_reduce_res_333042 =
           *futhark_mc_task_338832->retval_defunc_2_reduce_res_333042;
    double defunc_2_reduce_res_333043 =
           *futhark_mc_task_338832->retval_defunc_2_reduce_res_333043;
    size_t reduce_stage_1_tid_res_arr_mem_333373_cached_sizze_338834 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_333373 = NULL;
    size_t reduce_stage_1_tid_res_arr_mem_333375_cached_sizze_338835 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_333375 = NULL;
    size_t reduce_stage_1_tid_res_arr_mem_333377_cached_sizze_338836 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_333377 = NULL;
    
    if (reduce_stage_1_tid_res_arr_mem_333373_cached_sizze_338834 <
        (size_t) ((int64_t) 8 * num_tasks_333372)) {
        reduce_stage_1_tid_res_arr_mem_333373 =
            realloc(reduce_stage_1_tid_res_arr_mem_333373, (int64_t) 8 *
                    num_tasks_333372);
        reduce_stage_1_tid_res_arr_mem_333373_cached_sizze_338834 =
            (int64_t) 8 * num_tasks_333372;
    }
    if (reduce_stage_1_tid_res_arr_mem_333375_cached_sizze_338835 <
        (size_t) ((int64_t) 8 * num_tasks_333372)) {
        reduce_stage_1_tid_res_arr_mem_333375 =
            realloc(reduce_stage_1_tid_res_arr_mem_333375, (int64_t) 8 *
                    num_tasks_333372);
        reduce_stage_1_tid_res_arr_mem_333375_cached_sizze_338835 =
            (int64_t) 8 * num_tasks_333372;
    }
    if (reduce_stage_1_tid_res_arr_mem_333377_cached_sizze_338836 <
        (size_t) ((int64_t) 8 * num_tasks_333372)) {
        reduce_stage_1_tid_res_arr_mem_333377 =
            realloc(reduce_stage_1_tid_res_arr_mem_333377, (int64_t) 8 *
                    num_tasks_333372);
        reduce_stage_1_tid_res_arr_mem_333377_cached_sizze_338836 =
            (int64_t) 8 * num_tasks_333372;
    }
    
    int64_t iter_333379;
    struct futhark_mc_segred_stage_1_parloop_struct_338837
    futhark_mc_segred_stage_1_parloop_struct_338837;
    
    futhark_mc_segred_stage_1_parloop_struct_338837.ctx = ctx;
    futhark_mc_segred_stage_1_parloop_struct_338837.free_n_292675 = n_292675;
    futhark_mc_segred_stage_1_parloop_struct_338837.free_gtid_307873 =
        gtid_307873;
    futhark_mc_segred_stage_1_parloop_struct_338837.free_x_307878 = x_307878;
    futhark_mc_segred_stage_1_parloop_struct_338837.free_mem_312636 =
        mem_312636.mem;
    futhark_mc_segred_stage_1_parloop_struct_338837.free_mem_315742 =
        mem_315742.mem;
    futhark_mc_segred_stage_1_parloop_struct_338837.free_x_333036 = x_333036;
    futhark_mc_segred_stage_1_parloop_struct_338837.free_x_333037 = x_333037;
    futhark_mc_segred_stage_1_parloop_struct_338837.free_defunc_0_g_res_333040 =
        defunc_0_g_res_333040;
    futhark_mc_segred_stage_1_parloop_struct_338837.free_reduce_stage_1_tid_res_arr_mem_333373 =
        reduce_stage_1_tid_res_arr_mem_333373;
    futhark_mc_segred_stage_1_parloop_struct_338837.free_reduce_stage_1_tid_res_arr_mem_333375 =
        reduce_stage_1_tid_res_arr_mem_333375;
    futhark_mc_segred_stage_1_parloop_struct_338837.free_reduce_stage_1_tid_res_arr_mem_333377 =
        reduce_stage_1_tid_res_arr_mem_333377;
    
    struct scheduler_parloop futhark_mc_segred_stage_1_parloop_338838_task;
    
    futhark_mc_segred_stage_1_parloop_338838_task.name =
        "futhark_mc_segred_stage_1_parloop_338838";
    futhark_mc_segred_stage_1_parloop_338838_task.fn =
        futhark_mc_segred_stage_1_parloop_338838;
    futhark_mc_segred_stage_1_parloop_338838_task.args =
        &futhark_mc_segred_stage_1_parloop_struct_338837;
    futhark_mc_segred_stage_1_parloop_338838_task.iterations = iterations;
    futhark_mc_segred_stage_1_parloop_338838_task.info = info;
    
    uint64_t futhark_mc_segred_stage_1_parloop_338838_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_338838_total_start = get_wall_time();
    
    int futhark_mc_segred_stage_1_parloop_338838_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segred_stage_1_parloop_338838_task);
    
    if (futhark_mc_segred_stage_1_parloop_338838_err != 0) {
        err = futhark_mc_segred_stage_1_parloop_338838_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_338838_total_end =
                 get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_338838_total_end -
                 futhark_mc_segred_stage_1_parloop_338838_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338838_total_runs,
                           1, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338838_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338838_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    // neutral-initialise the output
    {
        defunc_2_reduce_res_333041 = 0.0;
        defunc_2_reduce_res_333042 = 0.0;
        defunc_2_reduce_res_333043 = 0.0;
    }
    
    double x_333383;
    double x_333384;
    double x_333386;
    double x_333387;
    double x_333389;
    double x_333390;
    
    for (int32_t i_333392 = 0; i_333392 < num_tasks_333372; i_333392++) {
        flat_tid_333301 = i_333392;
        // Apply main thread reduction
        {
            // load acc params
            {
                x_333383 = defunc_2_reduce_res_333041;
            }
            // load next params
            {
                x_333384 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_333373)[flat_tid_333301];
            }
            // red body
            {
                double defunc_1_op_res_333385 = x_333383 + x_333384;
                
                defunc_2_reduce_res_333041 = defunc_1_op_res_333385;
            }
            // load acc params
            {
                x_333386 = defunc_2_reduce_res_333042;
            }
            // load next params
            {
                x_333387 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_333375)[flat_tid_333301];
            }
            // red body
            {
                double defunc_1_op_res_333388 = x_333386 + x_333387;
                
                defunc_2_reduce_res_333042 = defunc_1_op_res_333388;
            }
            // load acc params
            {
                x_333389 = defunc_2_reduce_res_333043;
            }
            // load next params
            {
                x_333390 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_333377)[flat_tid_333301];
            }
            // red body
            {
                double defunc_1_op_res_333391 = x_333389 + x_333390;
                
                defunc_2_reduce_res_333043 = defunc_1_op_res_333391;
            }
        }
    }
    
  cleanup:
    {
        free(reduce_stage_1_tid_res_arr_mem_333373);
        free(reduce_stage_1_tid_res_arr_mem_333375);
        free(reduce_stage_1_tid_res_arr_mem_333377);
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_task_338833_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_task_338833_end -
                 futhark_mc_segred_task_338833_start;
        
        ctx->futhark_mc_segred_task_338833_runs[tid]++;
        ctx->futhark_mc_segred_task_338833_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segred_task_338833_iter[tid] += iterations;
    }
    if (err == 0) {
        *futhark_mc_task_338832->retval_defunc_2_reduce_res_333041 =
            defunc_2_reduce_res_333041;
        *futhark_mc_task_338832->retval_defunc_2_reduce_res_333042 =
            defunc_2_reduce_res_333042;
        *futhark_mc_task_338832->retval_defunc_2_reduce_res_333043 =
            defunc_2_reduce_res_333043;
    }
    return err;
}
struct futhark_mc_task_338839 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_307873;
    int64_t free_x_307878;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_315742;
    unsigned char *free_mem_315745;
    int64_t free_x_333036;
    double free_x_333037;
    int64_t free_defunc_0_g_res_333040;
    double free_a11_333082;
    double free_b11_333084;
    double free_c11_333085;
    double *retval_defunc_2_reduce_res_333086;
    double *retval_defunc_2_reduce_res_333087;
};
struct futhark_mc_segred_stage_1_parloop_struct_338843 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_307873;
    int64_t free_x_307878;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_315742;
    unsigned char *free_mem_315745;
    int64_t free_x_333036;
    double free_x_333037;
    int64_t free_defunc_0_g_res_333040;
    double free_a11_333082;
    double free_b11_333084;
    double free_c11_333085;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_333394;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_333396;
};
static int futhark_mc_segred_stage_1_parloop_338844(void *args, int64_t start,
                                                    int64_t end,
                                                    int flat_tid_333332,
                                                    int tid)
{
    int err = 0;
    struct futhark_mc_segred_stage_1_parloop_struct_338843
    *futhark_mc_segred_stage_1_parloop_struct_338843 =
    (struct futhark_mc_segred_stage_1_parloop_struct_338843 *) args;
    struct futhark_context *ctx =
                           futhark_mc_segred_stage_1_parloop_struct_338843->ctx;
    uint64_t futhark_mc_segred_stage_1_parloop_338844_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_338844_start = get_wall_time();
    
    int64_t n_292675 =
            futhark_mc_segred_stage_1_parloop_struct_338843->free_n_292675;
    int64_t gtid_307873 =
            futhark_mc_segred_stage_1_parloop_struct_338843->free_gtid_307873;
    int64_t x_307878 =
            futhark_mc_segred_stage_1_parloop_struct_338843->free_x_307878;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_338843->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_315742 = {.desc ="mem_315742", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_338843->free_mem_315742,
                                  .size =0, .references =NULL};
    struct memblock mem_315745 = {.desc ="mem_315745", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_338843->free_mem_315745,
                                  .size =0, .references =NULL};
    int64_t x_333036 =
            futhark_mc_segred_stage_1_parloop_struct_338843->free_x_333036;
    double x_333037 =
           futhark_mc_segred_stage_1_parloop_struct_338843->free_x_333037;
    int64_t defunc_0_g_res_333040 =
            futhark_mc_segred_stage_1_parloop_struct_338843->free_defunc_0_g_res_333040;
    double a11_333082 =
           futhark_mc_segred_stage_1_parloop_struct_338843->free_a11_333082;
    double b11_333084 =
           futhark_mc_segred_stage_1_parloop_struct_338843->free_b11_333084;
    double c11_333085 =
           futhark_mc_segred_stage_1_parloop_struct_338843->free_c11_333085;
    struct memblock reduce_stage_1_tid_res_arr_mem_333394 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_333394",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338843->free_reduce_stage_1_tid_res_arr_mem_333394,
                                                             .size =0,
                                                             .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_333396 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_333396",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338843->free_reduce_stage_1_tid_res_arr_mem_333396,
                                                             .size =0,
                                                             .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_333398 = start;
    double x_333334;
    double x_333335;
    double x_333337;
    double x_333338;
    double local_acc_333399 = 0.0;
    double local_acc_333400 = 0.0;
    
    for (; iter_333398 < end; iter_333398++) {
        int64_t gtid_333333 = iter_333398;
        bool cond_333340 = sle64(x_307878, gtid_333333);
        int64_t defunc_0_f_res_333341;
        
        if (cond_333340) {
            defunc_0_f_res_333341 = (int64_t) 0;
        } else {
            int64_t i_333342 = add64(x_333036, gtid_333333);
            int64_t defunc_0_add_arg_333343;
            
            defunc_0_add_arg_333343 = ((int64_t *) mem_312636.mem)[gtid_307873 *
                                                                   n_292675 +
                                                                   i_333342];
            
            int64_t defunc_1_add_res_333344 = add64((int64_t) 1,
                                                    defunc_0_add_arg_333343);
            
            defunc_0_f_res_333341 = defunc_1_add_res_333344;
        }
        
        double defunc_0_f_res_333345;
        
        if (cond_333340) {
            defunc_0_f_res_333345 = 0.0;
        } else {
            int64_t i_333346 = add64(x_333036, gtid_333333);
            double defunc_0_add_arg_333347;
            
            defunc_0_add_arg_333347 = ((double *) mem_315742.mem)[i_333346];
            defunc_0_f_res_333345 = defunc_0_add_arg_333347;
        }
        
        int64_t binop_p_333348 = sub64(defunc_0_f_res_333341,
                                       defunc_0_g_res_333040);
        double defunc_0_f_res_333349 = sitofp_i64_f64(binop_p_333348);
        double abs_res_333350 = fabs(defunc_0_f_res_333349);
        double tmp1_333351 = abs_res_333350 / x_333037;
        double x_333352 = tmp1_333351 * tmp1_333351;
        double y_333353 = tmp1_333351 * x_333352;
        double tmp2_333354 = 1.0 - y_333353;
        double x_333355 = tmp2_333354 * tmp2_333354;
        double tmp3_333356 = tmp2_333354 * x_333355;
        double tmp4_333357 = defunc_0_f_res_333345 * tmp3_333356;
        double defunc_1_f_res_333358 = defunc_0_f_res_333349 * tmp4_333357;
        double defunc_0_f_res_333359;
        
        if (cond_333340) {
            defunc_0_f_res_333359 = 0.0;
        } else {
            int64_t i_333360 = add64(x_333036, gtid_333333);
            double defunc_0_add_arg_333361;
            
            defunc_0_add_arg_333361 = ((double *) mem_315745.mem)[i_333360];
            defunc_0_f_res_333359 = defunc_0_add_arg_333361;
        }
        
        double x_333362 = a11_333082 * tmp4_333357;
        double y_333363 = b11_333084 * defunc_1_f_res_333358;
        double x_333364 = x_333362 + y_333363;
        double defunc_9_fit_fun_res_333365 = defunc_0_f_res_333359 * x_333364;
        double x_333366 = b11_333084 * tmp4_333357;
        double y_333367 = c11_333085 * defunc_1_f_res_333358;
        double x_333368 = x_333366 + y_333367;
        double defunc_9_slope_fun_res_333369 = defunc_0_f_res_333359 * x_333368;
        
        // save map-out results
        { }
        // Load accum params
        {
            x_333334 = local_acc_333399;
        }
        // Load next params
        {
            x_333335 = defunc_9_fit_fun_res_333365;
        }
        // Red body
        {
            double defunc_1_op_res_333336 = x_333334 + x_333335;
            
            local_acc_333399 = defunc_1_op_res_333336;
        }
        // Load accum params
        {
            x_333337 = local_acc_333400;
        }
        // Load next params
        {
            x_333338 = defunc_9_slope_fun_res_333369;
        }
        // Red body
        {
            double defunc_1_op_res_333339 = x_333337 + x_333338;
            
            local_acc_333400 = defunc_1_op_res_333339;
        }
    }
    ((double *) reduce_stage_1_tid_res_arr_mem_333394.mem)[flat_tid_333332] =
        local_acc_333399;
    ((double *) reduce_stage_1_tid_res_arr_mem_333396.mem)[flat_tid_333332] =
        local_acc_333400;
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_338844_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_338844_end -
                 futhark_mc_segred_stage_1_parloop_338844_start;
        
        ctx->futhark_mc_segred_stage_1_parloop_338844_runs[tid]++;
        ctx->futhark_mc_segred_stage_1_parloop_338844_total_runtime[tid] +=
            elapsed;
        ctx->futhark_mc_segred_stage_1_parloop_338844_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segred_task_338840(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_333332 = tid;
    int num_tasks_333393 = info.nsubtasks;
    struct futhark_mc_task_338839 *futhark_mc_task_338839 =
                                  (struct futhark_mc_task_338839 *) args;
    struct futhark_context *ctx = futhark_mc_task_338839->ctx;
    uint64_t futhark_mc_segred_task_338840_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_task_338840_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338839->free_n_292675;
    int64_t gtid_307873 = futhark_mc_task_338839->free_gtid_307873;
    int64_t x_307878 = futhark_mc_task_338839->free_x_307878;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_task_338839->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_315742 = {.desc ="mem_315742", .mem =
                                  futhark_mc_task_338839->free_mem_315742,
                                  .size =0, .references =NULL};
    struct memblock mem_315745 = {.desc ="mem_315745", .mem =
                                  futhark_mc_task_338839->free_mem_315745,
                                  .size =0, .references =NULL};
    int64_t x_333036 = futhark_mc_task_338839->free_x_333036;
    double x_333037 = futhark_mc_task_338839->free_x_333037;
    int64_t defunc_0_g_res_333040 =
            futhark_mc_task_338839->free_defunc_0_g_res_333040;
    double a11_333082 = futhark_mc_task_338839->free_a11_333082;
    double b11_333084 = futhark_mc_task_338839->free_b11_333084;
    double c11_333085 = futhark_mc_task_338839->free_c11_333085;
    double defunc_2_reduce_res_333086 =
           *futhark_mc_task_338839->retval_defunc_2_reduce_res_333086;
    double defunc_2_reduce_res_333087 =
           *futhark_mc_task_338839->retval_defunc_2_reduce_res_333087;
    size_t reduce_stage_1_tid_res_arr_mem_333394_cached_sizze_338841 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_333394 = NULL;
    size_t reduce_stage_1_tid_res_arr_mem_333396_cached_sizze_338842 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_333396 = NULL;
    
    if (reduce_stage_1_tid_res_arr_mem_333394_cached_sizze_338841 <
        (size_t) ((int64_t) 8 * num_tasks_333393)) {
        reduce_stage_1_tid_res_arr_mem_333394 =
            realloc(reduce_stage_1_tid_res_arr_mem_333394, (int64_t) 8 *
                    num_tasks_333393);
        reduce_stage_1_tid_res_arr_mem_333394_cached_sizze_338841 =
            (int64_t) 8 * num_tasks_333393;
    }
    if (reduce_stage_1_tid_res_arr_mem_333396_cached_sizze_338842 <
        (size_t) ((int64_t) 8 * num_tasks_333393)) {
        reduce_stage_1_tid_res_arr_mem_333396 =
            realloc(reduce_stage_1_tid_res_arr_mem_333396, (int64_t) 8 *
                    num_tasks_333393);
        reduce_stage_1_tid_res_arr_mem_333396_cached_sizze_338842 =
            (int64_t) 8 * num_tasks_333393;
    }
    
    int64_t iter_333398;
    struct futhark_mc_segred_stage_1_parloop_struct_338843
    futhark_mc_segred_stage_1_parloop_struct_338843;
    
    futhark_mc_segred_stage_1_parloop_struct_338843.ctx = ctx;
    futhark_mc_segred_stage_1_parloop_struct_338843.free_n_292675 = n_292675;
    futhark_mc_segred_stage_1_parloop_struct_338843.free_gtid_307873 =
        gtid_307873;
    futhark_mc_segred_stage_1_parloop_struct_338843.free_x_307878 = x_307878;
    futhark_mc_segred_stage_1_parloop_struct_338843.free_mem_312636 =
        mem_312636.mem;
    futhark_mc_segred_stage_1_parloop_struct_338843.free_mem_315742 =
        mem_315742.mem;
    futhark_mc_segred_stage_1_parloop_struct_338843.free_mem_315745 =
        mem_315745.mem;
    futhark_mc_segred_stage_1_parloop_struct_338843.free_x_333036 = x_333036;
    futhark_mc_segred_stage_1_parloop_struct_338843.free_x_333037 = x_333037;
    futhark_mc_segred_stage_1_parloop_struct_338843.free_defunc_0_g_res_333040 =
        defunc_0_g_res_333040;
    futhark_mc_segred_stage_1_parloop_struct_338843.free_a11_333082 =
        a11_333082;
    futhark_mc_segred_stage_1_parloop_struct_338843.free_b11_333084 =
        b11_333084;
    futhark_mc_segred_stage_1_parloop_struct_338843.free_c11_333085 =
        c11_333085;
    futhark_mc_segred_stage_1_parloop_struct_338843.free_reduce_stage_1_tid_res_arr_mem_333394 =
        reduce_stage_1_tid_res_arr_mem_333394;
    futhark_mc_segred_stage_1_parloop_struct_338843.free_reduce_stage_1_tid_res_arr_mem_333396 =
        reduce_stage_1_tid_res_arr_mem_333396;
    
    struct scheduler_parloop futhark_mc_segred_stage_1_parloop_338844_task;
    
    futhark_mc_segred_stage_1_parloop_338844_task.name =
        "futhark_mc_segred_stage_1_parloop_338844";
    futhark_mc_segred_stage_1_parloop_338844_task.fn =
        futhark_mc_segred_stage_1_parloop_338844;
    futhark_mc_segred_stage_1_parloop_338844_task.args =
        &futhark_mc_segred_stage_1_parloop_struct_338843;
    futhark_mc_segred_stage_1_parloop_338844_task.iterations = iterations;
    futhark_mc_segred_stage_1_parloop_338844_task.info = info;
    
    uint64_t futhark_mc_segred_stage_1_parloop_338844_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_338844_total_start = get_wall_time();
    
    int futhark_mc_segred_stage_1_parloop_338844_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segred_stage_1_parloop_338844_task);
    
    if (futhark_mc_segred_stage_1_parloop_338844_err != 0) {
        err = futhark_mc_segred_stage_1_parloop_338844_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_338844_total_end =
                 get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_338844_total_end -
                 futhark_mc_segred_stage_1_parloop_338844_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338844_total_runs,
                           1, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338844_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338844_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    // neutral-initialise the output
    {
        defunc_2_reduce_res_333086 = 0.0;
        defunc_2_reduce_res_333087 = 0.0;
    }
    
    double x_333401;
    double x_333402;
    double x_333404;
    double x_333405;
    
    for (int32_t i_333407 = 0; i_333407 < num_tasks_333393; i_333407++) {
        flat_tid_333332 = i_333407;
        // Apply main thread reduction
        {
            // load acc params
            {
                x_333401 = defunc_2_reduce_res_333086;
            }
            // load next params
            {
                x_333402 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_333394)[flat_tid_333332];
            }
            // red body
            {
                double defunc_1_op_res_333403 = x_333401 + x_333402;
                
                defunc_2_reduce_res_333086 = defunc_1_op_res_333403;
            }
            // load acc params
            {
                x_333404 = defunc_2_reduce_res_333087;
            }
            // load next params
            {
                x_333405 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_333396)[flat_tid_333332];
            }
            // red body
            {
                double defunc_1_op_res_333406 = x_333404 + x_333405;
                
                defunc_2_reduce_res_333087 = defunc_1_op_res_333406;
            }
        }
    }
    
  cleanup:
    {
        free(reduce_stage_1_tid_res_arr_mem_333394);
        free(reduce_stage_1_tid_res_arr_mem_333396);
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_task_338840_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_task_338840_end -
                 futhark_mc_segred_task_338840_start;
        
        ctx->futhark_mc_segred_task_338840_runs[tid]++;
        ctx->futhark_mc_segred_task_338840_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segred_task_338840_iter[tid] += iterations;
    }
    if (err == 0) {
        *futhark_mc_task_338839->retval_defunc_2_reduce_res_333086 =
            defunc_2_reduce_res_333086;
        *futhark_mc_task_338839->retval_defunc_2_reduce_res_333087 =
            defunc_2_reduce_res_333087;
    }
    return err;
}
static int futhark_mc_segmap_parloop_338831(void *args, int64_t start,
                                            int64_t end, int flat_tid_333034,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338830
    *futhark_mc_segmap_parloop_struct_338830 =
    (struct futhark_mc_segmap_parloop_struct_338830 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338830->ctx;
    uint64_t futhark_mc_segmap_parloop_338831_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338831_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_338830->free_n_292675;
    int64_t q_t_292679 =
            futhark_mc_segmap_parloop_struct_338830->free_q_t_292679;
    int64_t jump_t_292685 =
            futhark_mc_segmap_parloop_struct_338830->free_jump_t_292685;
    int64_t t_n_m_292839 =
            futhark_mc_segmap_parloop_struct_338830->free_t_n_m_292839;
    int64_t i_292846 = futhark_mc_segmap_parloop_struct_338830->free_i_292846;
    int64_t gtid_307873 =
            futhark_mc_segmap_parloop_struct_338830->free_gtid_307873;
    int64_t x_307878 = futhark_mc_segmap_parloop_struct_338830->free_x_307878;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_segmap_parloop_struct_338830->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_313143 = {.desc ="mem_313143", .mem =
                                  futhark_mc_segmap_parloop_struct_338830->free_mem_313143,
                                  .size =0, .references =NULL};
    struct memblock mem_313147 = {.desc ="mem_313147", .mem =
                                  futhark_mc_segmap_parloop_struct_338830->free_mem_313147,
                                  .size =0, .references =NULL};
    struct memblock mem_315742 = {.desc ="mem_315742", .mem =
                                  futhark_mc_segmap_parloop_struct_338830->free_mem_315742,
                                  .size =0, .references =NULL};
    struct memblock mem_315745 = {.desc ="mem_315745", .mem =
                                  futhark_mc_segmap_parloop_struct_338830->free_mem_315745,
                                  .size =0, .references =NULL};
    struct memblock mem_315748 = {.desc ="mem_315748", .mem =
                                  futhark_mc_segmap_parloop_struct_338830->free_mem_315748,
                                  .size =0, .references =NULL};
    struct memblock mem_315751 = {.desc ="mem_315751", .mem =
                                  futhark_mc_segmap_parloop_struct_338830->free_mem_315751,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_333300 = start;
    
    for (; iter_333300 < end; iter_333300++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_333370 = t_n_m_292839;
        int64_t gtid_333035 = iter_333300;
        int64_t remnant_333371 = iter_333300 - gtid_333035;
        int64_t x_333036;
        
        x_333036 = ((int64_t *) mem_313143.mem)[gtid_307873 * t_n_m_292839 +
                                                gtid_333035];
        
        double x_333037;
        
        x_333037 = ((double *) mem_313147.mem)[gtid_307873 * t_n_m_292839 +
                                               gtid_333035];
        
        int64_t min_arg_333038 = mul64(jump_t_292685, gtid_333035);
        int64_t min_res_333039 = smin64(i_292846, min_arg_333038);
        int64_t defunc_0_g_res_333040 = add64((int64_t) 1, min_res_333039);
        double defunc_2_reduce_res_333041;
        double defunc_2_reduce_res_333042;
        double defunc_2_reduce_res_333043;
        int64_t flat_tid_333301 = (int64_t) 0;
        int32_t num_tasks_333372;
        
        defunc_2_reduce_res_333041 = 0.0;
        defunc_2_reduce_res_333042 = 0.0;
        defunc_2_reduce_res_333043 = 0.0;
        
        struct futhark_mc_task_338832 futhark_mc_task_338832;
        
        futhark_mc_task_338832.ctx = ctx;
        futhark_mc_task_338832.free_n_292675 = n_292675;
        futhark_mc_task_338832.free_gtid_307873 = gtid_307873;
        futhark_mc_task_338832.free_x_307878 = x_307878;
        futhark_mc_task_338832.free_mem_312636 = mem_312636.mem;
        futhark_mc_task_338832.free_mem_315742 = mem_315742.mem;
        futhark_mc_task_338832.free_x_333036 = x_333036;
        futhark_mc_task_338832.free_x_333037 = x_333037;
        futhark_mc_task_338832.free_defunc_0_g_res_333040 =
            defunc_0_g_res_333040;
        futhark_mc_task_338832.retval_defunc_2_reduce_res_333041 =
            &defunc_2_reduce_res_333041;
        futhark_mc_task_338832.retval_defunc_2_reduce_res_333042 =
            &defunc_2_reduce_res_333042;
        futhark_mc_task_338832.retval_defunc_2_reduce_res_333043 =
            &defunc_2_reduce_res_333043;
        
        struct scheduler_segop futhark_mc_task_338832_task;
        
        futhark_mc_task_338832_task.args = &futhark_mc_task_338832;
        futhark_mc_task_338832_task.top_level_fn =
            futhark_mc_segred_task_338833;
        futhark_mc_task_338832_task.name = "futhark_mc_segred_task_338833";
        futhark_mc_task_338832_task.iterations = q_t_292679;
        futhark_mc_task_338832_task.task_time =
            &ctx->futhark_mc_segred_task_338833_total_time;
        futhark_mc_task_338832_task.task_iter =
            &ctx->futhark_mc_segred_task_338833_total_iter;
        futhark_mc_task_338832_task.sched = STATIC;
        futhark_mc_task_338832_task.nested_fn = NULL;
        
        int futhark_mc_segred_task_338833_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_338832_task);
        
        if (futhark_mc_segred_task_338833_err != 0) {
            ;
            err = futhark_mc_segred_task_338833_err;
            goto cleanup;
        }
        
        double a_333075 = 2.220446049250313e-16 + defunc_2_reduce_res_333041;
        double b_333076 = 2.220446049250313e-16 + defunc_2_reduce_res_333042;
        double c_333077 = 2.220446049250313e-16 + defunc_2_reduce_res_333043;
        double x_333078 = a_333075 * c_333077;
        double y_333079 = b_333076 * b_333076;
        double y_333080 = x_333078 - y_333079;
        double det1_333081 = 1.0 / y_333080;
        double a11_333082 = c_333077 * det1_333081;
        double x_333083 = 0.0 - b_333076;
        double b11_333084 = det1_333081 * x_333083;
        double c11_333085 = a_333075 * det1_333081;
        double defunc_2_reduce_res_333086;
        double defunc_2_reduce_res_333087;
        int64_t flat_tid_333332 = (int64_t) 0;
        int32_t num_tasks_333393;
        
        defunc_2_reduce_res_333086 = 0.0;
        defunc_2_reduce_res_333087 = 0.0;
        
        struct futhark_mc_task_338839 futhark_mc_task_338839;
        
        futhark_mc_task_338839.ctx = ctx;
        futhark_mc_task_338839.free_n_292675 = n_292675;
        futhark_mc_task_338839.free_gtid_307873 = gtid_307873;
        futhark_mc_task_338839.free_x_307878 = x_307878;
        futhark_mc_task_338839.free_mem_312636 = mem_312636.mem;
        futhark_mc_task_338839.free_mem_315742 = mem_315742.mem;
        futhark_mc_task_338839.free_mem_315745 = mem_315745.mem;
        futhark_mc_task_338839.free_x_333036 = x_333036;
        futhark_mc_task_338839.free_x_333037 = x_333037;
        futhark_mc_task_338839.free_defunc_0_g_res_333040 =
            defunc_0_g_res_333040;
        futhark_mc_task_338839.free_a11_333082 = a11_333082;
        futhark_mc_task_338839.free_b11_333084 = b11_333084;
        futhark_mc_task_338839.free_c11_333085 = c11_333085;
        futhark_mc_task_338839.retval_defunc_2_reduce_res_333086 =
            &defunc_2_reduce_res_333086;
        futhark_mc_task_338839.retval_defunc_2_reduce_res_333087 =
            &defunc_2_reduce_res_333087;
        
        struct scheduler_segop futhark_mc_task_338839_task;
        
        futhark_mc_task_338839_task.args = &futhark_mc_task_338839;
        futhark_mc_task_338839_task.top_level_fn =
            futhark_mc_segred_task_338840;
        futhark_mc_task_338839_task.name = "futhark_mc_segred_task_338840";
        futhark_mc_task_338839_task.iterations = q_t_292679;
        futhark_mc_task_338839_task.task_time =
            &ctx->futhark_mc_segred_task_338840_total_time;
        futhark_mc_task_338839_task.task_iter =
            &ctx->futhark_mc_segred_task_338840_total_iter;
        futhark_mc_task_338839_task.sched = STATIC;
        futhark_mc_task_338839_task.nested_fn = NULL;
        
        int futhark_mc_segred_task_338840_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_338839_task);
        
        if (futhark_mc_segred_task_338840_err != 0) {
            ;
            err = futhark_mc_segred_task_338840_err;
            goto cleanup;
        }
        ((double *) mem_315748.mem)[gtid_333035] = defunc_2_reduce_res_333086;
        ((double *) mem_315751.mem)[gtid_333035] = defunc_2_reduce_res_333087;
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338831_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338831_end -
                 futhark_mc_segmap_parloop_338831_start;
        
        ctx->futhark_mc_segmap_parloop_338831_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338831_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338831_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_nested_task_338829(void *args, int64_t iterations,
                                         int tid, struct scheduler_info info)
{
    int err = 0;
    int flat_tid_333034 = tid;
    int num_tasks_333229 = info.nsubtasks;
    struct futhark_mc_task_338825 *futhark_mc_task_338825 =
                                  (struct futhark_mc_task_338825 *) args;
    struct futhark_context *ctx = futhark_mc_task_338825->ctx;
    uint64_t futhark_mc_segmap_nested_task_338829_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_nested_task_338829_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338825->free_n_292675;
    int64_t q_t_292679 = futhark_mc_task_338825->free_q_t_292679;
    int64_t jump_t_292685 = futhark_mc_task_338825->free_jump_t_292685;
    int64_t t_n_m_292839 = futhark_mc_task_338825->free_t_n_m_292839;
    int64_t i_292846 = futhark_mc_task_338825->free_i_292846;
    int64_t gtid_307873 = futhark_mc_task_338825->free_gtid_307873;
    int64_t x_307878 = futhark_mc_task_338825->free_x_307878;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_task_338825->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_313143 = {.desc ="mem_313143", .mem =
                                  futhark_mc_task_338825->free_mem_313143,
                                  .size =0, .references =NULL};
    struct memblock mem_313147 = {.desc ="mem_313147", .mem =
                                  futhark_mc_task_338825->free_mem_313147,
                                  .size =0, .references =NULL};
    struct memblock mem_315742 = {.desc ="mem_315742", .mem =
                                  futhark_mc_task_338825->free_mem_315742,
                                  .size =0, .references =NULL};
    struct memblock mem_315745 = {.desc ="mem_315745", .mem =
                                  futhark_mc_task_338825->free_mem_315745,
                                  .size =0, .references =NULL};
    struct memblock mem_315748 = {.desc ="mem_315748", .mem =
                                  futhark_mc_task_338825->free_mem_315748,
                                  .size =0, .references =NULL};
    struct memblock mem_315751 = {.desc ="mem_315751", .mem =
                                  futhark_mc_task_338825->free_mem_315751,
                                  .size =0, .references =NULL};
    int64_t iter_333300;
    struct futhark_mc_segmap_parloop_struct_338830
    futhark_mc_segmap_parloop_struct_338830;
    
    futhark_mc_segmap_parloop_struct_338830.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338830.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_338830.free_q_t_292679 = q_t_292679;
    futhark_mc_segmap_parloop_struct_338830.free_jump_t_292685 = jump_t_292685;
    futhark_mc_segmap_parloop_struct_338830.free_t_n_m_292839 = t_n_m_292839;
    futhark_mc_segmap_parloop_struct_338830.free_i_292846 = i_292846;
    futhark_mc_segmap_parloop_struct_338830.free_gtid_307873 = gtid_307873;
    futhark_mc_segmap_parloop_struct_338830.free_x_307878 = x_307878;
    futhark_mc_segmap_parloop_struct_338830.free_mem_312636 = mem_312636.mem;
    futhark_mc_segmap_parloop_struct_338830.free_mem_313143 = mem_313143.mem;
    futhark_mc_segmap_parloop_struct_338830.free_mem_313147 = mem_313147.mem;
    futhark_mc_segmap_parloop_struct_338830.free_mem_315742 = mem_315742.mem;
    futhark_mc_segmap_parloop_struct_338830.free_mem_315745 = mem_315745.mem;
    futhark_mc_segmap_parloop_struct_338830.free_mem_315748 = mem_315748.mem;
    futhark_mc_segmap_parloop_struct_338830.free_mem_315751 = mem_315751.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338831_task;
    
    futhark_mc_segmap_parloop_338831_task.name =
        "futhark_mc_segmap_parloop_338831";
    futhark_mc_segmap_parloop_338831_task.fn = futhark_mc_segmap_parloop_338831;
    futhark_mc_segmap_parloop_338831_task.args =
        &futhark_mc_segmap_parloop_struct_338830;
    futhark_mc_segmap_parloop_338831_task.iterations = iterations;
    futhark_mc_segmap_parloop_338831_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338831_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338831_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338831_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338831_task);
    
    if (futhark_mc_segmap_parloop_338831_err != 0) {
        err = futhark_mc_segmap_parloop_338831_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338831_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338831_total_end -
                 futhark_mc_segmap_parloop_338831_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338831_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338831_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338831_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_nested_task_338829_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_nested_task_338829_end -
                 futhark_mc_segmap_nested_task_338829_start;
        
        ctx->futhark_mc_segmap_nested_task_338829_runs[tid]++;
        ctx->futhark_mc_segmap_nested_task_338829_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_nested_task_338829_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
static int futhark_mc_segmap_parloop_338811(void *args, int64_t start,
                                            int64_t end, int flat_tid_307872,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338810
    *futhark_mc_segmap_parloop_struct_338810 =
    (struct futhark_mc_segmap_parloop_struct_338810 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338810->ctx;
    uint64_t futhark_mc_segmap_parloop_338811_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338811_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_338810->free_n_292675;
    int64_t q_t_292679 =
            futhark_mc_segmap_parloop_struct_338810->free_q_t_292679;
    int64_t jump_t_292685 =
            futhark_mc_segmap_parloop_struct_338810->free_jump_t_292685;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_338810->free_partition_sizze_292766;
    int64_t t_n_m_292839 =
            futhark_mc_segmap_parloop_struct_338810->free_t_n_m_292839;
    int64_t i_292846 = futhark_mc_segmap_parloop_struct_338810->free_i_292846;
    struct memblock mem_312593 = {.desc ="mem_312593", .mem =
                                  futhark_mc_segmap_parloop_struct_338810->free_mem_312593,
                                  .size =0, .references =NULL};
    int64_t bytes_312598 =
            futhark_mc_segmap_parloop_struct_338810->free_bytes_312598;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_segmap_parloop_struct_338810->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_312639 = {.desc ="mem_312639", .mem =
                                  futhark_mc_segmap_parloop_struct_338810->free_mem_312639,
                                  .size =0, .references =NULL};
    int64_t bytes_313090 =
            futhark_mc_segmap_parloop_struct_338810->free_bytes_313090;
    struct memblock mem_313143 = {.desc ="mem_313143", .mem =
                                  futhark_mc_segmap_parloop_struct_338810->free_mem_313143,
                                  .size =0, .references =NULL};
    struct memblock mem_313147 = {.desc ="mem_313147", .mem =
                                  futhark_mc_segmap_parloop_struct_338810->free_mem_313147,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_segmap_parloop_struct_338810->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_segmap_parloop_struct_338810->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_segmap_parloop_struct_338810->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_segmap_parloop_struct_338810->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315656 = {.desc ="mem_315656", .mem =
                                  futhark_mc_segmap_parloop_struct_338810->free_mem_315656,
                                  .size =0, .references =NULL};
    struct memblock mem_315830 = {.desc ="mem_315830", .mem =
                                  futhark_mc_segmap_parloop_struct_338810->free_mem_315830,
                                  .size =0, .references =NULL};
    struct memblock mem_315834 = {.desc ="mem_315834", .mem =
                                  futhark_mc_segmap_parloop_struct_338810->free_mem_315834,
                                  .size =0, .references =NULL};
    size_t mem_315739_cached_sizze_338812 = 0;
    unsigned char *mem_315739 = NULL;
    size_t mem_315742_cached_sizze_338813 = 0;
    unsigned char *mem_315742 = NULL;
    size_t mem_315745_cached_sizze_338814 = 0;
    unsigned char *mem_315745 = NULL;
    size_t mem_315748_cached_sizze_338815 = 0;
    unsigned char *mem_315748 = NULL;
    size_t mem_315751_cached_sizze_338816 = 0;
    unsigned char *mem_315751 = NULL;
    int64_t iterations = end - start;
    int64_t iter_333013 = start;
    
    if (mem_315739_cached_sizze_338812 < (size_t) bytes_312598) {
        mem_315739 = realloc(mem_315739, bytes_312598);
        mem_315739_cached_sizze_338812 = bytes_312598;
    }
    if (mem_315742_cached_sizze_338813 < (size_t) bytes_312598) {
        mem_315742 = realloc(mem_315742, bytes_312598);
        mem_315742_cached_sizze_338813 = bytes_312598;
    }
    if (mem_315745_cached_sizze_338814 < (size_t) bytes_312598) {
        mem_315745 = realloc(mem_315745, bytes_312598);
        mem_315745_cached_sizze_338814 = bytes_312598;
    }
    if (mem_315748_cached_sizze_338815 < (size_t) bytes_313090) {
        mem_315748 = realloc(mem_315748, bytes_313090);
        mem_315748_cached_sizze_338815 = bytes_313090;
    }
    if (mem_315751_cached_sizze_338816 < (size_t) bytes_313090) {
        mem_315751 = realloc(mem_315751, bytes_313090);
        mem_315751_cached_sizze_338816 = bytes_313090;
    }
    for (; iter_333013 < end; iter_333013++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_333211 = partition_sizze_292766;
        int64_t gtid_307873 = iter_333013;
        int64_t remnant_333212 = iter_333013 - gtid_307873;
        int64_t x_307878;
        
        x_307878 = ((int64_t *) mem_312639.mem)[gtid_307873];
        
        int64_t flat_tid_333014 = (int64_t) 0;
        int32_t num_tasks_333213;
        struct futhark_mc_task_338817 futhark_mc_task_338817;
        
        futhark_mc_task_338817.ctx = ctx;
        futhark_mc_task_338817.free_n_292675 = n_292675;
        futhark_mc_task_338817.free_gtid_307873 = gtid_307873;
        futhark_mc_task_338817.free_mem_312593 = mem_312593.mem;
        futhark_mc_task_338817.free_mem_315656 = mem_315656.mem;
        futhark_mc_task_338817.free_mem_315739 = mem_315739;
        
        struct scheduler_segop futhark_mc_task_338817_task;
        
        futhark_mc_task_338817_task.args = &futhark_mc_task_338817;
        futhark_mc_task_338817_task.top_level_fn =
            futhark_mc_segmap_task_338818;
        futhark_mc_task_338817_task.name = "futhark_mc_segmap_task_338818";
        futhark_mc_task_338817_task.iterations = n_292675;
        futhark_mc_task_338817_task.task_time =
            &ctx->futhark_mc_segmap_task_338818_total_time;
        futhark_mc_task_338817_task.task_iter =
            &ctx->futhark_mc_segmap_task_338818_total_iter;
        futhark_mc_task_338817_task.sched = STATIC;
        futhark_mc_task_338817_task.nested_fn = NULL;
        
        int futhark_mc_segmap_task_338818_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_338817_task);
        
        if (futhark_mc_segmap_task_338818_err != 0) {
            ;
            err = futhark_mc_segmap_task_338818_err;
            goto cleanup;
        }
        
        int64_t flat_tid_333020 = (int64_t) 0;
        int32_t num_tasks_333217;
        struct futhark_mc_task_338821 futhark_mc_task_338821;
        
        futhark_mc_task_338821.ctx = ctx;
        futhark_mc_task_338821.free_n_292675 = n_292675;
        futhark_mc_task_338821.free_gtid_307873 = gtid_307873;
        futhark_mc_task_338821.free_mem_312636 = mem_312636.mem;
        futhark_mc_task_338821.free_ctx_param_ext_313174 = ctx_param_ext_313174;
        futhark_mc_task_338821.free_ctx_param_ext_313175 = ctx_param_ext_313175;
        futhark_mc_task_338821.free_ctx_param_ext_313177 = ctx_param_ext_313177;
        futhark_mc_task_338821.free_mem_param_313179 = mem_param_313179.mem;
        futhark_mc_task_338821.free_mem_315739 = mem_315739;
        futhark_mc_task_338821.free_mem_315742 = mem_315742;
        futhark_mc_task_338821.free_mem_315745 = mem_315745;
        
        struct scheduler_segop futhark_mc_task_338821_task;
        
        futhark_mc_task_338821_task.args = &futhark_mc_task_338821;
        futhark_mc_task_338821_task.top_level_fn =
            futhark_mc_segmap_task_338822;
        futhark_mc_task_338821_task.name = "futhark_mc_segmap_task_338822";
        futhark_mc_task_338821_task.iterations = n_292675;
        futhark_mc_task_338821_task.task_time =
            &ctx->futhark_mc_segmap_task_338822_total_time;
        futhark_mc_task_338821_task.task_iter =
            &ctx->futhark_mc_segmap_task_338822_total_iter;
        futhark_mc_task_338821_task.sched = STATIC;
        futhark_mc_task_338821_task.nested_fn = NULL;
        
        int futhark_mc_segmap_task_338822_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_338821_task);
        
        if (futhark_mc_segmap_task_338822_err != 0) {
            ;
            err = futhark_mc_segmap_task_338822_err;
            goto cleanup;
        }
        
        int64_t flat_tid_333126 = (int64_t) 0;
        int32_t num_tasks_333229;
        int64_t flat_tid_333034 = (int64_t) 0;
        struct futhark_mc_task_338825 futhark_mc_task_338825;
        
        futhark_mc_task_338825.ctx = ctx;
        futhark_mc_task_338825.free_n_292675 = n_292675;
        futhark_mc_task_338825.free_q_t_292679 = q_t_292679;
        futhark_mc_task_338825.free_jump_t_292685 = jump_t_292685;
        futhark_mc_task_338825.free_t_n_m_292839 = t_n_m_292839;
        futhark_mc_task_338825.free_i_292846 = i_292846;
        futhark_mc_task_338825.free_gtid_307873 = gtid_307873;
        futhark_mc_task_338825.free_x_307878 = x_307878;
        futhark_mc_task_338825.free_mem_312636 = mem_312636.mem;
        futhark_mc_task_338825.free_mem_313143 = mem_313143.mem;
        futhark_mc_task_338825.free_mem_313147 = mem_313147.mem;
        futhark_mc_task_338825.free_mem_315742 = mem_315742;
        futhark_mc_task_338825.free_mem_315745 = mem_315745;
        futhark_mc_task_338825.free_mem_315748 = mem_315748;
        futhark_mc_task_338825.free_mem_315751 = mem_315751;
        
        struct scheduler_segop futhark_mc_task_338825_task;
        
        futhark_mc_task_338825_task.args = &futhark_mc_task_338825;
        futhark_mc_task_338825_task.top_level_fn =
            futhark_mc_segmap_task_338826;
        futhark_mc_task_338825_task.name = "futhark_mc_segmap_task_338826";
        futhark_mc_task_338825_task.iterations = t_n_m_292839;
        futhark_mc_task_338825_task.task_time =
            &ctx->futhark_mc_segmap_task_338826_total_time;
        futhark_mc_task_338825_task.task_iter =
            &ctx->futhark_mc_segmap_task_338826_total_iter;
        futhark_mc_task_338825_task.sched = STATIC;
        futhark_mc_task_338825_task.nested_fn =
            futhark_mc_segmap_nested_task_338829;
        
        int futhark_mc_segmap_task_338826_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_338825_task);
        
        if (futhark_mc_segmap_task_338826_err != 0) {
            ;
            err = futhark_mc_segmap_task_338826_err;
            goto cleanup;
        }
        if (t_n_m_292839 * (int64_t) 8 > 0)
            memmove(mem_315830.mem + gtid_307873 * t_n_m_292839 * (int64_t) 8,
                    mem_315748 + (int64_t) 0, t_n_m_292839 * (int64_t) 8);
        if (t_n_m_292839 * (int64_t) 8 > 0)
            memmove(mem_315834.mem + gtid_307873 * t_n_m_292839 * (int64_t) 8,
                    mem_315751 + (int64_t) 0, t_n_m_292839 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_315739);
    free(mem_315742);
    free(mem_315745);
    free(mem_315748);
    free(mem_315751);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338811_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338811_end -
                 futhark_mc_segmap_parloop_338811_start;
        
        ctx->futhark_mc_segmap_parloop_338811_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338811_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338811_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_nested_task_338809(void *args, int64_t iterations,
                                         int tid, struct scheduler_info info)
{
    int err = 0;
    int flat_tid_307872 = tid;
    int num_tasks_332887 = info.nsubtasks;
    struct futhark_mc_task_338800 *futhark_mc_task_338800 =
                                  (struct futhark_mc_task_338800 *) args;
    struct futhark_context *ctx = futhark_mc_task_338800->ctx;
    uint64_t futhark_mc_segmap_nested_task_338809_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_nested_task_338809_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338800->free_n_292675;
    int64_t q_t_292679 = futhark_mc_task_338800->free_q_t_292679;
    int64_t jump_t_292685 = futhark_mc_task_338800->free_jump_t_292685;
    int64_t partition_sizze_292766 =
            futhark_mc_task_338800->free_partition_sizze_292766;
    int64_t t_n_m_292839 = futhark_mc_task_338800->free_t_n_m_292839;
    int64_t i_292846 = futhark_mc_task_338800->free_i_292846;
    struct memblock mem_312593 = {.desc ="mem_312593", .mem =
                                  futhark_mc_task_338800->free_mem_312593,
                                  .size =0, .references =NULL};
    int64_t bytes_312598 = futhark_mc_task_338800->free_bytes_312598;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_task_338800->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_312639 = {.desc ="mem_312639", .mem =
                                  futhark_mc_task_338800->free_mem_312639,
                                  .size =0, .references =NULL};
    int64_t bytes_313090 = futhark_mc_task_338800->free_bytes_313090;
    struct memblock mem_313143 = {.desc ="mem_313143", .mem =
                                  futhark_mc_task_338800->free_mem_313143,
                                  .size =0, .references =NULL};
    struct memblock mem_313147 = {.desc ="mem_313147", .mem =
                                  futhark_mc_task_338800->free_mem_313147,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_task_338800->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_task_338800->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_task_338800->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_task_338800->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315656 = {.desc ="mem_315656", .mem =
                                  futhark_mc_task_338800->free_mem_315656,
                                  .size =0, .references =NULL};
    struct memblock mem_315830 = {.desc ="mem_315830", .mem =
                                  futhark_mc_task_338800->free_mem_315830,
                                  .size =0, .references =NULL};
    struct memblock mem_315834 = {.desc ="mem_315834", .mem =
                                  futhark_mc_task_338800->free_mem_315834,
                                  .size =0, .references =NULL};
    int64_t iter_333013;
    struct futhark_mc_segmap_parloop_struct_338810
    futhark_mc_segmap_parloop_struct_338810;
    
    futhark_mc_segmap_parloop_struct_338810.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338810.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_338810.free_q_t_292679 = q_t_292679;
    futhark_mc_segmap_parloop_struct_338810.free_jump_t_292685 = jump_t_292685;
    futhark_mc_segmap_parloop_struct_338810.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_338810.free_t_n_m_292839 = t_n_m_292839;
    futhark_mc_segmap_parloop_struct_338810.free_i_292846 = i_292846;
    futhark_mc_segmap_parloop_struct_338810.free_mem_312593 = mem_312593.mem;
    futhark_mc_segmap_parloop_struct_338810.free_bytes_312598 = bytes_312598;
    futhark_mc_segmap_parloop_struct_338810.free_mem_312636 = mem_312636.mem;
    futhark_mc_segmap_parloop_struct_338810.free_mem_312639 = mem_312639.mem;
    futhark_mc_segmap_parloop_struct_338810.free_bytes_313090 = bytes_313090;
    futhark_mc_segmap_parloop_struct_338810.free_mem_313143 = mem_313143.mem;
    futhark_mc_segmap_parloop_struct_338810.free_mem_313147 = mem_313147.mem;
    futhark_mc_segmap_parloop_struct_338810.free_ctx_param_ext_313174 =
        ctx_param_ext_313174;
    futhark_mc_segmap_parloop_struct_338810.free_ctx_param_ext_313175 =
        ctx_param_ext_313175;
    futhark_mc_segmap_parloop_struct_338810.free_ctx_param_ext_313177 =
        ctx_param_ext_313177;
    futhark_mc_segmap_parloop_struct_338810.free_mem_param_313179 =
        mem_param_313179.mem;
    futhark_mc_segmap_parloop_struct_338810.free_mem_315656 = mem_315656.mem;
    futhark_mc_segmap_parloop_struct_338810.free_mem_315830 = mem_315830.mem;
    futhark_mc_segmap_parloop_struct_338810.free_mem_315834 = mem_315834.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338811_task;
    
    futhark_mc_segmap_parloop_338811_task.name =
        "futhark_mc_segmap_parloop_338811";
    futhark_mc_segmap_parloop_338811_task.fn = futhark_mc_segmap_parloop_338811;
    futhark_mc_segmap_parloop_338811_task.args =
        &futhark_mc_segmap_parloop_struct_338810;
    futhark_mc_segmap_parloop_338811_task.iterations = iterations;
    futhark_mc_segmap_parloop_338811_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338811_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338811_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338811_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338811_task);
    
    if (futhark_mc_segmap_parloop_338811_err != 0) {
        err = futhark_mc_segmap_parloop_338811_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338811_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338811_total_end -
                 futhark_mc_segmap_parloop_338811_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338811_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338811_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338811_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_nested_task_338809_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_nested_task_338809_end -
                 futhark_mc_segmap_nested_task_338809_start;
        
        ctx->futhark_mc_segmap_nested_task_338809_runs[tid]++;
        ctx->futhark_mc_segmap_nested_task_338809_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_nested_task_338809_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_task_338845 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_t_292679;
    int64_t free_jump_t_292685;
    int64_t free_partition_sizze_292766;
    int64_t free_t_n_m_292839;
    int64_t free_i_292846;
    unsigned char *free_mem_312593;
    int64_t free_bytes_312598;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_312639;
    int64_t free_bytes_313090;
    unsigned char *free_mem_313143;
    unsigned char *free_mem_313147;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315656;
    unsigned char *free_mem_315928;
    unsigned char *free_mem_315932;
};
struct futhark_mc_segmap_parloop_struct_338847 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_t_292679;
    int64_t free_jump_t_292685;
    int64_t free_partition_sizze_292766;
    int64_t free_t_n_m_292839;
    int64_t free_i_292846;
    unsigned char *free_mem_312593;
    int64_t free_bytes_312598;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_312639;
    int64_t free_bytes_313090;
    unsigned char *free_mem_313143;
    unsigned char *free_mem_313147;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315656;
    unsigned char *free_mem_315928;
    unsigned char *free_mem_315932;
};
static int futhark_mc_segmap_parloop_338848(void *args, int64_t start,
                                            int64_t end, int flat_tid_308092,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338847
    *futhark_mc_segmap_parloop_struct_338847 =
    (struct futhark_mc_segmap_parloop_struct_338847 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338847->ctx;
    uint64_t futhark_mc_segmap_parloop_338848_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338848_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_338847->free_n_292675;
    int64_t q_t_292679 =
            futhark_mc_segmap_parloop_struct_338847->free_q_t_292679;
    int64_t jump_t_292685 =
            futhark_mc_segmap_parloop_struct_338847->free_jump_t_292685;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_338847->free_partition_sizze_292766;
    int64_t t_n_m_292839 =
            futhark_mc_segmap_parloop_struct_338847->free_t_n_m_292839;
    int64_t i_292846 = futhark_mc_segmap_parloop_struct_338847->free_i_292846;
    struct memblock mem_312593 = {.desc ="mem_312593", .mem =
                                  futhark_mc_segmap_parloop_struct_338847->free_mem_312593,
                                  .size =0, .references =NULL};
    int64_t bytes_312598 =
            futhark_mc_segmap_parloop_struct_338847->free_bytes_312598;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_segmap_parloop_struct_338847->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_312639 = {.desc ="mem_312639", .mem =
                                  futhark_mc_segmap_parloop_struct_338847->free_mem_312639,
                                  .size =0, .references =NULL};
    int64_t bytes_313090 =
            futhark_mc_segmap_parloop_struct_338847->free_bytes_313090;
    struct memblock mem_313143 = {.desc ="mem_313143", .mem =
                                  futhark_mc_segmap_parloop_struct_338847->free_mem_313143,
                                  .size =0, .references =NULL};
    struct memblock mem_313147 = {.desc ="mem_313147", .mem =
                                  futhark_mc_segmap_parloop_struct_338847->free_mem_313147,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_segmap_parloop_struct_338847->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_segmap_parloop_struct_338847->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_segmap_parloop_struct_338847->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_segmap_parloop_struct_338847->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315656 = {.desc ="mem_315656", .mem =
                                  futhark_mc_segmap_parloop_struct_338847->free_mem_315656,
                                  .size =0, .references =NULL};
    struct memblock mem_315928 = {.desc ="mem_315928", .mem =
                                  futhark_mc_segmap_parloop_struct_338847->free_mem_315928,
                                  .size =0, .references =NULL};
    struct memblock mem_315932 = {.desc ="mem_315932", .mem =
                                  futhark_mc_segmap_parloop_struct_338847->free_mem_315932,
                                  .size =0, .references =NULL};
    size_t mem_315852_cached_sizze_338849 = 0;
    unsigned char *mem_315852 = NULL;
    size_t mem_315867_cached_sizze_338850 = 0;
    unsigned char *mem_315867 = NULL;
    size_t mem_315870_cached_sizze_338851 = 0;
    unsigned char *mem_315870 = NULL;
    size_t mem_315897_cached_sizze_338852 = 0;
    unsigned char *mem_315897 = NULL;
    size_t mem_315900_cached_sizze_338853 = 0;
    unsigned char *mem_315900 = NULL;
    int64_t iterations = end - start;
    int64_t iter_333409 = start;
    
    if (mem_315852_cached_sizze_338849 < (size_t) bytes_312598) {
        mem_315852 = realloc(mem_315852, bytes_312598);
        mem_315852_cached_sizze_338849 = bytes_312598;
    }
    if (mem_315867_cached_sizze_338850 < (size_t) bytes_312598) {
        mem_315867 = realloc(mem_315867, bytes_312598);
        mem_315867_cached_sizze_338850 = bytes_312598;
    }
    if (mem_315870_cached_sizze_338851 < (size_t) bytes_312598) {
        mem_315870 = realloc(mem_315870, bytes_312598);
        mem_315870_cached_sizze_338851 = bytes_312598;
    }
    if (mem_315897_cached_sizze_338852 < (size_t) bytes_313090) {
        mem_315897 = realloc(mem_315897, bytes_313090);
        mem_315897_cached_sizze_338852 = bytes_313090;
    }
    if (mem_315900_cached_sizze_338853 < (size_t) bytes_313090) {
        mem_315900 = realloc(mem_315900, bytes_313090);
        mem_315900_cached_sizze_338853 = bytes_313090;
    }
    for (; iter_333409 < end; iter_333409++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_333554 = partition_sizze_292766;
        int64_t gtid_308093 = iter_333409;
        int64_t remnant_333555 = iter_333409 - gtid_308093;
        int64_t x_296038;
        
        x_296038 = ((int64_t *) mem_312639.mem)[gtid_308093];
        for (int64_t i_333410 = 0; i_333410 < n_292675; i_333410++) {
            float x_333412;
            
            x_333412 = ((float *) mem_312593.mem)[gtid_308093 * n_292675 +
                                                  i_333410];
            
            double x_333413;
            
            x_333413 = ((double *) mem_315656.mem)[gtid_308093 * n_292675 +
                                                   i_333410];
            
            double f32_res_333414 = fpconv_f32_f64(x_333412);
            double defunc_1_f_res_333415 = f32_res_333414 - x_333413;
            
            ((double *) mem_315852)[i_333410] = defunc_1_f_res_333415;
        }
        for (int64_t i_333417 = 0; i_333417 < n_292675; i_333417++) {
            int64_t x_333420;
            
            x_333420 = ((int64_t *) mem_312636.mem)[gtid_308093 * n_292675 +
                                                    i_333417];
            
            bool cond_333421 = sle64((int64_t) 0, x_333420);
            double defunc_0_f_res_333422;
            
            if (cond_333421) {
                bool y_333423 = slt64(x_333420, n_292675);
                bool bounds_check_333424 = cond_333421 && y_333423;
                bool index_certs_333425;
                
                if (!bounds_check_333424) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [", (long long) x_333420,
                                  "] out of bounds for array of shape [",
                                  (long long) n_292675, "].",
                                  "-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:45:43-70\n   #3  stl.fut:285:33-58\n   #4  /prelude/soacs.fut:75:22-28\n   #5  /prelude/soacs.fut:75:3-45\n   #6  stl.fut:283:13-288:41\n   #7  stl.fut:419:61-435:77\n   #8  stl.fut:463:3-479:36\n   #9  stl.fut:445:1-479:36\n");
                    err = FUTHARK_PROGRAM_ERROR;
                    goto cleanup;
                }
                
                double defunc_0_f_res_t_res_333426;
                
                defunc_0_f_res_t_res_333426 = ((double *) mem_315852)[x_333420];
                defunc_0_f_res_333422 = defunc_0_f_res_t_res_333426;
            } else {
                defunc_0_f_res_333422 = 0.0;
            }
            
            double defunc_0_f_res_333427;
            
            if (cond_333421) {
                bool y_333428 = slt64(x_333420, n_292675);
                bool bounds_check_333429 = cond_333421 && y_333428;
                bool index_certs_333430;
                
                if (!bounds_check_333429) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [", (long long) x_333420,
                                  "] out of bounds for array of shape [",
                                  (long long) n_292675, "].",
                                  "-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:45:43-70\n   #3  stl.fut:286:33-64\n   #4  /prelude/soacs.fut:75:22-28\n   #5  /prelude/soacs.fut:75:3-45\n   #6  stl.fut:283:13-288:41\n   #7  stl.fut:419:61-435:77\n   #8  stl.fut:463:3-479:36\n   #9  stl.fut:445:1-479:36\n");
                    err = FUTHARK_PROGRAM_ERROR;
                    goto cleanup;
                }
                
                double defunc_0_f_res_t_res_333431;
                
                defunc_0_f_res_t_res_333431 =
                    ((double *) mem_param_313179.mem)[ctx_param_ext_313174 +
                                                      (gtid_308093 *
                                                       ctx_param_ext_313175 +
                                                       x_333420 *
                                                       ctx_param_ext_313177)];
                defunc_0_f_res_333427 = defunc_0_f_res_t_res_333431;
            } else {
                defunc_0_f_res_333427 = 0.0;
            }
            ((double *) mem_315867)[i_333417] = defunc_0_f_res_333427;
            ((double *) mem_315870)[i_333417] = defunc_0_f_res_333422;
        }
        for (int64_t i_333434 = 0; i_333434 < t_n_m_292839; i_333434++) {
            int64_t x_333437;
            
            x_333437 = ((int64_t *) mem_313143.mem)[gtid_308093 * t_n_m_292839 +
                                                    i_333434];
            
            double x_333438;
            
            x_333438 = ((double *) mem_313147.mem)[gtid_308093 * t_n_m_292839 +
                                                   i_333434];
            
            int64_t min_arg_333439 = mul64(jump_t_292685, i_333434);
            int64_t min_res_333440 = smin64(i_292846, min_arg_333439);
            int64_t defunc_0_g_res_333441 = add64((int64_t) 1, min_res_333440);
            double defunc_2_reduce_res_333442;
            double defunc_2_reduce_res_333443;
            double defunc_2_reduce_res_333444;
            double defunc_2_reduce_res_333445;
            double defunc_2_reduce_res_333446;
            double redout_333448;
            double redout_333449;
            double redout_333450;
            double redout_333451;
            double redout_333452;
            
            redout_333448 = 0.0;
            redout_333449 = 0.0;
            redout_333450 = 0.0;
            redout_333451 = 0.0;
            redout_333452 = 0.0;
            for (int64_t i_333447 = 0; i_333447 < q_t_292679; i_333447++) {
                bool cond_333453 = sle64(x_296038, i_333447);
                int64_t defunc_0_f_res_333454;
                
                if (cond_333453) {
                    defunc_0_f_res_333454 = (int64_t) 0;
                } else {
                    int64_t i_333455 = add64(x_333437, i_333447);
                    int64_t defunc_0_add_arg_333456;
                    
                    defunc_0_add_arg_333456 =
                        ((int64_t *) mem_312636.mem)[gtid_308093 * n_292675 +
                                                     i_333455];
                    
                    int64_t defunc_1_add_res_333457 = add64((int64_t) 1,
                                                            defunc_0_add_arg_333456);
                    
                    defunc_0_f_res_333454 = defunc_1_add_res_333457;
                }
                
                double defunc_0_f_res_333458;
                
                if (cond_333453) {
                    defunc_0_f_res_333458 = 0.0;
                } else {
                    int64_t i_333459 = add64(x_333437, i_333447);
                    double defunc_0_add_arg_333460;
                    
                    defunc_0_add_arg_333460 = ((double *) mem_315867)[i_333459];
                    defunc_0_f_res_333458 = defunc_0_add_arg_333460;
                }
                
                int64_t binop_p_333461 = sub64(defunc_0_f_res_333454,
                                               defunc_0_g_res_333441);
                double defunc_0_f_res_333462 = sitofp_i64_f64(binop_p_333461);
                double abs_res_333463 = fabs(defunc_0_f_res_333462);
                double tmp1_333464 = abs_res_333463 / x_333438;
                double x_333465 = tmp1_333464 * tmp1_333464;
                double y_333466 = tmp1_333464 * x_333465;
                double tmp2_333467 = 1.0 - y_333466;
                double x_333468 = tmp2_333467 * tmp2_333467;
                double tmp3_333469 = tmp2_333467 * x_333468;
                double w_j_333470 = defunc_0_f_res_333458 * tmp3_333469;
                double xw_j_333471 = defunc_0_f_res_333462 * w_j_333470;
                double x2w_j_333472 = defunc_0_f_res_333462 * xw_j_333471;
                double x3w_j_333473 = defunc_0_f_res_333462 * x2w_j_333472;
                double x4w_j_333474 = defunc_0_f_res_333462 * x3w_j_333473;
                double defunc_1_op_res_333475 = w_j_333470 + redout_333448;
                double defunc_1_op_res_333476 = xw_j_333471 + redout_333449;
                double defunc_1_op_res_333477 = x2w_j_333472 + redout_333450;
                double defunc_1_op_res_333478 = x3w_j_333473 + redout_333451;
                double defunc_1_op_res_333479 = x4w_j_333474 + redout_333452;
                double redout_tmp_333561 = defunc_1_op_res_333475;
                double redout_tmp_333562 = defunc_1_op_res_333476;
                double redout_tmp_333563 = defunc_1_op_res_333477;
                double redout_tmp_333564 = defunc_1_op_res_333478;
                double redout_tmp_333565 = defunc_1_op_res_333479;
                
                redout_333448 = redout_tmp_333561;
                redout_333449 = redout_tmp_333562;
                redout_333450 = redout_tmp_333563;
                redout_333451 = redout_tmp_333564;
                redout_333452 = redout_tmp_333565;
            }
            defunc_2_reduce_res_333442 = redout_333448;
            defunc_2_reduce_res_333443 = redout_333449;
            defunc_2_reduce_res_333444 = redout_333450;
            defunc_2_reduce_res_333445 = redout_333451;
            defunc_2_reduce_res_333446 = redout_333452;
            
            double a_333480 = 2.220446049250313e-16 +
                   defunc_2_reduce_res_333442;
            double b_333481 = 2.220446049250313e-16 +
                   defunc_2_reduce_res_333443;
            double c_333482 = 2.220446049250313e-16 +
                   defunc_2_reduce_res_333444;
            double d_333483 = 2.220446049250313e-16 +
                   defunc_2_reduce_res_333445;
            double e_333484 = 2.220446049250313e-16 +
                   defunc_2_reduce_res_333446;
            double x_333485 = c_333482 * e_333484;
            double y_333486 = d_333483 * d_333483;
            double a12_333487 = x_333485 - y_333486;
            double x_333488 = c_333482 * d_333483;
            double y_333489 = b_333481 * e_333484;
            double b12_333490 = x_333488 - y_333489;
            double x_333491 = b_333481 * d_333483;
            double y_333492 = c_333482 * c_333482;
            double c12_333493 = x_333491 - y_333492;
            double x_333494 = a_333480 * e_333484;
            double b2_333495 = x_333494 - y_333492;
            double x_333496 = b_333481 * c_333482;
            double y_333497 = a_333480 * d_333483;
            double c2_333498 = x_333496 - y_333497;
            double x_333499 = a_333480 * a12_333487;
            double y_333500 = b_333481 * b12_333490;
            double x_333501 = x_333499 + y_333500;
            double y_333502 = c_333482 * c12_333493;
            double y_333503 = x_333501 + y_333502;
            double det_333504 = 1.0 / y_333503;
            double a12_333505 = a12_333487 * det_333504;
            double b12_333506 = b12_333490 * det_333504;
            double c12_333507 = c12_333493 * det_333504;
            double b2_333508 = b2_333495 * det_333504;
            double c2_333509 = c2_333498 * det_333504;
            double defunc_2_reduce_res_333510;
            double defunc_2_reduce_res_333511;
            double redout_333513;
            double redout_333514;
            
            redout_333513 = 0.0;
            redout_333514 = 0.0;
            for (int64_t i_333512 = 0; i_333512 < q_t_292679; i_333512++) {
                bool cond_333515 = sle64(x_296038, i_333512);
                int64_t defunc_0_f_res_333516;
                
                if (cond_333515) {
                    defunc_0_f_res_333516 = (int64_t) 0;
                } else {
                    int64_t i_333517 = add64(x_333437, i_333512);
                    int64_t defunc_0_add_arg_333518;
                    
                    defunc_0_add_arg_333518 =
                        ((int64_t *) mem_312636.mem)[gtid_308093 * n_292675 +
                                                     i_333517];
                    
                    int64_t defunc_1_add_res_333519 = add64((int64_t) 1,
                                                            defunc_0_add_arg_333518);
                    
                    defunc_0_f_res_333516 = defunc_1_add_res_333519;
                }
                
                double defunc_0_f_res_333520;
                
                if (cond_333515) {
                    defunc_0_f_res_333520 = 0.0;
                } else {
                    int64_t i_333521 = add64(x_333437, i_333512);
                    double defunc_0_add_arg_333522;
                    
                    defunc_0_add_arg_333522 = ((double *) mem_315867)[i_333521];
                    defunc_0_f_res_333520 = defunc_0_add_arg_333522;
                }
                
                int64_t binop_p_333523 = sub64(defunc_0_f_res_333516,
                                               defunc_0_g_res_333441);
                double defunc_0_f_res_333524 = sitofp_i64_f64(binop_p_333523);
                double abs_res_333525 = fabs(defunc_0_f_res_333524);
                double tmp1_333526 = abs_res_333525 / x_333438;
                double x_333527 = tmp1_333526 * tmp1_333526;
                double y_333528 = tmp1_333526 * x_333527;
                double tmp2_333529 = 1.0 - y_333528;
                double x_333530 = tmp2_333529 * tmp2_333529;
                double tmp3_333531 = tmp2_333529 * x_333530;
                double tmp4_333532 = defunc_0_f_res_333520 * tmp3_333531;
                double defunc_1_f_res_333533 = defunc_0_f_res_333524 *
                       tmp4_333532;
                double defunc_1_f_res_333534 = defunc_0_f_res_333524 *
                       defunc_1_f_res_333533;
                double defunc_0_f_res_333535;
                
                if (cond_333515) {
                    defunc_0_f_res_333535 = 0.0;
                } else {
                    int64_t i_333536 = add64(x_333437, i_333512);
                    double defunc_0_add_arg_333537;
                    
                    defunc_0_add_arg_333537 = ((double *) mem_315870)[i_333536];
                    defunc_0_f_res_333535 = defunc_0_add_arg_333537;
                }
                
                double x_333538 = a12_333505 * tmp4_333532;
                double y_333539 = b12_333506 * defunc_1_f_res_333533;
                double x_333540 = x_333538 + y_333539;
                double y_333541 = c12_333507 * defunc_1_f_res_333534;
                double x_333542 = x_333540 + y_333541;
                double defunc_9_fit_fun_res_333543 = defunc_0_f_res_333535 *
                       x_333542;
                double x_333544 = b12_333506 * tmp4_333532;
                double y_333545 = b2_333508 * defunc_1_f_res_333533;
                double x_333546 = x_333544 + y_333545;
                double y_333547 = c2_333509 * defunc_1_f_res_333534;
                double x_333548 = x_333546 + y_333547;
                double defunc_9_slope_fun_res_333549 = defunc_0_f_res_333535 *
                       x_333548;
                double defunc_1_op_res_333550 = defunc_9_fit_fun_res_333543 +
                       redout_333513;
                double defunc_1_op_res_333551 = defunc_9_slope_fun_res_333549 +
                       redout_333514;
                double redout_tmp_333566 = defunc_1_op_res_333550;
                double redout_tmp_333567 = defunc_1_op_res_333551;
                
                redout_333513 = redout_tmp_333566;
                redout_333514 = redout_tmp_333567;
            }
            defunc_2_reduce_res_333510 = redout_333513;
            defunc_2_reduce_res_333511 = redout_333514;
            ((double *) mem_315897)[i_333434] = defunc_2_reduce_res_333510;
            ((double *) mem_315900)[i_333434] = defunc_2_reduce_res_333511;
        }
        if (t_n_m_292839 * (int64_t) 8 > 0)
            memmove(mem_315928.mem + gtid_308093 * t_n_m_292839 * (int64_t) 8,
                    mem_315897 + (int64_t) 0, t_n_m_292839 * (int64_t) 8);
        if (t_n_m_292839 * (int64_t) 8 > 0)
            memmove(mem_315932.mem + gtid_308093 * t_n_m_292839 * (int64_t) 8,
                    mem_315900 + (int64_t) 0, t_n_m_292839 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_315852);
    free(mem_315867);
    free(mem_315870);
    free(mem_315897);
    free(mem_315900);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338848_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338848_end -
                 futhark_mc_segmap_parloop_338848_start;
        
        ctx->futhark_mc_segmap_parloop_338848_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338848_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338848_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_338846(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_308092 = tid;
    int num_tasks_333408 = info.nsubtasks;
    struct futhark_mc_task_338845 *futhark_mc_task_338845 =
                                  (struct futhark_mc_task_338845 *) args;
    struct futhark_context *ctx = futhark_mc_task_338845->ctx;
    uint64_t futhark_mc_segmap_task_338846_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_338846_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338845->free_n_292675;
    int64_t q_t_292679 = futhark_mc_task_338845->free_q_t_292679;
    int64_t jump_t_292685 = futhark_mc_task_338845->free_jump_t_292685;
    int64_t partition_sizze_292766 =
            futhark_mc_task_338845->free_partition_sizze_292766;
    int64_t t_n_m_292839 = futhark_mc_task_338845->free_t_n_m_292839;
    int64_t i_292846 = futhark_mc_task_338845->free_i_292846;
    struct memblock mem_312593 = {.desc ="mem_312593", .mem =
                                  futhark_mc_task_338845->free_mem_312593,
                                  .size =0, .references =NULL};
    int64_t bytes_312598 = futhark_mc_task_338845->free_bytes_312598;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_task_338845->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_312639 = {.desc ="mem_312639", .mem =
                                  futhark_mc_task_338845->free_mem_312639,
                                  .size =0, .references =NULL};
    int64_t bytes_313090 = futhark_mc_task_338845->free_bytes_313090;
    struct memblock mem_313143 = {.desc ="mem_313143", .mem =
                                  futhark_mc_task_338845->free_mem_313143,
                                  .size =0, .references =NULL};
    struct memblock mem_313147 = {.desc ="mem_313147", .mem =
                                  futhark_mc_task_338845->free_mem_313147,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_task_338845->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_task_338845->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_task_338845->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_task_338845->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315656 = {.desc ="mem_315656", .mem =
                                  futhark_mc_task_338845->free_mem_315656,
                                  .size =0, .references =NULL};
    struct memblock mem_315928 = {.desc ="mem_315928", .mem =
                                  futhark_mc_task_338845->free_mem_315928,
                                  .size =0, .references =NULL};
    struct memblock mem_315932 = {.desc ="mem_315932", .mem =
                                  futhark_mc_task_338845->free_mem_315932,
                                  .size =0, .references =NULL};
    int64_t iter_333409;
    struct futhark_mc_segmap_parloop_struct_338847
    futhark_mc_segmap_parloop_struct_338847;
    
    futhark_mc_segmap_parloop_struct_338847.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338847.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_338847.free_q_t_292679 = q_t_292679;
    futhark_mc_segmap_parloop_struct_338847.free_jump_t_292685 = jump_t_292685;
    futhark_mc_segmap_parloop_struct_338847.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_338847.free_t_n_m_292839 = t_n_m_292839;
    futhark_mc_segmap_parloop_struct_338847.free_i_292846 = i_292846;
    futhark_mc_segmap_parloop_struct_338847.free_mem_312593 = mem_312593.mem;
    futhark_mc_segmap_parloop_struct_338847.free_bytes_312598 = bytes_312598;
    futhark_mc_segmap_parloop_struct_338847.free_mem_312636 = mem_312636.mem;
    futhark_mc_segmap_parloop_struct_338847.free_mem_312639 = mem_312639.mem;
    futhark_mc_segmap_parloop_struct_338847.free_bytes_313090 = bytes_313090;
    futhark_mc_segmap_parloop_struct_338847.free_mem_313143 = mem_313143.mem;
    futhark_mc_segmap_parloop_struct_338847.free_mem_313147 = mem_313147.mem;
    futhark_mc_segmap_parloop_struct_338847.free_ctx_param_ext_313174 =
        ctx_param_ext_313174;
    futhark_mc_segmap_parloop_struct_338847.free_ctx_param_ext_313175 =
        ctx_param_ext_313175;
    futhark_mc_segmap_parloop_struct_338847.free_ctx_param_ext_313177 =
        ctx_param_ext_313177;
    futhark_mc_segmap_parloop_struct_338847.free_mem_param_313179 =
        mem_param_313179.mem;
    futhark_mc_segmap_parloop_struct_338847.free_mem_315656 = mem_315656.mem;
    futhark_mc_segmap_parloop_struct_338847.free_mem_315928 = mem_315928.mem;
    futhark_mc_segmap_parloop_struct_338847.free_mem_315932 = mem_315932.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338848_task;
    
    futhark_mc_segmap_parloop_338848_task.name =
        "futhark_mc_segmap_parloop_338848";
    futhark_mc_segmap_parloop_338848_task.fn = futhark_mc_segmap_parloop_338848;
    futhark_mc_segmap_parloop_338848_task.args =
        &futhark_mc_segmap_parloop_struct_338847;
    futhark_mc_segmap_parloop_338848_task.iterations = iterations;
    futhark_mc_segmap_parloop_338848_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338848_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338848_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338848_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338848_task);
    
    if (futhark_mc_segmap_parloop_338848_err != 0) {
        err = futhark_mc_segmap_parloop_338848_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338848_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338848_total_end -
                 futhark_mc_segmap_parloop_338848_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338848_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338848_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338848_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_338846_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_338846_end -
                 futhark_mc_segmap_task_338846_start;
        
        ctx->futhark_mc_segmap_task_338846_runs[tid]++;
        ctx->futhark_mc_segmap_task_338846_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_338846_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_segmap_parloop_struct_338855 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_t_292679;
    int64_t free_jump_t_292685;
    int64_t free_partition_sizze_292766;
    int64_t free_t_n_m_292839;
    int64_t free_i_292846;
    unsigned char *free_mem_312593;
    int64_t free_bytes_312598;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_312639;
    int64_t free_bytes_313090;
    unsigned char *free_mem_313143;
    unsigned char *free_mem_313147;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315656;
    unsigned char *free_mem_315928;
    unsigned char *free_mem_315932;
};
struct futhark_mc_task_338862 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_308238;
    unsigned char *free_mem_312593;
    unsigned char *free_mem_315656;
    unsigned char *free_mem_315837;
};
struct futhark_mc_segmap_parloop_struct_338864 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_308238;
    unsigned char *free_mem_312593;
    unsigned char *free_mem_315656;
    unsigned char *free_mem_315837;
};
static int futhark_mc_segmap_parloop_338865(void *args, int64_t start,
                                            int64_t end, int flat_tid_333569,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338864
    *futhark_mc_segmap_parloop_struct_338864 =
    (struct futhark_mc_segmap_parloop_struct_338864 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338864->ctx;
    uint64_t futhark_mc_segmap_parloop_338865_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338865_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_338864->free_n_292675;
    int64_t gtid_308238 =
            futhark_mc_segmap_parloop_struct_338864->free_gtid_308238;
    struct memblock mem_312593 = {.desc ="mem_312593", .mem =
                                  futhark_mc_segmap_parloop_struct_338864->free_mem_312593,
                                  .size =0, .references =NULL};
    struct memblock mem_315656 = {.desc ="mem_315656", .mem =
                                  futhark_mc_segmap_parloop_struct_338864->free_mem_315656,
                                  .size =0, .references =NULL};
    struct memblock mem_315837 = {.desc ="mem_315837", .mem =
                                  futhark_mc_segmap_parloop_struct_338864->free_mem_315837,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_333835 = start;
    
    for (; iter_333835 < end; iter_333835++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_333836 = n_292675;
        int64_t gtid_333570 = iter_333835;
        int64_t remnant_333837 = iter_333835 - gtid_333570;
        float x_333571;
        
        x_333571 = ((float *) mem_312593.mem)[gtid_308238 * n_292675 +
                                              gtid_333570];
        
        double x_333572;
        
        x_333572 = ((double *) mem_315656.mem)[gtid_308238 * n_292675 +
                                               gtid_333570];
        
        double f32_res_333573 = fpconv_f32_f64(x_333571);
        double defunc_1_f_res_333574 = f32_res_333573 - x_333572;
        
        ((double *) mem_315837.mem)[gtid_333570] = defunc_1_f_res_333574;
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338865_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338865_end -
                 futhark_mc_segmap_parloop_338865_start;
        
        ctx->futhark_mc_segmap_parloop_338865_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338865_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338865_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_338863(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_333569 = tid;
    int num_tasks_333834 = info.nsubtasks;
    struct futhark_mc_task_338862 *futhark_mc_task_338862 =
                                  (struct futhark_mc_task_338862 *) args;
    struct futhark_context *ctx = futhark_mc_task_338862->ctx;
    uint64_t futhark_mc_segmap_task_338863_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_338863_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338862->free_n_292675;
    int64_t gtid_308238 = futhark_mc_task_338862->free_gtid_308238;
    struct memblock mem_312593 = {.desc ="mem_312593", .mem =
                                  futhark_mc_task_338862->free_mem_312593,
                                  .size =0, .references =NULL};
    struct memblock mem_315656 = {.desc ="mem_315656", .mem =
                                  futhark_mc_task_338862->free_mem_315656,
                                  .size =0, .references =NULL};
    struct memblock mem_315837 = {.desc ="mem_315837", .mem =
                                  futhark_mc_task_338862->free_mem_315837,
                                  .size =0, .references =NULL};
    int64_t iter_333835;
    struct futhark_mc_segmap_parloop_struct_338864
    futhark_mc_segmap_parloop_struct_338864;
    
    futhark_mc_segmap_parloop_struct_338864.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338864.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_338864.free_gtid_308238 = gtid_308238;
    futhark_mc_segmap_parloop_struct_338864.free_mem_312593 = mem_312593.mem;
    futhark_mc_segmap_parloop_struct_338864.free_mem_315656 = mem_315656.mem;
    futhark_mc_segmap_parloop_struct_338864.free_mem_315837 = mem_315837.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338865_task;
    
    futhark_mc_segmap_parloop_338865_task.name =
        "futhark_mc_segmap_parloop_338865";
    futhark_mc_segmap_parloop_338865_task.fn = futhark_mc_segmap_parloop_338865;
    futhark_mc_segmap_parloop_338865_task.args =
        &futhark_mc_segmap_parloop_struct_338864;
    futhark_mc_segmap_parloop_338865_task.iterations = iterations;
    futhark_mc_segmap_parloop_338865_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338865_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338865_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338865_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338865_task);
    
    if (futhark_mc_segmap_parloop_338865_err != 0) {
        err = futhark_mc_segmap_parloop_338865_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338865_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338865_total_end -
                 futhark_mc_segmap_parloop_338865_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338865_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338865_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338865_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_338863_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_338863_end -
                 futhark_mc_segmap_task_338863_start;
        
        ctx->futhark_mc_segmap_task_338863_runs[tid]++;
        ctx->futhark_mc_segmap_task_338863_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_338863_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_task_338866 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_308238;
    unsigned char *free_mem_312636;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315837;
    unsigned char *free_mem_315840;
    unsigned char *free_mem_315843;
};
struct futhark_mc_segmap_parloop_struct_338868 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_308238;
    unsigned char *free_mem_312636;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315837;
    unsigned char *free_mem_315840;
    unsigned char *free_mem_315843;
};
static int futhark_mc_segmap_parloop_338869(void *args, int64_t start,
                                            int64_t end, int flat_tid_333575,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338868
    *futhark_mc_segmap_parloop_struct_338868 =
    (struct futhark_mc_segmap_parloop_struct_338868 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338868->ctx;
    uint64_t futhark_mc_segmap_parloop_338869_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338869_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_338868->free_n_292675;
    int64_t gtid_308238 =
            futhark_mc_segmap_parloop_struct_338868->free_gtid_308238;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_segmap_parloop_struct_338868->free_mem_312636,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_segmap_parloop_struct_338868->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_segmap_parloop_struct_338868->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_segmap_parloop_struct_338868->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_segmap_parloop_struct_338868->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315837 = {.desc ="mem_315837", .mem =
                                  futhark_mc_segmap_parloop_struct_338868->free_mem_315837,
                                  .size =0, .references =NULL};
    struct memblock mem_315840 = {.desc ="mem_315840", .mem =
                                  futhark_mc_segmap_parloop_struct_338868->free_mem_315840,
                                  .size =0, .references =NULL};
    struct memblock mem_315843 = {.desc ="mem_315843", .mem =
                                  futhark_mc_segmap_parloop_struct_338868->free_mem_315843,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_333839 = start;
    
    for (; iter_333839 < end; iter_333839++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_333848 = n_292675;
        int64_t gtid_333576 = iter_333839;
        int64_t remnant_333849 = iter_333839 - gtid_333576;
        int64_t x_333577;
        
        x_333577 = ((int64_t *) mem_312636.mem)[gtid_308238 * n_292675 +
                                                gtid_333576];
        
        bool cond_333578 = sle64((int64_t) 0, x_333577);
        double defunc_0_f_res_333579;
        
        if (cond_333578) {
            bool y_333840 = slt64(x_333577, n_292675);
            bool bounds_check_333841 = cond_333578 && y_333840;
            bool index_certs_333842;
            
            if (!bounds_check_333841) {
                ctx->error =
                    msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                              "Index [", (long long) x_333577,
                              "] out of bounds for array of shape [",
                              (long long) n_292675, "].",
                              "-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:45:43-70\n   #3  stl.fut:285:33-58\n   #4  /prelude/soacs.fut:75:22-28\n   #5  /prelude/soacs.fut:75:3-45\n   #6  stl.fut:283:13-288:41\n   #7  stl.fut:419:61-435:77\n   #8  stl.fut:463:3-479:36\n   #9  stl.fut:445:1-479:36\n");
                err = FUTHARK_PROGRAM_ERROR;
                goto cleanup;
            }
            
            double defunc_0_f_res_t_res_333843;
            
            defunc_0_f_res_t_res_333843 = ((double *) mem_315837.mem)[x_333577];
            defunc_0_f_res_333579 = defunc_0_f_res_t_res_333843;
        } else {
            defunc_0_f_res_333579 = 0.0;
        }
        
        double defunc_0_f_res_333584;
        
        if (cond_333578) {
            bool y_333844 = slt64(x_333577, n_292675);
            bool bounds_check_333845 = cond_333578 && y_333844;
            bool index_certs_333846;
            
            if (!bounds_check_333845) {
                ctx->error =
                    msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                              "Index [", (long long) x_333577,
                              "] out of bounds for array of shape [",
                              (long long) n_292675, "].",
                              "-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:45:43-70\n   #3  stl.fut:286:33-64\n   #4  /prelude/soacs.fut:75:22-28\n   #5  /prelude/soacs.fut:75:3-45\n   #6  stl.fut:283:13-288:41\n   #7  stl.fut:419:61-435:77\n   #8  stl.fut:463:3-479:36\n   #9  stl.fut:445:1-479:36\n");
                err = FUTHARK_PROGRAM_ERROR;
                goto cleanup;
            }
            
            double defunc_0_f_res_t_res_333847;
            
            defunc_0_f_res_t_res_333847 =
                ((double *) mem_param_313179.mem)[ctx_param_ext_313174 +
                                                  (gtid_308238 *
                                                   ctx_param_ext_313175 +
                                                   x_333577 *
                                                   ctx_param_ext_313177)];
            defunc_0_f_res_333584 = defunc_0_f_res_t_res_333847;
        } else {
            defunc_0_f_res_333584 = 0.0;
        }
        ((double *) mem_315840.mem)[gtid_333576] = defunc_0_f_res_333584;
        ((double *) mem_315843.mem)[gtid_333576] = defunc_0_f_res_333579;
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338869_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338869_end -
                 futhark_mc_segmap_parloop_338869_start;
        
        ctx->futhark_mc_segmap_parloop_338869_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338869_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338869_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_338867(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_333575 = tid;
    int num_tasks_333838 = info.nsubtasks;
    struct futhark_mc_task_338866 *futhark_mc_task_338866 =
                                  (struct futhark_mc_task_338866 *) args;
    struct futhark_context *ctx = futhark_mc_task_338866->ctx;
    uint64_t futhark_mc_segmap_task_338867_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_338867_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338866->free_n_292675;
    int64_t gtid_308238 = futhark_mc_task_338866->free_gtid_308238;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_task_338866->free_mem_312636,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_task_338866->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_task_338866->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_task_338866->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_task_338866->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315837 = {.desc ="mem_315837", .mem =
                                  futhark_mc_task_338866->free_mem_315837,
                                  .size =0, .references =NULL};
    struct memblock mem_315840 = {.desc ="mem_315840", .mem =
                                  futhark_mc_task_338866->free_mem_315840,
                                  .size =0, .references =NULL};
    struct memblock mem_315843 = {.desc ="mem_315843", .mem =
                                  futhark_mc_task_338866->free_mem_315843,
                                  .size =0, .references =NULL};
    int64_t iter_333839;
    struct futhark_mc_segmap_parloop_struct_338868
    futhark_mc_segmap_parloop_struct_338868;
    
    futhark_mc_segmap_parloop_struct_338868.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338868.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_338868.free_gtid_308238 = gtid_308238;
    futhark_mc_segmap_parloop_struct_338868.free_mem_312636 = mem_312636.mem;
    futhark_mc_segmap_parloop_struct_338868.free_ctx_param_ext_313174 =
        ctx_param_ext_313174;
    futhark_mc_segmap_parloop_struct_338868.free_ctx_param_ext_313175 =
        ctx_param_ext_313175;
    futhark_mc_segmap_parloop_struct_338868.free_ctx_param_ext_313177 =
        ctx_param_ext_313177;
    futhark_mc_segmap_parloop_struct_338868.free_mem_param_313179 =
        mem_param_313179.mem;
    futhark_mc_segmap_parloop_struct_338868.free_mem_315837 = mem_315837.mem;
    futhark_mc_segmap_parloop_struct_338868.free_mem_315840 = mem_315840.mem;
    futhark_mc_segmap_parloop_struct_338868.free_mem_315843 = mem_315843.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338869_task;
    
    futhark_mc_segmap_parloop_338869_task.name =
        "futhark_mc_segmap_parloop_338869";
    futhark_mc_segmap_parloop_338869_task.fn = futhark_mc_segmap_parloop_338869;
    futhark_mc_segmap_parloop_338869_task.args =
        &futhark_mc_segmap_parloop_struct_338868;
    futhark_mc_segmap_parloop_338869_task.iterations = iterations;
    futhark_mc_segmap_parloop_338869_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338869_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338869_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338869_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338869_task);
    
    if (futhark_mc_segmap_parloop_338869_err != 0) {
        err = futhark_mc_segmap_parloop_338869_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338869_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338869_total_end -
                 futhark_mc_segmap_parloop_338869_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338869_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338869_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338869_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_338867_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_338867_end -
                 futhark_mc_segmap_task_338867_start;
        
        ctx->futhark_mc_segmap_task_338867_runs[tid]++;
        ctx->futhark_mc_segmap_task_338867_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_338867_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_task_338870 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_t_292679;
    int64_t free_jump_t_292685;
    int64_t free_t_n_m_292839;
    int64_t free_i_292846;
    int64_t free_gtid_308238;
    int64_t free_x_308243;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_313143;
    unsigned char *free_mem_313147;
    unsigned char *free_mem_315840;
    unsigned char *free_mem_315843;
    unsigned char *free_mem_315846;
    unsigned char *free_mem_315849;
};
struct futhark_mc_segmap_parloop_struct_338872 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_t_292679;
    int64_t free_jump_t_292685;
    int64_t free_t_n_m_292839;
    int64_t free_i_292846;
    int64_t free_gtid_308238;
    int64_t free_x_308243;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_313143;
    unsigned char *free_mem_313147;
    unsigned char *free_mem_315840;
    unsigned char *free_mem_315843;
    unsigned char *free_mem_315846;
    unsigned char *free_mem_315849;
};
static int futhark_mc_segmap_parloop_338873(void *args, int64_t start,
                                            int64_t end, int flat_tid_333715,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338872
    *futhark_mc_segmap_parloop_struct_338872 =
    (struct futhark_mc_segmap_parloop_struct_338872 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338872->ctx;
    uint64_t futhark_mc_segmap_parloop_338873_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338873_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_338872->free_n_292675;
    int64_t q_t_292679 =
            futhark_mc_segmap_parloop_struct_338872->free_q_t_292679;
    int64_t jump_t_292685 =
            futhark_mc_segmap_parloop_struct_338872->free_jump_t_292685;
    int64_t t_n_m_292839 =
            futhark_mc_segmap_parloop_struct_338872->free_t_n_m_292839;
    int64_t i_292846 = futhark_mc_segmap_parloop_struct_338872->free_i_292846;
    int64_t gtid_308238 =
            futhark_mc_segmap_parloop_struct_338872->free_gtid_308238;
    int64_t x_308243 = futhark_mc_segmap_parloop_struct_338872->free_x_308243;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_segmap_parloop_struct_338872->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_313143 = {.desc ="mem_313143", .mem =
                                  futhark_mc_segmap_parloop_struct_338872->free_mem_313143,
                                  .size =0, .references =NULL};
    struct memblock mem_313147 = {.desc ="mem_313147", .mem =
                                  futhark_mc_segmap_parloop_struct_338872->free_mem_313147,
                                  .size =0, .references =NULL};
    struct memblock mem_315840 = {.desc ="mem_315840", .mem =
                                  futhark_mc_segmap_parloop_struct_338872->free_mem_315840,
                                  .size =0, .references =NULL};
    struct memblock mem_315843 = {.desc ="mem_315843", .mem =
                                  futhark_mc_segmap_parloop_struct_338872->free_mem_315843,
                                  .size =0, .references =NULL};
    struct memblock mem_315846 = {.desc ="mem_315846", .mem =
                                  futhark_mc_segmap_parloop_struct_338872->free_mem_315846,
                                  .size =0, .references =NULL};
    struct memblock mem_315849 = {.desc ="mem_315849", .mem =
                                  futhark_mc_segmap_parloop_struct_338872->free_mem_315849,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_333851 = start;
    
    for (; iter_333851 < end; iter_333851++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_333925 = t_n_m_292839;
        int64_t gtid_333716 = iter_333851;
        int64_t remnant_333926 = iter_333851 - gtid_333716;
        int64_t x_333717;
        
        x_333717 = ((int64_t *) mem_313143.mem)[gtid_308238 * t_n_m_292839 +
                                                gtid_333716];
        
        double x_333718;
        
        x_333718 = ((double *) mem_313147.mem)[gtid_308238 * t_n_m_292839 +
                                               gtid_333716];
        
        int64_t min_arg_333719 = mul64(jump_t_292685, gtid_333716);
        int64_t min_res_333720 = smin64(i_292846, min_arg_333719);
        int64_t defunc_0_g_res_333721 = add64((int64_t) 1, min_res_333720);
        double defunc_2_reduce_res_333722;
        double defunc_2_reduce_res_333723;
        double defunc_2_reduce_res_333724;
        double defunc_2_reduce_res_333725;
        double defunc_2_reduce_res_333726;
        double redout_333853;
        double redout_333854;
        double redout_333855;
        double redout_333856;
        double redout_333857;
        
        redout_333853 = 0.0;
        redout_333854 = 0.0;
        redout_333855 = 0.0;
        redout_333856 = 0.0;
        redout_333857 = 0.0;
        for (int64_t i_333852 = 0; i_333852 < q_t_292679; i_333852++) {
            bool cond_333858 = sle64(x_308243, i_333852);
            int64_t defunc_0_f_res_333859;
            
            if (cond_333858) {
                defunc_0_f_res_333859 = (int64_t) 0;
            } else {
                int64_t i_333860 = add64(x_333717, i_333852);
                int64_t defunc_0_add_arg_333861;
                
                defunc_0_add_arg_333861 =
                    ((int64_t *) mem_312636.mem)[gtid_308238 * n_292675 +
                                                 i_333860];
                
                int64_t defunc_1_add_res_333862 = add64((int64_t) 1,
                                                        defunc_0_add_arg_333861);
                
                defunc_0_f_res_333859 = defunc_1_add_res_333862;
            }
            
            double defunc_0_f_res_333863;
            
            if (cond_333858) {
                defunc_0_f_res_333863 = 0.0;
            } else {
                int64_t i_333864 = add64(x_333717, i_333852);
                double defunc_0_add_arg_333865;
                
                defunc_0_add_arg_333865 = ((double *) mem_315840.mem)[i_333864];
                defunc_0_f_res_333863 = defunc_0_add_arg_333865;
            }
            
            int64_t binop_p_333866 = sub64(defunc_0_f_res_333859,
                                           defunc_0_g_res_333721);
            double defunc_0_f_res_333867 = sitofp_i64_f64(binop_p_333866);
            double abs_res_333868 = fabs(defunc_0_f_res_333867);
            double tmp1_333869 = abs_res_333868 / x_333718;
            double x_333870 = tmp1_333869 * tmp1_333869;
            double y_333871 = tmp1_333869 * x_333870;
            double tmp2_333872 = 1.0 - y_333871;
            double x_333873 = tmp2_333872 * tmp2_333872;
            double tmp3_333874 = tmp2_333872 * x_333873;
            double w_j_333875 = defunc_0_f_res_333863 * tmp3_333874;
            double xw_j_333876 = defunc_0_f_res_333867 * w_j_333875;
            double x2w_j_333877 = defunc_0_f_res_333867 * xw_j_333876;
            double x3w_j_333878 = defunc_0_f_res_333867 * x2w_j_333877;
            double x4w_j_333879 = defunc_0_f_res_333867 * x3w_j_333878;
            double defunc_1_op_res_333880 = w_j_333875 + redout_333853;
            double defunc_1_op_res_333881 = xw_j_333876 + redout_333854;
            double defunc_1_op_res_333882 = x2w_j_333877 + redout_333855;
            double defunc_1_op_res_333883 = x3w_j_333878 + redout_333856;
            double defunc_1_op_res_333884 = x4w_j_333879 + redout_333857;
            double redout_tmp_333927 = defunc_1_op_res_333880;
            double redout_tmp_333928 = defunc_1_op_res_333881;
            double redout_tmp_333929 = defunc_1_op_res_333882;
            double redout_tmp_333930 = defunc_1_op_res_333883;
            double redout_tmp_333931 = defunc_1_op_res_333884;
            
            redout_333853 = redout_tmp_333927;
            redout_333854 = redout_tmp_333928;
            redout_333855 = redout_tmp_333929;
            redout_333856 = redout_tmp_333930;
            redout_333857 = redout_tmp_333931;
        }
        defunc_2_reduce_res_333722 = redout_333853;
        defunc_2_reduce_res_333723 = redout_333854;
        defunc_2_reduce_res_333724 = redout_333855;
        defunc_2_reduce_res_333725 = redout_333856;
        defunc_2_reduce_res_333726 = redout_333857;
        
        double a_333760 = 2.220446049250313e-16 + defunc_2_reduce_res_333722;
        double b_333761 = 2.220446049250313e-16 + defunc_2_reduce_res_333723;
        double c_333762 = 2.220446049250313e-16 + defunc_2_reduce_res_333724;
        double d_333763 = 2.220446049250313e-16 + defunc_2_reduce_res_333725;
        double e_333764 = 2.220446049250313e-16 + defunc_2_reduce_res_333726;
        double x_333765 = c_333762 * e_333764;
        double y_333766 = d_333763 * d_333763;
        double a12_333767 = x_333765 - y_333766;
        double x_333768 = c_333762 * d_333763;
        double y_333769 = b_333761 * e_333764;
        double b12_333770 = x_333768 - y_333769;
        double x_333771 = b_333761 * d_333763;
        double y_333772 = c_333762 * c_333762;
        double c12_333773 = x_333771 - y_333772;
        double x_333774 = a_333760 * e_333764;
        double b2_333775 = x_333774 - y_333772;
        double x_333776 = b_333761 * c_333762;
        double y_333777 = a_333760 * d_333763;
        double c2_333778 = x_333776 - y_333777;
        double x_333779 = a_333760 * a12_333767;
        double y_333780 = b_333761 * b12_333770;
        double x_333781 = x_333779 + y_333780;
        double y_333782 = c_333762 * c12_333773;
        double y_333783 = x_333781 + y_333782;
        double det_333784 = 1.0 / y_333783;
        double a12_333785 = a12_333767 * det_333784;
        double b12_333786 = b12_333770 * det_333784;
        double c12_333787 = c12_333773 * det_333784;
        double b2_333788 = b2_333775 * det_333784;
        double c2_333789 = c2_333778 * det_333784;
        double defunc_2_reduce_res_333790;
        double defunc_2_reduce_res_333791;
        double redout_333886;
        double redout_333887;
        
        redout_333886 = 0.0;
        redout_333887 = 0.0;
        for (int64_t i_333885 = 0; i_333885 < q_t_292679; i_333885++) {
            bool cond_333888 = sle64(x_308243, i_333885);
            int64_t defunc_0_f_res_333889;
            
            if (cond_333888) {
                defunc_0_f_res_333889 = (int64_t) 0;
            } else {
                int64_t i_333890 = add64(x_333717, i_333885);
                int64_t defunc_0_add_arg_333891;
                
                defunc_0_add_arg_333891 =
                    ((int64_t *) mem_312636.mem)[gtid_308238 * n_292675 +
                                                 i_333890];
                
                int64_t defunc_1_add_res_333892 = add64((int64_t) 1,
                                                        defunc_0_add_arg_333891);
                
                defunc_0_f_res_333889 = defunc_1_add_res_333892;
            }
            
            double defunc_0_f_res_333893;
            
            if (cond_333888) {
                defunc_0_f_res_333893 = 0.0;
            } else {
                int64_t i_333894 = add64(x_333717, i_333885);
                double defunc_0_add_arg_333895;
                
                defunc_0_add_arg_333895 = ((double *) mem_315840.mem)[i_333894];
                defunc_0_f_res_333893 = defunc_0_add_arg_333895;
            }
            
            int64_t binop_p_333896 = sub64(defunc_0_f_res_333889,
                                           defunc_0_g_res_333721);
            double defunc_0_f_res_333897 = sitofp_i64_f64(binop_p_333896);
            double abs_res_333898 = fabs(defunc_0_f_res_333897);
            double tmp1_333899 = abs_res_333898 / x_333718;
            double x_333900 = tmp1_333899 * tmp1_333899;
            double y_333901 = tmp1_333899 * x_333900;
            double tmp2_333902 = 1.0 - y_333901;
            double x_333903 = tmp2_333902 * tmp2_333902;
            double tmp3_333904 = tmp2_333902 * x_333903;
            double tmp4_333905 = defunc_0_f_res_333893 * tmp3_333904;
            double defunc_1_f_res_333906 = defunc_0_f_res_333897 * tmp4_333905;
            double defunc_1_f_res_333907 = defunc_0_f_res_333897 *
                   defunc_1_f_res_333906;
            double defunc_0_f_res_333908;
            
            if (cond_333888) {
                defunc_0_f_res_333908 = 0.0;
            } else {
                int64_t i_333909 = add64(x_333717, i_333885);
                double defunc_0_add_arg_333910;
                
                defunc_0_add_arg_333910 = ((double *) mem_315843.mem)[i_333909];
                defunc_0_f_res_333908 = defunc_0_add_arg_333910;
            }
            
            double x_333911 = a12_333785 * tmp4_333905;
            double y_333912 = b12_333786 * defunc_1_f_res_333906;
            double x_333913 = x_333911 + y_333912;
            double y_333914 = c12_333787 * defunc_1_f_res_333907;
            double x_333915 = x_333913 + y_333914;
            double defunc_9_fit_fun_res_333916 = defunc_0_f_res_333908 *
                   x_333915;
            double x_333917 = b12_333786 * tmp4_333905;
            double y_333918 = b2_333788 * defunc_1_f_res_333906;
            double x_333919 = x_333917 + y_333918;
            double y_333920 = c2_333789 * defunc_1_f_res_333907;
            double x_333921 = x_333919 + y_333920;
            double defunc_9_slope_fun_res_333922 = defunc_0_f_res_333908 *
                   x_333921;
            double defunc_1_op_res_333923 = defunc_9_fit_fun_res_333916 +
                   redout_333886;
            double defunc_1_op_res_333924 = defunc_9_slope_fun_res_333922 +
                   redout_333887;
            double redout_tmp_333932 = defunc_1_op_res_333923;
            double redout_tmp_333933 = defunc_1_op_res_333924;
            
            redout_333886 = redout_tmp_333932;
            redout_333887 = redout_tmp_333933;
        }
        defunc_2_reduce_res_333790 = redout_333886;
        defunc_2_reduce_res_333791 = redout_333887;
        ((double *) mem_315846.mem)[gtid_333716] = defunc_2_reduce_res_333790;
        ((double *) mem_315849.mem)[gtid_333716] = defunc_2_reduce_res_333791;
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338873_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338873_end -
                 futhark_mc_segmap_parloop_338873_start;
        
        ctx->futhark_mc_segmap_parloop_338873_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338873_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338873_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_338871(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_333715 = tid;
    int num_tasks_333850 = info.nsubtasks;
    struct futhark_mc_task_338870 *futhark_mc_task_338870 =
                                  (struct futhark_mc_task_338870 *) args;
    struct futhark_context *ctx = futhark_mc_task_338870->ctx;
    uint64_t futhark_mc_segmap_task_338871_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_338871_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338870->free_n_292675;
    int64_t q_t_292679 = futhark_mc_task_338870->free_q_t_292679;
    int64_t jump_t_292685 = futhark_mc_task_338870->free_jump_t_292685;
    int64_t t_n_m_292839 = futhark_mc_task_338870->free_t_n_m_292839;
    int64_t i_292846 = futhark_mc_task_338870->free_i_292846;
    int64_t gtid_308238 = futhark_mc_task_338870->free_gtid_308238;
    int64_t x_308243 = futhark_mc_task_338870->free_x_308243;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_task_338870->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_313143 = {.desc ="mem_313143", .mem =
                                  futhark_mc_task_338870->free_mem_313143,
                                  .size =0, .references =NULL};
    struct memblock mem_313147 = {.desc ="mem_313147", .mem =
                                  futhark_mc_task_338870->free_mem_313147,
                                  .size =0, .references =NULL};
    struct memblock mem_315840 = {.desc ="mem_315840", .mem =
                                  futhark_mc_task_338870->free_mem_315840,
                                  .size =0, .references =NULL};
    struct memblock mem_315843 = {.desc ="mem_315843", .mem =
                                  futhark_mc_task_338870->free_mem_315843,
                                  .size =0, .references =NULL};
    struct memblock mem_315846 = {.desc ="mem_315846", .mem =
                                  futhark_mc_task_338870->free_mem_315846,
                                  .size =0, .references =NULL};
    struct memblock mem_315849 = {.desc ="mem_315849", .mem =
                                  futhark_mc_task_338870->free_mem_315849,
                                  .size =0, .references =NULL};
    int64_t iter_333851;
    struct futhark_mc_segmap_parloop_struct_338872
    futhark_mc_segmap_parloop_struct_338872;
    
    futhark_mc_segmap_parloop_struct_338872.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338872.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_338872.free_q_t_292679 = q_t_292679;
    futhark_mc_segmap_parloop_struct_338872.free_jump_t_292685 = jump_t_292685;
    futhark_mc_segmap_parloop_struct_338872.free_t_n_m_292839 = t_n_m_292839;
    futhark_mc_segmap_parloop_struct_338872.free_i_292846 = i_292846;
    futhark_mc_segmap_parloop_struct_338872.free_gtid_308238 = gtid_308238;
    futhark_mc_segmap_parloop_struct_338872.free_x_308243 = x_308243;
    futhark_mc_segmap_parloop_struct_338872.free_mem_312636 = mem_312636.mem;
    futhark_mc_segmap_parloop_struct_338872.free_mem_313143 = mem_313143.mem;
    futhark_mc_segmap_parloop_struct_338872.free_mem_313147 = mem_313147.mem;
    futhark_mc_segmap_parloop_struct_338872.free_mem_315840 = mem_315840.mem;
    futhark_mc_segmap_parloop_struct_338872.free_mem_315843 = mem_315843.mem;
    futhark_mc_segmap_parloop_struct_338872.free_mem_315846 = mem_315846.mem;
    futhark_mc_segmap_parloop_struct_338872.free_mem_315849 = mem_315849.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338873_task;
    
    futhark_mc_segmap_parloop_338873_task.name =
        "futhark_mc_segmap_parloop_338873";
    futhark_mc_segmap_parloop_338873_task.fn = futhark_mc_segmap_parloop_338873;
    futhark_mc_segmap_parloop_338873_task.args =
        &futhark_mc_segmap_parloop_struct_338872;
    futhark_mc_segmap_parloop_338873_task.iterations = iterations;
    futhark_mc_segmap_parloop_338873_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338873_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338873_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338873_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338873_task);
    
    if (futhark_mc_segmap_parloop_338873_err != 0) {
        err = futhark_mc_segmap_parloop_338873_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338873_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338873_total_end -
                 futhark_mc_segmap_parloop_338873_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338873_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338873_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338873_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_338871_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_338871_end -
                 futhark_mc_segmap_task_338871_start;
        
        ctx->futhark_mc_segmap_task_338871_runs[tid]++;
        ctx->futhark_mc_segmap_task_338871_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_338871_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_segmap_parloop_struct_338875 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_t_292679;
    int64_t free_jump_t_292685;
    int64_t free_t_n_m_292839;
    int64_t free_i_292846;
    int64_t free_gtid_308238;
    int64_t free_x_308243;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_313143;
    unsigned char *free_mem_313147;
    unsigned char *free_mem_315840;
    unsigned char *free_mem_315843;
    unsigned char *free_mem_315846;
    unsigned char *free_mem_315849;
};
struct futhark_mc_task_338877 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_308238;
    int64_t free_x_308243;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_315840;
    int64_t free_x_333591;
    double free_x_333592;
    int64_t free_defunc_0_g_res_333595;
    double *retval_defunc_2_reduce_res_333596;
    double *retval_defunc_2_reduce_res_333597;
    double *retval_defunc_2_reduce_res_333598;
    double *retval_defunc_2_reduce_res_333599;
    double *retval_defunc_2_reduce_res_333600;
};
struct futhark_mc_segred_stage_1_parloop_struct_338884 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_308238;
    int64_t free_x_308243;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_315840;
    int64_t free_x_333591;
    double free_x_333592;
    int64_t free_defunc_0_g_res_333595;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_334020;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_334022;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_334024;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_334026;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_334028;
};
static int futhark_mc_segred_stage_1_parloop_338885(void *args, int64_t start,
                                                    int64_t end,
                                                    int flat_tid_333935,
                                                    int tid)
{
    int err = 0;
    struct futhark_mc_segred_stage_1_parloop_struct_338884
    *futhark_mc_segred_stage_1_parloop_struct_338884 =
    (struct futhark_mc_segred_stage_1_parloop_struct_338884 *) args;
    struct futhark_context *ctx =
                           futhark_mc_segred_stage_1_parloop_struct_338884->ctx;
    uint64_t futhark_mc_segred_stage_1_parloop_338885_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_338885_start = get_wall_time();
    
    int64_t n_292675 =
            futhark_mc_segred_stage_1_parloop_struct_338884->free_n_292675;
    int64_t gtid_308238 =
            futhark_mc_segred_stage_1_parloop_struct_338884->free_gtid_308238;
    int64_t x_308243 =
            futhark_mc_segred_stage_1_parloop_struct_338884->free_x_308243;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_338884->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_315840 = {.desc ="mem_315840", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_338884->free_mem_315840,
                                  .size =0, .references =NULL};
    int64_t x_333591 =
            futhark_mc_segred_stage_1_parloop_struct_338884->free_x_333591;
    double x_333592 =
           futhark_mc_segred_stage_1_parloop_struct_338884->free_x_333592;
    int64_t defunc_0_g_res_333595 =
            futhark_mc_segred_stage_1_parloop_struct_338884->free_defunc_0_g_res_333595;
    struct memblock reduce_stage_1_tid_res_arr_mem_334020 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_334020",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338884->free_reduce_stage_1_tid_res_arr_mem_334020,
                                                             .size =0,
                                                             .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_334022 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_334022",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338884->free_reduce_stage_1_tid_res_arr_mem_334022,
                                                             .size =0,
                                                             .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_334024 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_334024",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338884->free_reduce_stage_1_tid_res_arr_mem_334024,
                                                             .size =0,
                                                             .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_334026 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_334026",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338884->free_reduce_stage_1_tid_res_arr_mem_334026,
                                                             .size =0,
                                                             .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_334028 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_334028",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338884->free_reduce_stage_1_tid_res_arr_mem_334028,
                                                             .size =0,
                                                             .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_334030 = start;
    double x_333937;
    double x_333938;
    double x_333940;
    double x_333941;
    double x_333943;
    double x_333944;
    double x_333946;
    double x_333947;
    double x_333949;
    double x_333950;
    double local_acc_334031 = 0.0;
    double local_acc_334032 = 0.0;
    double local_acc_334033 = 0.0;
    double local_acc_334034 = 0.0;
    double local_acc_334035 = 0.0;
    
    for (; iter_334030 < end; iter_334030++) {
        int64_t gtid_333936 = iter_334030;
        bool cond_333952 = sle64(x_308243, gtid_333936);
        int64_t defunc_0_f_res_333953;
        
        if (cond_333952) {
            defunc_0_f_res_333953 = (int64_t) 0;
        } else {
            int64_t i_333954 = add64(x_333591, gtid_333936);
            int64_t defunc_0_add_arg_333955;
            
            defunc_0_add_arg_333955 = ((int64_t *) mem_312636.mem)[gtid_308238 *
                                                                   n_292675 +
                                                                   i_333954];
            
            int64_t defunc_1_add_res_333956 = add64((int64_t) 1,
                                                    defunc_0_add_arg_333955);
            
            defunc_0_f_res_333953 = defunc_1_add_res_333956;
        }
        
        double defunc_0_f_res_333957;
        
        if (cond_333952) {
            defunc_0_f_res_333957 = 0.0;
        } else {
            int64_t i_333958 = add64(x_333591, gtid_333936);
            double defunc_0_add_arg_333959;
            
            defunc_0_add_arg_333959 = ((double *) mem_315840.mem)[i_333958];
            defunc_0_f_res_333957 = defunc_0_add_arg_333959;
        }
        
        int64_t binop_p_333960 = sub64(defunc_0_f_res_333953,
                                       defunc_0_g_res_333595);
        double defunc_0_f_res_333961 = sitofp_i64_f64(binop_p_333960);
        double abs_res_333962 = fabs(defunc_0_f_res_333961);
        double tmp1_333963 = abs_res_333962 / x_333592;
        double x_333964 = tmp1_333963 * tmp1_333963;
        double y_333965 = tmp1_333963 * x_333964;
        double tmp2_333966 = 1.0 - y_333965;
        double x_333967 = tmp2_333966 * tmp2_333966;
        double tmp3_333968 = tmp2_333966 * x_333967;
        double w_j_333969 = defunc_0_f_res_333957 * tmp3_333968;
        double xw_j_333970 = defunc_0_f_res_333961 * w_j_333969;
        double x2w_j_333971 = defunc_0_f_res_333961 * xw_j_333970;
        double x3w_j_333972 = defunc_0_f_res_333961 * x2w_j_333971;
        double x4w_j_333973 = defunc_0_f_res_333961 * x3w_j_333972;
        
        // save map-out results
        { }
        // Load accum params
        {
            x_333937 = local_acc_334031;
        }
        // Load next params
        {
            x_333938 = w_j_333969;
        }
        // Red body
        {
            double defunc_1_op_res_333939 = x_333937 + x_333938;
            
            local_acc_334031 = defunc_1_op_res_333939;
        }
        // Load accum params
        {
            x_333940 = local_acc_334032;
        }
        // Load next params
        {
            x_333941 = xw_j_333970;
        }
        // Red body
        {
            double defunc_1_op_res_333942 = x_333940 + x_333941;
            
            local_acc_334032 = defunc_1_op_res_333942;
        }
        // Load accum params
        {
            x_333943 = local_acc_334033;
        }
        // Load next params
        {
            x_333944 = x2w_j_333971;
        }
        // Red body
        {
            double defunc_1_op_res_333945 = x_333943 + x_333944;
            
            local_acc_334033 = defunc_1_op_res_333945;
        }
        // Load accum params
        {
            x_333946 = local_acc_334034;
        }
        // Load next params
        {
            x_333947 = x3w_j_333972;
        }
        // Red body
        {
            double defunc_1_op_res_333948 = x_333946 + x_333947;
            
            local_acc_334034 = defunc_1_op_res_333948;
        }
        // Load accum params
        {
            x_333949 = local_acc_334035;
        }
        // Load next params
        {
            x_333950 = x4w_j_333973;
        }
        // Red body
        {
            double defunc_1_op_res_333951 = x_333949 + x_333950;
            
            local_acc_334035 = defunc_1_op_res_333951;
        }
    }
    ((double *) reduce_stage_1_tid_res_arr_mem_334020.mem)[flat_tid_333935] =
        local_acc_334031;
    ((double *) reduce_stage_1_tid_res_arr_mem_334022.mem)[flat_tid_333935] =
        local_acc_334032;
    ((double *) reduce_stage_1_tid_res_arr_mem_334024.mem)[flat_tid_333935] =
        local_acc_334033;
    ((double *) reduce_stage_1_tid_res_arr_mem_334026.mem)[flat_tid_333935] =
        local_acc_334034;
    ((double *) reduce_stage_1_tid_res_arr_mem_334028.mem)[flat_tid_333935] =
        local_acc_334035;
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_338885_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_338885_end -
                 futhark_mc_segred_stage_1_parloop_338885_start;
        
        ctx->futhark_mc_segred_stage_1_parloop_338885_runs[tid]++;
        ctx->futhark_mc_segred_stage_1_parloop_338885_total_runtime[tid] +=
            elapsed;
        ctx->futhark_mc_segred_stage_1_parloop_338885_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segred_task_338878(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_333935 = tid;
    int num_tasks_334019 = info.nsubtasks;
    struct futhark_mc_task_338877 *futhark_mc_task_338877 =
                                  (struct futhark_mc_task_338877 *) args;
    struct futhark_context *ctx = futhark_mc_task_338877->ctx;
    uint64_t futhark_mc_segred_task_338878_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_task_338878_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338877->free_n_292675;
    int64_t gtid_308238 = futhark_mc_task_338877->free_gtid_308238;
    int64_t x_308243 = futhark_mc_task_338877->free_x_308243;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_task_338877->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_315840 = {.desc ="mem_315840", .mem =
                                  futhark_mc_task_338877->free_mem_315840,
                                  .size =0, .references =NULL};
    int64_t x_333591 = futhark_mc_task_338877->free_x_333591;
    double x_333592 = futhark_mc_task_338877->free_x_333592;
    int64_t defunc_0_g_res_333595 =
            futhark_mc_task_338877->free_defunc_0_g_res_333595;
    double defunc_2_reduce_res_333596 =
           *futhark_mc_task_338877->retval_defunc_2_reduce_res_333596;
    double defunc_2_reduce_res_333597 =
           *futhark_mc_task_338877->retval_defunc_2_reduce_res_333597;
    double defunc_2_reduce_res_333598 =
           *futhark_mc_task_338877->retval_defunc_2_reduce_res_333598;
    double defunc_2_reduce_res_333599 =
           *futhark_mc_task_338877->retval_defunc_2_reduce_res_333599;
    double defunc_2_reduce_res_333600 =
           *futhark_mc_task_338877->retval_defunc_2_reduce_res_333600;
    size_t reduce_stage_1_tid_res_arr_mem_334020_cached_sizze_338879 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_334020 = NULL;
    size_t reduce_stage_1_tid_res_arr_mem_334022_cached_sizze_338880 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_334022 = NULL;
    size_t reduce_stage_1_tid_res_arr_mem_334024_cached_sizze_338881 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_334024 = NULL;
    size_t reduce_stage_1_tid_res_arr_mem_334026_cached_sizze_338882 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_334026 = NULL;
    size_t reduce_stage_1_tid_res_arr_mem_334028_cached_sizze_338883 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_334028 = NULL;
    
    if (reduce_stage_1_tid_res_arr_mem_334020_cached_sizze_338879 <
        (size_t) ((int64_t) 8 * num_tasks_334019)) {
        reduce_stage_1_tid_res_arr_mem_334020 =
            realloc(reduce_stage_1_tid_res_arr_mem_334020, (int64_t) 8 *
                    num_tasks_334019);
        reduce_stage_1_tid_res_arr_mem_334020_cached_sizze_338879 =
            (int64_t) 8 * num_tasks_334019;
    }
    if (reduce_stage_1_tid_res_arr_mem_334022_cached_sizze_338880 <
        (size_t) ((int64_t) 8 * num_tasks_334019)) {
        reduce_stage_1_tid_res_arr_mem_334022 =
            realloc(reduce_stage_1_tid_res_arr_mem_334022, (int64_t) 8 *
                    num_tasks_334019);
        reduce_stage_1_tid_res_arr_mem_334022_cached_sizze_338880 =
            (int64_t) 8 * num_tasks_334019;
    }
    if (reduce_stage_1_tid_res_arr_mem_334024_cached_sizze_338881 <
        (size_t) ((int64_t) 8 * num_tasks_334019)) {
        reduce_stage_1_tid_res_arr_mem_334024 =
            realloc(reduce_stage_1_tid_res_arr_mem_334024, (int64_t) 8 *
                    num_tasks_334019);
        reduce_stage_1_tid_res_arr_mem_334024_cached_sizze_338881 =
            (int64_t) 8 * num_tasks_334019;
    }
    if (reduce_stage_1_tid_res_arr_mem_334026_cached_sizze_338882 <
        (size_t) ((int64_t) 8 * num_tasks_334019)) {
        reduce_stage_1_tid_res_arr_mem_334026 =
            realloc(reduce_stage_1_tid_res_arr_mem_334026, (int64_t) 8 *
                    num_tasks_334019);
        reduce_stage_1_tid_res_arr_mem_334026_cached_sizze_338882 =
            (int64_t) 8 * num_tasks_334019;
    }
    if (reduce_stage_1_tid_res_arr_mem_334028_cached_sizze_338883 <
        (size_t) ((int64_t) 8 * num_tasks_334019)) {
        reduce_stage_1_tid_res_arr_mem_334028 =
            realloc(reduce_stage_1_tid_res_arr_mem_334028, (int64_t) 8 *
                    num_tasks_334019);
        reduce_stage_1_tid_res_arr_mem_334028_cached_sizze_338883 =
            (int64_t) 8 * num_tasks_334019;
    }
    
    int64_t iter_334030;
    struct futhark_mc_segred_stage_1_parloop_struct_338884
    futhark_mc_segred_stage_1_parloop_struct_338884;
    
    futhark_mc_segred_stage_1_parloop_struct_338884.ctx = ctx;
    futhark_mc_segred_stage_1_parloop_struct_338884.free_n_292675 = n_292675;
    futhark_mc_segred_stage_1_parloop_struct_338884.free_gtid_308238 =
        gtid_308238;
    futhark_mc_segred_stage_1_parloop_struct_338884.free_x_308243 = x_308243;
    futhark_mc_segred_stage_1_parloop_struct_338884.free_mem_312636 =
        mem_312636.mem;
    futhark_mc_segred_stage_1_parloop_struct_338884.free_mem_315840 =
        mem_315840.mem;
    futhark_mc_segred_stage_1_parloop_struct_338884.free_x_333591 = x_333591;
    futhark_mc_segred_stage_1_parloop_struct_338884.free_x_333592 = x_333592;
    futhark_mc_segred_stage_1_parloop_struct_338884.free_defunc_0_g_res_333595 =
        defunc_0_g_res_333595;
    futhark_mc_segred_stage_1_parloop_struct_338884.free_reduce_stage_1_tid_res_arr_mem_334020 =
        reduce_stage_1_tid_res_arr_mem_334020;
    futhark_mc_segred_stage_1_parloop_struct_338884.free_reduce_stage_1_tid_res_arr_mem_334022 =
        reduce_stage_1_tid_res_arr_mem_334022;
    futhark_mc_segred_stage_1_parloop_struct_338884.free_reduce_stage_1_tid_res_arr_mem_334024 =
        reduce_stage_1_tid_res_arr_mem_334024;
    futhark_mc_segred_stage_1_parloop_struct_338884.free_reduce_stage_1_tid_res_arr_mem_334026 =
        reduce_stage_1_tid_res_arr_mem_334026;
    futhark_mc_segred_stage_1_parloop_struct_338884.free_reduce_stage_1_tid_res_arr_mem_334028 =
        reduce_stage_1_tid_res_arr_mem_334028;
    
    struct scheduler_parloop futhark_mc_segred_stage_1_parloop_338885_task;
    
    futhark_mc_segred_stage_1_parloop_338885_task.name =
        "futhark_mc_segred_stage_1_parloop_338885";
    futhark_mc_segred_stage_1_parloop_338885_task.fn =
        futhark_mc_segred_stage_1_parloop_338885;
    futhark_mc_segred_stage_1_parloop_338885_task.args =
        &futhark_mc_segred_stage_1_parloop_struct_338884;
    futhark_mc_segred_stage_1_parloop_338885_task.iterations = iterations;
    futhark_mc_segred_stage_1_parloop_338885_task.info = info;
    
    uint64_t futhark_mc_segred_stage_1_parloop_338885_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_338885_total_start = get_wall_time();
    
    int futhark_mc_segred_stage_1_parloop_338885_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segred_stage_1_parloop_338885_task);
    
    if (futhark_mc_segred_stage_1_parloop_338885_err != 0) {
        err = futhark_mc_segred_stage_1_parloop_338885_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_338885_total_end =
                 get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_338885_total_end -
                 futhark_mc_segred_stage_1_parloop_338885_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338885_total_runs,
                           1, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338885_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338885_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    // neutral-initialise the output
    {
        defunc_2_reduce_res_333596 = 0.0;
        defunc_2_reduce_res_333597 = 0.0;
        defunc_2_reduce_res_333598 = 0.0;
        defunc_2_reduce_res_333599 = 0.0;
        defunc_2_reduce_res_333600 = 0.0;
    }
    
    double x_334036;
    double x_334037;
    double x_334039;
    double x_334040;
    double x_334042;
    double x_334043;
    double x_334045;
    double x_334046;
    double x_334048;
    double x_334049;
    
    for (int32_t i_334051 = 0; i_334051 < num_tasks_334019; i_334051++) {
        flat_tid_333935 = i_334051;
        // Apply main thread reduction
        {
            // load acc params
            {
                x_334036 = defunc_2_reduce_res_333596;
            }
            // load next params
            {
                x_334037 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_334020)[flat_tid_333935];
            }
            // red body
            {
                double defunc_1_op_res_334038 = x_334036 + x_334037;
                
                defunc_2_reduce_res_333596 = defunc_1_op_res_334038;
            }
            // load acc params
            {
                x_334039 = defunc_2_reduce_res_333597;
            }
            // load next params
            {
                x_334040 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_334022)[flat_tid_333935];
            }
            // red body
            {
                double defunc_1_op_res_334041 = x_334039 + x_334040;
                
                defunc_2_reduce_res_333597 = defunc_1_op_res_334041;
            }
            // load acc params
            {
                x_334042 = defunc_2_reduce_res_333598;
            }
            // load next params
            {
                x_334043 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_334024)[flat_tid_333935];
            }
            // red body
            {
                double defunc_1_op_res_334044 = x_334042 + x_334043;
                
                defunc_2_reduce_res_333598 = defunc_1_op_res_334044;
            }
            // load acc params
            {
                x_334045 = defunc_2_reduce_res_333599;
            }
            // load next params
            {
                x_334046 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_334026)[flat_tid_333935];
            }
            // red body
            {
                double defunc_1_op_res_334047 = x_334045 + x_334046;
                
                defunc_2_reduce_res_333599 = defunc_1_op_res_334047;
            }
            // load acc params
            {
                x_334048 = defunc_2_reduce_res_333600;
            }
            // load next params
            {
                x_334049 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_334028)[flat_tid_333935];
            }
            // red body
            {
                double defunc_1_op_res_334050 = x_334048 + x_334049;
                
                defunc_2_reduce_res_333600 = defunc_1_op_res_334050;
            }
        }
    }
    
  cleanup:
    {
        free(reduce_stage_1_tid_res_arr_mem_334020);
        free(reduce_stage_1_tid_res_arr_mem_334022);
        free(reduce_stage_1_tid_res_arr_mem_334024);
        free(reduce_stage_1_tid_res_arr_mem_334026);
        free(reduce_stage_1_tid_res_arr_mem_334028);
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_task_338878_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_task_338878_end -
                 futhark_mc_segred_task_338878_start;
        
        ctx->futhark_mc_segred_task_338878_runs[tid]++;
        ctx->futhark_mc_segred_task_338878_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segred_task_338878_iter[tid] += iterations;
    }
    if (err == 0) {
        *futhark_mc_task_338877->retval_defunc_2_reduce_res_333596 =
            defunc_2_reduce_res_333596;
        *futhark_mc_task_338877->retval_defunc_2_reduce_res_333597 =
            defunc_2_reduce_res_333597;
        *futhark_mc_task_338877->retval_defunc_2_reduce_res_333598 =
            defunc_2_reduce_res_333598;
        *futhark_mc_task_338877->retval_defunc_2_reduce_res_333599 =
            defunc_2_reduce_res_333599;
        *futhark_mc_task_338877->retval_defunc_2_reduce_res_333600 =
            defunc_2_reduce_res_333600;
    }
    return err;
}
struct futhark_mc_task_338886 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_308238;
    int64_t free_x_308243;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_315840;
    unsigned char *free_mem_315843;
    int64_t free_x_333591;
    double free_x_333592;
    int64_t free_defunc_0_g_res_333595;
    double free_a12_333665;
    double free_b12_333666;
    double free_c12_333667;
    double free_b2_333668;
    double free_c2_333669;
    double *retval_defunc_2_reduce_res_333670;
    double *retval_defunc_2_reduce_res_333671;
};
struct futhark_mc_segred_stage_1_parloop_struct_338890 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_308238;
    int64_t free_x_308243;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_315840;
    unsigned char *free_mem_315843;
    int64_t free_x_333591;
    double free_x_333592;
    int64_t free_defunc_0_g_res_333595;
    double free_a12_333665;
    double free_b12_333666;
    double free_c12_333667;
    double free_b2_333668;
    double free_c2_333669;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_334053;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_334055;
};
static int futhark_mc_segred_stage_1_parloop_338891(void *args, int64_t start,
                                                    int64_t end,
                                                    int flat_tid_333974,
                                                    int tid)
{
    int err = 0;
    struct futhark_mc_segred_stage_1_parloop_struct_338890
    *futhark_mc_segred_stage_1_parloop_struct_338890 =
    (struct futhark_mc_segred_stage_1_parloop_struct_338890 *) args;
    struct futhark_context *ctx =
                           futhark_mc_segred_stage_1_parloop_struct_338890->ctx;
    uint64_t futhark_mc_segred_stage_1_parloop_338891_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_338891_start = get_wall_time();
    
    int64_t n_292675 =
            futhark_mc_segred_stage_1_parloop_struct_338890->free_n_292675;
    int64_t gtid_308238 =
            futhark_mc_segred_stage_1_parloop_struct_338890->free_gtid_308238;
    int64_t x_308243 =
            futhark_mc_segred_stage_1_parloop_struct_338890->free_x_308243;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_338890->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_315840 = {.desc ="mem_315840", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_338890->free_mem_315840,
                                  .size =0, .references =NULL};
    struct memblock mem_315843 = {.desc ="mem_315843", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_338890->free_mem_315843,
                                  .size =0, .references =NULL};
    int64_t x_333591 =
            futhark_mc_segred_stage_1_parloop_struct_338890->free_x_333591;
    double x_333592 =
           futhark_mc_segred_stage_1_parloop_struct_338890->free_x_333592;
    int64_t defunc_0_g_res_333595 =
            futhark_mc_segred_stage_1_parloop_struct_338890->free_defunc_0_g_res_333595;
    double a12_333665 =
           futhark_mc_segred_stage_1_parloop_struct_338890->free_a12_333665;
    double b12_333666 =
           futhark_mc_segred_stage_1_parloop_struct_338890->free_b12_333666;
    double c12_333667 =
           futhark_mc_segred_stage_1_parloop_struct_338890->free_c12_333667;
    double b2_333668 =
           futhark_mc_segred_stage_1_parloop_struct_338890->free_b2_333668;
    double c2_333669 =
           futhark_mc_segred_stage_1_parloop_struct_338890->free_c2_333669;
    struct memblock reduce_stage_1_tid_res_arr_mem_334053 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_334053",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338890->free_reduce_stage_1_tid_res_arr_mem_334053,
                                                             .size =0,
                                                             .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_334055 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_334055",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338890->free_reduce_stage_1_tid_res_arr_mem_334055,
                                                             .size =0,
                                                             .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_334057 = start;
    double x_333976;
    double x_333977;
    double x_333979;
    double x_333980;
    double local_acc_334058 = 0.0;
    double local_acc_334059 = 0.0;
    
    for (; iter_334057 < end; iter_334057++) {
        int64_t gtid_333975 = iter_334057;
        bool cond_333982 = sle64(x_308243, gtid_333975);
        int64_t defunc_0_f_res_333983;
        
        if (cond_333982) {
            defunc_0_f_res_333983 = (int64_t) 0;
        } else {
            int64_t i_333984 = add64(x_333591, gtid_333975);
            int64_t defunc_0_add_arg_333985;
            
            defunc_0_add_arg_333985 = ((int64_t *) mem_312636.mem)[gtid_308238 *
                                                                   n_292675 +
                                                                   i_333984];
            
            int64_t defunc_1_add_res_333986 = add64((int64_t) 1,
                                                    defunc_0_add_arg_333985);
            
            defunc_0_f_res_333983 = defunc_1_add_res_333986;
        }
        
        double defunc_0_f_res_333987;
        
        if (cond_333982) {
            defunc_0_f_res_333987 = 0.0;
        } else {
            int64_t i_333988 = add64(x_333591, gtid_333975);
            double defunc_0_add_arg_333989;
            
            defunc_0_add_arg_333989 = ((double *) mem_315840.mem)[i_333988];
            defunc_0_f_res_333987 = defunc_0_add_arg_333989;
        }
        
        int64_t binop_p_333990 = sub64(defunc_0_f_res_333983,
                                       defunc_0_g_res_333595);
        double defunc_0_f_res_333991 = sitofp_i64_f64(binop_p_333990);
        double abs_res_333992 = fabs(defunc_0_f_res_333991);
        double tmp1_333993 = abs_res_333992 / x_333592;
        double x_333994 = tmp1_333993 * tmp1_333993;
        double y_333995 = tmp1_333993 * x_333994;
        double tmp2_333996 = 1.0 - y_333995;
        double x_333997 = tmp2_333996 * tmp2_333996;
        double tmp3_333998 = tmp2_333996 * x_333997;
        double tmp4_333999 = defunc_0_f_res_333987 * tmp3_333998;
        double defunc_1_f_res_334000 = defunc_0_f_res_333991 * tmp4_333999;
        double defunc_1_f_res_334001 = defunc_0_f_res_333991 *
               defunc_1_f_res_334000;
        double defunc_0_f_res_334002;
        
        if (cond_333982) {
            defunc_0_f_res_334002 = 0.0;
        } else {
            int64_t i_334003 = add64(x_333591, gtid_333975);
            double defunc_0_add_arg_334004;
            
            defunc_0_add_arg_334004 = ((double *) mem_315843.mem)[i_334003];
            defunc_0_f_res_334002 = defunc_0_add_arg_334004;
        }
        
        double x_334005 = a12_333665 * tmp4_333999;
        double y_334006 = b12_333666 * defunc_1_f_res_334000;
        double x_334007 = x_334005 + y_334006;
        double y_334008 = c12_333667 * defunc_1_f_res_334001;
        double x_334009 = x_334007 + y_334008;
        double defunc_9_fit_fun_res_334010 = defunc_0_f_res_334002 * x_334009;
        double x_334011 = b12_333666 * tmp4_333999;
        double y_334012 = b2_333668 * defunc_1_f_res_334000;
        double x_334013 = x_334011 + y_334012;
        double y_334014 = c2_333669 * defunc_1_f_res_334001;
        double x_334015 = x_334013 + y_334014;
        double defunc_9_slope_fun_res_334016 = defunc_0_f_res_334002 * x_334015;
        
        // save map-out results
        { }
        // Load accum params
        {
            x_333976 = local_acc_334058;
        }
        // Load next params
        {
            x_333977 = defunc_9_fit_fun_res_334010;
        }
        // Red body
        {
            double defunc_1_op_res_333978 = x_333976 + x_333977;
            
            local_acc_334058 = defunc_1_op_res_333978;
        }
        // Load accum params
        {
            x_333979 = local_acc_334059;
        }
        // Load next params
        {
            x_333980 = defunc_9_slope_fun_res_334016;
        }
        // Red body
        {
            double defunc_1_op_res_333981 = x_333979 + x_333980;
            
            local_acc_334059 = defunc_1_op_res_333981;
        }
    }
    ((double *) reduce_stage_1_tid_res_arr_mem_334053.mem)[flat_tid_333974] =
        local_acc_334058;
    ((double *) reduce_stage_1_tid_res_arr_mem_334055.mem)[flat_tid_333974] =
        local_acc_334059;
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_338891_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_338891_end -
                 futhark_mc_segred_stage_1_parloop_338891_start;
        
        ctx->futhark_mc_segred_stage_1_parloop_338891_runs[tid]++;
        ctx->futhark_mc_segred_stage_1_parloop_338891_total_runtime[tid] +=
            elapsed;
        ctx->futhark_mc_segred_stage_1_parloop_338891_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segred_task_338887(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_333974 = tid;
    int num_tasks_334052 = info.nsubtasks;
    struct futhark_mc_task_338886 *futhark_mc_task_338886 =
                                  (struct futhark_mc_task_338886 *) args;
    struct futhark_context *ctx = futhark_mc_task_338886->ctx;
    uint64_t futhark_mc_segred_task_338887_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_task_338887_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338886->free_n_292675;
    int64_t gtid_308238 = futhark_mc_task_338886->free_gtid_308238;
    int64_t x_308243 = futhark_mc_task_338886->free_x_308243;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_task_338886->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_315840 = {.desc ="mem_315840", .mem =
                                  futhark_mc_task_338886->free_mem_315840,
                                  .size =0, .references =NULL};
    struct memblock mem_315843 = {.desc ="mem_315843", .mem =
                                  futhark_mc_task_338886->free_mem_315843,
                                  .size =0, .references =NULL};
    int64_t x_333591 = futhark_mc_task_338886->free_x_333591;
    double x_333592 = futhark_mc_task_338886->free_x_333592;
    int64_t defunc_0_g_res_333595 =
            futhark_mc_task_338886->free_defunc_0_g_res_333595;
    double a12_333665 = futhark_mc_task_338886->free_a12_333665;
    double b12_333666 = futhark_mc_task_338886->free_b12_333666;
    double c12_333667 = futhark_mc_task_338886->free_c12_333667;
    double b2_333668 = futhark_mc_task_338886->free_b2_333668;
    double c2_333669 = futhark_mc_task_338886->free_c2_333669;
    double defunc_2_reduce_res_333670 =
           *futhark_mc_task_338886->retval_defunc_2_reduce_res_333670;
    double defunc_2_reduce_res_333671 =
           *futhark_mc_task_338886->retval_defunc_2_reduce_res_333671;
    size_t reduce_stage_1_tid_res_arr_mem_334053_cached_sizze_338888 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_334053 = NULL;
    size_t reduce_stage_1_tid_res_arr_mem_334055_cached_sizze_338889 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_334055 = NULL;
    
    if (reduce_stage_1_tid_res_arr_mem_334053_cached_sizze_338888 <
        (size_t) ((int64_t) 8 * num_tasks_334052)) {
        reduce_stage_1_tid_res_arr_mem_334053 =
            realloc(reduce_stage_1_tid_res_arr_mem_334053, (int64_t) 8 *
                    num_tasks_334052);
        reduce_stage_1_tid_res_arr_mem_334053_cached_sizze_338888 =
            (int64_t) 8 * num_tasks_334052;
    }
    if (reduce_stage_1_tid_res_arr_mem_334055_cached_sizze_338889 <
        (size_t) ((int64_t) 8 * num_tasks_334052)) {
        reduce_stage_1_tid_res_arr_mem_334055 =
            realloc(reduce_stage_1_tid_res_arr_mem_334055, (int64_t) 8 *
                    num_tasks_334052);
        reduce_stage_1_tid_res_arr_mem_334055_cached_sizze_338889 =
            (int64_t) 8 * num_tasks_334052;
    }
    
    int64_t iter_334057;
    struct futhark_mc_segred_stage_1_parloop_struct_338890
    futhark_mc_segred_stage_1_parloop_struct_338890;
    
    futhark_mc_segred_stage_1_parloop_struct_338890.ctx = ctx;
    futhark_mc_segred_stage_1_parloop_struct_338890.free_n_292675 = n_292675;
    futhark_mc_segred_stage_1_parloop_struct_338890.free_gtid_308238 =
        gtid_308238;
    futhark_mc_segred_stage_1_parloop_struct_338890.free_x_308243 = x_308243;
    futhark_mc_segred_stage_1_parloop_struct_338890.free_mem_312636 =
        mem_312636.mem;
    futhark_mc_segred_stage_1_parloop_struct_338890.free_mem_315840 =
        mem_315840.mem;
    futhark_mc_segred_stage_1_parloop_struct_338890.free_mem_315843 =
        mem_315843.mem;
    futhark_mc_segred_stage_1_parloop_struct_338890.free_x_333591 = x_333591;
    futhark_mc_segred_stage_1_parloop_struct_338890.free_x_333592 = x_333592;
    futhark_mc_segred_stage_1_parloop_struct_338890.free_defunc_0_g_res_333595 =
        defunc_0_g_res_333595;
    futhark_mc_segred_stage_1_parloop_struct_338890.free_a12_333665 =
        a12_333665;
    futhark_mc_segred_stage_1_parloop_struct_338890.free_b12_333666 =
        b12_333666;
    futhark_mc_segred_stage_1_parloop_struct_338890.free_c12_333667 =
        c12_333667;
    futhark_mc_segred_stage_1_parloop_struct_338890.free_b2_333668 = b2_333668;
    futhark_mc_segred_stage_1_parloop_struct_338890.free_c2_333669 = c2_333669;
    futhark_mc_segred_stage_1_parloop_struct_338890.free_reduce_stage_1_tid_res_arr_mem_334053 =
        reduce_stage_1_tid_res_arr_mem_334053;
    futhark_mc_segred_stage_1_parloop_struct_338890.free_reduce_stage_1_tid_res_arr_mem_334055 =
        reduce_stage_1_tid_res_arr_mem_334055;
    
    struct scheduler_parloop futhark_mc_segred_stage_1_parloop_338891_task;
    
    futhark_mc_segred_stage_1_parloop_338891_task.name =
        "futhark_mc_segred_stage_1_parloop_338891";
    futhark_mc_segred_stage_1_parloop_338891_task.fn =
        futhark_mc_segred_stage_1_parloop_338891;
    futhark_mc_segred_stage_1_parloop_338891_task.args =
        &futhark_mc_segred_stage_1_parloop_struct_338890;
    futhark_mc_segred_stage_1_parloop_338891_task.iterations = iterations;
    futhark_mc_segred_stage_1_parloop_338891_task.info = info;
    
    uint64_t futhark_mc_segred_stage_1_parloop_338891_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_338891_total_start = get_wall_time();
    
    int futhark_mc_segred_stage_1_parloop_338891_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segred_stage_1_parloop_338891_task);
    
    if (futhark_mc_segred_stage_1_parloop_338891_err != 0) {
        err = futhark_mc_segred_stage_1_parloop_338891_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_338891_total_end =
                 get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_338891_total_end -
                 futhark_mc_segred_stage_1_parloop_338891_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338891_total_runs,
                           1, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338891_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338891_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    // neutral-initialise the output
    {
        defunc_2_reduce_res_333670 = 0.0;
        defunc_2_reduce_res_333671 = 0.0;
    }
    
    double x_334060;
    double x_334061;
    double x_334063;
    double x_334064;
    
    for (int32_t i_334066 = 0; i_334066 < num_tasks_334052; i_334066++) {
        flat_tid_333974 = i_334066;
        // Apply main thread reduction
        {
            // load acc params
            {
                x_334060 = defunc_2_reduce_res_333670;
            }
            // load next params
            {
                x_334061 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_334053)[flat_tid_333974];
            }
            // red body
            {
                double defunc_1_op_res_334062 = x_334060 + x_334061;
                
                defunc_2_reduce_res_333670 = defunc_1_op_res_334062;
            }
            // load acc params
            {
                x_334063 = defunc_2_reduce_res_333671;
            }
            // load next params
            {
                x_334064 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_334055)[flat_tid_333974];
            }
            // red body
            {
                double defunc_1_op_res_334065 = x_334063 + x_334064;
                
                defunc_2_reduce_res_333671 = defunc_1_op_res_334065;
            }
        }
    }
    
  cleanup:
    {
        free(reduce_stage_1_tid_res_arr_mem_334053);
        free(reduce_stage_1_tid_res_arr_mem_334055);
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_task_338887_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_task_338887_end -
                 futhark_mc_segred_task_338887_start;
        
        ctx->futhark_mc_segred_task_338887_runs[tid]++;
        ctx->futhark_mc_segred_task_338887_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segred_task_338887_iter[tid] += iterations;
    }
    if (err == 0) {
        *futhark_mc_task_338886->retval_defunc_2_reduce_res_333670 =
            defunc_2_reduce_res_333670;
        *futhark_mc_task_338886->retval_defunc_2_reduce_res_333671 =
            defunc_2_reduce_res_333671;
    }
    return err;
}
static int futhark_mc_segmap_parloop_338876(void *args, int64_t start,
                                            int64_t end, int flat_tid_333589,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338875
    *futhark_mc_segmap_parloop_struct_338875 =
    (struct futhark_mc_segmap_parloop_struct_338875 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338875->ctx;
    uint64_t futhark_mc_segmap_parloop_338876_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338876_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_338875->free_n_292675;
    int64_t q_t_292679 =
            futhark_mc_segmap_parloop_struct_338875->free_q_t_292679;
    int64_t jump_t_292685 =
            futhark_mc_segmap_parloop_struct_338875->free_jump_t_292685;
    int64_t t_n_m_292839 =
            futhark_mc_segmap_parloop_struct_338875->free_t_n_m_292839;
    int64_t i_292846 = futhark_mc_segmap_parloop_struct_338875->free_i_292846;
    int64_t gtid_308238 =
            futhark_mc_segmap_parloop_struct_338875->free_gtid_308238;
    int64_t x_308243 = futhark_mc_segmap_parloop_struct_338875->free_x_308243;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_segmap_parloop_struct_338875->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_313143 = {.desc ="mem_313143", .mem =
                                  futhark_mc_segmap_parloop_struct_338875->free_mem_313143,
                                  .size =0, .references =NULL};
    struct memblock mem_313147 = {.desc ="mem_313147", .mem =
                                  futhark_mc_segmap_parloop_struct_338875->free_mem_313147,
                                  .size =0, .references =NULL};
    struct memblock mem_315840 = {.desc ="mem_315840", .mem =
                                  futhark_mc_segmap_parloop_struct_338875->free_mem_315840,
                                  .size =0, .references =NULL};
    struct memblock mem_315843 = {.desc ="mem_315843", .mem =
                                  futhark_mc_segmap_parloop_struct_338875->free_mem_315843,
                                  .size =0, .references =NULL};
    struct memblock mem_315846 = {.desc ="mem_315846", .mem =
                                  futhark_mc_segmap_parloop_struct_338875->free_mem_315846,
                                  .size =0, .references =NULL};
    struct memblock mem_315849 = {.desc ="mem_315849", .mem =
                                  futhark_mc_segmap_parloop_struct_338875->free_mem_315849,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_333934 = start;
    
    for (; iter_333934 < end; iter_333934++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_334017 = t_n_m_292839;
        int64_t gtid_333590 = iter_333934;
        int64_t remnant_334018 = iter_333934 - gtid_333590;
        int64_t x_333591;
        
        x_333591 = ((int64_t *) mem_313143.mem)[gtid_308238 * t_n_m_292839 +
                                                gtid_333590];
        
        double x_333592;
        
        x_333592 = ((double *) mem_313147.mem)[gtid_308238 * t_n_m_292839 +
                                               gtid_333590];
        
        int64_t min_arg_333593 = mul64(jump_t_292685, gtid_333590);
        int64_t min_res_333594 = smin64(i_292846, min_arg_333593);
        int64_t defunc_0_g_res_333595 = add64((int64_t) 1, min_res_333594);
        double defunc_2_reduce_res_333596;
        double defunc_2_reduce_res_333597;
        double defunc_2_reduce_res_333598;
        double defunc_2_reduce_res_333599;
        double defunc_2_reduce_res_333600;
        int64_t flat_tid_333935 = (int64_t) 0;
        int32_t num_tasks_334019;
        
        defunc_2_reduce_res_333596 = 0.0;
        defunc_2_reduce_res_333597 = 0.0;
        defunc_2_reduce_res_333598 = 0.0;
        defunc_2_reduce_res_333599 = 0.0;
        defunc_2_reduce_res_333600 = 0.0;
        
        struct futhark_mc_task_338877 futhark_mc_task_338877;
        
        futhark_mc_task_338877.ctx = ctx;
        futhark_mc_task_338877.free_n_292675 = n_292675;
        futhark_mc_task_338877.free_gtid_308238 = gtid_308238;
        futhark_mc_task_338877.free_x_308243 = x_308243;
        futhark_mc_task_338877.free_mem_312636 = mem_312636.mem;
        futhark_mc_task_338877.free_mem_315840 = mem_315840.mem;
        futhark_mc_task_338877.free_x_333591 = x_333591;
        futhark_mc_task_338877.free_x_333592 = x_333592;
        futhark_mc_task_338877.free_defunc_0_g_res_333595 =
            defunc_0_g_res_333595;
        futhark_mc_task_338877.retval_defunc_2_reduce_res_333596 =
            &defunc_2_reduce_res_333596;
        futhark_mc_task_338877.retval_defunc_2_reduce_res_333597 =
            &defunc_2_reduce_res_333597;
        futhark_mc_task_338877.retval_defunc_2_reduce_res_333598 =
            &defunc_2_reduce_res_333598;
        futhark_mc_task_338877.retval_defunc_2_reduce_res_333599 =
            &defunc_2_reduce_res_333599;
        futhark_mc_task_338877.retval_defunc_2_reduce_res_333600 =
            &defunc_2_reduce_res_333600;
        
        struct scheduler_segop futhark_mc_task_338877_task;
        
        futhark_mc_task_338877_task.args = &futhark_mc_task_338877;
        futhark_mc_task_338877_task.top_level_fn =
            futhark_mc_segred_task_338878;
        futhark_mc_task_338877_task.name = "futhark_mc_segred_task_338878";
        futhark_mc_task_338877_task.iterations = q_t_292679;
        futhark_mc_task_338877_task.task_time =
            &ctx->futhark_mc_segred_task_338878_total_time;
        futhark_mc_task_338877_task.task_iter =
            &ctx->futhark_mc_segred_task_338878_total_iter;
        futhark_mc_task_338877_task.sched = STATIC;
        futhark_mc_task_338877_task.nested_fn = NULL;
        
        int futhark_mc_segred_task_338878_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_338877_task);
        
        if (futhark_mc_segred_task_338878_err != 0) {
            ;
            err = futhark_mc_segred_task_338878_err;
            goto cleanup;
        }
        
        double a_333640 = 2.220446049250313e-16 + defunc_2_reduce_res_333596;
        double b_333641 = 2.220446049250313e-16 + defunc_2_reduce_res_333597;
        double c_333642 = 2.220446049250313e-16 + defunc_2_reduce_res_333598;
        double d_333643 = 2.220446049250313e-16 + defunc_2_reduce_res_333599;
        double e_333644 = 2.220446049250313e-16 + defunc_2_reduce_res_333600;
        double x_333645 = c_333642 * e_333644;
        double y_333646 = d_333643 * d_333643;
        double a12_333647 = x_333645 - y_333646;
        double x_333648 = c_333642 * d_333643;
        double y_333649 = b_333641 * e_333644;
        double b12_333650 = x_333648 - y_333649;
        double x_333651 = b_333641 * d_333643;
        double y_333652 = c_333642 * c_333642;
        double c12_333653 = x_333651 - y_333652;
        double x_333654 = a_333640 * e_333644;
        double b2_333655 = x_333654 - y_333652;
        double x_333656 = b_333641 * c_333642;
        double y_333657 = a_333640 * d_333643;
        double c2_333658 = x_333656 - y_333657;
        double x_333659 = a_333640 * a12_333647;
        double y_333660 = b_333641 * b12_333650;
        double x_333661 = x_333659 + y_333660;
        double y_333662 = c_333642 * c12_333653;
        double y_333663 = x_333661 + y_333662;
        double det_333664 = 1.0 / y_333663;
        double a12_333665 = a12_333647 * det_333664;
        double b12_333666 = b12_333650 * det_333664;
        double c12_333667 = c12_333653 * det_333664;
        double b2_333668 = b2_333655 * det_333664;
        double c2_333669 = c2_333658 * det_333664;
        double defunc_2_reduce_res_333670;
        double defunc_2_reduce_res_333671;
        int64_t flat_tid_333974 = (int64_t) 0;
        int32_t num_tasks_334052;
        
        defunc_2_reduce_res_333670 = 0.0;
        defunc_2_reduce_res_333671 = 0.0;
        
        struct futhark_mc_task_338886 futhark_mc_task_338886;
        
        futhark_mc_task_338886.ctx = ctx;
        futhark_mc_task_338886.free_n_292675 = n_292675;
        futhark_mc_task_338886.free_gtid_308238 = gtid_308238;
        futhark_mc_task_338886.free_x_308243 = x_308243;
        futhark_mc_task_338886.free_mem_312636 = mem_312636.mem;
        futhark_mc_task_338886.free_mem_315840 = mem_315840.mem;
        futhark_mc_task_338886.free_mem_315843 = mem_315843.mem;
        futhark_mc_task_338886.free_x_333591 = x_333591;
        futhark_mc_task_338886.free_x_333592 = x_333592;
        futhark_mc_task_338886.free_defunc_0_g_res_333595 =
            defunc_0_g_res_333595;
        futhark_mc_task_338886.free_a12_333665 = a12_333665;
        futhark_mc_task_338886.free_b12_333666 = b12_333666;
        futhark_mc_task_338886.free_c12_333667 = c12_333667;
        futhark_mc_task_338886.free_b2_333668 = b2_333668;
        futhark_mc_task_338886.free_c2_333669 = c2_333669;
        futhark_mc_task_338886.retval_defunc_2_reduce_res_333670 =
            &defunc_2_reduce_res_333670;
        futhark_mc_task_338886.retval_defunc_2_reduce_res_333671 =
            &defunc_2_reduce_res_333671;
        
        struct scheduler_segop futhark_mc_task_338886_task;
        
        futhark_mc_task_338886_task.args = &futhark_mc_task_338886;
        futhark_mc_task_338886_task.top_level_fn =
            futhark_mc_segred_task_338887;
        futhark_mc_task_338886_task.name = "futhark_mc_segred_task_338887";
        futhark_mc_task_338886_task.iterations = q_t_292679;
        futhark_mc_task_338886_task.task_time =
            &ctx->futhark_mc_segred_task_338887_total_time;
        futhark_mc_task_338886_task.task_iter =
            &ctx->futhark_mc_segred_task_338887_total_iter;
        futhark_mc_task_338886_task.sched = STATIC;
        futhark_mc_task_338886_task.nested_fn = NULL;
        
        int futhark_mc_segred_task_338887_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_338886_task);
        
        if (futhark_mc_segred_task_338887_err != 0) {
            ;
            err = futhark_mc_segred_task_338887_err;
            goto cleanup;
        }
        ((double *) mem_315846.mem)[gtid_333590] = defunc_2_reduce_res_333670;
        ((double *) mem_315849.mem)[gtid_333590] = defunc_2_reduce_res_333671;
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338876_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338876_end -
                 futhark_mc_segmap_parloop_338876_start;
        
        ctx->futhark_mc_segmap_parloop_338876_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338876_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338876_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_nested_task_338874(void *args, int64_t iterations,
                                         int tid, struct scheduler_info info)
{
    int err = 0;
    int flat_tid_333589 = tid;
    int num_tasks_333850 = info.nsubtasks;
    struct futhark_mc_task_338870 *futhark_mc_task_338870 =
                                  (struct futhark_mc_task_338870 *) args;
    struct futhark_context *ctx = futhark_mc_task_338870->ctx;
    uint64_t futhark_mc_segmap_nested_task_338874_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_nested_task_338874_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338870->free_n_292675;
    int64_t q_t_292679 = futhark_mc_task_338870->free_q_t_292679;
    int64_t jump_t_292685 = futhark_mc_task_338870->free_jump_t_292685;
    int64_t t_n_m_292839 = futhark_mc_task_338870->free_t_n_m_292839;
    int64_t i_292846 = futhark_mc_task_338870->free_i_292846;
    int64_t gtid_308238 = futhark_mc_task_338870->free_gtid_308238;
    int64_t x_308243 = futhark_mc_task_338870->free_x_308243;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_task_338870->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_313143 = {.desc ="mem_313143", .mem =
                                  futhark_mc_task_338870->free_mem_313143,
                                  .size =0, .references =NULL};
    struct memblock mem_313147 = {.desc ="mem_313147", .mem =
                                  futhark_mc_task_338870->free_mem_313147,
                                  .size =0, .references =NULL};
    struct memblock mem_315840 = {.desc ="mem_315840", .mem =
                                  futhark_mc_task_338870->free_mem_315840,
                                  .size =0, .references =NULL};
    struct memblock mem_315843 = {.desc ="mem_315843", .mem =
                                  futhark_mc_task_338870->free_mem_315843,
                                  .size =0, .references =NULL};
    struct memblock mem_315846 = {.desc ="mem_315846", .mem =
                                  futhark_mc_task_338870->free_mem_315846,
                                  .size =0, .references =NULL};
    struct memblock mem_315849 = {.desc ="mem_315849", .mem =
                                  futhark_mc_task_338870->free_mem_315849,
                                  .size =0, .references =NULL};
    int64_t iter_333934;
    struct futhark_mc_segmap_parloop_struct_338875
    futhark_mc_segmap_parloop_struct_338875;
    
    futhark_mc_segmap_parloop_struct_338875.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338875.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_338875.free_q_t_292679 = q_t_292679;
    futhark_mc_segmap_parloop_struct_338875.free_jump_t_292685 = jump_t_292685;
    futhark_mc_segmap_parloop_struct_338875.free_t_n_m_292839 = t_n_m_292839;
    futhark_mc_segmap_parloop_struct_338875.free_i_292846 = i_292846;
    futhark_mc_segmap_parloop_struct_338875.free_gtid_308238 = gtid_308238;
    futhark_mc_segmap_parloop_struct_338875.free_x_308243 = x_308243;
    futhark_mc_segmap_parloop_struct_338875.free_mem_312636 = mem_312636.mem;
    futhark_mc_segmap_parloop_struct_338875.free_mem_313143 = mem_313143.mem;
    futhark_mc_segmap_parloop_struct_338875.free_mem_313147 = mem_313147.mem;
    futhark_mc_segmap_parloop_struct_338875.free_mem_315840 = mem_315840.mem;
    futhark_mc_segmap_parloop_struct_338875.free_mem_315843 = mem_315843.mem;
    futhark_mc_segmap_parloop_struct_338875.free_mem_315846 = mem_315846.mem;
    futhark_mc_segmap_parloop_struct_338875.free_mem_315849 = mem_315849.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338876_task;
    
    futhark_mc_segmap_parloop_338876_task.name =
        "futhark_mc_segmap_parloop_338876";
    futhark_mc_segmap_parloop_338876_task.fn = futhark_mc_segmap_parloop_338876;
    futhark_mc_segmap_parloop_338876_task.args =
        &futhark_mc_segmap_parloop_struct_338875;
    futhark_mc_segmap_parloop_338876_task.iterations = iterations;
    futhark_mc_segmap_parloop_338876_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338876_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338876_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338876_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338876_task);
    
    if (futhark_mc_segmap_parloop_338876_err != 0) {
        err = futhark_mc_segmap_parloop_338876_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338876_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338876_total_end -
                 futhark_mc_segmap_parloop_338876_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338876_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338876_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338876_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_nested_task_338874_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_nested_task_338874_end -
                 futhark_mc_segmap_nested_task_338874_start;
        
        ctx->futhark_mc_segmap_nested_task_338874_runs[tid]++;
        ctx->futhark_mc_segmap_nested_task_338874_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_nested_task_338874_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
static int futhark_mc_segmap_parloop_338856(void *args, int64_t start,
                                            int64_t end, int flat_tid_308237,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338855
    *futhark_mc_segmap_parloop_struct_338855 =
    (struct futhark_mc_segmap_parloop_struct_338855 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338855->ctx;
    uint64_t futhark_mc_segmap_parloop_338856_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338856_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_338855->free_n_292675;
    int64_t q_t_292679 =
            futhark_mc_segmap_parloop_struct_338855->free_q_t_292679;
    int64_t jump_t_292685 =
            futhark_mc_segmap_parloop_struct_338855->free_jump_t_292685;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_338855->free_partition_sizze_292766;
    int64_t t_n_m_292839 =
            futhark_mc_segmap_parloop_struct_338855->free_t_n_m_292839;
    int64_t i_292846 = futhark_mc_segmap_parloop_struct_338855->free_i_292846;
    struct memblock mem_312593 = {.desc ="mem_312593", .mem =
                                  futhark_mc_segmap_parloop_struct_338855->free_mem_312593,
                                  .size =0, .references =NULL};
    int64_t bytes_312598 =
            futhark_mc_segmap_parloop_struct_338855->free_bytes_312598;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_segmap_parloop_struct_338855->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_312639 = {.desc ="mem_312639", .mem =
                                  futhark_mc_segmap_parloop_struct_338855->free_mem_312639,
                                  .size =0, .references =NULL};
    int64_t bytes_313090 =
            futhark_mc_segmap_parloop_struct_338855->free_bytes_313090;
    struct memblock mem_313143 = {.desc ="mem_313143", .mem =
                                  futhark_mc_segmap_parloop_struct_338855->free_mem_313143,
                                  .size =0, .references =NULL};
    struct memblock mem_313147 = {.desc ="mem_313147", .mem =
                                  futhark_mc_segmap_parloop_struct_338855->free_mem_313147,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_segmap_parloop_struct_338855->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_segmap_parloop_struct_338855->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_segmap_parloop_struct_338855->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_segmap_parloop_struct_338855->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315656 = {.desc ="mem_315656", .mem =
                                  futhark_mc_segmap_parloop_struct_338855->free_mem_315656,
                                  .size =0, .references =NULL};
    struct memblock mem_315928 = {.desc ="mem_315928", .mem =
                                  futhark_mc_segmap_parloop_struct_338855->free_mem_315928,
                                  .size =0, .references =NULL};
    struct memblock mem_315932 = {.desc ="mem_315932", .mem =
                                  futhark_mc_segmap_parloop_struct_338855->free_mem_315932,
                                  .size =0, .references =NULL};
    size_t mem_315837_cached_sizze_338857 = 0;
    unsigned char *mem_315837 = NULL;
    size_t mem_315840_cached_sizze_338858 = 0;
    unsigned char *mem_315840 = NULL;
    size_t mem_315843_cached_sizze_338859 = 0;
    unsigned char *mem_315843 = NULL;
    size_t mem_315846_cached_sizze_338860 = 0;
    unsigned char *mem_315846 = NULL;
    size_t mem_315849_cached_sizze_338861 = 0;
    unsigned char *mem_315849 = NULL;
    int64_t iterations = end - start;
    int64_t iter_333568 = start;
    
    if (mem_315837_cached_sizze_338857 < (size_t) bytes_312598) {
        mem_315837 = realloc(mem_315837, bytes_312598);
        mem_315837_cached_sizze_338857 = bytes_312598;
    }
    if (mem_315840_cached_sizze_338858 < (size_t) bytes_312598) {
        mem_315840 = realloc(mem_315840, bytes_312598);
        mem_315840_cached_sizze_338858 = bytes_312598;
    }
    if (mem_315843_cached_sizze_338859 < (size_t) bytes_312598) {
        mem_315843 = realloc(mem_315843, bytes_312598);
        mem_315843_cached_sizze_338859 = bytes_312598;
    }
    if (mem_315846_cached_sizze_338860 < (size_t) bytes_313090) {
        mem_315846 = realloc(mem_315846, bytes_313090);
        mem_315846_cached_sizze_338860 = bytes_313090;
    }
    if (mem_315849_cached_sizze_338861 < (size_t) bytes_313090) {
        mem_315849 = realloc(mem_315849, bytes_313090);
        mem_315849_cached_sizze_338861 = bytes_313090;
    }
    for (; iter_333568 < end; iter_333568++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_333832 = partition_sizze_292766;
        int64_t gtid_308238 = iter_333568;
        int64_t remnant_333833 = iter_333568 - gtid_308238;
        int64_t x_308243;
        
        x_308243 = ((int64_t *) mem_312639.mem)[gtid_308238];
        
        int64_t flat_tid_333569 = (int64_t) 0;
        int32_t num_tasks_333834;
        struct futhark_mc_task_338862 futhark_mc_task_338862;
        
        futhark_mc_task_338862.ctx = ctx;
        futhark_mc_task_338862.free_n_292675 = n_292675;
        futhark_mc_task_338862.free_gtid_308238 = gtid_308238;
        futhark_mc_task_338862.free_mem_312593 = mem_312593.mem;
        futhark_mc_task_338862.free_mem_315656 = mem_315656.mem;
        futhark_mc_task_338862.free_mem_315837 = mem_315837;
        
        struct scheduler_segop futhark_mc_task_338862_task;
        
        futhark_mc_task_338862_task.args = &futhark_mc_task_338862;
        futhark_mc_task_338862_task.top_level_fn =
            futhark_mc_segmap_task_338863;
        futhark_mc_task_338862_task.name = "futhark_mc_segmap_task_338863";
        futhark_mc_task_338862_task.iterations = n_292675;
        futhark_mc_task_338862_task.task_time =
            &ctx->futhark_mc_segmap_task_338863_total_time;
        futhark_mc_task_338862_task.task_iter =
            &ctx->futhark_mc_segmap_task_338863_total_iter;
        futhark_mc_task_338862_task.sched = STATIC;
        futhark_mc_task_338862_task.nested_fn = NULL;
        
        int futhark_mc_segmap_task_338863_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_338862_task);
        
        if (futhark_mc_segmap_task_338863_err != 0) {
            ;
            err = futhark_mc_segmap_task_338863_err;
            goto cleanup;
        }
        
        int64_t flat_tid_333575 = (int64_t) 0;
        int32_t num_tasks_333838;
        struct futhark_mc_task_338866 futhark_mc_task_338866;
        
        futhark_mc_task_338866.ctx = ctx;
        futhark_mc_task_338866.free_n_292675 = n_292675;
        futhark_mc_task_338866.free_gtid_308238 = gtid_308238;
        futhark_mc_task_338866.free_mem_312636 = mem_312636.mem;
        futhark_mc_task_338866.free_ctx_param_ext_313174 = ctx_param_ext_313174;
        futhark_mc_task_338866.free_ctx_param_ext_313175 = ctx_param_ext_313175;
        futhark_mc_task_338866.free_ctx_param_ext_313177 = ctx_param_ext_313177;
        futhark_mc_task_338866.free_mem_param_313179 = mem_param_313179.mem;
        futhark_mc_task_338866.free_mem_315837 = mem_315837;
        futhark_mc_task_338866.free_mem_315840 = mem_315840;
        futhark_mc_task_338866.free_mem_315843 = mem_315843;
        
        struct scheduler_segop futhark_mc_task_338866_task;
        
        futhark_mc_task_338866_task.args = &futhark_mc_task_338866;
        futhark_mc_task_338866_task.top_level_fn =
            futhark_mc_segmap_task_338867;
        futhark_mc_task_338866_task.name = "futhark_mc_segmap_task_338867";
        futhark_mc_task_338866_task.iterations = n_292675;
        futhark_mc_task_338866_task.task_time =
            &ctx->futhark_mc_segmap_task_338867_total_time;
        futhark_mc_task_338866_task.task_iter =
            &ctx->futhark_mc_segmap_task_338867_total_iter;
        futhark_mc_task_338866_task.sched = STATIC;
        futhark_mc_task_338866_task.nested_fn = NULL;
        
        int futhark_mc_segmap_task_338867_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_338866_task);
        
        if (futhark_mc_segmap_task_338867_err != 0) {
            ;
            err = futhark_mc_segmap_task_338867_err;
            goto cleanup;
        }
        
        int64_t flat_tid_333715 = (int64_t) 0;
        int32_t num_tasks_333850;
        int64_t flat_tid_333589 = (int64_t) 0;
        struct futhark_mc_task_338870 futhark_mc_task_338870;
        
        futhark_mc_task_338870.ctx = ctx;
        futhark_mc_task_338870.free_n_292675 = n_292675;
        futhark_mc_task_338870.free_q_t_292679 = q_t_292679;
        futhark_mc_task_338870.free_jump_t_292685 = jump_t_292685;
        futhark_mc_task_338870.free_t_n_m_292839 = t_n_m_292839;
        futhark_mc_task_338870.free_i_292846 = i_292846;
        futhark_mc_task_338870.free_gtid_308238 = gtid_308238;
        futhark_mc_task_338870.free_x_308243 = x_308243;
        futhark_mc_task_338870.free_mem_312636 = mem_312636.mem;
        futhark_mc_task_338870.free_mem_313143 = mem_313143.mem;
        futhark_mc_task_338870.free_mem_313147 = mem_313147.mem;
        futhark_mc_task_338870.free_mem_315840 = mem_315840;
        futhark_mc_task_338870.free_mem_315843 = mem_315843;
        futhark_mc_task_338870.free_mem_315846 = mem_315846;
        futhark_mc_task_338870.free_mem_315849 = mem_315849;
        
        struct scheduler_segop futhark_mc_task_338870_task;
        
        futhark_mc_task_338870_task.args = &futhark_mc_task_338870;
        futhark_mc_task_338870_task.top_level_fn =
            futhark_mc_segmap_task_338871;
        futhark_mc_task_338870_task.name = "futhark_mc_segmap_task_338871";
        futhark_mc_task_338870_task.iterations = t_n_m_292839;
        futhark_mc_task_338870_task.task_time =
            &ctx->futhark_mc_segmap_task_338871_total_time;
        futhark_mc_task_338870_task.task_iter =
            &ctx->futhark_mc_segmap_task_338871_total_iter;
        futhark_mc_task_338870_task.sched = STATIC;
        futhark_mc_task_338870_task.nested_fn =
            futhark_mc_segmap_nested_task_338874;
        
        int futhark_mc_segmap_task_338871_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_338870_task);
        
        if (futhark_mc_segmap_task_338871_err != 0) {
            ;
            err = futhark_mc_segmap_task_338871_err;
            goto cleanup;
        }
        if (t_n_m_292839 * (int64_t) 8 > 0)
            memmove(mem_315928.mem + gtid_308238 * t_n_m_292839 * (int64_t) 8,
                    mem_315846 + (int64_t) 0, t_n_m_292839 * (int64_t) 8);
        if (t_n_m_292839 * (int64_t) 8 > 0)
            memmove(mem_315932.mem + gtid_308238 * t_n_m_292839 * (int64_t) 8,
                    mem_315849 + (int64_t) 0, t_n_m_292839 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_315837);
    free(mem_315840);
    free(mem_315843);
    free(mem_315846);
    free(mem_315849);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338856_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338856_end -
                 futhark_mc_segmap_parloop_338856_start;
        
        ctx->futhark_mc_segmap_parloop_338856_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338856_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338856_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_nested_task_338854(void *args, int64_t iterations,
                                         int tid, struct scheduler_info info)
{
    int err = 0;
    int flat_tid_308237 = tid;
    int num_tasks_333408 = info.nsubtasks;
    struct futhark_mc_task_338845 *futhark_mc_task_338845 =
                                  (struct futhark_mc_task_338845 *) args;
    struct futhark_context *ctx = futhark_mc_task_338845->ctx;
    uint64_t futhark_mc_segmap_nested_task_338854_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_nested_task_338854_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338845->free_n_292675;
    int64_t q_t_292679 = futhark_mc_task_338845->free_q_t_292679;
    int64_t jump_t_292685 = futhark_mc_task_338845->free_jump_t_292685;
    int64_t partition_sizze_292766 =
            futhark_mc_task_338845->free_partition_sizze_292766;
    int64_t t_n_m_292839 = futhark_mc_task_338845->free_t_n_m_292839;
    int64_t i_292846 = futhark_mc_task_338845->free_i_292846;
    struct memblock mem_312593 = {.desc ="mem_312593", .mem =
                                  futhark_mc_task_338845->free_mem_312593,
                                  .size =0, .references =NULL};
    int64_t bytes_312598 = futhark_mc_task_338845->free_bytes_312598;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_task_338845->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_312639 = {.desc ="mem_312639", .mem =
                                  futhark_mc_task_338845->free_mem_312639,
                                  .size =0, .references =NULL};
    int64_t bytes_313090 = futhark_mc_task_338845->free_bytes_313090;
    struct memblock mem_313143 = {.desc ="mem_313143", .mem =
                                  futhark_mc_task_338845->free_mem_313143,
                                  .size =0, .references =NULL};
    struct memblock mem_313147 = {.desc ="mem_313147", .mem =
                                  futhark_mc_task_338845->free_mem_313147,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_task_338845->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_task_338845->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_task_338845->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_task_338845->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315656 = {.desc ="mem_315656", .mem =
                                  futhark_mc_task_338845->free_mem_315656,
                                  .size =0, .references =NULL};
    struct memblock mem_315928 = {.desc ="mem_315928", .mem =
                                  futhark_mc_task_338845->free_mem_315928,
                                  .size =0, .references =NULL};
    struct memblock mem_315932 = {.desc ="mem_315932", .mem =
                                  futhark_mc_task_338845->free_mem_315932,
                                  .size =0, .references =NULL};
    int64_t iter_333568;
    struct futhark_mc_segmap_parloop_struct_338855
    futhark_mc_segmap_parloop_struct_338855;
    
    futhark_mc_segmap_parloop_struct_338855.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338855.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_338855.free_q_t_292679 = q_t_292679;
    futhark_mc_segmap_parloop_struct_338855.free_jump_t_292685 = jump_t_292685;
    futhark_mc_segmap_parloop_struct_338855.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_338855.free_t_n_m_292839 = t_n_m_292839;
    futhark_mc_segmap_parloop_struct_338855.free_i_292846 = i_292846;
    futhark_mc_segmap_parloop_struct_338855.free_mem_312593 = mem_312593.mem;
    futhark_mc_segmap_parloop_struct_338855.free_bytes_312598 = bytes_312598;
    futhark_mc_segmap_parloop_struct_338855.free_mem_312636 = mem_312636.mem;
    futhark_mc_segmap_parloop_struct_338855.free_mem_312639 = mem_312639.mem;
    futhark_mc_segmap_parloop_struct_338855.free_bytes_313090 = bytes_313090;
    futhark_mc_segmap_parloop_struct_338855.free_mem_313143 = mem_313143.mem;
    futhark_mc_segmap_parloop_struct_338855.free_mem_313147 = mem_313147.mem;
    futhark_mc_segmap_parloop_struct_338855.free_ctx_param_ext_313174 =
        ctx_param_ext_313174;
    futhark_mc_segmap_parloop_struct_338855.free_ctx_param_ext_313175 =
        ctx_param_ext_313175;
    futhark_mc_segmap_parloop_struct_338855.free_ctx_param_ext_313177 =
        ctx_param_ext_313177;
    futhark_mc_segmap_parloop_struct_338855.free_mem_param_313179 =
        mem_param_313179.mem;
    futhark_mc_segmap_parloop_struct_338855.free_mem_315656 = mem_315656.mem;
    futhark_mc_segmap_parloop_struct_338855.free_mem_315928 = mem_315928.mem;
    futhark_mc_segmap_parloop_struct_338855.free_mem_315932 = mem_315932.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338856_task;
    
    futhark_mc_segmap_parloop_338856_task.name =
        "futhark_mc_segmap_parloop_338856";
    futhark_mc_segmap_parloop_338856_task.fn = futhark_mc_segmap_parloop_338856;
    futhark_mc_segmap_parloop_338856_task.args =
        &futhark_mc_segmap_parloop_struct_338855;
    futhark_mc_segmap_parloop_338856_task.iterations = iterations;
    futhark_mc_segmap_parloop_338856_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338856_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338856_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338856_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338856_task);
    
    if (futhark_mc_segmap_parloop_338856_err != 0) {
        err = futhark_mc_segmap_parloop_338856_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338856_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338856_total_end -
                 futhark_mc_segmap_parloop_338856_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338856_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338856_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338856_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_nested_task_338854_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_nested_task_338854_end -
                 futhark_mc_segmap_nested_task_338854_start;
        
        ctx->futhark_mc_segmap_nested_task_338854_runs[tid]++;
        ctx->futhark_mc_segmap_nested_task_338854_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_nested_task_338854_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_task_338892 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_t_292679;
    int64_t free_jump_t_292685;
    int64_t free_partition_sizze_292766;
    int64_t free_t_n_m_292839;
    int64_t free_i_292846;
    unsigned char *free_mem_312593;
    int64_t free_bytes_312598;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_312639;
    int64_t free_bytes_313090;
    unsigned char *free_mem_313143;
    unsigned char *free_mem_313147;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315656;
    int64_t free_bytes_315951;
    unsigned char *free_mem_316049;
};
struct futhark_mc_segmap_parloop_struct_338894 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_t_292679;
    int64_t free_jump_t_292685;
    int64_t free_partition_sizze_292766;
    int64_t free_t_n_m_292839;
    int64_t free_i_292846;
    unsigned char *free_mem_312593;
    int64_t free_bytes_312598;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_312639;
    int64_t free_bytes_313090;
    unsigned char *free_mem_313143;
    unsigned char *free_mem_313147;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315656;
    int64_t free_bytes_315951;
    unsigned char *free_mem_316049;
};
static int futhark_mc_segmap_parloop_338895(void *args, int64_t start,
                                            int64_t end, int flat_tid_308525,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338894
    *futhark_mc_segmap_parloop_struct_338894 =
    (struct futhark_mc_segmap_parloop_struct_338894 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338894->ctx;
    uint64_t futhark_mc_segmap_parloop_338895_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338895_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_338894->free_n_292675;
    int64_t q_t_292679 =
            futhark_mc_segmap_parloop_struct_338894->free_q_t_292679;
    int64_t jump_t_292685 =
            futhark_mc_segmap_parloop_struct_338894->free_jump_t_292685;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_338894->free_partition_sizze_292766;
    int64_t t_n_m_292839 =
            futhark_mc_segmap_parloop_struct_338894->free_t_n_m_292839;
    int64_t i_292846 = futhark_mc_segmap_parloop_struct_338894->free_i_292846;
    struct memblock mem_312593 = {.desc ="mem_312593", .mem =
                                  futhark_mc_segmap_parloop_struct_338894->free_mem_312593,
                                  .size =0, .references =NULL};
    int64_t bytes_312598 =
            futhark_mc_segmap_parloop_struct_338894->free_bytes_312598;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_segmap_parloop_struct_338894->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_312639 = {.desc ="mem_312639", .mem =
                                  futhark_mc_segmap_parloop_struct_338894->free_mem_312639,
                                  .size =0, .references =NULL};
    int64_t bytes_313090 =
            futhark_mc_segmap_parloop_struct_338894->free_bytes_313090;
    struct memblock mem_313143 = {.desc ="mem_313143", .mem =
                                  futhark_mc_segmap_parloop_struct_338894->free_mem_313143,
                                  .size =0, .references =NULL};
    struct memblock mem_313147 = {.desc ="mem_313147", .mem =
                                  futhark_mc_segmap_parloop_struct_338894->free_mem_313147,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_segmap_parloop_struct_338894->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_segmap_parloop_struct_338894->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_segmap_parloop_struct_338894->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_segmap_parloop_struct_338894->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315656 = {.desc ="mem_315656", .mem =
                                  futhark_mc_segmap_parloop_struct_338894->free_mem_315656,
                                  .size =0, .references =NULL};
    int64_t bytes_315951 =
            futhark_mc_segmap_parloop_struct_338894->free_bytes_315951;
    struct memblock mem_316049 = {.desc ="mem_316049", .mem =
                                  futhark_mc_segmap_parloop_struct_338894->free_mem_316049,
                                  .size =0, .references =NULL};
    size_t mem_315973_cached_sizze_338896 = 0;
    unsigned char *mem_315973 = NULL;
    size_t mem_315988_cached_sizze_338897 = 0;
    unsigned char *mem_315988 = NULL;
    size_t mem_315991_cached_sizze_338898 = 0;
    unsigned char *mem_315991 = NULL;
    size_t mem_316018_cached_sizze_338899 = 0;
    unsigned char *mem_316018 = NULL;
    size_t mem_316028_cached_sizze_338900 = 0;
    unsigned char *mem_316028 = NULL;
    int64_t iterations = end - start;
    int64_t iter_334070 = start;
    
    if (mem_315973_cached_sizze_338896 < (size_t) bytes_312598) {
        mem_315973 = realloc(mem_315973, bytes_312598);
        mem_315973_cached_sizze_338896 = bytes_312598;
    }
    if (mem_315988_cached_sizze_338897 < (size_t) bytes_312598) {
        mem_315988 = realloc(mem_315988, bytes_312598);
        mem_315988_cached_sizze_338897 = bytes_312598;
    }
    if (mem_315991_cached_sizze_338898 < (size_t) bytes_312598) {
        mem_315991 = realloc(mem_315991, bytes_312598);
        mem_315991_cached_sizze_338898 = bytes_312598;
    }
    if (mem_316018_cached_sizze_338899 < (size_t) bytes_313090) {
        mem_316018 = realloc(mem_316018, bytes_313090);
        mem_316018_cached_sizze_338899 = bytes_313090;
    }
    if (mem_316028_cached_sizze_338900 < (size_t) bytes_315951) {
        mem_316028 = realloc(mem_316028, bytes_315951);
        mem_316028_cached_sizze_338900 = bytes_315951;
    }
    for (; iter_334070 < end; iter_334070++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_334142 = partition_sizze_292766;
        int64_t gtid_308526 = iter_334070;
        int64_t remnant_334143 = iter_334070 - gtid_308526;
        int64_t x_296204;
        
        x_296204 = ((int64_t *) mem_312639.mem)[gtid_308526];
        for (int64_t i_334071 = 0; i_334071 < n_292675; i_334071++) {
            float x_334073;
            
            x_334073 = ((float *) mem_312593.mem)[gtid_308526 * n_292675 +
                                                  i_334071];
            
            double x_334074;
            
            x_334074 = ((double *) mem_315656.mem)[gtid_308526 * n_292675 +
                                                   i_334071];
            
            double f32_res_334075 = fpconv_f32_f64(x_334073);
            double defunc_1_f_res_334076 = f32_res_334075 - x_334074;
            
            ((double *) mem_315973)[i_334071] = defunc_1_f_res_334076;
        }
        for (int64_t i_334078 = 0; i_334078 < n_292675; i_334078++) {
            int64_t x_334081;
            
            x_334081 = ((int64_t *) mem_312636.mem)[gtid_308526 * n_292675 +
                                                    i_334078];
            
            bool cond_334082 = sle64((int64_t) 0, x_334081);
            double defunc_0_f_res_334083;
            
            if (cond_334082) {
                bool y_334084 = slt64(x_334081, n_292675);
                bool bounds_check_334085 = cond_334082 && y_334084;
                bool index_certs_334086;
                
                if (!bounds_check_334085) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [", (long long) x_334081,
                                  "] out of bounds for array of shape [",
                                  (long long) n_292675, "].",
                                  "-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:45:43-70\n   #3  stl.fut:285:33-58\n   #4  /prelude/soacs.fut:75:22-28\n   #5  /prelude/soacs.fut:75:3-45\n   #6  stl.fut:283:13-288:41\n   #7  stl.fut:419:61-435:77\n   #8  stl.fut:463:3-479:36\n   #9  stl.fut:445:1-479:36\n");
                    err = FUTHARK_PROGRAM_ERROR;
                    goto cleanup;
                }
                
                double defunc_0_f_res_t_res_334087;
                
                defunc_0_f_res_t_res_334087 = ((double *) mem_315973)[x_334081];
                defunc_0_f_res_334083 = defunc_0_f_res_t_res_334087;
            } else {
                defunc_0_f_res_334083 = 0.0;
            }
            
            double defunc_0_f_res_334088;
            
            if (cond_334082) {
                bool y_334089 = slt64(x_334081, n_292675);
                bool bounds_check_334090 = cond_334082 && y_334089;
                bool index_certs_334091;
                
                if (!bounds_check_334090) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [", (long long) x_334081,
                                  "] out of bounds for array of shape [",
                                  (long long) n_292675, "].",
                                  "-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:45:43-70\n   #3  stl.fut:286:33-64\n   #4  /prelude/soacs.fut:75:22-28\n   #5  /prelude/soacs.fut:75:3-45\n   #6  stl.fut:283:13-288:41\n   #7  stl.fut:419:61-435:77\n   #8  stl.fut:463:3-479:36\n   #9  stl.fut:445:1-479:36\n");
                    err = FUTHARK_PROGRAM_ERROR;
                    goto cleanup;
                }
                
                double defunc_0_f_res_t_res_334092;
                
                defunc_0_f_res_t_res_334092 =
                    ((double *) mem_param_313179.mem)[ctx_param_ext_313174 +
                                                      (gtid_308526 *
                                                       ctx_param_ext_313175 +
                                                       x_334081 *
                                                       ctx_param_ext_313177)];
                defunc_0_f_res_334088 = defunc_0_f_res_t_res_334092;
            } else {
                defunc_0_f_res_334088 = 0.0;
            }
            ((double *) mem_315988)[i_334078] = defunc_0_f_res_334088;
            ((double *) mem_315991)[i_334078] = defunc_0_f_res_334083;
        }
        for (int64_t i_334095 = 0; i_334095 < t_n_m_292839; i_334095++) {
            int64_t x_334097;
            
            x_334097 = ((int64_t *) mem_313143.mem)[gtid_308526 * t_n_m_292839 +
                                                    i_334095];
            
            double x_334098;
            
            x_334098 = ((double *) mem_313147.mem)[gtid_308526 * t_n_m_292839 +
                                                   i_334095];
            
            int64_t min_arg_334099 = mul64(jump_t_292685, i_334095);
            int64_t min_res_334100 = smin64(i_292846, min_arg_334099);
            int64_t defunc_0_g_res_334101 = add64((int64_t) 1, min_res_334100);
            double defunc_2_reduce_res_334103;
            double redout_334106 = 0.0;
            
            for (int64_t i_334105 = 0; i_334105 < q_t_292679; i_334105++) {
                bool cond_334108 = sle64(x_296204, i_334105);
                int64_t defunc_0_f_res_334109;
                
                if (cond_334108) {
                    defunc_0_f_res_334109 = (int64_t) 0;
                } else {
                    int64_t i_334110 = add64(x_334097, i_334105);
                    int64_t defunc_0_add_arg_334111;
                    
                    defunc_0_add_arg_334111 =
                        ((int64_t *) mem_312636.mem)[gtid_308526 * n_292675 +
                                                     i_334110];
                    
                    int64_t defunc_1_add_res_334112 = add64((int64_t) 1,
                                                            defunc_0_add_arg_334111);
                    
                    defunc_0_f_res_334109 = defunc_1_add_res_334112;
                }
                
                double defunc_0_f_res_334113;
                
                if (cond_334108) {
                    defunc_0_f_res_334113 = 0.0;
                } else {
                    int64_t i_334114 = add64(x_334097, i_334105);
                    double defunc_0_add_arg_334115;
                    
                    defunc_0_add_arg_334115 = ((double *) mem_315988)[i_334114];
                    defunc_0_f_res_334113 = defunc_0_add_arg_334115;
                }
                
                int64_t binop_p_334116 = sub64(defunc_0_f_res_334109,
                                               defunc_0_g_res_334101);
                double defunc_0_f_res_334117 = sitofp_i64_f64(binop_p_334116);
                double abs_res_334118 = fabs(defunc_0_f_res_334117);
                double tmp1_334119 = abs_res_334118 / x_334098;
                double x_334120 = tmp1_334119 * tmp1_334119;
                double y_334121 = tmp1_334119 * x_334120;
                double tmp2_334122 = 1.0 - y_334121;
                double x_334123 = tmp2_334122 * tmp2_334122;
                double tmp3_334124 = tmp2_334122 * x_334123;
                double tmp4_334125 = defunc_0_f_res_334113 * tmp3_334124;
                double defunc_1_op_res_334126 = tmp4_334125 + redout_334106;
                
                ((double *) mem_316028)[i_334105] = tmp4_334125;
                
                double redout_tmp_334148 = defunc_1_op_res_334126;
                
                redout_334106 = redout_tmp_334148;
            }
            defunc_2_reduce_res_334103 = redout_334106;
            
            double a_334128 = 2.220446049250313e-16 +
                   defunc_2_reduce_res_334103;
            double a0_334129 = 1.0 / a_334128;
            double defunc_2_reduce_res_334130;
            double redout_334132 = 0.0;
            
            for (int64_t i_334131 = 0; i_334131 < q_t_292679; i_334131++) {
                double x_334133;
                
                x_334133 = ((double *) mem_316028)[i_334131];
                
                bool cond_334134 = sle64(x_296204, i_334131);
                double defunc_0_f_res_334135;
                
                if (cond_334134) {
                    defunc_0_f_res_334135 = 0.0;
                } else {
                    int64_t i_334136 = add64(x_334097, i_334131);
                    double defunc_0_add_arg_334137;
                    
                    defunc_0_add_arg_334137 = ((double *) mem_315991)[i_334136];
                    defunc_0_f_res_334135 = defunc_0_add_arg_334137;
                }
                
                double x_334138 = a0_334129 * x_334133;
                double defunc_9_fit_fun_res_334139 = defunc_0_f_res_334135 *
                       x_334138;
                double defunc_1_op_res_334140 = defunc_9_fit_fun_res_334139 +
                       redout_334132;
                double redout_tmp_334150 = defunc_1_op_res_334140;
                
                redout_334132 = redout_tmp_334150;
            }
            defunc_2_reduce_res_334130 = redout_334132;
            ((double *) mem_316018)[i_334095] = defunc_2_reduce_res_334130;
        }
        if (t_n_m_292839 * (int64_t) 8 > 0)
            memmove(mem_316049.mem + gtid_308526 * t_n_m_292839 * (int64_t) 8,
                    mem_316018 + (int64_t) 0, t_n_m_292839 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_315973);
    free(mem_315988);
    free(mem_315991);
    free(mem_316018);
    free(mem_316028);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338895_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338895_end -
                 futhark_mc_segmap_parloop_338895_start;
        
        ctx->futhark_mc_segmap_parloop_338895_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338895_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338895_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_338893(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_308525 = tid;
    int num_tasks_334069 = info.nsubtasks;
    struct futhark_mc_task_338892 *futhark_mc_task_338892 =
                                  (struct futhark_mc_task_338892 *) args;
    struct futhark_context *ctx = futhark_mc_task_338892->ctx;
    uint64_t futhark_mc_segmap_task_338893_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_338893_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338892->free_n_292675;
    int64_t q_t_292679 = futhark_mc_task_338892->free_q_t_292679;
    int64_t jump_t_292685 = futhark_mc_task_338892->free_jump_t_292685;
    int64_t partition_sizze_292766 =
            futhark_mc_task_338892->free_partition_sizze_292766;
    int64_t t_n_m_292839 = futhark_mc_task_338892->free_t_n_m_292839;
    int64_t i_292846 = futhark_mc_task_338892->free_i_292846;
    struct memblock mem_312593 = {.desc ="mem_312593", .mem =
                                  futhark_mc_task_338892->free_mem_312593,
                                  .size =0, .references =NULL};
    int64_t bytes_312598 = futhark_mc_task_338892->free_bytes_312598;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_task_338892->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_312639 = {.desc ="mem_312639", .mem =
                                  futhark_mc_task_338892->free_mem_312639,
                                  .size =0, .references =NULL};
    int64_t bytes_313090 = futhark_mc_task_338892->free_bytes_313090;
    struct memblock mem_313143 = {.desc ="mem_313143", .mem =
                                  futhark_mc_task_338892->free_mem_313143,
                                  .size =0, .references =NULL};
    struct memblock mem_313147 = {.desc ="mem_313147", .mem =
                                  futhark_mc_task_338892->free_mem_313147,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_task_338892->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_task_338892->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_task_338892->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_task_338892->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315656 = {.desc ="mem_315656", .mem =
                                  futhark_mc_task_338892->free_mem_315656,
                                  .size =0, .references =NULL};
    int64_t bytes_315951 = futhark_mc_task_338892->free_bytes_315951;
    struct memblock mem_316049 = {.desc ="mem_316049", .mem =
                                  futhark_mc_task_338892->free_mem_316049,
                                  .size =0, .references =NULL};
    int64_t iter_334070;
    struct futhark_mc_segmap_parloop_struct_338894
    futhark_mc_segmap_parloop_struct_338894;
    
    futhark_mc_segmap_parloop_struct_338894.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338894.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_338894.free_q_t_292679 = q_t_292679;
    futhark_mc_segmap_parloop_struct_338894.free_jump_t_292685 = jump_t_292685;
    futhark_mc_segmap_parloop_struct_338894.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_338894.free_t_n_m_292839 = t_n_m_292839;
    futhark_mc_segmap_parloop_struct_338894.free_i_292846 = i_292846;
    futhark_mc_segmap_parloop_struct_338894.free_mem_312593 = mem_312593.mem;
    futhark_mc_segmap_parloop_struct_338894.free_bytes_312598 = bytes_312598;
    futhark_mc_segmap_parloop_struct_338894.free_mem_312636 = mem_312636.mem;
    futhark_mc_segmap_parloop_struct_338894.free_mem_312639 = mem_312639.mem;
    futhark_mc_segmap_parloop_struct_338894.free_bytes_313090 = bytes_313090;
    futhark_mc_segmap_parloop_struct_338894.free_mem_313143 = mem_313143.mem;
    futhark_mc_segmap_parloop_struct_338894.free_mem_313147 = mem_313147.mem;
    futhark_mc_segmap_parloop_struct_338894.free_ctx_param_ext_313174 =
        ctx_param_ext_313174;
    futhark_mc_segmap_parloop_struct_338894.free_ctx_param_ext_313175 =
        ctx_param_ext_313175;
    futhark_mc_segmap_parloop_struct_338894.free_ctx_param_ext_313177 =
        ctx_param_ext_313177;
    futhark_mc_segmap_parloop_struct_338894.free_mem_param_313179 =
        mem_param_313179.mem;
    futhark_mc_segmap_parloop_struct_338894.free_mem_315656 = mem_315656.mem;
    futhark_mc_segmap_parloop_struct_338894.free_bytes_315951 = bytes_315951;
    futhark_mc_segmap_parloop_struct_338894.free_mem_316049 = mem_316049.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338895_task;
    
    futhark_mc_segmap_parloop_338895_task.name =
        "futhark_mc_segmap_parloop_338895";
    futhark_mc_segmap_parloop_338895_task.fn = futhark_mc_segmap_parloop_338895;
    futhark_mc_segmap_parloop_338895_task.args =
        &futhark_mc_segmap_parloop_struct_338894;
    futhark_mc_segmap_parloop_338895_task.iterations = iterations;
    futhark_mc_segmap_parloop_338895_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338895_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338895_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338895_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338895_task);
    
    if (futhark_mc_segmap_parloop_338895_err != 0) {
        err = futhark_mc_segmap_parloop_338895_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338895_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338895_total_end -
                 futhark_mc_segmap_parloop_338895_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338895_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338895_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338895_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_338893_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_338893_end -
                 futhark_mc_segmap_task_338893_start;
        
        ctx->futhark_mc_segmap_task_338893_runs[tid]++;
        ctx->futhark_mc_segmap_task_338893_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_338893_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_segmap_parloop_struct_338902 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_t_292679;
    int64_t free_jump_t_292685;
    int64_t free_partition_sizze_292766;
    int64_t free_t_n_m_292839;
    int64_t free_i_292846;
    unsigned char *free_mem_312593;
    int64_t free_bytes_312598;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_312639;
    int64_t free_bytes_313090;
    unsigned char *free_mem_313143;
    unsigned char *free_mem_313147;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315656;
    int64_t free_bytes_315951;
    unsigned char *free_mem_316049;
};
struct futhark_mc_task_338908 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_308592;
    unsigned char *free_mem_312593;
    unsigned char *free_mem_315656;
    unsigned char *free_mem_315943;
};
struct futhark_mc_segmap_parloop_struct_338910 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_308592;
    unsigned char *free_mem_312593;
    unsigned char *free_mem_315656;
    unsigned char *free_mem_315943;
};
static int futhark_mc_segmap_parloop_338911(void *args, int64_t start,
                                            int64_t end, int flat_tid_334152,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338910
    *futhark_mc_segmap_parloop_struct_338910 =
    (struct futhark_mc_segmap_parloop_struct_338910 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338910->ctx;
    uint64_t futhark_mc_segmap_parloop_338911_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338911_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_338910->free_n_292675;
    int64_t gtid_308592 =
            futhark_mc_segmap_parloop_struct_338910->free_gtid_308592;
    struct memblock mem_312593 = {.desc ="mem_312593", .mem =
                                  futhark_mc_segmap_parloop_struct_338910->free_mem_312593,
                                  .size =0, .references =NULL};
    struct memblock mem_315656 = {.desc ="mem_315656", .mem =
                                  futhark_mc_segmap_parloop_struct_338910->free_mem_315656,
                                  .size =0, .references =NULL};
    struct memblock mem_315943 = {.desc ="mem_315943", .mem =
                                  futhark_mc_segmap_parloop_struct_338910->free_mem_315943,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_334270 = start;
    
    for (; iter_334270 < end; iter_334270++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_334271 = n_292675;
        int64_t gtid_334153 = iter_334270;
        int64_t remnant_334272 = iter_334270 - gtid_334153;
        float x_334154;
        
        x_334154 = ((float *) mem_312593.mem)[gtid_308592 * n_292675 +
                                              gtid_334153];
        
        double x_334155;
        
        x_334155 = ((double *) mem_315656.mem)[gtid_308592 * n_292675 +
                                               gtid_334153];
        
        double f32_res_334156 = fpconv_f32_f64(x_334154);
        double defunc_1_f_res_334157 = f32_res_334156 - x_334155;
        
        ((double *) mem_315943.mem)[gtid_334153] = defunc_1_f_res_334157;
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338911_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338911_end -
                 futhark_mc_segmap_parloop_338911_start;
        
        ctx->futhark_mc_segmap_parloop_338911_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338911_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338911_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_338909(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_334152 = tid;
    int num_tasks_334269 = info.nsubtasks;
    struct futhark_mc_task_338908 *futhark_mc_task_338908 =
                                  (struct futhark_mc_task_338908 *) args;
    struct futhark_context *ctx = futhark_mc_task_338908->ctx;
    uint64_t futhark_mc_segmap_task_338909_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_338909_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338908->free_n_292675;
    int64_t gtid_308592 = futhark_mc_task_338908->free_gtid_308592;
    struct memblock mem_312593 = {.desc ="mem_312593", .mem =
                                  futhark_mc_task_338908->free_mem_312593,
                                  .size =0, .references =NULL};
    struct memblock mem_315656 = {.desc ="mem_315656", .mem =
                                  futhark_mc_task_338908->free_mem_315656,
                                  .size =0, .references =NULL};
    struct memblock mem_315943 = {.desc ="mem_315943", .mem =
                                  futhark_mc_task_338908->free_mem_315943,
                                  .size =0, .references =NULL};
    int64_t iter_334270;
    struct futhark_mc_segmap_parloop_struct_338910
    futhark_mc_segmap_parloop_struct_338910;
    
    futhark_mc_segmap_parloop_struct_338910.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338910.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_338910.free_gtid_308592 = gtid_308592;
    futhark_mc_segmap_parloop_struct_338910.free_mem_312593 = mem_312593.mem;
    futhark_mc_segmap_parloop_struct_338910.free_mem_315656 = mem_315656.mem;
    futhark_mc_segmap_parloop_struct_338910.free_mem_315943 = mem_315943.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338911_task;
    
    futhark_mc_segmap_parloop_338911_task.name =
        "futhark_mc_segmap_parloop_338911";
    futhark_mc_segmap_parloop_338911_task.fn = futhark_mc_segmap_parloop_338911;
    futhark_mc_segmap_parloop_338911_task.args =
        &futhark_mc_segmap_parloop_struct_338910;
    futhark_mc_segmap_parloop_338911_task.iterations = iterations;
    futhark_mc_segmap_parloop_338911_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338911_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338911_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338911_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338911_task);
    
    if (futhark_mc_segmap_parloop_338911_err != 0) {
        err = futhark_mc_segmap_parloop_338911_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338911_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338911_total_end -
                 futhark_mc_segmap_parloop_338911_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338911_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338911_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338911_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_338909_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_338909_end -
                 futhark_mc_segmap_task_338909_start;
        
        ctx->futhark_mc_segmap_task_338909_runs[tid]++;
        ctx->futhark_mc_segmap_task_338909_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_338909_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_task_338912 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_308592;
    unsigned char *free_mem_312636;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315943;
    unsigned char *free_mem_315946;
    unsigned char *free_mem_315949;
};
struct futhark_mc_segmap_parloop_struct_338914 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_308592;
    unsigned char *free_mem_312636;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315943;
    unsigned char *free_mem_315946;
    unsigned char *free_mem_315949;
};
static int futhark_mc_segmap_parloop_338915(void *args, int64_t start,
                                            int64_t end, int flat_tid_334158,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338914
    *futhark_mc_segmap_parloop_struct_338914 =
    (struct futhark_mc_segmap_parloop_struct_338914 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338914->ctx;
    uint64_t futhark_mc_segmap_parloop_338915_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338915_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_338914->free_n_292675;
    int64_t gtid_308592 =
            futhark_mc_segmap_parloop_struct_338914->free_gtid_308592;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_segmap_parloop_struct_338914->free_mem_312636,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_segmap_parloop_struct_338914->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_segmap_parloop_struct_338914->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_segmap_parloop_struct_338914->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_segmap_parloop_struct_338914->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315943 = {.desc ="mem_315943", .mem =
                                  futhark_mc_segmap_parloop_struct_338914->free_mem_315943,
                                  .size =0, .references =NULL};
    struct memblock mem_315946 = {.desc ="mem_315946", .mem =
                                  futhark_mc_segmap_parloop_struct_338914->free_mem_315946,
                                  .size =0, .references =NULL};
    struct memblock mem_315949 = {.desc ="mem_315949", .mem =
                                  futhark_mc_segmap_parloop_struct_338914->free_mem_315949,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_334274 = start;
    
    for (; iter_334274 < end; iter_334274++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_334283 = n_292675;
        int64_t gtid_334159 = iter_334274;
        int64_t remnant_334284 = iter_334274 - gtid_334159;
        int64_t x_334160;
        
        x_334160 = ((int64_t *) mem_312636.mem)[gtid_308592 * n_292675 +
                                                gtid_334159];
        
        bool cond_334161 = sle64((int64_t) 0, x_334160);
        double defunc_0_f_res_334162;
        
        if (cond_334161) {
            bool y_334275 = slt64(x_334160, n_292675);
            bool bounds_check_334276 = cond_334161 && y_334275;
            bool index_certs_334277;
            
            if (!bounds_check_334276) {
                ctx->error =
                    msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                              "Index [", (long long) x_334160,
                              "] out of bounds for array of shape [",
                              (long long) n_292675, "].",
                              "-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:45:43-70\n   #3  stl.fut:285:33-58\n   #4  /prelude/soacs.fut:75:22-28\n   #5  /prelude/soacs.fut:75:3-45\n   #6  stl.fut:283:13-288:41\n   #7  stl.fut:419:61-435:77\n   #8  stl.fut:463:3-479:36\n   #9  stl.fut:445:1-479:36\n");
                err = FUTHARK_PROGRAM_ERROR;
                goto cleanup;
            }
            
            double defunc_0_f_res_t_res_334278;
            
            defunc_0_f_res_t_res_334278 = ((double *) mem_315943.mem)[x_334160];
            defunc_0_f_res_334162 = defunc_0_f_res_t_res_334278;
        } else {
            defunc_0_f_res_334162 = 0.0;
        }
        
        double defunc_0_f_res_334167;
        
        if (cond_334161) {
            bool y_334279 = slt64(x_334160, n_292675);
            bool bounds_check_334280 = cond_334161 && y_334279;
            bool index_certs_334281;
            
            if (!bounds_check_334280) {
                ctx->error =
                    msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                              "Index [", (long long) x_334160,
                              "] out of bounds for array of shape [",
                              (long long) n_292675, "].",
                              "-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:45:43-70\n   #3  stl.fut:286:33-64\n   #4  /prelude/soacs.fut:75:22-28\n   #5  /prelude/soacs.fut:75:3-45\n   #6  stl.fut:283:13-288:41\n   #7  stl.fut:419:61-435:77\n   #8  stl.fut:463:3-479:36\n   #9  stl.fut:445:1-479:36\n");
                err = FUTHARK_PROGRAM_ERROR;
                goto cleanup;
            }
            
            double defunc_0_f_res_t_res_334282;
            
            defunc_0_f_res_t_res_334282 =
                ((double *) mem_param_313179.mem)[ctx_param_ext_313174 +
                                                  (gtid_308592 *
                                                   ctx_param_ext_313175 +
                                                   x_334160 *
                                                   ctx_param_ext_313177)];
            defunc_0_f_res_334167 = defunc_0_f_res_t_res_334282;
        } else {
            defunc_0_f_res_334167 = 0.0;
        }
        ((double *) mem_315946.mem)[gtid_334159] = defunc_0_f_res_334167;
        ((double *) mem_315949.mem)[gtid_334159] = defunc_0_f_res_334162;
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338915_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338915_end -
                 futhark_mc_segmap_parloop_338915_start;
        
        ctx->futhark_mc_segmap_parloop_338915_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338915_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338915_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_338913(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_334158 = tid;
    int num_tasks_334273 = info.nsubtasks;
    struct futhark_mc_task_338912 *futhark_mc_task_338912 =
                                  (struct futhark_mc_task_338912 *) args;
    struct futhark_context *ctx = futhark_mc_task_338912->ctx;
    uint64_t futhark_mc_segmap_task_338913_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_338913_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338912->free_n_292675;
    int64_t gtid_308592 = futhark_mc_task_338912->free_gtid_308592;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_task_338912->free_mem_312636,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_task_338912->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_task_338912->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_task_338912->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_task_338912->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315943 = {.desc ="mem_315943", .mem =
                                  futhark_mc_task_338912->free_mem_315943,
                                  .size =0, .references =NULL};
    struct memblock mem_315946 = {.desc ="mem_315946", .mem =
                                  futhark_mc_task_338912->free_mem_315946,
                                  .size =0, .references =NULL};
    struct memblock mem_315949 = {.desc ="mem_315949", .mem =
                                  futhark_mc_task_338912->free_mem_315949,
                                  .size =0, .references =NULL};
    int64_t iter_334274;
    struct futhark_mc_segmap_parloop_struct_338914
    futhark_mc_segmap_parloop_struct_338914;
    
    futhark_mc_segmap_parloop_struct_338914.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338914.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_338914.free_gtid_308592 = gtid_308592;
    futhark_mc_segmap_parloop_struct_338914.free_mem_312636 = mem_312636.mem;
    futhark_mc_segmap_parloop_struct_338914.free_ctx_param_ext_313174 =
        ctx_param_ext_313174;
    futhark_mc_segmap_parloop_struct_338914.free_ctx_param_ext_313175 =
        ctx_param_ext_313175;
    futhark_mc_segmap_parloop_struct_338914.free_ctx_param_ext_313177 =
        ctx_param_ext_313177;
    futhark_mc_segmap_parloop_struct_338914.free_mem_param_313179 =
        mem_param_313179.mem;
    futhark_mc_segmap_parloop_struct_338914.free_mem_315943 = mem_315943.mem;
    futhark_mc_segmap_parloop_struct_338914.free_mem_315946 = mem_315946.mem;
    futhark_mc_segmap_parloop_struct_338914.free_mem_315949 = mem_315949.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338915_task;
    
    futhark_mc_segmap_parloop_338915_task.name =
        "futhark_mc_segmap_parloop_338915";
    futhark_mc_segmap_parloop_338915_task.fn = futhark_mc_segmap_parloop_338915;
    futhark_mc_segmap_parloop_338915_task.args =
        &futhark_mc_segmap_parloop_struct_338914;
    futhark_mc_segmap_parloop_338915_task.iterations = iterations;
    futhark_mc_segmap_parloop_338915_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338915_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338915_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338915_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338915_task);
    
    if (futhark_mc_segmap_parloop_338915_err != 0) {
        err = futhark_mc_segmap_parloop_338915_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338915_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338915_total_end -
                 futhark_mc_segmap_parloop_338915_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338915_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338915_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338915_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_338913_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_338913_end -
                 futhark_mc_segmap_task_338913_start;
        
        ctx->futhark_mc_segmap_task_338913_runs[tid]++;
        ctx->futhark_mc_segmap_task_338913_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_338913_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_task_338916 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_t_292679;
    int64_t free_jump_t_292685;
    int64_t free_t_n_m_292839;
    int64_t free_i_292846;
    int64_t free_gtid_308592;
    int64_t free_x_308597;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_313143;
    unsigned char *free_mem_313147;
    unsigned char *free_mem_315946;
    unsigned char *free_mem_315949;
    int64_t free_bytes_315951;
    unsigned char *free_mem_315970;
};
struct futhark_mc_segmap_parloop_struct_338918 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_t_292679;
    int64_t free_jump_t_292685;
    int64_t free_t_n_m_292839;
    int64_t free_i_292846;
    int64_t free_gtid_308592;
    int64_t free_x_308597;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_313143;
    unsigned char *free_mem_313147;
    unsigned char *free_mem_315946;
    unsigned char *free_mem_315949;
    int64_t free_bytes_315951;
    unsigned char *free_mem_315970;
};
static int futhark_mc_segmap_parloop_338919(void *args, int64_t start,
                                            int64_t end, int flat_tid_334220,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338918
    *futhark_mc_segmap_parloop_struct_338918 =
    (struct futhark_mc_segmap_parloop_struct_338918 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338918->ctx;
    uint64_t futhark_mc_segmap_parloop_338919_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338919_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_338918->free_n_292675;
    int64_t q_t_292679 =
            futhark_mc_segmap_parloop_struct_338918->free_q_t_292679;
    int64_t jump_t_292685 =
            futhark_mc_segmap_parloop_struct_338918->free_jump_t_292685;
    int64_t t_n_m_292839 =
            futhark_mc_segmap_parloop_struct_338918->free_t_n_m_292839;
    int64_t i_292846 = futhark_mc_segmap_parloop_struct_338918->free_i_292846;
    int64_t gtid_308592 =
            futhark_mc_segmap_parloop_struct_338918->free_gtid_308592;
    int64_t x_308597 = futhark_mc_segmap_parloop_struct_338918->free_x_308597;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_segmap_parloop_struct_338918->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_313143 = {.desc ="mem_313143", .mem =
                                  futhark_mc_segmap_parloop_struct_338918->free_mem_313143,
                                  .size =0, .references =NULL};
    struct memblock mem_313147 = {.desc ="mem_313147", .mem =
                                  futhark_mc_segmap_parloop_struct_338918->free_mem_313147,
                                  .size =0, .references =NULL};
    struct memblock mem_315946 = {.desc ="mem_315946", .mem =
                                  futhark_mc_segmap_parloop_struct_338918->free_mem_315946,
                                  .size =0, .references =NULL};
    struct memblock mem_315949 = {.desc ="mem_315949", .mem =
                                  futhark_mc_segmap_parloop_struct_338918->free_mem_315949,
                                  .size =0, .references =NULL};
    int64_t bytes_315951 =
            futhark_mc_segmap_parloop_struct_338918->free_bytes_315951;
    struct memblock mem_315970 = {.desc ="mem_315970", .mem =
                                  futhark_mc_segmap_parloop_struct_338918->free_mem_315970,
                                  .size =0, .references =NULL};
    size_t mem_334227_cached_sizze_338920 = 0;
    unsigned char *mem_334227 = NULL;
    int64_t iterations = end - start;
    int64_t iter_334286 = start;
    
    if (mem_334227_cached_sizze_338920 < (size_t) bytes_315951) {
        mem_334227 = realloc(mem_334227, bytes_315951);
        mem_334227_cached_sizze_338920 = bytes_315951;
    }
    for (; iter_334286 < end; iter_334286++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_334320 = t_n_m_292839;
        int64_t gtid_334221 = iter_334286;
        int64_t remnant_334321 = iter_334286 - gtid_334221;
        int64_t x_334222;
        
        x_334222 = ((int64_t *) mem_313143.mem)[gtid_308592 * t_n_m_292839 +
                                                gtid_334221];
        
        double x_334223;
        
        x_334223 = ((double *) mem_313147.mem)[gtid_308592 * t_n_m_292839 +
                                               gtid_334221];
        
        int64_t min_arg_334224 = mul64(jump_t_292685, gtid_334221);
        int64_t min_res_334225 = smin64(i_292846, min_arg_334224);
        int64_t defunc_0_g_res_334226 = add64((int64_t) 1, min_res_334225);
        double defunc_2_reduce_res_334229;
        double redout_334288 = 0.0;
        
        for (int64_t i_334287 = 0; i_334287 < q_t_292679; i_334287++) {
            bool cond_334290 = sle64(x_308597, i_334287);
            int64_t defunc_0_f_res_334291;
            
            if (cond_334290) {
                defunc_0_f_res_334291 = (int64_t) 0;
            } else {
                int64_t i_334292 = add64(x_334222, i_334287);
                int64_t defunc_0_add_arg_334293;
                
                defunc_0_add_arg_334293 =
                    ((int64_t *) mem_312636.mem)[gtid_308592 * n_292675 +
                                                 i_334292];
                
                int64_t defunc_1_add_res_334294 = add64((int64_t) 1,
                                                        defunc_0_add_arg_334293);
                
                defunc_0_f_res_334291 = defunc_1_add_res_334294;
            }
            
            double defunc_0_f_res_334295;
            
            if (cond_334290) {
                defunc_0_f_res_334295 = 0.0;
            } else {
                int64_t i_334296 = add64(x_334222, i_334287);
                double defunc_0_add_arg_334297;
                
                defunc_0_add_arg_334297 = ((double *) mem_315946.mem)[i_334296];
                defunc_0_f_res_334295 = defunc_0_add_arg_334297;
            }
            
            int64_t binop_p_334298 = sub64(defunc_0_f_res_334291,
                                           defunc_0_g_res_334226);
            double defunc_0_f_res_334299 = sitofp_i64_f64(binop_p_334298);
            double abs_res_334300 = fabs(defunc_0_f_res_334299);
            double tmp1_334301 = abs_res_334300 / x_334223;
            double x_334302 = tmp1_334301 * tmp1_334301;
            double y_334303 = tmp1_334301 * x_334302;
            double tmp2_334304 = 1.0 - y_334303;
            double x_334305 = tmp2_334304 * tmp2_334304;
            double tmp3_334306 = tmp2_334304 * x_334305;
            double tmp4_334307 = defunc_0_f_res_334295 * tmp3_334306;
            double defunc_1_op_res_334308 = tmp4_334307 + redout_334288;
            
            ((double *) mem_334227)[i_334287] = tmp4_334307;
            
            double redout_tmp_334322 = defunc_1_op_res_334308;
            
            redout_334288 = redout_tmp_334322;
        }
        defunc_2_reduce_res_334229 = redout_334288;
        
        double a_334254 = 2.220446049250313e-16 + defunc_2_reduce_res_334229;
        double a0_334255 = 1.0 / a_334254;
        double defunc_2_reduce_res_334256;
        double redout_334311 = 0.0;
        
        for (int64_t i_334310 = 0; i_334310 < q_t_292679; i_334310++) {
            double x_334312;
            
            x_334312 = ((double *) mem_334227)[i_334310];
            
            bool cond_334313 = sle64(x_308597, i_334310);
            double defunc_0_f_res_334314;
            
            if (cond_334313) {
                defunc_0_f_res_334314 = 0.0;
            } else {
                int64_t i_334315 = add64(x_334222, i_334310);
                double defunc_0_add_arg_334316;
                
                defunc_0_add_arg_334316 = ((double *) mem_315949.mem)[i_334315];
                defunc_0_f_res_334314 = defunc_0_add_arg_334316;
            }
            
            double x_334317 = a0_334255 * x_334312;
            double defunc_9_fit_fun_res_334318 = defunc_0_f_res_334314 *
                   x_334317;
            double defunc_1_op_res_334319 = defunc_9_fit_fun_res_334318 +
                   redout_334311;
            double redout_tmp_334324 = defunc_1_op_res_334319;
            
            redout_334311 = redout_tmp_334324;
        }
        defunc_2_reduce_res_334256 = redout_334311;
        ((double *) mem_315970.mem)[gtid_334221] = defunc_2_reduce_res_334256;
    }
    
  cleanup:
    { }
    free(mem_334227);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338919_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338919_end -
                 futhark_mc_segmap_parloop_338919_start;
        
        ctx->futhark_mc_segmap_parloop_338919_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338919_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338919_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_338917(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_334220 = tid;
    int num_tasks_334285 = info.nsubtasks;
    struct futhark_mc_task_338916 *futhark_mc_task_338916 =
                                  (struct futhark_mc_task_338916 *) args;
    struct futhark_context *ctx = futhark_mc_task_338916->ctx;
    uint64_t futhark_mc_segmap_task_338917_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_338917_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338916->free_n_292675;
    int64_t q_t_292679 = futhark_mc_task_338916->free_q_t_292679;
    int64_t jump_t_292685 = futhark_mc_task_338916->free_jump_t_292685;
    int64_t t_n_m_292839 = futhark_mc_task_338916->free_t_n_m_292839;
    int64_t i_292846 = futhark_mc_task_338916->free_i_292846;
    int64_t gtid_308592 = futhark_mc_task_338916->free_gtid_308592;
    int64_t x_308597 = futhark_mc_task_338916->free_x_308597;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_task_338916->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_313143 = {.desc ="mem_313143", .mem =
                                  futhark_mc_task_338916->free_mem_313143,
                                  .size =0, .references =NULL};
    struct memblock mem_313147 = {.desc ="mem_313147", .mem =
                                  futhark_mc_task_338916->free_mem_313147,
                                  .size =0, .references =NULL};
    struct memblock mem_315946 = {.desc ="mem_315946", .mem =
                                  futhark_mc_task_338916->free_mem_315946,
                                  .size =0, .references =NULL};
    struct memblock mem_315949 = {.desc ="mem_315949", .mem =
                                  futhark_mc_task_338916->free_mem_315949,
                                  .size =0, .references =NULL};
    int64_t bytes_315951 = futhark_mc_task_338916->free_bytes_315951;
    struct memblock mem_315970 = {.desc ="mem_315970", .mem =
                                  futhark_mc_task_338916->free_mem_315970,
                                  .size =0, .references =NULL};
    int64_t iter_334286;
    struct futhark_mc_segmap_parloop_struct_338918
    futhark_mc_segmap_parloop_struct_338918;
    
    futhark_mc_segmap_parloop_struct_338918.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338918.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_338918.free_q_t_292679 = q_t_292679;
    futhark_mc_segmap_parloop_struct_338918.free_jump_t_292685 = jump_t_292685;
    futhark_mc_segmap_parloop_struct_338918.free_t_n_m_292839 = t_n_m_292839;
    futhark_mc_segmap_parloop_struct_338918.free_i_292846 = i_292846;
    futhark_mc_segmap_parloop_struct_338918.free_gtid_308592 = gtid_308592;
    futhark_mc_segmap_parloop_struct_338918.free_x_308597 = x_308597;
    futhark_mc_segmap_parloop_struct_338918.free_mem_312636 = mem_312636.mem;
    futhark_mc_segmap_parloop_struct_338918.free_mem_313143 = mem_313143.mem;
    futhark_mc_segmap_parloop_struct_338918.free_mem_313147 = mem_313147.mem;
    futhark_mc_segmap_parloop_struct_338918.free_mem_315946 = mem_315946.mem;
    futhark_mc_segmap_parloop_struct_338918.free_mem_315949 = mem_315949.mem;
    futhark_mc_segmap_parloop_struct_338918.free_bytes_315951 = bytes_315951;
    futhark_mc_segmap_parloop_struct_338918.free_mem_315970 = mem_315970.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338919_task;
    
    futhark_mc_segmap_parloop_338919_task.name =
        "futhark_mc_segmap_parloop_338919";
    futhark_mc_segmap_parloop_338919_task.fn = futhark_mc_segmap_parloop_338919;
    futhark_mc_segmap_parloop_338919_task.args =
        &futhark_mc_segmap_parloop_struct_338918;
    futhark_mc_segmap_parloop_338919_task.iterations = iterations;
    futhark_mc_segmap_parloop_338919_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338919_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338919_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338919_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338919_task);
    
    if (futhark_mc_segmap_parloop_338919_err != 0) {
        err = futhark_mc_segmap_parloop_338919_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338919_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338919_total_end -
                 futhark_mc_segmap_parloop_338919_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338919_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338919_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338919_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_338917_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_338917_end -
                 futhark_mc_segmap_task_338917_start;
        
        ctx->futhark_mc_segmap_task_338917_runs[tid]++;
        ctx->futhark_mc_segmap_task_338917_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_338917_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_segmap_parloop_struct_338922 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_t_292679;
    int64_t free_jump_t_292685;
    int64_t free_t_n_m_292839;
    int64_t free_i_292846;
    int64_t free_gtid_308592;
    int64_t free_x_308597;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_313143;
    unsigned char *free_mem_313147;
    unsigned char *free_mem_315946;
    unsigned char *free_mem_315949;
    int64_t free_bytes_315951;
    unsigned char *free_mem_315970;
};
struct futhark_mc_task_338925 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_308592;
    int64_t free_x_308597;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_315946;
    int64_t free_x_334174;
    double free_x_334175;
    int64_t free_defunc_0_g_res_334178;
    double *retval_defunc_2_reduce_res_334180;
    unsigned char *retval_mem_334179;
};
struct futhark_mc_segred_stage_1_parloop_struct_338928 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_308592;
    int64_t free_x_308597;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_315946;
    int64_t free_x_334174;
    double free_x_334175;
    int64_t free_defunc_0_g_res_334178;
    unsigned char *free_mem_334179;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_334364;
};
static int futhark_mc_segred_stage_1_parloop_338929(void *args, int64_t start,
                                                    int64_t end,
                                                    int flat_tid_334326,
                                                    int tid)
{
    int err = 0;
    struct futhark_mc_segred_stage_1_parloop_struct_338928
    *futhark_mc_segred_stage_1_parloop_struct_338928 =
    (struct futhark_mc_segred_stage_1_parloop_struct_338928 *) args;
    struct futhark_context *ctx =
                           futhark_mc_segred_stage_1_parloop_struct_338928->ctx;
    uint64_t futhark_mc_segred_stage_1_parloop_338929_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_338929_start = get_wall_time();
    
    int64_t n_292675 =
            futhark_mc_segred_stage_1_parloop_struct_338928->free_n_292675;
    int64_t gtid_308592 =
            futhark_mc_segred_stage_1_parloop_struct_338928->free_gtid_308592;
    int64_t x_308597 =
            futhark_mc_segred_stage_1_parloop_struct_338928->free_x_308597;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_338928->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_315946 = {.desc ="mem_315946", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_338928->free_mem_315946,
                                  .size =0, .references =NULL};
    int64_t x_334174 =
            futhark_mc_segred_stage_1_parloop_struct_338928->free_x_334174;
    double x_334175 =
           futhark_mc_segred_stage_1_parloop_struct_338928->free_x_334175;
    int64_t defunc_0_g_res_334178 =
            futhark_mc_segred_stage_1_parloop_struct_338928->free_defunc_0_g_res_334178;
    struct memblock mem_334179 = {.desc ="mem_334179", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_338928->free_mem_334179,
                                  .size =0, .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_334364 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_334364",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338928->free_reduce_stage_1_tid_res_arr_mem_334364,
                                                             .size =0,
                                                             .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_334366 = start;
    double x_334328;
    double x_334329;
    double local_acc_334367 = 0.0;
    
    for (; iter_334366 < end; iter_334366++) {
        int64_t gtid_334327 = iter_334366;
        bool cond_334331 = sle64(x_308597, gtid_334327);
        int64_t defunc_0_f_res_334332;
        
        if (cond_334331) {
            defunc_0_f_res_334332 = (int64_t) 0;
        } else {
            int64_t i_334333 = add64(x_334174, gtid_334327);
            int64_t defunc_0_add_arg_334334;
            
            defunc_0_add_arg_334334 = ((int64_t *) mem_312636.mem)[gtid_308592 *
                                                                   n_292675 +
                                                                   i_334333];
            
            int64_t defunc_1_add_res_334335 = add64((int64_t) 1,
                                                    defunc_0_add_arg_334334);
            
            defunc_0_f_res_334332 = defunc_1_add_res_334335;
        }
        
        double defunc_0_f_res_334336;
        
        if (cond_334331) {
            defunc_0_f_res_334336 = 0.0;
        } else {
            int64_t i_334337 = add64(x_334174, gtid_334327);
            double defunc_0_add_arg_334338;
            
            defunc_0_add_arg_334338 = ((double *) mem_315946.mem)[i_334337];
            defunc_0_f_res_334336 = defunc_0_add_arg_334338;
        }
        
        int64_t binop_p_334339 = sub64(defunc_0_f_res_334332,
                                       defunc_0_g_res_334178);
        double defunc_0_f_res_334340 = sitofp_i64_f64(binop_p_334339);
        double abs_res_334341 = fabs(defunc_0_f_res_334340);
        double tmp1_334342 = abs_res_334341 / x_334175;
        double x_334343 = tmp1_334342 * tmp1_334342;
        double y_334344 = tmp1_334342 * x_334343;
        double tmp2_334345 = 1.0 - y_334344;
        double x_334346 = tmp2_334345 * tmp2_334345;
        double tmp3_334347 = tmp2_334345 * x_334346;
        double tmp4_334348 = defunc_0_f_res_334336 * tmp3_334347;
        
        // save map-out results
        {
            ((double *) mem_334179.mem)[gtid_334327] = tmp4_334348;
        }
        // Load accum params
        {
            x_334328 = local_acc_334367;
        }
        // Load next params
        {
            x_334329 = tmp4_334348;
        }
        // Red body
        {
            double defunc_1_op_res_334330 = x_334328 + x_334329;
            
            local_acc_334367 = defunc_1_op_res_334330;
        }
    }
    ((double *) reduce_stage_1_tid_res_arr_mem_334364.mem)[flat_tid_334326] =
        local_acc_334367;
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_338929_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_338929_end -
                 futhark_mc_segred_stage_1_parloop_338929_start;
        
        ctx->futhark_mc_segred_stage_1_parloop_338929_runs[tid]++;
        ctx->futhark_mc_segred_stage_1_parloop_338929_total_runtime[tid] +=
            elapsed;
        ctx->futhark_mc_segred_stage_1_parloop_338929_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segred_task_338926(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_334326 = tid;
    int num_tasks_334363 = info.nsubtasks;
    struct futhark_mc_task_338925 *futhark_mc_task_338925 =
                                  (struct futhark_mc_task_338925 *) args;
    struct futhark_context *ctx = futhark_mc_task_338925->ctx;
    uint64_t futhark_mc_segred_task_338926_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_task_338926_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338925->free_n_292675;
    int64_t gtid_308592 = futhark_mc_task_338925->free_gtid_308592;
    int64_t x_308597 = futhark_mc_task_338925->free_x_308597;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_task_338925->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_315946 = {.desc ="mem_315946", .mem =
                                  futhark_mc_task_338925->free_mem_315946,
                                  .size =0, .references =NULL};
    int64_t x_334174 = futhark_mc_task_338925->free_x_334174;
    double x_334175 = futhark_mc_task_338925->free_x_334175;
    int64_t defunc_0_g_res_334178 =
            futhark_mc_task_338925->free_defunc_0_g_res_334178;
    double defunc_2_reduce_res_334180 =
           *futhark_mc_task_338925->retval_defunc_2_reduce_res_334180;
    struct memblock mem_334179 = {.desc ="mem_334179", .mem =
                                  futhark_mc_task_338925->retval_mem_334179,
                                  .size =0, .references =NULL};
    size_t reduce_stage_1_tid_res_arr_mem_334364_cached_sizze_338927 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_334364 = NULL;
    
    if (reduce_stage_1_tid_res_arr_mem_334364_cached_sizze_338927 <
        (size_t) ((int64_t) 8 * num_tasks_334363)) {
        reduce_stage_1_tid_res_arr_mem_334364 =
            realloc(reduce_stage_1_tid_res_arr_mem_334364, (int64_t) 8 *
                    num_tasks_334363);
        reduce_stage_1_tid_res_arr_mem_334364_cached_sizze_338927 =
            (int64_t) 8 * num_tasks_334363;
    }
    
    int64_t iter_334366;
    struct futhark_mc_segred_stage_1_parloop_struct_338928
    futhark_mc_segred_stage_1_parloop_struct_338928;
    
    futhark_mc_segred_stage_1_parloop_struct_338928.ctx = ctx;
    futhark_mc_segred_stage_1_parloop_struct_338928.free_n_292675 = n_292675;
    futhark_mc_segred_stage_1_parloop_struct_338928.free_gtid_308592 =
        gtid_308592;
    futhark_mc_segred_stage_1_parloop_struct_338928.free_x_308597 = x_308597;
    futhark_mc_segred_stage_1_parloop_struct_338928.free_mem_312636 =
        mem_312636.mem;
    futhark_mc_segred_stage_1_parloop_struct_338928.free_mem_315946 =
        mem_315946.mem;
    futhark_mc_segred_stage_1_parloop_struct_338928.free_x_334174 = x_334174;
    futhark_mc_segred_stage_1_parloop_struct_338928.free_x_334175 = x_334175;
    futhark_mc_segred_stage_1_parloop_struct_338928.free_defunc_0_g_res_334178 =
        defunc_0_g_res_334178;
    futhark_mc_segred_stage_1_parloop_struct_338928.free_mem_334179 =
        mem_334179.mem;
    futhark_mc_segred_stage_1_parloop_struct_338928.free_reduce_stage_1_tid_res_arr_mem_334364 =
        reduce_stage_1_tid_res_arr_mem_334364;
    
    struct scheduler_parloop futhark_mc_segred_stage_1_parloop_338929_task;
    
    futhark_mc_segred_stage_1_parloop_338929_task.name =
        "futhark_mc_segred_stage_1_parloop_338929";
    futhark_mc_segred_stage_1_parloop_338929_task.fn =
        futhark_mc_segred_stage_1_parloop_338929;
    futhark_mc_segred_stage_1_parloop_338929_task.args =
        &futhark_mc_segred_stage_1_parloop_struct_338928;
    futhark_mc_segred_stage_1_parloop_338929_task.iterations = iterations;
    futhark_mc_segred_stage_1_parloop_338929_task.info = info;
    
    uint64_t futhark_mc_segred_stage_1_parloop_338929_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_338929_total_start = get_wall_time();
    
    int futhark_mc_segred_stage_1_parloop_338929_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segred_stage_1_parloop_338929_task);
    
    if (futhark_mc_segred_stage_1_parloop_338929_err != 0) {
        err = futhark_mc_segred_stage_1_parloop_338929_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_338929_total_end =
                 get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_338929_total_end -
                 futhark_mc_segred_stage_1_parloop_338929_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338929_total_runs,
                           1, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338929_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338929_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    // neutral-initialise the output
    {
        defunc_2_reduce_res_334180 = 0.0;
    }
    
    double x_334368;
    double x_334369;
    
    for (int32_t i_334371 = 0; i_334371 < num_tasks_334363; i_334371++) {
        flat_tid_334326 = i_334371;
        // Apply main thread reduction
        {
            // load acc params
            {
                x_334368 = defunc_2_reduce_res_334180;
            }
            // load next params
            {
                x_334369 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_334364)[flat_tid_334326];
            }
            // red body
            {
                double defunc_1_op_res_334370 = x_334368 + x_334369;
                
                defunc_2_reduce_res_334180 = defunc_1_op_res_334370;
            }
        }
    }
    
  cleanup:
    {
        free(reduce_stage_1_tid_res_arr_mem_334364);
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_task_338926_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_task_338926_end -
                 futhark_mc_segred_task_338926_start;
        
        ctx->futhark_mc_segred_task_338926_runs[tid]++;
        ctx->futhark_mc_segred_task_338926_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segred_task_338926_iter[tid] += iterations;
    }
    if (err == 0) {
        *futhark_mc_task_338925->retval_defunc_2_reduce_res_334180 =
            defunc_2_reduce_res_334180;
        futhark_mc_task_338925->retval_mem_334179 = mem_334179.mem;
    }
    return err;
}
struct futhark_mc_task_338930 {
    struct futhark_context *ctx;
    int64_t free_x_308597;
    unsigned char *free_mem_315949;
    int64_t free_x_334174;
    unsigned char *free_mem_334179;
    double free_a0_334206;
    double *retval_defunc_2_reduce_res_334207;
};
struct futhark_mc_segred_stage_1_parloop_struct_338933 {
    struct futhark_context *ctx;
    int64_t free_x_308597;
    unsigned char *free_mem_315949;
    int64_t free_x_334174;
    unsigned char *free_mem_334179;
    double free_a0_334206;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_334373;
};
static int futhark_mc_segred_stage_1_parloop_338934(void *args, int64_t start,
                                                    int64_t end,
                                                    int flat_tid_334349,
                                                    int tid)
{
    int err = 0;
    struct futhark_mc_segred_stage_1_parloop_struct_338933
    *futhark_mc_segred_stage_1_parloop_struct_338933 =
    (struct futhark_mc_segred_stage_1_parloop_struct_338933 *) args;
    struct futhark_context *ctx =
                           futhark_mc_segred_stage_1_parloop_struct_338933->ctx;
    uint64_t futhark_mc_segred_stage_1_parloop_338934_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_338934_start = get_wall_time();
    
    int64_t x_308597 =
            futhark_mc_segred_stage_1_parloop_struct_338933->free_x_308597;
    struct memblock mem_315949 = {.desc ="mem_315949", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_338933->free_mem_315949,
                                  .size =0, .references =NULL};
    int64_t x_334174 =
            futhark_mc_segred_stage_1_parloop_struct_338933->free_x_334174;
    struct memblock mem_334179 = {.desc ="mem_334179", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_338933->free_mem_334179,
                                  .size =0, .references =NULL};
    double a0_334206 =
           futhark_mc_segred_stage_1_parloop_struct_338933->free_a0_334206;
    struct memblock reduce_stage_1_tid_res_arr_mem_334373 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_334373",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338933->free_reduce_stage_1_tid_res_arr_mem_334373,
                                                             .size =0,
                                                             .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_334375 = start;
    double x_334351;
    double x_334352;
    double local_acc_334376 = 0.0;
    
    for (; iter_334375 < end; iter_334375++) {
        int64_t gtid_334350 = iter_334375;
        double x_334354;
        
        x_334354 = ((double *) mem_334179.mem)[gtid_334350];
        
        bool cond_334355 = sle64(x_308597, gtid_334350);
        double defunc_0_f_res_334356;
        
        if (cond_334355) {
            defunc_0_f_res_334356 = 0.0;
        } else {
            int64_t i_334357 = add64(x_334174, gtid_334350);
            double defunc_0_add_arg_334358;
            
            defunc_0_add_arg_334358 = ((double *) mem_315949.mem)[i_334357];
            defunc_0_f_res_334356 = defunc_0_add_arg_334358;
        }
        
        double x_334359 = a0_334206 * x_334354;
        double defunc_9_fit_fun_res_334360 = defunc_0_f_res_334356 * x_334359;
        
        // save map-out results
        { }
        // Load accum params
        {
            x_334351 = local_acc_334376;
        }
        // Load next params
        {
            x_334352 = defunc_9_fit_fun_res_334360;
        }
        // Red body
        {
            double defunc_1_op_res_334353 = x_334351 + x_334352;
            
            local_acc_334376 = defunc_1_op_res_334353;
        }
    }
    ((double *) reduce_stage_1_tid_res_arr_mem_334373.mem)[flat_tid_334349] =
        local_acc_334376;
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_338934_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_338934_end -
                 futhark_mc_segred_stage_1_parloop_338934_start;
        
        ctx->futhark_mc_segred_stage_1_parloop_338934_runs[tid]++;
        ctx->futhark_mc_segred_stage_1_parloop_338934_total_runtime[tid] +=
            elapsed;
        ctx->futhark_mc_segred_stage_1_parloop_338934_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segred_task_338931(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_334349 = tid;
    int num_tasks_334372 = info.nsubtasks;
    struct futhark_mc_task_338930 *futhark_mc_task_338930 =
                                  (struct futhark_mc_task_338930 *) args;
    struct futhark_context *ctx = futhark_mc_task_338930->ctx;
    uint64_t futhark_mc_segred_task_338931_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_task_338931_start = get_wall_time();
    
    int64_t x_308597 = futhark_mc_task_338930->free_x_308597;
    struct memblock mem_315949 = {.desc ="mem_315949", .mem =
                                  futhark_mc_task_338930->free_mem_315949,
                                  .size =0, .references =NULL};
    int64_t x_334174 = futhark_mc_task_338930->free_x_334174;
    struct memblock mem_334179 = {.desc ="mem_334179", .mem =
                                  futhark_mc_task_338930->free_mem_334179,
                                  .size =0, .references =NULL};
    double a0_334206 = futhark_mc_task_338930->free_a0_334206;
    double defunc_2_reduce_res_334207 =
           *futhark_mc_task_338930->retval_defunc_2_reduce_res_334207;
    size_t reduce_stage_1_tid_res_arr_mem_334373_cached_sizze_338932 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_334373 = NULL;
    
    if (reduce_stage_1_tid_res_arr_mem_334373_cached_sizze_338932 <
        (size_t) ((int64_t) 8 * num_tasks_334372)) {
        reduce_stage_1_tid_res_arr_mem_334373 =
            realloc(reduce_stage_1_tid_res_arr_mem_334373, (int64_t) 8 *
                    num_tasks_334372);
        reduce_stage_1_tid_res_arr_mem_334373_cached_sizze_338932 =
            (int64_t) 8 * num_tasks_334372;
    }
    
    int64_t iter_334375;
    struct futhark_mc_segred_stage_1_parloop_struct_338933
    futhark_mc_segred_stage_1_parloop_struct_338933;
    
    futhark_mc_segred_stage_1_parloop_struct_338933.ctx = ctx;
    futhark_mc_segred_stage_1_parloop_struct_338933.free_x_308597 = x_308597;
    futhark_mc_segred_stage_1_parloop_struct_338933.free_mem_315949 =
        mem_315949.mem;
    futhark_mc_segred_stage_1_parloop_struct_338933.free_x_334174 = x_334174;
    futhark_mc_segred_stage_1_parloop_struct_338933.free_mem_334179 =
        mem_334179.mem;
    futhark_mc_segred_stage_1_parloop_struct_338933.free_a0_334206 = a0_334206;
    futhark_mc_segred_stage_1_parloop_struct_338933.free_reduce_stage_1_tid_res_arr_mem_334373 =
        reduce_stage_1_tid_res_arr_mem_334373;
    
    struct scheduler_parloop futhark_mc_segred_stage_1_parloop_338934_task;
    
    futhark_mc_segred_stage_1_parloop_338934_task.name =
        "futhark_mc_segred_stage_1_parloop_338934";
    futhark_mc_segred_stage_1_parloop_338934_task.fn =
        futhark_mc_segred_stage_1_parloop_338934;
    futhark_mc_segred_stage_1_parloop_338934_task.args =
        &futhark_mc_segred_stage_1_parloop_struct_338933;
    futhark_mc_segred_stage_1_parloop_338934_task.iterations = iterations;
    futhark_mc_segred_stage_1_parloop_338934_task.info = info;
    
    uint64_t futhark_mc_segred_stage_1_parloop_338934_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_338934_total_start = get_wall_time();
    
    int futhark_mc_segred_stage_1_parloop_338934_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segred_stage_1_parloop_338934_task);
    
    if (futhark_mc_segred_stage_1_parloop_338934_err != 0) {
        err = futhark_mc_segred_stage_1_parloop_338934_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_338934_total_end =
                 get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_338934_total_end -
                 futhark_mc_segred_stage_1_parloop_338934_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338934_total_runs,
                           1, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338934_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338934_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    // neutral-initialise the output
    {
        defunc_2_reduce_res_334207 = 0.0;
    }
    
    double x_334377;
    double x_334378;
    
    for (int32_t i_334380 = 0; i_334380 < num_tasks_334372; i_334380++) {
        flat_tid_334349 = i_334380;
        // Apply main thread reduction
        {
            // load acc params
            {
                x_334377 = defunc_2_reduce_res_334207;
            }
            // load next params
            {
                x_334378 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_334373)[flat_tid_334349];
            }
            // red body
            {
                double defunc_1_op_res_334379 = x_334377 + x_334378;
                
                defunc_2_reduce_res_334207 = defunc_1_op_res_334379;
            }
        }
    }
    
  cleanup:
    {
        free(reduce_stage_1_tid_res_arr_mem_334373);
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_task_338931_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_task_338931_end -
                 futhark_mc_segred_task_338931_start;
        
        ctx->futhark_mc_segred_task_338931_runs[tid]++;
        ctx->futhark_mc_segred_task_338931_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segred_task_338931_iter[tid] += iterations;
    }
    if (err == 0) {
        *futhark_mc_task_338930->retval_defunc_2_reduce_res_334207 =
            defunc_2_reduce_res_334207;
    }
    return err;
}
static int futhark_mc_segmap_parloop_338923(void *args, int64_t start,
                                            int64_t end, int flat_tid_334172,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338922
    *futhark_mc_segmap_parloop_struct_338922 =
    (struct futhark_mc_segmap_parloop_struct_338922 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338922->ctx;
    uint64_t futhark_mc_segmap_parloop_338923_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338923_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_338922->free_n_292675;
    int64_t q_t_292679 =
            futhark_mc_segmap_parloop_struct_338922->free_q_t_292679;
    int64_t jump_t_292685 =
            futhark_mc_segmap_parloop_struct_338922->free_jump_t_292685;
    int64_t t_n_m_292839 =
            futhark_mc_segmap_parloop_struct_338922->free_t_n_m_292839;
    int64_t i_292846 = futhark_mc_segmap_parloop_struct_338922->free_i_292846;
    int64_t gtid_308592 =
            futhark_mc_segmap_parloop_struct_338922->free_gtid_308592;
    int64_t x_308597 = futhark_mc_segmap_parloop_struct_338922->free_x_308597;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_segmap_parloop_struct_338922->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_313143 = {.desc ="mem_313143", .mem =
                                  futhark_mc_segmap_parloop_struct_338922->free_mem_313143,
                                  .size =0, .references =NULL};
    struct memblock mem_313147 = {.desc ="mem_313147", .mem =
                                  futhark_mc_segmap_parloop_struct_338922->free_mem_313147,
                                  .size =0, .references =NULL};
    struct memblock mem_315946 = {.desc ="mem_315946", .mem =
                                  futhark_mc_segmap_parloop_struct_338922->free_mem_315946,
                                  .size =0, .references =NULL};
    struct memblock mem_315949 = {.desc ="mem_315949", .mem =
                                  futhark_mc_segmap_parloop_struct_338922->free_mem_315949,
                                  .size =0, .references =NULL};
    int64_t bytes_315951 =
            futhark_mc_segmap_parloop_struct_338922->free_bytes_315951;
    struct memblock mem_315970 = {.desc ="mem_315970", .mem =
                                  futhark_mc_segmap_parloop_struct_338922->free_mem_315970,
                                  .size =0, .references =NULL};
    size_t mem_334179_cached_sizze_338924 = 0;
    unsigned char *mem_334179 = NULL;
    int64_t iterations = end - start;
    int64_t iter_334325 = start;
    
    if (mem_334179_cached_sizze_338924 < (size_t) bytes_315951) {
        mem_334179 = realloc(mem_334179, bytes_315951);
        mem_334179_cached_sizze_338924 = bytes_315951;
    }
    for (; iter_334325 < end; iter_334325++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_334361 = t_n_m_292839;
        int64_t gtid_334173 = iter_334325;
        int64_t remnant_334362 = iter_334325 - gtid_334173;
        int64_t x_334174;
        
        x_334174 = ((int64_t *) mem_313143.mem)[gtid_308592 * t_n_m_292839 +
                                                gtid_334173];
        
        double x_334175;
        
        x_334175 = ((double *) mem_313147.mem)[gtid_308592 * t_n_m_292839 +
                                               gtid_334173];
        
        int64_t min_arg_334176 = mul64(jump_t_292685, gtid_334173);
        int64_t min_res_334177 = smin64(i_292846, min_arg_334176);
        int64_t defunc_0_g_res_334178 = add64((int64_t) 1, min_res_334177);
        double defunc_2_reduce_res_334180;
        int64_t flat_tid_334326 = (int64_t) 0;
        int32_t num_tasks_334363;
        
        defunc_2_reduce_res_334180 = 0.0;
        
        struct futhark_mc_task_338925 futhark_mc_task_338925;
        
        futhark_mc_task_338925.ctx = ctx;
        futhark_mc_task_338925.free_n_292675 = n_292675;
        futhark_mc_task_338925.free_gtid_308592 = gtid_308592;
        futhark_mc_task_338925.free_x_308597 = x_308597;
        futhark_mc_task_338925.free_mem_312636 = mem_312636.mem;
        futhark_mc_task_338925.free_mem_315946 = mem_315946.mem;
        futhark_mc_task_338925.free_x_334174 = x_334174;
        futhark_mc_task_338925.free_x_334175 = x_334175;
        futhark_mc_task_338925.free_defunc_0_g_res_334178 =
            defunc_0_g_res_334178;
        futhark_mc_task_338925.retval_defunc_2_reduce_res_334180 =
            &defunc_2_reduce_res_334180;
        futhark_mc_task_338925.retval_mem_334179 = mem_334179;
        
        struct scheduler_segop futhark_mc_task_338925_task;
        
        futhark_mc_task_338925_task.args = &futhark_mc_task_338925;
        futhark_mc_task_338925_task.top_level_fn =
            futhark_mc_segred_task_338926;
        futhark_mc_task_338925_task.name = "futhark_mc_segred_task_338926";
        futhark_mc_task_338925_task.iterations = q_t_292679;
        futhark_mc_task_338925_task.task_time =
            &ctx->futhark_mc_segred_task_338926_total_time;
        futhark_mc_task_338925_task.task_iter =
            &ctx->futhark_mc_segred_task_338926_total_iter;
        futhark_mc_task_338925_task.sched = STATIC;
        futhark_mc_task_338925_task.nested_fn = NULL;
        
        int futhark_mc_segred_task_338926_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_338925_task);
        
        if (futhark_mc_segred_task_338926_err != 0) {
            ;
            err = futhark_mc_segred_task_338926_err;
            goto cleanup;
        }
        
        double a_334205 = 2.220446049250313e-16 + defunc_2_reduce_res_334180;
        double a0_334206 = 1.0 / a_334205;
        double defunc_2_reduce_res_334207;
        int64_t flat_tid_334349 = (int64_t) 0;
        int32_t num_tasks_334372;
        
        defunc_2_reduce_res_334207 = 0.0;
        
        struct futhark_mc_task_338930 futhark_mc_task_338930;
        
        futhark_mc_task_338930.ctx = ctx;
        futhark_mc_task_338930.free_x_308597 = x_308597;
        futhark_mc_task_338930.free_mem_315949 = mem_315949.mem;
        futhark_mc_task_338930.free_x_334174 = x_334174;
        futhark_mc_task_338930.free_mem_334179 = mem_334179;
        futhark_mc_task_338930.free_a0_334206 = a0_334206;
        futhark_mc_task_338930.retval_defunc_2_reduce_res_334207 =
            &defunc_2_reduce_res_334207;
        
        struct scheduler_segop futhark_mc_task_338930_task;
        
        futhark_mc_task_338930_task.args = &futhark_mc_task_338930;
        futhark_mc_task_338930_task.top_level_fn =
            futhark_mc_segred_task_338931;
        futhark_mc_task_338930_task.name = "futhark_mc_segred_task_338931";
        futhark_mc_task_338930_task.iterations = q_t_292679;
        futhark_mc_task_338930_task.task_time =
            &ctx->futhark_mc_segred_task_338931_total_time;
        futhark_mc_task_338930_task.task_iter =
            &ctx->futhark_mc_segred_task_338931_total_iter;
        futhark_mc_task_338930_task.sched = STATIC;
        futhark_mc_task_338930_task.nested_fn = NULL;
        
        int futhark_mc_segred_task_338931_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_338930_task);
        
        if (futhark_mc_segred_task_338931_err != 0) {
            ;
            err = futhark_mc_segred_task_338931_err;
            goto cleanup;
        }
        ((double *) mem_315970.mem)[gtid_334173] = defunc_2_reduce_res_334207;
    }
    
  cleanup:
    { }
    free(mem_334179);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338923_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338923_end -
                 futhark_mc_segmap_parloop_338923_start;
        
        ctx->futhark_mc_segmap_parloop_338923_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338923_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338923_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_nested_task_338921(void *args, int64_t iterations,
                                         int tid, struct scheduler_info info)
{
    int err = 0;
    int flat_tid_334172 = tid;
    int num_tasks_334285 = info.nsubtasks;
    struct futhark_mc_task_338916 *futhark_mc_task_338916 =
                                  (struct futhark_mc_task_338916 *) args;
    struct futhark_context *ctx = futhark_mc_task_338916->ctx;
    uint64_t futhark_mc_segmap_nested_task_338921_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_nested_task_338921_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338916->free_n_292675;
    int64_t q_t_292679 = futhark_mc_task_338916->free_q_t_292679;
    int64_t jump_t_292685 = futhark_mc_task_338916->free_jump_t_292685;
    int64_t t_n_m_292839 = futhark_mc_task_338916->free_t_n_m_292839;
    int64_t i_292846 = futhark_mc_task_338916->free_i_292846;
    int64_t gtid_308592 = futhark_mc_task_338916->free_gtid_308592;
    int64_t x_308597 = futhark_mc_task_338916->free_x_308597;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_task_338916->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_313143 = {.desc ="mem_313143", .mem =
                                  futhark_mc_task_338916->free_mem_313143,
                                  .size =0, .references =NULL};
    struct memblock mem_313147 = {.desc ="mem_313147", .mem =
                                  futhark_mc_task_338916->free_mem_313147,
                                  .size =0, .references =NULL};
    struct memblock mem_315946 = {.desc ="mem_315946", .mem =
                                  futhark_mc_task_338916->free_mem_315946,
                                  .size =0, .references =NULL};
    struct memblock mem_315949 = {.desc ="mem_315949", .mem =
                                  futhark_mc_task_338916->free_mem_315949,
                                  .size =0, .references =NULL};
    int64_t bytes_315951 = futhark_mc_task_338916->free_bytes_315951;
    struct memblock mem_315970 = {.desc ="mem_315970", .mem =
                                  futhark_mc_task_338916->free_mem_315970,
                                  .size =0, .references =NULL};
    int64_t iter_334325;
    struct futhark_mc_segmap_parloop_struct_338922
    futhark_mc_segmap_parloop_struct_338922;
    
    futhark_mc_segmap_parloop_struct_338922.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338922.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_338922.free_q_t_292679 = q_t_292679;
    futhark_mc_segmap_parloop_struct_338922.free_jump_t_292685 = jump_t_292685;
    futhark_mc_segmap_parloop_struct_338922.free_t_n_m_292839 = t_n_m_292839;
    futhark_mc_segmap_parloop_struct_338922.free_i_292846 = i_292846;
    futhark_mc_segmap_parloop_struct_338922.free_gtid_308592 = gtid_308592;
    futhark_mc_segmap_parloop_struct_338922.free_x_308597 = x_308597;
    futhark_mc_segmap_parloop_struct_338922.free_mem_312636 = mem_312636.mem;
    futhark_mc_segmap_parloop_struct_338922.free_mem_313143 = mem_313143.mem;
    futhark_mc_segmap_parloop_struct_338922.free_mem_313147 = mem_313147.mem;
    futhark_mc_segmap_parloop_struct_338922.free_mem_315946 = mem_315946.mem;
    futhark_mc_segmap_parloop_struct_338922.free_mem_315949 = mem_315949.mem;
    futhark_mc_segmap_parloop_struct_338922.free_bytes_315951 = bytes_315951;
    futhark_mc_segmap_parloop_struct_338922.free_mem_315970 = mem_315970.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338923_task;
    
    futhark_mc_segmap_parloop_338923_task.name =
        "futhark_mc_segmap_parloop_338923";
    futhark_mc_segmap_parloop_338923_task.fn = futhark_mc_segmap_parloop_338923;
    futhark_mc_segmap_parloop_338923_task.args =
        &futhark_mc_segmap_parloop_struct_338922;
    futhark_mc_segmap_parloop_338923_task.iterations = iterations;
    futhark_mc_segmap_parloop_338923_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338923_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338923_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338923_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338923_task);
    
    if (futhark_mc_segmap_parloop_338923_err != 0) {
        err = futhark_mc_segmap_parloop_338923_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338923_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338923_total_end -
                 futhark_mc_segmap_parloop_338923_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338923_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338923_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338923_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_nested_task_338921_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_nested_task_338921_end -
                 futhark_mc_segmap_nested_task_338921_start;
        
        ctx->futhark_mc_segmap_nested_task_338921_runs[tid]++;
        ctx->futhark_mc_segmap_nested_task_338921_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_nested_task_338921_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
static int futhark_mc_segmap_parloop_338903(void *args, int64_t start,
                                            int64_t end, int flat_tid_308591,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338902
    *futhark_mc_segmap_parloop_struct_338902 =
    (struct futhark_mc_segmap_parloop_struct_338902 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338902->ctx;
    uint64_t futhark_mc_segmap_parloop_338903_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338903_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_338902->free_n_292675;
    int64_t q_t_292679 =
            futhark_mc_segmap_parloop_struct_338902->free_q_t_292679;
    int64_t jump_t_292685 =
            futhark_mc_segmap_parloop_struct_338902->free_jump_t_292685;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_338902->free_partition_sizze_292766;
    int64_t t_n_m_292839 =
            futhark_mc_segmap_parloop_struct_338902->free_t_n_m_292839;
    int64_t i_292846 = futhark_mc_segmap_parloop_struct_338902->free_i_292846;
    struct memblock mem_312593 = {.desc ="mem_312593", .mem =
                                  futhark_mc_segmap_parloop_struct_338902->free_mem_312593,
                                  .size =0, .references =NULL};
    int64_t bytes_312598 =
            futhark_mc_segmap_parloop_struct_338902->free_bytes_312598;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_segmap_parloop_struct_338902->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_312639 = {.desc ="mem_312639", .mem =
                                  futhark_mc_segmap_parloop_struct_338902->free_mem_312639,
                                  .size =0, .references =NULL};
    int64_t bytes_313090 =
            futhark_mc_segmap_parloop_struct_338902->free_bytes_313090;
    struct memblock mem_313143 = {.desc ="mem_313143", .mem =
                                  futhark_mc_segmap_parloop_struct_338902->free_mem_313143,
                                  .size =0, .references =NULL};
    struct memblock mem_313147 = {.desc ="mem_313147", .mem =
                                  futhark_mc_segmap_parloop_struct_338902->free_mem_313147,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_segmap_parloop_struct_338902->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_segmap_parloop_struct_338902->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_segmap_parloop_struct_338902->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_segmap_parloop_struct_338902->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315656 = {.desc ="mem_315656", .mem =
                                  futhark_mc_segmap_parloop_struct_338902->free_mem_315656,
                                  .size =0, .references =NULL};
    int64_t bytes_315951 =
            futhark_mc_segmap_parloop_struct_338902->free_bytes_315951;
    struct memblock mem_316049 = {.desc ="mem_316049", .mem =
                                  futhark_mc_segmap_parloop_struct_338902->free_mem_316049,
                                  .size =0, .references =NULL};
    size_t mem_315943_cached_sizze_338904 = 0;
    unsigned char *mem_315943 = NULL;
    size_t mem_315946_cached_sizze_338905 = 0;
    unsigned char *mem_315946 = NULL;
    size_t mem_315949_cached_sizze_338906 = 0;
    unsigned char *mem_315949 = NULL;
    size_t mem_315970_cached_sizze_338907 = 0;
    unsigned char *mem_315970 = NULL;
    int64_t iterations = end - start;
    int64_t iter_334151 = start;
    
    if (mem_315943_cached_sizze_338904 < (size_t) bytes_312598) {
        mem_315943 = realloc(mem_315943, bytes_312598);
        mem_315943_cached_sizze_338904 = bytes_312598;
    }
    if (mem_315946_cached_sizze_338905 < (size_t) bytes_312598) {
        mem_315946 = realloc(mem_315946, bytes_312598);
        mem_315946_cached_sizze_338905 = bytes_312598;
    }
    if (mem_315949_cached_sizze_338906 < (size_t) bytes_312598) {
        mem_315949 = realloc(mem_315949, bytes_312598);
        mem_315949_cached_sizze_338906 = bytes_312598;
    }
    if (mem_315970_cached_sizze_338907 < (size_t) bytes_313090) {
        mem_315970 = realloc(mem_315970, bytes_313090);
        mem_315970_cached_sizze_338907 = bytes_313090;
    }
    for (; iter_334151 < end; iter_334151++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_334267 = partition_sizze_292766;
        int64_t gtid_308592 = iter_334151;
        int64_t remnant_334268 = iter_334151 - gtid_308592;
        int64_t x_308597;
        
        x_308597 = ((int64_t *) mem_312639.mem)[gtid_308592];
        
        int64_t flat_tid_334152 = (int64_t) 0;
        int32_t num_tasks_334269;
        struct futhark_mc_task_338908 futhark_mc_task_338908;
        
        futhark_mc_task_338908.ctx = ctx;
        futhark_mc_task_338908.free_n_292675 = n_292675;
        futhark_mc_task_338908.free_gtid_308592 = gtid_308592;
        futhark_mc_task_338908.free_mem_312593 = mem_312593.mem;
        futhark_mc_task_338908.free_mem_315656 = mem_315656.mem;
        futhark_mc_task_338908.free_mem_315943 = mem_315943;
        
        struct scheduler_segop futhark_mc_task_338908_task;
        
        futhark_mc_task_338908_task.args = &futhark_mc_task_338908;
        futhark_mc_task_338908_task.top_level_fn =
            futhark_mc_segmap_task_338909;
        futhark_mc_task_338908_task.name = "futhark_mc_segmap_task_338909";
        futhark_mc_task_338908_task.iterations = n_292675;
        futhark_mc_task_338908_task.task_time =
            &ctx->futhark_mc_segmap_task_338909_total_time;
        futhark_mc_task_338908_task.task_iter =
            &ctx->futhark_mc_segmap_task_338909_total_iter;
        futhark_mc_task_338908_task.sched = STATIC;
        futhark_mc_task_338908_task.nested_fn = NULL;
        
        int futhark_mc_segmap_task_338909_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_338908_task);
        
        if (futhark_mc_segmap_task_338909_err != 0) {
            ;
            err = futhark_mc_segmap_task_338909_err;
            goto cleanup;
        }
        
        int64_t flat_tid_334158 = (int64_t) 0;
        int32_t num_tasks_334273;
        struct futhark_mc_task_338912 futhark_mc_task_338912;
        
        futhark_mc_task_338912.ctx = ctx;
        futhark_mc_task_338912.free_n_292675 = n_292675;
        futhark_mc_task_338912.free_gtid_308592 = gtid_308592;
        futhark_mc_task_338912.free_mem_312636 = mem_312636.mem;
        futhark_mc_task_338912.free_ctx_param_ext_313174 = ctx_param_ext_313174;
        futhark_mc_task_338912.free_ctx_param_ext_313175 = ctx_param_ext_313175;
        futhark_mc_task_338912.free_ctx_param_ext_313177 = ctx_param_ext_313177;
        futhark_mc_task_338912.free_mem_param_313179 = mem_param_313179.mem;
        futhark_mc_task_338912.free_mem_315943 = mem_315943;
        futhark_mc_task_338912.free_mem_315946 = mem_315946;
        futhark_mc_task_338912.free_mem_315949 = mem_315949;
        
        struct scheduler_segop futhark_mc_task_338912_task;
        
        futhark_mc_task_338912_task.args = &futhark_mc_task_338912;
        futhark_mc_task_338912_task.top_level_fn =
            futhark_mc_segmap_task_338913;
        futhark_mc_task_338912_task.name = "futhark_mc_segmap_task_338913";
        futhark_mc_task_338912_task.iterations = n_292675;
        futhark_mc_task_338912_task.task_time =
            &ctx->futhark_mc_segmap_task_338913_total_time;
        futhark_mc_task_338912_task.task_iter =
            &ctx->futhark_mc_segmap_task_338913_total_iter;
        futhark_mc_task_338912_task.sched = STATIC;
        futhark_mc_task_338912_task.nested_fn = NULL;
        
        int futhark_mc_segmap_task_338913_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_338912_task);
        
        if (futhark_mc_segmap_task_338913_err != 0) {
            ;
            err = futhark_mc_segmap_task_338913_err;
            goto cleanup;
        }
        
        int64_t flat_tid_334220 = (int64_t) 0;
        int32_t num_tasks_334285;
        int64_t flat_tid_334172 = (int64_t) 0;
        struct futhark_mc_task_338916 futhark_mc_task_338916;
        
        futhark_mc_task_338916.ctx = ctx;
        futhark_mc_task_338916.free_n_292675 = n_292675;
        futhark_mc_task_338916.free_q_t_292679 = q_t_292679;
        futhark_mc_task_338916.free_jump_t_292685 = jump_t_292685;
        futhark_mc_task_338916.free_t_n_m_292839 = t_n_m_292839;
        futhark_mc_task_338916.free_i_292846 = i_292846;
        futhark_mc_task_338916.free_gtid_308592 = gtid_308592;
        futhark_mc_task_338916.free_x_308597 = x_308597;
        futhark_mc_task_338916.free_mem_312636 = mem_312636.mem;
        futhark_mc_task_338916.free_mem_313143 = mem_313143.mem;
        futhark_mc_task_338916.free_mem_313147 = mem_313147.mem;
        futhark_mc_task_338916.free_mem_315946 = mem_315946;
        futhark_mc_task_338916.free_mem_315949 = mem_315949;
        futhark_mc_task_338916.free_bytes_315951 = bytes_315951;
        futhark_mc_task_338916.free_mem_315970 = mem_315970;
        
        struct scheduler_segop futhark_mc_task_338916_task;
        
        futhark_mc_task_338916_task.args = &futhark_mc_task_338916;
        futhark_mc_task_338916_task.top_level_fn =
            futhark_mc_segmap_task_338917;
        futhark_mc_task_338916_task.name = "futhark_mc_segmap_task_338917";
        futhark_mc_task_338916_task.iterations = t_n_m_292839;
        futhark_mc_task_338916_task.task_time =
            &ctx->futhark_mc_segmap_task_338917_total_time;
        futhark_mc_task_338916_task.task_iter =
            &ctx->futhark_mc_segmap_task_338917_total_iter;
        futhark_mc_task_338916_task.sched = STATIC;
        futhark_mc_task_338916_task.nested_fn =
            futhark_mc_segmap_nested_task_338921;
        
        int futhark_mc_segmap_task_338917_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_338916_task);
        
        if (futhark_mc_segmap_task_338917_err != 0) {
            ;
            err = futhark_mc_segmap_task_338917_err;
            goto cleanup;
        }
        if (t_n_m_292839 * (int64_t) 8 > 0)
            memmove(mem_316049.mem + gtid_308592 * t_n_m_292839 * (int64_t) 8,
                    mem_315970 + (int64_t) 0, t_n_m_292839 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_315943);
    free(mem_315946);
    free(mem_315949);
    free(mem_315970);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338903_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338903_end -
                 futhark_mc_segmap_parloop_338903_start;
        
        ctx->futhark_mc_segmap_parloop_338903_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338903_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338903_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_nested_task_338901(void *args, int64_t iterations,
                                         int tid, struct scheduler_info info)
{
    int err = 0;
    int flat_tid_308591 = tid;
    int num_tasks_334069 = info.nsubtasks;
    struct futhark_mc_task_338892 *futhark_mc_task_338892 =
                                  (struct futhark_mc_task_338892 *) args;
    struct futhark_context *ctx = futhark_mc_task_338892->ctx;
    uint64_t futhark_mc_segmap_nested_task_338901_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_nested_task_338901_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338892->free_n_292675;
    int64_t q_t_292679 = futhark_mc_task_338892->free_q_t_292679;
    int64_t jump_t_292685 = futhark_mc_task_338892->free_jump_t_292685;
    int64_t partition_sizze_292766 =
            futhark_mc_task_338892->free_partition_sizze_292766;
    int64_t t_n_m_292839 = futhark_mc_task_338892->free_t_n_m_292839;
    int64_t i_292846 = futhark_mc_task_338892->free_i_292846;
    struct memblock mem_312593 = {.desc ="mem_312593", .mem =
                                  futhark_mc_task_338892->free_mem_312593,
                                  .size =0, .references =NULL};
    int64_t bytes_312598 = futhark_mc_task_338892->free_bytes_312598;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_task_338892->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_312639 = {.desc ="mem_312639", .mem =
                                  futhark_mc_task_338892->free_mem_312639,
                                  .size =0, .references =NULL};
    int64_t bytes_313090 = futhark_mc_task_338892->free_bytes_313090;
    struct memblock mem_313143 = {.desc ="mem_313143", .mem =
                                  futhark_mc_task_338892->free_mem_313143,
                                  .size =0, .references =NULL};
    struct memblock mem_313147 = {.desc ="mem_313147", .mem =
                                  futhark_mc_task_338892->free_mem_313147,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_task_338892->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_task_338892->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_task_338892->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_task_338892->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315656 = {.desc ="mem_315656", .mem =
                                  futhark_mc_task_338892->free_mem_315656,
                                  .size =0, .references =NULL};
    int64_t bytes_315951 = futhark_mc_task_338892->free_bytes_315951;
    struct memblock mem_316049 = {.desc ="mem_316049", .mem =
                                  futhark_mc_task_338892->free_mem_316049,
                                  .size =0, .references =NULL};
    int64_t iter_334151;
    struct futhark_mc_segmap_parloop_struct_338902
    futhark_mc_segmap_parloop_struct_338902;
    
    futhark_mc_segmap_parloop_struct_338902.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338902.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_338902.free_q_t_292679 = q_t_292679;
    futhark_mc_segmap_parloop_struct_338902.free_jump_t_292685 = jump_t_292685;
    futhark_mc_segmap_parloop_struct_338902.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_338902.free_t_n_m_292839 = t_n_m_292839;
    futhark_mc_segmap_parloop_struct_338902.free_i_292846 = i_292846;
    futhark_mc_segmap_parloop_struct_338902.free_mem_312593 = mem_312593.mem;
    futhark_mc_segmap_parloop_struct_338902.free_bytes_312598 = bytes_312598;
    futhark_mc_segmap_parloop_struct_338902.free_mem_312636 = mem_312636.mem;
    futhark_mc_segmap_parloop_struct_338902.free_mem_312639 = mem_312639.mem;
    futhark_mc_segmap_parloop_struct_338902.free_bytes_313090 = bytes_313090;
    futhark_mc_segmap_parloop_struct_338902.free_mem_313143 = mem_313143.mem;
    futhark_mc_segmap_parloop_struct_338902.free_mem_313147 = mem_313147.mem;
    futhark_mc_segmap_parloop_struct_338902.free_ctx_param_ext_313174 =
        ctx_param_ext_313174;
    futhark_mc_segmap_parloop_struct_338902.free_ctx_param_ext_313175 =
        ctx_param_ext_313175;
    futhark_mc_segmap_parloop_struct_338902.free_ctx_param_ext_313177 =
        ctx_param_ext_313177;
    futhark_mc_segmap_parloop_struct_338902.free_mem_param_313179 =
        mem_param_313179.mem;
    futhark_mc_segmap_parloop_struct_338902.free_mem_315656 = mem_315656.mem;
    futhark_mc_segmap_parloop_struct_338902.free_bytes_315951 = bytes_315951;
    futhark_mc_segmap_parloop_struct_338902.free_mem_316049 = mem_316049.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338903_task;
    
    futhark_mc_segmap_parloop_338903_task.name =
        "futhark_mc_segmap_parloop_338903";
    futhark_mc_segmap_parloop_338903_task.fn = futhark_mc_segmap_parloop_338903;
    futhark_mc_segmap_parloop_338903_task.args =
        &futhark_mc_segmap_parloop_struct_338902;
    futhark_mc_segmap_parloop_338903_task.iterations = iterations;
    futhark_mc_segmap_parloop_338903_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338903_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338903_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338903_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338903_task);
    
    if (futhark_mc_segmap_parloop_338903_err != 0) {
        err = futhark_mc_segmap_parloop_338903_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338903_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338903_total_end -
                 futhark_mc_segmap_parloop_338903_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338903_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338903_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338903_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_nested_task_338901_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_nested_task_338901_end -
                 futhark_mc_segmap_nested_task_338901_start;
        
        ctx->futhark_mc_segmap_nested_task_338901_runs[tid]++;
        ctx->futhark_mc_segmap_nested_task_338901_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_nested_task_338901_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_task_338935 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_t_292679;
    int64_t free_jump_t_292685;
    int64_t free_partition_sizze_292766;
    int64_t free_t_n_m_292839;
    int64_t free_i_292846;
    unsigned char *free_mem_312593;
    int64_t free_bytes_312598;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_312639;
    int64_t free_bytes_313090;
    unsigned char *free_mem_313143;
    unsigned char *free_mem_313147;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315656;
    int64_t free_bytes_316060;
    unsigned char *free_mem_316209;
    unsigned char *free_mem_316213;
};
struct futhark_mc_segmap_parloop_struct_338937 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_t_292679;
    int64_t free_jump_t_292685;
    int64_t free_partition_sizze_292766;
    int64_t free_t_n_m_292839;
    int64_t free_i_292846;
    unsigned char *free_mem_312593;
    int64_t free_bytes_312598;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_312639;
    int64_t free_bytes_313090;
    unsigned char *free_mem_313143;
    unsigned char *free_mem_313147;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315656;
    int64_t free_bytes_316060;
    unsigned char *free_mem_316209;
    unsigned char *free_mem_316213;
};
static int futhark_mc_segmap_parloop_338938(void *args, int64_t start,
                                            int64_t end, int flat_tid_308720,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338937
    *futhark_mc_segmap_parloop_struct_338937 =
    (struct futhark_mc_segmap_parloop_struct_338937 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338937->ctx;
    uint64_t futhark_mc_segmap_parloop_338938_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338938_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_338937->free_n_292675;
    int64_t q_t_292679 =
            futhark_mc_segmap_parloop_struct_338937->free_q_t_292679;
    int64_t jump_t_292685 =
            futhark_mc_segmap_parloop_struct_338937->free_jump_t_292685;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_338937->free_partition_sizze_292766;
    int64_t t_n_m_292839 =
            futhark_mc_segmap_parloop_struct_338937->free_t_n_m_292839;
    int64_t i_292846 = futhark_mc_segmap_parloop_struct_338937->free_i_292846;
    struct memblock mem_312593 = {.desc ="mem_312593", .mem =
                                  futhark_mc_segmap_parloop_struct_338937->free_mem_312593,
                                  .size =0, .references =NULL};
    int64_t bytes_312598 =
            futhark_mc_segmap_parloop_struct_338937->free_bytes_312598;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_segmap_parloop_struct_338937->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_312639 = {.desc ="mem_312639", .mem =
                                  futhark_mc_segmap_parloop_struct_338937->free_mem_312639,
                                  .size =0, .references =NULL};
    int64_t bytes_313090 =
            futhark_mc_segmap_parloop_struct_338937->free_bytes_313090;
    struct memblock mem_313143 = {.desc ="mem_313143", .mem =
                                  futhark_mc_segmap_parloop_struct_338937->free_mem_313143,
                                  .size =0, .references =NULL};
    struct memblock mem_313147 = {.desc ="mem_313147", .mem =
                                  futhark_mc_segmap_parloop_struct_338937->free_mem_313147,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_segmap_parloop_struct_338937->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_segmap_parloop_struct_338937->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_segmap_parloop_struct_338937->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_segmap_parloop_struct_338937->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315656 = {.desc ="mem_315656", .mem =
                                  futhark_mc_segmap_parloop_struct_338937->free_mem_315656,
                                  .size =0, .references =NULL};
    int64_t bytes_316060 =
            futhark_mc_segmap_parloop_struct_338937->free_bytes_316060;
    struct memblock mem_316209 = {.desc ="mem_316209", .mem =
                                  futhark_mc_segmap_parloop_struct_338937->free_mem_316209,
                                  .size =0, .references =NULL};
    struct memblock mem_316213 = {.desc ="mem_316213", .mem =
                                  futhark_mc_segmap_parloop_struct_338937->free_mem_316213,
                                  .size =0, .references =NULL};
    size_t mem_316103_cached_sizze_338939 = 0;
    unsigned char *mem_316103 = NULL;
    size_t mem_316118_cached_sizze_338940 = 0;
    unsigned char *mem_316118 = NULL;
    size_t mem_316121_cached_sizze_338941 = 0;
    unsigned char *mem_316121 = NULL;
    size_t mem_316148_cached_sizze_338942 = 0;
    unsigned char *mem_316148 = NULL;
    size_t mem_316151_cached_sizze_338943 = 0;
    unsigned char *mem_316151 = NULL;
    size_t mem_316168_cached_sizze_338944 = 0;
    unsigned char *mem_316168 = NULL;
    size_t mem_316171_cached_sizze_338945 = 0;
    unsigned char *mem_316171 = NULL;
    int64_t iterations = end - start;
    int64_t iter_334382 = start;
    
    if (mem_316103_cached_sizze_338939 < (size_t) bytes_312598) {
        mem_316103 = realloc(mem_316103, bytes_312598);
        mem_316103_cached_sizze_338939 = bytes_312598;
    }
    if (mem_316118_cached_sizze_338940 < (size_t) bytes_312598) {
        mem_316118 = realloc(mem_316118, bytes_312598);
        mem_316118_cached_sizze_338940 = bytes_312598;
    }
    if (mem_316121_cached_sizze_338941 < (size_t) bytes_312598) {
        mem_316121 = realloc(mem_316121, bytes_312598);
        mem_316121_cached_sizze_338941 = bytes_312598;
    }
    if (mem_316148_cached_sizze_338942 < (size_t) bytes_313090) {
        mem_316148 = realloc(mem_316148, bytes_313090);
        mem_316148_cached_sizze_338942 = bytes_313090;
    }
    if (mem_316151_cached_sizze_338943 < (size_t) bytes_313090) {
        mem_316151 = realloc(mem_316151, bytes_313090);
        mem_316151_cached_sizze_338943 = bytes_313090;
    }
    if (mem_316168_cached_sizze_338944 < (size_t) bytes_316060) {
        mem_316168 = realloc(mem_316168, bytes_316060);
        mem_316168_cached_sizze_338944 = bytes_316060;
    }
    if (mem_316171_cached_sizze_338945 < (size_t) bytes_316060) {
        mem_316171 = realloc(mem_316171, bytes_316060);
        mem_316171_cached_sizze_338945 = bytes_316060;
    }
    for (; iter_334382 < end; iter_334382++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_334487 = partition_sizze_292766;
        int64_t gtid_308721 = iter_334382;
        int64_t remnant_334488 = iter_334382 - gtid_308721;
        int64_t x_296285;
        
        x_296285 = ((int64_t *) mem_312639.mem)[gtid_308721];
        for (int64_t i_334383 = 0; i_334383 < n_292675; i_334383++) {
            float x_334385;
            
            x_334385 = ((float *) mem_312593.mem)[gtid_308721 * n_292675 +
                                                  i_334383];
            
            double x_334386;
            
            x_334386 = ((double *) mem_315656.mem)[gtid_308721 * n_292675 +
                                                   i_334383];
            
            double f32_res_334387 = fpconv_f32_f64(x_334385);
            double defunc_1_f_res_334388 = f32_res_334387 - x_334386;
            
            ((double *) mem_316103)[i_334383] = defunc_1_f_res_334388;
        }
        for (int64_t i_334390 = 0; i_334390 < n_292675; i_334390++) {
            int64_t x_334393;
            
            x_334393 = ((int64_t *) mem_312636.mem)[gtid_308721 * n_292675 +
                                                    i_334390];
            
            bool cond_334394 = sle64((int64_t) 0, x_334393);
            double defunc_0_f_res_334395;
            
            if (cond_334394) {
                bool y_334396 = slt64(x_334393, n_292675);
                bool bounds_check_334397 = cond_334394 && y_334396;
                bool index_certs_334398;
                
                if (!bounds_check_334397) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [", (long long) x_334393,
                                  "] out of bounds for array of shape [",
                                  (long long) n_292675, "].",
                                  "-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:45:43-70\n   #3  stl.fut:285:33-58\n   #4  /prelude/soacs.fut:75:22-28\n   #5  /prelude/soacs.fut:75:3-45\n   #6  stl.fut:283:13-288:41\n   #7  stl.fut:419:61-435:77\n   #8  stl.fut:463:3-479:36\n   #9  stl.fut:445:1-479:36\n");
                    err = FUTHARK_PROGRAM_ERROR;
                    goto cleanup;
                }
                
                double defunc_0_f_res_t_res_334399;
                
                defunc_0_f_res_t_res_334399 = ((double *) mem_316103)[x_334393];
                defunc_0_f_res_334395 = defunc_0_f_res_t_res_334399;
            } else {
                defunc_0_f_res_334395 = 0.0;
            }
            
            double defunc_0_f_res_334400;
            
            if (cond_334394) {
                bool y_334401 = slt64(x_334393, n_292675);
                bool bounds_check_334402 = cond_334394 && y_334401;
                bool index_certs_334403;
                
                if (!bounds_check_334402) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [", (long long) x_334393,
                                  "] out of bounds for array of shape [",
                                  (long long) n_292675, "].",
                                  "-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:45:43-70\n   #3  stl.fut:286:33-64\n   #4  /prelude/soacs.fut:75:22-28\n   #5  /prelude/soacs.fut:75:3-45\n   #6  stl.fut:283:13-288:41\n   #7  stl.fut:419:61-435:77\n   #8  stl.fut:463:3-479:36\n   #9  stl.fut:445:1-479:36\n");
                    err = FUTHARK_PROGRAM_ERROR;
                    goto cleanup;
                }
                
                double defunc_0_f_res_t_res_334404;
                
                defunc_0_f_res_t_res_334404 =
                    ((double *) mem_param_313179.mem)[ctx_param_ext_313174 +
                                                      (gtid_308721 *
                                                       ctx_param_ext_313175 +
                                                       x_334393 *
                                                       ctx_param_ext_313177)];
                defunc_0_f_res_334400 = defunc_0_f_res_t_res_334404;
            } else {
                defunc_0_f_res_334400 = 0.0;
            }
            ((double *) mem_316118)[i_334390] = defunc_0_f_res_334400;
            ((double *) mem_316121)[i_334390] = defunc_0_f_res_334395;
        }
        for (int64_t i_334407 = 0; i_334407 < t_n_m_292839; i_334407++) {
            int64_t x_334410;
            
            x_334410 = ((int64_t *) mem_313143.mem)[gtid_308721 * t_n_m_292839 +
                                                    i_334407];
            
            double x_334411;
            
            x_334411 = ((double *) mem_313147.mem)[gtid_308721 * t_n_m_292839 +
                                                   i_334407];
            
            int64_t min_arg_334412 = mul64(jump_t_292685, i_334407);
            int64_t min_res_334413 = smin64(i_292846, min_arg_334412);
            int64_t defunc_0_g_res_334414 = add64((int64_t) 1, min_res_334413);
            double defunc_2_reduce_res_334417;
            double defunc_2_reduce_res_334418;
            double defunc_2_reduce_res_334419;
            double redout_334423;
            double redout_334424;
            double redout_334425;
            
            redout_334423 = 0.0;
            redout_334424 = 0.0;
            redout_334425 = 0.0;
            for (int64_t i_334422 = 0; i_334422 < q_t_292679; i_334422++) {
                bool cond_334428 = sle64(x_296285, i_334422);
                int64_t defunc_0_f_res_334429;
                
                if (cond_334428) {
                    defunc_0_f_res_334429 = (int64_t) 0;
                } else {
                    int64_t i_334430 = add64(x_334410, i_334422);
                    int64_t defunc_0_add_arg_334431;
                    
                    defunc_0_add_arg_334431 =
                        ((int64_t *) mem_312636.mem)[gtid_308721 * n_292675 +
                                                     i_334430];
                    
                    int64_t defunc_1_add_res_334432 = add64((int64_t) 1,
                                                            defunc_0_add_arg_334431);
                    
                    defunc_0_f_res_334429 = defunc_1_add_res_334432;
                }
                
                double defunc_0_f_res_334433;
                
                if (cond_334428) {
                    defunc_0_f_res_334433 = 0.0;
                } else {
                    int64_t i_334434 = add64(x_334410, i_334422);
                    double defunc_0_add_arg_334435;
                    
                    defunc_0_add_arg_334435 = ((double *) mem_316118)[i_334434];
                    defunc_0_f_res_334433 = defunc_0_add_arg_334435;
                }
                
                int64_t binop_p_334436 = sub64(defunc_0_f_res_334429,
                                               defunc_0_g_res_334414);
                double defunc_0_f_res_334437 = sitofp_i64_f64(binop_p_334436);
                double abs_res_334438 = fabs(defunc_0_f_res_334437);
                double tmp1_334439 = abs_res_334438 / x_334411;
                double x_334440 = tmp1_334439 * tmp1_334439;
                double y_334441 = tmp1_334439 * x_334440;
                double tmp2_334442 = 1.0 - y_334441;
                double x_334443 = tmp2_334442 * tmp2_334442;
                double tmp3_334444 = tmp2_334442 * x_334443;
                double tmp4_334445 = defunc_0_f_res_334433 * tmp3_334444;
                double defunc_1_f_res_334446 = defunc_0_f_res_334437 *
                       tmp4_334445;
                double defunc_1_f_res_334447 = defunc_0_f_res_334437 *
                       defunc_1_f_res_334446;
                double defunc_1_op_res_334448 = tmp4_334445 + redout_334423;
                double defunc_1_op_res_334449 = defunc_1_f_res_334446 +
                       redout_334424;
                double defunc_1_op_res_334450 = defunc_1_f_res_334447 +
                       redout_334425;
                
                ((double *) mem_316168)[i_334422] = defunc_1_f_res_334446;
                ((double *) mem_316171)[i_334422] = tmp4_334445;
                
                double redout_tmp_334494 = defunc_1_op_res_334448;
                double redout_tmp_334495 = defunc_1_op_res_334449;
                double redout_tmp_334496 = defunc_1_op_res_334450;
                
                redout_334423 = redout_tmp_334494;
                redout_334424 = redout_tmp_334495;
                redout_334425 = redout_tmp_334496;
            }
            defunc_2_reduce_res_334417 = redout_334423;
            defunc_2_reduce_res_334418 = redout_334424;
            defunc_2_reduce_res_334419 = redout_334425;
            
            double a_334453 = 2.220446049250313e-16 +
                   defunc_2_reduce_res_334417;
            double b_334454 = 2.220446049250313e-16 +
                   defunc_2_reduce_res_334418;
            double c_334455 = 2.220446049250313e-16 +
                   defunc_2_reduce_res_334419;
            double x_334456 = a_334453 * c_334455;
            double y_334457 = b_334454 * b_334454;
            double y_334458 = x_334456 - y_334457;
            double det1_334459 = 1.0 / y_334458;
            double a11_334460 = c_334455 * det1_334459;
            double x_334461 = 0.0 - b_334454;
            double b11_334462 = det1_334459 * x_334461;
            double c11_334463 = a_334453 * det1_334459;
            double defunc_2_reduce_res_334464;
            double defunc_2_reduce_res_334465;
            double redout_334467;
            double redout_334468;
            
            redout_334467 = 0.0;
            redout_334468 = 0.0;
            for (int64_t i_334466 = 0; i_334466 < q_t_292679; i_334466++) {
                double x_334469;
                
                x_334469 = ((double *) mem_316171)[i_334466];
                
                double x_334470;
                
                x_334470 = ((double *) mem_316168)[i_334466];
                
                bool cond_334471 = sle64(x_296285, i_334466);
                double defunc_0_f_res_334472;
                
                if (cond_334471) {
                    defunc_0_f_res_334472 = 0.0;
                } else {
                    int64_t i_334473 = add64(x_334410, i_334466);
                    double defunc_0_add_arg_334474;
                    
                    defunc_0_add_arg_334474 = ((double *) mem_316121)[i_334473];
                    defunc_0_f_res_334472 = defunc_0_add_arg_334474;
                }
                
                double x_334475 = a11_334460 * x_334469;
                double y_334476 = b11_334462 * x_334470;
                double x_334477 = x_334475 + y_334476;
                double defunc_9_fit_fun_res_334478 = defunc_0_f_res_334472 *
                       x_334477;
                double x_334479 = b11_334462 * x_334469;
                double y_334480 = c11_334463 * x_334470;
                double x_334481 = x_334479 + y_334480;
                double defunc_9_slope_fun_res_334482 = defunc_0_f_res_334472 *
                       x_334481;
                double defunc_1_op_res_334483 = defunc_9_fit_fun_res_334478 +
                       redout_334467;
                double defunc_1_op_res_334484 = defunc_9_slope_fun_res_334482 +
                       redout_334468;
                double redout_tmp_334499 = defunc_1_op_res_334483;
                double redout_tmp_334500 = defunc_1_op_res_334484;
                
                redout_334467 = redout_tmp_334499;
                redout_334468 = redout_tmp_334500;
            }
            defunc_2_reduce_res_334464 = redout_334467;
            defunc_2_reduce_res_334465 = redout_334468;
            ((double *) mem_316148)[i_334407] = defunc_2_reduce_res_334464;
            ((double *) mem_316151)[i_334407] = defunc_2_reduce_res_334465;
        }
        if (t_n_m_292839 * (int64_t) 8 > 0)
            memmove(mem_316209.mem + gtid_308721 * t_n_m_292839 * (int64_t) 8,
                    mem_316148 + (int64_t) 0, t_n_m_292839 * (int64_t) 8);
        if (t_n_m_292839 * (int64_t) 8 > 0)
            memmove(mem_316213.mem + gtid_308721 * t_n_m_292839 * (int64_t) 8,
                    mem_316151 + (int64_t) 0, t_n_m_292839 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_316103);
    free(mem_316118);
    free(mem_316121);
    free(mem_316148);
    free(mem_316151);
    free(mem_316168);
    free(mem_316171);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338938_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338938_end -
                 futhark_mc_segmap_parloop_338938_start;
        
        ctx->futhark_mc_segmap_parloop_338938_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338938_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338938_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_338936(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_308720 = tid;
    int num_tasks_334381 = info.nsubtasks;
    struct futhark_mc_task_338935 *futhark_mc_task_338935 =
                                  (struct futhark_mc_task_338935 *) args;
    struct futhark_context *ctx = futhark_mc_task_338935->ctx;
    uint64_t futhark_mc_segmap_task_338936_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_338936_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338935->free_n_292675;
    int64_t q_t_292679 = futhark_mc_task_338935->free_q_t_292679;
    int64_t jump_t_292685 = futhark_mc_task_338935->free_jump_t_292685;
    int64_t partition_sizze_292766 =
            futhark_mc_task_338935->free_partition_sizze_292766;
    int64_t t_n_m_292839 = futhark_mc_task_338935->free_t_n_m_292839;
    int64_t i_292846 = futhark_mc_task_338935->free_i_292846;
    struct memblock mem_312593 = {.desc ="mem_312593", .mem =
                                  futhark_mc_task_338935->free_mem_312593,
                                  .size =0, .references =NULL};
    int64_t bytes_312598 = futhark_mc_task_338935->free_bytes_312598;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_task_338935->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_312639 = {.desc ="mem_312639", .mem =
                                  futhark_mc_task_338935->free_mem_312639,
                                  .size =0, .references =NULL};
    int64_t bytes_313090 = futhark_mc_task_338935->free_bytes_313090;
    struct memblock mem_313143 = {.desc ="mem_313143", .mem =
                                  futhark_mc_task_338935->free_mem_313143,
                                  .size =0, .references =NULL};
    struct memblock mem_313147 = {.desc ="mem_313147", .mem =
                                  futhark_mc_task_338935->free_mem_313147,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_task_338935->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_task_338935->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_task_338935->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_task_338935->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315656 = {.desc ="mem_315656", .mem =
                                  futhark_mc_task_338935->free_mem_315656,
                                  .size =0, .references =NULL};
    int64_t bytes_316060 = futhark_mc_task_338935->free_bytes_316060;
    struct memblock mem_316209 = {.desc ="mem_316209", .mem =
                                  futhark_mc_task_338935->free_mem_316209,
                                  .size =0, .references =NULL};
    struct memblock mem_316213 = {.desc ="mem_316213", .mem =
                                  futhark_mc_task_338935->free_mem_316213,
                                  .size =0, .references =NULL};
    int64_t iter_334382;
    struct futhark_mc_segmap_parloop_struct_338937
    futhark_mc_segmap_parloop_struct_338937;
    
    futhark_mc_segmap_parloop_struct_338937.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338937.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_338937.free_q_t_292679 = q_t_292679;
    futhark_mc_segmap_parloop_struct_338937.free_jump_t_292685 = jump_t_292685;
    futhark_mc_segmap_parloop_struct_338937.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_338937.free_t_n_m_292839 = t_n_m_292839;
    futhark_mc_segmap_parloop_struct_338937.free_i_292846 = i_292846;
    futhark_mc_segmap_parloop_struct_338937.free_mem_312593 = mem_312593.mem;
    futhark_mc_segmap_parloop_struct_338937.free_bytes_312598 = bytes_312598;
    futhark_mc_segmap_parloop_struct_338937.free_mem_312636 = mem_312636.mem;
    futhark_mc_segmap_parloop_struct_338937.free_mem_312639 = mem_312639.mem;
    futhark_mc_segmap_parloop_struct_338937.free_bytes_313090 = bytes_313090;
    futhark_mc_segmap_parloop_struct_338937.free_mem_313143 = mem_313143.mem;
    futhark_mc_segmap_parloop_struct_338937.free_mem_313147 = mem_313147.mem;
    futhark_mc_segmap_parloop_struct_338937.free_ctx_param_ext_313174 =
        ctx_param_ext_313174;
    futhark_mc_segmap_parloop_struct_338937.free_ctx_param_ext_313175 =
        ctx_param_ext_313175;
    futhark_mc_segmap_parloop_struct_338937.free_ctx_param_ext_313177 =
        ctx_param_ext_313177;
    futhark_mc_segmap_parloop_struct_338937.free_mem_param_313179 =
        mem_param_313179.mem;
    futhark_mc_segmap_parloop_struct_338937.free_mem_315656 = mem_315656.mem;
    futhark_mc_segmap_parloop_struct_338937.free_bytes_316060 = bytes_316060;
    futhark_mc_segmap_parloop_struct_338937.free_mem_316209 = mem_316209.mem;
    futhark_mc_segmap_parloop_struct_338937.free_mem_316213 = mem_316213.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338938_task;
    
    futhark_mc_segmap_parloop_338938_task.name =
        "futhark_mc_segmap_parloop_338938";
    futhark_mc_segmap_parloop_338938_task.fn = futhark_mc_segmap_parloop_338938;
    futhark_mc_segmap_parloop_338938_task.args =
        &futhark_mc_segmap_parloop_struct_338937;
    futhark_mc_segmap_parloop_338938_task.iterations = iterations;
    futhark_mc_segmap_parloop_338938_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338938_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338938_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338938_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338938_task);
    
    if (futhark_mc_segmap_parloop_338938_err != 0) {
        err = futhark_mc_segmap_parloop_338938_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338938_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338938_total_end -
                 futhark_mc_segmap_parloop_338938_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338938_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338938_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338938_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_338936_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_338936_end -
                 futhark_mc_segmap_task_338936_start;
        
        ctx->futhark_mc_segmap_task_338936_runs[tid]++;
        ctx->futhark_mc_segmap_task_338936_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_338936_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_segmap_parloop_struct_338947 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_t_292679;
    int64_t free_jump_t_292685;
    int64_t free_partition_sizze_292766;
    int64_t free_t_n_m_292839;
    int64_t free_i_292846;
    unsigned char *free_mem_312593;
    int64_t free_bytes_312598;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_312639;
    int64_t free_bytes_313090;
    unsigned char *free_mem_313143;
    unsigned char *free_mem_313147;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315656;
    int64_t free_bytes_316060;
    unsigned char *free_mem_316209;
    unsigned char *free_mem_316213;
};
struct futhark_mc_task_338954 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_308818;
    unsigned char *free_mem_312593;
    unsigned char *free_mem_315656;
    unsigned char *free_mem_316052;
};
struct futhark_mc_segmap_parloop_struct_338956 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_308818;
    unsigned char *free_mem_312593;
    unsigned char *free_mem_315656;
    unsigned char *free_mem_316052;
};
static int futhark_mc_segmap_parloop_338957(void *args, int64_t start,
                                            int64_t end, int flat_tid_334502,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338956
    *futhark_mc_segmap_parloop_struct_338956 =
    (struct futhark_mc_segmap_parloop_struct_338956 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338956->ctx;
    uint64_t futhark_mc_segmap_parloop_338957_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338957_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_338956->free_n_292675;
    int64_t gtid_308818 =
            futhark_mc_segmap_parloop_struct_338956->free_gtid_308818;
    struct memblock mem_312593 = {.desc ="mem_312593", .mem =
                                  futhark_mc_segmap_parloop_struct_338956->free_mem_312593,
                                  .size =0, .references =NULL};
    struct memblock mem_315656 = {.desc ="mem_315656", .mem =
                                  futhark_mc_segmap_parloop_struct_338956->free_mem_315656,
                                  .size =0, .references =NULL};
    struct memblock mem_316052 = {.desc ="mem_316052", .mem =
                                  futhark_mc_segmap_parloop_struct_338956->free_mem_316052,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_334684 = start;
    
    for (; iter_334684 < end; iter_334684++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_334685 = n_292675;
        int64_t gtid_334503 = iter_334684;
        int64_t remnant_334686 = iter_334684 - gtid_334503;
        float x_334504;
        
        x_334504 = ((float *) mem_312593.mem)[gtid_308818 * n_292675 +
                                              gtid_334503];
        
        double x_334505;
        
        x_334505 = ((double *) mem_315656.mem)[gtid_308818 * n_292675 +
                                               gtid_334503];
        
        double f32_res_334506 = fpconv_f32_f64(x_334504);
        double defunc_1_f_res_334507 = f32_res_334506 - x_334505;
        
        ((double *) mem_316052.mem)[gtid_334503] = defunc_1_f_res_334507;
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338957_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338957_end -
                 futhark_mc_segmap_parloop_338957_start;
        
        ctx->futhark_mc_segmap_parloop_338957_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338957_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338957_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_338955(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_334502 = tid;
    int num_tasks_334683 = info.nsubtasks;
    struct futhark_mc_task_338954 *futhark_mc_task_338954 =
                                  (struct futhark_mc_task_338954 *) args;
    struct futhark_context *ctx = futhark_mc_task_338954->ctx;
    uint64_t futhark_mc_segmap_task_338955_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_338955_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338954->free_n_292675;
    int64_t gtid_308818 = futhark_mc_task_338954->free_gtid_308818;
    struct memblock mem_312593 = {.desc ="mem_312593", .mem =
                                  futhark_mc_task_338954->free_mem_312593,
                                  .size =0, .references =NULL};
    struct memblock mem_315656 = {.desc ="mem_315656", .mem =
                                  futhark_mc_task_338954->free_mem_315656,
                                  .size =0, .references =NULL};
    struct memblock mem_316052 = {.desc ="mem_316052", .mem =
                                  futhark_mc_task_338954->free_mem_316052,
                                  .size =0, .references =NULL};
    int64_t iter_334684;
    struct futhark_mc_segmap_parloop_struct_338956
    futhark_mc_segmap_parloop_struct_338956;
    
    futhark_mc_segmap_parloop_struct_338956.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338956.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_338956.free_gtid_308818 = gtid_308818;
    futhark_mc_segmap_parloop_struct_338956.free_mem_312593 = mem_312593.mem;
    futhark_mc_segmap_parloop_struct_338956.free_mem_315656 = mem_315656.mem;
    futhark_mc_segmap_parloop_struct_338956.free_mem_316052 = mem_316052.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338957_task;
    
    futhark_mc_segmap_parloop_338957_task.name =
        "futhark_mc_segmap_parloop_338957";
    futhark_mc_segmap_parloop_338957_task.fn = futhark_mc_segmap_parloop_338957;
    futhark_mc_segmap_parloop_338957_task.args =
        &futhark_mc_segmap_parloop_struct_338956;
    futhark_mc_segmap_parloop_338957_task.iterations = iterations;
    futhark_mc_segmap_parloop_338957_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338957_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338957_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338957_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338957_task);
    
    if (futhark_mc_segmap_parloop_338957_err != 0) {
        err = futhark_mc_segmap_parloop_338957_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338957_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338957_total_end -
                 futhark_mc_segmap_parloop_338957_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338957_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338957_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338957_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_338955_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_338955_end -
                 futhark_mc_segmap_task_338955_start;
        
        ctx->futhark_mc_segmap_task_338955_runs[tid]++;
        ctx->futhark_mc_segmap_task_338955_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_338955_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_task_338958 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_308818;
    unsigned char *free_mem_312636;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_316052;
    unsigned char *free_mem_316055;
    unsigned char *free_mem_316058;
};
struct futhark_mc_segmap_parloop_struct_338960 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_308818;
    unsigned char *free_mem_312636;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_316052;
    unsigned char *free_mem_316055;
    unsigned char *free_mem_316058;
};
static int futhark_mc_segmap_parloop_338961(void *args, int64_t start,
                                            int64_t end, int flat_tid_334508,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338960
    *futhark_mc_segmap_parloop_struct_338960 =
    (struct futhark_mc_segmap_parloop_struct_338960 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338960->ctx;
    uint64_t futhark_mc_segmap_parloop_338961_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338961_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_338960->free_n_292675;
    int64_t gtid_308818 =
            futhark_mc_segmap_parloop_struct_338960->free_gtid_308818;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_segmap_parloop_struct_338960->free_mem_312636,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_segmap_parloop_struct_338960->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_segmap_parloop_struct_338960->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_segmap_parloop_struct_338960->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_segmap_parloop_struct_338960->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_316052 = {.desc ="mem_316052", .mem =
                                  futhark_mc_segmap_parloop_struct_338960->free_mem_316052,
                                  .size =0, .references =NULL};
    struct memblock mem_316055 = {.desc ="mem_316055", .mem =
                                  futhark_mc_segmap_parloop_struct_338960->free_mem_316055,
                                  .size =0, .references =NULL};
    struct memblock mem_316058 = {.desc ="mem_316058", .mem =
                                  futhark_mc_segmap_parloop_struct_338960->free_mem_316058,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_334688 = start;
    
    for (; iter_334688 < end; iter_334688++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_334697 = n_292675;
        int64_t gtid_334509 = iter_334688;
        int64_t remnant_334698 = iter_334688 - gtid_334509;
        int64_t x_334510;
        
        x_334510 = ((int64_t *) mem_312636.mem)[gtid_308818 * n_292675 +
                                                gtid_334509];
        
        bool cond_334511 = sle64((int64_t) 0, x_334510);
        double defunc_0_f_res_334512;
        
        if (cond_334511) {
            bool y_334689 = slt64(x_334510, n_292675);
            bool bounds_check_334690 = cond_334511 && y_334689;
            bool index_certs_334691;
            
            if (!bounds_check_334690) {
                ctx->error =
                    msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                              "Index [", (long long) x_334510,
                              "] out of bounds for array of shape [",
                              (long long) n_292675, "].",
                              "-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:45:43-70\n   #3  stl.fut:285:33-58\n   #4  /prelude/soacs.fut:75:22-28\n   #5  /prelude/soacs.fut:75:3-45\n   #6  stl.fut:283:13-288:41\n   #7  stl.fut:419:61-435:77\n   #8  stl.fut:463:3-479:36\n   #9  stl.fut:445:1-479:36\n");
                err = FUTHARK_PROGRAM_ERROR;
                goto cleanup;
            }
            
            double defunc_0_f_res_t_res_334692;
            
            defunc_0_f_res_t_res_334692 = ((double *) mem_316052.mem)[x_334510];
            defunc_0_f_res_334512 = defunc_0_f_res_t_res_334692;
        } else {
            defunc_0_f_res_334512 = 0.0;
        }
        
        double defunc_0_f_res_334517;
        
        if (cond_334511) {
            bool y_334693 = slt64(x_334510, n_292675);
            bool bounds_check_334694 = cond_334511 && y_334693;
            bool index_certs_334695;
            
            if (!bounds_check_334694) {
                ctx->error =
                    msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                              "Index [", (long long) x_334510,
                              "] out of bounds for array of shape [",
                              (long long) n_292675, "].",
                              "-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:45:43-70\n   #3  stl.fut:286:33-64\n   #4  /prelude/soacs.fut:75:22-28\n   #5  /prelude/soacs.fut:75:3-45\n   #6  stl.fut:283:13-288:41\n   #7  stl.fut:419:61-435:77\n   #8  stl.fut:463:3-479:36\n   #9  stl.fut:445:1-479:36\n");
                err = FUTHARK_PROGRAM_ERROR;
                goto cleanup;
            }
            
            double defunc_0_f_res_t_res_334696;
            
            defunc_0_f_res_t_res_334696 =
                ((double *) mem_param_313179.mem)[ctx_param_ext_313174 +
                                                  (gtid_308818 *
                                                   ctx_param_ext_313175 +
                                                   x_334510 *
                                                   ctx_param_ext_313177)];
            defunc_0_f_res_334517 = defunc_0_f_res_t_res_334696;
        } else {
            defunc_0_f_res_334517 = 0.0;
        }
        ((double *) mem_316055.mem)[gtid_334509] = defunc_0_f_res_334517;
        ((double *) mem_316058.mem)[gtid_334509] = defunc_0_f_res_334512;
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338961_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338961_end -
                 futhark_mc_segmap_parloop_338961_start;
        
        ctx->futhark_mc_segmap_parloop_338961_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338961_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338961_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_338959(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_334508 = tid;
    int num_tasks_334687 = info.nsubtasks;
    struct futhark_mc_task_338958 *futhark_mc_task_338958 =
                                  (struct futhark_mc_task_338958 *) args;
    struct futhark_context *ctx = futhark_mc_task_338958->ctx;
    uint64_t futhark_mc_segmap_task_338959_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_338959_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338958->free_n_292675;
    int64_t gtid_308818 = futhark_mc_task_338958->free_gtid_308818;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_task_338958->free_mem_312636,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_task_338958->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_task_338958->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_task_338958->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_task_338958->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_316052 = {.desc ="mem_316052", .mem =
                                  futhark_mc_task_338958->free_mem_316052,
                                  .size =0, .references =NULL};
    struct memblock mem_316055 = {.desc ="mem_316055", .mem =
                                  futhark_mc_task_338958->free_mem_316055,
                                  .size =0, .references =NULL};
    struct memblock mem_316058 = {.desc ="mem_316058", .mem =
                                  futhark_mc_task_338958->free_mem_316058,
                                  .size =0, .references =NULL};
    int64_t iter_334688;
    struct futhark_mc_segmap_parloop_struct_338960
    futhark_mc_segmap_parloop_struct_338960;
    
    futhark_mc_segmap_parloop_struct_338960.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338960.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_338960.free_gtid_308818 = gtid_308818;
    futhark_mc_segmap_parloop_struct_338960.free_mem_312636 = mem_312636.mem;
    futhark_mc_segmap_parloop_struct_338960.free_ctx_param_ext_313174 =
        ctx_param_ext_313174;
    futhark_mc_segmap_parloop_struct_338960.free_ctx_param_ext_313175 =
        ctx_param_ext_313175;
    futhark_mc_segmap_parloop_struct_338960.free_ctx_param_ext_313177 =
        ctx_param_ext_313177;
    futhark_mc_segmap_parloop_struct_338960.free_mem_param_313179 =
        mem_param_313179.mem;
    futhark_mc_segmap_parloop_struct_338960.free_mem_316052 = mem_316052.mem;
    futhark_mc_segmap_parloop_struct_338960.free_mem_316055 = mem_316055.mem;
    futhark_mc_segmap_parloop_struct_338960.free_mem_316058 = mem_316058.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338961_task;
    
    futhark_mc_segmap_parloop_338961_task.name =
        "futhark_mc_segmap_parloop_338961";
    futhark_mc_segmap_parloop_338961_task.fn = futhark_mc_segmap_parloop_338961;
    futhark_mc_segmap_parloop_338961_task.args =
        &futhark_mc_segmap_parloop_struct_338960;
    futhark_mc_segmap_parloop_338961_task.iterations = iterations;
    futhark_mc_segmap_parloop_338961_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338961_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338961_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338961_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338961_task);
    
    if (futhark_mc_segmap_parloop_338961_err != 0) {
        err = futhark_mc_segmap_parloop_338961_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338961_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338961_total_end -
                 futhark_mc_segmap_parloop_338961_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338961_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338961_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338961_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_338959_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_338959_end -
                 futhark_mc_segmap_task_338959_start;
        
        ctx->futhark_mc_segmap_task_338959_runs[tid]++;
        ctx->futhark_mc_segmap_task_338959_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_338959_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_task_338962 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_t_292679;
    int64_t free_jump_t_292685;
    int64_t free_t_n_m_292839;
    int64_t free_i_292846;
    int64_t free_gtid_308818;
    int64_t free_x_308823;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_313143;
    unsigned char *free_mem_313147;
    unsigned char *free_mem_316055;
    unsigned char *free_mem_316058;
    int64_t free_bytes_316060;
    unsigned char *free_mem_316097;
    unsigned char *free_mem_316100;
};
struct futhark_mc_segmap_parloop_struct_338964 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_t_292679;
    int64_t free_jump_t_292685;
    int64_t free_t_n_m_292839;
    int64_t free_i_292846;
    int64_t free_gtid_308818;
    int64_t free_x_308823;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_313143;
    unsigned char *free_mem_313147;
    unsigned char *free_mem_316055;
    unsigned char *free_mem_316058;
    int64_t free_bytes_316060;
    unsigned char *free_mem_316097;
    unsigned char *free_mem_316100;
};
static int futhark_mc_segmap_parloop_338965(void *args, int64_t start,
                                            int64_t end, int flat_tid_334602,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338964
    *futhark_mc_segmap_parloop_struct_338964 =
    (struct futhark_mc_segmap_parloop_struct_338964 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338964->ctx;
    uint64_t futhark_mc_segmap_parloop_338965_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338965_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_338964->free_n_292675;
    int64_t q_t_292679 =
            futhark_mc_segmap_parloop_struct_338964->free_q_t_292679;
    int64_t jump_t_292685 =
            futhark_mc_segmap_parloop_struct_338964->free_jump_t_292685;
    int64_t t_n_m_292839 =
            futhark_mc_segmap_parloop_struct_338964->free_t_n_m_292839;
    int64_t i_292846 = futhark_mc_segmap_parloop_struct_338964->free_i_292846;
    int64_t gtid_308818 =
            futhark_mc_segmap_parloop_struct_338964->free_gtid_308818;
    int64_t x_308823 = futhark_mc_segmap_parloop_struct_338964->free_x_308823;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_segmap_parloop_struct_338964->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_313143 = {.desc ="mem_313143", .mem =
                                  futhark_mc_segmap_parloop_struct_338964->free_mem_313143,
                                  .size =0, .references =NULL};
    struct memblock mem_313147 = {.desc ="mem_313147", .mem =
                                  futhark_mc_segmap_parloop_struct_338964->free_mem_313147,
                                  .size =0, .references =NULL};
    struct memblock mem_316055 = {.desc ="mem_316055", .mem =
                                  futhark_mc_segmap_parloop_struct_338964->free_mem_316055,
                                  .size =0, .references =NULL};
    struct memblock mem_316058 = {.desc ="mem_316058", .mem =
                                  futhark_mc_segmap_parloop_struct_338964->free_mem_316058,
                                  .size =0, .references =NULL};
    int64_t bytes_316060 =
            futhark_mc_segmap_parloop_struct_338964->free_bytes_316060;
    struct memblock mem_316097 = {.desc ="mem_316097", .mem =
                                  futhark_mc_segmap_parloop_struct_338964->free_mem_316097,
                                  .size =0, .references =NULL};
    struct memblock mem_316100 = {.desc ="mem_316100", .mem =
                                  futhark_mc_segmap_parloop_struct_338964->free_mem_316100,
                                  .size =0, .references =NULL};
    size_t mem_334609_cached_sizze_338966 = 0;
    unsigned char *mem_334609 = NULL;
    size_t mem_334611_cached_sizze_338967 = 0;
    unsigned char *mem_334611 = NULL;
    int64_t iterations = end - start;
    int64_t iter_334700 = start;
    
    if (mem_334609_cached_sizze_338966 < (size_t) bytes_316060) {
        mem_334609 = realloc(mem_334609, bytes_316060);
        mem_334609_cached_sizze_338966 = bytes_316060;
    }
    if (mem_334611_cached_sizze_338967 < (size_t) bytes_316060) {
        mem_334611 = realloc(mem_334611, bytes_316060);
        mem_334611_cached_sizze_338967 = bytes_316060;
    }
    for (; iter_334700 < end; iter_334700++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_334751 = t_n_m_292839;
        int64_t gtid_334603 = iter_334700;
        int64_t remnant_334752 = iter_334700 - gtid_334603;
        int64_t x_334604;
        
        x_334604 = ((int64_t *) mem_313143.mem)[gtid_308818 * t_n_m_292839 +
                                                gtid_334603];
        
        double x_334605;
        
        x_334605 = ((double *) mem_313147.mem)[gtid_308818 * t_n_m_292839 +
                                               gtid_334603];
        
        int64_t min_arg_334606 = mul64(jump_t_292685, gtid_334603);
        int64_t min_res_334607 = smin64(i_292846, min_arg_334606);
        int64_t defunc_0_g_res_334608 = add64((int64_t) 1, min_res_334607);
        double defunc_2_reduce_res_334613;
        double defunc_2_reduce_res_334614;
        double defunc_2_reduce_res_334615;
        double redout_334702;
        double redout_334703;
        double redout_334704;
        
        redout_334702 = 0.0;
        redout_334703 = 0.0;
        redout_334704 = 0.0;
        for (int64_t i_334701 = 0; i_334701 < q_t_292679; i_334701++) {
            bool cond_334707 = sle64(x_308823, i_334701);
            int64_t defunc_0_f_res_334708;
            
            if (cond_334707) {
                defunc_0_f_res_334708 = (int64_t) 0;
            } else {
                int64_t i_334709 = add64(x_334604, i_334701);
                int64_t defunc_0_add_arg_334710;
                
                defunc_0_add_arg_334710 =
                    ((int64_t *) mem_312636.mem)[gtid_308818 * n_292675 +
                                                 i_334709];
                
                int64_t defunc_1_add_res_334711 = add64((int64_t) 1,
                                                        defunc_0_add_arg_334710);
                
                defunc_0_f_res_334708 = defunc_1_add_res_334711;
            }
            
            double defunc_0_f_res_334712;
            
            if (cond_334707) {
                defunc_0_f_res_334712 = 0.0;
            } else {
                int64_t i_334713 = add64(x_334604, i_334701);
                double defunc_0_add_arg_334714;
                
                defunc_0_add_arg_334714 = ((double *) mem_316055.mem)[i_334713];
                defunc_0_f_res_334712 = defunc_0_add_arg_334714;
            }
            
            int64_t binop_p_334715 = sub64(defunc_0_f_res_334708,
                                           defunc_0_g_res_334608);
            double defunc_0_f_res_334716 = sitofp_i64_f64(binop_p_334715);
            double abs_res_334717 = fabs(defunc_0_f_res_334716);
            double tmp1_334718 = abs_res_334717 / x_334605;
            double x_334719 = tmp1_334718 * tmp1_334718;
            double y_334720 = tmp1_334718 * x_334719;
            double tmp2_334721 = 1.0 - y_334720;
            double x_334722 = tmp2_334721 * tmp2_334721;
            double tmp3_334723 = tmp2_334721 * x_334722;
            double tmp4_334724 = defunc_0_f_res_334712 * tmp3_334723;
            double defunc_1_f_res_334725 = defunc_0_f_res_334716 * tmp4_334724;
            double defunc_1_f_res_334726 = defunc_0_f_res_334716 *
                   defunc_1_f_res_334725;
            double defunc_1_op_res_334727 = tmp4_334724 + redout_334702;
            double defunc_1_op_res_334728 = defunc_1_f_res_334725 +
                   redout_334703;
            double defunc_1_op_res_334729 = defunc_1_f_res_334726 +
                   redout_334704;
            
            ((double *) mem_334609)[i_334701] = defunc_1_f_res_334725;
            ((double *) mem_334611)[i_334701] = tmp4_334724;
            
            double redout_tmp_334753 = defunc_1_op_res_334727;
            double redout_tmp_334754 = defunc_1_op_res_334728;
            double redout_tmp_334755 = defunc_1_op_res_334729;
            
            redout_334702 = redout_tmp_334753;
            redout_334703 = redout_tmp_334754;
            redout_334704 = redout_tmp_334755;
        }
        defunc_2_reduce_res_334613 = redout_334702;
        defunc_2_reduce_res_334614 = redout_334703;
        defunc_2_reduce_res_334615 = redout_334704;
        
        double a_334649 = 2.220446049250313e-16 + defunc_2_reduce_res_334613;
        double b_334650 = 2.220446049250313e-16 + defunc_2_reduce_res_334614;
        double c_334651 = 2.220446049250313e-16 + defunc_2_reduce_res_334615;
        double x_334652 = a_334649 * c_334651;
        double y_334653 = b_334650 * b_334650;
        double y_334654 = x_334652 - y_334653;
        double det1_334655 = 1.0 / y_334654;
        double a11_334656 = c_334651 * det1_334655;
        double x_334657 = 0.0 - b_334650;
        double b11_334658 = det1_334655 * x_334657;
        double c11_334659 = a_334649 * det1_334655;
        double defunc_2_reduce_res_334660;
        double defunc_2_reduce_res_334661;
        double redout_334733;
        double redout_334734;
        
        redout_334733 = 0.0;
        redout_334734 = 0.0;
        for (int64_t i_334732 = 0; i_334732 < q_t_292679; i_334732++) {
            double x_334735;
            
            x_334735 = ((double *) mem_334611)[i_334732];
            
            double x_334736;
            
            x_334736 = ((double *) mem_334609)[i_334732];
            
            bool cond_334737 = sle64(x_308823, i_334732);
            double defunc_0_f_res_334738;
            
            if (cond_334737) {
                defunc_0_f_res_334738 = 0.0;
            } else {
                int64_t i_334739 = add64(x_334604, i_334732);
                double defunc_0_add_arg_334740;
                
                defunc_0_add_arg_334740 = ((double *) mem_316058.mem)[i_334739];
                defunc_0_f_res_334738 = defunc_0_add_arg_334740;
            }
            
            double x_334741 = a11_334656 * x_334735;
            double y_334742 = b11_334658 * x_334736;
            double x_334743 = x_334741 + y_334742;
            double defunc_9_fit_fun_res_334744 = defunc_0_f_res_334738 *
                   x_334743;
            double x_334745 = b11_334658 * x_334735;
            double y_334746 = c11_334659 * x_334736;
            double x_334747 = x_334745 + y_334746;
            double defunc_9_slope_fun_res_334748 = defunc_0_f_res_334738 *
                   x_334747;
            double defunc_1_op_res_334749 = defunc_9_fit_fun_res_334744 +
                   redout_334733;
            double defunc_1_op_res_334750 = defunc_9_slope_fun_res_334748 +
                   redout_334734;
            double redout_tmp_334758 = defunc_1_op_res_334749;
            double redout_tmp_334759 = defunc_1_op_res_334750;
            
            redout_334733 = redout_tmp_334758;
            redout_334734 = redout_tmp_334759;
        }
        defunc_2_reduce_res_334660 = redout_334733;
        defunc_2_reduce_res_334661 = redout_334734;
        ((double *) mem_316097.mem)[gtid_334603] = defunc_2_reduce_res_334660;
        ((double *) mem_316100.mem)[gtid_334603] = defunc_2_reduce_res_334661;
    }
    
  cleanup:
    { }
    free(mem_334609);
    free(mem_334611);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338965_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338965_end -
                 futhark_mc_segmap_parloop_338965_start;
        
        ctx->futhark_mc_segmap_parloop_338965_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338965_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338965_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_338963(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_334602 = tid;
    int num_tasks_334699 = info.nsubtasks;
    struct futhark_mc_task_338962 *futhark_mc_task_338962 =
                                  (struct futhark_mc_task_338962 *) args;
    struct futhark_context *ctx = futhark_mc_task_338962->ctx;
    uint64_t futhark_mc_segmap_task_338963_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_338963_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338962->free_n_292675;
    int64_t q_t_292679 = futhark_mc_task_338962->free_q_t_292679;
    int64_t jump_t_292685 = futhark_mc_task_338962->free_jump_t_292685;
    int64_t t_n_m_292839 = futhark_mc_task_338962->free_t_n_m_292839;
    int64_t i_292846 = futhark_mc_task_338962->free_i_292846;
    int64_t gtid_308818 = futhark_mc_task_338962->free_gtid_308818;
    int64_t x_308823 = futhark_mc_task_338962->free_x_308823;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_task_338962->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_313143 = {.desc ="mem_313143", .mem =
                                  futhark_mc_task_338962->free_mem_313143,
                                  .size =0, .references =NULL};
    struct memblock mem_313147 = {.desc ="mem_313147", .mem =
                                  futhark_mc_task_338962->free_mem_313147,
                                  .size =0, .references =NULL};
    struct memblock mem_316055 = {.desc ="mem_316055", .mem =
                                  futhark_mc_task_338962->free_mem_316055,
                                  .size =0, .references =NULL};
    struct memblock mem_316058 = {.desc ="mem_316058", .mem =
                                  futhark_mc_task_338962->free_mem_316058,
                                  .size =0, .references =NULL};
    int64_t bytes_316060 = futhark_mc_task_338962->free_bytes_316060;
    struct memblock mem_316097 = {.desc ="mem_316097", .mem =
                                  futhark_mc_task_338962->free_mem_316097,
                                  .size =0, .references =NULL};
    struct memblock mem_316100 = {.desc ="mem_316100", .mem =
                                  futhark_mc_task_338962->free_mem_316100,
                                  .size =0, .references =NULL};
    int64_t iter_334700;
    struct futhark_mc_segmap_parloop_struct_338964
    futhark_mc_segmap_parloop_struct_338964;
    
    futhark_mc_segmap_parloop_struct_338964.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338964.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_338964.free_q_t_292679 = q_t_292679;
    futhark_mc_segmap_parloop_struct_338964.free_jump_t_292685 = jump_t_292685;
    futhark_mc_segmap_parloop_struct_338964.free_t_n_m_292839 = t_n_m_292839;
    futhark_mc_segmap_parloop_struct_338964.free_i_292846 = i_292846;
    futhark_mc_segmap_parloop_struct_338964.free_gtid_308818 = gtid_308818;
    futhark_mc_segmap_parloop_struct_338964.free_x_308823 = x_308823;
    futhark_mc_segmap_parloop_struct_338964.free_mem_312636 = mem_312636.mem;
    futhark_mc_segmap_parloop_struct_338964.free_mem_313143 = mem_313143.mem;
    futhark_mc_segmap_parloop_struct_338964.free_mem_313147 = mem_313147.mem;
    futhark_mc_segmap_parloop_struct_338964.free_mem_316055 = mem_316055.mem;
    futhark_mc_segmap_parloop_struct_338964.free_mem_316058 = mem_316058.mem;
    futhark_mc_segmap_parloop_struct_338964.free_bytes_316060 = bytes_316060;
    futhark_mc_segmap_parloop_struct_338964.free_mem_316097 = mem_316097.mem;
    futhark_mc_segmap_parloop_struct_338964.free_mem_316100 = mem_316100.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338965_task;
    
    futhark_mc_segmap_parloop_338965_task.name =
        "futhark_mc_segmap_parloop_338965";
    futhark_mc_segmap_parloop_338965_task.fn = futhark_mc_segmap_parloop_338965;
    futhark_mc_segmap_parloop_338965_task.args =
        &futhark_mc_segmap_parloop_struct_338964;
    futhark_mc_segmap_parloop_338965_task.iterations = iterations;
    futhark_mc_segmap_parloop_338965_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338965_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338965_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338965_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338965_task);
    
    if (futhark_mc_segmap_parloop_338965_err != 0) {
        err = futhark_mc_segmap_parloop_338965_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338965_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338965_total_end -
                 futhark_mc_segmap_parloop_338965_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338965_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338965_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338965_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_338963_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_338963_end -
                 futhark_mc_segmap_task_338963_start;
        
        ctx->futhark_mc_segmap_task_338963_runs[tid]++;
        ctx->futhark_mc_segmap_task_338963_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_338963_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_segmap_parloop_struct_338969 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_t_292679;
    int64_t free_jump_t_292685;
    int64_t free_t_n_m_292839;
    int64_t free_i_292846;
    int64_t free_gtid_308818;
    int64_t free_x_308823;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_313143;
    unsigned char *free_mem_313147;
    unsigned char *free_mem_316055;
    unsigned char *free_mem_316058;
    int64_t free_bytes_316060;
    unsigned char *free_mem_316097;
    unsigned char *free_mem_316100;
};
struct futhark_mc_task_338973 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_308818;
    int64_t free_x_308823;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_316055;
    int64_t free_x_334524;
    double free_x_334525;
    int64_t free_defunc_0_g_res_334528;
    double *retval_defunc_2_reduce_res_334531;
    double *retval_defunc_2_reduce_res_334532;
    double *retval_defunc_2_reduce_res_334533;
    unsigned char *retval_mem_334529;
    unsigned char *retval_mem_334530;
};
struct futhark_mc_segred_stage_1_parloop_struct_338978 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_308818;
    int64_t free_x_308823;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_316055;
    int64_t free_x_334524;
    double free_x_334525;
    int64_t free_defunc_0_g_res_334528;
    unsigned char *free_mem_334529;
    unsigned char *free_mem_334530;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_334817;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_334819;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_334821;
};
static int futhark_mc_segred_stage_1_parloop_338979(void *args, int64_t start,
                                                    int64_t end,
                                                    int flat_tid_334761,
                                                    int tid)
{
    int err = 0;
    struct futhark_mc_segred_stage_1_parloop_struct_338978
    *futhark_mc_segred_stage_1_parloop_struct_338978 =
    (struct futhark_mc_segred_stage_1_parloop_struct_338978 *) args;
    struct futhark_context *ctx =
                           futhark_mc_segred_stage_1_parloop_struct_338978->ctx;
    uint64_t futhark_mc_segred_stage_1_parloop_338979_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_338979_start = get_wall_time();
    
    int64_t n_292675 =
            futhark_mc_segred_stage_1_parloop_struct_338978->free_n_292675;
    int64_t gtid_308818 =
            futhark_mc_segred_stage_1_parloop_struct_338978->free_gtid_308818;
    int64_t x_308823 =
            futhark_mc_segred_stage_1_parloop_struct_338978->free_x_308823;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_338978->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_316055 = {.desc ="mem_316055", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_338978->free_mem_316055,
                                  .size =0, .references =NULL};
    int64_t x_334524 =
            futhark_mc_segred_stage_1_parloop_struct_338978->free_x_334524;
    double x_334525 =
           futhark_mc_segred_stage_1_parloop_struct_338978->free_x_334525;
    int64_t defunc_0_g_res_334528 =
            futhark_mc_segred_stage_1_parloop_struct_338978->free_defunc_0_g_res_334528;
    struct memblock mem_334529 = {.desc ="mem_334529", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_338978->free_mem_334529,
                                  .size =0, .references =NULL};
    struct memblock mem_334530 = {.desc ="mem_334530", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_338978->free_mem_334530,
                                  .size =0, .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_334817 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_334817",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338978->free_reduce_stage_1_tid_res_arr_mem_334817,
                                                             .size =0,
                                                             .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_334819 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_334819",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338978->free_reduce_stage_1_tid_res_arr_mem_334819,
                                                             .size =0,
                                                             .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_334821 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_334821",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338978->free_reduce_stage_1_tid_res_arr_mem_334821,
                                                             .size =0,
                                                             .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_334823 = start;
    double x_334763;
    double x_334764;
    double x_334766;
    double x_334767;
    double x_334769;
    double x_334770;
    double local_acc_334824 = 0.0;
    double local_acc_334825 = 0.0;
    double local_acc_334826 = 0.0;
    
    for (; iter_334823 < end; iter_334823++) {
        int64_t gtid_334762 = iter_334823;
        bool cond_334772 = sle64(x_308823, gtid_334762);
        int64_t defunc_0_f_res_334773;
        
        if (cond_334772) {
            defunc_0_f_res_334773 = (int64_t) 0;
        } else {
            int64_t i_334774 = add64(x_334524, gtid_334762);
            int64_t defunc_0_add_arg_334775;
            
            defunc_0_add_arg_334775 = ((int64_t *) mem_312636.mem)[gtid_308818 *
                                                                   n_292675 +
                                                                   i_334774];
            
            int64_t defunc_1_add_res_334776 = add64((int64_t) 1,
                                                    defunc_0_add_arg_334775);
            
            defunc_0_f_res_334773 = defunc_1_add_res_334776;
        }
        
        double defunc_0_f_res_334777;
        
        if (cond_334772) {
            defunc_0_f_res_334777 = 0.0;
        } else {
            int64_t i_334778 = add64(x_334524, gtid_334762);
            double defunc_0_add_arg_334779;
            
            defunc_0_add_arg_334779 = ((double *) mem_316055.mem)[i_334778];
            defunc_0_f_res_334777 = defunc_0_add_arg_334779;
        }
        
        int64_t binop_p_334780 = sub64(defunc_0_f_res_334773,
                                       defunc_0_g_res_334528);
        double defunc_0_f_res_334781 = sitofp_i64_f64(binop_p_334780);
        double abs_res_334782 = fabs(defunc_0_f_res_334781);
        double tmp1_334783 = abs_res_334782 / x_334525;
        double x_334784 = tmp1_334783 * tmp1_334783;
        double y_334785 = tmp1_334783 * x_334784;
        double tmp2_334786 = 1.0 - y_334785;
        double x_334787 = tmp2_334786 * tmp2_334786;
        double tmp3_334788 = tmp2_334786 * x_334787;
        double tmp4_334789 = defunc_0_f_res_334777 * tmp3_334788;
        double defunc_1_f_res_334790 = defunc_0_f_res_334781 * tmp4_334789;
        double defunc_1_f_res_334791 = defunc_0_f_res_334781 *
               defunc_1_f_res_334790;
        
        // save map-out results
        {
            ((double *) mem_334529.mem)[gtid_334762] = defunc_1_f_res_334790;
            ((double *) mem_334530.mem)[gtid_334762] = tmp4_334789;
        }
        // Load accum params
        {
            x_334763 = local_acc_334824;
        }
        // Load next params
        {
            x_334764 = tmp4_334789;
        }
        // Red body
        {
            double defunc_1_op_res_334765 = x_334763 + x_334764;
            
            local_acc_334824 = defunc_1_op_res_334765;
        }
        // Load accum params
        {
            x_334766 = local_acc_334825;
        }
        // Load next params
        {
            x_334767 = defunc_1_f_res_334790;
        }
        // Red body
        {
            double defunc_1_op_res_334768 = x_334766 + x_334767;
            
            local_acc_334825 = defunc_1_op_res_334768;
        }
        // Load accum params
        {
            x_334769 = local_acc_334826;
        }
        // Load next params
        {
            x_334770 = defunc_1_f_res_334791;
        }
        // Red body
        {
            double defunc_1_op_res_334771 = x_334769 + x_334770;
            
            local_acc_334826 = defunc_1_op_res_334771;
        }
    }
    ((double *) reduce_stage_1_tid_res_arr_mem_334817.mem)[flat_tid_334761] =
        local_acc_334824;
    ((double *) reduce_stage_1_tid_res_arr_mem_334819.mem)[flat_tid_334761] =
        local_acc_334825;
    ((double *) reduce_stage_1_tid_res_arr_mem_334821.mem)[flat_tid_334761] =
        local_acc_334826;
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_338979_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_338979_end -
                 futhark_mc_segred_stage_1_parloop_338979_start;
        
        ctx->futhark_mc_segred_stage_1_parloop_338979_runs[tid]++;
        ctx->futhark_mc_segred_stage_1_parloop_338979_total_runtime[tid] +=
            elapsed;
        ctx->futhark_mc_segred_stage_1_parloop_338979_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segred_task_338974(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_334761 = tid;
    int num_tasks_334816 = info.nsubtasks;
    struct futhark_mc_task_338973 *futhark_mc_task_338973 =
                                  (struct futhark_mc_task_338973 *) args;
    struct futhark_context *ctx = futhark_mc_task_338973->ctx;
    uint64_t futhark_mc_segred_task_338974_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_task_338974_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338973->free_n_292675;
    int64_t gtid_308818 = futhark_mc_task_338973->free_gtid_308818;
    int64_t x_308823 = futhark_mc_task_338973->free_x_308823;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_task_338973->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_316055 = {.desc ="mem_316055", .mem =
                                  futhark_mc_task_338973->free_mem_316055,
                                  .size =0, .references =NULL};
    int64_t x_334524 = futhark_mc_task_338973->free_x_334524;
    double x_334525 = futhark_mc_task_338973->free_x_334525;
    int64_t defunc_0_g_res_334528 =
            futhark_mc_task_338973->free_defunc_0_g_res_334528;
    double defunc_2_reduce_res_334531 =
           *futhark_mc_task_338973->retval_defunc_2_reduce_res_334531;
    double defunc_2_reduce_res_334532 =
           *futhark_mc_task_338973->retval_defunc_2_reduce_res_334532;
    double defunc_2_reduce_res_334533 =
           *futhark_mc_task_338973->retval_defunc_2_reduce_res_334533;
    struct memblock mem_334529 = {.desc ="mem_334529", .mem =
                                  futhark_mc_task_338973->retval_mem_334529,
                                  .size =0, .references =NULL};
    struct memblock mem_334530 = {.desc ="mem_334530", .mem =
                                  futhark_mc_task_338973->retval_mem_334530,
                                  .size =0, .references =NULL};
    size_t reduce_stage_1_tid_res_arr_mem_334817_cached_sizze_338975 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_334817 = NULL;
    size_t reduce_stage_1_tid_res_arr_mem_334819_cached_sizze_338976 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_334819 = NULL;
    size_t reduce_stage_1_tid_res_arr_mem_334821_cached_sizze_338977 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_334821 = NULL;
    
    if (reduce_stage_1_tid_res_arr_mem_334817_cached_sizze_338975 <
        (size_t) ((int64_t) 8 * num_tasks_334816)) {
        reduce_stage_1_tid_res_arr_mem_334817 =
            realloc(reduce_stage_1_tid_res_arr_mem_334817, (int64_t) 8 *
                    num_tasks_334816);
        reduce_stage_1_tid_res_arr_mem_334817_cached_sizze_338975 =
            (int64_t) 8 * num_tasks_334816;
    }
    if (reduce_stage_1_tid_res_arr_mem_334819_cached_sizze_338976 <
        (size_t) ((int64_t) 8 * num_tasks_334816)) {
        reduce_stage_1_tid_res_arr_mem_334819 =
            realloc(reduce_stage_1_tid_res_arr_mem_334819, (int64_t) 8 *
                    num_tasks_334816);
        reduce_stage_1_tid_res_arr_mem_334819_cached_sizze_338976 =
            (int64_t) 8 * num_tasks_334816;
    }
    if (reduce_stage_1_tid_res_arr_mem_334821_cached_sizze_338977 <
        (size_t) ((int64_t) 8 * num_tasks_334816)) {
        reduce_stage_1_tid_res_arr_mem_334821 =
            realloc(reduce_stage_1_tid_res_arr_mem_334821, (int64_t) 8 *
                    num_tasks_334816);
        reduce_stage_1_tid_res_arr_mem_334821_cached_sizze_338977 =
            (int64_t) 8 * num_tasks_334816;
    }
    
    int64_t iter_334823;
    struct futhark_mc_segred_stage_1_parloop_struct_338978
    futhark_mc_segred_stage_1_parloop_struct_338978;
    
    futhark_mc_segred_stage_1_parloop_struct_338978.ctx = ctx;
    futhark_mc_segred_stage_1_parloop_struct_338978.free_n_292675 = n_292675;
    futhark_mc_segred_stage_1_parloop_struct_338978.free_gtid_308818 =
        gtid_308818;
    futhark_mc_segred_stage_1_parloop_struct_338978.free_x_308823 = x_308823;
    futhark_mc_segred_stage_1_parloop_struct_338978.free_mem_312636 =
        mem_312636.mem;
    futhark_mc_segred_stage_1_parloop_struct_338978.free_mem_316055 =
        mem_316055.mem;
    futhark_mc_segred_stage_1_parloop_struct_338978.free_x_334524 = x_334524;
    futhark_mc_segred_stage_1_parloop_struct_338978.free_x_334525 = x_334525;
    futhark_mc_segred_stage_1_parloop_struct_338978.free_defunc_0_g_res_334528 =
        defunc_0_g_res_334528;
    futhark_mc_segred_stage_1_parloop_struct_338978.free_mem_334529 =
        mem_334529.mem;
    futhark_mc_segred_stage_1_parloop_struct_338978.free_mem_334530 =
        mem_334530.mem;
    futhark_mc_segred_stage_1_parloop_struct_338978.free_reduce_stage_1_tid_res_arr_mem_334817 =
        reduce_stage_1_tid_res_arr_mem_334817;
    futhark_mc_segred_stage_1_parloop_struct_338978.free_reduce_stage_1_tid_res_arr_mem_334819 =
        reduce_stage_1_tid_res_arr_mem_334819;
    futhark_mc_segred_stage_1_parloop_struct_338978.free_reduce_stage_1_tid_res_arr_mem_334821 =
        reduce_stage_1_tid_res_arr_mem_334821;
    
    struct scheduler_parloop futhark_mc_segred_stage_1_parloop_338979_task;
    
    futhark_mc_segred_stage_1_parloop_338979_task.name =
        "futhark_mc_segred_stage_1_parloop_338979";
    futhark_mc_segred_stage_1_parloop_338979_task.fn =
        futhark_mc_segred_stage_1_parloop_338979;
    futhark_mc_segred_stage_1_parloop_338979_task.args =
        &futhark_mc_segred_stage_1_parloop_struct_338978;
    futhark_mc_segred_stage_1_parloop_338979_task.iterations = iterations;
    futhark_mc_segred_stage_1_parloop_338979_task.info = info;
    
    uint64_t futhark_mc_segred_stage_1_parloop_338979_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_338979_total_start = get_wall_time();
    
    int futhark_mc_segred_stage_1_parloop_338979_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segred_stage_1_parloop_338979_task);
    
    if (futhark_mc_segred_stage_1_parloop_338979_err != 0) {
        err = futhark_mc_segred_stage_1_parloop_338979_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_338979_total_end =
                 get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_338979_total_end -
                 futhark_mc_segred_stage_1_parloop_338979_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338979_total_runs,
                           1, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338979_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338979_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    // neutral-initialise the output
    {
        defunc_2_reduce_res_334531 = 0.0;
        defunc_2_reduce_res_334532 = 0.0;
        defunc_2_reduce_res_334533 = 0.0;
    }
    
    double x_334827;
    double x_334828;
    double x_334830;
    double x_334831;
    double x_334833;
    double x_334834;
    
    for (int32_t i_334836 = 0; i_334836 < num_tasks_334816; i_334836++) {
        flat_tid_334761 = i_334836;
        // Apply main thread reduction
        {
            // load acc params
            {
                x_334827 = defunc_2_reduce_res_334531;
            }
            // load next params
            {
                x_334828 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_334817)[flat_tid_334761];
            }
            // red body
            {
                double defunc_1_op_res_334829 = x_334827 + x_334828;
                
                defunc_2_reduce_res_334531 = defunc_1_op_res_334829;
            }
            // load acc params
            {
                x_334830 = defunc_2_reduce_res_334532;
            }
            // load next params
            {
                x_334831 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_334819)[flat_tid_334761];
            }
            // red body
            {
                double defunc_1_op_res_334832 = x_334830 + x_334831;
                
                defunc_2_reduce_res_334532 = defunc_1_op_res_334832;
            }
            // load acc params
            {
                x_334833 = defunc_2_reduce_res_334533;
            }
            // load next params
            {
                x_334834 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_334821)[flat_tid_334761];
            }
            // red body
            {
                double defunc_1_op_res_334835 = x_334833 + x_334834;
                
                defunc_2_reduce_res_334533 = defunc_1_op_res_334835;
            }
        }
    }
    
  cleanup:
    {
        free(reduce_stage_1_tid_res_arr_mem_334817);
        free(reduce_stage_1_tid_res_arr_mem_334819);
        free(reduce_stage_1_tid_res_arr_mem_334821);
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_task_338974_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_task_338974_end -
                 futhark_mc_segred_task_338974_start;
        
        ctx->futhark_mc_segred_task_338974_runs[tid]++;
        ctx->futhark_mc_segred_task_338974_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segred_task_338974_iter[tid] += iterations;
    }
    if (err == 0) {
        *futhark_mc_task_338973->retval_defunc_2_reduce_res_334531 =
            defunc_2_reduce_res_334531;
        *futhark_mc_task_338973->retval_defunc_2_reduce_res_334532 =
            defunc_2_reduce_res_334532;
        *futhark_mc_task_338973->retval_defunc_2_reduce_res_334533 =
            defunc_2_reduce_res_334533;
        futhark_mc_task_338973->retval_mem_334529 = mem_334529.mem;
        futhark_mc_task_338973->retval_mem_334530 = mem_334530.mem;
    }
    return err;
}
struct futhark_mc_task_338980 {
    struct futhark_context *ctx;
    int64_t free_x_308823;
    unsigned char *free_mem_316058;
    int64_t free_x_334524;
    unsigned char *free_mem_334529;
    unsigned char *free_mem_334530;
    double free_a11_334574;
    double free_b11_334576;
    double free_c11_334577;
    double *retval_defunc_2_reduce_res_334578;
    double *retval_defunc_2_reduce_res_334579;
};
struct futhark_mc_segred_stage_1_parloop_struct_338984 {
    struct futhark_context *ctx;
    int64_t free_x_308823;
    unsigned char *free_mem_316058;
    int64_t free_x_334524;
    unsigned char *free_mem_334529;
    unsigned char *free_mem_334530;
    double free_a11_334574;
    double free_b11_334576;
    double free_c11_334577;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_334838;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_334840;
};
static int futhark_mc_segred_stage_1_parloop_338985(void *args, int64_t start,
                                                    int64_t end,
                                                    int flat_tid_334792,
                                                    int tid)
{
    int err = 0;
    struct futhark_mc_segred_stage_1_parloop_struct_338984
    *futhark_mc_segred_stage_1_parloop_struct_338984 =
    (struct futhark_mc_segred_stage_1_parloop_struct_338984 *) args;
    struct futhark_context *ctx =
                           futhark_mc_segred_stage_1_parloop_struct_338984->ctx;
    uint64_t futhark_mc_segred_stage_1_parloop_338985_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_338985_start = get_wall_time();
    
    int64_t x_308823 =
            futhark_mc_segred_stage_1_parloop_struct_338984->free_x_308823;
    struct memblock mem_316058 = {.desc ="mem_316058", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_338984->free_mem_316058,
                                  .size =0, .references =NULL};
    int64_t x_334524 =
            futhark_mc_segred_stage_1_parloop_struct_338984->free_x_334524;
    struct memblock mem_334529 = {.desc ="mem_334529", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_338984->free_mem_334529,
                                  .size =0, .references =NULL};
    struct memblock mem_334530 = {.desc ="mem_334530", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_338984->free_mem_334530,
                                  .size =0, .references =NULL};
    double a11_334574 =
           futhark_mc_segred_stage_1_parloop_struct_338984->free_a11_334574;
    double b11_334576 =
           futhark_mc_segred_stage_1_parloop_struct_338984->free_b11_334576;
    double c11_334577 =
           futhark_mc_segred_stage_1_parloop_struct_338984->free_c11_334577;
    struct memblock reduce_stage_1_tid_res_arr_mem_334838 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_334838",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338984->free_reduce_stage_1_tid_res_arr_mem_334838,
                                                             .size =0,
                                                             .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_334840 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_334840",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_338984->free_reduce_stage_1_tid_res_arr_mem_334840,
                                                             .size =0,
                                                             .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_334842 = start;
    double x_334794;
    double x_334795;
    double x_334797;
    double x_334798;
    double local_acc_334843 = 0.0;
    double local_acc_334844 = 0.0;
    
    for (; iter_334842 < end; iter_334842++) {
        int64_t gtid_334793 = iter_334842;
        double x_334800;
        
        x_334800 = ((double *) mem_334530.mem)[gtid_334793];
        
        double x_334801;
        
        x_334801 = ((double *) mem_334529.mem)[gtid_334793];
        
        bool cond_334802 = sle64(x_308823, gtid_334793);
        double defunc_0_f_res_334803;
        
        if (cond_334802) {
            defunc_0_f_res_334803 = 0.0;
        } else {
            int64_t i_334804 = add64(x_334524, gtid_334793);
            double defunc_0_add_arg_334805;
            
            defunc_0_add_arg_334805 = ((double *) mem_316058.mem)[i_334804];
            defunc_0_f_res_334803 = defunc_0_add_arg_334805;
        }
        
        double x_334806 = a11_334574 * x_334800;
        double y_334807 = b11_334576 * x_334801;
        double x_334808 = x_334806 + y_334807;
        double defunc_9_fit_fun_res_334809 = defunc_0_f_res_334803 * x_334808;
        double x_334810 = b11_334576 * x_334800;
        double y_334811 = c11_334577 * x_334801;
        double x_334812 = x_334810 + y_334811;
        double defunc_9_slope_fun_res_334813 = defunc_0_f_res_334803 * x_334812;
        
        // save map-out results
        { }
        // Load accum params
        {
            x_334794 = local_acc_334843;
        }
        // Load next params
        {
            x_334795 = defunc_9_fit_fun_res_334809;
        }
        // Red body
        {
            double defunc_1_op_res_334796 = x_334794 + x_334795;
            
            local_acc_334843 = defunc_1_op_res_334796;
        }
        // Load accum params
        {
            x_334797 = local_acc_334844;
        }
        // Load next params
        {
            x_334798 = defunc_9_slope_fun_res_334813;
        }
        // Red body
        {
            double defunc_1_op_res_334799 = x_334797 + x_334798;
            
            local_acc_334844 = defunc_1_op_res_334799;
        }
    }
    ((double *) reduce_stage_1_tid_res_arr_mem_334838.mem)[flat_tid_334792] =
        local_acc_334843;
    ((double *) reduce_stage_1_tid_res_arr_mem_334840.mem)[flat_tid_334792] =
        local_acc_334844;
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_338985_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_338985_end -
                 futhark_mc_segred_stage_1_parloop_338985_start;
        
        ctx->futhark_mc_segred_stage_1_parloop_338985_runs[tid]++;
        ctx->futhark_mc_segred_stage_1_parloop_338985_total_runtime[tid] +=
            elapsed;
        ctx->futhark_mc_segred_stage_1_parloop_338985_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segred_task_338981(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_334792 = tid;
    int num_tasks_334837 = info.nsubtasks;
    struct futhark_mc_task_338980 *futhark_mc_task_338980 =
                                  (struct futhark_mc_task_338980 *) args;
    struct futhark_context *ctx = futhark_mc_task_338980->ctx;
    uint64_t futhark_mc_segred_task_338981_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_task_338981_start = get_wall_time();
    
    int64_t x_308823 = futhark_mc_task_338980->free_x_308823;
    struct memblock mem_316058 = {.desc ="mem_316058", .mem =
                                  futhark_mc_task_338980->free_mem_316058,
                                  .size =0, .references =NULL};
    int64_t x_334524 = futhark_mc_task_338980->free_x_334524;
    struct memblock mem_334529 = {.desc ="mem_334529", .mem =
                                  futhark_mc_task_338980->free_mem_334529,
                                  .size =0, .references =NULL};
    struct memblock mem_334530 = {.desc ="mem_334530", .mem =
                                  futhark_mc_task_338980->free_mem_334530,
                                  .size =0, .references =NULL};
    double a11_334574 = futhark_mc_task_338980->free_a11_334574;
    double b11_334576 = futhark_mc_task_338980->free_b11_334576;
    double c11_334577 = futhark_mc_task_338980->free_c11_334577;
    double defunc_2_reduce_res_334578 =
           *futhark_mc_task_338980->retval_defunc_2_reduce_res_334578;
    double defunc_2_reduce_res_334579 =
           *futhark_mc_task_338980->retval_defunc_2_reduce_res_334579;
    size_t reduce_stage_1_tid_res_arr_mem_334838_cached_sizze_338982 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_334838 = NULL;
    size_t reduce_stage_1_tid_res_arr_mem_334840_cached_sizze_338983 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_334840 = NULL;
    
    if (reduce_stage_1_tid_res_arr_mem_334838_cached_sizze_338982 <
        (size_t) ((int64_t) 8 * num_tasks_334837)) {
        reduce_stage_1_tid_res_arr_mem_334838 =
            realloc(reduce_stage_1_tid_res_arr_mem_334838, (int64_t) 8 *
                    num_tasks_334837);
        reduce_stage_1_tid_res_arr_mem_334838_cached_sizze_338982 =
            (int64_t) 8 * num_tasks_334837;
    }
    if (reduce_stage_1_tid_res_arr_mem_334840_cached_sizze_338983 <
        (size_t) ((int64_t) 8 * num_tasks_334837)) {
        reduce_stage_1_tid_res_arr_mem_334840 =
            realloc(reduce_stage_1_tid_res_arr_mem_334840, (int64_t) 8 *
                    num_tasks_334837);
        reduce_stage_1_tid_res_arr_mem_334840_cached_sizze_338983 =
            (int64_t) 8 * num_tasks_334837;
    }
    
    int64_t iter_334842;
    struct futhark_mc_segred_stage_1_parloop_struct_338984
    futhark_mc_segred_stage_1_parloop_struct_338984;
    
    futhark_mc_segred_stage_1_parloop_struct_338984.ctx = ctx;
    futhark_mc_segred_stage_1_parloop_struct_338984.free_x_308823 = x_308823;
    futhark_mc_segred_stage_1_parloop_struct_338984.free_mem_316058 =
        mem_316058.mem;
    futhark_mc_segred_stage_1_parloop_struct_338984.free_x_334524 = x_334524;
    futhark_mc_segred_stage_1_parloop_struct_338984.free_mem_334529 =
        mem_334529.mem;
    futhark_mc_segred_stage_1_parloop_struct_338984.free_mem_334530 =
        mem_334530.mem;
    futhark_mc_segred_stage_1_parloop_struct_338984.free_a11_334574 =
        a11_334574;
    futhark_mc_segred_stage_1_parloop_struct_338984.free_b11_334576 =
        b11_334576;
    futhark_mc_segred_stage_1_parloop_struct_338984.free_c11_334577 =
        c11_334577;
    futhark_mc_segred_stage_1_parloop_struct_338984.free_reduce_stage_1_tid_res_arr_mem_334838 =
        reduce_stage_1_tid_res_arr_mem_334838;
    futhark_mc_segred_stage_1_parloop_struct_338984.free_reduce_stage_1_tid_res_arr_mem_334840 =
        reduce_stage_1_tid_res_arr_mem_334840;
    
    struct scheduler_parloop futhark_mc_segred_stage_1_parloop_338985_task;
    
    futhark_mc_segred_stage_1_parloop_338985_task.name =
        "futhark_mc_segred_stage_1_parloop_338985";
    futhark_mc_segred_stage_1_parloop_338985_task.fn =
        futhark_mc_segred_stage_1_parloop_338985;
    futhark_mc_segred_stage_1_parloop_338985_task.args =
        &futhark_mc_segred_stage_1_parloop_struct_338984;
    futhark_mc_segred_stage_1_parloop_338985_task.iterations = iterations;
    futhark_mc_segred_stage_1_parloop_338985_task.info = info;
    
    uint64_t futhark_mc_segred_stage_1_parloop_338985_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_338985_total_start = get_wall_time();
    
    int futhark_mc_segred_stage_1_parloop_338985_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segred_stage_1_parloop_338985_task);
    
    if (futhark_mc_segred_stage_1_parloop_338985_err != 0) {
        err = futhark_mc_segred_stage_1_parloop_338985_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_338985_total_end =
                 get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_338985_total_end -
                 futhark_mc_segred_stage_1_parloop_338985_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338985_total_runs,
                           1, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338985_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_338985_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    // neutral-initialise the output
    {
        defunc_2_reduce_res_334578 = 0.0;
        defunc_2_reduce_res_334579 = 0.0;
    }
    
    double x_334845;
    double x_334846;
    double x_334848;
    double x_334849;
    
    for (int32_t i_334851 = 0; i_334851 < num_tasks_334837; i_334851++) {
        flat_tid_334792 = i_334851;
        // Apply main thread reduction
        {
            // load acc params
            {
                x_334845 = defunc_2_reduce_res_334578;
            }
            // load next params
            {
                x_334846 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_334838)[flat_tid_334792];
            }
            // red body
            {
                double defunc_1_op_res_334847 = x_334845 + x_334846;
                
                defunc_2_reduce_res_334578 = defunc_1_op_res_334847;
            }
            // load acc params
            {
                x_334848 = defunc_2_reduce_res_334579;
            }
            // load next params
            {
                x_334849 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_334840)[flat_tid_334792];
            }
            // red body
            {
                double defunc_1_op_res_334850 = x_334848 + x_334849;
                
                defunc_2_reduce_res_334579 = defunc_1_op_res_334850;
            }
        }
    }
    
  cleanup:
    {
        free(reduce_stage_1_tid_res_arr_mem_334838);
        free(reduce_stage_1_tid_res_arr_mem_334840);
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_task_338981_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_task_338981_end -
                 futhark_mc_segred_task_338981_start;
        
        ctx->futhark_mc_segred_task_338981_runs[tid]++;
        ctx->futhark_mc_segred_task_338981_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segred_task_338981_iter[tid] += iterations;
    }
    if (err == 0) {
        *futhark_mc_task_338980->retval_defunc_2_reduce_res_334578 =
            defunc_2_reduce_res_334578;
        *futhark_mc_task_338980->retval_defunc_2_reduce_res_334579 =
            defunc_2_reduce_res_334579;
    }
    return err;
}
static int futhark_mc_segmap_parloop_338970(void *args, int64_t start,
                                            int64_t end, int flat_tid_334522,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338969
    *futhark_mc_segmap_parloop_struct_338969 =
    (struct futhark_mc_segmap_parloop_struct_338969 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338969->ctx;
    uint64_t futhark_mc_segmap_parloop_338970_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338970_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_338969->free_n_292675;
    int64_t q_t_292679 =
            futhark_mc_segmap_parloop_struct_338969->free_q_t_292679;
    int64_t jump_t_292685 =
            futhark_mc_segmap_parloop_struct_338969->free_jump_t_292685;
    int64_t t_n_m_292839 =
            futhark_mc_segmap_parloop_struct_338969->free_t_n_m_292839;
    int64_t i_292846 = futhark_mc_segmap_parloop_struct_338969->free_i_292846;
    int64_t gtid_308818 =
            futhark_mc_segmap_parloop_struct_338969->free_gtid_308818;
    int64_t x_308823 = futhark_mc_segmap_parloop_struct_338969->free_x_308823;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_segmap_parloop_struct_338969->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_313143 = {.desc ="mem_313143", .mem =
                                  futhark_mc_segmap_parloop_struct_338969->free_mem_313143,
                                  .size =0, .references =NULL};
    struct memblock mem_313147 = {.desc ="mem_313147", .mem =
                                  futhark_mc_segmap_parloop_struct_338969->free_mem_313147,
                                  .size =0, .references =NULL};
    struct memblock mem_316055 = {.desc ="mem_316055", .mem =
                                  futhark_mc_segmap_parloop_struct_338969->free_mem_316055,
                                  .size =0, .references =NULL};
    struct memblock mem_316058 = {.desc ="mem_316058", .mem =
                                  futhark_mc_segmap_parloop_struct_338969->free_mem_316058,
                                  .size =0, .references =NULL};
    int64_t bytes_316060 =
            futhark_mc_segmap_parloop_struct_338969->free_bytes_316060;
    struct memblock mem_316097 = {.desc ="mem_316097", .mem =
                                  futhark_mc_segmap_parloop_struct_338969->free_mem_316097,
                                  .size =0, .references =NULL};
    struct memblock mem_316100 = {.desc ="mem_316100", .mem =
                                  futhark_mc_segmap_parloop_struct_338969->free_mem_316100,
                                  .size =0, .references =NULL};
    size_t mem_334529_cached_sizze_338971 = 0;
    unsigned char *mem_334529 = NULL;
    size_t mem_334530_cached_sizze_338972 = 0;
    unsigned char *mem_334530 = NULL;
    int64_t iterations = end - start;
    int64_t iter_334760 = start;
    
    if (mem_334529_cached_sizze_338971 < (size_t) bytes_316060) {
        mem_334529 = realloc(mem_334529, bytes_316060);
        mem_334529_cached_sizze_338971 = bytes_316060;
    }
    if (mem_334530_cached_sizze_338972 < (size_t) bytes_316060) {
        mem_334530 = realloc(mem_334530, bytes_316060);
        mem_334530_cached_sizze_338972 = bytes_316060;
    }
    for (; iter_334760 < end; iter_334760++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_334814 = t_n_m_292839;
        int64_t gtid_334523 = iter_334760;
        int64_t remnant_334815 = iter_334760 - gtid_334523;
        int64_t x_334524;
        
        x_334524 = ((int64_t *) mem_313143.mem)[gtid_308818 * t_n_m_292839 +
                                                gtid_334523];
        
        double x_334525;
        
        x_334525 = ((double *) mem_313147.mem)[gtid_308818 * t_n_m_292839 +
                                               gtid_334523];
        
        int64_t min_arg_334526 = mul64(jump_t_292685, gtid_334523);
        int64_t min_res_334527 = smin64(i_292846, min_arg_334526);
        int64_t defunc_0_g_res_334528 = add64((int64_t) 1, min_res_334527);
        double defunc_2_reduce_res_334531;
        double defunc_2_reduce_res_334532;
        double defunc_2_reduce_res_334533;
        int64_t flat_tid_334761 = (int64_t) 0;
        int32_t num_tasks_334816;
        
        defunc_2_reduce_res_334531 = 0.0;
        defunc_2_reduce_res_334532 = 0.0;
        defunc_2_reduce_res_334533 = 0.0;
        
        struct futhark_mc_task_338973 futhark_mc_task_338973;
        
        futhark_mc_task_338973.ctx = ctx;
        futhark_mc_task_338973.free_n_292675 = n_292675;
        futhark_mc_task_338973.free_gtid_308818 = gtid_308818;
        futhark_mc_task_338973.free_x_308823 = x_308823;
        futhark_mc_task_338973.free_mem_312636 = mem_312636.mem;
        futhark_mc_task_338973.free_mem_316055 = mem_316055.mem;
        futhark_mc_task_338973.free_x_334524 = x_334524;
        futhark_mc_task_338973.free_x_334525 = x_334525;
        futhark_mc_task_338973.free_defunc_0_g_res_334528 =
            defunc_0_g_res_334528;
        futhark_mc_task_338973.retval_defunc_2_reduce_res_334531 =
            &defunc_2_reduce_res_334531;
        futhark_mc_task_338973.retval_defunc_2_reduce_res_334532 =
            &defunc_2_reduce_res_334532;
        futhark_mc_task_338973.retval_defunc_2_reduce_res_334533 =
            &defunc_2_reduce_res_334533;
        futhark_mc_task_338973.retval_mem_334529 = mem_334529;
        futhark_mc_task_338973.retval_mem_334530 = mem_334530;
        
        struct scheduler_segop futhark_mc_task_338973_task;
        
        futhark_mc_task_338973_task.args = &futhark_mc_task_338973;
        futhark_mc_task_338973_task.top_level_fn =
            futhark_mc_segred_task_338974;
        futhark_mc_task_338973_task.name = "futhark_mc_segred_task_338974";
        futhark_mc_task_338973_task.iterations = q_t_292679;
        futhark_mc_task_338973_task.task_time =
            &ctx->futhark_mc_segred_task_338974_total_time;
        futhark_mc_task_338973_task.task_iter =
            &ctx->futhark_mc_segred_task_338974_total_iter;
        futhark_mc_task_338973_task.sched = STATIC;
        futhark_mc_task_338973_task.nested_fn = NULL;
        
        int futhark_mc_segred_task_338974_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_338973_task);
        
        if (futhark_mc_segred_task_338974_err != 0) {
            ;
            err = futhark_mc_segred_task_338974_err;
            goto cleanup;
        }
        
        double a_334567 = 2.220446049250313e-16 + defunc_2_reduce_res_334531;
        double b_334568 = 2.220446049250313e-16 + defunc_2_reduce_res_334532;
        double c_334569 = 2.220446049250313e-16 + defunc_2_reduce_res_334533;
        double x_334570 = a_334567 * c_334569;
        double y_334571 = b_334568 * b_334568;
        double y_334572 = x_334570 - y_334571;
        double det1_334573 = 1.0 / y_334572;
        double a11_334574 = c_334569 * det1_334573;
        double x_334575 = 0.0 - b_334568;
        double b11_334576 = det1_334573 * x_334575;
        double c11_334577 = a_334567 * det1_334573;
        double defunc_2_reduce_res_334578;
        double defunc_2_reduce_res_334579;
        int64_t flat_tid_334792 = (int64_t) 0;
        int32_t num_tasks_334837;
        
        defunc_2_reduce_res_334578 = 0.0;
        defunc_2_reduce_res_334579 = 0.0;
        
        struct futhark_mc_task_338980 futhark_mc_task_338980;
        
        futhark_mc_task_338980.ctx = ctx;
        futhark_mc_task_338980.free_x_308823 = x_308823;
        futhark_mc_task_338980.free_mem_316058 = mem_316058.mem;
        futhark_mc_task_338980.free_x_334524 = x_334524;
        futhark_mc_task_338980.free_mem_334529 = mem_334529;
        futhark_mc_task_338980.free_mem_334530 = mem_334530;
        futhark_mc_task_338980.free_a11_334574 = a11_334574;
        futhark_mc_task_338980.free_b11_334576 = b11_334576;
        futhark_mc_task_338980.free_c11_334577 = c11_334577;
        futhark_mc_task_338980.retval_defunc_2_reduce_res_334578 =
            &defunc_2_reduce_res_334578;
        futhark_mc_task_338980.retval_defunc_2_reduce_res_334579 =
            &defunc_2_reduce_res_334579;
        
        struct scheduler_segop futhark_mc_task_338980_task;
        
        futhark_mc_task_338980_task.args = &futhark_mc_task_338980;
        futhark_mc_task_338980_task.top_level_fn =
            futhark_mc_segred_task_338981;
        futhark_mc_task_338980_task.name = "futhark_mc_segred_task_338981";
        futhark_mc_task_338980_task.iterations = q_t_292679;
        futhark_mc_task_338980_task.task_time =
            &ctx->futhark_mc_segred_task_338981_total_time;
        futhark_mc_task_338980_task.task_iter =
            &ctx->futhark_mc_segred_task_338981_total_iter;
        futhark_mc_task_338980_task.sched = STATIC;
        futhark_mc_task_338980_task.nested_fn = NULL;
        
        int futhark_mc_segred_task_338981_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_338980_task);
        
        if (futhark_mc_segred_task_338981_err != 0) {
            ;
            err = futhark_mc_segred_task_338981_err;
            goto cleanup;
        }
        ((double *) mem_316097.mem)[gtid_334523] = defunc_2_reduce_res_334578;
        ((double *) mem_316100.mem)[gtid_334523] = defunc_2_reduce_res_334579;
    }
    
  cleanup:
    { }
    free(mem_334529);
    free(mem_334530);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338970_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338970_end -
                 futhark_mc_segmap_parloop_338970_start;
        
        ctx->futhark_mc_segmap_parloop_338970_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338970_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338970_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_nested_task_338968(void *args, int64_t iterations,
                                         int tid, struct scheduler_info info)
{
    int err = 0;
    int flat_tid_334522 = tid;
    int num_tasks_334699 = info.nsubtasks;
    struct futhark_mc_task_338962 *futhark_mc_task_338962 =
                                  (struct futhark_mc_task_338962 *) args;
    struct futhark_context *ctx = futhark_mc_task_338962->ctx;
    uint64_t futhark_mc_segmap_nested_task_338968_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_nested_task_338968_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338962->free_n_292675;
    int64_t q_t_292679 = futhark_mc_task_338962->free_q_t_292679;
    int64_t jump_t_292685 = futhark_mc_task_338962->free_jump_t_292685;
    int64_t t_n_m_292839 = futhark_mc_task_338962->free_t_n_m_292839;
    int64_t i_292846 = futhark_mc_task_338962->free_i_292846;
    int64_t gtid_308818 = futhark_mc_task_338962->free_gtid_308818;
    int64_t x_308823 = futhark_mc_task_338962->free_x_308823;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_task_338962->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_313143 = {.desc ="mem_313143", .mem =
                                  futhark_mc_task_338962->free_mem_313143,
                                  .size =0, .references =NULL};
    struct memblock mem_313147 = {.desc ="mem_313147", .mem =
                                  futhark_mc_task_338962->free_mem_313147,
                                  .size =0, .references =NULL};
    struct memblock mem_316055 = {.desc ="mem_316055", .mem =
                                  futhark_mc_task_338962->free_mem_316055,
                                  .size =0, .references =NULL};
    struct memblock mem_316058 = {.desc ="mem_316058", .mem =
                                  futhark_mc_task_338962->free_mem_316058,
                                  .size =0, .references =NULL};
    int64_t bytes_316060 = futhark_mc_task_338962->free_bytes_316060;
    struct memblock mem_316097 = {.desc ="mem_316097", .mem =
                                  futhark_mc_task_338962->free_mem_316097,
                                  .size =0, .references =NULL};
    struct memblock mem_316100 = {.desc ="mem_316100", .mem =
                                  futhark_mc_task_338962->free_mem_316100,
                                  .size =0, .references =NULL};
    int64_t iter_334760;
    struct futhark_mc_segmap_parloop_struct_338969
    futhark_mc_segmap_parloop_struct_338969;
    
    futhark_mc_segmap_parloop_struct_338969.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338969.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_338969.free_q_t_292679 = q_t_292679;
    futhark_mc_segmap_parloop_struct_338969.free_jump_t_292685 = jump_t_292685;
    futhark_mc_segmap_parloop_struct_338969.free_t_n_m_292839 = t_n_m_292839;
    futhark_mc_segmap_parloop_struct_338969.free_i_292846 = i_292846;
    futhark_mc_segmap_parloop_struct_338969.free_gtid_308818 = gtid_308818;
    futhark_mc_segmap_parloop_struct_338969.free_x_308823 = x_308823;
    futhark_mc_segmap_parloop_struct_338969.free_mem_312636 = mem_312636.mem;
    futhark_mc_segmap_parloop_struct_338969.free_mem_313143 = mem_313143.mem;
    futhark_mc_segmap_parloop_struct_338969.free_mem_313147 = mem_313147.mem;
    futhark_mc_segmap_parloop_struct_338969.free_mem_316055 = mem_316055.mem;
    futhark_mc_segmap_parloop_struct_338969.free_mem_316058 = mem_316058.mem;
    futhark_mc_segmap_parloop_struct_338969.free_bytes_316060 = bytes_316060;
    futhark_mc_segmap_parloop_struct_338969.free_mem_316097 = mem_316097.mem;
    futhark_mc_segmap_parloop_struct_338969.free_mem_316100 = mem_316100.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338970_task;
    
    futhark_mc_segmap_parloop_338970_task.name =
        "futhark_mc_segmap_parloop_338970";
    futhark_mc_segmap_parloop_338970_task.fn = futhark_mc_segmap_parloop_338970;
    futhark_mc_segmap_parloop_338970_task.args =
        &futhark_mc_segmap_parloop_struct_338969;
    futhark_mc_segmap_parloop_338970_task.iterations = iterations;
    futhark_mc_segmap_parloop_338970_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338970_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338970_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338970_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338970_task);
    
    if (futhark_mc_segmap_parloop_338970_err != 0) {
        err = futhark_mc_segmap_parloop_338970_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338970_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338970_total_end -
                 futhark_mc_segmap_parloop_338970_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338970_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338970_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338970_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_nested_task_338968_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_nested_task_338968_end -
                 futhark_mc_segmap_nested_task_338968_start;
        
        ctx->futhark_mc_segmap_nested_task_338968_runs[tid]++;
        ctx->futhark_mc_segmap_nested_task_338968_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_nested_task_338968_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
static int futhark_mc_segmap_parloop_338948(void *args, int64_t start,
                                            int64_t end, int flat_tid_308817,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338947
    *futhark_mc_segmap_parloop_struct_338947 =
    (struct futhark_mc_segmap_parloop_struct_338947 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338947->ctx;
    uint64_t futhark_mc_segmap_parloop_338948_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338948_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_338947->free_n_292675;
    int64_t q_t_292679 =
            futhark_mc_segmap_parloop_struct_338947->free_q_t_292679;
    int64_t jump_t_292685 =
            futhark_mc_segmap_parloop_struct_338947->free_jump_t_292685;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_338947->free_partition_sizze_292766;
    int64_t t_n_m_292839 =
            futhark_mc_segmap_parloop_struct_338947->free_t_n_m_292839;
    int64_t i_292846 = futhark_mc_segmap_parloop_struct_338947->free_i_292846;
    struct memblock mem_312593 = {.desc ="mem_312593", .mem =
                                  futhark_mc_segmap_parloop_struct_338947->free_mem_312593,
                                  .size =0, .references =NULL};
    int64_t bytes_312598 =
            futhark_mc_segmap_parloop_struct_338947->free_bytes_312598;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_segmap_parloop_struct_338947->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_312639 = {.desc ="mem_312639", .mem =
                                  futhark_mc_segmap_parloop_struct_338947->free_mem_312639,
                                  .size =0, .references =NULL};
    int64_t bytes_313090 =
            futhark_mc_segmap_parloop_struct_338947->free_bytes_313090;
    struct memblock mem_313143 = {.desc ="mem_313143", .mem =
                                  futhark_mc_segmap_parloop_struct_338947->free_mem_313143,
                                  .size =0, .references =NULL};
    struct memblock mem_313147 = {.desc ="mem_313147", .mem =
                                  futhark_mc_segmap_parloop_struct_338947->free_mem_313147,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_segmap_parloop_struct_338947->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_segmap_parloop_struct_338947->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_segmap_parloop_struct_338947->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_segmap_parloop_struct_338947->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315656 = {.desc ="mem_315656", .mem =
                                  futhark_mc_segmap_parloop_struct_338947->free_mem_315656,
                                  .size =0, .references =NULL};
    int64_t bytes_316060 =
            futhark_mc_segmap_parloop_struct_338947->free_bytes_316060;
    struct memblock mem_316209 = {.desc ="mem_316209", .mem =
                                  futhark_mc_segmap_parloop_struct_338947->free_mem_316209,
                                  .size =0, .references =NULL};
    struct memblock mem_316213 = {.desc ="mem_316213", .mem =
                                  futhark_mc_segmap_parloop_struct_338947->free_mem_316213,
                                  .size =0, .references =NULL};
    size_t mem_316052_cached_sizze_338949 = 0;
    unsigned char *mem_316052 = NULL;
    size_t mem_316055_cached_sizze_338950 = 0;
    unsigned char *mem_316055 = NULL;
    size_t mem_316058_cached_sizze_338951 = 0;
    unsigned char *mem_316058 = NULL;
    size_t mem_316097_cached_sizze_338952 = 0;
    unsigned char *mem_316097 = NULL;
    size_t mem_316100_cached_sizze_338953 = 0;
    unsigned char *mem_316100 = NULL;
    int64_t iterations = end - start;
    int64_t iter_334501 = start;
    
    if (mem_316052_cached_sizze_338949 < (size_t) bytes_312598) {
        mem_316052 = realloc(mem_316052, bytes_312598);
        mem_316052_cached_sizze_338949 = bytes_312598;
    }
    if (mem_316055_cached_sizze_338950 < (size_t) bytes_312598) {
        mem_316055 = realloc(mem_316055, bytes_312598);
        mem_316055_cached_sizze_338950 = bytes_312598;
    }
    if (mem_316058_cached_sizze_338951 < (size_t) bytes_312598) {
        mem_316058 = realloc(mem_316058, bytes_312598);
        mem_316058_cached_sizze_338951 = bytes_312598;
    }
    if (mem_316097_cached_sizze_338952 < (size_t) bytes_313090) {
        mem_316097 = realloc(mem_316097, bytes_313090);
        mem_316097_cached_sizze_338952 = bytes_313090;
    }
    if (mem_316100_cached_sizze_338953 < (size_t) bytes_313090) {
        mem_316100 = realloc(mem_316100, bytes_313090);
        mem_316100_cached_sizze_338953 = bytes_313090;
    }
    for (; iter_334501 < end; iter_334501++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_334681 = partition_sizze_292766;
        int64_t gtid_308818 = iter_334501;
        int64_t remnant_334682 = iter_334501 - gtid_308818;
        int64_t x_308823;
        
        x_308823 = ((int64_t *) mem_312639.mem)[gtid_308818];
        
        int64_t flat_tid_334502 = (int64_t) 0;
        int32_t num_tasks_334683;
        struct futhark_mc_task_338954 futhark_mc_task_338954;
        
        futhark_mc_task_338954.ctx = ctx;
        futhark_mc_task_338954.free_n_292675 = n_292675;
        futhark_mc_task_338954.free_gtid_308818 = gtid_308818;
        futhark_mc_task_338954.free_mem_312593 = mem_312593.mem;
        futhark_mc_task_338954.free_mem_315656 = mem_315656.mem;
        futhark_mc_task_338954.free_mem_316052 = mem_316052;
        
        struct scheduler_segop futhark_mc_task_338954_task;
        
        futhark_mc_task_338954_task.args = &futhark_mc_task_338954;
        futhark_mc_task_338954_task.top_level_fn =
            futhark_mc_segmap_task_338955;
        futhark_mc_task_338954_task.name = "futhark_mc_segmap_task_338955";
        futhark_mc_task_338954_task.iterations = n_292675;
        futhark_mc_task_338954_task.task_time =
            &ctx->futhark_mc_segmap_task_338955_total_time;
        futhark_mc_task_338954_task.task_iter =
            &ctx->futhark_mc_segmap_task_338955_total_iter;
        futhark_mc_task_338954_task.sched = STATIC;
        futhark_mc_task_338954_task.nested_fn = NULL;
        
        int futhark_mc_segmap_task_338955_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_338954_task);
        
        if (futhark_mc_segmap_task_338955_err != 0) {
            ;
            err = futhark_mc_segmap_task_338955_err;
            goto cleanup;
        }
        
        int64_t flat_tid_334508 = (int64_t) 0;
        int32_t num_tasks_334687;
        struct futhark_mc_task_338958 futhark_mc_task_338958;
        
        futhark_mc_task_338958.ctx = ctx;
        futhark_mc_task_338958.free_n_292675 = n_292675;
        futhark_mc_task_338958.free_gtid_308818 = gtid_308818;
        futhark_mc_task_338958.free_mem_312636 = mem_312636.mem;
        futhark_mc_task_338958.free_ctx_param_ext_313174 = ctx_param_ext_313174;
        futhark_mc_task_338958.free_ctx_param_ext_313175 = ctx_param_ext_313175;
        futhark_mc_task_338958.free_ctx_param_ext_313177 = ctx_param_ext_313177;
        futhark_mc_task_338958.free_mem_param_313179 = mem_param_313179.mem;
        futhark_mc_task_338958.free_mem_316052 = mem_316052;
        futhark_mc_task_338958.free_mem_316055 = mem_316055;
        futhark_mc_task_338958.free_mem_316058 = mem_316058;
        
        struct scheduler_segop futhark_mc_task_338958_task;
        
        futhark_mc_task_338958_task.args = &futhark_mc_task_338958;
        futhark_mc_task_338958_task.top_level_fn =
            futhark_mc_segmap_task_338959;
        futhark_mc_task_338958_task.name = "futhark_mc_segmap_task_338959";
        futhark_mc_task_338958_task.iterations = n_292675;
        futhark_mc_task_338958_task.task_time =
            &ctx->futhark_mc_segmap_task_338959_total_time;
        futhark_mc_task_338958_task.task_iter =
            &ctx->futhark_mc_segmap_task_338959_total_iter;
        futhark_mc_task_338958_task.sched = STATIC;
        futhark_mc_task_338958_task.nested_fn = NULL;
        
        int futhark_mc_segmap_task_338959_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_338958_task);
        
        if (futhark_mc_segmap_task_338959_err != 0) {
            ;
            err = futhark_mc_segmap_task_338959_err;
            goto cleanup;
        }
        
        int64_t flat_tid_334602 = (int64_t) 0;
        int32_t num_tasks_334699;
        int64_t flat_tid_334522 = (int64_t) 0;
        struct futhark_mc_task_338962 futhark_mc_task_338962;
        
        futhark_mc_task_338962.ctx = ctx;
        futhark_mc_task_338962.free_n_292675 = n_292675;
        futhark_mc_task_338962.free_q_t_292679 = q_t_292679;
        futhark_mc_task_338962.free_jump_t_292685 = jump_t_292685;
        futhark_mc_task_338962.free_t_n_m_292839 = t_n_m_292839;
        futhark_mc_task_338962.free_i_292846 = i_292846;
        futhark_mc_task_338962.free_gtid_308818 = gtid_308818;
        futhark_mc_task_338962.free_x_308823 = x_308823;
        futhark_mc_task_338962.free_mem_312636 = mem_312636.mem;
        futhark_mc_task_338962.free_mem_313143 = mem_313143.mem;
        futhark_mc_task_338962.free_mem_313147 = mem_313147.mem;
        futhark_mc_task_338962.free_mem_316055 = mem_316055;
        futhark_mc_task_338962.free_mem_316058 = mem_316058;
        futhark_mc_task_338962.free_bytes_316060 = bytes_316060;
        futhark_mc_task_338962.free_mem_316097 = mem_316097;
        futhark_mc_task_338962.free_mem_316100 = mem_316100;
        
        struct scheduler_segop futhark_mc_task_338962_task;
        
        futhark_mc_task_338962_task.args = &futhark_mc_task_338962;
        futhark_mc_task_338962_task.top_level_fn =
            futhark_mc_segmap_task_338963;
        futhark_mc_task_338962_task.name = "futhark_mc_segmap_task_338963";
        futhark_mc_task_338962_task.iterations = t_n_m_292839;
        futhark_mc_task_338962_task.task_time =
            &ctx->futhark_mc_segmap_task_338963_total_time;
        futhark_mc_task_338962_task.task_iter =
            &ctx->futhark_mc_segmap_task_338963_total_iter;
        futhark_mc_task_338962_task.sched = STATIC;
        futhark_mc_task_338962_task.nested_fn =
            futhark_mc_segmap_nested_task_338968;
        
        int futhark_mc_segmap_task_338963_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_338962_task);
        
        if (futhark_mc_segmap_task_338963_err != 0) {
            ;
            err = futhark_mc_segmap_task_338963_err;
            goto cleanup;
        }
        if (t_n_m_292839 * (int64_t) 8 > 0)
            memmove(mem_316209.mem + gtid_308818 * t_n_m_292839 * (int64_t) 8,
                    mem_316097 + (int64_t) 0, t_n_m_292839 * (int64_t) 8);
        if (t_n_m_292839 * (int64_t) 8 > 0)
            memmove(mem_316213.mem + gtid_308818 * t_n_m_292839 * (int64_t) 8,
                    mem_316100 + (int64_t) 0, t_n_m_292839 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_316052);
    free(mem_316055);
    free(mem_316058);
    free(mem_316097);
    free(mem_316100);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338948_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338948_end -
                 futhark_mc_segmap_parloop_338948_start;
        
        ctx->futhark_mc_segmap_parloop_338948_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338948_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338948_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_nested_task_338946(void *args, int64_t iterations,
                                         int tid, struct scheduler_info info)
{
    int err = 0;
    int flat_tid_308817 = tid;
    int num_tasks_334381 = info.nsubtasks;
    struct futhark_mc_task_338935 *futhark_mc_task_338935 =
                                  (struct futhark_mc_task_338935 *) args;
    struct futhark_context *ctx = futhark_mc_task_338935->ctx;
    uint64_t futhark_mc_segmap_nested_task_338946_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_nested_task_338946_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338935->free_n_292675;
    int64_t q_t_292679 = futhark_mc_task_338935->free_q_t_292679;
    int64_t jump_t_292685 = futhark_mc_task_338935->free_jump_t_292685;
    int64_t partition_sizze_292766 =
            futhark_mc_task_338935->free_partition_sizze_292766;
    int64_t t_n_m_292839 = futhark_mc_task_338935->free_t_n_m_292839;
    int64_t i_292846 = futhark_mc_task_338935->free_i_292846;
    struct memblock mem_312593 = {.desc ="mem_312593", .mem =
                                  futhark_mc_task_338935->free_mem_312593,
                                  .size =0, .references =NULL};
    int64_t bytes_312598 = futhark_mc_task_338935->free_bytes_312598;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_task_338935->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_312639 = {.desc ="mem_312639", .mem =
                                  futhark_mc_task_338935->free_mem_312639,
                                  .size =0, .references =NULL};
    int64_t bytes_313090 = futhark_mc_task_338935->free_bytes_313090;
    struct memblock mem_313143 = {.desc ="mem_313143", .mem =
                                  futhark_mc_task_338935->free_mem_313143,
                                  .size =0, .references =NULL};
    struct memblock mem_313147 = {.desc ="mem_313147", .mem =
                                  futhark_mc_task_338935->free_mem_313147,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_task_338935->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_task_338935->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_task_338935->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_task_338935->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315656 = {.desc ="mem_315656", .mem =
                                  futhark_mc_task_338935->free_mem_315656,
                                  .size =0, .references =NULL};
    int64_t bytes_316060 = futhark_mc_task_338935->free_bytes_316060;
    struct memblock mem_316209 = {.desc ="mem_316209", .mem =
                                  futhark_mc_task_338935->free_mem_316209,
                                  .size =0, .references =NULL};
    struct memblock mem_316213 = {.desc ="mem_316213", .mem =
                                  futhark_mc_task_338935->free_mem_316213,
                                  .size =0, .references =NULL};
    int64_t iter_334501;
    struct futhark_mc_segmap_parloop_struct_338947
    futhark_mc_segmap_parloop_struct_338947;
    
    futhark_mc_segmap_parloop_struct_338947.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338947.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_338947.free_q_t_292679 = q_t_292679;
    futhark_mc_segmap_parloop_struct_338947.free_jump_t_292685 = jump_t_292685;
    futhark_mc_segmap_parloop_struct_338947.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_338947.free_t_n_m_292839 = t_n_m_292839;
    futhark_mc_segmap_parloop_struct_338947.free_i_292846 = i_292846;
    futhark_mc_segmap_parloop_struct_338947.free_mem_312593 = mem_312593.mem;
    futhark_mc_segmap_parloop_struct_338947.free_bytes_312598 = bytes_312598;
    futhark_mc_segmap_parloop_struct_338947.free_mem_312636 = mem_312636.mem;
    futhark_mc_segmap_parloop_struct_338947.free_mem_312639 = mem_312639.mem;
    futhark_mc_segmap_parloop_struct_338947.free_bytes_313090 = bytes_313090;
    futhark_mc_segmap_parloop_struct_338947.free_mem_313143 = mem_313143.mem;
    futhark_mc_segmap_parloop_struct_338947.free_mem_313147 = mem_313147.mem;
    futhark_mc_segmap_parloop_struct_338947.free_ctx_param_ext_313174 =
        ctx_param_ext_313174;
    futhark_mc_segmap_parloop_struct_338947.free_ctx_param_ext_313175 =
        ctx_param_ext_313175;
    futhark_mc_segmap_parloop_struct_338947.free_ctx_param_ext_313177 =
        ctx_param_ext_313177;
    futhark_mc_segmap_parloop_struct_338947.free_mem_param_313179 =
        mem_param_313179.mem;
    futhark_mc_segmap_parloop_struct_338947.free_mem_315656 = mem_315656.mem;
    futhark_mc_segmap_parloop_struct_338947.free_bytes_316060 = bytes_316060;
    futhark_mc_segmap_parloop_struct_338947.free_mem_316209 = mem_316209.mem;
    futhark_mc_segmap_parloop_struct_338947.free_mem_316213 = mem_316213.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338948_task;
    
    futhark_mc_segmap_parloop_338948_task.name =
        "futhark_mc_segmap_parloop_338948";
    futhark_mc_segmap_parloop_338948_task.fn = futhark_mc_segmap_parloop_338948;
    futhark_mc_segmap_parloop_338948_task.args =
        &futhark_mc_segmap_parloop_struct_338947;
    futhark_mc_segmap_parloop_338948_task.iterations = iterations;
    futhark_mc_segmap_parloop_338948_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338948_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338948_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338948_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338948_task);
    
    if (futhark_mc_segmap_parloop_338948_err != 0) {
        err = futhark_mc_segmap_parloop_338948_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338948_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338948_total_end -
                 futhark_mc_segmap_parloop_338948_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338948_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338948_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338948_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_nested_task_338946_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_nested_task_338946_end -
                 futhark_mc_segmap_nested_task_338946_start;
        
        ctx->futhark_mc_segmap_nested_task_338946_runs[tid]++;
        ctx->futhark_mc_segmap_nested_task_338946_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_nested_task_338946_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_task_338986 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_t_292679;
    int64_t free_jump_t_292685;
    int64_t free_partition_sizze_292766;
    int64_t free_t_n_m_292839;
    int64_t free_i_292846;
    unsigned char *free_mem_312593;
    int64_t free_bytes_312598;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_312639;
    int64_t free_bytes_313090;
    unsigned char *free_mem_313143;
    unsigned char *free_mem_313147;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315656;
    int64_t free_bytes_316224;
    unsigned char *free_mem_316439;
    unsigned char *free_mem_316443;
};
struct futhark_mc_segmap_parloop_struct_338988 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_t_292679;
    int64_t free_jump_t_292685;
    int64_t free_partition_sizze_292766;
    int64_t free_t_n_m_292839;
    int64_t free_i_292846;
    unsigned char *free_mem_312593;
    int64_t free_bytes_312598;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_312639;
    int64_t free_bytes_313090;
    unsigned char *free_mem_313143;
    unsigned char *free_mem_313147;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315656;
    int64_t free_bytes_316224;
    unsigned char *free_mem_316439;
    unsigned char *free_mem_316443;
};
static int futhark_mc_segmap_parloop_338989(void *args, int64_t start,
                                            int64_t end, int flat_tid_309009,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_338988
    *futhark_mc_segmap_parloop_struct_338988 =
    (struct futhark_mc_segmap_parloop_struct_338988 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_338988->ctx;
    uint64_t futhark_mc_segmap_parloop_338989_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338989_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_338988->free_n_292675;
    int64_t q_t_292679 =
            futhark_mc_segmap_parloop_struct_338988->free_q_t_292679;
    int64_t jump_t_292685 =
            futhark_mc_segmap_parloop_struct_338988->free_jump_t_292685;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_338988->free_partition_sizze_292766;
    int64_t t_n_m_292839 =
            futhark_mc_segmap_parloop_struct_338988->free_t_n_m_292839;
    int64_t i_292846 = futhark_mc_segmap_parloop_struct_338988->free_i_292846;
    struct memblock mem_312593 = {.desc ="mem_312593", .mem =
                                  futhark_mc_segmap_parloop_struct_338988->free_mem_312593,
                                  .size =0, .references =NULL};
    int64_t bytes_312598 =
            futhark_mc_segmap_parloop_struct_338988->free_bytes_312598;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_segmap_parloop_struct_338988->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_312639 = {.desc ="mem_312639", .mem =
                                  futhark_mc_segmap_parloop_struct_338988->free_mem_312639,
                                  .size =0, .references =NULL};
    int64_t bytes_313090 =
            futhark_mc_segmap_parloop_struct_338988->free_bytes_313090;
    struct memblock mem_313143 = {.desc ="mem_313143", .mem =
                                  futhark_mc_segmap_parloop_struct_338988->free_mem_313143,
                                  .size =0, .references =NULL};
    struct memblock mem_313147 = {.desc ="mem_313147", .mem =
                                  futhark_mc_segmap_parloop_struct_338988->free_mem_313147,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_segmap_parloop_struct_338988->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_segmap_parloop_struct_338988->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_segmap_parloop_struct_338988->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_segmap_parloop_struct_338988->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315656 = {.desc ="mem_315656", .mem =
                                  futhark_mc_segmap_parloop_struct_338988->free_mem_315656,
                                  .size =0, .references =NULL};
    int64_t bytes_316224 =
            futhark_mc_segmap_parloop_struct_338988->free_bytes_316224;
    struct memblock mem_316439 = {.desc ="mem_316439", .mem =
                                  futhark_mc_segmap_parloop_struct_338988->free_mem_316439,
                                  .size =0, .references =NULL};
    struct memblock mem_316443 = {.desc ="mem_316443", .mem =
                                  futhark_mc_segmap_parloop_struct_338988->free_mem_316443,
                                  .size =0, .references =NULL};
    size_t mem_316303_cached_sizze_338990 = 0;
    unsigned char *mem_316303 = NULL;
    size_t mem_316318_cached_sizze_338991 = 0;
    unsigned char *mem_316318 = NULL;
    size_t mem_316321_cached_sizze_338992 = 0;
    unsigned char *mem_316321 = NULL;
    size_t mem_316348_cached_sizze_338993 = 0;
    unsigned char *mem_316348 = NULL;
    size_t mem_316351_cached_sizze_338994 = 0;
    unsigned char *mem_316351 = NULL;
    size_t mem_316368_cached_sizze_338995 = 0;
    unsigned char *mem_316368 = NULL;
    size_t mem_316371_cached_sizze_338996 = 0;
    unsigned char *mem_316371 = NULL;
    size_t mem_316398_cached_sizze_338997 = 0;
    unsigned char *mem_316398 = NULL;
    size_t mem_316401_cached_sizze_338998 = 0;
    unsigned char *mem_316401 = NULL;
    int64_t iterations = end - start;
    int64_t iter_334853 = start;
    
    if (mem_316303_cached_sizze_338990 < (size_t) bytes_312598) {
        mem_316303 = realloc(mem_316303, bytes_312598);
        mem_316303_cached_sizze_338990 = bytes_312598;
    }
    if (mem_316318_cached_sizze_338991 < (size_t) bytes_312598) {
        mem_316318 = realloc(mem_316318, bytes_312598);
        mem_316318_cached_sizze_338991 = bytes_312598;
    }
    if (mem_316321_cached_sizze_338992 < (size_t) bytes_312598) {
        mem_316321 = realloc(mem_316321, bytes_312598);
        mem_316321_cached_sizze_338992 = bytes_312598;
    }
    if (mem_316348_cached_sizze_338993 < (size_t) bytes_313090) {
        mem_316348 = realloc(mem_316348, bytes_313090);
        mem_316348_cached_sizze_338993 = bytes_313090;
    }
    if (mem_316351_cached_sizze_338994 < (size_t) bytes_313090) {
        mem_316351 = realloc(mem_316351, bytes_313090);
        mem_316351_cached_sizze_338994 = bytes_313090;
    }
    if (mem_316368_cached_sizze_338995 < (size_t) bytes_316224) {
        mem_316368 = realloc(mem_316368, bytes_316224);
        mem_316368_cached_sizze_338995 = bytes_316224;
    }
    if (mem_316371_cached_sizze_338996 < (size_t) bytes_316224) {
        mem_316371 = realloc(mem_316371, bytes_316224);
        mem_316371_cached_sizze_338996 = bytes_316224;
    }
    if (mem_316398_cached_sizze_338997 < (size_t) bytes_316224) {
        mem_316398 = realloc(mem_316398, bytes_316224);
        mem_316398_cached_sizze_338997 = bytes_316224;
    }
    if (mem_316401_cached_sizze_338998 < (size_t) bytes_316224) {
        mem_316401 = realloc(mem_316401, bytes_316224);
        mem_316401_cached_sizze_338998 = bytes_316224;
    }
    for (; iter_334853 < end; iter_334853++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_335001 = partition_sizze_292766;
        int64_t gtid_309010 = iter_334853;
        int64_t remnant_335002 = iter_334853 - gtid_309010;
        int64_t x_296423;
        
        x_296423 = ((int64_t *) mem_312639.mem)[gtid_309010];
        for (int64_t i_334854 = 0; i_334854 < n_292675; i_334854++) {
            float x_334856;
            
            x_334856 = ((float *) mem_312593.mem)[gtid_309010 * n_292675 +
                                                  i_334854];
            
            double x_334857;
            
            x_334857 = ((double *) mem_315656.mem)[gtid_309010 * n_292675 +
                                                   i_334854];
            
            double f32_res_334858 = fpconv_f32_f64(x_334856);
            double defunc_1_f_res_334859 = f32_res_334858 - x_334857;
            
            ((double *) mem_316303)[i_334854] = defunc_1_f_res_334859;
        }
        for (int64_t i_334861 = 0; i_334861 < n_292675; i_334861++) {
            int64_t x_334864;
            
            x_334864 = ((int64_t *) mem_312636.mem)[gtid_309010 * n_292675 +
                                                    i_334861];
            
            bool cond_334865 = sle64((int64_t) 0, x_334864);
            double defunc_0_f_res_334866;
            
            if (cond_334865) {
                bool y_334867 = slt64(x_334864, n_292675);
                bool bounds_check_334868 = cond_334865 && y_334867;
                bool index_certs_334869;
                
                if (!bounds_check_334868) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [", (long long) x_334864,
                                  "] out of bounds for array of shape [",
                                  (long long) n_292675, "].",
                                  "-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:45:43-70\n   #3  stl.fut:285:33-58\n   #4  /prelude/soacs.fut:75:22-28\n   #5  /prelude/soacs.fut:75:3-45\n   #6  stl.fut:283:13-288:41\n   #7  stl.fut:419:61-435:77\n   #8  stl.fut:463:3-479:36\n   #9  stl.fut:445:1-479:36\n");
                    err = FUTHARK_PROGRAM_ERROR;
                    goto cleanup;
                }
                
                double defunc_0_f_res_t_res_334870;
                
                defunc_0_f_res_t_res_334870 = ((double *) mem_316303)[x_334864];
                defunc_0_f_res_334866 = defunc_0_f_res_t_res_334870;
            } else {
                defunc_0_f_res_334866 = 0.0;
            }
            
            double defunc_0_f_res_334871;
            
            if (cond_334865) {
                bool y_334872 = slt64(x_334864, n_292675);
                bool bounds_check_334873 = cond_334865 && y_334872;
                bool index_certs_334874;
                
                if (!bounds_check_334873) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [", (long long) x_334864,
                                  "] out of bounds for array of shape [",
                                  (long long) n_292675, "].",
                                  "-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:45:43-70\n   #3  stl.fut:286:33-64\n   #4  /prelude/soacs.fut:75:22-28\n   #5  /prelude/soacs.fut:75:3-45\n   #6  stl.fut:283:13-288:41\n   #7  stl.fut:419:61-435:77\n   #8  stl.fut:463:3-479:36\n   #9  stl.fut:445:1-479:36\n");
                    err = FUTHARK_PROGRAM_ERROR;
                    goto cleanup;
                }
                
                double defunc_0_f_res_t_res_334875;
                
                defunc_0_f_res_t_res_334875 =
                    ((double *) mem_param_313179.mem)[ctx_param_ext_313174 +
                                                      (gtid_309010 *
                                                       ctx_param_ext_313175 +
                                                       x_334864 *
                                                       ctx_param_ext_313177)];
                defunc_0_f_res_334871 = defunc_0_f_res_t_res_334875;
            } else {
                defunc_0_f_res_334871 = 0.0;
            }
            ((double *) mem_316318)[i_334861] = defunc_0_f_res_334871;
            ((double *) mem_316321)[i_334861] = defunc_0_f_res_334866;
        }
        for (int64_t i_334878 = 0; i_334878 < t_n_m_292839; i_334878++) {
            int64_t x_334881;
            
            x_334881 = ((int64_t *) mem_313143.mem)[gtid_309010 * t_n_m_292839 +
                                                    i_334878];
            
            double x_334882;
            
            x_334882 = ((double *) mem_313147.mem)[gtid_309010 * t_n_m_292839 +
                                                   i_334878];
            
            int64_t min_arg_334883 = mul64(jump_t_292685, i_334878);
            int64_t min_res_334884 = smin64(i_292846, min_arg_334883);
            int64_t defunc_0_g_res_334885 = add64((int64_t) 1, min_res_334884);
            
            for (int64_t i_334890 = 0; i_334890 < q_t_292679; i_334890++) {
                bool cond_334893 = sle64(x_296423, i_334890);
                int64_t defunc_0_f_res_334894;
                
                if (cond_334893) {
                    defunc_0_f_res_334894 = (int64_t) 0;
                } else {
                    int64_t i_334895 = add64(x_334881, i_334890);
                    int64_t defunc_0_add_arg_334896;
                    
                    defunc_0_add_arg_334896 =
                        ((int64_t *) mem_312636.mem)[gtid_309010 * n_292675 +
                                                     i_334895];
                    
                    int64_t defunc_1_add_res_334897 = add64((int64_t) 1,
                                                            defunc_0_add_arg_334896);
                    
                    defunc_0_f_res_334894 = defunc_1_add_res_334897;
                }
                
                double defunc_0_f_res_334898;
                
                if (cond_334893) {
                    defunc_0_f_res_334898 = 0.0;
                } else {
                    int64_t i_334899 = add64(x_334881, i_334890);
                    double defunc_0_add_arg_334900;
                    
                    defunc_0_add_arg_334900 = ((double *) mem_316318)[i_334899];
                    defunc_0_f_res_334898 = defunc_0_add_arg_334900;
                }
                
                int64_t binop_p_334901 = sub64(defunc_0_f_res_334894,
                                               defunc_0_g_res_334885);
                double defunc_0_f_res_334902 = sitofp_i64_f64(binop_p_334901);
                double abs_res_334903 = fabs(defunc_0_f_res_334902);
                double tmp1_334904 = abs_res_334903 / x_334882;
                double x_334905 = tmp1_334904 * tmp1_334904;
                double y_334906 = tmp1_334904 * x_334905;
                double tmp2_334907 = 1.0 - y_334906;
                double x_334908 = tmp2_334907 * tmp2_334907;
                double tmp3_334909 = tmp2_334907 * x_334908;
                double tmp4_334910 = defunc_0_f_res_334898 * tmp3_334909;
                
                ((double *) mem_316368)[i_334890] = defunc_0_f_res_334902;
                ((double *) mem_316371)[i_334890] = tmp4_334910;
            }
            
            double defunc_2_reduce_res_334915;
            double defunc_2_reduce_res_334916;
            double defunc_2_reduce_res_334917;
            double defunc_2_reduce_res_334918;
            double defunc_2_reduce_res_334919;
            double redout_334923;
            double redout_334924;
            double redout_334925;
            double redout_334926;
            double redout_334927;
            
            redout_334923 = 0.0;
            redout_334924 = 0.0;
            redout_334925 = 0.0;
            redout_334926 = 0.0;
            redout_334927 = 0.0;
            for (int64_t i_334922 = 0; i_334922 < q_t_292679; i_334922++) {
                double x_334930;
                
                x_334930 = ((double *) mem_316368)[i_334922];
                
                double x_334931;
                
                x_334931 = ((double *) mem_316371)[i_334922];
                
                double defunc_1_f_res_334932 = x_334930 * x_334931;
                double defunc_1_f_res_334933 = x_334930 * defunc_1_f_res_334932;
                double defunc_1_f_res_334934 = x_334930 * defunc_1_f_res_334933;
                double defunc_1_f_res_334935 = x_334930 * defunc_1_f_res_334934;
                double defunc_1_op_res_334936 = x_334931 + redout_334923;
                double defunc_1_op_res_334937 = defunc_1_f_res_334932 +
                       redout_334924;
                double defunc_1_op_res_334938 = defunc_1_f_res_334933 +
                       redout_334925;
                double defunc_1_op_res_334939 = defunc_1_f_res_334934 +
                       redout_334926;
                double defunc_1_op_res_334940 = defunc_1_f_res_334935 +
                       redout_334927;
                
                ((double *) mem_316398)[i_334922] = defunc_1_f_res_334933;
                ((double *) mem_316401)[i_334922] = defunc_1_f_res_334932;
                
                double redout_tmp_335010 = defunc_1_op_res_334936;
                double redout_tmp_335011 = defunc_1_op_res_334937;
                double redout_tmp_335012 = defunc_1_op_res_334938;
                double redout_tmp_335013 = defunc_1_op_res_334939;
                double redout_tmp_335014 = defunc_1_op_res_334940;
                
                redout_334923 = redout_tmp_335010;
                redout_334924 = redout_tmp_335011;
                redout_334925 = redout_tmp_335012;
                redout_334926 = redout_tmp_335013;
                redout_334927 = redout_tmp_335014;
            }
            defunc_2_reduce_res_334915 = redout_334923;
            defunc_2_reduce_res_334916 = redout_334924;
            defunc_2_reduce_res_334917 = redout_334925;
            defunc_2_reduce_res_334918 = redout_334926;
            defunc_2_reduce_res_334919 = redout_334927;
            
            double a_334943 = 2.220446049250313e-16 +
                   defunc_2_reduce_res_334915;
            double b_334944 = 2.220446049250313e-16 +
                   defunc_2_reduce_res_334916;
            double c_334945 = 2.220446049250313e-16 +
                   defunc_2_reduce_res_334917;
            double d_334946 = 2.220446049250313e-16 +
                   defunc_2_reduce_res_334918;
            double e_334947 = 2.220446049250313e-16 +
                   defunc_2_reduce_res_334919;
            double x_334948 = c_334945 * e_334947;
            double y_334949 = d_334946 * d_334946;
            double a12_334950 = x_334948 - y_334949;
            double x_334951 = c_334945 * d_334946;
            double y_334952 = b_334944 * e_334947;
            double b12_334953 = x_334951 - y_334952;
            double x_334954 = b_334944 * d_334946;
            double y_334955 = c_334945 * c_334945;
            double c12_334956 = x_334954 - y_334955;
            double x_334957 = a_334943 * e_334947;
            double b2_334958 = x_334957 - y_334955;
            double x_334959 = b_334944 * c_334945;
            double y_334960 = a_334943 * d_334946;
            double c2_334961 = x_334959 - y_334960;
            double x_334962 = a_334943 * a12_334950;
            double y_334963 = b_334944 * b12_334953;
            double x_334964 = x_334962 + y_334963;
            double y_334965 = c_334945 * c12_334956;
            double y_334966 = x_334964 + y_334965;
            double det_334967 = 1.0 / y_334966;
            double a12_334968 = a12_334950 * det_334967;
            double b12_334969 = b12_334953 * det_334967;
            double c12_334970 = c12_334956 * det_334967;
            double b2_334971 = b2_334958 * det_334967;
            double c2_334972 = c2_334961 * det_334967;
            double defunc_2_reduce_res_334973;
            double defunc_2_reduce_res_334974;
            double redout_334976;
            double redout_334977;
            
            redout_334976 = 0.0;
            redout_334977 = 0.0;
            for (int64_t i_334975 = 0; i_334975 < q_t_292679; i_334975++) {
                double x_334978;
                
                x_334978 = ((double *) mem_316371)[i_334975];
                
                double x_334979;
                
                x_334979 = ((double *) mem_316401)[i_334975];
                
                double x_334980;
                
                x_334980 = ((double *) mem_316398)[i_334975];
                
                bool cond_334981 = sle64(x_296423, i_334975);
                double defunc_0_f_res_334982;
                
                if (cond_334981) {
                    defunc_0_f_res_334982 = 0.0;
                } else {
                    int64_t i_334983 = add64(x_334881, i_334975);
                    double defunc_0_add_arg_334984;
                    
                    defunc_0_add_arg_334984 = ((double *) mem_316321)[i_334983];
                    defunc_0_f_res_334982 = defunc_0_add_arg_334984;
                }
                
                double x_334985 = a12_334968 * x_334978;
                double y_334986 = b12_334969 * x_334979;
                double x_334987 = x_334985 + y_334986;
                double y_334988 = c12_334970 * x_334980;
                double x_334989 = x_334987 + y_334988;
                double defunc_9_fit_fun_res_334990 = defunc_0_f_res_334982 *
                       x_334989;
                double x_334991 = b12_334969 * x_334978;
                double y_334992 = b2_334971 * x_334979;
                double x_334993 = x_334991 + y_334992;
                double y_334994 = c2_334972 * x_334980;
                double x_334995 = x_334993 + y_334994;
                double defunc_9_slope_fun_res_334996 = defunc_0_f_res_334982 *
                       x_334995;
                double defunc_1_op_res_334997 = defunc_9_fit_fun_res_334990 +
                       redout_334976;
                double defunc_1_op_res_334998 = defunc_9_slope_fun_res_334996 +
                       redout_334977;
                double redout_tmp_335017 = defunc_1_op_res_334997;
                double redout_tmp_335018 = defunc_1_op_res_334998;
                
                redout_334976 = redout_tmp_335017;
                redout_334977 = redout_tmp_335018;
            }
            defunc_2_reduce_res_334973 = redout_334976;
            defunc_2_reduce_res_334974 = redout_334977;
            ((double *) mem_316348)[i_334878] = defunc_2_reduce_res_334973;
            ((double *) mem_316351)[i_334878] = defunc_2_reduce_res_334974;
        }
        if (t_n_m_292839 * (int64_t) 8 > 0)
            memmove(mem_316439.mem + gtid_309010 * t_n_m_292839 * (int64_t) 8,
                    mem_316348 + (int64_t) 0, t_n_m_292839 * (int64_t) 8);
        if (t_n_m_292839 * (int64_t) 8 > 0)
            memmove(mem_316443.mem + gtid_309010 * t_n_m_292839 * (int64_t) 8,
                    mem_316351 + (int64_t) 0, t_n_m_292839 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_316303);
    free(mem_316318);
    free(mem_316321);
    free(mem_316348);
    free(mem_316351);
    free(mem_316368);
    free(mem_316371);
    free(mem_316398);
    free(mem_316401);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338989_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338989_end -
                 futhark_mc_segmap_parloop_338989_start;
        
        ctx->futhark_mc_segmap_parloop_338989_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_338989_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_338989_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_338987(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_309009 = tid;
    int num_tasks_334852 = info.nsubtasks;
    struct futhark_mc_task_338986 *futhark_mc_task_338986 =
                                  (struct futhark_mc_task_338986 *) args;
    struct futhark_context *ctx = futhark_mc_task_338986->ctx;
    uint64_t futhark_mc_segmap_task_338987_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_338987_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338986->free_n_292675;
    int64_t q_t_292679 = futhark_mc_task_338986->free_q_t_292679;
    int64_t jump_t_292685 = futhark_mc_task_338986->free_jump_t_292685;
    int64_t partition_sizze_292766 =
            futhark_mc_task_338986->free_partition_sizze_292766;
    int64_t t_n_m_292839 = futhark_mc_task_338986->free_t_n_m_292839;
    int64_t i_292846 = futhark_mc_task_338986->free_i_292846;
    struct memblock mem_312593 = {.desc ="mem_312593", .mem =
                                  futhark_mc_task_338986->free_mem_312593,
                                  .size =0, .references =NULL};
    int64_t bytes_312598 = futhark_mc_task_338986->free_bytes_312598;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_task_338986->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_312639 = {.desc ="mem_312639", .mem =
                                  futhark_mc_task_338986->free_mem_312639,
                                  .size =0, .references =NULL};
    int64_t bytes_313090 = futhark_mc_task_338986->free_bytes_313090;
    struct memblock mem_313143 = {.desc ="mem_313143", .mem =
                                  futhark_mc_task_338986->free_mem_313143,
                                  .size =0, .references =NULL};
    struct memblock mem_313147 = {.desc ="mem_313147", .mem =
                                  futhark_mc_task_338986->free_mem_313147,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_task_338986->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_task_338986->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_task_338986->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_task_338986->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315656 = {.desc ="mem_315656", .mem =
                                  futhark_mc_task_338986->free_mem_315656,
                                  .size =0, .references =NULL};
    int64_t bytes_316224 = futhark_mc_task_338986->free_bytes_316224;
    struct memblock mem_316439 = {.desc ="mem_316439", .mem =
                                  futhark_mc_task_338986->free_mem_316439,
                                  .size =0, .references =NULL};
    struct memblock mem_316443 = {.desc ="mem_316443", .mem =
                                  futhark_mc_task_338986->free_mem_316443,
                                  .size =0, .references =NULL};
    int64_t iter_334853;
    struct futhark_mc_segmap_parloop_struct_338988
    futhark_mc_segmap_parloop_struct_338988;
    
    futhark_mc_segmap_parloop_struct_338988.ctx = ctx;
    futhark_mc_segmap_parloop_struct_338988.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_338988.free_q_t_292679 = q_t_292679;
    futhark_mc_segmap_parloop_struct_338988.free_jump_t_292685 = jump_t_292685;
    futhark_mc_segmap_parloop_struct_338988.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_338988.free_t_n_m_292839 = t_n_m_292839;
    futhark_mc_segmap_parloop_struct_338988.free_i_292846 = i_292846;
    futhark_mc_segmap_parloop_struct_338988.free_mem_312593 = mem_312593.mem;
    futhark_mc_segmap_parloop_struct_338988.free_bytes_312598 = bytes_312598;
    futhark_mc_segmap_parloop_struct_338988.free_mem_312636 = mem_312636.mem;
    futhark_mc_segmap_parloop_struct_338988.free_mem_312639 = mem_312639.mem;
    futhark_mc_segmap_parloop_struct_338988.free_bytes_313090 = bytes_313090;
    futhark_mc_segmap_parloop_struct_338988.free_mem_313143 = mem_313143.mem;
    futhark_mc_segmap_parloop_struct_338988.free_mem_313147 = mem_313147.mem;
    futhark_mc_segmap_parloop_struct_338988.free_ctx_param_ext_313174 =
        ctx_param_ext_313174;
    futhark_mc_segmap_parloop_struct_338988.free_ctx_param_ext_313175 =
        ctx_param_ext_313175;
    futhark_mc_segmap_parloop_struct_338988.free_ctx_param_ext_313177 =
        ctx_param_ext_313177;
    futhark_mc_segmap_parloop_struct_338988.free_mem_param_313179 =
        mem_param_313179.mem;
    futhark_mc_segmap_parloop_struct_338988.free_mem_315656 = mem_315656.mem;
    futhark_mc_segmap_parloop_struct_338988.free_bytes_316224 = bytes_316224;
    futhark_mc_segmap_parloop_struct_338988.free_mem_316439 = mem_316439.mem;
    futhark_mc_segmap_parloop_struct_338988.free_mem_316443 = mem_316443.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_338989_task;
    
    futhark_mc_segmap_parloop_338989_task.name =
        "futhark_mc_segmap_parloop_338989";
    futhark_mc_segmap_parloop_338989_task.fn = futhark_mc_segmap_parloop_338989;
    futhark_mc_segmap_parloop_338989_task.args =
        &futhark_mc_segmap_parloop_struct_338988;
    futhark_mc_segmap_parloop_338989_task.iterations = iterations;
    futhark_mc_segmap_parloop_338989_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_338989_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_338989_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_338989_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_338989_task);
    
    if (futhark_mc_segmap_parloop_338989_err != 0) {
        err = futhark_mc_segmap_parloop_338989_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_338989_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_338989_total_end -
                 futhark_mc_segmap_parloop_338989_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338989_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338989_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_338989_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_338987_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_338987_end -
                 futhark_mc_segmap_task_338987_start;
        
        ctx->futhark_mc_segmap_task_338987_runs[tid]++;
        ctx->futhark_mc_segmap_task_338987_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_338987_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_segmap_parloop_struct_339000 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_t_292679;
    int64_t free_jump_t_292685;
    int64_t free_partition_sizze_292766;
    int64_t free_t_n_m_292839;
    int64_t free_i_292846;
    unsigned char *free_mem_312593;
    int64_t free_bytes_312598;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_312639;
    int64_t free_bytes_313090;
    unsigned char *free_mem_313143;
    unsigned char *free_mem_313147;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315656;
    int64_t free_bytes_316224;
    unsigned char *free_mem_316439;
    unsigned char *free_mem_316443;
};
struct futhark_mc_task_339007 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_309149;
    unsigned char *free_mem_312593;
    unsigned char *free_mem_315656;
    unsigned char *free_mem_316216;
};
struct futhark_mc_segmap_parloop_struct_339009 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_309149;
    unsigned char *free_mem_312593;
    unsigned char *free_mem_315656;
    unsigned char *free_mem_316216;
};
static int futhark_mc_segmap_parloop_339010(void *args, int64_t start,
                                            int64_t end, int flat_tid_335020,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_339009
    *futhark_mc_segmap_parloop_struct_339009 =
    (struct futhark_mc_segmap_parloop_struct_339009 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_339009->ctx;
    uint64_t futhark_mc_segmap_parloop_339010_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339010_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_339009->free_n_292675;
    int64_t gtid_309149 =
            futhark_mc_segmap_parloop_struct_339009->free_gtid_309149;
    struct memblock mem_312593 = {.desc ="mem_312593", .mem =
                                  futhark_mc_segmap_parloop_struct_339009->free_mem_312593,
                                  .size =0, .references =NULL};
    struct memblock mem_315656 = {.desc ="mem_315656", .mem =
                                  futhark_mc_segmap_parloop_struct_339009->free_mem_315656,
                                  .size =0, .references =NULL};
    struct memblock mem_316216 = {.desc ="mem_316216", .mem =
                                  futhark_mc_segmap_parloop_struct_339009->free_mem_316216,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_335289 = start;
    
    for (; iter_335289 < end; iter_335289++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_335290 = n_292675;
        int64_t gtid_335021 = iter_335289;
        int64_t remnant_335291 = iter_335289 - gtid_335021;
        float x_335022;
        
        x_335022 = ((float *) mem_312593.mem)[gtid_309149 * n_292675 +
                                              gtid_335021];
        
        double x_335023;
        
        x_335023 = ((double *) mem_315656.mem)[gtid_309149 * n_292675 +
                                               gtid_335021];
        
        double f32_res_335024 = fpconv_f32_f64(x_335022);
        double defunc_1_f_res_335025 = f32_res_335024 - x_335023;
        
        ((double *) mem_316216.mem)[gtid_335021] = defunc_1_f_res_335025;
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339010_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339010_end -
                 futhark_mc_segmap_parloop_339010_start;
        
        ctx->futhark_mc_segmap_parloop_339010_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_339010_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_339010_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_339008(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_335020 = tid;
    int num_tasks_335288 = info.nsubtasks;
    struct futhark_mc_task_339007 *futhark_mc_task_339007 =
                                  (struct futhark_mc_task_339007 *) args;
    struct futhark_context *ctx = futhark_mc_task_339007->ctx;
    uint64_t futhark_mc_segmap_task_339008_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_339008_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_339007->free_n_292675;
    int64_t gtid_309149 = futhark_mc_task_339007->free_gtid_309149;
    struct memblock mem_312593 = {.desc ="mem_312593", .mem =
                                  futhark_mc_task_339007->free_mem_312593,
                                  .size =0, .references =NULL};
    struct memblock mem_315656 = {.desc ="mem_315656", .mem =
                                  futhark_mc_task_339007->free_mem_315656,
                                  .size =0, .references =NULL};
    struct memblock mem_316216 = {.desc ="mem_316216", .mem =
                                  futhark_mc_task_339007->free_mem_316216,
                                  .size =0, .references =NULL};
    int64_t iter_335289;
    struct futhark_mc_segmap_parloop_struct_339009
    futhark_mc_segmap_parloop_struct_339009;
    
    futhark_mc_segmap_parloop_struct_339009.ctx = ctx;
    futhark_mc_segmap_parloop_struct_339009.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_339009.free_gtid_309149 = gtid_309149;
    futhark_mc_segmap_parloop_struct_339009.free_mem_312593 = mem_312593.mem;
    futhark_mc_segmap_parloop_struct_339009.free_mem_315656 = mem_315656.mem;
    futhark_mc_segmap_parloop_struct_339009.free_mem_316216 = mem_316216.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_339010_task;
    
    futhark_mc_segmap_parloop_339010_task.name =
        "futhark_mc_segmap_parloop_339010";
    futhark_mc_segmap_parloop_339010_task.fn = futhark_mc_segmap_parloop_339010;
    futhark_mc_segmap_parloop_339010_task.args =
        &futhark_mc_segmap_parloop_struct_339009;
    futhark_mc_segmap_parloop_339010_task.iterations = iterations;
    futhark_mc_segmap_parloop_339010_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_339010_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339010_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_339010_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_339010_task);
    
    if (futhark_mc_segmap_parloop_339010_err != 0) {
        err = futhark_mc_segmap_parloop_339010_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339010_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339010_total_end -
                 futhark_mc_segmap_parloop_339010_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339010_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339010_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339010_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_339008_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_339008_end -
                 futhark_mc_segmap_task_339008_start;
        
        ctx->futhark_mc_segmap_task_339008_runs[tid]++;
        ctx->futhark_mc_segmap_task_339008_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_339008_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_task_339011 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_309149;
    unsigned char *free_mem_312636;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_316216;
    unsigned char *free_mem_316219;
    unsigned char *free_mem_316222;
};
struct futhark_mc_segmap_parloop_struct_339013 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_309149;
    unsigned char *free_mem_312636;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_316216;
    unsigned char *free_mem_316219;
    unsigned char *free_mem_316222;
};
static int futhark_mc_segmap_parloop_339014(void *args, int64_t start,
                                            int64_t end, int flat_tid_335026,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_339013
    *futhark_mc_segmap_parloop_struct_339013 =
    (struct futhark_mc_segmap_parloop_struct_339013 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_339013->ctx;
    uint64_t futhark_mc_segmap_parloop_339014_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339014_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_339013->free_n_292675;
    int64_t gtid_309149 =
            futhark_mc_segmap_parloop_struct_339013->free_gtid_309149;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_segmap_parloop_struct_339013->free_mem_312636,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_segmap_parloop_struct_339013->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_segmap_parloop_struct_339013->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_segmap_parloop_struct_339013->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_segmap_parloop_struct_339013->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_316216 = {.desc ="mem_316216", .mem =
                                  futhark_mc_segmap_parloop_struct_339013->free_mem_316216,
                                  .size =0, .references =NULL};
    struct memblock mem_316219 = {.desc ="mem_316219", .mem =
                                  futhark_mc_segmap_parloop_struct_339013->free_mem_316219,
                                  .size =0, .references =NULL};
    struct memblock mem_316222 = {.desc ="mem_316222", .mem =
                                  futhark_mc_segmap_parloop_struct_339013->free_mem_316222,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_335293 = start;
    
    for (; iter_335293 < end; iter_335293++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_335302 = n_292675;
        int64_t gtid_335027 = iter_335293;
        int64_t remnant_335303 = iter_335293 - gtid_335027;
        int64_t x_335028;
        
        x_335028 = ((int64_t *) mem_312636.mem)[gtid_309149 * n_292675 +
                                                gtid_335027];
        
        bool cond_335029 = sle64((int64_t) 0, x_335028);
        double defunc_0_f_res_335030;
        
        if (cond_335029) {
            bool y_335294 = slt64(x_335028, n_292675);
            bool bounds_check_335295 = cond_335029 && y_335294;
            bool index_certs_335296;
            
            if (!bounds_check_335295) {
                ctx->error =
                    msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                              "Index [", (long long) x_335028,
                              "] out of bounds for array of shape [",
                              (long long) n_292675, "].",
                              "-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:45:43-70\n   #3  stl.fut:285:33-58\n   #4  /prelude/soacs.fut:75:22-28\n   #5  /prelude/soacs.fut:75:3-45\n   #6  stl.fut:283:13-288:41\n   #7  stl.fut:419:61-435:77\n   #8  stl.fut:463:3-479:36\n   #9  stl.fut:445:1-479:36\n");
                err = FUTHARK_PROGRAM_ERROR;
                goto cleanup;
            }
            
            double defunc_0_f_res_t_res_335297;
            
            defunc_0_f_res_t_res_335297 = ((double *) mem_316216.mem)[x_335028];
            defunc_0_f_res_335030 = defunc_0_f_res_t_res_335297;
        } else {
            defunc_0_f_res_335030 = 0.0;
        }
        
        double defunc_0_f_res_335035;
        
        if (cond_335029) {
            bool y_335298 = slt64(x_335028, n_292675);
            bool bounds_check_335299 = cond_335029 && y_335298;
            bool index_certs_335300;
            
            if (!bounds_check_335299) {
                ctx->error =
                    msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                              "Index [", (long long) x_335028,
                              "] out of bounds for array of shape [",
                              (long long) n_292675, "].",
                              "-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:45:43-70\n   #3  stl.fut:286:33-64\n   #4  /prelude/soacs.fut:75:22-28\n   #5  /prelude/soacs.fut:75:3-45\n   #6  stl.fut:283:13-288:41\n   #7  stl.fut:419:61-435:77\n   #8  stl.fut:463:3-479:36\n   #9  stl.fut:445:1-479:36\n");
                err = FUTHARK_PROGRAM_ERROR;
                goto cleanup;
            }
            
            double defunc_0_f_res_t_res_335301;
            
            defunc_0_f_res_t_res_335301 =
                ((double *) mem_param_313179.mem)[ctx_param_ext_313174 +
                                                  (gtid_309149 *
                                                   ctx_param_ext_313175 +
                                                   x_335028 *
                                                   ctx_param_ext_313177)];
            defunc_0_f_res_335035 = defunc_0_f_res_t_res_335301;
        } else {
            defunc_0_f_res_335035 = 0.0;
        }
        ((double *) mem_316219.mem)[gtid_335027] = defunc_0_f_res_335035;
        ((double *) mem_316222.mem)[gtid_335027] = defunc_0_f_res_335030;
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339014_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339014_end -
                 futhark_mc_segmap_parloop_339014_start;
        
        ctx->futhark_mc_segmap_parloop_339014_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_339014_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_339014_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_339012(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_335026 = tid;
    int num_tasks_335292 = info.nsubtasks;
    struct futhark_mc_task_339011 *futhark_mc_task_339011 =
                                  (struct futhark_mc_task_339011 *) args;
    struct futhark_context *ctx = futhark_mc_task_339011->ctx;
    uint64_t futhark_mc_segmap_task_339012_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_339012_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_339011->free_n_292675;
    int64_t gtid_309149 = futhark_mc_task_339011->free_gtid_309149;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_task_339011->free_mem_312636,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_task_339011->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_task_339011->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_task_339011->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_task_339011->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_316216 = {.desc ="mem_316216", .mem =
                                  futhark_mc_task_339011->free_mem_316216,
                                  .size =0, .references =NULL};
    struct memblock mem_316219 = {.desc ="mem_316219", .mem =
                                  futhark_mc_task_339011->free_mem_316219,
                                  .size =0, .references =NULL};
    struct memblock mem_316222 = {.desc ="mem_316222", .mem =
                                  futhark_mc_task_339011->free_mem_316222,
                                  .size =0, .references =NULL};
    int64_t iter_335293;
    struct futhark_mc_segmap_parloop_struct_339013
    futhark_mc_segmap_parloop_struct_339013;
    
    futhark_mc_segmap_parloop_struct_339013.ctx = ctx;
    futhark_mc_segmap_parloop_struct_339013.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_339013.free_gtid_309149 = gtid_309149;
    futhark_mc_segmap_parloop_struct_339013.free_mem_312636 = mem_312636.mem;
    futhark_mc_segmap_parloop_struct_339013.free_ctx_param_ext_313174 =
        ctx_param_ext_313174;
    futhark_mc_segmap_parloop_struct_339013.free_ctx_param_ext_313175 =
        ctx_param_ext_313175;
    futhark_mc_segmap_parloop_struct_339013.free_ctx_param_ext_313177 =
        ctx_param_ext_313177;
    futhark_mc_segmap_parloop_struct_339013.free_mem_param_313179 =
        mem_param_313179.mem;
    futhark_mc_segmap_parloop_struct_339013.free_mem_316216 = mem_316216.mem;
    futhark_mc_segmap_parloop_struct_339013.free_mem_316219 = mem_316219.mem;
    futhark_mc_segmap_parloop_struct_339013.free_mem_316222 = mem_316222.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_339014_task;
    
    futhark_mc_segmap_parloop_339014_task.name =
        "futhark_mc_segmap_parloop_339014";
    futhark_mc_segmap_parloop_339014_task.fn = futhark_mc_segmap_parloop_339014;
    futhark_mc_segmap_parloop_339014_task.args =
        &futhark_mc_segmap_parloop_struct_339013;
    futhark_mc_segmap_parloop_339014_task.iterations = iterations;
    futhark_mc_segmap_parloop_339014_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_339014_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339014_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_339014_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_339014_task);
    
    if (futhark_mc_segmap_parloop_339014_err != 0) {
        err = futhark_mc_segmap_parloop_339014_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339014_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339014_total_end -
                 futhark_mc_segmap_parloop_339014_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339014_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339014_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339014_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_339012_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_339012_end -
                 futhark_mc_segmap_task_339012_start;
        
        ctx->futhark_mc_segmap_task_339012_runs[tid]++;
        ctx->futhark_mc_segmap_task_339012_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_339012_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_task_339015 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_t_292679;
    int64_t free_jump_t_292685;
    int64_t free_t_n_m_292839;
    int64_t free_i_292846;
    int64_t free_gtid_309149;
    int64_t free_x_309154;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_313143;
    unsigned char *free_mem_313147;
    unsigned char *free_mem_316219;
    unsigned char *free_mem_316222;
    int64_t free_bytes_316224;
    unsigned char *free_mem_316297;
    unsigned char *free_mem_316300;
};
struct futhark_mc_segmap_parloop_struct_339017 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_t_292679;
    int64_t free_jump_t_292685;
    int64_t free_t_n_m_292839;
    int64_t free_i_292846;
    int64_t free_gtid_309149;
    int64_t free_x_309154;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_313143;
    unsigned char *free_mem_313147;
    unsigned char *free_mem_316219;
    unsigned char *free_mem_316222;
    int64_t free_bytes_316224;
    unsigned char *free_mem_316297;
    unsigned char *free_mem_316300;
};
static int futhark_mc_segmap_parloop_339018(void *args, int64_t start,
                                            int64_t end, int flat_tid_335162,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_339017
    *futhark_mc_segmap_parloop_struct_339017 =
    (struct futhark_mc_segmap_parloop_struct_339017 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_339017->ctx;
    uint64_t futhark_mc_segmap_parloop_339018_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339018_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_339017->free_n_292675;
    int64_t q_t_292679 =
            futhark_mc_segmap_parloop_struct_339017->free_q_t_292679;
    int64_t jump_t_292685 =
            futhark_mc_segmap_parloop_struct_339017->free_jump_t_292685;
    int64_t t_n_m_292839 =
            futhark_mc_segmap_parloop_struct_339017->free_t_n_m_292839;
    int64_t i_292846 = futhark_mc_segmap_parloop_struct_339017->free_i_292846;
    int64_t gtid_309149 =
            futhark_mc_segmap_parloop_struct_339017->free_gtid_309149;
    int64_t x_309154 = futhark_mc_segmap_parloop_struct_339017->free_x_309154;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_segmap_parloop_struct_339017->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_313143 = {.desc ="mem_313143", .mem =
                                  futhark_mc_segmap_parloop_struct_339017->free_mem_313143,
                                  .size =0, .references =NULL};
    struct memblock mem_313147 = {.desc ="mem_313147", .mem =
                                  futhark_mc_segmap_parloop_struct_339017->free_mem_313147,
                                  .size =0, .references =NULL};
    struct memblock mem_316219 = {.desc ="mem_316219", .mem =
                                  futhark_mc_segmap_parloop_struct_339017->free_mem_316219,
                                  .size =0, .references =NULL};
    struct memblock mem_316222 = {.desc ="mem_316222", .mem =
                                  futhark_mc_segmap_parloop_struct_339017->free_mem_316222,
                                  .size =0, .references =NULL};
    int64_t bytes_316224 =
            futhark_mc_segmap_parloop_struct_339017->free_bytes_316224;
    struct memblock mem_316297 = {.desc ="mem_316297", .mem =
                                  futhark_mc_segmap_parloop_struct_339017->free_mem_316297,
                                  .size =0, .references =NULL};
    struct memblock mem_316300 = {.desc ="mem_316300", .mem =
                                  futhark_mc_segmap_parloop_struct_339017->free_mem_316300,
                                  .size =0, .references =NULL};
    size_t mem_335169_cached_sizze_339019 = 0;
    unsigned char *mem_335169 = NULL;
    size_t mem_335171_cached_sizze_339020 = 0;
    unsigned char *mem_335171 = NULL;
    size_t mem_335198_cached_sizze_339021 = 0;
    unsigned char *mem_335198 = NULL;
    size_t mem_335200_cached_sizze_339022 = 0;
    unsigned char *mem_335200 = NULL;
    int64_t iterations = end - start;
    int64_t iter_335305 = start;
    
    if (mem_335169_cached_sizze_339019 < (size_t) bytes_316224) {
        mem_335169 = realloc(mem_335169, bytes_316224);
        mem_335169_cached_sizze_339019 = bytes_316224;
    }
    if (mem_335171_cached_sizze_339020 < (size_t) bytes_316224) {
        mem_335171 = realloc(mem_335171, bytes_316224);
        mem_335171_cached_sizze_339020 = bytes_316224;
    }
    if (mem_335198_cached_sizze_339021 < (size_t) bytes_316224) {
        mem_335198 = realloc(mem_335198, bytes_316224);
        mem_335198_cached_sizze_339021 = bytes_316224;
    }
    if (mem_335200_cached_sizze_339022 < (size_t) bytes_316224) {
        mem_335200 = realloc(mem_335200, bytes_316224);
        mem_335200_cached_sizze_339022 = bytes_316224;
    }
    for (; iter_335305 < end; iter_335305++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_335374 = t_n_m_292839;
        int64_t gtid_335163 = iter_335305;
        int64_t remnant_335375 = iter_335305 - gtid_335163;
        int64_t x_335164;
        
        x_335164 = ((int64_t *) mem_313143.mem)[gtid_309149 * t_n_m_292839 +
                                                gtid_335163];
        
        double x_335165;
        
        x_335165 = ((double *) mem_313147.mem)[gtid_309149 * t_n_m_292839 +
                                               gtid_335163];
        
        int64_t min_arg_335166 = mul64(jump_t_292685, gtid_335163);
        int64_t min_res_335167 = smin64(i_292846, min_arg_335166);
        int64_t defunc_0_g_res_335168 = add64((int64_t) 1, min_res_335167);
        
        for (int64_t i_335306 = 0; i_335306 < q_t_292679; i_335306++) {
            bool cond_335309 = sle64(x_309154, i_335306);
            int64_t defunc_0_f_res_335310;
            
            if (cond_335309) {
                defunc_0_f_res_335310 = (int64_t) 0;
            } else {
                int64_t i_335311 = add64(x_335164, i_335306);
                int64_t defunc_0_add_arg_335312;
                
                defunc_0_add_arg_335312 =
                    ((int64_t *) mem_312636.mem)[gtid_309149 * n_292675 +
                                                 i_335311];
                
                int64_t defunc_1_add_res_335313 = add64((int64_t) 1,
                                                        defunc_0_add_arg_335312);
                
                defunc_0_f_res_335310 = defunc_1_add_res_335313;
            }
            
            double defunc_0_f_res_335314;
            
            if (cond_335309) {
                defunc_0_f_res_335314 = 0.0;
            } else {
                int64_t i_335315 = add64(x_335164, i_335306);
                double defunc_0_add_arg_335316;
                
                defunc_0_add_arg_335316 = ((double *) mem_316219.mem)[i_335315];
                defunc_0_f_res_335314 = defunc_0_add_arg_335316;
            }
            
            int64_t binop_p_335317 = sub64(defunc_0_f_res_335310,
                                           defunc_0_g_res_335168);
            double defunc_0_f_res_335318 = sitofp_i64_f64(binop_p_335317);
            double abs_res_335319 = fabs(defunc_0_f_res_335318);
            double tmp1_335320 = abs_res_335319 / x_335165;
            double x_335321 = tmp1_335320 * tmp1_335320;
            double y_335322 = tmp1_335320 * x_335321;
            double tmp2_335323 = 1.0 - y_335322;
            double x_335324 = tmp2_335323 * tmp2_335323;
            double tmp3_335325 = tmp2_335323 * x_335324;
            double tmp4_335326 = defunc_0_f_res_335314 * tmp3_335325;
            
            ((double *) mem_335169)[i_335306] = defunc_0_f_res_335318;
            ((double *) mem_335171)[i_335306] = tmp4_335326;
        }
        
        double defunc_2_reduce_res_335202;
        double defunc_2_reduce_res_335203;
        double defunc_2_reduce_res_335204;
        double defunc_2_reduce_res_335205;
        double defunc_2_reduce_res_335206;
        double redout_335330;
        double redout_335331;
        double redout_335332;
        double redout_335333;
        double redout_335334;
        
        redout_335330 = 0.0;
        redout_335331 = 0.0;
        redout_335332 = 0.0;
        redout_335333 = 0.0;
        redout_335334 = 0.0;
        for (int64_t i_335329 = 0; i_335329 < q_t_292679; i_335329++) {
            double x_335337;
            
            x_335337 = ((double *) mem_335169)[i_335329];
            
            double x_335338;
            
            x_335338 = ((double *) mem_335171)[i_335329];
            
            double defunc_1_f_res_335339 = x_335337 * x_335338;
            double defunc_1_f_res_335340 = x_335337 * defunc_1_f_res_335339;
            double defunc_1_f_res_335341 = x_335337 * defunc_1_f_res_335340;
            double defunc_1_f_res_335342 = x_335337 * defunc_1_f_res_335341;
            double defunc_1_op_res_335343 = x_335338 + redout_335330;
            double defunc_1_op_res_335344 = defunc_1_f_res_335339 +
                   redout_335331;
            double defunc_1_op_res_335345 = defunc_1_f_res_335340 +
                   redout_335332;
            double defunc_1_op_res_335346 = defunc_1_f_res_335341 +
                   redout_335333;
            double defunc_1_op_res_335347 = defunc_1_f_res_335342 +
                   redout_335334;
            
            ((double *) mem_335198)[i_335329] = defunc_1_f_res_335340;
            ((double *) mem_335200)[i_335329] = defunc_1_f_res_335339;
            
            double redout_tmp_335378 = defunc_1_op_res_335343;
            double redout_tmp_335379 = defunc_1_op_res_335344;
            double redout_tmp_335380 = defunc_1_op_res_335345;
            double redout_tmp_335381 = defunc_1_op_res_335346;
            double redout_tmp_335382 = defunc_1_op_res_335347;
            
            redout_335330 = redout_tmp_335378;
            redout_335331 = redout_tmp_335379;
            redout_335332 = redout_tmp_335380;
            redout_335333 = redout_tmp_335381;
            redout_335334 = redout_tmp_335382;
        }
        defunc_2_reduce_res_335202 = redout_335330;
        defunc_2_reduce_res_335203 = redout_335331;
        defunc_2_reduce_res_335204 = redout_335332;
        defunc_2_reduce_res_335205 = redout_335333;
        defunc_2_reduce_res_335206 = redout_335334;
        
        double a_335230 = 2.220446049250313e-16 + defunc_2_reduce_res_335202;
        double b_335231 = 2.220446049250313e-16 + defunc_2_reduce_res_335203;
        double c_335232 = 2.220446049250313e-16 + defunc_2_reduce_res_335204;
        double d_335233 = 2.220446049250313e-16 + defunc_2_reduce_res_335205;
        double e_335234 = 2.220446049250313e-16 + defunc_2_reduce_res_335206;
        double x_335235 = c_335232 * e_335234;
        double y_335236 = d_335233 * d_335233;
        double a12_335237 = x_335235 - y_335236;
        double x_335238 = c_335232 * d_335233;
        double y_335239 = b_335231 * e_335234;
        double b12_335240 = x_335238 - y_335239;
        double x_335241 = b_335231 * d_335233;
        double y_335242 = c_335232 * c_335232;
        double c12_335243 = x_335241 - y_335242;
        double x_335244 = a_335230 * e_335234;
        double b2_335245 = x_335244 - y_335242;
        double x_335246 = b_335231 * c_335232;
        double y_335247 = a_335230 * d_335233;
        double c2_335248 = x_335246 - y_335247;
        double x_335249 = a_335230 * a12_335237;
        double y_335250 = b_335231 * b12_335240;
        double x_335251 = x_335249 + y_335250;
        double y_335252 = c_335232 * c12_335243;
        double y_335253 = x_335251 + y_335252;
        double det_335254 = 1.0 / y_335253;
        double a12_335255 = a12_335237 * det_335254;
        double b12_335256 = b12_335240 * det_335254;
        double c12_335257 = c12_335243 * det_335254;
        double b2_335258 = b2_335245 * det_335254;
        double c2_335259 = c2_335248 * det_335254;
        double defunc_2_reduce_res_335260;
        double defunc_2_reduce_res_335261;
        double redout_335351;
        double redout_335352;
        
        redout_335351 = 0.0;
        redout_335352 = 0.0;
        for (int64_t i_335350 = 0; i_335350 < q_t_292679; i_335350++) {
            double x_335353;
            
            x_335353 = ((double *) mem_335171)[i_335350];
            
            double x_335354;
            
            x_335354 = ((double *) mem_335200)[i_335350];
            
            double x_335355;
            
            x_335355 = ((double *) mem_335198)[i_335350];
            
            bool cond_335356 = sle64(x_309154, i_335350);
            double defunc_0_f_res_335357;
            
            if (cond_335356) {
                defunc_0_f_res_335357 = 0.0;
            } else {
                int64_t i_335358 = add64(x_335164, i_335350);
                double defunc_0_add_arg_335359;
                
                defunc_0_add_arg_335359 = ((double *) mem_316222.mem)[i_335358];
                defunc_0_f_res_335357 = defunc_0_add_arg_335359;
            }
            
            double x_335360 = a12_335255 * x_335353;
            double y_335361 = b12_335256 * x_335354;
            double x_335362 = x_335360 + y_335361;
            double y_335363 = c12_335257 * x_335355;
            double x_335364 = x_335362 + y_335363;
            double defunc_9_fit_fun_res_335365 = defunc_0_f_res_335357 *
                   x_335364;
            double x_335366 = b12_335256 * x_335353;
            double y_335367 = b2_335258 * x_335354;
            double x_335368 = x_335366 + y_335367;
            double y_335369 = c2_335259 * x_335355;
            double x_335370 = x_335368 + y_335369;
            double defunc_9_slope_fun_res_335371 = defunc_0_f_res_335357 *
                   x_335370;
            double defunc_1_op_res_335372 = defunc_9_fit_fun_res_335365 +
                   redout_335351;
            double defunc_1_op_res_335373 = defunc_9_slope_fun_res_335371 +
                   redout_335352;
            double redout_tmp_335385 = defunc_1_op_res_335372;
            double redout_tmp_335386 = defunc_1_op_res_335373;
            
            redout_335351 = redout_tmp_335385;
            redout_335352 = redout_tmp_335386;
        }
        defunc_2_reduce_res_335260 = redout_335351;
        defunc_2_reduce_res_335261 = redout_335352;
        ((double *) mem_316297.mem)[gtid_335163] = defunc_2_reduce_res_335260;
        ((double *) mem_316300.mem)[gtid_335163] = defunc_2_reduce_res_335261;
    }
    
  cleanup:
    { }
    free(mem_335169);
    free(mem_335171);
    free(mem_335198);
    free(mem_335200);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339018_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339018_end -
                 futhark_mc_segmap_parloop_339018_start;
        
        ctx->futhark_mc_segmap_parloop_339018_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_339018_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_339018_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_339016(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_335162 = tid;
    int num_tasks_335304 = info.nsubtasks;
    struct futhark_mc_task_339015 *futhark_mc_task_339015 =
                                  (struct futhark_mc_task_339015 *) args;
    struct futhark_context *ctx = futhark_mc_task_339015->ctx;
    uint64_t futhark_mc_segmap_task_339016_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_339016_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_339015->free_n_292675;
    int64_t q_t_292679 = futhark_mc_task_339015->free_q_t_292679;
    int64_t jump_t_292685 = futhark_mc_task_339015->free_jump_t_292685;
    int64_t t_n_m_292839 = futhark_mc_task_339015->free_t_n_m_292839;
    int64_t i_292846 = futhark_mc_task_339015->free_i_292846;
    int64_t gtid_309149 = futhark_mc_task_339015->free_gtid_309149;
    int64_t x_309154 = futhark_mc_task_339015->free_x_309154;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_task_339015->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_313143 = {.desc ="mem_313143", .mem =
                                  futhark_mc_task_339015->free_mem_313143,
                                  .size =0, .references =NULL};
    struct memblock mem_313147 = {.desc ="mem_313147", .mem =
                                  futhark_mc_task_339015->free_mem_313147,
                                  .size =0, .references =NULL};
    struct memblock mem_316219 = {.desc ="mem_316219", .mem =
                                  futhark_mc_task_339015->free_mem_316219,
                                  .size =0, .references =NULL};
    struct memblock mem_316222 = {.desc ="mem_316222", .mem =
                                  futhark_mc_task_339015->free_mem_316222,
                                  .size =0, .references =NULL};
    int64_t bytes_316224 = futhark_mc_task_339015->free_bytes_316224;
    struct memblock mem_316297 = {.desc ="mem_316297", .mem =
                                  futhark_mc_task_339015->free_mem_316297,
                                  .size =0, .references =NULL};
    struct memblock mem_316300 = {.desc ="mem_316300", .mem =
                                  futhark_mc_task_339015->free_mem_316300,
                                  .size =0, .references =NULL};
    int64_t iter_335305;
    struct futhark_mc_segmap_parloop_struct_339017
    futhark_mc_segmap_parloop_struct_339017;
    
    futhark_mc_segmap_parloop_struct_339017.ctx = ctx;
    futhark_mc_segmap_parloop_struct_339017.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_339017.free_q_t_292679 = q_t_292679;
    futhark_mc_segmap_parloop_struct_339017.free_jump_t_292685 = jump_t_292685;
    futhark_mc_segmap_parloop_struct_339017.free_t_n_m_292839 = t_n_m_292839;
    futhark_mc_segmap_parloop_struct_339017.free_i_292846 = i_292846;
    futhark_mc_segmap_parloop_struct_339017.free_gtid_309149 = gtid_309149;
    futhark_mc_segmap_parloop_struct_339017.free_x_309154 = x_309154;
    futhark_mc_segmap_parloop_struct_339017.free_mem_312636 = mem_312636.mem;
    futhark_mc_segmap_parloop_struct_339017.free_mem_313143 = mem_313143.mem;
    futhark_mc_segmap_parloop_struct_339017.free_mem_313147 = mem_313147.mem;
    futhark_mc_segmap_parloop_struct_339017.free_mem_316219 = mem_316219.mem;
    futhark_mc_segmap_parloop_struct_339017.free_mem_316222 = mem_316222.mem;
    futhark_mc_segmap_parloop_struct_339017.free_bytes_316224 = bytes_316224;
    futhark_mc_segmap_parloop_struct_339017.free_mem_316297 = mem_316297.mem;
    futhark_mc_segmap_parloop_struct_339017.free_mem_316300 = mem_316300.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_339018_task;
    
    futhark_mc_segmap_parloop_339018_task.name =
        "futhark_mc_segmap_parloop_339018";
    futhark_mc_segmap_parloop_339018_task.fn = futhark_mc_segmap_parloop_339018;
    futhark_mc_segmap_parloop_339018_task.args =
        &futhark_mc_segmap_parloop_struct_339017;
    futhark_mc_segmap_parloop_339018_task.iterations = iterations;
    futhark_mc_segmap_parloop_339018_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_339018_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339018_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_339018_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_339018_task);
    
    if (futhark_mc_segmap_parloop_339018_err != 0) {
        err = futhark_mc_segmap_parloop_339018_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339018_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339018_total_end -
                 futhark_mc_segmap_parloop_339018_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339018_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339018_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339018_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_339016_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_339016_end -
                 futhark_mc_segmap_task_339016_start;
        
        ctx->futhark_mc_segmap_task_339016_runs[tid]++;
        ctx->futhark_mc_segmap_task_339016_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_339016_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_segmap_parloop_struct_339024 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_t_292679;
    int64_t free_jump_t_292685;
    int64_t free_t_n_m_292839;
    int64_t free_i_292846;
    int64_t free_gtid_309149;
    int64_t free_x_309154;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_313143;
    unsigned char *free_mem_313147;
    unsigned char *free_mem_316219;
    unsigned char *free_mem_316222;
    int64_t free_bytes_316224;
    unsigned char *free_mem_316297;
    unsigned char *free_mem_316300;
};
struct futhark_mc_task_339030 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_t_292679;
    int64_t free_gtid_309149;
    int64_t free_x_309154;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_316219;
    int64_t free_x_335042;
    double free_x_335043;
    int64_t free_defunc_0_g_res_335046;
    unsigned char *free_mem_335047;
    unsigned char *free_mem_335048;
};
struct futhark_mc_segmap_parloop_struct_339032 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_t_292679;
    int64_t free_gtid_309149;
    int64_t free_x_309154;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_316219;
    int64_t free_x_335042;
    double free_x_335043;
    int64_t free_defunc_0_g_res_335046;
    unsigned char *free_mem_335047;
    unsigned char *free_mem_335048;
};
static int futhark_mc_segmap_parloop_339033(void *args, int64_t start,
                                            int64_t end, int flat_tid_335388,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_339032
    *futhark_mc_segmap_parloop_struct_339032 =
    (struct futhark_mc_segmap_parloop_struct_339032 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_339032->ctx;
    uint64_t futhark_mc_segmap_parloop_339033_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339033_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_339032->free_n_292675;
    int64_t q_t_292679 =
            futhark_mc_segmap_parloop_struct_339032->free_q_t_292679;
    int64_t gtid_309149 =
            futhark_mc_segmap_parloop_struct_339032->free_gtid_309149;
    int64_t x_309154 = futhark_mc_segmap_parloop_struct_339032->free_x_309154;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_segmap_parloop_struct_339032->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_316219 = {.desc ="mem_316219", .mem =
                                  futhark_mc_segmap_parloop_struct_339032->free_mem_316219,
                                  .size =0, .references =NULL};
    int64_t x_335042 = futhark_mc_segmap_parloop_struct_339032->free_x_335042;
    double x_335043 = futhark_mc_segmap_parloop_struct_339032->free_x_335043;
    int64_t defunc_0_g_res_335046 =
            futhark_mc_segmap_parloop_struct_339032->free_defunc_0_g_res_335046;
    struct memblock mem_335047 = {.desc ="mem_335047", .mem =
                                  futhark_mc_segmap_parloop_struct_339032->free_mem_335047,
                                  .size =0, .references =NULL};
    struct memblock mem_335048 = {.desc ="mem_335048", .mem =
                                  futhark_mc_segmap_parloop_struct_339032->free_mem_335048,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_335461 = start;
    
    for (; iter_335461 < end; iter_335461++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_335467 = q_t_292679;
        int64_t gtid_335389 = iter_335461;
        int64_t remnant_335468 = iter_335461 - gtid_335389;
        bool cond_335390 = sle64(x_309154, gtid_335389);
        int64_t defunc_0_f_res_335391;
        
        if (cond_335390) {
            defunc_0_f_res_335391 = (int64_t) 0;
        } else {
            int64_t i_335462 = add64(x_335042, gtid_335389);
            int64_t defunc_0_add_arg_335463;
            
            defunc_0_add_arg_335463 = ((int64_t *) mem_312636.mem)[gtid_309149 *
                                                                   n_292675 +
                                                                   i_335462];
            
            int64_t defunc_1_add_res_335464 = add64((int64_t) 1,
                                                    defunc_0_add_arg_335463);
            
            defunc_0_f_res_335391 = defunc_1_add_res_335464;
        }
        
        double defunc_0_f_res_335395;
        
        if (cond_335390) {
            defunc_0_f_res_335395 = 0.0;
        } else {
            int64_t i_335465 = add64(x_335042, gtid_335389);
            double defunc_0_add_arg_335466;
            
            defunc_0_add_arg_335466 = ((double *) mem_316219.mem)[i_335465];
            defunc_0_f_res_335395 = defunc_0_add_arg_335466;
        }
        
        int64_t binop_p_335398 = sub64(defunc_0_f_res_335391,
                                       defunc_0_g_res_335046);
        double defunc_0_f_res_335399 = sitofp_i64_f64(binop_p_335398);
        double abs_res_335400 = fabs(defunc_0_f_res_335399);
        double tmp1_335401 = abs_res_335400 / x_335043;
        double x_335402 = tmp1_335401 * tmp1_335401;
        double y_335403 = tmp1_335401 * x_335402;
        double tmp2_335404 = 1.0 - y_335403;
        double x_335405 = tmp2_335404 * tmp2_335404;
        double tmp3_335406 = tmp2_335404 * x_335405;
        double tmp4_335407 = defunc_0_f_res_335395 * tmp3_335406;
        
        ((double *) mem_335047.mem)[gtid_335389] = defunc_0_f_res_335399;
        ((double *) mem_335048.mem)[gtid_335389] = tmp4_335407;
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339033_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339033_end -
                 futhark_mc_segmap_parloop_339033_start;
        
        ctx->futhark_mc_segmap_parloop_339033_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_339033_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_339033_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_339031(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_335388 = tid;
    int num_tasks_335460 = info.nsubtasks;
    struct futhark_mc_task_339030 *futhark_mc_task_339030 =
                                  (struct futhark_mc_task_339030 *) args;
    struct futhark_context *ctx = futhark_mc_task_339030->ctx;
    uint64_t futhark_mc_segmap_task_339031_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_339031_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_339030->free_n_292675;
    int64_t q_t_292679 = futhark_mc_task_339030->free_q_t_292679;
    int64_t gtid_309149 = futhark_mc_task_339030->free_gtid_309149;
    int64_t x_309154 = futhark_mc_task_339030->free_x_309154;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_task_339030->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_316219 = {.desc ="mem_316219", .mem =
                                  futhark_mc_task_339030->free_mem_316219,
                                  .size =0, .references =NULL};
    int64_t x_335042 = futhark_mc_task_339030->free_x_335042;
    double x_335043 = futhark_mc_task_339030->free_x_335043;
    int64_t defunc_0_g_res_335046 =
            futhark_mc_task_339030->free_defunc_0_g_res_335046;
    struct memblock mem_335047 = {.desc ="mem_335047", .mem =
                                  futhark_mc_task_339030->free_mem_335047,
                                  .size =0, .references =NULL};
    struct memblock mem_335048 = {.desc ="mem_335048", .mem =
                                  futhark_mc_task_339030->free_mem_335048,
                                  .size =0, .references =NULL};
    int64_t iter_335461;
    struct futhark_mc_segmap_parloop_struct_339032
    futhark_mc_segmap_parloop_struct_339032;
    
    futhark_mc_segmap_parloop_struct_339032.ctx = ctx;
    futhark_mc_segmap_parloop_struct_339032.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_339032.free_q_t_292679 = q_t_292679;
    futhark_mc_segmap_parloop_struct_339032.free_gtid_309149 = gtid_309149;
    futhark_mc_segmap_parloop_struct_339032.free_x_309154 = x_309154;
    futhark_mc_segmap_parloop_struct_339032.free_mem_312636 = mem_312636.mem;
    futhark_mc_segmap_parloop_struct_339032.free_mem_316219 = mem_316219.mem;
    futhark_mc_segmap_parloop_struct_339032.free_x_335042 = x_335042;
    futhark_mc_segmap_parloop_struct_339032.free_x_335043 = x_335043;
    futhark_mc_segmap_parloop_struct_339032.free_defunc_0_g_res_335046 =
        defunc_0_g_res_335046;
    futhark_mc_segmap_parloop_struct_339032.free_mem_335047 = mem_335047.mem;
    futhark_mc_segmap_parloop_struct_339032.free_mem_335048 = mem_335048.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_339033_task;
    
    futhark_mc_segmap_parloop_339033_task.name =
        "futhark_mc_segmap_parloop_339033";
    futhark_mc_segmap_parloop_339033_task.fn = futhark_mc_segmap_parloop_339033;
    futhark_mc_segmap_parloop_339033_task.args =
        &futhark_mc_segmap_parloop_struct_339032;
    futhark_mc_segmap_parloop_339033_task.iterations = iterations;
    futhark_mc_segmap_parloop_339033_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_339033_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339033_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_339033_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_339033_task);
    
    if (futhark_mc_segmap_parloop_339033_err != 0) {
        err = futhark_mc_segmap_parloop_339033_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339033_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339033_total_end -
                 futhark_mc_segmap_parloop_339033_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339033_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339033_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339033_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_339031_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_339031_end -
                 futhark_mc_segmap_task_339031_start;
        
        ctx->futhark_mc_segmap_task_339031_runs[tid]++;
        ctx->futhark_mc_segmap_task_339031_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_339031_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_task_339034 {
    struct futhark_context *ctx;
    unsigned char *free_mem_335047;
    unsigned char *free_mem_335048;
    double *retval_defunc_2_reduce_res_335073;
    double *retval_defunc_2_reduce_res_335074;
    double *retval_defunc_2_reduce_res_335075;
    double *retval_defunc_2_reduce_res_335076;
    double *retval_defunc_2_reduce_res_335077;
    unsigned char *retval_mem_335071;
    unsigned char *retval_mem_335072;
};
struct futhark_mc_segred_stage_1_parloop_struct_339041 {
    struct futhark_context *ctx;
    unsigned char *free_mem_335047;
    unsigned char *free_mem_335048;
    unsigned char *free_mem_335071;
    unsigned char *free_mem_335072;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_335470;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_335472;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_335474;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_335476;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_335478;
};
static int futhark_mc_segred_stage_1_parloop_339042(void *args, int64_t start,
                                                    int64_t end,
                                                    int flat_tid_335408,
                                                    int tid)
{
    int err = 0;
    struct futhark_mc_segred_stage_1_parloop_struct_339041
    *futhark_mc_segred_stage_1_parloop_struct_339041 =
    (struct futhark_mc_segred_stage_1_parloop_struct_339041 *) args;
    struct futhark_context *ctx =
                           futhark_mc_segred_stage_1_parloop_struct_339041->ctx;
    uint64_t futhark_mc_segred_stage_1_parloop_339042_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_339042_start = get_wall_time();
    
    struct memblock mem_335047 = {.desc ="mem_335047", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_339041->free_mem_335047,
                                  .size =0, .references =NULL};
    struct memblock mem_335048 = {.desc ="mem_335048", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_339041->free_mem_335048,
                                  .size =0, .references =NULL};
    struct memblock mem_335071 = {.desc ="mem_335071", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_339041->free_mem_335071,
                                  .size =0, .references =NULL};
    struct memblock mem_335072 = {.desc ="mem_335072", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_339041->free_mem_335072,
                                  .size =0, .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_335470 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_335470",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_339041->free_reduce_stage_1_tid_res_arr_mem_335470,
                                                             .size =0,
                                                             .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_335472 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_335472",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_339041->free_reduce_stage_1_tid_res_arr_mem_335472,
                                                             .size =0,
                                                             .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_335474 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_335474",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_339041->free_reduce_stage_1_tid_res_arr_mem_335474,
                                                             .size =0,
                                                             .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_335476 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_335476",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_339041->free_reduce_stage_1_tid_res_arr_mem_335476,
                                                             .size =0,
                                                             .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_335478 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_335478",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_339041->free_reduce_stage_1_tid_res_arr_mem_335478,
                                                             .size =0,
                                                             .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_335480 = start;
    double x_335410;
    double x_335411;
    double x_335413;
    double x_335414;
    double x_335416;
    double x_335417;
    double x_335419;
    double x_335420;
    double x_335422;
    double x_335423;
    double local_acc_335481 = 0.0;
    double local_acc_335482 = 0.0;
    double local_acc_335483 = 0.0;
    double local_acc_335484 = 0.0;
    double local_acc_335485 = 0.0;
    
    for (; iter_335480 < end; iter_335480++) {
        int64_t gtid_335409 = iter_335480;
        double x_335425;
        
        x_335425 = ((double *) mem_335047.mem)[gtid_335409];
        
        double x_335426;
        
        x_335426 = ((double *) mem_335048.mem)[gtid_335409];
        
        double defunc_1_f_res_335427 = x_335425 * x_335426;
        double defunc_1_f_res_335428 = x_335425 * defunc_1_f_res_335427;
        double defunc_1_f_res_335429 = x_335425 * defunc_1_f_res_335428;
        double defunc_1_f_res_335430 = x_335425 * defunc_1_f_res_335429;
        
        // save map-out results
        {
            ((double *) mem_335071.mem)[gtid_335409] = defunc_1_f_res_335428;
            ((double *) mem_335072.mem)[gtid_335409] = defunc_1_f_res_335427;
        }
        // Load accum params
        {
            x_335410 = local_acc_335481;
        }
        // Load next params
        {
            x_335411 = x_335426;
        }
        // Red body
        {
            double defunc_1_op_res_335412 = x_335410 + x_335411;
            
            local_acc_335481 = defunc_1_op_res_335412;
        }
        // Load accum params
        {
            x_335413 = local_acc_335482;
        }
        // Load next params
        {
            x_335414 = defunc_1_f_res_335427;
        }
        // Red body
        {
            double defunc_1_op_res_335415 = x_335413 + x_335414;
            
            local_acc_335482 = defunc_1_op_res_335415;
        }
        // Load accum params
        {
            x_335416 = local_acc_335483;
        }
        // Load next params
        {
            x_335417 = defunc_1_f_res_335428;
        }
        // Red body
        {
            double defunc_1_op_res_335418 = x_335416 + x_335417;
            
            local_acc_335483 = defunc_1_op_res_335418;
        }
        // Load accum params
        {
            x_335419 = local_acc_335484;
        }
        // Load next params
        {
            x_335420 = defunc_1_f_res_335429;
        }
        // Red body
        {
            double defunc_1_op_res_335421 = x_335419 + x_335420;
            
            local_acc_335484 = defunc_1_op_res_335421;
        }
        // Load accum params
        {
            x_335422 = local_acc_335485;
        }
        // Load next params
        {
            x_335423 = defunc_1_f_res_335430;
        }
        // Red body
        {
            double defunc_1_op_res_335424 = x_335422 + x_335423;
            
            local_acc_335485 = defunc_1_op_res_335424;
        }
    }
    ((double *) reduce_stage_1_tid_res_arr_mem_335470.mem)[flat_tid_335408] =
        local_acc_335481;
    ((double *) reduce_stage_1_tid_res_arr_mem_335472.mem)[flat_tid_335408] =
        local_acc_335482;
    ((double *) reduce_stage_1_tid_res_arr_mem_335474.mem)[flat_tid_335408] =
        local_acc_335483;
    ((double *) reduce_stage_1_tid_res_arr_mem_335476.mem)[flat_tid_335408] =
        local_acc_335484;
    ((double *) reduce_stage_1_tid_res_arr_mem_335478.mem)[flat_tid_335408] =
        local_acc_335485;
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_339042_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_339042_end -
                 futhark_mc_segred_stage_1_parloop_339042_start;
        
        ctx->futhark_mc_segred_stage_1_parloop_339042_runs[tid]++;
        ctx->futhark_mc_segred_stage_1_parloop_339042_total_runtime[tid] +=
            elapsed;
        ctx->futhark_mc_segred_stage_1_parloop_339042_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segred_task_339035(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_335408 = tid;
    int num_tasks_335469 = info.nsubtasks;
    struct futhark_mc_task_339034 *futhark_mc_task_339034 =
                                  (struct futhark_mc_task_339034 *) args;
    struct futhark_context *ctx = futhark_mc_task_339034->ctx;
    uint64_t futhark_mc_segred_task_339035_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_task_339035_start = get_wall_time();
    
    struct memblock mem_335047 = {.desc ="mem_335047", .mem =
                                  futhark_mc_task_339034->free_mem_335047,
                                  .size =0, .references =NULL};
    struct memblock mem_335048 = {.desc ="mem_335048", .mem =
                                  futhark_mc_task_339034->free_mem_335048,
                                  .size =0, .references =NULL};
    double defunc_2_reduce_res_335073 =
           *futhark_mc_task_339034->retval_defunc_2_reduce_res_335073;
    double defunc_2_reduce_res_335074 =
           *futhark_mc_task_339034->retval_defunc_2_reduce_res_335074;
    double defunc_2_reduce_res_335075 =
           *futhark_mc_task_339034->retval_defunc_2_reduce_res_335075;
    double defunc_2_reduce_res_335076 =
           *futhark_mc_task_339034->retval_defunc_2_reduce_res_335076;
    double defunc_2_reduce_res_335077 =
           *futhark_mc_task_339034->retval_defunc_2_reduce_res_335077;
    struct memblock mem_335071 = {.desc ="mem_335071", .mem =
                                  futhark_mc_task_339034->retval_mem_335071,
                                  .size =0, .references =NULL};
    struct memblock mem_335072 = {.desc ="mem_335072", .mem =
                                  futhark_mc_task_339034->retval_mem_335072,
                                  .size =0, .references =NULL};
    size_t reduce_stage_1_tid_res_arr_mem_335470_cached_sizze_339036 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_335470 = NULL;
    size_t reduce_stage_1_tid_res_arr_mem_335472_cached_sizze_339037 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_335472 = NULL;
    size_t reduce_stage_1_tid_res_arr_mem_335474_cached_sizze_339038 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_335474 = NULL;
    size_t reduce_stage_1_tid_res_arr_mem_335476_cached_sizze_339039 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_335476 = NULL;
    size_t reduce_stage_1_tid_res_arr_mem_335478_cached_sizze_339040 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_335478 = NULL;
    
    if (reduce_stage_1_tid_res_arr_mem_335470_cached_sizze_339036 <
        (size_t) ((int64_t) 8 * num_tasks_335469)) {
        reduce_stage_1_tid_res_arr_mem_335470 =
            realloc(reduce_stage_1_tid_res_arr_mem_335470, (int64_t) 8 *
                    num_tasks_335469);
        reduce_stage_1_tid_res_arr_mem_335470_cached_sizze_339036 =
            (int64_t) 8 * num_tasks_335469;
    }
    if (reduce_stage_1_tid_res_arr_mem_335472_cached_sizze_339037 <
        (size_t) ((int64_t) 8 * num_tasks_335469)) {
        reduce_stage_1_tid_res_arr_mem_335472 =
            realloc(reduce_stage_1_tid_res_arr_mem_335472, (int64_t) 8 *
                    num_tasks_335469);
        reduce_stage_1_tid_res_arr_mem_335472_cached_sizze_339037 =
            (int64_t) 8 * num_tasks_335469;
    }
    if (reduce_stage_1_tid_res_arr_mem_335474_cached_sizze_339038 <
        (size_t) ((int64_t) 8 * num_tasks_335469)) {
        reduce_stage_1_tid_res_arr_mem_335474 =
            realloc(reduce_stage_1_tid_res_arr_mem_335474, (int64_t) 8 *
                    num_tasks_335469);
        reduce_stage_1_tid_res_arr_mem_335474_cached_sizze_339038 =
            (int64_t) 8 * num_tasks_335469;
    }
    if (reduce_stage_1_tid_res_arr_mem_335476_cached_sizze_339039 <
        (size_t) ((int64_t) 8 * num_tasks_335469)) {
        reduce_stage_1_tid_res_arr_mem_335476 =
            realloc(reduce_stage_1_tid_res_arr_mem_335476, (int64_t) 8 *
                    num_tasks_335469);
        reduce_stage_1_tid_res_arr_mem_335476_cached_sizze_339039 =
            (int64_t) 8 * num_tasks_335469;
    }
    if (reduce_stage_1_tid_res_arr_mem_335478_cached_sizze_339040 <
        (size_t) ((int64_t) 8 * num_tasks_335469)) {
        reduce_stage_1_tid_res_arr_mem_335478 =
            realloc(reduce_stage_1_tid_res_arr_mem_335478, (int64_t) 8 *
                    num_tasks_335469);
        reduce_stage_1_tid_res_arr_mem_335478_cached_sizze_339040 =
            (int64_t) 8 * num_tasks_335469;
    }
    
    int64_t iter_335480;
    struct futhark_mc_segred_stage_1_parloop_struct_339041
    futhark_mc_segred_stage_1_parloop_struct_339041;
    
    futhark_mc_segred_stage_1_parloop_struct_339041.ctx = ctx;
    futhark_mc_segred_stage_1_parloop_struct_339041.free_mem_335047 =
        mem_335047.mem;
    futhark_mc_segred_stage_1_parloop_struct_339041.free_mem_335048 =
        mem_335048.mem;
    futhark_mc_segred_stage_1_parloop_struct_339041.free_mem_335071 =
        mem_335071.mem;
    futhark_mc_segred_stage_1_parloop_struct_339041.free_mem_335072 =
        mem_335072.mem;
    futhark_mc_segred_stage_1_parloop_struct_339041.free_reduce_stage_1_tid_res_arr_mem_335470 =
        reduce_stage_1_tid_res_arr_mem_335470;
    futhark_mc_segred_stage_1_parloop_struct_339041.free_reduce_stage_1_tid_res_arr_mem_335472 =
        reduce_stage_1_tid_res_arr_mem_335472;
    futhark_mc_segred_stage_1_parloop_struct_339041.free_reduce_stage_1_tid_res_arr_mem_335474 =
        reduce_stage_1_tid_res_arr_mem_335474;
    futhark_mc_segred_stage_1_parloop_struct_339041.free_reduce_stage_1_tid_res_arr_mem_335476 =
        reduce_stage_1_tid_res_arr_mem_335476;
    futhark_mc_segred_stage_1_parloop_struct_339041.free_reduce_stage_1_tid_res_arr_mem_335478 =
        reduce_stage_1_tid_res_arr_mem_335478;
    
    struct scheduler_parloop futhark_mc_segred_stage_1_parloop_339042_task;
    
    futhark_mc_segred_stage_1_parloop_339042_task.name =
        "futhark_mc_segred_stage_1_parloop_339042";
    futhark_mc_segred_stage_1_parloop_339042_task.fn =
        futhark_mc_segred_stage_1_parloop_339042;
    futhark_mc_segred_stage_1_parloop_339042_task.args =
        &futhark_mc_segred_stage_1_parloop_struct_339041;
    futhark_mc_segred_stage_1_parloop_339042_task.iterations = iterations;
    futhark_mc_segred_stage_1_parloop_339042_task.info = info;
    
    uint64_t futhark_mc_segred_stage_1_parloop_339042_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_339042_total_start = get_wall_time();
    
    int futhark_mc_segred_stage_1_parloop_339042_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segred_stage_1_parloop_339042_task);
    
    if (futhark_mc_segred_stage_1_parloop_339042_err != 0) {
        err = futhark_mc_segred_stage_1_parloop_339042_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_339042_total_end =
                 get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_339042_total_end -
                 futhark_mc_segred_stage_1_parloop_339042_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_339042_total_runs,
                           1, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_339042_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_339042_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    // neutral-initialise the output
    {
        defunc_2_reduce_res_335073 = 0.0;
        defunc_2_reduce_res_335074 = 0.0;
        defunc_2_reduce_res_335075 = 0.0;
        defunc_2_reduce_res_335076 = 0.0;
        defunc_2_reduce_res_335077 = 0.0;
    }
    
    double x_335486;
    double x_335487;
    double x_335489;
    double x_335490;
    double x_335492;
    double x_335493;
    double x_335495;
    double x_335496;
    double x_335498;
    double x_335499;
    
    for (int32_t i_335501 = 0; i_335501 < num_tasks_335469; i_335501++) {
        flat_tid_335408 = i_335501;
        // Apply main thread reduction
        {
            // load acc params
            {
                x_335486 = defunc_2_reduce_res_335073;
            }
            // load next params
            {
                x_335487 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_335470)[flat_tid_335408];
            }
            // red body
            {
                double defunc_1_op_res_335488 = x_335486 + x_335487;
                
                defunc_2_reduce_res_335073 = defunc_1_op_res_335488;
            }
            // load acc params
            {
                x_335489 = defunc_2_reduce_res_335074;
            }
            // load next params
            {
                x_335490 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_335472)[flat_tid_335408];
            }
            // red body
            {
                double defunc_1_op_res_335491 = x_335489 + x_335490;
                
                defunc_2_reduce_res_335074 = defunc_1_op_res_335491;
            }
            // load acc params
            {
                x_335492 = defunc_2_reduce_res_335075;
            }
            // load next params
            {
                x_335493 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_335474)[flat_tid_335408];
            }
            // red body
            {
                double defunc_1_op_res_335494 = x_335492 + x_335493;
                
                defunc_2_reduce_res_335075 = defunc_1_op_res_335494;
            }
            // load acc params
            {
                x_335495 = defunc_2_reduce_res_335076;
            }
            // load next params
            {
                x_335496 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_335476)[flat_tid_335408];
            }
            // red body
            {
                double defunc_1_op_res_335497 = x_335495 + x_335496;
                
                defunc_2_reduce_res_335076 = defunc_1_op_res_335497;
            }
            // load acc params
            {
                x_335498 = defunc_2_reduce_res_335077;
            }
            // load next params
            {
                x_335499 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_335478)[flat_tid_335408];
            }
            // red body
            {
                double defunc_1_op_res_335500 = x_335498 + x_335499;
                
                defunc_2_reduce_res_335077 = defunc_1_op_res_335500;
            }
        }
    }
    
  cleanup:
    {
        free(reduce_stage_1_tid_res_arr_mem_335470);
        free(reduce_stage_1_tid_res_arr_mem_335472);
        free(reduce_stage_1_tid_res_arr_mem_335474);
        free(reduce_stage_1_tid_res_arr_mem_335476);
        free(reduce_stage_1_tid_res_arr_mem_335478);
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_task_339035_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_task_339035_end -
                 futhark_mc_segred_task_339035_start;
        
        ctx->futhark_mc_segred_task_339035_runs[tid]++;
        ctx->futhark_mc_segred_task_339035_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segred_task_339035_iter[tid] += iterations;
    }
    if (err == 0) {
        *futhark_mc_task_339034->retval_defunc_2_reduce_res_335073 =
            defunc_2_reduce_res_335073;
        *futhark_mc_task_339034->retval_defunc_2_reduce_res_335074 =
            defunc_2_reduce_res_335074;
        *futhark_mc_task_339034->retval_defunc_2_reduce_res_335075 =
            defunc_2_reduce_res_335075;
        *futhark_mc_task_339034->retval_defunc_2_reduce_res_335076 =
            defunc_2_reduce_res_335076;
        *futhark_mc_task_339034->retval_defunc_2_reduce_res_335077 =
            defunc_2_reduce_res_335077;
        futhark_mc_task_339034->retval_mem_335071 = mem_335071.mem;
        futhark_mc_task_339034->retval_mem_335072 = mem_335072.mem;
    }
    return err;
}
struct futhark_mc_task_339043 {
    struct futhark_context *ctx;
    int64_t free_x_309154;
    unsigned char *free_mem_316222;
    int64_t free_x_335042;
    unsigned char *free_mem_335048;
    unsigned char *free_mem_335071;
    unsigned char *free_mem_335072;
    double free_a12_335128;
    double free_b12_335129;
    double free_c12_335130;
    double free_b2_335131;
    double free_c2_335132;
    double *retval_defunc_2_reduce_res_335133;
    double *retval_defunc_2_reduce_res_335134;
};
struct futhark_mc_segred_stage_1_parloop_struct_339047 {
    struct futhark_context *ctx;
    int64_t free_x_309154;
    unsigned char *free_mem_316222;
    int64_t free_x_335042;
    unsigned char *free_mem_335048;
    unsigned char *free_mem_335071;
    unsigned char *free_mem_335072;
    double free_a12_335128;
    double free_b12_335129;
    double free_c12_335130;
    double free_b2_335131;
    double free_c2_335132;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_335503;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_335505;
};
static int futhark_mc_segred_stage_1_parloop_339048(void *args, int64_t start,
                                                    int64_t end,
                                                    int flat_tid_335431,
                                                    int tid)
{
    int err = 0;
    struct futhark_mc_segred_stage_1_parloop_struct_339047
    *futhark_mc_segred_stage_1_parloop_struct_339047 =
    (struct futhark_mc_segred_stage_1_parloop_struct_339047 *) args;
    struct futhark_context *ctx =
                           futhark_mc_segred_stage_1_parloop_struct_339047->ctx;
    uint64_t futhark_mc_segred_stage_1_parloop_339048_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_339048_start = get_wall_time();
    
    int64_t x_309154 =
            futhark_mc_segred_stage_1_parloop_struct_339047->free_x_309154;
    struct memblock mem_316222 = {.desc ="mem_316222", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_339047->free_mem_316222,
                                  .size =0, .references =NULL};
    int64_t x_335042 =
            futhark_mc_segred_stage_1_parloop_struct_339047->free_x_335042;
    struct memblock mem_335048 = {.desc ="mem_335048", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_339047->free_mem_335048,
                                  .size =0, .references =NULL};
    struct memblock mem_335071 = {.desc ="mem_335071", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_339047->free_mem_335071,
                                  .size =0, .references =NULL};
    struct memblock mem_335072 = {.desc ="mem_335072", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_339047->free_mem_335072,
                                  .size =0, .references =NULL};
    double a12_335128 =
           futhark_mc_segred_stage_1_parloop_struct_339047->free_a12_335128;
    double b12_335129 =
           futhark_mc_segred_stage_1_parloop_struct_339047->free_b12_335129;
    double c12_335130 =
           futhark_mc_segred_stage_1_parloop_struct_339047->free_c12_335130;
    double b2_335131 =
           futhark_mc_segred_stage_1_parloop_struct_339047->free_b2_335131;
    double c2_335132 =
           futhark_mc_segred_stage_1_parloop_struct_339047->free_c2_335132;
    struct memblock reduce_stage_1_tid_res_arr_mem_335503 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_335503",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_339047->free_reduce_stage_1_tid_res_arr_mem_335503,
                                                             .size =0,
                                                             .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_335505 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_335505",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_339047->free_reduce_stage_1_tid_res_arr_mem_335505,
                                                             .size =0,
                                                             .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_335507 = start;
    double x_335433;
    double x_335434;
    double x_335436;
    double x_335437;
    double local_acc_335508 = 0.0;
    double local_acc_335509 = 0.0;
    
    for (; iter_335507 < end; iter_335507++) {
        int64_t gtid_335432 = iter_335507;
        double x_335439;
        
        x_335439 = ((double *) mem_335048.mem)[gtid_335432];
        
        double x_335440;
        
        x_335440 = ((double *) mem_335072.mem)[gtid_335432];
        
        double x_335441;
        
        x_335441 = ((double *) mem_335071.mem)[gtid_335432];
        
        bool cond_335442 = sle64(x_309154, gtid_335432);
        double defunc_0_f_res_335443;
        
        if (cond_335442) {
            defunc_0_f_res_335443 = 0.0;
        } else {
            int64_t i_335444 = add64(x_335042, gtid_335432);
            double defunc_0_add_arg_335445;
            
            defunc_0_add_arg_335445 = ((double *) mem_316222.mem)[i_335444];
            defunc_0_f_res_335443 = defunc_0_add_arg_335445;
        }
        
        double x_335446 = a12_335128 * x_335439;
        double y_335447 = b12_335129 * x_335440;
        double x_335448 = x_335446 + y_335447;
        double y_335449 = c12_335130 * x_335441;
        double x_335450 = x_335448 + y_335449;
        double defunc_9_fit_fun_res_335451 = defunc_0_f_res_335443 * x_335450;
        double x_335452 = b12_335129 * x_335439;
        double y_335453 = b2_335131 * x_335440;
        double x_335454 = x_335452 + y_335453;
        double y_335455 = c2_335132 * x_335441;
        double x_335456 = x_335454 + y_335455;
        double defunc_9_slope_fun_res_335457 = defunc_0_f_res_335443 * x_335456;
        
        // save map-out results
        { }
        // Load accum params
        {
            x_335433 = local_acc_335508;
        }
        // Load next params
        {
            x_335434 = defunc_9_fit_fun_res_335451;
        }
        // Red body
        {
            double defunc_1_op_res_335435 = x_335433 + x_335434;
            
            local_acc_335508 = defunc_1_op_res_335435;
        }
        // Load accum params
        {
            x_335436 = local_acc_335509;
        }
        // Load next params
        {
            x_335437 = defunc_9_slope_fun_res_335457;
        }
        // Red body
        {
            double defunc_1_op_res_335438 = x_335436 + x_335437;
            
            local_acc_335509 = defunc_1_op_res_335438;
        }
    }
    ((double *) reduce_stage_1_tid_res_arr_mem_335503.mem)[flat_tid_335431] =
        local_acc_335508;
    ((double *) reduce_stage_1_tid_res_arr_mem_335505.mem)[flat_tid_335431] =
        local_acc_335509;
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_339048_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_339048_end -
                 futhark_mc_segred_stage_1_parloop_339048_start;
        
        ctx->futhark_mc_segred_stage_1_parloop_339048_runs[tid]++;
        ctx->futhark_mc_segred_stage_1_parloop_339048_total_runtime[tid] +=
            elapsed;
        ctx->futhark_mc_segred_stage_1_parloop_339048_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segred_task_339044(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_335431 = tid;
    int num_tasks_335502 = info.nsubtasks;
    struct futhark_mc_task_339043 *futhark_mc_task_339043 =
                                  (struct futhark_mc_task_339043 *) args;
    struct futhark_context *ctx = futhark_mc_task_339043->ctx;
    uint64_t futhark_mc_segred_task_339044_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_task_339044_start = get_wall_time();
    
    int64_t x_309154 = futhark_mc_task_339043->free_x_309154;
    struct memblock mem_316222 = {.desc ="mem_316222", .mem =
                                  futhark_mc_task_339043->free_mem_316222,
                                  .size =0, .references =NULL};
    int64_t x_335042 = futhark_mc_task_339043->free_x_335042;
    struct memblock mem_335048 = {.desc ="mem_335048", .mem =
                                  futhark_mc_task_339043->free_mem_335048,
                                  .size =0, .references =NULL};
    struct memblock mem_335071 = {.desc ="mem_335071", .mem =
                                  futhark_mc_task_339043->free_mem_335071,
                                  .size =0, .references =NULL};
    struct memblock mem_335072 = {.desc ="mem_335072", .mem =
                                  futhark_mc_task_339043->free_mem_335072,
                                  .size =0, .references =NULL};
    double a12_335128 = futhark_mc_task_339043->free_a12_335128;
    double b12_335129 = futhark_mc_task_339043->free_b12_335129;
    double c12_335130 = futhark_mc_task_339043->free_c12_335130;
    double b2_335131 = futhark_mc_task_339043->free_b2_335131;
    double c2_335132 = futhark_mc_task_339043->free_c2_335132;
    double defunc_2_reduce_res_335133 =
           *futhark_mc_task_339043->retval_defunc_2_reduce_res_335133;
    double defunc_2_reduce_res_335134 =
           *futhark_mc_task_339043->retval_defunc_2_reduce_res_335134;
    size_t reduce_stage_1_tid_res_arr_mem_335503_cached_sizze_339045 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_335503 = NULL;
    size_t reduce_stage_1_tid_res_arr_mem_335505_cached_sizze_339046 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_335505 = NULL;
    
    if (reduce_stage_1_tid_res_arr_mem_335503_cached_sizze_339045 <
        (size_t) ((int64_t) 8 * num_tasks_335502)) {
        reduce_stage_1_tid_res_arr_mem_335503 =
            realloc(reduce_stage_1_tid_res_arr_mem_335503, (int64_t) 8 *
                    num_tasks_335502);
        reduce_stage_1_tid_res_arr_mem_335503_cached_sizze_339045 =
            (int64_t) 8 * num_tasks_335502;
    }
    if (reduce_stage_1_tid_res_arr_mem_335505_cached_sizze_339046 <
        (size_t) ((int64_t) 8 * num_tasks_335502)) {
        reduce_stage_1_tid_res_arr_mem_335505 =
            realloc(reduce_stage_1_tid_res_arr_mem_335505, (int64_t) 8 *
                    num_tasks_335502);
        reduce_stage_1_tid_res_arr_mem_335505_cached_sizze_339046 =
            (int64_t) 8 * num_tasks_335502;
    }
    
    int64_t iter_335507;
    struct futhark_mc_segred_stage_1_parloop_struct_339047
    futhark_mc_segred_stage_1_parloop_struct_339047;
    
    futhark_mc_segred_stage_1_parloop_struct_339047.ctx = ctx;
    futhark_mc_segred_stage_1_parloop_struct_339047.free_x_309154 = x_309154;
    futhark_mc_segred_stage_1_parloop_struct_339047.free_mem_316222 =
        mem_316222.mem;
    futhark_mc_segred_stage_1_parloop_struct_339047.free_x_335042 = x_335042;
    futhark_mc_segred_stage_1_parloop_struct_339047.free_mem_335048 =
        mem_335048.mem;
    futhark_mc_segred_stage_1_parloop_struct_339047.free_mem_335071 =
        mem_335071.mem;
    futhark_mc_segred_stage_1_parloop_struct_339047.free_mem_335072 =
        mem_335072.mem;
    futhark_mc_segred_stage_1_parloop_struct_339047.free_a12_335128 =
        a12_335128;
    futhark_mc_segred_stage_1_parloop_struct_339047.free_b12_335129 =
        b12_335129;
    futhark_mc_segred_stage_1_parloop_struct_339047.free_c12_335130 =
        c12_335130;
    futhark_mc_segred_stage_1_parloop_struct_339047.free_b2_335131 = b2_335131;
    futhark_mc_segred_stage_1_parloop_struct_339047.free_c2_335132 = c2_335132;
    futhark_mc_segred_stage_1_parloop_struct_339047.free_reduce_stage_1_tid_res_arr_mem_335503 =
        reduce_stage_1_tid_res_arr_mem_335503;
    futhark_mc_segred_stage_1_parloop_struct_339047.free_reduce_stage_1_tid_res_arr_mem_335505 =
        reduce_stage_1_tid_res_arr_mem_335505;
    
    struct scheduler_parloop futhark_mc_segred_stage_1_parloop_339048_task;
    
    futhark_mc_segred_stage_1_parloop_339048_task.name =
        "futhark_mc_segred_stage_1_parloop_339048";
    futhark_mc_segred_stage_1_parloop_339048_task.fn =
        futhark_mc_segred_stage_1_parloop_339048;
    futhark_mc_segred_stage_1_parloop_339048_task.args =
        &futhark_mc_segred_stage_1_parloop_struct_339047;
    futhark_mc_segred_stage_1_parloop_339048_task.iterations = iterations;
    futhark_mc_segred_stage_1_parloop_339048_task.info = info;
    
    uint64_t futhark_mc_segred_stage_1_parloop_339048_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_339048_total_start = get_wall_time();
    
    int futhark_mc_segred_stage_1_parloop_339048_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segred_stage_1_parloop_339048_task);
    
    if (futhark_mc_segred_stage_1_parloop_339048_err != 0) {
        err = futhark_mc_segred_stage_1_parloop_339048_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_339048_total_end =
                 get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_339048_total_end -
                 futhark_mc_segred_stage_1_parloop_339048_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_339048_total_runs,
                           1, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_339048_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_339048_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    // neutral-initialise the output
    {
        defunc_2_reduce_res_335133 = 0.0;
        defunc_2_reduce_res_335134 = 0.0;
    }
    
    double x_335510;
    double x_335511;
    double x_335513;
    double x_335514;
    
    for (int32_t i_335516 = 0; i_335516 < num_tasks_335502; i_335516++) {
        flat_tid_335431 = i_335516;
        // Apply main thread reduction
        {
            // load acc params
            {
                x_335510 = defunc_2_reduce_res_335133;
            }
            // load next params
            {
                x_335511 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_335503)[flat_tid_335431];
            }
            // red body
            {
                double defunc_1_op_res_335512 = x_335510 + x_335511;
                
                defunc_2_reduce_res_335133 = defunc_1_op_res_335512;
            }
            // load acc params
            {
                x_335513 = defunc_2_reduce_res_335134;
            }
            // load next params
            {
                x_335514 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_335505)[flat_tid_335431];
            }
            // red body
            {
                double defunc_1_op_res_335515 = x_335513 + x_335514;
                
                defunc_2_reduce_res_335134 = defunc_1_op_res_335515;
            }
        }
    }
    
  cleanup:
    {
        free(reduce_stage_1_tid_res_arr_mem_335503);
        free(reduce_stage_1_tid_res_arr_mem_335505);
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_task_339044_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_task_339044_end -
                 futhark_mc_segred_task_339044_start;
        
        ctx->futhark_mc_segred_task_339044_runs[tid]++;
        ctx->futhark_mc_segred_task_339044_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segred_task_339044_iter[tid] += iterations;
    }
    if (err == 0) {
        *futhark_mc_task_339043->retval_defunc_2_reduce_res_335133 =
            defunc_2_reduce_res_335133;
        *futhark_mc_task_339043->retval_defunc_2_reduce_res_335134 =
            defunc_2_reduce_res_335134;
    }
    return err;
}
static int futhark_mc_segmap_parloop_339025(void *args, int64_t start,
                                            int64_t end, int flat_tid_335040,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_339024
    *futhark_mc_segmap_parloop_struct_339024 =
    (struct futhark_mc_segmap_parloop_struct_339024 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_339024->ctx;
    uint64_t futhark_mc_segmap_parloop_339025_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339025_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_339024->free_n_292675;
    int64_t q_t_292679 =
            futhark_mc_segmap_parloop_struct_339024->free_q_t_292679;
    int64_t jump_t_292685 =
            futhark_mc_segmap_parloop_struct_339024->free_jump_t_292685;
    int64_t t_n_m_292839 =
            futhark_mc_segmap_parloop_struct_339024->free_t_n_m_292839;
    int64_t i_292846 = futhark_mc_segmap_parloop_struct_339024->free_i_292846;
    int64_t gtid_309149 =
            futhark_mc_segmap_parloop_struct_339024->free_gtid_309149;
    int64_t x_309154 = futhark_mc_segmap_parloop_struct_339024->free_x_309154;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_segmap_parloop_struct_339024->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_313143 = {.desc ="mem_313143", .mem =
                                  futhark_mc_segmap_parloop_struct_339024->free_mem_313143,
                                  .size =0, .references =NULL};
    struct memblock mem_313147 = {.desc ="mem_313147", .mem =
                                  futhark_mc_segmap_parloop_struct_339024->free_mem_313147,
                                  .size =0, .references =NULL};
    struct memblock mem_316219 = {.desc ="mem_316219", .mem =
                                  futhark_mc_segmap_parloop_struct_339024->free_mem_316219,
                                  .size =0, .references =NULL};
    struct memblock mem_316222 = {.desc ="mem_316222", .mem =
                                  futhark_mc_segmap_parloop_struct_339024->free_mem_316222,
                                  .size =0, .references =NULL};
    int64_t bytes_316224 =
            futhark_mc_segmap_parloop_struct_339024->free_bytes_316224;
    struct memblock mem_316297 = {.desc ="mem_316297", .mem =
                                  futhark_mc_segmap_parloop_struct_339024->free_mem_316297,
                                  .size =0, .references =NULL};
    struct memblock mem_316300 = {.desc ="mem_316300", .mem =
                                  futhark_mc_segmap_parloop_struct_339024->free_mem_316300,
                                  .size =0, .references =NULL};
    size_t mem_335047_cached_sizze_339026 = 0;
    unsigned char *mem_335047 = NULL;
    size_t mem_335048_cached_sizze_339027 = 0;
    unsigned char *mem_335048 = NULL;
    size_t mem_335071_cached_sizze_339028 = 0;
    unsigned char *mem_335071 = NULL;
    size_t mem_335072_cached_sizze_339029 = 0;
    unsigned char *mem_335072 = NULL;
    int64_t iterations = end - start;
    int64_t iter_335387 = start;
    
    if (mem_335047_cached_sizze_339026 < (size_t) bytes_316224) {
        mem_335047 = realloc(mem_335047, bytes_316224);
        mem_335047_cached_sizze_339026 = bytes_316224;
    }
    if (mem_335048_cached_sizze_339027 < (size_t) bytes_316224) {
        mem_335048 = realloc(mem_335048, bytes_316224);
        mem_335048_cached_sizze_339027 = bytes_316224;
    }
    if (mem_335071_cached_sizze_339028 < (size_t) bytes_316224) {
        mem_335071 = realloc(mem_335071, bytes_316224);
        mem_335071_cached_sizze_339028 = bytes_316224;
    }
    if (mem_335072_cached_sizze_339029 < (size_t) bytes_316224) {
        mem_335072 = realloc(mem_335072, bytes_316224);
        mem_335072_cached_sizze_339029 = bytes_316224;
    }
    for (; iter_335387 < end; iter_335387++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_335458 = t_n_m_292839;
        int64_t gtid_335041 = iter_335387;
        int64_t remnant_335459 = iter_335387 - gtid_335041;
        int64_t x_335042;
        
        x_335042 = ((int64_t *) mem_313143.mem)[gtid_309149 * t_n_m_292839 +
                                                gtid_335041];
        
        double x_335043;
        
        x_335043 = ((double *) mem_313147.mem)[gtid_309149 * t_n_m_292839 +
                                               gtid_335041];
        
        int64_t min_arg_335044 = mul64(jump_t_292685, gtid_335041);
        int64_t min_res_335045 = smin64(i_292846, min_arg_335044);
        int64_t defunc_0_g_res_335046 = add64((int64_t) 1, min_res_335045);
        int64_t flat_tid_335388 = (int64_t) 0;
        int32_t num_tasks_335460;
        struct futhark_mc_task_339030 futhark_mc_task_339030;
        
        futhark_mc_task_339030.ctx = ctx;
        futhark_mc_task_339030.free_n_292675 = n_292675;
        futhark_mc_task_339030.free_q_t_292679 = q_t_292679;
        futhark_mc_task_339030.free_gtid_309149 = gtid_309149;
        futhark_mc_task_339030.free_x_309154 = x_309154;
        futhark_mc_task_339030.free_mem_312636 = mem_312636.mem;
        futhark_mc_task_339030.free_mem_316219 = mem_316219.mem;
        futhark_mc_task_339030.free_x_335042 = x_335042;
        futhark_mc_task_339030.free_x_335043 = x_335043;
        futhark_mc_task_339030.free_defunc_0_g_res_335046 =
            defunc_0_g_res_335046;
        futhark_mc_task_339030.free_mem_335047 = mem_335047;
        futhark_mc_task_339030.free_mem_335048 = mem_335048;
        
        struct scheduler_segop futhark_mc_task_339030_task;
        
        futhark_mc_task_339030_task.args = &futhark_mc_task_339030;
        futhark_mc_task_339030_task.top_level_fn =
            futhark_mc_segmap_task_339031;
        futhark_mc_task_339030_task.name = "futhark_mc_segmap_task_339031";
        futhark_mc_task_339030_task.iterations = q_t_292679;
        futhark_mc_task_339030_task.task_time =
            &ctx->futhark_mc_segmap_task_339031_total_time;
        futhark_mc_task_339030_task.task_iter =
            &ctx->futhark_mc_segmap_task_339031_total_iter;
        futhark_mc_task_339030_task.sched = STATIC;
        futhark_mc_task_339030_task.nested_fn = NULL;
        
        int futhark_mc_segmap_task_339031_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_339030_task);
        
        if (futhark_mc_segmap_task_339031_err != 0) {
            ;
            err = futhark_mc_segmap_task_339031_err;
            goto cleanup;
        }
        
        double defunc_2_reduce_res_335073;
        double defunc_2_reduce_res_335074;
        double defunc_2_reduce_res_335075;
        double defunc_2_reduce_res_335076;
        double defunc_2_reduce_res_335077;
        int64_t flat_tid_335408 = (int64_t) 0;
        int32_t num_tasks_335469;
        
        defunc_2_reduce_res_335073 = 0.0;
        defunc_2_reduce_res_335074 = 0.0;
        defunc_2_reduce_res_335075 = 0.0;
        defunc_2_reduce_res_335076 = 0.0;
        defunc_2_reduce_res_335077 = 0.0;
        
        struct futhark_mc_task_339034 futhark_mc_task_339034;
        
        futhark_mc_task_339034.ctx = ctx;
        futhark_mc_task_339034.free_mem_335047 = mem_335047;
        futhark_mc_task_339034.free_mem_335048 = mem_335048;
        futhark_mc_task_339034.retval_defunc_2_reduce_res_335073 =
            &defunc_2_reduce_res_335073;
        futhark_mc_task_339034.retval_defunc_2_reduce_res_335074 =
            &defunc_2_reduce_res_335074;
        futhark_mc_task_339034.retval_defunc_2_reduce_res_335075 =
            &defunc_2_reduce_res_335075;
        futhark_mc_task_339034.retval_defunc_2_reduce_res_335076 =
            &defunc_2_reduce_res_335076;
        futhark_mc_task_339034.retval_defunc_2_reduce_res_335077 =
            &defunc_2_reduce_res_335077;
        futhark_mc_task_339034.retval_mem_335071 = mem_335071;
        futhark_mc_task_339034.retval_mem_335072 = mem_335072;
        
        struct scheduler_segop futhark_mc_task_339034_task;
        
        futhark_mc_task_339034_task.args = &futhark_mc_task_339034;
        futhark_mc_task_339034_task.top_level_fn =
            futhark_mc_segred_task_339035;
        futhark_mc_task_339034_task.name = "futhark_mc_segred_task_339035";
        futhark_mc_task_339034_task.iterations = q_t_292679;
        futhark_mc_task_339034_task.task_time =
            &ctx->futhark_mc_segred_task_339035_total_time;
        futhark_mc_task_339034_task.task_iter =
            &ctx->futhark_mc_segred_task_339035_total_iter;
        futhark_mc_task_339034_task.sched = STATIC;
        futhark_mc_task_339034_task.nested_fn = NULL;
        
        int futhark_mc_segred_task_339035_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_339034_task);
        
        if (futhark_mc_segred_task_339035_err != 0) {
            ;
            err = futhark_mc_segred_task_339035_err;
            goto cleanup;
        }
        
        double a_335103 = 2.220446049250313e-16 + defunc_2_reduce_res_335073;
        double b_335104 = 2.220446049250313e-16 + defunc_2_reduce_res_335074;
        double c_335105 = 2.220446049250313e-16 + defunc_2_reduce_res_335075;
        double d_335106 = 2.220446049250313e-16 + defunc_2_reduce_res_335076;
        double e_335107 = 2.220446049250313e-16 + defunc_2_reduce_res_335077;
        double x_335108 = c_335105 * e_335107;
        double y_335109 = d_335106 * d_335106;
        double a12_335110 = x_335108 - y_335109;
        double x_335111 = c_335105 * d_335106;
        double y_335112 = b_335104 * e_335107;
        double b12_335113 = x_335111 - y_335112;
        double x_335114 = b_335104 * d_335106;
        double y_335115 = c_335105 * c_335105;
        double c12_335116 = x_335114 - y_335115;
        double x_335117 = a_335103 * e_335107;
        double b2_335118 = x_335117 - y_335115;
        double x_335119 = b_335104 * c_335105;
        double y_335120 = a_335103 * d_335106;
        double c2_335121 = x_335119 - y_335120;
        double x_335122 = a_335103 * a12_335110;
        double y_335123 = b_335104 * b12_335113;
        double x_335124 = x_335122 + y_335123;
        double y_335125 = c_335105 * c12_335116;
        double y_335126 = x_335124 + y_335125;
        double det_335127 = 1.0 / y_335126;
        double a12_335128 = a12_335110 * det_335127;
        double b12_335129 = b12_335113 * det_335127;
        double c12_335130 = c12_335116 * det_335127;
        double b2_335131 = b2_335118 * det_335127;
        double c2_335132 = c2_335121 * det_335127;
        double defunc_2_reduce_res_335133;
        double defunc_2_reduce_res_335134;
        int64_t flat_tid_335431 = (int64_t) 0;
        int32_t num_tasks_335502;
        
        defunc_2_reduce_res_335133 = 0.0;
        defunc_2_reduce_res_335134 = 0.0;
        
        struct futhark_mc_task_339043 futhark_mc_task_339043;
        
        futhark_mc_task_339043.ctx = ctx;
        futhark_mc_task_339043.free_x_309154 = x_309154;
        futhark_mc_task_339043.free_mem_316222 = mem_316222.mem;
        futhark_mc_task_339043.free_x_335042 = x_335042;
        futhark_mc_task_339043.free_mem_335048 = mem_335048;
        futhark_mc_task_339043.free_mem_335071 = mem_335071;
        futhark_mc_task_339043.free_mem_335072 = mem_335072;
        futhark_mc_task_339043.free_a12_335128 = a12_335128;
        futhark_mc_task_339043.free_b12_335129 = b12_335129;
        futhark_mc_task_339043.free_c12_335130 = c12_335130;
        futhark_mc_task_339043.free_b2_335131 = b2_335131;
        futhark_mc_task_339043.free_c2_335132 = c2_335132;
        futhark_mc_task_339043.retval_defunc_2_reduce_res_335133 =
            &defunc_2_reduce_res_335133;
        futhark_mc_task_339043.retval_defunc_2_reduce_res_335134 =
            &defunc_2_reduce_res_335134;
        
        struct scheduler_segop futhark_mc_task_339043_task;
        
        futhark_mc_task_339043_task.args = &futhark_mc_task_339043;
        futhark_mc_task_339043_task.top_level_fn =
            futhark_mc_segred_task_339044;
        futhark_mc_task_339043_task.name = "futhark_mc_segred_task_339044";
        futhark_mc_task_339043_task.iterations = q_t_292679;
        futhark_mc_task_339043_task.task_time =
            &ctx->futhark_mc_segred_task_339044_total_time;
        futhark_mc_task_339043_task.task_iter =
            &ctx->futhark_mc_segred_task_339044_total_iter;
        futhark_mc_task_339043_task.sched = STATIC;
        futhark_mc_task_339043_task.nested_fn = NULL;
        
        int futhark_mc_segred_task_339044_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_339043_task);
        
        if (futhark_mc_segred_task_339044_err != 0) {
            ;
            err = futhark_mc_segred_task_339044_err;
            goto cleanup;
        }
        ((double *) mem_316297.mem)[gtid_335041] = defunc_2_reduce_res_335133;
        ((double *) mem_316300.mem)[gtid_335041] = defunc_2_reduce_res_335134;
    }
    
  cleanup:
    { }
    free(mem_335047);
    free(mem_335048);
    free(mem_335071);
    free(mem_335072);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339025_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339025_end -
                 futhark_mc_segmap_parloop_339025_start;
        
        ctx->futhark_mc_segmap_parloop_339025_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_339025_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_339025_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_nested_task_339023(void *args, int64_t iterations,
                                         int tid, struct scheduler_info info)
{
    int err = 0;
    int flat_tid_335040 = tid;
    int num_tasks_335304 = info.nsubtasks;
    struct futhark_mc_task_339015 *futhark_mc_task_339015 =
                                  (struct futhark_mc_task_339015 *) args;
    struct futhark_context *ctx = futhark_mc_task_339015->ctx;
    uint64_t futhark_mc_segmap_nested_task_339023_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_nested_task_339023_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_339015->free_n_292675;
    int64_t q_t_292679 = futhark_mc_task_339015->free_q_t_292679;
    int64_t jump_t_292685 = futhark_mc_task_339015->free_jump_t_292685;
    int64_t t_n_m_292839 = futhark_mc_task_339015->free_t_n_m_292839;
    int64_t i_292846 = futhark_mc_task_339015->free_i_292846;
    int64_t gtid_309149 = futhark_mc_task_339015->free_gtid_309149;
    int64_t x_309154 = futhark_mc_task_339015->free_x_309154;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_task_339015->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_313143 = {.desc ="mem_313143", .mem =
                                  futhark_mc_task_339015->free_mem_313143,
                                  .size =0, .references =NULL};
    struct memblock mem_313147 = {.desc ="mem_313147", .mem =
                                  futhark_mc_task_339015->free_mem_313147,
                                  .size =0, .references =NULL};
    struct memblock mem_316219 = {.desc ="mem_316219", .mem =
                                  futhark_mc_task_339015->free_mem_316219,
                                  .size =0, .references =NULL};
    struct memblock mem_316222 = {.desc ="mem_316222", .mem =
                                  futhark_mc_task_339015->free_mem_316222,
                                  .size =0, .references =NULL};
    int64_t bytes_316224 = futhark_mc_task_339015->free_bytes_316224;
    struct memblock mem_316297 = {.desc ="mem_316297", .mem =
                                  futhark_mc_task_339015->free_mem_316297,
                                  .size =0, .references =NULL};
    struct memblock mem_316300 = {.desc ="mem_316300", .mem =
                                  futhark_mc_task_339015->free_mem_316300,
                                  .size =0, .references =NULL};
    int64_t iter_335387;
    struct futhark_mc_segmap_parloop_struct_339024
    futhark_mc_segmap_parloop_struct_339024;
    
    futhark_mc_segmap_parloop_struct_339024.ctx = ctx;
    futhark_mc_segmap_parloop_struct_339024.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_339024.free_q_t_292679 = q_t_292679;
    futhark_mc_segmap_parloop_struct_339024.free_jump_t_292685 = jump_t_292685;
    futhark_mc_segmap_parloop_struct_339024.free_t_n_m_292839 = t_n_m_292839;
    futhark_mc_segmap_parloop_struct_339024.free_i_292846 = i_292846;
    futhark_mc_segmap_parloop_struct_339024.free_gtid_309149 = gtid_309149;
    futhark_mc_segmap_parloop_struct_339024.free_x_309154 = x_309154;
    futhark_mc_segmap_parloop_struct_339024.free_mem_312636 = mem_312636.mem;
    futhark_mc_segmap_parloop_struct_339024.free_mem_313143 = mem_313143.mem;
    futhark_mc_segmap_parloop_struct_339024.free_mem_313147 = mem_313147.mem;
    futhark_mc_segmap_parloop_struct_339024.free_mem_316219 = mem_316219.mem;
    futhark_mc_segmap_parloop_struct_339024.free_mem_316222 = mem_316222.mem;
    futhark_mc_segmap_parloop_struct_339024.free_bytes_316224 = bytes_316224;
    futhark_mc_segmap_parloop_struct_339024.free_mem_316297 = mem_316297.mem;
    futhark_mc_segmap_parloop_struct_339024.free_mem_316300 = mem_316300.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_339025_task;
    
    futhark_mc_segmap_parloop_339025_task.name =
        "futhark_mc_segmap_parloop_339025";
    futhark_mc_segmap_parloop_339025_task.fn = futhark_mc_segmap_parloop_339025;
    futhark_mc_segmap_parloop_339025_task.args =
        &futhark_mc_segmap_parloop_struct_339024;
    futhark_mc_segmap_parloop_339025_task.iterations = iterations;
    futhark_mc_segmap_parloop_339025_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_339025_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339025_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_339025_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_339025_task);
    
    if (futhark_mc_segmap_parloop_339025_err != 0) {
        err = futhark_mc_segmap_parloop_339025_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339025_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339025_total_end -
                 futhark_mc_segmap_parloop_339025_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339025_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339025_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339025_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_nested_task_339023_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_nested_task_339023_end -
                 futhark_mc_segmap_nested_task_339023_start;
        
        ctx->futhark_mc_segmap_nested_task_339023_runs[tid]++;
        ctx->futhark_mc_segmap_nested_task_339023_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_nested_task_339023_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
static int futhark_mc_segmap_parloop_339001(void *args, int64_t start,
                                            int64_t end, int flat_tid_309148,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_339000
    *futhark_mc_segmap_parloop_struct_339000 =
    (struct futhark_mc_segmap_parloop_struct_339000 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_339000->ctx;
    uint64_t futhark_mc_segmap_parloop_339001_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339001_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_339000->free_n_292675;
    int64_t q_t_292679 =
            futhark_mc_segmap_parloop_struct_339000->free_q_t_292679;
    int64_t jump_t_292685 =
            futhark_mc_segmap_parloop_struct_339000->free_jump_t_292685;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_339000->free_partition_sizze_292766;
    int64_t t_n_m_292839 =
            futhark_mc_segmap_parloop_struct_339000->free_t_n_m_292839;
    int64_t i_292846 = futhark_mc_segmap_parloop_struct_339000->free_i_292846;
    struct memblock mem_312593 = {.desc ="mem_312593", .mem =
                                  futhark_mc_segmap_parloop_struct_339000->free_mem_312593,
                                  .size =0, .references =NULL};
    int64_t bytes_312598 =
            futhark_mc_segmap_parloop_struct_339000->free_bytes_312598;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_segmap_parloop_struct_339000->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_312639 = {.desc ="mem_312639", .mem =
                                  futhark_mc_segmap_parloop_struct_339000->free_mem_312639,
                                  .size =0, .references =NULL};
    int64_t bytes_313090 =
            futhark_mc_segmap_parloop_struct_339000->free_bytes_313090;
    struct memblock mem_313143 = {.desc ="mem_313143", .mem =
                                  futhark_mc_segmap_parloop_struct_339000->free_mem_313143,
                                  .size =0, .references =NULL};
    struct memblock mem_313147 = {.desc ="mem_313147", .mem =
                                  futhark_mc_segmap_parloop_struct_339000->free_mem_313147,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_segmap_parloop_struct_339000->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_segmap_parloop_struct_339000->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_segmap_parloop_struct_339000->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_segmap_parloop_struct_339000->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315656 = {.desc ="mem_315656", .mem =
                                  futhark_mc_segmap_parloop_struct_339000->free_mem_315656,
                                  .size =0, .references =NULL};
    int64_t bytes_316224 =
            futhark_mc_segmap_parloop_struct_339000->free_bytes_316224;
    struct memblock mem_316439 = {.desc ="mem_316439", .mem =
                                  futhark_mc_segmap_parloop_struct_339000->free_mem_316439,
                                  .size =0, .references =NULL};
    struct memblock mem_316443 = {.desc ="mem_316443", .mem =
                                  futhark_mc_segmap_parloop_struct_339000->free_mem_316443,
                                  .size =0, .references =NULL};
    size_t mem_316216_cached_sizze_339002 = 0;
    unsigned char *mem_316216 = NULL;
    size_t mem_316219_cached_sizze_339003 = 0;
    unsigned char *mem_316219 = NULL;
    size_t mem_316222_cached_sizze_339004 = 0;
    unsigned char *mem_316222 = NULL;
    size_t mem_316297_cached_sizze_339005 = 0;
    unsigned char *mem_316297 = NULL;
    size_t mem_316300_cached_sizze_339006 = 0;
    unsigned char *mem_316300 = NULL;
    int64_t iterations = end - start;
    int64_t iter_335019 = start;
    
    if (mem_316216_cached_sizze_339002 < (size_t) bytes_312598) {
        mem_316216 = realloc(mem_316216, bytes_312598);
        mem_316216_cached_sizze_339002 = bytes_312598;
    }
    if (mem_316219_cached_sizze_339003 < (size_t) bytes_312598) {
        mem_316219 = realloc(mem_316219, bytes_312598);
        mem_316219_cached_sizze_339003 = bytes_312598;
    }
    if (mem_316222_cached_sizze_339004 < (size_t) bytes_312598) {
        mem_316222 = realloc(mem_316222, bytes_312598);
        mem_316222_cached_sizze_339004 = bytes_312598;
    }
    if (mem_316297_cached_sizze_339005 < (size_t) bytes_313090) {
        mem_316297 = realloc(mem_316297, bytes_313090);
        mem_316297_cached_sizze_339005 = bytes_313090;
    }
    if (mem_316300_cached_sizze_339006 < (size_t) bytes_313090) {
        mem_316300 = realloc(mem_316300, bytes_313090);
        mem_316300_cached_sizze_339006 = bytes_313090;
    }
    for (; iter_335019 < end; iter_335019++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_335286 = partition_sizze_292766;
        int64_t gtid_309149 = iter_335019;
        int64_t remnant_335287 = iter_335019 - gtid_309149;
        int64_t x_309154;
        
        x_309154 = ((int64_t *) mem_312639.mem)[gtid_309149];
        
        int64_t flat_tid_335020 = (int64_t) 0;
        int32_t num_tasks_335288;
        struct futhark_mc_task_339007 futhark_mc_task_339007;
        
        futhark_mc_task_339007.ctx = ctx;
        futhark_mc_task_339007.free_n_292675 = n_292675;
        futhark_mc_task_339007.free_gtid_309149 = gtid_309149;
        futhark_mc_task_339007.free_mem_312593 = mem_312593.mem;
        futhark_mc_task_339007.free_mem_315656 = mem_315656.mem;
        futhark_mc_task_339007.free_mem_316216 = mem_316216;
        
        struct scheduler_segop futhark_mc_task_339007_task;
        
        futhark_mc_task_339007_task.args = &futhark_mc_task_339007;
        futhark_mc_task_339007_task.top_level_fn =
            futhark_mc_segmap_task_339008;
        futhark_mc_task_339007_task.name = "futhark_mc_segmap_task_339008";
        futhark_mc_task_339007_task.iterations = n_292675;
        futhark_mc_task_339007_task.task_time =
            &ctx->futhark_mc_segmap_task_339008_total_time;
        futhark_mc_task_339007_task.task_iter =
            &ctx->futhark_mc_segmap_task_339008_total_iter;
        futhark_mc_task_339007_task.sched = STATIC;
        futhark_mc_task_339007_task.nested_fn = NULL;
        
        int futhark_mc_segmap_task_339008_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_339007_task);
        
        if (futhark_mc_segmap_task_339008_err != 0) {
            ;
            err = futhark_mc_segmap_task_339008_err;
            goto cleanup;
        }
        
        int64_t flat_tid_335026 = (int64_t) 0;
        int32_t num_tasks_335292;
        struct futhark_mc_task_339011 futhark_mc_task_339011;
        
        futhark_mc_task_339011.ctx = ctx;
        futhark_mc_task_339011.free_n_292675 = n_292675;
        futhark_mc_task_339011.free_gtid_309149 = gtid_309149;
        futhark_mc_task_339011.free_mem_312636 = mem_312636.mem;
        futhark_mc_task_339011.free_ctx_param_ext_313174 = ctx_param_ext_313174;
        futhark_mc_task_339011.free_ctx_param_ext_313175 = ctx_param_ext_313175;
        futhark_mc_task_339011.free_ctx_param_ext_313177 = ctx_param_ext_313177;
        futhark_mc_task_339011.free_mem_param_313179 = mem_param_313179.mem;
        futhark_mc_task_339011.free_mem_316216 = mem_316216;
        futhark_mc_task_339011.free_mem_316219 = mem_316219;
        futhark_mc_task_339011.free_mem_316222 = mem_316222;
        
        struct scheduler_segop futhark_mc_task_339011_task;
        
        futhark_mc_task_339011_task.args = &futhark_mc_task_339011;
        futhark_mc_task_339011_task.top_level_fn =
            futhark_mc_segmap_task_339012;
        futhark_mc_task_339011_task.name = "futhark_mc_segmap_task_339012";
        futhark_mc_task_339011_task.iterations = n_292675;
        futhark_mc_task_339011_task.task_time =
            &ctx->futhark_mc_segmap_task_339012_total_time;
        futhark_mc_task_339011_task.task_iter =
            &ctx->futhark_mc_segmap_task_339012_total_iter;
        futhark_mc_task_339011_task.sched = STATIC;
        futhark_mc_task_339011_task.nested_fn = NULL;
        
        int futhark_mc_segmap_task_339012_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_339011_task);
        
        if (futhark_mc_segmap_task_339012_err != 0) {
            ;
            err = futhark_mc_segmap_task_339012_err;
            goto cleanup;
        }
        
        int64_t flat_tid_335162 = (int64_t) 0;
        int32_t num_tasks_335304;
        int64_t flat_tid_335040 = (int64_t) 0;
        struct futhark_mc_task_339015 futhark_mc_task_339015;
        
        futhark_mc_task_339015.ctx = ctx;
        futhark_mc_task_339015.free_n_292675 = n_292675;
        futhark_mc_task_339015.free_q_t_292679 = q_t_292679;
        futhark_mc_task_339015.free_jump_t_292685 = jump_t_292685;
        futhark_mc_task_339015.free_t_n_m_292839 = t_n_m_292839;
        futhark_mc_task_339015.free_i_292846 = i_292846;
        futhark_mc_task_339015.free_gtid_309149 = gtid_309149;
        futhark_mc_task_339015.free_x_309154 = x_309154;
        futhark_mc_task_339015.free_mem_312636 = mem_312636.mem;
        futhark_mc_task_339015.free_mem_313143 = mem_313143.mem;
        futhark_mc_task_339015.free_mem_313147 = mem_313147.mem;
        futhark_mc_task_339015.free_mem_316219 = mem_316219;
        futhark_mc_task_339015.free_mem_316222 = mem_316222;
        futhark_mc_task_339015.free_bytes_316224 = bytes_316224;
        futhark_mc_task_339015.free_mem_316297 = mem_316297;
        futhark_mc_task_339015.free_mem_316300 = mem_316300;
        
        struct scheduler_segop futhark_mc_task_339015_task;
        
        futhark_mc_task_339015_task.args = &futhark_mc_task_339015;
        futhark_mc_task_339015_task.top_level_fn =
            futhark_mc_segmap_task_339016;
        futhark_mc_task_339015_task.name = "futhark_mc_segmap_task_339016";
        futhark_mc_task_339015_task.iterations = t_n_m_292839;
        futhark_mc_task_339015_task.task_time =
            &ctx->futhark_mc_segmap_task_339016_total_time;
        futhark_mc_task_339015_task.task_iter =
            &ctx->futhark_mc_segmap_task_339016_total_iter;
        futhark_mc_task_339015_task.sched = STATIC;
        futhark_mc_task_339015_task.nested_fn =
            futhark_mc_segmap_nested_task_339023;
        
        int futhark_mc_segmap_task_339016_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_339015_task);
        
        if (futhark_mc_segmap_task_339016_err != 0) {
            ;
            err = futhark_mc_segmap_task_339016_err;
            goto cleanup;
        }
        if (t_n_m_292839 * (int64_t) 8 > 0)
            memmove(mem_316439.mem + gtid_309149 * t_n_m_292839 * (int64_t) 8,
                    mem_316297 + (int64_t) 0, t_n_m_292839 * (int64_t) 8);
        if (t_n_m_292839 * (int64_t) 8 > 0)
            memmove(mem_316443.mem + gtid_309149 * t_n_m_292839 * (int64_t) 8,
                    mem_316300 + (int64_t) 0, t_n_m_292839 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_316216);
    free(mem_316219);
    free(mem_316222);
    free(mem_316297);
    free(mem_316300);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339001_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339001_end -
                 futhark_mc_segmap_parloop_339001_start;
        
        ctx->futhark_mc_segmap_parloop_339001_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_339001_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_339001_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_nested_task_338999(void *args, int64_t iterations,
                                         int tid, struct scheduler_info info)
{
    int err = 0;
    int flat_tid_309148 = tid;
    int num_tasks_334852 = info.nsubtasks;
    struct futhark_mc_task_338986 *futhark_mc_task_338986 =
                                  (struct futhark_mc_task_338986 *) args;
    struct futhark_context *ctx = futhark_mc_task_338986->ctx;
    uint64_t futhark_mc_segmap_nested_task_338999_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_nested_task_338999_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_338986->free_n_292675;
    int64_t q_t_292679 = futhark_mc_task_338986->free_q_t_292679;
    int64_t jump_t_292685 = futhark_mc_task_338986->free_jump_t_292685;
    int64_t partition_sizze_292766 =
            futhark_mc_task_338986->free_partition_sizze_292766;
    int64_t t_n_m_292839 = futhark_mc_task_338986->free_t_n_m_292839;
    int64_t i_292846 = futhark_mc_task_338986->free_i_292846;
    struct memblock mem_312593 = {.desc ="mem_312593", .mem =
                                  futhark_mc_task_338986->free_mem_312593,
                                  .size =0, .references =NULL};
    int64_t bytes_312598 = futhark_mc_task_338986->free_bytes_312598;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_task_338986->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_312639 = {.desc ="mem_312639", .mem =
                                  futhark_mc_task_338986->free_mem_312639,
                                  .size =0, .references =NULL};
    int64_t bytes_313090 = futhark_mc_task_338986->free_bytes_313090;
    struct memblock mem_313143 = {.desc ="mem_313143", .mem =
                                  futhark_mc_task_338986->free_mem_313143,
                                  .size =0, .references =NULL};
    struct memblock mem_313147 = {.desc ="mem_313147", .mem =
                                  futhark_mc_task_338986->free_mem_313147,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_task_338986->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_task_338986->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_task_338986->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_task_338986->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315656 = {.desc ="mem_315656", .mem =
                                  futhark_mc_task_338986->free_mem_315656,
                                  .size =0, .references =NULL};
    int64_t bytes_316224 = futhark_mc_task_338986->free_bytes_316224;
    struct memblock mem_316439 = {.desc ="mem_316439", .mem =
                                  futhark_mc_task_338986->free_mem_316439,
                                  .size =0, .references =NULL};
    struct memblock mem_316443 = {.desc ="mem_316443", .mem =
                                  futhark_mc_task_338986->free_mem_316443,
                                  .size =0, .references =NULL};
    int64_t iter_335019;
    struct futhark_mc_segmap_parloop_struct_339000
    futhark_mc_segmap_parloop_struct_339000;
    
    futhark_mc_segmap_parloop_struct_339000.ctx = ctx;
    futhark_mc_segmap_parloop_struct_339000.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_339000.free_q_t_292679 = q_t_292679;
    futhark_mc_segmap_parloop_struct_339000.free_jump_t_292685 = jump_t_292685;
    futhark_mc_segmap_parloop_struct_339000.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_339000.free_t_n_m_292839 = t_n_m_292839;
    futhark_mc_segmap_parloop_struct_339000.free_i_292846 = i_292846;
    futhark_mc_segmap_parloop_struct_339000.free_mem_312593 = mem_312593.mem;
    futhark_mc_segmap_parloop_struct_339000.free_bytes_312598 = bytes_312598;
    futhark_mc_segmap_parloop_struct_339000.free_mem_312636 = mem_312636.mem;
    futhark_mc_segmap_parloop_struct_339000.free_mem_312639 = mem_312639.mem;
    futhark_mc_segmap_parloop_struct_339000.free_bytes_313090 = bytes_313090;
    futhark_mc_segmap_parloop_struct_339000.free_mem_313143 = mem_313143.mem;
    futhark_mc_segmap_parloop_struct_339000.free_mem_313147 = mem_313147.mem;
    futhark_mc_segmap_parloop_struct_339000.free_ctx_param_ext_313174 =
        ctx_param_ext_313174;
    futhark_mc_segmap_parloop_struct_339000.free_ctx_param_ext_313175 =
        ctx_param_ext_313175;
    futhark_mc_segmap_parloop_struct_339000.free_ctx_param_ext_313177 =
        ctx_param_ext_313177;
    futhark_mc_segmap_parloop_struct_339000.free_mem_param_313179 =
        mem_param_313179.mem;
    futhark_mc_segmap_parloop_struct_339000.free_mem_315656 = mem_315656.mem;
    futhark_mc_segmap_parloop_struct_339000.free_bytes_316224 = bytes_316224;
    futhark_mc_segmap_parloop_struct_339000.free_mem_316439 = mem_316439.mem;
    futhark_mc_segmap_parloop_struct_339000.free_mem_316443 = mem_316443.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_339001_task;
    
    futhark_mc_segmap_parloop_339001_task.name =
        "futhark_mc_segmap_parloop_339001";
    futhark_mc_segmap_parloop_339001_task.fn = futhark_mc_segmap_parloop_339001;
    futhark_mc_segmap_parloop_339001_task.args =
        &futhark_mc_segmap_parloop_struct_339000;
    futhark_mc_segmap_parloop_339001_task.iterations = iterations;
    futhark_mc_segmap_parloop_339001_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_339001_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339001_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_339001_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_339001_task);
    
    if (futhark_mc_segmap_parloop_339001_err != 0) {
        err = futhark_mc_segmap_parloop_339001_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339001_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339001_total_end -
                 futhark_mc_segmap_parloop_339001_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339001_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339001_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339001_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_nested_task_338999_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_nested_task_338999_end -
                 futhark_mc_segmap_nested_task_338999_start;
        
        ctx->futhark_mc_segmap_nested_task_338999_runs[tid]++;
        ctx->futhark_mc_segmap_nested_task_338999_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_nested_task_338999_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_task_339049 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_t_292679;
    int64_t free_jump_t_292685;
    int64_t free_partition_sizze_292766;
    int64_t free_t_n_m_292839;
    int64_t free_i_292846;
    unsigned char *free_mem_312593;
    int64_t free_bytes_312598;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_312639;
    int64_t free_bytes_313090;
    unsigned char *free_mem_313143;
    unsigned char *free_mem_313147;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315656;
    unsigned char *free_mem_316527;
};
struct futhark_mc_segmap_parloop_struct_339051 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_t_292679;
    int64_t free_jump_t_292685;
    int64_t free_partition_sizze_292766;
    int64_t free_t_n_m_292839;
    int64_t free_i_292846;
    unsigned char *free_mem_312593;
    int64_t free_bytes_312598;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_312639;
    int64_t free_bytes_313090;
    unsigned char *free_mem_313143;
    unsigned char *free_mem_313147;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315656;
    unsigned char *free_mem_316527;
};
static int futhark_mc_segmap_parloop_339052(void *args, int64_t start,
                                            int64_t end, int flat_tid_309418,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_339051
    *futhark_mc_segmap_parloop_struct_339051 =
    (struct futhark_mc_segmap_parloop_struct_339051 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_339051->ctx;
    uint64_t futhark_mc_segmap_parloop_339052_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339052_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_339051->free_n_292675;
    int64_t q_t_292679 =
            futhark_mc_segmap_parloop_struct_339051->free_q_t_292679;
    int64_t jump_t_292685 =
            futhark_mc_segmap_parloop_struct_339051->free_jump_t_292685;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_339051->free_partition_sizze_292766;
    int64_t t_n_m_292839 =
            futhark_mc_segmap_parloop_struct_339051->free_t_n_m_292839;
    int64_t i_292846 = futhark_mc_segmap_parloop_struct_339051->free_i_292846;
    struct memblock mem_312593 = {.desc ="mem_312593", .mem =
                                  futhark_mc_segmap_parloop_struct_339051->free_mem_312593,
                                  .size =0, .references =NULL};
    int64_t bytes_312598 =
            futhark_mc_segmap_parloop_struct_339051->free_bytes_312598;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_segmap_parloop_struct_339051->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_312639 = {.desc ="mem_312639", .mem =
                                  futhark_mc_segmap_parloop_struct_339051->free_mem_312639,
                                  .size =0, .references =NULL};
    int64_t bytes_313090 =
            futhark_mc_segmap_parloop_struct_339051->free_bytes_313090;
    struct memblock mem_313143 = {.desc ="mem_313143", .mem =
                                  futhark_mc_segmap_parloop_struct_339051->free_mem_313143,
                                  .size =0, .references =NULL};
    struct memblock mem_313147 = {.desc ="mem_313147", .mem =
                                  futhark_mc_segmap_parloop_struct_339051->free_mem_313147,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_segmap_parloop_struct_339051->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_segmap_parloop_struct_339051->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_segmap_parloop_struct_339051->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_segmap_parloop_struct_339051->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315656 = {.desc ="mem_315656", .mem =
                                  futhark_mc_segmap_parloop_struct_339051->free_mem_315656,
                                  .size =0, .references =NULL};
    struct memblock mem_316527 = {.desc ="mem_316527", .mem =
                                  futhark_mc_segmap_parloop_struct_339051->free_mem_316527,
                                  .size =0, .references =NULL};
    size_t mem_316466_cached_sizze_339053 = 0;
    unsigned char *mem_316466 = NULL;
    size_t mem_316481_cached_sizze_339054 = 0;
    unsigned char *mem_316481 = NULL;
    size_t mem_316484_cached_sizze_339055 = 0;
    unsigned char *mem_316484 = NULL;
    size_t mem_316511_cached_sizze_339056 = 0;
    unsigned char *mem_316511 = NULL;
    int64_t iterations = end - start;
    int64_t iter_335520 = start;
    
    if (mem_316466_cached_sizze_339053 < (size_t) bytes_312598) {
        mem_316466 = realloc(mem_316466, bytes_312598);
        mem_316466_cached_sizze_339053 = bytes_312598;
    }
    if (mem_316481_cached_sizze_339054 < (size_t) bytes_312598) {
        mem_316481 = realloc(mem_316481, bytes_312598);
        mem_316481_cached_sizze_339054 = bytes_312598;
    }
    if (mem_316484_cached_sizze_339055 < (size_t) bytes_312598) {
        mem_316484 = realloc(mem_316484, bytes_312598);
        mem_316484_cached_sizze_339055 = bytes_312598;
    }
    if (mem_316511_cached_sizze_339056 < (size_t) bytes_313090) {
        mem_316511 = realloc(mem_316511, bytes_313090);
        mem_316511_cached_sizze_339056 = bytes_313090;
    }
    for (; iter_335520 < end; iter_335520++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_335604 = partition_sizze_292766;
        int64_t gtid_309419 = iter_335520;
        int64_t remnant_335605 = iter_335520 - gtid_309419;
        int64_t x_296587;
        
        x_296587 = ((int64_t *) mem_312639.mem)[gtid_309419];
        for (int64_t i_335521 = 0; i_335521 < n_292675; i_335521++) {
            float x_335523;
            
            x_335523 = ((float *) mem_312593.mem)[gtid_309419 * n_292675 +
                                                  i_335521];
            
            double x_335524;
            
            x_335524 = ((double *) mem_315656.mem)[gtid_309419 * n_292675 +
                                                   i_335521];
            
            double f32_res_335525 = fpconv_f32_f64(x_335523);
            double defunc_1_f_res_335526 = f32_res_335525 - x_335524;
            
            ((double *) mem_316466)[i_335521] = defunc_1_f_res_335526;
        }
        for (int64_t i_335528 = 0; i_335528 < n_292675; i_335528++) {
            int64_t x_335531;
            
            x_335531 = ((int64_t *) mem_312636.mem)[gtid_309419 * n_292675 +
                                                    i_335528];
            
            bool cond_335532 = sle64((int64_t) 0, x_335531);
            double defunc_0_f_res_335533;
            
            if (cond_335532) {
                bool y_335534 = slt64(x_335531, n_292675);
                bool bounds_check_335535 = cond_335532 && y_335534;
                bool index_certs_335536;
                
                if (!bounds_check_335535) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [", (long long) x_335531,
                                  "] out of bounds for array of shape [",
                                  (long long) n_292675, "].",
                                  "-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:45:43-70\n   #3  stl.fut:285:33-58\n   #4  /prelude/soacs.fut:75:22-28\n   #5  /prelude/soacs.fut:75:3-45\n   #6  stl.fut:283:13-288:41\n   #7  stl.fut:419:61-435:77\n   #8  stl.fut:463:3-479:36\n   #9  stl.fut:445:1-479:36\n");
                    err = FUTHARK_PROGRAM_ERROR;
                    goto cleanup;
                }
                
                double defunc_0_f_res_t_res_335537;
                
                defunc_0_f_res_t_res_335537 = ((double *) mem_316466)[x_335531];
                defunc_0_f_res_335533 = defunc_0_f_res_t_res_335537;
            } else {
                defunc_0_f_res_335533 = 0.0;
            }
            
            double defunc_0_f_res_335538;
            
            if (cond_335532) {
                bool y_335539 = slt64(x_335531, n_292675);
                bool bounds_check_335540 = cond_335532 && y_335539;
                bool index_certs_335541;
                
                if (!bounds_check_335540) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [", (long long) x_335531,
                                  "] out of bounds for array of shape [",
                                  (long long) n_292675, "].",
                                  "-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:45:43-70\n   #3  stl.fut:286:33-64\n   #4  /prelude/soacs.fut:75:22-28\n   #5  /prelude/soacs.fut:75:3-45\n   #6  stl.fut:283:13-288:41\n   #7  stl.fut:419:61-435:77\n   #8  stl.fut:463:3-479:36\n   #9  stl.fut:445:1-479:36\n");
                    err = FUTHARK_PROGRAM_ERROR;
                    goto cleanup;
                }
                
                double defunc_0_f_res_t_res_335542;
                
                defunc_0_f_res_t_res_335542 =
                    ((double *) mem_param_313179.mem)[ctx_param_ext_313174 +
                                                      (gtid_309419 *
                                                       ctx_param_ext_313175 +
                                                       x_335531 *
                                                       ctx_param_ext_313177)];
                defunc_0_f_res_335538 = defunc_0_f_res_t_res_335542;
            } else {
                defunc_0_f_res_335538 = 0.0;
            }
            ((double *) mem_316481)[i_335528] = defunc_0_f_res_335538;
            ((double *) mem_316484)[i_335528] = defunc_0_f_res_335533;
        }
        for (int64_t i_335545 = 0; i_335545 < t_n_m_292839; i_335545++) {
            int64_t x_335547;
            
            x_335547 = ((int64_t *) mem_313143.mem)[gtid_309419 * t_n_m_292839 +
                                                    i_335545];
            
            double x_335548;
            
            x_335548 = ((double *) mem_313147.mem)[gtid_309419 * t_n_m_292839 +
                                                   i_335545];
            
            int64_t min_arg_335549 = mul64(jump_t_292685, i_335545);
            int64_t min_res_335550 = smin64(i_292846, min_arg_335549);
            int64_t defunc_0_g_res_335551 = add64((int64_t) 1, min_res_335550);
            double defunc_2_reduce_res_335552;
            double redout_335554 = 0.0;
            
            for (int64_t i_335553 = 0; i_335553 < q_t_292679; i_335553++) {
                bool cond_335555 = sle64(x_296587, i_335553);
                int64_t defunc_0_f_res_335556;
                
                if (cond_335555) {
                    defunc_0_f_res_335556 = (int64_t) 0;
                } else {
                    int64_t i_335557 = add64(x_335547, i_335553);
                    int64_t defunc_0_add_arg_335558;
                    
                    defunc_0_add_arg_335558 =
                        ((int64_t *) mem_312636.mem)[gtid_309419 * n_292675 +
                                                     i_335557];
                    
                    int64_t defunc_1_add_res_335559 = add64((int64_t) 1,
                                                            defunc_0_add_arg_335558);
                    
                    defunc_0_f_res_335556 = defunc_1_add_res_335559;
                }
                
                double defunc_0_f_res_335560;
                
                if (cond_335555) {
                    defunc_0_f_res_335560 = 0.0;
                } else {
                    int64_t i_335561 = add64(x_335547, i_335553);
                    double defunc_0_add_arg_335562;
                    
                    defunc_0_add_arg_335562 = ((double *) mem_316481)[i_335561];
                    defunc_0_f_res_335560 = defunc_0_add_arg_335562;
                }
                
                int64_t binop_p_335563 = sub64(defunc_0_f_res_335556,
                                               defunc_0_g_res_335551);
                double defunc_0_f_res_335564 = sitofp_i64_f64(binop_p_335563);
                double abs_res_335565 = fabs(defunc_0_f_res_335564);
                double tmp1_335566 = abs_res_335565 / x_335548;
                double x_335567 = tmp1_335566 * tmp1_335566;
                double y_335568 = tmp1_335566 * x_335567;
                double tmp2_335569 = 1.0 - y_335568;
                double x_335570 = tmp2_335569 * tmp2_335569;
                double tmp3_335571 = tmp2_335569 * x_335570;
                double w_j_335572 = defunc_0_f_res_335560 * tmp3_335571;
                double defunc_1_op_res_335573 = w_j_335572 + redout_335554;
                double redout_tmp_335610 = defunc_1_op_res_335573;
                
                redout_335554 = redout_tmp_335610;
            }
            defunc_2_reduce_res_335552 = redout_335554;
            
            double a_335574 = 2.220446049250313e-16 +
                   defunc_2_reduce_res_335552;
            double a0_335575 = 1.0 / a_335574;
            double defunc_2_reduce_res_335576;
            double redout_335578 = 0.0;
            
            for (int64_t i_335577 = 0; i_335577 < q_t_292679; i_335577++) {
                bool cond_335579 = sle64(x_296587, i_335577);
                int64_t defunc_0_f_res_335580;
                
                if (cond_335579) {
                    defunc_0_f_res_335580 = (int64_t) 0;
                } else {
                    int64_t i_335581 = add64(x_335547, i_335577);
                    int64_t defunc_0_add_arg_335582;
                    
                    defunc_0_add_arg_335582 =
                        ((int64_t *) mem_312636.mem)[gtid_309419 * n_292675 +
                                                     i_335581];
                    
                    int64_t defunc_1_add_res_335583 = add64((int64_t) 1,
                                                            defunc_0_add_arg_335582);
                    
                    defunc_0_f_res_335580 = defunc_1_add_res_335583;
                }
                
                double defunc_0_f_res_335584;
                
                if (cond_335579) {
                    defunc_0_f_res_335584 = 0.0;
                } else {
                    int64_t i_335585 = add64(x_335547, i_335577);
                    double defunc_0_add_arg_335586;
                    
                    defunc_0_add_arg_335586 = ((double *) mem_316481)[i_335585];
                    defunc_0_f_res_335584 = defunc_0_add_arg_335586;
                }
                
                int64_t binop_p_335587 = sub64(defunc_0_f_res_335580,
                                               defunc_0_g_res_335551);
                double defunc_0_f_res_335588 = sitofp_i64_f64(binop_p_335587);
                double abs_res_335589 = fabs(defunc_0_f_res_335588);
                double tmp1_335590 = abs_res_335589 / x_335548;
                double x_335591 = tmp1_335590 * tmp1_335590;
                double y_335592 = tmp1_335590 * x_335591;
                double tmp2_335593 = 1.0 - y_335592;
                double x_335594 = tmp2_335593 * tmp2_335593;
                double tmp3_335595 = tmp2_335593 * x_335594;
                double tmp4_335596 = defunc_0_f_res_335584 * tmp3_335595;
                double defunc_0_f_res_335597;
                
                if (cond_335579) {
                    defunc_0_f_res_335597 = 0.0;
                } else {
                    int64_t i_335598 = add64(x_335547, i_335577);
                    double defunc_0_add_arg_335599;
                    
                    defunc_0_add_arg_335599 = ((double *) mem_316484)[i_335598];
                    defunc_0_f_res_335597 = defunc_0_add_arg_335599;
                }
                
                double x_335600 = a0_335575 * tmp4_335596;
                double defunc_9_fit_fun_res_335601 = defunc_0_f_res_335597 *
                       x_335600;
                double defunc_1_op_res_335602 = defunc_9_fit_fun_res_335601 +
                       redout_335578;
                double redout_tmp_335611 = defunc_1_op_res_335602;
                
                redout_335578 = redout_tmp_335611;
            }
            defunc_2_reduce_res_335576 = redout_335578;
            ((double *) mem_316511)[i_335545] = defunc_2_reduce_res_335576;
        }
        if (t_n_m_292839 * (int64_t) 8 > 0)
            memmove(mem_316527.mem + gtid_309419 * t_n_m_292839 * (int64_t) 8,
                    mem_316511 + (int64_t) 0, t_n_m_292839 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_316466);
    free(mem_316481);
    free(mem_316484);
    free(mem_316511);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339052_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339052_end -
                 futhark_mc_segmap_parloop_339052_start;
        
        ctx->futhark_mc_segmap_parloop_339052_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_339052_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_339052_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_339050(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_309418 = tid;
    int num_tasks_335519 = info.nsubtasks;
    struct futhark_mc_task_339049 *futhark_mc_task_339049 =
                                  (struct futhark_mc_task_339049 *) args;
    struct futhark_context *ctx = futhark_mc_task_339049->ctx;
    uint64_t futhark_mc_segmap_task_339050_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_339050_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_339049->free_n_292675;
    int64_t q_t_292679 = futhark_mc_task_339049->free_q_t_292679;
    int64_t jump_t_292685 = futhark_mc_task_339049->free_jump_t_292685;
    int64_t partition_sizze_292766 =
            futhark_mc_task_339049->free_partition_sizze_292766;
    int64_t t_n_m_292839 = futhark_mc_task_339049->free_t_n_m_292839;
    int64_t i_292846 = futhark_mc_task_339049->free_i_292846;
    struct memblock mem_312593 = {.desc ="mem_312593", .mem =
                                  futhark_mc_task_339049->free_mem_312593,
                                  .size =0, .references =NULL};
    int64_t bytes_312598 = futhark_mc_task_339049->free_bytes_312598;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_task_339049->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_312639 = {.desc ="mem_312639", .mem =
                                  futhark_mc_task_339049->free_mem_312639,
                                  .size =0, .references =NULL};
    int64_t bytes_313090 = futhark_mc_task_339049->free_bytes_313090;
    struct memblock mem_313143 = {.desc ="mem_313143", .mem =
                                  futhark_mc_task_339049->free_mem_313143,
                                  .size =0, .references =NULL};
    struct memblock mem_313147 = {.desc ="mem_313147", .mem =
                                  futhark_mc_task_339049->free_mem_313147,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_task_339049->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_task_339049->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_task_339049->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_task_339049->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315656 = {.desc ="mem_315656", .mem =
                                  futhark_mc_task_339049->free_mem_315656,
                                  .size =0, .references =NULL};
    struct memblock mem_316527 = {.desc ="mem_316527", .mem =
                                  futhark_mc_task_339049->free_mem_316527,
                                  .size =0, .references =NULL};
    int64_t iter_335520;
    struct futhark_mc_segmap_parloop_struct_339051
    futhark_mc_segmap_parloop_struct_339051;
    
    futhark_mc_segmap_parloop_struct_339051.ctx = ctx;
    futhark_mc_segmap_parloop_struct_339051.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_339051.free_q_t_292679 = q_t_292679;
    futhark_mc_segmap_parloop_struct_339051.free_jump_t_292685 = jump_t_292685;
    futhark_mc_segmap_parloop_struct_339051.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_339051.free_t_n_m_292839 = t_n_m_292839;
    futhark_mc_segmap_parloop_struct_339051.free_i_292846 = i_292846;
    futhark_mc_segmap_parloop_struct_339051.free_mem_312593 = mem_312593.mem;
    futhark_mc_segmap_parloop_struct_339051.free_bytes_312598 = bytes_312598;
    futhark_mc_segmap_parloop_struct_339051.free_mem_312636 = mem_312636.mem;
    futhark_mc_segmap_parloop_struct_339051.free_mem_312639 = mem_312639.mem;
    futhark_mc_segmap_parloop_struct_339051.free_bytes_313090 = bytes_313090;
    futhark_mc_segmap_parloop_struct_339051.free_mem_313143 = mem_313143.mem;
    futhark_mc_segmap_parloop_struct_339051.free_mem_313147 = mem_313147.mem;
    futhark_mc_segmap_parloop_struct_339051.free_ctx_param_ext_313174 =
        ctx_param_ext_313174;
    futhark_mc_segmap_parloop_struct_339051.free_ctx_param_ext_313175 =
        ctx_param_ext_313175;
    futhark_mc_segmap_parloop_struct_339051.free_ctx_param_ext_313177 =
        ctx_param_ext_313177;
    futhark_mc_segmap_parloop_struct_339051.free_mem_param_313179 =
        mem_param_313179.mem;
    futhark_mc_segmap_parloop_struct_339051.free_mem_315656 = mem_315656.mem;
    futhark_mc_segmap_parloop_struct_339051.free_mem_316527 = mem_316527.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_339052_task;
    
    futhark_mc_segmap_parloop_339052_task.name =
        "futhark_mc_segmap_parloop_339052";
    futhark_mc_segmap_parloop_339052_task.fn = futhark_mc_segmap_parloop_339052;
    futhark_mc_segmap_parloop_339052_task.args =
        &futhark_mc_segmap_parloop_struct_339051;
    futhark_mc_segmap_parloop_339052_task.iterations = iterations;
    futhark_mc_segmap_parloop_339052_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_339052_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339052_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_339052_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_339052_task);
    
    if (futhark_mc_segmap_parloop_339052_err != 0) {
        err = futhark_mc_segmap_parloop_339052_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339052_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339052_total_end -
                 futhark_mc_segmap_parloop_339052_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339052_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339052_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339052_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_339050_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_339050_end -
                 futhark_mc_segmap_task_339050_start;
        
        ctx->futhark_mc_segmap_task_339050_runs[tid]++;
        ctx->futhark_mc_segmap_task_339050_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_339050_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_segmap_parloop_struct_339058 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_t_292679;
    int64_t free_jump_t_292685;
    int64_t free_partition_sizze_292766;
    int64_t free_t_n_m_292839;
    int64_t free_i_292846;
    unsigned char *free_mem_312593;
    int64_t free_bytes_312598;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_312639;
    int64_t free_bytes_313090;
    unsigned char *free_mem_313143;
    unsigned char *free_mem_313147;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315656;
    unsigned char *free_mem_316527;
};
struct futhark_mc_task_339064 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_309500;
    unsigned char *free_mem_312593;
    unsigned char *free_mem_315656;
    unsigned char *free_mem_316454;
};
struct futhark_mc_segmap_parloop_struct_339066 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_309500;
    unsigned char *free_mem_312593;
    unsigned char *free_mem_315656;
    unsigned char *free_mem_316454;
};
static int futhark_mc_segmap_parloop_339067(void *args, int64_t start,
                                            int64_t end, int flat_tid_335613,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_339066
    *futhark_mc_segmap_parloop_struct_339066 =
    (struct futhark_mc_segmap_parloop_struct_339066 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_339066->ctx;
    uint64_t futhark_mc_segmap_parloop_339067_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339067_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_339066->free_n_292675;
    int64_t gtid_309500 =
            futhark_mc_segmap_parloop_struct_339066->free_gtid_309500;
    struct memblock mem_312593 = {.desc ="mem_312593", .mem =
                                  futhark_mc_segmap_parloop_struct_339066->free_mem_312593,
                                  .size =0, .references =NULL};
    struct memblock mem_315656 = {.desc ="mem_315656", .mem =
                                  futhark_mc_segmap_parloop_struct_339066->free_mem_315656,
                                  .size =0, .references =NULL};
    struct memblock mem_316454 = {.desc ="mem_316454", .mem =
                                  futhark_mc_segmap_parloop_struct_339066->free_mem_316454,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_335756 = start;
    
    for (; iter_335756 < end; iter_335756++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_335757 = n_292675;
        int64_t gtid_335614 = iter_335756;
        int64_t remnant_335758 = iter_335756 - gtid_335614;
        float x_335615;
        
        x_335615 = ((float *) mem_312593.mem)[gtid_309500 * n_292675 +
                                              gtid_335614];
        
        double x_335616;
        
        x_335616 = ((double *) mem_315656.mem)[gtid_309500 * n_292675 +
                                               gtid_335614];
        
        double f32_res_335617 = fpconv_f32_f64(x_335615);
        double defunc_1_f_res_335618 = f32_res_335617 - x_335616;
        
        ((double *) mem_316454.mem)[gtid_335614] = defunc_1_f_res_335618;
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339067_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339067_end -
                 futhark_mc_segmap_parloop_339067_start;
        
        ctx->futhark_mc_segmap_parloop_339067_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_339067_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_339067_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_339065(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_335613 = tid;
    int num_tasks_335755 = info.nsubtasks;
    struct futhark_mc_task_339064 *futhark_mc_task_339064 =
                                  (struct futhark_mc_task_339064 *) args;
    struct futhark_context *ctx = futhark_mc_task_339064->ctx;
    uint64_t futhark_mc_segmap_task_339065_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_339065_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_339064->free_n_292675;
    int64_t gtid_309500 = futhark_mc_task_339064->free_gtid_309500;
    struct memblock mem_312593 = {.desc ="mem_312593", .mem =
                                  futhark_mc_task_339064->free_mem_312593,
                                  .size =0, .references =NULL};
    struct memblock mem_315656 = {.desc ="mem_315656", .mem =
                                  futhark_mc_task_339064->free_mem_315656,
                                  .size =0, .references =NULL};
    struct memblock mem_316454 = {.desc ="mem_316454", .mem =
                                  futhark_mc_task_339064->free_mem_316454,
                                  .size =0, .references =NULL};
    int64_t iter_335756;
    struct futhark_mc_segmap_parloop_struct_339066
    futhark_mc_segmap_parloop_struct_339066;
    
    futhark_mc_segmap_parloop_struct_339066.ctx = ctx;
    futhark_mc_segmap_parloop_struct_339066.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_339066.free_gtid_309500 = gtid_309500;
    futhark_mc_segmap_parloop_struct_339066.free_mem_312593 = mem_312593.mem;
    futhark_mc_segmap_parloop_struct_339066.free_mem_315656 = mem_315656.mem;
    futhark_mc_segmap_parloop_struct_339066.free_mem_316454 = mem_316454.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_339067_task;
    
    futhark_mc_segmap_parloop_339067_task.name =
        "futhark_mc_segmap_parloop_339067";
    futhark_mc_segmap_parloop_339067_task.fn = futhark_mc_segmap_parloop_339067;
    futhark_mc_segmap_parloop_339067_task.args =
        &futhark_mc_segmap_parloop_struct_339066;
    futhark_mc_segmap_parloop_339067_task.iterations = iterations;
    futhark_mc_segmap_parloop_339067_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_339067_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339067_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_339067_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_339067_task);
    
    if (futhark_mc_segmap_parloop_339067_err != 0) {
        err = futhark_mc_segmap_parloop_339067_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339067_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339067_total_end -
                 futhark_mc_segmap_parloop_339067_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339067_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339067_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339067_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_339065_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_339065_end -
                 futhark_mc_segmap_task_339065_start;
        
        ctx->futhark_mc_segmap_task_339065_runs[tid]++;
        ctx->futhark_mc_segmap_task_339065_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_339065_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_task_339068 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_309500;
    unsigned char *free_mem_312636;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_316454;
    unsigned char *free_mem_316457;
    unsigned char *free_mem_316460;
};
struct futhark_mc_segmap_parloop_struct_339070 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_309500;
    unsigned char *free_mem_312636;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_316454;
    unsigned char *free_mem_316457;
    unsigned char *free_mem_316460;
};
static int futhark_mc_segmap_parloop_339071(void *args, int64_t start,
                                            int64_t end, int flat_tid_335619,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_339070
    *futhark_mc_segmap_parloop_struct_339070 =
    (struct futhark_mc_segmap_parloop_struct_339070 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_339070->ctx;
    uint64_t futhark_mc_segmap_parloop_339071_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339071_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_339070->free_n_292675;
    int64_t gtid_309500 =
            futhark_mc_segmap_parloop_struct_339070->free_gtid_309500;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_segmap_parloop_struct_339070->free_mem_312636,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_segmap_parloop_struct_339070->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_segmap_parloop_struct_339070->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_segmap_parloop_struct_339070->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_segmap_parloop_struct_339070->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_316454 = {.desc ="mem_316454", .mem =
                                  futhark_mc_segmap_parloop_struct_339070->free_mem_316454,
                                  .size =0, .references =NULL};
    struct memblock mem_316457 = {.desc ="mem_316457", .mem =
                                  futhark_mc_segmap_parloop_struct_339070->free_mem_316457,
                                  .size =0, .references =NULL};
    struct memblock mem_316460 = {.desc ="mem_316460", .mem =
                                  futhark_mc_segmap_parloop_struct_339070->free_mem_316460,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_335760 = start;
    
    for (; iter_335760 < end; iter_335760++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_335769 = n_292675;
        int64_t gtid_335620 = iter_335760;
        int64_t remnant_335770 = iter_335760 - gtid_335620;
        int64_t x_335621;
        
        x_335621 = ((int64_t *) mem_312636.mem)[gtid_309500 * n_292675 +
                                                gtid_335620];
        
        bool cond_335622 = sle64((int64_t) 0, x_335621);
        double defunc_0_f_res_335623;
        
        if (cond_335622) {
            bool y_335761 = slt64(x_335621, n_292675);
            bool bounds_check_335762 = cond_335622 && y_335761;
            bool index_certs_335763;
            
            if (!bounds_check_335762) {
                ctx->error =
                    msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                              "Index [", (long long) x_335621,
                              "] out of bounds for array of shape [",
                              (long long) n_292675, "].",
                              "-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:45:43-70\n   #3  stl.fut:285:33-58\n   #4  /prelude/soacs.fut:75:22-28\n   #5  /prelude/soacs.fut:75:3-45\n   #6  stl.fut:283:13-288:41\n   #7  stl.fut:419:61-435:77\n   #8  stl.fut:463:3-479:36\n   #9  stl.fut:445:1-479:36\n");
                err = FUTHARK_PROGRAM_ERROR;
                goto cleanup;
            }
            
            double defunc_0_f_res_t_res_335764;
            
            defunc_0_f_res_t_res_335764 = ((double *) mem_316454.mem)[x_335621];
            defunc_0_f_res_335623 = defunc_0_f_res_t_res_335764;
        } else {
            defunc_0_f_res_335623 = 0.0;
        }
        
        double defunc_0_f_res_335628;
        
        if (cond_335622) {
            bool y_335765 = slt64(x_335621, n_292675);
            bool bounds_check_335766 = cond_335622 && y_335765;
            bool index_certs_335767;
            
            if (!bounds_check_335766) {
                ctx->error =
                    msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                              "Index [", (long long) x_335621,
                              "] out of bounds for array of shape [",
                              (long long) n_292675, "].",
                              "-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:45:43-70\n   #3  stl.fut:286:33-64\n   #4  /prelude/soacs.fut:75:22-28\n   #5  /prelude/soacs.fut:75:3-45\n   #6  stl.fut:283:13-288:41\n   #7  stl.fut:419:61-435:77\n   #8  stl.fut:463:3-479:36\n   #9  stl.fut:445:1-479:36\n");
                err = FUTHARK_PROGRAM_ERROR;
                goto cleanup;
            }
            
            double defunc_0_f_res_t_res_335768;
            
            defunc_0_f_res_t_res_335768 =
                ((double *) mem_param_313179.mem)[ctx_param_ext_313174 +
                                                  (gtid_309500 *
                                                   ctx_param_ext_313175 +
                                                   x_335621 *
                                                   ctx_param_ext_313177)];
            defunc_0_f_res_335628 = defunc_0_f_res_t_res_335768;
        } else {
            defunc_0_f_res_335628 = 0.0;
        }
        ((double *) mem_316457.mem)[gtid_335620] = defunc_0_f_res_335628;
        ((double *) mem_316460.mem)[gtid_335620] = defunc_0_f_res_335623;
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339071_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339071_end -
                 futhark_mc_segmap_parloop_339071_start;
        
        ctx->futhark_mc_segmap_parloop_339071_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_339071_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_339071_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_339069(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_335619 = tid;
    int num_tasks_335759 = info.nsubtasks;
    struct futhark_mc_task_339068 *futhark_mc_task_339068 =
                                  (struct futhark_mc_task_339068 *) args;
    struct futhark_context *ctx = futhark_mc_task_339068->ctx;
    uint64_t futhark_mc_segmap_task_339069_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_339069_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_339068->free_n_292675;
    int64_t gtid_309500 = futhark_mc_task_339068->free_gtid_309500;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_task_339068->free_mem_312636,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_task_339068->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_task_339068->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_task_339068->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_task_339068->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_316454 = {.desc ="mem_316454", .mem =
                                  futhark_mc_task_339068->free_mem_316454,
                                  .size =0, .references =NULL};
    struct memblock mem_316457 = {.desc ="mem_316457", .mem =
                                  futhark_mc_task_339068->free_mem_316457,
                                  .size =0, .references =NULL};
    struct memblock mem_316460 = {.desc ="mem_316460", .mem =
                                  futhark_mc_task_339068->free_mem_316460,
                                  .size =0, .references =NULL};
    int64_t iter_335760;
    struct futhark_mc_segmap_parloop_struct_339070
    futhark_mc_segmap_parloop_struct_339070;
    
    futhark_mc_segmap_parloop_struct_339070.ctx = ctx;
    futhark_mc_segmap_parloop_struct_339070.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_339070.free_gtid_309500 = gtid_309500;
    futhark_mc_segmap_parloop_struct_339070.free_mem_312636 = mem_312636.mem;
    futhark_mc_segmap_parloop_struct_339070.free_ctx_param_ext_313174 =
        ctx_param_ext_313174;
    futhark_mc_segmap_parloop_struct_339070.free_ctx_param_ext_313175 =
        ctx_param_ext_313175;
    futhark_mc_segmap_parloop_struct_339070.free_ctx_param_ext_313177 =
        ctx_param_ext_313177;
    futhark_mc_segmap_parloop_struct_339070.free_mem_param_313179 =
        mem_param_313179.mem;
    futhark_mc_segmap_parloop_struct_339070.free_mem_316454 = mem_316454.mem;
    futhark_mc_segmap_parloop_struct_339070.free_mem_316457 = mem_316457.mem;
    futhark_mc_segmap_parloop_struct_339070.free_mem_316460 = mem_316460.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_339071_task;
    
    futhark_mc_segmap_parloop_339071_task.name =
        "futhark_mc_segmap_parloop_339071";
    futhark_mc_segmap_parloop_339071_task.fn = futhark_mc_segmap_parloop_339071;
    futhark_mc_segmap_parloop_339071_task.args =
        &futhark_mc_segmap_parloop_struct_339070;
    futhark_mc_segmap_parloop_339071_task.iterations = iterations;
    futhark_mc_segmap_parloop_339071_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_339071_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339071_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_339071_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_339071_task);
    
    if (futhark_mc_segmap_parloop_339071_err != 0) {
        err = futhark_mc_segmap_parloop_339071_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339071_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339071_total_end -
                 futhark_mc_segmap_parloop_339071_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339071_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339071_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339071_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_339069_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_339069_end -
                 futhark_mc_segmap_task_339069_start;
        
        ctx->futhark_mc_segmap_task_339069_runs[tid]++;
        ctx->futhark_mc_segmap_task_339069_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_339069_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_task_339072 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_t_292679;
    int64_t free_jump_t_292685;
    int64_t free_t_n_m_292839;
    int64_t free_i_292846;
    int64_t free_gtid_309500;
    int64_t free_x_309505;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_313143;
    unsigned char *free_mem_313147;
    unsigned char *free_mem_316457;
    unsigned char *free_mem_316460;
    unsigned char *free_mem_316463;
};
struct futhark_mc_segmap_parloop_struct_339074 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_t_292679;
    int64_t free_jump_t_292685;
    int64_t free_t_n_m_292839;
    int64_t free_i_292846;
    int64_t free_gtid_309500;
    int64_t free_x_309505;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_313143;
    unsigned char *free_mem_313147;
    unsigned char *free_mem_316457;
    unsigned char *free_mem_316460;
    unsigned char *free_mem_316463;
};
static int futhark_mc_segmap_parloop_339075(void *args, int64_t start,
                                            int64_t end, int flat_tid_335695,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_339074
    *futhark_mc_segmap_parloop_struct_339074 =
    (struct futhark_mc_segmap_parloop_struct_339074 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_339074->ctx;
    uint64_t futhark_mc_segmap_parloop_339075_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339075_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_339074->free_n_292675;
    int64_t q_t_292679 =
            futhark_mc_segmap_parloop_struct_339074->free_q_t_292679;
    int64_t jump_t_292685 =
            futhark_mc_segmap_parloop_struct_339074->free_jump_t_292685;
    int64_t t_n_m_292839 =
            futhark_mc_segmap_parloop_struct_339074->free_t_n_m_292839;
    int64_t i_292846 = futhark_mc_segmap_parloop_struct_339074->free_i_292846;
    int64_t gtid_309500 =
            futhark_mc_segmap_parloop_struct_339074->free_gtid_309500;
    int64_t x_309505 = futhark_mc_segmap_parloop_struct_339074->free_x_309505;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_segmap_parloop_struct_339074->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_313143 = {.desc ="mem_313143", .mem =
                                  futhark_mc_segmap_parloop_struct_339074->free_mem_313143,
                                  .size =0, .references =NULL};
    struct memblock mem_313147 = {.desc ="mem_313147", .mem =
                                  futhark_mc_segmap_parloop_struct_339074->free_mem_313147,
                                  .size =0, .references =NULL};
    struct memblock mem_316457 = {.desc ="mem_316457", .mem =
                                  futhark_mc_segmap_parloop_struct_339074->free_mem_316457,
                                  .size =0, .references =NULL};
    struct memblock mem_316460 = {.desc ="mem_316460", .mem =
                                  futhark_mc_segmap_parloop_struct_339074->free_mem_316460,
                                  .size =0, .references =NULL};
    struct memblock mem_316463 = {.desc ="mem_316463", .mem =
                                  futhark_mc_segmap_parloop_struct_339074->free_mem_316463,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_335772 = start;
    
    for (; iter_335772 < end; iter_335772++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_335820 = t_n_m_292839;
        int64_t gtid_335696 = iter_335772;
        int64_t remnant_335821 = iter_335772 - gtid_335696;
        int64_t x_335697;
        
        x_335697 = ((int64_t *) mem_313143.mem)[gtid_309500 * t_n_m_292839 +
                                                gtid_335696];
        
        double x_335698;
        
        x_335698 = ((double *) mem_313147.mem)[gtid_309500 * t_n_m_292839 +
                                               gtid_335696];
        
        int64_t min_arg_335699 = mul64(jump_t_292685, gtid_335696);
        int64_t min_res_335700 = smin64(i_292846, min_arg_335699);
        int64_t defunc_0_g_res_335701 = add64((int64_t) 1, min_res_335700);
        double defunc_2_reduce_res_335702;
        double redout_335774 = 0.0;
        
        for (int64_t i_335773 = 0; i_335773 < q_t_292679; i_335773++) {
            bool cond_335775 = sle64(x_309505, i_335773);
            int64_t defunc_0_f_res_335776;
            
            if (cond_335775) {
                defunc_0_f_res_335776 = (int64_t) 0;
            } else {
                int64_t i_335777 = add64(x_335697, i_335773);
                int64_t defunc_0_add_arg_335778;
                
                defunc_0_add_arg_335778 =
                    ((int64_t *) mem_312636.mem)[gtid_309500 * n_292675 +
                                                 i_335777];
                
                int64_t defunc_1_add_res_335779 = add64((int64_t) 1,
                                                        defunc_0_add_arg_335778);
                
                defunc_0_f_res_335776 = defunc_1_add_res_335779;
            }
            
            double defunc_0_f_res_335780;
            
            if (cond_335775) {
                defunc_0_f_res_335780 = 0.0;
            } else {
                int64_t i_335781 = add64(x_335697, i_335773);
                double defunc_0_add_arg_335782;
                
                defunc_0_add_arg_335782 = ((double *) mem_316457.mem)[i_335781];
                defunc_0_f_res_335780 = defunc_0_add_arg_335782;
            }
            
            int64_t binop_p_335783 = sub64(defunc_0_f_res_335776,
                                           defunc_0_g_res_335701);
            double defunc_0_f_res_335784 = sitofp_i64_f64(binop_p_335783);
            double abs_res_335785 = fabs(defunc_0_f_res_335784);
            double tmp1_335786 = abs_res_335785 / x_335698;
            double x_335787 = tmp1_335786 * tmp1_335786;
            double y_335788 = tmp1_335786 * x_335787;
            double tmp2_335789 = 1.0 - y_335788;
            double x_335790 = tmp2_335789 * tmp2_335789;
            double tmp3_335791 = tmp2_335789 * x_335790;
            double w_j_335792 = defunc_0_f_res_335780 * tmp3_335791;
            double defunc_1_op_res_335793 = w_j_335792 + redout_335774;
            double redout_tmp_335822 = defunc_1_op_res_335793;
            
            redout_335774 = redout_tmp_335822;
        }
        defunc_2_reduce_res_335702 = redout_335774;
        
        double a_335724 = 2.220446049250313e-16 + defunc_2_reduce_res_335702;
        double a0_335725 = 1.0 / a_335724;
        double defunc_2_reduce_res_335726;
        double redout_335795 = 0.0;
        
        for (int64_t i_335794 = 0; i_335794 < q_t_292679; i_335794++) {
            bool cond_335796 = sle64(x_309505, i_335794);
            int64_t defunc_0_f_res_335797;
            
            if (cond_335796) {
                defunc_0_f_res_335797 = (int64_t) 0;
            } else {
                int64_t i_335798 = add64(x_335697, i_335794);
                int64_t defunc_0_add_arg_335799;
                
                defunc_0_add_arg_335799 =
                    ((int64_t *) mem_312636.mem)[gtid_309500 * n_292675 +
                                                 i_335798];
                
                int64_t defunc_1_add_res_335800 = add64((int64_t) 1,
                                                        defunc_0_add_arg_335799);
                
                defunc_0_f_res_335797 = defunc_1_add_res_335800;
            }
            
            double defunc_0_f_res_335801;
            
            if (cond_335796) {
                defunc_0_f_res_335801 = 0.0;
            } else {
                int64_t i_335802 = add64(x_335697, i_335794);
                double defunc_0_add_arg_335803;
                
                defunc_0_add_arg_335803 = ((double *) mem_316457.mem)[i_335802];
                defunc_0_f_res_335801 = defunc_0_add_arg_335803;
            }
            
            int64_t binop_p_335804 = sub64(defunc_0_f_res_335797,
                                           defunc_0_g_res_335701);
            double defunc_0_f_res_335805 = sitofp_i64_f64(binop_p_335804);
            double abs_res_335806 = fabs(defunc_0_f_res_335805);
            double tmp1_335807 = abs_res_335806 / x_335698;
            double x_335808 = tmp1_335807 * tmp1_335807;
            double y_335809 = tmp1_335807 * x_335808;
            double tmp2_335810 = 1.0 - y_335809;
            double x_335811 = tmp2_335810 * tmp2_335810;
            double tmp3_335812 = tmp2_335810 * x_335811;
            double tmp4_335813 = defunc_0_f_res_335801 * tmp3_335812;
            double defunc_0_f_res_335814;
            
            if (cond_335796) {
                defunc_0_f_res_335814 = 0.0;
            } else {
                int64_t i_335815 = add64(x_335697, i_335794);
                double defunc_0_add_arg_335816;
                
                defunc_0_add_arg_335816 = ((double *) mem_316460.mem)[i_335815];
                defunc_0_f_res_335814 = defunc_0_add_arg_335816;
            }
            
            double x_335817 = a0_335725 * tmp4_335813;
            double defunc_9_fit_fun_res_335818 = defunc_0_f_res_335814 *
                   x_335817;
            double defunc_1_op_res_335819 = defunc_9_fit_fun_res_335818 +
                   redout_335795;
            double redout_tmp_335823 = defunc_1_op_res_335819;
            
            redout_335795 = redout_tmp_335823;
        }
        defunc_2_reduce_res_335726 = redout_335795;
        ((double *) mem_316463.mem)[gtid_335696] = defunc_2_reduce_res_335726;
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339075_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339075_end -
                 futhark_mc_segmap_parloop_339075_start;
        
        ctx->futhark_mc_segmap_parloop_339075_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_339075_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_339075_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_339073(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_335695 = tid;
    int num_tasks_335771 = info.nsubtasks;
    struct futhark_mc_task_339072 *futhark_mc_task_339072 =
                                  (struct futhark_mc_task_339072 *) args;
    struct futhark_context *ctx = futhark_mc_task_339072->ctx;
    uint64_t futhark_mc_segmap_task_339073_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_339073_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_339072->free_n_292675;
    int64_t q_t_292679 = futhark_mc_task_339072->free_q_t_292679;
    int64_t jump_t_292685 = futhark_mc_task_339072->free_jump_t_292685;
    int64_t t_n_m_292839 = futhark_mc_task_339072->free_t_n_m_292839;
    int64_t i_292846 = futhark_mc_task_339072->free_i_292846;
    int64_t gtid_309500 = futhark_mc_task_339072->free_gtid_309500;
    int64_t x_309505 = futhark_mc_task_339072->free_x_309505;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_task_339072->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_313143 = {.desc ="mem_313143", .mem =
                                  futhark_mc_task_339072->free_mem_313143,
                                  .size =0, .references =NULL};
    struct memblock mem_313147 = {.desc ="mem_313147", .mem =
                                  futhark_mc_task_339072->free_mem_313147,
                                  .size =0, .references =NULL};
    struct memblock mem_316457 = {.desc ="mem_316457", .mem =
                                  futhark_mc_task_339072->free_mem_316457,
                                  .size =0, .references =NULL};
    struct memblock mem_316460 = {.desc ="mem_316460", .mem =
                                  futhark_mc_task_339072->free_mem_316460,
                                  .size =0, .references =NULL};
    struct memblock mem_316463 = {.desc ="mem_316463", .mem =
                                  futhark_mc_task_339072->free_mem_316463,
                                  .size =0, .references =NULL};
    int64_t iter_335772;
    struct futhark_mc_segmap_parloop_struct_339074
    futhark_mc_segmap_parloop_struct_339074;
    
    futhark_mc_segmap_parloop_struct_339074.ctx = ctx;
    futhark_mc_segmap_parloop_struct_339074.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_339074.free_q_t_292679 = q_t_292679;
    futhark_mc_segmap_parloop_struct_339074.free_jump_t_292685 = jump_t_292685;
    futhark_mc_segmap_parloop_struct_339074.free_t_n_m_292839 = t_n_m_292839;
    futhark_mc_segmap_parloop_struct_339074.free_i_292846 = i_292846;
    futhark_mc_segmap_parloop_struct_339074.free_gtid_309500 = gtid_309500;
    futhark_mc_segmap_parloop_struct_339074.free_x_309505 = x_309505;
    futhark_mc_segmap_parloop_struct_339074.free_mem_312636 = mem_312636.mem;
    futhark_mc_segmap_parloop_struct_339074.free_mem_313143 = mem_313143.mem;
    futhark_mc_segmap_parloop_struct_339074.free_mem_313147 = mem_313147.mem;
    futhark_mc_segmap_parloop_struct_339074.free_mem_316457 = mem_316457.mem;
    futhark_mc_segmap_parloop_struct_339074.free_mem_316460 = mem_316460.mem;
    futhark_mc_segmap_parloop_struct_339074.free_mem_316463 = mem_316463.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_339075_task;
    
    futhark_mc_segmap_parloop_339075_task.name =
        "futhark_mc_segmap_parloop_339075";
    futhark_mc_segmap_parloop_339075_task.fn = futhark_mc_segmap_parloop_339075;
    futhark_mc_segmap_parloop_339075_task.args =
        &futhark_mc_segmap_parloop_struct_339074;
    futhark_mc_segmap_parloop_339075_task.iterations = iterations;
    futhark_mc_segmap_parloop_339075_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_339075_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339075_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_339075_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_339075_task);
    
    if (futhark_mc_segmap_parloop_339075_err != 0) {
        err = futhark_mc_segmap_parloop_339075_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339075_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339075_total_end -
                 futhark_mc_segmap_parloop_339075_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339075_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339075_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339075_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_339073_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_339073_end -
                 futhark_mc_segmap_task_339073_start;
        
        ctx->futhark_mc_segmap_task_339073_runs[tid]++;
        ctx->futhark_mc_segmap_task_339073_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_339073_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_segmap_parloop_struct_339077 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_t_292679;
    int64_t free_jump_t_292685;
    int64_t free_t_n_m_292839;
    int64_t free_i_292846;
    int64_t free_gtid_309500;
    int64_t free_x_309505;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_313143;
    unsigned char *free_mem_313147;
    unsigned char *free_mem_316457;
    unsigned char *free_mem_316460;
    unsigned char *free_mem_316463;
};
struct futhark_mc_task_339079 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_309500;
    int64_t free_x_309505;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_316457;
    int64_t free_x_335635;
    double free_x_335636;
    int64_t free_defunc_0_g_res_335639;
    double *retval_defunc_2_reduce_res_335640;
};
struct futhark_mc_segred_stage_1_parloop_struct_339082 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_309500;
    int64_t free_x_309505;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_316457;
    int64_t free_x_335635;
    double free_x_335636;
    int64_t free_defunc_0_g_res_335639;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_335879;
};
static int futhark_mc_segred_stage_1_parloop_339083(void *args, int64_t start,
                                                    int64_t end,
                                                    int flat_tid_335825,
                                                    int tid)
{
    int err = 0;
    struct futhark_mc_segred_stage_1_parloop_struct_339082
    *futhark_mc_segred_stage_1_parloop_struct_339082 =
    (struct futhark_mc_segred_stage_1_parloop_struct_339082 *) args;
    struct futhark_context *ctx =
                           futhark_mc_segred_stage_1_parloop_struct_339082->ctx;
    uint64_t futhark_mc_segred_stage_1_parloop_339083_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_339083_start = get_wall_time();
    
    int64_t n_292675 =
            futhark_mc_segred_stage_1_parloop_struct_339082->free_n_292675;
    int64_t gtid_309500 =
            futhark_mc_segred_stage_1_parloop_struct_339082->free_gtid_309500;
    int64_t x_309505 =
            futhark_mc_segred_stage_1_parloop_struct_339082->free_x_309505;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_339082->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_316457 = {.desc ="mem_316457", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_339082->free_mem_316457,
                                  .size =0, .references =NULL};
    int64_t x_335635 =
            futhark_mc_segred_stage_1_parloop_struct_339082->free_x_335635;
    double x_335636 =
           futhark_mc_segred_stage_1_parloop_struct_339082->free_x_335636;
    int64_t defunc_0_g_res_335639 =
            futhark_mc_segred_stage_1_parloop_struct_339082->free_defunc_0_g_res_335639;
    struct memblock reduce_stage_1_tid_res_arr_mem_335879 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_335879",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_339082->free_reduce_stage_1_tid_res_arr_mem_335879,
                                                             .size =0,
                                                             .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_335881 = start;
    double x_335827;
    double x_335828;
    double local_acc_335882 = 0.0;
    
    for (; iter_335881 < end; iter_335881++) {
        int64_t gtid_335826 = iter_335881;
        bool cond_335830 = sle64(x_309505, gtid_335826);
        int64_t defunc_0_f_res_335831;
        
        if (cond_335830) {
            defunc_0_f_res_335831 = (int64_t) 0;
        } else {
            int64_t i_335832 = add64(x_335635, gtid_335826);
            int64_t defunc_0_add_arg_335833;
            
            defunc_0_add_arg_335833 = ((int64_t *) mem_312636.mem)[gtid_309500 *
                                                                   n_292675 +
                                                                   i_335832];
            
            int64_t defunc_1_add_res_335834 = add64((int64_t) 1,
                                                    defunc_0_add_arg_335833);
            
            defunc_0_f_res_335831 = defunc_1_add_res_335834;
        }
        
        double defunc_0_f_res_335835;
        
        if (cond_335830) {
            defunc_0_f_res_335835 = 0.0;
        } else {
            int64_t i_335836 = add64(x_335635, gtid_335826);
            double defunc_0_add_arg_335837;
            
            defunc_0_add_arg_335837 = ((double *) mem_316457.mem)[i_335836];
            defunc_0_f_res_335835 = defunc_0_add_arg_335837;
        }
        
        int64_t binop_p_335838 = sub64(defunc_0_f_res_335831,
                                       defunc_0_g_res_335639);
        double defunc_0_f_res_335839 = sitofp_i64_f64(binop_p_335838);
        double abs_res_335840 = fabs(defunc_0_f_res_335839);
        double tmp1_335841 = abs_res_335840 / x_335636;
        double x_335842 = tmp1_335841 * tmp1_335841;
        double y_335843 = tmp1_335841 * x_335842;
        double tmp2_335844 = 1.0 - y_335843;
        double x_335845 = tmp2_335844 * tmp2_335844;
        double tmp3_335846 = tmp2_335844 * x_335845;
        double w_j_335847 = defunc_0_f_res_335835 * tmp3_335846;
        
        // save map-out results
        { }
        // Load accum params
        {
            x_335827 = local_acc_335882;
        }
        // Load next params
        {
            x_335828 = w_j_335847;
        }
        // Red body
        {
            double defunc_1_op_res_335829 = x_335827 + x_335828;
            
            local_acc_335882 = defunc_1_op_res_335829;
        }
    }
    ((double *) reduce_stage_1_tid_res_arr_mem_335879.mem)[flat_tid_335825] =
        local_acc_335882;
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_339083_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_339083_end -
                 futhark_mc_segred_stage_1_parloop_339083_start;
        
        ctx->futhark_mc_segred_stage_1_parloop_339083_runs[tid]++;
        ctx->futhark_mc_segred_stage_1_parloop_339083_total_runtime[tid] +=
            elapsed;
        ctx->futhark_mc_segred_stage_1_parloop_339083_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segred_task_339080(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_335825 = tid;
    int num_tasks_335878 = info.nsubtasks;
    struct futhark_mc_task_339079 *futhark_mc_task_339079 =
                                  (struct futhark_mc_task_339079 *) args;
    struct futhark_context *ctx = futhark_mc_task_339079->ctx;
    uint64_t futhark_mc_segred_task_339080_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_task_339080_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_339079->free_n_292675;
    int64_t gtid_309500 = futhark_mc_task_339079->free_gtid_309500;
    int64_t x_309505 = futhark_mc_task_339079->free_x_309505;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_task_339079->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_316457 = {.desc ="mem_316457", .mem =
                                  futhark_mc_task_339079->free_mem_316457,
                                  .size =0, .references =NULL};
    int64_t x_335635 = futhark_mc_task_339079->free_x_335635;
    double x_335636 = futhark_mc_task_339079->free_x_335636;
    int64_t defunc_0_g_res_335639 =
            futhark_mc_task_339079->free_defunc_0_g_res_335639;
    double defunc_2_reduce_res_335640 =
           *futhark_mc_task_339079->retval_defunc_2_reduce_res_335640;
    size_t reduce_stage_1_tid_res_arr_mem_335879_cached_sizze_339081 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_335879 = NULL;
    
    if (reduce_stage_1_tid_res_arr_mem_335879_cached_sizze_339081 <
        (size_t) ((int64_t) 8 * num_tasks_335878)) {
        reduce_stage_1_tid_res_arr_mem_335879 =
            realloc(reduce_stage_1_tid_res_arr_mem_335879, (int64_t) 8 *
                    num_tasks_335878);
        reduce_stage_1_tid_res_arr_mem_335879_cached_sizze_339081 =
            (int64_t) 8 * num_tasks_335878;
    }
    
    int64_t iter_335881;
    struct futhark_mc_segred_stage_1_parloop_struct_339082
    futhark_mc_segred_stage_1_parloop_struct_339082;
    
    futhark_mc_segred_stage_1_parloop_struct_339082.ctx = ctx;
    futhark_mc_segred_stage_1_parloop_struct_339082.free_n_292675 = n_292675;
    futhark_mc_segred_stage_1_parloop_struct_339082.free_gtid_309500 =
        gtid_309500;
    futhark_mc_segred_stage_1_parloop_struct_339082.free_x_309505 = x_309505;
    futhark_mc_segred_stage_1_parloop_struct_339082.free_mem_312636 =
        mem_312636.mem;
    futhark_mc_segred_stage_1_parloop_struct_339082.free_mem_316457 =
        mem_316457.mem;
    futhark_mc_segred_stage_1_parloop_struct_339082.free_x_335635 = x_335635;
    futhark_mc_segred_stage_1_parloop_struct_339082.free_x_335636 = x_335636;
    futhark_mc_segred_stage_1_parloop_struct_339082.free_defunc_0_g_res_335639 =
        defunc_0_g_res_335639;
    futhark_mc_segred_stage_1_parloop_struct_339082.free_reduce_stage_1_tid_res_arr_mem_335879 =
        reduce_stage_1_tid_res_arr_mem_335879;
    
    struct scheduler_parloop futhark_mc_segred_stage_1_parloop_339083_task;
    
    futhark_mc_segred_stage_1_parloop_339083_task.name =
        "futhark_mc_segred_stage_1_parloop_339083";
    futhark_mc_segred_stage_1_parloop_339083_task.fn =
        futhark_mc_segred_stage_1_parloop_339083;
    futhark_mc_segred_stage_1_parloop_339083_task.args =
        &futhark_mc_segred_stage_1_parloop_struct_339082;
    futhark_mc_segred_stage_1_parloop_339083_task.iterations = iterations;
    futhark_mc_segred_stage_1_parloop_339083_task.info = info;
    
    uint64_t futhark_mc_segred_stage_1_parloop_339083_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_339083_total_start = get_wall_time();
    
    int futhark_mc_segred_stage_1_parloop_339083_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segred_stage_1_parloop_339083_task);
    
    if (futhark_mc_segred_stage_1_parloop_339083_err != 0) {
        err = futhark_mc_segred_stage_1_parloop_339083_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_339083_total_end =
                 get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_339083_total_end -
                 futhark_mc_segred_stage_1_parloop_339083_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_339083_total_runs,
                           1, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_339083_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_339083_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    // neutral-initialise the output
    {
        defunc_2_reduce_res_335640 = 0.0;
    }
    
    double x_335883;
    double x_335884;
    
    for (int32_t i_335886 = 0; i_335886 < num_tasks_335878; i_335886++) {
        flat_tid_335825 = i_335886;
        // Apply main thread reduction
        {
            // load acc params
            {
                x_335883 = defunc_2_reduce_res_335640;
            }
            // load next params
            {
                x_335884 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_335879)[flat_tid_335825];
            }
            // red body
            {
                double defunc_1_op_res_335885 = x_335883 + x_335884;
                
                defunc_2_reduce_res_335640 = defunc_1_op_res_335885;
            }
        }
    }
    
  cleanup:
    {
        free(reduce_stage_1_tid_res_arr_mem_335879);
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_task_339080_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_task_339080_end -
                 futhark_mc_segred_task_339080_start;
        
        ctx->futhark_mc_segred_task_339080_runs[tid]++;
        ctx->futhark_mc_segred_task_339080_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segred_task_339080_iter[tid] += iterations;
    }
    if (err == 0) {
        *futhark_mc_task_339079->retval_defunc_2_reduce_res_335640 =
            defunc_2_reduce_res_335640;
    }
    return err;
}
struct futhark_mc_task_339084 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_309500;
    int64_t free_x_309505;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_316457;
    unsigned char *free_mem_316460;
    int64_t free_x_335635;
    double free_x_335636;
    int64_t free_defunc_0_g_res_335639;
    double free_a0_335665;
    double *retval_defunc_2_reduce_res_335666;
};
struct futhark_mc_segred_stage_1_parloop_struct_339087 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_309500;
    int64_t free_x_309505;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_316457;
    unsigned char *free_mem_316460;
    int64_t free_x_335635;
    double free_x_335636;
    int64_t free_defunc_0_g_res_335639;
    double free_a0_335665;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_335888;
};
static int futhark_mc_segred_stage_1_parloop_339088(void *args, int64_t start,
                                                    int64_t end,
                                                    int flat_tid_335848,
                                                    int tid)
{
    int err = 0;
    struct futhark_mc_segred_stage_1_parloop_struct_339087
    *futhark_mc_segred_stage_1_parloop_struct_339087 =
    (struct futhark_mc_segred_stage_1_parloop_struct_339087 *) args;
    struct futhark_context *ctx =
                           futhark_mc_segred_stage_1_parloop_struct_339087->ctx;
    uint64_t futhark_mc_segred_stage_1_parloop_339088_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_339088_start = get_wall_time();
    
    int64_t n_292675 =
            futhark_mc_segred_stage_1_parloop_struct_339087->free_n_292675;
    int64_t gtid_309500 =
            futhark_mc_segred_stage_1_parloop_struct_339087->free_gtid_309500;
    int64_t x_309505 =
            futhark_mc_segred_stage_1_parloop_struct_339087->free_x_309505;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_339087->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_316457 = {.desc ="mem_316457", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_339087->free_mem_316457,
                                  .size =0, .references =NULL};
    struct memblock mem_316460 = {.desc ="mem_316460", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_339087->free_mem_316460,
                                  .size =0, .references =NULL};
    int64_t x_335635 =
            futhark_mc_segred_stage_1_parloop_struct_339087->free_x_335635;
    double x_335636 =
           futhark_mc_segred_stage_1_parloop_struct_339087->free_x_335636;
    int64_t defunc_0_g_res_335639 =
            futhark_mc_segred_stage_1_parloop_struct_339087->free_defunc_0_g_res_335639;
    double a0_335665 =
           futhark_mc_segred_stage_1_parloop_struct_339087->free_a0_335665;
    struct memblock reduce_stage_1_tid_res_arr_mem_335888 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_335888",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_339087->free_reduce_stage_1_tid_res_arr_mem_335888,
                                                             .size =0,
                                                             .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_335890 = start;
    double x_335850;
    double x_335851;
    double local_acc_335891 = 0.0;
    
    for (; iter_335890 < end; iter_335890++) {
        int64_t gtid_335849 = iter_335890;
        bool cond_335853 = sle64(x_309505, gtid_335849);
        int64_t defunc_0_f_res_335854;
        
        if (cond_335853) {
            defunc_0_f_res_335854 = (int64_t) 0;
        } else {
            int64_t i_335855 = add64(x_335635, gtid_335849);
            int64_t defunc_0_add_arg_335856;
            
            defunc_0_add_arg_335856 = ((int64_t *) mem_312636.mem)[gtid_309500 *
                                                                   n_292675 +
                                                                   i_335855];
            
            int64_t defunc_1_add_res_335857 = add64((int64_t) 1,
                                                    defunc_0_add_arg_335856);
            
            defunc_0_f_res_335854 = defunc_1_add_res_335857;
        }
        
        double defunc_0_f_res_335858;
        
        if (cond_335853) {
            defunc_0_f_res_335858 = 0.0;
        } else {
            int64_t i_335859 = add64(x_335635, gtid_335849);
            double defunc_0_add_arg_335860;
            
            defunc_0_add_arg_335860 = ((double *) mem_316457.mem)[i_335859];
            defunc_0_f_res_335858 = defunc_0_add_arg_335860;
        }
        
        int64_t binop_p_335861 = sub64(defunc_0_f_res_335854,
                                       defunc_0_g_res_335639);
        double defunc_0_f_res_335862 = sitofp_i64_f64(binop_p_335861);
        double abs_res_335863 = fabs(defunc_0_f_res_335862);
        double tmp1_335864 = abs_res_335863 / x_335636;
        double x_335865 = tmp1_335864 * tmp1_335864;
        double y_335866 = tmp1_335864 * x_335865;
        double tmp2_335867 = 1.0 - y_335866;
        double x_335868 = tmp2_335867 * tmp2_335867;
        double tmp3_335869 = tmp2_335867 * x_335868;
        double tmp4_335870 = defunc_0_f_res_335858 * tmp3_335869;
        double defunc_0_f_res_335871;
        
        if (cond_335853) {
            defunc_0_f_res_335871 = 0.0;
        } else {
            int64_t i_335872 = add64(x_335635, gtid_335849);
            double defunc_0_add_arg_335873;
            
            defunc_0_add_arg_335873 = ((double *) mem_316460.mem)[i_335872];
            defunc_0_f_res_335871 = defunc_0_add_arg_335873;
        }
        
        double x_335874 = a0_335665 * tmp4_335870;
        double defunc_9_fit_fun_res_335875 = defunc_0_f_res_335871 * x_335874;
        
        // save map-out results
        { }
        // Load accum params
        {
            x_335850 = local_acc_335891;
        }
        // Load next params
        {
            x_335851 = defunc_9_fit_fun_res_335875;
        }
        // Red body
        {
            double defunc_1_op_res_335852 = x_335850 + x_335851;
            
            local_acc_335891 = defunc_1_op_res_335852;
        }
    }
    ((double *) reduce_stage_1_tid_res_arr_mem_335888.mem)[flat_tid_335848] =
        local_acc_335891;
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_339088_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_339088_end -
                 futhark_mc_segred_stage_1_parloop_339088_start;
        
        ctx->futhark_mc_segred_stage_1_parloop_339088_runs[tid]++;
        ctx->futhark_mc_segred_stage_1_parloop_339088_total_runtime[tid] +=
            elapsed;
        ctx->futhark_mc_segred_stage_1_parloop_339088_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segred_task_339085(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_335848 = tid;
    int num_tasks_335887 = info.nsubtasks;
    struct futhark_mc_task_339084 *futhark_mc_task_339084 =
                                  (struct futhark_mc_task_339084 *) args;
    struct futhark_context *ctx = futhark_mc_task_339084->ctx;
    uint64_t futhark_mc_segred_task_339085_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_task_339085_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_339084->free_n_292675;
    int64_t gtid_309500 = futhark_mc_task_339084->free_gtid_309500;
    int64_t x_309505 = futhark_mc_task_339084->free_x_309505;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_task_339084->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_316457 = {.desc ="mem_316457", .mem =
                                  futhark_mc_task_339084->free_mem_316457,
                                  .size =0, .references =NULL};
    struct memblock mem_316460 = {.desc ="mem_316460", .mem =
                                  futhark_mc_task_339084->free_mem_316460,
                                  .size =0, .references =NULL};
    int64_t x_335635 = futhark_mc_task_339084->free_x_335635;
    double x_335636 = futhark_mc_task_339084->free_x_335636;
    int64_t defunc_0_g_res_335639 =
            futhark_mc_task_339084->free_defunc_0_g_res_335639;
    double a0_335665 = futhark_mc_task_339084->free_a0_335665;
    double defunc_2_reduce_res_335666 =
           *futhark_mc_task_339084->retval_defunc_2_reduce_res_335666;
    size_t reduce_stage_1_tid_res_arr_mem_335888_cached_sizze_339086 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_335888 = NULL;
    
    if (reduce_stage_1_tid_res_arr_mem_335888_cached_sizze_339086 <
        (size_t) ((int64_t) 8 * num_tasks_335887)) {
        reduce_stage_1_tid_res_arr_mem_335888 =
            realloc(reduce_stage_1_tid_res_arr_mem_335888, (int64_t) 8 *
                    num_tasks_335887);
        reduce_stage_1_tid_res_arr_mem_335888_cached_sizze_339086 =
            (int64_t) 8 * num_tasks_335887;
    }
    
    int64_t iter_335890;
    struct futhark_mc_segred_stage_1_parloop_struct_339087
    futhark_mc_segred_stage_1_parloop_struct_339087;
    
    futhark_mc_segred_stage_1_parloop_struct_339087.ctx = ctx;
    futhark_mc_segred_stage_1_parloop_struct_339087.free_n_292675 = n_292675;
    futhark_mc_segred_stage_1_parloop_struct_339087.free_gtid_309500 =
        gtid_309500;
    futhark_mc_segred_stage_1_parloop_struct_339087.free_x_309505 = x_309505;
    futhark_mc_segred_stage_1_parloop_struct_339087.free_mem_312636 =
        mem_312636.mem;
    futhark_mc_segred_stage_1_parloop_struct_339087.free_mem_316457 =
        mem_316457.mem;
    futhark_mc_segred_stage_1_parloop_struct_339087.free_mem_316460 =
        mem_316460.mem;
    futhark_mc_segred_stage_1_parloop_struct_339087.free_x_335635 = x_335635;
    futhark_mc_segred_stage_1_parloop_struct_339087.free_x_335636 = x_335636;
    futhark_mc_segred_stage_1_parloop_struct_339087.free_defunc_0_g_res_335639 =
        defunc_0_g_res_335639;
    futhark_mc_segred_stage_1_parloop_struct_339087.free_a0_335665 = a0_335665;
    futhark_mc_segred_stage_1_parloop_struct_339087.free_reduce_stage_1_tid_res_arr_mem_335888 =
        reduce_stage_1_tid_res_arr_mem_335888;
    
    struct scheduler_parloop futhark_mc_segred_stage_1_parloop_339088_task;
    
    futhark_mc_segred_stage_1_parloop_339088_task.name =
        "futhark_mc_segred_stage_1_parloop_339088";
    futhark_mc_segred_stage_1_parloop_339088_task.fn =
        futhark_mc_segred_stage_1_parloop_339088;
    futhark_mc_segred_stage_1_parloop_339088_task.args =
        &futhark_mc_segred_stage_1_parloop_struct_339087;
    futhark_mc_segred_stage_1_parloop_339088_task.iterations = iterations;
    futhark_mc_segred_stage_1_parloop_339088_task.info = info;
    
    uint64_t futhark_mc_segred_stage_1_parloop_339088_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_339088_total_start = get_wall_time();
    
    int futhark_mc_segred_stage_1_parloop_339088_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segred_stage_1_parloop_339088_task);
    
    if (futhark_mc_segred_stage_1_parloop_339088_err != 0) {
        err = futhark_mc_segred_stage_1_parloop_339088_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_339088_total_end =
                 get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_339088_total_end -
                 futhark_mc_segred_stage_1_parloop_339088_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_339088_total_runs,
                           1, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_339088_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_339088_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    // neutral-initialise the output
    {
        defunc_2_reduce_res_335666 = 0.0;
    }
    
    double x_335892;
    double x_335893;
    
    for (int32_t i_335895 = 0; i_335895 < num_tasks_335887; i_335895++) {
        flat_tid_335848 = i_335895;
        // Apply main thread reduction
        {
            // load acc params
            {
                x_335892 = defunc_2_reduce_res_335666;
            }
            // load next params
            {
                x_335893 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_335888)[flat_tid_335848];
            }
            // red body
            {
                double defunc_1_op_res_335894 = x_335892 + x_335893;
                
                defunc_2_reduce_res_335666 = defunc_1_op_res_335894;
            }
        }
    }
    
  cleanup:
    {
        free(reduce_stage_1_tid_res_arr_mem_335888);
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_task_339085_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_task_339085_end -
                 futhark_mc_segred_task_339085_start;
        
        ctx->futhark_mc_segred_task_339085_runs[tid]++;
        ctx->futhark_mc_segred_task_339085_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segred_task_339085_iter[tid] += iterations;
    }
    if (err == 0) {
        *futhark_mc_task_339084->retval_defunc_2_reduce_res_335666 =
            defunc_2_reduce_res_335666;
    }
    return err;
}
static int futhark_mc_segmap_parloop_339078(void *args, int64_t start,
                                            int64_t end, int flat_tid_335633,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_339077
    *futhark_mc_segmap_parloop_struct_339077 =
    (struct futhark_mc_segmap_parloop_struct_339077 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_339077->ctx;
    uint64_t futhark_mc_segmap_parloop_339078_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339078_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_339077->free_n_292675;
    int64_t q_t_292679 =
            futhark_mc_segmap_parloop_struct_339077->free_q_t_292679;
    int64_t jump_t_292685 =
            futhark_mc_segmap_parloop_struct_339077->free_jump_t_292685;
    int64_t t_n_m_292839 =
            futhark_mc_segmap_parloop_struct_339077->free_t_n_m_292839;
    int64_t i_292846 = futhark_mc_segmap_parloop_struct_339077->free_i_292846;
    int64_t gtid_309500 =
            futhark_mc_segmap_parloop_struct_339077->free_gtid_309500;
    int64_t x_309505 = futhark_mc_segmap_parloop_struct_339077->free_x_309505;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_segmap_parloop_struct_339077->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_313143 = {.desc ="mem_313143", .mem =
                                  futhark_mc_segmap_parloop_struct_339077->free_mem_313143,
                                  .size =0, .references =NULL};
    struct memblock mem_313147 = {.desc ="mem_313147", .mem =
                                  futhark_mc_segmap_parloop_struct_339077->free_mem_313147,
                                  .size =0, .references =NULL};
    struct memblock mem_316457 = {.desc ="mem_316457", .mem =
                                  futhark_mc_segmap_parloop_struct_339077->free_mem_316457,
                                  .size =0, .references =NULL};
    struct memblock mem_316460 = {.desc ="mem_316460", .mem =
                                  futhark_mc_segmap_parloop_struct_339077->free_mem_316460,
                                  .size =0, .references =NULL};
    struct memblock mem_316463 = {.desc ="mem_316463", .mem =
                                  futhark_mc_segmap_parloop_struct_339077->free_mem_316463,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_335824 = start;
    
    for (; iter_335824 < end; iter_335824++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_335876 = t_n_m_292839;
        int64_t gtid_335634 = iter_335824;
        int64_t remnant_335877 = iter_335824 - gtid_335634;
        int64_t x_335635;
        
        x_335635 = ((int64_t *) mem_313143.mem)[gtid_309500 * t_n_m_292839 +
                                                gtid_335634];
        
        double x_335636;
        
        x_335636 = ((double *) mem_313147.mem)[gtid_309500 * t_n_m_292839 +
                                               gtid_335634];
        
        int64_t min_arg_335637 = mul64(jump_t_292685, gtid_335634);
        int64_t min_res_335638 = smin64(i_292846, min_arg_335637);
        int64_t defunc_0_g_res_335639 = add64((int64_t) 1, min_res_335638);
        double defunc_2_reduce_res_335640;
        int64_t flat_tid_335825 = (int64_t) 0;
        int32_t num_tasks_335878;
        
        defunc_2_reduce_res_335640 = 0.0;
        
        struct futhark_mc_task_339079 futhark_mc_task_339079;
        
        futhark_mc_task_339079.ctx = ctx;
        futhark_mc_task_339079.free_n_292675 = n_292675;
        futhark_mc_task_339079.free_gtid_309500 = gtid_309500;
        futhark_mc_task_339079.free_x_309505 = x_309505;
        futhark_mc_task_339079.free_mem_312636 = mem_312636.mem;
        futhark_mc_task_339079.free_mem_316457 = mem_316457.mem;
        futhark_mc_task_339079.free_x_335635 = x_335635;
        futhark_mc_task_339079.free_x_335636 = x_335636;
        futhark_mc_task_339079.free_defunc_0_g_res_335639 =
            defunc_0_g_res_335639;
        futhark_mc_task_339079.retval_defunc_2_reduce_res_335640 =
            &defunc_2_reduce_res_335640;
        
        struct scheduler_segop futhark_mc_task_339079_task;
        
        futhark_mc_task_339079_task.args = &futhark_mc_task_339079;
        futhark_mc_task_339079_task.top_level_fn =
            futhark_mc_segred_task_339080;
        futhark_mc_task_339079_task.name = "futhark_mc_segred_task_339080";
        futhark_mc_task_339079_task.iterations = q_t_292679;
        futhark_mc_task_339079_task.task_time =
            &ctx->futhark_mc_segred_task_339080_total_time;
        futhark_mc_task_339079_task.task_iter =
            &ctx->futhark_mc_segred_task_339080_total_iter;
        futhark_mc_task_339079_task.sched = STATIC;
        futhark_mc_task_339079_task.nested_fn = NULL;
        
        int futhark_mc_segred_task_339080_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_339079_task);
        
        if (futhark_mc_segred_task_339080_err != 0) {
            ;
            err = futhark_mc_segred_task_339080_err;
            goto cleanup;
        }
        
        double a_335664 = 2.220446049250313e-16 + defunc_2_reduce_res_335640;
        double a0_335665 = 1.0 / a_335664;
        double defunc_2_reduce_res_335666;
        int64_t flat_tid_335848 = (int64_t) 0;
        int32_t num_tasks_335887;
        
        defunc_2_reduce_res_335666 = 0.0;
        
        struct futhark_mc_task_339084 futhark_mc_task_339084;
        
        futhark_mc_task_339084.ctx = ctx;
        futhark_mc_task_339084.free_n_292675 = n_292675;
        futhark_mc_task_339084.free_gtid_309500 = gtid_309500;
        futhark_mc_task_339084.free_x_309505 = x_309505;
        futhark_mc_task_339084.free_mem_312636 = mem_312636.mem;
        futhark_mc_task_339084.free_mem_316457 = mem_316457.mem;
        futhark_mc_task_339084.free_mem_316460 = mem_316460.mem;
        futhark_mc_task_339084.free_x_335635 = x_335635;
        futhark_mc_task_339084.free_x_335636 = x_335636;
        futhark_mc_task_339084.free_defunc_0_g_res_335639 =
            defunc_0_g_res_335639;
        futhark_mc_task_339084.free_a0_335665 = a0_335665;
        futhark_mc_task_339084.retval_defunc_2_reduce_res_335666 =
            &defunc_2_reduce_res_335666;
        
        struct scheduler_segop futhark_mc_task_339084_task;
        
        futhark_mc_task_339084_task.args = &futhark_mc_task_339084;
        futhark_mc_task_339084_task.top_level_fn =
            futhark_mc_segred_task_339085;
        futhark_mc_task_339084_task.name = "futhark_mc_segred_task_339085";
        futhark_mc_task_339084_task.iterations = q_t_292679;
        futhark_mc_task_339084_task.task_time =
            &ctx->futhark_mc_segred_task_339085_total_time;
        futhark_mc_task_339084_task.task_iter =
            &ctx->futhark_mc_segred_task_339085_total_iter;
        futhark_mc_task_339084_task.sched = STATIC;
        futhark_mc_task_339084_task.nested_fn = NULL;
        
        int futhark_mc_segred_task_339085_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_339084_task);
        
        if (futhark_mc_segred_task_339085_err != 0) {
            ;
            err = futhark_mc_segred_task_339085_err;
            goto cleanup;
        }
        ((double *) mem_316463.mem)[gtid_335634] = defunc_2_reduce_res_335666;
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339078_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339078_end -
                 futhark_mc_segmap_parloop_339078_start;
        
        ctx->futhark_mc_segmap_parloop_339078_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_339078_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_339078_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_nested_task_339076(void *args, int64_t iterations,
                                         int tid, struct scheduler_info info)
{
    int err = 0;
    int flat_tid_335633 = tid;
    int num_tasks_335771 = info.nsubtasks;
    struct futhark_mc_task_339072 *futhark_mc_task_339072 =
                                  (struct futhark_mc_task_339072 *) args;
    struct futhark_context *ctx = futhark_mc_task_339072->ctx;
    uint64_t futhark_mc_segmap_nested_task_339076_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_nested_task_339076_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_339072->free_n_292675;
    int64_t q_t_292679 = futhark_mc_task_339072->free_q_t_292679;
    int64_t jump_t_292685 = futhark_mc_task_339072->free_jump_t_292685;
    int64_t t_n_m_292839 = futhark_mc_task_339072->free_t_n_m_292839;
    int64_t i_292846 = futhark_mc_task_339072->free_i_292846;
    int64_t gtid_309500 = futhark_mc_task_339072->free_gtid_309500;
    int64_t x_309505 = futhark_mc_task_339072->free_x_309505;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_task_339072->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_313143 = {.desc ="mem_313143", .mem =
                                  futhark_mc_task_339072->free_mem_313143,
                                  .size =0, .references =NULL};
    struct memblock mem_313147 = {.desc ="mem_313147", .mem =
                                  futhark_mc_task_339072->free_mem_313147,
                                  .size =0, .references =NULL};
    struct memblock mem_316457 = {.desc ="mem_316457", .mem =
                                  futhark_mc_task_339072->free_mem_316457,
                                  .size =0, .references =NULL};
    struct memblock mem_316460 = {.desc ="mem_316460", .mem =
                                  futhark_mc_task_339072->free_mem_316460,
                                  .size =0, .references =NULL};
    struct memblock mem_316463 = {.desc ="mem_316463", .mem =
                                  futhark_mc_task_339072->free_mem_316463,
                                  .size =0, .references =NULL};
    int64_t iter_335824;
    struct futhark_mc_segmap_parloop_struct_339077
    futhark_mc_segmap_parloop_struct_339077;
    
    futhark_mc_segmap_parloop_struct_339077.ctx = ctx;
    futhark_mc_segmap_parloop_struct_339077.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_339077.free_q_t_292679 = q_t_292679;
    futhark_mc_segmap_parloop_struct_339077.free_jump_t_292685 = jump_t_292685;
    futhark_mc_segmap_parloop_struct_339077.free_t_n_m_292839 = t_n_m_292839;
    futhark_mc_segmap_parloop_struct_339077.free_i_292846 = i_292846;
    futhark_mc_segmap_parloop_struct_339077.free_gtid_309500 = gtid_309500;
    futhark_mc_segmap_parloop_struct_339077.free_x_309505 = x_309505;
    futhark_mc_segmap_parloop_struct_339077.free_mem_312636 = mem_312636.mem;
    futhark_mc_segmap_parloop_struct_339077.free_mem_313143 = mem_313143.mem;
    futhark_mc_segmap_parloop_struct_339077.free_mem_313147 = mem_313147.mem;
    futhark_mc_segmap_parloop_struct_339077.free_mem_316457 = mem_316457.mem;
    futhark_mc_segmap_parloop_struct_339077.free_mem_316460 = mem_316460.mem;
    futhark_mc_segmap_parloop_struct_339077.free_mem_316463 = mem_316463.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_339078_task;
    
    futhark_mc_segmap_parloop_339078_task.name =
        "futhark_mc_segmap_parloop_339078";
    futhark_mc_segmap_parloop_339078_task.fn = futhark_mc_segmap_parloop_339078;
    futhark_mc_segmap_parloop_339078_task.args =
        &futhark_mc_segmap_parloop_struct_339077;
    futhark_mc_segmap_parloop_339078_task.iterations = iterations;
    futhark_mc_segmap_parloop_339078_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_339078_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339078_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_339078_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_339078_task);
    
    if (futhark_mc_segmap_parloop_339078_err != 0) {
        err = futhark_mc_segmap_parloop_339078_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339078_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339078_total_end -
                 futhark_mc_segmap_parloop_339078_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339078_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339078_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339078_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_nested_task_339076_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_nested_task_339076_end -
                 futhark_mc_segmap_nested_task_339076_start;
        
        ctx->futhark_mc_segmap_nested_task_339076_runs[tid]++;
        ctx->futhark_mc_segmap_nested_task_339076_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_nested_task_339076_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
static int futhark_mc_segmap_parloop_339059(void *args, int64_t start,
                                            int64_t end, int flat_tid_309499,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_339058
    *futhark_mc_segmap_parloop_struct_339058 =
    (struct futhark_mc_segmap_parloop_struct_339058 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_339058->ctx;
    uint64_t futhark_mc_segmap_parloop_339059_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339059_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_339058->free_n_292675;
    int64_t q_t_292679 =
            futhark_mc_segmap_parloop_struct_339058->free_q_t_292679;
    int64_t jump_t_292685 =
            futhark_mc_segmap_parloop_struct_339058->free_jump_t_292685;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_339058->free_partition_sizze_292766;
    int64_t t_n_m_292839 =
            futhark_mc_segmap_parloop_struct_339058->free_t_n_m_292839;
    int64_t i_292846 = futhark_mc_segmap_parloop_struct_339058->free_i_292846;
    struct memblock mem_312593 = {.desc ="mem_312593", .mem =
                                  futhark_mc_segmap_parloop_struct_339058->free_mem_312593,
                                  .size =0, .references =NULL};
    int64_t bytes_312598 =
            futhark_mc_segmap_parloop_struct_339058->free_bytes_312598;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_segmap_parloop_struct_339058->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_312639 = {.desc ="mem_312639", .mem =
                                  futhark_mc_segmap_parloop_struct_339058->free_mem_312639,
                                  .size =0, .references =NULL};
    int64_t bytes_313090 =
            futhark_mc_segmap_parloop_struct_339058->free_bytes_313090;
    struct memblock mem_313143 = {.desc ="mem_313143", .mem =
                                  futhark_mc_segmap_parloop_struct_339058->free_mem_313143,
                                  .size =0, .references =NULL};
    struct memblock mem_313147 = {.desc ="mem_313147", .mem =
                                  futhark_mc_segmap_parloop_struct_339058->free_mem_313147,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_segmap_parloop_struct_339058->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_segmap_parloop_struct_339058->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_segmap_parloop_struct_339058->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_segmap_parloop_struct_339058->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315656 = {.desc ="mem_315656", .mem =
                                  futhark_mc_segmap_parloop_struct_339058->free_mem_315656,
                                  .size =0, .references =NULL};
    struct memblock mem_316527 = {.desc ="mem_316527", .mem =
                                  futhark_mc_segmap_parloop_struct_339058->free_mem_316527,
                                  .size =0, .references =NULL};
    size_t mem_316454_cached_sizze_339060 = 0;
    unsigned char *mem_316454 = NULL;
    size_t mem_316457_cached_sizze_339061 = 0;
    unsigned char *mem_316457 = NULL;
    size_t mem_316460_cached_sizze_339062 = 0;
    unsigned char *mem_316460 = NULL;
    size_t mem_316463_cached_sizze_339063 = 0;
    unsigned char *mem_316463 = NULL;
    int64_t iterations = end - start;
    int64_t iter_335612 = start;
    
    if (mem_316454_cached_sizze_339060 < (size_t) bytes_312598) {
        mem_316454 = realloc(mem_316454, bytes_312598);
        mem_316454_cached_sizze_339060 = bytes_312598;
    }
    if (mem_316457_cached_sizze_339061 < (size_t) bytes_312598) {
        mem_316457 = realloc(mem_316457, bytes_312598);
        mem_316457_cached_sizze_339061 = bytes_312598;
    }
    if (mem_316460_cached_sizze_339062 < (size_t) bytes_312598) {
        mem_316460 = realloc(mem_316460, bytes_312598);
        mem_316460_cached_sizze_339062 = bytes_312598;
    }
    if (mem_316463_cached_sizze_339063 < (size_t) bytes_313090) {
        mem_316463 = realloc(mem_316463, bytes_313090);
        mem_316463_cached_sizze_339063 = bytes_313090;
    }
    for (; iter_335612 < end; iter_335612++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_335753 = partition_sizze_292766;
        int64_t gtid_309500 = iter_335612;
        int64_t remnant_335754 = iter_335612 - gtid_309500;
        int64_t x_309505;
        
        x_309505 = ((int64_t *) mem_312639.mem)[gtid_309500];
        
        int64_t flat_tid_335613 = (int64_t) 0;
        int32_t num_tasks_335755;
        struct futhark_mc_task_339064 futhark_mc_task_339064;
        
        futhark_mc_task_339064.ctx = ctx;
        futhark_mc_task_339064.free_n_292675 = n_292675;
        futhark_mc_task_339064.free_gtid_309500 = gtid_309500;
        futhark_mc_task_339064.free_mem_312593 = mem_312593.mem;
        futhark_mc_task_339064.free_mem_315656 = mem_315656.mem;
        futhark_mc_task_339064.free_mem_316454 = mem_316454;
        
        struct scheduler_segop futhark_mc_task_339064_task;
        
        futhark_mc_task_339064_task.args = &futhark_mc_task_339064;
        futhark_mc_task_339064_task.top_level_fn =
            futhark_mc_segmap_task_339065;
        futhark_mc_task_339064_task.name = "futhark_mc_segmap_task_339065";
        futhark_mc_task_339064_task.iterations = n_292675;
        futhark_mc_task_339064_task.task_time =
            &ctx->futhark_mc_segmap_task_339065_total_time;
        futhark_mc_task_339064_task.task_iter =
            &ctx->futhark_mc_segmap_task_339065_total_iter;
        futhark_mc_task_339064_task.sched = STATIC;
        futhark_mc_task_339064_task.nested_fn = NULL;
        
        int futhark_mc_segmap_task_339065_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_339064_task);
        
        if (futhark_mc_segmap_task_339065_err != 0) {
            ;
            err = futhark_mc_segmap_task_339065_err;
            goto cleanup;
        }
        
        int64_t flat_tid_335619 = (int64_t) 0;
        int32_t num_tasks_335759;
        struct futhark_mc_task_339068 futhark_mc_task_339068;
        
        futhark_mc_task_339068.ctx = ctx;
        futhark_mc_task_339068.free_n_292675 = n_292675;
        futhark_mc_task_339068.free_gtid_309500 = gtid_309500;
        futhark_mc_task_339068.free_mem_312636 = mem_312636.mem;
        futhark_mc_task_339068.free_ctx_param_ext_313174 = ctx_param_ext_313174;
        futhark_mc_task_339068.free_ctx_param_ext_313175 = ctx_param_ext_313175;
        futhark_mc_task_339068.free_ctx_param_ext_313177 = ctx_param_ext_313177;
        futhark_mc_task_339068.free_mem_param_313179 = mem_param_313179.mem;
        futhark_mc_task_339068.free_mem_316454 = mem_316454;
        futhark_mc_task_339068.free_mem_316457 = mem_316457;
        futhark_mc_task_339068.free_mem_316460 = mem_316460;
        
        struct scheduler_segop futhark_mc_task_339068_task;
        
        futhark_mc_task_339068_task.args = &futhark_mc_task_339068;
        futhark_mc_task_339068_task.top_level_fn =
            futhark_mc_segmap_task_339069;
        futhark_mc_task_339068_task.name = "futhark_mc_segmap_task_339069";
        futhark_mc_task_339068_task.iterations = n_292675;
        futhark_mc_task_339068_task.task_time =
            &ctx->futhark_mc_segmap_task_339069_total_time;
        futhark_mc_task_339068_task.task_iter =
            &ctx->futhark_mc_segmap_task_339069_total_iter;
        futhark_mc_task_339068_task.sched = STATIC;
        futhark_mc_task_339068_task.nested_fn = NULL;
        
        int futhark_mc_segmap_task_339069_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_339068_task);
        
        if (futhark_mc_segmap_task_339069_err != 0) {
            ;
            err = futhark_mc_segmap_task_339069_err;
            goto cleanup;
        }
        
        int64_t flat_tid_335695 = (int64_t) 0;
        int32_t num_tasks_335771;
        int64_t flat_tid_335633 = (int64_t) 0;
        struct futhark_mc_task_339072 futhark_mc_task_339072;
        
        futhark_mc_task_339072.ctx = ctx;
        futhark_mc_task_339072.free_n_292675 = n_292675;
        futhark_mc_task_339072.free_q_t_292679 = q_t_292679;
        futhark_mc_task_339072.free_jump_t_292685 = jump_t_292685;
        futhark_mc_task_339072.free_t_n_m_292839 = t_n_m_292839;
        futhark_mc_task_339072.free_i_292846 = i_292846;
        futhark_mc_task_339072.free_gtid_309500 = gtid_309500;
        futhark_mc_task_339072.free_x_309505 = x_309505;
        futhark_mc_task_339072.free_mem_312636 = mem_312636.mem;
        futhark_mc_task_339072.free_mem_313143 = mem_313143.mem;
        futhark_mc_task_339072.free_mem_313147 = mem_313147.mem;
        futhark_mc_task_339072.free_mem_316457 = mem_316457;
        futhark_mc_task_339072.free_mem_316460 = mem_316460;
        futhark_mc_task_339072.free_mem_316463 = mem_316463;
        
        struct scheduler_segop futhark_mc_task_339072_task;
        
        futhark_mc_task_339072_task.args = &futhark_mc_task_339072;
        futhark_mc_task_339072_task.top_level_fn =
            futhark_mc_segmap_task_339073;
        futhark_mc_task_339072_task.name = "futhark_mc_segmap_task_339073";
        futhark_mc_task_339072_task.iterations = t_n_m_292839;
        futhark_mc_task_339072_task.task_time =
            &ctx->futhark_mc_segmap_task_339073_total_time;
        futhark_mc_task_339072_task.task_iter =
            &ctx->futhark_mc_segmap_task_339073_total_iter;
        futhark_mc_task_339072_task.sched = STATIC;
        futhark_mc_task_339072_task.nested_fn =
            futhark_mc_segmap_nested_task_339076;
        
        int futhark_mc_segmap_task_339073_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_339072_task);
        
        if (futhark_mc_segmap_task_339073_err != 0) {
            ;
            err = futhark_mc_segmap_task_339073_err;
            goto cleanup;
        }
        if (t_n_m_292839 * (int64_t) 8 > 0)
            memmove(mem_316527.mem + gtid_309500 * t_n_m_292839 * (int64_t) 8,
                    mem_316463 + (int64_t) 0, t_n_m_292839 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_316454);
    free(mem_316457);
    free(mem_316460);
    free(mem_316463);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339059_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339059_end -
                 futhark_mc_segmap_parloop_339059_start;
        
        ctx->futhark_mc_segmap_parloop_339059_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_339059_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_339059_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_nested_task_339057(void *args, int64_t iterations,
                                         int tid, struct scheduler_info info)
{
    int err = 0;
    int flat_tid_309499 = tid;
    int num_tasks_335519 = info.nsubtasks;
    struct futhark_mc_task_339049 *futhark_mc_task_339049 =
                                  (struct futhark_mc_task_339049 *) args;
    struct futhark_context *ctx = futhark_mc_task_339049->ctx;
    uint64_t futhark_mc_segmap_nested_task_339057_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_nested_task_339057_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_339049->free_n_292675;
    int64_t q_t_292679 = futhark_mc_task_339049->free_q_t_292679;
    int64_t jump_t_292685 = futhark_mc_task_339049->free_jump_t_292685;
    int64_t partition_sizze_292766 =
            futhark_mc_task_339049->free_partition_sizze_292766;
    int64_t t_n_m_292839 = futhark_mc_task_339049->free_t_n_m_292839;
    int64_t i_292846 = futhark_mc_task_339049->free_i_292846;
    struct memblock mem_312593 = {.desc ="mem_312593", .mem =
                                  futhark_mc_task_339049->free_mem_312593,
                                  .size =0, .references =NULL};
    int64_t bytes_312598 = futhark_mc_task_339049->free_bytes_312598;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_task_339049->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_312639 = {.desc ="mem_312639", .mem =
                                  futhark_mc_task_339049->free_mem_312639,
                                  .size =0, .references =NULL};
    int64_t bytes_313090 = futhark_mc_task_339049->free_bytes_313090;
    struct memblock mem_313143 = {.desc ="mem_313143", .mem =
                                  futhark_mc_task_339049->free_mem_313143,
                                  .size =0, .references =NULL};
    struct memblock mem_313147 = {.desc ="mem_313147", .mem =
                                  futhark_mc_task_339049->free_mem_313147,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_task_339049->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_task_339049->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_task_339049->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_task_339049->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315656 = {.desc ="mem_315656", .mem =
                                  futhark_mc_task_339049->free_mem_315656,
                                  .size =0, .references =NULL};
    struct memblock mem_316527 = {.desc ="mem_316527", .mem =
                                  futhark_mc_task_339049->free_mem_316527,
                                  .size =0, .references =NULL};
    int64_t iter_335612;
    struct futhark_mc_segmap_parloop_struct_339058
    futhark_mc_segmap_parloop_struct_339058;
    
    futhark_mc_segmap_parloop_struct_339058.ctx = ctx;
    futhark_mc_segmap_parloop_struct_339058.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_339058.free_q_t_292679 = q_t_292679;
    futhark_mc_segmap_parloop_struct_339058.free_jump_t_292685 = jump_t_292685;
    futhark_mc_segmap_parloop_struct_339058.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_339058.free_t_n_m_292839 = t_n_m_292839;
    futhark_mc_segmap_parloop_struct_339058.free_i_292846 = i_292846;
    futhark_mc_segmap_parloop_struct_339058.free_mem_312593 = mem_312593.mem;
    futhark_mc_segmap_parloop_struct_339058.free_bytes_312598 = bytes_312598;
    futhark_mc_segmap_parloop_struct_339058.free_mem_312636 = mem_312636.mem;
    futhark_mc_segmap_parloop_struct_339058.free_mem_312639 = mem_312639.mem;
    futhark_mc_segmap_parloop_struct_339058.free_bytes_313090 = bytes_313090;
    futhark_mc_segmap_parloop_struct_339058.free_mem_313143 = mem_313143.mem;
    futhark_mc_segmap_parloop_struct_339058.free_mem_313147 = mem_313147.mem;
    futhark_mc_segmap_parloop_struct_339058.free_ctx_param_ext_313174 =
        ctx_param_ext_313174;
    futhark_mc_segmap_parloop_struct_339058.free_ctx_param_ext_313175 =
        ctx_param_ext_313175;
    futhark_mc_segmap_parloop_struct_339058.free_ctx_param_ext_313177 =
        ctx_param_ext_313177;
    futhark_mc_segmap_parloop_struct_339058.free_mem_param_313179 =
        mem_param_313179.mem;
    futhark_mc_segmap_parloop_struct_339058.free_mem_315656 = mem_315656.mem;
    futhark_mc_segmap_parloop_struct_339058.free_mem_316527 = mem_316527.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_339059_task;
    
    futhark_mc_segmap_parloop_339059_task.name =
        "futhark_mc_segmap_parloop_339059";
    futhark_mc_segmap_parloop_339059_task.fn = futhark_mc_segmap_parloop_339059;
    futhark_mc_segmap_parloop_339059_task.args =
        &futhark_mc_segmap_parloop_struct_339058;
    futhark_mc_segmap_parloop_339059_task.iterations = iterations;
    futhark_mc_segmap_parloop_339059_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_339059_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339059_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_339059_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_339059_task);
    
    if (futhark_mc_segmap_parloop_339059_err != 0) {
        err = futhark_mc_segmap_parloop_339059_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339059_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339059_total_end -
                 futhark_mc_segmap_parloop_339059_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339059_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339059_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339059_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_nested_task_339057_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_nested_task_339057_end -
                 futhark_mc_segmap_nested_task_339057_start;
        
        ctx->futhark_mc_segmap_nested_task_339057_runs[tid]++;
        ctx->futhark_mc_segmap_nested_task_339057_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_nested_task_339057_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_task_339089 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_t_292679;
    int64_t free_jump_t_292685;
    int64_t free_partition_sizze_292766;
    int64_t free_t_n_m_292839;
    int64_t free_i_292846;
    unsigned char *free_mem_312593;
    int64_t free_bytes_312598;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_312639;
    int64_t free_bytes_313090;
    unsigned char *free_mem_313143;
    unsigned char *free_mem_313147;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315656;
    unsigned char *free_mem_316621;
    unsigned char *free_mem_316625;
};
struct futhark_mc_segmap_parloop_struct_339091 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_t_292679;
    int64_t free_jump_t_292685;
    int64_t free_partition_sizze_292766;
    int64_t free_t_n_m_292839;
    int64_t free_i_292846;
    unsigned char *free_mem_312593;
    int64_t free_bytes_312598;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_312639;
    int64_t free_bytes_313090;
    unsigned char *free_mem_313143;
    unsigned char *free_mem_313147;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315656;
    unsigned char *free_mem_316621;
    unsigned char *free_mem_316625;
};
static int futhark_mc_segmap_parloop_339092(void *args, int64_t start,
                                            int64_t end, int flat_tid_309658,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_339091
    *futhark_mc_segmap_parloop_struct_339091 =
    (struct futhark_mc_segmap_parloop_struct_339091 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_339091->ctx;
    uint64_t futhark_mc_segmap_parloop_339092_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339092_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_339091->free_n_292675;
    int64_t q_t_292679 =
            futhark_mc_segmap_parloop_struct_339091->free_q_t_292679;
    int64_t jump_t_292685 =
            futhark_mc_segmap_parloop_struct_339091->free_jump_t_292685;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_339091->free_partition_sizze_292766;
    int64_t t_n_m_292839 =
            futhark_mc_segmap_parloop_struct_339091->free_t_n_m_292839;
    int64_t i_292846 = futhark_mc_segmap_parloop_struct_339091->free_i_292846;
    struct memblock mem_312593 = {.desc ="mem_312593", .mem =
                                  futhark_mc_segmap_parloop_struct_339091->free_mem_312593,
                                  .size =0, .references =NULL};
    int64_t bytes_312598 =
            futhark_mc_segmap_parloop_struct_339091->free_bytes_312598;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_segmap_parloop_struct_339091->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_312639 = {.desc ="mem_312639", .mem =
                                  futhark_mc_segmap_parloop_struct_339091->free_mem_312639,
                                  .size =0, .references =NULL};
    int64_t bytes_313090 =
            futhark_mc_segmap_parloop_struct_339091->free_bytes_313090;
    struct memblock mem_313143 = {.desc ="mem_313143", .mem =
                                  futhark_mc_segmap_parloop_struct_339091->free_mem_313143,
                                  .size =0, .references =NULL};
    struct memblock mem_313147 = {.desc ="mem_313147", .mem =
                                  futhark_mc_segmap_parloop_struct_339091->free_mem_313147,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_segmap_parloop_struct_339091->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_segmap_parloop_struct_339091->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_segmap_parloop_struct_339091->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_segmap_parloop_struct_339091->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315656 = {.desc ="mem_315656", .mem =
                                  futhark_mc_segmap_parloop_struct_339091->free_mem_315656,
                                  .size =0, .references =NULL};
    struct memblock mem_316621 = {.desc ="mem_316621", .mem =
                                  futhark_mc_segmap_parloop_struct_339091->free_mem_316621,
                                  .size =0, .references =NULL};
    struct memblock mem_316625 = {.desc ="mem_316625", .mem =
                                  futhark_mc_segmap_parloop_struct_339091->free_mem_316625,
                                  .size =0, .references =NULL};
    size_t mem_316545_cached_sizze_339093 = 0;
    unsigned char *mem_316545 = NULL;
    size_t mem_316560_cached_sizze_339094 = 0;
    unsigned char *mem_316560 = NULL;
    size_t mem_316563_cached_sizze_339095 = 0;
    unsigned char *mem_316563 = NULL;
    size_t mem_316590_cached_sizze_339096 = 0;
    unsigned char *mem_316590 = NULL;
    size_t mem_316593_cached_sizze_339097 = 0;
    unsigned char *mem_316593 = NULL;
    int64_t iterations = end - start;
    int64_t iter_335897 = start;
    
    if (mem_316545_cached_sizze_339093 < (size_t) bytes_312598) {
        mem_316545 = realloc(mem_316545, bytes_312598);
        mem_316545_cached_sizze_339093 = bytes_312598;
    }
    if (mem_316560_cached_sizze_339094 < (size_t) bytes_312598) {
        mem_316560 = realloc(mem_316560, bytes_312598);
        mem_316560_cached_sizze_339094 = bytes_312598;
    }
    if (mem_316563_cached_sizze_339095 < (size_t) bytes_312598) {
        mem_316563 = realloc(mem_316563, bytes_312598);
        mem_316563_cached_sizze_339095 = bytes_312598;
    }
    if (mem_316590_cached_sizze_339096 < (size_t) bytes_313090) {
        mem_316590 = realloc(mem_316590, bytes_313090);
        mem_316590_cached_sizze_339096 = bytes_313090;
    }
    if (mem_316593_cached_sizze_339097 < (size_t) bytes_313090) {
        mem_316593 = realloc(mem_316593, bytes_313090);
        mem_316593_cached_sizze_339097 = bytes_313090;
    }
    for (; iter_335897 < end; iter_335897++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_336010 = partition_sizze_292766;
        int64_t gtid_309659 = iter_335897;
        int64_t remnant_336011 = iter_335897 - gtid_309659;
        int64_t x_296683;
        
        x_296683 = ((int64_t *) mem_312639.mem)[gtid_309659];
        for (int64_t i_335898 = 0; i_335898 < n_292675; i_335898++) {
            float x_335900;
            
            x_335900 = ((float *) mem_312593.mem)[gtid_309659 * n_292675 +
                                                  i_335898];
            
            double x_335901;
            
            x_335901 = ((double *) mem_315656.mem)[gtid_309659 * n_292675 +
                                                   i_335898];
            
            double f32_res_335902 = fpconv_f32_f64(x_335900);
            double defunc_1_f_res_335903 = f32_res_335902 - x_335901;
            
            ((double *) mem_316545)[i_335898] = defunc_1_f_res_335903;
        }
        for (int64_t i_335905 = 0; i_335905 < n_292675; i_335905++) {
            int64_t x_335908;
            
            x_335908 = ((int64_t *) mem_312636.mem)[gtid_309659 * n_292675 +
                                                    i_335905];
            
            bool cond_335909 = sle64((int64_t) 0, x_335908);
            double defunc_0_f_res_335910;
            
            if (cond_335909) {
                bool y_335911 = slt64(x_335908, n_292675);
                bool bounds_check_335912 = cond_335909 && y_335911;
                bool index_certs_335913;
                
                if (!bounds_check_335912) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [", (long long) x_335908,
                                  "] out of bounds for array of shape [",
                                  (long long) n_292675, "].",
                                  "-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:45:43-70\n   #3  stl.fut:285:33-58\n   #4  /prelude/soacs.fut:75:22-28\n   #5  /prelude/soacs.fut:75:3-45\n   #6  stl.fut:283:13-288:41\n   #7  stl.fut:419:61-435:77\n   #8  stl.fut:463:3-479:36\n   #9  stl.fut:445:1-479:36\n");
                    err = FUTHARK_PROGRAM_ERROR;
                    goto cleanup;
                }
                
                double defunc_0_f_res_t_res_335914;
                
                defunc_0_f_res_t_res_335914 = ((double *) mem_316545)[x_335908];
                defunc_0_f_res_335910 = defunc_0_f_res_t_res_335914;
            } else {
                defunc_0_f_res_335910 = 0.0;
            }
            
            double defunc_0_f_res_335915;
            
            if (cond_335909) {
                bool y_335916 = slt64(x_335908, n_292675);
                bool bounds_check_335917 = cond_335909 && y_335916;
                bool index_certs_335918;
                
                if (!bounds_check_335917) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [", (long long) x_335908,
                                  "] out of bounds for array of shape [",
                                  (long long) n_292675, "].",
                                  "-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:45:43-70\n   #3  stl.fut:286:33-64\n   #4  /prelude/soacs.fut:75:22-28\n   #5  /prelude/soacs.fut:75:3-45\n   #6  stl.fut:283:13-288:41\n   #7  stl.fut:419:61-435:77\n   #8  stl.fut:463:3-479:36\n   #9  stl.fut:445:1-479:36\n");
                    err = FUTHARK_PROGRAM_ERROR;
                    goto cleanup;
                }
                
                double defunc_0_f_res_t_res_335919;
                
                defunc_0_f_res_t_res_335919 =
                    ((double *) mem_param_313179.mem)[ctx_param_ext_313174 +
                                                      (gtid_309659 *
                                                       ctx_param_ext_313175 +
                                                       x_335908 *
                                                       ctx_param_ext_313177)];
                defunc_0_f_res_335915 = defunc_0_f_res_t_res_335919;
            } else {
                defunc_0_f_res_335915 = 0.0;
            }
            ((double *) mem_316560)[i_335905] = defunc_0_f_res_335915;
            ((double *) mem_316563)[i_335905] = defunc_0_f_res_335910;
        }
        for (int64_t i_335922 = 0; i_335922 < t_n_m_292839; i_335922++) {
            int64_t x_335925;
            
            x_335925 = ((int64_t *) mem_313143.mem)[gtid_309659 * t_n_m_292839 +
                                                    i_335922];
            
            double x_335926;
            
            x_335926 = ((double *) mem_313147.mem)[gtid_309659 * t_n_m_292839 +
                                                   i_335922];
            
            int64_t min_arg_335927 = mul64(jump_t_292685, i_335922);
            int64_t min_res_335928 = smin64(i_292846, min_arg_335927);
            int64_t defunc_0_g_res_335929 = add64((int64_t) 1, min_res_335928);
            double defunc_2_reduce_res_335930;
            double defunc_2_reduce_res_335931;
            double defunc_2_reduce_res_335932;
            double redout_335934;
            double redout_335935;
            double redout_335936;
            
            redout_335934 = 0.0;
            redout_335935 = 0.0;
            redout_335936 = 0.0;
            for (int64_t i_335933 = 0; i_335933 < q_t_292679; i_335933++) {
                bool cond_335937 = sle64(x_296683, i_335933);
                int64_t defunc_0_f_res_335938;
                
                if (cond_335937) {
                    defunc_0_f_res_335938 = (int64_t) 0;
                } else {
                    int64_t i_335939 = add64(x_335925, i_335933);
                    int64_t defunc_0_add_arg_335940;
                    
                    defunc_0_add_arg_335940 =
                        ((int64_t *) mem_312636.mem)[gtid_309659 * n_292675 +
                                                     i_335939];
                    
                    int64_t defunc_1_add_res_335941 = add64((int64_t) 1,
                                                            defunc_0_add_arg_335940);
                    
                    defunc_0_f_res_335938 = defunc_1_add_res_335941;
                }
                
                double defunc_0_f_res_335942;
                
                if (cond_335937) {
                    defunc_0_f_res_335942 = 0.0;
                } else {
                    int64_t i_335943 = add64(x_335925, i_335933);
                    double defunc_0_add_arg_335944;
                    
                    defunc_0_add_arg_335944 = ((double *) mem_316560)[i_335943];
                    defunc_0_f_res_335942 = defunc_0_add_arg_335944;
                }
                
                int64_t binop_p_335945 = sub64(defunc_0_f_res_335938,
                                               defunc_0_g_res_335929);
                double defunc_0_f_res_335946 = sitofp_i64_f64(binop_p_335945);
                double abs_res_335947 = fabs(defunc_0_f_res_335946);
                double tmp1_335948 = abs_res_335947 / x_335926;
                double x_335949 = tmp1_335948 * tmp1_335948;
                double y_335950 = tmp1_335948 * x_335949;
                double tmp2_335951 = 1.0 - y_335950;
                double x_335952 = tmp2_335951 * tmp2_335951;
                double tmp3_335953 = tmp2_335951 * x_335952;
                double w_j_335954 = defunc_0_f_res_335942 * tmp3_335953;
                double xw_j_335955 = defunc_0_f_res_335946 * w_j_335954;
                double x2w_j_335956 = defunc_0_f_res_335946 * xw_j_335955;
                double defunc_1_op_res_335957 = w_j_335954 + redout_335934;
                double defunc_1_op_res_335958 = xw_j_335955 + redout_335935;
                double defunc_1_op_res_335959 = x2w_j_335956 + redout_335936;
                double redout_tmp_336017 = defunc_1_op_res_335957;
                double redout_tmp_336018 = defunc_1_op_res_335958;
                double redout_tmp_336019 = defunc_1_op_res_335959;
                
                redout_335934 = redout_tmp_336017;
                redout_335935 = redout_tmp_336018;
                redout_335936 = redout_tmp_336019;
            }
            defunc_2_reduce_res_335930 = redout_335934;
            defunc_2_reduce_res_335931 = redout_335935;
            defunc_2_reduce_res_335932 = redout_335936;
            
            double a_335960 = 2.220446049250313e-16 +
                   defunc_2_reduce_res_335930;
            double b_335961 = 2.220446049250313e-16 +
                   defunc_2_reduce_res_335931;
            double c_335962 = 2.220446049250313e-16 +
                   defunc_2_reduce_res_335932;
            double x_335963 = a_335960 * c_335962;
            double y_335964 = b_335961 * b_335961;
            double y_335965 = x_335963 - y_335964;
            double det1_335966 = 1.0 / y_335965;
            double a11_335967 = c_335962 * det1_335966;
            double x_335968 = 0.0 - b_335961;
            double b11_335969 = det1_335966 * x_335968;
            double c11_335970 = a_335960 * det1_335966;
            double defunc_2_reduce_res_335971;
            double defunc_2_reduce_res_335972;
            double redout_335974;
            double redout_335975;
            
            redout_335974 = 0.0;
            redout_335975 = 0.0;
            for (int64_t i_335973 = 0; i_335973 < q_t_292679; i_335973++) {
                bool cond_335976 = sle64(x_296683, i_335973);
                int64_t defunc_0_f_res_335977;
                
                if (cond_335976) {
                    defunc_0_f_res_335977 = (int64_t) 0;
                } else {
                    int64_t i_335978 = add64(x_335925, i_335973);
                    int64_t defunc_0_add_arg_335979;
                    
                    defunc_0_add_arg_335979 =
                        ((int64_t *) mem_312636.mem)[gtid_309659 * n_292675 +
                                                     i_335978];
                    
                    int64_t defunc_1_add_res_335980 = add64((int64_t) 1,
                                                            defunc_0_add_arg_335979);
                    
                    defunc_0_f_res_335977 = defunc_1_add_res_335980;
                }
                
                double defunc_0_f_res_335981;
                
                if (cond_335976) {
                    defunc_0_f_res_335981 = 0.0;
                } else {
                    int64_t i_335982 = add64(x_335925, i_335973);
                    double defunc_0_add_arg_335983;
                    
                    defunc_0_add_arg_335983 = ((double *) mem_316560)[i_335982];
                    defunc_0_f_res_335981 = defunc_0_add_arg_335983;
                }
                
                int64_t binop_p_335984 = sub64(defunc_0_f_res_335977,
                                               defunc_0_g_res_335929);
                double defunc_0_f_res_335985 = sitofp_i64_f64(binop_p_335984);
                double abs_res_335986 = fabs(defunc_0_f_res_335985);
                double tmp1_335987 = abs_res_335986 / x_335926;
                double x_335988 = tmp1_335987 * tmp1_335987;
                double y_335989 = tmp1_335987 * x_335988;
                double tmp2_335990 = 1.0 - y_335989;
                double x_335991 = tmp2_335990 * tmp2_335990;
                double tmp3_335992 = tmp2_335990 * x_335991;
                double tmp4_335993 = defunc_0_f_res_335981 * tmp3_335992;
                double defunc_1_f_res_335994 = defunc_0_f_res_335985 *
                       tmp4_335993;
                double defunc_0_f_res_335995;
                
                if (cond_335976) {
                    defunc_0_f_res_335995 = 0.0;
                } else {
                    int64_t i_335996 = add64(x_335925, i_335973);
                    double defunc_0_add_arg_335997;
                    
                    defunc_0_add_arg_335997 = ((double *) mem_316563)[i_335996];
                    defunc_0_f_res_335995 = defunc_0_add_arg_335997;
                }
                
                double x_335998 = a11_335967 * tmp4_335993;
                double y_335999 = b11_335969 * defunc_1_f_res_335994;
                double x_336000 = x_335998 + y_335999;
                double defunc_9_fit_fun_res_336001 = defunc_0_f_res_335995 *
                       x_336000;
                double x_336002 = b11_335969 * tmp4_335993;
                double y_336003 = c11_335970 * defunc_1_f_res_335994;
                double x_336004 = x_336002 + y_336003;
                double defunc_9_slope_fun_res_336005 = defunc_0_f_res_335995 *
                       x_336004;
                double defunc_1_op_res_336006 = defunc_9_fit_fun_res_336001 +
                       redout_335974;
                double defunc_1_op_res_336007 = defunc_9_slope_fun_res_336005 +
                       redout_335975;
                double redout_tmp_336020 = defunc_1_op_res_336006;
                double redout_tmp_336021 = defunc_1_op_res_336007;
                
                redout_335974 = redout_tmp_336020;
                redout_335975 = redout_tmp_336021;
            }
            defunc_2_reduce_res_335971 = redout_335974;
            defunc_2_reduce_res_335972 = redout_335975;
            ((double *) mem_316590)[i_335922] = defunc_2_reduce_res_335971;
            ((double *) mem_316593)[i_335922] = defunc_2_reduce_res_335972;
        }
        if (t_n_m_292839 * (int64_t) 8 > 0)
            memmove(mem_316621.mem + gtid_309659 * t_n_m_292839 * (int64_t) 8,
                    mem_316590 + (int64_t) 0, t_n_m_292839 * (int64_t) 8);
        if (t_n_m_292839 * (int64_t) 8 > 0)
            memmove(mem_316625.mem + gtid_309659 * t_n_m_292839 * (int64_t) 8,
                    mem_316593 + (int64_t) 0, t_n_m_292839 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_316545);
    free(mem_316560);
    free(mem_316563);
    free(mem_316590);
    free(mem_316593);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339092_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339092_end -
                 futhark_mc_segmap_parloop_339092_start;
        
        ctx->futhark_mc_segmap_parloop_339092_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_339092_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_339092_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_339090(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_309658 = tid;
    int num_tasks_335896 = info.nsubtasks;
    struct futhark_mc_task_339089 *futhark_mc_task_339089 =
                                  (struct futhark_mc_task_339089 *) args;
    struct futhark_context *ctx = futhark_mc_task_339089->ctx;
    uint64_t futhark_mc_segmap_task_339090_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_339090_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_339089->free_n_292675;
    int64_t q_t_292679 = futhark_mc_task_339089->free_q_t_292679;
    int64_t jump_t_292685 = futhark_mc_task_339089->free_jump_t_292685;
    int64_t partition_sizze_292766 =
            futhark_mc_task_339089->free_partition_sizze_292766;
    int64_t t_n_m_292839 = futhark_mc_task_339089->free_t_n_m_292839;
    int64_t i_292846 = futhark_mc_task_339089->free_i_292846;
    struct memblock mem_312593 = {.desc ="mem_312593", .mem =
                                  futhark_mc_task_339089->free_mem_312593,
                                  .size =0, .references =NULL};
    int64_t bytes_312598 = futhark_mc_task_339089->free_bytes_312598;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_task_339089->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_312639 = {.desc ="mem_312639", .mem =
                                  futhark_mc_task_339089->free_mem_312639,
                                  .size =0, .references =NULL};
    int64_t bytes_313090 = futhark_mc_task_339089->free_bytes_313090;
    struct memblock mem_313143 = {.desc ="mem_313143", .mem =
                                  futhark_mc_task_339089->free_mem_313143,
                                  .size =0, .references =NULL};
    struct memblock mem_313147 = {.desc ="mem_313147", .mem =
                                  futhark_mc_task_339089->free_mem_313147,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_task_339089->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_task_339089->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_task_339089->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_task_339089->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315656 = {.desc ="mem_315656", .mem =
                                  futhark_mc_task_339089->free_mem_315656,
                                  .size =0, .references =NULL};
    struct memblock mem_316621 = {.desc ="mem_316621", .mem =
                                  futhark_mc_task_339089->free_mem_316621,
                                  .size =0, .references =NULL};
    struct memblock mem_316625 = {.desc ="mem_316625", .mem =
                                  futhark_mc_task_339089->free_mem_316625,
                                  .size =0, .references =NULL};
    int64_t iter_335897;
    struct futhark_mc_segmap_parloop_struct_339091
    futhark_mc_segmap_parloop_struct_339091;
    
    futhark_mc_segmap_parloop_struct_339091.ctx = ctx;
    futhark_mc_segmap_parloop_struct_339091.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_339091.free_q_t_292679 = q_t_292679;
    futhark_mc_segmap_parloop_struct_339091.free_jump_t_292685 = jump_t_292685;
    futhark_mc_segmap_parloop_struct_339091.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_339091.free_t_n_m_292839 = t_n_m_292839;
    futhark_mc_segmap_parloop_struct_339091.free_i_292846 = i_292846;
    futhark_mc_segmap_parloop_struct_339091.free_mem_312593 = mem_312593.mem;
    futhark_mc_segmap_parloop_struct_339091.free_bytes_312598 = bytes_312598;
    futhark_mc_segmap_parloop_struct_339091.free_mem_312636 = mem_312636.mem;
    futhark_mc_segmap_parloop_struct_339091.free_mem_312639 = mem_312639.mem;
    futhark_mc_segmap_parloop_struct_339091.free_bytes_313090 = bytes_313090;
    futhark_mc_segmap_parloop_struct_339091.free_mem_313143 = mem_313143.mem;
    futhark_mc_segmap_parloop_struct_339091.free_mem_313147 = mem_313147.mem;
    futhark_mc_segmap_parloop_struct_339091.free_ctx_param_ext_313174 =
        ctx_param_ext_313174;
    futhark_mc_segmap_parloop_struct_339091.free_ctx_param_ext_313175 =
        ctx_param_ext_313175;
    futhark_mc_segmap_parloop_struct_339091.free_ctx_param_ext_313177 =
        ctx_param_ext_313177;
    futhark_mc_segmap_parloop_struct_339091.free_mem_param_313179 =
        mem_param_313179.mem;
    futhark_mc_segmap_parloop_struct_339091.free_mem_315656 = mem_315656.mem;
    futhark_mc_segmap_parloop_struct_339091.free_mem_316621 = mem_316621.mem;
    futhark_mc_segmap_parloop_struct_339091.free_mem_316625 = mem_316625.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_339092_task;
    
    futhark_mc_segmap_parloop_339092_task.name =
        "futhark_mc_segmap_parloop_339092";
    futhark_mc_segmap_parloop_339092_task.fn = futhark_mc_segmap_parloop_339092;
    futhark_mc_segmap_parloop_339092_task.args =
        &futhark_mc_segmap_parloop_struct_339091;
    futhark_mc_segmap_parloop_339092_task.iterations = iterations;
    futhark_mc_segmap_parloop_339092_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_339092_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339092_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_339092_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_339092_task);
    
    if (futhark_mc_segmap_parloop_339092_err != 0) {
        err = futhark_mc_segmap_parloop_339092_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339092_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339092_total_end -
                 futhark_mc_segmap_parloop_339092_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339092_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339092_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339092_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_339090_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_339090_end -
                 futhark_mc_segmap_task_339090_start;
        
        ctx->futhark_mc_segmap_task_339090_runs[tid]++;
        ctx->futhark_mc_segmap_task_339090_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_339090_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_segmap_parloop_struct_339099 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_t_292679;
    int64_t free_jump_t_292685;
    int64_t free_partition_sizze_292766;
    int64_t free_t_n_m_292839;
    int64_t free_i_292846;
    unsigned char *free_mem_312593;
    int64_t free_bytes_312598;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_312639;
    int64_t free_bytes_313090;
    unsigned char *free_mem_313143;
    unsigned char *free_mem_313147;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315656;
    unsigned char *free_mem_316621;
    unsigned char *free_mem_316625;
};
struct futhark_mc_task_339106 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_309770;
    unsigned char *free_mem_312593;
    unsigned char *free_mem_315656;
    unsigned char *free_mem_316530;
};
struct futhark_mc_segmap_parloop_struct_339108 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_309770;
    unsigned char *free_mem_312593;
    unsigned char *free_mem_315656;
    unsigned char *free_mem_316530;
};
static int futhark_mc_segmap_parloop_339109(void *args, int64_t start,
                                            int64_t end, int flat_tid_336023,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_339108
    *futhark_mc_segmap_parloop_struct_339108 =
    (struct futhark_mc_segmap_parloop_struct_339108 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_339108->ctx;
    uint64_t futhark_mc_segmap_parloop_339109_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339109_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_339108->free_n_292675;
    int64_t gtid_309770 =
            futhark_mc_segmap_parloop_struct_339108->free_gtid_309770;
    struct memblock mem_312593 = {.desc ="mem_312593", .mem =
                                  futhark_mc_segmap_parloop_struct_339108->free_mem_312593,
                                  .size =0, .references =NULL};
    struct memblock mem_315656 = {.desc ="mem_315656", .mem =
                                  futhark_mc_segmap_parloop_struct_339108->free_mem_315656,
                                  .size =0, .references =NULL};
    struct memblock mem_316530 = {.desc ="mem_316530", .mem =
                                  futhark_mc_segmap_parloop_struct_339108->free_mem_316530,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_336223 = start;
    
    for (; iter_336223 < end; iter_336223++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_336224 = n_292675;
        int64_t gtid_336024 = iter_336223;
        int64_t remnant_336225 = iter_336223 - gtid_336024;
        float x_336025;
        
        x_336025 = ((float *) mem_312593.mem)[gtid_309770 * n_292675 +
                                              gtid_336024];
        
        double x_336026;
        
        x_336026 = ((double *) mem_315656.mem)[gtid_309770 * n_292675 +
                                               gtid_336024];
        
        double f32_res_336027 = fpconv_f32_f64(x_336025);
        double defunc_1_f_res_336028 = f32_res_336027 - x_336026;
        
        ((double *) mem_316530.mem)[gtid_336024] = defunc_1_f_res_336028;
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339109_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339109_end -
                 futhark_mc_segmap_parloop_339109_start;
        
        ctx->futhark_mc_segmap_parloop_339109_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_339109_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_339109_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_339107(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_336023 = tid;
    int num_tasks_336222 = info.nsubtasks;
    struct futhark_mc_task_339106 *futhark_mc_task_339106 =
                                  (struct futhark_mc_task_339106 *) args;
    struct futhark_context *ctx = futhark_mc_task_339106->ctx;
    uint64_t futhark_mc_segmap_task_339107_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_339107_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_339106->free_n_292675;
    int64_t gtid_309770 = futhark_mc_task_339106->free_gtid_309770;
    struct memblock mem_312593 = {.desc ="mem_312593", .mem =
                                  futhark_mc_task_339106->free_mem_312593,
                                  .size =0, .references =NULL};
    struct memblock mem_315656 = {.desc ="mem_315656", .mem =
                                  futhark_mc_task_339106->free_mem_315656,
                                  .size =0, .references =NULL};
    struct memblock mem_316530 = {.desc ="mem_316530", .mem =
                                  futhark_mc_task_339106->free_mem_316530,
                                  .size =0, .references =NULL};
    int64_t iter_336223;
    struct futhark_mc_segmap_parloop_struct_339108
    futhark_mc_segmap_parloop_struct_339108;
    
    futhark_mc_segmap_parloop_struct_339108.ctx = ctx;
    futhark_mc_segmap_parloop_struct_339108.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_339108.free_gtid_309770 = gtid_309770;
    futhark_mc_segmap_parloop_struct_339108.free_mem_312593 = mem_312593.mem;
    futhark_mc_segmap_parloop_struct_339108.free_mem_315656 = mem_315656.mem;
    futhark_mc_segmap_parloop_struct_339108.free_mem_316530 = mem_316530.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_339109_task;
    
    futhark_mc_segmap_parloop_339109_task.name =
        "futhark_mc_segmap_parloop_339109";
    futhark_mc_segmap_parloop_339109_task.fn = futhark_mc_segmap_parloop_339109;
    futhark_mc_segmap_parloop_339109_task.args =
        &futhark_mc_segmap_parloop_struct_339108;
    futhark_mc_segmap_parloop_339109_task.iterations = iterations;
    futhark_mc_segmap_parloop_339109_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_339109_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339109_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_339109_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_339109_task);
    
    if (futhark_mc_segmap_parloop_339109_err != 0) {
        err = futhark_mc_segmap_parloop_339109_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339109_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339109_total_end -
                 futhark_mc_segmap_parloop_339109_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339109_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339109_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339109_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_339107_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_339107_end -
                 futhark_mc_segmap_task_339107_start;
        
        ctx->futhark_mc_segmap_task_339107_runs[tid]++;
        ctx->futhark_mc_segmap_task_339107_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_339107_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_task_339110 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_309770;
    unsigned char *free_mem_312636;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_316530;
    unsigned char *free_mem_316533;
    unsigned char *free_mem_316536;
};
struct futhark_mc_segmap_parloop_struct_339112 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_309770;
    unsigned char *free_mem_312636;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_316530;
    unsigned char *free_mem_316533;
    unsigned char *free_mem_316536;
};
static int futhark_mc_segmap_parloop_339113(void *args, int64_t start,
                                            int64_t end, int flat_tid_336029,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_339112
    *futhark_mc_segmap_parloop_struct_339112 =
    (struct futhark_mc_segmap_parloop_struct_339112 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_339112->ctx;
    uint64_t futhark_mc_segmap_parloop_339113_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339113_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_339112->free_n_292675;
    int64_t gtid_309770 =
            futhark_mc_segmap_parloop_struct_339112->free_gtid_309770;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_segmap_parloop_struct_339112->free_mem_312636,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_segmap_parloop_struct_339112->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_segmap_parloop_struct_339112->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_segmap_parloop_struct_339112->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_segmap_parloop_struct_339112->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_316530 = {.desc ="mem_316530", .mem =
                                  futhark_mc_segmap_parloop_struct_339112->free_mem_316530,
                                  .size =0, .references =NULL};
    struct memblock mem_316533 = {.desc ="mem_316533", .mem =
                                  futhark_mc_segmap_parloop_struct_339112->free_mem_316533,
                                  .size =0, .references =NULL};
    struct memblock mem_316536 = {.desc ="mem_316536", .mem =
                                  futhark_mc_segmap_parloop_struct_339112->free_mem_316536,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_336227 = start;
    
    for (; iter_336227 < end; iter_336227++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_336236 = n_292675;
        int64_t gtid_336030 = iter_336227;
        int64_t remnant_336237 = iter_336227 - gtid_336030;
        int64_t x_336031;
        
        x_336031 = ((int64_t *) mem_312636.mem)[gtid_309770 * n_292675 +
                                                gtid_336030];
        
        bool cond_336032 = sle64((int64_t) 0, x_336031);
        double defunc_0_f_res_336033;
        
        if (cond_336032) {
            bool y_336228 = slt64(x_336031, n_292675);
            bool bounds_check_336229 = cond_336032 && y_336228;
            bool index_certs_336230;
            
            if (!bounds_check_336229) {
                ctx->error =
                    msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                              "Index [", (long long) x_336031,
                              "] out of bounds for array of shape [",
                              (long long) n_292675, "].",
                              "-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:45:43-70\n   #3  stl.fut:285:33-58\n   #4  /prelude/soacs.fut:75:22-28\n   #5  /prelude/soacs.fut:75:3-45\n   #6  stl.fut:283:13-288:41\n   #7  stl.fut:419:61-435:77\n   #8  stl.fut:463:3-479:36\n   #9  stl.fut:445:1-479:36\n");
                err = FUTHARK_PROGRAM_ERROR;
                goto cleanup;
            }
            
            double defunc_0_f_res_t_res_336231;
            
            defunc_0_f_res_t_res_336231 = ((double *) mem_316530.mem)[x_336031];
            defunc_0_f_res_336033 = defunc_0_f_res_t_res_336231;
        } else {
            defunc_0_f_res_336033 = 0.0;
        }
        
        double defunc_0_f_res_336038;
        
        if (cond_336032) {
            bool y_336232 = slt64(x_336031, n_292675);
            bool bounds_check_336233 = cond_336032 && y_336232;
            bool index_certs_336234;
            
            if (!bounds_check_336233) {
                ctx->error =
                    msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                              "Index [", (long long) x_336031,
                              "] out of bounds for array of shape [",
                              (long long) n_292675, "].",
                              "-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:45:43-70\n   #3  stl.fut:286:33-64\n   #4  /prelude/soacs.fut:75:22-28\n   #5  /prelude/soacs.fut:75:3-45\n   #6  stl.fut:283:13-288:41\n   #7  stl.fut:419:61-435:77\n   #8  stl.fut:463:3-479:36\n   #9  stl.fut:445:1-479:36\n");
                err = FUTHARK_PROGRAM_ERROR;
                goto cleanup;
            }
            
            double defunc_0_f_res_t_res_336235;
            
            defunc_0_f_res_t_res_336235 =
                ((double *) mem_param_313179.mem)[ctx_param_ext_313174 +
                                                  (gtid_309770 *
                                                   ctx_param_ext_313175 +
                                                   x_336031 *
                                                   ctx_param_ext_313177)];
            defunc_0_f_res_336038 = defunc_0_f_res_t_res_336235;
        } else {
            defunc_0_f_res_336038 = 0.0;
        }
        ((double *) mem_316533.mem)[gtid_336030] = defunc_0_f_res_336038;
        ((double *) mem_316536.mem)[gtid_336030] = defunc_0_f_res_336033;
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339113_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339113_end -
                 futhark_mc_segmap_parloop_339113_start;
        
        ctx->futhark_mc_segmap_parloop_339113_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_339113_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_339113_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_339111(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_336029 = tid;
    int num_tasks_336226 = info.nsubtasks;
    struct futhark_mc_task_339110 *futhark_mc_task_339110 =
                                  (struct futhark_mc_task_339110 *) args;
    struct futhark_context *ctx = futhark_mc_task_339110->ctx;
    uint64_t futhark_mc_segmap_task_339111_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_339111_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_339110->free_n_292675;
    int64_t gtid_309770 = futhark_mc_task_339110->free_gtid_309770;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_task_339110->free_mem_312636,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_task_339110->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_task_339110->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_task_339110->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_task_339110->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_316530 = {.desc ="mem_316530", .mem =
                                  futhark_mc_task_339110->free_mem_316530,
                                  .size =0, .references =NULL};
    struct memblock mem_316533 = {.desc ="mem_316533", .mem =
                                  futhark_mc_task_339110->free_mem_316533,
                                  .size =0, .references =NULL};
    struct memblock mem_316536 = {.desc ="mem_316536", .mem =
                                  futhark_mc_task_339110->free_mem_316536,
                                  .size =0, .references =NULL};
    int64_t iter_336227;
    struct futhark_mc_segmap_parloop_struct_339112
    futhark_mc_segmap_parloop_struct_339112;
    
    futhark_mc_segmap_parloop_struct_339112.ctx = ctx;
    futhark_mc_segmap_parloop_struct_339112.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_339112.free_gtid_309770 = gtid_309770;
    futhark_mc_segmap_parloop_struct_339112.free_mem_312636 = mem_312636.mem;
    futhark_mc_segmap_parloop_struct_339112.free_ctx_param_ext_313174 =
        ctx_param_ext_313174;
    futhark_mc_segmap_parloop_struct_339112.free_ctx_param_ext_313175 =
        ctx_param_ext_313175;
    futhark_mc_segmap_parloop_struct_339112.free_ctx_param_ext_313177 =
        ctx_param_ext_313177;
    futhark_mc_segmap_parloop_struct_339112.free_mem_param_313179 =
        mem_param_313179.mem;
    futhark_mc_segmap_parloop_struct_339112.free_mem_316530 = mem_316530.mem;
    futhark_mc_segmap_parloop_struct_339112.free_mem_316533 = mem_316533.mem;
    futhark_mc_segmap_parloop_struct_339112.free_mem_316536 = mem_316536.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_339113_task;
    
    futhark_mc_segmap_parloop_339113_task.name =
        "futhark_mc_segmap_parloop_339113";
    futhark_mc_segmap_parloop_339113_task.fn = futhark_mc_segmap_parloop_339113;
    futhark_mc_segmap_parloop_339113_task.args =
        &futhark_mc_segmap_parloop_struct_339112;
    futhark_mc_segmap_parloop_339113_task.iterations = iterations;
    futhark_mc_segmap_parloop_339113_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_339113_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339113_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_339113_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_339113_task);
    
    if (futhark_mc_segmap_parloop_339113_err != 0) {
        err = futhark_mc_segmap_parloop_339113_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339113_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339113_total_end -
                 futhark_mc_segmap_parloop_339113_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339113_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339113_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339113_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_339111_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_339111_end -
                 futhark_mc_segmap_task_339111_start;
        
        ctx->futhark_mc_segmap_task_339111_runs[tid]++;
        ctx->futhark_mc_segmap_task_339111_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_339111_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_task_339114 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_t_292679;
    int64_t free_jump_t_292685;
    int64_t free_t_n_m_292839;
    int64_t free_i_292846;
    int64_t free_gtid_309770;
    int64_t free_x_309775;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_313143;
    unsigned char *free_mem_313147;
    unsigned char *free_mem_316533;
    unsigned char *free_mem_316536;
    unsigned char *free_mem_316539;
    unsigned char *free_mem_316542;
};
struct futhark_mc_segmap_parloop_struct_339116 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_t_292679;
    int64_t free_jump_t_292685;
    int64_t free_t_n_m_292839;
    int64_t free_i_292846;
    int64_t free_gtid_309770;
    int64_t free_x_309775;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_313143;
    unsigned char *free_mem_313147;
    unsigned char *free_mem_316533;
    unsigned char *free_mem_316536;
    unsigned char *free_mem_316539;
    unsigned char *free_mem_316542;
};
static int futhark_mc_segmap_parloop_339117(void *args, int64_t start,
                                            int64_t end, int flat_tid_336135,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_339116
    *futhark_mc_segmap_parloop_struct_339116 =
    (struct futhark_mc_segmap_parloop_struct_339116 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_339116->ctx;
    uint64_t futhark_mc_segmap_parloop_339117_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339117_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_339116->free_n_292675;
    int64_t q_t_292679 =
            futhark_mc_segmap_parloop_struct_339116->free_q_t_292679;
    int64_t jump_t_292685 =
            futhark_mc_segmap_parloop_struct_339116->free_jump_t_292685;
    int64_t t_n_m_292839 =
            futhark_mc_segmap_parloop_struct_339116->free_t_n_m_292839;
    int64_t i_292846 = futhark_mc_segmap_parloop_struct_339116->free_i_292846;
    int64_t gtid_309770 =
            futhark_mc_segmap_parloop_struct_339116->free_gtid_309770;
    int64_t x_309775 = futhark_mc_segmap_parloop_struct_339116->free_x_309775;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_segmap_parloop_struct_339116->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_313143 = {.desc ="mem_313143", .mem =
                                  futhark_mc_segmap_parloop_struct_339116->free_mem_313143,
                                  .size =0, .references =NULL};
    struct memblock mem_313147 = {.desc ="mem_313147", .mem =
                                  futhark_mc_segmap_parloop_struct_339116->free_mem_313147,
                                  .size =0, .references =NULL};
    struct memblock mem_316533 = {.desc ="mem_316533", .mem =
                                  futhark_mc_segmap_parloop_struct_339116->free_mem_316533,
                                  .size =0, .references =NULL};
    struct memblock mem_316536 = {.desc ="mem_316536", .mem =
                                  futhark_mc_segmap_parloop_struct_339116->free_mem_316536,
                                  .size =0, .references =NULL};
    struct memblock mem_316539 = {.desc ="mem_316539", .mem =
                                  futhark_mc_segmap_parloop_struct_339116->free_mem_316539,
                                  .size =0, .references =NULL};
    struct memblock mem_316542 = {.desc ="mem_316542", .mem =
                                  futhark_mc_segmap_parloop_struct_339116->free_mem_316542,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_336239 = start;
    
    for (; iter_336239 < end; iter_336239++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_336302 = t_n_m_292839;
        int64_t gtid_336136 = iter_336239;
        int64_t remnant_336303 = iter_336239 - gtid_336136;
        int64_t x_336137;
        
        x_336137 = ((int64_t *) mem_313143.mem)[gtid_309770 * t_n_m_292839 +
                                                gtid_336136];
        
        double x_336138;
        
        x_336138 = ((double *) mem_313147.mem)[gtid_309770 * t_n_m_292839 +
                                               gtid_336136];
        
        int64_t min_arg_336139 = mul64(jump_t_292685, gtid_336136);
        int64_t min_res_336140 = smin64(i_292846, min_arg_336139);
        int64_t defunc_0_g_res_336141 = add64((int64_t) 1, min_res_336140);
        double defunc_2_reduce_res_336142;
        double defunc_2_reduce_res_336143;
        double defunc_2_reduce_res_336144;
        double redout_336241;
        double redout_336242;
        double redout_336243;
        
        redout_336241 = 0.0;
        redout_336242 = 0.0;
        redout_336243 = 0.0;
        for (int64_t i_336240 = 0; i_336240 < q_t_292679; i_336240++) {
            bool cond_336244 = sle64(x_309775, i_336240);
            int64_t defunc_0_f_res_336245;
            
            if (cond_336244) {
                defunc_0_f_res_336245 = (int64_t) 0;
            } else {
                int64_t i_336246 = add64(x_336137, i_336240);
                int64_t defunc_0_add_arg_336247;
                
                defunc_0_add_arg_336247 =
                    ((int64_t *) mem_312636.mem)[gtid_309770 * n_292675 +
                                                 i_336246];
                
                int64_t defunc_1_add_res_336248 = add64((int64_t) 1,
                                                        defunc_0_add_arg_336247);
                
                defunc_0_f_res_336245 = defunc_1_add_res_336248;
            }
            
            double defunc_0_f_res_336249;
            
            if (cond_336244) {
                defunc_0_f_res_336249 = 0.0;
            } else {
                int64_t i_336250 = add64(x_336137, i_336240);
                double defunc_0_add_arg_336251;
                
                defunc_0_add_arg_336251 = ((double *) mem_316533.mem)[i_336250];
                defunc_0_f_res_336249 = defunc_0_add_arg_336251;
            }
            
            int64_t binop_p_336252 = sub64(defunc_0_f_res_336245,
                                           defunc_0_g_res_336141);
            double defunc_0_f_res_336253 = sitofp_i64_f64(binop_p_336252);
            double abs_res_336254 = fabs(defunc_0_f_res_336253);
            double tmp1_336255 = abs_res_336254 / x_336138;
            double x_336256 = tmp1_336255 * tmp1_336255;
            double y_336257 = tmp1_336255 * x_336256;
            double tmp2_336258 = 1.0 - y_336257;
            double x_336259 = tmp2_336258 * tmp2_336258;
            double tmp3_336260 = tmp2_336258 * x_336259;
            double w_j_336261 = defunc_0_f_res_336249 * tmp3_336260;
            double xw_j_336262 = defunc_0_f_res_336253 * w_j_336261;
            double x2w_j_336263 = defunc_0_f_res_336253 * xw_j_336262;
            double defunc_1_op_res_336264 = w_j_336261 + redout_336241;
            double defunc_1_op_res_336265 = xw_j_336262 + redout_336242;
            double defunc_1_op_res_336266 = x2w_j_336263 + redout_336243;
            double redout_tmp_336304 = defunc_1_op_res_336264;
            double redout_tmp_336305 = defunc_1_op_res_336265;
            double redout_tmp_336306 = defunc_1_op_res_336266;
            
            redout_336241 = redout_tmp_336304;
            redout_336242 = redout_tmp_336305;
            redout_336243 = redout_tmp_336306;
        }
        defunc_2_reduce_res_336142 = redout_336241;
        defunc_2_reduce_res_336143 = redout_336242;
        defunc_2_reduce_res_336144 = redout_336243;
        
        double a_336172 = 2.220446049250313e-16 + defunc_2_reduce_res_336142;
        double b_336173 = 2.220446049250313e-16 + defunc_2_reduce_res_336143;
        double c_336174 = 2.220446049250313e-16 + defunc_2_reduce_res_336144;
        double x_336175 = a_336172 * c_336174;
        double y_336176 = b_336173 * b_336173;
        double y_336177 = x_336175 - y_336176;
        double det1_336178 = 1.0 / y_336177;
        double a11_336179 = c_336174 * det1_336178;
        double x_336180 = 0.0 - b_336173;
        double b11_336181 = det1_336178 * x_336180;
        double c11_336182 = a_336172 * det1_336178;
        double defunc_2_reduce_res_336183;
        double defunc_2_reduce_res_336184;
        double redout_336268;
        double redout_336269;
        
        redout_336268 = 0.0;
        redout_336269 = 0.0;
        for (int64_t i_336267 = 0; i_336267 < q_t_292679; i_336267++) {
            bool cond_336270 = sle64(x_309775, i_336267);
            int64_t defunc_0_f_res_336271;
            
            if (cond_336270) {
                defunc_0_f_res_336271 = (int64_t) 0;
            } else {
                int64_t i_336272 = add64(x_336137, i_336267);
                int64_t defunc_0_add_arg_336273;
                
                defunc_0_add_arg_336273 =
                    ((int64_t *) mem_312636.mem)[gtid_309770 * n_292675 +
                                                 i_336272];
                
                int64_t defunc_1_add_res_336274 = add64((int64_t) 1,
                                                        defunc_0_add_arg_336273);
                
                defunc_0_f_res_336271 = defunc_1_add_res_336274;
            }
            
            double defunc_0_f_res_336275;
            
            if (cond_336270) {
                defunc_0_f_res_336275 = 0.0;
            } else {
                int64_t i_336276 = add64(x_336137, i_336267);
                double defunc_0_add_arg_336277;
                
                defunc_0_add_arg_336277 = ((double *) mem_316533.mem)[i_336276];
                defunc_0_f_res_336275 = defunc_0_add_arg_336277;
            }
            
            int64_t binop_p_336278 = sub64(defunc_0_f_res_336271,
                                           defunc_0_g_res_336141);
            double defunc_0_f_res_336279 = sitofp_i64_f64(binop_p_336278);
            double abs_res_336280 = fabs(defunc_0_f_res_336279);
            double tmp1_336281 = abs_res_336280 / x_336138;
            double x_336282 = tmp1_336281 * tmp1_336281;
            double y_336283 = tmp1_336281 * x_336282;
            double tmp2_336284 = 1.0 - y_336283;
            double x_336285 = tmp2_336284 * tmp2_336284;
            double tmp3_336286 = tmp2_336284 * x_336285;
            double tmp4_336287 = defunc_0_f_res_336275 * tmp3_336286;
            double defunc_1_f_res_336288 = defunc_0_f_res_336279 * tmp4_336287;
            double defunc_0_f_res_336289;
            
            if (cond_336270) {
                defunc_0_f_res_336289 = 0.0;
            } else {
                int64_t i_336290 = add64(x_336137, i_336267);
                double defunc_0_add_arg_336291;
                
                defunc_0_add_arg_336291 = ((double *) mem_316536.mem)[i_336290];
                defunc_0_f_res_336289 = defunc_0_add_arg_336291;
            }
            
            double x_336292 = a11_336179 * tmp4_336287;
            double y_336293 = b11_336181 * defunc_1_f_res_336288;
            double x_336294 = x_336292 + y_336293;
            double defunc_9_fit_fun_res_336295 = defunc_0_f_res_336289 *
                   x_336294;
            double x_336296 = b11_336181 * tmp4_336287;
            double y_336297 = c11_336182 * defunc_1_f_res_336288;
            double x_336298 = x_336296 + y_336297;
            double defunc_9_slope_fun_res_336299 = defunc_0_f_res_336289 *
                   x_336298;
            double defunc_1_op_res_336300 = defunc_9_fit_fun_res_336295 +
                   redout_336268;
            double defunc_1_op_res_336301 = defunc_9_slope_fun_res_336299 +
                   redout_336269;
            double redout_tmp_336307 = defunc_1_op_res_336300;
            double redout_tmp_336308 = defunc_1_op_res_336301;
            
            redout_336268 = redout_tmp_336307;
            redout_336269 = redout_tmp_336308;
        }
        defunc_2_reduce_res_336183 = redout_336268;
        defunc_2_reduce_res_336184 = redout_336269;
        ((double *) mem_316539.mem)[gtid_336136] = defunc_2_reduce_res_336183;
        ((double *) mem_316542.mem)[gtid_336136] = defunc_2_reduce_res_336184;
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339117_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339117_end -
                 futhark_mc_segmap_parloop_339117_start;
        
        ctx->futhark_mc_segmap_parloop_339117_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_339117_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_339117_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_339115(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_336135 = tid;
    int num_tasks_336238 = info.nsubtasks;
    struct futhark_mc_task_339114 *futhark_mc_task_339114 =
                                  (struct futhark_mc_task_339114 *) args;
    struct futhark_context *ctx = futhark_mc_task_339114->ctx;
    uint64_t futhark_mc_segmap_task_339115_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_339115_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_339114->free_n_292675;
    int64_t q_t_292679 = futhark_mc_task_339114->free_q_t_292679;
    int64_t jump_t_292685 = futhark_mc_task_339114->free_jump_t_292685;
    int64_t t_n_m_292839 = futhark_mc_task_339114->free_t_n_m_292839;
    int64_t i_292846 = futhark_mc_task_339114->free_i_292846;
    int64_t gtid_309770 = futhark_mc_task_339114->free_gtid_309770;
    int64_t x_309775 = futhark_mc_task_339114->free_x_309775;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_task_339114->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_313143 = {.desc ="mem_313143", .mem =
                                  futhark_mc_task_339114->free_mem_313143,
                                  .size =0, .references =NULL};
    struct memblock mem_313147 = {.desc ="mem_313147", .mem =
                                  futhark_mc_task_339114->free_mem_313147,
                                  .size =0, .references =NULL};
    struct memblock mem_316533 = {.desc ="mem_316533", .mem =
                                  futhark_mc_task_339114->free_mem_316533,
                                  .size =0, .references =NULL};
    struct memblock mem_316536 = {.desc ="mem_316536", .mem =
                                  futhark_mc_task_339114->free_mem_316536,
                                  .size =0, .references =NULL};
    struct memblock mem_316539 = {.desc ="mem_316539", .mem =
                                  futhark_mc_task_339114->free_mem_316539,
                                  .size =0, .references =NULL};
    struct memblock mem_316542 = {.desc ="mem_316542", .mem =
                                  futhark_mc_task_339114->free_mem_316542,
                                  .size =0, .references =NULL};
    int64_t iter_336239;
    struct futhark_mc_segmap_parloop_struct_339116
    futhark_mc_segmap_parloop_struct_339116;
    
    futhark_mc_segmap_parloop_struct_339116.ctx = ctx;
    futhark_mc_segmap_parloop_struct_339116.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_339116.free_q_t_292679 = q_t_292679;
    futhark_mc_segmap_parloop_struct_339116.free_jump_t_292685 = jump_t_292685;
    futhark_mc_segmap_parloop_struct_339116.free_t_n_m_292839 = t_n_m_292839;
    futhark_mc_segmap_parloop_struct_339116.free_i_292846 = i_292846;
    futhark_mc_segmap_parloop_struct_339116.free_gtid_309770 = gtid_309770;
    futhark_mc_segmap_parloop_struct_339116.free_x_309775 = x_309775;
    futhark_mc_segmap_parloop_struct_339116.free_mem_312636 = mem_312636.mem;
    futhark_mc_segmap_parloop_struct_339116.free_mem_313143 = mem_313143.mem;
    futhark_mc_segmap_parloop_struct_339116.free_mem_313147 = mem_313147.mem;
    futhark_mc_segmap_parloop_struct_339116.free_mem_316533 = mem_316533.mem;
    futhark_mc_segmap_parloop_struct_339116.free_mem_316536 = mem_316536.mem;
    futhark_mc_segmap_parloop_struct_339116.free_mem_316539 = mem_316539.mem;
    futhark_mc_segmap_parloop_struct_339116.free_mem_316542 = mem_316542.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_339117_task;
    
    futhark_mc_segmap_parloop_339117_task.name =
        "futhark_mc_segmap_parloop_339117";
    futhark_mc_segmap_parloop_339117_task.fn = futhark_mc_segmap_parloop_339117;
    futhark_mc_segmap_parloop_339117_task.args =
        &futhark_mc_segmap_parloop_struct_339116;
    futhark_mc_segmap_parloop_339117_task.iterations = iterations;
    futhark_mc_segmap_parloop_339117_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_339117_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339117_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_339117_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_339117_task);
    
    if (futhark_mc_segmap_parloop_339117_err != 0) {
        err = futhark_mc_segmap_parloop_339117_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339117_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339117_total_end -
                 futhark_mc_segmap_parloop_339117_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339117_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339117_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339117_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_339115_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_339115_end -
                 futhark_mc_segmap_task_339115_start;
        
        ctx->futhark_mc_segmap_task_339115_runs[tid]++;
        ctx->futhark_mc_segmap_task_339115_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_339115_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_segmap_parloop_struct_339119 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_t_292679;
    int64_t free_jump_t_292685;
    int64_t free_t_n_m_292839;
    int64_t free_i_292846;
    int64_t free_gtid_309770;
    int64_t free_x_309775;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_313143;
    unsigned char *free_mem_313147;
    unsigned char *free_mem_316533;
    unsigned char *free_mem_316536;
    unsigned char *free_mem_316539;
    unsigned char *free_mem_316542;
};
struct futhark_mc_task_339121 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_309770;
    int64_t free_x_309775;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_316533;
    int64_t free_x_336045;
    double free_x_336046;
    int64_t free_defunc_0_g_res_336049;
    double *retval_defunc_2_reduce_res_336050;
    double *retval_defunc_2_reduce_res_336051;
    double *retval_defunc_2_reduce_res_336052;
};
struct futhark_mc_segred_stage_1_parloop_struct_339126 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_309770;
    int64_t free_x_309775;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_316533;
    int64_t free_x_336045;
    double free_x_336046;
    int64_t free_defunc_0_g_res_336049;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_336382;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_336384;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_336386;
};
static int futhark_mc_segred_stage_1_parloop_339127(void *args, int64_t start,
                                                    int64_t end,
                                                    int flat_tid_336310,
                                                    int tid)
{
    int err = 0;
    struct futhark_mc_segred_stage_1_parloop_struct_339126
    *futhark_mc_segred_stage_1_parloop_struct_339126 =
    (struct futhark_mc_segred_stage_1_parloop_struct_339126 *) args;
    struct futhark_context *ctx =
                           futhark_mc_segred_stage_1_parloop_struct_339126->ctx;
    uint64_t futhark_mc_segred_stage_1_parloop_339127_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_339127_start = get_wall_time();
    
    int64_t n_292675 =
            futhark_mc_segred_stage_1_parloop_struct_339126->free_n_292675;
    int64_t gtid_309770 =
            futhark_mc_segred_stage_1_parloop_struct_339126->free_gtid_309770;
    int64_t x_309775 =
            futhark_mc_segred_stage_1_parloop_struct_339126->free_x_309775;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_339126->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_316533 = {.desc ="mem_316533", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_339126->free_mem_316533,
                                  .size =0, .references =NULL};
    int64_t x_336045 =
            futhark_mc_segred_stage_1_parloop_struct_339126->free_x_336045;
    double x_336046 =
           futhark_mc_segred_stage_1_parloop_struct_339126->free_x_336046;
    int64_t defunc_0_g_res_336049 =
            futhark_mc_segred_stage_1_parloop_struct_339126->free_defunc_0_g_res_336049;
    struct memblock reduce_stage_1_tid_res_arr_mem_336382 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_336382",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_339126->free_reduce_stage_1_tid_res_arr_mem_336382,
                                                             .size =0,
                                                             .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_336384 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_336384",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_339126->free_reduce_stage_1_tid_res_arr_mem_336384,
                                                             .size =0,
                                                             .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_336386 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_336386",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_339126->free_reduce_stage_1_tid_res_arr_mem_336386,
                                                             .size =0,
                                                             .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_336388 = start;
    double x_336312;
    double x_336313;
    double x_336315;
    double x_336316;
    double x_336318;
    double x_336319;
    double local_acc_336389 = 0.0;
    double local_acc_336390 = 0.0;
    double local_acc_336391 = 0.0;
    
    for (; iter_336388 < end; iter_336388++) {
        int64_t gtid_336311 = iter_336388;
        bool cond_336321 = sle64(x_309775, gtid_336311);
        int64_t defunc_0_f_res_336322;
        
        if (cond_336321) {
            defunc_0_f_res_336322 = (int64_t) 0;
        } else {
            int64_t i_336323 = add64(x_336045, gtid_336311);
            int64_t defunc_0_add_arg_336324;
            
            defunc_0_add_arg_336324 = ((int64_t *) mem_312636.mem)[gtid_309770 *
                                                                   n_292675 +
                                                                   i_336323];
            
            int64_t defunc_1_add_res_336325 = add64((int64_t) 1,
                                                    defunc_0_add_arg_336324);
            
            defunc_0_f_res_336322 = defunc_1_add_res_336325;
        }
        
        double defunc_0_f_res_336326;
        
        if (cond_336321) {
            defunc_0_f_res_336326 = 0.0;
        } else {
            int64_t i_336327 = add64(x_336045, gtid_336311);
            double defunc_0_add_arg_336328;
            
            defunc_0_add_arg_336328 = ((double *) mem_316533.mem)[i_336327];
            defunc_0_f_res_336326 = defunc_0_add_arg_336328;
        }
        
        int64_t binop_p_336329 = sub64(defunc_0_f_res_336322,
                                       defunc_0_g_res_336049);
        double defunc_0_f_res_336330 = sitofp_i64_f64(binop_p_336329);
        double abs_res_336331 = fabs(defunc_0_f_res_336330);
        double tmp1_336332 = abs_res_336331 / x_336046;
        double x_336333 = tmp1_336332 * tmp1_336332;
        double y_336334 = tmp1_336332 * x_336333;
        double tmp2_336335 = 1.0 - y_336334;
        double x_336336 = tmp2_336335 * tmp2_336335;
        double tmp3_336337 = tmp2_336335 * x_336336;
        double w_j_336338 = defunc_0_f_res_336326 * tmp3_336337;
        double xw_j_336339 = defunc_0_f_res_336330 * w_j_336338;
        double x2w_j_336340 = defunc_0_f_res_336330 * xw_j_336339;
        
        // save map-out results
        { }
        // Load accum params
        {
            x_336312 = local_acc_336389;
        }
        // Load next params
        {
            x_336313 = w_j_336338;
        }
        // Red body
        {
            double defunc_1_op_res_336314 = x_336312 + x_336313;
            
            local_acc_336389 = defunc_1_op_res_336314;
        }
        // Load accum params
        {
            x_336315 = local_acc_336390;
        }
        // Load next params
        {
            x_336316 = xw_j_336339;
        }
        // Red body
        {
            double defunc_1_op_res_336317 = x_336315 + x_336316;
            
            local_acc_336390 = defunc_1_op_res_336317;
        }
        // Load accum params
        {
            x_336318 = local_acc_336391;
        }
        // Load next params
        {
            x_336319 = x2w_j_336340;
        }
        // Red body
        {
            double defunc_1_op_res_336320 = x_336318 + x_336319;
            
            local_acc_336391 = defunc_1_op_res_336320;
        }
    }
    ((double *) reduce_stage_1_tid_res_arr_mem_336382.mem)[flat_tid_336310] =
        local_acc_336389;
    ((double *) reduce_stage_1_tid_res_arr_mem_336384.mem)[flat_tid_336310] =
        local_acc_336390;
    ((double *) reduce_stage_1_tid_res_arr_mem_336386.mem)[flat_tid_336310] =
        local_acc_336391;
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_339127_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_339127_end -
                 futhark_mc_segred_stage_1_parloop_339127_start;
        
        ctx->futhark_mc_segred_stage_1_parloop_339127_runs[tid]++;
        ctx->futhark_mc_segred_stage_1_parloop_339127_total_runtime[tid] +=
            elapsed;
        ctx->futhark_mc_segred_stage_1_parloop_339127_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segred_task_339122(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_336310 = tid;
    int num_tasks_336381 = info.nsubtasks;
    struct futhark_mc_task_339121 *futhark_mc_task_339121 =
                                  (struct futhark_mc_task_339121 *) args;
    struct futhark_context *ctx = futhark_mc_task_339121->ctx;
    uint64_t futhark_mc_segred_task_339122_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_task_339122_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_339121->free_n_292675;
    int64_t gtid_309770 = futhark_mc_task_339121->free_gtid_309770;
    int64_t x_309775 = futhark_mc_task_339121->free_x_309775;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_task_339121->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_316533 = {.desc ="mem_316533", .mem =
                                  futhark_mc_task_339121->free_mem_316533,
                                  .size =0, .references =NULL};
    int64_t x_336045 = futhark_mc_task_339121->free_x_336045;
    double x_336046 = futhark_mc_task_339121->free_x_336046;
    int64_t defunc_0_g_res_336049 =
            futhark_mc_task_339121->free_defunc_0_g_res_336049;
    double defunc_2_reduce_res_336050 =
           *futhark_mc_task_339121->retval_defunc_2_reduce_res_336050;
    double defunc_2_reduce_res_336051 =
           *futhark_mc_task_339121->retval_defunc_2_reduce_res_336051;
    double defunc_2_reduce_res_336052 =
           *futhark_mc_task_339121->retval_defunc_2_reduce_res_336052;
    size_t reduce_stage_1_tid_res_arr_mem_336382_cached_sizze_339123 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_336382 = NULL;
    size_t reduce_stage_1_tid_res_arr_mem_336384_cached_sizze_339124 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_336384 = NULL;
    size_t reduce_stage_1_tid_res_arr_mem_336386_cached_sizze_339125 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_336386 = NULL;
    
    if (reduce_stage_1_tid_res_arr_mem_336382_cached_sizze_339123 <
        (size_t) ((int64_t) 8 * num_tasks_336381)) {
        reduce_stage_1_tid_res_arr_mem_336382 =
            realloc(reduce_stage_1_tid_res_arr_mem_336382, (int64_t) 8 *
                    num_tasks_336381);
        reduce_stage_1_tid_res_arr_mem_336382_cached_sizze_339123 =
            (int64_t) 8 * num_tasks_336381;
    }
    if (reduce_stage_1_tid_res_arr_mem_336384_cached_sizze_339124 <
        (size_t) ((int64_t) 8 * num_tasks_336381)) {
        reduce_stage_1_tid_res_arr_mem_336384 =
            realloc(reduce_stage_1_tid_res_arr_mem_336384, (int64_t) 8 *
                    num_tasks_336381);
        reduce_stage_1_tid_res_arr_mem_336384_cached_sizze_339124 =
            (int64_t) 8 * num_tasks_336381;
    }
    if (reduce_stage_1_tid_res_arr_mem_336386_cached_sizze_339125 <
        (size_t) ((int64_t) 8 * num_tasks_336381)) {
        reduce_stage_1_tid_res_arr_mem_336386 =
            realloc(reduce_stage_1_tid_res_arr_mem_336386, (int64_t) 8 *
                    num_tasks_336381);
        reduce_stage_1_tid_res_arr_mem_336386_cached_sizze_339125 =
            (int64_t) 8 * num_tasks_336381;
    }
    
    int64_t iter_336388;
    struct futhark_mc_segred_stage_1_parloop_struct_339126
    futhark_mc_segred_stage_1_parloop_struct_339126;
    
    futhark_mc_segred_stage_1_parloop_struct_339126.ctx = ctx;
    futhark_mc_segred_stage_1_parloop_struct_339126.free_n_292675 = n_292675;
    futhark_mc_segred_stage_1_parloop_struct_339126.free_gtid_309770 =
        gtid_309770;
    futhark_mc_segred_stage_1_parloop_struct_339126.free_x_309775 = x_309775;
    futhark_mc_segred_stage_1_parloop_struct_339126.free_mem_312636 =
        mem_312636.mem;
    futhark_mc_segred_stage_1_parloop_struct_339126.free_mem_316533 =
        mem_316533.mem;
    futhark_mc_segred_stage_1_parloop_struct_339126.free_x_336045 = x_336045;
    futhark_mc_segred_stage_1_parloop_struct_339126.free_x_336046 = x_336046;
    futhark_mc_segred_stage_1_parloop_struct_339126.free_defunc_0_g_res_336049 =
        defunc_0_g_res_336049;
    futhark_mc_segred_stage_1_parloop_struct_339126.free_reduce_stage_1_tid_res_arr_mem_336382 =
        reduce_stage_1_tid_res_arr_mem_336382;
    futhark_mc_segred_stage_1_parloop_struct_339126.free_reduce_stage_1_tid_res_arr_mem_336384 =
        reduce_stage_1_tid_res_arr_mem_336384;
    futhark_mc_segred_stage_1_parloop_struct_339126.free_reduce_stage_1_tid_res_arr_mem_336386 =
        reduce_stage_1_tid_res_arr_mem_336386;
    
    struct scheduler_parloop futhark_mc_segred_stage_1_parloop_339127_task;
    
    futhark_mc_segred_stage_1_parloop_339127_task.name =
        "futhark_mc_segred_stage_1_parloop_339127";
    futhark_mc_segred_stage_1_parloop_339127_task.fn =
        futhark_mc_segred_stage_1_parloop_339127;
    futhark_mc_segred_stage_1_parloop_339127_task.args =
        &futhark_mc_segred_stage_1_parloop_struct_339126;
    futhark_mc_segred_stage_1_parloop_339127_task.iterations = iterations;
    futhark_mc_segred_stage_1_parloop_339127_task.info = info;
    
    uint64_t futhark_mc_segred_stage_1_parloop_339127_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_339127_total_start = get_wall_time();
    
    int futhark_mc_segred_stage_1_parloop_339127_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segred_stage_1_parloop_339127_task);
    
    if (futhark_mc_segred_stage_1_parloop_339127_err != 0) {
        err = futhark_mc_segred_stage_1_parloop_339127_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_339127_total_end =
                 get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_339127_total_end -
                 futhark_mc_segred_stage_1_parloop_339127_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_339127_total_runs,
                           1, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_339127_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_339127_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    // neutral-initialise the output
    {
        defunc_2_reduce_res_336050 = 0.0;
        defunc_2_reduce_res_336051 = 0.0;
        defunc_2_reduce_res_336052 = 0.0;
    }
    
    double x_336392;
    double x_336393;
    double x_336395;
    double x_336396;
    double x_336398;
    double x_336399;
    
    for (int32_t i_336401 = 0; i_336401 < num_tasks_336381; i_336401++) {
        flat_tid_336310 = i_336401;
        // Apply main thread reduction
        {
            // load acc params
            {
                x_336392 = defunc_2_reduce_res_336050;
            }
            // load next params
            {
                x_336393 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_336382)[flat_tid_336310];
            }
            // red body
            {
                double defunc_1_op_res_336394 = x_336392 + x_336393;
                
                defunc_2_reduce_res_336050 = defunc_1_op_res_336394;
            }
            // load acc params
            {
                x_336395 = defunc_2_reduce_res_336051;
            }
            // load next params
            {
                x_336396 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_336384)[flat_tid_336310];
            }
            // red body
            {
                double defunc_1_op_res_336397 = x_336395 + x_336396;
                
                defunc_2_reduce_res_336051 = defunc_1_op_res_336397;
            }
            // load acc params
            {
                x_336398 = defunc_2_reduce_res_336052;
            }
            // load next params
            {
                x_336399 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_336386)[flat_tid_336310];
            }
            // red body
            {
                double defunc_1_op_res_336400 = x_336398 + x_336399;
                
                defunc_2_reduce_res_336052 = defunc_1_op_res_336400;
            }
        }
    }
    
  cleanup:
    {
        free(reduce_stage_1_tid_res_arr_mem_336382);
        free(reduce_stage_1_tid_res_arr_mem_336384);
        free(reduce_stage_1_tid_res_arr_mem_336386);
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_task_339122_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_task_339122_end -
                 futhark_mc_segred_task_339122_start;
        
        ctx->futhark_mc_segred_task_339122_runs[tid]++;
        ctx->futhark_mc_segred_task_339122_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segred_task_339122_iter[tid] += iterations;
    }
    if (err == 0) {
        *futhark_mc_task_339121->retval_defunc_2_reduce_res_336050 =
            defunc_2_reduce_res_336050;
        *futhark_mc_task_339121->retval_defunc_2_reduce_res_336051 =
            defunc_2_reduce_res_336051;
        *futhark_mc_task_339121->retval_defunc_2_reduce_res_336052 =
            defunc_2_reduce_res_336052;
    }
    return err;
}
struct futhark_mc_task_339128 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_309770;
    int64_t free_x_309775;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_316533;
    unsigned char *free_mem_316536;
    int64_t free_x_336045;
    double free_x_336046;
    int64_t free_defunc_0_g_res_336049;
    double free_a11_336091;
    double free_b11_336093;
    double free_c11_336094;
    double *retval_defunc_2_reduce_res_336095;
    double *retval_defunc_2_reduce_res_336096;
};
struct futhark_mc_segred_stage_1_parloop_struct_339132 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_309770;
    int64_t free_x_309775;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_316533;
    unsigned char *free_mem_316536;
    int64_t free_x_336045;
    double free_x_336046;
    int64_t free_defunc_0_g_res_336049;
    double free_a11_336091;
    double free_b11_336093;
    double free_c11_336094;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_336403;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_336405;
};
static int futhark_mc_segred_stage_1_parloop_339133(void *args, int64_t start,
                                                    int64_t end,
                                                    int flat_tid_336341,
                                                    int tid)
{
    int err = 0;
    struct futhark_mc_segred_stage_1_parloop_struct_339132
    *futhark_mc_segred_stage_1_parloop_struct_339132 =
    (struct futhark_mc_segred_stage_1_parloop_struct_339132 *) args;
    struct futhark_context *ctx =
                           futhark_mc_segred_stage_1_parloop_struct_339132->ctx;
    uint64_t futhark_mc_segred_stage_1_parloop_339133_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_339133_start = get_wall_time();
    
    int64_t n_292675 =
            futhark_mc_segred_stage_1_parloop_struct_339132->free_n_292675;
    int64_t gtid_309770 =
            futhark_mc_segred_stage_1_parloop_struct_339132->free_gtid_309770;
    int64_t x_309775 =
            futhark_mc_segred_stage_1_parloop_struct_339132->free_x_309775;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_339132->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_316533 = {.desc ="mem_316533", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_339132->free_mem_316533,
                                  .size =0, .references =NULL};
    struct memblock mem_316536 = {.desc ="mem_316536", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_339132->free_mem_316536,
                                  .size =0, .references =NULL};
    int64_t x_336045 =
            futhark_mc_segred_stage_1_parloop_struct_339132->free_x_336045;
    double x_336046 =
           futhark_mc_segred_stage_1_parloop_struct_339132->free_x_336046;
    int64_t defunc_0_g_res_336049 =
            futhark_mc_segred_stage_1_parloop_struct_339132->free_defunc_0_g_res_336049;
    double a11_336091 =
           futhark_mc_segred_stage_1_parloop_struct_339132->free_a11_336091;
    double b11_336093 =
           futhark_mc_segred_stage_1_parloop_struct_339132->free_b11_336093;
    double c11_336094 =
           futhark_mc_segred_stage_1_parloop_struct_339132->free_c11_336094;
    struct memblock reduce_stage_1_tid_res_arr_mem_336403 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_336403",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_339132->free_reduce_stage_1_tid_res_arr_mem_336403,
                                                             .size =0,
                                                             .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_336405 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_336405",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_339132->free_reduce_stage_1_tid_res_arr_mem_336405,
                                                             .size =0,
                                                             .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_336407 = start;
    double x_336343;
    double x_336344;
    double x_336346;
    double x_336347;
    double local_acc_336408 = 0.0;
    double local_acc_336409 = 0.0;
    
    for (; iter_336407 < end; iter_336407++) {
        int64_t gtid_336342 = iter_336407;
        bool cond_336349 = sle64(x_309775, gtid_336342);
        int64_t defunc_0_f_res_336350;
        
        if (cond_336349) {
            defunc_0_f_res_336350 = (int64_t) 0;
        } else {
            int64_t i_336351 = add64(x_336045, gtid_336342);
            int64_t defunc_0_add_arg_336352;
            
            defunc_0_add_arg_336352 = ((int64_t *) mem_312636.mem)[gtid_309770 *
                                                                   n_292675 +
                                                                   i_336351];
            
            int64_t defunc_1_add_res_336353 = add64((int64_t) 1,
                                                    defunc_0_add_arg_336352);
            
            defunc_0_f_res_336350 = defunc_1_add_res_336353;
        }
        
        double defunc_0_f_res_336354;
        
        if (cond_336349) {
            defunc_0_f_res_336354 = 0.0;
        } else {
            int64_t i_336355 = add64(x_336045, gtid_336342);
            double defunc_0_add_arg_336356;
            
            defunc_0_add_arg_336356 = ((double *) mem_316533.mem)[i_336355];
            defunc_0_f_res_336354 = defunc_0_add_arg_336356;
        }
        
        int64_t binop_p_336357 = sub64(defunc_0_f_res_336350,
                                       defunc_0_g_res_336049);
        double defunc_0_f_res_336358 = sitofp_i64_f64(binop_p_336357);
        double abs_res_336359 = fabs(defunc_0_f_res_336358);
        double tmp1_336360 = abs_res_336359 / x_336046;
        double x_336361 = tmp1_336360 * tmp1_336360;
        double y_336362 = tmp1_336360 * x_336361;
        double tmp2_336363 = 1.0 - y_336362;
        double x_336364 = tmp2_336363 * tmp2_336363;
        double tmp3_336365 = tmp2_336363 * x_336364;
        double tmp4_336366 = defunc_0_f_res_336354 * tmp3_336365;
        double defunc_1_f_res_336367 = defunc_0_f_res_336358 * tmp4_336366;
        double defunc_0_f_res_336368;
        
        if (cond_336349) {
            defunc_0_f_res_336368 = 0.0;
        } else {
            int64_t i_336369 = add64(x_336045, gtid_336342);
            double defunc_0_add_arg_336370;
            
            defunc_0_add_arg_336370 = ((double *) mem_316536.mem)[i_336369];
            defunc_0_f_res_336368 = defunc_0_add_arg_336370;
        }
        
        double x_336371 = a11_336091 * tmp4_336366;
        double y_336372 = b11_336093 * defunc_1_f_res_336367;
        double x_336373 = x_336371 + y_336372;
        double defunc_9_fit_fun_res_336374 = defunc_0_f_res_336368 * x_336373;
        double x_336375 = b11_336093 * tmp4_336366;
        double y_336376 = c11_336094 * defunc_1_f_res_336367;
        double x_336377 = x_336375 + y_336376;
        double defunc_9_slope_fun_res_336378 = defunc_0_f_res_336368 * x_336377;
        
        // save map-out results
        { }
        // Load accum params
        {
            x_336343 = local_acc_336408;
        }
        // Load next params
        {
            x_336344 = defunc_9_fit_fun_res_336374;
        }
        // Red body
        {
            double defunc_1_op_res_336345 = x_336343 + x_336344;
            
            local_acc_336408 = defunc_1_op_res_336345;
        }
        // Load accum params
        {
            x_336346 = local_acc_336409;
        }
        // Load next params
        {
            x_336347 = defunc_9_slope_fun_res_336378;
        }
        // Red body
        {
            double defunc_1_op_res_336348 = x_336346 + x_336347;
            
            local_acc_336409 = defunc_1_op_res_336348;
        }
    }
    ((double *) reduce_stage_1_tid_res_arr_mem_336403.mem)[flat_tid_336341] =
        local_acc_336408;
    ((double *) reduce_stage_1_tid_res_arr_mem_336405.mem)[flat_tid_336341] =
        local_acc_336409;
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_339133_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_339133_end -
                 futhark_mc_segred_stage_1_parloop_339133_start;
        
        ctx->futhark_mc_segred_stage_1_parloop_339133_runs[tid]++;
        ctx->futhark_mc_segred_stage_1_parloop_339133_total_runtime[tid] +=
            elapsed;
        ctx->futhark_mc_segred_stage_1_parloop_339133_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segred_task_339129(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_336341 = tid;
    int num_tasks_336402 = info.nsubtasks;
    struct futhark_mc_task_339128 *futhark_mc_task_339128 =
                                  (struct futhark_mc_task_339128 *) args;
    struct futhark_context *ctx = futhark_mc_task_339128->ctx;
    uint64_t futhark_mc_segred_task_339129_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_task_339129_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_339128->free_n_292675;
    int64_t gtid_309770 = futhark_mc_task_339128->free_gtid_309770;
    int64_t x_309775 = futhark_mc_task_339128->free_x_309775;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_task_339128->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_316533 = {.desc ="mem_316533", .mem =
                                  futhark_mc_task_339128->free_mem_316533,
                                  .size =0, .references =NULL};
    struct memblock mem_316536 = {.desc ="mem_316536", .mem =
                                  futhark_mc_task_339128->free_mem_316536,
                                  .size =0, .references =NULL};
    int64_t x_336045 = futhark_mc_task_339128->free_x_336045;
    double x_336046 = futhark_mc_task_339128->free_x_336046;
    int64_t defunc_0_g_res_336049 =
            futhark_mc_task_339128->free_defunc_0_g_res_336049;
    double a11_336091 = futhark_mc_task_339128->free_a11_336091;
    double b11_336093 = futhark_mc_task_339128->free_b11_336093;
    double c11_336094 = futhark_mc_task_339128->free_c11_336094;
    double defunc_2_reduce_res_336095 =
           *futhark_mc_task_339128->retval_defunc_2_reduce_res_336095;
    double defunc_2_reduce_res_336096 =
           *futhark_mc_task_339128->retval_defunc_2_reduce_res_336096;
    size_t reduce_stage_1_tid_res_arr_mem_336403_cached_sizze_339130 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_336403 = NULL;
    size_t reduce_stage_1_tid_res_arr_mem_336405_cached_sizze_339131 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_336405 = NULL;
    
    if (reduce_stage_1_tid_res_arr_mem_336403_cached_sizze_339130 <
        (size_t) ((int64_t) 8 * num_tasks_336402)) {
        reduce_stage_1_tid_res_arr_mem_336403 =
            realloc(reduce_stage_1_tid_res_arr_mem_336403, (int64_t) 8 *
                    num_tasks_336402);
        reduce_stage_1_tid_res_arr_mem_336403_cached_sizze_339130 =
            (int64_t) 8 * num_tasks_336402;
    }
    if (reduce_stage_1_tid_res_arr_mem_336405_cached_sizze_339131 <
        (size_t) ((int64_t) 8 * num_tasks_336402)) {
        reduce_stage_1_tid_res_arr_mem_336405 =
            realloc(reduce_stage_1_tid_res_arr_mem_336405, (int64_t) 8 *
                    num_tasks_336402);
        reduce_stage_1_tid_res_arr_mem_336405_cached_sizze_339131 =
            (int64_t) 8 * num_tasks_336402;
    }
    
    int64_t iter_336407;
    struct futhark_mc_segred_stage_1_parloop_struct_339132
    futhark_mc_segred_stage_1_parloop_struct_339132;
    
    futhark_mc_segred_stage_1_parloop_struct_339132.ctx = ctx;
    futhark_mc_segred_stage_1_parloop_struct_339132.free_n_292675 = n_292675;
    futhark_mc_segred_stage_1_parloop_struct_339132.free_gtid_309770 =
        gtid_309770;
    futhark_mc_segred_stage_1_parloop_struct_339132.free_x_309775 = x_309775;
    futhark_mc_segred_stage_1_parloop_struct_339132.free_mem_312636 =
        mem_312636.mem;
    futhark_mc_segred_stage_1_parloop_struct_339132.free_mem_316533 =
        mem_316533.mem;
    futhark_mc_segred_stage_1_parloop_struct_339132.free_mem_316536 =
        mem_316536.mem;
    futhark_mc_segred_stage_1_parloop_struct_339132.free_x_336045 = x_336045;
    futhark_mc_segred_stage_1_parloop_struct_339132.free_x_336046 = x_336046;
    futhark_mc_segred_stage_1_parloop_struct_339132.free_defunc_0_g_res_336049 =
        defunc_0_g_res_336049;
    futhark_mc_segred_stage_1_parloop_struct_339132.free_a11_336091 =
        a11_336091;
    futhark_mc_segred_stage_1_parloop_struct_339132.free_b11_336093 =
        b11_336093;
    futhark_mc_segred_stage_1_parloop_struct_339132.free_c11_336094 =
        c11_336094;
    futhark_mc_segred_stage_1_parloop_struct_339132.free_reduce_stage_1_tid_res_arr_mem_336403 =
        reduce_stage_1_tid_res_arr_mem_336403;
    futhark_mc_segred_stage_1_parloop_struct_339132.free_reduce_stage_1_tid_res_arr_mem_336405 =
        reduce_stage_1_tid_res_arr_mem_336405;
    
    struct scheduler_parloop futhark_mc_segred_stage_1_parloop_339133_task;
    
    futhark_mc_segred_stage_1_parloop_339133_task.name =
        "futhark_mc_segred_stage_1_parloop_339133";
    futhark_mc_segred_stage_1_parloop_339133_task.fn =
        futhark_mc_segred_stage_1_parloop_339133;
    futhark_mc_segred_stage_1_parloop_339133_task.args =
        &futhark_mc_segred_stage_1_parloop_struct_339132;
    futhark_mc_segred_stage_1_parloop_339133_task.iterations = iterations;
    futhark_mc_segred_stage_1_parloop_339133_task.info = info;
    
    uint64_t futhark_mc_segred_stage_1_parloop_339133_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_339133_total_start = get_wall_time();
    
    int futhark_mc_segred_stage_1_parloop_339133_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segred_stage_1_parloop_339133_task);
    
    if (futhark_mc_segred_stage_1_parloop_339133_err != 0) {
        err = futhark_mc_segred_stage_1_parloop_339133_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_339133_total_end =
                 get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_339133_total_end -
                 futhark_mc_segred_stage_1_parloop_339133_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_339133_total_runs,
                           1, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_339133_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_339133_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    // neutral-initialise the output
    {
        defunc_2_reduce_res_336095 = 0.0;
        defunc_2_reduce_res_336096 = 0.0;
    }
    
    double x_336410;
    double x_336411;
    double x_336413;
    double x_336414;
    
    for (int32_t i_336416 = 0; i_336416 < num_tasks_336402; i_336416++) {
        flat_tid_336341 = i_336416;
        // Apply main thread reduction
        {
            // load acc params
            {
                x_336410 = defunc_2_reduce_res_336095;
            }
            // load next params
            {
                x_336411 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_336403)[flat_tid_336341];
            }
            // red body
            {
                double defunc_1_op_res_336412 = x_336410 + x_336411;
                
                defunc_2_reduce_res_336095 = defunc_1_op_res_336412;
            }
            // load acc params
            {
                x_336413 = defunc_2_reduce_res_336096;
            }
            // load next params
            {
                x_336414 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_336405)[flat_tid_336341];
            }
            // red body
            {
                double defunc_1_op_res_336415 = x_336413 + x_336414;
                
                defunc_2_reduce_res_336096 = defunc_1_op_res_336415;
            }
        }
    }
    
  cleanup:
    {
        free(reduce_stage_1_tid_res_arr_mem_336403);
        free(reduce_stage_1_tid_res_arr_mem_336405);
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_task_339129_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_task_339129_end -
                 futhark_mc_segred_task_339129_start;
        
        ctx->futhark_mc_segred_task_339129_runs[tid]++;
        ctx->futhark_mc_segred_task_339129_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segred_task_339129_iter[tid] += iterations;
    }
    if (err == 0) {
        *futhark_mc_task_339128->retval_defunc_2_reduce_res_336095 =
            defunc_2_reduce_res_336095;
        *futhark_mc_task_339128->retval_defunc_2_reduce_res_336096 =
            defunc_2_reduce_res_336096;
    }
    return err;
}
static int futhark_mc_segmap_parloop_339120(void *args, int64_t start,
                                            int64_t end, int flat_tid_336043,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_339119
    *futhark_mc_segmap_parloop_struct_339119 =
    (struct futhark_mc_segmap_parloop_struct_339119 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_339119->ctx;
    uint64_t futhark_mc_segmap_parloop_339120_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339120_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_339119->free_n_292675;
    int64_t q_t_292679 =
            futhark_mc_segmap_parloop_struct_339119->free_q_t_292679;
    int64_t jump_t_292685 =
            futhark_mc_segmap_parloop_struct_339119->free_jump_t_292685;
    int64_t t_n_m_292839 =
            futhark_mc_segmap_parloop_struct_339119->free_t_n_m_292839;
    int64_t i_292846 = futhark_mc_segmap_parloop_struct_339119->free_i_292846;
    int64_t gtid_309770 =
            futhark_mc_segmap_parloop_struct_339119->free_gtid_309770;
    int64_t x_309775 = futhark_mc_segmap_parloop_struct_339119->free_x_309775;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_segmap_parloop_struct_339119->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_313143 = {.desc ="mem_313143", .mem =
                                  futhark_mc_segmap_parloop_struct_339119->free_mem_313143,
                                  .size =0, .references =NULL};
    struct memblock mem_313147 = {.desc ="mem_313147", .mem =
                                  futhark_mc_segmap_parloop_struct_339119->free_mem_313147,
                                  .size =0, .references =NULL};
    struct memblock mem_316533 = {.desc ="mem_316533", .mem =
                                  futhark_mc_segmap_parloop_struct_339119->free_mem_316533,
                                  .size =0, .references =NULL};
    struct memblock mem_316536 = {.desc ="mem_316536", .mem =
                                  futhark_mc_segmap_parloop_struct_339119->free_mem_316536,
                                  .size =0, .references =NULL};
    struct memblock mem_316539 = {.desc ="mem_316539", .mem =
                                  futhark_mc_segmap_parloop_struct_339119->free_mem_316539,
                                  .size =0, .references =NULL};
    struct memblock mem_316542 = {.desc ="mem_316542", .mem =
                                  futhark_mc_segmap_parloop_struct_339119->free_mem_316542,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_336309 = start;
    
    for (; iter_336309 < end; iter_336309++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_336379 = t_n_m_292839;
        int64_t gtid_336044 = iter_336309;
        int64_t remnant_336380 = iter_336309 - gtid_336044;
        int64_t x_336045;
        
        x_336045 = ((int64_t *) mem_313143.mem)[gtid_309770 * t_n_m_292839 +
                                                gtid_336044];
        
        double x_336046;
        
        x_336046 = ((double *) mem_313147.mem)[gtid_309770 * t_n_m_292839 +
                                               gtid_336044];
        
        int64_t min_arg_336047 = mul64(jump_t_292685, gtid_336044);
        int64_t min_res_336048 = smin64(i_292846, min_arg_336047);
        int64_t defunc_0_g_res_336049 = add64((int64_t) 1, min_res_336048);
        double defunc_2_reduce_res_336050;
        double defunc_2_reduce_res_336051;
        double defunc_2_reduce_res_336052;
        int64_t flat_tid_336310 = (int64_t) 0;
        int32_t num_tasks_336381;
        
        defunc_2_reduce_res_336050 = 0.0;
        defunc_2_reduce_res_336051 = 0.0;
        defunc_2_reduce_res_336052 = 0.0;
        
        struct futhark_mc_task_339121 futhark_mc_task_339121;
        
        futhark_mc_task_339121.ctx = ctx;
        futhark_mc_task_339121.free_n_292675 = n_292675;
        futhark_mc_task_339121.free_gtid_309770 = gtid_309770;
        futhark_mc_task_339121.free_x_309775 = x_309775;
        futhark_mc_task_339121.free_mem_312636 = mem_312636.mem;
        futhark_mc_task_339121.free_mem_316533 = mem_316533.mem;
        futhark_mc_task_339121.free_x_336045 = x_336045;
        futhark_mc_task_339121.free_x_336046 = x_336046;
        futhark_mc_task_339121.free_defunc_0_g_res_336049 =
            defunc_0_g_res_336049;
        futhark_mc_task_339121.retval_defunc_2_reduce_res_336050 =
            &defunc_2_reduce_res_336050;
        futhark_mc_task_339121.retval_defunc_2_reduce_res_336051 =
            &defunc_2_reduce_res_336051;
        futhark_mc_task_339121.retval_defunc_2_reduce_res_336052 =
            &defunc_2_reduce_res_336052;
        
        struct scheduler_segop futhark_mc_task_339121_task;
        
        futhark_mc_task_339121_task.args = &futhark_mc_task_339121;
        futhark_mc_task_339121_task.top_level_fn =
            futhark_mc_segred_task_339122;
        futhark_mc_task_339121_task.name = "futhark_mc_segred_task_339122";
        futhark_mc_task_339121_task.iterations = q_t_292679;
        futhark_mc_task_339121_task.task_time =
            &ctx->futhark_mc_segred_task_339122_total_time;
        futhark_mc_task_339121_task.task_iter =
            &ctx->futhark_mc_segred_task_339122_total_iter;
        futhark_mc_task_339121_task.sched = STATIC;
        futhark_mc_task_339121_task.nested_fn = NULL;
        
        int futhark_mc_segred_task_339122_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_339121_task);
        
        if (futhark_mc_segred_task_339122_err != 0) {
            ;
            err = futhark_mc_segred_task_339122_err;
            goto cleanup;
        }
        
        double a_336084 = 2.220446049250313e-16 + defunc_2_reduce_res_336050;
        double b_336085 = 2.220446049250313e-16 + defunc_2_reduce_res_336051;
        double c_336086 = 2.220446049250313e-16 + defunc_2_reduce_res_336052;
        double x_336087 = a_336084 * c_336086;
        double y_336088 = b_336085 * b_336085;
        double y_336089 = x_336087 - y_336088;
        double det1_336090 = 1.0 / y_336089;
        double a11_336091 = c_336086 * det1_336090;
        double x_336092 = 0.0 - b_336085;
        double b11_336093 = det1_336090 * x_336092;
        double c11_336094 = a_336084 * det1_336090;
        double defunc_2_reduce_res_336095;
        double defunc_2_reduce_res_336096;
        int64_t flat_tid_336341 = (int64_t) 0;
        int32_t num_tasks_336402;
        
        defunc_2_reduce_res_336095 = 0.0;
        defunc_2_reduce_res_336096 = 0.0;
        
        struct futhark_mc_task_339128 futhark_mc_task_339128;
        
        futhark_mc_task_339128.ctx = ctx;
        futhark_mc_task_339128.free_n_292675 = n_292675;
        futhark_mc_task_339128.free_gtid_309770 = gtid_309770;
        futhark_mc_task_339128.free_x_309775 = x_309775;
        futhark_mc_task_339128.free_mem_312636 = mem_312636.mem;
        futhark_mc_task_339128.free_mem_316533 = mem_316533.mem;
        futhark_mc_task_339128.free_mem_316536 = mem_316536.mem;
        futhark_mc_task_339128.free_x_336045 = x_336045;
        futhark_mc_task_339128.free_x_336046 = x_336046;
        futhark_mc_task_339128.free_defunc_0_g_res_336049 =
            defunc_0_g_res_336049;
        futhark_mc_task_339128.free_a11_336091 = a11_336091;
        futhark_mc_task_339128.free_b11_336093 = b11_336093;
        futhark_mc_task_339128.free_c11_336094 = c11_336094;
        futhark_mc_task_339128.retval_defunc_2_reduce_res_336095 =
            &defunc_2_reduce_res_336095;
        futhark_mc_task_339128.retval_defunc_2_reduce_res_336096 =
            &defunc_2_reduce_res_336096;
        
        struct scheduler_segop futhark_mc_task_339128_task;
        
        futhark_mc_task_339128_task.args = &futhark_mc_task_339128;
        futhark_mc_task_339128_task.top_level_fn =
            futhark_mc_segred_task_339129;
        futhark_mc_task_339128_task.name = "futhark_mc_segred_task_339129";
        futhark_mc_task_339128_task.iterations = q_t_292679;
        futhark_mc_task_339128_task.task_time =
            &ctx->futhark_mc_segred_task_339129_total_time;
        futhark_mc_task_339128_task.task_iter =
            &ctx->futhark_mc_segred_task_339129_total_iter;
        futhark_mc_task_339128_task.sched = STATIC;
        futhark_mc_task_339128_task.nested_fn = NULL;
        
        int futhark_mc_segred_task_339129_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_339128_task);
        
        if (futhark_mc_segred_task_339129_err != 0) {
            ;
            err = futhark_mc_segred_task_339129_err;
            goto cleanup;
        }
        ((double *) mem_316539.mem)[gtid_336044] = defunc_2_reduce_res_336095;
        ((double *) mem_316542.mem)[gtid_336044] = defunc_2_reduce_res_336096;
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339120_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339120_end -
                 futhark_mc_segmap_parloop_339120_start;
        
        ctx->futhark_mc_segmap_parloop_339120_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_339120_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_339120_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_nested_task_339118(void *args, int64_t iterations,
                                         int tid, struct scheduler_info info)
{
    int err = 0;
    int flat_tid_336043 = tid;
    int num_tasks_336238 = info.nsubtasks;
    struct futhark_mc_task_339114 *futhark_mc_task_339114 =
                                  (struct futhark_mc_task_339114 *) args;
    struct futhark_context *ctx = futhark_mc_task_339114->ctx;
    uint64_t futhark_mc_segmap_nested_task_339118_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_nested_task_339118_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_339114->free_n_292675;
    int64_t q_t_292679 = futhark_mc_task_339114->free_q_t_292679;
    int64_t jump_t_292685 = futhark_mc_task_339114->free_jump_t_292685;
    int64_t t_n_m_292839 = futhark_mc_task_339114->free_t_n_m_292839;
    int64_t i_292846 = futhark_mc_task_339114->free_i_292846;
    int64_t gtid_309770 = futhark_mc_task_339114->free_gtid_309770;
    int64_t x_309775 = futhark_mc_task_339114->free_x_309775;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_task_339114->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_313143 = {.desc ="mem_313143", .mem =
                                  futhark_mc_task_339114->free_mem_313143,
                                  .size =0, .references =NULL};
    struct memblock mem_313147 = {.desc ="mem_313147", .mem =
                                  futhark_mc_task_339114->free_mem_313147,
                                  .size =0, .references =NULL};
    struct memblock mem_316533 = {.desc ="mem_316533", .mem =
                                  futhark_mc_task_339114->free_mem_316533,
                                  .size =0, .references =NULL};
    struct memblock mem_316536 = {.desc ="mem_316536", .mem =
                                  futhark_mc_task_339114->free_mem_316536,
                                  .size =0, .references =NULL};
    struct memblock mem_316539 = {.desc ="mem_316539", .mem =
                                  futhark_mc_task_339114->free_mem_316539,
                                  .size =0, .references =NULL};
    struct memblock mem_316542 = {.desc ="mem_316542", .mem =
                                  futhark_mc_task_339114->free_mem_316542,
                                  .size =0, .references =NULL};
    int64_t iter_336309;
    struct futhark_mc_segmap_parloop_struct_339119
    futhark_mc_segmap_parloop_struct_339119;
    
    futhark_mc_segmap_parloop_struct_339119.ctx = ctx;
    futhark_mc_segmap_parloop_struct_339119.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_339119.free_q_t_292679 = q_t_292679;
    futhark_mc_segmap_parloop_struct_339119.free_jump_t_292685 = jump_t_292685;
    futhark_mc_segmap_parloop_struct_339119.free_t_n_m_292839 = t_n_m_292839;
    futhark_mc_segmap_parloop_struct_339119.free_i_292846 = i_292846;
    futhark_mc_segmap_parloop_struct_339119.free_gtid_309770 = gtid_309770;
    futhark_mc_segmap_parloop_struct_339119.free_x_309775 = x_309775;
    futhark_mc_segmap_parloop_struct_339119.free_mem_312636 = mem_312636.mem;
    futhark_mc_segmap_parloop_struct_339119.free_mem_313143 = mem_313143.mem;
    futhark_mc_segmap_parloop_struct_339119.free_mem_313147 = mem_313147.mem;
    futhark_mc_segmap_parloop_struct_339119.free_mem_316533 = mem_316533.mem;
    futhark_mc_segmap_parloop_struct_339119.free_mem_316536 = mem_316536.mem;
    futhark_mc_segmap_parloop_struct_339119.free_mem_316539 = mem_316539.mem;
    futhark_mc_segmap_parloop_struct_339119.free_mem_316542 = mem_316542.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_339120_task;
    
    futhark_mc_segmap_parloop_339120_task.name =
        "futhark_mc_segmap_parloop_339120";
    futhark_mc_segmap_parloop_339120_task.fn = futhark_mc_segmap_parloop_339120;
    futhark_mc_segmap_parloop_339120_task.args =
        &futhark_mc_segmap_parloop_struct_339119;
    futhark_mc_segmap_parloop_339120_task.iterations = iterations;
    futhark_mc_segmap_parloop_339120_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_339120_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339120_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_339120_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_339120_task);
    
    if (futhark_mc_segmap_parloop_339120_err != 0) {
        err = futhark_mc_segmap_parloop_339120_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339120_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339120_total_end -
                 futhark_mc_segmap_parloop_339120_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339120_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339120_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339120_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_nested_task_339118_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_nested_task_339118_end -
                 futhark_mc_segmap_nested_task_339118_start;
        
        ctx->futhark_mc_segmap_nested_task_339118_runs[tid]++;
        ctx->futhark_mc_segmap_nested_task_339118_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_nested_task_339118_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
static int futhark_mc_segmap_parloop_339100(void *args, int64_t start,
                                            int64_t end, int flat_tid_309769,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_339099
    *futhark_mc_segmap_parloop_struct_339099 =
    (struct futhark_mc_segmap_parloop_struct_339099 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_339099->ctx;
    uint64_t futhark_mc_segmap_parloop_339100_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339100_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_339099->free_n_292675;
    int64_t q_t_292679 =
            futhark_mc_segmap_parloop_struct_339099->free_q_t_292679;
    int64_t jump_t_292685 =
            futhark_mc_segmap_parloop_struct_339099->free_jump_t_292685;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_339099->free_partition_sizze_292766;
    int64_t t_n_m_292839 =
            futhark_mc_segmap_parloop_struct_339099->free_t_n_m_292839;
    int64_t i_292846 = futhark_mc_segmap_parloop_struct_339099->free_i_292846;
    struct memblock mem_312593 = {.desc ="mem_312593", .mem =
                                  futhark_mc_segmap_parloop_struct_339099->free_mem_312593,
                                  .size =0, .references =NULL};
    int64_t bytes_312598 =
            futhark_mc_segmap_parloop_struct_339099->free_bytes_312598;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_segmap_parloop_struct_339099->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_312639 = {.desc ="mem_312639", .mem =
                                  futhark_mc_segmap_parloop_struct_339099->free_mem_312639,
                                  .size =0, .references =NULL};
    int64_t bytes_313090 =
            futhark_mc_segmap_parloop_struct_339099->free_bytes_313090;
    struct memblock mem_313143 = {.desc ="mem_313143", .mem =
                                  futhark_mc_segmap_parloop_struct_339099->free_mem_313143,
                                  .size =0, .references =NULL};
    struct memblock mem_313147 = {.desc ="mem_313147", .mem =
                                  futhark_mc_segmap_parloop_struct_339099->free_mem_313147,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_segmap_parloop_struct_339099->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_segmap_parloop_struct_339099->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_segmap_parloop_struct_339099->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_segmap_parloop_struct_339099->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315656 = {.desc ="mem_315656", .mem =
                                  futhark_mc_segmap_parloop_struct_339099->free_mem_315656,
                                  .size =0, .references =NULL};
    struct memblock mem_316621 = {.desc ="mem_316621", .mem =
                                  futhark_mc_segmap_parloop_struct_339099->free_mem_316621,
                                  .size =0, .references =NULL};
    struct memblock mem_316625 = {.desc ="mem_316625", .mem =
                                  futhark_mc_segmap_parloop_struct_339099->free_mem_316625,
                                  .size =0, .references =NULL};
    size_t mem_316530_cached_sizze_339101 = 0;
    unsigned char *mem_316530 = NULL;
    size_t mem_316533_cached_sizze_339102 = 0;
    unsigned char *mem_316533 = NULL;
    size_t mem_316536_cached_sizze_339103 = 0;
    unsigned char *mem_316536 = NULL;
    size_t mem_316539_cached_sizze_339104 = 0;
    unsigned char *mem_316539 = NULL;
    size_t mem_316542_cached_sizze_339105 = 0;
    unsigned char *mem_316542 = NULL;
    int64_t iterations = end - start;
    int64_t iter_336022 = start;
    
    if (mem_316530_cached_sizze_339101 < (size_t) bytes_312598) {
        mem_316530 = realloc(mem_316530, bytes_312598);
        mem_316530_cached_sizze_339101 = bytes_312598;
    }
    if (mem_316533_cached_sizze_339102 < (size_t) bytes_312598) {
        mem_316533 = realloc(mem_316533, bytes_312598);
        mem_316533_cached_sizze_339102 = bytes_312598;
    }
    if (mem_316536_cached_sizze_339103 < (size_t) bytes_312598) {
        mem_316536 = realloc(mem_316536, bytes_312598);
        mem_316536_cached_sizze_339103 = bytes_312598;
    }
    if (mem_316539_cached_sizze_339104 < (size_t) bytes_313090) {
        mem_316539 = realloc(mem_316539, bytes_313090);
        mem_316539_cached_sizze_339104 = bytes_313090;
    }
    if (mem_316542_cached_sizze_339105 < (size_t) bytes_313090) {
        mem_316542 = realloc(mem_316542, bytes_313090);
        mem_316542_cached_sizze_339105 = bytes_313090;
    }
    for (; iter_336022 < end; iter_336022++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_336220 = partition_sizze_292766;
        int64_t gtid_309770 = iter_336022;
        int64_t remnant_336221 = iter_336022 - gtid_309770;
        int64_t x_309775;
        
        x_309775 = ((int64_t *) mem_312639.mem)[gtid_309770];
        
        int64_t flat_tid_336023 = (int64_t) 0;
        int32_t num_tasks_336222;
        struct futhark_mc_task_339106 futhark_mc_task_339106;
        
        futhark_mc_task_339106.ctx = ctx;
        futhark_mc_task_339106.free_n_292675 = n_292675;
        futhark_mc_task_339106.free_gtid_309770 = gtid_309770;
        futhark_mc_task_339106.free_mem_312593 = mem_312593.mem;
        futhark_mc_task_339106.free_mem_315656 = mem_315656.mem;
        futhark_mc_task_339106.free_mem_316530 = mem_316530;
        
        struct scheduler_segop futhark_mc_task_339106_task;
        
        futhark_mc_task_339106_task.args = &futhark_mc_task_339106;
        futhark_mc_task_339106_task.top_level_fn =
            futhark_mc_segmap_task_339107;
        futhark_mc_task_339106_task.name = "futhark_mc_segmap_task_339107";
        futhark_mc_task_339106_task.iterations = n_292675;
        futhark_mc_task_339106_task.task_time =
            &ctx->futhark_mc_segmap_task_339107_total_time;
        futhark_mc_task_339106_task.task_iter =
            &ctx->futhark_mc_segmap_task_339107_total_iter;
        futhark_mc_task_339106_task.sched = STATIC;
        futhark_mc_task_339106_task.nested_fn = NULL;
        
        int futhark_mc_segmap_task_339107_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_339106_task);
        
        if (futhark_mc_segmap_task_339107_err != 0) {
            ;
            err = futhark_mc_segmap_task_339107_err;
            goto cleanup;
        }
        
        int64_t flat_tid_336029 = (int64_t) 0;
        int32_t num_tasks_336226;
        struct futhark_mc_task_339110 futhark_mc_task_339110;
        
        futhark_mc_task_339110.ctx = ctx;
        futhark_mc_task_339110.free_n_292675 = n_292675;
        futhark_mc_task_339110.free_gtid_309770 = gtid_309770;
        futhark_mc_task_339110.free_mem_312636 = mem_312636.mem;
        futhark_mc_task_339110.free_ctx_param_ext_313174 = ctx_param_ext_313174;
        futhark_mc_task_339110.free_ctx_param_ext_313175 = ctx_param_ext_313175;
        futhark_mc_task_339110.free_ctx_param_ext_313177 = ctx_param_ext_313177;
        futhark_mc_task_339110.free_mem_param_313179 = mem_param_313179.mem;
        futhark_mc_task_339110.free_mem_316530 = mem_316530;
        futhark_mc_task_339110.free_mem_316533 = mem_316533;
        futhark_mc_task_339110.free_mem_316536 = mem_316536;
        
        struct scheduler_segop futhark_mc_task_339110_task;
        
        futhark_mc_task_339110_task.args = &futhark_mc_task_339110;
        futhark_mc_task_339110_task.top_level_fn =
            futhark_mc_segmap_task_339111;
        futhark_mc_task_339110_task.name = "futhark_mc_segmap_task_339111";
        futhark_mc_task_339110_task.iterations = n_292675;
        futhark_mc_task_339110_task.task_time =
            &ctx->futhark_mc_segmap_task_339111_total_time;
        futhark_mc_task_339110_task.task_iter =
            &ctx->futhark_mc_segmap_task_339111_total_iter;
        futhark_mc_task_339110_task.sched = STATIC;
        futhark_mc_task_339110_task.nested_fn = NULL;
        
        int futhark_mc_segmap_task_339111_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_339110_task);
        
        if (futhark_mc_segmap_task_339111_err != 0) {
            ;
            err = futhark_mc_segmap_task_339111_err;
            goto cleanup;
        }
        
        int64_t flat_tid_336135 = (int64_t) 0;
        int32_t num_tasks_336238;
        int64_t flat_tid_336043 = (int64_t) 0;
        struct futhark_mc_task_339114 futhark_mc_task_339114;
        
        futhark_mc_task_339114.ctx = ctx;
        futhark_mc_task_339114.free_n_292675 = n_292675;
        futhark_mc_task_339114.free_q_t_292679 = q_t_292679;
        futhark_mc_task_339114.free_jump_t_292685 = jump_t_292685;
        futhark_mc_task_339114.free_t_n_m_292839 = t_n_m_292839;
        futhark_mc_task_339114.free_i_292846 = i_292846;
        futhark_mc_task_339114.free_gtid_309770 = gtid_309770;
        futhark_mc_task_339114.free_x_309775 = x_309775;
        futhark_mc_task_339114.free_mem_312636 = mem_312636.mem;
        futhark_mc_task_339114.free_mem_313143 = mem_313143.mem;
        futhark_mc_task_339114.free_mem_313147 = mem_313147.mem;
        futhark_mc_task_339114.free_mem_316533 = mem_316533;
        futhark_mc_task_339114.free_mem_316536 = mem_316536;
        futhark_mc_task_339114.free_mem_316539 = mem_316539;
        futhark_mc_task_339114.free_mem_316542 = mem_316542;
        
        struct scheduler_segop futhark_mc_task_339114_task;
        
        futhark_mc_task_339114_task.args = &futhark_mc_task_339114;
        futhark_mc_task_339114_task.top_level_fn =
            futhark_mc_segmap_task_339115;
        futhark_mc_task_339114_task.name = "futhark_mc_segmap_task_339115";
        futhark_mc_task_339114_task.iterations = t_n_m_292839;
        futhark_mc_task_339114_task.task_time =
            &ctx->futhark_mc_segmap_task_339115_total_time;
        futhark_mc_task_339114_task.task_iter =
            &ctx->futhark_mc_segmap_task_339115_total_iter;
        futhark_mc_task_339114_task.sched = STATIC;
        futhark_mc_task_339114_task.nested_fn =
            futhark_mc_segmap_nested_task_339118;
        
        int futhark_mc_segmap_task_339115_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_339114_task);
        
        if (futhark_mc_segmap_task_339115_err != 0) {
            ;
            err = futhark_mc_segmap_task_339115_err;
            goto cleanup;
        }
        if (t_n_m_292839 * (int64_t) 8 > 0)
            memmove(mem_316621.mem + gtid_309770 * t_n_m_292839 * (int64_t) 8,
                    mem_316539 + (int64_t) 0, t_n_m_292839 * (int64_t) 8);
        if (t_n_m_292839 * (int64_t) 8 > 0)
            memmove(mem_316625.mem + gtid_309770 * t_n_m_292839 * (int64_t) 8,
                    mem_316542 + (int64_t) 0, t_n_m_292839 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_316530);
    free(mem_316533);
    free(mem_316536);
    free(mem_316539);
    free(mem_316542);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339100_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339100_end -
                 futhark_mc_segmap_parloop_339100_start;
        
        ctx->futhark_mc_segmap_parloop_339100_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_339100_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_339100_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_nested_task_339098(void *args, int64_t iterations,
                                         int tid, struct scheduler_info info)
{
    int err = 0;
    int flat_tid_309769 = tid;
    int num_tasks_335896 = info.nsubtasks;
    struct futhark_mc_task_339089 *futhark_mc_task_339089 =
                                  (struct futhark_mc_task_339089 *) args;
    struct futhark_context *ctx = futhark_mc_task_339089->ctx;
    uint64_t futhark_mc_segmap_nested_task_339098_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_nested_task_339098_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_339089->free_n_292675;
    int64_t q_t_292679 = futhark_mc_task_339089->free_q_t_292679;
    int64_t jump_t_292685 = futhark_mc_task_339089->free_jump_t_292685;
    int64_t partition_sizze_292766 =
            futhark_mc_task_339089->free_partition_sizze_292766;
    int64_t t_n_m_292839 = futhark_mc_task_339089->free_t_n_m_292839;
    int64_t i_292846 = futhark_mc_task_339089->free_i_292846;
    struct memblock mem_312593 = {.desc ="mem_312593", .mem =
                                  futhark_mc_task_339089->free_mem_312593,
                                  .size =0, .references =NULL};
    int64_t bytes_312598 = futhark_mc_task_339089->free_bytes_312598;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_task_339089->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_312639 = {.desc ="mem_312639", .mem =
                                  futhark_mc_task_339089->free_mem_312639,
                                  .size =0, .references =NULL};
    int64_t bytes_313090 = futhark_mc_task_339089->free_bytes_313090;
    struct memblock mem_313143 = {.desc ="mem_313143", .mem =
                                  futhark_mc_task_339089->free_mem_313143,
                                  .size =0, .references =NULL};
    struct memblock mem_313147 = {.desc ="mem_313147", .mem =
                                  futhark_mc_task_339089->free_mem_313147,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_task_339089->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_task_339089->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_task_339089->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_task_339089->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315656 = {.desc ="mem_315656", .mem =
                                  futhark_mc_task_339089->free_mem_315656,
                                  .size =0, .references =NULL};
    struct memblock mem_316621 = {.desc ="mem_316621", .mem =
                                  futhark_mc_task_339089->free_mem_316621,
                                  .size =0, .references =NULL};
    struct memblock mem_316625 = {.desc ="mem_316625", .mem =
                                  futhark_mc_task_339089->free_mem_316625,
                                  .size =0, .references =NULL};
    int64_t iter_336022;
    struct futhark_mc_segmap_parloop_struct_339099
    futhark_mc_segmap_parloop_struct_339099;
    
    futhark_mc_segmap_parloop_struct_339099.ctx = ctx;
    futhark_mc_segmap_parloop_struct_339099.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_339099.free_q_t_292679 = q_t_292679;
    futhark_mc_segmap_parloop_struct_339099.free_jump_t_292685 = jump_t_292685;
    futhark_mc_segmap_parloop_struct_339099.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_339099.free_t_n_m_292839 = t_n_m_292839;
    futhark_mc_segmap_parloop_struct_339099.free_i_292846 = i_292846;
    futhark_mc_segmap_parloop_struct_339099.free_mem_312593 = mem_312593.mem;
    futhark_mc_segmap_parloop_struct_339099.free_bytes_312598 = bytes_312598;
    futhark_mc_segmap_parloop_struct_339099.free_mem_312636 = mem_312636.mem;
    futhark_mc_segmap_parloop_struct_339099.free_mem_312639 = mem_312639.mem;
    futhark_mc_segmap_parloop_struct_339099.free_bytes_313090 = bytes_313090;
    futhark_mc_segmap_parloop_struct_339099.free_mem_313143 = mem_313143.mem;
    futhark_mc_segmap_parloop_struct_339099.free_mem_313147 = mem_313147.mem;
    futhark_mc_segmap_parloop_struct_339099.free_ctx_param_ext_313174 =
        ctx_param_ext_313174;
    futhark_mc_segmap_parloop_struct_339099.free_ctx_param_ext_313175 =
        ctx_param_ext_313175;
    futhark_mc_segmap_parloop_struct_339099.free_ctx_param_ext_313177 =
        ctx_param_ext_313177;
    futhark_mc_segmap_parloop_struct_339099.free_mem_param_313179 =
        mem_param_313179.mem;
    futhark_mc_segmap_parloop_struct_339099.free_mem_315656 = mem_315656.mem;
    futhark_mc_segmap_parloop_struct_339099.free_mem_316621 = mem_316621.mem;
    futhark_mc_segmap_parloop_struct_339099.free_mem_316625 = mem_316625.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_339100_task;
    
    futhark_mc_segmap_parloop_339100_task.name =
        "futhark_mc_segmap_parloop_339100";
    futhark_mc_segmap_parloop_339100_task.fn = futhark_mc_segmap_parloop_339100;
    futhark_mc_segmap_parloop_339100_task.args =
        &futhark_mc_segmap_parloop_struct_339099;
    futhark_mc_segmap_parloop_339100_task.iterations = iterations;
    futhark_mc_segmap_parloop_339100_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_339100_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339100_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_339100_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_339100_task);
    
    if (futhark_mc_segmap_parloop_339100_err != 0) {
        err = futhark_mc_segmap_parloop_339100_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339100_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339100_total_end -
                 futhark_mc_segmap_parloop_339100_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339100_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339100_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339100_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_nested_task_339098_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_nested_task_339098_end -
                 futhark_mc_segmap_nested_task_339098_start;
        
        ctx->futhark_mc_segmap_nested_task_339098_runs[tid]++;
        ctx->futhark_mc_segmap_nested_task_339098_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_nested_task_339098_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_task_339134 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_t_292679;
    int64_t free_jump_t_292685;
    int64_t free_partition_sizze_292766;
    int64_t free_t_n_m_292839;
    int64_t free_i_292846;
    unsigned char *free_mem_312593;
    int64_t free_bytes_312598;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_312639;
    int64_t free_bytes_313090;
    unsigned char *free_mem_313143;
    unsigned char *free_mem_313147;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315656;
    unsigned char *free_mem_316719;
    unsigned char *free_mem_316723;
};
struct futhark_mc_segmap_parloop_struct_339136 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_t_292679;
    int64_t free_jump_t_292685;
    int64_t free_partition_sizze_292766;
    int64_t free_t_n_m_292839;
    int64_t free_i_292846;
    unsigned char *free_mem_312593;
    int64_t free_bytes_312598;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_312639;
    int64_t free_bytes_313090;
    unsigned char *free_mem_313143;
    unsigned char *free_mem_313147;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315656;
    unsigned char *free_mem_316719;
    unsigned char *free_mem_316723;
};
static int futhark_mc_segmap_parloop_339137(void *args, int64_t start,
                                            int64_t end, int flat_tid_309989,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_339136
    *futhark_mc_segmap_parloop_struct_339136 =
    (struct futhark_mc_segmap_parloop_struct_339136 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_339136->ctx;
    uint64_t futhark_mc_segmap_parloop_339137_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339137_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_339136->free_n_292675;
    int64_t q_t_292679 =
            futhark_mc_segmap_parloop_struct_339136->free_q_t_292679;
    int64_t jump_t_292685 =
            futhark_mc_segmap_parloop_struct_339136->free_jump_t_292685;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_339136->free_partition_sizze_292766;
    int64_t t_n_m_292839 =
            futhark_mc_segmap_parloop_struct_339136->free_t_n_m_292839;
    int64_t i_292846 = futhark_mc_segmap_parloop_struct_339136->free_i_292846;
    struct memblock mem_312593 = {.desc ="mem_312593", .mem =
                                  futhark_mc_segmap_parloop_struct_339136->free_mem_312593,
                                  .size =0, .references =NULL};
    int64_t bytes_312598 =
            futhark_mc_segmap_parloop_struct_339136->free_bytes_312598;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_segmap_parloop_struct_339136->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_312639 = {.desc ="mem_312639", .mem =
                                  futhark_mc_segmap_parloop_struct_339136->free_mem_312639,
                                  .size =0, .references =NULL};
    int64_t bytes_313090 =
            futhark_mc_segmap_parloop_struct_339136->free_bytes_313090;
    struct memblock mem_313143 = {.desc ="mem_313143", .mem =
                                  futhark_mc_segmap_parloop_struct_339136->free_mem_313143,
                                  .size =0, .references =NULL};
    struct memblock mem_313147 = {.desc ="mem_313147", .mem =
                                  futhark_mc_segmap_parloop_struct_339136->free_mem_313147,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_segmap_parloop_struct_339136->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_segmap_parloop_struct_339136->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_segmap_parloop_struct_339136->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_segmap_parloop_struct_339136->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315656 = {.desc ="mem_315656", .mem =
                                  futhark_mc_segmap_parloop_struct_339136->free_mem_315656,
                                  .size =0, .references =NULL};
    struct memblock mem_316719 = {.desc ="mem_316719", .mem =
                                  futhark_mc_segmap_parloop_struct_339136->free_mem_316719,
                                  .size =0, .references =NULL};
    struct memblock mem_316723 = {.desc ="mem_316723", .mem =
                                  futhark_mc_segmap_parloop_struct_339136->free_mem_316723,
                                  .size =0, .references =NULL};
    size_t mem_316643_cached_sizze_339138 = 0;
    unsigned char *mem_316643 = NULL;
    size_t mem_316658_cached_sizze_339139 = 0;
    unsigned char *mem_316658 = NULL;
    size_t mem_316661_cached_sizze_339140 = 0;
    unsigned char *mem_316661 = NULL;
    size_t mem_316688_cached_sizze_339141 = 0;
    unsigned char *mem_316688 = NULL;
    size_t mem_316691_cached_sizze_339142 = 0;
    unsigned char *mem_316691 = NULL;
    int64_t iterations = end - start;
    int64_t iter_336418 = start;
    
    if (mem_316643_cached_sizze_339138 < (size_t) bytes_312598) {
        mem_316643 = realloc(mem_316643, bytes_312598);
        mem_316643_cached_sizze_339138 = bytes_312598;
    }
    if (mem_316658_cached_sizze_339139 < (size_t) bytes_312598) {
        mem_316658 = realloc(mem_316658, bytes_312598);
        mem_316658_cached_sizze_339139 = bytes_312598;
    }
    if (mem_316661_cached_sizze_339140 < (size_t) bytes_312598) {
        mem_316661 = realloc(mem_316661, bytes_312598);
        mem_316661_cached_sizze_339140 = bytes_312598;
    }
    if (mem_316688_cached_sizze_339141 < (size_t) bytes_313090) {
        mem_316688 = realloc(mem_316688, bytes_313090);
        mem_316688_cached_sizze_339141 = bytes_313090;
    }
    if (mem_316691_cached_sizze_339142 < (size_t) bytes_313090) {
        mem_316691 = realloc(mem_316691, bytes_313090);
        mem_316691_cached_sizze_339142 = bytes_313090;
    }
    for (; iter_336418 < end; iter_336418++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_336563 = partition_sizze_292766;
        int64_t gtid_309990 = iter_336418;
        int64_t remnant_336564 = iter_336418 - gtid_309990;
        int64_t x_296807;
        
        x_296807 = ((int64_t *) mem_312639.mem)[gtid_309990];
        for (int64_t i_336419 = 0; i_336419 < n_292675; i_336419++) {
            float x_336421;
            
            x_336421 = ((float *) mem_312593.mem)[gtid_309990 * n_292675 +
                                                  i_336419];
            
            double x_336422;
            
            x_336422 = ((double *) mem_315656.mem)[gtid_309990 * n_292675 +
                                                   i_336419];
            
            double f32_res_336423 = fpconv_f32_f64(x_336421);
            double defunc_1_f_res_336424 = f32_res_336423 - x_336422;
            
            ((double *) mem_316643)[i_336419] = defunc_1_f_res_336424;
        }
        for (int64_t i_336426 = 0; i_336426 < n_292675; i_336426++) {
            int64_t x_336429;
            
            x_336429 = ((int64_t *) mem_312636.mem)[gtid_309990 * n_292675 +
                                                    i_336426];
            
            bool cond_336430 = sle64((int64_t) 0, x_336429);
            double defunc_0_f_res_336431;
            
            if (cond_336430) {
                bool y_336432 = slt64(x_336429, n_292675);
                bool bounds_check_336433 = cond_336430 && y_336432;
                bool index_certs_336434;
                
                if (!bounds_check_336433) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [", (long long) x_336429,
                                  "] out of bounds for array of shape [",
                                  (long long) n_292675, "].",
                                  "-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:45:43-70\n   #3  stl.fut:285:33-58\n   #4  /prelude/soacs.fut:75:22-28\n   #5  /prelude/soacs.fut:75:3-45\n   #6  stl.fut:283:13-288:41\n   #7  stl.fut:419:61-435:77\n   #8  stl.fut:463:3-479:36\n   #9  stl.fut:445:1-479:36\n");
                    err = FUTHARK_PROGRAM_ERROR;
                    goto cleanup;
                }
                
                double defunc_0_f_res_t_res_336435;
                
                defunc_0_f_res_t_res_336435 = ((double *) mem_316643)[x_336429];
                defunc_0_f_res_336431 = defunc_0_f_res_t_res_336435;
            } else {
                defunc_0_f_res_336431 = 0.0;
            }
            
            double defunc_0_f_res_336436;
            
            if (cond_336430) {
                bool y_336437 = slt64(x_336429, n_292675);
                bool bounds_check_336438 = cond_336430 && y_336437;
                bool index_certs_336439;
                
                if (!bounds_check_336438) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [", (long long) x_336429,
                                  "] out of bounds for array of shape [",
                                  (long long) n_292675, "].",
                                  "-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:45:43-70\n   #3  stl.fut:286:33-64\n   #4  /prelude/soacs.fut:75:22-28\n   #5  /prelude/soacs.fut:75:3-45\n   #6  stl.fut:283:13-288:41\n   #7  stl.fut:419:61-435:77\n   #8  stl.fut:463:3-479:36\n   #9  stl.fut:445:1-479:36\n");
                    err = FUTHARK_PROGRAM_ERROR;
                    goto cleanup;
                }
                
                double defunc_0_f_res_t_res_336440;
                
                defunc_0_f_res_t_res_336440 =
                    ((double *) mem_param_313179.mem)[ctx_param_ext_313174 +
                                                      (gtid_309990 *
                                                       ctx_param_ext_313175 +
                                                       x_336429 *
                                                       ctx_param_ext_313177)];
                defunc_0_f_res_336436 = defunc_0_f_res_t_res_336440;
            } else {
                defunc_0_f_res_336436 = 0.0;
            }
            ((double *) mem_316658)[i_336426] = defunc_0_f_res_336436;
            ((double *) mem_316661)[i_336426] = defunc_0_f_res_336431;
        }
        for (int64_t i_336443 = 0; i_336443 < t_n_m_292839; i_336443++) {
            int64_t x_336446;
            
            x_336446 = ((int64_t *) mem_313143.mem)[gtid_309990 * t_n_m_292839 +
                                                    i_336443];
            
            double x_336447;
            
            x_336447 = ((double *) mem_313147.mem)[gtid_309990 * t_n_m_292839 +
                                                   i_336443];
            
            int64_t min_arg_336448 = mul64(jump_t_292685, i_336443);
            int64_t min_res_336449 = smin64(i_292846, min_arg_336448);
            int64_t defunc_0_g_res_336450 = add64((int64_t) 1, min_res_336449);
            double defunc_2_reduce_res_336451;
            double defunc_2_reduce_res_336452;
            double defunc_2_reduce_res_336453;
            double defunc_2_reduce_res_336454;
            double defunc_2_reduce_res_336455;
            double redout_336457;
            double redout_336458;
            double redout_336459;
            double redout_336460;
            double redout_336461;
            
            redout_336457 = 0.0;
            redout_336458 = 0.0;
            redout_336459 = 0.0;
            redout_336460 = 0.0;
            redout_336461 = 0.0;
            for (int64_t i_336456 = 0; i_336456 < q_t_292679; i_336456++) {
                bool cond_336462 = sle64(x_296807, i_336456);
                int64_t defunc_0_f_res_336463;
                
                if (cond_336462) {
                    defunc_0_f_res_336463 = (int64_t) 0;
                } else {
                    int64_t i_336464 = add64(x_336446, i_336456);
                    int64_t defunc_0_add_arg_336465;
                    
                    defunc_0_add_arg_336465 =
                        ((int64_t *) mem_312636.mem)[gtid_309990 * n_292675 +
                                                     i_336464];
                    
                    int64_t defunc_1_add_res_336466 = add64((int64_t) 1,
                                                            defunc_0_add_arg_336465);
                    
                    defunc_0_f_res_336463 = defunc_1_add_res_336466;
                }
                
                double defunc_0_f_res_336467;
                
                if (cond_336462) {
                    defunc_0_f_res_336467 = 0.0;
                } else {
                    int64_t i_336468 = add64(x_336446, i_336456);
                    double defunc_0_add_arg_336469;
                    
                    defunc_0_add_arg_336469 = ((double *) mem_316658)[i_336468];
                    defunc_0_f_res_336467 = defunc_0_add_arg_336469;
                }
                
                int64_t binop_p_336470 = sub64(defunc_0_f_res_336463,
                                               defunc_0_g_res_336450);
                double defunc_0_f_res_336471 = sitofp_i64_f64(binop_p_336470);
                double abs_res_336472 = fabs(defunc_0_f_res_336471);
                double tmp1_336473 = abs_res_336472 / x_336447;
                double x_336474 = tmp1_336473 * tmp1_336473;
                double y_336475 = tmp1_336473 * x_336474;
                double tmp2_336476 = 1.0 - y_336475;
                double x_336477 = tmp2_336476 * tmp2_336476;
                double tmp3_336478 = tmp2_336476 * x_336477;
                double w_j_336479 = defunc_0_f_res_336467 * tmp3_336478;
                double xw_j_336480 = defunc_0_f_res_336471 * w_j_336479;
                double x2w_j_336481 = defunc_0_f_res_336471 * xw_j_336480;
                double x3w_j_336482 = defunc_0_f_res_336471 * x2w_j_336481;
                double x4w_j_336483 = defunc_0_f_res_336471 * x3w_j_336482;
                double defunc_1_op_res_336484 = w_j_336479 + redout_336457;
                double defunc_1_op_res_336485 = xw_j_336480 + redout_336458;
                double defunc_1_op_res_336486 = x2w_j_336481 + redout_336459;
                double defunc_1_op_res_336487 = x3w_j_336482 + redout_336460;
                double defunc_1_op_res_336488 = x4w_j_336483 + redout_336461;
                double redout_tmp_336570 = defunc_1_op_res_336484;
                double redout_tmp_336571 = defunc_1_op_res_336485;
                double redout_tmp_336572 = defunc_1_op_res_336486;
                double redout_tmp_336573 = defunc_1_op_res_336487;
                double redout_tmp_336574 = defunc_1_op_res_336488;
                
                redout_336457 = redout_tmp_336570;
                redout_336458 = redout_tmp_336571;
                redout_336459 = redout_tmp_336572;
                redout_336460 = redout_tmp_336573;
                redout_336461 = redout_tmp_336574;
            }
            defunc_2_reduce_res_336451 = redout_336457;
            defunc_2_reduce_res_336452 = redout_336458;
            defunc_2_reduce_res_336453 = redout_336459;
            defunc_2_reduce_res_336454 = redout_336460;
            defunc_2_reduce_res_336455 = redout_336461;
            
            double a_336489 = 2.220446049250313e-16 +
                   defunc_2_reduce_res_336451;
            double b_336490 = 2.220446049250313e-16 +
                   defunc_2_reduce_res_336452;
            double c_336491 = 2.220446049250313e-16 +
                   defunc_2_reduce_res_336453;
            double d_336492 = 2.220446049250313e-16 +
                   defunc_2_reduce_res_336454;
            double e_336493 = 2.220446049250313e-16 +
                   defunc_2_reduce_res_336455;
            double x_336494 = c_336491 * e_336493;
            double y_336495 = d_336492 * d_336492;
            double a12_336496 = x_336494 - y_336495;
            double x_336497 = c_336491 * d_336492;
            double y_336498 = b_336490 * e_336493;
            double b12_336499 = x_336497 - y_336498;
            double x_336500 = b_336490 * d_336492;
            double y_336501 = c_336491 * c_336491;
            double c12_336502 = x_336500 - y_336501;
            double x_336503 = a_336489 * e_336493;
            double b2_336504 = x_336503 - y_336501;
            double x_336505 = b_336490 * c_336491;
            double y_336506 = a_336489 * d_336492;
            double c2_336507 = x_336505 - y_336506;
            double x_336508 = a_336489 * a12_336496;
            double y_336509 = b_336490 * b12_336499;
            double x_336510 = x_336508 + y_336509;
            double y_336511 = c_336491 * c12_336502;
            double y_336512 = x_336510 + y_336511;
            double det_336513 = 1.0 / y_336512;
            double a12_336514 = a12_336496 * det_336513;
            double b12_336515 = b12_336499 * det_336513;
            double c12_336516 = c12_336502 * det_336513;
            double b2_336517 = b2_336504 * det_336513;
            double c2_336518 = c2_336507 * det_336513;
            double defunc_2_reduce_res_336519;
            double defunc_2_reduce_res_336520;
            double redout_336522;
            double redout_336523;
            
            redout_336522 = 0.0;
            redout_336523 = 0.0;
            for (int64_t i_336521 = 0; i_336521 < q_t_292679; i_336521++) {
                bool cond_336524 = sle64(x_296807, i_336521);
                int64_t defunc_0_f_res_336525;
                
                if (cond_336524) {
                    defunc_0_f_res_336525 = (int64_t) 0;
                } else {
                    int64_t i_336526 = add64(x_336446, i_336521);
                    int64_t defunc_0_add_arg_336527;
                    
                    defunc_0_add_arg_336527 =
                        ((int64_t *) mem_312636.mem)[gtid_309990 * n_292675 +
                                                     i_336526];
                    
                    int64_t defunc_1_add_res_336528 = add64((int64_t) 1,
                                                            defunc_0_add_arg_336527);
                    
                    defunc_0_f_res_336525 = defunc_1_add_res_336528;
                }
                
                double defunc_0_f_res_336529;
                
                if (cond_336524) {
                    defunc_0_f_res_336529 = 0.0;
                } else {
                    int64_t i_336530 = add64(x_336446, i_336521);
                    double defunc_0_add_arg_336531;
                    
                    defunc_0_add_arg_336531 = ((double *) mem_316658)[i_336530];
                    defunc_0_f_res_336529 = defunc_0_add_arg_336531;
                }
                
                int64_t binop_p_336532 = sub64(defunc_0_f_res_336525,
                                               defunc_0_g_res_336450);
                double defunc_0_f_res_336533 = sitofp_i64_f64(binop_p_336532);
                double abs_res_336534 = fabs(defunc_0_f_res_336533);
                double tmp1_336535 = abs_res_336534 / x_336447;
                double x_336536 = tmp1_336535 * tmp1_336535;
                double y_336537 = tmp1_336535 * x_336536;
                double tmp2_336538 = 1.0 - y_336537;
                double x_336539 = tmp2_336538 * tmp2_336538;
                double tmp3_336540 = tmp2_336538 * x_336539;
                double tmp4_336541 = defunc_0_f_res_336529 * tmp3_336540;
                double defunc_1_f_res_336542 = defunc_0_f_res_336533 *
                       tmp4_336541;
                double defunc_1_f_res_336543 = defunc_0_f_res_336533 *
                       defunc_1_f_res_336542;
                double defunc_0_f_res_336544;
                
                if (cond_336524) {
                    defunc_0_f_res_336544 = 0.0;
                } else {
                    int64_t i_336545 = add64(x_336446, i_336521);
                    double defunc_0_add_arg_336546;
                    
                    defunc_0_add_arg_336546 = ((double *) mem_316661)[i_336545];
                    defunc_0_f_res_336544 = defunc_0_add_arg_336546;
                }
                
                double x_336547 = a12_336514 * tmp4_336541;
                double y_336548 = b12_336515 * defunc_1_f_res_336542;
                double x_336549 = x_336547 + y_336548;
                double y_336550 = c12_336516 * defunc_1_f_res_336543;
                double x_336551 = x_336549 + y_336550;
                double defunc_9_fit_fun_res_336552 = defunc_0_f_res_336544 *
                       x_336551;
                double x_336553 = b12_336515 * tmp4_336541;
                double y_336554 = b2_336517 * defunc_1_f_res_336542;
                double x_336555 = x_336553 + y_336554;
                double y_336556 = c2_336518 * defunc_1_f_res_336543;
                double x_336557 = x_336555 + y_336556;
                double defunc_9_slope_fun_res_336558 = defunc_0_f_res_336544 *
                       x_336557;
                double defunc_1_op_res_336559 = defunc_9_fit_fun_res_336552 +
                       redout_336522;
                double defunc_1_op_res_336560 = defunc_9_slope_fun_res_336558 +
                       redout_336523;
                double redout_tmp_336575 = defunc_1_op_res_336559;
                double redout_tmp_336576 = defunc_1_op_res_336560;
                
                redout_336522 = redout_tmp_336575;
                redout_336523 = redout_tmp_336576;
            }
            defunc_2_reduce_res_336519 = redout_336522;
            defunc_2_reduce_res_336520 = redout_336523;
            ((double *) mem_316688)[i_336443] = defunc_2_reduce_res_336519;
            ((double *) mem_316691)[i_336443] = defunc_2_reduce_res_336520;
        }
        if (t_n_m_292839 * (int64_t) 8 > 0)
            memmove(mem_316719.mem + gtid_309990 * t_n_m_292839 * (int64_t) 8,
                    mem_316688 + (int64_t) 0, t_n_m_292839 * (int64_t) 8);
        if (t_n_m_292839 * (int64_t) 8 > 0)
            memmove(mem_316723.mem + gtid_309990 * t_n_m_292839 * (int64_t) 8,
                    mem_316691 + (int64_t) 0, t_n_m_292839 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_316643);
    free(mem_316658);
    free(mem_316661);
    free(mem_316688);
    free(mem_316691);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339137_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339137_end -
                 futhark_mc_segmap_parloop_339137_start;
        
        ctx->futhark_mc_segmap_parloop_339137_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_339137_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_339137_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_339135(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_309989 = tid;
    int num_tasks_336417 = info.nsubtasks;
    struct futhark_mc_task_339134 *futhark_mc_task_339134 =
                                  (struct futhark_mc_task_339134 *) args;
    struct futhark_context *ctx = futhark_mc_task_339134->ctx;
    uint64_t futhark_mc_segmap_task_339135_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_339135_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_339134->free_n_292675;
    int64_t q_t_292679 = futhark_mc_task_339134->free_q_t_292679;
    int64_t jump_t_292685 = futhark_mc_task_339134->free_jump_t_292685;
    int64_t partition_sizze_292766 =
            futhark_mc_task_339134->free_partition_sizze_292766;
    int64_t t_n_m_292839 = futhark_mc_task_339134->free_t_n_m_292839;
    int64_t i_292846 = futhark_mc_task_339134->free_i_292846;
    struct memblock mem_312593 = {.desc ="mem_312593", .mem =
                                  futhark_mc_task_339134->free_mem_312593,
                                  .size =0, .references =NULL};
    int64_t bytes_312598 = futhark_mc_task_339134->free_bytes_312598;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_task_339134->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_312639 = {.desc ="mem_312639", .mem =
                                  futhark_mc_task_339134->free_mem_312639,
                                  .size =0, .references =NULL};
    int64_t bytes_313090 = futhark_mc_task_339134->free_bytes_313090;
    struct memblock mem_313143 = {.desc ="mem_313143", .mem =
                                  futhark_mc_task_339134->free_mem_313143,
                                  .size =0, .references =NULL};
    struct memblock mem_313147 = {.desc ="mem_313147", .mem =
                                  futhark_mc_task_339134->free_mem_313147,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_task_339134->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_task_339134->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_task_339134->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_task_339134->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315656 = {.desc ="mem_315656", .mem =
                                  futhark_mc_task_339134->free_mem_315656,
                                  .size =0, .references =NULL};
    struct memblock mem_316719 = {.desc ="mem_316719", .mem =
                                  futhark_mc_task_339134->free_mem_316719,
                                  .size =0, .references =NULL};
    struct memblock mem_316723 = {.desc ="mem_316723", .mem =
                                  futhark_mc_task_339134->free_mem_316723,
                                  .size =0, .references =NULL};
    int64_t iter_336418;
    struct futhark_mc_segmap_parloop_struct_339136
    futhark_mc_segmap_parloop_struct_339136;
    
    futhark_mc_segmap_parloop_struct_339136.ctx = ctx;
    futhark_mc_segmap_parloop_struct_339136.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_339136.free_q_t_292679 = q_t_292679;
    futhark_mc_segmap_parloop_struct_339136.free_jump_t_292685 = jump_t_292685;
    futhark_mc_segmap_parloop_struct_339136.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_339136.free_t_n_m_292839 = t_n_m_292839;
    futhark_mc_segmap_parloop_struct_339136.free_i_292846 = i_292846;
    futhark_mc_segmap_parloop_struct_339136.free_mem_312593 = mem_312593.mem;
    futhark_mc_segmap_parloop_struct_339136.free_bytes_312598 = bytes_312598;
    futhark_mc_segmap_parloop_struct_339136.free_mem_312636 = mem_312636.mem;
    futhark_mc_segmap_parloop_struct_339136.free_mem_312639 = mem_312639.mem;
    futhark_mc_segmap_parloop_struct_339136.free_bytes_313090 = bytes_313090;
    futhark_mc_segmap_parloop_struct_339136.free_mem_313143 = mem_313143.mem;
    futhark_mc_segmap_parloop_struct_339136.free_mem_313147 = mem_313147.mem;
    futhark_mc_segmap_parloop_struct_339136.free_ctx_param_ext_313174 =
        ctx_param_ext_313174;
    futhark_mc_segmap_parloop_struct_339136.free_ctx_param_ext_313175 =
        ctx_param_ext_313175;
    futhark_mc_segmap_parloop_struct_339136.free_ctx_param_ext_313177 =
        ctx_param_ext_313177;
    futhark_mc_segmap_parloop_struct_339136.free_mem_param_313179 =
        mem_param_313179.mem;
    futhark_mc_segmap_parloop_struct_339136.free_mem_315656 = mem_315656.mem;
    futhark_mc_segmap_parloop_struct_339136.free_mem_316719 = mem_316719.mem;
    futhark_mc_segmap_parloop_struct_339136.free_mem_316723 = mem_316723.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_339137_task;
    
    futhark_mc_segmap_parloop_339137_task.name =
        "futhark_mc_segmap_parloop_339137";
    futhark_mc_segmap_parloop_339137_task.fn = futhark_mc_segmap_parloop_339137;
    futhark_mc_segmap_parloop_339137_task.args =
        &futhark_mc_segmap_parloop_struct_339136;
    futhark_mc_segmap_parloop_339137_task.iterations = iterations;
    futhark_mc_segmap_parloop_339137_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_339137_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339137_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_339137_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_339137_task);
    
    if (futhark_mc_segmap_parloop_339137_err != 0) {
        err = futhark_mc_segmap_parloop_339137_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339137_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339137_total_end -
                 futhark_mc_segmap_parloop_339137_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339137_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339137_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339137_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_339135_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_339135_end -
                 futhark_mc_segmap_task_339135_start;
        
        ctx->futhark_mc_segmap_task_339135_runs[tid]++;
        ctx->futhark_mc_segmap_task_339135_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_339135_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_segmap_parloop_struct_339144 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_t_292679;
    int64_t free_jump_t_292685;
    int64_t free_partition_sizze_292766;
    int64_t free_t_n_m_292839;
    int64_t free_i_292846;
    unsigned char *free_mem_312593;
    int64_t free_bytes_312598;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_312639;
    int64_t free_bytes_313090;
    unsigned char *free_mem_313143;
    unsigned char *free_mem_313147;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_315656;
    unsigned char *free_mem_316719;
    unsigned char *free_mem_316723;
};
struct futhark_mc_task_339151 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_310135;
    unsigned char *free_mem_312593;
    unsigned char *free_mem_315656;
    unsigned char *free_mem_316628;
};
struct futhark_mc_segmap_parloop_struct_339153 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_310135;
    unsigned char *free_mem_312593;
    unsigned char *free_mem_315656;
    unsigned char *free_mem_316628;
};
static int futhark_mc_segmap_parloop_339154(void *args, int64_t start,
                                            int64_t end, int flat_tid_336578,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_339153
    *futhark_mc_segmap_parloop_struct_339153 =
    (struct futhark_mc_segmap_parloop_struct_339153 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_339153->ctx;
    uint64_t futhark_mc_segmap_parloop_339154_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339154_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_339153->free_n_292675;
    int64_t gtid_310135 =
            futhark_mc_segmap_parloop_struct_339153->free_gtid_310135;
    struct memblock mem_312593 = {.desc ="mem_312593", .mem =
                                  futhark_mc_segmap_parloop_struct_339153->free_mem_312593,
                                  .size =0, .references =NULL};
    struct memblock mem_315656 = {.desc ="mem_315656", .mem =
                                  futhark_mc_segmap_parloop_struct_339153->free_mem_315656,
                                  .size =0, .references =NULL};
    struct memblock mem_316628 = {.desc ="mem_316628", .mem =
                                  futhark_mc_segmap_parloop_struct_339153->free_mem_316628,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_336844 = start;
    
    for (; iter_336844 < end; iter_336844++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_336845 = n_292675;
        int64_t gtid_336579 = iter_336844;
        int64_t remnant_336846 = iter_336844 - gtid_336579;
        float x_336580;
        
        x_336580 = ((float *) mem_312593.mem)[gtid_310135 * n_292675 +
                                              gtid_336579];
        
        double x_336581;
        
        x_336581 = ((double *) mem_315656.mem)[gtid_310135 * n_292675 +
                                               gtid_336579];
        
        double f32_res_336582 = fpconv_f32_f64(x_336580);
        double defunc_1_f_res_336583 = f32_res_336582 - x_336581;
        
        ((double *) mem_316628.mem)[gtid_336579] = defunc_1_f_res_336583;
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339154_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339154_end -
                 futhark_mc_segmap_parloop_339154_start;
        
        ctx->futhark_mc_segmap_parloop_339154_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_339154_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_339154_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_339152(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_336578 = tid;
    int num_tasks_336843 = info.nsubtasks;
    struct futhark_mc_task_339151 *futhark_mc_task_339151 =
                                  (struct futhark_mc_task_339151 *) args;
    struct futhark_context *ctx = futhark_mc_task_339151->ctx;
    uint64_t futhark_mc_segmap_task_339152_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_339152_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_339151->free_n_292675;
    int64_t gtid_310135 = futhark_mc_task_339151->free_gtid_310135;
    struct memblock mem_312593 = {.desc ="mem_312593", .mem =
                                  futhark_mc_task_339151->free_mem_312593,
                                  .size =0, .references =NULL};
    struct memblock mem_315656 = {.desc ="mem_315656", .mem =
                                  futhark_mc_task_339151->free_mem_315656,
                                  .size =0, .references =NULL};
    struct memblock mem_316628 = {.desc ="mem_316628", .mem =
                                  futhark_mc_task_339151->free_mem_316628,
                                  .size =0, .references =NULL};
    int64_t iter_336844;
    struct futhark_mc_segmap_parloop_struct_339153
    futhark_mc_segmap_parloop_struct_339153;
    
    futhark_mc_segmap_parloop_struct_339153.ctx = ctx;
    futhark_mc_segmap_parloop_struct_339153.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_339153.free_gtid_310135 = gtid_310135;
    futhark_mc_segmap_parloop_struct_339153.free_mem_312593 = mem_312593.mem;
    futhark_mc_segmap_parloop_struct_339153.free_mem_315656 = mem_315656.mem;
    futhark_mc_segmap_parloop_struct_339153.free_mem_316628 = mem_316628.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_339154_task;
    
    futhark_mc_segmap_parloop_339154_task.name =
        "futhark_mc_segmap_parloop_339154";
    futhark_mc_segmap_parloop_339154_task.fn = futhark_mc_segmap_parloop_339154;
    futhark_mc_segmap_parloop_339154_task.args =
        &futhark_mc_segmap_parloop_struct_339153;
    futhark_mc_segmap_parloop_339154_task.iterations = iterations;
    futhark_mc_segmap_parloop_339154_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_339154_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339154_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_339154_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_339154_task);
    
    if (futhark_mc_segmap_parloop_339154_err != 0) {
        err = futhark_mc_segmap_parloop_339154_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339154_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339154_total_end -
                 futhark_mc_segmap_parloop_339154_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339154_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339154_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339154_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_339152_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_339152_end -
                 futhark_mc_segmap_task_339152_start;
        
        ctx->futhark_mc_segmap_task_339152_runs[tid]++;
        ctx->futhark_mc_segmap_task_339152_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_339152_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_task_339155 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_310135;
    unsigned char *free_mem_312636;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_316628;
    unsigned char *free_mem_316631;
    unsigned char *free_mem_316634;
};
struct futhark_mc_segmap_parloop_struct_339157 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_310135;
    unsigned char *free_mem_312636;
    int64_t free_ctx_param_ext_313174;
    int64_t free_ctx_param_ext_313175;
    int64_t free_ctx_param_ext_313177;
    unsigned char *free_mem_param_313179;
    unsigned char *free_mem_316628;
    unsigned char *free_mem_316631;
    unsigned char *free_mem_316634;
};
static int futhark_mc_segmap_parloop_339158(void *args, int64_t start,
                                            int64_t end, int flat_tid_336584,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_339157
    *futhark_mc_segmap_parloop_struct_339157 =
    (struct futhark_mc_segmap_parloop_struct_339157 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_339157->ctx;
    uint64_t futhark_mc_segmap_parloop_339158_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339158_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_339157->free_n_292675;
    int64_t gtid_310135 =
            futhark_mc_segmap_parloop_struct_339157->free_gtid_310135;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_segmap_parloop_struct_339157->free_mem_312636,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_segmap_parloop_struct_339157->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_segmap_parloop_struct_339157->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_segmap_parloop_struct_339157->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_segmap_parloop_struct_339157->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_316628 = {.desc ="mem_316628", .mem =
                                  futhark_mc_segmap_parloop_struct_339157->free_mem_316628,
                                  .size =0, .references =NULL};
    struct memblock mem_316631 = {.desc ="mem_316631", .mem =
                                  futhark_mc_segmap_parloop_struct_339157->free_mem_316631,
                                  .size =0, .references =NULL};
    struct memblock mem_316634 = {.desc ="mem_316634", .mem =
                                  futhark_mc_segmap_parloop_struct_339157->free_mem_316634,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_336848 = start;
    
    for (; iter_336848 < end; iter_336848++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_336857 = n_292675;
        int64_t gtid_336585 = iter_336848;
        int64_t remnant_336858 = iter_336848 - gtid_336585;
        int64_t x_336586;
        
        x_336586 = ((int64_t *) mem_312636.mem)[gtid_310135 * n_292675 +
                                                gtid_336585];
        
        bool cond_336587 = sle64((int64_t) 0, x_336586);
        double defunc_0_f_res_336588;
        
        if (cond_336587) {
            bool y_336849 = slt64(x_336586, n_292675);
            bool bounds_check_336850 = cond_336587 && y_336849;
            bool index_certs_336851;
            
            if (!bounds_check_336850) {
                ctx->error =
                    msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                              "Index [", (long long) x_336586,
                              "] out of bounds for array of shape [",
                              (long long) n_292675, "].",
                              "-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:45:43-70\n   #3  stl.fut:285:33-58\n   #4  /prelude/soacs.fut:75:22-28\n   #5  /prelude/soacs.fut:75:3-45\n   #6  stl.fut:283:13-288:41\n   #7  stl.fut:419:61-435:77\n   #8  stl.fut:463:3-479:36\n   #9  stl.fut:445:1-479:36\n");
                err = FUTHARK_PROGRAM_ERROR;
                goto cleanup;
            }
            
            double defunc_0_f_res_t_res_336852;
            
            defunc_0_f_res_t_res_336852 = ((double *) mem_316628.mem)[x_336586];
            defunc_0_f_res_336588 = defunc_0_f_res_t_res_336852;
        } else {
            defunc_0_f_res_336588 = 0.0;
        }
        
        double defunc_0_f_res_336593;
        
        if (cond_336587) {
            bool y_336853 = slt64(x_336586, n_292675);
            bool bounds_check_336854 = cond_336587 && y_336853;
            bool index_certs_336855;
            
            if (!bounds_check_336854) {
                ctx->error =
                    msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                              "Index [", (long long) x_336586,
                              "] out of bounds for array of shape [",
                              (long long) n_292675, "].",
                              "-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:45:43-70\n   #3  stl.fut:286:33-64\n   #4  /prelude/soacs.fut:75:22-28\n   #5  /prelude/soacs.fut:75:3-45\n   #6  stl.fut:283:13-288:41\n   #7  stl.fut:419:61-435:77\n   #8  stl.fut:463:3-479:36\n   #9  stl.fut:445:1-479:36\n");
                err = FUTHARK_PROGRAM_ERROR;
                goto cleanup;
            }
            
            double defunc_0_f_res_t_res_336856;
            
            defunc_0_f_res_t_res_336856 =
                ((double *) mem_param_313179.mem)[ctx_param_ext_313174 +
                                                  (gtid_310135 *
                                                   ctx_param_ext_313175 +
                                                   x_336586 *
                                                   ctx_param_ext_313177)];
            defunc_0_f_res_336593 = defunc_0_f_res_t_res_336856;
        } else {
            defunc_0_f_res_336593 = 0.0;
        }
        ((double *) mem_316631.mem)[gtid_336585] = defunc_0_f_res_336593;
        ((double *) mem_316634.mem)[gtid_336585] = defunc_0_f_res_336588;
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339158_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339158_end -
                 futhark_mc_segmap_parloop_339158_start;
        
        ctx->futhark_mc_segmap_parloop_339158_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_339158_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_339158_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_339156(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_336584 = tid;
    int num_tasks_336847 = info.nsubtasks;
    struct futhark_mc_task_339155 *futhark_mc_task_339155 =
                                  (struct futhark_mc_task_339155 *) args;
    struct futhark_context *ctx = futhark_mc_task_339155->ctx;
    uint64_t futhark_mc_segmap_task_339156_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_339156_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_339155->free_n_292675;
    int64_t gtid_310135 = futhark_mc_task_339155->free_gtid_310135;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_task_339155->free_mem_312636,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_task_339155->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_task_339155->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_task_339155->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_task_339155->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_316628 = {.desc ="mem_316628", .mem =
                                  futhark_mc_task_339155->free_mem_316628,
                                  .size =0, .references =NULL};
    struct memblock mem_316631 = {.desc ="mem_316631", .mem =
                                  futhark_mc_task_339155->free_mem_316631,
                                  .size =0, .references =NULL};
    struct memblock mem_316634 = {.desc ="mem_316634", .mem =
                                  futhark_mc_task_339155->free_mem_316634,
                                  .size =0, .references =NULL};
    int64_t iter_336848;
    struct futhark_mc_segmap_parloop_struct_339157
    futhark_mc_segmap_parloop_struct_339157;
    
    futhark_mc_segmap_parloop_struct_339157.ctx = ctx;
    futhark_mc_segmap_parloop_struct_339157.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_339157.free_gtid_310135 = gtid_310135;
    futhark_mc_segmap_parloop_struct_339157.free_mem_312636 = mem_312636.mem;
    futhark_mc_segmap_parloop_struct_339157.free_ctx_param_ext_313174 =
        ctx_param_ext_313174;
    futhark_mc_segmap_parloop_struct_339157.free_ctx_param_ext_313175 =
        ctx_param_ext_313175;
    futhark_mc_segmap_parloop_struct_339157.free_ctx_param_ext_313177 =
        ctx_param_ext_313177;
    futhark_mc_segmap_parloop_struct_339157.free_mem_param_313179 =
        mem_param_313179.mem;
    futhark_mc_segmap_parloop_struct_339157.free_mem_316628 = mem_316628.mem;
    futhark_mc_segmap_parloop_struct_339157.free_mem_316631 = mem_316631.mem;
    futhark_mc_segmap_parloop_struct_339157.free_mem_316634 = mem_316634.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_339158_task;
    
    futhark_mc_segmap_parloop_339158_task.name =
        "futhark_mc_segmap_parloop_339158";
    futhark_mc_segmap_parloop_339158_task.fn = futhark_mc_segmap_parloop_339158;
    futhark_mc_segmap_parloop_339158_task.args =
        &futhark_mc_segmap_parloop_struct_339157;
    futhark_mc_segmap_parloop_339158_task.iterations = iterations;
    futhark_mc_segmap_parloop_339158_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_339158_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339158_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_339158_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_339158_task);
    
    if (futhark_mc_segmap_parloop_339158_err != 0) {
        err = futhark_mc_segmap_parloop_339158_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339158_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339158_total_end -
                 futhark_mc_segmap_parloop_339158_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339158_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339158_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339158_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_339156_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_339156_end -
                 futhark_mc_segmap_task_339156_start;
        
        ctx->futhark_mc_segmap_task_339156_runs[tid]++;
        ctx->futhark_mc_segmap_task_339156_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_339156_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_task_339159 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_t_292679;
    int64_t free_jump_t_292685;
    int64_t free_t_n_m_292839;
    int64_t free_i_292846;
    int64_t free_gtid_310135;
    int64_t free_x_310140;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_313143;
    unsigned char *free_mem_313147;
    unsigned char *free_mem_316631;
    unsigned char *free_mem_316634;
    unsigned char *free_mem_316637;
    unsigned char *free_mem_316640;
};
struct futhark_mc_segmap_parloop_struct_339161 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_t_292679;
    int64_t free_jump_t_292685;
    int64_t free_t_n_m_292839;
    int64_t free_i_292846;
    int64_t free_gtid_310135;
    int64_t free_x_310140;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_313143;
    unsigned char *free_mem_313147;
    unsigned char *free_mem_316631;
    unsigned char *free_mem_316634;
    unsigned char *free_mem_316637;
    unsigned char *free_mem_316640;
};
static int futhark_mc_segmap_parloop_339162(void *args, int64_t start,
                                            int64_t end, int flat_tid_336724,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_339161
    *futhark_mc_segmap_parloop_struct_339161 =
    (struct futhark_mc_segmap_parloop_struct_339161 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_339161->ctx;
    uint64_t futhark_mc_segmap_parloop_339162_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339162_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_339161->free_n_292675;
    int64_t q_t_292679 =
            futhark_mc_segmap_parloop_struct_339161->free_q_t_292679;
    int64_t jump_t_292685 =
            futhark_mc_segmap_parloop_struct_339161->free_jump_t_292685;
    int64_t t_n_m_292839 =
            futhark_mc_segmap_parloop_struct_339161->free_t_n_m_292839;
    int64_t i_292846 = futhark_mc_segmap_parloop_struct_339161->free_i_292846;
    int64_t gtid_310135 =
            futhark_mc_segmap_parloop_struct_339161->free_gtid_310135;
    int64_t x_310140 = futhark_mc_segmap_parloop_struct_339161->free_x_310140;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_segmap_parloop_struct_339161->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_313143 = {.desc ="mem_313143", .mem =
                                  futhark_mc_segmap_parloop_struct_339161->free_mem_313143,
                                  .size =0, .references =NULL};
    struct memblock mem_313147 = {.desc ="mem_313147", .mem =
                                  futhark_mc_segmap_parloop_struct_339161->free_mem_313147,
                                  .size =0, .references =NULL};
    struct memblock mem_316631 = {.desc ="mem_316631", .mem =
                                  futhark_mc_segmap_parloop_struct_339161->free_mem_316631,
                                  .size =0, .references =NULL};
    struct memblock mem_316634 = {.desc ="mem_316634", .mem =
                                  futhark_mc_segmap_parloop_struct_339161->free_mem_316634,
                                  .size =0, .references =NULL};
    struct memblock mem_316637 = {.desc ="mem_316637", .mem =
                                  futhark_mc_segmap_parloop_struct_339161->free_mem_316637,
                                  .size =0, .references =NULL};
    struct memblock mem_316640 = {.desc ="mem_316640", .mem =
                                  futhark_mc_segmap_parloop_struct_339161->free_mem_316640,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_336860 = start;
    
    for (; iter_336860 < end; iter_336860++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_336934 = t_n_m_292839;
        int64_t gtid_336725 = iter_336860;
        int64_t remnant_336935 = iter_336860 - gtid_336725;
        int64_t x_336726;
        
        x_336726 = ((int64_t *) mem_313143.mem)[gtid_310135 * t_n_m_292839 +
                                                gtid_336725];
        
        double x_336727;
        
        x_336727 = ((double *) mem_313147.mem)[gtid_310135 * t_n_m_292839 +
                                               gtid_336725];
        
        int64_t min_arg_336728 = mul64(jump_t_292685, gtid_336725);
        int64_t min_res_336729 = smin64(i_292846, min_arg_336728);
        int64_t defunc_0_g_res_336730 = add64((int64_t) 1, min_res_336729);
        double defunc_2_reduce_res_336731;
        double defunc_2_reduce_res_336732;
        double defunc_2_reduce_res_336733;
        double defunc_2_reduce_res_336734;
        double defunc_2_reduce_res_336735;
        double redout_336862;
        double redout_336863;
        double redout_336864;
        double redout_336865;
        double redout_336866;
        
        redout_336862 = 0.0;
        redout_336863 = 0.0;
        redout_336864 = 0.0;
        redout_336865 = 0.0;
        redout_336866 = 0.0;
        for (int64_t i_336861 = 0; i_336861 < q_t_292679; i_336861++) {
            bool cond_336867 = sle64(x_310140, i_336861);
            int64_t defunc_0_f_res_336868;
            
            if (cond_336867) {
                defunc_0_f_res_336868 = (int64_t) 0;
            } else {
                int64_t i_336869 = add64(x_336726, i_336861);
                int64_t defunc_0_add_arg_336870;
                
                defunc_0_add_arg_336870 =
                    ((int64_t *) mem_312636.mem)[gtid_310135 * n_292675 +
                                                 i_336869];
                
                int64_t defunc_1_add_res_336871 = add64((int64_t) 1,
                                                        defunc_0_add_arg_336870);
                
                defunc_0_f_res_336868 = defunc_1_add_res_336871;
            }
            
            double defunc_0_f_res_336872;
            
            if (cond_336867) {
                defunc_0_f_res_336872 = 0.0;
            } else {
                int64_t i_336873 = add64(x_336726, i_336861);
                double defunc_0_add_arg_336874;
                
                defunc_0_add_arg_336874 = ((double *) mem_316631.mem)[i_336873];
                defunc_0_f_res_336872 = defunc_0_add_arg_336874;
            }
            
            int64_t binop_p_336875 = sub64(defunc_0_f_res_336868,
                                           defunc_0_g_res_336730);
            double defunc_0_f_res_336876 = sitofp_i64_f64(binop_p_336875);
            double abs_res_336877 = fabs(defunc_0_f_res_336876);
            double tmp1_336878 = abs_res_336877 / x_336727;
            double x_336879 = tmp1_336878 * tmp1_336878;
            double y_336880 = tmp1_336878 * x_336879;
            double tmp2_336881 = 1.0 - y_336880;
            double x_336882 = tmp2_336881 * tmp2_336881;
            double tmp3_336883 = tmp2_336881 * x_336882;
            double w_j_336884 = defunc_0_f_res_336872 * tmp3_336883;
            double xw_j_336885 = defunc_0_f_res_336876 * w_j_336884;
            double x2w_j_336886 = defunc_0_f_res_336876 * xw_j_336885;
            double x3w_j_336887 = defunc_0_f_res_336876 * x2w_j_336886;
            double x4w_j_336888 = defunc_0_f_res_336876 * x3w_j_336887;
            double defunc_1_op_res_336889 = w_j_336884 + redout_336862;
            double defunc_1_op_res_336890 = xw_j_336885 + redout_336863;
            double defunc_1_op_res_336891 = x2w_j_336886 + redout_336864;
            double defunc_1_op_res_336892 = x3w_j_336887 + redout_336865;
            double defunc_1_op_res_336893 = x4w_j_336888 + redout_336866;
            double redout_tmp_336936 = defunc_1_op_res_336889;
            double redout_tmp_336937 = defunc_1_op_res_336890;
            double redout_tmp_336938 = defunc_1_op_res_336891;
            double redout_tmp_336939 = defunc_1_op_res_336892;
            double redout_tmp_336940 = defunc_1_op_res_336893;
            
            redout_336862 = redout_tmp_336936;
            redout_336863 = redout_tmp_336937;
            redout_336864 = redout_tmp_336938;
            redout_336865 = redout_tmp_336939;
            redout_336866 = redout_tmp_336940;
        }
        defunc_2_reduce_res_336731 = redout_336862;
        defunc_2_reduce_res_336732 = redout_336863;
        defunc_2_reduce_res_336733 = redout_336864;
        defunc_2_reduce_res_336734 = redout_336865;
        defunc_2_reduce_res_336735 = redout_336866;
        
        double a_336769 = 2.220446049250313e-16 + defunc_2_reduce_res_336731;
        double b_336770 = 2.220446049250313e-16 + defunc_2_reduce_res_336732;
        double c_336771 = 2.220446049250313e-16 + defunc_2_reduce_res_336733;
        double d_336772 = 2.220446049250313e-16 + defunc_2_reduce_res_336734;
        double e_336773 = 2.220446049250313e-16 + defunc_2_reduce_res_336735;
        double x_336774 = c_336771 * e_336773;
        double y_336775 = d_336772 * d_336772;
        double a12_336776 = x_336774 - y_336775;
        double x_336777 = c_336771 * d_336772;
        double y_336778 = b_336770 * e_336773;
        double b12_336779 = x_336777 - y_336778;
        double x_336780 = b_336770 * d_336772;
        double y_336781 = c_336771 * c_336771;
        double c12_336782 = x_336780 - y_336781;
        double x_336783 = a_336769 * e_336773;
        double b2_336784 = x_336783 - y_336781;
        double x_336785 = b_336770 * c_336771;
        double y_336786 = a_336769 * d_336772;
        double c2_336787 = x_336785 - y_336786;
        double x_336788 = a_336769 * a12_336776;
        double y_336789 = b_336770 * b12_336779;
        double x_336790 = x_336788 + y_336789;
        double y_336791 = c_336771 * c12_336782;
        double y_336792 = x_336790 + y_336791;
        double det_336793 = 1.0 / y_336792;
        double a12_336794 = a12_336776 * det_336793;
        double b12_336795 = b12_336779 * det_336793;
        double c12_336796 = c12_336782 * det_336793;
        double b2_336797 = b2_336784 * det_336793;
        double c2_336798 = c2_336787 * det_336793;
        double defunc_2_reduce_res_336799;
        double defunc_2_reduce_res_336800;
        double redout_336895;
        double redout_336896;
        
        redout_336895 = 0.0;
        redout_336896 = 0.0;
        for (int64_t i_336894 = 0; i_336894 < q_t_292679; i_336894++) {
            bool cond_336897 = sle64(x_310140, i_336894);
            int64_t defunc_0_f_res_336898;
            
            if (cond_336897) {
                defunc_0_f_res_336898 = (int64_t) 0;
            } else {
                int64_t i_336899 = add64(x_336726, i_336894);
                int64_t defunc_0_add_arg_336900;
                
                defunc_0_add_arg_336900 =
                    ((int64_t *) mem_312636.mem)[gtid_310135 * n_292675 +
                                                 i_336899];
                
                int64_t defunc_1_add_res_336901 = add64((int64_t) 1,
                                                        defunc_0_add_arg_336900);
                
                defunc_0_f_res_336898 = defunc_1_add_res_336901;
            }
            
            double defunc_0_f_res_336902;
            
            if (cond_336897) {
                defunc_0_f_res_336902 = 0.0;
            } else {
                int64_t i_336903 = add64(x_336726, i_336894);
                double defunc_0_add_arg_336904;
                
                defunc_0_add_arg_336904 = ((double *) mem_316631.mem)[i_336903];
                defunc_0_f_res_336902 = defunc_0_add_arg_336904;
            }
            
            int64_t binop_p_336905 = sub64(defunc_0_f_res_336898,
                                           defunc_0_g_res_336730);
            double defunc_0_f_res_336906 = sitofp_i64_f64(binop_p_336905);
            double abs_res_336907 = fabs(defunc_0_f_res_336906);
            double tmp1_336908 = abs_res_336907 / x_336727;
            double x_336909 = tmp1_336908 * tmp1_336908;
            double y_336910 = tmp1_336908 * x_336909;
            double tmp2_336911 = 1.0 - y_336910;
            double x_336912 = tmp2_336911 * tmp2_336911;
            double tmp3_336913 = tmp2_336911 * x_336912;
            double tmp4_336914 = defunc_0_f_res_336902 * tmp3_336913;
            double defunc_1_f_res_336915 = defunc_0_f_res_336906 * tmp4_336914;
            double defunc_1_f_res_336916 = defunc_0_f_res_336906 *
                   defunc_1_f_res_336915;
            double defunc_0_f_res_336917;
            
            if (cond_336897) {
                defunc_0_f_res_336917 = 0.0;
            } else {
                int64_t i_336918 = add64(x_336726, i_336894);
                double defunc_0_add_arg_336919;
                
                defunc_0_add_arg_336919 = ((double *) mem_316634.mem)[i_336918];
                defunc_0_f_res_336917 = defunc_0_add_arg_336919;
            }
            
            double x_336920 = a12_336794 * tmp4_336914;
            double y_336921 = b12_336795 * defunc_1_f_res_336915;
            double x_336922 = x_336920 + y_336921;
            double y_336923 = c12_336796 * defunc_1_f_res_336916;
            double x_336924 = x_336922 + y_336923;
            double defunc_9_fit_fun_res_336925 = defunc_0_f_res_336917 *
                   x_336924;
            double x_336926 = b12_336795 * tmp4_336914;
            double y_336927 = b2_336797 * defunc_1_f_res_336915;
            double x_336928 = x_336926 + y_336927;
            double y_336929 = c2_336798 * defunc_1_f_res_336916;
            double x_336930 = x_336928 + y_336929;
            double defunc_9_slope_fun_res_336931 = defunc_0_f_res_336917 *
                   x_336930;
            double defunc_1_op_res_336932 = defunc_9_fit_fun_res_336925 +
                   redout_336895;
            double defunc_1_op_res_336933 = defunc_9_slope_fun_res_336931 +
                   redout_336896;
            double redout_tmp_336941 = defunc_1_op_res_336932;
            double redout_tmp_336942 = defunc_1_op_res_336933;
            
            redout_336895 = redout_tmp_336941;
            redout_336896 = redout_tmp_336942;
        }
        defunc_2_reduce_res_336799 = redout_336895;
        defunc_2_reduce_res_336800 = redout_336896;
        ((double *) mem_316637.mem)[gtid_336725] = defunc_2_reduce_res_336799;
        ((double *) mem_316640.mem)[gtid_336725] = defunc_2_reduce_res_336800;
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339162_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339162_end -
                 futhark_mc_segmap_parloop_339162_start;
        
        ctx->futhark_mc_segmap_parloop_339162_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_339162_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_339162_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_339160(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_336724 = tid;
    int num_tasks_336859 = info.nsubtasks;
    struct futhark_mc_task_339159 *futhark_mc_task_339159 =
                                  (struct futhark_mc_task_339159 *) args;
    struct futhark_context *ctx = futhark_mc_task_339159->ctx;
    uint64_t futhark_mc_segmap_task_339160_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_339160_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_339159->free_n_292675;
    int64_t q_t_292679 = futhark_mc_task_339159->free_q_t_292679;
    int64_t jump_t_292685 = futhark_mc_task_339159->free_jump_t_292685;
    int64_t t_n_m_292839 = futhark_mc_task_339159->free_t_n_m_292839;
    int64_t i_292846 = futhark_mc_task_339159->free_i_292846;
    int64_t gtid_310135 = futhark_mc_task_339159->free_gtid_310135;
    int64_t x_310140 = futhark_mc_task_339159->free_x_310140;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_task_339159->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_313143 = {.desc ="mem_313143", .mem =
                                  futhark_mc_task_339159->free_mem_313143,
                                  .size =0, .references =NULL};
    struct memblock mem_313147 = {.desc ="mem_313147", .mem =
                                  futhark_mc_task_339159->free_mem_313147,
                                  .size =0, .references =NULL};
    struct memblock mem_316631 = {.desc ="mem_316631", .mem =
                                  futhark_mc_task_339159->free_mem_316631,
                                  .size =0, .references =NULL};
    struct memblock mem_316634 = {.desc ="mem_316634", .mem =
                                  futhark_mc_task_339159->free_mem_316634,
                                  .size =0, .references =NULL};
    struct memblock mem_316637 = {.desc ="mem_316637", .mem =
                                  futhark_mc_task_339159->free_mem_316637,
                                  .size =0, .references =NULL};
    struct memblock mem_316640 = {.desc ="mem_316640", .mem =
                                  futhark_mc_task_339159->free_mem_316640,
                                  .size =0, .references =NULL};
    int64_t iter_336860;
    struct futhark_mc_segmap_parloop_struct_339161
    futhark_mc_segmap_parloop_struct_339161;
    
    futhark_mc_segmap_parloop_struct_339161.ctx = ctx;
    futhark_mc_segmap_parloop_struct_339161.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_339161.free_q_t_292679 = q_t_292679;
    futhark_mc_segmap_parloop_struct_339161.free_jump_t_292685 = jump_t_292685;
    futhark_mc_segmap_parloop_struct_339161.free_t_n_m_292839 = t_n_m_292839;
    futhark_mc_segmap_parloop_struct_339161.free_i_292846 = i_292846;
    futhark_mc_segmap_parloop_struct_339161.free_gtid_310135 = gtid_310135;
    futhark_mc_segmap_parloop_struct_339161.free_x_310140 = x_310140;
    futhark_mc_segmap_parloop_struct_339161.free_mem_312636 = mem_312636.mem;
    futhark_mc_segmap_parloop_struct_339161.free_mem_313143 = mem_313143.mem;
    futhark_mc_segmap_parloop_struct_339161.free_mem_313147 = mem_313147.mem;
    futhark_mc_segmap_parloop_struct_339161.free_mem_316631 = mem_316631.mem;
    futhark_mc_segmap_parloop_struct_339161.free_mem_316634 = mem_316634.mem;
    futhark_mc_segmap_parloop_struct_339161.free_mem_316637 = mem_316637.mem;
    futhark_mc_segmap_parloop_struct_339161.free_mem_316640 = mem_316640.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_339162_task;
    
    futhark_mc_segmap_parloop_339162_task.name =
        "futhark_mc_segmap_parloop_339162";
    futhark_mc_segmap_parloop_339162_task.fn = futhark_mc_segmap_parloop_339162;
    futhark_mc_segmap_parloop_339162_task.args =
        &futhark_mc_segmap_parloop_struct_339161;
    futhark_mc_segmap_parloop_339162_task.iterations = iterations;
    futhark_mc_segmap_parloop_339162_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_339162_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339162_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_339162_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_339162_task);
    
    if (futhark_mc_segmap_parloop_339162_err != 0) {
        err = futhark_mc_segmap_parloop_339162_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339162_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339162_total_end -
                 futhark_mc_segmap_parloop_339162_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339162_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339162_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339162_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_339160_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_339160_end -
                 futhark_mc_segmap_task_339160_start;
        
        ctx->futhark_mc_segmap_task_339160_runs[tid]++;
        ctx->futhark_mc_segmap_task_339160_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_339160_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_segmap_parloop_struct_339164 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_q_t_292679;
    int64_t free_jump_t_292685;
    int64_t free_t_n_m_292839;
    int64_t free_i_292846;
    int64_t free_gtid_310135;
    int64_t free_x_310140;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_313143;
    unsigned char *free_mem_313147;
    unsigned char *free_mem_316631;
    unsigned char *free_mem_316634;
    unsigned char *free_mem_316637;
    unsigned char *free_mem_316640;
};
struct futhark_mc_task_339166 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_310135;
    int64_t free_x_310140;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_316631;
    int64_t free_x_336600;
    double free_x_336601;
    int64_t free_defunc_0_g_res_336604;
    double *retval_defunc_2_reduce_res_336605;
    double *retval_defunc_2_reduce_res_336606;
    double *retval_defunc_2_reduce_res_336607;
    double *retval_defunc_2_reduce_res_336608;
    double *retval_defunc_2_reduce_res_336609;
};
struct futhark_mc_segred_stage_1_parloop_struct_339173 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_310135;
    int64_t free_x_310140;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_316631;
    int64_t free_x_336600;
    double free_x_336601;
    int64_t free_defunc_0_g_res_336604;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_337029;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_337031;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_337033;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_337035;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_337037;
};
static int futhark_mc_segred_stage_1_parloop_339174(void *args, int64_t start,
                                                    int64_t end,
                                                    int flat_tid_336944,
                                                    int tid)
{
    int err = 0;
    struct futhark_mc_segred_stage_1_parloop_struct_339173
    *futhark_mc_segred_stage_1_parloop_struct_339173 =
    (struct futhark_mc_segred_stage_1_parloop_struct_339173 *) args;
    struct futhark_context *ctx =
                           futhark_mc_segred_stage_1_parloop_struct_339173->ctx;
    uint64_t futhark_mc_segred_stage_1_parloop_339174_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_339174_start = get_wall_time();
    
    int64_t n_292675 =
            futhark_mc_segred_stage_1_parloop_struct_339173->free_n_292675;
    int64_t gtid_310135 =
            futhark_mc_segred_stage_1_parloop_struct_339173->free_gtid_310135;
    int64_t x_310140 =
            futhark_mc_segred_stage_1_parloop_struct_339173->free_x_310140;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_339173->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_316631 = {.desc ="mem_316631", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_339173->free_mem_316631,
                                  .size =0, .references =NULL};
    int64_t x_336600 =
            futhark_mc_segred_stage_1_parloop_struct_339173->free_x_336600;
    double x_336601 =
           futhark_mc_segred_stage_1_parloop_struct_339173->free_x_336601;
    int64_t defunc_0_g_res_336604 =
            futhark_mc_segred_stage_1_parloop_struct_339173->free_defunc_0_g_res_336604;
    struct memblock reduce_stage_1_tid_res_arr_mem_337029 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_337029",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_339173->free_reduce_stage_1_tid_res_arr_mem_337029,
                                                             .size =0,
                                                             .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_337031 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_337031",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_339173->free_reduce_stage_1_tid_res_arr_mem_337031,
                                                             .size =0,
                                                             .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_337033 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_337033",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_339173->free_reduce_stage_1_tid_res_arr_mem_337033,
                                                             .size =0,
                                                             .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_337035 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_337035",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_339173->free_reduce_stage_1_tid_res_arr_mem_337035,
                                                             .size =0,
                                                             .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_337037 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_337037",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_339173->free_reduce_stage_1_tid_res_arr_mem_337037,
                                                             .size =0,
                                                             .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_337039 = start;
    double x_336946;
    double x_336947;
    double x_336949;
    double x_336950;
    double x_336952;
    double x_336953;
    double x_336955;
    double x_336956;
    double x_336958;
    double x_336959;
    double local_acc_337040 = 0.0;
    double local_acc_337041 = 0.0;
    double local_acc_337042 = 0.0;
    double local_acc_337043 = 0.0;
    double local_acc_337044 = 0.0;
    
    for (; iter_337039 < end; iter_337039++) {
        int64_t gtid_336945 = iter_337039;
        bool cond_336961 = sle64(x_310140, gtid_336945);
        int64_t defunc_0_f_res_336962;
        
        if (cond_336961) {
            defunc_0_f_res_336962 = (int64_t) 0;
        } else {
            int64_t i_336963 = add64(x_336600, gtid_336945);
            int64_t defunc_0_add_arg_336964;
            
            defunc_0_add_arg_336964 = ((int64_t *) mem_312636.mem)[gtid_310135 *
                                                                   n_292675 +
                                                                   i_336963];
            
            int64_t defunc_1_add_res_336965 = add64((int64_t) 1,
                                                    defunc_0_add_arg_336964);
            
            defunc_0_f_res_336962 = defunc_1_add_res_336965;
        }
        
        double defunc_0_f_res_336966;
        
        if (cond_336961) {
            defunc_0_f_res_336966 = 0.0;
        } else {
            int64_t i_336967 = add64(x_336600, gtid_336945);
            double defunc_0_add_arg_336968;
            
            defunc_0_add_arg_336968 = ((double *) mem_316631.mem)[i_336967];
            defunc_0_f_res_336966 = defunc_0_add_arg_336968;
        }
        
        int64_t binop_p_336969 = sub64(defunc_0_f_res_336962,
                                       defunc_0_g_res_336604);
        double defunc_0_f_res_336970 = sitofp_i64_f64(binop_p_336969);
        double abs_res_336971 = fabs(defunc_0_f_res_336970);
        double tmp1_336972 = abs_res_336971 / x_336601;
        double x_336973 = tmp1_336972 * tmp1_336972;
        double y_336974 = tmp1_336972 * x_336973;
        double tmp2_336975 = 1.0 - y_336974;
        double x_336976 = tmp2_336975 * tmp2_336975;
        double tmp3_336977 = tmp2_336975 * x_336976;
        double w_j_336978 = defunc_0_f_res_336966 * tmp3_336977;
        double xw_j_336979 = defunc_0_f_res_336970 * w_j_336978;
        double x2w_j_336980 = defunc_0_f_res_336970 * xw_j_336979;
        double x3w_j_336981 = defunc_0_f_res_336970 * x2w_j_336980;
        double x4w_j_336982 = defunc_0_f_res_336970 * x3w_j_336981;
        
        // save map-out results
        { }
        // Load accum params
        {
            x_336946 = local_acc_337040;
        }
        // Load next params
        {
            x_336947 = w_j_336978;
        }
        // Red body
        {
            double defunc_1_op_res_336948 = x_336946 + x_336947;
            
            local_acc_337040 = defunc_1_op_res_336948;
        }
        // Load accum params
        {
            x_336949 = local_acc_337041;
        }
        // Load next params
        {
            x_336950 = xw_j_336979;
        }
        // Red body
        {
            double defunc_1_op_res_336951 = x_336949 + x_336950;
            
            local_acc_337041 = defunc_1_op_res_336951;
        }
        // Load accum params
        {
            x_336952 = local_acc_337042;
        }
        // Load next params
        {
            x_336953 = x2w_j_336980;
        }
        // Red body
        {
            double defunc_1_op_res_336954 = x_336952 + x_336953;
            
            local_acc_337042 = defunc_1_op_res_336954;
        }
        // Load accum params
        {
            x_336955 = local_acc_337043;
        }
        // Load next params
        {
            x_336956 = x3w_j_336981;
        }
        // Red body
        {
            double defunc_1_op_res_336957 = x_336955 + x_336956;
            
            local_acc_337043 = defunc_1_op_res_336957;
        }
        // Load accum params
        {
            x_336958 = local_acc_337044;
        }
        // Load next params
        {
            x_336959 = x4w_j_336982;
        }
        // Red body
        {
            double defunc_1_op_res_336960 = x_336958 + x_336959;
            
            local_acc_337044 = defunc_1_op_res_336960;
        }
    }
    ((double *) reduce_stage_1_tid_res_arr_mem_337029.mem)[flat_tid_336944] =
        local_acc_337040;
    ((double *) reduce_stage_1_tid_res_arr_mem_337031.mem)[flat_tid_336944] =
        local_acc_337041;
    ((double *) reduce_stage_1_tid_res_arr_mem_337033.mem)[flat_tid_336944] =
        local_acc_337042;
    ((double *) reduce_stage_1_tid_res_arr_mem_337035.mem)[flat_tid_336944] =
        local_acc_337043;
    ((double *) reduce_stage_1_tid_res_arr_mem_337037.mem)[flat_tid_336944] =
        local_acc_337044;
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_339174_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_339174_end -
                 futhark_mc_segred_stage_1_parloop_339174_start;
        
        ctx->futhark_mc_segred_stage_1_parloop_339174_runs[tid]++;
        ctx->futhark_mc_segred_stage_1_parloop_339174_total_runtime[tid] +=
            elapsed;
        ctx->futhark_mc_segred_stage_1_parloop_339174_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segred_task_339167(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_336944 = tid;
    int num_tasks_337028 = info.nsubtasks;
    struct futhark_mc_task_339166 *futhark_mc_task_339166 =
                                  (struct futhark_mc_task_339166 *) args;
    struct futhark_context *ctx = futhark_mc_task_339166->ctx;
    uint64_t futhark_mc_segred_task_339167_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_task_339167_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_339166->free_n_292675;
    int64_t gtid_310135 = futhark_mc_task_339166->free_gtid_310135;
    int64_t x_310140 = futhark_mc_task_339166->free_x_310140;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_task_339166->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_316631 = {.desc ="mem_316631", .mem =
                                  futhark_mc_task_339166->free_mem_316631,
                                  .size =0, .references =NULL};
    int64_t x_336600 = futhark_mc_task_339166->free_x_336600;
    double x_336601 = futhark_mc_task_339166->free_x_336601;
    int64_t defunc_0_g_res_336604 =
            futhark_mc_task_339166->free_defunc_0_g_res_336604;
    double defunc_2_reduce_res_336605 =
           *futhark_mc_task_339166->retval_defunc_2_reduce_res_336605;
    double defunc_2_reduce_res_336606 =
           *futhark_mc_task_339166->retval_defunc_2_reduce_res_336606;
    double defunc_2_reduce_res_336607 =
           *futhark_mc_task_339166->retval_defunc_2_reduce_res_336607;
    double defunc_2_reduce_res_336608 =
           *futhark_mc_task_339166->retval_defunc_2_reduce_res_336608;
    double defunc_2_reduce_res_336609 =
           *futhark_mc_task_339166->retval_defunc_2_reduce_res_336609;
    size_t reduce_stage_1_tid_res_arr_mem_337029_cached_sizze_339168 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_337029 = NULL;
    size_t reduce_stage_1_tid_res_arr_mem_337031_cached_sizze_339169 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_337031 = NULL;
    size_t reduce_stage_1_tid_res_arr_mem_337033_cached_sizze_339170 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_337033 = NULL;
    size_t reduce_stage_1_tid_res_arr_mem_337035_cached_sizze_339171 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_337035 = NULL;
    size_t reduce_stage_1_tid_res_arr_mem_337037_cached_sizze_339172 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_337037 = NULL;
    
    if (reduce_stage_1_tid_res_arr_mem_337029_cached_sizze_339168 <
        (size_t) ((int64_t) 8 * num_tasks_337028)) {
        reduce_stage_1_tid_res_arr_mem_337029 =
            realloc(reduce_stage_1_tid_res_arr_mem_337029, (int64_t) 8 *
                    num_tasks_337028);
        reduce_stage_1_tid_res_arr_mem_337029_cached_sizze_339168 =
            (int64_t) 8 * num_tasks_337028;
    }
    if (reduce_stage_1_tid_res_arr_mem_337031_cached_sizze_339169 <
        (size_t) ((int64_t) 8 * num_tasks_337028)) {
        reduce_stage_1_tid_res_arr_mem_337031 =
            realloc(reduce_stage_1_tid_res_arr_mem_337031, (int64_t) 8 *
                    num_tasks_337028);
        reduce_stage_1_tid_res_arr_mem_337031_cached_sizze_339169 =
            (int64_t) 8 * num_tasks_337028;
    }
    if (reduce_stage_1_tid_res_arr_mem_337033_cached_sizze_339170 <
        (size_t) ((int64_t) 8 * num_tasks_337028)) {
        reduce_stage_1_tid_res_arr_mem_337033 =
            realloc(reduce_stage_1_tid_res_arr_mem_337033, (int64_t) 8 *
                    num_tasks_337028);
        reduce_stage_1_tid_res_arr_mem_337033_cached_sizze_339170 =
            (int64_t) 8 * num_tasks_337028;
    }
    if (reduce_stage_1_tid_res_arr_mem_337035_cached_sizze_339171 <
        (size_t) ((int64_t) 8 * num_tasks_337028)) {
        reduce_stage_1_tid_res_arr_mem_337035 =
            realloc(reduce_stage_1_tid_res_arr_mem_337035, (int64_t) 8 *
                    num_tasks_337028);
        reduce_stage_1_tid_res_arr_mem_337035_cached_sizze_339171 =
            (int64_t) 8 * num_tasks_337028;
    }
    if (reduce_stage_1_tid_res_arr_mem_337037_cached_sizze_339172 <
        (size_t) ((int64_t) 8 * num_tasks_337028)) {
        reduce_stage_1_tid_res_arr_mem_337037 =
            realloc(reduce_stage_1_tid_res_arr_mem_337037, (int64_t) 8 *
                    num_tasks_337028);
        reduce_stage_1_tid_res_arr_mem_337037_cached_sizze_339172 =
            (int64_t) 8 * num_tasks_337028;
    }
    
    int64_t iter_337039;
    struct futhark_mc_segred_stage_1_parloop_struct_339173
    futhark_mc_segred_stage_1_parloop_struct_339173;
    
    futhark_mc_segred_stage_1_parloop_struct_339173.ctx = ctx;
    futhark_mc_segred_stage_1_parloop_struct_339173.free_n_292675 = n_292675;
    futhark_mc_segred_stage_1_parloop_struct_339173.free_gtid_310135 =
        gtid_310135;
    futhark_mc_segred_stage_1_parloop_struct_339173.free_x_310140 = x_310140;
    futhark_mc_segred_stage_1_parloop_struct_339173.free_mem_312636 =
        mem_312636.mem;
    futhark_mc_segred_stage_1_parloop_struct_339173.free_mem_316631 =
        mem_316631.mem;
    futhark_mc_segred_stage_1_parloop_struct_339173.free_x_336600 = x_336600;
    futhark_mc_segred_stage_1_parloop_struct_339173.free_x_336601 = x_336601;
    futhark_mc_segred_stage_1_parloop_struct_339173.free_defunc_0_g_res_336604 =
        defunc_0_g_res_336604;
    futhark_mc_segred_stage_1_parloop_struct_339173.free_reduce_stage_1_tid_res_arr_mem_337029 =
        reduce_stage_1_tid_res_arr_mem_337029;
    futhark_mc_segred_stage_1_parloop_struct_339173.free_reduce_stage_1_tid_res_arr_mem_337031 =
        reduce_stage_1_tid_res_arr_mem_337031;
    futhark_mc_segred_stage_1_parloop_struct_339173.free_reduce_stage_1_tid_res_arr_mem_337033 =
        reduce_stage_1_tid_res_arr_mem_337033;
    futhark_mc_segred_stage_1_parloop_struct_339173.free_reduce_stage_1_tid_res_arr_mem_337035 =
        reduce_stage_1_tid_res_arr_mem_337035;
    futhark_mc_segred_stage_1_parloop_struct_339173.free_reduce_stage_1_tid_res_arr_mem_337037 =
        reduce_stage_1_tid_res_arr_mem_337037;
    
    struct scheduler_parloop futhark_mc_segred_stage_1_parloop_339174_task;
    
    futhark_mc_segred_stage_1_parloop_339174_task.name =
        "futhark_mc_segred_stage_1_parloop_339174";
    futhark_mc_segred_stage_1_parloop_339174_task.fn =
        futhark_mc_segred_stage_1_parloop_339174;
    futhark_mc_segred_stage_1_parloop_339174_task.args =
        &futhark_mc_segred_stage_1_parloop_struct_339173;
    futhark_mc_segred_stage_1_parloop_339174_task.iterations = iterations;
    futhark_mc_segred_stage_1_parloop_339174_task.info = info;
    
    uint64_t futhark_mc_segred_stage_1_parloop_339174_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_339174_total_start = get_wall_time();
    
    int futhark_mc_segred_stage_1_parloop_339174_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segred_stage_1_parloop_339174_task);
    
    if (futhark_mc_segred_stage_1_parloop_339174_err != 0) {
        err = futhark_mc_segred_stage_1_parloop_339174_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_339174_total_end =
                 get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_339174_total_end -
                 futhark_mc_segred_stage_1_parloop_339174_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_339174_total_runs,
                           1, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_339174_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_339174_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    // neutral-initialise the output
    {
        defunc_2_reduce_res_336605 = 0.0;
        defunc_2_reduce_res_336606 = 0.0;
        defunc_2_reduce_res_336607 = 0.0;
        defunc_2_reduce_res_336608 = 0.0;
        defunc_2_reduce_res_336609 = 0.0;
    }
    
    double x_337045;
    double x_337046;
    double x_337048;
    double x_337049;
    double x_337051;
    double x_337052;
    double x_337054;
    double x_337055;
    double x_337057;
    double x_337058;
    
    for (int32_t i_337060 = 0; i_337060 < num_tasks_337028; i_337060++) {
        flat_tid_336944 = i_337060;
        // Apply main thread reduction
        {
            // load acc params
            {
                x_337045 = defunc_2_reduce_res_336605;
            }
            // load next params
            {
                x_337046 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_337029)[flat_tid_336944];
            }
            // red body
            {
                double defunc_1_op_res_337047 = x_337045 + x_337046;
                
                defunc_2_reduce_res_336605 = defunc_1_op_res_337047;
            }
            // load acc params
            {
                x_337048 = defunc_2_reduce_res_336606;
            }
            // load next params
            {
                x_337049 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_337031)[flat_tid_336944];
            }
            // red body
            {
                double defunc_1_op_res_337050 = x_337048 + x_337049;
                
                defunc_2_reduce_res_336606 = defunc_1_op_res_337050;
            }
            // load acc params
            {
                x_337051 = defunc_2_reduce_res_336607;
            }
            // load next params
            {
                x_337052 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_337033)[flat_tid_336944];
            }
            // red body
            {
                double defunc_1_op_res_337053 = x_337051 + x_337052;
                
                defunc_2_reduce_res_336607 = defunc_1_op_res_337053;
            }
            // load acc params
            {
                x_337054 = defunc_2_reduce_res_336608;
            }
            // load next params
            {
                x_337055 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_337035)[flat_tid_336944];
            }
            // red body
            {
                double defunc_1_op_res_337056 = x_337054 + x_337055;
                
                defunc_2_reduce_res_336608 = defunc_1_op_res_337056;
            }
            // load acc params
            {
                x_337057 = defunc_2_reduce_res_336609;
            }
            // load next params
            {
                x_337058 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_337037)[flat_tid_336944];
            }
            // red body
            {
                double defunc_1_op_res_337059 = x_337057 + x_337058;
                
                defunc_2_reduce_res_336609 = defunc_1_op_res_337059;
            }
        }
    }
    
  cleanup:
    {
        free(reduce_stage_1_tid_res_arr_mem_337029);
        free(reduce_stage_1_tid_res_arr_mem_337031);
        free(reduce_stage_1_tid_res_arr_mem_337033);
        free(reduce_stage_1_tid_res_arr_mem_337035);
        free(reduce_stage_1_tid_res_arr_mem_337037);
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_task_339167_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_task_339167_end -
                 futhark_mc_segred_task_339167_start;
        
        ctx->futhark_mc_segred_task_339167_runs[tid]++;
        ctx->futhark_mc_segred_task_339167_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segred_task_339167_iter[tid] += iterations;
    }
    if (err == 0) {
        *futhark_mc_task_339166->retval_defunc_2_reduce_res_336605 =
            defunc_2_reduce_res_336605;
        *futhark_mc_task_339166->retval_defunc_2_reduce_res_336606 =
            defunc_2_reduce_res_336606;
        *futhark_mc_task_339166->retval_defunc_2_reduce_res_336607 =
            defunc_2_reduce_res_336607;
        *futhark_mc_task_339166->retval_defunc_2_reduce_res_336608 =
            defunc_2_reduce_res_336608;
        *futhark_mc_task_339166->retval_defunc_2_reduce_res_336609 =
            defunc_2_reduce_res_336609;
    }
    return err;
}
struct futhark_mc_task_339175 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_310135;
    int64_t free_x_310140;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_316631;
    unsigned char *free_mem_316634;
    int64_t free_x_336600;
    double free_x_336601;
    int64_t free_defunc_0_g_res_336604;
    double free_a12_336674;
    double free_b12_336675;
    double free_c12_336676;
    double free_b2_336677;
    double free_c2_336678;
    double *retval_defunc_2_reduce_res_336679;
    double *retval_defunc_2_reduce_res_336680;
};
struct futhark_mc_segred_stage_1_parloop_struct_339179 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_310135;
    int64_t free_x_310140;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_316631;
    unsigned char *free_mem_316634;
    int64_t free_x_336600;
    double free_x_336601;
    int64_t free_defunc_0_g_res_336604;
    double free_a12_336674;
    double free_b12_336675;
    double free_c12_336676;
    double free_b2_336677;
    double free_c2_336678;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_337062;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_337064;
};
static int futhark_mc_segred_stage_1_parloop_339180(void *args, int64_t start,
                                                    int64_t end,
                                                    int flat_tid_336983,
                                                    int tid)
{
    int err = 0;
    struct futhark_mc_segred_stage_1_parloop_struct_339179
    *futhark_mc_segred_stage_1_parloop_struct_339179 =
    (struct futhark_mc_segred_stage_1_parloop_struct_339179 *) args;
    struct futhark_context *ctx =
                           futhark_mc_segred_stage_1_parloop_struct_339179->ctx;
    uint64_t futhark_mc_segred_stage_1_parloop_339180_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_339180_start = get_wall_time();
    
    int64_t n_292675 =
            futhark_mc_segred_stage_1_parloop_struct_339179->free_n_292675;
    int64_t gtid_310135 =
            futhark_mc_segred_stage_1_parloop_struct_339179->free_gtid_310135;
    int64_t x_310140 =
            futhark_mc_segred_stage_1_parloop_struct_339179->free_x_310140;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_339179->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_316631 = {.desc ="mem_316631", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_339179->free_mem_316631,
                                  .size =0, .references =NULL};
    struct memblock mem_316634 = {.desc ="mem_316634", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_339179->free_mem_316634,
                                  .size =0, .references =NULL};
    int64_t x_336600 =
            futhark_mc_segred_stage_1_parloop_struct_339179->free_x_336600;
    double x_336601 =
           futhark_mc_segred_stage_1_parloop_struct_339179->free_x_336601;
    int64_t defunc_0_g_res_336604 =
            futhark_mc_segred_stage_1_parloop_struct_339179->free_defunc_0_g_res_336604;
    double a12_336674 =
           futhark_mc_segred_stage_1_parloop_struct_339179->free_a12_336674;
    double b12_336675 =
           futhark_mc_segred_stage_1_parloop_struct_339179->free_b12_336675;
    double c12_336676 =
           futhark_mc_segred_stage_1_parloop_struct_339179->free_c12_336676;
    double b2_336677 =
           futhark_mc_segred_stage_1_parloop_struct_339179->free_b2_336677;
    double c2_336678 =
           futhark_mc_segred_stage_1_parloop_struct_339179->free_c2_336678;
    struct memblock reduce_stage_1_tid_res_arr_mem_337062 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_337062",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_339179->free_reduce_stage_1_tid_res_arr_mem_337062,
                                                             .size =0,
                                                             .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_337064 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_337064",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_339179->free_reduce_stage_1_tid_res_arr_mem_337064,
                                                             .size =0,
                                                             .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_337066 = start;
    double x_336985;
    double x_336986;
    double x_336988;
    double x_336989;
    double local_acc_337067 = 0.0;
    double local_acc_337068 = 0.0;
    
    for (; iter_337066 < end; iter_337066++) {
        int64_t gtid_336984 = iter_337066;
        bool cond_336991 = sle64(x_310140, gtid_336984);
        int64_t defunc_0_f_res_336992;
        
        if (cond_336991) {
            defunc_0_f_res_336992 = (int64_t) 0;
        } else {
            int64_t i_336993 = add64(x_336600, gtid_336984);
            int64_t defunc_0_add_arg_336994;
            
            defunc_0_add_arg_336994 = ((int64_t *) mem_312636.mem)[gtid_310135 *
                                                                   n_292675 +
                                                                   i_336993];
            
            int64_t defunc_1_add_res_336995 = add64((int64_t) 1,
                                                    defunc_0_add_arg_336994);
            
            defunc_0_f_res_336992 = defunc_1_add_res_336995;
        }
        
        double defunc_0_f_res_336996;
        
        if (cond_336991) {
            defunc_0_f_res_336996 = 0.0;
        } else {
            int64_t i_336997 = add64(x_336600, gtid_336984);
            double defunc_0_add_arg_336998;
            
            defunc_0_add_arg_336998 = ((double *) mem_316631.mem)[i_336997];
            defunc_0_f_res_336996 = defunc_0_add_arg_336998;
        }
        
        int64_t binop_p_336999 = sub64(defunc_0_f_res_336992,
                                       defunc_0_g_res_336604);
        double defunc_0_f_res_337000 = sitofp_i64_f64(binop_p_336999);
        double abs_res_337001 = fabs(defunc_0_f_res_337000);
        double tmp1_337002 = abs_res_337001 / x_336601;
        double x_337003 = tmp1_337002 * tmp1_337002;
        double y_337004 = tmp1_337002 * x_337003;
        double tmp2_337005 = 1.0 - y_337004;
        double x_337006 = tmp2_337005 * tmp2_337005;
        double tmp3_337007 = tmp2_337005 * x_337006;
        double tmp4_337008 = defunc_0_f_res_336996 * tmp3_337007;
        double defunc_1_f_res_337009 = defunc_0_f_res_337000 * tmp4_337008;
        double defunc_1_f_res_337010 = defunc_0_f_res_337000 *
               defunc_1_f_res_337009;
        double defunc_0_f_res_337011;
        
        if (cond_336991) {
            defunc_0_f_res_337011 = 0.0;
        } else {
            int64_t i_337012 = add64(x_336600, gtid_336984);
            double defunc_0_add_arg_337013;
            
            defunc_0_add_arg_337013 = ((double *) mem_316634.mem)[i_337012];
            defunc_0_f_res_337011 = defunc_0_add_arg_337013;
        }
        
        double x_337014 = a12_336674 * tmp4_337008;
        double y_337015 = b12_336675 * defunc_1_f_res_337009;
        double x_337016 = x_337014 + y_337015;
        double y_337017 = c12_336676 * defunc_1_f_res_337010;
        double x_337018 = x_337016 + y_337017;
        double defunc_9_fit_fun_res_337019 = defunc_0_f_res_337011 * x_337018;
        double x_337020 = b12_336675 * tmp4_337008;
        double y_337021 = b2_336677 * defunc_1_f_res_337009;
        double x_337022 = x_337020 + y_337021;
        double y_337023 = c2_336678 * defunc_1_f_res_337010;
        double x_337024 = x_337022 + y_337023;
        double defunc_9_slope_fun_res_337025 = defunc_0_f_res_337011 * x_337024;
        
        // save map-out results
        { }
        // Load accum params
        {
            x_336985 = local_acc_337067;
        }
        // Load next params
        {
            x_336986 = defunc_9_fit_fun_res_337019;
        }
        // Red body
        {
            double defunc_1_op_res_336987 = x_336985 + x_336986;
            
            local_acc_337067 = defunc_1_op_res_336987;
        }
        // Load accum params
        {
            x_336988 = local_acc_337068;
        }
        // Load next params
        {
            x_336989 = defunc_9_slope_fun_res_337025;
        }
        // Red body
        {
            double defunc_1_op_res_336990 = x_336988 + x_336989;
            
            local_acc_337068 = defunc_1_op_res_336990;
        }
    }
    ((double *) reduce_stage_1_tid_res_arr_mem_337062.mem)[flat_tid_336983] =
        local_acc_337067;
    ((double *) reduce_stage_1_tid_res_arr_mem_337064.mem)[flat_tid_336983] =
        local_acc_337068;
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_339180_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_339180_end -
                 futhark_mc_segred_stage_1_parloop_339180_start;
        
        ctx->futhark_mc_segred_stage_1_parloop_339180_runs[tid]++;
        ctx->futhark_mc_segred_stage_1_parloop_339180_total_runtime[tid] +=
            elapsed;
        ctx->futhark_mc_segred_stage_1_parloop_339180_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segred_task_339176(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_336983 = tid;
    int num_tasks_337061 = info.nsubtasks;
    struct futhark_mc_task_339175 *futhark_mc_task_339175 =
                                  (struct futhark_mc_task_339175 *) args;
    struct futhark_context *ctx = futhark_mc_task_339175->ctx;
    uint64_t futhark_mc_segred_task_339176_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_task_339176_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_339175->free_n_292675;
    int64_t gtid_310135 = futhark_mc_task_339175->free_gtid_310135;
    int64_t x_310140 = futhark_mc_task_339175->free_x_310140;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_task_339175->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_316631 = {.desc ="mem_316631", .mem =
                                  futhark_mc_task_339175->free_mem_316631,
                                  .size =0, .references =NULL};
    struct memblock mem_316634 = {.desc ="mem_316634", .mem =
                                  futhark_mc_task_339175->free_mem_316634,
                                  .size =0, .references =NULL};
    int64_t x_336600 = futhark_mc_task_339175->free_x_336600;
    double x_336601 = futhark_mc_task_339175->free_x_336601;
    int64_t defunc_0_g_res_336604 =
            futhark_mc_task_339175->free_defunc_0_g_res_336604;
    double a12_336674 = futhark_mc_task_339175->free_a12_336674;
    double b12_336675 = futhark_mc_task_339175->free_b12_336675;
    double c12_336676 = futhark_mc_task_339175->free_c12_336676;
    double b2_336677 = futhark_mc_task_339175->free_b2_336677;
    double c2_336678 = futhark_mc_task_339175->free_c2_336678;
    double defunc_2_reduce_res_336679 =
           *futhark_mc_task_339175->retval_defunc_2_reduce_res_336679;
    double defunc_2_reduce_res_336680 =
           *futhark_mc_task_339175->retval_defunc_2_reduce_res_336680;
    size_t reduce_stage_1_tid_res_arr_mem_337062_cached_sizze_339177 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_337062 = NULL;
    size_t reduce_stage_1_tid_res_arr_mem_337064_cached_sizze_339178 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_337064 = NULL;
    
    if (reduce_stage_1_tid_res_arr_mem_337062_cached_sizze_339177 <
        (size_t) ((int64_t) 8 * num_tasks_337061)) {
        reduce_stage_1_tid_res_arr_mem_337062 =
            realloc(reduce_stage_1_tid_res_arr_mem_337062, (int64_t) 8 *
                    num_tasks_337061);
        reduce_stage_1_tid_res_arr_mem_337062_cached_sizze_339177 =
            (int64_t) 8 * num_tasks_337061;
    }
    if (reduce_stage_1_tid_res_arr_mem_337064_cached_sizze_339178 <
        (size_t) ((int64_t) 8 * num_tasks_337061)) {
        reduce_stage_1_tid_res_arr_mem_337064 =
            realloc(reduce_stage_1_tid_res_arr_mem_337064, (int64_t) 8 *
                    num_tasks_337061);
        reduce_stage_1_tid_res_arr_mem_337064_cached_sizze_339178 =
            (int64_t) 8 * num_tasks_337061;
    }
    
    int64_t iter_337066;
    struct futhark_mc_segred_stage_1_parloop_struct_339179
    futhark_mc_segred_stage_1_parloop_struct_339179;
    
    futhark_mc_segred_stage_1_parloop_struct_339179.ctx = ctx;
    futhark_mc_segred_stage_1_parloop_struct_339179.free_n_292675 = n_292675;
    futhark_mc_segred_stage_1_parloop_struct_339179.free_gtid_310135 =
        gtid_310135;
    futhark_mc_segred_stage_1_parloop_struct_339179.free_x_310140 = x_310140;
    futhark_mc_segred_stage_1_parloop_struct_339179.free_mem_312636 =
        mem_312636.mem;
    futhark_mc_segred_stage_1_parloop_struct_339179.free_mem_316631 =
        mem_316631.mem;
    futhark_mc_segred_stage_1_parloop_struct_339179.free_mem_316634 =
        mem_316634.mem;
    futhark_mc_segred_stage_1_parloop_struct_339179.free_x_336600 = x_336600;
    futhark_mc_segred_stage_1_parloop_struct_339179.free_x_336601 = x_336601;
    futhark_mc_segred_stage_1_parloop_struct_339179.free_defunc_0_g_res_336604 =
        defunc_0_g_res_336604;
    futhark_mc_segred_stage_1_parloop_struct_339179.free_a12_336674 =
        a12_336674;
    futhark_mc_segred_stage_1_parloop_struct_339179.free_b12_336675 =
        b12_336675;
    futhark_mc_segred_stage_1_parloop_struct_339179.free_c12_336676 =
        c12_336676;
    futhark_mc_segred_stage_1_parloop_struct_339179.free_b2_336677 = b2_336677;
    futhark_mc_segred_stage_1_parloop_struct_339179.free_c2_336678 = c2_336678;
    futhark_mc_segred_stage_1_parloop_struct_339179.free_reduce_stage_1_tid_res_arr_mem_337062 =
        reduce_stage_1_tid_res_arr_mem_337062;
    futhark_mc_segred_stage_1_parloop_struct_339179.free_reduce_stage_1_tid_res_arr_mem_337064 =
        reduce_stage_1_tid_res_arr_mem_337064;
    
    struct scheduler_parloop futhark_mc_segred_stage_1_parloop_339180_task;
    
    futhark_mc_segred_stage_1_parloop_339180_task.name =
        "futhark_mc_segred_stage_1_parloop_339180";
    futhark_mc_segred_stage_1_parloop_339180_task.fn =
        futhark_mc_segred_stage_1_parloop_339180;
    futhark_mc_segred_stage_1_parloop_339180_task.args =
        &futhark_mc_segred_stage_1_parloop_struct_339179;
    futhark_mc_segred_stage_1_parloop_339180_task.iterations = iterations;
    futhark_mc_segred_stage_1_parloop_339180_task.info = info;
    
    uint64_t futhark_mc_segred_stage_1_parloop_339180_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_339180_total_start = get_wall_time();
    
    int futhark_mc_segred_stage_1_parloop_339180_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segred_stage_1_parloop_339180_task);
    
    if (futhark_mc_segred_stage_1_parloop_339180_err != 0) {
        err = futhark_mc_segred_stage_1_parloop_339180_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_339180_total_end =
                 get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_339180_total_end -
                 futhark_mc_segred_stage_1_parloop_339180_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_339180_total_runs,
                           1, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_339180_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_339180_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    // neutral-initialise the output
    {
        defunc_2_reduce_res_336679 = 0.0;
        defunc_2_reduce_res_336680 = 0.0;
    }
    
    double x_337069;
    double x_337070;
    double x_337072;
    double x_337073;
    
    for (int32_t i_337075 = 0; i_337075 < num_tasks_337061; i_337075++) {
        flat_tid_336983 = i_337075;
        // Apply main thread reduction
        {
            // load acc params
            {
                x_337069 = defunc_2_reduce_res_336679;
            }
            // load next params
            {
                x_337070 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_337062)[flat_tid_336983];
            }
            // red body
            {
                double defunc_1_op_res_337071 = x_337069 + x_337070;
                
                defunc_2_reduce_res_336679 = defunc_1_op_res_337071;
            }
            // load acc params
            {
                x_337072 = defunc_2_reduce_res_336680;
            }
            // load next params
            {
                x_337073 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_337064)[flat_tid_336983];
            }
            // red body
            {
                double defunc_1_op_res_337074 = x_337072 + x_337073;
                
                defunc_2_reduce_res_336680 = defunc_1_op_res_337074;
            }
        }
    }
    
  cleanup:
    {
        free(reduce_stage_1_tid_res_arr_mem_337062);
        free(reduce_stage_1_tid_res_arr_mem_337064);
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_task_339176_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_task_339176_end -
                 futhark_mc_segred_task_339176_start;
        
        ctx->futhark_mc_segred_task_339176_runs[tid]++;
        ctx->futhark_mc_segred_task_339176_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segred_task_339176_iter[tid] += iterations;
    }
    if (err == 0) {
        *futhark_mc_task_339175->retval_defunc_2_reduce_res_336679 =
            defunc_2_reduce_res_336679;
        *futhark_mc_task_339175->retval_defunc_2_reduce_res_336680 =
            defunc_2_reduce_res_336680;
    }
    return err;
}
static int futhark_mc_segmap_parloop_339165(void *args, int64_t start,
                                            int64_t end, int flat_tid_336598,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_339164
    *futhark_mc_segmap_parloop_struct_339164 =
    (struct futhark_mc_segmap_parloop_struct_339164 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_339164->ctx;
    uint64_t futhark_mc_segmap_parloop_339165_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339165_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_339164->free_n_292675;
    int64_t q_t_292679 =
            futhark_mc_segmap_parloop_struct_339164->free_q_t_292679;
    int64_t jump_t_292685 =
            futhark_mc_segmap_parloop_struct_339164->free_jump_t_292685;
    int64_t t_n_m_292839 =
            futhark_mc_segmap_parloop_struct_339164->free_t_n_m_292839;
    int64_t i_292846 = futhark_mc_segmap_parloop_struct_339164->free_i_292846;
    int64_t gtid_310135 =
            futhark_mc_segmap_parloop_struct_339164->free_gtid_310135;
    int64_t x_310140 = futhark_mc_segmap_parloop_struct_339164->free_x_310140;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_segmap_parloop_struct_339164->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_313143 = {.desc ="mem_313143", .mem =
                                  futhark_mc_segmap_parloop_struct_339164->free_mem_313143,
                                  .size =0, .references =NULL};
    struct memblock mem_313147 = {.desc ="mem_313147", .mem =
                                  futhark_mc_segmap_parloop_struct_339164->free_mem_313147,
                                  .size =0, .references =NULL};
    struct memblock mem_316631 = {.desc ="mem_316631", .mem =
                                  futhark_mc_segmap_parloop_struct_339164->free_mem_316631,
                                  .size =0, .references =NULL};
    struct memblock mem_316634 = {.desc ="mem_316634", .mem =
                                  futhark_mc_segmap_parloop_struct_339164->free_mem_316634,
                                  .size =0, .references =NULL};
    struct memblock mem_316637 = {.desc ="mem_316637", .mem =
                                  futhark_mc_segmap_parloop_struct_339164->free_mem_316637,
                                  .size =0, .references =NULL};
    struct memblock mem_316640 = {.desc ="mem_316640", .mem =
                                  futhark_mc_segmap_parloop_struct_339164->free_mem_316640,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_336943 = start;
    
    for (; iter_336943 < end; iter_336943++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_337026 = t_n_m_292839;
        int64_t gtid_336599 = iter_336943;
        int64_t remnant_337027 = iter_336943 - gtid_336599;
        int64_t x_336600;
        
        x_336600 = ((int64_t *) mem_313143.mem)[gtid_310135 * t_n_m_292839 +
                                                gtid_336599];
        
        double x_336601;
        
        x_336601 = ((double *) mem_313147.mem)[gtid_310135 * t_n_m_292839 +
                                               gtid_336599];
        
        int64_t min_arg_336602 = mul64(jump_t_292685, gtid_336599);
        int64_t min_res_336603 = smin64(i_292846, min_arg_336602);
        int64_t defunc_0_g_res_336604 = add64((int64_t) 1, min_res_336603);
        double defunc_2_reduce_res_336605;
        double defunc_2_reduce_res_336606;
        double defunc_2_reduce_res_336607;
        double defunc_2_reduce_res_336608;
        double defunc_2_reduce_res_336609;
        int64_t flat_tid_336944 = (int64_t) 0;
        int32_t num_tasks_337028;
        
        defunc_2_reduce_res_336605 = 0.0;
        defunc_2_reduce_res_336606 = 0.0;
        defunc_2_reduce_res_336607 = 0.0;
        defunc_2_reduce_res_336608 = 0.0;
        defunc_2_reduce_res_336609 = 0.0;
        
        struct futhark_mc_task_339166 futhark_mc_task_339166;
        
        futhark_mc_task_339166.ctx = ctx;
        futhark_mc_task_339166.free_n_292675 = n_292675;
        futhark_mc_task_339166.free_gtid_310135 = gtid_310135;
        futhark_mc_task_339166.free_x_310140 = x_310140;
        futhark_mc_task_339166.free_mem_312636 = mem_312636.mem;
        futhark_mc_task_339166.free_mem_316631 = mem_316631.mem;
        futhark_mc_task_339166.free_x_336600 = x_336600;
        futhark_mc_task_339166.free_x_336601 = x_336601;
        futhark_mc_task_339166.free_defunc_0_g_res_336604 =
            defunc_0_g_res_336604;
        futhark_mc_task_339166.retval_defunc_2_reduce_res_336605 =
            &defunc_2_reduce_res_336605;
        futhark_mc_task_339166.retval_defunc_2_reduce_res_336606 =
            &defunc_2_reduce_res_336606;
        futhark_mc_task_339166.retval_defunc_2_reduce_res_336607 =
            &defunc_2_reduce_res_336607;
        futhark_mc_task_339166.retval_defunc_2_reduce_res_336608 =
            &defunc_2_reduce_res_336608;
        futhark_mc_task_339166.retval_defunc_2_reduce_res_336609 =
            &defunc_2_reduce_res_336609;
        
        struct scheduler_segop futhark_mc_task_339166_task;
        
        futhark_mc_task_339166_task.args = &futhark_mc_task_339166;
        futhark_mc_task_339166_task.top_level_fn =
            futhark_mc_segred_task_339167;
        futhark_mc_task_339166_task.name = "futhark_mc_segred_task_339167";
        futhark_mc_task_339166_task.iterations = q_t_292679;
        futhark_mc_task_339166_task.task_time =
            &ctx->futhark_mc_segred_task_339167_total_time;
        futhark_mc_task_339166_task.task_iter =
            &ctx->futhark_mc_segred_task_339167_total_iter;
        futhark_mc_task_339166_task.sched = STATIC;
        futhark_mc_task_339166_task.nested_fn = NULL;
        
        int futhark_mc_segred_task_339167_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_339166_task);
        
        if (futhark_mc_segred_task_339167_err != 0) {
            ;
            err = futhark_mc_segred_task_339167_err;
            goto cleanup;
        }
        
        double a_336649 = 2.220446049250313e-16 + defunc_2_reduce_res_336605;
        double b_336650 = 2.220446049250313e-16 + defunc_2_reduce_res_336606;
        double c_336651 = 2.220446049250313e-16 + defunc_2_reduce_res_336607;
        double d_336652 = 2.220446049250313e-16 + defunc_2_reduce_res_336608;
        double e_336653 = 2.220446049250313e-16 + defunc_2_reduce_res_336609;
        double x_336654 = c_336651 * e_336653;
        double y_336655 = d_336652 * d_336652;
        double a12_336656 = x_336654 - y_336655;
        double x_336657 = c_336651 * d_336652;
        double y_336658 = b_336650 * e_336653;
        double b12_336659 = x_336657 - y_336658;
        double x_336660 = b_336650 * d_336652;
        double y_336661 = c_336651 * c_336651;
        double c12_336662 = x_336660 - y_336661;
        double x_336663 = a_336649 * e_336653;
        double b2_336664 = x_336663 - y_336661;
        double x_336665 = b_336650 * c_336651;
        double y_336666 = a_336649 * d_336652;
        double c2_336667 = x_336665 - y_336666;
        double x_336668 = a_336649 * a12_336656;
        double y_336669 = b_336650 * b12_336659;
        double x_336670 = x_336668 + y_336669;
        double y_336671 = c_336651 * c12_336662;
        double y_336672 = x_336670 + y_336671;
        double det_336673 = 1.0 / y_336672;
        double a12_336674 = a12_336656 * det_336673;
        double b12_336675 = b12_336659 * det_336673;
        double c12_336676 = c12_336662 * det_336673;
        double b2_336677 = b2_336664 * det_336673;
        double c2_336678 = c2_336667 * det_336673;
        double defunc_2_reduce_res_336679;
        double defunc_2_reduce_res_336680;
        int64_t flat_tid_336983 = (int64_t) 0;
        int32_t num_tasks_337061;
        
        defunc_2_reduce_res_336679 = 0.0;
        defunc_2_reduce_res_336680 = 0.0;
        
        struct futhark_mc_task_339175 futhark_mc_task_339175;
        
        futhark_mc_task_339175.ctx = ctx;
        futhark_mc_task_339175.free_n_292675 = n_292675;
        futhark_mc_task_339175.free_gtid_310135 = gtid_310135;
        futhark_mc_task_339175.free_x_310140 = x_310140;
        futhark_mc_task_339175.free_mem_312636 = mem_312636.mem;
        futhark_mc_task_339175.free_mem_316631 = mem_316631.mem;
        futhark_mc_task_339175.free_mem_316634 = mem_316634.mem;
        futhark_mc_task_339175.free_x_336600 = x_336600;
        futhark_mc_task_339175.free_x_336601 = x_336601;
        futhark_mc_task_339175.free_defunc_0_g_res_336604 =
            defunc_0_g_res_336604;
        futhark_mc_task_339175.free_a12_336674 = a12_336674;
        futhark_mc_task_339175.free_b12_336675 = b12_336675;
        futhark_mc_task_339175.free_c12_336676 = c12_336676;
        futhark_mc_task_339175.free_b2_336677 = b2_336677;
        futhark_mc_task_339175.free_c2_336678 = c2_336678;
        futhark_mc_task_339175.retval_defunc_2_reduce_res_336679 =
            &defunc_2_reduce_res_336679;
        futhark_mc_task_339175.retval_defunc_2_reduce_res_336680 =
            &defunc_2_reduce_res_336680;
        
        struct scheduler_segop futhark_mc_task_339175_task;
        
        futhark_mc_task_339175_task.args = &futhark_mc_task_339175;
        futhark_mc_task_339175_task.top_level_fn =
            futhark_mc_segred_task_339176;
        futhark_mc_task_339175_task.name = "futhark_mc_segred_task_339176";
        futhark_mc_task_339175_task.iterations = q_t_292679;
        futhark_mc_task_339175_task.task_time =
            &ctx->futhark_mc_segred_task_339176_total_time;
        futhark_mc_task_339175_task.task_iter =
            &ctx->futhark_mc_segred_task_339176_total_iter;
        futhark_mc_task_339175_task.sched = STATIC;
        futhark_mc_task_339175_task.nested_fn = NULL;
        
        int futhark_mc_segred_task_339176_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_339175_task);
        
        if (futhark_mc_segred_task_339176_err != 0) {
            ;
            err = futhark_mc_segred_task_339176_err;
            goto cleanup;
        }
        ((double *) mem_316637.mem)[gtid_336599] = defunc_2_reduce_res_336679;
        ((double *) mem_316640.mem)[gtid_336599] = defunc_2_reduce_res_336680;
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339165_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339165_end -
                 futhark_mc_segmap_parloop_339165_start;
        
        ctx->futhark_mc_segmap_parloop_339165_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_339165_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_339165_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_nested_task_339163(void *args, int64_t iterations,
                                         int tid, struct scheduler_info info)
{
    int err = 0;
    int flat_tid_336598 = tid;
    int num_tasks_336859 = info.nsubtasks;
    struct futhark_mc_task_339159 *futhark_mc_task_339159 =
                                  (struct futhark_mc_task_339159 *) args;
    struct futhark_context *ctx = futhark_mc_task_339159->ctx;
    uint64_t futhark_mc_segmap_nested_task_339163_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_nested_task_339163_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_339159->free_n_292675;
    int64_t q_t_292679 = futhark_mc_task_339159->free_q_t_292679;
    int64_t jump_t_292685 = futhark_mc_task_339159->free_jump_t_292685;
    int64_t t_n_m_292839 = futhark_mc_task_339159->free_t_n_m_292839;
    int64_t i_292846 = futhark_mc_task_339159->free_i_292846;
    int64_t gtid_310135 = futhark_mc_task_339159->free_gtid_310135;
    int64_t x_310140 = futhark_mc_task_339159->free_x_310140;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_task_339159->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_313143 = {.desc ="mem_313143", .mem =
                                  futhark_mc_task_339159->free_mem_313143,
                                  .size =0, .references =NULL};
    struct memblock mem_313147 = {.desc ="mem_313147", .mem =
                                  futhark_mc_task_339159->free_mem_313147,
                                  .size =0, .references =NULL};
    struct memblock mem_316631 = {.desc ="mem_316631", .mem =
                                  futhark_mc_task_339159->free_mem_316631,
                                  .size =0, .references =NULL};
    struct memblock mem_316634 = {.desc ="mem_316634", .mem =
                                  futhark_mc_task_339159->free_mem_316634,
                                  .size =0, .references =NULL};
    struct memblock mem_316637 = {.desc ="mem_316637", .mem =
                                  futhark_mc_task_339159->free_mem_316637,
                                  .size =0, .references =NULL};
    struct memblock mem_316640 = {.desc ="mem_316640", .mem =
                                  futhark_mc_task_339159->free_mem_316640,
                                  .size =0, .references =NULL};
    int64_t iter_336943;
    struct futhark_mc_segmap_parloop_struct_339164
    futhark_mc_segmap_parloop_struct_339164;
    
    futhark_mc_segmap_parloop_struct_339164.ctx = ctx;
    futhark_mc_segmap_parloop_struct_339164.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_339164.free_q_t_292679 = q_t_292679;
    futhark_mc_segmap_parloop_struct_339164.free_jump_t_292685 = jump_t_292685;
    futhark_mc_segmap_parloop_struct_339164.free_t_n_m_292839 = t_n_m_292839;
    futhark_mc_segmap_parloop_struct_339164.free_i_292846 = i_292846;
    futhark_mc_segmap_parloop_struct_339164.free_gtid_310135 = gtid_310135;
    futhark_mc_segmap_parloop_struct_339164.free_x_310140 = x_310140;
    futhark_mc_segmap_parloop_struct_339164.free_mem_312636 = mem_312636.mem;
    futhark_mc_segmap_parloop_struct_339164.free_mem_313143 = mem_313143.mem;
    futhark_mc_segmap_parloop_struct_339164.free_mem_313147 = mem_313147.mem;
    futhark_mc_segmap_parloop_struct_339164.free_mem_316631 = mem_316631.mem;
    futhark_mc_segmap_parloop_struct_339164.free_mem_316634 = mem_316634.mem;
    futhark_mc_segmap_parloop_struct_339164.free_mem_316637 = mem_316637.mem;
    futhark_mc_segmap_parloop_struct_339164.free_mem_316640 = mem_316640.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_339165_task;
    
    futhark_mc_segmap_parloop_339165_task.name =
        "futhark_mc_segmap_parloop_339165";
    futhark_mc_segmap_parloop_339165_task.fn = futhark_mc_segmap_parloop_339165;
    futhark_mc_segmap_parloop_339165_task.args =
        &futhark_mc_segmap_parloop_struct_339164;
    futhark_mc_segmap_parloop_339165_task.iterations = iterations;
    futhark_mc_segmap_parloop_339165_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_339165_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339165_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_339165_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_339165_task);
    
    if (futhark_mc_segmap_parloop_339165_err != 0) {
        err = futhark_mc_segmap_parloop_339165_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339165_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339165_total_end -
                 futhark_mc_segmap_parloop_339165_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339165_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339165_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339165_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_nested_task_339163_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_nested_task_339163_end -
                 futhark_mc_segmap_nested_task_339163_start;
        
        ctx->futhark_mc_segmap_nested_task_339163_runs[tid]++;
        ctx->futhark_mc_segmap_nested_task_339163_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_nested_task_339163_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
static int futhark_mc_segmap_parloop_339145(void *args, int64_t start,
                                            int64_t end, int flat_tid_310134,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_339144
    *futhark_mc_segmap_parloop_struct_339144 =
    (struct futhark_mc_segmap_parloop_struct_339144 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_339144->ctx;
    uint64_t futhark_mc_segmap_parloop_339145_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339145_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_339144->free_n_292675;
    int64_t q_t_292679 =
            futhark_mc_segmap_parloop_struct_339144->free_q_t_292679;
    int64_t jump_t_292685 =
            futhark_mc_segmap_parloop_struct_339144->free_jump_t_292685;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_339144->free_partition_sizze_292766;
    int64_t t_n_m_292839 =
            futhark_mc_segmap_parloop_struct_339144->free_t_n_m_292839;
    int64_t i_292846 = futhark_mc_segmap_parloop_struct_339144->free_i_292846;
    struct memblock mem_312593 = {.desc ="mem_312593", .mem =
                                  futhark_mc_segmap_parloop_struct_339144->free_mem_312593,
                                  .size =0, .references =NULL};
    int64_t bytes_312598 =
            futhark_mc_segmap_parloop_struct_339144->free_bytes_312598;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_segmap_parloop_struct_339144->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_312639 = {.desc ="mem_312639", .mem =
                                  futhark_mc_segmap_parloop_struct_339144->free_mem_312639,
                                  .size =0, .references =NULL};
    int64_t bytes_313090 =
            futhark_mc_segmap_parloop_struct_339144->free_bytes_313090;
    struct memblock mem_313143 = {.desc ="mem_313143", .mem =
                                  futhark_mc_segmap_parloop_struct_339144->free_mem_313143,
                                  .size =0, .references =NULL};
    struct memblock mem_313147 = {.desc ="mem_313147", .mem =
                                  futhark_mc_segmap_parloop_struct_339144->free_mem_313147,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_segmap_parloop_struct_339144->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_segmap_parloop_struct_339144->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_segmap_parloop_struct_339144->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_segmap_parloop_struct_339144->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315656 = {.desc ="mem_315656", .mem =
                                  futhark_mc_segmap_parloop_struct_339144->free_mem_315656,
                                  .size =0, .references =NULL};
    struct memblock mem_316719 = {.desc ="mem_316719", .mem =
                                  futhark_mc_segmap_parloop_struct_339144->free_mem_316719,
                                  .size =0, .references =NULL};
    struct memblock mem_316723 = {.desc ="mem_316723", .mem =
                                  futhark_mc_segmap_parloop_struct_339144->free_mem_316723,
                                  .size =0, .references =NULL};
    size_t mem_316628_cached_sizze_339146 = 0;
    unsigned char *mem_316628 = NULL;
    size_t mem_316631_cached_sizze_339147 = 0;
    unsigned char *mem_316631 = NULL;
    size_t mem_316634_cached_sizze_339148 = 0;
    unsigned char *mem_316634 = NULL;
    size_t mem_316637_cached_sizze_339149 = 0;
    unsigned char *mem_316637 = NULL;
    size_t mem_316640_cached_sizze_339150 = 0;
    unsigned char *mem_316640 = NULL;
    int64_t iterations = end - start;
    int64_t iter_336577 = start;
    
    if (mem_316628_cached_sizze_339146 < (size_t) bytes_312598) {
        mem_316628 = realloc(mem_316628, bytes_312598);
        mem_316628_cached_sizze_339146 = bytes_312598;
    }
    if (mem_316631_cached_sizze_339147 < (size_t) bytes_312598) {
        mem_316631 = realloc(mem_316631, bytes_312598);
        mem_316631_cached_sizze_339147 = bytes_312598;
    }
    if (mem_316634_cached_sizze_339148 < (size_t) bytes_312598) {
        mem_316634 = realloc(mem_316634, bytes_312598);
        mem_316634_cached_sizze_339148 = bytes_312598;
    }
    if (mem_316637_cached_sizze_339149 < (size_t) bytes_313090) {
        mem_316637 = realloc(mem_316637, bytes_313090);
        mem_316637_cached_sizze_339149 = bytes_313090;
    }
    if (mem_316640_cached_sizze_339150 < (size_t) bytes_313090) {
        mem_316640 = realloc(mem_316640, bytes_313090);
        mem_316640_cached_sizze_339150 = bytes_313090;
    }
    for (; iter_336577 < end; iter_336577++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_336841 = partition_sizze_292766;
        int64_t gtid_310135 = iter_336577;
        int64_t remnant_336842 = iter_336577 - gtid_310135;
        int64_t x_310140;
        
        x_310140 = ((int64_t *) mem_312639.mem)[gtid_310135];
        
        int64_t flat_tid_336578 = (int64_t) 0;
        int32_t num_tasks_336843;
        struct futhark_mc_task_339151 futhark_mc_task_339151;
        
        futhark_mc_task_339151.ctx = ctx;
        futhark_mc_task_339151.free_n_292675 = n_292675;
        futhark_mc_task_339151.free_gtid_310135 = gtid_310135;
        futhark_mc_task_339151.free_mem_312593 = mem_312593.mem;
        futhark_mc_task_339151.free_mem_315656 = mem_315656.mem;
        futhark_mc_task_339151.free_mem_316628 = mem_316628;
        
        struct scheduler_segop futhark_mc_task_339151_task;
        
        futhark_mc_task_339151_task.args = &futhark_mc_task_339151;
        futhark_mc_task_339151_task.top_level_fn =
            futhark_mc_segmap_task_339152;
        futhark_mc_task_339151_task.name = "futhark_mc_segmap_task_339152";
        futhark_mc_task_339151_task.iterations = n_292675;
        futhark_mc_task_339151_task.task_time =
            &ctx->futhark_mc_segmap_task_339152_total_time;
        futhark_mc_task_339151_task.task_iter =
            &ctx->futhark_mc_segmap_task_339152_total_iter;
        futhark_mc_task_339151_task.sched = STATIC;
        futhark_mc_task_339151_task.nested_fn = NULL;
        
        int futhark_mc_segmap_task_339152_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_339151_task);
        
        if (futhark_mc_segmap_task_339152_err != 0) {
            ;
            err = futhark_mc_segmap_task_339152_err;
            goto cleanup;
        }
        
        int64_t flat_tid_336584 = (int64_t) 0;
        int32_t num_tasks_336847;
        struct futhark_mc_task_339155 futhark_mc_task_339155;
        
        futhark_mc_task_339155.ctx = ctx;
        futhark_mc_task_339155.free_n_292675 = n_292675;
        futhark_mc_task_339155.free_gtid_310135 = gtid_310135;
        futhark_mc_task_339155.free_mem_312636 = mem_312636.mem;
        futhark_mc_task_339155.free_ctx_param_ext_313174 = ctx_param_ext_313174;
        futhark_mc_task_339155.free_ctx_param_ext_313175 = ctx_param_ext_313175;
        futhark_mc_task_339155.free_ctx_param_ext_313177 = ctx_param_ext_313177;
        futhark_mc_task_339155.free_mem_param_313179 = mem_param_313179.mem;
        futhark_mc_task_339155.free_mem_316628 = mem_316628;
        futhark_mc_task_339155.free_mem_316631 = mem_316631;
        futhark_mc_task_339155.free_mem_316634 = mem_316634;
        
        struct scheduler_segop futhark_mc_task_339155_task;
        
        futhark_mc_task_339155_task.args = &futhark_mc_task_339155;
        futhark_mc_task_339155_task.top_level_fn =
            futhark_mc_segmap_task_339156;
        futhark_mc_task_339155_task.name = "futhark_mc_segmap_task_339156";
        futhark_mc_task_339155_task.iterations = n_292675;
        futhark_mc_task_339155_task.task_time =
            &ctx->futhark_mc_segmap_task_339156_total_time;
        futhark_mc_task_339155_task.task_iter =
            &ctx->futhark_mc_segmap_task_339156_total_iter;
        futhark_mc_task_339155_task.sched = STATIC;
        futhark_mc_task_339155_task.nested_fn = NULL;
        
        int futhark_mc_segmap_task_339156_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_339155_task);
        
        if (futhark_mc_segmap_task_339156_err != 0) {
            ;
            err = futhark_mc_segmap_task_339156_err;
            goto cleanup;
        }
        
        int64_t flat_tid_336724 = (int64_t) 0;
        int32_t num_tasks_336859;
        int64_t flat_tid_336598 = (int64_t) 0;
        struct futhark_mc_task_339159 futhark_mc_task_339159;
        
        futhark_mc_task_339159.ctx = ctx;
        futhark_mc_task_339159.free_n_292675 = n_292675;
        futhark_mc_task_339159.free_q_t_292679 = q_t_292679;
        futhark_mc_task_339159.free_jump_t_292685 = jump_t_292685;
        futhark_mc_task_339159.free_t_n_m_292839 = t_n_m_292839;
        futhark_mc_task_339159.free_i_292846 = i_292846;
        futhark_mc_task_339159.free_gtid_310135 = gtid_310135;
        futhark_mc_task_339159.free_x_310140 = x_310140;
        futhark_mc_task_339159.free_mem_312636 = mem_312636.mem;
        futhark_mc_task_339159.free_mem_313143 = mem_313143.mem;
        futhark_mc_task_339159.free_mem_313147 = mem_313147.mem;
        futhark_mc_task_339159.free_mem_316631 = mem_316631;
        futhark_mc_task_339159.free_mem_316634 = mem_316634;
        futhark_mc_task_339159.free_mem_316637 = mem_316637;
        futhark_mc_task_339159.free_mem_316640 = mem_316640;
        
        struct scheduler_segop futhark_mc_task_339159_task;
        
        futhark_mc_task_339159_task.args = &futhark_mc_task_339159;
        futhark_mc_task_339159_task.top_level_fn =
            futhark_mc_segmap_task_339160;
        futhark_mc_task_339159_task.name = "futhark_mc_segmap_task_339160";
        futhark_mc_task_339159_task.iterations = t_n_m_292839;
        futhark_mc_task_339159_task.task_time =
            &ctx->futhark_mc_segmap_task_339160_total_time;
        futhark_mc_task_339159_task.task_iter =
            &ctx->futhark_mc_segmap_task_339160_total_iter;
        futhark_mc_task_339159_task.sched = STATIC;
        futhark_mc_task_339159_task.nested_fn =
            futhark_mc_segmap_nested_task_339163;
        
        int futhark_mc_segmap_task_339160_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_339159_task);
        
        if (futhark_mc_segmap_task_339160_err != 0) {
            ;
            err = futhark_mc_segmap_task_339160_err;
            goto cleanup;
        }
        if (t_n_m_292839 * (int64_t) 8 > 0)
            memmove(mem_316719.mem + gtid_310135 * t_n_m_292839 * (int64_t) 8,
                    mem_316637 + (int64_t) 0, t_n_m_292839 * (int64_t) 8);
        if (t_n_m_292839 * (int64_t) 8 > 0)
            memmove(mem_316723.mem + gtid_310135 * t_n_m_292839 * (int64_t) 8,
                    mem_316640 + (int64_t) 0, t_n_m_292839 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_316628);
    free(mem_316631);
    free(mem_316634);
    free(mem_316637);
    free(mem_316640);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339145_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339145_end -
                 futhark_mc_segmap_parloop_339145_start;
        
        ctx->futhark_mc_segmap_parloop_339145_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_339145_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_339145_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_nested_task_339143(void *args, int64_t iterations,
                                         int tid, struct scheduler_info info)
{
    int err = 0;
    int flat_tid_310134 = tid;
    int num_tasks_336417 = info.nsubtasks;
    struct futhark_mc_task_339134 *futhark_mc_task_339134 =
                                  (struct futhark_mc_task_339134 *) args;
    struct futhark_context *ctx = futhark_mc_task_339134->ctx;
    uint64_t futhark_mc_segmap_nested_task_339143_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_nested_task_339143_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_339134->free_n_292675;
    int64_t q_t_292679 = futhark_mc_task_339134->free_q_t_292679;
    int64_t jump_t_292685 = futhark_mc_task_339134->free_jump_t_292685;
    int64_t partition_sizze_292766 =
            futhark_mc_task_339134->free_partition_sizze_292766;
    int64_t t_n_m_292839 = futhark_mc_task_339134->free_t_n_m_292839;
    int64_t i_292846 = futhark_mc_task_339134->free_i_292846;
    struct memblock mem_312593 = {.desc ="mem_312593", .mem =
                                  futhark_mc_task_339134->free_mem_312593,
                                  .size =0, .references =NULL};
    int64_t bytes_312598 = futhark_mc_task_339134->free_bytes_312598;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_task_339134->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_312639 = {.desc ="mem_312639", .mem =
                                  futhark_mc_task_339134->free_mem_312639,
                                  .size =0, .references =NULL};
    int64_t bytes_313090 = futhark_mc_task_339134->free_bytes_313090;
    struct memblock mem_313143 = {.desc ="mem_313143", .mem =
                                  futhark_mc_task_339134->free_mem_313143,
                                  .size =0, .references =NULL};
    struct memblock mem_313147 = {.desc ="mem_313147", .mem =
                                  futhark_mc_task_339134->free_mem_313147,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_313174 =
            futhark_mc_task_339134->free_ctx_param_ext_313174;
    int64_t ctx_param_ext_313175 =
            futhark_mc_task_339134->free_ctx_param_ext_313175;
    int64_t ctx_param_ext_313177 =
            futhark_mc_task_339134->free_ctx_param_ext_313177;
    struct memblock mem_param_313179 = {.desc ="mem_param_313179", .mem =
                                        futhark_mc_task_339134->free_mem_param_313179,
                                        .size =0, .references =NULL};
    struct memblock mem_315656 = {.desc ="mem_315656", .mem =
                                  futhark_mc_task_339134->free_mem_315656,
                                  .size =0, .references =NULL};
    struct memblock mem_316719 = {.desc ="mem_316719", .mem =
                                  futhark_mc_task_339134->free_mem_316719,
                                  .size =0, .references =NULL};
    struct memblock mem_316723 = {.desc ="mem_316723", .mem =
                                  futhark_mc_task_339134->free_mem_316723,
                                  .size =0, .references =NULL};
    int64_t iter_336577;
    struct futhark_mc_segmap_parloop_struct_339144
    futhark_mc_segmap_parloop_struct_339144;
    
    futhark_mc_segmap_parloop_struct_339144.ctx = ctx;
    futhark_mc_segmap_parloop_struct_339144.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_339144.free_q_t_292679 = q_t_292679;
    futhark_mc_segmap_parloop_struct_339144.free_jump_t_292685 = jump_t_292685;
    futhark_mc_segmap_parloop_struct_339144.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_339144.free_t_n_m_292839 = t_n_m_292839;
    futhark_mc_segmap_parloop_struct_339144.free_i_292846 = i_292846;
    futhark_mc_segmap_parloop_struct_339144.free_mem_312593 = mem_312593.mem;
    futhark_mc_segmap_parloop_struct_339144.free_bytes_312598 = bytes_312598;
    futhark_mc_segmap_parloop_struct_339144.free_mem_312636 = mem_312636.mem;
    futhark_mc_segmap_parloop_struct_339144.free_mem_312639 = mem_312639.mem;
    futhark_mc_segmap_parloop_struct_339144.free_bytes_313090 = bytes_313090;
    futhark_mc_segmap_parloop_struct_339144.free_mem_313143 = mem_313143.mem;
    futhark_mc_segmap_parloop_struct_339144.free_mem_313147 = mem_313147.mem;
    futhark_mc_segmap_parloop_struct_339144.free_ctx_param_ext_313174 =
        ctx_param_ext_313174;
    futhark_mc_segmap_parloop_struct_339144.free_ctx_param_ext_313175 =
        ctx_param_ext_313175;
    futhark_mc_segmap_parloop_struct_339144.free_ctx_param_ext_313177 =
        ctx_param_ext_313177;
    futhark_mc_segmap_parloop_struct_339144.free_mem_param_313179 =
        mem_param_313179.mem;
    futhark_mc_segmap_parloop_struct_339144.free_mem_315656 = mem_315656.mem;
    futhark_mc_segmap_parloop_struct_339144.free_mem_316719 = mem_316719.mem;
    futhark_mc_segmap_parloop_struct_339144.free_mem_316723 = mem_316723.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_339145_task;
    
    futhark_mc_segmap_parloop_339145_task.name =
        "futhark_mc_segmap_parloop_339145";
    futhark_mc_segmap_parloop_339145_task.fn = futhark_mc_segmap_parloop_339145;
    futhark_mc_segmap_parloop_339145_task.args =
        &futhark_mc_segmap_parloop_struct_339144;
    futhark_mc_segmap_parloop_339145_task.iterations = iterations;
    futhark_mc_segmap_parloop_339145_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_339145_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339145_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_339145_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_339145_task);
    
    if (futhark_mc_segmap_parloop_339145_err != 0) {
        err = futhark_mc_segmap_parloop_339145_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339145_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339145_total_end -
                 futhark_mc_segmap_parloop_339145_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339145_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339145_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339145_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_nested_task_339143_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_nested_task_339143_end -
                 futhark_mc_segmap_nested_task_339143_start;
        
        ctx->futhark_mc_segmap_nested_task_339143_runs[tid]++;
        ctx->futhark_mc_segmap_nested_task_339143_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_nested_task_339143_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_task_339181 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_jump_t_292685;
    int64_t free_partition_sizze_292766;
    int64_t free_t_n_m_292839;
    int64_t free_i_292846;
    int64_t free_y_296962;
    int64_t free_bytes_312598;
    unsigned char *free_ext_mem_316730;
    unsigned char *free_ext_mem_316731;
    unsigned char *free_mem_316753;
};
struct futhark_mc_segmap_parloop_struct_339183 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_jump_t_292685;
    int64_t free_partition_sizze_292766;
    int64_t free_t_n_m_292839;
    int64_t free_i_292846;
    int64_t free_y_296962;
    int64_t free_bytes_312598;
    unsigned char *free_ext_mem_316730;
    unsigned char *free_ext_mem_316731;
    unsigned char *free_mem_316753;
};
static int futhark_mc_segmap_parloop_339184(void *args, int64_t start,
                                            int64_t end, int flat_tid_310422,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_339183
    *futhark_mc_segmap_parloop_struct_339183 =
    (struct futhark_mc_segmap_parloop_struct_339183 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_339183->ctx;
    uint64_t futhark_mc_segmap_parloop_339184_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339184_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_339183->free_n_292675;
    int64_t jump_t_292685 =
            futhark_mc_segmap_parloop_struct_339183->free_jump_t_292685;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_339183->free_partition_sizze_292766;
    int64_t t_n_m_292839 =
            futhark_mc_segmap_parloop_struct_339183->free_t_n_m_292839;
    int64_t i_292846 = futhark_mc_segmap_parloop_struct_339183->free_i_292846;
    int64_t y_296962 = futhark_mc_segmap_parloop_struct_339183->free_y_296962;
    int64_t bytes_312598 =
            futhark_mc_segmap_parloop_struct_339183->free_bytes_312598;
    struct memblock ext_mem_316730 = {.desc ="ext_mem_316730", .mem =
                                      futhark_mc_segmap_parloop_struct_339183->free_ext_mem_316730,
                                      .size =0, .references =NULL};
    struct memblock ext_mem_316731 = {.desc ="ext_mem_316731", .mem =
                                      futhark_mc_segmap_parloop_struct_339183->free_ext_mem_316731,
                                      .size =0, .references =NULL};
    struct memblock mem_316753 = {.desc ="mem_316753", .mem =
                                  futhark_mc_segmap_parloop_struct_339183->free_mem_316753,
                                  .size =0, .references =NULL};
    size_t mem_316737_cached_sizze_339185 = 0;
    unsigned char *mem_316737 = NULL;
    int64_t iterations = end - start;
    int64_t iter_337077 = start;
    
    if (mem_316737_cached_sizze_339185 < (size_t) bytes_312598) {
        mem_316737 = realloc(mem_316737, bytes_312598);
        mem_316737_cached_sizze_339185 = bytes_312598;
    }
    for (; iter_337077 < end; iter_337077++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_337127 = partition_sizze_292766;
        int64_t gtid_310423 = iter_337077;
        int64_t remnant_337128 = iter_337077 - gtid_310423;
        
        for (int64_t i_337078 = 0; i_337078 < n_292675; i_337078++) {
            int64_t m_v_337080 = sdiv64(i_337078, jump_t_292685);
            bool cond_337081 = m_v_337080 == y_296962;
            int64_t j_337082;
            
            if (cond_337081) {
                int64_t j_t_res_337083 = sub64(m_v_337080, (int64_t) 1);
                
                j_337082 = j_t_res_337083;
            } else {
                j_337082 = m_v_337080;
            }
            
            int64_t min_arg_337084 = mul64(jump_t_292685, j_337082);
            int64_t min_res_337085 = smin64(i_292846, min_arg_337084);
            int64_t defunc_0_m_fun_arg_337086 = add64((int64_t) 1, j_337082);
            int64_t min_arg_337087 = mul64(jump_t_292685,
                                           defunc_0_m_fun_arg_337086);
            int64_t min_res_337088 = smin64(i_292846, min_arg_337087);
            int64_t i64_arg_337089 = sub64(min_res_337088, min_res_337085);
            double i64_res_337090 = sitofp_i64_f64(i64_arg_337089);
            int64_t i64_arg_337091 = sub64(i_337078, min_res_337085);
            double i64_res_337092 = sitofp_i64_f64(i64_arg_337091);
            double u_337093 = i64_res_337092 / i64_res_337090;
            double u2_337094 = u_337093 * u_337093;
            double u3_337095 = u_337093 * u2_337094;
            double x_337096 = 2.0 * u3_337095;
            double y_337097 = 3.0 * u2_337094;
            double x_337098 = x_337096 - y_337097;
            double x_337099 = 1.0 + x_337098;
            bool x_337100 = sle64((int64_t) 0, j_337082);
            bool y_337101 = slt64(j_337082, t_n_m_292839);
            bool bounds_check_337102 = x_337100 && y_337101;
            bool index_certs_337103;
            
            if (!bounds_check_337102) {
                ctx->error =
                    msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                              "Index [", (long long) j_337082,
                              "] out of bounds for array of shape [",
                              (long long) t_n_m_292839, "].",
                              "-> #0  loess.fut:731:27-33\n   #1  loess.fut:744:13-50\n   #2  /prelude/soacs.fut:59:3-10\n   #3  /prelude/array.fut:195:3-17\n   #4  utils.fut:6:3-16\n   #5  loess.fut:741:3-745:9\n   #6  stl.fut:310:23-75\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:309:15-311:43\n   #10 stl.fut:419:61-435:77\n   #11 stl.fut:463:3-479:36\n   #12 stl.fut:445:1-479:36\n");
                err = FUTHARK_PROGRAM_ERROR;
                goto cleanup;
            }
            
            double y_337104;
            
            y_337104 = ((double *) ext_mem_316731.mem)[gtid_310423 *
                                                       t_n_m_292839 + j_337082];
            
            double x_337105 = x_337099 * y_337104;
            double x_337106 = y_337097 - x_337096;
            bool x_337107 = sle64((int64_t) 0, defunc_0_m_fun_arg_337086);
            bool y_337108 = slt64(defunc_0_m_fun_arg_337086, t_n_m_292839);
            bool bounds_check_337109 = x_337107 && y_337108;
            bool index_certs_337110;
            
            if (!bounds_check_337109) {
                ctx->error =
                    msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                              "Index [", (long long) defunc_0_m_fun_arg_337086,
                              "] out of bounds for array of shape [",
                              (long long) t_n_m_292839, "].",
                              "-> #0  loess.fut:732:27-37\n   #1  loess.fut:744:13-50\n   #2  /prelude/soacs.fut:59:3-10\n   #3  /prelude/array.fut:195:3-17\n   #4  utils.fut:6:3-16\n   #5  loess.fut:741:3-745:9\n   #6  stl.fut:310:23-75\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:309:15-311:43\n   #10 stl.fut:419:61-435:77\n   #11 stl.fut:463:3-479:36\n   #12 stl.fut:445:1-479:36\n");
                err = FUTHARK_PROGRAM_ERROR;
                goto cleanup;
            }
            
            double y_337111;
            
            y_337111 = ((double *) ext_mem_316731.mem)[gtid_310423 *
                                                       t_n_m_292839 +
                                                       defunc_0_m_fun_arg_337086];
            
            double y_337112 = x_337106 * y_337111;
            double x_337113 = x_337105 + y_337112;
            double y_337114 = 2.0 * u2_337094;
            double x_337115 = u3_337095 - y_337114;
            double x_337116 = u_337093 + x_337115;
            double y_337117;
            
            y_337117 = ((double *) ext_mem_316730.mem)[gtid_310423 *
                                                       t_n_m_292839 + j_337082];
            
            double x_337118 = x_337116 * y_337117;
            double y_337119 = i64_res_337090 * x_337118;
            double x_337120 = x_337113 + y_337119;
            double x_337121 = u3_337095 - u2_337094;
            double y_337122;
            
            y_337122 = ((double *) ext_mem_316730.mem)[gtid_310423 *
                                                       t_n_m_292839 +
                                                       defunc_0_m_fun_arg_337086];
            
            double x_337123 = x_337121 * y_337122;
            double y_337124 = i64_res_337090 * x_337123;
            double defunc_4_interpolate_proc_res_337125 = x_337120 + y_337124;
            
            ((double *) mem_316737)[i_337078] =
                defunc_4_interpolate_proc_res_337125;
        }
        if (n_292675 * (int64_t) 8 > 0)
            memmove(mem_316753.mem + gtid_310423 * n_292675 * (int64_t) 8,
                    mem_316737 + (int64_t) 0, n_292675 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_316737);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339184_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339184_end -
                 futhark_mc_segmap_parloop_339184_start;
        
        ctx->futhark_mc_segmap_parloop_339184_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_339184_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_339184_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_339182(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_310422 = tid;
    int num_tasks_337076 = info.nsubtasks;
    struct futhark_mc_task_339181 *futhark_mc_task_339181 =
                                  (struct futhark_mc_task_339181 *) args;
    struct futhark_context *ctx = futhark_mc_task_339181->ctx;
    uint64_t futhark_mc_segmap_task_339182_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_339182_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_339181->free_n_292675;
    int64_t jump_t_292685 = futhark_mc_task_339181->free_jump_t_292685;
    int64_t partition_sizze_292766 =
            futhark_mc_task_339181->free_partition_sizze_292766;
    int64_t t_n_m_292839 = futhark_mc_task_339181->free_t_n_m_292839;
    int64_t i_292846 = futhark_mc_task_339181->free_i_292846;
    int64_t y_296962 = futhark_mc_task_339181->free_y_296962;
    int64_t bytes_312598 = futhark_mc_task_339181->free_bytes_312598;
    struct memblock ext_mem_316730 = {.desc ="ext_mem_316730", .mem =
                                      futhark_mc_task_339181->free_ext_mem_316730,
                                      .size =0, .references =NULL};
    struct memblock ext_mem_316731 = {.desc ="ext_mem_316731", .mem =
                                      futhark_mc_task_339181->free_ext_mem_316731,
                                      .size =0, .references =NULL};
    struct memblock mem_316753 = {.desc ="mem_316753", .mem =
                                  futhark_mc_task_339181->free_mem_316753,
                                  .size =0, .references =NULL};
    int64_t iter_337077;
    struct futhark_mc_segmap_parloop_struct_339183
    futhark_mc_segmap_parloop_struct_339183;
    
    futhark_mc_segmap_parloop_struct_339183.ctx = ctx;
    futhark_mc_segmap_parloop_struct_339183.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_339183.free_jump_t_292685 = jump_t_292685;
    futhark_mc_segmap_parloop_struct_339183.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_339183.free_t_n_m_292839 = t_n_m_292839;
    futhark_mc_segmap_parloop_struct_339183.free_i_292846 = i_292846;
    futhark_mc_segmap_parloop_struct_339183.free_y_296962 = y_296962;
    futhark_mc_segmap_parloop_struct_339183.free_bytes_312598 = bytes_312598;
    futhark_mc_segmap_parloop_struct_339183.free_ext_mem_316730 =
        ext_mem_316730.mem;
    futhark_mc_segmap_parloop_struct_339183.free_ext_mem_316731 =
        ext_mem_316731.mem;
    futhark_mc_segmap_parloop_struct_339183.free_mem_316753 = mem_316753.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_339184_task;
    
    futhark_mc_segmap_parloop_339184_task.name =
        "futhark_mc_segmap_parloop_339184";
    futhark_mc_segmap_parloop_339184_task.fn = futhark_mc_segmap_parloop_339184;
    futhark_mc_segmap_parloop_339184_task.args =
        &futhark_mc_segmap_parloop_struct_339183;
    futhark_mc_segmap_parloop_339184_task.iterations = iterations;
    futhark_mc_segmap_parloop_339184_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_339184_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339184_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_339184_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_339184_task);
    
    if (futhark_mc_segmap_parloop_339184_err != 0) {
        err = futhark_mc_segmap_parloop_339184_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339184_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339184_total_end -
                 futhark_mc_segmap_parloop_339184_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339184_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339184_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339184_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_339182_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_339182_end -
                 futhark_mc_segmap_task_339182_start;
        
        ctx->futhark_mc_segmap_task_339182_runs[tid]++;
        ctx->futhark_mc_segmap_task_339182_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_339182_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_segmap_parloop_struct_339187 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_jump_t_292685;
    int64_t free_partition_sizze_292766;
    int64_t free_t_n_m_292839;
    int64_t free_i_292846;
    int64_t free_y_296962;
    int64_t free_bytes_312598;
    unsigned char *free_ext_mem_316730;
    unsigned char *free_ext_mem_316731;
    unsigned char *free_mem_316753;
};
struct futhark_mc_task_339190 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_jump_t_292685;
    int64_t free_t_n_m_292839;
    int64_t free_i_292846;
    int64_t free_y_296962;
    int64_t free_gtid_310429;
    unsigned char *free_ext_mem_316730;
    unsigned char *free_ext_mem_316731;
    unsigned char *free_mem_316734;
};
struct futhark_mc_segmap_parloop_struct_339192 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_jump_t_292685;
    int64_t free_t_n_m_292839;
    int64_t free_i_292846;
    int64_t free_y_296962;
    int64_t free_gtid_310429;
    unsigned char *free_ext_mem_316730;
    unsigned char *free_ext_mem_316731;
    unsigned char *free_mem_316734;
};
static int futhark_mc_segmap_parloop_339193(void *args, int64_t start,
                                            int64_t end, int flat_tid_337131,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_339192
    *futhark_mc_segmap_parloop_struct_339192 =
    (struct futhark_mc_segmap_parloop_struct_339192 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_339192->ctx;
    uint64_t futhark_mc_segmap_parloop_339193_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339193_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_339192->free_n_292675;
    int64_t jump_t_292685 =
            futhark_mc_segmap_parloop_struct_339192->free_jump_t_292685;
    int64_t t_n_m_292839 =
            futhark_mc_segmap_parloop_struct_339192->free_t_n_m_292839;
    int64_t i_292846 = futhark_mc_segmap_parloop_struct_339192->free_i_292846;
    int64_t y_296962 = futhark_mc_segmap_parloop_struct_339192->free_y_296962;
    int64_t gtid_310429 =
            futhark_mc_segmap_parloop_struct_339192->free_gtid_310429;
    struct memblock ext_mem_316730 = {.desc ="ext_mem_316730", .mem =
                                      futhark_mc_segmap_parloop_struct_339192->free_ext_mem_316730,
                                      .size =0, .references =NULL};
    struct memblock ext_mem_316731 = {.desc ="ext_mem_316731", .mem =
                                      futhark_mc_segmap_parloop_struct_339192->free_ext_mem_316731,
                                      .size =0, .references =NULL};
    struct memblock mem_316734 = {.desc ="mem_316734", .mem =
                                  futhark_mc_segmap_parloop_struct_339192->free_mem_316734,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_337182 = start;
    
    for (; iter_337182 < end; iter_337182++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_337184 = n_292675;
        int64_t gtid_337132 = iter_337182;
        int64_t remnant_337185 = iter_337182 - gtid_337132;
        int64_t m_v_337133 = sdiv64(gtid_337132, jump_t_292685);
        bool cond_337134 = m_v_337133 == y_296962;
        int64_t j_337135;
        
        if (cond_337134) {
            int64_t j_t_res_337183 = sub64(m_v_337133, (int64_t) 1);
            
            j_337135 = j_t_res_337183;
        } else {
            j_337135 = m_v_337133;
        }
        
        int64_t min_arg_337137 = mul64(jump_t_292685, j_337135);
        int64_t min_res_337138 = smin64(i_292846, min_arg_337137);
        int64_t defunc_0_m_fun_arg_337139 = add64((int64_t) 1, j_337135);
        int64_t min_arg_337140 = mul64(jump_t_292685,
                                       defunc_0_m_fun_arg_337139);
        int64_t min_res_337141 = smin64(i_292846, min_arg_337140);
        int64_t i64_arg_337142 = sub64(min_res_337141, min_res_337138);
        double i64_res_337143 = sitofp_i64_f64(i64_arg_337142);
        int64_t i64_arg_337144 = sub64(gtid_337132, min_res_337138);
        double i64_res_337145 = sitofp_i64_f64(i64_arg_337144);
        double u_337146 = i64_res_337145 / i64_res_337143;
        double u2_337147 = u_337146 * u_337146;
        double u3_337148 = u_337146 * u2_337147;
        double x_337149 = 2.0 * u3_337148;
        double y_337150 = 3.0 * u2_337147;
        double x_337151 = x_337149 - y_337150;
        double x_337152 = 1.0 + x_337151;
        bool x_337153 = sle64((int64_t) 0, j_337135);
        bool y_337154 = slt64(j_337135, t_n_m_292839);
        bool bounds_check_337155 = x_337153 && y_337154;
        bool index_certs_337156;
        
        if (!bounds_check_337155) {
            ctx->error = msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                   "Index [", (long long) j_337135,
                                   "] out of bounds for array of shape [",
                                   (long long) t_n_m_292839, "].",
                                   "-> #0  loess.fut:731:27-33\n   #1  loess.fut:744:13-50\n   #2  /prelude/soacs.fut:59:3-10\n   #3  /prelude/array.fut:195:3-17\n   #4  utils.fut:6:3-16\n   #5  loess.fut:741:3-745:9\n   #6  stl.fut:310:23-75\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:309:15-311:43\n   #10 stl.fut:419:61-435:77\n   #11 stl.fut:463:3-479:36\n   #12 stl.fut:445:1-479:36\n");
            err = FUTHARK_PROGRAM_ERROR;
            goto cleanup;
        }
        
        double y_337157;
        
        y_337157 = ((double *) ext_mem_316731.mem)[gtid_310429 * t_n_m_292839 +
                                                   j_337135];
        
        double x_337158 = x_337152 * y_337157;
        double x_337159 = y_337150 - x_337149;
        bool x_337160 = sle64((int64_t) 0, defunc_0_m_fun_arg_337139);
        bool y_337161 = slt64(defunc_0_m_fun_arg_337139, t_n_m_292839);
        bool bounds_check_337162 = x_337160 && y_337161;
        bool index_certs_337163;
        
        if (!bounds_check_337162) {
            ctx->error = msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                   "Index [",
                                   (long long) defunc_0_m_fun_arg_337139,
                                   "] out of bounds for array of shape [",
                                   (long long) t_n_m_292839, "].",
                                   "-> #0  loess.fut:732:27-37\n   #1  loess.fut:744:13-50\n   #2  /prelude/soacs.fut:59:3-10\n   #3  /prelude/array.fut:195:3-17\n   #4  utils.fut:6:3-16\n   #5  loess.fut:741:3-745:9\n   #6  stl.fut:310:23-75\n   #7  /prelude/soacs.fut:67:19-23\n   #8  /prelude/soacs.fut:67:3-37\n   #9  stl.fut:309:15-311:43\n   #10 stl.fut:419:61-435:77\n   #11 stl.fut:463:3-479:36\n   #12 stl.fut:445:1-479:36\n");
            err = FUTHARK_PROGRAM_ERROR;
            goto cleanup;
        }
        
        double y_337164;
        
        y_337164 = ((double *) ext_mem_316731.mem)[gtid_310429 * t_n_m_292839 +
                                                   defunc_0_m_fun_arg_337139];
        
        double y_337165 = x_337159 * y_337164;
        double x_337166 = x_337158 + y_337165;
        double y_337167 = 2.0 * u2_337147;
        double x_337168 = u3_337148 - y_337167;
        double x_337169 = u_337146 + x_337168;
        double y_337170;
        
        y_337170 = ((double *) ext_mem_316730.mem)[gtid_310429 * t_n_m_292839 +
                                                   j_337135];
        
        double x_337171 = x_337169 * y_337170;
        double y_337172 = i64_res_337143 * x_337171;
        double x_337173 = x_337166 + y_337172;
        double x_337174 = u3_337148 - u2_337147;
        double y_337175;
        
        y_337175 = ((double *) ext_mem_316730.mem)[gtid_310429 * t_n_m_292839 +
                                                   defunc_0_m_fun_arg_337139];
        
        double x_337176 = x_337174 * y_337175;
        double y_337177 = i64_res_337143 * x_337176;
        double defunc_4_interpolate_proc_res_337178 = x_337173 + y_337177;
        
        ((double *) mem_316734.mem)[gtid_337132] =
            defunc_4_interpolate_proc_res_337178;
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339193_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339193_end -
                 futhark_mc_segmap_parloop_339193_start;
        
        ctx->futhark_mc_segmap_parloop_339193_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_339193_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_339193_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_339191(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_337131 = tid;
    int num_tasks_337181 = info.nsubtasks;
    struct futhark_mc_task_339190 *futhark_mc_task_339190 =
                                  (struct futhark_mc_task_339190 *) args;
    struct futhark_context *ctx = futhark_mc_task_339190->ctx;
    uint64_t futhark_mc_segmap_task_339191_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_339191_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_339190->free_n_292675;
    int64_t jump_t_292685 = futhark_mc_task_339190->free_jump_t_292685;
    int64_t t_n_m_292839 = futhark_mc_task_339190->free_t_n_m_292839;
    int64_t i_292846 = futhark_mc_task_339190->free_i_292846;
    int64_t y_296962 = futhark_mc_task_339190->free_y_296962;
    int64_t gtid_310429 = futhark_mc_task_339190->free_gtid_310429;
    struct memblock ext_mem_316730 = {.desc ="ext_mem_316730", .mem =
                                      futhark_mc_task_339190->free_ext_mem_316730,
                                      .size =0, .references =NULL};
    struct memblock ext_mem_316731 = {.desc ="ext_mem_316731", .mem =
                                      futhark_mc_task_339190->free_ext_mem_316731,
                                      .size =0, .references =NULL};
    struct memblock mem_316734 = {.desc ="mem_316734", .mem =
                                  futhark_mc_task_339190->free_mem_316734,
                                  .size =0, .references =NULL};
    int64_t iter_337182;
    struct futhark_mc_segmap_parloop_struct_339192
    futhark_mc_segmap_parloop_struct_339192;
    
    futhark_mc_segmap_parloop_struct_339192.ctx = ctx;
    futhark_mc_segmap_parloop_struct_339192.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_339192.free_jump_t_292685 = jump_t_292685;
    futhark_mc_segmap_parloop_struct_339192.free_t_n_m_292839 = t_n_m_292839;
    futhark_mc_segmap_parloop_struct_339192.free_i_292846 = i_292846;
    futhark_mc_segmap_parloop_struct_339192.free_y_296962 = y_296962;
    futhark_mc_segmap_parloop_struct_339192.free_gtid_310429 = gtid_310429;
    futhark_mc_segmap_parloop_struct_339192.free_ext_mem_316730 =
        ext_mem_316730.mem;
    futhark_mc_segmap_parloop_struct_339192.free_ext_mem_316731 =
        ext_mem_316731.mem;
    futhark_mc_segmap_parloop_struct_339192.free_mem_316734 = mem_316734.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_339193_task;
    
    futhark_mc_segmap_parloop_339193_task.name =
        "futhark_mc_segmap_parloop_339193";
    futhark_mc_segmap_parloop_339193_task.fn = futhark_mc_segmap_parloop_339193;
    futhark_mc_segmap_parloop_339193_task.args =
        &futhark_mc_segmap_parloop_struct_339192;
    futhark_mc_segmap_parloop_339193_task.iterations = iterations;
    futhark_mc_segmap_parloop_339193_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_339193_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339193_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_339193_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_339193_task);
    
    if (futhark_mc_segmap_parloop_339193_err != 0) {
        err = futhark_mc_segmap_parloop_339193_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339193_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339193_total_end -
                 futhark_mc_segmap_parloop_339193_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339193_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339193_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339193_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_339191_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_339191_end -
                 futhark_mc_segmap_task_339191_start;
        
        ctx->futhark_mc_segmap_task_339191_runs[tid]++;
        ctx->futhark_mc_segmap_task_339191_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_339191_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
static int futhark_mc_segmap_parloop_339188(void *args, int64_t start,
                                            int64_t end, int flat_tid_310428,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_339187
    *futhark_mc_segmap_parloop_struct_339187 =
    (struct futhark_mc_segmap_parloop_struct_339187 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_339187->ctx;
    uint64_t futhark_mc_segmap_parloop_339188_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339188_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_339187->free_n_292675;
    int64_t jump_t_292685 =
            futhark_mc_segmap_parloop_struct_339187->free_jump_t_292685;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_339187->free_partition_sizze_292766;
    int64_t t_n_m_292839 =
            futhark_mc_segmap_parloop_struct_339187->free_t_n_m_292839;
    int64_t i_292846 = futhark_mc_segmap_parloop_struct_339187->free_i_292846;
    int64_t y_296962 = futhark_mc_segmap_parloop_struct_339187->free_y_296962;
    int64_t bytes_312598 =
            futhark_mc_segmap_parloop_struct_339187->free_bytes_312598;
    struct memblock ext_mem_316730 = {.desc ="ext_mem_316730", .mem =
                                      futhark_mc_segmap_parloop_struct_339187->free_ext_mem_316730,
                                      .size =0, .references =NULL};
    struct memblock ext_mem_316731 = {.desc ="ext_mem_316731", .mem =
                                      futhark_mc_segmap_parloop_struct_339187->free_ext_mem_316731,
                                      .size =0, .references =NULL};
    struct memblock mem_316753 = {.desc ="mem_316753", .mem =
                                  futhark_mc_segmap_parloop_struct_339187->free_mem_316753,
                                  .size =0, .references =NULL};
    size_t mem_316734_cached_sizze_339189 = 0;
    unsigned char *mem_316734 = NULL;
    int64_t iterations = end - start;
    int64_t iter_337130 = start;
    
    if (mem_316734_cached_sizze_339189 < (size_t) bytes_312598) {
        mem_316734 = realloc(mem_316734, bytes_312598);
        mem_316734_cached_sizze_339189 = bytes_312598;
    }
    for (; iter_337130 < end; iter_337130++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_337179 = partition_sizze_292766;
        int64_t gtid_310429 = iter_337130;
        int64_t remnant_337180 = iter_337130 - gtid_310429;
        int64_t flat_tid_337131 = (int64_t) 0;
        int32_t num_tasks_337181;
        struct futhark_mc_task_339190 futhark_mc_task_339190;
        
        futhark_mc_task_339190.ctx = ctx;
        futhark_mc_task_339190.free_n_292675 = n_292675;
        futhark_mc_task_339190.free_jump_t_292685 = jump_t_292685;
        futhark_mc_task_339190.free_t_n_m_292839 = t_n_m_292839;
        futhark_mc_task_339190.free_i_292846 = i_292846;
        futhark_mc_task_339190.free_y_296962 = y_296962;
        futhark_mc_task_339190.free_gtid_310429 = gtid_310429;
        futhark_mc_task_339190.free_ext_mem_316730 = ext_mem_316730.mem;
        futhark_mc_task_339190.free_ext_mem_316731 = ext_mem_316731.mem;
        futhark_mc_task_339190.free_mem_316734 = mem_316734;
        
        struct scheduler_segop futhark_mc_task_339190_task;
        
        futhark_mc_task_339190_task.args = &futhark_mc_task_339190;
        futhark_mc_task_339190_task.top_level_fn =
            futhark_mc_segmap_task_339191;
        futhark_mc_task_339190_task.name = "futhark_mc_segmap_task_339191";
        futhark_mc_task_339190_task.iterations = n_292675;
        futhark_mc_task_339190_task.task_time =
            &ctx->futhark_mc_segmap_task_339191_total_time;
        futhark_mc_task_339190_task.task_iter =
            &ctx->futhark_mc_segmap_task_339191_total_iter;
        futhark_mc_task_339190_task.sched = STATIC;
        futhark_mc_task_339190_task.nested_fn = NULL;
        
        int futhark_mc_segmap_task_339191_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_339190_task);
        
        if (futhark_mc_segmap_task_339191_err != 0) {
            ;
            err = futhark_mc_segmap_task_339191_err;
            goto cleanup;
        }
        if (n_292675 * (int64_t) 8 > 0)
            memmove(mem_316753.mem + gtid_310429 * n_292675 * (int64_t) 8,
                    mem_316734 + (int64_t) 0, n_292675 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_316734);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339188_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339188_end -
                 futhark_mc_segmap_parloop_339188_start;
        
        ctx->futhark_mc_segmap_parloop_339188_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_339188_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_339188_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_nested_task_339186(void *args, int64_t iterations,
                                         int tid, struct scheduler_info info)
{
    int err = 0;
    int flat_tid_310428 = tid;
    int num_tasks_337076 = info.nsubtasks;
    struct futhark_mc_task_339181 *futhark_mc_task_339181 =
                                  (struct futhark_mc_task_339181 *) args;
    struct futhark_context *ctx = futhark_mc_task_339181->ctx;
    uint64_t futhark_mc_segmap_nested_task_339186_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_nested_task_339186_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_339181->free_n_292675;
    int64_t jump_t_292685 = futhark_mc_task_339181->free_jump_t_292685;
    int64_t partition_sizze_292766 =
            futhark_mc_task_339181->free_partition_sizze_292766;
    int64_t t_n_m_292839 = futhark_mc_task_339181->free_t_n_m_292839;
    int64_t i_292846 = futhark_mc_task_339181->free_i_292846;
    int64_t y_296962 = futhark_mc_task_339181->free_y_296962;
    int64_t bytes_312598 = futhark_mc_task_339181->free_bytes_312598;
    struct memblock ext_mem_316730 = {.desc ="ext_mem_316730", .mem =
                                      futhark_mc_task_339181->free_ext_mem_316730,
                                      .size =0, .references =NULL};
    struct memblock ext_mem_316731 = {.desc ="ext_mem_316731", .mem =
                                      futhark_mc_task_339181->free_ext_mem_316731,
                                      .size =0, .references =NULL};
    struct memblock mem_316753 = {.desc ="mem_316753", .mem =
                                  futhark_mc_task_339181->free_mem_316753,
                                  .size =0, .references =NULL};
    int64_t iter_337130;
    struct futhark_mc_segmap_parloop_struct_339187
    futhark_mc_segmap_parloop_struct_339187;
    
    futhark_mc_segmap_parloop_struct_339187.ctx = ctx;
    futhark_mc_segmap_parloop_struct_339187.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_339187.free_jump_t_292685 = jump_t_292685;
    futhark_mc_segmap_parloop_struct_339187.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_339187.free_t_n_m_292839 = t_n_m_292839;
    futhark_mc_segmap_parloop_struct_339187.free_i_292846 = i_292846;
    futhark_mc_segmap_parloop_struct_339187.free_y_296962 = y_296962;
    futhark_mc_segmap_parloop_struct_339187.free_bytes_312598 = bytes_312598;
    futhark_mc_segmap_parloop_struct_339187.free_ext_mem_316730 =
        ext_mem_316730.mem;
    futhark_mc_segmap_parloop_struct_339187.free_ext_mem_316731 =
        ext_mem_316731.mem;
    futhark_mc_segmap_parloop_struct_339187.free_mem_316753 = mem_316753.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_339188_task;
    
    futhark_mc_segmap_parloop_339188_task.name =
        "futhark_mc_segmap_parloop_339188";
    futhark_mc_segmap_parloop_339188_task.fn = futhark_mc_segmap_parloop_339188;
    futhark_mc_segmap_parloop_339188_task.args =
        &futhark_mc_segmap_parloop_struct_339187;
    futhark_mc_segmap_parloop_339188_task.iterations = iterations;
    futhark_mc_segmap_parloop_339188_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_339188_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339188_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_339188_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_339188_task);
    
    if (futhark_mc_segmap_parloop_339188_err != 0) {
        err = futhark_mc_segmap_parloop_339188_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339188_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339188_total_end -
                 futhark_mc_segmap_parloop_339188_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339188_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339188_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339188_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_nested_task_339186_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_nested_task_339186_end -
                 futhark_mc_segmap_nested_task_339186_start;
        
        ctx->futhark_mc_segmap_nested_task_339186_runs[tid]++;
        ctx->futhark_mc_segmap_nested_task_339186_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_nested_task_339186_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_task_339194 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_partition_sizze_292766;
    unsigned char *free_mem_312593;
    int64_t free_bytes_312598;
    unsigned char *free_mem_312636;
    unsigned char *free_ext_mem_316760;
    unsigned char *free_ext_mem_316761;
    int64_t free_ext_316765;
    unsigned char *free_mem_316815;
    unsigned char *free_mem_316819;
};
struct futhark_mc_segmap_parloop_struct_339196 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_partition_sizze_292766;
    unsigned char *free_mem_312593;
    int64_t free_bytes_312598;
    unsigned char *free_mem_312636;
    unsigned char *free_ext_mem_316760;
    unsigned char *free_ext_mem_316761;
    int64_t free_ext_316765;
    unsigned char *free_mem_316815;
    unsigned char *free_mem_316819;
};
static int futhark_mc_segmap_parloop_339197(void *args, int64_t start,
                                            int64_t end, int flat_tid_310482,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_339196
    *futhark_mc_segmap_parloop_struct_339196 =
    (struct futhark_mc_segmap_parloop_struct_339196 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_339196->ctx;
    uint64_t futhark_mc_segmap_parloop_339197_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339197_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_339196->free_n_292675;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_339196->free_partition_sizze_292766;
    struct memblock mem_312593 = {.desc ="mem_312593", .mem =
                                  futhark_mc_segmap_parloop_struct_339196->free_mem_312593,
                                  .size =0, .references =NULL};
    int64_t bytes_312598 =
            futhark_mc_segmap_parloop_struct_339196->free_bytes_312598;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_segmap_parloop_struct_339196->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock ext_mem_316760 = {.desc ="ext_mem_316760", .mem =
                                      futhark_mc_segmap_parloop_struct_339196->free_ext_mem_316760,
                                      .size =0, .references =NULL};
    struct memblock ext_mem_316761 = {.desc ="ext_mem_316761", .mem =
                                      futhark_mc_segmap_parloop_struct_339196->free_ext_mem_316761,
                                      .size =0, .references =NULL};
    int64_t ext_316765 =
            futhark_mc_segmap_parloop_struct_339196->free_ext_316765;
    struct memblock mem_316815 = {.desc ="mem_316815", .mem =
                                  futhark_mc_segmap_parloop_struct_339196->free_mem_316815,
                                  .size =0, .references =NULL};
    struct memblock mem_316819 = {.desc ="mem_316819", .mem =
                                  futhark_mc_segmap_parloop_struct_339196->free_mem_316819,
                                  .size =0, .references =NULL};
    size_t mem_316784_cached_sizze_339198 = 0;
    unsigned char *mem_316784 = NULL;
    size_t mem_316799_cached_sizze_339199 = 0;
    unsigned char *mem_316799 = NULL;
    int64_t iterations = end - start;
    int64_t iter_337187 = start;
    
    if (mem_316784_cached_sizze_339198 < (size_t) bytes_312598) {
        mem_316784 = realloc(mem_316784, bytes_312598);
        mem_316784_cached_sizze_339198 = bytes_312598;
    }
    if (mem_316799_cached_sizze_339199 < (size_t) bytes_312598) {
        mem_316799 = realloc(mem_316799, bytes_312598);
        mem_316799_cached_sizze_339199 = bytes_312598;
    }
    for (; iter_337187 < end; iter_337187++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_337210 = partition_sizze_292766;
        int64_t gtid_310483 = iter_337187;
        int64_t remnant_337211 = iter_337187 - gtid_310483;
        
        for (int64_t i_337188 = 0; i_337188 < n_292675; i_337188++) {
            float x_337190;
            
            x_337190 = ((float *) mem_312593.mem)[gtid_310483 * n_292675 +
                                                  i_337188];
            
            double x_337191;
            
            x_337191 = ((double *) ext_mem_316761.mem)[gtid_310483 * n_292675 +
                                                       i_337188];
            
            double x_337192;
            
            x_337192 = ((double *) ext_mem_316760.mem)[gtid_310483 *
                                                       ext_316765 + i_337188];
            
            double f32_res_337193 = fpconv_f32_f64(x_337190);
            double x_337194 = f32_res_337193 - x_337191;
            double defunc_2_f_res_337195 = x_337194 - x_337192;
            bool isnan_res_337196;
            
            isnan_res_337196 = futrts_isnan64(defunc_2_f_res_337195);
            
            double defunc_0_f_res_337197;
            
            if (isnan_res_337196) {
                defunc_0_f_res_337197 = defunc_2_f_res_337195;
            } else {
                double abs_res_337198 = fabs(defunc_2_f_res_337195);
                
                defunc_0_f_res_337197 = abs_res_337198;
            }
            ((double *) mem_316784)[i_337188] = defunc_0_f_res_337197;
        }
        for (int64_t i_337200 = 0; i_337200 < n_292675; i_337200++) {
            int64_t x_337202;
            
            x_337202 = ((int64_t *) mem_312636.mem)[gtid_310483 * n_292675 +
                                                    i_337200];
            
            bool cond_337203 = sle64((int64_t) 0, x_337202);
            double defunc_0_f_res_337204;
            
            if (cond_337203) {
                bool y_337205 = slt64(x_337202, n_292675);
                bool bounds_check_337206 = cond_337203 && y_337205;
                bool index_certs_337207;
                
                if (!bounds_check_337206) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [", (long long) x_337202,
                                  "] out of bounds for array of shape [",
                                  (long long) n_292675, "].",
                                  "-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:340:21-49\n   #3  /prelude/soacs.fut:67:19-23\n   #4  /prelude/soacs.fut:67:3-37\n   #5  stl.fut:338:13-341:35\n   #6  stl.fut:419:61-435:77\n   #7  stl.fut:463:3-479:36\n   #8  stl.fut:445:1-479:36\n");
                    err = FUTHARK_PROGRAM_ERROR;
                    goto cleanup;
                }
                
                double defunc_0_f_res_t_res_337208;
                
                defunc_0_f_res_t_res_337208 = ((double *) mem_316784)[x_337202];
                defunc_0_f_res_337204 = defunc_0_f_res_t_res_337208;
            } else {
                defunc_0_f_res_337204 = INFINITY;
            }
            ((double *) mem_316799)[i_337200] = defunc_0_f_res_337204;
        }
        if (n_292675 * (int64_t) 8 > 0)
            memmove(mem_316815.mem + gtid_310483 * n_292675 * (int64_t) 8,
                    mem_316799 + (int64_t) 0, n_292675 * (int64_t) 8);
        if (n_292675 * (int64_t) 8 > 0)
            memmove(mem_316819.mem + gtid_310483 * n_292675 * (int64_t) 8,
                    mem_316784 + (int64_t) 0, n_292675 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_316784);
    free(mem_316799);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339197_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339197_end -
                 futhark_mc_segmap_parloop_339197_start;
        
        ctx->futhark_mc_segmap_parloop_339197_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_339197_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_339197_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_339195(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_310482 = tid;
    int num_tasks_337186 = info.nsubtasks;
    struct futhark_mc_task_339194 *futhark_mc_task_339194 =
                                  (struct futhark_mc_task_339194 *) args;
    struct futhark_context *ctx = futhark_mc_task_339194->ctx;
    uint64_t futhark_mc_segmap_task_339195_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_339195_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_339194->free_n_292675;
    int64_t partition_sizze_292766 =
            futhark_mc_task_339194->free_partition_sizze_292766;
    struct memblock mem_312593 = {.desc ="mem_312593", .mem =
                                  futhark_mc_task_339194->free_mem_312593,
                                  .size =0, .references =NULL};
    int64_t bytes_312598 = futhark_mc_task_339194->free_bytes_312598;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_task_339194->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock ext_mem_316760 = {.desc ="ext_mem_316760", .mem =
                                      futhark_mc_task_339194->free_ext_mem_316760,
                                      .size =0, .references =NULL};
    struct memblock ext_mem_316761 = {.desc ="ext_mem_316761", .mem =
                                      futhark_mc_task_339194->free_ext_mem_316761,
                                      .size =0, .references =NULL};
    int64_t ext_316765 = futhark_mc_task_339194->free_ext_316765;
    struct memblock mem_316815 = {.desc ="mem_316815", .mem =
                                  futhark_mc_task_339194->free_mem_316815,
                                  .size =0, .references =NULL};
    struct memblock mem_316819 = {.desc ="mem_316819", .mem =
                                  futhark_mc_task_339194->free_mem_316819,
                                  .size =0, .references =NULL};
    int64_t iter_337187;
    struct futhark_mc_segmap_parloop_struct_339196
    futhark_mc_segmap_parloop_struct_339196;
    
    futhark_mc_segmap_parloop_struct_339196.ctx = ctx;
    futhark_mc_segmap_parloop_struct_339196.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_339196.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_339196.free_mem_312593 = mem_312593.mem;
    futhark_mc_segmap_parloop_struct_339196.free_bytes_312598 = bytes_312598;
    futhark_mc_segmap_parloop_struct_339196.free_mem_312636 = mem_312636.mem;
    futhark_mc_segmap_parloop_struct_339196.free_ext_mem_316760 =
        ext_mem_316760.mem;
    futhark_mc_segmap_parloop_struct_339196.free_ext_mem_316761 =
        ext_mem_316761.mem;
    futhark_mc_segmap_parloop_struct_339196.free_ext_316765 = ext_316765;
    futhark_mc_segmap_parloop_struct_339196.free_mem_316815 = mem_316815.mem;
    futhark_mc_segmap_parloop_struct_339196.free_mem_316819 = mem_316819.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_339197_task;
    
    futhark_mc_segmap_parloop_339197_task.name =
        "futhark_mc_segmap_parloop_339197";
    futhark_mc_segmap_parloop_339197_task.fn = futhark_mc_segmap_parloop_339197;
    futhark_mc_segmap_parloop_339197_task.args =
        &futhark_mc_segmap_parloop_struct_339196;
    futhark_mc_segmap_parloop_339197_task.iterations = iterations;
    futhark_mc_segmap_parloop_339197_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_339197_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339197_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_339197_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_339197_task);
    
    if (futhark_mc_segmap_parloop_339197_err != 0) {
        err = futhark_mc_segmap_parloop_339197_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339197_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339197_total_end -
                 futhark_mc_segmap_parloop_339197_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339197_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339197_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339197_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_339195_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_339195_end -
                 futhark_mc_segmap_task_339195_start;
        
        ctx->futhark_mc_segmap_task_339195_runs[tid]++;
        ctx->futhark_mc_segmap_task_339195_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_339195_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_segmap_parloop_struct_339201 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_partition_sizze_292766;
    unsigned char *free_mem_312593;
    int64_t free_bytes_312598;
    unsigned char *free_mem_312636;
    unsigned char *free_ext_mem_316760;
    unsigned char *free_ext_mem_316761;
    int64_t free_ext_316765;
    unsigned char *free_mem_316815;
    unsigned char *free_mem_316819;
};
struct futhark_mc_task_339205 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_310491;
    unsigned char *free_mem_312593;
    unsigned char *free_ext_mem_316760;
    unsigned char *free_ext_mem_316761;
    int64_t free_ext_316765;
    unsigned char *free_mem_316778;
};
struct futhark_mc_segmap_parloop_struct_339207 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_310491;
    unsigned char *free_mem_312593;
    unsigned char *free_ext_mem_316760;
    unsigned char *free_ext_mem_316761;
    int64_t free_ext_316765;
    unsigned char *free_mem_316778;
};
static int futhark_mc_segmap_parloop_339208(void *args, int64_t start,
                                            int64_t end, int flat_tid_337215,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_339207
    *futhark_mc_segmap_parloop_struct_339207 =
    (struct futhark_mc_segmap_parloop_struct_339207 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_339207->ctx;
    uint64_t futhark_mc_segmap_parloop_339208_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339208_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_339207->free_n_292675;
    int64_t gtid_310491 =
            futhark_mc_segmap_parloop_struct_339207->free_gtid_310491;
    struct memblock mem_312593 = {.desc ="mem_312593", .mem =
                                  futhark_mc_segmap_parloop_struct_339207->free_mem_312593,
                                  .size =0, .references =NULL};
    struct memblock ext_mem_316760 = {.desc ="ext_mem_316760", .mem =
                                      futhark_mc_segmap_parloop_struct_339207->free_ext_mem_316760,
                                      .size =0, .references =NULL};
    struct memblock ext_mem_316761 = {.desc ="ext_mem_316761", .mem =
                                      futhark_mc_segmap_parloop_struct_339207->free_ext_mem_316761,
                                      .size =0, .references =NULL};
    int64_t ext_316765 =
            futhark_mc_segmap_parloop_struct_339207->free_ext_316765;
    struct memblock mem_316778 = {.desc ="mem_316778", .mem =
                                  futhark_mc_segmap_parloop_struct_339207->free_mem_316778,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_337238 = start;
    
    for (; iter_337238 < end; iter_337238++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_337240 = n_292675;
        int64_t gtid_337216 = iter_337238;
        int64_t remnant_337241 = iter_337238 - gtid_337216;
        float x_337217;
        
        x_337217 = ((float *) mem_312593.mem)[gtid_310491 * n_292675 +
                                              gtid_337216];
        
        double x_337218;
        
        x_337218 = ((double *) ext_mem_316761.mem)[gtid_310491 * n_292675 +
                                                   gtid_337216];
        
        double x_337219;
        
        x_337219 = ((double *) ext_mem_316760.mem)[gtid_310491 * ext_316765 +
                                                   gtid_337216];
        
        double f32_res_337220 = fpconv_f32_f64(x_337217);
        double x_337221 = f32_res_337220 - x_337218;
        double defunc_2_f_res_337222 = x_337221 - x_337219;
        bool isnan_res_337223;
        
        isnan_res_337223 = futrts_isnan64(defunc_2_f_res_337222);
        
        double defunc_0_f_res_337224;
        
        if (isnan_res_337223) {
            defunc_0_f_res_337224 = defunc_2_f_res_337222;
        } else {
            double abs_res_337239 = fabs(defunc_2_f_res_337222);
            
            defunc_0_f_res_337224 = abs_res_337239;
        }
        ((double *) mem_316778.mem)[gtid_337216] = defunc_0_f_res_337224;
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339208_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339208_end -
                 futhark_mc_segmap_parloop_339208_start;
        
        ctx->futhark_mc_segmap_parloop_339208_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_339208_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_339208_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_339206(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_337215 = tid;
    int num_tasks_337237 = info.nsubtasks;
    struct futhark_mc_task_339205 *futhark_mc_task_339205 =
                                  (struct futhark_mc_task_339205 *) args;
    struct futhark_context *ctx = futhark_mc_task_339205->ctx;
    uint64_t futhark_mc_segmap_task_339206_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_339206_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_339205->free_n_292675;
    int64_t gtid_310491 = futhark_mc_task_339205->free_gtid_310491;
    struct memblock mem_312593 = {.desc ="mem_312593", .mem =
                                  futhark_mc_task_339205->free_mem_312593,
                                  .size =0, .references =NULL};
    struct memblock ext_mem_316760 = {.desc ="ext_mem_316760", .mem =
                                      futhark_mc_task_339205->free_ext_mem_316760,
                                      .size =0, .references =NULL};
    struct memblock ext_mem_316761 = {.desc ="ext_mem_316761", .mem =
                                      futhark_mc_task_339205->free_ext_mem_316761,
                                      .size =0, .references =NULL};
    int64_t ext_316765 = futhark_mc_task_339205->free_ext_316765;
    struct memblock mem_316778 = {.desc ="mem_316778", .mem =
                                  futhark_mc_task_339205->free_mem_316778,
                                  .size =0, .references =NULL};
    int64_t iter_337238;
    struct futhark_mc_segmap_parloop_struct_339207
    futhark_mc_segmap_parloop_struct_339207;
    
    futhark_mc_segmap_parloop_struct_339207.ctx = ctx;
    futhark_mc_segmap_parloop_struct_339207.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_339207.free_gtid_310491 = gtid_310491;
    futhark_mc_segmap_parloop_struct_339207.free_mem_312593 = mem_312593.mem;
    futhark_mc_segmap_parloop_struct_339207.free_ext_mem_316760 =
        ext_mem_316760.mem;
    futhark_mc_segmap_parloop_struct_339207.free_ext_mem_316761 =
        ext_mem_316761.mem;
    futhark_mc_segmap_parloop_struct_339207.free_ext_316765 = ext_316765;
    futhark_mc_segmap_parloop_struct_339207.free_mem_316778 = mem_316778.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_339208_task;
    
    futhark_mc_segmap_parloop_339208_task.name =
        "futhark_mc_segmap_parloop_339208";
    futhark_mc_segmap_parloop_339208_task.fn = futhark_mc_segmap_parloop_339208;
    futhark_mc_segmap_parloop_339208_task.args =
        &futhark_mc_segmap_parloop_struct_339207;
    futhark_mc_segmap_parloop_339208_task.iterations = iterations;
    futhark_mc_segmap_parloop_339208_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_339208_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339208_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_339208_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_339208_task);
    
    if (futhark_mc_segmap_parloop_339208_err != 0) {
        err = futhark_mc_segmap_parloop_339208_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339208_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339208_total_end -
                 futhark_mc_segmap_parloop_339208_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339208_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339208_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339208_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_339206_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_339206_end -
                 futhark_mc_segmap_task_339206_start;
        
        ctx->futhark_mc_segmap_task_339206_runs[tid]++;
        ctx->futhark_mc_segmap_task_339206_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_339206_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_task_339209 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_310491;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_316778;
    unsigned char *free_mem_316781;
};
struct futhark_mc_segmap_parloop_struct_339211 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_310491;
    unsigned char *free_mem_312636;
    unsigned char *free_mem_316778;
    unsigned char *free_mem_316781;
};
static int futhark_mc_segmap_parloop_339212(void *args, int64_t start,
                                            int64_t end, int flat_tid_337226,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_339211
    *futhark_mc_segmap_parloop_struct_339211 =
    (struct futhark_mc_segmap_parloop_struct_339211 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_339211->ctx;
    uint64_t futhark_mc_segmap_parloop_339212_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339212_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_339211->free_n_292675;
    int64_t gtid_310491 =
            futhark_mc_segmap_parloop_struct_339211->free_gtid_310491;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_segmap_parloop_struct_339211->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_316778 = {.desc ="mem_316778", .mem =
                                  futhark_mc_segmap_parloop_struct_339211->free_mem_316778,
                                  .size =0, .references =NULL};
    struct memblock mem_316781 = {.desc ="mem_316781", .mem =
                                  futhark_mc_segmap_parloop_struct_339211->free_mem_316781,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_337243 = start;
    
    for (; iter_337243 < end; iter_337243++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_337248 = n_292675;
        int64_t gtid_337227 = iter_337243;
        int64_t remnant_337249 = iter_337243 - gtid_337227;
        int64_t x_337228;
        
        x_337228 = ((int64_t *) mem_312636.mem)[gtid_310491 * n_292675 +
                                                gtid_337227];
        
        bool cond_337229 = sle64((int64_t) 0, x_337228);
        double defunc_0_f_res_337230;
        
        if (cond_337229) {
            bool y_337244 = slt64(x_337228, n_292675);
            bool bounds_check_337245 = cond_337229 && y_337244;
            bool index_certs_337246;
            
            if (!bounds_check_337245) {
                ctx->error =
                    msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                              "Index [", (long long) x_337228,
                              "] out of bounds for array of shape [",
                              (long long) n_292675, "].",
                              "-> #0  utils.fut:32:29-33\n   #1  utils.fut:32:3-49\n   #2  stl.fut:340:21-49\n   #3  /prelude/soacs.fut:67:19-23\n   #4  /prelude/soacs.fut:67:3-37\n   #5  stl.fut:338:13-341:35\n   #6  stl.fut:419:61-435:77\n   #7  stl.fut:463:3-479:36\n   #8  stl.fut:445:1-479:36\n");
                err = FUTHARK_PROGRAM_ERROR;
                goto cleanup;
            }
            
            double defunc_0_f_res_t_res_337247;
            
            defunc_0_f_res_t_res_337247 = ((double *) mem_316778.mem)[x_337228];
            defunc_0_f_res_337230 = defunc_0_f_res_t_res_337247;
        } else {
            defunc_0_f_res_337230 = INFINITY;
        }
        ((double *) mem_316781.mem)[gtid_337227] = defunc_0_f_res_337230;
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339212_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339212_end -
                 futhark_mc_segmap_parloop_339212_start;
        
        ctx->futhark_mc_segmap_parloop_339212_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_339212_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_339212_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_339210(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_337226 = tid;
    int num_tasks_337242 = info.nsubtasks;
    struct futhark_mc_task_339209 *futhark_mc_task_339209 =
                                  (struct futhark_mc_task_339209 *) args;
    struct futhark_context *ctx = futhark_mc_task_339209->ctx;
    uint64_t futhark_mc_segmap_task_339210_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_339210_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_339209->free_n_292675;
    int64_t gtid_310491 = futhark_mc_task_339209->free_gtid_310491;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_task_339209->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock mem_316778 = {.desc ="mem_316778", .mem =
                                  futhark_mc_task_339209->free_mem_316778,
                                  .size =0, .references =NULL};
    struct memblock mem_316781 = {.desc ="mem_316781", .mem =
                                  futhark_mc_task_339209->free_mem_316781,
                                  .size =0, .references =NULL};
    int64_t iter_337243;
    struct futhark_mc_segmap_parloop_struct_339211
    futhark_mc_segmap_parloop_struct_339211;
    
    futhark_mc_segmap_parloop_struct_339211.ctx = ctx;
    futhark_mc_segmap_parloop_struct_339211.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_339211.free_gtid_310491 = gtid_310491;
    futhark_mc_segmap_parloop_struct_339211.free_mem_312636 = mem_312636.mem;
    futhark_mc_segmap_parloop_struct_339211.free_mem_316778 = mem_316778.mem;
    futhark_mc_segmap_parloop_struct_339211.free_mem_316781 = mem_316781.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_339212_task;
    
    futhark_mc_segmap_parloop_339212_task.name =
        "futhark_mc_segmap_parloop_339212";
    futhark_mc_segmap_parloop_339212_task.fn = futhark_mc_segmap_parloop_339212;
    futhark_mc_segmap_parloop_339212_task.args =
        &futhark_mc_segmap_parloop_struct_339211;
    futhark_mc_segmap_parloop_339212_task.iterations = iterations;
    futhark_mc_segmap_parloop_339212_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_339212_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339212_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_339212_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_339212_task);
    
    if (futhark_mc_segmap_parloop_339212_err != 0) {
        err = futhark_mc_segmap_parloop_339212_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339212_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339212_total_end -
                 futhark_mc_segmap_parloop_339212_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339212_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339212_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339212_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_339210_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_339210_end -
                 futhark_mc_segmap_task_339210_start;
        
        ctx->futhark_mc_segmap_task_339210_runs[tid]++;
        ctx->futhark_mc_segmap_task_339210_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_339210_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
static int futhark_mc_segmap_parloop_339202(void *args, int64_t start,
                                            int64_t end, int flat_tid_310490,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_339201
    *futhark_mc_segmap_parloop_struct_339201 =
    (struct futhark_mc_segmap_parloop_struct_339201 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_339201->ctx;
    uint64_t futhark_mc_segmap_parloop_339202_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339202_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_339201->free_n_292675;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_339201->free_partition_sizze_292766;
    struct memblock mem_312593 = {.desc ="mem_312593", .mem =
                                  futhark_mc_segmap_parloop_struct_339201->free_mem_312593,
                                  .size =0, .references =NULL};
    int64_t bytes_312598 =
            futhark_mc_segmap_parloop_struct_339201->free_bytes_312598;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_segmap_parloop_struct_339201->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock ext_mem_316760 = {.desc ="ext_mem_316760", .mem =
                                      futhark_mc_segmap_parloop_struct_339201->free_ext_mem_316760,
                                      .size =0, .references =NULL};
    struct memblock ext_mem_316761 = {.desc ="ext_mem_316761", .mem =
                                      futhark_mc_segmap_parloop_struct_339201->free_ext_mem_316761,
                                      .size =0, .references =NULL};
    int64_t ext_316765 =
            futhark_mc_segmap_parloop_struct_339201->free_ext_316765;
    struct memblock mem_316815 = {.desc ="mem_316815", .mem =
                                  futhark_mc_segmap_parloop_struct_339201->free_mem_316815,
                                  .size =0, .references =NULL};
    struct memblock mem_316819 = {.desc ="mem_316819", .mem =
                                  futhark_mc_segmap_parloop_struct_339201->free_mem_316819,
                                  .size =0, .references =NULL};
    size_t mem_316778_cached_sizze_339203 = 0;
    unsigned char *mem_316778 = NULL;
    size_t mem_316781_cached_sizze_339204 = 0;
    unsigned char *mem_316781 = NULL;
    int64_t iterations = end - start;
    int64_t iter_337214 = start;
    
    if (mem_316778_cached_sizze_339203 < (size_t) bytes_312598) {
        mem_316778 = realloc(mem_316778, bytes_312598);
        mem_316778_cached_sizze_339203 = bytes_312598;
    }
    if (mem_316781_cached_sizze_339204 < (size_t) bytes_312598) {
        mem_316781 = realloc(mem_316781, bytes_312598);
        mem_316781_cached_sizze_339204 = bytes_312598;
    }
    for (; iter_337214 < end; iter_337214++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_337235 = partition_sizze_292766;
        int64_t gtid_310491 = iter_337214;
        int64_t remnant_337236 = iter_337214 - gtid_310491;
        int64_t flat_tid_337215 = (int64_t) 0;
        int32_t num_tasks_337237;
        struct futhark_mc_task_339205 futhark_mc_task_339205;
        
        futhark_mc_task_339205.ctx = ctx;
        futhark_mc_task_339205.free_n_292675 = n_292675;
        futhark_mc_task_339205.free_gtid_310491 = gtid_310491;
        futhark_mc_task_339205.free_mem_312593 = mem_312593.mem;
        futhark_mc_task_339205.free_ext_mem_316760 = ext_mem_316760.mem;
        futhark_mc_task_339205.free_ext_mem_316761 = ext_mem_316761.mem;
        futhark_mc_task_339205.free_ext_316765 = ext_316765;
        futhark_mc_task_339205.free_mem_316778 = mem_316778;
        
        struct scheduler_segop futhark_mc_task_339205_task;
        
        futhark_mc_task_339205_task.args = &futhark_mc_task_339205;
        futhark_mc_task_339205_task.top_level_fn =
            futhark_mc_segmap_task_339206;
        futhark_mc_task_339205_task.name = "futhark_mc_segmap_task_339206";
        futhark_mc_task_339205_task.iterations = n_292675;
        futhark_mc_task_339205_task.task_time =
            &ctx->futhark_mc_segmap_task_339206_total_time;
        futhark_mc_task_339205_task.task_iter =
            &ctx->futhark_mc_segmap_task_339206_total_iter;
        futhark_mc_task_339205_task.sched = STATIC;
        futhark_mc_task_339205_task.nested_fn = NULL;
        
        int futhark_mc_segmap_task_339206_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_339205_task);
        
        if (futhark_mc_segmap_task_339206_err != 0) {
            ;
            err = futhark_mc_segmap_task_339206_err;
            goto cleanup;
        }
        
        int64_t flat_tid_337226 = (int64_t) 0;
        int32_t num_tasks_337242;
        struct futhark_mc_task_339209 futhark_mc_task_339209;
        
        futhark_mc_task_339209.ctx = ctx;
        futhark_mc_task_339209.free_n_292675 = n_292675;
        futhark_mc_task_339209.free_gtid_310491 = gtid_310491;
        futhark_mc_task_339209.free_mem_312636 = mem_312636.mem;
        futhark_mc_task_339209.free_mem_316778 = mem_316778;
        futhark_mc_task_339209.free_mem_316781 = mem_316781;
        
        struct scheduler_segop futhark_mc_task_339209_task;
        
        futhark_mc_task_339209_task.args = &futhark_mc_task_339209;
        futhark_mc_task_339209_task.top_level_fn =
            futhark_mc_segmap_task_339210;
        futhark_mc_task_339209_task.name = "futhark_mc_segmap_task_339210";
        futhark_mc_task_339209_task.iterations = n_292675;
        futhark_mc_task_339209_task.task_time =
            &ctx->futhark_mc_segmap_task_339210_total_time;
        futhark_mc_task_339209_task.task_iter =
            &ctx->futhark_mc_segmap_task_339210_total_iter;
        futhark_mc_task_339209_task.sched = STATIC;
        futhark_mc_task_339209_task.nested_fn = NULL;
        
        int futhark_mc_segmap_task_339210_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_339209_task);
        
        if (futhark_mc_segmap_task_339210_err != 0) {
            ;
            err = futhark_mc_segmap_task_339210_err;
            goto cleanup;
        }
        if (n_292675 * (int64_t) 8 > 0)
            memmove(mem_316815.mem + gtid_310491 * n_292675 * (int64_t) 8,
                    mem_316781 + (int64_t) 0, n_292675 * (int64_t) 8);
        if (n_292675 * (int64_t) 8 > 0)
            memmove(mem_316819.mem + gtid_310491 * n_292675 * (int64_t) 8,
                    mem_316778 + (int64_t) 0, n_292675 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_316778);
    free(mem_316781);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339202_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339202_end -
                 futhark_mc_segmap_parloop_339202_start;
        
        ctx->futhark_mc_segmap_parloop_339202_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_339202_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_339202_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_nested_task_339200(void *args, int64_t iterations,
                                         int tid, struct scheduler_info info)
{
    int err = 0;
    int flat_tid_310490 = tid;
    int num_tasks_337186 = info.nsubtasks;
    struct futhark_mc_task_339194 *futhark_mc_task_339194 =
                                  (struct futhark_mc_task_339194 *) args;
    struct futhark_context *ctx = futhark_mc_task_339194->ctx;
    uint64_t futhark_mc_segmap_nested_task_339200_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_nested_task_339200_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_339194->free_n_292675;
    int64_t partition_sizze_292766 =
            futhark_mc_task_339194->free_partition_sizze_292766;
    struct memblock mem_312593 = {.desc ="mem_312593", .mem =
                                  futhark_mc_task_339194->free_mem_312593,
                                  .size =0, .references =NULL};
    int64_t bytes_312598 = futhark_mc_task_339194->free_bytes_312598;
    struct memblock mem_312636 = {.desc ="mem_312636", .mem =
                                  futhark_mc_task_339194->free_mem_312636,
                                  .size =0, .references =NULL};
    struct memblock ext_mem_316760 = {.desc ="ext_mem_316760", .mem =
                                      futhark_mc_task_339194->free_ext_mem_316760,
                                      .size =0, .references =NULL};
    struct memblock ext_mem_316761 = {.desc ="ext_mem_316761", .mem =
                                      futhark_mc_task_339194->free_ext_mem_316761,
                                      .size =0, .references =NULL};
    int64_t ext_316765 = futhark_mc_task_339194->free_ext_316765;
    struct memblock mem_316815 = {.desc ="mem_316815", .mem =
                                  futhark_mc_task_339194->free_mem_316815,
                                  .size =0, .references =NULL};
    struct memblock mem_316819 = {.desc ="mem_316819", .mem =
                                  futhark_mc_task_339194->free_mem_316819,
                                  .size =0, .references =NULL};
    int64_t iter_337214;
    struct futhark_mc_segmap_parloop_struct_339201
    futhark_mc_segmap_parloop_struct_339201;
    
    futhark_mc_segmap_parloop_struct_339201.ctx = ctx;
    futhark_mc_segmap_parloop_struct_339201.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_339201.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_339201.free_mem_312593 = mem_312593.mem;
    futhark_mc_segmap_parloop_struct_339201.free_bytes_312598 = bytes_312598;
    futhark_mc_segmap_parloop_struct_339201.free_mem_312636 = mem_312636.mem;
    futhark_mc_segmap_parloop_struct_339201.free_ext_mem_316760 =
        ext_mem_316760.mem;
    futhark_mc_segmap_parloop_struct_339201.free_ext_mem_316761 =
        ext_mem_316761.mem;
    futhark_mc_segmap_parloop_struct_339201.free_ext_316765 = ext_316765;
    futhark_mc_segmap_parloop_struct_339201.free_mem_316815 = mem_316815.mem;
    futhark_mc_segmap_parloop_struct_339201.free_mem_316819 = mem_316819.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_339202_task;
    
    futhark_mc_segmap_parloop_339202_task.name =
        "futhark_mc_segmap_parloop_339202";
    futhark_mc_segmap_parloop_339202_task.fn = futhark_mc_segmap_parloop_339202;
    futhark_mc_segmap_parloop_339202_task.args =
        &futhark_mc_segmap_parloop_struct_339201;
    futhark_mc_segmap_parloop_339202_task.iterations = iterations;
    futhark_mc_segmap_parloop_339202_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_339202_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339202_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_339202_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_339202_task);
    
    if (futhark_mc_segmap_parloop_339202_err != 0) {
        err = futhark_mc_segmap_parloop_339202_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339202_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339202_total_end -
                 futhark_mc_segmap_parloop_339202_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339202_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339202_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339202_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_nested_task_339200_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_nested_task_339200_end -
                 futhark_mc_segmap_nested_task_339200_start;
        
        ctx->futhark_mc_segmap_nested_task_339200_runs[tid]++;
        ctx->futhark_mc_segmap_nested_task_339200_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_nested_task_339200_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_task_339213 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_partition_sizze_292766;
    unsigned char *free_mem_316815;
    unsigned char *free_mem_316822;
};
struct futhark_mc_segmap_parloop_struct_339215 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_partition_sizze_292766;
    unsigned char *free_mem_316815;
    unsigned char *free_mem_316822;
};
static int futhark_mc_segmap_parloop_339216(void *args, int64_t start,
                                            int64_t end, int flat_tid_310518,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_339215
    *futhark_mc_segmap_parloop_struct_339215 =
    (struct futhark_mc_segmap_parloop_struct_339215 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_339215->ctx;
    uint64_t futhark_mc_segmap_parloop_339216_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339216_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_339215->free_n_292675;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_339215->free_partition_sizze_292766;
    struct memblock mem_316815 = {.desc ="mem_316815", .mem =
                                  futhark_mc_segmap_parloop_struct_339215->free_mem_316815,
                                  .size =0, .references =NULL};
    struct memblock mem_316822 = {.desc ="mem_316822", .mem =
                                  futhark_mc_segmap_parloop_struct_339215->free_mem_316822,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_337251 = start;
    
    for (; iter_337251 < end; iter_337251++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_337258 = partition_sizze_292766;
        int64_t gtid_310519 = iter_337251;
        int64_t remnant_337259 = iter_337251 - gtid_310519;
        double defunc_0_f_res_297047;
        double defunc_0_f_res_297048;
        double redout_337253;
        double redout_337254;
        
        redout_337253 = INFINITY;
        redout_337254 = -INFINITY;
        for (int64_t i_337252 = 0; i_337252 < n_292675; i_337252++) {
            double x_337255;
            
            x_337255 = ((double *) mem_316815.mem)[gtid_310519 * n_292675 +
                                                   i_337252];
            
            double defunc_1_op_res_337256 = fmin64(x_337255, redout_337253);
            double defunc_1_op_res_337257 = fmax64(x_337255, redout_337254);
            double redout_tmp_337260 = defunc_1_op_res_337256;
            double redout_tmp_337261 = defunc_1_op_res_337257;
            
            redout_337253 = redout_tmp_337260;
            redout_337254 = redout_tmp_337261;
        }
        defunc_0_f_res_297047 = redout_337253;
        defunc_0_f_res_297048 = redout_337254;
        
        double defunc_1_f_res_297056 = defunc_0_f_res_297047 +
               defunc_0_f_res_297048;
        double defunc_0_f_res_297057 = defunc_1_f_res_297056 / 2.0;
        
        ((double *) mem_316822.mem)[gtid_310519] = defunc_0_f_res_297057;
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339216_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339216_end -
                 futhark_mc_segmap_parloop_339216_start;
        
        ctx->futhark_mc_segmap_parloop_339216_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_339216_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_339216_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_339214(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_310518 = tid;
    int num_tasks_337250 = info.nsubtasks;
    struct futhark_mc_task_339213 *futhark_mc_task_339213 =
                                  (struct futhark_mc_task_339213 *) args;
    struct futhark_context *ctx = futhark_mc_task_339213->ctx;
    uint64_t futhark_mc_segmap_task_339214_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_339214_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_339213->free_n_292675;
    int64_t partition_sizze_292766 =
            futhark_mc_task_339213->free_partition_sizze_292766;
    struct memblock mem_316815 = {.desc ="mem_316815", .mem =
                                  futhark_mc_task_339213->free_mem_316815,
                                  .size =0, .references =NULL};
    struct memblock mem_316822 = {.desc ="mem_316822", .mem =
                                  futhark_mc_task_339213->free_mem_316822,
                                  .size =0, .references =NULL};
    int64_t iter_337251;
    struct futhark_mc_segmap_parloop_struct_339215
    futhark_mc_segmap_parloop_struct_339215;
    
    futhark_mc_segmap_parloop_struct_339215.ctx = ctx;
    futhark_mc_segmap_parloop_struct_339215.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_339215.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_339215.free_mem_316815 = mem_316815.mem;
    futhark_mc_segmap_parloop_struct_339215.free_mem_316822 = mem_316822.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_339216_task;
    
    futhark_mc_segmap_parloop_339216_task.name =
        "futhark_mc_segmap_parloop_339216";
    futhark_mc_segmap_parloop_339216_task.fn = futhark_mc_segmap_parloop_339216;
    futhark_mc_segmap_parloop_339216_task.args =
        &futhark_mc_segmap_parloop_struct_339215;
    futhark_mc_segmap_parloop_339216_task.iterations = iterations;
    futhark_mc_segmap_parloop_339216_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_339216_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339216_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_339216_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_339216_task);
    
    if (futhark_mc_segmap_parloop_339216_err != 0) {
        err = futhark_mc_segmap_parloop_339216_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339216_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339216_total_end -
                 futhark_mc_segmap_parloop_339216_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339216_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339216_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339216_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_339214_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_339214_end -
                 futhark_mc_segmap_task_339214_start;
        
        ctx->futhark_mc_segmap_task_339214_runs[tid]++;
        ctx->futhark_mc_segmap_task_339214_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_339214_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_segmap_parloop_struct_339218 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_partition_sizze_292766;
    unsigned char *free_mem_316815;
    unsigned char *free_mem_316822;
};
struct futhark_mc_task_339220 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_310525;
    unsigned char *free_mem_316815;
    double *retval_defunc_0_f_res_310527;
    double *retval_defunc_0_f_res_310528;
};
struct futhark_mc_segred_stage_1_parloop_struct_339224 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_310525;
    unsigned char *free_mem_316815;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_337275;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_337277;
};
static int futhark_mc_segred_stage_1_parloop_339225(void *args, int64_t start,
                                                    int64_t end,
                                                    int flat_tid_337263,
                                                    int tid)
{
    int err = 0;
    struct futhark_mc_segred_stage_1_parloop_struct_339224
    *futhark_mc_segred_stage_1_parloop_struct_339224 =
    (struct futhark_mc_segred_stage_1_parloop_struct_339224 *) args;
    struct futhark_context *ctx =
                           futhark_mc_segred_stage_1_parloop_struct_339224->ctx;
    uint64_t futhark_mc_segred_stage_1_parloop_339225_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_339225_start = get_wall_time();
    
    int64_t n_292675 =
            futhark_mc_segred_stage_1_parloop_struct_339224->free_n_292675;
    int64_t gtid_310525 =
            futhark_mc_segred_stage_1_parloop_struct_339224->free_gtid_310525;
    struct memblock mem_316815 = {.desc ="mem_316815", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_339224->free_mem_316815,
                                  .size =0, .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_337275 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_337275",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_339224->free_reduce_stage_1_tid_res_arr_mem_337275,
                                                             .size =0,
                                                             .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_337277 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_337277",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_339224->free_reduce_stage_1_tid_res_arr_mem_337277,
                                                             .size =0,
                                                             .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_337279 = start;
    double x_337265;
    double x_337266;
    double x_337268;
    double x_337269;
    double local_acc_337280 = INFINITY;
    double local_acc_337281 = -INFINITY;
    
    for (; iter_337279 < end; iter_337279++) {
        int64_t gtid_337264 = iter_337279;
        double x_337271;
        
        x_337271 = ((double *) mem_316815.mem)[gtid_310525 * n_292675 +
                                               gtid_337264];
        // save map-out results
        { }
        // Load accum params
        {
            x_337265 = local_acc_337280;
        }
        // Load next params
        {
            x_337266 = x_337271;
        }
        // Red body
        {
            double defunc_1_op_res_337267 = fmin64(x_337265, x_337266);
            
            local_acc_337280 = defunc_1_op_res_337267;
        }
        // Load accum params
        {
            x_337268 = local_acc_337281;
        }
        // Load next params
        {
            x_337269 = x_337271;
        }
        // Red body
        {
            double defunc_1_op_res_337270 = fmax64(x_337268, x_337269);
            
            local_acc_337281 = defunc_1_op_res_337270;
        }
    }
    ((double *) reduce_stage_1_tid_res_arr_mem_337275.mem)[flat_tid_337263] =
        local_acc_337280;
    ((double *) reduce_stage_1_tid_res_arr_mem_337277.mem)[flat_tid_337263] =
        local_acc_337281;
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_339225_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_339225_end -
                 futhark_mc_segred_stage_1_parloop_339225_start;
        
        ctx->futhark_mc_segred_stage_1_parloop_339225_runs[tid]++;
        ctx->futhark_mc_segred_stage_1_parloop_339225_total_runtime[tid] +=
            elapsed;
        ctx->futhark_mc_segred_stage_1_parloop_339225_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segred_task_339221(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_337263 = tid;
    int num_tasks_337274 = info.nsubtasks;
    struct futhark_mc_task_339220 *futhark_mc_task_339220 =
                                  (struct futhark_mc_task_339220 *) args;
    struct futhark_context *ctx = futhark_mc_task_339220->ctx;
    uint64_t futhark_mc_segred_task_339221_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_task_339221_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_339220->free_n_292675;
    int64_t gtid_310525 = futhark_mc_task_339220->free_gtid_310525;
    struct memblock mem_316815 = {.desc ="mem_316815", .mem =
                                  futhark_mc_task_339220->free_mem_316815,
                                  .size =0, .references =NULL};
    double defunc_0_f_res_310527 =
           *futhark_mc_task_339220->retval_defunc_0_f_res_310527;
    double defunc_0_f_res_310528 =
           *futhark_mc_task_339220->retval_defunc_0_f_res_310528;
    size_t reduce_stage_1_tid_res_arr_mem_337275_cached_sizze_339222 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_337275 = NULL;
    size_t reduce_stage_1_tid_res_arr_mem_337277_cached_sizze_339223 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_337277 = NULL;
    
    if (reduce_stage_1_tid_res_arr_mem_337275_cached_sizze_339222 <
        (size_t) ((int64_t) 8 * num_tasks_337274)) {
        reduce_stage_1_tid_res_arr_mem_337275 =
            realloc(reduce_stage_1_tid_res_arr_mem_337275, (int64_t) 8 *
                    num_tasks_337274);
        reduce_stage_1_tid_res_arr_mem_337275_cached_sizze_339222 =
            (int64_t) 8 * num_tasks_337274;
    }
    if (reduce_stage_1_tid_res_arr_mem_337277_cached_sizze_339223 <
        (size_t) ((int64_t) 8 * num_tasks_337274)) {
        reduce_stage_1_tid_res_arr_mem_337277 =
            realloc(reduce_stage_1_tid_res_arr_mem_337277, (int64_t) 8 *
                    num_tasks_337274);
        reduce_stage_1_tid_res_arr_mem_337277_cached_sizze_339223 =
            (int64_t) 8 * num_tasks_337274;
    }
    
    int64_t iter_337279;
    struct futhark_mc_segred_stage_1_parloop_struct_339224
    futhark_mc_segred_stage_1_parloop_struct_339224;
    
    futhark_mc_segred_stage_1_parloop_struct_339224.ctx = ctx;
    futhark_mc_segred_stage_1_parloop_struct_339224.free_n_292675 = n_292675;
    futhark_mc_segred_stage_1_parloop_struct_339224.free_gtid_310525 =
        gtid_310525;
    futhark_mc_segred_stage_1_parloop_struct_339224.free_mem_316815 =
        mem_316815.mem;
    futhark_mc_segred_stage_1_parloop_struct_339224.free_reduce_stage_1_tid_res_arr_mem_337275 =
        reduce_stage_1_tid_res_arr_mem_337275;
    futhark_mc_segred_stage_1_parloop_struct_339224.free_reduce_stage_1_tid_res_arr_mem_337277 =
        reduce_stage_1_tid_res_arr_mem_337277;
    
    struct scheduler_parloop futhark_mc_segred_stage_1_parloop_339225_task;
    
    futhark_mc_segred_stage_1_parloop_339225_task.name =
        "futhark_mc_segred_stage_1_parloop_339225";
    futhark_mc_segred_stage_1_parloop_339225_task.fn =
        futhark_mc_segred_stage_1_parloop_339225;
    futhark_mc_segred_stage_1_parloop_339225_task.args =
        &futhark_mc_segred_stage_1_parloop_struct_339224;
    futhark_mc_segred_stage_1_parloop_339225_task.iterations = iterations;
    futhark_mc_segred_stage_1_parloop_339225_task.info = info;
    
    uint64_t futhark_mc_segred_stage_1_parloop_339225_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_339225_total_start = get_wall_time();
    
    int futhark_mc_segred_stage_1_parloop_339225_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segred_stage_1_parloop_339225_task);
    
    if (futhark_mc_segred_stage_1_parloop_339225_err != 0) {
        err = futhark_mc_segred_stage_1_parloop_339225_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_339225_total_end =
                 get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_339225_total_end -
                 futhark_mc_segred_stage_1_parloop_339225_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_339225_total_runs,
                           1, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_339225_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_339225_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    // neutral-initialise the output
    {
        defunc_0_f_res_310527 = INFINITY;
        defunc_0_f_res_310528 = -INFINITY;
    }
    
    double x_337282;
    double x_337283;
    double x_337285;
    double x_337286;
    
    for (int32_t i_337288 = 0; i_337288 < num_tasks_337274; i_337288++) {
        flat_tid_337263 = i_337288;
        // Apply main thread reduction
        {
            // load acc params
            {
                x_337282 = defunc_0_f_res_310527;
            }
            // load next params
            {
                x_337283 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_337275)[flat_tid_337263];
            }
            // red body
            {
                double defunc_1_op_res_337284 = fmin64(x_337282, x_337283);
                
                defunc_0_f_res_310527 = defunc_1_op_res_337284;
            }
            // load acc params
            {
                x_337285 = defunc_0_f_res_310528;
            }
            // load next params
            {
                x_337286 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_337277)[flat_tid_337263];
            }
            // red body
            {
                double defunc_1_op_res_337287 = fmax64(x_337285, x_337286);
                
                defunc_0_f_res_310528 = defunc_1_op_res_337287;
            }
        }
    }
    
  cleanup:
    {
        free(reduce_stage_1_tid_res_arr_mem_337275);
        free(reduce_stage_1_tid_res_arr_mem_337277);
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_task_339221_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_task_339221_end -
                 futhark_mc_segred_task_339221_start;
        
        ctx->futhark_mc_segred_task_339221_runs[tid]++;
        ctx->futhark_mc_segred_task_339221_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segred_task_339221_iter[tid] += iterations;
    }
    if (err == 0) {
        *futhark_mc_task_339220->retval_defunc_0_f_res_310527 =
            defunc_0_f_res_310527;
        *futhark_mc_task_339220->retval_defunc_0_f_res_310528 =
            defunc_0_f_res_310528;
    }
    return err;
}
static int futhark_mc_segmap_parloop_339219(void *args, int64_t start,
                                            int64_t end, int flat_tid_310524,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_339218
    *futhark_mc_segmap_parloop_struct_339218 =
    (struct futhark_mc_segmap_parloop_struct_339218 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_339218->ctx;
    uint64_t futhark_mc_segmap_parloop_339219_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339219_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_339218->free_n_292675;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_339218->free_partition_sizze_292766;
    struct memblock mem_316815 = {.desc ="mem_316815", .mem =
                                  futhark_mc_segmap_parloop_struct_339218->free_mem_316815,
                                  .size =0, .references =NULL};
    struct memblock mem_316822 = {.desc ="mem_316822", .mem =
                                  futhark_mc_segmap_parloop_struct_339218->free_mem_316822,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_337262 = start;
    
    for (; iter_337262 < end; iter_337262++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_337272 = partition_sizze_292766;
        int64_t gtid_310525 = iter_337262;
        int64_t remnant_337273 = iter_337262 - gtid_310525;
        double defunc_0_f_res_310527;
        double defunc_0_f_res_310528;
        int64_t flat_tid_337263 = (int64_t) 0;
        int32_t num_tasks_337274;
        
        defunc_0_f_res_310527 = 0.0;
        defunc_0_f_res_310528 = 0.0;
        
        struct futhark_mc_task_339220 futhark_mc_task_339220;
        
        futhark_mc_task_339220.ctx = ctx;
        futhark_mc_task_339220.free_n_292675 = n_292675;
        futhark_mc_task_339220.free_gtid_310525 = gtid_310525;
        futhark_mc_task_339220.free_mem_316815 = mem_316815.mem;
        futhark_mc_task_339220.retval_defunc_0_f_res_310527 =
            &defunc_0_f_res_310527;
        futhark_mc_task_339220.retval_defunc_0_f_res_310528 =
            &defunc_0_f_res_310528;
        
        struct scheduler_segop futhark_mc_task_339220_task;
        
        futhark_mc_task_339220_task.args = &futhark_mc_task_339220;
        futhark_mc_task_339220_task.top_level_fn =
            futhark_mc_segred_task_339221;
        futhark_mc_task_339220_task.name = "futhark_mc_segred_task_339221";
        futhark_mc_task_339220_task.iterations = n_292675;
        futhark_mc_task_339220_task.task_time =
            &ctx->futhark_mc_segred_task_339221_total_time;
        futhark_mc_task_339220_task.task_iter =
            &ctx->futhark_mc_segred_task_339221_total_iter;
        futhark_mc_task_339220_task.sched = STATIC;
        futhark_mc_task_339220_task.nested_fn = NULL;
        
        int futhark_mc_segred_task_339221_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_339220_task);
        
        if (futhark_mc_segred_task_339221_err != 0) {
            ;
            err = futhark_mc_segred_task_339221_err;
            goto cleanup;
        }
        
        double defunc_1_f_res_310538 = defunc_0_f_res_310527 +
               defunc_0_f_res_310528;
        double defunc_0_f_res_310539 = defunc_1_f_res_310538 / 2.0;
        
        ((double *) mem_316822.mem)[gtid_310525] = defunc_0_f_res_310539;
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339219_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339219_end -
                 futhark_mc_segmap_parloop_339219_start;
        
        ctx->futhark_mc_segmap_parloop_339219_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_339219_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_339219_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_nested_task_339217(void *args, int64_t iterations,
                                         int tid, struct scheduler_info info)
{
    int err = 0;
    int flat_tid_310524 = tid;
    int num_tasks_337250 = info.nsubtasks;
    struct futhark_mc_task_339213 *futhark_mc_task_339213 =
                                  (struct futhark_mc_task_339213 *) args;
    struct futhark_context *ctx = futhark_mc_task_339213->ctx;
    uint64_t futhark_mc_segmap_nested_task_339217_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_nested_task_339217_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_339213->free_n_292675;
    int64_t partition_sizze_292766 =
            futhark_mc_task_339213->free_partition_sizze_292766;
    struct memblock mem_316815 = {.desc ="mem_316815", .mem =
                                  futhark_mc_task_339213->free_mem_316815,
                                  .size =0, .references =NULL};
    struct memblock mem_316822 = {.desc ="mem_316822", .mem =
                                  futhark_mc_task_339213->free_mem_316822,
                                  .size =0, .references =NULL};
    int64_t iter_337262;
    struct futhark_mc_segmap_parloop_struct_339218
    futhark_mc_segmap_parloop_struct_339218;
    
    futhark_mc_segmap_parloop_struct_339218.ctx = ctx;
    futhark_mc_segmap_parloop_struct_339218.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_339218.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_339218.free_mem_316815 = mem_316815.mem;
    futhark_mc_segmap_parloop_struct_339218.free_mem_316822 = mem_316822.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_339219_task;
    
    futhark_mc_segmap_parloop_339219_task.name =
        "futhark_mc_segmap_parloop_339219";
    futhark_mc_segmap_parloop_339219_task.fn = futhark_mc_segmap_parloop_339219;
    futhark_mc_segmap_parloop_339219_task.args =
        &futhark_mc_segmap_parloop_struct_339218;
    futhark_mc_segmap_parloop_339219_task.iterations = iterations;
    futhark_mc_segmap_parloop_339219_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_339219_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339219_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_339219_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_339219_task);
    
    if (futhark_mc_segmap_parloop_339219_err != 0) {
        err = futhark_mc_segmap_parloop_339219_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339219_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339219_total_end -
                 futhark_mc_segmap_parloop_339219_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339219_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339219_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339219_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_nested_task_339217_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_nested_task_339217_end -
                 futhark_mc_segmap_nested_task_339217_start;
        
        ctx->futhark_mc_segmap_nested_task_339217_runs[tid]++;
        ctx->futhark_mc_segmap_nested_task_339217_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_nested_task_339217_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_task_339226 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_partition_sizze_292766;
    unsigned char *free_mem_312639;
    int64_t free_bytes_316827;
    unsigned char *free_mem_316832;
    unsigned char *free_mem_316835;
};
struct futhark_mc_segmap_parloop_struct_339228 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_partition_sizze_292766;
    unsigned char *free_mem_312639;
    int64_t free_bytes_316827;
    unsigned char *free_mem_316832;
    unsigned char *free_mem_316835;
};
static int futhark_mc_segmap_parloop_339229(void *args, int64_t start,
                                            int64_t end, int flat_tid_310540,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_339228
    *futhark_mc_segmap_parloop_struct_339228 =
    (struct futhark_mc_segmap_parloop_struct_339228 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_339228->ctx;
    uint64_t futhark_mc_segmap_parloop_339229_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339229_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_339228->free_n_292675;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_339228->free_partition_sizze_292766;
    struct memblock mem_312639 = {.desc ="mem_312639", .mem =
                                  futhark_mc_segmap_parloop_struct_339228->free_mem_312639,
                                  .size =0, .references =NULL};
    int64_t bytes_316827 =
            futhark_mc_segmap_parloop_struct_339228->free_bytes_316827;
    struct memblock mem_316832 = {.desc ="mem_316832", .mem =
                                  futhark_mc_segmap_parloop_struct_339228->free_mem_316832,
                                  .size =0, .references =NULL};
    struct memblock mem_316835 = {.desc ="mem_316835", .mem =
                                  futhark_mc_segmap_parloop_struct_339228->free_mem_316835,
                                  .size =0, .references =NULL};
    size_t mem_316828_cached_sizze_339230 = 0;
    unsigned char *mem_316828 = NULL;
    int64_t iterations = end - start;
    int64_t iter_337291 = start;
    
    if (mem_316828_cached_sizze_339230 < (size_t) bytes_316827) {
        mem_316828 = realloc(mem_316828, bytes_316827);
        mem_316828_cached_sizze_339230 = bytes_316827;
    }
    for (; iter_337291 < end; iter_337291++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_337292 = partition_sizze_292766;
        int64_t gtid_310541 = iter_337291;
        int64_t remnant_337293 = iter_337291 - gtid_310541;
        int64_t x_297064;
        
        x_297064 = ((int64_t *) mem_312639.mem)[gtid_310541];
        
        int64_t defunc_0_f_res_297066 = sdiv64(x_297064, (int64_t) 2);
        int32_t i64_res_297067 = sext_i64_i32(gtid_310541);
        int32_t defunc_0_f_res_297068 = add32(1, i64_res_297067);
        
        for (int64_t i_337294 = 0; i_337294 < n_292675; i_337294++) {
            ((int32_t *) mem_316828)[i_337294] = defunc_0_f_res_297068;
        }
        if (n_292675 * (int64_t) 4 > 0)
            memmove(mem_316832.mem + gtid_310541 * n_292675 * (int64_t) 4,
                    mem_316828 + (int64_t) 0, n_292675 * (int64_t) 4);
        ((int64_t *) mem_316835.mem)[gtid_310541] = defunc_0_f_res_297066;
    }
    
  cleanup:
    { }
    free(mem_316828);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339229_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339229_end -
                 futhark_mc_segmap_parloop_339229_start;
        
        ctx->futhark_mc_segmap_parloop_339229_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_339229_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_339229_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_339227(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_310540 = tid;
    int num_tasks_337290 = info.nsubtasks;
    struct futhark_mc_task_339226 *futhark_mc_task_339226 =
                                  (struct futhark_mc_task_339226 *) args;
    struct futhark_context *ctx = futhark_mc_task_339226->ctx;
    uint64_t futhark_mc_segmap_task_339227_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_339227_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_339226->free_n_292675;
    int64_t partition_sizze_292766 =
            futhark_mc_task_339226->free_partition_sizze_292766;
    struct memblock mem_312639 = {.desc ="mem_312639", .mem =
                                  futhark_mc_task_339226->free_mem_312639,
                                  .size =0, .references =NULL};
    int64_t bytes_316827 = futhark_mc_task_339226->free_bytes_316827;
    struct memblock mem_316832 = {.desc ="mem_316832", .mem =
                                  futhark_mc_task_339226->free_mem_316832,
                                  .size =0, .references =NULL};
    struct memblock mem_316835 = {.desc ="mem_316835", .mem =
                                  futhark_mc_task_339226->free_mem_316835,
                                  .size =0, .references =NULL};
    int64_t iter_337291;
    struct futhark_mc_segmap_parloop_struct_339228
    futhark_mc_segmap_parloop_struct_339228;
    
    futhark_mc_segmap_parloop_struct_339228.ctx = ctx;
    futhark_mc_segmap_parloop_struct_339228.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_339228.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_339228.free_mem_312639 = mem_312639.mem;
    futhark_mc_segmap_parloop_struct_339228.free_bytes_316827 = bytes_316827;
    futhark_mc_segmap_parloop_struct_339228.free_mem_316832 = mem_316832.mem;
    futhark_mc_segmap_parloop_struct_339228.free_mem_316835 = mem_316835.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_339229_task;
    
    futhark_mc_segmap_parloop_339229_task.name =
        "futhark_mc_segmap_parloop_339229";
    futhark_mc_segmap_parloop_339229_task.fn = futhark_mc_segmap_parloop_339229;
    futhark_mc_segmap_parloop_339229_task.args =
        &futhark_mc_segmap_parloop_struct_339228;
    futhark_mc_segmap_parloop_339229_task.iterations = iterations;
    futhark_mc_segmap_parloop_339229_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_339229_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339229_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_339229_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_339229_task);
    
    if (futhark_mc_segmap_parloop_339229_err != 0) {
        err = futhark_mc_segmap_parloop_339229_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339229_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339229_total_end -
                 futhark_mc_segmap_parloop_339229_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339229_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339229_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339229_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_339227_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_339227_end -
                 futhark_mc_segmap_task_339227_start;
        
        ctx->futhark_mc_segmap_task_339227_runs[tid]++;
        ctx->futhark_mc_segmap_task_339227_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_339227_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_task_339231 {
    struct futhark_context *ctx;
    int64_t free_partition_sizze_292766;
    unsigned char *free_mem_316835;
    unsigned char *free_mem_316841;
};
struct futhark_mc_segmap_parloop_struct_339233 {
    struct futhark_context *ctx;
    int64_t free_partition_sizze_292766;
    unsigned char *free_mem_316835;
    unsigned char *free_mem_316841;
};
static int futhark_mc_segmap_parloop_339234(void *args, int64_t start,
                                            int64_t end, int flat_tid_310542,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_339233
    *futhark_mc_segmap_parloop_struct_339233 =
    (struct futhark_mc_segmap_parloop_struct_339233 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_339233->ctx;
    uint64_t futhark_mc_segmap_parloop_339234_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339234_start = get_wall_time();
    
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_339233->free_partition_sizze_292766;
    struct memblock mem_316835 = {.desc ="mem_316835", .mem =
                                  futhark_mc_segmap_parloop_struct_339233->free_mem_316835,
                                  .size =0, .references =NULL};
    struct memblock mem_316841 = {.desc ="mem_316841", .mem =
                                  futhark_mc_segmap_parloop_struct_339233->free_mem_316841,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_337296 = start;
    
    for (; iter_337296 < end; iter_337296++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_337297 = partition_sizze_292766;
        int64_t gtid_310543 = iter_337296;
        int64_t remnant_337298 = iter_337296 - gtid_310543;
        int64_t x_297074;
        
        x_297074 = ((int64_t *) mem_316835.mem)[gtid_310543];
        
        int32_t defunc_0_f_res_297075 = sext_i64_i32(x_297074);
        
        ((int32_t *) mem_316841.mem)[gtid_310543] = defunc_0_f_res_297075;
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339234_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339234_end -
                 futhark_mc_segmap_parloop_339234_start;
        
        ctx->futhark_mc_segmap_parloop_339234_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_339234_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_339234_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_339232(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_310542 = tid;
    int num_tasks_337295 = info.nsubtasks;
    struct futhark_mc_task_339231 *futhark_mc_task_339231 =
                                  (struct futhark_mc_task_339231 *) args;
    struct futhark_context *ctx = futhark_mc_task_339231->ctx;
    uint64_t futhark_mc_segmap_task_339232_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_339232_start = get_wall_time();
    
    int64_t partition_sizze_292766 =
            futhark_mc_task_339231->free_partition_sizze_292766;
    struct memblock mem_316835 = {.desc ="mem_316835", .mem =
                                  futhark_mc_task_339231->free_mem_316835,
                                  .size =0, .references =NULL};
    struct memblock mem_316841 = {.desc ="mem_316841", .mem =
                                  futhark_mc_task_339231->free_mem_316841,
                                  .size =0, .references =NULL};
    int64_t iter_337296;
    struct futhark_mc_segmap_parloop_struct_339233
    futhark_mc_segmap_parloop_struct_339233;
    
    futhark_mc_segmap_parloop_struct_339233.ctx = ctx;
    futhark_mc_segmap_parloop_struct_339233.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_339233.free_mem_316835 = mem_316835.mem;
    futhark_mc_segmap_parloop_struct_339233.free_mem_316841 = mem_316841.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_339234_task;
    
    futhark_mc_segmap_parloop_339234_task.name =
        "futhark_mc_segmap_parloop_339234";
    futhark_mc_segmap_parloop_339234_task.fn = futhark_mc_segmap_parloop_339234;
    futhark_mc_segmap_parloop_339234_task.args =
        &futhark_mc_segmap_parloop_struct_339233;
    futhark_mc_segmap_parloop_339234_task.iterations = iterations;
    futhark_mc_segmap_parloop_339234_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_339234_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339234_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_339234_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_339234_task);
    
    if (futhark_mc_segmap_parloop_339234_err != 0) {
        err = futhark_mc_segmap_parloop_339234_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339234_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339234_total_end -
                 futhark_mc_segmap_parloop_339234_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339234_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339234_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339234_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_339232_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_339232_end -
                 futhark_mc_segmap_task_339232_start;
        
        ctx->futhark_mc_segmap_task_339232_runs[tid]++;
        ctx->futhark_mc_segmap_task_339232_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_339232_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_task_339235 {
    struct futhark_context *ctx;
    int64_t free_partition_sizze_292766;
    unsigned char *free_mem_param_316860;
    unsigned char *free_mem_316906;
};
struct futhark_mc_scan_stage_1_parloop_struct_339238 {
    struct futhark_context *ctx;
    unsigned char *free_mem_param_316860;
    unsigned char *free_mem_316906;
};
static int futhark_mc_scan_stage_1_parloop_339239(void *args, int64_t start,
                                                  int64_t end,
                                                  int flat_tid_310544, int tid)
{
    int err = 0;
    struct futhark_mc_scan_stage_1_parloop_struct_339238
    *futhark_mc_scan_stage_1_parloop_struct_339238 =
    (struct futhark_mc_scan_stage_1_parloop_struct_339238 *) args;
    struct futhark_context *ctx =
                           futhark_mc_scan_stage_1_parloop_struct_339238->ctx;
    uint64_t futhark_mc_scan_stage_1_parloop_339239_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_scan_stage_1_parloop_339239_start = get_wall_time();
    
    struct memblock mem_param_316860 = {.desc ="mem_param_316860", .mem =
                                        futhark_mc_scan_stage_1_parloop_struct_339238->free_mem_param_316860,
                                        .size =0, .references =NULL};
    struct memblock mem_316906 = {.desc ="mem_316906", .mem =
                                  futhark_mc_scan_stage_1_parloop_struct_339238->free_mem_316906,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_337337 = start;
    int32_t x_297113;
    int32_t x_297114;
    
    x_297113 = 0;
    for (; iter_337337 < end; iter_337337++) {
        int64_t gtid_310545 = iter_337337;
        
        // stage 1 scan body
        {
            int32_t x_297116;
            
            x_297116 = ((int32_t *) mem_param_316860.mem)[gtid_310545];
            // write mapped values results to memory
            { }
            x_297113 = x_297113;
            // Read next values
            {
                x_297114 = x_297116;
            }
            
            int32_t defunc_1_op_res_297115 = add32(x_297113, x_297114);
            
            ((int32_t *) mem_316906.mem)[gtid_310545] = defunc_1_op_res_297115;
            x_297113 = defunc_1_op_res_297115;
        }
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_scan_stage_1_parloop_339239_end = get_wall_time();
        uint64_t elapsed = futhark_mc_scan_stage_1_parloop_339239_end -
                 futhark_mc_scan_stage_1_parloop_339239_start;
        
        ctx->futhark_mc_scan_stage_1_parloop_339239_runs[tid]++;
        ctx->futhark_mc_scan_stage_1_parloop_339239_total_runtime[tid] +=
            elapsed;
        ctx->futhark_mc_scan_stage_1_parloop_339239_iter[tid] += iterations;
    }
    return err;
}
struct futhark_mc_scan_stage_3_parloop_struct_339240 {
    struct futhark_context *ctx;
    unsigned char *free_mem_param_316860;
    unsigned char *free_mem_316906;
};
static int futhark_mc_scan_stage_3_parloop_339241(void *args, int64_t start,
                                                  int64_t end,
                                                  int flat_tid_310544, int tid)
{
    int err = 0;
    struct futhark_mc_scan_stage_3_parloop_struct_339240
    *futhark_mc_scan_stage_3_parloop_struct_339240 =
    (struct futhark_mc_scan_stage_3_parloop_struct_339240 *) args;
    struct futhark_context *ctx =
                           futhark_mc_scan_stage_3_parloop_struct_339240->ctx;
    uint64_t futhark_mc_scan_stage_3_parloop_339241_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_scan_stage_3_parloop_339241_start = get_wall_time();
    
    struct memblock mem_param_316860 = {.desc ="mem_param_316860", .mem =
                                        futhark_mc_scan_stage_3_parloop_struct_339240->free_mem_param_316860,
                                        .size =0, .references =NULL};
    struct memblock mem_316906 = {.desc ="mem_316906", .mem =
                                  futhark_mc_scan_stage_3_parloop_struct_339240->free_mem_316906,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_337349 = start;
    int32_t x_337346;
    int32_t x_337347;
    
    if (iter_337349 == (int64_t) 0) {
        x_337346 = 0;
    } else {
        x_337346 = ((int32_t *) mem_316906.mem)[iter_337349 - (int64_t) 1];
    }
    for (; iter_337349 < end; iter_337349++) {
        int64_t gtid_310545 = iter_337349;
        
        // stage 3 scan body
        {
            int32_t x_297116;
            
            x_297116 = ((int32_t *) mem_param_316860.mem)[gtid_310545];
            x_337346 = x_337346;
            x_337347 = x_297116;
            
            int32_t defunc_1_op_res_337348 = add32(x_337346, x_337347);
            
            ((int32_t *) mem_316906.mem)[gtid_310545] = defunc_1_op_res_337348;
            x_337346 = defunc_1_op_res_337348;
        }
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_scan_stage_3_parloop_339241_end = get_wall_time();
        uint64_t elapsed = futhark_mc_scan_stage_3_parloop_339241_end -
                 futhark_mc_scan_stage_3_parloop_339241_start;
        
        ctx->futhark_mc_scan_stage_3_parloop_339241_runs[tid]++;
        ctx->futhark_mc_scan_stage_3_parloop_339241_total_runtime[tid] +=
            elapsed;
        ctx->futhark_mc_scan_stage_3_parloop_339241_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segscan_task_339236(void *args, int64_t iterations, int tid,
                                   struct scheduler_info info)
{
    int err = 0;
    int flat_tid_310544 = tid;
    int num_tasks_337336 = info.nsubtasks;
    struct futhark_mc_task_339235 *futhark_mc_task_339235 =
                                  (struct futhark_mc_task_339235 *) args;
    struct futhark_context *ctx = futhark_mc_task_339235->ctx;
    uint64_t futhark_mc_segscan_task_339236_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segscan_task_339236_start = get_wall_time();
    
    int64_t partition_sizze_292766 =
            futhark_mc_task_339235->free_partition_sizze_292766;
    struct memblock mem_param_316860 = {.desc ="mem_param_316860", .mem =
                                        futhark_mc_task_339235->free_mem_param_316860,
                                        .size =0, .references =NULL};
    struct memblock mem_316906 = {.desc ="mem_316906", .mem =
                                  futhark_mc_task_339235->free_mem_316906,
                                  .size =0, .references =NULL};
    size_t scan_stage_2_accum_mem_337343_cached_sizze_339237 = 0;
    unsigned char *scan_stage_2_accum_mem_337343 = NULL;
    int64_t iter_337337;
    struct futhark_mc_scan_stage_1_parloop_struct_339238
    futhark_mc_scan_stage_1_parloop_struct_339238;
    
    futhark_mc_scan_stage_1_parloop_struct_339238.ctx = ctx;
    futhark_mc_scan_stage_1_parloop_struct_339238.free_mem_param_316860 =
        mem_param_316860.mem;
    futhark_mc_scan_stage_1_parloop_struct_339238.free_mem_316906 =
        mem_316906.mem;
    
    struct scheduler_parloop futhark_mc_scan_stage_1_parloop_339239_task;
    
    futhark_mc_scan_stage_1_parloop_339239_task.name =
        "futhark_mc_scan_stage_1_parloop_339239";
    futhark_mc_scan_stage_1_parloop_339239_task.fn =
        futhark_mc_scan_stage_1_parloop_339239;
    futhark_mc_scan_stage_1_parloop_339239_task.args =
        &futhark_mc_scan_stage_1_parloop_struct_339238;
    futhark_mc_scan_stage_1_parloop_339239_task.iterations = iterations;
    futhark_mc_scan_stage_1_parloop_339239_task.info = info;
    
    uint64_t futhark_mc_scan_stage_1_parloop_339239_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_scan_stage_1_parloop_339239_total_start = get_wall_time();
    
    int futhark_mc_scan_stage_1_parloop_339239_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_scan_stage_1_parloop_339239_task);
    
    if (futhark_mc_scan_stage_1_parloop_339239_err != 0) {
        err = futhark_mc_scan_stage_1_parloop_339239_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_scan_stage_1_parloop_339239_total_end =
                 get_wall_time();
        uint64_t elapsed = futhark_mc_scan_stage_1_parloop_339239_total_end -
                 futhark_mc_scan_stage_1_parloop_339239_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_scan_stage_1_parloop_339239_total_runs,
                           1, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_scan_stage_1_parloop_339239_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_scan_stage_1_parloop_339239_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    if (slt32(1, num_tasks_337336)) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "nonsegmentedScan stage 2");
        
        int32_t x_337338;
        int32_t x_337339;
        int64_t offset_337341 = (int64_t) 0;
        int64_t offset_index_337342 = (int64_t) 0;
        
        if (scan_stage_2_accum_mem_337343_cached_sizze_339237 <
            (size_t) (int64_t) 4) {
            scan_stage_2_accum_mem_337343 =
                realloc(scan_stage_2_accum_mem_337343, (int64_t) 4);
            scan_stage_2_accum_mem_337343_cached_sizze_339237 = (int64_t) 4;
        }
        ((int32_t *) scan_stage_2_accum_mem_337343)[(int64_t) 0] = 0;
        for (int32_t i_337345 = 0; i_337345 < num_tasks_337336 - 1;
             i_337345++) {
            offset_337341 = squot64(partition_sizze_292766,
                                    sext_i32_i64(num_tasks_337336));
            if (slt64(sext_i32_i64(i_337345), srem64(partition_sizze_292766,
                                                     sext_i32_i64(num_tasks_337336)))) {
                offset_337341 += (int64_t) 1;
            }
            offset_index_337342 += offset_337341;
            
            int64_t gtid_310545 = offset_index_337342;
            int32_t x_297116;
            
            x_297116 = ((int32_t *) mem_param_316860.mem)[gtid_310545];
            // Read carry in
            {
                x_337338 =
                    ((int32_t *) scan_stage_2_accum_mem_337343)[(int64_t) 0];
            }
            // Read next values
            {
                x_337339 = ((int32_t *) mem_316906.mem)[offset_index_337342 -
                                                        (int64_t) 1];
            }
            
            int32_t defunc_1_op_res_337340 = add32(x_337338, x_337339);
            
            ((int32_t *) mem_316906.mem)[offset_index_337342 - (int64_t) 1] =
                defunc_1_op_res_337340;
            ((int32_t *) scan_stage_2_accum_mem_337343)[(int64_t) 0] =
                defunc_1_op_res_337340;
        }
        
        int64_t iter_337349 = (int64_t) 0;
        struct futhark_mc_scan_stage_3_parloop_struct_339240
        futhark_mc_scan_stage_3_parloop_struct_339240;
        
        futhark_mc_scan_stage_3_parloop_struct_339240.ctx = ctx;
        futhark_mc_scan_stage_3_parloop_struct_339240.free_mem_param_316860 =
            mem_param_316860.mem;
        futhark_mc_scan_stage_3_parloop_struct_339240.free_mem_316906 =
            mem_316906.mem;
        
        struct scheduler_parloop futhark_mc_scan_stage_3_parloop_339241_task;
        
        futhark_mc_scan_stage_3_parloop_339241_task.name =
            "futhark_mc_scan_stage_3_parloop_339241";
        futhark_mc_scan_stage_3_parloop_339241_task.fn =
            futhark_mc_scan_stage_3_parloop_339241;
        futhark_mc_scan_stage_3_parloop_339241_task.args =
            &futhark_mc_scan_stage_3_parloop_struct_339240;
        futhark_mc_scan_stage_3_parloop_339241_task.iterations = iterations;
        futhark_mc_scan_stage_3_parloop_339241_task.info = info;
        
        uint64_t futhark_mc_scan_stage_3_parloop_339241_total_start = 0;
        
        if (ctx->profiling && !ctx->profiling_paused)
            futhark_mc_scan_stage_3_parloop_339241_total_start =
                get_wall_time();
        
        int futhark_mc_scan_stage_3_parloop_339241_err =
            scheduler_execute_task(&ctx->scheduler,
                                   &futhark_mc_scan_stage_3_parloop_339241_task);
        
        if (futhark_mc_scan_stage_3_parloop_339241_err != 0) {
            err = futhark_mc_scan_stage_3_parloop_339241_err;
            goto cleanup;
        }
        if (ctx->profiling && !ctx->profiling_paused) {
            uint64_t futhark_mc_scan_stage_3_parloop_339241_total_end =
                     get_wall_time();
            uint64_t elapsed =
                     futhark_mc_scan_stage_3_parloop_339241_total_end -
                     futhark_mc_scan_stage_3_parloop_339241_total_start;
            
            __atomic_fetch_add(&ctx->futhark_mc_scan_stage_3_parloop_339241_total_runs,
                               1, __ATOMIC_RELAXED);
            __atomic_fetch_add(&ctx->futhark_mc_scan_stage_3_parloop_339241_total_total_runtime,
                               elapsed, __ATOMIC_RELAXED);
            __atomic_fetch_add(&ctx->futhark_mc_scan_stage_3_parloop_339241_total_iter,
                               iterations, __ATOMIC_RELAXED);
        }
    }
    
  cleanup:
    {
        free(scan_stage_2_accum_mem_337343);
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segscan_task_339236_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segscan_task_339236_end -
                 futhark_mc_segscan_task_339236_start;
        
        ctx->futhark_mc_segscan_task_339236_runs[tid]++;
        ctx->futhark_mc_segscan_task_339236_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segscan_task_339236_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_task_339242 {
    struct futhark_context *ctx;
    int64_t free_partition_sizze_292766;
    int64_t free_loopz2089U_297094;
    bool free_cond_297105;
    unsigned char *free_mem_316822;
    int64_t free_ctx_param_ext_316876;
    int64_t free_ctx_param_ext_316877;
    unsigned char *free_mem_param_316879;
    unsigned char *free_mem_316906;
    unsigned char *free_mem_316909;
};
struct futhark_mc_segmap_parloop_struct_339244 {
    struct futhark_context *ctx;
    int64_t free_partition_sizze_292766;
    int64_t free_loopz2089U_297094;
    bool free_cond_297105;
    unsigned char *free_mem_316822;
    int64_t free_ctx_param_ext_316876;
    int64_t free_ctx_param_ext_316877;
    unsigned char *free_mem_param_316879;
    unsigned char *free_mem_316906;
    unsigned char *free_mem_316909;
};
static int futhark_mc_segmap_parloop_339245(void *args, int64_t start,
                                            int64_t end, int flat_tid_310546,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_339244
    *futhark_mc_segmap_parloop_struct_339244 =
    (struct futhark_mc_segmap_parloop_struct_339244 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_339244->ctx;
    uint64_t futhark_mc_segmap_parloop_339245_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339245_start = get_wall_time();
    
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_339244->free_partition_sizze_292766;
    int64_t loopz2089U_297094 =
            futhark_mc_segmap_parloop_struct_339244->free_loopz2089U_297094;
    bool cond_297105 =
         futhark_mc_segmap_parloop_struct_339244->free_cond_297105;
    struct memblock mem_316822 = {.desc ="mem_316822", .mem =
                                  futhark_mc_segmap_parloop_struct_339244->free_mem_316822,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_316876 =
            futhark_mc_segmap_parloop_struct_339244->free_ctx_param_ext_316876;
    int64_t ctx_param_ext_316877 =
            futhark_mc_segmap_parloop_struct_339244->free_ctx_param_ext_316877;
    struct memblock mem_param_316879 = {.desc ="mem_param_316879", .mem =
                                        futhark_mc_segmap_parloop_struct_339244->free_mem_param_316879,
                                        .size =0, .references =NULL};
    struct memblock mem_316906 = {.desc ="mem_316906", .mem =
                                  futhark_mc_segmap_parloop_struct_339244->free_mem_316906,
                                  .size =0, .references =NULL};
    struct memblock mem_316909 = {.desc ="mem_316909", .mem =
                                  futhark_mc_segmap_parloop_struct_339244->free_mem_316909,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_337351 = start;
    
    for (; iter_337351 < end; iter_337351++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_337363 = partition_sizze_292766;
        int64_t gtid_310547 = iter_337351;
        int64_t remnant_337364 = iter_337351 - gtid_310547;
        double defunc_1_f_res_297126;
        
        if (cond_297105) {
            double defunc_1_f_res_t_res_337352;
            
            defunc_1_f_res_t_res_337352 =
                ((double *) mem_316822.mem)[gtid_310547];
            defunc_1_f_res_297126 = defunc_1_f_res_t_res_337352;
        } else {
            int32_t x_337353;
            
            x_337353 = ((int32_t *) mem_316906.mem)[gtid_310547];
            
            bool cond_337354 = x_337353 == 0;
            double defunc_1_f_res_f_res_337355;
            
            if (cond_337354) {
                defunc_1_f_res_f_res_337355 = 0.0;
            } else {
                int32_t i_337356 = sub32(x_337353, 1);
                int64_t i_337357 = sext_i32_i64(i_337356);
                bool x_337358 = sle64((int64_t) 0, i_337357);
                bool y_337359 = slt64(i_337357, loopz2089U_297094);
                bool bounds_check_337360 = x_337358 && y_337359;
                bool index_certs_337361;
                
                if (!bounds_check_337360) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [", (long long) i_337357,
                                  "] out of bounds for array of shape [",
                                  (long long) loopz2089U_297094, "].",
                                  "-> #0  median.fut:35:37-46\n   #1  /prelude/soacs.fut:67:19-23\n   #2  /prelude/soacs.fut:67:3-37\n   #3  median.fut:9:27-38\n   #4  median.fut:30:13-36:15\n   #5  median.fut:112:18-67\n   #6  stl.fut:343:23-52\n   #7  stl.fut:419:61-435:77\n   #8  stl.fut:463:3-479:36\n   #9  stl.fut:445:1-479:36\n");
                    err = FUTHARK_PROGRAM_ERROR;
                    goto cleanup;
                }
                
                double defunc_1_f_res_f_res_f_res_337362;
                
                defunc_1_f_res_f_res_f_res_337362 =
                    ((double *) mem_param_316879.mem)[ctx_param_ext_316876 +
                                                      i_337357 *
                                                      ctx_param_ext_316877];
                defunc_1_f_res_f_res_337355 = defunc_1_f_res_f_res_f_res_337362;
            }
            defunc_1_f_res_297126 = defunc_1_f_res_f_res_337355;
        }
        ((double *) mem_316909.mem)[gtid_310547] = defunc_1_f_res_297126;
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339245_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339245_end -
                 futhark_mc_segmap_parloop_339245_start;
        
        ctx->futhark_mc_segmap_parloop_339245_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_339245_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_339245_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_339243(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_310546 = tid;
    int num_tasks_337350 = info.nsubtasks;
    struct futhark_mc_task_339242 *futhark_mc_task_339242 =
                                  (struct futhark_mc_task_339242 *) args;
    struct futhark_context *ctx = futhark_mc_task_339242->ctx;
    uint64_t futhark_mc_segmap_task_339243_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_339243_start = get_wall_time();
    
    int64_t partition_sizze_292766 =
            futhark_mc_task_339242->free_partition_sizze_292766;
    int64_t loopz2089U_297094 = futhark_mc_task_339242->free_loopz2089U_297094;
    bool cond_297105 = futhark_mc_task_339242->free_cond_297105;
    struct memblock mem_316822 = {.desc ="mem_316822", .mem =
                                  futhark_mc_task_339242->free_mem_316822,
                                  .size =0, .references =NULL};
    int64_t ctx_param_ext_316876 =
            futhark_mc_task_339242->free_ctx_param_ext_316876;
    int64_t ctx_param_ext_316877 =
            futhark_mc_task_339242->free_ctx_param_ext_316877;
    struct memblock mem_param_316879 = {.desc ="mem_param_316879", .mem =
                                        futhark_mc_task_339242->free_mem_param_316879,
                                        .size =0, .references =NULL};
    struct memblock mem_316906 = {.desc ="mem_316906", .mem =
                                  futhark_mc_task_339242->free_mem_316906,
                                  .size =0, .references =NULL};
    struct memblock mem_316909 = {.desc ="mem_316909", .mem =
                                  futhark_mc_task_339242->free_mem_316909,
                                  .size =0, .references =NULL};
    int64_t iter_337351;
    struct futhark_mc_segmap_parloop_struct_339244
    futhark_mc_segmap_parloop_struct_339244;
    
    futhark_mc_segmap_parloop_struct_339244.ctx = ctx;
    futhark_mc_segmap_parloop_struct_339244.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_339244.free_loopz2089U_297094 =
        loopz2089U_297094;
    futhark_mc_segmap_parloop_struct_339244.free_cond_297105 = cond_297105;
    futhark_mc_segmap_parloop_struct_339244.free_mem_316822 = mem_316822.mem;
    futhark_mc_segmap_parloop_struct_339244.free_ctx_param_ext_316876 =
        ctx_param_ext_316876;
    futhark_mc_segmap_parloop_struct_339244.free_ctx_param_ext_316877 =
        ctx_param_ext_316877;
    futhark_mc_segmap_parloop_struct_339244.free_mem_param_316879 =
        mem_param_316879.mem;
    futhark_mc_segmap_parloop_struct_339244.free_mem_316906 = mem_316906.mem;
    futhark_mc_segmap_parloop_struct_339244.free_mem_316909 = mem_316909.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_339245_task;
    
    futhark_mc_segmap_parloop_339245_task.name =
        "futhark_mc_segmap_parloop_339245";
    futhark_mc_segmap_parloop_339245_task.fn = futhark_mc_segmap_parloop_339245;
    futhark_mc_segmap_parloop_339245_task.args =
        &futhark_mc_segmap_parloop_struct_339244;
    futhark_mc_segmap_parloop_339245_task.iterations = iterations;
    futhark_mc_segmap_parloop_339245_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_339245_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339245_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_339245_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_339245_task);
    
    if (futhark_mc_segmap_parloop_339245_err != 0) {
        err = futhark_mc_segmap_parloop_339245_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339245_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339245_total_end -
                 futhark_mc_segmap_parloop_339245_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339245_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339245_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339245_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_339243_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_339243_end -
                 futhark_mc_segmap_task_339243_start;
        
        ctx->futhark_mc_segmap_task_339243_runs[tid]++;
        ctx->futhark_mc_segmap_task_339243_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_339243_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_task_339246 {
    struct futhark_context *ctx;
    int64_t free_partition_sizze_292766;
    int64_t free_replicate_arg_297080;
    int64_t free_loopz2089U_297094;
    int64_t free_ctx_param_ext_316866;
    int64_t free_ctx_param_ext_316867;
    unsigned char *free_mem_param_316869;
    int64_t free_ctx_param_ext_316876;
    int64_t free_ctx_param_ext_316877;
    unsigned char *free_mem_param_316879;
    unsigned char *free_mem_316909;
    unsigned char *free_mem_316912;
};
struct futhark_mc_seghist_stage_1_parloop_struct_339249 {
    struct futhark_context *ctx;
    int64_t free_partition_sizze_292766;
    int64_t free_replicate_arg_297080;
    int64_t free_ctx_param_ext_316866;
    int64_t free_ctx_param_ext_316867;
    unsigned char *free_mem_param_316869;
    int64_t free_ctx_param_ext_316876;
    int64_t free_ctx_param_ext_316877;
    unsigned char *free_mem_param_316879;
    unsigned char *free_mem_316909;
    unsigned char *free_mem_316912;
    unsigned char *free_subhistogram_mem_337371;
};
static int futhark_mc_seghist_stage_1_parloop_339250(void *args, int64_t start,
                                                     int64_t end,
                                                     int flat_tid_310548,
                                                     int tid)
{
    int err = 0;
    struct futhark_mc_seghist_stage_1_parloop_struct_339249
    *futhark_mc_seghist_stage_1_parloop_struct_339249 =
    (struct futhark_mc_seghist_stage_1_parloop_struct_339249 *) args;
    struct futhark_context *ctx =
                           futhark_mc_seghist_stage_1_parloop_struct_339249->ctx;
    uint64_t futhark_mc_seghist_stage_1_parloop_339250_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_seghist_stage_1_parloop_339250_start = get_wall_time();
    
    int64_t partition_sizze_292766 =
            futhark_mc_seghist_stage_1_parloop_struct_339249->free_partition_sizze_292766;
    int64_t replicate_arg_297080 =
            futhark_mc_seghist_stage_1_parloop_struct_339249->free_replicate_arg_297080;
    int64_t ctx_param_ext_316866 =
            futhark_mc_seghist_stage_1_parloop_struct_339249->free_ctx_param_ext_316866;
    int64_t ctx_param_ext_316867 =
            futhark_mc_seghist_stage_1_parloop_struct_339249->free_ctx_param_ext_316867;
    struct memblock mem_param_316869 = {.desc ="mem_param_316869", .mem =
                                        futhark_mc_seghist_stage_1_parloop_struct_339249->free_mem_param_316869,
                                        .size =0, .references =NULL};
    int64_t ctx_param_ext_316876 =
            futhark_mc_seghist_stage_1_parloop_struct_339249->free_ctx_param_ext_316876;
    int64_t ctx_param_ext_316877 =
            futhark_mc_seghist_stage_1_parloop_struct_339249->free_ctx_param_ext_316877;
    struct memblock mem_param_316879 = {.desc ="mem_param_316879", .mem =
                                        futhark_mc_seghist_stage_1_parloop_struct_339249->free_mem_param_316879,
                                        .size =0, .references =NULL};
    struct memblock mem_316909 = {.desc ="mem_316909", .mem =
                                  futhark_mc_seghist_stage_1_parloop_struct_339249->free_mem_316909,
                                  .size =0, .references =NULL};
    struct memblock mem_316912 = {.desc ="mem_316912", .mem =
                                  futhark_mc_seghist_stage_1_parloop_struct_339249->free_mem_316912,
                                  .size =0, .references =NULL};
    struct memblock subhistogram_mem_337371 = {.desc ="subhistogram_mem_337371",
                                               .mem =
                                               futhark_mc_seghist_stage_1_parloop_struct_339249->free_subhistogram_mem_337371,
                                               .size =0, .references =NULL};
    size_t subhistogram_mem_337373_cached_sizze_339251 = 0;
    unsigned char *subhistogram_mem_337373 = NULL;
    int64_t iterations = end - start;
    int64_t iter_337370 = start;
    int64_t gtid_310549 = iter_337370;
    
    if (subhistogram_mem_337373_cached_sizze_339251 < (size_t) ((int64_t) 4 *
                                                                replicate_arg_297080)) {
        subhistogram_mem_337373 = realloc(subhistogram_mem_337373, (int64_t) 4 *
                                          replicate_arg_297080);
        subhistogram_mem_337373_cached_sizze_339251 = (int64_t) 4 *
            replicate_arg_297080;
    }
    if (flat_tid_310548 == (int64_t) 0) {
        if (replicate_arg_297080 * (int64_t) 4 > 0)
            memmove(subhistogram_mem_337373 + (int64_t) 0, mem_316912.mem +
                    (int64_t) 0, replicate_arg_297080 * (int64_t) 4);
    } else {
        for (int64_t nest_i_337375 = 0; nest_i_337375 < replicate_arg_297080;
             nest_i_337375++) {
            ((int32_t *) subhistogram_mem_337373)[nest_i_337375] = 0;
        }
    }
    for (; iter_337370 < end; iter_337370++) {
        int64_t gtid_310549 = iter_337370;
        int32_t x_297150;
        
        x_297150 = ((int32_t *) mem_param_316869.mem)[ctx_param_ext_316866 +
                                                      gtid_310549 *
                                                      ctx_param_ext_316867];
        
        double x_297151;
        
        x_297151 = ((double *) mem_param_316879.mem)[ctx_param_ext_316876 +
                                                     gtid_310549 *
                                                     ctx_param_ext_316877];
        
        int32_t sgmind_297153 = sub32(x_297150, 1);
        int64_t sgmind_297154 = sext_i32_i64(sgmind_297153);
        bool x_297155 = sle64((int64_t) 0, sgmind_297154);
        bool y_297156 = slt64(sgmind_297154, partition_sizze_292766);
        bool bounds_check_297157 = x_297155 && y_297156;
        bool index_certs_297158;
        
        if (!bounds_check_297157) {
            ctx->error = msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                   "Index [", (long long) sgmind_297154,
                                   "] out of bounds for array of shape [",
                                   (long long) partition_sizze_292766, "].",
                                   "-> #0  median.fut:43:34-47\n   #1  /prelude/soacs.fut:67:19-23\n   #2  /prelude/soacs.fut:67:3-37\n   #3  median.fut:9:27-38\n   #4  median.fut:40:13-49:19\n   #5  median.fut:112:18-67\n   #6  stl.fut:343:23-52\n   #7  stl.fut:419:61-435:77\n   #8  stl.fut:463:3-479:36\n   #9  stl.fut:445:1-479:36\n");
            err = FUTHARK_PROGRAM_ERROR;
            goto cleanup;
        }
        
        double pivot_297159;
        
        pivot_297159 = ((double *) mem_316909.mem)[sgmind_297154];
        
        int32_t h_ind_297160 = shl32(sgmind_297153, 1);
        bool cond_297161 = x_297151 < pivot_297159;
        int32_t binop_p_297162;
        
        if (cond_297161) {
            binop_p_297162 = h_ind_297160;
        } else {
            bool cond_297163 = pivot_297159 == x_297151;
            int32_t binop_p_f_res_297164;
            
            if (cond_297163) {
                int32_t binop_p_f_res_t_res_297165 = add32(1, h_ind_297160);
                
                binop_p_f_res_297164 = binop_p_f_res_t_res_297165;
            } else {
                binop_p_f_res_297164 = -1;
            }
            binop_p_297162 = binop_p_f_res_297164;
        }
        
        int64_t defunc_0_f_res_297166 = sext_i32_i64(binop_p_297162);
        
        // save map-out results
        { }
        // perform updates
        {
            if (sle64((int64_t) 0, defunc_0_f_res_297166) &&
                slt64(defunc_0_f_res_297166, replicate_arg_297080)) {
                int32_t x_297147;
                int32_t x_297148 = 1;
                
                // Start of body
                {
                    int32_t x_297147;
                    
                    x_297147 =
                        ((int32_t *) subhistogram_mem_337373)[defunc_0_f_res_297166];
                    
                    int32_t defunc_1_f_res_297149 = add32(x_297147, x_297148);
                    
                    ((int32_t *) subhistogram_mem_337373)[defunc_0_f_res_297166] =
                        defunc_1_f_res_297149;
                }
            }
        }
    }
    if (replicate_arg_297080 * (int64_t) 4 > 0)
        memmove(subhistogram_mem_337371.mem + flat_tid_310548 *
                replicate_arg_297080 * (int64_t) 4, subhistogram_mem_337373 +
                (int64_t) 0, replicate_arg_297080 * (int64_t) 4);
    
  cleanup:
    { }
    free(subhistogram_mem_337373);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_seghist_stage_1_parloop_339250_end =
                 get_wall_time();
        uint64_t elapsed = futhark_mc_seghist_stage_1_parloop_339250_end -
                 futhark_mc_seghist_stage_1_parloop_339250_start;
        
        ctx->futhark_mc_seghist_stage_1_parloop_339250_runs[tid]++;
        ctx->futhark_mc_seghist_stage_1_parloop_339250_total_runtime[tid] +=
            elapsed;
        ctx->futhark_mc_seghist_stage_1_parloop_339250_iter[tid] += iterations;
    }
    return err;
}
struct futhark_mc_task_339252 {
    struct futhark_context *ctx;
    int64_t free_replicate_arg_297080;
    unsigned char *free_mem_316912;
    int32_t free_num_tasks_337366;
    unsigned char *free_subhistogram_mem_337371;
};
struct futhark_mc_segmented_segred_parloop_struct_339254 {
    struct futhark_context *ctx;
    int64_t free_replicate_arg_297080;
    unsigned char *free_mem_316912;
    int32_t free_num_tasks_337366;
    unsigned char *free_subhistogram_mem_337371;
};
static int futhark_mc_segmented_segred_parloop_339255(void *args, int64_t start,
                                                      int64_t end,
                                                      int flat_tid_310548,
                                                      int tid)
{
    int err = 0;
    struct futhark_mc_segmented_segred_parloop_struct_339254
    *futhark_mc_segmented_segred_parloop_struct_339254 =
    (struct futhark_mc_segmented_segred_parloop_struct_339254 *) args;
    struct futhark_context *ctx =
                           futhark_mc_segmented_segred_parloop_struct_339254->ctx;
    uint64_t futhark_mc_segmented_segred_parloop_339255_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmented_segred_parloop_339255_start = get_wall_time();
    
    int64_t replicate_arg_297080 =
            futhark_mc_segmented_segred_parloop_struct_339254->free_replicate_arg_297080;
    struct memblock mem_316912 = {.desc ="mem_316912", .mem =
                                  futhark_mc_segmented_segred_parloop_struct_339254->free_mem_316912,
                                  .size =0, .references =NULL};
    int32_t num_tasks_337366 =
            futhark_mc_segmented_segred_parloop_struct_339254->free_num_tasks_337366;
    struct memblock subhistogram_mem_337371 = {.desc ="subhistogram_mem_337371",
                                               .mem =
                                               futhark_mc_segmented_segred_parloop_struct_339254->free_subhistogram_mem_337371,
                                               .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t segment_iter_337379 = start;
    
    for (; segment_iter_337379 < end; segment_iter_337379++) {
        int64_t flat_idx_337380 = segment_iter_337379 * num_tasks_337366;
        int64_t bucket_id_337376 = squot64(flat_idx_337380, num_tasks_337366);
        int64_t subhistogram_id_337377 = flat_idx_337380 -
                squot64(flat_idx_337380, num_tasks_337366) * num_tasks_337366;
        
        // neutral-initialise the accumulators
        {
            ((int32_t *) mem_316912.mem)[bucket_id_337376] = 0;
        }
        // main body
        {
            int32_t x_297147;
            int32_t x_297148;
            
            for (int64_t i_337381 = 0; i_337381 < num_tasks_337366;
                 i_337381++) {
                bucket_id_337376 = segment_iter_337379;
                
                int64_t subhistogram_id_337377 = i_337381;
                
                // load accum
                {
                    x_297147 = ((int32_t *) mem_316912.mem)[bucket_id_337376];
                }
                // load new val
                {
                    x_297148 =
                        ((int32_t *) subhistogram_mem_337371.mem)[subhistogram_id_337377 *
                                                                  replicate_arg_297080 +
                                                                  bucket_id_337376];
                }
                // apply reduction
                {
                    int32_t defunc_1_f_res_297149 = add32(x_297147, x_297148);
                    
                    // write back to res
                    {
                        ((int32_t *) mem_316912.mem)[bucket_id_337376] =
                            defunc_1_f_res_297149;
                    }
                }
            }
        }
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmented_segred_parloop_339255_end =
                 get_wall_time();
        uint64_t elapsed = futhark_mc_segmented_segred_parloop_339255_end -
                 futhark_mc_segmented_segred_parloop_339255_start;
        
        ctx->futhark_mc_segmented_segred_parloop_339255_runs[tid]++;
        ctx->futhark_mc_segmented_segred_parloop_339255_total_runtime[tid] +=
            elapsed;
        ctx->futhark_mc_segmented_segred_parloop_339255_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_seghist_red_task_339253(void *args, int64_t iterations, int tid,
                                       struct scheduler_info info)
{
    int err = 0;
    int flat_tid_310548 = tid;
    int num_tasks_337378 = info.nsubtasks;
    struct futhark_mc_task_339252 *futhark_mc_task_339252 =
                                  (struct futhark_mc_task_339252 *) args;
    struct futhark_context *ctx = futhark_mc_task_339252->ctx;
    uint64_t futhark_mc_seghist_red_task_339253_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_seghist_red_task_339253_start = get_wall_time();
    
    int64_t replicate_arg_297080 =
            futhark_mc_task_339252->free_replicate_arg_297080;
    struct memblock mem_316912 = {.desc ="mem_316912", .mem =
                                  futhark_mc_task_339252->free_mem_316912,
                                  .size =0, .references =NULL};
    int32_t num_tasks_337366 = futhark_mc_task_339252->free_num_tasks_337366;
    struct memblock subhistogram_mem_337371 = {.desc ="subhistogram_mem_337371",
                                               .mem =
                                               futhark_mc_task_339252->free_subhistogram_mem_337371,
                                               .size =0, .references =NULL};
    int64_t segment_iter_337379;
    struct futhark_mc_segmented_segred_parloop_struct_339254
    futhark_mc_segmented_segred_parloop_struct_339254;
    
    futhark_mc_segmented_segred_parloop_struct_339254.ctx = ctx;
    futhark_mc_segmented_segred_parloop_struct_339254.free_replicate_arg_297080 =
        replicate_arg_297080;
    futhark_mc_segmented_segred_parloop_struct_339254.free_mem_316912 =
        mem_316912.mem;
    futhark_mc_segmented_segred_parloop_struct_339254.free_num_tasks_337366 =
        num_tasks_337366;
    futhark_mc_segmented_segred_parloop_struct_339254.free_subhistogram_mem_337371 =
        subhistogram_mem_337371.mem;
    
    struct scheduler_parloop futhark_mc_segmented_segred_parloop_339255_task;
    
    futhark_mc_segmented_segred_parloop_339255_task.name =
        "futhark_mc_segmented_segred_parloop_339255";
    futhark_mc_segmented_segred_parloop_339255_task.fn =
        futhark_mc_segmented_segred_parloop_339255;
    futhark_mc_segmented_segred_parloop_339255_task.args =
        &futhark_mc_segmented_segred_parloop_struct_339254;
    futhark_mc_segmented_segred_parloop_339255_task.iterations = iterations;
    futhark_mc_segmented_segred_parloop_339255_task.info = info;
    
    uint64_t futhark_mc_segmented_segred_parloop_339255_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmented_segred_parloop_339255_total_start =
            get_wall_time();
    
    int futhark_mc_segmented_segred_parloop_339255_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmented_segred_parloop_339255_task);
    
    if (futhark_mc_segmented_segred_parloop_339255_err != 0) {
        err = futhark_mc_segmented_segred_parloop_339255_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmented_segred_parloop_339255_total_end =
                 get_wall_time();
        uint64_t elapsed =
                 futhark_mc_segmented_segred_parloop_339255_total_end -
                 futhark_mc_segmented_segred_parloop_339255_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmented_segred_parloop_339255_total_runs,
                           1, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmented_segred_parloop_339255_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmented_segred_parloop_339255_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_seghist_red_task_339253_end = get_wall_time();
        uint64_t elapsed = futhark_mc_seghist_red_task_339253_end -
                 futhark_mc_seghist_red_task_339253_start;
        
        ctx->futhark_mc_seghist_red_task_339253_runs[tid]++;
        ctx->futhark_mc_seghist_red_task_339253_total_runtime[tid] += elapsed;
        ctx->futhark_mc_seghist_red_task_339253_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_atomic_seg_hist_parloop_struct_339256 {
    struct futhark_context *ctx;
    int64_t free_partition_sizze_292766;
    int64_t free_replicate_arg_297080;
    int64_t free_ctx_param_ext_316866;
    int64_t free_ctx_param_ext_316867;
    unsigned char *free_mem_param_316869;
    int64_t free_ctx_param_ext_316876;
    int64_t free_ctx_param_ext_316877;
    unsigned char *free_mem_param_316879;
    unsigned char *free_mem_316909;
    unsigned char *free_mem_316912;
};
static int futhark_mc_atomic_seg_hist_parloop_339257(void *args, int64_t start,
                                                     int64_t end,
                                                     int flat_tid_310548,
                                                     int tid)
{
    int err = 0;
    struct futhark_mc_atomic_seg_hist_parloop_struct_339256
    *futhark_mc_atomic_seg_hist_parloop_struct_339256 =
    (struct futhark_mc_atomic_seg_hist_parloop_struct_339256 *) args;
    struct futhark_context *ctx =
                           futhark_mc_atomic_seg_hist_parloop_struct_339256->ctx;
    uint64_t futhark_mc_atomic_seg_hist_parloop_339257_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_atomic_seg_hist_parloop_339257_start = get_wall_time();
    
    int64_t partition_sizze_292766 =
            futhark_mc_atomic_seg_hist_parloop_struct_339256->free_partition_sizze_292766;
    int64_t replicate_arg_297080 =
            futhark_mc_atomic_seg_hist_parloop_struct_339256->free_replicate_arg_297080;
    int64_t ctx_param_ext_316866 =
            futhark_mc_atomic_seg_hist_parloop_struct_339256->free_ctx_param_ext_316866;
    int64_t ctx_param_ext_316867 =
            futhark_mc_atomic_seg_hist_parloop_struct_339256->free_ctx_param_ext_316867;
    struct memblock mem_param_316869 = {.desc ="mem_param_316869", .mem =
                                        futhark_mc_atomic_seg_hist_parloop_struct_339256->free_mem_param_316869,
                                        .size =0, .references =NULL};
    int64_t ctx_param_ext_316876 =
            futhark_mc_atomic_seg_hist_parloop_struct_339256->free_ctx_param_ext_316876;
    int64_t ctx_param_ext_316877 =
            futhark_mc_atomic_seg_hist_parloop_struct_339256->free_ctx_param_ext_316877;
    struct memblock mem_param_316879 = {.desc ="mem_param_316879", .mem =
                                        futhark_mc_atomic_seg_hist_parloop_struct_339256->free_mem_param_316879,
                                        .size =0, .references =NULL};
    struct memblock mem_316909 = {.desc ="mem_316909", .mem =
                                  futhark_mc_atomic_seg_hist_parloop_struct_339256->free_mem_316909,
                                  .size =0, .references =NULL};
    struct memblock mem_316912 = {.desc ="mem_316912", .mem =
                                  futhark_mc_atomic_seg_hist_parloop_struct_339256->free_mem_316912,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_337370 = start;
    
    for (; iter_337370 < end; iter_337370++) {
        int64_t gtid_310549 = iter_337370;
        int32_t x_297150;
        
        x_297150 = ((int32_t *) mem_param_316869.mem)[ctx_param_ext_316866 +
                                                      gtid_310549 *
                                                      ctx_param_ext_316867];
        
        double x_297151;
        
        x_297151 = ((double *) mem_param_316879.mem)[ctx_param_ext_316876 +
                                                     gtid_310549 *
                                                     ctx_param_ext_316877];
        
        int32_t sgmind_297153 = sub32(x_297150, 1);
        int64_t sgmind_297154 = sext_i32_i64(sgmind_297153);
        bool x_297155 = sle64((int64_t) 0, sgmind_297154);
        bool y_297156 = slt64(sgmind_297154, partition_sizze_292766);
        bool bounds_check_297157 = x_297155 && y_297156;
        bool index_certs_297158;
        
        if (!bounds_check_297157) {
            ctx->error = msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                   "Index [", (long long) sgmind_297154,
                                   "] out of bounds for array of shape [",
                                   (long long) partition_sizze_292766, "].",
                                   "-> #0  median.fut:43:34-47\n   #1  /prelude/soacs.fut:67:19-23\n   #2  /prelude/soacs.fut:67:3-37\n   #3  median.fut:9:27-38\n   #4  median.fut:40:13-49:19\n   #5  median.fut:112:18-67\n   #6  stl.fut:343:23-52\n   #7  stl.fut:419:61-435:77\n   #8  stl.fut:463:3-479:36\n   #9  stl.fut:445:1-479:36\n");
            err = FUTHARK_PROGRAM_ERROR;
            goto cleanup;
        }
        
        double pivot_297159;
        
        pivot_297159 = ((double *) mem_316909.mem)[sgmind_297154];
        
        int32_t h_ind_297160 = shl32(sgmind_297153, 1);
        bool cond_297161 = x_297151 < pivot_297159;
        int32_t binop_p_297162;
        
        if (cond_297161) {
            binop_p_297162 = h_ind_297160;
        } else {
            bool cond_297163 = pivot_297159 == x_297151;
            int32_t binop_p_f_res_297164;
            
            if (cond_297163) {
                int32_t binop_p_f_res_t_res_297165 = add32(1, h_ind_297160);
                
                binop_p_f_res_297164 = binop_p_f_res_t_res_297165;
            } else {
                binop_p_f_res_297164 = -1;
            }
            binop_p_297162 = binop_p_f_res_297164;
        }
        
        int64_t defunc_0_f_res_297166 = sext_i32_i64(binop_p_297162);
        
        // save map-out results
        { }
        // perform updates
        {
            if (sle64((int64_t) 0, defunc_0_f_res_297166) &&
                slt64(defunc_0_f_res_297166, replicate_arg_297080)) {
                int32_t x_337367;
                int32_t x_337368 = 1;
                int32_t old_337382;
                
                old_337382 =
                    __atomic_fetch_add(&((int32_t *) mem_316912.mem)[sext_i64_i32(defunc_0_f_res_297166)],
                                       (int32_t) x_337368, __ATOMIC_RELAXED);
            }
        }
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_atomic_seg_hist_parloop_339257_end =
                 get_wall_time();
        uint64_t elapsed = futhark_mc_atomic_seg_hist_parloop_339257_end -
                 futhark_mc_atomic_seg_hist_parloop_339257_start;
        
        ctx->futhark_mc_atomic_seg_hist_parloop_339257_runs[tid]++;
        ctx->futhark_mc_atomic_seg_hist_parloop_339257_total_runtime[tid] +=
            elapsed;
        ctx->futhark_mc_atomic_seg_hist_parloop_339257_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_seghist_task_339247(void *args, int64_t iterations, int tid,
                                   struct scheduler_info info)
{
    int err = 0;
    int flat_tid_310548 = tid;
    int num_tasks_337366 = info.nsubtasks;
    struct futhark_mc_task_339246 *futhark_mc_task_339246 =
                                  (struct futhark_mc_task_339246 *) args;
    struct futhark_context *ctx = futhark_mc_task_339246->ctx;
    uint64_t futhark_mc_seghist_task_339247_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_seghist_task_339247_start = get_wall_time();
    
    int64_t partition_sizze_292766 =
            futhark_mc_task_339246->free_partition_sizze_292766;
    int64_t replicate_arg_297080 =
            futhark_mc_task_339246->free_replicate_arg_297080;
    int64_t loopz2089U_297094 = futhark_mc_task_339246->free_loopz2089U_297094;
    int64_t ctx_param_ext_316866 =
            futhark_mc_task_339246->free_ctx_param_ext_316866;
    int64_t ctx_param_ext_316867 =
            futhark_mc_task_339246->free_ctx_param_ext_316867;
    struct memblock mem_param_316869 = {.desc ="mem_param_316869", .mem =
                                        futhark_mc_task_339246->free_mem_param_316869,
                                        .size =0, .references =NULL};
    int64_t ctx_param_ext_316876 =
            futhark_mc_task_339246->free_ctx_param_ext_316876;
    int64_t ctx_param_ext_316877 =
            futhark_mc_task_339246->free_ctx_param_ext_316877;
    struct memblock mem_param_316879 = {.desc ="mem_param_316879", .mem =
                                        futhark_mc_task_339246->free_mem_param_316879,
                                        .size =0, .references =NULL};
    struct memblock mem_316909 = {.desc ="mem_316909", .mem =
                                  futhark_mc_task_339246->free_mem_316909,
                                  .size =0, .references =NULL};
    struct memblock mem_316912 = {.desc ="mem_316912", .mem =
                                  futhark_mc_task_339246->free_mem_316912,
                                  .size =0, .references =NULL};
    size_t subhistogram_mem_337371_cached_sizze_339248 = 0;
    unsigned char *subhistogram_mem_337371 = NULL;
    
    if (!(loopz2089U_297094 == (int64_t) 0)) {
        int64_t iter_337370;
        
        if (sle64(sext_i32_i64(num_tasks_337366) * replicate_arg_297080,
                  loopz2089U_297094)) {
            if (ctx->debugging)
                fprintf(ctx->log, "%s\n", "subHistogram segHist");
            if (subhistogram_mem_337371_cached_sizze_339248 <
                (size_t) ((int64_t) 4 * (num_tasks_337366 *
                                         replicate_arg_297080))) {
                subhistogram_mem_337371 = realloc(subhistogram_mem_337371,
                                                  (int64_t) 4 *
                                                  (num_tasks_337366 *
                                                   replicate_arg_297080));
                subhistogram_mem_337371_cached_sizze_339248 = (int64_t) 4 *
                    (num_tasks_337366 * replicate_arg_297080);
            }
            
            struct futhark_mc_seghist_stage_1_parloop_struct_339249
            futhark_mc_seghist_stage_1_parloop_struct_339249;
            
            futhark_mc_seghist_stage_1_parloop_struct_339249.ctx = ctx;
            futhark_mc_seghist_stage_1_parloop_struct_339249.free_partition_sizze_292766 =
                partition_sizze_292766;
            futhark_mc_seghist_stage_1_parloop_struct_339249.free_replicate_arg_297080 =
                replicate_arg_297080;
            futhark_mc_seghist_stage_1_parloop_struct_339249.free_ctx_param_ext_316866 =
                ctx_param_ext_316866;
            futhark_mc_seghist_stage_1_parloop_struct_339249.free_ctx_param_ext_316867 =
                ctx_param_ext_316867;
            futhark_mc_seghist_stage_1_parloop_struct_339249.free_mem_param_316869 =
                mem_param_316869.mem;
            futhark_mc_seghist_stage_1_parloop_struct_339249.free_ctx_param_ext_316876 =
                ctx_param_ext_316876;
            futhark_mc_seghist_stage_1_parloop_struct_339249.free_ctx_param_ext_316877 =
                ctx_param_ext_316877;
            futhark_mc_seghist_stage_1_parloop_struct_339249.free_mem_param_316879 =
                mem_param_316879.mem;
            futhark_mc_seghist_stage_1_parloop_struct_339249.free_mem_316909 =
                mem_316909.mem;
            futhark_mc_seghist_stage_1_parloop_struct_339249.free_mem_316912 =
                mem_316912.mem;
            futhark_mc_seghist_stage_1_parloop_struct_339249.free_subhistogram_mem_337371 =
                subhistogram_mem_337371;
            
            struct scheduler_parloop
            futhark_mc_seghist_stage_1_parloop_339250_task;
            
            futhark_mc_seghist_stage_1_parloop_339250_task.name =
                "futhark_mc_seghist_stage_1_parloop_339250";
            futhark_mc_seghist_stage_1_parloop_339250_task.fn =
                futhark_mc_seghist_stage_1_parloop_339250;
            futhark_mc_seghist_stage_1_parloop_339250_task.args =
                &futhark_mc_seghist_stage_1_parloop_struct_339249;
            futhark_mc_seghist_stage_1_parloop_339250_task.iterations =
                iterations;
            futhark_mc_seghist_stage_1_parloop_339250_task.info = info;
            
            uint64_t futhark_mc_seghist_stage_1_parloop_339250_total_start = 0;
            
            if (ctx->profiling && !ctx->profiling_paused)
                futhark_mc_seghist_stage_1_parloop_339250_total_start =
                    get_wall_time();
            
            int futhark_mc_seghist_stage_1_parloop_339250_err =
                scheduler_execute_task(&ctx->scheduler,
                                       &futhark_mc_seghist_stage_1_parloop_339250_task);
            
            if (futhark_mc_seghist_stage_1_parloop_339250_err != 0) {
                err = futhark_mc_seghist_stage_1_parloop_339250_err;
                goto cleanup;
            }
            if (ctx->profiling && !ctx->profiling_paused) {
                uint64_t futhark_mc_seghist_stage_1_parloop_339250_total_end =
                         get_wall_time();
                uint64_t elapsed =
                         futhark_mc_seghist_stage_1_parloop_339250_total_end -
                         futhark_mc_seghist_stage_1_parloop_339250_total_start;
                
                __atomic_fetch_add(&ctx->futhark_mc_seghist_stage_1_parloop_339250_total_runs,
                                   1, __ATOMIC_RELAXED);
                __atomic_fetch_add(&ctx->futhark_mc_seghist_stage_1_parloop_339250_total_total_runtime,
                                   elapsed, __ATOMIC_RELAXED);
                __atomic_fetch_add(&ctx->futhark_mc_seghist_stage_1_parloop_339250_total_iter,
                                   iterations, __ATOMIC_RELAXED);
            }
            
            int32_t num_tasks_337378;
            struct futhark_mc_task_339252 futhark_mc_task_339252;
            
            futhark_mc_task_339252.ctx = ctx;
            futhark_mc_task_339252.free_replicate_arg_297080 =
                replicate_arg_297080;
            futhark_mc_task_339252.free_mem_316912 = mem_316912.mem;
            futhark_mc_task_339252.free_num_tasks_337366 = num_tasks_337366;
            futhark_mc_task_339252.free_subhistogram_mem_337371 =
                subhistogram_mem_337371;
            
            struct scheduler_segop futhark_mc_task_339252_task;
            
            futhark_mc_task_339252_task.args = &futhark_mc_task_339252;
            futhark_mc_task_339252_task.top_level_fn =
                futhark_mc_seghist_red_task_339253;
            futhark_mc_task_339252_task.name =
                "futhark_mc_seghist_red_task_339253";
            futhark_mc_task_339252_task.iterations = replicate_arg_297080;
            futhark_mc_task_339252_task.task_time =
                &ctx->futhark_mc_seghist_red_task_339253_total_time;
            futhark_mc_task_339252_task.task_iter =
                &ctx->futhark_mc_seghist_red_task_339253_total_iter;
            futhark_mc_task_339252_task.sched = STATIC;
            futhark_mc_task_339252_task.nested_fn = NULL;
            
            int futhark_mc_seghist_red_task_339253_err =
                scheduler_prepare_task(&ctx->scheduler,
                                       &futhark_mc_task_339252_task);
            
            if (futhark_mc_seghist_red_task_339253_err != 0) {
                ;
                err = futhark_mc_seghist_red_task_339253_err;
                goto cleanup;
            }
        } else {
            struct futhark_mc_atomic_seg_hist_parloop_struct_339256
            futhark_mc_atomic_seg_hist_parloop_struct_339256;
            
            futhark_mc_atomic_seg_hist_parloop_struct_339256.ctx = ctx;
            futhark_mc_atomic_seg_hist_parloop_struct_339256.free_partition_sizze_292766 =
                partition_sizze_292766;
            futhark_mc_atomic_seg_hist_parloop_struct_339256.free_replicate_arg_297080 =
                replicate_arg_297080;
            futhark_mc_atomic_seg_hist_parloop_struct_339256.free_ctx_param_ext_316866 =
                ctx_param_ext_316866;
            futhark_mc_atomic_seg_hist_parloop_struct_339256.free_ctx_param_ext_316867 =
                ctx_param_ext_316867;
            futhark_mc_atomic_seg_hist_parloop_struct_339256.free_mem_param_316869 =
                mem_param_316869.mem;
            futhark_mc_atomic_seg_hist_parloop_struct_339256.free_ctx_param_ext_316876 =
                ctx_param_ext_316876;
            futhark_mc_atomic_seg_hist_parloop_struct_339256.free_ctx_param_ext_316877 =
                ctx_param_ext_316877;
            futhark_mc_atomic_seg_hist_parloop_struct_339256.free_mem_param_316879 =
                mem_param_316879.mem;
            futhark_mc_atomic_seg_hist_parloop_struct_339256.free_mem_316909 =
                mem_316909.mem;
            futhark_mc_atomic_seg_hist_parloop_struct_339256.free_mem_316912 =
                mem_316912.mem;
            
            struct scheduler_parloop
            futhark_mc_atomic_seg_hist_parloop_339257_task;
            
            futhark_mc_atomic_seg_hist_parloop_339257_task.name =
                "futhark_mc_atomic_seg_hist_parloop_339257";
            futhark_mc_atomic_seg_hist_parloop_339257_task.fn =
                futhark_mc_atomic_seg_hist_parloop_339257;
            futhark_mc_atomic_seg_hist_parloop_339257_task.args =
                &futhark_mc_atomic_seg_hist_parloop_struct_339256;
            futhark_mc_atomic_seg_hist_parloop_339257_task.iterations =
                iterations;
            futhark_mc_atomic_seg_hist_parloop_339257_task.info = info;
            
            uint64_t futhark_mc_atomic_seg_hist_parloop_339257_total_start = 0;
            
            if (ctx->profiling && !ctx->profiling_paused)
                futhark_mc_atomic_seg_hist_parloop_339257_total_start =
                    get_wall_time();
            
            int futhark_mc_atomic_seg_hist_parloop_339257_err =
                scheduler_execute_task(&ctx->scheduler,
                                       &futhark_mc_atomic_seg_hist_parloop_339257_task);
            
            if (futhark_mc_atomic_seg_hist_parloop_339257_err != 0) {
                err = futhark_mc_atomic_seg_hist_parloop_339257_err;
                goto cleanup;
            }
            if (ctx->profiling && !ctx->profiling_paused) {
                uint64_t futhark_mc_atomic_seg_hist_parloop_339257_total_end =
                         get_wall_time();
                uint64_t elapsed =
                         futhark_mc_atomic_seg_hist_parloop_339257_total_end -
                         futhark_mc_atomic_seg_hist_parloop_339257_total_start;
                
                __atomic_fetch_add(&ctx->futhark_mc_atomic_seg_hist_parloop_339257_total_runs,
                                   1, __ATOMIC_RELAXED);
                __atomic_fetch_add(&ctx->futhark_mc_atomic_seg_hist_parloop_339257_total_total_runtime,
                                   elapsed, __ATOMIC_RELAXED);
                __atomic_fetch_add(&ctx->futhark_mc_atomic_seg_hist_parloop_339257_total_iter,
                                   iterations, __ATOMIC_RELAXED);
            }
        }
    }
    
  cleanup:
    {
        free(subhistogram_mem_337371);
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_seghist_task_339247_end = get_wall_time();
        uint64_t elapsed = futhark_mc_seghist_task_339247_end -
                 futhark_mc_seghist_task_339247_start;
        
        ctx->futhark_mc_seghist_task_339247_runs[tid]++;
        ctx->futhark_mc_seghist_task_339247_total_runtime[tid] += elapsed;
        ctx->futhark_mc_seghist_task_339247_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_task_339258 {
    struct futhark_context *ctx;
    int64_t free_partition_sizze_292766;
    int64_t free_replicate_arg_297080;
    unsigned char *free_mem_param_316855;
    unsigned char *free_mem_param_316860;
    unsigned char *free_mem_316912;
    unsigned char *free_mem_316915;
    unsigned char *free_mem_316917;
    unsigned char *free_mem_316920;
};
struct futhark_mc_segmap_parloop_struct_339260 {
    struct futhark_context *ctx;
    int64_t free_partition_sizze_292766;
    int64_t free_replicate_arg_297080;
    unsigned char *free_mem_param_316855;
    unsigned char *free_mem_param_316860;
    unsigned char *free_mem_316912;
    unsigned char *free_mem_316915;
    unsigned char *free_mem_316917;
    unsigned char *free_mem_316920;
};
static int futhark_mc_segmap_parloop_339261(void *args, int64_t start,
                                            int64_t end, int flat_tid_310550,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_339260
    *futhark_mc_segmap_parloop_struct_339260 =
    (struct futhark_mc_segmap_parloop_struct_339260 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_339260->ctx;
    uint64_t futhark_mc_segmap_parloop_339261_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339261_start = get_wall_time();
    
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_339260->free_partition_sizze_292766;
    int64_t replicate_arg_297080 =
            futhark_mc_segmap_parloop_struct_339260->free_replicate_arg_297080;
    struct memblock mem_param_316855 = {.desc ="mem_param_316855", .mem =
                                        futhark_mc_segmap_parloop_struct_339260->free_mem_param_316855,
                                        .size =0, .references =NULL};
    struct memblock mem_param_316860 = {.desc ="mem_param_316860", .mem =
                                        futhark_mc_segmap_parloop_struct_339260->free_mem_param_316860,
                                        .size =0, .references =NULL};
    struct memblock mem_316912 = {.desc ="mem_316912", .mem =
                                  futhark_mc_segmap_parloop_struct_339260->free_mem_316912,
                                  .size =0, .references =NULL};
    struct memblock mem_316915 = {.desc ="mem_316915", .mem =
                                  futhark_mc_segmap_parloop_struct_339260->free_mem_316915,
                                  .size =0, .references =NULL};
    struct memblock mem_316917 = {.desc ="mem_316917", .mem =
                                  futhark_mc_segmap_parloop_struct_339260->free_mem_316917,
                                  .size =0, .references =NULL};
    struct memblock mem_316920 = {.desc ="mem_316920", .mem =
                                  futhark_mc_segmap_parloop_struct_339260->free_mem_316920,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_337384 = start;
    
    for (; iter_337384 < end; iter_337384++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_337409 = partition_sizze_292766;
        int64_t gtid_310551 = iter_337384;
        int64_t remnant_337410 = iter_337384 - gtid_310551;
        int32_t x_297170;
        
        x_297170 = ((int32_t *) mem_param_316855.mem)[gtid_310551];
        
        bool cond_297172 = slt32(x_297170, 0);
        int32_t defunc_1_f_res_297173;
        int8_t defunc_1_f_res_297174;
        int32_t defunc_1_f_res_297175;
        
        if (cond_297172) {
            defunc_1_f_res_297173 = 0;
            defunc_1_f_res_297174 = (int8_t) 3;
            defunc_1_f_res_297175 = -1;
        } else {
            int64_t i_337385 = shl64(gtid_310551, (int64_t) 1);
            bool x_337386 = sle64((int64_t) 0, i_337385);
            bool y_337387 = slt64(i_337385, replicate_arg_297080);
            bool bounds_check_337388 = x_337386 && y_337387;
            bool index_certs_337389;
            
            if (!bounds_check_337388) {
                ctx->error =
                    msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                              "Index [", (long long) i_337385,
                              "] out of bounds for array of shape [",
                              (long long) replicate_arg_297080, "].",
                              "-> #0  median.fut:57:35-46\n   #1  /prelude/soacs.fut:67:19-23\n   #2  /prelude/soacs.fut:67:3-37\n   #3  median.fut:9:27-38\n   #4  median.fut:54:11-63:13\n   #5  median.fut:112:18-67\n   #6  stl.fut:343:23-52\n   #7  stl.fut:419:61-435:77\n   #8  stl.fut:463:3-479:36\n   #9  stl.fut:445:1-479:36\n");
                err = FUTHARK_PROGRAM_ERROR;
                goto cleanup;
            }
            
            int32_t lt_len_337390;
            
            lt_len_337390 = ((int32_t *) mem_316912.mem)[i_337385];
            
            bool cond_337391 = slt32(x_297170, lt_len_337390);
            int32_t defunc_1_f_res_f_res_337392;
            int8_t defunc_1_f_res_f_res_337393;
            int32_t defunc_1_f_res_f_res_337394;
            
            if (cond_337391) {
                defunc_1_f_res_f_res_337392 = lt_len_337390;
                defunc_1_f_res_f_res_337393 = (int8_t) 0;
                defunc_1_f_res_f_res_337394 = x_297170;
            } else {
                int64_t i_337395 = add64((int64_t) 1, i_337385);
                bool x_337396 = sle64((int64_t) 0, i_337395);
                bool y_337397 = slt64(i_337395, replicate_arg_297080);
                bool bounds_check_337398 = x_337396 && y_337397;
                bool index_certs_337399;
                
                if (!bounds_check_337398) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [", (long long) i_337395,
                                  "] out of bounds for array of shape [",
                                  (long long) replicate_arg_297080, "].",
                                  "-> #0  median.fut:59:40-58\n   #1  /prelude/soacs.fut:67:19-23\n   #2  /prelude/soacs.fut:67:3-37\n   #3  median.fut:9:27-38\n   #4  median.fut:54:11-63:13\n   #5  median.fut:112:18-67\n   #6  stl.fut:343:23-52\n   #7  stl.fut:419:61-435:77\n   #8  stl.fut:463:3-479:36\n   #9  stl.fut:445:1-479:36\n");
                    err = FUTHARK_PROGRAM_ERROR;
                    goto cleanup;
                }
                
                int32_t eq_len_337400;
                
                eq_len_337400 = ((int32_t *) mem_316912.mem)[i_337395];
                
                int32_t lteq_len_337401 = add32(lt_len_337390, eq_len_337400);
                bool cond_337402 = slt32(x_297170, lteq_len_337401);
                int8_t defunc_1_f_res_f_res_f_res_337403;
                
                if (cond_337402) {
                    defunc_1_f_res_f_res_f_res_337403 = (int8_t) 1;
                } else {
                    defunc_1_f_res_f_res_f_res_337403 = (int8_t) 2;
                }
                
                int32_t defunc_1_f_res_f_res_f_res_337404;
                int32_t defunc_1_f_res_f_res_f_res_337405;
                
                if (cond_337402) {
                    defunc_1_f_res_f_res_f_res_337404 = 0;
                    defunc_1_f_res_f_res_f_res_337405 = -1;
                } else {
                    int32_t x_337406;
                    
                    x_337406 = ((int32_t *) mem_param_316860.mem)[gtid_310551];
                    
                    int32_t defunc_1_f_res_f_res_f_res_f_res_337407 =
                            sub32(x_337406, lteq_len_337401);
                    int32_t defunc_1_f_res_f_res_f_res_f_res_337408 =
                            sub32(x_297170, lteq_len_337401);
                    
                    defunc_1_f_res_f_res_f_res_337404 =
                        defunc_1_f_res_f_res_f_res_f_res_337407;
                    defunc_1_f_res_f_res_f_res_337405 =
                        defunc_1_f_res_f_res_f_res_f_res_337408;
                }
                defunc_1_f_res_f_res_337392 = defunc_1_f_res_f_res_f_res_337404;
                defunc_1_f_res_f_res_337393 = defunc_1_f_res_f_res_f_res_337403;
                defunc_1_f_res_f_res_337394 = defunc_1_f_res_f_res_f_res_337405;
            }
            defunc_1_f_res_297173 = defunc_1_f_res_f_res_337392;
            defunc_1_f_res_297174 = defunc_1_f_res_f_res_337393;
            defunc_1_f_res_297175 = defunc_1_f_res_f_res_337394;
        }
        ((int32_t *) mem_316915.mem)[gtid_310551] = defunc_1_f_res_297173;
        ((int8_t *) mem_316917.mem)[gtid_310551] = defunc_1_f_res_297174;
        ((int32_t *) mem_316920.mem)[gtid_310551] = defunc_1_f_res_297175;
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339261_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339261_end -
                 futhark_mc_segmap_parloop_339261_start;
        
        ctx->futhark_mc_segmap_parloop_339261_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_339261_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_339261_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_339259(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_310550 = tid;
    int num_tasks_337383 = info.nsubtasks;
    struct futhark_mc_task_339258 *futhark_mc_task_339258 =
                                  (struct futhark_mc_task_339258 *) args;
    struct futhark_context *ctx = futhark_mc_task_339258->ctx;
    uint64_t futhark_mc_segmap_task_339259_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_339259_start = get_wall_time();
    
    int64_t partition_sizze_292766 =
            futhark_mc_task_339258->free_partition_sizze_292766;
    int64_t replicate_arg_297080 =
            futhark_mc_task_339258->free_replicate_arg_297080;
    struct memblock mem_param_316855 = {.desc ="mem_param_316855", .mem =
                                        futhark_mc_task_339258->free_mem_param_316855,
                                        .size =0, .references =NULL};
    struct memblock mem_param_316860 = {.desc ="mem_param_316860", .mem =
                                        futhark_mc_task_339258->free_mem_param_316860,
                                        .size =0, .references =NULL};
    struct memblock mem_316912 = {.desc ="mem_316912", .mem =
                                  futhark_mc_task_339258->free_mem_316912,
                                  .size =0, .references =NULL};
    struct memblock mem_316915 = {.desc ="mem_316915", .mem =
                                  futhark_mc_task_339258->free_mem_316915,
                                  .size =0, .references =NULL};
    struct memblock mem_316917 = {.desc ="mem_316917", .mem =
                                  futhark_mc_task_339258->free_mem_316917,
                                  .size =0, .references =NULL};
    struct memblock mem_316920 = {.desc ="mem_316920", .mem =
                                  futhark_mc_task_339258->free_mem_316920,
                                  .size =0, .references =NULL};
    int64_t iter_337384;
    struct futhark_mc_segmap_parloop_struct_339260
    futhark_mc_segmap_parloop_struct_339260;
    
    futhark_mc_segmap_parloop_struct_339260.ctx = ctx;
    futhark_mc_segmap_parloop_struct_339260.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_339260.free_replicate_arg_297080 =
        replicate_arg_297080;
    futhark_mc_segmap_parloop_struct_339260.free_mem_param_316855 =
        mem_param_316855.mem;
    futhark_mc_segmap_parloop_struct_339260.free_mem_param_316860 =
        mem_param_316860.mem;
    futhark_mc_segmap_parloop_struct_339260.free_mem_316912 = mem_316912.mem;
    futhark_mc_segmap_parloop_struct_339260.free_mem_316915 = mem_316915.mem;
    futhark_mc_segmap_parloop_struct_339260.free_mem_316917 = mem_316917.mem;
    futhark_mc_segmap_parloop_struct_339260.free_mem_316920 = mem_316920.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_339261_task;
    
    futhark_mc_segmap_parloop_339261_task.name =
        "futhark_mc_segmap_parloop_339261";
    futhark_mc_segmap_parloop_339261_task.fn = futhark_mc_segmap_parloop_339261;
    futhark_mc_segmap_parloop_339261_task.args =
        &futhark_mc_segmap_parloop_struct_339260;
    futhark_mc_segmap_parloop_339261_task.iterations = iterations;
    futhark_mc_segmap_parloop_339261_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_339261_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339261_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_339261_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_339261_task);
    
    if (futhark_mc_segmap_parloop_339261_err != 0) {
        err = futhark_mc_segmap_parloop_339261_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339261_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339261_total_end -
                 futhark_mc_segmap_parloop_339261_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339261_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339261_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339261_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_339259_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_339259_end -
                 futhark_mc_segmap_task_339259_start;
        
        ctx->futhark_mc_segmap_task_339259_runs[tid]++;
        ctx->futhark_mc_segmap_task_339259_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_339259_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_task_339262 {
    struct futhark_context *ctx;
    int64_t free_partition_sizze_292766;
    unsigned char *free_mem_316850;
    unsigned char *free_mem_316909;
    unsigned char *free_mem_316917;
};
struct futhark_mc_segmap_parloop_struct_339264 {
    struct futhark_context *ctx;
    int64_t free_partition_sizze_292766;
    unsigned char *free_mem_316850;
    unsigned char *free_mem_316909;
    unsigned char *free_mem_316917;
};
static int futhark_mc_segmap_parloop_339265(void *args, int64_t start,
                                            int64_t end, int flat_tid_310552,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_339264
    *futhark_mc_segmap_parloop_struct_339264 =
    (struct futhark_mc_segmap_parloop_struct_339264 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_339264->ctx;
    uint64_t futhark_mc_segmap_parloop_339265_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339265_start = get_wall_time();
    
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_339264->free_partition_sizze_292766;
    struct memblock mem_316850 = {.desc ="mem_316850", .mem =
                                  futhark_mc_segmap_parloop_struct_339264->free_mem_316850,
                                  .size =0, .references =NULL};
    struct memblock mem_316909 = {.desc ="mem_316909", .mem =
                                  futhark_mc_segmap_parloop_struct_339264->free_mem_316909,
                                  .size =0, .references =NULL};
    struct memblock mem_316917 = {.desc ="mem_316917", .mem =
                                  futhark_mc_segmap_parloop_struct_339264->free_mem_316917,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_337412 = start;
    
    for (; iter_337412 < end; iter_337412++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_337414 = partition_sizze_292766;
        int64_t gtid_310553 = iter_337412;
        int64_t remnant_337415 = iter_337412 - gtid_310553;
        int8_t x_297208;
        
        x_297208 = ((int8_t *) mem_316917.mem)[gtid_310553];
        
        bool cond_297209 = x_297208 == (int8_t) 1;
        int64_t defunc_1_f_res_297210;
        
        if (cond_297209) {
            defunc_1_f_res_297210 = gtid_310553;
        } else {
            defunc_1_f_res_297210 = (int64_t) -1;
        }
        
        double defunc_1_f_res_297211;
        
        if (cond_297209) {
            double defunc_1_f_res_t_res_337413;
            
            defunc_1_f_res_t_res_337413 =
                ((double *) mem_316909.mem)[gtid_310553];
            defunc_1_f_res_297211 = defunc_1_f_res_t_res_337413;
        } else {
            defunc_1_f_res_297211 = 0.0;
        }
        if (sle64((int64_t) 0, defunc_1_f_res_297210) &&
            slt64(defunc_1_f_res_297210, partition_sizze_292766)) {
            ((double *) mem_316850.mem)[defunc_1_f_res_297210] =
                defunc_1_f_res_297211;
        }
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339265_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339265_end -
                 futhark_mc_segmap_parloop_339265_start;
        
        ctx->futhark_mc_segmap_parloop_339265_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_339265_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_339265_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_339263(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_310552 = tid;
    int num_tasks_337411 = info.nsubtasks;
    struct futhark_mc_task_339262 *futhark_mc_task_339262 =
                                  (struct futhark_mc_task_339262 *) args;
    struct futhark_context *ctx = futhark_mc_task_339262->ctx;
    uint64_t futhark_mc_segmap_task_339263_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_339263_start = get_wall_time();
    
    int64_t partition_sizze_292766 =
            futhark_mc_task_339262->free_partition_sizze_292766;
    struct memblock mem_316850 = {.desc ="mem_316850", .mem =
                                  futhark_mc_task_339262->free_mem_316850,
                                  .size =0, .references =NULL};
    struct memblock mem_316909 = {.desc ="mem_316909", .mem =
                                  futhark_mc_task_339262->free_mem_316909,
                                  .size =0, .references =NULL};
    struct memblock mem_316917 = {.desc ="mem_316917", .mem =
                                  futhark_mc_task_339262->free_mem_316917,
                                  .size =0, .references =NULL};
    int64_t iter_337412;
    struct futhark_mc_segmap_parloop_struct_339264
    futhark_mc_segmap_parloop_struct_339264;
    
    futhark_mc_segmap_parloop_struct_339264.ctx = ctx;
    futhark_mc_segmap_parloop_struct_339264.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_339264.free_mem_316850 = mem_316850.mem;
    futhark_mc_segmap_parloop_struct_339264.free_mem_316909 = mem_316909.mem;
    futhark_mc_segmap_parloop_struct_339264.free_mem_316917 = mem_316917.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_339265_task;
    
    futhark_mc_segmap_parloop_339265_task.name =
        "futhark_mc_segmap_parloop_339265";
    futhark_mc_segmap_parloop_339265_task.fn = futhark_mc_segmap_parloop_339265;
    futhark_mc_segmap_parloop_339265_task.args =
        &futhark_mc_segmap_parloop_struct_339264;
    futhark_mc_segmap_parloop_339265_task.iterations = iterations;
    futhark_mc_segmap_parloop_339265_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_339265_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339265_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_339265_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_339265_task);
    
    if (futhark_mc_segmap_parloop_339265_err != 0) {
        err = futhark_mc_segmap_parloop_339265_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339265_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339265_total_end -
                 futhark_mc_segmap_parloop_339265_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339265_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339265_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339265_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_339263_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_339263_end -
                 futhark_mc_segmap_task_339263_start;
        
        ctx->futhark_mc_segmap_task_339263_runs[tid]++;
        ctx->futhark_mc_segmap_task_339263_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_339263_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_task_339266 {
    struct futhark_context *ctx;
    int64_t free_partition_sizze_292766;
    int64_t free_loopz2089U_297094;
    int64_t free_ctx_param_ext_316866;
    int64_t free_ctx_param_ext_316867;
    unsigned char *free_mem_param_316869;
    int64_t free_ctx_param_ext_316876;
    int64_t free_ctx_param_ext_316877;
    unsigned char *free_mem_param_316879;
    unsigned char *free_mem_316909;
    unsigned char *free_mem_316917;
    unsigned char *free_mem_316928;
};
struct futhark_mc_segmap_parloop_struct_339268 {
    struct futhark_context *ctx;
    int64_t free_partition_sizze_292766;
    int64_t free_loopz2089U_297094;
    int64_t free_ctx_param_ext_316866;
    int64_t free_ctx_param_ext_316867;
    unsigned char *free_mem_param_316869;
    int64_t free_ctx_param_ext_316876;
    int64_t free_ctx_param_ext_316877;
    unsigned char *free_mem_param_316879;
    unsigned char *free_mem_316909;
    unsigned char *free_mem_316917;
    unsigned char *free_mem_316928;
};
static int futhark_mc_segmap_parloop_339269(void *args, int64_t start,
                                            int64_t end, int flat_tid_310554,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_339268
    *futhark_mc_segmap_parloop_struct_339268 =
    (struct futhark_mc_segmap_parloop_struct_339268 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_339268->ctx;
    uint64_t futhark_mc_segmap_parloop_339269_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339269_start = get_wall_time();
    
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_339268->free_partition_sizze_292766;
    int64_t loopz2089U_297094 =
            futhark_mc_segmap_parloop_struct_339268->free_loopz2089U_297094;
    int64_t ctx_param_ext_316866 =
            futhark_mc_segmap_parloop_struct_339268->free_ctx_param_ext_316866;
    int64_t ctx_param_ext_316867 =
            futhark_mc_segmap_parloop_struct_339268->free_ctx_param_ext_316867;
    struct memblock mem_param_316869 = {.desc ="mem_param_316869", .mem =
                                        futhark_mc_segmap_parloop_struct_339268->free_mem_param_316869,
                                        .size =0, .references =NULL};
    int64_t ctx_param_ext_316876 =
            futhark_mc_segmap_parloop_struct_339268->free_ctx_param_ext_316876;
    int64_t ctx_param_ext_316877 =
            futhark_mc_segmap_parloop_struct_339268->free_ctx_param_ext_316877;
    struct memblock mem_param_316879 = {.desc ="mem_param_316879", .mem =
                                        futhark_mc_segmap_parloop_struct_339268->free_mem_param_316879,
                                        .size =0, .references =NULL};
    struct memblock mem_316909 = {.desc ="mem_316909", .mem =
                                  futhark_mc_segmap_parloop_struct_339268->free_mem_316909,
                                  .size =0, .references =NULL};
    struct memblock mem_316917 = {.desc ="mem_316917", .mem =
                                  futhark_mc_segmap_parloop_struct_339268->free_mem_316917,
                                  .size =0, .references =NULL};
    struct memblock mem_316928 = {.desc ="mem_316928", .mem =
                                  futhark_mc_segmap_parloop_struct_339268->free_mem_316928,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_337417 = start;
    
    for (; iter_337417 < end; iter_337417++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_337418 = loopz2089U_297094;
        int64_t gtid_310555 = iter_337417;
        int64_t remnant_337419 = iter_337417 - gtid_310555;
        int32_t x_297218;
        
        x_297218 = ((int32_t *) mem_param_316869.mem)[ctx_param_ext_316866 +
                                                      gtid_310555 *
                                                      ctx_param_ext_316867];
        
        double x_297219;
        
        x_297219 = ((double *) mem_param_316879.mem)[ctx_param_ext_316876 +
                                                     gtid_310555 *
                                                     ctx_param_ext_316877];
        
        int32_t sgmind_297220 = sub32(x_297218, 1);
        int64_t sgmind_297221 = sext_i32_i64(sgmind_297220);
        bool x_297222 = sle64((int64_t) 0, sgmind_297221);
        bool y_297223 = slt64(sgmind_297221, partition_sizze_292766);
        bool bounds_check_297224 = x_297222 && y_297223;
        bool index_certs_297225;
        
        if (!bounds_check_297224) {
            ctx->error = msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                   "Index [", (long long) sgmind_297221,
                                   "] out of bounds for array of shape [",
                                   (long long) partition_sizze_292766, "].",
                                   "-> #0  median.fut:80:23-36\n   #1  /prelude/soacs.fut:67:19-23\n   #2  /prelude/soacs.fut:67:3-37\n   #3  median.fut:84:21-39\n   #4  median.fut:112:18-67\n   #5  stl.fut:343:23-52\n   #6  stl.fut:419:61-435:77\n   #7  stl.fut:463:3-479:36\n   #8  stl.fut:445:1-479:36\n");
            err = FUTHARK_PROGRAM_ERROR;
            goto cleanup;
        }
        
        double pivot_297226;
        
        pivot_297226 = ((double *) mem_316909.mem)[sgmind_297221];
        
        int8_t kind_297227;
        
        kind_297227 = ((int8_t *) mem_316917.mem)[sgmind_297221];
        
        bool cond_297228 = x_297219 < pivot_297226;
        bool cond_t_res_297229 = kind_297227 == (int8_t) 0;
        bool x_297230 = cond_297228 && cond_t_res_297229;
        bool cond_297231 = pivot_297226 < x_297219;
        bool defunc_1_f_res_f_res_t_res_297232 = kind_297227 == (int8_t) 2;
        bool x_297233 = cond_297231 && defunc_1_f_res_f_res_t_res_297232;
        bool x_297234 = !x_297230;
        bool y_297235 = x_297233 && x_297234;
        bool defunc_1_f_res_297236 = x_297230 || y_297235;
        
        ((bool *) mem_316928.mem)[gtid_310555] = defunc_1_f_res_297236;
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339269_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339269_end -
                 futhark_mc_segmap_parloop_339269_start;
        
        ctx->futhark_mc_segmap_parloop_339269_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_339269_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_339269_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_339267(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_310554 = tid;
    int num_tasks_337416 = info.nsubtasks;
    struct futhark_mc_task_339266 *futhark_mc_task_339266 =
                                  (struct futhark_mc_task_339266 *) args;
    struct futhark_context *ctx = futhark_mc_task_339266->ctx;
    uint64_t futhark_mc_segmap_task_339267_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_339267_start = get_wall_time();
    
    int64_t partition_sizze_292766 =
            futhark_mc_task_339266->free_partition_sizze_292766;
    int64_t loopz2089U_297094 = futhark_mc_task_339266->free_loopz2089U_297094;
    int64_t ctx_param_ext_316866 =
            futhark_mc_task_339266->free_ctx_param_ext_316866;
    int64_t ctx_param_ext_316867 =
            futhark_mc_task_339266->free_ctx_param_ext_316867;
    struct memblock mem_param_316869 = {.desc ="mem_param_316869", .mem =
                                        futhark_mc_task_339266->free_mem_param_316869,
                                        .size =0, .references =NULL};
    int64_t ctx_param_ext_316876 =
            futhark_mc_task_339266->free_ctx_param_ext_316876;
    int64_t ctx_param_ext_316877 =
            futhark_mc_task_339266->free_ctx_param_ext_316877;
    struct memblock mem_param_316879 = {.desc ="mem_param_316879", .mem =
                                        futhark_mc_task_339266->free_mem_param_316879,
                                        .size =0, .references =NULL};
    struct memblock mem_316909 = {.desc ="mem_316909", .mem =
                                  futhark_mc_task_339266->free_mem_316909,
                                  .size =0, .references =NULL};
    struct memblock mem_316917 = {.desc ="mem_316917", .mem =
                                  futhark_mc_task_339266->free_mem_316917,
                                  .size =0, .references =NULL};
    struct memblock mem_316928 = {.desc ="mem_316928", .mem =
                                  futhark_mc_task_339266->free_mem_316928,
                                  .size =0, .references =NULL};
    int64_t iter_337417;
    struct futhark_mc_segmap_parloop_struct_339268
    futhark_mc_segmap_parloop_struct_339268;
    
    futhark_mc_segmap_parloop_struct_339268.ctx = ctx;
    futhark_mc_segmap_parloop_struct_339268.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_339268.free_loopz2089U_297094 =
        loopz2089U_297094;
    futhark_mc_segmap_parloop_struct_339268.free_ctx_param_ext_316866 =
        ctx_param_ext_316866;
    futhark_mc_segmap_parloop_struct_339268.free_ctx_param_ext_316867 =
        ctx_param_ext_316867;
    futhark_mc_segmap_parloop_struct_339268.free_mem_param_316869 =
        mem_param_316869.mem;
    futhark_mc_segmap_parloop_struct_339268.free_ctx_param_ext_316876 =
        ctx_param_ext_316876;
    futhark_mc_segmap_parloop_struct_339268.free_ctx_param_ext_316877 =
        ctx_param_ext_316877;
    futhark_mc_segmap_parloop_struct_339268.free_mem_param_316879 =
        mem_param_316879.mem;
    futhark_mc_segmap_parloop_struct_339268.free_mem_316909 = mem_316909.mem;
    futhark_mc_segmap_parloop_struct_339268.free_mem_316917 = mem_316917.mem;
    futhark_mc_segmap_parloop_struct_339268.free_mem_316928 = mem_316928.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_339269_task;
    
    futhark_mc_segmap_parloop_339269_task.name =
        "futhark_mc_segmap_parloop_339269";
    futhark_mc_segmap_parloop_339269_task.fn = futhark_mc_segmap_parloop_339269;
    futhark_mc_segmap_parloop_339269_task.args =
        &futhark_mc_segmap_parloop_struct_339268;
    futhark_mc_segmap_parloop_339269_task.iterations = iterations;
    futhark_mc_segmap_parloop_339269_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_339269_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339269_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_339269_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_339269_task);
    
    if (futhark_mc_segmap_parloop_339269_err != 0) {
        err = futhark_mc_segmap_parloop_339269_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339269_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339269_total_end -
                 futhark_mc_segmap_parloop_339269_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339269_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339269_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339269_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_339267_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_339267_end -
                 futhark_mc_segmap_task_339267_start;
        
        ctx->futhark_mc_segmap_task_339267_runs[tid]++;
        ctx->futhark_mc_segmap_task_339267_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_339267_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_task_339270 {
    struct futhark_context *ctx;
    int64_t free_loopz2089U_297094;
    unsigned char *free_mem_316928;
    unsigned char *free_mem_316931;
};
struct futhark_mc_scan_stage_1_parloop_struct_339273 {
    struct futhark_context *ctx;
    unsigned char *free_mem_316928;
    unsigned char *free_mem_316931;
};
static int futhark_mc_scan_stage_1_parloop_339274(void *args, int64_t start,
                                                  int64_t end,
                                                  int flat_tid_310556, int tid)
{
    int err = 0;
    struct futhark_mc_scan_stage_1_parloop_struct_339273
    *futhark_mc_scan_stage_1_parloop_struct_339273 =
    (struct futhark_mc_scan_stage_1_parloop_struct_339273 *) args;
    struct futhark_context *ctx =
                           futhark_mc_scan_stage_1_parloop_struct_339273->ctx;
    uint64_t futhark_mc_scan_stage_1_parloop_339274_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_scan_stage_1_parloop_339274_start = get_wall_time();
    
    struct memblock mem_316928 = {.desc ="mem_316928", .mem =
                                  futhark_mc_scan_stage_1_parloop_struct_339273->free_mem_316928,
                                  .size =0, .references =NULL};
    struct memblock mem_316931 = {.desc ="mem_316931", .mem =
                                  futhark_mc_scan_stage_1_parloop_struct_339273->free_mem_316931,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_337421 = start;
    int32_t x_297239;
    int32_t x_297240;
    
    x_297239 = 0;
    for (; iter_337421 < end; iter_337421++) {
        int64_t gtid_310557 = iter_337421;
        
        // stage 1 scan body
        {
            bool x_297242;
            
            x_297242 = ((bool *) mem_316928.mem)[gtid_310557];
            
            int32_t defunc_0_f_res_297243 = btoi_bool_i32(x_297242);
            
            // write mapped values results to memory
            { }
            x_297239 = x_297239;
            // Read next values
            {
                x_297240 = defunc_0_f_res_297243;
            }
            
            int32_t defunc_1_op_res_297241 = add32(x_297239, x_297240);
            
            ((int32_t *) mem_316931.mem)[gtid_310557] = defunc_1_op_res_297241;
            x_297239 = defunc_1_op_res_297241;
        }
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_scan_stage_1_parloop_339274_end = get_wall_time();
        uint64_t elapsed = futhark_mc_scan_stage_1_parloop_339274_end -
                 futhark_mc_scan_stage_1_parloop_339274_start;
        
        ctx->futhark_mc_scan_stage_1_parloop_339274_runs[tid]++;
        ctx->futhark_mc_scan_stage_1_parloop_339274_total_runtime[tid] +=
            elapsed;
        ctx->futhark_mc_scan_stage_1_parloop_339274_iter[tid] += iterations;
    }
    return err;
}
struct futhark_mc_scan_stage_3_parloop_struct_339275 {
    struct futhark_context *ctx;
    unsigned char *free_mem_316928;
    unsigned char *free_mem_316931;
};
static int futhark_mc_scan_stage_3_parloop_339276(void *args, int64_t start,
                                                  int64_t end,
                                                  int flat_tid_310556, int tid)
{
    int err = 0;
    struct futhark_mc_scan_stage_3_parloop_struct_339275
    *futhark_mc_scan_stage_3_parloop_struct_339275 =
    (struct futhark_mc_scan_stage_3_parloop_struct_339275 *) args;
    struct futhark_context *ctx =
                           futhark_mc_scan_stage_3_parloop_struct_339275->ctx;
    uint64_t futhark_mc_scan_stage_3_parloop_339276_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_scan_stage_3_parloop_339276_start = get_wall_time();
    
    struct memblock mem_316928 = {.desc ="mem_316928", .mem =
                                  futhark_mc_scan_stage_3_parloop_struct_339275->free_mem_316928,
                                  .size =0, .references =NULL};
    struct memblock mem_316931 = {.desc ="mem_316931", .mem =
                                  futhark_mc_scan_stage_3_parloop_struct_339275->free_mem_316931,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_337433 = start;
    int32_t x_337430;
    int32_t x_337431;
    
    if (iter_337433 == (int64_t) 0) {
        x_337430 = 0;
    } else {
        x_337430 = ((int32_t *) mem_316931.mem)[iter_337433 - (int64_t) 1];
    }
    for (; iter_337433 < end; iter_337433++) {
        int64_t gtid_310557 = iter_337433;
        
        // stage 3 scan body
        {
            bool x_297242;
            
            x_297242 = ((bool *) mem_316928.mem)[gtid_310557];
            
            int32_t defunc_0_f_res_297243 = btoi_bool_i32(x_297242);
            
            x_337430 = x_337430;
            x_337431 = defunc_0_f_res_297243;
            
            int32_t defunc_1_op_res_337432 = add32(x_337430, x_337431);
            
            ((int32_t *) mem_316931.mem)[gtid_310557] = defunc_1_op_res_337432;
            x_337430 = defunc_1_op_res_337432;
        }
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_scan_stage_3_parloop_339276_end = get_wall_time();
        uint64_t elapsed = futhark_mc_scan_stage_3_parloop_339276_end -
                 futhark_mc_scan_stage_3_parloop_339276_start;
        
        ctx->futhark_mc_scan_stage_3_parloop_339276_runs[tid]++;
        ctx->futhark_mc_scan_stage_3_parloop_339276_total_runtime[tid] +=
            elapsed;
        ctx->futhark_mc_scan_stage_3_parloop_339276_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segscan_task_339271(void *args, int64_t iterations, int tid,
                                   struct scheduler_info info)
{
    int err = 0;
    int flat_tid_310556 = tid;
    int num_tasks_337420 = info.nsubtasks;
    struct futhark_mc_task_339270 *futhark_mc_task_339270 =
                                  (struct futhark_mc_task_339270 *) args;
    struct futhark_context *ctx = futhark_mc_task_339270->ctx;
    uint64_t futhark_mc_segscan_task_339271_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segscan_task_339271_start = get_wall_time();
    
    int64_t loopz2089U_297094 = futhark_mc_task_339270->free_loopz2089U_297094;
    struct memblock mem_316928 = {.desc ="mem_316928", .mem =
                                  futhark_mc_task_339270->free_mem_316928,
                                  .size =0, .references =NULL};
    struct memblock mem_316931 = {.desc ="mem_316931", .mem =
                                  futhark_mc_task_339270->free_mem_316931,
                                  .size =0, .references =NULL};
    size_t scan_stage_2_accum_mem_337427_cached_sizze_339272 = 0;
    unsigned char *scan_stage_2_accum_mem_337427 = NULL;
    int64_t iter_337421;
    struct futhark_mc_scan_stage_1_parloop_struct_339273
    futhark_mc_scan_stage_1_parloop_struct_339273;
    
    futhark_mc_scan_stage_1_parloop_struct_339273.ctx = ctx;
    futhark_mc_scan_stage_1_parloop_struct_339273.free_mem_316928 =
        mem_316928.mem;
    futhark_mc_scan_stage_1_parloop_struct_339273.free_mem_316931 =
        mem_316931.mem;
    
    struct scheduler_parloop futhark_mc_scan_stage_1_parloop_339274_task;
    
    futhark_mc_scan_stage_1_parloop_339274_task.name =
        "futhark_mc_scan_stage_1_parloop_339274";
    futhark_mc_scan_stage_1_parloop_339274_task.fn =
        futhark_mc_scan_stage_1_parloop_339274;
    futhark_mc_scan_stage_1_parloop_339274_task.args =
        &futhark_mc_scan_stage_1_parloop_struct_339273;
    futhark_mc_scan_stage_1_parloop_339274_task.iterations = iterations;
    futhark_mc_scan_stage_1_parloop_339274_task.info = info;
    
    uint64_t futhark_mc_scan_stage_1_parloop_339274_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_scan_stage_1_parloop_339274_total_start = get_wall_time();
    
    int futhark_mc_scan_stage_1_parloop_339274_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_scan_stage_1_parloop_339274_task);
    
    if (futhark_mc_scan_stage_1_parloop_339274_err != 0) {
        err = futhark_mc_scan_stage_1_parloop_339274_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_scan_stage_1_parloop_339274_total_end =
                 get_wall_time();
        uint64_t elapsed = futhark_mc_scan_stage_1_parloop_339274_total_end -
                 futhark_mc_scan_stage_1_parloop_339274_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_scan_stage_1_parloop_339274_total_runs,
                           1, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_scan_stage_1_parloop_339274_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_scan_stage_1_parloop_339274_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    if (slt32(1, num_tasks_337420)) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "nonsegmentedScan stage 2");
        
        int32_t x_337422;
        int32_t x_337423;
        int64_t offset_337425 = (int64_t) 0;
        int64_t offset_index_337426 = (int64_t) 0;
        
        if (scan_stage_2_accum_mem_337427_cached_sizze_339272 <
            (size_t) (int64_t) 4) {
            scan_stage_2_accum_mem_337427 =
                realloc(scan_stage_2_accum_mem_337427, (int64_t) 4);
            scan_stage_2_accum_mem_337427_cached_sizze_339272 = (int64_t) 4;
        }
        ((int32_t *) scan_stage_2_accum_mem_337427)[(int64_t) 0] = 0;
        for (int32_t i_337429 = 0; i_337429 < num_tasks_337420 - 1;
             i_337429++) {
            offset_337425 = squot64(loopz2089U_297094,
                                    sext_i32_i64(num_tasks_337420));
            if (slt64(sext_i32_i64(i_337429), srem64(loopz2089U_297094,
                                                     sext_i32_i64(num_tasks_337420)))) {
                offset_337425 += (int64_t) 1;
            }
            offset_index_337426 += offset_337425;
            
            int64_t gtid_310557 = offset_index_337426;
            bool x_297242;
            
            x_297242 = ((bool *) mem_316928.mem)[gtid_310557];
            
            int32_t defunc_0_f_res_297243 = btoi_bool_i32(x_297242);
            
            // Read carry in
            {
                x_337422 =
                    ((int32_t *) scan_stage_2_accum_mem_337427)[(int64_t) 0];
            }
            // Read next values
            {
                x_337423 = ((int32_t *) mem_316931.mem)[offset_index_337426 -
                                                        (int64_t) 1];
            }
            
            int32_t defunc_1_op_res_337424 = add32(x_337422, x_337423);
            
            ((int32_t *) mem_316931.mem)[offset_index_337426 - (int64_t) 1] =
                defunc_1_op_res_337424;
            ((int32_t *) scan_stage_2_accum_mem_337427)[(int64_t) 0] =
                defunc_1_op_res_337424;
        }
        
        int64_t iter_337433 = (int64_t) 0;
        struct futhark_mc_scan_stage_3_parloop_struct_339275
        futhark_mc_scan_stage_3_parloop_struct_339275;
        
        futhark_mc_scan_stage_3_parloop_struct_339275.ctx = ctx;
        futhark_mc_scan_stage_3_parloop_struct_339275.free_mem_316928 =
            mem_316928.mem;
        futhark_mc_scan_stage_3_parloop_struct_339275.free_mem_316931 =
            mem_316931.mem;
        
        struct scheduler_parloop futhark_mc_scan_stage_3_parloop_339276_task;
        
        futhark_mc_scan_stage_3_parloop_339276_task.name =
            "futhark_mc_scan_stage_3_parloop_339276";
        futhark_mc_scan_stage_3_parloop_339276_task.fn =
            futhark_mc_scan_stage_3_parloop_339276;
        futhark_mc_scan_stage_3_parloop_339276_task.args =
            &futhark_mc_scan_stage_3_parloop_struct_339275;
        futhark_mc_scan_stage_3_parloop_339276_task.iterations = iterations;
        futhark_mc_scan_stage_3_parloop_339276_task.info = info;
        
        uint64_t futhark_mc_scan_stage_3_parloop_339276_total_start = 0;
        
        if (ctx->profiling && !ctx->profiling_paused)
            futhark_mc_scan_stage_3_parloop_339276_total_start =
                get_wall_time();
        
        int futhark_mc_scan_stage_3_parloop_339276_err =
            scheduler_execute_task(&ctx->scheduler,
                                   &futhark_mc_scan_stage_3_parloop_339276_task);
        
        if (futhark_mc_scan_stage_3_parloop_339276_err != 0) {
            err = futhark_mc_scan_stage_3_parloop_339276_err;
            goto cleanup;
        }
        if (ctx->profiling && !ctx->profiling_paused) {
            uint64_t futhark_mc_scan_stage_3_parloop_339276_total_end =
                     get_wall_time();
            uint64_t elapsed =
                     futhark_mc_scan_stage_3_parloop_339276_total_end -
                     futhark_mc_scan_stage_3_parloop_339276_total_start;
            
            __atomic_fetch_add(&ctx->futhark_mc_scan_stage_3_parloop_339276_total_runs,
                               1, __ATOMIC_RELAXED);
            __atomic_fetch_add(&ctx->futhark_mc_scan_stage_3_parloop_339276_total_total_runtime,
                               elapsed, __ATOMIC_RELAXED);
            __atomic_fetch_add(&ctx->futhark_mc_scan_stage_3_parloop_339276_total_iter,
                               iterations, __ATOMIC_RELAXED);
        }
    }
    
  cleanup:
    {
        free(scan_stage_2_accum_mem_337427);
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segscan_task_339271_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segscan_task_339271_end -
                 futhark_mc_segscan_task_339271_start;
        
        ctx->futhark_mc_segscan_task_339271_runs[tid]++;
        ctx->futhark_mc_segscan_task_339271_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segscan_task_339271_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_task_339277 {
    struct futhark_context *ctx;
    int64_t free_loopz2088U_297093;
    int64_t free_loopz2089U_297094;
    int64_t free_loopz2081Uz2080U_297095;
    int64_t free_ctx_param_ext_316866;
    int64_t free_ctx_param_ext_316867;
    unsigned char *free_mem_param_316869;
    int64_t free_ctx_param_ext_316871;
    int64_t free_ctx_param_ext_316872;
    unsigned char *free_mem_param_316874;
    int64_t free_ctx_param_ext_316876;
    int64_t free_ctx_param_ext_316877;
    unsigned char *free_mem_param_316879;
    int64_t free_ctx_param_ext_316881;
    int64_t free_ctx_param_ext_316882;
    unsigned char *free_mem_param_316884;
    unsigned char *free_mem_316928;
    unsigned char *free_mem_316931;
};
struct futhark_mc_segmap_parloop_struct_339279 {
    struct futhark_context *ctx;
    int64_t free_loopz2088U_297093;
    int64_t free_loopz2089U_297094;
    int64_t free_loopz2081Uz2080U_297095;
    int64_t free_ctx_param_ext_316866;
    int64_t free_ctx_param_ext_316867;
    unsigned char *free_mem_param_316869;
    int64_t free_ctx_param_ext_316871;
    int64_t free_ctx_param_ext_316872;
    unsigned char *free_mem_param_316874;
    int64_t free_ctx_param_ext_316876;
    int64_t free_ctx_param_ext_316877;
    unsigned char *free_mem_param_316879;
    int64_t free_ctx_param_ext_316881;
    int64_t free_ctx_param_ext_316882;
    unsigned char *free_mem_param_316884;
    unsigned char *free_mem_316928;
    unsigned char *free_mem_316931;
};
static int futhark_mc_segmap_parloop_339280(void *args, int64_t start,
                                            int64_t end, int flat_tid_310558,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_339279
    *futhark_mc_segmap_parloop_struct_339279 =
    (struct futhark_mc_segmap_parloop_struct_339279 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_339279->ctx;
    uint64_t futhark_mc_segmap_parloop_339280_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339280_start = get_wall_time();
    
    int64_t loopz2088U_297093 =
            futhark_mc_segmap_parloop_struct_339279->free_loopz2088U_297093;
    int64_t loopz2089U_297094 =
            futhark_mc_segmap_parloop_struct_339279->free_loopz2089U_297094;
    int64_t loopz2081Uz2080U_297095 =
            futhark_mc_segmap_parloop_struct_339279->free_loopz2081Uz2080U_297095;
    int64_t ctx_param_ext_316866 =
            futhark_mc_segmap_parloop_struct_339279->free_ctx_param_ext_316866;
    int64_t ctx_param_ext_316867 =
            futhark_mc_segmap_parloop_struct_339279->free_ctx_param_ext_316867;
    struct memblock mem_param_316869 = {.desc ="mem_param_316869", .mem =
                                        futhark_mc_segmap_parloop_struct_339279->free_mem_param_316869,
                                        .size =0, .references =NULL};
    int64_t ctx_param_ext_316871 =
            futhark_mc_segmap_parloop_struct_339279->free_ctx_param_ext_316871;
    int64_t ctx_param_ext_316872 =
            futhark_mc_segmap_parloop_struct_339279->free_ctx_param_ext_316872;
    struct memblock mem_param_316874 = {.desc ="mem_param_316874", .mem =
                                        futhark_mc_segmap_parloop_struct_339279->free_mem_param_316874,
                                        .size =0, .references =NULL};
    int64_t ctx_param_ext_316876 =
            futhark_mc_segmap_parloop_struct_339279->free_ctx_param_ext_316876;
    int64_t ctx_param_ext_316877 =
            futhark_mc_segmap_parloop_struct_339279->free_ctx_param_ext_316877;
    struct memblock mem_param_316879 = {.desc ="mem_param_316879", .mem =
                                        futhark_mc_segmap_parloop_struct_339279->free_mem_param_316879,
                                        .size =0, .references =NULL};
    int64_t ctx_param_ext_316881 =
            futhark_mc_segmap_parloop_struct_339279->free_ctx_param_ext_316881;
    int64_t ctx_param_ext_316882 =
            futhark_mc_segmap_parloop_struct_339279->free_ctx_param_ext_316882;
    struct memblock mem_param_316884 = {.desc ="mem_param_316884", .mem =
                                        futhark_mc_segmap_parloop_struct_339279->free_mem_param_316884,
                                        .size =0, .references =NULL};
    struct memblock mem_316928 = {.desc ="mem_316928", .mem =
                                  futhark_mc_segmap_parloop_struct_339279->free_mem_316928,
                                  .size =0, .references =NULL};
    struct memblock mem_316931 = {.desc ="mem_316931", .mem =
                                  futhark_mc_segmap_parloop_struct_339279->free_mem_316931,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_337435 = start;
    
    for (; iter_337435 < end; iter_337435++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_337439 = loopz2089U_297094;
        int64_t gtid_310559 = iter_337435;
        int64_t remnant_337440 = iter_337435 - gtid_310559;
        bool x_297253;
        
        x_297253 = ((bool *) mem_316928.mem)[gtid_310559];
        
        int32_t write_value_297255;
        
        write_value_297255 =
            ((int32_t *) mem_param_316869.mem)[ctx_param_ext_316866 +
                                               gtid_310559 *
                                               ctx_param_ext_316867];
        
        double write_value_297256;
        
        write_value_297256 =
            ((double *) mem_param_316879.mem)[ctx_param_ext_316876 +
                                              gtid_310559 *
                                              ctx_param_ext_316877];
        
        int64_t defunc_1_f_res_297257;
        
        if (x_297253) {
            int32_t x_337436;
            
            x_337436 = ((int32_t *) mem_316931.mem)[gtid_310559];
            
            int32_t i32_arg_337437 = sub32(x_337436, 1);
            int64_t i32_res_337438 = sext_i32_i64(i32_arg_337437);
            
            defunc_1_f_res_297257 = i32_res_337438;
        } else {
            defunc_1_f_res_297257 = (int64_t) -1;
        }
        if (sle64((int64_t) 0, defunc_1_f_res_297257) &&
            slt64(defunc_1_f_res_297257, loopz2088U_297093)) {
            ((int32_t *) mem_param_316874.mem)[ctx_param_ext_316871 +
                                               defunc_1_f_res_297257 *
                                               ctx_param_ext_316872] =
                write_value_297255;
        }
        if (sle64((int64_t) 0, defunc_1_f_res_297257) &&
            slt64(defunc_1_f_res_297257, loopz2081Uz2080U_297095)) {
            ((double *) mem_param_316884.mem)[ctx_param_ext_316881 +
                                              defunc_1_f_res_297257 *
                                              ctx_param_ext_316882] =
                write_value_297256;
        }
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339280_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339280_end -
                 futhark_mc_segmap_parloop_339280_start;
        
        ctx->futhark_mc_segmap_parloop_339280_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_339280_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_339280_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_339278(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_310558 = tid;
    int num_tasks_337434 = info.nsubtasks;
    struct futhark_mc_task_339277 *futhark_mc_task_339277 =
                                  (struct futhark_mc_task_339277 *) args;
    struct futhark_context *ctx = futhark_mc_task_339277->ctx;
    uint64_t futhark_mc_segmap_task_339278_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_339278_start = get_wall_time();
    
    int64_t loopz2088U_297093 = futhark_mc_task_339277->free_loopz2088U_297093;
    int64_t loopz2089U_297094 = futhark_mc_task_339277->free_loopz2089U_297094;
    int64_t loopz2081Uz2080U_297095 =
            futhark_mc_task_339277->free_loopz2081Uz2080U_297095;
    int64_t ctx_param_ext_316866 =
            futhark_mc_task_339277->free_ctx_param_ext_316866;
    int64_t ctx_param_ext_316867 =
            futhark_mc_task_339277->free_ctx_param_ext_316867;
    struct memblock mem_param_316869 = {.desc ="mem_param_316869", .mem =
                                        futhark_mc_task_339277->free_mem_param_316869,
                                        .size =0, .references =NULL};
    int64_t ctx_param_ext_316871 =
            futhark_mc_task_339277->free_ctx_param_ext_316871;
    int64_t ctx_param_ext_316872 =
            futhark_mc_task_339277->free_ctx_param_ext_316872;
    struct memblock mem_param_316874 = {.desc ="mem_param_316874", .mem =
                                        futhark_mc_task_339277->free_mem_param_316874,
                                        .size =0, .references =NULL};
    int64_t ctx_param_ext_316876 =
            futhark_mc_task_339277->free_ctx_param_ext_316876;
    int64_t ctx_param_ext_316877 =
            futhark_mc_task_339277->free_ctx_param_ext_316877;
    struct memblock mem_param_316879 = {.desc ="mem_param_316879", .mem =
                                        futhark_mc_task_339277->free_mem_param_316879,
                                        .size =0, .references =NULL};
    int64_t ctx_param_ext_316881 =
            futhark_mc_task_339277->free_ctx_param_ext_316881;
    int64_t ctx_param_ext_316882 =
            futhark_mc_task_339277->free_ctx_param_ext_316882;
    struct memblock mem_param_316884 = {.desc ="mem_param_316884", .mem =
                                        futhark_mc_task_339277->free_mem_param_316884,
                                        .size =0, .references =NULL};
    struct memblock mem_316928 = {.desc ="mem_316928", .mem =
                                  futhark_mc_task_339277->free_mem_316928,
                                  .size =0, .references =NULL};
    struct memblock mem_316931 = {.desc ="mem_316931", .mem =
                                  futhark_mc_task_339277->free_mem_316931,
                                  .size =0, .references =NULL};
    int64_t iter_337435;
    struct futhark_mc_segmap_parloop_struct_339279
    futhark_mc_segmap_parloop_struct_339279;
    
    futhark_mc_segmap_parloop_struct_339279.ctx = ctx;
    futhark_mc_segmap_parloop_struct_339279.free_loopz2088U_297093 =
        loopz2088U_297093;
    futhark_mc_segmap_parloop_struct_339279.free_loopz2089U_297094 =
        loopz2089U_297094;
    futhark_mc_segmap_parloop_struct_339279.free_loopz2081Uz2080U_297095 =
        loopz2081Uz2080U_297095;
    futhark_mc_segmap_parloop_struct_339279.free_ctx_param_ext_316866 =
        ctx_param_ext_316866;
    futhark_mc_segmap_parloop_struct_339279.free_ctx_param_ext_316867 =
        ctx_param_ext_316867;
    futhark_mc_segmap_parloop_struct_339279.free_mem_param_316869 =
        mem_param_316869.mem;
    futhark_mc_segmap_parloop_struct_339279.free_ctx_param_ext_316871 =
        ctx_param_ext_316871;
    futhark_mc_segmap_parloop_struct_339279.free_ctx_param_ext_316872 =
        ctx_param_ext_316872;
    futhark_mc_segmap_parloop_struct_339279.free_mem_param_316874 =
        mem_param_316874.mem;
    futhark_mc_segmap_parloop_struct_339279.free_ctx_param_ext_316876 =
        ctx_param_ext_316876;
    futhark_mc_segmap_parloop_struct_339279.free_ctx_param_ext_316877 =
        ctx_param_ext_316877;
    futhark_mc_segmap_parloop_struct_339279.free_mem_param_316879 =
        mem_param_316879.mem;
    futhark_mc_segmap_parloop_struct_339279.free_ctx_param_ext_316881 =
        ctx_param_ext_316881;
    futhark_mc_segmap_parloop_struct_339279.free_ctx_param_ext_316882 =
        ctx_param_ext_316882;
    futhark_mc_segmap_parloop_struct_339279.free_mem_param_316884 =
        mem_param_316884.mem;
    futhark_mc_segmap_parloop_struct_339279.free_mem_316928 = mem_316928.mem;
    futhark_mc_segmap_parloop_struct_339279.free_mem_316931 = mem_316931.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_339280_task;
    
    futhark_mc_segmap_parloop_339280_task.name =
        "futhark_mc_segmap_parloop_339280";
    futhark_mc_segmap_parloop_339280_task.fn = futhark_mc_segmap_parloop_339280;
    futhark_mc_segmap_parloop_339280_task.args =
        &futhark_mc_segmap_parloop_struct_339279;
    futhark_mc_segmap_parloop_339280_task.iterations = iterations;
    futhark_mc_segmap_parloop_339280_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_339280_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339280_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_339280_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_339280_task);
    
    if (futhark_mc_segmap_parloop_339280_err != 0) {
        err = futhark_mc_segmap_parloop_339280_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339280_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339280_total_end -
                 futhark_mc_segmap_parloop_339280_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339280_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339280_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339280_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_339278_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_339278_end -
                 futhark_mc_segmap_task_339278_start;
        
        ctx->futhark_mc_segmap_task_339278_runs[tid]++;
        ctx->futhark_mc_segmap_task_339278_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_339278_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_task_339281 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_partition_sizze_292766;
    unsigned char *free_mem_312639;
    unsigned char *free_mem_316815;
    unsigned char *free_mem_316835;
    unsigned char *free_mem_316850;
    unsigned char *free_mem_316973;
    unsigned char *free_mem_316976;
    unsigned char *free_mem_316979;
};
struct futhark_mc_segmap_parloop_struct_339283 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_partition_sizze_292766;
    unsigned char *free_mem_312639;
    unsigned char *free_mem_316815;
    unsigned char *free_mem_316835;
    unsigned char *free_mem_316850;
    unsigned char *free_mem_316973;
    unsigned char *free_mem_316976;
    unsigned char *free_mem_316979;
};
static int futhark_mc_segmap_parloop_339284(void *args, int64_t start,
                                            int64_t end, int flat_tid_310560,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_339283
    *futhark_mc_segmap_parloop_struct_339283 =
    (struct futhark_mc_segmap_parloop_struct_339283 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_339283->ctx;
    uint64_t futhark_mc_segmap_parloop_339284_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339284_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_339283->free_n_292675;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_339283->free_partition_sizze_292766;
    struct memblock mem_312639 = {.desc ="mem_312639", .mem =
                                  futhark_mc_segmap_parloop_struct_339283->free_mem_312639,
                                  .size =0, .references =NULL};
    struct memblock mem_316815 = {.desc ="mem_316815", .mem =
                                  futhark_mc_segmap_parloop_struct_339283->free_mem_316815,
                                  .size =0, .references =NULL};
    struct memblock mem_316835 = {.desc ="mem_316835", .mem =
                                  futhark_mc_segmap_parloop_struct_339283->free_mem_316835,
                                  .size =0, .references =NULL};
    struct memblock mem_316850 = {.desc ="mem_316850", .mem =
                                  futhark_mc_segmap_parloop_struct_339283->free_mem_316850,
                                  .size =0, .references =NULL};
    struct memblock mem_316973 = {.desc ="mem_316973", .mem =
                                  futhark_mc_segmap_parloop_struct_339283->free_mem_316973,
                                  .size =0, .references =NULL};
    struct memblock mem_316976 = {.desc ="mem_316976", .mem =
                                  futhark_mc_segmap_parloop_struct_339283->free_mem_316976,
                                  .size =0, .references =NULL};
    struct memblock mem_316979 = {.desc ="mem_316979", .mem =
                                  futhark_mc_segmap_parloop_struct_339283->free_mem_316979,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_337442 = start;
    
    for (; iter_337442 < end; iter_337442++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_337473 = partition_sizze_292766;
        int64_t gtid_310561 = iter_337442;
        int64_t remnant_337474 = iter_337442 - gtid_310561;
        double x_297282;
        
        x_297282 = ((double *) mem_316850.mem)[gtid_310561];
        
        int64_t x_297283;
        
        x_297283 = ((int64_t *) mem_316835.mem)[gtid_310561];
        
        int64_t x_297284;
        
        x_297284 = ((int64_t *) mem_312639.mem)[gtid_310561];
        
        double defunc_2_reduce_comm_res_297285;
        int64_t defunc_2_reduce_comm_res_297286;
        int64_t defunc_2_reduce_comm_res_297287;
        double redout_337444;
        int64_t redout_337445;
        int64_t redout_337446;
        
        redout_337444 = -INFINITY;
        redout_337445 = (int64_t) -1;
        redout_337446 = (int64_t) 0;
        for (int64_t i_337443 = 0; i_337443 < n_292675; i_337443++) {
            double x_337447;
            
            x_337447 = ((double *) mem_316815.mem)[gtid_310561 * n_292675 +
                                                   i_337443];
            
            bool cond_337448 = x_337447 < x_297282;
            int64_t defunc_0_f_res_337449 = btoi_bool_i64(cond_337448);
            bool cond_337450 = redout_337446 == (int64_t) 0;
            bool cond_t_res_337451 = slt64((int64_t) 0, defunc_0_f_res_337449);
            bool x_337452 = cond_337450 && cond_t_res_337451;
            double defunc_1_op_res_337453;
            int64_t defunc_1_op_res_337454;
            
            if (x_337452) {
                defunc_1_op_res_337453 = x_337447;
                defunc_1_op_res_337454 = i_337443;
            } else {
                bool cond_337455 = slt64((int64_t) 0, redout_337446);
                bool cond_t_res_337456 = defunc_0_f_res_337449 == (int64_t) 0;
                bool x_337457 = cond_337455 && cond_t_res_337456;
                double defunc_1_op_res_f_res_337458;
                int64_t defunc_1_op_res_f_res_337459;
                
                if (x_337457) {
                    defunc_1_op_res_f_res_337458 = redout_337444;
                    defunc_1_op_res_f_res_337459 = redout_337445;
                } else {
                    bool cond_337460 = x_337447 < redout_337444;
                    double defunc_1_op_res_f_res_f_res_337461;
                    int64_t defunc_1_op_res_f_res_f_res_337462;
                    
                    if (cond_337460) {
                        defunc_1_op_res_f_res_f_res_337461 = redout_337444;
                        defunc_1_op_res_f_res_f_res_337462 = redout_337445;
                    } else {
                        bool cond_337463 = redout_337444 < x_337447;
                        double defunc_1_op_res_f_res_f_res_f_res_337464;
                        int64_t defunc_1_op_res_f_res_f_res_f_res_337465;
                        
                        if (cond_337463) {
                            defunc_1_op_res_f_res_f_res_f_res_337464 = x_337447;
                            defunc_1_op_res_f_res_f_res_f_res_337465 = i_337443;
                        } else {
                            bool cond_337466 = slt64(redout_337445, i_337443);
                            double
                            defunc_1_op_res_f_res_f_res_f_res_f_res_337467;
                            
                            if (cond_337466) {
                                defunc_1_op_res_f_res_f_res_f_res_f_res_337467 =
                                    redout_337444;
                            } else {
                                defunc_1_op_res_f_res_f_res_f_res_f_res_337467 =
                                    x_337447;
                            }
                            
                            int64_t
                            defunc_1_op_res_f_res_f_res_f_res_f_res_337468;
                            
                            if (cond_337466) {
                                defunc_1_op_res_f_res_f_res_f_res_f_res_337468 =
                                    redout_337445;
                            } else {
                                defunc_1_op_res_f_res_f_res_f_res_f_res_337468 =
                                    i_337443;
                            }
                            defunc_1_op_res_f_res_f_res_f_res_337464 =
                                defunc_1_op_res_f_res_f_res_f_res_f_res_337467;
                            defunc_1_op_res_f_res_f_res_f_res_337465 =
                                defunc_1_op_res_f_res_f_res_f_res_f_res_337468;
                        }
                        defunc_1_op_res_f_res_f_res_337461 =
                            defunc_1_op_res_f_res_f_res_f_res_337464;
                        defunc_1_op_res_f_res_f_res_337462 =
                            defunc_1_op_res_f_res_f_res_f_res_337465;
                    }
                    defunc_1_op_res_f_res_337458 =
                        defunc_1_op_res_f_res_f_res_337461;
                    defunc_1_op_res_f_res_337459 =
                        defunc_1_op_res_f_res_f_res_337462;
                }
                defunc_1_op_res_337453 = defunc_1_op_res_f_res_337458;
                defunc_1_op_res_337454 = defunc_1_op_res_f_res_337459;
            }
            
            int64_t defunc_1_op_res_337469 = add64(defunc_0_f_res_337449,
                                                   redout_337446);
            double redout_tmp_337475 = defunc_1_op_res_337453;
            int64_t redout_tmp_337476 = defunc_1_op_res_337454;
            int64_t redout_tmp_337477 = defunc_1_op_res_337469;
            
            redout_337444 = redout_tmp_337475;
            redout_337445 = redout_tmp_337476;
            redout_337446 = redout_tmp_337477;
        }
        defunc_2_reduce_comm_res_297285 = redout_337444;
        defunc_2_reduce_comm_res_297286 = redout_337445;
        defunc_2_reduce_comm_res_297287 = redout_337446;
        
        bool cond_297318 = x_297283 == (int64_t) 0;
        int64_t x_297319 = smod64(x_297284, (int64_t) 2);
        bool cond_f_res_297320 = x_297319 == (int64_t) 1;
        bool x_297321 = !cond_297318;
        bool y_297322 = cond_f_res_297320 && x_297321;
        bool cond_297323 = cond_297318 || y_297322;
        bool cond_f_res_297324 = slt64(defunc_2_reduce_comm_res_297287,
                                       x_297283);
        bool x_297325 = !cond_297323;
        bool y_297326 = cond_f_res_297324 && x_297325;
        bool cond_297327 = cond_297323 || y_297326;
        double defunc_4_f_res_297328;
        
        if (cond_297327) {
            defunc_4_f_res_297328 = x_297282;
        } else {
            double x_337470 = x_297282 - defunc_2_reduce_comm_res_297285;
            double y_337471 = x_337470 / 2.0;
            double defunc_4_f_res_f_res_337472 =
                   defunc_2_reduce_comm_res_297285 + y_337471;
            
            defunc_4_f_res_297328 = defunc_4_f_res_f_res_337472;
        }
        
        double h_297332 = 6.0 * defunc_4_f_res_297328;
        double h9_297333 = 0.999 * h_297332;
        double h1_297334 = 1.0e-3 * h_297332;
        
        ((double *) mem_316973.mem)[gtid_310561] = h_297332;
        ((double *) mem_316976.mem)[gtid_310561] = h9_297333;
        ((double *) mem_316979.mem)[gtid_310561] = h1_297334;
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339284_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339284_end -
                 futhark_mc_segmap_parloop_339284_start;
        
        ctx->futhark_mc_segmap_parloop_339284_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_339284_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_339284_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_339282(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_310560 = tid;
    int num_tasks_337441 = info.nsubtasks;
    struct futhark_mc_task_339281 *futhark_mc_task_339281 =
                                  (struct futhark_mc_task_339281 *) args;
    struct futhark_context *ctx = futhark_mc_task_339281->ctx;
    uint64_t futhark_mc_segmap_task_339282_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_339282_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_339281->free_n_292675;
    int64_t partition_sizze_292766 =
            futhark_mc_task_339281->free_partition_sizze_292766;
    struct memblock mem_312639 = {.desc ="mem_312639", .mem =
                                  futhark_mc_task_339281->free_mem_312639,
                                  .size =0, .references =NULL};
    struct memblock mem_316815 = {.desc ="mem_316815", .mem =
                                  futhark_mc_task_339281->free_mem_316815,
                                  .size =0, .references =NULL};
    struct memblock mem_316835 = {.desc ="mem_316835", .mem =
                                  futhark_mc_task_339281->free_mem_316835,
                                  .size =0, .references =NULL};
    struct memblock mem_316850 = {.desc ="mem_316850", .mem =
                                  futhark_mc_task_339281->free_mem_316850,
                                  .size =0, .references =NULL};
    struct memblock mem_316973 = {.desc ="mem_316973", .mem =
                                  futhark_mc_task_339281->free_mem_316973,
                                  .size =0, .references =NULL};
    struct memblock mem_316976 = {.desc ="mem_316976", .mem =
                                  futhark_mc_task_339281->free_mem_316976,
                                  .size =0, .references =NULL};
    struct memblock mem_316979 = {.desc ="mem_316979", .mem =
                                  futhark_mc_task_339281->free_mem_316979,
                                  .size =0, .references =NULL};
    int64_t iter_337442;
    struct futhark_mc_segmap_parloop_struct_339283
    futhark_mc_segmap_parloop_struct_339283;
    
    futhark_mc_segmap_parloop_struct_339283.ctx = ctx;
    futhark_mc_segmap_parloop_struct_339283.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_339283.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_339283.free_mem_312639 = mem_312639.mem;
    futhark_mc_segmap_parloop_struct_339283.free_mem_316815 = mem_316815.mem;
    futhark_mc_segmap_parloop_struct_339283.free_mem_316835 = mem_316835.mem;
    futhark_mc_segmap_parloop_struct_339283.free_mem_316850 = mem_316850.mem;
    futhark_mc_segmap_parloop_struct_339283.free_mem_316973 = mem_316973.mem;
    futhark_mc_segmap_parloop_struct_339283.free_mem_316976 = mem_316976.mem;
    futhark_mc_segmap_parloop_struct_339283.free_mem_316979 = mem_316979.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_339284_task;
    
    futhark_mc_segmap_parloop_339284_task.name =
        "futhark_mc_segmap_parloop_339284";
    futhark_mc_segmap_parloop_339284_task.fn = futhark_mc_segmap_parloop_339284;
    futhark_mc_segmap_parloop_339284_task.args =
        &futhark_mc_segmap_parloop_struct_339283;
    futhark_mc_segmap_parloop_339284_task.iterations = iterations;
    futhark_mc_segmap_parloop_339284_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_339284_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339284_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_339284_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_339284_task);
    
    if (futhark_mc_segmap_parloop_339284_err != 0) {
        err = futhark_mc_segmap_parloop_339284_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339284_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339284_total_end -
                 futhark_mc_segmap_parloop_339284_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339284_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339284_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339284_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_339282_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_339282_end -
                 futhark_mc_segmap_task_339282_start;
        
        ctx->futhark_mc_segmap_task_339282_runs[tid]++;
        ctx->futhark_mc_segmap_task_339282_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_339282_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_segmap_parloop_struct_339286 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_partition_sizze_292766;
    unsigned char *free_mem_312639;
    unsigned char *free_mem_316815;
    unsigned char *free_mem_316835;
    unsigned char *free_mem_316850;
    unsigned char *free_mem_316973;
    unsigned char *free_mem_316976;
    unsigned char *free_mem_316979;
};
struct futhark_mc_task_339288 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_310567;
    double free_x_310569;
    unsigned char *free_mem_316815;
    double *retval_defunc_2_reduce_comm_res_310572;
    int64_t *retval_defunc_2_reduce_comm_res_310573;
    int64_t *retval_defunc_2_reduce_comm_res_310574;
};
struct futhark_mc_segred_stage_1_parloop_struct_339293 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_310567;
    double free_x_310569;
    unsigned char *free_mem_316815;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_337516;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_337518;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_337520;
};
static int futhark_mc_segred_stage_1_parloop_339294(void *args, int64_t start,
                                                    int64_t end,
                                                    int flat_tid_337479,
                                                    int tid)
{
    int err = 0;
    struct futhark_mc_segred_stage_1_parloop_struct_339293
    *futhark_mc_segred_stage_1_parloop_struct_339293 =
    (struct futhark_mc_segred_stage_1_parloop_struct_339293 *) args;
    struct futhark_context *ctx =
                           futhark_mc_segred_stage_1_parloop_struct_339293->ctx;
    uint64_t futhark_mc_segred_stage_1_parloop_339294_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_339294_start = get_wall_time();
    
    int64_t n_292675 =
            futhark_mc_segred_stage_1_parloop_struct_339293->free_n_292675;
    int64_t gtid_310567 =
            futhark_mc_segred_stage_1_parloop_struct_339293->free_gtid_310567;
    double x_310569 =
           futhark_mc_segred_stage_1_parloop_struct_339293->free_x_310569;
    struct memblock mem_316815 = {.desc ="mem_316815", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_339293->free_mem_316815,
                                  .size =0, .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_337516 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_337516",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_339293->free_reduce_stage_1_tid_res_arr_mem_337516,
                                                             .size =0,
                                                             .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_337518 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_337518",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_339293->free_reduce_stage_1_tid_res_arr_mem_337518,
                                                             .size =0,
                                                             .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_337520 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_337520",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_339293->free_reduce_stage_1_tid_res_arr_mem_337520,
                                                             .size =0,
                                                             .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_337522 = start;
    double x_337481;
    int64_t x_337482;
    int64_t x_337483;
    double x_337484;
    int64_t x_337485;
    int64_t x_337486;
    double local_acc_337523 = -INFINITY;
    int64_t local_acc_337524 = (int64_t) -1;
    int64_t local_acc_337525 = (int64_t) 0;
    
    for (; iter_337522 < end; iter_337522++) {
        int64_t gtid_337480 = iter_337522;
        double x_337507;
        
        x_337507 = ((double *) mem_316815.mem)[gtid_310567 * n_292675 +
                                               gtid_337480];
        
        bool cond_337508 = x_337507 < x_310569;
        int64_t defunc_0_f_res_337509 = btoi_bool_i64(cond_337508);
        
        // save map-out results
        { }
        // Load accum params
        {
            x_337481 = local_acc_337523;
            x_337482 = local_acc_337524;
            x_337483 = local_acc_337525;
        }
        // Load next params
        {
            x_337484 = x_337507;
            x_337485 = gtid_337480;
            x_337486 = defunc_0_f_res_337509;
        }
        // Red body
        {
            bool cond_337487 = x_337483 == (int64_t) 0;
            bool cond_t_res_337488 = slt64((int64_t) 0, x_337486);
            bool x_337489 = cond_337487 && cond_t_res_337488;
            double defunc_1_op_res_337490;
            int64_t defunc_1_op_res_337491;
            
            if (x_337489) {
                defunc_1_op_res_337490 = x_337484;
                defunc_1_op_res_337491 = x_337485;
            } else {
                bool cond_337492 = slt64((int64_t) 0, x_337483);
                bool cond_t_res_337493 = x_337486 == (int64_t) 0;
                bool x_337494 = cond_337492 && cond_t_res_337493;
                double defunc_1_op_res_f_res_337495;
                int64_t defunc_1_op_res_f_res_337496;
                
                if (x_337494) {
                    defunc_1_op_res_f_res_337495 = x_337481;
                    defunc_1_op_res_f_res_337496 = x_337482;
                } else {
                    bool cond_337497 = x_337484 < x_337481;
                    double defunc_1_op_res_f_res_f_res_337498;
                    int64_t defunc_1_op_res_f_res_f_res_337499;
                    
                    if (cond_337497) {
                        defunc_1_op_res_f_res_f_res_337498 = x_337481;
                        defunc_1_op_res_f_res_f_res_337499 = x_337482;
                    } else {
                        bool cond_337500 = x_337481 < x_337484;
                        double defunc_1_op_res_f_res_f_res_f_res_337501;
                        int64_t defunc_1_op_res_f_res_f_res_f_res_337502;
                        
                        if (cond_337500) {
                            defunc_1_op_res_f_res_f_res_f_res_337501 = x_337484;
                            defunc_1_op_res_f_res_f_res_f_res_337502 = x_337485;
                        } else {
                            bool cond_337503 = slt64(x_337482, x_337485);
                            double
                            defunc_1_op_res_f_res_f_res_f_res_f_res_337504;
                            
                            if (cond_337503) {
                                defunc_1_op_res_f_res_f_res_f_res_f_res_337504 =
                                    x_337481;
                            } else {
                                defunc_1_op_res_f_res_f_res_f_res_f_res_337504 =
                                    x_337484;
                            }
                            
                            int64_t
                            defunc_1_op_res_f_res_f_res_f_res_f_res_337505;
                            
                            if (cond_337503) {
                                defunc_1_op_res_f_res_f_res_f_res_f_res_337505 =
                                    x_337482;
                            } else {
                                defunc_1_op_res_f_res_f_res_f_res_f_res_337505 =
                                    x_337485;
                            }
                            defunc_1_op_res_f_res_f_res_f_res_337501 =
                                defunc_1_op_res_f_res_f_res_f_res_f_res_337504;
                            defunc_1_op_res_f_res_f_res_f_res_337502 =
                                defunc_1_op_res_f_res_f_res_f_res_f_res_337505;
                        }
                        defunc_1_op_res_f_res_f_res_337498 =
                            defunc_1_op_res_f_res_f_res_f_res_337501;
                        defunc_1_op_res_f_res_f_res_337499 =
                            defunc_1_op_res_f_res_f_res_f_res_337502;
                    }
                    defunc_1_op_res_f_res_337495 =
                        defunc_1_op_res_f_res_f_res_337498;
                    defunc_1_op_res_f_res_337496 =
                        defunc_1_op_res_f_res_f_res_337499;
                }
                defunc_1_op_res_337490 = defunc_1_op_res_f_res_337495;
                defunc_1_op_res_337491 = defunc_1_op_res_f_res_337496;
            }
            
            int64_t defunc_1_op_res_337506 = add64(x_337483, x_337486);
            
            local_acc_337523 = defunc_1_op_res_337490;
            local_acc_337524 = defunc_1_op_res_337491;
            local_acc_337525 = defunc_1_op_res_337506;
        }
    }
    ((double *) reduce_stage_1_tid_res_arr_mem_337516.mem)[flat_tid_337479] =
        local_acc_337523;
    ((int64_t *) reduce_stage_1_tid_res_arr_mem_337518.mem)[flat_tid_337479] =
        local_acc_337524;
    ((int64_t *) reduce_stage_1_tid_res_arr_mem_337520.mem)[flat_tid_337479] =
        local_acc_337525;
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_339294_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_339294_end -
                 futhark_mc_segred_stage_1_parloop_339294_start;
        
        ctx->futhark_mc_segred_stage_1_parloop_339294_runs[tid]++;
        ctx->futhark_mc_segred_stage_1_parloop_339294_total_runtime[tid] +=
            elapsed;
        ctx->futhark_mc_segred_stage_1_parloop_339294_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segred_task_339289(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_337479 = tid;
    int num_tasks_337515 = info.nsubtasks;
    struct futhark_mc_task_339288 *futhark_mc_task_339288 =
                                  (struct futhark_mc_task_339288 *) args;
    struct futhark_context *ctx = futhark_mc_task_339288->ctx;
    uint64_t futhark_mc_segred_task_339289_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_task_339289_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_339288->free_n_292675;
    int64_t gtid_310567 = futhark_mc_task_339288->free_gtid_310567;
    double x_310569 = futhark_mc_task_339288->free_x_310569;
    struct memblock mem_316815 = {.desc ="mem_316815", .mem =
                                  futhark_mc_task_339288->free_mem_316815,
                                  .size =0, .references =NULL};
    double defunc_2_reduce_comm_res_310572 =
           *futhark_mc_task_339288->retval_defunc_2_reduce_comm_res_310572;
    int64_t defunc_2_reduce_comm_res_310573 =
            *futhark_mc_task_339288->retval_defunc_2_reduce_comm_res_310573;
    int64_t defunc_2_reduce_comm_res_310574 =
            *futhark_mc_task_339288->retval_defunc_2_reduce_comm_res_310574;
    size_t reduce_stage_1_tid_res_arr_mem_337516_cached_sizze_339290 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_337516 = NULL;
    size_t reduce_stage_1_tid_res_arr_mem_337518_cached_sizze_339291 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_337518 = NULL;
    size_t reduce_stage_1_tid_res_arr_mem_337520_cached_sizze_339292 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_337520 = NULL;
    
    if (reduce_stage_1_tid_res_arr_mem_337516_cached_sizze_339290 <
        (size_t) ((int64_t) 8 * num_tasks_337515)) {
        reduce_stage_1_tid_res_arr_mem_337516 =
            realloc(reduce_stage_1_tid_res_arr_mem_337516, (int64_t) 8 *
                    num_tasks_337515);
        reduce_stage_1_tid_res_arr_mem_337516_cached_sizze_339290 =
            (int64_t) 8 * num_tasks_337515;
    }
    if (reduce_stage_1_tid_res_arr_mem_337518_cached_sizze_339291 <
        (size_t) ((int64_t) 8 * num_tasks_337515)) {
        reduce_stage_1_tid_res_arr_mem_337518 =
            realloc(reduce_stage_1_tid_res_arr_mem_337518, (int64_t) 8 *
                    num_tasks_337515);
        reduce_stage_1_tid_res_arr_mem_337518_cached_sizze_339291 =
            (int64_t) 8 * num_tasks_337515;
    }
    if (reduce_stage_1_tid_res_arr_mem_337520_cached_sizze_339292 <
        (size_t) ((int64_t) 8 * num_tasks_337515)) {
        reduce_stage_1_tid_res_arr_mem_337520 =
            realloc(reduce_stage_1_tid_res_arr_mem_337520, (int64_t) 8 *
                    num_tasks_337515);
        reduce_stage_1_tid_res_arr_mem_337520_cached_sizze_339292 =
            (int64_t) 8 * num_tasks_337515;
    }
    
    int64_t iter_337522;
    struct futhark_mc_segred_stage_1_parloop_struct_339293
    futhark_mc_segred_stage_1_parloop_struct_339293;
    
    futhark_mc_segred_stage_1_parloop_struct_339293.ctx = ctx;
    futhark_mc_segred_stage_1_parloop_struct_339293.free_n_292675 = n_292675;
    futhark_mc_segred_stage_1_parloop_struct_339293.free_gtid_310567 =
        gtid_310567;
    futhark_mc_segred_stage_1_parloop_struct_339293.free_x_310569 = x_310569;
    futhark_mc_segred_stage_1_parloop_struct_339293.free_mem_316815 =
        mem_316815.mem;
    futhark_mc_segred_stage_1_parloop_struct_339293.free_reduce_stage_1_tid_res_arr_mem_337516 =
        reduce_stage_1_tid_res_arr_mem_337516;
    futhark_mc_segred_stage_1_parloop_struct_339293.free_reduce_stage_1_tid_res_arr_mem_337518 =
        reduce_stage_1_tid_res_arr_mem_337518;
    futhark_mc_segred_stage_1_parloop_struct_339293.free_reduce_stage_1_tid_res_arr_mem_337520 =
        reduce_stage_1_tid_res_arr_mem_337520;
    
    struct scheduler_parloop futhark_mc_segred_stage_1_parloop_339294_task;
    
    futhark_mc_segred_stage_1_parloop_339294_task.name =
        "futhark_mc_segred_stage_1_parloop_339294";
    futhark_mc_segred_stage_1_parloop_339294_task.fn =
        futhark_mc_segred_stage_1_parloop_339294;
    futhark_mc_segred_stage_1_parloop_339294_task.args =
        &futhark_mc_segred_stage_1_parloop_struct_339293;
    futhark_mc_segred_stage_1_parloop_339294_task.iterations = iterations;
    futhark_mc_segred_stage_1_parloop_339294_task.info = info;
    
    uint64_t futhark_mc_segred_stage_1_parloop_339294_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_339294_total_start = get_wall_time();
    
    int futhark_mc_segred_stage_1_parloop_339294_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segred_stage_1_parloop_339294_task);
    
    if (futhark_mc_segred_stage_1_parloop_339294_err != 0) {
        err = futhark_mc_segred_stage_1_parloop_339294_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_339294_total_end =
                 get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_339294_total_end -
                 futhark_mc_segred_stage_1_parloop_339294_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_339294_total_runs,
                           1, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_339294_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_339294_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    // neutral-initialise the output
    {
        defunc_2_reduce_comm_res_310572 = -INFINITY;
        defunc_2_reduce_comm_res_310573 = (int64_t) -1;
        defunc_2_reduce_comm_res_310574 = (int64_t) 0;
    }
    
    double x_337526;
    int64_t x_337527;
    int64_t x_337528;
    double x_337529;
    int64_t x_337530;
    int64_t x_337531;
    
    for (int32_t i_337552 = 0; i_337552 < num_tasks_337515; i_337552++) {
        flat_tid_337479 = i_337552;
        // Apply main thread reduction
        {
            // load acc params
            {
                x_337526 = defunc_2_reduce_comm_res_310572;
                x_337527 = defunc_2_reduce_comm_res_310573;
                x_337528 = defunc_2_reduce_comm_res_310574;
            }
            // load next params
            {
                x_337529 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_337516)[flat_tid_337479];
                x_337530 =
                    ((int64_t *) reduce_stage_1_tid_res_arr_mem_337518)[flat_tid_337479];
                x_337531 =
                    ((int64_t *) reduce_stage_1_tid_res_arr_mem_337520)[flat_tid_337479];
            }
            // red body
            {
                bool cond_337532 = x_337528 == (int64_t) 0;
                bool cond_t_res_337533 = slt64((int64_t) 0, x_337531);
                bool x_337534 = cond_337532 && cond_t_res_337533;
                double defunc_1_op_res_337535;
                int64_t defunc_1_op_res_337536;
                
                if (x_337534) {
                    defunc_1_op_res_337535 = x_337529;
                    defunc_1_op_res_337536 = x_337530;
                } else {
                    bool cond_337537 = slt64((int64_t) 0, x_337528);
                    bool cond_t_res_337538 = x_337531 == (int64_t) 0;
                    bool x_337539 = cond_337537 && cond_t_res_337538;
                    double defunc_1_op_res_f_res_337540;
                    int64_t defunc_1_op_res_f_res_337541;
                    
                    if (x_337539) {
                        defunc_1_op_res_f_res_337540 = x_337526;
                        defunc_1_op_res_f_res_337541 = x_337527;
                    } else {
                        bool cond_337542 = x_337529 < x_337526;
                        double defunc_1_op_res_f_res_f_res_337543;
                        int64_t defunc_1_op_res_f_res_f_res_337544;
                        
                        if (cond_337542) {
                            defunc_1_op_res_f_res_f_res_337543 = x_337526;
                            defunc_1_op_res_f_res_f_res_337544 = x_337527;
                        } else {
                            bool cond_337545 = x_337526 < x_337529;
                            double defunc_1_op_res_f_res_f_res_f_res_337546;
                            int64_t defunc_1_op_res_f_res_f_res_f_res_337547;
                            
                            if (cond_337545) {
                                defunc_1_op_res_f_res_f_res_f_res_337546 =
                                    x_337529;
                                defunc_1_op_res_f_res_f_res_f_res_337547 =
                                    x_337530;
                            } else {
                                bool cond_337548 = slt64(x_337527, x_337530);
                                double
                                defunc_1_op_res_f_res_f_res_f_res_f_res_337549;
                                
                                if (cond_337548) {
                                    defunc_1_op_res_f_res_f_res_f_res_f_res_337549 =
                                        x_337526;
                                } else {
                                    defunc_1_op_res_f_res_f_res_f_res_f_res_337549 =
                                        x_337529;
                                }
                                
                                int64_t
                                defunc_1_op_res_f_res_f_res_f_res_f_res_337550;
                                
                                if (cond_337548) {
                                    defunc_1_op_res_f_res_f_res_f_res_f_res_337550 =
                                        x_337527;
                                } else {
                                    defunc_1_op_res_f_res_f_res_f_res_f_res_337550 =
                                        x_337530;
                                }
                                defunc_1_op_res_f_res_f_res_f_res_337546 =
                                    defunc_1_op_res_f_res_f_res_f_res_f_res_337549;
                                defunc_1_op_res_f_res_f_res_f_res_337547 =
                                    defunc_1_op_res_f_res_f_res_f_res_f_res_337550;
                            }
                            defunc_1_op_res_f_res_f_res_337543 =
                                defunc_1_op_res_f_res_f_res_f_res_337546;
                            defunc_1_op_res_f_res_f_res_337544 =
                                defunc_1_op_res_f_res_f_res_f_res_337547;
                        }
                        defunc_1_op_res_f_res_337540 =
                            defunc_1_op_res_f_res_f_res_337543;
                        defunc_1_op_res_f_res_337541 =
                            defunc_1_op_res_f_res_f_res_337544;
                    }
                    defunc_1_op_res_337535 = defunc_1_op_res_f_res_337540;
                    defunc_1_op_res_337536 = defunc_1_op_res_f_res_337541;
                }
                
                int64_t defunc_1_op_res_337551 = add64(x_337528, x_337531);
                
                defunc_2_reduce_comm_res_310572 = defunc_1_op_res_337535;
                defunc_2_reduce_comm_res_310573 = defunc_1_op_res_337536;
                defunc_2_reduce_comm_res_310574 = defunc_1_op_res_337551;
            }
        }
    }
    
  cleanup:
    {
        free(reduce_stage_1_tid_res_arr_mem_337516);
        free(reduce_stage_1_tid_res_arr_mem_337518);
        free(reduce_stage_1_tid_res_arr_mem_337520);
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_task_339289_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_task_339289_end -
                 futhark_mc_segred_task_339289_start;
        
        ctx->futhark_mc_segred_task_339289_runs[tid]++;
        ctx->futhark_mc_segred_task_339289_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segred_task_339289_iter[tid] += iterations;
    }
    if (err == 0) {
        *futhark_mc_task_339288->retval_defunc_2_reduce_comm_res_310572 =
            defunc_2_reduce_comm_res_310572;
        *futhark_mc_task_339288->retval_defunc_2_reduce_comm_res_310573 =
            defunc_2_reduce_comm_res_310573;
        *futhark_mc_task_339288->retval_defunc_2_reduce_comm_res_310574 =
            defunc_2_reduce_comm_res_310574;
    }
    return err;
}
static int futhark_mc_segmap_parloop_339287(void *args, int64_t start,
                                            int64_t end, int flat_tid_310566,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_339286
    *futhark_mc_segmap_parloop_struct_339286 =
    (struct futhark_mc_segmap_parloop_struct_339286 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_339286->ctx;
    uint64_t futhark_mc_segmap_parloop_339287_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339287_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_339286->free_n_292675;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_339286->free_partition_sizze_292766;
    struct memblock mem_312639 = {.desc ="mem_312639", .mem =
                                  futhark_mc_segmap_parloop_struct_339286->free_mem_312639,
                                  .size =0, .references =NULL};
    struct memblock mem_316815 = {.desc ="mem_316815", .mem =
                                  futhark_mc_segmap_parloop_struct_339286->free_mem_316815,
                                  .size =0, .references =NULL};
    struct memblock mem_316835 = {.desc ="mem_316835", .mem =
                                  futhark_mc_segmap_parloop_struct_339286->free_mem_316835,
                                  .size =0, .references =NULL};
    struct memblock mem_316850 = {.desc ="mem_316850", .mem =
                                  futhark_mc_segmap_parloop_struct_339286->free_mem_316850,
                                  .size =0, .references =NULL};
    struct memblock mem_316973 = {.desc ="mem_316973", .mem =
                                  futhark_mc_segmap_parloop_struct_339286->free_mem_316973,
                                  .size =0, .references =NULL};
    struct memblock mem_316976 = {.desc ="mem_316976", .mem =
                                  futhark_mc_segmap_parloop_struct_339286->free_mem_316976,
                                  .size =0, .references =NULL};
    struct memblock mem_316979 = {.desc ="mem_316979", .mem =
                                  futhark_mc_segmap_parloop_struct_339286->free_mem_316979,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_337478 = start;
    
    for (; iter_337478 < end; iter_337478++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_337513 = partition_sizze_292766;
        int64_t gtid_310567 = iter_337478;
        int64_t remnant_337514 = iter_337478 - gtid_310567;
        double x_310569;
        
        x_310569 = ((double *) mem_316850.mem)[gtid_310567];
        
        int64_t x_310570;
        
        x_310570 = ((int64_t *) mem_316835.mem)[gtid_310567];
        
        int64_t x_310571;
        
        x_310571 = ((int64_t *) mem_312639.mem)[gtid_310567];
        
        double defunc_2_reduce_comm_res_310572;
        int64_t defunc_2_reduce_comm_res_310573;
        int64_t defunc_2_reduce_comm_res_310574;
        int64_t flat_tid_337479 = (int64_t) 0;
        int32_t num_tasks_337515;
        
        defunc_2_reduce_comm_res_310572 = 0.0;
        defunc_2_reduce_comm_res_310573 = (int64_t) 0;
        defunc_2_reduce_comm_res_310574 = (int64_t) 0;
        
        struct futhark_mc_task_339288 futhark_mc_task_339288;
        
        futhark_mc_task_339288.ctx = ctx;
        futhark_mc_task_339288.free_n_292675 = n_292675;
        futhark_mc_task_339288.free_gtid_310567 = gtid_310567;
        futhark_mc_task_339288.free_x_310569 = x_310569;
        futhark_mc_task_339288.free_mem_316815 = mem_316815.mem;
        futhark_mc_task_339288.retval_defunc_2_reduce_comm_res_310572 =
            &defunc_2_reduce_comm_res_310572;
        futhark_mc_task_339288.retval_defunc_2_reduce_comm_res_310573 =
            &defunc_2_reduce_comm_res_310573;
        futhark_mc_task_339288.retval_defunc_2_reduce_comm_res_310574 =
            &defunc_2_reduce_comm_res_310574;
        
        struct scheduler_segop futhark_mc_task_339288_task;
        
        futhark_mc_task_339288_task.args = &futhark_mc_task_339288;
        futhark_mc_task_339288_task.top_level_fn =
            futhark_mc_segred_task_339289;
        futhark_mc_task_339288_task.name = "futhark_mc_segred_task_339289";
        futhark_mc_task_339288_task.iterations = n_292675;
        futhark_mc_task_339288_task.task_time =
            &ctx->futhark_mc_segred_task_339289_total_time;
        futhark_mc_task_339288_task.task_iter =
            &ctx->futhark_mc_segred_task_339289_total_iter;
        futhark_mc_task_339288_task.sched = STATIC;
        futhark_mc_task_339288_task.nested_fn = NULL;
        
        int futhark_mc_segred_task_339289_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_339288_task);
        
        if (futhark_mc_segred_task_339289_err != 0) {
            ;
            err = futhark_mc_segred_task_339289_err;
            goto cleanup;
        }
        
        bool cond_310607 = x_310570 == (int64_t) 0;
        int64_t x_310608 = smod64(x_310571, (int64_t) 2);
        bool cond_f_res_310609 = x_310608 == (int64_t) 1;
        bool x_310610 = !cond_310607;
        bool y_310611 = cond_f_res_310609 && x_310610;
        bool cond_310612 = cond_310607 || y_310611;
        bool cond_f_res_310613 = slt64(defunc_2_reduce_comm_res_310574,
                                       x_310570);
        bool x_310614 = !cond_310612;
        bool y_310615 = cond_f_res_310613 && x_310614;
        bool cond_310616 = cond_310612 || y_310615;
        double defunc_4_f_res_310617;
        
        if (cond_310616) {
            defunc_4_f_res_310617 = x_310569;
        } else {
            double x_337510 = x_310569 - defunc_2_reduce_comm_res_310572;
            double y_337511 = x_337510 / 2.0;
            double defunc_4_f_res_f_res_337512 =
                   defunc_2_reduce_comm_res_310572 + y_337511;
            
            defunc_4_f_res_310617 = defunc_4_f_res_f_res_337512;
        }
        
        double h_310621 = 6.0 * defunc_4_f_res_310617;
        double h9_310622 = 0.999 * h_310621;
        double h1_310623 = 1.0e-3 * h_310621;
        
        ((double *) mem_316973.mem)[gtid_310567] = h_310621;
        ((double *) mem_316976.mem)[gtid_310567] = h9_310622;
        ((double *) mem_316979.mem)[gtid_310567] = h1_310623;
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339287_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339287_end -
                 futhark_mc_segmap_parloop_339287_start;
        
        ctx->futhark_mc_segmap_parloop_339287_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_339287_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_339287_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_nested_task_339285(void *args, int64_t iterations,
                                         int tid, struct scheduler_info info)
{
    int err = 0;
    int flat_tid_310566 = tid;
    int num_tasks_337441 = info.nsubtasks;
    struct futhark_mc_task_339281 *futhark_mc_task_339281 =
                                  (struct futhark_mc_task_339281 *) args;
    struct futhark_context *ctx = futhark_mc_task_339281->ctx;
    uint64_t futhark_mc_segmap_nested_task_339285_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_nested_task_339285_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_339281->free_n_292675;
    int64_t partition_sizze_292766 =
            futhark_mc_task_339281->free_partition_sizze_292766;
    struct memblock mem_312639 = {.desc ="mem_312639", .mem =
                                  futhark_mc_task_339281->free_mem_312639,
                                  .size =0, .references =NULL};
    struct memblock mem_316815 = {.desc ="mem_316815", .mem =
                                  futhark_mc_task_339281->free_mem_316815,
                                  .size =0, .references =NULL};
    struct memblock mem_316835 = {.desc ="mem_316835", .mem =
                                  futhark_mc_task_339281->free_mem_316835,
                                  .size =0, .references =NULL};
    struct memblock mem_316850 = {.desc ="mem_316850", .mem =
                                  futhark_mc_task_339281->free_mem_316850,
                                  .size =0, .references =NULL};
    struct memblock mem_316973 = {.desc ="mem_316973", .mem =
                                  futhark_mc_task_339281->free_mem_316973,
                                  .size =0, .references =NULL};
    struct memblock mem_316976 = {.desc ="mem_316976", .mem =
                                  futhark_mc_task_339281->free_mem_316976,
                                  .size =0, .references =NULL};
    struct memblock mem_316979 = {.desc ="mem_316979", .mem =
                                  futhark_mc_task_339281->free_mem_316979,
                                  .size =0, .references =NULL};
    int64_t iter_337478;
    struct futhark_mc_segmap_parloop_struct_339286
    futhark_mc_segmap_parloop_struct_339286;
    
    futhark_mc_segmap_parloop_struct_339286.ctx = ctx;
    futhark_mc_segmap_parloop_struct_339286.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_339286.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_339286.free_mem_312639 = mem_312639.mem;
    futhark_mc_segmap_parloop_struct_339286.free_mem_316815 = mem_316815.mem;
    futhark_mc_segmap_parloop_struct_339286.free_mem_316835 = mem_316835.mem;
    futhark_mc_segmap_parloop_struct_339286.free_mem_316850 = mem_316850.mem;
    futhark_mc_segmap_parloop_struct_339286.free_mem_316973 = mem_316973.mem;
    futhark_mc_segmap_parloop_struct_339286.free_mem_316976 = mem_316976.mem;
    futhark_mc_segmap_parloop_struct_339286.free_mem_316979 = mem_316979.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_339287_task;
    
    futhark_mc_segmap_parloop_339287_task.name =
        "futhark_mc_segmap_parloop_339287";
    futhark_mc_segmap_parloop_339287_task.fn = futhark_mc_segmap_parloop_339287;
    futhark_mc_segmap_parloop_339287_task.args =
        &futhark_mc_segmap_parloop_struct_339286;
    futhark_mc_segmap_parloop_339287_task.iterations = iterations;
    futhark_mc_segmap_parloop_339287_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_339287_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339287_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_339287_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_339287_task);
    
    if (futhark_mc_segmap_parloop_339287_err != 0) {
        err = futhark_mc_segmap_parloop_339287_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339287_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339287_total_end -
                 futhark_mc_segmap_parloop_339287_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339287_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339287_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339287_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_nested_task_339285_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_nested_task_339285_end -
                 futhark_mc_segmap_nested_task_339285_start;
        
        ctx->futhark_mc_segmap_nested_task_339285_runs[tid]++;
        ctx->futhark_mc_segmap_nested_task_339285_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_nested_task_339285_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_task_339295 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_partition_sizze_292766;
    int64_t free_bytes_312598;
    unsigned char *free_mem_316819;
    unsigned char *free_mem_316973;
    unsigned char *free_mem_316976;
    unsigned char *free_mem_316979;
    unsigned char *free_mem_317001;
};
struct futhark_mc_segmap_parloop_struct_339297 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_partition_sizze_292766;
    int64_t free_bytes_312598;
    unsigned char *free_mem_316819;
    unsigned char *free_mem_316973;
    unsigned char *free_mem_316976;
    unsigned char *free_mem_316979;
    unsigned char *free_mem_317001;
};
static int futhark_mc_segmap_parloop_339298(void *args, int64_t start,
                                            int64_t end, int flat_tid_310624,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_339297
    *futhark_mc_segmap_parloop_struct_339297 =
    (struct futhark_mc_segmap_parloop_struct_339297 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_339297->ctx;
    uint64_t futhark_mc_segmap_parloop_339298_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339298_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_339297->free_n_292675;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_339297->free_partition_sizze_292766;
    int64_t bytes_312598 =
            futhark_mc_segmap_parloop_struct_339297->free_bytes_312598;
    struct memblock mem_316819 = {.desc ="mem_316819", .mem =
                                  futhark_mc_segmap_parloop_struct_339297->free_mem_316819,
                                  .size =0, .references =NULL};
    struct memblock mem_316973 = {.desc ="mem_316973", .mem =
                                  futhark_mc_segmap_parloop_struct_339297->free_mem_316973,
                                  .size =0, .references =NULL};
    struct memblock mem_316976 = {.desc ="mem_316976", .mem =
                                  futhark_mc_segmap_parloop_struct_339297->free_mem_316976,
                                  .size =0, .references =NULL};
    struct memblock mem_316979 = {.desc ="mem_316979", .mem =
                                  futhark_mc_segmap_parloop_struct_339297->free_mem_316979,
                                  .size =0, .references =NULL};
    struct memblock mem_317001 = {.desc ="mem_317001", .mem =
                                  futhark_mc_segmap_parloop_struct_339297->free_mem_317001,
                                  .size =0, .references =NULL};
    size_t mem_316985_cached_sizze_339299 = 0;
    unsigned char *mem_316985 = NULL;
    int64_t iterations = end - start;
    int64_t iter_337554 = start;
    
    if (mem_316985_cached_sizze_339299 < (size_t) bytes_312598) {
        mem_316985 = realloc(mem_316985, bytes_312598);
        mem_316985_cached_sizze_339299 = bytes_312598;
    }
    for (; iter_337554 < end; iter_337554++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_337575 = partition_sizze_292766;
        int64_t gtid_310625 = iter_337554;
        int64_t remnant_337576 = iter_337554 - gtid_310625;
        double x_297340;
        
        x_297340 = ((double *) mem_316973.mem)[gtid_310625];
        
        double x_297341;
        
        x_297341 = ((double *) mem_316976.mem)[gtid_310625];
        
        double x_297342;
        
        x_297342 = ((double *) mem_316979.mem)[gtid_310625];
        for (int64_t i_337555 = 0; i_337555 < n_292675; i_337555++) {
            double x_337557;
            
            x_337557 = ((double *) mem_316819.mem)[gtid_310625 * n_292675 +
                                                   i_337555];
            
            double x_337558 = x_337557 / x_297340;
            double y_337559 = fpow64(x_337558, 2.0);
            double x_337560 = 1.0 - y_337559;
            double bicube_337561 = fpow64(x_337560, 2.0);
            bool isnan_res_337562;
            
            isnan_res_337562 = futrts_isnan64(x_337557);
            
            bool cond_f_res_337563 = x_337557 <= x_297342;
            bool x_337564 = !isnan_res_337562;
            bool y_337565 = cond_f_res_337563 && x_337564;
            bool cond_337566 = isnan_res_337562 || y_337565;
            double defunc_0_f_res_337567;
            
            if (cond_337566) {
                defunc_0_f_res_337567 = 1.0;
            } else {
                bool cond_337568 = x_297341 <= x_337557;
                bool cond_f_res_337569 = x_337557 <= 1.0e-6;
                bool x_337570 = !cond_337568;
                bool y_337571 = cond_f_res_337569 && x_337570;
                bool cond_337572 = cond_337568 || y_337571;
                double defunc_0_f_res_f_res_337573;
                
                if (cond_337572) {
                    defunc_0_f_res_f_res_337573 = 1.0e-6;
                } else {
                    defunc_0_f_res_f_res_337573 = bicube_337561;
                }
                defunc_0_f_res_337567 = defunc_0_f_res_f_res_337573;
            }
            ((double *) mem_316985)[i_337555] = defunc_0_f_res_337567;
        }
        if (n_292675 * (int64_t) 8 > 0)
            memmove(mem_317001.mem + gtid_310625 * n_292675 * (int64_t) 8,
                    mem_316985 + (int64_t) 0, n_292675 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_316985);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339298_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339298_end -
                 futhark_mc_segmap_parloop_339298_start;
        
        ctx->futhark_mc_segmap_parloop_339298_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_339298_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_339298_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_339296(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_310624 = tid;
    int num_tasks_337553 = info.nsubtasks;
    struct futhark_mc_task_339295 *futhark_mc_task_339295 =
                                  (struct futhark_mc_task_339295 *) args;
    struct futhark_context *ctx = futhark_mc_task_339295->ctx;
    uint64_t futhark_mc_segmap_task_339296_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_339296_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_339295->free_n_292675;
    int64_t partition_sizze_292766 =
            futhark_mc_task_339295->free_partition_sizze_292766;
    int64_t bytes_312598 = futhark_mc_task_339295->free_bytes_312598;
    struct memblock mem_316819 = {.desc ="mem_316819", .mem =
                                  futhark_mc_task_339295->free_mem_316819,
                                  .size =0, .references =NULL};
    struct memblock mem_316973 = {.desc ="mem_316973", .mem =
                                  futhark_mc_task_339295->free_mem_316973,
                                  .size =0, .references =NULL};
    struct memblock mem_316976 = {.desc ="mem_316976", .mem =
                                  futhark_mc_task_339295->free_mem_316976,
                                  .size =0, .references =NULL};
    struct memblock mem_316979 = {.desc ="mem_316979", .mem =
                                  futhark_mc_task_339295->free_mem_316979,
                                  .size =0, .references =NULL};
    struct memblock mem_317001 = {.desc ="mem_317001", .mem =
                                  futhark_mc_task_339295->free_mem_317001,
                                  .size =0, .references =NULL};
    int64_t iter_337554;
    struct futhark_mc_segmap_parloop_struct_339297
    futhark_mc_segmap_parloop_struct_339297;
    
    futhark_mc_segmap_parloop_struct_339297.ctx = ctx;
    futhark_mc_segmap_parloop_struct_339297.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_339297.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_339297.free_bytes_312598 = bytes_312598;
    futhark_mc_segmap_parloop_struct_339297.free_mem_316819 = mem_316819.mem;
    futhark_mc_segmap_parloop_struct_339297.free_mem_316973 = mem_316973.mem;
    futhark_mc_segmap_parloop_struct_339297.free_mem_316976 = mem_316976.mem;
    futhark_mc_segmap_parloop_struct_339297.free_mem_316979 = mem_316979.mem;
    futhark_mc_segmap_parloop_struct_339297.free_mem_317001 = mem_317001.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_339298_task;
    
    futhark_mc_segmap_parloop_339298_task.name =
        "futhark_mc_segmap_parloop_339298";
    futhark_mc_segmap_parloop_339298_task.fn = futhark_mc_segmap_parloop_339298;
    futhark_mc_segmap_parloop_339298_task.args =
        &futhark_mc_segmap_parloop_struct_339297;
    futhark_mc_segmap_parloop_339298_task.iterations = iterations;
    futhark_mc_segmap_parloop_339298_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_339298_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339298_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_339298_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_339298_task);
    
    if (futhark_mc_segmap_parloop_339298_err != 0) {
        err = futhark_mc_segmap_parloop_339298_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339298_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339298_total_end -
                 futhark_mc_segmap_parloop_339298_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339298_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339298_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339298_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_339296_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_339296_end -
                 futhark_mc_segmap_task_339296_start;
        
        ctx->futhark_mc_segmap_task_339296_runs[tid]++;
        ctx->futhark_mc_segmap_task_339296_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_339296_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_segmap_parloop_struct_339301 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_partition_sizze_292766;
    int64_t free_bytes_312598;
    unsigned char *free_mem_316819;
    unsigned char *free_mem_316973;
    unsigned char *free_mem_316976;
    unsigned char *free_mem_316979;
    unsigned char *free_mem_317001;
};
struct futhark_mc_task_339304 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_310631;
    double free_x_310633;
    double free_x_310634;
    double free_x_310635;
    unsigned char *free_mem_316819;
    unsigned char *free_mem_316982;
};
struct futhark_mc_segmap_parloop_struct_339306 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_310631;
    double free_x_310633;
    double free_x_310634;
    double free_x_310635;
    unsigned char *free_mem_316819;
    unsigned char *free_mem_316982;
};
static int futhark_mc_segmap_parloop_339307(void *args, int64_t start,
                                            int64_t end, int flat_tid_337579,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_339306
    *futhark_mc_segmap_parloop_struct_339306 =
    (struct futhark_mc_segmap_parloop_struct_339306 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_339306->ctx;
    uint64_t futhark_mc_segmap_parloop_339307_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339307_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_339306->free_n_292675;
    int64_t gtid_310631 =
            futhark_mc_segmap_parloop_struct_339306->free_gtid_310631;
    double x_310633 = futhark_mc_segmap_parloop_struct_339306->free_x_310633;
    double x_310634 = futhark_mc_segmap_parloop_struct_339306->free_x_310634;
    double x_310635 = futhark_mc_segmap_parloop_struct_339306->free_x_310635;
    struct memblock mem_316819 = {.desc ="mem_316819", .mem =
                                  futhark_mc_segmap_parloop_struct_339306->free_mem_316819,
                                  .size =0, .references =NULL};
    struct memblock mem_316982 = {.desc ="mem_316982", .mem =
                                  futhark_mc_segmap_parloop_struct_339306->free_mem_316982,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_337601 = start;
    
    for (; iter_337601 < end; iter_337601++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_337608 = n_292675;
        int64_t gtid_337580 = iter_337601;
        int64_t remnant_337609 = iter_337601 - gtid_337580;
        double x_337581;
        
        x_337581 = ((double *) mem_316819.mem)[gtid_310631 * n_292675 +
                                               gtid_337580];
        
        double x_337582 = x_337581 / x_310633;
        double y_337583 = fpow64(x_337582, 2.0);
        double x_337584 = 1.0 - y_337583;
        double bicube_337585 = fpow64(x_337584, 2.0);
        bool isnan_res_337586;
        
        isnan_res_337586 = futrts_isnan64(x_337581);
        
        bool cond_f_res_337587 = x_337581 <= x_310635;
        bool x_337588 = !isnan_res_337586;
        bool y_337589 = cond_f_res_337587 && x_337588;
        bool cond_337590 = isnan_res_337586 || y_337589;
        double defunc_0_f_res_337591;
        
        if (cond_337590) {
            defunc_0_f_res_337591 = 1.0;
        } else {
            bool cond_337602 = x_310634 <= x_337581;
            bool cond_f_res_337603 = x_337581 <= 1.0e-6;
            bool x_337604 = !cond_337602;
            bool y_337605 = cond_f_res_337603 && x_337604;
            bool cond_337606 = cond_337602 || y_337605;
            double defunc_0_f_res_f_res_337607;
            
            if (cond_337606) {
                defunc_0_f_res_f_res_337607 = 1.0e-6;
            } else {
                defunc_0_f_res_f_res_337607 = bicube_337585;
            }
            defunc_0_f_res_337591 = defunc_0_f_res_f_res_337607;
        }
        ((double *) mem_316982.mem)[gtid_337580] = defunc_0_f_res_337591;
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339307_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339307_end -
                 futhark_mc_segmap_parloop_339307_start;
        
        ctx->futhark_mc_segmap_parloop_339307_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_339307_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_339307_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_339305(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_337579 = tid;
    int num_tasks_337600 = info.nsubtasks;
    struct futhark_mc_task_339304 *futhark_mc_task_339304 =
                                  (struct futhark_mc_task_339304 *) args;
    struct futhark_context *ctx = futhark_mc_task_339304->ctx;
    uint64_t futhark_mc_segmap_task_339305_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_339305_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_339304->free_n_292675;
    int64_t gtid_310631 = futhark_mc_task_339304->free_gtid_310631;
    double x_310633 = futhark_mc_task_339304->free_x_310633;
    double x_310634 = futhark_mc_task_339304->free_x_310634;
    double x_310635 = futhark_mc_task_339304->free_x_310635;
    struct memblock mem_316819 = {.desc ="mem_316819", .mem =
                                  futhark_mc_task_339304->free_mem_316819,
                                  .size =0, .references =NULL};
    struct memblock mem_316982 = {.desc ="mem_316982", .mem =
                                  futhark_mc_task_339304->free_mem_316982,
                                  .size =0, .references =NULL};
    int64_t iter_337601;
    struct futhark_mc_segmap_parloop_struct_339306
    futhark_mc_segmap_parloop_struct_339306;
    
    futhark_mc_segmap_parloop_struct_339306.ctx = ctx;
    futhark_mc_segmap_parloop_struct_339306.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_339306.free_gtid_310631 = gtid_310631;
    futhark_mc_segmap_parloop_struct_339306.free_x_310633 = x_310633;
    futhark_mc_segmap_parloop_struct_339306.free_x_310634 = x_310634;
    futhark_mc_segmap_parloop_struct_339306.free_x_310635 = x_310635;
    futhark_mc_segmap_parloop_struct_339306.free_mem_316819 = mem_316819.mem;
    futhark_mc_segmap_parloop_struct_339306.free_mem_316982 = mem_316982.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_339307_task;
    
    futhark_mc_segmap_parloop_339307_task.name =
        "futhark_mc_segmap_parloop_339307";
    futhark_mc_segmap_parloop_339307_task.fn = futhark_mc_segmap_parloop_339307;
    futhark_mc_segmap_parloop_339307_task.args =
        &futhark_mc_segmap_parloop_struct_339306;
    futhark_mc_segmap_parloop_339307_task.iterations = iterations;
    futhark_mc_segmap_parloop_339307_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_339307_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339307_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_339307_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_339307_task);
    
    if (futhark_mc_segmap_parloop_339307_err != 0) {
        err = futhark_mc_segmap_parloop_339307_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339307_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339307_total_end -
                 futhark_mc_segmap_parloop_339307_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339307_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339307_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339307_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_339305_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_339305_end -
                 futhark_mc_segmap_task_339305_start;
        
        ctx->futhark_mc_segmap_task_339305_runs[tid]++;
        ctx->futhark_mc_segmap_task_339305_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_339305_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
static int futhark_mc_segmap_parloop_339302(void *args, int64_t start,
                                            int64_t end, int flat_tid_310630,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_339301
    *futhark_mc_segmap_parloop_struct_339301 =
    (struct futhark_mc_segmap_parloop_struct_339301 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_339301->ctx;
    uint64_t futhark_mc_segmap_parloop_339302_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339302_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_339301->free_n_292675;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_339301->free_partition_sizze_292766;
    int64_t bytes_312598 =
            futhark_mc_segmap_parloop_struct_339301->free_bytes_312598;
    struct memblock mem_316819 = {.desc ="mem_316819", .mem =
                                  futhark_mc_segmap_parloop_struct_339301->free_mem_316819,
                                  .size =0, .references =NULL};
    struct memblock mem_316973 = {.desc ="mem_316973", .mem =
                                  futhark_mc_segmap_parloop_struct_339301->free_mem_316973,
                                  .size =0, .references =NULL};
    struct memblock mem_316976 = {.desc ="mem_316976", .mem =
                                  futhark_mc_segmap_parloop_struct_339301->free_mem_316976,
                                  .size =0, .references =NULL};
    struct memblock mem_316979 = {.desc ="mem_316979", .mem =
                                  futhark_mc_segmap_parloop_struct_339301->free_mem_316979,
                                  .size =0, .references =NULL};
    struct memblock mem_317001 = {.desc ="mem_317001", .mem =
                                  futhark_mc_segmap_parloop_struct_339301->free_mem_317001,
                                  .size =0, .references =NULL};
    size_t mem_316982_cached_sizze_339303 = 0;
    unsigned char *mem_316982 = NULL;
    int64_t iterations = end - start;
    int64_t iter_337578 = start;
    
    if (mem_316982_cached_sizze_339303 < (size_t) bytes_312598) {
        mem_316982 = realloc(mem_316982, bytes_312598);
        mem_316982_cached_sizze_339303 = bytes_312598;
    }
    for (; iter_337578 < end; iter_337578++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_337598 = partition_sizze_292766;
        int64_t gtid_310631 = iter_337578;
        int64_t remnant_337599 = iter_337578 - gtid_310631;
        double x_310633;
        
        x_310633 = ((double *) mem_316973.mem)[gtid_310631];
        
        double x_310634;
        
        x_310634 = ((double *) mem_316976.mem)[gtid_310631];
        
        double x_310635;
        
        x_310635 = ((double *) mem_316979.mem)[gtid_310631];
        
        int64_t flat_tid_337579 = (int64_t) 0;
        int32_t num_tasks_337600;
        struct futhark_mc_task_339304 futhark_mc_task_339304;
        
        futhark_mc_task_339304.ctx = ctx;
        futhark_mc_task_339304.free_n_292675 = n_292675;
        futhark_mc_task_339304.free_gtid_310631 = gtid_310631;
        futhark_mc_task_339304.free_x_310633 = x_310633;
        futhark_mc_task_339304.free_x_310634 = x_310634;
        futhark_mc_task_339304.free_x_310635 = x_310635;
        futhark_mc_task_339304.free_mem_316819 = mem_316819.mem;
        futhark_mc_task_339304.free_mem_316982 = mem_316982;
        
        struct scheduler_segop futhark_mc_task_339304_task;
        
        futhark_mc_task_339304_task.args = &futhark_mc_task_339304;
        futhark_mc_task_339304_task.top_level_fn =
            futhark_mc_segmap_task_339305;
        futhark_mc_task_339304_task.name = "futhark_mc_segmap_task_339305";
        futhark_mc_task_339304_task.iterations = n_292675;
        futhark_mc_task_339304_task.task_time =
            &ctx->futhark_mc_segmap_task_339305_total_time;
        futhark_mc_task_339304_task.task_iter =
            &ctx->futhark_mc_segmap_task_339305_total_iter;
        futhark_mc_task_339304_task.sched = STATIC;
        futhark_mc_task_339304_task.nested_fn = NULL;
        
        int futhark_mc_segmap_task_339305_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_339304_task);
        
        if (futhark_mc_segmap_task_339305_err != 0) {
            ;
            err = futhark_mc_segmap_task_339305_err;
            goto cleanup;
        }
        if (n_292675 * (int64_t) 8 > 0)
            memmove(mem_317001.mem + gtid_310631 * n_292675 * (int64_t) 8,
                    mem_316982 + (int64_t) 0, n_292675 * (int64_t) 8);
    }
    
  cleanup:
    { }
    free(mem_316982);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339302_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339302_end -
                 futhark_mc_segmap_parloop_339302_start;
        
        ctx->futhark_mc_segmap_parloop_339302_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_339302_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_339302_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_nested_task_339300(void *args, int64_t iterations,
                                         int tid, struct scheduler_info info)
{
    int err = 0;
    int flat_tid_310630 = tid;
    int num_tasks_337553 = info.nsubtasks;
    struct futhark_mc_task_339295 *futhark_mc_task_339295 =
                                  (struct futhark_mc_task_339295 *) args;
    struct futhark_context *ctx = futhark_mc_task_339295->ctx;
    uint64_t futhark_mc_segmap_nested_task_339300_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_nested_task_339300_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_339295->free_n_292675;
    int64_t partition_sizze_292766 =
            futhark_mc_task_339295->free_partition_sizze_292766;
    int64_t bytes_312598 = futhark_mc_task_339295->free_bytes_312598;
    struct memblock mem_316819 = {.desc ="mem_316819", .mem =
                                  futhark_mc_task_339295->free_mem_316819,
                                  .size =0, .references =NULL};
    struct memblock mem_316973 = {.desc ="mem_316973", .mem =
                                  futhark_mc_task_339295->free_mem_316973,
                                  .size =0, .references =NULL};
    struct memblock mem_316976 = {.desc ="mem_316976", .mem =
                                  futhark_mc_task_339295->free_mem_316976,
                                  .size =0, .references =NULL};
    struct memblock mem_316979 = {.desc ="mem_316979", .mem =
                                  futhark_mc_task_339295->free_mem_316979,
                                  .size =0, .references =NULL};
    struct memblock mem_317001 = {.desc ="mem_317001", .mem =
                                  futhark_mc_task_339295->free_mem_317001,
                                  .size =0, .references =NULL};
    int64_t iter_337578;
    struct futhark_mc_segmap_parloop_struct_339301
    futhark_mc_segmap_parloop_struct_339301;
    
    futhark_mc_segmap_parloop_struct_339301.ctx = ctx;
    futhark_mc_segmap_parloop_struct_339301.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_339301.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_339301.free_bytes_312598 = bytes_312598;
    futhark_mc_segmap_parloop_struct_339301.free_mem_316819 = mem_316819.mem;
    futhark_mc_segmap_parloop_struct_339301.free_mem_316973 = mem_316973.mem;
    futhark_mc_segmap_parloop_struct_339301.free_mem_316976 = mem_316976.mem;
    futhark_mc_segmap_parloop_struct_339301.free_mem_316979 = mem_316979.mem;
    futhark_mc_segmap_parloop_struct_339301.free_mem_317001 = mem_317001.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_339302_task;
    
    futhark_mc_segmap_parloop_339302_task.name =
        "futhark_mc_segmap_parloop_339302";
    futhark_mc_segmap_parloop_339302_task.fn = futhark_mc_segmap_parloop_339302;
    futhark_mc_segmap_parloop_339302_task.args =
        &futhark_mc_segmap_parloop_struct_339301;
    futhark_mc_segmap_parloop_339302_task.iterations = iterations;
    futhark_mc_segmap_parloop_339302_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_339302_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339302_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_339302_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_339302_task);
    
    if (futhark_mc_segmap_parloop_339302_err != 0) {
        err = futhark_mc_segmap_parloop_339302_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339302_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339302_total_end -
                 futhark_mc_segmap_parloop_339302_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339302_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339302_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339302_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_nested_task_339300_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_nested_task_339300_end -
                 futhark_mc_segmap_nested_task_339300_start;
        
        ctx->futhark_mc_segmap_nested_task_339300_runs[tid]++;
        ctx->futhark_mc_segmap_nested_task_339300_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_nested_task_339300_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_task_339308 {
    struct futhark_context *ctx;
    int64_t free_m_292674;
    int64_t free_n_292675;
    int64_t free_partition_sizze_292766;
    unsigned char *free_mem_312593;
    unsigned char *free_mem_312596;
    int64_t free_bytes_316827;
    unsigned char *free_ext_mem_317011;
    unsigned char *free_ext_mem_317012;
    int64_t free_ext_317023;
    unsigned char *free_mem_317037;
    unsigned char *free_mem_317041;
    unsigned char *free_mem_317045;
};
struct futhark_mc_segmap_parloop_struct_339310 {
    struct futhark_context *ctx;
    int64_t free_m_292674;
    int64_t free_n_292675;
    int64_t free_partition_sizze_292766;
    unsigned char *free_mem_312593;
    unsigned char *free_mem_312596;
    int64_t free_bytes_316827;
    unsigned char *free_ext_mem_317011;
    unsigned char *free_ext_mem_317012;
    int64_t free_ext_317023;
    unsigned char *free_mem_317037;
    unsigned char *free_mem_317041;
    unsigned char *free_mem_317045;
};
struct futhark_mc_task_339315 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_310657;
    unsigned char *free_mem_312593;
    unsigned char *free_ext_mem_317011;
    unsigned char *free_ext_mem_317012;
    int64_t free_ext_317023;
    unsigned char *free_mem_317048;
    unsigned char *free_mem_317051;
    unsigned char *free_mem_317054;
};
struct futhark_mc_segmap_parloop_struct_339317 {
    struct futhark_context *ctx;
    int64_t free_n_292675;
    int64_t free_gtid_310657;
    unsigned char *free_mem_312593;
    unsigned char *free_ext_mem_317011;
    unsigned char *free_ext_mem_317012;
    int64_t free_ext_317023;
    unsigned char *free_mem_317048;
    unsigned char *free_mem_317051;
    unsigned char *free_mem_317054;
};
static int futhark_mc_segmap_parloop_339318(void *args, int64_t start,
                                            int64_t end, int flat_tid_337618,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_339317
    *futhark_mc_segmap_parloop_struct_339317 =
    (struct futhark_mc_segmap_parloop_struct_339317 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_339317->ctx;
    uint64_t futhark_mc_segmap_parloop_339318_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339318_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_339317->free_n_292675;
    int64_t gtid_310657 =
            futhark_mc_segmap_parloop_struct_339317->free_gtid_310657;
    struct memblock mem_312593 = {.desc ="mem_312593", .mem =
                                  futhark_mc_segmap_parloop_struct_339317->free_mem_312593,
                                  .size =0, .references =NULL};
    struct memblock ext_mem_317011 = {.desc ="ext_mem_317011", .mem =
                                      futhark_mc_segmap_parloop_struct_339317->free_ext_mem_317011,
                                      .size =0, .references =NULL};
    struct memblock ext_mem_317012 = {.desc ="ext_mem_317012", .mem =
                                      futhark_mc_segmap_parloop_struct_339317->free_ext_mem_317012,
                                      .size =0, .references =NULL};
    int64_t ext_317023 =
            futhark_mc_segmap_parloop_struct_339317->free_ext_317023;
    struct memblock mem_317048 = {.desc ="mem_317048", .mem =
                                  futhark_mc_segmap_parloop_struct_339317->free_mem_317048,
                                  .size =0, .references =NULL};
    struct memblock mem_317051 = {.desc ="mem_317051", .mem =
                                  futhark_mc_segmap_parloop_struct_339317->free_mem_317051,
                                  .size =0, .references =NULL};
    struct memblock mem_317054 = {.desc ="mem_317054", .mem =
                                  futhark_mc_segmap_parloop_struct_339317->free_mem_317054,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_337630 = start;
    
    for (; iter_337630 < end; iter_337630++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_337631 = n_292675;
        int64_t gtid_337619 = iter_337630;
        int64_t remnant_337632 = iter_337630 - gtid_337619;
        double x_337620;
        
        x_337620 = ((double *) ext_mem_317012.mem)[gtid_310657 * n_292675 +
                                                   gtid_337619];
        
        double x_337621;
        
        x_337621 = ((double *) ext_mem_317011.mem)[gtid_310657 * ext_317023 +
                                                   gtid_337619];
        
        float x_337622;
        
        x_337622 = ((float *) mem_312593.mem)[gtid_310657 * n_292675 +
                                              gtid_337619];
        
        float defunc_0_g_res_337623 = fpconv_f64_f32(x_337620);
        float defunc_0_g_res_337624 = fpconv_f64_f32(x_337621);
        float x_337625 = x_337622 - defunc_0_g_res_337623;
        float defunc_2_f_res_337626 = x_337625 - defunc_0_g_res_337624;
        
        ((float *) mem_317048.mem)[gtid_337619] = defunc_2_f_res_337626;
        ((float *) mem_317051.mem)[gtid_337619] = defunc_0_g_res_337624;
        ((float *) mem_317054.mem)[gtid_337619] = defunc_0_g_res_337623;
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339318_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339318_end -
                 futhark_mc_segmap_parloop_339318_start;
        
        ctx->futhark_mc_segmap_parloop_339318_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_339318_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_339318_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_339316(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_337618 = tid;
    int num_tasks_337629 = info.nsubtasks;
    struct futhark_mc_task_339315 *futhark_mc_task_339315 =
                                  (struct futhark_mc_task_339315 *) args;
    struct futhark_context *ctx = futhark_mc_task_339315->ctx;
    uint64_t futhark_mc_segmap_task_339316_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_339316_start = get_wall_time();
    
    int64_t n_292675 = futhark_mc_task_339315->free_n_292675;
    int64_t gtid_310657 = futhark_mc_task_339315->free_gtid_310657;
    struct memblock mem_312593 = {.desc ="mem_312593", .mem =
                                  futhark_mc_task_339315->free_mem_312593,
                                  .size =0, .references =NULL};
    struct memblock ext_mem_317011 = {.desc ="ext_mem_317011", .mem =
                                      futhark_mc_task_339315->free_ext_mem_317011,
                                      .size =0, .references =NULL};
    struct memblock ext_mem_317012 = {.desc ="ext_mem_317012", .mem =
                                      futhark_mc_task_339315->free_ext_mem_317012,
                                      .size =0, .references =NULL};
    int64_t ext_317023 = futhark_mc_task_339315->free_ext_317023;
    struct memblock mem_317048 = {.desc ="mem_317048", .mem =
                                  futhark_mc_task_339315->free_mem_317048,
                                  .size =0, .references =NULL};
    struct memblock mem_317051 = {.desc ="mem_317051", .mem =
                                  futhark_mc_task_339315->free_mem_317051,
                                  .size =0, .references =NULL};
    struct memblock mem_317054 = {.desc ="mem_317054", .mem =
                                  futhark_mc_task_339315->free_mem_317054,
                                  .size =0, .references =NULL};
    int64_t iter_337630;
    struct futhark_mc_segmap_parloop_struct_339317
    futhark_mc_segmap_parloop_struct_339317;
    
    futhark_mc_segmap_parloop_struct_339317.ctx = ctx;
    futhark_mc_segmap_parloop_struct_339317.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_339317.free_gtid_310657 = gtid_310657;
    futhark_mc_segmap_parloop_struct_339317.free_mem_312593 = mem_312593.mem;
    futhark_mc_segmap_parloop_struct_339317.free_ext_mem_317011 =
        ext_mem_317011.mem;
    futhark_mc_segmap_parloop_struct_339317.free_ext_mem_317012 =
        ext_mem_317012.mem;
    futhark_mc_segmap_parloop_struct_339317.free_ext_317023 = ext_317023;
    futhark_mc_segmap_parloop_struct_339317.free_mem_317048 = mem_317048.mem;
    futhark_mc_segmap_parloop_struct_339317.free_mem_317051 = mem_317051.mem;
    futhark_mc_segmap_parloop_struct_339317.free_mem_317054 = mem_317054.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_339318_task;
    
    futhark_mc_segmap_parloop_339318_task.name =
        "futhark_mc_segmap_parloop_339318";
    futhark_mc_segmap_parloop_339318_task.fn = futhark_mc_segmap_parloop_339318;
    futhark_mc_segmap_parloop_339318_task.args =
        &futhark_mc_segmap_parloop_struct_339317;
    futhark_mc_segmap_parloop_339318_task.iterations = iterations;
    futhark_mc_segmap_parloop_339318_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_339318_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339318_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_339318_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_339318_task);
    
    if (futhark_mc_segmap_parloop_339318_err != 0) {
        err = futhark_mc_segmap_parloop_339318_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339318_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339318_total_end -
                 futhark_mc_segmap_parloop_339318_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339318_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339318_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339318_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_339316_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_339316_end -
                 futhark_mc_segmap_task_339316_start;
        
        ctx->futhark_mc_segmap_task_339316_runs[tid]++;
        ctx->futhark_mc_segmap_task_339316_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_339316_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
static int futhark_mc_segmap_parloop_339311(void *args, int64_t start,
                                            int64_t end, int flat_tid_310656,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_339310
    *futhark_mc_segmap_parloop_struct_339310 =
    (struct futhark_mc_segmap_parloop_struct_339310 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_339310->ctx;
    uint64_t futhark_mc_segmap_parloop_339311_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339311_start = get_wall_time();
    
    int64_t m_292674 = futhark_mc_segmap_parloop_struct_339310->free_m_292674;
    int64_t n_292675 = futhark_mc_segmap_parloop_struct_339310->free_n_292675;
    int64_t partition_sizze_292766 =
            futhark_mc_segmap_parloop_struct_339310->free_partition_sizze_292766;
    struct memblock mem_312593 = {.desc ="mem_312593", .mem =
                                  futhark_mc_segmap_parloop_struct_339310->free_mem_312593,
                                  .size =0, .references =NULL};
    struct memblock mem_312596 = {.desc ="mem_312596", .mem =
                                  futhark_mc_segmap_parloop_struct_339310->free_mem_312596,
                                  .size =0, .references =NULL};
    int64_t bytes_316827 =
            futhark_mc_segmap_parloop_struct_339310->free_bytes_316827;
    struct memblock ext_mem_317011 = {.desc ="ext_mem_317011", .mem =
                                      futhark_mc_segmap_parloop_struct_339310->free_ext_mem_317011,
                                      .size =0, .references =NULL};
    struct memblock ext_mem_317012 = {.desc ="ext_mem_317012", .mem =
                                      futhark_mc_segmap_parloop_struct_339310->free_ext_mem_317012,
                                      .size =0, .references =NULL};
    int64_t ext_317023 =
            futhark_mc_segmap_parloop_struct_339310->free_ext_317023;
    struct memblock mem_317037 = {.desc ="mem_317037", .mem =
                                  futhark_mc_segmap_parloop_struct_339310->free_mem_317037,
                                  .size =0, .references =NULL};
    struct memblock mem_317041 = {.desc ="mem_317041", .mem =
                                  futhark_mc_segmap_parloop_struct_339310->free_mem_317041,
                                  .size =0, .references =NULL};
    struct memblock mem_317045 = {.desc ="mem_317045", .mem =
                                  futhark_mc_segmap_parloop_struct_339310->free_mem_317045,
                                  .size =0, .references =NULL};
    size_t mem_317048_cached_sizze_339312 = 0;
    unsigned char *mem_317048 = NULL;
    size_t mem_317051_cached_sizze_339313 = 0;
    unsigned char *mem_317051 = NULL;
    size_t mem_317054_cached_sizze_339314 = 0;
    unsigned char *mem_317054 = NULL;
    int64_t iterations = end - start;
    int64_t iter_337617 = start;
    
    if (mem_317048_cached_sizze_339312 < (size_t) bytes_316827) {
        mem_317048 = realloc(mem_317048, bytes_316827);
        mem_317048_cached_sizze_339312 = bytes_316827;
    }
    if (mem_317051_cached_sizze_339313 < (size_t) bytes_316827) {
        mem_317051 = realloc(mem_317051, bytes_316827);
        mem_317051_cached_sizze_339313 = bytes_316827;
    }
    if (mem_317054_cached_sizze_339314 < (size_t) bytes_316827) {
        mem_317054 = realloc(mem_317054, bytes_316827);
        mem_317054_cached_sizze_339314 = bytes_316827;
    }
    for (; iter_337617 < end; iter_337617++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_337627 = partition_sizze_292766;
        int64_t gtid_310657 = iter_337617;
        int64_t remnant_337628 = iter_337617 - gtid_310657;
        int64_t write_index_297371;
        
        write_index_297371 = ((int64_t *) mem_312596.mem)[gtid_310657];
        
        int64_t flat_tid_337618 = (int64_t) 0;
        int32_t num_tasks_337629;
        struct futhark_mc_task_339315 futhark_mc_task_339315;
        
        futhark_mc_task_339315.ctx = ctx;
        futhark_mc_task_339315.free_n_292675 = n_292675;
        futhark_mc_task_339315.free_gtid_310657 = gtid_310657;
        futhark_mc_task_339315.free_mem_312593 = mem_312593.mem;
        futhark_mc_task_339315.free_ext_mem_317011 = ext_mem_317011.mem;
        futhark_mc_task_339315.free_ext_mem_317012 = ext_mem_317012.mem;
        futhark_mc_task_339315.free_ext_317023 = ext_317023;
        futhark_mc_task_339315.free_mem_317048 = mem_317048;
        futhark_mc_task_339315.free_mem_317051 = mem_317051;
        futhark_mc_task_339315.free_mem_317054 = mem_317054;
        
        struct scheduler_segop futhark_mc_task_339315_task;
        
        futhark_mc_task_339315_task.args = &futhark_mc_task_339315;
        futhark_mc_task_339315_task.top_level_fn =
            futhark_mc_segmap_task_339316;
        futhark_mc_task_339315_task.name = "futhark_mc_segmap_task_339316";
        futhark_mc_task_339315_task.iterations = n_292675;
        futhark_mc_task_339315_task.task_time =
            &ctx->futhark_mc_segmap_task_339316_total_time;
        futhark_mc_task_339315_task.task_iter =
            &ctx->futhark_mc_segmap_task_339316_total_iter;
        futhark_mc_task_339315_task.sched = STATIC;
        futhark_mc_task_339315_task.nested_fn = NULL;
        
        int futhark_mc_segmap_task_339316_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_339315_task);
        
        if (futhark_mc_segmap_task_339316_err != 0) {
            ;
            err = futhark_mc_segmap_task_339316_err;
            goto cleanup;
        }
        if (sle64((int64_t) 0, write_index_297371) && slt64(write_index_297371,
                                                            m_292674)) {
            if (n_292675 * (int64_t) 4 > 0)
                memmove(mem_317045.mem + write_index_297371 * n_292675 *
                        (int64_t) 4, mem_317048 + (int64_t) 0, n_292675 *
                        (int64_t) 4);
        }
        if (sle64((int64_t) 0, write_index_297371) && slt64(write_index_297371,
                                                            m_292674)) {
            if (n_292675 * (int64_t) 4 > 0)
                memmove(mem_317041.mem + write_index_297371 * n_292675 *
                        (int64_t) 4, mem_317051 + (int64_t) 0, n_292675 *
                        (int64_t) 4);
        }
        if (sle64((int64_t) 0, write_index_297371) && slt64(write_index_297371,
                                                            m_292674)) {
            if (n_292675 * (int64_t) 4 > 0)
                memmove(mem_317037.mem + write_index_297371 * n_292675 *
                        (int64_t) 4, mem_317054 + (int64_t) 0, n_292675 *
                        (int64_t) 4);
        }
    }
    
  cleanup:
    { }
    free(mem_317048);
    free(mem_317051);
    free(mem_317054);
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339311_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339311_end -
                 futhark_mc_segmap_parloop_339311_start;
        
        ctx->futhark_mc_segmap_parloop_339311_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_339311_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_339311_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_339309(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_310656 = tid;
    int num_tasks_337616 = info.nsubtasks;
    struct futhark_mc_task_339308 *futhark_mc_task_339308 =
                                  (struct futhark_mc_task_339308 *) args;
    struct futhark_context *ctx = futhark_mc_task_339308->ctx;
    uint64_t futhark_mc_segmap_task_339309_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_339309_start = get_wall_time();
    
    int64_t m_292674 = futhark_mc_task_339308->free_m_292674;
    int64_t n_292675 = futhark_mc_task_339308->free_n_292675;
    int64_t partition_sizze_292766 =
            futhark_mc_task_339308->free_partition_sizze_292766;
    struct memblock mem_312593 = {.desc ="mem_312593", .mem =
                                  futhark_mc_task_339308->free_mem_312593,
                                  .size =0, .references =NULL};
    struct memblock mem_312596 = {.desc ="mem_312596", .mem =
                                  futhark_mc_task_339308->free_mem_312596,
                                  .size =0, .references =NULL};
    int64_t bytes_316827 = futhark_mc_task_339308->free_bytes_316827;
    struct memblock ext_mem_317011 = {.desc ="ext_mem_317011", .mem =
                                      futhark_mc_task_339308->free_ext_mem_317011,
                                      .size =0, .references =NULL};
    struct memblock ext_mem_317012 = {.desc ="ext_mem_317012", .mem =
                                      futhark_mc_task_339308->free_ext_mem_317012,
                                      .size =0, .references =NULL};
    int64_t ext_317023 = futhark_mc_task_339308->free_ext_317023;
    struct memblock mem_317037 = {.desc ="mem_317037", .mem =
                                  futhark_mc_task_339308->free_mem_317037,
                                  .size =0, .references =NULL};
    struct memblock mem_317041 = {.desc ="mem_317041", .mem =
                                  futhark_mc_task_339308->free_mem_317041,
                                  .size =0, .references =NULL};
    struct memblock mem_317045 = {.desc ="mem_317045", .mem =
                                  futhark_mc_task_339308->free_mem_317045,
                                  .size =0, .references =NULL};
    int64_t iter_337617;
    struct futhark_mc_segmap_parloop_struct_339310
    futhark_mc_segmap_parloop_struct_339310;
    
    futhark_mc_segmap_parloop_struct_339310.ctx = ctx;
    futhark_mc_segmap_parloop_struct_339310.free_m_292674 = m_292674;
    futhark_mc_segmap_parloop_struct_339310.free_n_292675 = n_292675;
    futhark_mc_segmap_parloop_struct_339310.free_partition_sizze_292766 =
        partition_sizze_292766;
    futhark_mc_segmap_parloop_struct_339310.free_mem_312593 = mem_312593.mem;
    futhark_mc_segmap_parloop_struct_339310.free_mem_312596 = mem_312596.mem;
    futhark_mc_segmap_parloop_struct_339310.free_bytes_316827 = bytes_316827;
    futhark_mc_segmap_parloop_struct_339310.free_ext_mem_317011 =
        ext_mem_317011.mem;
    futhark_mc_segmap_parloop_struct_339310.free_ext_mem_317012 =
        ext_mem_317012.mem;
    futhark_mc_segmap_parloop_struct_339310.free_ext_317023 = ext_317023;
    futhark_mc_segmap_parloop_struct_339310.free_mem_317037 = mem_317037.mem;
    futhark_mc_segmap_parloop_struct_339310.free_mem_317041 = mem_317041.mem;
    futhark_mc_segmap_parloop_struct_339310.free_mem_317045 = mem_317045.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_339311_task;
    
    futhark_mc_segmap_parloop_339311_task.name =
        "futhark_mc_segmap_parloop_339311";
    futhark_mc_segmap_parloop_339311_task.fn = futhark_mc_segmap_parloop_339311;
    futhark_mc_segmap_parloop_339311_task.args =
        &futhark_mc_segmap_parloop_struct_339310;
    futhark_mc_segmap_parloop_339311_task.iterations = iterations;
    futhark_mc_segmap_parloop_339311_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_339311_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339311_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_339311_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_339311_task);
    
    if (futhark_mc_segmap_parloop_339311_err != 0) {
        err = futhark_mc_segmap_parloop_339311_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339311_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339311_total_end -
                 futhark_mc_segmap_parloop_339311_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339311_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339311_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339311_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_339309_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_339309_end -
                 futhark_mc_segmap_task_339309_start;
        
        ctx->futhark_mc_segmap_task_339309_runs[tid]++;
        ctx->futhark_mc_segmap_task_339309_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_339309_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_task_339320 {
    struct futhark_context *ctx;
    int64_t free_m_292609;
    int64_t free_n_292610;
    unsigned char *free_seasonal_l_mem_312581;
    unsigned char *free_mem_312584;
};
struct futhark_mc_segmap_parloop_struct_339322 {
    struct futhark_context *ctx;
    int64_t free_m_292609;
    int64_t free_n_292610;
    unsigned char *free_seasonal_l_mem_312581;
    unsigned char *free_mem_312584;
};
static int futhark_mc_segmap_parloop_339323(void *args, int64_t start,
                                            int64_t end, int flat_tid_297382,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_339322
    *futhark_mc_segmap_parloop_struct_339322 =
    (struct futhark_mc_segmap_parloop_struct_339322 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_339322->ctx;
    uint64_t futhark_mc_segmap_parloop_339323_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339323_start = get_wall_time();
    
    int64_t m_292609 = futhark_mc_segmap_parloop_struct_339322->free_m_292609;
    int64_t n_292610 = futhark_mc_segmap_parloop_struct_339322->free_n_292610;
    struct memblock seasonal_l_mem_312581 = {.desc ="seasonal_l_mem_312581",
                                             .mem =
                                             futhark_mc_segmap_parloop_struct_339322->free_seasonal_l_mem_312581,
                                             .size =0, .references =NULL};
    struct memblock mem_312584 = {.desc ="mem_312584", .mem =
                                  futhark_mc_segmap_parloop_struct_339322->free_mem_312584,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_317163 = start;
    
    for (; iter_317163 < end; iter_317163++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_317170 = m_292609;
        int64_t gtid_297383 = iter_317163;
        int64_t remnant_317171 = iter_317163 - gtid_297383;
        float defunc_2_reduce_res_292614;
        float defunc_2_reduce_res_292615;
        float redout_317165;
        float redout_317166;
        
        redout_317165 = -INFINITY;
        redout_317166 = INFINITY;
        for (int64_t i_317164 = 0; i_317164 < n_292610; i_317164++) {
            float x_317167;
            
            x_317167 = ((float *) seasonal_l_mem_312581.mem)[gtid_297383 *
                                                             n_292610 +
                                                             i_317164];
            
            float defunc_1_op_res_317168 = fmax32(x_317167, redout_317165);
            float defunc_1_op_res_317169 = fmin32(x_317167, redout_317166);
            float redout_tmp_317172 = defunc_1_op_res_317168;
            float redout_tmp_317173 = defunc_1_op_res_317169;
            
            redout_317165 = redout_tmp_317172;
            redout_317166 = redout_tmp_317173;
        }
        defunc_2_reduce_res_292614 = redout_317165;
        defunc_2_reduce_res_292615 = redout_317166;
        
        float v_292623 = defunc_2_reduce_res_292614 -
              defunc_2_reduce_res_292615;
        bool isinf_res_292624;
        
        isinf_res_292624 = futrts_isinf32(v_292623);
        
        float defunc_0_f_res_292625;
        
        if (isinf_res_292624) {
            defunc_0_f_res_292625 = NAN;
        } else {
            defunc_0_f_res_292625 = v_292623;
        }
        ((float *) mem_312584.mem)[gtid_297383] = defunc_0_f_res_292625;
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339323_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339323_end -
                 futhark_mc_segmap_parloop_339323_start;
        
        ctx->futhark_mc_segmap_parloop_339323_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_339323_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_339323_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_339321(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_297382 = tid;
    int num_tasks_317162 = info.nsubtasks;
    struct futhark_mc_task_339320 *futhark_mc_task_339320 =
                                  (struct futhark_mc_task_339320 *) args;
    struct futhark_context *ctx = futhark_mc_task_339320->ctx;
    uint64_t futhark_mc_segmap_task_339321_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_339321_start = get_wall_time();
    
    int64_t m_292609 = futhark_mc_task_339320->free_m_292609;
    int64_t n_292610 = futhark_mc_task_339320->free_n_292610;
    struct memblock seasonal_l_mem_312581 = {.desc ="seasonal_l_mem_312581",
                                             .mem =
                                             futhark_mc_task_339320->free_seasonal_l_mem_312581,
                                             .size =0, .references =NULL};
    struct memblock mem_312584 = {.desc ="mem_312584", .mem =
                                  futhark_mc_task_339320->free_mem_312584,
                                  .size =0, .references =NULL};
    int64_t iter_317163;
    struct futhark_mc_segmap_parloop_struct_339322
    futhark_mc_segmap_parloop_struct_339322;
    
    futhark_mc_segmap_parloop_struct_339322.ctx = ctx;
    futhark_mc_segmap_parloop_struct_339322.free_m_292609 = m_292609;
    futhark_mc_segmap_parloop_struct_339322.free_n_292610 = n_292610;
    futhark_mc_segmap_parloop_struct_339322.free_seasonal_l_mem_312581 =
        seasonal_l_mem_312581.mem;
    futhark_mc_segmap_parloop_struct_339322.free_mem_312584 = mem_312584.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_339323_task;
    
    futhark_mc_segmap_parloop_339323_task.name =
        "futhark_mc_segmap_parloop_339323";
    futhark_mc_segmap_parloop_339323_task.fn = futhark_mc_segmap_parloop_339323;
    futhark_mc_segmap_parloop_339323_task.args =
        &futhark_mc_segmap_parloop_struct_339322;
    futhark_mc_segmap_parloop_339323_task.iterations = iterations;
    futhark_mc_segmap_parloop_339323_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_339323_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339323_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_339323_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_339323_task);
    
    if (futhark_mc_segmap_parloop_339323_err != 0) {
        err = futhark_mc_segmap_parloop_339323_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339323_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339323_total_end -
                 futhark_mc_segmap_parloop_339323_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339323_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339323_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339323_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_339321_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_339321_end -
                 futhark_mc_segmap_task_339321_start;
        
        ctx->futhark_mc_segmap_task_339321_runs[tid]++;
        ctx->futhark_mc_segmap_task_339321_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_339321_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_segmap_parloop_struct_339325 {
    struct futhark_context *ctx;
    int64_t free_m_292609;
    int64_t free_n_292610;
    unsigned char *free_seasonal_l_mem_312581;
    unsigned char *free_mem_312584;
};
struct futhark_mc_task_339327 {
    struct futhark_context *ctx;
    int64_t free_n_292610;
    int64_t free_gtid_297389;
    unsigned char *free_seasonal_l_mem_312581;
    float *retval_defunc_2_reduce_res_297391;
    float *retval_defunc_2_reduce_res_297392;
};
struct futhark_mc_segred_stage_1_parloop_struct_339331 {
    struct futhark_context *ctx;
    int64_t free_n_292610;
    int64_t free_gtid_297389;
    unsigned char *free_seasonal_l_mem_312581;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_317187;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_317189;
};
static int futhark_mc_segred_stage_1_parloop_339332(void *args, int64_t start,
                                                    int64_t end,
                                                    int flat_tid_317175,
                                                    int tid)
{
    int err = 0;
    struct futhark_mc_segred_stage_1_parloop_struct_339331
    *futhark_mc_segred_stage_1_parloop_struct_339331 =
    (struct futhark_mc_segred_stage_1_parloop_struct_339331 *) args;
    struct futhark_context *ctx =
                           futhark_mc_segred_stage_1_parloop_struct_339331->ctx;
    uint64_t futhark_mc_segred_stage_1_parloop_339332_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_339332_start = get_wall_time();
    
    int64_t n_292610 =
            futhark_mc_segred_stage_1_parloop_struct_339331->free_n_292610;
    int64_t gtid_297389 =
            futhark_mc_segred_stage_1_parloop_struct_339331->free_gtid_297389;
    struct memblock seasonal_l_mem_312581 = {.desc ="seasonal_l_mem_312581",
                                             .mem =
                                             futhark_mc_segred_stage_1_parloop_struct_339331->free_seasonal_l_mem_312581,
                                             .size =0, .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_317187 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_317187",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_339331->free_reduce_stage_1_tid_res_arr_mem_317187,
                                                             .size =0,
                                                             .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_317189 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_317189",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_339331->free_reduce_stage_1_tid_res_arr_mem_317189,
                                                             .size =0,
                                                             .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_317191 = start;
    float x_317177;
    float x_317178;
    float x_317180;
    float x_317181;
    float local_acc_317192 = -INFINITY;
    float local_acc_317193 = INFINITY;
    
    for (; iter_317191 < end; iter_317191++) {
        int64_t gtid_317176 = iter_317191;
        float x_317183;
        
        x_317183 = ((float *) seasonal_l_mem_312581.mem)[gtid_297389 *
                                                         n_292610 +
                                                         gtid_317176];
        // save map-out results
        { }
        // Load accum params
        {
            x_317177 = local_acc_317192;
        }
        // Load next params
        {
            x_317178 = x_317183;
        }
        // Red body
        {
            float defunc_1_op_res_317179 = fmax32(x_317177, x_317178);
            
            local_acc_317192 = defunc_1_op_res_317179;
        }
        // Load accum params
        {
            x_317180 = local_acc_317193;
        }
        // Load next params
        {
            x_317181 = x_317183;
        }
        // Red body
        {
            float defunc_1_op_res_317182 = fmin32(x_317180, x_317181);
            
            local_acc_317193 = defunc_1_op_res_317182;
        }
    }
    ((float *) reduce_stage_1_tid_res_arr_mem_317187.mem)[flat_tid_317175] =
        local_acc_317192;
    ((float *) reduce_stage_1_tid_res_arr_mem_317189.mem)[flat_tid_317175] =
        local_acc_317193;
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_339332_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_339332_end -
                 futhark_mc_segred_stage_1_parloop_339332_start;
        
        ctx->futhark_mc_segred_stage_1_parloop_339332_runs[tid]++;
        ctx->futhark_mc_segred_stage_1_parloop_339332_total_runtime[tid] +=
            elapsed;
        ctx->futhark_mc_segred_stage_1_parloop_339332_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segred_task_339328(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_317175 = tid;
    int num_tasks_317186 = info.nsubtasks;
    struct futhark_mc_task_339327 *futhark_mc_task_339327 =
                                  (struct futhark_mc_task_339327 *) args;
    struct futhark_context *ctx = futhark_mc_task_339327->ctx;
    uint64_t futhark_mc_segred_task_339328_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_task_339328_start = get_wall_time();
    
    int64_t n_292610 = futhark_mc_task_339327->free_n_292610;
    int64_t gtid_297389 = futhark_mc_task_339327->free_gtid_297389;
    struct memblock seasonal_l_mem_312581 = {.desc ="seasonal_l_mem_312581",
                                             .mem =
                                             futhark_mc_task_339327->free_seasonal_l_mem_312581,
                                             .size =0, .references =NULL};
    float defunc_2_reduce_res_297391 =
          *futhark_mc_task_339327->retval_defunc_2_reduce_res_297391;
    float defunc_2_reduce_res_297392 =
          *futhark_mc_task_339327->retval_defunc_2_reduce_res_297392;
    size_t reduce_stage_1_tid_res_arr_mem_317187_cached_sizze_339329 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_317187 = NULL;
    size_t reduce_stage_1_tid_res_arr_mem_317189_cached_sizze_339330 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_317189 = NULL;
    
    if (reduce_stage_1_tid_res_arr_mem_317187_cached_sizze_339329 <
        (size_t) ((int64_t) 4 * num_tasks_317186)) {
        reduce_stage_1_tid_res_arr_mem_317187 =
            realloc(reduce_stage_1_tid_res_arr_mem_317187, (int64_t) 4 *
                    num_tasks_317186);
        reduce_stage_1_tid_res_arr_mem_317187_cached_sizze_339329 =
            (int64_t) 4 * num_tasks_317186;
    }
    if (reduce_stage_1_tid_res_arr_mem_317189_cached_sizze_339330 <
        (size_t) ((int64_t) 4 * num_tasks_317186)) {
        reduce_stage_1_tid_res_arr_mem_317189 =
            realloc(reduce_stage_1_tid_res_arr_mem_317189, (int64_t) 4 *
                    num_tasks_317186);
        reduce_stage_1_tid_res_arr_mem_317189_cached_sizze_339330 =
            (int64_t) 4 * num_tasks_317186;
    }
    
    int64_t iter_317191;
    struct futhark_mc_segred_stage_1_parloop_struct_339331
    futhark_mc_segred_stage_1_parloop_struct_339331;
    
    futhark_mc_segred_stage_1_parloop_struct_339331.ctx = ctx;
    futhark_mc_segred_stage_1_parloop_struct_339331.free_n_292610 = n_292610;
    futhark_mc_segred_stage_1_parloop_struct_339331.free_gtid_297389 =
        gtid_297389;
    futhark_mc_segred_stage_1_parloop_struct_339331.free_seasonal_l_mem_312581 =
        seasonal_l_mem_312581.mem;
    futhark_mc_segred_stage_1_parloop_struct_339331.free_reduce_stage_1_tid_res_arr_mem_317187 =
        reduce_stage_1_tid_res_arr_mem_317187;
    futhark_mc_segred_stage_1_parloop_struct_339331.free_reduce_stage_1_tid_res_arr_mem_317189 =
        reduce_stage_1_tid_res_arr_mem_317189;
    
    struct scheduler_parloop futhark_mc_segred_stage_1_parloop_339332_task;
    
    futhark_mc_segred_stage_1_parloop_339332_task.name =
        "futhark_mc_segred_stage_1_parloop_339332";
    futhark_mc_segred_stage_1_parloop_339332_task.fn =
        futhark_mc_segred_stage_1_parloop_339332;
    futhark_mc_segred_stage_1_parloop_339332_task.args =
        &futhark_mc_segred_stage_1_parloop_struct_339331;
    futhark_mc_segred_stage_1_parloop_339332_task.iterations = iterations;
    futhark_mc_segred_stage_1_parloop_339332_task.info = info;
    
    uint64_t futhark_mc_segred_stage_1_parloop_339332_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_339332_total_start = get_wall_time();
    
    int futhark_mc_segred_stage_1_parloop_339332_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segred_stage_1_parloop_339332_task);
    
    if (futhark_mc_segred_stage_1_parloop_339332_err != 0) {
        err = futhark_mc_segred_stage_1_parloop_339332_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_339332_total_end =
                 get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_339332_total_end -
                 futhark_mc_segred_stage_1_parloop_339332_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_339332_total_runs,
                           1, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_339332_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_339332_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    // neutral-initialise the output
    {
        defunc_2_reduce_res_297391 = -INFINITY;
        defunc_2_reduce_res_297392 = INFINITY;
    }
    
    float x_317194;
    float x_317195;
    float x_317197;
    float x_317198;
    
    for (int32_t i_317200 = 0; i_317200 < num_tasks_317186; i_317200++) {
        flat_tid_317175 = i_317200;
        // Apply main thread reduction
        {
            // load acc params
            {
                x_317194 = defunc_2_reduce_res_297391;
            }
            // load next params
            {
                x_317195 =
                    ((float *) reduce_stage_1_tid_res_arr_mem_317187)[flat_tid_317175];
            }
            // red body
            {
                float defunc_1_op_res_317196 = fmax32(x_317194, x_317195);
                
                defunc_2_reduce_res_297391 = defunc_1_op_res_317196;
            }
            // load acc params
            {
                x_317197 = defunc_2_reduce_res_297392;
            }
            // load next params
            {
                x_317198 =
                    ((float *) reduce_stage_1_tid_res_arr_mem_317189)[flat_tid_317175];
            }
            // red body
            {
                float defunc_1_op_res_317199 = fmin32(x_317197, x_317198);
                
                defunc_2_reduce_res_297392 = defunc_1_op_res_317199;
            }
        }
    }
    
  cleanup:
    {
        free(reduce_stage_1_tid_res_arr_mem_317187);
        free(reduce_stage_1_tid_res_arr_mem_317189);
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_task_339328_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_task_339328_end -
                 futhark_mc_segred_task_339328_start;
        
        ctx->futhark_mc_segred_task_339328_runs[tid]++;
        ctx->futhark_mc_segred_task_339328_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segred_task_339328_iter[tid] += iterations;
    }
    if (err == 0) {
        *futhark_mc_task_339327->retval_defunc_2_reduce_res_297391 =
            defunc_2_reduce_res_297391;
        *futhark_mc_task_339327->retval_defunc_2_reduce_res_297392 =
            defunc_2_reduce_res_297392;
    }
    return err;
}
static int futhark_mc_segmap_parloop_339326(void *args, int64_t start,
                                            int64_t end, int flat_tid_297388,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_339325
    *futhark_mc_segmap_parloop_struct_339325 =
    (struct futhark_mc_segmap_parloop_struct_339325 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_339325->ctx;
    uint64_t futhark_mc_segmap_parloop_339326_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339326_start = get_wall_time();
    
    int64_t m_292609 = futhark_mc_segmap_parloop_struct_339325->free_m_292609;
    int64_t n_292610 = futhark_mc_segmap_parloop_struct_339325->free_n_292610;
    struct memblock seasonal_l_mem_312581 = {.desc ="seasonal_l_mem_312581",
                                             .mem =
                                             futhark_mc_segmap_parloop_struct_339325->free_seasonal_l_mem_312581,
                                             .size =0, .references =NULL};
    struct memblock mem_312584 = {.desc ="mem_312584", .mem =
                                  futhark_mc_segmap_parloop_struct_339325->free_mem_312584,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_317174 = start;
    
    for (; iter_317174 < end; iter_317174++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_317184 = m_292609;
        int64_t gtid_297389 = iter_317174;
        int64_t remnant_317185 = iter_317174 - gtid_297389;
        float defunc_2_reduce_res_297391;
        float defunc_2_reduce_res_297392;
        int64_t flat_tid_317175 = (int64_t) 0;
        int32_t num_tasks_317186;
        
        defunc_2_reduce_res_297391 = 0.0F;
        defunc_2_reduce_res_297392 = 0.0F;
        
        struct futhark_mc_task_339327 futhark_mc_task_339327;
        
        futhark_mc_task_339327.ctx = ctx;
        futhark_mc_task_339327.free_n_292610 = n_292610;
        futhark_mc_task_339327.free_gtid_297389 = gtid_297389;
        futhark_mc_task_339327.free_seasonal_l_mem_312581 =
            seasonal_l_mem_312581.mem;
        futhark_mc_task_339327.retval_defunc_2_reduce_res_297391 =
            &defunc_2_reduce_res_297391;
        futhark_mc_task_339327.retval_defunc_2_reduce_res_297392 =
            &defunc_2_reduce_res_297392;
        
        struct scheduler_segop futhark_mc_task_339327_task;
        
        futhark_mc_task_339327_task.args = &futhark_mc_task_339327;
        futhark_mc_task_339327_task.top_level_fn =
            futhark_mc_segred_task_339328;
        futhark_mc_task_339327_task.name = "futhark_mc_segred_task_339328";
        futhark_mc_task_339327_task.iterations = n_292610;
        futhark_mc_task_339327_task.task_time =
            &ctx->futhark_mc_segred_task_339328_total_time;
        futhark_mc_task_339327_task.task_iter =
            &ctx->futhark_mc_segred_task_339328_total_iter;
        futhark_mc_task_339327_task.sched = STATIC;
        futhark_mc_task_339327_task.nested_fn = NULL;
        
        int futhark_mc_segred_task_339328_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_339327_task);
        
        if (futhark_mc_segred_task_339328_err != 0) {
            ;
            err = futhark_mc_segred_task_339328_err;
            goto cleanup;
        }
        
        float v_297402 = defunc_2_reduce_res_297391 -
              defunc_2_reduce_res_297392;
        bool isinf_res_297403;
        
        isinf_res_297403 = futrts_isinf32(v_297402);
        
        float defunc_0_f_res_297404;
        
        if (isinf_res_297403) {
            defunc_0_f_res_297404 = NAN;
        } else {
            defunc_0_f_res_297404 = v_297402;
        }
        ((float *) mem_312584.mem)[gtid_297389] = defunc_0_f_res_297404;
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339326_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339326_end -
                 futhark_mc_segmap_parloop_339326_start;
        
        ctx->futhark_mc_segmap_parloop_339326_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_339326_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_339326_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_nested_task_339324(void *args, int64_t iterations,
                                         int tid, struct scheduler_info info)
{
    int err = 0;
    int flat_tid_297388 = tid;
    int num_tasks_317162 = info.nsubtasks;
    struct futhark_mc_task_339320 *futhark_mc_task_339320 =
                                  (struct futhark_mc_task_339320 *) args;
    struct futhark_context *ctx = futhark_mc_task_339320->ctx;
    uint64_t futhark_mc_segmap_nested_task_339324_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_nested_task_339324_start = get_wall_time();
    
    int64_t m_292609 = futhark_mc_task_339320->free_m_292609;
    int64_t n_292610 = futhark_mc_task_339320->free_n_292610;
    struct memblock seasonal_l_mem_312581 = {.desc ="seasonal_l_mem_312581",
                                             .mem =
                                             futhark_mc_task_339320->free_seasonal_l_mem_312581,
                                             .size =0, .references =NULL};
    struct memblock mem_312584 = {.desc ="mem_312584", .mem =
                                  futhark_mc_task_339320->free_mem_312584,
                                  .size =0, .references =NULL};
    int64_t iter_317174;
    struct futhark_mc_segmap_parloop_struct_339325
    futhark_mc_segmap_parloop_struct_339325;
    
    futhark_mc_segmap_parloop_struct_339325.ctx = ctx;
    futhark_mc_segmap_parloop_struct_339325.free_m_292609 = m_292609;
    futhark_mc_segmap_parloop_struct_339325.free_n_292610 = n_292610;
    futhark_mc_segmap_parloop_struct_339325.free_seasonal_l_mem_312581 =
        seasonal_l_mem_312581.mem;
    futhark_mc_segmap_parloop_struct_339325.free_mem_312584 = mem_312584.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_339326_task;
    
    futhark_mc_segmap_parloop_339326_task.name =
        "futhark_mc_segmap_parloop_339326";
    futhark_mc_segmap_parloop_339326_task.fn = futhark_mc_segmap_parloop_339326;
    futhark_mc_segmap_parloop_339326_task.args =
        &futhark_mc_segmap_parloop_struct_339325;
    futhark_mc_segmap_parloop_339326_task.iterations = iterations;
    futhark_mc_segmap_parloop_339326_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_339326_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339326_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_339326_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_339326_task);
    
    if (futhark_mc_segmap_parloop_339326_err != 0) {
        err = futhark_mc_segmap_parloop_339326_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339326_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339326_total_end -
                 futhark_mc_segmap_parloop_339326_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339326_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339326_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339326_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_nested_task_339324_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_nested_task_339324_end -
                 futhark_mc_segmap_nested_task_339324_start;
        
        ctx->futhark_mc_segmap_nested_task_339324_runs[tid]++;
        ctx->futhark_mc_segmap_nested_task_339324_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_nested_task_339324_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_task_339335 {
    struct futhark_context *ctx;
    double *retval_defunc_2_reduce_res_292636;
    double *retval_defunc_2_reduce_res_292637;
    unsigned char *retval_mem_312584;
};
struct futhark_mc_segred_stage_1_parloop_struct_339339 {
    struct futhark_context *ctx;
    unsigned char *free_mem_312584;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_317163;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_317165;
};
static int futhark_mc_segred_stage_1_parloop_339340(void *args, int64_t start,
                                                    int64_t end,
                                                    int flat_tid_297405,
                                                    int tid)
{
    int err = 0;
    struct futhark_mc_segred_stage_1_parloop_struct_339339
    *futhark_mc_segred_stage_1_parloop_struct_339339 =
    (struct futhark_mc_segred_stage_1_parloop_struct_339339 *) args;
    struct futhark_context *ctx =
                           futhark_mc_segred_stage_1_parloop_struct_339339->ctx;
    uint64_t futhark_mc_segred_stage_1_parloop_339340_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_339340_start = get_wall_time();
    
    struct memblock mem_312584 = {.desc ="mem_312584", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_339339->free_mem_312584,
                                  .size =0, .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_317163 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_317163",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_339339->free_reduce_stage_1_tid_res_arr_mem_317163,
                                                             .size =0,
                                                             .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_317165 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_317165",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_339339->free_reduce_stage_1_tid_res_arr_mem_317165,
                                                             .size =0,
                                                             .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_317167 = start;
    double x_292639;
    double x_292640;
    double x_292642;
    double x_292643;
    double local_acc_317168 = 0.0;
    double local_acc_317169 = 0.0;
    
    for (; iter_317167 < end; iter_317167++) {
        int64_t gtid_297406 = iter_317167;
        int64_t x__292646 = add64((int64_t) 1, gtid_297406);
        double i64_res_292647 = sitofp_i64_f64(x__292646);
        double defunc_0_f_res_292648 = i64_res_292647 * i64_res_292647;
        
        // save map-out results
        {
            ((double *) mem_312584.mem)[gtid_297406] = i64_res_292647;
        }
        // Load accum params
        {
            x_292639 = local_acc_317168;
        }
        // Load next params
        {
            x_292640 = i64_res_292647;
        }
        // Red body
        {
            double defunc_1_op_res_292641 = x_292639 + x_292640;
            
            local_acc_317168 = defunc_1_op_res_292641;
        }
        // Load accum params
        {
            x_292642 = local_acc_317169;
        }
        // Load next params
        {
            x_292643 = defunc_0_f_res_292648;
        }
        // Red body
        {
            double defunc_1_op_res_292644 = x_292642 + x_292643;
            
            local_acc_317169 = defunc_1_op_res_292644;
        }
    }
    ((double *) reduce_stage_1_tid_res_arr_mem_317163.mem)[flat_tid_297405] =
        local_acc_317168;
    ((double *) reduce_stage_1_tid_res_arr_mem_317165.mem)[flat_tid_297405] =
        local_acc_317169;
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_339340_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_339340_end -
                 futhark_mc_segred_stage_1_parloop_339340_start;
        
        ctx->futhark_mc_segred_stage_1_parloop_339340_runs[tid]++;
        ctx->futhark_mc_segred_stage_1_parloop_339340_total_runtime[tid] +=
            elapsed;
        ctx->futhark_mc_segred_stage_1_parloop_339340_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segred_task_339336(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_297405 = tid;
    int num_tasks_317162 = info.nsubtasks;
    struct futhark_mc_task_339335 *futhark_mc_task_339335 =
                                  (struct futhark_mc_task_339335 *) args;
    struct futhark_context *ctx = futhark_mc_task_339335->ctx;
    uint64_t futhark_mc_segred_task_339336_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_task_339336_start = get_wall_time();
    
    double defunc_2_reduce_res_292636 =
           *futhark_mc_task_339335->retval_defunc_2_reduce_res_292636;
    double defunc_2_reduce_res_292637 =
           *futhark_mc_task_339335->retval_defunc_2_reduce_res_292637;
    struct memblock mem_312584 = {.desc ="mem_312584", .mem =
                                  futhark_mc_task_339335->retval_mem_312584,
                                  .size =0, .references =NULL};
    size_t reduce_stage_1_tid_res_arr_mem_317163_cached_sizze_339337 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_317163 = NULL;
    size_t reduce_stage_1_tid_res_arr_mem_317165_cached_sizze_339338 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_317165 = NULL;
    
    if (reduce_stage_1_tid_res_arr_mem_317163_cached_sizze_339337 <
        (size_t) ((int64_t) 8 * num_tasks_317162)) {
        reduce_stage_1_tid_res_arr_mem_317163 =
            realloc(reduce_stage_1_tid_res_arr_mem_317163, (int64_t) 8 *
                    num_tasks_317162);
        reduce_stage_1_tid_res_arr_mem_317163_cached_sizze_339337 =
            (int64_t) 8 * num_tasks_317162;
    }
    if (reduce_stage_1_tid_res_arr_mem_317165_cached_sizze_339338 <
        (size_t) ((int64_t) 8 * num_tasks_317162)) {
        reduce_stage_1_tid_res_arr_mem_317165 =
            realloc(reduce_stage_1_tid_res_arr_mem_317165, (int64_t) 8 *
                    num_tasks_317162);
        reduce_stage_1_tid_res_arr_mem_317165_cached_sizze_339338 =
            (int64_t) 8 * num_tasks_317162;
    }
    
    int64_t iter_317167;
    struct futhark_mc_segred_stage_1_parloop_struct_339339
    futhark_mc_segred_stage_1_parloop_struct_339339;
    
    futhark_mc_segred_stage_1_parloop_struct_339339.ctx = ctx;
    futhark_mc_segred_stage_1_parloop_struct_339339.free_mem_312584 =
        mem_312584.mem;
    futhark_mc_segred_stage_1_parloop_struct_339339.free_reduce_stage_1_tid_res_arr_mem_317163 =
        reduce_stage_1_tid_res_arr_mem_317163;
    futhark_mc_segred_stage_1_parloop_struct_339339.free_reduce_stage_1_tid_res_arr_mem_317165 =
        reduce_stage_1_tid_res_arr_mem_317165;
    
    struct scheduler_parloop futhark_mc_segred_stage_1_parloop_339340_task;
    
    futhark_mc_segred_stage_1_parloop_339340_task.name =
        "futhark_mc_segred_stage_1_parloop_339340";
    futhark_mc_segred_stage_1_parloop_339340_task.fn =
        futhark_mc_segred_stage_1_parloop_339340;
    futhark_mc_segred_stage_1_parloop_339340_task.args =
        &futhark_mc_segred_stage_1_parloop_struct_339339;
    futhark_mc_segred_stage_1_parloop_339340_task.iterations = iterations;
    futhark_mc_segred_stage_1_parloop_339340_task.info = info;
    
    uint64_t futhark_mc_segred_stage_1_parloop_339340_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_339340_total_start = get_wall_time();
    
    int futhark_mc_segred_stage_1_parloop_339340_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segred_stage_1_parloop_339340_task);
    
    if (futhark_mc_segred_stage_1_parloop_339340_err != 0) {
        err = futhark_mc_segred_stage_1_parloop_339340_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_339340_total_end =
                 get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_339340_total_end -
                 futhark_mc_segred_stage_1_parloop_339340_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_339340_total_runs,
                           1, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_339340_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_339340_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    // neutral-initialise the output
    {
        defunc_2_reduce_res_292636 = 0.0;
        defunc_2_reduce_res_292637 = 0.0;
    }
    
    double x_317170;
    double x_317171;
    double x_317173;
    double x_317174;
    
    for (int32_t i_317176 = 0; i_317176 < num_tasks_317162; i_317176++) {
        flat_tid_297405 = i_317176;
        // Apply main thread reduction
        {
            // load acc params
            {
                x_317170 = defunc_2_reduce_res_292636;
            }
            // load next params
            {
                x_317171 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_317163)[flat_tid_297405];
            }
            // red body
            {
                double defunc_1_op_res_317172 = x_317170 + x_317171;
                
                defunc_2_reduce_res_292636 = defunc_1_op_res_317172;
            }
            // load acc params
            {
                x_317173 = defunc_2_reduce_res_292637;
            }
            // load next params
            {
                x_317174 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_317165)[flat_tid_297405];
            }
            // red body
            {
                double defunc_1_op_res_317175 = x_317173 + x_317174;
                
                defunc_2_reduce_res_292637 = defunc_1_op_res_317175;
            }
        }
    }
    
  cleanup:
    {
        free(reduce_stage_1_tid_res_arr_mem_317163);
        free(reduce_stage_1_tid_res_arr_mem_317165);
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_task_339336_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_task_339336_end -
                 futhark_mc_segred_task_339336_start;
        
        ctx->futhark_mc_segred_task_339336_runs[tid]++;
        ctx->futhark_mc_segred_task_339336_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segred_task_339336_iter[tid] += iterations;
    }
    if (err == 0) {
        *futhark_mc_task_339335->retval_defunc_2_reduce_res_292636 =
            defunc_2_reduce_res_292636;
        *futhark_mc_task_339335->retval_defunc_2_reduce_res_292637 =
            defunc_2_reduce_res_292637;
        futhark_mc_task_339335->retval_mem_312584 = mem_312584.mem;
    }
    return err;
}
struct futhark_mc_task_339341 {
    struct futhark_context *ctx;
    int64_t free_m_292626;
    int64_t free_n_292627;
    double free_i64_res_292652;
    double free_b11_292658;
    double free_c11_292659;
    unsigned char *free_trend_l_mem_312581;
    unsigned char *free_mem_312584;
    unsigned char *free_mem_312587;
};
struct futhark_mc_segmap_parloop_struct_339343 {
    struct futhark_context *ctx;
    int64_t free_m_292626;
    int64_t free_n_292627;
    double free_i64_res_292652;
    double free_b11_292658;
    double free_c11_292659;
    unsigned char *free_trend_l_mem_312581;
    unsigned char *free_mem_312584;
    unsigned char *free_mem_312587;
};
static int futhark_mc_segmap_parloop_339344(void *args, int64_t start,
                                            int64_t end, int flat_tid_297407,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_339343
    *futhark_mc_segmap_parloop_struct_339343 =
    (struct futhark_mc_segmap_parloop_struct_339343 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_339343->ctx;
    uint64_t futhark_mc_segmap_parloop_339344_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339344_start = get_wall_time();
    
    int64_t m_292626 = futhark_mc_segmap_parloop_struct_339343->free_m_292626;
    int64_t n_292627 = futhark_mc_segmap_parloop_struct_339343->free_n_292627;
    double i64_res_292652 =
           futhark_mc_segmap_parloop_struct_339343->free_i64_res_292652;
    double b11_292658 =
           futhark_mc_segmap_parloop_struct_339343->free_b11_292658;
    double c11_292659 =
           futhark_mc_segmap_parloop_struct_339343->free_c11_292659;
    struct memblock trend_l_mem_312581 = {.desc ="trend_l_mem_312581", .mem =
                                          futhark_mc_segmap_parloop_struct_339343->free_trend_l_mem_312581,
                                          .size =0, .references =NULL};
    struct memblock mem_312584 = {.desc ="mem_312584", .mem =
                                  futhark_mc_segmap_parloop_struct_339343->free_mem_312584,
                                  .size =0, .references =NULL};
    struct memblock mem_312587 = {.desc ="mem_312587", .mem =
                                  futhark_mc_segmap_parloop_struct_339343->free_mem_312587,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_317178 = start;
    
    for (; iter_317178 < end; iter_317178++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_317188 = m_292626;
        int64_t gtid_297408 = iter_317178;
        int64_t remnant_317189 = iter_317178 - gtid_297408;
        double defunc_2_reduce_res_292662;
        double redout_317180 = 0.0;
        
        for (int64_t i_317179 = 0; i_317179 < n_292627; i_317179++) {
            double x_317181;
            
            x_317181 = ((double *) mem_312584.mem)[i_317179];
            
            float x_317182;
            
            x_317182 = ((float *) trend_l_mem_312581.mem)[gtid_297408 *
                                                          n_292627 + i_317179];
            
            double y_317183 = c11_292659 * x_317181;
            double x_317184 = b11_292658 + y_317183;
            double f32_res_317185 = fpconv_f32_f64(x_317182);
            double defunc_1_f_res_317186 = x_317184 * f32_res_317185;
            double defunc_1_op_res_317187 = defunc_1_f_res_317186 +
                   redout_317180;
            double redout_tmp_317190 = defunc_1_op_res_317187;
            
            redout_317180 = redout_tmp_317190;
        }
        defunc_2_reduce_res_292662 = redout_317180;
        
        double defunc_0_f_res_292672 = i64_res_292652 *
               defunc_2_reduce_res_292662;
        float defunc_0_f_res_292673 = fpconv_f64_f32(defunc_0_f_res_292672);
        
        ((float *) mem_312587.mem)[gtid_297408] = defunc_0_f_res_292673;
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339344_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339344_end -
                 futhark_mc_segmap_parloop_339344_start;
        
        ctx->futhark_mc_segmap_parloop_339344_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_339344_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_339344_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_task_339342(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_297407 = tid;
    int num_tasks_317177 = info.nsubtasks;
    struct futhark_mc_task_339341 *futhark_mc_task_339341 =
                                  (struct futhark_mc_task_339341 *) args;
    struct futhark_context *ctx = futhark_mc_task_339341->ctx;
    uint64_t futhark_mc_segmap_task_339342_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_task_339342_start = get_wall_time();
    
    int64_t m_292626 = futhark_mc_task_339341->free_m_292626;
    int64_t n_292627 = futhark_mc_task_339341->free_n_292627;
    double i64_res_292652 = futhark_mc_task_339341->free_i64_res_292652;
    double b11_292658 = futhark_mc_task_339341->free_b11_292658;
    double c11_292659 = futhark_mc_task_339341->free_c11_292659;
    struct memblock trend_l_mem_312581 = {.desc ="trend_l_mem_312581", .mem =
                                          futhark_mc_task_339341->free_trend_l_mem_312581,
                                          .size =0, .references =NULL};
    struct memblock mem_312584 = {.desc ="mem_312584", .mem =
                                  futhark_mc_task_339341->free_mem_312584,
                                  .size =0, .references =NULL};
    struct memblock mem_312587 = {.desc ="mem_312587", .mem =
                                  futhark_mc_task_339341->free_mem_312587,
                                  .size =0, .references =NULL};
    int64_t iter_317178;
    struct futhark_mc_segmap_parloop_struct_339343
    futhark_mc_segmap_parloop_struct_339343;
    
    futhark_mc_segmap_parloop_struct_339343.ctx = ctx;
    futhark_mc_segmap_parloop_struct_339343.free_m_292626 = m_292626;
    futhark_mc_segmap_parloop_struct_339343.free_n_292627 = n_292627;
    futhark_mc_segmap_parloop_struct_339343.free_i64_res_292652 =
        i64_res_292652;
    futhark_mc_segmap_parloop_struct_339343.free_b11_292658 = b11_292658;
    futhark_mc_segmap_parloop_struct_339343.free_c11_292659 = c11_292659;
    futhark_mc_segmap_parloop_struct_339343.free_trend_l_mem_312581 =
        trend_l_mem_312581.mem;
    futhark_mc_segmap_parloop_struct_339343.free_mem_312584 = mem_312584.mem;
    futhark_mc_segmap_parloop_struct_339343.free_mem_312587 = mem_312587.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_339344_task;
    
    futhark_mc_segmap_parloop_339344_task.name =
        "futhark_mc_segmap_parloop_339344";
    futhark_mc_segmap_parloop_339344_task.fn = futhark_mc_segmap_parloop_339344;
    futhark_mc_segmap_parloop_339344_task.args =
        &futhark_mc_segmap_parloop_struct_339343;
    futhark_mc_segmap_parloop_339344_task.iterations = iterations;
    futhark_mc_segmap_parloop_339344_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_339344_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339344_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_339344_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_339344_task);
    
    if (futhark_mc_segmap_parloop_339344_err != 0) {
        err = futhark_mc_segmap_parloop_339344_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339344_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339344_total_end -
                 futhark_mc_segmap_parloop_339344_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339344_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339344_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339344_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_task_339342_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_task_339342_end -
                 futhark_mc_segmap_task_339342_start;
        
        ctx->futhark_mc_segmap_task_339342_runs[tid]++;
        ctx->futhark_mc_segmap_task_339342_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_task_339342_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_mc_segmap_parloop_struct_339346 {
    struct futhark_context *ctx;
    int64_t free_m_292626;
    int64_t free_n_292627;
    double free_i64_res_292652;
    double free_b11_292658;
    double free_c11_292659;
    unsigned char *free_trend_l_mem_312581;
    unsigned char *free_mem_312584;
    unsigned char *free_mem_312587;
};
struct futhark_mc_task_339348 {
    struct futhark_context *ctx;
    int64_t free_n_292627;
    double free_b11_292658;
    double free_c11_292659;
    int64_t free_gtid_297414;
    unsigned char *free_trend_l_mem_312581;
    unsigned char *free_mem_312584;
    double *retval_defunc_2_reduce_res_297416;
};
struct futhark_mc_segred_stage_1_parloop_struct_339351 {
    struct futhark_context *ctx;
    int64_t free_n_292627;
    double free_b11_292658;
    double free_c11_292659;
    int64_t free_gtid_297414;
    unsigned char *free_trend_l_mem_312581;
    unsigned char *free_mem_312584;
    unsigned char *free_reduce_stage_1_tid_res_arr_mem_317206;
};
static int futhark_mc_segred_stage_1_parloop_339352(void *args, int64_t start,
                                                    int64_t end,
                                                    int flat_tid_317192,
                                                    int tid)
{
    int err = 0;
    struct futhark_mc_segred_stage_1_parloop_struct_339351
    *futhark_mc_segred_stage_1_parloop_struct_339351 =
    (struct futhark_mc_segred_stage_1_parloop_struct_339351 *) args;
    struct futhark_context *ctx =
                           futhark_mc_segred_stage_1_parloop_struct_339351->ctx;
    uint64_t futhark_mc_segred_stage_1_parloop_339352_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_339352_start = get_wall_time();
    
    int64_t n_292627 =
            futhark_mc_segred_stage_1_parloop_struct_339351->free_n_292627;
    double b11_292658 =
           futhark_mc_segred_stage_1_parloop_struct_339351->free_b11_292658;
    double c11_292659 =
           futhark_mc_segred_stage_1_parloop_struct_339351->free_c11_292659;
    int64_t gtid_297414 =
            futhark_mc_segred_stage_1_parloop_struct_339351->free_gtid_297414;
    struct memblock trend_l_mem_312581 = {.desc ="trend_l_mem_312581", .mem =
                                          futhark_mc_segred_stage_1_parloop_struct_339351->free_trend_l_mem_312581,
                                          .size =0, .references =NULL};
    struct memblock mem_312584 = {.desc ="mem_312584", .mem =
                                  futhark_mc_segred_stage_1_parloop_struct_339351->free_mem_312584,
                                  .size =0, .references =NULL};
    struct memblock reduce_stage_1_tid_res_arr_mem_317206 = {.desc =
                                                             "reduce_stage_1_tid_res_arr_mem_317206",
                                                             .mem =
                                                             futhark_mc_segred_stage_1_parloop_struct_339351->free_reduce_stage_1_tid_res_arr_mem_317206,
                                                             .size =0,
                                                             .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_317208 = start;
    double x_317194;
    double x_317195;
    double local_acc_317209 = 0.0;
    
    for (; iter_317208 < end; iter_317208++) {
        int64_t gtid_317193 = iter_317208;
        double x_317197;
        
        x_317197 = ((double *) mem_312584.mem)[gtid_317193];
        
        float x_317198;
        
        x_317198 = ((float *) trend_l_mem_312581.mem)[gtid_297414 * n_292627 +
                                                      gtid_317193];
        
        double y_317199 = c11_292659 * x_317197;
        double x_317200 = b11_292658 + y_317199;
        double f32_res_317201 = fpconv_f32_f64(x_317198);
        double defunc_1_f_res_317202 = x_317200 * f32_res_317201;
        
        // save map-out results
        { }
        // Load accum params
        {
            x_317194 = local_acc_317209;
        }
        // Load next params
        {
            x_317195 = defunc_1_f_res_317202;
        }
        // Red body
        {
            double defunc_1_op_res_317196 = x_317194 + x_317195;
            
            local_acc_317209 = defunc_1_op_res_317196;
        }
    }
    ((double *) reduce_stage_1_tid_res_arr_mem_317206.mem)[flat_tid_317192] =
        local_acc_317209;
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_339352_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_339352_end -
                 futhark_mc_segred_stage_1_parloop_339352_start;
        
        ctx->futhark_mc_segred_stage_1_parloop_339352_runs[tid]++;
        ctx->futhark_mc_segred_stage_1_parloop_339352_total_runtime[tid] +=
            elapsed;
        ctx->futhark_mc_segred_stage_1_parloop_339352_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segred_task_339349(void *args, int64_t iterations, int tid,
                                  struct scheduler_info info)
{
    int err = 0;
    int flat_tid_317192 = tid;
    int num_tasks_317205 = info.nsubtasks;
    struct futhark_mc_task_339348 *futhark_mc_task_339348 =
                                  (struct futhark_mc_task_339348 *) args;
    struct futhark_context *ctx = futhark_mc_task_339348->ctx;
    uint64_t futhark_mc_segred_task_339349_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_task_339349_start = get_wall_time();
    
    int64_t n_292627 = futhark_mc_task_339348->free_n_292627;
    double b11_292658 = futhark_mc_task_339348->free_b11_292658;
    double c11_292659 = futhark_mc_task_339348->free_c11_292659;
    int64_t gtid_297414 = futhark_mc_task_339348->free_gtid_297414;
    struct memblock trend_l_mem_312581 = {.desc ="trend_l_mem_312581", .mem =
                                          futhark_mc_task_339348->free_trend_l_mem_312581,
                                          .size =0, .references =NULL};
    struct memblock mem_312584 = {.desc ="mem_312584", .mem =
                                  futhark_mc_task_339348->free_mem_312584,
                                  .size =0, .references =NULL};
    double defunc_2_reduce_res_297416 =
           *futhark_mc_task_339348->retval_defunc_2_reduce_res_297416;
    size_t reduce_stage_1_tid_res_arr_mem_317206_cached_sizze_339350 = 0;
    unsigned char *reduce_stage_1_tid_res_arr_mem_317206 = NULL;
    
    if (reduce_stage_1_tid_res_arr_mem_317206_cached_sizze_339350 <
        (size_t) ((int64_t) 8 * num_tasks_317205)) {
        reduce_stage_1_tid_res_arr_mem_317206 =
            realloc(reduce_stage_1_tid_res_arr_mem_317206, (int64_t) 8 *
                    num_tasks_317205);
        reduce_stage_1_tid_res_arr_mem_317206_cached_sizze_339350 =
            (int64_t) 8 * num_tasks_317205;
    }
    
    int64_t iter_317208;
    struct futhark_mc_segred_stage_1_parloop_struct_339351
    futhark_mc_segred_stage_1_parloop_struct_339351;
    
    futhark_mc_segred_stage_1_parloop_struct_339351.ctx = ctx;
    futhark_mc_segred_stage_1_parloop_struct_339351.free_n_292627 = n_292627;
    futhark_mc_segred_stage_1_parloop_struct_339351.free_b11_292658 =
        b11_292658;
    futhark_mc_segred_stage_1_parloop_struct_339351.free_c11_292659 =
        c11_292659;
    futhark_mc_segred_stage_1_parloop_struct_339351.free_gtid_297414 =
        gtid_297414;
    futhark_mc_segred_stage_1_parloop_struct_339351.free_trend_l_mem_312581 =
        trend_l_mem_312581.mem;
    futhark_mc_segred_stage_1_parloop_struct_339351.free_mem_312584 =
        mem_312584.mem;
    futhark_mc_segred_stage_1_parloop_struct_339351.free_reduce_stage_1_tid_res_arr_mem_317206 =
        reduce_stage_1_tid_res_arr_mem_317206;
    
    struct scheduler_parloop futhark_mc_segred_stage_1_parloop_339352_task;
    
    futhark_mc_segred_stage_1_parloop_339352_task.name =
        "futhark_mc_segred_stage_1_parloop_339352";
    futhark_mc_segred_stage_1_parloop_339352_task.fn =
        futhark_mc_segred_stage_1_parloop_339352;
    futhark_mc_segred_stage_1_parloop_339352_task.args =
        &futhark_mc_segred_stage_1_parloop_struct_339351;
    futhark_mc_segred_stage_1_parloop_339352_task.iterations = iterations;
    futhark_mc_segred_stage_1_parloop_339352_task.info = info;
    
    uint64_t futhark_mc_segred_stage_1_parloop_339352_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segred_stage_1_parloop_339352_total_start = get_wall_time();
    
    int futhark_mc_segred_stage_1_parloop_339352_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segred_stage_1_parloop_339352_task);
    
    if (futhark_mc_segred_stage_1_parloop_339352_err != 0) {
        err = futhark_mc_segred_stage_1_parloop_339352_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_stage_1_parloop_339352_total_end =
                 get_wall_time();
        uint64_t elapsed = futhark_mc_segred_stage_1_parloop_339352_total_end -
                 futhark_mc_segred_stage_1_parloop_339352_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_339352_total_runs,
                           1, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_339352_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segred_stage_1_parloop_339352_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    // neutral-initialise the output
    {
        defunc_2_reduce_res_297416 = 0.0;
    }
    
    double x_317210;
    double x_317211;
    
    for (int32_t i_317213 = 0; i_317213 < num_tasks_317205; i_317213++) {
        flat_tid_317192 = i_317213;
        // Apply main thread reduction
        {
            // load acc params
            {
                x_317210 = defunc_2_reduce_res_297416;
            }
            // load next params
            {
                x_317211 =
                    ((double *) reduce_stage_1_tid_res_arr_mem_317206)[flat_tid_317192];
            }
            // red body
            {
                double defunc_1_op_res_317212 = x_317210 + x_317211;
                
                defunc_2_reduce_res_297416 = defunc_1_op_res_317212;
            }
        }
    }
    
  cleanup:
    {
        free(reduce_stage_1_tid_res_arr_mem_317206);
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segred_task_339349_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segred_task_339349_end -
                 futhark_mc_segred_task_339349_start;
        
        ctx->futhark_mc_segred_task_339349_runs[tid]++;
        ctx->futhark_mc_segred_task_339349_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segred_task_339349_iter[tid] += iterations;
    }
    if (err == 0) {
        *futhark_mc_task_339348->retval_defunc_2_reduce_res_297416 =
            defunc_2_reduce_res_297416;
    }
    return err;
}
static int futhark_mc_segmap_parloop_339347(void *args, int64_t start,
                                            int64_t end, int flat_tid_297413,
                                            int tid)
{
    int err = 0;
    struct futhark_mc_segmap_parloop_struct_339346
    *futhark_mc_segmap_parloop_struct_339346 =
    (struct futhark_mc_segmap_parloop_struct_339346 *) args;
    struct futhark_context *ctx = futhark_mc_segmap_parloop_struct_339346->ctx;
    uint64_t futhark_mc_segmap_parloop_339347_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339347_start = get_wall_time();
    
    int64_t m_292626 = futhark_mc_segmap_parloop_struct_339346->free_m_292626;
    int64_t n_292627 = futhark_mc_segmap_parloop_struct_339346->free_n_292627;
    double i64_res_292652 =
           futhark_mc_segmap_parloop_struct_339346->free_i64_res_292652;
    double b11_292658 =
           futhark_mc_segmap_parloop_struct_339346->free_b11_292658;
    double c11_292659 =
           futhark_mc_segmap_parloop_struct_339346->free_c11_292659;
    struct memblock trend_l_mem_312581 = {.desc ="trend_l_mem_312581", .mem =
                                          futhark_mc_segmap_parloop_struct_339346->free_trend_l_mem_312581,
                                          .size =0, .references =NULL};
    struct memblock mem_312584 = {.desc ="mem_312584", .mem =
                                  futhark_mc_segmap_parloop_struct_339346->free_mem_312584,
                                  .size =0, .references =NULL};
    struct memblock mem_312587 = {.desc ="mem_312587", .mem =
                                  futhark_mc_segmap_parloop_struct_339346->free_mem_312587,
                                  .size =0, .references =NULL};
    int64_t iterations = end - start;
    int64_t iter_317191 = start;
    
    for (; iter_317191 < end; iter_317191++) {
        if (ctx->debugging)
            fprintf(ctx->log, "%s\n", "SegMap fbody");
        
        int64_t slice_317203 = m_292626;
        int64_t gtid_297414 = iter_317191;
        int64_t remnant_317204 = iter_317191 - gtid_297414;
        double defunc_2_reduce_res_297416;
        int64_t flat_tid_317192 = (int64_t) 0;
        int32_t num_tasks_317205;
        
        defunc_2_reduce_res_297416 = 0.0;
        
        struct futhark_mc_task_339348 futhark_mc_task_339348;
        
        futhark_mc_task_339348.ctx = ctx;
        futhark_mc_task_339348.free_n_292627 = n_292627;
        futhark_mc_task_339348.free_b11_292658 = b11_292658;
        futhark_mc_task_339348.free_c11_292659 = c11_292659;
        futhark_mc_task_339348.free_gtid_297414 = gtid_297414;
        futhark_mc_task_339348.free_trend_l_mem_312581 = trend_l_mem_312581.mem;
        futhark_mc_task_339348.free_mem_312584 = mem_312584.mem;
        futhark_mc_task_339348.retval_defunc_2_reduce_res_297416 =
            &defunc_2_reduce_res_297416;
        
        struct scheduler_segop futhark_mc_task_339348_task;
        
        futhark_mc_task_339348_task.args = &futhark_mc_task_339348;
        futhark_mc_task_339348_task.top_level_fn =
            futhark_mc_segred_task_339349;
        futhark_mc_task_339348_task.name = "futhark_mc_segred_task_339349";
        futhark_mc_task_339348_task.iterations = n_292627;
        futhark_mc_task_339348_task.task_time =
            &ctx->futhark_mc_segred_task_339349_total_time;
        futhark_mc_task_339348_task.task_iter =
            &ctx->futhark_mc_segred_task_339349_total_iter;
        futhark_mc_task_339348_task.sched = STATIC;
        futhark_mc_task_339348_task.nested_fn = NULL;
        
        int futhark_mc_segred_task_339349_err =
            scheduler_prepare_task(&ctx->scheduler,
                                   &futhark_mc_task_339348_task);
        
        if (futhark_mc_segred_task_339349_err != 0) {
            ;
            err = futhark_mc_segred_task_339349_err;
            goto cleanup;
        }
        
        double defunc_0_f_res_297428 = i64_res_292652 *
               defunc_2_reduce_res_297416;
        float defunc_0_f_res_297429 = fpconv_f64_f32(defunc_0_f_res_297428);
        
        ((float *) mem_312587.mem)[gtid_297414] = defunc_0_f_res_297429;
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339347_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339347_end -
                 futhark_mc_segmap_parloop_339347_start;
        
        ctx->futhark_mc_segmap_parloop_339347_runs[tid]++;
        ctx->futhark_mc_segmap_parloop_339347_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_parloop_339347_iter[tid] += iterations;
    }
    return err;
}
int futhark_mc_segmap_nested_task_339345(void *args, int64_t iterations,
                                         int tid, struct scheduler_info info)
{
    int err = 0;
    int flat_tid_297413 = tid;
    int num_tasks_317177 = info.nsubtasks;
    struct futhark_mc_task_339341 *futhark_mc_task_339341 =
                                  (struct futhark_mc_task_339341 *) args;
    struct futhark_context *ctx = futhark_mc_task_339341->ctx;
    uint64_t futhark_mc_segmap_nested_task_339345_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_nested_task_339345_start = get_wall_time();
    
    int64_t m_292626 = futhark_mc_task_339341->free_m_292626;
    int64_t n_292627 = futhark_mc_task_339341->free_n_292627;
    double i64_res_292652 = futhark_mc_task_339341->free_i64_res_292652;
    double b11_292658 = futhark_mc_task_339341->free_b11_292658;
    double c11_292659 = futhark_mc_task_339341->free_c11_292659;
    struct memblock trend_l_mem_312581 = {.desc ="trend_l_mem_312581", .mem =
                                          futhark_mc_task_339341->free_trend_l_mem_312581,
                                          .size =0, .references =NULL};
    struct memblock mem_312584 = {.desc ="mem_312584", .mem =
                                  futhark_mc_task_339341->free_mem_312584,
                                  .size =0, .references =NULL};
    struct memblock mem_312587 = {.desc ="mem_312587", .mem =
                                  futhark_mc_task_339341->free_mem_312587,
                                  .size =0, .references =NULL};
    int64_t iter_317191;
    struct futhark_mc_segmap_parloop_struct_339346
    futhark_mc_segmap_parloop_struct_339346;
    
    futhark_mc_segmap_parloop_struct_339346.ctx = ctx;
    futhark_mc_segmap_parloop_struct_339346.free_m_292626 = m_292626;
    futhark_mc_segmap_parloop_struct_339346.free_n_292627 = n_292627;
    futhark_mc_segmap_parloop_struct_339346.free_i64_res_292652 =
        i64_res_292652;
    futhark_mc_segmap_parloop_struct_339346.free_b11_292658 = b11_292658;
    futhark_mc_segmap_parloop_struct_339346.free_c11_292659 = c11_292659;
    futhark_mc_segmap_parloop_struct_339346.free_trend_l_mem_312581 =
        trend_l_mem_312581.mem;
    futhark_mc_segmap_parloop_struct_339346.free_mem_312584 = mem_312584.mem;
    futhark_mc_segmap_parloop_struct_339346.free_mem_312587 = mem_312587.mem;
    
    struct scheduler_parloop futhark_mc_segmap_parloop_339347_task;
    
    futhark_mc_segmap_parloop_339347_task.name =
        "futhark_mc_segmap_parloop_339347";
    futhark_mc_segmap_parloop_339347_task.fn = futhark_mc_segmap_parloop_339347;
    futhark_mc_segmap_parloop_339347_task.args =
        &futhark_mc_segmap_parloop_struct_339346;
    futhark_mc_segmap_parloop_339347_task.iterations = iterations;
    futhark_mc_segmap_parloop_339347_task.info = info;
    
    uint64_t futhark_mc_segmap_parloop_339347_total_start = 0;
    
    if (ctx->profiling && !ctx->profiling_paused)
        futhark_mc_segmap_parloop_339347_total_start = get_wall_time();
    
    int futhark_mc_segmap_parloop_339347_err =
        scheduler_execute_task(&ctx->scheduler,
                               &futhark_mc_segmap_parloop_339347_task);
    
    if (futhark_mc_segmap_parloop_339347_err != 0) {
        err = futhark_mc_segmap_parloop_339347_err;
        goto cleanup;
    }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_parloop_339347_total_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_parloop_339347_total_end -
                 futhark_mc_segmap_parloop_339347_total_start;
        
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339347_total_runs, 1,
                           __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339347_total_total_runtime,
                           elapsed, __ATOMIC_RELAXED);
        __atomic_fetch_add(&ctx->futhark_mc_segmap_parloop_339347_total_iter,
                           iterations, __ATOMIC_RELAXED);
    }
    
  cleanup:
    { }
    if (ctx->profiling && !ctx->profiling_paused) {
        uint64_t futhark_mc_segmap_nested_task_339345_end = get_wall_time();
        uint64_t elapsed = futhark_mc_segmap_nested_task_339345_end -
                 futhark_mc_segmap_nested_task_339345_start;
        
        ctx->futhark_mc_segmap_nested_task_339345_runs[tid]++;
        ctx->futhark_mc_segmap_nested_task_339345_total_runtime[tid] += elapsed;
        ctx->futhark_mc_segmap_nested_task_339345_iter[tid] += iterations;
    }
    if (err == 0) { }
    return err;
}
struct futhark_f32_1d {
    struct memblock mem;
    int64_t shape[1];
};
struct futhark_f32_1d *futhark_new_f32_1d(struct futhark_context *ctx, const
                                          float *data, int64_t dim0)
{
    struct futhark_f32_1d *bad = NULL;
    struct futhark_f32_1d *arr =
                          (struct futhark_f32_1d *) malloc(sizeof(struct futhark_f32_1d));
    
    if (arr == NULL)
        return bad;
    lock_lock(&ctx->lock);
    worker_local = &ctx->scheduler.workers[0];
    arr->mem.references = NULL;
    if (memblock_alloc(ctx, &arr->mem, dim0 * 4, "arr->mem"))
        return NULL;
    arr->shape[0] = dim0;
    if ((size_t) dim0 * 4 > 0)
        memmove(arr->mem.mem + 0, data + 0, (size_t) dim0 * 4);
    lock_unlock(&ctx->lock);
    return arr;
}
struct futhark_f32_1d *futhark_new_raw_f32_1d(struct futhark_context *ctx, const
                                              unsigned char *data,
                                              int64_t offset, int64_t dim0)
{
    struct futhark_f32_1d *bad = NULL;
    struct futhark_f32_1d *arr =
                          (struct futhark_f32_1d *) malloc(sizeof(struct futhark_f32_1d));
    
    if (arr == NULL)
        return bad;
    lock_lock(&ctx->lock);
    worker_local = &ctx->scheduler.workers[0];
    arr->mem.references = NULL;
    if (memblock_alloc(ctx, &arr->mem, dim0 * 4, "arr->mem"))
        return NULL;
    arr->shape[0] = dim0;
    if ((size_t) dim0 * 4 > 0)
        memmove(arr->mem.mem + 0, data + offset, (size_t) dim0 * 4);
    lock_unlock(&ctx->lock);
    return arr;
}
int futhark_free_f32_1d(struct futhark_context *ctx, struct futhark_f32_1d *arr)
{
    lock_lock(&ctx->lock);
    worker_local = &ctx->scheduler.workers[0];
    if (memblock_unref(ctx, &arr->mem, "arr->mem") != 0)
        return 1;
    lock_unlock(&ctx->lock);
    free(arr);
    return 0;
}
int futhark_values_f32_1d(struct futhark_context *ctx,
                          struct futhark_f32_1d *arr, float *data)
{
    lock_lock(&ctx->lock);
    worker_local = &ctx->scheduler.workers[0];
    if ((size_t) arr->shape[0] * 4 > 0)
        memmove(data + 0, arr->mem.mem + 0, (size_t) arr->shape[0] * 4);
    lock_unlock(&ctx->lock);
    return 0;
}
unsigned char *futhark_values_raw_f32_1d(struct futhark_context *ctx,
                                         struct futhark_f32_1d *arr)
{
    (void) ctx;
    return arr->mem.mem;
}
const int64_t *futhark_shape_f32_1d(struct futhark_context *ctx,
                                    struct futhark_f32_1d *arr)
{
    (void) ctx;
    return arr->shape;
}
struct futhark_f32_2d {
    struct memblock mem;
    int64_t shape[2];
};
struct futhark_f32_2d *futhark_new_f32_2d(struct futhark_context *ctx, const
                                          float *data, int64_t dim0,
                                          int64_t dim1)
{
    struct futhark_f32_2d *bad = NULL;
    struct futhark_f32_2d *arr =
                          (struct futhark_f32_2d *) malloc(sizeof(struct futhark_f32_2d));
    
    if (arr == NULL)
        return bad;
    lock_lock(&ctx->lock);
    worker_local = &ctx->scheduler.workers[0];
    arr->mem.references = NULL;
    if (memblock_alloc(ctx, &arr->mem, dim0 * dim1 * 4, "arr->mem"))
        return NULL;
    arr->shape[0] = dim0;
    arr->shape[1] = dim1;
    if ((size_t) (dim0 * dim1) * 4 > 0)
        memmove(arr->mem.mem + 0, data + 0, (size_t) (dim0 * dim1) * 4);
    lock_unlock(&ctx->lock);
    return arr;
}
struct futhark_f32_2d *futhark_new_raw_f32_2d(struct futhark_context *ctx, const
                                              unsigned char *data,
                                              int64_t offset, int64_t dim0,
                                              int64_t dim1)
{
    struct futhark_f32_2d *bad = NULL;
    struct futhark_f32_2d *arr =
                          (struct futhark_f32_2d *) malloc(sizeof(struct futhark_f32_2d));
    
    if (arr == NULL)
        return bad;
    lock_lock(&ctx->lock);
    worker_local = &ctx->scheduler.workers[0];
    arr->mem.references = NULL;
    if (memblock_alloc(ctx, &arr->mem, dim0 * dim1 * 4, "arr->mem"))
        return NULL;
    arr->shape[0] = dim0;
    arr->shape[1] = dim1;
    if ((size_t) (dim0 * dim1) * 4 > 0)
        memmove(arr->mem.mem + 0, data + offset, (size_t) (dim0 * dim1) * 4);
    lock_unlock(&ctx->lock);
    return arr;
}
int futhark_free_f32_2d(struct futhark_context *ctx, struct futhark_f32_2d *arr)
{
    lock_lock(&ctx->lock);
    worker_local = &ctx->scheduler.workers[0];
    if (memblock_unref(ctx, &arr->mem, "arr->mem") != 0)
        return 1;
    lock_unlock(&ctx->lock);
    free(arr);
    return 0;
}
int futhark_values_f32_2d(struct futhark_context *ctx,
                          struct futhark_f32_2d *arr, float *data)
{
    lock_lock(&ctx->lock);
    worker_local = &ctx->scheduler.workers[0];
    if ((size_t) (arr->shape[0] * arr->shape[1]) * 4 > 0)
        memmove(data + 0, arr->mem.mem + 0, (size_t) (arr->shape[0] *
                                                      arr->shape[1]) * 4);
    lock_unlock(&ctx->lock);
    return 0;
}
unsigned char *futhark_values_raw_f32_2d(struct futhark_context *ctx,
                                         struct futhark_f32_2d *arr)
{
    (void) ctx;
    return arr->mem.mem;
}
const int64_t *futhark_shape_f32_2d(struct futhark_context *ctx,
                                    struct futhark_f32_2d *arr)
{
    (void) ctx;
    return arr->shape;
}

static int futrts_entry_main(struct futhark_context *ctx,
                             struct memblock *mem_out_p_337633,
                             struct memblock *mem_out_p_337634,
                             struct memblock *mem_out_p_337635,
                             struct memblock Y_mem_312581, int64_t m_292674,
                             int64_t n_292675, int64_t n_p_292677,
                             int64_t q_s_292678, int64_t q_t_292679,
                             int64_t q_l_292680, int64_t d_s_292681,
                             int64_t d_t_292682, int64_t d_l_292683,
                             int64_t jump_s_292684, int64_t jump_t_292685,
                             int64_t jump_l_292686, int64_t n_inner_292687,
                             int64_t n_outer_292688,
                             int64_t jump_threshold_1_292689,
                             int64_t jump_threshold_2_292690,
                             int64_t q_threshold_1_292691,
                             int64_t q_threshold_2_292692)
{
    (void) ctx;
    
    int err = 0;
    size_t mem_312584_cached_sizze_337636 = 0;
    unsigned char *mem_312584 = NULL;
    size_t mem_312587_cached_sizze_337637 = 0;
    unsigned char *mem_312587 = NULL;
    size_t mem_312589_cached_sizze_337638 = 0;
    unsigned char *mem_312589 = NULL;
    size_t mem_312593_cached_sizze_337639 = 0;
    unsigned char *mem_312593 = NULL;
    size_t mem_312596_cached_sizze_337640 = 0;
    unsigned char *mem_312596 = NULL;
    size_t mem_312636_cached_sizze_337641 = 0;
    unsigned char *mem_312636 = NULL;
    size_t mem_312639_cached_sizze_337642 = 0;
    unsigned char *mem_312639 = NULL;
    size_t mem_312713_cached_sizze_337643 = 0;
    unsigned char *mem_312713 = NULL;
    size_t mem_312838_cached_sizze_337644 = 0;
    unsigned char *mem_312838 = NULL;
    size_t mem_312842_cached_sizze_337645 = 0;
    unsigned char *mem_312842 = NULL;
    size_t mem_313018_cached_sizze_337646 = 0;
    unsigned char *mem_313018 = NULL;
    size_t mem_313023_cached_sizze_337647 = 0;
    unsigned char *mem_313023 = NULL;
    size_t mem_313081_cached_sizze_337648 = 0;
    unsigned char *mem_313081 = NULL;
    size_t mem_313085_cached_sizze_337649 = 0;
    unsigned char *mem_313085 = NULL;
    size_t mem_313143_cached_sizze_337650 = 0;
    unsigned char *mem_313143 = NULL;
    size_t mem_313147_cached_sizze_337651 = 0;
    unsigned char *mem_313147 = NULL;
    size_t mem_313223_cached_sizze_337652 = 0;
    unsigned char *mem_313223 = NULL;
    size_t mem_313366_cached_sizze_337653 = 0;
    unsigned char *mem_313366 = NULL;
    size_t mem_313371_cached_sizze_337654 = 0;
    unsigned char *mem_313371 = NULL;
    size_t mem_314946_cached_sizze_337655 = 0;
    unsigned char *mem_314946 = NULL;
    size_t mem_314949_cached_sizze_337656 = 0;
    unsigned char *mem_314949 = NULL;
    size_t mem_314971_cached_sizze_337657 = 0;
    unsigned char *mem_314971 = NULL;
    size_t mem_314974_cached_sizze_337658 = 0;
    unsigned char *mem_314974 = NULL;
    size_t mem_314996_cached_sizze_337659 = 0;
    unsigned char *mem_314996 = NULL;
    size_t mem_314999_cached_sizze_337660 = 0;
    unsigned char *mem_314999 = NULL;
    size_t mem_315021_cached_sizze_337661 = 0;
    unsigned char *mem_315021 = NULL;
    size_t mem_316815_cached_sizze_337662 = 0;
    unsigned char *mem_316815 = NULL;
    size_t mem_316819_cached_sizze_337663 = 0;
    unsigned char *mem_316819 = NULL;
    size_t mem_316822_cached_sizze_337664 = 0;
    unsigned char *mem_316822 = NULL;
    size_t mem_316832_cached_sizze_337665 = 0;
    unsigned char *mem_316832 = NULL;
    size_t mem_316835_cached_sizze_337666 = 0;
    unsigned char *mem_316835 = NULL;
    size_t mem_316850_cached_sizze_337667 = 0;
    unsigned char *mem_316850 = NULL;
    size_t mem_316906_cached_sizze_337668 = 0;
    unsigned char *mem_316906 = NULL;
    size_t mem_316909_cached_sizze_337669 = 0;
    unsigned char *mem_316909 = NULL;
    size_t mem_316912_cached_sizze_337670 = 0;
    unsigned char *mem_316912 = NULL;
    size_t mem_316915_cached_sizze_337671 = 0;
    unsigned char *mem_316915 = NULL;
    size_t mem_316917_cached_sizze_337672 = 0;
    unsigned char *mem_316917 = NULL;
    size_t mem_316920_cached_sizze_337673 = 0;
    unsigned char *mem_316920 = NULL;
    size_t mem_316928_cached_sizze_337674 = 0;
    unsigned char *mem_316928 = NULL;
    size_t mem_316931_cached_sizze_337675 = 0;
    unsigned char *mem_316931 = NULL;
    size_t mem_316973_cached_sizze_337676 = 0;
    unsigned char *mem_316973 = NULL;
    size_t mem_316976_cached_sizze_337677 = 0;
    unsigned char *mem_316976 = NULL;
    size_t mem_316979_cached_sizze_337678 = 0;
    unsigned char *mem_316979 = NULL;
    struct memblock mem_out_317161;
    
    mem_out_317161.references = NULL;
    
    struct memblock mem_out_317162;
    
    mem_out_317162.references = NULL;
    
    struct memblock mem_out_317163;
    
    mem_out_317163.references = NULL;
    
    double i64_res_292693 = sitofp_i64_f64(n_292675);
    double i64_res_292694 = sitofp_i64_f64(n_p_292677);
    double ceil_arg_292695 = i64_res_292693 / i64_res_292694;
    double ceil_res_292696;
    
    ceil_res_292696 = futrts_ceil64(ceil_arg_292695);
    
    int64_t defunc_0_f_res_292697 = fptosi_f64_i64(ceil_res_292696);
    bool bounds_invalid_upwards_292698 = slt64(n_p_292677, (int64_t) 0);
    bool valid_292699 = !bounds_invalid_upwards_292698;
    bool range_valid_c_292700;
    
    if (!valid_292699) {
        ctx->error = msgprintf("Error: %s%lld%s%lld%s%lld%s\n\nBacktrace:\n%s",
                               "Range ", (long long) (int64_t) 0, "..",
                               (long long) (int64_t) 1, "..<",
                               (long long) n_p_292677, " is invalid.",
                               "-> #0  /prelude/array.fut:90:3-10\n   #1  /prelude/array.fut:195:11-16\n   #2  utils.fut:6:3-16\n   #3  stl.fut:407:29-412:37\n   #4  stl.fut:406:22-413:28\n   #5  stl.fut:463:3-479:36\n   #6  stl.fut:445:1-479:36\n");
        if (memblock_unref(ctx, &mem_out_317163, "mem_out_317163") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_317162, "mem_out_317162") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_317161, "mem_out_317161") != 0)
            return 1;
        err = FUTHARK_PROGRAM_ERROR;
        goto cleanup;
    }
    
    bool bounds_invalid_upwards_292702 = slt64(defunc_0_f_res_292697,
                                               (int64_t) 0);
    bool valid_292703 = !bounds_invalid_upwards_292702;
    bool range_valid_c_292704;
    
    if (!valid_292703) {
        ctx->error = msgprintf("Error: %s%lld%s%lld%s%lld%s\n\nBacktrace:\n%s",
                               "Range ", (long long) (int64_t) 0, "..",
                               (long long) (int64_t) 1, "..<",
                               (long long) defunc_0_f_res_292697,
                               " is invalid.",
                               "-> #0  /prelude/array.fut:90:3-10\n   #1  /prelude/array.fut:195:11-16\n   #2  utils.fut:6:3-16\n   #3  stl.fut:408:36-411:52\n   #4  /prelude/soacs.fut:59:3-10\n   #5  /prelude/array.fut:195:3-17\n   #6  utils.fut:6:3-16\n   #7  stl.fut:407:29-412:37\n   #8  stl.fut:406:22-413:28\n   #9  stl.fut:463:3-479:36\n   #10 stl.fut:445:1-479:36\n");
        if (memblock_unref(ctx, &mem_out_317163, "mem_out_317163") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_317162, "mem_out_317162") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_317161, "mem_out_317161") != 0)
            return 1;
        err = FUTHARK_PROGRAM_ERROR;
        goto cleanup;
    }
    
    int64_t binop_y_312582 = (int64_t) 8 * m_292674;
    int64_t bytes_312583 = smax64((int64_t) 0, binop_y_312582);
    
    if (mem_312584_cached_sizze_337636 < (size_t) bytes_312583) {
        mem_312584 = realloc(mem_312584, bytes_312583);
        mem_312584_cached_sizze_337636 = bytes_312583;
    }
    if (mem_312587_cached_sizze_337637 < (size_t) bytes_312583) {
        mem_312587 = realloc(mem_312587, bytes_312583);
        mem_312587_cached_sizze_337637 = bytes_312583;
    }
    
    int64_t bytes_312588 = smax64((int64_t) 0, m_292674);
    
    if (mem_312589_cached_sizze_337638 < (size_t) bytes_312588) {
        mem_312589 = realloc(mem_312589, bytes_312588);
        mem_312589_cached_sizze_337638 = bytes_312588;
    }
    
    int64_t flat_tid_297430 = (int64_t) 0;
    int32_t num_tasks_317164;
    
    if (ctx->debugging)
        fprintf(ctx->log, "%s\n", "nonsegmented segScan");
    
    struct futhark_mc_task_337679 futhark_mc_task_337679;
    
    futhark_mc_task_337679.ctx = ctx;
    futhark_mc_task_337679.free_m_292674 = m_292674;
    futhark_mc_task_337679.free_n_292675 = n_292675;
    futhark_mc_task_337679.free_n_p_292677 = n_p_292677;
    futhark_mc_task_337679.free_defunc_0_f_res_292697 = defunc_0_f_res_292697;
    futhark_mc_task_337679.free_Y_mem_312581 = Y_mem_312581.mem;
    futhark_mc_task_337679.free_mem_312584 = mem_312584;
    futhark_mc_task_337679.free_mem_312587 = mem_312587;
    futhark_mc_task_337679.free_mem_312589 = mem_312589;
    
    struct scheduler_segop futhark_mc_task_337679_task;
    
    futhark_mc_task_337679_task.args = &futhark_mc_task_337679;
    futhark_mc_task_337679_task.top_level_fn = futhark_mc_segscan_task_337680;
    futhark_mc_task_337679_task.name = "futhark_mc_segscan_task_337680";
    futhark_mc_task_337679_task.iterations = m_292674;
    futhark_mc_task_337679_task.task_time =
        &ctx->futhark_mc_segscan_task_337680_total_time;
    futhark_mc_task_337679_task.task_iter =
        &ctx->futhark_mc_segscan_task_337680_total_iter;
    futhark_mc_task_337679_task.sched = STATIC;
    futhark_mc_task_337679_task.nested_fn = NULL;
    
    int futhark_mc_segscan_task_337680_err =
        scheduler_prepare_task(&ctx->scheduler, &futhark_mc_task_337679_task);
    
    if (futhark_mc_segscan_task_337680_err != 0) {
        if (memblock_unref(ctx, &mem_out_317163, "mem_out_317163") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_317162, "mem_out_317162") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_317161, "mem_out_317161") != 0)
            return 1;
        ;
        err = futhark_mc_segscan_task_337680_err;
        goto cleanup;
    }
    
    int64_t last_index_292764 = m_292674 - (int64_t) 1;
    bool is_empty_292765 = m_292674 == (int64_t) 0;
    int64_t partition_sizze_292766;
    
    if (is_empty_292765) {
        partition_sizze_292766 = (int64_t) 0;
    } else {
        int64_t last_offset_292767;
        
        last_offset_292767 = ((int64_t *) mem_312584)[last_index_292764];
        partition_sizze_292766 = last_offset_292767;
    }
    
    int64_t binop_x_312590 = m_292674 * n_292675;
    int64_t binop_y_312591 = (int64_t) 4 * binop_x_312590;
    int64_t bytes_312592 = smax64((int64_t) 0, binop_y_312591);
    
    if (mem_312593_cached_sizze_337639 < (size_t) bytes_312592) {
        mem_312593 = realloc(mem_312593, bytes_312592);
        mem_312593_cached_sizze_337639 = bytes_312592;
    }
    if (mem_312596_cached_sizze_337640 < (size_t) bytes_312583) {
        mem_312596 = realloc(mem_312596, bytes_312583);
        mem_312596_cached_sizze_337640 = bytes_312583;
    }
    
    int64_t flat_tid_297461 = (int64_t) 0;
    int32_t num_tasks_317259;
    struct futhark_mc_task_337728 futhark_mc_task_337728;
    
    futhark_mc_task_337728.ctx = ctx;
    futhark_mc_task_337728.free_m_292674 = m_292674;
    futhark_mc_task_337728.free_n_292675 = n_292675;
    futhark_mc_task_337728.free_Y_mem_312581 = Y_mem_312581.mem;
    futhark_mc_task_337728.free_mem_312584 = mem_312584;
    futhark_mc_task_337728.free_mem_312587 = mem_312587;
    futhark_mc_task_337728.free_mem_312593 = mem_312593;
    futhark_mc_task_337728.free_mem_312596 = mem_312596;
    
    struct scheduler_segop futhark_mc_task_337728_task;
    
    futhark_mc_task_337728_task.args = &futhark_mc_task_337728;
    futhark_mc_task_337728_task.top_level_fn = futhark_mc_segmap_task_337729;
    futhark_mc_task_337728_task.name = "futhark_mc_segmap_task_337729";
    futhark_mc_task_337728_task.iterations = m_292674;
    futhark_mc_task_337728_task.task_time =
        &ctx->futhark_mc_segmap_task_337729_total_time;
    futhark_mc_task_337728_task.task_iter =
        &ctx->futhark_mc_segmap_task_337729_total_iter;
    futhark_mc_task_337728_task.sched = STATIC;
    futhark_mc_task_337728_task.nested_fn = NULL;
    
    int futhark_mc_segmap_task_337729_err =
        scheduler_prepare_task(&ctx->scheduler, &futhark_mc_task_337728_task);
    
    if (futhark_mc_segmap_task_337729_err != 0) {
        if (memblock_unref(ctx, &mem_out_317163, "mem_out_317163") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_317162, "mem_out_317162") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_317161, "mem_out_317161") != 0)
            return 1;
        ;
        err = futhark_mc_segmap_task_337729_err;
        goto cleanup;
    }
    
    bool empty_slice_292780 = partition_sizze_292766 == (int64_t) 0;
    int64_t m_292781 = sub64(partition_sizze_292766, (int64_t) 1);
    bool zzero_leq_i_p_m_t_s_292782 = sle64((int64_t) 0, m_292781);
    bool i_p_m_t_s_leq_w_292783 = slt64(m_292781, m_292674);
    bool i_lte_j_292784 = sle64((int64_t) 0, partition_sizze_292766);
    bool y_292785 = zzero_leq_i_p_m_t_s_292782 && i_p_m_t_s_leq_w_292783;
    bool y_292786 = i_lte_j_292784 && y_292785;
    bool ok_or_empty_292787 = empty_slice_292780 || y_292786;
    bool index_certs_292788;
    
    if (!ok_or_empty_292787) {
        ctx->error = msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                               "Index [:", (long long) partition_sizze_292766,
                               "] out of bounds for array of shape [",
                               (long long) m_292674, "].",
                               "-> #0  /prelude/soacs.fut:163:6-16\n   #1  stl.fut:416:7-66\n   #2  stl.fut:463:3-479:36\n   #3  stl.fut:445:1-479:36\n");
        if (memblock_unref(ctx, &mem_out_317163, "mem_out_317163") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_317162, "mem_out_317162") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_317161, "mem_out_317161") != 0)
            return 1;
        err = FUTHARK_PROGRAM_ERROR;
        goto cleanup;
    }
    
    bool assert_cond_292791 = sle64((int64_t) 4, n_p_292677);
    bool assert_c_292792;
    
    if (!assert_cond_292791) {
        ctx->error = msgprintf("Error: %s\n\nBacktrace:\n%s",
                               "Assertion is false: (n_p >= 4)",
                               "-> #0  stl.fut:74:13-33\n   #1  stl.fut:419:61-435:77\n   #2  stl.fut:463:3-479:36\n   #3  stl.fut:445:1-479:36\n");
        if (memblock_unref(ctx, &mem_out_317163, "mem_out_317163") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_317162, "mem_out_317162") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_317161, "mem_out_317161") != 0)
            return 1;
        err = FUTHARK_PROGRAM_ERROR;
        goto cleanup;
    }
    
    int64_t x_292793 = smod64(q_t_292679, (int64_t) 2);
    bool assert_cond_292794 = x_292793 == (int64_t) 1;
    bool assert_c_292795;
    
    if (!assert_cond_292794) {
        ctx->error = msgprintf("Error: %s\n\nBacktrace:\n%s",
                               "Assertion is false: (x % 2 == 1)",
                               "-> #0  utils.fut:20:3-23\n   #1  /prelude/functional.fut:39:62-64\n   #2  stl.fut:76:13-25\n   #3  stl.fut:419:61-435:77\n   #4  stl.fut:463:3-479:36\n   #5  stl.fut:445:1-479:36\n");
        if (memblock_unref(ctx, &mem_out_317163, "mem_out_317163") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_317162, "mem_out_317162") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_317161, "mem_out_317161") != 0)
            return 1;
        err = FUTHARK_PROGRAM_ERROR;
        goto cleanup;
    }
    
    bool assert_cond_292796 = slt64((int64_t) 0, q_t_292679);
    bool assert_c_292797;
    
    if (!assert_cond_292796) {
        ctx->error = msgprintf("Error: %s\n\nBacktrace:\n%s",
                               "Assertion is false: (x > 0)",
                               "-> #0  utils.fut:17:3-18\n   #1  /prelude/functional.fut:39:59-65\n   #2  stl.fut:76:13-25\n   #3  stl.fut:419:61-435:77\n   #4  stl.fut:463:3-479:36\n   #5  stl.fut:445:1-479:36\n");
        if (memblock_unref(ctx, &mem_out_317163, "mem_out_317163") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_317162, "mem_out_317162") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_317161, "mem_out_317161") != 0)
            return 1;
        err = FUTHARK_PROGRAM_ERROR;
        goto cleanup;
    }
    
    int64_t x_292798 = smod64(q_l_292680, (int64_t) 2);
    bool assert_cond_292799 = x_292798 == (int64_t) 1;
    bool assert_c_292800;
    
    if (!assert_cond_292799) {
        ctx->error = msgprintf("Error: %s\n\nBacktrace:\n%s",
                               "Assertion is false: (x % 2 == 1)",
                               "-> #0  utils.fut:20:3-23\n   #1  /prelude/functional.fut:39:62-64\n   #2  stl.fut:77:13-25\n   #3  stl.fut:419:61-435:77\n   #4  stl.fut:463:3-479:36\n   #5  stl.fut:445:1-479:36\n");
        if (memblock_unref(ctx, &mem_out_317163, "mem_out_317163") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_317162, "mem_out_317162") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_317161, "mem_out_317161") != 0)
            return 1;
        err = FUTHARK_PROGRAM_ERROR;
        goto cleanup;
    }
    
    bool assert_cond_292801 = slt64((int64_t) 0, q_l_292680);
    bool assert_c_292802;
    
    if (!assert_cond_292801) {
        ctx->error = msgprintf("Error: %s\n\nBacktrace:\n%s",
                               "Assertion is false: (x > 0)",
                               "-> #0  utils.fut:17:3-18\n   #1  /prelude/functional.fut:39:59-65\n   #2  stl.fut:77:13-25\n   #3  stl.fut:419:61-435:77\n   #4  stl.fut:463:3-479:36\n   #5  stl.fut:445:1-479:36\n");
        if (memblock_unref(ctx, &mem_out_317163, "mem_out_317163") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_317162, "mem_out_317162") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_317161, "mem_out_317161") != 0)
            return 1;
        err = FUTHARK_PROGRAM_ERROR;
        goto cleanup;
    }
    
    bool cond_292803 = sle64((int64_t) 0, d_t_292682);
    bool assert_cond_t_res_292804 = sle64(d_t_292682, (int64_t) 2);
    bool x_292805 = cond_292803 && assert_cond_t_res_292804;
    bool assert_c_292806;
    
    if (!x_292805) {
        ctx->error = msgprintf("Error: %s\n\nBacktrace:\n%s",
                               "Assertion is false: (x >= 0 && x <= 2)",
                               "-> #0  utils.fut:23:3-29\n   #1  stl.fut:79:13-25\n   #2  stl.fut:419:61-435:77\n   #3  stl.fut:463:3-479:36\n   #4  stl.fut:445:1-479:36\n");
        if (memblock_unref(ctx, &mem_out_317163, "mem_out_317163") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_317162, "mem_out_317162") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_317161, "mem_out_317161") != 0)
            return 1;
        err = FUTHARK_PROGRAM_ERROR;
        goto cleanup;
    }
    
    bool cond_292807 = sle64((int64_t) 0, d_l_292683);
    bool assert_cond_t_res_292808 = sle64(d_l_292683, (int64_t) 2);
    bool x_292809 = cond_292807 && assert_cond_t_res_292808;
    bool assert_c_292810;
    
    if (!x_292809) {
        ctx->error = msgprintf("Error: %s\n\nBacktrace:\n%s",
                               "Assertion is false: (x >= 0 && x <= 2)",
                               "-> #0  utils.fut:23:3-29\n   #1  stl.fut:80:13-25\n   #2  stl.fut:419:61-435:77\n   #3  stl.fut:463:3-479:36\n   #4  stl.fut:445:1-479:36\n");
        if (memblock_unref(ctx, &mem_out_317163, "mem_out_317163") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_317162, "mem_out_317162") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_317161, "mem_out_317161") != 0)
            return 1;
        err = FUTHARK_PROGRAM_ERROR;
        goto cleanup;
    }
    
    bool assert_cond_292811 = slt64((int64_t) 0, jump_t_292685);
    bool assert_c_292812;
    
    if (!assert_cond_292811) {
        ctx->error = msgprintf("Error: %s\n\nBacktrace:\n%s",
                               "Assertion is false: (x > 0)",
                               "-> #0  utils.fut:17:3-18\n   #1  stl.fut:82:16-31\n   #2  stl.fut:419:61-435:77\n   #3  stl.fut:463:3-479:36\n   #4  stl.fut:445:1-479:36\n");
        if (memblock_unref(ctx, &mem_out_317163, "mem_out_317163") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_317162, "mem_out_317162") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_317161, "mem_out_317161") != 0)
            return 1;
        err = FUTHARK_PROGRAM_ERROR;
        goto cleanup;
    }
    
    bool assert_cond_292813 = slt64((int64_t) 0, jump_l_292686);
    bool assert_c_292814;
    
    if (!assert_cond_292813) {
        ctx->error = msgprintf("Error: %s\n\nBacktrace:\n%s",
                               "Assertion is false: (x > 0)",
                               "-> #0  utils.fut:17:3-18\n   #1  stl.fut:83:16-31\n   #2  stl.fut:419:61-435:77\n   #3  stl.fut:463:3-479:36\n   #4  stl.fut:445:1-479:36\n");
        if (memblock_unref(ctx, &mem_out_317163, "mem_out_317163") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_317162, "mem_out_317162") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_317161, "mem_out_317161") != 0)
            return 1;
        err = FUTHARK_PROGRAM_ERROR;
        goto cleanup;
    }
    
    bool assert_cond_292815 = slt64((int64_t) 0, n_inner_292687);
    bool assert_c_292816;
    
    if (!assert_cond_292815) {
        ctx->error = msgprintf("Error: %s\n\nBacktrace:\n%s",
                               "Assertion is false: (x > 0)",
                               "-> #0  utils.fut:17:3-18\n   #1  stl.fut:85:17-33\n   #2  stl.fut:419:61-435:77\n   #3  stl.fut:463:3-479:36\n   #4  stl.fut:445:1-479:36\n");
        if (memblock_unref(ctx, &mem_out_317163, "mem_out_317163") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_317162, "mem_out_317162") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_317161, "mem_out_317161") != 0)
            return 1;
        err = FUTHARK_PROGRAM_ERROR;
        goto cleanup;
    }
    
    bool assert_cond_292817 = slt64((int64_t) 0, n_outer_292688);
    bool assert_c_292818;
    
    if (!assert_cond_292817) {
        ctx->error = msgprintf("Error: %s\n\nBacktrace:\n%s",
                               "Assertion is false: (x > 0)",
                               "-> #0  utils.fut:17:3-18\n   #1  stl.fut:86:17-33\n   #2  stl.fut:419:61-435:77\n   #3  stl.fut:463:3-479:36\n   #4  stl.fut:445:1-479:36\n");
        if (memblock_unref(ctx, &mem_out_317163, "mem_out_317163") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_317162, "mem_out_317162") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_317161, "mem_out_317161") != 0)
            return 1;
        err = FUTHARK_PROGRAM_ERROR;
        goto cleanup;
    }
    
    double ceil_res_292819;
    
    ceil_res_292819 = futrts_ceil64(ceil_arg_292695);
    
    int64_t defunc_0_f_res_292820 = fptosi_f64_i64(ceil_res_292819);
    int64_t pad_css_len_292821 = add64((int64_t) 2, defunc_0_f_res_292820);
    int64_t y_292822 = mul64((int64_t) 2, n_p_292677);
    int64_t C_len_292823 = add64(n_292675, y_292822);
    bool cond_292824 = jump_s_292684 == (int64_t) 1;
    int64_t s_n_m_292825;
    
    if (cond_292824) {
        s_n_m_292825 = pad_css_len_292821;
    } else {
        bool zzero_292826 = jump_s_292684 == (int64_t) 0;
        bool nonzzero_292827 = !zzero_292826;
        bool nonzzero_cert_292828;
        
        if (!nonzzero_292827) {
            ctx->error = msgprintf("Error: %s\n\nBacktrace:\n%s",
                                   "division by zero",
                                   "-> #0  stl.fut:93:52-71\n   #1  stl.fut:419:61-435:77\n   #2  stl.fut:463:3-479:36\n   #3  stl.fut:445:1-479:36\n");
            if (memblock_unref(ctx, &mem_out_317163, "mem_out_317163") != 0)
                return 1;
            if (memblock_unref(ctx, &mem_out_317162, "mem_out_317162") != 0)
                return 1;
            if (memblock_unref(ctx, &mem_out_317161, "mem_out_317161") != 0)
                return 1;
            err = FUTHARK_PROGRAM_ERROR;
            goto cleanup;
        }
        
        int64_t x_292829 = sdiv64(defunc_0_f_res_292820, jump_s_292684);
        int64_t s_n_m_f_res_292830 = add64((int64_t) 3, x_292829);
        
        s_n_m_292825 = s_n_m_f_res_292830;
    }
    
    bool cond_292831 = jump_l_292686 == (int64_t) 1;
    int64_t l_n_m_292832;
    
    if (cond_292831) {
        l_n_m_292832 = n_292675;
    } else {
        bool zzero_292833 = jump_l_292686 == (int64_t) 0;
        bool nonzzero_292834 = !zzero_292833;
        bool nonzzero_cert_292835;
        
        if (!nonzzero_292834) {
            ctx->error = msgprintf("Error: %s\n\nBacktrace:\n%s",
                                   "division by zero",
                                   "-> #0  stl.fut:99:42-51\n   #1  stl.fut:419:61-435:77\n   #2  stl.fut:463:3-479:36\n   #3  stl.fut:445:1-479:36\n");
            if (memblock_unref(ctx, &mem_out_317163, "mem_out_317163") != 0)
                return 1;
            if (memblock_unref(ctx, &mem_out_317162, "mem_out_317162") != 0)
                return 1;
            if (memblock_unref(ctx, &mem_out_317161, "mem_out_317161") != 0)
                return 1;
            err = FUTHARK_PROGRAM_ERROR;
            goto cleanup;
        }
        
        int64_t x_292836 = sdiv64(n_292675, jump_l_292686);
        int64_t l_n_m_f_res_292837 = add64((int64_t) 1, x_292836);
        
        l_n_m_292832 = l_n_m_f_res_292837;
    }
    
    bool cond_292838 = jump_t_292685 == (int64_t) 1;
    int64_t t_n_m_292839;
    
    if (cond_292838) {
        t_n_m_292839 = n_292675;
    } else {
        bool zzero_292840 = jump_t_292685 == (int64_t) 0;
        bool nonzzero_292841 = !zzero_292840;
        bool nonzzero_cert_292842;
        
        if (!nonzzero_292841) {
            ctx->error = msgprintf("Error: %s\n\nBacktrace:\n%s",
                                   "division by zero",
                                   "-> #0  stl.fut:103:42-51\n   #1  stl.fut:419:61-435:77\n   #2  stl.fut:463:3-479:36\n   #3  stl.fut:445:1-479:36\n");
            if (memblock_unref(ctx, &mem_out_317163, "mem_out_317163") != 0)
                return 1;
            if (memblock_unref(ctx, &mem_out_317162, "mem_out_317162") != 0)
                return 1;
            if (memblock_unref(ctx, &mem_out_317161, "mem_out_317161") != 0)
                return 1;
            err = FUTHARK_PROGRAM_ERROR;
            goto cleanup;
        }
        
        int64_t x_292843 = sdiv64(n_292675, jump_t_292685);
        int64_t t_n_m_f_res_292844 = add64((int64_t) 1, x_292843);
        
        t_n_m_292839 = t_n_m_f_res_292844;
    }
    
    int64_t i_292846 = sub64(n_292675, (int64_t) 1);
    bool x_292847 = sle64((int64_t) 0, i_292846);
    bool y_292848 = slt64(i_292846, n_292675);
    bool bounds_check_292849 = x_292847 && y_292848;
    bool index_certs_292850;
    
    if (!bounds_check_292849) {
        ctx->error = msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                               "Index [", (long long) i_292846,
                               "] out of bounds for array of shape [",
                               (long long) n_292675, "].",
                               "-> #0  /prelude/array.fut:26:29-34\n   #1  utils.fut:45:13-20\n   #2  stl.fut:110:31-51\n   #3  stl.fut:419:61-435:77\n   #4  stl.fut:463:3-479:36\n   #5  stl.fut:445:1-479:36\n");
        if (memblock_unref(ctx, &mem_out_317163, "mem_out_317163") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_317162, "mem_out_317162") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_317161, "mem_out_317161") != 0)
            return 1;
        err = FUTHARK_PROGRAM_ERROR;
        goto cleanup;
    }
    
    int64_t binop_x_312633 = n_292675 * partition_sizze_292766;
    int64_t binop_y_312634 = (int64_t) 8 * binop_x_312633;
    int64_t bytes_312635 = smax64((int64_t) 0, binop_y_312634);
    
    if (mem_312636_cached_sizze_337641 < (size_t) bytes_312635) {
        mem_312636 = realloc(mem_312636, bytes_312635);
        mem_312636_cached_sizze_337641 = bytes_312635;
    }
    
    int64_t binop_y_312637 = (int64_t) 8 * partition_sizze_292766;
    int64_t bytes_312638 = smax64((int64_t) 0, binop_y_312637);
    
    if (mem_312639_cached_sizze_337642 < (size_t) bytes_312638) {
        mem_312639 = realloc(mem_312639, bytes_312638);
        mem_312639_cached_sizze_337642 = bytes_312638;
    }
    
    int64_t binop_y_312597 = (int64_t) 8 * n_292675;
    int64_t bytes_312598 = smax64((int64_t) 0, binop_y_312597);
    int64_t flat_tid_297463 = (int64_t) 0;
    int32_t num_tasks_317263;
    int64_t flat_tid_297471 = (int64_t) 0;
    struct futhark_mc_task_337732 futhark_mc_task_337732;
    
    futhark_mc_task_337732.ctx = ctx;
    futhark_mc_task_337732.free_n_292675 = n_292675;
    futhark_mc_task_337732.free_partition_sizze_292766 = partition_sizze_292766;
    futhark_mc_task_337732.free_i_292846 = i_292846;
    futhark_mc_task_337732.free_mem_312593 = mem_312593;
    futhark_mc_task_337732.free_bytes_312598 = bytes_312598;
    futhark_mc_task_337732.free_mem_312636 = mem_312636;
    futhark_mc_task_337732.free_mem_312639 = mem_312639;
    
    struct scheduler_segop futhark_mc_task_337732_task;
    
    futhark_mc_task_337732_task.args = &futhark_mc_task_337732;
    futhark_mc_task_337732_task.top_level_fn = futhark_mc_segmap_task_337733;
    futhark_mc_task_337732_task.name = "futhark_mc_segmap_task_337733";
    futhark_mc_task_337732_task.iterations = partition_sizze_292766;
    futhark_mc_task_337732_task.task_time =
        &ctx->futhark_mc_segmap_task_337733_total_time;
    futhark_mc_task_337732_task.task_iter =
        &ctx->futhark_mc_segmap_task_337733_total_iter;
    futhark_mc_task_337732_task.sched = STATIC;
    futhark_mc_task_337732_task.nested_fn =
        futhark_mc_segmap_nested_task_337738;
    
    int futhark_mc_segmap_task_337733_err =
        scheduler_prepare_task(&ctx->scheduler, &futhark_mc_task_337732_task);
    
    if (futhark_mc_segmap_task_337733_err != 0) {
        if (memblock_unref(ctx, &mem_out_317163, "mem_out_317163") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_317162, "mem_out_317162") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_317161, "mem_out_317161") != 0)
            return 1;
        ;
        err = futhark_mc_segmap_task_337733_err;
        goto cleanup;
    }
    
    bool bounds_invalid_upwards_292874 = slt64(defunc_0_f_res_292820,
                                               (int64_t) 0);
    bool valid_292875 = !bounds_invalid_upwards_292874;
    bool range_valid_c_292876;
    
    if (!valid_292875) {
        ctx->error = msgprintf("Error: %s%lld%s%lld%s%lld%s\n\nBacktrace:\n%s",
                               "Range ", (long long) (int64_t) 0, "..",
                               (long long) (int64_t) 1, "..<",
                               (long long) defunc_0_f_res_292820,
                               " is invalid.",
                               "-> #0  /prelude/array.fut:90:3-10\n   #1  /prelude/array.fut:195:11-16\n   #2  utils.fut:6:3-16\n   #3  stl.fut:117:20-123:36\n   #4  /prelude/soacs.fut:59:3-10\n   #5  /prelude/array.fut:195:3-17\n   #6  utils.fut:6:3-16\n   #7  stl.fut:115:12-124:20\n   #8  stl.fut:114:5-125:11\n   #9  stl.fut:419:61-435:77\n   #10 stl.fut:463:3-479:36\n   #11 stl.fut:445:1-479:36\n");
        if (memblock_unref(ctx, &mem_out_317163, "mem_out_317163") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_317162, "mem_out_317162") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_317161, "mem_out_317161") != 0)
            return 1;
        err = FUTHARK_PROGRAM_ERROR;
        goto cleanup;
    }
    
    int64_t binop_x_312709 = n_p_292677 * partition_sizze_292766;
    int64_t binop_x_312710 = defunc_0_f_res_292820 * binop_x_312709;
    int64_t binop_y_312711 = (int64_t) 8 * binop_x_312710;
    int64_t bytes_312712 = smax64((int64_t) 0, binop_y_312711);
    
    if (mem_312713_cached_sizze_337643 < (size_t) bytes_312712) {
        mem_312713 = realloc(mem_312713, bytes_312712);
        mem_312713_cached_sizze_337643 = bytes_312712;
    }
    
    int64_t binop_x_312658 = n_p_292677 * defunc_0_f_res_292820;
    int64_t binop_y_312659 = (int64_t) 8 * binop_x_312658;
    int64_t bytes_312660 = smax64((int64_t) 0, binop_y_312659);
    int64_t binop_y_312640 = (int64_t) 8 * defunc_0_f_res_292820;
    int64_t bytes_312641 = smax64((int64_t) 0, binop_y_312640);
    int64_t flat_tid_297496 = (int64_t) 0;
    int32_t num_tasks_317330;
    int64_t flat_tid_297523 = (int64_t) 0;
    struct futhark_mc_task_337754 futhark_mc_task_337754;
    
    futhark_mc_task_337754.ctx = ctx;
    futhark_mc_task_337754.free_n_292675 = n_292675;
    futhark_mc_task_337754.free_n_p_292677 = n_p_292677;
    futhark_mc_task_337754.free_partition_sizze_292766 = partition_sizze_292766;
    futhark_mc_task_337754.free_defunc_0_f_res_292820 = defunc_0_f_res_292820;
    futhark_mc_task_337754.free_i_292846 = i_292846;
    futhark_mc_task_337754.free_mem_312593 = mem_312593;
    futhark_mc_task_337754.free_bytes_312641 = bytes_312641;
    futhark_mc_task_337754.free_bytes_312660 = bytes_312660;
    futhark_mc_task_337754.free_mem_312713 = mem_312713;
    
    struct scheduler_segop futhark_mc_task_337754_task;
    
    futhark_mc_task_337754_task.args = &futhark_mc_task_337754;
    futhark_mc_task_337754_task.top_level_fn = futhark_mc_segmap_task_337755;
    futhark_mc_task_337754_task.name = "futhark_mc_segmap_task_337755";
    futhark_mc_task_337754_task.iterations = partition_sizze_292766;
    futhark_mc_task_337754_task.task_time =
        &ctx->futhark_mc_segmap_task_337755_total_time;
    futhark_mc_task_337754_task.task_iter =
        &ctx->futhark_mc_segmap_task_337755_total_iter;
    futhark_mc_task_337754_task.sched = STATIC;
    futhark_mc_task_337754_task.nested_fn =
        futhark_mc_segmap_nested_task_337759;
    
    int futhark_mc_segmap_task_337755_err =
        scheduler_prepare_task(&ctx->scheduler, &futhark_mc_task_337754_task);
    
    if (futhark_mc_segmap_task_337755_err != 0) {
        if (memblock_unref(ctx, &mem_out_317163, "mem_out_317163") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_317162, "mem_out_317162") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_317161, "mem_out_317161") != 0)
            return 1;
        ;
        err = futhark_mc_segmap_task_337755_err;
        goto cleanup;
    }
    
    int64_t i_292895 = sub64(defunc_0_f_res_292820, (int64_t) 1);
    bool x_292896 = sle64((int64_t) 0, i_292895);
    bool y_292897 = slt64(i_292895, defunc_0_f_res_292820);
    bool bounds_check_292898 = x_292896 && y_292897;
    bool index_certs_292899;
    
    if (!bounds_check_292898) {
        ctx->error = msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                               "Index [", (long long) i_292895,
                               "] out of bounds for array of shape [",
                               (long long) defunc_0_f_res_292820, "].",
                               "-> #0  /prelude/array.fut:26:29-34\n   #1  utils.fut:45:13-20\n   #2  stl.fut:131:51-67\n   #3  stl.fut:130:12-133:21\n   #4  stl.fut:129:5-134:16\n   #5  stl.fut:419:61-435:77\n   #6  stl.fut:463:3-479:36\n   #7  stl.fut:445:1-479:36\n");
        if (memblock_unref(ctx, &mem_out_317163, "mem_out_317163") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_317162, "mem_out_317162") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_317161, "mem_out_317161") != 0)
            return 1;
        err = FUTHARK_PROGRAM_ERROR;
        goto cleanup;
    }
    if (mem_312838_cached_sizze_337644 < (size_t) bytes_312712) {
        mem_312838 = realloc(mem_312838, bytes_312712);
        mem_312838_cached_sizze_337644 = bytes_312712;
    }
    
    int64_t binop_y_312840 = (int64_t) 8 * binop_x_312709;
    int64_t bytes_312841 = smax64((int64_t) 0, binop_y_312840);
    
    if (mem_312842_cached_sizze_337645 < (size_t) bytes_312841) {
        mem_312842 = realloc(mem_312842, bytes_312841);
        mem_312842_cached_sizze_337645 = bytes_312841;
    }
    
    int64_t binop_y_312754 = (int64_t) 8 * n_p_292677;
    int64_t bytes_312755 = smax64((int64_t) 0, binop_y_312754);
    int64_t flat_tid_297559 = (int64_t) 0;
    int32_t num_tasks_317432;
    int64_t flat_tid_297596 = (int64_t) 0;
    struct futhark_mc_task_337776 futhark_mc_task_337776;
    
    futhark_mc_task_337776.ctx = ctx;
    futhark_mc_task_337776.free_n_p_292677 = n_p_292677;
    futhark_mc_task_337776.free_partition_sizze_292766 = partition_sizze_292766;
    futhark_mc_task_337776.free_defunc_0_f_res_292820 = defunc_0_f_res_292820;
    futhark_mc_task_337776.free_i_292895 = i_292895;
    futhark_mc_task_337776.free_bytes_312641 = bytes_312641;
    futhark_mc_task_337776.free_bytes_312660 = bytes_312660;
    futhark_mc_task_337776.free_mem_312713 = mem_312713;
    futhark_mc_task_337776.free_bytes_312755 = bytes_312755;
    futhark_mc_task_337776.free_mem_312838 = mem_312838;
    futhark_mc_task_337776.free_mem_312842 = mem_312842;
    
    struct scheduler_segop futhark_mc_task_337776_task;
    
    futhark_mc_task_337776_task.args = &futhark_mc_task_337776;
    futhark_mc_task_337776_task.top_level_fn = futhark_mc_segmap_task_337777;
    futhark_mc_task_337776_task.name = "futhark_mc_segmap_task_337777";
    futhark_mc_task_337776_task.iterations = partition_sizze_292766;
    futhark_mc_task_337776_task.task_time =
        &ctx->futhark_mc_segmap_task_337777_total_time;
    futhark_mc_task_337776_task.task_iter =
        &ctx->futhark_mc_segmap_task_337777_total_iter;
    futhark_mc_task_337776_task.sched = STATIC;
    futhark_mc_task_337776_task.nested_fn =
        futhark_mc_segmap_nested_task_337784;
    
    int futhark_mc_segmap_task_337777_err =
        scheduler_prepare_task(&ctx->scheduler, &futhark_mc_task_337776_task);
    
    if (futhark_mc_segmap_task_337777_err != 0) {
        if (memblock_unref(ctx, &mem_out_317163, "mem_out_317163") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_317162, "mem_out_317162") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_317161, "mem_out_317161") != 0)
            return 1;
        ;
        err = futhark_mc_segmap_task_337777_err;
        goto cleanup;
    }
    
    int64_t min_res_292926 = smin64(q_s_292678, defunc_0_f_res_292820);
    bool bounds_invalid_upwards_292927 = slt64(s_n_m_292825, (int64_t) 0);
    bool valid_292928 = !bounds_invalid_upwards_292927;
    bool range_valid_c_292929;
    
    if (!valid_292928) {
        ctx->error = msgprintf("Error: %s%lld%s%lld%s%lld%s\n\nBacktrace:\n%s",
                               "Range ", (long long) (int64_t) 0, "..",
                               (long long) (int64_t) 1, "..<",
                               (long long) s_n_m_292825, " is invalid.",
                               "-> #0  /prelude/array.fut:90:3-10\n   #1  /prelude/array.fut:195:11-16\n   #2  utils.fut:6:3-16\n   #3  loess.fut:638:3-665:10\n   #4  loess.fut:712:15-50\n   #5  stl.fut:140:20-80\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  stl.fut:139:12-141:40\n   #9  /prelude/soacs.fut:67:19-23\n   #10 /prelude/soacs.fut:67:3-37\n   #11 stl.fut:138:5-142:36\n   #12 stl.fut:419:61-435:77\n   #13 stl.fut:463:3-479:36\n   #14 stl.fut:445:1-479:36\n");
        if (memblock_unref(ctx, &mem_out_317163, "mem_out_317163") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_317162, "mem_out_317162") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_317161, "mem_out_317161") != 0)
            return 1;
        err = FUTHARK_PROGRAM_ERROR;
        goto cleanup;
    }
    
    bool loop_cond_292931 = slt64((int64_t) 1, min_res_292926);
    double i64_res_292932 = sitofp_i64_f64(q_s_292678);
    int64_t binop_x_313015 = s_n_m_292825 * binop_x_312709;
    int64_t binop_y_313016 = (int64_t) 8 * binop_x_313015;
    int64_t bytes_313017 = smax64((int64_t) 0, binop_y_313016);
    
    if (mem_313018_cached_sizze_337646 < (size_t) bytes_313017) {
        mem_313018 = realloc(mem_313018, bytes_313017);
        mem_313018_cached_sizze_337646 = bytes_313017;
    }
    if (mem_313023_cached_sizze_337647 < (size_t) bytes_313017) {
        mem_313023 = realloc(mem_313023, bytes_313017);
        mem_313023_cached_sizze_337647 = bytes_313017;
    }
    
    int64_t binop_x_312897 = n_p_292677 * s_n_m_292825;
    int64_t binop_y_312898 = (int64_t) 8 * binop_x_312897;
    int64_t bytes_312899 = smax64((int64_t) 0, binop_y_312898);
    int64_t binop_y_312846 = (int64_t) 8 * s_n_m_292825;
    int64_t bytes_312847 = smax64((int64_t) 0, binop_y_312846);
    int64_t flat_tid_297647 = (int64_t) 0;
    int32_t num_tasks_317593;
    int64_t flat_tid_297782 = (int64_t) 0;
    struct futhark_mc_task_337811 futhark_mc_task_337811;
    
    futhark_mc_task_337811.ctx = ctx;
    futhark_mc_task_337811.free_n_p_292677 = n_p_292677;
    futhark_mc_task_337811.free_q_s_292678 = q_s_292678;
    futhark_mc_task_337811.free_jump_s_292684 = jump_s_292684;
    futhark_mc_task_337811.free_partition_sizze_292766 = partition_sizze_292766;
    futhark_mc_task_337811.free_defunc_0_f_res_292820 = defunc_0_f_res_292820;
    futhark_mc_task_337811.free_pad_css_len_292821 = pad_css_len_292821;
    futhark_mc_task_337811.free_s_n_m_292825 = s_n_m_292825;
    futhark_mc_task_337811.free_i_292895 = i_292895;
    futhark_mc_task_337811.free_x_292896 = x_292896;
    futhark_mc_task_337811.free_min_res_292926 = min_res_292926;
    futhark_mc_task_337811.free_loop_cond_292931 = loop_cond_292931;
    futhark_mc_task_337811.free_i64_res_292932 = i64_res_292932;
    futhark_mc_task_337811.free_bytes_312641 = bytes_312641;
    futhark_mc_task_337811.free_mem_312838 = mem_312838;
    futhark_mc_task_337811.free_mem_312842 = mem_312842;
    futhark_mc_task_337811.free_bytes_312847 = bytes_312847;
    futhark_mc_task_337811.free_bytes_312899 = bytes_312899;
    futhark_mc_task_337811.free_mem_313018 = mem_313018;
    futhark_mc_task_337811.free_mem_313023 = mem_313023;
    
    struct scheduler_segop futhark_mc_task_337811_task;
    
    futhark_mc_task_337811_task.args = &futhark_mc_task_337811;
    futhark_mc_task_337811_task.top_level_fn = futhark_mc_segmap_task_337812;
    futhark_mc_task_337811_task.name = "futhark_mc_segmap_task_337812";
    futhark_mc_task_337811_task.iterations = partition_sizze_292766;
    futhark_mc_task_337811_task.task_time =
        &ctx->futhark_mc_segmap_task_337812_total_time;
    futhark_mc_task_337811_task.task_iter =
        &ctx->futhark_mc_segmap_task_337812_total_iter;
    futhark_mc_task_337811_task.sched = DYNAMIC;
    futhark_mc_task_337811_task.nested_fn =
        futhark_mc_segmap_nested_task_337818;
    
    int futhark_mc_segmap_task_337812_err =
        scheduler_prepare_task(&ctx->scheduler, &futhark_mc_task_337811_task);
    
    if (futhark_mc_segmap_task_337812_err != 0) {
        if (memblock_unref(ctx, &mem_out_317163, "mem_out_317163") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_317162, "mem_out_317162") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_317161, "mem_out_317161") != 0)
            return 1;
        ;
        err = futhark_mc_segmap_task_337812_err;
        goto cleanup;
    }
    
    int64_t min_res_293058 = smin64(n_292675, q_l_292680);
    bool bounds_invalid_upwards_293059 = slt64(l_n_m_292832, (int64_t) 0);
    bool valid_293060 = !bounds_invalid_upwards_293059;
    bool range_valid_c_293061;
    
    if (!valid_293060) {
        ctx->error = msgprintf("Error: %s%lld%s%lld%s%lld%s\n\nBacktrace:\n%s",
                               "Range ", (long long) (int64_t) 0, "..",
                               (long long) (int64_t) 1, "..<",
                               (long long) l_n_m_292832, " is invalid.",
                               "-> #0  /prelude/array.fut:90:3-10\n   #1  /prelude/array.fut:195:11-16\n   #2  utils.fut:6:3-16\n   #3  loess.fut:638:3-665:10\n   #4  loess.fut:698:15-61\n   #5  stl.fut:148:13-60\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  stl.fut:146:5-149:26\n   #9  stl.fut:419:61-435:77\n   #10 stl.fut:463:3-479:36\n   #11 stl.fut:445:1-479:36\n");
        if (memblock_unref(ctx, &mem_out_317163, "mem_out_317163") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_317162, "mem_out_317162") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_317161, "mem_out_317161") != 0)
            return 1;
        err = FUTHARK_PROGRAM_ERROR;
        goto cleanup;
    }
    
    bool loop_cond_293063 = slt64((int64_t) 1, min_res_293058);
    double i64_res_293064 = sitofp_i64_f64(q_l_292680);
    int64_t binop_x_313078 = partition_sizze_292766 * l_n_m_292832;
    int64_t binop_y_313079 = (int64_t) 8 * binop_x_313078;
    int64_t bytes_313080 = smax64((int64_t) 0, binop_y_313079);
    
    if (mem_313081_cached_sizze_337648 < (size_t) bytes_313080) {
        mem_313081 = realloc(mem_313081, bytes_313080);
        mem_313081_cached_sizze_337648 = bytes_313080;
    }
    if (mem_313085_cached_sizze_337649 < (size_t) bytes_313080) {
        mem_313085 = realloc(mem_313085, bytes_313080);
        mem_313085_cached_sizze_337649 = bytes_313080;
    }
    
    int64_t binop_y_313027 = (int64_t) 8 * l_n_m_292832;
    int64_t bytes_313028 = smax64((int64_t) 0, binop_y_313027);
    int64_t flat_tid_298030 = (int64_t) 0;
    int32_t num_tasks_318317;
    int64_t flat_tid_298038 = (int64_t) 0;
    struct futhark_mc_task_337844 futhark_mc_task_337844;
    
    futhark_mc_task_337844.ctx = ctx;
    futhark_mc_task_337844.free_n_292675 = n_292675;
    futhark_mc_task_337844.free_q_l_292680 = q_l_292680;
    futhark_mc_task_337844.free_jump_l_292686 = jump_l_292686;
    futhark_mc_task_337844.free_partition_sizze_292766 = partition_sizze_292766;
    futhark_mc_task_337844.free_l_n_m_292832 = l_n_m_292832;
    futhark_mc_task_337844.free_i_292846 = i_292846;
    futhark_mc_task_337844.free_x_292847 = x_292847;
    futhark_mc_task_337844.free_min_res_293058 = min_res_293058;
    futhark_mc_task_337844.free_loop_cond_293063 = loop_cond_293063;
    futhark_mc_task_337844.free_i64_res_293064 = i64_res_293064;
    futhark_mc_task_337844.free_bytes_312598 = bytes_312598;
    futhark_mc_task_337844.free_mem_312636 = mem_312636;
    futhark_mc_task_337844.free_mem_312639 = mem_312639;
    futhark_mc_task_337844.free_bytes_313028 = bytes_313028;
    futhark_mc_task_337844.free_mem_313081 = mem_313081;
    futhark_mc_task_337844.free_mem_313085 = mem_313085;
    
    struct scheduler_segop futhark_mc_task_337844_task;
    
    futhark_mc_task_337844_task.args = &futhark_mc_task_337844;
    futhark_mc_task_337844_task.top_level_fn = futhark_mc_segmap_task_337845;
    futhark_mc_task_337844_task.name = "futhark_mc_segmap_task_337845";
    futhark_mc_task_337844_task.iterations = partition_sizze_292766;
    futhark_mc_task_337844_task.task_time =
        &ctx->futhark_mc_segmap_task_337845_total_time;
    futhark_mc_task_337844_task.task_iter =
        &ctx->futhark_mc_segmap_task_337845_total_iter;
    futhark_mc_task_337844_task.sched = DYNAMIC;
    futhark_mc_task_337844_task.nested_fn =
        futhark_mc_segmap_nested_task_337851;
    
    int futhark_mc_segmap_task_337845_err =
        scheduler_prepare_task(&ctx->scheduler, &futhark_mc_task_337844_task);
    
    if (futhark_mc_segmap_task_337845_err != 0) {
        if (memblock_unref(ctx, &mem_out_317163, "mem_out_317163") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_317162, "mem_out_317162") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_317161, "mem_out_317161") != 0)
            return 1;
        ;
        err = futhark_mc_segmap_task_337845_err;
        goto cleanup;
    }
    
    int64_t min_res_293170 = smin64(n_292675, q_t_292679);
    bool bounds_invalid_upwards_293171 = slt64(t_n_m_292839, (int64_t) 0);
    bool valid_293172 = !bounds_invalid_upwards_293171;
    bool range_valid_c_293173;
    
    if (!valid_293172) {
        ctx->error = msgprintf("Error: %s%lld%s%lld%s%lld%s\n\nBacktrace:\n%s",
                               "Range ", (long long) (int64_t) 0, "..",
                               (long long) (int64_t) 1, "..<",
                               (long long) t_n_m_292839, " is invalid.",
                               "-> #0  /prelude/array.fut:90:3-10\n   #1  /prelude/array.fut:195:11-16\n   #2  utils.fut:6:3-16\n   #3  loess.fut:638:3-665:10\n   #4  loess.fut:698:15-61\n   #5  stl.fut:155:13-60\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  stl.fut:153:5-156:26\n   #9  stl.fut:419:61-435:77\n   #10 stl.fut:463:3-479:36\n   #11 stl.fut:445:1-479:36\n");
        if (memblock_unref(ctx, &mem_out_317163, "mem_out_317163") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_317162, "mem_out_317162") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_317161, "mem_out_317161") != 0)
            return 1;
        err = FUTHARK_PROGRAM_ERROR;
        goto cleanup;
    }
    
    bool loop_cond_293175 = slt64((int64_t) 1, min_res_293170);
    double i64_res_293176 = sitofp_i64_f64(q_t_292679);
    int64_t binop_x_313140 = partition_sizze_292766 * t_n_m_292839;
    int64_t binop_y_313141 = (int64_t) 8 * binop_x_313140;
    int64_t bytes_313142 = smax64((int64_t) 0, binop_y_313141);
    
    if (mem_313143_cached_sizze_337650 < (size_t) bytes_313142) {
        mem_313143 = realloc(mem_313143, bytes_313142);
        mem_313143_cached_sizze_337650 = bytes_313142;
    }
    if (mem_313147_cached_sizze_337651 < (size_t) bytes_313142) {
        mem_313147 = realloc(mem_313147, bytes_313142);
        mem_313147_cached_sizze_337651 = bytes_313142;
    }
    
    int64_t binop_y_313089 = (int64_t) 8 * t_n_m_292839;
    int64_t bytes_313090 = smax64((int64_t) 0, binop_y_313089);
    int64_t flat_tid_298145 = (int64_t) 0;
    int32_t num_tasks_318592;
    int64_t flat_tid_298153 = (int64_t) 0;
    struct futhark_mc_task_337865 futhark_mc_task_337865;
    
    futhark_mc_task_337865.ctx = ctx;
    futhark_mc_task_337865.free_n_292675 = n_292675;
    futhark_mc_task_337865.free_q_t_292679 = q_t_292679;
    futhark_mc_task_337865.free_jump_t_292685 = jump_t_292685;
    futhark_mc_task_337865.free_partition_sizze_292766 = partition_sizze_292766;
    futhark_mc_task_337865.free_t_n_m_292839 = t_n_m_292839;
    futhark_mc_task_337865.free_i_292846 = i_292846;
    futhark_mc_task_337865.free_x_292847 = x_292847;
    futhark_mc_task_337865.free_min_res_293170 = min_res_293170;
    futhark_mc_task_337865.free_loop_cond_293175 = loop_cond_293175;
    futhark_mc_task_337865.free_i64_res_293176 = i64_res_293176;
    futhark_mc_task_337865.free_bytes_312598 = bytes_312598;
    futhark_mc_task_337865.free_mem_312636 = mem_312636;
    futhark_mc_task_337865.free_mem_312639 = mem_312639;
    futhark_mc_task_337865.free_bytes_313090 = bytes_313090;
    futhark_mc_task_337865.free_mem_313143 = mem_313143;
    futhark_mc_task_337865.free_mem_313147 = mem_313147;
    
    struct scheduler_segop futhark_mc_task_337865_task;
    
    futhark_mc_task_337865_task.args = &futhark_mc_task_337865;
    futhark_mc_task_337865_task.top_level_fn = futhark_mc_segmap_task_337866;
    futhark_mc_task_337865_task.name = "futhark_mc_segmap_task_337866";
    futhark_mc_task_337865_task.iterations = partition_sizze_292766;
    futhark_mc_task_337865_task.task_time =
        &ctx->futhark_mc_segmap_task_337866_total_time;
    futhark_mc_task_337865_task.task_iter =
        &ctx->futhark_mc_segmap_task_337866_total_iter;
    futhark_mc_task_337865_task.sched = DYNAMIC;
    futhark_mc_task_337865_task.nested_fn =
        futhark_mc_segmap_nested_task_337872;
    
    int futhark_mc_segmap_task_337866_err =
        scheduler_prepare_task(&ctx->scheduler, &futhark_mc_task_337865_task);
    
    if (futhark_mc_segmap_task_337866_err != 0) {
        if (memblock_unref(ctx, &mem_out_317163, "mem_out_317163") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_317162, "mem_out_317162") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_317161, "mem_out_317161") != 0)
            return 1;
        ;
        err = futhark_mc_segmap_task_337866_err;
        goto cleanup;
    }
    
    struct memblock mem_313151;
    
    mem_313151.references = NULL;
    if (memblock_alloc(ctx, &mem_313151, bytes_312635, "mem_313151")) {
        err = 1;
        goto cleanup;
    }
    for (int64_t i_318867 = 0; i_318867 < partition_sizze_292766; i_318867++) {
        for (int64_t i_318868 = 0; i_318868 < n_292675; i_318868++) {
            ((double *) mem_313151.mem)[i_318867 * n_292675 + i_318868] = 0.0;
        }
    }
    
    struct memblock mem_313155;
    
    mem_313155.references = NULL;
    if (memblock_alloc(ctx, &mem_313155, bytes_312635, "mem_313155")) {
        err = 1;
        goto cleanup;
    }
    for (int64_t i_318869 = 0; i_318869 < partition_sizze_292766; i_318869++) {
        for (int64_t i_318870 = 0; i_318870 < n_292675; i_318870++) {
            ((double *) mem_313155.mem)[i_318869 * n_292675 + i_318870] = 1.0;
        }
    }
    
    bool cond_293285 = slt64((int64_t) 1, jump_l_292686);
    bool cond_293286 = slt64((int64_t) 1, jump_t_292685);
    int64_t y_293287 = sub64(n_outer_292688, (int64_t) 1);
    int64_t css_results_l_293288;
    
    if (cond_292824) {
        css_results_l_293288 = s_n_m_292825;
    } else {
        css_results_l_293288 = pad_css_len_292821;
    }
    
    bool zzero_293289 = n_p_292677 == (int64_t) 0;
    bool nonzzero_293290 = !zzero_293289;
    bool loop_not_taken_293291 = !assert_cond_292815;
    bool protect_assert_disj_293292 = nonzzero_293290 || loop_not_taken_293291;
    bool loop_not_taken_293293 = !assert_cond_292817;
    bool protect_assert_disj_293294 = protect_assert_disj_293292 ||
         loop_not_taken_293293;
    bool nonzzero_cert_293295;
    
    if (!protect_assert_disj_293294) {
        ctx->error = msgprintf("Error: %s\n\nBacktrace:\n%s",
                               "division by zero",
                               "-> #0  stl.fut:228:51-57\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  stl.fut:228:28-74\n   #5  stl.fut:227:21-229:39\n   #6  stl.fut:419:61-435:77\n   #7  stl.fut:463:3-479:36\n   #8  stl.fut:445:1-479:36\n");
        if (memblock_unref(ctx, &mem_313155, "mem_313155") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_313151, "mem_313151") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_317163, "mem_out_317163") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_317162, "mem_out_317162") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_317161, "mem_out_317161") != 0)
            return 1;
        err = FUTHARK_PROGRAM_ERROR;
        goto cleanup;
    }
    
    int64_t j_293296 = add64(n_292675, n_p_292677);
    bool empty_slice_293297 = n_292675 == (int64_t) 0;
    int64_t i_p_m_t_s_293298 = add64(n_p_292677, i_292846);
    bool zzero_leq_i_p_m_t_s_293299 = sle64((int64_t) 0, i_p_m_t_s_293298);
    bool i_p_m_t_s_leq_w_293300 = slt64(i_p_m_t_s_293298, C_len_292823);
    bool zzero_lte_i_293301 = sle64((int64_t) 0, n_p_292677);
    bool i_lte_j_293302 = sle64(n_p_292677, j_293296);
    bool y_293303 = i_p_m_t_s_leq_w_293300 && zzero_lte_i_293301;
    bool y_293304 = zzero_leq_i_p_m_t_s_293299 && y_293303;
    bool y_293305 = i_lte_j_293302 && y_293304;
    bool forwards_ok_293306 = zzero_lte_i_293301 && y_293305;
    bool ok_or_empty_293307 = empty_slice_293297 || forwards_ok_293306;
    bool protect_assert_disj_293308 = loop_not_taken_293291 ||
         ok_or_empty_293307;
    bool protect_assert_disj_293309 = loop_not_taken_293293 ||
         protect_assert_disj_293308;
    bool index_certs_293310;
    
    if (!protect_assert_disj_293309) {
        ctx->error = msgprintf("Error: %s%lld%s%lld%s%lld%s\n\nBacktrace:\n%s",
                               "Index [", (long long) n_p_292677, ":",
                               (long long) j_293296,
                               "] out of bounds for array of shape [",
                               (long long) C_len_292823, "].",
                               "-> #0  stl.fut:266:35-50\n   #1  /prelude/soacs.fut:67:19-23\n   #2  /prelude/soacs.fut:67:3-37\n   #3  stl.fut:264:13-269:26\n   #4  stl.fut:419:61-435:77\n   #5  stl.fut:463:3-479:36\n   #6  stl.fut:445:1-479:36\n");
        if (memblock_unref(ctx, &mem_313155, "mem_313155") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_313151, "mem_313151") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_317163, "mem_out_317163") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_317162, "mem_out_317162") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_317161, "mem_out_317161") != 0)
            return 1;
        err = FUTHARK_PROGRAM_ERROR;
        goto cleanup;
    }
    
    int64_t lifted_single_ma_l_arg_293311 = add64((int64_t) 1, j_293296);
    int64_t m_293312 = sub64(n_p_292677, (int64_t) 1);
    bool zzero_leq_i_p_m_t_s_293313 = sle64((int64_t) 0, m_293312);
    bool i_p_m_t_s_leq_w_293314 = slt64(m_293312, C_len_292823);
    bool y_293315 = zzero_leq_i_p_m_t_s_293313 && i_p_m_t_s_leq_w_293314;
    bool y_293316 = zzero_lte_i_293301 && y_293315;
    bool ok_or_empty_293317 = zzero_293289 || y_293316;
    bool protect_assert_disj_293318 = loop_not_taken_293291 ||
         ok_or_empty_293317;
    bool protect_assert_disj_293319 = loop_not_taken_293293 ||
         protect_assert_disj_293318;
    bool index_certs_293320;
    
    if (!protect_assert_disj_293319) {
        ctx->error = msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                               "Index [:", (long long) n_p_292677,
                               "] out of bounds for array of shape [",
                               (long long) C_len_292823, "].",
                               "-> #0  stl.fut:26:37-43\n   #1  stl.fut:26:20-48\n   #2  stl.fut:40:3-36\n   #3  stl.fut:233:23-47\n   #4  stl.fut:419:61-435:77\n   #5  stl.fut:463:3-479:36\n   #6  stl.fut:445:1-479:36\n");
        if (memblock_unref(ctx, &mem_313155, "mem_313155") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_313151, "mem_313151") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_317163, "mem_out_317163") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_317162, "mem_out_317162") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_317161, "mem_out_317161") != 0)
            return 1;
        err = FUTHARK_PROGRAM_ERROR;
        goto cleanup;
    }
    
    int64_t dyn_lifted_single_ma_l_arg_293321 = add64((int64_t) 2, n_292675);
    bool i_p_m_t_s_leq_w_293322 = slt64(m_293312,
                                        lifted_single_ma_l_arg_293311);
    bool y_293323 = zzero_leq_i_p_m_t_s_293313 && i_p_m_t_s_leq_w_293322;
    bool y_293324 = zzero_lte_i_293301 && y_293323;
    bool ok_or_empty_293325 = zzero_293289 || y_293324;
    bool protect_assert_disj_293326 = loop_not_taken_293291 ||
         ok_or_empty_293325;
    bool protect_assert_disj_293327 = loop_not_taken_293293 ||
         protect_assert_disj_293326;
    bool index_certs_293328;
    
    if (!protect_assert_disj_293327) {
        ctx->error = msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                               "Index [:", (long long) n_p_292677,
                               "] out of bounds for array of shape [",
                               (long long) lifted_single_ma_l_arg_293311, "].",
                               "-> #0  stl.fut:26:37-43\n   #1  stl.fut:26:20-48\n   #2  /prelude/functional.fut:9:42-44\n   #3  stl.fut:40:3-64\n   #4  stl.fut:233:23-47\n   #5  stl.fut:419:61-435:77\n   #6  stl.fut:463:3-479:36\n   #7  stl.fut:445:1-479:36\n");
        if (memblock_unref(ctx, &mem_313155, "mem_313155") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_313151, "mem_313151") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_317163, "mem_out_317163") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_317162, "mem_out_317162") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_317161, "mem_out_317161") != 0)
            return 1;
        err = FUTHARK_PROGRAM_ERROR;
        goto cleanup;
    }
    
    bool i_p_m_t_s_leq_w_293329 = slt64((int64_t) 2,
                                        dyn_lifted_single_ma_l_arg_293321);
    bool protect_assert_disj_293330 = loop_not_taken_293291 ||
         i_p_m_t_s_leq_w_293329;
    bool protect_assert_disj_293331 = loop_not_taken_293293 ||
         protect_assert_disj_293330;
    bool index_certs_293332;
    
    if (!protect_assert_disj_293331) {
        ctx->error = msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                               "Index [:", (long long) (int64_t) 3,
                               "] out of bounds for array of shape [",
                               (long long) dyn_lifted_single_ma_l_arg_293321,
                               "].",
                               "-> #0  stl.fut:26:37-43\n   #1  stl.fut:26:20-48\n   #2  /prelude/functional.fut:9:42-44\n   #3  stl.fut:40:3-84\n   #4  stl.fut:233:23-47\n   #5  stl.fut:419:61-435:77\n   #6  stl.fut:463:3-479:36\n   #7  stl.fut:445:1-479:36\n");
        if (memblock_unref(ctx, &mem_313155, "mem_313155") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_313151, "mem_313151") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_317163, "mem_out_317163") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_317162, "mem_out_317162") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_317161, "mem_out_317161") != 0)
            return 1;
        err = FUTHARK_PROGRAM_ERROR;
        goto cleanup;
    }
    
    bool cond_293333 = slt64(jump_l_292686, jump_threshold_1_292689);
    bool cond_293334 = slt64(jump_l_292686, jump_threshold_2_292690);
    bool cond_f_res_t_res_293335 = slt64(q_l_292680, q_threshold_2_292692);
    bool x_293336 = cond_293334 && cond_f_res_t_res_293335;
    bool x_293337 = !cond_293333;
    bool y_293338 = x_293336 && x_293337;
    bool cond_293339 = cond_293333 || y_293338;
    bool cond_293340 = slt64(jump_t_292685, jump_threshold_1_292689);
    bool cond_293341 = slt64(jump_t_292685, jump_threshold_2_292690);
    bool cond_f_res_t_res_293342 = slt64(q_t_292679, q_threshold_2_292692);
    bool x_293343 = cond_293341 && cond_f_res_t_res_293342;
    bool x_293344 = !cond_293340;
    bool y_293345 = x_293343 && x_293344;
    bool cond_293346 = cond_293340 || y_293345;
    bool cond_293347 = slt64(jump_s_292684, jump_threshold_1_292689);
    bool cond_293348 = slt64(jump_s_292684, jump_threshold_2_292690);
    bool cond_f_res_t_res_293349 = slt64(q_s_292678, q_threshold_2_292692);
    bool x_293350 = cond_293348 && cond_f_res_t_res_293349;
    bool x_293351 = !cond_293347;
    bool y_293352 = x_293350 && x_293351;
    bool cond_293353 = cond_293347 || y_293352;
    bool bounds_invalid_upwards_293354 = slt64(C_len_292823, (int64_t) 0);
    bool valid_293355 = !bounds_invalid_upwards_293354;
    bool protect_assert_disj_293356 = loop_not_taken_293291 || valid_293355;
    bool protect_assert_disj_293357 = loop_not_taken_293293 ||
         protect_assert_disj_293356;
    bool range_valid_c_293358;
    
    if (!protect_assert_disj_293357) {
        ctx->error = msgprintf("Error: %s%lld%s%lld%s%lld%s\n\nBacktrace:\n%s",
                               "Range ", (long long) (int64_t) 0, "..",
                               (long long) (int64_t) 1, "..<",
                               (long long) C_len_292823, " is invalid.",
                               "-> #0  /prelude/array.fut:90:3-10\n   #1  /prelude/array.fut:195:11-16\n   #2  utils.fut:6:3-16\n   #3  stl.fut:228:28-74\n   #4  stl.fut:227:21-229:39\n   #5  stl.fut:419:61-435:77\n   #6  stl.fut:463:3-479:36\n   #7  stl.fut:445:1-479:36\n");
        if (memblock_unref(ctx, &mem_313155, "mem_313155") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_313151, "mem_313151") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_317163, "mem_out_317163") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_317162, "mem_out_317162") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_317161, "mem_out_317161") != 0)
            return 1;
        err = FUTHARK_PROGRAM_ERROR;
        goto cleanup;
    }
    
    bool bounds_invalid_upwards_293360 = slt64(lifted_single_ma_l_arg_293311,
                                               (int64_t) 0);
    bool valid_293361 = !bounds_invalid_upwards_293360;
    bool protect_assert_disj_293362 = loop_not_taken_293291 || valid_293361;
    bool protect_assert_disj_293363 = loop_not_taken_293293 ||
         protect_assert_disj_293362;
    bool range_valid_c_293364;
    
    if (!protect_assert_disj_293363) {
        ctx->error = msgprintf("Error: %s%lld%s%lld%s%lld%s\n\nBacktrace:\n%s",
                               "Range ", (long long) (int64_t) 0, "..",
                               (long long) (int64_t) 1, "..<",
                               (long long) lifted_single_ma_l_arg_293311,
                               " is invalid.",
                               "-> #0  /prelude/array.fut:90:3-10\n   #1  /prelude/array.fut:195:11-16\n   #2  utils.fut:6:3-16\n   #3  stl.fut:29:13-35:19\n   #4  /prelude/soacs.fut:67:19-23\n   #5  /prelude/soacs.fut:67:3-37\n   #6  stl.fut:28:5-36:23\n   #7  stl.fut:40:3-36\n   #8  stl.fut:233:23-47\n   #9  stl.fut:419:61-435:77\n   #10 stl.fut:463:3-479:36\n   #11 stl.fut:445:1-479:36\n");
        if (memblock_unref(ctx, &mem_313155, "mem_313155") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_313151, "mem_313151") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_317163, "mem_out_317163") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_317162, "mem_out_317162") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_317161, "mem_out_317161") != 0)
            return 1;
        err = FUTHARK_PROGRAM_ERROR;
        goto cleanup;
    }
    
    bool bounds_invalid_upwards_293366 =
         slt64(dyn_lifted_single_ma_l_arg_293321, (int64_t) 0);
    bool valid_293367 = !bounds_invalid_upwards_293366;
    bool protect_assert_disj_293368 = loop_not_taken_293291 || valid_293367;
    bool protect_assert_disj_293369 = loop_not_taken_293293 ||
         protect_assert_disj_293368;
    bool range_valid_c_293370;
    
    if (!protect_assert_disj_293369) {
        ctx->error = msgprintf("Error: %s%lld%s%lld%s%lld%s\n\nBacktrace:\n%s",
                               "Range ", (long long) (int64_t) 0, "..",
                               (long long) (int64_t) 1, "..<",
                               (long long) dyn_lifted_single_ma_l_arg_293321,
                               " is invalid.",
                               "-> #0  /prelude/array.fut:90:3-10\n   #1  /prelude/array.fut:195:11-16\n   #2  utils.fut:6:3-16\n   #3  stl.fut:29:13-35:19\n   #4  /prelude/soacs.fut:67:19-23\n   #5  /prelude/soacs.fut:67:3-37\n   #6  stl.fut:28:5-36:23\n   #7  /prelude/functional.fut:9:42-44\n   #8  stl.fut:40:3-64\n   #9  stl.fut:233:23-47\n   #10 stl.fut:419:61-435:77\n   #11 stl.fut:463:3-479:36\n   #12 stl.fut:445:1-479:36\n");
        if (memblock_unref(ctx, &mem_313155, "mem_313155") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_313151, "mem_313151") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_317163, "mem_out_317163") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_317162, "mem_out_317162") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_317161, "mem_out_317161") != 0)
            return 1;
        err = FUTHARK_PROGRAM_ERROR;
        goto cleanup;
    }
    if (mem_313223_cached_sizze_337652 < (size_t) bytes_312635) {
        mem_313223 = realloc(mem_313223, bytes_312635);
        mem_313223_cached_sizze_337652 = bytes_312635;
    }
    if (mem_313366_cached_sizze_337653 < (size_t) bytes_312712) {
        mem_313366 = realloc(mem_313366, bytes_312712);
        mem_313366_cached_sizze_337653 = bytes_312712;
    }
    if (mem_313371_cached_sizze_337654 < (size_t) bytes_312712) {
        mem_313371 = realloc(mem_313371, bytes_312712);
        mem_313371_cached_sizze_337654 = bytes_312712;
    }
    
    int64_t binop_x_314919 = pad_css_len_292821 * binop_x_312709;
    int64_t binop_y_314920 = (int64_t) 8 * binop_x_314919;
    int64_t bytes_314921 = smax64((int64_t) 0, binop_y_314920);
    int64_t binop_x_314943 = partition_sizze_292766 * C_len_292823;
    int64_t binop_y_314944 = (int64_t) 8 * binop_x_314943;
    int64_t bytes_314945 = smax64((int64_t) 0, binop_y_314944);
    
    if (mem_314946_cached_sizze_337655 < (size_t) bytes_314945) {
        mem_314946 = realloc(mem_314946, bytes_314945);
        mem_314946_cached_sizze_337655 = bytes_314945;
    }
    
    int64_t binop_y_314925 = (int64_t) 8 * C_len_292823;
    int64_t bytes_314926 = smax64((int64_t) 0, binop_y_314925);
    
    if (mem_314949_cached_sizze_337656 < (size_t) bytes_312638) {
        mem_314949 = realloc(mem_314949, bytes_312638);
        mem_314949_cached_sizze_337656 = bytes_312638;
    }
    
    int64_t binop_x_314968 = partition_sizze_292766 *
            lifted_single_ma_l_arg_293311;
    int64_t binop_y_314969 = (int64_t) 8 * binop_x_314968;
    int64_t bytes_314970 = smax64((int64_t) 0, binop_y_314969);
    
    if (mem_314971_cached_sizze_337657 < (size_t) bytes_314970) {
        mem_314971 = realloc(mem_314971, bytes_314970);
        mem_314971_cached_sizze_337657 = bytes_314970;
    }
    
    int64_t binop_y_314950 = (int64_t) 8 * lifted_single_ma_l_arg_293311;
    int64_t bytes_314951 = smax64((int64_t) 0, binop_y_314950);
    
    if (mem_314974_cached_sizze_337658 < (size_t) bytes_312638) {
        mem_314974 = realloc(mem_314974, bytes_312638);
        mem_314974_cached_sizze_337658 = bytes_312638;
    }
    
    int64_t binop_x_314993 = partition_sizze_292766 *
            dyn_lifted_single_ma_l_arg_293321;
    int64_t binop_y_314994 = (int64_t) 8 * binop_x_314993;
    int64_t bytes_314995 = smax64((int64_t) 0, binop_y_314994);
    
    if (mem_314996_cached_sizze_337659 < (size_t) bytes_314995) {
        mem_314996 = realloc(mem_314996, bytes_314995);
        mem_314996_cached_sizze_337659 = bytes_314995;
    }
    
    int64_t binop_y_314975 = (int64_t) 8 * dyn_lifted_single_ma_l_arg_293321;
    int64_t bytes_314976 = smax64((int64_t) 0, binop_y_314975);
    
    if (mem_314999_cached_sizze_337660 < (size_t) bytes_312638) {
        mem_314999 = realloc(mem_314999, bytes_312638);
        mem_314999_cached_sizze_337660 = bytes_312638;
    }
    if (mem_315021_cached_sizze_337661 < (size_t) bytes_312635) {
        mem_315021 = realloc(mem_315021, bytes_312635);
        mem_315021_cached_sizze_337661 = bytes_312635;
    }
    
    int64_t ext_315634;
    
    if (cond_293285) {
        ext_315634 = n_292675;
    } else {
        ext_315634 = l_n_m_292832;
    }
    
    int64_t ext_316755;
    
    if (cond_293286) {
        ext_316755 = n_292675;
    } else {
        ext_316755 = t_n_m_292839;
    }
    
    int32_t i64_res_297059 = sext_i64_i32(n_292675);
    int64_t binop_y_316823 = (int64_t) 4 * partition_sizze_292766;
    int64_t bytes_316824 = smax64((int64_t) 0, binop_y_316823);
    int64_t binop_y_316830 = (int64_t) 4 * binop_x_312633;
    int64_t bytes_316831 = smax64((int64_t) 0, binop_y_316830);
    int64_t binop_y_316826 = (int64_t) 4 * n_292675;
    int64_t bytes_316827 = smax64((int64_t) 0, binop_y_316826);
    bool loop_cond_297079 = slt64((int64_t) 0, binop_x_312633);
    int64_t replicate_arg_297080 = mul64((int64_t) 2, partition_sizze_292766);
    int64_t binop_y_316910 = (int64_t) 4 * replicate_arg_297080;
    int64_t bytes_316911 = smax64((int64_t) 0, binop_y_316910);
    int64_t bytes_316916 = smax64((int64_t) 0, partition_sizze_292766);
    int64_t ext_317025;
    int64_t ext_317023;
    int64_t ext_317019;
    int64_t ext_317018;
    int64_t ext_317017;
    int64_t ext_317016;
    int64_t ext_317015;
    int64_t ext_317014;
    int64_t ext_317013;
    struct memblock ext_mem_317012;
    
    ext_mem_317012.references = NULL;
    
    struct memblock ext_mem_317011;
    
    ext_mem_317011.references = NULL;
    
    struct memblock ext_mem_317010;
    
    ext_mem_317010.references = NULL;
    
    struct memblock mem_param_313163;
    
    mem_param_313163.references = NULL;
    
    int64_t ctx_param_ext_313165;
    int64_t ctx_param_ext_313167;
    struct memblock mem_param_313171;
    
    mem_param_313171.references = NULL;
    
    int64_t ctx_param_ext_313172;
    int64_t ctx_param_ext_313173;
    int64_t ctx_param_ext_313174;
    int64_t ctx_param_ext_313175;
    int64_t ctx_param_ext_313176;
    int64_t ctx_param_ext_313177;
    int64_t ctx_param_ext_313178;
    struct memblock mem_param_313179;
    
    mem_param_313179.references = NULL;
    ctx_param_ext_313165 = n_292675;
    ctx_param_ext_313167 = n_292675;
    ctx_param_ext_313172 = partition_sizze_292766;
    ctx_param_ext_313173 = n_292675;
    ctx_param_ext_313174 = (int64_t) 0;
    ctx_param_ext_313175 = n_292675;
    ctx_param_ext_313176 = partition_sizze_292766;
    ctx_param_ext_313177 = (int64_t) 1;
    ctx_param_ext_313178 = n_292675;
    if (memblock_set(ctx, &mem_param_313163, &mem_313151, "mem_313151") != 0)
        return 1;
    if (memblock_set(ctx, &mem_param_313171, &mem_313151, "mem_313151") != 0)
        return 1;
    if (memblock_set(ctx, &mem_param_313179, &mem_313155, "mem_313155") != 0)
        return 1;
    for (int64_t i_outer_293375 = 0; i_outer_293375 < n_outer_292688;
         i_outer_293375++) {
        int64_t ext_316767;
        int64_t ext_316765;
        struct memblock ext_mem_316761;
        
        ext_mem_316761.references = NULL;
        
        struct memblock ext_mem_316760;
        
        ext_mem_316760.references = NULL;
        
        struct memblock mem_param_313193;
        
        mem_param_313193.references = NULL;
        
        int64_t ctx_param_ext_313195;
        int64_t ctx_param_ext_313197;
        struct memblock mem_param_313201;
        
        mem_param_313201.references = NULL;
        ctx_param_ext_313195 = ctx_param_ext_313165;
        ctx_param_ext_313197 = ctx_param_ext_313167;
        if (memblock_set(ctx, &mem_param_313193, &mem_param_313163,
                         "mem_param_313163") != 0)
            return 1;
        if (memblock_set(ctx, &mem_param_313201, &mem_param_313171,
                         "mem_param_313171") != 0)
            return 1;
        for (int64_t _i_inner_293381 = 0; _i_inner_293381 < n_inner_292687;
             _i_inner_293381++) {
            int64_t flat_tid_298260 = (int64_t) 0;
            int32_t num_tasks_318892;
            int64_t flat_tid_298266 = (int64_t) 0;
            struct futhark_mc_task_337886 futhark_mc_task_337886;
            
            futhark_mc_task_337886.ctx = ctx;
            futhark_mc_task_337886.free_n_292675 = n_292675;
            futhark_mc_task_337886.free_partition_sizze_292766 =
                partition_sizze_292766;
            futhark_mc_task_337886.free_mem_312593 = mem_312593;
            futhark_mc_task_337886.free_bytes_312598 = bytes_312598;
            futhark_mc_task_337886.free_ctx_param_ext_313197 =
                ctx_param_ext_313197;
            futhark_mc_task_337886.free_mem_param_313201 = mem_param_313201.mem;
            futhark_mc_task_337886.free_mem_313223 = mem_313223;
            
            struct scheduler_segop futhark_mc_task_337886_task;
            
            futhark_mc_task_337886_task.args = &futhark_mc_task_337886;
            futhark_mc_task_337886_task.top_level_fn =
                futhark_mc_segmap_task_337887;
            futhark_mc_task_337886_task.name = "futhark_mc_segmap_task_337887";
            futhark_mc_task_337886_task.iterations = partition_sizze_292766;
            futhark_mc_task_337886_task.task_time =
                &ctx->futhark_mc_segmap_task_337887_total_time;
            futhark_mc_task_337886_task.task_iter =
                &ctx->futhark_mc_segmap_task_337887_total_iter;
            futhark_mc_task_337886_task.sched = STATIC;
            futhark_mc_task_337886_task.nested_fn =
                futhark_mc_segmap_nested_task_337891;
            
            int futhark_mc_segmap_task_337887_err =
                scheduler_prepare_task(&ctx->scheduler,
                                       &futhark_mc_task_337886_task);
            
            if (futhark_mc_segmap_task_337887_err != 0) {
                if (memblock_unref(ctx, &mem_param_313201,
                                   "mem_param_313201") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_313193,
                                   "mem_param_313193") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_316760, "ext_mem_316760") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_316761, "ext_mem_316761") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_313179,
                                   "mem_param_313179") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_313171,
                                   "mem_param_313171") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_313163,
                                   "mem_param_313163") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_317010, "ext_mem_317010") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_317011, "ext_mem_317011") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_317012, "ext_mem_317012") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_313155, "mem_313155") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_313151, "mem_313151") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_out_317163, "mem_out_317163") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_out_317162, "mem_out_317162") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_out_317161, "mem_out_317161") != 0)
                    return 1;
                ;
                err = futhark_mc_segmap_task_337887_err;
                goto cleanup;
            }
            
            int64_t flat_tid_298277 = (int64_t) 0;
            int32_t num_tasks_318917;
            int64_t flat_tid_298311 = (int64_t) 0;
            struct futhark_mc_task_337899 futhark_mc_task_337899;
            
            futhark_mc_task_337899.ctx = ctx;
            futhark_mc_task_337899.free_n_292675 = n_292675;
            futhark_mc_task_337899.free_n_p_292677 = n_p_292677;
            futhark_mc_task_337899.free_partition_sizze_292766 =
                partition_sizze_292766;
            futhark_mc_task_337899.free_defunc_0_f_res_292820 =
                defunc_0_f_res_292820;
            futhark_mc_task_337899.free_i_292846 = i_292846;
            futhark_mc_task_337899.free_bytes_312641 = bytes_312641;
            futhark_mc_task_337899.free_bytes_312660 = bytes_312660;
            futhark_mc_task_337899.free_mem_312838 = mem_312838;
            futhark_mc_task_337899.free_ctx_param_ext_313174 =
                ctx_param_ext_313174;
            futhark_mc_task_337899.free_ctx_param_ext_313175 =
                ctx_param_ext_313175;
            futhark_mc_task_337899.free_ctx_param_ext_313177 =
                ctx_param_ext_313177;
            futhark_mc_task_337899.free_mem_param_313179 = mem_param_313179.mem;
            futhark_mc_task_337899.free_mem_313223 = mem_313223;
            futhark_mc_task_337899.free_mem_313366 = mem_313366;
            futhark_mc_task_337899.free_mem_313371 = mem_313371;
            
            struct scheduler_segop futhark_mc_task_337899_task;
            
            futhark_mc_task_337899_task.args = &futhark_mc_task_337899;
            futhark_mc_task_337899_task.top_level_fn =
                futhark_mc_segmap_task_337900;
            futhark_mc_task_337899_task.name = "futhark_mc_segmap_task_337900";
            futhark_mc_task_337899_task.iterations = partition_sizze_292766;
            futhark_mc_task_337899_task.task_time =
                &ctx->futhark_mc_segmap_task_337900_total_time;
            futhark_mc_task_337899_task.task_iter =
                &ctx->futhark_mc_segmap_task_337900_total_iter;
            futhark_mc_task_337899_task.sched = STATIC;
            futhark_mc_task_337899_task.nested_fn =
                futhark_mc_segmap_nested_task_337905;
            
            int futhark_mc_segmap_task_337900_err =
                scheduler_prepare_task(&ctx->scheduler,
                                       &futhark_mc_task_337899_task);
            
            if (futhark_mc_segmap_task_337900_err != 0) {
                if (memblock_unref(ctx, &mem_param_313201,
                                   "mem_param_313201") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_313193,
                                   "mem_param_313193") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_316760, "ext_mem_316760") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_316761, "ext_mem_316761") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_313179,
                                   "mem_param_313179") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_313171,
                                   "mem_param_313171") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_313163,
                                   "mem_param_313163") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_317010, "ext_mem_317010") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_317011, "ext_mem_317011") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_317012, "ext_mem_317012") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_313155, "mem_313155") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_313151, "mem_313151") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_out_317163, "mem_out_317163") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_out_317162, "mem_out_317162") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_out_317161, "mem_out_317161") != 0)
                    return 1;
                ;
                err = futhark_mc_segmap_task_337900_err;
                goto cleanup;
            }
            
            struct memblock ext_mem_314848;
            
            ext_mem_314848.references = NULL;
            
            struct memblock ext_mem_314847;
            
            ext_mem_314847.references = NULL;
            if (cond_293353) {
                bool match_lit_293424 = (int64_t) 0 == d_s_292681;
                struct memblock ext_mem_313750;
                
                ext_mem_313750.references = NULL;
                
                struct memblock ext_mem_313749;
                
                ext_mem_313749.references = NULL;
                if (match_lit_293424) {
                    struct memblock mem_313376;
                    
                    mem_313376.references = NULL;
                    if (memblock_alloc(ctx, &mem_313376, bytes_313017,
                                       "mem_313376")) {
                        err = 1;
                        goto cleanup;
                    }
                    for (int64_t i_319065 = 0; i_319065 <
                         partition_sizze_292766; i_319065++) {
                        for (int64_t i_319066 = 0; i_319066 < n_p_292677;
                             i_319066++) {
                            for (int64_t i_319067 = 0; i_319067 < s_n_m_292825;
                                 i_319067++) {
                                ((double *) mem_313376.mem)[i_319065 *
                                                            (s_n_m_292825 *
                                                             n_p_292677) +
                                                            i_319066 *
                                                            s_n_m_292825 +
                                                            i_319067] = 0.0;
                            }
                        }
                    }
                    
                    struct memblock mem_313450;
                    
                    mem_313450.references = NULL;
                    if (memblock_alloc(ctx, &mem_313450, bytes_313017,
                                       "mem_313450")) {
                        err = 1;
                        goto cleanup;
                    }
                    
                    int64_t flat_tid_298364 = (int64_t) 0;
                    int32_t num_tasks_319068;
                    int64_t flat_tid_298628 = (int64_t) 0;
                    struct futhark_mc_task_337925 futhark_mc_task_337925;
                    
                    futhark_mc_task_337925.ctx = ctx;
                    futhark_mc_task_337925.free_n_p_292677 = n_p_292677;
                    futhark_mc_task_337925.free_q_s_292678 = q_s_292678;
                    futhark_mc_task_337925.free_jump_s_292684 = jump_s_292684;
                    futhark_mc_task_337925.free_partition_sizze_292766 =
                        partition_sizze_292766;
                    futhark_mc_task_337925.free_defunc_0_f_res_292820 =
                        defunc_0_f_res_292820;
                    futhark_mc_task_337925.free_pad_css_len_292821 =
                        pad_css_len_292821;
                    futhark_mc_task_337925.free_s_n_m_292825 = s_n_m_292825;
                    futhark_mc_task_337925.free_mem_312838 = mem_312838;
                    futhark_mc_task_337925.free_mem_312842 = mem_312842;
                    futhark_mc_task_337925.free_bytes_312847 = bytes_312847;
                    futhark_mc_task_337925.free_bytes_312899 = bytes_312899;
                    futhark_mc_task_337925.free_mem_313018 = mem_313018;
                    futhark_mc_task_337925.free_mem_313023 = mem_313023;
                    futhark_mc_task_337925.free_mem_313366 = mem_313366;
                    futhark_mc_task_337925.free_mem_313371 = mem_313371;
                    futhark_mc_task_337925.free_mem_313450 = mem_313450.mem;
                    
                    struct scheduler_segop futhark_mc_task_337925_task;
                    
                    futhark_mc_task_337925_task.args = &futhark_mc_task_337925;
                    futhark_mc_task_337925_task.top_level_fn =
                        futhark_mc_segmap_task_337926;
                    futhark_mc_task_337925_task.name =
                        "futhark_mc_segmap_task_337926";
                    futhark_mc_task_337925_task.iterations =
                        partition_sizze_292766;
                    futhark_mc_task_337925_task.task_time =
                        &ctx->futhark_mc_segmap_task_337926_total_time;
                    futhark_mc_task_337925_task.task_iter =
                        &ctx->futhark_mc_segmap_task_337926_total_iter;
                    futhark_mc_task_337925_task.sched = STATIC;
                    futhark_mc_task_337925_task.nested_fn =
                        futhark_mc_segmap_nested_task_337930;
                    
                    int futhark_mc_segmap_task_337926_err =
                        scheduler_prepare_task(&ctx->scheduler,
                                               &futhark_mc_task_337925_task);
                    
                    if (futhark_mc_segmap_task_337926_err != 0) {
                        if (memblock_unref(ctx, &mem_313450, "mem_313450") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_313376, "mem_313376") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_313749,
                                           "ext_mem_313749") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_313750,
                                           "ext_mem_313750") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_314847,
                                           "ext_mem_314847") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_314848,
                                           "ext_mem_314848") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_param_313201,
                                           "mem_param_313201") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_param_313193,
                                           "mem_param_313193") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_316760,
                                           "ext_mem_316760") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_316761,
                                           "ext_mem_316761") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_param_313179,
                                           "mem_param_313179") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_param_313171,
                                           "mem_param_313171") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_param_313163,
                                           "mem_param_313163") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_317010,
                                           "ext_mem_317010") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_317011,
                                           "ext_mem_317011") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_317012,
                                           "ext_mem_317012") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_313155, "mem_313155") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_313151, "mem_313151") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_out_317163,
                                           "mem_out_317163") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_out_317162,
                                           "mem_out_317162") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_out_317161,
                                           "mem_out_317161") != 0)
                            return 1;
                        ;
                        err = futhark_mc_segmap_task_337926_err;
                        goto cleanup;
                    }
                    if (memblock_set(ctx, &ext_mem_313750, &mem_313450,
                                     "mem_313450") != 0)
                        return 1;
                    if (memblock_set(ctx, &ext_mem_313749, &mem_313376,
                                     "mem_313376") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_313450, "mem_313450") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_313376, "mem_313376") != 0)
                        return 1;
                } else {
                    bool match_lit_293523 = (int64_t) 1 == d_s_292681;
                    struct memblock ext_mem_313748;
                    
                    ext_mem_313748.references = NULL;
                    
                    struct memblock ext_mem_313747;
                    
                    ext_mem_313747.references = NULL;
                    if (match_lit_293523) {
                        struct memblock mem_313593;
                        
                        mem_313593.references = NULL;
                        if (memblock_alloc(ctx, &mem_313593, bytes_313017,
                                           "mem_313593")) {
                            err = 1;
                            goto cleanup;
                        }
                        
                        struct memblock mem_313598;
                        
                        mem_313598.references = NULL;
                        if (memblock_alloc(ctx, &mem_313598, bytes_313017,
                                           "mem_313598")) {
                            err = 1;
                            goto cleanup;
                        }
                        
                        int64_t flat_tid_298888 = (int64_t) 0;
                        int32_t num_tasks_319790;
                        int64_t flat_tid_299243 = (int64_t) 0;
                        struct futhark_mc_task_337960 futhark_mc_task_337960;
                        
                        futhark_mc_task_337960.ctx = ctx;
                        futhark_mc_task_337960.free_n_p_292677 = n_p_292677;
                        futhark_mc_task_337960.free_q_s_292678 = q_s_292678;
                        futhark_mc_task_337960.free_jump_s_292684 =
                            jump_s_292684;
                        futhark_mc_task_337960.free_partition_sizze_292766 =
                            partition_sizze_292766;
                        futhark_mc_task_337960.free_defunc_0_f_res_292820 =
                            defunc_0_f_res_292820;
                        futhark_mc_task_337960.free_pad_css_len_292821 =
                            pad_css_len_292821;
                        futhark_mc_task_337960.free_s_n_m_292825 = s_n_m_292825;
                        futhark_mc_task_337960.free_mem_312838 = mem_312838;
                        futhark_mc_task_337960.free_mem_312842 = mem_312842;
                        futhark_mc_task_337960.free_bytes_312847 = bytes_312847;
                        futhark_mc_task_337960.free_bytes_312899 = bytes_312899;
                        futhark_mc_task_337960.free_mem_313018 = mem_313018;
                        futhark_mc_task_337960.free_mem_313023 = mem_313023;
                        futhark_mc_task_337960.free_mem_313366 = mem_313366;
                        futhark_mc_task_337960.free_mem_313371 = mem_313371;
                        futhark_mc_task_337960.free_mem_313593 = mem_313593.mem;
                        futhark_mc_task_337960.free_mem_313598 = mem_313598.mem;
                        
                        struct scheduler_segop futhark_mc_task_337960_task;
                        
                        futhark_mc_task_337960_task.args =
                            &futhark_mc_task_337960;
                        futhark_mc_task_337960_task.top_level_fn =
                            futhark_mc_segmap_task_337961;
                        futhark_mc_task_337960_task.name =
                            "futhark_mc_segmap_task_337961";
                        futhark_mc_task_337960_task.iterations =
                            partition_sizze_292766;
                        futhark_mc_task_337960_task.task_time =
                            &ctx->futhark_mc_segmap_task_337961_total_time;
                        futhark_mc_task_337960_task.task_iter =
                            &ctx->futhark_mc_segmap_task_337961_total_iter;
                        futhark_mc_task_337960_task.sched = STATIC;
                        futhark_mc_task_337960_task.nested_fn =
                            futhark_mc_segmap_nested_task_337966;
                        
                        int futhark_mc_segmap_task_337961_err =
                            scheduler_prepare_task(&ctx->scheduler,
                                                   &futhark_mc_task_337960_task);
                        
                        if (futhark_mc_segmap_task_337961_err != 0) {
                            if (memblock_unref(ctx, &mem_313598,
                                               "mem_313598") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_313593,
                                               "mem_313593") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_313747,
                                               "ext_mem_313747") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_313748,
                                               "ext_mem_313748") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_313749,
                                               "ext_mem_313749") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_313750,
                                               "ext_mem_313750") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_314847,
                                               "ext_mem_314847") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_314848,
                                               "ext_mem_314848") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_313201,
                                               "mem_param_313201") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_313193,
                                               "mem_param_313193") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_316760,
                                               "ext_mem_316760") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_316761,
                                               "ext_mem_316761") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_313179,
                                               "mem_param_313179") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_313171,
                                               "mem_param_313171") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_313163,
                                               "mem_param_313163") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_317010,
                                               "ext_mem_317010") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_317011,
                                               "ext_mem_317011") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_317012,
                                               "ext_mem_317012") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_313155,
                                               "mem_313155") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_313151,
                                               "mem_313151") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_317163,
                                               "mem_out_317163") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_317162,
                                               "mem_out_317162") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_317161,
                                               "mem_out_317161") != 0)
                                return 1;
                            ;
                            err = futhark_mc_segmap_task_337961_err;
                            goto cleanup;
                        }
                        if (memblock_set(ctx, &ext_mem_313748, &mem_313593,
                                         "mem_313593") != 0)
                            return 1;
                        if (memblock_set(ctx, &ext_mem_313747, &mem_313598,
                                         "mem_313598") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_313598, "mem_313598") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_313593, "mem_313593") != 0)
                            return 1;
                    } else {
                        struct memblock mem_313741;
                        
                        mem_313741.references = NULL;
                        if (memblock_alloc(ctx, &mem_313741, bytes_313017,
                                           "mem_313741")) {
                            err = 1;
                            goto cleanup;
                        }
                        
                        struct memblock mem_313746;
                        
                        mem_313746.references = NULL;
                        if (memblock_alloc(ctx, &mem_313746, bytes_313017,
                                           "mem_313746")) {
                            err = 1;
                            goto cleanup;
                        }
                        
                        int64_t flat_tid_299596 = (int64_t) 0;
                        int32_t num_tasks_320783;
                        int64_t flat_tid_300053 = (int64_t) 0;
                        struct futhark_mc_task_338002 futhark_mc_task_338002;
                        
                        futhark_mc_task_338002.ctx = ctx;
                        futhark_mc_task_338002.free_n_p_292677 = n_p_292677;
                        futhark_mc_task_338002.free_q_s_292678 = q_s_292678;
                        futhark_mc_task_338002.free_jump_s_292684 =
                            jump_s_292684;
                        futhark_mc_task_338002.free_partition_sizze_292766 =
                            partition_sizze_292766;
                        futhark_mc_task_338002.free_defunc_0_f_res_292820 =
                            defunc_0_f_res_292820;
                        futhark_mc_task_338002.free_pad_css_len_292821 =
                            pad_css_len_292821;
                        futhark_mc_task_338002.free_s_n_m_292825 = s_n_m_292825;
                        futhark_mc_task_338002.free_mem_312838 = mem_312838;
                        futhark_mc_task_338002.free_mem_312842 = mem_312842;
                        futhark_mc_task_338002.free_bytes_312847 = bytes_312847;
                        futhark_mc_task_338002.free_bytes_312899 = bytes_312899;
                        futhark_mc_task_338002.free_mem_313018 = mem_313018;
                        futhark_mc_task_338002.free_mem_313023 = mem_313023;
                        futhark_mc_task_338002.free_mem_313366 = mem_313366;
                        futhark_mc_task_338002.free_mem_313371 = mem_313371;
                        futhark_mc_task_338002.free_mem_313741 = mem_313741.mem;
                        futhark_mc_task_338002.free_mem_313746 = mem_313746.mem;
                        
                        struct scheduler_segop futhark_mc_task_338002_task;
                        
                        futhark_mc_task_338002_task.args =
                            &futhark_mc_task_338002;
                        futhark_mc_task_338002_task.top_level_fn =
                            futhark_mc_segmap_task_338003;
                        futhark_mc_task_338002_task.name =
                            "futhark_mc_segmap_task_338003";
                        futhark_mc_task_338002_task.iterations =
                            partition_sizze_292766;
                        futhark_mc_task_338002_task.task_time =
                            &ctx->futhark_mc_segmap_task_338003_total_time;
                        futhark_mc_task_338002_task.task_iter =
                            &ctx->futhark_mc_segmap_task_338003_total_iter;
                        futhark_mc_task_338002_task.sched = STATIC;
                        futhark_mc_task_338002_task.nested_fn =
                            futhark_mc_segmap_nested_task_338008;
                        
                        int futhark_mc_segmap_task_338003_err =
                            scheduler_prepare_task(&ctx->scheduler,
                                                   &futhark_mc_task_338002_task);
                        
                        if (futhark_mc_segmap_task_338003_err != 0) {
                            if (memblock_unref(ctx, &mem_313746,
                                               "mem_313746") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_313741,
                                               "mem_313741") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_313747,
                                               "ext_mem_313747") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_313748,
                                               "ext_mem_313748") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_313749,
                                               "ext_mem_313749") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_313750,
                                               "ext_mem_313750") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_314847,
                                               "ext_mem_314847") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_314848,
                                               "ext_mem_314848") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_313201,
                                               "mem_param_313201") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_313193,
                                               "mem_param_313193") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_316760,
                                               "ext_mem_316760") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_316761,
                                               "ext_mem_316761") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_313179,
                                               "mem_param_313179") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_313171,
                                               "mem_param_313171") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_313163,
                                               "mem_param_313163") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_317010,
                                               "ext_mem_317010") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_317011,
                                               "ext_mem_317011") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_317012,
                                               "ext_mem_317012") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_313155,
                                               "mem_313155") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_313151,
                                               "mem_313151") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_317163,
                                               "mem_out_317163") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_317162,
                                               "mem_out_317162") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_317161,
                                               "mem_out_317161") != 0)
                                return 1;
                            ;
                            err = futhark_mc_segmap_task_338003_err;
                            goto cleanup;
                        }
                        if (memblock_set(ctx, &ext_mem_313748, &mem_313741,
                                         "mem_313741") != 0)
                            return 1;
                        if (memblock_set(ctx, &ext_mem_313747, &mem_313746,
                                         "mem_313746") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_313746, "mem_313746") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_313741, "mem_313741") != 0)
                            return 1;
                    }
                    if (memblock_set(ctx, &ext_mem_313750, &ext_mem_313748,
                                     "ext_mem_313748") != 0)
                        return 1;
                    if (memblock_set(ctx, &ext_mem_313749, &ext_mem_313747,
                                     "ext_mem_313747") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_313747,
                                       "ext_mem_313747") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_313748,
                                       "ext_mem_313748") != 0)
                        return 1;
                }
                if (memblock_set(ctx, &ext_mem_314848, &ext_mem_313750,
                                 "ext_mem_313750") != 0)
                    return 1;
                if (memblock_set(ctx, &ext_mem_314847, &ext_mem_313749,
                                 "ext_mem_313749") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_313749, "ext_mem_313749") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_313750, "ext_mem_313750") != 0)
                    return 1;
            } else {
                bool cond_293816 = sle64(jump_threshold_2_292690,
                                         jump_s_292684);
                bool cond_t_res_293817 = slt64(q_s_292678,
                                               q_threshold_1_292691);
                bool x_293818 = cond_293816 && cond_t_res_293817;
                struct memblock ext_mem_314846;
                
                ext_mem_314846.references = NULL;
                
                struct memblock ext_mem_314845;
                
                ext_mem_314845.references = NULL;
                if (x_293818) {
                    bool match_lit_293821 = (int64_t) 0 == d_s_292681;
                    struct memblock ext_mem_314465;
                    
                    ext_mem_314465.references = NULL;
                    
                    struct memblock ext_mem_314464;
                    
                    ext_mem_314464.references = NULL;
                    if (match_lit_293821) {
                        struct memblock mem_313755;
                        
                        mem_313755.references = NULL;
                        if (memblock_alloc(ctx, &mem_313755, bytes_313017,
                                           "mem_313755")) {
                            err = 1;
                            goto cleanup;
                        }
                        for (int64_t i_322046 = 0; i_322046 <
                             partition_sizze_292766; i_322046++) {
                            for (int64_t i_322047 = 0; i_322047 < n_p_292677;
                                 i_322047++) {
                                for (int64_t i_322048 = 0; i_322048 <
                                     s_n_m_292825; i_322048++) {
                                    ((double *) mem_313755.mem)[i_322046 *
                                                                (s_n_m_292825 *
                                                                 n_p_292677) +
                                                                i_322047 *
                                                                s_n_m_292825 +
                                                                i_322048] = 0.0;
                                }
                            }
                        }
                        
                        struct memblock mem_313877;
                        
                        mem_313877.references = NULL;
                        if (memblock_alloc(ctx, &mem_313877, bytes_313017,
                                           "mem_313877")) {
                            err = 1;
                            goto cleanup;
                        }
                        
                        int64_t binop_y_313756 = (int64_t) 8 * q_s_292678;
                        int64_t bytes_313757 = smax64((int64_t) 0,
                                                      binop_y_313756);
                        int64_t flat_tid_300508 = (int64_t) 0;
                        int32_t num_tasks_322049;
                        int64_t flat_tid_300700 = (int64_t) 0;
                        struct futhark_mc_task_338046 futhark_mc_task_338046;
                        
                        futhark_mc_task_338046.ctx = ctx;
                        futhark_mc_task_338046.free_n_p_292677 = n_p_292677;
                        futhark_mc_task_338046.free_q_s_292678 = q_s_292678;
                        futhark_mc_task_338046.free_jump_s_292684 =
                            jump_s_292684;
                        futhark_mc_task_338046.free_partition_sizze_292766 =
                            partition_sizze_292766;
                        futhark_mc_task_338046.free_defunc_0_f_res_292820 =
                            defunc_0_f_res_292820;
                        futhark_mc_task_338046.free_pad_css_len_292821 =
                            pad_css_len_292821;
                        futhark_mc_task_338046.free_s_n_m_292825 = s_n_m_292825;
                        futhark_mc_task_338046.free_mem_312838 = mem_312838;
                        futhark_mc_task_338046.free_mem_312842 = mem_312842;
                        futhark_mc_task_338046.free_bytes_312847 = bytes_312847;
                        futhark_mc_task_338046.free_bytes_312899 = bytes_312899;
                        futhark_mc_task_338046.free_mem_313018 = mem_313018;
                        futhark_mc_task_338046.free_mem_313023 = mem_313023;
                        futhark_mc_task_338046.free_mem_313366 = mem_313366;
                        futhark_mc_task_338046.free_mem_313371 = mem_313371;
                        futhark_mc_task_338046.free_bytes_313757 = bytes_313757;
                        futhark_mc_task_338046.free_mem_313877 = mem_313877.mem;
                        
                        struct scheduler_segop futhark_mc_task_338046_task;
                        
                        futhark_mc_task_338046_task.args =
                            &futhark_mc_task_338046;
                        futhark_mc_task_338046_task.top_level_fn =
                            futhark_mc_segmap_task_338047;
                        futhark_mc_task_338046_task.name =
                            "futhark_mc_segmap_task_338047";
                        futhark_mc_task_338046_task.iterations =
                            partition_sizze_292766;
                        futhark_mc_task_338046_task.task_time =
                            &ctx->futhark_mc_segmap_task_338047_total_time;
                        futhark_mc_task_338046_task.task_iter =
                            &ctx->futhark_mc_segmap_task_338047_total_iter;
                        futhark_mc_task_338046_task.sched = STATIC;
                        futhark_mc_task_338046_task.nested_fn =
                            futhark_mc_segmap_nested_task_338052;
                        
                        int futhark_mc_segmap_task_338047_err =
                            scheduler_prepare_task(&ctx->scheduler,
                                                   &futhark_mc_task_338046_task);
                        
                        if (futhark_mc_segmap_task_338047_err != 0) {
                            if (memblock_unref(ctx, &mem_313877,
                                               "mem_313877") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_313755,
                                               "mem_313755") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_314464,
                                               "ext_mem_314464") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_314465,
                                               "ext_mem_314465") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_314845,
                                               "ext_mem_314845") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_314846,
                                               "ext_mem_314846") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_314847,
                                               "ext_mem_314847") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_314848,
                                               "ext_mem_314848") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_313201,
                                               "mem_param_313201") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_313193,
                                               "mem_param_313193") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_316760,
                                               "ext_mem_316760") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_316761,
                                               "ext_mem_316761") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_313179,
                                               "mem_param_313179") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_313171,
                                               "mem_param_313171") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_313163,
                                               "mem_param_313163") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_317010,
                                               "ext_mem_317010") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_317011,
                                               "ext_mem_317011") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_317012,
                                               "ext_mem_317012") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_313155,
                                               "mem_313155") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_313151,
                                               "mem_313151") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_317163,
                                               "mem_out_317163") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_317162,
                                               "mem_out_317162") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_317161,
                                               "mem_out_317161") != 0)
                                return 1;
                            ;
                            err = futhark_mc_segmap_task_338047_err;
                            goto cleanup;
                        }
                        if (memblock_set(ctx, &ext_mem_314465, &mem_313877,
                                         "mem_313877") != 0)
                            return 1;
                        if (memblock_set(ctx, &ext_mem_314464, &mem_313755,
                                         "mem_313755") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_313877, "mem_313877") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_313755, "mem_313755") != 0)
                            return 1;
                    } else {
                        bool match_lit_293896 = (int64_t) 1 == d_s_292681;
                        struct memblock ext_mem_314463;
                        
                        ext_mem_314463.references = NULL;
                        
                        struct memblock ext_mem_314462;
                        
                        ext_mem_314462.references = NULL;
                        if (match_lit_293896) {
                            struct memblock mem_314116;
                            
                            mem_314116.references = NULL;
                            if (memblock_alloc(ctx, &mem_314116, bytes_313017,
                                               "mem_314116")) {
                                err = 1;
                                goto cleanup;
                            }
                            
                            struct memblock mem_314121;
                            
                            mem_314121.references = NULL;
                            if (memblock_alloc(ctx, &mem_314121, bytes_313017,
                                               "mem_314121")) {
                                err = 1;
                                goto cleanup;
                            }
                            
                            int64_t binop_y_313878 = (int64_t) 8 * q_s_292678;
                            int64_t bytes_313879 = smax64((int64_t) 0,
                                                          binop_y_313878);
                            int64_t flat_tid_300888 = (int64_t) 0;
                            int32_t num_tasks_322580;
                            int64_t flat_tid_301174 = (int64_t) 0;
                            struct futhark_mc_task_338085
                            futhark_mc_task_338085;
                            
                            futhark_mc_task_338085.ctx = ctx;
                            futhark_mc_task_338085.free_n_p_292677 = n_p_292677;
                            futhark_mc_task_338085.free_q_s_292678 = q_s_292678;
                            futhark_mc_task_338085.free_jump_s_292684 =
                                jump_s_292684;
                            futhark_mc_task_338085.free_partition_sizze_292766 =
                                partition_sizze_292766;
                            futhark_mc_task_338085.free_defunc_0_f_res_292820 =
                                defunc_0_f_res_292820;
                            futhark_mc_task_338085.free_pad_css_len_292821 =
                                pad_css_len_292821;
                            futhark_mc_task_338085.free_s_n_m_292825 =
                                s_n_m_292825;
                            futhark_mc_task_338085.free_mem_312838 = mem_312838;
                            futhark_mc_task_338085.free_mem_312842 = mem_312842;
                            futhark_mc_task_338085.free_bytes_312847 =
                                bytes_312847;
                            futhark_mc_task_338085.free_bytes_312899 =
                                bytes_312899;
                            futhark_mc_task_338085.free_mem_313018 = mem_313018;
                            futhark_mc_task_338085.free_mem_313023 = mem_313023;
                            futhark_mc_task_338085.free_mem_313366 = mem_313366;
                            futhark_mc_task_338085.free_mem_313371 = mem_313371;
                            futhark_mc_task_338085.free_bytes_313879 =
                                bytes_313879;
                            futhark_mc_task_338085.free_mem_314116 =
                                mem_314116.mem;
                            futhark_mc_task_338085.free_mem_314121 =
                                mem_314121.mem;
                            
                            struct scheduler_segop futhark_mc_task_338085_task;
                            
                            futhark_mc_task_338085_task.args =
                                &futhark_mc_task_338085;
                            futhark_mc_task_338085_task.top_level_fn =
                                futhark_mc_segmap_task_338086;
                            futhark_mc_task_338085_task.name =
                                "futhark_mc_segmap_task_338086";
                            futhark_mc_task_338085_task.iterations =
                                partition_sizze_292766;
                            futhark_mc_task_338085_task.task_time =
                                &ctx->futhark_mc_segmap_task_338086_total_time;
                            futhark_mc_task_338085_task.task_iter =
                                &ctx->futhark_mc_segmap_task_338086_total_iter;
                            futhark_mc_task_338085_task.sched = STATIC;
                            futhark_mc_task_338085_task.nested_fn =
                                futhark_mc_segmap_nested_task_338093;
                            
                            int futhark_mc_segmap_task_338086_err =
                                scheduler_prepare_task(&ctx->scheduler,
                                                       &futhark_mc_task_338085_task);
                            
                            if (futhark_mc_segmap_task_338086_err != 0) {
                                if (memblock_unref(ctx, &mem_314121,
                                                   "mem_314121") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_314116,
                                                   "mem_314116") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_314462,
                                                   "ext_mem_314462") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_314463,
                                                   "ext_mem_314463") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_314464,
                                                   "ext_mem_314464") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_314465,
                                                   "ext_mem_314465") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_314845,
                                                   "ext_mem_314845") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_314846,
                                                   "ext_mem_314846") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_314847,
                                                   "ext_mem_314847") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_314848,
                                                   "ext_mem_314848") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_param_313201,
                                                   "mem_param_313201") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_param_313193,
                                                   "mem_param_313193") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_316760,
                                                   "ext_mem_316760") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_316761,
                                                   "ext_mem_316761") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_param_313179,
                                                   "mem_param_313179") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_param_313171,
                                                   "mem_param_313171") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_param_313163,
                                                   "mem_param_313163") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_317010,
                                                   "ext_mem_317010") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_317011,
                                                   "ext_mem_317011") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_317012,
                                                   "ext_mem_317012") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_313155,
                                                   "mem_313155") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_313151,
                                                   "mem_313151") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_out_317163,
                                                   "mem_out_317163") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_out_317162,
                                                   "mem_out_317162") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_out_317161,
                                                   "mem_out_317161") != 0)
                                    return 1;
                                ;
                                err = futhark_mc_segmap_task_338086_err;
                                goto cleanup;
                            }
                            if (memblock_set(ctx, &ext_mem_314463, &mem_314116,
                                             "mem_314116") != 0)
                                return 1;
                            if (memblock_set(ctx, &ext_mem_314462, &mem_314121,
                                             "mem_314121") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_314121,
                                               "mem_314121") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_314116,
                                               "mem_314116") != 0)
                                return 1;
                        } else {
                            struct memblock mem_314456;
                            
                            mem_314456.references = NULL;
                            if (memblock_alloc(ctx, &mem_314456, bytes_313017,
                                               "mem_314456")) {
                                err = 1;
                                goto cleanup;
                            }
                            
                            struct memblock mem_314461;
                            
                            mem_314461.references = NULL;
                            if (memblock_alloc(ctx, &mem_314461, bytes_313017,
                                               "mem_314461")) {
                                err = 1;
                                goto cleanup;
                            }
                            
                            int64_t binop_y_314122 = (int64_t) 8 * q_s_292678;
                            int64_t bytes_314123 = smax64((int64_t) 0,
                                                          binop_y_314122);
                            int64_t flat_tid_301458 = (int64_t) 0;
                            int32_t num_tasks_323414;
                            int64_t flat_tid_301864 = (int64_t) 0;
                            struct futhark_mc_task_338135
                            futhark_mc_task_338135;
                            
                            futhark_mc_task_338135.ctx = ctx;
                            futhark_mc_task_338135.free_n_p_292677 = n_p_292677;
                            futhark_mc_task_338135.free_q_s_292678 = q_s_292678;
                            futhark_mc_task_338135.free_jump_s_292684 =
                                jump_s_292684;
                            futhark_mc_task_338135.free_partition_sizze_292766 =
                                partition_sizze_292766;
                            futhark_mc_task_338135.free_defunc_0_f_res_292820 =
                                defunc_0_f_res_292820;
                            futhark_mc_task_338135.free_pad_css_len_292821 =
                                pad_css_len_292821;
                            futhark_mc_task_338135.free_s_n_m_292825 =
                                s_n_m_292825;
                            futhark_mc_task_338135.free_mem_312838 = mem_312838;
                            futhark_mc_task_338135.free_mem_312842 = mem_312842;
                            futhark_mc_task_338135.free_bytes_312847 =
                                bytes_312847;
                            futhark_mc_task_338135.free_bytes_312899 =
                                bytes_312899;
                            futhark_mc_task_338135.free_mem_313018 = mem_313018;
                            futhark_mc_task_338135.free_mem_313023 = mem_313023;
                            futhark_mc_task_338135.free_mem_313366 = mem_313366;
                            futhark_mc_task_338135.free_mem_313371 = mem_313371;
                            futhark_mc_task_338135.free_bytes_314123 =
                                bytes_314123;
                            futhark_mc_task_338135.free_mem_314456 =
                                mem_314456.mem;
                            futhark_mc_task_338135.free_mem_314461 =
                                mem_314461.mem;
                            
                            struct scheduler_segop futhark_mc_task_338135_task;
                            
                            futhark_mc_task_338135_task.args =
                                &futhark_mc_task_338135;
                            futhark_mc_task_338135_task.top_level_fn =
                                futhark_mc_segmap_task_338136;
                            futhark_mc_task_338135_task.name =
                                "futhark_mc_segmap_task_338136";
                            futhark_mc_task_338135_task.iterations =
                                partition_sizze_292766;
                            futhark_mc_task_338135_task.task_time =
                                &ctx->futhark_mc_segmap_task_338136_total_time;
                            futhark_mc_task_338135_task.task_iter =
                                &ctx->futhark_mc_segmap_task_338136_total_iter;
                            futhark_mc_task_338135_task.sched = STATIC;
                            futhark_mc_task_338135_task.nested_fn =
                                futhark_mc_segmap_nested_task_338145;
                            
                            int futhark_mc_segmap_task_338136_err =
                                scheduler_prepare_task(&ctx->scheduler,
                                                       &futhark_mc_task_338135_task);
                            
                            if (futhark_mc_segmap_task_338136_err != 0) {
                                if (memblock_unref(ctx, &mem_314461,
                                                   "mem_314461") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_314456,
                                                   "mem_314456") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_314462,
                                                   "ext_mem_314462") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_314463,
                                                   "ext_mem_314463") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_314464,
                                                   "ext_mem_314464") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_314465,
                                                   "ext_mem_314465") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_314845,
                                                   "ext_mem_314845") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_314846,
                                                   "ext_mem_314846") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_314847,
                                                   "ext_mem_314847") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_314848,
                                                   "ext_mem_314848") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_param_313201,
                                                   "mem_param_313201") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_param_313193,
                                                   "mem_param_313193") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_316760,
                                                   "ext_mem_316760") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_316761,
                                                   "ext_mem_316761") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_param_313179,
                                                   "mem_param_313179") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_param_313171,
                                                   "mem_param_313171") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_param_313163,
                                                   "mem_param_313163") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_317010,
                                                   "ext_mem_317010") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_317011,
                                                   "ext_mem_317011") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_317012,
                                                   "ext_mem_317012") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_313155,
                                                   "mem_313155") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_313151,
                                                   "mem_313151") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_out_317163,
                                                   "mem_out_317163") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_out_317162,
                                                   "mem_out_317162") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_out_317161,
                                                   "mem_out_317161") != 0)
                                    return 1;
                                ;
                                err = futhark_mc_segmap_task_338136_err;
                                goto cleanup;
                            }
                            if (memblock_set(ctx, &ext_mem_314463, &mem_314456,
                                             "mem_314456") != 0)
                                return 1;
                            if (memblock_set(ctx, &ext_mem_314462, &mem_314461,
                                             "mem_314461") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_314461,
                                               "mem_314461") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_314456,
                                               "mem_314456") != 0)
                                return 1;
                        }
                        if (memblock_set(ctx, &ext_mem_314465, &ext_mem_314463,
                                         "ext_mem_314463") != 0)
                            return 1;
                        if (memblock_set(ctx, &ext_mem_314464, &ext_mem_314462,
                                         "ext_mem_314462") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_314462,
                                           "ext_mem_314462") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_314463,
                                           "ext_mem_314463") != 0)
                            return 1;
                    }
                    if (memblock_set(ctx, &ext_mem_314846, &ext_mem_314465,
                                     "ext_mem_314465") != 0)
                        return 1;
                    if (memblock_set(ctx, &ext_mem_314845, &ext_mem_314464,
                                     "ext_mem_314464") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_314464,
                                       "ext_mem_314464") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_314465,
                                       "ext_mem_314465") != 0)
                        return 1;
                } else {
                    bool match_lit_294188 = (int64_t) 0 == d_s_292681;
                    struct memblock ext_mem_314844;
                    
                    ext_mem_314844.references = NULL;
                    
                    struct memblock ext_mem_314843;
                    
                    ext_mem_314843.references = NULL;
                    if (match_lit_294188) {
                        struct memblock mem_314470;
                        
                        mem_314470.references = NULL;
                        if (memblock_alloc(ctx, &mem_314470, bytes_313017,
                                           "mem_314470")) {
                            err = 1;
                            goto cleanup;
                        }
                        for (int64_t i_324621 = 0; i_324621 <
                             partition_sizze_292766; i_324621++) {
                            for (int64_t i_324622 = 0; i_324622 < n_p_292677;
                                 i_324622++) {
                                for (int64_t i_324623 = 0; i_324623 <
                                     s_n_m_292825; i_324623++) {
                                    ((double *) mem_314470.mem)[i_324621 *
                                                                (s_n_m_292825 *
                                                                 n_p_292677) +
                                                                i_324622 *
                                                                s_n_m_292825 +
                                                                i_324623] = 0.0;
                                }
                            }
                        }
                        
                        struct memblock mem_314544;
                        
                        mem_314544.references = NULL;
                        if (memblock_alloc(ctx, &mem_314544, bytes_313017,
                                           "mem_314544")) {
                            err = 1;
                            goto cleanup;
                        }
                        
                        int64_t flat_tid_302264 = (int64_t) 0;
                        int32_t num_tasks_324624;
                        int64_t flat_tid_302528 = (int64_t) 0;
                        struct futhark_mc_task_338199 futhark_mc_task_338199;
                        
                        futhark_mc_task_338199.ctx = ctx;
                        futhark_mc_task_338199.free_n_p_292677 = n_p_292677;
                        futhark_mc_task_338199.free_q_s_292678 = q_s_292678;
                        futhark_mc_task_338199.free_jump_s_292684 =
                            jump_s_292684;
                        futhark_mc_task_338199.free_partition_sizze_292766 =
                            partition_sizze_292766;
                        futhark_mc_task_338199.free_defunc_0_f_res_292820 =
                            defunc_0_f_res_292820;
                        futhark_mc_task_338199.free_pad_css_len_292821 =
                            pad_css_len_292821;
                        futhark_mc_task_338199.free_s_n_m_292825 = s_n_m_292825;
                        futhark_mc_task_338199.free_mem_312838 = mem_312838;
                        futhark_mc_task_338199.free_mem_312842 = mem_312842;
                        futhark_mc_task_338199.free_bytes_312847 = bytes_312847;
                        futhark_mc_task_338199.free_bytes_312899 = bytes_312899;
                        futhark_mc_task_338199.free_mem_313018 = mem_313018;
                        futhark_mc_task_338199.free_mem_313023 = mem_313023;
                        futhark_mc_task_338199.free_mem_313366 = mem_313366;
                        futhark_mc_task_338199.free_mem_313371 = mem_313371;
                        futhark_mc_task_338199.free_mem_314544 = mem_314544.mem;
                        
                        struct scheduler_segop futhark_mc_task_338199_task;
                        
                        futhark_mc_task_338199_task.args =
                            &futhark_mc_task_338199;
                        futhark_mc_task_338199_task.top_level_fn =
                            futhark_mc_segmap_task_338200;
                        futhark_mc_task_338199_task.name =
                            "futhark_mc_segmap_task_338200";
                        futhark_mc_task_338199_task.iterations =
                            partition_sizze_292766;
                        futhark_mc_task_338199_task.task_time =
                            &ctx->futhark_mc_segmap_task_338200_total_time;
                        futhark_mc_task_338199_task.task_iter =
                            &ctx->futhark_mc_segmap_task_338200_total_iter;
                        futhark_mc_task_338199_task.sched = STATIC;
                        futhark_mc_task_338199_task.nested_fn =
                            futhark_mc_segmap_nested_task_338204;
                        
                        int futhark_mc_segmap_task_338200_err =
                            scheduler_prepare_task(&ctx->scheduler,
                                                   &futhark_mc_task_338199_task);
                        
                        if (futhark_mc_segmap_task_338200_err != 0) {
                            if (memblock_unref(ctx, &mem_314544,
                                               "mem_314544") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_314470,
                                               "mem_314470") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_314843,
                                               "ext_mem_314843") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_314844,
                                               "ext_mem_314844") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_314845,
                                               "ext_mem_314845") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_314846,
                                               "ext_mem_314846") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_314847,
                                               "ext_mem_314847") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_314848,
                                               "ext_mem_314848") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_313201,
                                               "mem_param_313201") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_313193,
                                               "mem_param_313193") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_316760,
                                               "ext_mem_316760") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_316761,
                                               "ext_mem_316761") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_313179,
                                               "mem_param_313179") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_313171,
                                               "mem_param_313171") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_313163,
                                               "mem_param_313163") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_317010,
                                               "ext_mem_317010") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_317011,
                                               "ext_mem_317011") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_317012,
                                               "ext_mem_317012") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_313155,
                                               "mem_313155") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_313151,
                                               "mem_313151") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_317163,
                                               "mem_out_317163") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_317162,
                                               "mem_out_317162") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_317161,
                                               "mem_out_317161") != 0)
                                return 1;
                            ;
                            err = futhark_mc_segmap_task_338200_err;
                            goto cleanup;
                        }
                        if (memblock_set(ctx, &ext_mem_314844, &mem_314544,
                                         "mem_314544") != 0)
                            return 1;
                        if (memblock_set(ctx, &ext_mem_314843, &mem_314470,
                                         "mem_314470") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_314544, "mem_314544") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_314470, "mem_314470") != 0)
                            return 1;
                    } else {
                        bool match_lit_294287 = (int64_t) 1 == d_s_292681;
                        struct memblock ext_mem_314842;
                        
                        ext_mem_314842.references = NULL;
                        
                        struct memblock ext_mem_314841;
                        
                        ext_mem_314841.references = NULL;
                        if (match_lit_294287) {
                            struct memblock mem_314687;
                            
                            mem_314687.references = NULL;
                            if (memblock_alloc(ctx, &mem_314687, bytes_313017,
                                               "mem_314687")) {
                                err = 1;
                                goto cleanup;
                            }
                            
                            struct memblock mem_314692;
                            
                            mem_314692.references = NULL;
                            if (memblock_alloc(ctx, &mem_314692, bytes_313017,
                                               "mem_314692")) {
                                err = 1;
                                goto cleanup;
                            }
                            
                            int64_t flat_tid_302788 = (int64_t) 0;
                            int32_t num_tasks_325346;
                            int64_t flat_tid_303143 = (int64_t) 0;
                            struct futhark_mc_task_338234
                            futhark_mc_task_338234;
                            
                            futhark_mc_task_338234.ctx = ctx;
                            futhark_mc_task_338234.free_n_p_292677 = n_p_292677;
                            futhark_mc_task_338234.free_q_s_292678 = q_s_292678;
                            futhark_mc_task_338234.free_jump_s_292684 =
                                jump_s_292684;
                            futhark_mc_task_338234.free_partition_sizze_292766 =
                                partition_sizze_292766;
                            futhark_mc_task_338234.free_defunc_0_f_res_292820 =
                                defunc_0_f_res_292820;
                            futhark_mc_task_338234.free_pad_css_len_292821 =
                                pad_css_len_292821;
                            futhark_mc_task_338234.free_s_n_m_292825 =
                                s_n_m_292825;
                            futhark_mc_task_338234.free_mem_312838 = mem_312838;
                            futhark_mc_task_338234.free_mem_312842 = mem_312842;
                            futhark_mc_task_338234.free_bytes_312847 =
                                bytes_312847;
                            futhark_mc_task_338234.free_bytes_312899 =
                                bytes_312899;
                            futhark_mc_task_338234.free_mem_313018 = mem_313018;
                            futhark_mc_task_338234.free_mem_313023 = mem_313023;
                            futhark_mc_task_338234.free_mem_313366 = mem_313366;
                            futhark_mc_task_338234.free_mem_313371 = mem_313371;
                            futhark_mc_task_338234.free_mem_314687 =
                                mem_314687.mem;
                            futhark_mc_task_338234.free_mem_314692 =
                                mem_314692.mem;
                            
                            struct scheduler_segop futhark_mc_task_338234_task;
                            
                            futhark_mc_task_338234_task.args =
                                &futhark_mc_task_338234;
                            futhark_mc_task_338234_task.top_level_fn =
                                futhark_mc_segmap_task_338235;
                            futhark_mc_task_338234_task.name =
                                "futhark_mc_segmap_task_338235";
                            futhark_mc_task_338234_task.iterations =
                                partition_sizze_292766;
                            futhark_mc_task_338234_task.task_time =
                                &ctx->futhark_mc_segmap_task_338235_total_time;
                            futhark_mc_task_338234_task.task_iter =
                                &ctx->futhark_mc_segmap_task_338235_total_iter;
                            futhark_mc_task_338234_task.sched = STATIC;
                            futhark_mc_task_338234_task.nested_fn =
                                futhark_mc_segmap_nested_task_338240;
                            
                            int futhark_mc_segmap_task_338235_err =
                                scheduler_prepare_task(&ctx->scheduler,
                                                       &futhark_mc_task_338234_task);
                            
                            if (futhark_mc_segmap_task_338235_err != 0) {
                                if (memblock_unref(ctx, &mem_314692,
                                                   "mem_314692") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_314687,
                                                   "mem_314687") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_314841,
                                                   "ext_mem_314841") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_314842,
                                                   "ext_mem_314842") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_314843,
                                                   "ext_mem_314843") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_314844,
                                                   "ext_mem_314844") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_314845,
                                                   "ext_mem_314845") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_314846,
                                                   "ext_mem_314846") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_314847,
                                                   "ext_mem_314847") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_314848,
                                                   "ext_mem_314848") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_param_313201,
                                                   "mem_param_313201") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_param_313193,
                                                   "mem_param_313193") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_316760,
                                                   "ext_mem_316760") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_316761,
                                                   "ext_mem_316761") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_param_313179,
                                                   "mem_param_313179") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_param_313171,
                                                   "mem_param_313171") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_param_313163,
                                                   "mem_param_313163") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_317010,
                                                   "ext_mem_317010") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_317011,
                                                   "ext_mem_317011") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_317012,
                                                   "ext_mem_317012") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_313155,
                                                   "mem_313155") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_313151,
                                                   "mem_313151") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_out_317163,
                                                   "mem_out_317163") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_out_317162,
                                                   "mem_out_317162") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_out_317161,
                                                   "mem_out_317161") != 0)
                                    return 1;
                                ;
                                err = futhark_mc_segmap_task_338235_err;
                                goto cleanup;
                            }
                            if (memblock_set(ctx, &ext_mem_314842, &mem_314687,
                                             "mem_314687") != 0)
                                return 1;
                            if (memblock_set(ctx, &ext_mem_314841, &mem_314692,
                                             "mem_314692") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_314692,
                                               "mem_314692") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_314687,
                                               "mem_314687") != 0)
                                return 1;
                        } else {
                            struct memblock mem_314835;
                            
                            mem_314835.references = NULL;
                            if (memblock_alloc(ctx, &mem_314835, bytes_313017,
                                               "mem_314835")) {
                                err = 1;
                                goto cleanup;
                            }
                            
                            struct memblock mem_314840;
                            
                            mem_314840.references = NULL;
                            if (memblock_alloc(ctx, &mem_314840, bytes_313017,
                                               "mem_314840")) {
                                err = 1;
                                goto cleanup;
                            }
                            
                            int64_t flat_tid_303496 = (int64_t) 0;
                            int32_t num_tasks_326339;
                            int64_t flat_tid_303953 = (int64_t) 0;
                            struct futhark_mc_task_338276
                            futhark_mc_task_338276;
                            
                            futhark_mc_task_338276.ctx = ctx;
                            futhark_mc_task_338276.free_n_p_292677 = n_p_292677;
                            futhark_mc_task_338276.free_q_s_292678 = q_s_292678;
                            futhark_mc_task_338276.free_jump_s_292684 =
                                jump_s_292684;
                            futhark_mc_task_338276.free_partition_sizze_292766 =
                                partition_sizze_292766;
                            futhark_mc_task_338276.free_defunc_0_f_res_292820 =
                                defunc_0_f_res_292820;
                            futhark_mc_task_338276.free_pad_css_len_292821 =
                                pad_css_len_292821;
                            futhark_mc_task_338276.free_s_n_m_292825 =
                                s_n_m_292825;
                            futhark_mc_task_338276.free_mem_312838 = mem_312838;
                            futhark_mc_task_338276.free_mem_312842 = mem_312842;
                            futhark_mc_task_338276.free_bytes_312847 =
                                bytes_312847;
                            futhark_mc_task_338276.free_bytes_312899 =
                                bytes_312899;
                            futhark_mc_task_338276.free_mem_313018 = mem_313018;
                            futhark_mc_task_338276.free_mem_313023 = mem_313023;
                            futhark_mc_task_338276.free_mem_313366 = mem_313366;
                            futhark_mc_task_338276.free_mem_313371 = mem_313371;
                            futhark_mc_task_338276.free_mem_314835 =
                                mem_314835.mem;
                            futhark_mc_task_338276.free_mem_314840 =
                                mem_314840.mem;
                            
                            struct scheduler_segop futhark_mc_task_338276_task;
                            
                            futhark_mc_task_338276_task.args =
                                &futhark_mc_task_338276;
                            futhark_mc_task_338276_task.top_level_fn =
                                futhark_mc_segmap_task_338277;
                            futhark_mc_task_338276_task.name =
                                "futhark_mc_segmap_task_338277";
                            futhark_mc_task_338276_task.iterations =
                                partition_sizze_292766;
                            futhark_mc_task_338276_task.task_time =
                                &ctx->futhark_mc_segmap_task_338277_total_time;
                            futhark_mc_task_338276_task.task_iter =
                                &ctx->futhark_mc_segmap_task_338277_total_iter;
                            futhark_mc_task_338276_task.sched = STATIC;
                            futhark_mc_task_338276_task.nested_fn =
                                futhark_mc_segmap_nested_task_338282;
                            
                            int futhark_mc_segmap_task_338277_err =
                                scheduler_prepare_task(&ctx->scheduler,
                                                       &futhark_mc_task_338276_task);
                            
                            if (futhark_mc_segmap_task_338277_err != 0) {
                                if (memblock_unref(ctx, &mem_314840,
                                                   "mem_314840") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_314835,
                                                   "mem_314835") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_314841,
                                                   "ext_mem_314841") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_314842,
                                                   "ext_mem_314842") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_314843,
                                                   "ext_mem_314843") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_314844,
                                                   "ext_mem_314844") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_314845,
                                                   "ext_mem_314845") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_314846,
                                                   "ext_mem_314846") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_314847,
                                                   "ext_mem_314847") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_314848,
                                                   "ext_mem_314848") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_param_313201,
                                                   "mem_param_313201") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_param_313193,
                                                   "mem_param_313193") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_316760,
                                                   "ext_mem_316760") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_316761,
                                                   "ext_mem_316761") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_param_313179,
                                                   "mem_param_313179") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_param_313171,
                                                   "mem_param_313171") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_param_313163,
                                                   "mem_param_313163") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_317010,
                                                   "ext_mem_317010") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_317011,
                                                   "ext_mem_317011") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_317012,
                                                   "ext_mem_317012") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_313155,
                                                   "mem_313155") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_313151,
                                                   "mem_313151") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_out_317163,
                                                   "mem_out_317163") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_out_317162,
                                                   "mem_out_317162") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_out_317161,
                                                   "mem_out_317161") != 0)
                                    return 1;
                                ;
                                err = futhark_mc_segmap_task_338277_err;
                                goto cleanup;
                            }
                            if (memblock_set(ctx, &ext_mem_314842, &mem_314835,
                                             "mem_314835") != 0)
                                return 1;
                            if (memblock_set(ctx, &ext_mem_314841, &mem_314840,
                                             "mem_314840") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_314840,
                                               "mem_314840") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_314835,
                                               "mem_314835") != 0)
                                return 1;
                        }
                        if (memblock_set(ctx, &ext_mem_314844, &ext_mem_314842,
                                         "ext_mem_314842") != 0)
                            return 1;
                        if (memblock_set(ctx, &ext_mem_314843, &ext_mem_314841,
                                         "ext_mem_314841") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_314841,
                                           "ext_mem_314841") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_314842,
                                           "ext_mem_314842") != 0)
                            return 1;
                    }
                    if (memblock_set(ctx, &ext_mem_314846, &ext_mem_314844,
                                     "ext_mem_314844") != 0)
                        return 1;
                    if (memblock_set(ctx, &ext_mem_314845, &ext_mem_314843,
                                     "ext_mem_314843") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_314843,
                                       "ext_mem_314843") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_314844,
                                       "ext_mem_314844") != 0)
                        return 1;
                }
                if (memblock_set(ctx, &ext_mem_314848, &ext_mem_314846,
                                 "ext_mem_314846") != 0)
                    return 1;
                if (memblock_set(ctx, &ext_mem_314847, &ext_mem_314845,
                                 "ext_mem_314845") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_314845, "ext_mem_314845") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_314846, "ext_mem_314846") != 0)
                    return 1;
            }
            
            struct memblock ext_mem_314923;
            
            ext_mem_314923.references = NULL;
            if (cond_292824) {
                if (memblock_set(ctx, &ext_mem_314923, &ext_mem_314848,
                                 "ext_mem_314848") != 0)
                    return 1;
            } else {
                bool bounds_invalid_upwards_294584 = slt64(pad_css_len_292821,
                                                           (int64_t) 0);
                bool valid_294585 = !bounds_invalid_upwards_294584;
                bool range_valid_c_294586;
                
                if (!valid_294585) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Range ", (long long) (int64_t) 0, "..",
                                  (long long) (int64_t) 1, "..<",
                                  (long long) pad_css_len_292821,
                                  " is invalid.",
                                  "-> #0  /prelude/array.fut:90:3-10\n   #1  /prelude/array.fut:195:11-16\n   #2  utils.fut:6:3-16\n   #3  loess.fut:752:3-761:9\n   #4  stl.fut:222:31-96\n   #5  /prelude/soacs.fut:67:19-23\n   #6  /prelude/soacs.fut:67:3-37\n   #7  stl.fut:221:23-223:48\n   #8  /prelude/soacs.fut:67:19-23\n   #9  /prelude/soacs.fut:67:3-37\n   #10 stl.fut:220:15-224:44\n   #11 stl.fut:419:61-435:77\n   #12 stl.fut:463:3-479:36\n   #13 stl.fut:445:1-479:36\n");
                    if (memblock_unref(ctx, &ext_mem_314923,
                                       "ext_mem_314923") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_314847,
                                       "ext_mem_314847") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_314848,
                                       "ext_mem_314848") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_313201,
                                       "mem_param_313201") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_313193,
                                       "mem_param_313193") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316760,
                                       "ext_mem_316760") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316761,
                                       "ext_mem_316761") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_313179,
                                       "mem_param_313179") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_313171,
                                       "mem_param_313171") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_313163,
                                       "mem_param_313163") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_317010,
                                       "ext_mem_317010") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_317011,
                                       "ext_mem_317011") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_317012,
                                       "ext_mem_317012") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_313155, "mem_313155") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_313151, "mem_313151") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_317163,
                                       "mem_out_317163") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_317162,
                                       "mem_out_317162") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_317161,
                                       "mem_out_317161") != 0)
                        return 1;
                    err = FUTHARK_PROGRAM_ERROR;
                    goto cleanup;
                }
                
                struct memblock mem_314922;
                
                mem_314922.references = NULL;
                if (memblock_alloc(ctx, &mem_314922, bytes_314921,
                                   "mem_314922")) {
                    err = 1;
                    goto cleanup;
                }
                
                int64_t binop_x_314867 = n_p_292677 * pad_css_len_292821;
                int64_t binop_y_314868 = (int64_t) 8 * binop_x_314867;
                int64_t bytes_314869 = smax64((int64_t) 0, binop_y_314868);
                int64_t binop_y_314849 = (int64_t) 8 * pad_css_len_292821;
                int64_t bytes_314850 = smax64((int64_t) 0, binop_y_314849);
                int64_t flat_tid_304408 = (int64_t) 0;
                int32_t num_tasks_327602;
                int64_t flat_tid_304505 = (int64_t) 0;
                struct futhark_mc_task_338320 futhark_mc_task_338320;
                
                futhark_mc_task_338320.ctx = ctx;
                futhark_mc_task_338320.free_n_p_292677 = n_p_292677;
                futhark_mc_task_338320.free_jump_s_292684 = jump_s_292684;
                futhark_mc_task_338320.free_partition_sizze_292766 =
                    partition_sizze_292766;
                futhark_mc_task_338320.free_defunc_0_f_res_292820 =
                    defunc_0_f_res_292820;
                futhark_mc_task_338320.free_pad_css_len_292821 =
                    pad_css_len_292821;
                futhark_mc_task_338320.free_s_n_m_292825 = s_n_m_292825;
                futhark_mc_task_338320.free_ext_mem_314847 = ext_mem_314847.mem;
                futhark_mc_task_338320.free_ext_mem_314848 = ext_mem_314848.mem;
                futhark_mc_task_338320.free_bytes_314850 = bytes_314850;
                futhark_mc_task_338320.free_bytes_314869 = bytes_314869;
                futhark_mc_task_338320.free_mem_314922 = mem_314922.mem;
                
                struct scheduler_segop futhark_mc_task_338320_task;
                
                futhark_mc_task_338320_task.args = &futhark_mc_task_338320;
                futhark_mc_task_338320_task.top_level_fn =
                    futhark_mc_segmap_task_338321;
                futhark_mc_task_338320_task.name =
                    "futhark_mc_segmap_task_338321";
                futhark_mc_task_338320_task.iterations = partition_sizze_292766;
                futhark_mc_task_338320_task.task_time =
                    &ctx->futhark_mc_segmap_task_338321_total_time;
                futhark_mc_task_338320_task.task_iter =
                    &ctx->futhark_mc_segmap_task_338321_total_iter;
                futhark_mc_task_338320_task.sched = STATIC;
                futhark_mc_task_338320_task.nested_fn =
                    futhark_mc_segmap_nested_task_338325;
                
                int futhark_mc_segmap_task_338321_err =
                    scheduler_prepare_task(&ctx->scheduler,
                                           &futhark_mc_task_338320_task);
                
                if (futhark_mc_segmap_task_338321_err != 0) {
                    if (memblock_unref(ctx, &mem_314922, "mem_314922") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_314923,
                                       "ext_mem_314923") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_314847,
                                       "ext_mem_314847") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_314848,
                                       "ext_mem_314848") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_313201,
                                       "mem_param_313201") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_313193,
                                       "mem_param_313193") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316760,
                                       "ext_mem_316760") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316761,
                                       "ext_mem_316761") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_313179,
                                       "mem_param_313179") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_313171,
                                       "mem_param_313171") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_313163,
                                       "mem_param_313163") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_317010,
                                       "ext_mem_317010") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_317011,
                                       "ext_mem_317011") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_317012,
                                       "ext_mem_317012") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_313155, "mem_313155") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_313151, "mem_313151") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_317163,
                                       "mem_out_317163") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_317162,
                                       "mem_out_317162") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_317161,
                                       "mem_out_317161") != 0)
                        return 1;
                    ;
                    err = futhark_mc_segmap_task_338321_err;
                    goto cleanup;
                }
                if (memblock_set(ctx, &ext_mem_314923, &mem_314922,
                                 "mem_314922") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_314922, "mem_314922") != 0)
                    return 1;
            }
            if (memblock_unref(ctx, &ext_mem_314847, "ext_mem_314847") != 0)
                return 1;
            if (memblock_unref(ctx, &ext_mem_314848, "ext_mem_314848") != 0)
                return 1;
            
            int64_t flat_tid_304682 = (int64_t) 0;
            int32_t num_tasks_328120;
            int64_t flat_tid_304688 = (int64_t) 0;
            struct futhark_mc_task_338342 futhark_mc_task_338342;
            
            futhark_mc_task_338342.ctx = ctx;
            futhark_mc_task_338342.free_n_p_292677 = n_p_292677;
            futhark_mc_task_338342.free_partition_sizze_292766 =
                partition_sizze_292766;
            futhark_mc_task_338342.free_C_len_292823 = C_len_292823;
            futhark_mc_task_338342.free_css_results_l_293288 =
                css_results_l_293288;
            futhark_mc_task_338342.free_ext_mem_314923 = ext_mem_314923.mem;
            futhark_mc_task_338342.free_bytes_314926 = bytes_314926;
            futhark_mc_task_338342.free_mem_314946 = mem_314946;
            
            struct scheduler_segop futhark_mc_task_338342_task;
            
            futhark_mc_task_338342_task.args = &futhark_mc_task_338342;
            futhark_mc_task_338342_task.top_level_fn =
                futhark_mc_segmap_task_338343;
            futhark_mc_task_338342_task.name = "futhark_mc_segmap_task_338343";
            futhark_mc_task_338342_task.iterations = partition_sizze_292766;
            futhark_mc_task_338342_task.task_time =
                &ctx->futhark_mc_segmap_task_338343_total_time;
            futhark_mc_task_338342_task.task_iter =
                &ctx->futhark_mc_segmap_task_338343_total_iter;
            futhark_mc_task_338342_task.sched = STATIC;
            futhark_mc_task_338342_task.nested_fn =
                futhark_mc_segmap_nested_task_338347;
            
            int futhark_mc_segmap_task_338343_err =
                scheduler_prepare_task(&ctx->scheduler,
                                       &futhark_mc_task_338342_task);
            
            if (futhark_mc_segmap_task_338343_err != 0) {
                if (memblock_unref(ctx, &ext_mem_314923, "ext_mem_314923") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_314847, "ext_mem_314847") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_314848, "ext_mem_314848") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_313201,
                                   "mem_param_313201") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_313193,
                                   "mem_param_313193") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_316760, "ext_mem_316760") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_316761, "ext_mem_316761") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_313179,
                                   "mem_param_313179") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_313171,
                                   "mem_param_313171") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_313163,
                                   "mem_param_313163") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_317010, "ext_mem_317010") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_317011, "ext_mem_317011") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_317012, "ext_mem_317012") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_313155, "mem_313155") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_313151, "mem_313151") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_out_317163, "mem_out_317163") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_out_317162, "mem_out_317162") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_out_317161, "mem_out_317161") != 0)
                    return 1;
                ;
                err = futhark_mc_segmap_task_338343_err;
                goto cleanup;
            }
            if (memblock_unref(ctx, &ext_mem_314923, "ext_mem_314923") != 0)
                return 1;
            
            int64_t flat_tid_304706 = (int64_t) 0;
            int32_t num_tasks_328159;
            int64_t flat_tid_304712 = (int64_t) 0;
            struct futhark_mc_task_338355 futhark_mc_task_338355;
            
            futhark_mc_task_338355.ctx = ctx;
            futhark_mc_task_338355.free_n_p_292677 = n_p_292677;
            futhark_mc_task_338355.free_partition_sizze_292766 =
                partition_sizze_292766;
            futhark_mc_task_338355.free_C_len_292823 = C_len_292823;
            futhark_mc_task_338355.free_mem_314946 = mem_314946;
            futhark_mc_task_338355.free_mem_314949 = mem_314949;
            
            struct scheduler_segop futhark_mc_task_338355_task;
            
            futhark_mc_task_338355_task.args = &futhark_mc_task_338355;
            futhark_mc_task_338355_task.top_level_fn =
                futhark_mc_segmap_task_338356;
            futhark_mc_task_338355_task.name = "futhark_mc_segmap_task_338356";
            futhark_mc_task_338355_task.iterations = partition_sizze_292766;
            futhark_mc_task_338355_task.task_time =
                &ctx->futhark_mc_segmap_task_338356_total_time;
            futhark_mc_task_338355_task.task_iter =
                &ctx->futhark_mc_segmap_task_338356_total_iter;
            futhark_mc_task_338355_task.sched = STATIC;
            futhark_mc_task_338355_task.nested_fn =
                futhark_mc_segmap_nested_task_338359;
            
            int futhark_mc_segmap_task_338356_err =
                scheduler_prepare_task(&ctx->scheduler,
                                       &futhark_mc_task_338355_task);
            
            if (futhark_mc_segmap_task_338356_err != 0) {
                if (memblock_unref(ctx, &ext_mem_314923, "ext_mem_314923") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_314847, "ext_mem_314847") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_314848, "ext_mem_314848") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_313201,
                                   "mem_param_313201") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_313193,
                                   "mem_param_313193") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_316760, "ext_mem_316760") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_316761, "ext_mem_316761") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_313179,
                                   "mem_param_313179") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_313171,
                                   "mem_param_313171") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_313163,
                                   "mem_param_313163") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_317010, "ext_mem_317010") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_317011, "ext_mem_317011") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_317012, "ext_mem_317012") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_313155, "mem_313155") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_313151, "mem_313151") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_out_317163, "mem_out_317163") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_out_317162, "mem_out_317162") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_out_317161, "mem_out_317161") != 0)
                    return 1;
                ;
                err = futhark_mc_segmap_task_338356_err;
                goto cleanup;
            }
            
            int64_t flat_tid_304722 = (int64_t) 0;
            int32_t num_tasks_328186;
            int64_t flat_tid_304728 = (int64_t) 0;
            struct futhark_mc_task_338367 futhark_mc_task_338367;
            
            futhark_mc_task_338367.ctx = ctx;
            futhark_mc_task_338367.free_n_p_292677 = n_p_292677;
            futhark_mc_task_338367.free_i64_res_292694 = i64_res_292694;
            futhark_mc_task_338367.free_partition_sizze_292766 =
                partition_sizze_292766;
            futhark_mc_task_338367.free_C_len_292823 = C_len_292823;
            futhark_mc_task_338367.free_lifted_single_ma_l_arg_293311 =
                lifted_single_ma_l_arg_293311;
            futhark_mc_task_338367.free_mem_314946 = mem_314946;
            futhark_mc_task_338367.free_mem_314949 = mem_314949;
            futhark_mc_task_338367.free_bytes_314951 = bytes_314951;
            futhark_mc_task_338367.free_mem_314971 = mem_314971;
            
            struct scheduler_segop futhark_mc_task_338367_task;
            
            futhark_mc_task_338367_task.args = &futhark_mc_task_338367;
            futhark_mc_task_338367_task.top_level_fn =
                futhark_mc_segmap_task_338368;
            futhark_mc_task_338367_task.name = "futhark_mc_segmap_task_338368";
            futhark_mc_task_338367_task.iterations = partition_sizze_292766;
            futhark_mc_task_338367_task.task_time =
                &ctx->futhark_mc_segmap_task_338368_total_time;
            futhark_mc_task_338367_task.task_iter =
                &ctx->futhark_mc_segmap_task_338368_total_iter;
            futhark_mc_task_338367_task.sched = STATIC;
            futhark_mc_task_338367_task.nested_fn =
                futhark_mc_segmap_nested_task_338372;
            
            int futhark_mc_segmap_task_338368_err =
                scheduler_prepare_task(&ctx->scheduler,
                                       &futhark_mc_task_338367_task);
            
            if (futhark_mc_segmap_task_338368_err != 0) {
                if (memblock_unref(ctx, &ext_mem_314923, "ext_mem_314923") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_314847, "ext_mem_314847") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_314848, "ext_mem_314848") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_313201,
                                   "mem_param_313201") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_313193,
                                   "mem_param_313193") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_316760, "ext_mem_316760") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_316761, "ext_mem_316761") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_313179,
                                   "mem_param_313179") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_313171,
                                   "mem_param_313171") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_313163,
                                   "mem_param_313163") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_317010, "ext_mem_317010") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_317011, "ext_mem_317011") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_317012, "ext_mem_317012") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_313155, "mem_313155") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_313151, "mem_313151") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_out_317163, "mem_out_317163") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_out_317162, "mem_out_317162") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_out_317161, "mem_out_317161") != 0)
                    return 1;
                ;
                err = futhark_mc_segmap_task_338368_err;
                goto cleanup;
            }
            
            int64_t flat_tid_304757 = (int64_t) 0;
            int32_t num_tasks_328255;
            int64_t flat_tid_304763 = (int64_t) 0;
            struct futhark_mc_task_338383 futhark_mc_task_338383;
            
            futhark_mc_task_338383.ctx = ctx;
            futhark_mc_task_338383.free_n_p_292677 = n_p_292677;
            futhark_mc_task_338383.free_partition_sizze_292766 =
                partition_sizze_292766;
            futhark_mc_task_338383.free_lifted_single_ma_l_arg_293311 =
                lifted_single_ma_l_arg_293311;
            futhark_mc_task_338383.free_mem_314971 = mem_314971;
            futhark_mc_task_338383.free_mem_314974 = mem_314974;
            
            struct scheduler_segop futhark_mc_task_338383_task;
            
            futhark_mc_task_338383_task.args = &futhark_mc_task_338383;
            futhark_mc_task_338383_task.top_level_fn =
                futhark_mc_segmap_task_338384;
            futhark_mc_task_338383_task.name = "futhark_mc_segmap_task_338384";
            futhark_mc_task_338383_task.iterations = partition_sizze_292766;
            futhark_mc_task_338383_task.task_time =
                &ctx->futhark_mc_segmap_task_338384_total_time;
            futhark_mc_task_338383_task.task_iter =
                &ctx->futhark_mc_segmap_task_338384_total_iter;
            futhark_mc_task_338383_task.sched = STATIC;
            futhark_mc_task_338383_task.nested_fn =
                futhark_mc_segmap_nested_task_338387;
            
            int futhark_mc_segmap_task_338384_err =
                scheduler_prepare_task(&ctx->scheduler,
                                       &futhark_mc_task_338383_task);
            
            if (futhark_mc_segmap_task_338384_err != 0) {
                if (memblock_unref(ctx, &ext_mem_314923, "ext_mem_314923") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_314847, "ext_mem_314847") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_314848, "ext_mem_314848") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_313201,
                                   "mem_param_313201") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_313193,
                                   "mem_param_313193") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_316760, "ext_mem_316760") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_316761, "ext_mem_316761") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_313179,
                                   "mem_param_313179") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_313171,
                                   "mem_param_313171") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_313163,
                                   "mem_param_313163") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_317010, "ext_mem_317010") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_317011, "ext_mem_317011") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_317012, "ext_mem_317012") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_313155, "mem_313155") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_313151, "mem_313151") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_out_317163, "mem_out_317163") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_out_317162, "mem_out_317162") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_out_317161, "mem_out_317161") != 0)
                    return 1;
                ;
                err = futhark_mc_segmap_task_338384_err;
                goto cleanup;
            }
            
            int64_t flat_tid_304773 = (int64_t) 0;
            int32_t num_tasks_328282;
            int64_t flat_tid_304779 = (int64_t) 0;
            struct futhark_mc_task_338395 futhark_mc_task_338395;
            
            futhark_mc_task_338395.ctx = ctx;
            futhark_mc_task_338395.free_n_p_292677 = n_p_292677;
            futhark_mc_task_338395.free_i64_res_292694 = i64_res_292694;
            futhark_mc_task_338395.free_partition_sizze_292766 =
                partition_sizze_292766;
            futhark_mc_task_338395.free_lifted_single_ma_l_arg_293311 =
                lifted_single_ma_l_arg_293311;
            futhark_mc_task_338395.free_dyn_lifted_single_ma_l_arg_293321 =
                dyn_lifted_single_ma_l_arg_293321;
            futhark_mc_task_338395.free_mem_314971 = mem_314971;
            futhark_mc_task_338395.free_mem_314974 = mem_314974;
            futhark_mc_task_338395.free_bytes_314976 = bytes_314976;
            futhark_mc_task_338395.free_mem_314996 = mem_314996;
            
            struct scheduler_segop futhark_mc_task_338395_task;
            
            futhark_mc_task_338395_task.args = &futhark_mc_task_338395;
            futhark_mc_task_338395_task.top_level_fn =
                futhark_mc_segmap_task_338396;
            futhark_mc_task_338395_task.name = "futhark_mc_segmap_task_338396";
            futhark_mc_task_338395_task.iterations = partition_sizze_292766;
            futhark_mc_task_338395_task.task_time =
                &ctx->futhark_mc_segmap_task_338396_total_time;
            futhark_mc_task_338395_task.task_iter =
                &ctx->futhark_mc_segmap_task_338396_total_iter;
            futhark_mc_task_338395_task.sched = STATIC;
            futhark_mc_task_338395_task.nested_fn =
                futhark_mc_segmap_nested_task_338400;
            
            int futhark_mc_segmap_task_338396_err =
                scheduler_prepare_task(&ctx->scheduler,
                                       &futhark_mc_task_338395_task);
            
            if (futhark_mc_segmap_task_338396_err != 0) {
                if (memblock_unref(ctx, &ext_mem_314923, "ext_mem_314923") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_314847, "ext_mem_314847") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_314848, "ext_mem_314848") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_313201,
                                   "mem_param_313201") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_313193,
                                   "mem_param_313193") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_316760, "ext_mem_316760") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_316761, "ext_mem_316761") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_313179,
                                   "mem_param_313179") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_313171,
                                   "mem_param_313171") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_313163,
                                   "mem_param_313163") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_317010, "ext_mem_317010") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_317011, "ext_mem_317011") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_317012, "ext_mem_317012") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_313155, "mem_313155") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_313151, "mem_313151") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_out_317163, "mem_out_317163") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_out_317162, "mem_out_317162") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_out_317161, "mem_out_317161") != 0)
                    return 1;
                ;
                err = futhark_mc_segmap_task_338396_err;
                goto cleanup;
            }
            
            int64_t flat_tid_304808 = (int64_t) 0;
            int32_t num_tasks_328351;
            int64_t flat_tid_304814 = (int64_t) 0;
            struct futhark_mc_task_338411 futhark_mc_task_338411;
            
            futhark_mc_task_338411.ctx = ctx;
            futhark_mc_task_338411.free_partition_sizze_292766 =
                partition_sizze_292766;
            futhark_mc_task_338411.free_dyn_lifted_single_ma_l_arg_293321 =
                dyn_lifted_single_ma_l_arg_293321;
            futhark_mc_task_338411.free_mem_314996 = mem_314996;
            futhark_mc_task_338411.free_mem_314999 = mem_314999;
            
            struct scheduler_segop futhark_mc_task_338411_task;
            
            futhark_mc_task_338411_task.args = &futhark_mc_task_338411;
            futhark_mc_task_338411_task.top_level_fn =
                futhark_mc_segmap_task_338412;
            futhark_mc_task_338411_task.name = "futhark_mc_segmap_task_338412";
            futhark_mc_task_338411_task.iterations = partition_sizze_292766;
            futhark_mc_task_338411_task.task_time =
                &ctx->futhark_mc_segmap_task_338412_total_time;
            futhark_mc_task_338411_task.task_iter =
                &ctx->futhark_mc_segmap_task_338412_total_iter;
            futhark_mc_task_338411_task.sched = STATIC;
            futhark_mc_task_338411_task.nested_fn =
                futhark_mc_segmap_nested_task_338415;
            
            int futhark_mc_segmap_task_338412_err =
                scheduler_prepare_task(&ctx->scheduler,
                                       &futhark_mc_task_338411_task);
            
            if (futhark_mc_segmap_task_338412_err != 0) {
                if (memblock_unref(ctx, &ext_mem_314923, "ext_mem_314923") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_314847, "ext_mem_314847") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_314848, "ext_mem_314848") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_313201,
                                   "mem_param_313201") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_313193,
                                   "mem_param_313193") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_316760, "ext_mem_316760") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_316761, "ext_mem_316761") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_313179,
                                   "mem_param_313179") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_313171,
                                   "mem_param_313171") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_313163,
                                   "mem_param_313163") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_317010, "ext_mem_317010") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_317011, "ext_mem_317011") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_317012, "ext_mem_317012") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_313155, "mem_313155") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_313151, "mem_313151") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_out_317163, "mem_out_317163") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_out_317162, "mem_out_317162") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_out_317161, "mem_out_317161") != 0)
                    return 1;
                ;
                err = futhark_mc_segmap_task_338412_err;
                goto cleanup;
            }
            
            int64_t flat_tid_304824 = (int64_t) 0;
            int32_t num_tasks_328379;
            int64_t flat_tid_304830 = (int64_t) 0;
            struct futhark_mc_task_338423 futhark_mc_task_338423;
            
            futhark_mc_task_338423.ctx = ctx;
            futhark_mc_task_338423.free_n_292675 = n_292675;
            futhark_mc_task_338423.free_partition_sizze_292766 =
                partition_sizze_292766;
            futhark_mc_task_338423.free_dyn_lifted_single_ma_l_arg_293321 =
                dyn_lifted_single_ma_l_arg_293321;
            futhark_mc_task_338423.free_bytes_312598 = bytes_312598;
            futhark_mc_task_338423.free_mem_314996 = mem_314996;
            futhark_mc_task_338423.free_mem_314999 = mem_314999;
            futhark_mc_task_338423.free_mem_315021 = mem_315021;
            
            struct scheduler_segop futhark_mc_task_338423_task;
            
            futhark_mc_task_338423_task.args = &futhark_mc_task_338423;
            futhark_mc_task_338423_task.top_level_fn =
                futhark_mc_segmap_task_338424;
            futhark_mc_task_338423_task.name = "futhark_mc_segmap_task_338424";
            futhark_mc_task_338423_task.iterations = partition_sizze_292766;
            futhark_mc_task_338423_task.task_time =
                &ctx->futhark_mc_segmap_task_338424_total_time;
            futhark_mc_task_338423_task.task_iter =
                &ctx->futhark_mc_segmap_task_338424_total_iter;
            futhark_mc_task_338423_task.sched = STATIC;
            futhark_mc_task_338423_task.nested_fn =
                futhark_mc_segmap_nested_task_338428;
            
            int futhark_mc_segmap_task_338424_err =
                scheduler_prepare_task(&ctx->scheduler,
                                       &futhark_mc_task_338423_task);
            
            if (futhark_mc_segmap_task_338424_err != 0) {
                if (memblock_unref(ctx, &ext_mem_314923, "ext_mem_314923") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_314847, "ext_mem_314847") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_314848, "ext_mem_314848") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_313201,
                                   "mem_param_313201") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_313193,
                                   "mem_param_313193") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_316760, "ext_mem_316760") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_316761, "ext_mem_316761") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_313179,
                                   "mem_param_313179") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_313171,
                                   "mem_param_313171") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_313163,
                                   "mem_param_313163") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_317010, "ext_mem_317010") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_317011, "ext_mem_317011") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_317012, "ext_mem_317012") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_313155, "mem_313155") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_313151, "mem_313151") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_out_317163, "mem_out_317163") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_out_317162, "mem_out_317162") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_out_317161, "mem_out_317161") != 0)
                    return 1;
                ;
                err = futhark_mc_segmap_task_338424_err;
                goto cleanup;
            }
            
            struct memblock ext_mem_315610;
            
            ext_mem_315610.references = NULL;
            
            struct memblock ext_mem_315609;
            
            ext_mem_315609.references = NULL;
            if (cond_293339) {
                bool match_lit_294803 = (int64_t) 0 == d_l_292683;
                struct memblock ext_mem_315139;
                
                ext_mem_315139.references = NULL;
                
                struct memblock ext_mem_315138;
                
                ext_mem_315138.references = NULL;
                if (match_lit_294803) {
                    struct memblock mem_315025;
                    
                    mem_315025.references = NULL;
                    if (memblock_alloc(ctx, &mem_315025, bytes_313080,
                                       "mem_315025")) {
                        err = 1;
                        goto cleanup;
                    }
                    for (int64_t i_328448 = 0; i_328448 <
                         partition_sizze_292766; i_328448++) {
                        for (int64_t i_328449 = 0; i_328449 < l_n_m_292832;
                             i_328449++) {
                            ((double *) mem_315025.mem)[i_328448 *
                                                        l_n_m_292832 +
                                                        i_328449] = 0.0;
                        }
                    }
                    
                    struct memblock mem_315047;
                    
                    mem_315047.references = NULL;
                    if (memblock_alloc(ctx, &mem_315047, bytes_313080,
                                       "mem_315047")) {
                        err = 1;
                        goto cleanup;
                    }
                    
                    int64_t flat_tid_304859 = (int64_t) 0;
                    int32_t num_tasks_328450;
                    int64_t flat_tid_304934 = (int64_t) 0;
                    struct futhark_mc_task_338439 futhark_mc_task_338439;
                    
                    futhark_mc_task_338439.ctx = ctx;
                    futhark_mc_task_338439.free_n_292675 = n_292675;
                    futhark_mc_task_338439.free_q_l_292680 = q_l_292680;
                    futhark_mc_task_338439.free_jump_t_292685 = jump_t_292685;
                    futhark_mc_task_338439.free_partition_sizze_292766 =
                        partition_sizze_292766;
                    futhark_mc_task_338439.free_l_n_m_292832 = l_n_m_292832;
                    futhark_mc_task_338439.free_i_292846 = i_292846;
                    futhark_mc_task_338439.free_bytes_313028 = bytes_313028;
                    futhark_mc_task_338439.free_mem_313081 = mem_313081;
                    futhark_mc_task_338439.free_mem_313085 = mem_313085;
                    futhark_mc_task_338439.free_ctx_param_ext_313174 =
                        ctx_param_ext_313174;
                    futhark_mc_task_338439.free_ctx_param_ext_313175 =
                        ctx_param_ext_313175;
                    futhark_mc_task_338439.free_ctx_param_ext_313177 =
                        ctx_param_ext_313177;
                    futhark_mc_task_338439.free_mem_param_313179 =
                        mem_param_313179.mem;
                    futhark_mc_task_338439.free_mem_315021 = mem_315021;
                    futhark_mc_task_338439.free_mem_315047 = mem_315047.mem;
                    
                    struct scheduler_segop futhark_mc_task_338439_task;
                    
                    futhark_mc_task_338439_task.args = &futhark_mc_task_338439;
                    futhark_mc_task_338439_task.top_level_fn =
                        futhark_mc_segmap_task_338440;
                    futhark_mc_task_338439_task.name =
                        "futhark_mc_segmap_task_338440";
                    futhark_mc_task_338439_task.iterations =
                        partition_sizze_292766;
                    futhark_mc_task_338439_task.task_time =
                        &ctx->futhark_mc_segmap_task_338440_total_time;
                    futhark_mc_task_338439_task.task_iter =
                        &ctx->futhark_mc_segmap_task_338440_total_iter;
                    futhark_mc_task_338439_task.sched = STATIC;
                    futhark_mc_task_338439_task.nested_fn =
                        futhark_mc_segmap_nested_task_338444;
                    
                    int futhark_mc_segmap_task_338440_err =
                        scheduler_prepare_task(&ctx->scheduler,
                                               &futhark_mc_task_338439_task);
                    
                    if (futhark_mc_segmap_task_338440_err != 0) {
                        if (memblock_unref(ctx, &mem_315047, "mem_315047") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_315025, "mem_315025") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_315138,
                                           "ext_mem_315138") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_315139,
                                           "ext_mem_315139") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_315609,
                                           "ext_mem_315609") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_315610,
                                           "ext_mem_315610") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_314923,
                                           "ext_mem_314923") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_314847,
                                           "ext_mem_314847") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_314848,
                                           "ext_mem_314848") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_param_313201,
                                           "mem_param_313201") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_param_313193,
                                           "mem_param_313193") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_316760,
                                           "ext_mem_316760") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_316761,
                                           "ext_mem_316761") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_param_313179,
                                           "mem_param_313179") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_param_313171,
                                           "mem_param_313171") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_param_313163,
                                           "mem_param_313163") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_317010,
                                           "ext_mem_317010") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_317011,
                                           "ext_mem_317011") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_317012,
                                           "ext_mem_317012") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_313155, "mem_313155") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_313151, "mem_313151") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_out_317163,
                                           "mem_out_317163") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_out_317162,
                                           "mem_out_317162") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_out_317161,
                                           "mem_out_317161") != 0)
                            return 1;
                        ;
                        err = futhark_mc_segmap_task_338440_err;
                        goto cleanup;
                    }
                    if (memblock_set(ctx, &ext_mem_315139, &mem_315047,
                                     "mem_315047") != 0)
                        return 1;
                    if (memblock_set(ctx, &ext_mem_315138, &mem_315025,
                                     "mem_315025") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_315047, "mem_315047") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_315025, "mem_315025") != 0)
                        return 1;
                } else {
                    bool match_lit_294875 = (int64_t) 1 == d_l_292683;
                    struct memblock ext_mem_315137;
                    
                    ext_mem_315137.references = NULL;
                    
                    struct memblock ext_mem_315136;
                    
                    ext_mem_315136.references = NULL;
                    if (match_lit_294875) {
                        struct memblock mem_315087;
                        
                        mem_315087.references = NULL;
                        if (memblock_alloc(ctx, &mem_315087, bytes_313080,
                                           "mem_315087")) {
                            err = 1;
                            goto cleanup;
                        }
                        
                        struct memblock mem_315091;
                        
                        mem_315091.references = NULL;
                        if (memblock_alloc(ctx, &mem_315091, bytes_313080,
                                           "mem_315091")) {
                            err = 1;
                            goto cleanup;
                        }
                        
                        int64_t flat_tid_305063 = (int64_t) 0;
                        int32_t num_tasks_328754;
                        int64_t flat_tid_305168 = (int64_t) 0;
                        struct futhark_mc_task_338465 futhark_mc_task_338465;
                        
                        futhark_mc_task_338465.ctx = ctx;
                        futhark_mc_task_338465.free_n_292675 = n_292675;
                        futhark_mc_task_338465.free_q_l_292680 = q_l_292680;
                        futhark_mc_task_338465.free_jump_t_292685 =
                            jump_t_292685;
                        futhark_mc_task_338465.free_partition_sizze_292766 =
                            partition_sizze_292766;
                        futhark_mc_task_338465.free_l_n_m_292832 = l_n_m_292832;
                        futhark_mc_task_338465.free_i_292846 = i_292846;
                        futhark_mc_task_338465.free_bytes_313028 = bytes_313028;
                        futhark_mc_task_338465.free_mem_313081 = mem_313081;
                        futhark_mc_task_338465.free_mem_313085 = mem_313085;
                        futhark_mc_task_338465.free_ctx_param_ext_313174 =
                            ctx_param_ext_313174;
                        futhark_mc_task_338465.free_ctx_param_ext_313175 =
                            ctx_param_ext_313175;
                        futhark_mc_task_338465.free_ctx_param_ext_313177 =
                            ctx_param_ext_313177;
                        futhark_mc_task_338465.free_mem_param_313179 =
                            mem_param_313179.mem;
                        futhark_mc_task_338465.free_mem_315021 = mem_315021;
                        futhark_mc_task_338465.free_mem_315087 = mem_315087.mem;
                        futhark_mc_task_338465.free_mem_315091 = mem_315091.mem;
                        
                        struct scheduler_segop futhark_mc_task_338465_task;
                        
                        futhark_mc_task_338465_task.args =
                            &futhark_mc_task_338465;
                        futhark_mc_task_338465_task.top_level_fn =
                            futhark_mc_segmap_task_338466;
                        futhark_mc_task_338465_task.name =
                            "futhark_mc_segmap_task_338466";
                        futhark_mc_task_338465_task.iterations =
                            partition_sizze_292766;
                        futhark_mc_task_338465_task.task_time =
                            &ctx->futhark_mc_segmap_task_338466_total_time;
                        futhark_mc_task_338465_task.task_iter =
                            &ctx->futhark_mc_segmap_task_338466_total_iter;
                        futhark_mc_task_338465_task.sched = STATIC;
                        futhark_mc_task_338465_task.nested_fn =
                            futhark_mc_segmap_nested_task_338471;
                        
                        int futhark_mc_segmap_task_338466_err =
                            scheduler_prepare_task(&ctx->scheduler,
                                                   &futhark_mc_task_338465_task);
                        
                        if (futhark_mc_segmap_task_338466_err != 0) {
                            if (memblock_unref(ctx, &mem_315091,
                                               "mem_315091") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_315087,
                                               "mem_315087") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_315136,
                                               "ext_mem_315136") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_315137,
                                               "ext_mem_315137") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_315138,
                                               "ext_mem_315138") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_315139,
                                               "ext_mem_315139") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_315609,
                                               "ext_mem_315609") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_315610,
                                               "ext_mem_315610") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_314923,
                                               "ext_mem_314923") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_314847,
                                               "ext_mem_314847") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_314848,
                                               "ext_mem_314848") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_313201,
                                               "mem_param_313201") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_313193,
                                               "mem_param_313193") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_316760,
                                               "ext_mem_316760") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_316761,
                                               "ext_mem_316761") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_313179,
                                               "mem_param_313179") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_313171,
                                               "mem_param_313171") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_313163,
                                               "mem_param_313163") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_317010,
                                               "ext_mem_317010") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_317011,
                                               "ext_mem_317011") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_317012,
                                               "ext_mem_317012") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_313155,
                                               "mem_313155") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_313151,
                                               "mem_313151") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_317163,
                                               "mem_out_317163") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_317162,
                                               "mem_out_317162") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_317161,
                                               "mem_out_317161") != 0)
                                return 1;
                            ;
                            err = futhark_mc_segmap_task_338466_err;
                            goto cleanup;
                        }
                        if (memblock_set(ctx, &ext_mem_315137, &mem_315087,
                                         "mem_315087") != 0)
                            return 1;
                        if (memblock_set(ctx, &ext_mem_315136, &mem_315091,
                                         "mem_315091") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_315091, "mem_315091") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_315087, "mem_315087") != 0)
                            return 1;
                    } else {
                        struct memblock mem_315131;
                        
                        mem_315131.references = NULL;
                        if (memblock_alloc(ctx, &mem_315131, bytes_313080,
                                           "mem_315131")) {
                            err = 1;
                            goto cleanup;
                        }
                        
                        struct memblock mem_315135;
                        
                        mem_315135.references = NULL;
                        if (memblock_alloc(ctx, &mem_315135, bytes_313080,
                                           "mem_315135")) {
                            err = 1;
                            goto cleanup;
                        }
                        
                        int64_t flat_tid_305358 = (int64_t) 0;
                        int32_t num_tasks_329202;
                        int64_t flat_tid_305497 = (int64_t) 0;
                        struct futhark_mc_task_338496 futhark_mc_task_338496;
                        
                        futhark_mc_task_338496.ctx = ctx;
                        futhark_mc_task_338496.free_n_292675 = n_292675;
                        futhark_mc_task_338496.free_q_l_292680 = q_l_292680;
                        futhark_mc_task_338496.free_jump_t_292685 =
                            jump_t_292685;
                        futhark_mc_task_338496.free_partition_sizze_292766 =
                            partition_sizze_292766;
                        futhark_mc_task_338496.free_l_n_m_292832 = l_n_m_292832;
                        futhark_mc_task_338496.free_i_292846 = i_292846;
                        futhark_mc_task_338496.free_bytes_313028 = bytes_313028;
                        futhark_mc_task_338496.free_mem_313081 = mem_313081;
                        futhark_mc_task_338496.free_mem_313085 = mem_313085;
                        futhark_mc_task_338496.free_ctx_param_ext_313174 =
                            ctx_param_ext_313174;
                        futhark_mc_task_338496.free_ctx_param_ext_313175 =
                            ctx_param_ext_313175;
                        futhark_mc_task_338496.free_ctx_param_ext_313177 =
                            ctx_param_ext_313177;
                        futhark_mc_task_338496.free_mem_param_313179 =
                            mem_param_313179.mem;
                        futhark_mc_task_338496.free_mem_315021 = mem_315021;
                        futhark_mc_task_338496.free_mem_315131 = mem_315131.mem;
                        futhark_mc_task_338496.free_mem_315135 = mem_315135.mem;
                        
                        struct scheduler_segop futhark_mc_task_338496_task;
                        
                        futhark_mc_task_338496_task.args =
                            &futhark_mc_task_338496;
                        futhark_mc_task_338496_task.top_level_fn =
                            futhark_mc_segmap_task_338497;
                        futhark_mc_task_338496_task.name =
                            "futhark_mc_segmap_task_338497";
                        futhark_mc_task_338496_task.iterations =
                            partition_sizze_292766;
                        futhark_mc_task_338496_task.task_time =
                            &ctx->futhark_mc_segmap_task_338497_total_time;
                        futhark_mc_task_338496_task.task_iter =
                            &ctx->futhark_mc_segmap_task_338497_total_iter;
                        futhark_mc_task_338496_task.sched = STATIC;
                        futhark_mc_task_338496_task.nested_fn =
                            futhark_mc_segmap_nested_task_338502;
                        
                        int futhark_mc_segmap_task_338497_err =
                            scheduler_prepare_task(&ctx->scheduler,
                                                   &futhark_mc_task_338496_task);
                        
                        if (futhark_mc_segmap_task_338497_err != 0) {
                            if (memblock_unref(ctx, &mem_315135,
                                               "mem_315135") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_315131,
                                               "mem_315131") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_315136,
                                               "ext_mem_315136") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_315137,
                                               "ext_mem_315137") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_315138,
                                               "ext_mem_315138") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_315139,
                                               "ext_mem_315139") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_315609,
                                               "ext_mem_315609") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_315610,
                                               "ext_mem_315610") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_314923,
                                               "ext_mem_314923") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_314847,
                                               "ext_mem_314847") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_314848,
                                               "ext_mem_314848") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_313201,
                                               "mem_param_313201") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_313193,
                                               "mem_param_313193") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_316760,
                                               "ext_mem_316760") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_316761,
                                               "ext_mem_316761") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_313179,
                                               "mem_param_313179") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_313171,
                                               "mem_param_313171") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_313163,
                                               "mem_param_313163") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_317010,
                                               "ext_mem_317010") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_317011,
                                               "ext_mem_317011") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_317012,
                                               "ext_mem_317012") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_313155,
                                               "mem_313155") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_313151,
                                               "mem_313151") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_317163,
                                               "mem_out_317163") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_317162,
                                               "mem_out_317162") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_317161,
                                               "mem_out_317161") != 0)
                                return 1;
                            ;
                            err = futhark_mc_segmap_task_338497_err;
                            goto cleanup;
                        }
                        if (memblock_set(ctx, &ext_mem_315137, &mem_315131,
                                         "mem_315131") != 0)
                            return 1;
                        if (memblock_set(ctx, &ext_mem_315136, &mem_315135,
                                         "mem_315135") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_315135, "mem_315135") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_315131, "mem_315131") != 0)
                            return 1;
                    }
                    if (memblock_set(ctx, &ext_mem_315139, &ext_mem_315137,
                                     "ext_mem_315137") != 0)
                        return 1;
                    if (memblock_set(ctx, &ext_mem_315138, &ext_mem_315136,
                                     "ext_mem_315136") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_315136,
                                       "ext_mem_315136") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_315137,
                                       "ext_mem_315137") != 0)
                        return 1;
                }
                if (memblock_set(ctx, &ext_mem_315610, &ext_mem_315139,
                                 "ext_mem_315139") != 0)
                    return 1;
                if (memblock_set(ctx, &ext_mem_315609, &ext_mem_315138,
                                 "ext_mem_315138") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_315138, "ext_mem_315138") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_315139, "ext_mem_315139") != 0)
                    return 1;
            } else {
                bool cond_295112 = sle64(jump_threshold_2_292690,
                                         jump_l_292686);
                bool cond_t_res_295113 = slt64(q_l_292680,
                                               q_threshold_1_292691);
                bool x_295114 = cond_295112 && cond_t_res_295113;
                struct memblock ext_mem_315608;
                
                ext_mem_315608.references = NULL;
                
                struct memblock ext_mem_315607;
                
                ext_mem_315607.references = NULL;
                if (x_295114) {
                    bool match_lit_295117 = (int64_t) 0 == d_l_292683;
                    struct memblock ext_mem_315488;
                    
                    ext_mem_315488.references = NULL;
                    
                    struct memblock ext_mem_315487;
                    
                    ext_mem_315487.references = NULL;
                    if (match_lit_295117) {
                        struct memblock mem_315143;
                        
                        mem_315143.references = NULL;
                        if (memblock_alloc(ctx, &mem_315143, bytes_313080,
                                           "mem_315143")) {
                            err = 1;
                            goto cleanup;
                        }
                        for (int64_t i_329788 = 0; i_329788 <
                             partition_sizze_292766; i_329788++) {
                            for (int64_t i_329789 = 0; i_329789 < l_n_m_292832;
                                 i_329789++) {
                                ((double *) mem_315143.mem)[i_329788 *
                                                            l_n_m_292832 +
                                                            i_329789] = 0.0;
                            }
                        }
                        
                        struct memblock mem_315198;
                        
                        mem_315198.references = NULL;
                        if (memblock_alloc(ctx, &mem_315198, bytes_313080,
                                           "mem_315198")) {
                            err = 1;
                            goto cleanup;
                        }
                        
                        int64_t binop_y_315144 = (int64_t) 8 * q_l_292680;
                        int64_t bytes_315145 = smax64((int64_t) 0,
                                                      binop_y_315144);
                        int64_t flat_tid_305755 = (int64_t) 0;
                        int32_t num_tasks_329790;
                        int64_t flat_tid_305816 = (int64_t) 0;
                        struct futhark_mc_task_338529 futhark_mc_task_338529;
                        
                        futhark_mc_task_338529.ctx = ctx;
                        futhark_mc_task_338529.free_n_292675 = n_292675;
                        futhark_mc_task_338529.free_q_l_292680 = q_l_292680;
                        futhark_mc_task_338529.free_jump_t_292685 =
                            jump_t_292685;
                        futhark_mc_task_338529.free_partition_sizze_292766 =
                            partition_sizze_292766;
                        futhark_mc_task_338529.free_l_n_m_292832 = l_n_m_292832;
                        futhark_mc_task_338529.free_i_292846 = i_292846;
                        futhark_mc_task_338529.free_bytes_313028 = bytes_313028;
                        futhark_mc_task_338529.free_mem_313081 = mem_313081;
                        futhark_mc_task_338529.free_mem_313085 = mem_313085;
                        futhark_mc_task_338529.free_ctx_param_ext_313174 =
                            ctx_param_ext_313174;
                        futhark_mc_task_338529.free_ctx_param_ext_313175 =
                            ctx_param_ext_313175;
                        futhark_mc_task_338529.free_ctx_param_ext_313177 =
                            ctx_param_ext_313177;
                        futhark_mc_task_338529.free_mem_param_313179 =
                            mem_param_313179.mem;
                        futhark_mc_task_338529.free_mem_315021 = mem_315021;
                        futhark_mc_task_338529.free_bytes_315145 = bytes_315145;
                        futhark_mc_task_338529.free_mem_315198 = mem_315198.mem;
                        
                        struct scheduler_segop futhark_mc_task_338529_task;
                        
                        futhark_mc_task_338529_task.args =
                            &futhark_mc_task_338529;
                        futhark_mc_task_338529_task.top_level_fn =
                            futhark_mc_segmap_task_338530;
                        futhark_mc_task_338529_task.name =
                            "futhark_mc_segmap_task_338530";
                        futhark_mc_task_338529_task.iterations =
                            partition_sizze_292766;
                        futhark_mc_task_338529_task.task_time =
                            &ctx->futhark_mc_segmap_task_338530_total_time;
                        futhark_mc_task_338529_task.task_iter =
                            &ctx->futhark_mc_segmap_task_338530_total_iter;
                        futhark_mc_task_338529_task.sched = STATIC;
                        futhark_mc_task_338529_task.nested_fn =
                            futhark_mc_segmap_nested_task_338535;
                        
                        int futhark_mc_segmap_task_338530_err =
                            scheduler_prepare_task(&ctx->scheduler,
                                                   &futhark_mc_task_338529_task);
                        
                        if (futhark_mc_segmap_task_338530_err != 0) {
                            if (memblock_unref(ctx, &mem_315198,
                                               "mem_315198") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_315143,
                                               "mem_315143") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_315487,
                                               "ext_mem_315487") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_315488,
                                               "ext_mem_315488") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_315607,
                                               "ext_mem_315607") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_315608,
                                               "ext_mem_315608") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_315609,
                                               "ext_mem_315609") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_315610,
                                               "ext_mem_315610") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_314923,
                                               "ext_mem_314923") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_314847,
                                               "ext_mem_314847") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_314848,
                                               "ext_mem_314848") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_313201,
                                               "mem_param_313201") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_313193,
                                               "mem_param_313193") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_316760,
                                               "ext_mem_316760") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_316761,
                                               "ext_mem_316761") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_313179,
                                               "mem_param_313179") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_313171,
                                               "mem_param_313171") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_313163,
                                               "mem_param_313163") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_317010,
                                               "ext_mem_317010") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_317011,
                                               "ext_mem_317011") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_317012,
                                               "ext_mem_317012") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_313155,
                                               "mem_313155") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_313151,
                                               "mem_313151") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_317163,
                                               "mem_out_317163") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_317162,
                                               "mem_out_317162") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_317161,
                                               "mem_out_317161") != 0)
                                return 1;
                            ;
                            err = futhark_mc_segmap_task_338530_err;
                            goto cleanup;
                        }
                        if (memblock_set(ctx, &ext_mem_315488, &mem_315198,
                                         "mem_315198") != 0)
                            return 1;
                        if (memblock_set(ctx, &ext_mem_315487, &mem_315143,
                                         "mem_315143") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_315198, "mem_315198") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_315143, "mem_315143") != 0)
                            return 1;
                    } else {
                        bool match_lit_295175 = (int64_t) 1 == d_l_292683;
                        struct memblock ext_mem_315486;
                        
                        ext_mem_315486.references = NULL;
                        
                        struct memblock ext_mem_315485;
                        
                        ext_mem_315485.references = NULL;
                        if (match_lit_295175) {
                            struct memblock mem_315304;
                            
                            mem_315304.references = NULL;
                            if (memblock_alloc(ctx, &mem_315304, bytes_313080,
                                               "mem_315304")) {
                                err = 1;
                                goto cleanup;
                            }
                            
                            struct memblock mem_315308;
                            
                            mem_315308.references = NULL;
                            if (memblock_alloc(ctx, &mem_315308, bytes_313080,
                                               "mem_315308")) {
                                err = 1;
                                goto cleanup;
                            }
                            
                            int64_t binop_y_315199 = (int64_t) 8 * q_l_292680;
                            int64_t bytes_315200 = smax64((int64_t) 0,
                                                          binop_y_315199);
                            int64_t flat_tid_305917 = (int64_t) 0;
                            int32_t num_tasks_330034;
                            int64_t flat_tid_306009 = (int64_t) 0;
                            struct futhark_mc_task_338558
                            futhark_mc_task_338558;
                            
                            futhark_mc_task_338558.ctx = ctx;
                            futhark_mc_task_338558.free_n_292675 = n_292675;
                            futhark_mc_task_338558.free_q_l_292680 = q_l_292680;
                            futhark_mc_task_338558.free_jump_t_292685 =
                                jump_t_292685;
                            futhark_mc_task_338558.free_partition_sizze_292766 =
                                partition_sizze_292766;
                            futhark_mc_task_338558.free_l_n_m_292832 =
                                l_n_m_292832;
                            futhark_mc_task_338558.free_i_292846 = i_292846;
                            futhark_mc_task_338558.free_bytes_313028 =
                                bytes_313028;
                            futhark_mc_task_338558.free_mem_313081 = mem_313081;
                            futhark_mc_task_338558.free_mem_313085 = mem_313085;
                            futhark_mc_task_338558.free_ctx_param_ext_313174 =
                                ctx_param_ext_313174;
                            futhark_mc_task_338558.free_ctx_param_ext_313175 =
                                ctx_param_ext_313175;
                            futhark_mc_task_338558.free_ctx_param_ext_313177 =
                                ctx_param_ext_313177;
                            futhark_mc_task_338558.free_mem_param_313179 =
                                mem_param_313179.mem;
                            futhark_mc_task_338558.free_mem_315021 = mem_315021;
                            futhark_mc_task_338558.free_bytes_315200 =
                                bytes_315200;
                            futhark_mc_task_338558.free_mem_315304 =
                                mem_315304.mem;
                            futhark_mc_task_338558.free_mem_315308 =
                                mem_315308.mem;
                            
                            struct scheduler_segop futhark_mc_task_338558_task;
                            
                            futhark_mc_task_338558_task.args =
                                &futhark_mc_task_338558;
                            futhark_mc_task_338558_task.top_level_fn =
                                futhark_mc_segmap_task_338559;
                            futhark_mc_task_338558_task.name =
                                "futhark_mc_segmap_task_338559";
                            futhark_mc_task_338558_task.iterations =
                                partition_sizze_292766;
                            futhark_mc_task_338558_task.task_time =
                                &ctx->futhark_mc_segmap_task_338559_total_time;
                            futhark_mc_task_338558_task.task_iter =
                                &ctx->futhark_mc_segmap_task_338559_total_iter;
                            futhark_mc_task_338558_task.sched = STATIC;
                            futhark_mc_task_338558_task.nested_fn =
                                futhark_mc_segmap_nested_task_338566;
                            
                            int futhark_mc_segmap_task_338559_err =
                                scheduler_prepare_task(&ctx->scheduler,
                                                       &futhark_mc_task_338558_task);
                            
                            if (futhark_mc_segmap_task_338559_err != 0) {
                                if (memblock_unref(ctx, &mem_315308,
                                                   "mem_315308") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_315304,
                                                   "mem_315304") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_315485,
                                                   "ext_mem_315485") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_315486,
                                                   "ext_mem_315486") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_315487,
                                                   "ext_mem_315487") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_315488,
                                                   "ext_mem_315488") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_315607,
                                                   "ext_mem_315607") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_315608,
                                                   "ext_mem_315608") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_315609,
                                                   "ext_mem_315609") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_315610,
                                                   "ext_mem_315610") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_314923,
                                                   "ext_mem_314923") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_314847,
                                                   "ext_mem_314847") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_314848,
                                                   "ext_mem_314848") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_param_313201,
                                                   "mem_param_313201") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_param_313193,
                                                   "mem_param_313193") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_316760,
                                                   "ext_mem_316760") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_316761,
                                                   "ext_mem_316761") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_param_313179,
                                                   "mem_param_313179") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_param_313171,
                                                   "mem_param_313171") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_param_313163,
                                                   "mem_param_313163") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_317010,
                                                   "ext_mem_317010") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_317011,
                                                   "ext_mem_317011") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_317012,
                                                   "ext_mem_317012") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_313155,
                                                   "mem_313155") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_313151,
                                                   "mem_313151") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_out_317163,
                                                   "mem_out_317163") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_out_317162,
                                                   "mem_out_317162") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_out_317161,
                                                   "mem_out_317161") != 0)
                                    return 1;
                                ;
                                err = futhark_mc_segmap_task_338559_err;
                                goto cleanup;
                            }
                            if (memblock_set(ctx, &ext_mem_315486, &mem_315304,
                                             "mem_315304") != 0)
                                return 1;
                            if (memblock_set(ctx, &ext_mem_315485, &mem_315308,
                                             "mem_315308") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_315308,
                                               "mem_315308") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_315304,
                                               "mem_315304") != 0)
                                return 1;
                        } else {
                            struct memblock mem_315480;
                            
                            mem_315480.references = NULL;
                            if (memblock_alloc(ctx, &mem_315480, bytes_313080,
                                               "mem_315480")) {
                                err = 1;
                                goto cleanup;
                            }
                            
                            struct memblock mem_315484;
                            
                            mem_315484.references = NULL;
                            if (memblock_alloc(ctx, &mem_315484, bytes_313080,
                                               "mem_315484")) {
                                err = 1;
                                goto cleanup;
                            }
                            
                            int64_t binop_y_315309 = (int64_t) 8 * q_l_292680;
                            int64_t bytes_315310 = smax64((int64_t) 0,
                                                          binop_y_315309);
                            int64_t flat_tid_306173 = (int64_t) 0;
                            int32_t num_tasks_330437;
                            int64_t flat_tid_306307 = (int64_t) 0;
                            struct futhark_mc_task_338595
                            futhark_mc_task_338595;
                            
                            futhark_mc_task_338595.ctx = ctx;
                            futhark_mc_task_338595.free_n_292675 = n_292675;
                            futhark_mc_task_338595.free_q_l_292680 = q_l_292680;
                            futhark_mc_task_338595.free_jump_t_292685 =
                                jump_t_292685;
                            futhark_mc_task_338595.free_partition_sizze_292766 =
                                partition_sizze_292766;
                            futhark_mc_task_338595.free_l_n_m_292832 =
                                l_n_m_292832;
                            futhark_mc_task_338595.free_i_292846 = i_292846;
                            futhark_mc_task_338595.free_bytes_313028 =
                                bytes_313028;
                            futhark_mc_task_338595.free_mem_313081 = mem_313081;
                            futhark_mc_task_338595.free_mem_313085 = mem_313085;
                            futhark_mc_task_338595.free_ctx_param_ext_313174 =
                                ctx_param_ext_313174;
                            futhark_mc_task_338595.free_ctx_param_ext_313175 =
                                ctx_param_ext_313175;
                            futhark_mc_task_338595.free_ctx_param_ext_313177 =
                                ctx_param_ext_313177;
                            futhark_mc_task_338595.free_mem_param_313179 =
                                mem_param_313179.mem;
                            futhark_mc_task_338595.free_mem_315021 = mem_315021;
                            futhark_mc_task_338595.free_bytes_315310 =
                                bytes_315310;
                            futhark_mc_task_338595.free_mem_315480 =
                                mem_315480.mem;
                            futhark_mc_task_338595.free_mem_315484 =
                                mem_315484.mem;
                            
                            struct scheduler_segop futhark_mc_task_338595_task;
                            
                            futhark_mc_task_338595_task.args =
                                &futhark_mc_task_338595;
                            futhark_mc_task_338595_task.top_level_fn =
                                futhark_mc_segmap_task_338596;
                            futhark_mc_task_338595_task.name =
                                "futhark_mc_segmap_task_338596";
                            futhark_mc_task_338595_task.iterations =
                                partition_sizze_292766;
                            futhark_mc_task_338595_task.task_time =
                                &ctx->futhark_mc_segmap_task_338596_total_time;
                            futhark_mc_task_338595_task.task_iter =
                                &ctx->futhark_mc_segmap_task_338596_total_iter;
                            futhark_mc_task_338595_task.sched = STATIC;
                            futhark_mc_task_338595_task.nested_fn =
                                futhark_mc_segmap_nested_task_338605;
                            
                            int futhark_mc_segmap_task_338596_err =
                                scheduler_prepare_task(&ctx->scheduler,
                                                       &futhark_mc_task_338595_task);
                            
                            if (futhark_mc_segmap_task_338596_err != 0) {
                                if (memblock_unref(ctx, &mem_315484,
                                                   "mem_315484") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_315480,
                                                   "mem_315480") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_315485,
                                                   "ext_mem_315485") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_315486,
                                                   "ext_mem_315486") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_315487,
                                                   "ext_mem_315487") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_315488,
                                                   "ext_mem_315488") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_315607,
                                                   "ext_mem_315607") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_315608,
                                                   "ext_mem_315608") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_315609,
                                                   "ext_mem_315609") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_315610,
                                                   "ext_mem_315610") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_314923,
                                                   "ext_mem_314923") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_314847,
                                                   "ext_mem_314847") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_314848,
                                                   "ext_mem_314848") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_param_313201,
                                                   "mem_param_313201") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_param_313193,
                                                   "mem_param_313193") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_316760,
                                                   "ext_mem_316760") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_316761,
                                                   "ext_mem_316761") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_param_313179,
                                                   "mem_param_313179") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_param_313171,
                                                   "mem_param_313171") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_param_313163,
                                                   "mem_param_313163") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_317010,
                                                   "ext_mem_317010") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_317011,
                                                   "ext_mem_317011") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_317012,
                                                   "ext_mem_317012") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_313155,
                                                   "mem_313155") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_313151,
                                                   "mem_313151") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_out_317163,
                                                   "mem_out_317163") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_out_317162,
                                                   "mem_out_317162") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_out_317161,
                                                   "mem_out_317161") != 0)
                                    return 1;
                                ;
                                err = futhark_mc_segmap_task_338596_err;
                                goto cleanup;
                            }
                            if (memblock_set(ctx, &ext_mem_315486, &mem_315480,
                                             "mem_315480") != 0)
                                return 1;
                            if (memblock_set(ctx, &ext_mem_315485, &mem_315484,
                                             "mem_315484") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_315484,
                                               "mem_315484") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_315480,
                                               "mem_315480") != 0)
                                return 1;
                        }
                        if (memblock_set(ctx, &ext_mem_315488, &ext_mem_315486,
                                         "ext_mem_315486") != 0)
                            return 1;
                        if (memblock_set(ctx, &ext_mem_315487, &ext_mem_315485,
                                         "ext_mem_315485") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_315485,
                                           "ext_mem_315485") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_315486,
                                           "ext_mem_315486") != 0)
                            return 1;
                    }
                    if (memblock_set(ctx, &ext_mem_315608, &ext_mem_315488,
                                     "ext_mem_315488") != 0)
                        return 1;
                    if (memblock_set(ctx, &ext_mem_315607, &ext_mem_315487,
                                     "ext_mem_315487") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_315487,
                                       "ext_mem_315487") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_315488,
                                       "ext_mem_315488") != 0)
                        return 1;
                } else {
                    bool match_lit_295430 = (int64_t) 0 == d_l_292683;
                    struct memblock ext_mem_315606;
                    
                    ext_mem_315606.references = NULL;
                    
                    struct memblock ext_mem_315605;
                    
                    ext_mem_315605.references = NULL;
                    if (match_lit_295430) {
                        struct memblock mem_315492;
                        
                        mem_315492.references = NULL;
                        if (memblock_alloc(ctx, &mem_315492, bytes_313080,
                                           "mem_315492")) {
                            err = 1;
                            goto cleanup;
                        }
                        for (int64_t i_331033 = 0; i_331033 <
                             partition_sizze_292766; i_331033++) {
                            for (int64_t i_331034 = 0; i_331034 < l_n_m_292832;
                                 i_331034++) {
                                ((double *) mem_315492.mem)[i_331033 *
                                                            l_n_m_292832 +
                                                            i_331034] = 0.0;
                            }
                        }
                        
                        struct memblock mem_315514;
                        
                        mem_315514.references = NULL;
                        if (memblock_alloc(ctx, &mem_315514, bytes_313080,
                                           "mem_315514")) {
                            err = 1;
                            goto cleanup;
                        }
                        
                        int64_t flat_tid_306549 = (int64_t) 0;
                        int32_t num_tasks_331035;
                        int64_t flat_tid_306624 = (int64_t) 0;
                        struct futhark_mc_task_338644 futhark_mc_task_338644;
                        
                        futhark_mc_task_338644.ctx = ctx;
                        futhark_mc_task_338644.free_n_292675 = n_292675;
                        futhark_mc_task_338644.free_q_l_292680 = q_l_292680;
                        futhark_mc_task_338644.free_jump_t_292685 =
                            jump_t_292685;
                        futhark_mc_task_338644.free_partition_sizze_292766 =
                            partition_sizze_292766;
                        futhark_mc_task_338644.free_l_n_m_292832 = l_n_m_292832;
                        futhark_mc_task_338644.free_i_292846 = i_292846;
                        futhark_mc_task_338644.free_bytes_313028 = bytes_313028;
                        futhark_mc_task_338644.free_mem_313081 = mem_313081;
                        futhark_mc_task_338644.free_mem_313085 = mem_313085;
                        futhark_mc_task_338644.free_ctx_param_ext_313174 =
                            ctx_param_ext_313174;
                        futhark_mc_task_338644.free_ctx_param_ext_313175 =
                            ctx_param_ext_313175;
                        futhark_mc_task_338644.free_ctx_param_ext_313177 =
                            ctx_param_ext_313177;
                        futhark_mc_task_338644.free_mem_param_313179 =
                            mem_param_313179.mem;
                        futhark_mc_task_338644.free_mem_315021 = mem_315021;
                        futhark_mc_task_338644.free_mem_315514 = mem_315514.mem;
                        
                        struct scheduler_segop futhark_mc_task_338644_task;
                        
                        futhark_mc_task_338644_task.args =
                            &futhark_mc_task_338644;
                        futhark_mc_task_338644_task.top_level_fn =
                            futhark_mc_segmap_task_338645;
                        futhark_mc_task_338644_task.name =
                            "futhark_mc_segmap_task_338645";
                        futhark_mc_task_338644_task.iterations =
                            partition_sizze_292766;
                        futhark_mc_task_338644_task.task_time =
                            &ctx->futhark_mc_segmap_task_338645_total_time;
                        futhark_mc_task_338644_task.task_iter =
                            &ctx->futhark_mc_segmap_task_338645_total_iter;
                        futhark_mc_task_338644_task.sched = STATIC;
                        futhark_mc_task_338644_task.nested_fn =
                            futhark_mc_segmap_nested_task_338649;
                        
                        int futhark_mc_segmap_task_338645_err =
                            scheduler_prepare_task(&ctx->scheduler,
                                                   &futhark_mc_task_338644_task);
                        
                        if (futhark_mc_segmap_task_338645_err != 0) {
                            if (memblock_unref(ctx, &mem_315514,
                                               "mem_315514") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_315492,
                                               "mem_315492") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_315605,
                                               "ext_mem_315605") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_315606,
                                               "ext_mem_315606") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_315607,
                                               "ext_mem_315607") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_315608,
                                               "ext_mem_315608") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_315609,
                                               "ext_mem_315609") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_315610,
                                               "ext_mem_315610") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_314923,
                                               "ext_mem_314923") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_314847,
                                               "ext_mem_314847") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_314848,
                                               "ext_mem_314848") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_313201,
                                               "mem_param_313201") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_313193,
                                               "mem_param_313193") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_316760,
                                               "ext_mem_316760") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_316761,
                                               "ext_mem_316761") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_313179,
                                               "mem_param_313179") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_313171,
                                               "mem_param_313171") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_313163,
                                               "mem_param_313163") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_317010,
                                               "ext_mem_317010") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_317011,
                                               "ext_mem_317011") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_317012,
                                               "ext_mem_317012") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_313155,
                                               "mem_313155") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_313151,
                                               "mem_313151") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_317163,
                                               "mem_out_317163") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_317162,
                                               "mem_out_317162") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_317161,
                                               "mem_out_317161") != 0)
                                return 1;
                            ;
                            err = futhark_mc_segmap_task_338645_err;
                            goto cleanup;
                        }
                        if (memblock_set(ctx, &ext_mem_315606, &mem_315514,
                                         "mem_315514") != 0)
                            return 1;
                        if (memblock_set(ctx, &ext_mem_315605, &mem_315492,
                                         "mem_315492") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_315514, "mem_315514") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_315492, "mem_315492") != 0)
                            return 1;
                    } else {
                        bool match_lit_295502 = (int64_t) 1 == d_l_292683;
                        struct memblock ext_mem_315604;
                        
                        ext_mem_315604.references = NULL;
                        
                        struct memblock ext_mem_315603;
                        
                        ext_mem_315603.references = NULL;
                        if (match_lit_295502) {
                            struct memblock mem_315554;
                            
                            mem_315554.references = NULL;
                            if (memblock_alloc(ctx, &mem_315554, bytes_313080,
                                               "mem_315554")) {
                                err = 1;
                                goto cleanup;
                            }
                            
                            struct memblock mem_315558;
                            
                            mem_315558.references = NULL;
                            if (memblock_alloc(ctx, &mem_315558, bytes_313080,
                                               "mem_315558")) {
                                err = 1;
                                goto cleanup;
                            }
                            
                            int64_t flat_tid_306753 = (int64_t) 0;
                            int32_t num_tasks_331339;
                            int64_t flat_tid_306858 = (int64_t) 0;
                            struct futhark_mc_task_338670
                            futhark_mc_task_338670;
                            
                            futhark_mc_task_338670.ctx = ctx;
                            futhark_mc_task_338670.free_n_292675 = n_292675;
                            futhark_mc_task_338670.free_q_l_292680 = q_l_292680;
                            futhark_mc_task_338670.free_jump_t_292685 =
                                jump_t_292685;
                            futhark_mc_task_338670.free_partition_sizze_292766 =
                                partition_sizze_292766;
                            futhark_mc_task_338670.free_l_n_m_292832 =
                                l_n_m_292832;
                            futhark_mc_task_338670.free_i_292846 = i_292846;
                            futhark_mc_task_338670.free_bytes_313028 =
                                bytes_313028;
                            futhark_mc_task_338670.free_mem_313081 = mem_313081;
                            futhark_mc_task_338670.free_mem_313085 = mem_313085;
                            futhark_mc_task_338670.free_ctx_param_ext_313174 =
                                ctx_param_ext_313174;
                            futhark_mc_task_338670.free_ctx_param_ext_313175 =
                                ctx_param_ext_313175;
                            futhark_mc_task_338670.free_ctx_param_ext_313177 =
                                ctx_param_ext_313177;
                            futhark_mc_task_338670.free_mem_param_313179 =
                                mem_param_313179.mem;
                            futhark_mc_task_338670.free_mem_315021 = mem_315021;
                            futhark_mc_task_338670.free_mem_315554 =
                                mem_315554.mem;
                            futhark_mc_task_338670.free_mem_315558 =
                                mem_315558.mem;
                            
                            struct scheduler_segop futhark_mc_task_338670_task;
                            
                            futhark_mc_task_338670_task.args =
                                &futhark_mc_task_338670;
                            futhark_mc_task_338670_task.top_level_fn =
                                futhark_mc_segmap_task_338671;
                            futhark_mc_task_338670_task.name =
                                "futhark_mc_segmap_task_338671";
                            futhark_mc_task_338670_task.iterations =
                                partition_sizze_292766;
                            futhark_mc_task_338670_task.task_time =
                                &ctx->futhark_mc_segmap_task_338671_total_time;
                            futhark_mc_task_338670_task.task_iter =
                                &ctx->futhark_mc_segmap_task_338671_total_iter;
                            futhark_mc_task_338670_task.sched = STATIC;
                            futhark_mc_task_338670_task.nested_fn =
                                futhark_mc_segmap_nested_task_338676;
                            
                            int futhark_mc_segmap_task_338671_err =
                                scheduler_prepare_task(&ctx->scheduler,
                                                       &futhark_mc_task_338670_task);
                            
                            if (futhark_mc_segmap_task_338671_err != 0) {
                                if (memblock_unref(ctx, &mem_315558,
                                                   "mem_315558") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_315554,
                                                   "mem_315554") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_315603,
                                                   "ext_mem_315603") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_315604,
                                                   "ext_mem_315604") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_315605,
                                                   "ext_mem_315605") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_315606,
                                                   "ext_mem_315606") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_315607,
                                                   "ext_mem_315607") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_315608,
                                                   "ext_mem_315608") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_315609,
                                                   "ext_mem_315609") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_315610,
                                                   "ext_mem_315610") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_314923,
                                                   "ext_mem_314923") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_314847,
                                                   "ext_mem_314847") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_314848,
                                                   "ext_mem_314848") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_param_313201,
                                                   "mem_param_313201") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_param_313193,
                                                   "mem_param_313193") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_316760,
                                                   "ext_mem_316760") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_316761,
                                                   "ext_mem_316761") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_param_313179,
                                                   "mem_param_313179") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_param_313171,
                                                   "mem_param_313171") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_param_313163,
                                                   "mem_param_313163") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_317010,
                                                   "ext_mem_317010") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_317011,
                                                   "ext_mem_317011") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_317012,
                                                   "ext_mem_317012") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_313155,
                                                   "mem_313155") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_313151,
                                                   "mem_313151") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_out_317163,
                                                   "mem_out_317163") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_out_317162,
                                                   "mem_out_317162") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_out_317161,
                                                   "mem_out_317161") != 0)
                                    return 1;
                                ;
                                err = futhark_mc_segmap_task_338671_err;
                                goto cleanup;
                            }
                            if (memblock_set(ctx, &ext_mem_315604, &mem_315554,
                                             "mem_315554") != 0)
                                return 1;
                            if (memblock_set(ctx, &ext_mem_315603, &mem_315558,
                                             "mem_315558") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_315558,
                                               "mem_315558") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_315554,
                                               "mem_315554") != 0)
                                return 1;
                        } else {
                            struct memblock mem_315598;
                            
                            mem_315598.references = NULL;
                            if (memblock_alloc(ctx, &mem_315598, bytes_313080,
                                               "mem_315598")) {
                                err = 1;
                                goto cleanup;
                            }
                            
                            struct memblock mem_315602;
                            
                            mem_315602.references = NULL;
                            if (memblock_alloc(ctx, &mem_315602, bytes_313080,
                                               "mem_315602")) {
                                err = 1;
                                goto cleanup;
                            }
                            
                            int64_t flat_tid_307048 = (int64_t) 0;
                            int32_t num_tasks_331787;
                            int64_t flat_tid_307187 = (int64_t) 0;
                            struct futhark_mc_task_338701
                            futhark_mc_task_338701;
                            
                            futhark_mc_task_338701.ctx = ctx;
                            futhark_mc_task_338701.free_n_292675 = n_292675;
                            futhark_mc_task_338701.free_q_l_292680 = q_l_292680;
                            futhark_mc_task_338701.free_jump_t_292685 =
                                jump_t_292685;
                            futhark_mc_task_338701.free_partition_sizze_292766 =
                                partition_sizze_292766;
                            futhark_mc_task_338701.free_l_n_m_292832 =
                                l_n_m_292832;
                            futhark_mc_task_338701.free_i_292846 = i_292846;
                            futhark_mc_task_338701.free_bytes_313028 =
                                bytes_313028;
                            futhark_mc_task_338701.free_mem_313081 = mem_313081;
                            futhark_mc_task_338701.free_mem_313085 = mem_313085;
                            futhark_mc_task_338701.free_ctx_param_ext_313174 =
                                ctx_param_ext_313174;
                            futhark_mc_task_338701.free_ctx_param_ext_313175 =
                                ctx_param_ext_313175;
                            futhark_mc_task_338701.free_ctx_param_ext_313177 =
                                ctx_param_ext_313177;
                            futhark_mc_task_338701.free_mem_param_313179 =
                                mem_param_313179.mem;
                            futhark_mc_task_338701.free_mem_315021 = mem_315021;
                            futhark_mc_task_338701.free_mem_315598 =
                                mem_315598.mem;
                            futhark_mc_task_338701.free_mem_315602 =
                                mem_315602.mem;
                            
                            struct scheduler_segop futhark_mc_task_338701_task;
                            
                            futhark_mc_task_338701_task.args =
                                &futhark_mc_task_338701;
                            futhark_mc_task_338701_task.top_level_fn =
                                futhark_mc_segmap_task_338702;
                            futhark_mc_task_338701_task.name =
                                "futhark_mc_segmap_task_338702";
                            futhark_mc_task_338701_task.iterations =
                                partition_sizze_292766;
                            futhark_mc_task_338701_task.task_time =
                                &ctx->futhark_mc_segmap_task_338702_total_time;
                            futhark_mc_task_338701_task.task_iter =
                                &ctx->futhark_mc_segmap_task_338702_total_iter;
                            futhark_mc_task_338701_task.sched = STATIC;
                            futhark_mc_task_338701_task.nested_fn =
                                futhark_mc_segmap_nested_task_338707;
                            
                            int futhark_mc_segmap_task_338702_err =
                                scheduler_prepare_task(&ctx->scheduler,
                                                       &futhark_mc_task_338701_task);
                            
                            if (futhark_mc_segmap_task_338702_err != 0) {
                                if (memblock_unref(ctx, &mem_315602,
                                                   "mem_315602") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_315598,
                                                   "mem_315598") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_315603,
                                                   "ext_mem_315603") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_315604,
                                                   "ext_mem_315604") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_315605,
                                                   "ext_mem_315605") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_315606,
                                                   "ext_mem_315606") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_315607,
                                                   "ext_mem_315607") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_315608,
                                                   "ext_mem_315608") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_315609,
                                                   "ext_mem_315609") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_315610,
                                                   "ext_mem_315610") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_314923,
                                                   "ext_mem_314923") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_314847,
                                                   "ext_mem_314847") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_314848,
                                                   "ext_mem_314848") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_param_313201,
                                                   "mem_param_313201") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_param_313193,
                                                   "mem_param_313193") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_316760,
                                                   "ext_mem_316760") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_316761,
                                                   "ext_mem_316761") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_param_313179,
                                                   "mem_param_313179") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_param_313171,
                                                   "mem_param_313171") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_param_313163,
                                                   "mem_param_313163") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_317010,
                                                   "ext_mem_317010") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_317011,
                                                   "ext_mem_317011") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_317012,
                                                   "ext_mem_317012") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_313155,
                                                   "mem_313155") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_313151,
                                                   "mem_313151") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_out_317163,
                                                   "mem_out_317163") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_out_317162,
                                                   "mem_out_317162") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_out_317161,
                                                   "mem_out_317161") != 0)
                                    return 1;
                                ;
                                err = futhark_mc_segmap_task_338702_err;
                                goto cleanup;
                            }
                            if (memblock_set(ctx, &ext_mem_315604, &mem_315598,
                                             "mem_315598") != 0)
                                return 1;
                            if (memblock_set(ctx, &ext_mem_315603, &mem_315602,
                                             "mem_315602") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_315602,
                                               "mem_315602") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_315598,
                                               "mem_315598") != 0)
                                return 1;
                        }
                        if (memblock_set(ctx, &ext_mem_315606, &ext_mem_315604,
                                         "ext_mem_315604") != 0)
                            return 1;
                        if (memblock_set(ctx, &ext_mem_315605, &ext_mem_315603,
                                         "ext_mem_315603") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_315603,
                                           "ext_mem_315603") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_315604,
                                           "ext_mem_315604") != 0)
                            return 1;
                    }
                    if (memblock_set(ctx, &ext_mem_315608, &ext_mem_315606,
                                     "ext_mem_315606") != 0)
                        return 1;
                    if (memblock_set(ctx, &ext_mem_315607, &ext_mem_315605,
                                     "ext_mem_315605") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_315605,
                                       "ext_mem_315605") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_315606,
                                       "ext_mem_315606") != 0)
                        return 1;
                }
                if (memblock_set(ctx, &ext_mem_315610, &ext_mem_315608,
                                 "ext_mem_315608") != 0)
                    return 1;
                if (memblock_set(ctx, &ext_mem_315609, &ext_mem_315607,
                                 "ext_mem_315607") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_315607, "ext_mem_315607") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_315608, "ext_mem_315608") != 0)
                    return 1;
            }
            
            struct memblock ext_mem_315633;
            
            ext_mem_315633.references = NULL;
            if (cond_293285) {
                bool zzero_295740 = jump_l_292686 == (int64_t) 0;
                bool nonzzero_295741 = !zzero_295740;
                bool nonzzero_cert_295742;
                
                if (!nonzzero_295741) {
                    ctx->error = msgprintf("Error: %s\n\nBacktrace:\n%s",
                                           "division by zero",
                                           "-> #0  loess.fut:742:20-27\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:741:3-745:9\n   #5  stl.fut:256:23-75\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  stl.fut:254:15-257:43\n   #9  stl.fut:419:61-435:77\n   #10 stl.fut:463:3-479:36\n   #11 stl.fut:445:1-479:36\n");
                    if (memblock_unref(ctx, &ext_mem_315633,
                                       "ext_mem_315633") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_315609,
                                       "ext_mem_315609") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_315610,
                                       "ext_mem_315610") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_314923,
                                       "ext_mem_314923") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_314847,
                                       "ext_mem_314847") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_314848,
                                       "ext_mem_314848") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_313201,
                                       "mem_param_313201") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_313193,
                                       "mem_param_313193") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316760,
                                       "ext_mem_316760") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316761,
                                       "ext_mem_316761") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_313179,
                                       "mem_param_313179") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_313171,
                                       "mem_param_313171") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_313163,
                                       "mem_param_313163") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_317010,
                                       "ext_mem_317010") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_317011,
                                       "ext_mem_317011") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_317012,
                                       "ext_mem_317012") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_313155, "mem_313155") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_313151, "mem_313151") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_317163,
                                       "mem_out_317163") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_317162,
                                       "mem_out_317162") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_317161,
                                       "mem_out_317161") != 0)
                        return 1;
                    err = FUTHARK_PROGRAM_ERROR;
                    goto cleanup;
                }
                
                int64_t y_295743 = sub64(l_n_m_292832, (int64_t) 1);
                struct memblock mem_315632;
                
                mem_315632.references = NULL;
                if (memblock_alloc(ctx, &mem_315632, bytes_312635,
                                   "mem_315632")) {
                    err = 1;
                    goto cleanup;
                }
                
                int64_t flat_tid_307445 = (int64_t) 0;
                int32_t num_tasks_332373;
                int64_t flat_tid_307451 = (int64_t) 0;
                struct futhark_mc_task_338734 futhark_mc_task_338734;
                
                futhark_mc_task_338734.ctx = ctx;
                futhark_mc_task_338734.free_n_292675 = n_292675;
                futhark_mc_task_338734.free_jump_l_292686 = jump_l_292686;
                futhark_mc_task_338734.free_partition_sizze_292766 =
                    partition_sizze_292766;
                futhark_mc_task_338734.free_l_n_m_292832 = l_n_m_292832;
                futhark_mc_task_338734.free_i_292846 = i_292846;
                futhark_mc_task_338734.free_y_295743 = y_295743;
                futhark_mc_task_338734.free_bytes_312598 = bytes_312598;
                futhark_mc_task_338734.free_ext_mem_315609 = ext_mem_315609.mem;
                futhark_mc_task_338734.free_ext_mem_315610 = ext_mem_315610.mem;
                futhark_mc_task_338734.free_mem_315632 = mem_315632.mem;
                
                struct scheduler_segop futhark_mc_task_338734_task;
                
                futhark_mc_task_338734_task.args = &futhark_mc_task_338734;
                futhark_mc_task_338734_task.top_level_fn =
                    futhark_mc_segmap_task_338735;
                futhark_mc_task_338734_task.name =
                    "futhark_mc_segmap_task_338735";
                futhark_mc_task_338734_task.iterations = partition_sizze_292766;
                futhark_mc_task_338734_task.task_time =
                    &ctx->futhark_mc_segmap_task_338735_total_time;
                futhark_mc_task_338734_task.task_iter =
                    &ctx->futhark_mc_segmap_task_338735_total_iter;
                futhark_mc_task_338734_task.sched = STATIC;
                futhark_mc_task_338734_task.nested_fn =
                    futhark_mc_segmap_nested_task_338739;
                
                int futhark_mc_segmap_task_338735_err =
                    scheduler_prepare_task(&ctx->scheduler,
                                           &futhark_mc_task_338734_task);
                
                if (futhark_mc_segmap_task_338735_err != 0) {
                    if (memblock_unref(ctx, &mem_315632, "mem_315632") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_315633,
                                       "ext_mem_315633") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_315609,
                                       "ext_mem_315609") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_315610,
                                       "ext_mem_315610") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_314923,
                                       "ext_mem_314923") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_314847,
                                       "ext_mem_314847") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_314848,
                                       "ext_mem_314848") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_313201,
                                       "mem_param_313201") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_313193,
                                       "mem_param_313193") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316760,
                                       "ext_mem_316760") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316761,
                                       "ext_mem_316761") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_313179,
                                       "mem_param_313179") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_313171,
                                       "mem_param_313171") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_313163,
                                       "mem_param_313163") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_317010,
                                       "ext_mem_317010") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_317011,
                                       "ext_mem_317011") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_317012,
                                       "ext_mem_317012") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_313155, "mem_313155") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_313151, "mem_313151") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_317163,
                                       "mem_out_317163") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_317162,
                                       "mem_out_317162") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_317161,
                                       "mem_out_317161") != 0)
                        return 1;
                    ;
                    err = futhark_mc_segmap_task_338735_err;
                    goto cleanup;
                }
                if (memblock_set(ctx, &ext_mem_315633, &mem_315632,
                                 "mem_315632") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_315632, "mem_315632") != 0)
                    return 1;
            } else {
                bool dim_match_295795 = n_292675 == l_n_m_292832;
                bool empty_or_match_cert_295796;
                
                if (!dim_match_295795) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Value of (core language) shape (",
                                  (long long) partition_sizze_292766, ", ",
                                  (long long) l_n_m_292832,
                                  ") cannot match shape of type `[",
                                  (long long) partition_sizze_292766, "][",
                                  (long long) n_292675, "]t`.",
                                  "-> #0  stl.fut:259:15-36\n   #1  stl.fut:419:61-435:77\n   #2  stl.fut:463:3-479:36\n   #3  stl.fut:445:1-479:36\n");
                    if (memblock_unref(ctx, &ext_mem_315633,
                                       "ext_mem_315633") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_315609,
                                       "ext_mem_315609") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_315610,
                                       "ext_mem_315610") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_314923,
                                       "ext_mem_314923") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_314847,
                                       "ext_mem_314847") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_314848,
                                       "ext_mem_314848") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_313201,
                                       "mem_param_313201") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_313193,
                                       "mem_param_313193") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316760,
                                       "ext_mem_316760") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316761,
                                       "ext_mem_316761") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_313179,
                                       "mem_param_313179") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_313171,
                                       "mem_param_313171") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_313163,
                                       "mem_param_313163") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_317010,
                                       "ext_mem_317010") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_317011,
                                       "ext_mem_317011") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_317012,
                                       "ext_mem_317012") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_313155, "mem_313155") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_313151, "mem_313151") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_317163,
                                       "mem_out_317163") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_317162,
                                       "mem_out_317162") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_317161,
                                       "mem_out_317161") != 0)
                        return 1;
                    err = FUTHARK_PROGRAM_ERROR;
                    goto cleanup;
                }
                if (memblock_set(ctx, &ext_mem_315633, &ext_mem_315610,
                                 "ext_mem_315610") != 0)
                    return 1;
            }
            if (memblock_unref(ctx, &ext_mem_315609, "ext_mem_315609") != 0)
                return 1;
            if (memblock_unref(ctx, &ext_mem_315610, "ext_mem_315610") != 0)
                return 1;
            
            struct memblock mem_315656;
            
            mem_315656.references = NULL;
            if (memblock_alloc(ctx, &mem_315656, bytes_312635, "mem_315656")) {
                err = 1;
                goto cleanup;
            }
            
            int64_t flat_tid_307505 = (int64_t) 0;
            int32_t num_tasks_332483;
            int64_t flat_tid_307511 = (int64_t) 0;
            struct futhark_mc_task_338747 futhark_mc_task_338747;
            
            futhark_mc_task_338747.ctx = ctx;
            futhark_mc_task_338747.free_n_292675 = n_292675;
            futhark_mc_task_338747.free_n_p_292677 = n_p_292677;
            futhark_mc_task_338747.free_partition_sizze_292766 =
                partition_sizze_292766;
            futhark_mc_task_338747.free_C_len_292823 = C_len_292823;
            futhark_mc_task_338747.free_bytes_312598 = bytes_312598;
            futhark_mc_task_338747.free_mem_314946 = mem_314946;
            futhark_mc_task_338747.free_ext_mem_315633 = ext_mem_315633.mem;
            futhark_mc_task_338747.free_ext_315634 = ext_315634;
            futhark_mc_task_338747.free_mem_315656 = mem_315656.mem;
            
            struct scheduler_segop futhark_mc_task_338747_task;
            
            futhark_mc_task_338747_task.args = &futhark_mc_task_338747;
            futhark_mc_task_338747_task.top_level_fn =
                futhark_mc_segmap_task_338748;
            futhark_mc_task_338747_task.name = "futhark_mc_segmap_task_338748";
            futhark_mc_task_338747_task.iterations = partition_sizze_292766;
            futhark_mc_task_338747_task.task_time =
                &ctx->futhark_mc_segmap_task_338748_total_time;
            futhark_mc_task_338747_task.task_iter =
                &ctx->futhark_mc_segmap_task_338748_total_iter;
            futhark_mc_task_338747_task.sched = STATIC;
            futhark_mc_task_338747_task.nested_fn =
                futhark_mc_segmap_nested_task_338752;
            
            int futhark_mc_segmap_task_338748_err =
                scheduler_prepare_task(&ctx->scheduler,
                                       &futhark_mc_task_338747_task);
            
            if (futhark_mc_segmap_task_338748_err != 0) {
                if (memblock_unref(ctx, &mem_315656, "mem_315656") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_315633, "ext_mem_315633") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_315609, "ext_mem_315609") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_315610, "ext_mem_315610") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_314923, "ext_mem_314923") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_314847, "ext_mem_314847") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_314848, "ext_mem_314848") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_313201,
                                   "mem_param_313201") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_313193,
                                   "mem_param_313193") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_316760, "ext_mem_316760") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_316761, "ext_mem_316761") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_313179,
                                   "mem_param_313179") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_313171,
                                   "mem_param_313171") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_313163,
                                   "mem_param_313163") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_317010, "ext_mem_317010") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_317011, "ext_mem_317011") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_317012, "ext_mem_317012") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_313155, "mem_313155") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_313151, "mem_313151") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_out_317163, "mem_out_317163") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_out_317162, "mem_out_317162") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_out_317161, "mem_out_317161") != 0)
                    return 1;
                ;
                err = futhark_mc_segmap_task_338748_err;
                goto cleanup;
            }
            if (memblock_unref(ctx, &ext_mem_315633, "ext_mem_315633") != 0)
                return 1;
            
            struct memblock ext_mem_316731;
            
            ext_mem_316731.references = NULL;
            
            struct memblock ext_mem_316730;
            
            ext_mem_316730.references = NULL;
            if (cond_293346) {
                bool match_lit_295808 = (int64_t) 0 == d_t_292682;
                struct memblock ext_mem_315936;
                
                ext_mem_315936.references = NULL;
                
                struct memblock ext_mem_315935;
                
                ext_mem_315935.references = NULL;
                if (match_lit_295808) {
                    struct memblock mem_315660;
                    
                    mem_315660.references = NULL;
                    if (memblock_alloc(ctx, &mem_315660, bytes_313142,
                                       "mem_315660")) {
                        err = 1;
                        goto cleanup;
                    }
                    for (int64_t i_332508 = 0; i_332508 <
                         partition_sizze_292766; i_332508++) {
                        for (int64_t i_332509 = 0; i_332509 < t_n_m_292839;
                             i_332509++) {
                            ((double *) mem_315660.mem)[i_332508 *
                                                        t_n_m_292839 +
                                                        i_332509] = 0.0;
                        }
                    }
                    
                    struct memblock mem_315736;
                    
                    mem_315736.references = NULL;
                    if (memblock_alloc(ctx, &mem_315736, bytes_313142,
                                       "mem_315736")) {
                        err = 1;
                        goto cleanup;
                    }
                    
                    int64_t flat_tid_307521 = (int64_t) 0;
                    int32_t num_tasks_332510;
                    int64_t flat_tid_307602 = (int64_t) 0;
                    struct futhark_mc_task_338760 futhark_mc_task_338760;
                    
                    futhark_mc_task_338760.ctx = ctx;
                    futhark_mc_task_338760.free_n_292675 = n_292675;
                    futhark_mc_task_338760.free_q_t_292679 = q_t_292679;
                    futhark_mc_task_338760.free_jump_t_292685 = jump_t_292685;
                    futhark_mc_task_338760.free_partition_sizze_292766 =
                        partition_sizze_292766;
                    futhark_mc_task_338760.free_t_n_m_292839 = t_n_m_292839;
                    futhark_mc_task_338760.free_i_292846 = i_292846;
                    futhark_mc_task_338760.free_mem_312593 = mem_312593;
                    futhark_mc_task_338760.free_bytes_312598 = bytes_312598;
                    futhark_mc_task_338760.free_mem_312636 = mem_312636;
                    futhark_mc_task_338760.free_mem_312639 = mem_312639;
                    futhark_mc_task_338760.free_bytes_313090 = bytes_313090;
                    futhark_mc_task_338760.free_mem_313143 = mem_313143;
                    futhark_mc_task_338760.free_mem_313147 = mem_313147;
                    futhark_mc_task_338760.free_ctx_param_ext_313174 =
                        ctx_param_ext_313174;
                    futhark_mc_task_338760.free_ctx_param_ext_313175 =
                        ctx_param_ext_313175;
                    futhark_mc_task_338760.free_ctx_param_ext_313177 =
                        ctx_param_ext_313177;
                    futhark_mc_task_338760.free_mem_param_313179 =
                        mem_param_313179.mem;
                    futhark_mc_task_338760.free_mem_315656 = mem_315656.mem;
                    futhark_mc_task_338760.free_mem_315736 = mem_315736.mem;
                    
                    struct scheduler_segop futhark_mc_task_338760_task;
                    
                    futhark_mc_task_338760_task.args = &futhark_mc_task_338760;
                    futhark_mc_task_338760_task.top_level_fn =
                        futhark_mc_segmap_task_338761;
                    futhark_mc_task_338760_task.name =
                        "futhark_mc_segmap_task_338761";
                    futhark_mc_task_338760_task.iterations =
                        partition_sizze_292766;
                    futhark_mc_task_338760_task.task_time =
                        &ctx->futhark_mc_segmap_task_338761_total_time;
                    futhark_mc_task_338760_task.task_iter =
                        &ctx->futhark_mc_segmap_task_338761_total_iter;
                    futhark_mc_task_338760_task.sched = STATIC;
                    futhark_mc_task_338760_task.nested_fn =
                        futhark_mc_segmap_nested_task_338768;
                    
                    int futhark_mc_segmap_task_338761_err =
                        scheduler_prepare_task(&ctx->scheduler,
                                               &futhark_mc_task_338760_task);
                    
                    if (futhark_mc_segmap_task_338761_err != 0) {
                        if (memblock_unref(ctx, &mem_315736, "mem_315736") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_315660, "mem_315660") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_315935,
                                           "ext_mem_315935") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_315936,
                                           "ext_mem_315936") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_316730,
                                           "ext_mem_316730") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_316731,
                                           "ext_mem_316731") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_315656, "mem_315656") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_315633,
                                           "ext_mem_315633") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_315609,
                                           "ext_mem_315609") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_315610,
                                           "ext_mem_315610") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_314923,
                                           "ext_mem_314923") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_314847,
                                           "ext_mem_314847") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_314848,
                                           "ext_mem_314848") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_param_313201,
                                           "mem_param_313201") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_param_313193,
                                           "mem_param_313193") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_316760,
                                           "ext_mem_316760") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_316761,
                                           "ext_mem_316761") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_param_313179,
                                           "mem_param_313179") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_param_313171,
                                           "mem_param_313171") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_param_313163,
                                           "mem_param_313163") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_317010,
                                           "ext_mem_317010") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_317011,
                                           "ext_mem_317011") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_317012,
                                           "ext_mem_317012") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_313155, "mem_313155") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_313151, "mem_313151") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_out_317163,
                                           "mem_out_317163") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_out_317162,
                                           "mem_out_317162") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_out_317161,
                                           "mem_out_317161") != 0)
                            return 1;
                        ;
                        err = futhark_mc_segmap_task_338761_err;
                        goto cleanup;
                    }
                    if (memblock_set(ctx, &ext_mem_315936, &mem_315736,
                                     "mem_315736") != 0)
                        return 1;
                    if (memblock_set(ctx, &ext_mem_315935, &mem_315660,
                                     "mem_315660") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_315736, "mem_315736") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_315660, "mem_315660") != 0)
                        return 1;
                } else {
                    bool match_lit_295904 = (int64_t) 1 == d_t_292682;
                    struct memblock ext_mem_315934;
                    
                    ext_mem_315934.references = NULL;
                    
                    struct memblock ext_mem_315933;
                    
                    ext_mem_315933.references = NULL;
                    if (match_lit_295904) {
                        struct memblock mem_315830;
                        
                        mem_315830.references = NULL;
                        if (memblock_alloc(ctx, &mem_315830, bytes_313142,
                                           "mem_315830")) {
                            err = 1;
                            goto cleanup;
                        }
                        
                        struct memblock mem_315834;
                        
                        mem_315834.references = NULL;
                        if (memblock_alloc(ctx, &mem_315834, bytes_313142,
                                           "mem_315834")) {
                            err = 1;
                            goto cleanup;
                        }
                        
                        int64_t flat_tid_307761 = (int64_t) 0;
                        int32_t num_tasks_332887;
                        int64_t flat_tid_307872 = (int64_t) 0;
                        struct futhark_mc_task_338800 futhark_mc_task_338800;
                        
                        futhark_mc_task_338800.ctx = ctx;
                        futhark_mc_task_338800.free_n_292675 = n_292675;
                        futhark_mc_task_338800.free_q_t_292679 = q_t_292679;
                        futhark_mc_task_338800.free_jump_t_292685 =
                            jump_t_292685;
                        futhark_mc_task_338800.free_partition_sizze_292766 =
                            partition_sizze_292766;
                        futhark_mc_task_338800.free_t_n_m_292839 = t_n_m_292839;
                        futhark_mc_task_338800.free_i_292846 = i_292846;
                        futhark_mc_task_338800.free_mem_312593 = mem_312593;
                        futhark_mc_task_338800.free_bytes_312598 = bytes_312598;
                        futhark_mc_task_338800.free_mem_312636 = mem_312636;
                        futhark_mc_task_338800.free_mem_312639 = mem_312639;
                        futhark_mc_task_338800.free_bytes_313090 = bytes_313090;
                        futhark_mc_task_338800.free_mem_313143 = mem_313143;
                        futhark_mc_task_338800.free_mem_313147 = mem_313147;
                        futhark_mc_task_338800.free_ctx_param_ext_313174 =
                            ctx_param_ext_313174;
                        futhark_mc_task_338800.free_ctx_param_ext_313175 =
                            ctx_param_ext_313175;
                        futhark_mc_task_338800.free_ctx_param_ext_313177 =
                            ctx_param_ext_313177;
                        futhark_mc_task_338800.free_mem_param_313179 =
                            mem_param_313179.mem;
                        futhark_mc_task_338800.free_mem_315656 = mem_315656.mem;
                        futhark_mc_task_338800.free_mem_315830 = mem_315830.mem;
                        futhark_mc_task_338800.free_mem_315834 = mem_315834.mem;
                        
                        struct scheduler_segop futhark_mc_task_338800_task;
                        
                        futhark_mc_task_338800_task.args =
                            &futhark_mc_task_338800;
                        futhark_mc_task_338800_task.top_level_fn =
                            futhark_mc_segmap_task_338801;
                        futhark_mc_task_338800_task.name =
                            "futhark_mc_segmap_task_338801";
                        futhark_mc_task_338800_task.iterations =
                            partition_sizze_292766;
                        futhark_mc_task_338800_task.task_time =
                            &ctx->futhark_mc_segmap_task_338801_total_time;
                        futhark_mc_task_338800_task.task_iter =
                            &ctx->futhark_mc_segmap_task_338801_total_iter;
                        futhark_mc_task_338800_task.sched = STATIC;
                        futhark_mc_task_338800_task.nested_fn =
                            futhark_mc_segmap_nested_task_338809;
                        
                        int futhark_mc_segmap_task_338801_err =
                            scheduler_prepare_task(&ctx->scheduler,
                                                   &futhark_mc_task_338800_task);
                        
                        if (futhark_mc_segmap_task_338801_err != 0) {
                            if (memblock_unref(ctx, &mem_315834,
                                               "mem_315834") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_315830,
                                               "mem_315830") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_315933,
                                               "ext_mem_315933") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_315934,
                                               "ext_mem_315934") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_315935,
                                               "ext_mem_315935") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_315936,
                                               "ext_mem_315936") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_316730,
                                               "ext_mem_316730") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_316731,
                                               "ext_mem_316731") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_315656,
                                               "mem_315656") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_315633,
                                               "ext_mem_315633") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_315609,
                                               "ext_mem_315609") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_315610,
                                               "ext_mem_315610") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_314923,
                                               "ext_mem_314923") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_314847,
                                               "ext_mem_314847") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_314848,
                                               "ext_mem_314848") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_313201,
                                               "mem_param_313201") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_313193,
                                               "mem_param_313193") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_316760,
                                               "ext_mem_316760") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_316761,
                                               "ext_mem_316761") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_313179,
                                               "mem_param_313179") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_313171,
                                               "mem_param_313171") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_313163,
                                               "mem_param_313163") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_317010,
                                               "ext_mem_317010") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_317011,
                                               "ext_mem_317011") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_317012,
                                               "ext_mem_317012") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_313155,
                                               "mem_313155") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_313151,
                                               "mem_313151") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_317163,
                                               "mem_out_317163") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_317162,
                                               "mem_out_317162") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_317161,
                                               "mem_out_317161") != 0)
                                return 1;
                            ;
                            err = futhark_mc_segmap_task_338801_err;
                            goto cleanup;
                        }
                        if (memblock_set(ctx, &ext_mem_315934, &mem_315830,
                                         "mem_315830") != 0)
                            return 1;
                        if (memblock_set(ctx, &ext_mem_315933, &mem_315834,
                                         "mem_315834") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_315834, "mem_315834") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_315830, "mem_315830") != 0)
                            return 1;
                    } else {
                        struct memblock mem_315928;
                        
                        mem_315928.references = NULL;
                        if (memblock_alloc(ctx, &mem_315928, bytes_313142,
                                           "mem_315928")) {
                            err = 1;
                            goto cleanup;
                        }
                        
                        struct memblock mem_315932;
                        
                        mem_315932.references = NULL;
                        if (memblock_alloc(ctx, &mem_315932, bytes_313142,
                                           "mem_315932")) {
                            err = 1;
                            goto cleanup;
                        }
                        
                        int64_t flat_tid_308092 = (int64_t) 0;
                        int32_t num_tasks_333408;
                        int64_t flat_tid_308237 = (int64_t) 0;
                        struct futhark_mc_task_338845 futhark_mc_task_338845;
                        
                        futhark_mc_task_338845.ctx = ctx;
                        futhark_mc_task_338845.free_n_292675 = n_292675;
                        futhark_mc_task_338845.free_q_t_292679 = q_t_292679;
                        futhark_mc_task_338845.free_jump_t_292685 =
                            jump_t_292685;
                        futhark_mc_task_338845.free_partition_sizze_292766 =
                            partition_sizze_292766;
                        futhark_mc_task_338845.free_t_n_m_292839 = t_n_m_292839;
                        futhark_mc_task_338845.free_i_292846 = i_292846;
                        futhark_mc_task_338845.free_mem_312593 = mem_312593;
                        futhark_mc_task_338845.free_bytes_312598 = bytes_312598;
                        futhark_mc_task_338845.free_mem_312636 = mem_312636;
                        futhark_mc_task_338845.free_mem_312639 = mem_312639;
                        futhark_mc_task_338845.free_bytes_313090 = bytes_313090;
                        futhark_mc_task_338845.free_mem_313143 = mem_313143;
                        futhark_mc_task_338845.free_mem_313147 = mem_313147;
                        futhark_mc_task_338845.free_ctx_param_ext_313174 =
                            ctx_param_ext_313174;
                        futhark_mc_task_338845.free_ctx_param_ext_313175 =
                            ctx_param_ext_313175;
                        futhark_mc_task_338845.free_ctx_param_ext_313177 =
                            ctx_param_ext_313177;
                        futhark_mc_task_338845.free_mem_param_313179 =
                            mem_param_313179.mem;
                        futhark_mc_task_338845.free_mem_315656 = mem_315656.mem;
                        futhark_mc_task_338845.free_mem_315928 = mem_315928.mem;
                        futhark_mc_task_338845.free_mem_315932 = mem_315932.mem;
                        
                        struct scheduler_segop futhark_mc_task_338845_task;
                        
                        futhark_mc_task_338845_task.args =
                            &futhark_mc_task_338845;
                        futhark_mc_task_338845_task.top_level_fn =
                            futhark_mc_segmap_task_338846;
                        futhark_mc_task_338845_task.name =
                            "futhark_mc_segmap_task_338846";
                        futhark_mc_task_338845_task.iterations =
                            partition_sizze_292766;
                        futhark_mc_task_338845_task.task_time =
                            &ctx->futhark_mc_segmap_task_338846_total_time;
                        futhark_mc_task_338845_task.task_iter =
                            &ctx->futhark_mc_segmap_task_338846_total_iter;
                        futhark_mc_task_338845_task.sched = STATIC;
                        futhark_mc_task_338845_task.nested_fn =
                            futhark_mc_segmap_nested_task_338854;
                        
                        int futhark_mc_segmap_task_338846_err =
                            scheduler_prepare_task(&ctx->scheduler,
                                                   &futhark_mc_task_338845_task);
                        
                        if (futhark_mc_segmap_task_338846_err != 0) {
                            if (memblock_unref(ctx, &mem_315932,
                                               "mem_315932") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_315928,
                                               "mem_315928") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_315933,
                                               "ext_mem_315933") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_315934,
                                               "ext_mem_315934") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_315935,
                                               "ext_mem_315935") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_315936,
                                               "ext_mem_315936") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_316730,
                                               "ext_mem_316730") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_316731,
                                               "ext_mem_316731") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_315656,
                                               "mem_315656") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_315633,
                                               "ext_mem_315633") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_315609,
                                               "ext_mem_315609") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_315610,
                                               "ext_mem_315610") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_314923,
                                               "ext_mem_314923") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_314847,
                                               "ext_mem_314847") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_314848,
                                               "ext_mem_314848") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_313201,
                                               "mem_param_313201") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_313193,
                                               "mem_param_313193") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_316760,
                                               "ext_mem_316760") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_316761,
                                               "ext_mem_316761") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_313179,
                                               "mem_param_313179") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_313171,
                                               "mem_param_313171") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_313163,
                                               "mem_param_313163") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_317010,
                                               "ext_mem_317010") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_317011,
                                               "ext_mem_317011") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_317012,
                                               "ext_mem_317012") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_313155,
                                               "mem_313155") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_313151,
                                               "mem_313151") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_317163,
                                               "mem_out_317163") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_317162,
                                               "mem_out_317162") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_317161,
                                               "mem_out_317161") != 0)
                                return 1;
                            ;
                            err = futhark_mc_segmap_task_338846_err;
                            goto cleanup;
                        }
                        if (memblock_set(ctx, &ext_mem_315934, &mem_315928,
                                         "mem_315928") != 0)
                            return 1;
                        if (memblock_set(ctx, &ext_mem_315933, &mem_315932,
                                         "mem_315932") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_315932, "mem_315932") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_315928, "mem_315928") != 0)
                            return 1;
                    }
                    if (memblock_set(ctx, &ext_mem_315936, &ext_mem_315934,
                                     "ext_mem_315934") != 0)
                        return 1;
                    if (memblock_set(ctx, &ext_mem_315935, &ext_mem_315933,
                                     "ext_mem_315933") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_315933,
                                       "ext_mem_315933") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_315934,
                                       "ext_mem_315934") != 0)
                        return 1;
                }
                if (memblock_set(ctx, &ext_mem_316731, &ext_mem_315936,
                                 "ext_mem_315936") != 0)
                    return 1;
                if (memblock_set(ctx, &ext_mem_316730, &ext_mem_315935,
                                 "ext_mem_315935") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_315935, "ext_mem_315935") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_315936, "ext_mem_315936") != 0)
                    return 1;
            } else {
                bool cond_296189 = sle64(jump_threshold_2_292690,
                                         jump_t_292685);
                bool cond_t_res_296190 = slt64(q_t_292679,
                                               q_threshold_1_292691);
                bool x_296191 = cond_296189 && cond_t_res_296190;
                struct memblock ext_mem_316729;
                
                ext_mem_316729.references = NULL;
                
                struct memblock ext_mem_316728;
                
                ext_mem_316728.references = NULL;
                if (x_296191) {
                    bool match_lit_296194 = (int64_t) 0 == d_t_292682;
                    struct memblock ext_mem_316447;
                    
                    ext_mem_316447.references = NULL;
                    
                    struct memblock ext_mem_316446;
                    
                    ext_mem_316446.references = NULL;
                    if (match_lit_296194) {
                        struct memblock mem_315940;
                        
                        mem_315940.references = NULL;
                        if (memblock_alloc(ctx, &mem_315940, bytes_313142,
                                           "mem_315940")) {
                            err = 1;
                            goto cleanup;
                        }
                        for (int64_t i_334067 = 0; i_334067 <
                             partition_sizze_292766; i_334067++) {
                            for (int64_t i_334068 = 0; i_334068 < t_n_m_292839;
                                 i_334068++) {
                                ((double *) mem_315940.mem)[i_334067 *
                                                            t_n_m_292839 +
                                                            i_334068] = 0.0;
                            }
                        }
                        
                        struct memblock mem_316049;
                        
                        mem_316049.references = NULL;
                        if (memblock_alloc(ctx, &mem_316049, bytes_313142,
                                           "mem_316049")) {
                            err = 1;
                            goto cleanup;
                        }
                        
                        int64_t binop_y_315950 = (int64_t) 8 * q_t_292679;
                        int64_t bytes_315951 = smax64((int64_t) 0,
                                                      binop_y_315950);
                        int64_t flat_tid_308525 = (int64_t) 0;
                        int32_t num_tasks_334069;
                        int64_t flat_tid_308591 = (int64_t) 0;
                        struct futhark_mc_task_338892 futhark_mc_task_338892;
                        
                        futhark_mc_task_338892.ctx = ctx;
                        futhark_mc_task_338892.free_n_292675 = n_292675;
                        futhark_mc_task_338892.free_q_t_292679 = q_t_292679;
                        futhark_mc_task_338892.free_jump_t_292685 =
                            jump_t_292685;
                        futhark_mc_task_338892.free_partition_sizze_292766 =
                            partition_sizze_292766;
                        futhark_mc_task_338892.free_t_n_m_292839 = t_n_m_292839;
                        futhark_mc_task_338892.free_i_292846 = i_292846;
                        futhark_mc_task_338892.free_mem_312593 = mem_312593;
                        futhark_mc_task_338892.free_bytes_312598 = bytes_312598;
                        futhark_mc_task_338892.free_mem_312636 = mem_312636;
                        futhark_mc_task_338892.free_mem_312639 = mem_312639;
                        futhark_mc_task_338892.free_bytes_313090 = bytes_313090;
                        futhark_mc_task_338892.free_mem_313143 = mem_313143;
                        futhark_mc_task_338892.free_mem_313147 = mem_313147;
                        futhark_mc_task_338892.free_ctx_param_ext_313174 =
                            ctx_param_ext_313174;
                        futhark_mc_task_338892.free_ctx_param_ext_313175 =
                            ctx_param_ext_313175;
                        futhark_mc_task_338892.free_ctx_param_ext_313177 =
                            ctx_param_ext_313177;
                        futhark_mc_task_338892.free_mem_param_313179 =
                            mem_param_313179.mem;
                        futhark_mc_task_338892.free_mem_315656 = mem_315656.mem;
                        futhark_mc_task_338892.free_bytes_315951 = bytes_315951;
                        futhark_mc_task_338892.free_mem_316049 = mem_316049.mem;
                        
                        struct scheduler_segop futhark_mc_task_338892_task;
                        
                        futhark_mc_task_338892_task.args =
                            &futhark_mc_task_338892;
                        futhark_mc_task_338892_task.top_level_fn =
                            futhark_mc_segmap_task_338893;
                        futhark_mc_task_338892_task.name =
                            "futhark_mc_segmap_task_338893";
                        futhark_mc_task_338892_task.iterations =
                            partition_sizze_292766;
                        futhark_mc_task_338892_task.task_time =
                            &ctx->futhark_mc_segmap_task_338893_total_time;
                        futhark_mc_task_338892_task.task_iter =
                            &ctx->futhark_mc_segmap_task_338893_total_iter;
                        futhark_mc_task_338892_task.sched = STATIC;
                        futhark_mc_task_338892_task.nested_fn =
                            futhark_mc_segmap_nested_task_338901;
                        
                        int futhark_mc_segmap_task_338893_err =
                            scheduler_prepare_task(&ctx->scheduler,
                                                   &futhark_mc_task_338892_task);
                        
                        if (futhark_mc_segmap_task_338893_err != 0) {
                            if (memblock_unref(ctx, &mem_316049,
                                               "mem_316049") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_315940,
                                               "mem_315940") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_316446,
                                               "ext_mem_316446") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_316447,
                                               "ext_mem_316447") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_316728,
                                               "ext_mem_316728") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_316729,
                                               "ext_mem_316729") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_316730,
                                               "ext_mem_316730") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_316731,
                                               "ext_mem_316731") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_315656,
                                               "mem_315656") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_315633,
                                               "ext_mem_315633") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_315609,
                                               "ext_mem_315609") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_315610,
                                               "ext_mem_315610") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_314923,
                                               "ext_mem_314923") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_314847,
                                               "ext_mem_314847") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_314848,
                                               "ext_mem_314848") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_313201,
                                               "mem_param_313201") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_313193,
                                               "mem_param_313193") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_316760,
                                               "ext_mem_316760") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_316761,
                                               "ext_mem_316761") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_313179,
                                               "mem_param_313179") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_313171,
                                               "mem_param_313171") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_313163,
                                               "mem_param_313163") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_317010,
                                               "ext_mem_317010") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_317011,
                                               "ext_mem_317011") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_317012,
                                               "ext_mem_317012") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_313155,
                                               "mem_313155") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_313151,
                                               "mem_313151") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_317163,
                                               "mem_out_317163") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_317162,
                                               "mem_out_317162") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_317161,
                                               "mem_out_317161") != 0)
                                return 1;
                            ;
                            err = futhark_mc_segmap_task_338893_err;
                            goto cleanup;
                        }
                        if (memblock_set(ctx, &ext_mem_316447, &mem_316049,
                                         "mem_316049") != 0)
                            return 1;
                        if (memblock_set(ctx, &ext_mem_316446, &mem_315940,
                                         "mem_315940") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_316049, "mem_316049") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_315940, "mem_315940") != 0)
                            return 1;
                    } else {
                        bool match_lit_296275 = (int64_t) 1 == d_t_292682;
                        struct memblock ext_mem_316445;
                        
                        ext_mem_316445.references = NULL;
                        
                        struct memblock ext_mem_316444;
                        
                        ext_mem_316444.references = NULL;
                        if (match_lit_296275) {
                            struct memblock mem_316209;
                            
                            mem_316209.references = NULL;
                            if (memblock_alloc(ctx, &mem_316209, bytes_313142,
                                               "mem_316209")) {
                                err = 1;
                                goto cleanup;
                            }
                            
                            struct memblock mem_316213;
                            
                            mem_316213.references = NULL;
                            if (memblock_alloc(ctx, &mem_316213, bytes_313142,
                                               "mem_316213")) {
                                err = 1;
                                goto cleanup;
                            }
                            
                            int64_t binop_y_316059 = (int64_t) 8 * q_t_292679;
                            int64_t bytes_316060 = smax64((int64_t) 0,
                                                          binop_y_316059);
                            int64_t flat_tid_308720 = (int64_t) 0;
                            int32_t num_tasks_334381;
                            int64_t flat_tid_308817 = (int64_t) 0;
                            struct futhark_mc_task_338935
                            futhark_mc_task_338935;
                            
                            futhark_mc_task_338935.ctx = ctx;
                            futhark_mc_task_338935.free_n_292675 = n_292675;
                            futhark_mc_task_338935.free_q_t_292679 = q_t_292679;
                            futhark_mc_task_338935.free_jump_t_292685 =
                                jump_t_292685;
                            futhark_mc_task_338935.free_partition_sizze_292766 =
                                partition_sizze_292766;
                            futhark_mc_task_338935.free_t_n_m_292839 =
                                t_n_m_292839;
                            futhark_mc_task_338935.free_i_292846 = i_292846;
                            futhark_mc_task_338935.free_mem_312593 = mem_312593;
                            futhark_mc_task_338935.free_bytes_312598 =
                                bytes_312598;
                            futhark_mc_task_338935.free_mem_312636 = mem_312636;
                            futhark_mc_task_338935.free_mem_312639 = mem_312639;
                            futhark_mc_task_338935.free_bytes_313090 =
                                bytes_313090;
                            futhark_mc_task_338935.free_mem_313143 = mem_313143;
                            futhark_mc_task_338935.free_mem_313147 = mem_313147;
                            futhark_mc_task_338935.free_ctx_param_ext_313174 =
                                ctx_param_ext_313174;
                            futhark_mc_task_338935.free_ctx_param_ext_313175 =
                                ctx_param_ext_313175;
                            futhark_mc_task_338935.free_ctx_param_ext_313177 =
                                ctx_param_ext_313177;
                            futhark_mc_task_338935.free_mem_param_313179 =
                                mem_param_313179.mem;
                            futhark_mc_task_338935.free_mem_315656 =
                                mem_315656.mem;
                            futhark_mc_task_338935.free_bytes_316060 =
                                bytes_316060;
                            futhark_mc_task_338935.free_mem_316209 =
                                mem_316209.mem;
                            futhark_mc_task_338935.free_mem_316213 =
                                mem_316213.mem;
                            
                            struct scheduler_segop futhark_mc_task_338935_task;
                            
                            futhark_mc_task_338935_task.args =
                                &futhark_mc_task_338935;
                            futhark_mc_task_338935_task.top_level_fn =
                                futhark_mc_segmap_task_338936;
                            futhark_mc_task_338935_task.name =
                                "futhark_mc_segmap_task_338936";
                            futhark_mc_task_338935_task.iterations =
                                partition_sizze_292766;
                            futhark_mc_task_338935_task.task_time =
                                &ctx->futhark_mc_segmap_task_338936_total_time;
                            futhark_mc_task_338935_task.task_iter =
                                &ctx->futhark_mc_segmap_task_338936_total_iter;
                            futhark_mc_task_338935_task.sched = STATIC;
                            futhark_mc_task_338935_task.nested_fn =
                                futhark_mc_segmap_nested_task_338946;
                            
                            int futhark_mc_segmap_task_338936_err =
                                scheduler_prepare_task(&ctx->scheduler,
                                                       &futhark_mc_task_338935_task);
                            
                            if (futhark_mc_segmap_task_338936_err != 0) {
                                if (memblock_unref(ctx, &mem_316213,
                                                   "mem_316213") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_316209,
                                                   "mem_316209") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_316444,
                                                   "ext_mem_316444") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_316445,
                                                   "ext_mem_316445") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_316446,
                                                   "ext_mem_316446") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_316447,
                                                   "ext_mem_316447") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_316728,
                                                   "ext_mem_316728") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_316729,
                                                   "ext_mem_316729") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_316730,
                                                   "ext_mem_316730") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_316731,
                                                   "ext_mem_316731") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_315656,
                                                   "mem_315656") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_315633,
                                                   "ext_mem_315633") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_315609,
                                                   "ext_mem_315609") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_315610,
                                                   "ext_mem_315610") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_314923,
                                                   "ext_mem_314923") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_314847,
                                                   "ext_mem_314847") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_314848,
                                                   "ext_mem_314848") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_param_313201,
                                                   "mem_param_313201") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_param_313193,
                                                   "mem_param_313193") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_316760,
                                                   "ext_mem_316760") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_316761,
                                                   "ext_mem_316761") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_param_313179,
                                                   "mem_param_313179") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_param_313171,
                                                   "mem_param_313171") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_param_313163,
                                                   "mem_param_313163") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_317010,
                                                   "ext_mem_317010") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_317011,
                                                   "ext_mem_317011") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_317012,
                                                   "ext_mem_317012") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_313155,
                                                   "mem_313155") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_313151,
                                                   "mem_313151") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_out_317163,
                                                   "mem_out_317163") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_out_317162,
                                                   "mem_out_317162") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_out_317161,
                                                   "mem_out_317161") != 0)
                                    return 1;
                                ;
                                err = futhark_mc_segmap_task_338936_err;
                                goto cleanup;
                            }
                            if (memblock_set(ctx, &ext_mem_316445, &mem_316209,
                                             "mem_316209") != 0)
                                return 1;
                            if (memblock_set(ctx, &ext_mem_316444, &mem_316213,
                                             "mem_316213") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_316213,
                                               "mem_316213") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_316209,
                                               "mem_316209") != 0)
                                return 1;
                        } else {
                            struct memblock mem_316439;
                            
                            mem_316439.references = NULL;
                            if (memblock_alloc(ctx, &mem_316439, bytes_313142,
                                               "mem_316439")) {
                                err = 1;
                                goto cleanup;
                            }
                            
                            struct memblock mem_316443;
                            
                            mem_316443.references = NULL;
                            if (memblock_alloc(ctx, &mem_316443, bytes_313142,
                                               "mem_316443")) {
                                err = 1;
                                goto cleanup;
                            }
                            
                            int64_t binop_y_316223 = (int64_t) 8 * q_t_292679;
                            int64_t bytes_316224 = smax64((int64_t) 0,
                                                          binop_y_316223);
                            int64_t flat_tid_309009 = (int64_t) 0;
                            int32_t num_tasks_334852;
                            int64_t flat_tid_309148 = (int64_t) 0;
                            struct futhark_mc_task_338986
                            futhark_mc_task_338986;
                            
                            futhark_mc_task_338986.ctx = ctx;
                            futhark_mc_task_338986.free_n_292675 = n_292675;
                            futhark_mc_task_338986.free_q_t_292679 = q_t_292679;
                            futhark_mc_task_338986.free_jump_t_292685 =
                                jump_t_292685;
                            futhark_mc_task_338986.free_partition_sizze_292766 =
                                partition_sizze_292766;
                            futhark_mc_task_338986.free_t_n_m_292839 =
                                t_n_m_292839;
                            futhark_mc_task_338986.free_i_292846 = i_292846;
                            futhark_mc_task_338986.free_mem_312593 = mem_312593;
                            futhark_mc_task_338986.free_bytes_312598 =
                                bytes_312598;
                            futhark_mc_task_338986.free_mem_312636 = mem_312636;
                            futhark_mc_task_338986.free_mem_312639 = mem_312639;
                            futhark_mc_task_338986.free_bytes_313090 =
                                bytes_313090;
                            futhark_mc_task_338986.free_mem_313143 = mem_313143;
                            futhark_mc_task_338986.free_mem_313147 = mem_313147;
                            futhark_mc_task_338986.free_ctx_param_ext_313174 =
                                ctx_param_ext_313174;
                            futhark_mc_task_338986.free_ctx_param_ext_313175 =
                                ctx_param_ext_313175;
                            futhark_mc_task_338986.free_ctx_param_ext_313177 =
                                ctx_param_ext_313177;
                            futhark_mc_task_338986.free_mem_param_313179 =
                                mem_param_313179.mem;
                            futhark_mc_task_338986.free_mem_315656 =
                                mem_315656.mem;
                            futhark_mc_task_338986.free_bytes_316224 =
                                bytes_316224;
                            futhark_mc_task_338986.free_mem_316439 =
                                mem_316439.mem;
                            futhark_mc_task_338986.free_mem_316443 =
                                mem_316443.mem;
                            
                            struct scheduler_segop futhark_mc_task_338986_task;
                            
                            futhark_mc_task_338986_task.args =
                                &futhark_mc_task_338986;
                            futhark_mc_task_338986_task.top_level_fn =
                                futhark_mc_segmap_task_338987;
                            futhark_mc_task_338986_task.name =
                                "futhark_mc_segmap_task_338987";
                            futhark_mc_task_338986_task.iterations =
                                partition_sizze_292766;
                            futhark_mc_task_338986_task.task_time =
                                &ctx->futhark_mc_segmap_task_338987_total_time;
                            futhark_mc_task_338986_task.task_iter =
                                &ctx->futhark_mc_segmap_task_338987_total_iter;
                            futhark_mc_task_338986_task.sched = STATIC;
                            futhark_mc_task_338986_task.nested_fn =
                                futhark_mc_segmap_nested_task_338999;
                            
                            int futhark_mc_segmap_task_338987_err =
                                scheduler_prepare_task(&ctx->scheduler,
                                                       &futhark_mc_task_338986_task);
                            
                            if (futhark_mc_segmap_task_338987_err != 0) {
                                if (memblock_unref(ctx, &mem_316443,
                                                   "mem_316443") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_316439,
                                                   "mem_316439") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_316444,
                                                   "ext_mem_316444") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_316445,
                                                   "ext_mem_316445") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_316446,
                                                   "ext_mem_316446") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_316447,
                                                   "ext_mem_316447") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_316728,
                                                   "ext_mem_316728") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_316729,
                                                   "ext_mem_316729") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_316730,
                                                   "ext_mem_316730") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_316731,
                                                   "ext_mem_316731") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_315656,
                                                   "mem_315656") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_315633,
                                                   "ext_mem_315633") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_315609,
                                                   "ext_mem_315609") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_315610,
                                                   "ext_mem_315610") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_314923,
                                                   "ext_mem_314923") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_314847,
                                                   "ext_mem_314847") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_314848,
                                                   "ext_mem_314848") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_param_313201,
                                                   "mem_param_313201") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_param_313193,
                                                   "mem_param_313193") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_316760,
                                                   "ext_mem_316760") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_316761,
                                                   "ext_mem_316761") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_param_313179,
                                                   "mem_param_313179") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_param_313171,
                                                   "mem_param_313171") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_param_313163,
                                                   "mem_param_313163") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_317010,
                                                   "ext_mem_317010") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_317011,
                                                   "ext_mem_317011") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_317012,
                                                   "ext_mem_317012") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_313155,
                                                   "mem_313155") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_313151,
                                                   "mem_313151") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_out_317163,
                                                   "mem_out_317163") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_out_317162,
                                                   "mem_out_317162") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_out_317161,
                                                   "mem_out_317161") != 0)
                                    return 1;
                                ;
                                err = futhark_mc_segmap_task_338987_err;
                                goto cleanup;
                            }
                            if (memblock_set(ctx, &ext_mem_316445, &mem_316439,
                                             "mem_316439") != 0)
                                return 1;
                            if (memblock_set(ctx, &ext_mem_316444, &mem_316443,
                                             "mem_316443") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_316443,
                                               "mem_316443") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_316439,
                                               "mem_316439") != 0)
                                return 1;
                        }
                        if (memblock_set(ctx, &ext_mem_316447, &ext_mem_316445,
                                         "ext_mem_316445") != 0)
                            return 1;
                        if (memblock_set(ctx, &ext_mem_316446, &ext_mem_316444,
                                         "ext_mem_316444") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_316444,
                                           "ext_mem_316444") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_316445,
                                           "ext_mem_316445") != 0)
                            return 1;
                    }
                    if (memblock_set(ctx, &ext_mem_316729, &ext_mem_316447,
                                     "ext_mem_316447") != 0)
                        return 1;
                    if (memblock_set(ctx, &ext_mem_316728, &ext_mem_316446,
                                     "ext_mem_316446") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316446,
                                       "ext_mem_316446") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316447,
                                       "ext_mem_316447") != 0)
                        return 1;
                } else {
                    bool match_lit_296577 = (int64_t) 0 == d_t_292682;
                    struct memblock ext_mem_316727;
                    
                    ext_mem_316727.references = NULL;
                    
                    struct memblock ext_mem_316726;
                    
                    ext_mem_316726.references = NULL;
                    if (match_lit_296577) {
                        struct memblock mem_316451;
                        
                        mem_316451.references = NULL;
                        if (memblock_alloc(ctx, &mem_316451, bytes_313142,
                                           "mem_316451")) {
                            err = 1;
                            goto cleanup;
                        }
                        for (int64_t i_335517 = 0; i_335517 <
                             partition_sizze_292766; i_335517++) {
                            for (int64_t i_335518 = 0; i_335518 < t_n_m_292839;
                                 i_335518++) {
                                ((double *) mem_316451.mem)[i_335517 *
                                                            t_n_m_292839 +
                                                            i_335518] = 0.0;
                            }
                        }
                        
                        struct memblock mem_316527;
                        
                        mem_316527.references = NULL;
                        if (memblock_alloc(ctx, &mem_316527, bytes_313142,
                                           "mem_316527")) {
                            err = 1;
                            goto cleanup;
                        }
                        
                        int64_t flat_tid_309418 = (int64_t) 0;
                        int32_t num_tasks_335519;
                        int64_t flat_tid_309499 = (int64_t) 0;
                        struct futhark_mc_task_339049 futhark_mc_task_339049;
                        
                        futhark_mc_task_339049.ctx = ctx;
                        futhark_mc_task_339049.free_n_292675 = n_292675;
                        futhark_mc_task_339049.free_q_t_292679 = q_t_292679;
                        futhark_mc_task_339049.free_jump_t_292685 =
                            jump_t_292685;
                        futhark_mc_task_339049.free_partition_sizze_292766 =
                            partition_sizze_292766;
                        futhark_mc_task_339049.free_t_n_m_292839 = t_n_m_292839;
                        futhark_mc_task_339049.free_i_292846 = i_292846;
                        futhark_mc_task_339049.free_mem_312593 = mem_312593;
                        futhark_mc_task_339049.free_bytes_312598 = bytes_312598;
                        futhark_mc_task_339049.free_mem_312636 = mem_312636;
                        futhark_mc_task_339049.free_mem_312639 = mem_312639;
                        futhark_mc_task_339049.free_bytes_313090 = bytes_313090;
                        futhark_mc_task_339049.free_mem_313143 = mem_313143;
                        futhark_mc_task_339049.free_mem_313147 = mem_313147;
                        futhark_mc_task_339049.free_ctx_param_ext_313174 =
                            ctx_param_ext_313174;
                        futhark_mc_task_339049.free_ctx_param_ext_313175 =
                            ctx_param_ext_313175;
                        futhark_mc_task_339049.free_ctx_param_ext_313177 =
                            ctx_param_ext_313177;
                        futhark_mc_task_339049.free_mem_param_313179 =
                            mem_param_313179.mem;
                        futhark_mc_task_339049.free_mem_315656 = mem_315656.mem;
                        futhark_mc_task_339049.free_mem_316527 = mem_316527.mem;
                        
                        struct scheduler_segop futhark_mc_task_339049_task;
                        
                        futhark_mc_task_339049_task.args =
                            &futhark_mc_task_339049;
                        futhark_mc_task_339049_task.top_level_fn =
                            futhark_mc_segmap_task_339050;
                        futhark_mc_task_339049_task.name =
                            "futhark_mc_segmap_task_339050";
                        futhark_mc_task_339049_task.iterations =
                            partition_sizze_292766;
                        futhark_mc_task_339049_task.task_time =
                            &ctx->futhark_mc_segmap_task_339050_total_time;
                        futhark_mc_task_339049_task.task_iter =
                            &ctx->futhark_mc_segmap_task_339050_total_iter;
                        futhark_mc_task_339049_task.sched = STATIC;
                        futhark_mc_task_339049_task.nested_fn =
                            futhark_mc_segmap_nested_task_339057;
                        
                        int futhark_mc_segmap_task_339050_err =
                            scheduler_prepare_task(&ctx->scheduler,
                                                   &futhark_mc_task_339049_task);
                        
                        if (futhark_mc_segmap_task_339050_err != 0) {
                            if (memblock_unref(ctx, &mem_316527,
                                               "mem_316527") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_316451,
                                               "mem_316451") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_316726,
                                               "ext_mem_316726") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_316727,
                                               "ext_mem_316727") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_316728,
                                               "ext_mem_316728") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_316729,
                                               "ext_mem_316729") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_316730,
                                               "ext_mem_316730") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_316731,
                                               "ext_mem_316731") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_315656,
                                               "mem_315656") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_315633,
                                               "ext_mem_315633") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_315609,
                                               "ext_mem_315609") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_315610,
                                               "ext_mem_315610") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_314923,
                                               "ext_mem_314923") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_314847,
                                               "ext_mem_314847") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_314848,
                                               "ext_mem_314848") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_313201,
                                               "mem_param_313201") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_313193,
                                               "mem_param_313193") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_316760,
                                               "ext_mem_316760") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_316761,
                                               "ext_mem_316761") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_313179,
                                               "mem_param_313179") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_313171,
                                               "mem_param_313171") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_param_313163,
                                               "mem_param_313163") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_317010,
                                               "ext_mem_317010") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_317011,
                                               "ext_mem_317011") != 0)
                                return 1;
                            if (memblock_unref(ctx, &ext_mem_317012,
                                               "ext_mem_317012") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_313155,
                                               "mem_313155") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_313151,
                                               "mem_313151") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_317163,
                                               "mem_out_317163") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_317162,
                                               "mem_out_317162") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_out_317161,
                                               "mem_out_317161") != 0)
                                return 1;
                            ;
                            err = futhark_mc_segmap_task_339050_err;
                            goto cleanup;
                        }
                        if (memblock_set(ctx, &ext_mem_316727, &mem_316527,
                                         "mem_316527") != 0)
                            return 1;
                        if (memblock_set(ctx, &ext_mem_316726, &mem_316451,
                                         "mem_316451") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_316527, "mem_316527") != 0)
                            return 1;
                        if (memblock_unref(ctx, &mem_316451, "mem_316451") != 0)
                            return 1;
                    } else {
                        bool match_lit_296673 = (int64_t) 1 == d_t_292682;
                        struct memblock ext_mem_316725;
                        
                        ext_mem_316725.references = NULL;
                        
                        struct memblock ext_mem_316724;
                        
                        ext_mem_316724.references = NULL;
                        if (match_lit_296673) {
                            struct memblock mem_316621;
                            
                            mem_316621.references = NULL;
                            if (memblock_alloc(ctx, &mem_316621, bytes_313142,
                                               "mem_316621")) {
                                err = 1;
                                goto cleanup;
                            }
                            
                            struct memblock mem_316625;
                            
                            mem_316625.references = NULL;
                            if (memblock_alloc(ctx, &mem_316625, bytes_313142,
                                               "mem_316625")) {
                                err = 1;
                                goto cleanup;
                            }
                            
                            int64_t flat_tid_309658 = (int64_t) 0;
                            int32_t num_tasks_335896;
                            int64_t flat_tid_309769 = (int64_t) 0;
                            struct futhark_mc_task_339089
                            futhark_mc_task_339089;
                            
                            futhark_mc_task_339089.ctx = ctx;
                            futhark_mc_task_339089.free_n_292675 = n_292675;
                            futhark_mc_task_339089.free_q_t_292679 = q_t_292679;
                            futhark_mc_task_339089.free_jump_t_292685 =
                                jump_t_292685;
                            futhark_mc_task_339089.free_partition_sizze_292766 =
                                partition_sizze_292766;
                            futhark_mc_task_339089.free_t_n_m_292839 =
                                t_n_m_292839;
                            futhark_mc_task_339089.free_i_292846 = i_292846;
                            futhark_mc_task_339089.free_mem_312593 = mem_312593;
                            futhark_mc_task_339089.free_bytes_312598 =
                                bytes_312598;
                            futhark_mc_task_339089.free_mem_312636 = mem_312636;
                            futhark_mc_task_339089.free_mem_312639 = mem_312639;
                            futhark_mc_task_339089.free_bytes_313090 =
                                bytes_313090;
                            futhark_mc_task_339089.free_mem_313143 = mem_313143;
                            futhark_mc_task_339089.free_mem_313147 = mem_313147;
                            futhark_mc_task_339089.free_ctx_param_ext_313174 =
                                ctx_param_ext_313174;
                            futhark_mc_task_339089.free_ctx_param_ext_313175 =
                                ctx_param_ext_313175;
                            futhark_mc_task_339089.free_ctx_param_ext_313177 =
                                ctx_param_ext_313177;
                            futhark_mc_task_339089.free_mem_param_313179 =
                                mem_param_313179.mem;
                            futhark_mc_task_339089.free_mem_315656 =
                                mem_315656.mem;
                            futhark_mc_task_339089.free_mem_316621 =
                                mem_316621.mem;
                            futhark_mc_task_339089.free_mem_316625 =
                                mem_316625.mem;
                            
                            struct scheduler_segop futhark_mc_task_339089_task;
                            
                            futhark_mc_task_339089_task.args =
                                &futhark_mc_task_339089;
                            futhark_mc_task_339089_task.top_level_fn =
                                futhark_mc_segmap_task_339090;
                            futhark_mc_task_339089_task.name =
                                "futhark_mc_segmap_task_339090";
                            futhark_mc_task_339089_task.iterations =
                                partition_sizze_292766;
                            futhark_mc_task_339089_task.task_time =
                                &ctx->futhark_mc_segmap_task_339090_total_time;
                            futhark_mc_task_339089_task.task_iter =
                                &ctx->futhark_mc_segmap_task_339090_total_iter;
                            futhark_mc_task_339089_task.sched = STATIC;
                            futhark_mc_task_339089_task.nested_fn =
                                futhark_mc_segmap_nested_task_339098;
                            
                            int futhark_mc_segmap_task_339090_err =
                                scheduler_prepare_task(&ctx->scheduler,
                                                       &futhark_mc_task_339089_task);
                            
                            if (futhark_mc_segmap_task_339090_err != 0) {
                                if (memblock_unref(ctx, &mem_316625,
                                                   "mem_316625") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_316621,
                                                   "mem_316621") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_316724,
                                                   "ext_mem_316724") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_316725,
                                                   "ext_mem_316725") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_316726,
                                                   "ext_mem_316726") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_316727,
                                                   "ext_mem_316727") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_316728,
                                                   "ext_mem_316728") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_316729,
                                                   "ext_mem_316729") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_316730,
                                                   "ext_mem_316730") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_316731,
                                                   "ext_mem_316731") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_315656,
                                                   "mem_315656") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_315633,
                                                   "ext_mem_315633") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_315609,
                                                   "ext_mem_315609") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_315610,
                                                   "ext_mem_315610") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_314923,
                                                   "ext_mem_314923") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_314847,
                                                   "ext_mem_314847") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_314848,
                                                   "ext_mem_314848") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_param_313201,
                                                   "mem_param_313201") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_param_313193,
                                                   "mem_param_313193") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_316760,
                                                   "ext_mem_316760") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_316761,
                                                   "ext_mem_316761") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_param_313179,
                                                   "mem_param_313179") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_param_313171,
                                                   "mem_param_313171") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_param_313163,
                                                   "mem_param_313163") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_317010,
                                                   "ext_mem_317010") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_317011,
                                                   "ext_mem_317011") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_317012,
                                                   "ext_mem_317012") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_313155,
                                                   "mem_313155") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_313151,
                                                   "mem_313151") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_out_317163,
                                                   "mem_out_317163") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_out_317162,
                                                   "mem_out_317162") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_out_317161,
                                                   "mem_out_317161") != 0)
                                    return 1;
                                ;
                                err = futhark_mc_segmap_task_339090_err;
                                goto cleanup;
                            }
                            if (memblock_set(ctx, &ext_mem_316725, &mem_316621,
                                             "mem_316621") != 0)
                                return 1;
                            if (memblock_set(ctx, &ext_mem_316724, &mem_316625,
                                             "mem_316625") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_316625,
                                               "mem_316625") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_316621,
                                               "mem_316621") != 0)
                                return 1;
                        } else {
                            struct memblock mem_316719;
                            
                            mem_316719.references = NULL;
                            if (memblock_alloc(ctx, &mem_316719, bytes_313142,
                                               "mem_316719")) {
                                err = 1;
                                goto cleanup;
                            }
                            
                            struct memblock mem_316723;
                            
                            mem_316723.references = NULL;
                            if (memblock_alloc(ctx, &mem_316723, bytes_313142,
                                               "mem_316723")) {
                                err = 1;
                                goto cleanup;
                            }
                            
                            int64_t flat_tid_309989 = (int64_t) 0;
                            int32_t num_tasks_336417;
                            int64_t flat_tid_310134 = (int64_t) 0;
                            struct futhark_mc_task_339134
                            futhark_mc_task_339134;
                            
                            futhark_mc_task_339134.ctx = ctx;
                            futhark_mc_task_339134.free_n_292675 = n_292675;
                            futhark_mc_task_339134.free_q_t_292679 = q_t_292679;
                            futhark_mc_task_339134.free_jump_t_292685 =
                                jump_t_292685;
                            futhark_mc_task_339134.free_partition_sizze_292766 =
                                partition_sizze_292766;
                            futhark_mc_task_339134.free_t_n_m_292839 =
                                t_n_m_292839;
                            futhark_mc_task_339134.free_i_292846 = i_292846;
                            futhark_mc_task_339134.free_mem_312593 = mem_312593;
                            futhark_mc_task_339134.free_bytes_312598 =
                                bytes_312598;
                            futhark_mc_task_339134.free_mem_312636 = mem_312636;
                            futhark_mc_task_339134.free_mem_312639 = mem_312639;
                            futhark_mc_task_339134.free_bytes_313090 =
                                bytes_313090;
                            futhark_mc_task_339134.free_mem_313143 = mem_313143;
                            futhark_mc_task_339134.free_mem_313147 = mem_313147;
                            futhark_mc_task_339134.free_ctx_param_ext_313174 =
                                ctx_param_ext_313174;
                            futhark_mc_task_339134.free_ctx_param_ext_313175 =
                                ctx_param_ext_313175;
                            futhark_mc_task_339134.free_ctx_param_ext_313177 =
                                ctx_param_ext_313177;
                            futhark_mc_task_339134.free_mem_param_313179 =
                                mem_param_313179.mem;
                            futhark_mc_task_339134.free_mem_315656 =
                                mem_315656.mem;
                            futhark_mc_task_339134.free_mem_316719 =
                                mem_316719.mem;
                            futhark_mc_task_339134.free_mem_316723 =
                                mem_316723.mem;
                            
                            struct scheduler_segop futhark_mc_task_339134_task;
                            
                            futhark_mc_task_339134_task.args =
                                &futhark_mc_task_339134;
                            futhark_mc_task_339134_task.top_level_fn =
                                futhark_mc_segmap_task_339135;
                            futhark_mc_task_339134_task.name =
                                "futhark_mc_segmap_task_339135";
                            futhark_mc_task_339134_task.iterations =
                                partition_sizze_292766;
                            futhark_mc_task_339134_task.task_time =
                                &ctx->futhark_mc_segmap_task_339135_total_time;
                            futhark_mc_task_339134_task.task_iter =
                                &ctx->futhark_mc_segmap_task_339135_total_iter;
                            futhark_mc_task_339134_task.sched = STATIC;
                            futhark_mc_task_339134_task.nested_fn =
                                futhark_mc_segmap_nested_task_339143;
                            
                            int futhark_mc_segmap_task_339135_err =
                                scheduler_prepare_task(&ctx->scheduler,
                                                       &futhark_mc_task_339134_task);
                            
                            if (futhark_mc_segmap_task_339135_err != 0) {
                                if (memblock_unref(ctx, &mem_316723,
                                                   "mem_316723") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_316719,
                                                   "mem_316719") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_316724,
                                                   "ext_mem_316724") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_316725,
                                                   "ext_mem_316725") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_316726,
                                                   "ext_mem_316726") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_316727,
                                                   "ext_mem_316727") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_316728,
                                                   "ext_mem_316728") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_316729,
                                                   "ext_mem_316729") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_316730,
                                                   "ext_mem_316730") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_316731,
                                                   "ext_mem_316731") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_315656,
                                                   "mem_315656") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_315633,
                                                   "ext_mem_315633") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_315609,
                                                   "ext_mem_315609") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_315610,
                                                   "ext_mem_315610") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_314923,
                                                   "ext_mem_314923") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_314847,
                                                   "ext_mem_314847") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_314848,
                                                   "ext_mem_314848") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_param_313201,
                                                   "mem_param_313201") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_param_313193,
                                                   "mem_param_313193") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_316760,
                                                   "ext_mem_316760") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_316761,
                                                   "ext_mem_316761") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_param_313179,
                                                   "mem_param_313179") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_param_313171,
                                                   "mem_param_313171") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_param_313163,
                                                   "mem_param_313163") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_317010,
                                                   "ext_mem_317010") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_317011,
                                                   "ext_mem_317011") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &ext_mem_317012,
                                                   "ext_mem_317012") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_313155,
                                                   "mem_313155") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_313151,
                                                   "mem_313151") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_out_317163,
                                                   "mem_out_317163") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_out_317162,
                                                   "mem_out_317162") != 0)
                                    return 1;
                                if (memblock_unref(ctx, &mem_out_317161,
                                                   "mem_out_317161") != 0)
                                    return 1;
                                ;
                                err = futhark_mc_segmap_task_339135_err;
                                goto cleanup;
                            }
                            if (memblock_set(ctx, &ext_mem_316725, &mem_316719,
                                             "mem_316719") != 0)
                                return 1;
                            if (memblock_set(ctx, &ext_mem_316724, &mem_316723,
                                             "mem_316723") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_316723,
                                               "mem_316723") != 0)
                                return 1;
                            if (memblock_unref(ctx, &mem_316719,
                                               "mem_316719") != 0)
                                return 1;
                        }
                        if (memblock_set(ctx, &ext_mem_316727, &ext_mem_316725,
                                         "ext_mem_316725") != 0)
                            return 1;
                        if (memblock_set(ctx, &ext_mem_316726, &ext_mem_316724,
                                         "ext_mem_316724") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_316724,
                                           "ext_mem_316724") != 0)
                            return 1;
                        if (memblock_unref(ctx, &ext_mem_316725,
                                           "ext_mem_316725") != 0)
                            return 1;
                    }
                    if (memblock_set(ctx, &ext_mem_316729, &ext_mem_316727,
                                     "ext_mem_316727") != 0)
                        return 1;
                    if (memblock_set(ctx, &ext_mem_316728, &ext_mem_316726,
                                     "ext_mem_316726") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316726,
                                       "ext_mem_316726") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316727,
                                       "ext_mem_316727") != 0)
                        return 1;
                }
                if (memblock_set(ctx, &ext_mem_316731, &ext_mem_316729,
                                 "ext_mem_316729") != 0)
                    return 1;
                if (memblock_set(ctx, &ext_mem_316730, &ext_mem_316728,
                                 "ext_mem_316728") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_316728, "ext_mem_316728") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_316729, "ext_mem_316729") != 0)
                    return 1;
            }
            
            struct memblock ext_mem_316754;
            
            ext_mem_316754.references = NULL;
            if (cond_293286) {
                bool zzero_296959 = jump_t_292685 == (int64_t) 0;
                bool nonzzero_296960 = !zzero_296959;
                bool nonzzero_cert_296961;
                
                if (!nonzzero_296960) {
                    ctx->error = msgprintf("Error: %s\n\nBacktrace:\n%s",
                                           "division by zero",
                                           "-> #0  loess.fut:742:20-27\n   #1  /prelude/soacs.fut:59:3-10\n   #2  /prelude/array.fut:195:3-17\n   #3  utils.fut:6:3-16\n   #4  loess.fut:741:3-745:9\n   #5  stl.fut:310:23-75\n   #6  /prelude/soacs.fut:67:19-23\n   #7  /prelude/soacs.fut:67:3-37\n   #8  stl.fut:309:15-311:43\n   #9  stl.fut:419:61-435:77\n   #10 stl.fut:463:3-479:36\n   #11 stl.fut:445:1-479:36\n");
                    if (memblock_unref(ctx, &ext_mem_316754,
                                       "ext_mem_316754") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316730,
                                       "ext_mem_316730") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316731,
                                       "ext_mem_316731") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_315656, "mem_315656") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_315633,
                                       "ext_mem_315633") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_315609,
                                       "ext_mem_315609") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_315610,
                                       "ext_mem_315610") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_314923,
                                       "ext_mem_314923") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_314847,
                                       "ext_mem_314847") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_314848,
                                       "ext_mem_314848") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_313201,
                                       "mem_param_313201") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_313193,
                                       "mem_param_313193") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316760,
                                       "ext_mem_316760") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316761,
                                       "ext_mem_316761") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_313179,
                                       "mem_param_313179") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_313171,
                                       "mem_param_313171") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_313163,
                                       "mem_param_313163") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_317010,
                                       "ext_mem_317010") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_317011,
                                       "ext_mem_317011") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_317012,
                                       "ext_mem_317012") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_313155, "mem_313155") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_313151, "mem_313151") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_317163,
                                       "mem_out_317163") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_317162,
                                       "mem_out_317162") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_317161,
                                       "mem_out_317161") != 0)
                        return 1;
                    err = FUTHARK_PROGRAM_ERROR;
                    goto cleanup;
                }
                
                int64_t y_296962 = sub64(t_n_m_292839, (int64_t) 1);
                struct memblock mem_316753;
                
                mem_316753.references = NULL;
                if (memblock_alloc(ctx, &mem_316753, bytes_312635,
                                   "mem_316753")) {
                    err = 1;
                    goto cleanup;
                }
                
                int64_t flat_tid_310422 = (int64_t) 0;
                int32_t num_tasks_337076;
                int64_t flat_tid_310428 = (int64_t) 0;
                struct futhark_mc_task_339181 futhark_mc_task_339181;
                
                futhark_mc_task_339181.ctx = ctx;
                futhark_mc_task_339181.free_n_292675 = n_292675;
                futhark_mc_task_339181.free_jump_t_292685 = jump_t_292685;
                futhark_mc_task_339181.free_partition_sizze_292766 =
                    partition_sizze_292766;
                futhark_mc_task_339181.free_t_n_m_292839 = t_n_m_292839;
                futhark_mc_task_339181.free_i_292846 = i_292846;
                futhark_mc_task_339181.free_y_296962 = y_296962;
                futhark_mc_task_339181.free_bytes_312598 = bytes_312598;
                futhark_mc_task_339181.free_ext_mem_316730 = ext_mem_316730.mem;
                futhark_mc_task_339181.free_ext_mem_316731 = ext_mem_316731.mem;
                futhark_mc_task_339181.free_mem_316753 = mem_316753.mem;
                
                struct scheduler_segop futhark_mc_task_339181_task;
                
                futhark_mc_task_339181_task.args = &futhark_mc_task_339181;
                futhark_mc_task_339181_task.top_level_fn =
                    futhark_mc_segmap_task_339182;
                futhark_mc_task_339181_task.name =
                    "futhark_mc_segmap_task_339182";
                futhark_mc_task_339181_task.iterations = partition_sizze_292766;
                futhark_mc_task_339181_task.task_time =
                    &ctx->futhark_mc_segmap_task_339182_total_time;
                futhark_mc_task_339181_task.task_iter =
                    &ctx->futhark_mc_segmap_task_339182_total_iter;
                futhark_mc_task_339181_task.sched = STATIC;
                futhark_mc_task_339181_task.nested_fn =
                    futhark_mc_segmap_nested_task_339186;
                
                int futhark_mc_segmap_task_339182_err =
                    scheduler_prepare_task(&ctx->scheduler,
                                           &futhark_mc_task_339181_task);
                
                if (futhark_mc_segmap_task_339182_err != 0) {
                    if (memblock_unref(ctx, &mem_316753, "mem_316753") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316754,
                                       "ext_mem_316754") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316730,
                                       "ext_mem_316730") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316731,
                                       "ext_mem_316731") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_315656, "mem_315656") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_315633,
                                       "ext_mem_315633") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_315609,
                                       "ext_mem_315609") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_315610,
                                       "ext_mem_315610") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_314923,
                                       "ext_mem_314923") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_314847,
                                       "ext_mem_314847") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_314848,
                                       "ext_mem_314848") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_313201,
                                       "mem_param_313201") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_313193,
                                       "mem_param_313193") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316760,
                                       "ext_mem_316760") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316761,
                                       "ext_mem_316761") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_313179,
                                       "mem_param_313179") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_313171,
                                       "mem_param_313171") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_313163,
                                       "mem_param_313163") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_317010,
                                       "ext_mem_317010") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_317011,
                                       "ext_mem_317011") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_317012,
                                       "ext_mem_317012") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_313155, "mem_313155") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_313151, "mem_313151") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_317163,
                                       "mem_out_317163") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_317162,
                                       "mem_out_317162") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_317161,
                                       "mem_out_317161") != 0)
                        return 1;
                    ;
                    err = futhark_mc_segmap_task_339182_err;
                    goto cleanup;
                }
                if (memblock_set(ctx, &ext_mem_316754, &mem_316753,
                                 "mem_316753") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_316753, "mem_316753") != 0)
                    return 1;
            } else {
                bool dim_match_297015 = n_292675 == t_n_m_292839;
                bool empty_or_match_cert_297016;
                
                if (!dim_match_297015) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Value of (core language) shape (",
                                  (long long) partition_sizze_292766, ", ",
                                  (long long) t_n_m_292839,
                                  ") cannot match shape of type `[",
                                  (long long) partition_sizze_292766, "][",
                                  (long long) n_292675, "]t`.",
                                  "-> #0  stl.fut:313:15-36\n   #1  stl.fut:419:61-435:77\n   #2  stl.fut:463:3-479:36\n   #3  stl.fut:445:1-479:36\n");
                    if (memblock_unref(ctx, &ext_mem_316754,
                                       "ext_mem_316754") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316730,
                                       "ext_mem_316730") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316731,
                                       "ext_mem_316731") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_315656, "mem_315656") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_315633,
                                       "ext_mem_315633") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_315609,
                                       "ext_mem_315609") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_315610,
                                       "ext_mem_315610") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_314923,
                                       "ext_mem_314923") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_314847,
                                       "ext_mem_314847") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_314848,
                                       "ext_mem_314848") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_313201,
                                       "mem_param_313201") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_313193,
                                       "mem_param_313193") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316760,
                                       "ext_mem_316760") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316761,
                                       "ext_mem_316761") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_313179,
                                       "mem_param_313179") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_313171,
                                       "mem_param_313171") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_313163,
                                       "mem_param_313163") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_317010,
                                       "ext_mem_317010") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_317011,
                                       "ext_mem_317011") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_317012,
                                       "ext_mem_317012") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_313155, "mem_313155") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_313151, "mem_313151") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_317163,
                                       "mem_out_317163") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_317162,
                                       "mem_out_317162") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_317161,
                                       "mem_out_317161") != 0)
                        return 1;
                    err = FUTHARK_PROGRAM_ERROR;
                    goto cleanup;
                }
                if (memblock_set(ctx, &ext_mem_316754, &ext_mem_316731,
                                 "ext_mem_316731") != 0)
                    return 1;
            }
            if (memblock_unref(ctx, &ext_mem_316730, "ext_mem_316730") != 0)
                return 1;
            if (memblock_unref(ctx, &ext_mem_316731, "ext_mem_316731") != 0)
                return 1;
            
            int64_t ctx_param_ext_tmp_318886 = ext_316755;
            int64_t ctx_param_ext_tmp_318887 = ext_316755;
            struct memblock mem_param_tmp_318888;
            
            mem_param_tmp_318888.references = NULL;
            if (memblock_set(ctx, &mem_param_tmp_318888, &mem_315656,
                             "mem_315656") != 0)
                return 1;
            
            struct memblock mem_param_tmp_318889;
            
            mem_param_tmp_318889.references = NULL;
            if (memblock_set(ctx, &mem_param_tmp_318889, &ext_mem_316754,
                             "ext_mem_316754") != 0)
                return 1;
            ctx_param_ext_313195 = ctx_param_ext_tmp_318886;
            ctx_param_ext_313197 = ctx_param_ext_tmp_318887;
            if (memblock_set(ctx, &mem_param_313193, &mem_param_tmp_318888,
                             "mem_param_tmp_318888") != 0)
                return 1;
            if (memblock_set(ctx, &mem_param_313201, &mem_param_tmp_318889,
                             "mem_param_tmp_318889") != 0)
                return 1;
            if (memblock_unref(ctx, &mem_param_tmp_318889,
                               "mem_param_tmp_318889") != 0)
                return 1;
            if (memblock_unref(ctx, &mem_param_tmp_318888,
                               "mem_param_tmp_318888") != 0)
                return 1;
            if (memblock_unref(ctx, &ext_mem_316754, "ext_mem_316754") != 0)
                return 1;
            if (memblock_unref(ctx, &ext_mem_316730, "ext_mem_316730") != 0)
                return 1;
            if (memblock_unref(ctx, &ext_mem_316731, "ext_mem_316731") != 0)
                return 1;
            if (memblock_unref(ctx, &mem_315656, "mem_315656") != 0)
                return 1;
            if (memblock_unref(ctx, &ext_mem_315633, "ext_mem_315633") != 0)
                return 1;
            if (memblock_unref(ctx, &ext_mem_315609, "ext_mem_315609") != 0)
                return 1;
            if (memblock_unref(ctx, &ext_mem_315610, "ext_mem_315610") != 0)
                return 1;
            if (memblock_unref(ctx, &ext_mem_314923, "ext_mem_314923") != 0)
                return 1;
            if (memblock_unref(ctx, &ext_mem_314847, "ext_mem_314847") != 0)
                return 1;
            if (memblock_unref(ctx, &ext_mem_314848, "ext_mem_314848") != 0)
                return 1;
        }
        ext_316767 = ctx_param_ext_313195;
        ext_316765 = ctx_param_ext_313197;
        if (memblock_set(ctx, &ext_mem_316761, &mem_param_313193,
                         "mem_param_313193") != 0)
            return 1;
        if (memblock_set(ctx, &ext_mem_316760, &mem_param_313201,
                         "mem_param_313201") != 0)
            return 1;
        
        bool cond_297018 = slt64(i_outer_293375, y_293287);
        int64_t ext_317009;
        
        if (cond_297018) {
            ext_317009 = partition_sizze_292766;
        } else {
            ext_317009 = ctx_param_ext_313176;
        }
        
        int64_t ext_317008;
        
        if (cond_297018) {
            ext_317008 = n_292675;
        } else {
            ext_317008 = ctx_param_ext_313178;
        }
        
        int64_t ext_317007;
        
        if (cond_297018) {
            ext_317007 = partition_sizze_292766;
        } else {
            ext_317007 = ctx_param_ext_313172;
        }
        
        int64_t ext_317006;
        
        if (cond_297018) {
            ext_317006 = n_292675;
        } else {
            ext_317006 = ctx_param_ext_313173;
        }
        
        int64_t ext_317005;
        
        if (cond_297018) {
            ext_317005 = n_292675;
        } else {
            ext_317005 = ctx_param_ext_313175;
        }
        
        int64_t ext_317004;
        
        if (cond_297018) {
            ext_317004 = (int64_t) 1;
        } else {
            ext_317004 = ctx_param_ext_313177;
        }
        
        int64_t ext_317003;
        
        if (cond_297018) {
            ext_317003 = (int64_t) 0;
        } else {
            ext_317003 = ctx_param_ext_313174;
        }
        
        struct memblock ext_mem_317002;
        
        ext_mem_317002.references = NULL;
        if (cond_297018) {
            if (mem_316815_cached_sizze_337662 < (size_t) bytes_312635) {
                mem_316815 = realloc(mem_316815, bytes_312635);
                mem_316815_cached_sizze_337662 = bytes_312635;
            }
            if (mem_316819_cached_sizze_337663 < (size_t) bytes_312635) {
                mem_316819 = realloc(mem_316819, bytes_312635);
                mem_316819_cached_sizze_337663 = bytes_312635;
            }
            
            int64_t flat_tid_310482 = (int64_t) 0;
            int32_t num_tasks_337186;
            int64_t flat_tid_310490 = (int64_t) 0;
            struct futhark_mc_task_339194 futhark_mc_task_339194;
            
            futhark_mc_task_339194.ctx = ctx;
            futhark_mc_task_339194.free_n_292675 = n_292675;
            futhark_mc_task_339194.free_partition_sizze_292766 =
                partition_sizze_292766;
            futhark_mc_task_339194.free_mem_312593 = mem_312593;
            futhark_mc_task_339194.free_bytes_312598 = bytes_312598;
            futhark_mc_task_339194.free_mem_312636 = mem_312636;
            futhark_mc_task_339194.free_ext_mem_316760 = ext_mem_316760.mem;
            futhark_mc_task_339194.free_ext_mem_316761 = ext_mem_316761.mem;
            futhark_mc_task_339194.free_ext_316765 = ext_316765;
            futhark_mc_task_339194.free_mem_316815 = mem_316815;
            futhark_mc_task_339194.free_mem_316819 = mem_316819;
            
            struct scheduler_segop futhark_mc_task_339194_task;
            
            futhark_mc_task_339194_task.args = &futhark_mc_task_339194;
            futhark_mc_task_339194_task.top_level_fn =
                futhark_mc_segmap_task_339195;
            futhark_mc_task_339194_task.name = "futhark_mc_segmap_task_339195";
            futhark_mc_task_339194_task.iterations = partition_sizze_292766;
            futhark_mc_task_339194_task.task_time =
                &ctx->futhark_mc_segmap_task_339195_total_time;
            futhark_mc_task_339194_task.task_iter =
                &ctx->futhark_mc_segmap_task_339195_total_iter;
            futhark_mc_task_339194_task.sched = STATIC;
            futhark_mc_task_339194_task.nested_fn =
                futhark_mc_segmap_nested_task_339200;
            
            int futhark_mc_segmap_task_339195_err =
                scheduler_prepare_task(&ctx->scheduler,
                                       &futhark_mc_task_339194_task);
            
            if (futhark_mc_segmap_task_339195_err != 0) {
                if (memblock_unref(ctx, &ext_mem_317002, "ext_mem_317002") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_313201,
                                   "mem_param_313201") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_313193,
                                   "mem_param_313193") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_316760, "ext_mem_316760") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_316761, "ext_mem_316761") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_313179,
                                   "mem_param_313179") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_313171,
                                   "mem_param_313171") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_313163,
                                   "mem_param_313163") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_317010, "ext_mem_317010") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_317011, "ext_mem_317011") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_317012, "ext_mem_317012") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_313155, "mem_313155") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_313151, "mem_313151") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_out_317163, "mem_out_317163") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_out_317162, "mem_out_317162") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_out_317161, "mem_out_317161") != 0)
                    return 1;
                ;
                err = futhark_mc_segmap_task_339195_err;
                goto cleanup;
            }
            if (mem_316822_cached_sizze_337664 < (size_t) bytes_312638) {
                mem_316822 = realloc(mem_316822, bytes_312638);
                mem_316822_cached_sizze_337664 = bytes_312638;
            }
            
            int64_t flat_tid_310518 = (int64_t) 0;
            int32_t num_tasks_337250;
            int64_t flat_tid_310524 = (int64_t) 0;
            struct futhark_mc_task_339213 futhark_mc_task_339213;
            
            futhark_mc_task_339213.ctx = ctx;
            futhark_mc_task_339213.free_n_292675 = n_292675;
            futhark_mc_task_339213.free_partition_sizze_292766 =
                partition_sizze_292766;
            futhark_mc_task_339213.free_mem_316815 = mem_316815;
            futhark_mc_task_339213.free_mem_316822 = mem_316822;
            
            struct scheduler_segop futhark_mc_task_339213_task;
            
            futhark_mc_task_339213_task.args = &futhark_mc_task_339213;
            futhark_mc_task_339213_task.top_level_fn =
                futhark_mc_segmap_task_339214;
            futhark_mc_task_339213_task.name = "futhark_mc_segmap_task_339214";
            futhark_mc_task_339213_task.iterations = partition_sizze_292766;
            futhark_mc_task_339213_task.task_time =
                &ctx->futhark_mc_segmap_task_339214_total_time;
            futhark_mc_task_339213_task.task_iter =
                &ctx->futhark_mc_segmap_task_339214_total_iter;
            futhark_mc_task_339213_task.sched = STATIC;
            futhark_mc_task_339213_task.nested_fn =
                futhark_mc_segmap_nested_task_339217;
            
            int futhark_mc_segmap_task_339214_err =
                scheduler_prepare_task(&ctx->scheduler,
                                       &futhark_mc_task_339213_task);
            
            if (futhark_mc_segmap_task_339214_err != 0) {
                if (memblock_unref(ctx, &ext_mem_317002, "ext_mem_317002") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_313201,
                                   "mem_param_313201") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_313193,
                                   "mem_param_313193") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_316760, "ext_mem_316760") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_316761, "ext_mem_316761") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_313179,
                                   "mem_param_313179") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_313171,
                                   "mem_param_313171") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_313163,
                                   "mem_param_313163") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_317010, "ext_mem_317010") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_317011, "ext_mem_317011") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_317012, "ext_mem_317012") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_313155, "mem_313155") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_313151, "mem_313151") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_out_317163, "mem_out_317163") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_out_317162, "mem_out_317162") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_out_317161, "mem_out_317161") != 0)
                    return 1;
                ;
                err = futhark_mc_segmap_task_339214_err;
                goto cleanup;
            }
            
            struct memblock mem_316825;
            
            mem_316825.references = NULL;
            if (memblock_alloc(ctx, &mem_316825, bytes_316824, "mem_316825")) {
                err = 1;
                goto cleanup;
            }
            for (int64_t i_337289 = 0; i_337289 < partition_sizze_292766;
                 i_337289++) {
                ((int32_t *) mem_316825.mem)[i_337289] = i64_res_297059;
            }
            if (mem_316832_cached_sizze_337665 < (size_t) bytes_316831) {
                mem_316832 = realloc(mem_316832, bytes_316831);
                mem_316832_cached_sizze_337665 = bytes_316831;
            }
            if (mem_316835_cached_sizze_337666 < (size_t) bytes_312638) {
                mem_316835 = realloc(mem_316835, bytes_312638);
                mem_316835_cached_sizze_337666 = bytes_312638;
            }
            
            int64_t flat_tid_310540 = (int64_t) 0;
            int32_t num_tasks_337290;
            struct futhark_mc_task_339226 futhark_mc_task_339226;
            
            futhark_mc_task_339226.ctx = ctx;
            futhark_mc_task_339226.free_n_292675 = n_292675;
            futhark_mc_task_339226.free_partition_sizze_292766 =
                partition_sizze_292766;
            futhark_mc_task_339226.free_mem_312639 = mem_312639;
            futhark_mc_task_339226.free_bytes_316827 = bytes_316827;
            futhark_mc_task_339226.free_mem_316832 = mem_316832;
            futhark_mc_task_339226.free_mem_316835 = mem_316835;
            
            struct scheduler_segop futhark_mc_task_339226_task;
            
            futhark_mc_task_339226_task.args = &futhark_mc_task_339226;
            futhark_mc_task_339226_task.top_level_fn =
                futhark_mc_segmap_task_339227;
            futhark_mc_task_339226_task.name = "futhark_mc_segmap_task_339227";
            futhark_mc_task_339226_task.iterations = partition_sizze_292766;
            futhark_mc_task_339226_task.task_time =
                &ctx->futhark_mc_segmap_task_339227_total_time;
            futhark_mc_task_339226_task.task_iter =
                &ctx->futhark_mc_segmap_task_339227_total_iter;
            futhark_mc_task_339226_task.sched = STATIC;
            futhark_mc_task_339226_task.nested_fn = NULL;
            
            int futhark_mc_segmap_task_339227_err =
                scheduler_prepare_task(&ctx->scheduler,
                                       &futhark_mc_task_339226_task);
            
            if (futhark_mc_segmap_task_339227_err != 0) {
                if (memblock_unref(ctx, &mem_316825, "mem_316825") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_317002, "ext_mem_317002") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_313201,
                                   "mem_param_313201") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_313193,
                                   "mem_param_313193") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_316760, "ext_mem_316760") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_316761, "ext_mem_316761") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_313179,
                                   "mem_param_313179") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_313171,
                                   "mem_param_313171") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_313163,
                                   "mem_param_313163") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_317010, "ext_mem_317010") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_317011, "ext_mem_317011") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_317012, "ext_mem_317012") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_313155, "mem_313155") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_313151, "mem_313151") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_out_317163, "mem_out_317163") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_out_317162, "mem_out_317162") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_out_317161, "mem_out_317161") != 0)
                    return 1;
                ;
                err = futhark_mc_segmap_task_339227_err;
                goto cleanup;
            }
            
            struct memblock mem_316838;
            
            mem_316838.references = NULL;
            if (memblock_alloc(ctx, &mem_316838, bytes_312635, "mem_316838")) {
                err = 1;
                goto cleanup;
            }
            if (binop_x_312633 * (int64_t) 8 > 0)
                memmove(mem_316838.mem + (int64_t) 0, mem_316815 + (int64_t) 0,
                        binop_x_312633 * (int64_t) 8);
            
            struct memblock mem_316841;
            
            mem_316841.references = NULL;
            if (memblock_alloc(ctx, &mem_316841, bytes_316824, "mem_316841")) {
                err = 1;
                goto cleanup;
            }
            
            int64_t flat_tid_310542 = (int64_t) 0;
            int32_t num_tasks_337295;
            struct futhark_mc_task_339231 futhark_mc_task_339231;
            
            futhark_mc_task_339231.ctx = ctx;
            futhark_mc_task_339231.free_partition_sizze_292766 =
                partition_sizze_292766;
            futhark_mc_task_339231.free_mem_316835 = mem_316835;
            futhark_mc_task_339231.free_mem_316841 = mem_316841.mem;
            
            struct scheduler_segop futhark_mc_task_339231_task;
            
            futhark_mc_task_339231_task.args = &futhark_mc_task_339231;
            futhark_mc_task_339231_task.top_level_fn =
                futhark_mc_segmap_task_339232;
            futhark_mc_task_339231_task.name = "futhark_mc_segmap_task_339232";
            futhark_mc_task_339231_task.iterations = partition_sizze_292766;
            futhark_mc_task_339231_task.task_time =
                &ctx->futhark_mc_segmap_task_339232_total_time;
            futhark_mc_task_339231_task.task_iter =
                &ctx->futhark_mc_segmap_task_339232_total_iter;
            futhark_mc_task_339231_task.sched = STATIC;
            futhark_mc_task_339231_task.nested_fn = NULL;
            
            int futhark_mc_segmap_task_339232_err =
                scheduler_prepare_task(&ctx->scheduler,
                                       &futhark_mc_task_339231_task);
            
            if (futhark_mc_segmap_task_339232_err != 0) {
                if (memblock_unref(ctx, &mem_316841, "mem_316841") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_316838, "mem_316838") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_316825, "mem_316825") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_317002, "ext_mem_317002") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_313201,
                                   "mem_param_313201") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_313193,
                                   "mem_param_313193") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_316760, "ext_mem_316760") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_316761, "ext_mem_316761") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_313179,
                                   "mem_param_313179") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_313171,
                                   "mem_param_313171") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_313163,
                                   "mem_param_313163") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_317010, "ext_mem_317010") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_317011, "ext_mem_317011") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_317012, "ext_mem_317012") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_313155, "mem_313155") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_313151, "mem_313151") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_out_317163, "mem_out_317163") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_out_317162, "mem_out_317162") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_out_317161, "mem_out_317161") != 0)
                    return 1;
                ;
                err = futhark_mc_segmap_task_339232_err;
                goto cleanup;
            }
            
            struct memblock mem_316844;
            
            mem_316844.references = NULL;
            if (memblock_alloc(ctx, &mem_316844, bytes_316831, "mem_316844")) {
                err = 1;
                goto cleanup;
            }
            for (int64_t i_337299 = 0; i_337299 < binop_x_312633; i_337299++) {
                ((int32_t *) mem_316844.mem)[i_337299] = 0;
            }
            
            struct memblock mem_316847;
            
            mem_316847.references = NULL;
            if (memblock_alloc(ctx, &mem_316847, bytes_312635, "mem_316847")) {
                err = 1;
                goto cleanup;
            }
            for (int64_t i_337300 = 0; i_337300 < binop_x_312633; i_337300++) {
                ((double *) mem_316847.mem)[i_337300] = 0.0;
            }
            if (mem_316850_cached_sizze_337667 < (size_t) bytes_312638) {
                mem_316850 = realloc(mem_316850, bytes_312638);
                mem_316850_cached_sizze_337667 = bytes_312638;
            }
            for (int64_t i_337301 = 0; i_337301 < partition_sizze_292766;
                 i_337301++) {
                ((double *) mem_316850)[i_337301] = 0.0;
            }
            
            struct memblock mem_316863;
            
            mem_316863.references = NULL;
            if (memblock_alloc(ctx, &mem_316863, bytes_316831, "mem_316863")) {
                err = 1;
                goto cleanup;
            }
            if (binop_x_312633 * (int64_t) 4 > 0)
                memmove(mem_316863.mem + (int64_t) 0, mem_316832 + (int64_t) 0,
                        binop_x_312633 * (int64_t) 4);
            if (mem_316906_cached_sizze_337668 < (size_t) bytes_316824) {
                mem_316906 = realloc(mem_316906, bytes_316824);
                mem_316906_cached_sizze_337668 = bytes_316824;
            }
            if (mem_316909_cached_sizze_337669 < (size_t) bytes_312638) {
                mem_316909 = realloc(mem_316909, bytes_312638);
                mem_316909_cached_sizze_337669 = bytes_312638;
            }
            if (mem_316912_cached_sizze_337670 < (size_t) bytes_316911) {
                mem_316912 = realloc(mem_316912, bytes_316911);
                mem_316912_cached_sizze_337670 = bytes_316911;
            }
            if (mem_316915_cached_sizze_337671 < (size_t) bytes_316824) {
                mem_316915 = realloc(mem_316915, bytes_316824);
                mem_316915_cached_sizze_337671 = bytes_316824;
            }
            if (mem_316917_cached_sizze_337672 < (size_t) bytes_316916) {
                mem_316917 = realloc(mem_316917, bytes_316916);
                mem_316917_cached_sizze_337672 = bytes_316916;
            }
            if (mem_316920_cached_sizze_337673 < (size_t) bytes_316824) {
                mem_316920 = realloc(mem_316920, bytes_316824);
                mem_316920_cached_sizze_337673 = bytes_316824;
            }
            
            int64_t ext_316962;
            int64_t ext_316961;
            int64_t ext_316960;
            int64_t ext_316959;
            int64_t ext_316958;
            int64_t ext_316957;
            int64_t ext_316956;
            int64_t ext_316955;
            int64_t ext_316954;
            int64_t ext_316953;
            int64_t ext_316952;
            int64_t ext_316951;
            int64_t ext_316950;
            int64_t ext_316949;
            int64_t ext_316948;
            int64_t ext_316947;
            struct memblock ext_mem_316942;
            
            ext_mem_316942.references = NULL;
            
            struct memblock ext_mem_316941;
            
            ext_mem_316941.references = NULL;
            
            struct memblock ext_mem_316940;
            
            ext_mem_316940.references = NULL;
            
            struct memblock ext_mem_316939;
            
            ext_mem_316939.references = NULL;
            
            struct memblock ext_mem_316938;
            
            ext_mem_316938.references = NULL;
            
            struct memblock ext_mem_316937;
            
            ext_mem_316937.references = NULL;
            
            int64_t rankSearchBatch_res_297081;
            int64_t rankSearchBatch_res_297082;
            int64_t rankSearchBatch_res_297083;
            bool rankSearchBatch_res_297084;
            int64_t rankSearchBatch_res_297091;
            int64_t loopz2088U_297093;
            int64_t loopz2089U_297094;
            int64_t loopz2081Uz2080U_297095;
            bool loop_while_297096;
            int64_t q_297103;
            struct memblock mem_param_316855;
            
            mem_param_316855.references = NULL;
            
            struct memblock mem_param_316860;
            
            mem_param_316860.references = NULL;
            
            int64_t ctx_param_ext_316865;
            int64_t ctx_param_ext_316866;
            int64_t ctx_param_ext_316867;
            int64_t ctx_param_ext_316868;
            struct memblock mem_param_316869;
            
            mem_param_316869.references = NULL;
            
            int64_t ctx_param_ext_316870;
            int64_t ctx_param_ext_316871;
            int64_t ctx_param_ext_316872;
            int64_t ctx_param_ext_316873;
            struct memblock mem_param_316874;
            
            mem_param_316874.references = NULL;
            
            int64_t ctx_param_ext_316875;
            int64_t ctx_param_ext_316876;
            int64_t ctx_param_ext_316877;
            int64_t ctx_param_ext_316878;
            struct memblock mem_param_316879;
            
            mem_param_316879.references = NULL;
            
            int64_t ctx_param_ext_316880;
            int64_t ctx_param_ext_316881;
            int64_t ctx_param_ext_316882;
            int64_t ctx_param_ext_316883;
            struct memblock mem_param_316884;
            
            mem_param_316884.references = NULL;
            ctx_param_ext_316865 = binop_x_312633;
            ctx_param_ext_316866 = (int64_t) 0;
            ctx_param_ext_316867 = (int64_t) 1;
            ctx_param_ext_316868 = binop_x_312633;
            ctx_param_ext_316870 = binop_x_312633;
            ctx_param_ext_316871 = (int64_t) 0;
            ctx_param_ext_316872 = (int64_t) 1;
            ctx_param_ext_316873 = binop_x_312633;
            ctx_param_ext_316875 = binop_x_312633;
            ctx_param_ext_316876 = (int64_t) 0;
            ctx_param_ext_316877 = (int64_t) 1;
            ctx_param_ext_316878 = binop_x_312633;
            ctx_param_ext_316880 = binop_x_312633;
            ctx_param_ext_316881 = (int64_t) 0;
            ctx_param_ext_316882 = (int64_t) 1;
            ctx_param_ext_316883 = binop_x_312633;
            if (memblock_set(ctx, &mem_param_316855, &mem_316841,
                             "mem_316841") != 0)
                return 1;
            if (memblock_set(ctx, &mem_param_316860, &mem_316825,
                             "mem_316825") != 0)
                return 1;
            if (memblock_set(ctx, &mem_param_316869, &mem_316863,
                             "mem_316863") != 0)
                return 1;
            if (memblock_set(ctx, &mem_param_316874, &mem_316844,
                             "mem_316844") != 0)
                return 1;
            if (memblock_set(ctx, &mem_param_316879, &mem_316838,
                             "mem_316838") != 0)
                return 1;
            if (memblock_set(ctx, &mem_param_316884, &mem_316847,
                             "mem_316847") != 0)
                return 1;
            loopz2088U_297093 = binop_x_312633;
            loopz2089U_297094 = binop_x_312633;
            loopz2081Uz2080U_297095 = binop_x_312633;
            loop_while_297096 = loop_cond_297079;
            q_297103 = (int64_t) 0;
            while (loop_while_297096) {
                bool cond_297105 = q_297103 == (int64_t) 0;
                int64_t flat_tid_310544 = (int64_t) 0;
                int32_t num_tasks_337336;
                
                if (ctx->debugging)
                    fprintf(ctx->log, "%s\n", "nonsegmented segScan");
                
                struct futhark_mc_task_339235 futhark_mc_task_339235;
                
                futhark_mc_task_339235.ctx = ctx;
                futhark_mc_task_339235.free_partition_sizze_292766 =
                    partition_sizze_292766;
                futhark_mc_task_339235.free_mem_param_316860 =
                    mem_param_316860.mem;
                futhark_mc_task_339235.free_mem_316906 = mem_316906;
                
                struct scheduler_segop futhark_mc_task_339235_task;
                
                futhark_mc_task_339235_task.args = &futhark_mc_task_339235;
                futhark_mc_task_339235_task.top_level_fn =
                    futhark_mc_segscan_task_339236;
                futhark_mc_task_339235_task.name =
                    "futhark_mc_segscan_task_339236";
                futhark_mc_task_339235_task.iterations = partition_sizze_292766;
                futhark_mc_task_339235_task.task_time =
                    &ctx->futhark_mc_segscan_task_339236_total_time;
                futhark_mc_task_339235_task.task_iter =
                    &ctx->futhark_mc_segscan_task_339236_total_iter;
                futhark_mc_task_339235_task.sched = STATIC;
                futhark_mc_task_339235_task.nested_fn = NULL;
                
                int futhark_mc_segscan_task_339236_err =
                    scheduler_prepare_task(&ctx->scheduler,
                                           &futhark_mc_task_339235_task);
                
                if (futhark_mc_segscan_task_339236_err != 0) {
                    if (memblock_unref(ctx, &mem_param_316884,
                                       "mem_param_316884") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_316879,
                                       "mem_param_316879") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_316874,
                                       "mem_param_316874") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_316869,
                                       "mem_param_316869") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_316860,
                                       "mem_param_316860") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_316855,
                                       "mem_param_316855") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316937,
                                       "ext_mem_316937") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316938,
                                       "ext_mem_316938") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316939,
                                       "ext_mem_316939") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316940,
                                       "ext_mem_316940") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316941,
                                       "ext_mem_316941") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316942,
                                       "ext_mem_316942") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_316863, "mem_316863") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_316847, "mem_316847") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_316844, "mem_316844") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_316841, "mem_316841") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_316838, "mem_316838") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_316825, "mem_316825") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_317002,
                                       "ext_mem_317002") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_313201,
                                       "mem_param_313201") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_313193,
                                       "mem_param_313193") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316760,
                                       "ext_mem_316760") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316761,
                                       "ext_mem_316761") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_313179,
                                       "mem_param_313179") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_313171,
                                       "mem_param_313171") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_313163,
                                       "mem_param_313163") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_317010,
                                       "ext_mem_317010") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_317011,
                                       "ext_mem_317011") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_317012,
                                       "ext_mem_317012") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_313155, "mem_313155") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_313151, "mem_313151") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_317163,
                                       "mem_out_317163") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_317162,
                                       "mem_out_317162") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_317161,
                                       "mem_out_317161") != 0)
                        return 1;
                    ;
                    err = futhark_mc_segscan_task_339236_err;
                    goto cleanup;
                }
                
                int64_t flat_tid_310546 = (int64_t) 0;
                int32_t num_tasks_337350;
                struct futhark_mc_task_339242 futhark_mc_task_339242;
                
                futhark_mc_task_339242.ctx = ctx;
                futhark_mc_task_339242.free_partition_sizze_292766 =
                    partition_sizze_292766;
                futhark_mc_task_339242.free_loopz2089U_297094 =
                    loopz2089U_297094;
                futhark_mc_task_339242.free_cond_297105 = cond_297105;
                futhark_mc_task_339242.free_mem_316822 = mem_316822;
                futhark_mc_task_339242.free_ctx_param_ext_316876 =
                    ctx_param_ext_316876;
                futhark_mc_task_339242.free_ctx_param_ext_316877 =
                    ctx_param_ext_316877;
                futhark_mc_task_339242.free_mem_param_316879 =
                    mem_param_316879.mem;
                futhark_mc_task_339242.free_mem_316906 = mem_316906;
                futhark_mc_task_339242.free_mem_316909 = mem_316909;
                
                struct scheduler_segop futhark_mc_task_339242_task;
                
                futhark_mc_task_339242_task.args = &futhark_mc_task_339242;
                futhark_mc_task_339242_task.top_level_fn =
                    futhark_mc_segmap_task_339243;
                futhark_mc_task_339242_task.name =
                    "futhark_mc_segmap_task_339243";
                futhark_mc_task_339242_task.iterations = partition_sizze_292766;
                futhark_mc_task_339242_task.task_time =
                    &ctx->futhark_mc_segmap_task_339243_total_time;
                futhark_mc_task_339242_task.task_iter =
                    &ctx->futhark_mc_segmap_task_339243_total_iter;
                futhark_mc_task_339242_task.sched = STATIC;
                futhark_mc_task_339242_task.nested_fn = NULL;
                
                int futhark_mc_segmap_task_339243_err =
                    scheduler_prepare_task(&ctx->scheduler,
                                           &futhark_mc_task_339242_task);
                
                if (futhark_mc_segmap_task_339243_err != 0) {
                    if (memblock_unref(ctx, &mem_param_316884,
                                       "mem_param_316884") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_316879,
                                       "mem_param_316879") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_316874,
                                       "mem_param_316874") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_316869,
                                       "mem_param_316869") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_316860,
                                       "mem_param_316860") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_316855,
                                       "mem_param_316855") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316937,
                                       "ext_mem_316937") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316938,
                                       "ext_mem_316938") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316939,
                                       "ext_mem_316939") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316940,
                                       "ext_mem_316940") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316941,
                                       "ext_mem_316941") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316942,
                                       "ext_mem_316942") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_316863, "mem_316863") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_316847, "mem_316847") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_316844, "mem_316844") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_316841, "mem_316841") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_316838, "mem_316838") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_316825, "mem_316825") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_317002,
                                       "ext_mem_317002") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_313201,
                                       "mem_param_313201") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_313193,
                                       "mem_param_313193") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316760,
                                       "ext_mem_316760") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316761,
                                       "ext_mem_316761") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_313179,
                                       "mem_param_313179") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_313171,
                                       "mem_param_313171") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_313163,
                                       "mem_param_313163") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_317010,
                                       "ext_mem_317010") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_317011,
                                       "ext_mem_317011") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_317012,
                                       "ext_mem_317012") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_313155, "mem_313155") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_313151, "mem_313151") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_317163,
                                       "mem_out_317163") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_317162,
                                       "mem_out_317162") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_317161,
                                       "mem_out_317161") != 0)
                        return 1;
                    ;
                    err = futhark_mc_segmap_task_339243_err;
                    goto cleanup;
                }
                for (int64_t i_337365 = 0; i_337365 < replicate_arg_297080;
                     i_337365++) {
                    ((int32_t *) mem_316912)[i_337365] = 0;
                }
                
                int64_t flat_tid_310548 = (int64_t) 0;
                int32_t num_tasks_337366;
                struct futhark_mc_task_339246 futhark_mc_task_339246;
                
                futhark_mc_task_339246.ctx = ctx;
                futhark_mc_task_339246.free_partition_sizze_292766 =
                    partition_sizze_292766;
                futhark_mc_task_339246.free_replicate_arg_297080 =
                    replicate_arg_297080;
                futhark_mc_task_339246.free_loopz2089U_297094 =
                    loopz2089U_297094;
                futhark_mc_task_339246.free_ctx_param_ext_316866 =
                    ctx_param_ext_316866;
                futhark_mc_task_339246.free_ctx_param_ext_316867 =
                    ctx_param_ext_316867;
                futhark_mc_task_339246.free_mem_param_316869 =
                    mem_param_316869.mem;
                futhark_mc_task_339246.free_ctx_param_ext_316876 =
                    ctx_param_ext_316876;
                futhark_mc_task_339246.free_ctx_param_ext_316877 =
                    ctx_param_ext_316877;
                futhark_mc_task_339246.free_mem_param_316879 =
                    mem_param_316879.mem;
                futhark_mc_task_339246.free_mem_316909 = mem_316909;
                futhark_mc_task_339246.free_mem_316912 = mem_316912;
                
                struct scheduler_segop futhark_mc_task_339246_task;
                
                futhark_mc_task_339246_task.args = &futhark_mc_task_339246;
                futhark_mc_task_339246_task.top_level_fn =
                    futhark_mc_seghist_task_339247;
                futhark_mc_task_339246_task.name =
                    "futhark_mc_seghist_task_339247";
                futhark_mc_task_339246_task.iterations = loopz2089U_297094;
                futhark_mc_task_339246_task.task_time =
                    &ctx->futhark_mc_seghist_task_339247_total_time;
                futhark_mc_task_339246_task.task_iter =
                    &ctx->futhark_mc_seghist_task_339247_total_iter;
                futhark_mc_task_339246_task.sched = STATIC;
                futhark_mc_task_339246_task.nested_fn = NULL;
                
                int futhark_mc_seghist_task_339247_err =
                    scheduler_prepare_task(&ctx->scheduler,
                                           &futhark_mc_task_339246_task);
                
                if (futhark_mc_seghist_task_339247_err != 0) {
                    if (memblock_unref(ctx, &mem_param_316884,
                                       "mem_param_316884") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_316879,
                                       "mem_param_316879") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_316874,
                                       "mem_param_316874") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_316869,
                                       "mem_param_316869") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_316860,
                                       "mem_param_316860") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_316855,
                                       "mem_param_316855") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316937,
                                       "ext_mem_316937") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316938,
                                       "ext_mem_316938") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316939,
                                       "ext_mem_316939") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316940,
                                       "ext_mem_316940") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316941,
                                       "ext_mem_316941") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316942,
                                       "ext_mem_316942") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_316863, "mem_316863") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_316847, "mem_316847") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_316844, "mem_316844") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_316841, "mem_316841") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_316838, "mem_316838") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_316825, "mem_316825") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_317002,
                                       "ext_mem_317002") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_313201,
                                       "mem_param_313201") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_313193,
                                       "mem_param_313193") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316760,
                                       "ext_mem_316760") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316761,
                                       "ext_mem_316761") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_313179,
                                       "mem_param_313179") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_313171,
                                       "mem_param_313171") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_313163,
                                       "mem_param_313163") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_317010,
                                       "ext_mem_317010") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_317011,
                                       "ext_mem_317011") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_317012,
                                       "ext_mem_317012") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_313155, "mem_313155") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_313151, "mem_313151") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_317163,
                                       "mem_out_317163") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_317162,
                                       "mem_out_317162") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_317161,
                                       "mem_out_317161") != 0)
                        return 1;
                    ;
                    err = futhark_mc_seghist_task_339247_err;
                    goto cleanup;
                }
                
                int64_t flat_tid_310550 = (int64_t) 0;
                int32_t num_tasks_337383;
                struct futhark_mc_task_339258 futhark_mc_task_339258;
                
                futhark_mc_task_339258.ctx = ctx;
                futhark_mc_task_339258.free_partition_sizze_292766 =
                    partition_sizze_292766;
                futhark_mc_task_339258.free_replicate_arg_297080 =
                    replicate_arg_297080;
                futhark_mc_task_339258.free_mem_param_316855 =
                    mem_param_316855.mem;
                futhark_mc_task_339258.free_mem_param_316860 =
                    mem_param_316860.mem;
                futhark_mc_task_339258.free_mem_316912 = mem_316912;
                futhark_mc_task_339258.free_mem_316915 = mem_316915;
                futhark_mc_task_339258.free_mem_316917 = mem_316917;
                futhark_mc_task_339258.free_mem_316920 = mem_316920;
                
                struct scheduler_segop futhark_mc_task_339258_task;
                
                futhark_mc_task_339258_task.args = &futhark_mc_task_339258;
                futhark_mc_task_339258_task.top_level_fn =
                    futhark_mc_segmap_task_339259;
                futhark_mc_task_339258_task.name =
                    "futhark_mc_segmap_task_339259";
                futhark_mc_task_339258_task.iterations = partition_sizze_292766;
                futhark_mc_task_339258_task.task_time =
                    &ctx->futhark_mc_segmap_task_339259_total_time;
                futhark_mc_task_339258_task.task_iter =
                    &ctx->futhark_mc_segmap_task_339259_total_iter;
                futhark_mc_task_339258_task.sched = STATIC;
                futhark_mc_task_339258_task.nested_fn = NULL;
                
                int futhark_mc_segmap_task_339259_err =
                    scheduler_prepare_task(&ctx->scheduler,
                                           &futhark_mc_task_339258_task);
                
                if (futhark_mc_segmap_task_339259_err != 0) {
                    if (memblock_unref(ctx, &mem_param_316884,
                                       "mem_param_316884") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_316879,
                                       "mem_param_316879") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_316874,
                                       "mem_param_316874") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_316869,
                                       "mem_param_316869") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_316860,
                                       "mem_param_316860") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_316855,
                                       "mem_param_316855") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316937,
                                       "ext_mem_316937") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316938,
                                       "ext_mem_316938") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316939,
                                       "ext_mem_316939") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316940,
                                       "ext_mem_316940") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316941,
                                       "ext_mem_316941") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316942,
                                       "ext_mem_316942") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_316863, "mem_316863") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_316847, "mem_316847") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_316844, "mem_316844") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_316841, "mem_316841") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_316838, "mem_316838") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_316825, "mem_316825") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_317002,
                                       "ext_mem_317002") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_313201,
                                       "mem_param_313201") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_313193,
                                       "mem_param_313193") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316760,
                                       "ext_mem_316760") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316761,
                                       "ext_mem_316761") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_313179,
                                       "mem_param_313179") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_313171,
                                       "mem_param_313171") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_313163,
                                       "mem_param_313163") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_317010,
                                       "ext_mem_317010") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_317011,
                                       "ext_mem_317011") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_317012,
                                       "ext_mem_317012") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_313155, "mem_313155") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_313151, "mem_313151") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_317163,
                                       "mem_out_317163") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_317162,
                                       "mem_out_317162") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_317161,
                                       "mem_out_317161") != 0)
                        return 1;
                    ;
                    err = futhark_mc_segmap_task_339259_err;
                    goto cleanup;
                }
                
                struct memblock mem_316923;
                
                mem_316923.references = NULL;
                if (memblock_alloc(ctx, &mem_316923, bytes_316824,
                                   "mem_316923")) {
                    err = 1;
                    goto cleanup;
                }
                if (partition_sizze_292766 * (int64_t) 4 > 0)
                    memmove(mem_316923.mem + (int64_t) 0, mem_316915 +
                            (int64_t) 0, partition_sizze_292766 * (int64_t) 4);
                
                struct memblock mem_316926;
                
                mem_316926.references = NULL;
                if (memblock_alloc(ctx, &mem_316926, bytes_316824,
                                   "mem_316926")) {
                    err = 1;
                    goto cleanup;
                }
                if (partition_sizze_292766 * (int64_t) 4 > 0)
                    memmove(mem_316926.mem + (int64_t) 0, mem_316920 +
                            (int64_t) 0, partition_sizze_292766 * (int64_t) 4);
                
                int64_t flat_tid_310552 = (int64_t) 0;
                int32_t num_tasks_337411;
                struct futhark_mc_task_339262 futhark_mc_task_339262;
                
                futhark_mc_task_339262.ctx = ctx;
                futhark_mc_task_339262.free_partition_sizze_292766 =
                    partition_sizze_292766;
                futhark_mc_task_339262.free_mem_316850 = mem_316850;
                futhark_mc_task_339262.free_mem_316909 = mem_316909;
                futhark_mc_task_339262.free_mem_316917 = mem_316917;
                
                struct scheduler_segop futhark_mc_task_339262_task;
                
                futhark_mc_task_339262_task.args = &futhark_mc_task_339262;
                futhark_mc_task_339262_task.top_level_fn =
                    futhark_mc_segmap_task_339263;
                futhark_mc_task_339262_task.name =
                    "futhark_mc_segmap_task_339263";
                futhark_mc_task_339262_task.iterations = partition_sizze_292766;
                futhark_mc_task_339262_task.task_time =
                    &ctx->futhark_mc_segmap_task_339263_total_time;
                futhark_mc_task_339262_task.task_iter =
                    &ctx->futhark_mc_segmap_task_339263_total_iter;
                futhark_mc_task_339262_task.sched = STATIC;
                futhark_mc_task_339262_task.nested_fn = NULL;
                
                int futhark_mc_segmap_task_339263_err =
                    scheduler_prepare_task(&ctx->scheduler,
                                           &futhark_mc_task_339262_task);
                
                if (futhark_mc_segmap_task_339263_err != 0) {
                    if (memblock_unref(ctx, &mem_316926, "mem_316926") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_316923, "mem_316923") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_316884,
                                       "mem_param_316884") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_316879,
                                       "mem_param_316879") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_316874,
                                       "mem_param_316874") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_316869,
                                       "mem_param_316869") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_316860,
                                       "mem_param_316860") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_316855,
                                       "mem_param_316855") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316937,
                                       "ext_mem_316937") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316938,
                                       "ext_mem_316938") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316939,
                                       "ext_mem_316939") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316940,
                                       "ext_mem_316940") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316941,
                                       "ext_mem_316941") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316942,
                                       "ext_mem_316942") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_316863, "mem_316863") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_316847, "mem_316847") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_316844, "mem_316844") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_316841, "mem_316841") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_316838, "mem_316838") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_316825, "mem_316825") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_317002,
                                       "ext_mem_317002") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_313201,
                                       "mem_param_313201") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_313193,
                                       "mem_param_313193") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316760,
                                       "ext_mem_316760") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316761,
                                       "ext_mem_316761") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_313179,
                                       "mem_param_313179") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_313171,
                                       "mem_param_313171") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_313163,
                                       "mem_param_313163") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_317010,
                                       "ext_mem_317010") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_317011,
                                       "ext_mem_317011") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_317012,
                                       "ext_mem_317012") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_313155, "mem_313155") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_313151, "mem_313151") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_317163,
                                       "mem_out_317163") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_317162,
                                       "mem_out_317162") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_317161,
                                       "mem_out_317161") != 0)
                        return 1;
                    ;
                    err = futhark_mc_segmap_task_339263_err;
                    goto cleanup;
                }
                
                int64_t bytes_316927 = smax64((int64_t) 0, loopz2089U_297094);
                
                if (mem_316928_cached_sizze_337674 < (size_t) bytes_316927) {
                    mem_316928 = realloc(mem_316928, bytes_316927);
                    mem_316928_cached_sizze_337674 = bytes_316927;
                }
                
                int64_t flat_tid_310554 = (int64_t) 0;
                int32_t num_tasks_337416;
                struct futhark_mc_task_339266 futhark_mc_task_339266;
                
                futhark_mc_task_339266.ctx = ctx;
                futhark_mc_task_339266.free_partition_sizze_292766 =
                    partition_sizze_292766;
                futhark_mc_task_339266.free_loopz2089U_297094 =
                    loopz2089U_297094;
                futhark_mc_task_339266.free_ctx_param_ext_316866 =
                    ctx_param_ext_316866;
                futhark_mc_task_339266.free_ctx_param_ext_316867 =
                    ctx_param_ext_316867;
                futhark_mc_task_339266.free_mem_param_316869 =
                    mem_param_316869.mem;
                futhark_mc_task_339266.free_ctx_param_ext_316876 =
                    ctx_param_ext_316876;
                futhark_mc_task_339266.free_ctx_param_ext_316877 =
                    ctx_param_ext_316877;
                futhark_mc_task_339266.free_mem_param_316879 =
                    mem_param_316879.mem;
                futhark_mc_task_339266.free_mem_316909 = mem_316909;
                futhark_mc_task_339266.free_mem_316917 = mem_316917;
                futhark_mc_task_339266.free_mem_316928 = mem_316928;
                
                struct scheduler_segop futhark_mc_task_339266_task;
                
                futhark_mc_task_339266_task.args = &futhark_mc_task_339266;
                futhark_mc_task_339266_task.top_level_fn =
                    futhark_mc_segmap_task_339267;
                futhark_mc_task_339266_task.name =
                    "futhark_mc_segmap_task_339267";
                futhark_mc_task_339266_task.iterations = loopz2089U_297094;
                futhark_mc_task_339266_task.task_time =
                    &ctx->futhark_mc_segmap_task_339267_total_time;
                futhark_mc_task_339266_task.task_iter =
                    &ctx->futhark_mc_segmap_task_339267_total_iter;
                futhark_mc_task_339266_task.sched = STATIC;
                futhark_mc_task_339266_task.nested_fn = NULL;
                
                int futhark_mc_segmap_task_339267_err =
                    scheduler_prepare_task(&ctx->scheduler,
                                           &futhark_mc_task_339266_task);
                
                if (futhark_mc_segmap_task_339267_err != 0) {
                    if (memblock_unref(ctx, &mem_316926, "mem_316926") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_316923, "mem_316923") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_316884,
                                       "mem_param_316884") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_316879,
                                       "mem_param_316879") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_316874,
                                       "mem_param_316874") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_316869,
                                       "mem_param_316869") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_316860,
                                       "mem_param_316860") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_316855,
                                       "mem_param_316855") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316937,
                                       "ext_mem_316937") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316938,
                                       "ext_mem_316938") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316939,
                                       "ext_mem_316939") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316940,
                                       "ext_mem_316940") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316941,
                                       "ext_mem_316941") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316942,
                                       "ext_mem_316942") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_316863, "mem_316863") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_316847, "mem_316847") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_316844, "mem_316844") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_316841, "mem_316841") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_316838, "mem_316838") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_316825, "mem_316825") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_317002,
                                       "ext_mem_317002") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_313201,
                                       "mem_param_313201") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_313193,
                                       "mem_param_313193") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316760,
                                       "ext_mem_316760") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316761,
                                       "ext_mem_316761") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_313179,
                                       "mem_param_313179") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_313171,
                                       "mem_param_313171") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_313163,
                                       "mem_param_313163") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_317010,
                                       "ext_mem_317010") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_317011,
                                       "ext_mem_317011") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_317012,
                                       "ext_mem_317012") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_313155, "mem_313155") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_313151, "mem_313151") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_317163,
                                       "mem_out_317163") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_317162,
                                       "mem_out_317162") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_317161,
                                       "mem_out_317161") != 0)
                        return 1;
                    ;
                    err = futhark_mc_segmap_task_339267_err;
                    goto cleanup;
                }
                
                int64_t binop_y_316929 = (int64_t) 4 * loopz2089U_297094;
                int64_t bytes_316930 = smax64((int64_t) 0, binop_y_316929);
                
                if (mem_316931_cached_sizze_337675 < (size_t) bytes_316930) {
                    mem_316931 = realloc(mem_316931, bytes_316930);
                    mem_316931_cached_sizze_337675 = bytes_316930;
                }
                
                int64_t flat_tid_310556 = (int64_t) 0;
                int32_t num_tasks_337420;
                
                if (ctx->debugging)
                    fprintf(ctx->log, "%s\n", "nonsegmented segScan");
                
                struct futhark_mc_task_339270 futhark_mc_task_339270;
                
                futhark_mc_task_339270.ctx = ctx;
                futhark_mc_task_339270.free_loopz2089U_297094 =
                    loopz2089U_297094;
                futhark_mc_task_339270.free_mem_316928 = mem_316928;
                futhark_mc_task_339270.free_mem_316931 = mem_316931;
                
                struct scheduler_segop futhark_mc_task_339270_task;
                
                futhark_mc_task_339270_task.args = &futhark_mc_task_339270;
                futhark_mc_task_339270_task.top_level_fn =
                    futhark_mc_segscan_task_339271;
                futhark_mc_task_339270_task.name =
                    "futhark_mc_segscan_task_339271";
                futhark_mc_task_339270_task.iterations = loopz2089U_297094;
                futhark_mc_task_339270_task.task_time =
                    &ctx->futhark_mc_segscan_task_339271_total_time;
                futhark_mc_task_339270_task.task_iter =
                    &ctx->futhark_mc_segscan_task_339271_total_iter;
                futhark_mc_task_339270_task.sched = STATIC;
                futhark_mc_task_339270_task.nested_fn = NULL;
                
                int futhark_mc_segscan_task_339271_err =
                    scheduler_prepare_task(&ctx->scheduler,
                                           &futhark_mc_task_339270_task);
                
                if (futhark_mc_segscan_task_339271_err != 0) {
                    if (memblock_unref(ctx, &mem_316926, "mem_316926") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_316923, "mem_316923") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_316884,
                                       "mem_param_316884") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_316879,
                                       "mem_param_316879") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_316874,
                                       "mem_param_316874") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_316869,
                                       "mem_param_316869") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_316860,
                                       "mem_param_316860") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_316855,
                                       "mem_param_316855") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316937,
                                       "ext_mem_316937") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316938,
                                       "ext_mem_316938") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316939,
                                       "ext_mem_316939") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316940,
                                       "ext_mem_316940") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316941,
                                       "ext_mem_316941") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316942,
                                       "ext_mem_316942") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_316863, "mem_316863") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_316847, "mem_316847") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_316844, "mem_316844") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_316841, "mem_316841") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_316838, "mem_316838") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_316825, "mem_316825") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_317002,
                                       "ext_mem_317002") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_313201,
                                       "mem_param_313201") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_313193,
                                       "mem_param_313193") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316760,
                                       "ext_mem_316760") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316761,
                                       "ext_mem_316761") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_313179,
                                       "mem_param_313179") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_313171,
                                       "mem_param_313171") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_313163,
                                       "mem_param_313163") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_317010,
                                       "ext_mem_317010") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_317011,
                                       "ext_mem_317011") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_317012,
                                       "ext_mem_317012") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_313155, "mem_313155") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_313151, "mem_313151") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_317163,
                                       "mem_out_317163") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_317162,
                                       "mem_out_317162") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_317161,
                                       "mem_out_317161") != 0)
                        return 1;
                    ;
                    err = futhark_mc_segscan_task_339271_err;
                    goto cleanup;
                }
                
                int64_t i_297244 = sub64(loopz2089U_297094, (int64_t) 1);
                bool x_297245 = sle64((int64_t) 0, i_297244);
                bool y_297246 = slt64(i_297244, loopz2089U_297094);
                bool bounds_check_297247 = x_297245 && y_297246;
                bool index_certs_297248;
                
                if (!bounds_check_297247) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [", (long long) i_297244,
                                  "] out of bounds for array of shape [",
                                  (long long) loopz2089U_297094, "].",
                                  "-> #0  /prelude/array.fut:26:29-34\n   #1  median.fut:87:32-44\n   #2  median.fut:112:18-67\n   #3  stl.fut:343:23-52\n   #4  stl.fut:419:61-435:77\n   #5  stl.fut:463:3-479:36\n   #6  stl.fut:445:1-479:36\n");
                    if (memblock_unref(ctx, &mem_316926, "mem_316926") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_316923, "mem_316923") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_316884,
                                       "mem_param_316884") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_316879,
                                       "mem_param_316879") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_316874,
                                       "mem_param_316874") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_316869,
                                       "mem_param_316869") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_316860,
                                       "mem_param_316860") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_316855,
                                       "mem_param_316855") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316937,
                                       "ext_mem_316937") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316938,
                                       "ext_mem_316938") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316939,
                                       "ext_mem_316939") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316940,
                                       "ext_mem_316940") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316941,
                                       "ext_mem_316941") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316942,
                                       "ext_mem_316942") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_316863, "mem_316863") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_316847, "mem_316847") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_316844, "mem_316844") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_316841, "mem_316841") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_316838, "mem_316838") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_316825, "mem_316825") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_317002,
                                       "ext_mem_317002") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_313201,
                                       "mem_param_313201") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_313193,
                                       "mem_param_313193") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316760,
                                       "ext_mem_316760") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316761,
                                       "ext_mem_316761") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_313179,
                                       "mem_param_313179") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_313171,
                                       "mem_param_313171") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_313163,
                                       "mem_param_313163") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_317010,
                                       "ext_mem_317010") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_317011,
                                       "ext_mem_317011") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_317012,
                                       "ext_mem_317012") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_313155, "mem_313155") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_313151, "mem_313151") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_317163,
                                       "mem_out_317163") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_317162,
                                       "mem_out_317162") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_317161,
                                       "mem_out_317161") != 0)
                        return 1;
                    err = FUTHARK_PROGRAM_ERROR;
                    goto cleanup;
                }
                
                int32_t last_res_297249;
                
                last_res_297249 = ((int32_t *) mem_316931)[i_297244];
                
                int64_t i32_res_297250 = sext_i32_i64(last_res_297249);
                int64_t flat_tid_310558 = (int64_t) 0;
                int32_t num_tasks_337434;
                struct futhark_mc_task_339277 futhark_mc_task_339277;
                
                futhark_mc_task_339277.ctx = ctx;
                futhark_mc_task_339277.free_loopz2088U_297093 =
                    loopz2088U_297093;
                futhark_mc_task_339277.free_loopz2089U_297094 =
                    loopz2089U_297094;
                futhark_mc_task_339277.free_loopz2081Uz2080U_297095 =
                    loopz2081Uz2080U_297095;
                futhark_mc_task_339277.free_ctx_param_ext_316866 =
                    ctx_param_ext_316866;
                futhark_mc_task_339277.free_ctx_param_ext_316867 =
                    ctx_param_ext_316867;
                futhark_mc_task_339277.free_mem_param_316869 =
                    mem_param_316869.mem;
                futhark_mc_task_339277.free_ctx_param_ext_316871 =
                    ctx_param_ext_316871;
                futhark_mc_task_339277.free_ctx_param_ext_316872 =
                    ctx_param_ext_316872;
                futhark_mc_task_339277.free_mem_param_316874 =
                    mem_param_316874.mem;
                futhark_mc_task_339277.free_ctx_param_ext_316876 =
                    ctx_param_ext_316876;
                futhark_mc_task_339277.free_ctx_param_ext_316877 =
                    ctx_param_ext_316877;
                futhark_mc_task_339277.free_mem_param_316879 =
                    mem_param_316879.mem;
                futhark_mc_task_339277.free_ctx_param_ext_316881 =
                    ctx_param_ext_316881;
                futhark_mc_task_339277.free_ctx_param_ext_316882 =
                    ctx_param_ext_316882;
                futhark_mc_task_339277.free_mem_param_316884 =
                    mem_param_316884.mem;
                futhark_mc_task_339277.free_mem_316928 = mem_316928;
                futhark_mc_task_339277.free_mem_316931 = mem_316931;
                
                struct scheduler_segop futhark_mc_task_339277_task;
                
                futhark_mc_task_339277_task.args = &futhark_mc_task_339277;
                futhark_mc_task_339277_task.top_level_fn =
                    futhark_mc_segmap_task_339278;
                futhark_mc_task_339277_task.name =
                    "futhark_mc_segmap_task_339278";
                futhark_mc_task_339277_task.iterations = loopz2089U_297094;
                futhark_mc_task_339277_task.task_time =
                    &ctx->futhark_mc_segmap_task_339278_total_time;
                futhark_mc_task_339277_task.task_iter =
                    &ctx->futhark_mc_segmap_task_339278_total_iter;
                futhark_mc_task_339277_task.sched = STATIC;
                futhark_mc_task_339277_task.nested_fn = NULL;
                
                int futhark_mc_segmap_task_339278_err =
                    scheduler_prepare_task(&ctx->scheduler,
                                           &futhark_mc_task_339277_task);
                
                if (futhark_mc_segmap_task_339278_err != 0) {
                    if (memblock_unref(ctx, &mem_316926, "mem_316926") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_316923, "mem_316923") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_316884,
                                       "mem_param_316884") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_316879,
                                       "mem_param_316879") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_316874,
                                       "mem_param_316874") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_316869,
                                       "mem_param_316869") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_316860,
                                       "mem_param_316860") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_316855,
                                       "mem_param_316855") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316937,
                                       "ext_mem_316937") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316938,
                                       "ext_mem_316938") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316939,
                                       "ext_mem_316939") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316940,
                                       "ext_mem_316940") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316941,
                                       "ext_mem_316941") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316942,
                                       "ext_mem_316942") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_316863, "mem_316863") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_316847, "mem_316847") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_316844, "mem_316844") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_316841, "mem_316841") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_316838, "mem_316838") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_316825, "mem_316825") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_317002,
                                       "ext_mem_317002") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_313201,
                                       "mem_param_313201") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_313193,
                                       "mem_param_313193") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316760,
                                       "ext_mem_316760") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316761,
                                       "ext_mem_316761") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_313179,
                                       "mem_param_313179") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_313171,
                                       "mem_param_313171") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_313163,
                                       "mem_param_313163") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_317010,
                                       "ext_mem_317010") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_317011,
                                       "ext_mem_317011") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_317012,
                                       "ext_mem_317012") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_313155, "mem_313155") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_313151, "mem_313151") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_317163,
                                       "mem_out_317163") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_317162,
                                       "mem_out_317162") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_317161,
                                       "mem_out_317161") != 0)
                        return 1;
                    ;
                    err = futhark_mc_segmap_task_339278_err;
                    goto cleanup;
                }
                
                bool empty_slice_297260 = i32_res_297250 == (int64_t) 0;
                int64_t m_297261 = sub64(i32_res_297250, (int64_t) 1);
                bool zzero_leq_i_p_m_t_s_297262 = sle64((int64_t) 0, m_297261);
                bool i_p_m_t_s_leq_w_297263 = slt64(m_297261,
                                                    loopz2088U_297093);
                bool i_lte_j_297264 = sle64((int64_t) 0, i32_res_297250);
                bool y_297265 = zzero_leq_i_p_m_t_s_297262 &&
                     i_p_m_t_s_leq_w_297263;
                bool y_297266 = i_lte_j_297264 && y_297265;
                bool ok_or_empty_297267 = empty_slice_297260 || y_297266;
                bool index_certs_297268;
                
                if (!ok_or_empty_297267) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [:", (long long) i32_res_297250,
                                  "] out of bounds for array of shape [",
                                  (long long) loopz2088U_297093, "].",
                                  "-> #0  median.fut:91:20-33\n   #1  median.fut:112:18-67\n   #2  stl.fut:343:23-52\n   #3  stl.fut:419:61-435:77\n   #4  stl.fut:463:3-479:36\n   #5  stl.fut:445:1-479:36\n");
                    if (memblock_unref(ctx, &mem_316926, "mem_316926") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_316923, "mem_316923") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_316884,
                                       "mem_param_316884") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_316879,
                                       "mem_param_316879") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_316874,
                                       "mem_param_316874") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_316869,
                                       "mem_param_316869") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_316860,
                                       "mem_param_316860") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_316855,
                                       "mem_param_316855") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316937,
                                       "ext_mem_316937") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316938,
                                       "ext_mem_316938") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316939,
                                       "ext_mem_316939") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316940,
                                       "ext_mem_316940") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316941,
                                       "ext_mem_316941") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316942,
                                       "ext_mem_316942") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_316863, "mem_316863") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_316847, "mem_316847") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_316844, "mem_316844") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_316841, "mem_316841") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_316838, "mem_316838") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_316825, "mem_316825") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_317002,
                                       "ext_mem_317002") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_313201,
                                       "mem_param_313201") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_313193,
                                       "mem_param_313193") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316760,
                                       "ext_mem_316760") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316761,
                                       "ext_mem_316761") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_313179,
                                       "mem_param_313179") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_313171,
                                       "mem_param_313171") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_313163,
                                       "mem_param_313163") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_317010,
                                       "ext_mem_317010") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_317011,
                                       "ext_mem_317011") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_317012,
                                       "ext_mem_317012") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_313155, "mem_313155") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_313151, "mem_313151") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_317163,
                                       "mem_out_317163") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_317162,
                                       "mem_out_317162") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_317161,
                                       "mem_out_317161") != 0)
                        return 1;
                    err = FUTHARK_PROGRAM_ERROR;
                    goto cleanup;
                }
                
                bool i_p_m_t_s_leq_w_297270 = slt64(m_297261,
                                                    loopz2081Uz2080U_297095);
                bool y_297271 = zzero_leq_i_p_m_t_s_297262 &&
                     i_p_m_t_s_leq_w_297270;
                bool y_297272 = i_lte_j_297264 && y_297271;
                bool ok_or_empty_297273 = empty_slice_297260 || y_297272;
                bool index_certs_297274;
                
                if (!ok_or_empty_297273) {
                    ctx->error =
                        msgprintf("Error: %s%lld%s%lld%s\n\nBacktrace:\n%s",
                                  "Index [:", (long long) i32_res_297250,
                                  "] out of bounds for array of shape [",
                                  (long long) loopz2081Uz2080U_297095, "].",
                                  "-> #0  median.fut:92:20-31\n   #1  median.fut:112:18-67\n   #2  stl.fut:343:23-52\n   #3  stl.fut:419:61-435:77\n   #4  stl.fut:463:3-479:36\n   #5  stl.fut:445:1-479:36\n");
                    if (memblock_unref(ctx, &mem_316926, "mem_316926") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_316923, "mem_316923") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_316884,
                                       "mem_param_316884") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_316879,
                                       "mem_param_316879") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_316874,
                                       "mem_param_316874") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_316869,
                                       "mem_param_316869") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_316860,
                                       "mem_param_316860") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_316855,
                                       "mem_param_316855") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316937,
                                       "ext_mem_316937") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316938,
                                       "ext_mem_316938") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316939,
                                       "ext_mem_316939") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316940,
                                       "ext_mem_316940") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316941,
                                       "ext_mem_316941") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316942,
                                       "ext_mem_316942") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_316863, "mem_316863") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_316847, "mem_316847") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_316844, "mem_316844") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_316841, "mem_316841") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_316838, "mem_316838") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_316825, "mem_316825") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_317002,
                                       "ext_mem_317002") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_313201,
                                       "mem_param_313201") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_313193,
                                       "mem_param_313193") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316760,
                                       "ext_mem_316760") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_316761,
                                       "ext_mem_316761") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_313179,
                                       "mem_param_313179") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_313171,
                                       "mem_param_313171") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_param_313163,
                                       "mem_param_313163") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_317010,
                                       "ext_mem_317010") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_317011,
                                       "ext_mem_317011") != 0)
                        return 1;
                    if (memblock_unref(ctx, &ext_mem_317012,
                                       "ext_mem_317012") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_313155, "mem_313155") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_313151, "mem_313151") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_317163,
                                       "mem_out_317163") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_317162,
                                       "mem_out_317162") != 0)
                        return 1;
                    if (memblock_unref(ctx, &mem_out_317161,
                                       "mem_out_317161") != 0)
                        return 1;
                    err = FUTHARK_PROGRAM_ERROR;
                    goto cleanup;
                }
                
                int64_t loopres_297276 = add64((int64_t) 1, q_297103);
                bool loop_cond_297277 = slt64((int64_t) 0, i32_res_297250);
                int64_t ctx_param_ext_tmp_337302 = ctx_param_ext_316870;
                int64_t ctx_param_ext_tmp_337303 = ctx_param_ext_316871;
                int64_t ctx_param_ext_tmp_337304 = ctx_param_ext_316872;
                int64_t ctx_param_ext_tmp_337305 = i32_res_297250;
                int64_t ctx_param_ext_tmp_337306 = ctx_param_ext_316865;
                int64_t ctx_param_ext_tmp_337307 = ctx_param_ext_316866;
                int64_t ctx_param_ext_tmp_337308 = ctx_param_ext_316867;
                int64_t ctx_param_ext_tmp_337309 = ctx_param_ext_316868;
                int64_t ctx_param_ext_tmp_337310 = ctx_param_ext_316880;
                int64_t ctx_param_ext_tmp_337311 = ctx_param_ext_316881;
                int64_t ctx_param_ext_tmp_337312 = ctx_param_ext_316882;
                int64_t ctx_param_ext_tmp_337313 = i32_res_297250;
                int64_t ctx_param_ext_tmp_337314 = ctx_param_ext_316875;
                int64_t ctx_param_ext_tmp_337315 = ctx_param_ext_316876;
                int64_t ctx_param_ext_tmp_337316 = ctx_param_ext_316877;
                int64_t ctx_param_ext_tmp_337317 = ctx_param_ext_316878;
                struct memblock mem_param_tmp_337318;
                
                mem_param_tmp_337318.references = NULL;
                if (memblock_set(ctx, &mem_param_tmp_337318, &mem_316926,
                                 "mem_316926") != 0)
                    return 1;
                
                struct memblock mem_param_tmp_337319;
                
                mem_param_tmp_337319.references = NULL;
                if (memblock_set(ctx, &mem_param_tmp_337319, &mem_316923,
                                 "mem_316923") != 0)
                    return 1;
                
                struct memblock mem_param_tmp_337320;
                
                mem_param_tmp_337320.references = NULL;
                if (memblock_set(ctx, &mem_param_tmp_337320, &mem_param_316874,
                                 "mem_param_316874") != 0)
                    return 1;
                
                struct memblock mem_param_tmp_337321;
                
                mem_param_tmp_337321.references = NULL;
                if (memblock_set(ctx, &mem_param_tmp_337321, &mem_param_316869,
                                 "mem_param_316869") != 0)
                    return 1;
                
                struct memblock mem_param_tmp_337322;
                
                mem_param_tmp_337322.references = NULL;
                if (memblock_set(ctx, &mem_param_tmp_337322, &mem_param_316884,
                                 "mem_param_316884") != 0)
                    return 1;
                
                struct memblock mem_param_tmp_337323;
                
                mem_param_tmp_337323.references = NULL;
                if (memblock_set(ctx, &mem_param_tmp_337323, &mem_param_316879,
                                 "mem_param_316879") != 0)
                    return 1;
                
                int64_t loopz2088U_tmp_337324 = loopz2089U_297094;
                int64_t loopz2089U_tmp_337325 = i32_res_297250;
                int64_t loopz2081Uz2080U_tmp_337326 = loopz2089U_297094;
                bool loop_while_tmp_337327 = loop_cond_297277;
                int64_t q_tmp_337334 = loopres_297276;
                
                ctx_param_ext_316865 = ctx_param_ext_tmp_337302;
                ctx_param_ext_316866 = ctx_param_ext_tmp_337303;
                ctx_param_ext_316867 = ctx_param_ext_tmp_337304;
                ctx_param_ext_316868 = ctx_param_ext_tmp_337305;
                ctx_param_ext_316870 = ctx_param_ext_tmp_337306;
                ctx_param_ext_316871 = ctx_param_ext_tmp_337307;
                ctx_param_ext_316872 = ctx_param_ext_tmp_337308;
                ctx_param_ext_316873 = ctx_param_ext_tmp_337309;
                ctx_param_ext_316875 = ctx_param_ext_tmp_337310;
                ctx_param_ext_316876 = ctx_param_ext_tmp_337311;
                ctx_param_ext_316877 = ctx_param_ext_tmp_337312;
                ctx_param_ext_316878 = ctx_param_ext_tmp_337313;
                ctx_param_ext_316880 = ctx_param_ext_tmp_337314;
                ctx_param_ext_316881 = ctx_param_ext_tmp_337315;
                ctx_param_ext_316882 = ctx_param_ext_tmp_337316;
                ctx_param_ext_316883 = ctx_param_ext_tmp_337317;
                if (memblock_set(ctx, &mem_param_316855, &mem_param_tmp_337318,
                                 "mem_param_tmp_337318") != 0)
                    return 1;
                if (memblock_set(ctx, &mem_param_316860, &mem_param_tmp_337319,
                                 "mem_param_tmp_337319") != 0)
                    return 1;
                if (memblock_set(ctx, &mem_param_316869, &mem_param_tmp_337320,
                                 "mem_param_tmp_337320") != 0)
                    return 1;
                if (memblock_set(ctx, &mem_param_316874, &mem_param_tmp_337321,
                                 "mem_param_tmp_337321") != 0)
                    return 1;
                if (memblock_set(ctx, &mem_param_316879, &mem_param_tmp_337322,
                                 "mem_param_tmp_337322") != 0)
                    return 1;
                if (memblock_set(ctx, &mem_param_316884, &mem_param_tmp_337323,
                                 "mem_param_tmp_337323") != 0)
                    return 1;
                loopz2088U_297093 = loopz2088U_tmp_337324;
                loopz2089U_297094 = loopz2089U_tmp_337325;
                loopz2081Uz2080U_297095 = loopz2081Uz2080U_tmp_337326;
                loop_while_297096 = loop_while_tmp_337327;
                q_297103 = q_tmp_337334;
                if (memblock_unref(ctx, &mem_param_tmp_337323,
                                   "mem_param_tmp_337323") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_tmp_337322,
                                   "mem_param_tmp_337322") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_tmp_337321,
                                   "mem_param_tmp_337321") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_tmp_337320,
                                   "mem_param_tmp_337320") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_tmp_337319,
                                   "mem_param_tmp_337319") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_tmp_337318,
                                   "mem_param_tmp_337318") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_316926, "mem_316926") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_316923, "mem_316923") != 0)
                    return 1;
            }
            ext_316962 = ctx_param_ext_316865;
            ext_316961 = ctx_param_ext_316866;
            ext_316960 = ctx_param_ext_316867;
            ext_316959 = ctx_param_ext_316868;
            ext_316958 = ctx_param_ext_316870;
            ext_316957 = ctx_param_ext_316871;
            ext_316956 = ctx_param_ext_316872;
            ext_316955 = ctx_param_ext_316873;
            ext_316954 = ctx_param_ext_316875;
            ext_316953 = ctx_param_ext_316876;
            ext_316952 = ctx_param_ext_316877;
            ext_316951 = ctx_param_ext_316878;
            ext_316950 = ctx_param_ext_316880;
            ext_316949 = ctx_param_ext_316881;
            ext_316948 = ctx_param_ext_316882;
            ext_316947 = ctx_param_ext_316883;
            if (memblock_set(ctx, &ext_mem_316942, &mem_param_316855,
                             "mem_param_316855") != 0)
                return 1;
            if (memblock_set(ctx, &ext_mem_316941, &mem_param_316860,
                             "mem_param_316860") != 0)
                return 1;
            if (memblock_set(ctx, &ext_mem_316940, &mem_param_316869,
                             "mem_param_316869") != 0)
                return 1;
            if (memblock_set(ctx, &ext_mem_316939, &mem_param_316874,
                             "mem_param_316874") != 0)
                return 1;
            if (memblock_set(ctx, &ext_mem_316938, &mem_param_316879,
                             "mem_param_316879") != 0)
                return 1;
            if (memblock_set(ctx, &ext_mem_316937, &mem_param_316884,
                             "mem_param_316884") != 0)
                return 1;
            rankSearchBatch_res_297081 = loopz2088U_297093;
            rankSearchBatch_res_297082 = loopz2089U_297094;
            rankSearchBatch_res_297083 = loopz2081Uz2080U_297095;
            rankSearchBatch_res_297084 = loop_while_297096;
            rankSearchBatch_res_297091 = q_297103;
            if (memblock_unref(ctx, &mem_316825, "mem_316825") != 0)
                return 1;
            if (memblock_unref(ctx, &mem_316838, "mem_316838") != 0)
                return 1;
            if (memblock_unref(ctx, &mem_316841, "mem_316841") != 0)
                return 1;
            if (memblock_unref(ctx, &mem_316844, "mem_316844") != 0)
                return 1;
            if (memblock_unref(ctx, &mem_316847, "mem_316847") != 0)
                return 1;
            if (memblock_unref(ctx, &mem_316863, "mem_316863") != 0)
                return 1;
            if (mem_316973_cached_sizze_337676 < (size_t) bytes_312638) {
                mem_316973 = realloc(mem_316973, bytes_312638);
                mem_316973_cached_sizze_337676 = bytes_312638;
            }
            if (mem_316976_cached_sizze_337677 < (size_t) bytes_312638) {
                mem_316976 = realloc(mem_316976, bytes_312638);
                mem_316976_cached_sizze_337677 = bytes_312638;
            }
            if (mem_316979_cached_sizze_337678 < (size_t) bytes_312638) {
                mem_316979 = realloc(mem_316979, bytes_312638);
                mem_316979_cached_sizze_337678 = bytes_312638;
            }
            
            int64_t flat_tid_310560 = (int64_t) 0;
            int32_t num_tasks_337441;
            int64_t flat_tid_310566 = (int64_t) 0;
            struct futhark_mc_task_339281 futhark_mc_task_339281;
            
            futhark_mc_task_339281.ctx = ctx;
            futhark_mc_task_339281.free_n_292675 = n_292675;
            futhark_mc_task_339281.free_partition_sizze_292766 =
                partition_sizze_292766;
            futhark_mc_task_339281.free_mem_312639 = mem_312639;
            futhark_mc_task_339281.free_mem_316815 = mem_316815;
            futhark_mc_task_339281.free_mem_316835 = mem_316835;
            futhark_mc_task_339281.free_mem_316850 = mem_316850;
            futhark_mc_task_339281.free_mem_316973 = mem_316973;
            futhark_mc_task_339281.free_mem_316976 = mem_316976;
            futhark_mc_task_339281.free_mem_316979 = mem_316979;
            
            struct scheduler_segop futhark_mc_task_339281_task;
            
            futhark_mc_task_339281_task.args = &futhark_mc_task_339281;
            futhark_mc_task_339281_task.top_level_fn =
                futhark_mc_segmap_task_339282;
            futhark_mc_task_339281_task.name = "futhark_mc_segmap_task_339282";
            futhark_mc_task_339281_task.iterations = partition_sizze_292766;
            futhark_mc_task_339281_task.task_time =
                &ctx->futhark_mc_segmap_task_339282_total_time;
            futhark_mc_task_339281_task.task_iter =
                &ctx->futhark_mc_segmap_task_339282_total_iter;
            futhark_mc_task_339281_task.sched = STATIC;
            futhark_mc_task_339281_task.nested_fn =
                futhark_mc_segmap_nested_task_339285;
            
            int futhark_mc_segmap_task_339282_err =
                scheduler_prepare_task(&ctx->scheduler,
                                       &futhark_mc_task_339281_task);
            
            if (futhark_mc_segmap_task_339282_err != 0) {
                if (memblock_unref(ctx, &mem_param_316884,
                                   "mem_param_316884") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_316879,
                                   "mem_param_316879") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_316874,
                                   "mem_param_316874") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_316869,
                                   "mem_param_316869") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_316860,
                                   "mem_param_316860") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_316855,
                                   "mem_param_316855") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_316937, "ext_mem_316937") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_316938, "ext_mem_316938") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_316939, "ext_mem_316939") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_316940, "ext_mem_316940") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_316941, "ext_mem_316941") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_316942, "ext_mem_316942") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_316863, "mem_316863") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_316847, "mem_316847") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_316844, "mem_316844") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_316841, "mem_316841") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_316838, "mem_316838") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_316825, "mem_316825") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_317002, "ext_mem_317002") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_313201,
                                   "mem_param_313201") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_313193,
                                   "mem_param_313193") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_316760, "ext_mem_316760") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_316761, "ext_mem_316761") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_313179,
                                   "mem_param_313179") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_313171,
                                   "mem_param_313171") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_313163,
                                   "mem_param_313163") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_317010, "ext_mem_317010") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_317011, "ext_mem_317011") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_317012, "ext_mem_317012") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_313155, "mem_313155") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_313151, "mem_313151") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_out_317163, "mem_out_317163") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_out_317162, "mem_out_317162") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_out_317161, "mem_out_317161") != 0)
                    return 1;
                ;
                err = futhark_mc_segmap_task_339282_err;
                goto cleanup;
            }
            
            struct memblock mem_317001;
            
            mem_317001.references = NULL;
            if (memblock_alloc(ctx, &mem_317001, bytes_312635, "mem_317001")) {
                err = 1;
                goto cleanup;
            }
            
            int64_t flat_tid_310624 = (int64_t) 0;
            int32_t num_tasks_337553;
            int64_t flat_tid_310630 = (int64_t) 0;
            struct futhark_mc_task_339295 futhark_mc_task_339295;
            
            futhark_mc_task_339295.ctx = ctx;
            futhark_mc_task_339295.free_n_292675 = n_292675;
            futhark_mc_task_339295.free_partition_sizze_292766 =
                partition_sizze_292766;
            futhark_mc_task_339295.free_bytes_312598 = bytes_312598;
            futhark_mc_task_339295.free_mem_316819 = mem_316819;
            futhark_mc_task_339295.free_mem_316973 = mem_316973;
            futhark_mc_task_339295.free_mem_316976 = mem_316976;
            futhark_mc_task_339295.free_mem_316979 = mem_316979;
            futhark_mc_task_339295.free_mem_317001 = mem_317001.mem;
            
            struct scheduler_segop futhark_mc_task_339295_task;
            
            futhark_mc_task_339295_task.args = &futhark_mc_task_339295;
            futhark_mc_task_339295_task.top_level_fn =
                futhark_mc_segmap_task_339296;
            futhark_mc_task_339295_task.name = "futhark_mc_segmap_task_339296";
            futhark_mc_task_339295_task.iterations = partition_sizze_292766;
            futhark_mc_task_339295_task.task_time =
                &ctx->futhark_mc_segmap_task_339296_total_time;
            futhark_mc_task_339295_task.task_iter =
                &ctx->futhark_mc_segmap_task_339296_total_iter;
            futhark_mc_task_339295_task.sched = STATIC;
            futhark_mc_task_339295_task.nested_fn =
                futhark_mc_segmap_nested_task_339300;
            
            int futhark_mc_segmap_task_339296_err =
                scheduler_prepare_task(&ctx->scheduler,
                                       &futhark_mc_task_339295_task);
            
            if (futhark_mc_segmap_task_339296_err != 0) {
                if (memblock_unref(ctx, &mem_317001, "mem_317001") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_316884,
                                   "mem_param_316884") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_316879,
                                   "mem_param_316879") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_316874,
                                   "mem_param_316874") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_316869,
                                   "mem_param_316869") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_316860,
                                   "mem_param_316860") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_316855,
                                   "mem_param_316855") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_316937, "ext_mem_316937") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_316938, "ext_mem_316938") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_316939, "ext_mem_316939") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_316940, "ext_mem_316940") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_316941, "ext_mem_316941") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_316942, "ext_mem_316942") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_316863, "mem_316863") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_316847, "mem_316847") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_316844, "mem_316844") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_316841, "mem_316841") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_316838, "mem_316838") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_316825, "mem_316825") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_317002, "ext_mem_317002") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_313201,
                                   "mem_param_313201") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_313193,
                                   "mem_param_313193") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_316760, "ext_mem_316760") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_316761, "ext_mem_316761") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_313179,
                                   "mem_param_313179") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_313171,
                                   "mem_param_313171") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_param_313163,
                                   "mem_param_313163") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_317010, "ext_mem_317010") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_317011, "ext_mem_317011") != 0)
                    return 1;
                if (memblock_unref(ctx, &ext_mem_317012, "ext_mem_317012") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_313155, "mem_313155") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_313151, "mem_313151") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_out_317163, "mem_out_317163") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_out_317162, "mem_out_317162") != 0)
                    return 1;
                if (memblock_unref(ctx, &mem_out_317161, "mem_out_317161") != 0)
                    return 1;
                ;
                err = futhark_mc_segmap_task_339296_err;
                goto cleanup;
            }
            if (memblock_set(ctx, &ext_mem_317002, &mem_317001, "mem_317001") !=
                0)
                return 1;
            if (memblock_unref(ctx, &mem_317001, "mem_317001") != 0)
                return 1;
            if (memblock_unref(ctx, &mem_param_316884, "mem_param_316884") != 0)
                return 1;
            if (memblock_unref(ctx, &mem_param_316879, "mem_param_316879") != 0)
                return 1;
            if (memblock_unref(ctx, &mem_param_316874, "mem_param_316874") != 0)
                return 1;
            if (memblock_unref(ctx, &mem_param_316869, "mem_param_316869") != 0)
                return 1;
            if (memblock_unref(ctx, &mem_param_316860, "mem_param_316860") != 0)
                return 1;
            if (memblock_unref(ctx, &mem_param_316855, "mem_param_316855") != 0)
                return 1;
            if (memblock_unref(ctx, &ext_mem_316937, "ext_mem_316937") != 0)
                return 1;
            if (memblock_unref(ctx, &ext_mem_316938, "ext_mem_316938") != 0)
                return 1;
            if (memblock_unref(ctx, &ext_mem_316939, "ext_mem_316939") != 0)
                return 1;
            if (memblock_unref(ctx, &ext_mem_316940, "ext_mem_316940") != 0)
                return 1;
            if (memblock_unref(ctx, &ext_mem_316941, "ext_mem_316941") != 0)
                return 1;
            if (memblock_unref(ctx, &ext_mem_316942, "ext_mem_316942") != 0)
                return 1;
            if (memblock_unref(ctx, &mem_316863, "mem_316863") != 0)
                return 1;
            if (memblock_unref(ctx, &mem_316847, "mem_316847") != 0)
                return 1;
            if (memblock_unref(ctx, &mem_316844, "mem_316844") != 0)
                return 1;
            if (memblock_unref(ctx, &mem_316841, "mem_316841") != 0)
                return 1;
            if (memblock_unref(ctx, &mem_316838, "mem_316838") != 0)
                return 1;
            if (memblock_unref(ctx, &mem_316825, "mem_316825") != 0)
                return 1;
        } else {
            if (memblock_set(ctx, &ext_mem_317002, &mem_param_313179,
                             "mem_param_313179") != 0)
                return 1;
        }
        
        int64_t ctx_param_ext_tmp_318871 = ext_316767;
        int64_t ctx_param_ext_tmp_318872 = ext_316765;
        int64_t ctx_param_ext_tmp_318873 = ext_317007;
        int64_t ctx_param_ext_tmp_318874 = ext_317006;
        int64_t ctx_param_ext_tmp_318875 = ext_317003;
        int64_t ctx_param_ext_tmp_318876 = ext_317005;
        int64_t ctx_param_ext_tmp_318877 = ext_317009;
        int64_t ctx_param_ext_tmp_318878 = ext_317004;
        int64_t ctx_param_ext_tmp_318879 = ext_317008;
        struct memblock mem_param_tmp_318880;
        
        mem_param_tmp_318880.references = NULL;
        if (memblock_set(ctx, &mem_param_tmp_318880, &ext_mem_316761,
                         "ext_mem_316761") != 0)
            return 1;
        
        struct memblock mem_param_tmp_318881;
        
        mem_param_tmp_318881.references = NULL;
        if (memblock_set(ctx, &mem_param_tmp_318881, &ext_mem_316760,
                         "ext_mem_316760") != 0)
            return 1;
        
        struct memblock mem_param_tmp_318882;
        
        mem_param_tmp_318882.references = NULL;
        if (memblock_set(ctx, &mem_param_tmp_318882, &ext_mem_317002,
                         "ext_mem_317002") != 0)
            return 1;
        ctx_param_ext_313165 = ctx_param_ext_tmp_318871;
        ctx_param_ext_313167 = ctx_param_ext_tmp_318872;
        ctx_param_ext_313172 = ctx_param_ext_tmp_318873;
        ctx_param_ext_313173 = ctx_param_ext_tmp_318874;
        ctx_param_ext_313174 = ctx_param_ext_tmp_318875;
        ctx_param_ext_313175 = ctx_param_ext_tmp_318876;
        ctx_param_ext_313176 = ctx_param_ext_tmp_318877;
        ctx_param_ext_313177 = ctx_param_ext_tmp_318878;
        ctx_param_ext_313178 = ctx_param_ext_tmp_318879;
        if (memblock_set(ctx, &mem_param_313163, &mem_param_tmp_318880,
                         "mem_param_tmp_318880") != 0)
            return 1;
        if (memblock_set(ctx, &mem_param_313171, &mem_param_tmp_318881,
                         "mem_param_tmp_318881") != 0)
            return 1;
        if (memblock_set(ctx, &mem_param_313179, &mem_param_tmp_318882,
                         "mem_param_tmp_318882") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_param_tmp_318882,
                           "mem_param_tmp_318882") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_param_tmp_318881,
                           "mem_param_tmp_318881") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_param_tmp_318880,
                           "mem_param_tmp_318880") != 0)
            return 1;
        if (memblock_unref(ctx, &ext_mem_317002, "ext_mem_317002") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_param_313201, "mem_param_313201") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_param_313193, "mem_param_313193") != 0)
            return 1;
        if (memblock_unref(ctx, &ext_mem_316760, "ext_mem_316760") != 0)
            return 1;
        if (memblock_unref(ctx, &ext_mem_316761, "ext_mem_316761") != 0)
            return 1;
    }
    ext_317025 = ctx_param_ext_313165;
    ext_317023 = ctx_param_ext_313167;
    ext_317019 = ctx_param_ext_313172;
    ext_317018 = ctx_param_ext_313173;
    ext_317017 = ctx_param_ext_313174;
    ext_317016 = ctx_param_ext_313175;
    ext_317015 = ctx_param_ext_313176;
    ext_317014 = ctx_param_ext_313177;
    ext_317013 = ctx_param_ext_313178;
    if (memblock_set(ctx, &ext_mem_317012, &mem_param_313163,
                     "mem_param_313163") != 0)
        return 1;
    if (memblock_set(ctx, &ext_mem_317011, &mem_param_313171,
                     "mem_param_313171") != 0)
        return 1;
    if (memblock_set(ctx, &ext_mem_317010, &mem_param_313179,
                     "mem_param_313179") != 0)
        return 1;
    if (memblock_unref(ctx, &mem_313151, "mem_313151") != 0)
        return 1;
    if (memblock_unref(ctx, &mem_313155, "mem_313155") != 0)
        return 1;
    
    struct memblock mem_317037;
    
    mem_317037.references = NULL;
    if (memblock_alloc(ctx, &mem_317037, bytes_312592, "mem_317037")) {
        err = 1;
        goto cleanup;
    }
    for (int64_t i_337610 = 0; i_337610 < m_292674; i_337610++) {
        for (int64_t i_337611 = 0; i_337611 < n_292675; i_337611++) {
            ((float *) mem_317037.mem)[i_337610 * n_292675 + i_337611] = NAN;
        }
    }
    
    struct memblock mem_317041;
    
    mem_317041.references = NULL;
    if (memblock_alloc(ctx, &mem_317041, bytes_312592, "mem_317041")) {
        err = 1;
        goto cleanup;
    }
    for (int64_t i_337612 = 0; i_337612 < m_292674; i_337612++) {
        for (int64_t i_337613 = 0; i_337613 < n_292675; i_337613++) {
            ((float *) mem_317041.mem)[i_337612 * n_292675 + i_337613] = NAN;
        }
    }
    
    struct memblock mem_317045;
    
    mem_317045.references = NULL;
    if (memblock_alloc(ctx, &mem_317045, bytes_312592, "mem_317045")) {
        err = 1;
        goto cleanup;
    }
    for (int64_t i_337614 = 0; i_337614 < m_292674; i_337614++) {
        for (int64_t i_337615 = 0; i_337615 < n_292675; i_337615++) {
            ((float *) mem_317045.mem)[i_337614 * n_292675 + i_337615] = NAN;
        }
    }
    
    int64_t flat_tid_310656 = (int64_t) 0;
    int32_t num_tasks_337616;
    struct futhark_mc_task_339308 futhark_mc_task_339308;
    
    futhark_mc_task_339308.ctx = ctx;
    futhark_mc_task_339308.free_m_292674 = m_292674;
    futhark_mc_task_339308.free_n_292675 = n_292675;
    futhark_mc_task_339308.free_partition_sizze_292766 = partition_sizze_292766;
    futhark_mc_task_339308.free_mem_312593 = mem_312593;
    futhark_mc_task_339308.free_mem_312596 = mem_312596;
    futhark_mc_task_339308.free_bytes_316827 = bytes_316827;
    futhark_mc_task_339308.free_ext_mem_317011 = ext_mem_317011.mem;
    futhark_mc_task_339308.free_ext_mem_317012 = ext_mem_317012.mem;
    futhark_mc_task_339308.free_ext_317023 = ext_317023;
    futhark_mc_task_339308.free_mem_317037 = mem_317037.mem;
    futhark_mc_task_339308.free_mem_317041 = mem_317041.mem;
    futhark_mc_task_339308.free_mem_317045 = mem_317045.mem;
    
    struct scheduler_segop futhark_mc_task_339308_task;
    
    futhark_mc_task_339308_task.args = &futhark_mc_task_339308;
    futhark_mc_task_339308_task.top_level_fn = futhark_mc_segmap_task_339309;
    futhark_mc_task_339308_task.name = "futhark_mc_segmap_task_339309";
    futhark_mc_task_339308_task.iterations = partition_sizze_292766;
    futhark_mc_task_339308_task.task_time =
        &ctx->futhark_mc_segmap_task_339309_total_time;
    futhark_mc_task_339308_task.task_iter =
        &ctx->futhark_mc_segmap_task_339309_total_iter;
    futhark_mc_task_339308_task.sched = STATIC;
    futhark_mc_task_339308_task.nested_fn = NULL;
    
    int futhark_mc_segmap_task_339309_err =
        scheduler_prepare_task(&ctx->scheduler, &futhark_mc_task_339308_task);
    
    if (futhark_mc_segmap_task_339309_err != 0) {
        if (memblock_unref(ctx, &mem_317045, "mem_317045") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_317041, "mem_317041") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_317037, "mem_317037") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_param_313179, "mem_param_313179") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_param_313171, "mem_param_313171") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_param_313163, "mem_param_313163") != 0)
            return 1;
        if (memblock_unref(ctx, &ext_mem_317010, "ext_mem_317010") != 0)
            return 1;
        if (memblock_unref(ctx, &ext_mem_317011, "ext_mem_317011") != 0)
            return 1;
        if (memblock_unref(ctx, &ext_mem_317012, "ext_mem_317012") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_313155, "mem_313155") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_313151, "mem_313151") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_317163, "mem_out_317163") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_317162, "mem_out_317162") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_317161, "mem_out_317161") != 0)
            return 1;
        ;
        err = futhark_mc_segmap_task_339309_err;
        goto cleanup;
    }
    if (memblock_unref(ctx, &ext_mem_317011, "ext_mem_317011") != 0)
        return 1;
    if (memblock_unref(ctx, &ext_mem_317012, "ext_mem_317012") != 0)
        return 1;
    if (memblock_set(ctx, &mem_out_317161, &mem_317037, "mem_317037") != 0)
        return 1;
    if (memblock_set(ctx, &mem_out_317162, &mem_317041, "mem_317041") != 0)
        return 1;
    if (memblock_set(ctx, &mem_out_317163, &mem_317045, "mem_317045") != 0)
        return 1;
    (*mem_out_p_337633).references = NULL;
    if (memblock_set(ctx, &*mem_out_p_337633, &mem_out_317161,
                     "mem_out_317161") != 0)
        return 1;
    (*mem_out_p_337634).references = NULL;
    if (memblock_set(ctx, &*mem_out_p_337634, &mem_out_317162,
                     "mem_out_317162") != 0)
        return 1;
    (*mem_out_p_337635).references = NULL;
    if (memblock_set(ctx, &*mem_out_p_337635, &mem_out_317163,
                     "mem_out_317163") != 0)
        return 1;
    if (memblock_unref(ctx, &mem_317045, "mem_317045") != 0)
        return 1;
    if (memblock_unref(ctx, &mem_317041, "mem_317041") != 0)
        return 1;
    if (memblock_unref(ctx, &mem_317037, "mem_317037") != 0)
        return 1;
    if (memblock_unref(ctx, &mem_param_313179, "mem_param_313179") != 0)
        return 1;
    if (memblock_unref(ctx, &mem_param_313171, "mem_param_313171") != 0)
        return 1;
    if (memblock_unref(ctx, &mem_param_313163, "mem_param_313163") != 0)
        return 1;
    if (memblock_unref(ctx, &ext_mem_317010, "ext_mem_317010") != 0)
        return 1;
    if (memblock_unref(ctx, &ext_mem_317011, "ext_mem_317011") != 0)
        return 1;
    if (memblock_unref(ctx, &ext_mem_317012, "ext_mem_317012") != 0)
        return 1;
    if (memblock_unref(ctx, &mem_313155, "mem_313155") != 0)
        return 1;
    if (memblock_unref(ctx, &mem_313151, "mem_313151") != 0)
        return 1;
    if (memblock_unref(ctx, &mem_out_317163, "mem_out_317163") != 0)
        return 1;
    if (memblock_unref(ctx, &mem_out_317162, "mem_out_317162") != 0)
        return 1;
    if (memblock_unref(ctx, &mem_out_317161, "mem_out_317161") != 0)
        return 1;
    
  cleanup:
    { }
    free(mem_312584);
    free(mem_312587);
    free(mem_312589);
    free(mem_312593);
    free(mem_312596);
    free(mem_312636);
    free(mem_312639);
    free(mem_312713);
    free(mem_312838);
    free(mem_312842);
    free(mem_313018);
    free(mem_313023);
    free(mem_313081);
    free(mem_313085);
    free(mem_313143);
    free(mem_313147);
    free(mem_313223);
    free(mem_313366);
    free(mem_313371);
    free(mem_314946);
    free(mem_314949);
    free(mem_314971);
    free(mem_314974);
    free(mem_314996);
    free(mem_314999);
    free(mem_315021);
    free(mem_316815);
    free(mem_316819);
    free(mem_316822);
    free(mem_316832);
    free(mem_316835);
    free(mem_316850);
    free(mem_316906);
    free(mem_316909);
    free(mem_316912);
    free(mem_316915);
    free(mem_316917);
    free(mem_316920);
    free(mem_316928);
    free(mem_316931);
    free(mem_316973);
    free(mem_316976);
    free(mem_316979);
    return err;
}
static int futrts_entry_seasonal_amplitude(struct futhark_context *ctx,
                                           struct memblock *mem_out_p_339319,
                                           struct memblock seasonal_l_mem_312581,
                                           int64_t m_292609, int64_t n_292610)
{
    (void) ctx;
    
    int err = 0;
    struct memblock mem_out_317161;
    
    mem_out_317161.references = NULL;
    
    int64_t binop_y_312582 = (int64_t) 4 * m_292609;
    int64_t bytes_312583 = smax64((int64_t) 0, binop_y_312582);
    struct memblock mem_312584;
    
    mem_312584.references = NULL;
    if (memblock_alloc(ctx, &mem_312584, bytes_312583, "mem_312584")) {
        err = 1;
        goto cleanup;
    }
    
    int64_t flat_tid_297382 = (int64_t) 0;
    int32_t num_tasks_317162;
    int64_t flat_tid_297388 = (int64_t) 0;
    struct futhark_mc_task_339320 futhark_mc_task_339320;
    
    futhark_mc_task_339320.ctx = ctx;
    futhark_mc_task_339320.free_m_292609 = m_292609;
    futhark_mc_task_339320.free_n_292610 = n_292610;
    futhark_mc_task_339320.free_seasonal_l_mem_312581 =
        seasonal_l_mem_312581.mem;
    futhark_mc_task_339320.free_mem_312584 = mem_312584.mem;
    
    struct scheduler_segop futhark_mc_task_339320_task;
    
    futhark_mc_task_339320_task.args = &futhark_mc_task_339320;
    futhark_mc_task_339320_task.top_level_fn = futhark_mc_segmap_task_339321;
    futhark_mc_task_339320_task.name = "futhark_mc_segmap_task_339321";
    futhark_mc_task_339320_task.iterations = m_292609;
    futhark_mc_task_339320_task.task_time =
        &ctx->futhark_mc_segmap_task_339321_total_time;
    futhark_mc_task_339320_task.task_iter =
        &ctx->futhark_mc_segmap_task_339321_total_iter;
    futhark_mc_task_339320_task.sched = STATIC;
    futhark_mc_task_339320_task.nested_fn =
        futhark_mc_segmap_nested_task_339324;
    
    int futhark_mc_segmap_task_339321_err =
        scheduler_prepare_task(&ctx->scheduler, &futhark_mc_task_339320_task);
    
    if (futhark_mc_segmap_task_339321_err != 0) {
        if (memblock_unref(ctx, &mem_312584, "mem_312584") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_317161, "mem_out_317161") != 0)
            return 1;
        ;
        err = futhark_mc_segmap_task_339321_err;
        goto cleanup;
    }
    if (memblock_set(ctx, &mem_out_317161, &mem_312584, "mem_312584") != 0)
        return 1;
    (*mem_out_p_339319).references = NULL;
    if (memblock_set(ctx, &*mem_out_p_339319, &mem_out_317161,
                     "mem_out_317161") != 0)
        return 1;
    if (memblock_unref(ctx, &mem_312584, "mem_312584") != 0)
        return 1;
    if (memblock_unref(ctx, &mem_out_317161, "mem_out_317161") != 0)
        return 1;
    
  cleanup:
    { }
    return err;
}
static int futrts_entry_trend_magnitude(struct futhark_context *ctx,
                                        struct memblock *mem_out_p_339333,
                                        struct memblock trend_l_mem_312581,
                                        int64_t m_292626, int64_t n_292627)
{
    (void) ctx;
    
    int err = 0;
    size_t mem_312584_cached_sizze_339334 = 0;
    unsigned char *mem_312584 = NULL;
    struct memblock mem_out_317161;
    
    mem_out_317161.references = NULL;
    
    int64_t binop_y_312582 = (int64_t) 8 * n_292627;
    int64_t bytes_312583 = smax64((int64_t) 0, binop_y_312582);
    
    if (mem_312584_cached_sizze_339334 < (size_t) bytes_312583) {
        mem_312584 = realloc(mem_312584, bytes_312583);
        mem_312584_cached_sizze_339334 = bytes_312583;
    }
    
    double defunc_2_reduce_res_292636;
    double defunc_2_reduce_res_292637;
    int64_t flat_tid_297405 = (int64_t) 0;
    int32_t num_tasks_317162;
    
    defunc_2_reduce_res_292636 = 0.0;
    defunc_2_reduce_res_292637 = 0.0;
    
    struct futhark_mc_task_339335 futhark_mc_task_339335;
    
    futhark_mc_task_339335.ctx = ctx;
    futhark_mc_task_339335.retval_defunc_2_reduce_res_292636 =
        &defunc_2_reduce_res_292636;
    futhark_mc_task_339335.retval_defunc_2_reduce_res_292637 =
        &defunc_2_reduce_res_292637;
    futhark_mc_task_339335.retval_mem_312584 = mem_312584;
    
    struct scheduler_segop futhark_mc_task_339335_task;
    
    futhark_mc_task_339335_task.args = &futhark_mc_task_339335;
    futhark_mc_task_339335_task.top_level_fn = futhark_mc_segred_task_339336;
    futhark_mc_task_339335_task.name = "futhark_mc_segred_task_339336";
    futhark_mc_task_339335_task.iterations = n_292627;
    futhark_mc_task_339335_task.task_time =
        &ctx->futhark_mc_segred_task_339336_total_time;
    futhark_mc_task_339335_task.task_iter =
        &ctx->futhark_mc_segred_task_339336_total_iter;
    futhark_mc_task_339335_task.sched = STATIC;
    futhark_mc_task_339335_task.nested_fn = NULL;
    
    int futhark_mc_segred_task_339336_err =
        scheduler_prepare_task(&ctx->scheduler, &futhark_mc_task_339335_task);
    
    if (futhark_mc_segred_task_339336_err != 0) {
        if (memblock_unref(ctx, &mem_out_317161, "mem_out_317161") != 0)
            return 1;
        ;
        err = futhark_mc_segred_task_339336_err;
        goto cleanup;
    }
    
    double i64_res_292652 = sitofp_i64_f64(n_292627);
    double x_292653 = defunc_2_reduce_res_292637 * i64_res_292652;
    double y_292654 = defunc_2_reduce_res_292636 * defunc_2_reduce_res_292636;
    double y_292655 = x_292653 - y_292654;
    double det1_292656 = 1.0 / y_292655;
    double x_292657 = 0.0 - defunc_2_reduce_res_292636;
    double b11_292658 = det1_292656 * x_292657;
    double c11_292659 = i64_res_292652 * det1_292656;
    int64_t binop_y_312585 = (int64_t) 4 * m_292626;
    int64_t bytes_312586 = smax64((int64_t) 0, binop_y_312585);
    struct memblock mem_312587;
    
    mem_312587.references = NULL;
    if (memblock_alloc(ctx, &mem_312587, bytes_312586, "mem_312587")) {
        err = 1;
        goto cleanup;
    }
    
    int64_t flat_tid_297407 = (int64_t) 0;
    int32_t num_tasks_317177;
    int64_t flat_tid_297413 = (int64_t) 0;
    struct futhark_mc_task_339341 futhark_mc_task_339341;
    
    futhark_mc_task_339341.ctx = ctx;
    futhark_mc_task_339341.free_m_292626 = m_292626;
    futhark_mc_task_339341.free_n_292627 = n_292627;
    futhark_mc_task_339341.free_i64_res_292652 = i64_res_292652;
    futhark_mc_task_339341.free_b11_292658 = b11_292658;
    futhark_mc_task_339341.free_c11_292659 = c11_292659;
    futhark_mc_task_339341.free_trend_l_mem_312581 = trend_l_mem_312581.mem;
    futhark_mc_task_339341.free_mem_312584 = mem_312584;
    futhark_mc_task_339341.free_mem_312587 = mem_312587.mem;
    
    struct scheduler_segop futhark_mc_task_339341_task;
    
    futhark_mc_task_339341_task.args = &futhark_mc_task_339341;
    futhark_mc_task_339341_task.top_level_fn = futhark_mc_segmap_task_339342;
    futhark_mc_task_339341_task.name = "futhark_mc_segmap_task_339342";
    futhark_mc_task_339341_task.iterations = m_292626;
    futhark_mc_task_339341_task.task_time =
        &ctx->futhark_mc_segmap_task_339342_total_time;
    futhark_mc_task_339341_task.task_iter =
        &ctx->futhark_mc_segmap_task_339342_total_iter;
    futhark_mc_task_339341_task.sched = STATIC;
    futhark_mc_task_339341_task.nested_fn =
        futhark_mc_segmap_nested_task_339345;
    
    int futhark_mc_segmap_task_339342_err =
        scheduler_prepare_task(&ctx->scheduler, &futhark_mc_task_339341_task);
    
    if (futhark_mc_segmap_task_339342_err != 0) {
        if (memblock_unref(ctx, &mem_312587, "mem_312587") != 0)
            return 1;
        if (memblock_unref(ctx, &mem_out_317161, "mem_out_317161") != 0)
            return 1;
        ;
        err = futhark_mc_segmap_task_339342_err;
        goto cleanup;
    }
    if (memblock_set(ctx, &mem_out_317161, &mem_312587, "mem_312587") != 0)
        return 1;
    (*mem_out_p_339333).references = NULL;
    if (memblock_set(ctx, &*mem_out_p_339333, &mem_out_317161,
                     "mem_out_317161") != 0)
        return 1;
    if (memblock_unref(ctx, &mem_312587, "mem_312587") != 0)
        return 1;
    if (memblock_unref(ctx, &mem_out_317161, "mem_out_317161") != 0)
        return 1;
    
  cleanup:
    { }
    free(mem_312584);
    return err;
}

int futhark_entry_main(struct futhark_context *ctx,
                       struct futhark_f32_2d **out0,
                       struct futhark_f32_2d **out1,
                       struct futhark_f32_2d **out2, const
                       struct futhark_f32_2d *in0, const int64_t in1, const
                       int64_t in2, const int64_t in3, const int64_t in4, const
                       int64_t in5, const int64_t in6, const int64_t in7, const
                       int64_t in8, const int64_t in9, const int64_t in10, const
                       int64_t in11, const int64_t in12, const int64_t in13,
                       const int64_t in14, const int64_t in15, const
                       int64_t in16)
{
    struct memblock Y_mem_312581;
    
    Y_mem_312581.references = NULL;
    
    int64_t m_292674;
    int64_t n_292675;
    int64_t n_p_292677;
    int64_t q_s_292678;
    int64_t q_t_292679;
    int64_t q_l_292680;
    int64_t d_s_292681;
    int64_t d_t_292682;
    int64_t d_l_292683;
    int64_t jump_s_292684;
    int64_t jump_t_292685;
    int64_t jump_l_292686;
    int64_t n_inner_292687;
    int64_t n_outer_292688;
    int64_t jump_threshold_1_292689;
    int64_t jump_threshold_2_292690;
    int64_t q_threshold_1_292691;
    int64_t q_threshold_2_292692;
    struct memblock mem_out_317161;
    
    mem_out_317161.references = NULL;
    
    struct memblock mem_out_317162;
    
    mem_out_317162.references = NULL;
    
    struct memblock mem_out_317163;
    
    mem_out_317163.references = NULL;
    
    int ret = 0;
    
    lock_lock(&ctx->lock);
    worker_local = &ctx->scheduler.workers[0];
    Y_mem_312581 = in0->mem;
    m_292674 = in0->shape[0];
    n_292675 = in0->shape[1];
    n_p_292677 = in1;
    q_s_292678 = in2;
    q_t_292679 = in3;
    q_l_292680 = in4;
    d_s_292681 = in5;
    d_t_292682 = in6;
    d_l_292683 = in7;
    jump_s_292684 = in8;
    jump_t_292685 = in9;
    jump_l_292686 = in10;
    n_inner_292687 = in11;
    n_outer_292688 = in12;
    jump_threshold_1_292689 = in13;
    jump_threshold_2_292690 = in14;
    q_threshold_1_292691 = in15;
    q_threshold_2_292692 = in16;
    if (!(m_292674 == in0->shape[0] && n_292675 == in0->shape[1])) {
        ret = 1;
        if (!ctx->error)
            ctx->error =
                msgprintf("Error: entry point arguments have invalid sizes.\n");
    }
    if (ret == 0) {
        ret = futrts_entry_main(ctx, &mem_out_317161, &mem_out_317162,
                                &mem_out_317163, Y_mem_312581, m_292674,
                                n_292675, n_p_292677, q_s_292678, q_t_292679,
                                q_l_292680, d_s_292681, d_t_292682, d_l_292683,
                                jump_s_292684, jump_t_292685, jump_l_292686,
                                n_inner_292687, n_outer_292688,
                                jump_threshold_1_292689,
                                jump_threshold_2_292690, q_threshold_1_292691,
                                q_threshold_2_292692);
        if (ret == 0) {
            assert((*out0 =
                    (struct futhark_f32_2d *) malloc(sizeof(struct futhark_f32_2d))) !=
                NULL);
            (*out0)->mem = mem_out_317161;
            (*out0)->shape[0] = m_292674;
            (*out0)->shape[1] = n_292675;
            assert((*out1 =
                    (struct futhark_f32_2d *) malloc(sizeof(struct futhark_f32_2d))) !=
                NULL);
            (*out1)->mem = mem_out_317162;
            (*out1)->shape[0] = m_292674;
            (*out1)->shape[1] = n_292675;
            assert((*out2 =
                    (struct futhark_f32_2d *) malloc(sizeof(struct futhark_f32_2d))) !=
                NULL);
            (*out2)->mem = mem_out_317163;
            (*out2)->shape[0] = m_292674;
            (*out2)->shape[1] = n_292675;
        }
    }
    lock_unlock(&ctx->lock);
    return ret;
}
int futhark_entry_seasonal_amplitude(struct futhark_context *ctx,
                                     struct futhark_f32_1d **out0, const
                                     struct futhark_f32_2d *in0)
{
    struct memblock seasonal_l_mem_312581;
    
    seasonal_l_mem_312581.references = NULL;
    
    int64_t m_292609;
    int64_t n_292610;
    struct memblock mem_out_317161;
    
    mem_out_317161.references = NULL;
    
    int ret = 0;
    
    lock_lock(&ctx->lock);
    worker_local = &ctx->scheduler.workers[0];
    seasonal_l_mem_312581 = in0->mem;
    m_292609 = in0->shape[0];
    n_292610 = in0->shape[1];
    if (!(m_292609 == in0->shape[0] && n_292610 == in0->shape[1])) {
        ret = 1;
        if (!ctx->error)
            ctx->error =
                msgprintf("Error: entry point arguments have invalid sizes.\n");
    }
    if (ret == 0) {
        ret = futrts_entry_seasonal_amplitude(ctx, &mem_out_317161,
                                              seasonal_l_mem_312581, m_292609,
                                              n_292610);
        if (ret == 0) {
            assert((*out0 =
                    (struct futhark_f32_1d *) malloc(sizeof(struct futhark_f32_1d))) !=
                NULL);
            (*out0)->mem = mem_out_317161;
            (*out0)->shape[0] = m_292609;
        }
    }
    lock_unlock(&ctx->lock);
    return ret;
}
int futhark_entry_trend_magnitude(struct futhark_context *ctx,
                                  struct futhark_f32_1d **out0, const
                                  struct futhark_f32_2d *in0)
{
    struct memblock trend_l_mem_312581;
    
    trend_l_mem_312581.references = NULL;
    
    int64_t m_292626;
    int64_t n_292627;
    struct memblock mem_out_317161;
    
    mem_out_317161.references = NULL;
    
    int ret = 0;
    
    lock_lock(&ctx->lock);
    worker_local = &ctx->scheduler.workers[0];
    trend_l_mem_312581 = in0->mem;
    m_292626 = in0->shape[0];
    n_292627 = in0->shape[1];
    if (!(m_292626 == in0->shape[0] && n_292627 == in0->shape[1])) {
        ret = 1;
        if (!ctx->error)
            ctx->error =
                msgprintf("Error: entry point arguments have invalid sizes.\n");
    }
    if (ret == 0) {
        ret = futrts_entry_trend_magnitude(ctx, &mem_out_317161,
                                           trend_l_mem_312581, m_292626,
                                           n_292627);
        if (ret == 0) {
            assert((*out0 =
                    (struct futhark_f32_1d *) malloc(sizeof(struct futhark_f32_1d))) !=
                NULL);
            (*out0)->mem = mem_out_317161;
            (*out0)->shape[0] = m_292626;
        }
    }
    lock_unlock(&ctx->lock);
    return ret;
}
  
